$MODULE_FACTORY_REGISTRY = typeof $MODULE_FACTORY_REGISTRY != 'undefined' ? $MODULE_FACTORY_REGISTRY : {};
$MODULE_REGISTRY = typeof $MODULE_REGISTRY != 'undefined' ? $MODULE_REGISTRY : {};
if(typeof require == 'undefined')
function require(path){if(!$MODULE_REGISTRY[path]) $MODULE_REGISTRY[path] = $MODULE_FACTORY_REGISTRY[path](); return $MODULE_REGISTRY[path]};$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/NGJSEnvironmentSupport'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/NGJSEnvironmentSupport'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/NGJSEnvironmentSupport'] = exports; /**

 # NGJSEnvironmentSupport.js
 # webgame
 #
 # Created by Frederic Barthelemy on 10/01/10.
 # Copyright 2010 ngmoco:). All rights reserved.

 */

/**
 * Provides Environmental support for features missing on certain platforms.
 */


/**
 * setTimeout and setInterval implementation for platforms that don't have it.
 *	It fires timers at the beginning of the first frame past the requested millisecond,
 *	before it processes messages for a particular frame.
 *
 * Platform Consumers:
 *	- Android
 *
 * Note:
 *	- Only accurate to within the frame.
 *	- Does behaves like webkit in that it lets clearInterval and clearTimeout
 *		clear timers created by each other's constructor style.
 *
 */
var NGSetTimeoutCustom = false;
var NGSetTimeoutCallbacks = {};
var NGSetTimeoutUIDGenerator = 0;

exports.NGSetTimeoutRunTimers = function() {
	if(NGSetTimeoutCustom) {
		var timersToExecute = [];
		var curTime = new Date().getTime();
		for (var tk in NGSetTimeoutCallbacks) {
			if (NGSetTimeoutCallbacks.hasOwnProperty(tk) && NGSetTimeoutCallbacks[tk].shouldExecute(curTime)) {
				timersToExecute.push(NGSetTimeoutCallbacks[tk]);
			}
		}

		for (var i in timersToExecute) {
			if (timersToExecute.hasOwnProperty(i)) {
				timersToExecute[i].execute();
			}
		}
	}
};

if(typeof(setTimeout) != "function") {
	NGSetTimeoutCustom = true;

	var NGSingleTimeoutInstance = function(fptr, timeMs) {
		this.uid = NGSetTimeoutUIDGenerator++;
		if (NGSetTimeoutUIDGenerator == Infinity)
		{
			NGSetTimeoutUIDGenerator = 0;
		}
		this.fptr = fptr;
		this.interval = timeMs;
		this.requestedTime = new Date().getTime() + timeMs;
	};

	NGSingleTimeoutInstance.prototype.shouldExecute = function(curTime) {
		if(curTime < this.requestedTime) {
			return false;
		}
		return true;
	};

	NGSingleTimeoutInstance.prototype.execute = function() {
		delete NGSetTimeoutCallbacks[this.uid];
		this.fptr();
	};
	/**
	*
	*/
	setTimeout = function(fptr,requestedTime) {
		if(requestedTime < 0 || typeof(requestedTime) != "number") {
			requestedTime = 0;
		}

		var inst = new NGSingleTimeoutInstance(fptr,requestedTime);
		NGSetTimeoutCallbacks[inst.uid] = inst;
		return inst.uid;
	};
	/**
	*
	*/
	clearTimeout = function(uid) {
		if(NGSetTimeoutCallbacks.hasOwnProperty(uid)) {
			delete NGSetTimeoutCallbacks[uid];
		}
	};
	/**
	*
	*/
	setInterval = function(fptr,requestedTime) {
		if(requestedTime < 0 || typeof(requestedTime) != "number") {
			requestedTime = 0;
		}

		var inst = new NGSingleTimeoutInstance(fptr,requestedTime);
		/*Special setIntervalMagic */
		inst.execute = function() {
			this.requestedTime = new Date().getTime() + this.interval;
			this.fptr();
		};
		/*End setIntervalMagic */
		NGSetTimeoutCallbacks[inst.uid] = inst;
		return inst.uid;
	};
	clearInterval = clearTimeout;
	
}
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/SystemBinding'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/SystemBinding'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/SystemBinding'] = exports; var ClassReq = require('NGCore/Client/Core/Class');
var Base64 = require('NGCore/Client/Core/Base64').Base64;
var ResultSetReq = require('NGCore/Client/Plus/ResultSet');

var NGSystemBindingCommands = {
    HandleAction: 0
};

var SystemBinding = ClassReq.Class.subclass({
    classname: "SystemBinding",
    callbacks: {},
    callbacksUidGenerator: 0,
    _contResultSets: {},
    _contResultSetIdxs: {}
});

var ResultSet = ClassReq.Class.subclass({
    classname: "ResultSet",
    initialize: function(continueId) {
        this.items = [];
        this._continueId = continueId;
        this.totalLength = Number.MAX_VALUE;
    },
    /*
	 * Call to getMore adds more items to items list.
	 * Please note that in the callback, it is possible that addedCount == 0
	 * in some cases.  In that case access to items[newIdx] does not yield
	 * any result
	 */
    getMore: function(cb) {
        return SystemBinding._getMoreContacts(this, cb);
    },
    /*
	 * Releases resource used by current ResultSet.
	 *
	 * To avoid resource leakage, please call closeResultSet if getMore
	 * is not called all the way to the end.
	 */
    closeResultSet: function() {
        SystemBinding._closeContactsResultSet(this);
    }
});

SystemBinding._pushContactsCmd = function(cmdname, callbackFunc, continueId) {
    // Generate unused callbackEntry
    var callbackId = SystemBinding.callbacksUidGenerator++;
    if ( !! !callbackFunc) {
        callbackFunc = function() {};
    }
    SystemBinding.callbacks[callbackId] = callbackFunc;
    var message = {
        name: cmdname,
        callbackId: callbackId
    };
    if (typeof continueId != 'undefined') {
        message.continueId = continueId;
    }
    message = JSON.stringify(message);
    NgPushCommand3(NgEntityTypes.NgSystemBinding, NGSystemBindingCommands.HandleAction,
    Base64.encode(message));
};

SystemBinding._closeContactsResultSetfunction = function(rSet) {
    // Passing empty callback as caller does not need to know when the close
    // is complete
    var cb = function() {};
    SystemBinding._pushContactsCmd('closecontacts', cb, rSet._continueId);
};

SystemBinding._getMoreContacts = function(rSet, callbackFunc) {
    if ((typeof rSet._continueId != 'undefined') &&
    (rSet.items.length < rSet.totalLength)) {
        SystemBinding._pushContactsCmd('morecontacts', callbackFunc, rSet._continueId);
        return true;
    }
    return false;
};

SystemBinding.getContacts = function(callbackFunc) {
    SystemBinding._pushContactsCmd('contacts', callbackFunc, undefined);
};

SystemBinding.getDeviceToken = function(callbackFunc) {
    // Generate unused callbackEntry
    var callbackId = SystemBinding.callbacksUidGenerator++;
    if ( !! !callbackFunc) {
        callbackFunc = function() {};
    }
    SystemBinding.callbacks[callbackId] = callbackFunc;
    var message = {
        name: 'devicetoken',
        callbackId: callbackId
    };
    message = JSON.stringify(message);
    NgPushCommand3(NgEntityTypes.NgSystemBinding, NGSystemBindingCommands.HandleAction,
    Base64.encode(message));
};

SystemBinding.handleCommand = function(command) {
    var fields = NgParseCommand2(command, NgParseInt, NgParseBase64);
    var cmd = JSON.parse(fields[1]);
    if (cmd.name == 'callback') {
    	var cb = SystemBinding.callbacks[cmd.callbackId];
		if (typeof cb == "function") {
            if (cmd.callbackname == 'contacts') {
                var obj = SystemBinding._contResultSets[cmd.continueId];
                if (typeof obj == 'undefined') {
                    // First time for this callback
                    obj = new ResultSetReq.ResultSet(cmd.continueId);
                    SystemBinding._contResultSets[cmd.continueId] = obj;
                    SystemBinding._contResultSetIdxs[cmd.continueId] = 0;
                }

                var addedCount = cmd.list.length;
                while (cmd.list.length > 0) {
                    var item = cmd.list.shift();
                    obj.items.push(item);
                }

                var newIdx = SystemBinding._contResultSetIdxs[cmd.continueId];
				if ((typeof newIdx) != 'undefined') {
                	SystemBinding._contResultSetIdxs[cmd.continueId] = newIdx + addedCount;
				}

                // Invalidate the continueId if done - when total is return (no
                // more result) or when result set is explicitly closed (cmd.closed)
                if ((typeof cmd.total != 'undefined') ||
                (typeof cmd.rsclosed != 'undefined')) {
                    if (typeof cmd.total != 'undefined') {
                        obj.totalLength = cmd.total;
                    }
                    delete obj._continueId;
                    delete SystemBinding._contResultSets[cmd.continueId];
                    delete SystemBinding._contResultSetIdxs[cmd.continueId];
                }

                delete SystemBinding.callbacks[cmd.callbackId];
				if (cmd.success) {
                	cb(undefined, obj, newIdx, addedCount);
				} else {
                	cb(cmd.error, obj, newIdx, addedCount);
				}
            } else {
                // other callbacks
                delete SystemBinding.callbacks[cmd.callbackId];
                cb(cmd);
            }
        }
    }
};

exports.SystemBinding = SystemBinding;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI'] || {}; $MODULE_REGISTRY['NGCore/Client/UI'] = exports; var Commands = require('NGCore/Client/UI/Commands').Commands;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');

/**
 * <p>Classes and objects contained by the UI module.</p>
 * @name UI
 * @namespace
 * @description <p>The UI module is a collection of classes that control user interface components of a device.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 * <ul>
 * <li><code>{@link UI.AbstractView}</code>A base class object for constructing other UI objects.</li>
 * <li><code>{@link UI.CellView}</code>: Construct <code>CellView</code> objects.</li>
 * <li><code>{@link UI.CheckBox}</code>: Construct objects that are used as checkboxes in an application.</li>
 * <li><code>{@link UI.CheckoutView}</code>: Construct objects that handle and manage information associated with <code>POST</code> methods in an application.</li>
 * <li><code>{@link UI.DateField}</code>: Construct objects used for handling data returned by date functions.</li>
 * <li><code>{@link UI.DocumentView}</code>: Constructs objects that control the location of application documents.</li>
 * <li><code>{@link UI.EditText}</code>: Constructs objects for handling editable text in an application.</li>
 * <li><code>{@link UI.EditTextArea}</code>: Constructs objects for handling multiline editable text in an application.</li>
 * <li><code>{@link UI.Element}</code>: A base class object for constructing other UI objects.</li>
 * <li><code>{@link UI.GLView}</code>: Construct objects that provide applications with access to OpenGL.</li>
 * <li><code>{@link UI.Image}</code>: Constructs objects that control the location and size of images used in the user interface.</li>
 * <li><code>{@link UI.Label}</code>: Constructs objects that control the look and feel of application labels.</li>
 * <li><code>{@link UI.ListView}</code>: Construct <code>ListView</code> objects.</li>
 * <li><code>{@link UI.ListViewItem}</code>: Construct <code>ListViewItem</code> objects.</li>
 * <li><code>{@link UI.ListViewSection}</code>: Construct <code>ListViewSection</code> objects.</li>
 * <li><code>{@link UI.NavController}</code>: Construct objects that control the flow of applcation navigation.</li>
 * <li><code>{@link UI.ProgressDialog}</code>: Construct objects that control application progress messaging.</li>
 * <li><code>{@link UI.ScrollView}</code>: Construct <code>ScrollView</code> objects.</li>
 * <li><code>{@link UI.Spinner}</code>: Construct objects that handle application menu spinners.
 * <li><code>{@link UI.Toast}</code>: Construct <code>Toast</code> objects.
 * <li><code>{@link UI.View}</code>: Construct objects that control the look and feel of the application view state.</li>
 * <li><code>{@link UI.ViewGeometry.Rect}</code>: Construct rectangle objects for use as positionable elements in the user interface.</li>
 * <li><code>{@link UI.ViewGeometry.Scale}</code>: Construct objects that handle view geometry for different scales of measurement.</li>
 * <li><code>{@link UI.WebView}</code>: Construct objects that pass event callback functions when web page events occur.</li>
 * <li><code>{@link UI.Window}</code>: Construct application window objects.</li>
 * </ul>
 */

var UI = exports.UI = {
	Commands: Commands,

	FontStyle: Commands.FontStyle,
	State: Commands.State,
	FitMode: Commands.FitMode,

	ViewGeometry: ViewGeometry,
	Scale: ViewGeometry.Scale,

    /**
	 *	@function
	 * 	@name UI#animate
	 * 	Animate changes to the properties of one or more UI objects.
	 * 	Currently animates changes to frame and alpha, and animates the addition / removal of subviews.
	 * 	@param {Function} action A closure that sets the property or properties to be animated.
	 * 		This function may manipulate several objects.
	 * 	@param {Number} duration The time over which to execute the animation, in milliseconds.
	 * 	@param {Function} onCompletion A closure to be executed after the animation has completed.
	 */
    animate: Commands.animate,

    /**
		@name UI#compositeImages
		Creates a composition of images to an offscreen bitmap, writing the resulting picture to disk.
		
		The filename returned in the callback may not be the same as originally requested!
		
		@example
		UI.compositeImages( 200, 200, "basic.png", [
			{
				image:'./Content/background.png',
				rect:[ 0,0, 200, 200 ]
			},
			{
				image:'./Content/CanYouSeeThisImage.png',
				rect:[ 50, 50, 100, 100 ]
			},
		], function( data ) { 
			if ( data.error == undefined ) { 
				NgLogD("yay, picture! at:"+data.filename);
			}
		} );
	 */
    compositeImages: function(w, h, filename, infoArray, callback) {
        var cb = Commands.registerTemporaryCallback(callback);
        if (cb) {
			Commands.doCompositeImages(w, h, filename, infoArray, cb);
		}
    },

    /**
		@name UI#choosePhoto
		Show fullscreen user interface for taking a picture with the camera or choosing an existing
		photo.
		
		Currently there are no 'options' keys defined.  
		In the future, we're considering "forAvatar" key to use a custom cropping UI.
		
		The filename returned in the callback may not be the same as originally requested!
		If the user cancels or an error occurs, the callback will be passed an error string.
		
		Passing 0 for targetWide or High will return the original unscaled image.
		
		@example
		UI.choosePhoto( 0, 0, "basic.png", undefined, function( data ) { 
			if ( data.error == undefined ) { 
				NgLogD("yay, picture! at:"+data.filename);
			}
		} );
	*/
    choosePhoto: function(width, height, filename, options, callback, invokingView) {
       if (!invokingView || !invokingView.__objectRegistryId) {
            new exports.UI.Toast({
                'text': "Photo picker requires an invoking view.",
                'onDisappear': function() {
                    this.destroy();
                }
            }).show();
            return;
        }

        var cb = Commands.registerTemporaryCallback(callback);
		if (cb) {
        	Commands.doChoosePhoto(width, height, filename, options || {}, cb, invokingView.__objectRegistryId);
		}
    },

    /**
		@name UI#choosePhotoCamera
		Show fullscreen user interface for taking a picture with the camera or choosing an existing
		photo.
		
		Currently there are no 'options' keys defined.  
		In the future, we're considering "forAvatar" key to use a custom cropping UI.
		
		The filename returned in the callback may not be the same as originally requested!
		If the user cancels or an error occurs, the callback will be passed an error string.
		
		Passing 0 for targetWide or High will return the original unscaled image.
		
		@example
		UI.choosePhoto( 0, 0, "basic.png", undefined, function( data ) { 
			if ( data.error == undefined ) { 
				NgLogD("yay, picture! at:"+data.filename);
			}
		} );
	*/
    choosePhotoCamera: function(width, height, filename, options, callback) {
        var cb = Commands.registerTemporaryCallback(callback);
		if (cb) {
        	Commands.doChooseCamera(width, height, filename, options || {}, cb);
		}
    },

	measureText: function( text, w, h, font, size, callback) {
		var cb = Commands.registerTemporaryCallback(callback);
		if (cb != '') {
			Commands.measureText(text, w || -1, h || -1, font, size, cb);
		}
	}
};

exports.UI.__defineGetter__("Window",
function() {
    delete UI.Window;
    return UI.Window = require('NGCore/Client/UI/Window').Window;
});
exports.UI.__defineGetter__("Element",
function() {
    delete UI.Element;
    return UI.Element = require('NGCore/Client/UI/Element').Element;
});
exports.UI.__defineGetter__("View",
function() {
    delete UI.View;
    return UI.View = require('NGCore/Client/UI/View').View;
});
exports.UI.__defineGetter__("Label",
function() {
    delete UI.Label;
    return UI.Label = require('NGCore/Client/UI/Label').Label;
});
exports.UI.__defineGetter__("Image",
function() {
    delete UI.Image;
    return UI.Image = require('NGCore/Client/UI/Image').Image;
});
exports.UI.__defineGetter__("Button",
function() {
    delete UI.Button;
    return UI.Button = require('NGCore/Client/UI/Button').Button;
});
exports.UI.__defineGetter__("GLView",
function() {
    delete UI.GLView;
    return UI.GLView = require('NGCore/Client/UI/GLView').GLView;
});
exports.UI.__defineGetter__("NavController",
function() {
    delete UI.NavController;
    return UI.NavController = require('NGCore/Client/UI/NavController').NavController;
});
exports.UI.__defineGetter__("WebView",
function() {
    delete UI.WebView;
    return UI.WebView = require('NGCore/Client/UI/WebView').WebView;
});
exports.UI.__defineGetter__("ScrollView",
function() {
    delete UI.ScrollView;
    return UI.ScrollView = require('NGCore/Client/UI/ScrollView').ScrollView;
});
exports.UI.__defineGetter__("ListView",
function() {
    delete UI.ListView;
    return UI.ListView = require('NGCore/Client/UI/ListView').ListView;
});
exports.UI.__defineGetter__("ListViewSection",
function() {
    delete UI.ListViewSection;
    return UI.ListViewSection = require('NGCore/Client/UI/ListViewSection').ListViewSection;
});
exports.UI.__defineGetter__("ListViewItem",
function() {
    delete UI.ListViewItem;
    return UI.ListViewItem = require('NGCore/Client/UI/ListViewItem').ListViewItem;
});
exports.UI.__defineGetter__("CellView",
function() {
    delete UI.CellView;
    return UI.CellView = require('NGCore/Client/UI/CellView').CellView;
});
exports.UI.__defineGetter__("CheckBox",
function() {
    delete UI.CheckBox;
    return UI.CheckBox = require('NGCore/Client/UI/CheckBox').CheckBox;
});
exports.UI.__defineGetter__("EditText",
function() {
    delete UI.EditText;
    return UI.EditText = require('NGCore/Client/UI/EditText').EditText;
});
exports.UI.__defineGetter__("EditTextArea",
function() {
    delete UI.EditTextArea;
    return UI.EditTextArea = require('NGCore/Client/UI/EditTextArea').EditTextArea;
});
exports.UI.__defineGetter__("DateField",
function() {
    delete UI.DateField;
    return UI.DateField = require('NGCore/Client/UI/DateField').DateField;
});
exports.UI.__defineGetter__("AlertDialog",
function() {
    delete UI.AlertDialog;
    return UI.AlertDialog = require('NGCore/Client/UI/AlertDialog').AlertDialog;
});
exports.UI.__defineGetter__("ProgressDialog",
function() {
    delete UI.ProgressDialog;
    return UI.ProgressDialog = require('NGCore/Client/UI/ProgressDialog').ProgressDialog;
});
exports.UI.__defineGetter__("Toast",
function() {
    delete UI.Toast;
    return UI.Toast = require('NGCore/Client/UI/Toast').Toast;
});
/** @private */
exports.UI.__defineGetter__("AdView",
function() {
    delete UI.AdView;
    return UI.AdView = require('NGCore/Client/UI/AdView').AdView;
});
exports.UI.__defineGetter__("DocumentView",
function() {
    delete UI.DocumentView;
    return UI.DocumentView = require('NGCore/Client/UI/DocumentView').DocumentView;
});
exports.UI.__defineGetter__("CheckoutView",
function() {
    delete UI.CheckoutView;
    return UI.CheckoutView = require('NGCore/Client/UI/CheckoutView').CheckoutView;
});
exports.UI.__defineGetter__("Spinner",
function() {
    delete UI.Spinner;
    return UI.Spinner = require('NGCore/Client/UI/Spinner').Spinner;
});
exports.UI.__defineGetter__("ProgressBar",
function() {
    delete UI.ProgressBar;
    return UI.ProgressBar = require('NGCore/Client/UI/ProgressBar').ProgressBar;
});
exports.UI.__defineGetter__("MapView",
function() {
    delete UI.MapView;
    return UI.MapView = require('NGCore/Client/UI/MapView').MapView;
});
exports.UI.__defineGetter__("MapAnnotation",
function() {
    delete UI.MapAnnotation;
    return UI.MapAnnotation = require('NGCore/Client/UI/MapAnnotation').MapAnnotation;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/DownloadManifest'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/DownloadManifest'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/DownloadManifest'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class XHR
// XMLHttpRequest implementation
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
var XHR = require('NGCore/Client/Network/XHR').XHR;
var Util = require('NGCore/Client/Network/Util').Util;
var DownloadFile = require('NGCore/Client/Network/DownloadFile').DownloadFile;
var FileSystem = require('NGCore/Client/Storage/FileSystem').FileSystem;
var LocalGameList = require('NGCore/Client/Core/LocalGameList').LocalGameList;

// JMarr temporary hack to supress archive downloads on flash.
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;

////////////////////////////////////////////////////////////////////////////////

var Manifest = Class.subclass(
{
	classname: 'Manifest',

	initialize: function()
	{
	},

	reset: function ()
	{
		this.mJson = null;
		this.mArchives = null;
	},

	initWithJsonText: function ( text, emptyOnFail)
	{
		try
		{
			this.mJson = JSON.parse ( text );
			if (!this.mJson)
			{
				this.mJson = {};
			}
		}
		catch (e)
		{
			this.mJson = {};
		}

		if('__archives' in this.mJson)
		{
			this.mArchives = this.mJson['__archives'].files;
			delete this.mJson['__archives'];
		}
		else
		{
			this.mArchives = [];
		}
	},

	//cb: function ( itemKey, dstList, srcList ), which is compareItems
	//cb returns ! null, then dst[ item ] = cb return value.
	//cb returns null, then delete dst[ item ].
	foreach: function ( other, cb )
	{
		var dst = this.mJson;
		var src = other.mJson;
		// Handle all things in src.
		for ( var key in src )
		{
			this.handleItem ( key, dst, src, cb );
		}
		// Build up list of all things not in src.
		for ( var key in dst )
		{
			// Handle all things not in src.
			if ( ! (key in src) )
			{
				this.handleItem ( key, dst, src, cb );
			}
		}
	},

	handleItem: function ( key, dst, src, cb )
	{
		var ret = cb ( key, dst, src );
		if ( !ret )
		{
			delete dst[ key ];
		}
	},

	write: function ( fname )
	{
		var cb = function (err)
		{
			if (err)
			{
				console.log('Error writing manifest! ' + err);
			}
			// DO stuff?
		};

		if (this.mJson)
		{
			var out = JSON.stringify(this.mJson);
			FileSystem.writeFile(fname, out, cb);
		}
	}
});

////////////////////////////////////////////////////////////////////////////////

exports.DownloadManifest = MessageListener.subclass(
/** @lends Network.DownloadManifest.prototype */
{
	classname: 'DownloadManifest',

	/**
	 * @class The <code>DownloadManifest</code> class constructs objects that initiate the handling of a manifest file. 
	 * This ensures a set of files are kept up-to-date in the specified directory from the specified URL.
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this.reset();
	},

	_clearConnections: function()
	{
		for (var i in this.mConnections)
		{
			if(!this.mConnections.hasOwnProperty(i)) continue;
			
			this.mConnections[i].abort();
		}
		this.mConnections = [];
	},

	reset: function ()
	{
		this.mConcurrentRequests = 6;

		this.mManifest = null;

		this.mRemoteUrl = null;
		this.mLocalPath = null;
		this.mLocalRoot = null;

		this.mLocalText = null;
		this.mRemoteText = null;
		/** @private */
		this.mProgressCb = function() {};
		/** @private */
		this.mDoneCb = function() {};

		this.mPaused = false;
		this.mValid = false;

		this._clearConnections();
		this.mPendingItems = [];
		this.mCompleteBytes = 0;
		this.mTotalBytes = 0;
		
		this.mSpaceNeeded = 0;
		
		this.mNumRemoteManifestFiles = 0;
		this.mNumRemoteManifestBytes = 0;
		
		this.mDownloadArchives = true;
		this.mActiveRequests = [];

		this.mLocalGameList = LocalGameList;

		this.mNewJS = false;
		this.mAppObserver = null;

		this.mRetrySchedule = Util.RetrySchedule(50, 2000);
		this.mManifestRetrySchedule = this.mRetrySchedule.slice(0);

		if(this._statusListener)
		{
			this._statusListener.destroy();
			this._statusListener = null;
		}
		this.mCheckUpdateOnly = false;
		this.mCheckUpdateCallback = null;
	},

	_ensureTrailingSlashes: function(remoteUrl, localPath, secureContentUrl)
	{
		// Check for trailing slashes
		this.mRemoteUrl = remoteUrl.match(/.*\/$/) ? remoteUrl : remoteUrl + '/';
		// If the local path is nothing, do not alter the filename. Otherwise, ensure trailing slash
		this.mLocalRoot = (localPath.match(/.*\/$/) || (!localPath)) ? localPath : localPath + '/';
		this._secureContentUrl = ((!secureContentUrl) || secureContentUrl.match(/.*\/$/)) ? secureContentUrl : secureContentUrl + '/';
	},

	_readLocalManifest: function()
	{
		FileSystem.readFile ( this.mLocalPath, this._onReadLocalManifest.bind(this) );
	},

	_setRemotePath: function(manifestName)
	{
		if (this._secureContentUrl)
		{
			this.mRemotePath = this._secureContentUrl + manifestName;
		}
		else
		{
			this.mRemotePath = this.mRemoteUrl + manifestName;
		}
	},

	_parseManNames: function (man)
	{
		if (typeof man === 'string')
		{
			var obj = {};
			obj[man] = man;
			man = obj;
		}
		return man;
	},

	isUpdated: function(remoteUrl, localPath, manifest, doneCB, errorCB)
	{
		this.mCheckUpdateOnly = true;
		this.mCheckUpdateCallback = doneCB;

		this.mDoneCb = (typeof errorCB == 'function') ? errorCB : function() {};
		this.mProgressCb = function(done, left) {};
		var httpStatusCode = 0;
		var fullUrl = remoteUrl + "/configuration.json" + Util.getCacheBustingString();
		Util.OperationWithRetries(
			(function(failCall, abortCall)
			{
				// Start remote manifest download.
				var req = new XHR();
				req.onreadystatechange = (function()
				{
					if( req.readyState == 4 && this.mValid )	// done && not cancelled
					{
						this.mManifest = new Manifest ();
						var manifestUrl = null;
						// Only parse if we got a good response back
						if (req.status == 200 && req.responseText)
						{
							var config = JSON.parse(req.responseText);
							manifestUrl = config.contentUrl;
							if (!manifest)
							{
								manifest =
								{
									"webgame.ngmanifest":
									require('NGCore/Client/Core/_int_LGL')._int_LGL.getManifestName(config)
								};
							}

							// If config didn't have contentUrl or we never parsed(local testing), use the base URL
							if (!manifestUrl)
								manifestUrl = remoteUrl;

							manifest = this._parseManNames(manifest);
							var manifestSourceName;
							var manifestName;
							for (var key in manifest)
							{
								manifestSourceName = manifest[key];
								manifestName = key;
								break;
							}

							this._ensureTrailingSlashes(manifestUrl, localPath);
							this.mLocalPath = this.mLocalRoot + manifestName;
							this._setRemotePath(manifestSourceName);
							this._readLocalManifest();
						}
						else if (req.status == 404)
						{
							this._processError('404! Failed to download configuration at '+ fullUrl, false);
						}
						else
						{
							httpStatusCode = req.status;
							failCall();
						}
					}
				}).bind(this);

				req.open ( 'GET', fullUrl, true );
				req.send ();
			}).bind(this),
			(function()
			{
				console.log('Exceeded maximum number of manifest download retires, failing');
				this._processError('Failed to download manifest (' + httpStatusCode + ') at ' + fullUrl, false);
			}).bind(this),
			this.mFailEarly
		);

		this.mValid = true;
	},

	// progressCb: function ( completedRequests, totalRequests )
	// doneCb: function ( err, manifest )
	// throws if url/path arguments are null or empty.
	// TODO: Allow headers argument.  Currently null.
	// TODO: Allow HTTP method argument.  Currently GET.
	/**
	* @name Network.DownloadManifest#start
	* @description Start a download of a remote manifest file at <code>[remoteUrl + manifestName]</code> 
	* and read a local manifest at <code>[localPath + manifestName]</code>.<br><br>
	* <ul>
	* <li>If the local manifest does not exist, all files specified by the remote manifest are downloaded.</li>
	* <li>If the local manifest does exist, this method will update the file system at 
	* <code>[localPath]</code> to match the files specified in the remote manifest.</li>
	* </ul>
	* Each file download will trigger a <code>progress</code> callback function that returns the 
	* number of items downloaded and the total number of items to download.
	* <pre class="code">progressCb: function ( completedRequests, totalRequests )</pre>
	* When all downloads are complete, a <code>done</code> callback function is triggered that returns an error (if any) 
	* and the contents of <code>[localPath + manifestName]</code>. 
	* <pre class="code">doneCb: function ( err, manifest )</pre>
	* If an error does not occur, this function returns <code>undefined</code>.<br><br>
	* <b>Note:</b> The contents of <code>[localPath + manifestName]</code> are saved whether an error occurs or not.
	* @param {String} remoteUrl The URL to a manifest file.
	* @param {String} localPath The directory path to a manifest file.
	* @param {String} manifestName The manifest filename. 
	* @param {Function} progressCb The callback function to call for download progress.
	* @param {Function} doneCb The callback function to call when the download is complete.
	* @throws {invalid arguments} If the URL or directory path returns as empty or <code>null</code>.
	* @example Network.DownloadManifest.start(this._URL, './', this._manifestName, progressCb, doneCallback);
	* @function
    * @status iOS, Android
	*/
	/** @ignore */
	start: function ( remoteUrl, localPath, manifest, progressCb, doneCb, disableArchives, failEarly )
	{
		this.mCheckUpdateOnly = false;
		
		// Allow manifestName to be a hash with {manifestDestName: manifestSourceName}
		manifest = this._parseManNames(manifest);
		var manifestSourceName;
		var manifestName;
		for (var key in manifest)
		{
			manifestSourceName = manifest[key];
			manifestName = key;
			break;
		}

		console.log('DownloadManifest.start(', remoteUrl, localPath, manifestSourceName, ')');
		if ( ! remoteUrl || ! localPath || remoteUrl == '' || localPath == '' )
		{
			throw new Error ( 'invalid arguments: ' + JSON.stringify ( arguments ) );
		}

		// Set up instance state for this request.
		this.mManifest = new Manifest ();
		if(disableArchives)
			this.mDownloadArchives = false;
		
		// JMarr temporary hack to disable archive downloads on flash.
		if(Capabilities.getPlatformOS() == 'flash')
		{
			console.log('Flash does not yet support archive downloads');
			this.mDownloadArchives = false;
		}

		this._ensureTrailingSlashes(remoteUrl, localPath, this._secureContentUrl);
		this._setRemotePath(manifestSourceName);
		this.mLocalPath = this.mLocalRoot + manifestName;
		this.mFailEarly = failEarly;

		// try these to prevent a failed update due to bad code
		/** @private */
		this.mProgressCb = function (done, left)
		{
			try
			{
				progressCb(done, left);
			}
			catch (ex)
			{
				NgLogException(ex);
			}
		};

		var that = this;
		/** @private */
		this.mDoneCb = function (err, man, hadCache)
		{
			try
			{
				// touch the .nomedia file (MOB-1355)
				FileSystem.writeFile(that.mLocalRoot + '/.nomedia', '');

				/** @private */
				this.mProgressCb = function() {};
				/** @private */
				this.mDoneCb = function() {};
				this._setLifecycleListening(false);
				doneCb(err, man, hadCache);
			}
			catch (ex)
			{
				NgLogException(ex);
			}
		};

		this._readLocalManifest();
		this._setLifecycleListening(true);
		this.mValid = true;
	},

	abort: function()
	{
		this.reset();
	},

	pause: function()
	{
		// Cancel downloads
		this._clearConnections();

		// move active requests back to pending
		this.mPendingItems = this.mPendingItems.concat(this.mActiveRequests);
		this.mActiveRequests = [];

		this.mPaused = true;
	},

	resume: function()
	{
		if (this.mPaused)
		{
			this.mPaused = false;
			this._downloadPendingItems();
		}
	},

	_setLifecycleListening: function(toListen)
	{
		if (toListen && !this.lifeListening)
		{
			Device.LifecycleEmitter.addListener(this,
				function (event)
				{
					switch (event)
					{
						case Device.LifecycleEmitter.Event.Suspend:
						case Device.LifecycleEmitter.Event.Terminate:
							this._writeManifest();
						break;
					}
				}
			);
			this.lifeListening = true;
		}
		else if (this.lifeListening)
		{
			Device.LifecycleEmitter.removeListener(this);
			this.lifeListening = false;
		}
	},

	_theQuestion: function (toBe)
	{
		return toBe | !toBe;
	},

	_setConfig: function (cfg)
	{
		// For saving after completion
		this._Config = cfg;
		// for skipping JS download
		this._noJS = cfg.omitJsUpdate;
		// For using separate content URL
		this._secureContentUrl = cfg.secureContentUrl;
	},

	// Callback for read of local manifest file in start method.

	_onReadLocalManifest: function ( err, data )
	{
		if (this.mValid)
		{
			try	// always start try block in async callbacks
			{
				if ( ! err )
				{
					this.mLocalText = data;
				}
				else
				{
					this.mLocalText = '{}';	// Empty string is ! null.  It's ok for the read to fail.
				}
				this._downloadManifest();
			}
			catch ( ex )
			{
				NgLogException ( ex );
				this._processError ( 'Error reading local manifest err: ' + err , false );
			}
		}
	},

	// Called to start the manifest download.
	_downloadManifest: function()
	{
		var httpStatusCode = 0;
		Util.OperationWithRetries(
			(function(failCall, abortCall)
			{
				// Start remote manifest download.
				var req = new XHR();
				var id = this.mConnections.push(req) - 1;
				req.onreadystatechange = (function()
				{
					if( req.readyState == 4 && this.mValid )	// done && not cancelled
					{
						delete this.mConnections[id];
						httpStatusCode = req.status;
						if ( httpStatusCode == 200 )
						{
							this.mRemoteText = req.responseText;
							this._checkItems();

							if (this.mCheckUpdateOnly)
								this._checkUpdate();
							else
								this._evalManifests ();
						}
						else
						{
							console.log( 'Download of manifest at ' + this.mRemotePath
								+Util.getCacheBustingString() + ' failed: ' + httpStatusCode + ' '
								+ req.responseText);
							if (httpStatusCode == 404)
							{
								abortCall();
							}
							else
							{
								failCall();
							}
						}
					}
				}).bind(this);

				req.open ( 'GET', this.mRemotePath + Util.getCacheBustingString(), true );
				req.send ();
			}).bind(this),
			(function()
			{
				this._processError('Failed to download manifest (' + httpStatusCode + ')', false);
			}).bind(this),
			this.mFailEarly
		);
	},

	// Can be called at any time.

	_processError: function ( message , writeManifest)
	{
		if (writeManifest && this.mManifest)
		{
			this._writeManifest();
		}

		// Don't call the doneCB without checking local text
		if (this.mValid)
		{
			this.mDoneCb ( message, null,  this.mLocalText ? this.mLocalText.length > 2 : false );
			this.reset ();
		}
	},

	_checkItems: function()
	{
		// Init source and destination manifests.
		this.mManifest.initWithJsonText ( this.mLocalText , true );
		var other = new Manifest ();
		other.initWithJsonText ( this.mRemoteText );

		// Build list of pending local items.
		this.mManifest.foreach ( other, this._compareItems.bind(this));
	},

	_checkUpdate: function()
	{
		this.mPendingItems = [];
		this.mCheckUpdateCallback(this.mTotalBytes > 0, this.mTotalBytes);
	},

	_evalManifests: function ()
	{
		try
		{
			// JMarr always download with zips if they are available.
			// If we only need to download less than 33% of files and less than 33% of bytes, then don't use an archive.
			// Additinoally, we must be on wifi, or else carriers might tamper with our files.
			/*var NetworkEmitter = require('../Device/NetworkEmitter').NetworkEmitter;
			if(this.mPendingItems.length < this.mNumRemoteManifestFiles * 0.33
				&& this.mTotalBytes < this.mNumRemoteManifestBytes * 0.33
				&& NetworkEmitter.getLastStatus() == NetworkEmitter.Status.Wifi)
			{
				this.mDownloadArchives = false;
			}*/
			
			// Cache total bytes into separate variable. Archive download might increase
			// space needed, but not total bytes.
			this.mSpaceNeeded = this.mTotalBytes;

			var other = new Manifest ();
			other.initWithJsonText ( this.mRemoteText );
			// If there is no archive in the manifest, don't download an archive.
			if(!other.mArchives)
				this.mDownloadArchives = false;

			// Prepare for archive downloads. If mDownloadArchives is true,
			// then all files will be downloaded through an archive. Otherwise,
			// only files that are makred as force archive will be downloaded
			// through archive.
			this._prepareForArchiveDownload(other.mArchives, !this.mDownloadArchives);
			
			// Trigger progress callback.
			this.mProgressCb ( this.mCompleteBytes, this.mTotalBytes );

			this.mLocalGameList.freeSpace(this.mSpaceNeeded, (function (err)
			{
				if (err)
				{
					this._processError(err, false);
					return;
				}
				var num = this.mPendingItems.length;
				if (num)
				{
					console.log("Going to download %d items.", num);
					if (num < 10)
					{
						console.log("Items: " + JSON.stringify(this.mPendingItems));
					}
				}
				// Download anything that got into pending list
				this._downloadPendingItems ();
			}).bind(this));
		}
		catch (e)
		{
			NgLogException ( e );
			this.mDoneCb ( 'Failed processing manifests!', null );
		}
	},
	
	// Decides which archives need to be downloaded to ensure that all of the pending files are downloaded.
	_prepareForArchiveDownload: function(archives, onlyForcedFiles)
	{
		console.log('DownloadManfiest._prepareForArchiveDownload onlyForcedFiles:', onlyForcedFiles);
		// Iterate over files that need to be covered and make sure they are included.
		var neededFiles = [];
		var includedArcns = {};
		var includedExpSize = 0;
		var includedArcSize = 0;
		var filesToCover = this.mPendingItems;
		var nonForcedFiles = [];
		for(var i=0; i < filesToCover.length; ++i)
		{
			// If this file isn't an archive, just download the file.
			var f = filesToCover[i];
			if(!f.arcn)
			{
				//console.log('NonForced: including arnc-less %s', f.name);
				neededFiles.push(f);
				includedExpSize += f.size;
				continue;
			}
			
			// Record that this archive provides this file.
			var arcn = f.arcn;
			var a = archives[arcn];
			if(!a.files)
				a.files = [f];
			else
				a.files.push(f);
			
			// Is this archive already incldued?
			if(includedArcns[arcn])
				continue;
			
			// If we are only including forced files, remember that this
			// is a non forced file that we need to download. If after evaluating
			// all of the forced files and these files are not included, they will
			// be explicitly included.
			if(onlyForcedFiles && !f.arcForce)
			{
				nonForcedFiles.push(f);
				//console.log('NonForced: delaying decision about %s in arcn %d', f.name, f.arcn);
				continue;
			}
			
			//console.log('Forced: including %s from arcn %d', f.name, f.arcn);
			
			// Include the archive associated with this arcn.
			neededFiles.push(a);
			includedArcns[arcn] = true;
			includedExpSize += a.expSize;
			includedArcSize += a.arcSize;
		}
		
		// If only downloading forced archives, examine all of the queued
		// files that are not forced. If their archive is not included, then 
		// directly include the file.
		for(i=0; i < nonForcedFiles.length; ++i)
		{
			// Is the archive for this file already incldued?
			// This will happen if a forced file (like a .js) 
			// forced the archive to be included.
			var f = nonForcedFiles[i];
			if(includedArcns[f.arcn])
			{
				//console.log('NonForced: skipping %s because it is already in arcn %d', f.name, f.arcn);
				continue;
			}
			
			//console.log('NonForced: including %s from arch %d', f.name, f.arcn);
			
			// Otherwise, include this file.
			neededFiles.push(f);
			includedExpSize += f.size;
		}
		
		// Tell the rest of the world about our choices.
		this.mPendingItems = neededFiles;
		this.mTotalBytes = includedExpSize;
		this.mSpaceNeeded = includedExpSize + includedArcSize;
	},

	// Callback from Manifest.foreach.

	_compareItems: function ( key, dst, src )
	{
		var ditem = dst[key];
		var sitem = src[key];

		// Early out for removed file.  Always delete.
		if ( ! sitem )
		{
			var fname = this.mLocalRoot + key;
			var cb = function(err)
			{
				if (err)
				{
					console.log('Error deleting ' + fname + ' error: ' + err);
				}
			};
			FileSystem.deleteFile(fname, cb);

			// If the item was pending, delete the temporary file it was downloading
			if ('pending' in ditem )
			{
				fname = fname + '.tmp';
				FileSystem.deleteFile(fname, cb);
			}
			return false;
		}

		var isJS = this._extensionMatch ( key, 'js' );

		// Don't download the html or the js with noJS.
		if (this._noJS && (isJS || key == "index.html"))
		{
			// Don't download JS!! keep it in the local manifest, but don't push it to download
			return true;
		}

		sitem.name = key;
		this.mNumRemoteManifestFiles += 1;
		this.mNumRemoteManifestBytes += sitem.size;

		// No local version or version mismatch, must download.
		if ( ! ditem || ditem.hash != sitem.hash)
		{
			if ( isJS )
			{
				this.mNewJS = true;
			}

			// Tally the space we need for downloading new items
			this.mTotalBytes += sitem.size;

			// Add to the pending queue.
			this.mPendingItems.push ( sitem );
		}
		
		return true;
	},

	// Utility method to check for case-insensitive match for file extension.
	
	_extensionMatch: function ( fname, ext )
	{
		var pattern = new RegExp ( '^.*\.(' + ext + ')$', 'i' );
		var ret = fname.match ( pattern );
		return ret;
	},

	// Once in download state, this method is called to start downloading 
	// assets from manifest.  When each asset successfully completes, this method
	// will also be called to start the next download.  This method institutes
	// the logic for having a limited number of concurrent downloads from
	// the mCurrentRequests and mConcurrentRequests members.

	_downloadPendingItems: function ()
	{
		if (this.mValid && !this.mPaused)
		{
			// Are we done?
			if ( this.mPendingItems.length == 0 && this.mActiveRequests.length == 0)
			{
				if (this.mTotalBytes > 0)
				{
					this._writeManifest ();
				}
				this._writeConfig();

				// Trigger done callback and reset.
				this.mDoneCb ( null, this.mManifest );
				this.reset ();
				return;
			}

			// Not done, pop more pending items and start their downloads.
			while ( this.mPendingItems.length && this.mActiveRequests.length < this.mConcurrentRequests )
			{
				// Download the next pending file.
				var item = this.mPendingItems.pop ();
				item.retrySchedule = this.mRetrySchedule.slice(0);
				this._downloadItem(item);
			}
		}
	},
	
	_downloadItem: function(item)
	{
		this.mActiveRequests.push(item);
		var remoteUrl = this.mRemoteUrl + item.name;
		if(item.mangled)
		{
			var i = remoteUrl.lastIndexOf('.');
			remoteUrl = remoteUrl.substr(0, i) + '-' + remoteUrl.substr(i+1) + '.bin';
		}

		Util.OperationWithRetries((function(failCb)
		{
			// Start the download.
			var dlFile = new DownloadFile();
			var id = this.mConnections.push(dlFile) - 1;
			dlFile.start(this.mLocalRoot + item.name,
				'GET',
				remoteUrl + Util.getCacheBustingString(),
				[],
				this._onDownloadItemComplete.bind(this, item, failCb, id));
		}).bind(this), (function()
		{
			console.log('Manifest download failed. Too many failed download attempts for ' + item.name );
			this._processError ( 'Could not download file ' + item.name , true);
		}).bind(this), this.mFailEarly);
	},

	_removeActiveRequest: function (item)
	{
		for (var i in this.mActiveRequests)
		{
			if (item == this.mActiveRequests[i])
			{
				this.mActiveRequests.splice(i, 1);
			}
		}
	},

	// Callback for completion of download started in downloadItem method.
	// Will throw if item does not have pending member set.

	_onDownloadItemComplete: function ( item, failCb, id, status, hash )
	{
		try
		{
			delete this.mConnections[id];
			// Was there an error or bad download?
			if(status != 200 || item.hash != hash)
			{
				// Try to download the item again.
				console.log('Download failed.  Retrying ' + item.name );
				console.log('Status: ' + status + ' manifest hash: ' + item.hash + ' actual hash: ' + hash);
				failCb();
				return;
			}
			
			// Is this an archive?
			if(item.files)
			{
				// Temporarially increase the max number of connections while we decompress the archive.
				++this.mConcurrentRequests;
				
				FileSystem.decompressFile(this.mLocalRoot + item.name, this.mLocalRoot, false, (function(err, files)
				{
					// Restore max connections to original value.
					--this.mConcurrentRequests;
					
					// Delete the zip file.
					FileSystem.deleteFile(this.mLocalRoot + '/' + item.name);
					
					if(err)
					{
						// Try to download the item again.
						console.log('Decompress failed.  Retrying ' + item.name );
						failCb();
					}
					
					for(var i=0; i < item.files.length; ++i)
					{
						var f = item.files[i];
						this.mManifest.mJson[f.name] = {size: f.size, hash: f.hash};
					    if (typeof f.encryption != "undefined")
						this.mManifest.mJson[f.name].encryption = f.encryption;
					}

					this._removeActiveRequest(item);
					this.mCompleteBytes += Number(item.expSize);
					this.mProgressCb ( this.mCompleteBytes, this.mTotalBytes );
					this._downloadPendingItems ();
				}).bind(this));
			}
			else
			{
				// Update our working manifest.
				this.mManifest.mJson[item.name] = {size: item.size, hash: item.hash};
			    if (typeof item.encryption != "undefined")
				this.mManifest.mJson[item.name].encryption = item.encryption;
				
				// Make callbacks (like a boss).
				this._removeActiveRequest(item);
				this.mCompleteBytes += Number(item.size);
				this.mProgressCb ( this.mCompleteBytes, this.mTotalBytes );
				this._downloadPendingItems ();
			}
		}
		catch ( ex )
		{
			// Unlikely, but safety
			NgLogException ( ex );
			this._processError ( 'Error after finishing the download of item ' + item 
				+ '. status is ' + status , true );
		}
	},

	// Flush changes to locally cached manifest file.

	_writeManifest: function ()
	{
		console.log("DM Complete!");
		try
		{
			if (this.mManifest)
				this.mManifest.write ( this.mLocalPath );
		}
		catch (ex)
		{
			NgLogException(ex);
		}
	},

	_writeConfig: function ()
	{
		try
		{
			if (this._Config)
			{
				// console.log("writing |%s| to %s", JSON.stringify(this._Config), this.mLocalRoot + Capabilities._getConfigFile());
				FileSystem.writeFile(this.mLocalRoot + Capabilities._getConfigFile(),
					JSON.stringify(this._Config), function(err) {console.log(err); } );
			}
		}
		catch (ex)
		{
			NgLogException(ex);
		}
	}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/LocalGameList'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/LocalGameList'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/LocalGameList'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class LocalGameList
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Proc = require('NGCore/Client/Core/Proc').Proc;
var Class = require('NGCore/Client/Core/Class').Class;
var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Base64 = require('NGCore/Client/Core/Base64').Base64;
var toMD5 = require('NGCore/Client/Core/toMD5').toMD5;
var Util = require('NGCore/Client/Network/Util').Util;
var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;

////////////////////////////////////////////////////////////////////////////////

var LifeListener = MessageListener.subclass(
{
	initialize: function(listen)
	{
		LifecycleEmitter.addListener(this, this.onLifecycleUpdate);
		this._listener = listen;
	},

	destroy: function()
	{
		LifecycleEmitter.removeListener(this);
	},

	onLifecycleUpdate: function(event)
	{
		switch (event)
		{
			case Device.LifecycleEmitter.Event.Resume:
				this._listener.onResume();
				break;
		}
	}
});

exports.LocalGameList = Class.singleton (
/** @lends Core.LocalGameList.prototype */
{
	classname: 'LocalGameList',

	/**
	 * @class The <code>LocalGameList</code> class constructs objects that handle the loading and updating of a user's game list.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		new LifeListener(this);
		this.mRefCount = 0;
		this.mRefTable = [];
		this.mSpaceAvailable = 0;
		this.mRequiredAvailableSpace = 0;
		
		this.mSpaceCB = [];

		this._getRepoSpaceSendGen();

		var self = this;
		var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
		this.mGameStore = KeyValueCache.global("Core.GameList");
		this.mActiveGameKey = "activeGames";
		this.onResume();
	},


	/** @private */
	onResume: function()
	{
		this._reloadGameList();
	},

	_reloadGameList: function()
	{
		this.mGameStore.getItem(this.mActiveGameKey,
			(function(error, value)
			{
				var list;
				if (value)
					list = JSON.parse(value);
				else
					list = [];

				this.mGameList = list;
				if (typeof this.mListListen == 'function')
					this.mListListen();
			}).bind(this),
			true
		);
	},

	/** @private */
	setListListener: function(funk)
	{
		this.mListListen = funk;
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 302
	// Method create = -1
	// Method updateGame = 2
	// Method updateDone = 3
	// Method getRepoSpace = 4
	// Method repoSpace = 5
	// Method deleteGame = 6
	// Method _setUpdateProgressVisible = 7
	// Method _setUpdateProgressBounds = 8
	// Method pauseUpdate = 9
	// Method resumeUpdate = 10
	// Method cancelUpdate = 11
	// Method updateProgress = 12
	// Method runGame = 13
	// Method finishGame = 14
	// Method _forwardException = 15
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 3:
					instance._updateDoneRecv( cmd );
					break;
				case 5:
					instance._repoSpaceRecv( cmd );
					break;
				case 12:
					instance._updateProgressRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[302] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_updateDoneRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in LocalGameList.updateDone from command: " + cmd );
			return false;
		}
		
		obj[ "id" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "id" ] === undefined )
		{
			NgLogE("Could not parse id in LocalGameList.updateDone from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in LocalGameList.updateDone from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_repoSpaceRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		obj[ "space" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "space" ] === undefined )
		{
			NgLogE("Could not parse space in LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_updateProgressRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 4 )
		{
			NgLogE("Could not parse due to wrong argument count in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "cur" ] = Proc.parseInt( cmd[ 1 ] );
		if( obj[ "cur" ] === undefined )
		{
			NgLogE("Could not parse cur in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "total" ] = Proc.parseInt( cmd[ 2 ] );
		if( obj[ "total" ] === undefined )
		{
			NgLogE("Could not parse total in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Proc.parseBool( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( ":302,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_updateGameSendGen: function( url, id )
	{
		Proc.appendToCommandString( ":302,2," + this.__objectRegistryId + "," + Base64.encode( url ) + "," + id  );
	},
	
	/** @private */
	_getRepoSpaceSendGen: function(  )
	{
		Proc.appendToCommandString( ":302,4," + this.__objectRegistryId );
	},
	
	/** @private */
	_deleteGameSendGen: function( mdFive )
	{
		Proc.appendToCommandString( ":302,6," + this.__objectRegistryId + "," + Base64.encode( mdFive )  );
	},
	
	/** @private */
	__setUpdateProgressVisibleSendGen: function( visible )
	{
		Proc.appendToCommandString( ":302,7," + this.__objectRegistryId + "," + ( visible ? 1 : 0 )  );
	},
	
	/** @private */
	__setUpdateProgressBoundsSendGen: function( x, y, w, h )
	{
		Proc.appendToCommandString( ":302,8," + this.__objectRegistryId + "," + x + "," + y + "," + w + "," + h  );
	},
	
	/** @private */
	_pauseUpdateSendGen: function( url )
	{
		Proc.appendToCommandString( ":302,9," + this.__objectRegistryId + "," + Base64.encode( url )  );
	},
	
	/** @private */
	_resumeUpdateSendGen: function( url )
	{
		Proc.appendToCommandString( ":302,10," + this.__objectRegistryId + "," + Base64.encode( url )  );
	},
	
	/** @private */
	_cancelUpdateSendGen: function( url )
	{
		Proc.appendToCommandString( ":302,11," + this.__objectRegistryId + "," + Base64.encode( url )  );
	},
	
	/** @private */
	_runGameSendGen: function( url )
	{
		Proc.appendToCommandString( ":302,13," + this.__objectRegistryId + "," + Base64.encode( url )  );
	},
	
	/** @private */
	_finishGameSendGen: function(  )
	{
		Proc.appendToCommandString( ":302,14," + this.__objectRegistryId );
	},
	
	/** @private */
	__forwardExceptionSendGen: function( exceptionString )
	{
		Proc.appendToCommandString( ":302,15," + this.__objectRegistryId + "," + Base64.encode( exceptionString )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// updateGame: function( url, id ) {}
	
	// _updateDoneRecv: function( cmd ) {}
	// getRepoSpace: function(  ) {}
	
	// _repoSpaceRecv: function( cmd ) {}
	// deleteGame: function( mdFive ) {}
	
	// _setUpdateProgressVisible: function( visible ) {}
	
	// _setUpdateProgressBounds: function( x, y, w, h ) {}
	
	// pauseUpdate: function( url ) {}
	
	// resumeUpdate: function( url ) {}
	
	// cancelUpdate: function( url ) {}
	
	// _updateProgressRecv: function( cmd ) {}
	// runGame: function( url ) {}
	
	// finishGame: function(  ) {}
	
	// _forwardException: function( exceptionString ) {}
	

// {{/Wg Generated Code}}
	
	_setProgressVisible: function (progressVisible) {
		this.progressVisible = progressVisible;
		this.__setUpdateProgressVisibleSendGen(progressVisible);
	},
	
	_setProgressBounds: function(bounds) {
		this.__setUpdateProgressBoundsSendGen(bounds[0],bounds[1],bounds[2],bounds[3]);
	},
	
	_createProcSwitchDialog: function(title)
	{
		var UI = require('NGCore/Client/UI').UI;
		var Device = require('NGCore/Client/Device').Device;
		var w = NGWindow.outerWidth;
		var h = NGWindow.outerHeight;
		
		if(Device.OrientationEmitter.getInterfaceOrientation() == Device.OrientationEmitter.Orientation.Landscape
			|| Device.OrientationEmitter.getInterfaceOrientation() == Device.OrientationEmitter.Orientation.LandscapeLeft)
		{
			w = NGWindow.outerHeight;
			h = NGWindow.outerWidth;
		}
		
		var r = new UI.ViewGeometry.Rect(0, 0, w, h);
		
		var background = new UI.View({
			'frame': r.array(),
			'title': title,
			'backgroundColor': "8000"
		});
		
		r.inset(Math.round( (h - 238) / 2.0 ), 10);
		
		var dialog = new UI.View({
			'frame': r.array(),
			'gradient': {
				gradient: ["FF102031 0.0", "FF102031 0.394", "FF101820 0.394", "FF101820 1.0"],
				outerLine: "FF9c 1.0"
			}
		});
		background.addChild(dialog);

		r.x = r.y = 0;
		
		var header = new UI.Label({
			'frame': r.sliceVertical(94).array(),
			'text': (title || "Please Wait…"),
			'textColor': "FFFF",
			'textShadow': "8000 1.0 {0,-1}",
			'textSize': 24.0,
			'textGravity': [0.0, 0.5],
			'textInsets': [10, 30, 10, 30]
		});
		dialog.addChild(header);
		
		r.inset(36, 36 + Math.floor( (r.w - r.h) / 2));
		r.h = r.w;
		
		var spinner = new UI.Spinner({
			'frame': r.array()
		});
		dialog.addChild(spinner);
		
		UI.Window.document.addChild(background);
		
		return background;
	},

	/**
	* Restart the current game
	*/
	restartGame: function()
	{
		this.runGame(Capabilities.getServer() + "/" + Capabilities.getGame());
	},

	/**
	* Launch a game from the specified URL.
	* @param {String} url The specified URL of a game. Null to return to mobage.
	*/
	
	runGame: function( url )
	{
		console.log("Calling runGame with " + url);
		if (!url)
		{
			console.log("Finishing");
			this._finishGame();
		}
		else
		{
			this._runGameSendGen(Util.NormalizeUrl(url));
		}
	},

/** private */
	_finishGame: function()
	{
		this._finishGameSendGen();
	},

	// Next 5 functions are for mobage, not developers.

	// callback = function(gameUrl, dl'd, total, error)
	// mobage responsibility to intercept when dl'd == total, update is finished
	//	or know if there was an error by checking that param

	listenUpdates: function(callback)
	{
		this.mUpdateListener = callback;
	},

	stopUpdateListening: function()
	{
		delete this.mUpdateListener;
	},

	pauseUpdate: function(url)
	{
		this._pauseUpdateSendGen(Util.NormalizeUrl(url));
	},

	resumeUpdate: function(url)
	{
		this._resumeUpdateSendGen(Util.NormalizeUrl(url));
	},

	cancelUpdate: function(url)
	{
		this._cancelUpdateSendGen(Util.NormalizeUrl(url));
	},

	/**
	* Update an application at the specified URL.
	* @example Core.LocalGameList.updateGame(url, (function(err)
	*	{
	*		if (err)
	*		{
	*			NgLogE("GameHub error updating game! " + err);
	*			Network.Util.showSimpleNetworkError();
	*			this._loadingGame = false;
	*		}
	*		else
	*		{
	*			Core.LocalGameList.runGame(url);
	*		}
	*	});
	* @param {String} url The specified URL.
	* @param {Function} cb The callback function to pass in.
	*/
	
	updateGame: function( url , cb )
	{
		var reqId = this.mRefCount;
		this.mRefTable[this.mRefCount++] = cb;

		this._updateGameSendGen( Util.NormalizeUrl(url), reqId );
		return reqId;
	},
	
	/**
	* Launch an updated application from the specified URL.
	* @example Core.LocalGameList.runUpdatedGame('/games/MyGames');
	* @param {String} url The specified URL of an updated application.
	*/
	
	runUpdatedGame: function (url)
	{
		if (!url)
		{
			this._finishGame();
			return;
		}

		this.updateGame(url,
			(function(err)
			{
				if (err)
				{
					NgLogE("LGL Error updating game! " + err);
					Util.showFatalErrorDialog();
				}
				else
				{
					this.runGame(url);
				}
			}).bind(this)
		);
	},

	_updateProgressRecv: function( cmd )
	{
		var obj = {};
		this._updateProgressRecvGen(cmd, obj);
		if (this.mUpdateListener)
			this.mUpdateListener(obj.url, obj.cur, obj.total, obj.error);
	},

	_updateDoneRecv: function( cmd )
	{
		var obj = {};
		this._updateDoneRecvGen(cmd, obj);

		this._reloadGameList();

		var cb = this.mRefTable[obj.id];
		if (cb)
		{
			cb(obj.error);
		}

		delete this.mRefTable[obj.id];
		this._getRepoSpaceSendGen();
	},

	_repoSpaceRecv: function( cmd )
	{
		var obj = {};
		this._repoSpaceRecvGen(cmd, obj);
		this.mSpaceAvailable = obj.space - 7340032; // KJ report 7mb less
		console.log('LocalGameList.got response:', this.mSpaceAvailable, 'and need:', this.mRequiredAvailableSpace);
		
		if(this.mRequiredAvailableSpace > this.mSpaceAvailable)
		{
			var errorAlert = new UI.AlertDialog();
			errorAlert.setText(Core.Localization.getString("SD card is full"));
			errorAlert.setChoices([Core.Localization.getString("Exit")]);
			errorAlert.game = this.game;
			errorAlert.onchoice = function(ret)
			{
				errorAlert.hide();
				LifecycleEmitter.exitProcess();
			};
			errorAlert.show();
		}
		else
		{
			for(var i=0; i < this.mSpaceCB.length; ++i)
			{
				this.mSpaceCB[i]();
			}
			this.mSpaceCB = [];
			this.mRequiredAvailableSpace = 0;
		}
	},

	/**
	 * @private
	 */
	getGameList: function()
	{
		// Caveat! This will return an empty list if it is the first call. Must initialize beforehand.-KJ
		return this.mGameList;
	},

	/**
	 * @private
	 */
	updateGameList: function(list)
	{
		this.mGameList = list;
	},

	/**
	 * @private
	 */
	freeSpace: function(space, cb)
	{
		this.mRequiredAvailableSpace += space;
		
		this.mSpaceCB.push(cb);
		console.log('LocalGameList.freeSpace space=', this.mRequiredAvailableSpace);
		if(this.mSpaceCB.length == 1)
		{
			console.log('LocalGameList.sending request to native');
			// Send request to native if this is the first requester.
			this._getRepoSpaceSendGen();
		}
	},

	/**
	 * @private
	 */
	deleteGame: function(url)
	{
		url = Util.NormalizeUrl(url);
		var hash = toMD5(url);
		this._deleteGameSendGen(hash);

		var self = this;
		var doneCB = function ()
		{
			NgLogD("LocalGameList finished deleting game from " + self.mActiveGameKey + " for " + hash );
		};

		// Update cached game list to match what's going to happen in high-priv.
		// Matches logic in _LocalGameList._deleteGameFromStorage, but doesn't
		// write to Storage key.
		if( this.mGameList )
		{
			var list = this.mGameList;
			var good = false;
			var ind;
			var out = [];
			for(ind = 0; ind < list.length; ++ind)
			{
				if(list[ind].name == hash)
					good = true;
				else
					out.push(list[ind]);
			}

			if( good )
			{
				NgLogD("LocalGameList found and removed " + hash);
				this.mGameList = out;
			}
			else
				NgLogD("LocalGameList failed to find and remove " + hash);
		}
		else
			NgLogD("LocalGameList cache not warm, can't remove " + hash);
	},

	/**
	 * Check if an update is available for the specified application.<br><br>
	 * The following code illustrates how to retrieve an application name to pass in for this call.
	 * @param {String} game The specified game. Use <code>{@link Core.Capabilities.getGame}</code> to return the game name.
	 * @param {Function} callback The function to call once the check is complete.
	 * @example
	 *
	 * updateButton.onclick = function() {
	 *     LocalGameList.updateAvailable(Core.Capabilities.getUrl(), function(updated, spaceNeeded) {
	 *         if (updated)
	 *             LGL.runUpdatedGame(Core.Capabilities.getUrl());
	 *     });
	 * };
	 * @status
	 */
	updateAvailable: function(game, doneCB, errorCB)
	{
		var _int_LGL = require('NGCore/Client/Core/_int_LGL')._int_LGL;
		_int_LGL.updateAvailable(game, doneCB, errorCB);
	},

	_forwardException: function( exceptionString )
	{
		this.__forwardExceptionSendGen({exceptionString:exceptionString});
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device'] || {}; $MODULE_REGISTRY['NGCore/Client/Device'] = exports; /**
 * <p>Classes and objects contained by the Device module.</p>
 * @name Device
 * @namespace
 * @description <p>The Device module is a collection of classes that support the effect of physical movement on a device.
 * Each class instantiates a device singleton that emits when specific device conditions are met:</p>
 *<ul>
 *<li><code>{@link Device.KeyEmitter}</code>: A singleton object for emitting when the user presses or releases a device hardware key.</li>
 *<li><code>{@link Device.LifecycleEmitter}</code>: A singleton object for emitting when device lifecycle events occur.</li>
 *<li><code>{@link Device.LocationEmitter}</code>: A singleton object for emitting the geographic location of a device.</li>
 *<li><code>{@link Device.MemoryEmitter}</code>: A singleton object for emitting when low-memory states occur on a device.</li>
 *<li><code>{@link Device.MotionEmitter}</code>: A singleton object for emitting objects that collect spatial data from a device.</li>
 *<li><code>{@link Device.NetworkEmitter}</code>: A singleton object for emitting when a change in network status occurs for a device.</li>
 *<li><code>{@link Device.OrientationEmitter}</code>: A singleton object for emitting when a change to the physical orientation of the device occurs.</li>
 *<li><code>{@link Device.ShakeEmitter}</code>: A singleton object for emitting when the device detects a shake gesture.</li>
 *</ul>
 */
exports.Device = {};

exports.Device.__defineGetter__("LifecycleEmitter", function() {
	delete this.LifecycleEmitter;
	return this.LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;
});
exports.Device.__defineGetter__("LocationEmitter", function() {
	delete this.LocationEmitter;
	return this.LocationEmitter = require('NGCore/Client/Device/LocationEmitter').LocationEmitter;
});
exports.Device.__defineGetter__("MemoryEmitter", function() {
	delete this.MemoryEmitter;
	return this.MemoryEmitter = require('NGCore/Client/Device/MemoryEmitter').MemoryEmitter;
});
exports.Device.__defineGetter__("MotionEmitter", function() {
	delete this.MotionEmitter;
	return this.MotionEmitter = require('NGCore/Client/Device/MotionEmitter').MotionEmitter;
});
exports.Device.__defineGetter__("NetworkEmitter", function() {
	delete this.NetworkEmitter;
	return this.NetworkEmitter = require('NGCore/Client/Device/NetworkEmitter').NetworkEmitter;
});
exports.Device.__defineGetter__("OrientationEmitter", function() {
	delete this.OrientationEmitter;
	return this.OrientationEmitter = require('NGCore/Client/Device/OrientationEmitter').OrientationEmitter;
});
exports.Device.__defineGetter__("ShakeEmitter", function() {
	delete this.ShakeEmitter;
	return this.ShakeEmitter = require('NGCore/Client/Device/ShakeEmitter').ShakeEmitter;
});
exports.Device.__defineGetter__("KeyEmitter", function() {
	delete this.KeyEmitter;
	return this.KeyEmitter = require('NGCore/Client/Device/KeyEmitter').KeyEmitter;
});
exports.Device.__defineGetter__("PushNotificationEmitter", function() {
	delete this.PushNotificationEmitter;
	return this.PushNotificationEmitter = require('NGCore/Client/Device/_PushNotificationEmitter').PushNotificationEmitter;
});
exports.Device.__defineGetter__("InAppPurchaseEmitter", function() {
	delete this.InAppPurchaseEmitter;
	return this.InAppPurchaseEmitter = require('NGCore/Client/Device/_InAppPurchaseEmitter').InAppPurchaseEmitter;
});
exports.Device.__defineGetter__("InAppPurchase", function() {
	delete this.InAppPurchase;
	return this.InAppPurchase = require('NGCore/Client/Device/_InAppPurchase').InAppPurchase;
});
exports.Device.__defineGetter__("IPCEmitter", function() {
	delete this.IPCEmitter;
	return this.IPCEmitter = require('NGCore/Client/Device/IPCEmitter').IPCEmitter;
});
exports.Device.__defineGetter__("LayoutEmitter", function() {
	delete this.LayoutEmitter;
	return this.LayoutEmitter = require('NGCore/Client/Device/LayoutEmitter').LayoutEmitter;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core'] || {}; $MODULE_REGISTRY['NGCore/Client/Core'] = exports; /**
 * <p>Classes and objects contained by the Core module.</p>
 * @name Core
 * @namespace
 * @description <p>The Core module is a collection of classes that provide applications with access to:</p>
 * <ul>
 * <li>Core components of a device.</li>
 * <li>APIs that define a class-based structure for development.</li>
 * <li>Objects that support application updates.</li>
 * </ul>
 * <p>Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 * <ul>
 * <li><code>{@link Core.Analytics}</code>: Construct objects that keep track of game-specific items that require analysis and counting.</li>
 * <li><code>{@link Core.Capabilities}</code>: A singleton object that contains data about device hardware components.</li>
 * <li><code>{@link Core.Class}</code>: Supports construction of objects and classes for use in OOP environments.</li>
 * <li><code>{@link Core.Color}</code>: Control the RGB color components of a device.</li>
 * <li><code>{@link Core.LocalGameList}</code>: Construct objects that manage a user's game list.</li>
 * <li><code>{@link Core.MessageEmitter}</code>: A base class object for constructing objects that emit application notifications.</li>
 * <li><code>{@link Core.MessageListener}</code>: A base class object for constructing objects that handle application notifications.</li>
 * <li><code>{@link Core.NativeAppLaunch}</code>: Construct objects for storing <code>intent</code> strings.</li>
 * <li><code>{@link Core.Point}</code>: Control the point values for <i>x</i> and <i>y</i> coordinates.</li>
 * <li><code>{@link Core.Rect}</code>: Construct rectangle objects.</li>
 * <li><code>{@link Core.Size}</code>: Control the values for <i>height</i> and <i>width</i> components.</li>
 * <li><code>{@link Core.Time}</code>: A singleton that contains data about device timing values.
 * <li><code>{@link Core.UpdateEmitter}</code>: Control the application update time rate.</li>
 * <li><code>{@link Core.Vector}</code>: Control the vector values for <i>x</i> and <i>y</i> coordinates.</li>
 * </ul>
 */
exports.Core = {};

exports.Core.__defineGetter__("Analytics", function() {
	delete this.Analytics;
	return this.Analytics = require('NGCore/Client/Core/Analytics').Analytics;
});
exports.Core.__defineGetter__("Base64", function() {
	delete this.Base64;
	return this.Base64 = require('NGCore/Client/Core/Base64').Base64;
});
exports.Core.__defineGetter__("Capabilities", function() {
	delete this.Capabilities;
	return this.Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
});
exports.Core.__defineGetter__("Class", function() {
	delete this.Class;
	return this.Class = require('NGCore/Client/Core/Class').Class;
});
exports.Core.__defineGetter__("Color", function() {
	delete this.Color;
	return this.Color = require('NGCore/Client/Core/Color').Color;
});
exports.Core.__defineGetter__("Vector", function() {
	delete this.Vector;
	return this.Vector = require('NGCore/Client/Core/Vector').Vector;
});
exports.Core.__defineGetter__("Point", function() {
	delete this.Point;
	return this.Point = require('NGCore/Client/Core/Point').Point;
});
exports.Core.__defineGetter__("Size", function() {
	delete this.Size;
	return this.Size = require('NGCore/Client/Core/Size').Size;
});
exports.Core.__defineGetter__("Rect", function() {
	delete this.Rect;
	return this.Rect = require('NGCore/Client/Core/Rect').Rect;
});
exports.Core.__defineGetter__("MessageEmitter", function() {
	delete this.MessageEmitter;
	return this.MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
});
exports.Core.__defineGetter__("MessageListener", function() {
	delete this.MessageListener;
	return this.MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
});
exports.Core.__defineGetter__("ObjectRegistry", function() {
	delete this.ObjectRegistry;
	return this.ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
});
exports.Core.__defineGetter__("Time", function() {
	delete this.Time;
	return this.Time = require('NGCore/Client/Core/Time').Time;
});
exports.Core.__defineGetter__("toMD5", function() {
	delete this.toMD5;
	return this.toMD5 = require('NGCore/Client/Core/toMD5').toMD5;
});
exports.Core.__defineGetter__("SHA1", function() {
	delete this.SHA1;
	return this.SHA1 = require('NGCore/Client/Core/SHA1').SHA1;
});
exports.Core.__defineGetter__("UpdateEmitter", function() {
	delete this.UpdateEmitter;
	return this.UpdateEmitter = require('NGCore/Client/Core/UpdateEmitter').UpdateEmitter;
});
exports.Core.__defineGetter__("Proc", function() {
	delete this.Proc;
	return this.Proc = require('NGCore/Client/Core/Proc').Proc;
});
exports.Core.__defineGetter__("Logger", function() {
	delete this.Logger;
	return this.Logger = require('NGCore/Client/Core/Logger').Logger;
});
exports.Core.__defineGetter__("LocalGameList", function() {
	delete this.LocalGameList;
	return this.LocalGameList = require('NGCore/Client/Core/LocalGameList').LocalGameList;
});
exports.Core.__defineGetter__("Localization", function() {
	delete this.Localization;
	return this.Localization = require('NGCore/Client/Core/Localization').Localization;
});
exports.Core.__defineGetter__("_LocalGameList", function() {
	delete this._LocalGameList;
	return this._LocalGameList = require('NGCore/Client/Core/_LocalGameList')._LocalGameList;
});
exports.Core.__defineGetter__("NativeAppLaunch", function() {
	delete this.NativeAppLaunch;
	return this.NativeAppLaunch = require('NGCore/Client/Core/NativeAppLaunch').NativeAppLaunch;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Capabilities'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Capabilities'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Capabilities'] = exports; 	////////////////////////////////////////////////////////////////////////////////
// Class Capabilities
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Proc = require('NGCore/Client/Core/Proc').Proc;

////////////////////////////////////////////////////////////////////////////////

exports.Capabilities = Class.singleton(
/** @lends Core.Capabilities.prototype */
{
	classname: 'Capabilities',
	_configFile: 'configuration.json',

	/**
	 * @class The <code>Capabilities</code> class constructs a singleton object that contains device properties. These objects represent the device and provide access to device information. 
	 * This class also provides information about how a device and game servers communicate.
	 * <br><br>
	 * <b>Note:</b> An application should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

        // Please keep this on one line, sed won't update otherwise
		this._fields = {version: 'sdks_1.3-20110826-1.3.1', buildDate: '20110910', buildHash: 'g50eb399'};
	},

	_getConfigFile:			function() {return this._configFile;},
	_isGameLoaded:			function() {return this._fields._gamePreLoaded;},
	_getAccts:				function() {return this._fields._accts;},

	meetsBinaryVersion: function(desiredVersion)
	{
		var binary = this.getBinaryVersion().split('-').pop().split('.');
		var desired = desiredVersion.split('.');

		// A shorter length means a lower version (if all other items match)
		var meets = binary.length >= desired.length;
		var len = Math.min(desired.length, binary.length);
		for (var i = 0; i < len; ++i)
		{
			var bin = Number(binary[i]);
			var des = Number(desired[i]);
			if (bin != des)
			{
				meets = bin > des;
				break;
			}
		}
		return meets;
	},

	/**
	 * Return the object stored in configuration.json for your game.
	 * @returns {Object} The JSON.parsed object represented in your configuration.json file.
	 * @type Object
	 * @status
	 */
	getConfigs:			function() {return this._configuration;},

	/**
	 * Return the SDK version number from the <code>Capabilities</code> of this device.
	 * @returns {String} The version of the SDK on the device.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSDKVersion:           function() { return this._fields.version; },

	/**
	 * Return the build date for the currently installed SDK. The build date is in the format <i>YYYYMMDD</i>.
	 * @returns {String} The build date for the SDK on the device.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSDKBuildDate:           function() { return this._fields.buildDate; },
	
	/**
	 * Return the build hash of the currently installed SDK.
	 * @returns {String} The build hash for the SDK on the device.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSDKBuildHash:           function() { return this._fields.buildHash; },

	/**
	 * Return the version of the currently running ngCore binary
	 * @returns {String} The version of ngCore running
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBinaryVersion:           function() { return this._fields.binaryVersion; },

	/**
	 * Return the build date for the currently running ngCore binary. The build date is in the format <i>YYYYMMDD</i>.
	 * @returns {String} The build date for the ngCore binary
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBinaryBuildDate:           function() { return this._fields.binaryBuildDate; },

	/**
	 * Return the build hash of the currently running ngCore binary
	 * @returns {String} The build hash for the ngCore binary
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBinaryBuildHash:           function() { return this._fields.binaryBuildHash; },
	
	/**
	 * Return the device ID. 
	 * @returns {String} The device ID for the device running the application.
	 * @type String
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getUniqueId:           function() { return this._fields.uniqueId; },

	/**
	 * Return the lifetime constant value of the device.<br><br>
	 * <b>Note:</b> Currently only available on Android.
	 * @returns {String} <code>Settings.Secure.ANDROID_ID</code>: A 64-bit number as a hex string randomly generated on first boot of the device. 
	 * <b>Note:</b> This value only changes when the device is reset.
	 * @status Android
	 */
	getLifetimeName: function() { return this._fields.lifetimeName; },
	
	/**
	 * Return the device name.
	 * @returns {String} The device name for the device running the application.
	 * @type String
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getDeviceName:         function() { return this._fields.deviceName; },
	
	/**
	 * Return the operating system.
	 * @returns {String} The operating system of the device running the application.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getPlatformOS:         function() { return this._fields.platformOs; },
	
	/**
	 * Return the operating system version number.
	 * @returns {String} The version number of the operating system running on the device.
	 * @type String
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getPlatformOSVersion:  function() { return this._fields.platformOsVersion; },
	
	/**
	 * Return the device hardware type.
	 * @returns {String} The type of device hardware running the application.
	 * @type String
	 * @status iOS, Flash, Test, iOSTested, AndroidTested
	 */
	getPlatformHW:         function() { return this._fields.platformHw; },
	
	/**
	 * Return the total amount of installed memory.
	 * @returns {Number} The amount of installed memory on the device running the application.
	 * @type Number
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getPhysicalMem:        function() { return this._fields.physicalMem; },
	
	/**
	 * Return the total number of installed CPUs.
	 * @returns {Number} The number of CPUs installed on the device running the application.
	 * @type Number
	 * @status iOS, Test, iOSTested, AndroidTested
	 */
	getPhysicalCpus:       function() { return this._fields.physicalCpus; },
	
	/**
	 * Return the number of active CPUs.
	 * @returns {Number} The number of active CPUs on the device running the application.
	 * @type Number
	 * @status iOS, Test, iOSTested, AndroidTested
	 */
	getActiveCpus:         function() { return this._fields.activeCpus; },
	
	/**
	 * Return the installed user language. 
	 * @returns {String} The installed user language on the device running the application.
	 * Expressed as a canonicalized IETF BCP 47 language identifier.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLanguage:         function() { return this._fields.language; },

	_getBoot:         function() { return this._fields.boot; },
	_getBootServer:         function() { return this._fields.bootServer; },

	/**
	 * Return the URL for the content of this application.
	 * @returns {String} The URL to content for this application.
	 * @status
	 */
	getContentUrl:			function() {return this._fields.contentUrl;},

	/**
	 * Return the name of the root application. Root application refers to the application that launches when the user taps the application icon.
	 * @returns {String} The directory name for the root application.
	 * @status
	 */
	getBootGame:         function() { return this._fields.bootgame; },

	/**
	 * Return the starting server for an application.
	 * @returns {String} The start server.
	 * @type String
	 * @status
	 */
	getStartingServer:         function() { return this._fields.startingServer; },

	/**
	 * Return the name of the application bundled with the binary of this build.
	 * @returns {String} The name of the bundled game.
	 * @type String
	 * @status
	 */
	getBundleGame:         function() { return this._fields.bundleGame; },

	/**
	 * Return the server bundled with the binary of this build.
	 * @returns {String} The bundle server.
	 * @type String
	 * @status
	 */
	getBundleServer:         function() { return this._fields.bundleServer; },

	/**
	 * Return the bundle identifier for the binary of this build.
	 * @returns {String} The bundle identifier.
	 * @type String
	 * @status
	 */
	getBundleIdentifier:         function() { return this._fields.bundleIdentifier; },
	
	/**
	 * Return the directory name of the currently running application.
	 * @returns {String} The current folder name for the application.
	 * @type String
	 * @status iOS, Android, Flash
	 */
	getGame:         function() { return this._fields.game; },

	/**
	 * Return the server from which an application was downloaded.
	 * @returns {String} The download server.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getServer:         function() { return this._fields.server; },

	/**
	 * Return the full URL for the current application.
	 * @returns {String} The URL from which a application is downloaded.
	 * @type String
	 * @status
	 */
	getUrl:         function() { return this._fields.url; },

	/**
	 * Return the logical screen width for this device.
	 * @returns {Number} The current screen width of the device.
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getScreenWidth:        function() { return this._fields.screenWidth; },
	
	/**
	 * Return the logical screen height for this device.
	 * @returns {Number} The current screen height of the device.
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getScreenHeight:       function() { return this._fields.screenHeight; },
	
	/**
	 * Return a reasonable factor for scaling logical coordinates to the current display.
	 * @returns {Number} Logically scaled screen units for the device.
	 * @type Number
	 * @status
	 */
	getScreenUnits:        function() { return this._fields.screenUnits; },
	
	/**
	 * Return the number of physical pixels associated with one unit of logical space.
	 * @returns {Number} The total number of pixels that equal one screen unit.
	 * @type Number
	 * @status
	 */
	getScreenPixelUnits:       function() { return this._fields.screenPixelUnits; },
	
	/**
	 * Return the maximum number of supported textures.
	 * @returns {Number} The maximum number of supported textures per coordinate (<i>x</i>,<i>y</i>).
	 * @type Number
	 * @status Test, iOSTested, AndroidTested
	 */
	getMaxTextureSize:     function() { return this._fields.maxTextureSize; },
	
	/**
	 * Return the maximum number of supported texture units.
	 * @returns {Number} The maximum number of supported texture units per coordinate (<i>x</i>,<i>y</i>).
	 * @type Number
	 * @status Test, iOSTested, AndroidTested
	 */
	getMaxTextureUnits:    function() { return this._fields.maxTextureUnits; },
	
	/**
	 * @deprecated Replaced by {@link UI.GLView#getGLExtensions}.
	 */
	getOglExtensions:      function()
	{
		if (this._fields.oglExtensions)
			return this._fields.oglExtensions;

		// This table should stay in sync with:
		// https://spreadsheets.google.com/a/ngmoco.com/spreadsheet/ccc?key=0AinqDSqLOjJtdDMwNGk0eDgtRFdvQ2N0eWRUcGlsc0E&hl=en_US&authkey=CMWLyoAC
		switch (this._fields.deviceName)
		{
			case "Droid":                // Motorola Droid
			case "DROID2":               // Motorola Droid 2
			case "DROIDX":               // Motorola Droid X
			case "SGH-T959":             // Samsung Galaxy S 19000 8GB
			case "SGH-T959V":            // Samsung Galaxy S 4G
			case "SAMSUNG-SGH-I997":     // Samsung Galaxy S2
			case "SAMSUNG-SGH-I897":     // Samsung Captivate
			case "Nexus S":              // Google Nexus S
				return ["GL_IMG_texture_compression_pvrtc"];
			case "HTC Desire":           // HTC Desire GSM
			case "PC36100":              // HTC Evo 4G
			case "ADR6300":              // HTC Droid Incredible
			case "001HT":                // HTC Desire HD
			case "Nexus One":            // Google Nexus One
			case "HTC Glacier":          // HTC myTouch 4G
				return ["GL_AMD_compressed_ATC_texture"];
			default:
				return [];
		}
	},

	/**
	 * Return the directory path to the temp directory for this device.
	 * @returns {String} The directory path to the temp directory on the device.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTmpDir:           function() { return this._fields.tmpDir; },

	/**
	 * Check the <code>Capabilities</code> of this device for an accelerometer.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains an accelerometer.
	 * @type Boolean
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getHasAccel:           function() { return this._fields.hasAccel; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a gyroscope.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains an gyroscope.
	 * @type Boolean
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getHasGyro:            function() { return this._fields.hasGyro; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for touchscreen input support.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application supports touchscreen input.
	 * @type Boolean
	 * @status iOS, Test, iOSTested, AndroidTested
	 */
	getHasTouch:           function() { return this._fields.hasTouch; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for multi-touch input support.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application supports multi-touch input.
	 * @type Boolean
	 * @status iOS, Test, iOSTested, AndroidTested
	 */
	getHasMultiTouch:      function() { return this._fields.hasMultiTouch; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a GPS unit.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a GPS unit.
	 * @type Boolean
	 * @status Android, Test, iOSTested, AndroidTested
	 */
	getHasGps:             function() { return this._fields.hasGps; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a magnetic compass.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a magnetic compass.
	 * @type Boolean
	 * @status Android, Test, iOSTested, AndroidTested
	 */
	getHasCompass:         function() { return this._fields.hasCompass; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a hardware keyboard.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a hardware keyboard.
	 * @type Boolean
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getHasHwKeyboard:      function() { return this._fields.hasHwKeyboard; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a <b>Back</b> button.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a <b>Back</b> button.
	 * @status
	 */
	getHasBackButton:      function() { return this._fields.hasBackButton; },

	/**
	 * Check the <code>Capabilities</code> of this device for a camera.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a camera.
	 * @type Boolean
	 * @status Test, iOSTested, AndroidTested
	 */
	getHasCamera:          function() { return this._fields.hasCamera; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for access to a wide area network (WAN).
	 * @returns {Boolean} Returns <code>true</code> when the device running the application has access to a WAN.
	 * @type Boolean
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getHasWwan:            function() { return this._fields.hasWwan; },

	/**
	 * Check the <code>Capabilities</code> of this device for access to a Wi-Fi network.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application has access to Wi-Fi.
	 * @type Boolean
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getHasWifi:            function() { return this._fields.hasWifi; },

	/**
	 * Check the <code>Capabilities</code> of this device for access to a Wi-Fi network.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application has access to Wi-Fi.
	 * @status
	 */
	getCarrier:            function() { return this._fields.carrier; },

	/**
	 * Return the URL used to launch this application.
	 * @returns {String} The URL for launching this application. If the application is not launched from a URL, returns an empty string.
	 * @type String
	 * @status
	 */
	getIntentUrl:            function() { return this._fields.intentUrl; },
	
	/**
	 * Return the height of the system status bar.
	 * @returns {Number} The status bar height rounded to the nearest integer (in pixels).
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 * @status Android
	*/
     getStatusBarHeight:            function() { return this._fields.statusBarHeight; },
	
	/**
	 * Return the device locale.
	 * @returns {String} The regional location of a device.
	 * The <code>locale</code> string is a combination of ISO 639-1 and ISO 3166-1. For example, <code>en_US</code>, <code>ja_JP</code>.
	 * @type String
	 * @status
	 */
	getLocale: function() { return this._fields.locale; },

	/**
	 * Return a list of installed fonts on this device.
	 * @returns {Array (Strings)} An array of font names installed on the system or addressable by name.
	 * @type Array
	 * @status iOS, Android
	 */
	getAvailableFonts: function()
	{
		return this._deserializedFonts || (this._deserializedFonts = JSON.parse(this._fields.availableFonts));
	},
	
	/** @private */
	getAutorotateDisabled: function()
	{
		return this._fields.autorotateDisabled || false;
	},
	

	/**
	 * Return the social server used for this application.
	 * @returns {String} The social server URL. For example, partner.plusplus.com.
	 * @status
	 */	
	getSocialServer: function()
	{
		return this.socialServer;
	},

	/*
	 * Returns the name of the Mobage distribution first installed on the device.
	 * @returns {String} The name of the distribution.
	 */
	getDistributionName: function() 
	{
		return this._fields.distributionName;
	},

	/*
	 * @status
	 */	
	getSourceAppID: function()
	{
		return this._fields.sourceAppID;
	},

	/*
	 * @status Android
	 */	
	getAppSignatures: function()
	{
		return this._fields.appSignatures;
	},
	
	/*
	 * Return the release version of this application.  The value comes directly from the 
	 * configuration.json value for releaseVersion.
	 * @returns {String} The version identifier. For example, 1.1:20110607183748_blf7gety.
	 * @status
	 */
	getAppReleaseVersion: function()
	{
		return this._releaseVersion;
	},
	
	
	/** @private */
	_init: function(dict)
	{
		// parse the dict
		var ifields = [];
		NgParseCommandDictionary(dict, 2, this._fields, ifields);

		try {
			// Change server based on URL passed in
			var items = /(https?:\/\/.+?)\/(.*)/.exec(this._fields.url);
			this._fields.server = items[1];
			this._fields.game  = items[2];
		}
		catch (e)
		{
			NgLogException(e);
		}

		// KJ this is necessary because an empty string passed becomes undefined
		if (!this._fields.intentUrl)
			this._fields.intentUrl = "";

		if (this._fields.oglExtensions)
		try
		{
			this._fields.oglExtensions = JSON.parse(this._fields.oglExtensions);
		}
		catch (e)
		{
			NgLogE("Unable to parse OGL Extensions! " + this._fields.oglExtensions);
			NgLogException(e);
		}

		if (this._fields._accts)
		try
		{
			this._fields._accts = JSON.parse(this._fields._accts);
		}
		catch (e)
		{
			NgLogE("Unable to parse Accounts! " + this._fields._accts);
			NgLogException(e);
		}

		try
		{
			this._configuration = JSON.parse(this._fields.configJSON);
			this._fields.contentUrl = this._configuration.contentUrl;
			this.socialServer = this._configuration.socialServer;
			this._releaseVersion = this._configuration.releaseVersion;
		}
		catch (e)
		{
			NgLogE("Unable to parse config!! (" + this._fields.configJSON + ")");
			NgLogException(e);
		}

		console.log( "dict : JS version : " + this.getSDKVersion() );
		console.log( "dict : JS build date : " + this.getSDKBuildDate() );
		console.log( "dict : JS build hash : " + this.getSDKBuildHash() );

		console.log("dict : contentUrl : " + this._fields.contentUrl);
		console.log("dict : socialServer : " + this.socialServer);
		console.log("dict : releaseVersion : " + this._releaseVersion);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 301
	// Method create = -1
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Capabilities._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Capabilities._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[301] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( ":301,-1," + __objectRegistryId  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	

// {{/Wg Generated Code}}
	// This kills the JSLint error for trailing comma (since we can't change the generated code)
	t: 0
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Localization'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Localization'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Localization'] = exports; var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var FileSystem = require('NGCore/Client/Storage/FileSystem').FileSystem;

var LocalizationEngine = exports.LocalizationEngine = MessageEmitter.subclass(
/** @lends Core.Localization.prototype */
{
	classname: 'Localization',
    
    /**
     * Specifies the directory path to language files this object will load.
     */
    directoryPath:null,
    
    /**
     * Specifies the directory path to a language file for a specific language.
     */
	languageFilePath:null,
    
	/**
	 * @class The <code>Localization</code> class provides applications with access to localized strings.
	 * Applications supply a language code corresponding to a file in <code>Content/Localization/</code> or a JSON object.<br><br> 
     * Loading of dictionary files is an anynchronous process. Applications need to listen for emitted notifications from <code>Localization</code> objects that signal when the language dictionary
     * is modified. When a <code>Localization</code> object emits a notification, localized strings are available to the application (see <code>{@link Core.MessageEmitter#emit}</code>).
	 * @constructs The default constructor.
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Flash
	 */
	initialize: function(directoryPath)
	{
		if(!directoryPath){directoryPath = "./Content/Localization/";}
	    NgLogD("Localization : init ("+directoryPath+")");
	    this.directoryPath = directoryPath;
	    
        this.setLanguage(Capabilities.getLanguage());
	},
    
	/**
	 * Aynchronously load the localization dictionary for the specified language.
     * <br><br>
	 * <b>Notes:</b> 
	 * <ul>
	 * <li>This function looks for the corresponding JSON dictionary file in the <code>Content/Localization</code> directory.
     * For example, <code>Content/Localization/fr.json</code>. If the application cannot load a dictionary, this call has no effect.</li>
     * <li><code>Localization</code> objects emit a notification with the new language string if this call succeeds.</li>
     *</ul>
	 *
	 * @example
	 * Core.Localization.addListener(listener, function()
     * {
     *     listener.label.setText(Core.Localization.getString("Hello World"));
     * });
	 * Core.Localization.setLanguage('es');
	 *
	 * @param {String} language The base name of a JSON dictionary file in <code>./Content/Language</code>.
	 * @see Core.Localization#setDictionary, 
	 * @see Core.MessageListener
	 * @status
	 */    
    setLanguage: function(language)
    {
        var dictionaryPath = this.languageFilePath = this.directoryPath + language + '.json';
        var self = this;
        NgLogD("Localization : reading json file "+ dictionaryPath);
        
		FileSystem.readFile(dictionaryPath, function(error, data)
        {
            if(error === '')
            {
                NgLogD("Localization : successfully read json file "+ dictionaryPath);  
                self.setDictionary(language, JSON.parse(data));
            }
            else
            {
                NgLogD("Localization: unable to read json file "+ dictionaryPath + ", use default english setting instead");                
            }
        });
    },

	/**
	 * Directly set the language code and localization dictionary.
     * <code>Localization</code> objects emit a message with the new language string during this call.
	 * 
	 * @example
     * var chDictionary =    
     * {
     *     "Hello World": "你好世界"
     * };
	 * Core.Localization.setDictionary('ch', chDictionary);
	 * label.setText(Core.Localization.getString("Hello World"));
	 *
	 * @param {String} language A string identifying the specified language or localization.
	 * @param {Object} dictionary An object containing key/value pairs for the specified language.
	 * @see Core.Localization#setLanguage,
	 * @see Core.MessageEmitter#emit
	 * @status
	 */    
    setDictionary: function(lang, dictionary)
    {
        this._lang = lang;
        this._dictionary = dictionary;
        this.emit(this._lang);
    },    
    
    /**
	 * Retrieve a localized string.
     * @param {String} str A localization key.
	 * @returns {String} The localized string or the provided key if the application is unable to lcoate the specified string.
	 * @status
	 */
	getString: function(str)
	{        
        if(this._dictionary && typeof this._dictionary === 'object')
        {
            var value = this._dictionary[str];
            if(value && typeof value !== 'undefined')
            {
                return value;
            }
        }
        
        return this.unknownString(str);
	},
	
	/** @protected */
	unknownString:function(str){
		NgLogD("Localization: ... No localization for "+str+" in "+this._lang);
		return str;
	}
});

/**
 * Global Localization Singleton, gets initialized when the device locale is known.
 */
exports.Localization = LocalizationEngine.singleton({});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Storage'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Storage'] || {}; $MODULE_REGISTRY['NGCore/Client/Storage'] = exports; /**
 * <p>Classes and objects contained by the Storage module.</p>
 * @name Storage
 * @namespace
 * @description <p>The Storage module is a collection of classes that support file manipulation operations.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 * <ul>
 *  <li><code>{@link Storage.FileSystem}</code>: Construct objects for reading a file, writing to a file, deleting a file, or decompressing a file.</li>
 *  <li><code>{@link Storage.KeyValue}</code>: Construct objects that store key/value pairs.</li>
 * </ul>
 * <b>Note:</b> The static method <code>KeyValueCache.global()</code> creates a <code>KeyValueCache</code> object that multiple applications can use. 
 * @param {String} globalKey The module name for the <code>KeyValueCache</code> object. The <code>global()</code> method creates a new <code>KeyValueCache</code> 
 * when the module with that name doesn't already exist.
 */
var Storage = exports.Storage = {};

Storage.__defineGetter__("KeyValue", function() {
	delete this.KeyValue;
	return this.KeyValue = require('NGCore/Client/Storage/KeyValue').KeyValue;
});
Storage.__defineGetter__("KeyValueCache", function() {
	delete this.KeyValueCache;
	return this.KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
});
Storage.__defineGetter__("FileSystem", function() {
	delete this.FileSystem;
	return this.FileSystem = require('NGCore/Client/Storage/FileSystem').FileSystem;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Logger'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Logger'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Logger'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var sprintf = require('NGCore/Shared/Lib/sprintf').sprintf;
var Base64 = require('NGCore/Client/Core/Base64').Base64;

var Logger = Class.singleton(
/** @lends Core.Logger.prototype */
{
	classname: 'Logger',

	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	/** @private */
	_disable: function()
	{
		console.log("Logger : javascript logging disabled");
		console.log = Logger.log = function(message, argv) {};
	},

	_enable: function()
	{
		console.log = Logger.log = function(message, argv)
		{
			if (arguments.length > 1) {
				try {
					var params = new Array();
					for (var i = 0; i < arguments.length; ++i) {
						params[i] = arguments[i];
					}
					var result = sprintf(params);
					params.unshift(result);
					message = params.join(" ");
				} catch (err) {
					var concat = new Array();
					for (var i = 0; i < arguments.length; ++i) {
						concat[i] = arguments[i];
					}
					message = concat.join(" ");
				}
			}
			__underscore_SysLog(message);
		};

		console.log("Logger : javascript logging enabled");
	},

	/**
	 * Log a message to the development console.
	 * @param {string} message
	 * @param {Array} argv Additional arguments to log.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	log: function(message, argv)
	{
		
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 305
	// Method create = -1
	// Method log = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Logger._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Logger._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[305] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( ":305,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_logSendGen: function( msg )
	{
		Proc.appendToCommandString( ":305,2," + this.__objectRegistryId + "," + Base64.encode( msg )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// log: function( msg ) {}
	

// {{/Wg Generated Code}}
	
});

Logger.instantiate();

__underscore_SysLog = function(_massage)
{
	Logger._logSendGen( _massage );
};

// JMarr Don't override console.log when on flash.
if(typeof(_NG_TARGET_FLASH) == 'undefined')
	console.log = Logger.log;

exports.Logger = Logger;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Class'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Class'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Class'] = exports; exports.Class = require('NGCore/Shared/Class').Class;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Base64'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Base64'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Base64'] = exports; exports.Base64 = require('NGCore/Shared/Lib/base64').Base64;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Plus/ResultSet'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Plus/ResultSet'] || {}; $MODULE_REGISTRY['NGCore/Client/Plus/ResultSet'] = exports; var ClassReq = require('NGCore/Client/Core/Class');
var SystemBindingReq = require('NGCore/Client/UI/SystemBinding');

var ResultSet = ClassReq.Class.subclass({
    classname: "ResultSet",
    initialize: function(continueId) {
        this.items = [];
        this._continueId = continueId;
        this.totalLength = Number.MAX_VALUE;
    },
    /*
	 * Call to getMore adds more items to items list.
	 * Please note that in the callback, it is possible that addedCount == 0
	 * in some cases.  In that case access to items[newIdx] does not yield
	 * any result
	 */
    getMore: function(cb) {
        return SystemBindingReq.SystemBinding._getMoreContacts(this, cb);
    },
    /*
	 * Releases resource used by current ResultSet.
	 *
	 * To avoid resource leakage, please call closeResultSet if getMore
	 * is not called all the way to the end.
	 */
    closeResultSet: function() {
        SystemBindingReq.SystemBinding._closeContactsResultSet(this);
    }
});

exports.ResultSet = ResultSet;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Class'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Class'] || {}; $MODULE_REGISTRY['NGCore/Shared/Class'] = exports; /**
 * The default constructor.
 * @constructor 
 * @class The <code>Class</code> object provides an environment for Object Oriented Programming (OOP) development in Javascript, such as Java or C++.
 * @name Core.Class
 */
var Class = function() {}
exports.Class = Class;

/**
 * Create a new class by extending another class.
 * @example
 * var MyClass = Class.subclass(
 * {
 *    initialize: function()
 *    {
 *        console.log('constructor');
 *    },
 *    foo: function(v)
 *    {
 *        console.log('MyClass.foo(' + v + ')');
 *    },
 * });
 * var myClass = new MyClass();
 * myClass.foo('param');
 * @param {Object} extensions Object literal containing new functions for the derived class.
 * @function
 * @name Core.Class.subclass
 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
 */
Class.subclass = (function()
{
/**#@+ @ignore */
	// Parse a function body and extract the parameter names.
	function argumentNames(body)
	{
		var names = body.toString().match(/^[\s\(]*function[^(]*\(([^)]*)\)/)[1]
			.replace(/\/\/.*?[\r\n]|\/\*(?:.|[\r\n])*?\*\//g, '')
			.replace(/\s+/g, '').split(',');
		return names.length == 1 && !names[0] ? [] : names;
	}
	
	// Create a function that calls overrideBody with a closure to ancestorBody.
	function overrideMethod(overrideBody, ancestorBody)
	{
		if(ancestorBody !== undefined)
		{
			// Create a function that calls overrideBody with a closure to ancestorBody as the first param.
			var override = function()
			{
				var localThis = this;
				var $super = function() { return ancestorBody.apply(localThis, arguments) };
				Array.prototype.unshift.call(arguments, $super);
				return overrideBody.apply(this, arguments);
			}
		}
		else
		{
			// Create a function that calls overrideBody with undefined as the first param, because ancestorBody is undefined.
			var override = function()
			{
				Array.prototype.unshift.call(arguments, undefined);
				return overrideBody.apply(this, arguments);
			}
		}

		// Hide our dirty tricks from the rest of the world.
		override.valueOf = function() { return overrideBody.valueOf() };
		override.toString = function() { return overrideBody.toString() };
		return override;
	}
	
	// Define some empty functions used later. This is a speed optimization.
	function TempClass() {}
	function emptyFunction() {}
	
	return function()
	{
		// Constructor for new class to be created.
		var properties = arguments[0];
		var classname = properties.classname || "AnonymousClass";
		var NewClass = eval('(function ' + classname + '(){this.initialize.apply(this, arguments)})');
		
		// Copy statics from this.
		for(var property in this)
		{
			if(!this.hasOwnProperty(property)) continue;
			NewClass[property] = this[property];
		}
		
		// Copy prototype from this.
		var ancestorPrototype = this.prototype;
		TempClass.prototype = ancestorPrototype;
		NewClass.prototype = new TempClass();
		NewClass.prototype.superclass = ancestorPrototype;
		NewClass.prototype.constructor = NewClass;
		
		// Copy properties into NewClass prototype.
		for(var property in properties)
		{
			if(!properties.hasOwnProperty(property)) continue;

			// getters / setters behave differently than normal properties.
			var getter = properties.__lookupGetter__(property)
			var setter = properties.__lookupSetter__(property)
			if(getter || setter)
			{
				if(getter)
				{
					// Copy getter into klass.
					var value = getter;
					if(argumentNames(value)[0] == "$super")
						value = overrideMethod(value, ancestorPrototype.__lookupGetter__(property));
					NewClass.prototype.__defineGetter__(property, value);
				}

				if(setter)
				{
					// Copy setter into klass.
					var value = setter;
					if(argumentNames(value)[0] == "$super")
						value = overrideMethod(value, ancestorPrototype.__lookupSetter__(property));
					NewClass.prototype.__defineSetter__(property, value);
				}
			}
			else
			{
				var value = properties[property];
				if(typeof value === "function" && property[0] != '$')
				{
					if(argumentNames(value)[0] == "$super")
					{
						// Create override method if first param is $super.
						value = overrideMethod(value, ancestorPrototype[property]);
					}
					else if(property == 'initialize')
					{
						var ancestorInitialize = ancestorPrototype.initialize
						if(ancestorInitialize)
						{
							// Automatically call inherited constructor.
							var derivedInitialize = value;
							value = function()
							{
								ancestorInitialize.apply(this, arguments);
								derivedInitialize.apply(this, arguments);
							};
						}
					}
					else if(property == 'destroy')
					{
						var ancestorDestroy = ancestorPrototype.destroy
						if(ancestorDestroy)
						{
							// Automatically call inherited destructor.
							var derivedDestroy = value;
							value = function()
							{
								derivedDestroy.apply(this, arguments);
								ancestorDestroy.apply(this, arguments);
							};
						}
					}

					// Copy function into new class prototype.
					NewClass.prototype[property] = value;
				}
				else
				{
					if(property[0] == '$')
						property = property.slice(1);

					// Copy enum into new class and the prototype.
					NewClass[property] = value;
					NewClass.prototype[property] = value;
				}
			}
		}
		
		// Make sure the is an initialize function.
		if(!NewClass.prototype.initialize)
			NewClass.prototype.initialize = emptyFunction;

		return NewClass;
	}
/**#@-*/
})();

/**
 * Create a singleton by extending a class.
 * @example
 * var MySingleton = Class.singleton(
 * {
 *    initialize: function()
 *    {
 *        console.log('constructor');
 *    },
 *    foo: function(v)
 *    {
 *        console.log('MyClass.foo(' + v + ')');
 *    },
 * });
 * MySingleton.foo('param');
 * @param {Object} extensions Object literal containing new functions for the singleton.
 * @function
 * @name Core.Class.singleton
 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
 */
Class.singleton = function()
{
	// Create sublcass as normal.
	var tempClass = this.subclass.apply(this, arguments);
	
	// Hide the initialize.
	var initialize = tempClass.prototype.initialize;
	tempClass.prototype.initialize = function() {};
	
	// Now instantiate.
	var instance = new tempClass();
	
	// Hide every prototype function with an instance function that calls initialize.
	var functions = [];
	/** 
	 * Ensure that the singleton has been created and fully initialized.
	 * @status iOS, Android, Flash
	*/
	var instantiate = function(real)
	{
		// Delete all of the instance functions we added.
		for(var i in functions)
		{
			var func = functions[i];
			delete instance[func];
		}
		
		// Restore the initialize function and call it.
		instance.initialize = initialize;
		instance.initialize();
		
		// Replace instantiate method with an empty function.
		instance.instantiate = function() {};
		
		// Call the function that caused this instantiation.
		var args = Array.prototype.slice.call(arguments, 1);
		return real.apply(instance, args);
	}
	
	// Iterate over all prototype functions.
	for(var i in instance)
	{
		// Don't do anything for setters or getters.
		if(instance.__lookupGetter__(i)
			|| instance.__lookupSetter__(i))
		{
			//TODO Should put proxies here too.
			continue;
		}
			
		var value = instance[i];
		if(typeof(value) == 'function')
		{
			// Remember the function names that we added so that instantiate() can remove them.
			functions.push(i);
			
			// Add an instance function to hide the prototype function, which will call instantiate.
			instance[i] = instantiate.bind(this, value);
		}
	}
	
	// Add instantiate method.
	instance.instantiate = instantiate.bind(this, function() {});
	
	// Return the isntance.
	return instance;
}

/**
 * @ignore
 */
Class.prototype.bind = function(func)
{
	var context = this;
	if(arguments.length < 2)
	{
		// Fast path if only the 'this' pointer is being bound.
		return function()
		{
			return func.apply(context, arguments);
		}
	}
	else
	{
		// Slower path if additional parameters are being bound.
		var args = Array.prototype.slice.call(arguments, 1);
		return function()
		{
			var finalArgs = args.concat(Array.prototype.slice.call(arguments, 0));
			return func.apply(context, finalArgs);
		}
	}
}

/**
 * @ignore
 */
Class.prototype.toString = function()
{
	return this.constructor.name;
}

// Debug implementation that will replace every method in destroyed objects with a grenade.
/*Class.prototype.destroy = function()
{
	function suicide()
	{
		throw new Error('Function called on destroyed object');
	}
	
	for(var i in this)
	{
		var value = this[i];
		if(typeof(value) == 'function')
		{
			this[i] = suicide;
		}
	}
}*/
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/base64'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/base64'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/base64'] = exports; /**
* @description
* Takes a string and encodes or decodes base-64.
* @class Base64
* @see http://coderepos.org/share/browser/lang/javascript/Base64/trunk/base64.js
*
**/

/*
 * $Id: base64.js,v 1.1 2009/03/01 22:38:45 dankogai Exp dankogai $
 *
 * History:
 *   dankogai's original: character-based
 *   drry's fix: split string to array then join
 *   new version: regexp-based
 */

var Base64 = (function() {
    var b64chars
        = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
    var b64tab = function(bin){
        var t = {};
        for (var i = 0, l = bin.length; i < l; i++) {
            t[bin.charAt(i)] = i;
        }
        return t;
    }(b64chars);

    var fromCharCode = String.fromCharCode;

    var sub_toBase64 = function(m){
        var n = (m.charCodeAt(0) << 16)
              | (m.charCodeAt(1) <<  8)
              | (m.charCodeAt(2)      );
        return b64chars.charAt( n >>> 18)
             + b64chars.charAt((n >>> 12) & 63)
             + b64chars.charAt((n >>>  6) & 63)
             + b64chars.charAt( n         & 63);
    };

    var toBase64 = function(bin){
        if (bin.match(/[^\x00-\xFF]/)) {
            throw 'unsupported character found';
        }
        var padlen = 0;
        while(bin.length % 3) {
            bin += '\x00';
            padlen++;
        }
        var b64 = bin.replace(/[\x00-\xFF]{3}/g, sub_toBase64);
        if (!padlen) return b64;
        b64 = b64.substr(0, b64.length - padlen);
        while(padlen--) b64 += '=';
        return b64;
    };

    // use native btoa() if it exists
    var _btoa = typeof(btoa) !== "undefined" ? btoa : toBase64;

    var sub_fromBase64 = function(m){
            var n = (b64tab[ m.charAt(0) ] << 18)
                |   (b64tab[ m.charAt(1) ] << 12)
                |   (b64tab[ m.charAt(2) ] <<  6)
                |   (b64tab[ m.charAt(3) ]);
        return fromCharCode(  n >> 16 )
            +  fromCharCode( (n >>  8) & 0xff )
            +  fromCharCode(  n        & 0xff );
    };

    var fromBase64 = function(b64){
        b64 = b64.replace(/[^A-Za-z0-9\+\/]/g, '');
        var padlen = 0;
        while(b64.length % 4){
            b64 += 'A';
            padlen++;
        }
        var bin = b64.replace(/[A-Za-z0-9\+\/]{4}/g, sub_fromBase64);
        bin.length -= [0,0,2,1][padlen];
        return bin;
    };

    // use native atob() if it exists
    var _atob = typeof(atob) !== "undefined" ? atob : fromBase64;

    var re_char_nonascii = /[^\x00-\xFF]/g;

    var sub_char_nonascii = function(m){
        var n = m.charCodeAt(0);
        return n < 0x800 ? fromCharCode(0xc0 | (n >>>  6))
                         + fromCharCode(0x80 | (n & 0x3f))
            :              fromCharCode(0xe0 | ((n >>> 12) & 0x0f))
                         + fromCharCode(0x80 | ((n >>>  6) & 0x3f))
                         + fromCharCode(0x80 |  (n         & 0x3f))
            ;
    };

    var utob = function(uni){
        return uni.replace(re_char_nonascii, sub_char_nonascii);
    };

    var re_bytes_nonascii
        = /[\xC0-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF]{2}|[\xF0-\xF7][\x80-\xBF]{3}/g;

    var sub_bytes_nonascii = function(m){
        var c0 = m.charCodeAt(0);
        var c1 = m.charCodeAt(1);
        if(c0 < 0xe0){
            return fromCharCode(((c0 & 0x1f) << 6) | (c1 & 0x3f));
        }else{
            var c2 = m.charCodeAt(2);
            return fromCharCode(
                ((c0 & 0x0f) << 12) | ((c1 & 0x3f) <<  6) | (c2 & 0x3f)
            );
        }
    };

    var btou = function(bin){
        return bin.replace(re_bytes_nonascii, sub_bytes_nonascii);
    };
    return {
        fromBase64:fromBase64,
        toBase64:toBase64,
        atob:_atob,
        btoa:_btoa,
        utob:utob,
        btou:btou,
        /**
        * @description
        * Takes an input value and returns a base-64 encoded string.
        * @name Base64.encode
        * @function
        * @param String input The input to return as a base-64 encoded string.
        * @return String A base-64 encoded string of the input parameter.
        */
        encode:function(u){
            if(!u) {
                return "";
            }
            return _btoa(utob(new String(u)));
        },
        decode:function(a){
            if(!a) {
                return "";
            }
            return btou(_atob(a.replace(/[\-_]/g, function(m0){
                return m0 == '-' ? '+' : '/';
            })));
        }
    };
})();

exports.Base64 = Base64;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Commands'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Commands'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Commands'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Commands
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

function UIAnimationOptions() {
	this.animationCurve = "EaseInOut";
	return this;
}

var Commands = exports.Commands = Core.Class.singleton(
/** @lends UI.Commands.prototype */
{
	/**
	 * @name UI.Commands
	 * @class 
	 * @augments Core.Class
	 */
	/** 
	 * @field
	 */
	classname: 'Commands',
	
	/**
	 * @constructs
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this.initializeNative(this.__objectRegistryId);
		this._tempCBs = {};
		this._tempCBCount = 0;
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
			* Enumeration for image fit modes.
			* Image Fit is always applied relative to view bounds *after* content insets are applied.
			* @namespace
			 */
	FitMode:
	{ 
		/** The image content is not scaled at all. */
		None: 0,
		/** The image will be aspect-scaled to fit completely within the view. */
		Inside: 1,
		/** The image will be aspect-scaled to cover the entire view bounds. Clipping may occur. */
		Fill: 2,
		/** The image will be distorted to cover the exact view bounds. */
		Stretch: 3,
		/** The image will be aspect-scaled so its width matches the view bounds. Clipping may occur. */
		AspectWidth: 5,
		/** The image will be aspect-scaled so its height matches the view bounds. Clipping may occur. */
		AspectHeight: 6,
		/** The image will be scaled down to fit completely within the view, but not upscaled. */
		InsideNoUpscaling: 7,
	},
	
	/** 
			* Enumeration for supported units for dimensions.
			* Math.round() is your friend. Sending decimal pixel coordinates can result in unpredictable behavior on various platforms, but half- and quarter-pixels can be useful tools on iOS.
			* @namespace
			 */
	Scaling:
	{ 
		/** The native format, and the default for view bounds. No conversion will be performed. */
		Pixels: 0,
		/** Adjusted to roughly one typesetting point, downscaled from 72 to 160 dpi. */
		Points: 1,
		/** 1.0 represents 100% of the provided or implied size (usually a view width or height). */
		Unit: 2,
		/** A percentage of the provided or implied size (typically from 0 to 100). */
		Percent: 3,
		/** At this scale, the device's screen is always 320 units wide. */
		iPhone: 4,
	},
	
	/** 
			* Enumeration for text font styles.
			* @namespace
			 */
	FontStyle:
	{ 
		/** * */
		Normal: 0,
		/** * */
		Bold: 1,
		/** * */
		Italic: 2,
		/** * */
		BoldItalic: 3,
	},
	
	/** 
			* Flags for control / view states. Used in View and its subclasses.
			* When setting content and properties for states, the value with the highest id when AND'ed with the current state, but no additional bits, will be used.
			* @namespace
			 */
	State:
	{ 
		/** The view is in an unexceptional state. */
		Normal: 0x00,
		/** * */
		Focused: 0x01,
		/** * */
		Selected: 0x02,
		/** * */
		Pressed: 0x04,
		/** * */
		Checked: 0x08,
		/** * */
		Custom: 0x00FF0000,
		/** * */
		Disabled: 0x40000000,
	},
	
	/** 
			* Enumeration for Enter Key Behavior in editable text fields.
			* @namespace
			 */
	EnterKeyType:
	{ 
		/** * */
		Return: 0,
		/** * */
		Done: 1,
		/** * */
		Next: 2,
		/** * */
		Submit: 3,
		/** * */
		Go: 4,
		/** * */
		Search: 5,
		/** * */
		Send: 6,
	},
	
	/** 
			* Enumeration for Input Types for editable text fields.
			* @namespace
			 */
	InputType:
	{ 
		/** * */
		None: 0,
		/** * */
		TextWithCorrection: 1,
		/** * */
		Password: 2,
		/** * */
		Numeric: 4,
		/** * */
		Email: 5,
		/** * */
		URL: 6,
		/** * */
		Date: 7,
		/** * */
		ANDROID_LANDSCAPE_FULLSCREEN: 8,
	},
	
	/** 
			* Arrangement of combinations of text and images for buttons. When stacked, the button rect will be divided proportionally into two rects that completely cover the button. Gravity will apply to the image and text within their rects.
			* @namespace
			 */
	ButtonLayout:
	{ 
		/** The view is in an unexceptional state. */
		CenterTextOver: 0,
		/** * */
		StackImageLeft: 1,
		/** * */
		StackImageTop: 2,
		/** * */
		StackImageRight: 3,
		/** * */
		StackImageBottom: 4,
		/** * */
		CenterImageOver: 5,
	},
	
	/** 
			* Describes what direction a user swiped during a swipe callback.
			* @see UI.AbstractView#setOnSwipe
			* @namespace
			 */
	SwipeDirection:
	{ 
		/** * */
		Left: 1,
		/** * */
		Right: 2,
		/** * */
		Up: 3,
		/** * */
		Down: 4,
	},
	
	///////
	// Class Summary and Generated Constants (for internal use only):
	// Class ID = 337
	// Method -1: _initializeNative ( int reservedId )
	// Method -2: _create ( int newObjectId, str className )
	// Method 3: _destroy (  )
	// Method 4: _setActive ( bool active )
	// Method 5: _setTouchable ( bool touchable )
	// Method 6: _enableEvent ( str eventName )
	// Method 7: _disableEvent ( str eventName )
	// Method -8: _eventOccurred ( json eventObject )
	// Method 9: _setIsVisible ( bool visible )
	// Method 10: _setEnabled ( bool enable )
	// Method 11: _setState ( int state )
	// Method 12: _addSubview ( int __objectRegistryId, int index )
	// Method 13: _removeFromSuperview (  )
	// Method -14: _startAnimation ( int durationMs, str callbackId )
	// Method -15: _executeAnimation ( json options )
	// Method 16: _setFrame ( float x, float y, float w, float h )
	// Method 17: _setOrigin ( float x, float y )
	// Method 18: _setAnchor ( float x, float y )
	// Method 19: _setSize ( float w, float h )
	// Method 20: _setTransform ( float a, float b, float c, float d, float tx, float ty )
	// Method 21: _setBackgroundColor ( str color )
	// Method 22: _setImage ( int state, str imageURL )
	// Method 23: _setImageBorder ( int state, json gradientJSON )
	// Method 24: _setImageFitMode ( int fitMode )
	// Method 25: _setImageGravity ( float x, float y )
	// Method 26: _setImageOrigin ( float x, float y )
	// Method 27: _setImageAnchor ( float x, float y )
	// Method 28: _setImageSize ( float w, float h )
	// Method 29: _setImageInsets ( float t, float r, float b, float l )
	// Method 30: _setImageTransform ( float a, float b, float c, float d, float tx, float ty )
	// Method 31: _setText ( int state, str text )
	// Method 32: _setTextColor ( int state, str text )
	// Method 33: _setTextFont ( int state, str fontName )
	// Method 34: _setTextShadow ( int state, str shadow )
	// Method 35: _setTextSize ( float textFontSize )
	// Method 36: _setTextGravity ( float x, float y )
	// Method 37: _setTextInsets ( float t, float r, float b, float l )
	// Method 38: _setTextOverflow ( int overflowMode )
	// Method 39: _setTextMaxLines ( int maxLines )
	// Method 40: _setTextMinSize ( float minSize )
	// Method 41: _setTitle ( int state, str title )
	// Method 42: _setTitleColor ( int state, str title )
	// Method 43: _setTitleFont ( int state, str fontName )
	// Method 44: _setTitleShadow ( int state, str shadow )
	// Method 45: _setTitleSize ( float titleFontSize )
	// Method 46: _setTitleGravity ( float x, float y )
	// Method 47: _setTitleInsets ( float t, float r, float b, float l )
	// Method 48: _setTitleOverflow ( int overflowMode )
	// Method 49: _setTitleMaxLines ( int maxLines )
	// Method 50: _setTitleMinSize ( float minSize )
	// Method 51: _setGradient ( int state, json gradientJSON )
	// Method 52: _setStringValue ( str value )
	// Method 53: _setFloatValue ( float value )
	// Method 54: _setIntValue ( int value )
	// Method 55: _setBoolValue ( bool value )
	// Method 56: _setButtonLayout ( int layoutType )
	// Method 57: _setContentInsets ( float t, float r, float b, float l )
	// Method 58: _setBarGradient ( int state, json gradientJSON )
	// Method 59: _setPlaceholderText ( str placeholder )
	// Method 60: _setPlaceholderTextColor ( str color )
	// Method 61: _setPlaceholderTextShadow ( str shadow )
	// Method 62: _setEnterKeyType ( int enterKeyType )
	// Method 63: _setInputType ( int inputType )
	// Method 64: _setChecked ( bool checked )
	// Method 65: _setScrollPosition ( float x, float y )
	// Method 66: _setScrollableSize ( float w, float h )
	// Method 67: _setSections ( json idArray )
	// Method 68: _setTitleView ( int titleObjectID )
	// Method 69: _setSourceDocument ( str documentURL )
	// Method 70: _setChoices ( json stringArray, int defaultChoiceIndex, int cancelChoiceIndex )
	// Method 71: _show (  )
	// Method 72: _hide (  )
	// Method 73: _setPostData ( str data )
	// Method 74: _loadPostURL ( str url )
	// Method 75: _loadGetURL ( str url )
	// Method 76: _loadURL ( str url, json headers, float timeout )
	// Method 77: _stopLoading (  )
	// Method 78: _reload (  )
	// Method 79: _invoke ( str script )
	// Method 80: _goBack (  )
	// Method 81: _goForward (  )
	// Method 82: _setBasicAuthCredentials ( json credentials )
	// Method 83: _setRightImage ( int state, str rightImageURL )
	// Method 84: _setRightImageBorder ( int state, json gradientJSON )
	// Method 85: _setRightImageFitMode ( int fitMode )
	// Method 86: _setRightImageGravity ( float x, float y )
	// Method 87: _setRightImageOrigin ( float x, float y )
	// Method 88: _setRightImageAnchor ( float x, float y )
	// Method 89: _setRightImageSize ( float w, float h )
	// Method 90: _setRightImageInsets ( float t, float r, float b, float l )
	// Method 91: _setRightImageTransform ( float a, float b, float c, float d, float tx, float ty )
	// Method -92: _setStatusBarHidden ( bool statusBarStatus )
	// Method 93: _pauseAds (  )
	// Method 94: _resumeAds (  )
	// Method 95: _setAdRefreshRate ( int refreshRate )
	// Method 96: _setAdAllowAutoplay ( bool autoplay )
	// Method 97: _setAlpha ( float alpha )
	// Method 98: _postURL ( str url, str data )
	// Method 99: _setProgressGradient ( int state, json gradientJSON )
	// Method 100: _setSecondaryGradient ( int state, json gradientJSON )
	// Method 101: _setProgress ( float progress, float secondaryProgress )
	// Method 102: _useForUpdateProgress ( bool use )
	// Method 103: _setDarkStyle ( bool use )
	// Method -104: _doCompositeImages ( int w, int h, str filename, json infoArray, str callbackId )
	// Method -105: _REMOVED_doChoosePhoto ( int w, int h, str filename, json options, str callbackId )
	// Method -106: _doChooseCamera ( int w, int h, str filename, json options, str callbackId )
	// Method 107: _setScrollable ( bool enabled )
	// Method 108: _setZoomable ( bool enabled )
	// Method 109: _addAnnotation ( int __objectRegistryId )
	// Method 110: _removeAnnotation ( int __objectRegistryId )
	// Method 111: _selectAnnotation ( int __objectRegistryId )
	// Method 112: _setRegion ( float latitude, float longitude, float latitudeDelta, float longitudeDelta, bool animated )
	// Method 113: _setView ( int __objectRegistryId )
	// Method 114: _setCoordinate ( float latitude, float longitude )
	// Method 115: _setCalloutTitle ( str title )
	// Method 116: _setCalloutSubtitle ( str subTitle )
	// Method 117: _setCalloutEnabled ( bool enabled )
	// Method 118: _setCalloutLeftView ( int __objectRegistryId )
	// Method 119: _setCalloutRightView ( int __objectRegistryId )
	// Method 120: _setCenterOffset ( float xOffset, float yOffset )
	// Method -121: _doChoosePhoto ( int w, int h, str filename, json options, str callbackId, int invokingView )
	// Method 122: _setScrollIndicatorsVisible ( bool enabled )
	// Method -123: _measureText ( str string, int w, int h, str font, float fontSize, str callbackId )
	// Method 124: _setFocus ( bool enabled )
	// Method 125: _setViewportEnabled ( bool enabled )
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Commands._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				case -8:
					Commands._eventOccurredRecv( cmd );
					break;
				default:
					NgLogE("Unknown static method id " + cmdId + " in Commands._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[337] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	$_eventOccurredRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Commands.eventOccurred from command: " + cmd );
			return false;
		}
		
		obj[ "eventObject" ] = Core.Proc.parseJSONString( cmd[ 0 ] );
		if( obj[ "eventObject" ] === undefined )
		{
			NgLogE("Could not parse eventObject in Commands.eventOccurred from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$initializeNative: function( reservedId )
	{
		Core.Proc.appendToCommandString( ":337,-1," + reservedId  );
	},
	
	/** @private */
	$create: function( newObjectId, className )
	{
		Core.Proc.appendToCommandString( ":337,-2," + newObjectId + "," + Core.Base64.encode( className )  );
	},
	
	/** @private */
	destroy: function(  )
	{
		Core.Proc.appendToCommandString( ":337,3," + this.__objectRegistryId );
	},
	
	/** @private */
	setActive: function( active )
	{
		Core.Proc.appendToCommandString( ":337,4," + this.__objectRegistryId + "," + ( active ? 1 : 0 )  );
	},
	
	/** @private */
	setTouchable: function( touchable )
	{
		Core.Proc.appendToCommandString( ":337,5," + this.__objectRegistryId + "," + ( touchable ? 1 : 0 )  );
	},
	
	/** @private */
	enableEvent: function( eventName )
	{
		Core.Proc.appendToCommandString( ":337,6," + this.__objectRegistryId + "," + Core.Base64.encode( eventName )  );
	},
	
	/** @private */
	disableEvent: function( eventName )
	{
		Core.Proc.appendToCommandString( ":337,7," + this.__objectRegistryId + "," + Core.Base64.encode( eventName )  );
	},
	
	/** @private */
	setIsVisible: function( visible )
	{
		Core.Proc.appendToCommandString( ":337,9," + this.__objectRegistryId + "," + ( visible ? 1 : 0 )  );
	},
	
	/** @private */
	setEnabled: function( enable )
	{
		Core.Proc.appendToCommandString( ":337,10," + this.__objectRegistryId + "," + ( enable ? 1 : 0 )  );
	},
	
	/** @private */
	setState: function( state )
	{
		Core.Proc.appendToCommandString( ":337,11," + this.__objectRegistryId + "," + state  );
	},
	
	/** @private */
	addSubview: function( __objectRegistryId, index )
	{
		Core.Proc.appendToCommandString( ":337,12," + this.__objectRegistryId + "," + __objectRegistryId + "," + index  );
	},
	
	/** @private */
	removeFromSuperview: function(  )
	{
		Core.Proc.appendToCommandString( ":337,13," + this.__objectRegistryId );
	},
	
	/** @private */
	$startAnimation: function( durationMs, callbackId )
	{
		Core.Proc.appendToCommandString( ":337,-14," + durationMs + "," + Core.Base64.encode( callbackId )  );
	},
	
	/** @private */
	$executeAnimation: function( options )
	{
		Core.Proc.appendToCommandString( ":337,-15," + Core.Base64.encode( JSON.stringify( options ) )  );
	},
	
	/** @private */
	setFrame: function( x, y, w, h )
	{
		Core.Proc.appendToCommandString( ":337,16," + this.__objectRegistryId + "," + x + "," + y + "," + w + "," + h  );
	},
	
	/** @private */
	setOrigin: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,17," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setAnchor: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,18," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setSize: function( w, h )
	{
		Core.Proc.appendToCommandString( ":337,19," + this.__objectRegistryId + "," + w + "," + h  );
	},
	
	/** @private */
	setTransform: function( a, b, c, d, tx, ty )
	{
		Core.Proc.appendToCommandString( ":337,20," + this.__objectRegistryId + "," + a + "," + b + "," + c + "," + d + "," + tx + "," + ty  );
	},
	
	/** @private */
	setBackgroundColor: function( color )
	{
		Core.Proc.appendToCommandString( ":337,21," + this.__objectRegistryId + "," + Core.Base64.encode( color )  );
	},
	
	/** @private */
	setImage: function( state, imageURL )
	{
		Core.Proc.appendToCommandString( ":337,22," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( imageURL )  );
	},
	
	/** @private */
	setImageBorder: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,23," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setImageFitMode: function( fitMode )
	{
		Core.Proc.appendToCommandString( ":337,24," + this.__objectRegistryId + "," + fitMode  );
	},
	
	/** @private */
	setImageGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,25," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setImageOrigin: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,26," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setImageAnchor: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,27," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setImageSize: function( w, h )
	{
		Core.Proc.appendToCommandString( ":337,28," + this.__objectRegistryId + "," + w + "," + h  );
	},
	
	/** @private */
	setImageInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":337,29," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setImageTransform: function( a, b, c, d, tx, ty )
	{
		Core.Proc.appendToCommandString( ":337,30," + this.__objectRegistryId + "," + a + "," + b + "," + c + "," + d + "," + tx + "," + ty  );
	},
	
	/** @private */
	setText: function( state, text )
	{
		Core.Proc.appendToCommandString( ":337,31," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( text )  );
	},
	
	/** @private */
	setTextColor: function( state, text )
	{
		Core.Proc.appendToCommandString( ":337,32," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( text )  );
	},
	
	/** @private */
	setTextFont: function( state, fontName )
	{
		Core.Proc.appendToCommandString( ":337,33," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( fontName )  );
	},
	
	/** @private */
	setTextShadow: function( state, shadow )
	{
		Core.Proc.appendToCommandString( ":337,34," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( shadow )  );
	},
	
	/** @private */
	setTextSize: function( textFontSize )
	{
		Core.Proc.appendToCommandString( ":337,35," + this.__objectRegistryId + "," + textFontSize  );
	},
	
	/** @private */
	setTextGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,36," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setTextInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":337,37," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setTextOverflow: function( overflowMode )
	{
		Core.Proc.appendToCommandString( ":337,38," + this.__objectRegistryId + "," + overflowMode  );
	},
	
	/** @private */
	setTextMaxLines: function( maxLines )
	{
		Core.Proc.appendToCommandString( ":337,39," + this.__objectRegistryId + "," + maxLines  );
	},
	
	/** @private */
	setTextMinSize: function( minSize )
	{
		Core.Proc.appendToCommandString( ":337,40," + this.__objectRegistryId + "," + minSize  );
	},
	
	/** @private */
	setTitle: function( state, title )
	{
		Core.Proc.appendToCommandString( ":337,41," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( title )  );
	},
	
	/** @private */
	setTitleColor: function( state, title )
	{
		Core.Proc.appendToCommandString( ":337,42," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( title )  );
	},
	
	/** @private */
	setTitleFont: function( state, fontName )
	{
		Core.Proc.appendToCommandString( ":337,43," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( fontName )  );
	},
	
	/** @private */
	setTitleShadow: function( state, shadow )
	{
		Core.Proc.appendToCommandString( ":337,44," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( shadow )  );
	},
	
	/** @private */
	setTitleSize: function( titleFontSize )
	{
		Core.Proc.appendToCommandString( ":337,45," + this.__objectRegistryId + "," + titleFontSize  );
	},
	
	/** @private */
	setTitleGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,46," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setTitleInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":337,47," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setTitleOverflow: function( overflowMode )
	{
		Core.Proc.appendToCommandString( ":337,48," + this.__objectRegistryId + "," + overflowMode  );
	},
	
	/** @private */
	setTitleMaxLines: function( maxLines )
	{
		Core.Proc.appendToCommandString( ":337,49," + this.__objectRegistryId + "," + maxLines  );
	},
	
	/** @private */
	setTitleMinSize: function( minSize )
	{
		Core.Proc.appendToCommandString( ":337,50," + this.__objectRegistryId + "," + minSize  );
	},
	
	/** @private */
	setGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,51," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setStringValue: function( value )
	{
		Core.Proc.appendToCommandString( ":337,52," + this.__objectRegistryId + "," + Core.Base64.encode( value )  );
	},
	
	/** @private */
	setFloatValue: function( value )
	{
		Core.Proc.appendToCommandString( ":337,53," + this.__objectRegistryId + "," + value  );
	},
	
	/** @private */
	setIntValue: function( value )
	{
		Core.Proc.appendToCommandString( ":337,54," + this.__objectRegistryId + "," + value  );
	},
	
	/** @private */
	setBoolValue: function( value )
	{
		Core.Proc.appendToCommandString( ":337,55," + this.__objectRegistryId + "," + ( value ? 1 : 0 )  );
	},
	
	/** @private */
	setButtonLayout: function( layoutType )
	{
		Core.Proc.appendToCommandString( ":337,56," + this.__objectRegistryId + "," + layoutType  );
	},
	
	/** @private */
	setContentInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":337,57," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setBarGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,58," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setPlaceholderText: function( placeholder )
	{
		Core.Proc.appendToCommandString( ":337,59," + this.__objectRegistryId + "," + Core.Base64.encode( placeholder )  );
	},
	
	/** @private */
	setPlaceholderTextColor: function( color )
	{
		Core.Proc.appendToCommandString( ":337,60," + this.__objectRegistryId + "," + Core.Base64.encode( color )  );
	},
	
	/** @private */
	setPlaceholderTextShadow: function( shadow )
	{
		Core.Proc.appendToCommandString( ":337,61," + this.__objectRegistryId + "," + Core.Base64.encode( shadow )  );
	},
	
	/** @private */
	setEnterKeyType: function( enterKeyType )
	{
		Core.Proc.appendToCommandString( ":337,62," + this.__objectRegistryId + "," + enterKeyType  );
	},
	
	/** @private */
	setInputType: function( inputType )
	{
		Core.Proc.appendToCommandString( ":337,63," + this.__objectRegistryId + "," + inputType  );
	},
	
	/** @private */
	setChecked: function( checked )
	{
		Core.Proc.appendToCommandString( ":337,64," + this.__objectRegistryId + "," + ( checked ? 1 : 0 )  );
	},
	
	/** @private */
	setScrollPosition: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,65," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setScrollableSize: function( w, h )
	{
		Core.Proc.appendToCommandString( ":337,66," + this.__objectRegistryId + "," + w + "," + h  );
	},
	
	/** @private */
	setSections: function( idArray )
	{
		Core.Proc.appendToCommandString( ":337,67," + this.__objectRegistryId + "," + Core.Base64.encode( JSON.stringify( idArray ) )  );
	},
	
	/** @private */
	setTitleView: function( titleObjectID )
	{
		Core.Proc.appendToCommandString( ":337,68," + this.__objectRegistryId + "," + titleObjectID  );
	},
	
	/** @private */
	setSourceDocument: function( documentURL )
	{
		Core.Proc.appendToCommandString( ":337,69," + this.__objectRegistryId + "," + Core.Base64.encode( documentURL )  );
	},
	
	/** @private */
	setChoices: function( stringArray, defaultChoiceIndex, cancelChoiceIndex )
	{
		Core.Proc.appendToCommandString( ":337,70," + this.__objectRegistryId + "," + Core.Base64.encode( JSON.stringify( stringArray ) ) + "," + defaultChoiceIndex + "," + cancelChoiceIndex  );
	},
	
	/** @private */
	show: function(  )
	{
		Core.Proc.appendToCommandString( ":337,71," + this.__objectRegistryId );
	},
	
	/** @private */
	hide: function(  )
	{
		Core.Proc.appendToCommandString( ":337,72," + this.__objectRegistryId );
	},
	
	/** @private */
	setPostData: function( data )
	{
		Core.Proc.appendToCommandString( ":337,73," + this.__objectRegistryId + "," + Core.Base64.encode( data )  );
	},
	
	/** @private */
	loadPostURL: function( url )
	{
		Core.Proc.appendToCommandString( ":337,74," + this.__objectRegistryId + "," + Core.Base64.encode( url )  );
	},
	
	/** @private */
	loadGetURL: function( url )
	{
		Core.Proc.appendToCommandString( ":337,75," + this.__objectRegistryId + "," + Core.Base64.encode( url )  );
	},
	
	/** @private */
	loadURL: function( url, headers, timeout )
	{
		Core.Proc.appendToCommandString( ":337,76," + this.__objectRegistryId + "," + Core.Base64.encode( url ) + "," + Core.Base64.encode( JSON.stringify( headers ) ) + "," + timeout  );
	},
	
	/** @private */
	stopLoading: function(  )
	{
		Core.Proc.appendToCommandString( ":337,77," + this.__objectRegistryId );
	},
	
	/** @private */
	reload: function(  )
	{
		Core.Proc.appendToCommandString( ":337,78," + this.__objectRegistryId );
	},
	
	/** @private */
	invoke: function( script )
	{
		Core.Proc.appendToCommandString( ":337,79," + this.__objectRegistryId + "," + Core.Base64.encode( script )  );
	},
	
	/** @private */
	goBack: function(  )
	{
		Core.Proc.appendToCommandString( ":337,80," + this.__objectRegistryId );
	},
	
	/** @private */
	goForward: function(  )
	{
		Core.Proc.appendToCommandString( ":337,81," + this.__objectRegistryId );
	},
	
	/** @private */
	setBasicAuthCredentials: function( credentials )
	{
		Core.Proc.appendToCommandString( ":337,82," + this.__objectRegistryId + "," + Core.Base64.encode( JSON.stringify( credentials ) )  );
	},
	
	/** @private */
	setRightImage: function( state, rightImageURL )
	{
		Core.Proc.appendToCommandString( ":337,83," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( rightImageURL )  );
	},
	
	/** @private */
	setRightImageBorder: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,84," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setRightImageFitMode: function( fitMode )
	{
		Core.Proc.appendToCommandString( ":337,85," + this.__objectRegistryId + "," + fitMode  );
	},
	
	/** @private */
	setRightImageGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,86," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setRightImageOrigin: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,87," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setRightImageAnchor: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,88," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setRightImageSize: function( w, h )
	{
		Core.Proc.appendToCommandString( ":337,89," + this.__objectRegistryId + "," + w + "," + h  );
	},
	
	/** @private */
	setRightImageInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":337,90," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setRightImageTransform: function( a, b, c, d, tx, ty )
	{
		Core.Proc.appendToCommandString( ":337,91," + this.__objectRegistryId + "," + a + "," + b + "," + c + "," + d + "," + tx + "," + ty  );
	},
	
	/** @private */
	$setStatusBarHidden: function( statusBarStatus )
	{
		Core.Proc.appendToCommandString( ":337,-92," + ( statusBarStatus ? 1 : 0 )  );
	},
	
	/** @private */
	pauseAds: function(  )
	{
		Core.Proc.appendToCommandString( ":337,93," + this.__objectRegistryId );
	},
	
	/** @private */
	resumeAds: function(  )
	{
		Core.Proc.appendToCommandString( ":337,94," + this.__objectRegistryId );
	},
	
	/** @private */
	setAdRefreshRate: function( refreshRate )
	{
		Core.Proc.appendToCommandString( ":337,95," + this.__objectRegistryId + "," + refreshRate  );
	},
	
	/** @private */
	setAdAllowAutoplay: function( autoplay )
	{
		Core.Proc.appendToCommandString( ":337,96," + this.__objectRegistryId + "," + ( autoplay ? 1 : 0 )  );
	},
	
	/** @private */
	setAlpha: function( alpha )
	{
		Core.Proc.appendToCommandString( ":337,97," + this.__objectRegistryId + "," + alpha  );
	},
	
	/** @private */
	postURL: function( url, data )
	{
		Core.Proc.appendToCommandString( ":337,98," + this.__objectRegistryId + "," + Core.Base64.encode( url ) + "," + Core.Base64.encode( data )  );
	},
	
	/** @private */
	setProgressGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,99," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setSecondaryGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,100," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setProgress: function( progress, secondaryProgress )
	{
		Core.Proc.appendToCommandString( ":337,101," + this.__objectRegistryId + "," + progress + "," + secondaryProgress  );
	},
	
	/** @private */
	useForUpdateProgress: function( use )
	{
		Core.Proc.appendToCommandString( ":337,102," + this.__objectRegistryId + "," + ( use ? 1 : 0 )  );
	},
	
	/** @private */
	setDarkStyle: function( use )
	{
		Core.Proc.appendToCommandString( ":337,103," + this.__objectRegistryId + "," + ( use ? 1 : 0 )  );
	},
	
	/** @private */
	$doCompositeImages: function( w, h, filename, infoArray, callbackId )
	{
		Core.Proc.appendToCommandString( ":337,-104," + w + "," + h + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( JSON.stringify( infoArray ) ) + "," + Core.Base64.encode( callbackId )  );
	},
	
	/** @private */
	$doChooseCamera: function( w, h, filename, options, callbackId )
	{
		Core.Proc.appendToCommandString( ":337,-106," + w + "," + h + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( JSON.stringify( options ) ) + "," + Core.Base64.encode( callbackId )  );
	},
	
	/** @private */
	setScrollable: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,107," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	
	/** @private */
	setZoomable: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,108," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	
	/** @private */
	addAnnotation: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,109," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	removeAnnotation: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,110," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	selectAnnotation: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,111," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	setRegion: function( latitude, longitude, latitudeDelta, longitudeDelta, animated )
	{
		Core.Proc.appendToCommandString( ":337,112," + this.__objectRegistryId + "," + latitude + "," + longitude + "," + latitudeDelta + "," + longitudeDelta + "," + ( animated ? 1 : 0 )  );
	},
	
	/** @private */
	setView: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,113," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	setCoordinate: function( latitude, longitude )
	{
		Core.Proc.appendToCommandString( ":337,114," + this.__objectRegistryId + "," + latitude + "," + longitude  );
	},
	
	/** @private */
	setCalloutTitle: function( title )
	{
		Core.Proc.appendToCommandString( ":337,115," + this.__objectRegistryId + "," + Core.Base64.encode( title )  );
	},
	
	/** @private */
	setCalloutSubtitle: function( subTitle )
	{
		Core.Proc.appendToCommandString( ":337,116," + this.__objectRegistryId + "," + Core.Base64.encode( subTitle )  );
	},
	
	/** @private */
	setCalloutEnabled: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,117," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	
	/** @private */
	setCalloutLeftView: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,118," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	setCalloutRightView: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,119," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	setCenterOffset: function( xOffset, yOffset )
	{
		Core.Proc.appendToCommandString( ":337,120," + this.__objectRegistryId + "," + xOffset + "," + yOffset  );
	},
	
	/** @private */
	$doChoosePhoto: function( w, h, filename, options, callbackId, invokingView )
	{
		Core.Proc.appendToCommandString( ":337,-121," + w + "," + h + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( JSON.stringify( options ) ) + "," + Core.Base64.encode( callbackId ) + "," + invokingView  );
	},
	
	/** @private */
	setScrollIndicatorsVisible: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,122," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	
	/** @private */
	$measureText: function( string, w, h, font, fontSize, callbackId )
	{
		Core.Proc.appendToCommandString( ":337,-123," + Core.Base64.encode( string ) + "," + w + "," + h + "," + Core.Base64.encode( font ) + "," + fontSize + "," + Core.Base64.encode( callbackId )  );
	},
	
	/** @private */
	setFocus: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,124," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	
	/** @private */
	setViewportEnabled: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,125," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	

// {{/Wg Generated Code}}

	_eventOccurredRecv: function( cmd ) {
		var str = Core.Proc.parseString( cmd[ 0 ] );
		Commands.Window.doCommand(str);
	},
	
	registerTemporaryCallback: function( callback ) {
		if (typeof callback != 'function') return null;
		var regId = (++this._tempCBCount).toString(36);
		Commands._tempCBs[regId] = callback;
		return regId;
	},
	
	takeTemporaryCallback: function( regId ) {
		var cb = Commands._tempCBs[regId];
		delete Commands._tempCBs[regId];
		return cb;
	},

	/**
	 *	@function UI#animate
	 * 	Animate changes to the properties of one or more UI objects.
	 * 	Currently animates changes to frame and alpha, and animates the addition / removal of subviews.
	 * 	@param {Function} action A closure that sets the property or properties to be animated.
	 * 		This function may manipulate several objects.
	 * 	@param {Number} duration The time over which to execute the animation, in milliseconds.
	 * 	@param {Function} onCompletion A closure to be executed after the animation has completed.
	 */
	animate: function(action, duration, callback) {
		if (typeof action == 'function') {
			var cbFn = (typeof callback == 'function') ? callback : duration;
			var duration = (typeof duration == 'number') ? duration : callback;
			if (typeof duration != 'number') duration = 400;

			Commands.startAnimation( duration, Commands.registerTemporaryCallback(callback));
			var options = new UIAnimationOptions();
			action(options);
			Commands.executeAnimation(options);
		}
	},
});

exports.Commands.instantiate();
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ViewGeometry'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ViewGeometry'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ViewGeometry'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;

/**
 * <p>Classes and objects contained by the <code>ViewGeometry</code> class.</p>
 * @name UI.ViewGeometry
 * @namespace
 * @description <p>The <code>ViewGeometry</code> class is a collection of classes and objects that control spatial components for UI views. 
 * Derived classes from <code>ViewGeometry</code> include:</p>
 * <ul>
 * <li><code>{@link UI.ViewGeometry.Rect}</code></li>
 * <li><code>{@link UI.ViewGeometry.Scale}</code></li>
 * </ul>
 * <p><code>ViewGeometry</code> utilizes the following enumerated constants:</p>
 * <ul>
 * <li><code>{@link UI.ViewGeometry.FitMode}</code></li>
 * <li><code>{@link UI.ViewGeometry.Gravity}</code></li>
 * </ul>
 */

var Scale = exports.Scale = Class.singleton(
/** @lends UI.ViewGeometry.Scale.prototype */
{
	/**
	 * @name UI.ViewGeometry.Scale
	 * @class The <code>Scale</code> class constructs objects that handle view geometry for different scales of measurement.
         * @constructs The default constructor.
	 * @augments Core.Class
	 */
   
	initialize: function() {
		var screenUnits = Capabilities.getScreenUnits();
		this.iOSConversion = screenUnits;
		this.pointConversion = this.iOSConversion * 160 / 72; 
	},

	// Use the values of generated constants... Mostly for if we need to send these to native in the future.
	Pixels: Commands.Scaling.Pixels,
	Points: Commands.Scaling.Points,
	Unit: Commands.Scaling.Unit,
	Percent: Commands.Scaling.Percent,
	iPhone: Commands.Scaling.iPhone,
	
	// Internals.
    
	pointConversion: 1.0,
    
	iOSConversion: 1.0,

    /** 
     * Retrieve the supported measurement scale from the device.
     * @param {Number} units The unit of measure.
     * @param {Number} size The screen size of the device.
     * @returns The current screen dimension supported by the device.
     */
	getScale: function(units, size) {
		switch (+units) {
			case this.Points:
				return this.pointConversion;
			case this.Unit:
				return size;
			case this.Percent:
				return size / 100;
			case this.iPhone:
				return this.iOSConversion;
		}
		return 1.0;
	}
});

var Gravity = exports.Gravity = 
{
		
	/** 
	 * @name UI.ViewGeometry.Gravity
	 * @class Enumeration for image gravity in a view.
	 */
	/** 
	* Center of gravity is the top-left corner of the image.
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	TopLeft: [0.0,0.0],
	/** 
	* Center of gravity is the top-center portion of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	TopCenter: [0.5,0.0],
	/** 
	* Center of gravity is the top-right corner of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	TopRight: [1.0, 0.0],
	/** 
	* Center of gravity is the left side of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	Left: [0.0,0.5],
	/** 
	* Center of gravity is the center of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	Center: [0.5,0.5],
	/** 
	* Center of gravity is the right side of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	Right: [1.0,0.5],
	/** 
	* Center of gravity is the bottom-left corner of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	BottomLeft: [0.0,1.0],
	/** 
	* Center of gravity is the bottom-center portion of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	BottomCenter: [0.5,1.0],
	/** 
	* Center of gravity is the bottom-right corner of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	BottomRight: [1.0,1.0]
};

 
exports.FitModes = Commands.FitMode;
/** 
* @name UI.ViewGeometry.FitMode
* @class Enumeration for image fit modes in a view.
* @see UI.Commands#FitMode
*/

	
var Rect = exports.Rect = Class.subclass(
/** @lends UI.ViewGeometry.Rect.prototype */
{
	/**
	 * @name UI.ViewGeometry.Rect
	 * @class <code>Rect</code> constructs rectangle objects for use as positionable elements in the user interface. 
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */

    initialize: function(arg0)
    {
    	if (arg0 instanceof this.constructor){
    		// Another Rect
    		this.x = arg0.x;
    		this.y = arg0.y;
    		this.w = arg0.w;
    		this.h = arg0.h;
    	} else if (arg0 instanceof Array) {
    		if (arguments.length == 2 
    			&& arguments[0].length >= 2 
    			&& arguments[1] instanceof Array 
    			&& arguments[1].length >= 2) {
				
				// Arguments can be two arrays, one of which is a point and one of which is a size,
				this.x = arguments[0][0];
				this.y = arguments[0][1];
				this.w = arguments[1][0];
				this.h = arguments[1][1];
			}
			else if (arguments.length == 1 && arg0.length >= 4) {
				// Single Array
				this.x = arg0[0];
				this.y = arg0[1];
				this.w = arg0[2];
				this.h = arg0[3];
			}
			else {
				NgLogD("UI.ViewGeometry.Rect initialized with unparseable Array(s)");
			}
		} else if (arguments.length == 4) {
			// Four numbers
			this.x = arguments[0];
			this.y = arguments[1];
			this.w = arguments[2];
			this.h = arguments[3];
		}
		return this;
    },
	/**
	 * @returns {Boolean} Returns <code>true</code> if any component value is undefined, NaN, or the value indicates this rect has an area of 0 (<i>width</i> * <i>height</i>).
	 */
	isEmpty: function(){
		return !(this.w * this.h > 0) || isNaN(this.x) || isNaN(this.y) || isNaN(this.w) || isNaN(this.h);
	},
	/**
	 * Copy the component values of this <code>Rect</code>
	 * @returns {UI.ViewGeometry.Rect} A new <code>Rect</code> with identical component values.
	 */	
	copy: function() {
		return new (this).constructor(this);
	},
    /**
	 * Retrieve the component values of this <code>Rect</code>.
	 * @returns {Array (Number)} An array of component values for the specified <code>Rect</code> (<i>x</i>, <i>y</i>, <i>height</i>, <i>width</i>).
	 */	
	array: function() {
		return [this.x, this.y, this.w, this.h];
	},
    /**
	 * Set the dimensions of this <code>Rect</code> as an inset.
	 * @example var imageRect = null;
	 * var remainingRect = rect.copy();
	 * ...
	 * imageRect = remainingRect.sliceHorizontal(110).inset(8,15,8,15);
	 * @param {Number} t The size for the top of the rectangle.
	 * @param {Number} r The size for the right side of the rectangle.
	 * @param {Number} b The size for the bottom of the rectangle.
	 * @param {Number} l The size for the left side of the rectangle.
	 * @param {UI.ViewGeometry.Scale} units The unit of measure for the rectangle.
	 * @returns {UI.ViewGeometry.Rect} This function returns <code>this</code> to support method invocation chaining.
	 */	
	inset: function(t, r, b, l, units) {
		if (arguments.length > 4) {
			var xScale = Scale.getScale(units, this.w);
			var yScale = Scale.getScale(units, this.h);
			t = Math.floor(t * yScale);
			r = Math.floor(r * xScale);
			b = Math.floor(b * yScale);
			l = Math.floor(l * xScale);
		}
		
		if (arguments.length < 2) {
			r = t;
		}
		if (arguments.length < 4) {
			b = t;
			l = r;
		}
		this.y += t;
		this.h -= t + b;
		this.x += l;
		this.w -= l + r;
		return this;
	},
    /**
	 *	Create and return a new <code>Rect</code> representing the top (if positive) or bottom (if negative).
	 *	Destructively modifies this Rect, removing the new rect area from the receiver.
	 * @example var topPart = rect.inset(10).sliceVertical(50, UI.Scale.Percent);
	 * @param {Number} height The new rect height.
	 * @param {UI.ViewGeometry.Scale} [units] The scale of measurement.
	 * @returns {UI.ViewGeometry.Rect} A new <code>Rect</code> object.<br>
	 * @see UI.ViewGeometry.Rect#sliceHorizontal
	 */	
	sliceVertical: function(height, units) {
		if (arguments.length > 1) height = Math.floor(height * Scale.getScale(units, this.h));
		
		var newRect = this.copy();
		if (height < 0) {
			// Return the bottom area...
			newRect.h = -height;
			this.h += height;
			newRect.y += this.h;
		} else {
			newRect.h = height;
			this.y += height;
			this.h -= height;
		}
		return newRect;
	},
    /**
	 *	Create and return a new <code>Rect</code> representing the left (if positive) or right (if negative).
	 *	Destructively modifies this Rect, removing the new rect area from the receiver.
	 * @example var imageRect = null;
	 * var remainingRect = rect.copy();
	 * ...
	 * imageRect = remainingRect.sliceHorizontal(110).inset(8,15,8,15);
	 * @param {Number} width The new rect width.
	 * @param {UI.ViewGeometry.Scale} [units] The scale of measurement.
	 * @returns {UI.ViewGeometry.Rect} A new <code>Rect</code> object.<br>
	 * @see UI.ViewGeometry.Rect#sliceVertical
	 */	
	sliceHorizontal: function(width, units) {
		if (arguments.length > 1) width = Math.floor(width * Scale.getScale(units, this.w));

		var newRect = this.copy();
		if (width < 0) {
			newRect.w = -width;
			this.w += width;
			newRect.x += this.w;
		} else {
			newRect.w = width;
			this.x += width;
			this.w -= width;
		}
		return newRect;
	},

	toString: function() {
		return "Rect: {" + this.array().join(',') + "}";
	},

	/**
	 * Retrieve an array of component values for this <code>Rect</code> with rows and columns redistributed evenly.
	 * @returns {Array (Number)}
	 * @param {Number} rows The rect rows.
	 * @param {Number} columns The rect columns.
	 * @param {String} flat A one-dimensional array (left to right, top to bottom).
	 */
	getGrid: function(rows, columns, flat) {
		// Return an array of this rect divided equally into columns and rows.
		flat = (flat == true);
		var cellW = Math.floor(this.w / columns);
		var cellH = Math.floor(this.h / rows);
		
		var rowSet = new Array();
		for (var i = 0; i < rows; i++) {
			var colSet = new Array();
			for (var j = 0; j < columns; j++) {
				var r = new this.constructor(this.x + j * cellW, this.y + i * cellH, cellW, cellH);
				(flat ? rowSet : colSet).push(r);
			}
			if (!flat) rowSet.push(colSet);
		}
		return rowSet;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Window'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Window'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Window'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Element = require('NGCore/Client/UI/Element').Element;
var Rect = require('NGCore/Client/UI/ViewGeometry').Rect;

var WindowLayer = require('NGCore/Client/UI/WindowLayer').WindowLayer;

// Singleton
// Methods beginning with an underscore are considered private and should
// not be called from outside of the class.

Commands.Window = exports.Window = Class.singleton({

	/**
	 * @deprecated Replaced by {@link UI.Window#getWidth}.
	 */
	_outerWidth: 0,

	/**
	 * @deprecated Replaced by {@link UI.Window#getHeight}.
	 */
	_outerHeight: 0,

	/**
	 * @private
	 */
	_width: 0,
	/**
	 * @private
	 */
	_height: 0,

	 /**
	 * @class The <code>Window</code> class constructs a singleton object that manages application access to native UI.<br><br>
	 * <b>Note:</b> An application should never directly allocate a singleton.
	 * @name UI.Window
	 * @augments Core.Class	
	 * @see UI.Window#document
	 * @constructs The default constructor.
	 */
	initialize: function() {
		if (!this._outerWidth || !this._outerHeight) this.setWidthAndHeight(Capabilities.getScreenWidth(), Capabilities.getScreenHeight());
		if (!this._width || !this._height) this._setWidthAndHeight(Capabilities.getScreenWidth(), Capabilities.getScreenHeight());
		
		Commands.instantiate();
		var LayoutListener = Core.MessageListener.subclass(
		{
			initialize: function()
			{
				Device.LayoutEmitter.addListener(this, this.onUpdate);
			},
			
			onUpdate: function(layout)
			{
				UI.Window._setWidthAndHeight(layout['width'], layout['height']);
			}
		});
		var layout = new LayoutListener();
		NgLogD("window: outer = " + this._outerWidth + " × " + this._outerHeight + " frame = " + this._width + " × " + this._height);
	},
	
	document: WindowLayer.singleton({
		'type': 'document',
		register: function() {
			// This is not a registered object.
			this.__objectRegistryId = 0;
		}
	}),
	
	_layers: {},
	_getLayer: function(level) {
		return this._layers[level] || (this._layers[level] = new WindowLayer({'level':level || 0}));
	},
	
	/**
	 * @private
	 */
	destroyObject: function(obj) {
		obj.removeFromParent();
		Commands.destroy.call(obj);
		ObjectRegistry.unregister(obj);
	},
	
	/**
	 * @private
	 */
	handleCommand: function(command) {
		// this.log(["Raw Command", command]);
		var fields = NgParseCommand2(command, NgParseInt, NgParseBase64);
	//	this.log(["handleCommand:", fields[1]]);
		this.doCommand(fields[1]);
	},
	/**
	* @private
	*/
	setStatusBarHidden: function(value) {
		Commands.setStatusBarHidden(value);
		this._outerHeight = Capabilities.getScreenHeight() - (value ? 0 : (Capabilities.getStatusBarHeight() || 0));
	},
	
	/**
	 * @private
	 */
	doCommand: function(jsonString) {
		//NgLogD(jsonString);
		var command = JSON.parse(jsonString);
		if(command.name == 'callback'){
			var cb = Commands.takeTemporaryCallback(command.callback_id);
			if (typeof cb == 'function') {
				cb(command);
			}
		} else {
			var object = ObjectRegistry.idToObject(command.objId);
			if (object instanceof Element) {
				switch (command.name) {
					case 'event':
						object.performEventCallback(command);
						break;
					case 'update':
						var properties = command.properties || {};
						for (var property in properties) {
							try {
								var setter = object['update' + property.charAt(0).toUpperCase() + property.substr(1)];
								if (typeof setter == 'function') {
									setter.apply(object, [properties[property]]);
								} else {
									// Set read-only properties!
									object['_'+property] = properties[property];
								}
							} catch (e) {};
						}
						break;
					default:
						object.handleCommand(command);
				}
			} else {
				console.log("Message received for non-element object with id " + command.objId);
				return;
			}
		}
		// log(["Got message back", command]);
	},
    
	/**
	 * @private
	 */    
	log: function(object) {
		NgLogD(object.toString());
		// this.postMessage({name: 'log', message: object});
	},
	/**
	 * Return the available screen width, with respect to orientation and system status bars.
	 * @returns {Number} The currently available width in pixels that can be drawn to.
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getWidth: function()
	{
		return this._width;
	},

	/**
	 * Return the available screen height, with respect to orientation and system status bars.
	 * @returns {Number} The currently available height in pixels that can be drawn to.
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getHeight: function()
	{
		return this._height;
	},

	getOuterWidth: function() {
		return this._outerWidth;
	},
	
	getOuterHeight: function() {
		return this._outerHeight;
	},

	getFrame: function() {
		return new Rect(0, 0, this._width, this._height);
	}
});

// Cause property access to initialize the singleton. Needed for backward compatibility.
Commands.Window.__defineGetter__("outerWidth", function() {return this.getOuterWidth()});
Commands.Window.__defineGetter__("outerHeight", function() {return this.getOuterHeight()});

/**
 * @private
 */
Commands.Window._setWidthAndHeight = function(width, height)
{
	console.log("window: set layout size to: " + width + ' × ' + height);
	this._width = width;
	this._height = height;
};

/**
 * @private
 */
Commands.Window.setWidthAndHeight = function(width, height)
{
	console.log("window: set outer size to: " + width + ' × ' + height);
	this._outerWidth = width;
	this._outerHeight = height;
};

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Element'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Element'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Element'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;

var Element = exports.Element = Class.subclass(
/** @lends UI.Element.prototype */
{
	$subclass: function() {
		if (typeof this._init == 'function') this._init();
		return Class.subclass.apply(this, arguments);
	},
	
	classname: "UI_Element",

	/**
	 * @class The <code>Element</code> class is a base class for derived classes that manage object properties and handle user interface events.<br><br>
	 * <b>Caution!:</b> This base class is not exported in the UI module. Do not access it or subclass it at runtime.
	 * Derived classes from <code>Element</code> include:
	* <div class="ul">
	 * <li>{@link UI.AbstractView}</li>
	 * <li>{@link UI.AlertDialog}</li>
	 * <li>{@link UI.ListViewSection}</li>
	 * <li>{@link UI.ProgressDialog}</li>	 
	 * </div>
	 * @constructs The default constructor. 
	 * @param {String} properties
	 * @augments Core.Class
	*/
	initialize: function(properties) {
		if (Element._init) Element._init();
		
		this.register();
		
		// Enable events that are being handled at the class level...
		var events = this._eventNames;
		if (events) for (var e in events) {
			if (this[events[e]]) Commands.enableEvent.call(this, e);
		}
		
		//	Reimplement setAttributes here for speed
		var setters = this._setters;
		if (setters) for (var k in properties) {
			if (typeof setters[k] == 'function') try {
				setters[k].call(this, properties[k]);
			} catch (e) {
				NgLogD("Unable to set " + this.type + '.' + k);
			}
		}
		
	/*	This is awesome. Maybe use it in production code, but we want to keep
	//	our stylistic constraints for core development.
	
		for (var propName in this._setters) {
			this.__defineSetter__(propName, this._setters[propName]);
		}
		for (propName in this._getters) {
			this.__defineGetter__(propName, this._getters[propName]);
		}
	*/
	
		return this;
	},
	
	register: function() {
		try {
			ObjectRegistry.register(this);
			Commands.create(this.__objectRegistryId, this.type || this.classname);
		} catch (e) {
			// Nothing yet
		} finally {
			return this.__objectRegistryId;
		}
	},
	
	retain: function() {
		(this.__retainCount) ? ++this.__retainCount : (this.__retainCount = 1);
		return this;
	},
	
	release: function() {
		if (--this.__retainCount === 0) {
			this.destroy();
		}
	},
		
	/**
	 * Retrieve the property value of the given key. 
	 * @param {String} key The property keyword.
	 * @returns {String} The current property value.
	 * @see UI.Element#getAttributes,
	 * @see UI.Element#setAttribute,
	 * @see UI.Element#setAttributes
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	getAttribute: function(key) {
		var getter = this._getters[key];
		return (typeof getter == 'function') ? getter.call(this) : undefined;
	},
	
	/**
	 * Set the property value for the given key.
	 * @example var glView = new UI.GLView
	 * ...
	 * glView.setAttribute('active', true);
	 * @param {String} key The property keyword.
	 * @param {String} value The new property value.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see UI.Element#getAttribute,
	 * @see UI.Element#getAttributes,
	 * @see UI.Element#setAttributes
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	setAttribute: function(key, value){
		var setter = this._setters[key];
		if (typeof setter == 'function') {
			return setter.call(this, value);
		} else {
			NgLogD("Unable to set " + this.type + '.' + key);
		}
		return this;
	},
	
	/**
	 * Set the property value for each specified key. Property values are passed in as key/value pairs.
	 * @param {Object} dict A dictionary of property key/value pairs.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see UI.Element#getAttribute,
	 * @see UI.Element#getAttributes,
	 * @see UI.Element#setAttribute
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	setAttributes: function(dict) {
		var setters = this._setters;
		if (setters) for (var k in dict) {
			if (typeof setters[k] == 'function') try {
				setters[k].call(this, dict[k]);
			} catch (e) {
				NgLogD("Unable to set " + this.type + '.' + k);
			}
		}
		return this;
	},
	
	/**
	 * Retrieve property values for each specified key. 
	 * @param {String} list A list of property keywords.
	 * @returns {Object} A list of key/value pairs.
	 * @see UI.Element#getAttribute,
	 * @see UI.Element#setAttribute,
	 * @see UI.Element#setAttributes
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	getAttributes: function(list) {
		var output = {};
		if (list instanceof Array) {
			var key;
			for (var i = 0; i < list.length; i++) {
				key = list[i];
				output[key] = this._getters[key].call(this);
			}
		} else {
			for (var key in this._getters) {
				output[key] = this._getters[key].call(this);
			}
		}
		return output;
	},

	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	enableEvent: Commands.enableEvent,
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	toString: function() {
		return this.type + '(' + this.__objectRegistryId + ')';
	},

	/**
	 * @function
	 * @description Destroy this instance and release resources on the backend.
	 * @status Javascript, iOS, Android, Flash, Test
	*/
	destroy: function() {
		Commands.destroy.call(this);
		ObjectRegistry.unregister(this);
		delete this.prototype;
		for (var i in this) {
			if (this.hasOwnProperty(i)) {
				delete this[i];
			}
		}
		this._destroyed = true;
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	*/
	registerCallback: function(func, oneTime) {
		var callbackId = ++this.callbackCounter;
		var obj = this;
		this.callbacks[callbackId] = function(obj, args) {
			try {
				func(obj, args);
				if(oneTime) {
					delete obj.callbacks[callbackId];
				}
			}
			catch(e) {
				NgHandleException(e);
			}
		};
		return callbackId;
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	performCallback: function(event) {
		var cb = this.callbacks[event.callbackId];
		if(cb) {
			cb(this, event.arguments);
		}
	},
	
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	performEventCallback: function(event) {
		try {
			// Look up the event by its 'onXXX' name...
			var eName = this._eventNames[event.eventType];
			var fn = this['_'+eName] || this[eName];
			if (typeof fn == 'function') {
				fn.call(this, event);
			}
		}
		catch(e) {
			NgHandleException(e);
		}
	},	
	
	// STATICS: Setter and Getter Registration
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$registerAccessors: function(propName, getterFn, setterFn, deprecationMessage) {
		// Put the new setter / getter functions into the prototype.
		var caseAdjusted = propName.charAt(0).toUpperCase() + propName.substr(1);
		var byKeyOnly = Boolean(deprecationMessage || false);
	//	NgLogD("Synthesizing set" + caseAdjusted + (shouldSetClosure ? " (custom)" : " (standard)") +
	//		" and get" + caseAdjusted + (onGetClosure ? " (custom)" : " (standard)") + " for member variable " + localVar);
	
		// If this is an instance, use the instance. Otherwise, if we are a class constructor, modify the prototype.
		var pType = (this instanceof Element) ? this : this.prototype;
		if (typeof getterFn == 'function') {
			if (!pType.hasOwnProperty('_getters')) {
				try {
					var heritableMap = function() {return this;};
					var superGetters = pType.superclass._getters;
					if (superGetters) heritableMap.prototype = superGetters;
					pType._getters = new heritableMap();
				} catch (e) {};
			}
			if (byKeyOnly) {
				pType['get'+caseAdjusted] = function() {
					NgLogD("WARNING: Use of get" + caseAdjusted + "() is deprecated. " + deprecationMessage);
					getterFn.apply(this, arguments);
				};
			} else {
				pType['get'+caseAdjusted] = getterFn;
			}
			pType._getters[propName] = getterFn;
		}
		if (typeof setterFn == 'function') {
			if (!pType.hasOwnProperty('_setters')) {
				try {
					var heritableMap = function() {return this;};
					var superSetters = pType.superclass._setters;
					if (superSetters) heritableMap.prototype = superSetters;
					pType._setters = new heritableMap();
				} catch (e) {};
			}
			if (byKeyOnly) {
				pType['set'+caseAdjusted] = function() {
					NgLogD("WARNING: Calling set" + caseAdjusted + "() is deprecated. " + deprecationMessage);
					setterFn.apply(this, arguments);
				}
			} else {
				pType['set'+caseAdjusted] = setterFn;
			}
			pType._setters[propName] = setterFn;
		}
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$registerEventType: function(eventName) {
		var onEventName = 'on' + eventName.charAt(0).toUpperCase() + eventName.substr(1);
		var localVar = '_' + onEventName;
		var pType = this.prototype;
		
		var getterFn = function() {
			return this[localVar] || this[onEventName];
		};
		var setterFn = function(callback) {
			var isFn = (typeof callback == 'function');
			if (isFn) {
				this[localVar] = callback;
			} else {
				delete this[localVar];
			}
			this.enableEvent(eventName, isFn);
		};
		if (!pType.hasOwnProperty('_eventNames')) {
			try {
				var heritableMap = function() {return this;};
				var superEvents = pType.superclass._eventNames;
				if (superEvents) heritableMap.prototype = superEvents;
				pType._eventNames = new heritableMap();
			} catch (e) {};
		}
		pType._eventNames[eventName] = onEventName;
		
		this.registerAccessors(onEventName, getterFn, setterFn);
		
		// Legacy support. Let's concentrate on removing this soon or at least fixing the casing.
		pType.__defineGetter__(onEventName.toLowerCase(), getterFn);
		pType.__defineSetter__(onEventName.toLowerCase(), setterFn);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$synthesizePropertyWithState: function(propName, CommandsFn) {
		var lVarName = '_' + propName + 'Map';
		var setterFn;
		if (propName) {
			setterFn = function(value, optState) {
				optState |= 0;
			//	NgLogD("Set " + this.type + "." + propName + "[" + optState + "] = " + value);
				(this[lVarName] || (this[lVarName] = {}))[optState] = value;
				CommandsFn.call(this, optState, value);
				return this;
			};
		} else {
			setterFn = function(value, optState) {
				CommandsFn.call(this, (optState | 0), value);
				return this;
			};
		}
		
		var getterFn = function(state) {
			return (this[lVarName] || 0)[(state | 0)];
		};
		
		this.registerAccessors(propName, getterFn, setterFn);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$synthesizeCompoundProperty: function(propName, CommandsFn) {
		var lVarName = '_' + propName;
		var setterFn;
		if (CommandsFn) {
			// Synthesized setters accept EITHER an array of reasonable length OR individual args.
			setterFn = function(args) {
				this[lVarName] = (args instanceof Array)
					? args
					: Array.prototype.slice.call(arguments);
				CommandsFn.apply(this, this[lVarName]);
				return this;
			}
		} else {
			setterFn = function(args) {
				this[lVarName] = (args instanceof Array) ? args : Array.prototype.slice.call(arguments);
				return this;
			}
		}
		
		this.registerAccessors(propName, function() {return this[lVarName];} , setterFn);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$synthesizeProperty: function(propName, CommandsFn) {
		var lVarName = '_' + propName;
		var setterFn;
		if (CommandsFn) {
			// Optional args are still passed through, even though only the first arg is assigned.
			setterFn = function(arg) {
				this[lVarName] = arg;
				CommandsFn.apply(this, arguments);
				return this;
			}
		} else {
			setterFn = function(arg) {
				this[lVarName] = arg;
				return this;
			}
		}
		
		this.registerAccessors(propName, function() {return this[lVarName];} , setterFn);
	}
});


// Event Handlers
Element._init = function() {
	delete Element._init;
	
	/**
	 * @name UI.Element#setOnLoad
	 * @description Set a function to call when the <code>load</code> event occurs.
	 * @param {Function} loadCallback The new functoin to call.<br><br><b>Note:</b> The <code>load</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onLoad.loaded = true; 
	 * };
	 * @see UI.Element#event:getOnLoad
	 * @event
	 */
	/**
	 * @name UI.Element#getOnLoad
	 * @description Retrieve the function to call when the <code>load</code> event occurs.
	 * @returns {Function} The current function to call.
	 * @see UI.Element#event:setOnLoad
	 * @event
	 */
	Element.registerEventType('load');
	/**
	 * @name UI.Element#setOnUnload
	 * @description Set a function to call when the <code>unload</code> event occurs.
	 * @param {Function} unloadCallback The new functoin to call.<br><br><b>Note:</b> The <code>unload</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onUnload.unloaded = true; 
	 * };
	 * @see UI.Element#event:getOnUnload	
	 * @event
	 */
	/**
	 * @name UI.Element#getOnUnload
	 * @description Retrieve the function to call when the <code>unload</code> event occurs.
	 * @returns {Function} The current function to call.
	 * @see UI.Element#event:setOnUnload	 
	 * @event
	 */
	Element.registerEventType('unload');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/View'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/View'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/View'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Window = require('NGCore/Client/UI/Window').Window;

var ViewParent = require('NGCore/Client/UI/ViewParent').ViewParent;

var View = exports.View = AbstractView.subclass(
/** @lends UI.View.prototype */
{
	'type':'view',

	/**	 
	 * @class The <code>View</code> class is a base class for derived classes that handle application views. Derived classes from <code>View</code> include:
	 * <div class="ul">
	 * <li>{@link UI.ScrollView}</li>
	 * <li>{@link UI.Toast}</li>
	 * </div>
	 * @constructs The default constructor. 
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} properties Object properties.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (View._init) View._init();
		ViewParent.initialize.call(this);
		return $super(properties);
	},
	/**
	* Add a child node to this <code>View</code> at the specified index.
	* @example var mainView = new UI.View();
	* ...
	* var errorView = new UI.View();
	* ...
	* mainView.addChild(errorView);
	* @param {GL2.Node} childNode The child node to add.
	* @param {Number} index The specified index.
	* @throws {this.type + ".addChild: " + childNode + " is not a view!"} Specified node is not attached to a view.
	* @returns This function returns <code>this</code> to support method invocation chaining.
	* @see UI.View#removeChild
    * @status iOS, Android, Test
	*/
	addChild: ViewParent.addChild,
	
	/**
	* Remove a child node from this <code>View</code> at the specified index.
	* @example mainView.removeChild(errorView);
	* @param {GL2.Node} childNode The child node to remove.
	* @throws {this.type + ".removeChild: " + childNode + " is not a view!} Specified node is not attached to a view.
	* @returns The child node that was removed.
	* @see UI.View#addChild
    * @status iOS, Android, Test
	*/    
	removeChild: ViewParent.removeChild,


	/**
	 * Retrieve a count of the child nodes attached to this <code>View</code>.
	 * @return {Number} The current number of child nodes.
	 * @status Javascript, iOS, Android, Flash
	 */
	getChildCount: ViewParent.getChildCount,

	/**
	 * Retrieve the child nodes attached to this <code>View</code>.
	 * @return {Object} All attached children nodes.
	 * @status Javascript, iOS, Android, Flash
	 */
	getChildren: ViewParent.getChildren,

	/**
	 * @function
	 * @description Override this for custom view subclass layout code.
	 */
	layoutSubviews: function() {
		//Override this for custom view subclass layout code
	},
	/** @protected */
	_style:null,
	/**
	 * Retrieve the style for this <code>View</code>.
	 * @returns {UI.Style} The current <code>View</code> style.
	 * @see UI.View#setStyle
	 * @status Javascript, iOS, Android, Flash
	 */
	getStyle:function(){
		return this._style;
	},
	/**
	 * Set the style for this <code>View</code>. This call allows custom view objects to process and update their styles more easily.
	 * @param {UI.Style} style The new <code>View</code> style.
	 * @see UI.View#getStyle
	 * @status Javascript, iOS, Android, Flash
	 */
	setStyle: function(/*UI.Style*/style) {
		//Override this for custom view subclass styling code
		this._style = style;
	},
	
	/**
	 * @protected
	 * @function
	 * @status Javascript, iOS, Android, Flash
	 */
	_setVisible: function($super, makeVisible) {
		var wasVisible = this._visible;
		$super(makeVisible);
		if (this._visible != wasVisible) {
			var l = this._children.length;
			for (var i = 0; i < l; i++) {
				this._children[i]._setVisible(makeVisible);
			}
		}
	},
});

// Properties
View._init = function() {
	delete View._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * @name UI.View#setImage
	 * @description Set an image URL for a view state. This property defines a remote image resource to use in arbitrary contexts.
	 * @example var someSprite = new UI.View();        
	 * someSprite.setImage('./Content/mySprite.png', [w, h], [0, 0]);
	 * @see UI.View#getImage
	 * @param {String} imageURL The new image URL.
	 * @param {UI.State} [flags=UI.State.Normal] A set of flags describing the view state(s) for using this URL.
 	 * @status iOS, Android, Test
	 * @function 
	 */
	/**
	 * @name UI.View#getImage
	 * @description Retrieve the <code>image</code> URL for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current image URL for the specified view state.
	 * @see UI.View#setImage
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	View.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.View#setImageBorder
	 * @description Set the value of the <code>imageBorder</code> property for a view state. This property defines a border for images used in the specified view state.
	 * @param {Object} imageBorder The new value for <code>imageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.View#getImageBorder
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.View#getImageBorder
	 * @description Retrieve the value of the <code>imageBorder</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current value of <code>imageBorder</code>.
	 * @see UI.View#setImageBorder
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	View.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	/**
	 * @name UI.View#setImageGravity
	 * @description Set the value of the <code>imageGravity</code> property. This property defines how an image is positioned within a viewable area.
	 * @example var someSprite = new UI.View();
	 * ...
	 * someSprite.setImageGravity([0.5, 0.0]);
	 * @param {Number} imageGravity The new value for <code>imageGravity</code> (expressed as two floats).
	 * @see UI.View#getImageGravity
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.View#getImageGravity
	 * @description Retrieve the value of the <code>imageGravity</code> property.
	 * @returns {Number} The current value of <code>imageGravity</code> (expressed as two floats).
	 * @see UI.View#setImageGravity
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	View.synthesizeCompoundProperty('imageGravity', Commands.setImageGravity);
	/**
	 * @name UI.View#setImageFit
	 * @description Set the value of the <code>imageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example var someSprite = new UI.View();
	 * ...
	 * someSprite.setImageFit(UI.FitMode.None);
	 * @param {Number} imageFit The new value for <code>imageFit</code>.
	 * @see UI.View#getImageFit
	 * @function
	 */
	/**
	 * @name UI.View#getImageFit
	 * @description Retrieve the value of the <code>imageFit</code> property.
	 * @returns {Number} The current value of <code>imageFit</code>.
	 * @see UI.View#setImageFit
	 * @function
 	 * @status 
	 */
	View.synthesizeProperty('imageFit', Commands.setImageFitMode);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
		//** extra-deprecated */
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing View." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			View.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('image');
	bindStateProperties('imageBorder');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Label'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Label'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Label'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Label = exports.Label = AbstractView.subclass(
/** @lends UI.Label.prototype */
{
	'type':'label',
	/**
	 * @name UI.Label
	 * @class The <code>Label</code> class constructs objects for managing strings that are used as application labels. 
	 * These objects include access to a wide range of attributes for manipulating the look and feel of application labels.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (Label._init) Label._init();
		$super(properties);
	}
});

Label._init = function() {
	delete Label._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * @name UI.Label#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use as a label in the specified view state.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setText("Friends List");
	 * @param {String} text The new value for <code>text</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Label#getText
	 * @status iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>text</code>.
	 * @see UI.Label#setText
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizePropertyWithState('text', Commands.setText);	
	/**
	 * @name UI.Label#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with labels in the specified view state.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextFont(myFont);
	 * @param {String} textFont The new value for <code>textFont</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Label#getTextFont
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>textFont</code>.
	 * @see UI.Label#setTextFont
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizePropertyWithState('textFont', Commands.setTextFont);
	/**
	 * @name UI.Label#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string for a label in the specified view state.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextColor('FFFF');
	 * @param {String} textColor The new value for <code>textColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Label#getTextColor
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textColor</code>.
	 * @see UI.Label#setTextColor
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.Label#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of text shadowing used on labels in the specified view state.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextShadow("FF00 2.0 {0,-1}");
	 * @param {String} textShadow The new value for <code>textShadow</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Label#getTextShadow
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code>.
	 * @see UI.Label#setTextShadow
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	
	/**
	 * @name UI.Label#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property for this <code>Label</code>. This property defines how a text string is positioned within a viewable area.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextGravity([0.1, 0.5]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as individual components or a single array of components.
	 * @see UI.Label#getTextGravity
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property for this <code>Label</code>.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @see UI.Label#setTextGravity
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);
	/**
	 * @name UI.Label#setTextSize
	 * @description Set the value of the <code>textSize</code> property for this <code>Label</code>. This property defines the size of text strings for a label.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextGravity(24);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.Label#getTextSize
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextSize
	 * @description Retrieve the value of the <code>textSize</code> property for this <code>Label</code>.
	 * @returns {Number} The current value of <code>textSize</code>.
	 * @see UI.Label#setTextSize
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizeProperty('textSize', Commands.setTextSize);

	/**
	 * @name UI.Label#setTextInsets
	 * @description Set the value of the <code>textInsets</code> property for this <code>Label</code>. This property defines the viewable area of a text string when applying gravity.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextInsets(0, 0, 0, 64);
	 * @param {Number, Array (Number)} textInsets The new value for <code>textInsets</code>. Set as individual components or a single array of components.
	 * @see UI.Label#getTextInsets
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextInsets
	 * @description Retrieve the value of the <code>textInsets</code> property for this <code>Label</code>.
	 * @returns {Number, Array (Number)} The current value of <code>textInsets</code>.
	 * @see UI.Label#setTextInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
	
			// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Label." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			Label.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('text');
	bindStateProperties('textColor');
	bindStateProperties('textShadow');
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Image'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Image'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Image'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Image = exports.Image = AbstractView.subclass(
/** @lends UI.Image.prototype */
{
	/**
	 * @name UI.Image
	 * @class The <code>Image</code> class constructs objects that control the location and size of images used in the user interface.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (Image._init) Image._init();
		$super(properties);
	},
	
	'type':'image'
});


// Properties
Image._init = function() {
	delete Image._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * @name UI.Image#setImage
	 * @description Set an image URL for a view state. This property defines how an image appears for specific conditions. For example,
	 * set one image for the default view state and another image for a view state with focus.
	 * @example var splashGraphic = new UI.Image();
	 * ...
	 * splashGraphic.setImage('./Content/splash.png');
	 * @see UI.Image#getImage
	 * @param {String} imageURL The new image URL.
	 * @param {UI.State} [flags=UI.State.Normal] A set of flags describing the view state(s) for using this URL.
	 * @status iOS, Android, Test
	 * @function 
	 */
	/**
	 * @name UI.Image#getImage
	 * @description Retrieve the <code>image</code> URL for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current image URL for the specified view state..
	 * @see UI.Image#setImage
	 * @status iOS, Android, Test
	 * @function
	 */
	Image.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.Image#setImageBorder
	 * @description Set the value of the <code>imageBorder</code> property for a view state. This property defines a border for images used in the specified view state.
	 * @param {Object} imageBorder The new value for <code>imageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Image#getImageBorder
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Image#getImageBorder
	 * @description Retrieve the value of the <code>imageBorder</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current value of <code>imageBorder</code>.
	 * @see UI.Image#setImageBorder
	 * @function
	 * @status iOS, Android, Test
	 */
	Image.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	/**
	 * @name UI.Image#setImageGravity
	 * @description Set the value of the <code>imageGravity</code> property. This property defines how an image is positioned within a viewable area.
	 * @example var splashGraphic = new UI.Image();
	 * ...
	 * splashGraphic.setImageGravity([0.5, 0.0]);
	 * @param {Number} imageGravity The new value for <code>imageGravity</code> expressed as two floats.
	 * @see UI.Image#getImageGravity
	 * @function
	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Image#getImageGravity
	 * @description Retrieve the value of the <code>imageGravity</code> property.
	 * @returns {Number} The current value of <code>imageGravity</code> expressed as two floats.
	 * @see UI.Image#setImageGravity
	 * @function
	 * @status iOS, Android, Test
	 */
	Image.synthesizeCompoundProperty('imageGravity', Commands.setImageGravity);
	 /**
	 * @name UI.Image#setImageTransform
	 * @description Set the value of the <code>imageTransform</code> property. This property defines data compression for images.
	 * @example var splashGraphic = new UI.Image();
	 * ...
	 * splashGraphic.setImageTransform([Math.cos(angle), Math.sin(angle), Math.sin(angle), Math.cos(angle), 0, 0]);
	 * @param {Array (Number)} imageTransform The new value for <code>imageTransform</code>. 
	 * Set as an array of floats (<i>a</i>, <i>b</i>, <i>c</i>, <i>d</i>, <i>tx</i>, <i>ty</i>).
	 * @see UI.Image#getImageTransform
	 * @function
	 */
	/**
	 * @name UI.Image#getImageTransform
	 * @description Retrieve the value of the <code>imageTransform</code> property.
	 * @returns {Array (Number)} The current value of <code>imageTransform</code>.
	 * @see UI.Image#setImageTransform
	 * @function
	 */
	 Image.synthesizeCompoundProperty('imageTransform', Commands.setImageTransform);
	/**
	 * @name UI.Image#setImageFit
	 * @description Set the value of the <code>imageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example var splashGraphic = new UI.Image();
	 * ...
	 * splashGraphic.setImageFit(UI.FitMode.None);
	 * @param {Number} imageFit The new value for <code>imageFit</code>.
	 * @see UI.Image#getImageFit
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Image#getImageFit
	 * @description Retrieve the value of the <code>imageFit</code> property.
	 * @returns {Number} The current value of <code>imageFit</code>.
	 * @see UI.Image#setImageFit
	 * @function
 	 * @status iOS, Android, Test
	 */
	Image.synthesizeProperty('imageFit', Commands.setImageFitMode);
	
		// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Image." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			Image.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('image');
    bindStateProperties('imageBorder');
	bindStateProperties('gradient');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Button'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Button'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Button'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Button = exports.Button = AbstractView.subclass(
/** @lends UI.Button.prototype */
{
	/**
	 * @name UI.Button
	 * @class The <code>Button</code> class constructs objects that are used as application buttons.
	 * @augments UI.AbstractView
	 */
	'type':'button',

	'Layout':Commands.ButtonLayout,
	
	initialize: function($super, properties) {
		if (Button._init) Button._init();
		$super(properties);
	}
});

// Properties
Button._init = function() {
	delete Button._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * @name UI.Button#setImage
	 * @description Set an image URL for a view state. This defines how buttons appear for specific conditions. For example, 
	 * set different images for a button in the default view state and a button when it is pressed.
	 * @example var backButton = new UI.Button();        
	 * backButton.setImage('./Content/backButton.png', [w, h], [0, 0]);
	 * @see UI.Button#getImage
	 * @param {String} imageURL The new image URL.
	 * @param {UI.State} [flags=UI.State.Normal] A set of flags describing the view state(s) for using this URL.
 	 * @status iOS, Android, Test
	 * @function 
	 */
	/**
	 * @name UI.Button#getImage
	 * @description Retrieve the <code>image</code> URL for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current image URL for the specified view state..
	 * @see UI.Button#setImage
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.Button#setImageInsets
	 * @description Set the value of the <code>imageInsets</code> property. This property defines the viewable area of an image when applying gravity.
	 * @example var backButton = new UI.Button();
	 * ...
	 * backButton.setImageInset([10,10,10,10]);
	 * @param {Number, Array (Number)} imageInsets The new value for <code>imageInsets</code>. Set as insets or an array of insets (expressed as floats).
	 * @see UI.Button#getImageInsets
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getImageInsets
	 * @description Retrieve the value of the <code>imageInsets</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>imageInsets</code>.
	 * @see UI.Button#setImageInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizeCompoundProperty('imageInsets', Commands.setImageInsets);
	/**
	 * @name UI.Button#setImageFit
	 * @description Set the value of the <code>imageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example var backButton = new UI.Button();
	 * ...
	 * backButton.setImageFit(UI.FitMode.None);
	 * @param {Number} imageFit The new value for <code>imageFit</code>.
	 * @see UI.Button#getImageFit
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Button#getImageFit
	 * @description Retrieve the value of the <code>imageFit</code> property.
	 * @returns {Number} The current value of <code>imageFit</code>.
	 * @see UI.Button#setImageFit
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Button.synthesizeProperty('imageFit', Commands.setImageFitMode);
	/**
	 * @name UI.Button#setImageGravity
	 * @description Set the value of the <code>imageGravity</code> property. This property defines how a image for a button is positioned within a viewable area.
	 * @example var backButton = new UI.Button();
	 * ...
	 * backButton.setImageGravity([0.5, 0.0]);
	 * @param {Number} imageGravity The new value for <code>imageGravity</code> (expressed as two floats).
	 * @see UI.Button#getImageGravity
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Button#getImageGravity
	 * @description Retrieve the value of the <code>imageGravity</code> property.
	 * @returns {Number} The current value of <code>imageGravity</code> (expressed as two floats).
	 * @see UI.Button#setImageGravity
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Button.synthesizeCompoundProperty('imageGravity', Commands.setImageGravity);
	/**
	 * @name UI.Button#setImageTransform
	 * @description Set the value of the <code>imageTransform</code> property. This property defines data compression for an image used as a button.
	 * @example var button = new UI.Button()
	 * ...
	 * button.setImageTransform([Math.cos(angle), Math.sin(angle), Math.sin(angle), Math.cos(angle), 0, 0]);
	 * @param {Array (Number)} imageTransform The new value for <code>imageTransform</code>. 
	 * Set as an array of floats (<i>a</i>, <i>b</i>, <i>c</i>, <i>d</i>, <i>tx</i>, <i>ty</i>).
	 * @see UI.Button#getImageTransform
 	 * @status iOS, Android
	 * @function
	 */
	/**
	 * @name UI.Button#getImageTransform
	 * @description Retrieve the value of the <code>imageTransform</code> property.
	 * @returns {Array (Number)} The current value of <code>imageTransform</code>.
	 * @see UI.Button#setImageTransform
 	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	Button.synthesizeCompoundProperty('imageTransform', Commands.setImageTransform);
	/**
	 * @name UI.Button#setImageBorder
	 * @description Set the value of the <code>imageBorder</code> property for a view state. This property defines a border for images used in the specified view state.
	 * @param {Object} imageBorder The new value for <code>imageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Button#getImageBorder
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getImageBorder
	 * @description Retrieve the value of the <code>imageBorder</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current value of <code>imageBorder</code>.
	 * @see UI.Button#setImageBorder
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	
	/**
	 * @name UI.Button#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use as a label for a button in different view states.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setText("More information");
	 * @see UI.Button#getText
	 * @param {String} text The new value for <code>text</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code> in the specified view state..
	 * @see UI.Button#setText
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('text', Commands.setText);
	/**
	 * @name UI.Button#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string used as a label on a 
	 * button in different view states.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextColor('FFFFFF');
	 * @see UI.Button#getTextColor
	 * @param {String} textColor The new value for <code>textColor</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function 
	 */
	/**
	 * @name UI.Button#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textColor</code> in the specified view state..
	 * @see UI.Button#setTextColor
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.Button#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with labels for a button in different view states.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextFont(myFont);
	 * @param {String} textFont The new value for <code>textFont</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Button#getTextFont
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>textFont</code> in the specified view state.
	 * @see UI.Button#setTextFont
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('textFont', Commands.setTextFont);
	/**
	 * @name UI.Button#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of text shadowing used on text strings for a button in different view states.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextShadow("FF00 2.0 {0,-1}");
	 * @see UI.Button#getTextShadow
	 * @param {String} textShadow The new value for <code>textShadow</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code> in the specified view state..
	 * @see UI.Button#setTextShadow	
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	/**
	 * @name UI.Button#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property. This property defines how a text string for a button is positioned within a viewable area.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextGravity([0.1, 0.5]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as individual components or a single array of components.
	 * @see UI.Button#getTextGravity
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @see UI.Button#setTextGravity
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);

	/**
	 * @name UI.Button#setTextSize
	 * @description Set the value of the <code>textSize</code> property. This property defines the text size of labels for a button.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextSize(24);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.Button#getTextSize
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextSize
	 * @description Retrieve the value of the <code>textSize</code> property.
	 * @returns {Number} The current value for <code>textSize</code>.
	 * @see UI.Button#setTextSize
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.Button#setTextInsets
	 * @description Set the value of the <code>textInsets</code> property. This property defines the viewable area of a text string when applying gravity.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextInsets(0, 0, 0, 64);
	 * @param {Array (Number)} textInsets The new value for <code>textInsets</code>.
	 * @see UI.Button#getTextInsets
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextInsets
	 * @description Retrieve the value of the <code>textInsets</code> property.
	 * @returns {Array (Number)} The curent value for <code>textInsets</code>.
	 * @see UI.Button#setTextInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
		//** extra-deprecated */
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			Button.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('text');
	bindStateProperties('textColor');
    bindStateProperties('textFont');
	bindStateProperties('textShadow');
	bindStateProperties('gradient');
	bindStateProperties('image');
    bindStateProperties('imageBorder');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/GLView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/GLView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/GLView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var GLView = exports.GLView = AbstractView.subclass(
/** @lends UI.GLView.prototype */
{
	'type':'glview',
	/**
	* @class The <code>GLView</code> class constructs objects that provide applications with access to OpenGL. Games must instantiate a <code>GLView</code> object, 
	* set the active state to <code>true</code> and wait for the callback before instantiating any objects in the {@link GL2} module.
	* @name UI.GLView
	* @augments UI.AbstractView	
	*/
	initialize: function($super, properties) {
		if (GLView._init) GLView._init();
		$super(properties);
	}
});

GLView._init = function() {
	delete GLView._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * @name UI.GLView#setActive
	 * @description Set the value of the <code>active</code> property.
	 * @example var glView = new UI.GLView()
	 * ...
	 * glView.setActive(true);
	 * @param {Boolean} active Set as <code>true</code> if the <code>GLView</code> object is active.
	 * @see UI.GLView#getActive
	 * @status iOS, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.GLView#getActive
	 * @description Retrieve the value of the <code>active</code> property.
	 * @returns {Boolean} Returns <code>true</code> if the <code>GLView</code> object is active.
	 * @see UI.GLView#setActive
	 * @status iOS, Android, Flash, Test
	 * @function
	 */
	GLView.synthesizeProperty('active', Commands.setActive);
	
	/**
	 * @name UI.GLView#getOGLExtensions
	 * @description Return an array containing all of the OpenGL extensions that are supported within the context of this view.
	 * The return value of this method is only valid when the view is active.
	 * @status Android
	 * @function
	 */
	GLView.registerAccessors('OGLExtensions', function() {return this['_OGLExtensions'];}, function() {} );
	
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/NavController'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/NavController'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/NavController'] = exports; var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
var KeyEmitter = require('NGCore/Client/Device/KeyEmitter').KeyEmitter;
var Window = require('NGCore/Client/UI/Window').Window;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Device = require('NGCore/Client/Device').Device;
var Element = require('NGCore/Client/UI/Element').Element;
var View = require('NGCore/Client/UI/View').View;

function getAnalyticsName(item){
	if(item && item.hasOwnProperty("analyticsName")){
		return item["analyticsName"] || undefined;	// If NULL, return undefined.
	}
	return undefined;
}

var NavKeyListener = MessageListener.subclass({
	classname: "UI_NavController_KeyListener",
});

var NavController = exports.NavController = View.subclass(
/** @lends UI.NavController.prototype */
{
	/**
	 * @class The <code>NavController</code> class constructs objects that define application navigation components.
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} properties Object properties.
	 */
	initialize: function($super, properties) {
		if (NavController._init) NavController._init();
		
	    this.navStack = [];
		var onAndroid = Capabilities.getPlatformOS() == 'Android';
	    this._useBackButton = !onAndroid;
	
		this.keyListener = new NavKeyListener();
		KeyEmitter.addListener(this.keyListener, this.onKeyPressed.bind(this));
		$super(properties);
	},
	
	/**
	 * Turn on the onscreen <b>Back</b> button. Applications designed for iOS should always provide the <b>Back</b> button 
	 * and integrate it into the application UI (calling <code>{@link UI.NavController#back}</code> when pressed).<br><br>
	 * <b>Note:</b> This is turned off by default for applcations designed for Android because Android devices contain a hardware <b>Back</b> button.
	 * @param {Boolean} toUse Set as <code>true</code> to enable the onscreen <b>Back</b> button.
	 * @function
	 * @status Javascript, iOS, Android, Flash
	 */
	setUseBackButton: function(toUse) {
		this._useBackButton = toUse;
		if (toUse) {
			this._createBackButton();
		} else if (this.backButton) {
			this.backButton.removeFromParent();
		}
	},
    
	/**
	 * Reset the stack for this <code>NavController</code>.
	 * @param {String} fromButton The button to reset.
	 * @status Javascript, iOS, Android, Flash
	 */    
	clear: function(fromButton) {
		return this.backToView(undefined);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	logNavEvent: function (from, to, via) {
		var toName = getAnalyticsName(to);
		var fromName = getAnalyticsName(from);
		var viaName = getAnalyticsName(via);
		if (fromName || toName) {
			Core.Analytics._getPipe().navigationEvent(fromName, toName, viaName);
		}
	},
	
	/**
	 * Retrieve the top view from the nav stack of this <code>NavController</code>.
	 * @returns {Object} The top view in the nav stack
	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	getTopView: function() {
		return (this.navStack.length > 0) ? this.navStack[ (this.navStack.length - 1) ] : undefined;
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	navStackDepth: function() {
		return this.navStack.length;
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	depthOfView: function(targetView) {
		var targetIndex = this.navStack.indexOf(targetView);
		if(targetIndex == -1){return -1;}
		
		return this.navStack.length - targetIndex - 1;
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	viewAtDepth: function(targetDepth) {
		if(targetDepth >= this.navStack.length){
			return null;
		}
		return this.navStack[this.navStack.length - targetDepth - 1];
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	removeDeepView:function(targetView) {
		var targetIndex = this.navStack.indexOf(targetView);
		if(targetIndex == -1){
			NgLogE("NavController: trying to remove a nonexistent view from the nav stack!");
			return;
		}
		this.navStack.splice(targetIndex,1);
	},
    
	/**
	 * @protected
	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	_viewTransition: function(fromView, toView, back, buttonRef) {
		//The views transition within the container (which is 'this')
		var myFrame = this.getFrame();
		var w = myFrame[2];
		var h = myFrame[3];
		
		//TODO: animate this (below) transition.
		if (toView) {
			toView.setFrame( (back ? -w : w), 0, w, h);
			this.addChild(toView);
		}
		
		UI.animate(function() {
			if (fromView) fromView.setFrame( (back ? w : -w), 0, w, h);
			if (toView) toView.setFrame(0, 0, w, h);
		}, 400, function() {
			if (fromView) fromView.removeFromParent();
		});
		
		this.logNavEvent(fromView, toView, buttonRef);
		this._createBackButton();
	},

	/**
	 * Retrieve removed views in the reverse order they were removed.
	 * @example var page = new NavPage({...});
	 *
	 * var controller = new UI.NavController({...});
	 *
	 * NavPage.navController = controller;
	 * controller.forwardToView(page);
	 * @param {String} destView The destination view for this navigation component.
	 * @param {String} fromButton The button that triggers this navigation component.
	 * @status Javascript, iOS, Android, Flash
	 * @see UI.NavController#backToView
	 */    
	forwardToView: function(destView, fromButton) {
		var currentView = this.getTopView();
		if (destView && 
			(!this._delegate 
				|| (this._delegate 
					&& typeof this._delegate.navControllerShouldPush == "function" 
					&& this._delegate.navControllerShouldPush(this,destView))
			)) {
			
			destView.performEventCallback({eventType:"push",navController:this})
			
			this.navStack.push(destView);
			this._viewTransition(currentView, destView, false, fromButton);
		}
	},
    
	/**
	 * Set back navigation for this <code>NavController</code>.
	 * @param {String} fromButton The button that triggers this navigation component.
	 * @status Javascript, iOS, Android, Flash
	 * @see UI.NavController#forward	
	 */
	back: function(fromButton) {
		var removed = this.navStack.pop();
		
		if (removed && 
			(!this._delegate 
				|| (this._delegate 
					&& typeof this._delegate.navControllerShouldPop == "function" 
					&& this._delegate.navControllerShouldPop(this,removed))
			)) {
			removed.performEventCallback({eventType:"pop",navController:this});
		} else {
			return null;
		}
		this._viewTransition(removed, this.getTopView(), true, fromButton);
		return removed;
	},

	/**
	 * Retrieve removed views in the order they were removed.
	 * @example var page = new NavPage({...});
	 *
	 * var controller = new UI.NavController({...});
	 *
	 * NavPage.navController = controller;
	 * controller.backToView(page);
	 * @param {String} destView The destination view for this navigation component.
	 * @param {String} fromButton The button that triggers this navigation component.
	 * @status Javascript, iOS, Android, Flash
	 * @see UI.NavController#forwardToView
	 */    
	backToView: function(destView, fromButton) {
		var removedSet = [];
		var removed = this.navStack.pop();
		var originalView = removed;
		if (removed) {
			do {
				if (removed && 
					(!this._delegate 
						|| (this._delegate 
							&& typeof this._delegate.navControllerShouldPop == "function" 
							&& this._delegate.navControllerShouldPop(this,removed))
					)) {
					removedSet.push(removed);
					removed.performEventCallback({eventType:"pop",navController:this});
				}
				else {
					//There was nothing to remove, or the this._delegate said "don't remove".
					break;
				}
				
				if (this.getTopView() == destView){break;}
			} while ((removed = this.navStack.pop()));
		}
		if(removedSet.length > 0) {
			this._viewTransition(originalView, this.getTopView(), true, fromButton);
		}
		return removedSet;
	},

	/**
	 * Set this <code>NavController</code> to launch the application when activated.
	 * @status Javascript, iOS, Android, Flash
	 */    
	loadApp: function() {		
	},
    
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */    
	onBackPressed: function() {
		if (this.navStack.length > 1) {
		//	NgLogD("Handle back on nav stack. Number of views on stack=" + this.navStack.length);
			
			var analyticsName = "bcksbtn"; // Back System Button
			
			// if the topmost view has an analytics name, prefix the button
			var topView = this.getTopView();
			if(topView.analyticsName){
				analyticsName = topView.analyticsName + "." + analyticsName;
			}

			this.back({
				analyticsName: analyticsName
			});
			return true;
		}
		return false;
	},
	
	onKeyPressed: function(event) {
		if ((event.code === Device.KeyEmitter.Keycode.back) && (this.navStack.length > 1)) {
			this.back();
			return true;
		}
		return false;
	},
	
	/**
	 * @protected
	 * @status Javascript, iOS, Android, Flash
	 */
	_delegate:null,
	/**
	 * @description Set subscribers to the <code>NavController</code> behavior. Subscribers can modify what happens. 
	 * NavControllerDelegateProtocol:
	 *	@optional - (BOOL)navControllerShouldPop(NavController,View)
	 *	@optional - (BOOL)navControllerShouldPush(NavController,View)
	 * @param {String} navDelegate A <code>NavController</code> subscriber.
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	setDelegate:function( /*NavControllerDelegate*/ navDelegate){
		this._delegate = navDelegate;
	},
	
	delegate:function(){return this._delegate;},
	
	/**
	 * @protected
	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	_createBackButton: function() {
		// Do nothing if this device does not require an onscreen button.
		if (!this._useBackButton) return;
		
		if (!this.backButton) {
			this.backButton = new UI.Button({
				normalText: 'Back',
				textSize: 13.0,
				normalTextColor: "FF",
				normalTextShadow: "00 1.5 {0,-1}",
				frame: [-2, 20, Window.outerWidth / 5, Window.outerHeight / 12],
				normalGradient: {
					corners: "0 8 8 0",
					outerLine: "00 1.5",
					innerShadow: "99FF 2.0 {0,-1}",
					gradient: [
						"FFCC 0.0",
						"FF80 1.0"
					]
				},
				highlightedGradient: {
					corners: "0 8 8 0",
					outerLine: "00 1.5",
					innerLine: "FF00 15 {0,-1}",
					gradient: [
						"FF50 0.0",
						"FF80 1.0"
					]
				}
			});
			this.backButton.onclick = this.bind(this.onBackPressed);
		}
		
		if (this.navStack.length > 1) {
			if (!this.backButton.getParent()) Window.document.addChild(this.backButton);
		} else if ( this.backButton.getParent() ) {
			this.backButton.removeFromParent();
		}
	}
});

NavController._init = function() {
	delete NavController._init;
	if (View._init) View._init();
}; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/WebView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/WebView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/WebView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var WebView = exports.WebView = AbstractView.subclass(
/** @lends UI.WebView.prototype */
{
	'type':'webview',

	/**
	 * @class The <code>WebView</code> class constructs objects for loading and navigating documents. 
	 * <code>WebView</code> objects also trigger event callback functions when web page events occur.
	 * @constructs The default constructor. 
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} properties Object properties.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (WebView._init) WebView._init();
		this._canGoBack = false;
		this._canGoForward = false;
		return $super(properties);
	},
	
	/** @private */
	_onShouldLoad: function(event) {
		NgLogD("Should Load " + event.url + " ???????");
		var fn = this.getOnShouldload();
		if (typeof fn == 'function') {
			// If we SHOULDN'T load the url, bail.
			if (!Boolean(fn.call(this, event))) return;
		}
		// The default (if the function was missing or not a function) is to load the url.
		this.loadUrl(event.url);
	},
	
	/** @private */
	performEventCallback: function($super, event) {
		try {
			if (event.eventType == 'shouldload') {
				// We need to call the onShouldLoad function in a way that captures the return value.
				this._onShouldLoad(event);
				return;
			}
			if (event.eventType == 'pageload') {
				// Do not touch this parsing code. Everything else is wrong, extensive testing was done.
				this._canGoBack = event.canGoBack = Boolean(JSON.parse(event.canGoBack));
				this._canGoForward = event.canGoForward = Boolean(JSON.parse(event.canGoForward));
			}
			$super(event);
		} catch(e) {
			NgHandleException(e);
		}
	},
	// invoke doesn't return a value. to get response, use onpageevent
	/**
	* Run a string of Javascript code in this <code>WebView</code>. Any code requiring a result from <code>invoke()</code> must explicitly 
	* return a value by attempting to load an ngcore:// URL. The attempted load is caught by <code>pageEvent</code>. 
	* @see UI.WebView#event:setOnPageevent
	* @function
    * @status iOS, Android
	*/
	invoke: Commands.invoke,
	/**
	* Set a document to load from the specified URL.
	* @example myWebView = new UI.WebView();
	* ...
	* myWebView.loadUrl('http://www.webdoc.com/");
	* @param {String} url The URL from which to load a document.
	* @param {String} [headers] The document headers.
	* @param {Number} [timeout] The timeout duration.
	* @see UI.WebView#loadDocument
    * @status iOS, Android
	*/
	loadUrl: function(url, headers, timeout) {
		Commands.loadURL.call(this, url, headers || null, +(timeout || 0));
	},
	/**
	* Set a document to load from the specified local path.
	* @example myWebView = new UI.WebView();
	* ...
	* myWebView.loadUrl('./path/to/document/");
	* @param {String} relativePath The local path from which to load a document.
	* @see UI.WebView#loadUrl
    * @status iOS, Android
	*/
	loadDocument: function(relativePath){
		Commands.setSourceDocument.call(this, relativePath);
	},
	/**
	* Load a URL using the HTTP <code>POST</code> method.
	* @param {String} url The URL to load using <code>POST</code>.
	* @param {String / Object} data A string containing the raw <code>POST</code> body, or an object to post with <code>www/form-data</code> encoding containing key/value pairs.
	* @see UI.WebView#loadUrl,
	* @see UI.WebView#loadDocument
    * @status iOS, Android
	*/
	postUrl: function(url, data){
		var dataStr;
		if(typeof data == "object"){
			var params = [];
			for(var key in data){
				params.push(encodeURIComponent(key) + '=' + encodeURIComponent(data[key]));
			}
			dataStr = params.join('&');
		}else{
			dataStr = data;
		}
		Commands.postURL.call(this, url, dataStr);
	},
	/**
	* Stop loading a document. 
	* @function
    * @status iOS, Android
	*/
	stopLoading: Commands.stopLoading,
	/**
	* Reload a document called with <code>loadDocument()</code> or <code>loadUrl()</code>.
	* @see UI.WebView#loadDocument,
	* @see UI.WebView#loadUrl
	* @function
    * @status iOS, Android
	*/
	reload: Commands.reload,
	/**
	* Navigate to the previous page in a document view.
	* @see UI.WebView#goForward
	* @function
    * @status iOS, Android
	*/
	goBack: Commands.goBack,
	/**
	* Navigate to the next page in a document view.
	* @see UI.WebView#goBack
	* @function
    * @status iOS, Android
	*/
	goForward: Commands.goForward,
	/**
	* Set back navigation as supported in this <code>WebView</code>.
	* @returns {Boolean} Returns <code>true</code> if this <code>WebView</code> supports back navigation.
	* @see UI.WebView#canGoForward
    * @status iOS
	*/
	canGoBack: function(){
		return this._canGoBack;
	},
	/**
	* Set that forward navigation is supported in this <code>WebView</code>.
	* @returns {Boolean} Returns <code>true</code> if this <code>WebView</code> supports forward navigation.
	* @see UI.WebView#canGoBack
    * @status iOS
	*/
	canGoForward: function(){
		return this._canGoForward;
	},
	/**
	* Set the authentication credentials for this <code>WebView</code> session.
	* @param {String} host The authentication host.
	* @param {String} realm The security realm.
	* @param {String} username The username to use for authenticating the session.
	* @param {String} password The password to use for authenticating the session.
    * @status iOS, Android
	*/
	setBasicAuthCredential: function(host, realm, username, password){
		Commands.setBasicAuthCredentials.call(this, {'host':host, 'realm':realm, 'username':username, 'password':password});
	},

	setViewportEnabled: function(enabled) {
		Commands.setViewportEnabled.call(this, enabled);
	}
});

WebView._init = function() {
	delete WebView._init;
	if (AbstractView._init) AbstractView._init();
	
	WebView.synthesizeProperty('scrollable', Commands.setScrollable);
	
	/**
	 * @name UI.WebView#setOnStartload
	 * @description Set a function to call when the <code>startload</code> event occurs.
	 * @param {Function} startloadCallback The function to call.<br><br>
	 * <b>Note:</b> The <code>startload</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.WebView#event:getOnStartload
	 * @event
	 * @status iOS, Android
	 */
	/**
	 * @name UI.WebView#getOnStartload
	 * @description Retrieve the function to call when the <code>startload</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnStartload
	 * @event
	 * @status iOS, Android
	 */
	WebView.registerEventType('startload');
	/**
	 * @name UI.WebView#setOnPageload
	 * @description Set a function to call when the <code>pageload</code> event occurs.
	 * @param {Function} pageloadCallback The function to call.<br><br>
	 * <b>Note:</b> The <code>pageload</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.WebView#event:getOnPageload
	 * @event
	 * @status iOS, Android
	 */
	/**
	 * @name UI.WebView#getOnPageload
	 * @description Retrieve the function to call when the <code>pageload</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnPageload
	 * @event
	 * @status iOS, Android
	 */
	WebView.registerEventType('pageload');
	/**
	 * @name UI.WebView#setOnError
	 * @description Set a function to call when the <code>error</code> event occurs.
	 * @param {Function} [errorCallback] The function to call.<br><br>
	 * <b>Note:</b> The <code>error</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.WebView#event:getOnError
	 * @event
	 * @status iOS, Android
	 */
	/**
	 * @name UI.WebView#getOnError
	 * @description Retrieve the function to call when the <code>error</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnError
	 * @event
	 * @status iOS, Android
	 */
	WebView.registerEventType('error');
	/**
	 * @name UI.WebView#setOnPageevent
	 * @description Set a function to call when the <code>pageevent</code> event occurs.
	 * @param {Function} pageeventCallback The new callback function.<br><br>
	 * <b>Note:</b> The <code>pageevent</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.WebView#event:getOnPageevent
	 * @event
	 * @status iOS, Android
	 */
	/**
	 * @name UI.WebView#getOnPageevent
	 * @description Retrieve the function to call when the <code>pageevent</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnPageevent
	 * @event
	 * @status iOS, Android
	 */
	WebView.registerEventType('pageevent');	
	/** 
	* @name UI.WebView#setOnShouldLoad
	* @description Set a function to call when the <code>shouldload</code> event occurs. The callback for the event returns 
	* <code>true</code> if the page should be loaded. Otherwise, the callback returns <code>false</code>.
	* @param {function} shouldloadCallback The new callback function.<br><br>
	* <b>Note:</b> The <code>shouldload</code> event is disabled if the value of this parameter is not a function.
	* @example  myWebView.setOnShouldload( function(event) {
	NgLogD("URL is " + event.url);
	NgLogD("Nav Type is " + event.navigation);
  } );
	* @see UI.WebView#event:getOnShouldLoad
	* @event
	*/
	/**
	* @name UI.WebView#getOnShouldLoad
	* @description Retrieve the function to call when the <code>shouldload</code> event occurs.
	* @returns {function} The current callback function.
	* @see UI.WebView#event:setOnShouldLoad
	* @event
	*/
	WebView.registerEventType('shouldload');
	
	/** 
	* @name UI.WebView#setOnExternalLink
	* @description Set a function to call when a link will be opened in an external application.
	* @param {function} ExternalLinkCallback The new callback function.<br><br>
	* @see UI.WebView#event:getOnExternalLink
	* @event
	*/
	/**
	* @name UI.WebView#getOnExternalLink
	* @description Retrieve the function to call when the <code>ExternalLink</code> event occurs.
	* @returns {function} The current callback function.
	* @see UI.WebView#event:setOnExternalLink
	* @event
	*/
	WebView.registerEventType('externalLink');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ScrollView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ScrollView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ScrollView'] = exports; var View = require('NGCore/Client/UI/View').View;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');
var Commands = require('NGCore/Client/UI/Commands').Commands;

var ScrollView = exports.ScrollView = View.subclass(
/** @lends UI.ScrollView.prototype */
{
	'type':'scrollview',
	/**
	* @class The <code>ScrollView</code> class constructs objects that handle views in a scrolling list (see <code>{@link UI.ListView}</code>). 
	* You can define these views as scrolling vertically, horizontially, or both directions.<br><br>
	* <b>Note:</b> Android devices can only scroll in one direction at a time.
	* @name UI.ScrollView
	* @augments UI.View
	*/
	initialize: function($super, properties) {
		if (ScrollView._init) ScrollView._init();
		this._scrollPosition = [0, 0];
		return $super(properties);
	},
	
	/**
	 * @private
	 */    
	updateScrollPosition: function(newVal) {
		this._scrollPosition = newVal;
	},
	
	/**
	 * @private
	 */    
	performEventCallback: function($super, e) {
		if (e.eventType == 'scroll') this.updateScrollPosition(e.scrollPosition);
		$super(e);
	}
});

// Properties
ScrollView._init = function() {
	delete ScrollView._init;
	if (View._init) View._init();

	/**
	 * @name UI.ScrollView#setContentSize
	 * @description Set the value for the <code>contentSize</code> property. This property defines the size of a scroll area.
	 * @example var dialog = {
	 * 	width: screen.width * sizeRate.width / 100,
	 *	height: screen.height * sizeRate.height / 100
	 * };
	 * ...
	 * this.scrollView.setContentSize([dialog.width, 600]);
	 * @params {Number, Array (Number, String)} Individual components or a component array.
	 * @see UI.ScrollView#getContentSize
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ScrollView#getContentSize
	 * @description Retrieve the value of the <code>contentSize</code> property.
	 * @returns {Number, Array (Number, String)} The current value of <code>contentSize</code>.
	 * @see UI.ScrollView#setContentSize
	 * @function
     * @status iOS, Android, Test
	 */
	ScrollView.synthesizeCompoundProperty('contentSize', Commands.setScrollableSize);
	/**
	 * @name UI.ScrollView#setScrollPosition
	 * @description Set the value for the <code>scrollPosition</code> property.
	 * @example var hscroller = new UI.ScrollView();
	 * ...
	 * hscroller.setScrollPosition([0.5,0]);
	 * @params {Number, Array (Number)} Individual components or a component array.
	 * @see UI.ScrollView#getScrollPosition
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ScrollView#getScrollPosition
	 * @description Retrieve the value of the <code>scrollPosition</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>scrollPosition</code>.
	 * @see UI.ScrollView#setScrollPosition
	 * @function
     * @status iOS, Android, Test
	 */
	ScrollView.synthesizeCompoundProperty('scrollPosition', Commands.setScrollPosition);
	
	/**
	 * @name UI.ScrollView#setScrollIndicatorsVisible
	 * @description Set the value for the <code>scrollIndicatorsVisible</code> property.
	 * @example var hscroller = new UI.ScrollView();
	 * ...
	 * hscroller.setScrollIndicatorsVisible(false);
	 * @params {Boolean} Whether scroll indicators should be visible.
	 * @see UI.ScrollView#getScrollIndicatorsVisible
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ScrollView#getScrollIndicatorsVisible
	 * @description Retrieve the value of the <code>scrollIndicatorsVisible</code> property.
	 * @returns {Boolean} Whether scroll indicators will be visible during scrolling.
	 * @see UI.ScrollView#setScrollIndicatorsVisible
	 * @function
     * @status iOS, Android, Test
	 */
	ScrollView.synthesizeCompoundProperty('scrollIndicatorsVisible', Commands.setScrollIndicatorsVisible);

	/**
	 * @name UI.ScrollView#setOnScroll
	 * @description Set a function to call when the <code>scroll</code> event occurs.
	 * @param {Function} scrollCallback The new callback function.<br><br>
	 * <b>Note:</b> The <code>scroll</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.ScrollView#event:getOnScroll
	 * @event
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ScrollView#getOnScroll
	 * @description Retrieve the function to call when the <code>scroll</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.ScrollView#event:setOnScroll
	 * @event
     * @status iOS, Android, Test
	 */
	ScrollView.registerEventType('scroll');
	
	ScrollView.registerEventType('scrollEnded');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ListView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ListView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ListView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var ScrollView = require('NGCore/Client/UI/ScrollView').ScrollView;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');

var ListView = exports.ListView = ScrollView.subclass(
/** @lends UI.ListView.prototype */
{
	'type':'listview',
	/**
	* @class The <code>ListView</code> class constructs objects that contain <code>{@link UI.ListViewItem}</code> and <code>{@link UI.ListViewSection}</code> objects. 
	* These objects handle and render scrolling lists in an application.
	* A <code>ListView</code> object can contain potentially thousands of items, 
	* in sections, that use a pool of reusable views to display content.
	* @name UI.ListView
	* @augments UI.ScrollView
	*/
	initialize:function($super, properties) {
		if (ListView._init) ListView._init();
		$super(properties);
		
		this._sections = [];
		this._scrollPosition = [0,0];
		this.enableEvent('scroll', true);
		
		this._ownedViews = [];
		this._queuedViews = {};
		
		this._cellDivider = 0;
		
		return this;
	},
	
	destroy: function($super) {
		var l = this._ownedViews.length;
		for (var i = 0; i < l; i++) {
			this._ownedViews[i].release();
		}
		this._ownedViews = null;
		$super();
	},
	
	addChild: function($super, child, index) {
		if (index == "cell") {
			index = this._cellDivider++;
		} else if ((index || -1) >= 0) {
			index += this._cellDivider;
		}
		$super(child, index);
	},
	
	_viewForItem: function(lvItem) {
		if (lvItem._currentView instanceof AbstractView) return lvItem._currentView;
		
		var rID = lvItem._reuseId;
		var queue = this._queuedViews[rID];
		
		var view = null;
		while (queue && queue.length > 0) {
			if ((view = queue.pop()) instanceof AbstractView) break;
		}
		
		if (!(view instanceof AbstractView)) {
			view = lvItem._onCreateView(lvItem);
			if (view instanceof AbstractView) {
				this._ownedViews.push(view.retain());
				this.addChild(view, "cell");
			} else {
				console.log("Error creating view for list item with reuse id " + rID);
			}
		}
	//	console.log("_viewForItem: " + lvItem + " = " + view);
		return view;
	},
	
	_queueViewForItem: function(lvItem) {
		var viewToQueue = lvItem._currentView;
		if (viewToQueue instanceof AbstractView) {
			var rId = lvItem._reuseId;
			var queue = this._queuedViews[rId] || (this._queuedViews[rId] = []);
			queue.push(viewToQueue);
		}
		lvItem._setCurrentView();
	},
	
	_removeQueuedViews: function() {
		for (var q in this._queuedViews) {
			if (!this._queuedViews.hasOwnProperty(q)) continue;
			
			q = this._queuedViews[q];
			for (var i = 0, l = q.length; i < l; i++) {
				q[i].removeFromParent();
			}
		}
		this._cellDivider = 0;
	},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	flushSections: function() {
		for (var i in this._sections) {
			if(!this._sections.hasOwnProperty(i)) { continue; }
				
			var section = this._sections[i];
			// Cause every section to completely queue out its item views.
			section.flush();
			section.calculateItemPositions();
		}
		this._removeQueuedViews();
	},
	
	/**
	 * Clear this <code>ListView</code> and reload all list data.
	 * @see UI.ListViewItem,
	 * @see UI.ListViewSection
 	 * @status Javascript, iOS, Android, Flash
	 */
	reloadData: function() {
		this.flushSections();
		this.calculateSectionPositions();
		this.updateScrollPosition(this._scrollPosition);
	},
	
	/**
	 * Retrieve all contained sections by this <code>ListView</code>.
	 * @returns {Object} The current section list as an array of section IDs.
	 * @see UI.ListView#setSections
 	 * @status Javascript, iOS, Android, Flash
	 */
	getSections: function() {
		return this._sections;
	},
	
	/**
	 * Set the list of sections that this <code>ListView</code> contains.
	 * @example var sections = [];
	 * var section = new UI.ListViewSection;
	 * ...
	 * var items = [];
	 * for(news in News)
	 * {
	 *	var item = new ListItem.ListItem();
	 *	item.game = News[news];
	 *	items.push(item);
	 * }
	 *
	 * section.setItems(items);
	 * sections.push(section);
	 *
	 * gameNews.setSections(sections);
	 * @param {Object} newSections A new aray of section IDs.
	 * @see UI.ListView#getSections
 	 * @status Javascript, iOS, Android, Flash
	 */
	setSections: function(newSections) {
		this.flushSections();
		for (var i in this._sections) {
			if(this._sections.hasOwnProperty(i)) {
				this._sections[i].setListView(null);
			}
		}
		this._sections = newSections;
		var idArray = new Array();
		for (var i in newSections) {
			if(newSections.hasOwnProperty(i)) {
				idArray.push(0+(newSections[i].__objectRegistryId || 0));
			}
		}
		UI.Commands.setSections.call(this, idArray);
		this.reloadData();
	},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	calculateSectionPositions: function() {
		this._stackedSections = {};
		topY = 0;
		// Should account for header here.
		var l = this._sections.length;
		for (var i = 0; i < l; i++) {
		//	NgLogD("Calculating height for Section " + i + " / " + l + " from yPos " + topY);
			var section = this._sections[i];
			this._stackedSections[topY] = section;
			section.setListView(this);
			section.setYPosition(topY);
			var relTopY = this._scrollPosition[1/*y*/] - topY;
			section.updateVisibleRange(relTopY, relTopY + this._frame[3/*h*/]);
			var h = section._measureHeight();
			// Set the section's frame...
			section._setFrame(0, topY, this._frame[2], h);
			topY += h;
		}
		// Should account for footer here.
		this.setContentSize([this._frame[2], topY]);
	},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	updateScrollPosition:function(newVal) {
		if (this._scrollPosition[1] === newVal[1]) return;
		this._scrollPosition = newVal;
		
		var myHeight = this._frame[3];
		for (var yPos in this._stackedSections) {
			if(this._stackedSections.hasOwnProperty(yPos)) {
				var section = this._stackedSections[yPos];
				relTopY = newVal[1] - yPos;
				section.updateVisibleRange(relTopY, relTopY + myHeight);
			}
		}
	},
	
	/**
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	'_onScroll': function() {},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	enableEvent: function($super, eventName, enable) {
		// Don't allow scrolling events to be turned off!
		if ( (eventName == 'scroll') && !enable ) return;
		$super(eventName, enable);
	}
});

ListView._init = function() {
	delete ListView._init;
	if (ScrollView._init) ScrollView._init();

	/**
	 * @name UI.ListView#setHeader
	 * @description Set the value for the <code>header</code> property. This string is used as a header for the <code>ListView</code>.
	 * @example var friendHeader = mew UI.ListView();
	 * ...
	 * friendHeader.setHeader('Friends List');
	 * @param {String} header The new header.
	 * @see UI.ListView#getHeader
	 * @function
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.ListView#getHeader
	 * @description Retrieve the value of the <code>header</code> property.
	 * @returns {String} The current header.
	 * @see UI.ListView#setHeader
	 * @function
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	ListView.synthesizeProperty('header');
	/**
	 * @name UI.ListView#setFooter
	 * @description Set the value for the <code>footer</code> property. This string is used as a footer for the <code>ListView</code>.
	 * @example var friendFooter = mew UI.ListView();
	 * ...
	 * friendHeader.setHeader('This is a footer');
	 * @param {String} footer The new footer.
	 * @see UI.ListView#getFooter
	 * @function
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.ListView#getFooter
	 * @description Retrieve the value of the <code>footer</code> property.
	 * @returns {String} The current footer.
	 * @see UI.ListView#setFooter
	 * @function
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	ListView.synthesizeProperty('footer');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ListViewSection'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ListViewSection'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ListViewSection'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var ListViewItem = require('NGCore/Client/UI/ListViewItem').ListViewItem;

/* This class does not have a physical view representation.
	We still fully map and register it so that sections can be persisted independently of tables. */

var ListViewSection = exports.ListViewSection = Element.subclass(
/** @lends UI.ListViewSection.prototype */
{
	'type':'listview-section',
	/**
	* @class The <code>ListViewSection</code> class constructs objects that contain <code>ListViewItem</code> objects. 
	* These objects are rendered as individual sections of a scrolling list (see <code>{@link UI.ListView}</code>).
	* @name UI.ListViewSection
	* @augments UI.Element
	*/
	initialize:function($super, properties) {
		if (ListViewSection._init) ListViewSection._init();
		
		this._visibleRange = [0,0];
		this._headerHeight = 0;
		this._titleHeight = 0;
		
		delete this._measuredHeight;
		this._needsLayout = false;
		
		$super(properties);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	addItemToVisible: function(lvItem, index) {
		if (!(lvItem instanceof ListViewItem)) return;
		if (lvItem._currentView instanceof Element) return;
		
		var useView = this._listView._viewForItem(lvItem);
		var w = this._listView.getFrame()[2];
		
		if (this._rowHeight > 0) {
			useView.setFrame(0, this._yPosition + this._titleHeight + index * this._rowHeight, w, this._rowHeight);
		} else {
			useView.setFrame(0, this._yPosition + this._cellPositions[index], w, lvItem._height);
		}
		
		lvItem._setCurrentView(useView);
		if (!useView.getParent()) this._listView.addChild(useView, "cell");
	},
	
	_setFrame: function(l, t, w, h) {
		UI.Commands.setFrame.call(this, l, t, w, h);
		if (this._titleView) {
			var f = this._titleView.getFrame();
			this._titleView.setFrame(l, t, w, f[3]);
		}
	},
	
	/**
	 * Reset the visible range for this <code>ListViewSection</code>.
	 * @function
	 * @status Javascript, iOS, Android, Flash
	 */
	flush: function() {
		for (var i = this._visibleRange[0], l = this._visibleRange[1]; i < l; i++) {
			this._listView._queueViewForItem(this._items[i]);
		}
		this._visibleRange = [0,0];
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	updateVisibleRange: function(topY, bottomY) {
		var totalH = this._getMeasuredHeight();
		
		// Expand the view window. This is really only necessary for Android...
		var l = this._items.length;
		var rowH = this._rowHeight > 0 ? this._rowHeight : totalH / l;
		topY -= rowH * 5;
		bottomY += rowH * 5;
		
		var oldStartIndex = this._visibleRange[0];
		var oldEndIndex = this._visibleRange[1];
		var startIndex = l > 0 ? Math.max(0, Math.floor(topY / rowH)) : 0;
		var endIndex = l > 0 ? Math.min(l, startIndex + Math.floor((bottomY - topY) / rowH)) : 0;
		
		if (this._cellPositions) {
			// We should have a good guess into the array from the above code,
			// so now it just needs to be adjusted until accurate.
			while (startIndex < l && this._cellPositions[startIndex] < topY) startIndex++;
			while (startIndex > 0 && this._cellPositions[startIndex] > topY) startIndex--;
			if (startIndex >= l) startIndex = Math.max(0, l - 1);
			
			while (endIndex < l && this._cellPositions[endIndex] < bottomY) endIndex++;
			while (endIndex > startIndex && this._cellPositions[endIndex] > bottomY) endIndex--;
		
			topY = this._cellPositions[startIndex];
			// EndIndex is one past the last element...
			bottomY = endIndex == 0 ? topY : (this._cellPositions[endIndex-1] + this._items[endIndex-1]._height );
		}
		if (bottomY < 0 || topY > totalH) {
			for (var i = this._visibleRange[0]; i < this._visibleRange[1]; i++) {
				this._listView._queueViewForItem(this._items[i]);
			}
			this._visibleRange = [0,0];
			return;
		}
		
		if (oldStartIndex == startIndex && oldEndIndex == endIndex) return;
		
//		NgLogD("(" + oldStartIndex + "," + oldEndIndex + ") -> (" + startIndex + "," + endIndex + ")");
		
		if (oldStartIndex == oldEndIndex) {
			for (var i = startIndex; i < endIndex; i++) {
				this.addItemToVisible(this._items[i], i);
			}
		} else {
			// Dequeue and requeue from both ends.
			if (oldStartIndex < startIndex) {
				do {
					this._listView._queueViewForItem(this._items[oldStartIndex]);
				} while (++oldStartIndex < startIndex);
			}
			if (oldEndIndex > endIndex) {
				while (oldEndIndex-- > endIndex) {
					this._listView._queueViewForItem(this._items[oldEndIndex]);
				}
				oldEndIndex = endIndex;	// Keep later codepath from triggering
			}
		
			if (oldStartIndex > startIndex) {
				while (oldStartIndex-- > startIndex) {
					this.addItemToVisible(this._items[oldStartIndex], oldStartIndex);
				}
				oldStartIndex = startIndex;
			} 
			if (oldEndIndex < endIndex) {
				do {
					this.addItemToVisible(this._items[oldEndIndex], oldEndIndex);
				} while (++oldEndIndex < endIndex)
			}
		
		}
		this._visibleRange = [startIndex, endIndex];
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	setListView : function(listView) {
		this._listView = listView;
		delete this._measuredHeight;
		return this;
	},
	
	_getMeasuredHeight : function() {
		return this._measuredHeight || this._measureHeight();
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	_measureHeight : function() {
		// Sum the heights of the rows.  No variable-heights yet!!!
		if (this._rowHeight < 0) {
			// Variable Height Trigger
			var totalHeight = this._titleHeight + this._headerHeight;
			var runningHeights = [];
			var l = this._items.length;
			for (var i = 0; i < l; i++) {
				runningHeights.push(totalHeight);
				totalHeight += this._items[i]._height;
			}
			this._cellPositions = runningHeights;
			return this._measuredHeight = totalHeight;
		}
		
		delete this._cellPositions;
		return this._measuredHeight = this._titleHeight + this._headerHeight + this._rowHeight * this._items.length;
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	calculateItemPositions: function() {
		// Not used?.
	},
});

ListViewSection._init = function() {
	delete ListViewSection._init;
	if (Element._init) Element._init();

	// We don't have a set pattern for sending the id of a view we want to assign by reference...
	/**
	 * @name UI.ListViewSection#setTitleView
	 * @description 
	 * @function
	 * @see UI.ListViewSection#getTitleView
 	 * @status Javascript, iOS, Android, Flash
	 */
	var boundTitleFunction = function() {
		if (this.listViewMonitor) this.listViewMonitor.setTitleView(this);
		boundTitleFunction._superfunc.apply(this, Array.prototype.slice.call(arguments));
	};
	var setTitleView = function(titleView) {
		if (this._titleView && this._titleView.listViewMonitor == this) {
			delete this._titleView.listViewMonitor;
		}
		this._titleView = titleView;
		
		if (!(titleView.listViewMonitor == this)) {
			titleView.listViewMonitor = this;
			if (!boundTitleFunction._superfunc) {
				boundTitleFunction._superfunc = titleView.setFrame;
			}
			if (titleView.setFrame != boundTitleFunction) {
				titleView.registerAccessors('frame', null, boundTitleFunction);
			}
		}
		
		this._titleHeight = titleView.getFrame()[3];
		delete this._measuredHeight;
		Commands.setTitleView.call(this, ObjectRegistry.objectToId(titleView));
		return this;
	}
	/**
	 * @name UI.ListViewSection#getTitleView
	 * @description 
	 * @function
	 * @see UI.ListViewSection#setTitleView
 	 * @status Javascript, iOS, Android, Flash
	 */
	var getTitleView = function() {
		return this._titleView;
	}
	/**
	 * @name UI.ListViewSection#setTitle
	 * @description Set the value for the <code>title</code> property.
	 * @param {String} title The new section title.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.ListViewSection#getTitle
	 * @function
	 */
	/**
	 * @name UI.ListViewSection#getTitle
	 * @description Retrieve the value of the <code>title</code> property.
	 * @returns {String} The current section title.
	 * @see UI.ListViewSection#setTitle
	 * @function
	 */
	ListViewSection.registerAccessors('titleView', getTitleView, setTitleView);
	
	// Other properties
	/**
	 * @name UI.ListViewSection#setRowHeight
	 * @description Set the value for the <code>rowHeight</code> property.
	 * @param {Number} rowHeight The new row height.
	 * @see UI.ListViewSection#getRowHeight
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.ListViewSection#getRowHeight
	 * @description Retrieve the value of the <code>rowHeight</code> property.
	 * @returns {Number} The current row height.
	 * @see UI.ListViewSection#setRowHeight
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	ListViewSection.synthesizeProperty('rowHeight');
	/**
	 * @name UI.ListViewSection#setItems
	 * @description Set the value for the <code>items</code> property.
	 * Setting this updates the visual state of the <code>listView</code> if the section is in a <code>listView</code> that is visible.
	 * @param {UI.ListViewItem} items The new <code>ListView</code> items.
	 * @see UI.ListViewSection#getItems
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	var setItems = function(newItems) {
		newItems = (newItems instanceof Array) ? newItems : Array.prototype.slice.call(arguments);
		
		this.flush();
		this._items = newItems;
		
		if (!this._listView) return;
		this._listView.reloadData();
		delete this._measuredHeight;
	}
	/**
	 * @name UI.ListViewSection#getItems
	 * @description Retrieve the value of the <code>items</code> property.
	 * @returns {UI.ListViewItem} The current <code>ListView</code> items.
	 * @see UI.ListViewSection#setItems
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	var getItems = function() {
		return this._items;
	}
	ListViewSection.registerAccessors('items', getItems, setItems);
	/**
	 * @name UI.ListViewSection#setYPosition
	 * @description Set the value for the <code>yPosition</code> property.
	 * @param {Number} yPosition The new position for <i>y</i>.
	 * @see UI.ListViewSection#getYPosition
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.ListViewSection#getYPosition
	 * @description Retrieve the value of the <code>yPosition</code> property.
	 * @returns {Number} The current position of <i>y</i>.
	 * @see UI.ListViewSection#setYPosition
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	ListViewSection.synthesizeProperty('yPosition');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ListViewItem'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ListViewItem'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ListViewItem'] = exports; /* This class does not have a physical view representation, and is just a holder for closures / a bag for data...
	We still fully map and register it so that sections can be persisted independently of tables. */
var Class = require('NGCore/Client/Core/Class').Class;

var ListViewItem = exports.ListViewItem = Class.subclass(
/** @lends UI.ListViewItem.prototype */
{	/**
	* @class The <code>ListViewItem</code> class constructs objects that contain data for individual items in a scrolling list (see <code>{@link UI.ListView}</code>).
	* @name UI.ListViewItem
	* @constructs The default constructor.
	* @augments Core.Class
	*/
	
	'type':'listview-item',
	
	_reuseId: "__default__",
	/** @protected */
	_currentView: null,
	
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	_onCreateView: function() {},
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	_onReleaseView: function(oldView) {},
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	_onSetView: function(newView) {},
	
	/**
	 * Set the callback for the <code>onCreateView</code> event. 
	 * This event must return a newly created view that displays the data type represented by the item.
	 * @param {Function} newFn The new function to call.
	 * @event
	 */
	setOnCreateView: function(newFn)	{this._onCreateView = newFn},
	/**
	 * Set the callback for the <code>onReleaseView</code> event. This event occurs when the view is set to <code>null</code>. 
	 * Use this to remove uncommon view states or clean up the view when necessary.
	 * @param {Function} newFn The new function to call.
	 * @event
	 */
	setOnReleaseView: function(newFn)	{this._onReleaseView = newFn},
	/**
	 * Set the callback for the <code>onSetView</code> event. When this event occurs, the item puts any relevant visual state / data into <code>newView</code>.
	 * This transfer should occur before the item is visible to the user:
	 * <pre class="code">onSetView(newView)</pre>
	 * @param {Function} newFn The new function to call.
	 * @event
	 */
	setOnSetView: function(newFn)		{this._onSetView = newFn},
	
	/**
	 * Set the height of the current ListViewItem in pixels.
	 * <pre class="code">setHeight(Number)</pre>
	 * This should occur before the item is visible to the user.
	 * This setting is only used when the item's ListViewSection has height = -1
	 * @param {Function} newFn The new function to call.
	 */
	setHeight: function(h) {
		this._height = h;
	},
	
	/**
	 * Get the current height of the ListViewItem.
	 * <pre class="code">getHeight()</pre>
	 * This should occur before the item is visible to the user.
	 * @returns {Number} The height of this ListViewItem.
	 */
	getHeight: function() {
		return this._height;
	},
	
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	_setCurrentView: function(newView) {
		if (newView instanceof Class) {
			this._onSetView(newView);
		} else {
			this._onReleaseView(this._currentView);
		}
		this._currentView = newView;
		return this;
	},
	
	/**
 	 * Retrieve the current view attached to this <code>ListViewItem</code>.
	 * @returns {UI.View} The current <code>ListViewItem</code> view.
	 * @status Javascript, iOS, Android, Flash
	 */
	getCurrentView: function(){
		return this._currentView;
	},
		
	initialize: function(reuseId) {
		if (reuseId) this._reuseId = reuseId;
		return this;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/CellView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/CellView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/CellView'] = exports; var View = require('NGCore/Client/UI/View').View;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var CellView = exports.CellView = View.subclass(
/** @lends UI.CellView.prototype */
{
	'type':'cell',
	/**
	* @class The <code>CellView</code> class constructs objects that handle cell views in an application. For example, a cell in a scrolling list.
	* These objects are rendered with images on the left and right, and two text areas (title and text) stacked vertically in the middle.
	* @name UI.CellView
	* @augments UI.AbstractView
	*/
	initialize: function($super, properties) {
		if (CellView._init) CellView._init();
		$super(properties);
	}
});

// Properties
CellView._init = function() {
	delete CellView._init;
	if (View._init) View._init();
	
	/**
	 * @name UI.CellView#setImage
	 * @description Set the value of the <code>image</code> property for a view state. This defines how a cell view appears for specific conditions. For example,
	 * set different images for a cell view in the default state and when the cell view has focus.
	 * @example background.setImage('./Content/blank.png', [w, h], [0, 0]);
	 * @param {String} image The new <code>image</code> URL.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CellView#getImage
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.CellView#getImage
	 * @description Retrieve the value of the <code>image</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current <code>image</code> URL.
	 * @see UI.CellView#setImage
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	CellView.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.CellView#setImageBorder
	 * @description Set the value of the <code>imageBorder</code> property for a view state. This property defines a border for images used in the specified view state.
	 * @param {Object} imageBorder The new value for <code>imageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CellView#getImageBorder
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.CellView#getImageBorder
	 * @description Retrieve the value of the <code>imageBorder</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current value of <code>imageBorder</code>.
	 * @see UI.CellView#setImageBorder
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	CellView.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	/**
	 * @name UI.CellView#setImageInsets
	 * @description Set the value of the <code>imageInsets</code> property. This property defines the viewable area of an image when applying gravity.
	 * @example background.setImageInsets([10,10,10,10]);
	 * @param {Number, Array (Number)} imageInsets The new value for <code>imageInsets</code>. Set as insets or an array of insets (float).
	 * @see UI.CellView#getImageInsets
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#getImageInsets
	 * @description Retrieve the value of the <code>imageInsets</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>imageInsets</code>.
	 * @see UI.CellView#setImageInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	CellView.synthesizeCompoundProperty('imageInsets', Commands.setImageInsets);
	/**
	 * @name UI.CellView#setImageFit
	 * @description Set the value of the <code>imageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example background.setImageFit(UI.FitMode.None);
	 * @param {Number} imageFit The new value for <code>imageFit</code>.
	 * @see UI.CellView#getImageFit
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#getImageFit
	 * @description Retrieve the value of the <code>imageFit</code> property.
	 * @returns {Number} The current value of <code>imageFit</code>.
	 * @see UI.CellView#setImageFit
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	CellView.synthesizeProperty('imageFit', Commands.setImageFitMode);
	/**
	 * @name UI.CellView#setImageGravity
	 * @description Set the value of the <code>imageGravity</code> property. This property defines how an image is positioned within a viewable area.
	 * @example background.setImageGravity([0.5, 0.0]);
	 * @param {Number} imageGravity The new value for <code>imageGravity</code> (expressed as two floats).
	 * @see UI.CellView#getImageGravity
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.CellView#getImageGravity
	 * @description Retrieve the value of the <code>imageGravity</code> property.
	 * @returns {Number} The current value of <code>imageGravity</code> (expressed as two floats).
	 * @see UI.CellView#setImageGravity
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	CellView.synthesizeProperty('imageGravity', Commands.setImageGravity);
	 /**
	 * @name UI.CellView#setImageTransform
	 * @description Set the value of the <code>imageTransform</code> property. This property defines data compression for images used with a cell view.
	 * @example background.setImageTransform([Math.cos(angle), Math.sin(angle), Math.sin(angle), Math.cos(angle), 0, 0]);
	 * @param {Array (Number)} imageTransform The new value for <code>imageTransform</code>. Set as an array of floats (<i>a</i>, <i>b</i>, <i>c</i>, <i>d</i>, <i>tx</i>, <i>ty</i>).
	 * @see UI.CellView#getImageTransform
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#getImageTransform
	 * @description Retrieve the value of the <code>imageTransform</code> property.
	 * @returns {Array (Number)} The current value of <code>imageTransform</code>.
	 * @see UI.CellView#setImageTransform
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	 CellView.synthesizeCompoundProperty('imageTransform', Commands.setImageTransform);
	/**
	 * @name UI.CellView#getRightImage
	 * @description Retrieve the value of the <code>rightImage</code> property in the specified view state.
	 * @returns {String} The current value of <code>rightImage</code>.
	 * @function
	 * @see UI.CellView#setRightImage
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setRightImage
	 * @description Set the value of the <code>rightImage</code> property in the specified view state. This defines how images used for UI controls appear for specific conditions. For example, 
	 * use seperate images for a closure arrow in the default state and a closure arrow when expanded.
	 * @example var cellClosure = new UI.CellView()
	 * ...
	 * cellClosure.setRightImage('./Content/closure.png', [w, h], [0, 0]);
	 * @param {String} rightImage The new value for <code>rightImage</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI State.
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getRightImage
	 */
	CellView.synthesizePropertyWithState('rightImage', Commands.setRightImage);
	/**
	 * @name UI.CellView#getRightImageBorder
	 * @description Retrieve the value of the <code>rightImageBorder</code> property in the specified view state. 
	 * @returns {Object} The current value of <code>rightImageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 * @see UI.CellView#setRightImageBorder
	 */
	/**
	 * @name UI.CellView#setRightImageBorder
	 * @description Set the value of the <code>rightImageBorder</code> property in the specified view state. This property defines a border for images used in the specified view state.
	 * @param {Object} rightImageBorder The new value for <code>rightImageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI View state.
 	 * @status iOS, Android, Test
	 * @function
	 * @see UI.CellView#getRightImageBorder
	 */
	CellView.synthesizePropertyWithState('rightImageBorder', Commands.setRightImageBorder);
	/**
	 * @name UI.CellView#getRightImageInsets
	 * @description Retrieve the value of the <code>rightImageInsets</code> property.
	 * @returns {Array (Number)} The current value of <code>rightImageInsets</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @see UI.CellView#setRightImageInsets
	 */
	/**
	 * @name UI.CellView#setRightImageInsets
	 * @description Set the value of the <code>rightImageInsets</code> property. This property defines the viewable area of an image when applying gravity.
	 * @example closureIcon.setRightImageInsets([10,10,10,10]);
	 * @param {Array (Number)} rightImageInsets The new value for <code>rightImageInsets</code>. Set as floats (<i>t</i>, <i>r</i>, <i>b</i>, <i>l</i>).
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getRightImageInsets
	 */
	CellView.synthesizeProperty('rightImageInsets', Commands.setRightImageInsets);
	/**
	 * @name UI.CellView#getRightImageFit
	 * @description Retrieve the value of the <code>rightImageFit</code> property. 
	 * @returns {Number} The current value of <code>rightImageFit</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @see UI.CellView#setRightImageFit
	 */
	/**
	 * @name UI.CellView#setRightImageFit
	 * @description Set the value of the <code>rightImageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example closureIcon = new UI.CellView();
	 * ...
	 * closureIcon.setRightImageFit(UI.FitMode.None);
	 * @param {Number} rightImageFit The new value for <code>rightImageFit</code>.
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getRightImageFit
	 */
	CellView.synthesizeProperty('rightImageFit', Commands.setRightImageFitMode);
	/**
	 * @name UI.CellView#getRightImageGravity
	 * @description Retrieve the value of the <code>rightImageGravity</code> property. 
	 * @returns {Number} The current value of <code>rightImageGravity</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @see UI.CellView#setRightImageGravity
	 */
	/**
	 * @name UI.CellView#setRightImageGravity
	 * @description Set the value of the <code>rightImageGravity</code> property. This property defines how a image for a control is positioned within a viewable area.
	 * @example var closureIcon = new UI.CellView();
	 * ...
	 * closureIcon.setRightImageGravity([0.5, 0.0]);
	 * @param {Number} rightImageGravity The new value for <code>rightImageGravity</code>. Set as two floats (<i>x</i>, <i>y</i>).
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getRightImageGravity
	 */
	CellView.synthesizeProperty('rightImageGravity', Commands.setRightImageGravity);
	/**
	 * @name UI.CellView#getRightImageTransform
	 * @description Retrieve the value of the <code>rightImageTransform</code> property.
	 * @returns {Array (Number)} The current value of <code>rightImageTransform</code>.
	 * @see UI.CellView#setRightImageTransform
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	 /**
	 * @name UI.CellView#setRightImageTransform
	 * @description Set the value of the <code>rightImageTransform</code> property. This property defines data compression for images used with right image objects.
	 * @example var closureIcon = new UI.CellView();
	 * ...
	 * closureIcon.setRightImageTransform([Math.cos(angle), Math.sin(angle), Math.sin(angle), Math.cos(angle), 0, 0]);
	 * @param {Array (Number)} rightImageTransform The new value for <code>rightImageTransform</code>. 
	 * Set as six floats (<i>a</i>, <i>b</i>, <i>c</i>, <i>d</i>, <i>tx</i>, <i>ty</i>).
	 * @see UI.CellView#getRightImageTransform
 	 * @status iOS, Android, Test
	 * @function
	 */
	 CellView.synthesizeCompoundProperty('rightImageTransform', Commands.setRightImageTransform);
	 
	/**
	 * @name UI.CellView#getTitle
	 * @description Retrieve the value of the <code>title</code> property in a view state.
	 * @returns {String} The current value of <code>title</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 * @see UI.CellView#setTitle
	 */
	/**
	 * @name UI.CellView#setTitle
	 * @description Set the value of the <code>title</code> property for a view state. This property defines the title string for a view in the specified view state.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitle('Game of Foo');
	 * @param {String} title The new value for <code>title</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getTitle
	 * @function
	 */
	CellView.synthesizePropertyWithState('title', Commands.setTitle);
	/**
	 * @name UI.CellView#getTitleColor
	 * @description Retrieve the value of the <code>titleColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>titleColor</code>.
	 * @see UI.CellView#setTitleColor
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#setTitleColor
	 * @description Set the value of the <code>titleColor</code> property for a view state. This property defines the title string color for the <code>CellView</code> object in the specified view state.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleColor(0,0,1);
	 * @param {String} titleColor The new value for <code>titleColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CellView#getTitleColor
	 * @function 
 	 * @status iOS, Android, Test
	 */
	CellView.synthesizePropertyWithState('titleColor', Commands.setTitleColor);
	/**
	 * @name UI.CellView#getTitleFont	 
	 * @description Retrieve the value of the <code>titleFont</code> property in a view state. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>titleFont</code>.
	 * @function
	 * @see UI.CellView#setTitleFont
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleFont
	 * @description Set the value of the <code>titleFont</code> property in a view state. This property defines the title string font for cell view labels in the specified view state.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleFont('Content/Cacophony.ttf');
	 * @param {String} titleFont The new value for <code>titleFont</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @function
	 * @see UI.CellView#getTitleFont
 	 * @status iOS, Android, Test
	 */
	CellView.synthesizePropertyWithState('titleFont', Commands.setTitleFont);
	/**
	 * @name UI.CellView#getTitleShadow
	 * @description Retrieve the value of the <code>titleShadow</code> property in a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>titleShadow</code>.
	 * @see UI.CellView#setTitleShadow
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleShadow
	 * @description Set the value of the <code>titleShadow</code> property in a view state. This property defines the amount of text shadowing used for title strings in a cell view.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleShadow('FFCCCCFF 2.0 {0,0}');
	 * @param {String} titleShadow The new value for <code>titleShadow</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getTitleShadow
	 * @function
	 */
	CellView.synthesizePropertyWithState('titleShadow', Commands.setTitleShadow);

	/**
	 * @name UI.CellView#getTitleGravity
	 * @description Retrieve the value of the <code>titleGravity</code> property. 
	 * @returns {Array (Number)} The current value of <code>titleGravity</code>.
	 * @see UI.CellView#setTitleGravity
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleGravity
	 * @description Set the value of the <code>titleGravity</code> property. This property defines how a title string is positioned within a viewable area.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleGravity([0.5, 0.0]);	 
	 * @param {Array (Number)} titleGravity The new value for <code>titleGravity</code>. Set as two floats (<i>x</i>, <i>y</i>).
	 * @see UI.CellView#getTitleGravity
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizeCompoundProperty('titleGravity', Commands.setTitleGravity);

	/**
	 * @name UI.CellView#getTitleSize
	 * @description Retrieve the value of the <code>titleSize</code> property.
	 * @returns {Number} The current value of <code>titleSize</code>.
	 * @see UI.CellView#setTitleSize
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleSize
	 * @description Set the value of the <code>titleSize</code> property. This property defines the text size of title strings in the specified view state.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleSize(32);
	 * @param {Number} titleSize The new value for <code>titleSize</code>. Set as two floats (<i>x</i>, <i>y</i>).	
	 * @function
	 * @see UI.CellView#getTitleSize
 	 * @status iOS, Android, Test
	 */
	CellView.synthesizeProperty('titleSize', Commands.setTitleSize);
	/**
	 * @name UI.CellView#getTitleInsets
	 * @description Retrieve the value of the <code>titleInsets</code> property.	 
	 * @returns {Array (Number)} The current value of <code>titleInsets</code>.
	 * @function
	 * @see UI.CellView#setTitleInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleInsets
	 * @description Set the value of the <code>titleInsets</code> property. This property defines the viewable area of a title string when applying gravity.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleInsets([10,10,10,10]);	 
	 * @param {Array (Number)} titleInsets The new value for <code>titleInsets</code>. Set as four floats (<i>t</i>, <i>r</i>, <i>b</i>, <i>l</i>).
	 * @function
	 * @see UI.CellView#getTitleInsets
 	 * @status iOS, Android, Test
	 */
	CellView.synthesizeCompoundProperty('titleInsets', Commands.setTitleInsets);
	
	/**
	 * @name UI.CellView#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code>..
	 * @see UI.CellView#setText
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use in the specified view state.
	 * @example var cellView = new UI.CellView();
	 * ...
	 * cellView.setText(this.game.description);
	 * @see UI.CellView#getText
	 * @param {String} text The new value for <code>text</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizePropertyWithState('text', Commands.setText);
	/**
	 * @name UI.CellView#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textColor</code>.
	 * @see UI.CellView#setTextColor
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string in the specified view state.
	 * @example var cellText = new UI.CellView();
	 * ...
	 * cellText.setTextColor('FFFF');
	 * @see UI.CellView#getTextColor
	 * @param {String} textColor The new value for <code>textColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function 
	 */
	CellView.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.CellView#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code>.
	 * @see UI.CellView#setTextShadow	
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of text shadowing used on text strings in this view.
	 * @example var cellText = new UI.CellView();
	 * ...
	 * cellText.setTextShadow('FFCCCCFF 2.0 {0,0}');
	 * @see UI.CellView#getTextShadow
	 * @param {String} textShadow The new value for <code>textShadow</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	/**
	 * @name UI.CellView#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>textFont</code> in the specified view state.
	 * @see UI.CellView#setTextFont
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with labels for a cell view.
	 * @example var cellText = new UI.CellView()
	 * ...
	 * cellText.setTextFont('Content/Cacophony.ttf');
	 * @param {String} textFont The new value for <code>textFont</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CellView#getTextFont
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizePropertyWithState('textFont', Commands.setTextFont);
	
	/**
	 * @name UI.CellView#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @see UI.CellView#setTextGravity
	 */
	/**
	 * @name UI.CellView#setTextGravity	 
	 * @description Set the value of the <code>textGravity</code> property. This property defines how a text string is positioned within a viewable area.
	 * @example var cellText = new UI.CellView()
	 * ...
	 * cellText.setTextGravity([0.5, 0.0]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as individual components or a component array (<i>x</i>, <i>y</i>).
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getTextGravity
	 */
	CellView.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);

	/**
	 * @name UI.CellView#getTextSize
	 * @description Retrieve the value of the <code>textSize</code> property.
	 * @returns {Number} The current value for <code>textSize</code>.
	 * @see UI.CellView#setTextSize
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#setTextSize
	 * @description Set the value of the <code>textSize</code> property. This property defines the size of text strings for a view.
	 * @example var cellText = new UI.CellView()
	 * ...
	 * cellText.setTextSize(18);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.CellView#getTextSize
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.CellView#getTextInsets
	 * @description Retrieve the value of the <code>textInsets</code> property.
	 * @returns {Array (Number)} The curent value for <code>textInsets</code>.
	 * @see UI.CellView#setTextInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#setTextInsets
	 * @description Set the value of the <code>textInsets</code> property. This property defines the viewable area of a text string when applying gravity.
	 * @example var cellText = new UI.CellView()
	 * ...
	 * cellText.setTextInsets([10,10,10,10]);
	 * @param {Array (Number)} textInsets The new value for <code>textInsets</code>.
	 * @see UI.CellView#getTextInsets
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
		//** extra-deprecated */
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing CellView." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			CellView.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('text');
	bindStateProperties('textColor');
	bindStateProperties('textShadow');
	bindStateProperties('textFont');
	bindStateProperties('title');
	bindStateProperties('titleColor');
	bindStateProperties('titleFont');
	bindStateProperties('titleShadow');
	bindStateProperties('gradient');
	bindStateProperties('image');
	bindStateProperties('imageBorder');
	bindStateProperties('rightImage');
	bindStateProperties('rightImageBorder');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/CheckBox'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/CheckBox'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/CheckBox'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var WindowR = require('NGCore/Client/UI/Window');

var gradients = {
	'normal': {
		"gradient": ["FFED 0.000", "FFA4 1.000"],
		"insets": "{4.0,4.0,4.0,4.0}",
		"outerLine": "FF51 2.0",
		"outerShadow": "0000 0.0 {0.0,0.0}",
		"corners": "3.0 3.0 3.0 3.0"
	},
	'pressed': {
		"innerShadow": "FF00 6.0 {0.0,-1.0}",
		"gradient": ["FF80 0.000", "FF80 1.000"],
		"insets": "{4.0,4.0,4.0,4.0}",
		"outerLine": "FF51 2.0",
		"outerShadow": "0000 0.0 {0.0,0.0}",
		"corners": "3.0 3.0 3.0 3.0"
	},
	'checked': {"innerLine":"FF27A227 2.0","corners":"3.0 3.0 3.0 3.0","insets":"{4.0,4.0,4.0,4.0}","gradient":["FF2CFF2B 0.000","FF179117 1.000"],"outerShadow":"0000 0.0 {0.0,0.0}","outerLine":"FF51 3.0","innerShadow":"FF97FE97 1.0 {0.0,0.0}"},
	'checkedpressed': {"innerShadow":"FF0F610F 5.0 {0.0,-1.0}","gradient":["FF179117 0.000","FF179117 1.000"],"insets":"{4.0,4.0,4.0,4.0}","outerLine":"FF2B512B 3.0","outerShadow":"0000 0.0 {0.0,0.0}","corners":"3.0 3.0 3.0 3.0"},
	'disabled': {
		"innerShadow": "0000 0.0 {0.0,0.0}",
		"gradient": ["66B6 0.000", "66CA 1.000"],
		"insets": "{4.0,4.0,4.0,4.0}",
		"outerLine": "7FE0 3.0",
		"outerShadow": "0000 0.0 {0.0,0.0}",
		"corners": "3.0 3.0 3.0 3.0"
	},
};

var CheckBox = exports.CheckBox = AbstractView.subclass(
/** @lends UI.CheckBox.prototype */
{
	'type':'checkbox',

    /**
     * @class The <code>CheckBox</code> class constructs objects that handle the state of application checkboxes.
     * @constructs The default constructor. 
     * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
     * @param {String} properties Object properties.
     * @augments UI.AbstractView
     */
    initialize: function($super, properties) {
		if (CheckBox._init) CheckBox._init();
        this._checked = false;
        $super();
		this.setGradient(gradients['normal'], Commands.State.Normal);
		this.setGradient(gradients['pressed'], Commands.State.Pressed);
		this.setGradient(gradients['checked'], Commands.State.Checked);
		this.setGradient(gradients['checkedpressed'], Commands.State.Checked | Commands.State.Pressed);
		this.setGradient(gradients['disabled'], Commands.State.Disabled);
		this.setImageInsets([4,4,4,4]);
		this.setAttributes(properties);
    },
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
    performEventCallback: function($super, event) {
		if (event.eventType == 'click') {
        	this._checked = event.checked;
			if (this._checked) {
				this._state = this._state | Commands.State.Checked;
			} else {
				this._state = this._state & ~Commands.State.Checked;
			}
		}
		$super(event);
    }
});

CheckBox._init = function() {
	delete CheckBox._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * @name UI.CheckBox#getImage
	 * @description Retrieve the <code>image</code> URL for a view state. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current image URL for the specified view state.
	 * @see UI.CheckBox#setImage
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setImage
	 * @description Set an image URL for a view state. This defines how a checkbox appears for specific conditions. For example,
	 * set different images for a checkbox in the default state and when the checkbox is checked.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setImage('./Content/checkbox.png', [w, h], [0, 0]);
	 * @see UI.CheckBox#getImage
	 * @param {String} imageURL The new image URL.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status iOS, Android, Test
	 * @function 
	 */
	CheckBox.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.CheckBox#getImageInsets
	 * @description Retrieve the value of the <code>imageInsets</code> property (expressed as floats).
	 * @returns {Number, Array (Number)} The current value of <code>imageInsets</code>.
	 * @see UI.CheckBox#setImageInsets
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setImageInsets
	 * @description Set the value of the <code>imageInsets</code> property. This property defines the viewable area of an image when applying gravity.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setImageInset([10,10,10,10]);
	 * @param {Number, Array (Number)} imageInsets The new value for <code>imageInsets</code>. Set as insets or an array of insets (expressed as floats).
	 * @see UI.CheckBox#getImageInsets
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizeCompoundProperty('imageInsets', Commands.setImageInsets);
	
	/**
	 * @name UI.CheckBox#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code> in the specified view state.
	 * @see UI.CheckBox#setText
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use as a label for a 
	 * checkbox in the specified view state.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setText("Yes");
	 * @see UI.CheckBox#getText
	 * @param {String} text The new value for <code>text</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizePropertyWithState('text', Commands.setText);
	/**
	 * @name UI.CheckBox#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textColor</code> in the specified view state.
	 * @see UI.CheckBox#setTextColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string used as a label for a 
	 * checkbox in different view states.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextColor('FFFFFF');
	 * @see UI.CheckBox#getTextColor
	 * @param {String} textColor The new value for <code>textColor</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status iOS, Android, Test
	 * @function 
	 */
	CheckBox.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.CheckBox#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code> in the specified view state.
	 * @see UI.CheckBox#setTextShadow	
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of shadowing used on text strings for a checkbox in different view states.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextShadow("FF00 2.0 {0,-1}");
	 * @see UI.CheckBox#getTextShadow
	 * @param {String} textShadow The new value for <code>textShadow</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	/**
	 * @name UI.CheckBox#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property (expressed as floats).
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @see UI.CheckBox#setTextGravity
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property. This property defines how a text string is positioned within a viewable area.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextGravity([0.1, 0.5]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as individual components or a single array of components (expressed as floats).
	 * @see UI.CheckBox#getTextGravity
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);

	/**
	 * @name UI.CheckBox#getTextSize
	 * @description Retrieve the value of the <code>textSize</code> property.
	 * @returns {Number} The current value for <code>textSize</code>.
	 * @see UI.CheckBox#setTextSize
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextSize
	 * @description Set the value of the <code>textSize</code> property. This property defines the text size of labels for a checkbox.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextSize(18);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.CheckBox#getTextSize
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.CheckBox#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>textFont</code> in the specified view state.
	 * @see UI.CheckBox#setTextFont
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with labels for a checkbox in different view states.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextFont(myFont);
	 * @param {String} textFont The new value for <code>textFont</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CheckBox#getTextFont
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizePropertyWithState('textFont', Commands.setTextFont);
	/**
	 * @name UI.CheckBox#getTextInsets
	 * @description Retrieve the value of the <code>textInsets</code> property.
	 * @returns {Array (Number)} The curent value for <code>textInsets</code>.
	 * @see UI.CheckBox#setTextInsets
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextInsets
	 * @description Set the value of the <code>textInsets</code> property. This property defines the viewable area of a text string when applying gravity.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextInsets(0, 0, 0, 64);
	 * @param {Array (Number)} textInsets The new value for <code>textInsets</code>.
	 * @see UI.CheckBox#getTextInsets
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
	
	// Corresponding event is onClick
	/**
	 * @name UI.CheckBox#getChecked
	 * @description Retrieve whether this <code>CheckBox</code> is currently "checked".
	 * @returns {Boolean} Returns <code>true</code> if this <code>CheckBox</code> is currently "checked".
	 * @see UI.CheckBox#setChecked
	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setChecked
	 * @description Set whether this <code>CheckBox</code> is "checked".
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setChecked(true);
	 * @param {Boolean} checked Set as <code>true</code> if this <code>CheckBox</code> is "checked".
	 * @see UI.CheckBox#getChecked
	 * @status iOS, Android
	 * @function 
	 */
	CheckBox.synthesizeProperty('checked', Commands.setChecked);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
		'checked': Commands.State.Checked,
	};

	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			CheckBox.registerAccessors(thisStatePropName, getterFn, setterFn, 
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};

	bindStateProperties('text');
	bindStateProperties('textColor');
    bindStateProperties('textFont');
	bindStateProperties('textShadow');
	bindStateProperties('gradient');
	bindStateProperties('image');
    bindStateProperties('imageBorder');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/EditText'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/EditText'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/EditText'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var EditText = exports.EditText = AbstractView.subclass(
/** @lends UI.EditText.prototype */
{
	'type':'edittext',
	/**
	* @class The <code>EditText</code> class is a base class for derived classes that handle text-editing functions.
	* Derived classes from <code>EditText</code> include:
	* <div class="ul">
	 * <li>{@link UI.DateField}</li>
	 * </div>
	* @name UI.EditText
	* @augments UI.AbstractView
	*/
	initialize: function($super, properties) {
		if (EditText._init) EditText._init();
		$super(properties);
	},
	
	
	'InputTypes': Commands.InputType,
	'EnterKeyTypes': Commands.EnterKeyType,
	
	
	performEventCallback: function($super, event) {
		try {
			switch (event.eventType) {
				case 'change':
					this._text = event.text;
					// Fallthrough
				default: $super(event);
			}
		} catch(e) {
			NgHandleException(e);
		}
	},
	
	// Adapt API to the single-state model for "text" on editable text.
	/**
	 * Retrieve the value of the <code>text</code> property.
	 * @returns {String} The current value of <code>text</code>.
	 * @see UI.EditText#setText
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */	
	getText: function() {
		return this._text || "";
	},
	
	/**
	 * Set the value of the <code>text</code> property. This property defines a text string to use in arbitrary fashion.
	 * @example var someText = new UI.EditText();
	 * ...
	 * someText.setText("Pow!");
	 * @param {String} text The new value for <code>text</code>.
	 * @see UI.EditText#getText
	 * @status Javascript, iOS, Android, Test
	 * @function
	 */
	setText: function(text) {
		this._text = text;
		Commands.setText.call(this, 0, text);
	},

	setFocus: function(focus) {
		Commands.setFocus.call(this, focus);
	}
});

EditText._init = function() {
	delete EditText._init;
	if (AbstractView._init) AbstractView._init();
	
	// ==== Content
	// API defines state for the text property, but we ONLY support one state for this control.
	
	EditText.registerAccessors('text', EditText.prototype.getText, EditText.prototype.setText);
	
	/**
	 * @name UI.EditText#getPlaceholder
	 * @description Retrieve the value of the <code>placeholderText</code> property.
	 * @returns {String} The current value of <code>placeholder</code>.
	 * @see UI.EditText#setPlaceholder
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setPlaceholder
	 * @description Set the value of the <code>placeholderText</code> property. This property defines a text string to use as a placeholder for fields that require text input.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setPlaceholder("This is a placeholder");
	 * @param {String} placeholder The new value for <code>placeholder</code>.
	 * @see UI.EditText#getPlaceholder
	 * @function
	 */
	EditText.synthesizeProperty('placeholder', Commands.setPlaceholderText);
	/**
	 * @name UI.EditText#getPlaceholderColor
	 * @description Retrieve the value of the <code>placeholderTestColor</code> property. 
	 * @see UI.EditText#setPlaceholderColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */	
	/**
	 * @name UI.EditText#setPlaceholderColor
	 * @description Set the value of the <code>placeholderTestColor</code> property. This property defines the color of the placeholder text string.
	 * @returns {String} The current value of <code>placeholderTextColor</code>.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setPlaceholderColor('FFFFFF');
	 * @param {String} placeholderColor The new value for <code>placeholderTestColor</code>.
	 * @see UI.EditText#getPlaceholderColor
	 * @function
	 */
	EditText.synthesizeProperty('placeholderColor', Commands.setPlaceholderTextColor);
	/**
	 * @name UI.EditText#getPlaceholderShadow
	 * @description Retrieve the value of the <code>placeholderTestShadow</code> property.
	 * @returns {String} The current value of <code>placeholderTestShadow</code>.
	 * @see UI.EditText#setPlaceholderShadow
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setPlaceholderShadow
	 * @description Set the value of the <code>placeholderTestShadow</code> property.  This property defines the amount of shawdow applied to the placeholder text string.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setPlaceholderShadow("FF00 2.0 {0,-1}");
	 * @param {String} placeholderShadow The new value for <code>placeholderTestShadow</code>.
	 * @see UI.EditText#getPlaceholderShadow
	 * @function
	 */
	 EditText.synthesizeProperty('placeholderShadow', Commands.setPlaceholderTextShadow);
	
	// ==== Behavior
	/**
	 * @name UI.EditText#getInputType
	 * @description Retrieve the value of the <code>inputType</code> property.
	 * @returns {Number} The current value of <code>inputType</code>.
	 * @see UI.EditText#setInputType
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setInputType
	 * @description Set the value of the <code>inputType</code> property.
	 * @param {Number} inputType The new value for <code>inputType</code>.
	 * @see UI.EditText#getInputType
	 * @function
	 */	
	 EditText.synthesizeProperty('inputType', Commands.setInputType);
	/**
	 * @name UI.EditText#getEnterKeyType
	 * @description Retrieve the value of the <code>enterKeyType</code> property.
	 * @returns {Number} The current value of <code>enterKeyType</code>.
	 * @see UI.EditText#setEnterKeyType
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setEnterKeyType
	 * @description Set the value of the <code>enterKeyType</code> property.
	 * @param {Number} enterKeyType The new value for <code>enterKeyType</code>.
	 * @see UI.EditText#getEnterKeyType
	 * @function
	 */
	EditText.synthesizeProperty('enterKeyType', Commands.setEnterKeyType);
	
	// ==== Appearance
	/**
	 * @name UI.EditText#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} textColor The current value of <code>textColor</code>.
	 * @see UI.EditText#setTextColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string in the specified view state.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextColor('FFFFFF');
	 * @param {String} textColor The new value for <code>textColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.EditText#getTextColor
	 * @status iOS, Test
	 * @function
	 */
	EditText.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.EditText#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code>.
	 * @see UI.EditText#setTextShadow
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of text shadowing used on text strings in this view.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextShadow("FF00 2.0 {0,-1}");
	 * @param {String} textShadow The new value for <code>textShadow</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.EditText#getTextShadow
	 * @status iOS, Test
	 * @function
	 */
	EditText.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	
	/**
	 * @name UI.EditText#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property for this <code>EditText</code>.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @see UI.EditText#setTextGravity
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property for this <code>EditText</code>. This property defines how a text string is positioned within a viewable area.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextGravity([0.1, 0.5]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as a float or an array.
	 * @see UI.EditText#getTextGravity
	 * @function
	 */
	EditText.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);
	/**
	 * @name UI.EditText#getTextSize
	 * @description Retrieve the value of the <code>teztSize</code> property for this <code>EditText</code>.
	 * @returns {Number} The current value of <code>textSize</code>.
	 * @see UI.EditText#setTextSize
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextSize
	 * @description Set the value of the <code>textSize</code> property for this <code>EditText</code>. This property defines the size of text strings for a view.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextSize(18);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.EditText#getTextSize
	 * @status iOS, Test
	 * @function
	 */
	EditText.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.EditText#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property for this <code>EditText</code>.
	 * @returns {String} The current value of <code>textFont</code>.
	 * @see UI.EditText#setTextFont
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with text strings in a view.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextFont(myFont);
	 * @param {String} textFont The new value for <code>textFont</code>.
	 * @see UI.EditText#getTextFont
	 * @status iOS, Test
	 * @function
	 */
	EditText.synthesizePropertyWithState('textFont', Commands.setTextFont);
	
	// ==== Events
	/**
	 * @name UI.EditText#getOnChange
	 * @description Retrieve the function to call when the <code>change</code> event occurs.
	 * @returns {Function} The current <code>change</code> callback function.
	 * @see UI.EditText#event:setOnChange
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditText#setOnChange
	 * @description Set a function to call when the <code>change</code> event occurs.
	 * @param {Function} changeCallback The new <code>change</code> callback function. <br><br><b>Note:</b> The <code>change</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example EditText.setOnChange( function(event) { 
	 * 	console.log(event.text) 
	 *	} 
	 * );
	 * @see UI.EditText#event:getOnChange
	 * @status iOS
	 * @event
	 */
	EditText.registerEventType('change');
	/**
	 * @name UI.EditText#getOnFocus 
	 * @description Retrieve the function to call when the <code>focus</code> event occurs.
	 * @returns {Function} The current <code>focus</code> callback function.
	 * @see UI.EditText#event:setOnFocus
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event	 
	 */
	/**
	 * @name UI.EditText#setOnFocus
	 * @description Set a function to call when the <code>focus</code> event occurs.
	 * @param {Function} focusCallback The new <code>focus</code> callback function. <br><br><b>Note:</b> The <code>focus</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example EditText.setOnFocus( function(event) { 
	 * 	console.log(event.text) 
	 *	} 
	 * );
	 * @see UI.EditText#event:getOnFocus
	 * @event
	 */
	EditText.registerEventType('focus');
	/**
	 * @name UI.EditText#getOnBlur
	 * @description Retrieve the function to call when the <code>blur</code> event occurs.
	 * @returns {Function} The current <code>blur</code> callback function.
	 * @see UI.EditText#event:setOnBlur
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditText#setOnBlur
	 * @description Set a function to call when the <code>blur</code> event occurs.
	 * @note WARNING! This event is not guaranteed to occur on Android devices. Developers must not rely on this event occurring.
	 * @param {Function} blurCallback The new <code>blur</code> callback function.<br><br><b>Note:</b> The <code>blur</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example EditText.setOnBlur( function(event) { 
	 * 	console.log(event.text) 
	 *	} 
	 * );
	 * @see UI.EditText#event:getOnBlur
	 * @event
	 */
	EditText.registerEventType('blur');

	/**
	 * @name UI.EditText#getOnAction
	 * @description Retrieve the function to call when the <code>action</code> event occurs.
	 * @returns {Function} The current <code>action</code> callback function.
	 * @see UI.EditText#event:setOnAction
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditText#setOnAction
	 * @description Set a function to call when a keyboard key corresponding to executing an action is pressed.
	 * Available since 1.1.6
	 * @note WARNING! Soft keyboards on Android devices are not required to offer actions. Developers must not rely on this event occurring.
	 * @param {Function} actionCallback The new <code>action</code> callback function.<br><br><b>Note:</b> The <code>action</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.EditText#event:getOnAction
	 * @event
	 */
	EditText.registerEventType('action');

	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			};
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			};
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			EditText.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		};
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('textColor');
	bindStateProperties('textShadow');
	bindStateProperties('gradient');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/EditTextArea'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/EditTextArea'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/EditTextArea'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var EditTextArea = exports.EditTextArea = AbstractView.subclass(
/** @lends UI.EditTextArea.prototype */
{
	'type':'edittextarea',
	/**
	* @class The <code>EditTextArea</code> class is multiline text-editing area.
	* @name UI.EditTextArea
	* @augments UI.AbstractView
	*/
	initialize: function($super, properties) {
		if (EditTextArea._init) EditTextArea._init();
		$super(properties);
	},
	
	
	performEventCallback: function($super, event) {
		try {
			switch (event.eventType) {
				case 'change':
					this._text = event.text;
					$super(event);
					break;
				case 'focus':
				case 'blur':
					$super(event);
					break;
			}
		} catch(e) {
			NgHandleException(e);
		}
	},
	
	// Adapt API to the single-state model for "text" on editable text.
	/**
	 * Retrieve the value of the <code>text</code> property.
	 * @returns {String} The current value of <code>text</code>.
	 * @see UI.EditTextArea#setText
	 * @status Javascript, iOS
	 * @function
	 */	
	getText: function() {
		return this._text || "";
	},
	
	/**
	 * Set the value of the <code>text</code> property.
	 * @param {String} text The new value for <code>text</code>.
	 * @see UI.EditTextArea#getText
	 * @status Javascript, iOS
	 * @function
	 */
	setText: function(text) {
		this._text = text;
		Commands.setText.call(this, 0, text);
	},

	setFocus: function(focus) {
		Commands.setFocus.call(this, focus);
	}
});

EditTextArea._init = function() {
	delete EditTextArea._init;
	if (AbstractView._init) AbstractView._init();
	
	// ==== Content
	// API defines state for the text property, but we ONLY support one state for this control.
	
	EditTextArea.registerAccessors('text', EditTextArea.prototype.getText, EditTextArea.prototype.setText);
	
	/**
	 * @name UI.EditTextArea#getPlaceholder
	 * @description Retrieve the value of the <code>placeholder</code> property.
	 * @returns {String} The current value of <code>placeholder</code>.<br>
	 * @see UI.EditTextArea#setPlaceholder
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setPlaceholder
	 * @description Set the value of the <code>placeholder</code> property.
	 * @param {String} placeholder The new value for <code>placeholder</code>.
	 * @see UI.EditTextArea#getPlaceholder
	 * @function
	 */
	EditTextArea.synthesizeProperty('placeholder', Commands.setPlaceholderText);
	/**
	 * @name UI.EditTextArea#getPlaceholderColor
	 * @description Retrieve the value of the <code>placeholder color</code> property.
	 * @returns {String} The current value of <code>placeholder color</code>.<br>
	 * @see UI.EditTextArea#setPlaceholderColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */	
	/**
	 * @name UI.EditTextArea#setPlaceholderColor
	 * @description Set the value of the <code>placeholder color</code> property.
	 * @param {String} placeholderColor The new value for <code>placeholder color</code>.
	 * @see UI.EditTextArea#getPlaceholderColor
	 * @function
	 */
	EditTextArea.synthesizeProperty('placeholderColor', Commands.setPlaceholderTextColor);
	/**
	 * @name UI.EditTextArea#getPlaceholderShadow
	 * @description Retrieve the value of the <code>placeholder shadow</code> property.
	 * @returns {String} The current value of <code>placeholder shadow</code>.<br>
	 * @see UI.EditTextArea#setPlaceholderShadow
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setPlaceholderShadow
	 * @description Set the value of the <code>placeholder shadow</code> property.
	 * @param {String} placeholderShadow The new value for <code>placeholder shadow</code>.
	 * @see UI.EditTextArea#getPlaceholderShadow
	 * @function
	 */
	 EditTextArea.synthesizeProperty('placeholderShadow', Commands.setPlaceholderTextShadow);
	
	
	// ==== Appearance
	/**
	 * @name UI.EditTextArea#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} textColor The current value of <code>textColor</code>.<br>
	 * @see UI.EditTextArea#setTextColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state.
	 * @param {String} textColor The new value for <code>textColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.EditTextArea#getTextColor
	 * @status iOS, Test
	 * @function
	 */
	EditTextArea.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.EditTextArea#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code>.<br>
	 * @see UI.EditTextArea#setTextShadow
	 * @private not working on iOS
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state.
	 * @param {String} textShadow The new value for <code>textShadow</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.EditTextArea#getTextShadow
	 * @private not working on iOS
	 * @status iOS, Test
	 * @function
	 */
	EditTextArea.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	
	/**
	 * @name UI.EditTextArea#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property for this <code>EditTextArea</code>.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.<br>
	 * @see UI.EditTextArea#setTextGravity
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property for this <code>EditTextArea</code>.
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as a float or an array.
	 * @see UI.EditTextArea#getTextGravity
	 * @function
	 */
	EditTextArea.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);
	/**
	 * @name UI.EditTextArea#getTextSize
	 * @description Retrieve the value of the <code>teztSize</code> property for this <code>EditTextArea</code>.
	 * @returns {Number} The current value of <code>textSize</code>.<br>
	 * @see UI.EditTextArea#setTextSize
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextSize
	 * @description Set the value of the <code>textSize</code> property for this <code>EditTextArea</code>.
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.EditTextArea#getTextSize
	 * @status iOS, Test
	 * @function
	 */
	EditTextArea.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.EditTextArea#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property for this <code>EditTextArea</code>.
	 * @returns {String} The current value of <code>textFont</code>.<br>
	 * @see UI.EditTextArea#setTextFont
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextFont
	 * @description Set the value of the <code>textFont</code> property for this <code>EditTextArea</code>.
	 * @param {String} textFont The new value for <code>textFont</code>.
	 * @see UI.EditTextArea#getTextFont
	 * @status iOS, Test
	 * @function
	 */
	EditTextArea.synthesizePropertyWithState('textFont', Commands.setTextFont);
	
	// ==== Events
	/**
	 * @name UI.EditTextArea#getOnChange
	 * @description Retrieve the function to call when the <code>change</code> event occurs.
	 * @returns {Function} The current <code>change</code> callback function.
	 * @see UI.EditTextArea#event:setOnChange
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditTextArea#setOnChange
	 * @description Set a function to call when the <code>change</code> event occurs.
	 * @param {Function} changeCallback The new <code>change</code> callback function. <br><br><b>Note:</b> The <code>change</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.EditTextArea#event:getOnChange
	 * @status iOS
	 * @event
	 */
	EditTextArea.registerEventType('change');
	/**
	 * @name UI.EditTextArea#getOnFocus 
	 * @description Retrieve the function to call when the <code>focus</code> event occurs.
	 * @returns {Function} The current <code>focus</code> callback function.
	 * @see UI.EditTextArea#event:setOnFocus
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event	 
	 */
	/**
	 * @name UI.EditTextArea#setOnFocus
	 * @description Set a function to call when the <code>focus</code> event occurs.
	 * @param {Function} focusCallback The new <code>focus</code> callback function. <br><br><b>Note:</b> The <code>focus</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.EditTextArea#event:getOnFocus
	 * @event
	 */
	EditTextArea.registerEventType('focus');
	/**
	 * @name UI.EditTextArea#getOnBlur
	 * @description Retrieve the function to call when the <code>blur</code> event occurs.
	 * @returns {Function} The current <code>blur</code> callback function.
	 * @see UI.EditTextArea#event:setOnBlur
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditTextArea#setOnBlur
	 * @description Set a function to call when the <code>blur</code> event occurs.
	 * @param {Function} blurCallback The new <code>blur</code> callback function.<br><br><b>Note:</b> The <code>blur</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.EditTextArea#event:getOnBlur
	 * @event
	 */
	EditTextArea.registerEventType('blur');
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			};
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			};
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			EditTextArea.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		};
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('textColor');
	bindStateProperties('textShadow');
	bindStateProperties('gradient');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/DateField'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/DateField'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/DateField'] = exports; var EditText = require('NGCore/Client/UI/EditText').EditText;

function isValidDate(d) {
	if ( !d.getTime )
		return false; 
		
	return !isNaN(d.getTime());
}

/*
 Date Parser code to handle WebKit's lack of following the implementation.
 http://stackoverflow.com/questions/3085937/safari-js-cannot-parse-yyyy-mm-dd-date-format/3085993#3085993
 */
function parseDate(input, format) {
  format = format || 'yyyy-mm-dd'; // default format
  var parts = input.match(/(\d+)/g), 
      i = 0, fmt = {};
  // extract date-part indexes from the format
  format.replace(/(yyyy|dd|mm)/g, function(part) { fmt[part] = i++; });

  return new Date(parts[fmt['yyyy']], parts[fmt['mm']]-1, parts[fmt['dd']]);
}
/*
 * Our Code is not actually passing its format to parseDate (already had all the code to rejigger the date pieces to yyyy-mm-dd before I realized the problems with webkit's date constructor / date string parser). -fbartho 2010-11-30
 */

exports.DateField = EditText.subclass(
/** @lends UI.DateField.prototype */
{
	/**
	 * @class The <code>DateField</code> class constructs objects that handle data returned by date functions.
	 * @constructs The default constructor. 
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} properties
	 * @augments UI.EditText
	 */
	initialize: function($super, properties) {
		var constructorRVal = $super(properties);
		this.setDateFormat("yyyy-mm-dd");
		this.ondatechange = function(newDate){};
		
		this.setInputType(EditText.InputTypes.Date);
		return constructorRVal;
	},
    
	/**
	 * Trigger an event callback for this <code>DateField</code>.
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} event The event that triggers a callback function.
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	performEventCallback: function($super, event) {
		try {
			if (event.eventType == 'change') {
				// Make Sure the Text is changed (call $super), before we call our listeners!
				var oldText = this.getText();
				$super(event);
				this.ondatechange(this.getDate());
			}
		} catch(e) {
			NgHandleException(e);
		}
	},
	_filterAndInsertDashes:function(oldText,newText) {
		var t = newText;
		if((oldText.length == t.length + 1) && oldText[oldText.length-1] == "-") {
			//This lets the user backspace through - marks as if they weren't there.
			// fbartho: Currently not in use! 2010-12-10
			//this.setText(t.substring(0,t.length-1));
			return t.substring(0,t.length-1);
		}
		
		var nt = "";
		var j = 0;
		for(var i = 0; i < t.length && nt.length < this.formatStr.length; i++,j++) {
			if(j < this.formatStr.length && this.formatStr[j] == "-" && i < t.length){
				if(t[i] == "-"|| t[i] == "/"){
					nt+="-";
					continue;
				}
				else {
					nt+="-";
					nt+=t[i];
					continue;
				}
			}
			if ( i < t.length && (t[i] == "-" || t[i] == "/") ) {
				--j; 
				continue;
			}
			nt+=t[i];
		}
		
		if(this.formatStr.length > j && (this.formatStr[j] == "-" || this.formatStr[j] == "/") ) {
			nt+="-";
		}
		
		return nt;
	},
	/**
	 * Format a date parsed from this <code>DateField</code> into a human-readable string.
	 * @status Javascript, iOS, Android, Flash, Test
	 */    
	normalizeDateLayout:function() {
		var ot = this.getText();
		var nt = this._filterAndInsertDashes(this.getText(),this.getText());
		if(ot!=nt)this.setText(nt);
	},
	/**
	 * Retrieve the date format of date strings parsed from this <code>DateField</code>
	 * @returns {String} The current date format.
	 * @see UI.DateField#setDateFormat
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	getDateFormat:function() {
		return this.formatStr;
	},
	/**
	 * Set the date format for date strings parsed from this <code>DateField</code>.
	 * @param {String} dateFormat The new date format.
	 * @see UI.DateField#getDateFormat
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	setDateFormat:function(fStr) 
	{
		if (   fStr != "yyyy-mm-dd"
			&& fStr != "mm-yyyy"
			&& fStr != "yyyy-mm"
			&& fStr != "mm-dd-yyyy"
			&& fStr != "dd-mm-yyyy" ) {
			// Invalid Format String Error Case
			NgLogD("Error: Invalid Format String set for Birthdate Field!!\n");
			
			return;
		}
		
		this.formatStr = fStr;
		this.setPlaceholder(this.formatStr);
		return;
	},
	/**
	 * Retrieve a date string parsed from this <code>DateField</code>.
	 * @returns {String} The current date.
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	getDate:function() {
		return this._dateFromText(this._filterAndInsertDashes(this.getText(),this.getText()));
	}, 
	_dateFromText:function(text) 
	{
		var tmp = null;
		var t = text;
		var bits = null;
		var b2 = null;
		if ( this.formatStr == "dd-mm-yyyy" ) {
			bits = t.split("-");
			if(bits.length != 3 || bits[2].length != 4)
				return null;
			
			b2 = [];
			b2.push(bits.pop());
			b2.push(bits.pop());
			b2.push(bits.pop());
			tmp = parseDate(b2.join("-"));
		} else if ( this.formatStr == "mm-yyyy" ) {
			bits = t.split("-");
			if(bits.length != 2 || bits[1].length != 4)
				return null;
			
			b2 = [];
			b2.push(bits.pop());
			b2.push(bits.pop());
			b2.push("01");
			var tStr = b2.join("-");
			
			tmp = parseDate(tStr);
		} else if ( this.formatStr == "yyyy-mm" ) {
			bits = t.split("-");
			if(bits.length != 2 || bits[0].length != 4)
				return null;
			
			tmp = parseDate(t+"-01");
		} else if ( this.formatStr == "mm-dd-yyyy" ) {
			bits = t.split("-");
			if(bits.length != 3 || bits[2].length != 4)
				return null;
			
			b2 = [];
			b2.push(bits.pop());
			b2.push(bits.shift());
			b2.push(bits.shift());
			tmp = parseDate(b2.join("-"));
		} else {
			tmp = parseDate(t);
		}
		
		if(!isValidDate(tmp)) {
			NgLogD("Failed to parse date: "+tmp+"   -  "+tmp.toString()+"\n");
			return null;
		}
		return tmp;
	}
});

//TODO: make a proper DatePicker?
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/AlertDialog'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/AlertDialog'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/AlertDialog'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var AlertDialog = exports.AlertDialog = Element.subclass(
/** @lends UI.AlertDialog.prototype */
{
	'type':'alertdialog',
	/**
	 * @name UI.AlertDialog
	 * @class The <code>AlertDialog</code> class constructs objects that handle alert dialogs in an application.
	 * @augments UI.Element
	 */
	initialize: function($super, properties) {
		if (AlertDialog._init) AlertDialog._init();
		$super(properties);
	},
	
	/** 
	 * Show this dialog.
	 * @function
	 */
	show: Commands.show,
	/** 
	 * Hide this dialog.
	 * @function
	 */
	hide: Commands.hide
});

// Properties
AlertDialog._init = function() {
	delete AlertDialog._init;
	if (Element._init) Element._init();

	/**
	 * @name UI.AlertDialog#setTitle
	 * @description Set the value of the <code>title</code> property for a view state. This property defines the title string for an alert dialog window.
	 * @example var alertDialog = new UI.AlertDialog();
	 * alertDialog.setTitle("Exiting Game..");
	 * @see UI.AlertDialog#getTitle
	 * @param {String} title The new value for <code>title</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android
	 * @function
	 */
	/**
	 * @name UI.AlertDialog#getTitle
	 * @description Retrieve the value of the <code>title</code> property for a view state.
	 * @see UI.AlertDialog#setTitle
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>title</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	AlertDialog.synthesizePropertyWithState('title', Commands.setTitle);
	/**
	 * @name UI.AlertDialog#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string that is on display within an alert dialog window.
	 * @example var alertDialog = new UI.AlertDialog();
	 * ...
	 * alertDialog.setText("Returning to launcher..");
	 * @see UI.AlertDialog#getText
	 * @param {String} text The new value for <code>text</code>
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android
	 * @function
	 */
	/**
	 * @name UI.AlertDialog#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @see UI.AlertDialog#setText
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	AlertDialog.synthesizePropertyWithState('text', Commands.setText);
	// Not a compound property; AlertDialog.getChoices() should return the array of strings.
	/**
	 * @name UI.AlertDialog#setChoices
	 * @description Set the value of the <code>choices</code> property. This property defines any available interface options for the user.
	 * @example var errorAlert = new UI.AlertDialog();
	 * ...
	 * errorAlert.setChoices(["Yes", "No"]);
	 * @see UI.AlertDialog#getChoices
	 * @param {String} choices The new value for <code>choices</code>.
	 * @param {Number} defaultChoice The index of the default choice.
	 * @param {Number} cancelChoice The index of the <code>cancel</code> choice.
 	 * @status iOS, Android
	 * @function
	 */
	/**
	 * @name UI.AlertDialog#getChoices
	 * @description Retrieve the value of the <code>choices</code> property.
	 * @see UI.AlertDialog#setChoices
	 * @returns {Array (String)} The current value of <code>choices</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	AlertDialog.synthesizeProperty('choices', Commands.setChoices);
	
	// Event will contain .choice, which is the index of the option chosen.
	/**
	 * @name UI.AlertDialog#setOnChoice
	 * @description Set a function to call on <code>choice</code> events.	 
	 * @param {Function} choiceCallback The new function to call. <br><br>
	 * <b>Note:</b> The <code>choice</code> event is disabled if the value for this parameter is not a function.
	 * @see UI.AlertDialog#event:getOnChoice
 	 * @status iOS, Android, Test
	 * @event
	 */
	/**
	 * @name UI.AlertDialog#getOnChoice
	 * @description Retrieve the function to call on <code>choice</code> events.
	 * @see UI.AlertDialog#event:setOnChoice
	 * @returns {Function} The current function to call.
	 * @event
	 * @type {Function}
 	 * @status iOS, Android, Test
	 */
	 AlertDialog.registerEventType('choice');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ProgressDialog'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ProgressDialog'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ProgressDialog'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var ProgressDialog = exports.ProgressDialog = Element.subclass(
/** @lends UI.ProgressDialog.prototype */
{
	'type':'progressdialog',

    /**
     * @class The <code>ProgressDialog</code> class constructs objects that handle progress updates from the application.
     * @constructs The default constructor. 
     * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
     * @param {String} properties Object properties.
     * @augments UI.Element
     */
    initialize: function($super, properties) {
		if (ProgressDialog._init) ProgressDialog._init();
        return $super(properties);
    },
	/**
	 * Show this dialog.
	 * @function
     * @status iOS, Android, Test
	 */    
    show: Commands.show,
	/**
	 * Hide this dialog.
	 * @function
     * @status iOS, Android, Test
	 */    
    hide: Commands.hide
});

ProgressDialog._init = function() {
	delete ProgressDialog._init;
	if (Element._init) Element._init();
	
	/**
	 * @name UI.ProgressDialog#setTitle
	 * @description Set the value of the <code>title</code> property for a <code>ProgressDialog</code>. This property defines the title string for a progress dialog in the specified view state.
	 * @example var progDialog = new UI.ProgressDialog();
	 * progDialog.setTitle("Downloading game components...");
	 * @param {String} title The new value for <code>title</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.ProgressDialog#getTitle
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ProgressDialog#getTitle
	 * @description Retrieve the value of the <code>title</code> property for a <code>ProgressDialog</code> in the specified view state. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>title</code>.
	 * @see UI.ProgressDialog#setTitle
	 * @function
     * @status iOS, Android, Test
	 */
	ProgressDialog.synthesizePropertyWithState('title', Commands.setTitle);
	/**
	 * @name UI.ProgressDialog#setText
	 * @description Set the value of the <code>text</code> property for a <code>ProgressDialog</code> in the specified view state. This property defines a text string for a progress dialog in the specified view state.
	 * @example var progDialog = new UI.ProgressDialog();
	 * progDialog.setText("Please wait...");
	 * @param {String} text The new value for <code>text</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.ProgressDialog#getText
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ProgressDialog#getText
	 * @description Retrieve the value of the <code>text</code> property for a <code>ProgressDialog</code> in the specified view state.	 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code>.
	 * @see UI.ProgressDialog#setText
	 * @function
     * @status iOS, Android, Test
	 */
	ProgressDialog.synthesizePropertyWithState('text', Commands.setText);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Toast'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Toast'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Toast'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Toast = exports.Toast = Element.subclass(
/** @lends UI.Toast.prototype */
{	
    'type': 'toast',
    /**
    * @class The <code>Toast</code> class constructs objects that render temporary messages on the device screen.
    * @name UI.Toast
    * @augments UI.View
    */
	initialize: function($super, properties) {
		if (Toast._init) Toast._init();
		$super(properties);
	},
	
	/** 
	 * Show this dialog.
	 * @function
     * @status iOS, Android, Test
	 */
    show: Commands.show
});

Toast._init = function() {
	delete Toast._init;
	if (Element._init) Element._init();

	/**
	 * @name UI.Toast#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use in the specified view state.
	 * @example var tempMessage = new UI.Toast();
	 * tempMessage.setText("Game Over");
	 * @param {String} text The new value for <code>text</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Toast#getText
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Toast#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code>.
	 * @see UI.Toast#setText
	 * @function	 
     * @status iOS, Android, Test
	 */
	Toast.synthesizePropertyWithState('text', Commands.setText);
	/** 
	* @name UI.Toast#setOnDisappear
	* @description Set a function to call when the <code>disappear</code> event occurs. The callback for the event returns 
	* <code>true</code> if the temporary message should disappear. Otherwise, the callback returns <code>false</code>.
	* @param {function} disappearCallback The new callback function.<br><br>
	* <b>Note:</b> The <code>disappear</code> event is disabled if the value of this parameter is not a function.
	* @see UI.Toast#event:getOnDisappear
	* @event
	*/
	/**
	* @name UI.Toast#getOnDisappear
	* @description Retrieve the function to call when the <code>disappear</code> event occurs.
	* @returns {function} The current callback function.
	* @see UI.Toast#event:setOnDisappear
	* @event
	*/
	Toast.registerEventType('disappear');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/AdView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/AdView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/AdView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

/** @private */
var AdView = exports.AdView = AbstractView.subclass(
{
	'type':'adview',

	/**
	 * @class The <code>AdView</code> class constructs objects that handle event callback functions and ad event metadata.
	 * @constructs The default constructor. 
	 * @param $super This parameter is stripped out during execution. Do not supply it.
	 * @param {String} properties
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (AdView._init) AdView._init();
		$super(properties);
		
		this.onappear = this.bind(this._onappear);
		this.ondisappear = this.bind(this._ondisappear);
		this.onclick = this.bind(this._onclick);
	},
	
	/**
	 * An event for signaling when an <code>AdView</code> is on display.
	 * @event
	 */
	onappear: function() {
	 },
	
	/**
	 * An event for signaling when an <code>AdView</code> has been closed.
	 * @event
	 */
	ondisappear: function() { 
	},
	
	/** @protected */
	_onappear: function($super, event) {
		( $super || function(){} )(event);
//		Core.Analytics._getPipe().revenueEvent("ADSHOW",  this.getAdEventMetadata());
        visible = true;
	},
	
	/** @protected */
	_ondisappear: function($super, event) {
		( $super || function(){} )(event);
//		Core.Analytics._getPipe().revenueEvent("ADCLOSE", this.getAdEventMetadata());
        visible = false;
	},
	
	performEventCallback: function($super, event) {
		if (event.eventType == 'click')
		{
//			Core.Analytics._getPipe().revenueEvent("ADCLCK", this.getAdEventMetadata());
			NgLogD("AD WAS CLICKED in AdView wooo!!!!");
			( $super || function(){} )(event);
		}
		if (event.eventType == 'load')
		{
//			Core.Analytics._getPipe().revenueEvent("ADLOAD", this.getAdEventMetadata());
			NgLogD("AD WAS LOADED in AdView wooo!!!!");
			( $super || function(){} )(event);
		}
	},
	/**
	* Pause this <code>AdView</code>.<br><br>
	* <b>Note:</b> If an <code>AdView</code> is already paused, this call does nothing.
	* @see UI.AdView#resumeAds
	* @status Android
	*/
	pauseAds: function() {
		Commands.pauseAds.call(this);
	},
	/**
	* Resume this <code>AdView</code> from a paused state. Setting this will resume the <code>AdView</code> from the current position.
	* @see UI.AdView#resumeAds
	* @status Android
	*/
	resumeAds: function() {
		Commands.resumeAds.call(this);
	},
	/**
	* Set the refresh rate for this <code>AdView</code>. 
	* @param {Number} refreshRate The amount of time each ad is on display (in milliseconds).
	* @status Android
	*/
	setRefreshRate: function(refreshRate) {
		Commands.setAdRefreshRate.call(this, refreshRate);
	},
	/**
	* Set this <code>AdView</code> to automatically play.
	* @status Android
	* @param {Boolean} autoplay Set as <code>true</code> if autoplay is enabled.
	*/
	setAutoplay: function(autoplay) {
		Commands.setAdRefreshRate.call(this, autoplay);
	},
	
	/**
	 * Retrieve event metadata from this <code>AdView</code>. 
	 */
	getAdEventMetadata: function(){
		NgLogD("AD EventMetetData was requested!");
		var AdMeteData = "DefaultAdEventMetaData";
		return AdMeteData;
	}
});

// Event Handlers
AdView._init = function() {
	delete AdView._init;
	if (AbstractView._init) AbstractView._init();

    /**
	 * @name UI.AdView#getActive
	 * @description Retrieve the value of the <code>active</code> property.
	 * @returns {Boolean} Returns <code>true</code> if the <code>AdView</code> object is set to active.
	 * @see UI.AdView#setActive
	 * @status iOS, Android, Flash, Test
	 * @function
	 */
	AdView.synthesizeProperty('active', Commands.setActive);
    
	/**
	 * @name UI.AdView#setOnClick
	 * @description Set a function to call on <code>click</code> events.	 
	 * @param {Function} clickCallback The new <code>click</code> callback function. <br><br>
	 * <b>Note:</b> The <code>click</code> event is disabled if the value for this parameter is not a function.<br>
	 * @see UI.AdView#event:setOnClick
 	 * @status Android, Test
	 * @event
	 */
	/**
	 * @name UI.AdView#getOnClick
	 * @description Retrieve the function to call on <code>click</code> events.<br>
	 * @see UI.AdView#event:getOnClick
	 * @returns {Function} The current <code>click</code> callback function.<br>
 	 * @status Android, Test
	 * @event
	 */
	AdView.registerEventType('click');
	/**
	 * @name UI.AdView#setOnLoad
	 * @description Set a function to call on <code>load</code> events.	 
	 * @param {Function} loadCallback The new <code>load</code> callback function. <br><br>
	 * <b>Note:</b> The <code>load</code> event is disabled if the value for this parameter is not a function.<br>
	 * @see UI.AdView#event:getOnClick
 	 * @status Android, Test
	 * @event
	 */
	/**
	 * @name UI.AdView#getOnLoad
	 * @description Retrieve the function to call on <code>load</code> events.<br>
	 * @see UI.AdView#event:getOnClick
	 * @returns {Function} The current <code>load</code> callback function.<br>
 	 * @status Android, Test
	 * @event
	 */
	AdView.registerEventType('load');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/DocumentView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/DocumentView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/DocumentView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var DocumentView = exports.DocumentView = AbstractView.subclass(
/** @lends UI.DocumentView.prototype */
{
	'type':'documentview',
	/**
	 * @name UI.DocumentView
	 * @class The <code>DocumentView</code> class constructs objects that handle document locations.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (DocumentView._init) DocumentView._init();
		$super(properties);
	}
});

// Properties
DocumentView._init = function() {
	delete DocumentView._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * @name UI.DocumentView#setDocumentURL
	 * @description Set the document URL for this <code>DocumentView</code>.
	 * @param {String} documentURL The new document URL.
	 * @see UI.DocumentView#getDocumentURL
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.DocumentView#getDocumentURL
	 * @description Retrieve the document URL of this <code>DocumentView</code>.
	 * @returns {String} The current document URL.
	 * @see UI.DocumentView#setDocumentURL
	 * @status iOS, Android, Test
	 * @function
	 */
	DocumentView.synthesizeProperty('documentURL', Commands.setSourceDocument);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/CheckoutView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/CheckoutView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/CheckoutView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');
var Commands = require('NGCore/Client/UI/Commands').Commands;

var CheckoutView = exports.CheckoutView = AbstractView.subclass(
/** @lends UI.CheckoutView.prototype */
{
	'type':'checkoutview',
	/**
	 * @name UI.CheckoutView
	 * @class The <code>CheckoutView</code> class constructs objects that handle and manage information associated with <code>POST</code> methods in an application.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (CheckoutView._init) CheckoutView._init();
		$super(properties);
	}
});

// Properties
CheckoutView._init = function() {
	delete CheckoutView._init;
	if (AbstractView._init) AbstractView._init();
	
	// THESE ARE METHODS NOT PROPERTIES... THIS SHOULD BE FIXED.
	// We define ONLY setters, and no getters (write-only props, no local copies)
	/**
	 * @name UI.CheckoutView#setPostData
	 * @description Set the value returned by the <code>postData()</code> method of this <code>CheckoutView</code>.
	 * @param {String} postData The new value for <code>postData</code>.
	 * @see UI.CheckoutView#getPostData
	 * @status Android
	 * @function
	 */
	/**
	 * @name UI.CheckoutView#getPostData
	 * @description Retrieve the value returned by the <code>postData()</code> method of this <code>CheckoutView</code>.
	 * @returns {String} The current value of <code>postData</code>.
	 * @see UI.CheckoutView#setPostData
	 * @status Android
	 * @function
	 */
	CheckoutView.registerAccessors('postData', null, Commands.setPostData);
	/**
	 * @name UI.CheckoutView#setPostURL
	 * @description Set the value returned by the <code>postURL()</code> method of this <code>CheckoutView</code>.
	 * @param {String} postURL The new value for <code>postURL</code>.
	 * @see UI.CheckoutView#getPostURL
	 * @status Android
	 * @function
	 */
	/**
	 * @name UI.CheckoutView#getPostURL
	 * @description Retrieve the value returned by the <code>postURL()</code> method of this <code>CheckoutView</code>.
	 * @returns {String} The current value of <code>postURL</code>.
	 * @see UI.CheckoutView#setPostURL
	 * @status Android
	 * @function
	 */
	CheckoutView.registerAccessors('postURL', null, Commands.loadPostURL);
	/**
	 * @name UI.CheckoutView#setGetURL
	 * @description Set the value returned by the <code>getURL()</code> method of this <code>CheckoutView</code>.
	 * @param {String} getURL The new value for <code>getURL</code>.
	 * @see UI.CheckoutView#getGetURL
	 * @status Android
	 * @function
	 */
	/**
	 * @name UI.CheckoutView#getGetURL
	 * @description Retrieve the value returned by the <code>getURL()</code> method of this <code>CheckoutView</code>.
	 * @returns {String} The current value for <code>getURL</code>.
	 * @see UI.CheckoutView#setGetURL
	 * @status Android
	 * @function
	 */
	CheckoutView.registerAccessors('getURL', null, Commands.loadGetURL);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Spinner'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Spinner'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Spinner'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Spinner = exports.Spinner = AbstractView.subclass(
/** @lends UI.Spinner.prototype */
{
	'type':'spinner',
	
	/**
	* @class The <code>Spinner</code> class constructs objects that handle menu spinners in a user interface. 
	* @name UI.Spinner
	* @augments UI.AbstractView
	*/
	initialize: function($super, properties) {
		if (Spinner._init) Spinner._init();
		return $super(properties);
	}
});

Spinner._init = function() {
	delete Spinner._init;
	if (AbstractView._init) AbstractView._init();
	
	Spinner.synthesizeProperty('darkStyle', Commands.setDarkStyle);
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ProgressBar'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ProgressBar'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ProgressBar'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var WindowR = require('NGCore/Client/UI/Window');

var ProgressBar = exports.ProgressBar = AbstractView.subclass(
/** @lends UI.ProgressBar.prototype */
{
	'type':'progressbar',

    /**
     * @class <code>ProgressBar</code> constructs a horizontal bar that gives a finite indication of progress.
     * @constructs The default constructor. 
     * @param $super This parameter is stripped out during execution. Do not supply it.
     * @param {String} properties
     * @augments UI.AbstractView
     */
    initialize: function($super, properties) {
		if (ProgressBar._init) ProgressBar._init();
        return $super(properties);
    },

	useForUpdateProgress: Commands.useForUpdateProgress,
});

ProgressBar._init = function() {
	delete ProgressBar._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * @name UI.ProgressBar#getProgressGradient
	 * @description Retrieve the <code>progressGradient</code> for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current progressGradient for the specified view state.<br>
	 * @see UI.ProgressBar#setProgressGradient
	 * @status Javascript, Android
	 * @function
	 */
	/**
	 * @name UI.ProgressBar#setProgressGradient
	 * @description Set a progressGradient for a view state.
	 * @see UI.ProgressBar#getProgressGradient
	 * @param {Object} progressGradientURL The new progressGradient.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status Android
	 * @function 
	 */
	ProgressBar.synthesizePropertyWithState('progressGradient', Commands.setProgressGradient);
	/**
	 * @name UI.SecondaryBar#getSecondaryGradient
	 * @description Retrieve the <code>secondaryGradient</code> for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current secondaryGradient for the specified view state.<br>
	 * @see UI.SecondaryBar#setSecondaryGradient
	 * @status Javascript, Android
	 * @function
	 */
	/**
	 * @name UI.SecondaryBar#setSecondaryGradient
	 * @description Set a secondaryGradient for a view state.
	 * @see UI.SecondaryBar#getSecondaryGradient
	 * @param {Object} secondaryGradientURL The new secondaryGradient.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status Android
	 * @function 
	 */
	ProgressBar.synthesizePropertyWithState('secondaryGradient', Commands.setSecondaryGradient);
	
	/**
	 * @name UI.ProgressBar#getProgress
	 * @description Retrieve the value of the <code>progress</code> properties.
	 * @returns {Array} The current values of <code>progress</code> and <code>secondaryProgress</code>.<br>
	 * @see UI.ProgressBar#setProgress
	 * @status Javascript, Android
	 * @function
	 */
	/**
	 * @name UI.ProgressBar#setProgress
	 * @description Set the values of the <code>progress</code> properties.
	 * @see UI.ProgressBar#getProgress
	 * @param {Number} progress The new value for <code>progress</code>, as a decimal Number between 0.0 and 1.0.
	 * @param {Number} secondaryProgress The new value for <code>secondaryProgress</code>, as a decimal Number between 0.0 and 1.0.
	 * @status Javascript, Android
	 * @function
	 */
	var setProgressGuarded = function(arg0) {
		var args = (arg0 instanceof Array) ? arg0 : Array.prototype.slice.call(arguments);
		while (args.length < 2) args.push(0);
		Commands.setProgress.apply(this, args);
	}
	ProgressBar.synthesizeCompoundProperty('progress', setProgressGuarded);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
	};

	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			ProgressBar.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};

	bindStateProperties('progressGradient');
	bindStateProperties('secondaryGradient');
	bindStateProperties('gradient');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/MapView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/MapView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/MapView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var MapAnnotation = require('NGCore/Client/UI/MapAnnotation').MapAnnotation;

var MapView = exports.MapView = AbstractView.subclass(
/** @lends UI.MapView.prototype */
{
	'type':'mapview',
	/**
	* @class <code>MapView</code>
	* @name UI.MapView
	* @augments UI.View
	*/
	initialize: function($super, properties) {
		this._annotations = [];
		this._region = [];
		return $super(properties);
	},
	
	getCenterCoordinate: function()
	{
		return [this._region[0], this._region[1]];
	},
    
    setCenterCoordinate: function(lat, lon, animated)
    {
        this._region[0] = lat;
        this._region[1] = lon;
        if (!this._region[2])
            this._region[2] = 0.05;
        if (!this._region[3])
            this._region[3] = 0.05;            
        this.setRegion(this._region[0], this._region[1], this._region[2], this._region[3], animated);
    },
	
	getCoordinateSpan: function()
	{
		return [this._region[2], this._region[3]];
	},	
	
	selectAnnotation: function(annotation)
	{
		if (annotation instanceof MapAnnotation) {
			var index = this._annotations.indexOf(annotation);
			if (index != -1) {
				Commands.selectAnnotation.call(this, annotation.__objectRegistryId);
				return;
			}
		}
		Commands.selectAnnotation.call(this, -1);
	},
	
	addAnnotation: function(annotation)
	{
		if (annotation instanceof MapAnnotation) {
			this._annotations.push(annotation);
			
			Commands.addAnnotation.call(this, annotation.__objectRegistryId);
			
		} else throw {message: this.type + ".addAnnotation: " + annotation + " is not a MapAnnotation!"};
		return this;
	},
	
	removeAnnotation: function(annotation)
	{
		if (annotation instanceof MapAnnotation) {
			// Remove this node from parent's child list
			var index = this._annotations.indexOf(annotation);
			if (index != -1) {
				this._annotations.splice(index, 1);
			}
			
			// Remove from the parent at the system level
			Commands.removeAnnotation.call(this, annotation.__objectRegistryId);
		} else throw {message: this.type + ".removeAnnotation: " + annotation + " is not a MapAnnotation!"};
		return annotation;
	},
	
	/**
	 * @private
	 */    
	updateRegionFits: function(lat, lon ,latD , lonD) {
		//console.log(lat + " " + lon + " " + latD + " " + lonD);
		//console.log(this._region[0] + " " + this._region[1] + " " + this._region[2] + " " + this._region[3]);
		this._region[0] = lat;
		this._region[1] = lon;
		this._region[2] = latD;
		this._region[3] = lonD;
	},
	
	/**
	 * @private
	 */    
	performEventCallback: function($super, e) {
		if (e.eventType == 'regionchange') this.updateRegionFits(e.latitude, e.longitude , e.latitudeDelta , e.longitudeDelta);
		$super(e);
	}
});

// Properties
(function() {
	MapView.synthesizeProperty('scrollable', Commands.setScrollable);
	
	MapView.synthesizeProperty('zoomable', Commands.setZoomable);
	
	MapView.synthesizeCompoundProperty('region', Commands.setRegion);
	
	MapView.registerEventType('regionchange');
})();
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/MapAnnotation'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/MapAnnotation'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/MapAnnotation'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var MapAnnotation = exports.MapAnnotation = Element.subclass(
/** @lends UI.MapAnnotation.prototype */
{
	'type':'mapannotation',
	/**
	* @class <code>MapAnnotation</code>
	* @name UI.MapAnnotation
	* @augments Core.Class
	*/
	initialize: function($super, properties) {
		return $super(properties);
	},

	setCalloutLeftView: function(view)
	{
		this._calloutLeftView = view;
		Commands.setCalloutLeftView.call(this, view.__objectRegistryId);
	},

	getCalloutLeftView: function()
	{
		return this._calloutLeftView;
	},

	setCalloutRightView: function(view)
	{
		this._calloutRightView = view;
		Commands.setCalloutRightView.call(this, view.__objectRegistryId);
	},

	getCalloutRightView: function()
	{
		return this._calloutRightView;
	},

	setView: function(view)
	{
		this._view = view;
		Commands.setView.call(this, view.__objectRegistryId);
	},

	getView: function()
	{
		return this._view;
	},

	setImage: function(image)
	{
		console.log("WARNING : MapAnnotation.setImage has been deprecated. Use MapAnnotation.setView instead.");
		var iV = new UI.Image();
		iV.setImage(image);
		iV.setFrame([0, 0, 40, 40]);
		this.setView(iV);
	},

	/**
	 * @private
	 */    
	performEventCallback: function($super, e) {
		$super(e);
	}
});

// Properties
(function() {

	MapAnnotation.synthesizeCompoundProperty('coordinate', Commands.setCoordinate);
	
	MapAnnotation.synthesizeCompoundProperty('centerOffset', Commands.setCenterOffset);
	
	MapAnnotation.synthesizeProperty('calloutTitle', Commands.setCalloutTitle);

	MapAnnotation.synthesizeProperty('calloutSubtitle', Commands.setCalloutSubtitle);
	
	MapAnnotation.synthesizeProperty('calloutEnabled', Commands.setCalloutEnabled);

	MapAnnotation.registerEventType('select');
	MapAnnotation.registerEventType('deselect');
})();
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Analytics'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Analytics'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Analytics'] = exports; var Class = require('NGCore/Client/Core/Class').Class,
NgPipe = require('NGCore/Shared/NgPipe').NgPipe,
NgPipesRemote = require('NGCore/Shared/NgPipesRemote').NgPipesRemote;

var Analytics = Class.singleton(
/** @lends Core.Analytics.prototype */
{
    classname: 'Analytics',

    /**
     * @class The <code>Analytics</code> class serves as the custom messaging channel to the ngCore platform. 
     * The <code>Analytics</code> class provides developers with a way to keep track of game-specific items that require analysis and counting.
     * Use this class when you need your games to send custom elements that require in-game analytics support. 
     * @constructs The default constructor for setting up the NgPipe.
     * @augments Core.Class
     * @param {Boolean} [sendToRemote=true] Set <code>sendToRemote</code> to <code>true</code> to send analytics data to a remote server.
     * @param {String} [analyticsServer=ngmoco analytics server] A custom analytics server.
     * @private
     */
    initialize: function() {
        if (!this._pipe) {
          this._pipe = new NgPipe();
        }
    },

	/** @private */
	updateGLEXT: function()
	{
		try
		{
			var caps = require('NGCore/Client/Core/Capabilities').Capabilities;
			var ext = caps.getOglExtensions();
			if (ext.length > 2)	// > 2 means we got some actual data, not our fake string
			{
				// We need to rip out just one of the four tex compressions we want.
				var list = [];
				var goodies =
				[
					"GL_IMG_texture_compression_pvrtc",
					"GL_AMD_compressed_ATC_texture",
					"GL_OES_compressed_ETC1_RGB8_texture",
					"GL_AMD_compressed_3DC_texture"
				];
				for (var i in goodies)
				{
					var item = goodies[i];
					for (var j in ext)
					{
						if (ext[j] ===  item)
						{
							var rep = {};
							rep[caps.getDeviceName()] = item;
							list.push(rep);
						}
					}
				}

				for (i in list)
				{
					Analytics.reportGameEvent("openglexts", list[i]);
				}
			}
		}
		catch (e)
		{
			NgLogException(e);
		}
	},

    /** @private */
    enable: function() {
        this._pipe.enable();
    },

    /** @private */
    disable: function() {
        this._pipe.disable();
    },

    /** @private */
    setUrl: function(url) {
        this._pipe.setRemoteUrl(url);
    },

    /**
    * Report a navigation event that occurs when users navigate between application pages. 
    * Calling this function will alert the analytics platform that a user has generated a navigation event.
    * This information is used to plot how users move through the game, how long they spend on a page, and what page they navigate to next.
    *
    * @param {String} from The name of the page from which navigation originates. 
    * @param {String} to An analytics name for the destination page.
    * @param {String} btnid The ID of the button that triggered the navigation.
    */
    reportNavigation : function(from, to, btnid) {
        if (!(from && to)) {
            return false;
        }
        this._pipe.uiEvent('NAV', {to: to, fro: from, btnid: btnid} );
        return true;
    },
    /**
    * Report a custom game event. Use this when something in your game happens that you want to know about, 
    * but does not change the user's core stats.<br><br>
    * <b>Note:</b> This function serves as a catch-all. If you need your game to count or analyze something that does not fit into any 
    * other category, use this call.
    * 
    * @param {String} eventId The ID for the custom event.
    * @param {Object} payload A hash of extra information.
    * @param {Object} playerState A hash of important player states.
    */
    reportGameEvent : function(eventId, payload, playerState ) {
        if (!eventId) {
            return false;
        }

        this._pipe.gameEvent(eventId, payload, playerState);

        return true;
    },
    /**
    * Report a change to a playerstate. A playerstate is the object representation of the player's core stats. 
    * For example, if a player purchased an in-game item, you would call this to let the analytics system know what happened and how much gold was spent.
    * Everything in the player state is counted and recorded. Make sure to only pass in things for which you want to see the change 
    * (gold, mojo, grow, level, xp, health, lives, and so on).
    * <b>Note:</b> This is only for game state and should not include information that is unique to a user. For example, the user game tag or the user ID.
    *
    * @param {String} action The product ID of a purchased product. This essentially points out when an action is performed.
    * @param {Object} change A hash of currencies spent and/or gained. For example {mojo: 100, gold:-10}
    * @param {Object} playerState A hash of important player states after the purchase.
    */
    reportPlayerStateChange : function(action, change,  playerState) {
        if (action) {
            this._pipe.playerEvent(action, 'PLSTCHANGE', change, playerState);
            return true;
        } else {
            return false;
        }
    },

    /**
    * Report when a user reaches a new stage of a funnel. Funnel refers to a set of pages or requirements a user is required to engage in before proceeding. 
    * You can use this call to keep track of progress for all users. For example, keeping track of various stages users engage in for game registration.
    * Funnel stages are ordered by numeric ID. The funnel <code>stageName</code> is used for display. You do not need to define funnels ahead of time.
    * Funnel stages start at 0 and increase as the user proceeds further.<br><br>
    * <b>Note:</b> Calling <code>reportFunnelStage()</code> multiple times for a single user generates an incorrect count.
    *
    * @param {String} funnelName The name of the funnel that the user has progressed to.
    * @param {Number} funnelStage The integer value of the stage that the user reached.
    * @param {String} stageName The name of the stage that the user reached.
    * @param {Object} playerState A hash of important player states after a funnel stage.
    * @private
    */
    reportFunnelStage : function(funnelName, funnelStage, stageName, playerState) {
        var payload =  {};

        if (!(funnelName)) {
            return false;
        }
        if (funnelStage !== null && funnelStage !== undefined) {
            payload.stage = funnelStage;
        } else {
            return false;
        }

        if (stageName) {
            payload.stageName = stageName;
        }
        this._pipe.funnelEvent(funnelName, payload, playerState);

        return true;
    },
    /**
     * Report an interaction between two users.
     *
     * @param {String} actionId The action that the user is performing to interact with the other user
     * @param {String} friendGamerTag The other user with whom the current user is interacting.
     * @param {Object} payload A hash of extra information
     */
    reportSocialEvent: function(actionId, friendGamerTag, payload) {
        if (actionId && actionId.length && friendGamerTag && friendGamerTag.length ) {
            this._pipe.socialEvent(actionId, friendGamerTag, payload);
            return true;
        }
        return false;
    },
    /**
    * Report an error to analytics.
    *
    * @param {String} error_msg The error message to log.
    */
    reportError : function(error_msg) {
        if (!error_msg) {
            return false;
        }
        this._pipe.gameOpsEvent("ERR", {err: error_msg } );
        return true;
    },
    /**
     * @private
     */
    addTag: function(tag) {
        if (tag) {
            var evpl = {tag:tag};
            this._pipe.gameEvent('tag', evpl);
            return true;
        }
        return false;
    },
    /** @private */
    _getPipe: function() {
        return this._pipe;
    },
    /**
    * Game Service running inside privileged interpreter may use this method
    * to change the Social Analytic object to be used.  Please see MOBWEST-2300
	* for details
	*
    * @private
    */
	_setNgPipeSocialAnalytics: function(socialAnalyticObj) {
		if (this._pipe) {
			this._pipe._setSocialAnalytics(socialAnalyticObj);
		}
	}
});
exports.Analytics = Analytics;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Color'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Color'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Color'] = exports; exports.Color = require('NGCore/Shared/Color').Color;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Vector'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Vector'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Vector'] = exports; exports.Vector = require('NGCore/Shared/Vector').Vector;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Point'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Point'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Point'] = exports; exports.Point = require('NGCore/Shared/Point').Point;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Size'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Size'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Size'] = exports; exports.Size = require('NGCore/Shared/Size').Size;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Rect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Rect'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Rect'] = exports; exports.Rect = require('NGCore/Shared/Rect').Rect;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/MessageEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/MessageEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/MessageEmitter'] = exports; exports.MessageEmitter = require('NGCore/Shared/MessageEmitter').MessageEmitter;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/MessageListener'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/MessageListener'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/MessageListener'] = exports; exports.MessageListener = require('NGCore/Shared/MessageListener').MessageListener;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/ObjectRegistry'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/ObjectRegistry'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/ObjectRegistry'] = exports; var Class = require('NGCore/Client/Core/Class').Class;

exports.ObjectRegistry = Class.singleton(
{
	classname: 'ObjectRegistry',
		
	/** @private @class @status */
	initialize: function()
	{
		this._currentId = 0;
		this._guardId = 0;
		this._objects = {};
	},
	
	/** @status */
	register: function(obj)
	{
		if(obj.__objectRegistryId)
			throw new Error('ObjectRegistry.register: object already registered');
			
		var id = "" + ++this._currentId;
		obj.__objectRegistryId = id;
		this._objects[id] = obj;
	},
	
	/** @status */
	unregister: function(obj)
	{
		if(!obj.__objectRegistryId)
			throw new Error('ObjectRegistry.unregister: object not registered');
			
		var id = obj.__objectRegistryId;
		obj.__objectRegistryId = 0;
		delete this._objects[id];
	},
	
	/** @status */
	isObjectRegistered: function(obj)
	{
		if(obj.__objectRegistryId)
			return true;
		else
			return false;
	},
	
	/** @status */
	isIdRegistered: function(id)
	{
		if(this._objects[id])
			return true;
		else
			return false;
	},
	
	/** @status */
	objectToId: function(obj)
	{
		var id = obj.__objectRegistryId;
		
		if(!id)
			throw new Error('ObjectRegistry.objectToId: object not registered');
		
		return id;
	},
	
	/** @status */
	idToObject: function(id)
	{
		return this._objects[id];
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Time'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Time'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Time'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Time
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;

var Time = Class.singleton(
/** @lends Core.Time.prototype */
{
	classname: 'Time',
	mFrameTime: 0,
	mFrameDelta: 0,

	/**
	 * @class the <code>Time</code> class constructs objects that provide access to the system clock and system timings for a device.
	 * @status iOS, Android, Flash
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	initialize: function()
	{
	},

	/**
	 * Return the timestamp for the current time frame (expressed in milliseconds).
	 * @returns {Number} The timestamp for the current time frame.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrameTime: function()
	{
		return this.mFrameTime;
	},

	/**
	 * Return the delta time in milliseconds since the last time frame.
	 * @returns {Number} The delta time since the last time frame.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrameDelta: function()
	{
		return this.mFrameDelta;
	},

	/**
	 * Return the real-time clock in milliseconds. 
	 * <b>Note:</b> This differs from the time frame timestamp, which is constant for the entire time frame.
	 * @returns {Number} The real-time clock.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getRealTime: function()
	{
		return (new Date()).getTime();
	},

	$_frameTimeRecv: function( cmd )
	{
		var o = {};
		this._frameTimeRecvGen(cmd, o);

		this.mFrameDelta = this.mFrameTime ? o.time - this.mFrameTime : 1;
		this.mFrameTime = o.time;
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 351
	// Method frameTime = -1
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Time._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				case -1:
					Time._frameTimeRecv( cmd );
					break;
				default:
					NgLogE("Unknown static method id " + cmdId + " in Time._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[351] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	$_frameTimeRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Time.frameTime from command: " + cmd );
			return false;
		}
		
		obj[ "time" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "time" ] === undefined )
		{
			NgLogE("Could not parse time in Time.frameTime from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $_frameTimeRecv: function( cmd ) {}

// {{/Wg Generated Code}}

});

exports.Time = Time;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/toMD5'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/toMD5'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/toMD5'] = exports; exports.toMD5 = require('NGCore/Shared/Lib/md5').toMD5;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/SHA1'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/SHA1'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/SHA1'] = exports; var sha1 = require('NGCore/Shared/Lib/sha1');

exports.SHA1 = {
	b64_hmac_sha1: sha1.b64_hmac_sha1,
	hex_sha1: sha1.hex_sha1,
	b64_sha1: sha1.b64_sha1
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/UpdateEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/UpdateEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/UpdateEmitter'] = exports; var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var Time = require('NGCore/Client/Core/Time').Time;

exports.UpdateEmitter = MessageEmitter.singleton(
/** @lends Core.UpdateEmitter.prototype */
{
	classname: 'UpdateEmitter',
		
	/**
	 * @class The <code>UpdateEmitter</code> module constructs a singleton object that emits every frame with the delta in milliseconds since the last frame.<br><br>
	 * <b>Note:</b> <code>{@link Core.UpdateEmitter#setTickRate}</code> is also used to define the framerate of any animation reproduced by a sprite 
	 * (see <code>{@link GL2.Sprite#setAnimation}</code>).
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		
		this.__clubObject = new NgEngineEntity();
		this.__clubObject.mIsUpdatable = true;
		this.__clubObject.onUpdate = this._emitTime.bind(this);
		this.__clubObject.register();
		
		this._createSendGen(this.__objectRegistryId);
	},
	
	_emitTime: function()
	{
		this.emit(Time.getFrameDelta());
	},
	/**
	 * Set the tick rate that this <code>UpdateEmitter</code> object uses to send updates.<br><br>
	 * <b>Example:</b> Calling <code>setTickRate(15)</code>, any <code>MessageListener</code> objects that are listening 
	 * to the <code>UpdateEmitter</code> receive messages 15 times a second.	 
	 * @param {Number} r The new tick rate.
	 * @see GL2.Sprite
	 * @status iOS, Android, Flash
	 */
	setTickRate: function( r ) 
	{
		this._setTickRateSendGen(r);
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 304
	// Method create = -1
	// Method setTickRate = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in UpdateEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in UpdateEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[304] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( ":304,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_setTickRateSendGen: function( rate )
	{
		Proc.appendToCommandString( ":304,2," + this.__objectRegistryId + "," + rate  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setTickRate: function( rate ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Proc'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Proc'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Proc'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Proc
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var Base64 = require('NGCore/Client/Core/Base64').Base64;

////////////////////////////////////////////////////////////////////////////////

exports.Proc = Class.singleton(
{
	classname: 'Proc',
	
	initialize: function()
	{
		this._commandString = "";
	},
	
	appendToCommandString: function( str )
	{
		this._commandString += str;
	},
	
	getCommandString: function()
	{
		return this._commandString;
	},
	
	clearCommandString: function ()
	{
		this._commandString = "";
	},
	
	parseBool: function( v )
	{
		return v == 1 ? true : false;
	},

	parseInt: function( v )
	{
		return parseInt( v, 10 );
	},
	
	parseFloat: function( v )
	{
		return parseFloat( v );
	},
	
	parseString: function( v )
	{
		return Base64.decode( v );
	},
	
	parseJSONString: function( v )
	{
		return JSON.parse( Base64.decode( v ) );
	},

	setPrivileged: function()
	{
		this._privileged = true;
	},

	isPrivileged: function()
	{
		return this._privileged ? true : false;
	},

// {{?Wg Generated Code}}
	_classRecvGen: function( cmd )
	{
		var classId = parseInt( cmd.shift(), 10 );
		
		var handler = PROC_DISPATCH_TABLE[classId];
		if(handler)
		{
			handler(cmd);
		}
		else
		{
			NgLogE( "Unknown class id " + classId + " in _classRecvGen" );
		}
	}
// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/_LocalGameList'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/_LocalGameList'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/_LocalGameList'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class _LocalGameList
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Time = require('NGCore/Client/Core/Time').Time;
var toMD5 = require('NGCore/Client/Core/toMD5').toMD5;
var Util = require('NGCore/Client/Network/Util').Util;
var Base64 = require('NGCore/Client/Core/Base64').Base64;

////////////////////////////////////////////////////////////////////////////////

exports._LocalGameList = Class.singleton (
/** @lends Core._LocalGameList.prototype */
{
	classname: '_LocalGameList',

	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		this.mGameList = [];
		var Storage = require('NGCore/Client/Storage').Storage;
		this.mFile = Storage.FileSystem;
		this.mGameStore = Storage.KeyValueCache.global("Core.GameList");

		this.mLoadingGames = {};
		this.mActiveGameKey = "activeGames";
		this.mRequiredAvailableSpace = 0;
		this.mSpaceAvailable = 0;
		this.mSpaceFreeCallbacks = [];
		this._firstBootGameLaunch = true;

		this._getRepoSpaceSendGen();

		this._setStage(this.ProgressStage.BootFirst);
		this._reloadGameList();
	},
	
	ProgressStage:
	{
		BootFirst: {},
		BootSecond: {},
		GameWithoutSecond: {},
		GameWithSecond: {},
		Regular: {}
	},
	
	_setStage: function(stage)
	{
		this._progressStage = stage;
		switch(stage)
		{
			case this.ProgressStage.BootFirst:
				console.log('setStage BootFirst');
				this._progressMin = 0;
				this._progressRange = 0.25;
				break;
			case this.ProgressStage.BootSecond:
				console.log('setStage BootSecond');
				this._progressMin = 0.25;
				this._progressRange = 0.25;
				break;
			case this.ProgressStage.GameWithoutSecond:
				console.log('setStage GameWithoutSecond');
				this._progressMin = 0.25;
				this._progressRange = 0.75;
				break;
			case this.ProgressStage.GameWithSecond:
				console.log('setStage GameWithSecond');
				this._progressMin = 0.5;
				this._progressRange = 0.5;
				break;
			case this.ProgressStage.Regular:
				console.log('setStage Regular');
				this._progressMin = 0;
				this._progressRange = 1;
				break;
			default:
				console.log('setStage ERROR');
				this._progressMin = 0;
				this._progressRange = 1;
		}
		console.log('min:', this._progressMin, 'range:', this._progressRange);
	},
	
	_nextStage: function()
	{
		switch(this._progressStage)
		{
			case this.ProgressStage.BootFirst:
				this._setStage(this.ProgressStage.GameWithoutSecond);
				break;
			case this.ProgressStage.BootSecond:
				this._setStage(this.ProgressStage.GameWithSecond);
				break;
			case this.ProgressStage.GameWithoutSecond:
				this._setStage(this.ProgressStage.Regular);
				break;
			case this.ProgressStage.GameWithSecond:
				this._setStage(this.ProgressStage.Regular);
				break;
		}
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 303
	// Method create = -1
	// Method updateGame = 2
	// Method updateDone = 3
	// Method getRepoSpace = 4
	// Method repoSpace = 5
	// Method deleteGame = 6
	// Method setUpdateProgress = 7
	// Method pauseUpdate = 8
	// Method resumeUpdate = 9
	// Method cancelUpdate = 10
	// Method updateProgress = 11
	// Method allowBGUpdates = 12
	// Method runGame = 13
	// Method finishGame = 14
	// Method setProgressText = 15
	// Method setSplashVisible = 16
	// Method exceptionForwarded = 17
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._updateGameRecv( cmd );
					break;
				case 5:
					instance._repoSpaceRecv( cmd );
					break;
				case 6:
					instance._deleteGameRecv( cmd );
					break;
				case 8:
					instance._pauseUpdateRecv( cmd );
					break;
				case 9:
					instance._resumeUpdateRecv( cmd );
					break;
				case 10:
					instance._cancelUpdateRecv( cmd );
					break;
				case 12:
					instance._allowBGUpdatesRecv( cmd );
					break;
				case 13:
					instance._runGameRecv( cmd );
					break;
				case 14:
					instance._finishGameRecv( cmd );
					break;
				case 17:
					instance._exceptionForwardedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in _LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in _LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[303] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_updateGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.updateGame from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.updateGame from command: " + cmd );
			return false;
		}
		
		obj[ "id" ] = Proc.parseInt( cmd[ 1 ] );
		if( obj[ "id" ] === undefined )
		{
			NgLogE("Could not parse id in _LocalGameList.updateGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_repoSpaceRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		obj[ "space" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "space" ] === undefined )
		{
			NgLogE("Could not parse space in _LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_deleteGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.deleteGame from command: " + cmd );
			return false;
		}
		
		obj[ "mdFive" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "mdFive" ] === undefined )
		{
			NgLogE("Could not parse mdFive in _LocalGameList.deleteGame from command: " + cmd );
			return false;
		}
		
		obj[ "game" ] = Proc.parseString( cmd[ 1 ] );
		if( obj[ "game" ] === undefined )
		{
			NgLogE("Could not parse game in _LocalGameList.deleteGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_pauseUpdateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.pauseUpdate from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.pauseUpdate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_resumeUpdateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.resumeUpdate from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.resumeUpdate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_cancelUpdateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.cancelUpdate from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.cancelUpdate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_allowBGUpdatesRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.allowBGUpdates from command: " + cmd );
			return false;
		}
		
		obj[ "allow" ] = Proc.parseBool( cmd[ 0 ] );
		if( obj[ "allow" ] === undefined )
		{
			NgLogE("Could not parse allow in _LocalGameList.allowBGUpdates from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_runGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.runGame from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.runGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_finishGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.finishGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_exceptionForwardedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.exceptionForwarded from command: " + cmd );
			return false;
		}
		
		obj[ "exceptionString" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "exceptionString" ] === undefined )
		{
			NgLogE("Could not parse exceptionString in _LocalGameList.exceptionForwarded from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( ":303,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_updateDoneSendGen: function( id, error )
	{
		Proc.appendToCommandString( ":303,3," + this.__objectRegistryId + "," + id + "," + Base64.encode( error )  );
	},
	
	/** @private */
	_getRepoSpaceSendGen: function(  )
	{
		Proc.appendToCommandString( ":303,4," + this.__objectRegistryId );
	},
	
	/** @private */
	_setUpdateProgressSendGen: function( progress )
	{
		Proc.appendToCommandString( ":303,7," + this.__objectRegistryId + "," + progress  );
	},
	
	/** @private */
	_updateProgressSendGen: function( url, cur, total, error )
	{
		Proc.appendToCommandString( ":303,11," + this.__objectRegistryId + "," + Base64.encode( url ) + "," + cur + "," + total + "," + ( error ? 1 : 0 )  );
	},
	
	/** @private */
	_setProgressTextSendGen: function( text )
	{
		Proc.appendToCommandString( ":303,15," + this.__objectRegistryId + "," + Base64.encode( text )  );
	},
	
	/** @private */
	_setSplashVisibleSendGen: function( visible )
	{
		Proc.appendToCommandString( ":303,16," + this.__objectRegistryId + "," + ( visible ? 1 : 0 )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _updateGameRecv: function( cmd ) {}
	// updateDone: function( id, error ) {}
	
	// getRepoSpace: function(  ) {}
	
	// _repoSpaceRecv: function( cmd ) {}
	// _deleteGameRecv: function( cmd ) {}
	// setUpdateProgress: function( progress ) {}
	
	// _pauseUpdateRecv: function( cmd ) {}
	// _resumeUpdateRecv: function( cmd ) {}
	// _cancelUpdateRecv: function( cmd ) {}
	// updateProgress: function( url, cur, total, error ) {}
	
	// _allowBGUpdatesRecv: function( cmd ) {}
	// _runGameRecv: function( cmd ) {}
	// _finishGameRecv: function( cmd ) {}
	// setProgressText: function( text ) {}
	
	// setSplashVisible: function( visible ) {}
	
	// _exceptionForwardedRecv: function( cmd ) {}

// {{/Wg Generated Code}}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
	_updateGameRecv: function( cmd )
	{
		this._getRepoSpaceSendGen();

		var o = {};
		this._updateGameRecvGen(cmd, o);

		if (o.url in this.mLoadingGames)
		{
			this.mLoadingGames[o.url].id = o.id;
			this.mLoadingGames[o.url].dlman.resume();
		}
		else
		{
			this.updateGame(o.url, o.id,
				(function (url, newFiles, err)
				{
					o.id = this.mLoadingGames[url].id;
					this._updateDoneSendGen(o.id, err);
				}).bind(this, o.url)
			);
		}
	},
	mobageRunGame: function (funk)
	{
		this._gameRunner = funk;
	},
	_runGameRecv: function( cmd )
	{
		var o = {};
		this._runGameRecvGen(cmd, o);
		if (this._gameRunner)
		{
			console.log("_LGL running gameRunner " + o.url);
			this._gameRunner(o.url);
		}
		else
		{
			console.log("_LGL running game " + o.url);
			var _int_LGL = require('NGCore/Client/Core/_int_LGL')._int_LGL;
			_int_LGL.launch(o.url, _int_LGL.ProcID.Game);
		}
	},
	/**
	 * set the function that kills the current game app
	 */
	setFinishGameHandler: function(funk)
	{
		this._finishGameHandler = funk;
	},
	_finishGameRecv: function()
	{
		if (this._finishGameHandler)
		{
			this._finishGameHandler();
		} else {
			console.log("_LocalGameList: finishGameHandler is not set");
		}
	},
	_repoSpaceRecv: function( cmd )
	{
		var obj = {};
		this._repoSpaceRecvGen(cmd, obj);
		this.mSpaceAvailable = obj.space;
		console.log("SD card space available(b): " + this.mSpaceAvailable);

		var length = this.mSpaceFreeCallbacks.length;
		while (length--)
		{
			(this.mSpaceFreeCallbacks.pop())();
		}
	},

	_deleteGameRecv: function( cmd )
	{
		// site to calc md5: http://pajhome.org.uk/crypt/md5/
		var allowedGames =
		[
			"http://10.15.", // Allow partial ones, for testing
			'http://gamehub.mobage.com/app/1.0s/gamehub',
			'url of allowed game'
		];

		var obj = {};
		this._deleteGameRecvGen(cmd, obj);
		var i;
		for(i in allowedGames)
		{
			var match = obj.game.match(allowedGames[i]);
			if(match && !match.index)
			{
				NgLogD("Deleting " + obj.mdFive);
				this.deleteGameFiles(obj.mdFive);

				var doneCB = (function ()
				{
					NgLogD("Finished deleting game from " + this.mActiveGameKey + " for " + obj.mdFive );
				}).bind(this);
				this._deleteGameFromStorage(obj.mdFive,doneCB);

				return;
			}
			else
			{
				// for testing, allow any local server starting with 10.15
			}
		}
		NgLogE("_LocalGameList unauthorized call to deleteGame from "+obj.game+"!");
	},

// _deleteGameFromStorage is for deleting the games info from LGL storage, not the game's storage

	_deleteGameFromStorage: function(mdFive,doneCB)
	{
		var self = this;
		this.mGameStore.getItem(this.mActiveGameKey,
			function(error, value)
			{
				var list = JSON.parse(value);
				
				var good = false;
				var ind;
				var out = [];
				for(ind = 0; ind < list.length; ++ind)
				{
					if(list[ind].name == mdFive)
						good = true;
					else
						out.push(list[ind]);
				}
				
				if( good )
				{
					NgLogD("_LocalGameList found and removed " + mdFive);
					self.mGameStore.setItem(self.mActiveGameKey, JSON.stringify(out), doneCB);
				}
				else
				{
					NgLogD("_LocalGameList failed to find and remove " + mdFive);
					doneCB("Could not remove item: " + error);
				}
				
			}, true
		);
	},

	getGameConfig: function(identifier, isMDFive, callBack)
	{
		if (typeof isMDFive == 'function')
		{
			callBack = isMDFive;
			isMDFive = false;
		}

		var folder;
		if (isMDFive)
		{
			folder = identifier;
		}
		else
		{
			var Util = require('NGCore/Client/Network/Util').Util;
			var norm = Util.NormalizeUrl(identifier);
			folder = toMD5(norm);
		}

		this.mFile.readFile(folder + "/" + Capabilities._getConfigFile(),
			function (err, contents)
			{
				var ret = {};
				if (err || !contents)
				{
					console.log("Could not get config from %s! err: %s", identifier, err);
				}
				else
				{
					ret = JSON.parse(contents);
				}
				callBack(ret);
			}
		);
	},

	getRepoSpace: function()
	{
		return this.mSpaceAvailable;
	},

	getConfig: function(gameOrigin, name, callback, failEarly)
	{// callback = function (config, err)
		// XHR
		var XHR = require('NGCore/Client/Network/XHR').XHR;
		var Util = require('NGCore/Client/Network/Util').Util;
		
		var httpStatus = 0;
		
		Util.OperationWithRetries(function(failCb)
		{
			var req = new XHR();
			req.onreadystatechange = function()
			{
				if(req.readyState == 4)
				{
					httpStatus = req.status;
					if(httpStatus == 200)
					{
						// Succes.
						callback(req.responseText);
					}
					else if(httpStatus == 404)
					{
						// File not on server, so load from the regular location
						console.log("no configuration file found at %s, using root server", gameOrigin + name);
						callback( "{}" );
					}
					else
					{
						//Error! Retry
						failCb();
					}
				}
			};

			req.open('GET', gameOrigin + name + Util.getCacheBustingString(), true);
			req.send();
		}, function()
		{
			callback(null, true, httpStatus);
		}, failEarly);
	},

	// gameOrigin: url to folder holding webgame.ngmanifest
	// doneCB = function(totalBytes, error)
	updateGame: function(gameOrigin, id, doneCB, failEarly, failAllowed)
	{
		// console.log ( "LGL.updateGame url = " + gameOrigin );
		// console.log ( "LGL.updateGame boot game = " + Capabilities.getBootGame() );
		
		var re = new RegExp(".*" + Capabilities.getBootGame());
		var match = gameOrigin.match(re);
		
		if (match) 
			this._firstBootGameLaunch = false;
			
		// console.log ( "_LocalGameList.updateGame updating game." );

		// Normalize URL
		var Util = require('NGCore/Client/Network/Util').Util;
		gameOrigin = Util.NormalizeUrl(gameOrigin);
		var name = toMD5(gameOrigin);
		this.mLoadingGames[gameOrigin] = {id: id};

		console.log(gameOrigin + " toMD5: " + name);

		// Get device-specific manifest directory
		var buildPath = {"Android" : "android", "iPhone OS" : "ios", "flash" : ""};
		// Get Device capabilities platformOs
		var caps = require('NGCore/Client/Core/Capabilities').Capabilities;
		var build = "/" + buildPath[caps.getPlatformOS()];

		this._setProgress(0);

		var curContUrl = "";
		var configFile = toMD5(gameOrigin) + "/" + caps._getConfigFile();
		
		// This is guaranteed to be synchronous, so will always occur before the callback for subsequent operations.
		this.mFile.readFile(configFile,
			function(err, data)
			{
				if (data)
				{
					var obj = JSON.parse(data);
					curContUrl = obj.contentUrl;
				}
			}
		);

		this.getConfig(gameOrigin + build, "/" + caps._getConfigFile(),
		(function(config, error, status)
		{
			if (error)
			{
				doneCB(0, error);
				delete this.mLoadingGames[gameOrigin];
			}
			else
			{
				this._setProgress(0.1);

				// Read config
				var parsedConfig = JSON.parse(config);
				if(!parsedConfig.contentUrl)
				{
					parsedConfig.contentUrl = gameOrigin + build;
				}
				else if (parsedConfig.contentUrl == curContUrl)
				{
					// no need to update.
					this._setProgress( 1.0 );
					this._setStage(this.ProgressStage.Regular);
					this.mFile.writeFile(configFile, JSON.stringify(parsedConfig),
						function(err) {console.log(err); } );
					doneCB(0);
					delete this.mLoadingGames[gameOrigin];
					return;
				}

				this._callDownloadManifest(parsedConfig, gameOrigin, name, failEarly, failAllowed, (function(bytes, error)
				{
					this._setProgress( 1.0 );
					this._nextStage();

					if (! error) {
						var that = this;
						this._reloadGameList({name:name, url:gameOrigin}, function()
						{
							if (doneCB && (typeof doneCB == 'function')) {
								doneCB(bytes, error);
								delete that.mLoadingGames[gameOrigin];
							}
						});
					} else {
						doneCB(bytes, error);
						delete this.mLoadingGames[gameOrigin];
					}
				}).bind(this));
			}
		}).bind(this), failEarly);
	},

	_allowBGUpdatesRecv: function( cmd )
	{
		var o = {};
		this._allowBGUpdatesRecvGen(cmd, o);
		this._pauseOrResumeAll(o.allow);
	},

	_pauseOrResumeAll: function(resume)
	{
		for (i in this.mLoadingGames)
		{
			if (resume)
			{
				console.log("Resuming download of " + i);
				this.resumeUpdate(i);
			}
			else
			{
				console.log("Pausing download of " + i);
				this.pauseUpdate(i);
			}
		}
	},

	pauseUpdate: function(url)
	{
		if (this.mLoadingGames[url])
		{
			if(this.mLoadingGames[url].dlman)
			{
				this.mLoadingGames[url].dlman.pause();
				this.mLoadingGames[url].userPause = true;
			}
		}
	},

	_pauseUpdateRecv: function(cmd)
	{
		var o = {};
		this._pauseUpdateRecvGen(cmd, o);
		this.pauseUpdate(o.url);
	},

	resumeUpdate: function(url)
	{
		if (this.mLoadingGames[url])
		{
			if(this.mLoadingGames[url].dlman)
			{
				this.mLoadingGames[url].dlman.resume();
				this.mLoadingGames[url].userPause = false;
			}
		}
	},

	_resumeUpdateRecv: function(cmd)
	{
		var o = {};
		this._resumeUpdateRecvGen(cmd, o);
		this.resumeUpdate(o.url);
	},

	cancelUpdate: function(url)
	{
		if (this.mLoadingGames[url])
		{
			if (this.mLoadingGames[url].dlman) {
                this.mLoadingGames[url].dlman.abort();
            }
			delete this.mLoadingGames[url];

			//Cancel the keep alive request as well
			var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;

            this.identification_key = 'manifest_download';
            LifecycleEmitter.cancelEngineKeepAlive(this);
		}
	},

	_cancelUpdateRecv: function(cmd)
	{
		var o = {};
		this._cancelUpdateRecvGen(cmd, o);
		this.cancelUpdate(o.url);
	},

	_setProgress: function (progress) {
		if(progress > 1) progress = 1;
		if(progress < 0) progress = 0;
		progress = progress*this._progressRange + this._progressMin;
		this._setUpdateProgressSendGen(progress);
	},

	listenToProgress: function (listener)
	{
		this._privListener = listener;
	},

	_updateProgress: function(url, prog, total, err)
	{
		//console.log("Updating progress for: %s, %d, %d " + err, url, prog, total);
		if (this._privListener)
			this._privListener(url, prog, total, err);

		if (this.mLoadingGames[url] && this.mLoadingGames[url].id >=0)
			this._updateProgressSendGen(url,prog,total,err);
	},

	// doneCB = function(totalBytes, error)
	_callDownloadManifest: function (config, gameOrigin, name, failEarly, failAllowed, doneCB)
	{
		var contentUrl = config.contentUrl;
		var reportTotalBytes = 0;
		var self = this;
		var Downloader = require('NGCore/Client/Network/DownloadManifest').DownloadManifest;
		
		var manifestName = require('NGCore/Client/Core/_int_LGL')._int_LGL.getManifestName(config);

		// Do download
		(function doDownload()
		{
			var dler = new Downloader();
			dler.mLocalGameList = self;
			var firstProgress = true;
            var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;
            this.identification_key = 'manifest_download';
            NgLogD("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++Manifest Download Request Keep Engine Alive");
            LifecycleEmitter.requestEngineKeepAlive(this);
			// Only allow this on iOS
			config.omitJsUpdate = config.omitJsUpdate && (Capabilities.getPlatformOS() == "iPhone OS");
			dler._setConfig(config);
			dler.start(contentUrl, name, {'webgame.ngmanifest':manifestName}, function(bytesDownloaded, bytesTotal)
			{
				if(firstProgress)
				{
					// First progress callback is made when manifest is downloaded.
					firstProgress = false;
					self._setProgress(0.2);
					reportTotalBytes = bytesTotal;
				}
				else
				{
					self._setProgress(0.3 + 0.6 * (bytesDownloaded / bytesTotal));
				}

				// update LGL
				self._updateProgress(gameOrigin, bytesDownloaded, bytesTotal);
			}, function(error, manifest, wasCached)
			{
				if (failAllowed)
				{
					if (doneCB)
					{
						doneCB(reportTotalBytes, error);
					}
				}
				else if(error)
				{
					NgLogE("Error: " + error);
					// update LGL
					self._updateProgress(gameOrigin, 0, 0, error);
					doneCB(0, error);
				}
				else
				{
					if (doneCB)
					{
						doneCB(reportTotalBytes);
					}
				}

                this.identification_key = 'manifest_download';
                LifecycleEmitter.cancelEngineKeepAlive(this);
			}, false, failEarly);
			self.mLoadingGames[gameOrigin].dlman = dler;
		})();
	},

	freeSpace: function(space, cb)
	{
		this.mRequiredAvailableSpace = space;
		this.mSpaceFreeCallbacks.push(
			(function()
			{
				if (this.mRequiredAvailableSpace > this.mSpaceAvailable)
				{
					if (this._privListener)
					{
						this._privListener("", 0, 0, "SD card is full");
					}
					else
					{
						console.log("Warning!! Mobage is not handling SD card full error!");
						// This is Preservation of ancient code which has and will likely never execute
						var checkAgain = function()
						{
							if (this.mRequiredAvailableSpace > this.mSpaceAvailable)
							{
								this.pruneGames(1);
								this.mSpaceFreeCallbacks.push(checkAgain);
							}
							else
							{
								cb();
							}
						};
						// Is a redundant check on space, but looks better/is simpler/won't ever be used anyhow
						checkAgain();
					}
				}
				else
				{
					cb();
				}
			}).bind(this)
		);

		this._getRepoSpaceSendGen();
	},

	pruneGames: function(number)
	{
		var self = this;

		// Function to put oldest games on top of the stack
		var sort = function (l, r)
		{
			return r.lastRun - l.lastRun;
		};

		this.mGameStore.getItem(this.mActiveGameKey,
			function(error, value)
			{
				var list = JSON.parse(value);
				list.sort(sort);
				while (number-- && (list.length - 1))
				{
					var game = list.pop();

					// Do not delete the currently loading game
					if (!(game.name in self.mLoadingGames))
					{
						// delete game
						self.deleteGameFiles(game.name);
					}
					else
					{
						list.push(game);
					}
				}

				// Save the data
				self.mGameStore.setItem(self.mActiveGameKey, JSON.stringify(list));
			}, true
		);
	},

	deleteGame: function (url, callBack)
	{
		var Util = require('NGCore/Client/Network/Util').Util;
		var norm = Util.NormalizeUrl(url);
		var mdFive = toMD5(norm);

		this.deleteGameFiles(mdFive);
		this._deleteGameFromStorage(mdFive, callBack);
	},

	// Delete the KeyValueCache.local of the given game
	deleteGameKeyValue: function(mdFive)
	{
		var kvm = require('NGCore/Client/Storage').KeyValueCache;
		kvm.global(mdFive).clear();
	},

	deleteGameFiles: function(game)
	{
		var self = this;
		self.mFile.deleteFile( game , 
			function(err)
				{
					if(err == "" )
						NgLogI('Deleted');
					else
						NgLogD("Could not delete game");

					self._getRepoSpaceSendGen();
				});
	},

	getGameList: function()
	{
		return this.mGameList;
	},

	clearWatch: function()
	{
		var fs = require('NGCore/Client/Storage/FileSystem').FileSystem;
		fs.deleteFile(".watch");
	},

	/**
	 * @private
	 */
	_reloadGameList: function(newItem, cb)
	{
		this.mGameStore.getItem(this.mActiveGameKey,
			(function(error, value)
			{
				var list;
				if (value)
					list = JSON.parse(value);
				else
					list = [];

				if (newItem)
				{
					var bNew = true;
					for (var i in list)
					{
						if (list[i].name == newItem.name)
						{
							bNew = false;
							newItem.lastRun = list[i].lastRun;
							list[i] = newItem;
							break;
						}
					}

					if (bNew)
					{
						list.push(newItem);
					}
					this.mGameStore.setItem(this.mActiveGameKey, JSON.stringify(list));
				}

				this.mGameList = list;

				if (typeof cb == 'function')
					cb();
			}).bind(this),
			true
		);
	},

	_getRunningGame: function(callBack)
	{
		// Function to put oldest games on top of the stack
		var sort = function (l, r)
		{
			return r.lastRun - l.lastRun;
		};

		this._reloadGameList(false, (function(cb)
		{
			var list = this.mGameList;
			list.sort(sort);
			var current = null;
			var len = list.length;
			for (var i = 0; i < len; ++i)
			{
				if (list[i].lastRun)
				{
					current = list[i];
					break;
				}
			}
			if (current && current.url)
				cb(current.url);
		}).bind(this, callBack));
	},

	/** @private */
	_pausingGame: function()
	{
		// true to resume download when pausing a game
		this._pauseOrResumeAll(true);
	},

	/** @private */
	_resumingGame: function()
	{
		// Check if the current game allows downloading
		this._getRunningGame((function(game)
		{
			this.getGameConfig(game, (function(config)
			{
				if (config.noBackgroundUpdates)
				{
					// false to pause download when resuming a game
					this._pauseOrResumeAll(false);
				}
			}).bind(this));
		}).bind(this));
	},

	setSplashVisible: function( visible )
	{
		this._setSplashVisibleSendGen(visible);
	},

	setProgressText: function( text )
	{
		this._setProgressTextSendGen(text);
	},

	updateAvailable: function(game, doneCB, errorCB)
	{
		var _int_LGL = require('NGCore/Client/Core/_int_LGL')._int_LGL;
		_int_LGL.updateAvailable(game, doneCB, errorCB);
	},

	/*
	 * Set the exception handler. Default is undefined.
	 * @param {Function} the function that handles the exception occurred in the Game proc. signature: function(exceptionString)
	 */
	setExceptionHandler: function(func)
	{
		this._exceptionHandler = func;
	},

	_exceptionForwardedRecv: function( cmd )
	{
		var obj = {};
		this._exceptionForwardedRecvGen(cmd, obj);
		var exception = JSON.parse(obj.exceptionString);
		
		if (this._exceptionHandler)
			this._exceptionHandler(exception);
		else
			NgLogException(exception);
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/NativeAppLaunch'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/NativeAppLaunch'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/NativeAppLaunch'] = exports; // @deprecated
var NativeAppLaunch;

exports.NativeAppLaunch = NativeAppLaunch;; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/NgPipe'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/NgPipe'] || {}; $MODULE_REGISTRY['NGCore/Shared/NgPipe'] = exports; var Class = require('NGCore/Shared/Class').Class;
var NgPipesRemote = require('NGCore/Shared/NgPipesRemote').NgPipesRemote;
var hex_sha1 = require('NGCore/Shared/Lib/sha1').hex_sha1;
var __hasProp = Object.prototype.hasOwnProperty;
var CapabilitiesReq = require('NGCore/Client/Core/Capabilities');

/*
The NgPipes object
*/

NgPipe = Class.subclass({
    classname: "NgPipe",
    initialize: function(options) {
        options = options || {};
		/*
		 * Note that this require statement cannot be put at the top level
		 * because it will cause code to fail to execute.  It's an intricacy
		 * in our require system.
		 */
		this._socAnalytics = require('NGCore/Client/Social').Social.Common.Analytics;
        this._meta = options.meta || {};
        this._queue = null;
        this._isSendQueued = false;
        this._sendDelay = options.sendDelay || 5000;
        this._meta = options.meta || {};
        this._seqStart = options.seqStart || new Date().getTime();
        this._playerState = options.playerState || null;
        this._seqNumber = options.seqNumber || 0;
        this._allowedLargeValue = {
            msg: 1024 * 5,
            err: 1024 * 5,
            sid: 64,
            udid: 64
        };

        this._sendToRemote = true;
        this._globalKey = '__NgPipeStorage';
        var self = this;
        var cb = function(error,value, key) {
            var new_queue = [];
            if (!error) {
                try {
                    new_queue = JSON.parse(value);
                } catch(e) {
                    new_queue = [];
                }
            }

            if (self._queue) {
                new_queue = self._queue.concat(new_queue);
            }

            self._setQueue(new_queue);
            if (self._queue.length > 0 ){
                self._drainQueue();
            }
        };
        this._locListener = null;
        this._location = null;
        Storage.KeyValueCache.global(this._globalKey).getItem(this._globalKey, cb);
        var starting_queue = [].concat(options.queue || []);
        this._queue = starting_queue;
        this._sessionEnded = false;
        this._capAlphaNumStringKeys = ['afam', 'asku', 'srcty', 'evcl', 'evid', 'pltfmsku','carr','srv'];
        this.sessionStartEvent();
        this._tagQa();
        this._hookLifetime();
        this._hookGeo();
        return true;
    },

    close: function() {
        this._drainQueue();
        return true;
    },

    enable: function() {
        this._sendToRemote = true;
    },

    disable: function() {
        this._sendToRemote = false;
    },

    setRemoteUrl: function(url) {
        NgPipesRemote.setUrl(url);
    },

    playerEvent: function(eventId, evcl, change, playerState) {
        var e;
        evcl || (evcl = "PLST");
        e = {
            change: change,
            srcty: 'GC',
            evid: eventId,
            evcl: evcl,
            plst: this._getPlayerStateDiff(playerState || this._playerState)
        };
        this._queueMessage(e);
        this._setCurrentPlayerState(playerState);
        return e;
    },
    gameEvent: function(eventId, payload, playerState) {
        var e;
        e = {
            evid: eventId,
            evpl: payload,
            srcty: 'GC',
            evcl: 'GAME'
        };

        if (playerState) {
          e.plst = this._getPlayerStateDiff(playerState || this._playerState);
        }
        this._queueMessage(e);
        return e;
    },
    gameOpsEvent: function(eventId, payload) {
        var e;
        e = {
            evid: eventId,
            evpl: payload,
            srcty: 'GC',
            evcl: 'GAMEOPS'
        };
        this._queueMessage(e);
        return e;
    },
    revenueEvent: function(eventId, payload) {
        var e;
        e = {
            evcl: 'REV',
            evid: eventId,
            srcty: 'PC',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },
    uiEvent: function(eventId, payload) {
        var e;
        e = {
            evcl: 'UI',
            srcty: 'GC',
            evid: eventId,
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },
    funnelEvent: function(eventId, payload, playerState) {
        var e;
        e = {
            evcl: 'FUNNEL',
            srcty: 'GC',
            evid: eventId,
            evpl: payload
        };

        if (playerState) {
          e.plst = this._getPlayerStateDiff(playerState || this._playerState);
          this._setCurrentPlayerState(playerState);
        }
        this._queueMessage(e);
        return e;
    },
    plusEvent: function(eventId, payload) {
        var e;
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            evid: eventId,
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },
    plusUIEvent: function(eventId, payload) {
        var e = {
            evcl: 'PLUSUI',
            srcty: 'PC',
            evid: eventId,
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },
    navigationEvent: function(fromScreen, toScreen, buttonID){
        var payload = {};
        payload.fro = fromScreen;
        payload.to  = toScreen;
        if(buttonID){
            payload.btnid = buttonID;
        }

        return this.plusUIEvent("NAV", payload);
    },
    sessionEndEvent: function() {
        if (!(this._sessionEnded)) {
            var e;
            var Capabilities = CapabilitiesReq.Capabilities;

            e = {
                evid:  'SFN',
                evcl:  'PLUS',
                srcty: 'PC',
                hwty:  Capabilities.getDeviceName(), // cat ro.product.manufacturer, ro.product.brandh, ro.product.model
                hwrev: Capabilities.getPlatformHW(), // cat ro.revision + ro.build.date.utc
                osrev: ""+  Capabilities.getPlatformOS() + " " + Capabilities.getPlatformOSVersion(), // ro.build.fingerprint
                lang: Capabilities.getLanguage()
            };

            e = this._queueMessage(e);
            this._sessionEnded = true;
            return e;
        }
        return null;
    },
    sessionStartEvent: function() {
        var e;
        var Capabilities = CapabilitiesReq.Capabilities;

        e = {
            evid:  'SST',
            evcl:  'PLUS',
            srcty: 'PC',
            hwty:  Capabilities.getDeviceName(), // cat ro.product.manufacturer, ro.product.brandh, ro.product.model
            hwrev: Capabilities.getPlatformHW(), // cat ro.revision + ro.build.date.utc
            osrev: ""+  Capabilities.getPlatformOS() + " " + Capabilities.getPlatformOSVersion(), // ro.build.fingerprint
            lang: Capabilities.getLanguage()
        };



        e = this._queueMessage(e);
        return e;
    },
    socialEvent: function(eventId, friendId,  payload) {
        var e;
        e = {
            evcl: 'SOCL',
            srcty: 'GC',
            frid: friendId,
            evid: eventId,
            evpl: payload
        };
        return this._queueMessage(e);
    },
    initPlayerState: function(inState) {
        this._setCurrentPlayerState(inState);
        return true;
    },

    updatePlayerState: function(newState) {
        this._setCurrentPlayerState(newState);
        return true;
    },

    //params for internal IAP events:

    //promo campaign unique identifier
    //promoid (String)

    //price of virtual good
    //price (Float)

    //currency used. Defaults to USD
    //cur (String)

    //user's moba balance after purchase
    //mobabalance (Integer)

    //unique identifier for purchase
    //orderid (String)

    //a string identifier for an item, e.g. "IceCastle"
    //sku (String)

    //the value of the item in moba
    //mobaprice (Float)

    //the quantity of item being purchased
    //itemamt (Float)

    //a text description of the item.
    //desc (String)

    //a message displayed to the user when the debit or credit occurs
    //dispmsg (String)

    //the name of the item, as displayed to the user
    //dispname (String)

    //the Mobage ID for the product.
    //productid (Integer)

    //dynamic data accepts a custom object with any params not included above
    //dynamicdata (Object)

    reportAdShow : function(adid) {
        return this.revenueEvent('ADSHOW',{'adid':adid});      
    },

    reportAdClick : function(adid) {
        return this.revenueEvent('ADCLCK',{'adid':adid});    
    },

    reportPromoShow : function(promoid) {
        return this.revenueEvent('PROMOSHOW',{'promoid':promoid});    
    },

    reportPromoClick : function(promoid) {
        return this.revenueEvent('PROMOCLCK',{'promoid':promoid});    
    },

    reportPromoRedeem : function(promoid) {
        return this.revenueEvent('PROMOREDM',{'promoid':promoid});    
    },

    //user clicks on money sku
    reportMoneyIAPIntent : function(sku,item_amt,price,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPINTENT', evpl);
    },

    //user cancels a money sku transaction
    reportMoneyIAPCancel : function(sku,item_amt,price,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPCANCEL', evpl);
    },

    //money sku transaction is successful; orderid required
    reportMoneyIAPSuccess : function(sku,item_amt,price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            orderid : orderid,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPSUCCESS',evpl);
    },

    //money iap purchase fails after being authorized by user; orderid optional if available, pass in null otherwise
    reportMoneyIAPFail : function(sku,item_amt,price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        orderid ? evpl.orderid = orderid : "";
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPFAIL', evpl);
    },

    //user opens money IAP store
    reportMoneyIAPShow : function() {
        return this.revenueEvent('IAPSHOW',{});
    },

    //user opens moba IAP store
    reportMobaIAPShow : function() {
        return this.revenueEvent('MOBAIAPSHOW',{});
    },

    //user clicks on a moba sku
    reportMobaIAPIntent : function(sku,moba_price,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPINTENT', evpl);
    },

    //user cancels moba sku transaction
    reportMobaIAPCancel : function(sku,moba_price,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPCANCEL', evpl);
    },

    //moba sku transaction is successful. orderid required. 
    reportMobaIAPSuccess : function(sku,moba_price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            orderid : orderid,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPSUCCESS', evpl);
    },

    //moba sku purchase fails after being authorized by user. orderid optional if available, pass in null otherwise
    reportMobaIAPFail : function(sku,moba_price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        orderid ? evpl.orderid = orderid : '';
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPFAIL', evpl);
    },

    /**
    * Report us scraping a facebook user's profile - ext_id is the user's facebook ID.
    *
    */
    reportFacebookScrape : function(ext_id, dynamicdata) {
        var e;
        var evpl={};
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            extid: ext_id,
            evid: 'FBSCRAPE',
            evpl: evpl
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * Report us scraping a user's contact list - ext_id is the user's facebook ID.
    *
    */
    reportContactScrape : function(dynamicdata) {
        var e;
        var evpl={};
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            evid: 'CONTACTSCRAPE',
            evpl: evpl
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * Report a user posting to another user's wall.
    *
    */
    reportWallPost : function(friendId, payload) {
        var e;
        e = {
            evcl: 'SOCL',
            srcty: 'PC',
            frid: friendId,
            evid: 'WALLPOST',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * Report a user downloading a game from a specific section in the store.
    * @param {String} game is the asku for the game being downloaded.
    * @param {String} section is the name of the section that the user downloaded from:
    *   AllGames, FeaturedGames, MyProfile, FriendsLastPlayedGame, FriendsPlayingGame
    * @param {String} slot is the order of the game in the section (if applicable)
    */
    reportDownload : function(game, section, slot) {
        var payload = {};
        payload.game = game;
        payload.section = section;
        payload.slot = slot;
        var e;
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            evid: 'DOWNLOAD',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * add internal tag to a user.
    */
    addTag : function(tagName) {
        var payload = {};
        payload.tag = tagName;
        var e;
        e = {
            evcl: 'PLUS',
            evid: 'TAG', 
            srcty: 'PC',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },

    getSeqNumber: function() {
        this._seqNumber += 1;
        return this._seqNumber;
    },

    getQueueCount: function() {
        return this._queue.length;
    },

    getSendDelay: function() {
        return this._sendDelay;
    },

    setSendDelay: function(val) {
        return (this._sendDelay = val);
    },

    setMeta: function(key, value) {
        if (!value) {
            value = key;
            return (this._meta = value);
        } else {
            return (this._meta[key] = value);
        }
    },

    getMeta: function(key) {
        if (key) {
            return this._meta[key];
        } else {
            return this._meta;
        }
    },

    _queueMessage: function(msg) {
        if (!msg) {
            return false;
        }

        var self = this;

        //This sets metas that don't change often
        this._setUnsetMetaKeys();

        // The rest of these function set properties that 
        msg = this._mergeMeta(msg);
        msg = this._addSeqDetails(msg);
        msg = this._addGeo(msg);
        msg = this._addEvts(msg);
        msg = this._addGameSku(msg);
        msg = this._addGameRel(msg);
        msg = this._addCarrier(msg);
        msg = this._addService(msg);
        msg = this._addPlatformVersion(msg);
        msg = this._addUserId(msg);
        msg = this._addUserName(msg);
        msg = this._normalizeValues(msg);
        var queue = this._getQueue();
        queue.push(msg);
        this._setQueue(queue);

        if (!this._isSendQueued) {
            setTimeout(function() {
                self._isSendQueued = false;
                return self._drainQueue();
            }, self._sendDelay);
        }
        return msg;
    },
    _tagQa: function() {
        var fs = require('NGCore/Client/Storage/FileSystem').FileSystem;
        var self = this;
        fs.readFile('QA',function(err,data) {
            if (!err) {
                self.addTag("NGMOCOQA");
            }
        });
    },
    _hookGeo: function() {
        var Social = require('NGCore/Client/Social').Social;
        if(Social.US){
            var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
            var Device = require('NGCore/Client/Device').Device, self = this;
            var LocationListener = MessageListener.subclass({
                initialize: function() {
                    Device.LocationEmitter.addListener(this, this.onUpdate, false);
                },
                onUpdate: function(location) {
                    self._location = location;
                    Device.LocationEmitter.removeListener(this);
                    self._locListener = null;
                }
            });
            this._locListener = new LocationListener();
        }
    },
    _hookLifetime: function() {
        var self = this;
        var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
        var Device = require('NGCore/Client/Device').Device;
        var ListenerClass =  MessageListener.subclass({
            initialize: function() {
                Device.LifecycleEmitter.addListener(this, this.onLifecycleUpdate);
            },
            onLifecycleUpdate: function(event) {
                switch (event) {
                case Device.LifecycleEmitter.Event.Suspend:
                case Device.LifecycleEmitter.Event.Terminate:
                    self.sessionEndEvent();
					self._drainQueue();
                    break;
                case Device.LifecycleEmitter.Event.Resume:
                default:
                    self.initialize();
                    break;
                }
            }
        });
        if (!this._listener) {
            this._listener = new ListenerClass();
        }
    },
    /**
    * Game Service running inside privileged interpreter may use this method
    * to change the Social Analytic object to be used.  Please see MOBWEST-2300
	* for details
	*
    * @private
    */
	_setSocialAnalytics: function(obj) {
		this._socAnalytics = obj;
	},
    _setUnsetMetaKeys: function() {
        var Capabilities = CapabilitiesReq.Capabilities, udid;
        if ((!this.getMeta('udid')) && (udid = Capabilities.getUniqueId() )) {
            this.setMeta('udid', udid);
        }

        if (!this.getMeta('sid')) {
            var sid = ''+ hex_sha1(this._seqStart+ (this.getMeta('udid')|| "UNKNOWN"));
            this.setMeta('sid', sid);
        }

        if (!this.getMeta('pltfmsku')) {
            var platRegex = /android/;

            var plat = Capabilities.getPlatformOS();
            if (plat) {
                plat = plat.toLowerCase();
                if (plat.match(platRegex) ) {
                    plat = "android";
                } else if ("flash" === plat ) {
                    plat = "flash";
                } else {
                    plat = "ios";
                }
                this.setMeta( 'pltfmsku', plat);
            }
        }

        if (!this.getMeta('apiver')) {
            this.setMeta('apiver', 5);
        }
        return true;
    },

    _getPlayerStateDiff: function(newState) {
        var delta_sign, delta_value, diff, key, value;
        diff = {};
        if (!this._playerState) {
            this._setCurrentPlayerState(newState);
        }
        for (key in newState) {
            if (!__hasProp.call(newState, key)) continue;
            value = newState[key];
            if (typeof value === 'number') {
                delta_value = (value - this._playerState[key]) || 0;
                if (delta_value < 0) {
                    delta_sign = '-';
                }
                if (delta_value >= 0) {
                    delta_sign = '+';
                }
                diff[key] = "" + delta_sign + "," + Math.abs(delta_value) + "," + (this._playerState[key]);
            } else if (typeof value === 'string') {
                diff[key] = value;
            }
        }
        return diff;
    },

    _setCurrentPlayerState: function(pst) {
        var key, value;
        this._playerState = {};
        for (key in pst) {
            if (!__hasProp.call(pst, key)) continue;
            value = pst[key];
            this._playerState[key] = value;
        }
        return true;
    },

    _addEvts: function(msg) {
      var d = new Date(); 
      msg.evts =  d.getTime();
      return msg;
    },
    _addGeo: function(msg) {
        var loc_point;

        if (this._location && (loc_point = this._location.getPosition())  && !isNaN(loc_point.getX()) && !isNaN(loc_point.getY())) {
            msg.geo = "" + loc_point.getX() + "," + loc_point.getY();
        }
        return msg;
    },
    _addCarrier: function(msg) {
        var Capabilities = CapabilitiesReq.Capabilities;
        var carr = Capabilities.getCarrier();
        if (carr) {
            msg.carr = carr;
        }
        return msg;
    },
    _addService: function(msg) {
        var Analytics = this._socAnalytics;
        msg.srvc = Analytics.getServiceId();
        return msg;
    },
    _addPlatformVersion: function(msg) {
        var Analytics = this._socAnalytics;
        msg.pver = Analytics.getPlatformVersion();
        return msg;

    },
    _addSeqDetails: function(msg) {
        this._seqNum += 1;
        msg.seq = this.getSeqNumber();
        msg.seqdt = new Date().getTime() - this._seqStart;
        return msg;
    },
    _addUserId: function(msg) {
      var Analytics = this._socAnalytics;
      var uid = Analytics.getUserId();
      if (uid) {
        msg.uid = uid;
      }
      return msg;
    },
    _addUserName: function(msg) {
      var Analytics = this._socAnalytics;
      var un = Analytics.getUsername();
      if (un) {
        msg.plus = un;
      }
      return msg;
    },
    _addGameSku: function(msg) {
        var app_key = (Capabilities.getConfigs() || {} )["appId"];
        if ( app_key ) {
            msg.asku = app_key;
        }
        return msg;
    },
    _addGameRel: function(msg) {
        var arel = Capabilities.getAppReleaseVersion();
        if (arel) {
          msg.arel = arel;
        }
        return msg;
    },
    _normalizeValues: function(msg) {
        var key, value;
        for (key in msg) {
            if (!__hasProp.call(msg, key)) continue;
            value = msg[key];
            if (typeof value === 'string') {
                value = this._normalizeString(key, value);
            } else if (typeof value === 'object') {
                value = this._normalizeValues(value);
            }
            msg[key] = value;
        }
        return msg;
    },

    _normalizeString: function(key, value) {
        value = value.substring(0, this._allowedLargeValue[key] || 32);
        if (-1 !== this._capAlphaNumStringKeys.indexOf(key)) {
            value = value.toUpperCase().replace(/[^\w]+/g, "").replace("_", "");
        }
        return value;
    },

    _mergeMeta: function(msg) {
        var _ref, _ref2, key, new_msg, value;
        new_msg = {};
        for (key in msg) {
            if (!__hasProp.call(msg, key)) continue;
            value = msg[key];
            new_msg[key] = value;
        }
        for (key in _ref = this._meta) {
            if (!__hasProp.call(_ref, key)) continue;
            value = _ref[key];
            (_ref2 = new_msg[key]) ? _ref2 : new_msg[key] = value;
        }
        return new_msg;
    },

    _drainQueue: function() {
        var cb, self, toDrain;
        toDrain = this._getQueue();
        this._setQueue([]);
        self = this;

        if (! this._sendToRemote)
            return true;

        cb = function(state, not_sent) {
            if (state === NgPipesRemote.possibleStates.error) {
                self._queueMany(not_sent);
                self._sendDelay = self._sendDelay * 2;
            } else if (state === NgPipesRemote.possibleStates.finished ) {
                self._sendDelay = 5000;
            }
            return true;
        };
        NgPipesRemote.clearQueue(toDrain, cb);
        toDrain = null; // explicit clear to keep memory down
        return true;
    },

    _queueMany: function(msg_arr) {
        var _i, _len, msg, self = this;
        this._setQueue( (this._getQueue() || [] ).concat(msg_arr) );
        if (this._isSendQueued) {
          this._isSendQueued = true;
          setTimeout(function() {
              self._isSendQueued = false;
              return self._drainQueue();
          }, self._sendDelay);
        }

        return true;
    },
    _setQueue: function(new_queue) {
        this._queue = new_queue;
        Storage.KeyValueCache.global(this._globalKey).setItem(this._globalKey, JSON.stringify(this._queue));
        return true;
    },
    _getQueue: function() {
        return this._queue;

    }
});

exports.NgPipe = NgPipe;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/NgPipesRemote'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/NgPipesRemote'] || {}; $MODULE_REGISTRY['NGCore/Shared/NgPipesRemote'] = exports; var Network = require('NGCore/Client/Network').Network;

NgPipesRemote = {
  listeners: [],
  debug: false,

  possibleStates: {
    unknown: {},
    finished: {},
    error: {}
  }
};

NgPipesRemote.addListener = function(listner) {
  this.listeners.push(listner);
  return true;
};

NgPipesRemote.clearQueue = function(queue, callback) {

  if (!queue) {
    return false;
  }

  if (!this.getUrl()) {
    if (callback) {
      callback(NgPipesRemote.possibleStates.finished, []);
    }
    return false;
  }
	var copy_array = queue.slice(0, queue.length);

	var _j, _len2, data;
  while (copy_array && copy_array.length > 0) {
    var to_send = copy_array.slice(0, 10);
    copy_array = copy_array.slice(10);
    data = "";

    for (_j = 0, _len2 = to_send.length; _j < _len2; _j++) {
      data += JSON.stringify(to_send[_j]);
      if (_j+1 < _len2) {
         data += "\r\n";
      } //if len
    } //for

    if (data) {
      NgPipesRemote._makeRequest(data, to_send, callback);
    } //if data
  }//while

};

NgPipesRemote._makeRequest = function(json_data, objs, callback) {
  var request = new Network.XHR(), url = this.getUrl();
  if (this.debug) {
    NgPipesRemote._debugOutput(json_data);
  }

	var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;
	LifecycleEmitter.requestEngineKeepAlive(objs);
  request.onreadystatechange = function() {
    var status = null;
    try {
      if (this.readyState === 4) {
		LifecycleEmitter.cancelEngineKeepAlive(objs);
        status = NgPipesRemote._handleResponse(request.responseText);
      } else {
        status = NgPipesRemote.possibleStates.unknown;
      }
    } catch (ex) {
      status = NgPipesRemote.possibleStates.error;
      NgLogException(ex);
    }

    if (callback) {
      callback(status, objs);
    }

    NgPipesRemote._notifyListeners(status);
    return true;
  };

  request.open("POST", url, true);

  request.setRequestHeader("X-Ngpipes-Api", "1.0");
  request.setRequestHeader("Content-Type", "application/json+batch");
  request.setRequestHeader("If-None-Match", "0");

  request.send(json_data);

  NgPipesRemote._notifyListeners('started');
  return true;
};
NgPipesRemote.setUrl = function(url) {
    this.url = url;
};
NgPipesRemote.getUrl = function() {
    if (this.url)
        return this.url;
    var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
    var url = null;
    
    if (Capabilities) {
      //Get the url from the configuration.json
      url = (Capabilities.getConfigs() || {} )["analyticsServer"] || null;
      if (url) {
        url = "https://"+url+"/pipes/r.2/bulk_record_stats";
        if (this.debug) {
          NgLogD("Pipes URL => " + url );
        }
      }
    }
    return url;
};


NgPipesRemote._handleResponse = function(respText) {
  var respObj, result;
  result = NgPipesRemote.possibleStates.unknown;
  if (respText && respText.length > 0) {
    try {
    respObj = JSON.parse(respText);
    } catch (e) {
      //Clean up after ourselves.
      respObj = null;
    }
	if (respObj  && (respObj.success !== null && respObj.success !== undefined ) && respObj.success) {
      if (this.debug) {
        NgLogD("[NgPipesRemote] Got Success" );
      }
      result = NgPipesRemote.possibleStates.finished;
    } else {
      result = NgPipesRemote.possibleStates.error;
    }
  } else {
      if (this.debug) {
        NgLogD('[NgPipesRemote] ERROR posting');
      }

    result = NgPipesRemote.possibleStates.error;
  }
  return result;
};

NgPipesRemote._debugOutput = function(str) {
  var _i, _len, _result, msg, msgs;
  msgs = str.split("\r\n");
  for (_i = 0, _len = msgs.length; _i < _len; _i++) {
    msg = msgs[_i];
    NgLogD("[NgPipesRemote] Message sent: " + msg);
  }
  return false;
};

NgPipesRemote._notifyListeners = function(state) {
  var _i, _len, _ref, l;
  for (_i = 0, _len = (_ref = this.listeners).length; _i < _len; _i++) {
    l = _ref[_i];
    l(state);
  }
  return true;
};

exports.NgPipesRemote = NgPipesRemote;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/sha1'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/sha1'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/sha1'] = exports; /*
 * @description
 * A JavaScript implementation of the Secure Hash Algorithm, SHA-1, as defined
 * in FIPS PUB 180-1
 * Version 2.1a Copyright Paul Johnston 2000 - 2002.
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See http://pajhome.org.uk/crypt/md5 for details.
 * @namespace
 * @name sha1
 */

/*
 * Configurable variables. You may need to tweak these to be compatible with
 * the server-side, but the defaults work in most cases.
 */
var hexcase = 0;  /* hex output format. 0 - lowercase; 1 - uppercase        */
var b64pad  = ""; /* base-64 pad character. "=" for strict RFC compliance   */
var chrsz   = 8;  /* bits per input character. 8 - ASCII; 16 - Unicode      */

/*
 * Add integers, wrapping at 2^32. This uses 16-bit operations internally
 * to work around bugs in some JS interpreters.
 */
function safe_add(x, y)
{
  var lsw = (x & 0xFFFF) + (y & 0xFFFF);
  var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
  return (msw << 16) | (lsw & 0xFFFF);
}

/*
 * Bitwise rotate a 32-bit number to the left.
 */
function rol(num, cnt)
{
  return (num << cnt) | (num >>> (32 - cnt));
}

/*
 * Perform the appropriate triplet combination function for the current
 * iteration
 */
function sha1_ft(t, b, c, d)
{
  if(t < 20) { return (b & c) | ((~b) & d); }
  if(t < 40) { return b ^ c ^ d; }
  if(t < 60) { return (b & c) | (b & d) | (c & d); }
  return b ^ c ^ d;
}

/*
 * Determine the appropriate additive constant for the current iteration
 */
function sha1_kt(t)
{
  return (t < 20) ?  1518500249 : (t < 40) ?  1859775393 :
         (t < 60) ? -1894007588 : -899497514;
}

/*
 * Calculate the SHA-1 of an array of big-endian words, and a bit length
 */
function core_sha1(x, len)
{
  /* append padding */
  x[len >> 5] |= 0x80 << (24 - len % 32);
  x[((len + 64 >> 9) << 4) + 15] = len;

  var w = Array(80);
  var a =  1732584193;
  var b = -271733879;
  var c = -1732584194;
  var d =  271733878;
  var e = -1009589776;

  for(var i = 0; i < x.length; i += 16)
  {
    var olda = a;
    var oldb = b;
    var oldc = c;
    var oldd = d;
    var olde = e;

    for(var j = 0; j < 80; j++)
    {
      if(j < 16) { w[j] = x[i + j]; }
      else {
		w[j] = rol(w[j-3] ^ w[j-8] ^ w[j-14] ^ w[j-16], 1);
	  }
      var t = safe_add(safe_add(rol(a, 5), sha1_ft(j, b, c, d)),
                       safe_add(safe_add(e, w[j]), sha1_kt(j)));
      e = d;
      d = c;
      c = rol(b, 30);
      b = a;
      a = t;
    }

    a = safe_add(a, olda);
    b = safe_add(b, oldb);
    c = safe_add(c, oldc);
    d = safe_add(d, oldd);
    e = safe_add(e, olde);
  }
  return Array(a, b, c, d, e);

}

/*
 * Convert an 8-bit or 16-bit string to an array of big-endian words
 * In 8-bit function, characters >255 have their hi-byte silently ignored.
 */
function str2binb(str)
{
  var bin = Array();
  var mask = (1 << chrsz) - 1;
  for(var i = 0; i < str.length * chrsz; i += chrsz) {
    bin[i>>5] |= (str.charCodeAt(i / chrsz) & mask) << (32 - chrsz - i%32);
  }
  return bin;
}

/**
 * @description
 * Call the <code>core_hmac_sha1()</code> function to calculate the HMAC-SHA1 of a key and some data.
 * A JavaScript implementation of the Secure Hash Algorithm, SHA-1, as defined
 * in FIPS PUB 180-1
 * Version 2.1a Copyright Paul Johnston 2000 - 2002.
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See <a href="http://pajhome.org.uk/crypt/md5">this</a> or <a href="http://www.itl.nist.gov/fipspubs/fip180-1.htm">NIST</a> for details.
 * @namespace
 * @name core_hmac_sha1
 * @function
 * @param key The key to use with sha1.
 * @param data The data to hash.
 * @return A sha1 hash of the data and key.
 * @example
 * var key = "12345"
 * var data = "The data I would like to hash."
 * core_hmac_sha1(key, data);
 */
function core_hmac_sha1(key, data)
{
  var bkey = str2binb(key);
  if(bkey.length > 16) {
	bkey = core_sha1(bkey, key.length * chrsz);
  }

  var ipad = Array(16), opad = Array(16);
  for(var i = 0; i < 16; i++)
  {
    ipad[i] = bkey[i] ^ 0x36363636;
    opad[i] = bkey[i] ^ 0x5C5C5C5C;
  }

  var hash = core_sha1(ipad.concat(str2binb(data)), 512 + data.length * chrsz);
  return core_sha1(opad.concat(hash), 512 + 160);
}

/*
 * Convert an array of big-endian words to a string
 */
function binb2str(bin)
{
  var str = "";
  var mask = (1 << chrsz) - 1;
  for(var i = 0; i < bin.length * 32; i += chrsz) {
    str += String.fromCharCode((bin[i>>5] >>> (32 - chrsz - i%32)) & mask);
  }
  return str;
}

/*
 * Convert an array of big-endian words to a hex string.
 */
function binb2hex(binarray)
{
  var hex_tab = hexcase ? "0123456789ABCDEF" : "0123456789abcdef";
  var str = "";
  for(var i = 0; i < binarray.length * 4; i++)
  {
    str += hex_tab.charAt((binarray[i>>2] >> ((3 - i%4)*8+4)) & 0xF) +
           hex_tab.charAt((binarray[i>>2] >> ((3 - i%4)*8  )) & 0xF);
  }
  return str;
}

/*
 * Convert an array of big-endian words to a base-64 string
 */
function binb2b64(binarray)
{
  var tab = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
  var str = "";
  for(var i = 0; i < binarray.length * 4; i += 3)
  {
    var triplet = (((binarray[i   >> 2] >> 8 * (3 -  i   %4)) & 0xFF) << 16) |
                  (((binarray[i+1 >> 2] >> 8 * (3 - (i+1)%4)) & 0xFF) << 8 ) |
                   ((binarray[i+2 >> 2] >> 8 * (3 - (i+2)%4)) & 0xFF);
    for(var j = 0; j < 4; j++)
    {
      if(i * 8 + j * 6 > binarray.length * 32){
		str += b64pad;
	  } else {
		str += tab.charAt((triplet >> 6*(3-j)) & 0x3F);
	  }
    }
  }
  return str;
}

/*
 * These are the functions you'll usually want to call
 * They take string arguments and return either hex or base-64 encoded strings
 */
function hex_sha1(s){return binb2hex(core_sha1(str2binb(s),s.length * chrsz));}
function b64_sha1(s){return binb2b64(core_sha1(str2binb(s),s.length * chrsz));}
function str_sha1(s){return binb2str(core_sha1(str2binb(s),s.length * chrsz));}
function str_hmac_sha1(key, data){ return binb2str(core_hmac_sha1(key, data));}
function hex_hmac_sha1(key, data){ return binb2hex(core_hmac_sha1(key, data));}
function b64_hmac_sha1(key, data, padChar){
	if ((typeof padChar != "undefined") && padChar) {
        b64pad = padChar;
	}
	return binb2b64(core_hmac_sha1(key, data));
}

/*
 * Perform a simple self-test to see if the VM is working
 */
function sha1_vm_test()
{
  return hex_sha1("abc") == "a9993e364706816aba3e25717850c26c9cd0d89d";
}

// Exports for node.js
if((typeof exports != "undefined") && exports)
{
	exports.b64_hmac_sha1 = b64_hmac_sha1;
	exports.hex_sha1 = hex_sha1;
	exports.b64_sha1 = b64_sha1;
}
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social'] || {}; $MODULE_REGISTRY['NGCore/Client/Social'] = exports; /**
 * Public API for GameService
 * 
 * Access this file as NGCore/Client/Social.js
 */

// Note the proper require path for our public interface files is: "./Social/US/[filename]"

/** @namespace
 * @name Social
 * @description
 * The <code>Social</code> namespace provides interfaces for the Mobage Social APIs.
 */
exports.Social = {
};

/** @namespace
 * @name Social.Common
 * @description
 * The <code>Social.Common</code> namespace provides interfaces for functionality common to submodules for Japan (JP), the United States (US), 
 * and future submodules. The common features include Auth, People, Appdata, Blacklist, Profanity and Service. Service APIs can be both common
 * or native, and include the Community button, the Balance button, the Friend Picker, the User Finder, and the User Profile.
 */
exports.Social.Common = {
	Appdata: require('NGCore/Client/Social/US/Common/Appdata').Appdata,
	Auth: require('NGCore/Client/Social/US/Common/Auth').Auth,
	Blacklist: require('NGCore/Client/Social/US/Common/Blacklist').Blacklist,
	Config: require('NGCore/Client/Social/US/Common/Config').Config,
	People: require('NGCore/Client/Social/US/Common/People').People,
	Profanity: require('NGCore/Client/Social/US/Common/Profanity').Profanity,
	Request: require('NGCore/Client/Social/US/Common/Request').Request,
	Service: require('NGCore/Client/Social/US/Common/Service').Service,
  Analytics: require('NGCore/Client/Social/US/Common/Analytics').Analytics
};

/** @namespace
 * @name Social.US
 * @description
 * The <code>Social.US</code> namespace provides interfaces for the United States (US) submodule. 
 * The features include User, Game, Leaderboard, Score, Ordered List, and AppData.
 */
exports.Social.US = {
	// Data Models
	DataModel: require('NGCore/Client/Social/US/Models/DataModel').DataModel,
	User: require('NGCore/Client/Social/US/Models/User').User,
	Game: require('NGCore/Client/Social/US/Models/Game').Game,
	Leaderboard: require('NGCore/Client/Social/US/Models/Leaderboard').Leaderboard,
	Score: require('NGCore/Client/Social/US/Models/Score').Score,
	
	AppData: require('NGCore/Client/Social/US/Models/AppData').AppData,
	
	// Data Cache
	Cache: require('NGCore/Client/Social/US/Models/Cache').Cache,

	// Data APIs
	Session: require('NGCore/Client/Social/US/Data/Session').Session,
	Dispatcher: require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher
};

/** @namespace
 * @name Social.US.Service
 * @description
 * Service APIs include the Community button, the Balance button, the Friend Picker, the User Finder, and the User Profile.
 */
exports.Social.US.Service = {
	Friends: require('NGCore/Client/Social/US/Service/Friends').Friends,
	Profile: require('NGCore/Client/Social/US/Service/Profile').Profile,
	ButtonOverlays: require('NGCore/Client/Social/US/Service/ButtonOverlays').ButtonOverlays,
	GameLaunchPayload: require('NGCore/Client/Social/US/Service/GameLaunchPayload').GameLaunchPayload
};

/** @namespace
 * @name Bank
 * @description
 * The <code>Bank</code> namespace provides interfaces for the Mobage Bank APIs.
 */
exports.Bank = require('NGCore/Client/Social/US/Service/Bank').Bank;; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Storage/FileSystem'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Storage/FileSystem'] || {}; $MODULE_REGISTRY['NGCore/Client/Storage/FileSystem'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class FileSystem
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Class = require('NGCore/Client/Core/Class').Class;

////////////////////////////////////////////////////////////////////////////////

exports.FileSystem = Class.singleton(
/** @lends Storage.FileSystem.prototype */
{
	classname: 'FileSystem',
	
	/**
	 * @class The <code>FileSystem</code> class constructs a singleton object that controls file manipulation tasks: reading, writing, deleting, or decompressing a file.
	 * 
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */
	initialize: function()
	{
		/** @private */
		this.readRequests = {};
		/** @private */
		this.writeRequests = {};
		/** @private */
		this.cbIdCounter = 1;
		
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	/**
	 * Read a file into memory from local storage.
	 * @example FileSys.readFile(SomeFile, true, function(err, data){...}
	 * @param {String} fname The name of the file to read into memory.
	 * @param {Boolean} [binary=false] Set as <code>true</code> if <code>readFile()</code> shouuld conduct a binary read.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file read operation fails.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	readFile: function( fname, binary, cb )
	{
		this.readFileIn(this.Store.Local, fname, binary, cb);
	},

	/**
	 * @private
	 *	read a file from a common store on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location to read from
	 *	@param {fname} The name of the file to be read
	 *	@param {cb} The callback function to be called
	 *	@param {binary} binary mode or not
     *  @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	readFileIn: function( store, fname, binary, cb )
	{
		var cbId = 0;

		if(typeof(binary) == 'function')
		{
			cb = binary;
			binary = false;
		}
		binary = binary || false;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.readRequests[ cbId ] = cb;
		}
		this._readFileSendGen(cbId,store,fname,binary);
	},

	/**
	 * Write a file to local storage.
	 * @example FileSys.writeFile(SomeFile, someData, true, (function(){...});
	 * @param {String} fname The name of the file to write into storage.
	 * @param {Binary, String} data The data to write to the file.
	 * @param {Boolean} [binary=false] Set as <code>true</code> if <code>writeFile()</code> should conduct a binary write.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file write operation fails.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	writeFile: function( fname, data, binary, cb )
	{
		this.writeFileIn(this.Store.Local, fname, data, binary, cb);
	},

	/**
	 * @private
	 *	write a file to a common store on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location to write to
	 *	@param {fname} The name of the file to be written
	 *	@param {cb} The callback function to be called after completion
	 *	@param {binary} binary mode or not
     *  @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	writeFileIn: function( store, fname, data, binary, cb )
	{
		var cbId = 0;

		if(typeof(binary) == 'function')
		{
			cb = binary;
			binary = false;
		}
		binary = binary || false;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.writeRequests[ cbId ] = cb;
		}

		this._writeFileSendGen(cbId,store,fname,data,binary);
	},

	/**
	 * Delete a file from local storage.
	 * @example FileSys.deleteFile(SomeFile,function(err, data){});
	 * @param {String} fname The name of the file to delete.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file delete operation fails.
     * @status iOS, Android, Test, iOSTested, AndroidTested     
	 */
	deleteFile: function ( fname, cb )
	{
		this.deleteFileIn(this.Store.Local, fname, cb);
	},

	/**
	 * @private
	 *	delete a file from a common store on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location path
	 *	@param {fname} The name of the file to be deleted
	 *	@param {cb} The callback function to be called
     *  @status iOS, Android, Test, iOSTested, AndroidTested     
	 */
	deleteFileIn: function ( store, fname, cb )
	{
		var cbId = 0;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.writeRequests[ cbId ] = cb;
		}
		this._deleteFileSendGen(cbId,store,fname);
	},
	
	/**
	 * Decompress a zipfile.
	 * @example FileSys.readFile(SomeFile, ./some/path/to/destination/, true, function(err, data){...}
	 * @param {String} fname The name of the zipfile to decompress.
	 * @param {String} destination The directory path where the contents of the decompressed file are written.
	 * @param {Boolean} [returnFiles] Set as <code>true</code> if <code>decompressFile()</code> should return a list of files contained in the zipfile specified by the <code>fname</code> parameter.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file decompress operation fails.
     * @status iOS, Android
	 */
	decompressFile: function( fname, destination, returnFiles, cb )
	{
		this.decompressFileIn(this.Store.Local, fname, destination, returnFiles, cb);
	},
	
	/**
	 * @private
	 *	decompress a file to a shared location on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location path
	 *	@param {fname} The name of the file to be read
	 *	@param {cb} The callback function to be called
	 *	@param {destination} destination location to unzip files to
	 *	@param {returnFiles} true/false if true it returns a json object with a list of each file, its MD5 hash and its size
     *  @status iOS, Android    
	 */
	decompressFileIn: function( store, fname, destination, returnFiles, cb )
	{
		var cbId = 0;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.writeRequests[ cbId ] = cb;
		}
		this._decompressFileSendGen(cbId,store,fname,destination,returnFiles);
	},
	
	/**
	 * @private
	 */
	_readFileCbRecv: function( cmd ) 
	{
		var msg = {};
		if(!this._readFileCbRecvGen(cmd, msg))
			return;
			
		var cbId = msg[ "callbackId" ];
		var data = msg[ "data" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			NgLogE ( "FileSystem.onReadFile: No cbId" );
			return;
		}
		
		var cb = this.readRequests[ cbId ];
		
		if ( !cb )
		{
			NgLogE ( "FileSystem.onReadFile: No registered cb found..cbId is :" + cbId );
			return;
		}
		
		delete this.readRequests[ cbId ];
		cb ( err, data );
	},
	
	/**
	 * @private
	 */
	_writeFileCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._writeFileCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg[ "callbackId" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			//NgLogE ( "FileSystem command : No cbId" );
			return;
		}
		
		var cb = this.writeRequests[ cbId ];
			
		if ( !cb )
		{
			NgLogE ( "FileSystem command : No registered cb found..cbId is :" + cbId );
			return;
		}

		delete this.writeRequests[ cbId ];
		cb ( err );
	},
	
	/**
	 * @private
	 */
	_deleteFileCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._deleteFileCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg[ "callbackId" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			//NgLogE ( "FileSystem command : No cbId" );
			return;
		}
		
		var cb = this.writeRequests[ cbId ];
		
		if ( !cb )
		{
			NgLogE ( "FileSystem command : No registered cb found..cbId is :" + cbId );
			return;
		}
		
		delete this.writeRequests[ cbId ];
		cb ( err );
	},
	
	/**
	 * @private
	 */
	_decompressFileCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._decompressFileCbRecvGen(cmd, msg))
			return;
			
		var cbId = msg[ "callbackId" ];
		var files = msg[ "files" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			//NgLogE ( "FileSystem command : No cbId" );
			return;
		}
		
		var cb = this.writeRequests[ cbId ];
		
		if ( !cb )
		{
			NgLogE ( "FileSystem command : No registered cb found..cbId is :" + cbId );
			return;
		}
		
		try
		{
			files = JSON.parse(files);
		}
		catch(e)
		{
			NgLogE ( "FileSystem command : Could not parse response :" + files );
			err = "Could not parse files";
		}
		
		delete this.writeRequests[ cbId ];
		cb ( err, files );
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	Store:
	{ 
		/** /tmp */
		Temp: 0,
		/** local sandbox */
		Local: 1,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 338
	// Method create = -1
	// Method readFile = 2
	// Method writeFile = 3
	// Method deleteFile = 4
	// Method decompressFile = 5
	// Method readFileCb = 6
	// Method writeFileCb = 7
	// Method deleteFileCb = 8
	// Method decompressFileCb = 9
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 6:
					instance._readFileCbRecv( cmd );
					break;
				case 7:
					instance._writeFileCbRecv( cmd );
					break;
				case 8:
					instance._deleteFileCbRecv( cmd );
					break;
				case 9:
					instance._decompressFileCbRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in FileSystem._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in FileSystem._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[338] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_readFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "data" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "data" ] === undefined )
		{
			NgLogE("Could not parse data in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_writeFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.writeFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.writeFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.writeFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_deleteFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.deleteFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.deleteFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.deleteFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_decompressFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "files" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "files" ] === undefined )
		{
			NgLogE("Could not parse files in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":338,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_readFileSendGen: function( callbackId, storeId, filename, binary )
	{
		Core.Proc.appendToCommandString( ":338,2," + this.__objectRegistryId + "," + callbackId + "," + storeId + "," + Core.Base64.encode( filename ) + "," + ( binary ? 1 : 0 )  );
	},
	
	/** @private */
	_writeFileSendGen: function( callbackId, storeId, filename, data, binary )
	{
		Core.Proc.appendToCommandString( ":338,3," + this.__objectRegistryId + "," + callbackId + "," + storeId + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( data ) + "," + ( binary ? 1 : 0 )  );
	},
	
	/** @private */
	_deleteFileSendGen: function( callbackId, storeId, filename )
	{
		Core.Proc.appendToCommandString( ":338,4," + this.__objectRegistryId + "," + callbackId + "," + storeId + "," + Core.Base64.encode( filename )  );
	},
	
	/** @private */
	_decompressFileSendGen: function( callbackId, storeId, filename, destination, returnFiles )
	{
		Core.Proc.appendToCommandString( ":338,5," + this.__objectRegistryId + "," + callbackId + "," + storeId + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( destination ) + "," + ( returnFiles ? 1 : 0 )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// readFile: function( callbackId, storeId, filename, binary ) {}
	
	// writeFile: function( callbackId, storeId, filename, data, binary ) {}
	
	// deleteFile: function( callbackId, storeId, filename ) {}
	
	// decompressFile: function( callbackId, storeId, filename, destination, returnFiles ) {}
	
	// _readFileCbRecv: function( cmd ) {}
	// _writeFileCbRecv: function( cmd ) {}
	// _deleteFileCbRecv: function( cmd ) {}
	// _decompressFileCbRecv: function( cmd ) {}

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network'] || {}; $MODULE_REGISTRY['NGCore/Client/Network'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Network
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////
/**
 * @name Network
 * @namespace
 * <p>Classes and objects contained by the Network module.</p>
 * @description <p>The Network module is a collection of classes that support manipulation of network flow.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 *<ul>
 *<li><code>{@link Network.DownloadFile}</code>: Construct objects that conduct a file download.</li>
 *<li><code>{@link Network.DownloadManifest}</code>: Construct objects that keep manifests up-to-date.</li>
 *<li><code>{@link Network.XHR}</code>: Construct XmlHttpRequest objects.</li>
 *</ul>
 */
exports.Network = {};

exports.Network.__defineGetter__("XHR", function() {
	delete this.XHR;
	return this.XHR = require('NGCore/Client/Network/XHR').XHR;
});
exports.Network.__defineGetter__("DownloadFile", function() {
	delete this.DownloadFile;
	return this.DownloadFile = require('NGCore/Client/Network/DownloadFile').DownloadFile;
});
exports.Network.__defineGetter__("DownloadManifest", function() {
	delete this.DownloadManifest;
	return this.DownloadManifest = require('NGCore/Client/Network/DownloadManifest').DownloadManifest;
});
exports.Network.__defineGetter__("Util", function() {
	delete this.Util;
	return this.Util = require('NGCore/Client/Network/Util').Util;
});
exports.Network.__defineGetter__("_int_Util", function() {
	delete this._int_Util;
	return this._int_Util = require('NGCore/Client/Network/_int_Util')._int_Util;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/LifecycleEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/LifecycleEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/LifecycleEmitter'] = exports; var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Proc = require('NGCore/Client/Core/Proc').Proc;

exports.LifecycleEmitter = MessageEmitter.singleton(
/** @lends Device.LifecycleEmitter.prototype */
{
	classname: 'LifecycleEmitter',
		
	/**
	 * @class The <code>LifecycleEmitter</code> class constructs a singleton object that emits <code><a href="Device.LifecycleEmitter.html#Event">Event</a></code> 
	 * objects when device lifecycle events occur.
	 * Applications can respond to these events by notifying external sources. For example,
	 * an application can respond to a <code>Terminate</code> event by writing an analytics log.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		/** @private */
		this.identificationCache = {};
		this.numEngineRequests = 0;
	},
	
	_lifecycleEventRecv: function( cmd )
	{
		var msg = {};
		if(!this._lifecycleEventRecvGen(cmd, msg))
			return;
			
		this.emit(msg.event);
		//Cascade the original message back out to native for forwarding
		//	to the next interpreter in the chain.
		this._lifecycleEventSendGen(msg.event);
	},

	/** @private */
	$exitProcess: function()
	{
		this._exitProcessSendGen();
	},
	
	/** @private */
	$_bgMe: function()
	{
		this.__bgMeSendGen();
	},

	/** @private */
	$pauseGame: function()
	{
		NgLogD("+++++++++++++++++++++++++++++++++++++++++Pausing Game");
		this._pauseGameSendGen();
		var _lgl = require('NGCore/Client/Core/_LocalGameList')._LocalGameList;
		_lgl._pausingGame();
	},

	/** @private */
	$resumeGame: function()
	{
		NgLogD("+++++++++++++++++++++++++++++++++++++++++Resuming Game");
		this._resumeGameSendGen();
		var _lgl = require('NGCore/Client/Core/_LocalGameList')._LocalGameList;
		_lgl._resumingGame();
	},

	requestEngineKeepAlive: function(obj)
	{
		var key = obj;
		if (obj.identification_key !== undefined)
		{
			key = obj.identification_key;
		}

		{
			//Store identification key and increment request to engine
			this.identificationCache[key] = true;
			++this.numEngineRequests;
			this.incrementEngineAlive();
		}
	},
	
	cancelEngineKeepAlive: function(obj)
	{
		var key = obj;
		if (obj.identification_key !== undefined)
		{
			key = obj.identification_key;
		}

		{
			if (this.identificationCache[key])
			{
				//Store identification key and increment request to engine
				delete this.identificationCache[key];
				--this.numEngineRequests;
				this.decrementEngineAlive();
			}else{
				NgLogD("Identification Key not found");
			}
		}
	},

	incrementEngineAlive: function()
	{
		this._incrementEngineAliveSendGen();
	},
	
	decrementEngineAlive: function()
	{
		this._decrementEngineAliveSendGen();
	},
	
	cancelAllEngineRequests: function()
	{
		this._cancelAllEngineRequestsSendGen();
	},

	_killGameProc: function( )
	{
		this.__killGameProcSendGen();
	},

// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration values for lifecycle events.
	 * @fieldOf Device.LifecycleEmitter.prototype
	 */
	Event:
	{ 
		/** Application is being suspended. */
		Suspend: 0,
		/** Application is being resumed. */
		Resume: 1,
		/** Application is being terminated. */
		Terminate: 2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 334
	// Method create = -1
	// Method lifecycleEvent = 2
	// Method exitProcess = -3
	// Method pauseGame = -4
	// Method resumeGame = -5
	// Method incrementEngineAlive = 6
	// Method decrementEngineAlive = 7
	// Method cancelAllEngineRequests = 8
	// Method _killGameProc = -9
	// Method _bgMe = -10
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._lifecycleEventRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LifecycleEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LifecycleEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[334] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_lifecycleEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in LifecycleEmitter.lifecycleEvent from command: " + cmd );
			return false;
		}
		
		obj[ "event" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "event" ] === undefined )
		{
			NgLogE("Could not parse event in LifecycleEmitter.lifecycleEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":334,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_lifecycleEventSendGen: function( event )
	{
		Core.Proc.appendToCommandString( ":334,2," + this.__objectRegistryId + "," + event  );
	},
	
	/** @private */
	$_exitProcessSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334," + -3  );
	},
	
	/** @private */
	$_pauseGameSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334," + -4  );
	},
	
	/** @private */
	$_resumeGameSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334," + -5  );
	},
	
	/** @private */
	_incrementEngineAliveSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334,6," + this.__objectRegistryId );
	},
	
	/** @private */
	_decrementEngineAliveSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334,7," + this.__objectRegistryId );
	},
	
	/** @private */
	_cancelAllEngineRequestsSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334,8," + this.__objectRegistryId );
	},
	
	/** @private */
	$__killGameProcSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334," + -9  );
	},
	
	/** @private */
	$__bgMeSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334," + -10  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _lifecycleEventRecv: function( cmd ) {}
	// lifecycleEvent: function( event ) {}
	
	// $exitProcess: function(  ) {}
	
	// $pauseGame: function(  ) {}
	
	// $resumeGame: function(  ) {}
	
	// incrementEngineAlive: function(  ) {}
	
	// decrementEngineAlive: function(  ) {}
	
	// cancelAllEngineRequests: function(  ) {}
	
	// $_killGameProc: function(  ) {}
	
	// $_bgMe: function(  ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/XHR'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/XHR'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/XHR'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class XHR
// XMLHttpRequest implementation
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Util = require('NGCore/Client/Network/Util').Util;
var Caps = require('NGCore/Client/Core/Capabilities').Capabilities;

////////////////////////////////////////////////////////////////////////////////

var Header = function (item, content)
{
	this.item = item;
	this.content = content;
};
var headerEx = /(.*?): (.*)/;

/**
 * Constants
 */
var State =
{
	UNSENT: 0,
	OPENED: 1,
	HEADERS_RECEIVED: 2,
	LOADING: 3,
	DONE: 4
};

// ///////////// Begin HTTP req'd methods of testing! //////
var methods =
[
	"OPTIONS",
	"GET",
	"HEAD",
	"POST",
	"PUT",
	"DELETE",
	"TRACE",
	"CONNECT"
];

var unsecureMethods = ["CONNECT", "TRACE", "TRACK"];

var checkMethod = function(method)
{
	if(!method) return "GET";

	method = method.toString();

	if (method in unsecureMethods)
	{
		throw "SECURITY_ERROR " + method + " not allowed.";
	}
	if (method.toUpperCase() in methods)
	{
		return method.toUpperCase();
	}
	return method;
};

// ////////////////////////// End! /////////////////////

////////////////////////////////////////////////////////////////////////////////

exports.XHR = Class.subclass(
/** @lends Network.XHR.prototype */
{
	classname: 'XHR',
	
	/**
	 * @class The <code>XHR</code> class constructs <code>XmlHttpRequest</code> objects. Applications can use these objects to
	 * send HTTP or HTTPS requests directly to a web server and load the server response data directly back into a script.
	 * @constructs The default constructor. 
	 * @see <a href="http://www.w3.org/TR/XMLHttpRequest/">Official W3C XmlHttpRequest specification</a>
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this.request;
		this.respHeaders = {};

		this.settings = {};
		this.headers = [];

		// State-associated flags
		this.sendFlag = false;
		this.errorFlag = false;
		
		// Status & response
		this.readyState = State.UNSENT;
		this.responseText = null;
		this.responseXML = null;
		this.status = 0;
		this.statusText = "";
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 340
	// Method create = -1
	// Method destroy = 2
	// Method sendStatus = 3
	// Method sendHeaders = 4
	// Method sendData = 5
	// Method onFinish = 6
	// Method start = 7
	// Method header = 8
	// Method setComposition = 9
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 3:
					instance._sendStatusRecv( cmd );
					break;
				case 4:
					instance._sendHeadersRecv( cmd );
					break;
				case 5:
					instance._sendDataRecv( cmd );
					break;
				case 6:
					instance._onFinishRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in XHR._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in XHR._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[340] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_sendStatusRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.sendStatus from command: " + cmd );
			return false;
		}
		
		obj[ "statNum" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "statNum" ] === undefined )
		{
			NgLogE("Could not parse statNum in XHR.sendStatus from command: " + cmd );
			return false;
		}
		
		obj[ "statStr" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "statStr" ] === undefined )
		{
			NgLogE("Could not parse statStr in XHR.sendStatus from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_sendHeadersRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.sendHeaders from command: " + cmd );
			return false;
		}
		
		obj[ "headers" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "headers" ] === undefined )
		{
			NgLogE("Could not parse headers in XHR.sendHeaders from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_sendDataRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.sendData from command: " + cmd );
			return false;
		}
		
		obj[ "data" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "data" ] === undefined )
		{
			NgLogE("Could not parse data in XHR.sendData from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onFinishRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.onFinish from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseBool( cmd[ 0 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in XHR.onFinish from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":340,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":340,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_startSendGen: function( method, url, data, headers )
	{
		Core.Proc.appendToCommandString( ":340,7," + this.__objectRegistryId + "," + Core.Base64.encode( method ) + "," + Core.Base64.encode( url ) + "," + Core.Base64.encode( data ) + "," + headers  );
	},
	
	/** @private */
	_headerSendGen: function( item, content )
	{
		Core.Proc.appendToCommandString( "," + Core.Base64.encode( item ) + "," + Core.Base64.encode( content )  );
	},
	
	/** @private */
	_setCompositionSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":340,9," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// _sendStatusRecv: function( cmd ) {}
	// _sendHeadersRecv: function( cmd ) {}
	// _sendDataRecv: function( cmd ) {}
	// _onFinishRecv: function( cmd ) {}
	// start: function( method, url, data, headers ) {}
	
	// header: function( item, content ) {}
	
	// setComposition: function(  ) {}
	

// {{/Wg Generated Code}}

// API
	/**
	 * Initialize a request for this <code>XHR</code>.
	 *
	 * <b>Note:</b> Calling <code>open()</code> will wipe all request headers. You must set them after making this call.
	 *
	 * @param {String}
	 *            method The request method 
	 * 		(<code>GET</code>, <code>POST</code>, <code>OPTIONS</code>, <code>HEAD</code>,  
	 *		<code>PUT</code>, <code>DELETE</code>, <code>TRACE</code>, <code>CONNECT</code>)
	 * @param {String}
	 *            url The request URL.
	 * @param {Boolean}
	 *            [async=true] Returns <code>true</code> if the request is synchronous. Returns <code>false</code> in all other cases.<br><br> 
	 * 		<b>Note:</b> Currently not implemented.
	 * @param {String}
	 *            [user] Username for basic authentication.<br><br> 
	 *		<b>Note:</b> Currently not implemented.
	 * @param {String}
	 *            [password] Password for basic authentication.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	open: function(method, url, async, user, password)
	{
		url = url.split(' ').join('%20');
		this.settings =
		{
			"method": checkMethod(method),
			"url": Util.buildRelativeUrl(url),
			"async": async,
			"user": user,
			"password": password
		};

		// Check URL and set XHR flag appropriately
// 		var localServer = Caps.getServer();
// 		if (localServer == url.substr(0, localServer.length) && Caps.getPlatformOS() == "Android")
// 		{
// 			this.NXS = true;
// 		}

		if (this.me && this.sendFlag)
		{
			http.abort(this.me);
		}
		this.reset();
		this.setState(State.OPENED);
	},

	/**
	* @ private
	* Send a request initialized by the <code>open()</code> method. 
	* @param {Array} [composition] Array of strings and file names to be composed into the body.<br><br>
	* <b>Note:</b> This parameter is ignored if <code>readyState</code> is set as <code>GET</code> or <code>HEAD</code>.
	* @throws {INVALID_STATE_ERR} If <code>readyState</code> is set as anything other than <code>OPENED</code> or if the <code>send()</code> flag is true.
	* @see Network.XHR#open
	* @status iOS, Android
	*/

	sendComposition: function(comp)
	{
		// ex: [{"str":"string to send"},{"file":"path/to/file.bin"},{"str":"more goods"}]
		this.composing = true;
		this.send(JSON.stringify(comp));
	},

	/**
	* Send a request initialized by the <code>open()</code> method.
	* @param {String} [data] The request entity body.<br><br>
	* <b>Note:</b> This parameter is ignored if <code>readyState</code> is set as <code>GET</code> or <code>HEAD</code>.
	* @throws {INVALID_STATE_ERR} If <code>readyState</code> is set as anything other than <code>OPENED</code> or if the <code>send()</code> flag is true.
	* @see Network.XHR#open
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	send: function(data)
	{
		if (this.readyState != State.OPENED || this.sendFlag)
		{
			throw "INVALID_STATE_ERR: " + (this.sendFlag ? "Already sending" : "in state " + this.readyState);
		}
		this.sendFlag = true;

		if (data && this.settings.method != "GET" && this.settings.method != "HEAD")
		{
			// TODO http://www.w3.org/TR/XMLHttpRequest/#the-send-method step 3
		}

		this.errorFlag = false;

		// Set content length header
		if (this.settings.method == "GET" || this.settings.method == "HEAD")
		{
			data = null;
		}
		else if (data)
		{
			var bFound = false;
			for (var i in this.headers)
			{
				if (this.headers[i].item == "Content-Type")
				{
					bFound = true;
					break;
				}
			}
			if (!bFound)
			{
				this.setRequestHeader("Content-Type", "text/plain;charset=UTF-8");
			}
		}

		this.responseText = "";

		// Send data to the server
		if (!data)
		{
			data = "";
		}

		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

/* Not supporting NXS. Could remove it, but maybe we will support it one day */
		if (this.NXS)
		{
			this.me = http.create(this);
			for (var i in this.headers)
			{
				var h = this.headers[i];
				http.addHeader(this.me, h.item + ": " + h.content);
			}
			http.send(this.me, this.settings.method, this.settings.url, data);
		}
		else
		{
			if (this.composing)
				this._setCompositionSendGen();

			this._startSendGen(this.settings.method, this.settings.url, data, this.headers.length);
			for (var i in this.headers)
			{
				var obj = this.headers[i];
				this._headerSendGen(obj.item, obj.content);
			}
		}
	}, // this.send() 

	/**
	 * Cancel any existing or pending network activity for this <code>XHR</code>. 
	 * This method is invoked using the specification outlined by W3C.
	 * @see <a href="http://www.w3.org/TR/XMLHttpRequest/#the-abort-method">W3C specification outline for <code>abort()</code></a>
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	abort: function()
	{
		this.responseText = null;
		this.errorFlag = true;
		this.headers = [];

		if (this.sendFlag)
		{
			if (this.NXS)
			{
				http.abort(this.me);
			}

			if (this.readyState != State.DONE)
			{
				this.sendFlag = false;
				this.setState(State.DONE);
			}
		}
		this.readyState = State.UNSENT;
	},

	/**
	 * Retrieve a header from the server response.
	 *
	 * @param {String}
	 *            header Name of header to retrieve.
	 * @returns {String} Text of the header or <code>null</code> if text does not exist.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getResponseHeader: function(header)
	{
		if (this.readyState > State.OPENED)
		{
			return this.respHeaders[header.toLowerCase()];
		}
		return null;
	},

	/**
	 * Nonstandard: Retrieve the key-value map of all response headers.
	 *
	 * @return {Object} A key-value map as an object.
     * @status iOS, Android, Test, iOSTested, AndroidTested
     */
	getUnflattenedResponseHeaders: function()
	{
		return this.respHeaders;
	},

	/**
	 * Retrieve all the response headers from a request.
	 * This method is invoked using the specification outlined by W3C.
	 * @return {String} All the response headers from a request.
	 * @see <a href="http://www.w3.org/TR/XMLHttpRequest/#the-getallresponseheaders-method">W3C specification outline for <code>getAllResponseHeaders()</code>.</a>
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getAllResponseHeaders: function()
	{
		if (this.readyState < State.HEADERS_RECEIVED || this.errorFlag)
		{
			return "";
		}

		var result = "";
		for (var i in this.respHeaders)
		{
			result += i + ": " + this.respHeaders[i] + "\r\n";
		}
		return result.substr(0, result.length - 2);
	},

	/**
	 * Set a header for the request.
	 *
	 * @param {String}
	 *            header The name of the header.
	 * @param {String}
	 *            value The value of the header.
	 * @see Network.XHR#getRequestHeader
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setRequestHeader: function(header, value)
	{
		this.headers.push(new Header(header, value));
	},

	/**
	 * Retrieve a header from the request.
	 *
	 * @param {String} header The name of the header.
	 * @return {String} The value of the header.
	 * @see Network.XHR#setRequestHeader
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getRequestHeader: function(header)
	{
		var ret = null;
		for (var i in this.headers)
		{
			if (this.headers[i].item == header)
			{
				ret = this.headers[i].content;
				break;
			}
		}
		return ret;
	},

// Receivers
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	onStatus: function ( num, str)
	{
		this.status = num;
		this.statusText = str;
	},

	_sendStatusRecv: function( cmd )
	{
		var obj = {};
		this._sendStatusRecvGen(cmd, obj);
		this.onStatus(obj.statNum, obj.statStr);
	},
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	onHeaders: function(str)
	{
		var lines = str.split('\n');
		lines.pop();
		for (var i in lines)
		{
			var match = headerEx.exec(lines[i]);
			if (match)
				this.respHeaders[match[1].toLowerCase()] = match[2];
		}
		this.setState(State.HEADERS_RECEIVED);
	},

	_sendHeadersRecv: function( cmd )
	{
		var obj = {};
		this._sendHeadersRecvGen(cmd, obj);
		this.onHeaders(obj.headers);
	},
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	onData: function(data)
	{
		this.responseText += data;
		this.setState(State.LOADING);
	},

	_sendDataRecv: function( cmd )
	{
		var obj = {};
		this._sendDataRecvGen(cmd, obj);
		this.onData(obj.data);
	},
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	onFinish: function (err)
	{
		this.sendFlag = false;
		if (err)
		{
			this.responseText = null;
			this.error = "Network Error";
			this.errorFlag = true;
			this.status = 0;
		}
		this.setState(State.DONE);
	},

	_onFinishRecv: function( cmd )
	{
		var obj = {};
		this._onFinishRecvGen(cmd, obj);
		this.onFinish(obj.error);
	},

// Internal methods
	/**
	 * Reset all fields from a request. This call sets <code>readyState</code> to <code>UNSENT</code> 
	 * and the response properties to <code>null</code>.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	reset: function()
	{
		this.headers = [];
		this.readyState = State.UNSENT;
		this.responseText = null;
		this.responseXML = null;
		this.composing = false;
	},
	/**
	 * Change the value of <code>readyState</code> and call <code>onreadystatechange()</code>.
	 *
	 * @param {Number}
	 *            state The new value for <code>readyState</code>
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setState: function(state)
	{
		this.readyState = state;
		if (state == State.DONE)
		{
			this._destroySendGen();
			ObjectRegistry.unregister(this);
		}
		if (typeof this.onreadystatechange != 'undefined')
		{
			try
			{
				this.onreadystatechange();
			}
			catch (e)
			{
				NgLogException(e);
			}
		}
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/DownloadFile'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/DownloadFile'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/DownloadFile'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class DownloadFile
// Downloads a file to the sandbox
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Class = require('NGCore/Client/Core/Class').Class;

////////////////////////////////////////////////////////////////////////////////

exports.DownloadFile = Class.subclass(
/** @lends Network.DownloadFile.prototype */
{
	classname: 'DownloadFile',
	/**
	* @class The <code>DownloadFile</code> class constructs objects that conduct a file download through an HTTP request.
	* @constructs The default constructor. 
	* @augments Core.Class
	*/
	initialize: function() {},

	/**
	  * Initiate a file download.
	  * @example var url = 'http://url/to/stuff/
	  * new Network.DownloadFile).start(filename, 'GET', url, [], (function(status, md5)
	  * @param {String} filename A local and relative path for storing the downloaded data.
	  * @param {String} method The HTTP method to use.  For example, <code>GET</code> or <code>POST</code>.
	  * @param {String} url The URL of the downloaded file.
	  * @param {Object} [headers] A dictionary that maps header names to header values.
	  * @param {Function} [callback] A callback function for notification
	  * of when the download completes. The signature for the callback is equivalent
	  * to:<br><br>
	  * <pre>function(statusCode,fileSignature)</pre><br>
	  * The <code>fileSignature</code> is currently the
	  * md5 checksum of the file.
	  * @type void
      * @status iOS, Android, Test, iOSTested, AndroidTested
	  */
	start: function(filename, method, url, headers, callback)
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		url = url.split(' ').join('%20');
		// Check headers
		if (!(headers instanceof Array))
		{
			NgLogE('Improper headers sent('+headers+'). Need an array, ex: ["Content-Easter: egg"]');
			headers = [];
		}

		// Send the goods
		this.__sendSendGen( filename, method, url, headers.length );

		// Send headers
		for (var i in headers)
		{
			this.__headerSendGen(headers[i].item, headers[i].content);
		}

		// Save the callback
		this.mCB = callback
	},

	abort: function()
	{
		this._destroySendGen();
		ObjectRegistry.unregister(this);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 341
	// Method create = -1
	// Method destroy = 2
	// Method _send = 3
	// Method _header = 4
	// Method finish = 5
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 5:
					instance._finishRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in DownloadFile._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in DownloadFile._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[341] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_finishRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in DownloadFile.finish from command: " + cmd );
			return false;
		}
		
		obj[ "status" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "status" ] === undefined )
		{
			NgLogE("Could not parse status in DownloadFile.finish from command: " + cmd );
			return false;
		}
		
		obj[ "signature" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "signature" ] === undefined )
		{
			NgLogE("Could not parse signature in DownloadFile.finish from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":341,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":341,2," + this.__objectRegistryId );
	},
	
	/** @private */
	__sendSendGen: function( fileName, method, url, headers )
	{
		Core.Proc.appendToCommandString( ":341,3," + this.__objectRegistryId + "," + Core.Base64.encode( fileName ) + "," + Core.Base64.encode( method ) + "," + Core.Base64.encode( url ) + "," + headers  );
	},
	
	/** @private */
	__headerSendGen: function( item, content )
	{
		Core.Proc.appendToCommandString( "," + Core.Base64.encode( item ) + "," + Core.Base64.encode( content )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// _send: function( fileName, method, url, headers ) {}
	
	// _header: function( item, content ) {}
	
	// _finishRecv: function( cmd ) {}

// {{/Wg Generated Code}}
	
	_finishRecv: function( cmd )
	{
		this._destroySendGen();
		
		var obj = {};
		this._finishRecvGen(cmd, obj);

		if (this.mCB)
			this.mCB(obj.status, obj.signature);

		ObjectRegistry.unregister(this);
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/Util'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/Util'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/Util'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Utilities for Network
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Caps = require('NGCore/Client/Core/Capabilities').Capabilities;
var Time = require('NGCore/Client/Core/Time').Time;
var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;

////////////////////////////////////////////////////////////////////////////////

var urlPathServerSplit = /^(https?:\/\/)?([^\/]*)(.*[^\/])?.?/i;

var Util = exports.Util =
{
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	NormalizeUrl: function(url, keepTrailingSlash)
	{
		url = Util.buildRelativeUrl(url);

		// Now split it into parts and make server bits lower case
		var parsed = url.match(urlPathServerSplit);
		if (parsed && parsed[1])
		{
			// absolute path!
			url = parsed[1].toLowerCase() + parsed[2].toLowerCase() + (parsed[3] ? parsed[3] : "");
		}
		else
		{
			// Direct server, no path
			url = url.toLowerCase();
		}
		return url;
	},

	buildRelativeUrl: function(url)
	{
		if (!url.match(/^(https?:\/\/)/))
		{
			// If the path is relative, then we append our server to the beginning of it
			if (url.charAt(0) == '/' || !url.length)
			{
				url = Caps.getServer() + url;
			}
			else
			{
				url = Caps.getServer() + "/" + Caps.getGame() + "/" + url;
			}
		}

		return url;
	},

	RetrySchedule: function(initialRetry, maxDuration)
	{
		var count = Math.floor(Math.log(maxDuration / initialRetry));
		var schedule = [initialRetry];
		for(var i=0; i < count + 1; ++i)
		{
			initialRetry *= 2;
			schedule.push(initialRetry);
		}
		return schedule;
	},
	
	OperationWithRetries: function(operationCb, failureCb, failEarly)
	{
		var abortAttempts;
		var abortTime;
		var abortTimeAttempts;
		
		if(failEarly)
		{
			abortAttempts = 3;
			abortTime = 10000;
			abortTimeAttempts = 1;
		}
		else
		{
			abortAttempts = Infinity;
			abortTime = 30000;
			abortTimeAttempts = 6;
		}
		
		// console.log('retry config abortAttempts:', abortAttempts, 'abortTime', abortTime, 'abortTimeAttempts', abortTimeAttempts);
		
		abortTime = Core.Time.getRealTime() + abortTime;
		var timeout = 250;
		var attemptCount = 1;
		
		var failed = false;
		var armed = true;
		
		var failureParam = function()
		{
			if(failed) return;
			
			if(!armed)
			{
				console.log('OperationWithRetries: failureParam called when not armed');
				return;
			}
			armed = false;
			
			if(attemptCount >= abortAttempts)
			{
				console.log('OperationWithRetries: too many retry attempts');
				var failed = true;
				failureCb();
				return;
			}
			
			if(Core.Time.getRealTime() >= abortTime && attemptCount >= abortTimeAttempts)
			{
				console.log('OperationWithRetries: retries took too long');
				console.log('OperationWithRetries: abortTime:', abortTime, 'realTime:', Core.Time.getRealTime());
				console.log('OperationWithRetries: attemptCount:', attemptCount, 'abortTimeAttempts:', abortTimeAttempts);
				var failed = true;
				failureCb();
				return;
			}
			
			console.log('OperationWithRetries: Failure, will retry in ' + timeout + 'ms');
			setTimeout(function()
			{
				if(failed) return;
				armed = true;
				operationCb(failureParam, abortParam);
			}, timeout);
			
			attemptCount += 1;
			timeout *= 2;
		};
		
		var abortParam = function()
		{
			var failed = true;
			failureCb();
		};
		
		operationCb(failureParam, abortParam);
		
		return abortParam;
	},
	
	showFatalErrorDialog: function(status)
	{
		// Set up info dialog
		var myAlert = new AlertDialog();
		myAlert.setTitle(Core.Localization.getString("Network failure"));
		myAlert.setChoices([Core.Localization.getString("Exit")]);

		myAlert.onchoice =
		function(ret)
		{
			myAlert.hide();
			LifecycleEmitter.exitProcess();
		};
		
		// TODO: Move this list somewhere localizable
		var commonErrors = {
			'302': "File location has changed (302)",
			'400': "Bad request to server (400)",
			'401': "Authorization failed (401)",
			'403': "Server permissions error (403)",
			'404': "Resource not found (404)",
			'408': "Request timed out (408)",
			'500': "Internal server error (500)",
			'501': "Cannot process request (501)",
			'502': "Bad Gateway (502)",
			'503': "Service overloaded / down for maintenance (503)",
			'504': "Timeout at intervening gateway (504)"
		};
		myAlert.setText( Core.Localization.getString( commonErrors[status] || "This application requires a working data connection." ) );
		myAlert.show();
	},

	showSimpleNetworkError: function(status)
	{
		// Set up info dialog
		var myAlert = new AlertDialog();
		myAlert.setTitle(Core.Localization.getString("Network failure"));
		myAlert.setChoices([Core.Localization.getString("OK")]);

		myAlert.onchoice =
		function(ret)
		{
			myAlert.hide();
		};

		// TODO: Move this list somewhere localizable
		var commonErrors = {
			'302': " File location has changed (302)",
			'400': " Bad request to server (400)",
			'401': " Authorization failed (401)",
			'403': " Server permissions error (403)",
			'404': " Resource not found (404)",
			'408': " Request timed out (408)",
			'500': " Internal server error (500)",
			'501': " Cannot process request (501)",
			'502': " Bad Gateway (502)",
			'503': " Service overloaded / down for maintenance (503)",
			'504': " Timeout at intervening gateway (504)"
		};
		var message = "Cannot download game without network connection.";
		if (commonErrors[status])
		{
			message += commonErrors[status];
		}
		myAlert.setText( Core.Localization.getString( message ) );
		myAlert.show();
	},
	
	getCacheBustingString: function()
	{
		return '?t=' + (new Date()).getTime();
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/_int_Util'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/_int_Util'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/_int_Util'] = exports; ///////////////////////////////////////////////////////////////////////////////
// Class _int_Util
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Class = require('NGCore/Client/Core/Class').Class;
////////////////////////////////////////////////////////////////////////////////

exports._int_Util = Class.singleton(
/** @lends Network._int_Util.prototype */
{
	classname: '_int_Util',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this._callbackID = 0;
		this._callbacks = [];

		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	ProcID:
	{ 
		/** High privilege proc */
		Persist: -1,
		/** Low priv */
		Game: -2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 350
	// Method create = -1
	// Method destroy = 2
	// Method sign = 3
	// Method signCallback = 4
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 4:
					instance._signCallbackRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in _int_Util._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in _int_Util._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[350] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_signCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in _int_Util.signCallback from command: " + cmd );
			return false;
		}
		
		obj[ "signature" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "signature" ] === undefined )
		{
			NgLogE("Could not parse signature in _int_Util.signCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in _int_Util.signCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":350,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":350,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_signSendGen: function( baseString, callbackID, environment )
	{
		Core.Proc.appendToCommandString( ":350,3," + this.__objectRegistryId + "," + Core.Base64.encode( baseString ) + "," + callbackID + "," + Core.Base64.encode( environment )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// sign: function( baseString, callbackID, environment ) {}
	
	// _signCallbackRecv: function( cmd ) {}

// {{/Wg Generated Code}}

	sign: function( baseString, environment, callback) {
		this._callbacks[this._callbackID] = callback;
		this._signSendGen(baseString,this._callbackID, environment);
		this._callbackID++;
	},
	_signCallbackRecv: function( cmd ) {
		var msg = {};
		if (! this._signCallbackRecvGen(cmd, msg)) {
			return;
		}
		var func = this._callbacks[parseInt(msg.callbackID)];
		if (func) {
			func(msg.signature);
		}
	}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/MessageEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/MessageEmitter'] || {}; $MODULE_REGISTRY['NGCore/Shared/MessageEmitter'] = exports; var Class = require('NGCore/Shared/Class').Class;
var MessageListener = require('NGCore/Shared/MessageListener').MessageListener;

exports.MessageEmitter = Class.subclass(
/** @lends Core.MessageEmitter.prototype */
{
	classname: 'MessageEmitter',
	
	/**
	 * @status iOS, Android, Flash
	 * @class The <code>MessageEmitter</code> class constructs emitter objects that send messages to registered <code>{@link Core.MessageListener}</code> objects. 
	 * When a defined condition triggers an emitter, all registered listener objects are in turn triggered.
	 * <br><br>
	 * Emitter objects support two communication modes: emit and chain. When emitting, each listener is called in turn.
	 * When chaining, each listener can halt the propagation of a message to 
	 * other listeners by returning <code>true</code> from their callback.
	 * <br><br>
	 * Each listener can include an optional priority ranking. Priority determines the order
	 * in which an emitter calls each listener. 
	 * If two listener objects are registered with the same priority, the emitter calls them in the order they were registered. 
	 * The default priority is <code>0</code>. 
	 * <br><br>
	 * <b>Note:</b> Do not instantiate this class directly. Use classes derived from <code>MessageEmitter</code> for instantiation. This includes:
	 * <div class="ul">
	 * <li>{@link Core.Localization}</li>
	 * <li>{@link Core.UpdateEmitter}</li>
	 * <li>{@link Device.KeyEmitter}</li>
	 * <li>{@link Device.LifecycleEmitter}</li>
	 * <li>{@link Device.LocationEmitter}</li>
	 * <li>{@link Device.MemoryEmitter}</li>
	 * <li>{@link Device.MotionEmitter}</li>
	 * <li>{@link Device.NetworkEmitter}</li>
	 * <li>{@link Device.OrientationEmitter}</li>
	 * <li>{@link Device.ShakeEmitter}</li>
	 * </div>
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this._messageListenersCount = 0;
		this._messageListenerRecords = [];
		this._messageDeferredWork = [];
		this._messageShouldDefer = false;
	},
	
	/**
	 * Unregister all <code>MessageListener</code> objects from this <code>MessageEmitter</code>.<br><br>
	 * <b>Note:</b> Do not use the emitter after calling this.
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function($super)
	{
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._destroyActual.bind(this, $super));
		}
		else
		{
			this._destroyActual($super);
		}
	},
	
	_destroyActual: function(superDestroy)
	{
		// Unregister all listeners.
		var records = this._messageListenerRecords;
		while(records.length)
		{
			this.removeListener(records[0].l);
		}
		
		if(superDestroy)
			superDestroy();
	},
	
	/**
	 * Retrieve the number of <code>MessageListener</code> objects registered with this <code>MessageEmitter</code>.
	 * @returns {Number} The current number of <code>MessageListener</code> objects.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getListenerCount: function()
	{
		return this._messageListenersCount;
	},
	
	/**
	 * Add a <code>MessageListener</code> to this <code>MessageEmitter</code>. When an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * The parameters for the callback function are identical to parameters for <code>emit()</code> or
	 * <code>chain()</code>.
	 * <br><br>
	 * <b>Note:</b> Each listener can only listen to an emitter one time.<br><br>
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, 200);
	 *
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @param {Function} func The callback function.
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @throws {MessageEmitter.addListener: listener is already listening} Calling <code>addListener()</code> multiple times on the same emitter
	 * with the same listener.
	 * @throws {MessageEmitter.addListener: listener must be instances of MessageListener} Listener is not an instance of <code>MessageListener</code>.
	 * @see Core.MessageEmitter#removeListener,
	 * @see Core.MessageEmitter#emit,
	 * @see Core.MessageEmitter#chain
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	addListener: function(listener, func, priority)
	{
		if(!listener instanceof MessageListener)
			throw new Error('MessageEmitter.addListener: listener must be instances of MessageListener');
			
		if(!listener._startListeningEmitter(this))
			throw new Error('MessageEmitter.addListener: listener is already listening');
			
		if(!priority)
		{
			priority = 0;
		}
		
		this._messageListenersCount++;	
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._addListenerActual.bind(this, listener, func, priority));
		}
		else
		{
			this._addListenerActual(listener, func, priority);
		}
	},
	
	_addListenerActual: function(listener, func, priority)
	{
		//  The priority for default value is <code>0</code>
		if ((typeof priority) == 'undefined') {
			priority = 0;
		}
		// TODO Replace with binary search.
		var records = this._messageListenerRecords;
		var len = records.length;
		for(var i=0; i < len; ++i)
		{
			if(records[i].p <= priority)
				break;
		}
		records.splice(i, 0, {l: listener, f: func, p: priority});
	},
	
	/**
	 * Remove a <code>MessageListener</code> from this <code>MessageEmitter</code>.<br><br> 
	 * The following code examples illustrate different call styles for <code>removeListener</code>.
	 * @example
	 * emitter.removeListener(myListener, myListener.onCallback);
	 * @example
	 * emitter.removeListener(myListener);
	 *
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener was removed. Returns <code>false</code> if the registered listener is not found 
	 * or is not registered with this emitter.
	 * @throws {MessageEmitter.removeListener: listener is not listening} Specified listener is not currently registered
	 * with this <code>MessageEmitter</code>.
	 * @see Core.MessageEmitter#addListener
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	removeListener: function(listener)
	{
		if(!listener._stopListeningEmitter(this))
			//throw new Error('MessageEmitter.removeListner: listener is not listening');
			return false;
		
		this._messageListenersCount--;
		if(this._messageShouldDefer)
		{
			// TODO Replace with binary search.
			var records = this._messageListenerRecords;
			var len = records.length;
			for(var i=0; i < len; ++i)
			{
				var record = records[i];
				if(record.l == listener)
				{
					record.f = null;
					break;
				}
			}
			
			this._messageDeferredWork.push(this._removeListenerActual.bind(this, listener));
		}
		else
		{
			this._removeListenerActual(listener);
		}
		
		return true;
	},
	
	_removeListenerActual: function(listener)
	{
		// TODO Replace with binary search.
		var records = this._messageListenerRecords;
		var len = records.length;
		for(var i=0; i < len; ++i)
		{
			var record = records[i];
			if(record.l == listener)
			{
				records.splice(i, 1);
				break;
			}
		}
	},
	
	/**
	 * Send a message to every registered <code>MessageListener</code>. This emitter will trigger all listeners
	 * in descending order based on the listener priority. All listener callback functions are generated
	 * with parameters passed to <code>emit()</code>.
	 * @param {Parameters} parameters Parameters to pass in the generated callback funtion.
	 * @see Core.MessageEmitter#chain
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	emit: function(params)
	{
		var handled = false;
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._emitActual.bind(this, arguments, false));
		}
		else
		{
			handled = this._emitActual(arguments, true);
		}
		return handled;
	},
	
	_emitActual: function(params, executeDeferred)
	{
		this._messageShouldDefer = true;
		
		var records = this._messageListenerRecords;
		var len = records.length;
		var handled = false;
		for(var i=0; i < len; ++i)
		{
			var record = records[i];
			if(!record.f) continue;
			
			if(record.f.apply(record.l, params))
				handled = true;
		}

		if(!handled)
		{
			//NgLogD("No listeners handling emitted key");
		}
		
		this._messageShouldDefer = false;
		
		if(this._messageDeferredWork.length && executeDeferred)
		{
			this._executeDeferred();
		}

		return handled;
	},
	
	/**
	 * Send a message to every registered <code>MessageListener</code> through a chain of command. 
	 * This emitter will trigger all listeners in descending order based on the listener priority.
	 * All listener callback functions are generated with parameters passed to <code>chain()</code>.	 
	 * <br><br>
	 * Unlike <code>emit()</code>, <code>chain()</code> allows a <code>MessageListener</code> to halt propagation of a message 
	 * to other listener objects by returning <code>true</code> for the callback function.
	 * This is useful for things like touch event handling. A <code>MessageListener</code> can respond to a touch event
	 * by returning <code>true</code>, masking the touch event from other listener objects.
	 *
	 * @param {Parameters} parameters Parameters to pass in the generated callback funtion.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener responded. Returns <code>false</code> in all other cases.
	 * <br><br>
	 * <b>Note:</b> If the application calls <code>chain()</code> recursively from
	 * within a message handler callback, it will always return <code>undefined</code>
	 * regardless of if a <code>MessageListener</code> responds or not.
	 * @see Core.MessageEmitter#emit
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	chain: function(params)
	{
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._chainActual.bind(this, arguments, false));
			return undefined;
		}
		else
		{
			return this._chainActual(arguments, true);
		}
	},
	
	_chainActual: function(params, executeDeferred)
	{
		var result = false;
		this._messageShouldDefer = true;
		
		var records = this._messageListenerRecords;
		var len = records.length;
		for(var i=0; i < len; ++i)
		{
			var record = records[i];
			if(!record.f) continue;
			
			if(record.f.apply(record.l, params))
			{
				result = true;
				break;
			}
		}
		
		this._messageShouldDefer = false;
		
		if(this._messageDeferredWork.length && executeDeferred)
		{
			this._executeDeferred();
		}
		
		return result;
	},
	
	_executeDeferred: function()
	{
		// NOTE: Don't factor out deferred.length. Deferred work can add more deferred work.
		var deferred = this._messageDeferredWork;
		for(var i=0; i < deferred.length; ++i)
		{
			deferred[i]();
		}
		this._messageDeferredWork = [];
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/MessageListener'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/MessageListener'] || {}; $MODULE_REGISTRY['NGCore/Shared/MessageListener'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.MessageListener = Class.subclass(
/** @lends Core.MessageListener.prototype */
{
	classname: 'MessageListener',
	
	/**
	 * @class The <code>MessageListener</code> class is a base class for constructing objects that listen for notifications from emitters 
	 * (see <code>{@link Core.MessageEmitter}</code>). Objects of this type are registered with emitters.
	 * When <code>{@link Core.MessageEmitter#emit}</code> or <code>{@link Core.MessageEmitter#chain}</code> is called on an emitter
	 * all registered listeners will generate a callback function.
	 * <br><br>
	 * Applications must unregister listener objects when they are no longer required in one of three ways: 
	 * <div class="ul"><font size="3">
	 * <li>Calling <code>{@link Core.MessageEmitter#removeListener}</code> on the <code>MessageEmitter</code>.</li>
	 * <li>Calling <code>{@link Core.MessageEmitter#destroy}</code> on the <code>MessageEmitter</code>.</li>
	 * <li>Calling <code>{@link Core.MessageListener#destroy}</code> on the <code>MessageListener</code></li>
	 * </font></div><br>
	 * <font size="3"><b>Note:</b> Applications should not attempt to register a listener with an emitter more than once. Registering a listener with an emitter
	 * multiple times results in exceptions. </font>
	 * @example
	 * var MyListener = Core.MessageListener.subclass(
	 * {
	 *     myCallback: function(verb, value)
	 *     {
	 *         console.log('MyListener.myCallback(' + verb + ', ' + value + ')');
	 *     },
	 * }
	 * var listener = new MyListener();
	 * emitter.addListener(listener, listener.myCallback);
	 * emitter.emit('fun', 5);
	 * @constructs The default constructor.
	 * @augments Core.Class
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._messageEmitters = [];
	},
	
	/**
	 * Unregister this <code>MessageListener</code> from all emitters.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		// Unregister from all emitters.
		var emitters = this._messageEmitters;
		while(emitters.length)
			emitters[0].removeListener(this);
	},
	
	// Called by MessageEmitter when this receiver starts listening.
	_startListeningEmitter: function(emitter)
	{
		var emitters = this._messageEmitters;
		var index = emitters.indexOf(emitter);
		if(index !== -1)
			return false;
		
		emitters.push(emitter);
		return true;
	},
	
	// Called by MessageEmitter when this receiver stops listening.
	_stopListeningEmitter: function(emitter)
	{
		var emitters = this._messageEmitters;
		var index = emitters.indexOf(emitter);
		if(index === -1)
			return false;
		
		emitters.splice(index, 1);
		return true;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/_int_LGL'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/_int_LGL'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/_int_LGL'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class _int_LGL
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var Base64 = require('NGCore/Client/Core/Base64').Base64;
var toMD5 = require('NGCore/Client/Core/toMD5').toMD5;

////////////////////////////////////////////////////////////////////////////////
function getCorrectedPlatformOS() {
	var os = Capabilities.getPlatformOS();
	switch (os) {
		case 'Android': return 'android';
		case 'iPhone OS': return 'ios';
	}
	return os;
};

function expandTexName(name)
{
	var list =
	{
		"pvr": "GL_IMG_texture_compression_pvrtc",
		"atc": "GL_AMD_compressed_ATC_texture",
		"etc1": "GL_OES_compressed_ETC1_RGB8_texture",
		"3dc": "GL_AMD_compressed_3DC_texture"
	};

	return list[name] || name;
};

var overridePropertyEvaluators = {
	isMatch: function(condition, value) {
		// Return true if the condition holds for the provided value
		// condition may be prefixed with an operator, so we extract it.
		var symbol;
		switch (condition.charAt(0)) {
		case '>':
			symbol = (condition.charAt(1) == '=') ? '>=' : '>';
			break;
		case '<':
			symbol = (condition.charAt(1) == '=') ? '<=' : '<';
			break;
		}
		// Consume any characters we detected, then set the default operation (equals)
		if (symbol) {
			condition = condition.slice(symbol.length);
		} else symbol = '=';

		if (condition == value) {
			return (symbol == '=' || symbol == '<=' || symbol == '>=');
		} else if (condition < value) {
			return (symbol == '<' || symbol == '<=');
		} else {
			return (symbol == '>' || symbol == '>=');
		}
	},

	isVersionMatch: function(condition, value) {
		// Return true if the condition holds for the provided value
		// condition may be prefixed with an operator, so we extract it.
		var symbol;
		if (condition.length > 0) switch (condition.charAt(0)) {
		case '>':
			symbol = (condition.charAt(1) == '=') ? '>=' : '>';
			break;
		case '<':
			symbol = (condition.charAt(1) == '=') ? '<=' : '<';
			break;
		case '=':
			symbol = (condition.charAt(1) == '=') ? '==' : '=';
			break;
		}
		// Consume any characters we detected, or set the default operation (equals)
		if (symbol) {
			condition = condition.slice(symbol.length);
		} else symbol = '=';

		var condition = condition.split('.');
		var value = value.split('.');

		var l = Math.max(condition.length, value.length);

		for (var i = 0; i < l; i++) {
			var ci = '0.' + (condition[i] || 0);
			var vi = '0.' + (value[i] || 0);
			if (ci == vi) continue;
			if (ci < vi) {
				return (symbol == '<' || symbol == '<=');
			} else {
				return (symbol == '>' || symbol == '>=');
			}
		}
		return true;
	},

	'sdkVersion': function(v) {
		return this.isVersionMatch('' + v, Capabilities.getSDKVersion());
	},

	'binaryVersion': function(v) {
		return this.isVersionMatch('' + v, Capabilities.getBinaryVersion());
	},

	'platformOS': function(v) {
		return v == getCorrectedPlatformOS();
	},

	'platformOSVersion': function(v) {
		return this.isVersionMatch('' + v, Capabilities.getPlatformOSVersion());
	},

	'platformHW': function(v) {
		return v == Capabilities.getPlatformHW();
	},

	'physicalMem': function(v) {
		return this.isMatch(v, Capabilities.getPhysicalMem());
	},

	'physicalCpus': function(v) {
		return this.isMatch(v, Capabilities.getPhysicalCpus());
	},

	'activeCpus': function(v) {
		return this.isMatch(v, Capabilities.getActiveCpus());
	},

	'language': function(v) {
		return v == Capabilities.getLanguage();
	},

	'textureMatch': "none",
	'textureCompression': function(v) {
		var matched = Capabilities.getOglExtensions().indexOf(expandTexName(v)) > -1;
		if (matched) this.textureMatch = v;
		return matched;
	},

	'screenWidth': function(v) {
		return this.isMatch(v, Capabilities.getScreenWidth());
	},

	'screenHeight': function(v) {
		return this.isMatch(v, Capabilities.getScreenHeight());
	},

	'screenResolution': function(v) {
		return v == (Capabilities.getScreenWidth() + 'x' + Capabilities.getScreenHeight());
	},

	'screenUnits': function(v) {
		return this.isMatch(v, Capabilities.getScreenUnits());
	},

	'screenPixelUnits': function(v) {
		return this.isMatch(v, Capabilities.getScreenPixelUnits());
	},

	'maxTextureSize': function(v) {
		return this.isMatch(v, Capabilities.getMaxTextureSize());
	},
	
	'reset': function(v) {
		this.textureMatch = "none";
	}
};

var _int_LGL = Class.singleton(
/** @lends Core._int_LGL.prototype */
{
	classname: '_int_LGL',

	launch: function(url, proc)
	{
		var Util = require('NGCore/Client/Network/Util').Util;
		// Default to game proc. Games should actually not be aware of the third option,
		//	as they cannot use it anyway.
		if (!proc)
			proc = _int_LGL.ProcID.Game;

		url = Util.NormalizeUrl(url);

//		console.log("launching game url " + url);

		var run = (function()
		{
			gNgShutdownPending = true;
			this._launchSendGen(url,proc);
		}).bind(this);

		if (proc == _int_LGL.ProcID.Game)
		{
			this.updateGameUse(url, run);
		}
		else
		{
			run();
		}
	},

	updateAvailable: function(game, doneCB, errorCB)
	{
		// Normalize URL
		var url = game;
		if (! url.match(/^\//) && !url.match(/https?:\/\//))
			url = '/' + url;

		var caps = require('NGCore/Client/Core/Capabilities').Capabilities;

		// If we are testing ourselves, we don't to md5 our url
		var name = "";
		if (caps.getUrl() != game)
		{
			var Util = require('NGCore/Client/Network/Util').Util;
			url = Util.NormalizeUrl(url);
			name = toMD5(url);
		}

		// Get device-specific manifest directory
		var buildPath = {"Android" : "android", "iPhone OS" : "ios", "flash" : ""};
		// Get Device capabilities platformOs
		var build = "/" + buildPath[caps.getPlatformOS()];

		var DownloadManifest = require('NGCore/Client/Network/DownloadManifest').DownloadManifest;
		var dm = new DownloadManifest();

		dm.isUpdated(url + build, name, false, doneCB, errorCB);
	},

// Utility (non-generated) functionality
	updateGameUse: function(game, doneCB)
	{
		var name = toMD5(game);
		var self = this;
		var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
		this.mGameStore = KeyValueCache.global("Core.GameList");
		this.mActiveGameKey = "activeGames";

		// Get our list of games
		this.mGameStore.getItem(this.mActiveGameKey,
			function(error, value)
			{
				var list;
				if (value)
					list = JSON.parse(value);
				else
					list = [];

				var item;
				for (var i in list)
				{
					if (list[i].name == name)
					{
						item = list[i];
						break;
					}
				}

				if (!item)
				{
					item = {"name": name};
					list.push(item);
				}

				item.lastRun = (new Date()).getTime();
				item.url = game;

 				self.mGameStore.setItem(self.mActiveGameKey, JSON.stringify(list));

                LocalGameList.updateGameList(list);
 				doneCB();
			}, true
		);
	},
	
	getManifestName: function(config) {
		var manifestName = 'webgame.ngmanifest';

		if (config && config.manifestOverrides) {
			try {
				var overrides = config.manifestOverrides;

				for (var i = 0; i < overrides.length; i++) {
					var override = overrides[i];
					if (override && override.criteria) {
						// Clear any matched values...
						overridePropertyEvaluators.reset();

						var criteria = override.criteria;
						var overrideMatched = true;
						for (var key in criteria) {
							if (!criteria.hasOwnProperty(key)) continue;
							var value = criteria[key];

							var evaluator = overridePropertyEvaluators[key];
							if (typeof evaluator != 'function') {
								console.log("ERROR! Undefined criterion " + key + " in configuration.json");
								overrideMatched = false;
								break;
							}

							var criterionMatched = false;
							if (value instanceof Array) {
								for (vi = 0; vi < value.length; vi++) {
									criterionMatched |= evaluator.call(overridePropertyEvaluators, value[vi]);
									if (criterionMatched) break;
								}
							} else {
								criterionMatched = evaluator(value);
							}

							if (!criterionMatched) {
								overrideMatched = false;
								break;
							}
						}

						// At this point, the override has matched. Figure out its name and return the value.
						if (overrideMatched) {
							console.log("MATCHED Override: " + JSON.stringify(override));

							// Format the override manifest name:
							var format = override.manifest.slice(0);
							for (var fi = 1; fi < format.length; fi++) {
								var key = format[fi];
								switch (key) {
								case 'textureCompression':
									format[fi] = overridePropertyEvaluators.textureMatch;
									break;
								case 'platformOS':
									format[fi] = getCorrectedPlatformOS();
									break;
								default:
									// Look up the named property on Capabilities.
									var cap = Capabilities['get' + key.charAt(0).toUpperCase() + key.slice(1)]();
									format[fi] = cap.replace(' ', '_');
								}
							}

							return require('NGCore/Shared/Lib/sprintf').sprintf(format);
						} else {
							console.log("DID NOT MATCH Override: " + JSON.stringify(override));
						}
					}
				}
			} catch (e) {
				console.log("ERROR! Exception occurred in manifest overrides: " + e);
			}
		}

		return manifestName;
	},

// {{?Wg Generated Code}}
	
	// Enums.
	ProcID:
	{ 
		/** High privilege proc */
		Persist: -1,
		/** Low priv */
		Game: -2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 342
	// Method launch = -1
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in _int_LGL._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in _int_LGL._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[342] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_launchSendGen: function( url, proc )
	{
		Proc.appendToCommandString( ":342,-1," + Base64.encode( url ) + "," + proc  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $launch: function( url, proc ) {}
	

// {{/Wg Generated Code}}

});

exports._int_LGL = _int_LGL;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/md5'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/md5'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/md5'] = exports; /*
 * A JavaScript implementation of the RSA Data Security, Inc. MD5 Message
 * Digest Algorithm, as defined in RFC 1321.
 * Version 2.2 Copyright (C) Paul Johnston 1999 - 2009
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See http://pajhome.org.uk/crypt/md5 for more info.
 */

/*
 * Calculate the MD5 of a raw string
 */
function rstr_md5(s)
{
  return binl2rstr(binl_md5(rstr2binl(s), s.length * 8));
}

/*
 * Convert a raw string to a hex string
 */
function rstr2hex(input)
{
  var hex_tab = "0123456789abcdef";
  var output = "";
  var x;
  for(var i = 0; i < input.length; i++)
  {
    x = input.charCodeAt(i);
    output += hex_tab.charAt((x >>> 4) & 0x0F)
           +  hex_tab.charAt( x        & 0x0F);
  }
  return output;
}

/*
 * Encode a string as utf-8.
 * For efficiency, this assumes the input is valid utf-16.
 */
function str2rstr_utf8(input)
{
  var output = "";
  var i = -1;
  var x, y;

  while(++i < input.length)
  {
    /* Decode utf-16 surrogate pairs */
    x = input.charCodeAt(i);
    y = i + 1 < input.length ? input.charCodeAt(i + 1) : 0;
    if(0xD800 <= x && x <= 0xDBFF && 0xDC00 <= y && y <= 0xDFFF)
    {
      x = 0x10000 + ((x & 0x03FF) << 10) + (y & 0x03FF);
      i++;
    }

    /* Encode output as utf-8 */
    if(x <= 0x7F)
      output += String.fromCharCode(x);
    else if(x <= 0x7FF)
      output += String.fromCharCode(0xC0 | ((x >>> 6 ) & 0x1F),
                                    0x80 | ( x         & 0x3F));
    else if(x <= 0xFFFF)
      output += String.fromCharCode(0xE0 | ((x >>> 12) & 0x0F),
                                    0x80 | ((x >>> 6 ) & 0x3F),
                                    0x80 | ( x         & 0x3F));
    else if(x <= 0x1FFFFF)
      output += String.fromCharCode(0xF0 | ((x >>> 18) & 0x07),
                                    0x80 | ((x >>> 12) & 0x3F),
                                    0x80 | ((x >>> 6 ) & 0x3F),
                                    0x80 | ( x         & 0x3F));
  }
  return output;
}

/*
 * Convert a raw string to an array of little-endian words
 * Characters >255 have their high-byte silently ignored.
 */
function rstr2binl(input)
{
  var output = Array(input.length >> 2);
  for(var i = 0; i < output.length; i++)
    output[i] = 0;
  for(var i = 0; i < input.length * 8; i += 8)
    output[i>>5] |= (input.charCodeAt(i / 8) & 0xFF) << (i%32);
  return output;
}

/*
 * Convert an array of little-endian words to a string
 */
function binl2rstr(input)
{
  var output = "";
  for(var i = 0; i < input.length * 32; i += 8)
    output += String.fromCharCode((input[i>>5] >>> (i % 32)) & 0xFF);
  return output;
}

/*
 * Calculate the MD5 of an array of little-endian words, and a bit length.
 */
function binl_md5(x, len)
{
  /* append padding */
  x[len >> 5] |= 0x80 << ((len) % 32);
  x[(((len + 64) >>> 9) << 4) + 14] = len;

  var a =  1732584193;
  var b = -271733879;
  var c = -1732584194;
  var d =  271733878;

  for(var i = 0; i < x.length; i += 16)
  {
    var olda = a;
    var oldb = b;
    var oldc = c;
    var oldd = d;

    a = md5_ff(a, b, c, d, x[i+ 0], 7 , -680876936);
    d = md5_ff(d, a, b, c, x[i+ 1], 12, -389564586);
    c = md5_ff(c, d, a, b, x[i+ 2], 17,  606105819);
    b = md5_ff(b, c, d, a, x[i+ 3], 22, -1044525330);
    a = md5_ff(a, b, c, d, x[i+ 4], 7 , -176418897);
    d = md5_ff(d, a, b, c, x[i+ 5], 12,  1200080426);
    c = md5_ff(c, d, a, b, x[i+ 6], 17, -1473231341);
    b = md5_ff(b, c, d, a, x[i+ 7], 22, -45705983);
    a = md5_ff(a, b, c, d, x[i+ 8], 7 ,  1770035416);
    d = md5_ff(d, a, b, c, x[i+ 9], 12, -1958414417);
    c = md5_ff(c, d, a, b, x[i+10], 17, -42063);
    b = md5_ff(b, c, d, a, x[i+11], 22, -1990404162);
    a = md5_ff(a, b, c, d, x[i+12], 7 ,  1804603682);
    d = md5_ff(d, a, b, c, x[i+13], 12, -40341101);
    c = md5_ff(c, d, a, b, x[i+14], 17, -1502002290);
    b = md5_ff(b, c, d, a, x[i+15], 22,  1236535329);

    a = md5_gg(a, b, c, d, x[i+ 1], 5 , -165796510);
    d = md5_gg(d, a, b, c, x[i+ 6], 9 , -1069501632);
    c = md5_gg(c, d, a, b, x[i+11], 14,  643717713);
    b = md5_gg(b, c, d, a, x[i+ 0], 20, -373897302);
    a = md5_gg(a, b, c, d, x[i+ 5], 5 , -701558691);
    d = md5_gg(d, a, b, c, x[i+10], 9 ,  38016083);
    c = md5_gg(c, d, a, b, x[i+15], 14, -660478335);
    b = md5_gg(b, c, d, a, x[i+ 4], 20, -405537848);
    a = md5_gg(a, b, c, d, x[i+ 9], 5 ,  568446438);
    d = md5_gg(d, a, b, c, x[i+14], 9 , -1019803690);
    c = md5_gg(c, d, a, b, x[i+ 3], 14, -187363961);
    b = md5_gg(b, c, d, a, x[i+ 8], 20,  1163531501);
    a = md5_gg(a, b, c, d, x[i+13], 5 , -1444681467);
    d = md5_gg(d, a, b, c, x[i+ 2], 9 , -51403784);
    c = md5_gg(c, d, a, b, x[i+ 7], 14,  1735328473);
    b = md5_gg(b, c, d, a, x[i+12], 20, -1926607734);

    a = md5_hh(a, b, c, d, x[i+ 5], 4 , -378558);
    d = md5_hh(d, a, b, c, x[i+ 8], 11, -2022574463);
    c = md5_hh(c, d, a, b, x[i+11], 16,  1839030562);
    b = md5_hh(b, c, d, a, x[i+14], 23, -35309556);
    a = md5_hh(a, b, c, d, x[i+ 1], 4 , -1530992060);
    d = md5_hh(d, a, b, c, x[i+ 4], 11,  1272893353);
    c = md5_hh(c, d, a, b, x[i+ 7], 16, -155497632);
    b = md5_hh(b, c, d, a, x[i+10], 23, -1094730640);
    a = md5_hh(a, b, c, d, x[i+13], 4 ,  681279174);
    d = md5_hh(d, a, b, c, x[i+ 0], 11, -358537222);
    c = md5_hh(c, d, a, b, x[i+ 3], 16, -722521979);
    b = md5_hh(b, c, d, a, x[i+ 6], 23,  76029189);
    a = md5_hh(a, b, c, d, x[i+ 9], 4 , -640364487);
    d = md5_hh(d, a, b, c, x[i+12], 11, -421815835);
    c = md5_hh(c, d, a, b, x[i+15], 16,  530742520);
    b = md5_hh(b, c, d, a, x[i+ 2], 23, -995338651);

    a = md5_ii(a, b, c, d, x[i+ 0], 6 , -198630844);
    d = md5_ii(d, a, b, c, x[i+ 7], 10,  1126891415);
    c = md5_ii(c, d, a, b, x[i+14], 15, -1416354905);
    b = md5_ii(b, c, d, a, x[i+ 5], 21, -57434055);
    a = md5_ii(a, b, c, d, x[i+12], 6 ,  1700485571);
    d = md5_ii(d, a, b, c, x[i+ 3], 10, -1894986606);
    c = md5_ii(c, d, a, b, x[i+10], 15, -1051523);
    b = md5_ii(b, c, d, a, x[i+ 1], 21, -2054922799);
    a = md5_ii(a, b, c, d, x[i+ 8], 6 ,  1873313359);
    d = md5_ii(d, a, b, c, x[i+15], 10, -30611744);
    c = md5_ii(c, d, a, b, x[i+ 6], 15, -1560198380);
    b = md5_ii(b, c, d, a, x[i+13], 21,  1309151649);
    a = md5_ii(a, b, c, d, x[i+ 4], 6 , -145523070);
    d = md5_ii(d, a, b, c, x[i+11], 10, -1120210379);
    c = md5_ii(c, d, a, b, x[i+ 2], 15,  718787259);
    b = md5_ii(b, c, d, a, x[i+ 9], 21, -343485551);

    a = safe_add(a, olda);
    b = safe_add(b, oldb);
    c = safe_add(c, oldc);
    d = safe_add(d, oldd);
  }
  return Array(a, b, c, d);
}

/*
 * These functions implement the four basic operations the algorithm uses.
 */
function md5_cmn(q, a, b, x, s, t)
{
  return safe_add(bit_rol(safe_add(safe_add(a, q), safe_add(x, t)), s),b);
}
function md5_ff(a, b, c, d, x, s, t)
{
  return md5_cmn((b & c) | ((~b) & d), a, b, x, s, t);
}
function md5_gg(a, b, c, d, x, s, t)
{
  return md5_cmn((b & d) | (c & (~d)), a, b, x, s, t);
}
function md5_hh(a, b, c, d, x, s, t)
{
  return md5_cmn(b ^ c ^ d, a, b, x, s, t);
}
function md5_ii(a, b, c, d, x, s, t)
{
  return md5_cmn(c ^ (b | (~d)), a, b, x, s, t);
}

/*
 * Add integers, wrapping at 2^32. This uses 16-bit operations internally
 * to work around bugs in some JS interpreters.
 */
function safe_add(x, y)
{
  var lsw = (x & 0xFFFF) + (y & 0xFFFF);
  var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
  return (msw << 16) | (lsw & 0xFFFF);
}

/*
 * Bitwise rotate a 32-bit number to the left.
 */
function bit_rol(num, cnt)
{
  return (num << cnt) | (num >>> (32 - cnt));
}

var toMD5 = function(s) { return rstr2hex(rstr_md5(str2rstr_utf8(s))); }

/*
 * Perform a simple self-test to see if the VM is working
 */
function md5_vm_test()
{
  return toMD5("abc").toLowerCase() == "900150983cd24fb0d6963f7d28e17f72";
}

exports.toMD5 = toMD5;
exports.testMD5 = md5_vm_test;; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Storage/KeyValue'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Storage/KeyValue'] || {}; $MODULE_REGISTRY['NGCore/Client/Storage/KeyValue'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class KeyValue
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

function KeyValueCache() {
};
exports.KeyValueCache = KeyValueCache;
/** @private */
KeyValueCache.lruMeanCacheSize = 100;
/** @private */
KeyValueCache.instanceMap = {};
//TODO: rename this later
var StorageGlobalScopes = [];

KeyValueCache.optimizeCaches = function() 
{
	for (var storeKey in KeyValueCache.instanceMap) {
		if(KeyValueCache.instanceMap.hasOwnProperty(storeKey)) {
			KeyValueCache.instanceMap[storeKey].optimize();
		}
	}
};

KeyValueCache.lowMemoryWarning = function() 
{
	for (var storeKey in KeyValueCache.instanceMap) {
		if(KeyValueCache.instanceMap.hasOwnProperty(storeKey)) {
			var instance = KeyValueCache.instanceMap[storeKey];
			instance.data = {};

			//Purge entries in callbacks
			var newCallbacks = {};
			newCallbacks.uidGenerator = instance.callbacks.uidGenerator;
			for(var cbId in instance.callbacks)
			{
				if(instance.callbacks.hasOwnProperty(cbId)) {
					if(instance.callbacks[cbId]) {
						newCallbacks = instance.callbacks[cbId];
					}
				}
			}
			instance.callbacks = newCallbacks;
		}
	}
};

KeyValueCache.init = function()
{
	KeyValueCache.local = new Storage.KeyValue();
	KeyValueCache.local.registerForKey("local");
};

/**
 * @static Scopes this <code>KeyValueCache</code> object as global. A globally scoped KeyValueCache object can be used by multiple applications for the same data. 
 * @param {String} globalKey The store key for the <code>KeyValueCache</code> object.
 */
KeyValueCache.global = function(globalKey)
{
	if(StorageGlobalScopes[globalKey])
	{
		return StorageGlobalScopes[globalKey];
	}

	//Miss Global Table Cache.
	var scope = new Storage.KeyValue();
	scope.registerForKey(globalKey);
	StorageGlobalScopes[globalKey] = scope;
	return scope;
};

exports.KeyValue = Core.Class.subclass(
/** @lends Storage.KeyValue.prototype */
{
	classname: "KeyValue",
	/**
	 * @class The <code>KeyValue</code> class constructs objects that allow you to manage application key/value pairs in a datastore.
	 * <div class="ul">
	 * <li>Call <code>KeyValueCache.local()</code> to access the <code>local</code> datastore for your application.</li>
	 * <li>Call <code>KeyValueCache.global(globalKey)</code> to access a globally scoped datastore. Multiple applications can use a globally scoped
	 * datastore for the same data. The <code>globalKey</code> parameter is a string that uniquely identifies the datastore.</li>
	 * </div>
	 *
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		/** @private */
		this.initialized = false;
		/** @private */
		this.origin = null;
		/** @private */
		this.callbacks = {};
		/** @private */
		this.callbacks.uidGenerator = 0;
		/** @private */
		this.local = false;
		/** @private */
		this.lruCacheShrinkCounter = 0;
	
		/** @private */
		this.data = {};
		/** @private */
		this.usage = {};
		
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 */
	destroy: function()
	{
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
    /*
	 * @private
	 * Call <code>registerForKey()</code> to access a datastore identified by the value of the <code>storeKey</code> parameter.
	 * @param {String} storeKey The unique identifier of the datastore.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	registerForKey: function(storeKey) 
	{
		this.origin = storeKey;
		KeyValueCache.instanceMap[storeKey] = this;

		//Push this instance across the native bridge
		this._registerCommandSendGen(this.origin,KeyValueCache.lruMeanCacheSize);
		
		return this;
	},
	/**
	 * Pass the value associated with the key to the callback function.
	 * @param {String} key The key that is associated with the value to pass to the callback function.
	 * @param {Function} callbackFunc The callback function that uses the value associated with the key.
	 * @param {Boolean} [ignoreCache=false] Set <code>ignoreCache</code> to <code>true</code> to force a read from storage.
	 * @example KeyValue.getItem(SomeKey, function(err){...})
     * @status iOS, Android, Test, iOSTested, AndroidTested     
	 */
	getItem: function(key,callbackFunc,ignoreCache /*defaults to false*/)
	{
		if(!ignoreCache)
		{
			if(this.data[key]) {
				callbackFunc(null,this.data[key],key);
				this.usage[key]++;
				return;
			}
			else
			{
				NgLogD("Value not found in cache for..falling back to native");
			}
		}

		//Generate unused callbackEntry
		var callbackId = this.callbacks.uidGenerator++;

		if(!!!callbackFunc) {
			callbackFunc = function(){};
		}
		this.callbacks[callbackId] = callbackFunc;

		this._getItemSendGen(this.origin,callbackId,key);
	},
	
	/**
	 * Associate a value with a key.
	 * @param {String} key The key to associate with the value.
	 * @param {String} value The value to associate with the key.
	 * @param {Function} [callbackFunc] A callback function with an error parameter. The error parameter is null when the <code>setItem()</code> function completes successfully.
	 * @example KeyValue.setItem(someKey, someValue, function(err){...})
     * @status iOS, Android, Test, iOSTested, AndroidTested          
	 */
	setItem: function(key,value,callbackFunc)
	{
		var value = value;
		this.data[key] = value;

		var callbackId = this.callbacks.uidGenerator++;
		if(!callbackFunc) {
			callbackFunc = function(){};
		}
		this.callbacks[callbackId] = callbackFunc;

		this._setItemSendGen(this.origin,callbackId,key,value);
	},
	
	/**
	 * Remove the value that is associated with a key.
	 * @param {String} key The key that is associated with the value to remove.
	 * @param {Function} [callbackFunc] A callback function with an error parameter. The error parameter is null when the <code>removeItem()</code> function completes successfully.
	 * @example KeyValue.removeItem(someKey, function(err){...})
     * @status iOS, Android, Test, iOSTested, AndroidTested     
	 */
	removeItem: function(key,callbackFunc)
	{
		var callbackId = this.callbacks.uidGenerator++;
		if(!!!callbackFunc) {
			callbackFunc = function(){};
		}
		this.callbacks[callbackId] = callbackFunc;

		this._removeItemSendGen(this.origin,callbackId,key);
	},

	/**
	 *  @private
	 * 	clear all key/value pairs stored within this store
	 *  @param {callbackFunc} The callback function to be called
     *  @status iOS, Android, Test, iOSTested, AndroidTested          
	 */
	clear: function(callbackFunc)
	{
		var callbackId = this.callbacks.uidGenerator++;
		if(!!!callbackFunc) {
			callbackFunc = function(){};
		}
		this.callbacks[callbackId] = callbackFunc;

		this._clearSendGen(this.origin,callbackId);
	},
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	enforceLRUCacheSize: function()
	{
		NgLogD("Enforcing KeyValue Cache Size");
		var tmp = [];
		for (var k in this.data) {
			if (this.data.hasOwnProperty(k)) {
				tmp.push(k);
			}
		}
		var usage = this.usage;
		tmp.sort(function(a,b) {
			var p1 = usage[a];
			if (!p1) {
				p1 = 0;
			}

			var p2 = usage[b];
			if (!p2) {
				p2 = 0;
			}

			if (p1 == p2) { return 0; }
			return p1 < p2 ? 1 : -1;
		});

		var oldData = this.data;
		this.data = {};
		//Copy over the lruMeanCache(number) most used entries
		var stopPoint = KeyValueCache.lruMeanCacheSize;
		for (var i = 0; i < stopPoint && i < tmp.length; i++)
		{
			if(!oldData[tmp[i]]) {
				//Case cache didn't contain that key at this point in time
				stopPoint++;
			}
			else {
				this.data[tmp[i]] = oldData[tmp[i]];
			}
		}
	},
	
	_getInstanceRecv : function(cmd)
	{
		var msg = {};
		if(!this._getInstanceRecvGen(cmd, msg))
			return;
			
		var storeKey = msg["storeKey"];

		var instance = KeyValueCache.instanceMap[storeKey];
		//NgLogD("Storage.getInstanceForCommand Found instance for key [" + storeKey + "]: " + instance + " (" + command + ")");
		return instance;
	},
	
	_registerCommandCbRecv : function(cmd)
	{		
		var msg = {};
		if(!this._registerCommandCbRecvGen(cmd, msg))
			return;
		
		//NgLogD("Storage registerCallback: "+command+"\n");
		if(msg["error"]){
			console.log("Storage: Error registering for KeyValue location '"+msg["error"]+"'");
			if(!this.initialized) {
				delete StorageGlobalScopes[msg["originalStoreKey"]];
			}
			return;
		}

		if(this.origin == "local") {
			this.local = true;
			StorageGlobalScopes[this.origin] = this;
		}

		this.origin = msg["storeKey"];
		this.initialized = true;
		
		for(var i=0; i < msg.preloadDataCount; ++i)
		{
			var preload = {};
			if(!this._preloadDataRecvGen(cmd, preload))
				return;
			
			this.data[preload.key] = preload.value;
		}
	},
	
	_getItemCommandCbRecv : function(cmd)
	{
		var msg = {};
		if(!this._getItemCommandCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];
		var key = msg["key"];
		var value = msg["value"];
		if (error) {
			value = null;
		}

		this.data[key] = value;
		if(!this.usage[key]) {
			this.usage[key] = 1;
		} else {
			this.usage[key]++;
		}

		cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			cb(error,value,key);
			this.callbacks[cbId] = null;
		}

		if(((this.lruCacheShrinkCounter++) % KeyValueCache.lruMeanCacheSize) === 0) {
			this.enforceLRUCacheSize();
		}
		return this;
	},
	
	_setItemCommandCbRecv : function(cmd)
	{
		var msg = {};
		if(!this._setItemCommandCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];
		var key = msg["key"];

		if(!this.usage[key]) {
			this.usage[key] = 1;
		} else {
			this.usage[key]++;
		}
		
		//NgLogD("Storage.setItemCommand Found instance for key [" + key + "]: " + " (" + cbId + ")");

		cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			//NgLogD("Storage.setItemCommand Found callback");
			cb(error,key);
			this.callbacks[cbId] = null;
		}
		if(((this.lruCacheShrinkCounter++) % KeyValueCache.lruMeanCacheSize) === 0) {
			this.enforceLRUCacheSize();
		}
	},
	
	_removeItemCbRecv : function(cmd)
	{
		var msg = {};
		if(!this._removeItemCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];
		var key = msg["key"];
		delete this.usage[key];
		delete this.data[key];

		cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			cb(error,key);
			this.callbacks[cbId] = null;
		}
	},
	
	_clearCommandCbRecv : function(cmd)
	{
		var msg ={};
		if(!this._clearCommandCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];

		this.data = {};
		this.usage = {};

		cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			cb(error,this.origin);
			this.callbacks[cbId] = null;
		}

	},

	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for response types.
	 * @namespace
	 */
	Responses:
	{ 
		/** Register Storage */
		Register: 0,
		/** Get Item */
		GetItem: 1,
		/** Set Item */
		SetItem: 2,
		/** Remove Item */
		RemoveItem: 3,
		/** Clear All */
		Clear: 4,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 339
	// Method create = -1
	// Method destroy = 2
	// Method registerCommand = 3
	// Method getItem = 4
	// Method setItem = 5
	// Method removeItem = 6
	// Method clear = 7
	// Method getInstance = 8
	// Method registerCommandCb = 9
	// Method preloadData = 10
	// Method getItemCommandCb = 11
	// Method setItemCommandCb = 12
	// Method removeItemCb = 13
	// Method clearCommandCb = 14
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 8:
					instance._getInstanceRecv( cmd );
					break;
				case 9:
					instance._registerCommandCbRecv( cmd );
					break;
				case 10:
					instance._preloadDataRecv( cmd );
					break;
				case 11:
					instance._getItemCommandCbRecv( cmd );
					break;
				case 12:
					instance._setItemCommandCbRecv( cmd );
					break;
				case 13:
					instance._removeItemCbRecv( cmd );
					break;
				case 14:
					instance._clearCommandCbRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in KeyValue._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in KeyValue._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[339] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_getInstanceRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_registerCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 5 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "originalStoreKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "originalStoreKey" ] === undefined )
		{
			NgLogE("Could not parse originalStoreKey in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "preloadDataCount" ] = Core.Proc.parseInt( cmd[ 4 ] );
		if( obj[ "preloadDataCount" ] === undefined )
		{
			NgLogE("Could not parse preloadDataCount in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 5);
		return true;
	},
	
	/** @private */
	_preloadDataRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 2 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.preloadData from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.preloadData from command: " + cmd );
			return false;
		}
		
		obj[ "value" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "value" ] === undefined )
		{
			NgLogE("Could not parse value in KeyValue.preloadData from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 2);
		return true;
	},
	
	/** @private */
	_getItemCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 6 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 4 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "value" ] = Core.Proc.parseString( cmd[ 5 ] );
		if( obj[ "value" ] === undefined )
		{
			NgLogE("Could not parse value in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_setItemCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 6 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 4 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "value" ] = Core.Proc.parseString( cmd[ 5 ] );
		if( obj[ "value" ] === undefined )
		{
			NgLogE("Could not parse value in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_removeItemCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 5 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 4 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_clearCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 4 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":339,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":339,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_registerCommandSendGen: function( storeKey, lruMeanCacheSize )
	{
		Core.Proc.appendToCommandString( ":339,3," + this.__objectRegistryId + "," + Core.Base64.encode( storeKey ) + "," + lruMeanCacheSize  );
	},
	
	/** @private */
	_getItemSendGen: function( storeKey, callbackId, key )
	{
		Core.Proc.appendToCommandString( ":339,4," + this.__objectRegistryId + "," + Core.Base64.encode( storeKey ) + "," + callbackId + "," + Core.Base64.encode( key )  );
	},
	
	/** @private */
	_setItemSendGen: function( storeKey, callbackId, key, value )
	{
		Core.Proc.appendToCommandString( ":339,5," + this.__objectRegistryId + "," + Core.Base64.encode( storeKey ) + "," + callbackId + "," + Core.Base64.encode( key ) + "," + Core.Base64.encode( value )  );
	},
	
	/** @private */
	_removeItemSendGen: function( storeKey, callbackId, key )
	{
		Core.Proc.appendToCommandString( ":339,6," + this.__objectRegistryId + "," + Core.Base64.encode( storeKey ) + "," + callbackId + "," + Core.Base64.encode( key )  );
	},
	
	/** @private */
	_clearSendGen: function( storeKey, callbackId )
	{
		Core.Proc.appendToCommandString( ":339,7," + this.__objectRegistryId + "," + Core.Base64.encode( storeKey ) + "," + callbackId  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// registerCommand: function( storeKey, lruMeanCacheSize ) {}
	
	// getItem: function( storeKey, callbackId, key ) {}
	
	// setItem: function( storeKey, callbackId, key, value ) {}
	
	// removeItem: function( storeKey, callbackId, key ) {}
	
	// clear: function( storeKey, callbackId ) {}
	
	// _getInstanceRecv: function( cmd ) {}
	// _registerCommandCbRecv: function( cmd ) {}
	// _preloadDataRecv: function( cmd ) {}
	// _getItemCommandCbRecv: function( cmd ) {}
	// _setItemCommandCbRecv: function( cmd ) {}
	// _removeItemCbRecv: function( cmd ) {}
	// _clearCommandCbRecv: function( cmd ) {}

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/sprintf'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/sprintf'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/sprintf'] = exports; /**
sprintf() for JavaScript 0.6

Copyright (c) Alexandru Marasteanu <alexaholic [at) gmail (dot] com>
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of sprintf() for JavaScript nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL Alexandru Marasteanu BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


Changelog:
2007.04.03 - 0.1:
 - initial release
2007.09.11 - 0.2:
 - feature: added argument swapping
2007.09.17 - 0.3:
 - bug fix: no longer throws exception on empty paramenters (Hans Pufal)
2007.10.21 - 0.4:
 - unit test and patch (David Baird)
2010.05.09 - 0.5:
 - bug fix: 0 is now preceeded with a + sign
 - bug fix: the sign was not at the right position on padded results (Kamal Abdali)
 - switched from GPL to BSD license
2010.05.22 - 0.6:
 - reverted to 0.4 and fixed the bug regarding the sign of the number 0
 Note:
 Thanks to Raphael Pigulla <raph (at] n3rd [dot) org> (http://www.n3rd.org/)
 who warned me about a bug in 0.5, I discovered that the last update was
 a regress. I appologize for that.
**/



exports.sprintf = function() {
	str_repeat = function(i, m) {
		for (var o = []; m > 0; o[--m] = i);
		return o.join('');
	};

	var params = new Array();
	var outputArray = false;
	var paramsConsumed = 1;
	if (typeof(arguments[0]) == 'object' && arguments[0].length) {
		outputArray = true;
		for (var i = 0; i < arguments[0].length; ++i) {
			params[i] = arguments[0][i];
		}
	} else {
		for (var i = 0; i < arguments.length; ++i) {
			params[i] = arguments[i];
		}
	}

	var i = 0, a, f = params[i++], o = [], m, p, c, x, s = '';
	while (f) {
		if (m = /^[^\x25]+/.exec(f)) {
			o.push(m[0]);
		}
		else if (m = /^\x25{2}/.exec(f)) {
			o.push('%');
		}
		else if (m = /^\x25(?:(\d+)\$)?(\+)?(0|'[^$])?(-)?(\d+)?(?:\.(\d+))?([b-fosuxX])/.exec(f)) {
			if (((a = params[m[1] || i++]) == null) || (a == undefined)) {
				throw('Too few arguments.');
			}
			if (/[^s]/.test(m[7]) && (typeof(a) != 'number')) {
				throw('Expecting number but found ' + typeof(a));
			}
			switch (m[7]) {
				case 'b': a = a.toString(2); break;
				case 'c': a = String.fromCharCode(a); break;
				case 'd': a = parseInt(a); break;
				case 'e': a = m[6] ? a.toExponential(m[6]) : a.toExponential(); break;
				case 'f': a = m[6] ? parseFloat(a).toFixed(m[6]) : parseFloat(a); break;
				case 'o': a = a.toString(8); break;
				case 's': a = ((a = String(a)) && m[6] ? a.substring(0, m[6]) : a); break;
				case 'u': a = Math.abs(a); break;
				case 'x': a = a.toString(16); break;
				case 'X': a = a.toString(16).toUpperCase(); break;
			}
			a = (/[def]/.test(m[7]) && m[2] && a >= 0 ? '+'+ a : a);
			c = m[3] ? m[3] == '0' ? '0' : m[3].charAt(1) : ' ';
			x = m[5] - String(a).length - s.length;
			p = m[5] ? str_repeat(c, x) : '';
			o.push(s + (m[4] ? a + p : p + a));
			if (outputArray) ++paramsConsumed;
		}
		else {
			throw('Huh ?!');
		}
		f = f.substring(m[0].length);
	}
	if (outputArray && paramsConsumed > 0) {
		arguments[0].splice(0, paramsConsumed);
	}
	return o.join('');
};

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/LocationEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/LocationEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/LocationEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class LocationEmitter
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.LocationEmitter = Core.MessageEmitter.singleton(
/** @lends Device.LocationEmitter.prototype */
{
	classname: 'LocationEmitter',

	Accuracy:
	{
		LOW:    0, // less power consumption. equivalent to "3km"  in iOS
		MEDIUM: 1, // equivalent to "100m" in iOS
		HIGH:   2  // most accurate, high power consumption. equivalent to "Best" in iOS
	},

	Elements:
	{
		LATITUDE:  1,
		LONGITUDE: 2,
		ALTITUDE:  4,
		HEADING:   8  // equivalent to "bearing" in Android
	},

	/**
	 * @class The <code>LocationEmitter</code> class constructs a singleton object that emits <a href="Device.LocationEmitter.Location.html">Location</a> objects.<br><br>
     * @constructs The default constructor. 
 	 * @see Device.LocationEmitter.Location
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._lastLocation = undefined;
		this._forceListeners = [];
	},

	/**
	 * @param {LocationEmitter#Accuracy} Accuracy accuracy of updates. The default value is HIGH.
	 * @param {Number} elements OR-ed <code>LocationEmitter.Elements</code>. Example: LATITUDE | LONGITUDE. The default value is LATITUDE | LONGITUDE | ALTITUDE | HEADING (i.e. listens to all elements).
	 * @status
	 */
	setProperties: function(accuracy, elements)
	{
		if (! accuracy) accuracy = this.Accuracy.HIGH;
		if (! elements) elements = this.Elements.LATITUDE | this.Elements.LONGITUDE | this.Elements.ALTITUDE | this.Elements.HEADING;
		this.accuracy = accuracy;
		this.elements = elements;
		this._setPropertiesSendGen(accuracy,elements);
	},

	/**
	 * Add a <code>MessageListener</code> to this emitter. When an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * The parameters for the callback function are identical to parameters for <code>emit()</code> or
	 * <code>chain()</code>.
	 * <br><br>
	 * <b>Note:</b> Each listener can only listen to an emitter one time.<br><br>
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, 200);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @param {Function} func The callback function.
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @throws {MessageEmitter.addListener: listener is already listening} Calling <code>addListener()</code> multiple times on the same emitter
	 * with the same listener.
	 * @throws {MessageEmitter.addListener: listener must be instances of MessageListener} Listener is not an instance of <code>MessageListener</code>.
	 * @see Device.LocationEmitter#removeListener,
	 * @see Core.MessageEmitter#emit,
	 * @see Core.MessageEmitter#chain
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	addListener: function($super, listener, func, forceStart, priority) {
		if(forceStart == undefined)
		{
			this._startUpdatingSendGen(true);
			this._forceListeners.push(listener);
		}
		else
		{
			this._startUpdatingSendGen(forceStart);
			if(forceStart == true)
				this._forceListeners.push(listener);
		}

		$super(listener, func, priority);
	},
	
	/**
	 * Remove a <code>MessageListener</code> from this emitter.<br><br> 
	 * The following code examples illustrate different call styles for <code>removeListener()</code>.
	 * @example
	 * emitter.removeListener(myListener, myListener.onCallback);
	 * @example
	 * emitter.removeListener(myListener);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener was removed. Returns <code>false</code> if the registered listener is not found 
	 * or is not registered with this emitter.
	 * @throws {MessageEmitter.removeListener: listener is not listening} Specified listener is not currently registered
	 * with this emitter.
	 * @see Device.LocationEmitter#addListener
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	removeListener: function($super, listener) {
		$super(listener);

		var index = this._forceListeners.indexOf(listener);
		if(index != -1)
		{
			this._forceListeners.splice(index,1);
			if(this._forceListeners.length == 0)
				this._stopUpdatingSendGen();
		}
	},
    
	/**
	 * Retrieve the last location returned by this <code>LocationEmitter</code>.
	 * @returns {Device.LocationEmitter.Location} The last location returned.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getLastLocation: function()
	{
		if(this._lastLocation == undefined || !this._lastLocation.getPosition()) return undefined;
		
		return this._lastLocation;
	},
	
    _locationUpdatedRecv: function( cmd ) {
		var msg = {};
		if (!this._locationUpdatedRecvGen(cmd, msg))
		    return;
		
		if (((this.elements & this.Elements.LATITUDE) == 0)  &&
			((this.elements & this.Elements.LONGITUDE) == 0) &&
			((this.Elements & this.Elements.ALTITUDE) == 0))
			return;

		this._lastLocation = new this.Location(
			new Core.Point(msg["latitude"], msg["longitude"]),
			msg["altitude"],
			undefined,
			msg["accuracy"],
			msg["timestamp"]);

		this.emit(this._lastLocation);
    },
	
	_headingUpdatedRecv: function( cmd ) 
	{
		var msg = {};
		if (!this._headingUpdatedRecvGen(cmd, msg))
			return;
			
		if ((this.elements & this.Elements.HEADING) == 0)
			return;

		this._lastLocation = new this.Location(
			this._lastLocation ? this._lastLocation.getPosition() : undefined,
			this._lastLocation ? this._lastLocation.getAltitude() : undefined,
			msg['magneticHeading'],
			this._lastLocation ? this._lastLocation.getAccuracy() : undefined,
			msg['timestamp']);
		
		if(msg['magneticHeading']) {
			this.emit(this._lastLocation);
		}
	},
	
	Location: Core.Class.subclass(
	/** @lends Device.LocationEmitter.Location.prototype */
	{
		classname: 'Location',
		
		/**
		 * @class <code>Location</code> constructs objects that encapsulate the location of a device.
		 * <code>Location</code> objects contain spatial components, like position and heading information, and a timestamp that indicates when a location is measured.
		 * 
		 * @constructs The default constructor. 
		 * @param {Core.Point} position The latitude / longitude of the device.
		 * @param {Number} altitude The altitude of the device.
		 * @param {Number} heading The heading of the device.
		 * @param {Number} accuracy The accuracy of the measurement.
		 * @param {Number} timestamp The timestamp when the location was measured.
		 * @augments Core.Class
		 */
		initialize: function(position, altitude, heading, accuracy, timestamp)
		{
			this._position = position;
			this._altitude = altitude;
			this._accuracy = accuracy;
			this._heading = heading;
			this._timestamp = timestamp;
		},
		
		/**
		 * Return the position of this <code>Location</code> as latitude / longitude.
		 * @returns {Core.Point} The current latitude / longitude.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getPosition: function()
		{
			return this._position;
		},
		
		/**
		 * Return the altitude of this <code>Location</code> in feet (ft).
		 * @returns {Number} The current altitude.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getAltitude: function()
		{
			return this._altitude;
		},
		
		/**
		 * Return the heading of this <code>Location</code> in degrees east of north.
		 * @returns {Number} The current heading.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getHeading: function()
		{
			return this._heading;
		},
		
		/**
		 * Return the accuracy of the measurement for this <code>Location</code>.
		 * @returns {Number} The current location accuracy.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getAccuracy: function()
		{
			return this._accuracy;
		},
		
		/**
		 * Return the timestamp when this measurement was taken.
		 * Expressed in milliseconds since Epoch (Unix time).
		 * @returns {Number} The timestamp of the measurement.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getTimestamp: function()
		{
			return this._timestamp;
		},
	}),
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 333
	// Method create = -1
	// Method destroy = 2
	// Method startUpdatingLocation = 3
	// Method stopUpdatingLocation = 4
	// Method locationUpdated = 5
	// Method startUpdatingHeading = 6
	// Method stopUpdatingHeading = 7
	// Method headingUpdated = 8
	// Method setProperties = 9
	// Method startUpdating = 10
	// Method stopUpdating = 11
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 5:
					instance._locationUpdatedRecv( cmd );
					break;
				case 8:
					instance._headingUpdatedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LocationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LocationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[333] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_locationUpdatedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 5 )
		{
			NgLogE("Could not parse due to wrong argument count in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "timestamp" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "timestamp" ] === undefined )
		{
			NgLogE("Could not parse timestamp in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "latitude" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "latitude" ] === undefined )
		{
			NgLogE("Could not parse latitude in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "longitude" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "longitude" ] === undefined )
		{
			NgLogE("Could not parse longitude in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "altitude" ] = Core.Proc.parseFloat( cmd[ 3 ] );
		if( obj[ "altitude" ] === undefined )
		{
			NgLogE("Could not parse altitude in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "accuracy" ] = Core.Proc.parseFloat( cmd[ 4 ] );
		if( obj[ "accuracy" ] === undefined )
		{
			NgLogE("Could not parse accuracy in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_headingUpdatedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 4 )
		{
			NgLogE("Could not parse due to wrong argument count in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "timestamp" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "timestamp" ] === undefined )
		{
			NgLogE("Could not parse timestamp in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "magneticHeading" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "magneticHeading" ] === undefined )
		{
			NgLogE("Could not parse magneticHeading in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "trueHeading" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "trueHeading" ] === undefined )
		{
			NgLogE("Could not parse trueHeading in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "accuracy" ] = Core.Proc.parseFloat( cmd[ 3 ] );
		if( obj[ "accuracy" ] === undefined )
		{
			NgLogE("Could not parse accuracy in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":333,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":333,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_startUpdatingLocationSendGen: function( accuracy, distanceFilter )
	{
		Core.Proc.appendToCommandString( ":333,3," + this.__objectRegistryId + "," + accuracy + "," + distanceFilter  );
	},
	
	/** @private */
	_stopUpdatingLocationSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":333,4," + this.__objectRegistryId );
	},
	
	/** @private */
	_locationUpdatedSendGen: function( timestamp, latitude, longitude, altitude, accuracy )
	{
		Core.Proc.appendToCommandString( ":333,5," + this.__objectRegistryId + "," + timestamp + "," + latitude + "," + longitude + "," + altitude + "," + accuracy  );
	},
	
	/** @private */
	_startUpdatingHeadingSendGen: function( orientation, angularFilter )
	{
		Core.Proc.appendToCommandString( ":333,6," + this.__objectRegistryId + "," + orientation + "," + angularFilter  );
	},
	
	/** @private */
	_stopUpdatingHeadingSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":333,7," + this.__objectRegistryId );
	},
	
	/** @private */
	_headingUpdatedSendGen: function( timestamp, magneticHeading, trueHeading, accuracy )
	{
		Core.Proc.appendToCommandString( ":333,8," + this.__objectRegistryId + "," + timestamp + "," + magneticHeading + "," + trueHeading + "," + accuracy  );
	},
	
	/** @private */
	_setPropertiesSendGen: function( accuracy, elements )
	{
		Core.Proc.appendToCommandString( ":333,9," + this.__objectRegistryId + "," + accuracy + "," + elements  );
	},
	
	/** @private */
	_startUpdatingSendGen: function( force )
	{
		Core.Proc.appendToCommandString( ":333,10," + this.__objectRegistryId + "," + ( force ? 1 : 0 )  );
	},
	
	/** @private */
	_stopUpdatingSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":333,11," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// startUpdatingLocation: function( accuracy, distanceFilter ) {}
	
	// stopUpdatingLocation: function(  ) {}
	
	// _locationUpdatedRecv: function( cmd ) {}
	// locationUpdated: function( timestamp, latitude, longitude, altitude, accuracy ) {}
	
	// startUpdatingHeading: function( orientation, angularFilter ) {}
	
	// stopUpdatingHeading: function(  ) {}
	
	// _headingUpdatedRecv: function( cmd ) {}
	// headingUpdated: function( timestamp, magneticHeading, trueHeading, accuracy ) {}
	
	// setProperties: function( accuracy, elements ) {}
	
	// startUpdating: function( force ) {}
	
	// stopUpdating: function(  ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/MemoryEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/MemoryEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/MemoryEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.MemoryEmitter = Core.MessageEmitter.singleton(
/** @lends Device.MemoryEmitter.prototype */
{
	classname: 'MemoryEmitter',
		
	/**
	 * @class The <code>MemoryEmitter</code> class constructs a singleton object that emits messages
	 * when a low memory warning is received from the system.
	 * Applications can respond by releasing unused objects, allowing the system to re-allocate free memory.
	 * Failure to respond to low memory warnings may result in application 
	 * termination by the operating system.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	_memoryEventRecv: function( cmd ) 
	{
		this.emit();
		
		//Cascade the original message back out to native for forwarding
		this._memoryEventSendGen();
	},
													  
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 331
	// Method create = -1
	// Method memoryEvent = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._memoryEventRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in MemoryEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in MemoryEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[331] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_memoryEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in MemoryEmitter.memoryEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":331,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_memoryEventSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":331,2," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _memoryEventRecv: function( cmd ) {}
	// memoryEvent: function(  ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/MotionEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/MotionEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/MotionEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.MotionEmitter = Core.MessageEmitter.singleton(
/** @lends Device.MotionEmitter.prototype */
{
	classname: 'MotionEmitter',
	
	/**
	 * @class The <code>MotionEmitter</code> class constructs a singleton object that tracks device movement through 3D space. 
	 * These objects emit <a href="Device.MotionEmitter.Motion.html">Motion</a> objects that retrieve spatial data for a given component from the device.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @see Device.MotionEmitter.Motion
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		this._lastAccel = null;
		this._lastGyro  = null;
		this._lastCompass = null;
	},

	Motion: Core.Class.subclass(
	/** @lends Device.MotionEmitter.Motion.prototype */
	{
		classname: 'Motion',
		
		/**
		 * @class A <code>Motion</code> object is what <code>MotionEmitter</code> uses to capture device movement through 3D space.
		 * These objects retrieve data from device components on how a device responds to 
		 * physical movement, as reported by the accelerometer, gyroscope and compass instruments.
		 * @constructs The default constructor. 
		 * @param {Array (Number)} accel The accelerometer data.
		 * @param {Array (Number)} gyro The gyroscope data.
		 * @param {Array (Number)} compass The compass data.
		 * @see Device.MotionEmitter
		 * @augments Core.Class
		 */
		initialize: function(accel, gyro, compass)
		{
			this._accel = accel;
			this._gyro  = gyro;
			this._compass = compass;
		},
		
		/**
		 * Retrieve accelerometer data from the device. If the device contains an accelerometer,
		 * calling <code>getAccelData()</code> returns an array of three floating point values. In all other cases,
		 * calling <code>getAccelData()</code> returns <code>undefined</code>.
		 * <b>Note:</b> Use a <code>{@link Core.Capabilities</code> object 
		 * to programmatically check a device for a accelerometer. 
		 * @returns {Array (Number)} The accelerometer data for the device.
		 * @see Core.Capabilities#getHasAccel
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getAccelData: function()
		{
			return this._accel;
		},
		
		/**
		 * Retrieve gyroscope data from the device. If the device contains a gyroscope,
		 * this call returns an array of three floating point values. In all other cases,
		 * this call returns <code>undefined</code>. <br><br>
		 * <b>Note:</b> Use a <code>{@link Core.Capabilities</code> object 
		 * to programmatically check a device for a gyroscope. 
		 * @returns {Array (Number)} The gyroscope data for the device.
		 * @see Core.Capabilities#getHasGyro
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getGyroData: function()
		{
			return this._gyro;
		},
		
		/**
		 * Retrieve compass data from the device. If the device contains a magnetic compass,
		 * this call returns an array of three floating point values. In all other cases,
		 * this call returns <code>undefined</code>.<br><br>
		 * <b>Note:</b> Use a <code>Capabilities</code> object to programmatically check a device for a compass. 
		 * @returns {Array (Number)} The compass data for the device.
		 * @see Core.Capabilities#getHasCompass
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getCompassData: function()
		{
			return this._compass;
		},
	}),

	/**
	 * Construct a <code>MessageListener</code> object and register it with this <code>MotionEmitter</code> object. If an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * The parameters for the callback function are identical to parameters for <code>emit()</code> or
	 * <code>chain()</code>.<br><br>
	 * <b>Note:</b> Each listener can only listen to an emitter once.
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, 200);
	 *
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @param {Function} func The callback function.
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @see Core.MessageEmitter#emit,
	 * @see Core.MessageEmitter#chain
	 *
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	addListener: function($super, listener, func, priority)
	{
		if (this.getListenerCount() == 0) {
			// start the Accelerometer if this is the first listener
			this._startMotionSendGen();
		}

		$super(listener, func, priority);
	},

	/**
	 * Remove a <code>MessageListener</code> object from this <code>MotionEmitter</code> object. 
	 * The following code examples illustrate different call styles for <code>removeListener()</code>.
	 * @example
	 * emitter.removeListener(myListener, myListener.onCallback);
	 * @example
	 * emitter.removeListener(myListener);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.	 
	 * @returns {Boolean} Returns <code>true</code> when the registered listener was removed. Returns <code>false</code> in all other cases.
	 * @see Core.MessageEmitter#addListener
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	removeListener: function($super, listener)
	{
		$super(listener);

		if (this.getListenerCount() == 0) {
			// stop the Accelerometer if this is the last listener
			this._stopMotionSendGen();
		}
	},

	_emitMotion: function()
	{
		var motion = new Device.MotionEmitter.Motion(this._lastAccel, this._lastGyro, this._lastCompass);
		this.emit(motion);
	},

	_accelChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._accelChangedRecvGen(cmd, msg))
			return;

		this._lastAccel = msg;
		this._emitMotion();
		
		//Cascade the original message back out to native for forwarding
		this._accelChangedSendGen(msg.x, msg.y, msg.z);
	},

	_gyroChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._gyroChangedRecvGen(cmd, msg))
			return;

		this._lastGyro = msg;
		this._emitMotion();
		
		//Cascade the original message back out to native for forwarding
		this._gyroChangedSendGen(msg.x, msg.y, msg.z);
	},
	
	_magneticChangedRecv: function( cmd ) 
	{
		var msg = {};
		if(!this._magneticChangedRecvGen(cmd, msg))
			return;
		
 		this._lastCompass = msg;
		this._emitMotion();
		
		//Cascade the original message back out to native for forwarding
		this._magneticChangedSendGen(msg.x, msg.y, msg.z);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 330
	// Method create = -1
	// Method accelChanged = 2
	// Method gyroChanged = 3
	// Method magneticChanged = 4
	// Method startMotion = 5
	// Method stopMotion = 6
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._accelChangedRecv( cmd );
					break;
				case 3:
					instance._gyroChangedRecv( cmd );
					break;
				case 4:
					instance._magneticChangedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in MotionEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in MotionEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[330] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_accelChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		obj[ "z" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "z" ] === undefined )
		{
			NgLogE("Could not parse z in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_gyroChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		obj[ "z" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "z" ] === undefined )
		{
			NgLogE("Could not parse z in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_magneticChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		obj[ "z" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "z" ] === undefined )
		{
			NgLogE("Could not parse z in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":330,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_accelChangedSendGen: function( x, y, z )
	{
		Core.Proc.appendToCommandString( ":330,2," + this.__objectRegistryId + "," + x + "," + y + "," + z  );
	},
	
	/** @private */
	_gyroChangedSendGen: function( x, y, z )
	{
		Core.Proc.appendToCommandString( ":330,3," + this.__objectRegistryId + "," + x + "," + y + "," + z  );
	},
	
	/** @private */
	_magneticChangedSendGen: function( x, y, z )
	{
		Core.Proc.appendToCommandString( ":330,4," + this.__objectRegistryId + "," + x + "," + y + "," + z  );
	},
	
	/** @private */
	_startMotionSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":330,5," + this.__objectRegistryId );
	},
	
	/** @private */
	_stopMotionSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":330,6," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _accelChangedRecv: function( cmd ) {}
	// accelChanged: function( x, y, z ) {}
	
	// _gyroChangedRecv: function( cmd ) {}
	// gyroChanged: function( x, y, z ) {}
	
	// _magneticChangedRecv: function( cmd ) {}
	// magneticChanged: function( x, y, z ) {}
	
	// startMotion: function(  ) {}
	
	// stopMotion: function(  ) {}
	

// {{/Wg Generated Code}} }}}

});
// vim:set fdm=marker noexpandtab:
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/NetworkEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/NetworkEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/NetworkEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.NetworkEmitter = Core.MessageEmitter.singleton(
/** @lends Device.NetworkEmitter.prototype */
{
	classname: 'NetworkEmitter',
	
	/**
	 * @class The <code>NetworkEmitter</code> class constructs a singleton object that tracks network connectivity status for a device.
	 * These objects emit a <a href="Device.NetworkEmitter.html#Status">Status</a> object when a change to device network connectivity status occurs.
	 * A change in network status is defined as:
	 * <div class="ul"><font size="3">
	 * <li>The device loses access to a network.</li>
	 * <li>The device gains access to a network.</li>
	 * <li>The device switches between cellular and Wi-Fi network access.</li>
	 * </font></div><br>
	 * <p><b>Note:</b> Applications should never directly allocate a singleton.</p>
	 * @constructs The default constructor. 
	 * @see Device.NetworkEmitter#Status
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		this._lastStatus = null;
	},

	/**
	 * Retrieve the network status of the device.
	 * @returns {Device.NetworkEmitter#Status} The current device network status.
	 * @status iOS, Android, Test
	 */
	getLastStatus: function()
	{
		return this._lastStatus;
	},

	/** 
	 * Enumeration values for device network status.
	 * @fieldOf Device.NetworkEmitter.prototype
	 */
	Status:
	{
		/** 
		* <code>0</code> = No network connectivity. 
		* @fieldOf Device.NetworkEmitter.prototype
		* @constant
		*/
		None: 0,
		
		/** 
		* <code>1</code> = Cellular network connectivity. 
		* @fieldOf Device.NetworkEmitter.prototype
		* @constant
		*/
		Cellular: 1,
		
		/** 
		* <code>2</code> = Wi-Fi network connectivity. 
		* @fieldOf Device.NetworkEmitter.prototype
		* @constant
		*/
		Wifi: 2,
	},

	_statusChangedRecv: function( cmd )
	{
		var msg = {};
		if (!this._statusChangedRecvGen(cmd, msg))
		    return;

		this._lastStatus = msg['status'];
		this.emit(this._lastStatus);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 336
	// Method create = -1
	// Method statusChanged = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._statusChangedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in NetworkEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in NetworkEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[336] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_statusChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in NetworkEmitter.statusChanged from command: " + cmd );
			return false;
		}
		
		obj[ "status" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "status" ] === undefined )
		{
			NgLogE("Could not parse status in NetworkEmitter.statusChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":336,-1," + __objectRegistryId  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _statusChangedRecv: function( cmd ) {}

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/OrientationEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/OrientationEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/OrientationEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class OrientationEmitter
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.OrientationEmitter = Core.MessageEmitter.singleton(
/** @lends Device.OrientationEmitter.prototype */
{
	classname: 'OrientationEmitter',
		
	/**
	 * @class <code>OrientationEmitter</code> constructs a singleton object that tracks the physical orientation of the device.
	 * These objects emit an <code><a href="Device.OrientationEmitter.html#Orientation">Orientation</a></code> object when a change in device orientation occurs.<br><br>
	 * Rotating the device does not necessarily rotate the 
	 * interface presented to the user. Applications must
	 * explicitly call <code><a href="Device.OrientationEmitter.html#setInterfaceOrientation">setInterfaceOrientation()</a></code> to rotate the interface.
	 * This allows an application to selectively choose a supported device orientation.
	 * For example, an application can observe orientation change events and change the interface orientation only if the application suppoorts it.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 	 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		this._lastDeviceOrientation    = this.Orientation.Portrait;
		this._lastInterfaceOrientation = this.Orientation.Portrait;
	},
	
	/**
	 * Retrieve the device orientation.
	 * @returns {Device.OrientationEmitter#Orientation} The current device orienation.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getDeviceOrientation: function()
	{
		return this._lastDeviceOrientation;
	},
	
	/**
	 * Retrieve the interface orientation. Initially, this is the same
	 * as the device orientation.
	 * @returns {Device.OrientationEmitter#Orientation} The current interface orientation.
	 * @see Device.OrientationEmitter#setInterfaceOrientation
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getInterfaceOrientation: function()
	{
		return this._lastInterfaceOrientation;
	},
	
	/**
	 * Set the interface orientation.
	 * @example var orientation = new Device.OrientationEmitter(Device.OrientationEmitter.Orientation.Portrait, true);
	 * @param {Device.OrientationEmitter#Orientation} orientation The new device orientation.
	 * @param {Boolean} [animated] Set as <code>true</code> to render the orientation change with an animated effect.
	 * @see Device.OrientationEmitter#getInterfaceOrientation
	 * @status iOS, Test
	 */
	setInterfaceOrientation: function(orientation, animated)
	{
		if (orientation != this._lastInterfaceOrientation)
		{
			NgLogD("setInterfaceOrientation to " + orientation);
			this._setInterfaceOrientationSendGen(orientation,animated);
			this._lastInterfaceOrientation = orientation;
		}
	},
	
	/**
	 * Enumeration for device orientation.
	 * @fieldOf Device.OrientationEmitter.prototype
	 */
	Orientation:
	{ 
		/** 
		* Portrait orientation. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		Portrait: 0,
		/** 
		* Portrait orientation, but rotated 180 degrees. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		PortraitUpsideDown: 1,
		/** 
		* Landscape orientation with the top of the device to the left. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		LandscapeLeft: 2,
		/** 
		* Landscape orientation with the top of the device to the right. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		LandscapeRight: 3,
		/** 
		* Oriented with the face of the device up. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		FaceUp: 4,
		/** 
		* Oriented with the face of the device down. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		FaceDown: 5,
	},

	/**
	 * Enumeration for orientation type.
	 * It can be used to identify which event happens.
	 * @filedOf Device.OrientationEmitter.prototype
	 */
	OrientationType:
	{
		/**
		* Device orientation has changed.
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		Device: 0,
		/**
		* Interface orientation has changed.
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		Interface: 1
	},

	_orientationChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._orientationChangedRecvGen(cmd, msg))
			return;
 
 		this._lastDeviceOrientation = msg['orientation'];
		this.emit({type: this.OrientationType.Device, orientation:msg['orientation']});
		
		//Cascade the original message back out to native for forwarding
		this._orientationChangedSendGen(msg.orientation);
	},
	
	_interfaceOrientationChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._interfaceOrientationChangedRecvGen(cmd, msg))
			return;
 
 		this._lastInterfaceOrientation = msg['orientation'];
		this.emit({type: this.OrientationType.Interface, orientation:msg['orientation']});
		
		//Cascade the original message back out to native for forwarding
		this._interfaceOrientationChangedSendGen(msg.orientation);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 335
	// Method create = -1
	// Method orientationChanged = 2
	// Method setInterfaceOrientation = 3
	// Method interfaceOrientationChanged = 4
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._orientationChangedRecv( cmd );
					break;
				case 4:
					instance._interfaceOrientationChangedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in OrientationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in OrientationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[335] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_orientationChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in OrientationEmitter.orientationChanged from command: " + cmd );
			return false;
		}
		
		obj[ "orientation" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "orientation" ] === undefined )
		{
			NgLogE("Could not parse orientation in OrientationEmitter.orientationChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_interfaceOrientationChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in OrientationEmitter.interfaceOrientationChanged from command: " + cmd );
			return false;
		}
		
		obj[ "orientation" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "orientation" ] === undefined )
		{
			NgLogE("Could not parse orientation in OrientationEmitter.interfaceOrientationChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":335,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_orientationChangedSendGen: function( orientation )
	{
		Core.Proc.appendToCommandString( ":335,2," + this.__objectRegistryId + "," + orientation  );
	},
	
	/** @private */
	_setInterfaceOrientationSendGen: function( orientation, animated )
	{
		Core.Proc.appendToCommandString( ":335,3," + this.__objectRegistryId + "," + orientation + "," + ( animated ? 1 : 0 )  );
	},
	
	/** @private */
	_interfaceOrientationChangedSendGen: function( orientation )
	{
		Core.Proc.appendToCommandString( ":335,4," + this.__objectRegistryId + "," + orientation  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _orientationChangedRecv: function( cmd ) {}
	// orientationChanged: function( orientation ) {}
	
	// setInterfaceOrientation: function( orientation, animated ) {}
	
	// _interfaceOrientationChangedRecv: function( cmd ) {}
	// interfaceOrientationChanged: function( orientation ) {}
	

// {{/Wg Generated Code}} }}}

});
// vim:set fdm=marker noexpandtab:
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/ShakeEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/ShakeEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/ShakeEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;
var MotionEmitter = require('NGCore/Client/Device/MotionEmitter').MotionEmitter;

var ProxyListener = Core.MessageListener.subclass(
{
	onUpdate: function() {}
});

exports.ShakeEmitter = Core.MessageEmitter.singleton(
/** @lends Device.ShakeEmitter.prototype */
{
	classname: 'ShakeEmitter',
		
	/**
	 * @class The <code>ShakeEmitter</code> class constructs a singleton object that tracks when users physically shake the device. 
	 * These objects emit messages when the device recognizes a shake gesture.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android
	 */
	
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._proxyListener = new ProxyListener();
		
	},
	
	/**
	 * Add a <code>MessageListener</code> to this emitter. When an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * The parameters for the callback function are identical to parameters for <code>emit()</code> or
	 * <code>chain()</code>.
	 * <br><br>
	 * <b>Note:</b> Each listener can only listen to an emitter one time.<br><br>
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, 200);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @param {Function} func The callback function.
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @throws {MessageEmitter.addListener: listener is already listening} Calling <code>addListener()</code> multiple times on the same emitter
	 * with the same listener.
	 * @throws {MessageEmitter.addListener: listener must be instances of MessageListener} Listener is not an instance of <code>MessageListener</code>.
	 * @see Device.ShakeEmitter#removeListener,
	 * @see Core.MessageEmitter#emit,
	 * @see Core.MessageEmitter#chain
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	addListener: function($super, listener, func, priority)
	{
		if (this.getListenerCount() == 0) {
			MotionEmitter.addListener(this._proxyListener, function(){});
		}

		$super(listener, func, priority);
	},
	
	/**
	 * Remove a <code>MessageListener</code> from this emitter.<br><br> 
	 * The following code examples illustrate different call styles for <code>removeListener()</code>.
	 * @example
	 * emitter.removeListener(myListener, myListener.onCallback);
	 * @example
	 * emitter.removeListener(myListener);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener was removed. Returns <code>false</code> if the registered listener is not found 
	 * or is not registered with this emitter.
	 * @throws {MessageEmitter.removeListener: listener is not listening} Specified listener is not currently registered
	 * with this emitter.
	 * @see Device.ShakeEmitter#addListener
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	removeListener: function($super, listener)
	{
		$super(listener);

		if (this.getListenerCount() == 0) {
			MotionEmitter.removeListener(this._proxyListener);
		}
	},
	
	_shakeRecv: function( cmd )
	{
		this.emit();
		
		//Cascade the original message back out to native for forwarding
		this._shakeSendGen();
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 332
	// Method create = -1
	// Method shake = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._shakeRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in ShakeEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in ShakeEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[332] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_shakeRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in ShakeEmitter.shake from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":332,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_shakeSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":332,2," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _shakeRecv: function( cmd ) {}
	// shake: function(  ) {}
	

// {{/Wg Generated Code}}	

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/KeyEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/KeyEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/KeyEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;
var UI = require('NGCore/Client/UI').UI;

////////////////////////////////////////////////////////////////////////////////

// Private Class Statics
var keyCodeReverseMap = null;

exports.KeyEmitter = Core.MessageEmitter.singleton(
/** @lends Device.KeyEmitter.prototype */
{
	classname: 'KeyEmitter',

	/**
	 * @class The <code>KeyEmitter</code> class constructs a singleton object that emits a <code><a href="Device.KeyEmitter.KeyEvent.html">KeyEvent</a></code> object 
	 * when the user presses or releases a device hardware key.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @require Device
	 * @example
	 *
	 * var KeyListener = Core.MessageListener.subclass({
	 *   onUpdate: function(keyEvent) {
	 *     // back to the launcher when the back button is pressed
	 *     if (keyEvent.code === Device.KeyEmitter.Keycode.back) {
	 *        this.destroy();
	 *        LGL.runUpdatedGame('/Samples/Launcher');
	 *        return;
	 *     }
	 *
	 *     var text = '';
	 *     switch (keyEvent.type) {
	 *        case Device.KeyEmitter.EventType.onDown:
	 *           text += 'onDown :'
	 *           break;
	 *        case Device.KeyEmitter.EventType.onUp:
	 *           text += 'onUp :'
	 *           break;
	 *     }
	 *
	 *     text += Device.KeyEmitter.keyCodeToSymbol(keyEvent.code);
	 *     console.log(text);
	 *   }
	 * };
	 *
	 * var keyListener = new KeyListener();
	 * Device.KeyEmitter.addListener(keyListener, keyListener.onUpdate);
	 *
	 * @status Android, Test, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	/**
	 * Convert a keycode into the equivalent human-readable symbol. The keycode to convert is passed in as a parameter.
	 * The following code example illustrates how to convert a keycode into a human-readable symbol.
	 * @param {String} keyCode The keycode to convert.
	 * @static
	 *
	 * @example
	 *   var symbol = Device.KeyEmitter.keyCodeToSymbol(0x1d);
	 *   // symbol => 'a'
	 *
	 * @status
	 */
	keyCodeToSymbol: function(keyCode)
	{
		if (!keyCodeReverseMap) {
			keyCodeReverseMap = {};
			for (var codename in this.Keycode) {
				keyCodeReverseMap[this.Keycode[codename]] = codename;
			}
		}
		return keyCodeReverseMap[keyCode] || '';
	},

	KeyEvent: Core.Class.subclass(
	/** @lends Device.KeyEmitter.KeyEvent.prototype */
	{
		classname: 'KeyEvent',

		/**
		 * @class <code>KeyEvent</code> constructs objects that contain the parcel of a keyboard event. 
		 * The keycode of the key that triggered the event is passed in as a parameter.
		 * @constructs The default constructor. 
		 * @augments Core.Class
		 * @param {Device.KeyEmitter.EventType} type The type of the keyboard event.
		 * @param {Integer} modifiers the bit-and of {@link Device.KeyEmitter#Modifier} combination.
		 * @param {Device.KeyEmitter.Keycode} code The actual keycode.
		 */
		initialize: function(type, modifiers, code)
		{
			this.type      = type;
			this.modifiers = modifiers;
			this.code      = code;
		}
	}),

	_onKeyEventRecv: function( cmd )
	{
		var msg = {};
		if(!this._onKeyEventRecvGen(cmd, msg))
			return;

		var keyEvent = new Device.KeyEmitter.KeyEvent(msg.type, msg.modifiers, msg.code);
		
		if(!this.chain(keyEvent)) {
			//Noone handled this keyEvent. Cascade the original back out to native for forwarding
			//	to the next interpreter in the chain.
			this._onKeyEventSendGen(msg.type, msg.modifiers, msg.code);
		}
	},

// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Event type Enums.
	 * Currently we only have onUp and onDown events.
	 *
	 * @namespace
	 * */
	EventType:
	{ 
		/** the key is hooked up. */
		onUp: 0,
		/** the key is pressed down. */
		onDown: 1,
	},
	
	/** 
	 * Enums for modifiers that are being pressed.
	 * They are passed as bit-and-ed.
	 *
	 * @namespace
	 * @example
	 *
	 * var keyEvent; // emitted from KeyEmitter
	 * if (keyEvent.modifiers & Device.KeyEmitter.Modifier.ALT && 
	 *     keyEvent.modifiers & Device.KeyEmitter.Modifier.SHIFT)
	 *    console.log("ALT+SHIFT");
	 * */
	Modifier:
	{ 
		/** no modifiers */
		NONE: 0,
		/** SYMBOL modifier */
		SYMBOL: 1 << 0,
		/** ALT modifier */
		ALT: 1 << 1,
		/** ALT_LEFT modifier */
		ALT_LEFT: 1 << 2,
		/** ALT_RIGHT modifier */
		ALT_RIGHT: 1 << 3,
		/** SHIFT modifier */
		SHIFT: 1 << 4,
		/** SHIFT_LEFT modifier */
		SHIFT_LEFT: 1 << 5,
		/** SHIFT_RIGHT modifier */
		SHIFT_RIGHT: 1 << 6,
	},
	
	/** 
	 * Keycode Enums.
	 * Define bunch of key codes.
	 * @namespace
	 * */
	Keycode:
	{ 
		/** * */
		a: 0x1d,
		/** * */
		b: 0x1e,
		/** * */
		c: 0x1f,
		/** * */
		d: 0x20,
		/** * */
		e: 0x21,
		/** * */
		f: 0x22,
		/** * */
		g: 0x23,
		/** * */
		h: 0x24,
		/** * */
		i: 0x25,
		/** * */
		j: 0x26,
		/** * */
		k: 0x27,
		/** * */
		l: 0x28,
		/** * */
		m: 0x29,
		/** * */
		n: 0x2a,
		/** * */
		o: 0x2b,
		/** * */
		p: 0x2c,
		/** * */
		q: 0x2d,
		/** * */
		r: 0x2e,
		/** * */
		s: 0x2f,
		/** * */
		t: 0x30,
		/** * */
		u: 0x31,
		/** * */
		v: 0x32,
		/** * */
		w: 0x33,
		/** * */
		x: 0x34,
		/** * */
		y: 0x35,
		/** * */
		z: 0x36,
		/** TBD */
		up: 0x13,
		/** TBD */
		down: 0x14,
		/** TBD */
		left: 0x15,
		/** TBD */
		right: 0x16,
		/** * */
		enter: 0x42,
		/** * */
		backspace: 0x43,
		/** * */
		back: 0x04,
		/** backunhandled: 0x54, Special KeyCode to tell MobageService that the back was unhandled by the game, after the service declined first dibs. Stole MAX_KEYCODE (deprecated constant). */
		backunhandled: 0x54,
		/** * */
		menu: 0x52,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 343
	// Method create = -1
	// Method onKeyEvent = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._onKeyEventRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in KeyEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in KeyEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[343] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onKeyEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		obj[ "type" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "type" ] === undefined )
		{
			NgLogE("Could not parse type in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		obj[ "modifiers" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "modifiers" ] === undefined )
		{
			NgLogE("Could not parse modifiers in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		obj[ "code" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "code" ] === undefined )
		{
			NgLogE("Could not parse code in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":343,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_onKeyEventSendGen: function( type, modifiers, code )
	{
		Core.Proc.appendToCommandString( ":343,2," + this.__objectRegistryId + "," + type + "," + modifiers + "," + code  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _onKeyEventRecv: function( cmd ) {}
	// onKeyEvent: function( type, modifiers, code ) {}
	

// {{/Wg Generated Code}}

});
// vim:set fdm=marker noexpandtab:
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/_PushNotificationEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/_PushNotificationEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/_PushNotificationEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;

/*
	NOTE: 	THIS IS FOR INTERNAL USE ONLY AND WILL BE DEPRECATED IN THE FUTURE.
			DO NOT USE IT IN ANY OF YOUR CODE.
*/

exports.PushNotificationEmitter = Core.MessageEmitter.singleton(
/** @lends Device.PushNotificationEmitter.prototype */
{
	classname: 'PushNotificationEmitter',
		
	/**
	 * @class Emits when native code recieves a push notification
	 * @constructs The default constructor.
	 * @augments Core.MessageEmitter
	 */
	
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	_onPushNotificationRecv: function( cmd )
	{
		var msg = {};
		if (!this._onPushNotificationRecvGen(cmd, msg))
			return;
			
		this._lastMsgPayload = msg.msgPayload;
		
		if(!this.chain(msg.msgPayload))	{
			//Noone handled this keyEvent. Cascade the original back out to native for forwarding
			//	to the next interpreter in the chain.
			this._onPushNotificationSendGen(msg.msgPayload);
		}
		
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 345
	// Method create = -1
	// Method onPushNotification = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._onPushNotificationRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in PushNotificationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in PushNotificationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[345] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onPushNotificationRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in PushNotificationEmitter.onPushNotification from command: " + cmd );
			return false;
		}
		
		obj[ "msgPayload" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "msgPayload" ] === undefined )
		{
			NgLogE("Could not parse msgPayload in PushNotificationEmitter.onPushNotification from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":345,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_onPushNotificationSendGen: function( msgPayload )
	{
		Core.Proc.appendToCommandString( ":345,2," + this.__objectRegistryId + "," + Core.Base64.encode( msgPayload )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _onPushNotificationRecv: function( cmd ) {}
	// onPushNotification: function( msgPayload ) {}
	

// {{/Wg Generated Code}}	

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/_InAppPurchaseEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchaseEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchaseEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class InAppPurchaseEmitter
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.InAppPurchaseEmitter = Core.MessageEmitter.singleton(
/** @lends Device.InAppPurchaseEmitter.prototype */
{
	classname: 'InAppPurchaseEmitter',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	_onPurchaseEventRecv: function( cmd ) {
		var msg = {};
		if (!this._onPurchaseEventRecvGen(cmd, msg))
			return;
		if(!this.chain(msg.err, msg.data, msg.verificationToken))	{
			//Noone handled this keyEvent. Cascade the original back out to native for forwarding
			//	to the next interpreter in the chain.
			this._onPurchaseEventSendGen(msg.err, msg.data, msg.verificationToken);
		}
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 347
	// Method create = -1
	// Method onPurchaseEvent = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._onPurchaseEventRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in InAppPurchaseEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in InAppPurchaseEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[347] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onPurchaseEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		obj[ "err" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "err" ] === undefined )
		{
			NgLogE("Could not parse err in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		obj[ "data" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "data" ] === undefined )
		{
			NgLogE("Could not parse data in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		obj[ "verificationToken" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "verificationToken" ] === undefined )
		{
			NgLogE("Could not parse verificationToken in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":347,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_onPurchaseEventSendGen: function( err, data, verificationToken )
	{
		Core.Proc.appendToCommandString( ":347,2," + this.__objectRegistryId + "," + Core.Base64.encode( err ) + "," + Core.Base64.encode( data ) + "," + Core.Base64.encode( verificationToken )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _onPurchaseEventRecv: function( cmd ) {}
	// onPurchaseEvent: function( err, data, verificationToken ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/_InAppPurchase'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchase'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchase'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class InAppPurchase
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var DeviceReq = require('NGCore/Client/Device');
var Localization = require('NGCore/Client/Core/Localization').Localization;

////////////////////////////////////////////////////////////////////////////////

exports.InAppPurchase = Class.singleton(
/** @lends Device.InAppPurchase.prototype */
{
	classname: 'InAppPurchase',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	initService: function(ordercb, donecb) {
		if ((!this._isIOS()) && (!this._isAndroid())) {
			NgLogE("ERROR: Neither Android nor iOS platform, IAP will not work");
			donecb();
			return;
		}
		if (!this._iapInited) {
			var IAPListener = Core.MessageListener.subclass({
				onPurchaseEvent: this._iapCallback.bind(this)
			});
			// Register for Android / iOS IAP callbacks the same way
			this.listener = new IAPListener();
	        DeviceReq.Device.InAppPurchaseEmitter.addListener(
				this.listener, this.listener.onPurchaseEvent);
	    	// listener will be called when purchase state changes
		}
		this._initDonecb = donecb;
		this._initOrdercb = ordercb;
		if (this._isAndroid()) {
			this._iapCallback('morenonces', '', '');
			/*
			 * Gets persisted unfulfilled orders, calls back ordercb for each
			 * unfulfilled order.
			 */
			var self = this;
			Storage.KeyValueCache.local.getItem(this._IAB_ORPHANED,
			function(err, currorders) {
	   			if (currorders && (currorders.length > 0)) {
					var orders = JSON.parse(currorders);
   					// _restoreOrders eventually calls _initService when fully
					// done.
					self._restoreOrders(orders);
				} else {
					self._initService();
				}
			});
		} else {
			// _isIOS - call _initService directly.  It will call back with
			// orphaned order if any.
			this._initService();
		}
	},

	launchPurchaseView: function(productID, quantity, purchasecb, failcb, cancelcb) {
		if (!this._iapInited) {
			NgLogE("ERROR: function initService must be called and its donecb " +
			"called back, before launchPurchaseView may be used.");
			failcb(false, "failed:initservice_not_done");
			return;
		}

		this._currentOrderProductID = productID;

		this._currentOrderCancelcb = cancelcb;
		this._currentOrderFailcb = failcb;
		this._currentOrderPurchasecb = purchasecb;

		// Android IAB currently only supports quantity of 1
		if (quantity !== 1 && this._isAndroid()) {
			failcb(false, "failed:unsupported_quantity");
			return;
		}

		// Place progress dialog underneath the IAB view first
        if(this._isIOS()) {
	        this._currentOrderProgressDialog = (new UI.ProgressDialog()).retain();
	        this._currentOrderProgressDialog.setText(Localization.getString("Processing Order"));
        } else if(!this._isIOS()) {
	        this._currentOrderProgressDialog = (new UI.AlertDialog()).retain();
	        this._currentOrderProgressDialog.setTitle(Localization.getString("Processing Order"));
            // todo: localization???
            this._currentOrderProgressDialog.setText(
                "Your order is being processed. You will receive a confirmation momentarily.");
            this._currentOrderProgressDialog.setChoices(["OK"]);
            this._currentOrderProgressDialog.onchoice = function(event) {
                this._currentOrderProgressDialog.release();
                this._currentOrderProgressDialog = null;
            };
        }

	    this._currentOrderProgressDialog.show();

		if (this._isIOS() || this._isAndroid()) {
	        DeviceReq.Device.InAppPurchase._requestPurchase(productID, quantity);
			// Note that _iapCallback will call the *cb callback function(s)
			return;
		}
	    this._currentOrderProgressDialog.hide();
        this._currentOrderProgressDialog.release();
	    this._currentOrderProgressDialog = undefined;
		NgLogE('launchPurchaseView failed: only Android and iOS platforms are currently supported.');
		failcb(false, "failed:unsupported_platform");
		return;
	},

	pushSingleNonce: function(nonce){
		var noncePool = [];
		noncePool.push(nonce);
		this._fillIABNoncePool(JSON.stringify(noncePool));
	},

	/**
	 * get a product information specified by productId.
	 * @param {String} productId the product ID registered at iTunes connect.
	 * @param {Function} callback called back when it gets a response. The signature for the callback is equivalent to:<br><br>
	 * <pre>function(productData, err)</pre><br>
	 * The <code>productData</code> is an product information like "JPY,115.000000".
	 * When something bad happenes, <code>err</code> is set to the error message. Otherwise, err will be null or undefined.
	 * @status iOS, iOSTested
	 */
	getProductInformation: function(productId, callback) {
		this._getProductInformationCB = callback;
		this._getProductInformationSendGen(productId);
	},

	/*
	 * For Google IAB, these constants come from
	 * Consts.java in IAB sample code
	 *
	 *	public enum PurchaseState {
     *   PURCHASED,   // User was charged for the order. -- 0
     *   CANCELED,    // The charge failed on the server. -- 1
	 *   REFUNDED;    // User received a refund for the order. -- 2
	 */
	_IAB_PURCHASED: 0,
	_IAB_CANCELED: 1,
	_IAB_REFUNDED: 2,
	_IAB_ORPHANED: "com.ngmoco.in_app_purchase.iab_orphaned_orders",

	_capIsAndroid: undefined,
	_capIsIOS: undefined,

	// at most one outstanding order is supported
	_currentOrderCancelcb : undefined,
	_currentOrderFailcb : undefined,
	_currentOrderProductID : undefined,
	_currentOrderProgressDialog : undefined,
	_currentOrderPurchasecb : undefined,

	_initDonecb : undefined,
	_initOrdercb : undefined,
	_iapInited: false,

	_generateIABNonce: function(){
		var timestamp = new Date().getTime();
		var random = Math.floor(Math.random() * 1000);
		var nonce = (timestamp * 1000) + random;
		NgLogD("Generated nonce: " + nonce);
		return nonce;
	},

	_iapCallback: function( err, data, verificationToken ) {
		if (err == 'morenonces') {
			var count = 10;
			var noncePool = [];
			while(noncePool.length < count){
				noncePool.push(this._generateIABNonce());
			}
			this._fillIABNoncePool(JSON.stringify(noncePool));
			return true;
		}
		if ((err == 'initdone') || (err == 'initcheckdone')) {
			if (typeof this._initDonecb == 'function') {
				this._iapInited = true;
				this._initDonecb();
				this._initDonecb = undefined;
				this._initOrdercb = undefined;
			} else {
				NgLogW("WARN: " + err + " callback with empty donecb");
			}
	        // at most one listener gets iap events
	        return true;
		}
		if (err == 'getProductInformationDone') {
			if (data && data.length > 0) {
				var datajsonp = JSON.parse(data);
				this._getProductInformationCB(datajsonp.productId);
			} else {
				this._getProductInformationCB('', "no information on this product");
			}
			this._getProductInformationCB = undefined;
			return true;
		}
		var orderId = undefined;
		var prodId = "";
	    var firstOrder = undefined;
	    var datajson = undefined;
		if (data && data.length > 0) {
		    datajson = JSON.parse(data);
		    if ((typeof datajson.orders == 'undefined') ||
		        (datajson.orders.length <= 0)) {
		        // callback with no orders, try to get prodId
			    if (typeof datajson.productId != 'undefined') {
					prodId = datajson.productId.toUpperCase();
				}
		    } else {
 				if (this._isAndroid() &&
				 	(typeof this._currentOrderProgressDialog == 'undefined')) {
						// this callback comes in 'out of band', when user did
						// not attempt a purchase.  This happens on Android
						// when async callbacks are not confirmed due to
						// connectivity issue.  This callback is persisted for
						// the next 'initService' call to pick up. Only
						// successful orders will be used in callbacks.
						// Failed order and refunds are ignored.
						//
						// Note also that Android IAB could callback with
						// duplicate order numbers.  In other words, the same
						// order number could come back twice in 2 different
						// callbacks.  There is no code on client to detect
						// such duplicate.  It is up to the server to detect
						// orders which have already been fulfilled.
						//
						var successOrders = this._filterSuccessOrders(datajson, verificationToken);
						if (successOrders.length > 0) {
							this._persistOrphanedOrders(successOrders);
						}
						return true;
				} else if (datajson.orders.length === 1) {
					// on iOS, and in common cases on Android, there is at
					// most one order
				    firstOrder = datajson.orders[0];
					prodId = firstOrder.productId.toUpperCase();
					orderId = firstOrder.orderId;
				} else {
					var successOrders2 = this._filterSuccessOrders(datajson, verificationToken);
					// on Android, get the first match.  Then add any orphaned
					// orders to existing list of persisted
					// orders.  These will be processed during next initService
					if (successOrders2.length > 0) {
					    firstOrder = successOrders2.shift();
						prodId = firstOrder.productId.toUpperCase();
						orderId = firstOrder.orderId;
						if (successOrders2.length > 0) {
							this._persistOrphanedOrders(successOrders2);
						}
					}
				}
			}
		}
		if (this._currentOrderProductID != prodId) {
			NgLogW("iapCallback: product id mismatch in callback.  Req: '" +
					this._currentOrderProductID + "' CB:'" + prodId + "'");
		}
		if ((err && (err.length > 0)) || (firstOrder && firstOrder.purchaseState &&
			(firstOrder.purchaseState !== this._IAB_PURCHASED))) {
			if (firstOrder && firstOrder.purchaseState &&
				(firstOrder.purchaseState === this._IAB_REFUNDED)) {
				// refunds are generated 'out of the blue' by merchant and is
				// not part of normal flow.  Hence it is ignored.  Code now
				// continues to wait for actual purchase callback
				NgLogD("iapCallback: ignoring refunded order: " +
						JSON.stringify(firstOrder));
				return true;
			}
			if (typeof this._currentOrderProgressDialog != 'undefined') {
				this._currentOrderProgressDialog.hide();
                this._currentOrderProgressDialog.release();
				this._currentOrderProgressDialog = undefined;
			}

			if (err == 'cancelled') {
				if ((typeof this._currentOrderCancelcb) == 'function') {
					this._currentOrderCancelcb();
					this._currentOrderCancelcb = undefined;
				}
			} else {
				if (err) {
					NgLogD("DEBUG: iapCallback: got error: " + err);
				} else {
					// _IAB_CANCELED
					NgLogD("DEBUG: iapCallback: got canceled purchaseState.");
				}
				if ((typeof this._currentOrderFailcb) == 'function') {
					this._currentOrderFailcb(false, err);
					this._currentOrderFailcb = undefined;
				}
			}

	        // at most one listener gets iap events
	        return true;
	    }
		if (typeof firstOrder == 'undefined') {
			// there was no (non-refunded) order in callback
			return true;
		}
	    var nextcb2 = function(cbIsDone) {
			if (typeof this._currentOrderProgressDialog != 'undefined') {
				this._currentOrderProgressDialog.hide();
		        this._currentOrderProgressDialog.release();
				this._currentOrderProgressDialog = undefined;
			}
		    if (cbIsDone !== false) {
				return;
			}
			// Currently, fail if the first try is not done, no retry
			if ((typeof this._currentOrderFailcb) == 'function') {
				this._currentOrderFailcb(true, "failed:no_more_retry");
				this._currentOrderFailcb = undefined;
			}
	    };
		if ((typeof this._currentOrderPurchasecb) == 'function') {
			var receipt = verificationToken;
			if (this._isAndroid()) {
				// on Android, both the data and signature are required
				// for verification
				var receiptj = {
					data: data,
					signature: verificationToken
				};
				receipt = JSON.stringify(receiptj);
			}
		    this._currentOrderPurchasecb(prodId, orderId, receipt, firstOrder, nextcb2.bind(this));
			this._currentOrderPurchasecb = undefined;
		} else if ((!this._iapInited) && ((typeof this._initOrdercb) ==
		 			'function')) {
			var initcb2 = function(){
				// Do nothing on iOS as Store Observer simply emits
				// asychronously until done.
			};
			// part of initService flow
		    this._initOrdercb(prodId, orderId, verificationToken, firstOrder,
			initcb2);
		}
        // at most one listener gets iap events
        return true;
    },

	_isAndroid: function() {
		if (typeof this._capIsAndroid != 'undefined') {
			return this._capIsAndroid;
		}
		// Find out from capabilities
	    var capabilities = Core.Capabilities;
	    if ((typeof capabilities.getPlatformOS() != "undefined") &&
	        (capabilities.getPlatformOS().toLowerCase() == 'android')) {
	        this._capIsAndroid = true;
	    } else {
	        this._capIsAndroid = false;
		}
		return this._capIsAndroid;
	},

	_isIOS: function() {
		if (typeof this._capIsIOS != 'undefined') {
			return this._capIsIOS;
		}
		// Find out from capabilities
	    var capabilities = Core.Capabilities;
	    if ((typeof capabilities.getPlatformOS() != "undefined") &&
	        (capabilities.getPlatformOS().toLowerCase() == 'iphone os')) {
	        this._capIsIOS = true;
	    } else {
	        this._capIsIOS = false;
		}
		return this._capIsIOS;
	},

	_fillIABNoncePool: function(nonces) {
		this._fillIABNoncePoolSendGen(nonces);
	},
	_filterSuccessOrders: function(datajson, verificationToken) {
		var successOrders = [];
		for (var kdx in datajson.orders) {
			if ((datajson.orders[kdx].purchaseState) &&
				(datajson.orders[kdx].purchaseState ===
					this._IAB_PURCHASED)) {
				var theorder = datajson.orders[kdx];
				theorder.verificationToken = verificationToken;
				successOrders.push(theorder);
			}
		}
		return successOrders;
	},
	_persistOrphanedOrders: function(successOrders) {
		// add orders to existing list of persisted orders
		Storage.KeyValueCache.local.getItem(this._IAB_ORPHANED,
			(function(err, currorders){
				if (currorders && (currorders.length > 0)) {
					var orderlist = JSON.parse(currorders);
					for (var idx in orderlist) {
						successOrders.push(orderlist[idx]);
					}
				}
			    Storage.KeyValueCache.local.setItem(this._IAB_ORPHANED,
					JSON.stringify(successOrders), function(){
					NgLogD("Orphaned orders added to persistent store: " + JSON.stringify(successOrders));
			    });
			}).bind(this));
	},
	_initService: function() {
		this._initServiceSendGen();
	},

	_requestPurchase: function( sku, quantity ) {
		this._requestPurchaseSendGen(sku, quantity);
	},

	/*
	 * Given unfulfilled orders, calls back ordercb for each unfulfilled order.
	 * Resets persisted store using removeItem when done, then call
	 * _initService to continue init process.
	 */
	_restoreOrders: function(orders) {
		var self = this;
		if (orders.length <= 0) {
			// No more unfulfilled orders
			Storage.KeyValueCache.local.removeItem(this._IAB_ORPHANED,
			function() {
				self._initService();
			});
			return;
		}
		var order = orders.pop();
		var cb = function() {
			self._restoreOrders(orders);
		};
		// part of initService flow
		this._initOrdercb(order.productId.toUpperCase(), order.orderId, order.verificationToken, order, cb.bind(this));
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 348
	// Method create = -1
	// Method initService = 2
	// Method requestPurchase = 3
	// Method fillIABNoncePool = 4
	// Method getProductInformation = 5
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in InAppPurchase._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in InAppPurchase._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[348] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":348,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_initServiceSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":348,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_requestPurchaseSendGen: function( sku, quantity )
	{
		Core.Proc.appendToCommandString( ":348,3," + this.__objectRegistryId + "," + Core.Base64.encode( sku ) + "," + quantity  );
	},
	
	/** @private */
	_fillIABNoncePoolSendGen: function( nonces )
	{
		Core.Proc.appendToCommandString( ":348,4," + this.__objectRegistryId + "," + Core.Base64.encode( nonces )  );
	},
	
	/** @private */
	_getProductInformationSendGen: function( productId )
	{
		Core.Proc.appendToCommandString( ":348,5," + this.__objectRegistryId + "," + Core.Base64.encode( productId )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// initService: function(  ) {}
	
	// requestPurchase: function( sku, quantity ) {}
	
	// fillIABNoncePool: function( nonces ) {}
	
	// getProductInformation: function( productId ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/IPCEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/IPCEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/IPCEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class IPCEmitter
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;
var Class          = require('NGCore/Client/Core/Class').Class;
var Proc           = require('NGCore/Client/Core/Proc').Proc;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Base64         = require('NGCore/Client/Core/Base64').Base64;
var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var DownloadFile   = require('NGCore/Client/Network/DownloadFile').DownloadFile;
var Util           = require('NGCore/Client/Network/Util').Util;
var FileSystem     = require('NGCore/Client/Storage/FileSystem').FileSystem;

////////////////////////////////////////////////////////////////////////////////

exports.IPCEmitter = MessageEmitter.singleton(
/** @lends Device.IPCEmitter.prototype */
{

	classname: 'IPCEmitter',

	/**
	 * @class The IPCEmitter class constructs a singleton object that handles Inter-Process Communication. 
	 * These objects emit events when a specified application is launched from within another application.
	 * @constructs The default constructor.
	 * @augments Core.MessageEmitter
	 */
	initialize: function()
	{
		console.log('IPCEmitter.initialize');
		this._callbackID = 0;
		this._callbacks = [];
		
		this._shouldEmitIntents = false;

		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	/**
	 * Check whether the host OS can launch the provided URL asynchronously.
	 * @example var appToLaunch = 'mobage//auth?packageName=xxx.xxx&className=xxx.xxx';
	 * Device.IPCEmitter.canLaunch(appToLaunch, function(canLaunch) {
	 * 	if (canLaunch) {
	 * 		console.log('launching... ' + canLaunch);
	 * 		Device.IPCEmitter.launch(appToLaunch, function(error) {
	 * 			label.setText('failed in launching the URL:' + appToLaunch);
	 * 		});
	 * 	} else {
	 * 		label.setText('cannot launch the URL:' + appToLaunch);
	 * 	}
	 * });
	 * @param {String} url A URL to test
	 * @param {Function} callback A callback function that passes a Boolean value when a result is returned. 
	 * If the URL is OK to launch, the callback returns <code>true</code>.
	 * @status
	 */
	canLaunch: function(url, callback)
	{
		this._callbacks[this._callbackID] = callback;
		this._canLaunchSendGen(url,this._callbackID);
		this._callbackID++;
	},

	/**
	 * Request that the host OS launch the provided URL.
	 * @example var appToLaunch = 'mobage//auth?packageName=xxx.xxx&className=xxx.xxx'
	 * Device.IPCEmitter.launch(appToLaunch, function(error) {
	 * 	label.setText('failed in  launching the URL:' + appToLaunch);
	 * });
	 * @param {String} url A URL to launch
	 * @param {Function} errCallback A callback function that passes an error object when an error occurs. 
	 * If the URL is successfully launched, no callback. Otherwise, the callback returns an error.
	 */
	launch: function(url, callback)
	{
		 this._callbacks[this._callbackID] = callback;
		 this._launchSendGen(url,this._callbackID);
		 this._callbackID++;
	},

	launchIntent: function( intent, extras )
	{
		this._launchIntentSendGen(intent,extras);
	},
	
	launchService: function( intent, extras, packageName )
	{
		//This function originally did not take a "packageName" parameter, it was part of the extrasObj.
		//The separate parameter is added to make it a bit more clear that it is necessary to pass in a packageName.
		//Not sure it's going to help though, because we're trying to preserve backwards compatibility here.
		if (typeof(packageName) == "string")
		{
			var extrasObj;
			if (typeof(extras) == "string")
			{
				extrasObj = JSON.parse(extras);
			}
			else
			{
				extrasObj = {};
			}
			extrasObj["packageName"] = packageName;
			extras = JSON.stringify(extrasObj);
		}
		this._launchServiceSendGen(intent,extras);
	},

	/**
	 * Launch a Single Sign-on URL.
	 * @example var appToLaunch = 'mobage//auth?packageName=xxx.xxx&className=xxx.xxx';
	 * Device.IPCEmitter.launchForSSO(appToLaunch, function(error) {
	 * 	label.setText('failed in  launching the URL:' + appToLaunch);
	 * });
	 * @param {String} url The URL to launch. The URL must include the following as part of the query string: packageName=xxxx&className=yyyy.
	 * @param {Function} callback The callback function. 
	 * @status
	 */
	launchForSSO: function(url, callback)
	{
		url += '&sso_auth';
		this.launch(url, callback);
	},

	/**
	 * Return an array of signatures for the packageName.
	 * @param {String} packageName packageName is like "com.ngmoco.gamejs"
	 * @param {Function} callback callback function signature: function(signatures) { }
	 * @status Android
	 */
	getAppSignatures: function(packageName, callback)
	{
		this._callbacks[this._callbackID] = callback;
		this._getAppSignaturesSendGen(packageName,this._callbackID);
		this._callbackID++;
	},

	/**
	 * Return the package name that invokes this ngCore app.
	 * @param {Function} callback The current callback function. Below is the callback signature. 
	 * @example function(packageName) { }
	 * @status Android
	 */
	getCallingPackage: function(callback)
	{
		this._callbacks[this._callbackID] = callback;
		this._getCallingPackageSendGen(this._callbackID);
		this._callbackID++;
	},
	
	/**
	 * Return whether the service .
	 * @param {Function} callback The current callback function. Below is the callback signature. 
	 * @example function(packageName) { }
	 * @status Android
	 */
	getIsServiceRunning: function(serviceEnum, callback)
	{
		this._callbacks[this._callbackID] = callback;
		this._getIsServiceRunningSendGen(serviceEnum, this._callbackID);
		this._callbackID++;
	},


	app: function()
	{
		return this._app;
	},

	App: Class.subclass(
	/** @lends Device.IPCEmitter.App.prototype */
	{
		classname: 'App',

		/**
		 * @class Information about the app.
		 */
		initialize: function(sourceAppID, intentURL)
		{
			this._sourceAppID   = sourceAppID;
			this._intentURL     = intentURL;
		},

		/**
		 * information for checking if application has launched or resumed with custom URL scheme.
		 * @type String
		 */
		getID: function()
		{
			return this._sourceAppID;
		},

		/**
		 * Returns the URL used to launch this app, or an empty string if not launched via URL
		 * @type String
		 */
		getURL: function()
		{
			return this._intentURL;
		}
	}),

	Intent: Class.subclass(
	/** @lends Device.IPCEmitter.App.prototype */
	{
		classname: 'Intent',

		/**
		 * @class Information about the app.
		 */
		initialize: function(action, extras)
		{
			this._action   = action;
			this._extras   = extras;
		},

		/**
		 * information for checking if application has launched or resumed with custom URL scheme.
		 * @type String
		 */
		getAction: function()
		{
			return this._action;
		},

		/**
		 * Returns the URL used to launch this app, or an empty string if not launched via URL
		 * @type String
		 */
		getExtras: function()
		{
			return this._extras;
		}
	}),

	/**
	 * Create home screen shortcut icon.
	 * @param {String} name Displayed shortcut name
	 * @param {String} url Invoked url when icon clicked. 
	 * @param {String} icon_path Local file path that stores icon file.
	 * @status Android
	 */
	createShortcut: function( name, url, icon_path )
	{
		this._createShortcutSendGen(name, url, icon_path);
	},

	/**
	 * Create home screen shortcut icon with downloading its image.
	 * @param {String} name Displayed shortcut name.
	 * @param {String} url Invoked url when icon clicked. 
	 * @param {String} icon_url Icon image url.
	 * @param {Function} callback Callback function that passes a Boolean value whether download succeed. Below is the callback signature.
	 * @example function(hasDownloadError) { }
	 * @status Android
	 */
	createShortcutByIconUrl: function( name, url, icon_url, callback )
	{
                NgLogD("createShortcutByIconUrl called", name, url, icon_url);

                var df = new DownloadFile();
                var filename = 'shortcut_icon_image'+(new Date().getTime());
                var self = this;
                NgLogD("Icon download begin");
		Util.OperationWithRetries(function(failCb, abortCb) {
			df.start(filename, 'GET', icon_url, [], function( statusCode, fileSignature ) {
				NgLogD("Icon download finished status="+statusCode);
				if(statusCode == 200) {
					self.createShortcut( name, url, filename );
					FileSystem.deleteFile( filename, function() {
						if(callback)
							callback(false);
					});
				}
				else if(statusCode == 404)
				{
					NgLogE("Unable download icon file: icon_url="+icon_url+", status="+statusCode);
					abortCb();
				}
				else
				{
					NgLogE("Unable download icon file: icon_url="+icon_url+", status="+statusCode);
					failCb();
				}
			});
		},
		function() {
			NgLogE("Unable download icon file");
			if(callback)
				callback(true);
		}, 
		true);
	},

	// ------------------------------------------------------------------
	// private
	//

	/**
	 * invoked from native when the app is resumed back from other app.
	 */
	_onResumedFromOthers: function (url, sourceAppID)
	{
		this._app = new Device.IPCEmitter.App(sourceAppID, url);
		this.emit(this._app);

		//Cascade the original message back out to native for forwarding
		this._onResumeFromOthersSendGen(url, sourceAppID);
	},
	
	// Should only be called by privileged callers
	_setEmitIntents: function ( emit ) {
		this._shouldEmitIntents = Boolean(emit);
	},

	_onIntentReceived: function (action, extras)
	{
		console.log("On IntentReceived: " + action + " / " + JSON.stringify(extras));
		if (this._shouldEmitIntents) {
			this.emit( new exports.IPCEmitter.Intent(action, extras) );
		}
	},

	// private
	_canLaunchCallbackRecv: function( cmd )
	{
		var msg = {};
		if (! this._canLaunchCallbackRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.canLaunch);
		}
	},

	_onResumeFromOthersRecv: function(cmd)
	{
		var msg = {};
		if (! this._onResumeFromOthersRecvGen(cmd, msg))
			return;

		this._onResumedFromOthers(msg.url, msg.sourceAppID);
	},

	_launchFailedRecv: function( cmd )
	{
		var msg = {};
		if (! this._launchFailedRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.canLaunch);
		}
	},

	_getAppSignaturesCallbackRecv: function( cmd )
	{
		var msg = {};
		if (! this._getAppSignaturesCallbackRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.signatures.split(','));
		}
	},

	_getCallingPackageCallbackRecv: function( cmd )
	{
		var msg = {};
		if (! this._getCallingPackageCallbackRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.packageName);
		}
	},
	
	
	_getIsServiceRunningCallbackRecv: function( cmd )
	{
		var msg = {};
		if (! this._getIsServiceRunningCallbackRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.running);
		}
	},
	
	_onIntentReceivedRecv: function( cmd )
	{
		var msg = {};
		if (! this._onIntentReceivedRecvGen(cmd, msg))
			return;
		
		this._onIntentReceived( msg.action, JSON.parse(msg.extras, 10) );
	},

// {{?Wg Generated Code}}
	
	// Enums.
	/** 
			* Enumeration for services whose status may be queried.
			* @namespace
			 */
	Service:
	{ 
		/** * */
		SystemDownloadProvider: 1,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 349
	// Method create = -1
	// Method canLaunch = 2
	// Method launch = 3
	// Method onResumeFromOthers = 4
	// Method launchFailed = 5
	// Method canLaunchCallback = 6
	// Method getAppSignatures = 7
	// Method getAppSignaturesCallback = 8
	// Method getCallingPackage = 9
	// Method getCallingPackageCallback = 10
	// Method launchIntent = 11
	// Method launchService = 12
	// Method onIntentReceived = 13
	// Method getIsServiceRunning = 14
	// Method getIsServiceRunningCallback = 15
	// Method createShortcut = 16
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 4:
					instance._onResumeFromOthersRecv( cmd );
					break;
				case 5:
					instance._launchFailedRecv( cmd );
					break;
				case 6:
					instance._canLaunchCallbackRecv( cmd );
					break;
				case 8:
					instance._getAppSignaturesCallbackRecv( cmd );
					break;
				case 10:
					instance._getCallingPackageCallbackRecv( cmd );
					break;
				case 13:
					instance._onIntentReceivedRecv( cmd );
					break;
				case 15:
					instance._getIsServiceRunningCallbackRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in IPCEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in IPCEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[349] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onResumeFromOthersRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.onResumeFromOthers from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in IPCEmitter.onResumeFromOthers from command: " + cmd );
			return false;
		}
		
		obj[ "sourceAppID" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "sourceAppID" ] === undefined )
		{
			NgLogE("Could not parse sourceAppID in IPCEmitter.onResumeFromOthers from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_launchFailedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.launchFailed from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in IPCEmitter.launchFailed from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.launchFailed from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_canLaunchCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.canLaunchCallback from command: " + cmd );
			return false;
		}
		
		obj[ "canLaunch" ] = Core.Proc.parseBool( cmd[ 0 ] );
		if( obj[ "canLaunch" ] === undefined )
		{
			NgLogE("Could not parse canLaunch in IPCEmitter.canLaunchCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.canLaunchCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_getAppSignaturesCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.getAppSignaturesCallback from command: " + cmd );
			return false;
		}
		
		obj[ "signatures" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "signatures" ] === undefined )
		{
			NgLogE("Could not parse signatures in IPCEmitter.getAppSignaturesCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.getAppSignaturesCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_getCallingPackageCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.getCallingPackageCallback from command: " + cmd );
			return false;
		}
		
		obj[ "packageName" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "packageName" ] === undefined )
		{
			NgLogE("Could not parse packageName in IPCEmitter.getCallingPackageCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.getCallingPackageCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onIntentReceivedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.onIntentReceived from command: " + cmd );
			return false;
		}
		
		obj[ "action" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "action" ] === undefined )
		{
			NgLogE("Could not parse action in IPCEmitter.onIntentReceived from command: " + cmd );
			return false;
		}
		
		obj[ "extras" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "extras" ] === undefined )
		{
			NgLogE("Could not parse extras in IPCEmitter.onIntentReceived from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_getIsServiceRunningCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.getIsServiceRunningCallback from command: " + cmd );
			return false;
		}
		
		obj[ "running" ] = Core.Proc.parseBool( cmd[ 0 ] );
		if( obj[ "running" ] === undefined )
		{
			NgLogE("Could not parse running in IPCEmitter.getIsServiceRunningCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.getIsServiceRunningCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":349,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_canLaunchSendGen: function( url, callbackID )
	{
		Core.Proc.appendToCommandString( ":349,2," + this.__objectRegistryId + "," + Core.Base64.encode( url ) + "," + callbackID  );
	},
	
	/** @private */
	_launchSendGen: function( url, callbackID )
	{
		Core.Proc.appendToCommandString( ":349,3," + this.__objectRegistryId + "," + Core.Base64.encode( url ) + "," + callbackID  );
	},
	
	/** @private */
	_onResumeFromOthersSendGen: function( url, sourceAppID )
	{
		Core.Proc.appendToCommandString( ":349,4," + this.__objectRegistryId + "," + Core.Base64.encode( url ) + "," + Core.Base64.encode( sourceAppID )  );
	},
	
	/** @private */
	_getAppSignaturesSendGen: function( packageName, callbackID )
	{
		Core.Proc.appendToCommandString( ":349,7," + this.__objectRegistryId + "," + Core.Base64.encode( packageName ) + "," + callbackID  );
	},
	
	/** @private */
	_getCallingPackageSendGen: function( callbackID )
	{
		Core.Proc.appendToCommandString( ":349,9," + this.__objectRegistryId + "," + callbackID  );
	},
	
	/** @private */
	_launchIntentSendGen: function( intent, extras )
	{
		Core.Proc.appendToCommandString( ":349,11," + this.__objectRegistryId + "," + Core.Base64.encode( intent ) + "," + Core.Base64.encode( extras )  );
	},
	
	/** @private */
	_launchServiceSendGen: function( intent, extras )
	{
		Core.Proc.appendToCommandString( ":349,12," + this.__objectRegistryId + "," + Core.Base64.encode( intent ) + "," + Core.Base64.encode( extras )  );
	},
	
	/** @private */
	_getIsServiceRunningSendGen: function( serviceEnum, callbackID )
	{
		Core.Proc.appendToCommandString( ":349,14," + this.__objectRegistryId + "," + serviceEnum + "," + callbackID  );
	},
	
	/** @private */
	_createShortcutSendGen: function( name, url, icon_path )
	{
		Core.Proc.appendToCommandString( ":349,16," + this.__objectRegistryId + "," + Core.Base64.encode( name ) + "," + Core.Base64.encode( url ) + "," + Core.Base64.encode( icon_path )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// canLaunch: function( url, callbackID ) {}
	
	// launch: function( url, callbackID ) {}
	
	// _onResumeFromOthersRecv: function( cmd ) {}
	// onResumeFromOthers: function( url, sourceAppID ) {}
	
	// _launchFailedRecv: function( cmd ) {}
	// _canLaunchCallbackRecv: function( cmd ) {}
	// getAppSignatures: function( packageName, callbackID ) {}
	
	// _getAppSignaturesCallbackRecv: function( cmd ) {}
	// getCallingPackage: function( callbackID ) {}
	
	// _getCallingPackageCallbackRecv: function( cmd ) {}
	// launchIntent: function( intent, extras ) {}
	
	// launchService: function( intent, extras ) {}
	
	// _onIntentReceivedRecv: function( cmd ) {}
	// getIsServiceRunning: function( serviceEnum, callbackID ) {}
	
	// _getIsServiceRunningCallbackRecv: function( cmd ) {}
	// createShortcut: function( name, url, icon_path ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/LayoutEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/LayoutEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/LayoutEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class LayoutEmitter
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.LayoutEmitter = Core.MessageEmitter.singleton(
/** @lends Device.LayoutEmitter.prototype */
{
	classname: 'LayoutEmitter',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	_layoutChangedRecv: function( cmd ) 
	{
		var msg = {};
		if(!this._layoutChangedRecvGen(cmd, msg))
			return;

 		this._width = msg['width'];
 		this._height = msg['height'];
 		//NgLogD("+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++JS received width as :"+ this._width + " and height as :" + this._height); 
		this.emit(msg);
		this._layoutChangedSendGen(msg.width, msg.height);
	},
	
	$getWidth: function()
	{
		return this._width;
	},
	
	$getHeight: function()
	{
		return this._height;
	},
	
	/**
	 * @private
	 */
	setWidthAndHeight: function(width, height) {
		//NgLogD("---------------------------------Setting width and height for LayoutEmitter directly from native ......... width is " + width + " and height is " + height );
		this._width = width;
		this._width = height;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 352
	// Method create = -1
	// Method layoutChanged = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._layoutChangedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LayoutEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LayoutEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[352] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_layoutChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in LayoutEmitter.layoutChanged from command: " + cmd );
			return false;
		}
		
		obj[ "width" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "width" ] === undefined )
		{
			NgLogE("Could not parse width in LayoutEmitter.layoutChanged from command: " + cmd );
			return false;
		}
		
		obj[ "height" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "height" ] === undefined )
		{
			NgLogE("Could not parse height in LayoutEmitter.layoutChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":352,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_layoutChangedSendGen: function( width, height )
	{
		Core.Proc.appendToCommandString( ":352,2," + this.__objectRegistryId + "," + width + "," + height  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _layoutChangedRecv: function( cmd ) {}
	// layoutChanged: function( width, height ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Appdata'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Appdata'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Appdata'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class 
 * @name Social.Common.Appdata
 * @description
 * Mobage provides a common API for application data, which you can use for both Japan and the US. 
 * <code>Appdata</code> is consistent with the Open Social <code>osapi.appdata</code> interface, 
 * and enables the application to store name/value pairs for arbitrary application data.
 * To add or update application data, call <code>updateEntries()</code>. To retrieve entries, call <code>getEntries()</code>. 
 * To delete entries, call <code>deleteEntries()</code>.
 * @see Social.US.AppData for additional Mobage persistence facilities.
 * @see Storage.KeyValue for additional ngCore persistence facilities.
 * @see Storage.FileSystem for additional ngCore persistence facilities.
 */
exports.Appdata = {
		
	/**
	 * Retrieves a hash of one or more key/value pairs.
	 * If the <code>keys</code> parameter is <code>null</code>, <code>undefined</code> or an empty array, <code>getEntries()</code> 
	 * returns all key/value pairs to the callback function.
	 *
	 * @name Social.Common.Appdata.getEntries
	 * @function
	 * @public
	 * 
	 * @param {Array} keys Set as an array of key names. For example, <code>['key1', 'key2']</code>.
	 * @param {Function} callback Retrieves a hash of key/value pairs. If an error occurs, retursn an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var entries = {"key1": "value1", "key2": "value2"};
     * ...
     * function(error, entries){
     * &nbsp;&nbsp;   if (error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
     * &nbsp;&nbsp;   } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var retrievedEntries = entries;
     * &nbsp;&nbsp;   }
	 * }
	 * </pre>
	 * @see Social.Common.Appdata.updateEntries
	 * @example 
	 * Appdata.getEntries(['key1', 'key2'], callback );
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	getEntries: function(keys, callback) {
		var cmd = {apiURL:"Common.Appdata.getEntries", keys:keys, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
	},
	
	/**
	 * Inserts or updates the submitted key/value pairs. 
	 * <b>Note:</b> Limited to 30 key/value pairs per user, per game. 
	 * Maximum key name limited to 32 bytes. Maximum value limited to 1,024 bytes.
     * To use key/value pairs without the foregoing constraints, use <code>Storage.KeyValue</code>
     * in ngCore.
	 *
	 * @name Social.Common.Appdata.updateEntries
	 * @function
	 * @public
	 * 
	 * @param {Hash} entries Takes a hash of key/value pairs. For example, <code>{"favoriteMovie": "Pulp Fiction", "petName": "Rover"}</code>.
	 * @param {Function} callback Retrieves the updated entries. If an error occurs, returns an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var entries = {"favoriteMovie": "Pulp Fiction", "petName": "Rover"};
     * ...
     * function(error, entries){
     * &nbsp;&nbsp;   if (error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
     * &nbsp;&nbsp;   } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var updatedEntries = entries;
     * &nbsp;&nbsp;   }
	 * }
	 * </pre>
	 * @see Social.Common.Appdata.getEntries
	 * @example
	 * Appdata.updateEntries(
	 *              {   'favoriteMovie':'Pulp Fiction',    
	 *                  'petName':'Rover' }, 
	 *              callback );
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     * @see Social.US.AppData for additional Mobage persistence facilities.
     * @see Storage.KeyValue for additional ngCore persistence facilities.
     * @see Storage.FileSystem for additional ngCore persistence facilities.
	 */		
	updateEntries: function(entries, callback) {
		if(entries) {
			var cmd = {apiURL:"Common.Appdata.updateEntries", entries:entries, callbackFunc:callback};
			GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
		} else {
			if(typeof callback === 'function') {
				callback({ 
						errorCode: 400,
						description: "Entries to update are a required parameter"
					}, null);
			}
		}
	},
	
	
	/**
	 * Deletes one or more key/value pairs.
	 *
	 * @name Social.Common.Appdata.deleteEntries
	 * @function
	 * @public
	 * 
	 * @param {Array} keys Takes an array of key names. For example, <code>['petName']</code>. 
     * If <code>null</code>, the return object in the callback is not defined.
	 * @param {Function} callback  Retrieves a hash of the deleted entries. If an error occurs, returns an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var keys = {"petName"};
     * ...
     * function(error, keys){
     * &nbsp;&nbsp;   if (error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
     * &nbsp;&nbsp;   } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var deletedKeys = keys;
     * &nbsp;&nbsp;   }
	 * }
	 * </pre>
	 * @example
	 * Appdata.deleteEntries(['petName'], callback );
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	deleteEntries: function(keys, callback) {
		if(keys && keys.length > 0) {
			var cmd = {apiURL:"Common.Appdata.deleteEntries", keys:keys, callbackFunc:callback};
			GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
		} else {
			if(typeof callback === 'function') {
				callback({ 
						errorCode: 400,
						description: "Keys to delete are a required parameter"
					}, null);
			}
		}
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Auth'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Auth'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Auth'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class
 * @name Social.Common.Auth
 * @description
 * Retrieves a verification code.
 * Games call <code>Auth.authorizeToken()</code> if the game server is using the Mobage REST API.
 * For more information, refer to the Mobage RESTful API Conventions section of the developer's guide.
 */
exports.Auth = {
		
		
	/**
	 * Authorizes a temporary credential and returns a verification code.
	 *
	 * 
	 * @name Social.Common.Auth.authorizeToken
	 * @function
	 * @public
	 *
	 * @param {String} token The temporary credential identifier. 
	 * @param {Function} callback The callback function that handles the verification code and errors.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 *  <pre class="code">
     *  var verifier = "jklmnop";
	 *  function(error, verifier){
     *  &nbsp;&nbsp; if (error){
	 *  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 *  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 *  &nbsp;&nbsp; } else {
     *  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var verificationCode = verifier;    
     *  &nbsp;&nbsp; }
     *  }
	 * </pre>
	 * @example
	 * var token = "abcdefghi";
     * ...
	 * Social.Common.Auth.authorizeToken (token, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	authorizeToken: function(token, callback) {
		var cmd = {apiURL:"Common.Auth.authorizeToken", token:token, callbackFunc: callback };
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
		//callback(error, verifier)
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Blacklist'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Blacklist'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Blacklist'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class 
 * @name Social.Common.Blacklist
 * @description
 * Provides an interface for checking the user's blacklist.
 */
exports.Blacklist = {

	/**
	 * Retrieves the target user ID from the specified user's blacklist.
	 * This call passes a user ID and a target user ID to determine if the specified target user is blacklisted. 
	 * If the target user ID parameter is <code>null</code>, this call retrieves the entire blacklist. The callback function also receives the total number of 
	 * target user IDs, the starting index, and the number of target IDs returned for paging the results.
	 *
	 * @name Social.Common.Blacklist.checkBlacklist
	 * @function
	 * @public
	 *
	 * @param {String} userId The user ID for the user who owns the blacklist. 
	 * @param {String} targetUserId The target user ID to check in the blacklist. <br/>If <code>null</code>, it checks the entire blacklist.
	 * @param {Hash} opt Takes a hash containing the start index and count for pagination. <br/>E.g., <code>{'start': 1, 'count': 100}</code> 
     * Requires start index and count. The minimum start index is 1. 
     * If <code>null</code>, undefined or an empty array, the start index is 1 and the count is 50.
	 * @param {Function} callback Retrieves an array of user IDs found in the blacklist. Otherwise, it retrieves an empty array.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var listedUsers = ['user1', 'user2'];
     * ...
     * function(error, listedUsers, result)
	 * &nbsp;&nbsp;		{
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var blackListedUsers = listedUsers;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var total = result.total;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var start = result.start;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var count = result.count;
  	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var errorCode = error.errorCode;
  	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var errorDesc = error.description;
  	 * &nbsp;&nbsp;	}
  	 * </pre>
  	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */			
	checkBlacklist: function(userId, targetUserId, opt, callback) {
		var cmd = {apiURL:"Common.Blacklist.checkBlacklist", userId:userId, targetUserId:targetUserId, opt:opt, callbackFunc: function(error, args) {
			callback(error, args.users, args.result);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Config'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Config'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Config'] = exports; var Session = require('NGCore/Client/Social/US/Data/Session').Session;

/**
 * @class 
 * @name Social.Common.Config
 * @description
 * Mobage provides a common API to determine if the server is a sandbox server or a production server. 
 */
exports.Config = {

    /**
    * Returns whether the server is a sandbox server or a production server. 
    * Returns "unknown" if it cannot retrieve the current session
    * or if the server mode is not "sandbox" or "production."
    * 
    * @name Social.Common.Config.getServerEnvironment
    * @public
    * @function
    * @returns {String} "sandbox," "production" or "unknown."
    * @see Social.US.Session.serverModes
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */
	getServerEnvironment: function(){
		var session = Session.getCurrentSession();
		if(!session){
			return "unknown";
		}
		
		var serverMode = Session.getCurrentSession().serverMode();
		if(serverMode == Session.serverModes.production){
			return "production";
		}else if(serverMode == Session.serverModes.sandbox){
			return "sandbox";
		}else{
			return "unknown";
		}
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/People'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/People'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/People'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class 
 * @name Social.Common.People
 * @description
 * The social API for returning user objects with their social graphs. The user object
 * retrieved varies from platform to platform. US platform required fields are <code>id</code>, <code>displayName</code>, <code>hasApp</code> 
 * and <code>thumbnailUrl</code> of the <code>Person</code> data type.
 */
exports.People = {
	
	/**
	 * Retrieves fields for the specified user from the <code>Person</code> data type. The specified user corresponds to the user ID parameter.
	 * Below are the fields returned by this call:
	 * <ul>
	 * <li><code>id</code></li>
	 * <li><code>displayName</code></li>
	 * <li><code>hasApp</code></li>
	 * <li><code>thumbnailUrl</code></li>
	 * </ul>
	 * Use the <code>fields</code> parameter to retrieve non-required fields of the <code>Person</code> data type.
	 *
	 * @name Social.Common.People.getUser
	 * @function 
	 * @public 
	 *
	 * @param {String} userId The user ID of the user to retrieve.
	 * @param {Array} fields An array of non-required fields of the <code>Person</code> data type to include in the response to the callback. 
     * <br/>For example, <code>['nickname','aboutMe']</code>. If <code>null</code>, <code>undefined</code> or an empty array, this call only retrieves the required fields.
	 * @param {Function} callback Retrieves the user specified by the <code>userId</code> parameter. If an error occurs, returns an error code and error description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, user){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var retrievedUser = user;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getCurrentUser
	 * @example
	 * var recordID = 2;
	 *
	 * Social.Common.People.getUser(recordID, 
	 *                              ['id','nickname','aboutMe'], 
	 *                              callback
	 *		});
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */						
	getUser: function(userId, fields, callback) {
		var cmd = {apiURL:"Common.People.getUser", userId:userId, fields:fields, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Retrieves an array of users.
	 * Takes one or more user IDs and retrieves an array of users with the callback. 
	 * Retrieves up to 100 users, with no guarantee of retrieving the user array 
	 * in the order specified.
	 * Retrieves the <code>id</code>, <code>displayName</code>, <code>hasApp</code> 
	 * and <code>thumbnailUrl</code> fields of the <code>Person</code> data type for each user.
	 * To retrieve non-required fields of the <code>Person</code> data type, specify the non-required fields 
	 * desired in the <code>fields</code> parameter.
	 *	 
	 * @name Social.Common.People.getUsers
	 * @function 
	 * @public
	 * 
	 * @param {Array} userIds An array of user IDs of the users to retrieve. Minimum array size is 1, and maximum is 100.
	 * @param {Array} fields An array of non-required fields of the <code>Person</code> data type to include in the callback. <br/>For example, <code>['nickname','aboutMe']</code>.
     * <br/>If <code>null</code>, <code>undefined</code> or an empty array, it retrieves only the required fields.
	 * @param {Function} callback Retrieves an array of users specified by the <code>userIds</code> parameter and/or an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, users){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var retrievedUsers = users;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getUser
	 * @example
	 * People.getUsers([1,2,3],null, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */				
	getUsers: function(userIds, fields, callback) {
		var cmd = {apiURL:"Common.People.getUsers", userIds:userIds, fields:fields, callbackFunc:function(errors, args) {
			callback(errors, args.users, args.results);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	
	/**
	 * Retrieves fields for the current user from the <code>Person</code> data type. Below are the fields returned by this call:
	 * <ul>
	 * <li><code>id</code></code>
	 * <li><code>displayName</code></li>
	 * <li><code>hasApp</code></li>
	 * <li><code>thumbnailUrl</code></li>
	 * </ul>
	 *
	 * @name Social.Common.People.getCurrentUser
	 * @function
	 * @public
	 *
	 * @param {Array} fields An array of non-required fields of the <code>Person</code> data type to include in the callback. <br/>For example, <code>['nickname','aboutMe']</code>.
     * <br/>If <code>null</code>, <code>undefined</code> or an empty array, this call only retrieves the required fields.
	 * @param {Function} callback Retrieves the current user. If an error occurs, returns an error code and error description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, user){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var currentUser = user;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getUser
	 * @example
	 * People.getCurrentUser(null, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */				
	getCurrentUser: function(fields, callback) {
		var cmd = {apiURL:"Common.People.getCurrentUser", fields:fields, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	
	/**
	 * Retrieves fields for friends of a specified user. Below are the fields returned by this call:
	 * <ul>
	 * <li><code>id</code></li>
	 * <li><code>displayName</code></li>
	 * <li><code>hasApp</code></li> 
	 * <li><code>thumbnailUrl</code></li>
	 * </ul>
	 *
	 * @name Social.Common.People.getFriends
	 * @function
	 * @public
	 * 
	 * @param {String} userId The user ID of the user whose friends are retrieved by the callback function. 
	 * @param {Array} [fields] An array of non-required fields of the <code>Person</code> data type to include in the response to the callback. 
     * <br/>For example, <code>['nickname','aboutMe']</code>.
     * <br/> If <code>null</code>, <code>undefined</code> or an empty array, this call only retrieves the required fields.
	 * @param {Hash} [opt] A hash containing the start index and count for pagination. <br/>For example, <code>{'start': 1, 'count': 100}</code> 
	 * @param {Function} callback Retrieves the friends of the given user. If an error occurs, returns an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, friends){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var retrievedFriends = friends;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getFriendsWithGame
	 * @example
	 * People.getFriends(4, null, {'start': 2}, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */					
	getFriends: function(userId, fields, opt, callback) {
		var cmd = {apiURL:"Common.People.getFriends", userId:userId, fields:fields, opt:opt, callbackFunc: function(errors, args) {
			callback(errors, args.users, args.results);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	
	/**
	 * Retrieves a list of the user's friends playing the current game.
	 *
	 * @name Social.Common.People.getFriendsWithGame
	 * @function
	 * @public
	 *
	 * @param {String} userId The user ID of the person whose friends play the current game.
	 * @param {Array} fields An array of non-required fields of the <code>Person</code> data type to include in the response to the callback. 
     * <br/>For example, <code>['nickname','aboutMe']</code>.
     * <br/> If <code>null</code>, <code>undefined</code> or an empty array, this call retrieves only the required fields.
	 * @param {Hash} opt A hash containing the start index and count for pagination. <br/>For example, <code>{'start': 1, 'count': 100}</code> 
	 * @param {Function} callback Retrieves the friends of the specified user. If an error occurs, returns an error code and error description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, friends){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var retrievedFriends = friends;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getFriends
	 * @example 
	 * People.getFriendsWithGame(4, null, null, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */						
	getFriendsWithGame: function(userId, fields, opt, callback) {
		var cmd = {apiURL:"Common.People.getFriendsWithGame", userId:userId, fields:fields, opt:opt, callbackFunc: function(errors, args) {
			callback(errors, args.users, args.results);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	}
	
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Profanity'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Profanity'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Profanity'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');	

/**
 * @class 
 * @name Social.Common.Profanity
 * @description
 * Provides an interface to check games for profanity.
 */
exports.Profanity = {
	
	/**
	 * Checks a text string to determine if it contains profanity.
	 * This call only conducts a check and does not attempt to cleanup the string.<br><br>
	 * <b>Note:</b> The server handles locale and language automatically.
	 *
	 * @name Social.Common.Profanity.checkProfanity
	 * @function
	 * @public
	 * 
	 * @param {String} text The string to check for profanity.
	 * @param {Function} callback Retrieves any profane words or phrases in the text parameter. 
     * The result of checking is either <code>true</code> or <code>false</code>. If the result is <code>false</code>, the text string contains profanity. 
     	 * If an error occurs, returns an error code and error description to the callback.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class='code'>function(error, args){
     * &nbsp;&nbsp; if(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
     * &nbsp;&nbsp;} else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var profanity = args.profanity;
     * &nbsp;&nbsp;}
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	checkProfanity: function(text, callback) {
		var cmd = {apiURL:"Common.Profanity.checkProfanity", text:text, callbackFunc:function(error, args) {
			callback(error, args.profanity);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
	}	
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Request'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Request'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Request'] = exports; var Class = require('NGCore/Client/Core/Class').Class;


//Don't need to document
exports.Request = Class.subclass({
	execute: function(callback) {
		// [call US function here]	
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Service'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Service'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Service'] = exports; var UI = require('NGCore/Client/UI').UI;

var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;

var ButtonOverlays = require('NGCore/Client/Social/US/Service/ButtonOverlays').ButtonOverlays;
var Friends = require('NGCore/Client/Social/US/Service/Friends').Friends;
var Profile = require('NGCore/Client/Social/US/Service/Profile').Profile;
var User    = require('NGCore/Client/Social/US/Models/User').User;

/**
 * @class 
 * @name Social.Common.Service
 * @description
 * This interface provides the following social game services: <br/>
 * <div class="ul">
 * <li>Balance Button</li>
 * <li>Community Button</li>
 * <li>Friend Picker</li>
 * <li>User Finder</li>
 * <li>User Profile</li>
 * </div>
 */
exports.Service = {

	
	/**
	* Opens the user finder screen.
	* The user finder provides a way for users to find other users using the following filters:
	* <ul>
	* <li>Suggested Friends</li>
	* <li>Contacts</li> 
	* <li>Requests</li>
	* <li>Search</li>
	* </ul>
	*
	* @name Social.Common.Service.openUserFinder 
	* @function
	* @public
	* @status iOS, Android, Test, iOSTested, AndroidTested
    */		
	openUserFinder: function() {
		Friends.showFindFriends(undefined);
	},

	
	/**
	* Opens the friend picker.
	*
	* @name Social.Common.Service.openFriendPicker 
	* @function
	* @public 
	* 
	* @param {Number} maxFriendsToSelect The maximum number of friends the user may select.
	* @param {Function} callback The callback function called after the view closes. Returns an array of friends.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, friendUserIds){
	* 	&nbsp;&nbsp;&nbsp;if (error){
	* 	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  		var errorCode = error.errorCode;
	*   &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  		var errorDesc = error.description;
	* 	&nbsp;&nbsp;&nbsp;} else {
	*   &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  		var pickedFriends = friendUserIds;
	*   &nbsp;&nbsp;&nbsp;  	}
	*   &nbsp;&nbsp;  }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	openFriendPicker: function(maxFriendsToSelect, callback) {
		Friends.showFriendPicker(maxFriendsToSelect, function(err, friends){
			var userIDs = [];
			friends = friends || [];
			for(var idx = 0; idx < friends.length; idx++){
				userIDs.push(friends[idx].recordID);
			}
			callback( userIDs );
		});
	},

	
	/**
	* Opens the specified profile page.
	*
	* @name Social.Common.Service.openUserProfile 
	* @function
	* @public 
	* 
	* @param {String} userId The user ID or gamer name of the profile page to open.
	* @param {Function} callback The callback function if there is an error with the user ID or gamer name.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	openUserProfile: function(userId, callback) {
		if(typeof userId == "string"){
			// if the userId string contains no non-numeral characters:
			//   parse it into a number
			// else null it out, because it's not a valid userId
			if(userId.match(/[^0-9]/) === null){
				userId = parseInt(userId, 10);
			}else{
				userId = null;
			}
		}
		
		if( !userId ){
			callback({errorCode: 400, description: "userid is invalid"});
		}
		else{
			User.getUserWithID(userId, function(err, user){
				if(err){
					if( err==="Sorry, we can't find anyone with that name." ){
						callback({errorCode: 404, description: err});
					} else {
						callback({errorCode: 500, description: err});
					}
				}else if(!user){
					callback({errorCode: 404, description: "User not found"});
				}else{
					Profile.showUserProfile(user, undefined);
				}
			});
	}
	},


	/**
	* Displays the <b>Mobage Community</b> button.
	*	
	* @name Social.Common.Service.showCommunityButton
	* @function
	* @public 
	* 
	* @param {exports.Gravity} gravity Displays the button in the specified corner. 
    * <b>Note:</b> Only supported for the US. Japan uses the top-left corner only.
	* @param {String} theme Displays the theme for the button (for example, "default", "dark", "light"). 
    * <b>Note:</b> Only supported for Japan. You can specify <code>null</code> for the US region.
	* @param {Function} callback The callback function if there is an error related
    * to <code>gravity</code> or <code>theme</code> usage.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @see exports.Gravity
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/           
	showCommunityButton: function(gravity, theme, callback) {
		ButtonOverlays.showCommunityButton(gravity, callback);
	},

	/**
	* Hides the <b>Mobage Community</b> button.
	*
	* @name Social.Common.Service.hideCommunityButton
	* @function
	* @public 
	*	
	* @param {Function} callback The callback function if there is an error hiding the button.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/		
	hideCommunityButton: function(callback) {
		ButtonOverlays.hideCommunityButton(callback);
	},

	
	/**
	* A message emitter object for adding a message emitter when inviting a user.
	*
	* @name Social.Common.Service.invitedUserEmitter
	* @field
	* @public
	* @example 
	* Social.Common.Service. ...
	* ... invitedUserEmitter.addListener(
	*			new Core.MessageListener(), 
	*			function(userId){
	*				NgLogD("New Emitter! " + userId);
	*			}
	*		);
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	invitedUserEmitter : new MessageEmitter(),

	
	/**
	 * Shows the balance button where the <code>rect</code> parameter 
	 * determines the size and position of the button.
     * The minimum size of the button is:<br/>
     * <ul>
     * <li>10% of height in Landscape, and the absolute minimum size is 150 x 50.</li>
     * <li>6% of height in Portrait, and the absolute minimum size is 150 x 50.</li>
     	 * </ul>
	 *
	 * @name Social.Common.Service.showBalanceButton
	 * @function
	 * @public
	 *	 
	 * @param {UI.ViewGeometry.Rect} rect Determines the size and position of the balance button.
	 * @param {Function} callback The callback function if there is an error with the <code>rect</code> parameter.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 * &nbsp;&nbsp;   }
	 * </pre>
	 * @see UI.ViewGeometry.Rect
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	showBalanceButton: function(rect, callback) {		
		ButtonOverlays.showBalanceButton(rect, callback);
	},
	
	/**
	 * Hides the balance button.	
	 * @name Social.Common.Service.hideBalanceButton
	 * @function
	 * @public 
	 * 
	 * @param {Function} callback The callback function called after the view closes.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 * &nbsp;&nbsp;   }
     * </pre>
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	hideBalanceButton: function(callback) {
		ButtonOverlays.hideBalanceButton(callback);
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Analytics'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Analytics'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Analytics'] = exports; var SessionReq = require('NGCore/Client/Social/US/Data/Session');

/**
 * @private
 * @name Social.Common.Analytics
 * @description Private interface for analytics data
 *
 * TODO: These should be going into the priv interpreter. But need to check with Japan.
 */
exports.Analytics = {
  getUserId: function() {
	var cur_sess =	this._getSession(), cur_u = null;
	if (cur_sess) {
	  cur_u = (cur_sess.user() || {}).recordID;
	}
	return cur_u;
  },
  getUsername: function() {
	var cur_sess =	this._getSession(), cur_u = null;
	if (cur_sess) {
	  cur_u = (cur_sess.user() || {}).gamertag;
	}
	return cur_u;
  },
  getPlatformVersion: function() {
	var cur_sess =	this._getSession(), cur_pver = null;
	if (cur_sess) {
	  cur_pver = cur_sess.platformVersion();
	}
	return cur_pver;
  },
  getServiceId: function() { 
	return "US"; 
  },
  _getSession: function() {
	return SessionReq.Session.getCurrentSession();
  }
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/DataModel'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/DataModel'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/DataModel'] = exports; var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var SocialR = require('NGCore/Client/Social');
var SessionR        = require('NGCore/Client/Social/US/Data/Session');
var DispatcherR     = require('NGCore/Client/Social/US/Data/Dispatcher');

/**
 * <code>DataModel</code> constructs objects that emit messages when properties of an object change, and provides automatic caching,
 * serialization and deserialization between interpreters. 
 * <br/><br/>
 * <b>Note:</b> Do not instantiate this class directly. Use classes derived from <code>DataModel</code> for instantiation. These include:
 * <div class="ul">
 * <li>{@link Social.US.User}</li>
 * <li>{@link Social.US.AppData}</li>
 * <li>{@link Social.US.Game}</li>
 * <li>{@link Social.US.Score}</li>
 * <li>{@link Social.US.Leaderboard}</li>
 * </div>
 * @class 
 * @name Social.US.DataModel
 */
var DataModel = exports.DataModel = MessageEmitter.subclass({
		
	/**
	 * The default constructor.
	 * @constructs
	 * @private
	 */		
	initialize: function(recordID){
		this.recordID = recordID;

		this._cache();
	},
	beginChanges: function(){
		DispatcherR.Dispatcher.beginBatching();
	},
	endChanges: function(){
		DispatcherR.Dispatcher.endBatching();
	},
	_classname: function(){
		var classname = this.classname;
		return classname;
	},
	_cache: function(){
		if(!this._dataCache){
			var session = SessionR.Session.getCurrentSession();
			if(session){
				var cache = session.dataCache();
				if(cache){
					cache.addObject(this);
					this._dataCache = cache;
				}
			}
		}
		return this._dataCache;
	},
	$_serializedDataModel: function(obj){
		if(obj instanceof(DataModel)){
			obj = {
				classname: obj.classname,
				recordID:  obj.recordID
			};
		}
		return obj;
	},
	$_deserializedDataModel: function(value, cache){
		if(value && value.hasOwnProperty && value.hasOwnProperty("classname") && value.hasOwnProperty("recordID")){
			var theClassname = value.classname;
			var theClass = SocialR.Social.US[theClassname];
			var theRecordID = value.recordID;
			if(theClass && theRecordID){
				var theInstance = cache.getObjectWithRecordID(theClassname, theRecordID);
				if(!theInstance){
					theInstance = new theClass(theRecordID);
				}
				
				theInstance._deserializeFromHash(value.data);
				cache.addObject(theInstance);
    
				value = theInstance;
			}
		}
		return value;
	},
	_serializedHash: function(full){
		var theClass = this.constructor;
		var hash = {classname: theClass.classname, recordID: this.recordID};
		if(full === false){
			return hash; // if it's undefined, assume we want all the data
		}
		
		hash.data = {};
		
		var properties = this.constructor.properties || [];
		for(var idx = 0; idx < properties.length; idx++){
			var propertyName = properties[idx];
			var propertyValue = this[propertyName];

			if(propertyValue instanceof(Array)){
				for(var propertyIndex = 0; propertyIndex < propertyValue.length; propertyIndex++){
					propertyValue[propertyIndex] = DataModel._serializedDataModel(propertyValue[propertyIndex]);
				}
			}else{
				propertyValue = DataModel._serializedDataModel(propertyValue);
			}
			
			hash.data[propertyName] = propertyValue;
		}
		
		return hash;
	},
	_deserializeFromHash: function(data){
		if(!data){
			NgLogD("No public hash data for " + this.classname + " " + this.recordID);
			return;
		}
		
		var cache = this._cache();
		for(var key in data){
			var value = data[key];
			if(value instanceof(Array)){
				for(var propertyIndex = 0; propertyIndex < value.length; propertyIndex++){
					value[propertyIndex] = DataModel._deserializedDataModel(value[propertyIndex], cache);
				}
			}else{
				value = DataModel._deserializedDataModel(value, cache);
			}
			this[key] = value;
		}
	}
});

DataModel._oldSubclass = DataModel.subclass;
DataModel.subclass = function(contents){
	var theClass = DataModel._oldSubclass(contents);
	var properties = contents.properties || [];
	for(var idx = 0; idx < properties.length; idx++){
		var propertyName = properties[idx];
		
		(function(name){
			theClass.prototype.__defineSetter__(name, function(value){
				this["___" + name] = value;
				
				var msg = {};
				msg[""+name] = value;
				
				this.emit(msg);
			});
			theClass.prototype.__defineGetter__(name, function(value){
				return this["___" + name];
			});
		})(propertyName);
	}
	return theClass;
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/User'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/User'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/User'] = exports; var DataModelR  = require('NGCore/Client/Social/US/Models/DataModel');
var Dispatcher  = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;
var OrderedList = require('NGCore/Client/Social/US/Models/OrderedList').OrderedList;
var Social      = require('NGCore/Client/Social').Social;

/**
* <code>User</code> constructs objects that provide a service interface for the current user. 
* <code>User</code> objects enable the current user to retrieve:
* <div class="ul">
* <li>user details</li>
* <li>a list of friends</li>
* <li>games</li>
* </div>
* @class
* @name Social.US.User
* @augments Social.US.DataModel
*/
var User = exports.User = DataModelR.DataModel.subclass({
		
    /**
    * @constructs
    * @ignore
    */
	classname: "User",

	 /**
	 * The user's gamer tag. Read-only.
	 * @name Social.US.User.gamertag
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * The user's avatar ID. Read-only.
	 * @name Social.US.User.avatarId
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's motto. Read-only.
	 * @name Social.US.User.motto
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The relation to this user. Read-only.
	 * @name Social.US.User.relation
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Sparse limits attributes in search results. Read-only.
	 * @name Social.US.User.sparse
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The user's photo ID. Read-only.
	 * @name Social.US.User.photoId
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's email address. Read-only.
	 * @name Social.US.User.emailAddress
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A hash of the user's email address. Read-only.
	 * @name Social.US.User.emailHash
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The user's phone number. Read-only.
	 * @name Social.US.User.phoneNumber
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */


	 /**
	 * The user's password. Read-only.
	 * @name Social.US.User.password
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The user's first name. Read-only.
	 * @name Social.US.User.firstName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */


	 /**
	 * The user's last name. Read-only.
	 * @name Social.US.User.lastName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * Whether to hide the user's full name. Read-only.
	 * @name Social.US.User.hideFullName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * Whether the user is age restricted. Read-only.
	 * @name Social.US.User.ageRestricted
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Whether the relationship to the user is new. Read-only.
	 * @name Social.US.User.isNewRelationship
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Whether the user is a mutual friend. Read-only.
	 * @name Social.US.User.isMutualFriend
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Whether the user shows his/her presence. Read-only.
	 * @name Social.US.User.showsPresence
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * Whether the user only shows friend notifications. Read-only.
	 * @name Social.US.User.setOnlyShowFriendNotifications
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	 

	 /**
	 * The user's capabilities. Read-only.
	 * @name Social.US.User.capabilities
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's gamer score. Read-only.
	 * @name Social.US.User.gamerscore
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	 

	 /**
	 * The user's gamer level. Read-only.
	 * @name Social.US.User.gamerLevel
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	 

	 /**
	 * The user's gamer level name. Read-only.
	 * @name Social.US.User.gamerLevelName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The gamer level score. Read-only.
	 * @name Social.US.User.gamerLevelScore
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The gamer score for the next level. Read-only.
	 * @name Social.US.User.gamerNextLevelScore
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's games. Read-only.
	 * @name Social.US.User.games
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	properties: [
		// public
		"gamertag",
		"avatarId",
		"motto",
		"relation",
		"sparse",
		"photoId",
		"emailHash",
		"ageRestricted",
		"isMutualFriend",
		
		// private
		"phoneNumber",
		"password",
		"firstName",
		"lastName",
		"hideFullName",
		"emailAddress",
		"isNewRelationship",
		"showsPresence",
		"onlyShowFriendNotifications",
		"capabilities",
		"gamerscore",
		"gamerLevel",
		"gamerLevelName",
		"gamerLevelScore",
		"gamerNextLevelScore",
		"games"
	],
	
	/**
	 * @constructs The default constructor constructs <code>User</code> objects.
	 * @name Social.US.User.initialize 
	 * @private
	 */
	initialize: function($super, recordID){
		$super(recordID);
		NgLogD("User Public! " + recordID + " " + this.recordID);
	},
	
	
	/**
	* Adds a user to the buddies list and ensures the added user is not on the blocked users list.
	* @name Social.US.User.addBuddy
	* @function
	* @private
	*
	* @param {Social.US.User} buddy The user to add to the buddies list. If not a user, the callback error is "No user."
	* @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, data){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var buddyData = data;
    * &nbsp;&nbsp;  }
	* }
	* </pre>	
	*/	
	addBuddy: function(buddy, cb){
		Dispatcher.callMethodOnRemoteObject(this, "addBuddy", [buddy, cb]);
	},
	
	
	/**
	* Removes a user from the buddies list.
	* @name Social.US.User.removeBuddy
	* @function
	* @private
	*
	* @param {User} buddy The user to remove from the buddies list. If not a user, the callback error is "No user."
	* @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b>
	* <pre class="code">function(error, data){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var buddyData = data;
    * &nbsp;&nbsp;  }
	* }
	* </pre>
	*/		
	removeBuddy: function(buddy, cb){
		Dispatcher.callMethodOnRemoteObject(this, "deleteBuddy", [buddy, cb]);
	},
	
	
	/**
	* Retrieves a user object with all of the this user's details.
	*
	* @name Social.US.User.getUserDetails
	* @function
	* @public
	* 
	* @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, user){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var userWithDetails = user;
    * &nbsp;&nbsp;  }
	* }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/			
	getUserDetails: function(cb){
		Dispatcher.callMethodOnRemoteObject(this, "getUserDetails", [cb]);		
	},
	
	/**
	* Retrieves an ordered list of the user's friend requests on Mobage.
	* @name Social.US.User.getMobageFriendRequestLists
	* @function
	* @public
	*
	* @return {Social.US.OrderedList} A list of the user's friend requests.
    * @example
    * var myMobageFriendRequests = userA.getMobageFriendRequestsList();
    * @see Social.US.OrderedList for more information on iterating over the Mobage Friend Requests list.
	*/			
	getMobageFriendRequestsList: function(){
		return OrderedList.getObjectPublicInterface(this, "getInvitesList", "_followersListInterface");
	},
	
	/**
	* Returns the user's friends list on Mobage.
	* @name Social.US.User.getMobageFriendsList
	* @function
	* @public	
	*
	* @return {Social.US.OrderedList} The user's friend list on Mobage.
    * @example
    * var myMobageFriendsList = userA.getMobageFriendsList();
    * @see Social.US.OrderedList for more information on iterating over the Mobage friends list.
    * @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	getMobageFriendsList: function(){
		return OrderedList.getObjectPublicInterface(this, "getFriendsList", "_friendsListInterface");
	},
	
	/**
	* Returns the user's blocked user list.
	* @name Social.US.User.getMobageBlockedUserList
	* @function
	* @public	
	*
	* @return {Social.US.OrderedList} The user's blocked user list on Mobage.
	* @see Social.US.OrderedList
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	getMobageBlockedUserList: function(){
		return OrderedList.getObjectPublicInterface(this, "getBlockedUserList", "_enemyListInterface");
	},
	
	/**
	* Returns the user's games list.
	* @name Social.US.User.getOwnedGamesList
	* @function
	* @public	
	*
	* @return {Social.US.OrderedList} The user's Mobage game list.
    * @example
    * var myGamesList = userA.getOwnedGamesList();
    * @see Social.US.OrderedList for more information on iterating over the games list.
    * @status iOS, Android, Test, iOSTested, AndroidTested
	*/			
	getOwnedGamesList: function(){
		return OrderedList.getObjectPublicInterface(this, "getOwnedGamesList", "_ownedGamesListInterface");
	},
	
	/**
	* Returns the list of "featured" users.
	* @name Social.US.User.getFeaturedUsersList
	* @function
	* @public	
	*
	* @return {Social.US.OrderedList} The list of "featured" users.
    * @example
    * var mobageFeaturedUsers = userA.getFeaturedUsersList();
    * @see Social.US.OrderedList for more information on iterating over the Mobage Featured Users list.
    * @status iOS, Android, Test, iOSTested, AndroidTested
	*/	
	getFeaturedUsersList: function(){
		return OrderedList.getObjectPublicInterface(this, "getFeaturedUsersList", "_featuredUsersListInterface");
	},

	/**
	* Invites the user to the current game.
	* @name Social.US.User.inviteToCurrentGame
	* @public
	* @function
	* 
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	inviteToCurrentGame: function(cb){
		var user = this;
		Dispatcher.callMethodOnRemoteObject(this, "inviteToCurrentGame", [function(err){
			if(!err){
				Social.Common.Service.invitedUserEmitter.emit({userId: user.recordID});
				Social.US.Service.Friends.invitedUserEmitter.emit({user: user});
			}
			cb.apply(this, Array.apply(null, arguments));
		}]);		
	},
	
	/**
	 * Send a Push notification to this user through the GameService back end.
	 * @name Social.US.User.sendNotificationToUser
	 * @public
	 * @function
	 *
	 * @param {Alert Text} alertText The displayed message when the push is received.
	 * @param {Badge ID} badgeId Badge displayed on the push.
	 * @param {Sound} sound Sound played when push is received.
	 * @param {Extra Data} extraData Additional payload.
	 *
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	sendNotificationToUser: function(alertText, badgeId, sound, extraData) {
		Dispatcher.callMethodOnRemoteObject(this, "sendNotificationToUser", [alertText, badgeId, sound, extraData]);
	},

    /**
    * Adds a user to the current user's friend list for the current game. Implies a one-directional relationship or "follower" model.
    * Takes an optional group parameter to add the user to a particular group. Current user can only 
    * add the user to one group. If the current user adds the user to a second group in the friend list, 
    * the user is moved from the first group.
    *
    * A group is an arbitrary classification of friends. The <code>group</code> parameter is a string, which 
    * takes the name of the group. You may allow users to manage their own groups, create game-level groups, 
    * or omit groups altogether. A user may only reside in one group of another user's friend list.<br><br>
    * <b>Note:</b> This is part of the Game Graph API. 
    *
    * @example
    * //Retrieve a user and set up a follower relationship.
    * var userA = Social.US.User; 
    * Social.US.User.getUserWithGamertag("chuck", function(error, user){
    *   if(!user) {
    *       var errorCode = error.errorCode;
    *       var errorDesc = error.description;
    *   } else {
    *        userA = user;
    *   }
    * });
    * var userB = Social.US.Session.getCurrentSession().user();
    * userB.addFriend(userA, callback);
    * //...
    * @example
    * //To make the relationship bi-directional, 
    * //you must make the same call for the other user.
    * userA.addFriend(userB, callback);
    *
    * @name Social.US.User.addFriend
    * @public
    * @function
    *
    * @param user The user to add to the current user's friend list. If <code>null</code>, <code>undefined</code> or not a 
    * <code>Social.US.User</code> object, the callback error is "No user."
    * @param {String} [group] An optional parameter for adding the friend into a group within the friend list.
    * @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, data){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var appData = data;
    * &nbsp;&nbsp;  }
	* } </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
    */	
	addFriend: function(user, group, cb){
		if(typeof arguments[1] == "function" && !arguments[2]){
			cb = arguments[1];
			group = undefined;
		}
		Dispatcher.callMethodOnRemoteObject(this, "addGameFriend", [user, group, cb]);
	},

    /**
    * Removes a user from the current user's friend list for the current game.<br><br>
    * Does not require a group parameter, friends are only associated to one group in a friend list.
    * @name Social.US.User.removeFriend
    * @public
    * @function
    *
    * @param {Social.US.User} user The user to remove from the current user's friend list. If <code>null</code>, <code>undefined</code> or not a 
    * <code>Social.US.User</code> object, the callback error is "No user."
    * @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, data){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var appData = data;
    * &nbsp;&nbsp;  }
	* } </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
    */		
	removeFriend: function(user, cb){
		Dispatcher.callMethodOnRemoteObject(this, "removeGameFriend", [user, cb]);
	},
	
	report: function(reason, cb){
		Dispatcher.callMethodOnRemoteObject(this, "report", [reason, cb]);
	},

    /**
    * Returns the user's friend list for the current game. If you specify the <code>group</code>
    * parameter, this call only returns friends within the group.<br><br>
    * <b>Note:</b> This is part of the Game Graph API.
    * @name Social.US.User.getFriendsList
    * @public
    * @function
    *
    * @param {String} group If specified, returns only friends in the group.
    * @return {Social.US.OrderedList} The user's friend list for the current game.
    * @example
    * var myFriendsList = userA.getFriendsList ("Best Buddies");
    * @see Social.US.OrderedList for more information on iterating over the friends list.
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */	
	getFriendsList: function(group){
		return OrderedList.getObjectPublicInterface(this, "getGameFriendsList", (group ? ("_gameFriendsList-friends-" + group ) : "_gameFriendsList-friends"), "friends", group);
	},


    /**
    * Returns the user's mutual friends.
    * Mutual friends result when two users add each other to their respective friend list.<br><br>
    * <b>Note:</b> This is part of the game graph API.
    * @name Social.US.User.getMutualFriendsList
    * @public
    * @function
    *
    * @param {String} group The group within the friend list. If specified, returns only mutual friends within the group.
    * @return {Social.US.OrderedList} The user's mutual friend list.
    * @example
    * userA.addFriend(userB);
    * userB.addFriend(userA);
    * var myMutualFriends = userA.getMutualFriendsList();
    * //userA appears in userB's mutual friends list, 
    * //because they are in each other's friend lists.
    * @see Social.US.OrderedList for more information on iterating over the mutual friends list.
    * @status iOS, Android, Test, iOSTested, AndroidTested    
    */	
	getMutualFriendsList: function(group){
		return OrderedList.getObjectPublicInterface(this, "getGameFriendsList", (group ? ("_gameFriendsList-mutual-" + group) : "_gameFriendsList-mutual"), "mutual", group);
	},


    /**
    * Returns the user's friend requests list. If the <code>group</code> parameter is specified, returns
    * only friends within the group.
    * @name Social.US.User.getFriendRequestsList
    * @public
    * @function
    *
    * @param {String} group The group within the friend request list.
    * @return {Social.US.OrderedList} The user's friend requests list.
    * @example
    * var myFriendRequestsList = userA.getFriendRequestsList ();
    * @see Social.US.OrderedList for more information on iterating over the friend requests list. 
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */	
	getFriendRequestsList: function(group){
		return OrderedList.getObjectPublicInterface(this, "getGameFriendsList", (group ? ("_gameFriendsList-invitation-" + group) : "_gameFriendsList-invitation"), "invitation", group);
	},

	/**
	* Updates the email address for the current user.
	* @name Social.US.User.setEmailAddress
	* @function
	* @private
	*
	* @param {String} newAddress The email address for the current user.
	* @param {Function} cb The callback function if an error occurs (for example, invalid email address format).
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setEmailAddress:function(newAddress,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setEmailAddress", [newAddress, cb]);
	},
	
	/**
	* Sets whether the current user will receive notifications from other Mobage users or just from Mobage friends.
	* @name Social.US.User.setOnlyShowFriendNotifications
	* @function
	* @private
	*
	* @param {Boolean} isFriendsOnly Set to <code>true</code> if the current user will only receive notifications from Mobage users who are also Mobage friends. 
    * If set to <code>false</code>, the user receives notifications from all Mobage users. 
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setOnlyShowFriendNotifications:function(isFriendsOnly,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setOnlyShowFriendNotifications", [isFriendsOnly, cb]);
	},
	
	/**
	* Sets whether the current user will receive game news and updates from Mobage.
	* @name Social.US.User.setOptsIn
	* @function
	* @private
	*
	* @param {Boolean} optIn Set to <code>true</code> if the current user will receive news and updates from Mobage. 
    * If set to <code>false</code>, the user will not receive news or updates from Mobage. 
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	setOptsIn:function(optIn,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setOptsIn", [optIn, cb]);
	},

	/**
	* Sets a motto for the current user. In other words, the user's "about me" text string.
	* @name Social.US.User.setMotto
	* @function
	* @private
	*
	* @param {String} motto The motto for the current user.
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setMotto:function(motto,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setMotto", [motto, cb]);
	},
	
	/**
	* Updates the first name for the current user.
	* @name Social.US.User.setFirstName
	* @function
	* @private
	*
	* @param {String} firstName The first name for the current user.
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setFirstName:function(firstName,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setFirstName", [firstName, cb]);
	},
	
	/**
	* Updates the last name for the current user.
	* @name Social.US.User.setLastName
	* @function
	* @private
	*
	* @param {String} lastName The last name for the current user.
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	setLastName:function(lastName,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setLastName", [lastName, cb]);
	},
	

	/**
	* Sets a password for the current user.
	* @name Social.US.User.setPassword
	* @function
	* @private
	*
	* @param {String} password The password for the current user.
    * @param {String} confirmation The password confirmation for the current user.
	* @param {Function} cb The callback function if an error occurs. For example, password does not meet requirements; password and confirmation do not match, and so on.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	setPassword:function(password,confirmation, cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setPassword", [password, confirmation, cb]);
	},

	/**
	* Sets whether the target user is in the logged-in user's blocked user list.
	* @name Social.US.User.setBlocked
	* @function
	* @private
	*
	* @param {Social.US.User} user The user that is the subject of blocking or unblocking.
    * @param {Boolean} blocked Whether the current user blocks the specified user. If <code>true</code>, the specified user is blocked.
    	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setBlocked:function(blocked, cb){
		Dispatcher.callMethodOnRemoteObject(this, "setBlocked", [blocked, cb]);
	},
	
	/**
	 * Gets the origin of the user's registration.
	 * Mobage records the origin of a user's registration. The "origin" may be the name of an alliance partner.
	 * The origin is typically used as a means of tracking revenue sharing events, such as the promotional activity 
	 * of an alliance partner that attracts new users to Mobage and thereby entitles the alliance partner 
	 * to share in revenue generated by the application.  
	 *
	 * @name Social.US.User.getOriginOfRegistration
	 * @private
	 * @static
	 * @function
	 *
	 * @param {Function} cb The callback function returns the origin of registration, or an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, originOfRegistration){
	 *     if(!originOfRegistration) {
	 *          var errorCode = error.errorCode;
	 *          var errorDesc = error.description;
	 *     } else {
	 *          var origin = originOfRegistration;
	 *     }
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getOriginOfRegistration: function(cb) {
		Dispatcher.callMethodOnRemoteObject(this, "getOriginOfRegistration", [cb]);
	}
});

User.GamertagKey = "gamertag";
User.AvatarKey = "badge_id";
User.MottoKey = "motto";
User.RelationKey = "relation";
User.FirstNameKey = "first_name";
User.LastNameKey = "last_name";
User.BirthdateKey = "birth_date";
User.GenderKey = "gender";
User.PrivacyKey = "fullname_privacy";
User.PhotoKey = "photo_url";
User.EmailAddressKey = "email";
User.EmailHashKey = "email_hash";
User.PhoneNumberKey = "phone_number";
User.AgeRangeKey = "age_restricted";
User.SpamKey = "opt_in";

User.PasswordKey = "password";
User.PasswordConfirmKey = "password_confirmation";
User.GamesKey = "games";
User.CapabilitiesKey = "capabilities";
User.NewBuddyKey = "new_buddy";
User.IsMutualFriendKey = "mutual_friends";
User.HidePresenceKey = "hide_presence";
User.OnlyShowFriendNotificationsKey = "friend_only_notification";

User.GamerScoreKey = "gamerscore";
User.LevelNumberKey = "level_position";
User.LevelNameKey = "level_name";
User.CurrentLevelScoreKey = "level_points";
User.NextLevelScoreKey = "level_next_points";

// properties that are not returned in sparse search results
User.NonSparseKeys = [User.PhotoKey, User.EmailAddressKey,
User.EmailHashKey, User.PhoneNumberKey, User.PasswordKey,
User.FirstNameKey, User.LastNameKey, User.PrivacyKey,
User.NewBuddyKey, User.CapabilitiesKey, User.HidePresenceKey,
User.OnlyShowFriendNotificationsKey, User.GamerScoreKey,
User.LevelNumberKey, User.LevelNameKey, User.CurrentLevelScoreKey,
User.NextLevelScoreKey, User.GamesKey];


/**
* Retrieves the user corresponding to the <code>userID</code> parameter.
* @name Social.US.User.getUserWithID
* @public
* @static
* @function
* 
* @param {String} userID The ID for the user.
* @param {Function} cb The callback function if an error occurs.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">function(error, user){
* &nbsp;&nbsp;  if(!user) {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
* &nbsp;&nbsp;  } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var userWithID = user;
* &nbsp;&nbsp;  }
* }
* </pre>
* @status iOS, Android, Test, iOSTested, AndroidTested
*/	
User.getUserWithID = function(userID, cb){
	Dispatcher.callClassMethodOnRemoteObject(User, "getUserWithID", [userID, cb]);
};

/**
* Retrieves the user corresponding to the <code>gamertag</code> parameter.
* @name Social.US.User.getUserWithGamertag
* @public
* @static
* @function
* 
* @param {String} gamertag The user's gamertag.
* @param {Function} cb The callback function if an error occurs.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">function(error, user){
* &nbsp;&nbsp;  if(!user) {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
* &nbsp;&nbsp;  } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var userWithGamertag = user;
* &nbsp;&nbsp;  }
* }
* </pre>
* @status iOS, Android, Test, iOSTested, AndroidTested
*/	
User.getUserWithGamertag = function(gamertag, cb){
	Dispatcher.callClassMethodOnRemoteObject(User, "getUserWithGamertag", [gamertag, cb]);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Game'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Game'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Game'] = exports; var DataModelR = require('NGCore/Client/Social/US/Models/DataModel');
var OrderedList = require('NGCore/Client/Social/US/Models/OrderedList').OrderedList;
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * <code>Game</code> objects identify a game and its properties.
 * Game properties include: 
 * <div class="ul">
 * <li><code>name</code></li>
 * <li><code>publisher</code></li>
 * <li><code>category</code></li>
 * <li><code>featured</code></li>
 * <li><code>numberOfLeaderboards</code></li> 
 * <li><code>numberOfAchievements</code></li>
 * <li><code>masterProductID</code></li>
 * <li><code>iconURL</code></li>
 * <li><code>AppStoreURL</code></li>
 * <li><code>feedURL</code></li>
 * <li><code>catalogURL</code></li>
 * </div>
 * <code>Game</code> objects provide static functions to return all games in a catalog or games associated to a user profile.
 * 
 * @class 
 * @name Social.US.Game
 * @augments Social.US.DataModel
 */
var Game = exports.Game = DataModelR.DataModel.subclass({
	classname: "Game",
	
	
	 //Game is a subclass of data model, and the getter/setter methods are generated by defineSetterCallbacks. The following
	 //comments document the generated methods.
	 /**
	 * The game name. Read-only.
	 * @name Social.US.Game.name
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * The publisher name. Read-only.
	 * @name Social.US.Game.publisher
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The game category name. Read-only.
	 * @name Social.US.Game.category
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * Whether the game is featured. Read-only.
	 * @name Social.US.Game.featured
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The number of leaderboards for the game. Read-only.
	 * @name Social.US.Game.numberOfLeaderboards
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * The number of achievements. Read-only.
	 * @name Social.US.Game.numberOfAchievements
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The master product ID. Read-only.
	 * @name Social.US.Game.masterProductID
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A URL to the icon for a game. Read-only.
	 * @name Social.US.Game.iconURL
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A URL to the store or marketplace for a game. Read-only.
	 * @name Social.US.Game.appStoreURL
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A URL to the RSS feed for a game. Read-only.
	 * @name Social.US.Game.feedURL
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * Sets a catalog URL for the catalog of game items. Read-only.
	 * @name Social.US.Game.catalogURL
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	properties: [
		// public
		"name",
		"publisher",
		"category",
		"numberOfLeaderboards",
		"iconURL",
		
		// private
		"numberOfAchievements",
		"featured",
		"masterProductID",
		"appStoreURL",
		"feedURL",
		"catalogURL",
		"description",
		"phone_screenshot_urls",
		"ngcore_url"
	]
});

/**
 * Returns an ordered list interface to the Mobage game catalog.
 * 
 * @name Social.US.Game.getAllGamesList
 * @function
 * @private 
 * @static
 *
 * @returns {Social.US.OrderedList} An ordered list interface to the catalog of games.
 * @see Social.US.OrderedList
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Game.getAllGamesList = function(){
		
	return OrderedList.getClassPublicInterface(Game, "getAllGamesList", "_allGamesInterface");
};

/**
 * Returns the current game. 
 *
 * @name Social.US.Game.getCurrentGame
 * @function
 * @public 
 * @static
 *
 * @param {Function} cb The callback function returns the current game or an error code and description.
 * <br/> 
 * <b>Callback Example:</b><br/>
 * <pre class="code">function(error, game){
 * &nbsp;&nbsp; if(!game){
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
 * &nbsp;&nbsp;} else {
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var currentGame = game;
 * &nbsp;&nbsp;}
 * }
 * </pre>
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Game.getCurrentGame = function(cb){
	Dispatcher.callClassMethodOnRemoteObject(Game, "getCurrentGame", [cb]);
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Leaderboard'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Leaderboard'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Leaderboard'] = exports; var DataModelR = require('NGCore/Client/Social/US/Models/DataModel');
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;
var OrderedList = require('NGCore/Client/Social/US/Models/OrderedList').OrderedList;

/**
 * <code>Leaderboard</code> objects enable the current user to get friend scores, top scores, and submit a score.
 * To return a leaderboard, you must set up at least one leaderboard for your game in the Mobabe Sandbox or Production environment.
 * @class 
 * @name Social.US.Leaderboard
 * @augments Social.US.DataModel
 */
var Leaderboard = exports.Leaderboard = DataModelR.DataModel.subclass({

	 
	classname: "Leaderboard",
	properties: [
	"level",
	"title",
	"game",
	"iconURL"
	],

	
	/** 
	 * @constructs Constructs a <code>Leaderboard</code> object identified by the record ID. 
	 * @private
	 *
	 * @param {Type} $super A reference to the DataModel superclass.
	 * @param {String} recordId The record ID of the object.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	initialize: function($super, recordID){
		$super(recordID);
		NgLogD("Leaderboard Public! " + recordID + " " + this.recordID);
	},
	
	
	/**
	* Submits a score to the leaderboard.
	*
	* @name Social.US.Leaderboard.submitScore
	* @function
	* @public
	*
	* @param {Numeric} points The score points. If <code>null</code> or <code>undefined</code>, the callback error is "No score."
	* @param {Function} cb The callback function.
	* <br/> 
    * <b>Callback Example:</b><br/>
    * <pre class='code'>function(error, score){
    * &nbsp;&nbsp;  if(error) {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var setScore = score;
    * }
    * </pre>
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */
	submitScore: function(points, cb){
		Dispatcher.callMethodOnRemoteObject(this, "submitScoreWithPoints", [points, cb]);
	},	
	
	/**
	* Returns an <code>OrderedList</code> with the user's score and the highest scores.
	* 
	* @name Social.US.Leaderboard.getTopScoresList
	* @function
	* @public
	*
	* @return {Social.US.OrderedList} The list of highest scores.
	* @see Social.US.OrderedList
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/		
	getTopScoresList: function(){
		return OrderedList.getObjectPublicInterface(this, "getTopScoresList", "_leaderboardTopScoresInterface");
	},
	
	/**
	* Returns an <code>OrderedList</code> of scores for the user's friends.
	* 
	* @name Social.US.Leaderboard.getFriendsScoresList
	* @function
	* @public
	*
	* @return {Social.US.OrderedList} The list of scores for the user's friends.
	* @see Social.US.OrderedList
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/		
	getFriendsScoresList: function(){
		return OrderedList.getObjectPublicInterface(this, "getFriendsScoresList", "_leaderboardFriendsScoresInterface");
	}

	 /**
	 * The user's level in the game. Read-only.
	 * @name Social.US.Leaderboard.level
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The leaderboard title. Read-only.
	 * @name Social.US.Leaderboard.title
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * The game name. Read-only.
	 * @name Social.US.Leaderboard.game
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * A URL to the leaderboard icon. Read-only.
	 * @name Social.US.Leaderboard.iconURL
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
		 
});

/**
* Returns the leaderboard(s) for the current game.
* To return a leaderboard, you must set up at least one leaderboard for your game in the Mobabe Sandbox or Production environment.
*
* @name Social.US.Leaderboard.getLeaderboards
* @function
* @public
* @static
*
* @param cb Retrieves the leaderboard(s) for the current game. If an error occurs, returns an error code and error description.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class='code'>function(error, leaderboards){
*     if(error) {
*          var errorCode = error.errorCode;
*          var errorDesc = error.description;
*     } else {
*          var retrievedLeaderboards = leaderboards;
* }
* </pre>
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
Leaderboard.getLeaderboards = function(cb){
	Dispatcher.callClassMethodOnRemoteObject(Leaderboard, "getLeaderboards", [cb]);
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Score'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Score'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Score'] = exports; var DataModel 	  = require('NGCore/Client/Social/US/Models/DataModel').DataModel;

/**
 * <code>Score</code> constructs objects that reflect a user's score for the current game.
 * @class 
 * @name Social.US.Score
 * @augments Social.US.DataModel
 */
var Score = exports.Score = DataModel.subclass({
	
    classname: "Score",
    	
	 /**
	 * A user's score. Read-only.
	 * @name Social.US.Score.score
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The score as formatted for display. Read-only.
	 * @name Social.US.Score.displayScore
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	
	 /**
	 * The user's rank. Read-only.
	 * @name Social.US.Score.rank
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	
	 /**
	 * The user's level in the current game. Read-only.
	 * @name Social.US.Score.level
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
    
	 /**
	 * A <code>Social.US.User</code> reference to the user associated to the score. Read-only.
	 * @name Social.US.Score.user
	 * @field
	 * @public
     * @see Social.US.User
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */    
	 
    properties: [
	"points",
	"displayScore",
	"rank",
	"level",
	"user"
	]
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/AppData'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/AppData'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/AppData'] = exports; var DataModelReq = require('NGCore/Client/Social/US/Models/DataModel');
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * <code>AppData</code> constructs objects that get and set a user's properties, 
 * and provides permissions for sharing the user's properties with other users.
 * @class 
 * @name Social.US.AppData
 * @see Social.Common.Appdata for additional Mobage persistence facilities;
 * @see Storage.KeyValue for additional ngCore persistence facilities; and,
 * @see Storage.FileSystem for additional ngCore persistence facilities. 
 */
var AppData = exports.AppData = DataModelReq.DataModel.subclass({
		
	classname: "AppData",
	properties: [
		"data",
		"key",
		"user",
		"permissions"
	],
	
	/**
	 * The application data for the user. Limited to 1024 bytes.
	 * 
	 * @name Social.US.AppData.data
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	/**
	 * The key describing the application data. Limited to 32 bytes.
	 * 
	 * @name Social.US.AppData.key
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	/**
	 * The name of the user who owns the data.
	 * 
	 * @name Social.US.AppData.name
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	/**
	 * The permissions for the application data.<br/><br/>
	 * <code>Private</code>: only the user can read and write the user data.<br/>
	 * <code>FriendsReadOnly</code>: friends can read the user data, but cannot write it.<br/>
	 * <code>PublicReadOnly</code>: all users can read the user data, but cannot write it.     
	 * 
	 * @name Social.US.AppData.permissions
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	
	
    /**
     * The default constructor.
     * @constructs 
     * @name Social.US.AppData.initialize
     * @private
     *
     * @param recordID A unique ID for the <code>AppData</code> object.
     *
     * @augments Social.US.DataModel
     * @status iOS, Android, Test, iOSTested, AndroidTested
     */	
    initialize: function($super, recordID) {
        $super(recordID);
    }
});

/**
* Takes a user reference and returns key/value pairs of the user for the current game.
* @name Social.US.AppData.getKeysForUser
* @function
* @public
* @static
*
* @param {Social.US.User} user A reference to the user.
* @param {Function} callback The callback function returns key/value pairs for the user and/or and error code and description.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">var entries = {"key1": "value1", "key2": "value2"};
* ...
* function(error, entries){
* &nbsp;&nbsp;   if (error){
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
* &nbsp;&nbsp;   } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var retrievedEntries = entries;
* &nbsp;&nbsp;   }
* }
* </pre>
* @example
* var user = Social.US.Session.getCurrentSession().user();
* var AppData = Social.US.AppData;
* var retrievedEntries = null;
* AppData.getKeysForUser(user, function(error, entries){
*				retrievedEntries = entries;
*			});
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
AppData.getKeysForUser = function(user, cb){
	Dispatcher.callClassMethodOnRemoteObject(AppData, "getKeysForUser", [user, cb]);
};

/**
* Takes a user, a key (the name of the key for a name/value pair) and returns the key/value pair for the user for the current game.
* @name Social.US.AppData.getDataForUserWithKey
* @function
* @public
* @static
*
* @param {Social.US.User} user A reference to the user.
* @param {String} key The name of the key.
* @param {Function} callback Retrieves the key/value pair for the user and/or an error code and description.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">function(error, response){
* &nbsp;&nbsp;   if (error){
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
* &nbsp;&nbsp;   } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var fetchedData = response.data;
* &nbsp;&nbsp;   }
* }
* </pre>
* @example
* var user = Social.US.Session.getCurrentSession().user();
* var AData = Social.US.AppData;
* var errorCode = null;
* var errorDesc = null;
* var fetchedData = null;
* AData.getDataForUserWithKey( user, 
*                              key, 
*                              function(error, response){
*                                   errorCode = error.errorCode;
*                                   errorDesc = error.description;
*                                   fetchedData = response.data;
*                              }
*                            );
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
AppData.getDataForUserWithKey = function(user, key, cb){
	Dispatcher.callClassMethodOnRemoteObject(AppData, "getDataForUserWithKey", [user, key, cb]);
};


/**
* Takes data, a user, a key (the name of the key for a name/value pair) and permissions for the data and sets the application data for the user.
* <b>Note:</b> Limited to 30 key/value pairs per user, per game. 
* Maximum key name limited to 32 bytes. Maximum value limited to 1,024 bytes.
* To use key/value pairs without the foregoing constraints, use <code>Storage.KeyValue</code>
* in ngCore.
* @name Social.US.AppData.setDataForUserWithKeyAndPermissions
* @function
* @public
* @static 
*
* @param {String} data The data to set.
* @param {Social.US.User} user A reference to the user.
* @param {String} key The name of the key.
* @param {Social.US.AppData.Permissions} permission The permissions for the data.
* @param {Function} cb The callback function if there is an error with the parameters.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">function(error){
* &nbsp;&nbsp;  if(!response) {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
* &nbsp;&nbsp;   } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var responseValues = response;
* &nbsp;&nbsp;   }
* }
* </pre>
* @example
* var user = Social.US.Session.getCurrentSession().user();
* var data = "some data";
* var key = "some key";
* var errorCode = null;
* var errorDesc = null;
* var result = null; 
*
* var AData = Social.US.AppData;
* 
* AData.setDataForUserWithKeyAndPermissions(data, 
*                                           user, 
*                                           key, 
*                                           AppData.Permissions.Private, 
*                                           function(error, response){
*                                             errorCode = error.errorCode;
*                                             errorDesc = error.description;
*                                             result = response;
*                                           }
*                                         );
* @status iOS, Android, Test, iOSTested, AndroidTested
* @see Social.US.AppData.Permissions for permission settings;
* @see Social.Common.Appdata for additional Mobage persistence facilities;
* @see Storage.KeyValue for additional ngCore persistence facilities; and,
* @see Storage.FileSystem for additional ngCore persistence facilities.
*/
AppData.setDataForUserWithKeyAndPermissions = function(data, user, key, permissions, cb){
	Dispatcher.callClassMethodOnRemoteObject(AppData, "setDataForUserWithKeyAndPermissions", [data, user, key, permissions, cb]);
};



/**
* Defines permissions for viewing user data.<br/><br/>
* <code>Private</code>: only the user can read and write the user data.<br/>
* <code>FriendsReadOnly</code>: friends can read the user data, but cannot write it.<br/>
* <code>PublicReadOnly</code>: all users can read the user data, but cannot write it. 
* @name Social.US.AppData.Permissions
* @field
* @public
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
AppData.Permissions = {
	Private: 0,
	FriendsReadOnly: 1,
	PublicReadOnly: 2
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Cache'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Cache'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Cache'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var SocialR = require('NGCore/Client/Social');

/**
 * <code>Cache</code> provides caching for a user's objects residing in the local interpreter.
 * @class 
 * @name Social.US.Cache
 * @private
 */
var Cache = exports.Cache = Class.subclass({


	classname: "Cache",
	inMemoryObjects: {},
	caches: {},
	
	/**
	 * Initializes a cache object upon instantiation. 
	 * @name Social.US.Cache.initialize
	 * @constructs
	 * @private
	 */			
	initialize: function(){
	},

	
	/**
	* Takes a classname and a unique record ID and returns the object or <code>null</code> if it doesn't find the object.
	*
	* @name Social.US.Cache.getObjectWithRecordID
	* @function
	* @private
	*
	* @param {String} classname The name of the class.
	* @param {Number} recordID The object ID.
	*
	* @return Returns the object corresponding to the <code>recordID</code> parameter or <code>null</code> if it doesn't find the object.
	*/
	getObjectWithRecordID: function(classname, recordID){
		var category = this.inMemoryObjects[classname];
		if(category){
			return category[recordID] || null;
		}else{
			return null;
		}
	},
	
	/**
	* Takes an object and adds it to the cache.
	* <code>addObject()</code> takes an object, ensures that it is not already in the cache, and adds it to the cache.
	*
	* @name Social.US.Cache.addObject
	* @function
	* @private
	*	
	* @param {Object} obj The object to add to the cache.
	* @return Returns the record ID of the object added to the cache.
	*/	
	addObject: function(obj){
		var classname = obj._classname();
		var category = this.inMemoryObjects[classname];
		if(!category){
			category = {};
			this.inMemoryObjects[classname] = category;
		}

		var object = category[obj.recordID];
		if(object){
			return object;
		}else{
			category[obj.recordID] = obj;
			return obj;
		}
	},
	
	/**
	* Takes an object reference and removes the object from the cache.
	* 
	* @name Social.US.Cache.removeObject
	* @function
	* @private
	*	
	* @param {Object} obj The object to remove from the cache.
	*/	
	removeObject: function(obj){
		var classname = obj._classname();
		var category = this.inMemoryObjects[classname];
		if(category){
			delete category[obj.recordID]; // ZOMG THE DELETE OPERATOR
		}
	},
	
	/**
	* Takes an object reference and returns whether the object is in the cache.
	* 
	* @name Social.US.Cache.isObjectCached
	* @function
	* @private
	*	
	* @param {Object} obj The object to select in the cache.
	*
	* @return Returns <code>true</true> if the object is in the cache; otherwise, it returns <code>false</code>.
	*/		
	isObjectCached: function(obj){
		var classname = obj._classname();
		var category = this.inMemoryObjects[classname];
		return (category && (category[obj.recordID] == obj));
	},
	
	
	saveCache: function(){
		
	},
	
	
	loadCache: function(){
		
	},
	
	/**
	* Takes a JSON array of objects and loads them into the cache.
	*
	* @name Social.US.Cache.loadCacheFromJSONArray
	* @function
	* @private
	*
	* @param {JSON} jsonArray The JSON object array to load into the cache.
	* @param {function} cb <code>loadCacheFromJSONArray()</code> takes an optional callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
	*/			
	loadCacheFromJSONArray: function(jsonArray, cb){
		var objects = [];
        
		for(var idx = 0; idx < jsonArray.length; idx++){
			var hash = jsonArray[idx];
			if(hash && hash.hasOwnProperty("classname") && hash.hasOwnProperty("recordID")){
				var theClassname = hash.classname;
				var theClass = SocialR.Social.US[theClassname];
				var theRecordID = hash.recordID;
				if(theClass && theRecordID){
					var theInstance = this.getObjectWithRecordID(theClassname, theRecordID);
					if(!theInstance){
						theInstance = new theClass(theRecordID, {});
					}
        
					theInstance._deserializeFromHash(hash);
					this.addObject(theInstance);
				}
			}
		}
        
		cb(null, this);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Data/Session'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Session'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Session'] = exports; var CoreReq = require('NGCore/Client/Core');
//var UserReq = require('../Models/User');
var MessageEmitterReq = require('NGCore/Client/Core/MessageEmitter');
var CacheReq = require('NGCore/Client/Social/US/Models/Cache');
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * <code>Session</code> manages a user's game sessions.
 * @class 
 * @name Social.US.Session
 */
var Session = exports.Session = MessageEmitterReq.MessageEmitter.subclass({
		
	classname: "Session",
	
	/**
	 * Constructs a session object.
	 * @name Social.US.Session.initialize
	 * @private
	 * @constructs 
	 */	
	initialize: function(gameData){
		if(gameData){
			this._loadSessionData(gameData);
		}
	},
	
	/**
	 * Loads the user's game data into the current session.
	 *
	 * @name Social.US.Session._loadSessionData
	 * @function
	 * @private
	 *
	 * @param {Type} gameData Takes game data and loads it into the current session.
	 */		
	_loadSessionData: function(gameData){
		this._appKey = gameData.appId || this._appKey || null;
		this._appVersion = gameData.appVersion || this._appVersion || null;
		this._platformVersion = gameData.platformVersion || this._platformVersion || "1.0";
		this._serverMode = gameData.serverMode || this._serverMode || null;

		this._user = (gameData.userID ? this.dataCache().getObjectWithRecordID("User", gameData.userID) : null);		
		this.emit({user: this._user});
	},
	
	/**
	 * Returns the cache for the current session. If a session cache does not exist, this call creates a new cache, loads it and returns it.
	 *
	 * @name Social.US.Session.dataCache
	 * @function
	 * @private
	 *
	 * @return {Social.US.Cache} The cache for the current session.
	 */			
	dataCache: function(){
		if(!this._cache){
			this._cache = new CacheReq.Cache();
			this._cache.loadCache(function(err){
				NgLogD("Loaded cache: " + err);
			});
		}
		return this._cache;
	},
	
	
	/**
	 * Returns the user for this session.
	 *
	 * @name Social.US.Session.user
	 * @function
	 * @public
	 *
	 * @return {Social.US.User} The user for the current session.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */					
	user: function(){
		return this._user;
	},
	
	

	// data you probably don't need
	/**
	 * Returns the name of the game for this session.
	 *
	 * @name Social.US.Session.appKey
	 * @function
	 * @public
	 *
	 * @return {String} The application name.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */						
	appKey: function(){
		return this._appKey;
	},
	
	/**
	 * Returns the version of the game for this session.	 
	 *
	 * @name Social.US.Session.appVersion
	 * @function
	 * @public
	 *
	 * @return {String} The application version.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	appVersion: function(){
		return this._appVersion;
	},
	
	/**
	 * Returns the server mode of the game for this session.
	 *
	 * @name Social.US.Session.serverMode
	 * @function
	 * @public
	 *
	 * @return {String} The server mode.
	 * <b>Note:</b> Valid settings for the server mode include:<br/>
	 * <ul>
	 * <li>staging</li>
	 * <li>integration</li>
	 * <li>sandbox</li>
	 * <li>production</li>
	 * <li>unknown</li>
	 * </ul>
	 * @see Social.US.Session.serverModes
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	serverMode: function(){
		return this._serverMode;
	},
	
	/**
	 * Returns the platform version of the game for this session.
	 *
	 * @name Social.US.Session.platformVersion
	 * @function
	 * @public
	 *
	 * @return {String} The platform version.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	platformVersion: function(){
		return this._platformVersion;
	},
	

	/**
	 * Takes a consumer key and retrieves the session tokens for the the consumer key.
	 *
	 * @name Social.US.Session.getSessionTokensForConsumerKey
	 * @function
	 * @public
	 * 
     * @param {String} consumerKey The consumer key.
	 * @param {Function} cb A callback that retrieves the session tokens for the consumer key. If an error occurs, returns an error code 
	 * and error description.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	getSessionTokensForConsumerKey: function(consumerKey, cb){
		Dispatcher.callClassMethodOnRemoteObject("Session", ["getCurrentSession", "getSessionTokensForConsumerKey"], [[], [consumerKey, cb]]);
	}
});


/**
 * The session modes for the server. Session modes include:
 * <ul>
 * <li><code>staging</code></li>
 * <li><code>integration</code></li>
 * <li><code>sandbox</code></li>
 * <li><code>production</code></li>
 * <li><code>unknown</code></li>
 * </ul>
 * @name Social.US.Session.serverModes
 * @field
 * @public
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Session.serverModes = {
	staging: "staging",
	integration: "integration",
	partner: "sandbox",
	sandbox: "sandbox",
	production: "production",
	unknown: "unknown"
};

/**
 * Returns the current session.  
 * @name Social.US.Session.getCurrentSession
 * @function
 * @public 
 * @static
 *
 * @return {Social.US.Session} The current session.
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */	
Session.getCurrentSession = function(){
	return Session._currentSession;
};



Session._emitter = null;

/**
 * Adds a listener to the current session.
 *
 * @name Social.US.Session.addCurrentSessionListener
 * @function
 * @public
 * @static
 *  
 * @param {Core.MessageListener }listener The listener to add to the current session.
 * @param {Function} callback The callback function.
 * @param priority The priority for this <code>MessageListener</code>.
 *
 * @see Core.MessageListener
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Session.addCurrentSessionListener = function(listener, callback, priority){	
	if(!Session._emitter){
		Session._emitter = new MessageEmitterReq.MessageEmitter();
	}
	
	Session._emitter.addListener(listener, callback, priority);
};

/**
 * Removes the listener from the current session.
 *
 * @name Social.US.Session.removeCurrentSessionListener 
 * @function
 * @public 
 * @static
 *
 * @param {Core.MessageListener} listener The listener for the current session.
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Session.removeCurrentSessionListener = function(listener){
	if(Session._emitter){
		Session._emitter.removeListener(listener);
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Data/Dispatcher'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Dispatcher'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Dispatcher'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var Core = require('NGCore/Client/Core').Core;
var CacheR = require('NGCore/Client/Social/US/Models/Cache');

var SocialR = require('NGCore/Client/Social');
var SessionR = require('NGCore/Client/Social/US/Data/Session');

/**
 * <code>Dispatcher</code> objects know about <code>DataModel</code> objects and can "push" <code>DataModel</code> objects between interpreters.
 * <code>Dispatcher</code> objects can find classes and specific instances of objects, and may invoke their functions.
 * <code>Dispatcher</code> objects also provide a series of convenience functions to facilitate communication between interpreters.
 * @class 
 * @name Social.US.Dispatcher
 * @private
 */
var Dispatcher = exports.Dispatcher = {
				
	classname: "Dispatcher",
	callbackUIDCounter: 0,
	callbacks: {
		"-2": {},
		"-1": {}
	},
	
	/**
	 * Returns the data cache for the current session.
	 * @name Social.US.Dispatcher.cache
	 * @function
	 * @private
	 *
	 * @return {Social.US.Cache} The data cache for the current session.
	 * @see Social.US.Cache
	 */		
	cache: function(){		
		try {		
			return SessionR.Session.getCurrentSession().dataCache();
		}
		catch (err) {
			NgLogD("Mobage/Dispatcher/cache-Warning: cannot get cache. NOTE: This may be expected behavior if early on in initialization. Err=" 
				+ err);

			return null;
		}
	},
	
	
	/**
	 * Gets the current session and loads session data.
	 * If there is no current session, <code>receiveSession()</code> creates a new session.
	 *	 
	 * @name Social.US.Dispatcher.receiveSession
	 * @function
	 * @private
	 *
	 * @param {Type} command Takes a command, which may include the platform version, server mode, application name and application version. 
	 */		
	receiveSession: function(command){		
		var session = SessionR.Session.getCurrentSession();
		if(!session){
			session = new SessionR.Session();
			SessionR.Session._currentSession = session;
		}
		
		var userData = command.data.userData;
		if(userData){
			// the User object will be cached implicitly, then loaded in _loadSessionData
			Dispatcher.receiveObject({data: userData});
		}
		
		session._loadSessionData(command.data);
		
		if(SessionR.Session._emitter){
			SessionR.Session._emitter.emit({session: session});
		}
	},
	
	// DataModel communication
	/**
	 * Finds a particular instance of an object in the local interpreter and calls a method on the object.
	 *	 
	 * @name Social.US.Dispatcher.callMethodOnLocalObject
	 * @function
	 * @private
	 *
	 * @param {Command} command Takes a command object that identifies the class name of the object, 
     * its record ID, the method name to call, and any parameters for the method.
	 * The command object takes an optional callback and <code>callMethodOnLocalObject()</code> returns returns the result 
     * and/or any error code and description to the callback function.
	 */		
	callMethodOnLocalObject: function(command){		
		var recordID = command.recordID;
		var classname = command.classname;
		
		var object = Dispatcher.cache().getObjectWithRecordID(classname, recordID);
		if(object){
			var methodName = command.methodName;

			var error = false;
			var args;
			var retVal;
			if(methodName instanceof Array) {
				var methodOwner = object;
				for(var idx = 0; idx < methodName.length; idx++) {
					if(typeof methodOwner[methodName[idx]] == "function") {
						args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments[idx] || []);
						retVal = methodOwner[methodName[idx]].apply(methodOwner, args);
						methodOwner = retVal;						
					}
					else {
						error = true;
						break;
					}
				}
			}
			else {
				if(typeof object[methodName] == "function") {
					args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments || []);
					retVal = object[methodName].apply(object, args);
				}
				else {
					error = true;
				}
			}
			
			if(error) {
				NgLogD("ERROR: Invalid methods for calling on local object: " + command.recordID + " " + methodName);
			}
			else if(command.callback){
				var callback = Dispatcher.convertFunctionFromJSON({callbackUID: command.callback});
				if(callback){
					callback(retVal);
				}
			}
		}
	},
	
	
	/**
	 * Finds a particular instance of an object in a remote interpreter and calls a method on the remote object.
	 *	 
	 * @name Social.US.Dispatcher.callMethodOnRemoteObject
 	 * @function
 	 * @private
 	 *
	 * @param {Number} object The object reference (i.e., typically the keyword 'this').
	 * @param {String} method The method name to call.
	 * @param {Array} args An array of parameters for the method, including other <code>DataModel</code> objects or functions.
	 * @param {Function} cb Returns the result and/or any error code and description to the callback function.
	 *
	 * <b>Note:</b> If the target method wants a callback as one/more of its arguments, supply it as an element in the argument array, <b>NOT</b> as the fourth parameter.
	 */			
	callMethodOnRemoteObject: function(object, method, args, cb){		
		if(!object || !method){
			NgLogD("Public.Dispatcher.callMethodOnRemoteObject - bailing");
			if(cb){
				cb();
			}
			return;
		}

		args = Dispatcher.convertArgumentsArrayToJSON(args || []);
		
		var cmd = {
			apiURL: "US.Dispatcher.callMethodOnLocalObject",
			recordID: object.recordID,
			classname: object._classname(),
			methodName: method,
			arguments: args,
			callback: Dispatcher.convertFunctionToJSON(cb)
		};
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Calls a static method on a class in the local interpreter.
	 *	 
	 * @name Social.US.Dispatcher.callClassMethodOnLocalObject	
	 * @function
	 * @private
	 *
	 * @param {Command} command Takes a command object that identifies the class name of the object, the method name to call, and any parameters for the method.
	 * The command parameter takes an optional callback function and <code>callMethodOnLocalObject()</code> returns returns the result and/or any error code and description to the callback function.
	 */		
	callClassMethodOnLocalObject: function(command){		
		Dispatcher.beginBatching();
		
		var classname = command.classname;
		var methodName = command.methodName;
		if(classname && methodName){
			var theClass = SocialR.Social.US[classname];
			if(!theClass){
				theClass = SocialR.Social.US.Service[classname];
			}
			
			if(theClass){
				var error = false;
				var args;
				var retVal;
				if(methodName instanceof Array) {
					var methodOwner = theClass;
					for(var idx = 0; idx < methodName.length; idx++) {
						if(typeof methodOwner[methodName[idx]] == "function") {
							args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments[idx] || []);
							retVal = methodOwner[methodName[idx]].apply(methodOwner, args);
							methodOwner = retVal;						
						}
						else {
							error = true;
							break;
						}
					}
				}
				else {
					if(typeof theClass[methodName] == "function") {
						args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments || []);
						retVal = theClass[methodName].apply(theClass, args);
					}
					else {
						error = true;
					}
				}
				
				if(error) {
					NgLogD("ERROR: Invalid methods for calling on local Class: " + classname + " " + methodName);
				}
				else if(command.callback){
					var callback = Dispatcher.convertFunctionFromJSON({callbackUID: command.callback});
					if(callback){
						callback(retVal);
					}
				}				
			}
		}
		
		Dispatcher.endBatching();
	},

	/**
	 * Calls a static method on a class in a remote interpreter.
	 *	 
	 * @name Social.US.Dispatcher.callClassMethodOnRemoteObject
	 * @function
	 * @private
	 *
	 * @param {String} theClass The name of the class.
	 * @param {String} method The method name to call.
	 * @param {Array} args An array of parameters for the method.
	 * @param {Function} cb <code>callClassMethodOnRemoteObject()</code> returns returns the result and/or any error code and description to the callback function.
	 * 
	 */			
	callClassMethodOnRemoteObject: function(theClass, methodName, args, cb){		
		if(!theClass || !methodName){
			NgLogD("Public.Dispatcher.callClassMethodOnRemoteObject - bailing");
			if(cb){
				cb();
			}
			return;
		}

		args = Dispatcher.convertArgumentsArrayToJSON(args || []);
		
		var cmd = {
			apiURL: "US.Dispatcher.callClassMethodOnLocalObject",
			classname: (theClass.classname ? theClass.classname : theClass),
			methodName: methodName,
			arguments: args,
			callback: (cb ? Dispatcher.convertFunctionToJSON(cb) : null)
		};
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},


	// callback communication

	/**
  	 * Takes a callback and sends it to a remote interpreter.
	 *	 
	 * @name Social.US.Dispatcher.sendCallbackToRemote
	 * @function
	 * @private
	 *
	 * @param {String} callbackUID The user ID of the user receiving the callback.
	 * @param {Array} args An array of parameters for the callback function.
	 */		
	sendCallbackToRemote: function(callbackUID, args){		
		args = Dispatcher.convertArgumentsArrayToJSON(args || []);
		
		var cmd = {
			apiURL: "US.Dispatcher.receiveCallbackFromRemote",
			callbackUID: callbackUID,
			arguments: args,
			zone: GSGlobals.getRouterInstance().zone
		};

		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Receives a callback from a remote interpreter and provides the arguments to the local callback function.
	 *	 
	 * @name Social.US.Dispatcher.receiveCallbackFromRemote
	 * @function
	 * @private
	 *
	 * @param {Type} command A JSON object containing the user ID of the user receiving the callback and the callback arguments array.
	 */			
	receiveCallbackFromRemote: function(command){
		var callback = Dispatcher.callbacks[GSGlobals.getRouterInstance().zone][command.callbackUID]; //Dispatcher.convertFunctionFromJSON(command);
		if(!callback){
			return;
		}

		var args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments || []);
		
		callback.apply(callback, args);
	},
	

	// convenience functions to facilitate communication of all objects
	
	/**
	 * Parses a JSON array of function parameters and returns an array of function parameters.
	 *	 
	 * @name Social.US.Dispatcher.convertArgumentsArrayFromJSON
	 * @function
	 * @private
	 * 
	 * @param {Array} args An array of function parameters in JSON format.
	 * @return {Array} Returns an array of function parameters.
	 */	
	convertArgumentsArrayFromJSON: function(args){		
		var newArgs = [];
		for(var idx=0; idx < args.length; idx++){
			var arg = args[idx];
			
			if(arg && ((arg.recordID && arg.classname) || arg instanceof Array)){
				newArgs[idx] = Dispatcher.convertModelObjectFromJSON(arg);
			}else if(arg && arg.callbackUID){
				newArgs[idx] = Dispatcher.convertFunctionFromJSON(arg);
			}else{
				newArgs[idx] = arg;
			}
		}
		return newArgs;
	},

	/**
	 * Parses an array of function parameters and returns the array in JSON format.	 
	 * @name Social.US.Dispatcher.convertArgumentsArrayToJSON
	 * @function
	 * @private
	 *
	 * @param {Array} args An array of function parameters.
	 * 
	 * @returns {JSON} An array of function parameters in JSON format.
	 */
	convertArgumentsArrayToJSON: function(args){		
		var newArgs = [];
		for(var idx=0; idx < args.length; idx++){
			var arg = args[idx];
			if(arg && (arg.recordID && arg._classname && typeof arg._classname == "function" && arg._classname())){
				Dispatcher.sendObjectImmediately(arg);

				arg = Dispatcher.convertModelObjectToJSON(arg);
				newArgs[idx] = arg;
			}else if(arg && arg instanceof Array){
				arg = Dispatcher.convertArgumentsArrayToJSON(arg);
				newArgs[idx] = arg;
			}else if(arg && typeof arg == "function"){
				newArgs[idx] = Dispatcher.convertFunctionToJSON(arg);
			}else{
				newArgs[idx] = arg;
			}
		}
		return newArgs;
	},

	// convenience functions to facilitate communication of DataModel objects
	
	/**
	 * Takes a <code>DataModel</code> object and returns the object in JSON format.
	 *	 
	 * @name Social.US.Dispatcher.convertModelObjectToJSON
	 * @function
	 * @private
	 * 
	 * @param {Social.Models.DataModel} object A reference to a <code>DataModel</code> object (i.e., typically a subclass of <code>Models.DataModel</code>).
	 *
	 * @return {JSON} A <code>DataModel</code> object in JSON format.
	 */		
	convertModelObjectToJSON: function(object){		
		if(object && object.recordID && object._classname()){
			object = {
				classname: object._classname(),
				recordID:  object.recordID
			};
		}
		return object;
	},


	/**
	 * Takes a <code>DataModel</code> object in JSON format and returns the object.
	 *	 
	 * @name Social.US.Dispatcher.convertModelObjectFromJSON
 	 * @function
 	 * @private
 	 *
	 * @param {JSON} json A <code>DataModel</code> object in JSON format.
	 * 
	 * @return {Social.US.DataModel} A <code>DataModel</code> object.
	 */		
	convertModelObjectFromJSON: function(json){		
		var object = json;
		if(json.recordID && json.classname){
			var obj = Dispatcher.cache().getObjectWithRecordID(json.classname, json.recordID);
			if(obj){
				object = obj;
				if(json.data){
					object._deserializeFromHash(json.data);
				}
			}
		}else if(json instanceof Array){
			for(var idx=0; idx < json.length; idx++){
				var arg = json[idx];
				json[idx] = Dispatcher.convertModelObjectFromJSON(arg);
			}
		}
		return object;
	},

	// convenience functions to facilitate communication of functions
	
	/**
	 * Takes a function and returns the function in JSON format.
	 *	 
	 * @name Social.US.Dispatcher.convertFunctionToJSON
	 * @function
	 * @private	 
	 * 
	 * @param {function} The function to conver to JSON format.
	 * 
	 * @return {JSON} Returns a function in JSON format.
	 */		
	convertFunctionToJSON: function(fn){		
		if(fn && typeof fn == "function"){
			
			var callbackUID = ++Dispatcher.callbackUIDCounter;
			var zone = GSGlobals.getRouterInstance().zone;
			Dispatcher.callbacks[zone][callbackUID] = fn;

			fn = {
				callbackUID: callbackUID,
				zone: zone
			};
		}
		return fn;
	},


	
	/**
 	 * Takes a function expressed in JSON format and returns the function.
	 * @name Social.US.Dispatcher.convertFunctionFromJSON
	 * @function
	 * @private
	 * 
	 * @param {JSON} A function in JSON format.
	 * 
	 * @return {Function} Returns a function.
	 */	
	convertFunctionFromJSON: function(json){		
		var fn = json;
		var callbackUID = fn.callbackUID;
		var zone = fn.zone;
		
		if(callbackUID){
			var callback = Dispatcher.callbacks[zone][callbackUID];
			if(callback){
				fn = callback;
				delete Dispatcher.callbacks[zone][callbackUID];
			}else{
				fn = Dispatcher.generateCallbackForUID(callbackUID);
			}
		}
		return fn;
	},


	
	/**
	 * Takes a user ID and sends the callback to the remote interpreter.
	 *
	 * @name Social.US.Dispatcher.generateCallbackForUID
	 * @function
	 * @private
	 *	 
	 * @param {Number} The user ID.
	 * @return {Function} Returns a callback to the remote interpreter.
	 */	
	generateCallbackForUID: function(uid){		
		if(uid.callbackUID){
			uid = uid.callbackUID;
		}
		
		return function(){
			Dispatcher.sendCallbackToRemote(uid, arguments);
		};
	},
	
	
	// object sending and batching
	_batchCount: 0,
	_queuedObjects: [],
	
	/**
	 * <code>beginBatching()</code> increments the batch count.
	 * 
	 * @name Social.US.Dispatcher.
	 * @function
	 * @private
	 */	
	beginBatching: function(){		
		++Dispatcher._batchCount;
	},

	/**
	 * Decrements the batch count.
	 * Decrements the batch count and sends any objects remaining in the queue immediately.
	 *
	 * @name Social.US.Dispatcher.endBatching
	 * @function
	 * @private
	 */	
	endBatching: function(){		
		if((--Dispatcher._batchCount) === 0){
			for(var objKey in Dispatcher._queuedObjects){
				var obj = Dispatcher._queuedObjects[objKey];
				Dispatcher._queuedObjects[objKey] = undefined;
				Dispatcher.sendObjectImmediately(obj);
			}
		}
	},

	/**
	 * Takes an object and adds it to a queue, which pushes the object to the remote interpreter.
	 *
	 * @name Social.US.Dispatcher.sendObject
	 * @function
	 * @private
	 */
	sendObject: function(obj){		
		if(Dispatcher._queuedObjects.indexOf(obj) == -1){
			Dispatcher.beginBatching();
			
			var key = "" + obj.classname + "---" + obj.recordID;
			Dispatcher._queuedObjects[key] = obj;
			
			Dispatcher.endBatching();
		}
	},

	/**
	 * Takes an object and pushes it to the remote interpreter immediately (i.e., bypassing the queue).
	 *
	 * @name Social.US.Dispatcher.sendObjectImmediately
	 * @function
	 * @private
	 */
	sendObjectImmediately: function(obj){		
		if(!obj){
			return;
		}
		
		var cmd = {
			apiURL: "US.Dispatcher.receiveObject",
			data:   obj._serializedHash()
		};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Receives a serialized object from the remote interpreter, retrieves the local version of the same object from the cache, and deserializes the received object to the local object.
	 * If there is no local version of the received object, <code>receiveObject()</code> creates a local version and adds it to the cache; then, it deserializes the received object to the newly created local object.
	 *
	 * @name Social.US.Dispatcher.receiveObject
	 * @function
	 * @private
	 */
	receiveObject: function(command){		
		var data = command.data;
		var theRecordID  = data.recordID;
		var theClassname = data.classname;
		var theData      = data.data;
		
		if(theRecordID && theClassname && Dispatcher.cache()){
			var obj = Dispatcher.cache().getObjectWithRecordID(theClassname, theRecordID);
			if(!obj){
				var theClass = SocialR.Social.US[theClassname];
				obj = new theClass(theRecordID);
				
				Dispatcher.cache().addObject(obj);
			}

			// TODO disable emitting somehow
			if(theData){
				obj._deserializeFromHash(theData);
			}
		}
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/Friends'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Friends'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Friends'] = exports; var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;

var DataModelR = require('NGCore/Client/Social/US/Models/DataModel');
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * @class 
 * @name Social.US.Service.Friends
 */
var Friends = exports.Friends = DataModelR.DataModel.subclass({
    classname: "Friends"
});

/**
 * Opens the "Find Friends" view.
 *
 * @name Social.US.Service.Friends.showFindFriends
 * @function
 * @public
 * @static
 *
 * @param selectedTab Takes an optional tab reference.
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */		
Friends.showFindFriends = function(selectedTab) {
		NgLogD("Public call showFindFriends");
	
		var cmd = {
			apiURL:"US.Service.Friends.showFindFriends"
		};
		
		if(selectedTab){
			cmd.data.tab = selectedTab;
		}
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
};

/**
 * Opens the "Friend Picker" view.
 * 
 * @name Social.US.Service.Friends.openFriendPicker
 * @function
 * @public 
 * @static
 * 
 * @param maxFriendsToPick The maximum number of friends to pick. <code>0</code> for unlimited.
 * @param {Function} callback Retrieves an array of picked users.
 * 
 * <br/> 
 * <b>Callback Example:</b><br/>
 * <pre class="code">function(error, pickedUsers){
 * &nbsp;&nbsp; if(error){
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
 * &nbsp;&nbsp; } else {
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var users = pickedUsers;
 * &nbsp;&nbsp;}
 * }
 * </pre>
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */		
Friends.showFriendPicker = function(maxFriendsToPick, callback) { 
    Dispatcher.callClassMethodOnRemoteObject(Friends, "showFriendPicker", [maxFriendsToPick, callback]);
};

/**
* <code>Social.US.Service.Friends</code> has an invited user message emitter. 
* To add a message listener to the message emitter, see the example below.
*
* @name Social.US.Service.Friends.invitedUserEmitter
* @field
* @public
* @example
* 
* Social.US.Service.Friends.invitedUserEmitter.addListener(
*				new Core.MessageListener(), 
*				function(user){ 
*				// do sth. w/ User object 
*				}
* Social.US.Service.Friends.invitedUserEmitter.emit({user: user});
* @see Core.MessageListener
* @see Core.MessageEmitter
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
Friends.invitedUserEmitter = new MessageEmitter();; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/Profile'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Profile'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Profile'] = exports; var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class
 * @name Social.US.Service.Profile
 */

exports.Profile = {
	
	/**
	 * Shows the user profile of the user specified by the <code>userOrGamertag</code> parameter.
	 * 
	 * @name Social.US.Service.Profile.showUserProfile
	 * @function
	 * @public
	 * 
	 * @param userOrGamertag Identifies the user or gamertag corresponding to the user profile.
	 * @param tab Specifies the name of the tab to show when the UI opens. If <code>null</code>, it opens the default tab.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */			
	showUserProfile:function(userOrUserGamertag,tab){		
		var cmd = {
			apiURL:"US.Service.Profile.showUserProfile", 
			data:{
				user:userOrUserGamertag
			}
		};
		if(tab){cmd.tab = tab;}
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/ButtonOverlays'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/ButtonOverlays'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/ButtonOverlays'] = exports; var UI = require('NGCore/Client/UI').UI;

var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;

var Friends = require('NGCore/Client/Social/US/Service/Friends').Friends;
var Profile = require('NGCore/Client/Social/US/Service/Profile').Profile;
var User    = require('NGCore/Client/Social/US/Models/User').User;

/**
 * @class 
 * @name Social.US.Service.ButtonOverlays
 */
exports.ButtonOverlays = {
	/**
	* Displays the "Mobage Community" button.
	*	
	* @name Social.US.Service.ButtonOverlays.showCommunityButton
	* @function
	* @public 
	* 
	* @param {exports.Gravity} gravity Displays the button in the specified corner.
	* @param {Function} callback The callback function if there is an error related to <code>gravity</code> or <code>theme</code> usage.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @see exports.Gravity
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/   
	showCommunityButton: function(gravity, callback) {
		NgLogD("Public - showCommunityButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.showCommunityButton"
		};
		
		cmd["gravity"] = gravity;
		
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	* Hides the "Mobage Community" button.
	*
	* @name Social.US.Service.ButtonOverlays.hideCommunityButton
	* @function
	* @public 
	*	
	* @param {Function} callback The callback function if there is an error hiding the button.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/	
	hideCommunityButton: function(callback) {
		NgLogD("Public - hideCommunityButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.hideCommunityButton"
		};
		
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Shows the balance button.
	 * Shows the balance button where the <code>rect</code> parameter 
	 * determines the size and position of the button.
	 *
	 * @name Social.US.Service.ButtonOverlays.showBalanceButton
	 * @function
	 * @public
	 *	 
	 * @param {UI.ViewGeometry.Rect} rect Determines the size and position of the balance button.
	 * @param {Function} callback The callback function if there is an error with the <code>rect</code> parameter.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 * &nbsp;&nbsp;   }
	 * </pre>
	 * @see UI.ViewGeometry.Rect
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	showBalanceButton: function(rect, callback) {
		NgLogD("Public - showBalanceButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.showBalanceButton"
		};
		
		if (rect != undefined) {
			cmd["rect"] = rect;
		} else {
			cmd["rect"] = new UI.ViewGeometry.Rect(50, 50, 0, 0);
		}
		
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
	
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Hides the balance button.	
	 * @name Social.US.Service.ButtonOverlays.hideBalanceButton
	 * @function
	 * @public 
	 * 
	 * @param {Function} callback The callback function called after the view closes.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 * &nbsp;&nbsp;   }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	hideBalanceButton: function(callback) {
		NgLogD("Public - hideBalanceButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.hideBalanceButton"
		};

		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
	
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/GameLaunchPayload'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/GameLaunchPayload'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/GameLaunchPayload'] = exports; var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;

/**
* Provides an interface for retrieving a game's last payload from the game service. The game
* payload is returned as a string.
* @name Social.US.GameLaunchPayload
*/

var GameLaunchPayload = exports.GameLaunchPayload = {


	/**
	 * @name Social.US.GameLaunchPayload.getLastPayload
	 * @function
	 * @public
	 * 
	 * @param {Function} callback Retrieves the last payload generated by the game client from the game service 
     * as a string (e.g., JSON) and/or any error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, payload){
     *      if(error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     *      } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var pl = payload;     
     *      }
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     */
	getLastPayload:function(callback)
	{
        if(callback != undefined && typeof callback == "function")
		{
			var cmd = {
				apiURL:"US.Service.GameLaunchPayload.getLastPayload"
			};

            cmd["callbackFunc"] = callback;

			GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
		}
	},
	
	// private, automatically called when new payload arrives. Do not call.
	onGameLaunchPayload:function(data)
	{
		this.newGamePayloadEmitter.emit(data);
	}
};

GameLaunchPayload.newGamePayloadEmitter = new MessageEmitter();; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/Bank'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Bank'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Bank'] = exports; // Bank Public Interface
var RouterInited 	= require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals 		= require('NGCore/Client/Social/_Internal/GSGlobals');
var UI 				= require('NGCore/Client/UI').UI;

/**
* @ignore
* @private
*/
exports.Bank = {
};


/**
 * @class 
 * @name Bank.Debit
 * @description
 * Bank.Debit is an interface for in-game item purchasing. A transaction begins with a call to <code>createTransaction()</code>, which presents
 * a user interface to the user. If the user follows through with a purchase, the <code>transaction.state</code> property changes from 
 * <code>new</code> to <code>authorized</code>. Once <code>createTransaction()</code> executes its callback, the game may call 
 * <code>openTransaction()</code>, which changes the state from <code>authorized</code> to <code>open</code> and puts funds into escrow. 
 * At this point, the game/game server should deliver the purchased items. Once the items have been delivered, the game should call   
 * <code>closeTransaction()</code>. If there is a problem at any point in the transaction lifecycle, call <code>cancelTransaction()</code>,
 * which sets the <code>transactionState</code> property to <code>canceled</code> and restores funds from escrow back to the user.
 */
exports.Bank.Debit = {
	
		
	/**
	 * Creates a transaction. Initially, it sets the <code>transaction.state</code> to <code>new</code>.
     * Mobage presents a dialog that prompts the user to confirm the transaction. 
	 * If the user decides not to proceed with the transaction, the callback error returns as "usercanceled."
	 * In the client-only flow, this call checks inventory and sets the state to <code>authorized</code>.
	 * 
	 * @name Bank.Debit.createTransaction
	 * @function
	 * @public
	 * 
	 * @param {Array} billingItems The billing items for the transaction. <br/><b>Note:</b> The array is limited to one item for this release.
     * <br/><b>Array Example:</b><br/>
     * <pre class="code"> var billingItems = [{
     *     "item": {
     *           "id": "iceCastle",
     *          },
     *     "quantity": 1
     *    },
     *    {
     *     "item": {
     *           "id": "cobbleStoneRoad",
     *          },
     *     "quantity": 3
     *    } 
     * ];
     * </pre>
	 * @param {String} comment A comment about the transaction.
	 * @param {Function} callback Retrieves the transaction details and/or any error code and description.
	 * <br/> 
     * <b>Callback Example:</b><br/>
	 * <pre class="code">var createTxCallback = function (error, transaction){
	 *     if (error === 'usercanceled'){
     *         var userCanceledDlg = new UI.AlertDialog();
     *         userCanceledDlg.setTitle("Cancel Transaction");
     *         userCanceledDlg.setText("User canceled transaction.");
     *         userCanceledDlg.setChoices([('OK')]);
     *         userCanceledDlg.show();
     *     } else if(error){
     *         var errorCode = error.errorCode;
     *         var errorDesc = error.description;
     *         Bank.Debit.cancelTransaction(transaction.id);
     *     } else {
     *         txId = transaction.id;
     *         Bank.Debit.openTransaction(txId, openTxCallback)
     * };
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */				
    createTransaction: function(billingItems, comment, callback) {
		NgLogD("Public call createTransaction");
		
		
	var data = {
	    billingItems: billingItems,
	    comment: comment
	};
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.createTransaction",
			data: data
		};

		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}    
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Places funds into escrow and begins processing the transaction. 
	 * Indicates the game server needs to deliver the purchased item.
	 * The <code>transaction.state</code> transitions from <code>authorized</code> to <code>open</code>.
	 *
	 * @name Bank.Debit.openTransaction
	 * @function
	 * @public
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @param {Function} callback Retrieves the transaction details and/or any error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var openTxCallback = function (error, transaction){
	 *      if (error){
	 *          var errorCode = error.errorCode;
     *          var errorDesc = error.errorDescription;
     *          Bank.Debit.cancelTransaction( transaction.id, 
     *                                        cancelTxCallback );
     *      } else {
     *          var txId = transaction.id;
     *          var txState = transaction.state;
     *          var txComment = transaction.comment;
     *          //You are responsible for delivering items to the client.
     *          MyGameTxClass.deliverItems(transaction.items);
     *          //If you do not close the tx, you do not get paid.
     *          Bank.Debit.closeTransaction( transaction.id, 
     *                                       closeTxCallback );
     *      }	
     * };
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     */
	openTransaction: function(transactionId, callback) {
		NgLogD("Public call openTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.openTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Continues processing a transaction.
	 * Checks the inventory to verify the item is valid, available, and so on. After verification, the <code>transaction.state</code> chranges from <code>new</code> to <code>authorized</code>,
	 * and funds are placed in escrow. The <code>transaction.state</code> transitions from <code>authorized</code> to <code>open</code>, which 
	 * indicates the game server needs to deliver the purchased item. 
	 * 	 
	 *
	 * @name Bank.Debit.continueTransaction
	 * @function
	 * @public
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @param {Function} callback Retrieves the transaction details and/or any error code and description.
	 * <br/>
     * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, transaction){
     *      if(error) {
	 *           var errorCode = error.errorCode;
	 *           var errorDesc = error.description;
     *           Bank.Debit.cancelTransaction( transaction.id, 
     *                                         cancelTxCallback );
     *      } else {
     *           var tx = transaction;
     *           Bank.Debit.openTransaction( transaction.id, 
     *                                       openTxCallback );
     *      }
	 * };
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
    continueTransaction: function(transactionId, callback) {
		NgLogD("Public call continueTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.continueTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	

    /**
     * Cancels the transaction. The transaction was canceled or the purchased item was not delivered and the game
     * needs to return the user's funds. The <code>transaction.state</code> transitions to <code>canceled</code>.
     *
     * @name Bank.Debit.cancelTransaction
     * @function
     * @public 
     * 
     * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
     * @param {Function} callback Retrieves the transaction ID and/or an error code and description.
     * <br/>
     * <b>Callback Example:</b><br/>
	 * <pre class="code">var cancelTxCallback = function (error, transaction){
     *     if (error){
     *        var errorCode = error.errorCode;
     *        var errorDesc = error.errorDescription;
     *        NgLogD('Time to freak out!: ' + errorCode+ ': ' + errorDesc);
     *     } else {
     *        var txId = transaction.id;
     *        var txState = transaction.state;
     *        var txComment = transaction.comment;
     *        if (txState === 'canceled'){
     *          NgLogD('Sniff, sniff... Whaaaaahhhh!!!');
     *        }	
	 *     }	
     * };
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     */
    cancelTransaction: function(transactionId, callback) {
		NgLogD("Public call cancelTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.cancelTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
    },


	/**
	 * Closes the transaction. The virtual item was delivered.
	 * The <code>transaction.state</code> transitions from <code>open</code> to <code>closed</code>.
	 *
	 * @name Bank.Debit.closeTransaction
	 * @function
	 * @public
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @param {Function} callback Retrieves the transaction details and/or an error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var closeTxCallback = function (error, transaction){
     *     if (error){
     *          var errorCode = error.errorCode;
     *          var errorDesc = error.errorDescription;
     *          NgLogD('Oh my goodness! A transaction error: ' +
     *                  errorCode + ': ' + errorDesc);
     *          Bank.Debit.cancelTransaction( transaction.id, 
     *                                        cancelTxCallback );
	 *     } else {
     *          var txId = transaction.id;
     *          var txState = transaction.state;
     *          var txComment = transaction.comment;
     *          if (txState === 'closed'){
     *              NgLogD('I'm rich! I'm rich!');
     *          }	
     *     }	
     * };
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	closeTransaction: function(transactionId, callback) {
		NgLogD("Public call closeTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.closeTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Retrieves the transaction corresponding to the given transaction ID parameter.
	 *
	 * @name Bank.Debit.getTransaction
	 * @function
	 * @public
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @param {Function} callback Retrieves the transaction details and/or an error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, transaction){
     *      if(error) {
	 *            var errorCode = error.errorCode;
	 *            var errorDesc = error.description;
     *      } else {
     *            var tx = transaction;     
     *      }
	 *   }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getTransaction: function(transactionId, callback) {
		NgLogD("Public call getTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.getTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Retrieves the user's transactions where the state is <code>new</code>, <code>authorized</code> or <code>open</code>.
     * See the Game Service Programming Guide for details.
	 *
	 * @name Bank.Debit.getPendingTransactions
	 * @function
	 * @public
	 * 
	 * @param {Function} callback Retrieves the user's pending transactions and/or an error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, transaction){
     *      if(error) {
	 *         var errorCode = error.errorCode;
	 *         var errorDesc = error.description;
     *      } else {
     *         var tx = transaction;     
     *      }
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getPendingTransactions: function(callback) {
		NgLogD("Public call getPendingTransactions");

		var cmd = {
			apiURL:"US.Service.Banking.Purchase.getPendingTransactions",
			data:{}
		};

		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = function(err, data) {
				callback(err.error, data.openTransactions);
			};
		}

	    GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	_getCallBackFunc : function(callback) {
			return function(err, data) {
				if(err) {
					callback(err, undefined);
				} else {
					callback(err, data.transaction);					
				}
			};
	}
};

/**
 * @class 
 * @name Bank.Inventory
 * @description
 * Provides an interface to retrieve items from inventory. The Mobage platform
 * server is responsible for managing item inventory in games.
 */
exports.Bank.Inventory = {


	/**
	 * Retrieves the item identified by its product ID from inventory on the Mobage platform server.
	 *
	 * @name Bank.Inventory.getItem
	 * @function
	 * @public
	 * 
	 * @param {Number} itemId The product ID for the item.
     * @param {Function} callback Retrieves the item from inventory on the Mobage platform server and/or an error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var item = {
     *      "id" : "XXXXXXXXX",
     *      "name" : "Tractor",
     *      "price" : 350,
     *      "description" : "Tractor conveys huge amount of equipment.",
     *      "imageUrl" : "http://someurl.com"
     * }
     *function(error, item){
     *      if(error) {
	 *         var errorCode = error.errorCode;
	 *         var errorDesc = error.description;
     *      } else {
     *         var itemData = item;
     *      }
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */    
    getItem: function(itemId,callback) {
	NgLogD("Public call Inventory getItem");

	var data = {
	    itemId: itemId
	};

	var cmd = {
	    apiURL:"US.Service.Banking.Purchase.getItem",
	    data:data
	};

	if (callback != undefined && typeof callback == "function") {
	    cmd["callbackFunc"] =  function(err, data) {
		if(err) {
		    callback(err, undefined);
		} else {
		    callback(err, data.item);					
		}
	    };
	}

	GSGlobals.getRouterInstance().sendCommandToGameService(cmd);

    }


};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/GSGlobals'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSGlobals'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSGlobals'] = exports; /**
 * Annoyingly necessary file to break circular dependencies.
 */
var theRouter = null;
exports.setRouterInstance = function(router){
	theRouter = router;
};
exports.getRouterInstance = function(){
	return theRouter;
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/RouterInit'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/RouterInit'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/RouterInit'] = exports; var Router = require('NGCore/Client/Social/_Internal/_Router').Router;
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

//Generate 1 instance of our router now and treat as the global instance!
GSGlobals.setRouterInstance(new Router());; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/_Router'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/_Router'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/_Router'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Router INTERNAL ROUTING CLASS
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Shared/Class').Class;
var Core = require('NGCore/Client/Core').Core;
var GSCommand = require('NGCore/Client/Social/_Internal/GSCommand');
var Public = require('NGCore/Client/Social').Social;

////////////////////////////////////////////////////////////////////////////////
var RouterVerbose = false;

exports.Router = Class.subclass(
/** @lends GameService.Router.prototype */
{
	classname: 'Router',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	/** Member var to help shortcircuit uneccessary bounces out to native. */
	zone:-2,
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
			* Zone for this Router Singleton (per-process)
			* @private */
	Zone:
	{ 
		/** Public Zone */
		Public: -2,
		/** GameService Zone */
		GameService: -1,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 346
	// Method create = -1
	// Method sendToOtherProcess = 2
	// Method onCreate = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._sendToOtherProcessRecv( cmd );
					break;
				case 3:
					instance._onCreateRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Router._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Router._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[346] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_sendToOtherProcessRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Router.sendToOtherProcess from command: " + cmd );
			return false;
		}
		
		obj[ "gsCommand" ] = Core.Proc.parseJSONString( cmd[ 0 ] );
		if( obj[ "gsCommand" ] === undefined )
		{
			NgLogE("Could not parse gsCommand in Router.sendToOtherProcess from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onCreateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Router.onCreate from command: " + cmd );
			return false;
		}
		
		obj[ "zone" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "zone" ] === undefined )
		{
			NgLogE("Could not parse zone in Router.onCreate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":346,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_sendToOtherProcessSendGen: function( gsCommand )
	{
		Core.Proc.appendToCommandString( ":346,2," + this.__objectRegistryId + "," + Core.Base64.encode( JSON.stringify( gsCommand ) )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _sendToOtherProcessRecv: function( cmd ) {}
	// sendToOtherProcess: function( gsCommand ) {}
	
	// _onCreateRecv: function( cmd ) {}

// {{/Wg Generated Code}}
	_onCreateRecv:function(cmd) {
		if (!this._onCreateRecvGen(cmd,this)){
			return;
		}
		NgLogD("_Router/_onCreateRecv: "+this.zone);
		//We already stored the zone directly in ourselves (by passing in 'this').
	},
	_sendToOtherProcessRecv: function( cmd )
	{
		var decodedCommand = {};
		if(!this._sendToOtherProcessRecvGen(cmd,decodedCommand)){
			NgLogE("Decode of data for router, failed.");
			return;
		}
		
		var commandObject = decodedCommand["gsCommand"];
		
		//Incoming commands all get executed immediately.
		if(this.zone == this.Zone.Public) {
			if(RouterVerbose) {
				NgLogD("_Router/_sendToOtherProcessRecv - in public");
			}
			
			this.dispatchGameCommand(commandObject);
		}
		else if(this.zone == this.Zone.GameService) {
			if(RouterVerbose) {
				NgLogD("_Router/ _sendToOtherProcessRecv - in privileged");
			}
			
			// Dispatch Immediately, because we are in the right interpreter
			this.dispatchGameServiceCommand(commandObject);
		}
		else {
			NgLogE("Unknown Command Zone for the GameService Router.");
			// Assume public
			this.dispatchGameCommand(commandObject);
		}
	},
 	sendToOtherProcess: function( gsCommand ) 
	{
		var jsonCommand = GSCommand.makeSafe(gsCommand);
		if(!jsonCommand) {
			NgLogD("Couldn't prep GSCommand message for sending!");
			return;
		}
		
		if(RouterVerbose) {
			NgLogD("_Router.js/sendToOtherProcess: " + JSON.stringify(jsonCommand));
		}
		
		this._sendToOtherProcessSendGen(jsonCommand);
	},
	sendCommandToGameService:function(gsCommand) 
	{		
		if(this.zone == this.Zone.Public) {
			if(RouterVerbose) {
				NgLogD("_Router: sendCommandToGameService - in public");
			}
			
			// In the Public Interface, this is an alias for sendToOtherProcess
			this.sendToOtherProcess(gsCommand);
		}
		else if(this.zone == this.Zone.GameService) {
			if(RouterVerbose) {
				NgLogD("_Router: sendCommandToGameService - in privileged");
			}
			
			// Dispatch Immediately, because we are in the right interpreter
			this.dispatchGameServiceCommand(gsCommand);
		}
		else {
			NgLogE("Unknown Command Zone for the GameService Router.");
			// Assume public
			this.sendToOtherProcess(gsCommand);
		}
	},
	sendCommandToGame:function(gsCommand)
	{
		if(this.zone == this.Zone.GameService) {
			// In the GameService Interface, this is an alias for sendToOtherProcess
			this.sendToOtherProcess(gsCommand);
		}
		else if(this.zone == this.Zone.Public) {
			// Dispatch Immediately, because we are in the right interpreter
			this.dispatchGameCommand(gsCommand);
		}
		else {
			NgLogE("Unknown Command Zone for the GameService Router.");
			// Assume Privileged
			this.sendToOtherProcess(gsCommand);
		}
	},
	dispatchGameCommand:function(jsonCommand) 
	{
		var tCommand = GSCommand.makeExecutable(jsonCommand);
		//For the time being we expect this to almost always be callbacks
		if(tCommand && tCommand.hasOwnProperty("callbackFunc")) {	
			if( typeof tCommand["callbackFunc"] == "function" ) {
				var args = null;
				var error = null;
				if(tCommand.hasOwnProperty("error")) {
					error = tCommand["error"];
				}
				if(tCommand.hasOwnProperty("callbackData")) {
					args = tCommand["callbackData"];
				}

				//Time to execute the callback function!
				tCommand["callbackFunc"](error,args);
			}
		}
		else if(tCommand) {
			// Case there was no callbackFunc this is odd!!
			var apiURL = null;
			if(tCommand && tCommand.hasOwnProperty("apiURL") ) {
				apiURL = tCommand["apiURL"];

				var apiPieces = apiURL.split(".");
				var curPackage = Public;

				for ( var i = 0; i < apiPieces.length; i++ )
				{
					if(curPackage.hasOwnProperty(apiPieces[i])) {
						curPackage = curPackage[apiPieces[i]];
					}
					else {
						//Total Fail
						NgLogE("Cannot find namespace " + apiURL + " in GameService");
						curPackage = null;
						break;
					}
				}

				if(curPackage && typeof curPackage == "function" ) {			
					curPackage(tCommand);

					return; //done dispatching!
				}else{
					NgLogE("GameService Public cannot dispatch game command " + JSON.stringify(tCommand));
				}
			}
		}
	},
	dispatchGameServiceCommand:function(jsonCommand) 
	{
		//Don't decode the callbackId into a func when on a different interpreter!
		var apiURL = null;
		if(jsonCommand && jsonCommand.hasOwnProperty("apiURL") ) {
			apiURL = jsonCommand["apiURL"];

			var apiPieces = apiURL.split(".");
			var curPackage = require('NGCore/Client/Social/_Internal/Privileged').Social;

			for ( var i = 0; i < apiPieces.length; i++ )
			{
				if(curPackage.hasOwnProperty(apiPieces[i])) {
					curPackage = curPackage[apiPieces[i]];
				}
				else {
					//Total Fail
					NgLogE("Cannot find namespace " + apiURL + " in GameService");
					curPackage = null;
					break;
				}
			}

			if(curPackage && typeof curPackage == "function" ) {			
				curPackage(jsonCommand);

				return; //done dispatching!
			}
		}
		else {
			NgLogE("Someone called GameService without the proper parameters.\n");
		}
	},
	setVerboseLogging:function(useVerbose)
	{
		RouterVerbose = useVerbose;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/GSCommand'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSCommand'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSCommand'] = exports; /**
 * GSCommand.js
 * GameService Command Helper
 *
 * @summary Converts hashes for sending across the interpreter bounds, specifically:
 *		- Takes a hash with a callbackFunc
 * 			- Takes callbackFunc and converts to callbackId
 *		- Takes a hash with a callbackId
 *			- Takes the callbackId and looks up a callbackFunc from the local cache
 */
 
var GameServiceCommandCallbackStore = {};
GameServiceCommandCallbackStore.uidGenerator = 0;

/* @private */
var storeCallbackIdForFunc = function(callbackFunc) {
	var uid = GameServiceCommandCallbackStore.uidGenerator++;
	GameServiceCommandCallbackStore[uid] = callbackFunc;
	return uid;
};
/* @private */
var extractFuncForCallbackId = function(callbackId) {
	if(GameServiceCommandCallbackStore.hasOwnProperty(callbackId)){
		var callbackFunc = GameServiceCommandCallbackStore[callbackId];
		delete GameServiceCommandCallbackStore[callbackId];
		return callbackFunc;
	}
	return null;
};

var blindConvert = function(hash) {
	if ( typeof hash == "object" ) {
		// Case we have a hash
		if ( hash.hasOwnProperty("callbackFunc") ) {
			//	with a callback func to convert
			hash["callbackId"] = storeCallbackIdForFunc(hash["callbackFunc"]);
			
			delete hash["callbackFunc"];
		}
		else if (hash.hasOwnProperty("callbackId")) {
			hash["callbackFunc"] = extractFuncForCallbackId(hash["callbackId"]);
			delete hash["callbackId"];
		}
		return hash;
	}
	
	NgLogD("Error: invalid or non-object passed to gsCmdConvert.");
	return null;
};
exports.makeSafe = function(hash) {
	if (hash && typeof hash == "object" && hash.hasOwnProperty("callbackFunc"))
	{
		return blindConvert(hash);
	}
	return hash;
};
exports.makeExecutable = function(hash) {
	if (hash && typeof hash == "object" && hash.hasOwnProperty("callbackId"))
	{
		return blindConvert(hash);
	}
	return hash;
};

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/Privileged'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/Privileged'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/Privileged'] = exports; /**
 * Privileged API for GameService (Public Stub)
 * 
 * Access this file as NGCore/Client/Social.js
 */
exports.Social = {
	// stubbed out for the SDK
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/OrderedList'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/OrderedList'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/OrderedList'] = exports; var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * @class 
 * @name Social.US.OrderedList
 * @description
 * Do not instantiate <code>OrderedList</code> objects directly. This description is for information purposes only. 
 * <code>DataModel</code> subclasses that return <code>OrderedList</code> interfaces include:<br/><br/>
 * <div class="ul">
 * <li>{@link Social.US.User}</li>
 * <li>{@link Social.US.Leaderboard}</li>
 * </div><br/>
 * Some <code>DataModel</code> subclasses can return an <code>OrderedList</code>,
 * which is an interface for iterating over a range of values. You determine the iteration range by
 * selecting one of three common functions: <br/><br/>
 * <div class="ul">
 * <li><code>forAll(iterCb, doneCb):</code> Iterates over all values.</li>
 * <li><code>forRange(start, count, iterCb, doneCb):</code> Iterates from the starting index to the count.</li>
 * <li><code>forItem(index, iterCb, doneCb):</code> Iterates over a particular item given by its index.</li>
 * </div>
 * Each of the functions calls an iteration callback (iterCb) for every available item. 
 * When the function iterates over all items or an error occurs, it calls the done callback (doneCb). You <b>MUST</b> provide both callbacks.
 * <br/><br/>
 * <b>Note:</b> The <code>OrderedList</code> interface invokes an iterator on the server. Do NOT assume it will execute your callback functions immediately.
 *
 * @example
 * //NOTE: You MUST provide both callback functions.
 * userBuddiesList.forAll( 
 *      function(error, details){//per item cb body}, 
 *      function(error, details){//done cb body}
 * );
 *
 * @example
 * //Callback examples
 * var done = false;
 * var err = null;
 *
 * currentUser.getFriendsList().forAll(
 *          function(continueCb, user, index){
 *				if(user == otherUser){
 *					foundBuddy = true;
 *					continueCb(false);
 *				}else{
 *					continueCb(true);
 *				}
 *			}, 
 *          function(error){
 *                  if (!error){
 *                      done = true;
 *                   } else {
 *                      err = error;
 *                   }
 *          }
 * );
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
var OrderedList = {

    /**
    * Returns a public interface for an object.
    * 
    * To expose a privelegee ordered list of a <code>DataModel</code> object in the public interface, 
    * add a function to the object of the corresponding <code>DataModel</code>
    * subclass in the public interface.
    * @example
    * getFollowersList: function(cb){
 	* 	return OrderedList.getObjectPublicInterface(this, "getFollowersList", "_followersListInterface");
	* },
    *
    * @name Social.US.OrderedList.getObjectPublicInterface
    * @function    
    * @private
    *
    * @param {Object} ownerObject The object that will "own" the public interface.
    * @param {Function} getListFn The function that returns a list of values to the <code>OrderedList</code>.
    * @param interfaceName The name of the interface.
    *
    * @return {Social.US.OrderedList} The public interface.
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */
    getObjectPublicInterface: function(ownerObject, getListFn, interfaceName) {
		if(ownerObject[interfaceName]) {
			return ownerObject[interfaceName];
		}
		
		var args = Array.apply(null, arguments);
		if(args && args.length > 3){
			args.splice(0, 3);
		}else{
			args = [];
		}
		
		var newInterface = {
			forAll: function(perItemCb, doneCb) {
				Dispatcher.callMethodOnRemoteObject(ownerObject, [getListFn, "forAll"], [args,[perItemCb, doneCb]]);		
			},
			forRange: function(start, count, perItemCb, doneCb) {
				Dispatcher.callMethodOnRemoteObject(ownerObject, [getListFn, "forRange"], [args,[start, count, perItemCb, doneCb]]);
			},
			forItem: function(index, perItemCb, doneCb) {
				Dispatcher.callMethodOnRemoteObject(ownerObject, [getListFn, "forItem"], [args,[index, perItemCb, doneCb]]);
			}
		};
		
		ownerObject[interfaceName] = newInterface;
		
		return newInterface;
	},

    /**
    * Returns a public interface for a class.
    * To expose a priveleged ordered list of a <code>DataModel</code> subclass in the public interface, 
    * add a function to the subclass of the corresponding <code>DataModel</code>
    * subclass in the public interface.
    * @example
    * getFollowersList: function(cb){
 	* 	return OrderedList.getClassPublicInterface(this, "getFollowersList", "_followersListInterface");
	* },    
    *
    * @name Social.US.OrderedList.getClassPublicInterface
    * @function
    * @private
    *
    * @param {Object} owner The owner of the the public interface.
    * @param {Function} getListFn The function to call on each iteration.
    * @param interfaceName The name of the interface.
    * 
    * @return {Social.US.OrderedList} The public interface.
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */
    getClassPublicInterface: function(owner, getListFn, interfaceName) {
		if(owner[interfaceName]) {
			return owner[interfaceName];
		}
		
		var newInterface = {
			forAll: function(perItemCb, doneCb) {
				Dispatcher.callClassMethodOnRemoteObject(owner, [getListFn, "forAll"], [[],[perItemCb, doneCb]]);
			},
			forRange: function(start, count, perItemCb, doneCb) {
				Dispatcher.callClassMethodOnRemoteObject(owner, [getListFn, "forRange"], [[],[start, count, perItemCb, doneCb]]);
			},
			forItem: function(index, perItemCb, doneCb) {
				Dispatcher.callClassMethodOnRemoteObject(owner, [getListFn, "forItem"], [[],[index, perItemCb, doneCb]]);
			}
		};
		
		owner[interfaceName] = newInterface;
		
		return newInterface;
	}
};

exports.OrderedList = OrderedList;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Color'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Color'] || {}; $MODULE_REGISTRY['NGCore/Shared/Color'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.Color = Class.subclass(
/** @lends Core.Color.prototype */
{
	classname: 'Color',
	
	/**
	 * @class The <code>Color</code> class constructs objects that control the RGB components of a device. 
	 * RGB is a color model used for rendering objects on-screen and is derived 
	 * from the three primary colors used in the model: red, green, and blue.
	 * Each value ranges from <code>(0-1)</code> and determines the color saturation level.	 
	 * @constructs The default constructor.<br><br>
	 * <b>Example:</b> The following code examples illustrate different call styles for <code>Color</code> objects.<br><br>
	 * A new color with all components set to one (1 = white).
	 * <pre class="code">var style1 = new Core.Color();</pre>
	 *
	 * Copy an existing color.
	 * <pre class="code">var style2 = new Core.Color(style1);</pre>
	 *
	 * Specify all three components.
	 * <pre class="code">var style3 = new Core.Color(1.0, 1.0, 1.0);</pre>
	 *
	 * Specify the color as solid blue.
	 * <pre class="code">var style4 = new Core.Color([0, 0, 1.0]);</pre>
	 *
	 * Specify the color as solid red.
	 * <pre class="code">var style5 = new Core.Color([1.0, 0, 0]);</pre>
	 * 
	 * Specify the color as a dark shade of red.
	 * <pre class="code">var style6 = new Core.Color([.5, 0, 0]);'</pre>
	 * @augments Core.Class
	 * @param {Number} [red=1] The red component.
	 * @param {Number} [green=1] The green component.
	 * @param {Number} [blue=1] The blue component.
	 * @throws {Wrong number of arguments for a Color} Number of parameters passed by this call is invalid.
	 */
	initialize: function(red, green, blue)
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._red = 1.0;
				this._green = 1.0;
				this._blue = 1.0;
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._red = 1.0;
					this._green = 1.0;
					this._blue = 1.0;
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (color)
					this._red = rhs.getRed();
					this._green = rhs.getGreen();
					this._blue = rhs.getBlue();
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._red = 1.0;
							this._green = 1.0;
							this._blue = 1.0;
							break;
						case 1:
							// ([color])
							rhs = rhs[0];
							this._red = rhs.getRed();
							this._green = rhs.getGreen();
							this._blue = rhs.getBlue();
							break;
						case 3:
							// ([red, green, blue])
							this._red = rhs[0];
							this._green = rhs[1];
							this._blue = rhs[2];
							break;
						default:
							throw new Error('Wrong number of arguments for a Color');
					}
				}
				break;
			case 3:
				// (red, gree, blue)
				this._red = arguments[0];
				this._green = arguments[1];
				this._blue = arguments[2];
				break;
			default:
				throw new Error('Wrong number of arguments for a Color');
		}
		return this;
	},
	
	/**
	 * Set the saturation level for all three color components.
	 * @example Core.Color.setAll(0.5, 0.5, 1.0);
	 * @param {Number} [red=1] The red component.
	 * @param {Number} [green=1] The green component.
	 * @param {Number} [blue=1] The blue component.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color for a full list of supported calling styles.
	 */
	setAll: function(red, green, blue)
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Retrieve the saturation level for the red component of this <code>Color</code>.
	 * @returns {Number} The current saturation level for the red component.
	 */
	getRed: function()
	{
		return this._red;
	},
	
	/**
	 * Retrieve the saturation level for the green component of this <code>Color</code>.
	 * @returns {Number} The current saturation level for the green component.
	 */
	getGreen: function()
	{
		return this._green;
	},
	
	/**
	 * Retrieve the saturation level for the blue component of this <code>Color</code>.
	 * @returns {Number} The current saturation level for the blue component.
	 */
	getBlue: function()
	{
		return this._blue;
	},
	
	/**
	 * Set the saturation level for the red component of this <code>Color</code>.
	 * @example Core.Color.setRed(0.7);
	 * @param {Number} red The new saturation level for the red component.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color#getRed
	 */
	setRed: function(red)
	{
		this._red = red;
		return this;
	},
	
	/**
	 * Set the saturation level for the green component of this <code>Color</code>.
	 * @example Core.Color.setGreen(0.3);
	 * @param {Number} green The new saturation level for the green component.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color#getGreen
	 */
	setGreen: function(green)
	{
		this._green = green;
		return this;
	},
	
	/**
	 * Set the saturation level for the blue component of this <code>Color</code>.
	 * @example Core.Color.setBlue(1.0);
	 * @param {Number} blue The new saturation level for the blue component.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color#getBlue
	 */
	setBlue: function(blue)
	{
		this._blue = blue;
		return this;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Vector'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Vector'] || {}; $MODULE_REGISTRY['NGCore/Shared/Vector'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.Vector = Class.subclass(
/** @lends Core.Vector.prototype */
{
	classname: 'Vector',
	
	/**
	 * @class The <code>Vector</code> class constructs objects that define vector point values for the <i>x</i> and <i>y</i> components. 
	 * Supported values range between <code>(0-1)</code>.
	 * @constructs The default constructor. <br><br>
	 * The following code examples illustrate a variety of different calling styles for <code>Vector</code> objects.<br><br>
	 * All components are set to zero.
	 * <pre class="code">var style1 = new Core.Vector();</pre>
	 *
	 * Copy an existing vector.
	 * <pre class="code">var style2 = new Core.Vector(style1);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style3 = new Core.Vector(1.0, 1.0);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style4 = new Core.Vector([1.0, 1.0]);</pre>
	 * @augments Core.Class
	 * @param {Number} [x=0] The <i>x</i> component.
	 * @param {Number} [y=0] The <i>y</i> component.
	 * @throws {Wrong number of arguments for a Vector} Number of parameters passed by this call is invalid.
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._x = 0;
				this._y = 0;
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._x = 0;
					this._y = 0;
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (vector)
					this._x = rhs.getX();
					this._y = rhs.getY();
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._x = 0;
							this._y = 0;
							break;
						case 1:
							// ([vector])
							rhs = rhs[0];
							this._x = rhs.getX();
							this._y = rhs.getY();
							break;
						case 2:
							// ([x, y])
							this._x = rhs[0];
							this._y = rhs[1];
							break;
						default:
							throw new Error('Wrong number of arguments for a Vector');
					}
				}
				break;
			case 2:
				// (x, y)
				this._x = arguments[0];
				this._y = arguments[1];
				break;
			default:
				throw new Error('Wrong number of arguments for a Vector');
		}
	},
	
	/**
	 * Set the value of both components for this <code>Vector</code>. 
	 * @param {Number} [x=0] The new <i>x</i> coordinate.
	 * @param {Number} [y=0] The new <i>y</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Vector for examples of supported calling styles.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAll: function()
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Duplicate this <code>Vector</code>.
	 * @returns {Core.Vector} A new vector with identical coordinates to the duplicated vector.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the value of the <i>x</i> component for this <code>Vector</code>.
	 * @returns {Number} The current <i>x</i> coordinate.
	 * @see Core.Vector#setX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getX: function()
	{
		return this._x;
	},
	
	/**
	 * Set the value of the <i>x</i> component for this <code>Vector</code>.
	 * @param {Number} <i>x</i> The new <i>x</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Vector#getX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setX: function(x)
	{
		this._x = x;
		return this;
	},
	
	/**
	 * Retrieve the value of the <i>y</i> component for this <code>Vector</code>.
	 * @returns {Number} The current <i>y</i> coordinate.
	 * @see Core.Vector#setY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getY: function()
	{
		return this._y;
	},
	
	/**
	 * Set the value of the <i>y</i> component for this <code>Vector</code>.
	 * @param {Number} <i>y</i> The new <i>y</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Vector#getY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setY: function(y)
	{
		this._y = y;
		return this;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Point'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Point'] || {}; $MODULE_REGISTRY['NGCore/Shared/Point'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.Point = Class.subclass(
/** @lends Core.Point.prototype */
{
	classname: 'Point',
	
	/**
	 * @class The <code>Point</code> class defines a 2D point coordinate (<i>x</i> and <i>y</i>). 
	 * @status iOS, Android, Flash, Test
	 * @constructs The default constructor. <br><br>
	 * <b>Example:</b>The following code examples illustrate a variety of different calling styles for <code>Point</code> objects.<br><br>
	 * All components are set to zero.
	 * <pre class="code">var style1 = new Core.Point();</pre>
	 *
	 * Copy an existing point.
	 * <pre class="code">var style2 = new Core.Point(style1);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style3 = new Core.Point(1.0, 1.0);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style4 = new Core.Point([1.0, 1.0]);</pre>
	 * @augments Core.Class
	 * @param {Number} [x=0] The <i>x</i> coordinate.
	 * @param {Number} [y=0] The <i>y</i> coordinate.
	 * @throws {Wrong number of arguments for a Point} Number of parameters passed by this call is invalid.
	 */
	initialize: function(x, y)
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._x = 0;
				this._y = 0;
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._x = 0;
					this._y = 0;
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (point)
					this._x = rhs.getX();
					this._y = rhs.getY();
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._x = 0;
							this._y = 0;
							break;
						case 1:
							// ([point])
							rhs = rhs[0];
							this._x = rhs.getX();
							this._y = rhs.getY();
							break;
						case 2:
							// ([x, y])
							this._x = rhs[0];
							this._y = rhs[1];
							break;
						default:
							throw new Error('Wrong number of arguments for a Point');
					}
				}
				break;
			case 2:
				// (x, y)
				this._x = arguments[0];
				this._y = arguments[1];
				break;
			default:
				throw new Error('Wrong number of arguments for a Point');
		}
	},
	
	/**
	 * Set the value of both the <i>x</i> and <i>y</i> components. 
	 * @param {Number} [<i>x</i>=0] The new <i>x</i> coordinate.
	 * @param {Number} [<i>y</i>=0] The new <i>y</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Point for examples of supported calling styles.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAll: function(x, y)
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Duplicate this <code>Point</code>.
	 * @returns {Core.Point} A new point with identical <i>x</i> and <i>y</i> coordinates to the cloned point.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the value of the <i>x</i> component of this <code>Point</code>.
	 * @returns {Number} The current <i>x</i> coordinate.
	 * @see Core.Point#setX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getX: function()
	{
		return this._x;
	},
	
	/**
	 * Set the value of the <i>x</i> component for this <code>Point</code>.
	 * @param {Number} <i>x</i> The new <i>x</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Point#getX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setX: function(x)
	{
		this._x = x;
		return this;
	},
	
	/**
	 * Retrieve the value of the <i>y</i> component of this <code>Point</code>.
	 * @returns {Number} The current <i>y</i> coordinate.
	 * @see Core.Point#setY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getY: function()
	{
		return this._y;
	},
	
	/**
	 * Set the value of the <i>y</i> component for this <code>Point</code>.
	 * @param {Number} <i>y</i> The new <i>y</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Point#getY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setY: function(y)
	{
		this._y = y;
		return this;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Size'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Size'] || {}; $MODULE_REGISTRY['NGCore/Shared/Size'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.Size = Class.subclass(
/** @lends Core.Size.prototype */
{
	classname: 'Size',
	
	/**
	 * @class The <code>Size</code> class constructs objects that define size values for the <i>height</i> and <i>width</i> components. 
	 * @status iOS, Android, Flash
	 * Supported values range between <code>(0-1)</code>.
	 * @constructs The default constructor. <br><br>
	 * The following code examples illustrate a variety of different calling styles for <code>Size</code> objects.<br><br>
	 * Set both component values to 0.
	 * <pre class="code">var style1 = new Core.Size();</pre>
	 *
	 * Copy an existing size.
	 * <pre class="code">var style2 = new Core.Size(style1);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style3 = new Core.Size(1.0, 1.0);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style4 = new Core.Size([1.0, 1.0]);</pre>
	 * @augments Core.Class
	 * @param {Number} [width=0] The <i>width</i> component.
	 * @param {Number} [height=0] The <i>height</i> component.
	 */
	initialize: function(width, height)
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._width = 0;
				this._height = 0;
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._width = 0;
					this._height = 0;
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (size)
					this._width = rhs.getWidth();
					this._height = rhs.getHeight();
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._width = 0;
							this._height = 0;
							break;
						case 1:
							// ([size])
							rhs = rhs[0];
							this._width = rhs.getWidth();
							this._height = rhs.getHeight();
							break;
						case 2:
							// ([x, y])
							this._width = rhs[0];
							this._height = rhs[1];
							break;
						default:
							throw new Error('Wrong number of arguments for a Size');
					}
				}
				break;
			case 2:
				// (x, y)
				this._width = arguments[0];
				this._height = arguments[1];
				break;
			default:
				throw new Error('Wrong number of arguments for a Size');
		}
	},
	
	/**
	 * Set the value of all components for this <code>Size</code>. 
	 * @param {Number} [width=0] The new <i>width</i>.
	 * @param {Number} [height=0] The new <i>height</i>.
	 * @throws {Wrong number of arguments for a Size} Number of parameters passed by this call is invalid.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Size for examples of supported calling styles.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAll: function(width, height)
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Duplicate this <code>Size</code>.
	 * @returns {Core.Size} A new size with identical <i>height</i> and <i>width</i> components.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the value of the <i>width</i> component for this <code>Size</code>.
	 * @returns {Number} The current <i>width</i>.
	 * @see Core.Size#setWidth
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getWidth: function()
	{
		return this._width;
	},
	
	/**
	 * Set the value of the <i>width</i> component for this <code>Size</code>.
	 * @param {Number} width The new <i>width</i>.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Size#getWidth
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setWidth: function(width)
	{
		this._width = width;
		return this;
	},
	
	/**
	 * Retrieve the value of the <i>height</i> component for this <code>Size</code>.
	 * @returns {Number} The current <i>height</i>.
	 * @see Core.Size#setHeight
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getHeight: function()
	{
		return this._height;
	},
	
	/**
	 * Set the value of the <i>height</i> component for this <code>Size</code>.
	 * @param {Number} height The new <i>height</i>.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Size#getHeight
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setHeight: function(height)
	{
		this._height = height;
		return this;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Rect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Rect'] || {}; $MODULE_REGISTRY['NGCore/Shared/Rect'] = exports; var Class = require('NGCore/Shared/Class').Class;
var Point = require('NGCore/Shared/Point').Point;
var Size = require('NGCore/Shared/Size').Size;

exports.Rect = Class.subclass(
/** @lends Core.Rect.prototype */
{
	classname: 'Rect',
	
	/**
	 * @class The <code>Rect</code> class constructs a rectangle object that is derived from two values: a point of origin  
	 * and a size.	 
	 * @status iOS, Android, Flash
	 * @constructs The default constructor. <br><br>
	 * The following code examples illustrate a variety of different calling styles for <code>Rect</code> objects.<br><br>
	 * All components set to zero.
	 * <pre class="code">var style1 = new Core.Rect();</pre>
	 *
	 * Copy an existing <code>rect</code>.
	 * <pre class="code">var style2 = new Core.Rect(style1);</pre>
	 *
	 * Specify a point and size.
	 * <pre class="code">var style3 = new Core.Rect(new Core.Point(), new Core.Size());</pre>
	 *
	 * Specify four components.
	 * <pre class="code">var style4 = new Core.Rect(0, 0, 100, 100);</pre>
	 * @augments Core.Class
	 * @param {Core.Point} [origin=0] The rectangle point of origin.
	 * @param {Core.Size} [size=0] The rectangle size.
	 * @throws {Wrong number of arguments for a Rect} Number of parameters passed by this call is invalid.
	 */
	initialize: function(origin, size)
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._origin = new Point();
				this._size = new Size();
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._origin = new Point();
					this._size = new Size();
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (rect)
					this._origin = new Point(rhs.getOrigin());
					this._size = new Size(rhs.getSize());
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._origin = new Point();
							this._size = new Size();
							break;
						case 1:
							// ([rect])
							rhs = rhs[0];
							this._origin = new Point(rhs.getOrigin());
							this._size = new Size(rhs.getSize());
							break;
						case 2:
							// ([point, size])
							// ([[x, y], [width, height]])
							this._origin = new Point(rhs[0]);
							this._size = new Size(rhs[1]);
							break;
						case 4:
							// ([x, y, width, height])
							this._origin = new Point(rhs[0], rhs[1]);
							this._size = new Size(rhs[2], rhs[3]);
							break;
						default:
							throw new Error('Wrong number of arguments for a Rect');
					}
				}
				break;
			case 2:
				// (point, size)
				this._origin = new Point(arguments[0]);
				this._size = new Size(arguments[1]);
				break;
			case 4:
				// (x, y, width, height)
				this._origin = new Point(arguments[0], arguments[1]);
				this._size = new Size(arguments[2], arguments[3]);
				break;
			default:
				throw new Error('Wrong number of arguments for a Rect');
		}
	},
	
	/**
	 * Set the value of all components for this <code>rect</code>. 
	 * @param {Core.Point} [origin=0] The new point of origin.
	 * @param {Core.Size} [size=0] The new rectangle size.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect for examples of supported calling styles.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAll: function(origin, size)
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Duplicate the point of origin of this <code>rect</code>.
	 * @returns {Core.Point} A new rectangle with an identical origin and size.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the point of origin for this <code>rect</code>.
	 * @returns {Core.Point} The current point of origin.
	 * @see Core.Rect#setOrigin
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getOrigin: function()
	{
		return this._origin;
	},
	
	/**
	 * Set the point of origin for this <code>rect</code>.
	 * @param {Core.Point} origin The new point of origin.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect#getOrigin
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setOrigin: function(origin)
	{
		this._origin.setAll(origin);
		return this;
	},
	
	/**
	 * Change the point of origin so that the center of this <code>rect</code> is at the specified location.
	 * @param {Core.Point} origin The new point of origin that results in a rectangle with a center position at the specified location.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect#setSizeCentered,
	 * @see Core.Rect#setOrigin
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setOriginCentered: function(origin)
	{
		origin = new Core.Point(origin);
		this._origin.setX(origin.getX() - this._size.getWidth()/2);
		this._origin.setY(origin.getY() - this._size.getHeight()/2);
		return this;
	},
	
	/**
	 * Retrieve the size of this <code>rect</code>.
	 * @returns {Core.Size} The current rectangle size.
	 * @see Core.Rect#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSize: function()
	{
		return this._size;
	},
	
	/**
	 * Set the size of this <code>rect</code>.
	 * @param {Core.Size} size The new rectangle size.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect#getSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setSize: function(size)
	{
		this._size.setAll(size);
		return this;
	},
	
	/**
	 * Set the size of this <code>rect</code> and preserve the current center position.
	 * @param {Core.Size} size The new rectangle size that retains the current center position.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect#setOriginCentered,
	 * @see Core.Rect#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setSizeCentered: function(size)
	{
		var oldWidth = this._size.getWidth();
		var oldHeight = this._size.getHeight();
		
		this._size.setAll(size);

		this._origin.setX(this._origin.getX() + oldWidth/2 - this._size.getWidth()/2);
		this._origin.setY(this._origin.getY() + oldHeight/2 - this._size.getHeight()/2);
		return this;
	},
	
	/**
	 * Retrieve the minimum value for <i>x</i>. This is represented by the left coordinate.
	 * @returns {Number} The current minimum value of  the <i>x</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMinX: function()
	{
		return this._origin.getX();
	},
	
	/**
	 * Retrieve the average of the minimum and maximum <i>x</i> values. This is the middle coordinate.
	 * @returns {Number} The current average of the minimum and maximum <i>x</i> coordinate values. 
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMidX: function()
	{
		return this._origin.getX() +  this._size.getWidth()/2;
	},
	
	/**
	 * Retrieve the maximum value for <i>x</i>. This is the right coordinate.
	 * @returns {Number} The current maximum value of the <i>x</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMaxX: function()
	{
		return this._origin.getX() + this._size.getWidth();
	},
	
	/**
	 * Retrieve the minimum value for <i>y</i>. This is the top coordinate.
	 * @returns {Number} The current minimum value of the <i>y</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMinY: function()
	{
		return this._origin.getY();
	},
	
	/**
	 * Retrieve the average of the minimum and maximum <i>y</i> values. This is the middle coordinate.
	 * @returns {Number} The current average of the minimum and maximum <i>y</i> coordinate values.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMidY: function()
	{
		return this._origin.getY() + this._size.getHeight()/2;
	},
	
	/**
	 * Retrieve the maximum value for <i>y</i>. This is the bottom coordinate.
	 * @returns {Number} The current maximum value of the <i>y</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMaxY: function()
	{
		return this._origin.getY() + this._size.getHeight();
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/AbstractView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/AbstractView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/AbstractView'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Rect = require('NGCore/Client/UI/ViewGeometry').Rect;

var AbstractView = exports.AbstractView = Element.subclass(
/** @lends UI.AbstractView.prototype */
{
	'type':'<com.ngmoco.view.abstract>',
	/**
	* @class The <code>AbstractView</code> class is a base class for derived classes that handle and manage application views.<br><br>
	* <b>Caution!:</b> This base class is not exported in the UI module. Do not access it or subclass it at runtime. 
	* Derived classes from <code>AbstractView</code> include:
	* <div class="ul">
	 * <li>{@link UI.Button}</li>
	 * <li>{@link UI.CellView}</li>
	 * <li>{@link UI.CheckBox}</li>
	 * <li>{@link UI.CheckoutView}</li>
	 * <li>{@link UI.DocumentView}</li>
	 * <li>{@link UI.EditText}</li>
	 * <li>{@link UI.GLView}</li>
	 * <li>{@link UI.Image}</li>
	 * <li>{@link UI.Label}</li>
	 * <li>{@link UI.Spinner}</li>
	 * <li>{@link UI.View}</li>
	 * <li>{@link UI.WebView}</li>
	 * </div>
	* @constructs The default constructor.
	* @augments UI.Element
	* @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	* @param {String} properties Object properties.
	*/
	initialize: function($super, properties) {
		if (AbstractView._init) AbstractView._init();
		
		this._assignedVisible = true;
		$super(properties);
	},
	
	/** @private */
	destroy: function($super){
		this.removeFromParent();
		$super();
	},
	
	/**
	 * @function 
	 * @description Retrieve the parent node for this view.
	 * @returns Returns the parent if this view is a child of another element. Otherwise, returns undefined.
	 * @see UI.AbstractView#addToParent,
	 * @see UI.AbstractView#removeFromParent
	 */    
	getParent: function(){
		return this._parent;
	},
    
	/**
	 * Add a node at the specified index to the specified parent node.
	 * @example var myParent = new UI.View({
	 * 	...
	 * });
	 * var childNode = new UI.View({
	 *	...
	 * });
	 * ...
	 * childNode.addToParent(myParent); 
	 * @function
	 * @param {Object} parentNode The parent node.
	 * @param {Number} [index] The parent node index location.
	 * @see UI.AbstractView#getParent,
	 * @see UI.AbstractView#removeFromParent
	 */    
	addToParent: function(parentNode, index){
		parentNode.addChild(this, index);
	},
    
	/**
	 * Remove a node from the parent node.
	 * @example childNode.removeFromParent(myParent);
	 * @function 
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see UI.AbstractView#getParent,
	 * @see UI.AbstractView#addToParent
	 */    
	removeFromParent: function(){
		if (this._parent && !this._parent._destroyed) {
			this._parent.removeChild(this);
			this._parent = null;
		}
		return this;
	},
	
	
	/**
	 * Add a new view state.
	 * @function 
	 * @example this.addState(UI.State.Disabled);
	 * @param {UI.State} flags View state flags supported by the new view state.
	 * @see UI.AbstractView#getState,
	 * @see UI.AbstractView#setState,
	 * @see UI.AbstractView#clearState
	 */  
	addState: function(flags) {
		this.setState(this._state | flags);
	},
	
	/**
	 * Clear the view state and set view state flags to the default value.
	 * @function 
	 * @example this.clearState(UI.State.Disabled);
	 * @param {UI.State} flags
	 * @see UI.AbstractView#getState,
	 * @see UI.AbstractView#setState,
	 * @see UI.AbstractView#addState
	 */  
	clearState: function(flags) {
		this.setState(this._state & ~flags);
	},
    
	/**
	 * Retrieve the root node for this object.
	 * @function 
	 * @returns Returns the root node if this is a child node. Otherwise, returns undefined.
	 */
	getRoot: function() {
		return this._parent ? this._parent.getRoot() : undefined;
	},
    

	/** @protected */
	_setVisible: function(makeVisible) {
		var willBeVisible = makeVisible && this._assignedVisible && this._parent && this._parent._visible;
		if (this._visible != willBeVisible) {
			this._visible = willBeVisible;
			var fn = (makeVisible ? this.getOnAppear() : this.getOnDisappear());
			if (typeof fn == 'function') fn.call(this);
		}
	}
});

// Properties
AbstractView._init = function() {
	delete AbstractView._init;
	if (Element._init) Element._init();
	
	var getVisible = function() {
		return this._visible;
	};
	var setVisible = function(makeVisible) {
		this._assignedVisible = makeVisible;
		Commands.setIsVisible.call(this, makeVisible);
		this._setVisible(makeVisible);
	};
	/**
	 * @name UI.AbstractView#setVisible
	 * @description Set the visibility for this object.
	 * @example SomeView = new UI.View();
	 * ...
	 * SomeView.setVisible(true);
	 * @function 
	 * @param {boolean} makeVisible Set as <code>true</code> if this object is visible.
	 * @see UI.AbstractView#getVisible
	 */
	/**
	 * @name UI.AbstractView#getVisible
	 * @description Retrieve the state of visibility for this object.
	 * @function
	 * @returns {boolean} Returns <code>true</code> if this object is visible.
	 * @see UI.AbstractView#setVisible
	 */
	AbstractView.registerAccessors('visible', getVisible, setVisible);
	
	/**
	 * @name UI.AbstractView#setBackgroundColor
	 * @description Set the value for the <code>backgroundColor</code> property. This property defines the color of the background for an object when rendered.
	 * @example SomeView = new UI.View();
	 * ...
	 * SomeView.setBackgroundColor("FF000000");
	 * @param {String} backgroundColor The new background color.
	 * @see UI.AbstractView#getBackgroundColor
	 * @type Color
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getBackgroundColor
	 * @description Retrieve the value of the <code>backgroundColor</code> property.
	 * @returns {String} The current background color.
	 * @see UI.AbstractView#setBackgroundColor
	 * @function
	 */
	AbstractView.synthesizeProperty('backgroundColor', Commands.setBackgroundColor);
	/**
	 * @name UI.AbstractView#setEnabled
	 * @description Set the value for the <code>enabled</code> property. This property defines an object as active or inactive.
	 * @param {Boolean} enabled Set as <code>true</code> if this view state is enabled.
	 * @see UI.AbstractView#getEnabled
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getEnabled
	 * @description Retrieve the value of the <code>enabled</code> property. 
	 * @returns {Boolean} Returns <code>true</code> if this view state is enabled.
	 * @see UI.AbstractView#setEnabled
	 * @function
	 */
	
	AbstractView.synthesizeProperty('enabled', function(enable) {
		this[ (enable ? 'clearState' : 'setState') ](Commands.State.Disabled);
	});
	/**
	 * @name UI.AbstractView#setState
	 * @description Set the value for the <code>state</code> property. This property defines the view state for an object.
	 * @example cellView.setState(UI.State.Normal);
	 * @param {Number} state The new view state.
	 * @see UI.AbstractView#getState
	 * @type State
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getState
	 * @description Retrieve the value of the <code>state</code> property.
	 * @returns {Number} The current view state.
	 * @see UI.AbstractView#setState
	 * @function
	 */
	AbstractView.synthesizeProperty('state', Commands.setState);

	
	/**
	 * @name UI.AbstractView#getFrame
	 * @description Retrieve the value of the <code>frame</code> property.
	 * @param {Number, Array (Number)} frame Individual components or a component array (<i>x</i>,<i>y</i>,<i>w</i>,<i>h</i>).
	 * @see UI.AbstractView#setFrame
	 * @function
	 */
	var getFrame = function() {
		return this._frame;
	};
	/**
	 * @name UI.AbstractView#setFrame
	 * @function 
	 * @description Set the value of the <code>frame</code> property. This property defines the size of <code>frame</code> objects.
	 * @example var back = new UI.Button();
	 * ...
	 * back.setFrame([10, 10, 64, 64]);
	 * @param {Number, Array (Number), Object} arg0 This parameter will pass in values in one of three ways:
	 * <div class="ul">
	 * <li>Four float values (<i>x</i>, <i>y</i>, <i>w</i>, <i>h</i>).</li>
	 * <li>Single array containing the above four values.</li>
	 * <li>A rect specifying the frame (see <code>{@link UI.ViewGeometry.Rect}</code>).</li>
	 * </div>
	 * @see UI.AbstractView#getFrame
	 * @function
	 */
	var setFrame = function(arg0) {
		if( arg0 instanceof Rect ){
			this._frame = arg0.array();
		}
		else if( arg0 instanceof Array ){
			this._frame = arg0;
		}
		else {
			this._frame = Array.prototype.slice.call(arguments);
		}
		Commands.setFrame.apply(this, this._frame);
	};
	AbstractView.registerAccessors('frame', getFrame, setFrame);

	/**
	 * @name UI.AbstractView#setGradient
	 * @description Set the value of the <code>gradient</code> property for a view state. This property defines an image gradient for the object when rendered.
	 * @example label.setGradient({
	 *	corners: '11 11 11 11',
	 *	gradient: ['FFFF8000 0.0', 'FF703300 1.0']
	 * }, UI.State.Selected);
	 * @param {Object} gradient The new gradient. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.AbstractView#getGradient
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getGradient
	 * @description Retrieve the value of the <code>gradient</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current gradient.
	 * @see UI.AbstractView#setGradient
	 * @function	
	 */
	AbstractView.synthesizePropertyWithState('gradient', Commands.setGradient);	
	/**
	 * @name UI.AbstractView#setBlockTouchEvents
	 * @description Set the value of the <code>blockTouchEvents</code> property.
	 * @param {Object} blockTouchEvents The new value for <code>blockTouchEvents</code>.
	 * @see UI.View#getBlockTouchEvents
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getBlockTouchEvents
	 * @description Retrieve the value of the <code>blockTouchEvents</code> property.
	 * @returns {Object} The current value of <code>blockTouchEvents</code>.
	 * @see UI.View#setBlockTouchEvents
	 * @function
	 */
	AbstractView.synthesizeProperty('touchable', Commands.setTouchable);
	/**
	 * @name UI.AbstractView#setAlpha
	 * @function
	 * @description Set the value of the <code>alpha</code> property. This property defines the level of alpha composting for a specified object when rendered.
	 * @example this._node.setAlpha(1);
	 * @param {Number} decimal Alpha value ranging between <code>(0.0-1.0)</code>.
	 * @see UI.AbstractView#getAlpha
	 * @type Float
	 * @status iOS
	 */
	/**
	 * @name UI.AbstractView#getAlpha
	 * @function
	 * @description Retrieve the value of the <code>alpha</code> property.
	 * @returns {Number} Alpha value ranging between </code>(0.0-1.0)</code>.
	 * @see UI.AbstractView#setAlpha
	 * @type Float
	 * @status
	 */
	AbstractView.synthesizeProperty('alpha', Commands.setAlpha);




	// Event Handlers
	/**
	 * @name UI.AbstractView#setOnAppear
	 * @description Set a function to call when the <code>appear</code> event occurs.
	 * @param {Function} appearCallback The new callback function. <br><br><b>Note:</b> The <code>appear</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onAppear.appear = true; 
	 * };
	 * @see UI.AbstractView#event:getOnAppear
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnAppear
	 * @description Retrieve the function to call when the <code>appear</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnAppear
	 * @event
	 */
	AbstractView.registerEventType('appear');
	/**
	 * @name UI.AbstractView#setOnDisappear
	 * @description Set a function to call when the <code>disappear</code> event occurs.
	 * @param {Function} disappearCallback The new callback function. <br><br><b>Note:</b> The <code>disappear</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onDisappear.disappear = true; 
	 * };
	 * @see UI.AbstractView#event:getOnDisappear
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnDisappear
	 * @description Retrieve a function to call when the <code>disappear</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnDisappear
	 * @event
	 */
	AbstractView.registerEventType('disappear');
	/**
	 * @name UI.AbstractView#setOnClick
	 * @description Set a function to call when the <code>click</code> event occurs.
	 * @param {Function} clickCallback The new callback function. <br><br><b>Note:</b> The <code>click</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onClick.clicked = true; 
	 * };
	 * @see UI.AbstractView#event:getOnClick
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnClick
	 * @description Retrieve a function to call when the <code>click</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnClick
	 * @event
	 */
	AbstractView.registerEventType('click');
	/**
	 * @name UI.AbstractView#setOnSwipe
	 * @description Set a function to call when a <code>swipe</code> event occurs. 
	 * This is when the user swipes a finger across this view, similar to how a user indicatea a "delete row"
	 * request on a table view.  The function gets the <code>UI.Commands.SwipeDirection</code> from 
	 * the first <code>parameter.direction</code>.  
	 * @example
	 * view.setOnSwipe( function(params) { 
	 *	NgLogD("swipe code "+params.direction) 
	 *   } 
	 * );
	 * @param {Function} clickCallback The new callback function. <br><br><b>Note:</b> The <code>swipe</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.AbstractView#event:getOnSwipe
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnSwipe
	 * @description Retrieve a function to call when the <code>swipe</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnSwipe
	 * @event
	 */
	AbstractView.registerEventType('swipe');
	/**
	 * @name UI.AbstractView#setOnLongPress
	 * @description Set a function to call when a user taps and holds on a view. 
	 * @param {Function} clickCallback The new callback function. <br><br><b>Note:</b> The event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onLongPress.longpress = true; 
	 * };
	 * @see UI.AbstractView#event:getOnLongPress
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnLongPress
	 * @description Retrieve a function to call when a <code>tap and hold</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnLongPress
	 * @event
	 */
	AbstractView.registerEventType('longPress');

	/** @private NOT IMPLEMENTED */
	/*
		AbstractView.registerEventType('touchdown');
		AbstractView.registerEventType('touchup');
		AbstractView.registerEventType('touchmove');
		AbstractView.registerEventType('touchcancel');
	*/
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/WindowLayer'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/WindowLayer'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/WindowLayer'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var ViewParent = require('NGCore/Client/UI/ViewParent').ViewParent;
var Commands = require('NGCore/Client/UI/Commands').Commands;

/** @private
 * 	This ENTIRE CLASS is private.
 */
var WindowLayer = exports.WindowLayer = Element.subclass( {
	'type':'windowlayer',
	initialize: function($super, props) {
		if (WindowLayer.init) WindowLayer.init();
		$super(props);
		if (WindowLayer._init) WindowLayer._init();
		ViewParent.initialize.call(this);
		this._visible = true;
	},
	getRoot: function(){
		return this;
	},
	getParent: function(){
		return undefined;
	},
	
	getChildCount: ViewParent.getChildCount,
	getChildren: ViewParent.getChildren,
	addChild: ViewParent.addChild,
	removeChild: ViewParent.removeChild
});

WindowLayer.init = function() {
	delete WindowLayer._init;
	if (Element._init) Element._init();
	
	WindowLayer.synthesizeProperty('level', Commands.setIntValue);
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ViewParent'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ViewParent'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ViewParent'] = exports; var Commands = require('NGCore/Client/UI/Commands').Commands;
var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;

// CAREFUL! THIS IS NOT A CLASS!
exports.ViewParent = {
	initialize : function() {
		this._children = [];
	},

	getChildCount : function() {
		return this._children.length;
	},

	getChildren : function() {
		return this._children.slice();
	},

	addChild : function(childNode,index) {
		if (childNode === this) throw new Error("Cannot add " + childNode + " as a child of itself!");
		if (childNode instanceof AbstractView) {
			if (childNode._parent) childNode.removeFromParent();

			if (index === 0 || index > 0) {
				index = +index;
				this._children.splice(index, 0, childNode);
			} else {
				index = -1;
				this._children.push(childNode);
			}

			// Must populate parent before setting visibility
			childNode._parent = this;
			childNode._setVisible(this._visible);

			Commands.addSubview.call(this, childNode.__objectRegistryId, index);

		} else throw new Error(this.type + ".addChild: " + childNode + " is not a view!");
		return this;
	},

	removeChild : function(childNode) {
		if (childNode instanceof AbstractView) {
			if (childNode._parent == this) {
				childNode._setVisible(false);

				// Remove this node from parent's child list
				var nodeIndex = this._children.indexOf(childNode);
				if (nodeIndex != -1) {
					this._children.splice(nodeIndex, 1);
				}
			}
			// Clear parent value
			childNode._parent = undefined;

			// Remove from the parent at the system level
			Commands.removeFromSuperview.call(childNode);
		} else throw {message: this.type + ".removeChild: " + childNode + " is not a view!"};
		return childNode;
	}

};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2'] = exports; /**
 * <p>Classes and objects contained by the GL2 module.</p>
 * @name GL2
 * @namespace
 * @description <p>The GL2 module is a collection of classes that support manipulation of visual effects and frameworks in an application.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 * <ul>
 * <li><code>{@link GL2.Animation}</code>: Control animations in applications.</li>
 * <li><code>{@link GL2.Node}</code>: Control positionable screen elements.</li>
 * <li><code>{@link GL2.Primitive}</code>: Control the drawing of arbitrary vertex-based geometry.</li>
 * <li><code>{@link GL2.Root}</code>: A singleton that acts as a proxy object for the GLView node hierarchy 
 * (<code>Root</code> is the root element of the node hierarchy for GL2View).</li>
 * <li><code>{@link GL2.Sprite}</code>: Control resources for and use of application sprites.</li>
 * <li><code>{@link GL2.Text}</code>: Control resources for and use of application text.</li>
 * <li><code>{@link GL2.Touch}</code>: Control objects that track touch events for a device.</li>
 * <li><code>{@link GL2.TouchTarget}</code>: Control objects that support physical touch events on a device.</li>
 * <li><code>{@link GL2.RenderTarget}</code>: Render GL2 Nodes into a texture, which can then be attached to a GL.Animation</li>
 * </ul>
 * Games must instantiate a {@link UI.GLView} object, set the active state to <code>true</code> and wait for the callback before instantiating any objects in the GL2 class.
 */
exports.GL2 = {};

exports.GL2.__defineGetter__("Animation", function() {
	delete this.Animation;
	return this.Animation = require('NGCore/Client/GL2/Animation').Animation;
});
exports.GL2.__defineGetter__("Node", function() {
	delete this.Node;
	return this.Node = require('NGCore/Client/GL2/Node').Node;
});
exports.GL2.__defineGetter__("Primitive", function() {
	delete this.Primitive;
	return this.Primitive = require('NGCore/Client/GL2/Primitive').Primitive;
});
exports.GL2.__defineGetter__("Touch", function() {
	delete this.Touch;
	return this.Touch = require('NGCore/Client/GL2/Touch').Touch;
});
exports.GL2.__defineGetter__("TouchTarget", function() {
	delete this.TouchTarget;
	return this.TouchTarget = require('NGCore/Client/GL2/TouchTarget').TouchTarget;
});
exports.GL2.__defineGetter__("Root", function() {
	delete this.Root;
	return this.Root = require('NGCore/Client/GL2/Root').Root;
});
exports.GL2.__defineGetter__("Sprite", function() {
	delete this.Sprite;
	return this.Sprite = require('NGCore/Client/GL2/Sprite').Sprite;
});
exports.GL2.__defineGetter__("Text", function() {
	delete this.Text;
	return this.Text = require('NGCore/Client/GL2/Text').Text;
});
exports.GL2.__defineGetter__("RenderTarget", function() {
	delete this.RenderTarget;
	return this.RenderTarget = require('NGCore/Client/GL2/RenderTarget').RenderTarget;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Bank'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Bank'] || {}; $MODULE_REGISTRY['NGCore/Client/Bank'] = exports; 

exports.Bank = require('NGCore/Client/Social/US/Service/Bank').Bank;; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2'] = exports; /**
 * <p>Classes and objects contained by the Physics2 module.</p>
 * @name Physics2
 * @namespace
 * @description <p>The Physics2 module is a collection of classes that control physics interaction between application bodies.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 * <ul>
 * <li><code>{@link Physics2.Body}</code>: Construct objects that support physics interaction with other <code>Body</code> objects.</li>
 * <li><code>{@link Physics2.BoxShape}</code>: Construct a box collision shape.</li>
 * <li><code>{@link Physics2.CircleShape}</code>: Construct a circle collision shape.</li>
 * <li><code>{@link Physics2.Contact}</code>: Construct objects that store information about contact between two bodies.</li>
 * <li><code>{@link Physics2.DistanceJoint}</code>: Construct a distance joint that restricts the distance between two bodies.</li>
 * <li><code>{@link Physics2.Joint}</code>: A base class object for constructing <code>joint</code> objects.</li>
 * <li><code>{@link Physics2.MouseJoint}</code>: Construct a mouse joint that applies force at a specific location.</li>
 * <li><code>{@link Physics2.PolygonShape}</code>: Construct a polygon collision shape.</li>
 * <li><code>{@link Physics2.PrismaticJoint}</code>: Construct a prismatic joint that confines movement of two bodies along a specific axis.</li>
 * <li><code>{@link Physics2.Shape}</code>: A base class object for constructing <code>shape</code> objects.</li>
 * <li><code>{@link Physics2.WeldJoint}</code>: Construct a weld joint that holds two bodies completely stationary relative to each other.</li>
 * <li><code>{@link Physics2.World}</code>: Construct a physics world that contains bodies and allows simulation stepping.</li>
 * </ul>
 */
var Physics2 = exports.Physics2 = {};

Physics2.__defineGetter__("Body", function() {
	delete this.Body;
	return this.Body = require('NGCore/Client/Physics2/Body').Body;
});
Physics2.__defineGetter__("BoxShape", function() {
	delete this.BoxShape;
	return this.BoxShape = require('NGCore/Client/Physics2/BoxShape').BoxShape;
});
Physics2.__defineGetter__("CircleShape", function() {
	delete this.CircleShape;
	return this.CircleShape = require('NGCore/Client/Physics2/CircleShape').CircleShape;
});
Physics2.__defineGetter__("PolygonShape", function() {
	delete this.PolygonShape;
	return this.PolygonShape = require('NGCore/Client/Physics2/PolygonShape').PolygonShape;
});
Physics2.__defineGetter__("Shape", function() {
	delete this.Shape;
	return this.Shape = require('NGCore/Client/Physics2/Shape').Shape;
});
Physics2.__defineGetter__("World", function() {
	delete this.World;
	return this.World = require('NGCore/Client/Physics2/World').World;
});
Physics2.__defineGetter__("Joint", function() {
	delete this.Joint;
	return this.Joint = require('NGCore/Client/Physics2/Joint').Joint;
});
Physics2.__defineGetter__("DistanceJoint", function() {
	delete this.DistanceJoint;
	return this.DistanceJoint = require('NGCore/Client/Physics2/DistanceJoint').DistanceJoint;
});
Physics2.__defineGetter__("MouseJoint", function() {
	delete this.MouseJoint;
	return this.MouseJoint = require('NGCore/Client/Physics2/MouseJoint').MouseJoint;
});
Physics2.__defineGetter__("PrismaticJoint", function() {
	delete this.PrismaticJoint;
	return this.PrismaticJoint = require('NGCore/Client/Physics2/PrismaticJoint').PrismaticJoint;
});
Physics2.__defineGetter__("RevoluteJoint", function() {
	delete this.RevoluteJoint;
	return this.RevoluteJoint = require('NGCore/Client/Physics2/RevoluteJoint').RevoluteJoint;
});
Physics2.__defineGetter__("WeldJoint", function() {
	delete this.WeldJoint;
	return this.WeldJoint = require('NGCore/Client/Physics2/WeldJoint').WeldJoint;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGcore/Client/Storage/FileSystem'] = function(){var exports = $MODULE_REGISTRY['NGcore/Client/Storage/FileSystem'] || {}; $MODULE_REGISTRY['NGcore/Client/Storage/FileSystem'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class FileSystem
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var ObjectRegistry = require('NGcore/Client/Core/ObjectRegistry').ObjectRegistry;
var Class = require('NGcore/Client/Core/Class').Class;

////////////////////////////////////////////////////////////////////////////////

exports.FileSystem = Class.singleton(
/** @lends Storage.FileSystem.prototype */
{
	classname: 'FileSystem',
	
	/**
	 * @class The <code>FileSystem</code> class constructs a singleton object that controls file manipulation tasks: reading, writing, deleting, or decompressing a file.
	 * 
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */
	initialize: function()
	{
		/** @private */
		this.readRequests = {};
		/** @private */
		this.writeRequests = {};
		/** @private */
		this.cbIdCounter = 1;
		
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	/**
	 * Read a file into memory from local storage.
	 * @example FileSys.readFile(SomeFile, true, function(err, data){...}
	 * @param {String} fname The name of the file to read into memory.
	 * @param {Boolean} [binary=false] Set as <code>true</code> if <code>readFile()</code> shouuld conduct a binary read.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file read operation fails.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	readFile: function( fname, binary, cb )
	{
		this.readFileIn(this.Store.Local, fname, binary, cb);
	},

	/**
	 * @private
	 *	read a file from a common store on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location to read from
	 *	@param {fname} The name of the file to be read
	 *	@param {cb} The callback function to be called
	 *	@param {binary} binary mode or not
     *  @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	readFileIn: function( store, fname, binary, cb )
	{
		var cbId = 0;

		if(typeof(binary) == 'function')
		{
			cb = binary;
			binary = false;
		}
		binary = binary || false;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.readRequests[ cbId ] = cb;
		}
		this._readFileSendGen(cbId,store,fname,binary);
	},

	/**
	 * Write a file to local storage.
	 * @example FileSys.writeFile(SomeFile, someData, true, (function(){...});
	 * @param {String} fname The name of the file to write into storage.
	 * @param {Binary, String} data The data to write to the file.
	 * @param {Boolean} [binary=false] Set as <code>true</code> if <code>writeFile()</code> should conduct a binary write.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file write operation fails.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	writeFile: function( fname, data, binary, cb )
	{
		this.writeFileIn(this.Store.Local, fname, data, binary, cb);
	},

	/**
	 * @private
	 *	write a file to a common store on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location to write to
	 *	@param {fname} The name of the file to be written
	 *	@param {cb} The callback function to be called after completion
	 *	@param {binary} binary mode or not
     *  @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	writeFileIn: function( store, fname, data, binary, cb )
	{
		var cbId = 0;

		if(typeof(binary) == 'function')
		{
			cb = binary;
			binary = false;
		}
		binary = binary || false;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.writeRequests[ cbId ] = cb;
		}

		this._writeFileSendGen(cbId,store,fname,data,binary);
	},

	/**
	 * Delete a file from local storage.
	 * @example FileSys.deleteFile(SomeFile,function(err, data){});
	 * @param {String} fname The name of the file to delete.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file delete operation fails.
     * @status iOS, Android, Test, iOSTested, AndroidTested     
	 */
	deleteFile: function ( fname, cb )
	{
		this.deleteFileIn(this.Store.Local, fname, cb);
	},

	/**
	 * @private
	 *	delete a file from a common store on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location path
	 *	@param {fname} The name of the file to be deleted
	 *	@param {cb} The callback function to be called
     *  @status iOS, Android, Test, iOSTested, AndroidTested     
	 */
	deleteFileIn: function ( store, fname, cb )
	{
		var cbId = 0;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.writeRequests[ cbId ] = cb;
		}
		this._deleteFileSendGen(cbId,store,fname);
	},
	
	/**
	 * Decompress a zipfile.
	 * @example FileSys.readFile(SomeFile, ./some/path/to/destination/, true, function(err, data){...}
	 * @param {String} fname The name of the zipfile to decompress.
	 * @param {String} destination The directory path where the contents of the decompressed file are written.
	 * @param {Boolean} [returnFiles] Set as <code>true</code> if <code>decompressFile()</code> should return a list of files contained in the zipfile specified by the <code>fname</code> parameter.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file decompress operation fails.
     * @status iOS, Android
	 */
	decompressFile: function( fname, destination, returnFiles, cb )
	{
		this.decompressFileIn(this.Store.Local, fname, destination, returnFiles, cb);
	},
	
	/**
	 * @private
	 *	decompress a file to a shared location on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location path
	 *	@param {fname} The name of the file to be read
	 *	@param {cb} The callback function to be called
	 *	@param {destination} destination location to unzip files to
	 *	@param {returnFiles} true/false if true it returns a json object with a list of each file, its MD5 hash and its size
     *  @status iOS, Android    
	 */
	decompressFileIn: function( store, fname, destination, returnFiles, cb )
	{
		var cbId = 0;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.writeRequests[ cbId ] = cb;
		}
		this._decompressFileSendGen(cbId,store,fname,destination,returnFiles);
	},
	
	/**
	 * @private
	 */
	_readFileCbRecv: function( cmd ) 
	{
		var msg = {};
		if(!this._readFileCbRecvGen(cmd, msg))
			return;
			
		var cbId = msg[ "callbackId" ];
		var data = msg[ "data" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			NgLogE ( "FileSystem.onReadFile: No cbId" );
			return;
		}
		
		var cb = this.readRequests[ cbId ];
		
		if ( !cb )
		{
			NgLogE ( "FileSystem.onReadFile: No registered cb found..cbId is :" + cbId );
			return;
		}
		
		delete this.readRequests[ cbId ];
		cb ( err, data );
	},
	
	/**
	 * @private
	 */
	_writeFileCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._writeFileCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg[ "callbackId" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			//NgLogE ( "FileSystem command : No cbId" );
			return;
		}
		
		var cb = this.writeRequests[ cbId ];
			
		if ( !cb )
		{
			NgLogE ( "FileSystem command : No registered cb found..cbId is :" + cbId );
			return;
		}

		delete this.writeRequests[ cbId ];
		cb ( err );
	},
	
	/**
	 * @private
	 */
	_deleteFileCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._deleteFileCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg[ "callbackId" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			//NgLogE ( "FileSystem command : No cbId" );
			return;
		}
		
		var cb = this.writeRequests[ cbId ];
		
		if ( !cb )
		{
			NgLogE ( "FileSystem command : No registered cb found..cbId is :" + cbId );
			return;
		}
		
		delete this.writeRequests[ cbId ];
		cb ( err );
	},
	
	/**
	 * @private
	 */
	_decompressFileCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._decompressFileCbRecvGen(cmd, msg))
			return;
			
		var cbId = msg[ "callbackId" ];
		var files = msg[ "files" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			//NgLogE ( "FileSystem command : No cbId" );
			return;
		}
		
		var cb = this.writeRequests[ cbId ];
		
		if ( !cb )
		{
			NgLogE ( "FileSystem command : No registered cb found..cbId is :" + cbId );
			return;
		}
		
		try
		{
			files = JSON.parse(files);
		}
		catch(e)
		{
			NgLogE ( "FileSystem command : Could not parse response :" + files );
			err = "Could not parse files";
		}
		
		delete this.writeRequests[ cbId ];
		cb ( err, files );
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	Store:
	{ 
		/** /tmp */
		Temp: 0,
		/** local sandbox */
		Local: 1,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 338
	// Method create = -1
	// Method readFile = 2
	// Method writeFile = 3
	// Method deleteFile = 4
	// Method decompressFile = 5
	// Method readFileCb = 6
	// Method writeFileCb = 7
	// Method deleteFileCb = 8
	// Method decompressFileCb = 9
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 6:
					instance._readFileCbRecv( cmd );
					break;
				case 7:
					instance._writeFileCbRecv( cmd );
					break;
				case 8:
					instance._deleteFileCbRecv( cmd );
					break;
				case 9:
					instance._decompressFileCbRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in FileSystem._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in FileSystem._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[338] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_readFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "data" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "data" ] === undefined )
		{
			NgLogE("Could not parse data in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_writeFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.writeFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.writeFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.writeFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_deleteFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.deleteFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.deleteFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.deleteFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_decompressFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "files" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "files" ] === undefined )
		{
			NgLogE("Could not parse files in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":338,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_readFileSendGen: function( callbackId, storeId, filename, binary )
	{
		Core.Proc.appendToCommandString( ":338,2," + this.__objectRegistryId + "," + callbackId + "," + storeId + "," + Core.Base64.encode( filename ) + "," + ( binary ? 1 : 0 )  );
	},
	
	/** @private */
	_writeFileSendGen: function( callbackId, storeId, filename, data, binary )
	{
		Core.Proc.appendToCommandString( ":338,3," + this.__objectRegistryId + "," + callbackId + "," + storeId + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( data ) + "," + ( binary ? 1 : 0 )  );
	},
	
	/** @private */
	_deleteFileSendGen: function( callbackId, storeId, filename )
	{
		Core.Proc.appendToCommandString( ":338,4," + this.__objectRegistryId + "," + callbackId + "," + storeId + "," + Core.Base64.encode( filename )  );
	},
	
	/** @private */
	_decompressFileSendGen: function( callbackId, storeId, filename, destination, returnFiles )
	{
		Core.Proc.appendToCommandString( ":338,5," + this.__objectRegistryId + "," + callbackId + "," + storeId + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( destination ) + "," + ( returnFiles ? 1 : 0 )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// readFile: function( callbackId, storeId, filename, binary ) {}
	
	// writeFile: function( callbackId, storeId, filename, data, binary ) {}
	
	// deleteFile: function( callbackId, storeId, filename ) {}
	
	// decompressFile: function( callbackId, storeId, filename, destination, returnFiles ) {}
	
	// _readFileCbRecv: function( cmd ) {}
	// _writeFileCbRecv: function( cmd ) {}
	// _deleteFileCbRecv: function( cmd ) {}
	// _decompressFileCbRecv: function( cmd ) {}

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/NSObjects/NSUserDefaults'] = function(){var exports = $MODULE_REGISTRY['Code/NSObjects/NSUserDefaults'] || {}; $MODULE_REGISTRY['Code/NSObjects/NSUserDefaults'] = exports; var SyncKeyValue = require('Code/NSObjects/SyncKeyValue').SyncKeyValue;

exports.NSUserDefaults = SyncKeyValue.singleton({
    classname: 'NSUserDefaults',
    
    initialize : function($super)
    {
        $super("standardUserDefaults",
        [
            ZFGameDefines.kUserDefaultID_lastPlayerID,
            ZFGameDefines.kUserDefaultID_useFacebook,
            ZFGameDefines.kUserDefaultID_autoScreenshot,
            ZFGameDefines.kUserDefaultID_audioMute,
            ZFGameDefines.kUserDefaultID_audioSFXVol,
            ZFGameDefines.kUserDefaultID_audioBGMVol,
            ZFGameDefines.kUserDefaultID_flurryOffersEnabled,
            ZFGameDefines.ZFHarvestNotificationsEnabled,
            ZFGameDefines.ZFWitherNotificationsEnabled,
            ZFGameDefines.ZFInvasionNotificationsEnabled,
            ZFGameDefines.ZFOnlineSavingEnabled,
            ZFGameDefines.ZFStatusCheckDisabled,
            ZFGameDefines.ZFDayAndNightEnabled,
            ZFGameDefines.ZFAllowIncentivizedInstalls,
            ZFGameDefines.ZFAllowDailySalesOffer,
            ZFGameDefines.ZFAlreadyShowedGameCenterCancel,
            ZFGameDefines.ZFNumGameCenterCancels,
            ZFGameDefines.ZFSyncingStarted,
            ZFGameDefines.ZFSyncCrash,
            ZFGameDefines.ZFGameVersion
        ]);
    },
    
    standardUserDefaults : function()
    {
        return this;
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/External/SimpleAudioEngine'] = function(){var exports = $MODULE_REGISTRY['Code/External/SimpleAudioEngine'] || {}; $MODULE_REGISTRY['Code/External/SimpleAudioEngine'] = exports; var Audio = require('NGCore/Client/Audio').Audio;

exports.SimpleAudioEngine = Core.MessageListener.singleton({
    initialize : function()
    {
        var defaultValue;
        var defaults = NSUserDefaults.standardUserDefaults();
        
        this._playingEffects = {};
        this._effectsVolume = 1;
        this._musicVolume = 1;
        
        defaultValue = (defaults.objectForKey(ZFGameDefines.kUserDefaultID_audioSFXVol));
        if (defaultValue)
        {
            this._effectsVolume = defaultValue;
        }
        
        defaultValue = (defaults.objectForKey(ZFGameDefines.kUserDefaultID_audioBGMVol));
        if (defaultValue)
        {
            this._musicVolume = defaultValue;
        }
        
        this._muted = Boolean(defaults.objectForKey(ZFGameDefines.kUserDefaultID_audioMute));
        
        if (Core.Capabilities.getPlatformOS() === 'Android') { 
        	console.log("SimpleAudioEngine.initialize: using ogg audio format for sfx");
            this.oggMode = true; 
        } 
    },
    
    sharedEngine : function()
    {
        return this;
    },
    
    playBackgroundMusic : function(filePath)
    {
    	if(this._muted)	{
    		return;
		}
        if (Audio.Music.getIsPlaying())
        {        
            Audio.Music.stop();
        }
        
        Audio.Music.setPath(filePath);
        Audio.Music.play();
        Audio.Music.setVolume(this._musicVolume);
    },
    
    stopBackgroundMusic : function()
    {
        Audio.Music.stop();
    },
    
    pauseBackgroundMusic : function()
    {
        Audio.Music.pause();
    },
    
    resumeBackgroundMusic : function()
    {
        if (Audio.Music.getIsPaused())
        {
            Audio.Music.play();
            Audio.Music.setVolume(this._musicVolume);
        }
    },
    
    isBackgroundMusicPlaying : function()
    {
        return Audio.Music.getIsPlaying();
    },
    
    backgroundMusicVolume : function()
    {
        return Audio.Music.getVolume();
    },
    
    setBackgroundMusicVolume : function(volume)
    {
        this._musicVolume = volume;
        Audio.Music.setVolume(this._musicVolume);
    },
    
    playEffect : function(filePath)
    {
        if (!this._muted)
        {
        	filePath = this._switchOgg(filePath);
            var sfx = this._playingEffects[filePath];
            if (!sfx) {
            	sfx = new Audio.Effect(filePath);
            	this._playingEffects[filePath] = sfx;
            }
            
            var ae = new Audio.ActiveEffect(sfx);
			ae.getPlayCompleteEmitter().addListener(this, this._destroyActiveEffect);
			ae.setVolume(this._effectsVolume);
			ae.play();
        }
        else
        {
//            console.log("SimpleAudioEngine: Not playing effect " + filePath + ". Device is muted");
        }
        return filePath;
    },
    
    _destroyActiveEffect: function (ae) {
		ae.getPlayCompleteEmitter().removeListener(this);
		ae.destroy();
	},
	
    _switchOgg: function( filePath ) { 
        if (this.oggMode) { 
            return filePath.replace( ".wav", ".ogg" ); 
        } 
        return filePath; 
    },
    
    preloadSfXs: function () {
    	var self = this;
    	function loadInCache(filePath) {
    		filePath = self._switchOgg(filePath);
    		var sfx = new Audio.Effect(filePath);
    		self._playingEffects[filePath] = sfx;
    	}
    	
    	loadInCache(kMooSFX);
    	loadInCache(kSheepSFX);
    	loadInCache(kBirdsSFX);
    	loadInCache(kRoosterSFX);
    	loadInCache(kOinkSFX);
    	loadInCache(kCrowSFX);
    	loadInCache(kRainSFX);
    	loadInCache(kStormSFX);

    	loadInCache(kZombieRegularBrain);
    	loadInCache(kZombieRobotBrain);
    	loadInCache(kZombieGirlBrain);
    	loadInCache(kZombieSmallBrain);
    	loadInCache(kZombieLargeBrain);
    	loadInCache(kZombieGardenBrain);

    	loadInCache(kSplatSFX);
    	loadInCache(kHarvestZombieSFX);
    	loadInCache(kHarvestPlantSFX);

    	loadInCache(kWinnerSFX);
    	loadInCache(kDeleteSFX);
    	loadInCache(kBuySFX);
    	loadInCache(kEarnSFX);
    	loadInCache(kPlowingSFX);

    	loadInCache(kBiteSFX);
    	loadInCache(kFlailSFX);
    	loadInCache(kPokeSFX);
    	loadInCache(kPunchSFX);
    	loadInCache(kPoofSFX);
    	loadInCache(kRezSFX);
    	loadInCache(kBlockSFX);
    	loadInCache(kThrowSFX);

    	loadInCache(kMenuOpenSFX);
    	loadInCache(kMenuCloseSFX);
    	loadInCache(kMenuClick);

    	loadInCache(kCameraSFX);
    	loadInCache(kAlienLaserSFX);

    	loadInCache(kParrotSFX);
    	loadInCache(kTaikoSFX);
    },
    
    stopEffect : function(filePath)
    {
        //not possible to implement ins a safe way.
    },
    
    unloadEffect : function(filePath)
    {
        var effect = this._playingEffects[filePath];
        if (effect)
        {
        	this._playingEffects[filePath] = null;
        	delete this._playingEffects[filePath];
            destroy(effect);
        }
    },
    
    effectsVolume : function()
    {
        return this._effectsVolume;
        /*return Audio.Device.getEffectsVolume();*/
    },
    
    setEffectsVolume : function(volume)
    {
    	NSAssert(volume != null,"setEffectsVolume should be different than null/undefined");
//    	console.log("setEffectsVolume: " + volume);
        this._effectsVolume = volume || 0;
        /*Audio.Device.setEffectsVolume(volume);*/
    },
    
    setMute: function(value)
    {
        this._muted = value;
        
        if (value)
        {
        	this._musicVolumeBackUp = this._musicVolume;
        	this._effectsVolumeBackUp = this._effectsVolume;
        	
        	this.setBackgroundMusicVolume(0);
        	this.setEffectsVolume(0);
        }
        else
        {
        	if (this._musicVolumeBackUp)
        	{
        		this._musicVolume = this._musicVolumeBackUp;
        		this.setBackgroundMusicVolume(this._musicVolume);
        	}
        	
        	if (this._effectsVolumeBackUp)
        	{
        		this._effectsVolume = this._effectsVolumeBackUp;
        		this.setEffectsVolume(this._effectsVolume);
        	}
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/External/SpriteFactoryCache'] = function(){var exports = $MODULE_REGISTRY['Code/External/SpriteFactoryCache'] || {}; $MODULE_REGISTRY['Code/External/SpriteFactoryCache'] = exports; exports.SpriteFactoryCache = Core.Class.singleton({
	classname : 'SpriteFactoryCache',

	initialize : function() {
		this._animationCache = {};
	},
	
	/**
	 * 
	 * @param framePath - the path to the texture to use. Example: ./Content/textures/my_texture.png 
	 * @param size - the size of the texture. Example: new Core.Size(128,256) or [128,256]
	 * @param anchor - the anchor to use. Example: new Core.Point(0.5,1) or [0.5,1]
	 * @param uvs - the uvs mapping to use. Example: new Core.Rect(0,0,1,1) or [0,0,1,1]
	 * @param filter - boolean flag to filter the texture, by default false.
	 * @returns a GL2.Animation instance, could be a new one or a cached one if already exist.
	 */
	getAnimation: function(/*String*/ framePath, /*Core.Size*/ size, /*Core.Point*/ anchor, /*Core.Rect*/ uvs, /*Boolean*/ filter) {
		size = (size instanceof Core.Size) ? size : new Core.Size(size);
		anchor = (anchor instanceof Core.Point) ? anchor : new Core.Point(anchor || [0,0]);
		uvs = (uvs instanceof Core.Rect) ? uvs : new Core.Rect(uvs || [0,0,1,1]);
		
		var animation = this.__animationInCache(framePath, 0, size, anchor, uvs);
		if (!animation) {
//			console.log("SpriteFactory: cache miss for: " + framePath);
			animation = new GL2.Animation();
			animation.setFilteringEnabled(true && filter);
			animation.pushFrame(new GL2.Animation.Frame(framePath, 0, size, anchor, uvs));
			animation._refCounter = 0;
			this.__addToAnimationChache(animation);
		} else {
//			console.log("SpriteFactory: cache hit for: " + framePath);
		}
		animation._refCounter++;
		return animation;
	},
	
	/**
	 * 
	 * @param framePath - the path to the texture to use. Example: ./Content/textures/my_texture.png 
	 * @param size - the size of the texture. Example: new Core.Size(128,256) or [128,256]
	 * @param anchor - the anchor to use. Example: new Core.Point(0.5,1) or [0.5,1]
	 * @param uvs - the uvs mapping to use. Example: new Core.Rect(0,0,1,1) or [0,0,1,1]
	 * @param filter - boolean flag to filter the texture, by default false.
	 * @returns a new GL2.Sprite instance with a cached GL2.Animation instance.
	 */
	createSpriteWithCachedAnimation : function(/*String*/ framePath, /*Core.Size*/ size, /*Core.Point*/ anchor, /*Core.Rect*/ uvs, /*Boolean*/ filter) {
		var sprite = new GL2.Sprite();
		var animation = this.getAnimation(framePath,size,anchor,uvs,filter);
		sprite.setAnimation(animation);
		return sprite;
	},

	clearAnimationCache : function() {
		var cacheRefCopy = this._animationCache;
		this._animationCache = {};
		var cleared = 0;
		var keeped = 0;
		for ( var key in cacheRefCopy) {
			var animation = cacheRefCopy[key];
			cacheRefCopy[key] = null;
			if (animation._refCounter == 0) {
				animation.destroy();
				cleared++;
			} else {
				this._animationCache[key] = animation;
				keeped++;
			}
		}
		console.log('SpriteFactoryCache.clearAnimationCache: Animation cache cleared: %d, keeped: %d', cleared, keeped);
	},

	__animationInCache : function(image, duration, size, anchor, uvs) {
		var key = this.__createCacheKey(image, duration, size, anchor, uvs);
		return this._animationCache[key];
	},

	__addToAnimationChache : function(/*GL2.Animation*/animation) {
		var key = this.__createCacheKey(animation.getFrame(0).getImage(), animation.getFrame(0).getDuration(), animation.getFrame(0).getSize(), animation.getFrame(0).getAnchor(), animation
				.getFrame(0).getUVs());
		this._animationCache[key] = animation;
//		NgLogD("CachingAnimation: " + key);
	},

	__createCacheKey : function(image, duration, size, anchor, uvs) {
		var key = "";
		key += image;
		key += duration;
		key += size._width + "" + size._height;
		key += anchor._x + "" + anchor._y;
		key += uvs.getOrigin()._x + "" + uvs.getOrigin()._y + "" + uvs.getSize()._width + "" + uvs.getSize()._height;

		return key;
	}

});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/External/FPS'] = function(){var exports = $MODULE_REGISTRY['Code/External/FPS'] || {}; $MODULE_REGISTRY['Code/External/FPS'] = exports; var FPS = exports.FPS = Core.MessageListener.singleton({
    initialize : function()
    {
        this._fcount = 0;
        this._fduration = 0;
        this._fdurationMax = 0;
        this._fdurationMin = Number.MAX_VALUE;
        
        this._finterval = 30 * 5;
        
        // Subscribe to per frame updates.
        Core.UpdateEmitter.addListener(this, this.onUpdate);
        
        // After a timeout, place a button. The timeout is to allow interface orienation to stabalize.
//        this.button = new UI.Button({
//            normalGradient : {
//                'gradient' : [ 'FFF0 0.0', 'FFA0 1.0' ],
//                'corners' : '5',
//                'outerLine' : 'FF00 5.0'
//            },
//            highlightedGradient : {
//                'gradient' : [ 'FF80 0.0', 'FFC0 1.0' ],
//                'corners' : '5',
//                'outerLine' : 'FF00 5.0'
//            }
//        });
//        setTimeout(function()
//        {
//            var w = 240;
//            var h = 80;
//            this.button.setFrame([ UI.Window._width / 2 - w / 2, UI.Window._height - h, w, h ]);
//            UI.Window.document.addChild(this.button);
//            this.updateButton();
//        }.bind(this), 1000);
    },
    
    updateButton : function()
    {
        if (this.leakCheck)
        {
            this.button.onclick = this.stop.bind(this);
            this.button.setTextColor('FFFF0000');
            this.button.setText('stop leakcheck');
        }
        else
        {
            this.button.onclick = this.start.bind(this);
            this.button.setTextColor('FFFF');
            this.button.setText('start leakcheck');
        }
    },
    
    start : function()
    {
        console.log('/// Starting leakcheck');
        this.leakCheck = true;
        this.startTime = new Date().getTime();
        this.updateButton();
        this.stacks = [];
    },
    
    stop : function()
    {
        this.leakCheck = false;
        this.updateButton();
        
        function formatTime(t)
        {
            return '' + Math.round((t - FPS.startTime) / 100) / 10 + 's';
        }
        
        // output and reset.
        console.log('/// Leaked', this.stacks.length, 'objects in', formatTime(new Date().getTime()));
        for ( var i = 0; i < this.stacks.length; ++i)
        {
            try
            {
                var s = this.stacks[i];
                console.log('/// Leaked', s.type, 'at', formatTime(s.time));
                if (!s.exception || !s.exception.stack)
                    console.log('///   - Stacktrace unavailable');
                
                var stack = s.exception.stack.split('\n    ').slice(2);
                for ( var j = 0; j < stack.length; ++j)
                    console.log('///   -', stack[j]);
            }
            catch (e)
            {
                console.log('///   - Out of memory, stack trace lost');
            }
        }
    },
    
    trackObj : function(obj, type, exception)
    {
        // Check if this has already been registered.
        var s = this.stacks;
        for ( var i = 0; i < s.length; ++i)
        {
            if (s.obj === obj)
                return;
        }
        
        this.stacks.push({
            obj : obj,
            type : type,
            exception : exception,
            time : new Date().getTime()
        });
    },
    
    untrackObj : function(obj)
    {
        var s = this.stacks;
        for ( var i = 0; i < s.length; ++i)
        {
            if (s[i].obj !== obj)
                continue;
            s.splice(i, 1);
            return;
        }
    },
    
    onUpdate : function(frameDelta)
    {
        // add frame data
        this._fduration += frameDelta;
        this._fcount++;
        this._fdurationMax = Math.max(this._fdurationMax, frameDelta);
        this._fdurationMin = Math.min(this._fdurationMin, frameDelta);
        
        // If over our threshold, report and reset.
        if (this._fcount > this._finterval)
        {
            // Calculate average of frame samples.
            var average = this._fduration / this._fcount;
            
            // Output average.
            console.log('///FPS avg: %d, max: %d, min: %d; Instances nodes: %d, sprite: %d, anims: %d, texts: %d', Math.round(1000 / average), Math.round(1000 / this._fdurationMin), Math.round(1000 / this._fdurationMax), GL2.Node.getLiveInstances(), GL2.Sprite.getLiveInstances(), GL2.Animation
                    .getLiveInstances(), GL2.Text.getLiveInstances());
            
            // Reset sample data
            this._fcount = 0;
            this._fduration = 0;
            this._fdurationMax = 0;
            this._fdurationMin = Number.MAX_VALUE;
        }
    }
});

//Node
var nodesLiveInstances = 0;
GL2.Node.getLiveInstances = function()
{
    return nodesLiveInstances;
};

var __GL2Nodeinitialize = GL2.Node.prototype.initialize;
GL2.Node.prototype.initialize = function()
{
    if (FPS.leakCheck)
    {
        try
        {
            throw new Error();
        }
        catch (e)
        {
            FPS.trackObj(this, 'Node', e);
        }
    }
    nodesLiveInstances++;
    __GL2Nodeinitialize.apply(this, arguments);
};

var __GL2Nodedestroy = GL2.Node.prototype.destroy;
GL2.Node.prototype.destroy = function()
{
    if (FPS.leakCheck)
    {
        FPS.untrackObj(this);
    }
    nodesLiveInstances--;
    __GL2Nodedestroy.apply(this, arguments);
};

//Sprites
spritesLiveInstances = 0;
GL2.Sprite.getLiveInstances = function()
{
    return spritesLiveInstances;
};

var __GL2Spriteinitialize = GL2.Sprite.prototype.initialize;
GL2.Sprite.prototype.initialize = function()
{
    if (FPS.leakCheck)
    {
        try
        {
            throw new Error();
        }
        catch (e)
        {
            FPS.trackObj(this, 'Sprite', e);
        }
    }
    spritesLiveInstances++;
    __GL2Spriteinitialize.apply(this, arguments);
};

var __GL2Spritedestroy = GL2.Sprite.prototype.destroy;
GL2.Sprite.prototype.destroy = function()
{
    if (FPS.leakCheck)
    {
        FPS.untrackObj(this);
    }
    spritesLiveInstances--;
    __GL2Spritedestroy.apply(this, arguments);
};

//Texts
textsLiveInstances = 0;
GL2.Text.getLiveInstances = function()
{
    return textsLiveInstances;
};

var __GL2Textinitialize = GL2.Text.prototype.initialize;
GL2.Text.prototype.initialize = function()
{
    if (FPS.leakCheck)
    {
        try
        {
            throw new Error();
        }
        catch (e)
        {
            FPS.trackObj(this, 'Text', e);
        }
    }
    textsLiveInstances++;
    __GL2Textinitialize.apply(this, arguments);
};

var __GL2Textdestroy = GL2.Text.prototype.destroy;
GL2.Text.prototype.destroy = function()
{
    if (FPS.leakCheck)
    {
        FPS.untrackObj(this);
    }
    textsLiveInstances--;
    __GL2Textdestroy.apply(this, arguments);
};

//Animations
animsliveInstances = 0;
GL2.Animation.getLiveInstances = function()
{
    return animsliveInstances;
};

var __GL2Animationinitialize = GL2.Animation.prototype.initialize;
GL2.Animation.prototype.initialize = function()
{
    if (FPS.leakCheck)
    {
        try
        {
            throw new Error();
        }
        catch (e)
        {
            FPS.trackObj(this, 'Animation', e);
        }
    }
    animsliveInstances++;
    __GL2Animationinitialize.apply(this, arguments);
};

var __GL2Animationdestroy = GL2.Animation.prototype.destroy;
GL2.Animation.prototype.destroy = function()
{
    if (FPS.leakCheck)
    {
        FPS.untrackObj(this);
    }
    animsliveInstances--;
    __GL2Animationdestroy.apply(this, arguments);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/External/TouchTargetVisualizer'] = function(){var exports = $MODULE_REGISTRY['Code/External/TouchTargetVisualizer'] || {}; $MODULE_REGISTRY['Code/External/TouchTargetVisualizer'] = exports; var TouchTargetVisualizer = exports.TouchTargetVisualizer = Core.Class.singleton({
	initialize: function() {
		(function() {
			var oldInitialize = GL2.TouchTarget.prototype.initialize;
			GL2.TouchTarget.prototype.initialize = function() {
				oldInitialize.apply(this, arguments);
				this._anchor = new Core.Point(0, 0);
			};
		})();
		
		GL2.TouchTarget.prototype._showVisualization = function() {
			if(this._visualization) return;
			this._visualization = new GL2.Primitive();
			this._visualization.setType(GL2.Primitive.Type.TriangleStrip);
			this._visualization.pushVertex(new GL2.Primitive.Vertex([0, 0]));
			this._visualization.pushVertex(new GL2.Primitive.Vertex([1, 0]));
			this._visualization.pushVertex(new GL2.Primitive.Vertex([0, 1]));
			this._visualization.pushVertex(new GL2.Primitive.Vertex([1, 1]));
			this._visualization.setAlpha(0.5);
			this._visualization.setDepth(Infinity);
			this._visualization.setColor(Math.random(), Math.random(), Math.random());
			this.addChild(this._visualization);
			this._correctVisualization();
		};
		
		GL2.TouchTarget.prototype._hideVisualization = function() {
			if(!this._visualization) return;
			this._visualization.destroy();
			delete this._visualization;
		};
		
		GL2.TouchTarget.prototype._correctVisualization = function() {
			var s = this.getSize();
			var a = this.getAnchor();
			
			this._visualization.setScale(s._width, s._height);
			this._visualization.setPosition(-a._x * s._width, -a._y * s._height);
		};
		
		this.show();
	},
	
	show: function() {
		if(this.showing) return;
		this.showing = true;
		
		TouchTargetVisualizer.oldInitialize = GL2.TouchTarget.prototype.initialize;
		GL2.TouchTarget.prototype.initialize = function() {
			TouchTargetVisualizer.oldInitialize.apply(this, arguments);
			this._showVisualization();
		};
		
		TouchTargetVisualizer.oldDestroy = GL2.TouchTarget.prototype.destroy;
		GL2.TouchTarget.prototype.destroy = function() {
			TouchTargetVisualizer.oldDestroy.apply(this, arguments);
			this._hideVisualization();
		};
		
		TouchTargetVisualizer.oldSetAnchor = GL2.TouchTarget.prototype.setAnchor;
		GL2.TouchTarget.prototype.setAnchor = function() {
			TouchTargetVisualizer.oldSetAnchor.apply(this, arguments);
			this._correctVisualization();
		};
		
		TouchTargetVisualizer.oldSetSize = GL2.TouchTarget.prototype.setSize;
		GL2.TouchTarget.prototype.setSize = function() {
			TouchTargetVisualizer.oldSetSize.apply(this, arguments);
			this._correctVisualization();
		};
		
		var objs = Core.ObjectRegistry._objects;
		for(var i in objs) {
			if(!objs.hasOwnProperty(i)) continue;
			if(!(objs[i] instanceof GL2.TouchTarget)) continue;
			objs[i]._showVisualization();
		}
	},
	
	hide: function() {
		if(!this.showing) return;
		this.showing = false;
		
		GL2.TouchTarget.prototype.initialize = TouchTargetVisualizer.oldInitialize;
		GL2.TouchTarget.prototype.destroy = TouchTargetVisualizer.oldDestroy;
		GL2.TouchTarget.prototype.setAnchor = TouchTargetVisualizer.oldSetAnchor;
		GL2.TouchTarget.prototype.setSize = TouchTargetVisualizer.oldSetSize;
		
		var objs = Core.ObjectRegistry._objects;
		for(var i in objs) {
			if(!objs.hasOwnProperty(i)) continue;
			if(!(objs[i] instanceof GL2.TouchTarget)) continue;
			objs[i]._hideVisualization();
		}
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/External/RefCounter'] = function(){var exports = $MODULE_REGISTRY['Code/External/RefCounter'] || {}; $MODULE_REGISTRY['Code/External/RefCounter'] = exports; exports.RefCounter = Core.Class.subclass({
    initialize: function(parent)
    {
        this._parent = parent;
        this._refCount = 0;
    },
    
    canDestroy: function()
    {
        return (this._refCount < 1);
    },
    
    increaseRefCount: function()
    {
        if (this._refCount)
        {
            this._refCount++;
        }
    },
    
    decreaseRefCount: function()
    {
        if (this._refCount)
        {
            this._refCount--;
            if (this._refCount < 1)
            {
                console.log("CCNode.decreaseRefCount: Reference count is 0. Destroying object");
                destroy(this._parent);
            }
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/External/MobagePaymentController'] = function(){var exports = $MODULE_REGISTRY['Code/External/MobagePaymentController'] || {}; $MODULE_REGISTRY['Code/External/MobagePaymentController'] = exports; var Bank = require('NGCore/Client/Bank').Bank;

/**
 * Mobage payment controller class. Allows to perform payments using the Mobage banking API. 
 * Allows up to 1 concurrent payment.
 */
exports.MobagePaymentController = Core.Class.subclass({
    classname : "MobagePaymentController",
    onClose : null,
    onProcess : null,
    onError : null,
    debugMode : true,

    initialize : function(onClose, onProcess, onError) {
        this.transactionId = "";
        this.onClose = onClose;
        this.onProcess = onProcess;
        this.onError = onError;
    },
    
    /**
     * Attemps to buy 1 item, given its Stock-keeping Unit code
     * @param sku Stock-keeping Unit (item Id) 
     * @param comment Comment used by the transaction log
     */
    createSimpleTransaction : function(sku, comment) {
        this.createTransaction([{ 'item' : { 'id' : sku }, 'quantity' : '1'}], comment);
    },
    
    /**
     * Attemps to buy one or more items in any given quantity. 
     * @param billingItems Items array (see Bank.Debit.createTransaction for details)
     * @param comment Comment used by the transaction log
     */
    createTransaction : function(billingItems, comment) {
        // Creation response handler
        var onCreateResponse = function(error, transaction) {
            if (this.debugMode) {
                console.log("create tx error dump: " + error);
                console.log("create tx transaction dump: " + transaction);
            }
            
            if (error || !transaction) {
                console.log("PaymentController.createTransaction.onResponse: Error creating transaction. Error: " + error);
                if (transaction && transaction.id) {
                	Bank.Debit.cancelTransaction(transaction.id);
                }
                this.onError(error, transaction);
            } else {
                // Opening response handler
                var onOpenResponse = function(error, transaction) {
                    if (this.debugMode) {
                        console.log("open tx error dump: " + error);
                        console.log("open tx transaction dump: " + transaction);
                    }
                    
                    if (error || !transaction) {
                        console.log("PaymentController.createTransaction.onOpenResponse: Error opening transaction. Error: " + error);
                        Bank.Debit.cancelTransaction(this.transactionId, this.onError);
                    } else {
                        if (this.onProcess) {
                            this.onProcess(transaction);
                        } else {
                            console.log("PaymentController.createTransaction.onOpenResponse: No processing callback found.");   
                        }
                    }
                }
                
                // Call
                this.transactionId = transaction.id;
                Bank.Debit.openTransaction(this.transactionId, onOpenResponse.bind(this));
            }
        }
        
        // Call
        Bank.Debit.createTransaction(billingItems, comment, onCreateResponse.bind(this));
    },

    /**
     * Attemps to close a transaction 
     * @param transaction The transaction to close
     */
    closeTransaction : function(transaction) {
        // Response handler
        var onResponse = function(error, transaction) {
            if (this.debugMode) {
                console.log("close tx error dump: " + JSON.stringify(error));
                console.log("close tx transaction dump: " + JSON.stringify(transaction));
            }
            
            if (!error) {
                if (transaction) {
                    // Transaction successful
                    this.onClose(transaction);
                } else {
                    this.onError(null, transaction);
                }
            } else {
                console.log("PaymentController.closeTransaction.onResponse: Error closing transaction. Error: " + error);
                Bank.Debit.cancelTransaction(this.transactionId, this.onError);
            }
        };
        
        // Call
        if (transaction) {
            Bank.Debit.closeTransaction(transaction.id, onResponse.bind(this)); 
        } else {
            console.log("PaymentController.closeTransaction: No transaction transaction.");
        }
    },
    
    /**
     * Cancels existing transactions
     */
    $cancelPendingTransactions : function() {
        var onResponse = function(error, transactions)
        {
            if (this.debugMode) {
                console.log("get pending txs error dump: " + JSON.stringify(error));
                console.log("get pending txs transactions dump: " + JSON.stringify(transactions));
            }
            
            var onResponse = function(error, transaction) {
                if (this.debugMode) {
                    console.log("cancel pending txs error dump: " + JSON.stringify(error));
                    console.log("cancel pending txs response transaction dump: " + JSON.stringify(transaction));
                }
            }
            
            for (var i in transactions) {
                console.log("cancelling pending transaction : " + transactions[i]);
                Bank.Debit.cancelTransaction(transactions[i], onResponse.bind(this));
            }
        }
        
        if(Bank.Debit.getPendingTransactions)
        	Bank.Debit.getPendingTransactions(onResponse.bind(this));
        else
        {
        	console.log('///MobagePaymentController.cancelPendingTransactions: Bank.Debit.getPendingTransactions not available in current API.');
        }
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/External/BackButtonHandler'] = function(){var exports = $MODULE_REGISTRY['Code/External/BackButtonHandler'] || {}; $MODULE_REGISTRY['Code/External/BackButtonHandler'] = exports; exports.BackButtonHandler = Core.Class.singleton({
    initialize: function()
    {
        this._stack = [];
    },
    
    push : function(element)
    {        
        if (element instanceof ZFAlertWindow || element instanceof ZFMenu)
        {
        	//ZFZombieSelectionMenu can't be closed
        	if (!(element instanceof ZFZombieSelectionMenu.constructor)) {
        		this._stack.unshift(element);
        	}
        }
    },
    
    destroyTop: function()
    {
        if (this._stack.length > 0)
        {
            return this.closeElement(this._stack[0]);
        }
        
        return false;
    },
    
    removeElement : function(element)
    {
        var index = this._stack.indexOf(element);
        if (index >= 0)
        {
            this._stack.splice(index, 1);
        }
    },
    
    closeElement: function(element)
    {
        if (element)
        {
            var index = this._stack.indexOf(element);
            if (index >= 0)
            {
                if (element instanceof ZFAlertWindow)
                {
                    element.dismissAlertNegative();
                }
                else if (element instanceof ZFMenu)
                {
                    element.dismissMenu();
                }
                
                //check if the element still on the stack to remove it
                index = this._stack.indexOf(element);
                if (index >= 0) {
                	console.log("BackButtonHandler.closeElement: An element didn't call removeElement. Element: " + element);
                	this._stack.splice(index, 1);
                }

                return true;
            }
        }
        
        return false;
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/External/TouchBlocker'] = function(){var exports = $MODULE_REGISTRY['Code/External/TouchBlocker'] || {}; $MODULE_REGISTRY['Code/External/TouchBlocker'] = exports; exports.TouchBlocker = Core.Class.subclass({
    initialize: function()
    {
        var winSize = new Core.Size(10000, 10000);/*CCDirector.winSize()*/;
        
        this._node = new GL2.Node();
        this._touchListener = new Core.MessageListener();
        
        this._touchTarget = new GL2.TouchTarget();
        this._touchTarget.setAnchor(0.5, 0.5);
        this._touchTarget.setSize(winSize.getWidth(), winSize.getHeight());
        this._touchTarget.getTouchEmitter().addListener(this._touchListener, this.onTouch.bind(this));
        
        this._node.addChild(this._touchTarget);
        /*this._node.setPosition(winSize.getWidth()/2, winSize.getHeight()/2);*/
    },
    
    destroy: function()
    {
        this._touchTarget.getTouchEmitter().removeListener(this._touchListener);
        this._touchListener.destroy();
        this._node.removeChild(this._touchTarget);
        this._touchTarget.destroy();
        this._node.destroy();
        
        this._touchListener = null;
        this._touchTarget = null;
        this._node = null;
        
    },
    
    onTouch: function(touchEvent)
    {
        return true;
    },
    
    getNode: function()
    {
        return this._node;
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/External/RateGame'] = function(){var exports = $MODULE_REGISTRY['Code/External/RateGame'] || {}; $MODULE_REGISTRY['Code/External/RateGame'] = exports; exports.RateGame = Core.Class.singleton({
	classname : 'RateGame',
	
    initialize: function()
    {
//    	  -Won first invasion 
//        -Reached level 8 
//        -10 zombies harvested 
//        -Purchased and placed first decoration 
    	var popUpShowed = false;
//    	
//    	if(this.__shouldAsk() && GameState._zfGameData._level >= 8){
//    		popUpShowed = true;
//    		this.displayWindow();
//    	} 
//    	
//    	if(!popUpShowed && this.__shouldAsk() && GameState.curArmySize() >= 10 && GameState._zfGameData._10Zombies != 10){
//    		GameState._zfGameData._10Zombies = 10;
//    		popUpShowed = true;
//    		this.displayWindow();
//    	}
    	
    	if(!popUpShowed && this.__shouldAsk() && this.__enemyBeaten() && !GameState._zfGameData._wonFirstInvaion){
    		GameState._zfGameData._wonFirstInvaion = true;
    		this.displayWindow();
    	}
    },

    __enemyBeaten : function()
    {
    	return (!(GameState._zfGameData._gflags & ZFGameFlags.GFLAG_FB_ENEMY1) ||
        		!(GameState._zfGameData._gflags & ZFGameFlags.GFLAG_FB_ENEMY2) ||
        		!(GameState._zfGameData._gflags & ZFGameFlags.GFLAG_FB_ENEMY3) ||
        		!(GameState._zfGameData._gflags & ZFGameFlags.GFLAG_FB_ENEMY4) ||
        		!(GameState._zfGameData._gflags & ZFGameFlags.GFLAG_FB_ENEMY5) ||
        		!(GameState._zfGameData._gflags & ZFGameFlags.GFLAG_FB_ENEMY6) ||
        		!(GameState._zfGameData._gflags & ZFGameFlags.GFLAG_FB_ENEMY7) ||
        		!(GameState._zfGameData._gflags & ZFGameFlags.GFLAG_FB_ENEMY8) ||
        		!(GameState._zfGameData._gflags & ZFGameFlags.GFLAG_FB_ENEMY9));
    },
    
    __shouldAsk : function()
    {
    	if( GameState._zfGameData._askedTimes >= 1 || GameState._zfGameData._gameRatedByUser ) {
    		return false;
    	}
    	return true;
    },
    
    __increaseAsked : function()
    {
    	GameState._zfGameData._askedTimes = GameState._zfGameData._askedTimes ? GameState._zfGameData._askedTimes : 0;
		GameState._zfGameData._askedTimes++;
    },
    
    //Called by ZFGuiLayer (beatEnemyFirstTimeMessage)
    $askFirstInvasion : function()
    {
    	if(!this.__shouldAsk() || GameState._zfGameData._wonFirstInvaion){
    		return;
    	}
    	
    	GameState._zfGameData._wonFirstInvaion = true;
    	this.displayWindow();
    },
    
    //Called by GameState (levelUp)
    $askReachedLvl8 : function()
    {
    	if(!this.__shouldAsk() || GameState._zfGameData._level != 8){
    		return;
    	}
    	
    	this.displayWindow();
    },
    
    //Called by ZFToolManager (harvestZombieWithUnitKey)
    $ask10Zombies : function()
    {
    	GameState._zfGameData._10Zombies = GameState._zfGameData._10Zombies ? GameState._zfGameData._10Zombies : 0;
    	GameState._zfGameData._10Zombies++;
    	if(!this.__shouldAsk() || GameState._zfGameData._10Zombies != 10 ){
    		return;
    	}
    	GameState._zfGameData._10Zombies = (GameState._zfGameData._10Zombies >= 15) ? 15 : GameState._zfGameData._10Zombies;
    	this.displayWindow();
    },
    
    //Called by ZFToolManager (onTileClickUp) -> (this.kGameTool.kGameToolPlace, ZFGameTool.kGameToolState.kGameToolStateSpriteDragging)
    $askPurchased : function()
    {
    	if(!this.__shouldAsk() || GameState._zfGameData._purchased){
    		return;
    	}
    	
    	GameState._zfGameData._purchased = true;
    	this.displayWindow();
    },
    
    displayWindow : function()
    {
    	this.__increaseAsked();
    	
    	var aw = ZFGuiLayer.displayAlertSimpleChoice(
				NSLocalizedString("Rate us!"),
				NSLocalizedString("Please give us 5 Stars and tell us what you think."),
				CCSprite.spriteWithFile("male.png"));
		aw._delegate = this;
		
		GameState.saveGameReal();
    },
    
    alertWindow_dismissedPositive : function(aw, selectedYes, buttonTag)
    {
 		if(selectedYes)
		{
 			GameState._zfGameData._gameRatedByUser = true;
 			var marketUrl = "market://details?id=" + Core.Capabilities.getBundleIdentifier();
 		    Device.IPCEmitter.launch(marketUrl, function(error) {
 		    	GameState._zfGameData._gameRatedByUser = false;
 		    });
		} else{
			
		}
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCScheduler'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCScheduler'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCScheduler'] = exports; //scheduleds

//scheduling. the schedule object is an array compound of:
//[target,functionPointer,interval,elapsed]
//	0		1				2			3

exports.CCScheduler = Core.Class.singleton({
	classname: "CCScheduler",

	initialize: function () {
		this._targets = {};
		this._targetsUpdates = [];
		this._targetsDraws = [];
		this._lastIndex = 100;
	},
	
	sharedScheduler: function () {
		return this;
	},
	
	tickUpdateAndDraw: function (dt) {
		var targetsUpdates = this._targetsUpdates;
//		var ini = 0;
//		var delta = 0;
//		var classname = null;
		for (var i in targetsUpdates) {
//			ini = Core.Time.getRealTime();
//			classname = targetsUpdates[i].classname;
			targetsUpdates[i].update(dt);
//			delta = Core.Time.getRealTime() - ini;
//			if (delta > 6) {
//				console.log (ini + " : tickUpdateDrawn: %s, %f", classname, delta);
//			}
			
		}
		
		var targetsDraws = this._targetsDraws;
		for (var i in targetsDraws) {
			targetsDraws[i].draw();
		}
	},
	
	tickScheduled: function (dt) {
		var targets = this._targets;
		var j = 0;
		
//		var ini = 0;
//		var delta = 0;
//		var classname = null;
		
		for (var index in targets) {
			var targetScheduleds = targets[index];
			for (j=0; j < targetScheduleds.length; j++) {
				var scheduled = targetScheduleds[j];
				scheduled[3] += dt;
				if ( scheduled[3] >= scheduled[2] ) {
//					ini = Core.Time.getRealTime();
//					classname = scheduled[0].classname;
					scheduled[1].call(scheduled[0],scheduled[3]);
					scheduled[3] = 0;
//					delta = Core.Time.getRealTime() - ini;
//					if (delta > 6) {
//						console.log ("%d : tickScheduled: %s.%s: %f", ini, classname, scheduled[4], delta);
//					}
				}
			}
		}
	},
	
	_findTargetScheduled: function (target,remove) {
		var targets = this._targets;
		var sid = target.__schedulerId;
		var ret = targets[sid];
		if (ret && remove) {
			delete targets[sid];
		}
		return ret;
	},
	
	_findScheduled: function( target, functionPointer, remove ) {
		var targetScheduleds = this._findTargetScheduled(target,remove);
		if (targetScheduleds) {
			for (var i = 0; i < targetScheduleds.length; i++) {
				if (targetScheduleds[i][1] == functionPointer) {
					var scheduled = targetScheduleds[i];
					if (remove) {
						targetScheduleds.splice(i,1);
						//if still scheduled, then add again to the targets array
						if (targetScheduleds.length) {
							this._targets[target.__schedulerId] = targetScheduleds;
						}
					}
					return scheduled;
				}
			}
			if (remove) {
				if (targetScheduleds.length) {
					this._targets[target.__schedulerId] = targetScheduleds;
				}
			}
		}
		
		return null;
	},
	
	isScheduled: function( target, functionPointer ) {
		return functionPointer && this._findScheduled(target,functionPointer) != null;
	},
	
	isUpdateScheduled: function (target) {
		return this._targetsUpdates.indexOf(target) != -1;
	},
	
	schedule: function ( target, functionPointer, interval, functionName ) {
		if (target.__schedulerId == null) {
			target.__schedulerId = String(this._lastIndex++);
		}
		if (target instanceof ZombieActor) {
			interval = interval || 0.066;
//			interval < 0.20 && console.log("CCScheduler.schedule: zombie actor interval: " + interval);
		} else {
			interval = interval || 0.033;//if not interval, then use 33ms for 30fps.
		}
		if (!functionPointer) {
			return;
		}
		var scheduled = this._findScheduled(target, functionPointer);
		if (scheduled) {
			//update the interval
			if (scheduled[2] != interval) {
				scheduled[2] = interval;
			}
		} else {
			var targetScheduleds = this._findTargetScheduled(target);
			if (!targetScheduleds) {
				targetScheduleds = [];
				this._targets[target.__schedulerId] = targetScheduleds;
			}
			scheduled = [target,functionPointer,interval,0];
			targetScheduleds.push(scheduled);
		}
		if(functionName){
			scheduled[4] = functionName;
		}
	},
	
	scheduleUpdateForTarget: function (target,priority,paused) {
		var targetsUpdates = this._targetsUpdates;
		if (targetsUpdates.indexOf(target) == -1) {
			targetsUpdates.push(target);
		}
	},
	
	scheduleDrawForTarget: function (target,priority,paused) {
		var targetsDraws = this._targetsDraws;
		if (targetsDraws.indexOf(target) == -1) {
			targetsDraws.push(target);
		}
	},
	
	unschedule: function( target, functionPointer )	{
		var scheduled = this._findScheduled(target,functionPointer,true);
		if (scheduled) {
			scheduled.length = 0;
		}
	},
	
	unscheduleUpdateForTarget: function (target) {
		var targetsUpdates = this._targetsUpdates;
		var index = targetsUpdates.indexOf(target);
		if ( index != -1 ) {
			targetsUpdates.splice(index,1);
		}
	},
	
	unscheduleDrawForTarget: function (target) {
		var targetsDraws = this._targetsDraws;
		var index = targetsDraws.indexOf(target);
		if ( index != -1 ) {
			targetsDraws.splice(index,1);
		}
	},
	
	unscheduleAllSelectorsForTarget: function( target ) {
		var targetScheduleds = this._findTargetScheduled(target,true);
		if (targetScheduleds) {
			for (var i in targetScheduleds) {
				var scheduled = targetScheduleds[i];
				scheduled.length = 0;
			}
			targetScheduleds.length = 0;
		}
	},
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCColor'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCColor'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCColor'] = exports; var Core = require('NGCore/Client/Core').Core;

var CCColor = Core.Color.subclass(
{
    classname: 'CCColor',
    
    initialize: function($super, red, green, blue, alpha) {
        if (arguments.length == 5)
        {
            $super(red, green, blue);
            if (typeof alpha != "undefined")
            {
                this._a = alpha;
            }
        } 
        else
        {
            var args = Array.prototype.concat.apply([],arguments);
            args.shift();
            $super.apply(this, args);
            
            if (args.length == 1 && args[0] instanceof CCColor) {
            	this.setAlpha(args[0].getAlpha());
            }
        }
    },
    
    getAlpha: function() {
        return (typeof this._a != "undefined") ? this._a : 1;  
    },
    
    setAlpha: function(value) {
        this._a = value;
    }
});

exports.CCColor = CCColor;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCNode'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCNode'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCNode'] = exports; var CCActionManager =  require('Code/Cocos2D/CCActionManager').CCActionManager;

exports.CCNode = GL2.Node.subclass(
{	
	classname: "CCNode",	
	
	initialize: function()
	{
        this._mobage = true;
        this._contentSize = new Core.Size(0, 0);
        this._anchorPoint = new Core.Point(0, 0);
        this._anchorPointInPixels = new Core.Point(0, 0);
        this._isRelativeAnchorPoint = true;
        this._tag = -1;
        this._listener = null;
        this._flipX = false;
        this._flipY = false;
        this._opacity = 255;
        
        this._totoScale = new Core.Vector(+1, +1);
        
        this._ccPosition = new Core.Point(0,0);
	},
	
	destroy: function()
    {
		this.cleanup();
        if(this._children.length > 0)
        for(var i = this._children.length - 1;i>=0; i--)
        {
            destroy(this._children[i]);
        }
        
        this._contentSize = null;
        this._anchorPoint = null;
        this._anchorPointInPixels = null;
        this._listener = null;        
        this._totoScale = null;
    },
    
	removeChildByTag: function(tag, cleanup)
	{
		for(var i = this._children.length-1; i >= 0; i--)
		{
			var it = this._children[i];
			if(it._tag == tag)
			{
				this.removeChild(it);
				if (cleanup)
				{
				    it.cleanup();
				    destroyWithChildren(it);
				}
			}
		}
	},
	
	getOpacity: function()
	{
		return this._opacity;
	},
	
	//value between [0..255]
	setOpacity: function(opacity)
	{		
		if (opacity < 0 || opacity > 255) {
			throw new Error("Opacity should be a value between 0 and 255");
		} else {
			this._opacity = opacity;
			this.setAlpha(opacity/255);
		}
	},
	
	//value between [0..1]
	setAlpha: function ($super,alpha)
	{
		if (alpha < 0 || alpha > 1) {
			throw new Error("Alpha should be a value between 0 and 1");
		} else {
			this._opacity = Math.round(255 * alpha);
			$super(alpha);
		}
		
	},
	
	setColor: function ($super,color) {
		if (color instanceof CCColor) {
			this.setAlpha(color.getAlpha());
		}
		$super(color);
	},
	
	runAction: function(action)
	{	
		CCActionManager.addAction(action, this, !this._isRunning);
		return action;
	},
	
	numberOfRunningActions: function()
	{
		return CCActionManager.numberOfRunningActionsInTarget(this);
	},
	
	getPosition: function()
	{
		return this._ccPosition;
	},
		
	setPosition: function($super, position, y) {
		var ccpos = this._ccPosition;
		if(y != null) {
			ccpos._x = position;
			ccpos._y = -y;
		} else {
			ccpos._x = position._x || position[0] || 0;
			ccpos._y = -position._y|| -position[1] || 0;
		}
		$super(ccpos);
		
		ccpos._y *= -1;
	},
	
//	
	setFlipX: function( flipped )
	{
		if ( this._flipX == flipped )
		{
			return false;
		}
		
		this._flipX = flipped;
		this._updateScale();
		return true;
	},
	
	getFlipX: function()
	{
		return this._flipX;
	},
	
	setFlipY: function( flipped )
	{
		this._flipY = flipped;
		this._updateScale();
	},
	
	getFlipY: function()
	{
		return this._flipY;
	},
	
	_updateScale: function()
	{
		this.setScale( 	this._totoScale._x * ( this.getFlipX() ? -1 : +1 ),
						this._totoScale._y * ( this.getFlipY() ? -1 : +1 ),
						true ); // Force.
	},
	
	setScale: function( $super , scaleX , scaleY , forceSuper )
	{
		if ( forceSuper )
		{
			$super( scaleX , scaleY );
			return;
		}
		
		if ( scaleX == "Vector" || scaleX == "Point" )
		{
			this._totoScale = scaleX.clone();
		}
		else 
		{
			if ( !scaleY ) scaleY = scaleX;
			
			this._totoScale = new Core.Vector( scaleX , scaleY );
		}
		
		this._updateScale();
	},
	
	getScale: function( )
	{
		return this._totoScale;
	},
	
	addChild: function($super, child, z, tag)
	{
		
		child.__oldParent = this.classname; 
		
		if (typeof z != "undefined")
		{
			child.setDepth(z);
		}
		
		if (typeof tag != "undefined")
		{
			child._tag = tag;
		}
		$super(child);
	},
	
	insertChild: function(child, index, zOrder)
	{
//should do same as insert child from cocos ?
		this.addChild(child, zOrder, child.tag);
//		var childPoped = this._children.pop();
//		console.log("insert child = " + (child == childPoped));
//		this._children.splice(index, 0, child);
	},
	
	getChildByTag: function(tag)
	{
		for (var key in this._children)
		{
			if(this._children[key]._tag == tag)
				return this._children[key];
		}
		
		return null;
	},
	
//	shift: function( x , y )	
//	{
//		if ( this._shift == undefined )
//		{
//			this._shift = new Core.Point( 0 , 0 );
//		}
//		
//		if ( x != undefined && y != undefined )
//		{
//			this._shift = ccpAdd( this._shift , ccp( x , y ) );
//			this.setPosition( ccp( x + this.getPosition()._x , y + this.getPosition()._y ) );
//		}
//	
//		console.log( this._shift._x + "," + this._shift._y );
//	},

	
	setContentSize: function(size)
	{
		if(size._width != this._contentSize._width || size._height != this._contentSize._height) 
		{
//			contentSize_ = size;
			this._contentSize = size;
//		anchorPointInPixels_ = ccp( contentSize_.width * anchorPoint_.x, contentSize_.height * anchorPoint_.y );
		}

	},

	removeChild: function($super, child, cleanup)
	{
		//console.log("child = " + child + " index of = " + this._children.indexOf(child));
		
		// explicit nil handling
		if (!child)
			return;
		
		
		//callback for debugging
//		if(child.removed) child.removed();
		
		
		if (this._children.indexOf(child) >= 0)
		{
			this.detachChild(child, cleanup);
			//console.log("child = " + child);
//in original code it is done in all cases			
//			if (!cleanup) {
				$super(child);
//			}
				
				
			if(child._deleteOnRemove == true) 
				{			
					for(var i = child._children.length-1; i >= 0; i--)
						child.removeChild(child._children[i]);
				
					destroy(child);
				}
			//child.destroy();
		}
	},
	
	removeAllChildrenWithCleanup: function(cleanup)
	{
		// not using detachChild improves speed here
		var c;
		for(var i = this._children.length-1; i >= 0; i--)
		{
			c = this._children[i];
			
			// IMPORTANT:
			//  -1st do onExit
			//  -2nd cleanup
			if (this._isRunning)
				c.onExit && c.onExit();
			
			if (cleanup && c._mobage)
				c.cleanup && c.cleanup();
			
			// set parent nil at the end (issue #476)
//			[c setParent:nil];
			this.removeChild(c);
		}
		this._children.length = 0;
	},

	
	detachChild: function(child, doCleanup)
	{
		// IMPORTANT:
		//  -1st do onExit
		//  -2nd cleanup
		if (this._isRunning)
			child.onExit && child.onExit();
		
		// If you don't do cleanup, the child's actions will not get removed and the
		// its scheduledSelectors_ dict will not get released!
		if (doCleanup)
			child.cleanup && child.cleanup();
		
		// set parent nil at the end (issue #476)
//		[child setParent:nil];
		
//		[children_ removeObject:child];
//done in removeChild
//		this.removeChild(child);
	},

	cleanup : function()
	{
		// actions
		this.stopAllActions();
		this.unscheduleAllSelectors();
		
		this.unscheduleUpdate();
		this.unscheduleDraw();
		
		// timers
		var children = this._children;
		for (var key in children) {
			var child = children[key];
			child.cleanup && child.cleanup();
		}
		
	},

	getContentSize: function()
	{
		return this._contentSize;
	},
	
	setAnchorPoint: function(point)
	{
		if(point._x != this._anchorPoint._x || point._y != this._anchorPoint._y) 
		{
			this._anchorPoint._x = point._x;
			this._anchorPoint._y = point._y;
			var scale = this.getScale();
			this._anchorPointInPixels._x = this._contentSize._width * scale._x * this._anchorPoint._x;
			this._anchorPointInPixels._y = this._contentSize._height * scale._y * this._anchorPoint._y;
		}
	},
	
	getAnchorPoint: function()
	{
		return this._anchorPoint;
	},
	
	onEnter: function() {
		var children = this._children;
		for(var key in children)
		{
			var child = children[key];
			child.onEnter && child.onEnter();
		}
		//FIXME: this.resumeSchedulerAndActions();
		this._isRunning = true;
	},
	
	onExit: function()
	{
		//FIXME: this.pauseSchedulerAndActions();
		this._isRunning = false;	
	
		var children = this._children;
		for(var key in children)
		{
			var child = children[key];
			child.onExit && child.onExit();
		}
	},
	
	reorderChild: function(child, depth)
	{
		if(child)
		child.setDepth(depth);
	},
	
	beforeDraw : function()
	{
	},
	
	draw : function()
	{
	},
	
	afterDraw : function()
	{
	},

	isFacingRight: function()
	{
		return this.getFlipX();
	},
	
	isScheduled: function( functionPointer ) {
		return CCScheduler.isScheduled(this, functionPointer);
	},
	
	isUpdateScheduled: function () {
		return CCScheduler.isUpdateScheduled(this);
	},
	
	schedule: function( functionPointer, interval, functionName ) {
		CCScheduler.schedule(this, functionPointer, interval, functionName);
	},
	
	unschedule: function( functionPointer )	
	{
		CCScheduler.unschedule( this , functionPointer );
	},
	
	unscheduleAllSelectors: function() {
		CCScheduler.unscheduleAllSelectorsForTarget(this);
	},
	
	scheduleUpdate: function() {
		CCScheduler.scheduleUpdateForTarget(this, 0, !this._isRunning);
	},
	
	scheduleDraw: function() {
		CCScheduler.scheduleDrawForTarget(this, 0, !this._isRunning);
	},

	unscheduleUpdate: function () {
		CCScheduler.unscheduleUpdateForTarget(this);
	},
	
	unscheduleDraw: function () {
		CCScheduler.unscheduleDrawForTarget(this);
	},
	
	stopAllActions: function()
	{
		CCActionManager.stopAllActions( this );
	},
	
	performSelector: function (selector,param,delay) {
		setTimeout(selector.bind(this,param),delay*1000);
	},
	
	convertTouchToNodeSpace: function(touch)
	{
		var point = this.screenToLocal(touch.getPosition());
		point._y *= -1;
		return point;
	},
	
//	convertToWorldSpace: function(nodePoint)
//	{
//		/*Not implemented*/
//	},
	
	removeFromParentAndCleanup : function(cleanup)
	{
		this.getParent() && this.getParent().removeChild(this, cleanup);
	}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCLayer'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCLayer'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCLayer'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var CCNode = require('Code/Cocos2D/CCNode').CCNode;

exports.CCLayer = CCNode.subclass(
{
	classname: 'CCLayer',
	
	initialize: function()
	{
		this._anchorPoint = new Core.Point(0.5, 0.5);
        this.setContentSize(CCDirector.winSize());
		this._isRelativeAnchorPoint = false;
		this._isTouchEnabled = false;
		this._isAccelerometerEnabled = false;
	},
	
	destroy: function()
	{
	    this._anchorPoint = null;
	},

	registerWithTouchDispatcher: function()
	{
	    console.log("CCLayer.registerWithTouchDispatcher: Method not implemented");
	},
	
	isTouchEnabled: function()
	{
		return this._isTouchEnabled;
	},
	
	isAccelerometerEnabled: function()
	{
		return this._isAccelerometerEnabled;
	}	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCColorLayer'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCColorLayer'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCColorLayer'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var CCNode = require('Code/Cocos2D/CCNode').CCNode;
var CCLayer = require('Code/Cocos2D/CCLayer').CCLayer;

exports.CCColorLayer = CCLayer.subclass({
    classname : "CCColorLayer",
    
    initialize : function($super)
    {
        this._node = SpriteFactoryCache.createSpriteWithCachedAnimation("./Content/blank.png", new Core.Size(1, 1), [ 0.0, 0.5 ]);
        $super();//this._node should exist before calling $super()
        this.addChild(this._node);
    },
    
    destroy : function()
    {
        this._node = null;
    },
    
    $layerWithColor : function(color, w, h)
    {
        var l = new this();
        l.initWithColor(color, w, h);
        return l;
    },
    
    initWithColor : function(color, w, h)
    {
        this.setColor(color);
        
        if (!w || !h)
        {
            var size = CCDirector.winSize();
            w = size._width;
            h = size._height;
        }
        this.setContentSize(CGSizeMake(w, h));
    },
    
    setColor : function()
    {
        var color = new CCColor();
        color.constructor.apply(color, arguments);
        this._node.setColor(color);
        if (color instanceof CCColor)
        {
            this._node.setAlpha(color.getAlpha());
        }
    },
    
    getColor : function()
    {
        return this._node.getColor();
    },
    
    setContentSize : function($super, size)
    {
        $super(size);
        
        this._node.setScale(size._width, size._height);
    },
    
    getSize : function()
    {
        return new Core.Size(this._node.getScale()._x, this._node.getScale()._y);
    },
    
    changeWidth : function(w, h)
    {
        if (typeof h == "undefined")
        {
            h = this.getSize()._height;
        }
        this.setContentSize(new Core.Size(w, h));
    },
    
    changeHeight : function(h)
    {
        this.setContentSize(this.getSize()._width, h);
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCMenuItem'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCMenuItem'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCMenuItem'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var CCNode = require('Code/Cocos2D/CCNode').CCNode;


// TODO:  <UIAccelerometerDelegate, CCStandardTouchDelegate, CCTargetedTouchDelegate>
exports.CCMenuItem = CCNode.subclass(
{
	classname: 'CCMenuItem',
	
	initialize: function()
	{
		this.isEnabled = true;
		this.isSelected = false;
		this._touchTarget = null;
	},

	destroy: function()
	{
		destroy(this._touchTarget);
	},
	
	setIsEnabled: function(enabled)
	{
		this.isEnabled = enabled; 
	},
	
	getSize: function()
	{
		return this._size;
	},
	
	setScale: function(scale, scaleY)
	{	
		if(!scaleY) scaleY = scale;
		
		if(this._touchTarget)
			this._touchTarget.setSize(this.getSize()._width * scale, this.getSize()._width * scaleY); 
	},
	
	setPosition: function($super, position)
	{
		$super(position);
			if(this._touchTarget != null) this._updateTouchTargetProperties();
	},
	
	//Create touch target for this MenuItem
	//{Core.MessageListener} instance of message listener
	//{Function} callback function
	_createTouchTarget: function(listener, onTouchCallback)
	{
		this._touchTarget  = new GL2.TouchTarget();
		
		this._updateTouchTargetProperties();
		this._touchTarget.getTouchEmitter().addListener(listener , onTouchCallback);
		
		return this._touchTarget;
	},
	
	
	setAnchorPoint: function($super, point, hardFix)
	{
		$super(point);
		if(this._touchTarget) { 
				if(!hardFix) this._touchTarget.setAnchor(point._x, -point._y);			
			}
	},
	
	_updateTouchTargetProperties: function()
	{
		if(this._touchTarget != null) 
		{
			//TODO fix that to work with CCSprite
			this._touchTarget.setAnchor([0, 0]);
			
			// TODO make it work even if MenuItem is inside object which is children of another object (Root doesn't count)
			
			this._touchTarget.setPosition(new Core.Vector(this.getPosition()._x, toMY(this.getPosition()._y) - this.getSize()._height ));
			
			this._touchTarget.setSize(this.getSize());
			this._touchTarget.setDepth(this.getDepth());
		}
	},
		
	clicked: function()
	{
		console.log("clicked - shouldn't appear (child clicked should)");
	},
	
	selected: function()
	{
		this._isSelected = true;
	},
	
	unselected: function()
	{
		this._isSelected = false;
	},
	
	activate : function()
	{
		
	},
	
	onTouch: function(touchEvent)
	{	
		if(this.getVisible() == false || this._parentMenu && this._parentMenu.getVisible() == false) return false;
		if(!this.isEnabled) return true;
		
		switch(touchEvent.getAction())
		{
			case touchEvent.Action.Start:
		        this.selected();
				break;
				
			case touchEvent.Action.End:
				this.unselected();
				if(touchEvent.getIsInside(this._touchTarget))
				{
					this.clicked(this._target);
					this.activate();
				}
				break;
			case touchEvent.Action.Move:
				if(touchEvent.getIsInside(this._touchTarget))
				{
				}
				else 
				{
					this.unselected();
				}
				break;
		}
		
		return true;
	},
	
	//
	///** CCMenuItem base class
	//*
	//*  Subclass CCMenuItem (or any subclass) to create your custom CCMenuItem objects.
	//*/
	//@interface CCMenuItem : CCNode
	//{
	//	NSInvocation *invocation;
	//#if NS_BLOCKS_AVAILABLE
	//	// used for menu items using a block
	//	void (^block_)(id sender);
	//#endif
	//	
	//	BOOL isEnabled_;
	//	BOOL isSelected_;
	//}
	//
	///** returns whether or not the item is selected
	//@since v0.8.2
	//*/
	//@property (nonatomic,readonly) BOOL isSelected;
	//
	///** Creates a CCMenuItem with a target/selector */
	//+(id) itemWithTarget:(id)target selector:(SEL)selector;
	//
	///** Initializes a CCMenuItem with a target/selector */
	initWithTarget: function(target, selector){}
	//
	//#if NS_BLOCKS_AVAILABLE
	///** Creates a CCMenuItem with the specified block */
	//+(id) itemWithBlock:(void(^)(id sender))block;
	//
	///** Initializes a CCMenuItem with the specified block */
	//-(id) initWithBlock:(void(^)(id sender))block;
	//#endif
	//
	///** Returns the outside box */
	//-(CGRect) rect;
	//
	///** Activate the item */
	//-(void) activate;
	//
	///** The item was selected (not activated), similar to "mouse-over" */
	//-(void) selected;
	//
	///** The item was unselected */
	//-(void) unselected;
	//
	///** Enable or disabled the CCMenuItem */
	//-(void) setIsEnabled:(BOOL)enabled;
	///** Returns whether or not the CCMenuItem is enabled */
	//-(BOOL) isEnabled;
	//@end
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCMenuItemLayer'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCMenuItemLayer'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCMenuItemLayer'] = exports; 
var CCMenuItemLayer = require('Code/Cocos2D/CCMenuItemLayer').CCMenuItemLayer;
var CCMenuItem = require('Code/Cocos2D/CCMenuItem').CCMenuItem;



exports.CCMenuItemLayer = CCMenuItem.subclass(
{
	classname: "CCMenuItemLayer",
	
	initialize: function()
	{
		
	},
	
	destroy: function()
	{
		if (this._layer) {
			destroy(this._layer);
			this._layer = null;
		}
	},

	
	setSize: function(size)
	{
		this._size = size;
	},
	
	getSize: function()
	{
		return this._size;
	},
	
	clicked: function($super)
	{
		this._selector(this._target);
	},
	
	$itemFromLayer: function(layer, target, selector)
	{
		var item = new this();
		item.initFromLayer(layer, target, selector);
		return item;
	},
	
	initFromLayer: function(layer, target, selector)
	{
		this._selector = selector; 
		this._target = target; 
		this._layer = layer;
		this.addChild(layer);
		this.setSize(layer.getSize());
		layer.setPosition(ccp(0, layer.getSize()._height / 2));
		
		//console.log(this);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCMenuItemSprite'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCMenuItemSprite'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCMenuItemSprite'] = exports; var CCNode = require('Code/Cocos2D/CCNode').CCNode;
var CCMenuItem = require('Code/Cocos2D/CCMenuItem').CCMenuItem;

exports.CCMenuItemSprite = CCMenuItem.subclass(
{
	classname: 'CCMenuItemSprite',
	
	initialize: function()
	{
		this._normalImage = null;
		this._selectedImage = null;
	},
	
	$itemFromNormalSprite: function(normalSprite, selectedSprite, /*disabledSprite,*/ target, selector)
	{
		if (!target)
		{
			target = null;
		}
		
		if (!selector)
		{
			selector = null;
		}
		
		var item = new this();
		item.initFromNormalSprite(normalSprite, selectedSprite, /*disabledSprite,*/ target, selector);
		return item;
	},
	
	initFromNormalSprite: function(normalSprite, selectedSprite, /*disabledSprite, */target, selector)
	{
		this._normalImage = normalSprite;
		this._selectedImage = selectedSprite;
		
		this.setContentSize(this._normalImage.getContentSize());
		
		this._selector = selector;
		this._target = target;
		
		this._normalImage.setAnchorPoint(new Core.Vector(0, 0));
		this._selectedImage && this._selectedImage.setAnchorPoint(new Core.Vector(0, 0));
		
		this.addChild(this._normalImage);
		this._selectedImage && this.addChild(this._selectedImage);
		
		this._selectedImage && this._selectedImage.setVisible(false);
		return this;
	},

	destroy: function()
	{
		this._normalImage = null;
		this._selectedImage = null;
		//this._disabledImage = null;
	},
	
	selected: function()
	{
	    if (this.isEnabled && this._selectedImage && this._normalImage)
	    {
	        this._selectedImage.setVisible(true);
	        this._normalImage.setVisible(false);
	    }
	},

	unselected: function()
	{
	    if (this.isEnabled && this._selectedImage && this._normalImage)
	    {
    	    this._selectedImage.setVisible(false);
    	    this._normalImage.setVisible(true);
	    }
	},
	
	setOpacity: function(opacity)
	{
		
		this._normalImage && this._normalImage.setOpacity(opacity);
		this._selectedImage && this._selectedImage.setOpacity(opacity);
	},

	setColor: function(color)
	{
		this._normalImage && this._normalImage.setColor(color);
		this._selectedImage && this._selectedImage.setColor(color);
		//this._disabledImage.setColor(color);	
	},

	getOpacity: function()
	{
		return this._normalImage._opacity;
	},
	
	getColor: function()
	{
		return this._normalImage._color;
	},
	
	clicked: function(sender)
	{
		this._selector(sender);
	},
	
	setAnchorPoint: function($super, point, hardFix)
	{	
		$super(point, hardFix);
		this._normalImage.setAnchorPoint(point);
		this._selectedImage && this._selectedImage.setAnchorPoint(point);
		//this._disabledImage.setAnchorPoint(point);
	},
	
	getSize: function()
	{
		return this._normalImage.getSize();
	},
	
	setScale : function($super, scale, scaleY)
	{
		if(scale.classname && scale.classname == "Vector") { console.log("��� Wrong arguments in setScale for: "); console.log(this); console.log(arguments);  }; 
		if(!scaleY) scaleY = scale;
		this._normalImage.setScale(new Core.Vector(scale, scaleY));
		this._selectedImage && this._selectedImage.setScale(new Core.Vector(scale, scaleY));
//		this._disabledImage.setScale(new Core.Vector(scale, scaleY));
		$super(scale, scaleY);
	},
	
	setAnchorPoint: function($super, point, hardFix)
	{	
		$super(point, hardFix);
		this._normalImage.setAnchorPoint(point);
		this._selectedImage && this._selectedImage.setAnchorPoint(point);
//		this._disabledImage.setAnchorPoint(point);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCMenuItemImage'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCMenuItemImage'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCMenuItemImage'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var CCNode = require('Code/Cocos2D/CCNode').CCNode;
var CCMenuItem = require('Code/Cocos2D/CCMenuItem').CCMenuItem;
var CCSprite = require('Code/Cocos2D/CCSprite').CCSprite;

exports.CCMenuItemImage = CCMenuItem.subclass(
{
	classname: 'CCMenuItemImage',
	
	//{Text} optional parameter for debugging
	initialize: function()
	{

	},
	
	destroy: function()
	{
		destroyWithChildren(this._selectedSprite);
		destroyWithChildren(this._disabledSprite);		
//		destroy(this._target);
	},
	
	
	selected: function($super)
	{
		$super();

		this._selectedSprite.setVisible(false);
		this._disabledSprite.setVisible(true);
	},
	
//	setVisible: function($super, visible)
//	{
//		$super(visible); 
//		
//		console.log(this);
//		
//		if(!visible)
//		{
//			this._selectedSprite.setVisible(false);
//			this._disabledSprite.setVisible(false);
//		}
//		else
//		{
//			this._selectedSprite.setVisible(true);
//			this._disabledSprite.setVisible(false);
//		}
//	},
//	
	unselected: function($super)
	{
		$super();

		this._selectedSprite.setVisible(true);
		this._disabledSprite.setVisible(false);
	},
	
	setAnchorPoint: function($super, point, hardFix)
	{	
		$super(point, hardFix);
		this._selectedSprite.setAnchorPoint(point);
		this._disabledSprite.setAnchorPoint(point);
	},
	
	replaceSprites: function(selectedImage, disabledImage)
	{
		this._selectedSprite.replaceSprite(selectedImage);
		this._disabledSprite.replaceSprite(disabledImage);
	},
	
	
	$itemFromNormalImage: function(selectedImage, disabledImage, r, s)
	{
		var img = new this();
		img.initFromNormalImage(selectedImage, disabledImage, r, s);
		return img;
	},
	
	//{selectedImage} path to img
	//{disabledImage} path to diabledImg
	//{Object} r - target 
	//{Function} s - selector
	initFromNormalImage: function(selectedImage, disabledImage, r, s)
	{	
		this._selectedSprite = CCSprite.spriteWithFile(selectedImage);
		
		this._disabledSprite = CCSprite.spriteWithFile(disabledImage);
		
		this._selector = s;
		this._target = r;
		
		
		this._selectedSprite.setAnchorPoint(new Core.Vector(0, 0));
		this._disabledSprite.setAnchorPoint(new Core.Vector(0, 0));
		
		this.addChild(this._selectedSprite);
		this.addChild(this._disabledSprite);
		
		this._disabledSprite.setVisible(false);
	},
	
	clicked: function(sender)
	{
		if(typeof this._selector ==  "function")
			this._selector(sender);
		else
		{
			var selector = this._selector;
			eval('(' + "this._target" + "." + selector + "(sender)" + ')');
		}
	},
	
	getSize: function()
	{
		return this._selectedSprite.getSize();
	},
	
	setScale : function($super, scale, scaleY)
	{
		if(scale.classname && scale.classname == "Vector") { console.log("��� Wrong arguments in setScale for: "); console.log(this); console.log(arguments);  }; 
		if(!scaleY) scaleY = scale;
		this._selectedSprite.setScale(new Core.Vector(scale, scaleY));
		this._disabledSprite.setScale(new Core.Vector(scale, scaleY));
		$super(scale, scaleY);
	},
	
	$itemFromNormalSprite: function(selectedSprite, disabledSprite, r, s)
	{
		var img = new this();
		img.initFromNormalSprite(selectedSprite, disabledSprite, r, s);
		return img;
	},
	
	initFromNormalSprite: function(selectedSprite, disabledSprite, r, s)
	{
		this._selectedSprite = selectedSprite;
		this._disabledSprite = disabledSprite;
		
		this._selector = s;
		this._target = r;
	
		this._selectedSprite.setAnchorPoint(new Core.Vector(0, 0));
		this._disabledSprite.setAnchorPoint(new Core.Vector(0, 0));
		
		
		this.addChild(this._selectedSprite);
		this.addChild(this._disabledSprite);
		
		this._disabledSprite.setVisible(false);
	}
	
	///** CCMenuItemImage accepts images as items.
	//The images has 3 different states:
	//- unselected image
	//- selected image
	//- disabled image
	//
	//For best results try that all images are of the same size
	//*/
	//@interface CCMenuItemImage : CCMenuItemSprite
	//{
	//}
	//
	///** creates a menu item with a normal and selected image*/
	//+(id) itemFromNormalImage: (NSString*)value selectedImage:(NSString*) value2;
	///** creates a menu item with a normal and selected image with target/selector */
	//+(id) itemFromNormalImage: (NSString*)value selectedImage:(NSString*) value2 target:(id) r selector:(SEL) s;
	///** creates a menu item with a normal,selected  and disabled image with target/selector */
	//+(id) itemFromNormalImage: (NSString*)value selectedImage:(NSString*) value2 disabledImage:(NSString*) value3 target:(id) r selector:(SEL) s;
	///** initializes a menu item with a normal, selected  and disabled image with target/selector */
	//-(id) initFromNormalImage: (NSString*) value selectedImage:(NSString*)value2 disabledImage:(NSString*) value3 target:(id) r selector:(SEL) s;
	//@end
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCLabel'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCLabel'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCLabel'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var CCNode = require('Code/Cocos2D/CCNode').CCNode;

exports.CCLabel = CCNode.subclass(
{
	classname: 'CCLabel',
	
	initialize: function()
	{	
	},

	destroy: function()
	{
		if (this._label) {
			this.removeChild(this._label);
			destroy(this._label);
			this._label = null;
		}
		
		if (this._bgColor) {
			destroy(this._bgColor);
			this._bgColor = null;
		}
		
//		destroyWithChildren(this);
	},
	
	getColor: function($super)
	{
		$super();
		return this._label.getColor();
	},
	
	//this function determine with labelWithString function to call by name of parameter type so parameters names are 'a,b,c...'
	$labelWithString: function(a,b,c,d,e)
	{
		var label = new this();
		if (d)
		{
		    //function has more then 3 parameters so call labelWithString2
			label.initWithString2(a,b,c,d,e);
		}
		else
		{
			label.initWithString(a,b,c);
		}
		
		label._label.setDepth(1);
		return label;
	},
	
	initWithString: function(string, fontName, fontSize)
	{
		fontSize+=5;

		this._string = string;
//		destroy(this._label);
		this._label = new GL2.Text();
		
		if(Core.Localization._lang == "en"){
			this._label.setFontLocation(GL2.Text.FontLocation.Manifest);
			this._label.setFontFamily("Content/Fonts/onomatoshark.ttf");
		}else{
			this._label.setFontFamily(fontName);
			fontSize *= 0.7;
		}
		
		this._fontSize = fontSize;
		
		// This makes iOS to crash
		//this._label.setFontLocation(GL2.Text.FontLocation.Manifest);
		
		this._label.setText(string);
		if(fontSize) this._label.setFontSize(fontSize);
		//if(fontName) this._label.setFontFamily(fontName);
		
		this._contentSize = this._label.getSize(); //TODO: get current size of text
		
		this._label.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
		this._label.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		
		this.addChild(this._label);
	},
	
	initWithString2: function(string, dimension, align_H, fontName, fontSize)
	{
		fontSize+=5;
		
		this._string = string;
		this._label = new GL2.Text();
//		this._label.setOverflowMode(GL2.Text.OverflowMode.ReduceFontSize);
		
		if(Core.Localization._lang == "en"){
			this._label.setFontLocation(GL2.Text.FontLocation.Manifest);
			this._label.setFontFamily("Content/Fonts/onomatoshark.ttf");
		}else{
			this._label.setFontFamily(fontName);
			fontSize *= 0.9;
		}
		
		
		this._fontSize = fontSize;
		
		this._label.setText(string);
		if(fontSize) this._label.setFontSize(fontSize);
		//if(fontName) this._label.setFontFamily(fontName);
		
		// This makes iOS to crash
		//this._label.setFontLocation(GL2.Text.FontLocation.Manifest);
		
		this._contentSize = this._label.getSize(); //TODO: get current size of text
		
		this._label.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
		this._label.setHorizontalAlign(align_H);
		
		this._size = dimension;
		this._label.setSize(dimension);
		//this._label.setOverflowMode(GL2.Text.OverflowMode.Multiline);
		
		this.addChild(this._label);
	},
	
	setSize: function(size)
	{
		size.setWidth(size._width + 5);
		size.setHeight(size._height + 5);
		this._label.setSize(size);
	},
	
	setHorizontalAlign: function(align)
	{
		this._label.setHorizontalAlign(align);
	},
	
	setVerticalAlign: function(align)
	{
		this._label.setVerticalAlign(align);
	},
	
	setString: function(text)
	{
	    if (this._label)
	    {
	        this._label.setText(text);
	    }
	},
	
	setScale: function(scale)
	{
		this._label.setFontSize(this._fontSize * scale);
	},

	setColor: function($super, color)
	{
		$super(color);
		this._label.setColor(color);
	},
	
	//ERASE: ngcore inherit the opacity/alpha, so if set to the parent, then all the child will have this opacity.
	//value between [0..255]
	/*setOpacity: function($super, opacity)
	{
		$super(opacity); 
		
		var alpha = opacity/255;
		this._label.setAlpha(alpha);
	},*/
	

	setShadowColor: function(color)
	{
		console.log("CCLabel.setShadowColor: Method not implemented");
	},
	
	setBackgroundColor: function(color)
	{
		this._bgColor = CCColorLayer.layerWithColor(color, this._size._width, this._size._height);
		this._bgColor.setDepth(0);
		this.addChild(this._bgColor);	
	},
	
	setShadowOffset: function(point)
	{
	    console.log("CCLabel.setShadowOffset: Method not implemented");
	},
	
	setAnchorPoint: function($super, point)
	{
		this._label.setAnchor(point._x,point._y);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCMenu'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCMenu'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCMenu'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var CCLayer = require('Code/Cocos2D/CCLayer').CCLayer;
var CCMenuItem = require('Code/Cocos2D/CCMenuItem').CCMenuItem;

exports.CCMenu = CCLayer.subclass(
{
	classname: 'CCMenu',
	
	initialize: function()
	{
		

	},
	
	destroy: function()
	{
		for(var i in this._children)
		{
			destroy(this._children[i]);
		}
	},
	
	$menuWithItems: function(menuItems)
	{
		var menu = new this();
		menu.initWithItems(menuItems);
		return menu;
	},
	
	//Create CCMenu class with passed items
	//{Array of MenuItems} menuItems
	initWithItems: function(menuItems)
	{		
		this._menuItems = menuItems;
		
//		//Add TouchListener for each menuItem
		this._msgListener = new Core.MessageListener();
		
		for(var i in menuItems)
		{
			var it = menuItems[i];
			it._parentMenu = this;
			
			this.addChild(it, 0);
			{
				var target = it._createTouchTarget(this._msgListener, it.onTouch.bind(it));
				this.addChild(target,1);
				var targetPos = new Core.Point(-it.getSize()._width * it._anchorPoint._x + it.getPosition()._x, it.getSize()._height * it._anchorPoint._y - it.getPosition()._y - it.getSize()._height);
				target.setPosition(targetPos);
			}
		}

		
	},
//	
//	destroy: function($super)
//	{
//		for(var i in this._menuItems)
//		{
//			var it = this._menuItems[i];
//			it.destroy();
//		}
//		
//		this.msgListener.destroy();
//		
//		$super();
//	},
	
	childrenCount: function()
	{
		return this._menuItems.length; 
	},
	
	alignItemsHorizontally: function()
	{
		this.alignItemsHorizontallyWithPadding(0);
	},
	
	alignItemsHorizontallyWithPadding: function(padding)
	{
		var width = -padding;
		var item;
		
		for(var i in this._menuItems)
		{
			var it = this._menuItems[i];
			width += it.getSize()._width * it.getScale()._x + padding;
		}

		var x = -width / 2;
		
		for(var i in this._menuItems)
		{
			var it = this._menuItems[i];
			it.setPosition(ccp(x + it.getSize()._width * it.getScale()._x / 2, 0));
			x += it.getSize()._width * it.getScale()._x + padding;
		}
	},
	
	alignItemsVerticallyWithPadding: function(padding)
	{
		var height = -padding;
		var item;
		
		for(var i in this._menuItems)
		{
			var it = this._menuItems[i];
			height += it.getSize()._height * it.getScale()._y + padding;
		}

		var y = -height / 2;
		
		for(var i in this._menuItems)
		{
			var it = this._menuItems[i];
			it.setPosition(ccp(0, y - it.getSize()._height * it.getScale()._y / 2));
			y -= it.getSize()._height * it.getScale()._y + padding;
		}
	}

//// Create touch target.
//this._target = new GL2.TouchTarget();
////this._target.setAnchor(this._bg.getAnimation().getFrame(0).getAnchor());
//this._target.setSize(size);
//this._target.getTouchEmitter().addListener(this, this.onTouch);
//this._node.addChild(this._target);


	//
	///** A CCMenu
	// * 
	// * Features and Limitation:
	// *  - You can add MenuItem objects in runtime using addChild:
	// *  - But the only accecpted children are MenuItem objects
	// */
	//@interface CCMenu : CCLayer <CCRGBAProtocol>
	//{
	//	MenuState state;
	//	CCMenuItem *selectedItem;
	//	GLubyte		opacity_;
	//	ccColor3B	color_;
	//}
	//
	///** creates a CCMenu with it's items */
	//+ (id) menuWithItems: (CCMenuItem*) item, ... NS_REQUIRES_NIL_TERMINATION;
	//
	///** initializes a CCMenu with it's items */
	//- (id) initWithItems: (CCMenuItem*) item vaList: (va_list) args;
	//
	///** align items vertically */
	//-(void) alignItemsVertically;
	///** align items vertically with padding
	// @since v0.7.2
	// */
	//-(void) alignItemsVerticallyWithPadding:(float) padding;
	//
	///** align items horizontally */
	//-(void) alignItemsHorizontally;
	///** align items horizontally with padding
	// @since v0.7.2
	// */
	//-(void) alignItemsHorizontallyWithPadding: (float) padding;
	//
	//
	///** align items in rows of columns */
	//-(void) alignItemsInColumns: (NSNumber *) columns, ... NS_REQUIRES_NIL_TERMINATION;
	//-(void) alignItemsInColumns: (NSNumber *) columns vaList: (va_list) args;
	//
	///** align items in columns of rows */
	//-(void) alignItemsInRows: (NSNumber *) rows, ... NS_REQUIRES_NIL_TERMINATION;
	//-(void) alignItemsInRows: (NSNumber *) rows vaList: (va_list) args;
	//
	//
	///** conforms to CCRGBAProtocol protocol */
	//@property (nonatomic,readonly) GLubyte opacity;
	///** conforms to CCRGBAProtocol protocol */
	//@property (nonatomic,readonly) ccColor3B color;
	//
	//@end
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCSprite'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCSprite'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCSprite'] = exports; var CCTexture2D = require('Code/Cocos2D/CCTexture2D').CCTexture2D;

exports.CCSprite = CCNode.subclass(
{
	classname: 'CCSprite',
	
	initialize: function()
	{	
		this._anchorPoint = new Core.Point(0.5, 0.5);
		
		this._sprite = null;
	},
	
    destroy: function()
    {        
        this._sprite = null;
        this._anchorPoint = null;
    },
	
	getSize: function()
	{
		return this._textureRect.getSize();
	},
	
    setRotation: function(rotate)
    {
    	this._rotation = rotate;
        if(this._sprite != null) {
            this._sprite.setRotation(rotate);
        }
    },
	
	getRotation: function()
	{
		return this._rotation;
	},
//	
	initWithSpriteFrame: function(spriteFrame, anchor)
	{
		if(!anchor) anchor = new Core.Point(0.5, 0.5);
		this._anchorPoint = anchor;
		
		var name = spriteFrame._textureName ? spriteFrame._textureName : spriteFrame._imageName;
		//this._sprite = new GL2.Sprite();
		var uvs = new Core.Rect(spriteFrame._rect.getMinX() / spriteFrame._imageSize._width, spriteFrame._rect.getMinY() / spriteFrame._imageSize._height,
		spriteFrame._rect.getSize()._width / spriteFrame._imageSize._width, spriteFrame._rect.getSize()._height / spriteFrame._imageSize._height);
		this._sprite = SpriteFactoryCache.createSpriteWithCachedAnimation(name, spriteFrame._rect.getSize(), anchor, uvs);
		//this._sprite.setImage(spriteFrame._imageName, spriteFrame._rect.getSize(), anchor , uvs)._animation.setFilteringEnabled(false);
	
//		var spritePos = new Core.Point( -spriteFrame._rect.getSize()._width  * this._anchorPoint._x,
//				spriteFrame._rect.getSize()._height * this._anchorPoint._y - spriteFrame._rect.getSize()._height );
//
//		this._sprite.setPosition(spritePos);				

		this.addChild(this._sprite);
		this._textureRect = spriteFrame._rect;
//		this.setContentSize(this._textureRect.getSize());
		this._specialOffset = spriteFrame._offset;
		this.setContentSize(spriteFrame._originalSize);
	},
	
	$spriteWithSpriteSheet: function(spritesheet, rect, anchor)
	{
		var s = new this();
		s.initWithSpriteSheet(spritesheet, rect, anchor);
		return s;
	},
	
	initWithSpriteSheet: function(spritesheet, rect, anchor )
	{
		if ( !anchor )
		{
			this._anchorPoint = new Core.Point( 0.5 , 0.5 );
		}
		else
		{
			this._anchorPoint = new Core.Point( anchor._x , anchor._y );
		}
		
		//this._sprite = new GL2.Sprite();

		var uvs = new Core.Rect( rect.getMinX() / spritesheet.texture()._imageSize._width,
								 rect.getMinY() / spritesheet.texture()._imageSize._height,
								 rect.getSize()._width / spritesheet.texture()._imageSize._width,
								 rect.getSize()._height / spritesheet.texture()._imageSize._height );
		
		this._sprite = SpriteFactoryCache.createSpriteWithCachedAnimation('./Content/' + spritesheet.texture()._textureName, rect.getSize(), this._anchorPoint, uvs);
		//this._sprite.setImage('./Content/' + spritesheet.texture()._textureName, rect.getSize(), this._anchorPoint, uvs)._animation.setFilteringEnabled(false);
		
//		var spritePos = new Core.Point( -rect.getSize()._width  * this._anchorPoint._x,
//										 rect.getSize()._height * this._anchorPoint._y - rect.getSize()._height );
//
//		this._sprite.setPosition(spritePos);				
		
		this.addChild(this._sprite);
		this._textureRect = rect;
		this.setContentSize(this._textureRect.getSize());
	},
	
	initWithFile: function(filename, anchor)
	{
//		NSAssert(filename!=nil, @"Invalid filename for sprite");

//		var texture = CCTextureCache.sharedTextureCache().addImage(filename);
//		if( texture ) {
//			var rect = new Core;
//			rect.size = texture.contentSize;
//			return [self initWithTexture:texture rect:rect];
//		}
//
//		[self release];
//		return nil;
		
		if(!anchor) anchor = new Core.Point(0.5, 0.5);
		this._anchorPoint = anchor;
		
		var texture = new CCTexture2D();
		texture.initWithFileName(filename);
		var rect = new Core.Rect(new Core.Point(0, 0), texture._imageSize);
		//this._sprite = new GL2.Sprite();
		var uvs = new Core.Rect(rect.getMinX() / texture._imageSize._width, rect.getMinY() / texture._imageSize._height,
		rect.getSize()._width / texture._imageSize._width, rect.getSize()._height / texture._imageSize._height);
		this._sprite = SpriteFactoryCache.createSpriteWithCachedAnimation('./Content/' + texture._textureName, rect.getSize(), anchor , uvs);
		//this._sprite.setImage('./Content/' + texture._textureName, rect.getSize(), anchor , uvs)._animation.setFilteringEnabled(false);
		
//		var spritePos = new Core.Point( -rect.getSize()._width  * this._anchorPoint._x,
//				 rect.getSize()._height * this._anchorPoint._y - rect.getSize()._height );
//
//		this._sprite.setPosition(spritePos);					

		this.addChild(this._sprite);
		this._textureRect = rect;
		this.setContentSize(this._textureRect.getSize());
	},
	
	initWithFile_rect: function(filename, rect, anchor)
	{
		if(!anchor) anchor = new Core.Point(0.5, 0.5);
		this._anchorPoint = anchor;
		
		var texture = new CCTexture2D();
		texture.initWithFileName(filename);
		//this._sprite = new GL2.Sprite();
		var uvs = new Core.Rect(rect.getMinX() / texture._imageSize._width, rect.getMinY() / texture._imageSize._height,
		rect.getSize()._width / texture._imageSize._width, rect.getSize()._height / texture._imageSize._height);
		this._sprite = SpriteFactoryCache.createSpriteWithCachedAnimation('./Content/' + texture._textureName, rect.getSize(), anchor , uvs);
		//this._sprite.setImage('./Content/' + texture._textureName, rect.getSize(), anchor , uvs)._animation.setFilteringEnabled(false);
//		
//		var spritePos = new Core.Point( -rect.getSize()._width  * this._anchorPoint._x,
//				 rect.getSize()._height * this._anchorPoint._y - rect.getSize()._height );

//		this._sprite.setPosition(spritePos);		
		
		this.addChild(this._sprite);
		this._textureRect = rect;
		this.setContentSize(this._textureRect.getSize());

	},
	

	
	//helper function to calculate UV 
	_calculateUV: function(partOfImage, sizeOfImage)
	{		
		var x1 = partOfImage.getMinX() / sizeOfImage._width;
		var y1 = partOfImage.getMinY() / sizeOfImage._height;
		var x2 = partOfImage.getSize()._width / sizeOfImage._width;
		var y2 = partOfImage.getSize()._height /  sizeOfImage._height ;
		
		return new Core.Rect(x1,y1,x2,y2);	
	},
	
	//{String} path to file
	//{Core.Rect}[Optional] rect 
	$spriteWithFile: function(file, rect, anchor)
	{
//		var CCSprite = require('./CCSprite').CCSprite;
		var sprite = new this();
		
		if(rect && (rect.classname != "Rect" && !anchor))
			{
				anchor = rect;
				rect = null;
			}

//		//save stuff for replacing
//		this._file = file;
//		this._rect = rect;
//		
//		
//		this._sprite = new GL2.Sprite();
//		var imageSize = new Core.Size(imagesSize[file]);
//		
		if(!rect)
		{			
//			this._sprite.setImage("./Content/" + file, imageSize, [0,0])._animation.setFilteringEnabled(false);
//			this._textureRect = new Core.Rect(0, 0, imageSize._width, imageSize._height);
			sprite.initWithFile(file, anchor);
		}
		else
		{ 
//			var imgPart = this._calculateUV(rect, imageSize);		
//			this._sprite.setImage("./Content/" + file, rect.getSize(), [0,0], imgPart)._animation.setFilteringEnabled(false);
//			this._textureRect = rect;
			sprite.initWithFile_rect(file, rect, anchor);
//			
		}
//		this.setContentSize(this._textureRect.getSize());
//		//this.setAnchorPoint(new Core.Vector(0, 0.5));
//		this.addChild(this._sprite);
		
		return sprite;
	},
	
	replaceSprite: function(file)
	{
		var imageSize = new Core.Size(imagesSize[file]);
		this._sprite.setAnimation(SpriteFactoryCache.getAnimation("./Content/" + file, imageSize, [0.5,0.5]));
		this._textureRect = new Core.Rect(0, 0, imageSize._width, imageSize._height);
		this.setContentSize(this._textureRect.getSize());
	},

	
	setColor: function(color)
	{
		this._sprite.setColor(color);
	},
	
	getColor: function($super)
	{
		return this._sprite.getColor();
	},
	
	setAnchorPoint: function($super, point, y)
	{
		if(y!=null) {
			point = {_x: point,_y: y};
		}
		
		$super(point);
		this._sprite.setPosition(
				-this._textureRect._size._width  * ( this._anchorPoint._x - 0.5 ),
				this._textureRect._size._height * ( this._anchorPoint._y + 0.5 ) - this._textureRect._size._height);
	},
	
	flipX: function() {
		return this._flipX;
	},
	
	$spriteWithSpriteFrame: function(spriteFrame)
	{
		var s = new this();
		s.initWithSpriteFrame(spriteFrame);
		return s;
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCDirector'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCDirector'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCDirector'] = exports; var CCTransitionScene = require('Code/Cocos2D/CCTransition').CCTransitionScene;

exports.CCDirector = Core.Class.singleton({
	classname : 'CCDirector',

	initialize : function() {
//		console.log("init CCDirector");
		this._runningScene = null;
		this._nextScene = null;

		this._sceneStack = [];

		// landscape
		this._deviceOrientation = Device.OrientationEmitter.getInterfaceOrientation();
//		console.log("CCDirector: device orientation: " + this._deviceOrientation);

		// FPS
		this._displayFPS = false;
		this._frames = 0;

		// paused ?
		this._isPaused = false;

		this._contentScaleFactor = 1;
		this._screenSize = new Core.Size(0, 0);
		this._isContentScaleSupported = false;

		// animationTimer = [NSTimer
		// scheduledTimerWithTimeInterval:animationInterval_ target:self
		// selector:@selector(drawScene) userInfo:nil repeats:YES];

		this._transformationNode = new GL2.Node();
		// TODO : screenheight is hardcoded
		this._transformationNode.setPosition(new Core.Point(0, UI.Window._height));
//		console.log("Screen height = " + UI.Window._width);
		// this._transformationNode.setRotation(180);
		// this._transformationNode.setScale(new Core.Vector(1, -1));
		this._node = new GL2.Node();
		this._transformationNode.addChild(this._node);
		GL2.Root.addChild(this._transformationNode);

		this._fcount = 0;
		this._schedulerdt = 0;
		
		this._listener = new Core.MessageListener();
		Core.UpdateEmitter.addListener(this._listener, this.drawScene.bind(this));
		
		this._lastSave = Core.Time.getRealTime();
	},

	pause : function() {
		if (this._isPaused)
			return;
		this._isPaused = true;
	},

	resume : function() {
		if (!this._isPaused)
			return;

		this._isPaused = false;
		this._dt = 0;
	},

	runningScene : function() {
		return this._runningScene;
	},

	sharedDirector : function() {
		return this;
	},

	winSize : function() {
		if (this._deviceOrientation == Device.OrientationEmitter.Orientation.LandscapeLeft
				|| this._deviceOrientation == Device.OrientationEmitter.Orientation.LandscapeRight) {
			return new Core.Size(UI.Window._width, UI.Window._height);
		} else {
			return new Core.Size(UI.Window._height, UI.Window._width);
		}
	},
	
	zoomValue : function() {
		var size = CCDirector.winSize();
		if(size._height > 320 || size._width > 480)
		{
			return new Core.Vector(1.25, 1.25);
		}
		return new Core.Vector(1.0, 1.0);
	},

	runWithScene : function(scene) {
		NSAssert(scene != null, "Argument must be non-null");
		NSAssert(this._runningScene == null, "You can't run an scene if another Scene is running. Use replaceScene or pushScene instead");
//		console.log("runWithScene scene " + scene.classname);
		this.pushScene(scene);
		this.startAnimation();
	},

	pushScene : function(scene) {
		this._sendCleanupToScene = false;
		this._sceneStack.push(scene);
		this._nextScene = scene;
//		console.log("pushed scene = " + this._nextScene);
	},

	startAnimation : function() {
	},

	replaceScene : function(scene) {
		NSAssert(scene, "CCDirector::replaceScene - Argument must be non-null");

		var index = this._sceneStack.length;

		this._sendCleanupToScene = true;
		this._sceneStack[index - 1] = scene;
		this._nextScene = scene; // nextScene_ is a weak ref
	},

	drawScene : function(delta) {
		/* calculate "global" dt */
		//Min 20 FPS (0.05) on slow machines
		dt = Math.min(delta / 1000, 0.05);
		
		this._fcount++;
		/* tick before glClear: issue #533 */
		if (!this._isPaused) {
			this._schedulerdt += dt;
			//target minimum 20fps for the game and no less than 5fps for the scheduled
			if (dt > 0.05 && this._schedulerdt < 0.20) {
				CCScheduler.tickUpdateAndDraw(dt);
//				(this._fcount % 10 == 0) && console.log ("CCDirector.drawScene: CCScheduler.tick displaced to next frame");
			} else {
//				var ini = Core.Time.getRealTime();
				CCScheduler.tickUpdateAndDraw(dt);
				CCScheduler.tickScheduled(this._schedulerdt);
//				(this._fcount % 10 == 0) && console.log("CCDirector.drawScene: CCScheduler.tick took: " + ((Core.Time.getRealTime() - ini) / 1000));
				this._schedulerdt = 0;
			}

		}

		if (this._nextScene) {
			this.setNextScene();
		}

		/* draw the scene */
		if (this._runningScene) {
			// var ini = Core.Time.getRealTime();
			this._runningScene.draw();
			// console.log("CCDirector.drawScene: _runningScene.visit took: " +
			// ((Core.Time.getRealTime() - ini)/1000));
		}
		
		if (this._runningScene instanceof ZFFarmGameScene)
		{
		    if (this.shouldAutoSave())
		    {
		    	console.log ("CCDirector: auto saving");
		        GameState.saveGameReal();
		    }
		}
	},
	
	shouldAutoSave: function () {
		return (Core.Time.getRealTime() - this._lastSave)/1000 > 30;
	},
	
	shouldSave: function () {
		return (Core.Time.getRealTime() - this._lastSave)/1000 > 10;
	},

	setNextScene : function() {
		var runningIsTransition = this._runningScene instanceof CCTransitionScene;
		var newIsTransition = this._nextScene instanceof CCTransitionScene;

		// If it is not a transition, call onExit/cleanup
		if (!newIsTransition) {
			if (this._runningScene)
				this._runningScene.onExit();

			// issue #709. the root node (scene) should receive the cleanup
			// message too
			// otherwise it might be leaked.
			if (this._sendCleanupToScene && (this._runningScene)) {
				this._runningScene.cleanup();
			}
		}

		if (this._runningScene)
		{
		    this._node.removeChild(this._runningScene);
		}
		
		this._runningScene = this._nextScene;
		this._node.addChild(this._runningScene);
		this._nextScene = null;

		if (!runningIsTransition) {
			this._runningScene.onEnter();
			// this.runningScene.onEnterTransitionDidFinish();
		}
	}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCSpriteSheet'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCSpriteSheet'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCSpriteSheet'] = exports; var CCNode = require('Code/Cocos2D/CCNode').CCNode;
var CCTextureAtlas = require('Code/Cocos2D/CCTextureAtlas').CCTextureAtlas;
var CCTexture2D = require('Code/Cocos2D/CCTexture2D').CCTexture2D;

exports.CCSpriteSheet = CCNode.subclass(
{
	classname: 'CCSpriteSheet',
	
	initialize: function()
	{	
		//console.log("CCSpriteSheet initialize");
	},
	
	/*
	destroy: function($super)
	{
		this._textureAtlas.destroy();
		$super();
	},*/
	
	initWithTexture: function(texture, capacity)
	{
		this._textureAtlas = new CCTextureAtlas(texture, capacity);
	},
	
	$spriteSheetWithFile: function(fileImage, capacity)
	{
		var s = new this();
		s.initWithFile(fileImage, capacity);
		return s;
	},
	
	initWithFile: function(fileImage, capacity)
	{
		var tex = new CCTexture2D();
		tex.initWithFileName(fileImage);
		this.initWithTexture(tex, capacity);
	},
	
	/*
	removeChild: function($super, sprite, doCleanup)
	{
		// explicit nil handling
		if (!sprite)
			return;
		
//		NSAssert([children_ containsObject:sprite], @"CCSpriteSheet doesn't contain the sprite. Can't remove it");
		
		// cleanup before removing
// TODO ?		
//		[self removeSpriteFromAtlas:sprite];
		
		$super(sprite, doCleanup);
	},*/
	
	//super method added for CCTMXLayer call to [super removeChild] from removeTileAt
	removeTileAt: function(sprite, doCleanup)
	{
		this.removeChild(sprite, doCleanup);
	},
	
	texture: function()
	{
		return this._textureAtlas._texture;
	}	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCMenuItemToggle'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCMenuItemToggle'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCMenuItemToggle'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var CCNode = require('Code/Cocos2D/CCNode').CCNode;
var CCMenuItem = require('Code/Cocos2D/CCMenuItem').CCMenuItem;
var CCSprite = require('Code/Cocos2D/CCSprite').CCSprite;

exports.CCMenuItemToggle = CCMenuItem.subclass(
{
	classname: 'CCMenuItemToggle',
	
	kCurrentItem: 0xc0c05001,
	
	initialize: function()
	{
		this._selectedIndex = -1;
		
	},
	
	destroy: function()
	{
		for(var i in this._children)
			destroy(this._children[i]);
	},
	
	$itemWithTarget: function(t, sel, item)
	{
		var s = new this();
		s.initWithTarget(t,sel,item);
		return s;
	},

	initWithTarget: function(t, sel, item)
	{
		this._subItems = [];
		var z = 0;
		
		for(var i in item)
		{
			var it = item[i];
			
			this._subItems.push(it);
			this.setSize(it.getSize());
			this.addChild(it, 0 /*, kCurrentItem*/);
			it.setVisible(false);
		}
			
		this._target = t;
		this._selector = sel;
		
		this._selectedIndex = 1;
		this.setSelectedIndex(0);
	},
	
	getSize: function()
	{
		return this._size;
	},
	
	setSize: function(size)
	{
		this._size = size;
	},
	
	clicked: function(sender)
	{
		this._selector(sender);
		
		//console.log(this);
	},
	
	setSelectedIndex: function(index)
	{
		if(this._selectedIndex != index)
		{
			if ( this._subItems[this._selectedIndex]) {
				this._subItems[this._selectedIndex].setVisible(false);
			}
			this._selectedIndex = index;
			//this.removeChildByTag(this.kCurrentItem, false);
			
			//var item = this._subItems[this._selectedIndex];
			this._subItems[this._selectedIndex].setVisible(true);
			//this.addChild(item, 0, this.kCurrentItem);
			
			//item.setPosition = ccp( item.getSize()._width/2, item.getSize().getHeight/2 );
		}
	},
	
	selected: function($super)
	{
		//console.log(this._selectedIndex);
		
		this._subItems && this._selectedIndex && this._subItems[this._selectedIndex] && this._subItems[this._selectedIndex].selected();		
		
		$super();
	},
	
	unselected: function($super)
	{
		$super();
		this._subItems && this._selectedIndex && this._subItems[this._selectedIndex] && this._subItems[this._selectedIndex].unselected();
	},
//	
	activate : function($super)
	{
		if( this.isEnabled && this._mausTag) {
			var newIndex = (this._selectedIndex + 1) % this._subItems.length;
			this.setSelectedIndex(newIndex);
		}

		$super();
	}
//
//	-(void) setIsEnabled: (BOOL)enabled
//	{
//		[super setIsEnabled:enabled];
//		for(CCMenuItem* item in subItems_)
//			[item setIsEnabled:enabled];
//	}
//
//	-(CCMenuItem*) selectedItem
//	{
//		return [subItems_ objectAtIndex:selectedIndex_];
//	}
//
//	#pragma mark CCMenuItemToggle - CCRGBAProtocol protocol
//
//	- (void) setOpacity: (GLubyte)opacity
//	{
//		opacity_ = opacity;
//		for(CCMenuItem<CCRGBAProtocol>* item in subItems_)
//			[item setOpacity:opacity];
//	}
//
//	- (void) setColor:(ccColor3B)color
//	{
//		color_ = color;
//		for(CCMenuItem<CCRGBAProtocol>* item in subItems_)
//			[item setColor:color];
//	}

});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCSpawn'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCSpawn'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCSpawn'] = exports; var CCIntervalAction = require('Code/Cocos2D/CCIntervalAction').CCIntervalAction;
var CCSequence = require('Code/Cocos2D/CCSequence').CCSequence;
var CCDelayTime = require('Code/Cocos2D/CCDelayTime').CCDelayTime;

exports.CCSpawn = CCIntervalAction.subclass(
{
	classname: "CCSpawn",
	
	$actions: function( actionsArray )
	{
		if (!(actionsArray instanceof Array)) {
			actionsArray = Array.prototype.slice.call(arguments,0);
		}
		var now;
		var prev = actionsArray[ 0 ];
		
		if ( actionsArray )
		{
			for ( var i = 0 ; actionsArray.length ; i++ )
			{
				now = actionsArray[ i ];
				
				if ( now )
				{
					prev = this.actionOne( prev , now );
				}
				else
				{
					break;
				}
			}
		}
		
		return prev;
	},
	
	$actionOne: function( one , two )
	{
		var CCSpawn = require('Code/Cocos2D/CCSpawn').CCSpawn;
		var action = new CCSpawn();
		action.initOne( one , two );
		return action;
	},

	initOne: function( one_ , two_ )
	{
		var d1 = one_._duration;
		var d2 = two_._duration;	
		
		this.initWithDuration( Math.max( d1 , d2 ) );

		this._one = one_;
		this._two = two_;

		if( d1 > d2 )
		{
			this._two = CCSequence.actions(two_ , CCDelayTime.actionWithDuration( d1 - d2 ));
		}
		else if( d1 < d2 )
		{
			this._one = CCSequence.actions(one_ , CCDelayTime.actionWithDuration( d2 - d1 ));
		}
		
		return this;
	},

//	-(id) copyWithZone: (NSZone*) zone
//	{
//		CCAction *copy = [[[self class] allocWithZone: zone] initOne: [[one copy] autorelease] two: [[two copy] autorelease] ];
//		return copy;
//	}

//	-(void) dealloc
//	{
//		[one release];
//		[two release];
//		[super dealloc];
//	}

	startWithTarget: function( $super , aTarget )
	{
		$super( aTarget );
		this._one.startWithTarget( aTarget );
		this._two.startWithTarget( aTarget );
	},

	stop: function( $super )
	{
		this._one.stop();
		this._two.stop();
		$super();
	},

	update: function( t )
	{
		this._one.update( t );
		this._two.update( t );
	}

//	- (CCIntervalAction *) reverse
//	{
//		return [[self class] actionOne: [one reverse] two: [two reverse ] ];
//	}
//	@end
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCSpriteFrameCache'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCSpriteFrameCache'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCSpriteFrameCache'] = exports; var CCSpriteFrame = require('Code/Cocos2D/CCSpriteFrame').CCSpriteFrame;

exports.CCSpriteFrameCache = Core.Class.singleton(
{
	classname: 'CCSpriteFrameCache',
	
	initialize: function()
	{	
		this._spriteFrames = {};
	},
	
	sharedSpriteFrameCache : function()
	{
		return this;
	},
	
/** Adds multiple Sprite Frames with a dictionary. The texture will be associated with the created sprite frames.
 */
	$addSpriteFramesWithDictionary: function(dictionary ,textureName)
	{
		/*
		Supported Zwoptex Formats:
			enum {
				ZWTCoordinatesListXMLFormat_Legacy = 0
				ZWTCoordinatesListXMLFormat_v1_0,
			};
		*/
	    
		var metadataDict = dictionary.metadata;
		var framesDict  =  dictionary.frames;
		
		var format = 0;
		
		// get the format
		if(metadataDict)
		{
			format = metadataDict.format;
		}
		
		// check the format
		if(format !=1 && format != 3) {
			console.log("CCSpriteFrameCache.addSpriteFramesWithDictionary: format 1 and 3 are not supported");
			return;
		}

		for (var frameDictKey in framesDict)
		{
			var frameDict = framesDict[frameDictKey];
			var spriteFrame;
			if(format == 0) {
				var x = frameDict.x;
				var y = frameDict.y;
				var w = frameDict.width;
				var h = frameDict.height;
				var ox = frameDict.offsetX;
				var oy = frameDict.offsetY;
				var ow = frameDict.originalWidth;
				var oh = frameDict.originalHeight;
				// abs ow/oh
				ow = Math.abs(ow);
				oh = Math.abs(oh);
				// create frame
				spriteFrame = new CCSpriteFrame(textureName, CGRectMake(x, y, w, h), CGPointMake(ox, oy), CGSizeMake(ow, oh));
			} else if(format == 1) {
				var frame = CGRectFromString(frameDict.frame);
				var offset = CGPointFromString(frameDict.offset);
				var sourceSize = CGSizeFromString(frameDict.sourceSize);
				var imageSize = CGSizeFromString(metadataDict.size);
				// create frame
				spriteFrame = new CCSpriteFrame(textureName, frame, offset, sourceSize, imageSize);
			}
			else if(format == 3) 
			{			    
				// get values
				var spriteSize = CGSizeFromString(frameDict.spriteSize);
				var spriteOffset = CGPointFromString(frameDict.spriteOffset);
				var spriteSourceSize = CGSizeFromString(frameDict.spriteSourceSize);
				var textureRect = CGRectFromString(frameDict.textureRect);
				var imageSize = CGSizeFromString(metadataDict.size);
				// create frame
				spriteFrame = new CCSpriteFrame(
				        textureName,
				        new Core.Rect(textureRect.getOrigin(), spriteSize),
				        spriteOffset,
				        spriteSourceSize,
				        imageSize);
			}
			else 
			{
			    throw new Error("CCSpriteFrameCache.addSpriteFramesWithDictionary: unsupported zwoptex version");
			}
	
			// add sprite frame
			this._spriteFrames[frameDictKey] = spriteFrame;
		}
		
	},
	
/** Adds multiple Sprite Frames from a plist file.
 * A texture will be loaded automatically. The texture name will composed by replacing the .plist suffix with .png
 * If you want to use another texture, you should use the addSpriteFramesWithFile:texture method.
 */
	addSpriteFramesWithFile: function(plist)
	{
		var self = this;
	    Storage.FileSystem.readFile(plist, false, 
	    function(err, file)
   		{
   			if(err)
	        {
	            console.log("CCSpriteFrameCache.Error == " + err);
	        }
	        else
	        {
//	            console.log("File = " + file);
	            var jsonfile = eval('(' + file + ')');
	            self.addSpriteFramesWithFileCallback(plist, jsonfile);
	        }   
   		});
	},
	
	addSpriteFramesWithFileCallback: function(plist, dict)	
	{
	    console.log("CCSpriteFrameCache.addSpriteFramesWithFileCallback: Method not implemented");
		var texturePath = "./Content/" + plist.replace(".plist", ".png");
//		CCTexture2D *texture = [[CCTextureCache sharedTextureCache] addImage:texturePath];
//		return [self addSpriteFramesWithDictionary:dict texture:texture];
		this.addSpriteFramesWithDictionary(dict, texturePath);
	},
	
	spriteFrameByName: function(name)
	{
		var frame = this._spriteFrames[name];
		if(!frame)
		{
			console.log("cocos2d: CCSpriteFrameCache: Frame not found " + name);
		}
		
		return frame;
	},
	
	removeUnusedSpriteFrames: function()
	{
	    console.log("CCSpriteFrameCache.removeUnusedSpriteFrames: Method not implemented");
		//TODO
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCScene'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCScene'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCScene'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var CCNode = require('Code/Cocos2D/CCNode').CCNode;

exports.CCScene = CCNode.subclass(
{
	classname: 'CCScene',
	
	initialize: function()
	{	
//		console.log("CCScene initialize");
		this._isRelativeAnchorPoint = false;
		this._anchorPoint.setAll(0.5, 0.5);
		this.setContentSize(new Core.Size(UI.Window._height, UI.Window._width));
	},
	
	draw: function () {
	}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/CCTableViewSuite/CCScrollView'] = function(){var exports = $MODULE_REGISTRY['Code/CCTableViewSuite/CCScrollView'] || {}; $MODULE_REGISTRY['Code/CCTableViewSuite/CCScrollView'] = exports; var CCLayer = require('Code/Cocos2D/CCLayer').CCLayer;

var SCROLL_DEACCEL_RATE = 0.95;
var SCROLL_DEACCEL_DIST = 1;
var BOUNCE_DURATION = 0.35;
var BOUNCE_STEP = 0.1;
var INSET_RATIO = 0.3;

var MINUS_POINT = ccp(-1, -1);

exports.CCScrollView = CCLayer.subclass({
	classname : 'CCScrollView',

	$CCScrollViewDirection : {
		CCScrollViewDirectionHorizontal : 0,
		CCScrollViewDirectionVertical : 1,
		CCScrollViewDirectionBoth : 2
	},

	//***** Init *****//

	$scrollViewWithViewSize : function(size) {
		var scrollView = new this();
		scrollView.initWithViewSize(size);
		return scrollView;
	},

	initialize : function() {
		this._minContainerOffset = ccp(0, 0);
		this._maxContainerOffset = ccp(0, 0);
		this._touchPoint = ccpF(0,0);
		this._scrollDistance = ccpF(0,0);
	},

	initWithViewSize : function(size) {
		this._container = new CCNode();
		this._viewSize = size;
		this._isEnabled = true;
		this._delegate = null;
		this._bounces = true;
		this._clipToBounds = true;
		this._container.setContentSize(CGSizeMake(0, 0));
		this._direction = this.CCScrollViewDirection.CCScrollViewDirectionBoth;
		this._container.setPosition(0, 0);

		this.addChild(this._container);

		this._target = new GL2.TouchTarget();
		this._target.setAnchor(new Core.Point(0, 0.7));

		this._target.setPosition(0, 0);//-size._height*2
		this._target.setSize(size._width, size._height*2);
		this._target.getTouchEmitter().addListener(new Core.MessageListener(), this.onTouch.bind(this));
		this.addChild(this._target, 0, null, true);
		this._target.setDepth(100000);

		this._minContainerOffset = ccp(0, 0);
		this._maxContainerOffset = ccp(0, 0);
		return this;
	},

	//***** Properties *****//

	setContentOffset : function(offset, animated) {
		if (false/*animated*/) { //animate scrolling
			var scroll = CCMoveTo.actionWithDuration(BOUNCE_DURATION, offset);
			var expire = CCCallFunc.actionWithTarget(this, this.stoppedAnimatedScroll.bind(this));
			this._container.runAction(CCSequence.actions(new Array(scroll, expire)));
			this.schedule(this.performedAnimatedScroll);
		} else { //set the container position directly
			this._container.setPosition(offset);
			if (this._delegate)
				this._delegate.scrollViewDidScroll(this);
		}
	},

	contentOffset : function() {
		return this._container.getPosition();
	},

	setViewSize : function(size) {
		if (!CGSizeEqualToSize(this._viewSize, size)) {
			this._viewSize = size;
			this._maxInset = this.maxContainerOffset();
			this._maxInset = ccp(this._maxInset._x + this._viewSize._width * INSET_RATIO, this._maxInset._y + this._viewSize._height * INSET_RATIO);
			this._minInset = this.minContainerOffset();
			this._minInset = ccp(this._minInset._x - this._viewSize._width * INSET_RATIO, this._minInset._y - this._viewSize._height * INSET_RATIO);
		}
	},

	//***** Private *****//

	relocateContainer : function(animated) {
		var min = this.minContainerOffset();
		var max = this.maxContainerOffset();

		var oldPoint = this._container._ccPosition;
		var newX = Math.max(Math.min(oldPoint._x, max._x), min._x);
		var newY = Math.max(Math.min(oldPoint._y, max._y), min._y);

		if (newY != oldPoint._y || newX != oldPoint._x) {
			this.setContentOffset([ newX, newY ], animated);
		}
	},

	maxContainerOffset : function() {
		return this._maxContainerOffset;
	},

	minContainerOffset : function() {
		var contentSize = this.getContentSize();
		var containerOffset = this._minContainerOffset;
		var viewSize = this._viewSize;
		return ccpF(viewSize._width - contentSize._width + containerOffset._x, viewSize._height - contentSize._height + containerOffset._y);
	},

	deaccelerateScrolling : function(dt) {
		if (this._isDragging) {
			this.unschedule(this.deaccelerateScrolling);
			return;
		}

		//	    this._container.setPosition(ccpAdd(this._container.getPosition(), this._scrollDistance));

		var maxInset;
		var minInset;
		if (this._bounces) {
			maxInset = this._maxInset;
			minInset = this._minInset;
		} else {
			maxInset = this.maxContainerOffset();
			minInset = this.minContainerOffset();
		}

		//check to see if offset lies within the inset bounds
		var containerPosition = this._container.getPosition();
		var newX = Math.min(containerPosition._x, maxInset._x);
		newX = Math.max(newX, minInset._x);
		var newY = Math.min(containerPosition._y, maxInset._y);
		newY = Math.max(newY, minInset._y);

		var scrollDistance = this._scrollDistance;
		var p = ccpF(newX - containerPosition._x, newY - containerPosition._y);
		ccpSubF(p, scrollDistance);
		ccpMultF(p, -SCROLL_DEACCEL_RATE);//negative because the above substraction should be scrollDistance - p
		this._scrollDistance._x = p._x;
		this._scrollDistance._y = p._y;

		this.setContentOffset([ newX, newY ]);

		if ((Math.abs(scrollDistance._x) <= SCROLL_DEACCEL_DIST && Math.abs(scrollDistance._y) <= SCROLL_DEACCEL_DIST) || newX == maxInset._x
				|| newX == minInset._x || newY == maxInset._y || newY == minInset._y) {
			this.unschedule(this.deaccelerateScrolling);
			this.relocateContainer(true);
		}
	},

	stoppedAnimatedScroll : function(node) {
		this.unschedule(this.performedAnimatedScroll);
	},

	performedAnimatedScroll : function(dt) {
		if (this._isDragging) {
			this.unschedule(this.performedAnimatedScroll);
			return;
		}

		if (this._delegate)
			this._delegate.scrollViewDidScroll(this);
	},

	//***** Overriden *****//

	getContentSize : function() {
		return this._container.getContentSize();
//		var scale = this.getScale();
//		var contentSize = this._container.getContentSize();
//		return CGSizeMake(scale._x * contentSize._width, scale._y * contentSize._height);
	},

	setContentSize : function(size) {
		if (!this._container)
			return;

		var viewSize = this._viewSize;

		this._container.setContentSize(size);
		this._maxInset = this.maxContainerOffset();

		this._maxInset = ccp(this._maxInset._x + viewSize._width * INSET_RATIO, this._maxInset._y + viewSize._height * INSET_RATIO);
		this._minInset = this.minContainerOffset();
		this._minInset = ccp(this._minInset._x - viewSize._width * INSET_RATIO, this._minInset._y - viewSize._height * INSET_RATIO);
	},

	addChild : function($super, node, z, aTag, attachToParent) {
		if (attachToParent) {
			$super(node);
			return this;
		}
		node._isRelativeAnchorPoint = true;
		if (this._container != node) {
			this._container.addChild(node, z, aTag);
		} else {
			$super(node, z, aTag);
		}

		return this;
	},

//	beforeDraw : function() {
//		if (this._clipToBounds) {
//			var planeTop = [ 0, -1, 0, this._viewSize._height ];
//			var planeBottom = [ 0, 1, 0, 0 ];
//			var planeLeft = [ 1, 0, 0, 0 ];
//			var planeRight = [ -1, 0, 0, this._viewSize._width ];
//
//			//TODO: test this part
//			//	        glClipPlanef(GL_CLIP_PLANE0, planeTop);
//			//	        glClipPlanef(GL_CLIP_PLANE1, planeBottom);
//			//	        glClipPlanef(GL_CLIP_PLANE2, planeLeft);
//			//	        glClipPlanef(GL_CLIP_PLANE3, planeRight);
//			//	        glEnable(GL_CLIP_PLANE0);
//			//	        glEnable(GL_CLIP_PLANE1);
//			//	        glEnable(GL_CLIP_PLANE2);
//			//	        glEnable(GL_CLIP_PLANE3);
//		}
//	},

//	afterDraw : function() {
//		if (this._clipToBounds) {
//			//	        glDisable(GL_CLIP_PLANE0);
//			//	        glDisable(GL_CLIP_PLANE1);
//			//	        glDisable(GL_CLIP_PLANE2);
//			//	        glDisable(GL_CLIP_PLANE3);
//		}
//	},

	//***** Touch Events *****//

	onTouch : function(touch) {
		switch (touch.getAction()) {
		case touch.Action.Start:
			return this.ccTouchBegan(touch);
		case touch.Action.End:
			this.ccTouchEnded(touch);
			break;
		case touch.Action.Move:
			this.ccTouchMoved(touch);
			break;
		}
	},

	ccTouchBegan : function(touch, event) {
		if (!this.getVisible() || !this._isEnabled) {
			return false;
		}

		var pos = this.convertTouchToNodeSpace(touch);
		this._touchPoint._x = pos._x;
		this._touchPoint._y = pos._y;
		this._touchMoved = false;
		this._isDragging = true; //dragging started
		this._scrollDistance._x = 0;
		this._scrollDistance._y = 0;
		this._beganTime = Core.Time.getRealTime();

		return true;
	},

	ccTouchMoved : function(touch, event) {

		if (!this.getVisible() || !this._isEnabled || Core.Time.getRealTime() - this._beganTime < 100) {
			return;
		}

		this._touchMoved = true;
		if (this._isDragging && !CGPointEqualToPoint(MINUS_POINT, this._touchPoint)) { // scrolling
			var newPoint = this.convertTouchToNodeSpace(touch);
			
			//FIXME: should be CGRectMake(self.position.x + self.parent.position.x, self.position.y + self.parent.position.y, 0, viewSize_.height);
//			var frame = CGRectMake(0, -80, this._viewSize._width, this._viewSize._height + 120);
			
			var moveDistance = ccpSub(newPoint, this._touchPoint);
			
			this._touchPoint._x = newPoint._x;
			this._touchPoint._y = newPoint._y;
			
//			if (CGRectContainsPoint(frame, this.convertToWorldSpace(newPoint))) {
				switch (this._direction) {
				case 1://this.CCScrollViewDirection.CCScrollViewDirectionVertical
					moveDistance._x = 0;
					break;
				case 0://this.CCScrollViewDirection.CCScrollViewDirectionHorizontal
					moveDistance._y = 0;
					break;
				default:
					break;
				}
				var pos = this._container._ccPosition;
				pos._x += moveDistance._x;
				pos._y += moveDistance._y;
				this._container.setPosition(pos);
				var maxInset;
				var minInset;
				if (this._bounces) {
					maxInset = this._maxInset;
					minInset = this._minInset;
				} else {
					maxInset = this.maxContainerOffset();
					minInset = this.minContainerOffset();
				}

				//check to see if offset lies within the inset bounds
				var containerPos = this._container._ccPosition;
				var newX = Math.max(Math.min(containerPos._x, maxInset._x), minInset._x);
				var newY = Math.max(Math.min(containerPos._y, maxInset._y), minInset._y);

				var p = ccpF(newX - containerPos._x, newY - containerPos._y);
				ccpSubF(p,moveDistance);
				//negative values because ccpSubF should be moveDistance - p
				this._scrollDistance._x = -p._x;
				this._scrollDistance._y = -p._y;
				this.setContentOffset([newX, newY]);
				this.relocateContainer();
			}
//		}
	},

	ccTouchEnded : function(touch, event) {

		if (!this.getVisible() || !this._isEnabled) {
			return;
		}

		this._isDragging = false;
		//FIXME: this was commented
	    if (this._touchMoved && !CGPointEqualToPoint(MINUS_POINT, this._touchPoint)) {
	    	//this.schedule(this.deaccelerateScrolling);
	    }
	},

	getContainerPos : function() {
		return this._container.getPosition();
	},

	destroy : function() {
		destroyChildren(this);
//		if (this._target) {
//			this.removeChild(this._target);
//			destroy(this._target);
//			this._target = null;
//			
//		}
//		this.unschedule(this.deaccelerateScrolling);
//		this.removeChild(this._container);
//		destroyWithChildren(this._container);
//		destroyWithChildren(this);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/CCTableViewSuite/CCTableView'] = function(){var exports = $MODULE_REGISTRY['Code/CCTableViewSuite/CCTableView'] || {}; $MODULE_REGISTRY['Code/CCTableViewSuite/CCTableView'] = exports; var CCScrollView = require('Code/CCTableViewSuite/CCScrollView').CCScrollView;
var CCTableViewCell = require('Code/CCTableViewSuite/CCTableViewCell').CCTableViewCell;
var CELLNOTFOUND = CCTableViewCell.CELLNOTFOUND;

exports.CCTableView = CCScrollView.subclass(
{
	classname: 'CCTableView',

	$tableViewWithDataSource: function(dataSource, size)
	{
		var table = new this().initWithViewSize(size);
		table._dataSource = dataSource;
		table._updateContentSize();
		return table;
	},

	$scrollViewWithViewSize: function(size)
	{
		console.log("You can not use this method (CCTableView.scrollViewWithViewSize)");
	    return null;
	},

	initialize:function()
	{
		this._tDelegate = null;
		this._dataSource = null;
		
	},

	initWithViewSize: function($super, size)
	{
		$super(size);
		
		this._cellsUsed  = [];
        this._cellsFreed = [];
        this._tDelegate  = null;
        this._direction  = CCScrollView.CCScrollViewDirection.CCScrollViewDirectionVertical;
        this._delegate = this;

	    return this;
	},

	//????
	setDelegate: function(delegate)
	{
	    if (delegate)
	    {
	    	console.log("CCTableView.setDelegate : you cannot set this delegate. use tDelegate instead.");
	    }
	},

	reloadData: function()
	{
	    for (var key in this._cellsUsed) {
	    	var cell = this._cellsUsed[key];
	    	this._cellsFreed.push(cell);
	        cell._idx = CELLNOTFOUND;//NSNotFound
	        cell._node.setVisible(false);
	    }

		var length = this._cellsUsed.length;
    	for ( var i = length-1; i >= 0; i--)
        {
    		if(this._cellsUsed[i]){
    			this._container.removeChild(this._cellsUsed[i]._node, true);
		        destroyWithChildren(this._cellsUsed[i]);
	            this._cellsUsed.splice( i, 1 );
    	    }
        }
	    this._cellsUsed.length = 0;
	    this._cellsUsed = [];

	    if (this._dataSource.numberOfCellsInTableView(this) > 0) {
	    	this.scrollViewDidScroll(this);
	    }

	    this._updateContentSize();
	},

	updateCellAtIndex: function(idx) {
	    if (idx == CELLNOTFOUND || idx > this._dataSource.numberOfCellsInTableView(this)-1) {
//	    	console.log("CCTableView.updateCellAtIndex : invalid index");
	        return;
	    }

	    var cell = this.cellWithIndex(idx);
	    if (cell) {
	    	this._moveCellOutOfSight(cell);
	    }

	    cell = this._dataSource.table_cellAtIndex(this, idx);
		if(cell) {
			this._addCellIfNecessary(cell);
			this._setIndex(idx, cell);
			this._cellsUsed.push(cell);
		}
	},
	
	insertCellAtIndex: function(idx) {
	    if (idx == CELLNOTFOUND || idx > this._dataSource.numberOfCellsInTableView(this)-1) {
//	    	console.log("CCTableView.insertCellAtIndex : invalid index " + idx + "/" +this._dataSource.numberOfCellsInTableView(this));
	        return;
	    }
	    
	    var movingCells = this._cellsUsed.filter(function(val,i){return val._idx >= idx;});
	    var newIdx = 0;
	    
	    //Pushing existing cells down.
	    for (var key in movingCells) {
	    	var tCell = movingCells[key];
	        newIdx = cell._idx + 1;
	        this._setIndex(newIdx, tCell);
	    }
	    
	    //insert a new cell
	    var cell = this._dataSource.table_cellAtIndex(this, idx);
	    this._addCellIfNecessary(cell);
	    this._setIndex(idx, cell);
	    this._cellsUsed.push(cell);
	    
	    this.updateContentSize();
	},

	removeCellAtIndex: function(idx) {
		if (idx == CELLNOTFOUND || idx > this._dataSource.numberOfCellsInTableView(this)-1) {
//			console.log("CCTableView.removeCellAtIndex : invalid index");
			return;
		}
    
		var cell = this.cellWithIndex(idx);
		if (!cell) {
			return;
		}
		//remove first
		this._moveCellOutOfSight(cell);
    
		var movingCells = this._cellsUsed.filter(function(val,i){return val._idx > idx;});
	    var newIdx = 0;
		    
		for (var key in movingCells) {
			var cell = movingCells[key];
			newIdx = cell._idx - 1;
			this._setIndex(newIdx,cell);
		}
	},

	dequeueCell: function(dequeueCell) {
		var cell = null;
    
		this._evictCell();
		if (this._cellsFreed.length == 0) {
			cell = null;
		} else {
			cell = this._cellsFreed[0];
			this._cellsFreed.splice(0,1); 
		}
		return cell;
	},
	
	_addCellIfNecessary: function (cell) {
	    if (cell._node.getParent() != this._container ) {
	        NSAssert( !cell._node.getParent() , "CCTableView: _addCellIfNecessary: cell from another table view is returned from data source");  
	        this._container.addChild( cell._node );
	    }
	},

	_updateContentSize: function() {
	    var size = null;
	    var cellSize  = this._dataSource.cellClassForTable(this).cellSize();
	    var cellCount = this._dataSource.numberOfCellsInTableView(this);
	    
	    switch (this._direction) {
	    	//Not sure
	    	case CCScrollView.CCScrollViewDirection.CCScrollViewDirectionHorizontal:
	            size = CGSizeMake(cellCount * cellSize._width, this._viewSize._height);
	            if (size._width < this._viewSize._width) {
	                size.setWidth(this._viewSize._width);
	            }
	            break;
	        default:
	            size = CGSizeMake(this._viewSize._width, cellCount * cellSize._height);
	            if (size._height < this._viewSize._height) {
	                size.setHeight(this._viewSize._height);
	            }
	            break;
	    }
	    this.setContentSize(size);
	},
	
	_offsetFromIndex: function (index) {
		NSAssert(index != CELLNOTFOUND, "CCTableView: _offsetFromIndex: invalid index");
		var offset = null;
	    var cellSize = this._dataSource.cellClassForTable(this).cellSize();
	    switch (this._direction) {
	        case CCScrollView.CCScrollViewDirection.CCScrollViewDirectionHorizontal:
	            offset = ccp(cellSize._width * index, 0);
	            break;
	        default:
	            offset = ccp(0, cellSize._height * index);
	            break;
	    }
	    
	    return offset;
	},
	
	_indexFromOffset: function(offset) {
	    var index = null;
	    var cellSize = this._dataSource.cellClassForTable(this).cellSize();
	    
	    switch (this._direction) {
	        case CCScrollView.CCScrollViewDirection.CCScrollViewDirectionHorizontal:
	            index = offset._x/cellSize._width;
	            break;
	        default:
	            index = offset._y/cellSize._height;
	            break;
	    }
	    
	    index = Math.max(0, Math.floor(index));
	    index = Math.min(this._dataSource.numberOfCellsInTableView(this)-1, index);
	    return index;
	},

	cellWithIndex: function(cellIndex) {
	    var array = this._cellsUsed.filter(function(cell, i){ return cell._idx == cellIndex; });
	    
	    var cell = null;
	    
	    if (array.length > 0) {
	        if (array.length > 1) {
	            console.log("CCTableView.cellWithIndex : duplicate cells at index "+cellIndex);
	        }
	        cell = array[0];
	    }
	    
	    return cell;
	},

	_moveCellOutOfSight: function(cell) {
	    this._cellsFreed.push(cell);
	    this._cellsUsed.splice(this._cellsUsed.indexOf(cell), 1);
	    this._container.removeChild(cell._node, true);
	    cell._idx = CELLNOTFOUND;
	    cell._node = null;
	},
	
	_evictCell: function () {
	    if (this._cellsFreed.length > 0) {
	        return;
	    }

	    var offset = this.contentOffset();
	    offset = ccp(-offset._x, -offset._y);
	    var cellSize = this._dataSource.cellClassForTable(this).cellSize();
	    var startIdx = this._indexFromOffset(offset);
	    
	    switch (this._direction) {
	        case CCScrollView.CCScrollViewDirection.CCScrollViewDirectionHorizontal:
	        	offset.setX(offset._x + this._viewSize._width);
	            offset.setY(this._viewSize._height);
	            break;
	        default:
	            offset.setX(this._viewSize._width);
	            offset.setY(offset._y + this._viewSize._height);
	            break;
	    }
	    
	    var endIdx = this._indexFromOffset(offset);
	    var clippedCells = this._cellsUsed.filter(function(val,i){return val._idx < startIdx;});
	    
	    for (var key in clippedCells) {
	    	var cell = clippedCells[key];
	        this._moveCellOutOfSight(cell);
	    }
	    
	    clippedCells = this._cellsUsed.filter(function(val,i){val._idx > endIdx;});
	    
	    for (var key in clippedCells) {
	    	var cell = clippedCells[key];
	        this._moveCellOutOfSight(cell);
	    }
	},

	_setIndex: function (index, cell) {
	    NSAssert(cell != null, "CCTableView: _setIndex:forCell: cell is null!");
	    
	    var offset   = this._offsetFromIndex(index);
	    var cellSize = this._dataSource.cellClassForTable(this).cellSize();
	    
	    if (!CGSizeEqualToSize(cell._node.getContentSize(), cellSize)) {
//	    	console.log("CCTableView._setIndex: inconsistent cell size" + stringFromSize(cell._node.getContentSize()) + " / " + stringFromSize(cellSize));
	    }
	    
	    var item = cell._node;
	    item.setAnchorPoint(ccp(0.0, 0.5));
	    item.setPosition(offset.clone());
	    cell._idx = index;
	},

//#pragma mark -
//#pragma mark scrollView
	scrollViewDidScroll: function (view) {
	    var offset   = this.contentOffset();
	    offset   = ccp(-offset._x, -offset._y);
	    var cellSize = this._dataSource.cellClassForTable(this).cellSize();
	    var startIdx = this._indexFromOffset(offset);
	    
	    switch (this._direction) {
	        case CCScrollView.CCScrollViewDirection.CCScrollViewDirectionHorizontal:
	            offset.setX( offset._x + this._viewSize._width);
	            offset.setY(this._viewSize._height);
	            break;
	        default:
	            offset.setX(this._viewSize._width);
	            offset.setY(offset._y + this._viewSize._height);
	            break;
	    }
	    
	    var endIdx = this._indexFromOffset(offset);
	    var clippedCells = this._cellsUsed.filter(function(val,i){return val._idx < startIdx;});
	    for (var key in clippedCells) {
	    	this._moveCellOutOfSight(clippedCells[key]);
	    }
	    
	    var clippedCells = this._cellsUsed.filter(function(val,i){return val._idx > endIdx;});
	    for (var key in clippedCells) {
	    	this._moveCellOutOfSight(clippedCells[key]);
	    }
	    
	    for (var i=startIdx; i <= endIdx; i++) {
	        if (this.cellWithIndex(i)) {
	            continue;
	        }
	        this.updateCellAtIndex(i);
	    }
	},

	ccTouchEnded: function($super, touch ,event) {
		if (!this._visible || !this._isEnabled) {
	        return;
	    }
	    if (!this._touchMoved && !CGPointEqualToPoint(ccp(-1.0, -1.0), this._touchPoint)) {
	        var localPoint = this.contentOffset();
	        localPoint = ccpAdd(ccp(-localPoint._x, -localPoint._y), ccp(this._touchPoint._x, this._touchPoint._y));

	        var index = this._indexFromOffset(localPoint);
	        var cell = this.cellWithIndex(index);
	        
	        if(!cell)
				return;
			
	        this._tDelegate.table_cellTouched(this, cell);
	    }
	    $super(touch, event);
	},

	maxContainerOffset: function()
	{
		if(this._tDelegate)
			return ccpSub(this._maxContainerOffset,this._tDelegate.getMenuOffset());
		else
			return this._maxContainerOffset;
	},

	minContainerOffset: function()
	{
		if(this._tDelegate)
			return ccpSub(
	    	ccp(this._viewSize._width - this.getContentSize()._width + this._minContainerOffset._x,
	    		   this._viewSize._height - this.getContentSize()._height + this._minContainerOffset._y),
	    		   this._tDelegate.getMenuOffset());
		else
			return ccp(this._viewSize._width - this.getContentSize()._width + this._minContainerOffset._x,
		    		   this._viewSize._height - this.getContentSize()._height + this._minContainerOffset._y);
	},

	contentOffset: function()
	{
		return ccpAdd(this._container.getPosition(), this._tDelegate.getMenuOffset());
	},

	destroy: function($super)
	{
		if (this._cellsUsed) {
			var length = this._cellsUsed.length;
	    	for ( var i = length-1; i >= 0; i--)
	        {
	    		if(this._cellsUsed[i]){
	    			this._container.removeChild(this._cellsUsed[i]._node, true);
//		            destroyWithChildren(this._cellsUsed[i]);
//		            this._cellsUsed[i].destroy();
		            destroyWithChildren(this._cellsUsed[i]);
		            this._cellsUsed[i] = null;
		            this._cellsUsed.splice( i, 1 );
	    	    }
	        }
			this._cellsUsed.length = 0;
			this._cellsUsed = null;
		}
	    
		if (this._cellsFreed) {
			var length = this._cellsFreed.length;
	    	for ( var i = length-1; i >= 0; i--)
	        {
	    		if(this._cellsFreed[i]){
	    			this._container.removeChild(this._cellsFreed[i]._node, true);
//	    			this._cellsFreed[i].destroy();
	    			destroyWithChildren(this._cellsFreed[i]);
	    			this._cellsFreed[i] = null;
		            this._cellsFreed.splice( i, 1 );
	    	    }
	        }
			this._cellsFreed.length = 0;
			this._cellsFreed = null;
		}
		
		$super();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/CCTableViewSuite/CCMultiColumnTableView'] = function(){var exports = $MODULE_REGISTRY['Code/CCTableViewSuite/CCMultiColumnTableView'] || {}; $MODULE_REGISTRY['Code/CCTableViewSuite/CCMultiColumnTableView'] = exports; exports.CCMultiColumnTableView = CCTableView.subclass(
{
	classname: 'CCMultiColumnTableView',

	$tableViewWithDataSource: function(dataSource, size)
	{
		var table = new this();
		table.initWithViewSize(size);
		table._dataSource = dataSource;
		table._updateContentSize();

		return table;
	},

	initialize:function()
	{
	},

	initWithViewSize: function($super, size)
	{
		$super(size);
		this._colCount = 1;
	    return this;
	},

	setColCount:function(cols)
	{
		this._colCount = cols;
	    if (this._direction == CCScrollView.CCScrollViewDirection.CCScrollViewDirectionBoth)
	    {
	    	this._updateContentSize();
	    }
	    else
	    {
	    	console.log("CCMultiColumnTableView.setColCount: You cannot set this value. The value will ignored and overwritten.");
	    }
	},

	_indexFromOffset: function(offset)
	{
	    var col; var row; var spaceWidth;
	    var cellSize = this._dataSource.cellClassForTable(this).cellSize();

	    switch (this._direction) {
	        case CCScrollView.CCScrollViewDirection.CCScrollViewDirectionBoth:
	            spaceWidth = this.getContentSize()._width / this._colCount;
	            col        = Math.floor((offset._x - (spaceWidth - cellSize._width)*0.5)/spaceWidth);
	            row        = Math.floor(offset._y / cellSize._height);
	            break;
	        case CCScrollView.CCScrollViewDirection.CCScrollViewDirectionHorizontal:
	            colCount   = this._viewSize._height / cellSize._height;
	            spaceWidth = this._viewSize._height / this._colCount;
	            col        = Math.floor((offset._y - (spaceWidth - cellSize._height)*0.5)/spaceWidth);
	            row        = Math.floor(offset._x / cellSize._width);
	            break;
	        default:
	            colCount   = this._viewSize._width / cellSize._width;
	            spaceWidth = this._viewSize._width / this._colCount;
	            col        = Math.floor((offset._x - (spaceWidth - cellSize._width)*0.5)/spaceWidth);
	            row        = Math.floor(offset._y / cellSize._height);
	            break;
	    }

	    var index = col + row * this._colCount;
	    index = Math.max(0, index);
	    index = Math.min(this._dataSource.numberOfCellsInTableView(this)-1, index);
	    return index;
	},

	_offsetFromIndex: function(index)
	{
	    //NSAssert(index != NSNotFound, @"CCTableView: _offsetFromIndex: invalid index");
	    var offset; var spaceWidth; var col; var row;
	    var cellSize = this._dataSource.cellClassForTable(this).cellSize();
	    switch (this._direction)
	    {
	        case CCScrollView.CCScrollViewDirection.CCScrollViewDirectionBoth:
	            row        = Math.floor(index / this._colCount);
	            col        = Math.floor(index % this._colCount);
	            spaceWidth = this.getContentSize()._width / this._colCount;
	            offset     = ccp(col * spaceWidth + (spaceWidth - cellSize._width) * 0.5,
	                             row * cellSize._height);
	            break;
	        case CCScrollView.CCScrollViewDirection.CCScrollViewDirectionHorizontal:
	        	this._colCount = Math.floor(this._viewSize._height / cellSize._height);
	            row            = Math.floor(index / this._colCount);
	            col            = Math.floor(index % this._colCount);
	            spaceWidth     = this._viewSize._height / this._colCount;
	            offset         = ccp(row * cellSize._height,
	                                 col * spaceWidth + (spaceWidth - cellSize._width) * 0.5);
	            break;
	        default:
	            this._colCount = Math.floor(this._viewSize._width / cellSize._width);
	            row            = Math.floor(index / this._colCount);
	            col            = index % this._colCount;
	            spaceWidth     = this._viewSize._width / this._colCount;
	            offset         = ccp(col * spaceWidth + (spaceWidth - cellSize._width) * 0.5,
	                                 row * cellSize._height);
	            break;
	    }
	    
	    return offset;
	},

	_updateContentSize: function()
	{
	    var size; var rows;
	    var cellSize  = this._dataSource.cellClassForTable(this).cellSize();
	    var cellCount = this._dataSource.numberOfCellsInTableView(this);
	    switch (this._direction) {
	        case CCScrollView.CCScrollViewDirection.CCScrollViewDirectionBoth:
	            rows = Math.ceil(cellCount/this._colCount);
	            size = CGSizeMake(cellSize._width * this._colCount, rows * cellSize._height);
	            break;
	        case CCScrollView.CCScrollViewDirection.CCScrollViewDirectionHorizontal:
	            this.setColCount(is._viewSize._height / cellSize._height);
	            rows           = Math.ceil(cellCount/this._colCount);
	            size           = CGSizeMake(rows * cellSize._width, this._colCount * cellSize._height);
	            break;
	        default:
	            this._colCount = Math.floor(this._viewSize._width / cellSize._width);
	            rows           = Math.ceil(cellCount/this._colCount);
	            size           = CGSizeMake(cellSize._width * this._colCount, rows * cellSize._height);
	            break;
	    }

	    this.setContentSize(size);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/CCTableViewSuite/CCTableViewCell'] = function(){var exports = $MODULE_REGISTRY['Code/CCTableViewSuite/CCTableViewCell'] || {}; $MODULE_REGISTRY['Code/CCTableViewSuite/CCTableViewCell'] = exports; exports.CCTableViewCell = CCNode.subclass(
{
	classname: 'CCTableViewCell',

	CELLNOTFOUND : Number.MAX_VALUE,

	$cellSize: function()
	{
	    return CGSizeMake(0,0);
	},

	initialize: function()
	{
	    this._node = null;
	    this._idx = 0;
	},

	destroy: function()
	{
		if (this._node)
		{
			if(this._node.getParent())
				this._node.getParent().removeChild(this._node,true);
			destroyWithChildren(this._node);
			this._node = null;
//			destroyWithChildren(this);
		}
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/MainMenu/ZombieMiniGame'] = function(){var exports = $MODULE_REGISTRY['Code/MainMenu/ZombieMiniGame'] || {}; $MODULE_REGISTRY['Code/MainMenu/ZombieMiniGame'] = exports; exports.ZombieMiniGame = Core.Class.singleton({
    classname : 'ZombieMiniGame',
    
    eState : {
        WaitingForRising : 1,
        Idle : 2
    },
    
    initialize : function()
    {
    	ZombieMiniGame._handTappedCount = 0;
    	ZombieMiniGame._timer = null;
    },
    
    init : function(zombieHandsArray)
    {
    	ZombieMiniGame._zombieHands = zombieHandsArray;
    },
       
    RaiseNewZombieHands : function()
    {
        var handUpCount = 0;
        
        for (var i in ZombieMiniGame._zombieHands)
        {
            if (ZombieMiniGame._zombieHands[i].getState() == HandButton.eHandState.Visible)
            {
                handUpCount++;
            }
        }
        
        var simultaneousHandCount = 1;
        if (ZombieMiniGame._handTappedCount >= 18)
        {
            simultaneousHandCount = 4;
        }
        else if (ZombieMiniGame._handTappedCount >= 12)
        {
            simultaneousHandCount = 3;
        }
        else if (ZombieMiniGame._handTappedCount >= 3)
        {
            simultaneousHandCount = 2;
        }
        
        simultaneousHandCount = (simultaneousHandCount < 1) ? 1 : simultaneousHandCount;
        simultaneousHandCount = (simultaneousHandCount > 4) ? 4 : simultaneousHandCount;
        
        var randHand = 0;
        if (ZombieMiniGame._handTappedCount >= 10)
        {
            randHand = Math.floor(Math.random() * ZombieMiniGame._zombieHands.length);
        }
        
        //console.log(randHand);
        
        var newHandUp = false;
        
        while (simultaneousHandCount > 0 && simultaneousHandCount > handUpCount)
        {
            //check randHand state
            if (ZombieMiniGame._zombieHands[randHand].getState() != HandButton.eHandState.Visible)
            {
                newHandUp = true;
            }
            
            ZombieMiniGame._zombieHands[randHand].setState(HandButton.eHandState.Rising);
            simultaneousHandCount--;
        }
        
        //shake only when hand rising
        if (newHandUp)
        {
            MainMenu.Shake();
        }
        
        //destroy listener
        clearTimeout(ZombieMiniGame._timer);
        ZombieMiniGame._timer = null;
    },
    
    //Tapped hand with {Number} handID
    HandTapped : function(handID)
    {
    	ZombieMiniGame._handTappedCount++;
//        if (!ZombieMiniGame._timer)
        {
            var randValDelay = Math.random()*2 + 1;
            ZombieMiniGame._timer = setTimeout(this.RaiseNewZombieHands.bind(this), randValDelay * 1000);
        }
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/MainMenu/Classes/Timer'] = function(){var exports = $MODULE_REGISTRY['Code/MainMenu/Classes/Timer'] || {}; $MODULE_REGISTRY['Code/MainMenu/Classes/Timer'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Timer = Core.MessageListener.subclass(
{
	initialize: function(callback)
	{
		this._enabled = false;
		this._currentTime = 0;
		this._callback = callback;
		
		Core.UpdateEmitter.addListener(this, this.onUpdate);
	},
	
	destroy: function()
	{
	    this._callback = null;
	    Core.UpdateEmitter.removeListener(this.onUpdate);
	},
	
	setInterval: function(time)
	{
		this._interval = time;
	}, 
	
	Start: function()
	{
		this._enabled = true;
	},
	
	onUpdate: function(dt)
	{	
		if(this._enabled == false)
		{
			return;
		}
		
		this._currentTime += dt;
		
		if(this._interval < this._currentTime)
		{
			this._currentTime = 0;
			this._callback();
		}
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/MainMenu/HandButton'] = function(){var exports = $MODULE_REGISTRY['Code/MainMenu/HandButton'] || {}; $MODULE_REGISTRY['Code/MainMenu/HandButton'] = exports; exports.HandButton = Core.MessageListener.subclass({
    classname : 'HandButton',
    
    //states of zombie hand
    $eHandState : {
        None : 0, // not set
        Hide : 1, // hand is placed under eggs
        Rising : 2, // rising zombie hand animation
        Hiding : 3, // hiding zombie hand under eggs
        Visible : 4 // zombie hand is placed above hand
    },
    
    // {Core.Vector} position of hidden hand
    // {Core.Size} size
    // {String] image: path to the image
    // {Number} handID
    initialize : function(position, size, image, handID)
    {
        this._handID = handID;
        
        var heightScale = UI.Window._height / 320.0;
        
        this._hidePosition = position._y;
        this._showPosition = 290.0 * heightScale - 125.0 * heightScale;
        
        this._node = new GL2.Node();
        this._node.setPosition(position);
        this._node.setDepth(-1);
        
        this._handImage = new GL2.Sprite();
        this._handImage.setImage(image, size)._animation.setFilteringEnabled(false);
        this._handImage.setPosition(size._width / 2, size._height / 2);
        
        // Create touch target.
        this._target = new GL2.TouchTarget();
        //this._target.setAnchorPoint(this._bg.getAnimation().getFrame(0).getAnchor());
        this._target.setSize(size);
        this._target.getTouchEmitter().addListener(this, this.onTouch);
        
        this._node.addChild(this._target);
        this._node.addChild(this._handImage);
        
        this._state = this.eHandState.Hide;
        
        Core.UpdateEmitter.addListener(this, this.onUpdate);
        
        //speed of hiding/rising hand
        this._handSpeed = 450 * heightScale;
    },
    
    setState : function(state)
    {
        //don't allow to change states Hiding<=>Rising
        if (state == this.eHandState.Rising && this._state == this.eHandState.Hiding)
        {
            return;
        }
        
        if (state == this.eHandState.Hiding && this._state == this.eHandState.Rising)
        {
            return;
        }
        
        this._state = state;
    },
    
    getState : function()
    {
        return this._state;
    },
    
    getNode : function()
    {
        return this._node;
    },
    
    onUpdate : function(dt)
    {
        if (dt > 200)
        {
            return;
        }
        
        var move = this._handSpeed * (dt / 1000.0);
        switch (this._state)
        {
            case this.eHandState.Hiding:
                //are we finishing rising zombie hand?
                if (this._node.getPosition()._y >= this._hidePosition)
                {
                    //don't go too far
                    this._node.setPosition(this._node.getPosition()._x, this._hidePosition);
                    this._state = this.eHandState.Hide;
                    return;
                }
                
                this._node.setPosition(this._node.getPosition()._x, this._node.getPosition()._y + move);
                break;
            
            case this.eHandState.Rising:
                //are we finishing rising zombie hand?
                if (this._node.getPosition()._y <= this._showPosition)
                {
                    //don't go too far
                    this._node.setPosition(this._node.getPosition()._x, this._showPosition);
                    this._state = this.eHandState.Visible;
                    return;
                }
                
                //check if we don't go too far with y
                var distance = Math.abs(this._node.getPosition()._y - this._showPosition);
                if (move > distance)
                {
                    move = distance;
                }
                
                //raise hand moar 
                this._node.setPosition(this._node.getPosition()._x, this._node.getPosition()._y - move);
                break;
        }
    },
    
    onTouch : function(touch)
    {
        this._state = this.eHandState.Hiding;
        ZombieMiniGame.HandTapped(this._handID);
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCAction'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCAction'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCAction'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.CCAction = Core.MessageListener.subclass({
	classname : "CCAction",

	tag : {
		kCCActionTagInvalid : -1
	},

	$action : function() {
		return new this();
	},

	initialize : function() {
		this._target = null;
		this._tag = this.tag.kCCActionTagInvalid;
	},

	destroy : function() {
		this._target = null;
	},

	startWithTarget : function(target) {
		this._target = target;
	},

	stop : function() {
		this._target = null;
	},

	isDone : function() {
		return true;
	},

	step : function(dt) {
		console.log("action step - override me!");
	},

	update : function(time) {
		console.log("aciton.update - override me!");
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCActionManager'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCActionManager'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCActionManager'] = exports; var Core = require('NGCore/Client/Core').Core;
var HashTable = require('Code/Game/Tools/HashTable').HashTable;

var tHashElement = Core.Class.singleton({
	// struct ccArray *actions;
	// id target;
	// unsigned int actionIndex;
	// CCAction *currentAction;
	// BOOL currentActionSalvaged;
	// BOOL paused;
	// UT_hash_handle hh;

	initialize : function() {
		this.id = null;
		this.actionIndex = 0;
		this.currentAction = null;
		this.currentActionSalvaged = false;
		this.paused = false;
		this.hh = null;
	}
});

exports.CCActionManager = Core.Class.singleton({
	classname : 'CCActionManager',

	initialize : function() {
		this._actions = new HashTable();

		// Core.UpdateEmitter.addListener( new Core.MessageListener() ,
		// this.update.bind( this ) );
		CCScheduler.scheduleUpdateForTarget(this, 0, false);
	},

	addAction : function(action, target, paused) {
		// this._targets.push(target);
		// console.log(this._targets.indexOf(target));

		if (!action) {
			console.log("NO ACTION DEFINED.");
			return;
		}

		action.startWithTarget(target);
		this._actions.put(target, action);
	},

	stopAllActions : function(target) {
		var targetActions = this._actions.get(target);
//		console.log("CCActionManager.stopAllActions for: " + target.classname + ", B: targetActions.length: " + (targetActions? targetActions.length : null));
		if (targetActions) {
			for ( var i in targetActions) {
				targetActions[i] && targetActions[i].stop();
			}
			this._actions.remove(target);
		}
//		var targetActions = this._actions.get(target);
//		console.log("CCActionManager.stopAllActions for: " + target.classname + ", A: targetActions.length: " + (targetActions? targetActions.length : null));
	},
	
	numberOfRunningActionsInTarget: function (target) {
		var targetActions = this._actions.get(target);
		var count = 0;
		if (targetActions) {
			for ( var i in targetActions) {
				if (targetActions[i]) {
					count++;
				}
			}
		}
		return count;
	},

	//
	// #pragma mark ActionManager - main loop
	update : function(dt) {
		// console.log( "CCActionManager.update()");
		var valArray = this._actions._valArray;
		var toRemove = [];
		for ( var i = 0; i < valArray.length; i++) {
			// Browse all the actions for this target.
			toRemove.length = 0;
			var targetActions = valArray[i];
			if (targetActions) {
				for ( var j = 0; j < targetActions.length; j++) {
					var action = targetActions[j];

					if (action) {
						action.step(dt);

						if (action.isDone()) {
							// console.log( "action finished:" + j );
							// console.log(targetActions[j]);
							toRemove.push(action);
						}
					}
				}
			}

			// Clean the array.
			for (key in toRemove) {
				var action = toRemove[key];
				targetActions.splice(targetActions.indexOf(action),1);
				destroy(action);
			}
		}
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCMoveTo'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCMoveTo'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCMoveTo'] = exports; var CCIntervalAction = require('Code/Cocos2D/CCIntervalAction').CCIntervalAction;

exports.CCMoveTo = CCIntervalAction.subclass(
{
	classname: "CCMoveTo",
	
	initialize: function( $super )
	{
		$super();
	},
	
	$actionWithDuration: function( t , p )
	{
		var action = new this();
		action.initWithDuration( t , p );
		return action;
	},
	
	initWithDuration: function( $super , t , p )
	{
		$super( t );
		this._endPosition = p.clone();
	},
	
	startWithTarget: function( $super, target )
	{
		$super( target );
		this._startPosition = this._target.getPosition().clone();
		this._delta = ccpSub( this._endPosition , this._startPosition );
	},
	
	update: function( t )
	{
		this._target.setPosition(this._startPosition._x + this._delta._x * t , this._startPosition._y + this._delta._y * t );
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCMoveBy'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCMoveBy'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCMoveBy'] = exports; var CCMoveTo = require('Code/Cocos2D/CCMoveTo').CCMoveTo;

exports.CCMoveBy = CCMoveTo.subclass(
{
	classname: "CCMoveBy",
	
	$actionWithDuration: function( t , p )
	{	
		var action = new this();
		action.initWithDuration( t , p );
		return action;
	},
		
	initWithDuration: function( $super , t , p )
	{
		$super( t, p );
		this._delta = p.clone();
	},
	
//	-(id) copyWithZone: (NSZone*) zone
//	{
//		CCAction *copy = [[[self class] allocWithZone: zone] initWithDuration: [self duration] position: delta];
//		return copy;
//	}
	
	startWithTarget: function( $super , target )
	{
		var tmpDelta = this._delta;
		$super( target );
		this._delta = tmpDelta;
	}
	
//	-(CCIntervalAction*) reverse
//	{
//		return [[self class] actionWithDuration: duration position: ccp( -delta.x, -delta.y)];
//	}
//	@end
	
	
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCRepeatForever'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCRepeatForever'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCRepeatForever'] = exports; var CCIntervalAction = require('Code/Cocos2D/CCIntervalAction').CCIntervalAction;

exports.CCRepeatForever = CCIntervalAction.subclass({
	classname : "CCRepeatForever",

	$actionWithAction : function(aAction) {
		var action = new this();
		action.initWithAction(aAction);
		return action;
	},

	initWithAction : function(action) {
		this._other = action;
	},

	startWithTarget : function($super, target) {
		$super(target);
		this._other.startWithTarget(this._target);
	},

	step : function(dt) {
		this._other.step(dt);
		if (this._other.isDone()) {
			var diff = dt + this._other._duration - this._other._elapsed;
			this._other.startWithTarget(this._target);

			//to prevent jerk
			this._other.step(diff);
		}
	},

	isDone : function() {
		return false;
	}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCSequence'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCSequence'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCSequence'] = exports; var CCIntervalAction = require('Code/Cocos2D/CCIntervalAction').CCIntervalAction;
var Core = require('NGCore/Client/Core').Core;

exports.CCSequence = CCIntervalAction.subclass(
{
	classname: "CCSequence",

	$actionOne: function(one, two)
	{
		var action  = new this();
		action.initOne(one, two);
		return action;
	},
	
	$actions: function(arrayOfAction)
	{
		if (!(arrayOfAction instanceof Array)) {
			arrayOfAction = Array.prototype.slice.call(arguments,0);
		}
		var now;
		var prev = arrayOfAction[0];
		
		if(arrayOfAction)
		for(var i = 1; i < arrayOfAction.length; i++)
		{
			now = arrayOfAction[i];
			if(now)
				prev = this.actionOne(prev, now);
			else
				break;
		}
		
		return prev;
	},
	
	initOne: function( one, two)
	{
		var d = one._duration + two._duration;
		
		this.initWithDuration(d);
		
		this._actions = new Array(2);
		this._actions[0] = one;
		this._actions[1] = two;
	},
	
	startWithTarget: function($super, target)
	{
		$super(target);
		this._split = this._actions[0]._duration / this._duration;
		this._last = -1;
	},
	
	stop: function($super)
	{
		this._actions[0].stop();
		this._actions[1].stop();
		$super();
	},

	update: function($super, t)
	{
		var found = 0;
		var new_t = 0.0;

		if( t >= this._split) 
		{
			found = 1;
			if(this._split == 1)
				new_t = 1;
			else
				new_t = (t-this._split) / (1 - this._split);
		}
		else
		{
			found = 0;
			if(this._split != 0)
				new_t = t / this._split;
			else
				new_t = 1;
		}
		
		if(this._last == -1 && found == 1)
		{
			this._actions[0].startWithTarget(this._target);
			this._actions[0].update(1);
			this._actions[0].stop();
		}
		
		if(this._last != found)
		{
			if( this._last != -1 )
			{
				this._actions[this._last].update(1);
				this._actions[this._last].stop();
			}
			this._actions[found].startWithTarget(this._target);
		}
		
		this._actions[found].update(new_t);
		this._last = found;
	}
});

//@implementation CCSequence

//
//-(id) copyWithZone: (NSZone*) zone
//{
//	CCAction *copy = [[[self class] allocWithZone:zone] initOne:[[actions[0] copy] autorelease] two:[[actions[1] copy] autorelease] ];
//	return copy;
//}
//
//-(void) dealloc
//{
//	[actions[0] release];
//	[actions[1] release];
//	[super dealloc];
//}
//

//
//- (CCIntervalAction *) reverse
//{
//	return [[self class] actionOne: [actions[1] reverse] two: [actions[0] reverse ] ];
//}
//@end

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCScaleTo'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCScaleTo'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCScaleTo'] = exports; var CCIntervalAction = require('Code/Cocos2D/CCIntervalAction').CCIntervalAction;

exports.CCScaleTo = CCIntervalAction.subclass(
{
	classname: "CCScaleTo",

	$actionWithDuration: function( t , sx, sy )
	{
		var action = new this();
		action.initWithDuration( t , sx, sy );
		return action;
	},

	initWithDuration: function( $super , t , sx, sy ) 
	{
		$super( t );
		this._endScaleX = sx;
		if( typeof(sy) != "undefined" ){
			this._endScaleY = sy;
		}
		else{
			this._endScaleY = sx;
		}
	},

//	-(id) copyWithZone: (NSZone*) zone
//	{
//		CCAction *copy = [[[self class] allocWithZone: zone] initWithDuration: [self duration] scaleX:endScaleX scaleY:endScaleY];
//		return copy;
//	}

	startWithTarget: function( $super , target )
	{
		$super( target );
		
		var scale = this._target.getScale().clone();
		
		this._startScaleX 	= scale._x;
		this._startScaleY 	= scale._y;
		this._deltaX		= this._endScaleX - this._startScaleX;
		this._deltaY		= this._endScaleY - this._startScaleY;
	},
	
	update: function( t )
	{
		this._target.setScale( new Core.Vector(this._startScaleX + this._deltaX * t , this._startScaleY + this._deltaY * t ));
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCMoveByWithoutChangingPosition'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCMoveByWithoutChangingPosition'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCMoveByWithoutChangingPosition'] = exports; var CCMoveTo = require('Code/Cocos2D/CCMoveTo').CCMoveTo;

exports.CCMoveByWithoutChangingPosition = CCMoveTo.subclass(
{
	classname: "CCMoveByWithoutChangingPosition",
	
	update: function( t )
	{
		this._target.setPosition(this._startPosition._x + this._delta._x * t , this._startPosition._y + this._delta._y * t );
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCFadeIn'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCFadeIn'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCFadeIn'] = exports; var CCIntervalAction = require('Code/Cocos2D/CCIntervalAction').CCIntervalAction;
var CCFadeOut = require('Code/Cocos2D/CCFadeOut').CCFadeOut;

exports.CCFadeIn = CCIntervalAction.subclass({
	classname : "CCFadeIn",

	update : function(t) {
		this._target.setAlpha(t);
	},

	reverse : function() {
		return CCFadeOut.actionWithDuration(this._duration);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCFadeOut'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCFadeOut'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCFadeOut'] = exports; var CCIntervalAction = require('Code/Cocos2D/CCIntervalAction').CCIntervalAction;
var CCFadeIn = require('Code/Cocos2D/CCFadeIn').CCFadeIn;

exports.CCFadeOut = CCIntervalAction.subclass({
	classname : "CCFadeOut",

	update : function(t) {
		this._target.setAlpha(1 - t);
	},

	reverse : function() {
		return CCFadeIn.actionWithDuration(this._duration);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCFadeTo'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCFadeTo'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCFadeTo'] = exports; var CCIntervalAction = require('Code/Cocos2D/CCIntervalAction').CCIntervalAction;

exports.CCFadeTo = CCIntervalAction.subclass(
{
	classname: "CCFadeTo",
	
	initialize: function()
	{
	},
	
	$actionWithDuration: function( t , o )
	{
		var action = new this();
		action.initWithDuration( t , o );
		return action;
	},

	initWithDuration: function( $super , t , o )
	{
		$super( t );
		this._toOpacity = o;
	},

	startWithTarget: function( $super , target )
	{	
		$super( target );
		this._fromOpacity = this._target.getAlpha() * 255;
	},

	update: function( t )
	{
		var opacity = this._fromOpacity + ( this._toOpacity - this._fromOpacity ) * t ;
		this._target.setOpacity( opacity );
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCDelayTime'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCDelayTime'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCDelayTime'] = exports; var CCIntervalAction = require('Code/Cocos2D/CCIntervalAction').CCIntervalAction;

exports.CCDelayTime = CCIntervalAction.subclass({
	classname : "CCDelayTime",

	update : function(t) {
	},

	reverse : function() {
		return CCDelayTime.actionWithDuration(this._duration);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCJumpTo'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCJumpTo'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCJumpTo'] = exports; var CCJumpBy = require('Code/Cocos2D/CCJumpBy').CCJumpBy;

exports.CCJumpTo = CCJumpBy.subclass(
{
	classname: "CCJumpTo",
	
	startWithTarget: function( $super , target )
	{
		$super( target );
		this._delta = ccp( 	this._delta._x - this._startPosition._x , this._delta._y - this._startPosition._y );
	},
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCRotateTo'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCRotateTo'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCRotateTo'] = exports; var CCIntervalAction = require('Code/Cocos2D/CCIntervalAction').CCIntervalAction;

exports.CCRotateTo = CCIntervalAction.subclass(
{
	classname: "CCRotateTo",
	
	$actionWithDuration: function( t , a ) // ccTime, angle
	{
		var action = new this();
		action.initWithDuration( t , a );
		return action;	
	},
	
	initWithDuration: function( $super , t , a )
	{
		$super( t );
		this._dstAngle = a;
	},
	
	initialize: function( )
	{
	},
	
	startWithTarget: function( $super , aTarget )
	{
		$super( aTarget );
		
		this._startAngle = this._target.getRotation();
		
		if ( this._startAngle > 0 )
		{
			this._startAngle %= 360;
		}
		else
		{
			this._startAngle %= -360;
		}
		
		this._diffAngle = this._dstAngle - this._startAngle;
	},
	
	update: function( time )
	{
		var newAngle = this._startAngle + this._diffAngle * time;
		this._target.setRotation( newAngle );
	},
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCRepeat'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCRepeat'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCRepeat'] = exports; var CCIntervalAction = require('Code/Cocos2D/CCIntervalAction').CCIntervalAction;

exports.CCRepeat = CCIntervalAction.subclass(
{
	classname: "CCRepeat",
	
	$actionWithAction: function( action , times )
	{
		var action = new this();
		action.initWithAction( action , times );
		return action;
	},

	initWithAction: function( $super , action , times )
	{
		var d = action._duration * times;

		$super( d );
		this._times = times;
		this._other = action;
		this._total = 0;
		
		return this;
	},

	startWithTarget: function( $super , target )
	{
		this._total = 0;
		$super( target );
		this._other.startWithTarget( target );
	},

	stop: function( $super )
	{    
		this._other.stop();
		$super();
	},
	
	update: function( dt )
	{
		var t = dt * this._times;
		
		if( t > this._total + 1 )
		{
			this._other.update( 1.0 );
			this._total++;
			this._other.stop();
			this._other.startWithTarget( this._target );
			
			// repeat is over ?
			if( this._total == this._times )
			{
				// so, set it in the original position
				this._other.update( 0 );
			
			}
			else
			{
				// no ? start next repeat with the right update
				// to prevent jerk (issue #390)
				this._other.update( t - this._total );
			}

		} 
		else
		{
			var r = t % 1.0;
			
			// fix last repeat position
			// else it could be 0.
			if ( dt == 1.0 )
			{
				r = 1.0;
				this._total++; // this is the added line
			}
			
			this._other.update( Math.min( r , 1 ) );
		}
	},
	
	isDone: function()
	{
		return this._total = this._times;
	},

	reverse: function()
	{
//		return [[self class] actionWithAction:[other_ reverse] times:times_];
	},
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCRotateBy'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCRotateBy'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCRotateBy'] = exports; var CCIntervalAction = require('Code/Cocos2D/CCIntervalAction').CCIntervalAction;

exports.CCRotateBy = CCIntervalAction.subclass(
{
	classname: "CCRotateBy",
	
	$actionWithDuration: function( t , a )
	{	
		var action = new this();
		action.initWithDuration( t , a );
		return action;
	},
	
	initWithDuration: function( $super , t , a )
	{
		$super( t );
		this._angle = a;
	},
	
	startWithTarget: function( $super, target )
	{
		$super( target );
		this._startAngle = target.getRotation();
	},
	
	update: function( t )
	{	
		this._target.setRotation( this._startAngle + this._angle * t );
	},
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCScaleBy'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCScaleBy'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCScaleBy'] = exports; var CCScaleTo = require('Code/Cocos2D/CCScaleTo').CCScaleTo;

exports.CCScaleBy = CCScaleTo.subclass(
{
	classname: "CCScaleBy",
	
	startWithTarget: function( $super , target ) 
	{
		$super( target );
		this._deltaX = this._startScaleX * this._endScaleX - this._startScaleX;
		this._deltaY = this._startScaleY * this._endScaleY - this._startScaleY;
	}
//	-(CCIntervalAction*) reverse
//	{
//		return [[self class] actionWithDuration: duration scaleX: 1/endScaleX scaleY:1/endScaleY];
//	}
});
	; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCTintBy'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCTintBy'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCTintBy'] = exports; var CCIntervalAction = require('Code/Cocos2D/CCIntervalAction').CCIntervalAction;

exports.CCTintBy = CCIntervalAction.subclass(
{
	classname: "CCTintBy",
	
	$actionWithDuration: function( t , r , g , b )
	{
		var action = new this();
		action.initWithDuration( t , r , g , b );
		return action;
	},

	initWithDuration: function( $super , t , r , g , b )
	{
		$super( t );
		this._deltaR = r;
		this._deltaG = g;
		this._deltaB = b;
	},

//	-(id) copyWithZone: (NSZone*) zone
//	{
//		return[(CCTintBy*)[[self class] allocWithZone: zone] initWithDuration: [self duration] red:deltaR green:deltaG blue:deltaB];
//	}

	startWithTarget: function($super, target)
	{
		$super( target );
		this._fromR = target.getColor().getRed();
		this._fromG = target.getColor().getGreen();
		this._fromB = target.getColor().getBlue();
	},

	update: function( t )
	{
		this._target.setColor( ccc3( 	this._fromR + this._deltaR * t,
									 	this._fromG + this._deltaG * t,
									 	this._fromB + this._deltaB * t ) );
	},
	
	reverse: function()
	{
		return CCTintBy.actionWithDuration( this._duration , -this._deltaR , -this._deltaG , -this._deltaB );
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCTintTo'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCTintTo'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCTintTo'] = exports; var CCIntervalAction = require('Code/Cocos2D/CCIntervalAction').CCIntervalAction;

exports.CCTintTo = CCIntervalAction.subclass(
{
	classname: "CCTintTo",
	
	$actionWithDuration: function( t , r , g , b )
	{
		var action = new this();
		action.initWithDuration( t , r , g , b );
		return action;
	},
	
	initWithDuration: function($super, t , r , g , b )
	{
		$super( t );
		this._to = ccc3( r , g , b );
//		return this;
	},

//	-(id) copyWithZone: (NSZone*) zone
//	{
//		CCAction *copy = [(CCTintTo*)[[self class] allocWithZone: zone] initWithDuration: [self duration] red:to.r green:to.g blue:to.b];
//		return copy;
//	}

	startWithTarget: function( $super , target )
	{
		$super( target );
		this._from = target;
	},

	update: function( t )
	{
		var r = this._from.getColor().getRed() + (this._to.getRed() - this._from.getColor().getRed()) * t;
		var g = this._from.getColor().getGreen() + (this._to.getGreen() - this._from.getColor().getGreen()) * t;
		var b = this._from.getColor().getBlue() + (this._to.getBlue() - this._from.getColor().getBlue()) * t;

		this._target.setColor(new Core.Color(r,g,b));
		
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCJumpBy'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCJumpBy'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCJumpBy'] = exports; var CCIntervalAction = require('Code/Cocos2D/CCIntervalAction').CCIntervalAction;

exports.CCJumpBy = CCIntervalAction.subclass(
{
	classname: "CCJumpBy",
	
	actionWithDuration: function( t , pos , h , j )
	{
		var action = new this();
		action.initWithDuration( t , pos , h , j );
		return action;
	},

	initWithDuration: function( $super , t , pos , h , j )
	{
		$super( t );
		this._delta 	= pos.clone();
		this._height 	= h;
		this._jumps		= j;
	},
	
//	-(id) copyWithZone: (NSZone*) zone
//	{
//		CCAction *copy = [[[self class] allocWithZone: zone] initWithDuration: [self duration] position: delta height:height jumps:jumps];
//		return copy;
//	}

	startWithTarget: function( $super , target )
	{
		$super( target );
		this._startPosition = this._target.getPosition().clone();
	},
	
	update: function( t )
	{
		var frac = ( t * this._jumps ) % 1.0;
		var y = height * 4 * frac * ( 1 - frac );
		y += this._delta._y * t;
		var x = this._delta._x * t;
		this._target.setPosition(this._startPosition._x + x , this._startPosition._y + y);
	},

//	-(void) update: (ccTime) t
//	{
//		// Sin jump. Less realistic
////		ccTime y = height * fabsf( sinf(t * (CGFloat)M_PI * jumps ) );
////		y += delta.y * t;
////		ccTime x = delta.x * t;
////		[target setPosition: ccp( startPosition.x + x, startPosition.y + y )];	
//		
//		// parabolic jump (since v0.8.2)
//		ccTime frac = fmodf( t * jumps, 1.0f );
//		ccTime y = height * 4 * frac * (1 - frac);
//		y += this._delta._y * t;
//		var x = this._delta._x * t;
//		[target setPosition: ccp( startPosition.x + x, startPosition.y + y )];
//	},

//	-(CCIntervalAction*) reverse
//	{
//		return [[self class] actionWithDuration: duration position: ccp(-delta.x,-delta.y) height: height jumps:jumps];
//	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCBlink'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCBlink'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCBlink'] = exports; var CCIntervalAction = require('Code/Cocos2D/CCIntervalAction').CCIntervalAction;

exports.CCBlink = CCIntervalAction.subclass(
{
	classname: "CCBlink",
	
	$actionWithDuration: function ( t , b )
	{
		var action = new this();
		action.initWithDuration( t , b );
		return action;
	},

	initWithDuration: function( $super , t , b )
	{
		$super( t );
		this._times = b;
	},

//	-(id) copyWithZone: (NSZone*) zone
//	{
//		CCAction *copy = [[[self class] allocWithZone: zone] initWithDuration: [self duration] blinks: times];
//		return copy;
//	}

	update: function( t )
	{
		var slice = 1.0 / this._times;
		var m = t % slice;
		this._target.setVisible( m > slice / 2 );
	}

//	-(CCIntervalAction*) reverse
//	{
//		// return 'self'
//		return [[self class] actionWithDuration: duration blinks: times];
//	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCBezierBy'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCBezierBy'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCBezierBy'] = exports; var CCIntervalAction = require('Code/Cocos2D/CCIntervalAction').CCIntervalAction;

exports.CCBezierBy = CCIntervalAction.subclass(
{
	classname: "CCBezierBy",
	
	$actionWithDuration: function( t ,  c )
	{	
		var action = new this();
		action.initWithDuration( t , c );
		return action;
	},

	initWithDuration: function( $super , t , c ) // BezierConfig
	{
		$super( t );
		this._config = c;
	},

//	-(id) copyWithZone: (NSZone*) zone
//	{
//		CCAction *copy = [[[self class] allocWithZone: zone] initWithDuration: [self duration] bezier: config];
//	    return copy;
//	}

	startWithTarget: function( $super , target )
	{
		$super( target );
		this._startPosition = target.getPosition().clone();
	},
	
	update: function( t )
	{
		var x = bezierAt( this._startPosition._x , 
				this._config._controlPoint_1._x, 
				this._config._controlPoint_2._x, 
				this._config._endPosition._x, t);
		
		var y = bezierAt( this._startPosition._y ,
				this._config._controlPoint_1._y,
				this._config._controlPoint_2._y,
				this._config._endPosition._y, t);
		
		var p = ccp( x , y );
		ccpAddF(p, this._startPosition);
		this._target.setPosition(p);
	},

//	- (CCIntervalAction*) reverse
//	{
//		ccBezierConfig r;
//
//		r.endPosition	 = ccpNeg(config.endPosition);
//		r.controlPoint_1 = ccpAdd(config.controlPoint_2, ccpNeg(config.endPosition));
//		r.controlPoint_2 = ccpAdd(config.controlPoint_1, ccpNeg(config.endPosition));
//		
//		CCBezierBy *action = [[self class] actionWithDuration:[self duration] bezier:r];
//		return action;
//	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCBezierTo'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCBezierTo'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCBezierTo'] = exports; var CCBezierBy = require('Code/Cocos2D/CCBezierBy').CCBezierBy;

exports.CCBezierTo = CCBezierBy.subclass(
{
	classname: "BezierTo",
	
	startWithTarget: function( $super , target )
	{
		$super( target );
		this._config._controlPoint_1 	= ccpSub( this._config._controlPoint_1 	, this._startPosition );
		this._config._controlPoint_2 	= ccpSub( this._config._controlPoint_2	, this._startPosition );
		this._config._endPosition 		= ccpSub( this._config._endPosition		, this._startPosition );
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCInstantAction'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCInstantAction'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCInstantAction'] = exports; var CCFiniteTimeAction = require('Code/Cocos2D/CCFiniteTimeAction').CCFiniteTimeAction;

var CCInstantAction = CCFiniteTimeAction.subclass({
	classname: 'CCInstantAction',
	
	initialize: function()
	{
		this._duration = 0;
	},
	
	isDone: function () {
		return true;
	},
	
	step: function(dt) {
		this._target && this.update(1);
	},
	
	update: function(t) {
		// ignore
	},
	
	reverse: function()
	{
		//console.log("cocos2d: CCInstantAction#reverse: Implement me");
	}
});
exports.CCInstantAction = CCInstantAction;


var CCCallFunc = CCInstantAction.subclass({
	classname: 'CCCallFunc',
	
	$actionWithTarget: function(t, s) {
		return new this().initWithTarget(t,s);
	},
	
	initialize: function () {
		this._targetCallback = null;
		this._selector = null;
	},

	initWithTarget: function(t,s) {
		this._targetCallback = t;
		this._selector = s;
		
		return this;
	},

	startWithTarget: function($super, aTarget) {
		$super(aTarget);
		this.execute();
	},

	execute: function () {
		this._selector.call(this._targetCallback);
	}
});
exports.CCCallFunc = CCCallFunc;

var CCCallFuncN = CCCallFunc.subclass({
	classname: 'CCCallFuncN',
	execute: function ()
	{
		this._selector.call(this._targetCallback,this._target);
	}
});
exports.CCCallFuncN = CCCallFuncN;


var CCCallFuncND = CCCallFuncN.subclass({
	classname: 'CCCallFuncND',
	
	initialize: function () {
		this._data;
		this._callbackMethod;//(id, SEL, id, void *)
	},
	
	$actionWithTarget: function (t,s,d)
	{
		return new this().initWithTarget(t,s,d);
	},
	
	initWithTarget: function ($super,t,s,d)
	{
		$super(t,s);
		this._data = d;
		this._callbackMethod = s;
		return this;
	},
	
	execute: function() {
		this._selector.call(this._targetCallback,this._target,this._data);
	}
});
exports.CCCallFuncND = CCCallFuncND;
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCTransition'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCTransition'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCTransition'] = exports; var CCScene = require('Code/Cocos2D/CCScene').CCScene;

var kSceneFade = 0xFADEFADE;

var CCTransitionScene = CCScene.subclass({
	classname: 'CCTransitionScene',
	
	$transitionWithDuration: function (t,scene) {
		return new this().initWithDuration(t,scene);
	},

	initWithDuration: function (t,s) {
		this._duration = t;
		this._inScene = s;
		this._outScene = CCDirector.runningScene();
		
		// disable events while transitions
//		FIXME: [[CCTouchDispatcher sharedDispatcher] setDispatchEvents: NO];

		return this;
	},
	
	sceneOrder: function() {
		this._inSceneOnTop = true;
	},
	
	draw: function () {
		if( this._inSceneOnTop ) {
			this._outScene.visit();
			this._inScene.visit();
		} else {
			this._inScene.visit();
			this._outScene.visit();
		}
	},
	
	setNewScene: function (dt) {
		this.unschedule(this.setNewScene);
		
		var director = CCDirector;
		
		// Before replacing, save the "send cleanup to scene"
		this._sendCleanupToScene = director._sendCleanupToScene;
		
		director.replaceScene(inScene);
		
		// enable events while transitions
//		FIXME: [[CCTouchDispatcher sharedDispatcher] setDispatchEvents: YES];
		
		// issue #267
		this._outScene.setVisible(true);	
	},

	hideOutShowIn: function () {
		this._inScene.setVisible(true);
		this._outScene.setVisible(false);
	},

	// custom onEnter
	onEnter: function($super) {
		$super();
		this._inScene.onEnter();
		// outScene should not receive the onEnter callback
	},

	// custom onExit
	onExit: function ($super) {
		$super();
		this._outScene.onExit();

		// inScene should not receive the onExit callback
		// only the onEnterTransitionDidFinish
//		TODO: this._inScene.onEnterTransitionDidFinish();
	},

	// custom cleanup
	cleanup: function ($super) {
		$super();
		
		if( this._sendCleanupToScene ) {
			this._outScene.cleanup();
		}
	},
	
	finish: function () {
		/* clean up */	
		this._inScene.setVisible(true);
		this._inScene.setPosition(ccp(0,0));
		this._inScene.setScale(1.0);
		this._inScene.setRotation(0.0);
//		this._inScene.camera();
		
		this._outScene.setVisible(false);
		this._outScene.setPosition(ccp(0,0));
		this._outScene.setScale(1.0);
		this._outScene.setRotation(0.0);
//		this._outScene.camera.restore();
		
		this.schedule(this.setNewScene,0);
	}
	
});
exports.CCTransitionScene = CCTransitionScene;


var CCFadeTransition = CCTransitionScene.subclass({
	classname: 'CCFadeTransition',
	
	$transitionWithDuration: function(d,s,color)
	{
		return new this().initWithDuration(d,s,color);
	},
	
	initWithDuration: function($super,d,s,aColor) {
		if (!aColor) {
			aColor = ccc3(0x00, 0x00, 0x00);
		}
		$super(d,s);
		this._color = new Core.Color(aColor);
		return this;
	},
	
	onEnter: function($super) {
		$super();
		
		var l = CCColorLayer.layerWithColor(this._color);
		this._inScene.setVisible(false);
		
		this.addChild(l,2,kSceneFade);
		
		
		var f = this.getChildByTag(kSceneFade);
		
		var a = CCSequence.actions(CCFadeIn.actionWithDuration(this._duration/2),
								   CCCallFunc.actionWithTarget(this, this.hideOutShowIn.bind(this)),
								   CCFadeOut.actionWithDuration(this._duration/2),
								   CCCallFunc.actionWithTarget(this, this.finish.bind(this)));
		f.runAction(a);
	},

	onExit: function ($super) {
		$super();
		this.removeChildByTag(kSceneFade,false);
	}
});
exports.CCFadeTransition = CCFadeTransition;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/TouchSprite/TSprite'] = function(){var exports = $MODULE_REGISTRY['Code/Game/TouchSprite/TSprite'] || {}; $MODULE_REGISTRY['Code/Game/TouchSprite/TSprite'] = exports; _imageCollisionMapCache = {};
exports.TSprite = Core.Class.subclass(
{
	classname:'TSprite',
	
	initialize: function()
	{
	},

	initWithAtlasSprite_collisionImageName:function (aSprite ,collisionImageName)
	{
		this._collisionImageName = collisionImageName;
		this._sprite = aSprite;
		this.track(this);
		
		if (!_imageCollisionMapCache[this._collisionImageName])
			this.generateCollisionMap();
//			Storage.FileSystem.readFile('./Content/' + collisionImageName + '.map', true, this.generateCollisionMap.bind(this));
		if(_imageCollisionMapCache[this._collisionImageName])
			this._collisionMap = _imageCollisionMapCache[this._collisionImageName];
		else
			Storage.FileSystem.readFile('./Content/' + collisionImageName + '.map', true, this.generateCollisionMap.bind(this));
//		collisionImage = [UIImage imageNamed:collisionImageName];
//        console.log("collisionImageName = " + collisionImageName);
//TODO		
//		if (!collisionImage)	
//		{			//not in app bundle, so check downloaded images
//			collisionImage = [[ [UIImage alloc] initWithContentsOfFile: collisionImageName] autorelease];
//		}
//        NSLog(@"collisionImage = %@", collisionImage);
//		[collisionImage retain];
//		[self generateCollisionMap];
		this._tile = null;
		this._effects = null;
		this._animatedSprites = null;
		this._light = null;
	},

	initWithAtlasSprite: function( $super , aSprite )
	{
		this._sprite = aSprite;
		//TSprite.track( this );
		this._tile = null;
		this._effects = null;
		this._animatedSprites = null;
		this._light = null;
	    
	    return this;
	},
	
	$findByCoordinates: function(tileCoordinates)
	{
		if(tileCoordinates._x == -1 && tileCoordinates._y == -1)
			return null;
		
		for(var key in allMySprites)
		{
			var obj = allMySprites[key];
			if(obj._tile && tileCoordinates._x == obj._tile._rootTile._x && tileCoordinates._y == obj._tile._rootTile._y)
			{
				return obj;
			}
		}
		return null;
	},
	
	$allMySprites: function()
	{
    	return allMySprites;
	},
	
	$track: function(aSprite) 
	{
		for (var key in allMySprites)
		{
			var obj = allMySprites[key];
			if (obj == aSprite)
			{
				return;
			}
		}
		
        allMySprites.push(aSprite);
	},

	$untrack: function(aSprite)
	{
        /* TODO: Particle system, lights
		if(aSprite.effects)
			for(CCQuadParticleSystem *particle in aSprite.effects)
			{
				// stopsystem does not release object must manually remove it
				[particle.parent removeChild:particle cleanup:YES];
				[particle stopSystem];
			}
		
		[aSprite.effects removeAllObjects];
		aSprite.effects = nil;
		
		if(aSprite.light)
		{
			[[AmbientLayer getInstance] removeLight:aSprite.light];
			aSprite.light = nil;
		}*/
		
		if (aSprite._animation)
		{
			aSprite._animation._parent.removeChild(aSprite._animation, true);
			destroyWithChildren(aSprite._animation);
			aSprite._animation = null;
		}
		
		if (aSprite._animatedSprites)
		{
			for (var key in aSprite._animatedSprites)
			{
				var anim = aSprite._animatedSprites[key];
				
				if (anim && anim._parent)
				{
				    anim._parent.removeChild(anim, true);
				    destroyWithChildren( anim );
				}
			}
			
			aSprite._animatedSprites.length = 0;
			aSprite._animatedSprites = null;			
		}
		
		allMySprites.splice(allMySprites.indexOf(aSprite), 1);
	},
	
	setSpecialAnchor: function(x,y){
		this._specialAnchorX = x;
		this._specialAnchorY = y;
	},
	

	
	rect: function() 
	{
		var scale = this._sprite.getParent().getScale();		
		var pos = new Core.Point(this._sprite.getPosition()._x * scale._x, this._sprite.getPosition()._y * scale._y);
		
		var w = this._sprite._contentSize._width * scale._x;
		var h = this._sprite._contentSize._height * scale._y;
		
		anchorX = this._specialAnchorX? this._specialAnchorX:this._sprite._anchorPoint._x;
		anchorY = this._specialAnchorY? this._specialAnchorY:this._sprite._anchorPoint._y;
		
		var x = pos._x - w * anchorX;
		var y = pos._y - h * anchorY;
		var r = new Core.Rect(x,y,w,h);
		
		if (this._actor)
		{
			r.setSize(new Core.Size(r.getSize()._width, r.getSize()._height*1.5));
			r.setOrigin(new Core.Point(r.getOrigin()._x, r.getOrigin()._y - (r.getSize()._height - (r.getSize()._height/1.5))));
		}
		
		return r;
	},

	generateCollisionMap: function(err, imageData)
	{
		if(err)
		{
			console.log("error reading file " + err + " for file " + this._collisionImageName + ".map");
			return;
		}

		if(!err && !imageData){
			imageData = DataPreloader._tilesCache["./Content/"+this._collisionImageName+".map"];
			if(imageData)
				console.log("-- Precreated: "+this._collisionImageName+" --");
		}
		else{
			imageData = Base64Ext.decode(imageData);
			console.log("-- Created: "+this._collisionImageName+" --");
		}
		if(!imageData)
			return;
		
		var rect = this._sprite._textureRect;
		
		if (this._collisionMap)
		{
			this._collisionMap = null;
		}
		this._collisionMap = [];
//		console.log("collision map = " + imageData.length);
//		for(var key in imageData)
//		{
//			console.log("key " + key + " = " + imageData.charCodeAt(key));
//		}
		var originX = rect.getOrigin()._x;
		var originY = rect.getOrigin()._y;
		var rw = rect.getSize()._width;
		var rh = rect.getSize()._height;
		var collisionArraySize = rw * rh;
		
		
//		CFDataRef imageData = CGDataProviderCopyData( CGImageGetDataProvider( collisionImage.CGImage ) );
//		const UInt32 *pixels = (const UInt32*)CFDataGetBytePtr( imageData ); 

		var collisionImageWidth = imagesSize[this._collisionImageName][0];
//		console.log("collisionImageWidth  = " + collisionImageWidth)
		var imageDataLength = imageData.length;

		for(var y=0; y < rh; y++)
		{
			for(var x=0; x < rw; x++)
			{
				//int element1 = (int)(((y + originY) * collisionImage.size.width) + (x + originX));
				var element1 = ((y + originY) * collisionImageWidth) + (x + originX);
				
				
				if (element1 >= imageDataLength)
				{
					console.log("generateCollisionMap element1 OOB!!!! " + this._collisionImageName + ".map data len = " + imageDataLength);
					break;//continue;
				}
				
				//if (  pixels[(y+originY) * STANDARD_TILE_WIDTH * STANDARD_SHEET_WIDTH + x + originX] & 0xFF000000 )
				
				var element2 = y * rw + x;
//				console.log("elem at = " + element1 + " is " + imageData[element1]);
				if (imageData.charCodeAt(element1) != 0)
				{	
					
					//if (element2 >= collisionArraySize)
//					{
//						NSLog(@"generateCollisionMap element2 OOB!!!!");
//						continue;
//					}
//					else
//					{					
					this._collisionMap[element2] = 1;
					//}			
				}
				else
				{
					this._collisionMap[element2] = 0;
				}
			}
		}
		_imageCollisionMapCache[this._collisionImageName] = this._collisionMap;
//		if(this._collisionImageName == "tex0002.png")
//		{
//			console.log(JSON.stringify(this._collisionMap));
//			for(var i = 0; i <collisionArraySize; i++)
//			{
//				if(this._collisionMap[i] != 0)
//				{
//					console.log("" + this._collisionImageName + " col array first pixel non transparent at index = " + i);
//					break;
//				}
//			}
//			for(var i = collisionArraySize - 1; i > 0; i--)
//			{
//				if(this._collisionMap[i] != 0)
//				{
//					console.log("" + this._collisionImageName + "col array last pixel non transparent at index = " + i);
//					break;
//				}
//			}
//			
//			for(var i = 0; i < imageData.length; i++)
//			{
//				if(imageData.charCodeAt(i) != 0)
//				{
//					console.log("" + this._collisionImageName + "first pixel non transparent at index = " + i);
//					break;
//				}
//			}
//			for(var i = imageData.length - 1; i > 0; i--)
//			{
//				if(imageData.charCodeAt(i) != 0)
//				{
//					console.log("" + this._collisionImageName + "last pixel non transparent at index = " + i);
//					break;
//				}
//			}
			

//		}
//		CFRelease( imageData ); 
	},
	
	isPixelOpaqueAt: function(point)
	{
		var rect = this._sprite._textureRect;
		
//		NSAssert(point.x < rect.size.width || point.x >= 0, @"oob");
//		NSAssert(point.y < rect.size.height || point.y >= 0, @"oob");
		
//		console.log("point to check = "+ stringFromPoint(point));
		var x = Math.floor(point._x); 
		var y = rect.getSize()._height - Math.floor(point._y) - 1;
//		console.log("X = "+ x + " y = " + y + " rect = " + stringFromRect(rect));
//		console.log("index to check = "+ Math.floor(((y * rect.getSize()._width) + x)) + " value = "+ this._collisionMap[Math.floor(((y * rect.getSize()._width) + x))]);
		if(this._collisionMap)
		{
			var res =  this._collisionMap[Math.floor(((y * rect.getSize()._width) + x))]; 
			return res;
		}
		else
		{
			console.log("no collision map for image " + this._collisionImageName);
			return 0;
		}
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/LoadingScreen/LoadScreen'] = function(){var exports = $MODULE_REGISTRY['Code/LoadingScreen/LoadScreen'] || {}; $MODULE_REGISTRY['Code/LoadingScreen/LoadScreen'] = exports; /**
 * Only show this LoadScreen if there is an Internet Connection, developer must
 * validate the condition before calling this class
 * 
 * How to use
 * ==========
 * - Call load() if Internet Connection is Available when the game tarts so we will have time before showing for images downloading
 * - If you want to show the LoadScreen image call show();
 * - If you want to hide the LoadScreen image call hide();
 * - If you call show function, but no server image has been loading yet, is going to try _showTries times in one more second... if no chance it will use the backup image
 * - Id there is some network error this._remoteError is going to be true, so check out this variable before calling any function
 */
exports.LoadScreen = Core.Class.singleton({
    classname : 'LoadScreen',
    
    $loadScreen : {
        kLoadScreenHideDoneNotification : "kLoadScreenHideDoneNotification"
    },
    
    initialize : function()
    {
        this._webSiteUrl = "http://s3.amazonaws.com/zombiefarm-website/website/images/loadscreen/"; // remote base URL
        this._imagesList = "LoadScreenImageNames.plist"; // there is an iPad list also
        this._downloadFolder = "Content/"; // Relative Path
        this._imageFolder = "Content/"; // Directory path
//        this._backupImage = "Default.png"; // Directory path
        this._remoteError = false; // If a remote error occurs this is going to be true
        this._imageList = []; // List of images names
        this._imageListSize = 0; // Number of images names on list
        this._showTries = 5; // Number of times shows tries to execute, if not image loaded, backup image is used
        this._prevImageIndex = -1; // Index of last image shown to rotate
        this._imageNode = null; // Image node
        this._depth = 10; // Z Index
        this._imageAlpha = 1; // Current alpha
        this._imageAlphaStep = 0.2; // How alpha we increment each step
        this._imageAlphaInterval = 33; //How fast the alpha is incremented
        this._rootNode = UI.Window.document; // GL2.Root
        
        this._IMAGE_QUANTITY = 4;
        this._isFirstTime = true;
        this._hideCalled = false;
        return this;
    },
    
    getInstance : function()
    {
        return this;
    },
    
    /**
     * Loads the Remote Images to Files
     */
    load : function()
    {
        var url = this._webSiteUrl + this._imagesList;
        
        this._remoteError = true;
        
        for (var i = 0; i < this._IMAGE_QUANTITY; i++){
        	 this._imageList[i] = "loadingScreenImage" + i + ".png";
             this._imageListSize++;
        }
        
        /* FIXME: disabled loading screen download
        var download = new DownloadFile();
        download.start(this._downloadFolder + this._imagesList, "GET", url, [], function(s, f)
        {
            this.didGetXML(s, f);
        }.bind(this));*/
    },
    
    /**
     * When the XML is received tries to read it
     */
    didGetXML : function(statusCode, fileSignature)
    {
        if (statusCode != 200)
        {
            this._remoteError = true;
            return;
        }
        
        Storage.FileSystem.readFile(this._downloadFolder + this._imagesList, false, function(err, data)
        {
            this.setImageList(err, data);
        }.bind(this));
    },
    
    /**
     * Reads the XML to the imagename list
     */
    setImageList : function(err, data)
    {
        if (err)
        {
            this._remoteError = true;
            return;
        }
        
        var index = data.indexOf('<string>');
        if (index == -1)
        {
            this._remoteError = true;
            return;
        }
        
        while (index >= 0)
        {
            var end = data.indexOf('</string>');
            index = index + 8; //<string> length
            var length = end - index;
            var imageFile = data.substr(index, length);
            this.downloadImage(imageFile);
            end = end + 9; //</string> length
            data = data.substr(end);
            index = data.indexOf('<string>');
        }
    },
    
    /**
     * Downloads an Image
     */
    downloadImage : function(imageName)
    {
        var url = this._webSiteUrl + imageName;
        var download = new DownloadFile();
        download.start(this._downloadFolder + imageName, "GET", url, [], function(s, f)
        {
            this.didGetImage(s, f, imageName);
        }.bind(this));
    },
    
    /**
     * When image is downloaded, stores the name on the available array list 
     */
    didGetImage : function(statusCode, fileSignature, imageName)
    {
        if (statusCode != 200)
        {
            this._remoteError = true;
            return;
        }
        
        this._imageList[this._imageListSize] = imageName;
        this._imageListSize++;
    },
    
    /**
     * Shows the loading screen if there is an image available. Retries on failure.
     */
    show : function()
    {
    	/*
        if (this._imageListSize == 0)
        {
        	//FIXME: setting the default image
//            if (this._remoteError || this._showTries <= 0)
//            {
                this._imageList[this._imageListSize] = this._backupImage;
                this._imageListSize++;
//            }
            // Tries again if no image data exists
//            this._showTries--;
            
//            setTimeout(this.show.bind(this), 200);
//            return;
        }
        */
        this.start();
    },
    
    /**
     * Starts showing the loading screen
     */
    start : function()
    {
        // never the same image twice in a row
//    	var size = new Core.Size(UI.Window._width, UI.Window._height);
    	var size = CCDirector.winSize();
//    	if(this._isFirstTime){
//    		this._imageNode = new UI.Image();
//	        this._imageNode.setImage(this._imageFolder + this._backupImage);
//	        this._isFirstTime = false;
//    	} else{
    	var index = Math.floor(Math.random() * this._imageListSize);
    	this._imageNode = new UI.Image();
	    this._imageNode.setImage(this._imageFolder + this._imageList[index]);
//    	}
    	
	    var loadingH = size._height/15;
	    
    	if(!this._backGround){
    		this._backGround = new UI.Image();
    		this._backGround.setImage("Content/blank.png");
	        this._backGround.setImageFit(UI.FitMode.Stretch);
	        this._backGround.setFrame([ 0, 0, size._width, size._height ]);
	        this._backGround.setAlpha(1);
	        
	        
	        var loadingY = size._height-loadingH;
	        var loadingW = loadingH*3;
	        var loadingX = size._width - loadingW;
	        
	        this._loadingBar = new UI.Image();
    		this._loadingBar.setImage("Content/loading_bar.png");
	        this._loadingBar.setImageFit(UI.FitMode.Stretch);
	        this._loadingBar.setFrame([ 0, loadingY, size._width, loadingH ]);
	        this._loadingBar.setAlpha(1);
	        
	        this._loading = new UI.Image();
    		this._loading.setImage("Content/loading.png");
	        this._loading.setImageFit(UI.FitMode.Stretch);
	        this._loading.setFrame([ loadingX, loadingY, loadingW, loadingH ]);
	        this._loading.setAlpha(1);
    	}
    	
        this._imageNode.setImageFit(UI.FitMode.Stretch);
        
//        var imageSize = new Core.Size(imagesSize[this._backupImage]);
        
        var A = 1.72; //imageSize._width / imageSize._height;
        
        var w = size._width;
        var h = w/A;
        var posx = 0;
        var posy = 0;
        
        var maxH = size._height-loadingH;
        
        if(h>maxH){
        	h = maxH;
        	w = h*A;
        	posx = (size._width - w)/2;
        }
        else{
        	posy = (maxH - h)/2;
        }
        	
        this._imageNode.setFrame([ posx, posy, w, h ]);
        this._imageNode.setAlpha(1);
        this._imageAlpha = 1;
        
        this._rootNode.addChild(this._backGround);
        this._rootNode.addChild(this._imageNode);
        this._rootNode.addChild(this._loadingBar);
        this._rootNode.addChild(this._loading);
        
        this._spinner = new UI.Spinner();
        this._spinner.setDarkStyle(true);
        spinnerSize = Math.floor(UI.Window._height / 9);
        this._spinner.setFrame([ UI.Window._width / 2 - spinnerSize / 2, UI.Window._height  - spinnerSize * 2,spinnerSize,spinnerSize]);
    	this._rootNode.addChild(this._spinner);
        this.fadeIn();
    },
    
    fadeIn : function()
    {
        this._imageAlpha = this._imageAlpha + this._imageAlphaStep;
        if (this._imageAlpha > 1 || this._hideCalled)
        {
            this._imageNode.setAlpha(1);
            this._backGround.setAlpha(1);
            this._loadingBar.setAlpha(1);
            this._loading.setAlpha(1);
            return;
        }
        
        this._imageNode.setAlpha(this._imageAlpha);
        this._backGround.setAlpha(this._imageAlpha);
        this._loadingBar.setAlpha(this._imageAlpha);
        this._loading.setAlpha(this._imageAlpha);
        
        setTimeout(this.fadeIn.bind(this), this._imageAlphaInterval);
    },
    
    hide : function()
    {
        this._hideCalled = true;
        
        if (this._spinner)
        {
        	this._spinner.destroy();
        	this._spinner = null;
        }
        
        this.fadeOut();
    },
    
    fadeOut : function()
    {        
        if (this._imageAlpha <= 0)
        {
            if (this._imageNode)
            {
                this._imageNode.destroy();
                this._imageNode = null;
            }
            
            if (this._backGround)
            {
                this._backGround.destroy();
                this._backGround = null;
            }
            
            if (this._loadingBar)
            {
                this._loadingBar.destroy();
                this._loadingBar = null;
            }
            
            if (this._loading)
            {
                this._loading.destroy();
                this._loading = null;
            }
            
            this._hideCalled = false;
            return;
        }
        else
        {
            this._imageAlpha -= this._imageAlphaStep;
        }
        
        if (this._imageNode && this._backGround && this._loadingBar && this._loading) {
            this._imageNode.setAlpha(this._imageAlpha);
            this._backGround.setAlpha(this._imageAlpha);
            this._loadingBar.setAlpha(this._imageAlpha);
            this._loading.setAlpha(this._imageAlpha);
            setTimeout(this.fadeOut.bind(this), this._imageAlphaInterval);
        }
            
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Application/ZombieFarmAppDelegate'] = function(){var exports = $MODULE_REGISTRY['Code/Application/ZombieFarmAppDelegate'] || {}; $MODULE_REGISTRY['Code/Application/ZombieFarmAppDelegate'] = exports; var UI = require('NGCore/Client/UI').UI;

var glViewInitialized = false;
exports.ZombieFarmAppDelegate = Core.Class.singleton({
	classname : 'ZombieFarmAppDelegate',
	initialize : function() {
		LoadScreen.load();
		
		function initGLView() {
			glViewInitialized = true;
			LoadScreen.show();
			var glView = new UI.GLView();
			glView.onload = function() {
				mainContinueLoad();
			};
			
			glView.setAttribute('frame', [0,0,UI.Window._width,UI.Window._height]);
			glView.setAttribute('active', true);
		};
		
		var LayoutListener = Core.MessageListener.subclass(
				{
					initialize: function()
					{
						console.log("LayoutListener.initialize(ZF)");
						Device.LayoutEmitter.addListener(this, this.onUpdate,-1);
					},
					
					onUpdate: function(layout)
					{
						console.log("LayoutListener.onUpdate(ZF): %s, %d",JSON.stringify(layout),Device.OrientationEmitter.getInterfaceOrientation());
						//requires to ask for width > height to avoid false call on Android where the orientation is LandscafpeLeft but the width is till the same as in portrait
						if (!glViewInitialized && UI.Window._width > UI.Window._height) {
							initGLView();
						}
					}
		});
		
		if(Core.Capabilities.getPlatformOS() == "flash"){
			Device.OrientationEmitter.setInterfaceOrientation(Device.OrientationEmitter.Orientation.LandscapeLeft);
			UI.Window._width = Core.Capabilities.getScreenHeight();
			UI.Window._height = Core.Capabilities.getScreenWidth();
			initGLView();
		} else{
			if (Device.OrientationEmitter.getInterfaceOrientation() != Device.OrientationEmitter.Orientation.LandscapeLeft) {
				console.log("ZombieFarmAppDelegate.initialize: setting interface orientation to LandscapeLeft");
				new LayoutListener();
				Device.OrientationEmitter.setInterfaceOrientation(Device.OrientationEmitter.Orientation.LandscapeLeft);
			} else {
				console.log("ZombieFarmAppDelegate.initialize: interface already on LandscapeLeft orientation");
				initGLView();
			}
		}
		
		Device.LifecycleEmitter.addListener(new Core.MessageListener(),this._onLifecycleChange.bind(this));
		Device.KeyEmitter.addListener(new Core.MessageListener(),this._onKeyPressed.bind(this));
		
		// Send a first install event if this is the first time we are running the app
//	    NSUserDefaults* defaults = [NSUserDefaults standardUserDefaults];
//	    NSNumber* alreadyInstalled = (NSNumber*)[defaults objectForKey:kEventAlreadyInstalled];
//	    
//	    if (alreadyInstalled == nil || ![alreadyInstalled boolValue])
//	    {
//	        // Send event notification
//	        EventTracker* eventTracker = [EventTracker eventTracker];
//	        
//	        [eventTracker sendEvent:@"new_install" withParameters:nil andDelegate:self];
//	    }
	    
	    // Reset our pref for whether or not we have already shown the Game Center canceled message
//	    NSNumber* alreadyShowedCancel = [NSNumber numberWithBool:NO];
//	    
//	    [defaults setObject:alreadyShowedCancel forKey:ZFAlreadyShowedGameCenterCancel];
//	    [defaults synchronize];
	    
	    // Start up the Player Profile Manager //this is being done on Main class. 
//	    var ppm = PlayerProfileManager.playerProfileManager();
//	    ppm.startup();
	    
		//Conversion Tracking for Ad networks
	    
	    //Millenial
//	    [MMAdView startSynchronousConversionTrackerWithGoalId:kMillenialGoalID];
	    
	    //g6Pay
//		G6Pay *trackerInstance = [G6Pay new];
//		[trackerInstance trackWithAppId:G6PayAppID : G6PaySecret];    
	    
//		[self performSelectorInBackground:@selector(reportAppOpenToAdMob) withObject:nil];		//AdMob
//		[self performSelectorInBackground:@selector(trackDownload) withObject:nil];				//GrayStripe
																								
		//JumpTap
//		[JumpTapAppReport loggingEnabled: NO];
//		[self performSelector: @selector(doJumptapReport) withObject: nil afterDelay: 0];
		
		// Playhaven
//		[PlayHaven preloadWithDelegate:self];
		
		// Init the window
//		window = [[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]];
		
		// cocos2d will inherit these values
//		[window setUserInteractionEnabled:YES];	
//		[window setMultipleTouchEnabled:YES];
	    
//		if( ! [CCDirector setDirectorType:CCDirectorTypeDisplayLink] )
//			[CCDirector setDirectorType:CCDirectorTypeMainLoop];
		
//		[CCTexture2D.setDefaultAlphaPixelFormat:kTexture2DPixelFormat_RGBA4444];
//		[[CCDirector sharedDirector] setDeviceOrientation:CCDeviceOrientationLandscapeLeft];
//		[[CCDirector sharedDirector] setAnimationInterval:1/60.0];//does nothing atm
//		[[CCDirector sharedDirector] setDisplayFPS:NO];
	    
	    // Alloc and init the opengl view
	    // [[CCDirector sharedDirector] attachInView:window];
//	    EAGLView* glView = [EAGLView viewWithFrame:[window bounds]
//	                                     pixelFormat:kEAGLColorFormatRGB565
//	                                     depthFormat:0 /* GL_DEPTH_COMPONENT24_OES */
//	                              preserveBackbuffer:NO];

	    // Turn on multiple touches
//	    [glView setMultipleTouchEnabled:YES];
	    
	    // Add it to our main window
//	    [window addSubview:glView];
	    
	    // Set the opengl view for the CCDirector
//	    [[CCDirector sharedDirector] setOpenGLView:glView];
		
		// create and fetch data from website to show for loading screen
		
		
		// trying out 2d projection
//		[[CCDirector sharedDirector] setProjection:CCDirectorProjection2D];

//		[window makeKeyAndVisible];	
		
//		this.preloadAudio();
		
//	    this._mainMenu = MainMenu.initWithNibName(null,null);
	    
//		[window addSubview:mainMenu.view];
		
		//ApSalar
//	    [Apsalar startSession:kApSalarAPPID withKey:kApSalarSecret];
	    
		//Flurry
//		NSSetUncaughtExceptionHandler(&uncaughtExceptionHandler);
//		[FlurryAPI setAppCircleEnabled:YES];
//		[FlurryAPI startSession:kFlurryAPIKey];
		
		//TapJoy
//		[[TapjoyConnect requestTapjoyConnectWithAppId:kTapjoyAPPID
//										 WithPassword:kTapjoyPW
//										  WithVersion:kTapjoyVer] connect];
		
		//preload fonts
//		[[FontManager sharedManager] loadFont:@"AmericanTypewriter-Bold"];
//		[[FontManager sharedManager] loadFont:@"AmericanTypewriter"];
//		[[FontManager sharedManager] loadFont:@"Arial-BoldMT"];
		
		this._returnedFromBackground = false;
		this._enteredBackground = false;
		this._inMainMenu = true;
	},
	
	_onKeyPressed: function(/*Device.KeyEmitter.Event*/ event) {
       if (event.code === Device.KeyEmitter.Keycode.back) {
    	   var ret = BackButtonHandler.destroyTop();
    	   
    	   //If we are not handling this event, means that we are in the farm scene, so we have to save the game because 
    	   if(!ret){
    		   GameState.saveGameReal();
    	   }
           return ret;
       };
       
       return false;
	},
	
	_onLifecycleChange: function(/*Device.LifecycleEmitter.Event*/ event) {
		switch(event) {
		case Device.LifecycleEmitter.Event.Suspend:
			this.applicationWillResignActive();
			break;
		case Device.LifecycleEmitter.Event.Resume:
			this.applicationDidBecomeActive();
			break;
		case Device.LifecycleEmitter.Event.Terminate:
			this.applicationWillTerminate();
			break;
		}
	},
	
	/**
     * Called when the application is about to terminate.
     */
	applicationWillTerminate: function() {
		console.log("ZombieFarmAppDelegate: applicationWillTerminate");
//		[[TapjoyConnect sharedTapjoyConnect] disconnect];
		
		//dont save the game if the user never hit the play button
		//user hit the play button if a scene is running
		if (CCDirector._runningScene instanceof ZFFarmGameScene)
		{
//			this.scheduleLocalNotifications();
			GameState.saveGameReal();
		}
		
		CCDirector.end();
//	    [Apsalar event:@"zf_close_app"];
	},
	
	/**
     * Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions
     * (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     * Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
	applicationWillResignActive: function() {
		console.log("ZombieFarmAppDelegate: applicationWillResignActive");
		CCDirector.pause();
		var sae = SimpleAudioEngine;
		if (sae.isBackgroundMusicPlaying()) {
			sae.pauseBackgroundMusic();
		}
		
		if (CCDirector._runningScene instanceof ZFFarmGameScene) {
//			this.scheduleLocalNotifications();
			GameState.saveGameReal();
		}
		
		SpriteFactoryCache.clearAnimationCache();
	},
	
	/**
     * Restart any tasks that were paused (or not yet started) while the application was inactive.
     */
	applicationDidBecomeActive:function() {
		
		console.log("ZombieFarmAppDelegate: applicationDidBecomeActive");
		Device.OrientationEmitter.setInterfaceOrientation(Device.OrientationEmitter.Orientation.LandscapeLeft);
				
		setTimeout(this.wakeUp.bind(this),0);	
//		application.applicationIconBadgeNumber = 0;
//	    [Apsalar event:@"zf_start_app"];
		
		GameState.saveGameReal();
		
		SimpleAudioEngine.resumeBackgroundMusic();
		
		console.log("UI(" + UI.Window._height + "," + UI.Window._width + ")");
		
	},
	
	wakeUp: function() {
		CCDirector.resume();
		
		console.log("ZombieFarmAppDelegate: Resumed");

//		[window makeKeyAndVisible];
		
		CCDirector.startAnimation();
		
		//check if the game is running
		var gui = ZFGuiLayer.guiCheck();
		if (gui && CCDirector._runningScene)
		{
//			ZFGuiLayer.gui().dailyEventCheck();
//			ZFGuiLayer.gui().initFarmWeather();
		}
		
		//clear any badge number
//		var enabled = ZombieFarmAppDelegate.localNotificationEnabled();
//		if (enabled) 
//		{
//			UIApplication.sharedApplication().cancelAllLocalNotifications();
//		}
	},
	
	getCurrentLanguage: function () {
		return Core.Capabilities.getLanguage();
	}

});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/DataPreloader'] = function(){var exports = $MODULE_REGISTRY['Code/Game/DataPreloader'] || {}; $MODULE_REGISTRY['Code/Game/DataPreloader'] = exports; exports.DataPreloader = Core.Class.singleton({
    classname: 'DataPreloader',
    
    initialize: function() {
    },

    preloadData:function (callback) {        
        var loadedFiles = 0;
        this._stageActorData = [];
        var firstTileGroup = 18;//36
        var secondTileGroup = 15;//95

        this._tilesCache = {};
        function fileLoadedCallback(i, data) {
            NSAssert(data != null, "Could not load file");
            
            if(typeof i == "string"){
            	console.log(" -- Precreated Tiles: "+i +" --");
            	this._tilesCache[i] = Base64Ext.decode(data);
            }
            else
            switch (i)
            {
                case 0:
                    this._alienStageData = data;
                    break;
                case 1:
                    this._alienStageElementsData = data;
                    break;
                case 2:
                    this._beachStageData = data;
                    break;
                case 3:
                    this._farmStageData = data;
                    break;
                case 4:
                    this._robotStageElementsData = data;
                    break;
                case 5:
                	this._drops = data;
                	break;
                case 6:
                	this._skeletonDictionary = data;
                	break;
                case 7:
                    this._attacksData = data;
                    break;
                case 8:
                    this._enemyData = data;
                    break;
                case 9:
                    this._marketData = data;
                    break;
                case 10:
                    this._farmerSprites = data;
                    break;
                case 11:
                    this._unitStats = data;
                    break;
                case 12:
                    this._nameList = data;
                    break;
                case 13:
                    this._stageActorDictionaries = data;
                    break;
                case 14:
                    this._zombieSheet = data;
                    break;
                case 15:
                    this._tex1085 = data;
                    break;
                case 16:
                    this._tex1086 = data;
                    break;
                case 17:
                    this._tex1087 = data;
                    break;
                case 18:
                    this._questData = data;
                    break;
                case 19:
                    this._iceCreamStageDictionary = data;
                    break;
                case 20:
                    this._mutationCollectionDictionary = data;
                    break;
                case 21:
                    this._robotStageData = data;
                    break;
//                case 22:
//                    this._stageActorData["alienInvader.plist"] = data;
//                    break;
//                case 23:
//                    this._stageActorData["bunyActor.plist"] = data;
//                    break;
                case 22:
                    this._tex1093 = data;
                    break;
                case 23:
                    this._tex1083 = data;
                    break;
                case 24:
                    this._tex1082 = data;
                    break;
                case 25:
                    this._tex1080 = data;
                    break;
                case 26:
                    this._tex1079 = data;
                    break;
                case 27:
                    this._tex1081 = data;
                    break;
                case 28:
                    this._tex1084 = data;
                    break;
            }
            
            loadedFiles++;
            if (loadedFiles == (29+firstTileGroup+secondTileGroup)) {
                callback();
            }
        }
        
        // Pre-loads files
        this._preloadFile("./Content/AlienStage.plist.json", fileLoadedCallback.bind(this, 0),false);
        this._preloadFile("./Content/AlienStageElements.plist.json", fileLoadedCallback.bind(this, 1),false);
        this._preloadFile("./Content/BeachStageSkeleton.plist.json", fileLoadedCallback.bind(this, 2),false);
        this._preloadFile("./Content/FarmStage.plist.json", fileLoadedCallback.bind(this, 3),false);
        this._preloadFile("./Content/RobotStageElements.plist.json", fileLoadedCallback.bind(this, 4),false);
        this._preloadFile("./Content/Drops.plist.json", fileLoadedCallback.bind(this, 5),false);
        this._preloadFile("./Content/IceCreamStageSkeleton.plist.json", fileLoadedCallback.bind(this, 6),false);
        this._preloadFile("./Content/Attacks.plist.json", fileLoadedCallback.bind(this, 7),false);
        this._preloadFile("./Content/Enemies.plist.json", fileLoadedCallback.bind(this, 8),false);
        this._preloadFile("./Content/Market.plist.json", fileLoadedCallback.bind(this, 9),false);
        this._preloadFile("./Content/FarmerSprites.plist.json", fileLoadedCallback.bind(this, 10),false);
        this._preloadFile("./Content/UnitStats.plist.json", fileLoadedCallback.bind(this, 11),false);
        this._preloadFile("./Content/ZombieNames.plist.json", fileLoadedCallback.bind(this, 12),false);
        this._preloadFile("./Content/stageActors.plist.json", fileLoadedCallback.bind(this, 13),false);
        this._preloadFile("./Content/ZombieSheet.plist.json", fileLoadedCallback.bind(this, 14),false);
        this._preloadFile("./Content/tex1085.plist.json", fileLoadedCallback.bind(this, 15),false);
        this._preloadFile("./Content/tex1086.plist.json", fileLoadedCallback.bind(this, 16),false);
        this._preloadFile("./Content/tex1087.plist.json", fileLoadedCallback.bind(this, 17),false);
        this._preloadFile("./Content/Quests.plist.json", fileLoadedCallback.bind(this, 18));
        this._preloadFile("./Content/IceCreamStage.plist.json", fileLoadedCallback.bind(this, 19),false);
        this._preloadFile("./Content/MutationCollection.plist.json", fileLoadedCallback.bind(this, 20),false);
        this._preloadFile("./Content/RobotStage.plist.json", fileLoadedCallback.bind(this, 21),false);
        this._preloadFile("./Content/tex1093.plist.json", fileLoadedCallback.bind(this, 22),false);
        this._preloadFile("./Content/tex1083.plist.json", fileLoadedCallback.bind(this, 23),false);
        this._preloadFile("./Content/tex1082.plist.json", fileLoadedCallback.bind(this, 24),false);
        this._preloadFile("./Content/tex1080.plist.json", fileLoadedCallback.bind(this, 25),false);
        this._preloadFile("./Content/tex1079.plist.json", fileLoadedCallback.bind(this, 26),false);
        this._preloadFile("./Content/tex1081.plist.json", fileLoadedCallback.bind(this, 27),false);
        this._preloadFile("./Content/tex1084.plist.json", fileLoadedCallback.bind(this, 28),false);
       
        for(var i = 0; i<firstTileGroup; i++){
    		var filename = null;
    		if(i>9)
    			filename = "./Content/tex00"+i+".png.map";
    		else
    			filename = "./Content/tex000"+i+".png.map";
    		
    		this._preloadFile(filename, fileLoadedCallback.bind(this, filename), true);
    	}
        
        for(var i = 0; i<secondTileGroup; i++){
    		var filename = null;
    		if(i>9)
    			filename = "./Content/tex10"+i+".png.map";
    		else
    			filename = "./Content/tex100"+i+".png.map";
    		
    		this._preloadFile(filename, fileLoadedCallback.bind(this, filename), true);
    	}
    },
    
    _preloadFile:function(fileName, callback, binaryData) {
        Storage.FileSystem.readFile(fileName, binaryData, function(error, content)
        {
            if (error || !content)
            {
                NgLogD("ERROR: Couldn't read file " + fileName);
                callback(null);
            }
            else
            {
            	if(binaryData)
            		callback(content);
            	else{
            		var data = eval('(' + content + ')');
            		callback(data);
            	}
                
            }
            
        }.bind(this));
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Actor'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Actor'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Actor'] = exports; exports.Actor = CCNode.subclass({
	classname : 'Actor',

	initValues : function() {
		this._spriteFileName = null;
		this._spriteFrameFile = null;
		this._attachments = [];
		this._abilityList = [];
		this._particles = [];
		this._spriteDictionary = {};
		this._skeletonDictionary = {};
		this._unitDictionary = {};
		this._frameOffset = null; // CGPoint
		this._lastFramePosition = null; // CGPoint
		this._destinationPoint = null; // CGPoint to avoid cycles
		this._state = 0; // int, idle walking etc
		this._brainState = 0; // int, this actor's needs like i want to go to
								// a shed
		this._type = 0; // int
		this._subType = 0; // int
		this._color = ccc3(0, 0, 0); // ccColor3B
		this._savedColor = ccc3(0, 0, 0); // ccColor3B
		this._walkingSpeed = 0; // float
		this._animSpeed = 0; // float
		// NSString *unitKey;
		// #ifndef ZFthis._SAVEthis._ED
		this._fightData = null; // ActorFightData
		this._spriteMan = null; // CCSpriteSheet
		// #endif // ZFthis._SAVEthis._ED
		this._farmData = null; // ActorFarmData *
		this._fights = 0; // int
		this._flags = 0; // int
		this._eatDate = null; // NSDate*
		this._hunger = 0; // float
		this._collisionBoxSize = null; // CGSize
		this._collisionBoxOffset = null; // CGPoint
		this._collisionEnabled = false; // BOOL
		this._stunRotateLayer = null; // CCLayer *
		this._stunSprite = null; // CCSprite *
		this._stunTrail = null; // CCParticleSystem *
		this._doppleganger = null; // Actor *
		this._widthScale = 0; // float
		this._heightScale = 0; // float
		this._classUnitKey = null; // NSString*
		this._resolutionHeight = 0; // float
		this._resolutionWidth = 0; // float
		this._widthScale = UI.Window._height / ZFGameDefines.ORIGINAL_WINDOW_WIDTH;
		this._heightScale = this._widthScale;
		this._flipUpdate = true;
		this._lastScale = -1000;
		this._actorLastPosition = -1000880;
	},

	initialize : function() {
		this.initValues();
		this.initActorSpecificData();
		this._tmpOffset = 0;
	},

	destroy : function() {

		if (this._spriteMan) {
			destroyWithChildren(this._spriteMan);
		}

		if (this._abilityList) {
			this._abilityList.length = 0;
			this._abilityList = null;
		}

		if (this._spriteDictionary) {
			this._spriteDictionary.length = 0;
			this._spriteDictionary = null;
		}

		if (this._unitDictionary) {
			this._unitDictionary.length = 0;
			this._unitDictionary = null;
		}

		if (this._fightData) {
			destroy(this._fightData);
			this._fightData = null;
		}

		if (this._farmData) {
			destroy(this._farmData);
			this._farmData = null;
		}

		if (this._particles) {
			this._particles.length = 0;
			this._particles = null;
		}

		if (this._skeletonDictionary) {
			this._skeletonDictionary.length = 0;
			this._skeletonDictionary = null;
		}

		this._frameOffset = null; // CGPoint
		this._lastFramePosition = null; // CGPoint
		this._destinationPoint = null; // CGPoint to avoid cycles
		this._color = null; // ccColor3B
		this._savedColor = null; // ccColor3B
		this._collisionBoxSize = null; // CGSize
		this._collisionBoxOffset = null; // CGPoint

		if (this._stunRotateLayer) {
			destroyWithChildren(this._stunRotate);
			this._stunRotate = null;
		}

		if (this._stunSprite) {
			destroyWithChildren(this._stunSprite);
			this._stunSprite = null;
		}

		this._stunTrail = null;

//		if (this._doppleganger) {
//			destroyWithChildren(this._doppleganger);
//			this._doppleganger = null;
//		}
	},

	copyActorData : function(target, zone) {
		if(!this._color){
			this._color = ccc3(0, 0, 0);
		}
		if(!this._savedColor){
			this._savedColor = ccc3(0, 0, 0);
		}
		target._color = new Core.Color(this._color._red, this._color._green, this._color._blue);
		target._savedColor = new Core.Color(this._savedColor._red, this._savedColor._green, this._savedColor._blue);
		target.setOnlyState(this._state);

		target._brainState = this._brainState;
		target._type = this._type;
		target._subType = this._subType;
		target._flags = this._flags;
		if(this._farmData){
			target._farmData = this._farmData.copyWithZone(zone);
		} else{
			var data = new ActorFarmData();
			data.copyWithZone(zone);
			target._farmData = data;
			this._farmData = data;
		}
		target._eatDate = this._eatDate;
		target._fights = this._fights;
		target.classname = this.classname;
	},
	
	initWithData : function(data) {
		this._color = new Core.Color(data._color.getRed(), data._color.getGreen(), data._color.getBlue());
		if (data._savedColor)
		{
			this._savedColor = new Core.Color(data._savedColor.getRed(), data._savedColor.getGreen(), data._savedColor.getBlue());
		}
		
		this.setOnlyState(data._state);
		this._brainState = data._brainState;
		this._type = data._type;
		this._subType = data._subType;
		this._flags = data._flags;
		this._farmData = new ActorFarmData();
		this._farmData.initWithData(data._farmData);
		this._eatDate = data._eatDate;
		this._fights = data._fights;
	},

	copyWithZone: function (/*NSZone **/ zone)
	{
		var copy = new this.constructor();
	    
	    this.copyActorData(copy,zone);

		return copy;
	},


	initActorSpecificData : function() {
		this._spriteDictionary = [];
		this._attachments = [];
		this._abilityList = [];
		this._particles = [];

		for ( var i = 0; i < kActorPartTagMax; i++) {
			this._attachments[i] = null;
		}

		this._state = kActorStateInvalid;
		this._brainState = kActorBrainStateNone;
		this._type = kActorTypeZombie;
		this._subType = zombieSubTypeNone;
		this._walkingSpeed = 1.0;
		this._animSpeed = 1.0;

		this._destinationPoint = new Core.Point(0, 0);
		this._lastFramePosition = new Core.Point(0, 0);
		this._frameOffset = new Core.Point(0, 0);
		this._unitDictionary = null;
		this._farmData = null;

		// #ifndef ZF_SAVE_ED
		this._fightData = null;
		this.setColor(this.colorFromSubType(this._subType));
		// #endif // ZF_SAVE_ED

		this._spriteFileName = '';
		this._skeletonDictionary = [];
		this._spriteFrameFile = '';
		this._eatDate = Core.Time.getRealTime() / 1000;
		this._collisionBoxSize = new Core.Size(32, 32);
		this._collisionBoxOffset = new Core.Point(0, 0);

		this._hunger = 0.0;
		this._fights = 0.0;

		this._stunSprite = null;
		this._stunTrail = null;
		this._stunRotateLayer = null;
		this._collisionEnabled = true;
	},

	setOnlyState : function(value) // int
	{
		if (this._state != value) {
			this._state = value;
		}
	},

	setUnitDictionaryWithSubType : function() {
		// Meant to be overriden
	},

	setUnitDictionaryWithUnitKey : function(unitKey) {
		// Meant to be overriden
	},

	encodeWithCoder : function(coder) // NSCoder
	{
		// TODO : convert
		// [coder encodeInt:state forKey:@"state"];
		// [coder encodeInt:brainState forKey:@"brainState"];
		// [coder encodeInt:type forKey:@"type"];
		// [coder encodeInt:subType forKey:@"subType"];
		// [coder encodeInt:flags forKey:@"flags"];
		// //[coder encodeObject:unitKey forKey:@"unitKey"];
		// [coder encodeObject:farmData forKey:@"farmData"];
		// [coder encodeObject:eatDate forKey:@"eatDate"];
		// [coder encodeInt:fights forKey:@"fights1"];
		// [coder encodeInt:(int)color.r forKey:@"colorR"];
		// [coder encodeInt:(int)color.g forKey:@"colorG"];
		// [coder encodeInt:(int)color.b forKey:@"colorB"];
	},

	encodeWithCoder : function(coder) // NSCoder
	{
		// TODO : convert
		// [coder encodeInt:state forKey:@"state"];
		// [coder encodeInt:brainState forKey:@"brainState"];
		// [coder encodeInt:type forKey:@"type"];
		// [coder encodeInt:subType forKey:@"subType"];
		// [coder encodeInt:flags forKey:@"flags"];
		// //[coder encodeObject:unitKey forKey:@"unitKey"];
		// [coder encodeObject:farmData forKey:@"farmData"];
		// [coder encodeObject:eatDate forKey:@"eatDate"];
		// [coder encodeInt:fights forKey:@"fights1"];
		// [coder encodeInt:(int)color.r forKey:@"colorR"];
		// [coder encodeInt:(int)color.g forKey:@"colorG"];
		// [coder encodeInt:(int)color.b forKey:@"colorB"];
	},

	// changed to init from saved data
	initWithCoder : function(coder) {
		this._color = new Core.Color(coder._color._red, coder._color._green, coder._color._blue);
		this._savedColor = new Core.Color(coder._color._red, coder._color._green, coder._color._blue);
		//
		this._state = coder._state;
		this._brainState = coder._brainState;
		this._type = coder._type;
		this._subType = coder._subType;
		this._flags = coder._flags;
		// //unitKey = [coder decodeObjectForKey:@"unitKey"];
		this._farmData = new ActorFarmData();
		this._farmData.initWithCoder(coder._farmData);
		this._eatDate = coder._eatDate;
		this._fights = coder._fights;
	},

	initActorSpecificDataAfterLoad : function() {
		this.initActorSpecificAbilities();
		// meant to be overridden
	},

	initFightDataAfterLoad : function() {
		// meant to be overridden
	},

	update : function(dt) // ccTime
	{
//		console.log("---------------FightUpdate: "+this.classname);	
		this.updateHunger();
		
		if (this._fightData && this._fightData._damageTimer > 0.0) {
			this._fightData._damageTimer -= dt;
			this._fightData._damageTimer = this._fightData._damageTimer < 0.0 ? 0.0 : this._fightData._damageTimer;
		}
		this.movementUpdate(dt);
	},

	updateHunger : function(dt) // ccTime
	{
		var gs = GameState;

		if (this._eatDate) {
			var timeSinceNow = Core.Time.getRealTime() / 1000 - this._eatDate;
			var zombieHungerDuration = ZFGameDefines.ZOMBIE_HUNGER_DURATION;

			if (gs._zfGameData._headID == 8 || gs._zfGameData._headID == 9) {
				zombieHungerDuration *= 0.75; // down from 8 hours to 6 hour
												// hunger
			}
			this._hunger = Math.abs((timeSinceNow / zombieHungerDuration));
			this._hunger = (!(gs._zfGameData._gflags & ZFGameFlags.GFLAG_FIGHT_TUTORIAL)) ? 0 : this._hunger;
			this._hunger = (this._hunger > 1) ? 1 : this._hunger;
		}	
	},
	
	movementUpdate : function(dt) {

		if (this._farmData && this instanceof ZombieActor && ZFMarketMenu.theMarket()._menuState != ZFMenu.menuStates.menuStateClosed) {
			// if (WINDOW_WIDTH == ORIGINAL_WINDOW_WIDTH)
			return; // no updates when market is open for zombies on farm (only
					// in iPod version)
		}

//		console.log("exceptionnnnnnnnn: "+this.classname);
//		if(this._spriteMan.getScale())
			var deltaScale = this._lastScale - this._spriteMan.getScale()._x;
//		var deltaPosition = 0;
//		if(this._destinationPoint)
//			deltaPosition = this._destinationPoint._x - this._ccPosition._x;
//		var deltaPosition2 = this._actorLastPosition - this._ccPosition._x;
		this._lastScale = this._spriteMan.getScale()._x;
//		this._actorLastPosition = this._ccPosition._x;
		
		if(this._fightData && this instanceof ZombieActor && this.isInMeleeRange() && !this._dying && deltaScale == 0){
//		if(deltaPosition == 0 && deltaScale == 0 && deltaPosition2 == 0){
			if(this._rotated != this._flipUpdate){
				for ( var key in this._attachments ) {
					var a = this._attachments[key];
	
					if (!a) {
						continue;
					}
					a._updated = false;
	
					// this should be here, don't remove
					this.updateAttachment(a);
				}
				this._flipUpdate = this._rotated;
			}
			else 
				if(this._flags & kMutationArms){
					var a = this._attachments[kActorPartTagArmFm];
					if (a) {
						a._updated = false;
						this.updateAttachment(a);
					}
				}
			if(!this._firstTimeFighting){		
				this.barUpdate(true);
			}
			return;
			
		}
		
		var fpsComp = dt * 60.0;
		this._lastFramePosition = this._ccPosition;

		// Process knockback, commonly from AOE
		// moves zombie back by knockback amount (caused rubber banding effect
		// when death isn't processed correctly)
		// e.g. zombie is killed and has a knockback point set ... so zombie is
		// moving back while death effect runs at
		// original location

		var fightdata = this._fightData;
		if (fightdata && fightdata._knockBackPoint && !(fightdata._knockBackPoint._x == 0.0 && fightdata._knockBackPoint._y == 0.0)) {
			
			var xx = fightdata._knockBackPoint._x - this._ccPosition._x;
			var yy = fightdata._knockBackPoint._y - this._ccPosition._y;
			var distanceLeftDelta = {_x:xx,_y:yy}
			
			var distanceLeftDeltalength = Math.sqrt( ( distanceLeftDelta._x * distanceLeftDelta._x ) + ( distanceLeftDelta._y * distanceLeftDelta._y ) );
			var distanceLeftDeltaInv = 1 / distanceLeftDeltalength;
			var dlfNormaliced = {_x : distanceLeftDelta._x * distanceLeftDeltaInv, _y : distanceLeftDelta._y * distanceLeftDeltaInv };
			
			xx = dlfNormaliced._x * fightdata._knockBackSpeed * fpsComp;
			yy = dlfNormaliced._y * fightdata._knockBackSpeed * fpsComp;
			var newPositionDelta = {_x:xx,_y:yy};
			var npdLength = Math.sqrt( ( newPositionDelta._x * newPositionDelta._x ) + ( newPositionDelta._y * newPositionDelta._y ));
			
			if (npdLength >= distanceLeftDeltalength) {
				this.setPosition(fightdata._knockBackPoint);
				fightdata._knockBackPoint = CGPointMake(0, 0);
			} else {
				this.setPosition({_x: this._ccPosition._x + newPositionDelta._x, _y: this._ccPosition._y + newPositionDelta._y});
			}
		}

		// if ACTOR is not where he's supposed to be yet then move him (unless
		// stunned)
		if (this._destinationPoint && (this._ccPosition._x != this._destinationPoint._x || this._ccPosition._y != this._destinationPoint._y)
				&& this._state != kActorFightStateStunned) {

			var lastTile = this._farmData ? this._farmData._currentTile : ccpF(0,0);
			
			var xx = this._destinationPoint._x - this._ccPosition._x;
			var yy = this._destinationPoint._y - this._ccPosition._y;
			var distanceLeftDelta = {_x:xx,_y:yy}
			
			var distanceLeftDeltalength = Math.sqrt( ( distanceLeftDelta._x * distanceLeftDelta._x ) + ( distanceLeftDelta._y * distanceLeftDelta._y ) );
			var distanceLeftDeltaInv = 1 / distanceLeftDeltalength;
			var dlfNormaliced = {_x : distanceLeftDelta._x * distanceLeftDeltaInv, _y : distanceLeftDelta._y * distanceLeftDeltaInv };
			
			xx = dlfNormaliced._x * this._walkingSpeed * fpsComp;
			yy = dlfNormaliced._y * this._walkingSpeed * fpsComp;
			var newPositionDelta = {_x:xx,_y:yy};
			var npdLength = Math.sqrt( ( newPositionDelta._x * newPositionDelta._x ) + ( newPositionDelta._y * newPositionDelta._y ));

			if (npdLength >= distanceLeftDeltalength) {
				this.setPosition(this._destinationPoint);

				if (this._farmData) {
					this._farmData.currentTile = this._farmData._destinationTile;
					this.setState(kActorStateIdle);
				}
			} else {
				ccpAddF(newPositionDelta, this._ccPosition);
				this.setPosition(newPositionDelta);

				if (this._farmData) {
					this._farmData._currentTile = ZFTileManager.tileFromMapPoint(this._ccPosition);
					this.setState(kActorStateWalking);
				}
			}

			if (this._farmData && (this._farmData._currentTile._x != lastTile._x || this._farmData._currentTile._y != lastTile._y)) {
				var x = this._farmData._currentTile._x;
				var y = this._farmData._currentTile._y;
				var newZ = y + x + 1;
				this._spriteMan.setDepth(newZ);
			}
		}

		// set the new position for the attachments
		for ( var key in this._attachments ) {
			var a = this._attachments[key];

			if (!a) {
				continue;
			}
			a._updated = false;

			// this should be here, don't remove
			this.updateAttachment(a);
		}

		// if fighting and zombie is moving ... adjust head position and life
		// bars
		this.barUpdate();
		this._firstTimeFighting = false;
	},

	barUpdate : function(stopped){
		
		var fightdata = this._fightData;
		if (fightdata && fightdata._lifeBar && fightdata._lifeBar._opacity > 0) {
			
			if(stopped)
				this._firstTimeFighting = true;
			
			var pos;
			if (this instanceof ZombieActor) {
				pos = this.getHeadPosition();
				pos._y += 110;
				pos._x -= 90;
			} else {
				var a = this._attachments[kActorPartTagHead];
				if (!a) {
					a = this._attachments[kActorPartTagBody];
				}

				var headPosX = a._ccPosition._x * a._sprite._flipX ? -1 : 1;
				var headPosY = a._lastFramePosition._y*this._spriteMan._totoScale._y;
				
				headPosY = (headPosY > 95) ? 95 : headPosY;
				if (this instanceof RobotStageActorBrainBot) {
					headPosY = 105;
				} else if (this instanceof RobotStageActorBroBot) {
					headPosY = 120;
				}
				pos = {_x:headPosX, _y:headPosY + 140};
				pos._x += (this._ccPosition._x + fightdata._lifeBarOffset._x);
				pos._y += (this._ccPosition._y + fightdata._lifeBarOffset._y);
			}

			fightdata._lifeBar.setPosition(pos);
			pos = {_x:-0.8 * this._widthScale, _y: -0.3 * this._heightScale};
			pos._x += fightdata._lifeBar._ccPosition._x;
			pos._y += fightdata._lifeBar._ccPosition._y;
			fightdata._lifeBG.setPosition(pos);
			fightdata._lifeBarTemp.setPosition(fightdata._lifeBar._ccPosition);
		}
	},
	guiAddToParent : function() {
		try {
			if (this._futureParent) {
				this._futureParent.addChild(this);
				this._futureParent.addChild(this._spriteMan, 11);
			}
		} catch (e) {
		}

		this.unschedule(this.guiAddToParent);
	},

	guiActorUpdate : function(dt) // ccTime
	{
		// set the new position for the attachments

		if (this._attachments) {
			for ( var key in this._attachments) {
				var a = this._attachments[key];

				if (!a) {
					continue;
				}

				a._updated = false;
				
				this.updateAttachment(a);
			}
		}

		this.unschedule(this.guiActorUpdate);
	},

	updateAttachment : function(a) // ActorAttachment
	{
		if (!a || a._updated) {
			return;
		}
	
		var bonePos = a.calculateBonePosition();
		
		var localOffset = {_x:bonePos._x, _y:bonePos._y}; // CGPoint
		
		var asprite = a._sprite;

		var boneRotation = a.calculateRotateValue(); // Float

		if (boneRotation != 0.0) {
			asprite.setRotation(a._originalRotation + boneRotation);
		}

		if (asprite._flipX) {
			localOffset._x = -localOffset._x;
		}

		// Take the actor's position.
		asprite.setPosition(this._ccPosition);
		// OLD Code for moving.
		if (a._parentAttachment == null) {
			if (a._tag == kActorPartTagArmFm) {
				var b = this._attachments[kActorPartTagArmF];
				asprite.setRotation(b._sprite._rotation);			
//				a.setRotation(b._rotation);
				asprite.setPosition(b._sprite._ccPosition);
//				a.setPosition(b._ccPosition);
				if(this instanceof ZombieActor){
					var bb = this._attachments[kActorPartTagArmB];
					var bbsprite = bb._sprite;
					bbsprite.setRotation(b._sprite._rotation);
					bbsprite.setPosition(b._sprite._ccPosition);
				}
			} else if (a._tag == kActorPartTagArmBm) {
				var b = this._attachments[kActorPartTagArmB];
				asprite.setRotation(b._sprite._rotation);
//				a.setRotation(b._rotation);
				asprite.setPosition(b._sprite._ccPosition);
//				a.setPosition(b._ccPosition);
			} else if (a._tag > kActorPartTagHeadParts && a._tag < kActorPartTagHeadPartsMAX) {
				// Offset with respect to the head position.
				// console.log( "head parts");
				var b = this._attachments[kActorPartTagHead];

				var pos = b._sprite._ccPosition;

				var add = {_x: a._offsetFromRefPoint._x + localOffset._x, _y:a._offsetFromRefPoint._y + localOffset._y}; 
				var scl = Math.abs(b._sprite._totoScale._x);
				add._x *= scl;
				add._y *= scl;
				add._x += pos._x;
				add._y += pos._y;
				asprite.setPosition(add);

				var angle = 0;

				if (asprite._flipX) {
					angle = degreesToRadian(-b._sprite._rotation); // Float
				} else {
					angle = degreesToRadian(+b._sprite._rotation); // Float
				}

				add._x = asprite._ccPosition._x - b._sprite._ccPosition._x;
				add._y = asprite._ccPosition._y - b._sprite._ccPosition._y;

				var cosAngle = Math.cos(angle);
				var sinAngle = Math.sin(angle);
				add._x = add._x * cosAngle + add._y * sinAngle;
				add._y = add._y * cosAngle - add._x * sinAngle;

				asprite.setPosition({_x: add._x + b._sprite._ccPosition._x, _y: add._y + b._sprite._ccPosition._y});
				asprite.setRotation(b._sprite._rotation);
			} else {
				localOffset = {_x: localOffset._x * this._spriteMan._totoScale._x, _y: localOffset._y * this._spriteMan._totoScale._y};

				// Move by its natural offset.
				var naturalOffset = ccpF(a._offsetFromRefPoint._x * this._spriteMan._totoScale._x, a._offsetFromRefPoint._y
						* this._spriteMan._totoScale._y);
				ccpAddF(naturalOffset, a._sprite._ccPosition);
				a._sprite.setPosition(naturalOffset);

				// Move by local offset if any.
				ccpAddF(localOffset, a._sprite._ccPosition);
				a._sprite.setPosition(localOffset);
				var b = 1.0 / this._spriteMan._totoScale._x;
				a._sprite.setPosition(a._sprite._ccPosition._x * b, a._sprite._ccPosition._y * b);
			}
		} else {
			// New code for moving.
			localOffset = {_x: localOffset._x * this._spriteMan._totoScale._x, _y: localOffset._y * this._spriteMan._totoScale._y};

			// Move by its natural offset.
			var naturalOffset = {_x: a._offsetFromRefPoint._x * this._spriteMan._totoScale._x, _y: a._offsetFromRefPoint._y * this._spriteMan._totoScale._y};
			naturalOffset._x += asprite._ccPosition._x;
			naturalOffset._y += asprite._ccPosition._y;
			asprite.setPosition(naturalOffset);

			// Move by local offset if any.
			localOffset._x += asprite._ccPosition._x;
			localOffset._y += asprite._ccPosition._y;
			asprite.setPosition(localOffset);
			var b = 1.0 / this._spriteMan._totoScale._x;
			asprite.setPosition(asprite._ccPosition._x * b, asprite._ccPosition._y * b);
			// end part of old code. //
		}

		a._lastFramePosition = asprite._ccPosition;

		var angle = asprite._rotation - a._lastFrameRotation;
		if (angle > 0.01 || angle < -0.01) {
			if (a._childAttachments) {
				for (var key in a._childAttachments) // ActorAttachment*
				{
					var bone = a._childAttachments[key];
					bone.rotateBone(angle, a._offsetFromRefPoint, 0);
				}
			}
		}

		a._lastFrameRotation = asprite._rotation;
		a._updated = true;

		// Check if there are any particles in the particle array that should be
		// added to the attachment.
// for (p in a._particles)
// {
// TODO : Uncomment and convert when doing the particles.
// if (a.tag == p.attachmentID )
// {
// if(!p.particle.parent)
// {
// // used to have a tag here til i realized it wasn't necessary ==> just search
// the array
// [spriteMan.parent addChild:p.particle z:spriteMan.zOrder];
// }
// else if(spriteMan.zOrder != p.particle.zOrder)
// {
// [p.particle retain];
// [spriteMan.parent removeChild: p.particle cleanup:NO];
// [spriteMan.parent addChild: p.particle z:spriteMan.zOrder];
// [p.particle release];
// }
//							
// p.particle.position = ccpMult(a.sprite.position, spriteMan.scale);
// p.particle.anchorPoint = a.sprite.anchorPoint;
//							
// if(p.attachmentID == kActorPartTagHead)
// {
// p.particle.position = ccpAdd(p.particle.position, ccpMult(ccp(([a.sprite
// flipX] ? -1 : 1) * -5,8), spriteMan.scale));
// }
//							
// if(p.attachmentID == kActorPartTagJaw)
// {
// p.particle.position = ccpAdd(p.particle.position, ccpMult(ccp(([a.sprite
// flipX] ? -1 : 1) * -18,-10), spriteMan.scale));
// }
//							
// if (p.attachmentID == kActorPartTagEyeL || p.attachmentID ==
// kActorPartTagEyeR)
// {
// a.sprite.visible = NO;
// }
//							
// CGPoint particleOffset = p.offset;
//							
// if([a.sprite flipX])
// particleOffset = ccp(p.offset.x * - 1, p.offset.y);
//							
// p.particle.position = ccpAdd(p.particle.position, particleOffset);
// }
// }
	},

	setAttackVariation : function() {
		var fm = ZFFightMan;
		var attacks = this._unitDictionary["attacks"];
		var attack = GameState.rollAgainstFrequencyInArray(attacks);
		this._fightData._currentAttackVariation = fm._allAttacks[attack["name"]];
	},

	getAttackVariationByTag : function(tag) // int
	{
		var fm = ZFFightMan;
		var attack = null; // NSDictionary
		switch (tag) {
		case ZFAttackAnims.kAttackTypes.kAttackTypeExplode: {
			attack = fm._allAttacks["ZombieExplode"];
		}
			break;
		case ZFAttackAnims.kAttackTypes.kAttackTypeExplodeV2: {
			attack = fm._allAttacks["ZombieExplodeV2"];
		}
			break;
		}
		return attack; // NSDictionary
	},
	//
	getFightAttackSpeed : function() {
		var asc = 1.0;
		if (this._fightData && this._fightData._currentAttackVariation) {
			// xxx
			if (this instanceof PirateStageActorScallywag && this._fightData._opponent && this._fightData._opponent._fightData) {
				this._fightData._finalAttackSpeed = (this._fightData._opponent._fightData._finalAttackSpeed*1.25)
						* this._fightData._opponent._fightData._finalAttackSpeed;
				this._fightData._finalAttackSpeed = (this._fightData._finalAttackSpeed < 0.5) ? 0.5 : this._fightData._finalAttackSpeed;
			}

			var temp = this._fightData._currentAttackVariation.speedMultiplier;
			var attackModifier = temp ? temp : 1;
			asc = this._fightData._finalAttackSpeed * attackModifier;

			if (this instanceof ZombieActor) {
				var fm = ZFFightMan;
				var column = Math.floor(fm._zombies.indexOf(this) *0.2);

				if (this._state != kActorFightStateFightingBossWall && this._state != kActorFightStateFightWall)

					switch (column) {
					case 0:
						break; // no change
					case 1:
						asc *= 1.425;
						break; // doing 70% dps
					case 2:
						asc *= 2.0;
						break; // doing 50% dps
					default:
						asc *= 4.0;
						break; // doing 25% dps
					}

			}

			// ol mc'donnel normal and hard mode
			var gs = GameState;
			if (gs._zfGameData._currentEnemy == 0 && !(this instanceof ZombieActor)) {
				if (gs._zfGameData._level >= ZFGameDefines.TIER2LVL) {
					asc *= .44;
				} else if (gs._zfGameData._level >= ZFGameDefines.TIER1LVL) {
					asc *= .66;
				}
			}
		}

		return asc;
	},

	fightAttack : function(dt) // ccTime
	{
		this.unschedule(this.fightAttack);
		var state = this._state;
		if (((state != kActorFightStateFighting && state != kActorFightStateFight && 
				state != kActorFightStateFightingBossWall && state != kActorFightStateFightWall) || !this._fightData._opponent)
				&& !this._fightData._specialAttack) {
			return;
		}

		if (this._fightData && this._fightData._specialAttack) {
			this._fightData._currentAttackVariation = this._fightData._specialAttack;
			this._fightData._specialAttack = null;
		}

		var asc = this.getFightAttackSpeed();

		var cantInterrupt = this._fightData._currentAttackVariation.cantInterrupt;

		this._fightData._canInterrupt = !cantInterrupt;

		var temp = this._fightData._currentAttackVariation.damageTiming;
		var damageTiming = temp ? temp : 1.0;
		this.schedule(this.damageIn, asc * damageTiming, "damageIn");

		temp = this._fightData._currentAttackVariation.sfxTiming;
		var sfxTiming = temp ? temp : 1.0;
		this.schedule(this.attackSFXIn, asc * sfxTiming, "attackSFXIn");

		if(this._fightData && this._fightData._opponent){
			if (this._fightData._opponent._ccPosition._x > this._ccPosition._x)
				this.flipActor(true);
			else
				this.flipActor(false);
		}
//		else
//			this.flipActor(true);
		

		this.startAnim(kActorAnimAttack, true);
	},

	fightAttackWall : function(dt) // ccTime
	{
		this.unschedule(this.fightAttackWall);
		var asc = this.getFightAttackSpeed();

		var temp = this._fightData._currentAttackVariation["damageTiming"];
		var damageTiming = temp ? temp : 1.0;
		this.schedule(this.damageWallIn, asc * damageTiming, "damageWallIn");

		temp = this._fightData._currentAttackVariation["sfxTiming"];
		var sfxTiming = temp ? temp : 1.0;
		this.schedule(this.attackSFXIn, asc * sfxTiming, "attackSFXIn");

		this.startAnim(kActorAnimAttack, true);
	},

	attackSFXIn : function(dt) // ccTime
	{
		this.unschedule(this.attackSFXIn);

		var sae = SimpleAudioEngine;
		var sfxID = this._fightData._currentAttackVariation["sfxID"];
		if (sfxID) {
			sae.playEffect("./Content/" + sfxID);
		}
	},

	damageIn : function(dt) {
		this.unschedule(this.damageIn);

		var temp = this._fightData._currentAttackVariation["damageMultiplier"];
		var damageMultiplier = temp ? temp : 1.0;
//		console.log("MULTIPLIER: "+damageMultiplier);
		var damage = this._fightData._finalPower * damageMultiplier;
		var knockBack = this._fightData._currentAttackVariation["knockBack"];
		var stun = this._fightData._currentAttackVariation["stun"];
		var hitBoss = this._fightData._currentAttackVariation["hitBoss"];
//		var particleSystem = this._fightData._currentAttackVariation["particleSystemOnStrike"];
		var soundEffect = this._fightData._currentAttackVariation["soundEffectOnStrike"];
		var stunTimer = this._fightData._currentAttackVariation["stunTimer"];

		var fm = ZFFightMan;

		if (this instanceof ZombieActor && this._state != kActorFightStateFightingBossWall && this._state != kActorFightStateFightBossWall) {
			var column = Math.floor(fm._zombies.indexOf(this) / 5);
			switch (column) {
			case 0:
				break;
			case 1:
				damage *= 0.85;
				break;
			case 2:
				damage *= 0.7;
				break;
			default:
				damage *= 0.55;
				break;
			}
		}

		if (this._fightData && (!this._fightData._opponent || !this._fightData._opponent._fightData || this._fightData._opponent._fightData._hitPoints <= 0)) {
			// enemy finding algorithm
			if (this instanceof CivilianActorFight && fm._zombies.lentgh > 0) {
				var target = null;
				for ( var key in fm._zombies) {
					var z = fm._zombies[key];
					if (Math.floor(fm._zombies.indexOf(z) / 5) > 0)
						break;

					if (z.isInMeleeRange()) {
						if (!target)
							target = z;
						else {
							if (z._priority > target._priority)
								target = z;

						}
					}
				}
				this._fightData._opponent = target;
			} else if (this instanceof ZombieActor) {
				if (fm._enemy && fm._enemy.isInMeleeRange())
					this._fightData._opponent = fm._enemy;
			}
		}

		if (this._fightData && this._fightData._opponent && this._fightData._opponent._fightData && this._fightData._opponent._fightData._hitPoints > 0) {
			if (soundEffect) {
				var sae = SimpleAudioEngine;
				sae.playEffect("./Content/"+soundEffect);
			}
			// TODO: Particles Required
			// if(particleSystem)
			// {
			// CCQuadParticleSystem *emitter = [ZFParticleEffects
			// particleSystemByTag:particleSystem];
			// emitter.position = fightData.opponent.position;
			// emitter.position = ccpAdd(emitter.position, ccp(0,50));
			// [fm.parent addChild:emitter z:199]; // adds it just behind the
			// life bars
			// }

			if (this._fightData._opponent._fightData._canInterrupt && !this._fightData._opponent._fightData._invincible) {
				if (stun) {
					this._fightData._opponent.stunSelfFor(stunTimer);
				}
				if (knockBack) {
					this._fightData._opponent.knockBackBy(-50 + (-100 * Math.random()), 5);
				}
			}

			this._fightData._opponent.damage(damage);

		}

		var aoe = this._fightData._currentAttackVariation["zombieAOE"];
		if (aoe > 0) {
			if (this._state != kActorFightStateFightingBossWall && this._state != kActorFightStateFightWall) {
				for ( var key in fm._enemySlots) {
					var c = fm._enemySlots[key];
					if (c == null)
						continue;
					if (c._fightData._hitPoints > 0) {
						c.damage(damage * aoe);

						// if it can stun the boss it can stun in an aoe
						if (stun && hitBoss) {
							c.stunSelfFor(stunTimer);
						}
					}
				}
			}
		}

		if (this._fightData && this._hitBoss && fm._boss && fm._boss._fightData._hitPoints > 0) {
			if (fm._boss != this._fightData._opponent && fm._boss._state != kActorFightStateGoing && fm.boss._state != kActorFightStateBossGoingDown) {
				damage = damage / 10;
				damage = (damage >= fm._boss._fightData._hitPoints) ? fm._boss._fightData._hitPoints - 20 : damage;

				fm._boss.damage(damage);

				if (stun && fm._boss._fightData._canInterrupt) {
					fm._boss.stunSelfFor(stunTimer);
				}
			}
		}

		// clear target
		if (knockBack)
			this._fightData._opponent = null;
	},

	damageWallIn : function(dt) {
		this.unschedule(this.damageWallIn);

		var fm = ZFFightMan;

		if (this._state == kActorFightStateFightWall && fm._wall) {
			var temp = this._fightData._currentAttackVariation["damageMultiplier"];
			var damageMultiplier = temp ? temp : 1.0;
			fm._wall.damage(this._fightData._finalPower * damageMultiplier);
		}
	},

	doneAttacking : function(dt) {
		this.unschedule(this.doneAttacking);
		this._fightData._attacking = false;
		this._fightData._canInterrupt = true;
	},

	talk : function() {

	},

	setZombieToLastIndex : function() {
		var fm = ZFFightMan;

		fm._zombies.splice((fm._zombies).indexOf(this), 1);

		var indexToInsertAt = 0;
		for ( var key in fm._zombies) {
			var z = fm._zombies[key];
			if (z._state == kActorFightStateWait || z._state == kActorFightStatePrepCycle || z._state == kActorFightStatePrepStart)
				break;
			indexToInsertAt++;
		}
		fm._zombies.splice(indexToInsertAt, 0, this);
	},

	// knock back sets state to fightState going
	knockBackBy : function(distance, force) // float float
	{
		distance *= 2.2;
		force *= 1.5;
		if (this instanceof ZombieActor) {
			var fm = ZFFightMan;

			this.setZombieToLastIndex();

			this.startAnim(kActorAnimKnockBack, true);

			this.unschedule(this.damageIn);
			this.unschedule(this.fightAttack);
			this.unschedule(this.attackSFXIn);

			if (this.isInMeleeRange()) {
				// to ensure it doesnt get placed back into combat we subtract 1
				// so destination != position
				this.setPosition(ccpAdd(this._ccPosition, ccp(-1, 0)));
				if (this._state != kActorFightStateStunned)
					this._state = kActorFightStateGoing;
				else
					this.startAnim(kActorAnimIdea, false);
			}

			fm.reorderZombies();
		}

		this._fightData._knockBackPoint = ccpAdd(this._ccPosition, ccp(distance, 0));
		this._fightData._knockBackSpeed = force;
	},

	colorFromSubType : function(actorSubType) // int
	{
		return ccc3(0xFF, 0xFF, 0xFF);
	},

	setState : function(value) // int
	{
		if (this._state == value) {
			return;
		}

		if (this._state == kActorFightStateStunned) {
			// assuming every necessary check is made here
			this.cleanupStunEffect();
		}

		this.cleanupAnimForState(this._state);
		
		this.startAnimForState(value);
		
		this._state = value;
	},

	callSetPosition : function(sender, value) {
		this.setPosition(value);
	},

	callSetState : function(sender, value) {
		this.setState(value);
	},

	animForState : function(value) // int
	{
		return 0;
	},

	startAnimForState : function(value) // int
	{
		// meant to be overwridden
	},

	startAnim : function(animID, interrupt) // int, bool
	{
		// meant to be overwridden
	},

	callStartAnim : function(sender, animID) {
		this.startAnim(animID, true);
	},

	cleanupAnimForState : function(value) {
		// meant to be overwridden
	},

	cleanupAnim : function(animID) {
		// meant to be overwridden
	},

	moveToPoint : function(point, flip, forceNoAnimation) // CGPoint, BOOL
	{
//		var ini = Core.Time.getRealTime();
		this._destinationPoint = point;
		if (typeof flip == "undefined")
			flip = true;
		
		if ( !flip ){
			return;
		}
		if (this._destinationPoint._x > this._ccPosition._x) // moving to the
																// right
		{
			this.flipActor(true, forceNoAnimation);
		} else if (this._destinationPoint._x < this._ccPosition._x) // moving to
																	// the left
		{
			this.flipActor(false, forceNoAnimation);
		}
//		console.log("moveToPoint kActorFightStateGo with state " + (Core.Time.getRealTime() - ini) );
	},

	moveToTile : function(tileCoordinates) // CGPoint
	{
		// NSAssert(farmData, @"farmData missing");

		if (!ccpEqual(this._farmData._currentTile, tileCoordinates)) {
			var destPos = ccpAdd(ZFTileManager.mapPointFromTile(tileCoordinates), ccp(24, 12));
			var facingRight = this._spriteMan._children[0].getFlipX();

			if ((destPos._x > this._ccPosition._x && !facingRight) || (destPos._x < this._ccPosition._x && facingRight)) {
				this.flipActor(!facingRight);
			}

			this._farmData._destinationTile = tileCoordinates.clone();
			this._destinationPoint = destPos.clone();
			return true;
		}

		return false;
	},

	flipActor : function(faceRight, forceNoAnimation) // BOOL
	{
		if(this._rotated == faceRight)
			return;
		
		this._rotated = faceRight;
		
		for ( var key in this._attachments) {
			var a = this._attachments[key];

			if (!a || a == null) {
				continue;
			}

			if (a._sprite.setFlipX(faceRight)) {
				a._offsetFromRefPoint = new Core.Vector(-a._offsetFromRefPoint._x, a._offsetFromRefPoint._y);
				
				if( a._childAttachments || a._parentAttachment ) {
						a._lastFrameRotation = 180 -  a._sprite._rotation;
						a._originalRotation = 180 - a._originalRotation;
//						a.setRotation( 180 + a._rotation );
//						a._sprite.setRotation( a._rotation );
				}
//				if (faceRight) {
					// a._sprite._anchorPoint = ccp( 1.0 - a._originalAnchor._x
					// , a._originalAnchor._y );
//				} else {
					// a._sprite._anchorPoint = ccp( a._originalAnchor._x ,
					// a._originalAnchor._y );
//				}
			}
			// if this is part of a bone system
//			if( a._childAttachments || a._parentAttachment ) {
//				if(faceRight){
//					a._lastFrameRotation = a._sprite._rotation;
//					a._originalRotation = - a._originalRotation;
//					a.setRotation( -a._rotation );
//					a._sprite.setRotation( a._rotation );
//				}
//			}
//			this.updateAttachment(a);
		}
		
		if(!forceNoAnimation)
		{
			this.startAnimForState(this._state);
		}
	},

	updateParticles : function() {
		for ( var p in this._particles) {
			for ( var key in this._attachments) {
				var a = this._attachments[key];

				if (a != null) {
					if (a._tag == p._attachmentID) {
						this.updateAttachment(a);
					}
				}
			}
		}
	},

	resetColor : function() {
		if (this._state != kActorFightStateUsingAbility) {
			for ( var key in this._attachments) {
				var a = this._attachments[key];
				if (!a) {
					continue;
				}

				if (a._inheritColor) {
					var tempColor = this.colorFromSubType(this._subType);

					if (this._fightData) {
						if (!(this._fightData._fightColor._red == 1 &&
						      this._fightData._fightColor._green == 1 &&
						      this._fightData._fightColor._blue == 1))
						{
							tempColor = this._fightData._fightColor;
						}
					}

					a._sprite.setColor(tempColor);
				} else {
					if (this instanceof ZombieActorLargeTier3 && (a._tag == kActorPartTagEyeL || a._tag == kActorPartTagEyeR)) {
						a._sprite.setColor(ccc3(0xFF, 0x00, 0x00));
					} else {
						a._sprite.setColor(ccc3(0xFF, 0xFF, 0xFF));
					}
				}
			}
		}
	},

	resetAttachmentPositionInterpolate : function(interpolate) // BOOL
	{
		for ( var key in this._attachments) {
			var a = this._attachments[key];

			if (!a || a == null) {
				continue;
			}

			if (interpolate) {
				a.runAction(CCMoveByWithoutChangingPosition.actionWithDuration(0.01, ccp(0, 0)));
			} else {
				a.setPosition(ccp(0, 0));
			}
		}
	},

	healBlink : function() {
		if (this._fightData && this._fightData._canInterrupt) {
			for ( var key in this._attachments) {
				var a = this._attachments[key];
				if (a == null)
					continue;

				if (a._inheritColor == false) {
					a._sprite.setColor(ccc3(0xFF, 0xFF, 0xFF));
					continue;
				}

				if ((a._tag == kActorPartTagEyeR || a._tag == kActorPartTagEyeL)
						|| ((a._tag == kActorPartTagArmF || a._tag == kActorPartTagArmB) && (this._flags & kMutationArms))
						|| ((a._tag == kActorPartTagHead) && (this._flags & kMutationHead))) {
					a._sprite.setColor(ccc3(0xFF, 0xFF, 0xFF));
					continue;
				}

				var sColor = this.colorFromSubType(this._subType);
				a._sprite.setColor(ccc3(0xFF, 0xFF, 0x00));
				var action1 = CCTintBy.actionWithDuration(0.05, sColor._red, sColor._green, sColor._blue);
				var action2 = CCCallFunc.actionWithTarget(this, this.resetColor.bind(this));
				a._sprite.runAction(CCSequence.actions(action1, action2));
			}
		}
	},

	damageBlink : function() {
		if (this._fightData && this._fightData._canInterrupt) {
			for ( var key in this._attachments) {
				var a = this._attachments[key];
				if (a == null)
					continue;

				if (a._inheritColor == false) {
					a._sprite.setColor(ccc3(0xFF, 0xFF, 0xFF));
					continue;
				}

				if ((a._tag == kActorPartTagEyeR || a._tag == kActorPartTagEyeL)
						|| ((a._tag == kActorPartTagArmF || a._tag == kActorPartTagArmB) && (this._flags & kMutationArms))
						|| ((a._tag == kActorPartTagHead) && (this._flags & kMutationHead))) {
					a._sprite.setColor(ccc3(0xFF, 0xFF, 0xFF));
					continue;
				}

				// sColor is == savedColor
				var sColor = this.colorFromSubType(this._subType);
				a._sprite.setColor(ccc3(0xFF, 0x00, 0x00));
				var action1 = CCTintBy.actionWithDuration(0.05, sColor._red, sColor._green, sColor._blue);
				var action2 = CCCallFunc.actionWithTarget(this, this.resetColor.bind(this));
				a._sprite.runAction(CCSequence.actions(action1, action2));
			}
		}
	},

	blinkWithColor : function(blinkColor) // ccColor3B
	{
		if (this._fightData && this._fightData._canInterrupt) {
			for ( var key in this._attachments) {
				var a = this._attachments[key];
				if (a == null)
					continue;

				if (a._inheritColor == false) {
					a._sprite.setColor(ccc3(0xFF, 0xFF, 0xFF));
					continue;
				}

				if ((a._tag == kActorPartTagEyeR || a._tag == kActorPartTagEyeL)
						|| ((a._tag == kActorPartTagArmF || a._tag == kActorPartTagArmB) && (this._flags & kMutationArms))
						|| ((a._tag == kActorPartTagHead) && (this._flags & kMutationHead))) {
					a._sprite.setColor(ccc3(0xFF, 0xFF, 0xFF));
					continue;
				}

				// sColor is == savedColor
				var sColor = this.colorFromSubType(this._subType);
				a._sprite.setColor(blinkColor);
				var action1 = CCTintBy.actionWithDuration(0.05, sColor._red, sColor._green, sColor._blue);
				var action2 = CCCallFunc.actionWithTarget(this, this.resetColor.bind(this));
				a._sprite.runAction(CCSequence.actions(action1, action2));
//				a._sprite.runAction(action1);
			}
		}
	},

	resetAttachmentPositionsInterpolate : function(interpolate) {
		for ( var key in this._attachments) {
			var a = this._attachments[key];
			if (!a)
				continue;

			if (interpolate) {
				a.runAction(CCMoveByWithoutChangingPosition.actionWithDuration(.01, ccp(0, 0)));
			} else {
				a.setPosition(0,0);
			}
		}
	},

	resetAttachmentScaleInterpolate : function(interpolate) {
		for ( var key in this._attachments) {
			var a = this._attachments[key];
			if (!a)
				continue;

			if (interpolate) {
				a._sprite.runAction(CCScaleTo.actionWithDuration(.01, a._totoScale._x));
			} else {
				a._sprite.setScale(a._totoScale._x, a._totoScale._y);
			}
		}
	},

	resetAttachmentRotationInterpolate : function(interpolate) {
		for ( var key in this._attachments) {
			var a = this._attachments[key];
			if (!a)
				continue;

			a.setRotation(a._originalRotation);
			if (interpolate) {
				a._sprite.runAction(CCRotateTo.actionWithDuration(0.1, a._originalRotation));
			} else {
				a._sprite.setRotation(a._originalRotation);
			}
		}
	},

	canBeDamaged : function() {
		if (!this._fightData) {
			return false;
		}
		if (this._fightData._invincible) {
			return false;
		}

		if (this._state == kActorFightStatePrepCycle || this._state == kActorFightStatePrepStart || this._state == kActorFightStateWait
				|| this._state == kActorFightStateDying || this._state == kActorFightStateDead) {
			return false;
		}

		return (this._fightData._hitPoints > 0.0 && this._fightData._damageTimer <= 0.0);

	},

	heal : function(amount) // float
	{
		if (this._state != kActorFightStateDying && this._state != kActorFightStateDead) {
			this._fightData._lifeBG.stopAllActions();
			this._fightData._lifeBar.stopAllActions();
			this._fightData._lifeBarTemp.stopAllActions();

			this._fightData._lifeBar
					.setScale(this._fightData._hitPoints / this._fightData._finalHitPointsTotal, this._fightData._lifeBar._totoScale._y);

			this._fightData._hitPoints += amount;

			this.healBlink();

			if (this._fightData._hitPoints > this._fightData._finalHitPointsTotal)
				this._fightData._hitPoints = this._fightData._finalHitPointsTotal;

			this._fightData._lifeBarTemp.setScale(this._fightData._hitPoints / this._fightData._finalHitPointsTotal, this._fightData._lifeBarTemp
					._totoScale._y);
			this._fightData._lifeBarTemp.setColor(ccc3(0x00, 0xff, 0x00));

			this._fightData._lifeBG.setOpacity(255);
			this._fightData._lifeBar.setOpacity(255);
			this._fightData._lifeBarTemp.setOpacity(255);

			var showLifeBarDelay = 0.5;

			if (this._fightData._opponent && this._fightData._opponent._fightData && this._fightData._opponent._fightData._opponent == this) {
				showLifeBarDelay = 5.0;
			}

			var actionTo = CCSequence.actions([ CCDelayTime.actionWithDuration(showLifeBarDelay), CCFadeOut.actionWithDuration(0.25), null ]);
			this._fightData._lifeBG.runAction(actionTo);
			actionTo = CCSequence.actions([ CCDelayTime.actionWithDuration(showLifeBarDelay), CCFadeOut.actionWithDuration(0.25), null ]);
			this._fightData._lifeBarTemp.runAction(actionTo);

			actionTo = CCSequence.actions([ CCDelayTime.actionWithDuration(showLifeBarDelay), CCFadeOut.actionWithDuration(0.25), null ]);
			var actionToTwo = CCScaleTo.actionWithDuration(0.5, this._fightData._lifeBarTemp._totoScale._x, this._fightData._lifeBarTemp._totoScale._y);

			this._fightData._lifeBar.runAction(CCSpawn.actions([ actionTo, actionToTwo, null ]));
		}
	},

	damage : function(amount) // float
	{
		if (!this._fightData || !this.canBeDamaged()) {
			return;
		}

		this._fightData._lifeBG.stopAllActions();
		this._fightData._lifeBar.stopAllActions();
		this._fightData._lifeBarTemp.stopAllActions();

		this._fightData._lifeBarTemp.setScale(this._fightData._hitPoints / this._fightData._finalHitPointsTotal, 1);
		this._fightData._lifeBarTemp.setColor(ccc3(0xff, 0xff, 0x00));

		amount = (amount > this._fightData._armor) ? amount - this._fightData._armor : 0;

		this._fightData._hitPoints -= (1 - this._fightData._finalDamageReduction) * amount;

		if (this._fightData._hitPoints <= 0) {
			this._fightData._hitPoints = 0;
		}

		this._fightData._lifeBar.setScale(this._fightData._hitPoints / this._fightData._finalHitPointsTotal, this._fightData._lifeBar._totoScale._y);

		this.damageBlink();
		this._fightData._damageTimer = ZFGameDefines.DAMAGE_IMMUNITY_IN_FRAMES;

		this._fightData._lifeBG.setOpacity(255);
		this._fightData._lifeBar.setOpacity(255);
		this._fightData._lifeBarTemp.setOpacity(255);

		var showLifeBarDelay = 0.5;

		if (this._fightData._opponent && this._fightData._opponent._fightData &&  this._fightData._opponent._fightData._opponent == this) {
			showLifeBarDelay = 5.0;
		}

		var scaleDuration = 0.5;

		var actionTo = CCSequence.actions(CCDelayTime.actionWithDuration(showLifeBarDelay), CCFadeOut.actionWithDuration(0.25));
		this._fightData._lifeBG.runAction(actionTo);
		actionTo = CCSequence.actions(CCDelayTime.actionWithDuration(showLifeBarDelay), CCFadeOut.actionWithDuration(0.25));
		this._fightData._lifeBar.runAction(actionTo);

		var actionToTwo = CCScaleTo.actionWithDuration(scaleDuration, this._fightData._hitPoints / this._fightData._finalHitPointsTotal,
				this._fightData._lifeBarTemp.getScale()._y);

		actionTo = CCSequence.actions(CCDelayTime.actionWithDuration(showLifeBarDelay), CCFadeOut.actionWithDuration(0.25));

		this._fightData._lifeBarTemp.runAction(CCSpawn.actions(actionTo, actionToTwo));
	},

	initSprite : function() {
		if (!this._spriteMan) {
			this._spriteMan = new CCSpriteSheet();
			this._spriteMan.initWithFile(this._spriteFileName, 50);

			this.initSpriteDictionary();
			// sublasses will do more stuff from here...
		}
	},

	initSpriteDictionary : function() {
		// sublasses will do more stuff from here...
	},

	addAttachment_withRect_withAnchor_withOffset_withZOrder_withRotation : function(attachmentID, rect, anchor, offset, z, r) {
		var t = this.addAttachment_withRect_withAnchor_withOffset_withZOrder(attachmentID, rect, anchor, offset, z);
		t._originalRotation = r;
		t.setRotation(t._originalRotation);
		return t;
	},

	addAttachment_withRect_withAnchor_withOffset_withZOrder : function(attachmentID, rect, anchor, offset, z) {
		var attachment = null;

		// echoRect( rect );
		attachment = new ActorAttachment();
		attachment._atlasRect = rect.clone();

		// Convert anchor.
		attachment._originalAnchor = new Core.Vector(anchor._x, 1 - anchor._y);

		attachment._offsetFromRefPoint = offset.clone();

		attachment._sprite = CCSprite.spriteWithSpriteSheet(this._spriteMan, rect.clone(), attachment._originalAnchor);
//		attachment._sprite.initWithSpriteSheet(this._spriteMan, rect.clone(), attachment._originalAnchor);
		// attachment._sprite.setAnchorPoint( attachment._originalAnchor.clone()
		// );
		attachment._sprite.setPosition(offset.clone());

		attachment._inheritColor = true;
		attachment._sprite.setScale(1, 1);

		this._spriteMan.addChild(attachment._sprite);
		this._attachments[attachmentID] = attachment;
// this.addChild(attachment);

		attachment._sprite.setDepth(z);
		attachment._tag = attachmentID;

		// console.log( "Add attachment : attachmentID=" + attachmentID
		// + ", rect=" + rect
		// + ", anchor=" + anchor._x + "," + anchor._y
		// + ", offset=" + offset._x + "," + offset._y
		// + ", z=" + z
		// + ", realDepth=" + attachment._sprite.getDepth() );

		return attachment;
	},

	addAttachment_withSprite_withZOrder : function(attachmentID, sprite, z) {
		var attachment = new ActorAttachment();

		attachment._atlasRect = sprite._textureRect;
		attachment._originalAnchor = sprite._anchorPoint;
		attachment._offsetFromRefPoint = sprite._offsetPosition;
		attachment._tag = attachmentID;

		attachment._sprite = sprite;
		attachment._inheritColor = true;
		this._spriteMan.addChild(attachment._sprite, z);

		this._attachments[attachmentID] = attachment;

		return attachment;
	},

	spriteFromPlist_withFile : function(spriteDetails, texture) // NSDictionary*,
																// NSString*
	{
		var rect = new Core.Rect(new Core.Point(spriteDetails.x, spriteDetails.y), new Core.Size(spriteDetails.width, spriteDetails.height));

		var anchor = ccp(spriteDetails.pivotX, spriteDetails.pivotY);
		var rotation = spriteDetails.rotation;

		var sprite = CCSprite.spriteWithFile(texture, rect);
		sprite._anchorPoint = anchor;
		sprite._rotation = rotation;

		return sprite;
	},

	setFrameForActorAttachment : function(t, frameName) // ActorAttachment*,
														// NSString*
	{
		CCSpriteFrameCache.sharedSpriteFrameCache().addSpriteFrameWithFile("./Content/"+this._spriteFrameFile);
//		if(!this._srpitesLoaded){
//			CCSpriteFrameCache.addSpriteFramesWithDictionary(this._spriteFrameFile, ("./Content/"+this._spriteFileName));
//			this._srpitesLoaded = true;
//		}
		var sprite = CCSprite.spriteWithSpriteFrame(CCSpriteFrameCache.sharedSpriteFrameCache().spriteFrameByName(frameName));
		var skeletonEntry = this._skeletonDictionary[frameName];

		var offset = ccp(0, 0);

		if (skeletonEntry.anchor) {
			var anchorPixelPosition = CGPointFromString(skeletonEntry.anchor); // CGPoint;

			anchorPixelPosition = ccp(anchorPixelPosition._x, sprite._contentSize._height - anchorPixelPosition._y);

			offset = sprite._anchorPointInPixels;

			var anchorPosition = ccp(anchorPixelPosition._x / sprite._contentSize._width, anchorPixelPosition._y / sprite._contentSize._height);
			sprite._anchorPoint = anchorPosition;
			offset = ccpSub(sprite._anchorPointInPixels, offset);
		}

		// Frame offset is defined as 0,0 by default --> change in initSprite
		offset = ccpAdd(offset, this._frameOffset);

		t._originalRotation = 0;
		t._rotation = 0;
		sprite._rotation = 0;
		t._atlasRect = sprite._textureRect;
		t._offsetFromRefPoint = offset;

		if (skeletonEntry.offset) {
			skeletonOffset = CGPointFromString(skeletonEntry.offset);
			t._offsetFromRefPoint = ccpAdd(t._offsetFromRefPoint, skeletonOffset);
		}

		t._originalAnchor = sprite._anchorPoint;
		t._sprite = sprite;
		t._inheritColor = true;

		var z = 0;

		if (skeletonEntry.z) {
			z = skeletonEntry.z;
		} else {
			switch (t._tag) {
			case kActorPartTagButt:
				z = 0;
				break;
			case kActorPartTagFistB:
				z = 1;
				break;
			case kActorPartTagArmB:
				z = 2;
				break;
			case kActorPartTagFootB:
				z = 3;
				break;
			case kActorPartTagFootF:
				z = 4;
				break;
			case kActorPartTagBody:
				z = 5;
				break;
			case kActorPartTagHead:
				z = 6;
				break;
			case kActorPartTagJaw:
				z = 7;
				break;
			case kActorPartTagFeatures:
				z = 8;
				break;
			case kActorPartTagArmF:
				z = 9;
				break;
			case kActorPartTagFistF:
				z = 10;
				break;
			}
		}

		this._spriteMan.addChild(t._sprite, z);
	},

	addAttachment : function(attachmentID, frameName) {
		// NSAssert(spriteFrameFile,@"No Frame List in Actor");
		// CCSpriteFrameCache.sharedSpriteFrameCache().addSpriteFramesWithFile(this._spriteFrameFile);
		if(!this._spritesLoaded){
			CCSpriteFrameCache.addSpriteFramesWithDictionary(this._spriteFrameFile, ("./Content/"+this._spriteFileName));
			this._spritesLoaded = true;
		}
		var spriteFrame = CCSpriteFrameCache.sharedSpriteFrameCache().spriteFrameByName(frameName);
		var sprite = CCSprite.spriteWithSpriteFrame(spriteFrame);
		var skeletonEntry = this._skeletonDictionary[frameName];
		var offset = ccp(0, 0);
//		sprite._contentSize._width = 90;
//		sprite._contentSize._height = 146;
		if (skeletonEntry.anchor) {
			var anchorPixelPosition = CGPointFromString(skeletonEntry.anchor);
			anchorPixelPosition = ccp(anchorPixelPosition._x, sprite._contentSize._height - anchorPixelPosition._y);
			offset = sprite._anchorPointInPixels;
			var anchorPosition = ccp(anchorPixelPosition._x / sprite._contentSize._width, anchorPixelPosition._y / sprite._contentSize._height);
			sprite._anchorPoint = anchorPosition;
//			offset = ccpSub(sprite._anchorPointInPixels, offset);
		}

		// frame offset is defined as 0,0 by default --> change in initSprite
		offset = ccpAdd(offset, this._frameOffset);
		offset = ccpAdd(offset, sprite._specialOffset);
		var t = new ActorAttachment();
		//		
		t._originalRotation = 0;
		t._rotation = 0;
		sprite._rotation = 0;

		t._atlasRect = sprite._textureRect;
		t._offsetFromRefPoint = offset;
		if (skeletonEntry.offset) {
			var skeletonOffset = CGPointFromString(skeletonEntry.offset);
			t._offsetFromRefPoint = ccpAdd(t._offsetFromRefPoint, skeletonOffset);
		}

		t._originalAnchor = sprite._anchorPoint;
		t._sprite = sprite;
		t._tag = attachmentID;
		t._inheritColor = true;
//		t._sprite.setColor(a._sprite._color);
		var z = 0;

		if (skeletonEntry.z) {
			z = skeletonEntry.z;
		} else {
			switch (attachmentID) {
			case kActorPartTagButt:
				z = 0;
				break;
			case kActorPartTagFistB:
				z = 1;
				break;
			case kActorPartTagArmB:
				z = 2;
				break;
			case kActorPartTagFootB:
				z = 3;
				break;
			case kActorPartTagFootF:
				z = 4;
				break;
			case kActorPartTagBody:
				z = 5;
				break;
			case kActorPartTagHead:
				z = 6;
				break;
			case kActorPartTagJaw:
				z = 7;
				break;
			case kActorPartTagFeatures:
				z = 8;
				break;
			case kActorPartTagArmF:
				z = 9;
				break;
			case kActorPartTagFistF:
				z = 10;
				break;
			}
		}

		this._spriteMan.addChild(t._sprite, z);
//		t._sprite.setPosition(offset.clone());
		this._attachments[attachmentID] = t;
		CCSpriteFrameCache.sharedSpriteFrameCache().removeUnusedSpriteFrames();
		return this._attachments[attachmentID];
		
	},

	addAttachmentFromPlist_withSpriteDetails : function(attachmentID, spriteDetails) {
		return this.addAttachment_withRect_withAnchor_withOffset_withZOrder_withRotation(attachmentID, new Core.Rect(new Core.Point(spriteDetails.x,
				spriteDetails.y), new Core.Size(spriteDetails.width, spriteDetails.height)),
				new Core.Point(spriteDetails.pivotX, spriteDetails.pivotY), new Core.Point(spriteDetails.offsetX, spriteDetails.offsetY),
				spriteDetails.z,
				spriteDetails.rotation || 0);
	},

	addAttachment_withSpriteDetails : function(attachmentID, spriteDetails) {
		var t = null;
		if (!spriteDetails) {
			t = this.addAttachment_withRect_withAnchor_withOffset_withZOrder(attachmentID, CGRectMake(0,0,0,0), ccp(0,0),
					ccp(0,0), 0);
		} else
		{
			t = this.addAttachment_withRect_withAnchor_withOffset_withZOrder(attachmentID, spriteDetails.rect, spriteDetails.anchor,
				spriteDetails.offset, spriteDetails.z);
		}

		return t;
	},

	replaceAttachment_withFrame : function(attachmentID, frameName) {
		var a = this._attachments[attachmentId];
		if (a == null) {
			return this.addAttachment(attachmentID, frameName);
		}

		var oldSprite = a._sprite;

		this.setFrameForActorAttachment(a, frameName);

		a._sprite.setRotation(a._sprite._rotation);
		a._sprite.setPosition(a._sprite._ccPosition);

		a._sprite.setColor(a._sprite._color);
		a._sprite.setOpacity(a._sprite._opacity);
		a._sprite.setScale(a._sprite._scale);

		var faceRight = oldSprite._flipX;
		a._sprite.setFlipX(faceRight);

		if (faceRight) {
			a._offsetFromRefPoint = ccp(-a._offsetFromRefPoint._x, a._offsetFromRefPoint._y);
			a._sprite._anchorPoint = ccp(1.0 - a._originalAnchor._x, a._originalAnchor._y);
		} else {
			a._sprite.anchorPoint = ccp(a.originalAnchor.x, a.originalAnchor.y);
		}

		// this attachment's sprite can be in the array of touchSprites
		var toRemove = [];
		var addNewTSprite = false;

		for (key in allMySprites) {
			tSprite = allMySprites[key];

			if (tSprite._sprite == oldSprite && tSprite._actor == this) {
				// TODO : Double check this syntax.
				toRemove.push(tSprite);
				addNewTSprite = true;
				// [toRemove addObject:tSprite];
				// addNewTSprite = YES;
			}
		}

		for (key in toRemove) {
			TSprite.untrack(toRemove[key]);
		}

		// [toRemove release];

		// This actor must be able to be touched, set this up now.
		if (addNewTSprite) {
			var tSprite = new TSprite();
			tSprite.initWithAtlasSprite(a._sprite);
			TSprite.track(tSprite);
			tSprite._actor = this;
		}

		if (oldSprite && oldSprite._parent) {
			oldSprite.removeFromParentAndCleanup(true);
		}

		return a;
	},

	replaceAttachment_withRect_withAnchor_withOffset_withZOrder : function(attachmentID, rect, anchor, offset, z) {
		return this.replaceAttachment_withRect_withAnchor_withOffset_withZOrder_withRotation(attachmentID, rect, anchor, offset, z, 0);
	},

	replaceAttachment_withRect_withAnchor_withOffset_withZOrder_withRotation : function(attachmentID, rect, anchor, offset, z, r) {
		var attachmentOld = this._attachments[attachmentID];

		if (!attachmentOld || attachmentOld == null) {
			return this.addAttachment_withRect_withAnchor_withOffset_withZOrder(attachmentID, rect, anchor, offset, z);
		}

		if (CGRectEqualToRect(rect, attachmentOld._sprite._textureRect)) {
			return attachmentOld; // Same attachment, don't swap.
		}

		var old_s_rotation = attachmentOld._sprite.getRotation();
		var old_s_position = attachmentOld._sprite._ccPosition;
		var old_s_color = attachmentOld._sprite.getColor();
		var old_s_opacity = attachmentOld._sprite.getOpacity();
		var old_s_scale = attachmentOld._sprite._totoScale.clone();
		var old_s_flipX = attachmentOld._sprite.getFlipX();

		var old_position = attachmentOld._ccPosition;
		var old_rotation = attachmentOld.getRotation();
		var old_scale = attachmentOld._totoScale.clone();
		// var old_refPoint = attachmentOld._offsetFromRefPoint.clone();

		this.removeChild(attachmentOld, true);

		if (attachmentOld._sprite && attachmentOld._sprite._parent) {
			attachmentOld._sprite._parent.removeChild(attachmentOld._sprite, true);
		}

		// this attachment's sprite can be in the array of touchSprites
		var toRemove = [];
		var addNewTSprite = false;

		for (t in allMySprites) {
			var tSprite = allMySprites[t];

			if (tSprite._sprite == attachmentOld._sprite && tSprite._actor == this) {
				toRemove.push(tSprite);
				addNewTSprite = true;
			}
		}

		destroyWithChildren(attachmentOld);
		
		for (key in toRemove) {
			TSprite.untrack(toRemove[key]);
		}

		this._attachments[attachmentID] = null;

		// *** Old Attachment suppressed.

		var attachmentNew = this.addAttachment_withRect_withAnchor_withOffset_withZOrder(attachmentID, rect, anchor, offset, z);

		attachmentNew._sprite._flipX = false;
		attachmentNew._sprite._flipY = false;
		attachmentNew._sprite._totoScole = ccp(1, 1);
		attachmentNew._sprite.setDepth(z);

		attachmentNew._sprite.setRotation(old_s_rotation);
		attachmentNew._sprite.setPosition(old_s_position);
		attachmentNew.setPosition(old_position);
		attachmentNew._originalRotation = r;
		attachmentNew.setRotation(attachmentNew._originalRotation);
		attachmentNew._sprite.setColor(old_s_color);
		attachmentNew._sprite.setOpacity(old_s_opacity);
		attachmentNew._sprite.setScale(old_s_scale);
		attachmentNew.setScale(old_scale);
		attachmentNew._sprite.setFlipX(old_s_flipX);

		if (old_s_flipX) {
			attachmentNew._offsetFromRefPoint = ccp(-attachmentNew._offsetFromRefPoint._x, attachmentNew._offsetFromRefPoint._y);

			// attachmentNew._sprite.setAnchorPoint( ccp( 1.0 -
			// attachmentNew._originalAnchor._x ,
			// attachmentNew._originalAnchor._y ) );
			// }
			// else
			// {
			// attachmentNew._sprite.setAnchorPoint(
			// ccp(attachmentNew._originalAnchor._x ,
			// attachmentNew._originalAnchor._y ) );
		}

		// [toRemove release];

		// This actor must be able to be touched, set this up now.
		if (addNewTSprite) {
			var tSprite = new TSprite();
			tSprite.initWithAtlasSprite(attachmentNew._sprite);
			TSprite.track(tSprite);
			tSprite._actor = this;
		}

		attachmentNew._tag = attachmentID;

		return attachmentNew;
	},

	replaceAttachmentFromPlist_withSpriteDetails : function(attachmentID, spriteDetails) {
		return this.replaceAttachment_withRect_withAnchor_withOffset_withZOrder_withRotation(attachmentID, new Core.Rect(new Core.Point(
				spriteDetails.x, spriteDetails.y), new Core.Size(spriteDetails.width, spriteDetails.height)), ccp(spriteDetails.pivotX,
				spriteDetails.pivotY), ccp(spriteDetails.offsetX, spriteDetails.offsetY), spriteDetails.z, spriteDetails.rotation);
	},

	replaceAttachment_withSpriteDetails : function(attachmentID, spriteDetails) {
		return this.replaceAttachment_withRect_withAnchor_withOffset_withZOrder(attachmentID, spriteDetails.rect, spriteDetails.anchor,
				spriteDetails.offset, spriteDetails.z);
	},

	addSpriteDictionaryEntry : function(key, rect, anchor, offset, z) {
		var spriteDictionaryDetails = {};

		spriteDictionaryDetails['rect'] = rect;
		spriteDictionaryDetails['anchor'] = anchor;
		spriteDictionaryDetails['offset'] = offset;
		spriteDictionaryDetails['z'] = z;

		this._spriteDictionary[key] = spriteDictionaryDetails;
		spriteDictionaryDetails.length = 0;
		spriteDictionaryDetails = null;
		return spriteDictionaryDetails;
	},

	hitBoxTouched : function() {
		// overwrite this
	},

	collidedWith : function(object) // Actor*
	{
		// overwrite this
	},

	setInterrupt : function(interrupt) // BOOL
	{
		if (this._fightData) {
			this._fightData._canInterrupt = interrupt;
		}
	},

	getAbilityByTag : function(abilityTag) // int
	{
		if (this._abilityList) {
			for (key in this._abilityList) {
				var a = this._abilityList[key];
				if (a._tag == abilityTag) {
					return a;
				}
			}
		}

		return null; // ZFActorAbility*
	},

	cleanupStunEffect : function() {
		var p; // ActorParticle*

		for (particle in this._particles) {
			if (particle._tagID == kActorStunParticle) {
				p = particle;
				break;
			}
		}

		if (p) {
			this._spriteMan._parent.removeChild(p._particle, true);
			this._particles.removeObject(p);
		}
	},

	stunSelfFor : function(seconds) // int
	{
		if (this._fightData && this._fightData._canInterrupt && this._fightData._hitPoints > 0) {
			if (this.isScheduled(this.fightAttack))
				this.unschedule(this.fightAttack);

			this.stopAllActions();
			if (this.isScheduled(this.damageIn))
				this.unschedule(this.damageIn);
			if (this.isScheduled(this.attackSFXIn))
				this.unschedule(this.attackSFXIn);
			if (this.isScheduled(this.doneAttacking))
				this.unschedule(this.doneAttacking);
			this._fightData._attacking = false;

			this.setState(kActorFightStateStunned);

			this._fightData._stunTimer = (this._fightData._stunTimer < seconds) ? seconds : this._fightData._stunTimer;
			// TODO: Wait for quad particles
			// CCQuadParticleSystem *stun = nil;
			// for(ActorParticle *actorParticle in particles)
			// {
			// if(actorParticle.tagID == kActorStunParticle)
			// {
			// stun = (CCQuadParticleSystem*)actorParticle.particle;
			// break;
			// }
			// }
			// if(!stun)
			// {
			// var sae = SimpleAudioEngine;
			// sae.playEffect("stun.wav");
			//				
			// TODO: Wait for implementation
			// ActorParticle *p = [[ActorParticle alloc] init];
			// p.particle = [ZFParticleEffects
			// particleSystemByTag:@"stun.plist"];
			// [p.particle retain];
			// p.attachmentID = kActorPartTagHead;
			//				
			// if([self isKindOfClass:[ZombieActorHeadless class]])
			// p.attachmentID = kActorPartTagBody;
			//				
			// p.size = p.particle.startSize;
			// p.sizevar = p.particle.startSizeVar;
			// p.tagID = kActorStunParticle;
			//				
			// // particles is an NSMutableArray found in Actor class
			// [particles addObject:p];
			//				
			// // no longer need to keep track of p
			// [p release];
			// }
		}
	},

	actorIsFighting : function() {
		return this._state == kActorFightStateFight || this._state == kActorFightStateFighting || this._state == kActorFightStateEnterFight;
	},

	isInMeleeRange : function() {
		// Overwrite this.
		return false;
	},

	despawn : function() {
		this.cleanup();

		var toRemove = [];

		var tSprites = TSprite.allMySprites();
		for ( var tSpriteKey in tSprites) {
			var tSprite = tSprites[tSpriteKey];
			if (tSprite._actor && tSprite._actor == this) {
				toRemove.push(tSprite);
			}
		}

		for ( var tSpriteKey in toRemove) {
			var tSprite = toRemove[tSpriteKey];
			TSprite.untrack(tSprite);
		}

		toRemove.length = 0;
		toRemove = null;

		this.cleanupStunEffect();

		if (this._farmData) {
			this._farmData = null;
		}

		if (this._fightData) {
			
			this._fightData._opponent = null;

			if (this._fightData._lifeBG._parent) {
				this._fightData._lifeBG._parent.removeChild(this._fightData._lifeBG, true);
			}
			destroyWithChildren(this._fightData._lifeBG);
			this._fightData._lifeBG = null;

			if (this._fightData._lifeBar._parent) {
				this._fightData._lifeBar._parent.removeChild(this._fightData._lifeBar, true);
			}
			destroyWithChildren(this._fightData._lifeBar);
			this._fightData._lifeBar = null;

			if (this._fightData._lifeBarTemp._parent) {
				this._fightData._lifeBarTemp._parent.removeChild(this._fightData._lifeBarTemp, true);
			}
			destroyWithChildren(this._fightData._lifeBarTemp);
			this._fightData._lifeBarTemp = null;
			
			destroyWithChildren(this._fightData);
			this._fightData = null;
		}

		if (this._spriteMan && this._spriteMan._parent) {
			this._spriteMan.removeAllChildrenWithCleanup(true);
			this._spriteMan._parent.removeChild(this._spriteMan, true);
			destroy(this._spriteMan);
			this._spriteMan = null;
		}

		for ( var key in this._particles) {
			var p = this._particles[key];
			p._particle._parent.removeChild(p._particle, true);
		}

		if (this._attachments) {
			for ( var key in this._attachments) {
				destroyWithChildren(this._attachments[key]);
			}
			this._attachments.length = 0;
			this._attachments = null;
		}

		// this._particles.removeAllObjects( this._particles );
		if(this._particles) {
			this._particles.length = 0;
			this._particles = null;
		}

		// this._spriteDictionary.removeAllObjects( this._spriteDictionary );
		if(this._spriteDictionary) {
			this._spriteDictionary.length = 0;
			this._spriteDictionary = null;
		}

		// this._abilityList.removeAllObjects( this._abilityList );
		if(this._abilityList) {
			this._abilityList.length = 0;
			this._abilityList = null;
		}

		this._unitDictionary = null;
		this._spriteFileName = null;
		this._spriteFrameFile = null;
		this._eatDate = null;
		this._skeletonDictionary = null;

		if (this.getParent())
			this.getParent().removeChild(this, true);
		
		destroyWithChildren(this);
	},

	initActorSpecificAbilities : function() {
		// overwritten
	},

	// these three functions CAN be overwritten but probably shouldn't
	calculateFinalPower : function() {
		var power = this._fightData._passivePowerChange;
		power += this._fightData._temporaryPowerChange;
		// there is only a -100% cap for power, any less would heal the enemy
		power = (power < -1.0) ? -1.0 : power;
		power = (1 + power) * this._fightData._power;

		return power;
	},

	calculateFinalAttackSpeed : function() {
		// check over 100% passive haste cap
		//Original code says  var speed = this._fightData._passivePowerChange;
		var speed = this._fightData._passiveAttackSpeedChange;
		speed = (speed > 0.50) ? 0.50 : speed;
		// check for -100% total haste
		speed += this._fightData._temporaryAttackSpeedChange;
		speed = (speed < -0.50) ? -0.50 : speed;

		// calculating the actual speed after buffs / debuffs
		speed = (1.0 - speed) * this._fightData._attackSpeed;
		return speed;
	},

	calculateFinalDamageReduction : function() {
		var dr = this._fightData._passiveDamageReduction;
		// check for 50% to -50% damage reduction
		dr = (dr > 0.50) ? 0.50 : dr;
		dr = (dr < -0.50) ? -0.50 : dr;

		// there is no negative or positive cap for temporary damage reduction
		dr += this._fightData._temporaryDamageReduction;
		return dr;
	},

	calculateFinalHitPointsTotal : function() {
		// theres no real caps on hpChange ... can go as high or low as you want
		// but the hpTotal will stop at 1hp
		var hpTotal = this._fightData._hitPointsTotal * (1 + this._fightData._hitPointsTotalChange);
		// cap is 1hp to prevent divide by zero situation
		hpTotal = (hpTotal < 1.0) ? 1.0 : hpTotal;

		return hpTotal;
	},

	// used for any special effect sprites used with actor attacks
	cleanupSprite : function(sender, sprite) // id, CCSprite*
	{
		this._sprite._parent.removeChild(true);
	},

	startPausedParticleSystem : function(sender, data) // (id)sender
														// data:(CCQuadParticleSystem*)p
	{
		p.scheduleUpdate(); // if it's a finite particles system it will
							// automatically clean itself up
	},

	cleanupNode : function(id, data) {
		if (data && data._parent) {
			data._parent.removeChild(data, true);
		}
	},
	
	stopAttachmentActions : function(){
		for ( var key in this._attachments )
		{
			var a = this._attachments[ key ];

			if (a == null)
				continue;
			
			a._sprite.stopAllActions();
			a.stopAllActions();
		}
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/ZFAnims'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/ZFAnims'] || {}; $MODULE_REGISTRY['Code/Game/Actor/ZFAnims'] = exports; exports.ZFAnims = Core.Class.subclass (
{
	classname: 'ZFAnims',
	
	$eyeBulge: function( s , sc )
	{
		return CCScaleTo.actionWithDuration( s * 0.25 , sc * 1.15 );
	},

	$eyePop: function( s )
	{
		var bezier  = {};
		//bezier.startPosition = ccp(0,0);
		bezier._controlPoint_1 	= ccp( 5	, 10	);
		bezier._controlPoint_2 	= ccp( 10	, -25	);
		bezier._endPosition 	= ccp( 10	,-50	);
		
		return CCSequence.actions( 
				CCBezierBy.actionWithDuration( 0.5 , bezier )  );
//		
//		return [CCSequence actions:
//				[CCBezierBy actionWithDuration:.5f bezier:bezier],nil];
	},

	$eyeBlink: function( rand, sc )
	{
		return	CCSequence.actions( 
				 CCDelayTime.actionWithDuration( rand ),
				 CCScaleTo.actionWithDuration( 0.05 , sc * 1.0 , sc * 0.0 ),
				 CCScaleTo.actionWithDuration( 0.05 , sc * 1.0 , sc * 1.0 ) );
	},

	$eyeSquint: function( sc )
	{
		return	CCScaleTo.actionWithDuration( 1.0 , sc * 1.0 , sc * 0.5 );
	},

	$eyeBiteSquint: function( s , sc )
	{
		return CCSequence.actions( 
				CCScaleTo.actionWithDuration( s * 0.43 , sc * 1.0 , sc * 0.75 ),
				CCScaleTo.actionWithDuration( s * 0.06 , sc * 1.0 , sc * 0.0 ),
				CCDelayTime.actionWithDuration( s * 0.06 ),
				CCScaleTo.actionWithDuration( s * 0.06 , sc * 1.0 , sc * 1.0 ) );
	},

	$eyeFlailSquint: function( s , sc ) 
	{
		return CCSequence.actions(
				CCScaleTo.actionWithDuration( s * 0.125 , sc * 1.0 , sc * 0.75 ),
				CCDelayTime.actionWithDuration( s * 0.5 ),
				CCScaleTo.actionWithDuration( s * 0.125 , sc * 1.0 , sc * 1.0 ) );
	},

	$eyeDistractedMove: function( s )
	{
		return CCMoveTo.actionWithDuration( s * 0.5 , ccp( -1 , 3 ) ); 
	},

	$eyeRotateClockwise: function( s , f )
	{
		return CCRotateBy.actionWithDuration( s * 0.5 , f * 90 );
	},

	$eyeRotateCounterClockwise: function( s , f )
	{
		return CCRotateBy.actionWithDuration( s * 0.5 , f * -90 );	
	},
	
	$jawOpenMove: function( s )
	{
		return CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.25 , ccp( 0 , -1 ) );
	},

	$jawCloseMove: function( s )
	{
		return CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.25 , ccp( 0 ,  5 ) );
	},

	$jawOpenCloseMove: function( s )
	{
		return CCSequence.actions(
				CCMoveByWithoutChangingPosition.actionWithDuration( s * 2.0 , ccp( 0 , 0 ) ),
				CCMoveByWithoutChangingPosition.actionWithDuration( s * 2.0 , ccp( 2 , 6 ) ) );
	},

	$jawBite: function( s )
	{
		return CCSequence.actions(
				CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.37 , ccp( -3 , -6 ) ),
				CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.06 , ccp(  0 ,  5 ) ) );
	},

	$armHopMoveRotateF: function( s , f )
	{
		return CCSequence.actions( 
				CCRotateTo.actionWithDuration( s * 0.25 , f *   0 ),
				CCRotateTo.actionWithDuration( s * 0.25 , f *  -5 ),
				CCRotateTo.actionWithDuration( s * 0.25 , f * -10 ),
				CCRotateTo.actionWithDuration( s * 0.25 , f *   3 ) );
	},
	
	$armHopMoveRotateB: function( s , f )
	{
		return CCSequence.actions( 
				CCRotateTo.actionWithDuration( s * 0.25 , f *  0 ),
				CCRotateTo.actionWithDuration( s * 0.25 , f *  5 ),
				CCRotateTo.actionWithDuration( s * 0.25 , f * 10 ),
				CCRotateTo.actionWithDuration( s * 0.25 , f * -3 ) );
	},
	
	$armHopMove: function( s )
	{
		return CCSequence.actions(
				CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.25 , ccp( 0 , -1 ) ),
				CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.25 , ccp( 0 ,  1 ) ),
				CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.25 , ccp( 0 ,  5 ) ),
				CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.25 , ccp( 0 ,  1 ) ) );
	},
	
	$armLeanForwardMoveF: function( s )
	{
		return CCMoveByWithoutChangingPosition.actionWithDuration( s * 1.0 , ccp( -10.0 , -2.0 ) );
	},
	
	$armLeanForwardMoveB: function( s )
	{
		return CCMoveByWithoutChangingPosition.actionWithDuration( s * 1.0 , ccp( -5.0 , -4.0 ) );
	},
	
	$armIdleRotateNoScale: function( s , f )
	{
		var addThis = 0;
		
		if( f == -1 ) addThis = 180;
			
		return CCRotateTo.actionWithDuration( s * 1 , addThis - 90 ); // f*-90];
	},

	$armIdleRotate: function( s , f )
	{
		return CCSpawn.actions(
				CCScaleTo.actionWithDuration( 0.5 , 0.8 ),
				CCRotateTo.actionWithDuration( s * 1 , f  * -90 ) );
	},

	$armWalkWiggleFrontRotate: function( s , sc , f )
	{
		return CCSpawn.actions(
					CCSequence.actions ( 
							CCRotateTo.actionWithDuration( s * 0.25 , f * -15.0 ),
							CCRotateTo.actionWithDuration( s * 0.25 , f * -1.0 )  ),
					CCScaleTo.actionWithDuration( s * 0.25 , sc * 1.0 ) );
	},

	$armWalkWiggleBackRotate: function( s , sc ,f )
	{
		return CCSpawn.actions( 
					CCSequence.actions( 
							CCRotateTo.actionWithDuration( s * 0.25 , f *  -1.0 ),
							CCRotateTo.actionWithDuration( s * 0.25 , f * -15.0 )  ),
					CCScaleTo.actionWithDuration( s * 0.25 , sc * 1.0 ) );
	},

	$armWalkFrontRotate: function( s , f )
	{
		return CCSpawn.actions( 
				CCScaleTo.actionWithDuration( s * 1.0 , 1.0 ),
				CCRotateTo.actionWithDuration( s * 1.0 , f * -7.0 ) );
	},

	$armWalkFrontRotatePlayer: function( s , f )
	{
		return CCSequence.actions( 
					CCRotateTo.actionWithDuration( s * 0.5 ,  f *  14.0 ),
					CCRotateTo.actionWithDuration( s * 0.5 ,  f * -14.0 ) );
	},

	$armWalkBackRotatePlayer: function( s , f )
	{
		return CCSequence.actions(
					CCRotateTo.actionWithDuration( s * 0.5 , f * -14.0 ),
					CCRotateTo.actionWithDuration( s * 0.5 , f *  14.0 ) );
	},

	$armWorkFrontRotatePlayer: function( s , f )
	{
		return CCSpawn.actions(
					CCScaleTo.actionWithDuration( s * 1.0 , 1.2 ),
					CCSequence.actions( 
							CCRotateTo.actionWithDuration( s * 0.5 , f * ( -4.0 + 90 ) ),
							CCRotateTo.actionWithDuration( s * 0.5 , f * (  4.0 + 90 ) ) ) );
	},

	$armWorkFrontMovePlayer: function( s )
	{
		return CCSequence.actions(
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.75 , ccp( -8.0 , -4.0 ) ),
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.25 , ccp( -8.0 , -7.0 ) ) );
	},

	$armWorkBackRotatePlayer: function( s , f )
	{
		return CCSequence.actions( 
					CCRotateTo.actionWithDuration( s * 0.5 , f * ( -14.0 + 15 ) ),
					CCRotateTo.actionWithDuration( s * 0.5 , f * (  14.0 + 15 ) ) );
	},

	$armWalkLummoxRotate: function( s , f ) 
	{
		return CCSpawn.actions(
				CCScaleTo.actionWithDuration( s * 1.0 , 1.0 ),
				CCRotateTo.actionWithDuration( s * 1.0 , f * -120 ) );
	},

	$armBite: function( s , sc , f )
	{
		return CCSpawn.actions( 
					CCSequence.actions(
						CCRotateTo.actionWithDuration( s * 0.12 , f *  -90.0 ),
						CCRotateTo.actionWithDuration( s * 0.06 , f * -120.0 ), 
						CCDelayTime.actionWithDuration( s * 0.18 )  ),
					CCSequence.actions( 
						CCScaleTo.actionWithDuration( s * 0.06 , sc * 0.8 ),
						CCDelayTime.actionWithDuration( s * 0.43 ) ) );
	},

	$armFlailFront3: function( s , sc , f )
	{
		return   CCSequence.actions(
				 	CCRotateTo.actionWithDuration( s * 0.80 , f * -20.0 ),
				 	CCRotateTo.actionWithDuration( s * 0.20 , f *  90.0 ) );
	},

	$armFlailBack3: function( s , sc , f )
	{
		return   CCSequence.actions( 
				 	CCRotateTo.actionWithDuration( s * 0.20 , f  * -90.0 ),
				 	CCRotateTo.actionWithDuration( s * 0.80 , f  *  20.0 ) );
	},

	$armFlailFront2: function( s , sc , f )
	{
		return CCSpawn.actions(
					CCSequence.actions(
						CCRotateTo.actionWithDuration( s * 0.40 , f * -90.0 ),
						CCRotateTo.actionWithDuration( s * 0.10 , f *   0.0 ),
						CCRotateTo.actionWithDuration( s * 0.40 , f * -90.0 ),
						CCRotateTo.actionWithDuration( s * 0.10 , f *   0.0 ) ),
					CCSequence.actions(
						CCScaleTo.actionWithDuration( s * 0.1 , sc * 1.2 ),
						CCDelayTime.actionWithDuration( s  * 0.8 ),
						CCScaleTo.actionWithDuration( s * 0.1 , sc * 1.0 ) ) );
	},

	$armFlailBack2: function( s , sc , f )
	{
		return CCSpawn.actions(
					CCSequence.actions( 
						CCRotateTo.actionWithDuration( s * 0.10 , f * -45.0 ),
						CCRotateTo.actionWithDuration( s * 0.40 , f * ( -90 - 45.0 ) ), 
						CCRotateTo.actionWithDuration( s * 0.10 , f * -45.0 ),
						CCRotateTo.actionWithDuration( s * 0.40 , f * ( -90 - 45.0 ) ) ),
					CCSequence.actions( 
						CCScaleTo.actionWithDuration( s * 0.1 , sc * 1.2 ), 
						CCDelayTime.actionWithDuration( s * 0.8 ),
						CCScaleTo.actionWithDuration( s * 0.1 , sc * 1.0 ) ) );
	},

	$armWhackFront: function( s , sc , f )
	{
		return CCSpawn.actions(
				CCSequence.actions( 
					CCRotateTo.actionWithDuration( s * 0.90 , f * 180.0 ),
					CCRotateTo.actionWithDuration( s * 0.10 , f * 0.0 ) ),
				CCSequence.actions( 
					CCScaleTo.actionWithDuration( s * 0.90 , sc * 1.2 ),
					CCScaleTo.actionWithDuration( s * 0.1 , sc * 1.0 ) ) );
	},

	$armWhackBack: function( s , sc , f )
	{
		return CCSequence.actions( 
					CCRotateTo.actionWithDuration( s * 0.90 , f *  10 ),
					CCRotateTo.actionWithDuration( s * 0.10 , f * -20 ) );
	},

	$armPirateIdleFront: function (  s , sc , f )
	{
		return CCSequence.actions( 
					CCRotateTo.actionWithDuration( s * 0.40 , f * -90 - 5 ),
					CCRotateTo.actionWithDuration( s * 0.60 , f * -90 + 5 ) );
	},

	$armPirateIdleBack: function( s , sc , f )
	{
		return CCSequence.actions (  
					CCRotateTo.actionWithDuration( s * 0.40 , f * -90 + 5 ),
					CCRotateTo.actionWithDuration( s * 0.60 , f * -90 - 5 ) );
	},

	$armHackFront: function( s , sc , f )
	{
		return CCSequence.actions( 
					CCRotateTo.actionWithDuration( s * 0.95 , f *  90.0 ),
					CCRotateTo.actionWithDuration( s * 0.05 , f * -90.0 -45 ) );
	},

	$armHackBack: function( s , sc , f ) 
	{
		return CCSequence.actions( 
				CCRotateTo.actionWithDuration( s * 0.95 , f *  45.0 ),
				CCRotateTo.actionWithDuration( s * 0.05 , f * -90 - 45.0 ) );
	},

	$armHackBack2: function( s , sc , f )
	{
		return CCSequence.actions(
				CCRotateTo.actionWithDuration( s * 0.55 , f * -90.0 ),
				CCRotateTo.actionWithDuration( s * 0.25 , f *  25.0 ),
				CCRotateTo.actionWithDuration( s * 0.05 , f * -90.0 - 45.0 ),
				CCDelayTime.actionWithDuration( s * 0.15 ) );
	},

	$armFlailFront: function( s , sc , f )
	{
		return CCSpawn.actions(
					CCSequence.actions(
							CCRotateTo.actionWithDuration( s * 0.5 , f * 50.0 ),
							CCRotateTo.actionWithDuration( s * 0.5 , f * 0.0 ) ),
					CCSequence.actions(  
						 	CCScaleTo.actionWithDuration( s * 0.25 , sc * 1.3 ),
						 	CCDelayTime.actionWithDuration( s * 0.5 ),
						 	CCScaleTo.actionWithDuration( s * 0.25 , sc * 1.0 ) ) );
	},

	$armFlailBack: function( s , sc , f )
	{
		return CCSpawn.actions(
					CCSequence.actions( 
						CCRotateTo.actionWithDuration( s * 0.5 , f * 0.0 ),
						CCRotateTo.actionWithDuration( s * 0.5 , f * 50.0 ) ),
					CCSequence.actions( 
						CCScaleTo.actionWithDuration( s * 0.25 , sc * 1.3 ), 
						CCDelayTime.actionWithDuration( s * 0.5 ),
						CCScaleTo.actionWithDuration( s * 0.25 , sc * 1.0 ) ) );
	},

	$armVictory: function( s , sc , f )
	{
		return CCSpawn.actions(
					CCSequence.actions( 
						 CCRotateTo.actionWithDuration( s * 0.25 , f *  80.0 ),
						 CCRotateTo.actionWithDuration( s * 0.25 , f * 100.0 ),
						 CCRotateTo.actionWithDuration( s * 0.25 , f *  80.0 ),
						 CCRotateTo.actionWithDuration( s * 0.25 , f * 100.0 ) ),
					CCScaleTo.actionWithDuration( s * 1.0 , sc * 1.0 ) );
	},

	$armVictoryMove: function( s )
	{
		return CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.25 , ccp( 6.0 , 5.0 ) );
	},

	$armFallMove: function( s )
	{
		return CCMoveByWithoutChangingPosition.actionWithDuration( 0.75 , ccp( 0.0 , -30.0 ) );
	},

	$armThrow: function( s , f )
	{
		return CCSequence.actions(
					CCRotateBy.actionWithDuration( s * 0.25 , f *  130 ),
					CCRotateBy.actionWithDuration( s * 0.75 , f * -130 ) );
	},

	$footHopMove: function( s )
	{
		return CCSequence.actions(
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.25 , ccp( 0 , 0 ) ),
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.25 , ccp( 0 , 6 ) ),
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.25 , ccp( 0 , 2 ) ),
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.25 , ccp( 0 , 0 ) ) );
		
	},
	
	$footHop: function( s , f )
	{
		return CCSequence.actions(
				CCRotateTo.actionWithDuration( s * 0.25 , f *  -5 ),
				CCRotateTo.actionWithDuration( s * 0.25 , f * -10 ),
				CCRotateTo.actionWithDuration( s * 0.25 , f * -30 ),
				CCRotateTo.actionWithDuration( s * 0.25 , f *  -5 ) );
	},
	
	$footTipToe: function( s , f )
	{
		return CCRotateTo.actionWithDuration( s * 1.0 , f * -20 );
	},
	
	$footLeanForwardMoveF: function( s )
	{
		return CCMoveByWithoutChangingPosition.actionWithDuration( s * 1.0 , ccp( 2 , 2 ) );
	},
	
	$footWalkFrontMove: function ( s )
	{
		return CCSequence.actions( 
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.60 , ccp(  1.0 ,  4.0 ) ),
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.40 , ccp( -3.0 , -2.0 ) ) );
	},

	$footWalkBackMove: function( s )
	{
		return CCSequence.actions(
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.40 , ccp( -1.0 , 0.0 ) ),
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.60 , ccp( 10.0 , 4.0 ) ) );
	},

	$footWalkFrontMovePlayer: function( s )
	{
		return CCSequence.actions( 
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.60 , ccp(  3.0 ,  4.0 ) ),
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.40 , ccp( -2.0 , -2.0 ) ) );
	},

	$footWalkBackMovePlayer: function( s )
	{
		return CCSequence.actions(
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.40 , ccp( -4.0 , 0.0 ) ),
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.60 , ccp(  2.0 , 1.0 ) ) );
	},

	$footWalkFrontRotate: function( s , f )
	{
		return CCSequence.actions( 
					CCDelayTime.actionWithDuration( s * 0.10 ),
					CCRotateTo.actionWithDuration( s * 0.50 , f * -20.0 ),
					CCRotateTo.actionWithDuration( s * 0.10 , f * -1.0 ),
					CCDelayTime.actionWithDuration( s * 0.30 ) );
	},

	$footWalkFrontRotatePlayer: function( s , f )
	{
		return CCSequence.actions( 
					CCDelayTime.actionWithDuration( s * 0.10 ),
					CCRotateTo.actionWithDuration( s * 0.50 , f * -20.0 ),
					CCRotateTo.actionWithDuration( s * 0.10 , f * -1.0 ),
					CCDelayTime.actionWithDuration( s * 0.30 ) );
	},

	$bodyHopMove: function( s )
	{
		return CCSequence.actions(
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.25 , ccp( 0 , -2 ) ),
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.25 , ccp( 0 ,  2 ) ),
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.25 , ccp( 0 ,  5 ) ),
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.25 , ccp( 0 , -0 ) ) );
		
	},
	
	$bodyLeanForwardRotate: function( s ,f )
	{
		return CCRotateTo.actionWithDuration( s * 1.0 , f * -8.0 );
	},
	
	$bodyWalkMove: function ( s )
	{
		return CCSequence.actions( 
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.50 , ccp( 0.0 ,  0.5 ) ),
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.50 , ccp( 0.0 , -0.5 ) ) );
	},

	$bodyWorkMovePlayer: function ( s )
	{
		return CCSequence.actions( 
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.75 , ccp( 0.0 , -4.0 ) ),
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.25 , ccp( 0.0 , -7.0 ) ) );
	},

	$bodyDieMove: function( s )
	{
		return CCSequence.actions( 
					CCDelayTime.actionWithDuration( 0.20 ),
					CCMoveByWithoutChangingPosition.actionWithDuration( 0.25 , ccp( 0 , -7 ) ),
					CCDelayTime.actionWithDuration( 0.55 ),
					CCMoveByWithoutChangingPosition.actionWithDuration( 0.35 , ccp( 0 , -7 ) ) );
	},

	$bodyDie: function( s , f )
	{
		return CCSequence.actions(
					CCRotateTo.actionWithDuration( 0.75 , f * -20.0 ),
					CCRotateTo.actionWithDuration( 0.75 , f *  20.0 ),
					CCRotateTo.actionWithDuration( 0.35 , f * -85.0 ) );
	},

	$headHopMove: function( s )
	{
		return CCSequence.actions(
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.25 , ccp( 0 , -2 ) ),
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.25 , ccp( 0 ,  1 ) ),
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.25 , ccp( 0 ,  4 ) ),
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.25 , ccp( 0 ,  1 ) ) );
	},
	
	$headLeanForwardMove: function( s )
	{
		return CCMoveByWithoutChangingPosition.actionWithDuration( s * 1.0 , ccp( -8 , -3 ) );
	},
	
	$headDaydream: function( s ,  f )
	{
		return CCSequence.actions( 
					CCRotateTo.actionWithDuration( s * 3.0 , f * 10.0 ),
					CCRotateTo.actionWithDuration( s * 3.0 , f * 20.0 ) );
	},

	$headSleep: function ( s , f )
	{
		return CCSequence.actions(
					CCRotateTo.actionWithDuration( s * 3.0 , f * -10.0 ),
					CCRotateTo.actionWithDuration( s * 3.0 , f * -20.0 ) );
	},

	$headWorkPlayer: function( s , f )
	{
		return CCRotateTo.actionWithDuration( s * 3.0 , f * -10.0 );
	},

	$headWalkMove: function ( s , p )
	{
		return CCSequence.actions(
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.05 , ccpAdd( p , ccp( -2 , -4 ) ) ),
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.15 , ccpAdd( p , ccp( -1 , -3 ) ) ),
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.50 , ccpAdd( p , ccp(  0 , -3 ) ) ),
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.30 , ccpAdd( p , ccp( -3 , -3 ) ) ) );
	},

	$headWalkRotate: function( s , f )
	{				
		return CCSequence.actions(
					CCRotateTo.actionWithDuration( s * 0.20 , f *  3.5 ),
					CCRotateTo.actionWithDuration( s * 0.50 , f * 10 ),
					CCRotateTo.actionWithDuration( s * 0.30 , f * 0 ) );
	},

	$headBite: function( s )
	{
		return CCSequence.actions(
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.13 , ccp( -8 , -6 ) ),
					CCDelayTime.actionWithDuration( s * 0.25 ),
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.62 , ccp( 0 , 0 ) ) );
	},

	$headFlail: function ( s )
	{
		return CCSequence.actions(
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.5 , ccp( 8 , -1 ) ),
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.5 , ccp( 0 ,  0 ) ) );
	},

	$headFlail2: function( s , f )
	{
		return	CCSequence.actions(
					  CCRotateTo.actionWithDuration( s * 0.25 , f *   0   ),
					  CCRotateTo.actionWithDuration( s * 0.25 , f *  -3.0 ),
					  CCRotateTo.actionWithDuration( s * 0.25 , f * -10.0 ),
					  CCRotateTo.actionWithDuration( s * 0.25 , f *  -2.0 ) );
	},

	$headHack: function( s )
	{
		return CCSequence.actions(
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.95 , ccp(  8 , 4 ) ),
					CCMoveByWithoutChangingPosition.actionWithDuration( s * 0.05 , ccp( -5 , 0 ) ) );
	},

	$headBob: function( s )
	{
		var v = 2.0;
		
		var bezier1 = {};
		//bezier1.startPosition = ccp(0,0);	
		bezier1._controlPoint_1 = ccp( 0  	 , v * 1.5 );
		bezier1._controlPoint_2 = ccp( v * 2 , v * 1.5 );
		bezier1._endPosition 	= ccp( v * 2 , 0 );
		
		var bezier2 = {};
		//bezier2.startPosition = ccp(v,0);
		bezier2._controlPoint_1 = ccp( 0	 , v * 1.5 );
		bezier2._controlPoint_2 = ccp(-v * 2 , v * 1.5 );
		bezier2._endPosition 	= ccp(-v * 2 , 0 );
		
		return CCSequence.actions(
					CCDelayTime.actionWithDuration( s * 0.1 ),
					CCBezierBy.actionWithDuration( s * 0.4 , bezier1 ),
					CCDelayTime.actionWithDuration( s * 0.1 ),
					CCBezierBy.actionWithDuration( s * 0.4 , bezier2 ) );
	},

	$headFlyOff: function( s , f )
	{
		var bezier = {};
		//bezier.startPosition = ccp(f*0,0);
		bezier._controlPoint_1 	= ccp( f * 100 ,  75	);
		bezier._controlPoint_2 	= ccp( f * 100 ,  0		);
		bezier._endPosition 	= ccp( f * 100 , -30	);
		
		return CCBezierBy.actionWithDuration( 1.0 , bezier );
	},

	$headFlyRotate: function( s , f )
	{
		return CCRotateTo.actionWithDuration( 1.0 , f * ( 500.0 ) );
	},

	$headMove: function( s , p )
	{
		return CCMoveByWithoutChangingPosition.actionWithDuration( s * 1.0 , p );
	},

	$headDistracted: function( s , f )
	{
		return CCSequence.actions(
				CCRotateTo.actionWithDuration( s * 0.5 , f * 20.0 ),
				CCRotateTo.actionWithDuration( s * 1.0 , f * 15.0 ) );
	},

	//////////// anim is for separate parts ///////////


	// Breathing animation 
	$headBreatheRotate: function( s , f )
	{
		return CCSequence.actions(
					CCRotateTo.actionWithDuration( s * 0.25 , f * 0.0 ),
					CCRotateTo.actionWithDuration( s * 0.25 , f * 1.0 ),
					CCRotateTo.actionWithDuration( s * 0.25 , f * 3.0 ),
					CCRotateTo.actionWithDuration( s * 0.25 , f * 1.0 ) );
	},
	
	$bodyBreatheScale: function( s ,sc ) 
	{
		return 	CCSequence.actions(
					 CCScaleTo.actionWithDuration( s * 0.25 , sc * 1.0  ),
					 CCScaleTo.actionWithDuration( s * 0.25 , sc * 1.01 ),
					 CCScaleTo.actionWithDuration( s * 0.25 , sc * 1.03 ),
					 CCScaleTo.actionWithDuration( s * 0.25 , sc * 1.0 ) );
	},

	$hatFallsOffMove: function( s )
	{
		return CCSequence.actions(
					CCMoveTo.actionWithDuration( s * 0.1 , ccp( 1 , 4 ) ),
					CCMoveTo.actionWithDuration( s * 0.1 , ccp( 2 , 6 ) ),
					CCMoveTo.actionWithDuration( s * 0.1 , ccp( 3 , 3 ) ),
					CCMoveTo.actionWithDuration( s * 0.7 , ccp( 4 , -100 ) ) );
	},

	$explosionColorChange: function( s )
	{
		// TODO Maybe replace 255 => 1.0.
		return CCSequence.actions(
				CCTintTo.actionWithDuration( s * 0.0  , 255 , 255 , 255 ),
				CCTintTo.actionWithDuration( s * 0.03 , 255 , 255 , 255 ),
				CCTintTo.actionWithDuration( s * 0.03 , 255 , 255 , 255 ),
				CCTintTo.actionWithDuration( s * 0.03 , 255 , 255 , 0 ),
				CCTintTo.actionWithDuration( s * 0.03 , 255 , 255 , 255 ),
				CCTintTo.actionWithDuration( s * 0.03 , 255 , 255 , 0 ),
				CCTintTo.actionWithDuration( s * 0.03 , 255 , 255 , 255 ),
				CCTintTo.actionWithDuration( s * 0.02 , 255 , 255 , 0 ),
				CCTintTo.actionWithDuration( s * 0.02 , 255 , 255 , 255),
				CCTintTo.actionWithDuration( s * 0.02 , 255 , 255 , 0),
				CCTintTo.actionWithDuration( s * 0.02 , 255 , 255 , 255),
				CCTintTo.actionWithDuration( s * 0.02 , 255 , 255 , 0),
				CCTintTo.actionWithDuration( s * 0.02 , 255 , 255 , 255),
				CCTintTo.actionWithDuration( s * 0.01 , 255 , 255 , 0),
				CCTintTo.actionWithDuration( s * 0.01 , 255 , 255 , 255),
				CCTintTo.actionWithDuration( s * 0.01 , 255 , 255 , 0),
				CCTintTo.actionWithDuration( s * 0.01 , 255 , 255 , 255),
				CCTintTo.actionWithDuration( s * 0.01 , 255 , 255 , 0),
				CCTintTo.actionWithDuration( s * 0.01 , 255 , 255 , 255),
				CCTintTo.actionWithDuration( s * 0.01 , 255 , 255 , 0),
				CCTintTo.actionWithDuration( s * 0.01 , 255 , 255 , 255),
				CCTintTo.actionWithDuration( s * 0.01 , 255 , 255 , 0),
				CCTintTo.actionWithDuration( s * 0.01 , 255 , 255 , 255));
	},

	
	$setAnimationActions: function( 	dict , animationFrames , sequenceActions , moveToOffsets , moveOffsets , scaleSequence , 
							sprite , animatedSprite , repeatForever )
	{
		var animationAction = null;
		
		if ( animationFrames )
		{
			var animationDelay		= dict[ "animationDelay" ];
			var animationDelayAfter = dict[ "animationDelayAfter" ];
			var animationSpeed		= dict[ "animationSpeed" ];
			
			var animationSet = null;
			var animation = CCAnimation.animationWithName( "animatedSprite" );
			
			for ( var frameName in animationFrames )
			{
				if ( frameName == "playSound" )
				{
					if ( !animationSet )
					{
						animationSet = CCAnimation.actionWithDuration( animationSpeed)
					}
				}
			}
		}
		
	},
	
	//+ (void)playSoundFromSprite:(id)sender data:(NSString*)soundID
	playSoundFromSprite: function(sender, soundID)
	{
		SimpleAudioEngine.playEffect(soundID);	
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/ZFAttackAnims'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/ZFAttackAnims'] || {}; $MODULE_REGISTRY['Code/Game/Actor/ZFAttackAnims'] = exports; exports.ZFAttackAnims = Core.Class.subclass (
{
	classname: 'ZFAttackAnims',
	
	$kAttackTypes : 
	{
		kAttackTypeNone : 0,
		kAttackTypeFrontArmSwingDown : 1,
		kAttackTypeBothArmsSwingDownSimultaneous : 2,
		kAttackSwingDownArmsConsecutive : 3,
		kAttackSwingUpArmsConsecutive : 4,
		kAttackTypeWeaponPoke : 5,
		kAttackTypeFlailArmsFront : 6,
		kAttackTypeLeanForwardDoubleStab : 7,
		kAttackTypeBite : 8,
		kAttackTypeScratch : 9,
		kAttackTypeBash : 10,
		kAttackTypeExplode : 11,
		kAttackTypeBashV2 : 12,
		kAttackTypeExplodeV2 : 13,
		kAttackTypeBroBotBash : 14,
		kAttackTypeJunkBotBite : 15,
		kAttackTypeBrainBotShock : 16,
		kAttackTypeLumberjackSlice : 17,
		kAttackTypeLumberjackSpecial : 18,
		kAttackTypeSpecialMinion1Attack : 19,
		kAttackTypeSpecialMinion2Attack : 20,
		kAttackTypeSpecialBossAttack : 21,
		kAttackTypeMAX : 22
	},
	
	$performAttackWithID: function( attackID , actor )
	{
	    var mainFrame = CCDirector.winSize();
        var resolutionWidth = mainFrame._height;
        var widthScale = resolutionWidth / 480;
        var heightScale = widthScale;
			
		var arm1 	= actor._attachments[ kActorPartTagArmF		];
		var arm2 	= actor._attachments[ kActorPartTagArmB		];
		var foot1	= actor._attachments[ kActorPartTagFootF	];
		var foot2 	= actor._attachments[ kActorPartTagFootB	];
		var body 	= actor._attachments[ kActorPartTagBody		];
		var head 	= actor._attachments[ kActorPartTagHead		];
		var jaw 	= actor._attachments[ kActorPartTagJaw		];
		var eye1 	= actor._attachments[ kActorPartTagEyeL		];
		var eye2 	= actor._attachments[ kActorPartTagEyeR		];
		var fist1 	= actor._attachments[ kActorPartTagFistF	];
		var fist2 	= actor._attachments[ kActorPartTagFistB	];
		
		var f = head._sprite.flipX() ? -1 : 1;
		var asc = actor.getFightAttackSpeed();
		
		var fm = ZFFightMan;
		
		switch ( attackID ) 
		{
			case this.kAttackTypes.kAttackTypeFrontArmSwingDown:
				arm1.onceS( ZFAnims.armWhackFront( asc , arm1.getScale()._x , f ) );
				arm2.onceS( ZFAnims.armWhackBack( asc , arm1.getScale()._x , f ) );
				head.once( ZFAnims.headHack( asc ) );
				break;
				
			case this.kAttackTypes.kAttackTypeBothArmsSwingDownSimultaneous:
				arm1.onceS( ZFAnims.armHackFront( asc , arm1.getScale()._x , f ) );
				arm2.onceS( ZFAnims.armHackBack( asc , arm2.getScale()._x * 0.9 , f ) );
				head.once( ZFAnims.headHack( asc ) );
				break;
				
			case this.kAttackTypes.kAttackSwingDownArmsConsecutive:
				arm1.onceS( ZFAnims.armHackFront( asc , arm1.getScale()._x , f ) );
				arm2.onceS( ZFAnims.armHackBack2( asc , arm1.getScale()._x , f ) );
				head.once( ZFAnims.headHack( asc ) );
				break;
				
			case this.kAttackTypes.kAttackSwingUpArmsConsecutive:
				arm1.onceS( ZFAnims.armFlailFront2( asc , arm1.getScale()._x , f ) );
				arm2.onceS( ZFAnims.armFlailBack2( asc , arm2.getScale()._x * 0.9 , f ) );
				head.once( ZFAnims.headFlail( asc ) );
				break;
				
			case this.kAttackTypes.kAttackTypeWeaponPoke:
				arm2.onceS( ZFAnims.armIdleRotateNoScale( 0 , f ) );
				head.once( ZFAnims.headFlail( asc * 0.5 ) );
				arm1.onceS( CCSequence.actions( 
							 	CCRotateTo.actionWithDuration( asc * 0.25 , f * -45.0 ),
							 	CCRotateTo.actionWithDuration( asc * 0.25 , f * -90.0 )  ) );
				arm2.once( CCSequence.actions( 
							CCMoveBy.actionWithDuration( asc * 0.25 , ccp( -30 , 0 ) ),
							CCMoveBy.actionWithDuration( asc * 0.25 , ccp( +30 , 0 ) )  ) );
				break;
				
			case this.kAttackTypes.kAttackTypeFlailArmsFront:
				arm2.once( CCMoveTo.actionWithDuration( 0 , ccp( 15 , -15 ) ) );
				arm1.onceS( ZFAnims.armFlailFront( asc , arm1.getScale()._x , f ) );
				arm2.onceS( ZFAnims.armFlailBack( asc , arm2.getScale()._x * 0.9 , f ) );
				head.once( ZFAnims.headFlail( asc ) );
				break;
				
			case this.kAttackTypes.kAttackTypeLeanForwardDoubleStab:
				arm1.onceS( ZFAnims.armFlailFront3( asc , arm1.getScale()._x , f ) );
				arm2.onceS( ZFAnims.armFlailBack3( asc , arm2.getScale()._x , f ) );
				head.onceS( ZFAnims.headFlail2( asc , f ) );
				foot1.once( ZFAnims.footLeanForwardMoveF( asc ) );
				foot1.onceS( ZFAnims.footTipToe( asc , f ) );
				arm1.once( ZFAnims.armLeanForwardMoveF( asc ) );
				arm2.once( ZFAnims.armLeanForwardMoveB( asc ) );
				head.once( ZFAnims.headLeanForwardMove( asc ) );
				body.onceS( ZFAnims.bodyLeanForwardRotate( asc , f ) );
				break;
				
			case this.kAttackTypes.kAttackTypeBite:
//				eye1.onceS( ZFAnims.eyeBiteSquint( asc , eye1.getScale()._x ) );
//				eye2.onceS( ZFAnims.eyeBiteSquint( asc , eye2.getScale()._x ) );
				jaw.once( ZFAnims.jawBite( asc ) );
				head.once( ZFAnims.headBite( asc ) );
				arm1.onceS( ZFAnims.armBite( asc , arm1.getScale()._x , f ) );
				arm2.onceS( ZFAnims.armBite( asc , arm2.getScale()._x , f ) );
				break;
				
			case this.kAttackTypes.kAttackTypeScratch: 
				if (!( actor._flags & kMutationArms ) )
				{
					arm1 = actor.replaceAttachmentFromPlist_withSpriteDetails( kActorPartTagArmF,
							actor._spriteDictionary[ "excitedArmF"] );
					arm2 = actor.replaceAttachmentFromPlist_withSpriteDetails( kActorPartTagArmB,
							actor._spriteDictionary[ "excitedArmB"] );
				}
				
//				eye1.onceS( ZFAnims.eyeFlailSquint( asc , eye1.getScale()._x ) );
//				eye2.onceS( ZFAnims.eyeFlailSquint( asc , eye2.getScale()._x ) );
				arm1.onceS( ZFAnims.armFlailFront( asc , arm1.getScale()._x , f ) );
				arm2.onceS( ZFAnims.armFlailBack( asc , arm2.getScale()._x , f ) );
				head.once( ZFAnims.headFlail( asc ) );
				break;
				
			case this.kAttackTypes.kAttackTypeBashV2:
			case this.kAttackTypes.kAttackTypeBash:
				// attack both arms simultaneously
				arm1.onceS( ZFAnims.armHackFront( asc , arm1.getScale()._x , f ) );
				arm2.onceS( ZFAnims.armHackBack( asc , arm2.getScale()._x * 0.9 , f ) );
				head.once( ZFAnims.headHack( asc ) );
				var originalScale = actor._spriteMan.getScale()._x;
				var bashScale = 1.0;
				
				if(attackID == this.kAttackTypes.kAttackTypeBash)
					bashScale = 1.25;
				if(attackID == this.kAttackTypes.kAttackTypeBashV2)
					bashScale = 1.5;
				
				actor._spriteMan.runAction( CCSequence.actions( 
						CCScaleTo.actionWithDuration( asc * 0.95 , (originalScale * bashScale) ),
						CCScaleTo.actionWithDuration( asc * 0.05 , originalScale )  ) );
				
				// add bash explosion effect
				break;
				
			case this.kAttackTypes.kAttackTypeExplodeV2:
			case this.kAttackTypes.kAttackTypeExplode:
				if ( !( actor._flags & kMutationArms ) )
				{
					arm1 = actor.replaceAttachmentFromPlist_withSpriteDetails( kActorPartTagArmF,
							actor._spriteDictionary[ "excitedArmF" ] );
					
					arm2 = actor.replaceAttachmentFromPlist_withSpriteDetails( kActorPartTagArmB,
							actor._spriteDictionary[ "excitedArmB" ] );
				}
				
				var s = actor._animSpeed;
				var explodeScale = 1.2;
				
				actor._spriteMan.runAction( CCScaleTo.actionWithDuration( asc * 0.7 , 
						actor._spriteMan.getScale()._x * explodeScale ) );
				
				// sets scale, color and fade for all sprites
				for( key in actor._attachments )
				{
					var actorAttach = actor._attachments[ key ];
					
					if ( actorAttach != null )
					{
						actorAttach._sprite.runAction( ZFAnims.explosionColorChange( asc ) );
					}
				}

				arm1._sprite.stopAllActions();
				
				arm1._sprite.runAction( CCSpawn.actions( 
									CCRotateTo.actionWithDuration( asc * 0.8 , f * 110.0 ),
									ZFAnims.explosionColorChange( asc )  ) );
				
				arm2._sprite.stopAllActions();
				arm2._sprite.runAction( CCSpawn.actions( 
										CCRotateTo.actionWithDuration( asc * 0.8 , f * 110.0 ),
										ZFAnims.explosionColorChange( asc )  ) );

				// just moving the node no need to change 
				arm1.once( ZFAnims.armVictoryMove( asc ) );
				arm2.once( ZFAnims.armVictoryMove( asc ) );
				
				// just scaling make our own scale action to account for increased size
				// normal eyeBulge = action with duration of 1/4 regular speed
				// therefore: new eyeBulge = action with duration of 1/4 * 1/speedMultiplier (which is 5) == 1/20
				
				var eyeBulgeTime		= asc * 0.8;
				var eyeBulgeScale		= eye1.getScale()._x * 1.25;
				
				eye1._sprite.stopAllActions();
				eye1._sprite.runAction( CCSpawn.actions( 
										CCScaleTo.actionWithDuration( eyeBulgeTime , eyeBulgeScale ),
										CCTintTo.actionWithDuration( asc , ccc3( 255 , 0 , 0 ) )  ) );
				
				eye2._sprite.stopAllActions();
				eye2._sprite.runAction( CCSpawn.actions( 
										CCScaleTo.actionWithDuration( eyeBulgeTime , eyeBulgeScale ),
										CCTintTo.actionWithDuration( asc , ccc3( 255 , 0 , 0 ) )  ) );
				
				// just moving
				head.loop( ZFAnims.headWalkMove( s , ccp( 0 , 0 ) ) );
				head._sprite.runAction( ZFAnims.explosionColorChange( asc ) );
				jaw._sprite.runAction( ZFAnims.explosionColorChange( asc ) );
				actor.schedule( actor.suicide, asc * 1.1, "suicide" );
				
				// this is a special effect that doesn't stop when the zombie dies 
				// (zombie death stops all actions the zombie is running ... which is why we're using a non-zombie sprite for this)

//				var explodePosition = ccpAdd( actor.getPosition() , ccp( 0 , 20 * heightScale ) );
//				var boomFire = ZFParticleEffects.particleSystemByTag( "boomFire.plist" );
//				boomFire.setPosition( explodePosition.clone() );
//				boomFire.setScale( ccpMult( boomFire.getScale() , widthScale ) );
//				fm.getParent().addChild( boomFire , 203 );
//				boomFire.unscheduleUpdate();
//				
//				boomFire.runAction( CCSequence.actions( new Array (
//									CCDelayTime.actionWithDuration( asc ),
//									CCCallFuncND.actionWithTarget( actor , actor.startPausedParticleSystem , boomFire ) ) ) );
//				
//				var boomSide = ZFParticleEffects.particleSystemByTag( "boomSide.plist" );
//				boomSide.setPosition( explodePosition.clone() );
//				boomSide.setScale( ccpMult( boomSide.getScale() , widthScale ) );
//				fm.getParent().addChild( boomSide , 202 );
//				boomSide.unscheduleUpdate();
//				
//				boomSide.runAction( CCSequence.actions( new Array(
//									CCDelayTime.actionWithDuration( asc ),
//									CCCallFuncND.actionWithTarget( actor , actor.startPausedParticleSystem , boomSide ) ) ) );
				
				if( attackID == actor.kAttackTypeExplodeV2 )
				{
//					var boomTop = ZFParticleEffects.particleSystemByTag( "boomTop.plist" );
//					boomTop.setPosition( ccpAdd( explodePosition, ccp( 0 , 20 * heightScale ) ) );
//					boomTop.setScale( ccpMult( boomTop.getScale() , widthScale ) );
//					fm.getParent().addChild( boomTop , 202 );
//					boomTop.unscheduleUpdate();
//					boomTop.runAction( CCSequence.actions( new Array (
//									CCDelayTime.actionWithDuration( asc ),
//									CCCallFuncND.actionWithTarget( actor , actor.startPausedParticleSystem , boomTop ) ) ) );
					
//					var boomBiggerFire = ZFParticleEffects.particleSystemByTag( "boomBiggerFire.plist" );
//					boomBiggerFire.setPosition( explodePosition.clone() );
//					boomBiggerFire.setScale( ccpMult( boomBiggerFire.getScale() , widthScale ) );
//					fm.getParent().addChild( boomBiggerFire , 202 );
//					boomBiggerFire.unscheduleUpdate();
//					boomBiggerFire.runAction( CCSequence.actions( new Array (
//										CCDelayTime.actionWithDuration( asc ),
//										CCCallFuncND.actionWithTarget( actor , actor.startPausedParticleSystem , boomBiggerFire ) ) ) );
				}
				break;
				
			case this.kAttackTypes.kAttackTypeBroBotBash:
				var sequence = CCSequence.actions( 
								CCRotateTo.actionWithDuration( asc * 0.05 , 0 ),
								CCRotateBy.actionWithDuration( asc * 0.60 , f *  180.0 ),
								CCRotateBy.actionWithDuration( asc * 0.30 , f * -270.0 ),
								CCRotateBy.actionWithDuration( asc * 0.05 , f *   90.0 )  );
				
				arm1.once( sequence );
				arm1.onceS( CCSequence.actions( 
							 CCScaleTo.actionWithDuration( asc * 0.90 , arm1.getScale()._x * 1.2 ),
							 CCScaleTo.actionWithDuration( asc * 0.10 , arm1.getScale()._x * 1.0 )  ) );
				
				arm2.once( ZFAnims.armWhackBack( asc , arm1.getScale()._x , f ) );
				
				sequence = CCSequence.actions( 
								 CCRotateTo.actionWithDuration( asc* 0.01 , 0 ),
								 CCRotateBy.actionWithDuration( asc* 0.60 , f * 140 ),
								 CCRotateBy.actionWithDuration( asc* 0.35 , f *-275.0 ),
								 CCRotateTo.actionWithDuration( asc* 0.04 , 0 )  );
				
				fist1.once( sequence );
				fist1.onceS( CCSequence.actions( 
							  CCScaleTo.actionWithDuration( asc * 0.90 , fist1.getScale()._x * 1.2 ),
							  CCScaleTo.actionWithDuration( asc * 0.10 , fist1.getScale()._x * 1.0 )  ) );
				
				head.once( CCSequence.actions( 
							 CCMoveBy.actionWithDuration( asc * 0.8  , ccp(  8 , 4 ) ),
							 CCMoveBy.actionWithDuration( asc * 0.15 , ccp( -13,-6 ) ),
							 CCMoveBy.actionWithDuration( asc * 0.05 , ccp( 5 , 2 ) )  ) );
				break;

			case this.kAttackTypes.kAttackTypeJunkBotBite:
				body.onceS( CCSequence.actions( 
							 CCRotateTo.actionWithDuration( asc * 0.2 , f * -20 ),
							 CCRotateTo.actionWithDuration( asc * 0.8 , f * 0 )  ) );

				head.onceS( CCSequence.actions( 
							 CCRotateTo.actionWithDuration( asc * 0.2 , f * 100 ),
							 CCRotateTo.actionWithDuration( asc * 0.1 , f * 0 ),
							 CCRotateTo.actionWithDuration( asc * 0.7 , f * 0 )  ) );
				break;

			case this.kAttackTypes.kAttackTypeBrainBotShock:
				arm1.onceS( ZFAnims.armWhackFront( asc , arm1.getScale()._x , f ) );
				arm2.onceS( ZFAnims.armWhackBack( asc , arm1.getScale()._x , f ) );
				head.once( ZFAnims.headHack( asc ) );
				break;
				
			case this.kAttackTypes.kAttackTypeLumberjackSlice:
				arm2.once( CCMoveByWithoutChangingPosition.actionWithDuration( 0 , ccp( 15 , -15 ) ) );

				arm2.onceS( ZFAnims.armFlailBack( asc , arm2.getScale()._x * 0.9 , f ) );
				head.once( ZFAnims.headFlail( asc ) );
				
				arm1.once( CCSequence.actions( 
							CCRotateTo.actionWithDuration( asc * 0.5 , f *  60.0 ),
							CCRotateTo.actionWithDuration( asc * 0.4 , f * -90.0 )  ) );
				
				fist1.once( CCSequence.actions( 
							  CCRotateBy.actionWithDuration( asc * 0.6 , f *  25.0 ),
							  CCRotateBy.actionWithDuration( asc * 0.3 , f * -110.0 ),
							  CCRotateBy.actionWithDuration( asc * 0.1 , f * 85.0 )  ) );
				break;
			
			case this.kAttackTypes.kAttackTypeLumberjackSpecial:
				arm2.onceS( ZFAnims.armWhackBack( asc , arm1.getScale()._x , f ) );
				head.once( ZFAnims.headHack( asc ) );
				
				arm1.once( CCSpawn.actions( 
								CCSequence.actions( 
									 CCRotateTo.actionWithDuration( asc * 0.90 , f * 180.0 ),
									 CCRotateTo.actionWithDuration( asc * 0.05 , f * 0.0 )  ),
								CCSequence.actions( 
									 CCScaleTo.actionWithDuration( asc * 0.90 , arm1.getScale()._x * 1.2 ),
									 CCScaleTo.actionWithDuration( asc * 0.10 , arm1.getScale()._x * 1.0 )  )  ) );
				
				fist1.once( CCSequence.actions( 
							 CCRotateBy.actionWithDuration( asc * 0.90 , f *  45.0 ),
							 CCRotateBy.actionWithDuration( asc * 0.05 , f * -90.0 ),
							 CCRotateBy.actionWithDuration( asc * 0.05 , f *  45.0 )  ) );
				break;
			
			case this.kAttackTypes.kAttackTypeSpecialMinion1Attack:
				arm1.onceS( CCSequence.actions( 
								 CCRotateBy.actionWithDuration( asc * 0.35 , f * -45 ),
								 CCRotateBy.actionWithDuration( asc * 0.20 , f * 270 ),
								 CCDelayTime.actionWithDuration( asc * 0.15 ),
								 CCRotateBy.actionWithDuration( asc * 0.10 , f * -180 ),
								 CCRotateTo.actionWithDuration( asc * 0.20 , f * 0 )  ) );
				
				arm2.onceS( CCSequence.actions( 
							 CCRotateBy.actionWithDuration( asc * 0.35 , f * -45 ),
							 CCRotateBy.actionWithDuration( asc * 0.20 , f * 270 ),
							 CCDelayTime.actionWithDuration( asc * 0.15 ),
							 CCRotateBy.actionWithDuration( asc * 0.10 , f * -180 ),
							 CCRotateTo.actionWithDuration( asc * 0.20 , f * 0 )  ) );
				
				body.onceS( CCSequence.actions(
							 CCRotateTo.actionWithDuration( asc * 0.40 , f * -20 ),
							 CCRotateTo.actionWithDuration( asc * 0.05 , f * 20 ),
							 CCDelayTime.actionWithDuration( asc * 0.30 ),
							 CCRotateTo.actionWithDuration( asc * 0.05 , f * -60 ),
							 CCRotateTo.actionWithDuration( asc * 0.2 , f * 0 )  ) );
				
				head.onceS( CCSequence.actions(
							 CCRotateTo.actionWithDuration( asc * 0.33 , f * -20 ),
							 CCRotateTo.actionWithDuration( asc * 0.33 , f * 1 ),
							 CCRotateTo.actionWithDuration( asc * 0.33 , f * 1 )  ) );
				
				foot1.onceS( CCSequence.actions( 
							  CCRotateTo.actionWithDuration( asc * 0.4 , f * 0 ),
							  CCRotateTo.actionWithDuration( asc * 0.05 , f * -60 ),
							  CCDelayTime.actionWithDuration( asc * 0.3 ),
							  CCRotateTo.actionWithDuration( asc * 0.05 , f * 0 ),
							  CCRotateTo.actionWithDuration( asc * 0.2 , f * 0 )  ) );
				
				foot2.onceS( CCSequence.actions( 
							  CCRotateTo.actionWithDuration( asc * 0.4 , f * 0 ),
							  CCRotateTo.actionWithDuration( asc * 0.05 , f * -40 ),
							  CCDelayTime.actionWithDuration( asc * 0.3 ),
							  CCRotateTo.actionWithDuration( asc * 0.05 , f * 0 ),
							  CCRotateTo.actionWithDuration( asc * 0.2 , f * 0 )  ) );

				actor.runAction( CCSequence.actions( 
									CCDelayTime.actionWithDuration( asc * 0.4 ), // TODO : Maybe transform the position with toCY( ).
									CCJumpTo.actionWithDuration( asc *0.4 , fm._enemyPosition.clone() , 20 * heightScale , 1 )  ) );
				break;
			
			case this.kAttackTypes.kAttackTypeSpecialMinion2Attack:
				arm1.onceS( CCSpawn.actions( 
							 	CCSequence.actions( 
										CCScaleTo.actionWithDuration( asc * 0.30 , 1.0 , 1.0 ),
										CCScaleTo.actionWithDuration( asc * 0.5 , 1.3 , 0.65 ),
										CCScaleTo.actionWithDuration( asc * 0.02 ,0.7 ,1.73 ),
										CCScaleTo.actionWithDuration( asc * 0.01 ,1.1 ,1.83 ),									
										CCScaleTo.actionWithDuration( asc * 0.01 ,0.7 ,1.73 ),
										CCScaleTo.actionWithDuration( asc * 0.03 ,1.25 ,1.0 ),
										CCScaleTo.actionWithDuration( asc * 0.03 ,0.9 ,1.21 ),
										CCScaleTo.actionWithDuration( asc * 0.1 ,1.0 ,1.0 )  ),
								CCSequence.actions( 
										CCRotateTo.actionWithDuration( asc *0.2 , f * 100 ),
										CCRotateTo.actionWithDuration( asc * 0.05 , f * 90 ),
										CCDelayTime.actionWithDuration( asc * 0.65 ),
										CCRotateTo.actionWithDuration( asc * 0.1 , f * 0 )  )  ) );
				
				arm2.onceS( CCSpawn.actions(
							 CCSequence.actions( 
										CCScaleTo.actionWithDuration( asc * 0.30 , 1.0 , 1.0 ),
										CCScaleTo.actionWithDuration( asc * 0.5 , 1.3 , 0.65 ),
										CCScaleTo.actionWithDuration( asc * 0.02 , 0.7 , 1.73 ),
										CCScaleTo.actionWithDuration( asc * 0.01 , 1.1 , 1.83 ),									
										CCScaleTo.actionWithDuration( asc * 0.01 , 0.7 , 1.73 ),
										CCScaleTo.actionWithDuration( asc * 0.03 , 1.25 , 1.0 ),
										CCScaleTo.actionWithDuration( asc * 0.03 , 0.9 , 1.21 ),
										CCScaleTo.actionWithDuration( asc * 0.1 , 1.0 , 1.0 )  ),
										
							 CCSequence.actions(
									  CCRotateTo.actionWithDuration( asc * 0.2 , f * 100 ),
									  CCRotateTo.actionWithDuration( asc * 0.05 , f * 90 ),
									  CCDelayTime.actionWithDuration( asc * 0.65 ),
									  CCRotateTo.actionWithDuration( asc * 0.1 , f * 0 )  )  ) );
				
				body.onceS( CCSequence.actions( 
							 CCRotateTo.actionWithDuration( asc * 0.15 , f * 10 ),
							 CCRotateTo.actionWithDuration( asc * 0.1 , f * -20 ),
							 CCDelayTime.actionWithDuration( asc * 0.65 ),
							 CCRotateTo.actionWithDuration( asc * 0.1 , f * 0 )  ) );
				
				head.onceS( CCSequence.actions( 
							 CCDelayTime.actionWithDuration( asc * 0.4 ),
							 CCRotateTo.actionWithDuration( asc * 0.4 , f * -10 ),
							 CCRotateTo.actionWithDuration( asc * 0.1 , f * 0 ),
							 CCRotateTo.actionWithDuration( asc * 0.1 , f * 0 )  ) );
				
				foot1.onceS( CCSequence.actions( 
								  CCDelayTime.actionWithDuration( asc * 0.85 ),
								  CCRotateTo.actionWithDuration( asc * 0.05 , f * -45 ),
								  CCRotateTo.actionWithDuration( asc * 0.10 , f * 0 )  ) );
				break;

			case this.kAttackTypes.kAttackTypeSpecialBossAttack:
				arm2.onceS( CCSequence.actions( new Array (
							 CCRotateTo.actionWithDuration( asc * 0.6 , f * 180 ),
							 CCRotateTo.actionWithDuration( asc * 0.2 , f * -90 ),
							 CCRotateTo.actionWithDuration( asc * 0.2 , f * 0 ) ) ) );
				
				arm1.onceS( CCSequence.actions(
							  CCDelayTime.actionWithDuration( asc * 0.6 ),
							  CCRotateTo.actionWithDuration( asc * 0.2 , f * -5 ),
							  CCRotateTo.actionWithDuration( asc * 0.2 , f * 0 )  ) );
				break;
			
			default:
				console.log( "ZFAttackAnims : Attack type not found.");
				//NSAssert(0,@"missing attck type");
				break;
		}
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/ActorAttachment'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/ActorAttachment'] || {}; $MODULE_REGISTRY['Code/Game/Actor/ActorAttachment'] = exports; var CCNode = require('Code/Cocos2D/CCNode').CCNode;
var CCRepeatForever = require('Code/Cocos2D/CCRepeatForever').CCRepeatForever;

exports.ActorAttachment = CCNode.subclass({
	classname : 'ActorAttachment',

	initialize : function() {
		this._sprite = null; // CCSprite*
		this._originalAnchor = null; // CGPoint
		this._offsetFromRefPoint = null; // CGPoint
		this._lastFramePosition = null; // CGPoint
		this._lastFrameScale = 0; // float
		this._atlasRect = null; // CGRect
		this._lastFrameRotation = 0; // float
		this._changeInRotation = 0; // float
		this._inheritColor = false; // BOOL
		this._followRotation = true; // BOOL, default is to follow rotation
		this._updated = false; // BOOL
		this._childAttachments = null; // NSMutableArray
		this._parentAttachment = null; // ActorAttachment*
		this._originalRotation = 0; // float
	},

	destroy : function() {
		this._originalAnchor = null;
		this._offsetFromRefPoint = null;
		this._lastFramePosition = null;
		this._atlasRect = null;

		if (this._childAttachments) {
			for ( var key in this._childAttachments) {
				destroyWithChildren(this._childAttachments[key]);
			}
			this._childAttachments.length = 0;
			this._childAttachments = null;
		}
		this._parentAttachment = null;
		
		if (this._sprite) {
			destroyWithChildren(this._sprite);
			this._sprite = null;
		}
	},

	loop : function(action) {
		this.runAction(CCRepeatForever.actionWithAction(action));
	},

	loopS : function(action) // id
	{
		this._sprite.runAction(CCRepeatForever.actionWithAction(action));
	},

	once : function(action) // id
	{
		this.runAction(action);
	},

	onceS : function(action) // id
	{
		this._sprite.runAction(action);
	},

	calculateRotateValue : function() {
		var rot = 0;
		if( this._followRotation ) {
			if( this._parentAttachment ) {
				rot = ( ( this._rotation - this._originalRotation ) + this._parentAttachment.calculateRotateValue() );
				 
			} else {
				rot = ( this._rotation - this._originalRotation);
			}
		} else {
			rot = ( this._rotation - this._originalRotation );		
		}
		return rot;
	},

	calculateBonePosition : function() {
		if (this._parentAttachment) {
			var pos = this._parentAttachment.calculateBonePosition();
			return {_x: this._ccPosition._x + pos._x, _y: this._ccPosition._y + pos._y};
		}

		return this._ccPosition;
	},

	flipBonePosition : function() {
	},

	rotateBone : function(angle, center, rotate) // float, CGPoint, rotateChildren:BOOL 
	{
		// note this isn't an action! this is for making attachment adjustments in update
		// sets the origin point to the center for the sake of sin,cos calculations
		// setting proper position for object:		
		// offset from refpoint is fixed ... therefore flip it when actor is flipped

		if (arguments.length == 2)
			rotate = false;

		var p = ccpF(this._offsetFromRefPoint._x - center._x, this._offsetFromRefPoint._y - center._y);
		var temp = ccpF(p._x,p._y);

		var rad = degreesToRadian(-angle);
		var cos = Math.cos(rad);
		var sin = Math.sin(rad);
		
		temp._x = p._x * cos - (p._y * sin);
		temp._y = p._x * sin + (p._y * cos);
		ccpAddF(temp, center);

		this._offsetFromRefPoint = temp;

		// setting proper rotation for object:
//		var childAttachments = this._childAttachments;
		if (this._childAttachments) {
			for (var index in this._childAttachments) {
				this._childAttachments[index].rotateBone(angle, center);
			}
		}
	},

	addBone : function(bone) {
		if (!this._childAttachments) {
			this._childAttachments = [];
		}

		bone._parentAttachment = this;
		this._childAttachments.push(bone);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/ActorFarmData'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/ActorFarmData'] || {}; $MODULE_REGISTRY['Code/Game/Actor/ActorFarmData'] = exports; exports.ActorFarmData = Core.Class.subclass({
    classname : 'ActorFarmData',
    
    initialize : function()
    {
        this._currentTile = new Core.Point(0, 0);
        this._destinationTile = new Core.Point(0, 0);
        this._myHomeTile = new Core.Point(-1, -1);
    },
    
    destroy : function()
    {
        this._currentTile = null;
        this._destinationTile = null;
        this._myHomeTile = null;
    },
    
    copyWithZone : function(zone)
    {
        var copy = new this.constructor();
        
        copy._currentTile = ccp(this._currentTile._x, this._currentTile._y);
        copy._destinationTile = ccp(this._destinationTile._x, this._destinationTile._y);
        copy._myHomeTile = ccp(this._myHomeTile._x, this._myHomeTile._y);
        
        return copy;
    },
    
    initWithCoder : function(coder)
    {
        this._currentTile = ccp(coder._currentTile._x, coder._currentTile._y);
        this._destinationTile = ccp(coder._destinationTile._x, coder._destinationTile._y);
        this._myHomeTile = ccp(coder._myHomeTile._x, coder._myHomeTile._y);
    },
    
    initWithData : function(data)
    {
        //		console.log(data);
        this._currentTile = ccp(data._currentTile._x, data._currentTile._y);
        this._destinationTile = ccp(data._destinationTile._x, data._destinationTile._y);
        this._myHomeTile = ccp(data._myHomeTile._x, data._myHomeTile._y);
    },
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/ActorHitBox'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/ActorHitBox'] || {}; $MODULE_REGISTRY['Code/Game/Actor/ActorHitBox'] = exports; exports.ActorHitBox = CCColorLayer.subclass({
    classname : 'ActorHitBox',
    
    initialize : function($super)
    {
    	$super();
        this.initWithColor(ccc4(0x00, 0xff, 0x00, 0x00), 32, 32);
        
        this._widthScale = UI.Window._height / 480;
        this._heightScale = this._widthScale;
        this._arrow = null;
        this._isTouchEnabled = true;
        this._active = true;
        this._offset = ccp(0, 0);
        this._actorSpecificOffset = ccp(0, 0);
        this._target = null;
        this._tapDelay = 1.0;
        this._attachedTo = null;
        
        if (!this.isScheduled(this.showWallHelperArrow))
        {
            this.schedule(this.showWallHelperArrow, 1.0, "showWallHelperArrow");
        }
    },
    
    destroy : function()
    {
        this._arrow = null;
        this._offset = null;
        this._actorSpecificOffset = null;
        this._target = null;
        this._attachedTo = null;
    },
    
    setAttachedTo : function(a)
    {
        this._offset = ccp(-this._contentSize._width / 2, -this._contentSize._height / 2);
        this._attachedTo = a;
    },
    
    setActive : function(value)
    {
        this._active = value;
        
        if (this._active)
        {
            if (!this.isScheduled(this.showWallHelperArrow))
            {
                this.schedule(this.showWallHelperArrow, 0.25, "showWallHelperArrow");
            }
        }
        else
        {
            if (this._arrow && this._arrow._parent)
            {
                this._arrow.removeFromParentAndCleanup(true);
                this._arrow = null;
            }
        }
    },
    
    initWithHitBoxSize : function(s)
    {
        this.changeWidth(s._width, s._height);
        
        return this;
    },
    
    cleanupHitBox : function()
    {
        //CCTouchDispatcher.sharedDispatcher().removeDelegate(this);
        
        this._attachedTo = null;
        
        if (this._parent)
        {
            this._parent.removeChild(this, true);
        }
        
        if (this._arrow && this._arrow._parent)
        {
            this.removeFromParentAndCleanup(true);
            true._arrow = null;
        }
        
        if (this.isScheduled(this.showWallHelperArrow))
        {
            this.unschedule(this.showWallHelperArrow);
        }
        
        this._active = false;
    },
    
    showWallHelperArrow : function(dt) // ccTime
    {
        this.unschedule(this.showWallHelperArrow);
        
        if (this._arrow || !this._active)
        {
            return;
        }
        
        this._arrow = CCSprite.spriteWithFile("tap1.png");
        this._arrow._opacity = 0xff;
        this._arrow._scale = 0.67 * this._widthScale;
        
        this._arrow._position = ccp(this._contentSize._width / 2, this._contentSize._height + (10 * this._heightScale));
        this.addChild(this._arrow, 0); // z = 0
        
        var sharedTextureCache = CCTextureCache.sharedTextureCache();
        var frame1 = CCSpriteFrame.frameWithTexture(sharedTextureCache.addImage("tap1.png"), CGRectMake(0, 0, 64, 64), ccp(0, 0));
        var frame2 = CCSpriteFrame.frameWithTexture(sharedTextureCache.addImage("tap2.png"), CGRectMake(0, 0, 64, 64), ccp(0, 0));
        // 3up 2down
        //CCSpriteFrame *frame1 = [CCSpriteFrame frameWithTexture:[[CCTextureCache sharedTextureCache] addImage:@"tap1.png"] rect:CGRectMake(0, 0, 64, 64) offset:CGPointZero];
        //CCSpriteFrame *frame2 = [CCSpriteFrame frameWithTexture:[[CCTextureCache sharedTextureCache] addImage:@"tap2.png"] rect:CGRectMake(0, 0, 64, 64) offset:CGPointZero];
        
        CCSpriteFrameCache.sharedSpriteFrameCache().addSpriteFrame(frame1, "tap1.png");
        CCSpriteFrameCache.sharedSpriteFrameCache().addSpriteFrame(frame2, "tap2.png");
        
        var frames = [ frame1, frame2, null ];
        
        var animMixed = CCAnimation.animationWithName_withDelay_withFrames("TapMe", 1, frames);
        var action1 = CCScaleTo.actionWithDuration_withScale(0.25, 1.2);
        
        this._arrow.runAction(CCRepeatForever.actionWithAction(CCSpawn.actions()));
        
        var act1 = CCAnimation.actionWithDuration(0.5, animMixed, false); // duration, animation, restoreOriginalFrame
        var act2 = CCFadeTo.actionWithDuration(0.25, 0xff); // duration, opacity
        var act3 = CCSequence.actions(act1, act2.reverse(), null);
        var spawn = CCSpawn.actions(act1, act2, act3, null);
        
        this._arrow.runAction(CCRepeatForever.actionWithAction(spawn));
    },
    
    registerWithTouchDispatcher : function()
    {
        CCTouchDispatcher.sharedDispatcher().addTargetedDelegate(this, 0, false); // Delegate, Priority, swallowsTouches
    },
    
    ccTouchBegan : function(touch, event) // UITouch*, UIEvent*
    {
        var pos = touch.locationInView(touch._view);
        pos = CCDirector.sharedDirector.convertToGL(pos);
        var nodePos = this.convertToNodeSpace(pos);
        var rect = CGRectMake(0, 0, this._contentSize._width, this._contentSize._height);
        
        if (rectContainsPoint(rect, nodePos))
        {
            return true;
        }
        
        return true;
    },
    
    ccTouchEnded : function(touch, event) // 
    {
        var pos = touch.locationInView(touch._view);
        pos = CCDirector.convertToGL(pos);
        var rect = CGRectMake(0, 0, this._contentSize._width, this._contentSize._height);
        var nodePos = this.convertToNodeSpace(pos);
        
        if (rectContainsPoint(rect, nodePos) && this._active)
        {
            if (this._arrow)
            {
                this.removeChild(this._arrow, true);
                this._arrow = null;
            }
            
            // TODO : Not sure about function pointer.
            if (this.isScheduled(this.showWallHelperArrow))
            {
                this.unschedule(this.showWallHelperArrow);
            }
            
            this.schedule(this.showWallHelperArrow, this._tapDelay, "showWallHelperArrow");
            
            if (this._target)
            {
                this._target.performSelector(this.hitBoxTouched);
            }
        }
    },
    
    updatePosition : function()
    {
    },
    
    showWallHelperArrow : function(dt) // ccTime
    {
    },
    
    updatePosition : function()
    {
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/MainMenu/OptionsMenu'] = function(){var exports = $MODULE_REGISTRY['Code/MainMenu/OptionsMenu'] || {}; $MODULE_REGISTRY['Code/MainMenu/OptionsMenu'] = exports; var MenuButton = require('Code/MainMenu/Classes/MenuButton').MenuButton;
var UISlider = require('Code/MainMenu/Classes/UISlider').UISlider;

// NOTE:
// I've split OptionsMenu to logic part and View part (Model-View ;-) )
// OptionsMenu is a singleton, so View can use it, and OptionsMenu can use View (OptionsMenu._view) 
//
// I've decided to stay with 480x320 dimension, there are two frame PNGs for it for iPhone/iPad resolution in other cases there are stretched
// however it should be easy to use other images

var OptionsMenuView = Core.Class.subclass({
    //enum
    //{
    //	kTagAlertUnknown,
    //	kTagAlertRelaunchApp = 50,
    //};

    classname : 'OptionsMenuView',
    
    destroy : function()
    {
        this._soundLabel.destroy();
        this._muteLabel.destroy();
        this._muteSwitch.destroy();
        this._musicLabel.destroy();
        this._musicSlider.destroy();
        this._effectsLabel.destroy();
        this._effectsSlider.destroy();
        this._notificationsLabel.destroy();
        this._harvestNotificationsLabel.destroy();
        this._witherNotificationsLabel.destroy();
        this._witherNotificationSwitch.destroy();
        this._invasionNotificationsLabel.destroy();
        this._invasionNotificationSwitch.destroy();
        /* FIXME: Remote market 
        this._otherLabel.destroy();
        */
        
        /* FIXME: Flurry
        this._dailyOfferLabel.destroy();
        this._dailyOfferSwitch.destroy();*/
        
        /* FIXME: Screenshot Manager
        this._autoScreenshotLabel.destroy();
        this._autoScreenshotSwitch.destroy();
        */
        /* FIXME: Day and night
        this._dayAndNightLabel.destroy();
        this._dayAndNightSwitch.destroy();
        */
        
        /* FIXME: Remote market
        this._remoteMarketLabel.destroy();
        this._remoteMarketSwitch.destroy();
        */
        
        this._aboutButton.destroy();
        /* FIXME: Game center
        this._gameCenterIDLabel.destroy();*/
        this._backButton.destroy();
        this._connectLabel.destroy();
        this._onlineSavingSwitch.destroy();
        this._onlineSavingLabel.destroy();
        
        /* FIXME: Facebook API
        this._facebookLabel.destroy();
        this._facebookSwitch.destroy();
        */
        
        this._slistener.destroy();
        this._scrollBody.destroy();
        this._backButton.destroy();
        this._backgroundFrameImage.destroy();
        this._Root.destroy();
    },
    
    // FIXME: Decelerate scrolling
    onScrollTouch : function(touch)
    {
        this._size = new Core.Size(this._resolutionWidth, this._resolutionHeight);
        switch (touch.getAction())
        {
            case touch.Action.Start:
                this._startPos = touch.getPosition();
                return true;
            case touch.Action.End:
                this._startPos = ccp(-1, -1);
                break;
            case touch.Action.Move:
                var yMove = this._startPos._y - touch.getPosition()._y;
                var newPos = ccp(this.getPosition()._x, this.getPosition()._y - yMove);
                
                //FIXME:Adapt this number
                // Check borders
                if (newPos._y > 80)
                {
                    newPos = ccp(newPos._x, 80);
                }
                
//                if (this._size._height + newPos._y < 300)
                if (newPos._y < 38)
                {
                    newPos = ccp(newPos._x, 38);
//                    newPos = ccp(newPos._x, -(this._size._height - 300));
                }
                
                this.setPosition(newPos);
                
                // Refresh
                this._startPos = touch.getPosition();
                break;
            default:
                break;
        }
        
        return true;
    },
    
    initialize : function()
    {
	    /* FIXME: Facebook API
        NSNotificationCenter.defaultCenter().addObserver(this, this.initFacebookElements.bind(this), kNetConnectivityUpdatedNotification , null);*/
        
        this._Root = new GL2.Node();
        
        this._widthScale = 1;//UI.Window._width / 480.0; 
        this._heightScale = 1;//UI.Window._height / 320.0;
        
        this._resolutionWidth = 480;//UI.Window._width;
        this._resolutionHeight = 320;// UI.Window._height;
        
        var xOffset = (UI.Window._width - 480-40) / 2;
        var yOffset = (UI.Window._height - (320+80)) / 2;
        this._Root.setPosition(ccp(xOffset, yOffset));
        
        
        var backgroundFrameImageURL = "";
        // Load the background image
//      if (this._widthScale>1)
//      {
//          backgroundFrameImageURL = "./Content/OptionsMenuBorderLong.png";
//      }
//      else
//      {
            backgroundFrameImageURL = "./Content/OptionsMenuBorder.png";
//      }
        
        // The font color for the property labels
        var labelColor = ccc4(255, 255, 255, 255);
        var headerBGColor = ccc4(47, 47, 77, 255);
        var bodyBGColor = ccc4(30, 30, 60, 255);
        
        var buttonImageNormal = "./Content/checkboxFilled.png";
        
        // Some positional variables
        
        var imageSize = 35.0;
        var topOffset = 65.0;
        var rowPad = ((imageSize + 4.0) / 2);
        
        var labelFrame = CGRectMake(20.0, topOffset, 280, 23);
        var categoryFrame = CGRectMake(0.0, topOffset, 480, 23);
        var switchFrame = CGRectMake(321.0, topOffset - 6, imageSize, imageSize);
        
        var rowOffset = 0.0;
        
        // The label font
        var labelFont = "Arial-BoldMT";
        var labelSize = 17;
        
        this._backgroundFrameImage = new GL2.Sprite();
        this._backgroundFrameImage.setDepth(3);
        this._backgroundFrameImage.setImage(backgroundFrameImageURL, [ this._resolutionWidth, this._resolutionHeight ], [ 0, 0 ])._animation.setFilteringEnabled(false);
        
        this._Root.addChild(this._backgroundFrameImage);
        
        var scrollBgColor = new Core.Color(30.0 / 255.0, 30.0 / 255.0, 60.0 / 255.0);
        
        this._backgroundLayer = CCColorLayer.layerWithColor(scrollBgColor, UI.Window._width, UI.Window._height);
        this._backgroundLayer.setPosition(ccp(-xOffset, yOffset - UI.Window._height / 2));
        this._Root.addChild(this._backgroundLayer);
        this._backgroundLayer.setDepth(1);
        
        //Color layer for simulating clipping (ScrollView)
        if (UI.Window._height > 320)
        {
            this._topColorLayer = CCColorLayer.layerWithColor(scrollBgColor, 480, yOffset);
            this._bottomColorLayer = CCColorLayer.layerWithColor(scrollBgColor, 480, yOffset);
            
            this._topColorLayer.setDepth(10);
            this._bottomColorLayer.setDepth(10);
            
            this._topColorLayer.setPosition(ccp(0, yOffset * 0.5));
            this._bottomColorLayer.setPosition(ccp(0, -320 - yOffset * 0.5));
            
            this._Root.addChild(this._topColorLayer);
            this._Root.addChild(this._bottomColorLayer);
        }
        
        // The font color for the property labels
        var labelColor = new Core.Color(1, 1, 1);
        var headerBGColor = new Core.Color(47 / 255, 47 / 255, 77 / 255);
        
        // The button image
        var buttonImageNormal = "./Content/checkboxFilled.png";
        
        // Some positional variables
        var imageSize = 35.0;
        var topOffset = 65.0;
        var rowPad = ((imageSize + 4.0) / 2);
        
        var labelFrame = new Core.Rect(20.0, topOffset, 280.0, 23.0);
        var categoryFrame = new Core.Rect(0.0, topOffset, 480.0, 23.0);
        var switchFrame = new Core.Rect(321.0, topOffset - 6.0, imageSize, imageSize);
        
        var rowOffset = 0.0;
        
        this._scrollTouch = new GL2.TouchTarget();
        this._scrollTouch.setSize(new Core.Size(480, 320));
        this._scrollTouch.setDepth(-1);
        this._scrollTouch.setAnchor(ccp(0, 0));
        
        this._scrollBody = new GL2.Node();
        this._scrollBody.setPosition(ccp(0, 65));
        this._scrollBody.setDepth(2);
        this._Root.addChild(this._scrollBody);
        
        // Scroll touch listener
        this._slistener = new Core.MessageListener();
        this._scrollTouch.getTouchEmitter().addListener(this._slistener, this.onScrollTouch.bind(this._scrollBody));
        this._Root.addChild(this._scrollTouch);
        
        // The connectivity label
        this._connectLabel = CCLabel.labelWithString("CONNECTION", new Core.Size(480, 23), GL2.Text.HorizontalAlign.Center, labelSize);
        this._connectLabel._label.setPosition(ccp(240, 0));
        this._connectLabel.setAnchorPoint(ccp(0.5, 0.5));
        this._connectLabel.setColor(labelColor);
        this._connectLabel.setBackgroundColor(headerBGColor);
        this._connectLabel.setShadowColor(ccc4(255, 255, 255, 128));
        this._connectLabel.setShadowOffset(ccp(3, 2));
        
        //FIXME: Implement AutoSave
        /*
        this._scrollBody.addChild(this._connectLabel);
        
        // Increment the rowOffset
        rowOffset++;
        rowOffset++;
        */
        
//	    // The online saving label
        //if ([GameCenterManager isGameCenterAvailable])
        {
            this._onlineSavingLabel = CCLabel.labelWithString(NSLocalizedString("Enable Online Saving"), new Core.Size(280, 23), GL2.Text.HorizontalAlign.Right, labelFont, labelSize);
            
            // Smaller font for Japanese version
            //TODO: onlineSavingLabel.setLabelSize(14) or sth ;->
            //if ([[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"ja"])
            //{
            //  onlineSavingLabel.font = [UIFont fontWithName:@"Arial-BoldMT" size:14];
            //}
            
            this._onlineSavingLabel.setColor(labelColor);
            this._onlineSavingLabel.setPosition(ccp(140, -(rowPad * rowOffset) - 6));
            
          //FIXME: Implement AutoSave
            /*this._scrollBody.addChild(this._onlineSavingLabel);
            */
            // The online saving switch   	
            this._onlineSavingSwitch = new MenuButton(ccp(321, (rowPad * rowOffset) - 6), new Core.Size(32, 36), buttonImageNormal, OptionsMenu.onlineSavingToggled.bind(OptionsMenu));
            /*
            this._scrollBody.addChild(this._onlineSavingSwitch.getNode());
            
            //Increment the rowOffset
            rowOffset++;
            rowOffset++;*/
        }
        //else
        //  onlineSavingSwitch = nil;
        
        /* TODO: Facebook API
        // The Facebook label
        this._facebookLabel = CCLabel.labelWithString(NSLocalizedString("Enable Facebook"), new Core.Size(280, 23), GL2.Text.HorizontalAlign.Right, labelFont, labelSize);
        this._facebookLabel.setColor(labelColor);
        this._facebookLabel.setPosition(ccp(140, -(rowPad * rowOffset) - 6));
        
        // Add it to the scroll view
        this._scrollBody.addChild(this._facebookLabel);
        
        // The Facebook switch
        this._facebookSwitch = new MenuButton(ccp(321, (rowPad * rowOffset) - 6), new Core.Size(32, 36), buttonImageNormal, OptionsMenu.facebookSwitchToggled.bind(OptionsMenu));
        
        // Add it to the scroll view
        this._scrollBody.addChild(this._facebookSwitch.getNode());
        
        //space for facebook stuff
        rowOffset++;
        rowOffset++;
        rowOffset++;
        
        // Increment the rowOffset
        rowOffset++;
        rowOffset++;*/
        rowOffset++;
        
        // The sound notifications label
        this._soundLabel = CCLabel.labelWithString("SOUND", new Core.Size(480, 23), GL2.Text.HorizontalAlign.Center, labelSize);
        this._soundLabel._label.setPosition(ccp(240, 0));
        this._soundLabel.setAnchorPoint(ccp(0.5, 0.5));
        this._soundLabel.setColor(labelColor);
        this._soundLabel.setBackgroundColor(headerBGColor);
        this._soundLabel.setShadowColor(ccc4(0, 0, 0, 128));
        this._soundLabel.setShadowOffset(ccp(3, 2));
        this._soundLabel.setPosition(ccp(0, -(rowPad * rowOffset) - 6));
        this._scrollBody.addChild(this._soundLabel);
        
        // Increment the rowOffset
        rowOffset++;
        rowOffset++;
        
        // The mute label
        this._muteLabel = CCLabel.labelWithString(NSLocalizedString("Enable Sound"), new Core.Size(280, 23), GL2.Text.HorizontalAlign.Right, labelFont, labelSize);
        this._muteLabel.setColor(labelColor);
        this._muteLabel.setPosition(ccp(140, -(rowPad * rowOffset) - 6));
        this._scrollBody.addChild(this._muteLabel);
        
        // The mute switch
        this._muteSwitch = new MenuButton(ccp(321, (rowPad * rowOffset) - 6), new Core.Size(32, 36), buttonImageNormal, OptionsMenu.muteSwitchToggled.bind(OptionsMenu));
        
        // Add it to the scroll view
        this._scrollBody.addChild(this._muteSwitch.getNode());
        
        // Increment the rowOffset
        rowOffset++;
        rowOffset++;
        
	    // The music label
        this._musicLabel = CCLabel.labelWithString(NSLocalizedString("Music"), new Core.Size(118, 23), GL2.Text.HorizontalAlign.Right, labelFont, labelSize);
        this._musicLabel.setColor(labelColor);
        this._musicLabel.setPosition(ccp(87, -(rowPad * rowOffset) - 6));
        this._scrollBody.addChild(this._musicLabel);
        
        var defaults = NSUserDefaults.standardUserDefaults();
        
        // The music slider
        
        var musicVolume = Number(defaults.objectForKey(ZFGameDefines.kUserDefaultID_audioBGMVol));
        if (!musicVolume)
        {
            musicVolume = SimpleAudioEngine._musicVolume;
        }
        
        this._musicSlider = new UISlider(ccp(215, rowPad * rowOffset), new Core.Size(130, 30));
        this._musicSlider.setValue(musicVolume);
        this._musicSlider.addTarget(this, OptionsMenu.musicSliderTouchUp.bind(OptionsMenu), "UIControlEventTouchUpInside");
//        this._musicSlider.addTarget(this, OptionsMenu.musicSliderChanged.bind(OptionsMenu), "UIControlEventValueChanged");
        this._scrollBody.addChild(this._musicSlider);
        
        // Increment the rowOffset
        rowOffset++;
        rowOffset++;
        rowOffset++;
        
	    // Sound effects label
        this._effectsLabel = CCLabel.labelWithString(NSLocalizedString("Sound FX"), new Core.Size(118, 23), GL2.Text.HorizontalAlign.Right, labelFont, labelSize);
        this._effectsLabel.setColor(labelColor);
        this._effectsLabel.setPosition(ccp(87, -(rowPad * rowOffset) - 6));
        
        var effectsVolume = Number(defaults.objectForKey(ZFGameDefines.kUserDefaultID_audioSFXVol));
        if (!effectsVolume)
        {
            effectsVolume = SimpleAudioEngine._effectsVolume;
        }
        
        this._scrollBody.addChild(this._effectsLabel);
        
	    // Sound effects slider
        this._effectsSlider = new UISlider(ccp(215, rowPad * rowOffset), new Core.Size(130, 30));
        this._effectsSlider.setValue(effectsVolume);
        this._effectsSlider.addTarget(this, OptionsMenu.effectsSliderTouchUp.bind(OptionsMenu), "UIControlEventTouchUpInside");
//        this._effectsSlider.addTarget(this, OptionsMenu.effectsSliderChanged.bind(OptionsMenu), "UIControlEventValueChanged");
        this._scrollBody.addChild(this._effectsSlider);
               
 
//        var mute = SimpleAudioEngine._mute;
//        this._musicSlider.setEnabled(!mute);
//        this._effectsSlider.setEnabled(!mute);
        
        
        // Increment the rowOffset
        rowOffset++;
        rowOffset++;
        rowOffset++;
        
        // Notifications title label
        this._notificationsLabel = CCLabel.labelWithString("NOTIFICATIONS", new Core.Size(480, 23), GL2.Text.HorizontalAlign.Center, labelSize);
        this._notificationsLabel._label.setPosition(ccp(240, 0));
        this._notificationsLabel.setAnchorPoint(ccp(0.5, 0.5));
        this._notificationsLabel.setColor(labelColor);
        this._notificationsLabel.setBackgroundColor(headerBGColor);
        this._notificationsLabel.setShadowColor(ccc4(0, 0, 0, 128));
        this._notificationsLabel.setShadowOffset(ccp(3, 2));
        this._notificationsLabel.setPosition(ccp(0, -(rowPad * rowOffset) - 6));
        
        //FIXME: Implement Notifications
        /*
        this._scrollBody.addChild(this._notificationsLabel);
        
        rowOffset++;
        rowOffset++;
        */
        this._harvestNotificationsLabel = CCLabel.labelWithString(NSLocalizedString("Harvest Notifications"), new Core.Size(280, 23), GL2.Text.HorizontalAlign.Right, labelFont, labelSize);
        this._harvestNotificationsLabel.setColor(labelColor);
        this._harvestNotificationsLabel.setPosition(ccp(140, -(rowPad * rowOffset) - 6));
      //FIXME: Implement Notifications
        /*
        this._scrollBody.addChild(this._harvestNotificationsLabel);
        */
        this._harvestNotificationSwitch = new MenuButton(ccp(321, (rowPad * rowOffset) - 6), new Core.Size(32, 36), buttonImageNormal, OptionsMenu.harvestNotificationToggled.bind(OptionsMenu));
        
      //FIXME: Implement Notifications
        /*
        this._scrollBody.addChild(this._harvestNotificationSwitch.getNode());
        
        // Increment the rowOffset
        rowOffset++;
        rowOffset++;
        */
        
        this._witherNotificationsLabel = CCLabel.labelWithString(NSLocalizedString("Wither Warning Notifications"), new Core.Size(280, 23), GL2.Text.HorizontalAlign.Right, labelFont, labelSize);
        this._witherNotificationsLabel.setColor(labelColor);
        this._witherNotificationsLabel.setPosition(ccp(140, -(rowPad * rowOffset) - 6));
        
      //FIXME: Implement Notifications
        /*
        this._scrollBody.addChild(this._witherNotificationsLabel);
        */
        this._witherNotificationSwitch = new MenuButton(ccp(321, (rowPad * rowOffset) - 6), new Core.Size(32, 36), buttonImageNormal, OptionsMenu.witherNotificationToggled.bind(OptionsMenu));
        
      //FIXME: Implement Notifications
        /*
        this._scrollBody.addChild(this._witherNotificationSwitch.getNode());
        
        // Increment the rowOffset
        rowOffset++;
        rowOffset++;
        */
        this._invasionNotificationsLabel = CCLabel.labelWithString(NSLocalizedString("Invasion Ready Notifications"), new Core.Size(280, 23), GL2.Text.HorizontalAlign.Right, labelFont, labelSize);
        this._invasionNotificationsLabel.setColor(labelColor);
        this._invasionNotificationsLabel.setPosition(ccp(140, -(rowPad * rowOffset) - 6));
        
      //FIXME: Implement Notifications
        /*
        this._scrollBody.addChild(this._invasionNotificationsLabel);
        */
        this._invasionNotificationSwitch = new MenuButton(ccp(321, (rowPad * rowOffset) - 6), new Core.Size(32, 36), buttonImageNormal, OptionsMenu.invasionNotificationToggled.bind(OptionsMenu));
        
      //FIXME: Implement Notifications
        /*
        this._scrollBody.addChild(this._invasionNotificationSwitch.getNode());
        
        // Increment the rowOffset
        rowOffset++;
        rowOffset++;
        rowOffset++;
        */
        
        /* FIXME: Remote market
        // The other label
        this._otherLabel = CCLabel.labelWithString("OTHER", new Core.Size(480, 23), GL2.Text.HorizontalAlign.Center, labelSize);
        this._otherLabel._label.setPosition(ccp(240, 0));
        this._otherLabel.setAnchorPoint(ccp(0.5, 0.5));
        this._otherLabel.setColor(labelColor);
        this._otherLabel.setBackgroundColor(headerBGColor);
        this._otherLabel.setShadowColor(ccc4(0, 0, 0, 128));
        this._otherLabel.setShadowOffset(ccp(3, 2));
        this._otherLabel.setPosition(ccp(0, -(rowPad * rowOffset) - 6));
        this._scrollBody.addChild(this._otherLabel);
        
        // Increment the rowOffset
        rowOffset++;
        rowOffset++;*/
        
        /* FIXME: Flurry offers
//	    //check for flurry rewards
//	    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
//		NSNumber *isDailyDalesOfferAllowed = (NSNumber*)[defaults objectForKey:ZFAllowDailySalesOffer];
        
//	    if (isDailyDalesOfferAllowed && [isDailyDalesOfferAllowed boolValue] == YES)
//      {
            this._dailyOfferLabel = CCLabel.labelWithString(NSLocalizedString("Daily Bonus Offers"), new Core.Size(280, 23), GL2.Text.HorizontalAlign.Right, labelFont, labelSize);
            this._dailyOfferLabel.setColor(labelColor);
            this._dailyOfferLabel.setPosition(ccp(140, -(rowPad * rowOffset) - 6));
            this._scrollBody.addChild(this._dailyOfferLabel);
            
//	        // Smaller font for Japanese version
//	        if ([[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"ja"])
//	            dailyOfferLabel.font = [UIFont fontWithName:@"Arial-BoldMT" size:16];
//	        else
//	            dailyOfferLabel.font = labelFont;

            this._dailyOfferSwitch = new MenuButton(ccp(321, (rowPad * rowOffset) - 6), new Core.Size(32, 36), buttonImageNormal, OptionsMenu.dailyOffersToggled.bind(OptionsMenu));
            this._scrollBody.addChild(this._dailyOfferSwitch.getNode());
            
            // Increment the rowOffset
            rowOffset++;
            rowOffset++;
//      }
        */
        
        /* FIXME: Screenshot Manager
        this._autoScreenshotLabel = CCLabel.labelWithString(NSLocalizedString("Photo on Level-Up"), new Core.Size(280, 23), GL2.Text.HorizontalAlign.Right, labelFont, labelSize);
        this._autoScreenshotLabel.setColor(labelColor);
        this._autoScreenshotLabel.setPosition(ccp(140, -(rowPad * rowOffset) - 6));
        this._scrollBody.addChild(this._autoScreenshotLabel);
        
        this._autoScreenshotSwitch = new MenuButton(ccp(321, (rowPad * rowOffset) - 6), new Core.Size(32, 36), buttonImageNormal, OptionsMenu.autoScreenshotSwitchToggled.bind(OptionsMenu));
        this._scrollBody.addChild(this._autoScreenshotSwitch.getNode());
        
        // Increment the rowOffset
        rowOffset++;
        rowOffset++;*/
        
        /* FIXME: Day and night
        this._dayAndNightLabel = CCLabel.labelWithString(NSLocalizedString("Day & Night"), new Core.Size(280, 23), GL2.Text.HorizontalAlign.Right, labelFont, labelSize);
        this._dayAndNightLabel.setColor(labelColor);
        this._dayAndNightLabel.setPosition(ccp(140, -(rowPad * rowOffset) - 6));
        this._scrollBody.addChild(this._dayAndNightLabel);
        
        this._dayAndNightSwitch = new MenuButton(ccp(321, (rowPad * rowOffset) - 6), new Core.Size(32, 36), buttonImageNormal, OptionsMenu.dayAndNightToggled.bind(OptionsMenu));
        this._scrollBody.addChild(this._dayAndNightSwitch.getNode());
        
        // Increment the rowOffset
        rowOffset++;
        rowOffset++; */
        
        //#ifndef ZF_SUBMISSION
        
        /* FIXME: Remote market
	    // The remote market label
        this._remoteMarketLabel = CCLabel.labelWithString(NSLocalizedString("Reload Remote Data"), new Core.Size(280, 23), GL2.Text.HorizontalAlign.Right, labelFont, labelSize);
        this._remoteMarketLabel.setColor(labelColor);
        this._remoteMarketLabel.setPosition(ccp(140, -(rowPad * rowOffset) - 6));
        this._scrollBody.addChild(this._remoteMarketLabel);
        
        this._remoteMarketSwitch = new MenuButton(ccp(321, (rowPad * rowOffset) - 6), new Core.Size(32, 36), buttonImageNormal, OptionsMenu.getRemoteMarketTapped.bind(OptionsMenu));
        this._scrollBody.addChild(this._remoteMarketSwitch.getNode());
        
        // Increment the rowOffset
        rowOffset++;
        rowOffset++;*/
        //#endif
        
      //FIXME: Implement Notifications
        /*
        rowOffset++;
        */
        
	    // About button background image
        this._aboutButton = new MenuButton(ccp(210, (rowPad * rowOffset)), new Core.Size(60, 40), "./Content/blankButton.png", OptionsMenu.aboutTapped.bind(OptionsMenu));
        this._aboutButton.setText(NSLocalizedString("About"));
        this._aboutButton.setFontColor(ccc3(0, 0, 0));
        this._aboutButton.setFontSize(13);
        
      //FIXME: Implement Notifications
        /*
        this._scrollBody.addChild(this._aboutButton.getNode());
        
        // Increment the rowOffset
        rowOffset++;
        rowOffset++;
        rowOffset++;
        */
        
        
        /* FIXME: Game center
	    // The Game Center ID label
        this._gameCenterIDLabel = CCLabel.labelWithString(NSLocalizedString("G1133673658"), new Core.Size(480, 23), GL2.Text.HorizontalAlign.Center, "Arial", 10);
        this._gameCenterIDLabel.setColor(ccc4(255, 255, 255, 255 * 0.33));
        this._gameCenterIDLabel.setPosition(ccp(240, -(rowPad * rowOffset) - 6));
        this._scrollBody.addChild(this._gameCenterIDLabel);
        this._scrollBody._size = new Core.Size(480, (rowPad * rowOffset) + 15);*/

        // Back button background image
        var backButtonPosition = new Core.Vector(480 - 63, 1);
        var buttonSize = new Core.Size(60, 40);
        if (this._widthScale > 1)
        {
            backButtonPosition = new Core.Vector(272 + (480 - 63), 1);
        }
        
        this._backButton = new MenuButton(backButtonPosition, buttonSize, "./Content/backButton.png", OptionsMenu.Close.bind(OptionsMenu));
        this._backButton.setDepth(3);
        
        this._Root.addChild(this._backButton.getNode());
        
        this._messageBackground = CCColorLayer.layerWithColor(ccc4(0, 0, 0, 255 * 0.66), 480, 42);
        this._messageBackground.setVisible(false);
        this._messageBackground.setPosition(ccp(0, -128 - 42));
        this._messageBackground.setDepth(9);
        this._Root.addChild(this._messageBackground);
        
        //FIXME:  
	    // Build the activity indicator
//	    messageActivityIndicator = [[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleWhite];
//	    messageActivityIndicator.frame = CGRectMake(127.0f, 11.0f, 20.0f, 20.0f);
//	    [messageActivityIndicator startAnimating];
    
	    // Add it to the message view
//	    [messageView addSubview:messageActivityIndicator];
        
        this._messageLabel = CCLabel.labelWithString(NSLocalizedString("Downloading user data..."), new Core.Size(401, 50), GL2.Text.HorizontalAlign.Center, "Arial", 17);
        this._messageLabel.setColor(ccc3(255, 255, 255));
        this._messageBackground.addChild(this._messageLabel);
        this._messageLabel.setPosition(ccp(200, 0));
        
	    // Add the cancel button
//	    CGRect messageButtonFrame = CGRectMake(408.0, 72.0f, 40.0f, 20.f);
//	    messageCancelButton = [[UIButton alloc] initWithFrame:messageButtonFrame];
//	    [messageCancelButton addTarget:self action:@selector(messageViewCancelTapped) forControlEvents:UIControlEventTouchUpInside];
    
	    // Add the image for the cancel button
//	    UIImageView *cancelImage = [[UIImageView alloc]initWithImage:[UIImage imageNamed:@"smallX.png"]];
    
	    // Grab the size of the image
//	    float cancelImageWidth = cancelImage.frame.size.width;
//	    float cancelImageHeight = cancelImage.frame.size.height;
    
//	    cancelImage.frame = CGRectMake(messageButtonFrame.size.width / 2.0f - cancelImageWidth / 2.0f, messageButtonFrame.size.height / 2.0f - cancelImageHeight / 2.0f, cancelImageWidth, cancelImageHeight);
    
	    // Add the logo to the main view
//	    [messageCancelButton addSubview:cancelImage];
    
	    // Add the cancel button to the message view
//	    [messageView addSubview:messageCancelButton];
    
	    // Add the whole message view to the options menu
//	    [self.view addSubview:messageView];	    
        
        //this.initFacebookElements();
    },
    
    getNode : function()
    {
        return this._Root;
    }
    
    /* FIXME: Facebook API
    initFacebookElements : function()
    {
		FBMan *fb = [FBMan fbman];
		//CGSize w = [[CCDirector sharedDirector] winSize];
	
		//if (fb.useFaceBook && [fb connectedToInternet])
		{
			if(!fbImgView)
			{
				fbImgView = [[UIImageView alloc] initWithFrame:CGRectMake((240.f - 45.f - 25.f), 180.0f, 50.0f, 50.0f)];
				fbImgView.hidden = YES;
				[scrollView addSubview:fbImgView];
			}
			
			if(!fbUserNameLabel)
			{
				fbUserNameLabel = [[UILabel alloc] initWithFrame:CGRectMake((240.f - 45.f + 52.f - 25.f), (180.0f + 32.f), 200.0f, 20.0f)];
				fbUserNameLabel.textAlignment = UITextAlignmentLeft;
				fbUserNameLabel.font = [UIFont boldSystemFontOfSize:12];
				fbUserNameLabel.textColor = [UIColor whiteColor];
				fbUserNameLabel.backgroundColor = [UIColor clearColor];
				fbUserNameLabel.hidden = YES;
	            [scrollView addSubview:fbUserNameLabel];
			}
			
			if (!zffbLoginButton)
			{
				zffbLoginButton = [FBMan fbman].zffbLoginButton;
				zffbLoginButton.frame = CGRectMake((240.f - 45.f), 180.0f, 90.0f, 31.0f);
	            [scrollView addSubview:zffbLoginButton];
				[[NSNotificationCenter defaultCenter] addObserver:self
														 selector:@selector(fBUserLoggedIn:)
															 name:@"FBUserLoggedIn" 
														   object:nil];
				
				[[NSNotificationCenter defaultCenter] addObserver:self
														 selector:@selector(fBUserLoggedOut:)
															 name:@"FBUserLoggedOut" 
														   object:nil];
				[fb resume];
			}
		}
//		else
//		{
//			[self removeFacebookElements];
//		}
    
	    if (!fb.useFaceBook || ![fb connectedToInternet])
	    {
	        zffbLoginButton.enabled = NO;
	        zffbLoginButton.alpha = .25f;
	    }
	    else
	    {
	        zffbLoginButton.enabled = YES;
	        zffbLoginButton.alpha = 1.f;
	    }
    
    }*/
});

exports.OptionsMenu = Core.Class.singleton({
    classname : 'OptionsMenu',
    
    initialize : function()
    {
        OptionsMenu._view = null;
    },
    
    Show : function()
    {
        //console.log(this);
        OptionsMenu._view = new OptionsMenuView();
        var viewNode = OptionsMenu._view.getNode();
        viewNode.setScale(1.2,1.2);
        GL2.Root.addChild(viewNode);
        this.updateButtons();
    },
    
    Close : function()
    {
	    if (!this.isSFXOff())
	    {
	        SimpleAudioEngine.playEffect(kMenuClick);
	    }
    
	    NSNotificationCenter.defaultCenter().removeObserver(this);
	    NSNotificationCenter.defaultCenter().postNotificationName(ZFGameDefines.kReturnedFromOptionsNotification, null);
        
        destroyWithChildren(OptionsMenu._view.getNode());
        OptionsMenu._view = null;
    },
    
    buttonToggledWithDefaultsID : function(defaultsID)
    { 
        if (!this.isSFXOff())
        {
            SimpleAudioEngine.playEffect(kMenuClick);
        }
        
        var defaults = NSUserDefaults.standardUserDefaults();
        var buttonEnabled = defaults.objectForKey(defaultsID);
        var buttonEnabledVal = !(buttonEnabled);
        defaults.setObject(buttonEnabledVal, defaultsID);
        this.updateButtons();
        
        return buttonEnabledVal;
    },
    
    updateButtons : function()
    {
        //var gs = GameState;
        var defaults = NSUserDefaults.standardUserDefaults();
        
        var muted = defaults.objectForKey(ZFGameDefines.kUserDefaultID_audioMute);
        
        /* FIXME: Flurry offers
        var flurryOffersEnabled = defaults.objectForKey(ZFGameDefines.kUserDefaultID_flurryOffersEnabled);*/
        var harvestNotificationsEnabled = defaults.objectForKey(ZFGameDefines.ZFHarvestNotificationsEnabled);
        var witherNotificationsEnabled = defaults.objectForKey(ZFGameDefines.ZFWitherNotificationsEnabled);
        var invasionNotificationsEnabled = defaults.objectForKey(ZFGameDefines.ZFInvasionNotificationsEnabled);
        var onlineSavingEnabled = defaults.objectForKey(ZFGameDefines.ZFOnlineSavingEnabled);
        
        /* FIXME: Day and night
        var dayAndNightEnabled = defaults.objectForKey(ZFGameDefines.ZFDayAndNightEnabled);*/
        
        /* FIXME: Flurry offers
        if (!flurryOffersEnabled)
        {
//			flurryOffersEnabled = [NSNumber numberWithBool:!gs.zfGameData.isPayingUser];
//			[defaults setObject:flurryOffersEnabled forKey:ZFGameDefines.kUserDefaultID_flurryOffersEnabled];
        }*/
        
        if (harvestNotificationsEnabled == undefined)
        {
			harvestNotificationsEnabled = 1; // true casted to Number
			defaults.setObject(harvestNotificationsEnabled, ZFGameDefines.ZFHarvestNotificationsEnabled);
        }
        
        if (witherNotificationsEnabled == undefined)
        {
			witherNotificationsEnabled = 1; // true casted to Number
			defaults.setObject(witherNotificationsEnabled, ZFGameDefines.ZFWitherNotificationsEnabled);
        }
        
        if (invasionNotificationsEnabled == undefined)
        {
			invasionNotificationsEnabled = 1; // true casted to Number
			defaults.setObject(invasionNotificationsEnabled, ZFGameDefines.ZFInvasionNotificationsEnabled);
        }
        
        if (onlineSavingEnabled == undefined)
        {
			onlineSavingEnabled = 1; // true casted to Number
			defaults.setObject(onlineSavingEnabled, ZFGameDefines.ZFOnlineSavingEnabled);
        }
        
        /* FIXME: Day and night
        if (dayAndNightEnabled == undefined)
        {
//			dayAndNightEnabled = [NSNumber numberWithBool:YES];
//			[defaults setObject:dayAndNightEnabled forKey:ZFDayAndNightEnabled];
        }*/
        
        var muteState = (muted) ? muted : false;
        
        if (!muteState)
        {
//			SimpleAudioEngine.playBackgroundMusic(kFarmBGM);
//			SimpleAudioEngine.setBackgroundMusicVolume(this._view._musicSlider.getValue());
//			SimpleAudioEngine.setEffectsVolume(this._view._effectsSlider.getValue());
            
			this._view._musicSlider.setEnabled(true);
			this._view._effectsSlider.setEnabled(true);
        }
        else
        {
            // testing disable sliders code
//        	SimpleAudioEngine.setBackgroundMusicVolume(0);
        	SimpleAudioEngine.pauseBackgroundMusic();
        	this._view._musicSlider.setEnabled(false);
        	this._view._effectsSlider.setEnabled(false);
        }
        
        /*
        // FIXME: Facebook API
        var useFaceBook = false; //[FBMan fbman].useFaceBook;
        
        // FIXME: Screenshot Manager
        var autoScreenShot = true; //[ZFScreenshotManager screenshotManager].autoScreenShot;
        
        // FIXME: Flurry
        var flurryOffersEnabledState = Boolean(flurryOffersEnabled);*/
        
        var harvestNotificationsEnabledState = Boolean(harvestNotificationsEnabled);
        var witherNotificationsEnabledState = Boolean(witherNotificationsEnabled);
        var invasionNotificationsEnabledState = Boolean(invasionNotificationsEnabled);
        var onlineSavingEnabledState = Boolean(onlineSavingEnabled);
        
        /* FIXME: Day and night
        var dayAndNightState = Boolean(dayAndNightEnabled);*/
        
        var empty = "./Content/checkboxEmpty.png";
        var filled = "./Content/checkboxFilled.png";
        
        this._view._muteSwitch.setBackgroundImage(muted ? empty : filled);
        /* FIXME: Facebook API
        this._view._facebookSwitch.setBackgroundImage(useFaceBook ? filled : empty);*/
        
        /* FIXME: Screenshot Manager
        this._view._autoScreenshotSwitch.setBackgroundImage(autoScreenShot ? filled : empty);*/
        
        /* FIXME: Flurry Offers
        this._view._dailyOfferSwitch.setBackgroundImage(flurryOffersEnabledState ? filled : empty);*/
        
        this._view._harvestNotificationSwitch.setBackgroundImage(harvestNotificationsEnabledState ? filled : empty);
        this._view._witherNotificationSwitch.setBackgroundImage(witherNotificationsEnabledState ? filled : empty);
        this._view._invasionNotificationSwitch.setBackgroundImage(invasionNotificationsEnabledState ? filled : empty);
        
        this._view._onlineSavingSwitch.setBackgroundImage(onlineSavingEnabledState ? filled : empty);
        
        /* FIXME: Day and night
        this._view._dayAndNightSwitch.setBackgroundImage(dayAndNightState ? filled : empty);
        */
    },
    
    // NOTE: This function is a callback
    onlineSavingToggled : function()
    {
        var retval = this.buttonToggledWithDefaultsID(ZFGameDefines.ZFOnlineSavingEnabled);
        
        // If the user has manually enabled online saving then
        // clear the pref to disable status checks
        if (retval)
        {
            var defaults = NSUserDefaults.standardUserDefaults();
            
            // Ah...double negative...
            defaults.setObject(0, ZFGameDefines.ZFStatusCheckDisabled);
            defaults.setObject(0, ZFGameDefines.ZFSyncingStarted);
            defaults.setObject(0, ZFGameDefines.ZFSyncCrash);
        
//	        // Queue up some sync operations
//	        SyncQueue* syncQueue = [SyncQueue syncQueue];
//	        
//	        StatusCheckOperation* statusCheckOp = [[StatusCheckOperation alloc] initWithManager:syncQueue andDelegate:self];
//	        
//	        [syncQueue.operations addOperation:statusCheckOp];
//	        [statusCheckOp release];
//	        
//	        RemoteGameLoadOperation* remoteLoadOp = [[RemoteGameLoadOperation alloc] initWithManager:syncQueue andDelegate:self];
//	        
//	        [syncQueue.operations addOperation:remoteLoadOp];
//	        [remoteLoadOp release];
        }
    },
    
    isSFXOff: function()
    {
        var defaults = NSUserDefaults.standardUserDefaults();
        var muted = Number(defaults.objectForKey(ZFGameDefines.kUserDefaultID_audioMute));
        var sfvVolume = Number(defaults.objectForKey(ZFGameDefines.kUserDefaultID_audioSFXVol));
        var muteState = (muted) ? Boolean(muted) : false;
        
        if (muteState)
        {
            muteState = (sfvVolume) ? Boolean(sfvVolume) : false;
        }
        
        return muteState;
    },

    /*
    facebookSwitchToggled : function()
    {
        this.buttonToggledWithDefaultsID(ZFGameDefines.kUserDefaultID_useFacebook);
        
        var defaults = NSUserDefaults.standardUserDefaults();
        var buttonEnabled = defaults.objectForKey(ZFGameDefines.kUserDefaultID_useFacebook);
        var buttonEnabledVal = Boolean(buttonEnabled);
        
        if (!buttonEnabledVal)
        {
            //FIXME:
            FBMan.fbman().logout();
        }
        
        this._view.initFacebookElements();
    },*/
    
    muteSwitchToggled : function()
    {
	    if (!this.isSFXOff())
	    {
	        SimpleAudioEngine.playEffect(kMenuClick);
	    }
    
        var retval = this.buttonToggledWithDefaultsID(ZFGameDefines.kUserDefaultID_audioMute);
		SimpleAudioEngine.setMute(retval);
	
		// Only play the battle music for a fight if your not muted
        if (!retval)
        {
			SimpleAudioEngine.playBackgroundMusic(kFarmBGM);
			SimpleAudioEngine.setBackgroundMusicVolume(this._view._musicSlider.getValue());
			SimpleAudioEngine.setEffectsVolume(this._view._effectsSlider.getValue());
            
            this._view._musicSlider.setEnabled(true);
            this._view._effectsSlider.setEnabled(true);
        }
        else
        {
            // testing disable sliders code
//        	SimpleAudioEngine.setBackgroundMusicVolume(0);
            this._view._musicSlider.setEnabled(false);
            this._view._effectsSlider.setEnabled(false);
        }
    },
    
    harvestNotificationToggled : function()
    {
        this.buttonToggledWithDefaultsID(ZFGameDefines.ZFHarvestNotificationsEnabled);
    },
    
    witherNotificationToggled : function()
    {
        this.buttonToggledWithDefaultsID(ZFGameDefines.ZFWitherNotificationsEnabled);
    },
    
    invasionNotificationToggled : function()
    {
        this.buttonToggledWithDefaultsID(ZFGameDefines.ZFInvasionNotificationsEnabled);
    },
    
    /* FIXME: Disabled functionalities
    dailyOffersToggled : function()
    {
        this.buttonToggledWithDefaultsID(ZFGameDefines.kUserDefaultID_flurryOffersEnabled);
    },
    
    autoScreenshotSwitchToggled : function()
    {
        this.buttonToggledWithDefaultsID(ZFGameDefines.kUserDefaultID_autoScreenshot);
    },
    
    dayAndNightToggled : function()
    {
        this.buttonToggledWithDefaultsID(ZFGameDefines.ZFDayAndNightEnabled);
    },*/
    
    getRemoteMarketTapped : function()
    {
//#ifdef ZF_REMOTE_MARKET
//	    [self disableInput];
//    
//		//FBMan *fb = [FBMan fbman];
//		ZFRemoteMarket *remote = [ZFRemoteMarket theRemoteMarket];
//		//if ([fb connectedToInternet])	
//		//{
//			[self showLoadingBar:NO:YES];
//			[self changeLoadingBarText: NSLocalizedString(@"Fetching Market Data", @"Getting Remote Market Data")];	//make localized
//			
//			[[NSNotificationCenter defaultCenter] addObserver:self
//													 selector: @selector(getRemoteMarketDone)
//														 name: kRemoteMarketGetMarketDoneNotification
//													   object: nil];
//			[remoteMarketSwitch setBackgroundImage:[UIImage imageNamed:@"checkboxEmpty.png"] forState:UIControlStateNormal ];
//			[remote startGetRequestsWithDelegate:self postUpdates:YES useMarketVersion: NO setRemoteData: YES];
//			[[NSNotificationCenter defaultCenter] removeObserver:self name:kNetConnectivityResultDetermined object:nil];
//		//}
//		//else {
//		//	[self showLoadingBar:NO:NO];
//		//	[self performSelector:@selector(hideLoadingBar) withObject: nil afterDelay:1.0f];
//		//	[self changeLoadingBarText: NSLocalizedString(@"No Internet Connection", @"Not internet connection for remote market")];
//		//}
//#endif
    },
    
    aboutTapped : function()
    {
	    if (!this.isSFXOff())
	    {
	        SimpleAudioEngine.playEffect(kMenuClick);
	    }

//		NSString *bundleVer = [[[NSBundle mainBundle] infoDictionary] objectForKey:@"CFBundleVersion"];
//		UIAlertView *aw = [[UIAlertView alloc] initWithTitle:NSLocalizedString(@"Zombie Farm", @"Title")
//													 message:[NSString stringWithFormat:NSLocalizedString(@"Version %@\nCreated by\nVince McDonnell\n\n2010 The Playforge LLC", @"Version Info"), bundleVer]
//													delegate:nil cancelButtonTitle:NSLocalizedString(@"OK", @"OK Button") otherButtonTitles:nil];
//		[aw show];
//		[aw release];
    },
    
    effectsSliderTouchUp : function()
    {
    	this.effectsSliderChanged();
    	
		if (this._effectID != -1)
		{
			SimpleAudioEngine.stopEffect(this._effectID);
		}
			
		this._effectID = SimpleAudioEngine.playEffect(kPokeSFX);
    },
    
    musicSliderChanged : function()
    {
		var defaults = NSUserDefaults.standardUserDefaults();
		var muted = Number(defaults.objectForKey(ZFGameDefines.kUserDefaultID_audioMute));
	
		var muteState = (muted) ? Boolean(muted) : false;
	
		defaults.setObject(Number(this._view._musicSlider.getValue()), ZFGameDefines.kUserDefaultID_audioBGMVol);
	
		// Only play the battle music for a fight if your not muted
		if(!muteState)
		{
			SimpleAudioEngine.setBackgroundMusicVolume(this._view._musicSlider.getValue());
		}
		
		this.updateItems();
    },
    
    musicSliderTouchUp : function()
    {
    	this.musicSliderChanged();
		var defaults = NSUserDefaults.standardUserDefaults();
		var muted = Number(defaults.objectForKey(ZFGameDefines.kUserDefaultID_audioMute));

		var muteState = (muted) ? Boolean(muted) : false;
		if (!SimpleAudioEngine.isBackgroundMusicPlaying())
		{
			// Only play the battle music for a fight if your not muted
			if(!muteState)
			{
				SimpleAudioEngine.playBackgroundMusic(kFarmBGM);
			}
			
			setTimeout(this.stopMusic.bind(this), 1.5);
		}
		else
		{
			// Only play the battle music for a fight if your not muted
			if(!muteState)
			{
				SimpleAudioEngine.resumeBackgroundMusic();
			}
		}
    },
    
    effectsSliderChanged : function()
    {
		var defaults = NSUserDefaults.standardUserDefaults();
		defaults.setObject(Number(this._view._effectsSlider.getValue()), ZFGameDefines.kUserDefaultID_audioSFXVol);
		SimpleAudioEngine.setEffectsVolume(this._view._effectsSlider.getValue());
		
		this.updateItems();
    },
    
    stopMusic: function()
    {
        //SimpleAudioEngine.pauseBackgroundMusic();
    },
    
    updateItems: function() 
    {
        this.updateSliders();
        this.updateButtons();
    },
    
    updateSliders: function()
    {
        /*
        var defaults = NSUserDefaults.standardUserDefaults();
        var SFX = defaults.objectForKey(ZFGameDefines.kUserDefaultID_audioSFXVol);
        var BGM = defaults.objectForKey(ZFGameDefines.kUserDefaultID_audioBGMVol);
        var sfxVal = (SFX) ? Number(SFX) : 1.0;
        var bgmVal = (BGM) ? Number(BGM) : 1.0;
        this._view._effectsSlider.setValue(sfxVal);
        this._view._musicSlider.setValue(bgmVal);*/ 
        this._effectID = -1;
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/MainMenu/MainMenu'] = function(){var exports = $MODULE_REGISTRY['Code/MainMenu/MainMenu'] || {}; $MODULE_REGISTRY['Code/MainMenu/MainMenu'] = exports; var OptionsMenu = require('Code/MainMenu/OptionsMenu').OptionsMenu;
var MenuButton = require('Code/MainMenu/Classes/MenuButton').MenuButton;
var ProfileView = require('Code/MainMenu/ProfileView').ProfileView;
var ShakeListener = require('Code/MainMenu/ShakeListener').ShakeListener;
var SlideInListener = require('Code/MainMenu/SlideInListener').SlideInListener;

var MainMenuView = Core.Class.subclass(
{
	classname: 'MainMenuView',

	initialize: function(hasDoneStartup)
	{		
		this._rootNode = new GL2.Node();
		
		// BEWARE: 2 different ways to define the screen resolution
		var w = UI.Window._height;
		var h = UI.Window._width;
		
		this._widthScale = UI.Window._width / 480.0; 
		this._heightScale = UI.Window._height / 320.0;
		
        this._resolutionWidth = h;
        this._resolutionHeight = w;
		
        //setup background
		this._background = new GL2.Sprite();
		this._background.setDepth(0);
		this._background.setImage('./Content/MainMenuBG.png', [h, w], [0, 0])._animation.setFilteringEnabled(false);
		this._rootNode.addChild(this._background);
		
		//setup background frame
	    this._backgroundFrameImage = new GL2.Sprite();
	    this._backgroundFrameImage.setDepth(2);
	    this._backgroundFrameImage.setImage('./Content/MainMenuBGFrame.png', [h, w], [0,0])._animation.setFilteringEnabled(false);
	    this._rootNode.addChild(this._backgroundFrameImage);
	    
	    //season airplane
//	    this._seasonImage = new GL2.Sprite();
//	    this._seasonImage.setImage("./Content/MainMenuSubtitlePlane.png", [208*this._widthScale, 31*this._heightScale], [0,0])._animation.setFilteringEnabled(false);
//	    var planePositon = new Core.Vector(140 * this._widthScale, 175 * this._heightScale);
//	    this._seasonImage.setPosition(planePositon);
//	    this._seasonImage.setDepth(4);
//	    this._rootNode.addChild(this._seasonImage);

	    //setup slide in frame
	    var slideInBGImageWidth = 194 * this._widthScale;
	    this._slideInView = new GL2.Node();
	    
	    this._frameSlideInListener = null;
	    if (hasDoneStartup) 
	    {
	    	this._slideInView.setPosition(h-slideInBGImageWidth, 0);
	    }
	    else
    	{
	    	this._slideInView.setPosition(this._resolutionWidth, 0);
	    	var frameSlideDst = new Core.Vector(h-slideInBGImageWidth + 20, this._slideInView.getPosition()._y);
	    	this._frameSlideInListener = new SlideInListener(this._slideInView, frameSlideDst, 350);
    	}
	    
	    this._slideInView.setDepth(1);    	    
	    this._slideInBGImage = new GL2.Sprite();
	    this._slideInBGImage.setImage('./Content/MainMenuSlideInBG.png', [slideInBGImageWidth,w], [0,0])._animation.setFilteringEnabled(false);
	    this._slideInView.addChild(this._slideInBGImage); 
	    
	    // Build the menu buttons
	    
//	    var buttonImageNormalOption = '';
//	    if(this._widthScale > 1)
//    	{
//	    	menuButtonSize = new Core.Size(110.0 * this._widthScale * 1.3, 52.0 * this._heightScale * 0.8);
//	    	buttonImageNormalOption = './Content/woodBoardButtonStretchable168x125.png';
//    	}
//	    else 
//	    {
//	    	buttonImageNormal = './Content/woodBoardButtonStretchable70_52.png';
//	    	buttonImageNormalOption = './Content/MainMenuPlayButton.png';
//	    }
	    
	    // Button font color
	    var buttonFontColor = new Core.Color(66.0 / 255.0, 66.0 / 255.0, 66.0 / 255.0);

	    // First the "Play" button
	    var playImage = './Content/MainMenuPlay.png';
	    var playButtonSize = new Core.Size(156.0 * this._widthScale, 44.0 * this._heightScale );
	    var playPosition = new Core.Vector(20.0 * this._widthScale + 10, 135.0 * this._heightScale );   
	    this._playButton = new MenuButton( playPosition, playButtonSize, playImage, MainMenu.playTapped.bind(MainMenu) );
//	    this._playButton.setText(Core.Localization.getString("Play")); 
	    this._playButton.setFontColor(buttonFontColor);
	    this._playButton.setFontSize(Math.round(14 * this._widthScale));
	    this._slideInView.addChild(this._playButton.getNode());

	    // Now the Options button
	    //var optionsPosition = new Core.Vector(87.0 * this._widthScale * xAdjust, 151.0 * this._heightScale * xAdjust);
	    var optionImage = './Content/MainMenuOptions.png';
	    var optionsButtonSize = new Core.Size(138.0 * this._widthScale, 35.0 * this._heightScale);
	    var optionsPosition = new Core.Vector(35 * this._widthScale + 15, 200.0 * this._heightScale);
	    this._optionsButton = new MenuButton(optionsPosition, optionsButtonSize, optionImage, MainMenu.optionsTapped);
	    this._optionsButton.setFontSize(Math.round(14 * this._widthScale));
	    this._optionsButton.setFontColor(buttonFontColor);
//	    this._optionsButton.setText(Core.Localization.getString("Options"));
	    this._slideInView.addChild(this._optionsButton.getNode());

	    //597x333
	    // Add the game logo   
	    this._logoImage = new GL2.Sprite();
	    var logoSize = null;
	    var logoPosition = null;

	    var xanchor = 0.21;
	    if (this._widthScale>1)
		{
	    	logoSize = new Core.Size(252.0 * this._widthScale /* * 1.1*/, 137.0 * this._heightScale);
	    	logoPosition = new Core.Vector(114 * this._widthScale * 0.9, 35.0 * this._heightScale);
	    	xanchor = 0.16;
	    }
	    else
	    {
	    	logoSize = new Core.Size(252.0 * this._widthScale, 137.0 * this._heightScale);
	    	logoPosition = new Core.Vector(114 * this._widthScale, 35.0 * this._heightScale);
	    }
	    
	    var logoAnchor = new Core.Point(xanchor, 0);
	    this._logoImage.setImage('./Content/ZombieFarmLogo.png', logoSize, logoAnchor)._animation.setFilteringEnabled(false);
	    this._logoImage.setPosition(logoPosition);
	    this._logoImage.setDepth(2);
	    this._rootNode.addChild(this._logoImage);

	    // Next the zombie hands!
//	    var handButtonSize = new Core.Size(54.0 * this._widthScale, 130.0 * this._heightScale);
//	    var handImage = "./Content/MainMenuHand.png";
//	    
//	    var hand0Position = new Core.Vector(93.0 * this._widthScale, 290.0 * this._heightScale);
//	    this._hand0Button = new HandButton(hand0Position, handButtonSize, handImage, 0);
//	    this._hand0Button._node.setDepth(1);
//	    this._rootNode.addChild(this._hand0Button.getNode());
//	    this._hand0Button.setState(this._hand0Button.eHandState.Rising);

	    //MiniGame (hands)
//	    ZombieMiniGame.instantiate();
//	    ZombieMiniGame.init([this._hand0Button /*, this._hand1Button, this._hand2Button, this._hand3Button*/]);
	    
	    /* FIXME: Profile view
	    this._profileView = new ProfileView();
	    var profileButtonPosY = (320 - 20) * this._heightScale;
	    var profileViewPosition = new Core.Vector((240 - (60 / 2)) * this._widthScale, profileButtonPosY);
	    this._profileView.setPosition(profileViewPosition);
	    this._profileView.getNode().setScale(new Core.Vector(this._heightScale, this._heightScale));
	    this._profileView.setDepth(5);
	    this._rootNode.addChild(this._profileView.getNode());*/
	    this._slideInView.setDepth(2);
	    this._rootNode.addChild(this._slideInView);
	    GL2.Root.addChild(this._rootNode);
	    this.showMobageButtons();
	        
	    SimpleAudioEngine.playBackgroundMusic(kFarmBGM);
	    LoadScreen.hide();
	},
	
	getNode: function()
	{
		return this._rootNode;
	},	
	
	shake: function()
	{
		this._shakeFrameListener = new ShakeListener(this._backgroundFrameImage);
	},
	
	destroy: function()
	{
	    if (this._frameSlideInListener)
        {
            this._frameSlideInListener.destroy();
            this._frameSlideInListener = null;
        }
        
        if (this._profileSlideInListener)
        {
            this._profileSlideInListener.destroy();
            this._profileSlideInListener = null;
        }
	    
//	    this._playButton.destroy();
		this._playBautton = null;
//		
//		this._optionsButton.destroy();
		this._optionsButton = null;
//		
//		this._logoImage.destroy();
		this._logoImage = null;
//		
//		this._background.destroy();
		this._background = null;
//		
//		this._backgroundFrameImage.destroy();
		this._backgroundFrameImage = null;
//		
//		this._slideInBGImage.destroy();
		this._slideInBGImage = null;
		
		/* FIXME: Profile view
//		this._profileView.destroy();
//		this._profileView = null;*/

//		this._hand0Button.destroy();
		this._hand0Button = null;
		
		this.hideMobageButtons();
		
		// Kill the rest!
		this._rootNode = null;
	},
	
	showMobageButtons: function() {
        if (!this._mobageButtonsVisible) {
            Social.Common.Service.showCommunityButton(UI.ViewGeometry.Gravity.TopRight, null, function(error) {});
            this._mobageButtonsVisible = true;
        }
    },
    
    hideMobageButtons: function() {
        if (this._mobageButtonsVisible) 
        {
            Social.Common.Service.hideCommunityButton();
            this._mobageButtonsVisible = false;
        }
    }
});

exports.MainMenu = Core.Class.singleton(
{
	classname: 'MainMenu',
	
	initialize: function()
	{
		this._hasDoneStartup = false;
	},
	
	Init: function()
	{
		this._farmGameScene = null;
		this._director = CCDirector;
		this.ReopenMenu();
		this._hasDoneStartup = true;
	},
	
	ReopenMenu: function()
	{
	    this._mainMenu = new MainMenuView(this._hasDoneStartup);
		GL2.Root.addChild(this._mainMenu.getNode());
		
		if (!this._touchBlocker)
	    {
	        this._touchBlocker = new TouchBlocker();
	        this._mainMenu._rootNode.addChild(this._touchBlocker.getNode());
	    }
	},
	
	playTapped : function()
    {
		Social.Common.Service.hideCommunityButton();
		
		setTimeout(function(){
			LoadScreen.show();
			setTimeout(function(){
				GL2.Root.removeChild(this._mainMenu.getNode());
		        destroyWithChildren(this._mainMenu);
		        this._mainMenu = null;
			}.bind(this), 500);
		}.bind(this), 300);
        
        if (!this._farmGameScene)
        {
            setTimeout(this.preloadDatas.bind(this), 2500);
        } else {
            setTimeout(this.startGameCallback.bind(this), 2500);
        }
        
        if (this._touchBlocker)
        {
            this._touchBlocker.destroy();
            this._touchBlocker = null;
        }
    },

	optionsTapped: function()
	{
		OptionsMenu.Show();
	},
	
	Shake: function()
	{
		this._mainMenu.shake();
	},
    
	preloadDatas : function(){
		DataPreloader.instantiate();
	    DataPreloader.preloadData(this.startGame.bind(this));
	},
	startGame : function()
    {
		ZFActorManager.instantiate();
	    GameState.loadGameData();
	    var am = ZFActorManager;
        am.loadActorManager();
        
        var resume = this._farmGameScene !== null;        
        this._farmGameScene = new ZFFarmGameScene(this.startGameCallback.bind(this));
        if (!resume)
        {
            SimpleAudioEngine.playBackgroundMusic(kFarmBGM);    
        }
    },
	
	startGameCallback : function()
	{
		LoadScreen.hide();
		if (this._farmGameScene && CCDirector._runningScene != this._farmGameScene)
		{
			CCDirector.runWithScene(this._farmGameScene);
		}
		ZFGuiLayer._mobageButtonsVisible = false;
		ZFGuiLayer.showMobageButtons();
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/ZFMenus/Zombie/ZFZombieSelectionMenu'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Zombie/ZFZombieSelectionMenu'] || {}; $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Zombie/ZFZombieSelectionMenu'] = exports; //var ZFAbilityCell = require("./ZFAbilityCell");
var ZombieActor = require('Code/Game/Actor/Types/Zombies/ZombieActor').ZombieActor;
var ZFZombieCell = require('Code/Game/GUI/ZFMenus/ZombieSelection/ZFZombieCell').ZFZombieCell;
var CCMenuItemSprite = require('Code/Cocos2D/CCMenuItemSprite').CCMenuItemSprite;
var ZFMenu = require('Code/Game/GUI/ZFMenus/ZFMenu').ZFMenu;


exports.ZFZombieSelectionMenu = ZFMenu.singleton(
{
	classname : 'ZFZombieSelectionMenu',
	
	$zombieSelectionMenu: function() { return this; },
	

	zombieSelectionMenuTags:
	{
		kZombieSelectionMenuTagTable  		: 3,
		kZombieSelectionMenuTagBanner 		: 4,
		kZombieSelectionMenuTagBannerLabel 	: 5,
		kZombieSelectionMenuTagPanel1		: 6,
		kZombieSelectionMenuTagPanel2		: 7
	},

	zombieSelectionButtonState:
	{
		zombieSelectionButtonStateRandom	: 0,
		zombieSelectionButtonStateInvade	: 1
	},

	
	initialize: function()
	{	
		this.setPosition (ccp(480, 0));
	},
	
	initElements: function($super)
	{
		var ptOffset = new Core.Point(0, -35);
		
		// RECTANGLES FOR TILES
		var c;			//corner
		var bc;			//bottom corner
		var b;			//bar
						//CGRect bb;			//bottom bar
		var s;			//side
		var windowSize;	//window size
		
		// HUDELEMENTS FILE
		var f = ZFGameDefines.HUDELEMENTS1_FILE; //"hudElements.png"
		
		// build brick layer 
		
		$super();
		this.cleanWindow(this.kZFMenuTags.kZFMenuTagBackground);
		
		var w = CCDirector.winSize();
		w.setWidth(w._width/CCDirector.zoomValue().getX());
		
		if (w._width>ZFGameDefines.ORIGINAL_WINDOW_WIDTH)
		{
			/*this._dimLayer.changeWidth(2*w._width);
			this._dimLayer.setPosition(CGPointMake(-w._width, 0));
			if(!this._dimLayer.getParent)
			{
				this.addChild(this._dimLayer,1000);
				//TODO
				//CCTouchDispatcher.sharedDispatcher().addTargetedDelegate(this._dimLayer, 90, true);
			}*/
		}
	//	
//		//////////////////// BG STUFF ////////////////////
		windowSize = CGRectMake(0, w._height - 34-this._heightOffset, w._width, 204 + 15);
		
		c = CGRectMake(172, 74, 41, 41);
		bc = CGRectMake(214, 74, 41, 41);
		b = CGRectMake(118,28,26,26);
		s = CGRectMake(145,28,26,26);
		var color = ccc3(ZFColorDefines.colorPaper.getRed()*255, ZFColorDefines.colorPaper.getGreen()*255, ZFColorDefines.colorPaper.getBlue()*255);
		color._a = 0;
		var bg = ZFMenu.makeWindow(windowSize, c, b, f, color, bc, b, s);
		this._windowNode.addChild(bg, 10, this.kZFMenuTags.kZFMenuTagBackground);
		this.initZombieList();
		
		bg.setPosition(ccp(0, -w._height/2 + windowSize.getSize()._height/2));
		
		//banner
		var banner = CCSprite.spriteWithFile(f, CGRectMake(144, 376, 200, 47));
		banner.setScale(1.25, 0.75);
		//banner.setPosition(ccp(w._width/2, w.getHeight*86/100 +2-((this._heightOffset)*72/100)));
		//banner.setPosition(ccp(w._width/2, -w._height/2));
		this._windowNode.addChild(banner, 13, this.zombieSelectionMenuTags.kZombieSelectionMenuTagBanner);
		banner.setPosition(ccp(w._width/2,w._height/2 + windowSize.getSize()._height/2));
		
		var bannerLabel = CCLabel.labelWithString(NSLocalizedString("Select Zombie Order", "Zombie Order Title"), "AmericanTypewriter-Bold", 18);
		this._windowNode.addChild(bannerLabel, 14, this.zombieSelectionMenuTags.kZombieSelectionMenuTagBannerLabel);
		bannerLabel.setColor(ZFColorDefines.colorTextAsh);
		bannerLabel.setPosition(ccp(w._width/2,w._height/2 + windowSize.getSize()._height/2));
		
		//Zombie table
		var cSize   = ZFZombieCell.cellSize();
		this._zombieTable = CCTableView.tableViewWithDataSource(this, CGSizeMake(w._width - 26*2, cSize._height) );
		this._zombieTable._direction = CCScrollView.CCScrollViewDirection.CCScrollViewDirectionHorizontal;
		this._zombieTable._tDelegate = this;
		this._windowNode.addChild(this._zombieTable, 5, this.zombieSelectionMenuTags.kZombieSelectionMenuTagTable);
		//this._zombieTable.setPosition(ccp(20, w._height - 20 - (52+20)));
		//this._zombieTable.setPosition(ccpAdd(this._zombieTable.getPosition(), ptOffset));
		this._zombieTable.setPosition(ccp(26,w._height/2+15));
		this._zombieTable.reloadData();
		this._curNumber = 0;
		this._zombieOrder = [];
		
		for (var i=0;i<this._zombieList.length; i++)
		{	
			this._zombieOrder[i]= null;
		}

		this._leftArrow = CCSprite.spriteWithFile(f, CGRectMake(289,45,18,36));
		this._rightArrow = CCSprite.spriteWithFile(f, CGRectMake(289,45,18,36));
		this._rightArrow._flipX = true;
		
		this._windowNode.addChild(this._leftArrow, 3);
		this._windowNode.addChild(this._rightArrow, 3);
		this._leftArrow.setScale(0.75);
		this._rightArrow.setScale(0.75);
		this._leftArrow.setColor(ZFColorDefines.colorYellowButton);
		this._rightArrow.setColor(ZFColorDefines.colorYellowButton);
		
		this._leftArrow.setPosition(ccp(10, w._height/2));
		this._rightArrow.setPosition(ccp(w._width - 10, w._height/2));
		//this._leftArrow.setPosition(ccpAdd(this._leftArrow.getPosition(), ptOffset));
		//this._rightArrow.setPosition(ccpAdd(this._rightArrow.getPosition(), ptOffset));
		
		this._leftArrow.setVisible(false);
		
		this._leftArrow.setAlpha(0x80/0xff);
		this._rightArrow.setAlpha(0x80/0xff);
		
		var actionTo = CCSequence.actions([
			   CCMoveBy.actionWithDuration(0.25, ccp(10,0)),
			   CCMoveBy.actionWithDuration(0.25, ccp(-10,0))]);

		var repeatForever = CCRepeatForever.actionWithAction(actionTo);
		this._rightArrow.runAction(repeatForever);
		
		actionTo = CCSequence.actions([
					   CCMoveBy.actionWithDuration(0.25, ccp(-10,0)),
					   CCMoveBy.actionWithDuration(0.25, ccp(10,0))]);
		repeatForever = CCRepeatForever.actionWithAction(actionTo);
		this._leftArrow.runAction(repeatForever);
		
		var s1 = CCSprite.spriteWithFile(f, CGRectMake(1,252,180,55));
		var s2 = CCSprite.spriteWithFile(f, CGRectMake(182,252,180,55));
		s1.setColor(ZFColorDefines.colorBrownButton);
		s2.setColor(ZFColorDefines.colorBrownButton);
		
		var s3 = CCSprite.spriteWithFile(f, CGRectMake(1,252,180,55));
		var s4 = CCSprite.spriteWithFile(f, CGRectMake(182,252,180,55));
		s3.setColor(ZFColorDefines.colorRedButton);
		s4.setColor(ZFColorDefines.colorRedButton);
		
		var randomize = CCMenuItemSprite.itemFromNormalSprite(s1, s2);
		randomize.setScale(0.80); 
		
		var invade = CCMenuItemSprite.itemFromNormalSprite(s3, s4);
		invade.setScale(0.80);
		
		l1 = CCLabel.labelWithString(NSLocalizedString("Pick for me", "Choose zombies for me prompt"), "Arial-BoldMT", 20);
		l1.setPosition(ccp(randomize.getContentSize()._width/2 - 17, randomize.getContentSize()._height/2 - 2));
		l1.setColor(ZFColorDefines.colorTextAsh);
		randomize.addChild(l1);
		
		l2 = CCLabel.labelWithString(NSLocalizedString("INVADE!", "Invade Prompt"), "Arial-BoldMT", 20);
		l2.setPosition(ccp(invade.getContentSize()._width/2 - 17, invade.getContentSize()._height/2 - 2));
		l2.setColor(ZFColorDefines.colorTextWhite);
		invade.addChild(l2);
		
		this._button = CCMenuItemToggle.itemWithTarget(this, this.buttonTapped.bind(this), [randomize, invade]);
		this._menu = CCMenu.menuWithItems([this._button]);
		this._menu.setPosition(ccp(w._width/2 - s1.getSize()._width/2, w._height/2 - windowSize.getSize()._height/2 + 27));		
		this._windowNode.addChild(this._menu, 10);
		
		var col = ccc3(ZFColorDefines.colorPaper.getRed()*255, ZFColorDefines.colorPaper.getGreen()*255, ZFColorDefines.colorPaper.getBlue()*255);
		var buttonPanel = CCColorLayer.layerWithColor(col, w._width - 26*2, 52 + cSize._height + 15);
		//buttonPanel.setPosition(ccp(26, w._height - 52 - 15 - (35)));
		//buttonPanel.setPosition(ccpAdd(buttonPanel.getPosition(), ptOffset));
		this._windowNode.addChild(buttonPanel, 2, this.zombieSelectionMenuTags.kZombieSelectionMenuTagPanel1);
		buttonPanel.setPosition(ccp(26,w._height/2));
		
		var col = ccc4(ZFColorDefines.colorTextBlack.getRed()*255, ZFColorDefines.colorTextBlack.getGreen()*255, ZFColorDefines.colorTextBlack.getBlue()*255, 0x40);
		var scrollPanel = CCColorLayer.layerWithColor(col, w._width - 26 * 2, cSize._height - 15);
		//scrollPanel.setPosition(ccp(26,w._height - 20 - (52+20)));
		//scrollPanel.setPosition(ccpAdd(scrollPanel.getPosition(), ptOffset));
		
		scrollPanel.setPosition(ccp(26,w._height/2+15));
		this._windowNode.addChild(scrollPanel, 3, this.zombieSelectionMenuTags.kZombieSelectionMenuTagPanel2);
		
		this._dismissMenu._tag = 8425251;
		var n = this._dismissMenu._children[0];
		n._tag = 8700636;
		this._dismissMenu.removeAllChildrenWithCleanup(true);
		this._windowNode.removeChild(this._dismissMenu, true);
		this._dismissMenu = null;
		
		if (this._widthOffset>0)
		{
			this._zombieTable._bounces = false;
		}
		
		this._button.setSelectedIndex(this.zombieSelectionButtonState.zombieSelectionButtonStateRandom);
		
		this.schedule(this.tick);
		
		this._windowNode.setScale(CCDirector.zoomValue());
        if (CCDirector.zoomValue()._x > 1.0)
            this._windowNode.setPosition(new Core.Point(0, -this._windowNode.getSize()._height * 1/8));
	},
	
	dismissMenu: function(sender)
	{
		var actionTo = CCMoveTo.actionWithDuration(0.05, this.closePos());
		this.runAction(actionTo);
		this.schedule(this.dismissTimerCallback, 0.05);
		this._menuState = ZFMenu.menuStates.menuStateClosing;
		//this.disableMenus();
		
		SimpleAudioEngine.playEffect(kMenuCloseSFX);
		
		//TODO
		//CCTextureCache.sharedTextureCache().removeUnusedTextures();
	},
	
	saveDone: function(sender)
	{
		ZFGuiLayer.removeToolTip();
		
		// display a message for loading the level if no internet to display a page from the web
		//FIXME
		if(true)//!FBMan.fbman().connectedToInternet())
		{
			ZFGuiLayer.gui().displayToolTip(NSLocalizedString("Loading level...", "Loading into a level"));
		}
		
		//TODO
		NSNotificationCenter.defaultCenter().removeObserver(this, ZFGameDefines.kSaveDoneNotification, null);
		
		this.dismissMenu(this);
	},
	
	dismissTimerCallback: function($super)
	{
		this._windowNode.removeChildByTag(this.zombieSelectionMenuTags.kZombieSelectionMenuTagBanner, true);
		this._windowNode.removeChildByTag(this.zombieSelectionMenuTags.kZombieSelectionMenuTagBannerLabel, true);
		this._windowNode.removeChildByTag(this.zombieSelectionMenuTags.kZombieSelectionMenuTagPanel1, true);
		this._windowNode.removeChildByTag(this.zombieSelectionMenuTags.kZombieSelectionMenuTagPanel2, true);
		
		this._windowNode.removeChild(this._leftArrow, true); 
		this._leftArrow = null;
		this._windowNode.removeChild(this._rightArrow, true); 
		this._rightArrow = null;
		
		this.reorderZombiesInActorList();
		this.unschedule(this.tick);
		
		var gui = ZFGuiLayer.gui();
		this._zombieList = null;
		this._zombieOrder = null;
		
		this._zombieTable._tDelegate = null;
		//TODO
		//CCTouchDispatcher.sharedDispatcher().removeDelegate(this._zombieTable);
		this._windowNode.removeChild(this._zombieTable, true);
		
		this._zombieTable = null;
		$super();
		ZFGuiLayer.disableMenus();
		
		// monitor for when the load screen is finished
		//TODO kLoadScreenHideDoneNotification from loadingscreen
		//NSNotificationCenter.defaultCenter().addObserver(gui, this.loadScreenHideDone, kLoadScreenHideDoneNotification, null);
		setTimeout(gui.beginInvasionEvent.bind(gui), 5);
		
	},
	
//	#pragma mark -
//	#pragma mark Utility

	initZombieList: function() {
		var acm = ZFActorManager;
		
		if (this._zombieList) {
			this._zombieList.length = 0;
			this._zombieList = null;
		}
		
		this._zombieList = new Array();
		
		for (var i=0; i < acm._actorList.length; i++) {
			var z = acm._actorList[i];
			if (! (z instanceof  ZombieActor)) {
				continue;
			}
			this._zombieList.push(z);
		}
	},
	
	reorderZombiesInActorList: function()
	{
		var acm = ZFActorManager;
		
		// step1 fill out missing slots in the  zombie Order
		this.fillOutMissingSlots();
		
		//step 2 reorder the actorlist
		for (var i=0; i < this._zombieOrder.length; i++)
		{
			var ind1 = i;
			
			for (var j=0; j < acm._actorList.length; j++)
			{
				if (!(acm._actorList[j] instanceof ZombieActor))
				{
					continue; //player
				}
		
				if (this._zombieOrder[i] == acm._actorList[j])
				{
					var ind2 = j;
					var aux = acm._actorList[ind1];
					acm._actorList[ind1] = acm._actorList[ind2];
					acm._actorList[ind2] = aux;
					break;
				}
			}
		}
	},
	
	
	fillOutMissingSlots: function()
	{
		var acm = ZFActorManager;
		var replaced = true;
		
		while (replaced)
		{
			replaced = false;
			for (var i=0; i < this._zombieOrder.length; i++)
			{
				if (this._zombieOrder[i] instanceof ZombieActor)
				{
					continue; //not null
				}
				
				for (var j=0; j < acm._actorList.length; j++)
				{
					if ( (this._zombieOrder.indexOf(acm._actorList[j] ) == -1) && (acm._actorList[j] instanceof ZombieActor))
					{
						this._zombieOrder[i] = acm._actorList[j];
						replaced = true;
						break;	  
					}
				}
				
				if (replaced)
				{
					break;
				}
			}
		}
		
		//EventTracker.eventTracker().sendEvent("zf_invade_sel_autopick", null, null);	
	},
	
//	#pragma mark Interactions
	buttonTapped: function(sender)
	{
		if (this._button._selectedIndex == this.zombieSelectionButtonState.zombieSelectionButtonStateRandom)
		{
			this.fillOutMissingSlots();
			
			for (var i=0; i < this._zombieList.length; i++)
			{
				var cell = this._zombieTable.cellWithIndex(i);
				if (cell)
				{
				    cell.updateNumberDisplay();
				}
			}
			
			this._button.setSelectedIndex(this.zombieSelectionButtonState.zombieSelectionButtonStateInvade);
		}
		else 
		{
			this.disableMenus();
			// disable this button so it cant be tapped multiple times in a row
			this._button.setIsEnabled(false);
			
			ZFGuiLayer.displayToolTip(NSLocalizedString("Saving game..."));
	        this.saveGame();
		}
	},
	
	saveGame: function()
	{
		this.unschedule(this.saveGame);
		var gs = GameState;
		
		NSNotificationCenter.defaultCenter().addObserver(this, this.saveDone, ZFGameDefines.kSaveDoneNotification, null);

		
		gs._zfGameData._lastInvasionDate = Core.Time.getRealTime()/1000;
		
		// SHIKAKA : SET DICE TO ZERO
		gs._bonusDropRate = gs._zfGameData._bonusDropRate;
		gs._zfGameData._bonusDropRate = 0;
		
		gs.saveGameReal(); //save the game before an invasion
		
		//FIXME: Remove this line!!
//		this.saveDone(null);
	},

	getMenuOffset: function()
	{
		return ccp(0,0);
	},

//	#pragma mark -
//	#pragma mark Tick
	tick: function (dt)
	{
	    if (!this._zombieTable || !this._rightArrow || !this._leftArrow)
	    {
	        return;
	    }
	    
		var p = this._zombieTable.getContainerPos();
		
		//TODO
		if (this._zombieTable._isDragging || this._widthOffset>0)
		{
			this._leftArrow._visible = false;
			this._rightArrow._visible = false;
		}
		else
		{
			this._rightArrow._visible = (p._x > -292);
			this._leftArrow._visible = (p._x < 0);
		}
	},
	
//	#pragma mark -
//	#pragma mark TableView Delegate

	//TODO:
	//table: function(table:(CCTableView *)table cellTouched:(CCTableViewCell *)cell) 
	table_cellTouched: function(table, cell) 
	{
		cell.pressed(this);
		
		var full = true;
		for (var i=0; i < this._zombieOrder.length; i++)
		{
			if (this._zombieOrder[i] == null)
			{
				full = false;
				break;
			}
		}
		
		if (full)
		{
			this._button.setSelectedIndex(this.zombieSelectionButtonState.zombieSelectionButtonStateInvade);
		}
		else
		{
			this._button.setSelectedIndex(this.zombieSelectionButtonState.zombieSelectionButtonStateRandom);
		}
	},
	
//	#pragma mark -
//	#pragma mark TableView DataSource

	//TODO:
	cellClassForTable: function (table) 
	{
	    return ZFZombieCell;
	},

	table_cellAtIndex: function (table, idx) 
	{
		var cell = table.dequeueCell();
		var z = this._zombieList[idx];
		
	    if (!cell) 
		{
	    	cell = new ZFZombieCell();
	    }
		
		cell.setZombie(z);
		cell._node = cell._cellLayer;
		cell._name.setString(z._name);
		cell._place = idx;
		
	    return cell;
	},
	
	numberOfCellsInTableView: function(table) 
	{
		if(!this._zombieList)
		{
			console.log("ERROR");
		}
		return this._zombieList.length;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/FarmGameScene/ZFFarmGameScene'] = function(){var exports = $MODULE_REGISTRY['Code/Game/FarmGameScene/ZFFarmGameScene'] || {}; $MODULE_REGISTRY['Code/Game/FarmGameScene/ZFFarmGameScene'] = exports; var ZFFarmTileMap = require('Code/Game/FarmGameScene/ZFFarmTileMap').ZFFarmTileMap;
var ZFSelectorLayer = require('Code/Game/GUI/GuiLayer/ZFSelectorLayer').ZFSelectorLayer;
var ZFZombieSelectionMenu = require('Code/Game/GUI/ZFMenus/Zombie/ZFZombieSelectionMenu').ZFZombieSelectionMenu;

exports.ZFFarmGameScene = CCScene.subclass(
{
	classname: 'ZFFarmGameScene',
	$kTag:
	{
		kTagFarm : 0,
		kTagSelectors : 1,
		kTagGui : 2,
		kTagGameCenter : 3,
		kTagMarket : 4,
		kTagActorManager : 5,
		kTagCreateFarmer : 6,
	    kTagQuest : 7,
	    kTagMutationMenu : 8,
		kTagStorage : 9,
		kTagZombie : 10,
		kTagMausoleum : 11,
		kTagZombieSelection : 12,
		kTagQuestMan : 13,
		kTagDayAndNight : 14
	},

	initialize: function(cb)
	{
//		console.log("the market = " + ZFMarketMenu.classname);
		this._cb = cb;
		var self = this;

		//init GameState and TileManager
//		GameState.instantiate();
//		GameState.init();
		var gs = GameState;
		GameState.init(function()
		{
//			console.log("@@@@@@@@@@@@ tGameState game data = " + GameState._zfGameData);
			
			ZFTileManager.instantiate();
	    	ZFGuiLayer.gui();//required to initialize the gui

			ZFTileManager.init(function()
			{
//				console.log("the market = " + ZFMarketMenu);
				ZFMarketMenu.instantiate();
				ZFMarketMenu.init(function()
				{
					self._flayer = new ZFFarmTileMap(function()
					{
//						console.log(">>>>>>>>>>>>>>>>>>>>>>>> finish init ZFFarmGameScene flayer position = " + self._flayer.getPosition()._x + ", " + self._flayer.getPosition()._y);
	
						var slayer = new ZFSelectorLayer();
	
						var clayer = ZFFarmerSelectionMenu.farmerSelectionMenu();
	//			        ZFQuestMenu* qlayer = [ZFQuestMenu questMenu];
				        var mutationLayer = ZFMutationMenu.mutationMenu();
	//					ZFStorageMenu* stlayer = [ZFStorageMenu storageMenu];
	//					ZFZombieMenu* zlayer = [ZFZombieMenu zombieMenu];
	//					ZFMausoleumMenu* mausoleumlayer = [ZFMausoleumMenu mausoleumMenu];
						var zombieSelectionLayer = ZFZombieSelectionMenu.zombieSelectionMenu();
	//					
	//					ZFGameCenterDelegate* gcd = [ZFGameCenterDelegate gameCenterDelegate];
	//					
	
						self._glayer = ZFGuiLayer;
						
						
						// saveTiles already loaded at this point ... adjust map to new maximum size
	
	//TODO
						ZFTileManager.setupMapFromSave();
						ZFTileManager._map.addChild(slayer, 3000, self.kTag.kTagSelectors);
						
	//					[self addChild:gcd z:2 tag:kTagGameCenter];
	//					
						self._glayer.addChild(ZFMarketMenu, 10, self.kTag.kTagMarket);
						self._glayer.addChild(ZFFarmerSelectionMenu , 10 , self.kTag.kTagCreateFarmer );
						self._glayer.addChild(ZFQuestMenu, 10, self.kTag.kTagQuest);
						self._glayer.addChild(ZFMutationMenu, 10, self.kTag.kTagMutationMenu);
						self._glayer.addChild(ZFStorageMenu, 4, self.kTag.kTagStorage);
						self._glayer.addChild(ZFZombieMenu, 10, self.kTag.kTagZombie);
						self._glayer.addChild(ZFMausoleumMenu, 10, self.kTag.kTagMausoleum);
						self._glayer.addChild(zombieSelectionLayer, 10, self.kTag.kTagZombieSelection);
	//					[glayer addChild:[ZFQuestMan questMan] z:10 tag:kTagQuestMan];
	//					
						self.addChild( ZFActorManager, 3, self.kTag.kTagActorManager );
						self.addChild(self._glayer, 0, self.kTag.kTagGui);
						
						
						//spawn the actors
	
						ZFActorManager.spawnActorsInSpawnQueue();
						
						// create the light for the player
						// have to do this here, because player init gets called twice...
						var player = ZFActorManager._player;
	
						if ( player == null)
						{
//							console.log( "Spawning Player." );
							
							/*TODO: restore original behavior
							var spawnTile = ccp( ZFTileManager._map._contentSize._width  / 2 + 2,
												 ZFTileManager._map._contentSize._height / 2 + 4 );
							player = ZFActorManager.spawnFarmActor_onTile( "PlayerActor" , spawnTile );*/
							player = ZFActorManager.spawnFarmActor_onTile( "PlayerActor" , new Core.Point(12,21));
							ZFActorManager._player = player;
						}
	
						// TODO : Remove mass spawn after test.
						var zombies = new Array( 	/*'ZombieActorRegularTier1' , 'ZombieActorRegularTier1', 'ZombieActorRegularTier1' /*, 'ZombieActorRegularTier1','ZombieActorRegularTier1' , 'ZombieActorRegularTier1','ZombieActorRegularTier1' , 'ZombieActorRegularTier1', 'ZombieActorRegularTier1' , 'ZombieActorRegularTier1','ZombieActorRegularTier1' , 'ZombieActorRegularTier1'/* , 'ZombieActorGardenTier2' , 'ZombieActorGardenTier3' , 'ZombieActorGardenTier4',
													'ZombieActorGirlTier1' , 'ZombieActorGirlTier2' , 'ZombieActorGirlTier3' , 'ZombieActorGirlTier4' ,
													'ZombieActorHeadlessTier1' , 'ZombieActorHeadlessTier2' , 'ZombieActorHeadlessTier3' , 'ZombieActorHeadlessTier4',
													'ZombieActorLargeTier1', 'ZombieActorLargeTier2', 'ZombieActorLargeTier3', 'ZombieActorLargeTier4',
													'ZombieActorRegularCrazy', 'ZombieActorGardenCupid', 'ZombieActorRegularTier2', 'ZombieActorRegularTier3', 'ZombieActorRegularTier4',
													'ZombieActorSmallTier1', 'ZombieActorSmallTier2', 'ZombieActorSmallTier3', 'ZombieActorSmallTier4'*/ ); 
													
						for ( key in zombies )
						{
							var zombieName = zombies[ key ];
//							console.log( "Spawning:" + zombieName );
							ZFActorManager.spawnFarmActor_onTile( zombieName ,
									ccp( 	5 + Math.floor( Math.random() * 20 ),
											5 + Math.floor( Math.random() * 20 ) ) );
						}
										
	//					player.playerLight = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:200 intensity:0xFF] autorelease];
	//					player.playerLight.enableColorWriting = NO; // cookie cut out light
	//					
	//					Light* outerRingLight = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:350 intensity:0xFF] autorelease];
	//					outerRingLight.enableColorWriting = NO; // cookie cut out light
	//					[player.playerLight addChild:outerRingLight];
	//					[flayer addChild:player.playerLight];
	//					
	//					// Day and Night functionality
	//					DayCycle* dayCycle = [[[DayCycle alloc] init] autorelease];
	//					[self addChild:dayCycle z:0 tag:kTagDayAndNight];

						player._playerProgressBar = self._glayer._playerProgressBar;
//						console.log("zf game flags tuto = " + (gs._zfGameData._gflags & ZFGameFlags.GFLAG_TUTORIAL_START));
						if (!(gs._zfGameData._gflags & ZFGameFlags.GFLAG_TUTORIAL_START))
						{
							ZFTileManager.setupFirstTimeMap(function()
							{
                                if (!(gs._zfGameData._gflags & ZFGameFlags.GFLAG_STARTING_GOLD_GIVEN))
                                {
                                    gs.addResource(GameData.gameResources.kGameResourceGold, 200);
                                    gs._zfGameData._gflags |= ZFGameFlags.GFLAG_STARTING_GOLD_GIVEN;
                                    gs.saveGameReal(); //save after initial bonus gold is given
                                }
                                
                                ZFFarmerSelectionMenu.farmerSelectionMenu().openMenu();
                                
                                // FIXME: This wasn't in the original code.
                                //ZFGuiLayer.schedule(ZFGuiLayer.gamestart, 1.0);
                            }.bind(this));
						}
						else
						{
							ZFGuiLayer.schedule(ZFGuiLayer.gamestart, 1.0, "gamestart");
						}
						
						ZFGuiLayer.gui().updateArmySize();
						if(GameState.canInvade())
						{
							ZFGuiLayer.gui().showInvasionMenu(null);
						}

						//[self addChild:[AmbientLayer getInstance] z:0];
						//removes all textures that are not needed (frees memory)
						//[[CCTextureCache sharedTextureCache] removeUnusedTextures];
	
						//init finished
						self._cb(self);
					});
					self.addChild(self._flayer, 0, self.kTag.kTagFarm);
				});
			});
		//GameState.init()
		});
		
		ZFQuestMan.instantiate();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GameState/GameData'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GameState/GameData'] || {}; $MODULE_REGISTRY['Code/Game/GameState/GameData'] = exports; var Storage = require('NGCore/Client/Storage').Storage;
//var ZFTileManager = require('../Tiles/ZFTileManager').ZFTileManager;
//var GameState = require('./GameState').GameState;
var ZFBitBank = require('Code/Game/GameState/ZFBitBank').ZFBitBank;
var ZFGameDefines = require('Code/Game/ZFGameDefines').ZFGameDefines;
var ZFGameFlags = require('Code/Game/ZFGameFlags').ZFGameFlags;
var SaveTile = require('Code/Game/Tiles/SaveTile').SaveTile;
var PlayerProfile = require('Code/Game/Player/PlayerProfile').PlayerProfile;

exports.GameData = Core.Class.subclass(
{
	classname:'GameData',
	
	$gameResources:
	{
		kGameResourceGold:0,
		kGameResourceBrains:1,
		kGameResourceXP:2,
		kGameResourceBrainFragmentsSpent:3,
		kGameResourceMAX:4
	},

	
	initialize: function()
	{
//		ZFTileManager = require('../Tiles/ZFTileManager').ZFTileManager;
//		console.log("Game Data ZFTileManager? " + GameState + " " + ZFTileManager + " " + SaveTile + " " + Core);
		this.initValues();
		
//		NSString* path = [[NSBundle mainBundle] bundlePath];
//#ifdef ZF_REMOTE_MARKET
//		NSString* finalPath = [[ZFRemoteMarket theRemoteMarket] getPathToLocalMarketIfUpdated];
//		if (!finalPath)
//			finalPath = [path stringByAppendingPathComponent:@"Market.plist"];
//#else
//		NSString* finalPath = [path stringByAppendingPathComponent:@"Market.plist"];
//#endif
//		self.marketArray = [NSArray arrayWithContentsOfFile:finalPath];
	},

	initValues: function()
	{
		this._resources = [];
		this._inventory = [];
		this._zombieCombiners = [];
		this._completedQuests = [];
		this._currentQuests = [];
		this._actorList = [];
		this._devHistory = [];
		this._sentGiftFriendsIDs = [];
		this._receivedGiftFriendsAliases = [];
		this._unlockedItems = [];
		this._giftBasket = [];
		this._oldGiftBasket = [];
		this._tempOldGiftBasket = null;
		this._tempUDID = null;
		this._abilityFlags = new ZFBitBank();
		this._achievementFlags = new ZFBitBank();
		this._purchaseFlags = new ZFBitBank();
		this._promoFlags = new ZFBitBank();
	    this._mutationCollectionFlags = new ZFBitBank();
		this._zombieStorage = null;
		this._saveTiles = [];
		this._saveTiles.toJSON = function() {
            var a = [];
            for (var i = 0; i < this.length; i ++)
            {
                if (this[i]._date || this[i]._key ||
                    (this[i]._ownerTile && this[i]._ownerTile._x != -1 && this[i]._ownerTile._y != -1)) {
                    a.push(this[i]);
                }
            }
            
            return a;
        };
		
		for (var i=0; i < this.gameResources.kGameResourceMAX; i++)
		{
			this._resources.push(0);
		}
		
		// creates the whole array
        for ( var y = 0; y < ZFGameDefines.getConst("MAXMAPSIZE"); y++) //problem here use max size????
        {
            for ( var x = 0; x < ZFGameDefines.getConst("MAXMAPSIZE"); x++)
            {
                var saveTile = this.saveTileAt(new Core.Point(x, y), new Core.Size(ZFGameDefines.getConst("MAXMAPSIZE"), ZFGameDefines.getConst("MAXMAPSIZE")));
                
                saveTile._rootTile = new Core.Point(x, y);
                saveTile._ownerTile = new Core.Point(-1, -1);
                saveTile._date = null;
                saveTile.setKey("", ZFTileManager);
                saveTile._endCropTile = null;
                saveTile._color = new Core.Color(1.0, 1.0, 1.0);
            }
        }
		
	    this._playerProfileID = "UnknownPlayer";
		this._playforgeID = 0;
	    this._saveID = 0;
		this._level = 1;
		this._mapSize = 30;
		//sfxVolume = .5f;
		//bgmVolume = .5f;
		//muteAudio = NO;
		var currentTime = Core.Time.getRealTime()/1000;
		
        this._lastInvasionDate = currentTime + 60 * 60 * 2;
        this._cheatFlags = 0;//CFLAG_CHEATS_ON;
        this._playerActionSpeed = ZFGameDefines.getConst("PLAYERACTIONSPEED");
        this._growSpeed = ZFGameDefines.getConst("GROWSPEED");
        this._defectiveRate = 0;
        this._currentEnemy = 0;
        this._bonusDropRate = 0;
        this._gflags = 0; // do something bought here
        this._mausoleumFlags = 0;
        this._fflags = 0;
        this._headID = 0;
        this._bodyID = 0;
        this._baseGID = 1;
        this._zombiePatchOn = false;
        this._isPayingUser = false;
        this._currentGameVersion = 0;
        this._lastEarnedBrainDate = currentTime;
        this._flurryRewardClaimed = currentTime - (10 * 60 * 60 * 24 * 365); // Distant time on the iPhone = seconds since 2001
        this._mausoleumSlots = ZFGameDefines.MAUSOLEUM_SLOTS_MIN;
		
		this._farmerFightsWon = 0;
		this._lawyerFightsWon = 0;
		this._pirateFightsWon = 0;
		this._ninjaFightsWon  = 0;
		this._carrotsHarvested = 0;
		this._timesFertilized = 0;
		this._fightLossCount = 0;
//		
		this.setBlueGravestoneFlag();
//		
		this._farmOwner = Core.Localization.getString("Zombie Farmer");
		this._UDID = "UNDEFINED";
		this._previousTransactionIdentifier = "UNDEFINED";
	},
	
	initWithData: function(data)
	{
		this._resources = data._resources;
		//this._saveTiles = data._saveTiles;
		this._inventory = data._inventory;
		this._zombieCombiners = data._zombieCombiners;
		this._completedQuests = data._completedQuests;
		this._currentQuests = data._currentQuests;
		this._actorList = [];
		for(var key in data._actorList)
		{
			var actorData = data._actorList[key];
			var newActor = eval('(' + "new " + actorData.classname +"()" + ')');
			newActor.initWithCoder(actorData);
			this._actorList.push(newActor);
		}
		this._zombieStorage = [];
		for(var key in data._zombieStorage)
		{
			var actorData = data._zombieStorage[key];
			newActor.initWithCoder(actorData);
			this._zombieStorage.push(newActor);
		}
		this._devHistory = data._devHistory;
		this._sentGiftFriendsIDs = data._sentGiftFriendsIDs;
		this._receivedGiftFriendsAliases = data._receivedGiftFriendsAliases;
		this._unlockedItems = data._unlockedItems;
		this._giftBasket = data._giftBasket;
		this._oldGiftBasket = data._oldGiftBasket;
		this._tempOldGiftBasket = data._tempOldGiftBasket;
		this._tempUDID = data._tempUDID;
		this._abilityFlags._bank = data._abilityFlags._bank;
		this._achievementFlags._bank = data._achievementFlags._bank;
		this._purchaseFlags._bank = data._purchaseFlags._bank;
		this._promoFlags._bank = data._promoFlags._bank;
	    this._mutationCollectionFlags._bank = data._mutationCollectionFlags._bank;
		this._resources = data._resources;
		
		// RateMe
		this._10Zombies = data._10Zombies;
		this._wonFirstInvaion = data._wonFirstInvaion;
		this._gameRatedByUser = data._gameRatedByUser;
		this._askedTimes = data._askedTimes;
		
		/*
        for (var y=0; y< ZFGameDefines.getConst("MAXMAPSIZE"); y++) //problem here use max size????
        {
            for (var x=0; x< ZFGameDefines.getConst("MAXMAPSIZE"); x++)
            {
                var saveTile = this.saveTileAt(new Core.Point(x, y), new Core.Size(ZFGameDefines.getConst("MAXMAPSIZE"), ZFGameDefines.getConst("MAXMAPSIZE")));
                
                saveTile._rootTile = new Core.Point(x,y);
                saveTile._ownerTile = new Core.Point(-1,-1);
                saveTile._date = null;
                saveTile.setKey("", ZFTileManager);
                saveTile._endCropTile = null;
                saveTile._color = new Core.Color(1.0, 1.0, 1.0);
            }
        }*/
        
		for (var key in data._saveTiles)
		{
			var tile = data._saveTiles[key];
			var saveTile = new SaveTile();
			saveTile._rootTile = new Core.Point(tile._rootTile._x, tile._rootTile._y);
			saveTile._ownerTile = new Core.Point(tile._ownerTile._x, tile._ownerTile._y);
			if(tile._date)
			{
				saveTile._date = tile._date;
			}
			else
			{
				saveTile._date = null;
			}
			
			if(tile._plantDate)
			{
				saveTile._plantDate = tile._plantDate;
			}
			else
			{
				saveTile._plantDate = null;
			}
			
			saveTile._key = tile._key;
			saveTile._color = new Core.Color(tile._color._red, tile._color._green, tile._color._blue);			
			saveTile._fertilized = tile._fertilized;
			saveTile._endCropTile = tile._endCropTile;
			saveTile._orientation = tile._orientation || 0;
	
			//this._saveTiles.push(saveTile);
            var auxSaveTile = this.saveTileAt(saveTile._rootTile, new Core.Size(ZFGameDefines.getConst("MAXMAPSIZE"), ZFGameDefines.getConst("MAXMAPSIZE")));
            var index = this._saveTiles.indexOf(auxSaveTile);
            this._saveTiles[index] = saveTile;
		}

		this.adjustSaveTileArrayForMapSize(new Core.Size(ZFGameDefines.MAXMAPSIZE, ZFGameDefines.MAXMAPSIZE));
		
	    this._playerProfileID = data._playerProfileID;
		this._playforgeID = data._playforgeID;
	    this._saveID = data._saveID;
		this._level = data._level;
		this._mapSize = data._mapSize;
		//sfxVolume = .5f;
		//bgmVolume = .5f;
		//muteAudio = NO;
		//var currentTime = new Date();
		 
		this._lastInvasionDate = data._lastInvasionDate;
		this._cheatFlags = data._cheatFlags;//CFLAG_CHEATS_ON;
		this._playerActionSpeed = data._playerActionSpeed;
		this._growSpeed = data._growSpeed;
		this._defectiveRate = data._defectiveRate;
		this._currentEnemy = data._currentEnemy;
		this._bonusDropRate = data._bonusDropRate;
		this._gflags = data._gflags; // do something bought here
		this._mausoleumFlags = data._mausoleumFlags;
		this._fflags = data._fflags;
		this._headID = data._headID;
		this._bodyID = data._bodyID;
		this._baseGID = data._baseGID;
		this._zombiePatchOn = data._zombiePatchOn;
		this._isPayingUser = data._isPayingUser;
		this._currentGameVersion = data._currentGameVersion;
		this._lastEarnedBrainDate = data._lastEarnedBrainDate;
		this._flurryRewardClaimed = data._flurryRewardClaimed;
		this._mausoleumSlots = data._mausoleumSlots;
		
		this._farmerFightsWon = data._farmerFightsWon;
		this._lawyerFightsWon = data._lawyerFightsWon;
		this._pirateFightsWon = data._pirateFightsWon;
		this._ninjaFightsWon  = data._ninjaFightsWon;
		this._carrotsHarvested = data._carrotsHarvested;
		this._timesFertilized = data._timesFertilized;
		this._fightLossCount = data._fightLossCount;
//		
//		this.setBlueGravestoneFlag();
//		
		this._farmOwner = data._farmOwner;
		this._UDID = data._UDID;
		this._previousTransactionIdentifier = data._previousTransactionIdentifier;

	},
	
	saveTileAt: function(tileCoordinates, sizeofMap)
	{
		sizeofMap = new Core.Size(ZFGameDefines.getConst("MAXMAPSIZE"), ZFGameDefines.getConst("MAXMAPSIZE"));
		//i may change this in the future
	
		// assume maps are always same width and height
		if(tileCoordinates._x < 0 || tileCoordinates._x >= sizeofMap._width)
		{
			return null;
		}
		
		if(tileCoordinates._y < 0 || tileCoordinates._y >= sizeofMap._height)
		{
			return null;
		}
		
		var index = (tileCoordinates._y * sizeofMap._width) + tileCoordinates._x;
        var saveTile = null;
        if (index < this._saveTiles.length)
        {
            saveTile = this._saveTiles[index];
        }
        else if (index == this._saveTiles.length)
        {
            saveTile = new SaveTile();
            this._saveTiles.push(saveTile);
        }
        else
        {
            console.log("Hey! do this in sequence! index: " + index + ", length: " + this._saveTiles.length);
        }
		
		return saveTile;
	},
	
	// passing in a mapsize and then adjusting the array to fit it (if it needs to be bigger)
	adjustSaveTileArrayForMapSize: function(sizeofMap)
	{
		var oldMapSize = this._saveTiles.length;
		
		var newMapSize = sizeofMap._width * sizeofMap._height;

		var oldMapSizeWidth;
		var oldMapSizeHeight;

		// all maps are squares so square root == width / height
		oldMapSizeHeight = oldMapSizeWidth = Math.sqrt(oldMapSize);
			
		if(newMapSize > oldMapSize)
		{
			// adding extra columns to old rows
			for(var row = 0; row < oldMapSizeHeight; row++)
			{
				for(var col = oldMapSizeWidth; col < sizeofMap._width; col++)
				{
					var saveTile = new SaveTile();
					
					saveTile._rootTile = ccp(col,row);
					saveTile._ownerTile = ccp(-1,-1);
					saveTile._date = null;
					saveTile._key = "";
					saveTile._endCropTile = null;
					saveTile._color = ccc3(0xFF, 0xFF, 0xFF);
					
					this._saveTiles.splice(row * sizeofMap._width + col, 0, saveTile);
				}
			}
			
			// adding new rows
			for(var row = oldMapSizeHeight; row < sizeofMap._height; row++)
			{
				for(var col = 0; col < sizeofMap._width; col++)
				{
					var saveTile = new SaveTile();
					
					saveTile._rootTile = ccp(col,row);
					saveTile._ownerTile = ccp(-1,-1);
					saveTile._date = null;
					saveTile._key = "";
					saveTile._endCropTile = null;
					saveTile._color = ccc3(0xFF, 0xFF, 0xFF);
					
					this._saveTiles.push(saveTile);
				}
			}
		}
		else if(newMapSize == oldMapSize)
		{
			// fix current saveTiles if broken (cuz i broke it)
			for(var row = 0; row < oldMapSizeHeight; row++)
				for(var col = 0; col < oldMapSizeWidth; col++)
				{
					var saveTile = this.saveTileAt(ccp(col,row), sizeofMap);
					if(CGPointEqualToPoint(ccp(0,0), saveTile._rootTile) && !CGPointEqualToPoint(ccp(0,0), ccp(col,row)))
					{
						// fix this tile
						saveTile._rootTile = ccp(col,row);
						saveTile._ownerTile = ccp(-1,-1);
						saveTile._date = null;
						saveTile._key = "";
						saveTile._endCropTile = null;
						saveTile._color = ccc3(0xFF, 0xFF, 0xFF);
					}
				}
			
		}
	},
	
	fillActorList: function(actors, farmActors, storage)
	{
		if (this._actorList) {
//			console.log("GameData.fillActorList: Destroying actors: " + this._actorList.length);
			for (var i in this._actorList) {
				this._actorList[i].despawn();
//				destroyWithChildren(this._actorList[i]);
			}
			this._actorList.length = 0;
		}
	    this._actorList = [];
		for(var key in actors)
		{
			var actor = actors[key];
			this._actorList.push(actor.copyWithZone(null));
		}
		for(var key in farmActors)
		{
			var actor = farmActors[key];
			this._actorList.push(actor.copyWithZone(null));
		}
		this._zombieStorage = [];
		for(var key in storage)
		{
			var actor = storage[key];
			if(actor instanceof Actor){
				this._zombieStorage.push(actor.copyWithZone(null));	
			}else{
//				console.log("ssss Game.data.fillActorList actor es null: " +actor + "instanceof: " + (instanceof actor));
			}
			
		}
//		console.log("ssss Game.data.fillActorList guardando _actorList[" + this._actorList + "]");
//		console.log("ssss Game.data.fillActorList guardando _zombieStorage [" + this._zombieStorage + "]");
//		this._zombieStorage = storage;
	},
	
	setBlueGravestoneFlag : function()
	{
		this._gflags |= ZFGameFlags.GFLAG_SOMETHING_BOUGHT;
		this._purchaseFlags.setFlag(ZFGameFlags.PFLAG_ONIONMUTATION);
	},
	
	save: function()
	{
	    // Build the save file name
	    var saveFileName = PlayerProfile.determineSaveFileName(this._playerProfileID);
		this.writeToFile(saveFileName);
	},

	writeToFile: function(fileName)
	{
		// This method on handles actual file names
		if (!fileName ||  this._isWritingFile)
		{
			return;
		}
		
	    this._isWritingFile = true;
		// Find the save path
//		NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
//		NSString *rootPath = nil;
//		
//		rootPath = [paths objectAtIndex:0];
//		
//		NSAssert(rootPath != nil, @"writeToFile(): rootPath is nil");
//		
//		// Construct the full path including file name
//		NSString* fullPath = [rootPath stringByAppendingPathComponent:fileName];
//		
//		// Save the current GameData to a file
//		[[PlayerProfileManager playerProfileManager] log:[NSString stringWithFormat:@"******* SAVING %@ *******", fileName]];
		
//		[NSKeyedArchiver archiveRootObject:self toFile:fullPath];
		//serialized GameData with JSON
		var saveGame = JSON.stringify(this);
		//write it locally
//		console.log ("GameData.writeToFile: saving (" + fileName + "): " + saveGame);
		Storage.FileSystem.writeFile(fileName, saveGame, false, function(err)
		{
//			console.log("GameData.writeToFile CB");
			if(err)
			{
				console.log("error writing save");
			}
			else
			{
	             //set the saving done,
//				console.log("GameData.writeFile: game saved to disk");
				NSNotificationCenter.postNotificationName(ZFGameDefines.kSaveDoneNotification, null);
			}
			
			GameState._isSaving = false;
		    this._isWritingFile = false;
		}.bind(this)); 
	    
	    // Save out a preview of this data
//	    NSDictionary *dict = [NSDictionary dictionaryWithObjectsAndKeys:
//	                          farmOwner, @"farmOwner",
//	                          [NSNumber numberWithInt:headID], @"headID",
//	                          [NSString stringWithFormat:@"%d", level], @"level",
//	                          [NSString stringWithFormat:@"%d", [[resources objectAtIndex:kGameResourceGold] intValue]], @"gold",
//	                          [NSString stringWithFormat:@"%d", [[resources objectAtIndex:kGameResourceBrains] intValue]], @"brains",
//	                          fileName, @"fileName",
//	                          nil];
//	    
//	    NSString* previewFile = [NSString stringWithFormat:@"%@.preview", [fileName stringByDeletingPathExtension]];
//	    NSString* fullPreviewPath = [rootPath stringByAppendingPathComponent:previewFile];
//	    
//	    [dict writeToFile:fullPreviewPath atomically:YES];
	},

	//- (BOOL)flagAnyStorage
	flagAnyStorage: function()
	{
		if(	this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE01) || 
			this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE02) || 
			this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE03) || 
			this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE04) || 
			this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE05) || 
			this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE06) ||
			this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE07) ||
			this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE08))
		{
			return true;
		}
		
		return false;
	},

	//- (BOOL)flagAllStorage
	flagAllStorage: function()
	{
		if(this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE01) && 
		   this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE02) && 
		   this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE03) && 
		   this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE04) && 
		   this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE05) && 
		   this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE06) &&
		   this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE07) &&
		   this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE08))
		{
			return true;
		}
		
		return false;
	},
	
	//- (BOOL)flagAllMutations
	flagAllMutations: function()
	{
		if(this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_TOMATOMUTATION) && 
		   this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_CARROTMUTATION) && 
		   this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_TURNIPMUTATION) && 
		   this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_POTATOMUTATION) && 
		   this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_COFFEEMUTATION) && 
		   this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_CELERYMUTATION) &&	   
		   this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_BROCCOLIMUTATION) && 
		   this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_GARLICMUTATION) && 
		   this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_CAULIFLOWERMUTATION) && 
		   this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_LIMABEANMUTATION) && 
		   this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_FLYTRAPMUTATION) &&
		   this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_DRAGONMUTATION))
		{
			return true;
		}
		
		return false;
	},
	
	//- (BOOL)flagAllClimate
	flagAllClimate: function()
	{
		if (this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_CLIMATE_SAND) && 
		    this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_CLIMATE_CONCRETE) && 
		    this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_CLIMATE_SNOW) && 
		    this._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_CLIMATE_DEAD))
		{
			return true;
		}
		
		return false;
	},
	
	//-(int)mausoleumSlotsAllowed
	mausoleumSlotsAllowed: function()
	{
		var slots = 3;
		if (this._mausoleumFlags & ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM01)
		{
			slots = 9; // putting this here as it's subject to change: <changed from 3 to 6>
		}
		if (this._mausoleumFlags & ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM02)
		{
			slots = 12;
		}
		if (this._mausoleumFlags & ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM03)
		{
			slots = 15;
		}
		
		return slots;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Application/ZFAchievementChecker'] = function(){var exports = $MODULE_REGISTRY['Code/Application/ZFAchievementChecker'] || {}; $MODULE_REGISTRY['Code/Application/ZFAchievementChecker'] = exports; exports.ZFAchievementChecker = Core.Class.singleton({
	classname: "ZFAchievementChecker",
	
	initialize: function () {
	},
	
	achievementChecker: function () {
		return this;
	},
	
	checkFarmTutorialDone: function () {
		var gs = GameState;
		if (gs._zfGameData._gflags & ZFGameFlags.GFLAG_TUTORIAL_DONE) {
//			FIXME [[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.farm.tutorial_done" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievementFarmTutorialDone);
		}
	},

	checkFightTutorialDone: function () {
		var gs = GameState;
		if (gs._zfGameData._gflags & ZFGameFlags.GFLAG_FIGHT_TUTORIAL)
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.fight.tutorial_done" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievementFightTutorialDone);
		}
	},

	checkAllMasters: function () {
		var masCt = 0;
		
		var acm = ZFActorManager;
		var gs = GameState;
		for (var key in acm._actorList)
		{
			var actor =  acm._actorList[key];
			if (actor instanceof ZombieActor)
			{
				if (actor._fights >= ZFGameDefines.ZOMBIE_RANK_CAP )
				{
					masCt++;
				}
			}
		}
		
		if (masCt >= ZFGameDefines.ARMYINCREASEBY)
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.fight.all_masters" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievementAllMasters);
			return true;
		}
		
		return false;
	},

	checkAllVeterans: function () {
		var vetCt = 0;
		
		var acm = ZFActorManager;
		var gs = GameState;
		for (var key in acm._actorList)
		{
			var actor = acm._actorList[key];
			if (actor instanceof ZombieActor)
			{
				if (actor._fights > 0 )
				{
					vetCt++;
				}
			}
		}
		
		if (vetCt >= ZFGameDefines.ARMYINCREASEBY)
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.fight.all_veterans" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievementAllVeterans);
			return true;
		}
		
		return false;
	},

	checkFarmerBanner: function () {
		var sm = ZFStorageMenu.storageMenu();
		var gs = GameState;
		
		if (sm.doesOwnItem("oldMcDonnellBanner"))
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.farm.farm_banner" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievementFarmBanner);
		}
	},

	checkCorporateBanner: function () {
		var sm = ZFStorageMenu.storageMenu();
		var gs = GameState;
		
		if (sm.doesOwnItem("corporatevilleBanner"))
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.farm.city_banner" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievementFarmBanner);
		}
	},

	checkPirateBanner: function () {
		var sm = ZFStorageMenu.storageMenu();
		var gs = GameState;
		
		if (sm.doesOwnItem("pirateBanner"))
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.farm.pirate_banner" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievementPirateBanner);
		}
	},

	checkNinjaBanner: function () {
		var sm = ZFStorageMenu.storageMenu();
		var gs = GameState;
		
		if (sm.doesOwnItem("ninjaBanner"))
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.farm.ninja_banner" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievementNinjaBanner);
		}
	},

	checkRobotBanner: function () {
		var sm = ZFStorageMenu.storageMenu();
		var gs = GameState;
		
		if (sm.doesOwnItem("robotBanner"))
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.farm.robot_banner" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievementRobotBanner);
		}
	},

	checkAllBanners: function () {
		var sm = ZFStorageMenu.storageMenu();
		var gs = GameState;
		
		if (sm.doesOwnItem("oldMcDonnellBanner") &&
			sm.doesOwnItem("corporatevilleBanner") &&
			sm.doesOwnItem("pirateBanner") &&
			sm.doesOwnItem("pirateBanner") &&
			sm.doesOwnItem("robotBanner"))
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.farm.all_banners" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievementAllBanners);
			return true;
		}
		
		return false;
	},

	checkAllStorage: function () {
		var gs = GameState;
		if (gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE08))
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.farm.all_storage" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievementAllStorage);
			return true;
		}
		return false;
	},

	checkAllMutations: function () {
		var gs = GameState;
		if (gs._zfGameData._flagAllMutations)
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.farm.all_mutations" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievementAllMutations);
			return true;
		}
		return false;
	},

	checkAllGrounds: function () {
		var gs = GameState;
		if (gs._zfGameData._flagAllClimate)
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.farm.all_grounds" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievementAllGrounds);
			return true;
		}
		return false;
		
	},

	checkAllMonoliths: function () {
		var sm = ZFStorageMenu.storageMenu();
		var gs = GameState;
		
		if (sm.doesOwnItem("monolithZombie") &&
			sm.doesOwnItem("monolithPlowing") &&
			sm.doesOwnItem("monolithMutation") &&
			sm.doesOwnItem("monolithCombine") &&
			sm.doesOwnItem("monolithSpeed")) //please add any future monoliths here too
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.farm.all_monoliths" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievementAllMonoliths);
			return true;
		}
		return false;
	},

	checkAllGraves: function () {
		var sm = ZFStorageMenu.storageMenu();
		var gs = GameState;
		if (sm.doesOwnItem("gravestoneBlue") &&
			sm.doesOwnItem("gravestoneRed"))
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.farm.all_graves" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievementAllGraves);
			return true;
		}
		return false;
	},

	check1000Carrots: function () {
		var gs = GameState;
		
		if (gs._zfGameData._carrotsHarvested >= 1000)
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.farm.1000_carrots" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievement1000Carrots);
		}
	},

	check100Fertilize: function () {
		var gs = GameState;
		
		if (gs._zfGameData._timesFertilized >= 100)
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.farm.100_fertilize" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievement100Fertilize);

		}
	},

	checkMausoleumUnlock: function () {
		var gs = GameState;
		
		if (gs._zfGameData._mausoleumFlags & ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM_UNLOCKED)
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.farm.unlock_mausoleum" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievementUnlockMausoleum);
		}
	},

	checkFightsWon10: function () {
		var gs = GameState;
		var total = gs._zfGameData._farmerFightsWon + gs._zfGameData._lawyerFightsWon + gs._zfGameData._pirateFightsWon + gs._zfGameData._ninjaFightsWon + gs._zfGameData._robotFightsWon + gs._zfGameData._alienFightsWon + gs._zfGameData._seasonalFightsWon;
	    
		if (total >= 10)
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.fight.10_wins" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievement10Wins);
		}
	},

	checkFightsWon25: function () {
		var gs = GameState;
		var total = gs._zfGameData._farmerFightsWon + gs._zfGameData._lawyerFightsWon + gs._zfGameData._pirateFightsWon + gs._zfGameData._ninjaFightsWon + gs._zfGameData._robotFightsWon + gs._zfGameData._alienFightsWon + gs._zfGameData._seasonalFightsWon;
	    
		if (total >= 25)
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.fight.25_wins" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievement25Wins);
		}
	},

	checkFightsWon50: function () {
		var gs = GameState;
		var total = gs._zfGameData._farmerFightsWon + gs._zfGameData._lawyerFightsWon + gs._zfGameData._pirateFightsWon + gs._zfGameData._ninjaFightsWon + gs._zfGameData._robotFightsWon + gs._zfGameData._alienFightsWon + gs._zfGameData._seasonalFightsWon;
	    
		if (total >= 50)
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.fight.50_wins" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievement50Wins);
		}
	},

	checkAllZombieAbilities: function () {
		var gs = GameState;
		var missing = false;
		for (var i = 0; i < kAbilityBitsMAX ; i++)
		{
			if (!gs._zfGameData._abilityFlags.hasFlag(i))
			{
				missing = true;
				break;
			}
		}
		
		if (!missing)
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.fight.all_abilities" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievementAllAbilities);
		}
	},

	checkWinEnraged: function () {
		var fm = ZFFightMan;
		var gs = GameState;
		
		if (fm._enrageTime <= 0)
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.fight.win_enraged" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievementWinEnraged);
		}
	},

	checkWin1Minute: function () {
		var fm = ZFFightMan;
		var gs = GameState;
		
		if (fm._enrageTime > ZFGameDefines.FIGHT_TIMER - 60)
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.fight.1_minute_win" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievement1MinuteWin);
		}
	},

	checkWin1Survivor: function () {
		var fm = ZFFightMan;
		var gs = GameState;
		
		var numberOfZombies = 0;
		
		for(var key in fm._zombies)
		{
			z = fm._zombies[key];
			if(z._state == Actor.actorFightState.kActorFightStateDead || z._state == Actor.actorFightState.kActorFightStateDying)
				continue;
			
			numberOfZombies++;
		}
				
		if (numberOfZombies == 1)
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.fight.1_zombie_left" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievement1ZombieLeft);
		}
	},

	checkWinNoZombiesLost: function () {
		var fm = ZFFightMan;
		var gs = GameState;
		if (fm._zombieCasualty == 0)
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.fight.no_deaths" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievementNoDeaths);
		}
	},

	checkWin2OrLessDeaths: function () {
		var fm = ZFFightMan;
		var gs = GameState;
		if (fm._zombieCasualty <= 2)
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.fight.2_or_less_deaths" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievement2orLessDeaths);
		}
	},

	checkLosses10: function () {
		var gs = GameState;
		if (gs._zfGameData._fightLossCount >= 10)
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:"com.zombiefarm.fight.10_losses" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievement10Losses);
		}
	},
	
	checkWinAllTypes: function ()
	{
		
		var fm = ZFFightMan;
		var gs = GameState;
		var regular = false;
		var girl = false;
		var small = false;
		var large = false;
		var headless = false;
		var garden = false;
		
		for (var key in fm._zombies)
		{
			var zombie = fm._zombies[key];
			if (zombie instanceof ZombieActorRegular)
			{
				regular = true;
			}
			
			if (zombie instanceof ZombieActorGirl)
			{
				girl = true;
			}
			
			if (zombie instanceof ZombieActorSmall)
			{
				small = true;
			}
			
			if (zombie instanceof ZombieActorLarge)
			{
				large = true;
			}
			
			if (zombie instanceof ZombieActorHeadless)
			{
				headless = true;
			}
			
			if (zombie instanceof ZombieActorGarden)
			{
				garden = true;
			}
		}
		
		for (var key in fm._defeatedZombies)
		{
			var zombie = fm._defeatedZombies[key];
			if (zombie instanceof ZombieActorRegular)
			{
				regular = true;
			}
			
			if (zombie instanceof ZombieActorGirl)
			{
				girl = true;
			}
			
			if (zombie instanceof ZombieActorSmall)
			{
				small = true;
			}
			
			if (zombie instanceof ZombieActorLarge)
			{
				large = true;
			}
			
			if (zombie instanceof ZombieActorHeadless)
			{
				headless = true;
			}
			
			if (zombie instanceof ZombieActorGarden)
			{
				garden = true;
			}
		}
		
		if (regular && girl && small && large && headless && garden)
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:@"com.zombiefarm.fight.all_zombie_types" percentComplete:100.f];
			gs._zfGameData._achievementFlags.setFlag(kAchievementAllZombieTypes);
		}
	},

	checkZombieFights10: function ()
	{	
		var acm = ZFActorManager;
		var gs = GameState;
		for (var key in acm._actorList)
		{
			var actor = acm._actorList[key];
			if (actor instanceof ZombieActor)
			{
				if (actor._fights > 10)
				{
//					[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:@"com.zombiefarm.fight.10_fight_zombie" percentComplete:100.f];
					gs._zfGameData._achievementFlags.setFlag(kAchievement10FightZombie);
					return true;
				}
			}
		}
		
		return false;
	},

//	#pragma mark -
	checkAllAchievments: function ()
	{
		this.checkFarmTutorialDone();
		this.checkFightTutorialDone();
		this.checkAllMasters();
		this.checkAllVeterans();
		this.checkFarmerBanner();
		this.checkCorporateBanner();
		this.checkPirateBanner();
		this.checkNinjaBanner();
		this.checkRobotBanner();
		this.checkAllBanners();
		this.checkAllStorage();
		this.checkAllMutations();
		this.checkAllGrounds();
		this.checkAllMonoliths();
		this.checkAllGraves();
		this.check1000Carrots();
		this.check100Fertilize();
		this.checkMausoleumUnlock();
		this.checkFightsWon10();
		this.checkFightsWon25();
		this.checkFightsWon50();
		this.checkAllZombieAbilities();
		//this.checkWinEnraged();
		//this.checkWin1Minute();
		//this.checkWin1Survivor();
		//this.checkWinNoZombiesLost();
		//this.checkWin2OrLessDeaths();
		this.checkLosses10();
		//this.checkWinAllTypes();
		this.checkZombieFights10();
	}

});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/ZFMenus/ZFMenu'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/ZFMenu'] || {}; $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/ZFMenu'] = exports; var CCMenuItem = require('Code/Cocos2D/CCMenuItem').CCMenuItem;


////new cocos requires a CCColorLayer that monitors touches to overwrite this function
//@implementation DimLayer
//
////Raises HELL
///*-(void) registerWithTouchDispatcher
//{
////Make sure this number is one greater than the menu it will be behind
//[[CCTouchDispatcher sharedDispatcher] addTargetedDelegate:self priority:91 swallowsTouches:YES];
//}*/
//
//-(BOOL) ccTouchBegan:(UITouch *)touch withEvent:(UIEvent *)event
//{
//return NO;
//}
//
//@end
//
//@implementation CCMenuItemLayer
//
//@synthesize itemLayer;
//
//+(id) itemFromLayer:(CCColorLayer*)layer target:(id)target selector:(SEL)selector
//{
//return [[self alloc] initFromLayer:layer target:target selector:selector];
//}
//
//-(id) initFromLayer:(CCColorLayer*)layer target:(id)target selector:(SEL)selector
//{
//if( (self=[super initWithTarget:target selector:selector]) ) {
//
//self.itemLayer = layer;
//
//[self setContentSize: [itemLayer contentSize]];
//}
//return self;	
//}
//-(void) draw
//{
//[itemLayer draw];
//}
//
//- (void) dealloc
//{
//[itemLayer release];
//[super dealloc];
//}
//@end
//

var DimLayer = CCColorLayer.subclass(
{
	classname: "DimLayer"
});

exports.DimLayer = DimLayer;

exports.ZFMenu = CCLayer.subclass(
{
	classname: "ZFMenu",
	
	menuStates:
	{
		menuStateClosed : 1,
		menuStateOpening : 2,
		menuStateOpen : 3,
		menuStateClosing : 4,
		menuStateCleanup : 5,
		menuStateHalfOpen : 6,
		menuStateHalfOpening : 7,
		menuStateHalfClosing : 8,
		menuStateHalfClosed : 9,
		menuStateMAX : 10
	},

	kZFMenuTags:
	{
		kZFMenuTagBackground : 1,
		kZFMenuTagBrowse : 2,
		kMenuTagMAX : 3
	},
	
	initialize: function()
	{
		this._winSize =  CCDirector.winSize();
		var winSize = this._winSize;
		this._widthScale = UI.Window._width / 480.0; 
		this._heightScale = UI.Window._height / 320.0;
		
		this._dimLayer = new DimLayer();
		this._dimLayer.initWithColor(ccc4(0x0,0x0,0x0,0x80), 
				winSize._width,
				winSize._height);
		this._dimLayer.setPosition(CGPointMake(0, this._winSize._height/2));
		
		
//		//iPad stuff
		this._bounds = this._winSize; //TODO: temporary
		var w = new Core.Size(480, 320);
		//		CGRect mainFrame = [[UIScreen mainScreen] bounds];
		this._resolutionWidth = this._bounds._height;
		this._resolutionHeight = this._bounds._width;
		this._widthOffset =  (this._resolutionHeight  - 480) / 2;
		this._heightOffset = -(this._resolutionWidth - 320) / 2;
//		//end iPad stuff
		

		//dimLayer.isTouchEnabled = NO; 
		this._menuState = this.menuStates.menuStateClosed;
		this._currentPage = 0;
		this._maxMenuPages = 0;
		this.setVisible(false);
		this.setPosition(this.closePos());
		if(this._menu)
			this.disableMenus();
		this.setContentSize(winSize);
		this._isTouchEnabled = true;
		
		if(!this._windowNode)
			this._windowNode = CCColorLayer.layerWithColor(ccc4(0, 0, 0, 0), this._winSize._width, this._winSize._height);
		this.addChild(this._windowNode, 0);
	},

	initElementsWithWindowScale: function(widthScale, heightScale, originX, originY)
	{  
		var winSize = new Core.Size(UI.Window._width, UI.Window._height);
		var w = new Core.Size(480, 320);
		//// TESTING BETTER BG SPRITESHEET ! (PS: IT WORKS) //
		var windowSize = new Core.Rect(0, 320, 480 * widthScale, 320 * heightScale);
		var c = new Core.Rect(1,1,34,42);
		var b = new Core.Rect(36, 1, 30, 38);
		var s = new Core.Rect(1, 44, 34, 24);
		var f = "hudElements.png";
		var color =   ccc3(237, 226, 177);

		this._windowNode.removeChild(this._bgOverlay,true);
		destroyWithChildren(this._bgOverlay);
		
		this._bgOverlay = this.makeWindow(windowSize, c,b, f, color, new Core.Rect(0,0,0,0), new Core.Rect(0,0,0,0), s);
		
		if(this._backgroundSpriteSheet){
			if(this._backgroundSpriteSheet.getParent())
				this._backgroundSpriteSheet.getParent().removeChild(this._backgroundSpriteSheet);
			destroyWithChildren(this._backgroundSpriteSheet);
		}
		
		this._backgroundSpriteSheet = this._bgOverlay.getChildByTag(1);
		this._bgOverlay.setPosition(ccp(originX, originY));
		this._windowNode.addChild(this._bgOverlay, 1, this.kZFMenuTags.kZFMenuTagBackground);
		
		if(this._dimLayer){
			if(this._dimLayer.getParent())
				this._dimLayer.getParent().removeChild(this._dimLayer);
			destroyWithChildren(this._dimLayer);
			this._dimLayer = null;
		}
		
		this._dimLayer = new DimLayer(); 
		this._dimLayer.initWithColor(ccc3(0,0,0), winSize._width, winSize._height);
		this._dimLayer.setOpacity(128);
		
		this._dimLayer.setPosition(ccp(0, winSize._height/2));//this._dimLayer.setPosition(ccp(0,0));
		this._windowNode.addChild(this._dimLayer);
	
		var dismissItem = new CCMenuItemImage();
		dismissItem.initFromNormalImage("bigX.png", "bigXSel.png", this, this.dismissMenu.bind(this));
		dismissItem.setScale(0.8);
		
		this._windowNode.removeChild(this._dismissMenu,true);
		destroyWithChildren(this._dismissMenu);
		
		this._dismissMenu = CCMenu.menuWithItems([dismissItem]);
		this._dismissMenu.setPosition(ccp(w._width + this._widthOffset - 20 - dismissItem.getSize()._width/2*0.8, w._height - this._heightOffset - 20  - dismissItem.getSize()._height/2*0.8));
	//	ccp((w.width+widthOffset) - 20, (w.height+heightOffset) - 20)
	//	this._dismissMenu.alignItemsHorizontallyWithPadding(0);
		this._windowNode.addChild(this._dismissMenu, 100);	

	},
	
	initElements: function()
	{
		this.initElementsWithWindowScale(1,1, this._widthOffset, this._heightOffset);
	},

	initBrowseMenuWithPosition: function(pt, dt)
	{	    
		destroyWithChildren(this._forwardItem);
		this._forwardItem = new CCMenuItemImage();
		this._forwardItem.initFromNormalImage("browseButton.png", "browseButtonSel.png", this, this.browseForward.bind(this));
		this._forwardItem.setScale(-1, 1);
		this._forwardItem.setAnchorPoint(ccp(0, 0.5));
		
		destroyWithChildren(this._backItem);
		this._backItem = new CCMenuItemImage();
		this._backItem.initFromNormalImage("browseButton.png", "browseButtonSel.png", this, this.browseBackward.bind(this));
		this._backItem.setAnchorPoint(ccp(0, 0.5));

		destroyWithChildren(this._browseMenu);
		this._browseMenu = CCMenu.menuWithItems([this._backItem, this._forwardItem]);
		this._browseMenu.alignItemsHorizontallyWithPadding(dt);
		this._browseMenu.setPosition(ccpAdd(pt, ccp(this._widthOffset, -this._heightOffset)));
		//browseMenu.anchorPoint = ccp(.5f, .5f);
		this._windowNode.addChild(this._browseMenu, 10, this.kZFMenuTags.kZFMenuTagBrowse);	
		
		this._forwardItem._touchTarget.setAnchor(ccp( 1, -0.5));
		this._backItem._touchTarget.setAnchor(ccp( 0, -0.5));
	},
	
	browseForward: function()
	{
		this._currentPage++;
		this._currentPage = (this._currentPage > this._maxMenuPages) ? this._maxMenuPages : this._currentPage;
		this.displayPage(this._currentPage);
	},

	browseBackward: function()
	{
		this._currentPage--;
		this._currentPage = (this._currentPage < 0) ? 0 : this._currentPage;
		this.displayPage(this._currentPage);
	},
	
	disableMenus: function()
	{
		if(this._menu)
		for(var i in this._menu._children)
		{
			var it = this._menu._children[i];
			it.isEnabled = false;
		}		
		
		if(this._dismissMenu)
		for(var i in this._dismissMenu._children)
		{
			var it = this._dismissMenu._children[i];
			it.isEnabled = false;
		}

		if(this._browseMenu)
		{
			for(var i in this._browseMenu._children)
			{
				var it = this._browseMenu._children[i];
				it.isEnabled = false;
			}
		}

		try
		{
			if(this._dimLayer){
				if(this._windowNode._children.indexOf(this._dimLayer) >= 0){
					this._windowNode.removeChild(this._dimLayer);
				}    			
				this._windowNode.addChild(this._dimLayer, 0);
			}
		}
		catch (e)
		{
			console.log("zfmenu exception (dimlayer):" +e );
		}
	},
	
	enableMenus: function()
	{
		if(this._menu)
		for(var i in this._menu._children)
		{
			var it = this._menu._children[i];
			it.isEnabled = true;
		}
		
		if(this._dismissMenu)
		for(var i in this._dismissMenu._children)
		{
			var it = this._dismissMenu._children[i];
			it.isEnabled = true;
		}

		if(this._browseMenu)
		for(var i in this._browseMenu._children)
		{
			var it = this._browseMenu._children[i];
			it.isEnabled = true;
		}

		try
		{
    		if(this._dimLayer)
    		{
    			if(this._windowNode._children.indexOf(this._dimLayer) >= 0){
    				this._windowNode.removeChild(this._dimLayer);
    			}    			
    			this._windowNode.addChild(this._dimLayer, 0);
    		}
		} catch (e)
		{
			console.log("zfmenu EXCEPTION: Enable Menu (dimlayer ): " + e);
		}
	},
	
	openPos: function()
	{
		return ccp(0, 0);
	},
	
	closePos: function()
	{
		return ccp(0, -this._bounds._width);
	},
	
	cleanWindow: function(tagId)
	{
		var window = this._windowNode.getChildByTag(tagId);
		if(window)
		{
		    this._windowNode.removeChildByTag(tagId, true);
		    
			// sprite sheet is always tag == 1, color layer tag == 0
			var spriteSheet = window.getChildByTag(1);
			destroyWithChildren(spriteSheet);
			
			var colorLayer = window.getChildByTag(0);
			destroyWithChildren(colorLayer);
		}	
	},

	displayPage: function(pageID)
	{
		console.log("ZFMenu.displayPage - override me");
	},

	initBannerWithString: function(title, dimensions, fontSize)
	{
		if(this._backgroundSpriteSheet)
		{
			destroyWithChildren(this._menuBanner);
			this._menuBanner = new CCSprite();
			this._menuBanner.initWithSpriteSheet(this._backgroundSpriteSheet, new Core.Rect(144, 376, 200, 47));
			this._backgroundSpriteSheet.addChild(this._menuBanner, 25);
			this._menuBanner.setScale(ccp(1.25, 1));
			//menuBanner.position = ccpSub(p, CGPointMake(widthOffset, heightOffset));
			this._menuBanner.setPosition(ccp( 240 /*- this._menuBanner.getSize()._width/2 + this._widthOffset*/ ,  this._winSize._height ));
			this._menuBanner.setAnchorPoint(ccp(0.5, 1));
		}

		destroyWithChildren(this._menuTitle);
		this._menuTitle = CCLabel.labelWithString(title , dimensions,  GL2.Text.HorizontalAlign.Center , "AmericanTypewriter-Bold", fontSize); 
		this._menuTitle.setColor(ccc3(0,0,0));
		this._menuTitle.setPosition(ccp( 0, 0 ));
		this._menuTitle.setAnchorPoint(ccp(0.5, 0));
		//this._menuTitle._label.setSize(this._menuBanner.getSize());
		this._menuTitle.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
		this._menuTitle.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
		
		this._menuBanner.addChild(this._menuTitle, 2);
	},
	
	initPleaseWaitLayer: function()
	{
//		return;
		var w = CCDirector.winSize();
		destroyWithChildren(this._pleaseWaitLayer);
		this._pleaseWaitLayer = CCColorLayer.layerWithColor(ccc3(0,0,0), w.getWidth(), w.getHeight());
		this._pleaseWaitLayer.setPosition(0, w.getHeight()/2);
		this._pleaseWaitLayer.setOpacity(128);
		
		var waitLabel = new CCLabel();
		waitLabel.initWithString(Core.Localization.getString("Please wait..."),"AmericanTypewriter-Bold", 48);
		waitLabel.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
		waitLabel.setColor(ccc3(255,255,255));
		waitLabel.setPosition(w.getWidth()/2, 0);
		this._pleaseWaitLayer.addChild(waitLabel, 100);
	},
		
	//(CCLayer*)makeWindow:(CGRect)w corner:(CGRect)c bar:(CGRect)b file:(NSString*)f color:(ccColor4B)c4 bcorner:(CGRect)bc bbar:(CGRect)bb side:(CGRect)s
	$makeWindow: function(w, c, b, f, c4, bc, bb, s, mausHack)
	{	    
        if (!bc)
        {
            bc = new Core.Rect(0, 0, 0, 0);
        }
        
        if (!bb)
        {
            bb = new Core.Rect(0, 0, 0, 0);
        }
        
        if (!s)
        {
            s = new Core.Rect(0, 0, 0, 0);
        }
        
        var winSize = new Core.Size(UI.Window._width, UI.Window._height);
        var heightOffset = -(winSize._height - w.getSize()._height) / 2;
        
        var window = new CCLayer();
        var windowSpriteSheet = new CCSpriteSheet();
        windowSpriteSheet.initWithFile(f);
        //TODO: [windowSpriteSheet.texture setAliasTexParameters];
        
        ////////////// extra code to make this work with or without certain tiles /////////////
        
        ////////////////////
        // temp variables //
        ////////////////////
        var cornerAnchorY = 0;
        var bottomAnchorY = 0;
        var sideAnchorLX = 0;
        var sideAnchorRY = 0;
        var sideSize = 0;
        var colorLayerWidthOffset = 0;
        
        var rotateSide = 0.0;
        
        var cornerFlipY = false;
        var barFlipY = false;
        var sideFlipX = false;
        var sideFlipY = false;
        
        var bcTemp;
        var bbTemp;
        var sTemp;
        ///////////////////////////////////////////////////////////////////////////////////
        // check if nil tiles and adjust anchor points,rotations, and scales accordingly //
        ///////////////////////////////////////////////////////////////////////////////////
        
        // if bottom corner does not exist
        if (bc.getSize()._width == 0)
        {
            cornerFlipY = -1;
            cornerAnchorY = 0;
            bcTemp = c;
        }
        else
        {
            cornerFlipY = 1;
            cornerAnchorY = 0;
            bcTemp = bc;
        }
        // if bottom bar does not exist
        if (bb.getSize()._width == 0)
        {
            barFlipY = true;
            bottomAnchorY = 0;
            bbTemp = b;
        }
        else
        {
            barFlipY = false;
            bottomAnchorY = 1;
            bbTemp = bb;
        }
        // if side bar does not exist
        if (s.getSize()._width == 0)
        {
            rotateSide = -90.0;
            sTemp = b;
            sideAnchorLX = 1;
            sideAnchorRY = 0;
            //sideFlipX = false;
            //sideFlipY = true;
            //sideSize = b.getSize()._width;
            //colorLayerWidthOffset = b.getSize()._height * 2;
        }
        else
        {
            rotateSide = 0.0;
            sTemp = s;
            sideAnchorLX = 0;
            sideAnchorRY = 1;
            //sideFlipX = true;
            //sideFlipY = false;
            //sideSize = s.getSize()._height;
            //colorLayerWidthOffset = s.getSize()._width * 2;
        }
        
        widthSegment = (!rotateSide) ? sTemp.getSize()._width : sTemp.getSize()._height;
        var windowColor = CCColorLayer.layerWithColor(c4, w.getSize()._width - widthSegment * 2 + 2, w.getSize()._height);
        
        //FIXME: find why that doesn't work...
        //if(c4._a != undefined) windowColor.setOpacity(c4._a * 255); 
        
        var cornerTL = new CCSprite();
        var cornerTR = new CCSprite();
        var cornerBL = new CCSprite();
        var cornerBR = new CCSprite();
        cornerTL.initWithSpriteSheet(windowSpriteSheet, c);
        cornerTR.initWithSpriteSheet(windowSpriteSheet, c);
        cornerBL.initWithSpriteSheet(windowSpriteSheet, bcTemp);
        cornerBR.initWithSpriteSheet(windowSpriteSheet, bcTemp);
        
        cornerTR.setScale(-1, 1);
        cornerBR.setScale(-1, cornerFlipY);
        cornerBL.setScale(1, cornerFlipY);
        
        var i = cornerTL.getSize()._width;
        var size = w.getSize()._width - cornerTL.getSize()._width - cornerTR.getSize()._width + 6;
        
        var segmentSize = b.getSize()._width;

        // horizontal bars
        var BarT = new CCSprite();
        var BarB = new CCSprite();
        
        BarT.initWithSpriteSheet(windowSpriteSheet, b, ccp(0, 0));
        BarB.initWithSpriteSheet(windowSpriteSheet, bbTemp, ccp(0, 1 - bottomAnchorY));
        windowSpriteSheet.addChild(BarT, 1, 0);
        BarT.setPosition(ccp(i - 1, w.getSize()._height - heightOffset * 2));
        BarB.setPosition(ccp(i - 1, -heightOffset * 2 + BarB.getSize()._height));
        windowSpriteSheet.addChild(BarB, 1, 0);
        
        var scaleY = -1;
        if(mausHack)
        	scaleY = 1;
        
        BarB.setScale(size/BarB.getContentSize().getWidth(), scaleY);
        BarT.setScale(size/BarT.getContentSize().getWidth(), 1);
        
        // vertical bars (rotated horizontal bars)
        
        // i = y value after top left corner is placed
        i = cornerBR.getSize()._height;
        size = w.getSize()._height - cornerBL.getSize()._height - cornerBR.getSize()._height + 4;
        
        segmentSize = (rotateSide) ? sTemp.getSize()._width : sTemp.getSize()._height;
        segmentSizeX = (rotateSide == 0) ? sTemp.getSize()._width : sTemp.getSize()._height;

        var BarL = new CCSprite();
        var BarR = new CCSprite();
        
        BarL.initWithSpriteSheet(windowSpriteSheet, sTemp, ccp(0.5, 0.5));
        BarR.initWithSpriteSheet(windowSpriteSheet, sTemp, ccp(0.5, 0.5));
        
        BarR.setPosition(ccp(w.getSize()._width, -heightOffset * 2 + i - 1));
        BarL.setPosition(ccp(0, -heightOffset * 2 + i - 1));
        
        //BarR.setScale(-1, 1);		
        BarR.setFlipX(true);
        
        BarL.setRotation(rotateSide);
        BarR.setRotation(rotateSide);
        
        if (rotateSide != 0)
        {   
            BarR.setPosition(ccp(w.getSize()._width + segmentSizeX, -heightOffset * 2 + i - 1));
            BarL.setPosition(ccp(0 - segmentSizeX, -heightOffset * 2 + i - 1));
            BarL.setAnchorPoint(ccp(0, 0.5));
            BarR.setAnchorPoint(ccp(0, 0.5));
        }
            
        BarR.setAnchorPoint(ccp(0, 0));
        BarL.setAnchorPoint(ccp(0, 0));
            
        windowSpriteSheet.addChild(BarR, 1, 0);
        windowSpriteSheet.addChild(BarL, 1, 0);

        BarL.setScale(1, size/BarL.getContentSize().getHeight());
        BarR.setScale(1, size/BarR.getContentSize().getHeight());
        
        // add corners to the sprite sheet
        windowSpriteSheet.addChild(cornerTL, 1, 0);
        cornerTL.setPosition(ccp(0, w.getSize()._height - heightOffset * 2));
        
        windowSpriteSheet.addChild(cornerTR, 1, 0);
        cornerTR.setPosition(ccp(w.getSize()._width, w.getSize()._height - heightOffset * 2));
        
        windowSpriteSheet.addChild(cornerBL, 1, 0);
        cornerBL.setPosition(ccp(cornerBL.getSize()._width / 2, -heightOffset * 2 + cornerBR.getSize()._height / 2));
        
        windowSpriteSheet.addChild(cornerBR, 1, 0);
        cornerBR.setPosition(ccp(w.getSize()._width - cornerBR.getSize()._width / 2, -heightOffset * 2 + cornerBR.getSize()._height / 2));
        
        // add all children to the layer then return
        window.addChild(windowSpriteSheet, 100, 1);
        window.addChild(windowColor, 1, 0);
        
        // set back windowcolor
        windowColor.setPosition(ccp(widthSegment, -heightOffset * 2 + w.getSize()._height / 2));
        
        cornerTL.setAnchorPoint(ccp(0, 1));
        cornerTR.setAnchorPoint(ccp(0, 1));
        //cornerBL.setAnchorPoint(ccp(0,cornerAnchorY));
        //cornerBR.setAnchorPoint(ccp(0,cornerAnchorY));
        
        return window;
	},
	
	
	/// fixme
	//(CCLayer*)makeWindow:(CGRect)w corner:(CGRect)c bar:(CGRect)b file:(NSString*)f color:(ccColor4B)c4 bcorner:(CGRect)bc bbar:(CGRect)bb side:(CGRect)s
    $makeWindowOld: function(w, c, b, f, c4, bc, bb, s)
    {       
        if(!bc) bc = new Core.Rect(0,0,0,0);
        if(!bb) bb = new Core.Rect(0,0,0,0);
        if(!s) s = new Core.Rect(0,0,0,0);
        
        var winSize =  new Core.Size(UI.Window._width, UI.Window._height);
//        var widthOffset =  (winSize._width  - w.getSize()._width) / 2;
        var heightOffset = -(winSize._height - w.getSize()._height) / 2;
        
        var window = new CCLayer();
        window.__debugTag = "CCMenu.makeWindow item";
        var windowSpriteSheet = new CCSpriteSheet();
        windowSpriteSheet.initWithFile(f);
        windowSpriteSheet.__debugTag = "CCMenu.makeWindow item";
//TODO: [windowSpriteSheet.texture setAliasTexParameters];
        
////////////// extra code to make this work with or without certain tiles /////////////

        ////////////////////
        // temp variables //
        ////////////////////
        var cornerAnchorY = 0;
        var bottomAnchorY = 0;
        var sideAnchorLX = 0;
        var sideAnchorRY = 0;
        var sideSize = 0;
        var colorLayerWidthOffset = 0;
        
        var rotateSide = 0.0;
        
        var cornerFlipY = false;
        var barFlipY = false;
        var sideFlipX = false;
        var sideFlipY = false;
        
        var bcTemp;
        var bbTemp;
        var sTemp;
        ///////////////////////////////////////////////////////////////////////////////////
        // check if nil tiles and adjust anchor points,rotations, and scales accordingly //
        ///////////////////////////////////////////////////////////////////////////////////
        
        // if bottom corner does not exist
        if(bc.getSize()._width == 0)
        {
            cornerFlipY = -1;
            cornerAnchorY = 0;
            bcTemp = c;
        }   
        else
        {
            cornerFlipY = 1;
            cornerAnchorY = 0;
            bcTemp = bc;
        }
        // if bottom bar does not exist
        if(bb.getSize()._width == 0)
        {
            barFlipY = true;
            bottomAnchorY = 0;
            bbTemp = b;
        }
        else 
        {
            barFlipY = false;
            bottomAnchorY = 1;
            bbTemp = bb;
        }
        // if side bar does not exist
        if(s.getSize()._width == 0)
        {
            rotateSide = -90.0;
            sTemp = b;
            sideAnchorLX = 1;
            sideAnchorRY = 0;
//          sideFlipX = false;
//          sideFlipY = true;
//          sideSize = b.getSize()._width;
//          colorLayerWidthOffset = b.getSize()._height * 2;
        }
        else 
        {
            rotateSide = 0.0;
            sTemp = s;
            sideAnchorLX = 0;
            sideAnchorRY = 1;
//          sideFlipX = true;
//          sideFlipY = false;
//          sideSize = s.getSize()._height;
//          colorLayerWidthOffset = s.getSize()._width * 2;
        }
            
            widthSegment = (!rotateSide)?sTemp.getSize()._width:sTemp.getSize()._height ;
            var windowColor = CCColorLayer.layerWithColor(c4, w.getSize()._width - widthSegment*2+2, w.getSize()._height );
        
            //FIXME: find why that doesn't work...
        //  if(c4._a != undefined) windowColor.setOpacity(c4._a * 255); 
            
            var cornerTL = new CCSprite(); var cornerTR = new CCSprite(); var cornerBL = new CCSprite(); var cornerBR = new CCSprite();
            cornerTL.initWithSpriteSheet(windowSpriteSheet, c);
            cornerTR.initWithSpriteSheet(windowSpriteSheet, c);
            cornerBL.initWithSpriteSheet(windowSpriteSheet, bcTemp);
            cornerBR.initWithSpriteSheet(windowSpriteSheet, bcTemp);

            
            cornerTR.setScale(-1, 1);
            cornerBR.setScale(-1, cornerFlipY);
            cornerBL.setScale(1, cornerFlipY);
        
            var i = cornerTL.getSize()._width;
            var size = w.getSize()._width - cornerTR.getSize()._width; 

            var segmentSize = b.getSize()._width;
            // place horizontal bars
            while(i < size)
            {               
                var BarT = new CCSprite();
                var BarB = new CCSprite();
                
                BarT.initWithSpriteSheet(windowSpriteSheet, b, ccp(0,0));
                BarB.initWithSpriteSheet(windowSpriteSheet, bbTemp, ccp(0,1-bottomAnchorY));

                windowSpriteSheet.addChild(BarT, 1, 0);
                
                if(i + segmentSize > size)
                    i = size - segmentSize + 1;
                
                BarT.setPosition(ccp(i, w.getSize()._height - heightOffset*2 ));
                windowSpriteSheet.addChild(BarB, 1, 0);
                BarB.setPosition(ccp(i, -heightOffset*2 + BarB.getSize()._height));
                BarB.setScale(1, -barFlipY);
                                
                i += segmentSize - 1;
            }
            

            // i = y value after top left corner is placed
            i = cornerBR.getSize()._height;
            
            size = w.getSize()._height - cornerBR.getSize()._height;
            
            
            // place vertical bars (rotated horizontal bars)
            segmentSize = (rotateSide)?sTemp.getSize()._width:sTemp.getSize()._height ;
            segmentSizeX = (rotateSide==0)?sTemp.getSize()._width:sTemp.getSize()._height ;
            var yOffset = -2;// (!rotateSide)?0:segmentSize / 2;
            while(i < size)
            {
                var BarL = new CCSprite();
                var BarR = new CCSprite();

                BarL.initWithSpriteSheet(windowSpriteSheet, sTemp, ccp(0.5, 0.5));
                BarR.initWithSpriteSheet(windowSpriteSheet, sTemp, ccp(0.5, 0.5));
        
                BarR.setPosition(ccp(w.getSize()._width ,   -heightOffset*2 + i + yOffset));
                BarL.setPosition(ccp(0  ,                       -heightOffset*2 + i + yOffset));
                
//              BarR.setScale(-1, 1);       
                BarR.setFlipX(true);
                
                BarL.setRotation(rotateSide);
                BarR.setRotation(rotateSide);
                
                if(rotateSide != 0)
                {
                    BarR.setPosition(ccp(w.getSize()._width + segmentSizeX,     -heightOffset*2 + i ));
                    BarL.setPosition(ccp(0  - segmentSizeX,                         -heightOffset*2 + i ));
                     BarL.setAnchorPoint(ccp(0, 0.5));
                     BarR.setAnchorPoint(ccp(0, 0.5));
                }
                
                BarR.setAnchorPoint(ccp(0,0));
                BarL.setAnchorPoint(ccp(0,0));
                
                windowSpriteSheet.addChild(BarR, 1, 0);
                windowSpriteSheet.addChild(BarL, 1, 0);

                i += segmentSize -1;
            }
    
        // add corners to the sprite sheet
        windowSpriteSheet.addChild(cornerTL, 1, 0);
        cornerTL.setPosition(ccp(0, w.getSize()._height - heightOffset*2));
        
        windowSpriteSheet.addChild(cornerTR, 1, 0);
        cornerTR.setPosition(ccp( w.getSize()._width, w.getSize()._height - heightOffset*2  ));
        
        windowSpriteSheet.addChild(cornerBL, 1, 0);
        cornerBL.setPosition(ccp( cornerBL.getSize()._width/2, -heightOffset*2 + cornerBR.getSize()._height/2 ));
        
        windowSpriteSheet.addChild(cornerBR, 1, 0);
        cornerBR.setPosition(ccp( w.getSize()._width-cornerBR.getSize()._width/2, -heightOffset*2 + cornerBR.getSize()._height/2  ));
        
        // add all children to the layer then return
        window.addChild(windowSpriteSheet, 100, 1);
        window.addChild(windowColor, 1, 0);
        
        // set back windowcolor
        windowColor.setPosition(ccp( widthSegment, -heightOffset * 2 + w.getSize()._height/2 ));
    
        cornerTL.setAnchorPoint(ccp(0,1));
        cornerTR.setAnchorPoint(ccp(0,1));
//      cornerBL.setAnchorPoint(ccp(0,cornerAnchorY));
//      cornerBR.setAnchorPoint(ccp(0,cornerAnchorY));
        
        return window;
    },
	/// fixme
	
	
		
//+ (CCLayer*)makeDividerwithSize:(float)size bar:(CGRect)b file:(NSString*)f color:(ccColor3B)c3 
//{
//CGRect mainFrame = [[UIScreen mainScreen] bounds];
//float resolutionWidth = mainFrame.size.height;
//float resolutionHeight = mainFrame.size.width;
//float widthOffset = (resolutionWidth - 480.0f)/2;
//float heightOffset = (resolutionHeight - 320.0f)/2;
//
//int i = 0;
//CCLayer *retLayer = [[[CCLayer alloc] init] autorelease];
//// place horizontal bars
//while(i < size)
//{
//	CCSprite *BarT = nil;
//	
//	if(i + b.size.width > size)
//	{
//		BarT = [CCSprite spriteWithFile:f rect:CGRectMake(b.origin.x, b.origin.y,size - i, b.size.height)];
//	}
//	else
//	{
//		BarT = [CCSprite spriteWithFile:f rect:b];		
//	}
//	BarT.color = c3;
//	BarT.anchorPoint = ccp(0,.5);
//	[retLayer addChild:BarT z:1 tag:0];
//	BarT.position = ccp(i+widthOffset,-35+heightOffset);		
//	i += b.size.width;
//}
//
//return retLayer;
//}

	//do checks for being able to open menu before calling this function
	openMenu: function()
	{
	    BackButtonHandler.push(this);
	    
	    if (!this._touchBlocker)
	    {
	        this._touchBlocker = new TouchBlocker();
	        this.addChild(this._touchBlocker.getNode(), -1);
	    }
	    
		var gui = ZFGuiLayer.gui();
		this.initElements();
		gui.removeToolTip();
		this.setVisible(true);
		var actionTo = CCMoveTo.actionWithDuration(0.25, this.openPos());
		this.runAction(actionTo);
		this.schedule(this.openTimerCallback, this.openTimerTime());
		this._menuState = this.menuStates.menuStateOpening;
		this.displayPage(this._currentPage);
		SimpleAudioEngine.playEffect(kMenuOpenSFX);
	},
	
	openTimerTime : function()
	{
		return 0.25;
	},

	openTimerCallback: function()
	{
		this.unschedule(this.openTimerCallback);
		this._menuState = this.menuStates.menuStateOpen;
		
		this.enableMenus();
		
		//if(dimLayer)
		//{
//			if(!dimLayer.parent)
//			{
//				[self addChild:dimLayer z:0];
//			}
		//
//			// Haulting here do to this call. Looks like its not needed, dim layer still protects
//			//[[CCTouchDispatcher sharedDispatcher] addTargetedDelegate:dimLayer priority:90 swallowsTouches:YES];
		//}
		
		ZFGuiLayer.disableMenus();
	},

	dismissMenu: function(sender)
	{
		var actionTo = CCMoveTo.actionWithDuration(0.25, this.closePos());
		
		this.runAction(actionTo);
		this.schedule(this.dismissTimerCallback, 0.25);
		this._menuState = this.menuStates.menuStateClosing;
		
		
		if(this._dimLayer){
			this._windowNode.removeChild(this._dimLayer);
			destroyWithChildren(this._dimLayer);
			this._dimLayer = null;
		}
		this.disableMenus();
//		destroyWithChildren(this._dimLayer);
//		this._dimLayer = null;
		
		//[[CCTouchDispatcher sharedDispatcher] removeDelegate:dimLayer];
		SimpleAudioEngine.playEffect(kMenuCloseSFX);
		//
		//[[CCTextureCache sharedTextureCache] removeUnusedTextures];
	},
	
	dismissTimerCallback: function()
	{	    
//		console.log("dismissTimerCallback");
	
	    BackButtonHandler.removeElement(this);
	    
	    this.removePleaseWait();
		if (this._touchBlocker)
		{
		    if (this._children.indexOf(this._touchBlocker) >= 0)
		    {
		        this.removeChild(this._touchBlocker);
		    }
		    
		    this._touchBlocker.destroy();
		    this._touchBlocker = null;
		}
		
		//cleanup here
		this.cleanWindow(this.kZFMenuTags.kZFMenuTagBackground);
		destroyWithChildren(this._backgroundSprite);
		this._backgroundSprite = null;
		
		
		
//		if(this._dismissMenu)
//		{
//			this._windowNode.removeChild(this._dismissMenu, true);
//			destroyWithChildren(this._dismissMenu);
//		}
//		
//		if(this._browseMenu)
//		{
//			this._windowNode.removeChild(this._browseMenu, true);
//			destroyWithChildren(this._browseMenu);
//		}
//
//		if(this._menu)
//		{
//			this._windowNode.removeChild(this._menu, true);
//			destroyWithChildren(this._menu);
//		}
//		
//		if(this._menuTitle)
//		{
//			this._windowNode.removeChild(this._menuTitle, true);
//			destroyWithChildren(this._menuTitle);
//		}

		for (var i = this._windowNode._children.length-1; i >= 0; i--) {
			var child = this._windowNode._children[i];
			if(!child._inmortal){
				this._windowNode.removeChild(child, true);
				destroyWithChildren(child);
				child = null;
			}
		}
		
		this.setVisible(false);
		this.unschedule(this.dismissTimerCallback);
		this._menuState = this.menuStates.menuStateClosed;
		
		ZFGuiLayer.enableMenus();
	},
	
	displayPleaseWait: function()
	{
		if(!this._pleaseWaitLayer || this._pleaseWaitLayer._parent )
		{
			return;
		}
		
		this.addChild(this._pleaseWaitLayer, 50);
		if (!this._touchBlocker)
	    {
	        this._touchBlocker = new TouchBlocker();
	        this.addChild(this._touchBlocker.getNode(), -1);
	    }
		this.disableMenus();
	},
	
	removePleaseWait: function()
	{
		if(!this._pleaseWaitLayer)
		{
			return;
		}

		this.removeChild(this._pleaseWaitLayer);
		
		destroyWithChildren(this._pleaseWaitLayer);
		this._pleaseWaitLayer = null;
		if (this._touchBlocker)
		{
		    if (this._children.indexOf(this._touchBlocker) >= 0)
		    {
		        this.removeChild(this._touchBlocker);
		    }
		    
		    this._touchBlocker.destroy();
		    this._touchBlocker = null;
		}
		this.enableMenus();
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/ZFMenus/FarmerSelection/ZFFarmerSelectionMenu'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/FarmerSelection/ZFFarmerSelectionMenu'] || {}; $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/FarmerSelection/ZFFarmerSelectionMenu'] = exports; var ZFFarmerCell = require('Code/Game/GUI/ZFMenus/FarmerSelection/ZFFarmerCell').ZFFarmerCell;
var CCTableViewCell = require('Code/CCTableViewSuite/CCScrollView').CCScrollView;

exports.ZFFarmerSelectionMenu = ZFMenu.singleton({
    classname : 'ZFFarmerSelectionMenu',
    
    farmerSelectionMenuTags : {
        kFarmerTagPurchaseInfo : 2, // ZFMenu.kZFMenuTags.kMenuTagMAX,
        kFarmerSelectionMenuTagTable : 3,
        kFarmerAvailabilityLabel : 4,
        kFarmerSelectionMenuTagBackground : 5,
        kFarmerSelectionMenuRibbon : 6,
        kFarmerSelectionMenuRibbonShadow : 7,
        kFarmerCellTagCheck : 1000
    },
    
    $farmerSelectionMenu : function()
    {
        return this;
    },
    
    initialize : function()
    {
    },
    
    destroy : function()
    {
    	this.removePleaseWait();
        this._pleaseWaitLayer = null;
    },
    
    initElements : function()
    {
        var screenSize = CCDirector.winSize();
        if (this._heightOffset > 0)
        {
            this._dimLayer.changeHeight(2 * screenSize._height);
            if (!this._dimLayer.getParent())
            {
                this._windowNode.addChild(this._dimLayer, 1000);
            }
        }
        var scaleFactor = CCDirector.zoomValue().getX();
        // Window initialization
        var windowSize = CGRectMake(0, 0, screenSize._width/scaleFactor, 250);
        var c = CGRectMake(1, 1, 34, 42);
        var b = CGRectMake(36, 1, 30, 38);
        var s = CGRectMake(1, 44, 34, 24);
        var f = ZFGameDefines.HUDELEMENTS1_FILE;
        var color = ccc4(237, 226, 177, 0xff);
        
        this._bgOverlay = ZFMenu.makeWindow(windowSize, c, b, f, color, CGRectMake(0, 0, 0, 0), CGRectMake(0, 0, 0, 0), s);
        this._bgOverlay.setPosition(ccp(0, -1 * (screenSize._height - windowSize.getSize()._height) / 2));
        this._windowNode.addChild(this._bgOverlay, 1, this.kZFMenuTags.kZFMenuTagBackground);
        this._backgroundSpriteSheet = this._bgOverlay.getChildByTag(1);
        
        // Menu title
        this.initBannerWithString(NSLocalizedString("Choose Your Farmer"), CGSizeMake(500, 50), 18);
        this._menuTitle.setDepth(21);
        this._menuBanner.setPosition(ccp(screenSize._width/(2*scaleFactor), this._menuBanner.getPosition()._y + 15));
        
        // Dismiss menu
        var dismissItem = CCMenuItemImage.itemFromNormalImage("bigX.png", "bigXSel.png", this, this.dismissMenu.bind(this));
        dismissItem.setPosition(ccp(0, 0));
        this._dismissMenu = CCMenu.menuWithItems([dismissItem]);
        this._dismissMenu.setPosition(ccp(screenSize._width/scaleFactor - 55, screenSize._height/2 + windowSize.getSize()._height/2 - 30));
        this._windowNode.addChild(this._dismissMenu, 10);
        
        // Purchase info label
        this._purchaseInfo = new CCLabel();
        this._purchaseInfo.initWithString("", CGSizeMake(200, 50), GL2.Text.HorizontalAlign.Center, "Arial", 12);
        this._purchaseInfo.setColor(ccc3(0, 0, 0)); // colorTextBlack
        this._purchaseInfo.setPosition(CGPointMake(screenSize._width / (2*scaleFactor), 25));
        this._windowNode.addChild(this._purchaseInfo, 3, this.farmerSelectionMenuTags.kFarmerTagPurchaseInfo);
        
        this.initPleaseWaitLayer(); // super.
        
        // Ribbons
        this._ribbonMainLayer = CCColorLayer.layerWithColor(ccc4(0xbc, 0x96, 0x84, 0xff), screenSize._width/scaleFactor, 80);
        this._ribbonMainLayer.setPosition(ccp(0, screenSize._height / 2 + 5));
        this._windowNode.addChild(this._ribbonMainLayer, 2, this.farmerSelectionMenuTags.kFarmerSelectionMenuRibbon);
        
        this._ribbonShadowLayer = CCColorLayer.layerWithColor(ccc4(0x7a, 0x5c, 0x4d, 0xff), screenSize._width/scaleFactor, 4);
        this._ribbonShadowLayer.setPosition(ccp(0, screenSize._height / 2 + 43));
        this._windowNode.addChild(this._ribbonShadowLayer, 4, this.farmerSelectionMenuTags.kFarmerSelectionMenuRibbonShadow);
               
        this.displayFarmerTable();
        
        // Left arrow
        this._leftArrow = CCSprite.spriteWithFile(f, CGRectMake(289, 45, 18, 36));
        this._leftArrow.setColor(ZFColorDefines.colorYellowButton);
        this._leftArrow.setPosition(ccp(10, screenSize._height / 2 + this._farmerTable._contentSize._height / 2 + 30));
        this._leftArrow.setScale(0.75, 0.75);
        this._leftArrow.setVisible(false);
        
        this._leftArrow.runAction(CCRepeatForever.actionWithAction(
				CCSequence.actions(
				 [CCFadeTo.actionWithDuration(0.25, 0x00),
				 CCFadeTo.actionWithDuration(0.25, 0xff)]
				 )));
        
        this._windowNode.addChild(this._leftArrow, 15);

        // Right arrow
        this._rightArrow = CCSprite.spriteWithFile(f, CGRectMake(289, 45, 18, 36));
        this._rightArrow.setColor(ZFColorDefines.colorYellowButton);
        this._rightArrow.setPosition(ccp(screenSize._width/scaleFactor - 10, screenSize._height / 2 + this._farmerTable._contentSize._height / 2 + 30));
        this._rightArrow.setScale(0.75, 0.75);
        this._rightArrow.setFlipX(true);
        this._windowNode.addChild(this._rightArrow, 15);
        
        this._rightArrow.runAction(CCRepeatForever.actionWithAction(
				CCSequence.actions(
				 [CCFadeTo.actionWithDuration(0.25, 0x00),
				 CCFadeTo.actionWithDuration(0.25, 0xff)]
				 )));
        
//      var actionTo = CCSequence.actions([CCMoveBy.actionWithDuration(0.25, ccp(-10, 0)), CCMoveBy.actionWithDuration(0.25, ccp(10, 0))]);
//      repeatForever = CCRepeatForever.actionWithAction(actionTo);
//      this._leftArrow.runAction(repeatForever);
        
//      var actionTo = CCSequence.actions([CCMoveBy.actionWithDuration(0.25, ccp(10, 0)), CCMoveBy.actionWithDuration(0.25, ccp(-10, 0))]);
//      var repeatForever = CCRepeatForever.actionWithAction(actionTo);
//      this._rightArrow.runAction(repeatForever);
        
        // Button
        this._s1 = CCSprite.spriteWithFile(f, CGRectMake(1, 252, 180, 55));
        this._s2 = CCSprite.spriteWithFile(f, CGRectMake(182, 252, 180, 55));
        this._s1.setColor(ZFColorDefines.colorGreenButton);
        this._s2.setColor(ZFColorDefines.colorGreenButton);
        
        this._button = CCMenuItemSprite.itemFromNormalSprite(this._s1, this._s2, this, this.asianHeadMaleSelected.bind(this));
        this._button.setScale(0.8, 0.8);
        
        var abilityPosition = ccp(150, screenSize._height / 2 - this._button._contentSize._height / 2 - 55);        
        var descriptionPosition = ccp(150, screenSize._height / 2 - this._button._contentSize._height / 2 - 20);
        var buttonTextPosition = ccp(this._button._contentSize._width / 2 -15, this._button._contentSize._height / 2 -3);
        var menuPosition = ccp(screenSize._width/scaleFactor - 180, screenSize._height / 2 - this._button._contentSize._height / 2 - 55);
        
        this._buttonText = CCLabel.labelWithString(NSLocalizedString("Select"), "AmericanTypewriter-Bold", 20);
        this._buttonText.setColor(ccc3(255, 255, 255));
        this._buttonText.setPosition(buttonTextPosition);
        this._button.addChild(this._buttonText);
        
        this._menu = CCMenu.menuWithItems([this._button]);
        this._menu.setPosition(menuPosition);
        this._windowNode.addChild(this._menu, 10);
        
        this._description = CCLabel.labelWithString(NSLocalizedString("Male Head 1"), CGSizeMake(200, 50), GL2.Text.HorizontalAlign.Left, "AmericanTypewriter-Bold", 14);
        this._description.setColor(ZFColorDefines.colorTextBlack);
        this._description.setPosition(descriptionPosition);
        this._windowNode.addChild(this._description, 10);
        
        this._ability = CCLabel.labelWithString("", CGSizeMake(200, 50), GL2.Text.HorizontalAlign.Left, "AmericanTypewriter", 12);
        this._ability.setVerticalAlign(GL2.Text.VerticalAlign.Top);
        this._ability.setColor(ZFColorDefines.colorTextBlack);
        this._ability.setPosition(abilityPosition);
        this._windowNode.addChild(this._ability, 10);
    
        this.schedule(this.tick);       
        
        this._windowNode.setScale(CCDirector.zoomValue());
		if(CCDirector.zoomValue()._x > 1.0)
		{
			this._windowNode.setPosition(new Core.Point(0, -this._windowNode.getSize()._height* 1/8 - 10));
		}
		
		if(!GameState._zfGameData._headID)
			GameState._zfGameData._headID = 0;

        this._curHeadID = this.tableIndexFromHeadID(GameState._zfGameData._headID);
        this.initPosition();
    },
    
    displayFarmerTable : function()
    {
        var w = CCDirector.winSize();
        var scaleFactor = CCDirector.zoomValue().getX(); 
        //Zombie table
        var cSize = ZFFarmerCell.cellSize();
        
        this._farmerTable = CCTableView.tableViewWithDataSource(this, CGSizeMake(w._width/scaleFactor, cSize._height-30));
        this._farmerTable._direction = CCScrollView.CCScrollViewDirection.CCScrollViewDirectionHorizontal;
        this._farmerTable._tDelegate = this;
        this._farmerTable._minContainerOffset = ccp(-50,0);
        this._farmerTable._maxContainerOffset = ccp(0,0);
        this._farmerTable.setPosition(35, w._height / 2);
        this._farmerTable.reloadData();
        this._windowNode.addChild(this._farmerTable, 3, this.farmerSelectionMenuTags.kFarmerSelectionMenuTagTable);
    },
    
    openMenu : function($super)
    {
        var w = CCDirector.winSize();
        var scaleFactor = CCDirector.zoomValue().getX();
        $super();
        
        var gs = GameState;
        
        if (!(gs._zfGameData._gflags & ZFGameFlags.GFLAG_TUTORIAL_START))
        {
            ZFGuiLayer.gui().displayAlertSimple(
                    NSLocalizedString("Welcome to Zombie Farm!"),
                    NSLocalizedString("Before we start, let's create your farmer.\n\nSelect your farmer on the following screen. You can always change your farmer again later on."),
                    null,
                    CGRectMake((w._width/scaleFactor - 480) / 2, w._height/scaleFactor - (w._height - 240) / 2, 480, 240));
        }
        
        this._curHeadID = this.tableIndexFromHeadID(GameState._zfGameData._headID);
        this.refreshTable(this._farmerTable);
        this.initPosition();
    },
    
    $tableIndexFromHeadID : function(hID)
    {
        var convertedHeadID;
        switch (hID)
        {
            case 0: convertedHeadID = 0;break;
            case 1: convertedHeadID = 2;break;
            case 2: convertedHeadID = 9;break;
            case 3: convertedHeadID = 11;break;
            case 4: convertedHeadID = 1;break;
            case 5: convertedHeadID = 3;break;
            case 6: convertedHeadID = 10;break;
            case 7: convertedHeadID = 12;break;
            case 8: convertedHeadID = 13;break;
            case 9: convertedHeadID = 14;break;
            case 10:convertedHeadID = 4;break;
            case 11:convertedHeadID = 5;break;
            case 12:convertedHeadID = 6;break;
            case 13:convertedHeadID = 7;break;
            case 14:convertedHeadID = 8;break;
            default:convertedHeadID = 0;break;
        }
        
        return convertedHeadID;
    },
    
    $headIDFromTableIndex : function(tableIndex)
    {
        var convertedIndex;
        switch (tableIndex)
        {
            case 0: convertedIndex = 0; break;
            case 1: convertedIndex = 4; break;
            case 2: convertedIndex = 1; break;
            case 3: convertedIndex = 5; break;
            case 4: convertedIndex = 10;break;
            case 5: convertedIndex = 11;break;
            case 6: convertedIndex = 12;break;
            case 7: convertedIndex = 13;break;
            case 8: convertedIndex = 14;break;
            case 9: convertedIndex = 2; break;
            case 10:convertedIndex = 6; break;
            case 11:convertedIndex = 3; break;
            case 12:convertedIndex = 7; break;
            case 13:convertedIndex = 8; break;
            case 14:convertedIndex = 9; break;
            default:convertedIndex = -1;
        }
        
        return convertedIndex;
    },
    
    dismissMenu : function($super, sender)
    {        
        // TODO : Restore after please wait screen done.
        this.removePleaseWait();
        
        if (!(GameState._zfGameData._gflags & ZFGameDefines.GFLAG_TUTORIAL_START)) // TODO : Check constant.
        {
            ZFGuiLayer.gui().schedule(ZFGuiLayer.gui().gamestart, 1.0);
        }
        
        // [[EventTracker eventTracker] sendEvent:@"zf_farmersel_dismiss" withParameters:nil andDelegate:nil];
        this.hideBalanceButton();
        $super();
    },
    
    dismissTimerCallback : function($super)
    {
        ZFActorManager._player.reloadPlayerSprite();
        this.unschedule(this.tick);
        
//        for (var i = this._windowNode._children.length-1; i >= 0; i--) {
//			var child = this._windowNode._children[i];
//        	this._windowNode.removeChild(child, true);
//			destroyWithChildren(child);
//		}
  /*      
        if (this._menu) // button must exist
        {
            if (this._button)
            {
                if (this._buttonText)
                {
//                    this._button.removeChild(this._buttonText);
//                    this._buttonText.destroy();
                    this._buttonText = null;
                }
                
//                this._menu.removeChild(this._button);
//                this._button.destroy();
                this._button = null;
            }
            
//            this._windowNode.removeChild(this._menu);
//            destroyWithChildren(this._menu);
            this._menu = null;
        }
        
        if (this._description)
        {
//            this._windowNode.removeChild(this._description);
//            this._description.destroy();
            this._description = null;
        }
        
        if (this._ability)
        {
//            this._windowNode.removeChild(this._ability);
//            this._ability.destroy();
            this._ability = null;
        }
        
//        this._windowNode.removeChild(this._leftArrow);
//        this._leftArrow.destroy();
        this._leftArrow = null;
        
//        this._windowNode.removeChild(this._rightArrow);
//        this._rightArrow.destroy();
        this._rightArrow = null;
        
//        this._farmerTable._tDelegate = null;
//        this._windowNode.removeChild(this._farmerTable);
//        this._farmerTable.destroy();
        this._farmerTable = null;
        
        if (this._ribbonMainLayer)
        {
//        	this._windowNode.removeChild(this._ribbonMainLayer);
//            this._ribbonMainLayer.destroy();
            this._ribbonMainLayer = null;
        }
        
        if (this._ribbonShadowLayer)
        {
//        	this._windowNode.removeChild(this._ribbonShadowLayer);
//            this._ribbonShadowLayer.destroy();
            this._ribbonShadowLayer = null;
        }
        
        if (this._dismissMenu)
        {
//            this._windowNode.removeChild(this._dismissMenu);
//            this._dismissMenu.destroy();
            this._dismissMenu = null;
        }
        
        if (this._purchaseInfo)
        {
//            destroyWithChildren(this._purchaseInfo);//.destroy();
            this._purchaseInfo = null;
        }*/
        
        
        
        NSNotificationCenter.defaultCenter().postNotificationName(ZFGameDefines.kEnableInGameMenusNotification, null);
        
        $super();
    },
    
    addHeadWithSpriteKey_atPoint : function(key, point)
    {
        var acm = ZFActorManager;
        var spriteDetails = acm._farmerSprites[key];
        var rect = CGRectMake(spriteDetails.x, spriteDetails.y, spriteDetails.width, spriteDetails.height);
        var sprite = CCSprite.spriteWithFile("playerSpriteSheet.png", rect);
        sprite.setPosition(point);
        return sprite;
    },
    
    initPosition : function(){ 
		var cSize = ZFFarmerCell.cellSize();
	    var cellsToDrag = this._curHeadID - this._farmerTable._viewSize._width/cSize._width;
	    if(cellsToDrag <= 0)
	    	return;
	    
	    var distanceToDrag = (cellsToDrag + 1.5)* cSize._width;
    		
	    var p = this._farmerTable.getContainerPos();
	    this._farmerTable._container.setPosition(-distanceToDrag,p._y);
		
    },
    tick : function(dt)
    {   
        if (this._farmerTable._isDragging)
        {
            this._leftArrow.setVisible(false);
            this._rightArrow.setVisible(false);
        }
        else
        { 
        	var p = this._farmerTable.getContainerPos();
        	
        	if(!this._maxDistanceToDrag){
	        	var cSize = ZFFarmerCell.cellSize();
	        	var maxCellsToDrag = 15 - Math.floor(this._farmerTable._viewSize._width/cSize._width);
	        	this._maxDistanceToDrag = (maxCellsToDrag-0.5)* cSize._width;
        	}
            this._rightArrow.setVisible(p._x > (-this._maxDistanceToDrag));
            this._leftArrow.setVisible(p._x < 0);
        }
    },
    
    refreshTable : function(table)
    {        
        var total = this.numberOfCellsInTableView(table);
        for ( var i = 0; i < total; i++)
        {
            table.updateCellAtIndex(i);
        }
    },
    
    table_cellTouched : function(table, cell)
    {
        var c = cell;
 
        // create new button and labels
        if (c._available)
        {
			this._buttonText.setString(NSLocalizedString("Select"));
			this._s1.setColor(ZFColorDefines.colorGreenButton);
	        this._s2.setColor(ZFColorDefines.colorGreenButton);
	        this.hideBalanceButton();
       	}
        else
        {
        	this._buttonText.setString(NSLocalizedString("Purchase"));
        	this._s1.setColor(ZFColorDefines.colorBlueButton);
            this._s2.setColor(ZFColorDefines.colorBlueButton);
            this.showBalanceButton();
        }
        
        this._button._selector = c._selector;
        
        if (c._description)
        {
            this._description.setString(c._description);
            this._description.setColor(ZFColorDefines.colorTextBlack);
        }
        else 
        {
            this._description.setString("");
        }
               
        if (c._ability)
        {
            this._ability.setString(c._ability);
            this._ability.setColor(ZFColorDefines.colorTextBlack);
        }
        else
        {
            this._ability.setString("");
        }

        this._curHeadID = c._headID;
//        GameState._zfGameData._headID = c._headID;
        this.refreshTable(table);
    },
    
    showBalanceButton : function()
    {
        if (!this._mobageButtonsVisible)
        {
        	console.log('widthScale!!! ' + this._widthScale);
            //var balanceRect = new UI.ViewGeometry.Rect(5 * this._widthScale, UI.Window._height - 35 * this._heightScale, 25 * this._widthScale, 10 * this._heightScale);
        	var balanceRect = new UI.ViewGeometry.Rect(5 * this._widthScale, UI.Window._height - 40 * this._heightScale, 100 * this._widthScale, 40 * this._heightScale);
            Social.Common.Service.showBalanceButton(balanceRect, function(error)
            {
            	if(error)
            		console.log('///ZFFarmerSelectionMenu.showBalanceButton error: ' + error.description);
            });
            this._mobageButtonsVisible = true;
        }
    },
    
    hideBalanceButton : function()
    {
        if (this._mobageButtonsVisible)
        {
            Social.Common.Service.hideBalanceButton(function(error)
            {
            	if(error)
            		console.log('///ZFFarmerSelectionMenu.hideBalanceButton error: ' + error.description);
            });
            this._mobageButtonsVisible = false;
        }
    },
    
    cellClassForTable : function(table)
    {
        return ZFFarmerCell;
    },
    
    table_cellAtIndex : function(table, idx)
    {
        var cell = table.dequeueCell();
        if (!cell || cell == null)
        {
            cell = new ZFFarmerCell();
        }
        
        cell.setHeadID(idx);
        cell._node = cell._cellLayer;
        cell._place = idx;
        
        return cell;
    },
    
    numberOfCellsInTableView : function(table)
    {
        return ZFGameDefines.NUMBER_OF_HEAD_IDS;
    },
    
    asianHeadMaleSelected : function(sender)
    {    
        GameState._zfGameData._headID = 0;
        GameState._zfGameData._bodyID = 0;
        this.dismissMenu(this);
        
        /* TODO: Events
        NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
                                            @"asianHeadMale", @"faceType",
                                            @"free", @"Cost",
                                            nil];
        [[EventTracker eventTracker] sendEvent:@"zf_farmersel_sel_purchase" withParameters:eventDictionary andDelegate:nil]; */
    },
    
    whiteHeadMaleSelected : function(sender)
    {
        GameState._zfGameData._headID = 1;
        GameState._zfGameData._bodyID = 0;
        this.dismissMenu(this);
        
        /* TODO: Events
        NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
            @"whiteHeadMale", @"faceType",
            @"free", @"Cost",
            nil];
        [[EventTracker eventTracker] sendEvent:@"zf_farmersel_sel_purchase" withParameters:eventDictionary andDelegate:nil]; */
    },
    
    skeletonHeadMaleSelected : function(sender)
    {
        if (GameState._zfGameData._fflags & ZFGameFlags.FFLAG_HEAD01)
        {
            GameState._zfGameData._headID = 2;
            GameState._zfGameData._bodyID = 0;
            this.dismissMenu(this);
            
            /* TODO: Events
            NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
                @"skeletonHeadMale", @"faceType",
                @"paid", @"Cost",
                nil];
            [[EventTracker eventTracker] sendEvent:@"zf_farmersel_sel_purchase" withParameters:eventDictionary andDelegate:nil]; */
        }
        else
        {
            this.buyHead(ZFGameDefines.kStoreFarmerHead1Identifier);
        }
    },
    
    vampireHeadMaleSelected : function(sender)
    {
        if (GameState._zfGameData._fflags & ZFGameFlags.FFLAG_HEAD02)
        {
            GameState._zfGameData._headID = 3;
            GameState._zfGameData._bodyID = 0;
            this.dismissMenu(this);
            
            /* TODO: Events
            NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
                @"vampireHeadMale", @"faceType",
                @"paid", @"Cost",
                nil];
            [[EventTracker eventTracker] sendEvent:@"zf_farmersel_sel_purchase" withParameters:eventDictionary andDelegate:nil];*/
        }
        else
        {
            this.buyHead(ZFGameDefines.kStoreFarmerHead2Identifier);
        }
    },
    
    asianHeadFemaleSelected : function(sender)
    {       
        GameState._zfGameData._headID = 4;
        GameState._zfGameData._bodyID = 1;
        this.dismissMenu(this);
        
        /* TODO: Events
        NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
            @"asianHeadFemale", @"faceType",
            @"free", @"Cost",
            nil];
        [[EventTracker eventTracker] sendEvent:@"zf_farmersel_sel_purchase" withParameters:eventDictionary andDelegate:nil];*/
    },
    
    whiteHeadFemaleSelected : function(sender)
    {
        GameState._zfGameData._headID = 5;
        GameState._zfGameData._bodyID = 1;
        this.dismissMenu(this);
        
        /* TODO: Events
        NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
            @"whiteHeadFemale", @"faceType",
            @"free", @"Cost",
            nil];
        [[EventTracker eventTracker] sendEvent:@"zf_farmersel_sel_purchase" withParameters:eventDictionary andDelegate:nil]; */
    },
    
    skeletonHeadFemaleSelected : function(sender)
    {
        if (GameState._zfGameData._fflags & ZFGameFlags.FFLAG_HEAD03)
        {
            GameState._zfGameData._headID = 6;
            GameState._zfGameData._bodyID = 1;
            this.dismissMenu(this);
            
            /* TODO: Events
            NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
                                        @"skeletonHeadFemale", @"faceType",
                                        @"paid", @"Cost",
                                        nil];
            [[EventTracker eventTracker] sendEvent:@"zf_farmersel_sel_purchase" withParameters:eventDictionary andDelegate:nil]; */
        }
        else
        {
            this.buyHead(ZFGameDefines.kStoreFarmerHead3Identifier);
        }
    },
    
    vampireHeadFemaleSelected : function(sender)
    {
        if (GameState._zfGameData._fflags & ZFGameFlags.FFLAG_HEAD04)
        {
            GameState._zfGameData._headID = 7;
            GameState._zfGameData._bodyID = 1;
            this.dismissMenu(this);
            
            /* TODO: Events
            NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
                                                @"vampireHeadFemale", @"faceType",
                                                @"paid", @"Cost",
                                                nil];
            [[EventTracker eventTracker] sendEvent:@"zf_farmersel_sel_purchase" withParameters:eventDictionary andDelegate:nil]; */
        }
        else
        {
            this.buyHead(ZFGameDefines.kStoreFarmerHead4Identifier);
        }
    },
    
    //new heads
    zombieHeadMaleSelected : function(sender)
    {
        if (GameState._zfGameData._fflags & ZFGameFlags.FFLAG_HEAD05)
        {
            GameState._zfGameData._headID = 8;
            GameState._zfGameData._bodyID = 0;
            this.dismissMenu(this);
            
            /* TODO: Events
            NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
                                                @"zombieHeadMale", @"faceType",
                                                @"paid", @"Cost",
                                                nil];
            [[EventTracker eventTracker] sendEvent:@"zf_farmersel_sel_purchase" withParameters:eventDictionary andDelegate:nil]; */
        }
        else
        {
            this.buyHead(ZFGameDefines.kStoreFarmerHead5Identifier);
        }
    },
    
    zombieHeadFemaleSelected : function(sender)
    {
        if (GameState._zfGameData._fflags & ZFGameFlags.FFLAG_HEAD06)
        {
            GameState._zfGameData._headID = 9;
            GameState._zfGameData._bodyID = 1;
            this.dismissMenu(this);
            
            /* TODO: Events
            NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
                @"zombieHeadFemale", @"faceType",
                @"paid", @"Cost",
                nil];
            [[EventTracker eventTracker] sendEvent:@"zf_farmersel_sel_purchase" withParameters:eventDictionary andDelegate:nil];*/
        }
        else
        {
            this.buyHead(ZFGameDefines.kStoreFarmerHead6Identifier);
        }
    },
    
    blackHeadMaleSelected : function(sender)
    {
        GameState._zfGameData._headID = 10;
        GameState._zfGameData._bodyID = 2;
        this.dismissMenu(this);
        
        /* TODO: Events
        NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
            @"blackHeadMale", @"faceType",
            @"free", @"Cost",
            nil];
        [[EventTracker eventTracker] sendEvent:@"zf_farmersel_sel_purchase" withParameters:eventDictionary andDelegate:nil]; */
    },
    
    blackHeadFemaleSelected : function(sender)
    {
        GameState._zfGameData._headID = 11;
        GameState._zfGameData._bodyID = 3;
        this.dismissMenu(this);
        
        /* TODO: Events
        NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
                                            @"blackHeadFemale", @"faceType",
                                            @"free", @"Cost",
                                            nil];
        [[EventTracker eventTracker] sendEvent:@"zf_farmersel_sel_purchase" withParameters:eventDictionary andDelegate:nil];*/
    },
    
    paperBagHeadMaleSelected : function(sender)
    {
        if (GameState._zfGameData._fflags & ZFGameFlags.FFLAG_HEAD07)
        {
            GameState._zfGameData._headID = 12;
            GameState._zfGameData._bodyID = 0;
            this.dismissMenu(this);
            
            /* TODO: Events
            NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
                                                @"paperBagHeadMale", @"faceType",
                                                @"paid", @"Cost",
                                                nil];
            [[EventTracker eventTracker] sendEvent:@"zf_farmersel_sel_purchase" withParameters:eventDictionary andDelegate:nil]; */
        }
        else
        {            
            this.buyHead(ZFGameDefines.kStoreFarmerHead7Identifier);
        }
    },
    
    monolithHeadMaleSelected : function(sender)
    {
        if (GameState._zfGameData._fflags & ZFGameFlags.FFLAG_HEAD08)
        {
            GameState._zfGameData._headID = 13;
            GameState._zfGameData._bodyID = 0;
            this.dismissMenu(this);
            
            /* TODO: Events
            NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
                                                @"monolithHeadMale", @"faceType",
                                                @"paid", @"Cost",
                                                nil];
            [[EventTracker eventTracker] sendEvent:@"zf_farmersel_sel_purchase" withParameters:eventDictionary andDelegate:nil]; */
        }
        else
        {
            this.buyHead(ZFGameDefines.kStoreFarmerHead8Identifier);
        }
    },
    
    pumpkinHeadMaleSelected : function(sender)
    {
        if (GameState._zfGameData._fflags & ZFGameFlags.FFLAG_HEAD09)
        {
            GameState._zfGameData._headID = 14;
            GameState._zfGameData._bodyID = 0;
            this.dismissMenu(this);
            
            /* TODO: Events
            NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
                                                @"pumpkinHeadMale", @"faceType",
                                                @"paid", @"Cost",
                                                nil];
            [[EventTracker eventTracker] sendEvent:@"zf_farmersel_sel_purchase" withParameters:eventDictionary andDelegate:nil]; */
        }
        else
        {
            this.buyHead(ZFGameDefines.kStoreFarmerHead9Identifier);
        }
    },
    
    buyHead : function(itemID)
    {        
        // Used for Bank.Inventory.getItem and MobagePaymentController
        var paymentController = null;
        var onSuccess = function(transaction)
        {           
        	console.log("ZFFarmerSelectionMenu.buyHead: Purchase completed successfully " + itemID);
         
            var tempMessage = new UI.AlertDialog();
            tempMessage.setTitle(NSLocalizedString("Successfully"));
            tempMessage.setText(NSLocalizedString("Purchase completed successfully"));
            tempMessage.setChoices(["OK"]);
            tempMessage.setOnChoice(function()
            { 
                tempMessage.hide();
                tempMessage.destroy();     
                CCDirector.resume();
            }.bind(this));
            tempMessage.show();
        }.bind(this);
        
        var onProcess = function(transaction)
        {
            // Reward the user
            console.log("ZFFarmerSelectionMenu.buyHead: Buying item " + itemID);
            var identifier = itemID;
            if(transaction.item){
            	identifier = transaction.item.sku;
            } else if (transaction.items[0]) {
            	identifier = transaction.items[0].item.id;
            }
            MKStoreObserver.provideContent(identifier, 1);
            //MKStoreObserver.provideContent(transaction.item.sku, 1);
            this.removePleaseWait();
            this.hideBalanceButton();
            GameState.saveGameReal();
            paymentController.closeTransaction(transaction);
        }.bind(this);
        
        // Used for Bank.Inventory.getItem and MobagePaymentController
        var onFailure = function(error, data)
        {
        	if (error && (error !== "usercanceled" && error.description !== "usercanceled"))
            {
                var tempMessage = new UI.AlertDialog();
                tempMessage.setTitle(NSLocalizedString("Failure"));
                tempMessage.setText(NSLocalizedString("Server Error"));
                tempMessage.setChoices(["OK"]);
                tempMessage.setOnChoice(function()
                { 
                    tempMessage.hide();
                    tempMessage.destroy();
                }.bind(this));
                tempMessage.show();
                console.log("ZFFarmerSelectionMenu.buyHead: Error while trying to buy " + itemID + ". Error: " + error.description);
            }
        	
            CCDirector.resume();
            this.removePleaseWait();
            //FIXME: Requires UIAlertView
            /* UIAlertView *aw = [[UIAlertView alloc] initWithTitle:NSLocalizedString(@"Product not found", nil)
                message:nil
                delegate:nil 
                cancelButtonTitle:NSLocalizedString(@"Try Again", nil)
                otherButtonTitles:nil];
            [aw show];
            [aw release];*/
        }.bind(this);

        this.displayPleaseWait();

        Bank.Inventory.getItem(itemID, function(error, data)
        {
            // Product found
            if (error || !data)
            {
                onFailure(error, data);
            }
            else
            {
            	CCDirector.pause();
                console.log("ZFFarmerSelectionMenu.buyHead: Creating transaction. item: " + itemID + ", amount: " + 1);
                paymentController = new MobagePaymentController(onSuccess.bind(this), onProcess.bind(this), onFailure.bind(this));
                paymentController.createTransaction([ {
                    'item' : {
                        'id' : itemID
                    },
                    'quantity' : '1'
                } ], 'Zombie Farm Item'); //jp: ゾンビファームのアイテム us: Zombie Farm Item
            }
        }.bind(this));
    },
    
    alertView : function(alertView, buttonIndex)
    {
        this._createFarmerAlertView = null;
    },
        
    getMenuOffset : function()
    {
        return ccp(0, 0);
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/AlertWindows/ZFAlertWindow'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/AlertWindows/ZFAlertWindow'] || {}; $MODULE_REGISTRY['Code/Game/GUI/AlertWindows/ZFAlertWindow'] = exports; var ZFMenu = require('Code/Game/GUI/ZFMenus/ZFMenu').ZFMenu;

exports.ZFAlertWindow = CCLayer.subclass(
{
	classname: "ZFAlertWindow",
	
	kAlertWindowTags:
	{
		kAlertWindowTagBGMgr : 	200,
		kAlertWindowTagBG : 	201,
		kAlertWindowTagBG1 : 	202,
		kAlertWindowTagBG2 : 	203,
		kAlertWindowTagBG3 : 	204,
		kAlertWindowTagOk : 	205,
		kAlertWindowTagCancel : 206,
		kAlertWindowTagDismiss: 207,
		kAlertWindowTagZombie : 208,
		kAlertWindowTagSell : 	209
	},
		

	initialize: function()
	{
		this._winSize = CCDirector.winSize();
		
		this._windowNode = CCColorLayer.layerWithColor(ccc4(0, 0, 0, 0), this._winSize._width, this._winSize._height);
		BackButtonHandler.push(this);
		if (!this._touchBlocker)
	    {
	        this._touchBlocker = new TouchBlocker();
	        this.addChild(this._touchBlocker.getNode(), -1);
	    }
	},

	dismissAlertPositive: function(sender) 
	{ 
		if(this._menuState == ZFMenu.menuStates.menuStateOpen)
		{
			this.dismissAlert();
			
			if(this._delegate && (typeof this._delegate.alertWindow_dismissedPositive === 'function'))
				 this._delegate.alertWindow_dismissedPositive(this, true, sender._tag);
		}
		
		return true;
	},
	
	dismissAlertNegative: function() 
	{ 
		if(this._menuState == ZFMenu.menuStates.menuStateOpen)
		{
			this.dismissAlert();
			
			if(this._delegate && (typeof this._delegate.alertWindow_dismissedPositive === 'function'))
				this._delegate.alertWindow_dismissedPositive(this, false);
		}
		
		return true;
	},
	
	dismissAlertPositiveWithButtonTag: function(sender) 
	{ 
		if(this._menuState == ZFMenu.menuStates.menuStateOpen)
		{
			this.dismissAlert();
			
			if(this._delegate && (typeof this._delegate.alertWindow_dismissedPositive === 'function'))
				this._delegate.alertWindow_dismissedPositive_withButtonTag(this, true, sender._tag);
//				this._delegate.alertWindow_dismissedPositive(this, false, sender._tag);
		}
		
		return true;
	},
		
	
	destroy: function()
	{				
		destroy(this._image);
		destroy(this._image2);
		destroy(this._body1);
		destroy(this._body2);
		destroy(this._cancel);
		destroy(this._dismiss );
		destroy(this._ok);
		destroy(this._title1);
	},
	
	initWithWindow: function(windowSize)
	{	    
		this._isTouchEnabled = true;
		
		var winSize =  CCDirector.winSize();
		
		var w = new Core.Size(480, 320);
		var resolutionWidth = this._winSize._width;
		var resolutionHeight = this._winSize._height;
		var widthOffset =  (resolutionWidth - windowSize.getSize()._width) / 2;
		var heightOffset = -(resolutionHeight - windowSize.getSize()._height)/ 2;

		var c = new Core.Rect(1,1,34,42);
		var b = new Core.Rect(36, 1, 30, 38);
		var s = new Core.Rect(1, 44, 34, 24);
		var f = "hudElements.png";

		var color = ccc3(237, 226, 177);
		
		var bgOverlay = ZFMenu.makeWindow(windowSize,c,b,f,color,new Core.Rect(0,0,0,0), new Core.Rect(0,0,0,0), s);
		this._bgOverlay = bgOverlay;
			
		this._windowNode.addChild(bgOverlay, 0, this.kAlertWindowTags.kAlertWindowTagBG);
		
		bgOverlay.setPosition(ccp(widthOffset, heightOffset));

		
		var labelWidth = windowSize.getSize()._width-120;
		
		this._title1 = CCLabel.labelWithString("", new Core.Size(labelWidth, 120), GL2.Text.HorizontalAlign.Center, "AmericanTypewriter-Bold", 20);
		this._body1 = CCLabel.labelWithString("", new Core.Size(labelWidth, 180), GL2.Text.HorizontalAlign.Center, "AmericanTypewriter", 15);
		this._body2 = CCLabel.labelWithString("", new Core.Size(labelWidth, 120), GL2.Text.HorizontalAlign.Cetner, "AmericanTypewriter", 15);
		
		//dismiss
		var dismissItem = new CCMenuItemImage();
		dismissItem.initFromNormalImage("bigX.png", "bigXSel.png", dismissItem, this.dismissAlertNegative.bind(this));
		dismissItem._tag = this.kAlertWindowTags.kAlertWindowTagDismiss;
		this._dismiss = CCMenu.menuWithItems([dismissItem]);

		var okItem = new CCMenuItemImage();
		okItem.initFromNormalImage("bigCheck.png", "bigCheckSel.png", okItem, this.dismissAlertPositive.bind(this));
		okItem._tag = this.kAlertWindowTags.kAlertWindowTagOk;
		this._ok = CCMenu.menuWithItems([okItem]);

		var cancelItem = new CCMenuItemImage();
		cancelItem.initFromNormalImage("bigX.png", "bigXSel.png", cancelItem, this.dismissAlertNegative.bind(this));
		this._cancel = CCMenu.menuWithItems([cancelItem]);

		this._delayOkButton = 0;
		this._endScale = 1;

		this._windowNode.addChild(this._title1, 1);
		this._windowNode.addChild(this._body1, 1);
		this._windowNode.addChild(this._body2, 1);
		this._windowNode.addChild(this._dismiss, 2);
		this._windowNode.addChild(this._ok, 2);
		//this.addChild(this._cancel, 2);
		
		this._title1.setColor(ccc3(0,0,0));
		this._body1.setColor(ccc3(0,0,0));
		this._body2.setColor(ccc3(0,0,0));
		
		var yOffset = (320 - windowSize.getSize()._height)/2;
		
		this._body1.setPosition(widthOffset + windowSize.getSize()._width/2 , winSize._height + heightOffset - 45 - yOffset  );
		
		this._dismiss.setPosition(ccp( widthOffset + windowSize.getSize()._width - dismissItem.getSize()._width, -heightOffset - dismissItem.getSize()._height + windowSize.getSize()._height ));
		this._ok.setPosition(ccp( widthOffset + windowSize.getSize()._width/2 - okItem.getSize()._width/2, -heightOffset + 13 ));

		this.addChild(this._windowNode);
		this._windowNode.setScale(CCDirector.zoomValue());
		if(CCDirector.zoomValue()._x > 1.0)
			this._windowNode.setPosition(new Core.Point(-this._windowNode.getSize()._width*1/8, -this._windowNode.getSize()._height* 1/8));
			
		return this;
	},
	
	$alertWindowSlideInInformative: function(title, message, sprite, filename, r1, r2, buttonText, buttonColor, fromLeft)
	{
		var winSize =  CCDirector.winSize();
		var resolutionWidth = winSize._width;
		var resolutionHeight = winSize._height;
		var widthScale = resolutionWidth / 480;
		var heightScale = resolutionHeight / 320;
		
//		var heightOffset = (windowSize.getSize()._height - winSize._height)/2;
//		var widthOffset = (winSize._width - windowSize.getSize()._width )/2;
		
		var w = new Core.Size(480, winSize._height*0.75); //var w = new Core.Size(480, 320 * heightScale);
		var aw = new this();

		var fontSize = 16;
		var windowSize = new Core.Rect(20, w._height - w.getHeight() * 1/5/2, w._width/2, w._height * 4/5);		
		var c = CGRectMake(1,1,34,42);	
		var b = CGRectMake(36,1,30,38);
		var s = CGRectMake(1,44,34,24);
		var f = "hudElements.png";
		
		var color = ccc3(237, 226, 177);
		var bgOverlay = ZFMenu.makeWindow(windowSize, c, b, f, color, CGRectMake(0,0,0,0), CGRectMake(0,0,0,0), s);
		this._bgOverlay = bgOverlay;
		aw._windowNode.addChild(bgOverlay, 0, this.kAlertWindowTags.kAlertWindowTagBG);
		
		
		var widthOffset = (resolutionWidth - windowSize.getSize()._width) / 2;
		var heightOffset = (resolutionHeight - windowSize.getSize()._height) / 2;

		if(aw._title1) aw.removeChild(aw._title1, true);
		
		aw._title1 = CCLabel.labelWithString(NSLocalizedString(title), new Core.Size(200, 50), GL2.Text.HorizontalAlign.Center, "AmericanTypewriter-Bold", fontSize);
		
		var menuBanner = CCSprite.spriteWithFile(f, new Core.Rect(144, 376, 200, 47));
		aw._windowNode.addChild(menuBanner, 1);
		menuBanner.setPosition(ccp(20 + menuBanner.getSize()._width/2,  resolutionHeight - menuBanner.getSize()._height/2 ));
		aw._title1.setColor(ccc3(0,0,0));
		
		//aw._title1.setPosition(ccp(menuBanner.getSize()._width/2, -menuBanner.getSize()._height/2 ));
		menuBanner.addChild(aw._title1);
		
		aw._menuBanner = menuBanner;
		
		if(aw._body1) aw.removeChild(aw._body1, true);
		
		if(message.length > 130 && Core.Localization._lang == "en"){
			fontSize -= 3;
		}		
		else if(message.length > 35 && Core.Localization._lang == "ja"){
			fontSize -= 3;
		}
		aw._body1 = CCLabel.labelWithString( NSLocalizedString(message),
											new Core.Size(200, windowSize.getSize()._height),
											GL2.Text.HorizontalAlign.Center,
											"AmericanTypewriter",
											fontSize - 3);
		aw._body1.setColor(ccc3(0,0,0));
		aw._body1._label.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
		
		aw._windowNode.addChild(aw._body1, 1);
		aw._body1.setPosition(ccp(20, resolutionHeight - 30));
		aw._body1.setAnchorPoint(ccp(0,0));
		
		destroyWithChildren(aw._ok);
		destroyWithChildren(aw._cancel);
		
		var s1 = CCSprite.spriteWithFile(filename, r1);;
		var s2 = CCSprite.spriteWithFile(filename, r2);

		s1.setColor(buttonColor);
		s2.setColor(buttonColor);
		

		var okItem = null;
		if(buttonText != "missingItem")
		{
			var okItem = new CCMenuItemImage();
			okItem.initFromNormalSprite(s1, s2, okItem, aw.dismissAlertPositive.bind(aw));
			okItem._tag = this.kAlertWindowTags.kAlertWindowTagOk;
			aw._ok = CCMenu.menuWithItems([okItem]);
			aw._windowNode.addChild(aw._ok, 2);
			
			aw._buttonLabel = CCLabel.labelWithString(buttonText, "AmericanTypewriter-Bold", fontSize);
			aw._buttonLabel.setPosition(okItem.getSize()._width*0.8/2, okItem.getSize()._height*0.8/2+4);
			aw._buttonLabel.setSize(okItem.getSize());
			aw._buttonLabel.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
			okItem.addChild(aw._buttonLabel, 0);
			
			okItem.setScale(0.8);
			
			okItem._touchTarget.setScale(new Core.Vector(1, 0.3));
		}
		

		var dismissItem = new CCMenuItemImage();
		dismissItem.initFromNormalImage("bigX.png", "bigXSel.png", dismissItem, aw.dismissAlertNegative.bind(aw));
		dismissItem._tag = this.kAlertWindowTags.kAlertWindowTagDismiss;
		aw._dismiss = CCMenu.menuWithItems([dismissItem]);
		dismissItem.setScale(0.7);
		aw._windowNode.addChild(aw._dismiss, 2);

//		aw.endScale = 1.0f;

		//TODO
		var spriteAmoeba = null;
		
		if(sprite.classname == "CCSprite")
		{
			if(sprite._parent)
			{
				spriteAmoeba = sprite._parent;
			}
			else spriteAmoeba = sprite;
			
			spriteAmoeba.setScale(1.75);
			aw._image = spriteAmoeba;
			aw._image.setAnchorPoint(ccp(0.5, 0));
		}
		else 
		{
			// this came from spriteNode built in tileManager
			spriteAmoeba = sprite;
			spriteAmoeba.setScale(spriteAmoeba.getScale()._x * 1.75, spriteAmoeba.getScale()._y * 1.75);
			aw._image = sprite;
		}
			
				

		var iconOffset = 12;
//		if (heightScale>1)
//		{
//			iconOffset = 10;
//			aw.image.scale = 1;
//		}
		if (fromLeft)
		{
			aw.setPosition(ccp(-15, -heightOffset));
			aw._ok.setPosition(ccp(140 - okItem.getSize()._width/2, 50 * heightScale + resolutionHeight - windowSize.getSize()._height - heightOffset/2));
			aw._dismiss.setPosition(ccp( menuBanner.getSize()._width+iconOffset , resolutionHeight-dismissItem.getSize()._height*0.7/2 - 23));
			aw._image.setPosition(ccp(menuBanner.getSize()._width/1.8, winSize._height - 100));
		}
		else
		{
			aw.setPosition(ccp(15 + winSize._width -  windowSize.getSize()._width, -heightOffset));
			aw._dismiss.setPosition(ccp(-iconOffset, resolutionHeight-dismissItem.getSize()._height*0.7/2 - 23));
			aw._ok.setPosition(ccp(140 - okItem.getSize()._width/2, 50 * heightScale + resolutionHeight - windowSize.getSize()._height - heightOffset/2));
			aw._image.setPosition(ccp(menuBanner.getSize()._width/1.8, resolutionHeight - 100));
		}
		
		aw._windowNode.addChild(spriteAmoeba, 1);
		
		aw.addChild(aw._windowNode);
		aw._windowNode.setScale(CCDirector.zoomValue());
		
		if (fromLeft) {
			aw._windowNode.setPosition(0, -aw._windowNode.getSize()._height*3/8);
		} else {
			aw._windowNode.setPosition(-aw._windowNode.getSize()._width*1/16, -aw._windowNode.getSize()._height* 3/16);
		}
		
		dismissItem._touchTarget.setPosition(ccpAdd(dismissItem.getPosition(), ccp(0, -35)));
		okItem._touchTarget.setPosition(ccpAdd(okItem.getPosition(), ccp(0,-42)));
		
		return aw;
	},
	

	$alertWindowSlideInInformativeWithSell: function(title, message, sprite, filename, r1, r2, buttonText, buttonColor, sellr1, sellr2, sellButtonText, sellButtonColor, fromLeft)
	{
		var aw = this.alertWindowSlideInInformative(title, message, sprite, filename, r1, r2, buttonText, buttonColor, fromLeft);

		var fontSize = 15;
		var s1 = CCSprite.spriteWithFile(filename, sellr1);
		var s2 = CCSprite.spriteWithFile(filename, sellr2);
		
		s1.setColor(sellButtonColor);
		s2.setColor(sellButtonColor);
		aw._ok.setPosition(ccpAdd(aw._ok.getPosition(), ccp(0, 10)));
		var okPos = aw._ok.getPosition();
		
		var sellItem = new CCMenuItemImage();
		sellItem.initFromNormalSprite(s1, s2, sellItem, aw.dismissAlertPositiveWithButtonTag.bind(aw));
		sellItem.setScale(0.8, 0.55);
		sellItem._tag = this.kAlertWindowTags.kAlertWindowTagSell;

		aw._sell = CCMenu.menuWithItems([sellItem]);
		aw._windowNode.addChild(aw._sell, 2);
		aw._sell.setPosition( ccpAdd(okPos, ccp(0, - aw._ok._children[0].getSize()._height/2)) );
		
		aw._buttonLabelSell = CCLabel.labelWithString(sellButtonText, "AmericanTypewriter-Bold", fontSize);
		aw._buttonLabelSell.setPosition(sellItem.getSize()._width*0.8/2, sellItem.getSize()._height/2 * 0.55 + 2);
		aw._buttonLabelSell.setSize(sellItem.getSize());
		aw._buttonLabelSell.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
		sellItem.addChild(aw._buttonLabelSell, 0);
		
		sellItem._touchTarget.setScale(new Core.Vector(0.8, 0.5));
		sellItem._touchTarget.setPosition(ccpAdd(sellItem.getPosition(), ccp(0, -30)));
		
		return aw;
	},
	

	$alertWindowSimpleChoice : function(title,  message, sprite, windowSize)
	{
		if(!windowSize) windowSize = new Core.Rect(0,0, 480, 320 - 72);
		
		var winSize =  CCDirector.winSize();
		var heightOffset = (windowSize.getSize()._height - winSize._height)/2;
		var widthOffset = (winSize._width - windowSize.getSize()._width )/2;

		var resolutionWidth = winSize._width;
		var resolutionHeight = winSize._height;

		var aw = new this();
		aw.initWithWindow(windowSize);
		
		var menuBanner = CCSprite.spriteWithFile("hudElements.png", new Core.Rect(144, 376, 200, 47));
		aw._windowNode.addChild(menuBanner, 2);
		menuBanner.setPosition(ccp(240 + widthOffset, winSize._height/2 + windowSize.getSize()._height/2/*-heightOffset + 277 - menuBanner.getSize()._height/2 - 12*/));
		menuBanner.setScale(480/280, 1);
		menuBanner.setAnchorPoint(0.5, 0.5);
		
		var menuTitle = CCLabel.labelWithString(title, new Core.Size(300, 47), GL2.Text.HorizontalAlign.Center, "AmericanTypewriter-Bold", 20);
		menuTitle.setColor(ccc3(0,0,0));
		menuBanner.addChild(menuTitle, 3);

		if(!sprite) aw._body1.setString(message);
		
		var ok = aw._ok;
		
		//I'm used _dismiss button becouse cancel and dismiss buttons was binded to same callback function
		var cancel = aw._dismiss;
		
		var offset = ok._children[0].getSize()._width/2;
		var space = windowSize.getSize()._width / 3;
		var oldOkPos = ok.getPosition();
		ok.setPosition(ccp(widthOffset + space - offset, oldOkPos._y ));
		cancel.setPosition(ccp(widthOffset + space*2 - offset, oldOkPos._y));
		
		
		if(sprite)
		{
			var scale = 100 / sprite.getSize()._width;
			var scaleVector = new ccp((scale >  1)?1:scale, (scale >  1)?1:scale);
			sprite.setScale(scaleVector);
			aw._image = sprite;
			sprite.setPosition(ccp(50 + widthOffset, windowSize.getSize()._height/2 - heightOffset));
			aw._windowNode.addChild(sprite, 1);
			
			sprite.setAnchorPoint(ccp(0, 0.5));
			var oldBody1Pos = aw._body1.getPosition();
			if(aw._body1) aw.removeChild(aw._body1, true);
			aw._body1 = CCLabel.labelWithString(message, new Core.Size(250, 180), GL2.Text.HorizontalAlign.Left, "AmericanTypewriter", 15);
			aw._windowNode.addChild(aw._body1, 1);
			aw._body1.setColor(ccc3(0,0,0));
//			var newBodyPos = ccpAdd(oldBody1Pos, ccp(160-125, -15));
//			aw._body1.setPosition(newBodyPos);
			
			var newBodyPos = ccpAdd(oldBody1Pos, ccp(35 + 30, -100  + (320 - windowSize.getSize()._height)));
			aw._body1.setPosition(newBodyPos);
			
			aw._body1.setString(message);
		}
		
//		if(sprite)
//		{
//			float scale = 100 / sprite.contentSize.width;
//			sprite.scale = scale > 1.f ? 1.f : scale;
//			aw.image = sprite;
//			aw.image.anchorPoint = ccp(0,.5);
//			aw.image.position = ccp(50, aw.contentSize.height/2);
//			aw.image.position = ccpAdd(aw.image.position, CGPointMake(widthOffset, 0));
//			[aw removeChild:aw.body1 cleanup:YES];
//			aw.body1 = [CCLabel labelWithString:@"" dimensions:CGSizeMake(300 - 50, 180) alignment:UITextAlignmentLeft fontName:@"AmericanTypewriter" fontSize:15];
//			aw.body1.anchorPoint = ccp(0,1);
//			aw.body1.position = ccp(160, topReferencePosition.y - 35);
//			aw.body1.position = ccpAdd(aw.body1.position, CGPointMake(widthOffset, heightOffset));
//			aw.body1.color = ccc3(0,0,0);
//			[aw.body1 setString:message];
//			[aw addChild:aw.body1 z:1];
//			[aw addChild:sprite z:1];
//		}

		return aw;
	},
	
	$_createMenuBanner: function(aw, title, windowSize, bannerSize)
	{
		var winSize =  CCDirector.winSize();
		var widthOffset =  ( 480 - windowSize.getSize()._width) / 2;
		widthOffset += (winSize._width - 480)/2;

		var offsetX = widthOffset + (windowSize.getSize()._width - bannerSize._width)/2;
		var offsetY = ((winSize._height - 320) / 2  +
					  windowSize.getSize()._height +
					  (320 - windowSize.getSize()._height) / 2); 
		

		
		var menuBanner = CCSprite.spriteWithFile("hudElements.png", new Core.Rect(144, 376, 200, 47));
		aw._windowNode.addChild(menuBanner, 2);
		
		menuBanner.setPosition(ccp(offsetX, offsetY));
		menuBanner.setAnchorPoint(0, 0.5);
		
		var menuTitle = CCLabel.labelWithString(title, bannerSize, GL2.Text.HorizontalAlign.Center, "AmericanTypewriter-Bold", 20);
		menuTitle.setColor(ccc3(0,0,0));
		menuTitle.setAnchorPoint(ccp(0, 0.5));
		menuTitle.setPosition(ccp(offsetX, offsetY));
		
		
		aw._windowNode.addChild(menuTitle, 3);
		
		return menuBanner;
	},
	
	
	$alertWindowSimple: function(title, message, sprite, windowSize)
	{
		if(!windowSize) 
			windowSize = new Core.Rect(0,0, 480, 320 - 24);
		else
			windowSize = new Core.Rect(0,0,windowSize.getSize()._width, windowSize.getSize()._height);
		
		var winSize =  CCDirector.winSize();
		var heightOffset = (windowSize.getSize()._height - winSize._height)/2;
		var widthOffset = (winSize._width - windowSize.getSize()._width )/2;

		var resolutionWidth = winSize._width;
		var resolutionHeight = winSize._height;

		var aw = new this();
		aw.initWithWindow(windowSize);
		
		var bannerSize = new Core.Size(200 * (windowSize.getSize()._width/280), 47);
		var menuBanner = this._createMenuBanner(aw, title, windowSize, bannerSize);
		menuBanner.setScale(windowSize.getSize()._width/280, 1);
		
		if (!sprite) {
			aw._body1.setString(message);
			var newBodyPos = ccpAdd(aw._body1._ccPosition, ccp(0, -100  + (320 - windowSize.getSize()._height)));
			aw._body1.setPosition(newBodyPos);
		} else {
			var scale = 100 / sprite.getSize()._width;
			var scaleVector = new ccp((scale >  1)?1:scale, (scale >  1)?1:scale);
			sprite.setScale(scaleVector);
			
			sprite.setPosition(ccp(50 + widthOffset, windowSize.getSize()._height/2 - heightOffset));
			aw._windowNode.addChild(sprite, 1);
			
			sprite.setAnchorPoint(ccp(0, 0.5));
			var oldBody1Pos = aw._body1.getPosition();
			if (aw._body1) {
				aw._windowNode.removeChild(aw._body1, true);
				destroyWithChildren(aw._body1);
			}
			
			aw._body1 = CCLabel.labelWithString(message, new Core.Size(windowSize.getSize()._width-200,  windowSize.getSize()._height - 116), GL2.Text.HorizontalAlign.Left, "AmericanTypewriter", 15);
			aw._body1._label.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
			aw._windowNode.addChild(aw._body1, 1);
			aw._body1.setColor(ccc3(0,0,0));
			
			var newBodyPos = ccpAdd(oldBody1Pos, ccp(35 + 30, -100  + (320 - windowSize.getSize()._height)));
			aw._body1.setPosition(newBodyPos);
			aw._body1.setString(message);
		}
		
		return aw;
	},

	//+ (ZFAlertWindow *)alertWindowSimple:(NSString*)title withMessage:(NSString*)message withSprite:(CCSprite*)sprite withWindow:(CGRect)windowSize
	//{
//		ZFAlertWindow *aw = [[self alloc] initWithWindow:windowSize];
//		CGSize winSize = CGSizeMake(480, 320);
//		CGRect mainFrame = [[UIScreen mainScreen] bounds];
//		float resolutionWidth = mainFrame.size.height;
//		float resolutionHeight = mainFrame.size.width;
//		float widthOffset = (resolutionWidth - 480.0f)/2;
//		float heightOffset = (resolutionHeight - 320.0f)/2;
//		[aw.title1 setString:title];
//		[aw.body1 setString:message];
//		[aw removeChild:aw.cancel cleanup:YES];
//		float yDiff = winSize.height - windowSize.size.height;
//		yDiff /= 2;
//		CCMenuItem *okItem = [[aw.ok children] objectAtIndex:0];
//		aw.ok.position = ccp(winSize.width/2+widthOffset, okItem.contentSize.height/2 + yDiff + 12+heightOffset);
	//	
//		//remove dismiss button on simple alerts
//		[aw.dismiss removeAllChildrenWithCleanup:YES];
//		aw.dismiss = nil;
	//	
//		CGPoint topReferencePosition = ccp(winSize.width/2, windowSize.size.height + yDiff - 12);
//		aw.body1.position = ccp(topReferencePosition.x+widthOffset, topReferencePosition.y - 35+heightOffset);
	//	
	//	
//		NSString *f = HUDELEMENTS1_FILE;
	//	
//		CCSprite *banner = [CCSprite spriteWithFile:f rect:CGRectMake(144, 376, 200, 47)];
//		[aw addChild:banner z:0];
//		banner.position = ccpAdd(topReferencePosition, CGPointMake(widthOffset, heightOffset));
//		banner.scaleX = windowSize.size.width/280;
//		aw.title1.position = ccp(banner.position.x, banner.position.y + 12);
	//	
//		if(sprite)
//		{
//			float scale = 100 / sprite.contentSize.width;
//			sprite.scale = scale > 1.f ? 1.f : scale;
//			aw.image = sprite;
//			aw.image.anchorPoint = ccp(0,.5);
//			aw.image.position = ccp(50+widthOffset, aw.contentSize.height/2);
//			[aw removeChild:aw.body1 cleanup:YES];
//			aw.body1 = [CCLabel labelWithString:@"" dimensions:CGSizeMake(300 - 50, 180) alignment:UITextAlignmentLeft fontName:@"AmericanTypewriter" fontSize:15];
//			aw.body1.anchorPoint = ccp(0,1);
//			aw.body1.position = ccp(160+widthOffset, topReferencePosition.y - 35+heightOffset);
//			aw.body1.color = ccc3(0,0,0);
//			[aw.body1 setString:message];
//			[aw addChild:aw.body1 z:1];
//			[aw addChild:sprite z:1];
//		}
	//	
//		return [aw autorelease];
	//}
	
	$alertWindowInformative: function(title, message, fontSize)
	{
		var AlertWindow = require('Code/Game/GUI/AlertWindows/ZFAlertWindow').ZFAlertWindow;
		var aw = new AlertWindow();
		aw.initWithWindow(new Core.Rect(0,0,480, 320));

		destroy(aw._body1);
		destroy(aw._title1);
		
		if(aw._title1) aw.removeChild(aw._title1, true);
		aw._title1 = CCLabel.labelWithString( NSLocalizedString(title),
											new Core.Size(440, 280),
											GL2.Text.HorizontalAlign.Center,
											"Arial-BoldMT",
											fontSize);
		aw._title1.setColor(ccc3(0,0,0));
		aw._title1._label.setVerticalAlign(GL2.Text.VerticalAlign.Top);
		
		aw._title1.setPosition(ccp(20, 280));
		aw._title1.setAnchorPoint(ccp(0,0));
		
		aw._windowNode.addChild(aw._title1, 10);
				
		
		
		if(aw._body1) aw.removeChild(aw._body1, true);
		aw._body1 = CCLabel.labelWithString( NSLocalizedString(message),
											new Core.Size(400, 280),
											GL2.Text.HorizontalAlign.Left,
											"Arial",
											fontSize);
		aw._body1.setColor(ccc3(0,0,0));
		aw._body1._label.setVerticalAlign(GL2.Text.VerticalAlign.Top);
		
		aw._body1.setPosition(ccp(40, 280-35));
		aw._body1.setAnchorPoint(ccp(0,0));
		
		aw._windowNode.addChild(aw._body1, 10);
		
		return aw;
	},
	
	dismissed: function(dt)
	{
		ZFGuiLayer.enableMenus();
		this._menuState = ZFMenu.menuStates.menuStateCleanup;
		
		this.cleanWindow();
		this.unschedule(this.dismissed);
	},
	
	dismissAlert: function()
	{
	    BackButtonHandler.removeElement(this);
	    if (this._touchBlocker)
		{
		    if (this._children.indexOf(this._touchBlocker) >= 0)
		    {
		        this.removeChild(this._touchBlocker);
		    }
		    
		    this._touchBlocker.destroy();
		    this._touchBlocker = null;
		}
	    
		if(this._menuState == ZFMenu.menuStates.menuStateClosing);
		var actionTo = null;
		var interval = 0.15;
		var resolutionWidth = this._winSize._width;
		var widthScale = resolutionWidth/480;
		var widthOffset = (resolutionWidth - 480)/2;
		
//		if (self.position.x < 0)
//		{
//			actionTo = [CCMoveTo actionWithDuration:interval position:ccp(-400+widthOffset, self.position.y)];
//		}
//		else if (self.position.x >= 235)
//		{
//			actionTo = [CCMoveTo actionWithDuration:interval position:ccp(400*widthScale+widthOffset, self.position.y)];
//		}
//		else
//		{
//			actionTo = [CCScaleTo actionWithDuration:interval scale:.01f];
//		}
//		[self runAction:actionTo];
		
		this.schedule(this.dismissed, interval);
		SimpleAudioEngine.playEffect(kMenuCloseSFX);
	},
	
	display: function()
	{
		ZFGuiLayer.disableMenus();
	
//		CGRect mainFrame = [[UIScreen mainScreen] bounds];
//		float resolutionWidth = mainFrame.size.height;
//		float widthOffset = 0;
//		if (resolutionWidth>ORIGINAL_WINDOW_WIDTH)
//		{
//			widthOffset = resolutionWidth-ORIGINAL_WINDOW_WIDTH;
//		}
	//	
//		self.visible = YES;
//		self.scale = .01f;
//		id actionTo = nil;
		var interval = 0.15;
//		if (self.position.x < 0)
//		{
//			actionTo = [CCMoveTo actionWithDuration:interval position:ccp(-235+widthOffset, self.position.y)];
//			self.scale = endScale;
//		}
//		else if (self.position.x >= 400)
//		{
//			actionTo = [CCMoveTo actionWithDuration:interval position:ccp(235+widthOffset, self.position.y)];
//			self.scale = endScale;
//		}
//		else
//		{
//			actionTo = [CCScaleTo actionWithDuration:interval scale:endScale];
//		}
	//	
//		[self runAction:actionTo];
		
		this._menuState = ZFMenu.menuStates.menuStateOpening;
		this.schedule(this.open, interval);
	
		SimpleAudioEngine.playEffect(kMenuOpenSFX);
	},
	
	open: function(dt)
	{	
		this._menuState = ZFMenu.menuStates.menuStateOpen;
		this.unschedule(this.open);
	},
	
	
	
	cleanWindow: function()
	{
//		var window = this.getChildByTag(this.kAlertWindowTags.kAlertWindowTagBG);
//		var spriteSheet = window.getChildByTag(1);
//		spriteSheet.removeAllChildrenWithCleanup(true);
//		window.removeChildByTag(1, true);
//		window.removeChildByTag(0, true);
//		this.removeChildByTag(this.kAlertWindowTags.kAlertWindowTagBG, true);
		
		destroy(this);
	}
	
	
	//+ (ZFAlertWindow *)alertWindowInformative:(NSString*)title 
//	  withMessage:(NSString*)message
//	 withFontSize:(int)fontSize
//{
//CGSize actualSize = WINDOW_SIZE;
//float widthOffset = (actualSize.width - ORIGINAL_WINDOW_WIDTH)/2;
//float heightOffset = (actualSize.height - ORIGINAL_WINDOW_HEIGHT)/2;
//CGSize winSize = CGSizeMake(480, 320);
//ZFAlertWindow *aw = [[self alloc] initWithWindow:CGRectMake(0, winSize.height, winSize.width, winSize.height)];
//
//[aw removeChild:aw.cancel cleanup:YES];
//aw.ok.position = ccp(winSize.width/2+widthOffset, 40+heightOffset);
//[aw removeChild:aw.body1 cleanup:YES];
//aw.body1 = [CCLabel labelWithString:message 
//	 dimensions:CGSizeMake(380, 180) 
//	  alignment:UITextAlignmentLeft 
//	   fontName:@"Arial" 
//	   fontSize:fontSize];
//aw.body1.anchorPoint = ccp(0,1);
//aw.body1.position = ccp(50+widthOffset, winSize.height - 70+heightOffset);
//aw.body1.color = ccc3(0,0,0);
//[aw addChild:aw.body1 z:1];
//
//[aw removeChild:aw.title1 cleanup:YES];
//aw.title1 = [CCLabel labelWithString:title 
//	  dimensions:CGSizeMake(300, 120) 
//	   alignment:UITextAlignmentCenter 
//		fontName:@"Arial-BoldMT" fontSize:fontSize+4];
//aw.title1.color = ccc3(0,0,0);
//aw.title1.anchorPoint = ccp(.5,1);
//aw.title1.position = ccp(winSize.width/2+widthOffset, winSize.height - 35+heightOffset);
//[aw addChild:aw.title1 z:1];
//
//return [aw autorelease];
//}		
	

	//
	//+ (ZFAlertWindow *)alertWindowSimpleChoice:(NSString*)title withMessage:(NSString*)message withSprite:(CCSprite*)sprite
	//{
//		CGSize w = CGSizeMake(480, 320);
//		return [ZFAlertWindow alertWindowSimpleChoice:title withMessage:message withSprite:sprite withWindow:CGRectMake(0,w.height - 36, w.width, w.height - 72)];
	//}
	//
	//+ (ZFAlertWindow *)alertWindowSimpleChoice:(NSString*)title withMessage:(NSString*)message withSprite:(CCSprite*)sprite withWindow:(CGRect)windowSize
	//{
//		CGSize winSize = CGSizeMake(480, 320);
//		CGRect mainFrame = [[UIScreen mainScreen] bounds];
//		float resolutionWidth = mainFrame.size.height;
//		float resolutionHeight = mainFrame.size.width;
//		float widthOffset = (resolutionWidth - 480.0f)/2;
//		float heightOffset = (resolutionHeight - 320.0f)/2;
	//	
//		ZFAlertWindow *aw = [[self alloc] initWithWindow:windowSize];
//		[aw.title1 setString:title];
//		[aw.body1 setString:message];
	//	
//		float yDiff = winSize.height - windowSize.size.height;
//		yDiff /= 2;
	//	
//		CCMenuItem *okItem = [[aw.ok children] objectAtIndex:0];
//		CCMenuItem *cancelItem = [[aw.cancel children] objectAtIndex:0];
//		aw.ok.position = ccp(aw.ok.position.x, okItem.contentSize.height/2 + yDiff + 12);
//		aw.ok.position = ccpAdd(aw.ok.position, CGPointMake(0, heightOffset));
//		aw.cancel.position = ccp(aw.cancel.position.x, cancelItem.contentSize.height/2 + yDiff + 12);
//		aw.cancel.position = ccpAdd(aw.cancel.position, CGPointMake(0, heightOffset));
	//	
//		CGPoint topReferencePosition = ccp(winSize.width/2, windowSize.size.height + yDiff - 12);
//		aw.body1.position = ccp(topReferencePosition.x+widthOffset, topReferencePosition.y - 35+heightOffset);
//		NSString *f = HUDELEMENTS1_FILE;
	//	
//		CCSprite *banner = [CCSprite spriteWithFile:f rect:CGRectMake(144, 376, 200, 47)];
//		[aw addChild:banner z:0];
//		banner.position = topReferencePosition;
//		banner.position = ccpAdd(banner.position, CGPointMake(widthOffset, heightOffset));
//		banner.scaleX = winSize.width/280;
//		aw.title1.position = ccp(banner.position.x, banner.position.y + 12);
	//	
//		//remove dismiss button on simple alerts
//		[aw.dismiss removeAllChildrenWithCleanup:YES];
//		aw.dismiss = nil;
	//	
//		if(sprite)
//		{
//			float scale = 100 / sprite.contentSize.width;
//			sprite.scale = scale > 1.f ? 1.f : scale;
//			aw.image = sprite;
//			aw.image.anchorPoint = ccp(0,.5);
//			aw.image.position = ccp(50, aw.contentSize.height/2);
//			aw.image.position = ccpAdd(aw.image.position, CGPointMake(widthOffset, 0));
//			[aw removeChild:aw.body1 cleanup:YES];
//			aw.body1 = [CCLabel labelWithString:@"" dimensions:CGSizeMake(300 - 50, 180) alignment:UITextAlignmentLeft fontName:@"AmericanTypewriter" fontSize:15];
//			aw.body1.anchorPoint = ccp(0,1);
//			aw.body1.position = ccp(160, topReferencePosition.y - 35);
//			aw.body1.position = ccpAdd(aw.body1.position, CGPointMake(widthOffset, heightOffset));
//			aw.body1.color = ccc3(0,0,0);
//			[aw.body1 setString:message];
//			[aw addChild:aw.body1 z:1];
//			[aw addChild:sprite z:1];
//		}
	//	
//		return [aw autorelease];
	//}
});




//
///*-(id) init
// { 
// self = [super init];
// 
// if (self != nil)
// {
// CGSize w = [[CCDirector sharedDirector] winSize];
// [self initWithWindow:CGRectMake(0,w.height, 480, 320)];
// }
// 
// return self;
// }*/
//

//
//-(void)showOkButtonIn:(ccTime)dt
//{
//	[self unschedule:@selector(showOkButtonIn:)];
//	ok.visible = YES;
//	ok.scale = .01f;
//	[ok runAction:[CCScaleTo actionWithDuration:.5f scale:1.f]];
//}
//

//

//

//
//+ (ZFAlertWindow *)alertWindowLevelUp:(NSString*)title withMessage1:(NSString*)message1 withMessage2:(NSString*)message2 withSprite:(CCSprite*)sprite;
//{
//	CGSize w = CGSizeMake(480, 320);
//	ZFAlertWindow *aw = [[self alloc] initWithWindow:CGRectMake(0, w.height, w.width, w.height)];
//	[aw.title1 setString:title];
//	[aw.body1 setString:message1];
//	[aw.body2 setString:message2]; 
//	[aw removeChild:aw.cancel cleanup:YES];
//	aw.ok.position = ccp(w.width/2, 40);
//	return [aw autorelease];
//}
//
//+ (ZFAlertWindow *)alertWindowSlideInInformativeWithSell:(NSString*)title 
//											 withMessage:(NSString*)message 
//											  withSprite:(CCNode*)sprite 
//											 withHudFile:(NSString*)filename 
//										  withButtonRect:(CGRect)r1 
//								  withButtonSelectedRect:(CGRect)r2
//										  withButtonText:(NSString*)buttonText
//										 withButtonColor:(ccColor3B)buttonColor
//									  withSellButtonRect:(CGRect)sellr1 
//							  withSellButtonSelectedRect:(CGRect)sellr2
//									  withSellButtonText:(NSString*)sellButtonText
//									 withSellButtonColor:(ccColor3B)sellButtonColor
//										   slideFromLeft:(BOOL)fromLeft;
//{
//	ZFAlertWindow *aw = [ZFAlertWindow alertWindowSlideInInformative:title 
//														 withMessage:message 
//														  withSprite:sprite 
//														 withHudFile:filename 
//													  withButtonRect:r1 
//											  withButtonSelectedRect:r2
//													  withButtonText:buttonText
//													 withButtonColor:buttonColor
//													   slideFromLeft:fromLeft];
//	
//	float fontsize = 15;
//	CCSprite *s1 = [CCSprite spriteWithFile:filename rect:sellr1];
//	CCSprite *s2 = [CCSprite spriteWithFile:filename rect:sellr2];
//	
//	s1.color = sellButtonColor;
//	s2.color = sellButtonColor;
//	
//	CGRect mainFrame = [[UIScreen mainScreen] bounds];
//	//float resolutionWidth = mainFrame.size.height;
//	float resolutionHeight = mainFrame.size.width;
//	float heightScale = resolutionHeight/ORIGINAL_WINDOW_HEIGHT;
//	float heightOffset = 0;
//	
//	CGSize w = CGSizeMake(480, 320*heightScale);
//	CCLayer *bgOverlay = (CCLayer*)[aw getChildByTag:kAlertWindowTagBG];
//	[aw removeChild:bgOverlay cleanup:YES];
//	
//	CGRect windowSize;
//	if (heightScale > 1)
//	{
//		 windowSize = CGRectMake(20,((int)(w.height - w.height * 1/5/2)), ((int)(w.width/2)), ((int)(w.height * 4/5)));
//		heightOffset = 70;
//	}
//	else
//	{
//		windowSize = CGRectMake(20,((int)(w.height - w.height * 1/5/2)), ((int)(w.width/2)), ((int)(w.height * 8/9)));;
//	}
//	CGRect c = CGRectMake(1,1,34,42);	
//	CGRect b = CGRectMake(36,1,30,38);
//	CGRect s = CGRectMake(1,44,34,24);
//	NSString *f = HUDELEMENTS1_FILE;
//	
//	ccColor4B color = ccc4(237,226,177,0xff);
//	
//	bgOverlay = [ZFMenu makeWindow:windowSize 
//							corner:c 
//							   bar:b 
//							  file:f 
//							 color:color 
//						   bcorner:CGRectMake(0,0,0,0)
//							  bbar:CGRectMake(0,0,0,0)
//							  side:s];	
//	
//	[aw addChild:bgOverlay z:0 tag:kAlertWindowTagBG];
//	
//	CCMenuItemImage* sellItem = [CCMenuItemSprite itemFromNormalSprite:s1 selectedSprite:s2 target:aw selector:@selector(dismissAlertPositiveWithButtonTag:)];
//	sellItem.tag = kAlertWindowTagSell;
//	sellItem.scaleX = 0.8f;
//	sellItem.scaleY = 0.55f;
//	
//	aw.sell = [CCMenu menuWithItems:sellItem, nil];
//	[aw addChild:aw.sell z:2];
//	
//	aw.buttonLabel = [CCLabel labelWithString:sellButtonText fontName:@"AmericanTypewriter-Bold" fontSize:fontsize];
//	aw.buttonLabel.position = ccp(sellItem.position.x + sellItem.contentSize.width / 2 * sellItem.scaleX, sellItem.position.y + sellItem.contentSize.height / 2 * sellItem.scaleY+heightOffset);
//	[aw addChild:aw.buttonLabel z:2];
//	
//	
//	if (fromLeft)
//	{
//		bgOverlay.position = ccpAdd(bgOverlay.position, ccp(((int)(w.width/2)) - 40, 0));
//		aw.sell.position = ccp(340, 10 + sellItem.contentSize.height/2+heightOffset);
//		aw.ok.position = ccp(340, 75+heightOffset);
//		aw.buttonLabel.position = ccp(340, 12 + sellItem.contentSize.height/2);
//	}
//	else
//	{
//		aw.sell.position = ccp(140, 10 + sellItem.contentSize.height/2+heightOffset);
//		aw.ok.position = ccp(140, 75+heightOffset);
//		aw.buttonLabel.position = ccpAdd(aw.buttonLabel.position, ccp(68,24));
//	}
//	
//	return aw;
//}
//
//+ (ZFAlertWindow *)alertWindowSlideInInformative:(NSString*)title 
//									 withMessage:(NSString*)message 
//									  withSprite:(CCNode*)sprite 
//									 withHudFile:(NSString*)filename 
//								  withButtonRect:(CGRect)r1 
//						  withButtonSelectedRect:(CGRect)r2
//								  withButtonText:(NSString*)buttonText
//								 withButtonColor:(ccColor3B)buttonColor
//								   slideFromLeft:(BOOL)fromLeft
//{
//	CGRect mainFrame = [[UIScreen mainScreen] bounds];
//	float resolutionWidth = mainFrame.size.height;
//	float resolutionHeight = mainFrame.size.width;
//	float widthScale = resolutionWidth/ORIGINAL_WINDOW_WIDTH;
//	float heightScale = resolutionHeight/ORIGINAL_WINDOW_HEIGHT;
//	float widthOffset = (resolutionWidth - 480.0f)/2;
//	float heightOffset = (resolutionHeight - 320.0f)/2;
//		
//	CGSize w = CGSizeMake(480, 320*heightScale);
//	ZFAlertWindow *aw = [[self alloc] initWithWindow:CGRectMake(0, w.height, w.width, w.height)];
//	[aw cleanWindow];
//	float fontsize = 18;
//	CGRect windowSize = CGRectMake(20,((int)(w.height - w.height * 1/5/2)), ((int)(w.width/2)), ((int)(w.height * 4/5)));
//	CGRect c = CGRectMake(1,1,34,42);	
//	CGRect b = CGRectMake(36,1,30,38);
//	CGRect s = CGRectMake(1,44,34,24);
//	NSString *f = HUDELEMENTS1_FILE;
//	
//	ccColor4B color = ccc4(237,226,177,0xff);
//	
//	CCLayer *bgOverlay = [ZFMenu makeWindow:windowSize 
//									 corner:c 
//										bar:b 
//									   file:f 
//									  color:color 
//									bcorner:CGRectMake(0,0,0,0)
//									   bbar:CGRectMake(0,0,0,0)
//									   side:s];	
//	[aw addChild:bgOverlay z:0 tag:kAlertWindowTagBG];
//	
//	CGSize winSize = CGSizeMake(480, 320*heightScale);
//	[aw removeChild:aw.title1 cleanup:YES];
//	aw.title1 = [CCLabel labelWithString:NSLocalizedString(title, title)
//							  dimensions:CGSizeMake(200, 20) 
//							   alignment:UITextAlignmentCenter
//								fontName:@"AmericanTypewriter-Bold" 
//								fontSize:fontsize];
//	aw.title1.anchorPoint = ccp(0,0);
//	//[aw addChild:aw.title1 z:1];
//	aw.title1.color = ccc3(0,0,0);
//	
//	CCSprite *banner = [CCSprite spriteWithFile:f rect:CGRectMake(144,376,200,47)];
//	[aw addChild:banner z:1];
//	aw.title1.position = ccp(banner.contentSize.width/2 - aw.title1.contentSize.width/2, banner.contentSize.height/2 - 6);
//	[banner addChild:aw.title1];
//	
//	[aw removeChild:aw.body1 cleanup:YES];
//	aw.body1 = [CCLabel labelWithString:NSLocalizedString(message, message)
//							 dimensions:CGSizeMake(200, 100) 
//							  alignment:UITextAlignmentCenter
//							   fontName:@"AmericanTypewriter" 
//							   fontSize:fontsize - 6];
//	aw.body1.anchorPoint = ccp(0,0);
//	[aw addChild:aw.body1 z:1];
//	aw.body1.color = ccc3(0,0,0);
//	[aw removeChild:aw.ok cleanup:YES];
//	[aw removeChild:aw.cancel cleanup:YES];
//	
//	CCSprite *s1 = [CCSprite spriteWithFile:filename rect:r1];
//	CCSprite *s2 = [CCSprite spriteWithFile:filename rect:r2];
//	
//	s1.color = buttonColor;
//	s2.color = buttonColor;
//	
//	CCMenuItemImage *okItem = nil;
//	if (![buttonText isEqualToString:@"missingItem"])
//	{
//		okItem = [CCMenuItemSprite itemFromNormalSprite:s1 selectedSprite:s2 target:aw selector:@selector(dismissAlertPositive:)];
//		okItem.tag = kAlertWindowTagOk;
//	
//		aw.ok = [CCMenu menuWithItems:okItem, nil];
//		[aw addChild:aw.ok z:2];
//	
//		aw.buttonLabel = [CCLabel labelWithString:buttonText fontName:@"AmericanTypewriter-Bold" fontSize:fontsize];
//		aw.buttonLabel.position = ccp(okItem.contentSize.width/2, okItem.contentSize.height/2 + 4);
//		[okItem addChild:aw.buttonLabel z:0];
//		okItem.scale = 0.8f;
//	}
//	aw.endScale = 1.0f;
//	CCMenuItem *dismissBox = [aw.dismiss.children objectAtIndex:0];
//	dismissBox.scale = 0.70f;
//	
//	
//	CCNode *spriteAmoeba = nil;
//	
//	if([sprite isKindOfClass:[CCSprite class]])
//	{
//		
//		if (sprite.parent)
//		{
//			spriteAmoeba = sprite.parent;
//		}
//		else
//		{
//			spriteAmoeba = sprite;
//		}
//		spriteAmoeba.scale = 1.75f;
//		aw.image = (CCSprite*)spriteAmoeba;
//		aw.image.anchorPoint = ccp(0.5,0.5);
//	}
//	else
//	{
//		// this came from spriteNode built in tileManager
//		spriteAmoeba = sprite;
//		spriteAmoeba.scale = spriteAmoeba.scale * 1.75;
//		aw.image = (CCSprite*)sprite;
//	}
//	float iconOffset = 0;
//	if (heightScale>1)
//	{
//		iconOffset = 10;
//		aw.image.scale = 1;
//	}
//	if (fromLeft)
//	{
//		bgOverlay.position = ccpAdd(bgOverlay.position, ccp(((int)(w.width/2)) - 40+widthOffset, 0));
//		aw.position = ccp(-400+widthOffset, 0);
//		aw.dismiss.position = ccp(aw.dismiss.position.x-2-widthOffset, aw.dismiss.position.y-23*heightScale+heightOffset-iconOffset);
//		aw.ok.position = ccp(340, 40*heightScale + okItem.contentSize.height/2);
//		//aw.title1.position = ccp(250, winSize.height - 50);
//		banner.position = ccp(238 + banner.contentSize.width/2, winSize.height - 50*heightScale);
//		aw.body1.position = ccp(240, winSize.height - 260*heightScale+heightOffset/2);
//		aw.image.position = ccp(340, winSize.height - 100*heightScale-5*iconOffset);
//	}
//	else
//	{
//		aw.position = ccp(400*widthScale+widthOffset, 0);
//		aw.dismiss.position = ccp(28, aw.dismiss.position.y-23*heightScale+heightOffset-iconOffset);
//		aw.ok.position = ccp(140, 35*heightScale + okItem.contentSize.height/2);
//		//aw.title1.position = ccp(40, winSize.height - 50);
//		banner.position = ccp(42 + banner.contentSize.width/2, winSize.height - 50*heightScale);
//		aw.body1.position = ccp(40, winSize.height - 260*heightScale+heightOffset/2);
//		aw.image.position = ccp(140, winSize.height - 100*heightScale-5*iconOffset);
//	}
//	[aw addChild:spriteAmoeba z:1];
//	
//	return [aw autorelease];
//}
//


//

//
//-(void)dealloc
//{
//	self.delegate = nil;
//	self.title1 = nil;
//	self.body1 = nil;
//	self.body2 = nil;
//	self.ok = nil;
//	self.cancel = nil;
//	self.dismiss = nil;
//	self.buttonLabel = nil;
//	//self.background = nil;
//	self.image = nil;
//    self.image2 = nil;
//	self.data = nil;
//	self.isTouchEnabled = NO;
//	[super dealloc];
//}
//
//- (BOOL) ccTouchBegan:(UITouch *)touch withEvent:(UIEvent *)event
//{
//	return YES;
//}
//
//- (void)ccTouchEnded:(UITouch *)touch withEvent:(UIEvent *)event
//{
//	
//}
//
//-(void) registerWithTouchDispatcher
//{
//	[[CCTouchDispatcher sharedDispatcher] addTargetedDelegate:self priority:INT_MIN+1 swallowsTouches:YES];
//}
//
//
//@end
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/AlertWindows/ZFAlertWindowQuest'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/AlertWindows/ZFAlertWindowQuest'] || {}; $MODULE_REGISTRY['Code/Game/GUI/AlertWindows/ZFAlertWindowQuest'] = exports; 
var Core = require('NGCore/Client/Core').Core;
var CCLayer = require('Code/Cocos2D/CCLayer').CCLayer;
var CCMenu = require('Code/Cocos2D/CCMenu').CCMenu;
var CCSprite = require('Code/Cocos2D/CCSprite').CCSprite;
var CCLabel = require('Code/Cocos2D/CCLabel').CCLabel;
var CCMenuItemImage = require('Code/Cocos2D/CCMenuItemImage').CCMenuItemImage;
var ZFAlertWindow = require('Code/Game/GUI/AlertWindows/ZFAlertWindow').ZFAlertWindow;
var ZFMenu = require('Code/Game/GUI/ZFMenus/ZFMenu').ZFMenu;


exports.ZFAlertWindowQuest = ZFAlertWindow.subclass(
{
	classname: "ZFAlertWindowQuest",
	
	$alertWindowWithQuest: function(quest)
	{
		var z = new this();
		z.initWithQuest(quest);
		return z;
	},
	
	initWithQuest: function(aQuest)
	{

			this._quest = aQuest;
			//var w = new Core.Size(UI.Window._width, UI.Window._height);
			var w = new Core.Rect(20, 20, 440, 280);
			//CGSize w = [[CCDirector sharedDirector] winSize];
			var c = new Core.Rect(1,1,34,42);	
			var b = new Core.Rect(36,1,30,38);
			var s = new Core.Rect(1,44,34,24);
			var f = "hudElements.png";

			var winSize =  new Core.Size(UI.Window._width, UI.Window._height);
			var widthOffset =  (winSize._width  - w.getSize()._width) / 2;
			var heightOffset = -(winSize._height - w.getSize()._height) / 2;
			
			var color = ccc3(237, 226, 177);
			var bgOverlay1 = ZFMenu.makeWindow(w, c, b, f, color, new Core.Rect(0,0,0,0), new Core.Rect(0,0,0,0), s);

			
			this.addChild(bgOverlay1, 0, this.kAlertWindowTags.kAlertWindowTagBG1);
			bgOverlay1.setPosition(ccp(widthOffset, heightOffset));
			

			//			
//			CGRect windowSize = CGRectMake(116, 246, 325, 60);
//			CGRect cornerSize = CGRectMake(250,1,5,5);
//			CGRect barSize	  = CGRectMake(237,1,12,4);
//			
//			color = ccc4(colorPaper.r, colorPaper.g, colorPaper.b, 0xFF);
//			
//			// Show the title/banner
			var menuBanner = CCSprite.spriteWithFile(f, new Core.Rect(144, 376, 200, 47));
			this.addChild(menuBanner, 2);
			menuBanner.setPosition(ccp(widthOffset + 220, -heightOffset + 277 - menuBanner.getSize()._height/2));
			menuBanner.setScale(1.5, 1);
			menuBanner.setAnchorPoint(0.5, 0.5);
			
			var menuTitle = CCLabel.labelWithString(this._quest.title, new Core.Size(300, 47), GL2.Text.HorizontalAlign.Center, "AmericanTypewriter-Bold", 20);
			//menuTitle.setColor(ZFColorDefines.colorTextDarkBrown);
			menuBanner.addChild(menuTitle, 3);
			
//			float bufferY = 58;
//			for (int i = 0; i < quest.requirements.count; i++ )
//			{
//				ZFQuestRequirement *req = [quest.requirements objectAtIndex:i];
//				
//				color = ccc4(colorPaper.r, colorPaper.g, colorPaper.b, 0xFF);
//				windowSize = CGRectMake(108, 246 - i * bufferY, 325, 53);
//				CCLayer *requisiteOverlay1 = [ZFMenu makeWindow:windowSize 
//														 corner:cornerSize 
//															bar:barSize 
//														   file:f 
//														  color:color];
//				[self addChild:requisiteOverlay1 z:1];
//				
//				CCSprite *icon = [CCSprite spriteWithFile:req.spriteFilename];
//				icon.position = ccp(80, 226 - i * bufferY);
//				[self addChild:icon z:2];
//				
//				CCLabel *questText = [[[CCLabel alloc] initWithString:req.text
//														   dimensions:CGSizeMake(250, 47) 
//															alignment:UITextAlignmentLeft 
//															 fontName:@"Arial" 
//															 fontSize:16] autorelease];
//				
//				questText.color = colorTextBlack;
//				questText.position = ccp(218+25, 215 - i * bufferY);
//				[self addChild:questText z:3];
//				
//				CCLabel *progressText = [[[CCLabel alloc] initWithString:[NSString stringWithFormat:@"%i/%i", req.countCurrent, req.countTotal]
//														   dimensions:CGSizeMake(60, 47) 
//															alignment:UITextAlignmentRight 
//															 fontName:@"Arial-BoldMT" 
//															 fontSize:16] autorelease];
//				
//				progressText.color = colorTextBlack;
//				progressText.position = ccp(390, 215 - i * bufferY);
//				[self addChild:progressText z:3];
//			}
//			
			
			dismissItem = CCMenuItemImage.itemFromNormalImage("bigX.png", "bigXSel.png", this, this.dismissAlertNegative.bind(this));
			this._dismiss = CCMenu.menuWithItems([dismissItem]);
			dismissItem.setScale(0.75);
			
			okItem = CCMenuItemImage.itemFromNormalImage("bigCheck.png", "bigCheckSel.png", this, this.dismissAlertPositive.bind(this));
			this._ok = CCMenu.menuWithItems([okItem]);
			okItem.setScale(0.75);
			
//			
//			delayOkButton = 0.f;
//			endScale = 1.f;
//			
			
			this._dismiss.setPosition(ccp( widthOffset + w.getSize()._width - dismissItem.getSize()._width * 0.75, -heightOffset - dismissItem.getSize()._height * 0.75 + w.getSize()._height ));
			this._ok.setPosition(ccp( widthOffset + w.getSize()._width/2 - okItem.getSize()._width*0.5/2, -heightOffset + 13 ));
			
			this.addChild(this._dismiss, 2);
			this.addChild(this._ok, 2);
			
//			body2.color = ccc3(0,0,0);
//			
//			body2.anchorPoint = ccp(.5,1);
//			body2.position = ccp(w.width/2, w.height - 150);
//			self.visible = NO;
//			menuState = menuStateClosed;

	}
	
});

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/AlertWindows/ZFAlertWindowQuestComplete'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/AlertWindows/ZFAlertWindowQuestComplete'] || {}; $MODULE_REGISTRY['Code/Game/GUI/AlertWindows/ZFAlertWindowQuestComplete'] = exports; var ZFAlertWindow = require('Code/Game/GUI/AlertWindows/ZFAlertWindow').ZFAlertWindow;
var ZFMenu = require('Code/Game/GUI/ZFMenus/ZFMenu').ZFMenu;
var ZFColorDefines = require('Code/Game/ZFColorDefines').ZFColorDefines;

var ZFQuestNotification = require('Code/Game/GUI/GuiLayer/Quests/ZFQuestNotification').ZFQuestNotification;



exports.ZFAlertWindowQuestComplete = ZFAlertWindow.subclass(
{
	classname: "ZFAlertWindowQuestComplete",
	
	$alertWindowWithQuest: function(quest)
	{
		var z = new this();
		z.initWithQuest(quest);
		return z;
	},
	
	destroy: function($super)
	{
		CCActionManager.stopAllActions(this._rewardBody);
		this._repeatAction.destroy();
		
		destroy(this._completeMessage);
		destroy(this._requisiteOverlay);
		destroy(this._dismiss);
		destroy(this._ok);
		destroy(this._menuTitle);
		destroy(this._menuBanner);
		destroy(this._rewardBody);
		destroy(this._rewardTitle);
		destroy(this._icon);
		destroy(this._bg);
	},
	
	initWithQuest: function(aQuest)
	{
		this._quest = aQuest;
		var w = new Core.Rect(20, 20, 440, 280);
		var c = new Core.Rect(1,1,34,42);	
		var b = new Core.Rect(36,1,30,38);
		var s = new Core.Rect(1,44,34,24);
		var f = "hudElements.png";

		var winSize =  new Core.Size(UI.Window._width, UI.Window._height);
		var widthOffset =  (winSize._width  - 480) / 2 + 20;
		var heightOffset = -(winSize._height - 320) / 2 - 20;
		
		var color = ccc3(237, 226, 177);
				var bgOverlay1 = ZFMenu.makeWindow(w, c, b, f, color, new Core.Rect(0,0,0,0), new Core.Rect(0,0,0,0), s);
				this._bg = bgOverlay1;
		
		this.addChild(bgOverlay1, 0, this.kAlertWindowTags.kAlertWindowTagBG1);
		bgOverlay1.setPosition(ccp(widthOffset, heightOffset));
		
//		color = ccc4(colorPaper.r, colorPaper.g, colorPaper.b, 0xFF);
		
//		// Show the title/banner
		var menuBanner = CCSprite.spriteWithFile(f, new Core.Rect(144, 376, 200, 47));
		this._menuBanner = menuBanner;
		this.addChild(menuBanner, 2);
		menuBanner.setPosition(ccp(widthOffset + 220, -heightOffset + 277 - menuBanner.getSize()._height/2));
		menuBanner.setScale(1.5, 1);
		menuBanner.setAnchorPoint(0.5, 0.5);
		
		
		var menuTitle = CCLabel.labelWithString(this._quest._title, new Core.Size(300, 47), GL2.Text.HorizontalAlign.Center, "AmericanTypewriter-Bold", 20);
		menuTitle.setColor(ZFColorDefines.colorTextDarkBrown);
		menuBanner.addChild(menuTitle, 3);

		this._menuTitle =menuTitle; 
			
		var completeMessage = CCLabel.labelWithString(this._quest._messageComplete, new Core.Size(200, 47), GL2.Text.HorizontalAlign.Center, "AmericanTypewriter-Bold", 17);
		completeMessage.setColor(ZFColorDefines.colorTextAsh);
		completeMessage.setPosition(ccp(224 + widthOffset,210 - heightOffset));
		this.addChild(completeMessage, 3);
		this._completeMessage = completeMessage;

		var icon = CCSprite.spriteWithFile(this._quest._spriteFilename);
		this._icon = icon;
		icon.setPosition(80 + widthOffset - icon.getSize()._width, 210 - heightOffset);
		this.addChild(icon, 2);

		color = ZFColorDefines.colorPaper;
		var cornerSize = CGRectMake(250,1,5,5);
		var barSize	  = CGRectMake(237,1,12,4);
		var windowSize = new Core.Rect(0, 0, 275, 80);
		var requisiteOverlay1 = ZFMenu.makeWindowOld(windowSize, cornerSize, barSize, f, color);

		this.addChild(requisiteOverlay1, 1);
		requisiteOverlay1.setPosition(ccp(82 + widthOffset, -145 + heightOffset));
		this._requisiteOverlay = requisiteOverlay1;
		
		var rewardTitle = CCLabel.labelWithString(Core.Localization.getString("REWARD:"), new Core.Size(200, 47), GL2.Text.HorizontalAlign.Center, "AmericanTypewriter-Bold", 20);
		rewardTitle.setColor(ZFColorDefines.colorTextDarkBrown);
		rewardTitle.setPosition(ccp(220 + widthOffset, 120 - heightOffset));
		this.addChild(rewardTitle, 3);
		this._rewardTitle = rewardTitle;
		
		var rewardMessage = "";
		switch (this._quest._rewardType) 
		{
			case ZFQuestNotification.questRewardTypes.questRewardTypeResourceXP:
//				rewardMessage = this._quest._rewardObject + Core.Localization.getString(" xp");
				rewardMessage = sprintf(NSLocalizedString("%i xp"), this._quest._rewardObject);
				break;
				
			case ZFQuestNotification.questRewardTypes.questRewardTypeResourceGold:
//				rewardMessage = this._quest._rewardObject + Core.Localization.getString(" gold");
				rewardMessage = sprintf(NSLocalizedString("%i gold"), this._quest._rewardObject);
				break;
				
			case ZFQuestNotification.questRewardTypes.questRewardTypeResourceBrains:
//				rewardMessage = this._quest._rewardObject + Core.Localization.getString(" brain(s)");
				rewardMessage = sprintf(NSLocalizedString("%i brain(s)"), this._quest._rewardObject);
				break;
				
			case ZFQuestNotification.questRewardTypes.questRewardTypeItem:;
//				rewardMessage = Core.Localization.getString(quest._rewardObject); 
				rewardMessage = NSLocalizedString(this._quest._rewardObject);
				break;
		}

		var rewardBody = CCLabel.labelWithString(rewardMessage, new Core.Size(200, 47), GL2.Text.HorizontalAlign.Center, "AmericanTypewriter-Bold", 28);
		this._rewardBody = rewardBody;
		
		rewardBody.setPosition(220 + widthOffset, 92 - heightOffset);
		this.addChild(rewardBody, 3);
	
		
		var tintStart = CCTintTo.actionWithDuration(0.5, 0, 0xC0, 0);
		var tintEnd = CCTintTo.actionWithDuration(0.5, 0, 0x40, 0);
		
		var sequence = CCSequence.actions([tintStart, tintEnd]);
		
		var actionTo = CCRepeatForever.actionWithAction(sequence);
		this._repeatAction = actionTo;
		rewardBody.runAction(actionTo);			
		
		dismissItem = CCMenuItemImage.itemFromNormalImage("bigX.png", "bigXSel.png", this, this.dismissAlertNegative.bind(this));
		this._dismiss = CCMenu.menuWithItems([dismissItem]);
		dismissItem.setScale(0.75);
		
		okItem = CCMenuItemImage.itemFromNormalImage("bigCheck.png", "bigCheckSel.png", this, this.dismissAlertPositive.bind(this));
		this._ok = CCMenu.menuWithItems([okItem]);
		okItem.setScale(0.75);
		
//		
//		delayOkButton = 0.f;
//		endScale = 1.f;
//		
		
		this._dismiss.setPosition(ccp( widthOffset + w.getSize()._width - dismissItem.getSize()._width * 0.75, -heightOffset - dismissItem.getSize()._height * 0.75 + w.getSize()._height ));
		this._ok.setPosition(ccp( widthOffset + w.getSize()._width/2 - okItem.getSize()._width*0.5/2, -heightOffset + 13 ));
		
		this.addChild(this._dismiss, 2);
		this.addChild(this._ok, 2);
		
//		body2.color = ccc3(0,0,0);
//		
//		body2.anchorPoint = ccp(.5,1);
//		body2.position = ccp(w.width/2, w.height - 150);
//		self.visible = NO;
//		menuState = menuStateClosed;
	}
	
});

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/ZFMenus/Market/MKStoreObserver'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Market/MKStoreObserver'] || {}; $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Market/MKStoreObserver'] = exports; exports.MKStoreObserver = Core.Class.subclass({ 
    $provideContent: function(productIdentifier, amount)
    {   
        var gs = GameState;
        var gui = ZFGuiLayer.gui();
        var brainBought = false;
        var headBought = false;
        var boughtType = "";
        var tier = 1;
        
        productIdentifier = productIdentifier.replace("debit:", "");
        
        console.log("MKStoreObserver: Attempting to buy " + productIdentifier + ", amount: " + parseInt(amount));
        
        if (productIdentifier == ZFGameDefines.kStoreBrainIdentifier)
        {
            console.log("MKStoreObserver: Buying " + productIdentifier);
            
            tier = 1;
            brainBought = true;
            boughtType = "1";
            gs.addResource(GameData.gameResources.kGameResourceBrains, parseInt(amount));
            gui.displayAlertSimple(
                    Core.Localization.getString("Purchase Successful!"),
                    Core.Localization.getString("You received " + amount + " brain" + ((amount > 1 ) ? "s" : "") + "!"),
                    CCSprite.spriteWithFile("./Content/brainLarge.png"));
        }
        else if (productIdentifier == ZFGameDefines.kStoreBrainIdentifier5Weekday)
        {
            console.log("MKStoreObserver: Buying " + productIdentifier);
            
            tier = 5;
            brainBought = true;
            boughtType = "5";
            gs.addResource(GameData.gameResources.kGameResourceBrains, 5 + 1);
            gui.displayAlertSimple(
                    Core.Localization.getString("Purchase Successful!"),
                    Core.Localization.getString("You received 5 brains!\n\nPlus an additional 1 brain free!"),
                    CCSprite.spriteWithFile("./Content/brainLarge.png"));
        }
        else if (productIdentifier == ZFGameDefines.kStoreBrainIdentifier10Weekday)
        {
            console.log("MKStoreObserver: Buying " + productIdentifier);
            
            tier = 10;
            brainBought = true;
            boughtType = "10";
            gs.addResource(GameData.gameResources.kGameResourceBrains, 10 + 3);
            
            gui.displayAlertSimple(
                    Core.Localization.getString("Purchase Successful!"),
                    Core.Localization.getString("You received 10 brains!\n\nPlus an additional 3 brains free!"),
                    CCSprite.spriteWithFile("./Content/brainLarge.png"));
        }
        else if (productIdentifier == ZFGameDefines.kStoreBrainIdentifier50Weekday)
        {
            console.log("MKStoreObserver: Buying " + productIdentifier);
            
            tier = 50;
            brainBought = true;
            boughtType = "50";
            gs.addResource(GameData.gameResources.kGameResourceBrains, 50 + 15);
            
            gui.displayAlertSimple(
                    Core.Localization.getString("Purchase Successful!"),
                    Core.Localization.getString("You received 50 brains!\n\nPlus an additional 15 brains free!"),
                    CCSprite.spriteWithFile("./Content/brainLarge.png"));
        }
        /*
        else if (productIdentifier == ZFGameDefines.kStoreBrainIdentifier5)
        {
            console.log("MKStoreObserver: Buying " + productIdentifier);
            
            tier = 4;
            brainBought = true;
            boughtType = "5";
            gs.addResource(GameData.gameResources.kGameResourceBrains, 5);
            
            gui.displayAlertSimple(
                    Core.Localization.getString("Purchase Successful!"),
                    Core.Localization.getString("You received 5 brains at a discount!"),
                    CCSprite.spriteWithFile("./Content/brainLarge.png"));
        }
        else if (productIdentifier == ZFGameDefines.kStoreBrainIdentifier10)
        {
            console.log("MKStoreObserver: Buying " + productIdentifier);
            
            tier = 7;
            brainBought = true;
            boughtType = "10";
            gs.addResource(GameData.gameResources.kGameResourceBrains, 10);
            
            gui.displayAlertSimple(
                    Core.Localization.getString("Purchase Successful!"),
                    Core.Localization.getString("You received 10 brains at a discount!"),
                    CCSprite.spriteWithFile("./Content/brainLarge.png"));
        }
        else if (productIdentifier == ZFGameDefines.kStoreBrainIdentifier50)
        {
            console.log("MKStoreObserver: Buying " + productIdentifier);
            
            tier = 35;
            brainBought = true;
            boughtType = "50";
            gs.addResource(GameData.gameResources.kGameResourceBrains, 50);
            
            gui.displayAlertSimple(
                    Core.Localization.getString("Purchase Successful!"),
                    Core.Localization.getString("You received 50 brains at a discount!"),
                    CCSprite.spriteWithFile("./Content/brainLarge.png"));
        }*/
        else if (productIdentifier == ZFGameDefines.kStoreBlueGraveIdentifier)
        {
            console.log("MKStoreObserver: Buying " + productIdentifier);
            
            gs._zfGameData._purchaseFlags.setFlag(ZFGameFlags.PFLAG_UNLOCK_BLUE);
            var item = ZFMarketMenu.theMarket().marketItemFromName("Blue Grave");
            var color = ZFMarketMenu.theMarket().marketColorFromName("Blue Grave");
            var graveKey = item["tile"];
            ZFMarketMenu.theMarket().placeItemAfterSelectingItFromMarket(item, graveKey, color);
            gs.addResource(GameData.gameResources.kGameResourceBrains, 1);            
            gui.displayAlertSimple(
                    Core.Localization.getString("Purchase Successful!"),
                    Core.Localization.getString("You bought the Blue Grave\n\nYou receive one free Brain!"),
                    CCSprite.spriteWithFile("./Content/graveStoneBlue128.png"));
            
            //flurry
            /*NSDictionary* eventDictionary = [NSDictionary dictionaryWithObjectsAndKeys:"Free With Blue Grave", "Source", nil];
            [FlurryAPI logEvent:kFlurryEvent_brainAttained withParameters:eventDictionary];*/
        }
        else if(productIdentifier == ZFGameDefines.kStoreBrainiacPackIdentifier)
        {
            console.log("MKStoreObserver: Buying " + productIdentifier);
            
            tier = 54;
            brainBought = true;
            boughtType = "BrainiacPack";
            gs.addResource(GameData.gameResources.kGameResourceBrains, 100);
            gui.displayAlertSimple(
                    Core.Localization.getString("Purchase Successful!"),
                    Core.Localization.getString("CONGRATULATIONS!\n\nThank you for purchasing the Brainiac Pack...\nYou have received 100 brains!\nAnd the exclusive Pet Brain!"),
                    CCSprite.spriteWithFile("./Content/brainLarge.png"));
            
            var sm = ZFStorageMenu.storageMenu();
            sm.addMarketItemToStorage("Pet Brain");
            sm.retreieveItemWithName("Pet Brain");
        }
        else
        {
            tier = 2;
            
            if (productIdentifier == ZFGameDefines.kStoreFarmerHead1Identifier)
            {
                headBought = true;
                boughtType = "skele male";
                gs._zfGameData._fflags |= ZFGameFlags.FFLAG_HEAD01;
                gs._zfGameData._headID = 2;
                gs._zfGameData._bodyID = 0;
            }
            else if (productIdentifier == ZFGameDefines.kStoreFarmerHead2Identifier)
            {
                headBought = true;
                boughtType = "vamp male";
                gs._zfGameData._fflags |= ZFGameFlags.FFLAG_HEAD02;
                gs._zfGameData._headID = 3;
                gs._zfGameData._bodyID = 0;
            }
            else if (productIdentifier == ZFGameDefines.kStoreFarmerHead3Identifier)
            {
                headBought = true;
                boughtType = "skele female";
                gs._zfGameData._fflags |= ZFGameFlags.FFLAG_HEAD03;
                gs._zfGameData._headID = 6;
                gs._zfGameData._bodyID = 1;
            }
            else if (productIdentifier == ZFGameDefines.kStoreFarmerHead4Identifier)
            {
                headBought = true;
                boughtType = "vamp female";
                gs._zfGameData._fflags |= ZFGameFlags.FFLAG_HEAD04;
                gs._zfGameData._headID = 7;
                gs._zfGameData._bodyID = 1;
            }
            else if (productIdentifier == ZFGameDefines.kStoreFarmerHead5Identifier)
            {
                headBought = true;
                boughtType = "king male";
                gs._zfGameData._fflags |= ZFGameFlags.FFLAG_HEAD05;
                gs._zfGameData._headID = 8;
                gs._zfGameData._bodyID = 0;
            }
            else if (productIdentifier == ZFGameDefines.kStoreFarmerHead6Identifier)
            {
                headBought = true;
                boughtType = "queen female";
                gs._zfGameData._fflags |= ZFGameFlags.FFLAG_HEAD06;
                gs._zfGameData._headID = 9;
                gs._zfGameData._bodyID = 1;
            }
            else if (productIdentifier == ZFGameDefines.kStoreFarmerHead7Identifier)
            {
                headBought = true;
                boughtType = "paper bag head";
                gs._zfGameData._fflags |= ZFGameFlags.FFLAG_HEAD07;
                gs._zfGameData._headID = 12;
                gs._zfGameData._bodyID = 0;
            }
            else if (productIdentifier == ZFGameDefines.kStoreFarmerHead8Identifier)
            {
                headBought = true;
                boughtType = "monolith head";
                gs._zfGameData._fflags |= ZFGameFlags.FFLAG_HEAD08;
                gs._zfGameData._headID = 13;
                gs._zfGameData._bodyID = 0;
            }
            else if (productIdentifier == ZFGameDefines.kStoreFarmerHead9Identifier)
            {
                headBought = true;
                boughtType = "pumpkin head";
                gs._zfGameData._fflags |= ZFGameFlags.FFLAG_HEAD09;
                gs._zfGameData._headID = 14;
                gs._zfGameData._bodyID = 0;
            }
            
            if (ZFActorManager._player && ZFFarmerSelectionMenu.farmerSelectionMenu()._menuState != ZFMenu.menuStates.menuStateOpen)
            {
                ZFActorManager._player.reloadPlayerSprite();
            }
        };
        
        if (!(gs._zfGameData._gflags & ZFGameFlags.GFLAG_SOMETHING_BOUGHT))
        {
            gs._zfGameData._purchaseFlags.setFlag(ZFGameFlags.PFLAG_ONIONMUTATION);
            gs._zfGameData._gflags |= ZFGameFlags.GFLAG_SOMETHING_BOUGHT;
            
            if (gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_UNLOCK_BLUE))
            {
                gui.displayAlertSimple(
                        Core.Localization.getString("Thank You!"),
                        Core.Localization.getString("Thank you for your purchase!\n\nYou have also unlocked the Onion Mutation!"),
                        CCSprite.spriteWithFile("./Content/levelUp.png"));
            }
            else
            {
                gui.displayAlertSimple(
                        Core.Localization.getString("Thank You!"),
                        Core.Localization.getString("Thank you for your purchase!\n\nThe Blue Grave is no longer an in app purchase and can now be bought with brains.\nYou have also unlocked the Onion Mutation!"),
                        CCSprite.spriteWithFile("./Content/levelUp.png"));
            }
        };
        
        gs._zfGameData._isPayingUser = true; // This user is now a paying user
        gs.saveGameReal();
        
        if (ZFFarmerSelectionMenu.farmerSelectionMenu()._menuState == ZFMenu.menuStates.menuStateOpen)
        {
            ZFFarmerSelectionMenu.farmerSelectionMenu().dismissMenu(null);
        }
        
        if (ZFMarketMenu.theMarket()._menuState == ZFMenu.menuStates.menuStateOpen)
        {
            ZFMarketMenu.theMarket().dismissMenu(null);
        }
        
        /* TODO: Flurry
        if (brainBought)
        {
            //flurry
            NSDictionary *eventDictionary = [NSDictionary dictionaryWithObjectsAndKeys:
                                             boughtType, "quantity", 
                                             [NSNumber numberWithInt:gs._zfGameData._level], "level",
                                             nil];
            [FlurryAPI logEvent:kFlurryEvent_boughtBrain withParameters:eventDictionary];
            
            eventDictionary = [NSDictionary dictionaryWithObjectsAndKeys:
                               "In app Purchase", "Source",
                               nil];
            
            for (int i = 0; i < [boughtType intValue]; i++)
            {
                [FlurryAPI logEvent:kFlurryEvent_brainAttained withParameters:eventDictionary];
            }
            
            //apsalar
            
            [Apsalar eventWithArgs:"zf_iap_brains_brains",
                                    "packageType", boughtType,
                                    "price", [NSNumber numberWithInt:tier],
                                    "playerLevel", [NSNumber numberWithInt:gs._zfGameData._level],
                                    nil];
        }
        else if (headBought)
        {
            //flurry
            NSDictionary *eventDictionary = [NSDictionary dictionaryWithObjectsAndKeys:
                                             boughtType, "Type",
                                             [NSNumber numberWithInt:gs._zfGameData._level], "level",
                                             nil];
            [FlurryAPI logEvent:kFlurryEvent_boughtBrain withParameters:eventDictionary];
        }
        else if (productIdentifier == ZFGameDefines.kStoreBlueGraveIdentifier)
        {
            NSDictionary *eventDictionary = [NSDictionary dictionaryWithObjectsAndKeys:
                                             [NSNumber numberWithInt:gs._zfGameData._level], "level",
                                             nil];
            [FlurryAPI logEvent:kFlurryEvent_boughtGrave withParameters:eventDictionary];
        } */
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/ZFMenus/Market/ZFMarketMenu'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Market/ZFMarketMenu'] || {}; $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Market/ZFMarketMenu'] = exports; var ZFSelectorLayer = require('Code/Game/GUI/GuiLayer/ZFSelectorLayer').ZFSelectorLayer;
var ZFBuyable = require('Code/Game/GUI/ZFMenus/Market/ZFBuyable').ZFBuyable;

var MARKET_PAGE_PER_SCREEN = 6;

exports.ZFMarketMenu = ZFMenu.singleton({
    classname : 'ZFMarketMenu',
    
    kMarketTag : {
        kTagBuyable : ZFMenu.kZFMenuTags.kMenuTagMAX,
        kMarketTagSubcategoryLabel : 4,
        kMarketTagSubcategorySeparator1 : 5,
        kMarketTagSubcategorySeparator2 : 6,
        kMarketTagBuyablesFrame : 7,
        kMarketTagTapJoyLabelButton : 8,
        kMarketTagTapJoyLabelHeader : 9,
        kMarketTagTapJoySprite : 10,
        kMarketTagTapJoyLayer : 11,
        kMarketTagUIView : 12,
        kMarketTagBuyablesNewBadge : 13,
        kMarketTagBuyablesResourceIcon : 14,
        kMarketTagBuyablesamountGivenPerPurchase : 15,
        kMarketTagPromoLayer : 16,
        kMarketTagPromoLabelButton : 17,
        kMarketTagPromoLabelText1 : 18,
        kMarketTagPromoLabelText2 : 19,
        kMarketTagPromoLabelBestValue : 20
    },
    
    kMarketAlert : {
        kMarketAlertBuyBrains : 1,
        kMarketAlertConvertBrains : 2,
        kMarketAlertUnlockItemEarly : 3,
        kMarketAlertConfirmPurchase : 4,
        kMarketAlertShortcutBuy : 5
    },
    
    initialize : function()
    {
        this._exist = false;
        this._subCategoryMenu = null;
        
        // init selected category and subCategory elements (original ObjC
        // look a bit diffrent, but i cannot do this in that way here ;p
        // )
        this._subCategory = "plant";
        
        this._windowNode.setScale(CCDirector.zoomValue());
        if (CCDirector.zoomValue()._x > 1.0)
            this._windowNode.setPosition(new Core.Point(-this._windowNode.getSize()._width * 1/8, -this._windowNode.getSize()._height * 1/8));
    },
    
    // use this to construct the market menu properly asynchronously
    // with a callback at the end
    init : function(cb)
    {
        this._cb = cb;
        this._brainFragments = 0;
        
        var w = new Core.Size(480, 320);
        
        // //iPad scaling
        // CGRect mainFrame = [[UIScreen mainScreen] bounds];
        // float resolutionHeight = mainFrame.size.width;
        this._additionalItems = 0;
        this._menuWidthOffset = 0;
        this._menuWidthScale = 1;
        
        // if (resolutionHeight>ORIGINAL_WINDOW_HEIGHT)
        // {
        // additionalItems = 4;
        // menuWidthOffset = 121; //account for the 2 more columns for
        // menu
        // menuWidthScale = (320.0f+200.0f)/(320.0f); //scale of menu w/
        // 5 columns to menu w/ 3 columns
        // [super initElementsWithWindowScale:menuWidthScale :1.0f
        // atX:menuWidthOffset Y:heightOffset];
        // }
        
        // this.initBrowseMenuWithPosition(ccp(w._width/2), 241),
        // 400 * this._menuWidthScale;
        // this.initBannerWithString(Core.Localization.getString("Market"),
        // new Core.Size(200, 50), 20);
        // menuBanner.scaleY *= 0.95f;
        
        this.initPleaseWaitLayer();
        
        // console.log("--");
        // console.log(this._browseMenu);
        // this._browseMenu.destroy();
        // this.reorderChild(this._browseMenu, 2);
        //		
        // [[NSNotificationCenter defaultCenter] addObserver:self
        // selector:@selector(boxClose:)
        // name:SHOW_BOX_CLOSE_NOTIFICATION
        // object:nil];
        
        //FIXME: Hack for debug
//        var val = GameState.xpNeededForLevel(25);
//        GameState.addResource(GameData.gameResources.kGameResourceXP, val);
        
        this.finishInit();
    },
    
    dismissMenu : function($super, sender)
    {
        this.hideMobageButtons();
        this.removeBlayers();
        
        destroyWithChildren(this._subCategoryMenu);
        
        $super(sender);
    },
    
    openMenuWithPage : function(page)
    {
        this._currentPage = page;
        this.openMenu();
    },
    
    openMenu : function($super)
    {
        // this.ZFGuiLayer.disableMenus();
        $super();
        
        this._paymentPending = false;
        // showSeasonalItems = [[GameState gameState]
        // seasonalItemsAvailable];
        //		
        // // PAIR THESE TOGETHER //
        // NSUserDefaults *defaults = [NSUserDefaults
        // standardUserDefaults];
        // NSNumber *isIncentivizedInstallsAllowed =
        // (NSNumber*)[defaults
        // objectForKey:ZFAllowIncentivizedInstalls];
        //	    
        // if (isIncentivizedInstallsAllowed &&
        // [isIncentivizedInstallsAllowed boolValue] == YES)
        // {
        // [[NSNotificationCenter defaultCenter] addObserver:self
        // selector:@selector(getUpdatePoints:)
        // name:TJC_TAP_POINTS_RESPONSE_NOTIFICATION
        // object:nil];
        // [[TapjoyConnect sharedTapjoyConnect] getTapPoints];
        // }
        
        // this.enableInput();
        this.updateBrains();
        this.updateGold();
        
        if (!this._category)
        {
            this._category = "crop";
        }
        
        this.setMarketCategory(this);
    },
    
    showMobageButtons : function()
    {
        if (!this._mobageButtonsVisible)
        {
        	//var balanceRect = new UI.ViewGeometry.Rect(5 * this._widthScale, UI.Window._height - 35 * this._heightScale, 25 * this._widthScale, 10 * this._heightScale);
        	var balanceRect = new UI.ViewGeometry.Rect(5 * this._widthScale, UI.Window._height - 40 * this._heightScale, 100 * this._widthScale, 40 * this._heightScale);
            Social.Common.Service.showBalanceButton(balanceRect, function(error)
            {
            	if(error){
            		console.log('///ZFMarketMenu.showMobageButtons error: ' + error.description);
            	}
            });
            this._mobageButtonsVisible = true;
        }
    },
    
    hideMobageButtons : function()
    {
        if (this._mobageButtonsVisible)
        {
            Social.Common.Service.hideBalanceButton(function(error)
            {
            	if(error){
            		console.log('///ZFMarketMenu.hideMobageButtons error: ' + error.description);
            	}
            });
            this._mobageButtonsVisible = false;
        }
    },
    
    _initSprite : function(idx)
    {
        var sprite = CCSprite.spriteWithFile("hudElements.png", new Core.Rect(138, 204, 62, 43));
        if (idx == 1)
        {
            sprite.setColor(ZFColorDefines.colorBrownButton2);
        }
        
        if (idx == 2)
        {
            sprite.setColor(ZFColorDefines.colorYellowButton2);
        }
        
        sprite.setScale(ccp(this._menuWidthScale, 1));
        
        return sprite;
    },
    
    _setButtonLabel : function(button, labelText, fontSize)
    {
        var menuFontName = "Arial-BoldMT";
        if (!fontSize)
            fontSize = 12.5;
        
        catLabel = CCLabel.labelWithString(Core.Localization.getString(labelText), menuFontName, fontSize);
        catLabel.setColor(ccc3(0, 0, 0));
        button.addChild(catLabel, 2);
        catLabel.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
        catLabel.setPosition(ccp(button.getSize()._width / 2 - 2, button.getSize()._height / 2 + fontSize / 2));
    },
    
    finishInit : function()
    {
        this._marketArray = DataPreloader._marketData;
        
        // console.log(this._marketArray);
        var menuFontSize = 48;
        var menuFontName = "Arial-BoldMT";
        this._paymentPending = false;
        this._maxMenuPages = 100;
        
        // menuBanner.position = ccp((w.width*menuWidthScale)/2,
        // w.height - 21);
        // backgroundSprite.scale = 1.05f;
        // [backgroundSprite setPosition:CGPointMake(240.f,160.f)];
        // dismissMenu.position = ccpAdd(dismissMenu.position,
        // CGPointMake(menuWidthOffset, 0));
        
        var sp1 = CCSprite.spriteWithFile("MarketMenuSubcatSeparator.png");
        sp1.setScale(113 * this._menuWidthScale, 24);
        sp1.setOpacity(128);
        // sp1.setPosition(ccp((480*this._menuWidthScale)/2 +
        // this._menuWidthOffset, 320 - 93 + this._heightOffset));
        sp1.setPosition(ccp(241 + this._widthOffset, 320 - 93 - this._heightOffset));
        sp1.setAnchorPoint(ccp(0.5, 1));
        this._windowNode.addChild(sp1, 3, this.kMarketTag.kMarketTagSubcategorySeparator1);
        sp1._inmortal = true;
        // categories
        
        // CROPS
        this._cropsItem = new CCMenuItemToggle();
        var it1 = null;
        var it2 = null;
        
        var sprite1 = this._initSprite(1);
        var sprite2 = this._initSprite(1);
        it1 = CCMenuItemImage.itemFromNormalSprite(sprite1, sprite2);
        
        sprite1 = this._initSprite(2);
        sprite2 = this._initSprite(2);
        it2 = CCMenuItemImage.itemFromNormalSprite(sprite1, sprite2);
        this._cropsItem.initWithTarget(this._cropsItem, this.setMarketCategory.bind(this), [ it1, it2 ]);
        
        // ITEMS
        this._itemsItem = new CCMenuItemToggle();
        
        sprite1 = this._initSprite(1);
        sprite2 = this._initSprite(1);
        it1 = CCMenuItemImage.itemFromNormalSprite(sprite1, sprite2);
        
        sprite1 = this._initSprite(2);
        sprite2 = this._initSprite(2);
        it2 = CCMenuItemImage.itemFromNormalSprite(sprite1, sprite2);
        
        this._itemsItem.initWithTarget(this._itemsItem, this.setMarketCategory.bind(this), [ it1, it2 ]);
        
        // UPGRADE
        this._upgradeItem = new CCMenuItemToggle();
        sprite1 = this._initSprite(1);
        sprite2 = this._initSprite(1);
        it1 = CCMenuItemImage.itemFromNormalSprite(sprite1, sprite2);
        sprite1 = this._initSprite(2);
        sprite2 = this._initSprite(2);
        it2 = CCMenuItemImage.itemFromNormalSprite(sprite1, sprite2);
        
        this._upgradeItem.initWithTarget(this._upgradeItem, this.setMarketCategory.bind(this), [ it1, it2 ]);
        
        // BOOST
        this._boostItem = new CCMenuItemToggle();
        sprite1 = this._initSprite(1);
        sprite2 = this._initSprite(1);
        it1 = CCMenuItemImage.itemFromNormalSprite(sprite1, sprite2);
        sprite1 = this._initSprite(2);
        sprite2 = this._initSprite(2);
        it2 = CCMenuItemImage.itemFromNormalSprite(sprite1, sprite2);
        
        this._boostItem.initWithTarget(this._boostItem, this.setMarketCategory.bind(this), [ it1, it2 ]);
        
        // BRAINS
        this._brainsItem = new CCMenuItemToggle();
        sprite1 = this._initSprite(1);
        sprite2 = this._initSprite(1);
        it1 = CCMenuItemImage.itemFromNormalSprite(sprite1, sprite2);
        sprite1 = this._initSprite(2);
        sprite2 = this._initSprite(2);
        it2 = CCMenuItemImage.itemFromNormalSprite(sprite1, sprite2);
        
        this._brainsItem.initWithTarget(this._brainsItem, this.setMarketCategory.bind(this), [ it1, it2 ]);
        
        this._categoryMenu = CCMenu.menuWithItems([ this._cropsItem, this._itemsItem, this._upgradeItem, this._boostItem, this._brainsItem ]);
        this._categoryMenu.setPosition(ccp(this._winSize._width / 2 - this._cropsItem.getSize()._width / 2 + 4, this._winSize._height + this._heightOffset - 66 - this._cropsItem.getSize()._height / 2 - 4));
        
        this._windowNode.addChild(this._categoryMenu, 2);
        this._categoryMenu._inmortal = true;
        this._categoryMenu.alignItemsHorizontallyWithPadding(1);
        
        this._setButtonLabel(this._cropsItem, "Crops");
        this._setButtonLabel(this._itemsItem, "Items");
        this._setButtonLabel(this._upgradeItem, "Upgrade");
        this._setButtonLabel(this._brainsItem, "Brains");
        this._setButtonLabel(this._boostItem, "Boosts");
        
        //this._cropsItem.__category = "crop";
        //this._itemsItem.__category = "item";
        //this._upgradeItem.__category = "upgrade";
        //this._brainsItem.__category = "brain";
        //this._boostItem.__category = "boost";
        
        this._playersGold = CCLabel.labelWithString("0", menuFontName, menuFontSize);
        this._playersGold.setPosition(ccp(97 + this._widthOffset, 320 - this._heightOffset - 23));
        this._playersGold.setAnchorPoint(ccp(1, 0.5));
        this._playersGold._label.setScale(0.35,0.35);
        this._playersGold.setHorizontalAlign(GL2.Text.HorizontalAlign.Right);
        this._playersGold.setColor(ccc3(0, 0, 0));
        this._windowNode.addChild(this._playersGold, 2);
        this._playersGold._inmortal = true;
        this.updateGold();
        
        this._playersBrains = CCLabel.labelWithString("0", menuFontName, menuFontSize);
        this._playersBrains.setPosition(ccp(97 + this._widthOffset, 320 - this._heightOffset - 38));
        this._playersBrains.setAnchorPoint(ccp(1, 0.5));
        this._playersBrains._label.setScale(0.35,0.35);
        this._playersBrains.setHorizontalAlign(GL2.Text.HorizontalAlign.Right);
        this._playersBrains.setColor(ccc3(0, 0, 0));
        this._windowNode.addChild(this._playersBrains, 2);
        this._playersBrains._inmortal = true;
        this.updateBrains();
        //			
        var goldSprite = CCSprite.spriteWithFile("gold.png");
        goldSprite.setAnchorPoint(0, 0.5);
        goldSprite.setScale(ccp(0.66, 0.66));
        this._windowNode.addChild(goldSprite, 2);
        goldSprite._inmortal = true;
        goldSprite.setPosition(ccp(99 + this._widthOffset, 320 - this._heightOffset - 23));
        
        var brainsSprite = CCSprite.spriteWithFile("brain.png");
        brainsSprite.setAnchorPoint(0, 0.5);
        brainsSprite.setScale(ccp(0.66, 0.66));
        this._windowNode.addChild(brainsSprite, 2);
        brainsSprite._inmortal = true;
        brainsSprite.setPosition(ccp(99 + this._widthOffset, 320 - this._heightOffset - 38));
        
        this._cropsItem.setSelectedIndex(1);
        this._itemsItem.setSelectedIndex(0);
        this._category = "crop";
        
        this.marketProducts = null;
        // [self requestProductData];
        this._exist = true;
        this._cb();
    },
    
    $exists : function()
    {
        return this._exist;
    },
    
    $theMarket : function()
    {
        return this;
    },
    
    marketItemFromName_withProperty : function(name, property)
    {
    	//JP: This function was modify to accept name or unitkey
        
        var unitKey = this.nameFromUnitKey(name);
        
        for ( var key in this._marketArray )
        {
            var item = this._marketArray[key];
            if (name == item["name"] || name == item["unitKey"])
            {
                if (property)
                {
                    if (item[property])
                    {
                        return item;
                    }
                }
                else
                {
                    return item;
                }
            }
        }
        
        return null;
    },
    
    marketItemFromTileKey : function(tileKey)
    {
        // 255,255,255 == 0xff,0xff,0xff
        return this.marketItemFromTileKey_withColor(tileKey, ccc3(255, 255, 255));
    },
    
    marketItemFromTileKey_withColor : function(tileKey, color)
    {       
        var tempItem = null;
        
        // should we ever need to have an item that doesn't exist have a
        // specific color use these vars
        // NSDictionary *fixItem = nil;
        var tim = ZFTileManager;
        var dict = tim._tilePropertiesDictionary[tileKey];
        
        var newTileKey = null;
        if (dict && dict["marketKey"])
        {
            newTileKey = dict["marketKey"];
        }
        else
        {
            newTileKey = tim.fixedTileKey_checkUsesSeparateRotateSprite(tileKey, true);
        }
        
        for (var key in this._marketArray)
        {
            var item = this._marketArray[key];
            if (newTileKey == item["tile"])
            {
                tempItem = item;
                var marketColor = null;
                
                var colorArray = item["color"];
                if (colorArray)
                {
                    marketColor = ccc3(colorArray[0], colorArray[1], colorArray[2]);
                }
                else
                {
                    marketColor = ccc3(255, 255, 255);
                }
                
                if (Math.abs(marketColor.getRed() - color.getRed()) < 0.05 &&
                    Math.abs(marketColor.getGreen() - color.getGreen()) < 0.05 &&
                    Math.abs(marketColor.getBlue() - color.getBlue()) < 0.05)
                {
                    break;
                }
            }
        }
        
        return tempItem;
    },
    
    marketItemFromTilePropertiesKey : function(key)
    {
        var tim = ZFTileManager;
        var tileItemDictionary = tim._tilePropertiesDictionary[key];        
        var name = tileItemDictionary["name"];
        var marketItemDictionary = this.marketItemFromName(name);
        
        // if no name matches try match the key
        if (!marketItemDictionary)
        {
            marketItemDictionary = this.marketItemFromTileKey(key);
        }
        
        return marketItemDictionary;
    },
    
    marketItemFromName : function(name)
    {
        return this.marketItemFromName_withProperty(name, null);
    },
    
    subCategoryFromName : function(name)
    {
//        console.log("subCategoryFromName " + name);
        var item = this.marketItemFromName(name);
        if (item)
        {
            return item["subCategory"];
        }
        return null;
    },
    
    growTimeFromName : function(name)
    {
        var item = this.marketItemFromName(name);
        if (item)
        {
            return item["growTime"];
        }
        
        return 0; // insta grow
    },
    
    displayPage : function(pageID)
    {
        this.setupCategory(this._category, this._subCategory, this._currentPage);
    },
    
    setupCategory : function(aCategory, aSubcategory, pageNumber)
    {
        if (aCategory == "brain" && aSubcategory == "brain")
        {
            this.showMobageButtons();
        }
        else
        {
            this.hideMobageButtons();
        }
        
        var gs = GameState;
//        console.log("setupCategory " + aCategory + " | " + aSubcategory + "|" + pageNumber);
        this.removeBlayers();
        
        this._buyableLayers = [];
        
        var buyables = [];
        
        for ( var i in this._marketArray ) 
        {
            var item = this._marketArray[i];
            
            var itemCategory = item.category;
            var itemSubCategory = item.subCategory;
            //console.log("" + i +  " = " + item.name + " , category = " + itemCategory + " , sub =" + itemSubCategory);
            // Find limited and new items for new New subCategory
            var isNew = item["new"];
            var isLimited = item.limited;
            
            if ((itemCategory && itemCategory == aCategory && itemSubCategory && itemSubCategory == aSubcategory) ||
                (itemCategory && itemCategory == aCategory && ((isNew || isLimited) && aSubcategory == "new")))
            {
                // if this item is not available because of an item you
                // dont have, dont show it
                if (item.modular)
                {
                    // this is for storage
                    if (item.flagNeeded)
                    {
                        var flagVal = item.flagNeeded;
                        //
                        if (!gs._zfGameData._purchaseFlags.hasFlag(flagVal))
                        {
                            continue;
                        }
                    }
                    // this is for mausoleums
                    else if (item["mausoleumFlagNeeded"])
                    {
                        var flagVal = item["mausoleumFlagNeeded"];
                        if (!(gs._zfGameData._mausoleumFlags & flagVal))
                        {
                            continue;
                        }
                    }
                }
                
                if (item.limited && !this._showSeasonalItems)
                {
                    continue;
                }
                
                //FIXME: Remove when they get implemented

                if(/*item.name != "Golden Dice"*/
                    /*&& item.name != "Insta-Grow" &&*/
                    /*item.name != "Zombie Pot" && */
                    /*item.name != "Blue Grave" &&*/
                    item.name != "Zombie Camera" /*&& 
                    /*item.name != "Zombie Patch" &&*/
                    /*item.name != "Rusty Fragment" && 
                    /*item.name != "Red Grave" &&*/
                    /*item.name != "Clay Monolith" &&*/
                    /*item.name != "Speed Monolith" &&*/
                    /*item.name != "Mutant Monolith" &&*/
                    /*item.name.indexOf("Mauso") < 0*/ )

                {
                	buyables.push(item);
                }
            }
        }
        var length = buyables.length;
        for ( var i = length-1 ; i > -1; i-- )
        {
            var item = buyables[i];
            // purchase
            if (item.purchaseFirstWithGold)
            {
                var name = item.name;
                if (name == "Zombie Pot" && gs._zfGameData._zombiePotBought)
                {
                	buyables.splice(i, 1);
//                    toRemove.push(item);
                }
            }
            
            if (item.modular)
            {
                if (item.pflag)
                {
                    var item1flagVal = item.pflag;
                    
                    for ( var i2 in buyables)
                    {
                        var item2 = buyables[i2];
                        if (item2.flagNeeded && item2.modular)
                        {
                            var item2flagVal = item2.flagNeeded;
                            if (item2flagVal == item1flagVal)
                            {
                            	buyables.splice(i, 1);
//                                toRemove.push(item);
                            }
                        }
                    }
                }
                else if (item.mausoleumFlag)
                {
                    var item1flagVal = item.mausoleumFlag;
                    
                    for ( var i2 in buyables)
                    {
                        var item2 = buyables[i2];
                        if (item2.mausoleumFlagNeeded && item2.modular)
                        {
                            var item2flagVal = item2.mausoleumFlagNeeded;
                            if (item2flagVal == item1flagVal)
                            {
                            	buyables.splice(i, 1);
//                                toRemove.push(item);
                            }
                        }
                    }
                }
            }
            
            // weekend special
            // Sunday = 1, Saturday = 7 Friday = 6
            var weekday = (new Date()).getDay() + 1;
            // int weekday = [[[NSCalendar currentCalendar] components:NSWeekdayCalendarUnit fromDate:[NSDate date]] weekday];
            // int hour = [[[NSCalendar currentCalendar] components:NSHourCalendarUnit fromDate:[NSDate date]] weekday];
            
            if (item.weekendsOnly && (weekday != 1 && weekday != 6 && weekday != 7))
            {
            	buyables.splice(i, 1);
//                toRemove.push(item);
            }
            if (item.weekdaysOnly && (weekday == 1 || weekday == 6 || weekday == 7))
            {
            	buyables.splice(i, 1);
//                toRemove.push(item);
            }
            
            if (item.dontShowInMarket)
            {
            	buyables.splice(i, 1);
//                toRemove.push(item);
            }
        }
        
        if (buyables.length <= 0)
        {
            return;
        }

    	buyables.sort(this._sorter.bind(this));
        
        for ( var i = 0; (i < (MARKET_PAGE_PER_SCREEN + this._additionalItems)) && (i + (pageNumber * (MARKET_PAGE_PER_SCREEN + this._additionalItems)) < buyables.length); i++)
        {
            var item = buyables[Math.floor(i + (pageNumber * (MARKET_PAGE_PER_SCREEN + this._additionalItems)))];
            this.addBuyableLayerWithItem(item, i);
            // console.log(item);
        }
        var totalPages = Math.ceil(buyables.length / MARKET_PAGE_PER_SCREEN + this._additionalItems);
        this._forwardItem.setVisible(this._currentPage < totalPages - 1);
        // this._forwardItem.isEnabled = (this._currentPage !=
        // totalPages - 1);
        this._backItem.setVisible(this._currentPage != 0);
        // this._backItem.isEnabled(this._currentPage != 0);
        
        this.displayPageSprites();
        this.displayTapJoyStuff();
        this.displayBrainPackPromo();
    },
    
    _sorter : function(a, b)
    {
        if (a.limited == b.limited)
        {
            if (a["new"] == b["new"])
            {
                if (a.level == b.level)
                {
                	//FIXME: Sort on android is not stable
                    if (a.cost - b.cost){
                    	return a.cost - b.cost;
                    }
                    //FIXME: Hack for previous fix
                    else if (a.subCategory == "brain")
                    {
                    	return (a.spriteSheet - b.spriteSheet);
                    }
                    
                    if (a.name >= b.name)
                    		return 1;
                    	return -1;
                    
                }
                else
                {
                	if(typeof(a.level) == "undefined")
                		return -1;
                	if(typeof(b.level) == "undefined")
                		return 1;
                	return (a.level - b.level);
                }
            }
            else
            {
                if (typeof(a["new"]) == "undefined")
                    return 1;
                if (typeof(b["new"]) == "undefined")
                    return -1;
                return (b["new"] - a["new"]);
            }
        }
        else
        {
            if (typeof(a.limited) == "undefined")
                return 1;
            if (typeof(b.limited) == "undefined")
                return -1;
            return (b.limited - a.limited);
        }
        
    },
    
    displayPageSprites : function()
    {
        for ( var i in this._buyableLayers)
        {
            var blayer = this._buyableLayers[i];
            
            // skip this for actors
            if (blayer.item.actor)
            {
                if (blayer.spriteNode)
                {
                    // [blayer.spriteNode removeAllChildrenWithCleanup:YES];
                    // [self removeChild:blayer.spriteNode cleanup:YES];
                }
                if (blayer.mgr)
                {
                    // [blayer.mgr removeAllChildrenWithCleanup:YES];
                    // [self removeChild:blayer.mgr cleanup:YES];
                }
                continue;
            }
            
            // if this blayer's index is the current page show it.
            
            if (!blayer.mgr && !blayer.spriteNode)
            {
                var offsetX = 0;
                var offsetY = 0;
                
                if (blayer.item.offsetY)
                {
                    offsetY = blayer.item.offsetY;
                }
                
                if (blayer.item.offsetX)
                {
                    offsetX = blayer.item.offsetX;
                }
                
                var spriteNode = this.spriteNodeFromKey(blayer.item.tile, true, this.marketColorFromName(blayer.item.name));
                
                var pos = ccp(-47 + offsetX + this._widthOffset, -5 + offsetY);
                
                if (spriteNode)
                {
                    destroy(blayer.spriteNode);
                    blayer.spriteNode = spriteNode;
                    blayer.addChild(blayer.spriteNode, 3);
                    
                    spriteNode.setPosition(pos);
                    //spriteNode.setAnchorPoint(ccp(0.5,0.5));
                    for ( var i in spriteNode._children)
                    {
                        var c = spriteNode._children[i];
                        // c.setOpacity( (this._menuState == this.menuStates.menuStateOpen )?255:0 );
                    }
                }
                else
                {
                    destroy(blayer.mgr);
                    blayer.mgr = this.spritesheetFromItem(blayer.item);
                    if (blayer.mgr)
                    {
                        blayer.addChild(blayer.mgr, 3);
                        var sprite = blayer.mgr._children[0];
                        sprite.setPosition(pos);
                        sprite.setAnchorPoint(ccp(0.5, 0.5));
                        // sprite.opacity = (menuState == menuStateOpen)
                        // ? 0xFF : 0x00;
                    }
                    else
                    { // not all of the textures for this item
                        // are correct, skip
                        // if (blayer.spriteNode)
                        {
                            // [blayer.spriteNode removeAllChildrenWithCleanup:YES];
                            // [self removeChild:blayer.spriteNode cleanup:YES];
                        }
                        continue;
                    }
                    
                }
            }
            else if (blayer.mgr._children.length > 0 || blayer.spriteNode)
            {
                if (blayer.spriteNode)
                {
                    for ( var i in blayer.spriteNode._children)
                        blayer.spriteNode._children[i].setVisible(true);
                }
                else
                {
                    blayer.mgr._children[0].setVisible(true);
                }
            }
            
            var colorConv = ccc3(0xFF, 0xFF, 0xFF);
            if ((blayer.mgr && blayer.mgr._children.length > 0) || blayer.spriteNode)
            {
                var colorArray = blayer.item.color;
                
                if (colorArray)
                {
                    colorConv = ccc3(colorArray[0], colorArray[1], colorArray[2]);
                }
                
                if (blayer.spriteNode)
                {
                    for ( var i in blayer.spriteNode._children)
                        blayer.spriteNode._children[i].setColor(colorConv); //
                }
                else
                {
                    blayer.mgr._children[0].setColor(colorConv);
                }
            }
        }
        
    },
    
    displayTapJoyStuff : function()
    {
        // TODO
    },
    
    displayBrainPackPromo : function()
    {
        // TODO
    },
    
    spriteNodeFromKey : function(key, marketSize, color)
    {
        if (!color)
            color = ccc3(0, 0, 0);
        
        var tim = ZFTileManager;
        var acm = ZFActorManager;
        
        if (tim._tilePropertiesDictionary[key])
        {
            return tim.spriteNodeFromKey(key, true, color);
        }
        else
        {
            return StageActor.spriteNodeForDictionary(acm._stageActorDictionaries[key], color);
        }
        
        return null;
    },
    
    marketColorFromName : function(name)
    {
        var colorConv = ccc3(0xFF, 0xFF, 0xFF);
        for (var key in this._marketArray)
        {
            var item = this._marketArray[key];
            if (name == item["name"] && item["color"])
            {
                var colorArray = item["color"];
                if (colorArray)
                {
                    colorConv = ccc3(Number(colorArray[0]), Number(colorArray[1]), Number(colorArray[2]));
                }
                
                break;
            }
        }
        
        return colorConv;
    },
    
    // {ZFBuyable} itemDict
    spritesheetFromItem : function(itemDict)
    {
        var filename = itemDict.spriteSheet;
        var spriteRect = new Core.Rect(0, 0, 0, 0);
        var scale = 1;
        var width = 32;
        var height = 32;
        var originX = 0;
        var originY = 0;
        
        // BOOL flipX = NO;
        // BOOL flipY = NO;
        // BOOL rot90 = NO;
        
        // NSDictionary *dictWithSpriteInfo = itemDict;
        // NSNumber *useTileSheet = [itemDict
        // objectForKey:@"spriteInfoInTileProperties"];
        //			
        //
        // if (useTileSheet && [useTileSheet boolValue])
        // {
        // ZFTileManager *tim = [ZFTileManager tileManager];
        // dictWithSpriteInfo = [tim.tilePropertiesDictionary
        // objectForKey: [itemDict objectForKey:@"tile"]];
        // if (!dictWithSpriteInfo)
        // {
        // NSLog(@"%@ missing dictionary counterpart in
        // tilesProperties",[itemDict objectForKey:@"name"]);
        // dictWithSpriteInfo = [tim.tilePropertiesDictionary
        // objectForKey:@"missingItem"];
        // }
        // NSAssert(dictWithSpriteInfo, @"missing dictionary");
        // filename = [dictWithSpriteInfo objectForKey:@"spriteSheet"];
        // }
        //			
        mgr = CCSpriteSheet.spriteSheetWithFile(filename, 1);
        
        if (!mgr.texture)
        {
            console.log("spritesheetFromItem: couldn't add texture");
            return null;
        }
        
        // TODO: need pixels width and height in spritesheet
        var widthData = itemDict.width;
        if (widthData)
        {
            width = widthData;
        }
        else
        {
            // if(width != mgr.texture.pixelsWide)
            // width = mgr.texture.pixelsWide;
            width = 32;
        }
        
        var heightData = itemDict.height;
        if (heightData)
        {
            height = heightData;
        }
        else
        {
            // if(height != mgr.texture.pixelsHigh)
            // height = mgr.texture.pixelsHigh;
            width = 32;
        }
        
        // NSNumber *xData = [dictWithSpriteInfo objectForKey:@"x"];
        // if (xData)
        // {
        // originX = [xData intValue];
        // }
        //			
        // NSNumber *yData = [dictWithSpriteInfo objectForKey:@"y"];
        // if (yData)
        // {
        // originY = [yData intValue];
        // }
        //			
        // NSNumber *flipXData = [dictWithSpriteInfo
        // objectForKey:@"flipX"];
        // if (flipXData)
        // {
        // flipX = [flipXData boolValue];
        // }
        //			
        // NSNumber *flipYData = [dictWithSpriteInfo
        // objectForKey:@"flipY"];
        // if (flipYData)
        // {
        // flipY = [flipYData boolValue];
        // }
        //			
        // NSNumber *rot90Data = [dictWithSpriteInfo
        // objectForKey:@"rot90"];
        // if (rot90Data)
        // {
        // rot90 = [rot90Data boolValue];
        // }
        //			
        // NSNumber *scaleData = [itemDict objectForKey:@"scale"];
        // if (scaleData)
        // {
        // scale = [scaleData floatValue];
        // }
        //			
        // NSAssert(filename, @"filename missing in
        // displayPageSprites");
        spriteRect = new Core.Rect(originX, originY, width, height);
        var sprite = new CCSprite();
        sprite.initWithSpriteSheet(mgr, spriteRect);
        sprite._sprite._animation.setFilteringEnabled(true);
        // sprite.scale = scale;
        //			
        // if (flipX)
        // {
        // [sprite setFlipX:YES];
        // }
        //			
        // if (flipY)
        // {
        // [sprite setFlipY:YES];
        //				
        // }
        //			
        // if (rot90)
        // {
        // sprite.rotation = 90;
        // }
        //			
        
        mgr.addChild(sprite, 1);
        return mgr;
    },
    
    removeBlayers : function()
    {
        
//        var found = true;   
         if (this._marketActorList)
         {
        	var length = this._marketActorList.length;
         	for (var i = length-1; i >= 0; i--)
     		{
         		if(this._marketActorList[i]){
         			this._marketActorList[i].despawn();
         			this._marketActorList.splice( i, 1 );
         		}
     		}
         }
        //			
        // [marketActorList removeAllObjects];
        // marketActorList= nil;
        // }
        //		
        
        //				while(found)
        //				{
        //					found = false;
        //							
        //					for (var i in this._children)
        //					{
        //						var node = this._children[i];
        //						if (node._tag == this.kMarketTag.kTagBuyable)
        //						{
        //							var blayer = node;
        //							if (blayer._buyButton)
        //							{
        //								for (var b in blayer._buyButton._children)
        //								{
        //									var tmp = blayer._buyButton._children[b];
        //									blayer._buyButton.removeChild(b, true);
        //									blayer._buyButton.removeAllChildrenWithCleanup(true);
        //									blayer._buyButton._parent.removeChild(blayer._buyButton, true);
        //								}
        //							}
        //												
        //							if (blayer._backgroundSprite && blayer._backgroundSprite._parent)
        //							{
        //								blayer._backgroundSprite._parent.removeChild(blayer._backgroundSprite, true);
        //							}
        //												
        //							if (blayer._newBadge && blayer._newBadge._parent)
        //							{
        //								blayer._newBadge._parent.removeChild(blayer._newBadge, true);
        //							}
        //												
        //							if (blayer._mgr)
        //							{
        //								blayer._mgr.removeAllChildrenWithCleanup(true);
        //								this.removeChild(blayer._mgr, true);
        //							}
        //							
        //							blayer.removeAllChildrenWithCleanup(true);
        //							this.removeChild(blayer, true);
        //							
        //							console.log(blayer);
        //							
        //							destroyWithChildren(blayer);
        //							found = true;
        //							break;
        //					 	}
        //					}
        //				 }
        
        for ( var i in this._buyableLayers)
        {
            var it = this._buyableLayers[i];
            
            destroyWithChildren(it);
        }
        
        if (this._buyableLayers)
        {
            this._buyableLayers.length = 0;
        }
        //TODO: CCTextureCache.sharedTextureCache.removeUnusedTextures();
    },
    
    unlockItem : function(sender)
    {
        var w = CGSizeMake(480, 320);
        var gs = GameState;
        var gui = ZFGuiLayer.gui();
        var blayer = sender;
        
        if (!blayer)
        {
            return;
        }
        
        if ( this._blockOtherUnlockingOperations )
        {
            return;
        }
        
        // Calculate the number of brains needed for unlocking as
        // a linear function to how far away from the intended level
        // the user is.
        var unlockCost = Math.abs(Number(blayer.item["level"]) - gs._zfGameData._level);
        var totalFunds = Number(gs._zfGameData._resources[GameData.gameResources.kGameResourceBrains]);
        var name = blayer.item["name"];
        var title = NSLocalizedString("Unlock Item", null);
        var msg = null;
        
        var aw = new ZFAlertWindow(); 
        aw.initWithWindow(CGRectMake(w._width * 1.5/3, w._height*4/5, w._width*1.5/2, 5 + w._height*3.5/5));        
        if ( unlockCost > totalFunds )
        {
            var stuff = unlockCost - totalFunds;
            msg = sprintf(NSLocalizedString("You are short %1$d brains to unlock %2$@. Would you like to get more?"), stuff, NSLocalizedString(name));
            
        }
        else 
        {
    		msg = sprintf(NSLocalizedString("Are you sure you want to unlock %@\nearly?\n\nCost: %d"), NSLocalizedString(name), unlockCost);
            var resourceIcon = CCSprite.spriteWithFile("brain.png");
            resourceIcon.setPosition(ccp(
                    aw._windowNode.getContentSize()._width/2 + 37,
                    aw._windowNode.getContentSize()._height/2 - 30));
            resourceIcon.setScale(0.5);
            resourceIcon.setAnchorPoint(ccp(1.0, 0.0));
            aw._windowNode.addChild(resourceIcon, 4);
        }

        aw.removeChild(aw._body1, true);
        aw.removeChild(aw._dismiss, true);
                        
        var banner = CCSprite.spriteWithFile(ZFGameDefines.HUDELEMENTS1_FILE, CGRectMake(144,376,200,47));
        banner.setAnchorPoint(0.5, 0.5);
        
        
        var heightOffset = (CCDirector.winSize()._height - 5 + w._height*3.5/5) / 2;
        
        var winSize = CCDirector.winSize();
        banner.setPosition(ccp(winSize._width/2, heightOffset));
        aw._windowNode.addChild(banner, 3);
        
        aw._title1.setString(title);
        banner.addChild(aw._title1);
        
        aw._body1 = CCLabel.labelWithString(msg, CGSizeMake(200, 180), GL2.Text.HorizontalAlign.Center, "AmericanTypewriter", 14);
        aw._body1.setAnchorPoint(ccp(0.5, 0.5));
        aw._body1.setPosition(aw._windowNode.getContentSize()._width/2, aw._windowNode.getContentSize()._height/2);
        aw._body1.setColor(ccc3(0,0,0));
        aw._body1.setString(msg);
        aw._windowNode.addChild(aw._body1, 1);
        aw._delegate = this;
        
        if ( unlockCost > totalFunds )
        {
            aw._idTag = this.kMarketAlert.kMarketAlertBuyBrains;
        }
        else
        {
            aw._idTag = this.kMarketAlert.kMarketAlertUnlockItemEarly;
            aw._userData = sender;
        }
        
        gui._alertWindows.unshift(aw);
        this._blockOtherUnlockingOperations = true;
    },
    
    chargeUnlock: function(sender)
    {       
        var gs = GameState;
        var blayer = sender;
        
        if (!blayer)
        {
            return;
        }
        
        var unlockCost = Math.abs(Number(blayer.item["level"]) - GameState._zfGameData._level);
        
        gs.subResource(GameData.gameResources.kGameResourceBrains, unlockCost);
        
        var name = blayer.item["name"];
        NSAssert(name, "name missing");
        
        if (!gs._zfGameData._unlockedItems.indexOf(name) != -1)
        {
            gs._zfGameData._unlockedItems.push(name);
        }
            
        this.displayPage(this._currentPage);
        this._blockOtherUnlockingOperations = false;
    },
    
    checkBoughtItem : function(sender)
    {
//        console.log(sender.item.name);
//        console.log(sender.item);
        
        //				if(this._blockOtherUnlockingOperations)
        //					return false;
        //
        //				var w = CGSizeMake(480, 320);
        //				var gui = ZFGuiLayer.gui();
        //				var blayer = sender.getParent().getParent();
        //				var itemCategory = blayer.item["category"];
        //
        //				if (itemCategory == "upgrade")
        //				{
        //					//are you sure
        //					var name = blayer.item["name"];
        //					var title = Core.Localization.getString("Confirm");
        //					var message = Core.Localization.getString("Are you sure you want to buy\n%@?") + Core.Localization.getString("name");
        //
        //					// This is a terrible hack to check if sender has unlockedGround
        //					if ( blayer.userData )
        //						return this.boughtItemFromMarketMenu(sender);
        
        // ZFAlertWindow *aw = [[ZFAlertWindow alloc]
        // initWithWindow:CGRectMake(w.width/4, w.height*3/4, w.width/2,
        // w.height/2)];
        // [aw autorelease];
        // [aw removeChild:aw.body1 cleanup:YES];
        // [aw removeChild:aw.dismiss cleanup:YES];
        //			
        // CCSprite *banner = [CCSprite spriteWithFile:HUDELEMENTS1_FILE
        // rect:CGRectMake(144,376,200,47)];
        // [aw addChild:banner z:0];
        // banner.position = ccp(w.width*55/100 - 24+widthOffset,
        // w.height - 74-12+heightOffset);
        //			
        // [aw.title1 setString:title];
        // aw.title1.position = ccpAdd(ccp(0,-48+15),
        // aw.title1.position);
        // aw.body1 = [CCLabel labelWithString:message
        // dimensions:CGSizeMake(200, 180)
        // alignment:UITextAlignmentCenter
        // fontName:@"AmericanTypewriter" fontSize:14];
        // aw.body1.anchorPoint = ccp(0,1);
        // aw.body1.position = ccp(115+25+widthOffset, w.height -
        // 115+heightOffset);
        // aw.body1.color = ccc3(0,0,0);
        // [aw.body1 setString:message];
        // [aw addChild:aw.body1 z:1];
        // aw.ok.position = ccpAdd(aw.ok.position, ccp(40, 75));
        // aw.cancel.position = ccpAdd(aw.cancel.position, ccp(-40,
        // 75));
        // aw.delegate = self;
        //			
        // aw.idTag = kMarketAlertConfirmPurchase;
        // aw.userData = sender;
        // [gui.alertWindows insertObject:aw atIndex:0];
        //
        // return NO;
        //				}
        
        return this.boughtItemFromMarketMenu(sender);
    },
    
    boughtItemFromMarketMenu : function(sender)
    {
        var blayer = sender;
        if (!blayer)
            return false;
        return this.boughtItemWithItem(blayer.item, blayer);
    },
    
    boughtItemWithItem : function(item, blayer)
    {
        // FBMan *fb = [FBMan fbman];
        var tom = ZFToolManager.toolManager();
        var tim = ZFTileManager;
        var gs = GameState;
        var gui = ZFGuiLayer.gui();
        
        var resourceType = (item["brainsNeeded"]) ? GameData.gameResources.kGameResourceBrains : GameData.gameResources.kGameResourceGold;
        var itemCategory = item["category"];
        var itemSubCategory = item["subCategory"];
        var cost = item["cost"];
        
        var variableCost = item["variableCost"];
        var dismiss = true;
        var appStoreItem = item["InAppPurchase"];
        
        var name = item["name"];
        // NSAssert(name, @"name missing in this item");		
        if (appStoreItem && name == "Blue Grave")
        {
            if (gs._zfGameData._gflags & ZFGameFlags.GFLAG_SOMETHING_BOUGHT) //if already bought remove the dictionary keys below
            {
                appStoreItem = false;
            }
        }
        
        if (appStoreItem)
        {
            //this is an app store purchase
            //brain purchase
            var appStoreID = item["AppStoreID"];
            var amount = item["amount"];
            var amountVal = 1;
            if (amount)
            {
                amountVal = amount;
            }
            this.buyAppStoreItem(appStoreID, amountVal);
            return false;
        }
        
        if (variableCost)
            cost = this.costFromName(name);
        
        NSAssert(cost!=null, "cost missing in this item");
        //		
        if (typeof item["flagNeeded"] != "undefined")
        {
            var flag = item["flagNeeded"];
            var flagVal = -1;
            flagVal = flag;
            
            if (!gs._zfGameData._purchaseFlags.hasFlag(flagVal))
            {
                var message = null;
                var sprite = null;
                
                if (flagVal == ZFGameFlags.PFLAG_FARM40)
                {
                    message = NSLocalizedString("You need to buy a Big 'ol Farm first.");
//                    console.log("Requirements = " + message);
                }
                if (flagVal == ZFGameFlags.PFLAG_FARM50)
                {
                    message = NSLocalizedString("You need to buy a Huge 'ol Farm first.");
                }
                else if (flagVal == ZFGameFlags.PFLAG_UNLOCK_BLUE)
                {
                    message = sprintf(NSLocalizedString("You need to buy a Blue Gravestone first before you can buy this %@."), name);
                    sprite = CCSprite.spriteWithFile("graveStoneBlue128.png");
                }
                else if (flagVal == ZFGameFlags.PFLAG_UNLOCK_RED)
                {
                    message = sprintf(NSLocalizedString("You need to buy a Red Gravestone first before you can buy this %@."), name);
                    sprite = CCSprite.spriteWithFile("graveStoneRed128.png");
                }
                
                gui.displayAlertSimple(NSLocalizedString("Requirement Needed"), message, sprite);
                
                return false;
            }
        }
        
        // check resources
        var totalFunds = gs._zfGameData._resources[resourceType];
        var skipResourceCheck = false;
        
        // checks for flag for ground
        if (itemCategory == "upgrade" && itemSubCategory == "climate")
        {
            var pflag = item["pflag"];
            
            if (gs._zfGameData._purchaseFlags.hasFlag(pflag) || name == "Grassy Ground")
            {
                skipResourceCheck = true;
            }
            
        }
        
        // checks money or brains
        if (totalFunds < cost && !skipResourceCheck)
        {
            if (resourceType == GameData.gameResources.kGameResourceBrains)
            {
                var aw = gui.displayAlertSimpleChoice(Core.Localization.getString("Not enough Brains!"), Core.Localization.getString("Would you like to buy some brains?"), CCSprite.spriteWithFile("brainLarge.png"));
                
                aw._delegate = this;
                aw._idTag = this.kMarketAlert.kMarketAlertBuyBrains;
            }
            else
            {
                var aw = gui
                        .displayAlertSimpleChoice(Core.Localization.getString("Not enough Gold!"), Core.Localization.getString("Earn more gold by harvesting crops or by invasion.\n\nYou can also convert brains into gold. Would you like to do this?"), CCSprite.spriteWithFile("goldLarge.png"));
                
                aw._delegate = this;
                aw._idTag = this.kMarketAlert.kMarketAlertConvertBrains;
            }
            
            return false;
        }
        
        // if buying a crop
        if (itemCategory == "crop")
        {
            var tool = tom._tools[ZFToolManager.kGameTool.kGameToolPlant];
            tool._dictionary = item;
            var filename = item["spriteSheet"];
            
            var spriteRect = new Core.Rect(0, 0, 32, 32);
            var mgr = CCSpriteSheet.spriteSheetWithFile(filename, 29);
            var image = CCSprite.spriteWithSpriteSheet(mgr, spriteRect);
            mgr.addChild(image);
            gui.addChild(mgr, 3);
            image.setScale(new Core.Vector(1.25, 1.25));
            destroy(tool._sprite);
            tool._sprite = image;
            tool._sprite._tag = ZFSelectorLayer.kTag.kTagSelectedSprite;
            tom.toolSelected(ZFToolManager.kGameTool.kGameToolPlant);
        }
        
        // // if buying an item
        else if (itemCategory == "item")
        {
            var sm = ZFStorageMenu.storageMenu();
            
            if (item["zombiePatch"])//@"zombiePatch" is a flag
            {
                if (sm.doesOwnItem(ZFGameDefines.kZombiePatchKey))
                {
                    gui.displayAlertSimple(name, sprintf(NSLocalizedString("You can only have one %@ at a time."), name), CCSprite.spriteWithFile("SoilZombiePatch.png"));
                    return false;
                }
                else
                {
                    gui.displayAlertSimple(NSLocalizedString(name), NSLocalizedString("A Zombie Patch is great for keeping zombies from wandering around your farm!\nTo gather the zombies, tap on the patch.\nYou can wake them up too by tapping again."), CCSprite.spriteWithFile("SoilZombiePatch.png"));
                    
                }
            }
         
            // else if ([item objectForKey:@"screenshotCamera"])
            // {//
	
            // ZFStorageMenu *sm = [ZFStorageMenu storageMenu];
            //				
            // if ([sm doesOwnItem:kCameraKey])
            // {
            // [gui displayAlertSimple:NSLocalizedString(@"Zombie
            // Camera", nil)
            // withMessage:NSLocalizedString(@"You already have a Zombie
            // Camera", nil)
            // withSprite:[CCSprite spriteWithFile:@"camera.png"]];
            // return NO;
            // }
            // else
            // {
            // [gui displayAlertSimple:NSLocalizedString(@"Zombie
            // Camera", nil)
            // withMessage:NSLocalizedString(@"Show off your farm to
            // friends! Earn gold by taking a daily photo.\nTo take a
            // photo, tap on the camera.\n\nGo nuts! Take as many photos
            // as you want!", nil)
            // withSprite:[CCSprite spriteWithFile:@"camera.png"]];
            // }
            // }
            var color = ccc3(0x00, 0x00, 0x00);
            
            if (blayer)
            {
                if ((blayer.mgr && blayer.mgr._children.length > 0) || blayer.spriteNode)
                {
                    if (blayer.spriteNode)
                    {
                        var sprite = blayer.spriteNode._children[0];
                        color = sprite.getColor();
                    }
                    else
                    {
                        var sprite = blayer.mgr._children[0];
                        color = sprite.getColor();
                    }
                }
            }
            
            // the replacing algorigth,

            if (item["modular"] && 
    			(item["flagNeeded"] || item["mausoleumFlagNeeded"]))
    		{
    			var flagKey;
    			var flagNeeded = 0;
    			
    			if(item["flagNeeded"])
    			{
    				flagKey = "pflag";
    				flagNeeded = item["flagNeeded"];
    			}
    			else if(item["mausoleumFlagNeeded"])
    			{
    				flagKey = "mausoleumFlag";
    				flagNeeded = item["mausoleumFlagNeeded"];
    			}
    			
    			
    			var sm = ZFStorageMenu.storageMenu();
    			var itemIsPlacedInStorage = false;
    			var modularItemDict = this.marketItemFromFlag(flagNeeded, flagKey);
    			var tileKey = item["tile"];
    			var modularItemTileKey = modularItemDict["tile"];
    			var tSprite = sm.tSpriteForItemOnFarm(modularItemTileKey);
    			var index = sm.indexForItemInStorage(modularItemTileKey);
    			
    			if (tSprite)
    			{
    				//this item is on the farm
    				var rootPt = tSprite._tile._rootTile;
    				var tileSize = tim.tileDimensionsFromKey(tileKey);
    				
    				//delete the old item
    				tim._tileCoordinateToDelete = rootPt;
    				tim._selectedSprite = tSprite;
    				tim.deleteConfirmedDisplaySale(false, false);
    				
    				if (tim.canPlaceTileOfSize(tileSize, rootPt))
    				{
    					//auto replace item
    					tim.replaceTile_withGIDkey_considerNeighbouringTiles(rootPt, tileKey, false);
    					tSprite = tim.tSpriteFromTile(rootPt);
    					
    					var colorArray = item["color"];
    					var colorConv = ccc3(0xFF, 0xFF, 0xFF);
    					if (colorArray)
    					{
    						colorConv = ccc3(colorArray[0], colorArray[1], colorArray[2]);
    					}
    					
    					
    					tSprite._tile._color = colorConv;
    					tSprite._sprite.setColor(colorConv);
    					
    					//achievement: the flag for the highest storage building
    					if(ZFAchievementChecker.checkAllStorage())
    					{
    						/* Unlock Achievement through Facebook */
    						var gui = ZFGuiLayer.gui();
    						gui.publishAchievement("com.zombiefarm.farm.all_storage", "com.zombiefarm.farm.all_storage.description", "com.zombiefarm.farm.all_storage.image");
    						/////////////////////////////////////////
    					}
    					
    					
    				}
    				else
    				{
    					//if no space put it in storage and pop up a message
    					var itemDictionary = {	"name" : name,
				    							"tile" : tileKey,
				    							"color": item["color"]};
    					gs._zfGameData._inventory.push(itemDictionary);
    					itemIsPlacedInStorage = true;
    				}
    			}
    			else if (index >= 0)
    			{
    				//its in inventory
    				var itemDictionary = {	"name" : name,
				    						"tile" : tileKey,
				    						"color" : item["color"]};
    				
    				gs._zfGameData._inventory.splice(index, 1, itemDictionary);
    				itemIsPlacedInStorage = true;
    			}
    			else
    			{
    				//bad! item to be upgraded not found in farm or inventory
    				index = -1;
    			}
    			
    			if (itemIsPlacedInStorage)
    			{
    				gui.displayAlertSimple(	NSLocalizedString("Item is in Storage", null),
    										NSLocalizedString("There was trouble placing the item on yer farm.\nThe item ya just bought can be found in yer storage.", null),
    										null);
    			}
    			
    			if (gs.subResource(resourceType, cost))
    			{
    				// ONLY GETS CALLED WHEN UPGRADING
    				var flagVal = -1;
    				if(item["pflag"])
    				{
    					flagVal = item["pflag"];			
    					gs._zfGameData._purchaseFlags.setFlag(flagVal);
    				}
    				
    				// if mausoleum flag doesn't exist then this does nothing
    				if(item["mausoleumFlag"])
    				{
    					flagVal = item["mausoleumFlag"];
    					gs._zfGameData._mausoleumFlags |= flagVal;
    					gs._zfGameData._mausoleumSlots = gs._zfGameData.mausoleumSlotsAllowed();
    					gs.upgradeMausoleumSlots();
    				}
    				
    				var message = sprintf(NSLocalizedString("You upgraded to %@. Yee-haw!", null), NSLocalizedString(name, null));
    				var xp = this.xpFromName(item["name"]);
    				
    				if (xp)
    				{
    					gs.addResource(GameData.gameResources.kGameResourceXP, xp);
    					message = sprintf(NSLocalizedString("%@\n\n+%ixp", "xp stands for experience points"), message, xp);
    				}
    				
    				
    				gui.displayAlertSimple(NSLocalizedString("Purchase Made", null), 
    														message, CCSprite.spriteWithFile("boughtSprite.png"));
    				
    				
//    				if ( [fb connectedToInternet] && [fb isSessionValid])
//    				{
//    					NSString *imageUrl = @"http://www.theplayforge.com/home/zombie-farm/upgrade2_128.png";
//    					if (flagVal == PFLAG_STORAGE02)
//    					{
//    						imageUrl = @"http://www.theplayforge.com/home/zombie-farm/storage02_128.png";
//    					}
//    					else if (flagVal == PFLAG_STORAGE03)
//    					{
//    						imageUrl = @"http://www.theplayforge.com/home/zombie-farm/storage03_128.png";
//    					}
//    					else if (flagVal == PFLAG_STORAGE04)
//    					{
//    						imageUrl = @"http://www.theplayforge.com/home/zombie-farm/storage04_128.png";
//    					}
//    					else if (flagVal == PFLAG_STORAGE05)
//    					{
//    						imageUrl = @"http://www.theplayforge.com/home/zombie-farm/storage05_128.png";
//    					}
//    					else if (flagVal == PFLAG_STORAGE06)
//    					{
//    						imageUrl = @"http://www.theplayforge.com/home/zombie-farm/storage06_128.png";
//    					}
//    					
//    					NSString *pname = [NSString stringWithFormat:NSLocalizedString(@"%@ is upgrading in Zombie Farm!", nil), fb.playerName];
//    					NSString *caption = [NSString stringWithFormat:
//    										 NSLocalizedString(@"%@ just upgraded to %@ in Zombie Farm!", nil),
//    										 fb.playerName, 
//    										 [item objectForKey:@"name"]];
//    					
//    					[fb publishFeed:pname withCaption:caption withDescription:@"" withImageURl:imageUrl withDelegate:nil];
//    				}
    			}
    		}
            else
            {
                if (item["stageActor"])
                {
                    // if ([gs subResource:resourceType amount:[cost
                    // intValue]])
                    // {
                    // [sm addItemToStorage:item checkCapacity:NO];
                    // [[ZFStorageMenu storageMenu] openMenu];
                    // [gui displayToolTip:NSLocalizedString(@"Item
                    // Added to Storage", nil) duration:1.25f];
                    // int xp = [self xpFromName:(NSString*)[item
                    // objectForKey:@"name"]];
                    // if (xp)
                    // {
                    // [gs addResource:kGameResourceXP amount:xp];
                    // //message = [NSString
                    // stringWithFormat:NSLocalizedString(@"%@\n\n+%ixp",
                    // @"xp stands for experience points"),message, xp];
                    // }
                    // }
                }
                else if (blayer)
                {
                    this.placeItemAfterSelectingItFromMarket_color(blayer, color);
                }
            }
        }
        else if (itemCategory == "upgrade")
        {
            dismiss = false;
            var paid = false;
            var announce = true;
            var pflag = null;
            
            if (item["hasPflag"])
                pflag = item["pflag"];
            else
                pflag = -1;
            //pflag = blayer.item["pflag"];
            
            if (itemSubCategory == "climate" && gs._zfGameData._purchaseFlags.hasFlag(pflag))
            {
                paid = true;
            }
            else
            {
                if (gs.subResource(resourceType, cost))
                {
                    paid = true;
                }
            }
            
            if (paid)
            {
                if (!skipResourceCheck)
                {
                    var w = CCDirector.winSize();
                    var message = sprintf(Core.Localization.getString("You bought %@"), Core.Localization.getString(name));
                    gui.displayAlertSimple(Core.Localization.getString("Purchase Made"), message, CCSprite.spriteWithFile("boughtSprite.png"), CGRectMake((w._width - ZFGameDefines.ORIGINAL_WINDOW_WIDTH) / 2, w._height - (w._height - ZFGameDefines.ORIGINAL_WINDOW_HEIGHT) / 2 - 62,
                            ZFGameDefines.ORIGINAL_WINDOW_WIDTH, 200));
                }
                
                gs._zfGameData._purchaseFlags.setFlag(pflag);
                
                //for mapsizing
                if (item["mapSize"])
                {
                    gs._zfGameData._mapSize = blayer.item["mapSize"];
                    tim.updateMapSize();
                    dismiss = true;
                }
                else if (itemSubCategory == "climate" && blayer.item["climateGID"])
                {
                    gs._zfGameData._baseGID = blayer.item["climateGID"];
                    tim.changeClimate();
                    dismiss = true;
                    announce = false;
                }
                
                // remove the buy button
                blayer.removeChild(blayer.buyButton, true);
                blayer.buyButton = null;
                blayer.backgroundSprite.setColor(ccc3(0x80, 0x80, 0x80));

//				//FACEBOOK
//				
//				if (announce && [fb connectedToInternet] && [fb isSessionValid])
//				{
//					NSString *image = @"upgrade2_128.png";
//					switch (flag)
//					{
//						case PFLAG_TOMATOMUTATION		:	image = @"mutationTomato128.png";		break;
//						case PFLAG_ONIONMUTATION		:	image = @"mutationOnion128.png";		break;
//						case PFLAG_CARROTMUTATION		:	image = @"mutationCarrot128.png";		break;
//						case PFLAG_TURNIPMUTATION		:	image = @"mutationTurnip128.png";		break;
//						case PFLAG_POTATOMUTATION		:	image = @"mutationPotato128.png";		break;
//						case PFLAG_COFFEEMUTATION		:	image = @"mutationCoffee128.png";		break;
//						case PFLAG_CELERYMUTATION		:	image = @"mutationCelery128.png";		break;
//						case PFLAG_BROCCOLIMUTATION		:	image = @"mutationBroccoli128.png";		break;
//						case PFLAG_GARLICMUTATION		:	image = @"mutationGarlic128.png";		break;
//						case PFLAG_CAULIFLOWERMUTATION	:	image = @"mutationCauliflower128.png";	break;
//						case PFLAG_LIMABEANMUTATION		:	image = @"mutationLimabean128.png";		break;
//						case PFLAG_FLYTRAPMUTATION		:	image = @"mutationFlytrap128.png";		break;
//						case PFLAG_DRAGONMUTATION		:	image = @"mutationDragon128.png";		break;
//					}
//					
//					NSString *imageUrl = [NSString stringWithFormat:@"http://www.theplayforge.com/home/zombie-farm/%@", image ];
//					NSString *name = [NSString stringWithFormat:NSLocalizedString(@"%@ is upgrading in Zombie Farm!", nil), fb.playerName];
//					NSString *caption = [NSString stringWithFormat:
//										 NSLocalizedString(@"%@ just bought %@ in Zombie Farm!", nil),
//										 fb.playerName, 
//										 [blayer.item objectForKey:@"name"]];
//					
//					[fb publishFeed:name withCaption:caption withDescription:@"" withImageURl:imageUrl withDelegate:nil];
//				}
            }
        }
        else if (itemCategory == "brain")
        {
            dismiss = false;
            if (itemSubCategory == "gold")
            {
                if (gs.subResource(resourceType, cost)) //conversion
                {
                    var amount = blayer.item["amount"];
                    //							NSAssert(amount, @"amount missing in this item");
                    gs.addResource(GameData.gameResources.kGameResourceGold, amount);
                    SimpleAudioEngine.playEffect(kEarnSFX);
                }
            }
        }
        else if (itemCategory == "boost")
        {
            dismiss = false;
            sm = ZFStorageMenu.storageMenu();
            if (itemSubCategory == "boost")
            {
                dismiss = false;
                if (gs.subResource(resourceType, cost))
                {
                    var amount = item["amountGivenPerPurchase"];
                    var consumable = new ZFConsumable();
                    consumable.initWithName(name, amount);
                    sm.addItemToStorage(consumable, false);
                    
                    if (blayer) //means that this purchase is being called form the market
                    {
                        sm.openMenuWithBoostPageDisplayed(true);
                        gui.displayToolTip(NSLocalizedString("Item Added to Storage"), 1.25);
                        dismiss = true;
                    }
                }
            }
        }
        
//      TODO: FB
//		var preUnlockCheck = false;
//		var postUnlockCheck = false;
//		
//		preUnlockCheck = gs._zfGameData.achievementFlags.hasFlag(kAchievementAllMutations);
//		ZFAchievementChecker.checkAllMutations();
//		postUnlockCheck = gs._zfGameData.achievementFlags.hasFlag(kAchievementAllMutations);
		
		
//		if (preUnlockCheck != postUnlockCheck)
//		{
//			/* Unlock Achievement through Facebook */
//			ZFGuiLayer *gui = [ZFGuiLayer gui];
//			[gui publishAchievement:@"com.zombiefarm.farm.all_mutations" withDescription:@"com.zombiefarm.farm.all_mutations.description" withImageURl:@"com.zombiefarm.farm.all_mutations.image" ];
//			/////////////////////////////////////////
//		}
		
		
//		preUnlockCheck = gs_.zfGameData.achievementFlags.hasFlag(kAchievementAllGrounds);
//		ZFAchievementChecker.checkAllGrounds();
//		postUnlockCheck = gs._zfGameData.achievementFlags.hasFlag(kAchievementAllGrounds);
		
//		if (preUnlockCheck != postUnlockCheck)
//		{
//			/* Unlock Achievement through Facebook */
//			ZFGuiLayer *gui = [ZFGuiLayer gui];
//			[gui publishAchievement:@"com.zombiefarm.farm.all_grounds" withDescription:@"com.zombiefarm.farm.all_grounds.description" withImageURl:@"com.zombiefarm.farm.all_grounds.image" ];
//			/////////////////////////////////////////
//		}
//
//		//flurry
//		if (!skipResourceCheck)
//		{
//			NSDictionary *eventDictionary = [NSDictionary dictionaryWithObjectsAndKeys:
//											 name, @"SpentOn", 
//											 [NSNumber numberWithInt:gs.zfGameData.level], @"Level",
//											 nil];
//			[FlurryAPI logEvent:(resourceType == kGameResourceGold) ? kFlurryEvent_goldSpent : kFlurryEvent_brainSpent withParameters:eventDictionary];
//			
//		}
//	    
//	    //apsalar
//	    if (!skipResourceCheck && [subCategory isEqualToString:@"new"])
//	    {
//	        [Apsalar eventWithArgs:@"zf_mkt_items_new",
//	                                @"itemType", name,
//	                                @"userLevel", [NSNumber numberWithInt:gs.zfGameData.level],
//	                                nil];
//	    }
        
        if (dismiss)
        {
            this.dismissMenu(null);
        }
        
        return true;
    },
    
    payForItemFromTool : function(tool)
    {
        var tim = ZFTileManager;
        var gs = GameState;
        var gui = ZFGuiLayer.gui();
        // TODO ?
        // FBMan *fb = [FBMan fbman];
        
        // pay for it
        var paid = false;
        var cost = tool._dictionary["cost"];
        var resource = GameData.gameResources.kGameResourceGold;
        
        // var message = [NSString
        // stringWithFormat:NSLocalizedString(@"-%ig", @"g stands for
        // gold"),cost];
        //				console.log("message = " + sprintf("%i", cost));
        var message = sprintf(Core.Localization.getString("-%ig"), cost);
        
        if (tool._dictionary["name"] == "Blue Grave")
        {
            if ((gs._zfGameData._gflags & ZFGameFlags.GFLAG_SOMETHING_BOUGHT) &&
                 gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_UNLOCK_BLUE))
            {
                cost = 0;
            }
        }
        
        if (tool._dictionary["brainsNeeded"])
        {
            resource = GameData.gameResources.kGameResourceBrains;
            // message = [NSString stringWithFormat:NSLocalizedString(@"-%i brain(s)", nil),cost];
            message = sprintf(Core.Localization.getString("-%i brain(s)"), cost);
        }
        
        if (GameState.subResource(resource, cost))
        {
            gui.displayMessage(message, tool._toolTile, ccc3(0xFF, 0x40, 0x40), 0);
            paid = true;
        }
        else
        {
            gui.displayMessage(Core.Localization.getString("Not enough resources!"), tool._toolTile, ccc3(0xFF, 0x40, 0x40), 0);
        }
        
        // untrack/free the old touchsprite
        var tSprite = tim.tSpriteFromTile(tool._originalTile);
        if (tSprite)
            TSprite.untrack(tSprite);
        
        if (paid)
        {
            tim.replaceTile_withGIDkey_considerNeighbouringTiles(tool._toolTile, tool._key, true);
            tSprite = tim.tSpriteFromTile(tool._toolTile);
            
            var color;
            if (tool._spriteNode)
                color = tool._spriteNode._children[0].getColor();
            else
                color = tool._sprite.getColor();
            
            tSprite._tile._color = color;
            tSprite._sprite.setColor(color);
            tim.setTileToOccupied(tool._toolTile);
            var marketItemDictionary = this.marketItemFromTileKey_withColor(tSprite._tile._key, color);
            // NSAssert(marketItemDictionary, @"marketItemDictionary missing");
            
            var xp = Math.floor(this.xpFromName(tool._dictionary["name"]));
            
            if (xp)
            {
                gs.addResource(GameData.gameResources.kGameResourceXP, xp);
//                gui.displayMessage(sprintf(Core.Localization.getString("+%i xp"), xp), tool._toolTile, ZFColorDefines.colorTextHighlight, 30);
    			gui.displayMessage(sprintf(NSLocalizedString("+%i xp", "xp stands for experience"), xp), tool._toolTile, ZFColorDefines.colorTextHighlight, 30);
            }
            
            // game objects
            if (tool._key == ZFGameDefines.kZombiePatchKey)
            {
                tim.createZombiePatchAtTile(tool._toolTile);
            }
            
            if (tim.isKeyZombieCombiner(tool._key))
            {
                tim.createZombieCombinerAtTile(tool._toolTile);
            }
            
            if (tool._dictionary["tile"] == "mausoleum1")
            {
                 gui.displayAlertSimple(
                		 NSLocalizedString("Mausoleum",null),
                		 NSLocalizedString("This darn thing is locked! The key ain't nowhere on the farm so I reckon it's time to round up the zombies and start lookin elsewhere... ", null),
                		 CCSprite.spriteWithFile("mausoleumIcon.png"));
            }
            
            if (tool._dictionary["tile"] == "storage01")
            {
                gui.displayAlertSimple(ZFGameDefines.kStorage01ItemName, NSLocalizedString("You can now store yer items!\n\nSheds are upgradable. Buying a better shed will replace yer old one. Better sheds store more stuff!"), CCSprite.spriteWithFile("storageIcon.png"));
            }
            
            var pflag = tool._dictionary["pflag"];
            var mausoleumFlag = tool._dictionary["mausoleumFlag"];
            
            if (pflag || mausoleumFlag) // for EVERYTHING with a flag
            // ... pflag or otherwise
            {
                
                var flagVal = -1;
                if (pflag)
                    flagVal = pflag;
                var mausoleumFlagVal = mausoleumFlag;
                
                gs._zfGameData._purchaseFlags.setFlag(flagVal);
                gs._zfGameData._mausoleumFlags |= mausoleumFlagVal;
                
                if (mausoleumFlagVal)
                {
                    gs._zfGameData._mausoleumSlots = gs.mausoleumSlotsAllowed();
                    gs.upgradeMausoleumSlots();
                }
                
                // FACEBOOK
                // TODO ?
                //				
                // if ([fb connectedToInternet] && [fb isSessionValid])
                // {
                // NSString *imageUrl =
                // @"http://www.theplayforge.com/home/zombie-farm/monolith128.png";
                // if (flagVal == PFLAG_UNLOCK_BLUE)
                // {
                // imageUrl =
                // @"http://www.theplayforge.com/home/zombie-farm/graveStoneBlue128.png";
                // }
                // else if (flagVal == PFLAG_UNLOCK_RED)
                // {
                // imageUrl =
                // @"http://www.theplayforge.com/home/zombie-farm/graveStoneRed128.png";
                // }
                // else if (flagVal == PFLAG_STORAGE01)
                // {
                // imageUrl =
                // @"http://www.theplayforge.com/home/zombie-farm/storage01_128.png";
                // }
                // else if (mausoleumFlag)
                // {
                // imageUrl =
                // @"http://www.theplayforge.com/home/zombie-farm/mausoleumIcon.png";
                // }
                //					
                // NSString *name = [NSString
                // stringWithFormat:NSLocalizedString(@"%@ obtained a
                // crucial item in Zombie Farm!", nil), fb.playerName];
                // NSString *caption = [NSString stringWithFormat:
                // NSLocalizedString(@"%@ just obtained a %@! (%@)",
                // nil),
                // fb.playerName,
                // [tool.dictionary objectForKey:@"name"],
                // [tool.dictionary objectForKey:@"info2"]];
                //					
                // [fb publishFeed:name withCaption:caption
                // withDescription:@"" withImageURl:imageUrl
                // withDelegate:nil];
                // }
            }
            
            var name = tool._dictionary["name"];
            
            NSNotificationCenter.defaultCenter().postNotificationName_object_userInfo(ZFGameDefines.kItemBoughtNotification, null, name);
            
            var preUnlockCheck = false;
            var postUnlockCheck = false;
            
            preUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievementAllMonoliths);
            
            // TODO achievement
            // if(!preUnlockCheck)
            // [[ZFAchievementChecker achievementChecker]
            // checkAllMonoliths];
            
            postUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievementAllMonoliths);
            
            if (preUnlockCheck != postUnlockCheck)
            {
                /* Unlock Achievement through Facebook */
                // TODO achievement
                // ZFGuiLayer *gui = [ZFGuiLayer gui];
                // [gui
                // publishAchievement:@"com.zombiefarm.farm.all_monoliths"
                // withDescription:@"com.zombiefarm.farm.all_monoliths.description"
                // withImageURl:@"com.zombiefarm.farm.all_monoliths.image"
                // ];
                // ///////////////////////////////////////
            }
            
            preUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievementAllGraves);
            
            // TODO achievement
            // if(!preUnlockCheck)
            // [[ZFAchievementChecker achievementChecker]
            // checkAllGraves];
            
            postUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievementAllGraves);
            
            if (preUnlockCheck != postUnlockCheck)
            {
                /* Unlock Achievement through Facebook */
                // TODO achievement
                // ZFGuiLayer *gui = [ZFGuiLayer gui];
                // [gui
                // publishAchievement:@"com.zombiefarm.farm.all_graves"
                // withDescription:@"com.zombiefarm.farm.all_graves.description"
                // withImageURl:@"com.zombiefarm.farm.all_graves.image"
                // ];
                // ///////////////////////////////////////
            }
            
            // apsalar
            // TODO ?
            // if ([subCategory isEqualToString:@"new"])
            // {
            // [Apsalar eventWithArgs:@"zf_mkt_items_new",
            // @"itemType", [tool.dictionary objectForKey:@"name"],
            // @"userLevel", [NSNumber
            // numberWithInt:gs.zfGameData.level],
            // nil];
            // }
        }
        
        this._paymentPending = false;
        GameState.saveGameReal();
    },
    
    placeItemAfterSelectingItFromMarket_color : function(blayer, color)
    {
        var tom = ZFToolManager.toolManager();
        var tim = ZFTileManager;
        this._paymentPending = true;
        var dictWithSpriteInfo = blayer.item;
        
        var useTileSheet = blayer.item["spriteInfoInTileProperties"];
        if (useTileSheet)
        {
            dictWithSpriteInfo = tim._tilePropertiesDictionary[blayer.key];
            // NSAssert(dictWithSpriteInfo, @"missing dictionary in
            // placeItemAfterSelectingItFromMarket");
        }
        
        var filename = dictWithSpriteInfo["spriteSheet"];
        // NSAssert(filename, @"spriteSheet missing");
        
        var tool = tom._tools[ZFToolManager.kGameTool.kGameToolPlace];
        tool._dictionary = blayer.item;
        tim.placeNewObjectTileWithKey(blayer.key, filename, color);
    },
    
    placeItemAfterSelectingItFromMarket : function(itemDict, key, color)
    {
        var tom = ZFToolManager.toolManager();
        var tim = ZFTileManager.tileManager();
        this._paymentPending = true;
        var dictWithSpriteInfo = itemDict;
        
        var useTileSheet = itemDict["spriteInfoInTileProperties"];
        if (useTileSheet)
        {
            dictWithSpriteInfo = tim._tilePropertiesDictionary[key];
            //NSAssert(dictWithSpriteInfo, "missing dictionary in placeItemAfterSelectingItFromMarket");
        }
        		
        var filename = dictWithSpriteInfo["spriteSheet"];
        //NSAssert(filename, "spriteSheet missing");
        	
        var tool = tom._tools[ZFToolManager.kGameTool.kGameToolPlace];
        tool._dictionary = itemDict;
        tim.placeNewObjectTileWithKey(key, filename, color);
    },
    
    updateGold : function()
    {
        if (this._playersGold)
        {
            var value = GameState._zfGameData._resources[GameData.gameResources.kGameResourceGold];
            var goldString = sprintf("%i", value);
            this._playersGold.setString(goldString);
        }
        else
        {
            console.log("ZFMarketMenu.updateGold: Could not update gold (widget missing)");
        }
    },
    
    updateBrains : function()
    {
        if (this._playersBrains)
        {
            var value = GameState._zfGameData._resources[GameData.gameResources.kGameResourceBrains];
            var brainString = sprintf("%i", value);
            this._playersBrains.setString(brainString);
        }
        else
        {
            console.log("ZFMarketMenu.updateBrains: Could not update brains (widget missing)");
        }
    },
    
    xpFromItem : function(item)
    {
        var xp = 0;
        
        if (item)
        {
            var subcategory = item.subCategory;
            var costBrains = item.brainsNeeded;
            var seasonal = item.limited;
            // var new_ = item.new_; //TODO update that in plist
            var cost = item.cost;
            
            if (subcategory == "decor" || subcategory == "tree")
            {
                // base xp
                xp = (costBrains) ? cost * 100 : cost / 100;
                
                // bonus xp for new or seasonal items
                if (/* new_ || */seasonal)
                {
                    if (costBrains)
                        xp = xp * 1.2;
                    else
                        xp = xp * 2;
                }
            }
            else if (subcategory == "special")
            {
                xp = (costBrains) ? cost * 80 : cost / 200;
                
                // there are no seasonal or new functional items at this
                // time
            }
            else if (subcategory == "plant" || subcategory == "zombie")
            {
                // plants give 1 xp when planted
                xp = 1;
            }
            
        }
        
        return xp;
    },
    
    addBuyableLayerWithItem : function(item, index)
    {
        // console.log(item);
        // dorzucic zeby sie wyrysowalo
        
        var categoryName = item.category;
        var subCategoryName = item.subCategory;
        var name = item.name;
        
        var centerWidthOffset = 0; // for centering the items if they
        // are on only one row - ie brain
        // and convert pages
        
        // if (menuWidthOffset>0)
        // {
        // if ([subCategoryName isEqualToString:@"brain"])
        // {
        // centerWidthOffset = 75;
        // }
        // else if ([subCategoryName isEqualToString:@"gold"])
        // {
        // centerWidthOffset = 150;
        // }
        // }
        
        var gs = GameState;
        var blayer = new ZFBuyable(); // ZFBuyable *blayer =
        // [ZFBuyable node];
        
        this._buyableLayers.push(blayer);
        
        var y = 155;
        var idx = index;
        if (idx >= 3)
        {
            idx -= 3;
            y = 155 - 95;
        }
        var blayerPosition = ccp(idx * 150 + 90, y - this._heightOffset);
        blayer.setPosition(blayerPosition);
        
        blayer.item = item;
        
        var isActor = (item.actor) ? true : false;
        var ignoreInAppPurchase = (name == "Blue Grave" && gs._zfGameData._gflags & ZFGameFlags.GFLAG_SOMETHING_BOUGHT);
        var brainsNeeded = (item.brainsNeeded) ? true : false;
        var levelNeeded = item.level;
        var myLevel = gs._zfGameData._level;
        var myLevelExceedsLevelNeeded = (myLevel >= levelNeeded);
        var alreadyBought = false;
        var alreadyUnlocked = false;
        
        var pflag;
        if (item["hasPflag"])
            pflag = item["pflag"];
        else
            pflag = -1;
        
        var mausoleumFlag = item.mausoleumFlag;
        var customBackgroundSprite = item.backgroundSprite;
        
        if (customBackgroundSprite)
        {
            destroy(blayer.backgroundSprite);
            blayer.backgroundSprite = CCSprite.spriteWithFile(customBackgroundSprite, ccp(0.5, 0.5));
            // [backgroundSpriteSheet.parent addChild:blayer.backgroundSprite z:backgroundSpriteSheet.zOrder tag:kMarketTagBuyablesFrame];
            this._backgroundSpriteSheet._parent.addChild(blayer.backgroundSprite, backgroundSpriteSheet.getDepth(), this.kMarketTag.kMarketTagBuyablesFrame);
        }
        else
        {
            destroy(blayer.backgroundSprite);
            blayer.backgroundSprite = CCSprite.spriteWithSpriteSheet(this._backgroundSpriteSheet, new Core.Rect(0, 377, 142, 92));
            this._backgroundSpriteSheet.addChild(blayer.backgroundSprite, 2, this.kMarketTag.kMarketTagBuyablesFrame);
        }
        
        blayer.backgroundSprite.setPosition(ccpSub(blayer.getPosition(), ccp(0, this._heightOffset)));
        
        // key
        blayer.key = (isActor) ? null : item.tile;
        
        // name
        blayer.nameLabel = CCLabel.labelWithString(Core.Localization.getString(name), "AmericanTypewriter-Bold", 14);
        blayer.nameLabel.setColor(ccc3(0, 0, 0));
        blayer.nameLabel.setSize(new Core.Size(150, 30));
        blayer.nameLabel.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
        blayer.nameLabel.setPosition(ccp(this._widthOffset, 32));
        
        for (var key in gs._zfGameData._unlockedItems)
        {
            if (gs._zfGameData._unlockedItems[key] == name)
            {
                alreadyUnlocked = true;
                break;
            }
        }
        		
        // Determine what items (if any) have already been purchased.
        var unlockedGround = false;
        
        if (categoryName == "upgrade")
        {
            // NSAssert(pflag,@"pflag missing in this upgrade");
            //			
            if (gs._zfGameData._purchaseFlags.hasFlag(pflag) || name == "Grassy Ground")
            {
                alreadyBought = true;
            }
        }
        
        // if this is an item
        if (item.category == "item" || item.category == "plant")
        {
            // check if you already bought it (by checking flags)
            if (pflag && gs._zfGameData._purchaseFlags.hasFlag(pflag))
            {
                alreadyBought = true;
            }
            
            if (mausoleumFlag && (gs._zfGameData._mausoleumFlags & mausoleumFlag))
            {
                 alreadyBought = true;
            }
        }
        
        var hasUnlockCost = false;
        // //info
        if ((myLevelExceedsLevelNeeded || alreadyBought || alreadyUnlocked))
        {
            var info = Core.Localization.getString(item.info);
            
            if (item.category == "item")
            {
                var xp = this.xpFromItem(blayer.item); // originally
                // xpFromName
                info = sprintf(NSLocalizedString("+%dxp", "xp stand for experience points") , xp);
                
                var tileKey = blayer.item.tile;
                var luck = ZFTileManager.luckFromKey(tileKey);
                info += sprintf("   +%d   ", luck);
                
                // life force icon
                var resourceIcon = CCSprite.spriteWithFile("lifeForce.png");
                resourceIcon.setPosition(ccp(this._widthOffset + 61, 8));
                resourceIcon.setScale(ccp(0.5, 0.5));
                resourceIcon.setAnchorPoint(ccp(1, 0));
                if (blayer.lifeforceIcon)
                {
                    blayer.removeChild(blayer.lifeforceIcon);
                    blayer.lifeforceIcon.destroy();
                }
                blayer.lifeforceIcon = resourceIcon;
                blayer.addChild(resourceIcon, 4);
            }
            
            if (name == "Blue Grave" && !gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_UNLOCK_BLUE) &&
                !(gs._zfGameData._gflags & ZFGameFlags.GFLAG_SOMETHING_BOUGHT))
            {
                info = NSLocalizedString("Free brain w/ purchase!");
            }
            			
            destroy(blayer.infoLabel);
            
            var fontSize = 12;
            if ( name == "Insta-Grow" )
        	{
            	info = info.replace("一", "\n一");
            	fontSize = 10;
        	}
            
            blayer.infoLabel = CCLabel.labelWithString(info, "Arial", fontSize);
            blayer.infoLabel.setColor(ccc3(0, 0, 0));
            blayer.infoLabel.setAnchorPoint(ccp(1, 0.5));
            blayer.infoLabel.setPosition(ccp(60 + this._widthOffset, 11));
            blayer.infoLabel.setHorizontalAlign(GL2.Text.HorizontalAlign.Right);
            blayer.infoLabel.setSize(new Core.Size(142, 20));
        }
        else
        {
            hasUnlockCost = true;
            var levelReq = blayer.item.level;
            var unlockCost = Math.abs(blayer.item.level - gs._zfGameData._level);
            var nameLabel = sprintf(NSLocalizedString("Level %d"), levelReq);
            
            destroy(blayer.nameLabel);
            blayer.nameLabel = CCLabel.labelWithString(nameLabel, "AmericanTypewriter-Bold", 10);
            blayer.nameLabel.setColor(ccc3(0xDE, 0xA2, 0x00));
            blayer.nameLabel.setPosition(ccp(this._widthOffset, 32));
            blayer.nameLabel.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
            var costMessage = sprintf(NSLocalizedString("Unlock cost:\n%d"), unlockCost);
            
            if (blayer.item.flagNeeded)
            {
                var flag = blayer.item.flagNeeded;
                var flagVal = -1;
                if (flag)
                    flagVal = flag;
                
                if (!gs._zfGameData._purchaseFlags.hasFlag(flagVal))
                {
                    hasUnlockCost = false;
                    costMessage = null;
                }
            }
            
            if (subCategoryName == "zombie" || name == "Blue Grave" || name == "Red Grave")
            {
                // zombies cannot be unlocked prematurely
                hasUnlockCost = false;
                costMessage = NSLocalizedString("Unlocks at\nlevel ") + levelReq;
            }
            
            if (costMessage)
            {
                blayer.infoLabel = CCLabel.labelWithString(costMessage, new Core.Size(80, 40), GL2.Text.HorizontalAlign.Center, "Arial", 10);
                blayer.infoLabel.setColor(ccc3(0, 0, 0));
                blayer.infoLabel.setAnchorPoint(ccp(1, 0));
                blayer.infoLabel.setPosition(ccp(60 + this._widthOffset, 19));
            }
            
            if (hasUnlockCost)
            {
                whiteLayer = CCColorLayer.layerWithColor(ccc3(0xFF, 0xFF, 0xFF), 130, 31);
                whiteLayer.setOpacity(128);
                whiteLayer.setPosition(ccp(this._widthOffset - 65, -3.5));
                blayer.addChild(whiteLayer, 1);
                
                
                if (blayer.unlockResourceIcon)
                {
                    blayer.removeChild(blayer.unlockResourceIcon);
                    blayer.unlockResourceIcon.destroy();
                }
                
                var unlockResourceIcon = CCSprite.spriteWithFile("brain.png");
                unlockResourceIcon.setPosition(ccp(this._widthOffset + 36, -14));
                unlockResourceIcon.setAnchorPoint(ccp(1, 0));
                unlockResourceIcon.setScale(ccp(0.5, 0.5));
                blayer.unlockResourceIcon = unlockResourceIcon;
                blayer.addChild(unlockResourceIcon, 4);
                
                if (blayer.lockIcon)
                {
                    blayer.removeChild(blayer.lockIcon);
                    blayer.lockIcon.destroy();
                }
                var lockIcon = CCSprite.spriteWithFile("lockIcon.png");
                lockIcon.setPosition(ccp(this._widthOffset + 65, -30));
                lockIcon.setAnchorPoint(ccp(1, 0));
                blayer.lockIcon = lockIcon;
                blayer.addChild(lockIcon, 4);
            }
        }
        
        // info2
        if (myLevelExceedsLevelNeeded || alreadyBought || alreadyUnlocked)
        {
            var info2 = item.info2;
            

    		if (name == "Mausoleum" || name == "Mausoleum 2")
    		{ 
    			if (gs._zfGameData._mausoleumFlags & ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM_UNLOCKED)
    			{
    				info2 = NSLocalizedString(item["info2Alt"], item["info2Alt"]);
    			}
    		}
            
            if (!info2 && item.category == "crop")
            {
                info2 = "";
                
                var growTime = item.growTime;
                var days = growTime / 60 / 60 / 24;
                days = Math.round(days);
                growTime -= days * 60 * 60 * 24;
                var hours = growTime / 60 / 60;
                hours = Math.round(hours);
                growTime -= hours * 60 * 60;
                var minutes = growTime / 60;
                minutes = Math.round(minutes);
                var harvestTime = "";
    			if (days > 0)
    			{
    				harvestTime = sprintf(NSLocalizedString("%d day%@", "amount of days for crop"), days, days==1 ? "" : "s");
    			}
    			else if (hours > 0)
    			{
    				harvestTime = sprintf(NSLocalizedString("%d hr%@", "amount of hours for crop"), hours, hours==1 ? "" : "s");
    				
    			}
    			else if (minutes > 0)
    			{
    				harvestTime = sprintf(NSLocalizedString("%d min%@", "amount of minutes for crop"), minutes, minutes==1 ? "" : "s");
    			}
    			
    			info2 = sprintf(NSLocalizedString("Time: %@", "harvest time"), harvestTime);

                
                var price = item.price;
                if (price)
                {
                    info2 += sprintf(NSLocalizedString("\nSells for: %d .", "Sells for"), price);
                    var resourceIcon = CCSprite.spriteWithFile("gold.png");
                    resourceIcon.setPosition(ccp(60 + this._widthOffset, -17));
                    resourceIcon.setScale(ccp(0.33, 0.33));
                    resourceIcon.setAnchorPoint(ccp(1, 1));
                    if (blayer.resourceIcon)
                    {
                        blayer.removeChild(blayer.resourceIcon);
                        blayer.resourceIcon.destroy();
                    }
                    blayer.resourceIcon = resourceIcon;
                    blayer.addChild(resourceIcon, 4);
                }
            }
            var fontSize = 10;
            if(Core.Localization._lang == "ja"){
            	fontSize -=2;
            	if(name == "Blue Grave" || name == "Red Grave" ){
            		fontSize -=2;
            	}
            }
            blayer.infoLabel2 = CCLabel.labelWithString(NSLocalizedString(info2), new Core.Size(100, 60), GL2.Text.HorizontalAlign.Right, "Arial", fontSize);
            blayer.infoLabel2.setColor(ccc3(0, 0, 0));
        }
        else
        {
            blayer.infoLabel2 = CCLabel.labelWithString("", "Arial", 0);
        }
        
        blayer.infoLabel2.setAnchorPoint(ccp(1, 0));
        blayer.infoLabel2.setPosition(ccp(65 + this._widthOffset, 20));
        
        // "new" badge
        if (item.limited)
        {
            destroy(blayer.newBadge);
            blayer.newBadge = CCSprite.spriteWithSpriteSheet(this._backgroundSpriteSheet, new Core.Rect(380, 376, 52, 9));
            this._backgroundSpriteSheet.addChild(blayer.newBadge, 4, this.kMarketTag.kMarketTagBuyablesNewBadge);
            blayer.newBadge.setPosition(ccpAdd(blayer.getPosition(), ccp(-blayer.newBadge.getSize()._width / 2 - 10, -32 - this._heightOffset)));
        }
        else if (item["new"])
        {
            destroy(blayer.newBadge);
            blayer.newBadge = CCSprite.spriteWithSpriteSheet(this._backgroundSpriteSheet, new Core.Rect(345, 376, 34, 23));
            this._backgroundSpriteSheet.addChild(blayer.newBadge, 2, this.kMarketTag.kMarketTagBuyablesNewBadge);
            blayer.newBadge.setPosition(ccpAdd(blayer.getPosition(), ccp(blayer.newBadge.getSize()._width * 1.5 + 10, 39 - this._heightOffset)));
        }
        
        // "amountGivenPerPurchase" label
        // if ([item objectForKey:@"amountGivenPerPurchase"])
        // {
            // int amount = [[item objectForKey:@"amountGivenPerPurchase"] intValue];
            //			
            // CCLabel *amountGivenPerPurchase = [CCLabel
            // labelWithString:[NSString stringWithFormat:@"x%i", amount]
            // fontName:@"Arial-BoldMT" fontSize:16];
            // amountGivenPerPurchase.position = ccp(-20,-10);
            // amountGivenPerPurchase.color = colorTextAsh;
            // [blayer addChild:amountGivenPerPurchase z:4
            // tag:kMarketTagBuyablesamountGivenPerPurchase];
        // }
        
        // //price,cost
        if (item.cost || item.InAppPurchase)
        {            
            var freeMutation = item.pflag && (item.pflag == ZFGameFlags.PFLAG_ONIONMUTATION);
            if (categoryName == "upgrade" && gs._zfGameData._purchaseFlags.hasFlag(pflag) && !freeMutation)
            {
                // no need to show cost for upgrades that are bought
            }
            else if ((item.InAppPurchase || freeMutation) && !ignoreInAppPurchase)
            {           
                if (freeMutation) alreadyBought = true;
                var xAdjust = ((!freeMutation) ? 0: 25) + this._widthOffset;
                var yAdjust = -33;
                var fontSize = 10;
                
                blayer.costLabel = CCLabel.labelWithString("(" + NSLocalizedString("loading") + ")", "Arial-BoldMT", fontSize);
                blayer.costLabel.setHorizontalAlign(GL2.Text.HorizontalAlign.Center); 
                blayer.costLabel.setColor(ccc3(0,0,0));
                blayer.costLabel.setPosition(ccp(xAdjust, yAdjust));
                
                if (!freeMutation)
                {
                    Bank.Inventory.getItem(item["AppStoreID"], function(error, data)
                    {
                    	if (!blayer.costLabel._label) {
                    		return;
                    	}
                        if (error || !data)
                        {
                        	console.log('///ZFMarketMenu.addBuyableLayerWithItem error for Item with ID ' + item["AppStoreID"] +', ' + error.description);
                            blayer.costLabel.setString(NSLocalizedString("(In App Purchase)"));
                        }
                        else
                        {
                            blayer.costLabel.setString(NSLocalizedString(data.price));
                            blayer.costLabel.setHorizontalAlign(GL2.Text.HorizontalAlign.Right);
                            blayer.costLabel.setPosition(ccp(9 + this._widthOffset, -33));
                            blayer.costLabel.setAnchorPoint(ccp(1, 0.5));
                            blayer.costLabel.setColor(ccc3(255,255,255));
                            
                            var resourceIcon = CCSprite.spriteWithFile("gold_mobacoin.png");
                            resourceIcon.setPosition(ccp(10 + this._widthOffset, -33));
                            resourceIcon.setScale(ccp(0.5, 0.5));
                            resourceIcon.setAnchorPoint(ccp(0, 0.5));
                            if (blayer.resourceIcon)
                            {
                                blayer.removeChild(blayer.resourceIcon);
                                blayer.resourceIcon.destroy();
                            }
                            blayer.resourceIcon = resourceIcon;
                            blayer.addChild(resourceIcon, 4, this.kMarketTag.kMarketTagBuyablesResourceIcon);
                            
                            var resourceText = CCLabel.labelWithString("MC", "Arial", fontSize);
                            resourceText.setAnchorPoint(ccp(0, 0.5));
                            resourceText.setColor(ccc3(255,255,255));
                            resourceText.setPosition(ccpAdd(resourceIcon.getPosition(), ccp(20, 0)));
                            if (blayer.resourceText)
                            {
                            	resourceText.removeChild(blayer.resourceText);
                                blayer.resourceText.destroy();
                            }
                            blayer.resourceText = resourceText;
                            blayer.addChild(resourceText, 4, this.kMarketTag.kMarketTagBuyablesResourceIcon);
                        }
                    }.bind(this));
                }
                else
                {
                    blayer.costLabel.setString(NSLocalizedString("(It's Free!)"));
                }
            }
            else
            {                
                var cost = (name == "Invasion Voucher") ? this.costFromName("Invasion Voucher") : item.cost;
                
                blayer.costLabel = CCLabel.labelWithString(cost, "Arial-BoldMT", 12);
                blayer.costLabel.setHorizontalAlign(GL2.Text.HorizontalAlign.Right);
                blayer.costLabel.setPosition(ccp(9 + this._widthOffset, -33));
                blayer.costLabel.setAnchorPoint(ccp(1, 0.5));
                
                var resourceIcon = CCSprite.spriteWithFile((!brainsNeeded) ? "gold.png" : "brain.png");
                resourceIcon.setPosition(ccp(10 + this._widthOffset, -33));
                resourceIcon.setScale(ccp(0.5, 0.5));
                resourceIcon.setAnchorPoint(ccp(0, 0.5));
                if (blayer.resourceIcon)
                {
                    blayer.removeChild(blayer.resourceIcon);
                    blayer.resourceIcon.destroy();
                }
                blayer.resourceIcon = resourceIcon;
                blayer.addChild(resourceIcon, 4, this.kMarketTag.kMarketTagBuyablesResourceIcon);
                
                if (hasUnlockCost)
                {
                    blayer.costLabel.setOpacity(128);
                    resourceIcon.setOpacity(128);
                }
            }
        }
        
        var groundIsActive = false;
        
        if (categoryName == "upgrade")
        {
            // NSAssert(pflag,@"pflag missing in this upgrade");
            
            if (subCategoryName == "climate")
            {
                var baseGID = blayer.item.climateGID;
                
                // Make sure that the pflag for this is set (just in
                // case)
                if (gs._zfGameData._baseGID == baseGID)
                    gs._zfGameData._purchaseFlags.setFlag(pflag);
            }
            
            if (gs._zfGameData._purchaseFlags.hasFlag(pflag) || name == "Grassy Ground")
            {
                if (subCategoryName == "climate")
                {
                    unlockedGround = true;
                    if (blayer.costLabel)
                        blayer.costLabel.destroy();
                    // if(blayer.costLabel) blayer.infoLabel.destroy();
                    // if(blayer.costLabel) blayer.infoLabel2.destroy();
                    blayer.costLabel = null;
                    // blayer.infoLabel = null;
                    // blayer.infoLabel2 = null;
                    blayer.removeChildByTag(this.kMarketTag.kMarketTagBuyablesResourceIcon, true);
                    var costText = "";
                    var baseGID = blayer.item.climateGID;
                    
                    if (gs._zfGameData._baseGID == baseGID)
                    {
                        groundIsActive = true;
                        costText = Core.Localization.getString("Active");
                    }
                    else
                    {
                        costText = Core.Localization.getString("Tap To Activate");
                    }
                    
                    blayer.costLabel = CCLabel.labelWithString(costText, new Core.Size(100, 24), GL2.Text.HorizontalAlign.Center, "Arial-BoldMT", 11);
                    blayer.costLabel.setPosition(ccp(this._widthOffset, -33));
                    blayer.costLabel.setAnchorPoint(ccp(0.5, 0.5));
                 
                }
                else if (subCategoryName == "mapsize")
                {
                    // already bought farm sizes
                    var mapsizeUpgrade = item.mapSize;
                    blayer.backgroundSprite.setColor(ccc3(0x80, 0x80, 0x80));
                    alreadyBought = true;
                    
                    if (mapsizeUpgrade == gs._zfGameData._mapSize)
                    {
                        var costText = Core.Localization.getString("Active");
                        blayer.costLabel = CCLabel.labelWithString(costText, new Core.Size(100, 24), GL2.Text.HorizontalAlign.Center, "Arial-BoldMT", 11);
                        blayer.costLabel.setPosition(ccp(this._widthOffset, -33));
                        blayer.costLabel.setAnchorPoint(ccp(0.5, 0.5));
                    }
                }
                else
                {
                    alreadyBought = true;
                }
            }
        }
        
        // if this is an item
        if (categoryName == "item")
        {
    		if (pflag && gs._zfGameData._purchaseFlags.hasFlag(pflag))
    		{
    			alreadyBought = true;
    		}
    		if (mausoleumFlag && (gs._zfGameData._mausoleumFlags & mausoleumFlag))
    		{
    			alreadyBought = true;
    		}
        }
        
        var hasBuyButton = !blayer.item.noBuyButton;
        var forSale = !blayer.item.notForSale;
        
        if (!hasBuyButton || !forSale)
        {
            blayer.backgroundSprite.setColor(ccc3(0x80, 0x80, 0x80));
        }
        else if (forSale)
        {
            // buy button
            var buttonItem;
            var buttonColor;
            
            if ((myLevelExceedsLevelNeeded || alreadyUnlocked) && (!alreadyBought || subCategoryName == "climate"))
            {
                if (unlockedGround)
                {
                    var clayer = CCColorLayer.layerWithColor(ccc3(0, 0, 0), 138, 90);
                    clayer.setOpacity(0);
                    var buttonCover = new CCMenuItemLayer();
                    buttonCover.initFromLayer(clayer, blayer, groundIsActive ? null : this.checkBoughtItem.bind(this));
                    
                    blayer.buyButton = CCMenu.menuWithItems([ buttonCover ]);
                    blayer.addChild(blayer.buyButton, 2, 5);
                    blayer.buyButton.setPosition(ccp(this._widthOffset - 138 / 2, -45));
                    
                    blayer.backgroundSprite.setColor(groundIsActive ? ccc3(0x80, 0x80, 0x80) : ccc3(0xff, 0xff, 0xff));
                    blayer.userData = unlockedGround;
                }
                else if (alreadyBought && categoryName == "upgrade" // &&
                // [gs.zfGameData.purchaseFlags hasFlag:[pflag
                // intValue]]
                )
                {
                    // //undo if we are displaying upgrades that you
                    // already have
                    blayer.backgroundSprite.setColor(ccc3(0x80, 0x80, 0x80));
                }
                else
                {
                    var clayer = CCColorLayer.layerWithColor(ccc3(0, 0, 0), 138, 90);
                    clayer.setOpacity(0);
                    
                    var buttonCover = new CCMenuItemLayer();
                    buttonCover.initFromLayer(clayer, blayer, this.checkBoughtItem.bind(this));
                    
                    blayer.buyButton = CCMenu.menuWithItems([ buttonCover ]);
                    blayer.addChild(blayer.buyButton, 2, 5);
                    blayer.buyButton.setPosition(ccp(this._widthOffset - 138 / 2, -45));
                    
                    blayer.backgroundSprite.setColor(ccc3(0xff, 0xff, 0xff));
                }
            }
            else
            {
                if (hasUnlockCost) // ![subCategoryName
                // isEqualToString:@"zombie"])
                // //zombies cannot be unlocked
                // prematurely
                {
                    var clayer = CCColorLayer.layerWithColor(ccc3(0, 0, 0), 138, 90);
                    clayer.setOpacity(0);
                    
                    var buttonCover = new CCMenuItemLayer();
                    buttonCover.initFromLayer(clayer, blayer, this.unlockItem.bind(this));
                    
                    blayer.buyButton = CCMenu.menuWithItems([ buttonCover ]);
                    blayer.addChild(blayer.buyButton, 2, 5);
                    blayer.buyButton.setPosition(ccp(this._widthOffset - 138 / 2, -45));
                    
                }
                
                if(blayer.costLabel)
                	blayer.costLabel.setColor(ccc3(0xA0, 0xA0, 0xA0));
                // CCSprite* resourceIcon = (CCSprite*)[blayer getChildByTag:kMarketTagBuyablesResourceIcon]; resourceIcon.setOpacity(0x40);
                if(blayer.backgroundSprite)
                	blayer.backgroundSprite.setColor(ccc3(128, 128, 128));
            }
        }
        
        blayer.addChild(blayer.nameLabel, 1, 1);
        
        if (blayer.infoLabel)
        {
            blayer.addChild(blayer.infoLabel, 1, 2);
        }
        
        if (blayer.infoLabel2)
        {
            blayer.addChild(blayer.infoLabel2, 1, 2);
        }
        
        if (blayer.costLabel)
        {
            blayer.addChild(blayer.costLabel, 10, 3);
        }
        
        if (isActor)
        {
            var mutation = item.mutation;
            var z = null; // ZombieActor
            
            if (mutation)
            {
                
                z = ZFActorManager.spawnGUIActor_withClass_atPoint_withTarget("ZombieActorRegularTier1", ccp(this._widthOffset -47, -40), blayer);
                z.addMutation(mutation);
            }
            else
            {
                var unitKey = blayer.item.unitKey;
                
                z = ZFActorManager.spawnGUIActor_withClass_atPoint_withTarget(unitKey, ccp(this._widthOffset - 47, -40), blayer);
                
                //// >>>> this piece of code is missing in the original code
                if (blayer.zombieActor)
                {
                    blayer.removeChild(blayer.zombieActor._spriteMan);
                    blayer.removeChild(blayer.zombieActor);
                    blayer.zombieActor._spriteMan.destroy();
                    blayer.zombieActor.destroy();
                }
                
                blayer.zombieActor = z;
                //// <<< this piece of code is missing in the original code  
            }
            
            if (!myLevelExceedsLevelNeeded && !alreadyUnlocked)
            {
                for (var key in z._attachments)
                {
                    var a = z._attachments[key];
                    if (!a)
                    {
                        continue;
                    }
                    
                    a._sprite.setColor(ccc3(0x0,0x0,0x0));
                }
                
                // for (ActorParticle *p in z.particles)
                //{
                    // p.particle.startColor = (ccColor4F) {0,0,0,1};
                    // p.particle.endColor = (ccColor4F) {0,0,0,1};
                //}
            }
            
            if (!this._marketActorList)
            {
                this._marketActorList = [];
            }
            
            this._marketActorList.push(z);
        }
        
        this._windowNode.addChild(blayer, 2, this.kMarketTag.kTagBuyable);
    },
    
    initElementsWithWindowScale : function($super, widthScale, heightScale, originX, originY)
    {
        var w = new Core.Size(480, 320);
        
        $super(widthScale, heightScale, originX, originY);
        
        this.initBrowseMenuWithPosition(ccp(w._width / 2, 241), 400 * this._menuWidthScale);
        this.initBannerWithString(Core.Localization.getString("Market"), new Core.Size(200, 50), 20);
        
    },
    
    addMarketSubCategories : function(arrayOfNames)
    {
        destroyWithChildren(this._subCategoryMenu);
        this._subCategoryMenu = null;
        //				
        //				if (this._subCategoryMenu != null) {
        //					this.removeChild(this._subCategoryMenu, true);
        //					this._subCategoryMenu.destroy();
        //					this._subCategoryMenu = null;
        //
        //					for ( var i = 0; i < 6; i++) {
        //						// this.removeChildByTag(
        //						// this.kMarketTag.kMarketTagSubcategoryLabel, true );
        //					}
        //				}
        
        var marray = new Array();
        var f = "hudElements.png";
        
        for ( var i in arrayOfNames)
        {
            var name = arrayOfNames[i];
            
            var sprite11 = CCSprite.spriteWithFile(f, new Core.Rect(1, 308, 62, 27));
            var sprite21 = CCSprite.spriteWithFile(f, new Core.Rect(1, 308, 62, 27));
            var sprite12 = CCSprite.spriteWithFile(f, new Core.Rect(1, 308, 62, 27));
            var sprite22 = CCSprite.spriteWithFile(f, new Core.Rect(1, 308, 62, 27));
            
            sprite11.setColor(ZFColorDefines.colorBrownButton2);
            sprite21.setColor(ZFColorDefines.colorYellowButton2);
            sprite12.setColor(ZFColorDefines.colorBrownButton2);
            sprite22.setColor(ZFColorDefines.colorYellowButton2);
//            
            var subCatButton = new CCMenuItemToggle();
            subCatButton.__subCategoryIdx = i;
//            
            var it1 = CCMenuItemImage.itemFromNormalSprite(sprite11, sprite12);
            var it2 = CCMenuItemImage.itemFromNormalSprite(sprite21, sprite22);
            
            subCatButton.initWithTarget(subCatButton, this.setMarketSubCategory.bind(this), [ it1, it2]);
            
            marray.push(subCatButton);
            
            this._setButtonLabel(subCatButton, name, 10);
        }
        
        this._subCategoryMenu = CCMenu.menuWithItems(marray);
        
        if (this._widthScale > 1)
        {
            this._subCategoryMenu.alignItemsHorizontallyWithPadding(10);
        }
        else
        {
            this._subCategoryMenu.alignItemsHorizontally();
        }
        
        this._subCategoryMenu.setPosition(ccp(this._categoryMenu.getPosition()._x, 244 - 29 - this._heightOffset - 27 / 2)); // 27/2 wziete z rozmiaru sprite1/2
        this._windowNode.addChild(this._subCategoryMenu, 10);
        
    },
    
    setMarketSubCategory : function(sender)
    {
        var idx = sender.__subCategoryIdx;
        
        for ( var i in this._subCategoryMenu._children)
        {
            var item = this._subCategoryMenu._children[i];
            
            if (item.classname != "CCMenuItemToggle")
                continue;
            
            if (sender == item)
            {
                item.setSelectedIndex(1);
            }
            else
            {
                item.setSelectedIndex(0);
            }
        }
        
        switch (this._category)
        {
            case "crop": {
                if (idx == 0)
                    this._subCategory = "plant";
                if (idx == 1)
                    this._subCategory = "zombie";
                
                break;
            }
                
            case "item": {
            	//FIXME
//                if (idx == 0)
//                    this._subCategory = "new";
                if (idx == 0)
                    this._subCategory = "special";
                if (idx == 1)
                    this._subCategory = "decor";
                if (idx == 2)
                    this._subCategory = "tree";
                
                break;
            }
                
            case "upgrade": {
            	if (idx == 0)
                    this._subCategory = "mutation";
                if (idx == 1)
                    this._subCategory = "mapsize";
                if (idx == 2)
                    this._subCategory = "climate";
                
                break;
            }
                
            case "brain": {
                if (idx == 0)
                    this._subCategory = "brain";
                if (idx == 1)
                    this._subCategory = "gold";
                
                break;
            }
                
            case "boost": {
                this._subCategory = "boost";
                
                break;
            }
        }
        
        this._currentPage = 0;
        
        this.openMarketMenuWithCategory(this._category, this._subCategory);
        
    },
    
    setMarketCategory : function(sender)
    {
        this._cropsItem.setSelectedIndex(0);
        this._itemsItem.setSelectedIndex(0);
        this._upgradeItem.setSelectedIndex(0);
        this._brainsItem.setSelectedIndex(0);
        this._boostItem.setSelectedIndex(0);
        
        //				var subCategory = this._subCategory;
        //				var category = sender.__category;
        //				if (!category) {
        //					category = "crop";
        //				}
        
        //	this._category = category;
        
        destroyWithChildren(this._subCategoryMenu);
        
        if (this == sender)
        {
            var idx = -1;
            
            if (this._category == "crop")
            {
                this._cropsItem.setSelectedIndex(1);
                
                idx = [ "plant", "zombie" ].indexOf(this._subCategory);
                if (idx == -1)
                {
                    this._subCategory = "plant";
                    idx = 0;
                }
                
                this.addMarketSubCategories([ Core.Localization.getString("Plants"), Core.Localization.getString("Zombies") ]);
                
                if (this._subCategory == "plant")
                    this._subCategoryMenu._children[0].setSelectedIndex(1);
                else
                    this._subCategoryMenu._children[2].setSelectedIndex(1);
            }
            
            else if (this._category == "item")
            {
                this._itemsItem.setSelectedIndex(1);
                
                // I'm so fcking awesome
                //FIXME: Enable the "New" category when more items are added
                idx = [ /*"new"*/, "special", "decor", "tree" ].indexOf(this._subCategory);
                if (idx == -1)
                {
                    this._subCategory = "special";
                    idx = 1;
                }
                
                //FIXME: Enable the "New" category when more items are added
                this.addMarketSubCategories([ /*Core.Localization.getString("New"),*/ Core.Localization.getString("Functional"), Core.Localization.getString("Decors"), Core.Localization.getString("Trees") ]);
                
                //FIXME When new category gets added, change indexes ading 2
                if (this._subCategory == "decor")
                    this._subCategoryMenu._children[2].setSelectedIndex(1);
                else if (this._subCategory == "tree")
                    this._subCategoryMenu._children[4].setSelectedIndex(1);
                //FIXME: Enable the "New" category when more items are added
//                else if (this._subCategory == "new")
//                    this._subCategoryMenu._children[0].setSelectedIndex(1);
                else
                    this._subCategoryMenu._children[0].setSelectedIndex(1);
            }
            else if (this._category == "upgrade")
            {
                this._upgradeItem.setSelectedIndex(1);
                
                idx = [ "mutation", "mapsize", "climate" ].indexOf(this._subCategory);
                if (idx == -1)
                {
                    this._subCategory = "mutation";
                    idx = 0;
                }
                
                this.addMarketSubCategories([ NSLocalizedString("Mutations"), NSLocalizedString("Farm Size"), NSLocalizedString("Ground") ]);
                
                if (this._subCategory == "mutation")
                    this._subCategoryMenu._children[0].setSelectedIndex(1);
                else if (this._subCategory == "mapsize")
                    this._subCategoryMenu._children[2].setSelectedIndex(1);
                else if (this._subCategory == "climate")
                	this._subCategoryMenu._children[4].setSelectedIndex(1);
                
            }
            else if (this._category == "brain")
            {
                this._brainsItem.setSelectedIndex(1);
                
                idx = [ "brain", "gold" ].indexOf(this._subCategory);
                if (idx == -1)
                {
                    this._subCategory = "brain";
                    idx = 0;
                }
                
                this.addMarketSubCategories([ Core.Localization.getString("Brains"), Core.Localization.getString("Convert") ]);
                
                if(this._subCategory == "brain")
            	{
                	this._subCategoryMenu._children[0].setSelectedIndex(1);
            	} else
            	{
            		this._subCategoryMenu._children[2].setSelectedIndex(1);
            	}
            }
            else if (this._category == "boost")
            {
                this._boostItem.setSelectedIndex(1);
                this._subCategory = "boost";
                
                idx = 0;
                
                this.addMarketSubCategories([ Core.Localization.getString("Boosts")/*, Core.Localization.getString("Enhancements")*/ ]);
            }
            
            //
            //this._subCategoryMenu._children[idx * 2].setSelectedIndex(1);
        }
        
        if (sender == this._cropsItem)
        {
            this._cropsItem.setSelectedIndex(1);
            this._category = "crop";
            this._currentPage = 0;
            this._subCategory = "plant";
            
            this.addMarketSubCategories([ Core.Localization.getString("Plants"), Core.Localization.getString("Zombies") ]);
            
            this._subCategoryMenu._children[0].setSelectedIndex(1);
            
        }
        
        if (sender == this._itemsItem)
        {
            this._itemsItem.setSelectedIndex(1);
            this._category = "item";
            this._currentPage = 0;
            //this._subCategory = "new";
            this._subCategory = "special";
            
            //FIXME: Enable the "New" category when more items are added
            this.addMarketSubCategories([ /*Core.Localization.getString("New"),*/ Core.Localization.getString("Functional"), Core.Localization.getString("Decors"), Core.Localization.getString("Trees") ]);
            
            this._subCategoryMenu._children[0].setSelectedIndex(1);
            
        }
        
        if (sender == this._upgradeItem)
        {
            this._upgradeItem.setSelectedIndex(1);
            this._category = "upgrade";
            this._currentPage = 0;
            this._subCategory = "mutation";
            
            this.addMarketSubCategories([ NSLocalizedString("Mutations"), NSLocalizedString("Farm Size"), NSLocalizedString("Ground") ]);
            
            this._subCategoryMenu._children[0].setSelectedIndex(1);
        }
        
        if (sender == this._brainsItem)
        {
            this._brainsItem.setSelectedIndex(1);
            this._category = "brain";
            this._currentPage = 0;
            this._subCategory = "brain";
            
            this.addMarketSubCategories([ Core.Localization.getString("Brains"), Core.Localization.getString("Convert") ]);
            
            this._subCategoryMenu._children[0].setSelectedIndex(1);
            
        }
        
        if (sender == this._boostItem)
        {
            this._boostItem.setSelectedIndex(1);
            this._category = "boost";
            this._currentPage = 0;
            this._subCategory = "boost";
            
            this.addMarketSubCategories([ Core.Localization.getString("Boosts")/*, Core.Localization.getString("Enhancements")*/ ]);
            
            this._subCategoryMenu._children[0].setSelectedIndex(1);
        }
        
        // [self openMarketMenuWithCategory:category
        // andSubcategory:subCategory];
        this.openMarketMenuWithCategory(this._category, this._subCategory);
    },
    
    openMarketMenuWithCategory : function(category, subcategory)
    {
        this.setupCategory(category, subcategory, this._currentPage);
    },
    
    marketItemFromUnitKey : function(unitKey)
    {
        //assuming unitkey is unique
        
        for ( var key in this._marketArray)
        {
            var item = this._marketArray[key];
            if (unitKey == item["unitKey"])
            {
                return item;
            }
        }
        
        return null;
    },
    
    nameFromUnitKey : function(unitKey)
    {
        var item = this.marketItemFromUnitKey(unitKey);
        
        if (item)
        {
            return item["name"];
        }
        
        return null;
    },
    
    spriteFilenameFromName : function(name)
    {
        var item = this.marketItemFromName(name);
        if (item)
        {
            var filename = item["spriteSheet"];
            
            if (!filename)
            {
                var tim = ZFTileManager;
                var dictWithSpriteInfo = tim._tilePropertiesDictionary[item["tile"]];
                filename = dictWithSpriteInfo["spriteSheet"];
            }
            
            return filename;
        }
        
        return null;
    },
    
    buyAppStoreItem : function(itemID, amount)
    {
        // Used for Bank.Inventory.getItem and MobagePaymentController
        var onSuccess = function(transaction)
        {            
            console.log("ZFMarketMenu.buyAppStoreItem: Purchase completed successfully " + itemID);
            this._paymentController = null;
            CCDirector.resume();
            this.removePleaseWait();
        };
        
        var onProcess = function(transaction)
        {
            // Reward the user
            console.log("ZFMarketMenu.buyAppStoreItem: Buying item " + itemID);
            var identifier = itemID;
            if(transaction.item){
            	identifier = transaction.item.sku;
            } else if (transaction.items[0]) {
            	identifier = transaction.items[0].item.id;
            }
            console.log("ZFMarketMenu.onProcess -> identifier: " + identifier);
            MKStoreObserver.provideContent(identifier, amount);
            //MKStoreObserver.provideContent(transaction.item.sku, amount);
            GameState.saveGameReal();
            this._paymentController.closeTransaction(transaction);
        };
        
        // Used for Bank.Inventory.getItem and MobagePaymentController
        var onFailure = function(error, data)
        {
            if (error && (error !== "usercanceled" && error.description !== "usercanceled"))
            {
                var tempMessage = new UI.AlertDialog();
                tempMessage.setTitle(NSLocalizedString("Failure"));
                tempMessage.setText(NSLocalizedString("Server Error"));
                tempMessage.setChoices(["OK"]);
                tempMessage.setOnChoice(function()
                { 
                    tempMessage.hide();
                    tempMessage.destroy();
                }.bind(this));
                tempMessage.show();
                console.log("ZFMarketMenu.buyAppStoreItem: Error while trying to buy " + itemID + ". Error: " + error.description);
            }
            this._paymentController = null;
            CCDirector.resume();
            this.removePleaseWait();
            
            //FIXME: Requires UIAlertView
            /* UIAlertView *aw = [[UIAlertView alloc] initWithTitle:NSLocalizedString(@"Product not found", nil)
                message:nil
                delegate:nil 
                cancelButtonTitle:NSLocalizedString(@"Try Again", nil)
                otherButtonTitles:nil];
            [aw show];
            [aw release];*/
        };
        
        console.log("ZFMarketMenu.buyAppStoreItem: Creating transaction. item: " + itemID + ", amount: " + amount);
        if (!this._paymentController)
        {
            CCDirector.pause();
            this._paymentController = new MobagePaymentController(onSuccess.bind(this), onProcess.bind(this), onFailure.bind(this));
            this._paymentController.createTransaction([ {
                'item' : {
                    'id' : itemID
                },
                'quantity' : '' + amount
            } ], 'Zombie Farm Item'); //jp: ゾンビファームのアイテム us: Zombie Farm Item
            
            this.displayPleaseWait();
        }
    },
    
    xpFromName : function(name)
    {
        var item = this.marketItemFromName(name);
        
        var xp = 0;
        
        if (item)
        {
            var subcategory = item["subCategory"];
            var costBrains = item["brainsNeeded"];
            var seasonal = item["limited"];
            var newItem = item["new"];
            var cost = item["cost"];
            
            if (subcategory == "decor" || subcategory == "tree")
            {
                // base xp
                xp = (costBrains) ? cost * 100 : cost / 100;
                
                // bonus xp for new or seasonal items
                if (newItem || seasonal)
                {
                    if (costBrains)
                        xp = xp * 1.2;
                    else
                        xp = xp * 2;
                }
            }
            else if (subcategory == "special")
            {
                xp = (costBrains) ? cost * 80 : cost / 200;
                
                // there are no seasonal or new functional items at this
                // time
            }
            else if (subcategory == "plant" || subcategory == "zombie")
            {
                // plants give 1 xp when planted
                xp = 1;
            }
        }
        
        return xp;
    },
    
    costFromName : function(name)
    {
        var item = this.marketItemFromName(name);
        
        if (item)
        {
            // this way if we add more variable cost items it'll do this compare first so other 
            // items wont have to compare item names as well
            if (item["variableCost"])
            {
                var cost = 0;
                
                if (item["invasionVoucher"])
                {
                    var level = GameState._zfGameData._level;
                    
                    if (level < 16)
                    {
                        // ol mcdonnell stage
                        cost = 10000;
                    }
                    else if (level < 21)
                    {
                        // lawyer stage
                        cost = 12000;
                    }
                    else if (level < 26)
                    {
                        // pirate stage
                        cost = 14000;
                    }
                    else if (level < 31)
                    {
                        // ninja stage
                        cost = 16000;
                    }
                    else if (level < 36)
                    {
                        // robot stage
                        cost = 18000;
                    }
                    else
                    {
                        // alien stage
                        cost = 20000;
                    }
                }
                
                return cost;
            }
            else if (item["cost"])
            {
                return item["cost"];
            }
        }
        
        return 0; //free	
    },
    
    // - (NSDictionary*)marketItemFromName:(NSString *)name
    // withProperty:(NSString*)property
    // {
    // for (NSDictionary *item in marketArray)
    // {
    // if ( [name isEqualToString:(NSString*)[item objectForKey:@"name"]] )
    // {
    // }
    // }
    // }
    //		
    // return nil;
    // }
    
    shortcutBuy : function(key)
    {
        var gui = ZFGuiLayer.gui();
        var w = CCDirector.winSize();
        
        //prompt for confirmation on item and price
        var item = this.marketItemFromName(key);
        var cost = parseInt(this.costFromName(key));
        var brainsNeeded = item["brainsNeeded"];
        var amount = parseInt(item["amountGivenPerPurchase"]);
        var message = sprintf(NSLocalizedString("Buy %i of this item for: %i     ?"), amount, cost);
        
        var aw = gui.displayAlertSimpleChoice(NSLocalizedString(key), message, CCSprite.spriteWithFile(this.spriteFilenameFromName(key)), CGRectMake((w._width - 450) / 2, w._height - (w._height - 200) / 2, 450, 200));
        aw._idTag = this.kMarketAlert.kMarketAlertShortcutBuy;
        aw._delegate = this;
        
        var digitCount = Math.floor(log10(Math.abs(cost))) + 1;
        var resourceType = (brainsNeeded) ? GameData.gameResources.kGameResourceBrains : GameData.gameResources.kGameResourceGold;
        aw._image2 = (resourceType == GameData.gameResources.kGameResourceBrains) ? CCSprite.spriteWithFile("brain.png") : CCSprite.spriteWithFile("gold.png");
        aw._image2.setPosition(ccpAdd(aw._body1.getPosition(), ccp(34 + (digitCount * 9), 0)));
        aw._image2.setScale(ccp(1, 1));
        aw._image2.setAnchorPoint(ccp(0, 0.5));
        aw._windowNode.addChild(aw._image2);
        
        aw._userData = item;
        
    },
    
    alertWindow_dismissedPositive : function(alertWindow, dummy)
    {
        if (!dummy)
        {
            this._blockOtherUnlockingOperations = false;
            return;
        }
        
        if (alertWindow._idTag == this.kMarketAlert.kMarketAlertShortcutBuy)
        {
            var item = alertWindow._userData;
            if (this.boughtItemWithItem(item, null))
            {
                var name = item["name"];
                ZFStorageMenu.storageMenu().useItemWithName(name);
                ZFGuiLayer.gui().displayToolTip(sprintf(Core.Localization.getString("%@ Used!"), name), 1.25);
            }
        }
        else if (alertWindow._idTag == this.kMarketAlert.kMarketAlertBuyBrains)
        {
            this._currentPage = 0;
            this._category = "brain";
            this._subCategory = "brain";
            if (this._menuState != ZFMenu.menuStates.menuStateOpen)
            {
                this.openMenuWithPage(0);
            }
            else
            {
                this.setMarketCategory(this);
            }
        }
        else if (alertWindow._idTag == this.kMarketAlert.kMarketAlertConvertBrains)
        {
            
            this._currentPage = 0;
            this._category = "brain";
            this._subCategory = "gold";
            
            if (this._menuState != ZFMenu.menuStates.menuStateOpen)
            {
                this.openMenuWithPage(0);
            }
            else
            {
                this.setMarketCategory(this);
            }
        }
        else if (alertWindow._idTag == this.kMarketAlert.kMarketAlertUnlockItemEarly)
        {
            // So, the user data should only ever be an NSDictionary, but
            // just to be sure...
            /*if (alertWindow._userData instanceof CCMenuItem)
            {*/
                this.chargeUnlock(alertWindow._userData);
            //}
        }
        else if (alertWindow._idTag == this.kMarketAlert.kMarketAlertConfirmPurchase)
        {
            this.boughtItemFromMarketMenu(alertWindow._userData);
        }
        this._blockOtherUnlockingOperations = false;
    },
    
    alertWindow : function(alertWindow, dummy)
    {
//        console.log("££");
//        console.log(arguments);
        
        if (!dummy)
        {
            this._blockOtherUnlockingOperations = false;
            return;
        }
        
        if (alertWindow._idTag == this.kMarketAlert.kMarketAlertShortcutBuy)
        {
            var item = alertWindow._userData;
            if (this.boughtItemWithItem(item, null))
            {
                var name = item["name"];
                ZFStorageMenu.storageMenu().useItemWithName(name);
                ZFGuiLayer.gui().displayToolTip(sprintf(NSLocalizedString("%@ Used!"), name), 1.25);
            }
            
        }
        else if (alertWindow._idTag == this.kMarketAlert.kMarketAlertBuyBrains)
        {
            this._currentPage = 0;
            this._category = "brain";
            this._subCategory = "brain";
            if (this._menuState != ZFMenu.menuStates.menuStateOpen)
            {
                this.openMenuWithPage(0);
            }
            else
            {
                this.setMarketCategory(this);
            }
        }
        else if (alertWindow._idTag == this.kMarketAlert.kMarketAlertConvertBrains)
        {
            this._currentPage = 0;
            this._category = "brain";
            this._subCategory = "gold";
            
            if (this._menuState != ZFMenu.menuStates.menuStateOpen)
            {
                this.openMenuWithPage(0);
            }
            else
            {
                this.setMarketCategory(this);
            }
        }
        else if (alertWindow._idTag == this.kMarketAlert.kMarketAlertUnlockItemEarly)
        {
            // So, the user data should only ever be an NSDictionary, but
            // just to be sure...
            /*if (alertWindow._userData instanceof CCMenuItem)
            {*/
                this.chargeUnlock(alertWindow._userData);
            //}
        }
        else if (alertWindow._idTag == this.kMarketAlert.kMarketAlertConfirmPurchase)
        {
            this.boughtItemFromMarketMenu(alertWindow._userData);
        }
        
        this._blockOtherUnlockingOperations = false;
    },
    
    //- (NSDictionary*)marketItemFromFlag:(int)flag withType:(NSString*)flagKey
    marketItemFromFlag: function(flag, flagKey)
    {
    	for (var key in this._marketArray)
    	{
    		item = this._marketArray[key];
    		// check if it has a pflag first
    		var itemFlag = item[flagKey];
    		if (flag == itemFlag)
    		{
    			return item;
    		}
    	}
    	
    	return nil;
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/ZFMenus/MutationCollection/ZFMutationMenu'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/MutationCollection/ZFMutationMenu'] || {}; $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/MutationCollection/ZFMutationMenu'] = exports; var ZFMutationCell = require('Code/Game/GUI/ZFMenus/MutationCollection/ZFMutationCell').ZFMutationCell;

exports.ZFMutationMenu = ZFMenu.singleton({
	classname : 'ZFMutationMenu',

	mutationMenuMenuTags : {
		kMutationMenuTagTable : ZFMenu.kZFMenuTags.kMenuTagMAX,
		kMutationMenuTagUpArrow : ZFMenu.kZFMenuTags.kMenuTagMAX + 1,
		kMutationMenuTagDnArrow : ZFMenu.kZFMenuTags.kMenuTagMAX + 2,
		kMutationMenuTagBanner : ZFMenu.kZFMenuTags.kMenuTagMAX + 3,
		kMutationMenuTagIcon : ZFMenu.kZFMenuTags.kMenuTagMAX + 4,
		kMutationMenuTagTableBG : ZFMenu.kZFMenuTags.kMenuTagMAX + 5,
		kMutationMenuTagDetailBG : ZFMenu.kZFMenuTags.kMenuTagMAX + 6,
		kMutationMenuTagDetailInnerBG : ZFMenu.kZFMenuTags.kMenuTagMAX + 7,
		kMutationMenuTagDetailCard : ZFMenu.kZFMenuTags.kMenuTagMAX + 8,
		kMutationMenuTagInfoTabBG : ZFMenu.kZFMenuTags.kMenuTagMAX + 9,
		kMutationMenuTagInfoTabInnerBG : ZFMenu.kZFMenuTags.kMenuTagMAX + 10,
		kMutationMenuTagNumberBG : ZFMenu.kZFMenuTags.kMenuTagMAX + 11,
		kMutationMenuTagNumberInnerBG : ZFMenu.kZFMenuTags.kMenuTagMAX + 12,
		kMutationMenuTagLabelRequired : ZFMenu.kZFMenuTags.kMenuTagMAX + 13,
		kMutationMenuTagLabelMutationsCollected : ZFMenu.kZFMenuTags.kMenuTagMAX + 14,
		kMutationMenuTagLabelMutationsCollectedCount : ZFMenu.kZFMenuTags.kMenuTagMAX + 15,
		kMutationMenuTagLabelNumber : ZFMenu.kZFMenuTags.kMenuTagMAX + 16,

		kMutationMenuTagSpriteRequired1 : ZFMenu.kZFMenuTags.kMenuTagMAX + 17,
		kMutationMenuTagSpriteRequired2 : ZFMenu.kZFMenuTags.kMenuTagMAX + 18,
		kMutationMenuTagSpriteRequired3 : ZFMenu.kZFMenuTags.kMenuTagMAX + 19,
		kMutationMenuTagSpriteRequired4 : ZFMenu.kZFMenuTags.kMenuTagMAX + 20,
		kMutationMenuTagSpriteRequired5 : ZFMenu.kZFMenuTags.kMenuTagMAX + 21,

		kMutationMenuTagMAX : ZFMenu.kZFMenuTags.kMenuTagMAX + 22
	},

	$mutationMenu : function() {
		return this;
	},

	enableMenus : function($super)
	{
		$super();
		this._scrolled = true;
		this.displayPage(true);
	},
	
	openTimerTime : function()
	{
		return 0.5;
	},
	
	initialize : function() {
		//this.setPosition(ccp(0, -320));
		this._mutationCollectionArray = DataPreloader._mutationCollectionDictionary;
		this._windowNode.setScale(CCDirector.zoomValue());
		if (CCDirector.zoomValue()._x > 1.0)
			this._windowNode.setPosition(new Core.Point(-this._windowNode.getSize()._width * 1/8, -this._windowNode.getSize()._height * 1/8 - 10));
	},

	destroy : function() {
		this._mutationCollectionArray = null;
	},

	init : function(cb) {
//		this._mutationCollectionArray = DataPreloader._mutationCollectionDictionary;
//		if (!this._mutationCollectionArray) {
//			Storage.FileSystem.readFile("./Content/MutationCollection.plist.json", false, function(err, file) {
//				if (err) {
//					console.log("GameData error read file = " + err);
//				} else if (file) {
//					this._mutationCollectionArray = eval('(' + file + ')');
//					cb();
//				}
//			}.bind(this));
//		}
	},

	initElements : function() {
		var resolutionHeight = UI.Window._height;
		var menuHeightOffset = 0;
		var heightScale = 1;

		//		if (resolutionHeight > ZFGameDefines.ORIGINAL_WINDOW_HEIGHT)
		//		{
		//			heightScale = (resolutionHeight/320.0)*2/3;
		//			menuHeightOffset = (resolutionHeight-320*heightScale)/2;
		//
		//			this._dimLayer.changeHeight(2*resolutionHeight);
		//			if(!this._dimLayer.getParent())
		//			{
		//				this.addChild(this._dimLayer, 1000);
		//				//TODO CCTouchDispatcher
		//				//[[CCTouchDispatcher sharedDispatcher] addTargetedDelegate:dimLayer priority:90 swallowsTouches:YES];
		//			}
		//		}

		this._actors = [];
		var w = CGSizeMake(480, 320);
		//var windowSize = CGRectMake(0+this._heightOffset, w._height-16+this._heightOffset, w._width, w._height-32);
		//		var windowSize = CGRectMake(0+this._heightOffset, w._height-16+this._heightOffset, 480, w._height-32);

		var windowSize = CGRectMake(0, 0, 480, w._height - 32);
		var f = ZFGameDefines.HUDELEMENTS1_FILE;
		var color = ccc4(237, 226, 177, 0);
		var color2 = ccc3(237, 226, 177);

		destroyWithChildren(this._bgOverlay);

		var s = CGRectMake(1, 44, 34, 24);

		var bgOverlay = ZFMenu.makeWindow(windowSize, CGRectMake(1, 1, 34, 42), CGRectMake(36, 1, 30, 38), f, color, CGRectMake(0, 0, 0, 0),
				CGRectMake(0, 0, 0, 0), s);

		this._bgOverlay = bgOverlay;

		this._widthOffset = (this._winSize._width - windowSize.getSize()._width) / 2;
		this._heightOffset = -(this._winSize._height - windowSize.getSize()._height) / 2;

		this._backgroundSpriteSheet = bgOverlay.getChildByTag(1);
		this._windowNode.addChild(bgOverlay, 2, ZFMenu.kZFMenuTags.kZFMenuTagBackground);
		bgOverlay.setPosition(ccp(this._widthOffset, this._heightOffset));
		//bgOverlay.setPosition(ccpSub(bgOverlay.getPosition(),ccp(0,menuHeightOffset)));

		var wSize = CCDirector.winSize();
		rotateSide = 0;
		widthSegment = (!rotateSide) ? s.getSize()._width : s.getSize()._height;
		var windowColor = CCColorLayer.layerWithColor(color2, windowSize.getSize()._width - widthSegment * 2 + 2, windowSize.getSize()._height);
		this._windowNode.addChild(windowColor, 0);
		windowColor.setPosition(ccp(wSize._width / 2 - windowColor.getSize()._width / 2, wSize._height / 2));

		//table window
		var tableBg = ZFMenu.makeWindow(CGRectMake(/*35+this._widthOffset*/0, /*38 + 220+this._heightOffset+menuHeightOffset*3/10*/0, 274,
				220 * heightScale), CGRectMake(37, 40, 11, 11), CGRectMake(49, 40, 11, 11), f, ZFColorDefines.colorMenuMutationPurpleDark, CGRectMake(
				0, 0, 0, 0), CGRectMake(0, 0, 0, 0), CGRectMake(49, 40, 11, 11));
		this._windowNode.addChild(tableBg, 1, ZFMutationMenu.mutationMenuMenuTags.kMutationMenuTagTableBG);
		tableBg.setPosition(ccp(35 + this._widthOffset, this._heightOffset - 38));

		this._tableBg = tableBg;
		this._tableBg._cellNode = new CCNode();
		this._tableBg.addChild(this._tableBg._cellNode,10);

		for ( var i in tableBg._children) {
			var l = tableBg._children[i];

			//[l isKindOfClass:[CCSpriteSheet class]]
			if (l.classname == 'CCSpriteSheet' || l.classname == 'CCTMXLayer' || l.classname == 'CCBitmapFontAtlas') {
				for ( var j in l._children) {
					//console.log("*");
					var s = l._children[j];
					s.setColor(ZFColorDefines.colorMenuMutationPurpleDark);
				}
			}
		}

		//detail window
		var detailBg = ZFMenu.makeWindow(CGRectMake(/*318+this._widthOffset*/0, /*93 + 161+this._heightOffset+(menuHeightOffset*1/3)*/0, 128, 161),
				CGRectMake(37, 40, 11, 11), CGRectMake(49, 40, 11, 11), f, ZFColorDefines.colorMenuMutationPurpleLight, CGRectMake(0, 0, 0, 0),
				CGRectMake(0, 0, 0, 0), CGRectMake(49, 40, 11, 11));
		detailBg.setPosition(ccp(318 + this._widthOffset, 93 + 16 - 161 + this._heightOffset + 8));
		this._windowNode.addChild(detailBg, 3, ZFMutationMenu.mutationMenuMenuTags.kMutationMenuTagDetailBG);

		for ( var i in detailBg._children) {
			var l = detailBg._children[i];

			//[l isKindOfClass:[CCSpriteSheet class]]
			if (l.classname == 'CCSpriteSheet' || l.classname == 'CCTMXLayer' || l.classname == 'CCBitmapFontAtlas') {
				for ( var j in l._children) {
					var s = l._children[j];
					s.setColor(ZFColorDefines.colorMenuMutationPurpleLight);
				}
			}
		}

		//detail window inner
		var detailInnerBg = ZFMenu.makeWindow(CGRectMake(/*321+this._widthOffset*/0,/* 134 + 117+this._heightOffset+(menuHeightOffset*1/3)*/0, 122,
				117), CGRectMake(37, 40, 11, 11), CGRectMake(49, 40, 11, 11), f, ZFColorDefines.colorMenuMutationPurpleDark, CGRectMake(0, 0, 0, 0),
				CGRectMake(0, 0, 0, 0), CGRectMake(49, 40, 11, 11));

		detailInnerBg.setPosition(ccp(321 + this._widthOffset, 93 + 12 - 161 + this._heightOffset + 8));
		this._windowNode.addChild(detailInnerBg, 3, ZFMutationMenu.mutationMenuMenuTags.kMutationMenuTagDetailInnerBG);

		for ( var i in detailInnerBg._children) {
			var l = detailInnerBg._children[i];

			//[l isKindOfClass:[CCSpriteSheet class]]
			if (l.classname == 'CCSpriteSheet' || l.classname == 'CCTMXLayer' || l.classname == 'CCBitmapFontAtlas') {
				for ( var j in l._children) {
					var s = l._children[j];
					s.setColor(ZFColorDefines.colorMenuMutationPurpleDark);
				}
			}
		}

		//detail window card
		var detailCardBG = ZFMenu.makeWindow(
				CGRectMake(/*330+this._widthOffset*/0, /*138 + 110+this._heightOffset+(menuHeightOffset*1/3)*/0, 83, 110),
				CGRectMake(37, 40, 11, 11), CGRectMake(49, 40, 11, 11), f, ZFColorDefines.colorMenuMutationGreen, CGRectMake(0, 0, 0, 0), CGRectMake(0,
						0, 0, 0), CGRectMake(49, 40, 11, 11));

		detailCardBG.setPosition(ccp(this._widthOffset + 330, this._heightOffset + 110 - 138 - 32 + 8));
		this._windowNode.addChild(detailCardBG, 3, ZFMutationMenu.mutationMenuMenuTags.kMutationMenuTagDetailCard);

		for ( var i in detailCardBG._children) {
			var l = detailCardBG._children[i];

			//[l isKindOfClass:[CCSpriteSheet class]]
			if (l.classname == 'CCSpriteSheet' || l.classname == 'CCTMXLayer' || l.classname == 'CCBitmapFontAtlas') {
				for ( var j in l._children) {
					var s = l._children[j];
					s.setColor(ZFColorDefines.colorMenuMutationGreen);
				}
			}
		}

		//number window
		var numberBg = ZFMenu.makeWindow(CGRectMake(415 + this._widthOffset, 224 + 39 + this._heightOffset + (menuHeightOffset * 1 / 3), 39, 39),
				CGRectMake(37, 40, 11, 11), CGRectMake(49, 40, 11, 11), f, ZFColorDefines.colorMenuMutationPurpleLight, CGRectMake(0, 0, 0, 0),
				CGRectMake(0, 0, 0, 0), CGRectMake(49, 40, 11, 11));

		this._windowNode.addChild(numberBg, 4, ZFMutationMenu.mutationMenuMenuTags.kMutationMenuTagNumberBG);
		numberBg.setPosition(ccp(415 + this._widthOffset, this._heightOffset - 35 - 6 + 8));

		for ( var i in numberBg._children) {
			var l = numberBg._children[i];

			//[l isKindOfClass:[CCSpriteSheet class]]
			if (l.classname == 'CCSpriteSheet' || l.classname == 'CCTMXLayer' || l.classname == 'CCBitmapFontAtlas') {
				for ( var j in l._children) {
					var s = l._children[j];
					s.setColor(ZFColorDefines.colorMenuMutationPurpleLight);
				}
			}
		}

		//number window inner
		var numberInnerBg = ZFMenu.makeWindow(
				CGRectMake(/*417+this._widthOffset*/0, /*226 + 35+this._heightOffset+(menuHeightOffset*1/3)*/0, 35, 35), CGRectMake(37, 40, 11, 11),
				CGRectMake(49, 40, 11, 11), f, ZFColorDefines.colorMenuMutationPurpleLighter, CGRectMake(0, 0, 0, 0), CGRectMake(0, 0, 0, 0),
				CGRectMake(49, 40, 11, 11));
		numberInnerBg.setPosition(ccp(417 + this._widthOffset, this._heightOffset - 35));
		this._windowNode.addChild(numberInnerBg, 4, ZFMutationMenu.mutationMenuMenuTags.kMutationMenuTagNumberInnerBG);

		for ( var i in numberInnerBg._children) {
			var l = numberInnerBg._children[i];

			//[l isKindOfClass:[CCSpriteSheet class]]
			if (l.classname == 'CCSpriteSheet' || l.classname == 'CCTMXLayer' || l.classname == 'CCBitmapFontAtlas') {
				for ( var j in l._children) {
					var s = l._children[j];
					s.setColor(ZFColorDefines.colorMenuMutationPurpleLighter);
				}
			}
		}

		//info tab border
		var r = CGRectMake(/*300+this._widthOffset*/0, /*44 + 44+this._heightOffset+(menuHeightOffset*1/3)*/0, 150, 44);
		//        if (resolutionHeight>ZFGameDefines.ORIGINAL_WINDOW_HEIGHT)
		//    	{
		//            r = CGRectMake(300+this._widthOffset, 44 + 44+this._heightOffset+(menuHeightOffset*1/3) - 134, 150, 44);
		//        }

		var infoTabBg = ZFMenu.makeWindow(r, CGRectMake(37, 40, 11, 11), CGRectMake(49, 40, 11, 11), f, ZFColorDefines.colorMenuMutationPurpleDark,
				CGRectMake(0, 0, 0, 0), CGRectMake(0, 0, 0, 0), CGRectMake(49, 40, 11, 11));

		infoTabBg.setPosition(ccp(300 + this._widthOffset, this._heightOffset - 35 - 172 + 1));
		this._windowNode.addChild(infoTabBg, 0, ZFMutationMenu.mutationMenuMenuTags.kMutationMenuTagInfoTabBG);

		for ( var i in infoTabBg._children) {
			var l = infoTabBg._children[i];

			//[l isKindOfClass:[CCSpriteSheet class]]
			if (l.classname == 'CCSpriteSheet' || l.classname == 'CCTMXLayer' || l.classname == 'CCBitmapFontAtlas') {
				for ( var j in l._children) {
					var s = l._children[j];
					s.setColor(ZFColorDefines.colorMenuMutationPurpleDark);
				}
			}
		}

		//info tab inner
		r = CGRectMake(/*300+this._widthOffset*/0, /*44 + 3 + 38+this._heightOffset+(menuHeightOffset*1/3)*/0, 147, 38);
		//        if (resolutionHeight>ZFGameDefines.ORIGINAL_WINDOW_HEIGHT)
		//    	{
		//            r = CGRectMake(300+this._widthOffset, 44 + 3 + 38+this._heightOffset+(menuHeightOffset*1/3) - 134, 147, 38);
		//        }

		var infoInnerTabBg = ZFMenu.makeWindow(r, CGRectMake(37, 40, 11, 11), CGRectMake(49, 40, 11, 11), f,
				ZFColorDefines.colorMenuMutationPurpleLight, CGRectMake(0, 0, 0, 0), CGRectMake(0, 0, 0, 0), CGRectMake(49, 40, 11, 11));

		infoInnerTabBg.setPosition(ccp(300 + this._widthOffset, this._heightOffset - 35 - 175 + 1));

		this._windowNode.addChild(infoInnerTabBg, 0, ZFMutationMenu.mutationMenuMenuTags.kMutationMenuTagInfoTabInnerBG);

		for ( var i in infoInnerTabBg._children) {
			var l = infoInnerTabBg._children[i];

			//[l isKindOfClass:[CCSpriteSheet class]]
			if (l.classname == 'CCSpriteSheet' || l.classname == 'CCTMXLayer' || l.classname == 'CCBitmapFontAtlas') {
				for ( var j in l._children) {
					var s = l._children[j];
					s.setColor(ZFColorDefines.colorMenuMutationPurpleLight);
				}
			}
		}

		//labels
		var required = CCLabel.labelWithString(Core.Localization.getString("Required"), CGSizeMake(124, 40), GL2.Text.HorizontalAlign.Center,
				"Arial-BoldMT", 12);
		required.setColor(ZFColorDefines.colorTextWhite);
		this._windowNode.addChild(required, 5, ZFMutationMenu.mutationMenuMenuTags.kMutationMenuTagLabelRequired);
		required.setPosition(ccp(380 + this._widthOffset, 113 - 2 - this._heightOffset + (menuHeightOffset * 1 / 3)));

		this._required = required;

		var mutationsCollected = CCLabel.labelWithString(Core.Localization.getString("Mutations Collected"), CGSizeMake(130, 40),
				GL2.Text.HorizontalAlign.Center, "Arial-BoldMT", 12);
		mutationsCollected.setColor(ZFColorDefines.colorMenuMutationPurpleLighter);
		this._windowNode.addChild(mutationsCollected, 5, ZFMutationMenu.mutationMenuMenuTags.kMutationMenuTagLabelMutationsCollected);

		var number = CCLabel.labelWithString("3", CGSizeMake(60, 60), GL2.Text.HorizontalAlign.Center, "Arial-BoldMT", 26);
		number.setColor(ZFColorDefines.colorTextBlack);
		this._windowNode.addChild(number, 5, ZFMutationMenu.mutationMenuMenuTags.kMutationMenuTagLabelNumber);
		number.setPosition(ccp(432 + this._widthOffset, 243 - 16 - this._heightOffset/*+(menuHeightOffset*1/3)*/+ 8));

		var mutationsCollectedCount = CCLabel.labelWithString("20/75", CGSizeMake(130, 40), GL2.Text.HorizontalAlign.Right, "Arial-BoldMT", 22);
		mutationsCollectedCount.setColor(ZFColorDefines.colorTextWhite);
		this._windowNode.addChild(mutationsCollectedCount, 5, ZFMutationMenu.mutationMenuMenuTags.kMutationMenuTagLabelMutationsCollectedCount);

		//dismiss
		destroy(this._dismissMenu);

		var dismissItem = CCMenuItemImage.itemFromNormalImage("bigX.png", "bigXSel.png", this, this.dismissMenu.bind(this));
		//dismissItem.setAnchorPoint(ccp(1,1));
		//dismissItem.setPosition(ccp(windowSize.getSize()._width/2, windowSize.getSize()._height/2+16-menuHeightOffset*1/3));

		this._dismissMenu = CCMenu.menuWithItems([ dismissItem ]);
		this._dismissMenu.setPosition(ccp(w._width + this._widthOffset - 20 - dismissItem.getSize()._width / 2, w._height - this._heightOffset - 25
				- 16 - dismissItem.getSize()._height / 2));
		//this._dismissMenu.setPosition(ccp(windowSize.getSize()._width/2, windowSize.getSize()._height/2+16-menuHeightOffset*1/3));
		this._windowNode.addChild(this._dismissMenu, 6);

		//	ccp((w.width+widthOffset) - 20, (w.height+heightOffset) - 20)
		//	this._dismissMenu.alignItemsHorizontallyWithPadding(0);
		this._windowNode.addChild(this._dismissMenu, 100);

		//icon
		var menuIcon = CCSprite.spriteWithFile("iconMutationMenu.png");
		menuIcon.setPosition(ccp(33 + this._widthOffset, 270 - this._heightOffset));
		this._windowNode.addChild(menuIcon, 3, ZFMutationMenu.mutationMenuMenuTags.kMutationMenuTagIcon);

		//banner
		var yDiff = w._height - windowSize.getSize()._height;
		yDiff /= 2;
		this.initBannerWithString(Core.Localization.getString("Mutation Collection"), CGSizeMake(400, 50), 14);
		this._menuTitle.getParent().reorderChild(this._menuTitle, 21);
		this._backgroundSpriteSheet.removeChild(this._menuBanner, false);
		this._windowNode.addChild(this._menuBanner, 20, ZFMutationMenu.mutationMenuMenuTags.kMutationMenuTagBanner);
		this._menuBanner.setPosition(ccpAdd(this._menuBanner.getPosition(), ccp(this._widthOffset, this._heightOffset + 16)));
		this._menuBanner.setScale(1.25, 1.25);
		
		//table
		this.displayMutationTable();
		this.schedule(this.initTableOffset, 0.5);

		var gs = GameState;
		var collectedMutations = 0;

		for ( var i in this._mutationCollectionArray.collection) {
			if (gs._zfGameData._mutationCollectionFlags.hasFlag(i)) {
				collectedMutations++;
			}
		}
		mutationsCollected.setPosition(ccp(383 + this._widthOffset, 65 - this._heightOffset /*+ (menuHeightOffset*1/3)*/+ 8));
		mutationsCollectedCount.setPosition(ccp(412 - 38 + this._widthOffset, 50 - 5 - this._heightOffset + (menuHeightOffset * 1 / 3) + 8));
		mutationsCollectedCount.setString(collectedMutations + "/" + this._mutationCollectionArray.collection.length);
		
	},

	openMenu : function($super) {
		$super();		
		this.refreshTable(this._mutationTable);
	},

	displayMutationTable : function() {
//		console.log("��� display mutation table ");
		this._tableData = [];

		// add all mutations from plist
		var index = 0;
		var gs = GameState;
		for ( var i in this._mutationCollectionArray.collection) {
			var mutationArray = this._mutationCollectionArray.collection[i];
			var locked = true;

			if (gs._zfGameData._mutationCollectionFlags.hasFlag(index)) {
//			if (gs._zfGameData._purchaseFlags.hasFlag(index)) {
				locked = false;
			}

			var dict = {};
			dict['id'] = index;
			dict['array'] = mutationArray;
			dict['locked'] = locked;
			this._tableData.push(dict);
			index++;
		}
		//fill the cells to make the rows even
//		var fillerCells = this._tableData.length % 4;
//		for ( var i = 0; i < fillerCells; i++) {
//			this._tableData.unshift(null);
//		}

		//in sets or 4 reverse each row
//		for ( var i = 0; i < this._tableData.length; i += 4) {
//			var tmp = this._tableData[i + 3];
//			this._tableData[i + 3] = this._tableData[i + 0];
//			this._tableData[i + 0] = tmp;
//
//			tmp = this._tableData[i + 2];
//			this._tableData[i + 2] = this._tableData[i + 1];
//			this._tableData[i + 1] = tmp;
//		}
		//FIXME
		//CGRect mainFrame = [[UIScreen mainScreen] bounds];
		//float resolutionHeight = mainFrame.size.width;
		var resolutionHeight = UI.Window._height;
		var menuHeightOffset = 0;
		var heightScale = 1;
		/*if (resolutionHeight>ZFGameDefines.ORIGINAL_WINDOW_HEIGHT)
		{
			heightScale = (resolutionHeight/320.0)*2/3;
			menuHeightOffset = (219*heightScale-219);
		}*/

		var size = ZFMutationCell.cellSize();
		this._mutationTable = CCMultiColumnTableView.tableViewWithDataSource(this, CGSizeMake(size._width * 4, 219 * heightScale));
		this._mutationTable._dirtyFlag = true;
		this._mutationTable._direction = CCScrollView.CCScrollViewDirection.CCScrollViewDirectionVertical;
		this._mutationTable._tDelegate = this;
		
		this._currentPage = 0;

		this._cellMaxX = 3;
		this._cellMaxY = 2;
		this._cellMax = this._cellMaxX*this._cellMaxY;
		this._cellInterx = 14;
		
		var cell = this.table_cellAtIndex(null, 0);
		this._cellHeight = cell._node.getContentSize()._height;
		this._cellWidth = cell._node.getContentSize()._width;
		var w = CGSizeMake(480, 320);
		this.initBrowseMenuWithPosition( ccp(160, w._height*0.5), this._cellMaxX*this._cellWidth+((this._cellMaxX+1)*this._cellInterx));
		this._backItem.setVisible(false);
		this._browseMenu.setDepth(3);
//		this.displayPage(true);
		this._currentSelectedIndex = 0;
		this._lastCell = cell;
		
//		this._tableBg.addChild(this._mutationTable, 5, ZFMutationMenu.mutationMenuMenuTags.kMutationMenuTagTable);
		
//		this._mutationTable._target.setAnchor(new Core.Point(0, 1));		
//		this._mutationTable.setPosition(ccp(6, 100));
//		this._mutationTable.reloadData();
//		console.log("display mutation: " + this._tableData.length.toString());
//		this._currentSelectedIndex = this._tableData.length - 4;	
	},

	browseForward: function(sender)
	{
		if (this._currentPage >= 4) {
			return;
		}
		
		this._backItem.setVisible(true);
		this.cleanupPage();
		this._currentPage++;
		setTimeout(this.displayPage.bind(this), 300);
		
		if (this._currentPage >= 4) {
			this._forwardItem.setVisible(false);
		}

	},

	browseBackward: function(sender)
	{
		if (this._currentPage <= 0) {
			return;
		}
		
		this._forwardItem.setVisible(true);
		this.cleanupPage();
		this._currentPage--;
		setTimeout(this.displayPage.bind(this), 150);
		
		if (this._currentPage <= 0) {
			this._backItem.setVisible(false);
		}
	},
	
	displayPage: function(targets){
		
		if (!this._scrolled) {console.log("RETURNING"); return;}
		var firstCellIndex = this._currentPage*this._cellMax;
		var lvl = 0;
		
		var length = this._tableData.length;
		
		for(var i = firstCellIndex; (i<(firstCellIndex+this._cellMax)) && (i<length); i++){
			
			if(i == (firstCellIndex+this._cellMaxX))
				lvl = 1;
			
			var cell = this.table_cellAtIndex(null, i);
			if(i == this._currentSelectedIndex){
				cell.pressed();
				this._lastCell = cell;
			}
			this._tableBg._cellNode.addChild(cell._node, 6);
			var y = (3-lvl)*(this._cellHeight);
			var x = this._cellInterx+ (i%this._cellMaxX)*(this._cellWidth+this._cellInterx);
			cell._node.setPosition(ccp(x, y));	
		}
	},
	
	onTouch : function(touch) {
		return;
//		switch (touch.getAction()) {
//		case touch.Action.Start:
//			return this.ccTouchBegan(touch);
//		case touch.Action.End:
//			this.ccTouchEnded(touch);
//			break;
//		case touch.Action.Move:
//			this.ccTouchMoved(touch);
//			break;
//		}
	},
	
	cleanupPage: function() {
		for (var index in this._actors) {
			var actor = this._actors[index];
			if (actor) {
				actor.despawn();
			}
		}
		this._actors.length = 0;
		destroyChildren(this._tableBg._cellNode);
	},
	
	initTableOffset : function() {
		this.unschedule(this.initTableOffset);

		var minsize = this._mutationTable.minContainerOffset();
		this._mutationTable.setContentOffset(ccp(0,/*40+*/minsize._y));
//		console.log(">>>>>>>>>>>>>>>>>>>> initTableOffset");
		if (this._qCell) {
			this.displayCellContents(this._qCell);
			this._qCell.pressed(this);
		}
	},

	refreshTable : function(table) {
		NSNotificationCenter.defaultCenter().postNotificationName(ZFMutationCell.kMutationCellClearSelectorNotification);
		this.refreshActors();
	},

	refreshActors : function() {
		this.unschedule(this.refreshActors);

		for ( var i in this._actors) {
			var actor = this._actors[i];
			actor.unschedule(actor.update);
			actor.schedule(actor.guiActorUpdate);
		}
	},

	table_cellTouched : function(cell) {
//		this.refreshTable(table);
		var i = cell._idx;
		if(!this._lastCell){
			this._lastCell = cell;
		}
		
		else{
			if(this._lastCell == cell)
				return;
			this._lastCell.clearSelector();
			this._lastCell = cell;
			this._currentSelectedIndex = i;
		}
		
//		if(i == this._currentSelectedIndex){
//			return;
//		}
//		
//		var lastCell = this._tableData[this._currentSelectedIndex];
//		lastCell.clearSelector();
		
		this.displayCellContents(cell);
		cell.pressed(this);
	},

	displayCellContents : function(mCell) {
//		console.log(mCell);
		this._windowNode.removeChildByTag(ZFMutationMenu.mutationMenuMenuTags.kMutationMenuTagSpriteRequired1, true);
		this._windowNode.removeChildByTag(ZFMutationMenu.mutationMenuMenuTags.kMutationMenuTagSpriteRequired2, true);
		this._windowNode.removeChildByTag(ZFMutationMenu.mutationMenuMenuTags.kMutationMenuTagSpriteRequired3, true);
		this._windowNode.removeChildByTag(ZFMutationMenu.mutationMenuMenuTags.kMutationMenuTagSpriteRequired4, true);
		this._windowNode.removeChildByTag(ZFMutationMenu.mutationMenuMenuTags.kMutationMenuTagSpriteRequired5, true);

		var wSize = CCDirector.winSize();

		//FIXME
		//CGRect mainFrame = [[UIScreen mainScreen] bounds];
		//float resolutionHeight = mainFrame.size.width;
		//var resolutionHeight = UI.Window._height;
		var menuHeightOffset = 0;
		var heightScale = 1;
		/*if (resolutionHeight>ZFGameDefines.ORIGINAL_WINDOW_HEIGHT)
		{
			heightScale = (resolutionHeight/320.0)*2/3;
			menuHeightOffset = (resolutionHeight-320*heightScale)/2;
		}*/

		var number = this._windowNode.getChildByTag(ZFMutationMenu.mutationMenuMenuTags.kMutationMenuTagLabelNumber);
		var numberToDisplay = mCell._cellID + 1;
		number.setString("" + numberToDisplay);

		if (this._selectedActor) {
			this._selectedActor.despawn();
		}
		var point = ccpAdd(ccp(330 + this._widthOffset, 138 - this._heightOffset), ccp(44, 0/*25*/));
		this._selectedActor = ZFActorManager.spawnGUIActor_withClass_atPoint_withTarget("ZombieActorRegularTier1", point, this._windowNode);
		this._selectedActor._spriteMan.setScale(0.9, 0.9);
		this._selectedActor.addMutation(mCell._cellActor._flags);

		var locked = true;

		for ( var i in this._tableData) {
			var d = this._tableData[i];
			var idNum = d["id"];

			if (idNum == mCell._cellID) {
				locked = d["locked"];
				var array = d["array"];

				for ( var i in array) {
					var num = array[i];
					i = parseInt(i);
					var zm = ZFZombieMenu.zombieMenu();
					var flag = (1 << num);
					var sprite = CCSprite.spriteWithFile(zm.fileForMutation(flag));
					sprite.setScale(0.6, 0.6);

					sprite
							.setPosition(ccp(330 + this._widthOffset + (i * 21) + 10, wSize._height / 2 - 30 - 21/* +UI.Window._height-320 */));

					this._windowNode.addChild(sprite, 5, ZFMutationMenu.mutationMenuMenuTags.kMutationMenuTagSpriteRequired1 + i);
				}

				break;
			}
		}

		if (locked) {
			this.darkenActor(this._selectedActor);
		}
	},

	darkenActor : function(z) {
		for ( var key in z._attachments) {
			var a = z._attachments[key];
			if (a == null) {
				continue;
			}

			a._sprite.setColor(ccc3(0, 0, 0));
		}
	},

	cellClassForTable : function(table) {
		return ZFMutationCell;
	},

	table_cellAtIndex : function(table, idx) {
		var cell = null;
		if (idx >= this._tableData.length) {
			return cell;
		}

		var element = this._tableData[idx];

		if (!cell) {
			cell = new ZFMutationCell(this.table_cellTouched.bind(this));
			cell._idx = idx;
		}
		if (cell._node == null) {
			if (element == null) {
				var ini1 = Core.Time.getRealTime();
				var cellSize = ZFMutationCell.cellSize();

				cell._node = CCColorLayer.layerWithColor(ccc3(0, 0, 0), cellSize._width, cellSize._height);
			} else {
				var oldID = cell._cellID;

				var dict = element;
				cell.setCellID(dict["id"]);
				cell._node = cell._bg;
				if (oldID != cell._cellID) {
					var ini5 = Core.Time.getRealTime();
					var array = dict["array"];
					var mutaFlags = 0;

					for ( var i in array) {
						mutaFlags |= (1 << array[i]);
					}

					cell._node = cell._bg;

					if (cell._cellActor) {
						this._actors.splice(this._actors.indexOf(cell._cellActor), 1);
						cell._cellActor.despawn();
					}
					cell._cellActor = ZFActorManager.spawnGUIActor_withClass_atPoint_withTarget("ZombieActorRegularTier1", ccp(32, -58 - this._heightOffset * 2), cell._bg);
					var scale = cell._cellActor._spriteMan.getScale();
					cell._cellActor._spriteMan.setScale(scale._x * 0.75, scale._y * 0.75);
					cell._cellActor.addMutation(mutaFlags);
					this._actors.push(cell._cellActor);
					// we need to delay refresh because the cell needs a parent for the actor's update scehduler to work
					if (!this.isScheduled(this.refreshActors)) {
						this.schedule(this.refreshActors, 0.25);
					}

					if (dict["locked"] == true) {
						this.darkenActor(cell._cellActor);
					}
				}
			}
		}
		if (idx == this._currentSelectedIndex) {
			this._qCell = cell;
		}
		return cell;
	},

	numberOfCellsInTableView : function(table) {
		return this._tableData.length;
	},

	getMenuOffset : function() {
		return ccp(0, -43);
	},

	dismissTimerCallback : function($super) {
		if (this._selectedActor) {
			this._selectedActor.despawn();
			this._selectedActor = null;
		}

		for (var index in this._actors) {
			var actor = this._actors[index];
			if (actor) {
				actor.despawn();
			}
		}
		this._actors.length = 0;
		this._actors = null;

		this._tableData = [];

		for ( var i = ZFMenu.kZFMenuTags.kMenuTagMAX; i < ZFMutationMenu.mutationMenuMenuTags.kMutationMenuTagMAX; i++) {
			this._windowNode.removeChildByTag(i, true);
		}

		this._mutationTable._tDelegate = null;
		this._windowNode.removeChild(this._mutationTable, false);
		destroy(this._mutationTable);
		this._mutationTable = null;

		NSNotificationCenter.defaultCenter().postNotificationName(ZFGameDefines.kEnableInGameMenusNotification, null);
		this._scrolled = false;
		$super();
	}
	});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/ZFMenus/Zombie/ZFZombieMenu'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Zombie/ZFZombieMenu'] || {}; $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Zombie/ZFZombieMenu'] = exports; var ZFAbilityCell = require('Code/Game/GUI/ZFMenus/Zombie/ZFAbilityCell').ZFAbilityCell;

exports.ZFZombieMenu = ZFMenu.singleton(
{
	classname : 'ZFZombieMenu',
	
	TAG_DELETE_ACTOR : 1,
	
	$zombieMenu: function() 
	{ 
		return this; 
	},
	

	kZombieTags:
	{
		kZombieSleep: 1,
		kZombieWakeUp:2
	},
	
	$kZombieMenuTags:
	{
		kZombieMenuTagDismiss 				: 3,
		kZombieMenuTagBGMgr					: 4,
		kZombieMenuTagSelectedZombie		: 5,
		kZombieMenuTagNextZombie			: 6,
		kZombieMenuTagBrickOverlay1			: 7,
		kZombieMenuTagBrickOverlay2			: 8,
		kZombieMenuTagBrickOverlay3			: 9,
		kZombieMenuTagGrassOverlay1			: 10,
		kZombieMenuTagGrassOverlay2			: 11,
		kZombieMenuTagGrassOverlay3			: 12,
		kZombieMenuTagGrass					: 13,
		kZombieMenuTagStatTab				: 14,
		kZombieMenuTagAbilityTab			: 15,
		kZombieMenuTagStatWindow			: 16,
		kZombieMenuTagStatLayer				: 17,
		kZombieMenuTagAbilitiesLayer		: 18,
		kZombieMenuTagAbilityDisplay		: 19,
		kZombieMenuTagHungerLayer			: 20,
		kZombieMenuTagBanner				: 21,
		kZombieMenuTagTransitionLayer		: 22,
		kZombieMenuTagShowFarmZombiesMenu	: 23,
		kZombieMenuTagShowFarmZombiesLabel	: 24,
		kZombieMenuTagPageCountColorLayerLabel:25
	},
	
	initialize: function()
	{
//		var screenWidth = 480;
//		self.position = ccp(screenWidth, 0);
		this._currentZombie = null;
		this._statsLabel = null;
		this._currentPage = 0;
		// browseable therefore needs max pages var
		this._maxMenuPages = 1;
		this._abilityTable = null;
		this._openingMenuThroughMausoleum = false;
		
		this._resolutionWidth = this._bounds._height;
		this._resolutionHeight = this._bounds._width;
		this._widthOffset =  (this._resolutionHeight  - 480) / 2;
		this._heightOffset = -(this._resolutionWidth - 320) / 2;
		
		// Save these values for use eslewhere
		this._widthScale = 1;
		
		this._windowNode.setScale(CCDirector.zoomValue());
		if(CCDirector.zoomValue()._x > 1.0)
			this._windowNode.setPosition(new Core.Point(-this._windowNode.getSize()._width*1/8, -this._windowNode.getSize()._height* 1/8));
	},
	
	initElements: function($super)
	{
//		CGPoint ptOffset = CGPointMake(widthOffset, heightOffset);
		var ptOffset = ccp(this._widthOffset, this._heightOffset);
		
		// RECTANGLES FOR TILES
		var c;			//corner
		var bc;			//bottom corner
		var b;			//bar
		var bb;			//bottom bar
		var s;			//side
		var windowSize;	//window size
		var viewingAbilities = false;
		
		// HUDELEMENTS FILE
		var f = "hudElements.png";
		
		// build brick layer 
		
		$super();
		this.cleanWindow(this.kZFMenuTags.kZFMenuTagBackground);
		
		
		var w = CGSizeMake(480, 320);
		
//		float winWidth = WINDOW_WIDTH;
//		if (winWidth>ORIGINAL_WINDOW_WIDTH)
//		{
//			[dimLayer changeWidth: 2*winWidth];
//			dimLayer.position = CGPointMake(-winWidth, 0);
//			if(!dimLayer.parent)
//			{
//				[self addChild:dimLayer z:1000];
//				[[CCTouchDispatcher sharedDispatcher] addTargetedDelegate:dimLayer priority:90 swallowsTouches:YES];
//			}
//		}
	//	
//		//////////////////// BG STUFF ////////////////////
		windowSize = CGRectMake(0, 0, (w._width*0.34 + 2) * this._widthScale, w._height);
		
		c = CGRectMake(172, 74, 41, 41);
		bc = CGRectMake(214, 74, 41, 41);
		b = CGRectMake(118,28,26,26);
		s = CGRectMake(145,28,26,26);

		
		var grassOverlay1 = ZFMenu.makeWindowOld( windowSize, c, b, f, ZFColorDefines.colorPaper , bc, b, s);
		
		var color = ZFColorDefines.colorSoil;
		color._a = 0;
		
		color._a = 255;
		windowSize = CGRectMake(0,0, (w._width * 0.67) * this._widthScale, w._height*0.7+25);
		
		grassOverlay2 = ZFMenu.makeWindowOld(windowSize, c, b, f, color, bc, b, s);
	
		windowSize = CGRectMake(0,0, (w._width*0.67)*this._widthScale, w._height*0.4);
		color = ZFColorDefines.colorPaper;
		
		var grassOverlay3 = ZFMenu.makeWindowOld(windowSize, c, b, f, color, bc, b, s);
//		//paper panel
		this._cl1 = CCColorLayer.layerWithColor(ZFColorDefines.colorPaper, w._width*0.34*this._widthScale, 320);
		this._cl1.setPosition(ccpAdd(ptOffset, ccp(0, -this._heightOffset*2 + 160)));

		//divider  - TODO: What is that?!
//		b = CGRectMake(237,1,12,3);
//		ccColor3B colr = ccc3(0xdf,0xcf,0x8f);
//		CCLayer *div1 = [ZFMenu makeDividerwithSize:70.f*widthScale bar:b file:f color:colr];
//		div1.position = ccp(45, w.height*60/100);
	//	
//		for(CCSprite *sp in div1.children)
//		{
//			sp.opacity = 0x30;
//		}
	//	
		this._windowNode.addChild(this._cl1, 2, 0);
//		[self addChild:div1 z:3 tag:0];
		this._windowNode.addChild(grassOverlay1, 3, this.kZombieMenuTags.kZombieMenuTagGrassOverlay1);
		this._windowNode.addChild(grassOverlay2, 3, this.kZombieMenuTags.kZombieMenuTagGrassOverlay2);
		this._windowNode.addChild(grassOverlay3, 1, this.kZombieMenuTags.kZombieMenuTagGrassOverlay3);
	//	
		grassOverlay1.setPosition(ptOffset);
		grassOverlay2.setPosition(ccpAdd(ptOffset, ccp(w._width * 0.34, 0)));
		grassOverlay3.setPosition(ccpAdd(ptOffset, ccp(w._width * 0.34, -w._height*0.6)));
		
//		// BRICK BG 
//		windowSize = CGRectMake(0, w.height, (((int)w.width*34/100)+2)*widthScale, w.height);//w.height*70/100+25);CGRectMake(0, w.height, w.width*33/100, w.height*70/100+25);
//		//windowSize = CGRectMake(0,w.height, 480,320);
//		c = CGRectMake(172, 32, 41, 41);
//		bc = CGRectMake(214, 32, 41, 41);
	//	
//		b = CGRectMake(131,1,26,26);
//		bb = CGRectMake(104,1,26,26);
//		s = CGRectMake(158,1,26,26);
	//	
//		color = ccc4(0x25,0x1f,0x15,0x0);//322021 331f00
//		CCLayer *brickOverlay1 = [ZFMenu makeWindow:windowSize 
//											 corner:c 
//												bar:b 
//											   file:f 
//											  color:color 
//											bcorner:bc 
//											   bbar:b // using the same bar rectangle so that it won't orient it upside down 
//											   side:s];	
	//	
//		color = ccc4(0x25,0x1f,0x15,0xFF);
//		windowSize = CGRectMake(((int)w.width*34/100), w.height, ((int)w.width*67/100)*widthScale, ((int)w.height*70/100)+25);
//		CCLayer *brickOverlay2 = [ZFMenu makeWindow:windowSize 
//											 corner:c 
//												bar:b 
//											   file:f 
//											  color:color 
//											bcorner:bc 
//											   bbar:b 
//											   side:s];
	//	
//		windowSize = CGRectMake(((int)w.width*34/100), ((int)w.height*40/100), ((int)w.width*67/100)*widthScale, ((int)w.height*40/100));
//		CCLayer *brickOverlay3 = [ZFMenu makeWindow:windowSize 
//											 corner:c 
//												bar:b 
//											   file:f 
//											  color:color 
//											bcorner:bc 
//											   bbar:b 
//											   side:s];
//		
	//	
//		[self addChild:brickOverlay1 z:3 tag:kZombieMenuTagBrickOverlay1];
//		[self addChild:brickOverlay2 z:3 tag:kZombieMenuTagBrickOverlay2];
//		[self addChild:brickOverlay3 z:1 tag:kZombieMenuTagBrickOverlay3];
	//	
//		brickOverlay1.position = ptOffset;
//		brickOverlay2.position = ptOffset;
//		brickOverlay3.position = ptOffset;
		
		//////////// END BG STUFF /////////////////
	
//		//////////// STAT WINDOW (z-order of 4 minimum) //////////////////
//		// CGRectMake(x value, y value, width, height) //
	//	
		windowSize = CGRectMake(0, 0, w._width * 0.54, w._height *0.5);	
		var cornerSize = CGRectMake(250,1,5,5);
		var barSize	  = CGRectMake(237,1,12,4);
	
		color = ZFColorDefines.colorPaper;

		var statOverlay = ZFMenu.makeWindowOld(windowSize, cornerSize, barSize, f, color);
//		for (CCNode *statOverlayChild in statOverlay.children)
//		{
//			if ([statOverlayChild isKindOfClass:[CCSpriteSheet class]])
//			{
//				for (CCSprite *CCSpriteSheetChild in statOverlayChild.children)
//				{
//					CCSpriteSheetChild.color = colorPaper;//ccc3(0xdf,0xcf, 0x88);
//				}
//			}
//		}
		
		statOverlay.setPosition(ccp(w._width*0.41 + this._widthOffset, this._heightOffset - 50 ));
		this._windowNode.addChild(statOverlay, 40, this.kZombieMenuTags.kZombieMenuTagStatWindow);
		
		
		this.initZombieInfo();
//		///////////// END STAT WINDOW ///////////////
		
		this.initZombieList();
		
		if ( !this._zombieList || this._zombieList.length <= 0 )
		{
			return;
		}

		else if( !this._currentZombie ) // if there is no current zombie 
		{
			this._currentZombie = this._zombieList[ 0 ];
		}
		
		if( this._currentZombie )
		{
			var i;
			var length = this._zombieList.length;
			for( i = 0 ; i < length ; i++ )
			{
				if ( this._currentZombie == this._zombieList[ i ] )
				{
					this._currentPage = i;
					break;
				}
			}
		}
		
		this.initLowerMenu();
		this.initBrowseMenuWithPosition( ccp(80, w._height*0.5), 1*(160-25));
		this._browseMenu.setDepth(3);
		
		this._dimLayer.setVisible(false);
	},
	
	initLowerMenu: function()
	{
		var f = "hudElements.png";
		var w = CGSizeMake(480, 320);
		
		
		
		var sprite1 = CCSprite.spriteWithFile("deleteButton.png");
		var sprite2 = CCSprite.spriteWithFile("deleteButton.png");		
		sprite2.setColor(ccc3(128, 128, 128));
		this._sellZombieButton = new CCMenuItemImage();
		this._sellZombieButton.initFromNormalSprite(sprite1, sprite2, this, this.sellZombieButtonTapped.bind(this));
			
		// toggle between mausoleum view and zombie info view //

		var s1a = CCSprite.spriteWithFile(f, CGRectMake(1, 253, 180, 54));
//		var s2a = CCSprite.spriteWithFile(f, CGRectMake(182, 253, 180, 54));
		var s1b = CCSprite.spriteWithFile(f, CGRectMake(1, 253, 180, 54));
//		var s2b = CCSprite.spriteWithFile(f, CGRectMake(182, 253, 180, 54));
	
		
//		s1a.flipX = s1b.flipX = YES;
		
		s1a.setColor(ZFColorDefines.colorBrownButton);
		s1b.setColor(ZFColorDefines.colorBrownButton);
//		s2a.setColor(ZFColorDefines.colorBrownButton);
//		s2b.setColor(ZFColorDefines.colorBrownButton);

		this._mausoleumButton = CCMenuItemImage.itemFromNormalSprite(s1a, s1b, this, this.toggleWindowButtonTapped.bind(this));
		this._mausoleumButton.setScale(0.8, 0.8);
//		FIXME: Uncomment this line for mausoleum
		this._menu = CCMenu.menuWithItems([this._mausoleumButton, this._sellZombieButton]);
		this._menu.alignItemsHorizontallyWithPadding(50);
		this._sellZombieButton.setScale(0.7);
		
		var offsetX = 90  + this._sellZombieButton.getSize()._width*0.8/2;
		var offsetY = this._sellZombieButton.getSize()._height*0.8/2 - 3;
		this._menu.setPosition(ccp(w._width*0.68 + this._widthOffset - offsetX/2, w._height * 0.14 + 3 - this._heightOffset - offsetY));
//		FIXME: Comment this line for mausoleum
//		this._menu.setPosition(this._menu.getPosition()._x + this._mausoleumButton.getSize()._width/2, this._menu.getPosition()._y );
	
		
		this._windowNode.addChild(this._menu, 5); //default depth 2
				
		var tmp = this._mausoleumButton.getSize();
		this._lowerMenuLabel1 = CCLabel.labelWithString(NSLocalizedString("Mausoleum"), tmp, GL2.Text.HorizontalAlign.Center, "AmericanTypewriter-Bold", 14);
		this._lowerMenuLabel1.setColor(ccc3(0,0,0));
		this._lowerMenuLabel1.setPosition(tmp._width*0.8/2, tmp._height/2);
		this._mausoleumButton.addChild(this._lowerMenuLabel1, 2);
		
		//FIXME: Uncomment this line for mausoleum
		this._mausoleumButton._touchTarget.setScale(new Core.Vector(0.8, 1.0));
		this._sellZombieButton._touchTarget.setPosition(ccpAdd(this._sellZombieButton.getPosition(), ccp(0, -40)));
	},
	
	sellZombieButtonTapped: function(sender)
	{

		if ( !this._mausoleumButton.isEnabled )
			return;
		
		this._sellZombieButton.isEnabled = false;
		
		var acm = ZFActorManager;
		var market = ZFMarketMenu;
		var baseSaleValue = ZFGameDefines.PLOW_COST;
		var trueSaleValue = baseSaleValue + market.costFromName(this._currentZombie.classname);
		
		var zType = market.nameFromUnitKey(this._currentZombie.classname);
		
		var aw = ZFGuiLayer.displayAlertSimpleChoice( NSLocalizedString("Sell Zombie"), sprintf("Are you sure you want to sell %@ the %@ for %ig?", this._currentZombie._name, NSLocalizedString(zType), trueSaleValue),
						CCSprite.spriteWithFile("male.png"));

		aw._delegate = this;
		aw._idTag = this.TAG_DELETE_ACTOR;
		aw._data = this._currentZombie;
		var w = CGSizeMake(480, 320);
	
//		//////////////////////// SHIKAKA : TESTING ZOMBIE ACTOR IN SELL WINDOW
//		[aw.image.parent removeChild:aw.image cleanup:YES];
//		ZombieActor *zombieGuiActor = (ZombieActor*)[acm spawnGUIActor:[currentZombie class] 
//															   atPoint:ccp(84+widthOffset, ((int) w.height*55/100)+heightOffset) 
//																target:aw];	
//		[zombieGuiActor addMutation:currentZombie.flags];
//		zombieGuiActor.savedColor = currentZombie.savedColor;
//		zombieGuiActor.spriteMan.scale *= 1.25;
//		[zombieGuiActor resetColor];
//		zombieGuiActor.tag = kAlertWindowTagZombie;
//		////////////////////////
	},
	
	//
	toggleWindowButtonTapped: function(sender)
	{	
		if (ZFMausoleumMenu._menuState != this.menuStates.menuStateClosed)	//can be tapped while mausoleum isn't closed yet
		{
			return;
		}
		
		var gui = ZFGuiLayer.gui();
		var sm = ZFStorageMenu;
		
		var message = null;
		if (!sm.doesOwnItem("mausoleum1") && !sm.doesOwnItem("mausoleum2") && !sm.doesOwnItem("mausoleum3"))
		{
			message = NSLocalizedString("You do not own a Mausoleum", null);
			
		}
		else if (!(GameState._zfGameData._mausoleumFlags & ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM_UNLOCKED))
		{
			message = NSLocalizedString("Your Mausoleum is locked");
		}
		
		if (message)
		{
			ZFGuiLayer.displayToolTip(message, 1.5);
			return;
		}
		
		if(this._dimLayer){
			if(this._dimLayer.getParent())
				this._dimLayer.getParent().removeChild(this._dimLayer);
			destroyWithChildren(this._dimLayer);
			this._dimLayer = null;
		}
		
		ZFMausoleumMenu.openMenu();
		this._mausoleumButton.isEnabled = false;
	//	
//		[[EventTracker eventTracker] sendEvent:@"zf_army_sel_mausoleum" withParameters:nil andDelegate:nil];
	},
	
	
	openMenu: function()
	{
	    BackButtonHandler.push(this);
	    
		ZFGuiLayer.disableMenus();
		ZFGuiLayer.removeToolTip();
		this.setVisible(true);
		
		this.initElements();
		
		if (!this._zombieList || this._zombieList.length <= 0)
		{
			if(ZFMausoleumMenu.containsZombie()){
				ZFMausoleumMenu.openMenu();
			}
			else {
				this.noZombieMessage();
			}
			
			this.dismissMenu(this);
			return;
		}
	
		this.schedule(this.openTimerCallback, this.showEntireMenu(this));
		this.displayPage();
		SimpleAudioEngine.playEffect(kMenuOpenSFX);		
	},
	
	openTimerCallback: function()
	{
		this.unschedule(this.openTimerCallback);
		this._menuState = ZFMenu.menuStates.menuStateOpen;
		this.enableMenus();

		ZFGuiLayer.disableMenus();
	},
	
	showEntireMenu: function(sender)
	{
		var actionTo = null;
		var ret = 0.5;
		
		if (sender == this)
		{
			var move1 = CCMoveTo.actionWithDuration(0.25, this.openPos());
			var move2 = CCMoveTo.actionWithDuration(0.25, ccpAdd(this.openPos(), ccp(50, 0)));
			var move3 = CCMoveTo.actionWithDuration(0.25, this.openPos());
			
			 actionTo = CCSequence.actions([move1, move2, move3]);
			
			ret = .45;
		}
		else 
		{
			var delay = CCDelayTime.actionWithDuration(0.075);
//			var move1 = CCMoveTo.actionWithDuration(0.3, ccpAdd( this.slideOutPosition(), ccp( 50, 0 ) ) );
			var move2 = CCMoveTo.actionWithDuration(0.25, this.openPos());
			var move3 = CCMoveTo.actionWithDuration(0.25, ccpAdd(this.openPos(), ccp(25, 0)));
			var move4 = CCMoveTo.actionWithDuration(0.25, this.openPos());
			
			
			actionTo = CCSequence.actions(delay/*, move1*/, move2, move3, move4);
			
			ret = .65;
		}
		
		this.runAction(actionTo);
		
		
		this._menuState = ZFMenu.menuStates.menuStateOpening;
		this._mausoleumButton.isEnabled = true;
		
		return ret;
	},
	
	displayPage: function()
	{	
//		console.log( this._zombieList );
		
		var w = CGSizeMake(480, 320);
		
		if( this._currentPage >= 0 && this._currentPage < this._zombieList.length )
		{
//			this._currentPage = this._currentPage;
			this._currentZombie = this._zombieList[this._currentPage];
		}

		if( !this._currentZombie )
		{
			this.hidePanel();
			return;
		}
		
		this.displayCurrentZombie();
		
		
		//	
//			CCLayer *brick1 = (CCLayer *)[self getChildByTag:kZombieMenuTagBrickOverlay1];	
//			CCLayer *brick2 = (CCLayer *)[self getChildByTag:kZombieMenuTagBrickOverlay2];
//			CCLayer *brick3 = (CCLayer *)[self getChildByTag:kZombieMenuTagBrickOverlay3];
//			CCLayer *grass1 = (CCLayer *)[self getChildByTag:kZombieMenuTagGrassOverlay1];
//			CCLayer *grass2 = (CCLayer *)[self getChildByTag:kZombieMenuTagGrassOverlay2];
//			CCLayer *grass3 = (CCLayer *)[self getChildByTag:kZombieMenuTagGrassOverlay3];
		//	
//			grass1.visible = grass2.visible = grass3.visible = [self isCurrentZombieActive];
//			brick1.visible = brick2.visible = brick3.visible = ![self isCurrentZombieActive];
		//	
			if (this.isCurrentZombieActive())
			{
				this._forwardItem.setVisible(this._currentPage != this._zombieList.length-1);
				this._forwardItem.setIsEnabled(this._currentPage != this._zombieList.length-1);
				this._backItem.setVisible(this._currentPage != 0);
				this._backItem.setIsEnabled(this._currentPage != 0);
//		
				var text = this._currentPage+1 + " / " + this._zombieList.length;
//				
				if (this._pageCount)
				{
					destroyWithChildren(this._pageCount);
					this._windowNode.removeChildByTag(this.kZombieMenuTags.kZombieMenuTagPageCountColorLayerLabel, true);
					this._windowNode.removeChild(this._pageCount, true);
				}
				var pcolor = ccc3(0,0,0);
				var cl = CCColorLayer.layerWithColor(pcolor, w._width * 0.34, 50);
				cl.setOpacity(0x80);
				this._pageCount = CCLabel.labelWithString(text, "Arial-BoldMT", 15);
				cl.setPosition(ccp(this._widthOffset, 25 - this._heightOffset));
				this._pageCount.setPosition(ccp(80,15));
				this._windowNode.addChild(cl, 2, this.kZombieMenuTags.kZombieMenuTagPageCountColorLayerLabel);
				cl.addChild(this._pageCount, 2);
			}
			else 
			{
				this._forwardItem.setVisible(false);
				this._forwardItem.setIsEnabled(false);
				this._backItem.setVisible(false);
				this._backItem.setIsEnabled(false);
			}
			
			if (this._menuState == ZFMenu.menuStates.menuStateHalfClosed)
			{
				this.showPanel();
			}
	},
		
	openMenuThroughMausoleum : function()
	{
		var gui = ZFGuiLayer.gui();
		
		if (this._visible == false) //if this menu hasnt already been init'ed
		{
			this.initElements();
			gui.removeToolTip();
			this.setVisible(true);
		}
		
		this._openingMenuThroughMausoleum = true;
		
		if (this._zombieList.length > 0)
		{
			this.showPanel();		
			this.schedule(this.openTimerCallback, 0.25);		//to enable menu the first time it's opened
			this._currentPage = -1;
			this.displayPage();
		}
		else 
		{
			this.hidePanel();
		}
		
		SimpleAudioEngine.playEffect(kMenuOpenSFX);
		this._openingMenuThroughMausoleum = false;		
	},
	
	
	initZombieList: function()
	{
		var acm = ZFActorManager;
			
		this._zombieList = [];
		
		for( var i in acm._actorList )
		{
			var z = acm._actorList[i];
		
			if( z == null || z.classname.indexOf( "ZombieActor" ) < 0 )
			{
				continue;
			}
			
			this._zombieList.push(z);			
		}
	},
	
	//#pragma mark -
	//#pragma mark zombie Info
	//
	initZombieInfo: function()
	{
		var f = "hudElements.png";
		var w = CGSizeMake(480, 320);
	
		//banner
		var banner = CCSprite.spriteWithFile(f, CGRectMake(144, 376, 200, 47), ccp(0.5,0.5));
		banner.setScale(0.75);
		banner.setPosition(ccp(160 / 2 + this._widthOffset , w._height*0.9 - this._heightOffset ));
		this._windowNode.addChild(banner, 13, this.kZombieMenuTags.kZombieMenuTagBanner);
		
		//labels
		var fontName = "Arial";
		var fontsize = 10;
		
		var y = -this._heightOffset;

		//That was commented in original code...
//		this._typeLabel = CCLabel.labelWithString(NSLocalizedString("Type:"), new Core.Size(140, 30), GL2.Text.HorizontalAlign.Left, fontName, fontsize);
//		this._typeLabel.setColor(ZFColorDefines.colorTextAsh);
//		this._typeLabel.setPosition(ccp(100 + this._widthOffset, w._height*0.4+y));
//		this.addChild(this._typeLabel, 4);
//		
		this._statusLabel = CCLabel.labelWithString(NSLocalizedString("Status:"), new Core.Size(140, 30), GL2.Text.HorizontalAlign.Left, fontName, fontsize);
		this._statusLabel.setColor(ZFColorDefines.colorTextAsh);
		this._statusLabel.setPosition(ccp(100 + this._widthOffset, w._height*0.35+y));
		this._windowNode.addChild(this._statusLabel, 4);
		
		this._invasionsLabel = CCLabel.labelWithString(NSLocalizedString("Invasions:"), new Core.Size(140, 30), GL2.Text.HorizontalAlign.Left, fontName, fontsize);
		this._invasionsLabel.setColor(ZFColorDefines.colorTextAsh);
		this._invasionsLabel.setPosition(ccp(100 + this._widthOffset, w._height*0.3+y));
		this._windowNode.addChild(this._invasionsLabel, 4);

		this._hungerLabel = CCLabel.labelWithString(NSLocalizedString("Hunger")+":", new Core.Size(80, 30), GL2.Text.HorizontalAlign.Center, fontName, fontsize);
		this._hungerLabel.setColor(ZFColorDefines.colorTextAsh);
		this._hungerLabel.setPosition(ccp(83 + this._widthOffset, w._height*0.25+y));
		this._windowNode.addChild(this._hungerLabel, 4);

	},
	
	hidePanel: function()
	{
//		return;
		// TODO : Remove hardcode by injecting the dynamic resolution.
//		var w = new Core.Size( 480, 320 );
		
		var w = CCDirector.winSize();
		
		var actionTo = CCMoveTo.actionWithDuration( 0.2 , ccp( w._width + 10 + this._widthOffset, 0 ) );
		this.runAction( actionTo );
		this._menuState = this.menuStates.menuStateHalfClosing;
		this.schedule( this.slideDone , 0.2 );
		
		if(this._dimLayer){
			if(this._dimLayer.getParent())
				this._dimLayer.getParent().removeChild(this._dimLayer);
			destroyWithChildren(this._dimLayer);
			this._dimLayer = null;
		}
	},
	
	showPanel: function()
	{
		
		var actionTo = CCMoveTo.actionWithDuration( 0 , this.slideOutPosition() );
		this.runAction( actionTo );
		this._menuState = this.menuStates.menuStateHalfOpening;
		this.schedule( this.slideDone , 0.2 );
	},
	
	slideDone: function(sender)
	{
		this.unschedule( this.slideDone );
		
		if ( this._menuState == this.menuStates.menuStateHalfClosing )
		{
			this._menuState = this.menuStates.menuStateHalfClosed;
		}
		else
		{
			this._menuState = this.menuStates.menuStateHalfOpen;
		}
	},
	
	slideOutPosition: function()
	{
//		CGRect mainFrame = [[UIScreen mainScreen] bounds];
//		float resolutionWidth = mainFrame.size.height;
		var menuWidthOffset = 0;
//		if (resolutionWidth>ORIGINAL_WINDOW_WIDTH)
//		{
			menuWidthOffset = this._widthOffset;
//		}
		return ccp(320+menuWidthOffset,0);
	},
	
	displayCurrentZombie: function()
	{
		if (!this._currentZombie)
		{
			return;
		}
	
		this.cleanupSelectedZombieGuiActor();
		this.spawnSelectedZombieGuiActor();
	
		this.cleanRightMenu();
		this.initRightMenu();
	
		this.cleanStatDisplay();
		this.initStatDisplay();
	
		this.cleanAbilityDisplay();
		this.initAbilitiesDisplay();
	
		this.cleanHunger();
		this.displayHunger();
		
		this.updateSelectedZombieInfo();
	},
	
	updateSelectedZombieInfo: function()
	{
		var fontName = "Arial-BoldMT";
		var fontsize = 10;
		var w = CGSizeMake(480, 320);
	
//		console.log("����");
//		console.log(this._currentZombie);
			
		var text = this._currentZombie._name;
		if (this._nameLabel)
		{
			destroyWithChildren(this._nameLabel);
			this._windowNode.removeChild(this._nameLabel);
		}
		
		this._nameLabel = CCLabel.labelWithString(text,CGSizeMake(200, 50), GL2.Text.VerticalAlign.Middle, "AmericanTypewriter-Bold", 18);
		this._windowNode.addChild(this._nameLabel, 14);
		this._nameLabel.setColor(ZFColorDefines.colorTextAsh);
		this._nameLabel.setPosition(ccp(160 / 2 + this._widthOffset, w._height*0.9 - this._heightOffset));

		text = NSLocalizedString(ZFMarketMenu.theMarket().nameFromUnitKey(this._currentZombie.classname));
		
		if (this._typeValLabel)
		{
			destroyWithChildren(this._typeValLabel);
			this._windowNode.removeChild(this._typeValLabel);
		}
		
		this._typeValLabel = CCLabel.labelWithString(text, new Core.Size(140, 30), GL2.Text.HorizontalAlign.Center, fontName, fontsize);
		this._windowNode.addChild(this._typeValLabel, 4);
		this._typeValLabel.setColor(ZFColorDefines.colorTextAsh);
		this._typeValLabel.setPosition(ccp(80 + this._widthOffset, w._height*0.41 - this._heightOffset));
		
		text = this.isCurrentZombieActive() ? NSLocalizedString("On Farm") : NSLocalizedString("Mausoleum");
	
		if (this._statusValLabel)
		{
			destroyWithChildren(this._statusValLabel);
			this._windowNode.removeChild(this._statusValLabel);
		}
		
		this._statusValLabel = CCLabel.labelWithString(text, new Core.Size(140, 30), GL2.Text.HorizontalAlign.Right, fontName, fontsize);
		this._windowNode.addChild(this._statusValLabel, 4);
		this._statusValLabel.setColor(ZFColorDefines.colorTextAsh);
		this._statusValLabel.setPosition(ccp(58 + this._widthOffset, this._statusLabel.getPosition()._y));
		
		text = this._currentZombie._fights.toString();
	
		if (this._invasionsValLabel)
		{
			destroyWithChildren(this._invasionsValLabel);
			this._windowNode.removeChild(this._invasionsValLabel);
		}
		
		this._invasionsValLabel = CCLabel.labelWithString(text, new Core.Size(140, 30), GL2.Text.HorizontalAlign.Right, fontName, fontsize);
		this._windowNode.addChild(this._invasionsValLabel, 4);
		this._invasionsValLabel.setColor(ZFColorDefines.colorTextAsh);
		this._invasionsValLabel.setPosition(ccp(58 + this._widthOffset, this._invasionsLabel.getPosition()._y));
		
		//text = "Master";
		var rank = this._currentZombie.getRank();
		text = (rank > 0) ? ((rank == ZFGameDefines.ZOMBIE_RANK_CAP) ? NSLocalizedString("Master") : ("Veteran ") + rank) : "";
		
		if (this._veteranStatusLabel)
		{
			destroyWithChildren(this._veteranStatusLabel);
			this._windowNode.removeChild(this._veteranStatusLabel);
		}
		
		this._veteranStatusLabel = CCLabel.labelWithString(text, new Core.Size(80, 30), GL2.Text.HorizontalAlign.Center, fontName, 11);
		this._veteranStatusLabel.setColor(ccc3(255, 0, 0));
		this._veteranStatusLabel.setPosition(ccp(83 + this._widthOffset, w._height * 0.5 - 3 - this._heightOffset));
		this._windowNode.addChild(this._veteranStatusLabel, 4);
	},
	
	//
	displayHunger: function()
	{
		var w = CGSizeMake(480, 320);
		
		var screenSize = CCDirector.winSize();
		
		var initialY = screenSize._height-326;
		
		var hungerLayer = new CCLayer(); //CCColorLayer.layerWithColor(ccc3(128,0,128), 85, 12);

		var hungerBar = CCColorLayer.layerWithColor(ccc3(255, 0x69, 0), 83, 10);
		
		hungerBar.setPosition(1,initialY);
	
		var windowSize = CGRectMake(0, 0, 85, 12);
		var cornerSize = CGRectMake(250,1,5,5);
		var barSize	  = CGRectMake(237,1,12,4);
		var color = ccc4(255,0x0,0x0, 0);
		var f = "hudElements.png";
		
	
		//pozycja +12 lub -12
		var hungerOverlay = ZFMenu.makeWindowOld(windowSize, cornerSize, barSize, f, color);
				 
//		for (CCNode *hungerOverlayChild in hungerOverlay.children)
//		{
//			if ([hungerOverlayChild isKindOfClass:[CCSpriteSheet class]])
//			{
//				for (CCSprite *CCSpriteSheetChild in hungerOverlayChild.children)
//				{
//					CCSpriteSheetChild.color = ccc3(0x87, 0x87, 0x87);//ccc3(0xdf,0xcf, 0x88);
//				}
//			}
//		}
	
		// FIXME : Bar has to be shifted up due to changes in makeWindow.
		var hungerBG = CCColorLayer.layerWithColor(ccc3(0,0,0), 83, 10);
		hungerBG.setPosition(ccp(0,initialY));
		hungerOverlay.setPosition( ccpAdd( hungerOverlay.getPosition() , ccp( 0 , -320 ) ) );
		hungerLayer.addChild(hungerBG, 0);
		
		hungerLayer.addChild( hungerOverlay, 2);

		//hungerBar.setAnchorPoint(ccp(0,1));this._currentZombie._hunger;
		hungerBar.setScale(this._selectedZombieGUIActor._hunger, 1);
//		hungerBar.setScale(this._currentZombie._hunger, 1);
		var brain = CCSprite.spriteWithFile("brain.png", ccp( 0 , 0.5 ) );
		brain.setPosition(81, initialY);
		hungerLayer.addChild(brain, 5);
		hungerLayer.addChild(hungerBar, 1);
		this._windowNode.addChild(hungerLayer, 6, this.kZombieMenuTags.kZombieMenuTagHungerLayer);
		//hungerLayer.setPosition(ccp( 33 + this._widthOffset, w._height * 0.21 - this._heightOffset ));
		hungerLayer.setPosition(ccp( 33 + this._widthOffset, w._height * 0.21 + this._heightOffset ));
	},
	
	cleanHunger: function()
	{
		var hunger = this._windowNode.getChildByTag(this.kZombieMenuTags.kZombieMenuTagHungerLayer);
		if(!hunger) return;
		this._windowNode.removeChild(hunger,true);
		destroyWithChildren(hunger);				
	},
		


//#define TAG_DELETE_ACTOR 1

//
//+(id)alloc
//{	
//	@synchronized([ZFZombieMenu class])
//	{ 
//		NSAssert(_zombieMenu == nil, @"Attempted to allocate a second instance of a singleton.");
//		_zombieMenu = [super alloc];
//		return _zombieMenu;
//	}
//	
//	return nil;
//}


	dismissMenu: function(sender)
	{
		if ( sender == this && (!this._mausoleumButton || !this._mausoleumButton.isEnabled || !this._sellZombieButton || !this._sellZombieButton.isEnabled) ){
			console.log("zfzombiemenu returning!!");
			return;
		}
		
		var screenWidth = CCDirector.winSize()._width;
		var actionTo = CCMoveTo.actionWithDuration(0.25, ccp(screenWidth, 0));
		this.runAction(actionTo);
		this.schedule(this.dismissTimerCallback, 0.5);
		
		this._menuState = this.menuStates.menuStateClosing;
		this.disableMenus();
//		this._windowNode.removeChild(this._nameLabel, true);
//		destroyWithChildren(this._nameLabel);
//		this._nameLabel = null;
//		
//		this._windowNode.removeChild(this._typeLabel, true);
//		destroyWithChildren(this._typeLabel);
//		this._typeLabel = null;
//		
//		this._windowNode.removeChild(this._invasionsLabel, true);
//		destroyWithChildren(this._invasionsLabel);
//		this._invasionsLabel = null;
//		
//		this._windowNode.removeChild(this._hungerLabel, true);
//		destroyWithChildren(this._hungerLabel);
//		this._hungerLabel = null;
//		
//		this._windowNode.removeChild(this._statusLabel, true);
//		destroyWithChildren(this._statusLabel);
//		this._statusLabel = null;
//		
//		this._windowNode.removeChild(this._typeValLabel, true);
//		destroyWithChildren(this._typeValLabel);
//		this._typeValLabel = null;
//		
//		this._windowNode.removeChild(this._invasionsValLabel, true);
//		destroyWithChildren(this._invasionsValLabel);
//		this._invasionsValLabel = null;
//		
//		this._windowNode.removeChild(this._statusValLabel, true);
//		destroyWithChildren(this._statusValLabel);
//		this._statusValLabel = null;
//		
//		
//		this._windowNode.removeChild(this._cl1, true);
//		destroyWithChildren(this._cl1);
//		this._cl1 = null;
//
//		this._windowNode.removeChild(this._sellZombieButton, true);
//		destroyWithChildren(this._sellZombieButton);
//		this._sellZombieButton = null;
//		
//		this._windowNode.removeChild(this._hungerValLabel, true);
//		destroyWithChildren(this._hungerValLabel);
//		this._hungerValLabel = null;
	//	[self removeChild:dimLayer cleanup:YES];
	//	[[CCTouchDispatcher sharedDispatcher] removeDelegate:dimLayer];
		ZFGuiLayer.enableMenus();
		SimpleAudioEngine.playEffect(kMenuCloseSFX);
		
//		var banner = this._windowNode.getChildByTag(this.kZombieMenuTags.kZombieMenuTagBanner);
//		{
//			if(banner)
//			{
//				this._windowNode.removeChild(banner);
//				destroy(banner);
//			}
//		}
	//	
	//	[[CCTextureCache sharedTextureCache] removeUnusedTextures];
	//
	//	[[EventTracker eventTracker] sendEvent:@"zf_army_dismiss" withParameters:nil andDelegate:nil];		
	},

	dismissTimerCallback: function($super)
	{	
	//	// cleanup actors
		this._currentZombie = null;
		
		if(this._selectedZombieGUIActor){
//			console.log("FPS: ZOMBIE MENOS........................"+this._selectedZombieGUIActor.classname);
			this._selectedZombieGUIActor.despawn();
		}
		
		if (this._zombieList) {
			this._zombieList.length = 0;
			this._zombieList = null;
		}
		
		// get rid of background overlay, regular bg is handled in ZFMenu
//		this.cleanRightMenu();
//		this.cleanWindow(this.kZombieMenuTags.kZombieMenuTagStatWindow);
//		this.cleanHunger();
//		this.cleanStatDisplay();
//		this.cleanAbilityDisplay();
			
//		this.cleanWindow(this.kZombieMenuTags.kZombieMenuTagGrassOverlay1);
//		this.cleanWindow(this.kZombieMenuTags.kZombieMenuTagGrassOverlay2);
//		this.cleanWindow(this.kZombieMenuTags.kZombieMenuTagGrassOverlay3);
		
	//	this.cleanWindow:kZombieMenuTagBrickOverlay1);
	//	this.cleanWindow:kZombieMenuTagBrickOverlay2];
	//	this.cleanWindow:kZombieMenuTagBrickOverlay3];
		
//		this._windowNode.removeChildByTag(this.kZombieMenuTags.kZombieMenuTagGrass, true);
//		this.removeChild(this._nameLabel, true);
//		this._nameLabel = null;
//		this._windowNode.removeChild(this._statusValLabel, true);
//		destroyWithChildren(this._statusValLabel);
//		this._statusValLabel = null;
//		this._windowNode.removeChild(this._typeValLabel, true);
//		destroyWithChildren(this._typeValLabel);
//		this._typeValLabel = null;
//		this._windowNode.removeChildByTag(this.kZombieMenuTags.kZombieMenuTagPageCountColorLayerLabel, true);
//		this._windowNode.removeChild(this._pageCount, true);
//		destroyWithChildren(this._pageCount);
//		this._pageCount = null;
		
		
//		for (var i = this._windowNode._children.length-1; i >= 0; i--) {
//			var child = this._windowNode._children[i];
//        	this._windowNode.removeChild(child, true);
//			destroyWithChildren(child);
//		}
		
		ZFGuiLayer.updateArmySize();
		
		$super();
	},
	
	browseForward: function(sender)
	{
		if(this._currentPage >= this._zombieList.length - 1)
			return;
		
		this._currentPage++;
//		this._currentPage = (this._currentPage > this._zombieList.length - 1) ? this._zombieList.length - 1 : this._currentPage;
		
		if(this._menuState == ZFMenu.menuStates.menuStateOpen)
		{
			this.displayPage();
		}
		else 
		{
			this.doZombieSwitchAction();
		}	
	},

	browseBackward: function(sender)
	{
		if(this._currentPage <= 0)
			return;
		
		this._currentPage--;
//		this._currentPage = (this._currentPage < 0) ? 0 : this._currentPage;
		
		if(this._menuState == ZFMenu.menuStates.menuStateOpen)
		{
			this.displayPage();
		}
		else 
		{
			this.doZombieSwitchAction();//while in mausoleum menu
		}
	},



//
//
//#pragma mark -
//#pragma mark stat menu
//
	initRightMenu: function()
	{
		var w = CGSizeMake(480, 320);
		var f = "hudElements.png";
		var windowPoint = ccp(w._width*0.41 + this._widthOffset, w._height - 50 - this._heightOffset);
		var tabSprite1 = CCSprite.spriteWithFile(f, CGRectMake(185,7,70,24));
		var tabSprite2 = CCSprite.spriteWithFile(f, CGRectMake(185,7,70,24));
		tabSprite1.setColor(ZFColorDefines.colorPaper);
		tabSprite2.setColor(ZFColorDefines.colorPaper);
		
		
	//	if([[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hant"] || [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hans"]||
	//	   [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"ja"])
		{
			//stats tab
			this._statsLabel = CCLabel.labelWithString(NSLocalizedString("STATS"), "Arial", 26);
			this._statsLabel.setScale(0.46);
			this._statsLabel.setPosition(ccp(windowPoint._x + 5 + 13, windowPoint._y + 24 - 21));
			this._statsLabel.setColor(ccc3(0, 0, 0));
			
			var statTabImage = CCMenuItemImage.itemFromNormalSprite(tabSprite1, tabSprite2, this.kZombieMenuTags.kZombieMenuTagStatTab, this.displayStats.bind(this, this.kZombieMenuTags.kZombieMenuTagStatTab));

			var statTab = CCMenu.menuWithItems([statTabImage]);
			statTabImage.setAnchorPoint(ccp(0,1));
			statTab._tag = this.kZombieMenuTags.kZombieMenuTagStatTab;
			statTab.setPosition(ccp(windowPoint._x + 5, windowPoint._y + 24 - 4));
			this._statsLabel.setAnchorPoint(ccp(0, 1));
			
			//ability Tab
			this._abilityTabLabel = CCLabel.labelWithString(NSLocalizedString("ABILITY"), "Arial", 26);
			this._abilityTabLabel.setScale(0.46);
			this._abilityTabLabel.setColor(ccc3(0, 0, 0));//ZFColorDefines.colorTextWhite);
			this._abilityTabLabel.setPosition(windowPoint._x + 5 + 75 + 5, windowPoint._y + 24 - 23);
			
			tabSprite1 = CCSprite.spriteWithFile(f, CGRectMake(185,7,70,24));
			tabSprite2 = CCSprite.spriteWithFile(f, CGRectMake(185,7,70,24));
			tabSprite1.setColor(ZFColorDefines.colorPaper);
			tabSprite2.setColor(ZFColorDefines.colorPaper);
			
			var abilityTabImage = CCMenuItemImage.itemFromNormalSprite(tabSprite1, tabSprite2, this.kZombieMenuTags.kZombieMenuTagAbilityTab, this.displayStats.bind(this, this.kZombieMenuTags.kZombieMenuTagAbilityTab));

			var abilityTab = CCMenu.menuWithItems([abilityTabImage]);
			abilityTabImage.setAnchorPoint(ccp(0,1));
			abilityTab._tag = this.kZombieMenuTags.kZombieMenuTagStatTab; 
			abilityTab.setPosition(ccp(windowPoint._x + 5 + 70, windowPoint._y + 24 - 8));
			this._abilityTabLabel.setAnchorPoint(ccp(0,1));
			
			var statOrder = 50;
			var abilityOrder = 3;
			
			if(this._viewingAbilities)
			{
				statOrder = 3;
				abilityOrder = 50;
			}
			
			this._windowNode.addChild(statTab, statOrder, this.kZombieMenuTags.kZombieMenuTagStatTab);
			this._windowNode.addChild(this._statsLabel, statOrder);
			this._windowNode.addChild(abilityTab, abilityOrder, this.kZombieMenuTags.kZombieMenuTagAbilityTab);
			this._windowNode.addChild(this._abilityTabLabel, abilityOrder);	
			
//			statTabImage._touchTarget.setAnchor(0.5, 0.5);
			statTabImage._touchTarget.setScale(new Core.Vector(1.0, 1.2));
//			statTabImage._touchTarget.setPosition(statTabImage._touchTarget._position._x, statTabImage._touchTarget._position._y - statTabImage._touchTarget.getSize()._height*0,5); 
			
//			abilityTabImage._touchTarget.setAnchor(0.5, 0.5);
			abilityTabImage._touchTarget.setScale(new Core.Vector(1.0, 1.2));
		}
	//	else 
	//	{
	//		//stats tab
	//		statsLabel = [CCBitmapFontAtlas bitmapFontAtlasWithString:NSLocalizedString(@"STATS", nil) fntFile:@"ABD26.fnt"];
	//		statsLabel.scale = .46;
	//		statsLabel.position = ccp(windowPoint.x + 5 + 13, windowPoint.y + 24 - 9+heightOffset);
	//		CCMenuItemImage *statTabImage = [CCMenuItemImage itemFromNormalSprite:tabSprite 
	//															   selectedSprite:tabSprite
	//																	   target:self 
	//																	 selector:@selector(displayStats:)];
	//		
	//		CCMenu *statTab = [CCMenu menuWithItems:statTabImage,nil];
	//		statTabImage.anchorPoint = ccp(0,1); 
	//		statTab.tag = kZombieMenuTagStatTab;
	//		statTab.position = ccp(windowPoint.x + 5, windowPoint.y + 24 - 4+heightOffset);
	//		statsLabel.anchorPoint = ccp(0,1);
	//		
	//		//ability Tab
	//		abilityTabLabel = [CCBitmapFontAtlas bitmapFontAtlasWithString:NSLocalizedString(@"ABILITY", nil) fntFile:@"ABD26.fnt"];
	//		abilityTabLabel.scale = .46;
	//		abilityTabLabel.color = colorTextWhite;
	//		abilityTabLabel.position = ccp(windowPoint.x + 5 + 75 + 5, windowPoint.y + 24 - 9+heightOffset);
	//		CCMenuItemImage *abilityTabImage = [CCMenuItemImage itemFromNormalSprite:tabSprite 
	//																  selectedSprite:tabSprite
	//																		  target:self 
	//																		selector:@selector(displayStats:)];
	//		
	//		CCMenu *abilityTab = [CCMenu menuWithItems:abilityTabImage,nil];
	//		abilityTabImage.anchorPoint = ccp(0,1);
	//		abilityTab.tag = kZombieMenuTagAbilityTab;
	//		abilityTab.position = ccp(windowPoint.x + 5 + 70,windowPoint.y + 24 - 8+heightOffset);
	//		abilityTabLabel.anchorPoint = ccp(0,1);
	//		
	//		int statOrder = 5;
	//		int abilityOrder = 3;
	//		
	//		if(viewingAbilities)
	//		{
	//			statOrder = 3;
	//			abilityOrder = 5;
	//		}
	//		
	//		[self addChild:statTab z:statOrder tag:kZombieMenuTagStatTab];
	//		[self addChild:statsLabel z:statOrder];
	//		[self addChild:abilityTab z:abilityOrder tag:kZombieMenuTagAbilityTab];
	//		[self addChild:abilityTabLabel z:abilityOrder];
	//	}
		
		this.displayStats(null, null);
	},
	
	cleanRightMenu: function()
	{
		var stab = this._windowNode.getChildByTag(this.kZombieMenuTags.kZombieMenuTagStatTab);

		if(stab)
		{
//			stab.removeAllChildrenWithCleanup(true);
			this._windowNode.removeChildByTag(this.kZombieMenuTags.kZombieMenuTagStatTab, true);
			destroyWithChildren(stab);
		}
	
		var atab = this._windowNode.getChildByTag(this.kZombieMenuTags.kZombieMenuTagAbilityTab);
		
		if(atab && atab != null)
		{
//			atab.removeAllChildrenWithCleanup(true);
			this._windowNode.removeChildByTag(this.kZombieMenuTags.kZombieMenuTagAbilityTab, true);
			destroyWithChildren(atab);
		}
	
		if(this._statsLabel && this._statsLabel != null)
		{
			this._windowNode.removeChild(this._statsLabel, true);
			destroyWithChildren(this._statsLabel);
			this._statsLabel = null;
		}
	
		if(this._abilityTabLabel && this._abilityTabLabel != null)
		{
			this._windowNode.removeChild(this._abilityTabLabel, true);
			destroyWithChildren(this._abilityTabLabel);
			this._abilityTabLabel = null;
		}
	},
	
	initStatDisplay: function()
	{
		var f = "hudElements.png";
		var fontName = "ABD26.fnt";
		//int fontSize = 14;
		var w = CGSizeMake(480, 320);
		var acm = ZFActorManager;
		var p;
		
		// make and add statsLayer so addMutationIcon will work
		var statsLayer = new CCLayer();
		
		var statOrder = 50;
		if(this._viewingAbilities)
			statOrder = 3;
		
		this._windowNode.addChild(statsLayer, statOrder, this.kZombieMenuTags.kZombieMenuTagStatLayer);
		
		// taken from initelements
		var windowPoint = ccp(w._width*0.41+this._widthOffset, w._height - 60 - this._heightOffset);
		statsLayer.setPosition(ccp(windowPoint._x + 10, windowPoint._y - 4 - 10));
		
		//icons
		var powerIcon = CCSprite.spriteWithFile(f, CGRectMake(295,1,42,43), ccp(0,1));
		var lifeIcon  = CCSprite.spriteWithFile(f, CGRectMake(383,1,42,43), ccp(0,1));
		var speedIcon = CCSprite.spriteWithFile(f, CGRectMake(339,1,42,43), ccp(0,1));
	
		powerIcon.setPosition(ccp(0, -32));
		lifeIcon.setPosition(ccp(0, -32-48));
		speedIcon.setPosition(ccp(0, -32-48-48));
		
		statsLayer.addChild(powerIcon, 1);
		statsLayer.addChild(lifeIcon, 1);
		statsLayer.addChild(speedIcon, 1);
		
		//labels
		var unitDictionary = ZFActorManager._unitStats[ this._currentZombie.classname ]; //*/ "ZombieActorRegularCrazy"];
		
		var statDict = {str: unitDictionary.str, con: unitDictionary.con, dex: unitDictionary.dex};
		
		statDict = this._currentZombie.modifyStats(statDict);
		var str = statDict.str;
		var con = statDict.con;
		var dex = statDict.dex;
		
	//	if([[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hant"] || [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hans"]||
	//	   [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"ja"])
		{
			var strLabel = CCLabel.labelWithString(NSLocalizedString("POWER"), "Arial", 26);
			var conLabel = CCLabel.labelWithString(NSLocalizedString("LIFE"), "Arial", 26);
			var dexLabel = CCLabel.labelWithString(NSLocalizedString("SPEED"),"Arial", 26);
			
			strLabel.setScale(0.54);
			conLabel.setScale(0.54);
			dexLabel.setScale(0.54);

			strLabel.setAnchorPoint(ccp(0,1));
			conLabel.setAnchorPoint(ccp(0,1));
			dexLabel.setAnchorPoint(ccp(0,1));
	
			strLabel.setPosition(ccpAdd(powerIcon.getPosition(),ccp(powerIcon.getSize()._width + 15, powerIcon.getSize()._height/2)));
			conLabel.setPosition(ccpAdd(lifeIcon.getPosition(),ccp(powerIcon.getSize()._width + 15, powerIcon.getSize()._height/2)));
			dexLabel.setPosition(ccpAdd(speedIcon.getPosition(), ccp(powerIcon.getSize()._width + 15, powerIcon.getSize()._height/2)));
			
			var strLabelDS = CCLabel.labelWithString(NSLocalizedString("POWER"), "Arial", 26);
			var conLabelDS = CCLabel.labelWithString(NSLocalizedString("LIFE"), "Arial", 26);
			var dexLabelDS = CCLabel.labelWithString(NSLocalizedString("SPEED"),"Arial", 26);
			
			strLabelDS.setScale(0.54);
			conLabelDS.setScale(0.54);
			dexLabelDS.setScale(0.54);

			strLabelDS.setAnchorPoint(ccp(0,1));
			conLabelDS.setAnchorPoint(ccp(0,1));
			dexLabelDS.setAnchorPoint(ccp(0,1));
	
			strLabelDS.setPosition(ccpAdd(powerIcon.getPosition(),ccp(powerIcon.getSize()._width + 15 + 2, powerIcon.getSize()._height/2 - 2)));
			conLabelDS.setPosition(ccpAdd(lifeIcon.getPosition(),ccp(powerIcon.getSize()._width + 15 + 2, powerIcon.getSize()._height/2 - 2)));
			dexLabelDS.setPosition(ccpAdd(speedIcon.getPosition(), ccp(powerIcon.getSize()._width + 15 + 2, powerIcon.getSize()._height/2 - 2)));
			
			strLabelDS.setColor(ccc3(0, 0, 0));
			conLabelDS.setColor(ccc3(0, 0, 0));
			dexLabelDS.setColor(ccc3(0, 0, 0));
			
			statsLayer.addChild(strLabelDS, 1);
			statsLayer.addChild(conLabelDS, 1);
			statsLayer.addChild(dexLabelDS, 1);
			
			statsLayer.addChild(strLabel, 2);
			statsLayer.addChild(conLabel, 2);
			statsLayer.addChild(dexLabel, 2);
			
			//dividers
			var b = CGRectMake(237,1,12,3);
			var c = ZFColorDefines.colorTextWhite;
	//		CCLayer *div1 = [ZFMenu makeDividerwithSize:240.f bar:b file:f color:c];
	//		CCLayer *div2 = [ZFMenu makeDividerwithSize:240.f bar:b file:f color:c];
	//		div1.position = ccp(0-widthOffset, 1-heightOffset);
	//		div2.position = ccp(0-widthOffset, -47-heightOffset);
	//		[statsLayer addChild:div1 z:1];
	//		[statsLayer addChild:div2 z:1];
	//		
			//stars
			var posY = this.displayStatBarWithTotalValue(str, strLabel.getPosition(), statsLayer);
			p = ccp(strLabel.getPosition()._x + 160, strLabel.getPosition()._y + 20);
			
			////// MUTATIONS THAT ADD STR /////////
			p = this.addMutationIcon( kMutationTomatoHead, p );
			p = this.addMutationIcon( kMutationTurnipArms, p );
			p = this.addMutationIcon( kMutationCeleryArms, p );
			p = this.addMutationIcon( kMutationGarlicHead, p );
			p = this.addMutationIcon( kMutationDragonArms, p );
			
			posY = this.displayStatBarWithTotalValue(con, conLabel.getPosition(), statsLayer);
			
			p = ccp(conLabel.getPosition()._x + 160, conLabel.getPosition()._y + 20);
			///////// MUTATIONS THAT ADD CON //////////////

			p = this.addMutationIcon( kMutationOnionHead, p );
			p = this.addMutationIcon( kMutationPotatoHead, p );
			p = this.addMutationIcon( kMutationBroccoliHat, p );
			p = this.addMutationIcon( kMutationCauliflowerHat, p );
			p = this.addMutationIcon( kMutationLimaBeanBody, p );
			p = this.addMutationIcon( kMutationFlyTrapCollar, p );
			
			posY = this.displayStatBarWithTotalValue(dex, dexLabel.getPosition(), statsLayer);
			p = ccp(dexLabel.getPosition()._x + 160, dexLabel.getPosition()._y + 20);
		}
	//	else
	//	{
	//		CCBitmapFontAtlas *strLabel = [CCBitmapFontAtlas bitmapFontAtlasWithString:NSLocalizedString(@"POWER", nil) fntFile:fontName];
	//		CCBitmapFontAtlas *conLabel = [CCBitmapFontAtlas bitmapFontAtlasWithString:NSLocalizedString(@"LIFE", nil) fntFile:fontName];
	//		CCBitmapFontAtlas *dexLabel = [CCBitmapFontAtlas bitmapFontAtlasWithString:NSLocalizedString(@"SPEED", nil) fntFile:fontName];
	//		strLabel.scale = conLabel.scale = dexLabel.scale =.54;
	//		
	//		strLabel.anchorPoint = conLabel.anchorPoint = dexLabel.anchorPoint = ccp(0,0);
	//		
	//		strLabel.position = ccpAdd(powerIcon.position, ccp(powerIcon.contentSize.width + 15, powerIcon.contentSize.height/2));
	//		conLabel.position = ccpAdd(lifeIcon.position,  ccp(powerIcon.contentSize.width + 15, powerIcon.contentSize.height/2));
	//		dexLabel.position = ccpAdd(speedIcon.position, ccp(powerIcon.contentSize.width + 15, powerIcon.contentSize.height/2));
	//		
	//		[statsLayer addChild:strLabel z:1];
	//		[statsLayer addChild:conLabel z:1];
	//		[statsLayer addChild:dexLabel z:1];
	//		
	//		//dividers
	//		CGRect b = CGRectMake(237,1,12,3);
	//		ccColor3B c = colorTextWhite;
	//		CCLayer *div1 = [ZFMenu makeDividerwithSize:240.f bar:b file:f color:c];
	//		CCLayer *div2 = [ZFMenu makeDividerwithSize:240.f bar:b file:f color:c];
	//		div1.position = ccp(0-widthOffset, 1-heightOffset);
	//		div2.position = ccp(0-widthOffset, -47-heightOffset);
	//		[statsLayer addChild:div1 z:1];
	//		[statsLayer addChild:div2 z:1];
	//		
	//		//stars
	//		float posY = [self displayStatBarWithTotalValue:str pos:strLabel.position withParent:statsLayer];
	//		p = ccp(strLabel.position.x + 160, strLabel.position.y + 20);
	//		
	//		////// MUTATIONS THAT ADD STR /////////
	//		p = [self addMutationIcon:kMutationTomatoHead position:p];
	//		p = [self addMutationIcon:kMutationTurnipArms position:p];
	//		p = [self addMutationIcon:kMutationCeleryArms position:p];
	//		p = [self addMutationIcon:kMutationGarlicHead position:p];
	//		p = [self addMutationIcon:kMutationDragonArms position:p];
	//		p = [self addMutationIcon:kMutationPumpkinHead position:p];
	//		
	//		posY = [self displayStatBarWithTotalValue:con pos:conLabel.position withParent:statsLayer];
	//		p = ccp(conLabel.position.x + 160, conLabel.position.y + 20);	
	//		///////// MUTATIONS THAT ADD CON //////////////
	//		p = [self addMutationIcon:kMutationOnionHead position:p];
	//		p = [self addMutationIcon:kMutationPotatoHead position:p];
	//		p = [self addMutationIcon:kMutationBroccoliHat position:p];
	//		p = [self addMutationIcon:kMutationCauliflowerHat position:p];
	//		p = [self addMutationIcon:kMutationLimaBeanBody position:p];
	//		p = [self addMutationIcon:kMutationFlyTrapCollar position:p];	
	//		
	//		posY = [self displayStatBarWithTotalValue:dex pos:dexLabel.position withParent:statsLayer];
	//		p = ccp(dexLabel.position.x + 160, dexLabel.position.y + 20);	
	//	}
	//	
	//	//////// MUTATIONS THAT ADD SPEED ///////////
		p = this.addMutationIcon( kMutationCarrotHat, p );
		p = this.addMutationIcon( kMutationCoffeeHead, p );
	},

	initAbilitiesDisplay: function()
	{
		if (this._openingMenuThroughMausoleum)
		{
			return;
		}
		
		var w = CGSizeMake(480, 320);
		var abilitiesLayer = new CCLayer();
		var windowPoint = ccp(w._width*0.41+this._widthOffset, w._height - 58 - this._heightOffset);
		abilitiesLayer.setPosition(ccp(windowPoint._x + 10, windowPoint._y));	
		
		if(this._currentZombie && this._currentZombie._abilityList && this._currentZombie._abilityList.length > 0)
		{
			this._currentZombie.initActorSpecificAbilities();
			
			var cSize = ZFAbilityCell.cellSize();
			
			this._abilityTable  = CCTableView.tableViewWithDataSource(this, CGSizeMake(cSize._width, 65));
			this._abilityTable._direction = CCScrollView.CCScrollViewDirection.CCScrollViewDirectionVertical;
			this._abilityTable._tDelegate = this;
			this._abilityTable._bounces = false;
			
			// 5 pixels up and to the right of the bottom left layer corner
			this._abilityTable.setAnchorPoint(ccp(0,0));
			this._abilityTable.setPosition(ccp(0,-100));
			this._abilityTable.reloadData();
			
			abilitiesLayer.addChild(this._abilityTable, 2);
			
			var f = ZFGameDefines.HUDELEMENTS1_FILE;
			this._upArrow = CCSprite.spriteWithFile(f, CGRectMake(289,45,18,36));
			this._downArrow = CCSprite.spriteWithFile(f, CGRectMake(289,45,18,36));
			
			abilitiesLayer.addChild(this._upArrow, 3);
			abilitiesLayer.addChild(this._downArrow, 3);
			this._upArrow.setScale(0.75);
			this._upArrow.setRotation(90);
			this._downArrow.setScale(0.75);
			this._downArrow.setRotation(-90);
			this._upArrow.setColor(ZFColorDefines.colorYellowButton);
			this._downArrow.setColor(ZFColorDefines.colorYellowButton);
			this._upArrow.setPosition(ccp(this._abilityTable.getContentSize()._width /2,0));
			this._downArrow.setPosition(ccp(this._abilityTable.getContentSize()._width /2,- 147));
			
			var actionTo = CCSequence.actions(
						   CCMoveBy.actionWithDuration(0.25, ccp(0,10)),
						   CCMoveBy.actionWithDuration(0.25, ccp(0,-10)));
			var repeatForever = CCRepeatForever.actionWithAction(actionTo);
			this._downArrow.runAction(repeatForever);
			
			actionTo = CCSequence.actions(
						CCMoveBy.actionWithDuration(0.25, ccp(0,-10)),
						CCMoveBy.actionWithDuration(0.25, ccp(0,10)));
			repeatForever = CCRepeatForever.actionWithAction(actionTo);
			this._upArrow.runAction(repeatForever);
			this.schedule(this.tick);
		}
		
		var abilityOrder = 3;
		if(this._viewingAbilities)
			abilityOrder = 50;
		this._windowNode.addChild(abilitiesLayer, abilityOrder, this.kZombieMenuTags.kZombieMenuTagAbilitiesLayer);
	},
	
	tick: function(dt)
	{
		var p = this._abilityTable.getContainerPos();
		
		if (this._abilityTable._isDragging)
		{
			this._upArrow.setVisible(false);
			this._downArrow.setVisible(false);
		}
		else
		{
			var cSize   = ZFAbilityCell.cellSize();
			if(this._currentZombie && this._currentZombie._abilityList){
				var cellCount = (this._currentZombie._abilityList.length > 3)?this._currentZombie._abilityList.length-3 : 0; 
				this._upArrow.setVisible(p._y > -cSize.getHeight()*cellCount);
				this._downArrow.setVisible(p._y < 0);
			}
		}
	},

	addMutationIcon: function(flag, p)
	{
		// check if it has the flag before anything else 
		if(this._currentZombie._flags & flag)
		{
			var tmpY = p._y;
			var mutationIcon = null;
			var spriteFile = this.fileForMutation(flag);
			mutationIcon =  CCSprite.spriteWithFile(spriteFile, new Core.Rect(0,0,32,32));
			mutationIcon.setAnchorPoint(ccp(0,1));
			mutationIcon.setScale(0.5);

			var statsLayer = this._windowNode.getChildByTag(this.kZombieMenuTags.kZombieMenuTagStatLayer);
			statsLayer.addChild(mutationIcon);
			mutationIcon.setPosition(p);
			
			return ccp(p._x - mutationIcon.getSize()._width/2, tmpY);
		}
		return p;
	},

	fileForMutation:function(flag)
	{
	  var spriteFile = "";
	
	  switch(flag)
	  {
	      case kMutationTomatoHead:	 	spriteFile="stex0004.png"; break;
	      case kMutationTurnipArms:	 	spriteFile="stex0009.png"; break;
	      case kMutationCeleryArms:	 	spriteFile="stex0007.png"; break;
	      case kMutationGarlicHead:	 	spriteFile="stex0013.png"; break;
	      case kMutationDragonArms:	 	spriteFile="stex0025.png"; break;
	      case kMutationCarrotHat:	 	spriteFile="stex0006.png"; break;
	      case kMutationCoffeeHead:	 	spriteFile="stex0010.png"; break;
	      case kMutationPumpkinHead:	 	spriteFile="stex0042.png"; break;
	      case kMutationOnionHead:	 	spriteFile="stex0005.png"; break;
	      case kMutationPotatoHead:	 	spriteFile="stex0008.png"; break; 
	      case kMutationBroccoliHat:	 	spriteFile="stex0011.png"; break;
	      case kMutationCauliflowerHat:	spriteFile="stex0012.png"; break;
	      case kMutationLimaBeanBody:	 	spriteFile="stex0014.png"; break;
	      case kMutationFlyTrapCollar: 	spriteFile="stex0016.png"; break;
	  }
	  
	  return spriteFile;
	},

	displayStatBarWithTotalValue: function(total, pos, aParent)
	{
		var f = "hudElements.png";
		var posX = pos._x;
		var posY = pos._y - 10;
		var iconCount = 0;
	
		for(var i = 0; i < total; i++)
		{
			var icon = null;
			var cmp = total - i;
			cmp = (cmp < 0.35) ? 0.35 : cmp;

			icon = CCSprite.spriteWithFile(f, CGRectMake(265,42,(cmp < 1) ? 16 * cmp : 16, 16, ccp(0,0)));
			icon.setColor(ccc3(255, 255, 0));
			aParent.addChild(icon, i);
			posX += icon.getSize()._width/2 + 1;
			icon.setPosition(ccp(posX, posY));
			

			iconCount++;
			if(iconCount >= 20)
			{
				iconCount = 0;
				posX = pos._x + i/20*2;
				posY -= 5;
			}
		}
		
		return posY;
	},

	cleanStatDisplay: function()
	{
		var statsLayer = this._windowNode.getChildByTag(this.kZombieMenuTags.kZombieMenuTagStatLayer);
		if(statsLayer)
		{
//			statsLayer.removeAllChildrenWithCleanup(true);
			this._windowNode.removeChild(statsLayer);
			destroyWithChildren(statsLayer);
		}
		
	//	CCLayer *statsLayer = (CCLayer*)[self getChildByTag:kZombieMenuTagStatLayer];
	//	if(statsLayer)
	//	{
	//		[statsLayer removeAllChildrenWithCleanup:YES];
	//		[self removeChildByTag:kZombieMenuTagStatLayer cleanup:YES];
	//	}
	},

	cleanAbilityDisplay: function()
	{
		var abilityLayer = this._windowNode.getChildByTag(this.kZombieMenuTags.kZombieMenuTagAbilitiesLayer);
		this.unschedule(this.tick);
		if(abilityLayer )
		{
			abilityLayer.removeChild(this._abilityTable, true);
			if(this._upArrow && this._upArrow.getParent())
			{
				this._upArrow.getParent().removeChild(this._upArrow, true);
				destroyWithChildren(this._upArrow);
				this._upArrow = null;
			}
			
			if(this._downArrow && this._downArrow.getParent())
			{
				this._downArrow.getParent().removeChild(this._downArrow, true);
				destroyWithChildren(this._downArrow);
				this._downArrow = null;
			}
			
//			abilityLayer.removeAllChildrenWithCleanup(true);
			this._windowNode.removeChild(abilityLayer, true);
			destroyWithChildren(abilityLayer);
			
			// cleanup table here
			if (this._abilityTable) {
				this._abilityTable._tDelegate = null;
				destroyWithChildren(this._abilityTable);
				this._abilityTable = null;
			}
		}
	},

	displayStats: function(index,sender)
	{
		var w = CGSizeMake(480, 320);
		// taken from initelements
		var windowPoint = ccp(w._width*0.41+this._widthOffset, w._height - 50 - this._heightOffset);
	
		var statTab = this._windowNode.getChildByTag(this.kZombieMenuTags.kZombieMenuTagStatTab);
		var abilityTab = this._windowNode.getChildByTag(this.kZombieMenuTags.kZombieMenuTagAbilityTab);
		var statsLayer = this._windowNode.getChildByTag(this.kZombieMenuTags.kZombieMenuTagStatLayer);
		var abilitiesLayer = this._windowNode.getChildByTag(this.kZombieMenuTags.kZombieMenuTagAbilitiesLayer);
		
	//	if((!sender && !viewingAbilities) || (sender && sender == [statTab.children objectAtIndex:0]))
		if((!index && !this._viewingAbilities) || index == this.kZombieMenuTags.kZombieMenuTagStatTab)
		{
			//console.log("�1");
			
			this._viewingAbilities = false;;
			if (statsLayer)
			{
				statsLayer.setDepth(50);
			}
			statTab.setDepth(50);
			this._statsLabel.setDepth(51);
			
			this._statsLabel.setPosition(ccp(windowPoint._x + 5 + 13, windowPoint._y + 24 - 21));
			statTab.setPosition(ccp(windowPoint._x + 5, windowPoint._y + 24 - 4));
			
			if (abilitiesLayer)
			{
				abilitiesLayer.setDepth(3);
			}

			abilityTab.setDepth(3);
			this._abilityTabLabel.setDepth(3);
			
			abilityTab.setPosition(ccp(windowPoint._x + 5 + 70, windowPoint._y + 24 - 8));
			this._abilityTabLabel.setPosition(windowPoint._x + 5 + 75 + 5, windowPoint._y + 24 - 23);
		}
	//	else if((!sender && viewingAbilities) || (sender && sender == [abilityTab.children objectAtIndex:0]))
		else if((!index && this._viewingAbilities) || index == this.kZombieMenuTags.kZombieMenuTagAbilityTab)
		{
			//console.log("�2");
			
			this._viewingAbilities = true;
			if (abilitiesLayer && abilitiesLayer != null)
			{
				abilitiesLayer.setDepth(50);
			}
			
			abilityTab.setDepth(50);
			this._abilityTabLabel.setDepth(51);
			abilityTab.setPosition(ccp(windowPoint._x + 5 + 70, windowPoint._y + 24 - 4));
			this._abilityTabLabel.setPosition(windowPoint._x + 5 + 75 + 5, windowPoint._y + 24 - 21);
						
			if (statsLayer)
			{
				statsLayer.setDepth(3);
			}
			
			statTab.setDepth(3);
			this._statsLabel.setDepth(3);
			
			this._statsLabel.setPosition(ccp(windowPoint._x + 5 + 13, windowPoint._y + 24 - 23));
			statTab.setPosition(ccp(windowPoint._x + 5, windowPoint._y + 24 - 8));
		}
	},
//
//
//#pragma mark -
//#pragma mark buttons
//

//
//#pragma mark -
//#pragma mark gui Actor
//
	cleanupSelectedZombieGuiActor: function()
	{
		if (this._selectedZombieGUIActor)
		{
			this._selectedZombieGUIActor.despawn();
//			destroyWithChildren(this._selectedZombieGUIActor);
			this._selectedZombieGUIActor = null;
		}
	},
//
	spawnSelectedZombieGuiActor: function()
	{
		var w = CGSizeMake(480, 320);
		var acm = ZFActorManager;
		
		this._selectedZombieGUIActor = acm.spawnGUIActor_withClass_atPoint_withTarget( this._currentZombie.classname,
				ccp(84 + this._widthOffset,w._height*0.55 - this._heightOffset), this._windowNode);
						
		this._selectedZombieGUIActor.addMutation( this._currentZombie._flags );
		
		this._selectedZombieGUIActor._savedColor = this._currentZombie._savedColor;
		this._selectedZombieGUIActor._spriteMan.setScale( ccpMult( this._selectedZombieGUIActor._spriteMan.getScale() , 1.25 ) );
		this._selectedZombieGUIActor.resetColor();
		this._selectedZombieGUIActor._hunger = this._currentZombie._hunger;
		this._selectedZombieGUIActor._tag = this.kZombieMenuTags.kZombieMenuTagSelectedZombie;
		
		if ( ! this.isCurrentZombieActive() )
		{
			for ( var key in this._selectedZombieGUIActor._attachments )
			{
				var a = this._selectedZombieGUIActor._attachments[ key ];
				
				if ( !a || a == null )
				{
					continue;
				}
				
				if ( (		a._tag == kActorPartTagEyeL 
						|| 	a._tag == kActorPartTagEyeR ) )
				{
					continue;
				}
				else
				{
					a._sprite.setColor( ccc3(0x0,0x0,0x0) );
				}
			}
			
			// TODO : To be done when particles are done.
//			for (ActorParticle *p in selectedZombieGuiActor.particles)
//			{
//				p.particle.startColor = (ccColor4F) {0,0,0,1};
//				p.particle.endColor = (ccColor4F) {0,0,0,1};
//			}
		}
	}, 

	activeZombieCount: function()
	{
		var acm = ZFActorManager;
		var zombieCount = 0;
		
		for ( key in acm._actorList )
		{
			var actor = acm._actorList[ key ];
			
			if ( actor == null || !(actor instanceof "ZombieActor"))
			{
				continue;
			}
			
			zombieCount++;
		}
		
		return zombieCount;
	},

	noZombieMessage : function()
	{
		var gui = ZFGuiLayer.gui();
		var message = NSLocalizedString("Ya got no zombies yet.\n\nYou need at least one zombie to access the Zombie Menu.", null);
		gui.displayAlertSimple(
				NSLocalizedString("No Zombies", null),
				message,
				CCSprite.spriteWithFile("male.png"));
	},

	isCurrentZombieActive: function()
	{
//		console.log("isCurrentZombieActive this._zombieList.length:" + this._zombieList.length);
		for ( var key in this._zombieList )
		{
			var z = this._zombieList[ key ];
			
			if ( z == this._currentZombie )
			{
//				console.log("isCurrentZombieActive: returning true");
				return true;
			}
		}
//		console.log("isCurrentZombieActive: returning FALSE");
		return false;
	},
//
	doZombieSwitchAction: function()
	{	
		this._openingMenuThroughMausoleum = true;
		
		this._currentZombie = this._zombieList[ this._currentPage ];
		
		// TODO : Remove hardcoded size.
		var w = new Core.Size( 480 , 320 );
		
		var actionTo = CCSequence.actions( new Array (
					  		CCMoveTo.actionWithDuration( 0.1 , ccp( w._width , 0 ) ),
					  		CCCallFunc.actionWithTarget( this , this.displayCurrentZombie ),
					  		CCCallFunc.actionWithTarget( this , this.displayPage ),
					  		CCMoveTo.actionWithDuration( 0.1 , this.slideOutPosition() ),
					  		CCMoveTo.actionWithDuration( 0.05 , ccpAdd( this.slideOutPosition() , ccp( 15 , 0 ) ) ),
					  		CCMoveTo.actionWithDuration( 0.05 , this.slideOutPosition() ),
					  		CCCallFunc.actionWithTarget( this , this.tempFunc ) ) );
		
		this.runAction( actionTo );
	},

	tempFunc: function( sender )
	{
		this._openingMenuThroughMausoleum = false;
	},

	alertWindow_dismissedPositive: function(/* ZFAlertWindow* */ alertWindow, /*Bool*/dummy) {
		var market = ZFMarketMenu;
		if (alertWindow._idTag == this.TAG_DELETE_ACTOR) {
			if(dummy) {
				var actor = alertWindow._data;
				
				var baseSaleValue = ZFGameDefines.PLOW_COST;
				var trueSaleValue = baseSaleValue + market.costFromName(actor.classname);
				
				ZFGuiLayer.gui().displayMessage(sprintf(NSLocalizedString("Sold! +%ig"), trueSaleValue),actor._farmData._currentTile, ZFColorDefines.colorTextHighlight,0);
				GameState.addResource(GameData.gameResources.kGameResourceGold, trueSaleValue);
				SimpleAudioEngine.playEffect(kEarnSFX);
				
				
				ZFActorManager.despawnFarmActor(actor);
				SimpleAudioEngine.playEffect(kDeleteSFX);
				
	//          [[PlayerProfileManager playerProfileManager] log:@"Sold a zombie from the zombie list"];
				this._zombieList.splice(this._zombieList.indexOf(actor), 1);
				
				if (this._zombieList.length <= 0) {
					this._sellZombieButton.isEnabled = true;
					this.dismissMenu(this);
				} else {
					this._currentPage = this._currentPage - 1;
					this._currentPage = (this._currentPage >= 0) ? this._currentPage : 0;
					this._currentZombie = this._zombieList[this._currentPage];
					this.displayPage();
				}
//				actor.release();
			}
			
			this._sellZombieButton.isEnabled = true;
		}
		alertWindow._data = null;
	},

	//- (void)table:(CCTableView *)table cellTouched:(CCTableViewCell *)cell
	table_cellTouched: function(table, cell)
	{
		// do nothing
	},
	
	//- (Class)cellClassForTable:(CCTableView *)table
	cellClassForTable: function(table)
	{
	  return ZFAbilityCell;
	},
	
	//-(CCTableViewCell *)table:(CCTableView *)table cellAtIndex:(NSUInteger)idx
	table_cellAtIndex: function(table, idx)
	{
		var cell = table.dequeueCell();
		var a = this._currentZombie._abilityList[idx];
		
		if (!cell) 
		{
			cell = new ZFAbilityCell();
		}
		
		cell.setAbility(a);
		cell._node = cell._cellLayer;
		cell._place = idx;
		
	  return cell;
	},
	
	//-(NSUInteger)numberOfCellsInTableView:(CCTableView *)table
	numberOfCellsInTableView: function(table)
	{
		var cells = 0;
		if(this._currentZombie && this._currentZombie._abilityList) cells = this._currentZombie._abilityList.length;
		return cells;
	},
	
	//- (void)alertWindow:(ZFAlertWindow*)alertWindow dismissedPositive:(BOOL)dummy withButtonTag:(NSInteger)buttonTag
	alertWindow_withButtonTag: function(alertWindow, dummy, buttonTag)
	{
		
	},
	
	getMenuOffset: function()
	{
		return ccp(0,0);
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/ZFMenus/Storage/ZFStorageMenu'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Storage/ZFStorageMenu'] || {}; $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Storage/ZFStorageMenu'] = exports; 
var INVENTORY_ITEMS_PER_ROW = 8;
var INVENTORY_ROWS_PER_PAGE  = 3;
var INVENTORY_ITEMS_PER_PAGE = (INVENTORY_ITEMS_PER_ROW * INVENTORY_ROWS_PER_PAGE);
var MAX_INVENTORY_PAGES = 3;


exports.ZFStorageMenu = ZFMenu.singleton(
{
	classname : 'ZFStorageMenu',

	$kStorageAlert: 
	{
		kStorageAlertWindowIDTagConfirmStore : 1,
		kStorageAlertWindowIDTagConfirmStoreActor : 2,
		kStorageAlertWindowIDTagConfirmRetireve : 3,
		kStorageAlertWindowIDTagConfirmUse : 4,
		kStorageAlertWindowIDTagConvertFragments :5,
		kStorageAlertWindowIDTagUnlockMausoleum : 6,
		kStorageAlertWindowIDTagMessage : 7,
		kStorageAlertWindowIDTagSell : 8,
		kStorageAlertWindowIDTagCantSell : 9
	},

	$kStorageMenuTags:
	{
		kStorageMenuTagItemSpriteSheet : 3,
		kStorageMenuTagItemCountLabel : 4,
		kStorageMenuTagBGOverlay : 5,
		kStorageMenuTagBG : 6,
		kStorageMenuTagBGColor : 7,
		kStorageMenuTagRoofShade : 8,
		kStorageMenuTagDimRow : 9,
		kStorageMenuTagSpriteNode : 10
	},
	
	storageMenu : function()
	{
		return this;
	},
	
	initialize: function()
	{
		// tells where it'll pop out of ... -320 = pops up from above when it's moved into frame
		this.setPosition(ccp(0, -320));
		this._currentActor = null;
		this._checkStageActor = false;
		this._currentItemCoordinates = ccp(-1, -1);
			
		// browseable therefore needs max pages var
		this._maxMenuPages = MAX_INVENTORY_PAGES;
			
		this._additionalStorageItems = 0;
		this._additionalStorageRows = 0;
		this._additionalStoragePages = 0;
		this._menuHeightOffset = 0;
	},
	
	
	fixInventory: function()
	{
		var gs = GameState;
		var tim = ZFTileManager;
		var market = ZFMarketMenu.theMarket();
		var toRemove = [];
		
		if (gs._zfGameData._inventory)
		{
			for (var i = gs._zfGameData._inventory.length - 1; i >= 0; i--)
			{
				var item = gs._zfGameData._inventory[i];
				if (!item){
					gs._zfGameData._inventory.splice( i, 1 );
				}
			}
			
			for (var i=0; i < gs._zfGameData._inventory.length; i++)
			{
				var item = gs._zfGameData._inventory[i];
				// get the tile key -> fix tile key -> get correct market name -> fix color -> set it into inventory
//				if (!item)
//					continue;
				var key = item["tile"];
				if (key && !tim._tilePropertiesDictionary[key])
				{
					var newkey = tim.fixedTileKey(key, true);
					if(!tim._tilePropertiesDictionary[newkey])
					{
						toRemove.push(item);
					}
					else 
					{
						var colorArray = item.color;
						
						//FIXME: This have to be solve because color doesn't exist after the fight.
						var color = ccc3(255, 255, 255);
						if (colorArray)
	                    {
	                        color = ccc3(Number(colorArray[0]), Number(colorArray[1]), Number(colorArray[2]));
	                    }
						
						var marketItemDictionary = market.marketItemFromTileKey_withColor(newkey, color);
						NSAssert(marketItemDictionary, "marketItemDictionary missing");
						var marketKey = marketItemDictionary["name"];
						
						var mutable = {};// = item.concat();//duplicate
						for( var key in item )
						{
							mutable[key] = item[key];
						}
						
						mutable["tile"] = newkey;
						mutable["name"] = marketKey;
						
						gs._zfGameData._inventory[i] = mutable;
					}
				}
				else if (key && tim._tilePropertiesDictionary[key])
				{
					// tile exists now check for correct color
					var colorArray = item["color"];
					
					//FIXME: This have to be solve because color doesn't exist after the fight.
					var color = ccc3(255, 255, 255);
					if (colorArray)
					{
						color = ccc3(Number(colorArray[0]), Number(colorArray[1]), Number(colorArray[2]));
					}
					
					var marketItemDictionary = market.marketItemFromTileKey_withColor(key, color);
					if (marketItemDictionary)
					{
						var marketColorArray = marketItemDictionary["color"];
						
						if(marketColorArray)
						{
							var marketColor = ccc3(marketColorArray[0], marketColorArray[1], marketColorArray[2]);
						
							if(marketColor.getRed() != color.getRed() ||
							   marketColor.getGreen() != color.getGreen() || 
							   marketColor.getBlue() != color.getBlue())
							{
							    
								// replace item in storage with correct color
								var marketKey = marketItemDictionary["name"];
								
								var mutable = {};
								for( var key in item )
								{
									mutable[key] = item[key];
								}
								
								mutable["name"] = marketKey;
								mutable["color"] = marketColorArray;
								
								gs._zfGameData._inventory[i] = mutable;
							}
						}
					}
					
				}

			}
			
			for(var itemKey in toRemove)
			{
				var item = toRemove[itemKey];
				gs._zfGameData._inventory.splice(gs._zfGameData._inventory[item],1);
			}
			
			toRemove.length = 0;
		}
	},

	initElements: function($super)
	{
		$super();
		this.fixInventory();

		var w = CCDirector.winSize();
		var resolutionHeight = UI.Window._height;
		var heightScale = 1;
		var menuButtonOffset = 0;
		var browseOffset = 0;

		this._currentItemIndex = -1;
		
		//FIXME: set correct position of dismissMenu for other then 480x320 resolutions
	//	var dismissBox = this._dismissMenu._children[0];
	//	dismissBox.setScale(0.8);
	//	dismissBox.setPosition(ccpAdd(dismissBox.getPosition(), ccp(0, this._browseOffset*1.5)));
		var winSize = new Core.Size(480, 320 * this._heightScale);
		
		// clean up window behind storage menu
		this.cleanWindow(this.kZFMenuTags.kZFMenuTagBackground);
		
		//shed background
		var bgOverlay  = CCSpriteSheet.spriteSheetWithFile("hudElements.png");
		var mgrOverlay  = CCSpriteSheet.spriteSheetWithFile("hudElements.png");

		this._myHeightOffset = w._height/2 - 158;//w._height/2 - bgOverlay.getContentSize()._height/2;
		
		bgOverlay.setPosition(ccpAdd(bgOverlay.getPosition(), ccp(this._widthOffset, this._myHeightOffset)));
		mgrOverlay.setPosition(ccpAdd(mgrOverlay.getPosition(), ccp(this._widthOffset, 0)));
		
//		bgOverlay.setPosition(ccp(w._width/2, w._height/2));
//		mgrOverlay.setPosition(ccp(w._width/2, w._height/2));
				
		var max = 28;
		var buff = 26;
		for (var i = 0; i <= max; i++)
		{
			var roof = null;
			
			if (i == 0)
			{
				roof = CCSprite.spriteWithSpriteSheet(bgOverlay, CGRectMake(279,470,50,34));
			}
			else if (i == max)
			{
				roof = CCSprite.spriteWithSpriteSheet(bgOverlay, CGRectMake(279,470,50,34));
				roof.setFlipX(true);				
				buff += 18;
			}
			else
			{
				roof = CCSprite.spriteWithSpriteSheet(bgOverlay, CGRectMake(337,470,15,34));
			}

			bgOverlay.addChild(roof, 3, 300 + i);
			roof.setPosition(ccp(buff + (i * 14), 120 + 90 * 2/*winSize._height - 20 + this._heightOffset*/));
			
			if (i==0)
			{
				buff += 18;
			}
		}
		
		max = 16;
		
		
		for (var i = 0; i <= max; i++)
		{
			var sideL = CCSprite.spriteWithSpriteSheet(bgOverlay, CGRectMake(329,429,24,16));
			var sideR = CCSprite.spriteWithSpriteSheet(bgOverlay, CGRectMake(329,429,24,16));
			sideR.setFlipX(true);
			bgOverlay.addChild(sideL, 2, 0);
			bgOverlay.addChild(sideR, 2, 0);
			sideL.setPosition(CGPointMake(18, 35 + 15 * i));
			sideR.setPosition(CGPointMake(480-18, 35 + 15 * i));
		}
		
		max = 15;
		buff = 34;
		for (var i = 0; i <= max; i++)
		{
			var shelf1 = null;
			var shelf2 = null;
			var shelf3 = null;
			var shelf4 = null;
			var shelf5 = null;
			
			if (i == 0)
			{
				shelf1 = CCSprite.spriteWithSpriteSheet(bgOverlay, CGRectMake(326,451,30,10));
				shelf2 = CCSprite.spriteWithSpriteSheet(bgOverlay, CGRectMake(326,451,30,10));
				if (heightScale>1)
				{
					shelf3 = CCSprite.spriteWithSpriteSheet(bgOverlay, CGRectMake(326,451,30,10));
					shelf4 = CCSprite.spriteWithSpriteSheet(bgOverlay, CGRectMake(326,451,30,10));
					shelf5 = CCSprite.spriteWithSpriteSheet(bgOverlay, CGRectMake(326,451,30,10));
				}
			}
			else if (i == max)
			{
				shelf1 = CCSprite.spriteWithSpriteSheet(bgOverlay, CGRectMake(326,451,30,10));
				shelf2 = CCSprite.spriteWithSpriteSheet(bgOverlay, CGRectMake(326,451,30,10));
				shelf1.setFlipX(true);
				shelf2.setFlipX(true);
//				if (heightScale>1)
//				{
//					shelf3 = [CCSprite spriteWithSpriteSheet:bgOverlay rect:CGRectMake(326,451,30,10)];
//					shelf4 = [CCSprite spriteWithSpriteSheet:bgOverlay rect:CGRectMake(326,451,30,10)];
//					shelf5 = [CCSprite spriteWithSpriteSheet:bgOverlay rect:CGRectMake(326,451,30,10)];
//					shelf3.flipX = YES;
//					shelf4.flipX = YES;
//					shelf5.flipX = YES;
//				}
				buff -= 23;
			}
			else
			{
				shelf1 = CCSprite.spriteWithSpriteSheet(bgOverlay, CGRectMake(362,451,32,10));
				shelf2 = CCSprite.spriteWithSpriteSheet(bgOverlay, CGRectMake(362,451,32,10));
//				if (heightScale>1)
//				{
//					shelf3 = [CCSprite spriteWithSpriteSheet:bgOverlay rect:CGRectMake(362,451,32,10)];
//					shelf4 = [CCSprite spriteWithSpriteSheet:bgOverlay rect:CGRectMake(362,451,32,10)];
//					shelf5 = [CCSprite spriteWithSpriteSheet:bgOverlay rect:CGRectMake(362,451,32,10)];
//				}
			}

			bgOverlay.addChild(shelf1, 3, 0);
			bgOverlay.addChild(shelf2, 3, 0);
			shelf1.setPosition(ccp(buff + (i*29),  120/*  - this._heightOffset*/));
			shelf2.setPosition(ccp(buff + (i*29),  120 + 90 /* - this._heightOffset*/));
//			if (heightScale>1)
//			{
//				[bgOverlay addChild:shelf3 z:3 tag:0];
//				[bgOverlay addChild:shelf4 z:3 tag:0];
//				[bgOverlay addChild:shelf5 z:3 tag:0];
//				[shelf3 setPosition:CGPointMake(buff + (i * 29), winSize.height - 120 - 90 - 90)];
//				[shelf4 setPosition:CGPointMake(buff + (i * 29), winSize.height - 120 - 90 - 90 - 90)];
//				[shelf5 setPosition:CGPointMake(buff + (i * 29), winSize.height - 120 - 90 - 90 - 90 - 90)];
//			}
			
			if (i==0)
			{
				buff -= 1;
			}
		}
		
		var groundWidthOffset = 0;
//		if (heightScale>1)
//		{
//			max = 40;
//			groundWidthOffset = -270;
//		}
//		else {
			max = 15;
//		}

		for (var i = 0; i <= max; i++)
		{
			var ground = CCSprite.spriteWithSpriteSheet(mgrOverlay, CGRectMake(361,472,33,32));
			mgrOverlay.addChild(ground, 3, 0); 
			ground.setPosition(CGPointMake(9 + (i * 31)+groundWidthOffset, 15 + this._myHeightOffset));
		}
		
//		var roofShadow = CCColorLayer.layerWithColor(ccc3(0,0,0), 480 - 12, 5);
//		roofShadow.setOpacity(0x40);
//		this._windowNode.addChild(roofShadow, 3, this.kStorageMenuTags.kStorageMenuTagRoofShade);
//		roofShadow.setPosition(6 + this._widthOffset, winSize._height - 42 + this._myHeightOffset + 3);
		
		var zombieHead = CCSprite.spriteWithSpriteSheet(mgrOverlay, CGRectMake(358,420,26,24));
		mgrOverlay.addChild(zombieHead, 3, 0);
		zombieHead.setPosition(CGPointMake(30, 13 + this._myHeightOffset));
		
		var zombieArm = CCSprite.spriteWithSpriteSheet(mgrOverlay, CGRectMake(390,420,16,24));
		mgrOverlay.addChild(zombieArm, 3, 0);
		zombieArm.setPosition(CGPointMake(30+20, 13+22 + this._myHeightOffset));
		
		// 24 = width of side tile
		// 18 = x position of side tile
		var colorLayerWidthOffset = (24 + 18/2) * 2 - 10;
		
		// 34 = height of roof tile
		// 20 = y position of roof tile (i.e. 20 pixels down)
		var colorLayerHeightOffset = (34 + 20/2) * 2 - 30;
		
//		var windowColorSize = CGRectMake(279,470,50,34).getSize();
//		var windowColor = CCColorLayer.layerWithColor(ccc3(206,190,124), (windowColorSize._width  - colorLayerWidthOffset), (windowColorSize._height - colorLayerHeightOffset));
//		this.addChild(windowColor, 1, this.kStorageMenuTags.kStorageMenuTagBGColor);
		
//		var windowColor = CCColorLayer.layerWithColor(ccc3(206,190,124), (winSize._width  - colorLayerWidthOffset), (winSize._height - colorLayerHeightOffset));
		
		var windowColor = CCColorLayer.layerWithColor(ccc3(206,190,124), (466), (279));
		
		this._windowNode.addChild(windowColor, 1, this.kStorageMenuTags.kStorageMenuTagBGColor);
		
		this._windowNode.addChild(bgOverlay, 2, this.kStorageMenuTags.kStorageMenuTagBG);
		this._windowNode.addChild(mgrOverlay, 3, this.kStorageMenuTags.kStorageMenuTagBGOverlay);
		
		windowColor.setPosition(ccp(colorLayerWidthOffset/2+this._widthOffset, colorLayerHeightOffset/2));
		windowColor.setPosition(ccp(w._width/2 - 235 + 2, w._height/2));

		this.initBrowseMenuWithPosition(ccp(480 / 2, 160 + this._heightOffset + this._myHeightOffset/* TODO: winSize._height/2 - menuHeightOffset+ browseOffset(*/), 450);	
		
		var sprite1a = CCSprite.spriteWithFile("menuButtonDn.png");
		var sprite1b = CCSprite.spriteWithFile("menuButtonDn.png");
		var sprite2a = CCSprite.spriteWithFile("menuButtonDn.png");
		var sprite2b = CCSprite.spriteWithFile("menuButtonDn.png");
		sprite1a.setColor(ZFColorDefines.colorDarkBrownButton);//colorBrownButton;
		sprite2a.setColor(ZFColorDefines.colorYellowButton);
		sprite1b.setColor(ZFColorDefines.colorDarkBrownButton);//colorBrownButton;
		sprite2b.setColor(ZFColorDefines.colorYellowButton);
		var boostItemA = CCMenuItemImage.itemFromNormalSprite(sprite1a, sprite1b);
		var boostItemB = CCMenuItemImage.itemFromNormalSprite(sprite2a, sprite2b);
		var boosts = CCMenuItemToggle.itemWithTarget(this, this.boostsButtonPressed.bind(this), [boostItemA, boostItemB]);

		sprite1a = CCSprite.spriteWithFile("menuButtonDn.png");
		sprite1b = CCSprite.spriteWithFile("menuButtonDn.png");
		sprite2a = CCSprite.spriteWithFile("menuButtonDn.png");
		sprite2b = CCSprite.spriteWithFile("menuButtonDn.png");
		sprite1a.setColor(ZFColorDefines.colorDarkBrownButton);//colorBrownButton;
		sprite2a.setColor(ZFColorDefines.colorYellowButton);
		sprite1b.setColor(ZFColorDefines.colorDarkBrownButton);//colorBrownButton;
		sprite2b.setColor(ZFColorDefines.colorYellowButton);
		var decorItemA = CCMenuItemImage.itemFromNormalSprite(sprite1a, sprite1b);
		var decorItemB = CCMenuItemImage.itemFromNormalSprite(sprite2a, sprite2b);
		var decors = CCMenuItemToggle.itemWithTarget(this, this.decorsButtonPressed.bind(this), [decorItemA, decorItemB]);

		decors.setSelectedIndex(1);
		
		this._decorDisplayMenu = CCMenu.menuWithItems([decors]);
		this._decorDisplayMenu.setPosition(ccp(150 + this._widthOffset, this._myHeightOffset));
		this._decorDisplayMenu.setScale(0.5);
		this._windowNode.addChild(this._decorDisplayMenu, 100);
		//this._decorDisplayMenu.setPosition(ccp(w._width/2, w._height/2));
	
		this._decorLabel = CCLabel.labelWithString(NSLocalizedString("Decors"), "Arial-BoldMT", 12.5);
		this._decorLabel.setColor(ccc3(0,0,0));
		this._decorLabel.setPosition(ccp(195 + this._widthOffset, 9+this._myHeightOffset));
		this._decorLabel.setAnchorPoint(ccp(0.5, 1));
		this._windowNode.addChild(this._decorLabel, 101);
		//this._decorLabel.setPosition(ccp(w._width/2, w._height/2));
		
		this._boostDisplayMenu = CCMenu.menuWithItems([boosts]);
		this._boostDisplayMenu.setPosition(250 + this._widthOffset, this._myHeightOffset);
		this._boostDisplayMenu.setScale(0.5);
		this._windowNode.addChild(this._boostDisplayMenu, 100);
		//this._boostDisplayMenu.setPosition(ccp(w._width/2, w._height/2));
				
		this._boostLabel = CCLabel.labelWithString(NSLocalizedString("Boosts"), "Arial-BoldMT", 12.5);
		this._boostLabel.setColor(ccc3(0,0,0));
		this._boostLabel.setPosition(ccp(295 + this._widthOffset, 9+this._myHeightOffset));
		this._boostLabel.setAnchorPoint(ccp(0.5, 1));
		this._windowNode.addChild(this._boostLabel, 101);
		//this._boostLabel.setPosition(ccp(w._width/2, w._height/2));
		
		this._displayBoosts = false;
		
		this._windowNode.setScale(CCDirector.zoomValue());
		if(CCDirector.zoomValue()._x > 1.0)
			this._windowNode.setPosition(new Core.Point(-this._windowNode.getSize()._width*1/8, -this._windowNode.getSize()._height* 1/8));
	},


	displayPage: function(pageID)
	{
		var gs = GameState;
		var market = ZFMarketMenu.theMarket();
		var index = pageID * (INVENTORY_ITEMS_PER_PAGE + this._additionalStorageItems);
		
		if (this._menu)
		{
			this._menu.removeAllChildrenWithCleanup(true);
			this._windowNode.removeChild(this._menu, true);
			destroy(this._menu);
			this._menu = null;
		}
		
		for(var i = 0; i < (INVENTORY_ITEMS_PER_PAGE + this._additionalStorageItems) * (MAX_INVENTORY_PAGES + this._additionalStoragePages); i++)
		{
			this._windowNode.removeChildByTag(this.kStorageMenuTags.kStorageMenuTagSpriteNode, true);
			this._windowNode.removeChildByTag(this.kStorageMenuTags.kStorageMenuTagItemSpriteSheet, true);
			this._windowNode.removeChildByTag(this.kStorageMenuTags.kStorageMenuTagItemCountLabel, true);
		}
		
		for (var i=0; i < INVENTORY_ROWS_PER_PAGE+this._additionalStorageRows; i++)
		{
			var dim = this._windowNode.getChildByTag(this.kStorageMenuTags.kStorageMenuTagDimRow);
			if (dim)
			{
				dim.removeAllChildrenWithCleanup(true);
			}
			
			this._windowNode.removeChild(dim, true);
		}
		
		// Get the number of boosts for this page
		if(pageID > 0)
		{
			for(var i = 0; i < (INVENTORY_ITEMS_PER_PAGE + this._additionalStorageItems); i++)
			{
				if(i >= gs._zfGameData._inventory.length)
					break;
				
				var storageItemDict = gs._zfGameData._inventory[i];
				var storageItem = this.storageItemFromInventoryDictionary(storageItemDict);
				
				if(storageItem && storageItem.subCategory == "boost")
					index++;
			}
		}

		var count = 0;
		itemsLayers = [];
		while(index < (gs._zfGameData._inventory.length)) 
		{
			var storageItemDict = gs._zfGameData._inventory[index++];
			var storageItem = this.storageItemFromInventoryDictionary(storageItemDict);
		
			// Break if the count exceedes the amount of items that should be displayed on this page
			if(count >= (/*(pageID + 1)*/1 * (INVENTORY_ITEMS_PER_PAGE + this._additionalStorageItems)))
				break;
			
			//FIXME: JP: This is required since the inventory comes with an empty array at the beggining
			if(storageItem == null)
				continue;
			
			// Continue if the item IS a boost but we are NOT displaying boosts
			if(storageItem.subCategory == "boost" && !this._displayBoosts)
				continue;
			
			// Continue if the item is NOT a boost and we ARE displaying boosts
			if(storageItem.subCategory != "boost" && this._displayBoosts)
				continue;
			
			var spriteNode = market.spriteNodeFromKey(storageItem["tile"], true, market.marketColorFromName(storageItem["name"]));
			var mgr = market.spritesheetFromItem(storageItem);
			var sprite = null;

			var color = this.colorFromDictionary(storageItem);
			
			var x = 62 + ((count % 8) * 51);
			var y = 240 - (Math.floor(count / 8) * 85 - 10);
			var pos = ccp(x+this._widthOffset, y+this._menuHeightOffset + this._myHeightOffset);
			
			
			if(spriteNode)
			{
				this._windowNode.addChild(spriteNode, 1002, this.kStorageMenuTags.kStorageMenuTagSpriteNode );
				sprite = spriteNode;

				for(var i in spriteNode._children)
				{
					spriteNode._children[i].setColor(color);
				}
			}
			else
			{
				this._windowNode.addChild(mgr, 1001, this.kStorageMenuTags.kStorageMenuTagItemSpriteSheet);
				var temp = mgr._children[0];
				temp.setColor(color);
				
				sprite = temp;
			}
			
			sprite.setPosition(pos);
			sprite.setVisible(true);
			
			if (storageItemDict["count"])
			{
				var countLabel = CCLabel.labelWithString(sprintf("x%i", storageItemDict["count"]), "Arial", 26);
				countLabel.setScale(0.54);
				this._windowNode.addChild(countLabel, 1002, this.kStorageMenuTags.kStorageMenuTagItemCountLabel);
				countLabel.setPosition(ccpAdd(sprite.getPosition(), ccp(0,-25)));
			}
			
			
			// SHIKAKA : not being released ?
			var cl = CCColorLayer.layerWithColor(ccc3(0xff, 0, 0, 0), 50, 50);
			cl.setOpacity(0);
			var storageMenuItem = new CCMenuItemLayer();
			storageMenuItem.initFromLayer(cl, storageMenuItem, this.itemTapped.bind(this));
			storageMenuItem._tag = (index - 1);
			storageMenuItem.setPosition(sprite.getPosition());

			itemsLayers.push(storageMenuItem);
			
			count++;
		}

		destroy(this._menu);
		this._menu = CCMenu.menuWithItems(itemsLayers);
		
		{	
			this._menu.setPosition(ccp(-25,-25));
			this._windowNode.addChild(this._menu, 1002);
		}

		if(!this._displayBoosts)
		{
			//dimmed out storage rows
			for (var i = 0; i < INVENTORY_ROWS_PER_PAGE + this._additionalStorageRows; i++)
			{
				if(this.storageSlotsAllowed() <= pageID * (INVENTORY_ITEMS_PER_PAGE + this._additionalStorageItems) + (i * INVENTORY_ITEMS_PER_ROW) )
				{
					var dimRow = CCColorLayer.layerWithColor(ccc3(0,0,0), 480 - 29 * 2, 81);
					dimRow.setPosition(ccp(29 + this._widthOffset, 205 - (i * 90) + this._menuHeightOffset + 50 + this._myHeightOffset));
					this._windowNode.addChild(dimRow, 1, this.kStorageMenuTags.kStorageMenuTagDimRow);
					
					var label = CCLabel.labelWithString(NSLocalizedString("Locked"), "AmericanTypewriter-Bold", 20);
					label.setPosition(ccp(dimRow.getContentSize()._width/2, dimRow.getContentSize()._height/2 - 40));
	                label.setOpacity(0x80);
					dimRow.addChild(label);
				}
			}
		}
		
		// If we are on the boost display, dont show pages
		if(!this._displayBoosts)
		{
			this._forwardItem.setVisible(this._currentPage != MAX_INVENTORY_PAGES+this._additionalStoragePages-1);
			this._forwardItem.setIsEnabled(this._currentPage != MAX_INVENTORY_PAGES+this._additionalStoragePages-1);
			this._backItem.setVisible(this._currentPage != 0);
			this._backItem.setIsEnabled(this._currentPage != 0);
		}
	},
		
	openMenuWithBoostPageDisplayed: function(boostPageDisplayed)
	{
		var gs = GameState;

		if(this.storageSlotsAllowed() <= 0 && gs._zfGameData._inventory.length == 0)
		{
			this.noStorageMessage();
			return;
		}
	    
		this.initElements();
	    this._displayBoosts = boostPageDisplayed;
	    
	    this._boostDisplayMenu._children[0].setSelectedIndex(1);
	    this._decorDisplayMenu._children[0].setSelectedIndex(0);
	    
	    this._forwardItem.setVisible(false);
		this._forwardItem.setIsEnabled(false);
		this._backItem.setVisible(false);
		this._backItem.setIsEnabled(false);
		
	    this.setVisible(true);
	    var action = CCMoveTo.actionWithDuration(0.25, this.openPos());
	    this.runAction(action);

	    this.schedule(this.openTimerCallback, 0.25);

	    this._menuState = ZFMenu.menuStates.menuStateOpening;
	    this.displayPage(0);
		SimpleAudioEngine.playEffect(kMenuOpenSFX);
	},

	openMenu: function($super)
	{
		ZFGuiLayer.disableMenus();
		if(this.storageSlotsAllowed() <= 0 && GameState._zfGameData._inventory.length == 0)
		{
			this.noStorageMessage();
			ZFGuiLayer.enableMenus();
			return;
		}
		$super();
	},

	dismissMenu: function($super, sender)
	{
        $super(sender);
//		[[EventTracker eventTracker] sendEvent:@"zf_storage_dismiss" withParameters:nil andDelegate:nil];
	},

	
	dismissTimerCallback: function($super)
	{
		//cleanup here
		
		for (var i=0; i < (INVENTORY_ITEMS_PER_PAGE+this._additionalStorageItems) * (MAX_INVENTORY_PAGES+this._additionalStoragePages); i++)
		{
			this._windowNode.removeChildByTag(this.kStorageMenuTags.kStorageMenuTagItemSpriteSheet, true);
			this._windowNode.removeChildByTag(this.kStorageMenuTags.kStorageMenuTagSpriteNode, true);
		}
		
		for (i=0; i < (INVENTORY_ROWS_PER_PAGE+this._additionalStorageRows); i++)
		{
			var dim = this._windowNode.getChildByTag(this.kStorageMenuTags.kStorageMenuTagDimRow);
			
			if (dim)
			{
				this._windowNode.removeChild(dim);
				destroyWithChildren(dim);
			}
			
		}
		
//		var roofShade = this._windowNode.getChildByTag(this.kStorageMenuTags.kStorageMenuTagRoofShade);
//		roofShade.removeAllChildrenWithCleanup(true);
//		this._windowNode.removeChildByTag(this.kStorageMenuTags.kStorageMenuTagRoofShade, true);
		
		this._windowNode.removeChildByTag(this.kStorageMenuTags.kStorageMenuTagBGColor, true);

		var bg1 = this._windowNode.getChildByTag(this.kStorageMenuTags.kStorageMenuTagBG);
		for(var key = bg1._children.length-1; key >= 0; --key)
		{
			bg1.removeChild(bg1._children[key], true);
		}
		bg1.removeAllChildrenWithCleanup(true);
		this._windowNode.removeChildByTag(this.kStorageMenuTags.kStorageMenuTagBG, true);
		
		var bg2 = this._windowNode.getChildByTag(this.kStorageMenuTags.kStorageMenuTagBGOverlay);
		for(var key = bg2._children.length-1; key >= 0; --key)
		{
			bg2.removeChild(bg2._children[key], true);
		}
		bg2.removeAllChildrenWithCleanup(true);
		this._windowNode.removeChildByTag(this.kStorageMenuTags.kStorageMenuTagBGOverlay, true);
		
		if(this._decorDisplayMenu && this._decorDisplayMenu._parent)
			this._decorDisplayMenu.removeFromParentAndCleanup(true);
		if(this._boostDisplayMenu && this._boostDisplayMenu._parent)
			this._boostDisplayMenu.removeFromParentAndCleanup(true);
		if(this._decorLabel && this._decorLabel._parent)
			this._decorLabel.removeFromParentAndCleanup(true);
		if(this._boostLabel && this._boostLabel._parent)
			this._boostLabel.removeFromParentAndCleanup(true);
		
		this._decorDisplayMenu = null;
		this._boostDisplayMenu = null;
		this._decorLabel = null;
		this._boostLabel = null;
		
		this._windowNode.removeChildByTag(this.kStorageMenuTags.kStorageMenuTagItemSpriteSheet, true);
		this._windowNode.removeChildByTag(this.kStorageMenuTags.kStorageMenuTagItemCountLabel, true);
		this._windowNode.removeChildByTag(this.kStorageMenuTags.kStorageMenuTagBGOverlay);
		this._windowNode.removeChildByTag(this.kStorageMenuTags.kStorageMenuTagBG, true);
		this._windowNode.removeChildByTag(this.kStorageMenuTags.kStorageMenuTagBGColor, true);
		this._windowNode.removeChildByTag(this.kStorageMenuTags.kStorageMenuTagRoofShade, true);
		this._windowNode.removeChildByTag(this.kStorageMenuTags.kStorageMenuTagDimRow, true);
		this._windowNode.removeChildByTag(this.kStorageMenuTags.kStorageMenuTagSpriteNode, true);
		
		for(var key = this._windowNode._children.length-1; key >= 0; --key)
		{
			this._windowNode._children[key] && this._windowNode.removeChild(this._windowNode._children[key], true);
		}
		
		ZFGuiLayer.gui().enableMenus();
		$super();
		
		
//		//cleanup here		
//		for (var i=0; i < (INVENTORY_ITEMS_PER_PAGE + this._additionalStorageItems) * (MAX_INVENTORY_PAGES + this._additionalStoragePages); i++)
//		{
//			var it1 = this._windowNode.getChildByTag(this.kStorageMenuTags.kStorageMenuTagItemSpriteSheet);
//			var it2 = this._windowNode.getChildByTag(this.kStorageMenuTags.kStorageMenuTagSpriteNode);
//			
//			if(it1 && it2) tmp;
//			
//			this._windowNode.removeChild(it1);
//			this._windowNode.removeChild(it2);
//			
//			destroyWithChildren(it1);
//			destroyWithChildren(it2);
//		}
//		
//		
////		for (int i=0; i < (INVENTORY_ROWS_PER_PAGE+additionalStorageRows); i++)
////		{
////			CCColorLayer *dim = (CCColorLayer*)[self getChildByTag:kStorageMenuTagDimRow];
////			
////			if (dim)
////			{
////				[dim removeAllChildrenWithCleanup:YES];
////			}
////			[self removeChild:dim cleanup:YES];
////		}
////		
////		CCColorLayer *roofShade = (CCColorLayer *)[self getChildByTag:kStorageMenuTagRoofShade];
////		[roofShade removeAllChildrenWithCleanup:YES];
////		[self removeChildByTag:kStorageMenuTagRoofShade cleanup:YES];
////		
////		[self removeChildByTag:kStorageMenuTagBGColor cleanup:YES];
////
////		CCSpriteSheet *bg1 = (CCSpriteSheet *)[self getChildByTag:kStorageMenuTagBG];
////		[bg1 removeAllChildrenWithCleanup:YES];
////		[self removeChildByTag:kStorageMenuTagBG cleanup:YES];
////		
////		CCSpriteSheet *bg2 = (CCSpriteSheet *)[self getChildByTag:kStorageMenuTagBGOverlay];
////		[bg2 removeAllChildrenWithCleanup:YES];
////		[self removeChildByTag:kStorageMenuTagBGOverlay cleanup:YES];
////		
////		if(decorDisplayMenu && decorDisplayMenu.parent)
////			[decorDisplayMenu removeFromParentAndCleanup:YES];
////		if(boostDisplayMenu && boostDisplayMenu.parent)
////			[boostDisplayMenu removeFromParentAndCleanup:YES];
////		if(decorLabel && decorLabel.parent)
////			[decorLabel removeFromParentAndCleanup:YES];
////		if(boostLabel && boostLabel.parent)
////			[boostLabel removeFromParentAndCleanup:YES];
////		
////		self.decorDisplayMenu = nil;
////		self.boostDisplayMenu = nil;
////		self.decorLabel = nil;
////		self.boostLabel = nil;
////		
//		
//		ZFGuiLayer.gui().enableMenus();
////		[[ZFGuiLayer gui] enableMenus];
////		[super dismissTimerCallback];
//		
//		$super();
	},

	storeItemFromCurrentItemCoordinates: function()
	{
		var gui = ZFGuiLayer;
		gui.removeToolTip();

		if(this._currentItemCoordinates._x == -1 || this._currentItemCoordinates._y == -1)
		{
			return false;
		}
		
		var tSprite = TSprite.findByCoordinates(this._currentItemCoordinates);
		this._currentItemCoordinates = ccp(-1, -1);
		return this.addItemToStorage(tSprite, true);
	},
	
	//- (BOOL)showInformativeSlideInForActor
	showInformativeSlideInForActor: function()
	{
		if(!this._currentActor || !this._currentActor instanceof StageActor)
		{
			return false;
		}
		
		var gui = ZFGuiLayer.gui();
		var market = ZFMarketMenu.theMarket();
		
		var marketDict = market.marketItemFromTileKey_withColor(this._currentActor._key, this._currentActor._savedColor);
		var sprite = market.spriteNodeFromKey(marketDict["tile"], true, this._currentActor._savedColor);
		var message = NSLocalizedString(marketDict["flavorText"]);
		
		var aw = gui.displayAlertSlideInInformative(NSLocalizedString(marketDict["name"]),
													message,
													sprite,
													ZFGameDefines.HUDELEMENTS1_FILE,
													CGRectMake(1,253,180,54),
										 			CGRectMake(182,253,180,54),
												 	NSLocalizedString("Put in Storage"),
												 	colorGreenButton,
												  	false);
		aw._delegate = this;
		aw._idTag = this.kStorageAlert.kStorageAlertWindowIDTagConfirmStoreActor;
		
		gui.removeToolTip();
		
		return true;
	},

	showInformativeSlideIn: function()
	{
		var gui = ZFGuiLayer.gui();
		var market = ZFMarketMenu.theMarket();
		gui.removeToolTip();
		
		if (this._currentItemCoordinates._x == -1 || this._currentItemCoordinates._y == -1)
		{
			return false;
		}
		
		var tSprite = TSprite.findByCoordinates(this._currentItemCoordinates);
		var marketDict = market.marketItemFromTileKey_withColor(tSprite._tile._key, tSprite._tile._color);
		var mgr = market.spritesheetFromItem(marketDict);
		
		var sprite = mgr._children[0];
		sprite.setColor(this.colorFromDictionary(marketDict));
		var message = NSLocalizedString(marketDict["flavorText"]);
		
		if (tSprite._tile._key == "mausoleum1" || tSprite._tile._key == "mausoleum2" || tSprite._tile._key == "mausoleum3")
		{
			message = NSLocalizedString(marketDict["flavorTextAlt"]);
		}
		
		if (!message)
		{
			message = NSLocalizedString(marketDict["info2"]);
		}
		
		if (!message)
		{
			message = NSLocalizedString(marketDict["info"]);
		}
		
		// the tile sprite is still a spritesheet
		var spriteNode = market.spriteNodeFromKey(tSprite._tile._key, true, tSprite._tile._color);
//	#ifdef ZF_REMOTE_MARKET
//		ZFAlertWindow *aw = nil;
//		if ([tSprite.tile.key isEqualToString:@"missingItem"])
//		{		
//			CGSize w = [[CCDirector sharedDirector] winSize];
//			CGRect windowRect = CGRectMake((w.width - 480) / 2, w.height - (w.height - 240) / 2, 480, 240);
//			aw = [gui displayAlertSimple:NSLocalizedString([marketDict objectForKey:@"name"], [marketDict objectForKey:@"name"])
//								withMessage:message
//							  withSprite:(CCSprite *)spriteNode
//							  withWindow: windowRect];
//		}
//		else {
//			aw = [gui displayAlertSlideInInformative:NSLocalizedString([marketDict objectForKey:@"name"], [marketDict objectForKey:@"name"])
//										 withMessage:message
//										  withSprite:spriteNode//[mgr.children objectAtIndex:0]
//										 withHudFile:HUDELEMENTS1_FILE
//									  withButtonRect:CGRectMake(1,253,180,54)
//							  withButtonSelectedRect:CGRectMake(182,253,180,54)
//									  withButtonText:NSLocalizedString(@"Put in Storage", @"Place in storage button text")
//									 withButtonColor:colorGreenButton
//									   slideFromLeft:NO];
//			aw.delegate = self;
//			aw.idTag = kStorageAlertWindowIDTagConfirmStore;
//
//		}
//
//	#else
		var aw = gui.displayAlertSlideInInformative(NSLocalizedString(marketDict["name"]),
													message,
													spriteNode,//[mgr.children objectAtIndex:0]
													ZFGameDefines.HUDELEMENTS1_FILE,
													CGRectMake(1,253,180,54),
													CGRectMake(182,253,180,54),
													NSLocalizedString("Put in Storage"),
													ZFColorDefines.colorGreenButton,
													false);
		aw._delegate = this;
		aw._idTag = this.kStorageAlert.kStorageAlertWindowIDTagConfirmStore;

//	#endif
		return true;
	},
	
	
	addMarketItemToStorage: function(key)
	{
		
		var market = ZFMarketMenu.theMarket();
		var dictionary = market.marketItemFromName(key);
		
		if(dictionary["amountGivenPerPurchase"])
		{
			// CONSUMEABLE
			
			var addToStorage = new ZFConsumable();
			addToStorage.initWithName(key, 1);
			this.addItemToStorage(addToStorage, false);
		}
		else 
		{
			// TILE
			var addToStorage = {"name" : dictionary["name"],
			                    "tile" : dictionary["tile"], 
			                    "color" : dictionary["color"],
			                    "stageActor" : dictionary["stageActor"]};
			
			this.addItemToStorage(addToStorage, false);
		}
	},

	addItemToStorage: function(/*id*/item, /*bool*/checkCapacity)
	{
		
		var tim = ZFTileManager;
		var gs = GameState;
		var market = ZFMarketMenu.theMarket();
		
		if (checkCapacity && !this.canAddToStorage())
		{
			return false;
		}
		
		if (item instanceof TSprite)
		{
			var tSprite = item;
			var marketItemDictionary = market.marketItemFromTileKey_withColor(tSprite._tile._key, tSprite._tile._color);
			var colorArray = [tSprite._tile._color.getRed() * 255, tSprite._tile._color.getGreen() * 255, tSprite._tile._color.getBlue() * 255];
			
			var key = tim.fixedTileKey(tSprite._tile._key, true);
			NSAssert(marketItemDictionary, "marketItemDictionary missing");
			var itemDictionary ={	"name" : marketItemDictionary["name"],
									"tile" : key,
									"color" : colorArray };
			gs._zfGameData._inventory.push(itemDictionary);
			tim.deleteTile(tSprite._tile._rootTile);
			return true;
		}
		else if (item instanceof ZFConsumable)
		{
			var consumable = item;
			var exsistingConsumable = null;
			for (var key in gs._zfGameData._inventory)
			{
				var dict = gs._zfGameData._inventory[key];
				if (!dict) {
					console.log("null item on gs._zfGameData._inventory with key: " + key + ", removing it.");
					gs._zfGameData._inventory.splice(key,1);
					continue;
				}
				var name = dict["name"];
				if (name == consumable._name)
				{
					var ct = dict["count"];
					consumable._count += ct;
					exsistingConsumable = dict;
					break;
				}
			}
			
			//item already an array in javascript ?			
			var itemDictionary = {};
			itemDictionary["name"] = consumable._name;
			itemDictionary["count"] = consumable._count;
			
			if (exsistingConsumable)
			{
				gs._zfGameData._inventory.splice(gs._zfGameData._inventory.indexOf(exsistingConsumable), 1, itemDictionary);
			}
			else
			{
				gs._zfGameData._inventory.push(itemDictionary);
			}
			
			
			return true;
		} else //if (item.classname == "object")
			{
				gs._zfGameData._inventory.push(item);
			}
			 

		return false;
	},

	//- (void)restoreItemFromTool:(ZFGameTool*)tool
	restoreItemFromTool: function(tool)
	{
		var gs = GameState;
		
		if (this._currentItemIndex >= 0  && this._currentItemIndex < gs._zfGameData._inventory.length)
		{
			gs._zfGameData._inventory.splice(this._currentItemIndex, 1);
		}
	},

	storageItemFromInventoryDictionary: function(storageItemDict)
	{
		var market = ZFMarketMenu.theMarket();	
		var storageItemTile = storageItemDict["tile"];
		var storageItemName = storageItemDict["name"];
		var colorArray = storageItemDict["color"];
		
		var color = ccc3(255,255,255);
		if(colorArray)
		{
			color = ccc3(Number(colorArray[0]), Number(colorArray[1]), Number(colorArray[2]));
		}
		
		var storageItem = null;
		var consumable = this.isConsumable(storageItemDict);

		if (!consumable)
		{
			storageItem = market.marketItemFromTileKey_withColor(storageItemTile, color);
		}
		else 
		{
			for (var key in market._marketArray)
			{
				var item = market._marketArray[key];
				if (item["name"] == storageItemName)
				{
					if (!consumable && item["tile"] != storageItemTile)
					{
						continue;
					}
					
					storageItem = item;
				}
			}
		}
		
		if (!storageItem)
		{
		    for (var key in market._marketArray)
			{
			    var item = market._marketArray[key];
				if (item && item.tile == "missingItem")
				{
					return item;
				}
			}
			
		    return null;
		}
		
		return storageItem;
	},

	//- (void)missingItemCheck
	missingItemCheck: function()
	{
		var gs = GameState;
		var hasBlueGrave = this.doesOwnItem("gravestoneBlue");
		var hasRedGrave = this.doesOwnItem("gravestoneRed");
		var hasZombieMonolith = this.doesOwnItem("monolithZombie");
		var hasPlowingMonolith = this.doesOwnItem("monolithPlowing");
		var hasMutationMonolith = this.doesOwnItem("monolithMutation");
		var hasSpeedMonolith = this.doesOwnItem("monolithSpeed");
		var hasCombineMonolith = this.doesOwnItem("monolithCombine");
		
		var hasMausoleum01 = this.doesOwnItem("mausoleum1");
		var hasMausoleum02 = this.doesOwnItem("mausoleum2");
		var hasMausoleum03 = this.doesOwnItem("mausoleum3");
		
		var hasStorage = 0;
		if(this.doesOwnItem("storage01"))
			hasStorage = 1;
		if(this.doesOwnItem("storage02"))
			hasStorage = 2;
		if(this.doesOwnItem("storage03"))
			hasStorage = 3;
		if(this.doesOwnItem("storage04"))
			hasStorage = 4;
		if(this.doesOwnItem("storage05"))
			hasStorage = 5;
		if(this.doesOwnItem("storage06"))
			hasStorage = 6;
		if(this.doesOwnItem("storage07"))
			hasStorage = 7;
		if(this.doesOwnItem("storage08"))
			hasStorage = 8;
		
		switch(hasStorage)
		{
			case 8:gs._zfGameData._purchaseFlags.setFlag(ZFGameFlags.PFLAG_STORAGE08);
			case 7:gs._zfGameData._purchaseFlags.setFlag(ZFGameFlags.PFLAG_STORAGE07);
			case 6:gs._zfGameData._purchaseFlags.setFlag(ZFGameFlags.PFLAG_STORAGE06);
			case 5:gs._zfGameData._purchaseFlags.setFlag(ZFGameFlags.PFLAG_STORAGE05);
			case 4:gs._zfGameData._purchaseFlags.setFlag(ZFGameFlags.PFLAG_STORAGE04);
			case 3:gs._zfGameData._purchaseFlags.setFlag(ZFGameFlags.PFLAG_STORAGE03);
			case 2:gs._zfGameData._purchaseFlags.setFlag(ZFGameFlags.PFLAG_STORAGE02);
			case 1:gs._zfGameData._purchaseFlags.setFlag(ZFGameFlags.PFLAG_STORAGE01);	break;
			default:	break;
		}
		
		
		//restore the item if you have the flag
		if(gs._zfGameData._mausoleumFlags & ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM01 && !hasMausoleum01 &&
		   (!(gs._zfGameData._mausoleumFlags & ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM02) && !(gs._zfGameData._mausoleumFlags & ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM03)))
		{
			this.restoreItem("mausoleum1");
		}
		if(gs._zfGameData._mausoleumFlags & ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM02 && !hasMausoleum02 &&
		   !(gs._zfGameData._mausoleumFlags & ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM03))
		{
			this.restoreItem("mausoleum2");
		}
		if(gs._zfGameData._mausoleumFlags & ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM03 && !hasMausoleum03)
		{
			this.restoreItem("mausoleum3");
		}
		if (gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_UNLOCK_BLUE) && !hasBlueGrave)
		{
			this.restoreItem("gravestoneBlue");
		}
		
		if (gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_UNLOCK_RED) && !hasRedGrave)
		{
			this.restoreItem("gravestoneRed");
		}
		
		if (gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_NO_LIFELESS) && !hasZombieMonolith)
		{
			this.restoreItem("monolithZombie");
		}
		
		if (gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_NO_PLOWCOST) && !hasPlowingMonolith)
		{
			this.restoreItem("monolithPlowing");
		}
		
		if (gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_ALL_MUTATION) && !hasMutationMonolith)
		{
			this.restoreItem("monolithMutation");
		}
		
		if (gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_FARMER_SPEED) && !hasSpeedMonolith)
		{
			this.restoreItem("monolithSpeed");
		}
		
		if (gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_FASTER_COMBINE) && !hasCombineMonolith)
		{
			this.restoreItem("monolithCombine");
		}
		
		
		
		//restore the flag if you have the item
		if (hasMausoleum01 && !(gs._zfGameData._mausoleumFlags & ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM01))
		{
			gs._zfGameData._mausoleumFlags |= ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM01;
		}
		if (hasMausoleum02 && !(gs._zfGameData._mausoleumFlags & ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM02))
		{
			gs._zfGameData._mausoleumFlags |= ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM02;
		}
		if(hasMausoleum03 && !(gs._zfGameData._mausoleumFlags & ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM03))
		{
			gs._zfGameData._mausoleumFlags |= ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM03;
		}
		if (hasBlueGrave && !gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_UNLOCK_BLUE))
		{
			gs._zfGameData._purchaseFlags.setFlag(ZFGameFlags.PFLAG_UNLOCK_BLUE);
		}
		
		if (hasRedGrave && !gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_UNLOCK_RED))
		{
			gs._zfGameData._purchaseFlags.setFlag(ZFGameFlags.PFLAG_UNLOCK_RED);
		}
		
		if (hasZombieMonolith && !gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_NO_LIFELESS))
		{
			gs._zfGameData._purchaseFlags.setFlag(ZFGameFlags.PFLAG_NO_LIFELESS);
		}
		
		if (hasPlowingMonolith && !gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_NO_PLOWCOST))
		{
			gs._zfGameData._purchaseFlags.setFlag(ZFGameFlags.PFLAG_NO_PLOWCOST);
		}
		
		if (hasMutationMonolith && !gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_ALL_MUTATION))
		{
			gs._zfGameData._purchaseFlags.setFlag(ZFGameFlags.PFLAG_ALL_MUTATION);
		}
		
		if (hasSpeedMonolith && !gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_FARMER_SPEED))
		{
			gs._zfGameData._purchaseFlags.setFlag(ZFGameFlags.PFLAG_FARMER_SPEED);
		}
		
		if (hasCombineMonolith && !gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_FASTER_COMBINE))
		{
			gs._zfGameData._purchaseFlags.setFlag(ZFGameFlags.PFLAG_FASTER_COMBINE);
		}
	},

	//-(void)restoreItem:(NSString*)tileKey
	restoreItem: function(tileKey)
	{
		var gs = GameState;
		var market = ZFMarketMenu.theMarket();
		var marketItemDictionary = market.marketItemFromTilePropertiesKey(tileKey);
		var itemDictionary = {	"name" : marketItemDictionary["name"],
								"tile" : tileKey, 
								"color" : marketItemDictionary["color"] };
		gs._zfGameData._inventory.push(itemDictionary);
		this.restoreMessageWithItem(NSLocalizedString(marketItemDictionary["name"], marketItemDictionary["name"]));
	},
	
	boostsButtonPressed: function(sender)
	{
		this._boostDisplayMenu._children[0].setSelectedIndex(1);
		this._decorDisplayMenu._children[0].setSelectedIndex(0);
		

		if(!this._displayBoosts)
		{
			this._displayBoosts = true;
	        
			// Always show page 0
			this.displayPage(0);
			this._forwardItem.setVisible(false);
			this._forwardItem.setIsEnabled(false);
			this._backItem.setVisible(false);
			this._backItem.setIsEnabled(false);
		}
	},

	decorsButtonPressed: function(sender)
	{	
		this._boostDisplayMenu._children[0].setSelectedIndex(0);
		this._decorDisplayMenu._children[0].setSelectedIndex(1);
		

		if(this._displayBoosts)
		{
			this._displayBoosts = false;		
			this.displayPage(this._currentPage);
		}
	},

	itemTapped: function(sender)
	{
		var gui = ZFGuiLayer;
		var gs = GameState;
		var market = ZFMarketMenu;

		var storageMenuItem = sender;
		this._currentItemIndex = storageMenuItem._tag;
		var storageItemDict = gs._zfGameData._inventory[this._currentItemIndex];
		var consumable = this.isConsumable(storageItemDict);
		var buttonText = consumable ? NSLocalizedString("Use", "Use Button Text"): NSLocalizedString("Retrieve", "Retrieve Button Text");
		var storageItemName = storageItemDict.name;
		var fromLeft =/*(storageMenuItem.getPosition()._x<240)?0:1;*/ 0;
		if (this._heightOffset > 0)
		{
			fromLeft = 0;
		}
		var storageItem = this.storageItemFromInventoryDictionary(storageItemDict);
		var mgr = market.spritesheetFromItem(storageItem);
		var sprite = mgr._children[0];
		var spriteNode = market.spriteNodeFromKey(storageItemDict.tile, true);
		
		var color = this.colorFromDictionary(storageItemDict);
		
		if(!spriteNode)
		{
			sprite.setColor(color);
			spriteNode = sprite;
		}
		else 
		{
			for(var i in spriteNode._children)
			{
				spriteNode._children[i].setColor(color);
			}
		}
		
		var aw = null;

//	#ifdef ZF_REMOTE_MARKET
//		if ([[storageItem objectForKey:@"tile"] isEqualToString:@"missingItem"])
//		{		
//			buttonText = @"missingItem";
//		}
//		aw = [gui alertWindowSlideInInformativeWithSell:storageItemName
//												withMessage:[storageItem objectForKey:@"flavorText"] 
//												 withSprite:spriteNode 
//												withHudFile:HUDELEMENTS1_FILE 
//											 withButtonRect:CGRectMake(1,253,180,54) 
//									 withButtonSelectedRect:CGRectMake(182,253,180,54)
//											 withButtonText:buttonText
//											withButtonColor:colorGreenButton
//										 withSellButtonRect:CGRectMake(1,253,180,54) 
//								 withSellButtonSelectedRect:CGRectMake(182,253,180,54)
//										 withSellButtonText:NSLocalizedString(@"Sell", nil)
//										withSellButtonColor:colorRedButton
//											  slideFromLeft:fromLeft];
//
//	#else
		aw = gui.alertWindowSlideInInformativeWithSell(storageItemName, storageItem["flavorText"], spriteNode, "hudElements.png", CGRectMake(1, 253, 180, 54), 
													   CGRectMake(182, 253, 180, 54), buttonText, ZFColorDefines.colorGreenButton, CGRectMake(1, 253, 180, 54),
													   CGRectMake(182, 253, 180, 54), NSLocalizedString("Sell"), ZFColorDefines.colorRedButton, fromLeft);

//	#endif

		aw._idTag = consumable ? this.kStorageAlert.kStorageAlertWindowIDTagConfirmUse : this.kStorageAlert.kStorageAlertWindowIDTagConfirmRetireve;
		aw._delegate = this;
		this.disableMenus();
		
		if(consumable)
		{
//			NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObject:storageItemName forKey:@"itemType"];
//			[[EventTracker eventTracker] sendEvent:@"zf_storage_use_item" withParameters:eventDictionary andDelegate:nil];
		}
	},

	//-(void)retreieveItemWithName:(NSString*)name
	retreieveItemWithName: function(name)
	{
//	    console.log("retrieving storage item: " + name);
	    
	    var gs = GameState;
	    var tom = ZFToolManager.toolManager();
	    var tim = ZFTileManager;
	    
	    var index = this.indexForItemNameInStorage(name);
	    var storageItemDict = gs._zfGameData._inventory[index];
	    var storageItem = this.storageItemFromInventoryDictionary(storageItemDict);
	    var storageItemKey = storageItemDict["tile"];
	    var dictWithSpriteInfo = storageItem;
	    var useTileSheet = storageItem["spriteInfoInTileProperties"];
	    
	    if (useTileSheet/* && [useTileSheet boolValue]*/)
	    {
	        dictWithSpriteInfo = tim._tilePropertiesDictionary[storageItemKey];
	        NSAssert(dictWithSpriteInfo, "missing dictionary ");
	    }
	    
	    var filename = dictWithSpriteInfo["spriteSheet"];
	    NSAssert(filename, "spriteSheet missing");
	    
	    var market = ZFMarketMenu.theMarket();
	    market._paymentPending = false;
	    
	    var tool = tom._tools[ZFToolManager.kGameTool.kGameToolPlace];
	    
	    tool._dictionary = storageItem;
	    
	    if(storageItemDict["stageActor"])
	    {
	        /// CHECK FOR PETS !!!!
	        var acm = ZFActorManager;
	        
	        var stageActorDict = acm._stageActorDictionaries[storageItemDict["tile"]];
	        if(stageActorDict && stageActorDict["isPet"])
	        {
	            for(var key in acm._farmActors)
	            {
	            	var actor = acm._farmActors[key];
	                if(actor._actorDictionary["isPet"])
	                {
	                    // SWITCH !!!
	                    var dict = ZFMarketMenu.theMarket().marketItemFromTileKey_withColor(actor._key, actor._savedColor);
	                    
	                    if(dict)
	                    {
	                        this.addItemToStorage(dict, false);
	                        acm._farmActors.splice(acm._farmActors.indexOf(actor), 1);
	                        actor.despawn();
	                    }
	                    else 
	                    {
	                        console.log("Error could not find market dictionary for Stage Actor - ZFStorageMenu alertWindow:dismissedPositive:withButtonTag:");
	                    }
	                }
	            }
	        }
	        
	        var index = -1;
	        acm.spawnStageActorWithMarketDictionary(storageItemDict, acm._player._farmData._currentTile);
	        for(var key in gs._zfGameData._inventory)
	        {
	        	var object = gs._zfGameData._inventory[key];
	            if(object == storageItemDict)
	            {
	                index = gs._zfGameData._inventory.indexOf(object);
	            }							
	        }
	        
	        if(index >= 0)
	        {
	            gs._zfGameData._inventory.splice(index, 1);
	        }
	    }
	    else 
	    {
	        tim.placeNewObjectTileWithKey(storageItemKey, filename, this.colorFromDictionary(storageItemDict));	
	    }
	},
	
	//- (void)alertWindow:(ZFAlertWindow*)alertWindow dismissedPositive:(BOOL)dummy
	alertWindow_dismissedPositive: function(alertWindow, dummy)
	{
		var gs = GameState;
		//FIXME: JP:This validation is not in the original code, however, the original game breaks here too :P
		var storageItemDict = gs._zfGameData._inventory[this._currentItemIndex];
		if(storageItemDict)
		{
			var storageItem = this.storageItemFromInventoryDictionary(storageItemDict);
		}
		
		   if (alertWindow._idTag == this.kStorageAlert.kStorageAlertWindowIDTagSell)
		   {
			   if(dummy)
			   {
				   // remove the object from your inventory
				   if(storageItemDict["count"] > 1)
				   {
					   var count = storageItemDict["count"];
					   count--;
					   storageItemDict["count"] = count;
					   gs._zfGameData._inventory[this._currentItemIndex] = storageItemDict;
				   } 
				   else 
				   {
					   gs._zfGameData._inventory.splice(this._currentItemIndex, 1);
				   }
				   
				   gs.addResource(GameData.gameResources.kGameResourceGold, 10);
				   
				   //TODO
//				   NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
//														   [storageItemDict objectForKey:@"name"], @"itemType",
//															@"10 gold", @"amountReimbursed",
//														   nil];
//				   [[EventTracker eventTracker] sendEvent:@"zf_sell_item_confirm" withParameters:eventDictionary andDelegate:nil];
				   
				   // Only page 0 for consumables
				   if(storageItem["subCategory"] == "boost")
				   {
					   this.displayPage(0);
				   }   
				   else
				   {
					   this.displayPage(this._currentPage);
				   }
			   }
			   else
			   {
				  /* do nothing */
				   
				   //TODO
//				   NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
//														   [storageItemDict objectForKey:@"name"], @"itemType",
//														   nil];
//				   [[EventTracker eventTracker] sendEvent:@"zf_sell_item_dismiss" withParameters:eventDictionary andDelegate:nil];
				   
			   }
			   
			   // Enable and refresh the page
			   this.enableMenus();
		   }
		if (alertWindow._idTag == this.kStorageAlert.kStorageAlertWindowIDTagCantSell)
		{
			// Enable and refresh the page
			this.enableMenus();
		}
		else 
		{
			this.alertWindow_dismissedPositive_withButtonTag(alertWindow, dummy, ZFAlertWindow.kAlertWindowTags.kAlertWindowTagOk);
			
//			if(storageItem && storageItem["subCategory"] == "boost" && !dummy && alertWindow._idTag == this.kStorageAlert.kStorageAlertWindowIDTagConfirmUse)	//when dummy == YES, we're using something
//			{
				//dismissed a boost
				//TODO
//				NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObject:[storageItem objectForKey:@"name"] forKey:@"itemType"];
//				[[EventTracker eventTracker] sendEvent:@"zf_storage_dismiss_use_item" withParameters:eventDictionary andDelegate:nil];
//			}
		}
	},
//
//	- (void)alertWindow:(ZFAlertWindow*)alertWindow dismissedPositive:(BOOL)dummy withButtonTag:(NSInteger)buttonTag
	alertWindow_dismissedPositive_withButtonTag: function(alertWindow, dummy, buttonTag)
	{
//		console.log("alert window dismissed with button tag = " + buttonTag);
	    w = CCDirector.winSize();
		var tom = ZFToolManager.toolManager();
		var tim = ZFTileManager;
		var acm = ZFActorManager;
		var gs = GameState;
		var market = ZFMarketMenu.theMarket();
		var gui = ZFGuiLayer.gui();
		
		if (dummy)
		{
			if(buttonTag == ZFAlertWindow.kAlertWindowTags.kAlertWindowTagOk)
			{
				
				if (alertWindow._idTag == this.kStorageAlert.kStorageAlertWindowIDTagConfirmStore)
				{
					this.storeItemFromCurrentItemCoordinates();
				}
				else if(alertWindow._idTag == this.kStorageAlert.kStorageAlertWindowIDTagConfirmStoreActor)
				{
					if(this._currentActor)
					{
						var marketDict = market.marketItemFromTileKey(this._currentActor._key, this._currentActor._savedColor);
						
						if(marketDict)
						{
							this.addItemToStorage(marketDict, false);
							
							acm._farmActors.splice(acm._farmActors.indexOf(this._currentActor), 1);
							this._currentActor.despawn();
						}
						else 
						{
							console.log("Error storing stage actor");
						}
					}
				}
				else if (alertWindow._idTag == this.kStorageAlert.kStorageAlertWindowIDTagConfirmRetireve)
				{				    
					this.dismissMenu(alertWindow);	//because [self dismissMenu] records the event of the user clicking the X
	                
					var storageItemDict = gs._zfGameData._inventory[this._currentItemIndex];
					var storageItem = this.storageItemFromInventoryDictionary(storageItemDict);
					var storageItemKey = storageItemDict["tile"];
					var dictWithSpriteInfo = storageItem;
					var useTileSheet = storageItem["spriteInfoInTileProperties"];
					if (useTileSheet/* && [useTileSheet boolValue]*/)
					{
						dictWithSpriteInfo = tim._tilePropertiesDictionary[storageItemKey];
						//NSAssert(dictWithSpriteInfo, "missing dictionary ");
					}
	                
					var filename = dictWithSpriteInfo["spriteSheet"];
					//NSAssert(filename, "spriteSheet missing");
	                
					var market = ZFMarketMenu.theMarket();
					market._paymentPending = false;
	                
					var tool = tom._tools[ZFToolManager.kGameTool.kGameToolPlace];
	                
					tool._dictionary = storageItem;		
					if(storageItemDict["stageActor"])
					{					    
						/// CHECK FOR PETS !!!!
						var acm = ZFActorManager;
						
						var stageActorDict = acm._stageActorDictionaries[storageItemDict["tile"]];
						if(stageActorDict && stageActorDict["isPet"])
						{
							for(var key in acm._farmActors)
							{
								var actor = acm._farmActors[key];
								if(actor._actorDictionary["isPet"])
								{
									// SWITCH !!!
									var dict = ZFMarketMenu.theMarket().marketItemFromTileKey_withColor(actor._key, actor._savedColor);
									if(dict)
									{
										this.addItemToStorage(dict, false);
										acm._farmActors.splice(acm._farmActors.indexOf(actor), 1);
										actor.despawn();
									}
									else 
										NSLog("Error could not find market dictionary for Stage Actor - ZFStorageMenu alertWindow:dismissedPositive:withButtonTag:");
								}
							}
						}
						
						var index = -1;
						acm.spawnStageActorWithMarketDictionary(storageItemDict, acm._player._farmData._currentTile);
						for(var key in gs._zfGameData._inventory)
						{   
							var object = gs._zfGameData._inventory[key];
							if (object === storageItemDict)
							{
								index = gs._zfGameData._inventory.indexOf[object];
							}							
						}
						if(index >= 0)
						{
							gs._zfGameData._inventory.splice(index, 1);
						}
					}
					else 
					{
						tim.placeNewObjectTileWithKey(storageItemKey, filename, this.colorFromDictionary(storageItemDict));	
					}
				}
				else if (alertWindow._idTag == this.kStorageAlert.kStorageAlertWindowIDTagConfirmUse)
				{				    
//					console.log("!!-- use item ");
					this.useItemWithIndex(this._currentItemIndex);
	                this.dismissMenu(alertWindow);	//because [self dismissMenu] records the event of the user clicking the X
				}
				else if (alertWindow._idTag == this.kStorageAlert.kStorageAlertWindowIDTagConvertFragments)
				{
					var keyName = NSLocalizedString("Rusty Key", "Rusty Key Name");
					var message = sprintf(NSLocalizedString("You pieced together a...\n\n%@!", "Key Fragments have pieced to create the key"), keyName);
					gui.displayAlertSimple(keyName, message, CCSprite.spriteWithFile(market.spriteFilenameFromName("Rusty Key")));
					gs._zfGameData._inventory.splice(this._currentItemIndex, 1);
					var addToStorage = new ZFConsumable();
					addToStorage.initWithName("Rusty Key", 1);
					this.addItemToStorage(addToStorage, false);
				}
				else if (alertWindow._idTag == this.kStorageAlert.kStorageAlertWindowIDTagUnlockMausoleum)
				{
					var message = NSLocalizedString("You unlocked the Mausoleum!\n\nYou may now use the Mausoleum to store zombies!", "Unlocked Mausoleum Message");
					gui.displayAlertSimple("Mausoleum", message, CCSprite.spriteWithFile(market.spriteFilenameFromName("Mausoleum")));
					gs._zfGameData._inventory.splice(this._currentItemIndex, 1);
					gs._zfGameData._mausoleumFlags |= ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM_UNLOCKED;
					ZFAchievementChecker.checkMausoleumUnlock();
				
					/* Unlock Achievement through Facebook */
					//TODO: Facebook
//					ZFGuiLayer *gui = [ZFGuiLayer gui];
//					[gui publishAchievement:@"com.zombiefarm.farm.unlock_mausoleum" withDescription:@"com.zombiefarm.farm.unlock_mausoleum.description" withImageURl:@"com.zombiefarm.farm.unlock_mausoleum.image" ];
				}
			}
			//FIXME: else if(buttonTag == this.kStorageAlert.kAlertWindowStorageSendGiftTag)
		//	{
//TODO gift				
//				[super dismissMenu:alertWindow];	//because [self dismissMenu] records the event of the user clicking the X
//				
//				/* Gifting*/
//				NSDictionary *storageItemDict = (NSMutableDictionary*)[gs.zfGameData.inventory objectAtIndex:currentItemIndex];
//				NSString *storageItemName = (NSString*)[storageItemDict objectForKey:@"name"];
//				
//	#ifdef ZF_REMOTE_MARKET
//				NSString* finalPath = [[ZFRemoteMarket theRemoteMarket] getPathToLocalMarketIfUpdated];
//				if (!finalPath)
//					finalPath = [[NSBundle mainBundle] pathForResource:@"Market" ofType:@"plist"]; 
//	#else
//				NSString *finalPath = [[NSBundle mainBundle] pathForResource:@"Market" ofType:@"plist"]; 
//	#endif 
//				NSMutableArray* marketArray = [NSMutableArray arrayWithContentsOfFile:finalPath];
//				NSDictionary* mareketItem = nil;
//				for (NSDictionary* item in marketArray)
//				{
//					if([[item objectForKey:@"name"] isEqualToString:storageItemName])
//					{
//						mareketItem = item;
//					}
//				}
//				
//				NSString* category = (NSString*)[mareketItem objectForKey:@"category"];
//				NSString* subCategory = (NSString*)[mareketItem objectForKey:@"subCategory"];
//				[storageItemName retain];
//				[category retain];
//				[subCategory retain];
//				
//				NSArray* keys = [NSArray arrayWithObjects:[NSString stringWithString:@"count"], [NSString stringWithString:@"sender"],  [NSString stringWithString:@"category"], [NSString stringWithString:@"subCategory"], nil];
//				NSArray* objects = [NSArray arrayWithObjects:[NSNumber numberWithInt:1], [NSString stringWithString:[GKLocalPlayer localPlayer].alias], category, subCategory, nil]; 
//				
//				NSMutableDictionary* gift = [[NSMutableDictionary alloc] initWithObjects:objects forKeys:keys];
//				
//				// show friend window with gift
//				[gui displayAlertFriendsListWithGiftName:storageItemName withGift:gift];
//				
//				[storageItemName release];
//				[category release];
//				[subCategory release];
//				
//				// init the ability to catch put messages
//				[self initRemoteStoragePutMonitor];
			//}
			else if(buttonTag == ZFAlertWindow.kAlertWindowTags.kAlertWindowTagSell)
			{
				var storageItemDict = gs._zfGameData._inventory[this._currentItemIndex];
				var storageItemName = storageItemDict["name"];
//	#ifdef ZF_REMOTE_MARKET
//				NSString* finalPath = [[ZFRemoteMarket theRemoteMarket] getPathToLocalMarketIfUpdated];
//				if (!finalPath)
//					finalPath = [[NSBundle mainBundle] pathForResource:@"Market" ofType:@"plist"]; 
//	#else
//				NSString *finalPath = [[NSBundle mainBundle] pathForResource:@"Market" ofType:@"plist"]; 
//	#endif
				//TODO
				var marketArray = DataPreloader._marketData;
				var mareketItem = null;
				for (var key in marketArray)
				{
					var item = marketArray[key];
					if(item["name"] == storageItemName)
					{
						mareketItem = item;
	                    break;
					}
//	#ifdef ZF_REMOTE_MARKET
//					else if([[item objectForKey:@"tile"] isEqualToString:@"missingItem"]) {
//						mareketItem = item;		//default to this 
//					}
//	#endif
				}
				
				NSAssert(mareketItem, "ZFStorageMenu: Can't find item in market.plist");
				
				var category = mareketItem["category"];
				var subCategory = mareketItem["subCategory"];
				
				if(subCategory == "special")
				{
					var aw = ZFGuiLayer.gui().displayAlertSimple(NSLocalizedString("Cannot Sell"), 
	                                                             NSLocalizedString("You cannot sell important purchased items"),
	                                                             CCSprite.spriteWithFile("sellSprite.png"),
	                                                             CGRectMake((w.getWidth - ZFGameDefines.ORIGINAL_WINDOW_WIDTH)/2, w.getHeight - (w.getHeight - ZFGameDefines.ORIGINAL_WINDOW_HEIGHT)/2 - 62, 480, 200));
					
					aw._idTag = this.kStorageAlert.kStorageAlertWindowIDTagCantSell;
					aw._delegate = this;
					
					//TODO
					//var eventDictionary = {	"itemType" : storageItemName,
					//		"errorType" : "Cannot sell important items" };
					//[[EventTracker eventTracker] sendEvent:@"zf_sell_item_error" withParameters:eventDictionary andDelegate:nil];
				}
				else
				{
					var cost = 10;
					var aw = ZFGuiLayer.gui().displayAlertSimpleChoice(	NSLocalizedString("Sell Item"),
																		sprintf(NSLocalizedString("Are you sure you want to sell %@ for %ig?"), NSLocalizedString(storageItemName), cost), 
														 				CCSprite.spriteWithFile("sellSprite.png"));
					
					aw._idTag = this.kStorageAlert.kStorageAlertWindowIDTagSell;
					aw._delegate = this;

					//TODO
					//NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObject:storageItemName forKey:@"itemType"];
					//[[EventTracker eventTracker] sendEvent:@"zf_storage_sell_item" withParameters:eventDictionary andDelegate:nil];
				}
			}
		}
		else
		{
			this.enableMenus();
		}
	},
//
	useItemWithName: function(name)
	{
	    var gs = GameState;
	    var index = -1;
	    for (var key in gs._zfGameData._inventory)
	    {
	    	var storageItemDict  = gs._zfGameData._inventory[key];
	        var storageItemName = storageItemDict["name"];
	        
	        if (storageItemName == name)
	        {
	            index = gs._zfGameData._inventory.indexOf(storageItemDict);
	            break;
	        }
	    }
	    
	    if (index >= 0)
	    {
	        this.useItemWithIndex(index);
	    }
	},

	useItemWithIndex:function (index)
	{
		var w = this._winSize;
//		var w = CCDirector.winSize();
		var tom = ZFToolManager.toolManager();
		var tim = ZFTileManager;
		var acm = ZFActorManager;
		var gs = GameState;
		var market = ZFMarketMenu.theMarket();
		var gui = ZFGuiLayer.gui();

		var storageItemDict = gs._zfGameData._inventory[index];
		var storageItemName = storageItemDict.name;
		
//		NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObject:storageItemName forKey:@"itemType"];
//		[[EventTracker eventTracker] sendEvent:@"zf_storage_confirm_use_item" withParameters:eventDictionary andDelegate:nil];

		var ct = storageItemDict.count - 1;
		var usedItem = true;
		var nextTag = this.kStorageMenuTags.kStorageAlertWindowIDTagConfirmUse;

		switch(storageItemName)
		{
			case "Insta-Plow":
			    setTimeout(tim.plowEntireMap.bind(tim, 0), 1000);
				break;
			
			case "Insta-Harvest":
			    setTimeout(tim.harvestEntireMap.bind(tim, 0), 1000);		
				break;
			
			case "Regrowth":
			    setTimeout(tim.unwitherEntireMap.bind(tim, 0), 1000);
				break;
				
			case "Insta-Hunger":
				if(gs.curArmySize() > 0)
		        {
					var armyAverageHunger = acm.getAverageHunger();
					if (armyAverageHunger < 1)
					{
						acm.makeAllZombiesHungry();
					}
					else 
					{
						gui.displayAlertSimple(storageItemName, NSLocalizedString("Your zombies are all already starving!", "Zombies already hungry"),
									 CCSprite.spriteWithFile(market.spriteFilenameFromName(storageItemName)),
									 CGRectMake((w._width - 480) / 2, w._height - (w._height - 220) / 2, 480, 220));
						usedItem = false;
					}

		        }
		        else
		        {
		            usedItem = false;
		            tim.refundItem("Insta-Hunger", true);
		        }				
				break;
				
			case "Insta-Grow":
		        var storageItem = this.storageItemFromInventoryDictionary(storageItemDict);
		        tom.startInstaGrow(storageItem);
				break;
	
			case "Rusty Fragment":
				ct++;
		        var message = "";
		        
		        if (ct >= ZFGameDefines.FRAGMENTS_TO_KEY)
		        {
		            message = sprintf(NSLocalizedString("Would you like to piece together these...\n\n%@s?", "Fragment brains together message"), storageItemName);
		            nextTag = this.kStorageAlert.kStorageAlertWindowIDTagConvertFragments;

		            var aw = gui.displayAlertSimpleChoice(storageItemName, message, CCSprite.spriteWithFile(market.spriteFilenameFromName(storageItemName)),
		                                                  CGRectMake((w._width - 480) / 2, w._height - (w._height - 220) / 2, 480, 220));
		            aw._idTag = nextTag;
		            aw._delegate = this;
		        }
		        else
		        {
		            message = sprintf(NSLocalizedString("not enough, need %i more", "Not Enough Fragments Message"), (ZFGameDefines.FRAGMENTS_TO_KEY - ct));
		            gui.displayAlertSimple(storageItemName, message, CCSprite.spriteWithFile(market.spriteFilenameFromName(storageItemName)), CGRectMake((w._width - 480) / 2, w._height - (w.getHeight - 220) / 2, 480, 220));
		        }
		        
		        usedItem = false;				
				ct--;
				break;
		
			case "Rusty Key":
		        var message = NSLocalizedString("Nothing to use this key on", "Key has no use message");
		        usedItem = false;
		        if (this.doesOwnItem("mausoleum1") || this.doesOwnItem("mausoleum2") || this.doesOwnItem("mausoleum3"))
		        {
		            message = NSLocalizedString("Would you like to unlock the Mausoleum?", "Unlock Mausoleum Message");
		            var aw = gui.displayAlertSimpleChoice(storageItemName, message, CCSprite.spriteWithFile(market.spriteFilenameFromName(storageItemName)), 
		                                                  CGRectMake((w._width - 480) / 2, w._height - (w.height - 220) / 2, 480, 220));
		                                
		            aw._idTag = this.kStorageAlert.kStorageAlertWindowIDTagUnlockMausoleum;
		            aw._delegate = this;
		        }
		        else
		        {
		            gui.displayAlertSimple(storageItemName, message, CCSprite.spriteWithFile(market.spriteFilenameFromName(storageItemName)),
		                         		CGRectMake((w._width - 480) / 2, w._height - (w._height - 220) / 2, 480, 220));
		        }			
				break;
		
			case "Golden Dice":
		        var message = "";
		        usedItem = false;
		        		        
		        message = NSLocalizedString("Try invading to use the dice.\n\nYou will be asked if you want to use the dice before the invasion starts.");
		        
		        var aw = gui.displayAlertSimple(NSLocalizedString("Golden Dice"), message, 
                                    CCSprite.spriteWithFile(market.spriteFilenameFromName(storageItemName)),
                                    CGRectMake((w._width - 480) / 2, w._height - (w._height - 220) / 2, 480, 220));
		        aw._idTag = this.kStorageAlert.kStorageAlertWindowIDTagMessage;
		        aw._delegate = this;		
				break;
		
			case "Invasion Voucher":
		        var message = null;
		        
		        if(gs.canInvade())
		        {
		            usedItem = false;
		            message = NSLocalizedString("You cannot use the Invasion Voucher when you can already invade.\n\nTry using the Voucher immediately after your next invasion."); 
		        }
		        else 
		        {
		            message = NSLocalizedString("Invasion Voucher used. You may now invade!");
		            
		            gs._zfGameData._lastInvasionDate -= ZFGameDefines.INVASION_INTERVAL;
		        }
		        
		        var aw = gui.displayAlertSimple(NSLocalizedString("Invasion Voucher"), message, 
		                                        CCSprite.spriteWithFile(market.spriteFilenameFromName(storageItemName)),
		                                        CGRectMake((w._width - 480) / 2, w._height - (w._height - 238) / 2, 480, 238));
		        aw._idTag = this.kStorageAlert.kStorageAlertWindowIDTagMessage;
		        aw._delegate = this;	
				break;
	
			case "Valentine Gift":
//		        BOOL cupidZombieExists = NO;
//		        ZFToolManager *tom  = [ZFToolManager toolManager];
//		        ZFActorManager *acm = [ZFActorManager actorManager];
//		        
//		        cupidZombieExists = [acm doesActorTypeExistAnywhere:[ZombieActorGardenCupid class]];
//		        
//		        if([gs curArmySize] < [gs maxArmySize] && !cupidZombieExists)
//		        {
//		            
//		            //zfgametoolmanager harvestZombieWithUnitKey onTile:tile
//		            //[tom harvestZombieWithUnitKey:@"ZombieActorGardenCupid" onTile:acm.player.farmData.currentTile];
//		            [tom spawnFarmActorNoMutations:@"ZombieActorGardenCupid" onTile:acm.player.farmData.currentTile];
//		        }
//		        else 
//		        {
//		            NSString *message;
//		            if(cupidZGameState *ombieExists)
//		                message = NSLocalizedString(@"You can only have one cupid zombie!", nil);
//		            else
//		                message = NSLocalizedString(@"You have too many zombies!", nil);
//		            
//		            [gui displayAlertSimple:storageItemName
//		                        withMessage:message
//		                         withSprite:[CCSprite spriteWithFile:[market spriteFilenameFromName:storageItemName]]];
//		            usedItem = NO;
//		        }			
				break;
				
			case "Crazy Zombie Voucher":
		        var crazyZombieExists = false;
		        
		        crazyZombieExists = acm.doesActorTypeExistAnywhere("ZombieActorRegularCrazy");
		        
		        if(gs.curArmySize() < gs.maxArmySize() && !crazyZombieExists)
		        {
		        	tom.spawnFarmActorNoMutations("ZombieActorRegularCrazy", acm._player._farmData._currentTile);
		        }
		        else 
		        {
		            var message;
		            if(crazyZombieExists)
		                message = NSLocalizedString("You can only have one Crazy zombie!");
		            else
		                message = NSLocalizedString("You have too many zombies!");
		            
		            gui.displayAlertSimple(storageItemName, message, CCSprite.spriteWithFile(market.spriteFilenameFromName(storageItemName)));
		            usedItem = false;
		        }				
				break;
				
		}

	    
	    if (usedItem)
	    {
	        if (storageItemDict && ct > 0)
	        {
	        	var itemDictionary = {	"name" : storageItemName,
	        							"count" : ct };
	        	gs._zfGameData._inventory[index] = itemDictionary;
	        }
	        else
	        {
	        	gs._zfGameData._inventory.splice(index, 1);
	        }
	    }
	},
//
//	- (void)initRemoteStoragePutMonitor
//	{
//		if (![ZFGameCenterDelegate isGameCenterEnabled])
//			return;
//		
//		[[NSNotificationCenter defaultCenter] addObserver:self 
//												 selector:@selector(storageStatePutDone:) 
//													 name:kRemoteStorageStatePutDoneNotification 
//												   object:nil];
//	}
//
//	- (void)storageStatePutDone:(NSNotification*)notification
//	{
//		[[NSNotificationCenter defaultCenter] removeObserver:self name:kRemoteStorageStatePutDoneNotification object:nil];
//		
//		NSError* error = [notification.userInfo objectForKey:@"error"];
//		if(error)
//		{
//			NSString* errorMsg = [error localizedDescription];
//			// if this is not a 403 message
//			if ([errorMsg rangeOfString:@"403"].location == NSNotFound)
//			{
//				NSString* message = [NSString stringWithFormat:@"(%@)\n", [error localizedDescription]];
//				UIAlertView *av = [[UIAlertView alloc] initWithTitle:NSLocalizedString(@"Server Error", @"Synchronization Error") 
//															 message:message
//															delegate:self 
//												   cancelButtonTitle:NSLocalizedString(@"Ok", @"Ok")
//												   otherButtonTitles:nil];
//				
//				[av show];
//				[av release];
//			}
//			else 
//			{
//				NSString* message = [NSString stringWithFormat:NSLocalizedString(@"(%@)\nMake sure your device's Date & Time is accurate. Saving will be disabled if you continue.", nil), [error localizedDescription]];
//				UIAlertView *av = [[UIAlertView alloc] initWithTitle:NSLocalizedString(@"Server Error", @"Synchronization Error") 
//														 message:message
//														delegate:self 
//											   cancelButtonTitle:NSLocalizedString(@"Ok", @"Ok")
//											   otherButtonTitles:nil];
//			
//				[av show];
//				[av release];
//			}
//			return;
//		}
//		
//		// remove the object from your inventory
//		GameState *gs = [GameState gameState];
//		[gs.zfGameData.inventory removeObjectAtIndex:currentItemIndex];
//	},

	colorFromDictionary: function(dict)
	{
		var colorConv = ccc3(0xFF, 0xFF, 0xFF);
		var colorArray = dict["color"];
		if (colorArray)
		{
			colorConv = ccc3(new Number(colorArray[0]), 
							 new Number(colorArray[1]), 
							 new Number(colorArray[2]));
		}
		
		return colorConv;
	},

	canAddToStorage: function()
	{
		var gs = GameState;

		if(this.storageSlotsAllowed() <= 0 && gs._zfGameData._inventory.length == 0)
		{
			this.noStorageMessage();
			return false;
		}
				
		// Dont count boosts against you when checking if you can add an item to storage
		var count = gs._zfGameData._inventory.length;
		for(var i in gs._zfGameData._inventory)
		{
			var storageItemDict = gs._zfGameData._inventory[i];
			storageItem = this.storageItemFromInventoryDictionary(storageItemDict);
			
			if(storageItem["subCategory"] == "boost")
			{
				count--;
			}
		}
		
		if(count >= this.storageSlotsAllowed())
		{
			this.fullStorageMessage();
			return false;
		}
		
		return true;
	},

	doesOwnItem: function(tileKey)
	{	
		return (this.isItemInStorage(tileKey) || this.isItemOnFarm(tileKey));
	},

	isItemInStorage: function(tileKey)
	{
		var index = this.indexForItemInStorage(tileKey);
		return (index >= 0);
	},

	isItemOnFarm: function(tileKey)
	{
		if(this.tSpriteForItemOnFarm(tileKey))
		{
			return true;
		}
		
		return false;
	},

	isConsumable: function(item)
	{
		return !item.tile;
	},

	tSpriteForItemOnFarm: function(tileKey)
	{
		var a = TSprite.allMySprites();
		for (var tSpriteKey in a)
		{
			var tSprite = a[tSpriteKey];
			if (!tSprite._tile || !tSprite._tile._key)
			{
				continue;
			}
			
			if (tSprite._tile._key  == tileKey)
			{
				return tSprite;
			}
		}
		
		return null;
	},

	numberOfItemOnFarmWithKey: function(tileKey)
	{
		var ct = 0;
		for (var tSpriteKey in TSprite.allMySprites())
		{
			var tSprite = (TSprite.allMySprites())[tSpriteKey];
			if (!tSprite._tile)
			{
				continue;
			}
			
			if (tSprite._tile._key == tileKey)
			{
				ct++;
			}
		}
		
		return ct;
	},

	//- (CGPoint)coordinatesOfItemOnFarmWithKey:(NSString*)tileKey
	coordinatesOfItemOnFarmWithKey: function(tileKey)
	{
		for (var key in TSprite.allMySprites())
		{
			tSprite = (TSprite.allMySprites())[key];
			if (!tSprite._tile)
			{
				continue;
			}
			
			if (tSprite._tile._key == tileKey)
			{
				return tSprite._tile._rootTile;
			}
		}
		
		return ccp(0,0);
	},
	
	indexForItemNameInStorage: function(itemName)
	{
		var gs = GameState;
		var index = -1;
		
		for (var storageItemDictKey in gs._zfGameData._inventory)
		{
			var storageItemDict = gs._zfGameData._inventory[storageItemDictKey];
			
			//FIXME: This validation is not in the original code
			if (!storageItemDict)
			{
				continue;
			}
			var name = storageItemDict["name"];
			
			if (name == itemName)
			{
				index = gs._zfGameData._inventory.indexOf(storageItemDict);
				break;
			}
		}
		
		return index;
	},
	
	indexForItemInStorage: function(tileKey)
	{
		var gs = GameState;
		var index = -1;
		
		for (var storageItemDictKey in gs._zfGameData._inventory)
		{
			var storageItemDict = gs._zfGameData._inventory[storageItemDictKey];
			
			//FIXME: This validation is not in the original code
			if(!storageItemDict)
			{
				continue;
			}
			var key = storageItemDict["tile"];
			
			if (key  == tileKey)
			{
				index = gs._zfGameData._inventory.indexOf(storageItemDict);
				break;
			}
		}
		
		return index;
	},

	numberOfItemInStorageWithKey: function(aName)
	{
		var gs = GameState;
		for (var storageItemDictKey in gs._zfGameData._inventory)
		{
			var storageItemDict = gs._zfGameData._inventory[storageItemDictKey];
			if(!storageItemDict)
				continue;
			var name = storageItemDict["name"];
			
			if (name  == aName)
			{
				return new Number(storageItemDict["count"]);
			}
		}
		return 0;
	},

	storageSlotsAllowed: function()
	{
		var gs = GameState;
		
		if (gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE08))
		{
			return INVENTORY_ITEMS_PER_ROW * 8;
		}
		if (gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE07))
		{
			return INVENTORY_ITEMS_PER_ROW * 7;
		}
		if (gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE06))
		{
			return INVENTORY_ITEMS_PER_ROW * 6;
		}
		if (gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE05))
		{
			return INVENTORY_ITEMS_PER_ROW * 5;
		}
		if (gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE04))
		{
			return INVENTORY_ITEMS_PER_ROW * 4;
		}
		if (gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE03))
		{
			return INVENTORY_ITEMS_PER_ROW * 3;
		}
		if (gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE02))
		{
			return INVENTORY_ITEMS_PER_ROW * 2;
		}
		if (gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_STORAGE01))
		{
			return INVENTORY_ITEMS_PER_ROW * 1;
		}
		
		return 0;
	},

	noStorageMessage: function()
	{
		var gui = ZFGuiLayer.gui();
		var gs = GameState;
	    var w = CCDirector.winSize();
		
		var message = sprintf(NSLocalizedString("Ya got no place to store stuff yet.\nTo store items from yer farm, you have to buy a %@ from the market."), ZFGameDefines.kStorage01ItemName);
		
		if (gs._zfGameData._level < ZFGameDefines.STORAGE_AVAILABLE_LVL)
		{
			message = sprintf(NSLocalizedString("%@\n\nA %@ will be available for purchase once ya hit level %i."), message, ZFGameDefines.kStorage01ItemName, ZFGameDefines.STORAGE_AVAILABLE_LVL);
		}
		else
		{
			message = sprintf(NSLocalizedString("%@\n\nA %@ is now available to purchase in the market!"), message, ZFGameDefines.kStorage01ItemName);
		}
		
		gui.displayAlertSimple(NSLocalizedString("No Storage Building"),
					message,
					 CCSprite.spriteWithFile("storageIcon.png"),
	                 CGRectMake((w._width - 480) / 2, w._height - (w._height - 260) / 2, 480, 260));
	},

	//- (void)fullStorageMessage
	fullStorageMessage: function()
	{
	    var w = CCDirector.winSize();
		var gui = ZFGuiLayer.gui();
		gui.displayAlertSimple(NSLocalizedString("Storage Full"),
							NSLocalizedString("Gosh! Yer storage is full!\n\nMake more room by emptying out items.\n\nOr, purchase a storage upgrade in the market for more space."),
							CCSprite.spriteWithFile("storageIcon.png"),
			                CGRectMake((w._width - 480) / 2, w.getHeight - (w.getHeight - 260) / 2, 480, 260));
	},

	//- (void)restoreMessageWithItem:(NSString*)restoredItem
	restoreMessageWithItem: function(restoredItem)
	{
		var gui = ZFGuiLayer.gui();
		var title = NSLocalizedString("Missing Item Restored");
		var message = sprintf(NSLocalizedString("Looks like ya had a missin'...\n %@.\n\n We've rightfully restored a missin' item. Ya can find it in yer storage, and place it back on the farm."),restoredItem);
		gui.displayAlertSimple(title, message, null);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/ZFMenus/Quest/ZFQuestMenu'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Quest/ZFQuestMenu'] || {}; $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Quest/ZFQuestMenu'] = exports; var ZFQuestCell = require('Code/Game/GUI/ZFMenus/Quest/ZFQuestCell').ZFQuestCell;

exports.ZFQuestMenu = ZFMenu.singleton({
	classname : 'ZFQuestMenu',

	questSelectionMenuTags : {
		kQuestSelectionMenuTagTable : 3,
		kQuestMenuTagTableBG : 4,
		kQuestMenuTagRewardLabel : 5,
		kQuestMenuTagReqLabel : 6,
		kQuestMenuTagUpArrow : 7,
		kQuestMenuTagDnArrow : 8,
		kQuestMenuTagBanner : 9,
		kQuestMenuTagIcon : 10,
		kQuestMenuTagReqBG : 11,
		kQuestMenuTagReqBorder : 12,
		kQuestMenuTagMAX : 13
	},

	initElements : function($super) {
//		$super();

		this._currentSelectedIndex = 0;

		this._isMenuEnabled = true;
		//var resolutionHeight = this._winSize._height;
		//var menuHeightOffset = 0;
		var heightScale = 1;

		//	if (resolutionHeight>ORIGINAL_WINDOW_HEIGHT)
		//	{
		//	heightScale = (resolutionHeight/320.0)*2/3;
		//		menuHeightOffset = (resolutionHeight-320*heightScale)/2;
		//		
		//		[dimLayer changeHeight: 2*resolutionHeight];
		//		if(!dimLayer.parent)
		//		{
		//			[self addChild:dimLayer z:1000];
		//			[[CCTouchDispatcher sharedDispatcher] addTargetedDelegate:dimLayer priority:90 swallowsTouches:YES];
		//		}
		//	}

		var w = new Core.Size(480, 320 * heightScale);
		// CGRect windowSize = CGRectMake(0+widthOffset, w.height-16+heightOffset, w.width, w.height-32);
		var windowSize = CGRectMake(0, 0, w._width, w._height - 32);
		var f = "hudElements.png";

		this._widthOffset = (this._winSize._width - windowSize.getSize()._width) / 2;
		this._heightOffset = -(this._winSize._height - windowSize.getSize()._height) / 2;

		var color = ccc4(237, 226, 177, 255);

		//destroyWithChildren(this._bgOverlay);
		this._windowNode.removeChild(this._bgOverlay);
		var bgOverlay = ZFMenu.makeWindow(windowSize, CGRectMake(1, 1, 34, 42), CGRectMake(36, 1, 30, 38), f, color, CGRectMake(0, 0, 0, 0), CGRectMake(0, 0,
				0, 0), CGRectMake(1, 44, 34, 24));
		this._bgOverlay = bgOverlay;

		this._backgroundSpriteSheet = this._bgOverlay.getChildByTag(1);
		bgOverlay.setPosition(ccpAdd(bgOverlay.getPosition(), ccp(this._widthOffset, this._heightOffset)));
		this._windowNode.addChild(bgOverlay, 1, ZFMenu.kZFMenuTags.kZFMenuTagBackground);

		var dismissItem = new CCMenuItemImage();
		dismissItem.initFromNormalImage("bigX.png", "bigXSel.png", this, this.dismissMenu.bind(this));
		dismissItem.setScale(0.8);
		this._dismissMenu = CCMenu.menuWithItems([dismissItem]);
		this._dismissMenu.setPosition(ccp(w._width + this._widthOffset - 20 - dismissItem.getSize()._width/2*0.8, w._height - this._heightOffset - 20 - dismissItem.getSize()._height*0.8));
		this._windowNode.addChild(this._dismissMenu, 100);	
		
		//quest window
		color = ZFColorDefines.colorMenuQuestDarkBrown;
		var wSize = CGRectMake(/*36+widthOffset*/0, /*258+heightOffset+menuHeightOffset*3/10*/0, 154, -22 + 220 * heightScale);
		this._tableBg = ZFMenu.makeWindow(wSize, CGRectMake(37, 40, 11, 11), CGRectMake(49, 40, 11, 11), f, color, null, null, CGRectMake(49, 40, 11, 11));

		this._tableBg.setPosition(ccpAdd(this._tableBg.getPosition(), ccp(36 + this._widthOffset, -54 + this._heightOffset)));
		this._windowNode.addChild(this._tableBg, 2, this.questSelectionMenuTags.kQuestMenuTagTableBG);

		//this._tableBg = tableBg;

		for ( var li in this._tableBg._children) {
			var l = this._tableBg._children[li];
			if (l instanceof CCSpriteSheet) {
				for ( var si in l._children) {
					var s = l._children[si];
					s.setColor(ZFColorDefines.colorMenuQuestDarkBrown);
				}
			}
		}
		    
		//requirements window
		var reqBg = ZFMenu.makeWindow(CGRectMake(0, 0, 212, 132), CGRectMake(37, 40, 11, 11), CGRectMake(49, 40, 11, 11), f, color, null, null, CGRectMake(49,
				40, 11, 10));
		//GRectMake(236+widthOffset, 232+heightOffset+(menuHeightOffset*1/3), 212, 132)

		reqBg.setPosition(ccpAdd(reqBg.getPosition(), ccp(236 + this._widthOffset, -22 - 32 - 26 + this._heightOffset)));
		this._windowNode.addChild(reqBg, 2, this.questSelectionMenuTags.kQuestMenuTagReqBG);

		for ( var li in reqBg._children) {
			var l = reqBg._children[li];
			if (l instanceof CCSpriteSheet) {
				for ( var si in l._children) {
					var s = l._children[si];
					s.setColor(ZFColorDefines.colorMenuQuestDarkBrown);
				}
			}
		}

		//	requirements border
		color = ccc4(0, 0, 0, 0);//FIXME: check alfa
		var reqBorder = ZFMenu.makeWindow(CGRectMake(/*194+this._widthOffset*/0, /*258+this._heightOffset*/0, 262, 168), CGRectMake(37, 52, 11, 11),
				CGRectMake(49, 52, 11, 3), f, color, null, null, CGRectMake(49, 52, 3, 3));

		this._windowNode.addChild(reqBorder, 2, this.questSelectionMenuTags.kQuestMenuTagReqBorder);

		reqBorder.setPosition(ccp(194 + this._widthOffset, this._heightOffset - (320 - 258) + 11));

		for ( var li in reqBorder._children) {
			var l = reqBorder._children[li];
			if (l instanceof CCSpriteSheet) {
				for ( var si in l._children) {
					var s = l._children[si];
					s.setColor(ZFColorDefines.colorMenuQuestLightBrown);
				}
			}
		}

		//    //icon
		var menuIcon = CCSprite.spriteWithFile("iconQuestMenu.png");
		menuIcon.setPosition(ccp(32 + this._widthOffset, 285 - this._heightOffset - 16));
		this._windowNode.addChild(menuIcon, 2, this.questSelectionMenuTags.kQuestMenuTagIcon);

		//	//banner
		this.initBannerWithString(NSLocalizedString("Quests"), CGSizeMake(400, 50), 22);
		var oldPos = this._menuBanner.getPosition();
		this._menuBanner.setPosition(ccpAdd(oldPos, ccp(0, 16)));

		//    //table
		this.displayQuestTable();

		//    //arrows
		var upArrow = CCSprite.spriteWithFile(f, CGRectMake(416,56,52,17));
		var dnArrow = CCSprite.spriteWithFile(f, CGRectMake(416,74,52,18));
		this._windowNode.addChild(upArrow, 10, this.questSelectionMenuTags.kQuestMenuTagUpArrow);
		this._windowNode.addChild(dnArrow, 10, this.questSelectionMenuTags.kQuestMenuTagDnArrow);
		upArrow.setPosition(ccp(160 + this._widthOffset, 220 - this._heightOffset));
		dnArrow.setPosition(ccp(160 + this._widthOffset, 40 - this._heightOffset));
		var actionTo = CCSequence.actions(
				CCMoveBy.actionWithDuration(0.5, ccp(0,5)),
				CCMoveBy.actionWithDuration(0.5, ccp(0,-5)));
		
		var repeatForever = CCRepeatForever.actionWithAction(actionTo);
		upArrow.runAction(repeatForever);
		
		actionTo = CCSequence.actions(
				CCMoveBy.actionWithDuration(0.5, ccp(0,-5)),
				CCMoveBy.actionWithDuration(0.5, ccp(0,5)));
					
		repeatForever = CCRepeatForever.actionWithAction(actionTo);
		dnArrow.runAction(repeatForever);
		
		//    //requirements
		var reqLabel = CCLabel.labelWithString(NSLocalizedString("Requirements"), new Core.Size(120, 30), GL2.Text.HorizontalAlign.Center, "AmericanTypewriter-Bold", 18);
		reqLabel.setPosition(ccp(335 + this._widthOffset, -20 + 244 - this._heightOffset));
		reqLabel.setColor(ZFColorDefines.colorTextBlack);
		this._windowNode.addChild(reqLabel, 3, this.questSelectionMenuTags.kQuestMenuTagReqLabel);
		//    [reqLabel.texture setAliasTexParameters];

		//reward
		var rewardString = NSLocalizedString("Reward");
		var rewardLabel = CCLabel.labelWithString(rewardString, "AmericanTypewriter-Bold", 18);
		rewardLabel.setPosition(ccp(244 + this._widthOffset, 70 - 22 - this._heightOffset));
		rewardLabel.setColor(ZFColorDefines.colorTextBlack);
		this._windowNode.addChild(rewardLabel, 3, this.questSelectionMenuTags.kQuestMenuTagRewardLabel);
		//    [rewardLabel.texture setAliasTexParameters];
		    
		//reward var
		this._rewardVarLabel = CCLabel.labelWithString("", CGSizeMake(200, 24), GL2.Text.HorizontalAlign.Left, "AmericanTypewriter-Bold", 18);
		this._rewardVarLabel.setPosition(ccp(294 + 82 + this._widthOffset, 70 - 22 - this._heightOffset));
		this._rewardVarLabel.setColor(ZFColorDefines.colorTextBlack);
		this._windowNode.addChild(this._rewardVarLabel, 3);

		//req vars
		this._reqVar1aLabel = CCLabel.labelWithString("", CGSizeMake(175, 24), GL2.Text.HorizontalAlign.Left, "AmericanTypewriter-Bold", 11);
		this._reqVar1aLabel.setPosition(ccp(246 + 82 + this._widthOffset, 205 - 11 - this._heightOffset));
		this._reqVar1aLabel.setColor(ZFColorDefines.colorTextWhite);
		this._windowNode.addChild(this._reqVar1aLabel, 3);
		//    [reqVar1aLabel.texture setAliasTexParameters];

		this._reqVar2aLabel = CCLabel.labelWithString("", CGSizeMake(175, 24), GL2.Text.HorizontalAlign.Left, "AmericanTypewriter-Bold", 11);
		this._reqVar2aLabel.setPosition(ccp(246 + 82 + this._widthOffset, 205 - 11 - 40 - this._heightOffset));
		this._reqVar2aLabel.setColor(ZFColorDefines.colorTextWhite);
		this._windowNode.addChild(this._reqVar2aLabel, 3);
		//    [reqVar2aLabel.texture setAliasTexParameters];
		//    
		this._reqVar3aLabel = CCLabel.labelWithString("", CGSizeMake(175, 24), GL2.Text.HorizontalAlign.Left, "AmericanTypewriter-Bold", 11);
		this._reqVar3aLabel.setPosition(ccp(246 + 82 + this._widthOffset, 205 - 11 - 80 - this._heightOffset));
		this._reqVar3aLabel.setColor(ZFColorDefines.colorTextWhite);
		this._windowNode.addChild(this._reqVar3aLabel, 3);
		//    [reqVar3aLabel.texture setAliasTexParameters];

		//    //req progress
		this._reqVar1bLabel = CCLabel.labelWithString("", CGSizeMake(150, 24), GL2.Text.HorizontalAlign.Right, "AmericanTypewriter-Bold", 15);
		this._reqVar1bLabel.setPosition(ccp(242 + 82 + 46 + this._widthOffset, 207 - 11 - this._heightOffset));
		this._reqVar1bLabel.setColor(ZFColorDefines.colorTextWhite);
		this._windowNode.addChild(this._reqVar1bLabel, 3);
		//    
		this._reqVar2bLabel = CCLabel.labelWithString("", CGSizeMake(150, 24), GL2.Text.HorizontalAlign.Right, "AmericanTypewriter-Bold", 15);
		this._reqVar2bLabel.setPosition(ccp(242 + 82 + 46 + this._widthOffset, 207 - 40 - 11 - this._heightOffset));
		this._reqVar2bLabel.setColor(ZFColorDefines.colorTextWhite);
		this._windowNode.addChild(this._reqVar2bLabel, 3);

		this._reqVar3bLabel = CCLabel.labelWithString("", CGSizeMake(150, 24), GL2.Text.HorizontalAlign.Right, "AmericanTypewriter-Bold", 15);
		this._reqVar3bLabel.setPosition(ccp(242 + 82 + 46 + this._widthOffset, 207 - 80 - 11 - this._heightOffset));
		this._reqVar3bLabel.setColor(ZFColorDefines.colorTextWhite);
		this._windowNode.addChild(this._reqVar3bLabel, 3);

		this._reqVar1Sprite = null;
		this._reqVar2Sprite = null;
		this._reqVar3Sprite = null;
		this._rewardImage = null;
		//    

		this.schedule(this.initTableOffset, 0.25);

		this._currentSelectedIndex = this.numberOfCellsInTableView(this._questTable) - 1;
		
		this._windowNode.setScale(CCDirector.zoomValue());
		if(CCDirector.zoomValue()._x > 1.0)
			this._windowNode.setPosition(new Core.Point(-this._windowNode.getSize()._width*1/8, -this._windowNode.getSize()._height* 1/8 - 10));
	},

	openMenu : function($super) {
		$super();
		this.refreshTable(this._questTable);
	},

	openMenuWithQuest : function(quest) {
		if (this._menuState != ZFMenu.menuStates.menuStateClosed)
			return;

//		console.log("ZFQuestMenu.openMenuWithQuest: " + quest._ID);
		this._selectedQuest = quest;
		this.openMenu(); //[super openMenu];
	},

	displayQuestTable : function() {    
		var qm = ZFQuestMan;
		var gs = GameState;

		this._tableData = [];
		var i = 0;
		// add all queued quest
		for (qni in qm._questQueue) {
			var qn = qm._questQueue[qni];
			//weed out notifications
			if (!qn._alertWindowActive) {
				this._tableData.push(qn);
				i++;
			}
		}

		// add all completed quest
		for (qni in gs._zfGameData._completedQuests) {
			var qn = gs._zfGameData._completedQuests[qni];
			this._tableData.push(qn);
			i++;
		}

		//CGRect mainFrame = [[UIScreen mainScreen] bounds];
		//float resolutionHeight = mainFrame.size.width;
		//float menuHeightOffset = 0;
		//float heightScale = 1;
		//if (resolutionHeight>ORIGINAL_WINDOW_HEIGHT)
		//{
		//    heightScale = (resolutionHeight/320.0)*2/3;
		//    menuHeightOffset = (219*heightScale-219);
		//} 
		this._questTable = CCTableView.tableViewWithDataSource(this, CGSizeMake(154, 110));
		this._questTable._direction = CCScrollView.CCScrollViewDirection.CCScrollViewDirectionVertical;
		this._questTable._tDelegate = this;
		this._questTable._minContainerOffset = ccp(0,20);
		
		if (i > 4)
		{
			this._questTable._maxContainerOffset = ccp(0,-10);
		}
		else
		{
			this._questTable._maxContainerOffset = ccp(0,-100);
		}
		
		this._tableBg.addChild(this._questTable, 5, this.questSelectionMenuTags.kQuestSelectionMenuTagTable);
		this._questTable.setPosition(ccp(0, 140 - this._heightOffset * 2));
		this._questTable.setAnchorPoint(ccp(0,0));		

		if (qm._questQueue.length > 0)
		{
			this._questTable.reloadData();
		}
	},

	initTableOffset : function() {
		this.unschedule(this.initTableOffset);

		var minsize = this._questTable.minContainerOffset();
		this._questTable.setContentOffset(ccp(0, minsize._y));

		if (this._qCell) {
			this.displayCellContents(this._qCell);
		}
	},

	//#pragma mark -
	//#pragma mark TableView Delegate
	refreshTable : function(table) {
		NSNotificationCenter.defaultCenter().postNotificationName(ZFQuestCell.kQuestCellClearSelectorNotification);
	},

	table_cellTouched : function(table, cell) {
		this.refreshTable(table);
		this.displayCellContents(cell);
	},

	displayCellContents : function(questCell) {
		var qm = ZFQuestMan;
		questCell.pressed(this);

		var quest = questCell._quest; // ZFQuestMan._questArray[questCell._questID];  //
		var req = quest.requirements;
		var rewType = quest.rewardType;
		var rewardText = NSLocalizedString(quest.rewardObject);

		switch (rewType) {
		case ZFQuestNotification.questRewardTypes.questRewardTypeResourceXP:
			rewardText = sprintf("%@ %@", rewardText, NSLocalizedString("xp"));
			break;

		case ZFQuestNotification.questRewardTypes.questRewardTypeResourceGold:
			rewardText = sprintf("%@ %@", rewardText, NSLocalizedString("gold"));
			break;

		case ZFQuestNotification.questRewardTypes.questRewardTypeResourceBrains:
			rewardText = sprintf("%@ %@", rewardText, NSLocalizedString("brain(s)"));
			break;
		}

		this._reqVar1aLabel.setString("");
		this._reqVar2aLabel.setString("");
		this._reqVar3aLabel.setString("");
		this._reqVar1bLabel.setString("");
		this._reqVar2bLabel.setString("");
		this._reqVar3bLabel.setString("");

		if (this._rewardImage) {
			this._windowNode.removeChild(this._rewardImage, true);
			this._rewardImage = null;
		}

		if (this._reqVar1Sprite && this._reqVar1Sprite._parent) {
			this._reqVar1Sprite._parent.removeChild(this._reqVar1Sprite, true);
			this._reqVar1Sprite = null;
		}

		if (this._reqVar2Sprite && this._reqVar2Sprite._parent) {
			this._reqVar2Sprite._parent.removeChild(this._reqVar2Sprite, true);
			this._reqVar2Sprite = null;
		}

		if (this._reqVar3Sprite && this._reqVar3Sprite._parent) {
			this._reqVar3Sprite._parent.removeChild(this._reqVar3Sprite, true);
			this._reqVar3Sprite = null;
		}

		this._rewardVarLabel.setString(NSLocalizedString(rewardText));
		//    [rewardVarLabel.texture setAliasTexParameters];
		//    
		//	CGRect mainFrame = [[UIScreen mainScreen] bounds];
		//	float resolutionHeight = mainFrame.size.width;
		//	float menuHeightOffset = 0;
		//	float heightScale = 1;
		//	if (resolutionHeight>ORIGINAL_WINDOW_HEIGHT)
		//	{
		//		heightScale = (resolutionHeight/320.0)*2/3;
		//		menuHeightOffset = (219*heightScale-219);
		//	}
		//	
		if (rewType == this._questRewardTypeItem) {
			var name = quest.rewardObject;
			var marketItem = ZFMarketMenu.marketItemFromName(name);

			if (marketItem.stageActor) {
				this._rewardImage = ZFMarketMenu.spriteNodeFromKey(marketItem._tile, true, ZFMarketMenu.marketColorFromName(marketItem._name));
			} else if (marketItem.tile) {
				this._rewardImage = ZFTileManager.spriteNodeFromKey(marketItem._tile, true);
			} else {
				this._rewardImage = CCSpriteWithFile(marketItem._spriteSheet);
			}

			if (this._rewardImage) {
				this._windowNode.addChild(this._rewardImage, 3);
				this._rewardImage.setPosition(ccp(440 + this._widthOffset, 70 - this._heightOffset));
			}
		}

		var requirements = null;

		if (req.length >= 1) {
			for ( var qi in qm._questQueue) {
				var q = qm._questQueue[qi];
				if (q._ID == questCell._questID) {
					requirements = q._requirements;
					break;
				}
			}

			var text = req[0].text;
			var spriteFilename = req[0].sprite;
			var countTotal = req[0].countTotal;
			var countCurrent = countTotal;

			if (requirements) //quest is note in the queue, dig data based on the quest array instead
			{
				var r = requirements[0];
				countCurrent = r._countCurrent || 0;
			}

			this._reqVar1aLabel.setString(NSLocalizedString(text));
			this._reqVar1bLabel.setString(sprintf("%i/%i", countCurrent , countTotal));

			this._windowNode.removeChild(this._reqVar1Sprite, true);
			this._reqVar1Sprite = CCSprite.spriteWithFile(spriteFilename);
			this._reqVar1Sprite.setPosition(ccp(244 - 28 + this._widthOffset, 197 - this._heightOffset));
			this._windowNode.addChild(this._reqVar1Sprite, 3);
			this._reqVar1aLabel.setColor(ZFColorDefines.colorTextMenuQuestBlue);
			this._reqVar1bLabel.setColor(ZFColorDefines.colorTextMenuQuestBlue);

			//        [reqVar1aLabel.texture setAliasTexParameters];

			if (countCurrent != countTotal) {
				this._reqVar1aLabel.setColor(ZFColorDefines.colorTextWhite);
				this._reqVar1bLabel.setColor(ZFColorDefines.colorTextWhite);
			}
		}

		if (req.length >= 2) {
			var text = req[1].text;
			var spriteFilename = req[1].sprite;
			var countTotal = req[1].countTotal;
			var countCurrent = countTotal;
			//        
			if (requirements) //quest is note in the queue, dig data based on the quest array instead
			{
				var r = requirements[1];
				countCurrent = r._countCurrent || 0;
			}

			this._reqVar2aLabel.setString(NSLocalizedString(text));
			this._reqVar2bLabel.setString(sprintf(NSLocalizedString("%i/%i"), countCurrent , countTotal));
			this._windowNode.removeChild(this._reqVar2Sprite, true);
			this._reqVar2Sprite = CCSprite.spriteWithFile(spriteFilename);
			this._reqVar2Sprite.setPosition(ccp(244 - 28 + this._widthOffset, 197 - 40 - this._heightOffset));
			this._windowNode.addChild(this._reqVar2Sprite, 3);
			this._reqVar2aLabel.setColor(ZFColorDefines.colorTextMenuQuestBlue);
			this._reqVar2bLabel.setColor(ZFColorDefines.colorTextMenuQuestBlue);

			//        [reqVar2aLabel.texture setAliasTexParameters];
			//        
			if (countCurrent != countTotal) {
				this._reqVar2aLabel.setColor(ZFColorDefines.colorTextWhite);
				this._reqVar2bLabel.setColor(ZFColorDefines.colorTextWhite);
			}
		}

		if (req.length >= 3) {
			var text = req[2].text;
			var spriteFilename = req[2].sprite;
			var countTotal = req[2].countTotal;
			var countCurrent = countTotal;

			if (requirements) //quest is note in the queue, dig data based on the quest array instead
			{
				var r = requirements[2];
				countCurrent = r._countCurrent || 0;
			}

			this._reqVar3aLabel.setString(NSLocalizedString(text));
			this._reqVar3bLabel.setString(sprintf(NSLocalizedString("%i/%i"), countCurrent , countTotal));
			this._windowNode.removeChild(this._reqVar3Sprite, true);
			this._reqVar3Sprite = CCSprite.spriteWithFile(spriteFilename);
			this._reqVar3Sprite.setPosition(ccp(244 - 28 + this._widthOffset, 197 - 80 - this._heightOffset));
			this._windowNode.addChild(this._reqVar3Sprite, 3);
			this._reqVar3aLabel.setColor(ccc3(0x2f, 0xa9, 0xff));
			this._reqVar3bLabel.setColor(ccc3(0x2f, 0xa9, 0xff));
			//        [reqVar2aLabel.texture setAliasTexParameters];

			if (countCurrent != countTotal) {
				this._reqVar3aLabel.setColor(ZFColorDefines.colorTextWhite);
				this._reqVar3bLabel.setColor(ZFColorDefines.colorTextWhite);
			}
		}

		if (questCell._name)
			questCell._name.setColor((!requirements) ? ZFColorDefines.colorTextMenuQuestBlue : ZFColorDefines.colorTextWhite);

	},

	//#pragma mark -
	//#pragma mark TableView DataSource
	cellClassForTable : function(table) {
		return ZFQuestCell;
	},

	table_cellAtIndex : function(table, idx) {
	    var questQueueID = this.numberOfCellsInTableView(table) - idx - 1;
	    //out of bounds
	    if (questQueueID >= this._tableData.length || questQueueID < 0) {
	        return null;
	    }
	    
	    var cell = table.dequeueCell();
		
	    if (!cell)  {
	        cell = new ZFQuestCell();
	    }
	    
	    cell._cellID = idx;
	    cell._node = cell._bg;
	    
	    var element = this._tableData[questQueueID];
	    if (element instanceof ZFQuestNotification) {
	        var qn = element;
	        cell.setQuestID(qn._ID);
//	        console.log("ZFQuestMenu.table_cellAtIndex: this._selectedQuest._ID: " + this._selectedQuest._ID);
	        if (this._selectedQuest && this._selectedQuest._ID == qn._ID) {
//	        	console.log("ZFQuestMenu.table_cellAtIndex: " + idx);
	            this._currentSelectedIndex = idx;
	        }
	    } else {
	    	//completed quest
	        cell.setQuestID(element);
	        cell._name.setColor(ZFColorDefines.colorTextMenuQuestBlue);
	    }
	    
	    // store the selected cell
	    if (idx == this._currentSelectedIndex) {
//	    	console.log("ZFQuestMenu.table_cellAtIndex: idx selected: " + idx);
	        this._qCell = cell;
	    }else if (!this._currentSelectedIndex && !this._qCell) {
//	    	console.log("ZFQuestMenu.table_cellAtIndex: default cell selected");
	    	this._qCell = cell;
	    }
	    
	    return cell;
	},

	numberOfCellsInTableView : function(table) {
		var total = this._tableData.length;
		return (total < 6) ? 6 : total;
	},

	getMenuOffset : function() {
		return ccp(0, 0);
	},

	isMenuEnabled : function() {
		return this._isMenuEnabled;
	},

	dismissTimerCallback : function($super) {	    
        if (this._tableData)
        {
    	    this._tableData.length = 0;
    	    this._tableData = null;
        }
        
	    this._selectedQuest = null;
	    
	    this.removeChild(this._rewardVarLabel);
        destroy(this._rewardVarLabel);
        this._rewardVarLabel = null;
        
        this.removeChild(this._reqVar1aLabel);
        destroy(this._reqVar1aLabel);
        this._reqVar1aLabel = null;
        
        this.removeChild(this._reqVar2aLabel);
        destroy(this._reqVar2aLabel);
        this._reqVar2aLabel = null;
        
        this.removeChild(this._reqVar3aLabel);
        destroy(this._reqVar3aLabel);
        this._reqVar3aLabel = null;
        
        this.removeChild(this._reqVar1bLabel);
        destroy(this._reqVar1bLabel);
        this._reqVar1bLabel = null;
        
        this.removeChild(this._reqVar2bLabel);
        destroy(this._reqVar2bLabel);
        this._reqVar2bLabel = null;
        
        this.removeChild(this._reqVar3bLabel);
        destroy(this._reqVar3bLabel);
        this._reqVar3bLabel = null;
        
        this.removeChild(this._reqVar1Sprite);
        destroy(this._reqVar1Sprite);
        this._reqVar1Sprite = null;
        
        this.removeChild(this._reqVar2Sprite);
        destroy(this._reqVar2Sprite);
        this._reqVar2Sprite = null;
        
        this.removeChild(this._reqVar3Sprite);
        destroy(this._reqVar3Sprite);
        this._reqVar3Sprite = null;
        
        this.removeChild(this._rewardImage);
        destroy(this._rewardImage);
        this._rewardImage = null;
        
	    this._tableBg.removeChild(this._questTable);
	    destroy(this._questTable);
        this._questTable = null;
	    
		for (var i = this.questSelectionMenuTags.kQuestSelectionMenuTagTable; i < this.questSelectionMenuTags.kQuestMenuTagMAX; i++) {
			var child = this._windowNode.getChildByTag(i);
			if (child)
			{
			    this._windowNode.removeChild(child);
			    destroy(child);
			}
		}
	    
		NSNotificationCenter.defaultCenter().postNotificationName(ZFGameDefines.kEnableInGameMenusNotification, null);

		$super();
		this._isMenuEnabled = false;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/ZFMenus/InGame/ZFInGameMenu'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/InGame/ZFInGameMenu'] || {}; $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/InGame/ZFInGameMenu'] = exports; exports.ZFInGameMenu = ZFMenu.subclass(
{
	classname:'ZFInGameMenu',

	inGameMenuTag: {
		kInGameMenuTagLabel1: ZFMenu.kZFMenuTags.kMenuTagMAX,
		kInGameMenuTagLabel2: ZFMenu.kZFMenuTags.kMenuTagMAX + 1,
		kInGameMenuTagLabel3: ZFMenu.kZFMenuTags.kMenuTagMAX + 2,
		kInGameMenuTagLabel4: ZFMenu.kZFMenuTags.kMenuTagMAX + 3,
		kInGameMenuTagLabel5: ZFMenu.kZFMenuTags.kMenuTagMAX + 4,
		kInGameMenuTagLabel6: ZFMenu.kZFMenuTags.kMenuTagMAX + 5,
		kInGameMenuTagLavel7: ZFMenu.kZFMenuTags.kMenuTagMAX + 6,
		kInGameMenuTagLavel8: ZFMenu.kZFMenuTags.kMenuTagMAX + 7,
		kInGameMenuTagSprite0: ZFMenu.kZFMenuTags.kMenuTagMAX + 8,
		kInGameMenuTagSprite1: ZFMenu.kZFMenuTags.kMenuTagMAX + 9,
		kInGameMenuTagSprite2: ZFMenu.kZFMenuTags.kMenuTagMAX + 10,
		kInGameMenuTagSprite3: ZFMenu.kZFMenuTags.kMenuTagMAX + 11,
		kInGameMenuTagSprite4: ZFMenu.kZFMenuTags.kMenuTagMAX + 12,
		kInGameMenuTagSprite5: ZFMenu.kZFMenuTags.kMenuTagMAX + 13,
		kInGameMenuTagSprite6: ZFMenu.kZFMenuTags.kMenuTagMAX + 14,
		kZFMenuTagBackground2: ZFMenu.kZFMenuTags.kMenuTagMAX + 15
	},

	initialize: function()
	{
		this._hm = null;
		this._isMenuEnabled = false;
		
		if(!this._windowNode){
//			var w = CGSizeMake(480, 320);
			var winHeight = 320;
			this._position = ccp(0, - winHeight * 2);
			this._windowNode = CCColorLayer.layerWithColor(ccc4(0, 0, 0, 0), this._winSize._width, this._winSize._height);
			this.addChild(this._windowNode);
			
			this._windowNode.setScale(CCDirector.zoomValue());
			if(CCDirector.zoomValue()._x > 1.0)
				this._windowNode.setPosition(new Core.Point(-this._windowNode.getSize()._width*1/8, -this._windowNode.getSize()._height* 1/8 - 10));
		}
	},

	destroy: function()
	{
		destroyWithChildren(this._dimLayer);
		this._dimLayer = null;
	},

	initElements: function()
	{
		this._isMenuEnabled = true;

		var w = CCDirector.winSize();

		this._moreGamesTapped = false;

//		if(this._widthOffset > 0)
//		{
//			var resolutionHeight = UI.Window._height;//WINDOW_HEIGHT
//			/*this._dimLayer.changeHeight(2*resolutionHeight);
//			if(!this._dimLayer.getParent())
//			{
//				this.addChild(this._dimLayer, 1000);
//				CCTouchDispatcher.sharedDispatcher().addTargetedDelegate(this._dimLayer, 90, true);
//			}*/
//		}

		// TESTING BETTER BG SPRITESHEET ! (PS: IT WORKS) //
		var windowSize = CGRectMake(4, -22, 480-8, 290);
		var c = CGRectMake(87,116,50,50);
		var b = CGRectMake(138,116,50,50);
		var s = CGRectMake(87,167,50,50);
		var f = ZFGameDefines.HUDELEMENTS1_FILE;
		var color = ccc3(0xba,0xbf,0xc8);

		var bgOverlay = ZFMenu.makeWindow(windowSize, c, b, f, color, CGRectMake(0,0,0,0), CGRectMake(0,0,0,0), s);

		bgOverlay.setPosition(w._width/2-windowSize.getSize()._width/2, -22+this._heightOffset);

		this._backgroundSpriteSheet = bgOverlay.getChildByTag(1);

		this._windowNode.addChild(bgOverlay, 1, this.kZFMenuTags.kZFMenuTagBackground);

		//dismiss
		var dismissItem = CCMenuItemImage.itemFromNormalImage("bigX.png", "bigXSel.png", this, this.dismissMenu.bind(this));
		this._dismissMenu = CCMenu.menuWithItems([dismissItem]);
		this._windowNode.addChild(this._dismissMenu, 5);

		//dismissItem.setAnchorPoint(ccp(0,0));
		dismissItem.setPosition(ccp(-dismissItem.getSize()._width-2, 
				-dismissItem.getSize()._width-2));
		

		//TODO delete this setPosition when possible
		this._dismissMenu.setPosition(ccp(2 + w._width/2 + windowSize.getSize()._width/2, 
                						3 + w._height/2 + windowSize.getSize()._height/2+15));


		
		var embelishmentUR = CCSprite.spriteWithFile(f, CGRectMake(189,116,55,57));
	    embelishmentUR.setAnchorPoint(ccp(1,1));
		embelishmentUR.setPosition(ccp(2 + w._width/2 + windowSize.getSize()._width/2, 
	                                   3 + w._height/2 + windowSize.getSize()._height/2+15));
		this._windowNode.addChild(embelishmentUR, 4);

		var embelishmentUL = CCSprite.spriteWithFile(f, CGRectMake(342,112,84,96));
	    embelishmentUL.setAnchorPoint(ccp(0,1));
		embelishmentUL.setPosition(ccp(-8 + w._width/2 - windowSize.getSize()._width/2, 
                						15 + w._height/2 + windowSize.getSize()._height/2));
		this._windowNode.addChild(embelishmentUL, 4);

		var embelishmentLL = CCSprite.spriteWithFile(f, CGRectMake(426,112,86,86));
	    embelishmentLL.setAnchorPoint(ccp(0,0));
	    embelishmentLL.setPosition(ccp(-2 + w._width/2 - windowSize.getSize()._width/2,
                					   -8 + w._height/2 - windowSize.getSize()._height/2));
		this._windowNode.addChild(embelishmentLL, 4);

		var embelishmentLR = CCSprite.spriteWithFile(f, CGRectMake(426,112,86,86));
	    embelishmentLR.setFlipX(true);
	    embelishmentLR.setAnchorPoint(ccp(1,0));
	    embelishmentLR.setPosition(ccp( 3 + w._width/2 + windowSize.getSize()._width/2 - embelishmentLR.getSize()._width,
                					    -8 + w._height/2 - windowSize.getSize()._height/2));
		this._windowNode.addChild(embelishmentLR, 4);
		
		var buttonUPlist = new Array();
		var buttonDnlist = new Array();
		
		for (var i = 0; i < 6 ; i++)
		{
			var buttonUP = CCSprite.spriteWithFile(f, CGRectMake(245,116,96,97));
			var buttonDn = CCSprite.spriteWithFile(f, CGRectMake(245,116,96,97));
			buttonDn.setColor(ccc3(0x80, 0x80, 0x80));
			
			buttonUPlist.push(buttonUP);
			buttonDnlist.push(buttonDn);
		}

		var button1 = CCMenuItemImage.itemFromNormalSprite(buttonUPlist[0], buttonDnlist[0], this, this.mainMenuButtonTapped.bind(this));
		var button2 = CCMenuItemImage.itemFromNormalSprite(buttonUPlist[1], buttonDnlist[1], this, this.farmerButtonTapped.bind(this));
		var button3 = CCMenuItemImage.itemFromNormalSprite(buttonUPlist[2], buttonDnlist[2], this, this.questButtonTapped.bind(this));
		var button4 = CCMenuItemImage.itemFromNormalSprite(buttonUPlist[3], buttonDnlist[3], this, this.saveButtonTapped.bind(this));
		var button5 = CCMenuItemImage.itemFromNormalSprite(buttonUPlist[4], buttonDnlist[4], this, this.mutationButtonTapped.bind(this));
		var button6 = CCMenuItemImage.itemFromNormalSprite(buttonUPlist[5], buttonDnlist[5], this, this.helpButtonTapped.bind(this));
		
//		var button7 = CCMenuItemImage.itemFromNormalSprite(buttonUPlist[6], buttonDnlist[6], this, this.giftButtonTapped.bind(this));

		this._menu = CCMenu.menuWithItems([button1, button2, button3, button4, button5, button6/*, button7 , button8*/]);
		this._menu.setAnchorPoint(ccp(0.5, 0.5));
		//this._menu.setPosition(ccpAdd( this._menu.getPosition(), ccp(-15, 0)));

		//this._menu.alignItemsInColumns(NSNumber.numberWithInt(4), NSNumber.numberWithInt(3), null); //alignItemsInColumns doesn't follow adhere to content size
		this._windowNode.addChild(this._menu, 2);
//		return;
		//set positions of menu items, since alignItemsInColumns doesn't adhere to contentsize property
		var item0 = this._menu._children[0];
		var item1 = this._menu._children[2];
		var item2 = this._menu._children[4];
		var item3 = this._menu._children[6];
		var item4 = this._menu._children[8];
		var item5 = this._menu._children[10];
//		var item6 = this._menu._children[12];
		item0.setPosition(ccp(-144, 50.5));
		item1.setPosition(ccp(-38, 50.5));
		item2.setPosition(ccp(68, 50.5));
		item3.setPosition(ccp(174, 50.5));
		item4.setPosition(ccp(-120, -51.5));
		item5.setPosition(ccp(10, -51.5));
//		item6.setPosition(ccp(140, -51.5));

		this._menu.setPosition(ccp(w._width/2 - item0.getSize()._width/2 - 15, w._height/2 - item0.getSize()._height/2 - 10));
		
		for (var index = 0; index < this._menu._children.length/2 ; index++) {
	        var iconFileName = null;
	        var iconLabelName = null;
	        var mi = this._menu._children[2 * index];

	        switch (index) 
	        {
	            case 0: iconFileName = "iconMainMenu.png";     iconLabelName = Core.Localization.getString("Main Menu");  break;
	            case 1: iconFileName = "iconFarmerMenu.png";   iconLabelName = Core.Localization.getString("Farmer");     break;
	            case 2: iconFileName = "iconQuestMenu.png";    iconLabelName = Core.Localization.getString("Quests");     break;
	            case 3: iconFileName = "iconSaveGame.png";     iconLabelName = Core.Localization.getString("Save Game");  break;
	            case 4: iconFileName = "iconMutationMenu.png"; iconLabelName = Core.Localization.getString("Mutations");  break;
	            case 5: iconFileName = "iconHelp.png";         iconLabelName = Core.Localization.getString("Help");       break;
//	            case 6: iconFileName = "iconGift.png";         iconLabelName = Core.Localization.getString("Give Gifts"); continue;
	            
	        }

	        var icon = CCSprite.spriteWithFile(iconFileName);
	        icon.setPosition(ccpAdd(ccpAdd(this._menu.getPosition(), ccpAdd(ccp(0,6), /*TODO delete*/ccp(48,50)/**/)), mi.getPosition()));
	        this._windowNode.addChild(icon, 2, this.inGameMenuTag.kInGameMenuTagSprite0 + index);

	        var iconLabel = CCLabel.labelWithString(iconLabelName, "Arial-BoldMT", 13);
	        iconLabel.setPosition(ccpAdd(ccpAdd(this._menu.getPosition(), ccpAdd(ccp(0,-36), /*TODO delete*/ccp(48,50)/**/)), mi.getPosition()));
	        iconLabel.setColor(ZFColorDefines.colorTextAsh);
	        this._windowNode.addChild(iconLabel, 2, this.inGameMenuTag.kInGameMenuTagLabel1 + index);
		}
	},

	isMenuEnabled: function()
	{
		return this._isMenuEnabled;
	},

	openTimerCallback: function($super)
	{
		$super();
		//this.showPlayhavenBadge();
	},

	dismissMenu: function($super, sender)
	{
		if(this._hm)
		{
			destroyWithChildren(this._hm);
			this._hm = null;
		}
		
		this.cleanPlayhavenBadge();
    	
		$super();

		this._isMenuEnabled = false;
	},

	dismissTimerCallback: function($super)
	{
		this._backgroundSpriteSheet = null;
		this._menu = null;
		this._dismissMenu = null;
    	
		$super();
	},
	
	subMenuClosed: function()
	{
		this.enableMenus();
		NSNotificationCenter.defaultCenter().removeObserver(this, ZFGameDefines.kEnableInGameMenusNotification, null);

		//FIXME 
//		if (this._moreGamesTapped)
//		{
//			this.showPlayhavenBadge();
//		}
	},

	cleanPlayhavenBadge: function()
	{
	    console.log("ZFInGameMenu.cleanPlayhavenBadge not implemented");
		if(this._phnv)
		{
			/* TODO ZFPlayhavenNotifierViewController
			this._phnv.view.removeFromSuperview();
			this._phnv = null;
			*/
		}
	},

	showPlayhavenBadge: function()
	{
	    console.log("ZFInGameMenu.showPlayhavenBadge not implemented");
		if(!this._phnv)
		{
			/*
			 * TODO ZFPlayhavenNotifierViewController
			this._phnv = new ZFPlayhavenNotifierViewController();
			PlayHaven.loadChartsNotifierWithDelegate(this._phnv, null);
			*/
		}
	},

	mainMenuButtonTapped: function(sender)
	{
		console.log("ZFInGameMenu.mainMenuButtonTapped mostly not implemented");
		// Make sure we save the current player's data locally
		var gs = GameState;
		gs.saveGame();

		this.dismissMenu(this);

		//TODO
		MainMenu.ReopenMenu();
		/*
			ZombieFarmAppDelegate *appDelegate = (ZombieFarmAppDelegate *)[[UIApplication sharedApplication] delegate];
			[appDelegate.window addSubview:appDelegate.mainMenu.view];
			appDelegate.mainMenu.view.hidden = NO;
			appDelegate.inMainMenu = YES;
			
			appDelegate.mainMenu.messageView.hidden = YES;
			//[appDelegate.mainMenu.playButton setTitle:NSLocalizedString(@"Resume", @"Resume back to game") forState:UIControlStateNormal];
			//[appDelegate.mainMenu initPlayhavenBadge];
			[UIView beginAnimations:nil context:nil]; // begins animation block
			[UIView setAnimationDuration:0.5f];        // sets animation duration
			[UIView setAnimationDelegate:self];        // sets delegate for this block
			appDelegate.mainMenu.fadeView.alpha = 0.0;       // Fades the alpha channel of this view to "0.0" over the animationDuration of "0.75" seconds
			[UIView commitAnimations];   // commits the animation block.  This Block is done.
		*/
		/*
			NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
											 @"mm", @"Selected setting",
											 nil];
			[[EventTracker eventTracker] sendEvent:@"zf_farm_sel_settings" withParameters:eventDictionary andDelegate:nil];
		 */
	},

	saveButtonTapped: function(sender)
	{
		console.log("saveButtonTapped");

		var gs = GameState;
		var message = NSLocalizedString("Saving game...");
		this.dismissMenu(this);
		ZFGuiLayer.displayToolTip(message, 2);
		gs.saveGameReal();
		message = NSLocalizedString("Game Saved");
		setTimeout(function(){
			ZFGuiLayer.displayToolTip(message, 1);
		}.bind(this), 2100);
		
//		var delegate = ZFGuiLayer.gui();

		//delegate.disableShellMenu();

		// Queue up a status check and a save operation
		//var syncQueue = SyncQueue.syncQueue();

		/*var statusCheckOp = new StatusCheckOperation().initWithManager(syncQueue, delegate);
		syncQueue.operations().addOperation(statusCheckOp);

		var saveGameOp = new RemoteGameSaveOperation().initWithManager(syncQueue, delegate);
		syncQueue.operations().addOperation(saveGameOp);*/

		/*
			NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
											 @"save", @"Selected setting",
											 nil];
			[[EventTracker eventTracker] sendEvent:@"zf_farm_sel_settings" withParameters:eventDictionary andDelegate:nil];
		 */
	},

	helpButtonTapped: function(sender)
	{
		console.log("helpButtonTapped");

		this._windowNode.reorderChild(this._dimLayer, 0);
		new ZFHelpMenu(); //.helpMenu().openMenu();
		NSNotificationCenter.addObserver(this, this.subMenuClosed.bind(this), ZFGameDefines.kEnableInGameMenusNotification, null);

		/* TODO: Events
	    NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
											 @"help", @"Selected setting",
											 nil];
		[[EventTracker eventTracker] sendEvent:@"zf_farm_sel_settings" withParameters:eventDictionary andDelegate:nil]; */
	},

	mutationButtonTapped: function(sender)
	{
		//console.log("mutationButtonTapped");
		this.disableMenus();
		this._windowNode.reorderChild(this._dimLayer, 0);
		ZFMutationMenu.mutationMenu().openMenu();
//		if(!ZFMutationMenu._mutationCollectionArray)
//		{
//			ZFMutationMenu.init(ZFMutationMenu.openMenu.bind(ZFMutationMenu));
//		}
//		else
//		{
//			ZFMutationMenu.mutationMenu().openMenu();
//		}
//		setTimeout(this.dismissMenu.bind(this),500);
	    NSNotificationCenter.defaultCenter().addObserver(this, this.subMenuClosed.bind(this), ZFGameDefines.kEnableInGameMenusNotification, null);

		/*
			NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
											 @"mutations", @"Selected setting",
											 nil];
			[[EventTracker eventTracker] sendEvent:@"zf_farm_sel_settings" withParameters:eventDictionary andDelegate:nil];
		 */
	},
	
	questButtonTapped: function(sender)
	{
		this.disableMenus();
		this._windowNode.reorderChild(this._dimLayer, 0);
		
		ZFQuestMenu.openMenu();
		NSNotificationCenter.defaultCenter().addObserver(this, this.subMenuClosed.bind(this), ZFGameDefines.kEnableInGameMenusNotification, null);

		/* FIXME:
			NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys: @"quests", @"Selected setting", nil];
			[[EventTracker eventTracker] sendEvent:@"zf_farm_sel_settings" withParameters:eventDictionary andDelegate:nil];
		 */
	},

	community: function(sender)
	{
//		this.cleanPlayhavenBadge();
		//TODO ZFPlayHavenView
		//new ZFPlayHavenView().initWithCommunity();
//		this.disableMenus();
//		this._windowNode.reorderChild(this._dimLayer, 0);
//		NSNotificationCenter.defaultCenter().addObserver(this, this.subMenuClosed.bind(this), ZFGameDefines.kEnableInGameMenusNotification, null);
	},

	charts: function(sender)
	{
//		this._moreGamesTapped = true;
//		this.cleanPlayhavenBadge();
		//TODO ZFPlayHavenView
		//new ZFPlayHavenView().initWithCharts();
//		this.disableMenus();
//		this._windowNode.reorderChild(this._dimLayer, 0);
//		NSNotificationCenter.defaultCenter().addObserver(this, this.subMenuClosed.bind(this), ZFGameDefines.kEnableInGameMenusNotification, null);
	},

	farmerButtonTapped: function(sender)
	{
		console.log("farmerButtonTapped");

		this.disableMenus();
		this._windowNode.reorderChild(this._dimLayer, 0);
		ZFFarmerSelectionMenu.farmerSelectionMenu().openMenu();
		NSNotificationCenter.defaultCenter().addObserver(this, this.subMenuClosed.bind(this), ZFGameDefines.kEnableInGameMenusNotification, null);

		/* TODO: Events
		NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
										 @"farmer", @"Selected setting",
										 nil];
		[[EventTracker eventTracker] sendEvent:@"zf_farm_sel_settings" withParameters:eventDictionary andDelegate:nil]; */
	},

	giftButtonTapped: function(sender)
	{
		console.log("giftButtonTapped");

		//TODO ZFGameCenterDelegate
		var gameCenterEnabled = null;//ZFGameCenterDelegate.isGameCenterEnabled();

		// Check if we are logged into Game Center
		if(gameCenterEnabled)
		{
			//TODO defaultCenter
			//NSNotificationCenter.defaultCenter().addObserver(this, this.friendsListRetrieved.bind(this), ZFGameDefines.kZFGameCenterDelegateRetrievedFriendsNotification, null);
//			this.disableMenus();

//			var gcd = ZFGameCenterDelegate.gameCenterDelegate();
//			gcd.retrieveFriends();
			
			/*
				NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
												 @"give gift", @"Selected setting",
												 nil];
				[[EventTracker eventTracker] sendEvent:@"zf_farm_sel_settings" withParameters:eventDictionary andDelegate:nil];
			 */
		}
		else
		{
			/*
				NSString* message = [NSString stringWithString:NSLocalizedString(@"You must be logged into Game Center to gift friends.", nil)];
				UIAlertView *av = [[UIAlertView alloc] initWithTitle:NSLocalizedString(@"Gifting Error", @"Gifting Error") 
															 message:message
															delegate:self 
												   cancelButtonTitle:NSLocalizedString(@"Ok", @"Ok")
												   otherButtonTitles:nil];
				
				[av show];
				[av release];
			 */
		}
	},

	friendsListRetrieved: function(notification)
	{
		//TODO defaultCenter
		//NSNotificationCenter.defaultCenter().removeObserver(this, ZFGameDefines.kZFGameCenterDelegateRetrievedFriendsNotification, null);

		//TODO
		
		/*
			ZFGameCenterDelegate *gcd = (ZFGameCenterDelegate *)notification.object;
			NSString* errorMsg = [notification.userInfo objectForKey:@"error"];
			
			if(errorMsg)
			{
				UIAlertView *av = [[UIAlertView alloc] initWithTitle:NSLocalizedString(@"Friends List Error", @"Synchronization Error") 
															 message:errorMsg
															delegate:self 
												   cancelButtonTitle:NSLocalizedString(@"Ok", @"Ok")
												   otherButtonTitles:nil];
				
				[av show];
				[av release];
				
				[self enableMenus];
				return;
			}
			
			if([gcd.friendsList count])
			{
				GameData* gameData = [GameState gameState].zfGameData;
				NSTimeInterval day = 60 * 60 * 24;
				// gifting time restraint 
				if(!gameData.friendGiftingDate || fabs([gameData.friendGiftingDate timeIntervalSinceNow]) > day) 
				{
					gameData.friendGiftingDate = [GameState getBeginningOfTheDayFromDate:[NSDate date]];
					[gameData.sentGiftFriendsIDs removeAllObjects];
				}
				
		#ifdef ZF_SUBMISSION
				if([gameData.sentGiftFriendsIDs count] < 5)
		#else
				if(1)
		#endif
				{
					[self cleanPlayhavenBadge];
					[[ZFGuiLayer gui] displayAlertGiftSelection:gameData.level];
					[self reorderChild:dimLayer z:0];
					[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(subMenuClosed) name:kEnableInGameMenusNotification object:nil];
				}
				else 
				{
					NSString* message = [NSString stringWithString:@"Can't send gifts to more than 5 friends a day."];
					UIAlertView *av = [[UIAlertView alloc] initWithTitle:NSLocalizedString(@"Gifting Error", @"Gifting Error") 
																 message:message
																delegate:self 
													   cancelButtonTitle:NSLocalizedString(@"Ok", @"Ok")
													   otherButtonTitles:nil];
					
					[av show];
					[av release];
					
					[self enableMenus];
				}
		
			}
			else 
			{
				NSString* message = [NSString stringWithString:NSLocalizedString(@"You must have Game Center friends in order to gift.", @"No friends message")];
				UIAlertView *av = [[UIAlertView alloc] initWithTitle:NSLocalizedString(@"Gifting Error", @"Gifting Error") 
															 message:message
															delegate:self 
												   cancelButtonTitle:NSLocalizedString(@"Ok", @"Ok")
												   otherButtonTitles:nil];
				
				[av show];
				[av release];
				
				[self enableMenus];
			}
		 */
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/ZFMenus/Help/ZFHelpMenu'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Help/ZFHelpMenu'] || {}; $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Help/ZFHelpMenu'] = exports; var UI = require('NGCore/Client/UI').UI;

exports.ZFHelpMenu = ZFMenu.subclass({

	classname : "ZFHelpMenu",

	helpMenuTags : {
		kHelpMenuTagBG : ZFMenu.kZFMenuTags.kMenuTagMAX,
	},

	initialize: function($super) {
		//super added so we don't call it
		
		this._winSize = CCDirector.winSize();
		this._cornerX=0;
		this._cornerY=0;
		width = this._winSize._width-this._cornerX*2;
		height = this._winSize._height-this._cornerY*2;
		barHeight = Math.floor(height*0.08);//8%

		var mainRect = new UI.ViewGeometry.Rect(0, 0, width, height);
		this._baseView = new UI.View();
		this._baseView.setFrame(mainRect.array());
		
//		this.baseView.setAlpha('FFFFFFFF');
		
		UI.Window.document.addChild(this._baseView);

		// Sets up web view
		var webRect = new UI.ViewGeometry.Rect(this._cornerX, this._cornerY, width, height /*- barHeight*/);
		
		this._webView = new UI.WebView();
		this._webView.setFrame(webRect.array());
		this._baseView.addChild(this._webView);
		this._webView.setGradient({
			gradient: [
			    "00000000 0",
			]
		},UI.State.Normal);
		UI.Window.document.addChild(this._baseView);
		
		var url = "./Content/help";
		
		if(Core.Localization._lang == "ja"){
			url += "ja.html";
		} else{
			url += ".html";
		}
		this._webView.loadDocument(url);
		
//		var buttonHeight = Math.floor(barHeight*0.7);//70%
		this._closeButton = new UI.Button();
		this._closeButton.setFrame([width - 55, 7, 40, 40]);
		
		
		this._closeButton.setGradient({
			corners: '12 12 12 12',
			outerLine: "00 1.5",
			innerLine: "99FF 1.5",
			gradient: [ "FFFF0000 1.0","FFFF0000 1.0" ]
		},UI.State.Normal);
		
		this._closeButton.setGradient({
			corners: '12 12 12 12',
			outerLine: "00 1.5",
			innerLine: "99FF 1.5",
			gradient: [ "FFFF8888 1.0","FFFF8888 1.0" ]
		},UI.State.Pressed);
		
		this._closeButton.setText('X',UI.State.Normal);
		this._closeButton.setTextSize('25');
		this._closeButton.setTextColor('FFFFFFFF');
		this._closeButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
		
		this._closeButton.onclick = this.dismissMenu.bind(this);
		
		this._baseView.addChild(this._closeButton);
		BackButtonHandler.push(this);
	},
	
	dismissMenu: function() {
		this._closeButton.destroy();
		this._webView.destroy();
		this._baseView.destroy();
		BackButtonHandler.removeElement(this);
		NSNotificationCenter.postNotificationName(ZFGameDefines.kEnableInGameMenusNotification, null);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/ZFMenus/Mausoleum/ZFMausoleumMenu'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Mausoleum/ZFMausoleumMenu'] || {}; $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Mausoleum/ZFMausoleumMenu'] = exports; exports.ZFMausoleumMenu = ZFMenu.singleton
({
	classname : 'ZFMausoleumMenu',
	
	mausoleumMenuTags : 
	{
		kMausoleumMenuTagStoneOverlay :	3, /* kMenuTagMAX */
		kMausoleumMenuTagBanner : 4,
		kMausoleumMenuTagSkullL : 5,
		kMausoleumMenuTagSkullR : 6,
		kMausoleumMenuTagTitle : 7,
		kMausoleumMenuTagTitleShadow : 8,
		kMausoleumMenuTagSelector : 9,
		kMausoleumMenuTagTable : 10,
		kMausoleumMenuTagLowerSection : 11,
		kMausoleumMenuTagSelectorDim : 12
	},
	
	viewStates : 
	{
		viewsStateOff : 0,
		viewsStateOn : 1
	},
	
	actionStates :
	{
		actionStateEnter : 0,
		actionStateExit : 1,
		actionStateSwap : 2,
		actionStateMAX : 3
	},
	
	initialize : function()
	{
		this._mvTable = null; // CCMultiColumnTableView
		this._selector = null; // CCColorLayer
		this._icon = null; // CCSprite
		this._selectorMenuItemLabel = null; // CCMenuItemFont
		this._currentCellIndex = 0;
		this._swap = false; // BOOL
		
		this._blockingForSwap = false; // BOOL
		this._blockingForView = false; // BOOL
		this._swapCellIndex = 0; // int
		
		this._contextPanel = null; // CCColorLayer
		this._contextPanelBG = null; // CCLayer
		this._contextPanelViewButton = null; // CCMenuItemToggle
		this._contextPanelActionButton = null; // CCMenuItemToggle
		this._contextPanelMenu = null; // ZFMenuWithHigherPriority
		this._cellActor = null; // ZombieActor
		this._selectorDimLayer = null; // CCColorLayer
		
		this._widthScale = 0; // float
		this._fakeCells = 0;  // int
		
		this._initialized = false;
	},
	
	$mausoleumMenu : function()
	{ 
//		if (!this._initialized) {
//			this.initElements();
//			this._initialized = true;
//		}
		return this;
	},
	
	initElements : function($super)
	{
		var acm = ZFActorManager;
		this._widthScale = 1.0;
		this._fakeCells = 0;
		
		var w = CGSizeMake(480, 320);
		
		this._widthOffset = (this._winSize._width - w._width) / 2;
		this._heightOffset = -(this._winSize._height - w._height) / 2;
		
		if (this._widthOffset>0)
		{
			this._widthScale = 2.0;
			this._fakeCells = acm._zombieStorage.length % 6;
		}
		
		$super();
		
		this._dimLayer.setOpacity(0x0);
		
		//this._heightOffset = 0 (iphone)
		//this._heightOffset = -224 (ipad)
		//this._heightOffset = 80 (xperia)
		
		this.cleanWindow(this.kZFMenuTags.kZFMenuTagBackground);
		var f = "hudElements.png";
		var windowSize = CGRectMake(w._width -295 -26, w._height + this._heightOffset, (295 * this._widthScale + 26), 320);
		var c = CGRectMake(172, 32, 41, 41);
		var bc = CGRectMake(214, 32, 41, 41);
		
		var b = CGRectMake(131, 1, 26, 26);
		var bb = CGRectMake(104, 1, 26, 26);
		var s = CGRectMake(158, 1, 26, 26);
		
		var color = ccc4(0x49, 0x58, 0x61, 0x00);
		
		var stoneOverlay = ZFMenu.makeWindow(windowSize, c, b, f, color, bc, bb, s, true);	
		//borde de piedras (todo)
		stoneOverlay.setPosition(ccpAdd(stoneOverlay.getPosition(), ccp(0, this._heightOffset)));
		this._windowNode.addChild(stoneOverlay, 6, this.mausoleumMenuTags.kMausoleumMenuTagStoneOverlay);
		
		//fondo gris !
		var colorLayer = CCColorLayer.layerWithColor(ccc4(0x49, 0x58, 0x61, 0xFF), windowSize._size._width, w._height - 15);
		this._windowNode.addChild(colorLayer, 1, this.mausoleumMenuTags.kMausoleumMenuTagStoneOverlay);
		colorLayer.setPosition(0, 166 * 1.92 + 40);
		colorLayer.setPosition(0, this._dismissMenu.getPosition()._y - (w._height - 30)/2 + 30);


		this._dismissMenu.setPosition(ccpAdd(ccp(0, this._dismissMenu.getPosition()._y), ccp((295 * this._widthScale - 15) , 0)));
		
		windowSize = CGRectMake((w._width * 45/100*this._widthScale + 3) - this._widthOffset*2.5/10, w._height+this._heightOffset, 200,50); // full screen
		c  = CGRectMake(256, 24, 8, 8);
		s  = CGRectMake(256, 33, 8, 8);
		bc = CGRectMake(256, 42, 8, 8);
		b  = CGRectMake(265, 24, 24, 8);
		bb = CGRectMake(265, 33, 24, 8);
		color = ccc4(0x49, 0x58, 0x61, 0xff);
		
		//banner de ARRIBA.
		var bannerOverlay = ZFMenu.makeWindow(windowSize, c, b, f, color, bc, bb, s, true);
		var contextX = Math.min(0.32 * this._resolutionHeight - 90, 200);
		bannerOverlay.setPosition(ccpAdd(bannerOverlay.getPosition(), ccp(contextX, this._heightOffset)))
		this._windowNode.addChild(bannerOverlay, 7, this.mausoleumMenuTags.kMausoleumMenuTagBanner);
		
		// rectangle for skull
		var skullRect = CGRectMake(256, 1, 21, 22);
		var skullSpriteL = CCSprite.spriteWithFile(f, skullRect);
		var skullSpriteR = CCSprite.spriteWithFile(f, skullRect);
		
//		var titlePosition = Math.min(0.25 * this._resolutionHeight + 45, 330);
		this._windowNode.addChild(skullSpriteL, 7, this.mausoleumMenuTags.kMausoleumMenuTagSkullL);
		this._windowNode.addChild(skullSpriteR, 7, this.mausoleumMenuTags.kMausoleumMenuTagSkullR);
		
		skullSpriteL.setPosition(ccp(bannerOverlay.getPosition()._x, this._dismissMenu.getPosition()._y));
		skullSpriteR.setPosition(ccp(bannerOverlay.getPosition()._x + windowSize._size._width, this._dismissMenu.getPosition()._y));
		
		var titlePosition = ccp((skullSpriteL.getPosition()._x + skullSpriteR.getPosition()._x)/2, this._dismissMenu.getPosition()._y + 20);
		
		this._title = CCLabel.labelWithString(NSLocalizedString("Mausoleum", "Mausoleum Font"), CGSizeMake(200, 50), GL2.Text.VerticalAlign.Middle, "Arial", 26);
		this._title.setColor(ZFColorDefines.colorTextWhite);
		this._title.setPosition(titlePosition);
//		this._title.setPosition(bannerOverlay.getPosition()._x +100, this._dismissMenu.getPosition()._y + 20);
		this._windowNode.addChild(this._title, 9, this.mausoleumMenuTags.kMausoleumMenuTagTitle);
		
		// ////////// END BG STUFF /////////////////

		var cSize = MausoleumCell.cellSize();
		this._mvTable = CCMultiColumnTableView.tableViewWithDataSource(this, CGSizeMake(cSize._width * 3*this._widthScale, 80 * 3 + 15+10));
		this._mvTable._direction = CCScrollView.CCScrollViewDirection.CCScrollViewDirectionVertical;
		this._mvTable._tDelegate = this;
		if (this._widthScale > 1)
		{
			this._mvTable._bounces = false;
		}
		this._windowNode.addChild(this._mvTable, 2, this.mausoleumMenuTags.kMausoleumMenuTagTable);
		this._mvTable.reloadData();
		this._mvTable.setPosition(stoneOverlay.getPosition()._x + 40, 30 - this._heightOffset);
		
		this._selectorDimLayer = CCColorLayer.layerWithColor(ccc4(0x21, 0x24, 0x28, 0xFF), 93-9,73-10);	
		this._selectorDimLayer.setPosition(ccp(4,38+this._heightOffset));
		this._selector = CCColorLayer.layerWithColor(ccc4(0x0, 0, 0, 0x0), 93, 73);
		this._selector.addChild(this._selectorDimLayer, 0, this.mausoleumMenuTags.kMausoleumMenuTagSelectorDim);
		
		var uL = CCSprite.spriteWithFile(f, CGRectMake(278,1,14,14));
		var uR = CCSprite.spriteWithFile(f, CGRectMake(278,1,14,14));
		var lL = CCSprite.spriteWithFile(f, CGRectMake(278,1,14,14));
		var lR = CCSprite.spriteWithFile(f, CGRectMake(278,1,14,14));
		uL.setAnchorPoint(ccp(0,1));
		uR.setAnchorPoint(ccp(1,1));
		lL.setAnchorPoint(ccp(0,0));
		lR.setAnchorPoint(ccp(1,0));
		uL.setPosition(ccp(5, this._selector.getContentSize()._height + this._heightOffset));
		uR.setPosition(ccp(this._selector.getContentSize()._width - 18, this._selector.getContentSize()._height+this._heightOffset));
		lL.setPosition(ccp(5, 0+this._heightOffset + 18));
		lR.setPosition(ccp(this._selector.getContentSize()._width - 18, 18+this._heightOffset));
		
		this._selector.addChild(uL);
		this._selector.addChild(uR);
		this._selector.addChild(lL);
		this._selector.addChild(lR);
		uR.setFlipX(true);
		lL.setFlipY(true);
		lR.setFlipY(true);
		lR.setFlipX(true);
		
		var actionTo = CCSequence.actions(
				CCMoveBy.actionWithDuration(0.2, ccp(-3,3)),
				CCMoveBy.actionWithDuration(0.2, ccp(3,-3)),
				CCDelayTime.actionWithDuration(0.4));
		var repeatAction = CCRepeatForever.actionWithAction(actionTo);
		uL.runAction(repeatAction);
		
		actionTo = CCSequence.actions(
				CCMoveBy.actionWithDuration(0.2, ccp(3,3)),
				CCMoveBy.actionWithDuration(0.2, ccp(-3,-3)),
				CCDelayTime.actionWithDuration(0.4));
		repeatAction = CCRepeatForever.actionWithAction(actionTo);
		uR.runAction(repeatAction);
		
		actionTo = CCSequence.actions(
				CCMoveBy.actionWithDuration(0.2, ccp(-3,-3)),
				CCMoveBy.actionWithDuration(0.2, ccp(3,3)),
				CCDelayTime.actionWithDuration(0.4));
		repeatAction = CCRepeatForever.actionWithAction(actionTo);
		lL.runAction(repeatAction);
		
		actionTo = CCSequence.actions(
				CCMoveBy.actionWithDuration(0.2, ccp(3,-3)),
				CCMoveBy.actionWithDuration(0.2, ccp(-3,3)),
				CCDelayTime.actionWithDuration(0.4));
		repeatAction = CCRepeatForever.actionWithAction(actionTo);
		lR.runAction(repeatAction);
		
		this._windowNode.addChild(this._selector, 5, this.mausoleumMenuTags.kMausoleumMenuTagSelector);
		
		//mini lupa
		this._icon = CCSprite.spriteWithFile(f, CGRectMake(256,59,32,32));
		this._icon.setScale(0.75);
		this._icon.setColor(ZFColorDefines.colorTextHighlight);
		this._icon.setAnchorPoint(ccp(1,1));
		this._icon.setPosition(ccpAdd(ccp(this._selector.getContentSize()._width, this._selector.getContentSize()._height), ccp(-7,-7+this._heightOffset)));
		this._selector.addChild(this._icon, 2);
		
		this.createContextPanel();
		
		this._currentCellIndex = acm._zombieStorage.length + this._fakeCells;
		var zm = ZFZombieMenu;
		for (var zKey in acm._zombieStorage)
		{
			var z = acm._zombieStorage[zKey];
			if (z && zm._currentZombie == z)
			{
				this._currentCellIndex = acm._zombieStorage.indexOf(z);
				this._contextPanelViewButton.setSelectedIndex(this.viewStates.viewsStateOn);
				break;
			}
		}
		
		this.schedule(this.initTableOffset);
	},
	
	createContextPanel : function()
	{
		var w = CGSizeMake(480, 320);
		var f = ZFGameDefines.HUDELEMENTS1_FILE;
		var contextHeightOffset = 0;
		var contextX = Math.min(0.29 * this._resolutionHeight - 90, 200);
		
		if (this._widthOffset>0)
		{
			contextHeightOffset = 31;
		}
		//todo el panel del medio
//		{
//			this._contextPanel = CCColorLayer.layerWithColor(ccc4(255, 255, 255, 0x40), 239, 60);
//			this._windowNode.addChild(this._contextPanel, 6);
//		}
		//banner de ABAJO
		if (!this._contextPanelBG)
		{
			var windowSize = CGRectMake(w._width - 239 - 41+(5.5/10)*this._widthOffset, 50+this._heightOffset-contextHeightOffset,
					239, 60);
			var c  = CGRectMake(256, 24, 8, 8);
			var s  = CGRectMake(256, 33, 8, 8);
			var bc = CGRectMake(256, 42, 8, 8);
			var b  = CGRectMake(265, 24, 24, 8);
			var bb = CGRectMake(265, 33, 24, 8);
			var color = ccc4(0x49, 0x58, 0x61, 0xff);
//			color = ccc4(0x00, 0xff, 0x00, 0xff);
			this._contextPanelBG = ZFMenu.makeWindow(windowSize, c, b, f, color, bc, bb, s, true);
			this._contextPanelBG.setPosition(ccp(contextX, this._heightOffset - 310));
			if(this._winSize._width <= 480){
				this._contextPanelBG.setPosition(this._contextPanelBG.getPosition()._x, this._contextPanelBG.getPosition()._y + 50);
			}
			this._windowNode.addChild(this._contextPanelBG, 6);
		}
		if (!this._contextPanelMenu)
		{
			//s1 y s2 es el fondo de de la lupa
			var s1 = CCSprite.spriteWithFile(f, CGRectMake(427,0,50,55));
			var s2 = CCSprite.spriteWithFile(f, CGRectMake(427,0,50,55));
			
			//sA y sB lupa
			var sA = CCSprite.spriteWithFile(f, CGRectMake(256,59,32,32));
			var sB = CCSprite.spriteWithFile(f, CGRectMake(256,59,32,32));
			
			s1.setColor(ZFColorDefines.colorTextMausoleumBlue);
			s2.setColor(ZFColorDefines.colorTextMausoleumBlueShadow);
			
			var viewItem = CCMenuItemSprite.itemFromNormalSprite(s1, null);
			var unviewItem = CCMenuItemSprite.itemFromNormalSprite(s2, null);
			
			this._contextPanelViewButton = CCMenuItemToggle.itemWithTarget(this, this.contextPanelViewButtonTapped.bind(this), [viewItem, unviewItem] )
			this._contextPanelViewButton._mausTag = true;

//			sA.setPosition(s1.getSize()._width/2, s1.getSize()._height/2);
//			sB.setPosition(s1.getSize()._width/2, s1.getSize()._height/2);
			sA.setPosition(viewItem.getContentSize()._width/2, viewItem.getContentSize()._height/2 +2);
			sB.setPosition(unviewItem.getContentSize()._width/2, unviewItem.getContentSize()._height/2 +2);
			
			viewItem.addChild(sA);
			unviewItem.addChild(sB);
			
			//s3...s8 boton de fondo de la flecha
			var s3 = CCSprite.spriteWithFile(f, CGRectMake(1,252,180,55));
			var s4 = CCSprite.spriteWithFile(f, CGRectMake(1,252,180,55));
			var s5 = CCSprite.spriteWithFile(f, CGRectMake(1,252,180,55));
			var s6 = CCSprite.spriteWithFile(f, CGRectMake(1,252,180,55));
			var s7 = CCSprite.spriteWithFile(f, CGRectMake(1,252,180,55));
			var s8 = CCSprite.spriteWithFile(f, CGRectMake(1,252,180,55));
			//sC...sF flecha
			var sC = CCSprite.spriteWithFile(f, CGRectMake(289,45,126,36));
			var sD = CCSprite.spriteWithFile(f, CGRectMake(289,45,126,36));
			var sE = CCSprite.spriteWithFile(f, CGRectMake(289,45,63,36));
			var sF = CCSprite.spriteWithFile(f, CGRectMake(289,45,63,36));
			
			s3.setColor(ZFColorDefines.colorTextMausoleumBlue);
			s5.setColor(ZFColorDefines.colorTextMausoleumBlue);
			s7.setColor(ZFColorDefines.colorTextMausoleumBlue);
			s4.setColor(ZFColorDefines.colorTextMausoleumBlueShadow);
			s6.setColor(ZFColorDefines.colorTextMausoleumBlueShadow);
			s8.setColor(ZFColorDefines.colorTextMausoleumBlueShadow);
			var storeItem = CCMenuItemSprite.itemFromNormalSprite(s3, s4);
			var getItem = CCMenuItemSprite.itemFromNormalSprite(s5, s6);
			var swapItem = CCMenuItemSprite.itemFromNormalSprite(s7, s8);
			
			sE.setPosition(ccp(storeItem.getContentSize()._width/2 + 5, storeItem.getContentSize()._height/2 + 2));  
			sF.setPosition(ccp(storeItem.getContentSize()._width/2 + 65, storeItem.getContentSize()._height/2 + 2));
			sD.setPosition(ccp(storeItem.getContentSize()._width/2, storeItem.getContentSize()._height/2 + 2));
			sC.setPosition(ccp(storeItem.getContentSize()._width/2, storeItem.getContentSize()._height/2 + 2));
			
			sE.setAnchorPoint(ccp(1,0.5));
			sF.setAnchorPoint(ccp(0,0.5));
			sF.setFlipX(true);
			sD.setFlipX(true);
			
			storeItem.addChild(sC);
			getItem.addChild(sD);
			swapItem.addChild(sE);
			swapItem.addChild(sF);
			
			this._contextPanelActionButton = CCMenuItemToggle.itemWithTarget(this, this.contextPanelActionButtonTapped.bind(this), [storeItem, getItem, swapItem]);
			
			this._contextPanelMenu = CCMenu.menuWithItems([this._contextPanelViewButton, this._contextPanelActionButton]);
			var xPosition = (this._widthScale > 1) ? 0 : -25; 
			this._contextPanelMenu.setPosition(contextX + 20, this._dismissMenu.getPosition()._y - 70 - 310);
			if(this._winSize._width <= 480){
				this._contextPanelMenu.setPosition(this._contextPanelMenu.getPosition()._x, this._contextPanelMenu.getPosition()._y + 50);
			}
			this._contextPanelMenu.setScale(0.8);
			this._contextPanelViewButton.setPosition(ccp(0, 70));
			this._contextPanelActionButton.setPosition(ccp(70, 70));
			
			this._windowNode.addChild(this._contextPanelMenu, 20);
			
		}
	},
	
	contextPanelActionButtonTapped : function()
	{	
		var zm = ZFZombieMenu;
		var acm = ZFActorManager;
		var gui = ZFGuiLayer.gui();
		var sm = ZFStorageMenu;
		var c = this._mvTable.cellWithIndex(this._currentCellIndex);
		var index = this._contextPanelActionButton._selectedIndex; /* -1 !!!!! */
		index = (index <= -1) ? this.actionStates.actionStateMAX - 1 : index;
		if (!c || c._isFake)
		{
			return;
		}
		
		if ( this._blockingForSwap || this._blockingForView )
		{
			var zCount = zm._zombieList.length;
			if ( zCount == GameState.maxArmySize() )
			{
				if ( this._swapCellIndex == this._currentCellIndex )
				{
					if ( index == this.actionStates.actionStateSwap ){
						this._blockingForSwap = false;
					}
					else{
						return;
					}
				}
				else{
					this._blockingForSwap = false;
				}
			}
			else{
				return;
			}
		}
		
		zm._openingMenuThroughMausoleum = true;
		
		switch (index)
		{
			case this.actionStates.actionStateEnter:
			{
				var priorZombie = null;
				var followingZombie = null;
				for (var zKey in zm._zombieList)
				{
					var z = zm._zombieList[zKey];
					if (zm._currentZombie == z)
					{
						followingZombie = null;
						
						var ind = zm._zombieList.indexOf(z);
						if (ind+1 < zm._zombieList.length)
						{
							followingZombie = zm._zombieList[ind+1];
						}
						break;
					}
					priorZombie = z;
				}
				
				gui.displayToolTip(NSLocalizedString("Zombie placed in Mausoleum", "Zombie placed Message"), 1);

				
				if ( !zm._currentZombie ) break;
				acm.addZombieToStorage_atSlot(zm._currentZombie, c._place - c._placeOffset);
				var storedZombie = acm.getZombieFromStorageSlot(c._place - c._placeOffset);
				
				c._zombie = storedZombie;
				c._name.setString(storedZombie._name);			
				c.showClosedHole();
				
				//TODO: Log
//	            [[PlayerProfileManager playerProfileManager] log:@"Putting a zombie into the mausoleum"];
				
				zm._zombieList.splice(zm._zombieList.indexOf(zm._currentZombie), 1);
				zm._currentZombie = (priorZombie) ? priorZombie : ((followingZombie) ? followingZombie : null);
				zm._currentPage = (zm._zombieList.length > 0) ? zm._zombieList.indexOf(zm._currentZombie) : -1;
				zm.displayPage();
				this.showCellContents();
			}
				break;
				
			case this.actionStates.actionStateExit:
			{
				ZFGuiLayer.gui().displayToolTip(NSLocalizedString("Zombie is back on the farm", "Zombie back on farm Message"), 1);
				var zombieToSpawn = c._zombie;

				c.showOpenHole();
				c._name.setString(NSLocalizedString("Empty", "Nothing there"));
				
				var indexInZombieList = zm._zombieList.indexOf(zm._currentZombie);
				var indexInZombieStorage = acm._zombieStorage.indexOf(c._zombie);
				
				var mKey = ZFGameDefines.kMausoleumKey;
				
				if (sm.doesOwnItem("mausoleum2"))
				{
					mKey = 	"mausoleum2";
				}
				else if (sm.doesOwnItem("mausoleum3"))
				{
					mKey = 	"mausoleum3";
				}
					
				var newZombie = acm.getZombieFromStorage_toTile(indexInZombieStorage, sm.coordinatesOfItemOnFarmWithKey(mKey));
				if ( !newZombie )
				{
					zombieToSpawn = null;
					break;
				}
				zm._currentZombie = newZombie;
				
				if (zm._zombieList.length <= 0)
				{
					indexInZombieList = 0;
				}
				
				if (indexInZombieList < zm._zombieList.length)
				{
//					zm._zombieList.insertObject(newZombie atIndex:indexInZombieList];
					zm._zombieList.splice(indexInZombieList, 0, newZombie);
				}
				
				c._zombie = null;
				
				if (!zm._visible)
				{
					zm.openMenuThroughMausoleum();
				}
				zm._currentPage = (zm._zombieList.length> 0) ? zm._zombieList.indexOf(zm._currentZombie) : -1; 
				zm.displayPage();
				this.dontShowCellContents();
				
			}
				break;
				
			case this.actionStates.actionStateSwap:
			{
				var zombieToSpawn = c._zombie;
				var zombieToStore = zm._currentZombie;
				if(zombieToSpawn && zombieToStore)
				{
					var zombieStorageIndex = acm._zombieStorage.indexOf(zombieToSpawn);
					var zombieListIndex = zm._zombieList.indexOf(zombieToStore);
					gui.displayToolTip(NSLocalizedString("Zombies have been swapped", "Zombie Swapped Message"), 1);
					
					var mKey = ZFGameDefines.kMausoleumKey;
					
					if (sm.doesOwnItem("mausoleum2"))
					{
						mKey = 	"mausoleum2";
					}
					else if (sm.doesOwnItem("mausoleum3"))
					{
						mKey = 	"mausoleum3";
					}
					zm._currentZombie = acm.getZombieFromStorage_toTile(zombieStorageIndex, sm.coordinatesOfItemOnFarmWithKey(mKey));
					
					/////////////
					acm.addZombieToStorage_atSlot(zombieToStore, c._place - c._placeOffset);
					var storedZombie = acm.getZombieFromStorageSlot(c._place - c._placeOffset);
					
					c._zombie = storedZombie;
					c._name.setString(storedZombie._name);		
					c.showClosedHole();
					
					/////////////
					if (zombieListIndex < zm._zombieList.length)
					{
//						[zm.zombieList replaceObjectAtIndex:zombieListIndex withObject:zm.currentZombie];
						zm._zombieList.splice(zombieListIndex, 1, zm._currentZombie);
					}
					zm._currentPage = (zm._zombieList.length > 0) ? zm._zombieList.indexOf(zm._currentZombie) : -1; 
					zm.displayPage();
					this.showCellContents();			

					this._blockingForSwap = true;
				} 
			}
				break;
		}
		
		zm._openingMenuThroughMausoleum = false;
	},
	
	contextPanelViewButtonTapped : function()
	{	
		var zm = ZFZombieMenu;
//		var newIndex = (this._contextPanelViewButton._selectedIndex + 1) % 2;
		switch (this._contextPanelViewButton._selectedIndex)
		{
			case this.viewStates.viewsStateOn:
			{
				//view the active zombie
				this._blockingForView = false;
				
				if (zm._zombieList.length > 0)
				{
					zm._currentPage = 0;
					zm.displayPage();
				}
				else 
				{
					zm._currentZombie = null;
					zm._currentPage = -1;
					zm.displayPage();
				}
				this._contextPanelViewButton.setSelectedIndex(this.viewStates.viewsStateOn);
			}
				break;
				
			case this.viewStates.viewsStateOff:
			{
				//view the mausoleum zombie
				this._blockingForView = true;
				
				var cell = this._mvTable.cellWithIndex(this._currentCellIndex)
				if (cell && cell._zombie)
				{
					zm._currentZombie = cell._zombie;
					
					cell._zombie.setHunger();
					
					zm._currentPage = -1;
					zm.displayPage();
				}
				else 
				{
					this._blockingForView = false;
				}
				this._contextPanelViewButton.setSelectedIndex(this.viewStates.viewsStateOff);
			}
				break;
		}
	},
	
	openMenu : function()
	{
		var acm = ZFActorManager;
		var gui = ZFGuiLayer.gui();
		var zm = ZFZombieMenu;
		zm.initZombieList();
		
		if ((!zm._zombieList || zm._zombieList.length <= 0) && (acm._zombieStorage <= 0))
		{
			zm.noZombieMessage();
			this.cleanup();
			return;
		}
		
		this.initElements();

		gui.removeToolTip();
		this.setVisible(true);
		var actionTo = CCSequence.actions(
				CCMoveTo.actionWithDuration(0.25, this.openPos()),
				CCMoveTo.actionWithDuration(0.10, ccpAdd(this.openPos(), ccp(-50,0))),
				CCMoveTo.actionWithDuration(0.10, this.openPos()));
		this.runAction(actionTo);
		
		this.schedule(this.openTimerCallback, 0.25);
		this._menuState = this.menuStates.menuStateOpening;
		this.displayPage(this._currentPage);
		SimpleAudioEngine.playEffect(kMenuOpenSFX);
		
		zm.openMenuThroughMausoleum();
	},
	
	openPos : function()
	{
		var mainFrame = CCDirector.winSize();
	    var w = CGSizeMake(mainFrame._height, mainFrame._width);
		var scale = (this._widthScale > 1) ? 1.6 : this._widthScale;
	    return ccp(320 + this._widthOffset - ((295 * scale + 26)) - 20, 0);
//	    if(this._widthScale > 1)
//	    {
//	        return ccp(865 - w._width, 0);
//	    }
//		return ccp((295 * this._widthScale) - w._width, 0);
	},
	
	closePos : function()
	{ 
		var mainFrame = CCDirector.winSize();
	    var w = CGSizeMake(mainFrame._height, mainFrame._width);
	    
	    return ccp(-w._width, 0);
	},
	
	dismissMenu : function(sender)
	{		
		var zm = ZFZombieMenu;
		
		if (zm._zombieList.length > 0)
		{
			if (!zm.isCurrentZombieActive()) //aka a mauzoleum zombie
			{
				zm._currentPage = 0;
				zm.displayPage();
			}
			zm.disableMenus();
			//TODO: CCTouchDispatcher
//			[[CCTouchDispatcher sharedDispatcher] removeDelegate:dimLayer];
			ZFGuiLayer.gui().enableMenus();
			zm.schedule(zm.openTimerCallback, zm.showEntireMenu(this));
		}
		else 
		{
			zm.dismissMenu(this);
		}

		
		var actionTo = CCSequence.actions(
				CCMoveTo.actionWithDuration(0.10, ccpAdd(this.openPos(), ccp(25,0))),
				CCMoveTo.actionWithDuration(0.25, ccpAdd(this.closePos(), ccp(-50,0))));
		
		
		this.runAction(actionTo);
		this.schedule(this.dismissTimerCallback, 0.5);
		this._menuState = this.menuStates.menuStateClosing;
		SimpleAudioEngine.playEffect(kMenuCloseSFX);
		
		//TODO: Event Tracker
//		[[EventTracker eventTracker] sendEvent:@"zf_mausoleum_dismiss" withParameters:nil andDelegate:nil];
	},
	
	dismissTimerCallback : function($super)
	{	
		this.cleanup();
		$super();
	},
	
	cleanup : function()
	{
		this.unschedule(this.tick);
		
		this._blockingForView = false;		//not going to be blocking anymore
		this._blockingForSwap = false;		
		
		if (this._cellActor)
		{
			this._cellActor.despawn();
			this._cellActor = null;
		}
		
		
		
		if(this._contextPanelMenu)
		{
			if(this._contextPanelViewButton)
			{
				this._contextPanelMenu.removeChild(this._contextPanelViewButton);
				destroyWithChildren(this._contextPanelViewButton);
				this._contextPanelViewButton = null;
			}
			
			if(this._contextPanelActionButton)
			{
				this._contextPanelMenu.removeChild(this._contextPanelActionButton);
				destroyWithChildren(this._contextPanelActionButton);
				this._contextPanelActionButton = null;
			}
			this.removeChild(this._contextPanelMenu);
			destroy(this._contextPanelMenu);
			this._contextPanelMenu = null;
		}
		
		if(this._contextPanelBG)
		{
			this._windowNode.removeChild(this._contextPanelBG);
			destroy(this._contextPanelBG);
			this._contextPanelBG = null;
		}
		
		if(this._selectorMenuItemLabel)
		{
			destroy(this._selectorMenuItemLabel);
			this._selectorMenuItemLabel = null;
		}
		
		if(this._selector)
		{
			if(this._icon)
			{
				this._selector.removeChild(this._icon);
				destroy(this._icon);
				this._icon = null;
			}
			
			if(this._selectorDimLayer)
			{
				this._selector.removeChild(this._selectorDimLayer);
				destroy(this._selectorDimLayer);
				this._selectorDimLayer = null;
			}
			this.removeChild(this._selector);
			destroy(this._selector);
			this._selector = null;
		}
		this.disableMenus();
		
		ZFGuiLayer.gui().enableMenus();
		//TODO: CCTouchDispatcher
//		[[CCTouchDispatcher sharedDispatcher] removeDelegate:dimLayer];
		
		//TODO: CCTouchDispatcher
//		[[CCTouchDispatcher sharedDispatcher] removeDelegate:mvTable];
		
		this._windowNode.removeChild(this._mvTable);
		destroy(this._mvTable);
		this._mvTable = null;
	},
	
	initTableOffset : function()
	{
		this.unschedule(this.initTableOffset);
		var minsize = this._mvTable.minContainerOffset();
		this._mvTable.setContentOffset(ccp(0,minsize._y));
		this.schedule(this.tick, 0, "ZFMauseoleumMenu.tick");
		
		var cell = this._mvTable.cellWithIndex(this._currentCellIndex);
		if (cell && cell._zombie)
		{
			this.showCellContents();
		}
	},

	tick : function(dt)
	{
		var cell = this._mvTable.cellWithIndex(this._currentCellIndex);
		
		if (this._selector)
		{
			if (cell)
			{
				this._selector.setPosition(ccpAdd(this._mvTable.getPosition(), ccpAdd(ccpAdd(cell._cellLayer._parent.getPosition(), cell._cellLayer.getPosition()), ccp(-4,-6-this._heightOffset))));
				this._selector.setVisible(true);
				
				if(cell._zombie)
				{
					if (this.shouldSwapZombies())
					{
						this._swapCellIndex = this._currentCellIndex;
						this._contextPanelActionButton.setSelectedIndex(this.actionStates.actionStateSwap);
					}
					else 
					{
						this._contextPanelActionButton.setSelectedIndex(this.actionStates.actionStateExit);
					}
				}
				else 
				{
					this._contextPanelActionButton.setSelectedIndex(this.actionStates.actionStateEnter);
				}
			}
			else 
			{
				this._selector.setVisible(false);
			}
		}
		
		var zm = ZFZombieMenu;
		if (this.isViewing() || (!zm.isCurrentZombieActive() && (!cell || !cell._zombie)))
		{
			this._contextPanelActionButton.isEnabled = false;
			this._contextPanelActionButton.setOpacity(0x40);
			
			for (var misKey in this._contextPanelActionButton._subItems)
			{
				var mis = this._contextPanelActionButton._subItems[misKey];
				for (var sKey in mis._children)
				{
					var s = mis._children[sKey]
//					s.setOpacity(0x40);
				}
			}
		}
		else
		{
			this._contextPanelActionButton.isEnabled = true;
			this._contextPanelActionButton.setOpacity(0xFF);
			for (var misKey in this._contextPanelActionButton._subItems)
			{
				var mis = this._contextPanelActionButton._subItems[misKey];
				for (var sKey in mis._children)
				{
					var s = mis._children[sKey];
//					s.setOpacity(0xFF);
				}
			}
		}
		if (!this.isViewing() && (!cell || !cell._zombie))
		{
			this._contextPanelViewButton.isEnabled = false;
			this._contextPanelViewButton.setOpacity(0x40);
			
			for (var misKey in this._contextPanelViewButton._subItems)
			{
				var mis = this._contextPanelViewButton._subItems[misKey];
				for (var sKey in mis._children)
				{
					var s = mis._children[sKey];
//					s.setOpacity(0x40);
				}
			}
		}
		else 
		{
			this._contextPanelViewButton.isEnabled = true;
			this._contextPanelViewButton.setOpacity(0xff);
			
			for (var misKey in this._contextPanelViewButton._subItems)
			{
				var mis = this._contextPanelViewButton._subItems[misKey];
				for (var sKey in mis._children)
				{
					var s = mis._children[sKey];
//					s.setOpacity(0xff);
				}
			}
		}
		
		if (this.isViewing() && cell && cell._zombie)
		{
			this._icon.setVisible(true);
		}
		else 
		{
			this._icon.setVisible(false);
		}
	},
	
	setCurrentCellIndex : function(index)
	{
		this._currentCellIndex = index;
		this.updateStoreButton();
	},
	
	updateStoreButton : function()
	{
		var c = this._mvTable.cellWithIndex(this._currentCellIndex);
		this._swap = false;
		if (c._zombie)
		{
			if (this.shouldSwapZombies())
			{
				this._swap = true;
				this._selectorMenuItemLabel.setString(NSLocalizedString("Tap to swap zombies", "Tap to Swap Message"));
			}
			else
			{
				this._selectorMenuItemLabel.setString(NSLocalizedString("Tap to remove zombie", "Tap to Remove Message"));
			}
		}
		else 
		{
			this._selectorMenuItemLabel.setString(NSLocalizedString("Tap to place zombie", "Tap to Place Zombie"));
		}
	},
	
	shouldSwapZombies : function()
	{	
		var zm = ZFZombieMenu;
		if (zm._zombieList.length < GameState.maxArmySize())
		{
			return false;
		}
		
		var c = this._mvTable.cellWithIndex(this._currentCellIndex);
		if (!c._zombie)
		{
			return false;
		}
		
		return true;
	},
	
	reloadTableData : function()
	{
		this._mvTable.reloadData();
	},
	
	containsZombie : function()
	{
		var answer = false;
		var acm = ZFActorManager;
		for(var zKey in acm._zombieStorage)
		{
			var z = acm._zombieStorage[zKey];
			if(z instanceof ZombieActor)
				answer = true;
		}
		return answer;
	},
	
	cellFromZombie : function(zombie)
	{
		var acm = ZFActorManager;
		var index = -1;
		
		for (var zKey in acm._zombieStorage)
		{
			var z = acm._zombieStorage[zKey];
			if (z instanceof ZombieActor)
			{
				if (z == zombie)
				{
					index = acm._zombieStorage.indexOf(z);
					break;
				}
			}
		}
			
		if (index >= 0)
		{
			return this._mvTable.cellWithIndex(index);
		}
		
		return null;
	},
	
	showCellContents : function()
	{
		var cell = this._mvTable.cellWithIndex(this._currentCellIndex);
		var zombie = cell._zombie;
		
		if (!zombie)
		{
			return;
		}
		
		this.dontShowCellContents();
		
		var actionTo = CCSequence.actions(
				CCFadeIn.actionWithDuration(0.25),
				CCDelayTime.actionWithDuration(1),
				CCFadeOut.actionWithDuration(0.25),
				CCDelayTime.actionWithDuration(1));
		var repeatForever = CCRepeatForever.actionWithAction(actionTo);
		this._selectorDimLayer.runAction(repeatForever);
		
		var acm = ZFActorManager;
		this._cellActor = acm.spawnGUIActor_withClass_atPoint_withTarget("ZombieActor", ccp(45, -30), this._selectorDimLayer);
		this._cellActor.addMutation(zombie._flags);
		this._cellActor._savedColor = ccc3(zombie._savedColor._red*255, zombie._savedColor._green*255, zombie._savedColor._blue*255);	
		this._cellActor._spriteMan.setScale(0.75, 0.75);
		this._cellActor.resetColor();
		this._cellActor._tag = ZFZombieMenu.kZombieMenuTags.kZombieMenuTagSelectedZombie;
		
		for (var atKey in this._cellActor._attachments)
		{
			var at = this._cellActor._attachments[atKey];
			if (at == null)
			{
				continue;
			}
			
			actionTo = CCSequence.actions(
					CCFadeIn.actionWithDuration(0.25),
					CCDelayTime.actionWithDuration(1),
					CCFadeOut.actionWithDuration(0.25),
					CCDelayTime.actionWithDuration(1));
			repeatForever = CCRepeatForever.actionWithAction(actionTo);
			at._sprite.runAction(repeatForever);
		}
	},
	
	dontShowCellContents : function()
	{
		this._selectorDimLayer.setOpacity(0x0);
		this._selectorDimLayer.stopAllActions();
		
		if (this._cellActor)
		{
			this._cellActor.despawn();
			this._cellActor = null;
		}
	},
	
	isViewing : function()
	{
		return this._contextPanelViewButton._selectedIndex == this.viewStates.viewsStateOn;
	},
	
	cellClassForTable : function(table) 
	{
	    return MausoleumCell;
	},
	
	table : function(table, value)
	{
		if(value instanceof CCTableViewCell)
		{
			this.table_cellTouched(table, value);
		}else{
			this.table_cellAtIndex(table, value);
		}
	},
	
	table_cellTouched : function(table, cell) 
	{
//		this._contextPanelMenu.setPosition(contextX/*this._skullSpriteLPos*/, this._dismissMenu.getPosition()._y - 70 - 260);
//		this._contextPanelMenu.setPosition(this._title.getPosition()._x+1,this._title.getPosition()._y);
//		console.log("POSssssssssssssssssssssssssssssssssss: ("+this._title.getPosition()._x+")");
		var m = cell;
		if (m._isFake == true)
			return;
		m.pressed(this);
	},
	
	table_cellAtIndex : function(table, idx)
	{	
		var acm = ZFActorManager;
		var cell = table.dequeueCell()
		var zombieStorageOffset = 0;
		if (this._widthOffset>0 && this._fakeCells>0)		//modifying how the table is built for the ipad version
		{
			if (idx >= this._fakeCells && idx < 6)	//if not a multiple of 6, put empty cells between fakecells and 6
			{
				if (!cell) 
				{	
					cell = new MausoleumCell();
					cell.initWithZombie(null);
				}
				var m = cell;
				cell._node = m._cellLayer;
				m.showClosedHole();
				m._place = idx;
				m._isFake = true;
				return cell;
			}
			else if (idx >= 6)
			{
				idx = idx - this._fakeCells;
				zombieStorageOffset = this._fakeCells;
			}

		}
		var storageObject = acm._zombieStorage[idx];
	    if (!cell) 
		{
	        cell = new MausoleumCell();
	        cell.initWithZombie(null);
	    }
		
		var m = cell;
		cell._node = m._cellLayer;
		
		if (storageObject instanceof ZombieActor)
		{
			var z = storageObject;
			m._name.setString(z._name);
			m._zombie = z;
			m.showClosedHole();
		}
		else
		{
			m._name.setString(NSLocalizedString("Empty","Nothing is there"));
			m._zombie = null;
			m.showOpenHole();
		}
		
		m._place = idx + zombieStorageOffset;
		m._placeOffset = zombieStorageOffset;
		m._isFake = false;
		
	    return cell;
	},
	
	numberOfCellsInTableView : function(table) 
	{
		var acm = ZFActorManager;
		return acm._zombieStorage.length + this._fakeCells;
	},
	
	getMenuOffset : function()
	{
		return ccp(0,0);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/ZFMenus/Mausoleum/MausoleumCell'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Mausoleum/MausoleumCell'] || {}; $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Mausoleum/MausoleumCell'] = exports; exports.MausoleumCell = CCTableViewCell.subclass
({
	classname : 'MausoleumCell',
	
	initialize : function()
	{
		this._menu = null; //CCMenu
		this._button = null; //CCMenuItemSprite *
		this._name = null; //CCLabel *
		this._cellLayer = null; //CCColorLayer *
		this._cellLayer2 = null; //CCColorLayer *
		this._selector = null;//CCColorLayer *
		this._zombie = 0; //id
		this._place = 0; //int
		this._s1 = null; //CCSprite *
		this._s2 = null; //CCSprite *
		this._isFake = false; //BOOL
		this._placeOffset = 0; //int
	},
	
	$cellSize : function() 
	{
	    return CGSizeMake(88, 95);
	},
	
	initWithZombie : function(aZombie)
	{
		var f = ZFGameDefines.HUDELEMENTS1_FILE;
		this._cellLayer = CCColorLayer.layerWithColor(ccc4(0x29, 0x3d, 0x3d, 0x0), 64+20, 64);
//		if([[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hant"] || [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hans"]||
//		   [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"ja"])
//		{
			this._name = CCLabel.labelWithString("", CGSizeMake(200, 50), GL2.Text.VerticalAlign.Middle, "Arial", 26);
//		}
//		else 
//		{
//			//name = [CCBitmapFontAtlas bitmapFontAtlasWithString:@"" fntFile:@"ABD26.fnt"];
//			name = [CCLabel labelWithString:@"" fontName:@"AmericanTypewriter-Bold" fontSize:26];
//		}

		this._name.setScale(0.57);
		
		this._cellLayer.addChild(this._name, 4);
		this._s1 = CCSprite.spriteWithFile(f,CGRectMake(0, 68, 86, 68));
		this._s2 = CCSprite.spriteWithFile(f, CGRectMake(1, 135, 86, 66));
		this._s1.setPosition(ccp(this._cellLayer.getContentSize()._width/2, this._cellLayer.getContentSize()._height/2));
		this._s2.setPosition(ccp(this._cellLayer.getContentSize()._width/2, this._cellLayer.getContentSize()._height/2));
		this._cellLayer.addChild(this._s1, 1);
		this._cellLayer.addChild(this._s2, 1);

		this._zombie = aZombie;
		
		return this;
	},
	
//	-(void)dealloc
//	{
//		[cellLayer removeAllChildrenWithCleanup:YES];
//		[cellLayer release]; cellLayer = nil;
//		[super dealloc];
//	},
	
	pressed : function(sender)
	{
		var zmm = ZFMausoleumMenu;
		var zm = ZFZombieMenu;
		zmm._currentCellIndex = this._place;
		
		if (this._zombie)
		{
			zmm.showCellContents();
			
			if (zmm.isViewing())
			{
				zm._currentZombie = this._zombie;
				this._zombie.setHunger();
				zm._currentPage = -1;
				zm.displayPage();
			}
		}
		else 
		{
			zmm.dontShowCellContents();
			
			if (zmm.isViewing())
			{
				zm.hidePanel();
			}
		}
	},
	
	showClosedHole : function()
	{	
		this._name.setPosition(ccp(this._cellLayer.getContentSize()._width/2, this._cellLayer.getContentSize()._height/2));
		this._name.setColor(ZFColorDefines.colorTextMausoleumBlue);
		this._name.setOpacity(0xFF);
		this._s1.setVisible(true);
		this._s2.setVisible(false); 
	},
	
	showOpenHole : function()
	{
		this._name.setPosition(ccp(this._cellLayer.getContentSize()._width/2, this._cellLayer.getContentSize()._height/2 - 12));
		this._name.setColor(ZFColorDefines.colorGrayButton);
		this._name.setOpacity(0xC0);
		this._s1.setVisible(false);
		this._s2.setVisible(true); 
	},

	showNothing : function()
	{
		this._name.setOpacity(0xFF);
		this._s1.setVisible(false);
		this._s2.setVisible(false); 
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/ZFMenus/Mausoleum/ZFMenuWithHigherPriority'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Mausoleum/ZFMenuWithHigherPriority'] || {}; $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Mausoleum/ZFMenuWithHigherPriority'] = exports; exports.ZFMenuWithHigherPriority = CCMenu.subclass
({
	classname : 'ZFMenuWithHigherPriority',
	
	initialize : function()
	{
		
	},
	
	registerWithTouchDispatcher : function()
	{
		//TODO: CCTouchDispatcher
		//[[CCTouchDispatcher sharedDispatcher] addTargetedDelegate:self priority:INT_MIN swallowsTouches:YES];
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/GuiLayer/Quests/ZFQuestRequirement'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/GuiLayer/Quests/ZFQuestRequirement'] || {}; $MODULE_REGISTRY['Code/Game/GUI/GuiLayer/Quests/ZFQuestRequirement'] = exports; exports.ZFQuestRequirement = Core.Class.subclass({
	
	classname: "ZFQuestRequirement",
	
	$questType:	{
		kQuestTypeNotification: -1
	},

	$questRewardTypes: 
	{
		questRewardTypeResourceXP :  0,
		questRewardTypeResourceGold: 1,
		questRewardTypeResourceBrains: 2,
		questRewardTypeItem :3
	},

	$questRequirementTypes:
	{
		questRequirementTypeResource: 0,
		questRequirementTypeItem: 1,
		questRequirementTypeEvent: 2
	},
	
	initialize: function () {
		this._type = 0;/*int */
		this._notificationID = null;/*String */
		this._notificationObject = null;/*Object */
		this._countCurrent = 0;/*int */
		this._countTotal = 0;/*int */
		this._text = null;/*String */
		this._spriteFilename = null;/*String */
	},
	
	incrementCount: function(/*NSNotification* */ notification) {
		switch (this._type) {
			case this.questRequirementTypes.questRequirementTypeResource:
				if (typeof notification == "number") {
					this._countCurrent += notification;
				}
				break;
			case this.questRequirementTypes.questRequirementTypeItem:
				if (typeof this._notificationObject == "string" && typeof notification == "string") {
					if (this._notificationObject == notification) {
						this._countCurrent++;
					}
				}
				break;
			case this.questRequirementTypes.questRequirementTypeEvent: {
				var str1 = this._notificationObject;
				if (!str1 || str1 == "") {
					this._countCurrent++;
				} else if (typeof this._notificationObject == "string" && typeof notification == "string") {
					if (str1 == notification) {
						this._countCurrent++;
					}
				}
			}
				break;
		}
		
		if (this._countCurrent >= this._countTotal) {
			this._countCurrent = this._countTotal;
		}
		
		NSNotificationCenter.defaultCenter().postNotificationName(ZFGameDefines.kRequirementUpdated, this);
		
		if (this._countCurrent == this._countTotal) {
			NSNotificationCenter.defaultCenter().postNotificationName(ZFGameDefines.kRequirementComplete, this);
		}
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/GuiLayer/Quests/ZFQuestNotification'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/GuiLayer/Quests/ZFQuestNotification'] || {}; $MODULE_REGISTRY['Code/Game/GUI/GuiLayer/Quests/ZFQuestNotification'] = exports; exports.ZFQuestNotification = CCColorLayer.subclass({
	classname : "ZFQuestNotification",

	questType : {
		kQuestTypeNotification : -1
	},

	questRewardTypes : {
		questRewardTypeResourceXP : 0,
		questRewardTypeResourceGold : 1,
		questRewardTypeResourceBrains : 2,
		questRewardTypeItem : 3
	},

	questRequirementTypes : {
		questRequirementTypeResource : 0,
		questRequirementTypeItem : 1,
		questRequirementTypeEvent : 2
	},

	initWithID : function(questID, /*BOOL */loadSprite) {
		this.initWithColor(ccc4(0, 255, 0, 0), 32, 32);
		this._isTouchEnabled = true;

		if (questID >= ZFQuestMan._questArray.length) {
			return null;
		}

		var quest = ZFQuestMan._questArray[questID];
		
		//FIXME: Hack to remove farm photography quests
		if(quest.title.indexOf("Farm Photo") >= 0)
		{
			return false;
		}
		
		this._ID = questID;

		//Lets read in the quest from data
		this._title = NSLocalizedString(quest.title);

		
		
		this._spriteFilename = quest.sprite;
		if (loadSprite) {
			this._sprite = CCSprite.spriteWithFile(this._spriteFilename);
			this._sprite.setScale(1.2,1.2,true);
			var target = new GL2.TouchTarget();
			target.setSize(this._sprite.getSize());
			target.setDepth(100000);
			target.setPosition(ccp(0, -this._sprite.getSize()._height));
			this._sprite._target = target;
			this._sprite.addChild(target);
			this._qListener = new Core.MessageListener();
			target.getTouchEmitter().addListener(this._qListener, this._questTapped.bind(this));
		}

		this._messageActive = quest.messageActive;
		this._messageComplete = NSLocalizedString(quest.messageComplete);

		//prerequisites
		this._levelRequired = quest.levelRequired;
		this._prerequisiteQuest = quest.prerequisiteQuest;
		this._seasonal = quest.seasonal;
		this._removeQuest = quest.removeQuest;

		//requirement for completion
		this._requirements = [];
		var requirementsTemp = quest.requirements;

		for ( var ni in requirementsTemp) {
			var n = requirementsTemp[ni];
			var req = new ZFQuestRequirement();
			req._type = n.type;
			req._notificationID = n.notificationID;
			req._notificationObject = n.notificationObject;
			req._countCurrent = 0;
			req._countTotal = n.countTotal;
			req._text = NSLocalizedString(n.text);
			req._spriteFilename = n.sprite;
			this._requirements.push(req);
		}

		//reward
		this._rewardType = quest.rewardType;
		this._rewardObject = quest.rewardObject;

		NSNotificationCenter.defaultCenter().addObserver(this, this.requirementComplete, ZFGameDefines.kRequirementComplete, null);
		NSNotificationCenter.defaultCenter().addObserver(this, this.requirementUpdated, ZFGameDefines.kRequirementUpdated, null);
		return true;
	},

	destroy : function() {
		NSNotificationCenter.removeObserver(this);
		if (this._qListener)
			this._qListener.destroy();
		this._rewardObject = null;
		this._title = null;
		this._spriteFilename = null;
		this._sprite = null;
		this._messageActive = null;
		this._alertWindowActive = null;
		this._alertWindowComplete = null;
		this._isTouchEnabled = false;
		if (this._requirements) {
			this._requirements.length = 0;
			this._requirements = null;
		}
	},

	_questTapped : function(touchEvent) {
//		console.log("ZFQuestNotification._questTapped");

		switch (touchEvent.getAction()) {
		case touchEvent.Action.Start:
			if (touchEvent.getIsInside(this._sprite._target)) {
				if (this.isTouchEnabled())
					ZFQuestMan.questPressed(this); 
			}
			return true;
			break;
		}

		return false;
	},

	startListening : function() {
		for ( var reqi in this._requirements) {
			var req = this._requirements[reqi];
//			console.log("ZFQuestNotification.startListening: " + req._notificationID);
			NSNotificationCenter.defaultCenter().addObserver(req, req.incrementCount.bind(req), req._notificationID, null);
		}
	},

	stopListening : function() {
		for ( var reqi in this._requirements) {
			var req = this._requirements[reqi];
			NSNotificationCenter.defaultCenter().removeObserver(req);
		}
	},

	requirementUpdated : function() {
		//update the save structure
		var gs = GameState;

		for ( var di in gs._zfGameData._currentQuests) {
			var d = gs._zfGameData._currentQuests[di];

			if (d.ID == this._ID) {
				var tempA = d.progress;

				if (tempA && tempA.length > 0) {
					var a = d.progress;
					var acount = a.length;

					for ( var index in this._requirements) {
						var req = this._requirements[index];
						if (index < acount) {
							//prevent bug where progress array isn't properly initialized
							a[index] = req._countCurrent;
						} else if (index == acount) {
							a.push(req._countCurrent);
						}
					}

					d.progress = a;
					break;
				} else {
					//progress array wasn't initialized
					d.progress = [ 0, 0, 0 ];
				}
			}

		}
	},

	requirementComplete : function() {
		for ( var reqi in this._requirements) {
			var req = this._requirements[reqi];
			if (req._countCurrent != req._countTotal) {
				return;
			}
		}

		NSNotificationCenter.defaultCenter().removeObserver(this);
		ZFQuestMan.completeQuest(this);
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/ZFColorDefines'] = function(){var exports = $MODULE_REGISTRY['Code/Game/ZFColorDefines'] || {}; $MODULE_REGISTRY['Code/Game/ZFColorDefines'] = exports; exports.ZFColorDefines = Core.Class.singleton(
{
	classname: 'ZFColorDefines',

	colorBrownButton :  ccc3(255, 126, 63),
	colorBrownButton2 : ccc3(209, 100, 47),
	colorYellowButton2 : ccc3(255, 215, 77),
	colorDarkBrownButton : ccc3(0x80, 0x3f, 0x20),
	colorYellowButton : ccc3(0xff, 0xb7, 0x00),	
	colorGreenButtonHighlight : ccc3(0xaa, 0xd7, 0xa1),
	colorGrayButton  : ccc3(0x80, 0x80, 0x80),
	colorMenuBorderBrown  : ccc3(0x90, 0x60, 0x49),
	colorMenuBorderDarkBrown  : ccc3(0x51, 0x3a, 0x28),
	colorMenuMutationGreen : ccc3(0x47, 0x82, 0x4d),
	colorMenuMutationPurpleDark : ccc3(0x33,0x1e,0x40),
	colorMenuMutationPurpleLight : ccc3(0x93, 0x48, 0x9e),
	colorMenuMutationPurpleLighter : ccc3(0xe4, 0xaf, 0xec),
	colorMenuMutationSelector : ccc3(0xdb, 0xff, 0x4d),
	colorMenuQuestDarkBrown1 : ccc3(0x44, 0x34, 0x28),
	colorMenuQuestDarkBrown : ccc3(0x33, 0x24, 0x17),
	colorMenuQuestLightBrown : ccc3(0xD0, 0xA0, 0x54),
	colorTextWhite  : ccc3(0xff, 0xff, 0xff),
	colorTextBlack  : ccc3(0, 0, 0),
	colorTextDarkBrown  : ccc3(0x3d, 0x2c, 0x25),
	colorTextAsh  : ccc3(0x21, 0x21, 0x1b),
	colorTextMausoleumBlue : ccc3(0xba, 0xd0, 0xde),
	colorTextMausoleumBlueShadow : ccc3(0x2c, 0x54, 0x52),
	colorTextMausoleumTitle  : ccc3(0x87, 0x89, 0x97),
	colorTextMausoleumTitleShadow  : ccc3(0x20, 0x21, 0x31),
	colorTextHighlight : ccc3(0xff, 0xcc, 0x3a),
	colorTextWarning : ccc3(0xFF, 0x40, 0x40),
	colorTextMenuQuestBlue : ccc3(0x2f, 0xa9, 0xff),
	colorSoil : ccc3(0x25,0x1f,0x15),
	colorPaper : ccc3(0xdf,0xcf,0x8f),
	colorRedButton : ccc3(0xff, 0x0, 0x00),
	colorGreenButton : ccc3(0x24, 0xd7, 0x01),
	colorBlueButton  : ccc3(0x26, 0x58, 0xb4),
	colorBrownButton : ccc3(0xff, 0x7e, 0x3f)
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/ZFGameDefines'] = function(){var exports = $MODULE_REGISTRY['Code/Game/ZFGameDefines'] || {}; $MODULE_REGISTRY['Code/Game/ZFGameDefines'] = exports; exports.ZFGameDefines = Core.Class.singleton({
    classname : 'ZFGameDefines',
    
    /*
    // Flurry
    kFlurryEvent_beginFight :  "Begin Fight",
    kFlurryEvent_fightResult : "Fight Result",
    kFlurryEvent_fightLostAtLevel : "Fight Lost At Level",
    kFlurryEvent_brainAttained : "Brain Attained",
    kFlurryEvent_boughtBrain : "Brains Bought",
    kFlurryEvent_boughtGrave : "Blue Grave Bought at Level",
    kFlurryEvent_brainSpent : "Brain Spent",
    kFlurryEvent_goldSpent : "Gold Spent",
    kFlurryEvent_headBought : "Head Bought",
    kFlurryEvent_levelUp_level01to10 : "Level Up 1-10",
    kFlurryEvent_levelUp_level11to15 : "Level Up 11-15",
    kFlurryEvent_levelUp_level16to20 : "Level Up 16-20",
    kFlurryEvent_levelUp_level21to25 : "Level Up 21-25",
    kFlurryEvent_levelUp_level26to30 : "Level Up 26-30",
    kFlurryEvent_levelUp_level31to35 : "Level Up 31-35",
    kFlurryEvent_levelUp_level36to40 : "Level Up 36-40",
    kFlurryEvent_gameStarted : "Game Started",
    kFlurryEvent_playTapped : "Play Tapped",
    kFlurryEvent_cropsExpired : "Crops Expired",
    kFlurryEvent_zombieCombiner : "Zombie Pot",
    kFlurryEvent_finishedLoading : "Finished Loading",
    kFlurryEvent_dlOfferConfirmation : "Download Offer Confirmation",
    kFlurryEvent_giftSent : "Gift Sent",
    kFlurryEvent_zombieCamera : "Zombie Camera Picture Taken",
    kFlurryEvent_mutationCollection : "Mutation Collectable Unlocked",
    kFlurryEvent_recommendInvasionVoucher : "Recommend Invasion Voucher"
    */

    // Dev keys,
    kPlayHavenDevKey : "PDzdejZfePVGHg6Kp85J4Q:5sL8tXbYFiR-jVMO0_hk5g",
    kFlurryAPIKey : "MUR5CJLUGDY8YSHEE14D",
    kFlurryAPIAccessCode : "5UQTMYT6QJZI737SIMGR",
    kTapjoyAPPID : "e26bd54e-a9ec-4f60-b84d-82b4f678343a",
    kTapjoyVer : "0.75",
    kTapjoyPW : "playforge",
    G6PayAppID : "305",
    G6PaySecret : "6454d94fdce57d810.14681857",
    
    // Save
    kUserDefaultID_lastPlayerID : "ZFLastPlayerID",
    kUserDefaultID_lastPlayerAlias : "ZFLastPlayerAlias",
    kUserDefaultID_lastPlayerLevel : "ZFLastPlayerLevel",
    
    // StoreIDs
//    kStoreBrainIdentifier : "Brain",
    kStoreBrainIdentifier : "brain",
    /*kStoreBrainIdentifier5 : "Brain5",
    kStoreBrainIdentifier10 : "Brain10",
    kStoreBrainIdentifier50 : "Brain50",*/
//    kStoreBrainIdentifier5Weekday : "Brain5Weekday",
    kStoreBrainIdentifier5Weekday : "brain5weekday",
    //
    kStoreBrainIdentifier10Weekday : "brain10weekday",
    kStoreBrainIdentifier50Weekday : "brain50weekday",
    kStoreFarmerHead1Identifier : "farmerhead1",
    kStoreFarmerHead2Identifier : "farmerhead2",
    kStoreFarmerHead3Identifier : "farmerhead3",
    kStoreFarmerHead4Identifier : "farmerhead4",
    kStoreFarmerHead5Identifier : "farmerhead5",
    kStoreFarmerHead6Identifier : "farmerhead6",
    kStoreBlueGraveIdentifier : "bluegrave",
    
    // new StoreIDs
    kStoreFarmerHead7Identifier : "farmerhead7",
    kStoreFarmerHead8Identifier : "farmerhead8",
    kStoreFarmerHead9Identifier : "farmerhead9",
    
    // URLs
    //kZombieFarmPage : "http://itunes.com/apps/ZombieFarm",
    kZombieFarmPage : "http://itunes.apple.com/co/app/zombie-farm/id339933022?mt=8",
    
    // Notifications
    kSaveDoneNotification : "kSaveDoneNotification",
    kLoadDoneNotification : "kLoadDoneNotification",
    kEnableInGameMenusNotification : "kEnableInGameMenusNotification",
    kReturnedFromOptionsNotification : "kReturnedFromOptionsNotification",
    kReturnedFromFriendsNotification : "kReturnedFromFriendsNotification",
    kNetConnectivityUpdatedNotification : "kNetConnectivityUpdatedNotification",
    kNetConnectivityResultDetermined : "kNetConnectivityResultDetermined",
    kScreenShotUploadDoneNotification : "kScreenShotUploadDoneNotification",
    kPhotoPermissionApproved : "kPhotoPermissionApproved",
    kFightSummaryDone : "kFightSummaryDone",
    kCropHarvestedZombieNotification : "kCropHarvestedZombieNotification",
    kInvasionSuccessfulNotification : "kInvasionSuccessfulNotification",
    kCropPlantedNotification : "kCropPlantedNotification",
    kCropHarvestedNotification : "kCropHarvestedNotification",
    kCombinerHarvestedNotification : "kCombinerHarvestedNotification",
    kSoilPlowedNotification : "kSoilPlowedNotification",
    kRequirementComplete : "kRequirementComplete",
    kRequirementUpdated : "kRequirementUpdated",
    kItemBoughtNotification : "kItemBoughtNotification",
    kPhotoTakenNotification : "kPhotoTakenNotification",
    kGameCenterDisabledNotification : "kGameCenterDisabledNotification",
    kGameCenterAuthenticationDoneNotification : "kGameCenterAuthenticationDoneNotification",
    
    kStageActorDefeated : "kStageActorDefeated",
    kLootItemWonNotification : "kLootItemWonNotification",
    kInvasionPerfectGameNotification : "kInvasionPerfectGameNotification",
    
    // User defaults,
    kUserDefaultID_useFacebook : "ZFUseFacebook",
    kUserDefaultID_autoScreenshot : "ZFAutoScreenshot",
    kUserDefaultID_audioMute : "kUserDefaultID_audioMute",
    kUserDefaultID_audioSFXVol : "kUserDefaultID_audioSFXVol",
    kUserDefaultID_audioBGMVol : "kUserDefaultID_audioBGMVol",
    kUserDefaultID_flurryOffersEnabled : "ZFFlurryOffersEnabled",
    ZFHarvestNotificationsEnabled: "ZFHarvestNotificationsEnabled",
    ZFWitherNotificationsEnabled: "ZFWitherNotificationsEnabled",
    ZFInvasionNotificationsEnabled: "ZFInvasionNotificationsEnabled",
    ZFOnlineSavingEnabled: "ZFOnlineSavingEnabled",
    ZFStatusCheckDisabled: "ZFStatusCheckDisabled",
    ZFDayAndNightEnabled: "ZFDayAndNightEnabled",
    ZFAllowIncentivizedInstalls: "ZFAllowIncentivizedInstalls",
    ZFAllowDailySalesOffer: "ZFAllowDailySalesOffer",
    ZFAlreadyShowedGameCenterCancel: "ZFAlreadyShowedGameCenterCancel",
    ZFNumGameCenterCancels: "ZFNumGameCenterCancels",
    ZFSyncingStarted: "ZFSyncingStarted",
    ZFSyncCrash: "ZFSyncCrash",
    ZFGameVersion: "ZFGameVersion",
    
    // Farm
    TILE_WIDTH : 48,
    TILE_HEIGHT : 24,
    
    //zoom
    ZOOM_MAX_VALUE : 2,
    ZOOM_MIN_VALUE : 0.2,
    
    STANDARD_TILE_WIDTH : 192,
    STANDARD_TILE_HEIGHT : 192,
    STANDARD_SHEET_WIDTH : 5,
    STANDARD_SHEET_HEIGHT : 5,
    //STANDARD_SHEET_CAPACITY : (STANDARD_SHEET_HEIGHT * STANDARD_SHEET_WIDTH),
    
    LARGE_TILE_POSITION_ADJUST_X : 0.38,
    LARGE_TILE_POSITION_ADJUST_Y : 0.0,
    
    PLOW_COST : 10,
    PLOW_XP : 1,
    PLANT_GROWTH_STAGES : 2,
    ZOMBIE_GROWTH_STAGES : 3,
    WITHER_MULTIPLIER : 3,
    WITHER_MINTIME : (60 * 60),
    
    GUI_UPDATE_INTERVAL : (1. / 30.),
    FARM_UPDATE_INTERVAL : (1. / 4.),
    PLAYERACTIONSPEED : 2.0,
    PLAYERACTIONSPEED_CHEAT : 1000.,
    
    GROWSPEED : 1,
    GROWSPEED_CHEAT : (60 * 10 * 6),
    
    INVASION_INTERVAL : (60 * 60 * 2),
    ZOMBIE_HUNGER_DURATION : (60 * 60 * 8),
    
    BRAIN_DROPRATE_LEVEL_DEVIATION : 10.,
    BRAIN_DROPRATE_MIN : 0.02,
    BRAIN_DROPRATE_MAX : 0.13,
    DAILYBONUS_BRAIN_RATE : 0.07,
    DAILYBONUS_ZOMBIE_RATE : 0.25,
    BASE_DAILY_GOLD_BONUS : 100,
    MAX_DAILY_GOLD_BONUS : 1000,
    DAILY_PHOTO_GOLD_BONUS : 100,
    
    BASEDEFECTIVERATE : 0.25,
    MINDEFECTIVERATE : 0.01,
    MAXDEFECTIVERATE : 0.5,
    LEVEL_DEFECTS_PROTECTION_CAP : 3,
    LEVEL_DEFECTS_IN_FULL_EFFECT : 10,
    
    MINMUTANTRATE : 0.0,
    MAXMUTANTRATE : 0.6,
    LEVEL_MUTANT_IN_EFFECT : 3,
    LEVEL_PITCH : 10,
    LEVEL_SUBSIDY : 5,
    
    ARMYINCREASELEVEL : 5,
    ARMYINCREASEBY : 16,
    
    MAUSOLEUM_SLOTS_MIN : 3,
    
    LUCK_NEEDED_PER_LEVEL : 3.,
    
    MAXLEVEL : 40,
    BUY_A_TREE_LEVEL : 5,
    RATE_IT_LEVEL : 7,
    COMBINER_AVAILABLE_LVL : 25,
    FLURRY_OFFER_LEVEL_THRESH : 4,
    
    MINMAPSIZE : 30,
    MAXMAPSIZE : 60,
    
    kZombiePatchKey : "soil_zombiePatch",
    kMausoleumKey : "mausoleum1",
    kCameraKey : "cameraNormal",
    kZombieCombinerKey1 : "zombieCombiner",
    kZombieCombinerKey2 : "zombieCombiner_cooking",
    kZombieCombinerKey3 : "zombieCombiner_done",
    
    kCombiner01ItemName : "Zombie Pot",
    kStorage01ItemName : "Shed",
    
    STORAGE_AVAILABLE_LVL : 8,
    ZOMBIE_COMBINER_COOK_TIME : (60 * 60 * 1),
    
    // Market,
    MARKET_PAGE_PER_SCREEN : 6.,
    
    // Farmer Menu,
    NUMBER_OF_HEAD_IDS : 15 /*NOTE: use 6 to disable purchaseable heads*/,
    
    // Drops,
    DROPRATE_COMMON : 0.8,
    DROPRATE_RARE : 0.2,
    DROPRATE_EPIC : 0.05,
    
    FRAGMENTS_TO_KEY : 3,
    
    // Stats
    ZOMBIE_RANK_CAP : 5,
    ZOMBIE_RANK_STAT_INCREASE : 0.05,
    
    // Fight,
    BOSS_POSITION_X : 450.,
    BOSS_POSITION_Y : 200.,
    ENEMY_POSITION_X : 435.,
    ENEMY_POSITION_Y : 20.,
    
    HEALY_POSITION_X_OFFSET : 80.0,
    
    FIGHT_PREPSPOT_X : 200,
    FIGHTBUBBLE_OFFSET_X : 25.,
    FIGHTBUBBLE_OFFSET_Y : 60.,
    MAX_THOUGHT_ROLLS : 5,
    
    TIER1LVL : 10,
    TIER2LVL : 15,
    TIER3LVL : 20,
    TIER4LVL : 25,
    TIER5LVL : 30,
    TIER6LVL : 35,
    PREP_CHARGE_TIME_MAX : 1.35,
    POWER_MULTIPLIER : 10.,
    HITPOINTS_MULTIPLIER : 100.,
    ATTACKSPEED_MULTIPLIER : 1.0,
    PROJECTILE_DAMAGE_MULTIPLIER : 1.,
    PROJECTILE_THROW_MAXDELAY : 9.0,
    PROJECTILE_THROW_MINDELAY : 2.,
    PROJECTILE_THROW_LEVEL_SLOWSPEED_T1 : 1.0,
    PROJECTILE_THROW_LEVEL_FULLSPEED_T1 : 10.0,
    PROJECTILE_THROW_LEVEL_SLOWSPEED_T2 : 15.0,
    PROJECTILE_THROW_LEVEL_FULLSPEED_T2 : 25.0,
    DAMAGE_IMMUNITY_IN_FRAMES : 0,
    
    MAX_ZOMBIE_FIGHTING : 16,
    FIGHT_TIMER : 180,
    
    HUDELEMENTS1_FILE : "hudElements.png",
    HEAD_GOLD_BONUS : 0.1,
    
    // removed from cocos,
    //	CCARCRANDOM_0_1() : (((arc4random() % 100) / 100)),
    
    SEASONAL_DEADLINE_MONTH : 5,
    SEASONAL_DEADLINE_DAY : 3,
    SEASONAL_DEADLINE_YEAR : 2011,
    
    // for relative window positioning,
    //	WINDOW_SIZE : CCDirector.winSize(),
    //	WINDOW_WIDTH : CCDirector.winSize()._width,
    //	WINDOW_HEIGHT : CCDirector.winSize()._height,
    
    //	ORIGINAL_WINDOW_SIZE : CGSizeMake(480,320),
    ORIGINAL_WINDOW_WIDTH : 480,
    ORIGINAL_WINDOW_HEIGHT : 320,
    
    //	WIDTH_SCALE : WINDOW_WIDTH/ORIGINAL_WINDOW_WIDTH,
    //	HEIGHT_SCALE : WINDOW_HEIGHT/ORIGINAL_WINDOW_HEIGHT,
    
    PI : 3.14159,
    
    //notifications from PlayerProfileManager
    kStatusCheckDoneNotification : "kStatusCheckDoneNotification",
    kRemoteGameLoadDoneNotification : "kRemoteGameLoadDoneNotification",
    kRemoteGameSaveDoneNotification : "kRemoteGameSaveDoneNotification",
    kActivePlayerProfileUpdateNotification : "kActivePlayerProfileUpdateNotification",
    
    TAG_DELETE_TILE : 1,
    
    initialize : function()
    {
    },
    
    getConst : function(name)
    {
        return this[name];
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/ZFGameFlags'] = function(){var exports = $MODULE_REGISTRY['Code/Game/ZFGameFlags'] || {}; $MODULE_REGISTRY['Code/Game/ZFGameFlags'] = exports; exports.ZFGameFlags = Core.Class.singleton(
{
	classname: 'ZFGameFlags',
	
	
//flags
 GFLAG_TUTORIAL_START	:	(1<<0),
 GFLAG_TUTORIAL_PLANT	:	(1<<1),
 GFLAG_TUTORIAL_PLANT_DONE:	(1<<2),
 GFLAG_HARVEST_ZOMBIE		:(1<<3),
 GFLAG_TUTORIAL_DONE		:	(1<<4),
 GFLAG_HARVEST_GARDEN_ZOMBIE:	(1<<5),
 GFLAG_HARVEST_MUTANT		:(1<<6),
 GFLAG_LIFELESS				:(1<<7),
 GFLAG_MAX_ARMY_SIZE		:	(1<<8),
 GFLAG_INVADE				:(1<<9),
 GFLAG_FB_ENEMY1			:	(1<<10),
 GFLAG_FB_ENEMY2			:	(1<<11),
 GFLAG_FB_ENEMY3			:	(1<<12),
 GFLAG_FB_ENEMY4			:	(1<<13),
 GFLAG_FB_ENEMY5			:	(1<<14),
 GFLAG_FB_ENEMY6			:	(1<<15),
 GFLAG_FB_ENEMY7			:	(1<<16),
 GFLAG_FB_ENEMY8			:	(1<<17),
 GFLAG_FB_ENEMY9			:	(1<<18),
 GFLAG_SOMETHING_BOUGHT	:	(1<<19),
 GFLAG_FIGHT_TUTORIAL	:	(1<<20),
 GFLAG_RAIN				:	(1<<21),
 GFLAG_STARTING_GOLD_GIVEN	:(1<<22),
 GFLAG_RATE_IT_SHOWN		:	(1<<23),
 GFLAG_PITCH_SHOWN			:(1<<24),
 GFLAG_TUTORIAL_STORAGE		:(1<<25),
 GFLAG_TUTORIAL_COMBINER	:	(1<<26),
 GFLAG_TUTORIAL_ZOMBIE_RANK	:(1<<27),

//purchase flags

	PFLAG_FARM40 : 0,
	PFLAG_FARM50 : 1,
	PFLAG_TOMATOMUTATION : 2,
	PFLAG_ONIONMUTATION : 3,
	PFLAG_CARROTMUTATION : 4,
	PFLAG_TURNIPMUTATION : 5,
	PFLAG_POTATOMUTATION :		6,
	PFLAG_COFFEEMUTATION :		7,
	PFLAG_CELERYMUTATION :		8,
	PFLAG_BROCCOLIMUTATION	:	9,
	PFLAG_GARLICMUTATION	:	10,
	PFLAG_CAULIFLOWERMUTATION:	11,
	PFLAG_LIMABEANMUTATION	:	12,

	PFLAG_NO_LIFELESS		:	13,
	PFLAG_NO_PLOWCOST		:	14,
	PFLAG_ALL_MUTATION		:	15,
	PFLAG_FARMER_SPEED		:	16,

	PFLAG_UNLOCK_BLUE		:	17,
	PFLAG_UNLOCK_RED		:	18,

	PFLAG_CLIMATE_SAND		:	19,
	PFLAG_CLIMATE_CONCRETE	:	20,
	PFLAG_CLIMATE_SNOW		:	21,

	PFLAG_STORAGE01			:	22,
	PFLAG_STORAGE02			:	23,
	PFLAG_STORAGE03			:	24,
	PFLAG_STORAGE04			:	25,
	PFLAG_STORAGE05			:	26,
	PFLAG_STORAGE06			:	27,

	PFLAG_FASTER_COMBINE	:	28,

	PFLAG_FLYTRAPMUTATION	:	29,
	PFLAG_DRAGONMUTATION	:	30,

	PFLAG_CLIMATE_DEAD		:	31,

	PFLAG_FARM60			:	32,

	PFLAG_STORAGE07			:	33,		
	PFLAG_STORAGE08			:	34,

	MAUSOLEUMFLAG_MAUSOLEUM_UNLOCKED :	(1<<0),
	MAUSOLEUMFLAG_MAUSOLEUM01	:		(1<<1),
	MAUSOLEUMFLAG_MAUSOLEUM02	:		(1<<2),
	MAUSOLEUMFLAG_MAUSOLEUM03	:		(1<<3),

	MAUSOLEUMFLAG_ALL_MAUSOLEUMS : (this.MAUSOLEUMFLAG_MAUSOLEUM01|this.MAUSOLEUMFLAG_MAUSOLEUM02|this.MAUSOLEUMFLAG_MAUSOLEUM03),
	
	//farmer head flags
	FFLAG_HEAD01					: (1<<0), // skeleton male
	FFLAG_HEAD02					: (1<<1), // vampire male
	FFLAG_HEAD03					: (1<<2), // skeleton female
	FFLAG_HEAD04					: (1<<3), // vampire female
	FFLAG_HEAD05					: (1<<4), // zombie male
	FFLAG_HEAD06					: (1<<5), // zombie female
	FFLAG_HEAD07					: (1<<6), // paper bag male
	FFLAG_HEAD08					: (1<<7), // monolith male
	FFLAG_HEAD09					: (1<<8), // pumpkin male
	FFLAG_ALL 						: this.FFLAG_HEAD01	| this.FFLAG_HEAD02 | this.FFLAG_HEAD03 | this.FFLAG_HEAD04 | this.FFLAG_HEAD05 | this.FFLAG_HEAD06	| this.FFLAG_HEAD07 | this.FFLAG_HEAD08 | this.FFLAG_HEAD09,


	initialize: function()
	{

	},
	
	getConst: function(name)
	{
		return this[name];
	}
	

});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/NSObjects/NSNotificationCenter'] = function(){var exports = $MODULE_REGISTRY['Code/NSObjects/NSNotificationCenter'] || {}; $MODULE_REGISTRY['Code/NSObjects/NSNotificationCenter'] = exports; exports.NSNotificationCenter = Core.MessageEmitter.singleton(
{
	classname:'NSNotificationCenter',
	
	initialize: function()
	{   
		this._targets = [];
	},
	
	defaultCenter: function()
	{
		return this;
	},
	
	postNotificationName: function(aName, anObject, aUserInfo)
	{
		this.emit(aName, anObject, aUserInfo);
	},
	
	postNotificationName_object_userInfo: function(aName, anObject, aUserInfo)
	{
		this.emit(aName, anObject, aUserInfo);
	},
	
	_findTargetListener: function (target,remove) {
		var targets = this._targets;
		for (var i=0; i < targets.length; i++) {
			if (targets[i][0] == target) {
				var ret = targets[i][1];
				if (remove) {
					targets.splice(i,1);
				}
				return ret;
			}
		}
		return null;
	},

	
	addObserver: function(target, selector, name, object)
	{
		var listener = this._findTargetListener(target, false);
		if(!this._targets[target])
		{
	        var Listener = Core.MessageListener.subclass(
		    {
		    	initialize: function(target) {
		    		this._target = target;
		    		this._selectors = [];
		    	},
		    	
				_findTargetFunction: function (target,remove) {
					var targets = this._selectors;
					for (var i=0; i < targets.length; i++) {
						if (targets[i][0] == target) {
							var ret = targets[i][1];
							if (remove) {
								targets.splice(i,1);
							}
							return ret;
						}
					}
					return null;
				},
		    		
		    	onEvent: function(event, anObject, aUserInfo){
		    		var selector = this._findTargetFunction(event);
		    		if(selector)
		    			selector.call(this._target, aUserInfo);	
		    	},
		    	
		    	addSelectorForName: function(aSelector, aName)
		    	{
		    		this._selectors.push([aName, aSelector]);
		    	},
		    	
		    	removeSelectorForName: function(aName)
		    	{
		    		this._findTargetFunction(aName, true);
		    	}
		    });
	    
	        listener = new Listener(target);
	        NSNotificationCenter.addListener(listener, listener.onEvent);
	        listener.addSelectorForName(selector, name);
	        this._targets.push([target,listener]);
		}
		else
		{
			listener.addSelectorForName(selector, name);
		}
	},
	
	removeObserver: function(observer, aName, anObject)
	{
		var listener = this._findTargetListener(observer, false);
		if(listener)
		{
			if(aName)
			{
				listener.removeSelectorForName(aName);
				if(!listener._selectors.length)
				{
					this.removeListener(listener);
					this._findTargetListener(observer, true);
				}
			}
			else
			{
				this.removeListener(listener);
				this._findTargetListener(observer, true);
			}
		}
	}
	
	
	


	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Player/PlayerProfileManager'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Player/PlayerProfileManager'] || {}; $MODULE_REGISTRY['Code/Game/Player/PlayerProfileManager'] = exports; var PlayerProfile = require('Code/Game/Player/PlayerProfile').PlayerProfile;
var ZFGameDefines = require('Code/Game/ZFGameDefines').ZFGameDefines;

exports.PlayerProfileManager = Core.Class.singleton(
{
	classname:'PlayerProfileManager',
	
	initialize: function()
	{        
	},
	
	init: function()
	{
		this._activePlayer = new PlayerProfile(this.startup.bind(this));
		this._remoteSaveCounter = 0;
		this._remoteSaveTimer = null;
		this._isSwitchingUser = false;
	},
	
	$playerProfileManager: function()
	{
		return this;
	},
	
	startup: function()
	{	    
	    // First log our startup info
	    this.logStartupInfo();
	    
	    // Next determine which user we are starting up with
	    this.determineStartupPlayer();
	    
	    // Now that we have a startup player profile get the
	    // info for that profile
	    this.updatePlayerInfo();
	},

	logStartupInfo: function()
	{
	    var startTime = Core.Time.getRealTime()/1000;
	    this._saveBackups = false;
	},
	
	determineStartupPlayer: function()
	{	    
	    var defaults = NSUserDefaults.standardUserDefaults();
	    var lastPlayerID = defaults.objectForKey(ZFGameDefines.kUserDefaultID_lastPlayerID);
	},
	
	updatePlayerInfo: function()
	{
	    // Make sure to sync the last player pref
		var defaults = NSUserDefaults.standardUserDefaults();
		defaults.setObject(this._activePlayer._playerProfileID, ZFGameDefines.kUserDefaultID_lastPlayerID);
		this._activePlayer.loadFromSaveFile(function()
		{
		    NSNotificationCenter.postNotificationName(ZFGameDefines.kActivePlayerProfileUpdateNotification, null);
		});
	},
		
	saveGameData: function(gameData)
	{
	    // First let the GameData save itself
	    gameData.save();
	    
	    // If the GameData's playerProfileID matches the active player's profile id
	    // then this is a good time to update the active player's data and info
	    if (gameData._playerProfileID && !(gameData._playerProfileID === null) &&
	        (gameData._playerProfileID == this._activePlayer._playerProfileID))
	    {
	        // Set the GameData
	        //this._activePlayer.setGameData(gameData);
	        
	        // Update the player info
	        this.updatePlayerInfo();
	    }
	},
	
	saveActivePlayerLocalGame: function()
	{
	    // Allow the active player's profile to save itself
	    this._activePlayer.save();
	    
	    // Notify the rest of the game that saving the active player locally is done
	    NSNotificationCenter.defaultCenter().postNotificationName(ZFGameDefines.kSaveDoneNotification, null);
	},
	
	$getActivePlayer: function()
	{
		return this._activePlayer;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/ZFActorManager'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/ZFActorManager'] || {}; $MODULE_REGISTRY['Code/Game/Actor/ZFActorManager'] = exports; exports.ZFActorManager = CCNode.singleton (
{
	classname: 'ZFActorManager',

//enum 
//{
//	kTagTileMap = 1,
//	kTagSpriteManager = 1,
//	kTagAnimation1 = 1,
//};
	initialize: function()
	{	    
	    this._farmerSprites = DataPreloader._farmerSprites;
        this._unitStats = DataPreloader._unitStats;
        this._nameList = DataPreloader._nameList;
        this._stageActorDictionaries = DataPreloader._stageActorDictionaries;
        this._zombieSheet = DataPreloader._zombieSheet;
        
        this._actorList = [];
        this._spawnQueue = [];
            
        this._zombieStorage = null;
        this._farmActors = [];
        this.schedule(this.updateAnimations, 10, "updateAnimations");
	},

	$actorManager: function()
	{
		return this;
	},
	
//	Piano: reserved for animation polishing
	$pianoTouched: function( pianoKey )
	{
//		console.log( "Piano:" + pianoKey );
		
		acm = this.actorManager();
		
		for ( key in acm._actorList )
		{
			a = acm._actorList[ key ];
			
			var arm1 		= a._attachments[ kActorPartTagArmF ];
			var arm2 		= a._attachments[ kActorPartTagArmB ];
			var foot1 		= a._attachments[ kActorPartTagFootF ];
			var foot2 		= a._attachments[ kActorPartTagFootB ];
			var body 		= a._attachments[ kActorPartTagBody ];
			var head 		= a._attachments[ kActorPartTagHead ];
			var tool 		= a._attachments[ kActorPartTagArmBm ];
			
			var s = 1.0; // Speed
			var f = head._sprite.getFlipX() ? -1 : +1;
			
			if ( a != "PlayerActor" )
			{
//				console.log( a );
				
				var head = a._attachments[ 0 ];
				
				a.addMutation( 1 << pianoKey );
				
				switch( pianoKey )
				{
				case 0:
					break;				
				case 1:
					break;
				case 2:
					break;
				case 3:
					break;
				case 4:
					break;
				case 5:
					break;
				case 6:
					break;
				case 7:
					break;
				case 8:
					break;
				case 9:
					break;
				}
			}
		}
	},
	
	farmerSprites: function( key )
	{
		return this._farmerSprites[ key ];
	},
	
	zombieSprites: function()
	{
		return this._zombieSheet;
	},
	
	spawnStageGUIActor_withName_atPoint_withTarget: function( actorName , point , target )
	{
	    /* NOTE: This method is not in use */
		var actorDictionary = this._stageActorDictionaries[ actorName ];
		var actor = StageActor.stageActorWithDictionary( actorDictionary ); // StageActor*

		actor._destinationPoint = this._point;
		actor._originalPosition = this._point;
		actor._destinationPoint = this._point;
		actor._originalPosition = this._point;
		
		this._target.addChild( actor );
		this._target.addChild( actor._spriteMan , 11 ); // addChild , z
		
		actor.resetColor();
		actor.unscheduleUpdate();
		actor.schedule( actor.guiActorUpdate, 0, "guiActorUpdate");
		actor.guiActorUpdate();
		actor._spriteMan.setScale( ccpMult( actor._spriteMan.getScale() , 0.8 ) );
		
		return actor;
	},
	
	spawnGUIActor_withClass_atPoint_withTarget: function( actorClass , point , target )
	{
		var actor = eval( '(' + " new " + actorClass + "() " + ')' );
	
		actor.setColor( actor.colorFromSubType( actor._subType ) );
		actor.initSprite();
		actor.setDepth( 20 );
		actor.setPosition( point.clone() );
				
		actor.resetColor();
		
		var scl = ccpMult( actor._spriteMan.getScale() , 0.8 );
        actor._spriteMan.setScale( scl );
        actor._futureParent = target;
		
		actor.schedule(actor.guiActorUpdate, 0, "guiActorUpdate");
        actor.schedule(actor.guiAddToParent, 0, "guiAddToParent");
		
		return actor;
	},
	
	loadActorManager: function()
	{	
	    // Clear out the current spawn queue
		this._spawnQueue = [];
	    
	    // Get a copy of the actors in the active GameData
	    var gs = GameState;
	
		var actors = gs._zfGameData._actorList;
		
	    // Add them to the spawn queue
		for( key in actors )
		{
			this._spawnQueue.push( actors[ key ] );
		}
		
	    // Initialize the storage
		if ( gs._zfGameData._zombieStorage )
			this._zombieStorage = gs._zfGameData._zombieStorage;
		else 
			this._zombieStorage = [];
	
	    // Fill NSNull objects into unused slots
		for ( var i = this._zombieStorage.length ; i < gs._zfGameData._mausoleumSlots; i++ )
			this._zombieStorage.push( null );
	},
	
	spawnActor_withClass_atPoint: function( actorClass , point )
	{
		var actor = eval( '(' + "new " + actorClass + "()" + ')' );		
		if ( actor.classname == "PlayerActor" )
		{
			this._player = actor;
		}
		
		actor.setPosition( point.clone() );
		actor._destinationPoint = point.clone();
		actor.initActorSpecificDataAfterLoad();
		actor.initSprite();
		
		return actor;
	},
	
	spawnStageActorWithMarketDictionary_onTile: function( marketDict , tileCoordinates ) 
	{
		var gs = GameState;
		
		tileCoordinates.setX ( (tileCoordinates._x > gs._zfGameData._mapSize) ? gs._zfGameData._mapSize : tileCoordinates._x );
		tileCoordinates.setY ( (tileCoordinates._y > gs._zfGameData._mapSize) ? gs._zfGameData._mapSize : tileCoordinates._y );
		
		var spawnLocation = ZFTileManager.mapPointFromTile( new Core.Point( 14.0 , 12.0 ) );
		// TODO : Remove hardcode, when mapPointFromTile will be coded.
		//var spawnLocation = ZFTileManager.mapPointFromTile( tileCoordinates );
			
		
		var actor = StageActor.stageActorWithMarketDictionary( marketDict );
		
		///////// SETUP FARM TILE POSITION //////////
		actor._destinationPoint = spawnLocation;
		actor._originalPosition = spawnLocation;
		actor._position = spawnLocation;
		
		actor._farmData = new ActorFarmData();
		actor._farmData._currentTile = tileCoordinates;
		actor._farmData._destinationTile = tileCoordinates;
		
		///////// SETUP Z-ORDER //////////
		var newZ = tileCoordinates._y + tileCoordinates._x + 1;
		ZFTileManager._map.addChild( actor._spriteMan , newZ );
		
		// TODO : ActorStateSpawn not found in objC classes ...
		//actor.setState( kStageActorStateSpawn);
		actor.setState( 0 );
		
		this._farmActors.push( actor );
		
		this.addChild( actor );
		actor.movementUpdate( 0 ); // Need to get dt here somehow
		
		///////// ENABLE ON ACTOR CLICK-UP //////////
		if ( this._actor._actorDictionary[ "touchSpriteID" ] )
		{
			var attachmentID = actor._actorDictionaryobjectForKey[ "touchSpriteID"];
			var a = this._actor._attachments[ attachmentID ];
			
			var tSprite = new TSprite();
			tSprite.initWithAtlasSprite( a._sprite );
			TSprite.track( tSprite );
			tSprite._actor = this._actor;
		}
		
		///////// ACTOR SHOULD START RUNNING //////////
		actor.scheduleUpdate();
		
		return actor;
	},
	
	spawnStageActor_onTile: function( actorName , tileCoordinates ) // NSString*, CGPoint
	{
		var gs = GameState;
		
		tileCoordinates.setX ( (tileCoordinates._x > gs._zfGameData._mapSize) ? gs._zfGameData._mapSize : tileCoordinates._x );
		tileCoordinates.setY ( (tileCoordinates._y > gs._zfGameData._mapSize) ? gs._zfGameData._mapSize : tileCoordinates._y );
		
		//CGPoint spawnLocation = ccpAdd([[ZFTileManager tileManager] mapPointFromTile:tileCoordinates],ccp(24.f, 12.f));
		var spawnLocation = ZFTileManager.mapPointFromTile( tileCoordinates );
		
		var actorDictionary = this._stageActorDictionaries[ actorName ];
		var actor = StageActor.stageActorWithDictionary( actorDictionary );
		
		///////// SETUP FARM TILE POSITION //////////
		actor._destinationPoint = spawnLocation;
		actor._originalPosition = spawnLocation;
		actor._position = spawnLocation;
		
		actor._farmData = new ActorFarmData();
		actor._farmData._currentTile = tileCoordinates;
		actor._farmData._destinationTile = tileCoordinates;
		
		///////// SETUP Z-ORDER //////////
		var newZ = tileCoordinates._y + tileCoordinates._x + 1;
		ZFTileManager._map.addChild( actor._spriteMan , newZ );
		// TODO : Find out actor state spawn.
		//actor.setState( kStageActorStateSpawn );
		
		this._farmActors.push( actor );
		
		this.addChild( actor );
		actor.movementUpdate( 0 ); // Need to get dt here somehow
		
		///////// ENABLE ON ACTOR CLICK-UP //////////
		if( actor._actorDictionary._touchSpriteID )
		{
			var attachmentID = actor._actorDictionary._touchSpriteID;
			
			var a = actor._attachments[ attachmentID ];
			
			var tSprite = new TSprite();
			tSprite.initWithAtlasSprite( a._sprite );
			TSprite.track( tSprite );
			tSprite._actor = _actor;
		}		
		///////// ACTOR SHOULD START RUNNING //////////
		actor.scheduleUpdate();
		
		return actor;
	},
	
	spawnFarmActor_onTile: function( actorClass , tileCoordinates ) 
	{
		var gs = GameState;
		ZFTileManager.instantiate();
		var maxWidth = 6;
		
		// TODO : link with real game data.
//		var clampedX = tileCoordinates._x > ZFTileManager._map._mapSize._width ?
//				ZFTileManager._map._mapSize._width : tileCoordinates._x;
//		var clampedY = tileCoordinates._y > ZFTileManager._map._mapSize._height ?
//				ZFTileManager._map._mapSize._height : tileCoordinates._y;
		
		var spawnLocation = ZFTileManager.mapPointFromTile( tileCoordinates.clone() );
		
		//spawnLocation.setY( -spawnLocation._y );
		
		var actor = this.spawnActor_withClass_atPoint( actorClass , spawnLocation.clone() );
		
		// Restore position.
		actor.setPosition( spawnLocation.clone() );
		//actor._spriteMan.setPosition( spawnLocation.clone() );
		
		actor._farmData = new ActorFarmData();
		actor._farmData._currentTile = tileCoordinates.clone();
		actor._farmData._destinationTile = tileCoordinates.clone();
		
		var newZ = tileCoordinates._x + tileCoordinates._y + 1;
		ZFTileManager._map.addChild( actor._spriteMan ,  newZ );
		actor.setState( kActorStateIdle );
		this._actorList.push( actor );
		this.addChild( actor );
		actor.movementUpdate( 0 );
		
		// This actor must be able to be touched, set this up now.
		var a = actor._attachments[ kActorPartTagHead ];
		var tSprite = new TSprite();
		tSprite.initWithAtlasSprite( a._sprite );
		TSprite.track( tSprite );
		tSprite._actor = actor;
		
		if ( !(actor instanceof PlayerActor)) {
			//zombies need this update
//			actor._farmAnimated = true;
			actor.schedule( actor.farmUpdate, 0, "farmUpdate" );
		} else {
			// stage actors use this update
			actor.scheduleUpdate();
		}
		
		
		return actor;
	},
	
	restoreSchedules: function()
	{
		for ( var key in this._actorList ) {
			var actor = this._actorList[key];
			if ( !(actor instanceof PlayerActor )) {
				//zombies need this update
				actor.schedule( actor.farmUpdate, 0, "farmUpdate" );
			} else {
				actor.scheduleUpdate();
			}
		}
		
		for( var key in this._farmActors ) {
			var actor = this._farmActors[key];
			actor._state = StageActor.stageActorState.kStageActorStateSpawn;
			actor.scheduleUpdate();
		}
		this.schedule(this.updateAnimations, 10, "updateAnimations");
	},
	
	updateAnimations: function()
	{	
		this.updateAnimations2();
		return;
		
		if(this._actorList.length < 10){
			return;
		}
		for (var key in this._actorList) {
			var actor = this._actorList[key];
			if( !actor ) {
				continue;
			}
			if ( actor instanceof ZombieActor ) {
				if(GameState._zfGameData._zombiePatchOn){
					if(actor._brainState == kActorBrainStateAtHome){
						actor.stopZombieAnimation();
					}			
					continue;
				}
				else{
					//zombies need this update	
					if(Math.random() < 0.6){
						actor.schedule( actor.farmUpdate, 0, "farmUpdate");
					}
					else{
						actor.stopZombieAnimation();
						actor.startAnim(kActorAnimIdle, true);
					}
				}
			}
		}
	},
	
	updateAnimations2: function()
	{	
		var MIN_ANIMATED = 5;
		if(this._actorList.length <= MIN_ANIMATED){
			//doing nothing
		}else{
			var zombiesAnimated = 0;
			var indexArray = [];
			for (var key in this._actorList)
			{
				if(key == 0) continue; //Skipping PlayerActor
				indexArray.push(key);
			}
			shuffle(indexArray);
			
			function shuffle(o){
				for(var j, x, i = o.length; i; j = parseInt(Math.random() * i), x = o[--i], o[i] = o[j], o[j] = x);
				return o;
			};
			
			for(var key in indexArray)
			{
				var actor = this._actorList[indexArray[key]];
				if(!actor || (actor instanceof PlayerActor)) continue;
				if(GameState._zfGameData._zombiePatchOn){
					if(actor._brainState == kActorBrainStateAtHome){
						actor.stopZombieAnimation();
//						actor.startAnim(kActorAnimSleeping, true);
					}			
					continue;
				} else{
					if(key < MIN_ANIMATED - 1){
						actor.schedule( actor.farmUpdate, 0, "farmUpdate");
					} else{
						actor.stopZombieAnimation();
						if(Math.random() > 0.3)
						{
							actor.startAnim(kActorAnimIdleFarm, true, true);
						}
					}
				}
			}
		}
	},
	
	
	
	animAllZombies : function(initAgain){
		for (var key in this._actorList) {
			var actor = this._actorList[key];
			if( !actor ) {
				continue;
			}
			
			if ( !(actor instanceof PlayerActor )) {
				//zombies need this update
				actor.schedule(actor.farmUpdate, 0, "farmUpdate");
			}
		}
		this.unschedule(this.updateAnimations);
		
		if(initAgain)
			this.schedule(this.updateAnimations, 10, "updateAnimations");
	},
	
	
	spawnStageActorWithDictionary_fromObject: function( actorDictionary , sender ) // NSDictionary*, id
	{
		var actor = StageActor.stageActorWithDictionary( actorDictionary );
		
		if ( sender )
		{
			sender.addChild( actor._spriteMan , actorDictionary["z"] );
			sender.addChild( actor , actorDictionary["z"] );
			// TODO : to be bone during particles.
			//[sender addChild:actor.constantParticleNode z:[[actorDictionary objectForKey:@"z"]intValue]];
			//[sender addChild:actor.particleNode z:[[actorDictionary objectForKey:@"z"]intValue]];
			
		}
			
		sender.addChild( actor._fightData._lifeBG , 200 );
		sender.addChild( actor._fightData._lifeBar , 202 );
		sender.addChild( actor._fightData._lifeBarTemp , 201 );
		
		actor.initAfterAttachingToScene();
		
		return actor;
	},
	
	spawnFightActor: function(className, point, sender, order)
    {
        var actor = this.spawnActor_withClass_atPoint(className , point);
        var actorFightData = new ActorFightData();
        actor._fightData = actorFightData;
        actor._fightData._hitPoints = ZFGameDefines.HITPOINTS_MULTIPLIER * actor._unitDictionary["con"];
        actor._fightData._power = ZFGameDefines.POWER_MULTIPLIER * actor._unitDictionary["str"];
        actor._fightData._attackSpeed = ZFGameDefines.ATTACKSPEED_MULTIPLIER / actor._unitDictionary["dex"]; //dex is # of attacks in 2 seconds
        
        if (sender)
        {
            sender.addChild(actor, order);
            sender.addChild(actor._spriteMan, order);
        }
        
        actor.initFightDataAfterLoad();
        
        sender.addChild(actor._fightData._lifeBG, 200);
        sender.addChild(actor._fightData._lifeBar, 202);
        sender.addChild(actor._fightData._lifeBarTemp, 201);
        
        actor.movementUpdate(0.03);
        return actor;
    },
    
	spawnActorsInSpawnQueue: function()
	{
		this._spawningSpawnQueue = true;

		for ( key in this._spawnQueue )
		{
			var actor = this._spawnQueue[ key ];
			//Actor* newActor = [self spawnFarmActor:actor.type withSubType:actor.subType onTile:actor.farmData.currentTile withUnitKey:actor.unitKey];
	        
	        var newActor = null;
	        
	        if ( actor.classname == "StageActor" )
	        {
	        	// TODO : Does this work ? ObjectiveC was requiring a cast. 
	            var stageActor = actor;
	            
	            // Maybe change ._key by .classname
	            newActor = this.spawnStageActor_onTile( stageActor.classname , actor._farmData._currentTile );
			}
	        else
	        {
//	        	console.log(actor);
	            newActor = this.spawnFarmActor_onTile( actor.classname , actor._farmData._currentTile );
	        }
			
			//overwrite with saved data
	        if ( newActor )
	        {
	        	this.copyActorPropertiesFromActor_toActor( actor , newActor );
	        }
		}

		this._spawnQueue = null;
		this._spawnQueue = new Array();
		this._spawningSpawnQueue = false;
	},
	
	copyActorPropertiesFromActor_toActor: function( a1 , a2 )
	{
		if ( a1._farmData )
		{
			var gs = GameState;
			var currentCoordinates = a1._farmData._currentTile;	
			currentCoordinates.setX( (currentCoordinates._x > gs._zfGameData._mapSize) ? gs._zfGameData._mapSize-1 : currentCoordinates._x );
			currentCoordinates.setY( (currentCoordinates._y > gs._zfGameData._mapSize) ? gs._zfGameData._mapSize-1 : currentCoordinates._y );
			a2._farmData._currentTile = currentCoordinates;
			a2._farmData._destinationTile = a1._farmData._destinationTile;
			a2._farmData._myHomeTile = a1._farmData._myHomeTile;
		}
		
		if ( 		a1._state == kActorStateWalking 
				|| 	a1._state == kActorStateWorking )
		{
			a2._state = kActorStateIdle;
		}
		else
		{
			a2._state = a1._state;
		}
		if( a1 instanceof StageActor )
		{
			a2._key = a1._key;
			// TODO : check state enum.
			a2._state = a2.stageActorStates.kStageActorStateSpawn;
		}
		
		a2._brainState = a1._brainState;
		a2._flags = a1._flags;
		a2._eatDate = a1._eatDate;
		a2._fights = a1._fights;
		a2._savedColor = a1._savedColor; 
		a2.resetColor();
		a2._hunger = a1._hunger;
		a2._fights = a1._fights;
		
		if ( a1 instanceof ZombieActor )
		{
			a2._name = a1._name;
		}

		if(typeof a2.addMutation === 'function')
		{
			a2.addMutation( a1._flags );
		}
	
		if ( !CGPointEqualToPoint(a2._farmData._myHomeTile, ccp(-1,-1) ) )
		{			
			var patch = ZFTileManager.getZombiePatchAtTile(a2._farmData._myHomeTile);
			
			if (patch)
			{
				patch.loadInhabitant(a2);
			}
		}
	},
	
	despawnActor: function( actor ) // *StageActor
	{
		actor.despawn();
	},
	
	despawnFarmActor: function( actor )
	{
		//release actor
		if ( actor._brainState == kActorBrainStateAtHome )
		{
			var patch = ZFTileManager.getZombiePatchAtTile( actor._farmData._myHomeTile );
			if(patch)
			patch.evictInabitant( actor );
		}
		
		actor.unscheduleUpdate();
		actor.unscheduleAllSelectors();
			
		this.despawnActor( actor );
		this._actorList.splice( this._actorList.indexOf(actor),1 );
		ZFGuiLayer.gui().updateArmySize();
	},
	
	getAverageHunger: function()
	{
		var cummulativeHunger = 0;
		var zombieCt = 0;
		for (var actorKey in this._actorList)
		{
			var actor = this._actorList[actorKey];
			if (actor instanceof ZombieActor)
			{
				cummulativeHunger += actor._hunger;
				zombieCt++;
			}
		}
		
		if (zombieCt)
		{
			var res = cummulativeHunger / zombieCt;
			return res;
		}
		else 
		{
			return 0;
		}
	},
	
	makeAllZombiesHungry: function()
	{
		for (var actorKey in this._actorList)
		{
			var actor = this._actorList[actorKey];
			if (actor instanceof ZombieActor )
			{
				actor._eatDate = Core.Time.getRealTime()/1000 - ZFGameDefines.ZOMBIE_HUNGER_DURATION;
				actor.setHunger();
				actor.setThought(ZombieActor.zombieThoughts.kZombieThoughtBrains);
			}
		}
	},
	
	makeAllZombiesFull: function()
	{
		// Remove Hunger and make em smile
		for (actorKey in this._actorList)
		{
			var actor = this._actorList[actorKey];
			if (actor instanceof ZombieActor )
			{
				actor._eatDate = Core.Time.getRealTime()/1000;
				actor.setThought(ZombieActor.zombieThoughts.kZombieThoughtSmile);
			}
		}
	},
	
	incrementAllZombiesFightCount: function()
	{
		for (var actorKey in this._actorList)
		{
			var actor = this._actorList[actorKey];
			if (actor instanceof ZombieActor)
			{
				actor._fights++;
			}
		}
		
		var gs = GameState;
		
		var preUnlockCheck = false;
		var postUnlockCheck = false;
		
		preUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievementAllMasters);
		ZFAchievementChecker.checkAllMasters();
		postUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievementAllMasters);
		
		if (preUnlockCheck != postUnlockCheck)
		{
			/* Unlock Achievement through Facebook */
			var gui = ZFGuiLayer.gui();
			gui.publishAchievement("com.zombiefarm.fight.all_masters", "com.zombiefarm.fight.all_masters.description", "com.zombiefarm.fight.all_masters.image");
			/////////////////////////////////////////
		}
		
		preUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievementAllVeterans);
		ZFAchievementChecker.checkAllVeterans();
		postUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievementAllVeterans);
	
		if (preUnlockCheck != postUnlockCheck)
		{
			/* Unlock Achievement through Facebook */
			var gui = ZFGuiLayer.gui();
			gui.publishAchievement("com.zombiefarm.fight.all_veterans", "com.zombiefarm.fight.all_veterans.description", "com.zombiefarm.fight.all_veterans.image");
			/////////////////////////////////////////
		}

		preUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievement10FightZombie);
		ZFAchievementChecker.checkZombieFights10();
		postUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievement10FightZombie);
		
		if (preUnlockCheck != postUnlockCheck)
		{
			/* Unlock Achievement through Facebook */
			var gui = ZFGuiLayer.gui();
			gui.publishAchievement("com.zombiefarm.fight.10_fight_zombie", "com.zombiefarm.fight.10_fight_zombie.description", "com.zombiefarm.fight.10_fight_zombie.image");
			/////////////////////////////////////////
		}
	},
//	
	doesActorTypeExistOnFarm: function( classname )
	{
		for( var zKey in this._actorList)
		{
			var z = this._actorList[zKey];
			if( z.classname == classname )
			{
				return true;
			}
		}
		
		return false;
	},
	
	doesActorTypeExistInStorage: function( classname )
	{
		for( var zKey in this._zombieStorage)
		{
			var z = this._zombieStorage[zKey];
			if( z.classname == classname )
			{
				return true;
			}
		}
		
		return false;
	},
	
	doesActorTypeExistAnywhere: function( classname )
	{
		if (		this.doesActorTypeExistOnFarm( actorClass )
				||  this.doesActorTypeExistInStorage( actorClass ) )
		{
			return true;
		}
		
		return false;
	},

	addZombieToStorage_atSlot: function( z , slot ) // ZombieActor*, int
	{	
		if (	slot >= this._zombieStorage.length || slot < 0)
		{
			console.log( "BAD: addZombieToStorage slot OOB" );
			return;
		}
				
		// copy actor
		var copy = z.copyWithZone(null);
//		copy._eatDate = z._eatDate;
//		copy._hunger = z._hunger;
//		copy._fights = z._fights;
//		copy._savedColor = z._savedColor;
//		copy._name = z._name;
//		copy._flags = z._flags;
		
		this._zombieStorage[ slot ] = copy; 
		
		this.despawnFarmActor( z );
	},

	
	getZombieFromStorageSlot: function( slot ) // int
	{
		var storedZombie = this._zombieStorage[ slot ];
		
		if( storedZombie instanceof ZombieActor )
		{
			return storedZombie;
		}
		
		return null;
	},
	
	getZombieFromStorage_toTile: function( slot , tileCoordinates ) // int, CGPoint
	{
		if (slot < 0 || slot >= this._zombieStorage.length )
		{
			console.log( "BAD: getZombieFromStorage slot OOB");
			return null;
		}
		
		var z = this._zombieStorage[ slot ];
		var newZombie = this.spawnFarmActor_onTile( z.classname , tileCoordinates );
		this.copyActorPropertiesFromActor_toActor( z , newZombie );
		this._zombieStorage[slot] = null;
		
		return newZombie;
	},
	
	despawnActorsInActorList: function()
	{
		for ( var actorKey in this._actorList )
		{
			var actor = this._actorList[actorKey];
			actor.despawn();
		}
	},
	
	despawnFarmActors: function()
	{
//		console.log("ZFActorManager.despawnFarmActors");
		for ( var actorKey in this._farmActors )
		{
			var actor = this._farmActors[actorKey];
			actor.despawn();
		}
	},
	
	destroy: function()
	{
		this.despawnActorsInActorList();
		this.despawnFarmActors();
		
		this._unitStats.length = 0;
		this._unitStats = null;
		
		this._actorList.length = 0;
		this._actorList = null;
		
		this._spawnQueue.length = 0;
		this._spawnQueue = null;
		
		for (var key1 in this._stageActorDictionaries) {
			var dict = this._stageActorDictionaries[key1];
			for (var key2 in dict) {
				delete dict[key2];
			}
			delete this._stageActorDictionaries[key1];
		}
		this._stageActorDictionaries = null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/ZFGuiLayer'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/ZFGuiLayer'] || {}; $MODULE_REGISTRY['Code/Game/GUI/ZFGuiLayer'] = exports; var ZFProgressBar = require('Code/Game/GUI/GuiLayer/ZFProgressBar').ZFProgressBar; 
var ZFToolsLayer = require('Code/Game/GUI/GuiLayer/ZFToolsLayer').ZFToolsLayer;
var ZFGameFlags = require('Code/Game/ZFGameFlags').ZFGameFlags;
var ZFGameAction = require('Code/Game/Tools/ZFGameAction').ZFGameAction;
var ZFScrollingText = require('Code/Game/GUI/GuiLayer/ZFScrollingText').ZFScrollingText;
var ZFFightMan = require('Code/Game/FightGameScene/ZFFightMan').ZFFightMan;
var ZFAlertWindowGoldenDice = require('Code/Game/GUI/AlertWindows/ZFAlertWindowGoldenDice').ZFAlertWindowGoldenDice;

exports.ZFGuiLayer = CCLayer.singleton(
{
	classname: 'ZFGuiLayer',

	$guiTags:
	{
		kGuiTagAlertWindow : 0,
		kGuiTagPlayerProgressBar : 1,
		kGuiTagAtlasSpriteManager : 2,
		kGuiTagToolLabel : 3,
		kGuiTagScrollingText : 4,
		kGuiTagInvasionAlertTag : 5,
		kGuiTagInvasionNotHungryTag : 6,
		kGuiTagInvasionUseInstaHungerTag : 7,
	    kGuiTagInvasionUseInvasionVoucher : 8,
		kGuiTagInvasionUseRegrowth : 9,
		kGuiTagInvasionLabelTag : 10,
		kGuiTagAlertWindowPitch : 11,
		kGuiTagAlertWindowPitch0 : 12,
		kGuiTagAlertWindowPitch1 : 13,
		kGuiTagAlertWindowPitch2 : 14,
		kGuiTagAlertWindowPitch3 : 15,
		kGuiTagAlertWindowPitch4 : 16,
		kGuiTagAlertWindowPitch5 : 17,
		kGuiTagAlertWindowPitchLast : 18,
		kGuiTagAlertWindowPitchSprite : 19,
		kGuiTagAlertWindowPitchEmitter : 20,
		kGuiTagAlertWindowLevelUp : 21,
		kGuiTagAlertWindowSurpriseBrain : 22,
		kGuiTagPitchBlackOut : 23,
		kGuiTagScreenshotLayer1 : 24,
		kGuiTagFBManLayer1 : 25,
		kGuiTagScreenCapFacebookUploadFailTag : 26,
		kGuiTagScreenCapEmailAccountFailTag : 27,
		kGuiTagInGameMenu : 28,
		kGuiTagBGMgr : 29,
		kGuiTagBG : 30,
		kGuiTagWeather : 31,
		kGuiTagAchievementBox : 32	
	},
	
	inGameMenuTapped: function()
	{
//		console.log("inGameMenuTapped");

		//TODO ZFQuestMenu
		if(/*ZFQuestMenu.questMenu().isMenuEnabled() ||*/ this._inGameMenu.isMenuEnabled())
		{
			return; //prevent overlapping with questMenu and multitapping ingamemenu
		}

		this._inGameMenu.openMenu();
	},
	
	currencyTapped : function(id)
	{
	    var market = ZFMarketMenu;
	    market._category = "brain";
	    market._subCategory = "brain";
	    market.openMenuWithPage(0);
	    
	},
	
	showEnemyMenu: function(sender)
	{
		this._toolsLayer.closeToolMenu();
		var w = new Core.Size(UI.Window._height, UI.Window._width);
		var gs = GameState;
		var interval = ZFGameDefines.INVASION_INTERVAL;
		var cur = gs.curArmySize();
		var max = gs.maxArmySize() / 2.0;
		
		if (cur < max)
		{
			this.displayToolTip(NSLocalizedString("Need more zombies"), NSLocalizedString("You need at least 8 zombies to invade"));
			return;

		}
		
		if (Math.abs(gs._zfGameData._lastInvasionDate - Core.Time.getRealTime()/1000) <= interval)
		{
			if (gs._zfGameData._level >= 5)
			{ 
				var aw = this.displayAlertSimpleChoice(
						NSLocalizedString("Can't Invade Yet"),
						NSLocalizedString("Would you like to use\nInvasion Voucher\nto skip the timer and invade now?"),
						CCSprite.spriteWithFile("stex0050.png"),
						CGRectMake((w._width - 480) / 2, w._height - (w._height - 180) / 2, 480, 220));
				aw._delegate = this;
				aw._idTag = this.guiTags.kGuiTagInvasionUseInvasionVoucher;
			}
			else
			{
			    this.displayToolTip(NSLocalizedString("You cannot invade yet"));
			}
			
			// Comment this to make the zombies not invade 
			return;

		}
		
		this.prepareEnemyMenu();
		this.hideInvasionMenu(sender);
		var actionTo1 = CCMoveTo.actionWithDuration(0.5, ccp(0.0, this._enemyMenu.getPosition()._y));
		this._enemyMenu.runAction(actionTo1);
		
		for (var item in this._enemyMenu._children)
		{
			item.isEnabled = true;
		}
	},
	
	$gui: function()
	{
		if (!this._initialized) {
			this.init();
			this._initialized = true;
		}
		return this;
	},
	
	$guiCheck: function() 
	{ 	
	    return this._initialized;
	},
	
	init: function()
	{	    
//		console.log("GUI initialize");

			this._widthScale = UI.Window._width / 480.0; 
			this._heightScale = UI.Window._height / 320.0;
			
			this._windowHeight = UI.Window._height;
		
			var winSize = new Core.Size(UI.Window._width, UI.Window._height);
			
			this._myScale = new Core.Vector(1.5,1.5);//CCDirector.zoomValue();
			
//			this._heightScale = 1;
//			if (this._widthScale > 1)
//			{
//				this._heightScale  = 1.5;
//			}
		
			this._fightGameScene = null;
			
			var menuFontSize = 12;
			this._disableMenusRefCount = 0;
			var menuFontName = "AmericanTypewriter-Bold";
			//TODO var path = [[NSBundle mainBundle] bundlePath];
			//TODO var finalPath = [path stringByAppendingPathComponent:@"Enemies.plist"];
			var bitmapFntName = "ABD26.fnt";
			
            this.initCallback();
					
//			///// MY bg layer /////
            this._space = 20;
			var hudBG = new CCLayer();
			var goldIcon = new CCSprite();
			var brainIcon = new CCSprite();
			var zombieIcon = new CCSprite();
			var lifeForceIcon = new CCSprite();
	        var levelIcon = new CCSprite();
	 
	        
	        if (this._widthScale>1)
			{
//	            levelIcon.initWithFile_rect("uIBars.png", new Core.Rect(29, 69, 29 , 28));
//	            goldIcon.initWithFile_rect("uIBars.png", new Core.Rect(3, 69, 24, 23));
//	            brainIcon.initWithFile_rect("uIBars.png", new Core.Rect(0, 45, 28, 22));
//	            zombieIcon.initWithFile_rect("uIBars.png", new Core.Rect(4, 94, 23, 24));
//	            lifeForceIcon.initWithFile_rect("uIBars.png", new Core.Rect(29, 45, 23, 22));
	        	
	            levelIcon.initWithFile_rect("uIBars.png", new Core.Rect(42, 103, 58 , 44));
	            goldIcon.initWithFile_rect("uIBars.png", new Core.Rect(5, 103, 37, 36));
	            brainIcon.initWithFile_rect("uIBars.png", new Core.Rect(0, 67, 47, 36));
	            zombieIcon.initWithFile_rect("uIBars.png", new Core.Rect(4, 140, 37, 37));
	            lifeForceIcon.initWithFile_rect("uIBars.png", new Core.Rect(46, 70, 33, 32));

	            levelIcon.setAnchorPoint(new Core.Vector(0, 0.5));
	            brainIcon.setAnchorPoint(new Core.Vector(1.3, 0.5));
	            zombieIcon.setAnchorPoint(new Core.Vector(1.3, 0.5));
	            lifeForceIcon.setAnchorPoint(new Core.Vector(1.2, 0.5));
	            goldIcon.setAnchorPoint(new Core.Vector(1.4, 0.5));
	            
//	            levelIcon.setScale(this._myScale);
//	            goldIcon.setScale(this._myScale);
//	            brainIcon.setScale(this._myScale);
//	            zombieIcon.setScale(this._myScale);
//	            lifeForceIcon.setScale(this._myScale);
	        }
	        else
	        {	        	     
	        	goldIcon.initWithFile("gold.png");
	        	brainIcon.initWithFile("brain.png");
	        	zombieIcon.initWithFile("smallZombieIcon.png");
	        	lifeForceIcon.initWithFile("lifeForce.png");

	        	goldIcon.setAnchorPoint(new Core.Vector(1,0.5));
	        	brainIcon.setAnchorPoint(new Core.Vector(1, 0.5));
	        	zombieIcon.setAnchorPoint(new Core.Vector(1, 0.5));
	        	lifeForceIcon.setAnchorPoint(new Core.Vector(1.4, 0.5));
	        }
	        			
			var iconOffset = 0;
			var _offset =8 * this._widthScale;
			
			
			if (this._widthScale > 1)
			{
				iconOffset = (78-30) * this._widthScale;	//width of brains bar, plus some space
				
				goldIcon.setPosition(new Core.Vector(this._space + 60 * this._widthScale, this._windowHeight - 10 * this._heightScale - 3));
				brainIcon.setPosition(new Core.Vector(this._space + 60 * this._widthScale + 8, this._windowHeight - 32 * this._heightScale - 3));
				zombieIcon.setPosition(new Core.Vector(this._space + 60 * this._widthScale + 180, this._windowHeight - 10 * this._heightScale - 3));
				lifeForceIcon.setPosition(new Core.Vector(this._space + 155 * this._widthScale + 150, this._windowHeight - 10 * this._heightScale - 3));
			}
	        else 
	        {
	        	goldIcon.setPosition(new Core.Vector(57 * this._widthScale, this._windowHeight - 10 * this._heightScale));
	        	brainIcon.setPosition(new Core.Vector(57 * this._widthScale, this._windowHeight - 30 * this._heightScale));
	        	zombieIcon.setPosition(new Core.Vector(138 * this._widthScale + iconOffset, this._windowHeight - 10 * this._heightScale));
	        	lifeForceIcon.setPosition(new Core.Vector(215 * this._widthScale + iconOffset, this._windowHeight - 10 * this._heightScale));
			}
			
	        //gold icon + bg
			
			var targetBrain = new GL2.TouchTarget();
			var targetGold = new GL2.TouchTarget();
			var listener = new Core.MessageListener();
			targetBrain.getTouchEmitter().addListener(listener, this.currencyTapped.bind(this));
			targetGold.getTouchEmitter().addListener(listener, this.currencyTapped.bind(this));
			
	        var iconBG = new CCSprite();
	        
	        if (this._widthScale > 1)
			{
	        	iconBG.initWithFile_rect("uIBars.png", new Core.Rect(0, 1, 181, 33));
	        	iconBG.setScale(0.7, 1);
	        }
	        else
        	{
	        	iconBG.initWithFile_rect("hudElements.png", new Core.Rect(414 + 10, 269, 78 - 10, 17));
        	}
			
	        iconBG.addChild(targetGold);
	        
	        var iconBGposition = new Core.Vector(goldIcon.getPosition()._x - _offset -  14, goldIcon.getPosition()._y);
	        iconBG.setPosition(iconBGposition);
	        iconBG.setAnchorPoint(new Core.Vector(0, 0.5));
	        targetGold.setAnchor(new Core.Point(0.5, 0.5));

	        hudBG.addChild(iconBG);
	        hudBG.addChild(goldIcon);
	        
	        targetGold.setSize(iconBG.getSize());
	        targetGold.setPosition(targetGold.getPosition()._x + goldIcon.getSize()._width, targetGold.getPosition()._y);
	        
	        //brain icon + bg
	        var iconBG2 = new CCSprite();
	        
	        if (this._widthScale > 1)
			{
	        	iconBG2.initWithFile_rect("uIBars.png", new Core.Rect(0,34,125,31));
	        	iconBG2.setScale(0.7, 1);
	        }
	        else
        	{
	        	iconBG2.initWithFile_rect("hudElements.png", new Core.Rect(414 + 30, 269, 78 - 30, 17));
        	}
	        
	        iconBG2.addChild(targetBrain);
	        iconBG2.setAnchorPoint(new Core.Vector(0, 0.5));
	        targetBrain.setAnchor(new Core.Point(0.5, 0.5));
	        iconBG2.setPosition(new Core.Vector(brainIcon.getPosition()._x - _offset - 15, brainIcon.getPosition()._y));
	        iconBG2.setDepth(0);
	        hudBG.addChild(iconBG2);
	        
	        hudBG.addChild(brainIcon);
	        brainIcon.setDepth(3);
             
	        targetBrain.setSize(iconBG2.getSize());
	        targetBrain.setPosition(targetBrain.getPosition()._x + brainIcon.getSize()._width, targetBrain.getPosition()._y);
	        

	        //zombie icon + bg
//			// lower bar size +20
	        var iconBG3 = new CCSprite();
	        if (this._widthScale > 1)
			{
	         	iconBG3.initWithFile_rect("uIBars.png", new Core.Rect(0,34,125,31));
	         	iconBG3.setScale(0.7, 1);
	        }
	        else
        	{
	        	iconBG3.initWithFile_rect("hudElements.png", new Core.Rect(414 + 25, 269, 78 - 25, 17));
        	}
	        
	        iconBG3.setPosition(new Core.Vector(zombieIcon.getPosition()._x - _offset - 10, zombieIcon.getPosition()._y));
	        iconBG3.setAnchorPoint(new Core.Vector(0, 0.5));
	        iconBG3.setDepth(0);
	        hudBG.addChild(iconBG3);
	        
	        
	        hudBG.addChild(zombieIcon);
	        zombieIcon.setDepth(3);
			
	        //lifeForce Icon + bg
//			// life force bg and life force percentage bar
	        var iconBG4 = new CCSprite();	      
	        if (this._widthScale>1)
			{
	        	iconBG4.initWithFile_rect("uIBars.png", new Core.Rect(0,34,125,31));
		        iconBG4.setPosition(new Core.Vector(lifeForceIcon.getPosition()._x - _offset - 5, lifeForceIcon.getPosition()._y));
		        iconBG4.setScale(0.7, 1);
	        }
	        else
        	{
	        	iconBG4.initWithFile_rect("hudElements.png", new Core.Rect(414 + 33, 269, 78 - 33, 17));
		        iconBG4.setPosition(new Core.Vector( lifeForceIcon.getPosition()._x - _offset - 3, lifeForceIcon.getPosition()._y));
        	}


	        iconBG4.setAnchorPoint(new Core.Vector(0, 0.5));
	        iconBG4.setDepth(0);
	        hudBG.addChild(iconBG4);
	        
	        hudBG.addChild(lifeForceIcon);
	        lifeForceIcon.setDepth(3);
	        
	        //------------------------------------------------
	        var iconStartCap = CCSprite.spriteWithFile(ZFGameDefines.HUDELEMENTS1_FILE, CGRectMake(414,269,10,17));
			var iconBar = CCSprite.spriteWithFile(ZFGameDefines.HUDELEMENTS1_FILE, CGRectMake(424,269,64,17));
			var iconEndCap = CCSprite.spriteWithFile(ZFGameDefines.HUDELEMENTS1_FILE, CGRectMake(482,269,10,17));
		    
			iconStartCap.setAnchorPoint(0, 0.5);
			iconEndCap.setAnchorPoint(0, 0.5);
			iconBar.setAnchorPoint(0, 0.5);
		    
		    if(this._widthScale > 1){
		    	
		    	iconStartCap = CCSprite.spriteWithFile("uIBars.png", new Core.Rect(0,34,125,31));
		        iconEndCap = CCSprite.spriteWithFile("uIBars.png", new Core.Rect(0,34,125,31));
		    	
//			    iconStartCap.setScale(this._myScale);
//		    	iconEndCap.setScale(this._myScale);
		    	
		    	iconStartCap.setFlipX(true);
		    	
		    	iconStartCap.setPosition(new Core.Vector(this._space + 350 * this._widthScale + 20, lifeForceIcon.getPosition()._y));
		    	iconEndCap.setPosition(new Core.Vector(this._space + 350 * this._widthScale + 20 + 42 + iconStartCap.getSize()._width, lifeForceIcon.getPosition()._y));
		    	//iconBar.setPosition(new Core.Vector( lifeForceIcon.getPosition()._x + 240 - _offset - 3, lifeForceIcon.getPosition()._y));
		    	
//		    	hudBG.addChild(iconStartCap, 0);
//		        hudBG.addChild(iconEndCap, 0);
		    }else{
		    	iconStartCap.setPosition(new Core.Vector( lifeForceIcon.getPosition()._x + iconBG4.getSize()._width + 130 - _offset - 3, lifeForceIcon.getPosition()._y));
		    	iconEndCap.setPosition(new Core.Vector( lifeForceIcon.getPosition()._x + iconBG4.getSize()._width + 204 - _offset - 3, lifeForceIcon.getPosition()._y));
		    	iconBar.setPosition(new Core.Vector( lifeForceIcon.getPosition()._x + iconBG4.getSize()._width + 140 - _offset - 3, lifeForceIcon.getPosition()._y));
		    	//iconBar.setPosition(new Core.Vector( lifeForceIcon.getPosition()._x + 240 - _offset - 3, lifeForceIcon.getPosition()._y));
//		    	hudBG.addChild(iconStartCap, 0);
//		        hudBG.addChild(iconEndCap, 0);
//		        hudBG.addChild(iconBar, 0);
		    }
		    
		   
	        
	        var activePlayer = PlayerProfileManager.playerProfileManager()._activePlayer;
	        var gs = GameState;
	        var farmOwnerString = null;
		    gs._zfGameData._farmOwner = activePlayer.playerProfileAlias();
			farmOwnerString = gs._zfGameData._farmOwner;
			
//			var session = null;
//			if(Social.US) 
//			{ 
//				session = Social.US.Session.getCurrentSession();
//			}
//			else
//			{
//				console.log('///ZFGuiLayer.init: Session not available in current API.');
//			}
//			
//			if (session)
//			{
//			    var gamerTag = session.user().gamertag;
//			    if ( gamerTag )
//			    {
//	                farmOwnerString = gamerTag;
//			    }
//			}
//			else
//			{
//			    farmOwnerString = "Zombie Farmer";
//			}

			//COMMENTED BECAUSE GAMERTAG IS NO MORE SHOWED
//			Social.Common.People.getCurrentUser(null, function(error, user){
//				if(error){
//					console.log('///ZFGuiLayer.init: Social.Common.People.getCurrentUser failed: ' + error.description);
//				} else {
//					this.setFarmOwner(user, iconStartCap);
//				}
//			}.bind(this));

		
	        
//	        if (this._widthScale > 1)
//			{
//	        	this._percentBar = new CCSprite();
//	        	this._percentBar.initWithFile_rect("uIBars.png", new Core.Rect(104,45,1,21));
//	        	var bgPos = new Core.Vector(iconBG4.getPosition()._x + 2, iconBG4.getPosition()._y);
//	        	this._percentBar.setPosition(bgPos);
//	        	
////	            percentBar.scaleX = 1.f;
//            
//	        	this._percentCap = new CCSprite();
//	        	this._percentCap.initWithFile_rect("uIBars.png", new Core.Rect(110,45,12,21));
//	        	var pos = new Core.Vector(this._percentBar.getPosition()._x + 33, this._percentBar.getPosition()._y);
//	        	this._percentCap.setPosition(pos);
//	        	this._percentCap.setAnchorPoint(new Core.Vector(0,0.5));
//	        	
//	        	this._percentBar.setAnchorPoint(new Core.Vector(0.5,0.5));
//	        	this._percentCap.setAnchorPoint(new Core.Vector(0.5,0.5));
//	        	
//	        	hudBG.addChild(this._percentCap, 1);
//	        	hudBG.addChild(this._percentBar, 1);	        	
//	        }
//	        else
	        {
	        	this._percentBar = CCColorLayer.layerWithColor(new Core.Color(1,1,1), 34, 13*this._heightScale);
	        	var bgPos = new Core.Vector(iconBG4.getPosition()._x - 3, iconBG4.getPosition()._y);
	        	this._percentBar.setPosition(bgPos);
	        	this._percentBar.setScale(this._widthScale, this._heightScale);
	        	this._percentCap = new CCSprite();
	        	this._percentCap.initWithFile_rect("hudElements.png", new Core.Rect(397, 271, 7,13));
	        	var pos = new Core.Vector(this._percentBar.getPosition()._x + 33 /* TODO * percentBar.scaleX*/, this._percentBar.getPosition()._y);
	        	this._percentCap.setPosition(pos);
	        	this._percentCap.setAnchorPoint(new Core.Vector(0,0.5));
	        	hudBG.addChild(this._percentCap, 1);
	        	hudBG.addChild(this._percentBar, 1);
	        	this._percentCap.setScale(this._widthScale, this._heightScale);
	        }
//			
	        this.addChild(hudBG, 0, this.guiTags.kGuiTagBG);
	        
	        	      
//			////// END my bg layer //////
	        this._playerProgressBar = new ZFProgressBar();
	        this._playerProgressBar._bar.initWithFile("ProgressBar.png");
	        this._playerProgressBar._frame.initWithFile("ProgressBarFrame.png");
	        this._playerProgressBar._frame.setScale(this._widthScale, this._heightScale);
	        

//			if([[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hant"] || [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hans"]||
//			   [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"ja"])
//			{
//				playerProgressBar.text  = [CCLabel labelWithString:@"0%" fontName:@"Arial" fontSize:26];
//			}
//			else
//			{
				//playerProgressBar._text  = [CCBitmapFontAtlas bitmapFontAtlasWithString:@"0%" fntFile:bitmapFntName];
				
//			}

			this._playerProgressBar._text = CCLabel.labelWithString("0", "Arial", 26);
	        //this._playerProgressBar._text.setScale(0.46 * this._heightScale);
	        //this._playerProgressBar.setScale(0.46 * this._heightScale);

	        
	        this._playerProgressBar.addChild(this._playerProgressBar._frame, 0);
	        this._playerProgressBar.addChild(this._playerProgressBar._text, 2);
	        this._playerProgressBar._frame.addChild(this._playerProgressBar._bar, 1);
	        this._playerProgressBar._bar.setPosition(-45, 10);
	        this._playerProgressBar._bar.setScale(0, 1);
	        this._playerProgressBar.setPosition(240, 160);
	        this._playerProgressBar._bar.setAnchorPoint(0, 1);
	        this._playerProgressBar._frame.setAnchorPoint(0.5, 0.5);
	        this._playerProgressBar._text.setAnchorPoint(ccp(0.5, 0.5));
	        this._playerProgressBar._text.setColor(ccc3(255,255,255));
	        this._playerProgressBar.setVisible( false );

	        this.addChild( this._playerProgressBar);
	        this._playerProgressBar.setPosition(ccpAdd(this._playerProgressBar.getPosition(), ccp(100, 0)));
	        
	        if (this._widthScale > 1)
			{
//	        	this._playerProgressBar._text.setScale(ccp(0.66, 0.66));
//	        	this._playerProgressBar._frame.setScale(ccp(1,1));
	        }

//	        var percentBG = new CCSprite();
//	        percentBG.initWithFile("buffCountBorder.png");
//	        var percentBGpos = new Core.Vector(lifeForceIcon.getPosition()._x + 35, lifeForceIcon.getPosition()._y - 10);
//	        percentBG.setPosition(percentBGpos);
//	        percentBG.setScale(1.3, 1);
//	        percentBG.setAnchorPoint(new Core.Vector(0.0, 0.0));
//	        this.addChild(percentBG, 0);
//	        
	       
	        
	        
//			if([[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hant"] || [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hans"]||
//			   [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"ja"])
//			{
//				playersLifeForce = [CCLabel labelWithString:@"0%" fontName:@"Arial" fontSize:26];
//			}
//			else
//			{
				//playersLifeForce = [CCBitmapFontAtlas bitmapFontAtlasWithString:@"0" fntFile:bitmapFntName];
				
//			}
	        
	        this._playersLifeForce = CCLabel.labelWithString("0", "Arial", 26);
			this._playersLifeForce.setPosition( ccpAdd(lifeForceIcon.getPosition(), ccp(0,4)));
			//this._playersLifeForce.setScale(0.46 * this._heightScale);
			this._playersLifeForce.setAnchorPoint(ccp(0,0.3));
			this.addChild(this._playersLifeForce, 2);
			
			this.updateLifeForce();
			
//			if([[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hant"] || [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hans"]||
//			   [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"ja"])
//			{
//				armySize = [CCLabel labelWithString:@"0/16" fontName:@"Arial" fontSize:26];
//			}
//			else 
//			{
//				armySize = [CCBitmapFontAtlas bitmapFontAtlasWithString:@"0/16" fntFile:bitmapFntName];
				
//			}

			this._armySize = CCLabel.labelWithString("0/16", "Arial", 26);
			//this._armySize.setScale(0.46 * this._heightScale);
			this._armySize.setPosition(ccpAdd(zombieIcon.getPosition(), ccp(0, 4)));
			this._armySize.setAnchorPoint(ccp(0,0.3));
			this.addChild(this._armySize);
			
			this.updateArmySize();
//			
//			if([[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hant"] || [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hans"]||
//			   [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"ja"])
//			{
//				playersBrains = [CCLabel labelWithString:@"0" fontName:@"Arial" fontSize:26];
//			}
//			else
//			{
//				playersBrains = [CCBitmapFontAtlas bitmapFontAtlasWithString:@"0" fntFile:bitmapFntName];
				
//			}
			this._playersBrains = CCLabel.labelWithString("0", "Arial", 26);
			//this._playersBrains.setScale(0.46 * this._heightScale);
			this._playersBrains.setAnchorPoint(ccp(0, 0.3));
			this._playersBrains.setPosition(ccpAdd(brainIcon.getPosition(), ccp(3*this._widthScale, 4)));

			this.addChild(this._playersBrains);

			this.updateBrains();
//			
//			if([[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hant"] || [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hans"]||
//			   [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"ja"])
//			{
//				playersGold = [CCLabel labelWithString:@"0" fontName:@"Arial" fontSize:26];
//			}
//			else
//			{
//							
//			}

			this._playersGold = CCLabel.labelWithString("0", "Arial", 26);
			this._playersGold.setPosition( ccpAdd( goldIcon.getPosition(), ccp(3 * this._widthScale, 4) ) );
			//this._playersGold.setScale(0.46 * this._heightScale);
			this._playersGold.setAnchorPoint(ccp(0,0.3));
			
			this.addChild(this._playersGold);
			this.updateGold();
			
//			console.log( "toto ") ;

//			if([[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hant"] || [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hans"]||
//			   [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"ja"])
//			{
//				playersLevel = [CCLabel labelWithString:@"1" fontName:@"Arial" fontSize:26];
//			}
//			else
//			{   
				//playersLevel = [CCBitmapFontAtlas bitmapFontAtlasWithString:@"1" fntFile:bitmapFntName];
				
//			}
			this._playersLevel = CCLabel.labelWithString("1", "Arial", 26);
			//this._playersLevel.setScale(0.5 ); 	
		
//			// xp bar (made up of 2 endcaps with 1 flipped and a scaled horizontal bar)
	        
	        var xpStartCap = new CCSprite();
	        xpStartCap.initWithFile("xpEndCap.png");
	        if(this._widthScale > 1){
	        	xpStartCap.setPosition(this._space + (180 /*- xpStartCap.getSize()._width*/) * this._widthScale + iconOffset + 140, this._windowHeight - 10 * this._heightScale);
	        }else{
	        	xpStartCap.setPosition((260 /*- xpStartCap.getSize()._width*/) * this._widthScale + iconOffset,  goldIcon.getPosition()._y);
	        }
	        
	        xpStartCap.setAnchorPoint(ccp(1,0.5));
	        	
	        
	        xpStartCap.setScale(-1*this._myScale._x,1*this._myScale._y);

	        //  TODO take care about that - original CCSprite have custor setter for scaleX which add some strange macro function... hope we will not need that
//			xpStartCap.scaleX = widthScale;
//			xpStartCap.scaleX = -xpStartCap.scaleX;
//			xpStartCap.scaleY = heightScale;

	        this._playerXPBar = new ZFProgressBar(); 
	        {
	        	this._playerXPBar._frame.initWithFile("xpEndCap.png");
	        	this._playerXPBar._bar.initWithFile("xpBar.png");
	        	//this._playerXPBar._frame.setScale(this._widthScale, this._heightScale);
	        	
	        	this._playerXPBar._bar.setScale(0, 1*this._myScale._y);
	        	this._playerXPBar._bar.setAnchorPoint(ccp(0,0.5));
	        }
	        
	        this.addChild(xpStartCap, 1);
	        

//			if([[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hant"] || [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hans"]||
//			   [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"ja"])
//			{
//				playersXP = [CCLabel labelWithString:@"0" fontName:@"Arial" fontSize:26];
//			}fdfdfdfdfdfdfdfdf
//			else 
//			{
//				playersXP = [CCBitmapFontAtlas bitmapFontAtlasWithString:@"0" fntFile:bitmapFntName];
			if(this._widthScale > 1){
	        	this._playersXP = CCLabel.labelWithString("0", "Arial", 26);
			}else{
				this._playersXP = CCLabel.labelWithString("0", "Arial", 26);
			}
//

	        this._playerXPBar._text = this._playersXP;
	        this._playerXPBar._text.setScale(0.8);
	        
	        this.updateXP();
	        
	        this._playerXPBar._text.setPosition(10, 14);
	        
//	        if (this._widthScale > 1)
//			{
//	        	//this._playersXP.setScale(1);
//	        	this._playerXPBar._text.setPosition(this._space + 33 * this._widthScale - 40, 14);
//	        }
//	        else
//	        {
//	        	//this._playersXP.setScale(0.46);
//	        	this._playerXPBar._text.setPosition(42 * this._widthScale, 14);
//	        }
	        	        	        
	        this._playerXPBar.setPosition(ccpAdd(xpStartCap.getPosition(), ccp(xpStartCap.getSize()._width + this._widthScale, 0 ) ) );

	        this._playerXPBar._bar.setPosition(-1*this._widthScale,0);
	        this._playerXPBar._frame.setPosition(this._playerXPBar._bar.getScale()._x * this._playerXPBar._bar.getSize()._width - this._space * this._widthScale,0);
	        this._playerXPBar._frame.setAnchorPoint(0,0.5);
	        //this._playerXPBar._frame.setScale(this._myScale);
	        this._playerXPBar._frame.setScale(1,this._myScale._y);
	        this._playerXPBar._bar.setScale(1,this._myScale._y);
	        this._playerXPBar.addChild(this._playerXPBar._text, 2);
	        this._playerXPBar.addChild(this._playerXPBar._bar, 1);
	        this._playerXPBar.addChild(this._playerXPBar._frame, 1);
	        this.addChild(this._playerXPBar);
	        
	        this._playerXPBar._text.setAnchorPoint(ccp(0, 0));
		 //   this._playerXPBar._bar.setAnchorPoint(ccp(0, 1));
	        
			this.updateLevel();

			// bg for xp bar
	        var xpBG = new CCSprite();
	        xpBG.setDepth(0);

	        {
	        	 xpBG.initWithFile_rect("hudElements.png", new Core.Rect(397, 248, 114, 20));
	        	 xpBG.setPosition(xpStartCap.getPosition()._x - 1, xpStartCap.getPosition()._y );
	        	 xpBG.setAnchorPoint(0,0.5);
	        	 xpBG.setScale(this._myScale);
	        	 hudBG.addChild(xpBG);
	        }
	        

	        this._playersLevel.setColor(ccc3(0x60, 0x60, 0x60));
	        this._playersLevel.setScale(0.8);
	        this._playersLevel.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);  
	        if(this._widthScale > 1){
	        	this._playersLevel.setPosition( ccpAdd( xpBG.getPosition(), ccp(xpBG.getSize()._width + 40, 4 ) ));
	        }else{
	        	this._playersLevel.setPosition( ccpAdd( xpBG.getPosition(), ccp(xpBG.getSize()._width -13, 4 ) ));
	        }
	         
	      	this._playersLevel.setAnchorPoint(ccp(0.5, 0.3));
	      	//this._playersLevel.setScale(this._myScale);
	      	this.addChild(this._playersLevel, 6);
	      	 
			
	      	this._scrollingText = [];
	      	this._alertWindows = [];
//			flyingCrops = [[NSMutableArray alloc] init];
//
//			// place menu items
//			[CCMenuItemFont setFontSize:menuFontSize + 4.f];
//	        [CCMenuItemFont setFontName:menuFontName];
//			
//			
			
			var returnToMainMenu = new CCMenuItemImage();
			returnToMainMenu.initFromNormalImage("mainMenuButton.png", "mainMenuButton.png", this, this.inGameMenuTapped.bind(this));
			returnToMainMenu.setDepth(1); 
//	        
//	        CCMenuItemLayer *currencyButton = nil;
//	        
//	        
//			if(this._widthScale > 1)
//			{
//            currencyButton = [CCMenuItemLayer itemFromLayer:[CCColorLayer layerWithColor:ccc4(0xff, 0x0, 0x0, 0x0) width:266 height:40]
//            target:self 
//          	selector:@selector(currencyTapped:)];  
			//currencyButton.anchorPoint = ccp(.5f, .25f);
			//shellMenu = [CCMenu menuWithItems:returnToMainMenu, currencyButton, nil];
			//shellMenu.position = ccp(112 + 66, (int)(winSize.height-19*heightScale));
			//[shellMenu alignItemsHorizontallyWithPadding:33.f];
			//shellMenu.anchorPoint = ccp(0.f, 1.f);
//			}
//			else
			{
//	            
//currencyButton = [CCMenuItemLayer itemFromLayer:[CCColorLayer layerWithColor:ccc4(0xff, 0x0, 0x0, 0x0) width:80*widthScale height:40]
//                target:self 
//              selector:@selector(currencyTapped:)]; 
				

				this._shellMenu = CCMenu.menuWithItems([returnToMainMenu/*, currencyButton, null  */]); //shellMenu = [CCMenu menuWithItems:returnToMainMenu, currencyButton, nil];
				this._shellMenu.alignItemsHorizontallyWithPadding(2 * this._widthScale);
				this._shellMenu.setPosition(0,this._windowHeight-returnToMainMenu.getSize()._height);
			}
			
			this.addChild(this._shellMenu, 1);
			
//			//Invasion
			var s1 = new CCSprite();
			var s2 = new CCSprite();
			
			if(this._widthScale > 1)
			{
				s1.initWithFile_rect("hudElements.png", new Core.Rect(1,253,180,50));
				s2.initWithFile_rect("hudElements.png", new Core.Rect(182, 253, 180, 50));
			}
			else 
	        {
				s1.initWithFile_rect("hudElements.png", new Core.Rect(109, 55, 62, 23));
				s2.initWithFile_rect("hudElements.png", new Core.Rect(109, 78, 62, 23));
			}

			var invadeMenuItem = CCMenuItemSprite.itemFromNormalSprite(s1, s2, this, this.showEnemyMenu.bind(this));

			s1.setColor(ZFColorDefines.colorBrownButton);
			s2.setColor(ZFColorDefines.colorBrownButton);

			if(this._widthScale > 1)
			{
				invadeMenuItem.setScale(0.8);
			}

			if(false/*[[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hant"] || [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hans"]||
			   [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"ja"]*/)
			{
				var invadeText = CCLabel.labelWithString(NSLocalizedString("Invade"), "Arial", 26);
				//invadeText.setScale(0.5, 0.5);
	            invadeText.setPosition(invadeMenuItem.getContentSize()._width/2 - 15, invadeMenuItem.getContentSize()._height/2 - 4);
	            
	            invadeText.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
				if (winSize._width > ZFGameDefines.ORIGINAL_WINDOW_WIDTH)
				{
					//invadeText.setScale(invadeMenuItem.getScale());
				}
//				console.log("�������������� A: invadeText.position: " + JSON.stringify(invadeText.getPosition()));
				invadeMenuItem.addChild(invadeText);
			}
			else
			{
//				CCBitmapFontAtlas *invadeText = [CCBitmapFontAtlas bitmapFontAtlasWithString:NSLocalizedString(@"Invade", nil) fntFile:bitmapFntName];
				invadeText = CCLabel.labelWithString(Core.Localization.getString("Invade"), "Arial", 26);
				//invadeText.setScale(0.5);
				invadeText.setPosition(invadeMenuItem.getSize()._width/2 - 15, invadeMenuItem.getSize()._height/2 - 4);
				
				invadeText.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
				if(this._widthScale > 1)
				{
					//invadeText.setScale(0.8);		
				}
//				console.log("�������������� B: invadeText.position: " + JSON.stringify(invadeText.getPosition()));
				invadeMenuItem.addChild(invadeText);
			}

			this._invadeMenu = CCMenu.menuWithItems([invadeMenuItem]);
			
			if(this._widthScale > 1)
			{
				this._invadeMenu.setPosition(new Core.Vector(-6, 2));
			}
			else
			{
				this._invadeMenu.setPosition(new Core.Vector(-62, 0));
			}
			
			//TODO: find why -6 and -62 position doesn't work same like on iphone
			this._invadeMenu.setPosition(new Core.Vector(0, 0)); //temporary fix
			
			invadeMenuItem.isEnabled = false;
			this.addChild(this._invadeMenu, 2, 0);
			

			//Tools
			this._toolsLayer = new ZFToolsLayer();
			this.addChild(this._toolsLayer, 0, 0);			

			//CHEATS
//			var ZFCheats = require('./GuiLayer/ZFCheats').ZFCheats;
//			this._zfc = new ZFCheats();
//			this.addChild(this._zfc._cheatMenu);
//			this._zfc.setup();
			
			this.schedule(this.tick, ZFGameDefines.GUI_UPDATE_INTERVAL, "tick");
			this.schedule(this.updateInvasionLabel, 2.0, "updateInvasionLabel");
			this.showInvasionMenu(this);
			
			//TODO
			//[self initFarmWeather];

		this.enableMenus(false);
	},
	
	setFarmOwner: function(user, iconStartCap){
		var farmOwnerString = null;
		if (user && user.displayName){
			farmOwnerString = user.displayName;
		} else {
			farmOwnerString = "Zombie Farmer";
		}
		
		if (farmOwnerString.length > 17)	//string is too long for the CCLabel, truncate
		{
			farmOwnerString = farmOwnerString.substring(0, 17) + "...";
		}
		
		if(this._widthScale > 1){
			this._farmOwner = CCLabel.labelWithString(farmOwnerString+"", CGSizeMake(120,20), GL2.Text.HorizontalAlign.Center, "Arial", 15);
		}else
		{
			this._farmOwner = CCLabel.labelWithString(farmOwnerString+"", CGSizeMake(120,20), GL2.Text.HorizontalAlign.Center, "Arial", 11);
		}
		this._farmOwner.setAnchorPoint(ccp(0, 0.5));
		
//		hudBG.addChild(this._farmOwner, 1);
		this._farmOwner.setPosition(iconStartCap.getPosition()._x - 50, iconStartCap.getPosition()._y);
		//this._farmOwner.setScale(this._myScale);
	},
	
	initCallback: function()
	{
		var winSize = new Core.Size(UI.Window._width, UI.Window._height);
		this._enemyArray = DataPreloader._enemyData;
		var s1 = null;
		var s2 = null;
		
		//Enemies
		if (winSize._width > ZFGameDefines.ORIGINAL_WINDOW_WIDTH)
		{
			s1 = CCSprite.spriteWithFile(ZFGameDefines.HUDELEMENTS1_FILE, CGRectMake(1,253,180,50));
			s2 = CCSprite.spriteWithFile(ZFGameDefines.HUDELEMENTS1_FILE, CGRectMake(182,253,180,50));
		}
		else {
			s1 = CCSprite.spriteWithFile(ZFGameDefines.HUDELEMENTS1_FILE, CGRectMake(109,55,62,23));
			s2 = CCSprite.spriteWithFile(ZFGameDefines.HUDELEMENTS1_FILE, CGRectMake(109,78,62,23));
		}
		s1.setColor(ZFColorDefines.colorRedButton);
		s2.setColor(ZFColorDefines.colorRedButton);
		var s3 = CCSprite.spriteWithFile(ZFGameDefines.HUDELEMENTS1_FILE, CGRectMake(1,253,180,50));
		var s4 = CCSprite.spriteWithFile(ZFGameDefines.HUDELEMENTS1_FILE, CGRectMake(182,253,180,50));
		s3.setColor(ZFColorDefines.colorBlueButton);
		s4.setColor(ZFColorDefines.colorBlueButton);
		var s5 = CCSprite.spriteWithFile(ZFGameDefines.HUDELEMENTS1_FILE, CGRectMake(1,253,180,50));
		var s6 = CCSprite.spriteWithFile(ZFGameDefines.HUDELEMENTS1_FILE, CGRectMake(182,253,180,50));
		s5.setColor(ZFColorDefines.colorBlueButton);
		s6.setColor(ZFColorDefines.colorBlueButton);
		var s7 = CCSprite.spriteWithFile(ZFGameDefines.HUDELEMENTS1_FILE, CGRectMake(1,253,180,50));
		var s8 = CCSprite.spriteWithFile(ZFGameDefines.HUDELEMENTS1_FILE, CGRectMake(182,253,180,50));
		s7.setColor(ZFColorDefines.colorBlueButton);
		s8.setColor(ZFColorDefines.colorBlueButton);
		var s9 = CCSprite.spriteWithFile(ZFGameDefines.HUDELEMENTS1_FILE, CGRectMake(1,253,180,50));
		var s10 = CCSprite.spriteWithFile(ZFGameDefines.HUDELEMENTS1_FILE, CGRectMake(182,253,180,50));
		s9.setColor(ZFColorDefines.colorBlueButton);
		s10.setColor(ZFColorDefines.colorBlueButton);
		var s11 = CCSprite.spriteWithFile(ZFGameDefines.HUDELEMENTS1_FILE, CGRectMake(1,253,180,50));
		var s12 = CCSprite.spriteWithFile(ZFGameDefines.HUDELEMENTS1_FILE, CGRectMake(182,253,180,50));
		s11.setColor(ZFColorDefines.colorGrayButton);
		s12.setColor(ZFColorDefines.colorGrayButton);
		var s13 = CCSprite.spriteWithFile(ZFGameDefines.HUDELEMENTS1_FILE, CGRectMake(1,253,180,50));
		var s14 = CCSprite.spriteWithFile(ZFGameDefines.HUDELEMENTS1_FILE, CGRectMake(182,253,180,50));
		s13.setColor(ZFColorDefines.colorGrayButton);
		s14.setColor(ZFColorDefines.colorGrayButton);

//		 beach boss
		var s15 = CCSprite.spriteWithFile(ZFGameDefines.HUDELEMENTS1_FILE, CGRectMake(1,253,180,50));
		var s16 = CCSprite.spriteWithFile(ZFGameDefines.HUDELEMENTS1_FILE, CGRectMake(182,253,180,50));
		s15.setColor(ZFColorDefines.colorGrayButton);
		s16.setColor(ZFColorDefines.colorGrayButton);	
		
		var cancelEnemyMenuItem = CCMenuItemSprite.itemFromNormalSprite(s1, s2, this, this.hideEnemyMenu.bind(this));
		var enemyMenuItem1 = CCMenuItemSprite.itemFromNormalSprite(s3, s4, this, this.startInvasion.bind(this, 1));
		var enemyMenuItem2 = CCMenuItemSprite.itemFromNormalSprite(s5, s6, this, this.startInvasion.bind(this, 2));
		var enemyMenuItem3 = CCMenuItemSprite.itemFromNormalSprite(s7, s8, this, this.startInvasion.bind(this, 3));
		var enemyMenuItem4 = CCMenuItemSprite.itemFromNormalSprite(s9, s10, this, this.startInvasion.bind(this, 4));
		var enemyMenuItem5 = CCMenuItemSprite.itemFromNormalSprite(s11, s12, this, this.startInvasion.bind(this, 5));
		var enemyMenuItem6 = CCMenuItemSprite.itemFromNormalSprite(s13, s14, this, this.startInvasion.bind(this, 6));

//		 beach boss
		var enemyMenuItem7 = CCMenuItemSprite.itemFromNormalSprite(s15, s16, this, this.startInvasion.bind(this, 7));
		
		cancelEnemyMenuItem._anchorPoint = CGPointMake(0,0);
		enemyMenuItem1._anchorPoint = CGPointMake(0,0);
		enemyMenuItem2._anchorPoint = CGPointMake(0,0);
		enemyMenuItem3._anchorPoint = CGPointMake(0,0);
		enemyMenuItem4._anchorPoint = CGPointMake(0,0);
		enemyMenuItem5._anchorPoint = CGPointMake(0,0);
		enemyMenuItem6._anchorPoint = CGPointMake(0,0);
		
//		 beach boss
		enemyMenuItem7._anchorPoint = CGPointMake(0,0);
	
				
		var buttonScale = 1;
		var labelScale = (1 / 0.75);
		if (this._widthScale > 1)
		{
			labelScale = 1;
			cancelEnemyMenuItem.setScale(cancelEnemyMenuItem.getScale()._x, 0.75);
			
			buttonScale = 1.2;
//			enemyMenuItem1.setScale(buttonScale);
//			enemyMenuItem2.setScale(buttonScale);
//			enemyMenuItem3.setScale(buttonScale);
//			enemyMenuItem4.setScale(buttonScale);
//			enemyMenuItem5.setScale(buttonScale);
//			enemyMenuItem6.setScale(buttonScale);
//			enemyMenuItem7.setScale(buttonScale);
		}
		else {
			enemyMenuItem1.setScale(enemyMenuItem1.getScale()._x, 0.75);
			enemyMenuItem2.setScale(enemyMenuItem2.getScale()._x, 0.75);
			enemyMenuItem3.setScale(enemyMenuItem3.getScale()._x, 0.75);
			enemyMenuItem4.setScale(enemyMenuItem4.getScale()._x, 0.75);
			enemyMenuItem5.setScale(enemyMenuItem5.getScale()._x, 0.75);
			enemyMenuItem6.setScale(enemyMenuItem6.getScale()._x, 0.75);
			
//			 beach boss
			enemyMenuItem7.setScale(enemyMenuItem7.getScale()._x, 0.75);
			
		}

		
		var eDict = null; //Dict
		var name = null;
		
		//TODO
		if(true/*ZombieFarmAppDelegate.getCurrentLanguage == "zh-Hant" || ZombieFarmAppDelegate.getCurrentLanguage=="zh-Hans" ||
		   ZombieFarmAppDelegate.getCurrentLanguage=="ja"*/)
		{
			var lb = null;
			lb = CCLabel.labelWithString(NSLocalizedString("Cancel"), "Arial", 26);
			lb.setPosition(cancelEnemyMenuItem.getContentSize()._width/2, cancelEnemyMenuItem.getContentSize()._height/2 - 3);
			lb.setScale(0.45, 0.45);
			if (winSize._width > ZFGameDefines.ORIGINAL_WINDOW_WIDTH)
			{
				lb.setScale( lb.getScale()._x, lb.getScale()._y*(1/0.75));
			}
			cancelEnemyMenuItem.addChild(lb);
			
			eDict = this._enemyArray[0];
			name = NSLocalizedString(eDict["name"]);
			lb = CCLabel.labelWithString(name, "Arial", 26*this._myScale._x);
			lb.setPosition(enemyMenuItem1.getContentSize()._width/2, enemyMenuItem1.getContentSize()._height/2);
			lb.setScale(0.45, 0.45 * labelScale);
			enemyMenuItem1.addChild(lb);
			enemyMenuItem1._tag = 1;
			
//			// beach boss (insterted between ol mcdonnell and lawyer stages
			eDict = this._enemyArray[6];
			name = NSLocalizedString(eDict["name"]);
			lb = CCLabel.labelWithString(name, "Arial", 26*this._myScale._x);
			lb.setPosition(enemyMenuItem1.getContentSize()._width/2, enemyMenuItem1.getContentSize()._height/2);
			lb.setScale(0.45, 0.45 * labelScale);
			enemyMenuItem7.addChild(lb);
			enemyMenuItem7._tag = 7;
			
			eDict = this._enemyArray[1];
			name = NSLocalizedString(eDict["name"]);
			lb = CCLabel.labelWithString(name, "Arial", 26*this._myScale._x+7);
			lb.setPosition(enemyMenuItem1.getContentSize()._width/2, enemyMenuItem1.getContentSize()._height/2);
			lb.setScale(0.45, 0.45 * labelScale);
			enemyMenuItem2.addChild(lb);
			enemyMenuItem2._tag = 2;
			
			eDict = this._enemyArray[2];
			name = NSLocalizedString(eDict["name"]);
			lb = CCLabel.labelWithString(name, "Arial", 26*this._myScale._x);
			lb.setPosition(enemyMenuItem1.getContentSize()._width/2, enemyMenuItem1.getContentSize()._height/2);
			lb.setScale(0.45, 0.45 * labelScale);
			enemyMenuItem3.addChild(lb);
			enemyMenuItem3._tag = 3;
			
			eDict = this._enemyArray[3];
			name = NSLocalizedString(eDict["name"]);
			lb = CCLabel.labelWithString(name, "Arial", 26*this._myScale._x);
			lb.setPosition(enemyMenuItem1.getContentSize()._width/2, enemyMenuItem1.getContentSize()._height/2);
			lb.setScale(0.45, 0.45 * labelScale);
			enemyMenuItem4.addChild(lb);
			enemyMenuItem4._tag = 4;
			
			eDict = this._enemyArray[4];
			name = NSLocalizedString(eDict["name"]);
//			name = "Coming Soon";
			lb = CCLabel.labelWithString(name, "Arial", 26*this._myScale._x);
			lb.setPosition(enemyMenuItem1.getContentSize()._width/2, enemyMenuItem1.getContentSize()._height/2);
			lb.setScale(0.45, 0.45 * labelScale);
			lb.setColor(ZFColorDefines.colorGrayButton);
			enemyMenuItem5.addChild(lb);
			enemyMenuItem5._tag = 5;
			
			//FIXME: 
//			name = "Coming Soon";
			eDict = this._enemyArray[5];
			name = NSLocalizedString(eDict["name"]);
			lb = CCLabel.labelWithString(name, s3.getSize(), GL2.Text.VerticalAlign.Middle, "Arial", 26*this._myScale._x);
			lb.setPosition(enemyMenuItem1.getContentSize()._width/2, enemyMenuItem1.getContentSize()._height/2);
			lb.setScale(0.45, 0.45 * labelScale);
			lb.setColor(ZFColorDefines.colorGrayButton);
			enemyMenuItem6.addChild(lb);
			enemyMenuItem6._tag = 6;
			
		}
		else
		{
			var lb = null;
			//TODO: Waiting for creatiom
			lb = CCBitmapFontAtlas.bitmapFontAtlasWithString(NSLocalizedString("Cancel"), bitmapFntName);
			lb.position = ccp(cancelEnemyMenuItem.contentSize.width/2, cancelEnemyMenuItem.contentSize.height/2);
			lb.setScale(0.45, 0.45);
			if (winSize._width > ZFGameDefines.ORIGINAL_WINDOW_WIDTH)
			{
				lb.setSscale(lb.getScale()._x, lb.getScale()._y*(1/0.75));
			}
			cancelEnemyMenuItem.addChild(lb);
			
			eDict = enemyArray[0];
			name = eDict["name"];
			//TODO: Waiting for creatiom
			lb = CCBitmapFontAtlas.bitmapFontAtlasWithString(name, bitmapFntName);
			lb.setPosition(ccp(enemyMenuItem1.getContentSize()._width/2, enemyMenuItem1.getContentSize().getHeight/2));
			lb.setScale(0.45, 0.45 * labelScale);
			enemyMenuItem1.addChild(lb);
			enemyMenuItem1._tag = 1;
			
//			// beach boss (insterted between ol mcdonnell and lawyer stages
			eDict = enemyArray[6];
			name = eDict["name"];
			lb = CCBitmapFontAtlas.bitmapFontAtlasWithString(name, bitmapFntName);
			lb.setPosition(ccp(enemyMenuItem1.getContentSize()._width/2, enemyMenuItem1.getContentSize()._height/2));
			lb.setScale(0.45, 0.45 * labelScale);
			lb.setColor(ZFColorDefines.colorGrayButton);
			enemyMenuItem7.addChild(lb);
			enemyMenuItem7._tag = 7;
			
			eDict = enemyArray[1];
			name = eDict["name"];
			lb = CCBitmapFontAtlas.bitmapFontAtlasWithString(name, bitmapFntName);
			lb.setPosition(ccp(enemyMenuItem1.getContentSize()._width/2, enemyMenuItem1.getContentSize()._height/2));
			lb.setScale(0.45, 0.45 * labelScale);
			enemyMenuItem2.addChild(lb);
			enemyMenuItem2._tag = 2;
			
			eDict = enemyArray[2];
			name = eDict["name"];
			lb = CCBitmapFontAtlas.bitmapFontAtlasWithString(name, bitmapFntName);
			lb.setPosition(ccp(enemyMenuItem1.getContentSize()._width/2, enemyMenuItem1.getContentSize()._height/2));
			lb.setScale(0.45, 0.45 * labelScale);
			enemyMenuItem3.addChild(lb);
			enemyMenuItem3._tag = 3;
			
			eDict = enemyArray[3];
			name = eDict["name"];
			lb = CCBitmapFontAtlas.bitmapFontAtlasWithString(name, bitmapFntName);
			lb.setPosition(ccp(enemyMenuItem1.getContentSize()._width/2, enemyMenuItem1.getContentSize()._height/2));
			lb.setScale(0.45, 0.45 * labelScale);
			enemyMenuItem4.addChild(lb);
			enemyMenuItem4._tag = 4;
			
			eDict = enemyArray[4];
			name = eDict["name"];
			lb = CCBitmapFontAtlas.bitmapFontAtlasWithString(name, bitmapFntName);
			lb.setPosition(ccp(enemyMenuItem1.getContentSize()._width/2, enemyMenuItem1.getContentSize()._height/2));
			lb.setScale(0.45, 0.45 * labelScale);
			lb.setColor(ZFColorDefines.colorGrayButton);
			enemyMenuItem5.addChild(lb);
			enemyMenuItem5._tag = 5;
			
			eDict = enemyArray[5];
			name = eDict["name"];
			lb = CCBitmapFontAtlas.bitmapFontAtlasWithString(name, bitmapFntName);
			lb.setPosition(ccp(enemyMenuItem1.getContentSize()._width/2, enemyMenuItem1.getContentSize()._height/2));
			lb.setScale(0.45, 0.45 * labelScale);
			lb.setColor(ZFColorDefines.colorGrayButton);
			enemyMenuItem6.addChild(lb);
			enemyMenuItem6._tag = 6;
			//FALTAN COSAS AQUI!!!
		}
		
		var heightOffset = 0;
		if (winSize._width > ZFGameDefines.ORIGINAL_WINDOW_WIDTH)
		{
			heightOffset = 7;
		}
		//FIXME: enemyMenuItem7
		this._enemyMenu = CCMenu.menuWithItems([cancelEnemyMenuItem, enemyMenuItem1, enemyMenuItem7, enemyMenuItem2, enemyMenuItem3, enemyMenuItem4, enemyMenuItem5, enemyMenuItem6]);
		this._enemyMenu.setPosition(CGPointMake(0,0));
		this._enemyMenu.setPosition(ccp(-180.0*buttonScale, 0.0 - 12-heightOffset));
		this.addChild(this._enemyMenu, 6);
		cancelEnemyMenuItem.isEnabled = enemyMenuItem1.isEnabled = enemyMenuItem2.isEnabled = enemyMenuItem3.isEnabled = enemyMenuItem4.isEnabled = enemyMenuItem5.isEnabled = enemyMenuItem6.isEnabled = false;
		
		heightOffset *= 2;		//if on iPod, heightOffset will be 0
		var y = 0.0;
		for(var i in this._enemyMenu._children)
		{
			var item = this._enemyMenu._children[i];

			if(!(item instanceof CCNode))
				continue;
			var sz = item.getContentSize();
			item.setPosition(ccp(0, y + sz._height * item.getScale()._x / 2.0));
			y += sz._height * item.getScale()._y;
		}
		
		this._inGameMenu = new ZFInGameMenu();
		this.addChild(this._inGameMenu, 9, ZFGuiLayer.guiTags.kGuiTagInGameMenu);
	
		//TODO
//		[self initFarmWeather];
			
		//this.schedule(this.tick);
		
		enemyMenuItem1._touchTarget.setScale(1.1, 1.0);
		enemyMenuItem2._touchTarget.setScale(1.1, 1.0);
		enemyMenuItem3._touchTarget.setScale(1.1, 1.0);
		enemyMenuItem4._touchTarget.setScale(1.1, 1.0);
		enemyMenuItem5._touchTarget.setScale(1.1, 1.0);
		enemyMenuItem6._touchTarget.setScale(1.1, 1.0);
		//FIXME: enemyMenuItem7
		enemyMenuItem7._touchTarget.setScale(1.1, 1.0);
		
		enemyMenuItem1._touchTarget.setPosition(ccpAdd(enemyMenuItem1._touchTarget.getPosition(), ccp(10.0, 0.0)));
		enemyMenuItem2._touchTarget.setPosition(ccpAdd(enemyMenuItem2._touchTarget.getPosition(), ccp(10.0, 0.0)));
		enemyMenuItem3._touchTarget.setPosition(ccpAdd(enemyMenuItem3._touchTarget.getPosition(), ccp(10.0, 0.0)));
		enemyMenuItem4._touchTarget.setPosition(ccpAdd(enemyMenuItem4._touchTarget.getPosition(), ccp(10.0, 0.0)));
		enemyMenuItem5._touchTarget.setPosition(ccpAdd(enemyMenuItem5._touchTarget.getPosition(), ccp(10.0, 0.0)));
		enemyMenuItem6._touchTarget.setPosition(ccpAdd(enemyMenuItem6._touchTarget.getPosition(), ccp(10.0, 0.0)));
		//FIXME: enemyMenuItem7
		enemyMenuItem7._touchTarget.setPosition(ccpAdd(enemyMenuItem7._touchTarget.getPosition(), ccp(10.0, 0.0)));
			
		return this;
	},


	updateGold: function()
	{
		var value = GameState._zfGameData._resources[GameData.gameResources.kGameResourceGold];
		this._playersGold.setString(Number(value));
	},
		
	updateArmySize: function()
	{
		var cur = GameState.curArmySize();
		var max = GameState.maxArmySize();
		var armySizeString = "" + cur + "/" + max;
		this._armySize.setString(armySizeString);
	},
	
	updateLifeForce: function()
	{
		var gs = GameState;

		var luck = gs.getLuck();

		var maxLuck = gs.maxLuckForLevel(gs._zfGameData._level);
		var percent = luck / maxLuck;

		var color = null;
		if(percent >= 1.0)
		{
			percent = 1.0;
			color = ccc3(0x49,0xc1,0xcb);
		}
		else 
		{
			color = ccc3(0x29,0x70,0xba);
		}

		percent += 0.1;
		if(percent > 1) percent = 1;
		this._percentBar.setScale(percent, 1);

		this._percentBar.setColor(color);
		this._percentCap.setColor(color);
		
		this._percentCap.setPosition(ccpAdd(this._percentBar.getPosition(), ccp(36 * percent - 3 , 0)));
			
		this._playersLifeForce.setString(luck+"");
	},
		
	updateXP: function()
	{
		var gs = GameState;
		var value = gs._zfGameData._resources[GameData.gameResources.kGameResourceXP];
		var thisLevelValue = gs.xpNeededForLevel(gs._zfGameData._level);
		var nextLevelValue = gs.xpNeededForLevel(gs._zfGameData._level + 1);
	
		var xpString = value.toString();
		
		if(gs._zfGameData._level >= ZFGameDefines.MAXLEVEL)
		{
			xpString = Core.Localization.getString("MAX LEVEL");
		}
		
		this._playersXP.setString(xpString);
		var progress = (value - thisLevelValue) / (nextLevelValue - thisLevelValue);
		progress = (progress < 0) ? 0 : progress;
		progress = (progress > 1) ? 1 : progress;
		
		var scale = this._widthScale;
		
		if(this._widthScale > 1)
			scale = this._widthScale-0.5;
//		else
//			scale = this._widthScale+0.5;
		scale = 1.63;
		this._playerXPBar._bar.setScale(progress * scale, this._myScale._y);
		
		this._playerXPBar._frame.setPosition(this._playerXPBar._bar.getScale()._x * this._playerXPBar._bar.getSize()._width - 1 * this._widthScale, 0);
//		this._playerXPBar._frame.setPosition(this._playerXPBar._bar.getScale()._x * this._playerXPBar._bar.getSize()._width - 20 * this._widthScale,0);
        
		/*
		//playerXPBar._frame.position = ccp(-1 + ((int)(playerXPBar._bar.position.x + (progress * maxScaleX))), 0);

//	    if (widthScale>1)
//	    {
//	        float maxScaleX = 140.f;
//	        playerXPBar._bar.scaleX = progress * maxScaleX;
//	        playerXPBar._frame.position = ccp(-1 + ((int)(playerXPBar._bar.position.x + (progress * maxScaleX))), 0);
//	    }
//	    else
//	    {
//	        playerXPBar._bar.scaleX = progress * widthScale;
//	        playerXPBar._frame.position = ccp(playerXPBar._bar.scaleX * playerXPBar._bar.contentSize.width - 1.f*widthScale, 0);
//	    }
*/
	},
	
	updateLevel: function()
	{
		var value = GameState._zfGameData._level;
		this._playersLevel.setString(value+"");
		this.updateXP();
		this.updateLifeForce();
	},

	
	updateBrains: function()
	{
		var value = GameState._zfGameData._resources[GameData.gameResources.kGameResourceBrains];
		this._playersBrains.setString(value+"");
	},
	
    showMobageButtons: function() {
        if (!this._mobageButtonsVisible) {
            Social.Common.Service.showCommunityButton(UI.ViewGeometry.Gravity.TopRight, null, function(error) {});
            this._mobageButtonsVisible = true;
        }
    },
    
    hideMobageButtons: function() {
        if (this._mobageButtonsVisible) 
        {
            Social.Common.Service.hideCommunityButton();
            this._mobageButtonsVisible = false;
        }
    },
	
	gamestart: function(dt)
	{
		this.unschedule(this.gamestart);
		var gs = GameState;
		
		var sm = ZFStorageMenu.storageMenu();
		var w = new Core.Size(UI.Window._width, UI.Window._height);
		
		
		if (!(gs._zfGameData._gflags & ZFGameFlags.GFLAG_TUTORIAL_START))
		{
			gs._zfGameData._gflags |= ZFGameFlags.GFLAG_TUTORIAL_START;
			var message = Core.Localization.getString("Welcome to yer very own farm! Here's some gold to get ya started...\n\nLearning how to farm is easy, let's begin with the basics.");
			this.displayAlertSimple(Core.Localization.getString("Howdy Farmer!"), message, 
						  null,
						  new Core.Rect((w._width - 360) / 2, w._height - (w._height - 220) / 2, 360, 220));
			
			message = Core.Localization.getString("Harvesting crops gains you gold. Harvesting zombies increases yer zombie army.\nTap on the half buried zombie with the thumbs-up there to harvest him.\nHe's just dying to get outta the ground!");
			this.displayAlertSimple(Core.Localization.getString("Harvesting"), message, 
						  CCSprite.spriteWithFile("harvestTutorial1.png"),
						  CGRectMake((w._width - 480) / 2, w._height - (w._height - 240) / 2, 480, 240));
			
			return; //tutorial return early
		}
	
				
		ZFQuestMan.restoreQuestsFromSave();

		sm.missingItemCheck();
		//TODO
//		[[ZFAchievementChecker achievementChecker] checkAllAchievments];
		
//		[self dailyEventCheck];
		RateGame.instantiate();
	},


	tick: function(dt)
	{
		//console.log("*tick*");
		// All non GUI updates should go in ZFFarmTileMap tick:
		var gs = GameState;
		var tim = ZFTileManager;
		var tom = ZFToolManager.toolManager();
		
		var hasSpeedMonolith = (gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_FARMER_SPEED));
		gs._zfGameData._playerActionSpeed = (hasSpeedMonolith) ? ZFGameDefines.PLAYERACTIONSPEED_CHEAT : ZFGameDefines.PLAYERACTIONSPEED;
		
		var s = new Core.Size(UI.Window._width, UI.Window._height);	
		if (tom._currentGameTool != ZFToolManager.kGameTool.kGameToolNone)
		{
			var tool = tom._tools[tom._currentGameTool];
			
			switch (tom._currentGameTool)
			{
				case ZFToolManager.kGameTool.kGameToolPlow:
				case ZFToolManager.kGameTool.kGameToolMove:
				case ZFToolManager.kGameTool.kGameToolRotate:
				case ZFToolManager.kGameTool.kGameToolPlace:	
				{
					var toolSelectorRect = new Core.Rect(tool._toolSelectorRectMap.getOrigin(), tool._toolSelectorRectMap.getSize());

					toolSelectorRect.getOrigin().setAll(toolSelectorRect.getOrigin()._x + tim._map.getPosition()._x,
							toolSelectorRect.getOrigin()._y + tim._map.getPosition()._y);
					
					//LABEL
					
					if (tool._label && !tool._label.getParent())
					{
						this.addChild(tool._label, 7, ZFGuiLayer.guiTags.kGuiTagToolLabel);
						tool._label.setAnchorPoint(ccp(0.5, 0.5));
					}
					
					var scale = tim._map.getParent().getScale();
					var locationOnScreen = toolSelectorRect.getOrigin();
					var midpt = ccp(s._width/2, s._height/2);
					var tmp = ccpSub(locationOnScreen, midpt);
					tmp = ccpMult(tmp, scale._x);
					locationOnScreen = ccpAdd(tmp, midpt);

//TODO substract size text height to y position to match iphone display position perfectly
					if(tool._label)
						tool._label.setPosition(ccpAdd(locationOnScreen, ccpMult(ccp(toolSelectorRect.getSize()._width/2, toolSelectorRect.getSize()._height/2), scale._x)));
				}
					break;
		
				case ZFToolManager.kGameTool.kGameToolInstaGrow:
				case ZFToolManager.kGameTool.kGameToolPlant:
				{
					// SPRITE
					if(tool._spriteNode)
					{
						tool._spriteNode.setPosition(s._width - (58 + 12), 30.0);
						tool._spriteNode.setAnchorPoint(ccp(1.0,0.5));
					}
					else if(tool._sprite)
					{		
						tool._sprite.setPosition(s._width - (58 + 12), 30.0);
						tool._sprite.setAnchorPoint(ccp(1.0, 0.5));
					}
					
					//LABEL
					if(tool._label && !tool._label.getParent())
					{
						this.addChild(tool._label, 1, this.guiTags.kGuiTagToolLabel);
						tool._label.setAnchorPoint(ccp(1.0, 0.5));
					}
					
					tool._label.setPosition(s._width-5, 50);
				}
				break;
			}		
		}
		
		if (this._playerProgressBar._bar.getScale()._x >= 1.0)
	    {
			this._playerProgressBar._bar.setScale(0, this._playerProgressBar._bar.getScale()._y);
	    }
	    
		this._playerProgressBar.setVisible(this._playerProgressBar._bar.getScale()._x > 0 );
		
		if (this._playerProgressBar.getVisible())
		{
			var am = ZFActorManager;
			if (!this._playerProgressBar._text == "0")
			{
				
				var player = am._player;
				if (player._currentPlayerAction)
				{
					switch(player._currentPlayerAction._command)
					{
						case ZFGameAction.gameCommands.kGameCommandPlow:		this._playerProgressBar._actionString = NSLocalizedString("Plow");		break;
						case ZFGameAction.gameCommands.kGameCommandHarvest:		this._playerProgressBar._actionString = NSLocalizedString("Harvest");	break;
						case ZFGameAction.gameCommands.kGameCommandPlant:		this._playerProgressBar._actionString = NSLocalizedString("Plant");		break;
					}
				}
				
				this._playerProgressBar._text.setString(this._playerProgressBar._actionString);
			}
			
			var point = ccpAdd(am._player.getPosition(), tim._map.getPosition());
			point.setY(point._y + 100);
			var scale = tim._map.getParent().getScale()._x;
			var locationOnScreen = point;
			var midpt = ccp(s._width/2, s._height/2);
			var tmp = ccpSub(locationOnScreen, midpt);
			tmp = ccpMult(tmp, scale);
			locationOnScreen = ccpAdd(tmp, midpt);
			this._playerProgressBar.setPosition(locationOnScreen);
		}
		
		if(this._scrollingText.length > 0)
		{
			var length = this._scrollingText.length;
			for(var iSt = length-1; iSt > -1 ; iSt--)
			{
				var st = this._scrollingText[iSt];
				if(!st._label._parent)
				{
					if(st._delay <= 0)
					{
						this.addChild(st._label, 6, this.guiTags.kGuiTagScrollingText);
						
						st._label.setPosition(st._originalPosition._x,  st._originalPosition._y);
						st._label.setPosition(ccpAdd(ZFTileManager._map.getPosition(), st._label.getPosition()));
						
						var fade1 = CCFadeTo.actionWithDuration(0.15, 255);
						var fade2 = CCFadeTo.actionWithDuration(2, 0);
						var action = CCSequence.actions([fade1, fade2]);
						st._label.runAction(action);						
					}
					else
					{
						st._delay--;
					}
				}
				
				if(st._label._opacity <= 0)
				{
					this.removeChild(st._label, true);
					this._scrollingText.splice(iSt, 1);
					destroy(st._label);
					destroy(st);
				}
				else
				{					
					st._distanceScrolled = ((100 * st._label._opacity/255) - 100);
					st._label.setPosition(ccp(st._originalPosition._x,  st._originalPosition._y - st._distanceScrolled));
					st._label.setPosition(ccpAdd(ZFTileManager._map.getPosition(), st._label.getPosition()));
				}
			}
		}

		
//		//alerts
		if(this._alertWindows.length > 0 /* TODO: && ![ZFScreenshotManager screenshotManager].screenCapInProgress */)		
		{
			var toRemove = [];
			var isAlertUp = this.isAlertWindowOpen();
			
			for(var i in this._alertWindows)
			{
				var aw = this._alertWindows[i];
				if(aw._menuState == ZFMenu.menuStates.menuStateCleanup)
				{
					toRemove.push(aw);
				}
			}

			for(var i in toRemove)
			{
				var aw = toRemove[i];
				this._alertWindows.splice(this._alertWindows.indexOf(aw), 1);
				this.removeChild(aw, true);
			}

			if(this._alertWindows.length > 0 && isAlertUp == false)						
			{
				var aw = this._alertWindows[0]; //in original they get last object, but in original they insert new objects at index 0 when i push it 
				this.addChild(aw, 10, this.guiTags.kGuiTagAlertWindow);
				aw.display();
//				
//				if(aw.delayOkButton > 0.f)
				{
//					aw.ok.scale = .01f;
//					aw.dismiss.scale = .01f;
//					aw.dismiss.visible = NO;
//					aw.ok.visible = NO;
//					[aw schedule:@selector(showOkButtonIn:) interval:aw.delayOkButton];
				}
//							
//				[self processSalesPitchWindows:aw];
			}
			
			toRemove.length = 0;
			toRemove = null;
		}
//		
//		//flying crops cleanup
//		if (flyingCrops.count > 0)
//		{
//			NSMutableArray *flyingCropsToRemove = [[NSMutableArray alloc] init];
//			
//			for (CCSprite *fc in flyingCrops)
//			{
//				if(fc.position.y >= 310.f)
//				{
//					SimpleAudioEngine.playEffect(kEarnSFX);
//					[flyingCropsToRemove addObject:fc];
//				}
//			}
//			
//			for (CCSprite *fc in flyingCropsToRemove)
//			{
//				[self removeChild:fc cleanup:YES];
//				[flyingCrops removeObject:fc];
//			}
//			
//			[flyingCropsToRemove release];
//		}
	},

	isAlertWindowOpen: function()
	{
		for (var i in this._alertWindows)
		{
			var aw = this._alertWindows[i];
			if(		aw._menuState == ZFMenu.menuStates.menuStateOpen ||
					aw._menuState == ZFMenu.menuStates.menuStateOpening ||
					aw._menuState == ZFMenu.menuStates.menuStateClosing )
			{
				return true;
			}
		}
		return false;
	},

	
	displayMessage: function(message, tileCoordinates, color, delay)
	{
		var tim = ZFTileManager;
		var scale = tim._map._parent.getScale()._x;
		var mapPos = tim.mapPointFromTile(tileCoordinates);
		var w = new Core.Size(480, 320);
		
//		if([[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hant"] || [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hans"]||
//		   [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"ja"])
//		{
//			CCLabel *tileLabel = [CCLabel labelWithString:message fontName:@"Arial" fontSize:26];
//			tileLabel.scale = .7 + (.31 * scale);
//			
//			ZFScrollingText *newScrollingText = [[[ZFScrollingText alloc] init] autorelease];
//			newScrollingText.string = message;
//			newScrollingText.label = (CCBitmapFontAtlas*)tileLabel;
//			[newScrollingText.label setColor: color];
//			[newScrollingText.label setAnchorPoint:ccp(.5f, .5f)];
//			newScrollingText.label.position = ccp(mapPos.x + 24.f, mapPos.y + 24.f + 48.f);
//			
//			//scale compensation
//			CGPoint locationOnScreen = ccpAdd(newScrollingText.label.position, tim.map.position);
//			CGPoint midpt = ccp(w.width/2, w.height/2);
//			CGPoint tmp = ccpSub(locationOnScreen, midpt);
//			tmp = ccpMult(tmp, scale);
//			locationOnScreen = ccpAdd(tmp, midpt);
//			newScrollingText.label.position = ccpSub(locationOnScreen, tim.map.position);
//			
//			newScrollingText.distanceScrolled = 0.f;
//			newScrollingText.originalPosition = newScrollingText.label.position;
//			newScrollingText.delay = delay;
//			[scrollingText addObject:newScrollingText];
//		}
//		else
		{
			var tileLabel = CCLabel.labelWithString(message, "Arial", 26);
			tileLabel.setScale(0.7 + (0.31 * scale));

			var st = new ZFScrollingText();
			st._string = message;
			st._label = tileLabel;
			tileLabel.setColor(color);
			tileLabel.setPosition(mapPos._x + 24, mapPos._y + 24 + 48);
			
						
//			//scale compensation
			var locationOnScreen = ccpAdd(tileLabel.getPosition(), tim._map.getPosition());
			var midpt = ccp(240, 160);
			var tmp = ccpSub(locationOnScreen, midpt);
			tmp = ccpMult(tmp, scale);
			locationOnScreen = ccpAdd(tmp, midpt);
			tileLabel.setPosition(ccpSub(locationOnScreen, tim._map.getPosition()));

			tileLabel._label.setSize(new Core.Size(480, 40));
			tileLabel._label.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
			//tileLabel.setAnchorPoint(ccp(0.5, 0.5)); 
			
			st._delay = delay;
			st._originalPosition = tileLabel.getPosition().clone();
			st._distanceScrolled = 0;
			this._scrollingText.push(st);
		}		
		
		
	},
	
	
	
//	#pragma mark -
//	#pragma mark AlertWindow
//
//	- (ZFAlertWindow *)displayAlertFlurry:(NSString*)title withMessage:(NSString*)message withSprite:(CCSprite*)sprite
//	{
//		CGSize w = [[CCDirector sharedDirector] winSize];
//		ZFAlertWindowFlurryOffer *newAlertWindow = [[[ZFAlertWindowFlurryOffer alloc] initWithWindow:CGRectMake(0, 0, w.width, w.height)] autorelease];
//		[alertWindows insertObject:newAlertWindow atIndex:0];
//		return newAlertWindow;
//	}
//
//	- (ZFAlertWindow *)displayAlertFriendsListWithGiftName:(NSString*)giftName withGift:(NSMutableDictionary*)gift
//	{
//		ZFAlertWindowFriendsList* newAlertWindow = [[[ZFAlertWindowFriendsList alloc] initWithGiftName:giftName withGift:gift] autorelease];
//		[alertWindows insertObject:newAlertWindow atIndex:0];
//		return newAlertWindow;
//	}
//
//	- (ZFAlertWindow *)displayAlertGiftSend:(NSArray*)friends withGiftName:(NSString*)giftName withGift:(NSMutableDictionary*)gift withFriendsData:(NSDictionary*)friendsData
//	{
//		ZFAlertWindowGiftSend* newAlertWindow = [[[ZFAlertWindowGiftSend alloc] initWithFriends:friends withGiftName:giftName withGift:gift withFriendsData:friendsData] autorelease];
//		[alertWindows insertObject:newAlertWindow atIndex:0];
//		return newAlertWindow;
//	}
//
//	- (ZFAlertWindow *)displayAlertGiftReceived:(NSMutableDictionary*)giftBasket
//	{
//		ZFAlertWindowGiftReceive* newAlertWindow = [[[ZFAlertWindowGiftReceive alloc] initWithGifts:giftBasket] autorelease];
//		[alertWindows insertObject:newAlertWindow atIndex:0];
//		return newAlertWindow;
//	}
//
//	- (ZFAlertWindow *)displayAlertGiftSelection:(NSInteger)level
//	{
//		ZFAlertWindowGiftSelection* newAlertWindow = [[[ZFAlertWindowGiftSelection alloc] initWithLevel:level] autorelease];
//		[alertWindows insertObject:newAlertWindow atIndex:0];
//		return newAlertWindow;
//	}
//
	
	//windowSize is optional
	displayAlertSimple: function(title, message, sprite, windowSize)
	{
		var aw = ZFAlertWindow.alertWindowSimple(title, message, sprite, windowSize);
		this._alertWindows.push(aw);
		return aw;
	},
	
//	- (ZFAlertWindow *)displayAlertSimple:(NSString*)title withMessage:(NSString*)message withSprite:(CCSprite*)sprite withWindow:(CGRect)windowSize
//	{
//		CGSize winSize = [[CCDirector sharedDirector]winSize];
//		float widthOffset = (winSize.width-ORIGINAL_WINDOW_WIDTH)/2;
//		float heightOffset = (winSize.height-ORIGINAL_WINDOW_HEIGHT)/2;
//		windowSize.origin = ccpSub(windowSize.origin, CGPointMake(widthOffset, heightOffset));	//accomodate for initWindow method, which adds an offset for iPad scaling
//		ZFAlertWindow *newAlertWindow = [ZFAlertWindow alertWindowSimple:title withMessage:message withSprite:(CCSprite*)sprite withWindow:windowSize];
//		[alertWindows insertObject:newAlertWindow atIndex:0];
//		return newAlertWindow;
//	}
	
	displayAlertInformative: function(title, message, fontsize)
	{
		var aw = ZFAlertWindow.alertWindowInformative(title, message, fontsize);
		this._alertWindows.push(aw);
		return aw;
	},
	
//	- (ZFAlertWindow *)displayAlertInformative:(NSString*)title 
//								   withMessage:(NSString*)message 
//								  withFontSize:(int)fontsize
//	{
//		ZFAlertWindow *newAlertWindow = [ZFAlertWindow alertWindowInformative:title 
//																  withMessage:message 
//																 withFontSize:fontsize];
//		[alertWindows insertObject:newAlertWindow atIndex:0];
//		return newAlertWindow;
//	}

	alertWindowSlideInInformative: function(title, message, sprite, filename, r1, r2, buttonText, buttonColor, r3, giftButtonText, giftButtonColor, fromLeft)
	{
		var aw = ZFAlertWindow.alertWindowSlideInInformative(title, message, sprite, filename, r1, r2, buttonText, buttonColor, r3, gifitButtonText, giftButtonColor, fromLeft);
		this._alertWindows.push(aw);
		return aw;	
	},

	alertWindowSlideInInformativeWithSell: function(title, message, sprite, filename, r1, r2, buttonText, buttonColor, sellr1, sellr2, sellButtonText, sellButtonColor, fromLeft)
	{
		var aw = ZFAlertWindow.alertWindowSlideInInformativeWithSell(title, message, sprite, filename, r1, r2, buttonText, buttonColor, sellr1, sellr2, sellButtonText, sellButtonColor, fromLeft);
		this._alertWindows.push(aw);
		return aw;	
	},

	displayAlertSlideInInformative: function(title, message, sprite, filename, r1, r2, buttonText, buttonColor, fromLeft)
	{
		var aw = ZFAlertWindow.alertWindowSlideInInformative(title, message, sprite, filename, r1, r2, buttonText, buttonColor, fromLeft);
		this._alertWindows.push(aw);
		return aw;
	},
	
	displayAlertSimpleChoice: function(title, message, sprite, windowRect)
	{
		var aw = ZFAlertWindow.alertWindowSimpleChoice(title, message, sprite, windowRect);
		this._alertWindows.push(aw);
		return aw;
		
	},
//	- (ZFAlertWindow *)displayAlertSimpleChoice:(NSString*)title withMessage:(NSString*)message withSprite:(CCSprite*)sprite
//	{
//		ZFAlertWindow *newAlertWindow = [ZFAlertWindow alertWindowSimpleChoice:title withMessage:message withSprite:sprite];

//		return newAlertWindow;
//	}
//
//	- (ZFAlertWindow *)displayAlertSimpleChoice:(NSString*)title withMessage:(NSString*)message withSprite:(CCSprite*)sprite withWindow:(CGRect)windowRect
//	{
//		CGSize winSize = [[CCDirector sharedDirector]winSize];
//		float widthOffset = (winSize.width-ORIGINAL_WINDOW_WIDTH)/2;
//		float heightOffset = (winSize.height-ORIGINAL_WINDOW_HEIGHT)/2;
//		windowRect.origin = ccpSub(windowRect.origin, CGPointMake(widthOffset, heightOffset));	//accomodate for initWindow method, which adds an offset for iPad scaling
//		ZFAlertWindow *newAlertWindow = [ZFAlertWindow alertWindowSimpleChoice:title withMessage:message withSprite:sprite withWindow:(CGRect)windowRect];
//		[alertWindows insertObject:newAlertWindow atIndex:0];
//		return newAlertWindow;
//	}
//
//	- (ZFAlertWindow *)displayAlertLevelUp:(NSString*)title withMessage1:(NSString*)message1 withMessage2:(NSString*)message2 withSprite:(CCSprite*)sprite
//	{
//		ZFAlertWindow *newAlertWindow = [ZFAlertWindow alertWindowLevelUp:title withMessage1:message1 withMessage2:message2 withSprite:nil];
//		[alertWindows insertObject:newAlertWindow atIndex:0];
//		return newAlertWindow;
//	}

//	#pragma mark -
//	#pragma mark update hud numbers
//
	
	
	//{TEXT} text
	//{TEXT}[optional] info
	displayToolTip: function(text, info_or_duration)
	{		
		this.removeToolTip();
		this._toolsLayer.closeToolMenu();

		var width = UI.Window._width;
		
		if(!this._toolTipBG)
		{
			
			this._toolTipBG = CCColorLayer.layerWithColor(ccc3(0,0,0), width, 70);
			this._toolTipBG.setOpacity(208);
			this._toolTipBG.setPosition(0, 15+35);
			this.addChild(this._toolTipBG, 10);			
		}

		if(!this._toolTip)
		{
//			if([[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hant"] || [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hans"]||
//			   [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"ja"])
//			{
//				toolTip = [CCLabel labelWithString:NSLocalizedString(text, text) fontName:@"Arial" fontSize:26];
//			}
//			else
			{
				this._toolTip = CCLabel.labelWithString(Core.Localization.getString(text), new Core.Size(width, 50), GL2.Text.HorizontalAlign.Center, "Arial", 30);
			}
			
			this._toolTip.setScale(0.77);
			this._toolTipBG.addChild(this._toolTip, 2);
			this._toolTip.setPosition(width/2, 0);
			this._toolTip.setAnchorPoint(ccp(0.5, 0.5));
			
			var fade1 = CCFadeTo.actionWithDuration(0.5, 0xBF);
			var fade2 = CCFadeTo.actionWithDuration(0.5, 0xFF);
			
			var sequence = CCSequence.actions([fade1, fade2]);
			var repeatAction = CCRepeatForever.actionWithAction(sequence);
			
			this._toolTip.runAction(repeatAction);			
		}
		

		this.schedule(this.removeToolTipIn, 5, "removeToolTipIn");
		
		if(info_or_duration && typeof(info_or_duration) == "string" )
		{
			var info = info_or_duration;
//			if([[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hant"] || [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hans"]||
//			   [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"ja"])
//			{
//				for(CCLabel *label in toolTipBG.children)
//				{
//					label.position = ccpAdd(label.position, ccp(0, 10.f));
//				}
//				
//				CCLabel *toolTipInfo = [CCLabel labelWithString:NSLocalizedString(info, info) fontName:@"Arial" fontSize:26];
//				toolTipInfo.scale = .54;
//				toolTipInfo.anchorPoint = ccp(.5f, .5f);
//				[toolTipBG addChild:toolTipInfo z:2];
//				toolTipInfo.position = ccp(toolTipBG.contentSize.width/2, toolTipBG.contentSize.height/2 - 10);
//			}
//			else 
			{
				
				this._toolTip.setPosition(ccpAdd(this._toolTip.getPosition(), ccp(0, 10)));
				
				var toolTipInfo = CCLabel.labelWithString(Core.Localization.getString(info), new Core.Size(width, 30), GL2.Text.HorizontalAlign.Center, "AmericanTypewriter-Bold", 26);
				toolTipInfo.setScale(0.54);
				toolTipInfo.setAnchorPoint(ccp(0.5, 0.5));
				this._toolTipBG.addChild(toolTipInfo, 2);
				toolTipInfo.setPosition(width/2, -10);
			}
		}
		
		if(info_or_duration && typeof(info_or_duration) == "number" )
		{
			var duration = info_or_duration;
			this.displayToolTip(text);
			
			if(duration)
			{
				this.unschedule(this.removeToolTipIn);
				this.schedule(this.removeToolTipIn, duration, "removeToolTipIn");
			}
		}
		

	},

	addToolTipButton:  function(text, target, selector, s1, s2, isOnLeft)
	{
		//Setting default values for arguments if not set
		if(!s1) 
		{
			s1 = CCSprite.spriteWithFile("infoButton.png");
//			s1.setScale(1.4);
		}
		
		if(!s2)
		{
			s2 = CCSprite.spriteWithFile("infoButton.png");
//			s2.setScale(1.4);
		}
		
		//method body
		
		if(!this._toolTipBG) return;
		
		if(this._toolTipBG.getChildByTag(this.guiTags.kGuiToolTipButtonTag ))
		{
			this.removeToolTipButton();
		}

		this._toolTipButton = CCMenuItemImage.itemFromNormalSprite(s1, s2, target, selector);

		var menu = CCMenu.menuWithItems([this._toolTipButton]);
		menu.setScale(1.5);

		this._toolTipBG.addChild(menu, 2, this.guiTags.kGuiToolTipButtonTag);		
//		menu.contentSize = CGSizeMake(toolTipButton.contentSize.width, toolTipButton.contentSize.height);
		
		var winSize =  new Core.Size(UI.Window._width, UI.Window._height);
		
		if (isOnLeft)
		{
			menu.setPosition(5, -26);
		}
		else {
			menu.setPosition(winSize._width - this._toolTipButton.getSize()._width - 30, -26);
		}
		
		menu.setColor(ccc3(255,255,255));
		
		if(text && text != "")
		{
//			if([[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hant"] || [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hans"]||
//			   [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"ja"])
			{
//				CCLabel *toolTipButtonLabel = [CCLabel labelWithString:text fontName:@"Arial" fontSize:26];
//				toolTipButtonLabel.scale = .77;
//				toolTipButtonLabel.position = ccpAdd(menu.position, toolTipButton.position);
//				[toolTipBG addChild:toolTipButtonLabel z:2 tag:kGuiToolTipButtonLabelTag];
			}
//			else
			{
				this._toolTipButtonLabel = CCLabel.labelWithString(Core.Localization.getString(text), "Arial", 26);
				this._toolTipButtonLabel.setScale(0.77);
				//toolTipButtonLabel.setPosition(ccpAdd(menu.getPosition(), toolTipButton.getPosition()));
				this._toolTipButtonLabel.setPosition(this._toolTipButton.getSize()._width, this._toolTipButton.getSize()._height/2);
				//toolTipButtonLabel.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
				//toolTipButtonLabel.setAnchorPoint(ccp(0.5, 0.5));
				this._toolTipButton.addChild(this._toolTipButtonLabel, 2, this.guiTags.kGuiToolTipButtonLabelTag);			
				
			}
		}		
		
	},
	
	removeToolTipButton: function()
	{
		if(!this._toolTipBG)
			return;

		
		if(!this._toolTipButtonLabel)
			return;
		this._toolTipButton.removeChild(this._toolTipButtonLabel, true);
		this._toolTipBG.removeChild(this._toolTipButton, true);
		
		destroyWithChildren(this._toolTipButtonLabel);
		destroyWithChildren(this._toolTipButton);
		
//		[toolTipBG removeChildByTag:kGuiToolTipButtonBGTag cleanup:YES];
	},
	
	removeToolTipIn: function(dt)
	{
		this.removeToolTip();
	},
	
	removeToolTip: function()
	{
		this.unschedule(this.removeToolTipIn);
		if(this._toolTipBG)
		{
			CCActionManager.stopAllActions(this._toolTip);
//			this.removeToolTipButton();
			this.removeChild(this._toolTipBG, true);
			destroyWithChildren(this._toolTipBG);
			destroyWithChildren(this._toolTip);
			this._toolTipBG = null;
			this._toolTip = null;
		}
	},
	
	enableMenus: function(withMobageCommunity)
	{
		this._disableMenusRefCount--;
//		console.log("this._disableMenusRefCount " + this._disableMenusRefCount);
		if (this._disableMenusRefCount > 0)
		{
			return;
		}
		
		this._disableMenusRefCount = 0;
		
		this._toolsLayer.enableMenus();
		ZFQuestMan.enableMenus();
		
		if (this._zfc && this._zfc._cheatMenu)
		for(var itemKey in this._zfc._cheatMenu._children)
		{
			var item = this._zfc._cheatMenu._children[itemKey];
			item.isEnabled = true;
		}
		
		if(GameState.canInvade())
		{
			for(var itemKey in this._invadeMenu._children)
			{
				var item = this._invadeMenu._children[itemKey];
				item.isEnabled = true;
			}
			
			this.prepareEnemyMenu(); //also sets the proper enabled flags based on level
		}
		
		this._invadeMenu.setVisible(true);
		this._enemyMenu.setVisible(true);
		this._zfc && this._zfc._cheatMenu && this._zfc._cheatMenu.setVisible(true);
		
		// Just in case we are saving and someone enteres the storage menu or another menu that
		// re-enables all other menus, we make sure that the shell menu doesnt get re-enabled until saving is finished
//		FIXME: ZFRemoteStorageManager* remoteStorage = [ZFRemoteStorageManager getInstance];
//		FIXME: if(!remoteStorage.isProcessingRequest)
//		{
		   for(var itemKey in this._shellMenu._children)
		   {
			   var item = this._shellMenu._children[itemKey];
			   item.isEnabled = true;
		   }
		
		   this._shellMenu.setVisible(true);
//		}
//		else 
//		{
//			[self disableShellMenu];
//		}
	   if(typeof(withMobageCommunity) == "undefined"){
		  this.showMobageButtons();
	   }else{
		   setTimeout(this.showMobageButtons.bind(this), 1500);
	   }
	   
	},

	disableMenus: function()
	{
		this._disableMenusRefCount++;
//		console.log("this._disableMenusRefCount " + this._disableMenusRefCount);
		if (this._disableMenusRefCount > 1)
		{
			return;
		}
		
		this._toolsLayer.disableMenus();
		
		this.hideMobageButtons();
		
		ZFQuestMan.disableMenus();

		for (var itemKey in this._invadeMenu._children)
		{
			var item = this._invadeMenu._children[itemKey];
			item.isEnabled = false;
		}
		
		for (var itemKey in this._enemyMenu._children)
		{
			var item = this._enemyMenu._children[itemKey];
			item.isEnabled = false;
		}
		
		if (this._zfc && this._zfc._cheatMenu)
		for (var itemKey in this._zfc._cheatMenu._children)
		{
			var item = this._zfc._cheatMenu._children[itemKey];
			item.isEnabled = false;
		}
		
		for (var itemKey in this._shellMenu._children)
		{
			var item = this._shellMenu._children[itemKey];
			item.isEnabled = false;
		}
		
		this._invadeMenu.setVisible(false);
		this._enemyMenu.setVisible(false);
		this._zfc  && this._zfc._cheatMenu && this._zfc._cheatMenu.setVisible(false);
		this._shellMenu.setVisible(false);
		this.hideEnemyMenu(null);
	},
	
	prepareEnemyMenu: function()
	{
		for(var i=0; i < this._enemyMenu._children.length; ++i)
		{
			var item = this._enemyMenu._children[i];
			if(!(item instanceof CCNode))
				continue;
			var index = item._tag;
			
			if (index < 0 ) //cancel button
			{
				item.isEnabled = true;
				continue;
			}
			
			var dictionary = this._enemyArray[index-1];
			var isEnabled = (GameState._zfGameData._level >= dictionary["level"]);
			
			//FIXME: This stages are not implemented
//	        if (index == 5 || index == 6) {
//	        	item.isEnabled = false;
//	        	isEnabled = false; 
//	        }
			
			if (isEnabled)
			{
				item._normalImage.setColor(ZFColorDefines.colorBlueButton);
				item._selectedImage.setColor(ZFColorDefines.colorBlueButton);
				item.isEnabled = true;
			}
			else 
			{
				item._normalImage.setColor(ZFColorDefines.colorGrayButton);
				item._selectedImage.setColor(ZFColorDefines.colorGrayButton);
				
				//item._normalImage.setColor(ZFColorDefines.colorBlueButton);
				//item._selectedImage.setColor(ZFColorDefines.colorBlueButton);
				//item.isEnabled = true;
			}
			
			for(var j=0; j < item._children.length; ++j)
			{
				var n = item._children[j];
				//TODO
				if(true/*ZombieFarmAppDelegate.getCurrentLanguage() == "zh-Hant" || ZombieFarmAppDelegate.getCurrentLanguage() == "zh-Hans" ||
				   ZombieFarmAppDelegate.getCurrentLanguage() == "ja"*/)
				{
					if (n instanceof CCLabel)
					{
						label = n;
						if (isEnabled)
						{
							label.setColor(ZFColorDefines.colorTextWhite);
						}
						else 
						{
							label.setColor(ZFColorDefines.colorGrayButton);
						}
						
						break;
					}
				}
				else 
				{
					if (n instanceof CCBitmapFontAtlas)
					{
						//CCBitmapFontAtlas *label = (CCBitmapFontAtlas*)n;
						if (isEnabled)
						{
							label.setColor(ZFColorDefines.colorTextWhite);
						}
						else 
						{
							label.setColor(ZFColorDefines.colorGrayButton);
						}
					
						break;
					}
				}
			}
		}
	},

	showInvasionMenu: function(sender)
	{
		var winSize = new Core.Size(UI.Window._width, UI.Window._height);
	    var actionTo = null;
	    
	    if (winSize._width > ZFGameDefines.ORIGINAL_WINDOW_WIDTH)
	    {
	        actionTo = CCMoveTo.actionWithDuration(0.5, new Core.Point(2.0, this._invadeMenu.getPosition()._y));
	    }
	    else
	    {
	        actionTo = CCMoveTo.actionWithDuration(0.5, new Core.Point(0.0, this._invadeMenu.getPosition()._y));
	    }
	    
	    
		this._invadeMenu.runAction(actionTo);
		
		for(var i=0; i < this._invadeMenu._children.length; ++i)
		{
			var item = this._invadeMenu._children[i];
			if(!(item instanceof CCNode))
					continue;
			item.isEnabled =true;
		}
	},

	hideInvasionMenu: function(sender)
	{ 
		var widthOffset = 0;
//		FIXME: not well handdled for android device if (ZFGameDefines.WINDOW_WIDTH > ZFGameDefines.ORIGINAL_WINDOW_WIDTH)
		if (true)
		{
			widthOffset = 118;
		}
		var actionTo = CCMoveTo.actionWithDuration(0.5, ccp(-62.0-widthOffset, 0.0));
		this._invadeMenu.runAction(actionTo);
		
		for(var i=0; i < this._invadeMenu._children.length; ++i)
		{
			var item = this._invadeMenu._children[i];
			if(!(item instanceof CCNode))
					continue;
			item.isEnabled = false;
		}
	},

	hideEnemyMenu: function(sender)
	{
		var buttonScale = 1;
		if (this._widthScale>1)
		{
			buttonScale = 1.2;
		}
		var actionTo1 = CCMoveTo.actionWithDuration(0.5, new Core.Point(-180.0*buttonScale, this._enemyMenu.getPosition()._y));
		this._enemyMenu.runAction(actionTo1);
		
		for(var i=0; i < this._enemyMenu._children.length; ++i)
		{
			var item = this._enemyMenu._children[i];
			if(!(item instanceof CCNode))
					continue;
			item.isEnabled = false;
		}
		
		this.showInvasionMenu(sender);
	},
	
	//- (void)updateInvasionLabel:(ccTime)dt
	updateInvasionLabel: function(dt)
	{
		var gs = GameState;
		
		if(!this._invasionDelayLabel)
		{
			if(true/*[[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hant"] || [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hans"]||
			   [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"ja"]*/)
			{
				this._invasionDelayLabel = CCLabel.labelWithString(NSLocalizedString("in:"), "Arial", 26);
			}
			else 
			{
				//this._invasionDelayLabel = [CCBitmapFontAtlas bitmapFontAtlasWithString:NSLocalizedString(@"in:", @"in stands for invation") fntFile:@"ABD26.fnt"];
			}
			
			this.addChild(this._invasionDelayLabel, 1, this.guiTags.kGuiTagInvasionLabelTag);
			var invasionWidthOffset = 0;
			this._invasionDelayLabel.setPosition(240, 20);
		}
		
		var delay = ZFGameDefines.INVASION_INTERVAL - (Core.Time.getRealTime()/1000 - gs._zfGameData._lastInvasionDate);
		var delay2 = delay;
		delay = (delay < 0) ? 0 : delay;
		
		var hoursLeft = Math.floor((delay / 60 / 60 ));
		delay -= (hoursLeft * 60 * 60);
		var minutesLeft = Math.floor((delay / 60));
		delay -= Math.floor((minutesLeft * 60));
		
		var time = sprintf(NSLocalizedString("%ihr %imins"),hoursLeft,minutesLeft);
		this._invasionDelayLabel.setString(sprintf(NSLocalizedString("in: %@"),time));
		this._invasionDelayLabel.setVisible(delay2 > 0);
	},
	
	//- (void)startInvasion:(id)sender
	startInvasion: function(index, sender)
	{
		var gs = GameState;
		
		//FIXME
		var LVL = gs._zfGameData._level;
		var requiredLVL = 0;
		
//		var item = sender;
		
		var enemyDictionary = this._enemyArray[index-1];
		requiredLVL = enemyDictionary["level"];
		
		//FIXME
		//var eventDictionary = { "enemy": (enemyDictionary["name"])};
		//[[EventTracker eventTracker ] sendEvent:@"zf_farm_sel_invade" withParameters:eventDictionary andDelegate:nil];
		
		if(LVL < requiredLVL)
		{
			var msg = "Requires level "+requiredLVL;
			this.displayToolTip(NSLocalizedString(msg));
			return;
		}
		
		this.startInvasion_checkHunger(index, sender, true);
	},
	
	//- (void)startInvasion:(id)sender checkHunger:(BOOL)checkHunger
	startInvasion_checkHunger: function(/*id*/index, sender,/*Boolean*/checkHunger)
	{
		this.hideEnemyMenu(sender);
		
		var gs = GameState;
//		var item = sender;
		var acm = ZFActorManager;
//		var index = id;
		
		// Check if we should warn the user if they
		// are not well equipped for this invasion.
		this.detectInvasionWarning(index, sender);
		
		//check hunger
		if ( (gs._zfGameData._gflags & ZFGameFlags.GFLAG_FIGHT_TUTORIAL) && checkHunger && acm.getAverageHunger() < 0.8)	
		{
			var aw = this.displayAlertSimpleChoice(NSLocalizedString("WHOA THERE!"), 
												   NSLocalizedString("Hold yer horses, your zombies aren't quite hungry yet.\nThey may get distracted during the fight.\n\nDo you still want to invade?"),
													CCSprite.spriteWithFile("distractedZombie.png"));
			aw._delegate = this;
			aw._idTag = this.guiTags.kGuiTagInvasionNotHungryTag;
			aw._userData = sender;
			aw._index = index;
			return;
		}
			
		if (index < 0 || index > this._enemyArray.length)
		{
			return;
		}
		
		for (var i=0; i<this._alertWindows.length; ++i)
		{
			aw = this._alertWindows[i];
			if(aw._idTag == this.guiTags.kGuiTagInvasionAlertTag)
			{
				return;
			}
		}

		var enemyDictionary = this._enemyArray[index-1];
		
		//are you sure?
		bossName = NSLocalizedString(enemyDictionary["bossName"]);
		var levelReq = enemyDictionary["level"];
		var difficulty = NSLocalizedString("Easy");
		
		if(GameState._zfGameData._level == levelReq)
		{
			difficulty = NSLocalizedString("Hard");
		}
		else if(GameState._zfGameData._level >= (levelReq + 2))
		{
			difficulty = NSLocalizedString("Medium");
		}

		var spriteName = enemyDictionary["bossHeadSprite"];
		var sprite = CCSprite.spriteWithFile(spriteName);
		var message = sprintf(NSLocalizedString("Are ya ready to send yer zombie army to invade\n%@?"), NSLocalizedString(bossName));
		if (index-1 >= 2) //pirate hack
		{
			message = sprintf(NSLocalizedString("%@\nThese guys are tough! Be sure to come hungry."), message);
		}
		
		var brainDropRate = gs.chancetoEarnBrain(enemyDictionary);//gs.chancetoEarnBrain(enemyDictionary);
		console.log("brain drop rate: " + brainDropRate);
		console.log(JSON.stringify(enemyDictionary));
		if (this.isFirstTimeBeatingEnemy(false))
		{
			brainDropRate = 1.0;
		}
		
		var brainEarnDescription = null;
		if (brainDropRate >= 1.0 * ZFGameDefines.BRAIN_DROPRATE_MAX)
		{	
			brainEarnDescription = NSLocalizedString("Excellent");
		}
		else if (brainDropRate >= (0.75 * (ZFGameDefines.BRAIN_DROPRATE_MAX - ZFGameDefines.BRAIN_DROPRATE_MIN)) + ZFGameDefines.BRAIN_DROPRATE_MIN)
		{
			brainEarnDescription = NSLocalizedString("Good");
		}
		else if (brainDropRate >= (0.5 * (ZFGameDefines.BRAIN_DROPRATE_MAX - ZFGameDefines.BRAIN_DROPRATE_MIN)) + ZFGameDefines.BRAIN_DROPRATE_MIN)
		{
			brainEarnDescription = NSLocalizedString("Decent");
		}
		else if (brainDropRate >= (0.25 * (ZFGameDefines.BRAIN_DROPRATE_MAX - ZFGameDefines.BRAIN_DROPRATE_MIN)) + ZFGameDefines.BRAIN_DROPRATE_MIN)
		{
			brainEarnDescription = NSLocalizedString("Low");
		}
		else if (brainDropRate > (0.0 * (ZFGameDefines.BRAIN_DROPRATE_MAX - ZFGameDefines.BRAIN_DROPRATE_MIN)) + ZFGameDefines.BRAIN_DROPRATE_MIN)
		{
			brainEarnDescription = NSLocalizedString("Horrible");
		}
		else if (brainDropRate <= (0.0 * (ZFGameDefines.BRAIN_DROPRATE_MAX - ZFGameDefines.BRAIN_DROPRATE_MIN)) + ZFGameDefines.BRAIN_DROPRATE_MIN)
		{
			brainEarnDescription = NSLocalizedString("Abysmal");
		}
		
		if(ZFStorageMenu.storageMenu().indexForItemNameInStorage("Golden Dice") >= 0)
		{
			var diceWindow = new ZFAlertWindowGoldenDice();
			this._alertWindows.unshift(diceWindow);
		}
		
		var aw = this.displayAlertSimpleChoice(NSLocalizedString("Start Invasion"),
											   message,
												sprite);
		aw._delegate = this;
		aw._idTag = this.guiTags.kGuiTagInvasionAlertTag;
		
		gs._zfGameData._currentEnemy = index-1;
	},
	
	//- (void)detectInvasionWarning:(id)sender
	detectInvasionWarning: function(index, sender)
	{
//		var item = sender;
//		var index = item._tag;
		
		// Check the required level of the currently
		// selected stage.
		var enemyDictionary = this._enemyArray[index-1];
		var requiredLevel = enemyDictionary["reccomendedLevel"];
		
		if ( requiredLevel <= 10 )
			return;
	
		var zombieGroup;
		var hasAtLeastOneColoredZombie = false;
		
		if ( requiredLevel > 10 && requiredLevel <= 20 )
		{
			zombieGroup = NSLocalizedString("BLUE");
			
			if ( !hasAtLeastOneColoredZombie )
				hasAtLeastOneColoredZombie = this.checkForPlayerZombieColor(2);

			if ( !hasAtLeastOneColoredZombie )
				hasAtLeastOneColoredZombie = this.checkForPlayerZombieColor(0);

			if ( !hasAtLeastOneColoredZombie )
				hasAtLeastOneColoredZombie = this.checkPlayerHasCombinerZombie();
		}
		else if ( requiredLevel >= 21 && requiredLevel <= 25 )
		{
			zombieGroup = NSLocalizedString("RED");
			
			if ( !hasAtLeastOneColoredZombie )
				hasAtLeastOneColoredZombie = this.checkForPlayerZombieColor(0);
			
			if ( !hasAtLeastOneColoredZombie )
				hasAtLeastOneColoredZombie = this.checkPlayerHasCombinerZombie();
		}
		else if ( requiredLevel >= 26 )
		{
			zombieGroup = NSLocalizedString("COMBINED");
			
			if ( !hasAtLeastOneColoredZombie )
				hasAtLeastOneColoredZombie = this.checkPlayerHasCombinerZombie();
		}
		
		// Display a warning message (if applicable).
		if ( !hasAtLeastOneColoredZombie )
		{
			var message = sprintf(NSLocalizedString("I reckon if you had some\n\n%@ ZOMBIES\n\nyou'd have a better chance of winning."), zombieGroup);
				
			var aw = this.displayAlertSimple(NSLocalizedString("TOUGH ENEMIES AHEAD!"), 
											 NSLocalizedString(message),
											  CCSprite.spriteWithFile("veteran.png"));
			aw._delegate = this;
			aw._userData = sender;
			return;
		}
		
		return;
	},
	
	checkPlayerHasCombinerZombie : function()
   {
       for (var key in ZFActorManager._actorList)
       {
           var zombie = ZFActorManager._actorList[key];
           if ( zombie instanceof ZombieActor )
           {
               if ( zombie instanceof ZombieActorRegularTier4 ||
                       zombie instanceof  ZombieActorLargeTier4   ||
                       zombie instanceof ZombieActorSmallTier4   ||
                       zombie instanceof ZombieActorGirlTier4    ||
                       zombie instanceof  ZombieActorHeadlessTier4||
                       zombie instanceof ZombieActorGardenTier4 )
                   return true;
           }
       }
       
       return false;
   },
   
   detectInvasionWarning : function(index, sender)
   {
// FIXME: behavior changed
//       var item = sender;
//       var index = item._tag;
       
       var enemyDictionary = this._enemyArray[index-1];
       var requiredLevel = enemyDictionary["reccomendedLevel"];
       
       if ( requiredLevel <= 10 )
       {
           return;
       }
       
       var zombieGroup = null;
       var hasAtLeastOneColoredZombie = true;
       
       if ( requiredLevel > 10 && requiredLevel <= 20 )
       {
           zombieGroup = NSLocalizedString("BLUE");
           
           if ( !hasAtLeastOneColoredZombie )
               hasAtLeastOneColoredZombie = this.checkForPlayerZombieColor(2);

           if ( !hasAtLeastOneColoredZombie )
               hasAtLeastOneColoredZombie = this.checkForPlayerZombieColor(0);

           if ( !hasAtLeastOneColoredZombie )
               hasAtLeastOneColoredZombie = this.checkPlayerHasCombinerZombie();
       }
       else if ( requiredLevel >= 21 && requiredLevel <= 25 )
       {
           zombieGroup = NSLocalizedString("RED");
           
           if ( !hasAtLeastOneColoredZombie )
               hasAtLeastOneColoredZombie = this.checkForPlayerZombieColor(0);
           
           if ( !hasAtLeastOneColoredZombie )
               hasAtLeastOneColoredZombie = this.checkPlayerHasCombinerZombie();
       }
       else if ( requiredLevel >= 26 )
       {
           zombieGroup = NSLocalizedString("COMBINED");
           
           if ( !hasAtLeastOneColoredZombie )
               hasAtLeastOneColoredZombie = this.checkPlayerHasCombinerZombie();
       }
       
       // Display a warning message (if applicable).
       if ( !hasAtLeastOneColoredZombie )
       {
           var message = sprintf(NSLocalizedString("I reckon if you had some\n\n%@ ZOMBIES\n\nyou'd have a better chance of winning."), zombieGroup);
           var aw = this.displayAlertSimple(NSLocalizedString("TOUGH ENEMIES AHEAD!"), 
                                            NSLocalizedString(message),
                                            CCSprite.spriteWithFile("veteran.png"));
           aw._delegate = this;
           aw._userData = sender;
       }
   },

   checkForPlayerZombieColor: function(color)
   {
       for (var key in ZFActorManager._actorList)
       {
           var zombie = ZFActorManager._actorList[key];
           if ( zombie instanceof ZombieActor )
           {
               var colors = [zombie.getColor()._r, zombie.getColor()._g, zombie.getColor()._b];
               if ( colors[color] == 1 ) return true;
           }
       }
       
       return false;
   },

   checkPlayerHasCombinerZombie: function()
   {
       for (var key in ZFActorManager._actorList)
       {
           var zombie = ZFActorManager._actorList[key];
           if ( zombie instanceof ZombieActor )
           {
               
               if ( zombie instanceof ZombieActorRegularTier4 ||
                       zombie instanceof ZombieActorLargeTier4   ||
                       zombie instanceof ZombieActorSmallTier4   ||
                       zombie instanceof ZombieActorGirlTier4    ||
                       zombie instanceof ZombieActorHeadlessTier4||
                       zombie instanceof ZombieActorGardenTier4 )
                   return true;
           }
       }
       
       return false;
   },
   
   //- (BOOL)isFirstTimeBeatingEnemy:(BOOL)saveFlag
   isFirstTimeBeatingEnemy : function(saveFlag)
   {
        var gflag = 0;
        var fm = ZFFightMan;
        
        var i;
        for (i = 0; i < this._enemyArray.length; i++)
        {
            dict = this._enemyArray[i];
            if (fm._enemyDictionary && dict && fm._enemyDictionary.name == dict.name)
            {
                break;
            }
        }
                
        switch (i)
        {
            case 0:
                gflag = ZFGameFlags.GFLAG_FB_ENEMY1;
                break;
            case 1:
                gflag = ZFGameFlags.GFLAG_FB_ENEMY2;
                break;
            case 2:
                gflag = ZFGameFlags.GFLAG_FB_ENEMY3;
                break;
            case 3:
                gflag = ZFGameFlags.GFLAG_FB_ENEMY4;
                break;
            case 4:
                gflag = ZFGameFlags.GFLAG_FB_ENEMY5;
                break;
            case 5:
                gflag = ZFGameFlags.GFLAG_FB_ENEMY6;
                break;
            case 6:
                gflag = ZFGameFlags.GFLAG_FB_ENEMY7;
                break;
            case 7:
                gflag = ZFGameFlags.GFLAG_FB_ENEMY8;
                break;
            case 8:
                gflag = ZFGameFlags.GFLAG_FB_ENEMY9;
                break;
            default:
//                console.log("isFirstTimeBeatingEnemy index oob");
                break;
        }
        
        if (!(GameState._zfGameData._gflags & gflag))
        {
            if (saveFlag)
            {
                GameState._zfGameData._gflags |= gflag;
            }
            
            return true;
        }
        
        return false;
   },
   
   //- (void)alertWindow:(ZFAlertWindow*)alertWindow dismissedPositive:(BOOL)dummy
   alertWindow_dismissedPositive: function (alertWindow, dummy)
   {
	   	var gs = GameState;
	    var market = ZFMarketMenu.theMarket();
		
		switch (alertWindow._idTag)
		{
			case this.guiTags.kGuiTagScreenCapEmailAccountFailTag:
			{
				var sm = ZFScreenshotManager.screenshotManager();
				sm.chooseScreenCapUploadMethod();
			}
				break;
				
			case this.guiTags.kGuiTagScreenCapFacebookUploadFailTag:
			{
				var sm = ZFScreenshotManager.screenshotManager();
				sm.chooseScreenCapUploadMethod();
			}
				break;
			
			case this.guiTags.kGuiTagInvasionAlertTag:
			{
				this.hideEnemyMenu(null);
				
				var acm = ZFActorManager;
				var hunger = acm.getAverageHunger();
				var enemyDictionary = this._enemyArray[gs._zfGameData._currentEnemy];
				var enemyName = enemyDictionary["name"];
				var armyCount = gs.curArmySize();
				var eventDictionary = {hunger: "hungerLevel",
										enemyName: "enemy",
										armyCount: "armyCount"};
				
				if(dummy)
				{	
					this.displayZombieSelectionMenu();
					
					//TODO
					//[[EventTracker eventTracker] sendEvent:@"zf_invade_confirm" withParameters:eventDictionary andDelegate:nil];
				}
				else {	//dismissed
					//TODO
					//[[EventTracker eventTracker] sendEvent:@"zf_invade_dismiss" withParameters:eventDictionary andDelegate:nil];
				}

			}
				break;
				
			case this.guiTags.kGuiTagInvasionNotHungryTag:
			{
				if(dummy)
				{
					this.startInvasion_checkHunger(alertWindow._index, alertWindow._userData, false);
				}
				else 
				{
					var aw = this.displayAlertSimpleChoice(NSLocalizedString("Insta-Hunger"),
															NSLocalizedString("Would you like to use\nInsta-Hunger\nto make your zombies hungry?"),
															 CCSprite.spriteWithFile("stex0032.png"));
					aw._delegate = this;
					aw._idTag = this.guiTags.kGuiTagInvasionUseInstaHungerTag;
				}
				
				alertWindow._userData = null;

			}
				break;
				
			case this.guiTags.kGuiTagInvasionUseInstaHungerTag:
			{
				if(dummy)
				{
					var sm = ZFStorageMenu.storageMenu();
	                var key = "Insta-Hunger";
					if (sm.numberOfItemInStorageWithKey(key) > 0)
					{
						//auto use the item
						sm.useItemWithName(key);
					}
					else 
					{
	                    market.shortcutBuy(key);
					}
				}
			}
				break;
	            
	        case this.guiTags.kGuiTagInvasionUseInvasionVoucher:
			{
	            if(dummy)
				{
	            	//FIXME
	                //[FlurryAPI logEvent:kFlurryEvent_recommendInvasionVoucher withParameters:[NSDictionary dictionaryWithObjectsAndKeys: [NSNumber numberWithBool:YES], @"Accpeted", nil]];
	                
					var sm = ZFStorageMenu.storageMenu();
	                var key = "Invasion Voucher";
					if (sm.numberOfItemInStorageWithKey(key) > 0)
					{
	                    //auto use the item
						sm.useItemWithName(key);
					}
					else 
					{
						market.shortcutBuy(key);
					}
				}
	            else
	            {
	            	//FIXME
	                //[FlurryAPI logEvent:kFlurryEvent_recommendInvasionVoucher withParameters:[NSDictionary dictionaryWithObjectsAndKeys: [NSNumber numberWithBool:YES], @"Accpeted", nil]];
	            }
	        }
	            break;
				
			case this.guiTags.kGuiTagInvasionUseRegrowth:
			{
				if(dummy)
				{
					var sm = ZFStorageMenu.storageMenu();
	                var key = "Regrowth";
					if (sm.numberOfItemInStorageWithKey(key) > 0)
					{
						//auto use the item
						sm.useItemWithName(key);
					}
					else 
					{
						market.shortcutBuy(key);
					}
				}
			}
				break;
				
			case this.guiTags.kGuiTagAlertWindowPitchLast:
			{
				var market = ZFMarketMenu.theMarket();
				this.removeChildByTag(this.guiTags.kGuiTagPitchBlackOut, true);
				market._category = "item";
				market._subCategory = "special";
				market.openMenuWithPage(0);
				
				var z1 = this._pitchActors[0];
				z1.unscheduleAllSelectors();
				z1.despawn();
				
				this._pitchActors.length = 0;
				this._pitchActors.release();
				
				this.removeChildByTag(this.guiTags.kGuiTagAlertWindowPitchEmitter, true);
				this.removeChildByTag(this.guiTags.kGuiTagAlertWindowPitchEmitter, true);
				
				gs._zfGameData._gflags |= ZFGameFlags.GFLAG_PITCH_SHOWN;
			}
				break;
				
			case this.guiTags.kGuiTagAlertWindowLevelUp:
			{
//				var fb = FBMan.fbman();
				var qm = ZFQuestMan.questMan();
				
				if (gs._zfGameData._level >= ZFGameDefines.MAXLEVEL)
				{
					this.displayAlertSimple(NSLocalizedString("You've Hit the Top"),
								 NSLocalizedString("Congratulations!\nYou just reached the current maximum level! The level cap may increase with periodic updates, along with new items, zombies and enemies!\nSo stay tuned!"),
								  CCSprite.spriteWithFile("male.png"));
				}
//				else if (this.shouldStartSalesPitch())
//				{
//					this.startSalesPitch();
//				}
//				else if (fb.isSessionValid() && gs._zfGameData._level > 5)
//				{
//					var existsCount = 0;
//					
//					for(var i=0; i < alertWindows.length; ++i)
//					{
//						window = alertWindow[i];
//						if (window._idTag == this.guiTags.kGuiTagAlertWindowLevelUp)
//						{
//							existsCount++;
//						}
//					}
//						
//					if(existsCount <= 1)
//						self.publishLevelUp();
//				}
//				else if (fb.connectedToInternet() && !(gs._zfGameData._gflags & ZFGameFlags.GFLAG_RATE_IT_SHOWN))
//				{
//					//conected but not logged into facebook
//					if (gs._zfGameData._level >= ZFGameDefines.RATE_IT_LEVEL)
//					{
//						self.showRateIt();
//					}
//				}
				
				if (gs._zfGameData._level == ZFGameDefines.BUY_A_TREE_LEVEL)
				{
					var newAlertWindow = ZFAlertWindow.alertWindowSimple(
							NSLocalizedString("Life Force"),
							NSLocalizedString("Now would be a good time to buy a tree if you dont have one. All decorative items give Life Force, but trees give the most. Life Force is important for preventing lifeless zombies and good for zombie mutations."),
							null);
					
					qm.addQuestWithAlert(newAlertWindow, CCSprite.spriteWithFile("stex1004.png"));
				}
				
				this.showCombinerTutorialMessage();
				this.showStorageTutorialMessage();				
				
				for (var i = 0; i < this._enemyArray.length; ++i)
				{
					var enemy = this._enemyArray[i];
					if (this._enemyArray.indexOf(enemy) == 0)
					{
						continue;
					}
					
					if (gs._zfGameData._level == enemy["level"])
					{
						//FIXME: removed The Aliens
//						if (enemy.bossName == "The Aliens" || enemy.bossName == "Dairy King" || enemy.bossName.indexOf("obots")>0) {
//							return;
//						}
						
						this.displayAlertSimple(NSLocalizedString(enemy["name"]),
									 NSLocalizedString(enemy["introText"]),
									  CCSprite.spriteWithFile(enemy["bossHeadSprite"]));
					}
				}
				
				//trigger quests
				qm.questTriggerCheckLevelUp();
			}
				break;
				
			case this.guiTags.kGuiTagAlertWindowSurpriseBrain:
				this.publishDailySurprise();
				break;
				
			default:
				break;
		}
   },
   
   showStorageTutorialMessage: function()
   {
       var gs = GameState;
       var qm = ZFQuestMan;
       if (gs._zfGameData._level >= ZFGameDefines.STORAGE_AVAILABLE_LVL && !(gs._zfGameData._gflags & ZFGameFlags.GFLAG_TUTORIAL_STORAGE))
       {
           gs._zfGameData._gflags |= ZFGameFlags.GFLAG_TUTORIAL_STORAGE;
           var newAlertWindow = ZFAlertWindow.alertWindowSimple(NSLocalizedString("Storage is Here!"),
                                                                NSLocalizedString("Farm feeling a little cramp? Keep it nice n' tidy with storage buildings! Store away old stale items, and spice up yer farm with new stuff.\nA storage shed is now available for you to purchase in the market!"),
                                                                CCSprite.spriteWithFile("storageIcon.png"));
           qm.addQuestWithAlert(newAlertWindow, CCSprite.spriteWithFile("stex1004.png"));
       }
   },

   showCombinerTutorialMessage: function()
   {
       var gs = GameState;
       if (gs._zfGameData._level >= ZFGameDefines.COMBINER_AVAILABLE_LVL && !(gs._zfGameData._gflags & ZFGameFlags.GFLAG_TUTORIAL_COMBINER))
       {
           gs._zfGameData._gflags |= ZFGameFlags.GFLAG_TUTORIAL_COMBINER;
           this.displayAlertSimple(NSLocalizedString("Combine Zombies!"),
        		   sprintf(NSLocalizedString("You can now grow super strong zombies in the %@ by combining two of yer zombies.\n\nThe %@ is now available for you to purchase in the market."), NSLocalizedString(ZFGameDefines.kCombiner01ItemName), NSLocalizedString(ZFGameDefines.kCombiner01ItemName)),
                                   CCSprite.spriteWithFile("combineZombiesIcon.png"));
       }
   },
   
   //- (void)displayZombieSelectionMenu
   displayZombieSelectionMenu: function()
   {
	   var zs = ZFZombieSelectionMenu.zombieSelectionMenu();
	   zs.openMenu();
   },
   
   //- (void)beginInvasionEvent
   beginInvasionEvent: function()
   {
   		this.disableMenus(); //dismissMenu callback enables menu, disable it again while the invasion is loading (and loadscreen isn't up yet)
        
        //TODO
        // EAGLContext *k_context = [[[EAGLContext alloc] initWithAPI :kEAGLRenderingAPIOpenGLES1
        //   													 sharegroup:[[[[CCDirector sharedDirector] openGLView] context] sharegroup]] autorelease];
        // [EAGLContext setCurrentContext:k_context]; 
        
        var farmScene = CCDirector._runningScene;
        
        //if (true)//FBMan.fbman().connectedToInternet())
        //{
            //var scene = new CCScene();
            //var loadInstance = LoadScreen.getInstance();
            
            //if user puts app in background before invasion event, loadscreen may already be added
            //if (!loadInstance._imageNode && scene)
            //{
            	//FIXME: This should't be necessary with the present implementation of the LoadScreen
                //scene.addChild(LoadScreen.getInstance());
                //CCDirector.replaceScene(scene);
                
                //this.showLoadScreen();
            //}
        //}
        
        var gs = GameState;
        //FIXME : Hardcorded
        var enemyDictionary = this._enemyArray[gs._zfGameData._currentEnemy];
        var enemyDictionaryCopy = {};
		for (var key in enemyDictionary) {
			enemyDictionaryCopy[key] = enemyDictionary[key];
		}
        
        this._fightGameScene = new ZFFightGameScene();
        this._fightGameScene.initWithEnemyDictionary(enemyDictionaryCopy);
        this._fightGameScene._farmGameScene = farmScene;
        
        
    	LoadScreen.show();
    	setTimeout(this.switchToFightScene.bind(this), 2000);
        
        this.removeChildByTag(this.guiTags.kGuiTagWeather, true);
        this.removeToolTip();
		gs.saveGame();
    },
    
    //- (void)switchToFightScene
    switchToFightScene: function()
    {   
    	LoadScreen.hide();
        if (this._fightGameScene)
        	//FIXME: FadeTransition not used. [[CCDirector sharedDirector] replaceScene: [CCFadeTransition transitionWithDuration:0.5 scene:fightGameScene]];
        	//CCDirector.replaceScene(CCFadeTransition.transitionWithDuration(0.5, this._fightGameScene));
        	CCDirector.replaceScene(this._fightGameScene);
    	//[fightGameScene release];
        
    },
    
    //- (void)showLoadScreen
    showLoadScreen: function()
    {
    	LoadScreen.getInstance().show();
    },
    
    //- (void)hideLoadScreen
    hideLoadScreen: function()
    {
    	LoadScreen.getInstance().hide();
    },
    
    showFightResult : function()
    {
    	var fm = ZFFightMan;
    	var am = ZFActorManager;
    	var gs = GameState;
    	var dict = fm._enemyDictionary;
    	if(fm.isGameWon())
    	{
    		var message = dict? NSLocalizedString(dict["invasionSuccessText"]) : "Success" ;
    		this.displayAlertSimple(NSLocalizedString("Invasion Successful!"), message, null);
    		this.beatEnemyFirstTimeMessage();
    		this.fightWonTutorialMessage();
    		
    		NSNotificationCenter.defaultCenter().postNotificationName(ZFGameDefines.kInvasionSuccessfulNotification, null, fm._enemyDictionary["name"]);
    	}
    	else
    	{
    		//refund lost zombies
    		GameState.gameState().addResource(GameData.gameResources.kGameResourceGold, fm._refund);
    		var message = dict ? NSLocalizedString(dict["invasionFailedText"]) : "Failed";
    		this.displayAlertSimple(NSLocalizedString("Invasion Failed!"), message, null);
    		
    		/* FIXME: Flurry
    		//flurry
    		NSDictionary *eventDictionary = [NSDictionary dictionaryWithObjectsAndKeys: [NSNumber numberWithInt:gs.zfGameData.level], @"level", nil];
    		[FlurryAPI logEvent:kFlurryEvent_fightLostAtLevel withParameters:eventDictionary];*/
    	}
    	
    	// Despawn dead zombies
    	for (var actorKey in fm._farmDespawnList)
    	{
    		var actor = fm._farmDespawnList[actorKey];
    		am.despawnFarmActor(actor);
    	}
    	
    	if(gs.canInvade())
    	{
    		this.showInvasionMenu(null);
    	}
    	else
    	{
    		this.hideInvasionMenu(null);
    	}
    	
    	am.incrementAllZombiesFightCount();
    	
    	/* FIXME: Flurry
    	NSDictionary *eventDictionary = [NSDictionary dictionaryWithObjectsAndKeys:
    									 [NSNumber numberWithBool:[fm isGameWon]], NSLocalizedString(@"Won", nil), 
    									 [NSNumber numberWithInt:gs.zfGameData.level], NSLocalizedString(@"level", nil),
    									 [NSNumber numberWithInt:fm.zombieCasualty], NSLocalizedString(@"Zombie Casualty", nil),
    									nil];
    	
    	[FlurryAPI logEvent:kFlurryEvent_fightResult withParameters:eventDictionary];*/
    	
    	gs.saveGameReal();
    	//Harcoded
    	this.enableMenus(false);
    },
    
    beatEnemyFirstTimeMessage : function()
    {
//    	var fb = FBMan.fbman();
    	var fm = ZFFightMan;
    	var gs = GameState;
    	
    	if (this.isFirstTimeBeatingEnemy(true))
    	{
    		this.displayAlertSimple(NSLocalizedString("Enemy Conquered!"), sprintf(NSLocalizedString("Congratulations on conquering %@!\nYou earned %ixp for beating this enemy for the first time."), NSLocalizedString(fm._enemyName), fm._xpGained ), null); 
    		gs.addResource(GameData.kGameResourceXP, fm._xpGained);
    		
    		/* FIXME: Facebook
    		if([fb connectedToInternet] && [fb isSessionValid])
    		{
    			var imageUrl = fm._enemyDictionary["imageURL"];
    			var name = sprintf(NSLocalizedString("%@ conquered %@"), fb._playerName, NSLocalizedString(fm._enemyName, fm._enemyName)));
    			var caption =  sprintf(NSLocalizedString("%@'s home grown zombies beat the enemy somethin' fierce in Zombie Farm.\n%@ plundered a big ol' pile of gold!"), fb._playerName, fb._playerName);
    			fb.publishFeed(name, caption, "", imageUrl, null);
    		}*/
    	}
    	
    	RateGame.askFirstInvasion();
    },
    
    fightWonTutorialMessage : function()
    {
    	var gs = GameState;
    	var qm = ZFQuestMan.questMan();
    	
    	if (!gs._zfGameData._gflags & ZFGameFlags.GFLAG_TUTORIAL_ZOMBIE_RANK)
    	{
    		gs._zfGameData._gflags |= ZFGameFlags.GFLAG_TUTORIAL_ZOMBIE_RANK;
    		var newAlertWindow = ZFAlertWindow.alertWindowSimple(NSLocalizedString("Zombie Veterans",
    															 NSLocalizedString("Zombies get more experience with each invasion they survive. All yer zombies have been promoted to \"Veteran\", and have received a small boost to their stats. If they keep survivin' they might just make it all the way to Master!"),
    															 CCSprite.spriteWithFile("veteran.png")));
    		qm.addQuestWithAlert(newAlertWindow,CCSprite.spriteWithFile("stex1004.png"));
    	}
    },
    
    startInitialSchedules : function()
    {
    	this.schedule(this.tick, ZFGameDefines.GUI_UPDATE_INTERVAL, "tick");
    	this.schedule(this.updateInvasionLabel, 2, "updateInvasionLabel");
    },
    
    publishAchievement : function(identifier, desc, img) 
    {
//    	var fb = FBMan.fbman();
//    	
//    	var imageUrl = NSLocalizedString(img, null);
//    	var name = sprintf(NSLocalizedString("%@ has earned the achievement: %@!", "Congratulatons!"), fb._playerName, NSLocalizedString(identifier, null));
//    	var caption = NSLocalizedString(desc, null);
//    	
//    	//TODO
////    	if ([fb connectedToInternet] && [fb isSessionValid])
////    		[fb publishFeed:name withCaption:caption withDescription:@"" withImageURl:imageUrl withDelegate:nil];
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Tiles/ZFTileManager'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Tiles/ZFTileManager'] || {}; $MODULE_REGISTRY['Code/Game/Tiles/ZFTileManager'] = exports; var CCTMXTiledMap = require('Code/Cocos2D/CCTMXTiledMap').CCTMXTiledMap;

exports.ZFTileManager = Core.Class.singleton({
	classname : 'ZFTileManager',

	kTagMapSpriteManTempObjectPlacementSpriteMan : 100,

	initialize : function() {
		this._tileCoordinateToDelete = ccp(-1, -1);
//		console.log("ZFTileManager initialize");
		this._exist = false;

		this._zombieCombinerList = null; //Array
		this._zombiePatchList = null // ARray
		//#ifdef ZF_REMOTE_MARKET
		//		ZFRemoteMarket *remote = [ZFRemoteMarket theRemoteMarket];
		//		[remote setToLocalTileIfUpdated];		//call this here, since on load the new market can still be downloading
		//#endif
		//		
		//		// options online storage... [NSDictionary dictionaryWithContentsOfURL:[NSURL URLWithString:@"http://localhost/~henrik/foo.xml"]];
		//		

		//TODO : grassGID = [GameState gameState].zfGameData.baseGID;

		//TODO : [[NSNotificationCenter defaultCenter] addObserver:self 
		//												 selector:@selector(refreshFarmParticles:) 
		//												     name:kDayCycleStateChangeNotification 
		//												   object:nil];

	},

	//use this to construct the tile manager properly asynchronously with a callback at the end	
	init : function(cb) {
		this._cb = cb;
		Storage.FileSystem.readFile("./Content/TileProperties.plist.json", false, this.finishInit.bind(this));
	},

	finishInit : function(err, file) {
		if (err) {
			console.log("ZFTileManager error read file = " + err);
		} else if (file) {
			this._tilePropertiesDictionary = eval('(' + file + ')');
			//			console.log("dictionnary = " + this._tilePropertiesDictionary.soil_harvestable_tomatoes.name);

			this._grassGID = 1;
			this._occupiedGID = this._grassGID + 1;

			this._tileSpriteManagers = new Array(ZFGameDefines.getConst("MAXMAPSIZE"));

			for ( var i = 0; i < ZFGameDefines.getConst("MAXMAPSIZE"); i++) {
				this._tileSpriteManagers[i] = new Array(ZFGameDefines.getConst("MAXMAPSIZE"));
				;
			}
			console.log("**************** ZFTileManager init finished asynchronously ***************");
			this._exist = true;
			this._cb();
		}
	},

	exists : function() {
		return this._exist;
	},

	tileManager : function() {
		return this;
	},

	pointInPolygon : function(poly, numberOfPolySides, point) {
		var i, j = numberOfPolySides - 1;
		var oddNodes = false;

		for (i = 0; i < numberOfPolySides; i++) {
			if ((poly[i]._y < point._y && poly[j]._y >= point._y) || (poly[j]._y < point._y && poly[i]._y >= point._y)) {
				if (poly[i]._x + (point._y - poly[i]._y) / (poly[j]._y - poly[i]._y) * (poly[j]._x - poly[i]._x) < point._x) {
					oddNodes = !oddNodes;
				}
			}

			j = i;
		}

		return oddNodes;
	},

	tileFromScreenPoint : function(pointOnScreen, considerOffMap) {
		var pointOnMap = ccpSub(pointOnScreen, this._map.getPosition());
		return this.tileFromMapPoint(pointOnMap, considerOffMap);
	},

	tileFromMapPoint : function(pointOnMap, considerOffMap) {
		var tmp = new Core.Point();
		var ret = new Core.Point();

		// get the x and y positions on screen relative to scroll and center coords
		tmp.setX(pointOnMap._x - (this._map._contentSize._width / 2));
		tmp.setY(pointOnMap._y - (this._map._contentSize._height - 24));

		// start to figure the map coordinates
		ret.setX(tmp._y - (tmp._x / 2));
		ret.setY(tmp._y + (tmp._x / 2));

		if (ret._x < 0)
			ret.setX(ret._x - 23);
		if (ret._y < 0)
			ret.setY(ret._y - 23);

		ret.setX(Math.floor((ret._x / -24.0)));
		ret.setY(Math.floor(ret._y / -24.0));

		if (ret._x < 0)
			ret.setX(0);

		if (ret._y < 0)
			ret.setY(0);

		if (ret._x >= this._map._mapSize._width)
			ret.setX(this._map._mapSize._width - 1);

		if (ret._y >= this._map._mapSize._height)
			ret.setY(this._map._mapSize._height - 1);

		return ret;
	},

	// returns the tile dimensions from a point
	// e.g. send it the rootTile from SaveTile class and it'll send actual dimensions 
	//	      with consideration to orientation
	tileDimensionsFromPoint : function(tileCoordinate) {
		var tileDimensions = new Core.Size(1, 1);

		var tileGID = this._baseTileLayer.tileGIDAt(tileCoordinate);
		if (tileGID != this._occupiedGID) {
			return tileDimensions;
		}

		var key = this.tileKeyFromPoint(tileCoordinate);

		if (key) {
			var tsprite = this.tSpriteFromTile(tileCoordinate);
			var orientation = tsprite._tile._orientation;

			tileDimensions = this.tileDimensionsFromKey(key, orientation);
		}

		return tileDimensions;
	},

	tilePropertiesFromPoint : function(tileCoordinate) {
		var key = this.tileKeyFromPoint(tileCoordinate);

		if (key === null) {
			return null;
		}

		return this._tilePropertiesDictionary[key];
	},

	tileKeyFromPoint : function(tileCoordinates) {
		var tSprite = TSprite.findByCoordinates(tileCoordinates);
		if (tSprite && tSprite._tile) {
			return tSprite._tile._key;
		}

		return null;
	},

	setMap : function(aMap) {
		//		console.log("ZFTileManager setMap");
		if (this._map != aMap) {
			if (this._map) {
				//				console.log("ZFTileManager replace map");

				//				for (var j=0; j< this._map._mapSize._height; j++)
				//				{
				//					for (var k=0; k < this._map._mapSize._width; k++)
				//					{
				//						var tSprite = TSprite.findByCoordinates(ccp(k,j));
				//						
				//						if (tSprite && tSprite._sprite)
				//						{
				//							console.log("tsprite parent 0 = " + tSprite._sprite.getParent());
				//						}
				//					}
				//				}

				var mapToRemove = this._map;
				var mapParent = mapToRemove.getParent();
				//				mapParent._map = null;
				//				this._map = null;

				var z = 0;
				var newBaseTileLayer = aMap.layerNamed("base");

				for ( var y = 0; y < mapToRemove._mapSize._height; y++) {
					for ( var x = 0; x < mapToRemove._mapSize._width; x++) {
						var gid = this._baseTileLayer.tileGIDAt(ccp(x, y));
						newBaseTileLayer.setTileGID(gid, ccp(x, y));
					}
				}

				this._baseTileLayer = null;
				this._baseTileLayer = newBaseTileLayer;
				aMap.reorderChild(this._baseTileLayer, -1);

				var children = mapToRemove._children;

				//				for (var key in children)
				//				{
				//					var node = children[key];
				//					console.log(node);
				//				}

				for ( var key = children.length - 1; key >= 0; key--) {
					var node = children[key];
					//					console.log("children len = " + children.length);
					//					console.log(node);

					if (node.classname == "CCTMXLayer") {
						continue;
					}

					//					[node retain];
					var childrenArrayOfNode = null;
					if (node._children)
						childrenArrayOfNode = node._children;
					z = node.getDepth();
					mapToRemove.removeChild(node, false);
					aMap.addChild(node, z);

					for ( var keybis = childrenArrayOfNode.length - 1; keybis >= 0; keybis--) {
						var childOfNode = childrenArrayOfNode[keybis];
						//						console.log(childOfNode);
						//						[childOfNode retain];
						var z1 = childOfNode.getDepth();
						node.removeChild(childOfNode, false);
						node.addChild(childOfNode, z1);
						//						[childOfNode release];
					}
					//					[node release];
				}
				//				console.log("children len = " + children.length);

				z = mapToRemove.getDepth();

				mapParent.removeChild(mapToRemove, false);

				mapParent._map = aMap;
				this._map = aMap;
				mapParent.addChild(this._map, z);

				//[mapToRemove release];

				//place all sprites at new location

				for ( var j = 0; j < this._map._mapSize._height; j++) {
					for ( var k = 0; k < this._map._mapSize._width; k++) {
						var tSprite = TSprite.findByCoordinates(ccp(k, j));

						if (tSprite && tSprite._sprite) {
							//							console.log("tsprite parent1 = " + tSprite._sprite.getParent());
							if (tSprite._animatedSprites) {
								this.replaceTile(ccp(k, j), tSprite._tile._key, false, tSprite._tile._orientation);
							} else {
								var newPosition = this.mapPointFromTile(ccp(k, j));
								//TODO special effects
								//								if(tSprite.effects)
								//								{
								//									for(CCQuadParticleSystem *effect in tSprite.effects)
								//									{
								//										CGPoint effectOffset = ccpSub(effect.position,tSprite.sprite.position);
								//										
								//										effect.position = ccpAdd(effectOffset, newPosition);
								//									}
								//								}	
								//								if(tSprite.emmiter)
								//								{
								//									tSprite.emmiter.position = ccpAdd(newPosition,ccp(20,50));
								//									[tSprite.emmiter.parent reorderChild:tSprite.emmiter z:tSprite.sprite.zOrder +1];
								//								}
								//								if(tSprite.light)
								//								{
								//									CGPoint lightOffset = ccpSub(tSprite.light.position,tSprite.sprite.position);
								//									
								//									tSprite.light.position = ccpAdd(lightOffset, newPosition);
								//								}									
								//								if(tSprite.animation)
								//								{
								//									CGPoint animationOffset = ccpSub(tSprite.animation.position,tSprite.sprite.position);
								//									
								//									tSprite.animation.position = ccpAdd(animationOffset, newPosition);
								//								}
								tSprite._sprite.setPosition(newPosition);
							}
						}
					}
				}

				//place all actors at new location
				for ( var key3 = ZFActorManager._actorList.length - 1; key3 >= 0; key3--)
				//				for (var key3 in ZFActorManager._actorList)
				{
					var actor = ZFActorManager._actorList[key3];
					var destPos = ccpAdd(ZFTileManager.mapPointFromTile(actor._farmData._currentTile), ccp(24, 12));
					//					console.log("destpos = " + stringFromPoint(destPos));
					actor._farmData._destinationTile = actor._farmData._currentTile.clone();
					actor._destinationPoint = destPos.clone();
					actor.setPosition(destPos.clone());

					//					console.log(actor);
				}

				this.changeClimate();
			} else {
				console.log("ZFTileManager set new map");
				this._map = aMap;
			}
		}

		if (!this._baseTileLayer) {
			this._baseTileLayer = this._map.layerNamed("base");
			this._map.reorderChild(this._baseTileLayer, -1);
		}

		//		for (var j=0; j< this._map._mapSize._height; j++)
		//		{
		//			for (var k=0; k < this._map._mapSize._width; k++)
		//			{
		//				var tSprite = TSprite.findByCoordinates(ccp(k,j));
		//				
		//				if (tSprite && tSprite._sprite)
		//				{
		//					console.log("tsprite parent = " + tSprite._sprite.getParent());
		//				}
		//			}
		//		}

	},

	deleteTile : function(tileCoordinate) {
		var gid = this._baseTileLayer.tileGIDAt(tileCoordinate);
		var tSpriteObject = TSprite.findByCoordinates(tileCoordinate);

		if (gid == this._grassGID || !gid || !tSpriteObject || !tSpriteObject._tile) {
			return;
		}

		this._tileCoordinateToDelete = tileCoordinate;
		this.deleteConfirmedDisplaySale(false, true);
	},

	setupFirstTimeMap : function(cb) {
		//		console.log("ZFTileManager.setupFirstTimeMap: start");
		// gets called after loadmap, so all the init stuff should be in place
		//we just need some tiles to start out our 1st farm
		this._cbSetup = cb;
		var self = this;

		var marketArray = DataPreloader._marketData;

		var item1 = 0;
		var item1b = 0;
		var item2 = 0;
		var item2b = 0;

		for (item2 = 0; item2 < marketArray.length; item2++) {
			if (marketArray[item2].name == "Tomatoes") {
				item2 = marketArray[item2];
				break;
			}
		}

		for (item2b = 0; item2b < marketArray.length; item2b++) {
			if (marketArray[item2b].name == "Onions") {
				item2b = marketArray[item2b];
				break;
			}
		}
		//		console.log("retrieved item = " + item2b.name);

		for (item1 = 0; item1 < marketArray.length; item1++) {
			if (marketArray[item1].name == "ZombieActorRegularTier1") {
				item1 = marketArray[item1];
				break;
			}
		}

		for (item1b = 0; item1b < marketArray.length; item1b++) {
			if (marketArray[item1b].name == "ZombieActorGardenTier1") {
				item1b = marketArray[item1b];
				break;
			}
		}

		self.replaceTile(new Core.Point(14, 12), "soil_harvestable_tomatoes", false, 0);
		self.replaceTile(new Core.Point(14, 16), "soil_seedling_onions", false, 0);
		self.replaceTile(new Core.Point(14, 20), "soil_plowed", false, 0);
		self.replaceTile(new Core.Point(18, 12), "soil_harvestable_zombie", false, 0);
		self.replaceTile(new Core.Point(18, 16), "soil_germinating_garden_zombie", false, 0);
		self.replaceTile(new Core.Point(18, 20), "soil_plowed", false, 0);
		self.setupFirstTimeMapFinished();
		//		console.log("ZFTileManager.setupFirstTimeMap: " + (Core.Time.getRealTime()/1000) + "s");
	},

	setupFirstTimeMapFinished : function() {
		var tSprite = TSprite.findByCoordinates(new Core.Point(14, 12));
		tSprite._tile._date = Core.Time.getRealTime() / 1000;
		tSprite._tile._plantDate = Core.Time.getRealTime() / 1000;
		tSprite._tile._endCropTile = "soil_harvestable_tomatoes";
		tSprite = TSprite.findByCoordinates(new Core.Point(14, 16));
		tSprite._tile._date = Core.Time.getRealTime() / 1000;
		tSprite._tile._plantDate = Core.Time.getRealTime() / 1000;
		tSprite._tile._endCropTile = "soil_harvestable_onions";
		tSprite = TSprite.findByCoordinates(new Core.Point(18, 12));
		tSprite._tile._date = Core.Time.getRealTime() / 1000;
		tSprite._tile._plantDate = Core.Time.getRealTime() / 1000;
		tSprite._tile._endCropTile = "soil_harvestable_zombie";
		tSprite = TSprite.findByCoordinates(new Core.Point(18, 16));
		tSprite._tile._date = Core.Time.getRealTime() / 1000;
		tSprite._tile._plantDate = Core.Time.getRealTime() / 1000;
		tSprite._tile._endCropTile = "soil_harvestable_garden_zombie";
		//		console.log("@@@@@@@@@@@@@ finished init setup first map cb = " + cb + " this = "+ this);
		this._cbSetup();
		this._cbSetup = null;
	},

	fixedTileKey_checkUsesSeparateRotateSprite : function(key, check) {

		key = this.fixedTileKey(key);
		var newKey = null;
		if (check) {
			if (this._tilePropertiesDictionary[key]["usesSeparateRotateSprite"]) {
				var keycopy = key;
				if ((key.length > 4) && (keycopy.substring(keycopy.length - 3, keycopy.length - 2) == "_")) {
					newKey = key.substring(0, key.length - 3) + "_01";
				}
			}
		}

		if (!newKey)
			newKey = key;

		return newKey;
	},

	luckFromKey : function(key) {
		var tileItemDictionary = this._tilePropertiesDictionary[key];
		var luck = 0;

		if (key && tileItemDictionary) {
			var luckData = tileItemDictionary["luck"];
			if (luckData) {
				luck = luckData;
			} else {
				var tileWidth = tileItemDictionary["tileWidth"];
				var tileHeight = tileItemDictionary["tileHeight"];

				if (tileWidth && tileHeight) {
					luck = tileWidth * tileHeight;
				}
			}
		}

		return luck;
	},

	fixedTileKey : function(key) {
		var newKey = null;

		// if the key does not exist in the dictionary
		if (!(this._tilePropertiesDictionary[key])) {
			if (key == "hedgeNormalA") {
				newKey = "hedge_01";
			} else if (key == "hedgeNormalB") {
				newKey = "hedge_02";
			} else if (key == "cobbleStoneRoadBend_02") // only affects developer saves when this was in effect
			{
				newKey = "cobbleStoneRoadBend_04";
			} else if (key == "roadStraightA") {
				newKey = "roadStraight";
			} else if (key == "roadStraightB") {
				newKey = "roadStraight";
			} else if (key == "roadBendA") // roadBendA was == to <
			{
				newKey = "roadBend_04";
			} else if (key == "roadBendB") // roadBendB was == to >
			{
				newKey = "roadBend_04";
			} else if (key == "roadBendC") // roadBendC was == to ^
			{
				newKey = "roadBend_01";
			} else if (key == "roadBendD") // roadBendD was == to v
			{
				newKey = "roadBend_03";
			} else // the default is ALWAYS the name - 3 characters + _01 with a flipped orientation, takes care of all old fences
			{
				var keycopy = key;
				if ((key.length > 4) && (keycopy.substring(keycopy.length - 3, keycopy.length - 2) == "_")) {
					newKey = key.substring(0, key.length - 3) + "_01";
				} else {
					newKey = key;
				}
			}
		} else {
			newKey = key;
		}
		return newKey;
	},

	// used for fixing 
	fixSaveTileKey : function(tile) {
		var key = tile._key;
		var orientation = 0;
		var tempDictionary = this._tilePropertiesDictionary[key];

		var newKey = null;

		/// for debugging purposes, if it crashes it will let me know the original key we're trying to change
		if (!tempDictionary) {
			console.log("assert with key " + key);
		}

		if (key == "hedgeNormalA") {
			newKey = this.fixedTileKey(key);
			orientation = 0;
		} else if (key == "hedgeNormalB") {
			newKey = this.fixedTileKey(key);
			orientation = 1;
		} else if (key == "cobbleStoneRoadBend_02") // only affects developer saves when this was in effect
		{
			newKey = this.fixedTileKey(key);
			orientation = 1;
		} else if (key == "roadStraightA") {
			newKey = this.fixedTileKey(key);
			orientation = 0;
		} else if (key == "roadStraightB") {
			newKey = this.fixedTileKey(key);
			orientation = 1;
		} else if (key == "roadBendA") // roadBendA was == to <
		{
			newKey = this.fixedTileKey(key);
			orientation = 3;
		} else if (key == "roadBendB") // roadBendB was == to >
		{
			newKey = this.fixedTileKey(key);
			orientation = 1;
		} else if (key == "roadBendC") // roadBendC was == to ^
		{
			newKey = this.fixedTileKey(key);
			orientation = 0;
		} else if (key == "roadBendD") // roadBendD was == to v
		{
			newKey = this.fixedTileKey(key);
			orientation = 2;
		} else // the default is ALWAYS the name - 3 characters + _01 with a flipped orientation, takes care of all old fences
		{
			var keycopy = key;
			if ((key.length > 4) && (keycopy.substring(keycopy.length - 3, keycopy.length - 2) == "_")) {
				newKey = key.substring(0, key.length - 3) + "_01";
			} else {
				newKey = key;
			}
			orientation = 1;
		}

		/// if it still doesn't exist then let me know on console ////
		tempDictionary = this._tilePropertiesDictionary[newKey];
		if (!tempDictionary) {
			console.log("assert with key " + key);
		}

		// sets new key
		tile._key = newKey;
		tile._orientation = orientation;
	},

	// checks the current tile in zombieActor farmData
	zombieAtTile : function(tileCoordinates) {
		var acm = ZFActorManager;
		for ( var key in acm._actorList) {
			var z = acm._actorList[key];
			if (!(z instanceof ZombieActor)) {
				continue;
			}

			if (CGPointEqualToPoint(z._farmData._currentTile, tileCoordinates)) {
				return true;
			}
		}

		return false;
	},

	// toggle between alternate tiles, also perform actions associated with toggling here
	toggleTile : function(tileCoordinate) {
		var tileDictionary = this.tilePropertiesFromPoint(tileCoordinate);

		if (tileDictionary && tileDictionary["alternateTile"]) {
			// get alternate dictionary entry
			var key = tileDictionary["alternateTile"];
			var alternateTileDictionary = this._tilePropertiesDictionary[key];

			if (alternateTileDictionary["allowZombieToggle"] && this.zombieAtTile(tileCoordinate)) {
				return;
			}

			// get tile at current location with orientation
			var tSprite = TSprite.findByCoordinates(tileCoordinate);
			var orientation = tSprite._tile._orientation;

			// overwrite the tile
			this.replaceTile(tileCoordinate, key, false, orientation);

			// at this point current tile dictionary == alternateTileDictionary
			// if tile performs action (make this use a specified action)
			if (alternateTileDictionary["summonZombies"]) {
				var acm = ZFActorManager;
				for ( var key in acm._actorList) {
					var z = acm._actorList[key];
					if (!(z instanceof ZombieActor)) {
						continue;
					}

					if (z._brainState == kActorBrainStateAtHome) {
						continue;
					}

					z._thought = ZombieActor.zombieThoughts.kZombieThoughtBrains;
					z.moveToTile(tileCoordinate);
					z._brainState = kActorBrainStatePerformingTileAction;
				}
			} else {
				// automatically sets it to turn zombies off (again change this to use a specified action_
				var acm = ZFActorManager;
				for ( var z in acm._actorList) {
					if (!(z instanceof ZombieActor)) {
						continue;
					}

					if (z._brainState == kActorBrainStateAtHome) {
						continue;
					}

					z._farmData._destinationTile = z._farmData._currentTile; // cleaning up destination tile
					z._destinationPoint = z._ccPosition; // stopping movement update

					z._thought = ZombieActor.zombieThoughts.kZombieThoughtHmm;
					z.setState(kActorStateIdle);
					z._brainState = kActorBrainStateLookingForHome;
				}
			}

			// PUT ACTIONS FOR ALTERNATE TILE HERE USING ALTERNATE TILE DICTIONARY
			// sample : if([alternateTileDictionary objectForKey:@"someActionDictionaryOrFlagOrEtc"]){};
			// p.s.   : SHIKAKA!!!
		}
	},

	replaceTile_withGIDkey_considerNeighbouringTiles : function(tileCoordinate, key, considerNeighbouringTiles) {
		return this.replaceTile(tileCoordinate, key, considerNeighbouringTiles, 0);
	},

	//	- (BOOL)replaceTile:(CGPoint)tileCoordinate withGIDkey:(NSString*)key considerNeighbouringTiles:(BOOL)considerNeighbouringTiles orientation:(int)orientation;
	replaceTile : function(tileCoordinate, key, considerNeighbouringTiles, orientation, color) {
		//		console.log("key: " + key);
		if (arguments.length < 4) {
			orientation = 0;
		}

		var isCorrupt = false;

		//removes all textures that are not needed (frees memory)
		var gs = GameState;
		var dictionary = this._tilePropertiesDictionary[key];

		// Dont assert here anymore, just return if you cant recognize the item
		if (!dictionary) {
			key = "soil_plowed";
			dictionary = this._tilePropertiesDictionary["soil_plowed"];
			isCorrupt = true;
		}

		// for rotations
		var usesSeparateRotateSprite = dictionary["usesSeparateRotateSprite"];
		var rotations = dictionary["rotations"];
		var useThisKey = null;

		// not really necessary but is a fail safe against crashing
		var isUnderscore = false;
		if (key.length > 4) {
			isUnderscore = (key.charAt(key.length - 3) == "_");
		}
		if ((rotations == 3 || usesSeparateRotateSprite) && isUnderscore) // objects can rotate 0,1, or 3 times ONLY
		{
			var subStringLength = key.length;
			// shave off last 3 characters of NSString keyValue and then set appropriate tile key 

			// NAMING CONVENTION
			// ^ = key_01 = top rotation 
			// > = key_02 = right rotation (left rotation that's flipped)
			// v = key_03 = bottom rotation
			// < = key_04 = left rotation
			switch (orientation) {
			case 1:
				if (usesSeparateRotateSprite) {
					useThisKey = key.substring(0, subStringLength - 3) + "_02";
				} else {
					useThisKey = key.substring(0, subStringLength - 3) + "_04";
				}
				break;
			case 2:
				useThisKey = key.substring(0, subStringLength - 3) + "_03";
				break;
			case 3:
				useThisKey = key.substring(0, subStringLength - 3) + "_04";
				break;
			case 0:
			default:
				useThisKey = key.substring(0, subStringLength - 3) + "_01";
				break;
			}
			dictionary = this._tilePropertiesDictionary[useThisKey];
		} else {
			useThisKey = key;
		}

		var tileSize = this.tileDimensionsFromKey(useThisKey, orientation);
		if (considerNeighbouringTiles && !this.canPlaceTileOfSize(tileSize, tileCoordinate)) {
			return false;
		}

		var flipY = Boolean(dictionary["flipY"]);

		var sprite = null;
		var ma = this._tileSpriteManagers[tileCoordinate._x];
		var mgr = ma[tileCoordinate._y];
		var filename = dictionary["spriteSheet"];

		//replace this manager no matter what
		mgr = this.cleanupTileSpriteManagerAtCoordinate(tileCoordinate);

		if (!mgr) {
			// SHIKAKA : Z-ORDER ISSUES

			//make one CCSpriteSheet
			mgr = new CCSpriteSheet();
			mgr.initWithFile(filename, 1);
			//[[tileSpriteManagers objectAtIndex:tileCoordinate.x] replaceObjectAtIndex:tileCoordinate.y withObject:mgr];
			//this._tileSpriteManagers[tileCoordinate._x].splice(tileCoordinate._y, 1, mgr);
			this._tileSpriteManagers[tileCoordinate._x][tileCoordinate._y] = null;
			this._tileSpriteManagers[tileCoordinate._x][tileCoordinate._y] = mgr;

			var newZ = 0;
			var zOffset = 0;
			var indexToInsertAt = -1;
			var indexToInsertAfter = -1;
			newZ = tileCoordinate._y + tileCoordinate._x;

			var coordinateToFixLeft = null;
			var coordinateToFixRight = null;

			if (tileSize._height == tileSize._width) {
				zOffset = tileSize._width - 1;

				newZ -= zOffset;

				// get tiles adjacent to the object at the same depth value
				coordinateToFixLeft = new Core.Point(tileCoordinate._x - tileSize._width, tileCoordinate._y + 1);
				coordinateToFixRight = new Core.Point(tileCoordinate._x + 1, tileCoordinate._y - tileSize._height);
			} else if (tileSize._width > tileSize._height)// irregular tiles 
			{
				// may add error calculation in here for irregular
				zOffset = tileSize._height - 1; //- tileSize.height; 

				if (tileSize._width > 2) {
					zOffset += 1;
				}

				// - offset ?
				coordinateToFixLeft = new Core.Point(tileCoordinate._x - (zOffset + 1), tileCoordinate._y + 1);
				coordinateToFixRight = new Core.Point(tileCoordinate._x + 1 - zOffset, tileCoordinate._y - tileSize._height);

				newZ -= zOffset;
			} else if (tileSize._height > tileSize._width) {
				zOffset = (tileSize._width - 1);
				if (tileSize._height > 2)
					zOffset += 1;
				// - offset ?

				coordinateToFixLeft = new Core.Point(tileCoordinate._x - tileSize._width, tileCoordinate._y + 1 - zOffset);
				coordinateToFixRight = new Core.Point(tileCoordinate._x + 1, tileCoordinate._y - (zOffset + 1));

				newZ -= zOffset;
			}

			// if left tile is valid
			if (coordinateToFixLeft._x >= 0 && coordinateToFixLeft._x < gs._zfGameData._mapSize && coordinateToFixLeft._y >= 0 && coordinateToFixLeft._y < gs._zfGameData._mapSize) {
				// get savetiles to check
				var tileToFix = gs._zfGameData.saveTileAt(coordinateToFixLeft, new Core.Point(gs._zfGameData._mapSize, gs._zfGameData._mapSize));
				var tileToFix_minusy = gs._zfGameData.saveTileAt(new Core.Point(coordinateToFixLeft._x, coordinateToFixLeft._y - 1), new Core.Point(gs._zfGameData._mapSize, gs._zfGameData._mapSize));
				var tileToFix_plusx = gs._zfGameData.saveTileAt(new Core.Point(coordinateToFixLeft._x + 1, coordinateToFixLeft._y), new Core.Point(gs._zfGameData._mapSize, gs._zfGameData._mapSize));

				// get sprite to get zorder and index value
				var spriteToFix = null;
				if (tileToFix) {
					spriteToFix = this.tSpriteFromTile(tileToFix._ownerTile);
				}
				// 2nd try to get sprite
				if (!spriteToFix && tileToFix) {
					spriteToFix = this.tSpriteFromTile(tileToFix._rootTile);
				}

				// if same depth value
				if (spriteToFix && newZ == spriteToFix._sprite._parent.getDepth()) {
					var temp = this._map._children.indexOf(spriteToFix._sprite._parent);

					if (tileToFix_plusx && (tileSize._width > tileSize._height || (CGPointEqualToPoint(tileToFix_plusx._ownerTile, spriteToFix._tile._rootTile) || CGPointEqualToPoint(tileToFix_plusx._rootTile, spriteToFix._tile._rootTile)))) {
						// it is in front
						indexToInsertAt = temp;
					} else if (tileToFix_minusy && (tileSize._height > tileSize._width || CGPointEqualToPoint(tileToFix_minusy._ownerTile, spriteToFix._tile._rootTile))) {
						// it is behind
						indexToInsertAfter = temp;
					} else {
						// do nothing it's neither in front of or behind
					}
				}
			}

			// if right tile is valid
			if (coordinateToFixRight._x >= 0 && coordinateToFixRight._x < gs._zfGameData._mapSize && coordinateToFixRight._y >= 0 && coordinateToFixRight._y < gs._zfGameData._mapSize) {
				var tileToFix = gs._zfGameData.saveTileAt(coordinateToFixRight, new Core.Point(gs._zfGameData._mapSize, gs._zfGameData._mapSize));
				var tileToFix_minusx = gs._zfGameData.saveTileAt(new Core.Point(coordinateToFixRight._x - 1, coordinateToFixRight._y), new Core.Size(gs._zfGameData._mapSize, gs._zfGameData._mapSize));
				var tileToFix_plusy = gs._zfGameData.saveTileAt(new Core.Point(coordinateToFixRight._x, coordinateToFixRight._y + 1), new Core.Size(gs._zfGameData._mapSize, gs._zfGameData._mapSize));

				var spriteToFix = null;
				if (tileToFix) {
					spriteToFix = this.tSpriteFromTile(tileToFix._ownerTile);
				}

				if (!spriteToFix && tileToFix) {
					spriteToFix = this.tSpriteFromTile(tileToFix._rootTile);
				}

				if (spriteToFix && newZ == spriteToFix._sprite._parent.getDepth()) {
					var temp = this._map._children.indexOf(spriteToFix._sprite._parent);

					if (tileToFix_plusy && (tileSize._height > tileSize._width || (CGPointEqualToPoint(tileToFix_plusy._ownerTile, spriteToFix._tile._rootTile) || CGPointEqualToPoint(tileToFix_plusy._rootTile, spriteToFix._tile._rootTile)))) {
						// it is in front // choose lowest index to insert at		
						if (indexToInsertAt == -1) {
							indexToInsertAt = temp;
						}
						if (indexToInsertAt > temp) {
							indexToInsertAt = temp;
						}
					} else if (tileToFix_minusx && (tileSize._width > tileSize._height || CGPointEqualToPoint(tileToFix_minusx._ownerTile, spriteToFix._tile._rootTile))) {
						// it is behind // choose highest index to insert at
						if (indexToInsertAfter == -1) {
							indexToInsertAfter = temp;
						} else if (indexToInsertAfter < temp) {
							indexToInsertAfter = temp;
						}
					} else {
						// do nothing it's neither in front of or behind
					}
				}
			}

			// insert child at correct index with appropriate z order
			if (indexToInsertAt != -1 && indexToInsertAfter != -1) // if there are tiles you need to be inbetween
			{
				if (indexToInsertAfter > indexToInsertAt) {
					// get object to be in front (object at indexToInsertAt)
					// place it AFTER the object to be behind (object at indexToInsertAfter):
					// - remove object from array
					// - readjust indexToInsertAfter (should have gone down by 1 but just to be sure do indexOfObject)
					// - insert at indexToInsertAfter + 1
					// insert mgr inbetween (insert at indexToInsertAt)

					var object1 = this._map._children[indexToInsertAt];
					var object2 = this._map._children[indexToInsertAfter];
					this._map.removeChild(object1, false);

					indexToInsertAfter = this._map._children.indexOf(object2);
					indexToInsertAt = indexToInsertAfter + 1;

					this._map.insertChild(object1, indexToInsertAt, newZ);
				}

				this._map.insertChild(mgr, indexToInsertAt, newZ);
			} else if (indexToInsertAt != -1 && indexToInsertAfter == -1) // if there is a tile you need to be behind
			{
				this._map.insertChild(mgr, indexToInsertAt, newZ);
			} else //if (indexToInsertAt == -1 && indexToInsertAfter != -1) // if there is a tile you need to be in front of
			{
				this._map.addChild(mgr, newZ);
			} 
//			else // default case
//			{
//				this._map.addChild(mgr, newZ);
//			}
		}

		///// END Z-ORDER ISSUES (STICK A FORK IN IT, CUZ IT'S DONE!!!) ////////	

		//place the new tile on the base tile layer
		this._baseTileLayer.setTileGID(this._occupiedGID, tileCoordinate);

		for ( var x = 0; x < tileSize._width; x++) {
			for ( var y = 0; y < tileSize._height; y++) {
				this.setTileToOccupied_withOwner(new Core.Point(tileCoordinate._x - x, tileCoordinate._y - y), GameState._zfGameData.saveTileAt(tileCoordinate, this._map._mapSize));
			}
		}

		///// GET SPRITE EITHER FROM MANUALLY ENTERED VALUES OR ZWOPTEX FRAME //////
		if (dictionary.frameName) {
			//			CCSpriteFrameCache.sharedSpriteFrameCache().addSpriteFramesWithFile(dictionary.frameList);
			//			var frame = CCSpriteFrameCache.sharedSpriteFrameCache().spriteFrameByName(dictionary.frameName);
			//			sprite = new CCSprite();
			//			sprite.initWithSpriteFrame(frame);
			//CCSpriteFrameCache.sharedSpriteFrameCache().removeUnusedSpriteFrames();

			//			CCSpriteFrameCache.addSpriteFramesWithFile(dictionary.frameList);
			var plist = eval(DataPreloader + "._" + (dictionary.frameList + "").replace(".plist", ""));
			CCSpriteFrameCache.addSpriteFramesWithDictionary(plist, "./Content/" + dictionary.spriteSheet);
			var frame = CCSpriteFrameCache.spriteFrameByName(dictionary.frameName);

			if (frame) {
				sprite = new CCSprite();
				sprite.initWithSpriteFrame(frame);
				//CCSpriteFrameCache.removeUnusedSpriteFrames();
			}

		} else {
			var origin;
			var x = 0;
			var y = 0;
			if (dictionary.x !== undefined) {
				x = dictionary.x;
			}
			if (dictionary.y !== undefined) {
				y = dictionary.y;
			}
			origin = new Core.Point(x, y);
			var width = (dictionary.width) ? dictionary.width : mgr.texture()._imageSize._width;
			var height = (dictionary.height) ? dictionary.height : mgr.texture()._imageSize._height;

			var size = new Core.Size(width, height);
			var spriteRect = new Core.Rect(origin, size);

			sprite = new CCSprite();
			sprite.initWithSpriteSheet(mgr, spriteRect);
		}

		////////// ADJUST SPRITE /////////
		sprite.setPosition(this.mapPointFromTile(tileCoordinate));
		mgr.addChild(sprite,1);

		// rotated !!
		if (orientation == 1 && !usesSeparateRotateSprite) {
			sprite.setFlipX(true);
		}
		if (flipY) {
			sprite.setFlipY(true);
		}

		if (color) {
			sprite.setColor(color);
		}
		//		
		//		// remove anti aliasing !!!
		//		[sprite.texture setAliasTexParameters];
		//		
		//		var anchors = [self anchorsFromKey:useThisKey orientation:orientation];
		var self = this;
		
		this.anchorsFromKey_orientation(useThisKey, orientation, function(anchors) {
			//			anchors = ccp(0.5,0.5);anchorsFromKey_orientation2
			sprite.setAnchorPoint(anchors);
			// This tile must be able to be touched, set this up now.
			var tSprite = new TSprite();

			// already tracked by allMySprites after init !
			tSprite.initWithAtlasSprite_collisionImageName(sprite, filename);

			if (dictionary["tileWidth"] == dictionary["tileHeight"])
				tSprite.setSpecialAnchor(dictionary["pivotx"], dictionary["pivoty"]);

			tSprite._tile = GameState._zfGameData.saveTileAt(tileCoordinate, self._map._mapSize);

			tSprite._tile.resetData();
			tSprite._tile.setKey(useThisKey, self);
			tSprite._tile._orientation = orientation;

			//		// adding effects based on array in TileProperties.plist
			//		NSMutableArray *effectsToAdd = [dictionary objectForKey:@"effects"];
			//		
			//		// PARTICLE EFFECTS //
			//		if(effectsToAdd)
			//		{
			//			// this is retained !
			//			tSprite.effects = [[[NSMutableArray alloc]init]autorelease];
			//			
			//			ZFFarmGameScene *farmScene = (ZFFarmGameScene*)[[CCDirector sharedDirector] runningScene];
			//			DayCycle *cycle    = (DayCycle*)[farmScene getChildByTag:kTagDayAndNight];		
			//			
			//			
			//			BOOL nightParticles = [[dictionary objectForKey:@"nightParticles"]boolValue];
			//			tSprite.nightParticles = nightParticles;
			//			
			//			BOOL turnOFF = (nightParticles && !(cycle.currentState == kDayStateDusk || cycle.currentState == kDayStateNight))?YES:NO;
			//			
			//			for(NSDictionary *effect in effectsToAdd)
			//			{
			//				int flip = 1;
			//				int flipOffset = 0;
			//				
			//				if(orientation == 1 && !usesSeparateRotateSprite)
			//				{
			//					flip = -1;
			//					flipOffset = TILE_WIDTH;
			//				}
			//				
			//				// if this does use a separate rotateSprite gonna need extra code to calculate the position
			//				int offsetX = [[effect objectForKey:@"offsetX"]intValue] * flip + flipOffset;
			//				int offsetY = [[effect objectForKey:@"offsetY"]intValue];
			//				
			//				NSString *particleName = [effect objectForKey:@"name"];
			//				
			//				CCQuadParticleSystem *particle = [CCQuadParticleSystem particleWithFile:particleName];
			//				particle.positionType = kCCPositionTypeGrouped;
			//				particle.position = ccpAdd(tSprite.sprite.position,ccp(offsetX,offsetY));
			//				particle.autoRemoveOnFinish = NO; // these effects have no duration
			//				[map addChild:particle z:mgr.zOrder];
			//				[tSprite.effects addObject:particle];
			//				
			//				if(turnOFF)
			//					[particle stopSystem];
			//			}
			//		}
			//		// END PARTICLE EFFECTS //
			//		
			//		// ANIMATED TILES (ZWOPTEX: THIS IS BETTER)
			//		NSArray *animationDictionaries = [dictionary objectForKey:@"animationDictionaries"];
			//		if(animationDictionaries)
			//		{
			//			tSprite.animatedSprites = [[[NSMutableArray alloc]init]autorelease];
			//			for(NSDictionary *dict in animationDictionaries)
			//			{
			//				[[CCTextureCache sharedTextureCache] addImage:[dict objectForKey:@"animationSheet"]];
			//				[[CCSpriteFrameCache sharedSpriteFrameCache] addSpriteFramesWithFile:[dict objectForKey:@"animationFrameList"]];
			//				
			//				CCSprite *animatedSprite = nil;
			//				NSMutableArray *sequenceActions = [[[NSMutableArray alloc]init]autorelease];
			//				
			//				NSArray *animationFrames = [dict objectForKey:@"animationFrames"];
			//				NSString *moveToOffsets = [dict objectForKey:@"moveToOffsets"];
			//				NSString *moveOffsets = [dict objectForKey:@"moveOffsets"];
			//				NSString *scaleSequence = [dict objectForKey:@"scaleSequence"];
			//				
			//				BOOL noFlip = [[dict objectForKey:@"noFlip"]boolValue];
			//				BOOL onClick = [[dict objectForKey:@"onClick"]boolValue];
			//				
			//				CCSpriteFrame *frame = nil;
			//				
			//				if(animationFrames)
			//				{
			//					frame = [[CCSpriteFrameCache sharedSpriteFrameCache] spriteFrameByName:[animationFrames objectAtIndex:0]];
			//					animatedSprite = [CCSprite spriteWithSpriteFrame:frame];
			//				}
			//				else 
			//				{
			//					frame = [[CCSpriteFrameCache sharedSpriteFrameCache] spriteFrameByName:[dict objectForKey:@"animationFrameName"]];
			//					animatedSprite = [CCSprite spriteWithSpriteFrame:frame];
			//				}
			//				
			//				[animatedSprite.texture setAliasTexParameters];
			//				animatedSprite.position = tSprite.sprite.position;
			//				
			//				if(noFlip && orientation == 1 && !usesSeparateRotateSprite)
			//				{
			//					float offset = (sprite.anchorPoint.x) * sprite.textureRect.size.width;
			//					animatedSprite.position = ccpAdd(animatedSprite.position,ccp(offset,0));
			//				}
			//				
			//				// will only work if the bottom left point of the texture is located at 0,0 
			//				// e.g. it contains no offsets
			//				if([dict objectForKey:@"anchorPoint"])
			//				{
			//					CGPoint anchor = CGPointFromString([dict objectForKey:@"anchorPoint"]);
			//					
			//					float pixelsX = anchor.x * animatedSprite.textureRect.size.width;
			//					float pixelsY = anchor.y * animatedSprite.textureRect.size.height;
			//					
			//					anchor = ccp(pixelsX / animatedSprite.contentSize.width,pixelsY / animatedSprite.contentSize.height);
			//					
			//					animatedSprite.anchorPoint = anchor;
			//					
			//					// note: this does not work yet for flipped images (set noFlip boolean to make sure flipX doesnt get set)
			//				}
			//				else
			//					animatedSprite.anchorPoint = tSprite.sprite.anchorPoint;
			//				
			//				if(orientation == 1 && !usesSeparateRotateSprite && !noFlip)
			//				{
			//					animatedSprite.flipX = YES;
			//				}	
			//				
			//				[tSprite.animatedSprites addObject:animatedSprite];
			//				
			//				if([[dict objectForKey:@"frameBehind"]boolValue])
			//				{
			//					[map addChild:animatedSprite z:mgr.zOrder-1];
			//				}
			//				else 
			//				{
			//					[map addChild:animatedSprite z:mgr.zOrder];
			//				}
			//				
			//				// SHIKAKA : ANIMATION ACTIONS START HERE !!!
			//				BOOL repeatAnimations = NO;
			//				if(!onClick)
			//				{
			//					repeatAnimations = YES;
			//				}
			//				
			//				[ZFAnims setAnimationActions:dict animationFrames:animationFrames sequenceActions:sequenceActions
			//							   moveToOffsets:moveToOffsets moveOffsets:moveOffsets scaleSequence:scaleSequence
			//									  sprite:sprite animatedSprite:animatedSprite repeatForever:repeatAnimations];
			//				
			//				[[CCSpriteFrameCache sharedSpriteFrameCache] removeUnusedSpriteFrames];
			//			}
			//		}
			//		
			//		
			//		// LIGHTS //
			//		if([useThisKey isEqualToString:@"mausoleum3"])
			//		{
			//			tSprite.light = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:30 intensity:0xFF] autorelease];
			//			//tSprite.light.enableColorWriting = NO;
			//			tSprite.light.color = ccc3(0,255,0);
			//			Light* spotLight = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:30 intensity:0xFF] autorelease];	
			//			//spotLight.enableColorWriting = NO; // cookie cut out light
			//			spotLight.color = ccc3(0,255,0);
			//			// add spotlight as a child of the main light
			//			[tSprite.light addChild:spotLight z:0];
			//			
			//			int flip = 1;
			//			int flipOffset = 0;
			//			
			//			if(sprite.flipX && !usesSeparateRotateSprite)
			//			{
			//				flip = -1;
			//				flipOffset = TILE_WIDTH;
			//				/*horizontal flip*/
			//			}
			//			
			//			int offsetX = 30 * flip + flipOffset;
			//			int offsetY = 60;
			//			
			//			tSprite.light.position = ccpAdd(tSprite.sprite.position,ccp(offsetX,offsetY));
			//			spotLight.position = ccp((97-30) * flip,95-60);
			//			[map addChild:tSprite.light z:tSprite.light.zOrder];
			//			
			//		}
			//		else if([useThisKey isEqualToString:@"streetLight"])
			//		{
			//			tSprite.light = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:20 intensity:0xFF] autorelease];
			//			tSprite.light.color = ccc3(255, 255, 255);
			//			
			//			SpotLight* spotLight = [[[SpotLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 width:200 height:75 intensity:0xFF] autorelease];	
			//			spotLight.rotation = 90;
			//			spotLight.color = ccc3(255, 255, 255);
			//			spotLight.enableColorWriting = NO; // cookie cut out light
			//			
			//			// add spotlight as a child of the main light
			//			[tSprite.light addChild:spotLight z:0];
			//			
			//			int flip = 1;
			//			int flipOffset = 0;
			//			int rotOffset = 0;
			//			if(sprite.flipX && !usesSeparateRotateSprite)
			//			{
			//				flip = -1;
			//				flipOffset = TILE_WIDTH;
			//				/*horizontal flip*/
			//				rotOffset = 90 - spotLight.rotation;
			//				spotLight.rotation = 90 + rotOffset;
			//			}
			//			
			//			int offsetX = -35 * flip + flipOffset;
			//			int offsetY = 180;
			//			
			//			tSprite.light.position = ccpAdd(tSprite.sprite.position,ccp(offsetX,offsetY));
			//			[map addChild:tSprite.light z:tSprite.light.zOrder];
			//		}
			//	    else if([useThisKey isEqualToString:@"eggLamp"])
			//		{
			//			tSprite.light = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:80 intensity:0xFF] autorelease];
			//			tSprite.light.color = ccc3(255, 255, 255);
			//			
			//			PointLight* pointLight = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:100 intensity:0x7F] autorelease];
			//			pointLight.enableColorWriting = NO;
			//			[tSprite.light addChild:pointLight];
			//			
			//			
			//			int flip = 1;
			//			int flipOffset = 0;
			//			if(sprite.flipX && !usesSeparateRotateSprite)
			//			{
			//				flip = -1;
			//				flipOffset = TILE_WIDTH;
			//			}
			//			
			//			int offsetX = 24 * flip + flipOffset;;
			//			int offsetY = 165 - 96;
			//			
			//			tSprite.light.position = ccpAdd(tSprite.sprite.position,ccp(offsetX,offsetY));
			//			[map addChild:tSprite.light z:tSprite.light.zOrder];
			//		}
			//		else if([useThisKey isEqualToString:@"candle"])
			//		{
			//			tSprite.light = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:50 intensity:0xFF] autorelease];
			//			tSprite.light.color = ccc3(255, 255, 255);
			//			[tSprite.light runAction:[CCRepeatForever actionWithAction:[CCSequence actions:
			//																		[CCScaleTo actionWithDuration:0.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.5f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:2.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.3f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:1.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		/*
			//																		 [CCFadeTo actionWithDuration:0.0f opacity:0xFF],
			//																		 [CCFadeTo actionWithDuration:0.1f opacity:0x4C],
			//																		 [CCFadeTo actionWithDuration:0.5f opacity:0xFF],
			//																		 [CCFadeTo actionWithDuration:2.0f opacity:0xFF],
			//																		 [CCFadeTo actionWithDuration:0.1f opacity:0x4C],
			//																		 [CCFadeTo actionWithDuration:0.1f opacity:0xFF],
			//																		 [CCFadeTo actionWithDuration:0.1f opacity:0x4C],
			//																		 [CCFadeTo actionWithDuration:0.0f opacity:0xFF],
			//																		 [CCFadeTo actionWithDuration:0.1f opacity:0x4C],
			//																		 [CCFadeTo actionWithDuration:0.5f opacity:0xFF],
			//																		 [CCFadeTo actionWithDuration:1.0f opacity:0xFF],
			//																		 [CCFadeTo actionWithDuration:0.1f opacity:0x4C],*/
			//																		nil]]];
			//			
			//			int offsetX = 25;
			//			int offsetY = 60;
			//			
			//			tSprite.light.position = ccpAdd(tSprite.sprite.position,ccp(offsetX,offsetY));
			//			[map addChild:tSprite.light z:tSprite.light.zOrder];
			//		}
			//		else if([useThisKey isEqualToString:@"heartCandle"])
			//		{
			//			tSprite.light = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:50 intensity:0xFF] autorelease];
			//			tSprite.light.color = ccc3(255, 255, 255);
			//			[tSprite.light runAction:[CCRepeatForever actionWithAction:[CCSequence actions:
			//																		[CCScaleTo actionWithDuration:0.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.5f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:2.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.3f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:1.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		/*
			//																		 [CCFadeTo actionWithDuration:0.0f opacity:0xFF],
			//																		 [CCFadeTo actionWithDuration:0.1f opacity:0x4C],
			//																		 [CCFadeTo actionWithDuration:0.5f opacity:0xFF],
			//																		 [CCFadeTo actionWithDuration:2.0f opacity:0xFF],
			//																		 [CCFadeTo actionWithDuration:0.1f opacity:0x4C],
			//																		 [CCFadeTo actionWithDuration:0.1f opacity:0xFF],
			//																		 [CCFadeTo actionWithDuration:0.1f opacity:0x4C],
			//																		 [CCFadeTo actionWithDuration:0.0f opacity:0xFF],
			//																		 [CCFadeTo actionWithDuration:0.1f opacity:0x4C],
			//																		 [CCFadeTo actionWithDuration:0.5f opacity:0xFF],
			//																		 [CCFadeTo actionWithDuration:1.0f opacity:0xFF],
			//																		 [CCFadeTo actionWithDuration:0.1f opacity:0x4C],*/
			//																		nil]]];
			//			
			//			int offsetX = 21;
			//			int offsetY = 56;
			//			
			//			tSprite.light.position = ccpAdd(tSprite.sprite.position,ccp(offsetX,offsetY));
			//			[map addChild:tSprite.light z:tSprite.light.zOrder];
			//		}
			//		else if([useThisKey isEqualToString:@"bunchOfCandles"])
			//		{
			//			tSprite.light = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:50 intensity:0x00] autorelease];
			//			tSprite.light.color = ccc3(255, 255, 255);
			//			
			//			PointLight* light3 = [[[PointLight alloc] initWithPosition:ccp(-2.0f, -30.0f) depth:0 radius:70 intensity:0xcc] autorelease];
			//			[tSprite.light addChild:light3];
			//			light3.color = ccc3(255, 255, 255);
			//			
			//			PointLight* light2 = [[[PointLight alloc] initWithPosition:ccp(15.0f, -12.0f) depth:0 radius:70 intensity:0xdd] autorelease];
			//			[tSprite.light addChild:light2];
			//			light2.color = ccc3(255, 255, 255);
			//			
			//			PointLight* light1 = [[[PointLight alloc] initWithPosition:ccp(0.f, 0.f) depth:0 radius:60 intensity:0xff] autorelease];
			//			[tSprite.light addChild:light1];
			//			light1.color = ccc3(255, 255, 255);
			//			
			//			float delayTime = 0.f;
			//			for(PointLight *light in tSprite.light.children)
			//			{
			//				delayTime = 2.0 * CCARCRANDOM_0_1();
			//				[light runAction:[CCRepeatForever actionWithAction:[CCSequence actions:
			//																	[CCScaleTo actionWithDuration:0.0f scale:1.2f],
			//																	[CCDelayTime actionWithDuration:delayTime],
			//																	[CCScaleTo actionWithDuration:0.1f scale:1.0f],
			//																	[CCScaleTo actionWithDuration:0.5f scale:1.2f],
			//																	[CCScaleTo actionWithDuration:2.0f scale:1.2f],
			//																	[CCScaleTo actionWithDuration:0.1f scale:1.0f],
			//																	[CCScaleTo actionWithDuration:0.1f scale:1.2f],
			//																	[CCScaleTo actionWithDuration:0.1f scale:1.0f],
			//																	[CCScaleTo actionWithDuration:0.0f scale:1.2f],
			//																	[CCScaleTo actionWithDuration:0.1f scale:1.0f],
			//																	[CCScaleTo actionWithDuration:0.3f scale:1.2f],
			//																	[CCScaleTo actionWithDuration:1.0f scale:1.2f],
			//																	[CCScaleTo actionWithDuration:0.1f scale:1.0f],	
			//																	nil]]];
			//			}
			//			
			//			
			//			int flip = 1;
			//			int flipOffset = 0;
			//			if(sprite.flipX && !usesSeparateRotateSprite)
			//			{
			//				flip = -1;
			//				flipOffset = TILE_WIDTH;
			//			}
			//			
			//			int offsetX = 18 * flip + flipOffset;
			//			int offsetY = 70;
			//			
			//			light1.position = ccp(light1.position.x * flip, light1.position.y);
			//			light2.position = ccp(light2.position.x * flip, light2.position.y);
			//			light3.position = ccp(light3.position.x * flip, light3.position.y);	
			//			
			//			tSprite.light.position = ccpAdd(tSprite.sprite.position,ccp(offsetX,offsetY));
			//			[map addChild:tSprite.light z:tSprite.light.zOrder];
			//		}
			//		else if([useThisKey isEqualToString:@"skullCandle"])
			//		{
			//			tSprite.light = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:50 intensity:0xFF] autorelease];
			//			tSprite.light.color = ccc3(255, 255, 255);
			//			[tSprite.light runAction:[CCRepeatForever actionWithAction:[CCSequence actions:
			//																		[CCScaleTo actionWithDuration:0.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.5f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:2.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.3f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:1.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		nil]]];
			//			
			//			int offsetX = 25;
			//			int offsetY = 70;
			//			
			//			tSprite.light.position = ccpAdd(tSprite.sprite.position,ccp(offsetX,offsetY));
			//			[map addChild:tSprite.light z:tSprite.light.zOrder];
			//		}
			//		else if([useThisKey isEqualToString:@"bonfire"])
			//		{
			//			tSprite.light = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:100 intensity:0xFF] autorelease];
			//			tSprite.light.enableColorWriting = NO;
			//			[tSprite.light runAction:[CCRepeatForever actionWithAction:[CCSequence actions:
			//																		[CCScaleTo actionWithDuration:0.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.5f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:2.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.3f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:1.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		nil]]];
			//			//tSprite.light.color = ccc3(255, 0, 0);
			//			
			//			int offsetX = 25;
			//			int offsetY = 20;
			//			
			//			tSprite.light.position = ccpAdd(tSprite.sprite.position,ccp(offsetX,offsetY));
			//			[map addChild:tSprite.light z:tSprite.light.zOrder];
			//		}
			//		else if([useThisKey isEqualToString:@"pumpkinHappy"])
			//		{
			//			tSprite.light = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:70 intensity:0xFF] autorelease];
			//			tSprite.light.color = ccc3(255, 255, 255);
			//			tSprite.light.enableColorWriting = NO;
			//			int offsetX = 25;
			//			int offsetY = 50;
			//			
			//			tSprite.light.position = ccpAdd(tSprite.sprite.position,ccp(offsetX,offsetY));
			//			[map addChild:tSprite.light z:tSprite.light.zOrder];
			//		}
			//		else if([useThisKey isEqualToString:@"pumpkinAngry"])
			//		{
			//			tSprite.light = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:70 intensity:0xFF] autorelease];
			//			tSprite.light.color = ccc3(255, 255, 255);
			//			tSprite.light.enableColorWriting = NO;
			//			int offsetX = 25;
			//			int offsetY = 50;
			//			
			//			tSprite.light.position = ccpAdd(tSprite.sprite.position,ccp(offsetX,offsetY));
			//			[map addChild:tSprite.light z:tSprite.light.zOrder];
			//		}
			//		else if([useThisKey isEqualToString:@"pumpkinMan"])
			//		{
			//			tSprite.light = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:60 intensity:0xAB] autorelease];
			//			tSprite.light.color = ccc3(255, 255, 255);
			//			tSprite.light.enableColorWriting = NO;
			//			int flip = 1;
			//			int flipOffset = 0;
			//			if(sprite.flipX && !usesSeparateRotateSprite)
			//			{
			//				flip = -1;
			//				flipOffset = TILE_WIDTH;
			//			}
			//			
			//			int offsetX = 28 * flip + flipOffset;
			//			int offsetY = 135;
			//			
			//			tSprite.light.position = ccpAdd(tSprite.sprite.position,ccp(offsetX,offsetY));
			//			[map addChild:tSprite.light z:tSprite.light.zOrder];
			//		}
			//		else if([useThisKey isEqualToString:@"cityLamp"])
			//		{
			//			tSprite.light = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:80 intensity:0xFF] autorelease];
			//			tSprite.light.color = ccc3(255, 255, 255);
			//			
			//			PointLight* pointLight = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:100 intensity:0x7F] autorelease];
			//			pointLight.enableColorWriting = NO;
			//			[tSprite.light addChild:pointLight];
			//			
			//			
			//			int flip = 1;
			//			int flipOffset = 0;
			//			if(sprite.flipX && !usesSeparateRotateSprite)
			//			{
			//				flip = -1;
			//				flipOffset = TILE_WIDTH;
			//			}
			//			
			//			int offsetX = 20 * flip + flipOffset;;
			//			int offsetY = 165;
			//			
			//			tSprite.light.position = ccpAdd(tSprite.sprite.position,ccp(offsetX,offsetY));
			//			[map addChild:tSprite.light z:tSprite.light.zOrder];
			//		}
			//		else if([useThisKey isEqualToString:@"xmasFence"])
			//		{
			//			tSprite.light = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:10 intensity:0xFF] autorelease];
			//			[tSprite.light runAction:[CCRepeatForever actionWithAction:[CCBlink actionWithDuration:60 blinks:30]]];
			//			tSprite.light.color = ccc3(255, 0, 0);
			//			
			//			PointLight* greenLight = [[[PointLight alloc] initWithPosition:ccp(10.0f, -8.0f) depth:0 radius:10 intensity:0xFF] autorelease];
			//			[tSprite.light addChild:greenLight];
			//			greenLight.color = ccc3(0, 255, 0);
			//			
			//			PointLight* blueLight = [[[PointLight alloc] initWithPosition:ccp(20.0f, -13.0f) depth:0 radius:10 intensity:0xFF] autorelease];
			//			[tSprite.light addChild:blueLight];
			//			blueLight.color = ccc3(0, 255, 255);
			//			
			//			PointLight* yellowLight = [[[PointLight alloc] initWithPosition:ccp(32.0f, -15.0f) depth:0 radius:10 intensity:0xFF] autorelease];
			//			[tSprite.light addChild:yellowLight];
			//			yellowLight.color = ccc3(255, 255, 0);
			//			
			//			PointLight* ambientLight1 = [[[PointLight alloc] initWithPosition:ccp(-10.0f, -20.0f) depth:0 radius:50 intensity:0x4C] autorelease];
			//			ambientLight1.enableColorWriting = NO;
			//			[tSprite.light addChild:ambientLight1];
			//			
			//			PointLight* ambientLight2 = [[[PointLight alloc] initWithPosition:ccp(32.0f, -35.0f) depth:0 radius:50 intensity:0x4C] autorelease];
			//			ambientLight2.enableColorWriting = NO;
			//			[tSprite.light addChild:ambientLight2];
			//			
			//			int flip = 1;
			//			int flipOffset = 0;
			//			if(sprite.flipX && !usesSeparateRotateSprite)
			//			{
			//				flip = -1;
			//				flipOffset = TILE_WIDTH;
			//			}
			//			
			//			int offsetX = 5 * flip + flipOffset;;
			//			int offsetY = 30;
			//			
			//			tSprite.light.position = ccpAdd(tSprite.sprite.position,ccp(offsetX,offsetY));
			//			greenLight.position = ccp(greenLight.position.x * flip, greenLight.position.y);
			//			blueLight.position = ccp(blueLight.position.x * flip, blueLight.position.y);
			//			yellowLight.position = ccp(yellowLight.position.x * flip, yellowLight.position.y);
			//			ambientLight1.position = ccp(ambientLight1.position.x * flip, ambientLight1.position.y);
			//			ambientLight2.position = ccp(ambientLight2.position.x * flip, ambientLight2.position.y);
			//			[map addChild:tSprite.light z:tSprite.light.zOrder];
			//		}
			//		else if([useThisKey isEqualToString:@"xmasTree"])
			//		{
			//			tSprite.light = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:30 intensity:0xFF] autorelease];
			//			tSprite.light.color = ccc3(255, 255, 0);
			//			
			//			PointLight* light1 = [[[PointLight alloc] initWithPosition:ccp(-5.0f, -20.0f) depth:0 radius:20 intensity:0xFF] autorelease];
			//			[tSprite.light addChild:light1];
			//			light1.color = ccc3(255, 255, 0);
			//			
			//			PointLight* light2 = [[[PointLight alloc] initWithPosition:ccp(-6.0f, -50.0f) depth:0 radius:20 intensity:0xFF] autorelease];
			//			[tSprite.light addChild:light2];
			//			light2.color = ccc3(255, 255, 0);
			//			
			//			PointLight* light3 = [[[PointLight alloc] initWithPosition:ccp(-14.0f, -90.0f) depth:0 radius:20 intensity:0xFF] autorelease];
			//			[tSprite.light addChild:light3];
			//			light3.color = ccc3(255, 255, 0);
			//			
			//			PointLight* light4 = [[[PointLight alloc] initWithPosition:ccp(-37.0f, -120.0f) depth:0 radius:20 intensity:0xFF] autorelease];
			//			[tSprite.light addChild:light4];
			//			light4.color = ccc3(255, 255, 0);
			//			
			//			PointLight* light5 = [[[PointLight alloc] initWithPosition:ccp(7.0f, -132.0f) depth:0 radius:20 intensity:0xFF] autorelease];
			//			[tSprite.light addChild:light5];
			//			light5.color = ccc3(255, 255, 0);
			//			
			//			PointLight* light6 = [[[PointLight alloc] initWithPosition:ccp(21.0f, -74.0f) depth:0 radius:20 intensity:0xFF] autorelease];
			//			[tSprite.light addChild:light6];
			//			light6.color = ccc3(255, 255, 0);
			//			
			//			PointLight* light7 = [[[PointLight alloc] initWithPosition:ccp(20.0f, -110.0f) depth:0 radius:20 intensity:0xFF] autorelease];
			//			[tSprite.light addChild:light7];
			//			light7.color = ccc3(255, 255, 0);
			//			
			//			PointLight* light8 = [[[PointLight alloc] initWithPosition:ccp(41.0f, -120.0f) depth:0 radius:20 intensity:0xFF] autorelease];
			//			[tSprite.light addChild:light8];
			//			light8.color = ccc3(255, 255, 0);
			//			
			//			PointLight* ambientLight1 = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:100 intensity:0xFF] autorelease];
			//			ambientLight1.enableColorWriting = NO;
			//			[tSprite.light addChild:ambientLight1];
			//			
			//			PointLight* ambientLight2 = [[[PointLight alloc] initWithPosition:ccp(0.0f, -100.0f) depth:0 radius:150 intensity:0x7F] autorelease];
			//			ambientLight2.enableColorWriting = NO;
			//			[tSprite.light addChild:ambientLight2];
			//			
			//			int flip = 1;
			//			int flipOffset = 0;
			//			if(sprite.flipX && !usesSeparateRotateSprite)
			//			{
			//				flip = -1;
			//				flipOffset = TILE_WIDTH;
			//			}
			//			
			//			int offsetX = 23 * flip + flipOffset;;
			//			int offsetY = 170;
			//			
			//			tSprite.light.position = ccpAdd(tSprite.sprite.position,ccp(offsetX,offsetY));
			//			
			//			light1.position = ccp(light1.position.x * flip, light1.position.y);
			//			light2.position = ccp(light2.position.x * flip, light2.position.y);
			//			light3.position = ccp(light3.position.x * flip, light3.position.y);
			//			light4.position = ccp(light4.position.x * flip, light4.position.y);
			//			light5.position = ccp(light5.position.x * flip, light5.position.y);
			//			light6.position = ccp(light6.position.x * flip, light6.position.y);
			//			light7.position = ccp(light7.position.x * flip, light7.position.y);
			//			light8.position = ccp(light8.position.x * flip, light8.position.y);
			//			
			//			ambientLight1.position = ccp(ambientLight1.position.x * flip, ambientLight1.position.y);
			//			ambientLight2.position = ccp(ambientLight2.position.x * flip, ambientLight2.position.y);
			//			[map addChild:tSprite.light z:tSprite.light.zOrder];
			//		}
			//		else if([useThisKey isEqualToString:@"xmasCandle"])
			//		{
			//			tSprite.light = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:50 intensity:0xFF] autorelease];
			//			tSprite.light.color = ccc3(255, 255, 255);
			//			[tSprite.light runAction:[CCRepeatForever actionWithAction:[CCSequence actions:
			//																		[CCScaleTo actionWithDuration:0.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.5f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:2.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.3f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:1.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		nil]]];
			//			
			//			int offsetX = 25;
			//			int offsetY = 55;
			//			
			//			tSprite.light.position = ccpAdd(tSprite.sprite.position,ccp(offsetX,offsetY));
			//			[map addChild:tSprite.light z:tSprite.light.zOrder];
			//		}
			//		else if([useThisKey isEqualToString:@"xmasArch"])
			//		{
			//			tSprite.light = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:100 intensity:0xFF] autorelease];
			//			tSprite.light.enableColorWriting = NO; // cookie cut out light
			//			
			//			Light* outerRingLight = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:150 intensity:0xFF] autorelease];
			//			outerRingLight.enableColorWriting = NO; // cookie cut out light
			//			[tSprite.light addChild:outerRingLight];
			//			
			//			int flip = 1;
			//			int flipOffset = 0;
			//			if(sprite.flipX && !usesSeparateRotateSprite)
			//			{
			//				flip = -1;
			//				flipOffset = TILE_WIDTH;
			//			}
			//			
			//			int offsetX = 10 * flip + flipOffset;
			//			int offsetY = 75;
			//			
			//			tSprite.light.position = ccpAdd(tSprite.sprite.position,ccp(offsetX,offsetY));
			//			[map addChild:tSprite.light z:tSprite.light.zOrder];
			//		}
			//		else if([useThisKey isEqualToString:@"tikiTorch"])
			//		{
			//			tSprite.light = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:100 intensity:0xFF] autorelease];
			//			tSprite.light.enableColorWriting = NO;
			//			[tSprite.light runAction:[CCRepeatForever actionWithAction:[CCSequence actions:
			//																		[CCScaleTo actionWithDuration:0.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.5f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:2.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		[CCScaleTo actionWithDuration:0.3f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:1.0f scaleX:1.2f scaleY:1.2f],
			//																		[CCScaleTo actionWithDuration:0.1f scaleX:1.0f scaleY:1.0f],
			//																		nil]]];
			//			//tSprite.light.color = ccc3(255, 0, 0);
			//			
			//			int offsetX = 25;
			//			int offsetY = 100;
			//			
			//			tSprite.light.position = ccpAdd(tSprite.sprite.position,ccp(offsetX,offsetY));
			//			[map addChild:tSprite.light z:tSprite.light.zOrder];
			//		}
			//		else if([useThisKey isEqualToString:@"tikiHeadSmall"])
			//		{
			//			tSprite.light = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:50 intensity:0xaa] autorelease];
			//			tSprite.light.color = ccc3(255, 125, 125);
			//			
			//			
			//			PointLight* light3 = [[[PointLight alloc] initWithPosition:ccp(-7.0f, 13.0f) depth:0 radius:15 intensity:0x99] autorelease];
			//			[tSprite.light addChild:light3];
			//			light3.color = ccc3(255, 125, 0);
			//			
			//			PointLight* light2 = [[[PointLight alloc] initWithPosition:ccp(5.0f, 0.0f) depth:0 radius:5 intensity:0xff] autorelease];
			//			[tSprite.light addChild:light2];
			//			light2.color = ccc3(255, 255, 0);
			//			
			//			PointLight* light1 = [[[PointLight alloc] initWithPosition:ccp(-10.f, -2.f) depth:0 radius:5 intensity:0xff] autorelease];
			//			[tSprite.light addChild:light1];
			//			light1.color = ccc3(255, 255, 0);
			//			
			//			float delayTime = 0.f;
			//			for(PointLight *light in tSprite.light.children)
			//			{
			//				delayTime = 2.0 * CCARCRANDOM_0_1();
			//				[light runAction:[CCRepeatForever actionWithAction:[CCSequence actions:
			//																	[CCScaleTo actionWithDuration:0.0f scale:1.2f],
			//																	[CCDelayTime actionWithDuration:delayTime],
			//																	[CCScaleTo actionWithDuration:0.1f scale:1.0f],
			//																	[CCScaleTo actionWithDuration:0.5f scale:1.2f],
			//																	[CCScaleTo actionWithDuration:2.0f scale:1.2f],
			//																	[CCScaleTo actionWithDuration:0.1f scale:1.0f],
			//																	[CCScaleTo actionWithDuration:0.1f scale:1.2f],
			//																	[CCScaleTo actionWithDuration:0.1f scale:1.0f],
			//																	[CCScaleTo actionWithDuration:0.0f scale:1.2f],
			//																	[CCScaleTo actionWithDuration:0.1f scale:1.0f],
			//																	[CCScaleTo actionWithDuration:0.3f scale:1.2f],
			//																	[CCScaleTo actionWithDuration:1.0f scale:1.2f],
			//																	[CCScaleTo actionWithDuration:0.1f scale:1.0f],	
			//																	nil]]];
			//			}
			//			
			//			int flip = 1;
			//			int flipOffset = 0;
			//			if(sprite.flipX && !usesSeparateRotateSprite)
			//			{
			//				flip = -1;
			//				flipOffset = TILE_WIDTH;
			//			}
			//			
			//			int offsetX = 31 * flip + flipOffset;
			//			int offsetY = 39;
			//			
			//			light1.position = ccp(light1.position.x * flip, light1.position.y);
			//			light2.position = ccp(light2.position.x * flip, light2.position.y);
			//			light3.position = ccp(light3.position.x * flip, light3.position.y);
			//			
			//			tSprite.light.position = ccpAdd(tSprite.sprite.position,ccp(offsetX,offsetY));
			//			[map addChild:tSprite.light z:tSprite.light.zOrder];
			//		}
			//		else if([useThisKey isEqualToString:@"tikiHeadLarge"])
			//		{
			//			tSprite.light = [[[PointLight alloc] initWithPosition:ccp(0.0f, 0.0f) depth:0 radius:70 intensity:0xaa] autorelease];
			//			tSprite.light.color = ccc3(255, 125, 125);
			//			
			//			
			//			PointLight* light3 = [[[PointLight alloc] initWithPosition:ccp(-7.0f, 3.0f) depth:0 radius:15 intensity:0x99] autorelease];
			//			[tSprite.light addChild:light3];
			//			light3.color = ccc3(255, 125, 0);
			//			
			//			PointLight* light2 = [[[PointLight alloc] initWithPosition:ccp(6.0f, -5.0f) depth:0 radius:4 intensity:0xff] autorelease];
			//			[tSprite.light addChild:light2];
			//			light2.color = ccc3(255, 255, 0);
			//			
			//			PointLight* light1 = [[[PointLight alloc] initWithPosition:ccp(-8.f, -7.f) depth:0 radius:4 intensity:0xff] autorelease];
			//			[tSprite.light addChild:light1];
			//			light1.color = ccc3(255, 255, 0);
			//			
			//			float delayTime = 0.f;
			//			for(PointLight *light in tSprite.light.children)
			//			{
			//				delayTime = 2.0 * CCARCRANDOM_0_1();
			//				[light runAction:[CCRepeatForever actionWithAction:[CCSequence actions:
			//																	[CCScaleTo actionWithDuration:0.0f scale:1.2f],
			//																	[CCDelayTime actionWithDuration:delayTime],
			//																	[CCScaleTo actionWithDuration:0.1f scale:1.0f],
			//																	[CCScaleTo actionWithDuration:0.5f scale:1.2f],
			//																	[CCScaleTo actionWithDuration:2.0f scale:1.2f],
			//																	[CCScaleTo actionWithDuration:0.1f scale:1.0f],
			//																	[CCScaleTo actionWithDuration:0.1f scale:1.2f],
			//																	[CCScaleTo actionWithDuration:0.1f scale:1.0f],
			//																	[CCScaleTo actionWithDuration:0.0f scale:1.2f],
			//																	[CCScaleTo actionWithDuration:0.1f scale:1.0f],
			//																	[CCScaleTo actionWithDuration:0.3f scale:1.2f],
			//																	[CCScaleTo actionWithDuration:1.0f scale:1.2f],
			//																	[CCScaleTo actionWithDuration:0.1f scale:1.0f],	
			//																	nil]]];
			//			}
			//			
			//			int flip = 1;
			//			int flipOffset = 0;
			//			if(sprite.flipX && !usesSeparateRotateSprite)
			//			{
			//				flip = -1;
			//				flipOffset = TILE_WIDTH;
			//			}
			//			
			//			int offsetX = 31 * flip + flipOffset;
			//			int offsetY = 49;
			//			
			//			light1.position = ccp(light1.position.x * flip, light1.position.y);
			//			light2.position = ccp(light2.position.x * flip, light2.position.y);
			//			light3.position = ccp(light3.position.x * flip, light3.position.y);
			//			
			//			tSprite.light.position = ccpAdd(tSprite.sprite.position,ccp(offsetX,offsetY));
			//			[map addChild:tSprite.light z:tSprite.light.zOrder];
			//		}
			//		
			//		
			//		ZFGuiLayer.gui().updateLifeForce();
			//		
			//		//removes all textures that are not needed (frees memory)
			//		//[[CCTextureCache sharedTextureCache] removeUnusedTextures]; //this probably slows things down more then needed
			//		
			//		if(isCorrupt)
			//			return NO;
			//		
			//		return YES;
		});

		ZFGuiLayer.gui().updateLifeForce();

		if (isCorrupt)
			return false;
		return true;
	},

	tileDimensionsFromKey : function(key, orientation) {
		item = this._tilePropertiesDictionary[key];
		var usesSeparateRotateSprite = item.usesSeparateRotateSprite;
		//		NSAssert(item, @"item not in tilePropertiesDictionary");

		//default size is 4 by 4
		var tileDimensions = new Core.Size(4, 4);
		var tileWidth = item.tileWidth;
		var tileHeight = item.tileHeight;

		if (tileWidth) {
			tileDimensions._width = tileWidth;
		}

		if (tileHeight) {
			tileDimensions._height = tileHeight;
		}

		/*
		tileDimensions.setHeight(tileDimensions._height <= 0 ? 1: tileDimensions._height);
		tileDimensions.setWidth(tileDimensions._width <= 0 ? 1: tileDimensions._width);*/

		if (tileDimensions._height <= 0) {
			tileDimensions._height = 1;
		}

		if (tileDimensions._width <= 0) {
			tileDimensions._width = 1;
		}

		if (orientation == 1 && !usesSeparateRotateSprite) {
			tileDimensions = new Core.Size(tileDimensions._height, tileDimensions._width);
		}

		return tileDimensions;
	},

	isValidPosition : function(position) {
		if (position._x < this._baseTileLayer._layerSize._width && position._y < this._baseTileLayer._layerSize._height && position._x >= 0 && position._y >= 0)
			return true;

		return false;
	},

	canPlaceTileOfSize : function(tileSize, tileCoordinate) {
		for ( var x = 0; x < tileSize._width; x++) {
			for ( var y = 0; y < tileSize._height; y++) {
				//in the farm area?
				if (tileCoordinate._x - x >= this._map._mapSize._width || tileCoordinate._y - y >= this._map._mapSize._height || tileCoordinate._x - x < 0 || tileCoordinate._y - y < 0) {
					return false;
				}

				// already occupied?
				var tmpgid = this._baseTileLayer.tileGIDAt(new Core.Point(tileCoordinate._x - x, tileCoordinate._y - y));
				if (tmpgid != this._grassGID) {
					return false;
				}
			}
		}

		return true;
	},

	cleanupTileSpriteManagerAtCoordinate : function(tileCoordinate) {
		//		console.log("cleanupTileSpriteManagerAtCoordinate = " + tileCoordinate._x + ","  + tileCoordinate._y);
		var ma = this._tileSpriteManagers[tileCoordinate._x];
		var mgr = ma[tileCoordinate._y];
		//		console.log("cleanupTileSpriteManagerAtCoordinate = " + mgr);
		//		[mgr retain];

		if (mgr) {
//						console.log("kill mgr");
			//kill mgr
			this.unFertilizeTile(tileCoordinate);
			this.removeTileAt(tileCoordinate);
			this._map.removeChild(mgr, true);
			//			ma.replaceObjectAtIndex(tileCoordinate._y ,null);
			ma.splice(tileCoordinate._y, 1,null);
			destroyWithChildren(mgr,true);
			mgr = null;
		}

		return null;
	},

	neighbouringTilesWithCategory : function(category, subCategory, tileCoordiantes, tileDimensions) {
		var mArray = [];

		for ( var x = tileCoordiantes._x - tileDimensions._width; x <= tileCoordiantes._x + tileDimensions._width; x++) {
			for ( var y = tileCoordiantes._y - tileDimensions._height; y <= tileCoordiantes._y + tileDimensions._height; y++) {
				if ((x > tileCoordiantes._x - tileDimensions._width && x < (tileCoordiantes._x + tileDimensions._width)) && (y > tileCoordiantes._y - tileDimensions._height && y < (tileCoordiantes._y + tileDimensions._height))) {
					continue;
				}

				//in the farm area?
				if (x >= this._map._mapSize._width && y >= this._map._mapSize._height && x < 0 && y < 0) {
					continue;
				}

				var prop = this.tilePropertiesFromPoint(ccp(x, y));
				if (!prop) {
					continue;
				}

				var name = prop["name"];
				var dict = ZFMarketMenu.theMarket().marketItemFromName(name);

				if (dict) {
					var cat = dict["category"];
					var subCat = dict["subCategory"];

					if (cat && subCat && cat == category && subCat == subCategory) {
						mArray.push(name);
					}
				}
			}
		}

		return mArray;
	},

	fertilizeTile : function(tileCoordinates) {
		var tSprite = this.tSpriteFromTile(tileCoordinates);
		tSprite._tile._fertilized = true;
		//TODO		
		//		if (tSprite.emmiter)
		//		{
		//			[map removeChild: tSprite.emmiter cleanup:YES];
		//			tSprite.emmiter = nil;
		//		}
		//		
		//		CCParticleSystem *emitter = [[[CCParticleFlower alloc] initWithTotalParticles:1] autorelease];
		//		emitter.speed = 25;
		//		emitter.speedVar = 5;
		//		emitter.radialAccel = -30;
		//		emitter.tangentialAccel = 7.5;
		//		emitter.startSize = 60.f;
		//		emitter.startSizeVar = 10.0f;
		//		emitter.emissionRate = 4;
		//		emitter.life = 6;
		//		emitter.lifeVar = 1;
		//		emitter.startColor = (ccColor4F) {.5,1,.5,1.f};
		//		emitter.startColorVar = (ccColor4F) {0,.25,0,.5};
		//		emitter.position = ccpAdd(tSprite.sprite.position,ccp(20,50));
		//		emitter.positionType = kCCPositionTypeGrouped;
		//		emitter.autoRemoveOnFinish = NO; // so the fertilize effect keeps on going i guess
		//		
		//		[map addChild:emitter z:tSprite.sprite.parent.zOrder+1];
		//		tSprite.emmiter = emitter;

	},

	unFertilizeTile : function(tileCoordinates) {
		var tSprite = this.tSpriteFromTile(tileCoordinates);
		if (!(tSprite === null)) {
			//			console.log("tile = " + tSprite._tile + " coord = " + tileCoordinates._x + "," + tileCoordinates._y);
			tSprite._tile._fertilized = false;
			//TODO				
			//		if (tSprite.emmiter)
			//		{
			//			[map removeChild: tSprite.emmiter cleanup:YES];
			//			tSprite.emmiter = nil;
			//		}
		}
	},

	removeTileAt : function(tileCoordinates) {
		var tSprite = TSprite.findByCoordinates(tileCoordinates);
		//		
		if (tSprite) {
			if (tSprite._tile) {
				if (tSprite._tile._key == "missingItem") { //find its original SaveTile, since it still has the old key
					//SaveTile *s = [[GameState gameState].zfGameData saveTileAt:tileCoordinates forMapWithSize:map.mapSize];
					var s = GameState._zfGameData.saveTileAt(tileCoordinates, this._map._mapSize);
					s.resetData();
					tSprite._tile = s;
				}
				tSprite._tile.resetData();
			}

//			if (tSprite._sprite && tSprite._sprite._parent) {
//				tSprite._sprite._parent.removeChild(tSprite._sprite, true);
//				destroyWithChildren(tSprite._sprite);
//				tSprite._sprite = null;
				//				console.log("removeChild 1");
//			}

			if (this._selectedSprite == tSprite) {
				this._selectedSprite = null;
			}

			TSprite.untrack(tSprite);
		}
	},

	getCorrectKey : function(key, orientation) {
		var useThisKey = key;
		var item = this._tilePropertiesDictionary[useThisKey];
		var usesSeparateRotateSprite = item["usesSeparateRotateSprite"];

		var returnThisKey = 0;
		var subStringLength = key.length;
		switch (orientation) {
		//case 0:{returnThisKey = [[[useThisKey substringToIndex:[key length] - 3] stringByAppendingString:@"_01"]retain];}break;
		case 1:
			if (usesSeparateRotateSprite) {
				returnThisKey = useThisKey.substring(0, subStringLength - 3) + "_02";
				//returnThisKey = [[[useThisKey substringToIndex:[useThisKey length] - 3] stringByAppendingFormat:@"_02"]retain];
			} else {
				returnThisKey = useThisKey.substring(0, subStringLength - 3) + "_04";
				//returnThisKey = [[[useThisKey substringToIndex:[useThisKey length] - 3] stringByAppendingFormat:@"_04"]retain];
			}
			break;
		case 2:
			//returnThisKey = [[[useThisKey substringToIndex:[useThisKey length] - 3] stringByAppendingFormat:@"_03"]retain];
			returnThisKey = useThisKey.substring(0, subStringLength - 3) + "_03";
			break;
		case 3:
			//returnThisKey = [[[useThisKey substringToIndex:[useThisKey length] - 3] stringByAppendingFormat:@"_04"]retain];
			returnThisKey = useThisKey.substring(0, subStringLength - 3) + "_04";
			break;
		case 0:
		default:
			returnThisKey = useThisKey.slice(0, subStringLength - 3) + "_01";
			break;
		}

		return returnThisKey;
	},

	atlasSpriteFromTile : function(tileCoordinates) {
		var tSprite = TSprite.findByCoordinates(tileCoordinates);
		var retSprite = null;

		if (tSprite) {
			retSprite = tSprite._sprite;
		}

		return retSprite;
	},

	tSpriteFromTile : function(tileCoordinates) {
		return TSprite.findByCoordinates(tileCoordinates);
	},

	setTileToGrass : function(tileCoordinate) {
		var s = GameState._zfGameData.saveTileAt(tileCoordinate, this._map._mapSize);
		s._ownerTile = ccp(-1, -1);
		//[s resetData];
		this._baseTileLayer.setTileGID(this._grassGID, tileCoordinate);
	},

	setTileToOccupied_withOwner : function(tileCoordinate, ownedBy) {
		if (tileCoordinate._x < 0 || tileCoordinate._y < 0) {
			return;
		}

		//		SaveTile *s = [[GameState gameState].zfGameData saveTileAt:tileCoordinate forMapWithSize:map.mapSize];
		s = GameState._zfGameData.saveTileAt(tileCoordinate, this._map._mapSize);

		if (s != ownedBy) {
			s.resetData();
			s._ownerTile = ownedBy._rootTile;
		}

		this._baseTileLayer.setTileGID(this._occupiedGID, tileCoordinate);
	},

	setTileToOccupied : function(tileCoordinate) {
		this._baseTileLayer.setTileGID(this._occupiedGID, tileCoordinate);
	},

	isTileOccupied : function(tileCoordinate) {
		var tmpgid = this._baseTileLayer.tileGIDAt(tileCoordinate);

		if (tmpgid % 2 == 1) {
			return false;
		}

		return true;
	},

	scaleCompensation : function(touchLocationOnScreen) {
		var winSize = CCDirector.winSize();
		var widthScale = winSize._width / 480;
		var heightScale = winSize._height / 320;

		var midpt = ccp((480 * widthScale) / 2, (320 * heightScale) / 2);
		var tmp = ccpSub(touchLocationOnScreen, midpt);
		tmp = ccpMult(tmp, 1 / this._map.getParent().getScale()._x);
		touchLocationOnScreen = ccpAdd(tmp, midpt);

		return touchLocationOnScreen;
	},

	placeNewObjectTileWithKey : function(key, filename, color) {
		var sprite = this.placeNewObjectTileWithKey_andFilename(key, filename);
		if (sprite instanceof CCSprite) {
			sprite.setColor(color);
		} else {
			for ( var key in sprite._children) {
				c = sprite._children[key];
				c.setColor(color);
			}
		}

		return sprite;
	},

	placeNewObjectTileWithKey_andFilename : function(key, filename) {
		var dictWithSpriteInfo = this._tilePropertiesDictionary[key];
		var originX = 0;
		var originY = 0;
		var width = ZFGameDefines.STANDARD_TILE_WIDTH;
		var height = ZFGameDefines.STANDARD_TILE_HEIGHT;
		var flipX = false;
		var flipY = false;

		var widthData = dictWithSpriteInfo["width"];
		if (widthData) {
			width = widthData;
		}

		var heightData = dictWithSpriteInfo["height"];
		if (heightData) {
			height = heightData;
		}

		var xData = dictWithSpriteInfo["x"];
		if (xData) {
			originX = xData;
		}

		var yData = dictWithSpriteInfo["y"];
		if (yData) {
			originY = yData;
		}

		var flipXData = dictWithSpriteInfo["flipX"];
		if (flipXData) {
			flipX = flipXData;
		}

		var flipYData = dictWithSpriteInfo["flipY"];
		if (flipYData) {
			flipY = flipYData;
		}

		var sprite;
		var spriteNode = this.spriteNodeFromKey(key, false);
		if (spriteNode) {
			this._map.addChild(spriteNode, ZFGameDefines.MAXMAPSIZE + ZFGameDefines.MAXMAPSIZE + 1);
			sprite = spriteNode;
		} else {
			var mgr = this._map.getChildByTag(this.kTagMapSpriteManTempObjectPlacementSpriteMan);

			if (mgr) {
				mgr.removeAllChildrenWithCleanup(true);
				map.removeChild(mgr, true);
				destroyWithChildren(mgr);
				mgr = null;
			}

			mgr = new CCSpriteSheet();
			mgr.initWithFile(filename, 1);
			this._map.addChild(mgr, ZFGameDefines.MAXMAPSIZE + ZFGameDefines.MAXMAPSIZE + 1, this.kTagMapSpriteManTempObjectPlacementSpriteMan);
			sprite = new CCSprite();
			sprite.initWithSpriteSheet(mgr, new Core.Rect(originX, originY, width, height));
			mgr.addChild(sprite);

			if (flipX) {
				sprite.setFlipX(true);
			}

			if (flipY) {
				sprite.setFlipY(true);
			}
		}
		ZFToolManager.toolManager().placeTileWithSprite(sprite, key);

		return sprite;
	},

	graduateSoilTileWithTSprite : function(tSprite) {
		var market = ZFMarketMenu.theMarket();

		if (!tSprite || !tSprite._tile) {
			//no tile to graduate
			return;
		}

		var saveTile = tSprite._tile;
		dict = this._tilePropertiesDictionary[saveTile._key];

		if (!dict) {
			return;
		}

		var newKey = dict["transformsTo"];

		if (!newKey) {
			return;
		}

		var name = dict["name"];
		//		NSAssert(name, @"no tileProperties name");
		var subCategory = market.subCategoryFromName(name);
		var growthStages = 1;

		if (subCategory) {
			if (subCategory == "plant") {
				growthStages = ZFGameDefines.PLANT_GROWTH_STAGES;
			} else if (subCategory == "zombie") {
				growthStages = ZFGameDefines.ZOMBIE_GROWTH_STAGES;
			}
		}
		var harvestable = dict["canHarvest"];
		var curDate = Core.Time.getRealTime() / 1000;
		var growTime = market.growTimeFromName(name);
		var growthStageAge = (curDate - tSprite._tile._date);
		var growthStageMaturity = (growTime / growthStages);

		if (harvestable) {
			growthStageMaturity = (growTime * ZFGameDefines.WITHER_MULTIPLIER);
			growthStageMaturity = (growthStageMaturity < ZFGameDefines.WITHER_MINTIME) ? ZFGameDefines.WITHER_MINTIME : growthStageMaturity;
		}

		growthStageMaturity = (growthStageMaturity / GameState._zfGameData._growSpeed); //Used for cheats

		// BONUS FROM HEAD ID
		var gs = GameState;
		if (gs._zfGameData._headID == 13 && tSprite._tile._isZombie) //monolithHead
		{
			if (tSprite._tile._isHarvestable) {
				//make it wilt slower proportional to the speed gained from increased grow time
				growthStageMaturity = growthStageMaturity + (growthStageMaturity / ZFGameDefines.WITHER_MULTIPLIER / 4);
			} else {
				//make it grow faster
				growthStageMaturity = (growthStageMaturity * 3) / 4;
			}

		}

		var leftOverTime = (growthStageAge - growthStageMaturity);

		var tileCoordinates = saveTile._rootTile;

		var plantDate = saveTile._plantDate;

		var fertilized = (saveTile._fertilized && !harvestable);
		var endCropName = saveTile._endCropTile;

		//		if (endCropName)
		//		{
		//			[endCropName retain];
		//		}
		//		console.log("graduate tile at " + "(" + tileCoordinates._x + ", " + tileCoordinates._y + ")" + " " + newKey);
		this.replaceTile(tileCoordinates, newKey, false, 0);

		var tSpriteNew = TSprite.findByCoordinates(tileCoordinates);

		if (tSpriteNew) {
			tSpriteNew._tile._plantDate = plantDate;
			tSpriteNew._tile._date = curDate - (leftOverTime);

			//			console.log("@@@@@@@@@@@@@@@ sprite new date = " + tSpriteNew._tile._date);
			tSpriteNew._tile._endCropTile = endCropName;

			if (fertilized) {
				this.fertilizeTile(tileCoordinates);
			} else {
				this.unFertilizeTile(tileCoordinates);
			}
		}

		//		if (endCropName)
		//		{
		//			[endCropName release];
		//		}
		//		[plantDate release];
	},

	updateMapSize : function() {
		switch (GameState._zfGameData._mapSize) {
		case 30:
			this._tmpMap = new CCTMXTiledMap('./Content/farm30.tmx', this.updateMapSizeFinish.bind(this));
			break;
		case 40:
			this._tmpMap = new CCTMXTiledMap('./Content/farm40.tmx', this.updateMapSizeFinish.bind(this));
			break;
		case 50:
			this._tmpMap = new CCTMXTiledMap('./Content/farm50.tmx', this.updateMapSizeFinish.bind(this));
			break;
		case 60:
			this._tmpMap = new CCTMXTiledMap('./Content/farm60.tmx', this.updateMapSizeFinish.bind(this));
			break;
		}
	},

	updateMapSizeFinish : function() {
		//		console.log("set map with size = "  + GameState._zfGameData._mapSize);
		this.setMap(this._tmpMap);
		
		var am = ZFActorManager;
		am.animAllZombies(true);
	},

	changeClimate : function() {
		this._grassGID = GameState._zfGameData._baseGID;
		this._occupiedGID = this._grassGID + 1;

		this._baseTileLayer.setupTiles();

		var p = ccp(0,0);
		for ( var x = 0; x < this._map._mapSize._width; x++) {
			for ( var y = 0; y < this._map._mapSize._height; y++) {
				p._x = x;
				p._y = y;
				if (this.isTileOccupied(p)) {
					this.setTileToOccupied(p);
				} else {
					this.setTileToGrass(p);
				}
			}
		}
	},

	setupMapFromSave : function() {
		var s = this._baseTileLayer._layerSize;
		market = ZFMarketMenu.theMarket();

		for ( var y = 0; y < s._height; y++) {
			for ( var x = 0; x < s._width; x++) {
				//first wipe whats on the map
				this._baseTileLayer.setTileGID(this._grassGID, ccp(x, y));
				var saveTile = GameState._zfGameData.saveTileAt(ccp(x, y), this._map._mapSize);

				if (saveTile._key && saveTile._key != "") {
					///////////////// CHECK IF SAVETILE KEY EXISTS IN DICTIONARY ///////////////////
					// - used for preventing crashes with newly structured plist
					// - no need for CCLOG in here as it's handled in fixSaveTileKey function
					var tempDictionary = this._tilePropertiesDictionary[saveTile._key];
					if (!tempDictionary) {
						this.fixSaveTileKey(saveTile);
						tempDictionary = this._tilePropertiesDictionary[saveTile._key];
					}
					if (saveTile._key == "mausoleum1")
						GameState._zfGameData._mausoleumFlags |= ZFGameDefines.MAUSOLEUMFLAG_MAUSOLEUM01;
					if (saveTile._key == "mausoleum2")
						GameState._zfGameData._mausoleumFlags |= (ZFGameDefines.MAUSOLEUMFLAG_MAUSOLEUM01 | ZFGameDefines.MAUSOLEUMFLAG_MAUSOLEUM02);

					////////////////////////////////////////////////////////////////////////////				

					//keep track of these because the replaceTile replace wipes them
					var key = saveTile._key;
					var oldKey = null; //in case this item is non-downloaded remote item or corrupt
					var date = saveTile._date;
					var plantDate = saveTile._plantDate;
					var fertilized = saveTile._fertilized;
					var endCropTile = saveTile._endCropTile;
					var orientation = saveTile._orientation;

					//					if (endCropTile)
					//					{
					//						[endCropTile retain];
					//					}

					var color = new Core.Color(saveTile._color.getRed(), saveTile._color.getGreen(), saveTile._color.getBlue());

					//	#ifdef ZF_REMOTE_MARKET
					//					if (![tilePropertiesDictionary objectForKey:key])
					//					{	//we don't have this guy... yet
					//						oldKey = [NSString stringWithString:key];
					//						[oldKey retain];
					//						key = @"missingItem";
					//						orientation = 0;
					//					}
					//	#endif

					//if tile was corrupt
					if (!(this.replaceTile(ccp(x, y), key, false, orientation))) {
						key = "soil_plowed";
						endCropTile = null;
					}

					var tSprite = TSprite.findByCoordinates(ccp(x, y)); //TSprite is created from the replaceTile function
					// SHIKAKA : COLOR FIX //
					// check if there exists a market entry that is white
					var itemDict = market.marketItemFromTileKey_withColor(key, color);
					if (itemDict) {
						var marketColor;

						var colorArray = itemDict["color"];
						if (colorArray) {
							marketColor = ccc3(colorArray[0], colorArray[1], colorArray[2]);
						} else {
							marketColor = ccc3(255, 255, 255);
						}

						color = marketColor;
					} else {
						console.log("" + saveTile._key + " : does not have a market entry");
					}
					// END COLOR FIX //

					if (tSprite) {
						//	#ifdef ZF_REMOTE_MARKET
						//						if ([key isEqualToString:@"missingItem"])	
						//						{
						//							SaveTile *newTile = [[SaveTile alloc] init];	//we want to give the TSprite a missingItem tile, but keep
						//							newTile.key = @"missingItem";			//the SaveTile in gamedata the old key, so that we can 
						//							newTile.color = color;					//retrieve the item later
						//							newTile.rootTile = saveTile.rootTile;
						//							newTile.ownerTile = saveTile.ownerTile;
						//							tSprite.tile = [newTile retain];
						//							tSprite.sprite.color = newTile.color;
						//						}
						//						else {
						//							tSprite.tile = saveTile;
						//							saveTile.color = color;
						//							tSprite.sprite.color = saveTile.color;
						//						}
						//
						//	#else
						tSprite._tile = saveTile;
						saveTile._color = color;
						tSprite._sprite.setColor(saveTile._color);
						//	#endif
					}

					//saveTile.item = item;
					//	#ifdef ZF_REMOTE_MARKET
					//					if (![key isEqualToString:@"missingItem"])
					//					{
					//						saveTile.key = key;
					//					}
					//					else {
					//						saveTile.key = oldKey;
					//						//int temp = 1;
					//					}
					//					[oldKey release];
					//	#else
					saveTile._key = key;
					//	#endif
					saveTile._date = date;
					saveTile._plantDate = plantDate;
					saveTile._endCropTile = endCropTile;
					saveTile._orientation = orientation;

					if (fertilized) {
						this.fertilizeTile(ccp(x, y));
					}

					//game objects

					if (key == ZFGameDefines.kZombiePatchKey) {
						this.createZombiePatchAtTile(ccp(x, y));
					}

					if (this.isKeyZombieCombiner(key)) {
						this.createZombieCombinerAtTile(ccp(x, y));
					}

					//[item release];

					//					if (endCropTile)
					//					{
					//						[endCropTile release];
					//					}
					//					[key release];
					//					[date release];
				}
			}
		}
	},

	sellTile : function(tileCoordinate, prompt) {
		var w = new Core.Size(UI.Window._height, UI.Window._width);
		var tileName = "";
		var dictionary = null;
		var gid = this._baseTileLayer.tileGIDAt(tileCoordinate);
		var tSpriteObject = TSprite.findByCoordinates(tileCoordinate);

		if (this._gid == this._grassGID || !gid) {
			return;
		}

		if (tSpriteObject && tSpriteObject._tile) {
			//refactor pls
			dictionary = this._tilePropertiesDictionary[tSpriteObject._tile._key];
			tileName = dictionary["name"];
			this._tileCoordinateToDelete = tileCoordinate;

			// undeletables
			if (dictionary["undeletable"]) {
				//we can have only one mausoleum on farm, but some users may have already bought 2 or more.
				var proceedWithDelete = false;
				if (dictionary["mausoleum"]) {
					var sm = ZFStorageMenu;
					var ct = 0;
					ct += sm.numberOfItemOnFarmWithKey(tSpriteObject._tile._key);
					ct += sm.numberOfItemInStorageWithKey(tSpriteObject._tile._key);

					if (ct > 1) {
						proceedWithDelete = YES;
					}
				}

				if (!proceedWithDelete) {
					ZFGuiLayer.gui().displayAlertSimple(Core.Localization.getString("Cannot Sell"), Core.Localization.getString("You cannot sell important purchased items"), CCSprite.spriteWithFile("sellSprite.png"),
							new Core.Rect((w._width - 480) / 2, w._height - (w._height - ZFGameDefines.ORIGINAL_WINDOW_HEIGHT) / 2 - 62, 480, 200));
					//TODO ?					
					//					NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
					//															[dictionary objectForKey:@"name"], @"itemType",
					//															@"Cannot sell important items", @"errorType",
					//															nil];
					//					[[EventTracker eventTracker] sendEvent:@"zf_sell_item_error" withParameters:eventDictionary andDelegate:nil];

					return;
				}
			}
		} else {
			return;
		}

		if (prompt) {
			var cost = ZFGameDefines.PLOW_COST;
			var aw = null;
			if (tSpriteObject._tile._key.indexOf("soil_") == 0) {
				this._cost = 0;
				aw = ZFGuiLayer.gui().displayAlertSimpleChoice(Core.Localization.getString("Delete Item"), sprintf(Core.Localization.getString("Are you sure you want to delete %@?"), Core.Localization.getString(tileName)), CCSprite.spriteWithFile("sellSprite.png"));

			} else {
				aw = ZFGuiLayer.gui().displayAlertSimpleChoice(Core.Localization.getString("Sell Item"), sprintf(Core.Localization.getString("Are you sure you want to sell %@ for %ig?"), Core.Localization.getString(tileName), cost), CCSprite.spriteWithFile("sellSprite.png"));
			}

			aw._delegate = this;
			aw._idTag = ZFGameDefines.TAG_DELETE_TILE;

			//			NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
			//														tileName, @"itemSold",
			//														nil];
			//			[[EventTracker eventTracker] sendEvent:@"zf_farm_sel_tool_sell" withParameters:eventDictionary andDelegate:nil];

			return;
		} else {
			this.deleteConfirmedDisplaySale(true, false);
		}
	},

	deleteConfirmedDisplaySale : function(displaySaleText, displayStoredText) {
		var tom = ZFToolManager.toolManager();
		var gs = GameState;
		var market = ZFMarketMenu.theMarket();

		var tileSize;

		if (CGPointEqualToPoint(this._tileCoordinateToDelete, ccp(-1, -1))) {
			return;
		}

		// setting tileSize
		tileSize = this.tileDimensionsFromPoint(this._tileCoordinateToDelete);

		this._selectedSprite = TSprite.findByCoordinates(this._tileCoordinateToDelete);
		var tileGIDKeyToDelete = this._selectedSprite._tile._key;

		var marketItemDictionary = market.marketItemFromTileKey_withColor(this._selectedSprite._tile._key, this._selectedSprite._tile._color);

		this.removeTileAt(this._tileCoordinateToDelete);

		// SHIKAKA : UNSELECTABLE SPRITE

		// remove this tile from the list of touchable sprites
		if (this._selectedSprite) {
			if (this._selectedSprite._tile && this._selectedSprite._tile._key) {
				// dunno what this is for yet ... seems to get skipped every single time because of removeTileAt
				if (marketItemDictionary && marketItemDictionary["pflag"]) {
					// pflag == bit now
					var pflag = marketItemDictionary["pflag"];
					gs._zfGameData._purchaseFlags.remFlag(pflag);
				}
				if (marketItemDictionary && marketItemDictionary["mausoleumFlag"]) {
					var mausoleumFlag = marketItemDictionary["mausoleumFlag"];
					gs._zfGameData._mausoleumFlags &= ~mausoleumFlag;
				}
			}

			TSprite.untrack(this._selectedSprite);
			//TODO ? destroy sprite properly to release the memory			
			this._selectedSprite = null;
		}

		this.setTileToGrass(this._tileCoordinateToDelete);

		for ( var x = 0; x < tileSize._width; x++) {
			for ( var y = 0; y < tileSize._height; y++) {
				if (this.isValidPosition(ccp(this._tileCoordinateToDelete._x - x, this._tileCoordinateToDelete._y - y))) {
					if (this._baseTileLayer.tileGIDAt(ccp(this._tileCoordinateToDelete._x - x, this._tileCoordinateToDelete._y - y)) == this._occupiedGID) {
						this.setTileToGrass(ccp(this._tileCoordinateToDelete._x - x, this._tileCoordinateToDelete._y - y));
					}
				}
			}
		}
		this.unFertilizeTile(this._tileCoordinateToDelete);

		//game objects
		if (tileGIDKeyToDelete == ZFGameDefines.kZombiePatchKey) {
			this.deleteZombiePatchAtTile(this._tileCoordinateToDelete);
		}

		if (this.isKeyZombieCombiner(tileGIDKeyToDelete))// [tileGIDKeyToDelete isEqualToString:kZombieCombinerKey])
		{
			this.deleteZombieCombinerAtTile(this._tileCoordinateToDelete);
		}

		//mgr
		var ma = this._tileSpriteManagers[this._tileCoordinateToDelete._x];
		var mgr = ma[this._tileCoordinateToDelete._y];

		if (!(mgr === null)) {
			this._map.removeChild(mgr, true);
			ma.splice(this._tileCoordinateToDelete._y, 1, null);
		}

		if (displayStoredText) {
			//TODO			
			//			[[ZFGuiLayer gui] displayMessage:NSLocalizedString(@"Stored", nil)
			//									  onTile:this._tileCoordinateToDelete 
			//								   withColor:colorTextHighlight
			//								   withDelay:0];
		}

		if (displaySaleText && tom._currentGameTool != ZFToolManager.kGameTool.kGameToolMove && tom._currentGameTool != ZFToolManager.kGameTool.kGameToolRotate) {
			var cost = ZFGameDefines.PLOW_COST;

			var message = Core.Localization.getString("Deleted");

			if (tileGIDKeyToDelete.indexOf("soil_") == 0) {
				cost = 0;
				//new 
				var xpRefund = 0;
				gs.subResource(GameData.gameResources.kGameResourceXP, xpRefund);
			}

			if (cost > 0) {
				//TODO				
				//				message = [NSString stringWithFormat:NSLocalizedString(@"Sold! +%ig", nil), cost];
				gs.addResource(GameData.gameResources.kGameResourceGold, cost);

				SimpleAudioEngine.playEffect(kEarnSFX);
			}
			//TODO			
			//			[[ZFGuiLayer gui] displayMessage:message 
			//									  onTile:this._tileCoordinateToDelete 
			//								   withColor:colorTextHighlight
			//								   withDelay:0];

			if (tom._currentGameTool == ZFToolManager.kGameTool.kGameToolDelete) //since other tools use this method
			{
				var dictionary = this._tilePropertiesDictionary[tileGIDKeyToDelete];
				//TODO				
				//				var eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
				//														[dictionary objectForKey:@"name"], @"itemSold",
				//														[NSString stringWithFormat:@"%d gold", cost], @"amountReimbursed",
				//														nil];
				//				[[EventTracker eventTracker] sendEvent:@"zf_sell_item_confirm" withParameters:eventDictionary andDelegate:nil];
			}
		}

		SimpleAudioEngine.playEffect(kDeleteSFX);
		this._tileCoordinateToDelete = ccp(-1, -1);

		//removes all textures that are not needed (frees memory)
		//		[[CCTextureCache sharedTextureCache] removeUnusedTextures];

		ZFGuiLayer.gui().updateLifeForce();
	},

	mapPointFromTile : function(tileCoordinates) {
		//		console.log("tile coordinates = " + tileCoordinates._x + ", " + tileCoordinates._y);
		var sprite = this._baseTileLayer.tileAt(tileCoordinates);
		var result = sprite.getPosition().clone();
		sprite.destroy();
		return result;
	},

	selectorRectFromTile : function(tileCoordinates) {
		var sprite = this._baseTileLayer.tileAt(tileCoordinates);
		var result = new Core.Rect(sprite.getPosition()._x, sprite.getPosition()._y, sprite._contentSize._width, sprite._contentSize._height);
		sprite.destroy();
		return result;
	},

	anchorsFromKey : function(key, cb) {
		return this.anchorsFromKey_orientation(key, 0, cb);
	},

	anchorsFromKey_orientation : function(key, orientation, cb) {
		//CGPoints can be a set of floatValues
		var anchorPoints = new Core.Point(0, 0);

		if (key) {
			// SHIKAKA
			//			console.log("anchor key = " +  key);
			var temp = this._tilePropertiesDictionary[key];
			var usesSeparateRotateSprite = temp["usesSeparateRotateSprite"];

			// theres a default x and y anchorpoint if none exist
			var anchorX = ZFGameDefines.LARGE_TILE_POSITION_ADJUST_X;
			var anchorY = ZFGameDefines.LARGE_TILE_POSITION_ADJUST_Y;
			if (temp["pivotx"]) {
				anchorX = temp["pivotx"];
			}

			if (temp["pivoty"]) {
				anchorY = temp["pivoty"];
			}
			//			console.log("anchorX 1 = " +  anchorX);
			var imageWidth = temp["width"];
			var spriteSize;
			var originalSize;
			var frameOffset;
			if (temp["frameName"]) {
				var frame = this.frameFromKey(key);

				frameOffset = frame._offset;
				originalSize = frame._originalSize;
				imageWidth = frame._originalSize._width;

				spriteSize = frame._rect.getSize();

				anchorX = temp["pivotx"];
				anchorY = temp["pivoty"];

				//anchorX = anchorX * originalSize.width / spriteSize.width;
				//anchorY = anchorY * originalSize.height / spriteSize.height;
			}
			//			console.log("anchorX 2 = " +  anchorX);
			anchorPoints = new Core.Point(anchorX, anchorY);

			if (orientation == 1 && !usesSeparateRotateSprite) {
				// we only need imageWidth if we are rotating

				if (imageWidth == 0 && temp["frameName"]) {
					//					console.log("ZFTileManager.anchorsFromKey read plist from framename = " +  temp["frameName"] + " and plist = " + temp["frameList"]);
					//					NSString *path = [[NSBundle mainBundle] bundlePath];
					//					NSString *finalPath = [path stringByAppendingPathComponent:[temp objectForKey:@"frameList"]];
					//					NSDictionary *frameDict = [NSDictionary dictionaryWithContentsOfFile:finalPath];
					Storage.FileSystem.readFile("./Content/" + temp["frameList"], false, function(file, err) {
						if (err) {
							console.log("ZFTileManager.anchorsFromKey  error reading plist");
						} else {
							var frameDict = eval('(' + file + ')');
							var frameInfo = frameDict[frames][frameName];
							var originalSize = new Core.Size(eval("(" + frameInfo["spriteSourceSize"].replace(/{/g, "[").replace(/}/g, "]") + ")"));
							imageWidth = originalSize._width;
							//						NSDictionary *frameInfo = [[frameDict objectForKey:@"frames"] objectForKey:[temp objectForKey:@"frameName"]];
							//						CGSize originalSize = CGSizeFromString([frameInfo objectForKey:@"spriteSourceSize"]);
							//						imageWidth = originalSize.width;	
							anchorX = anchorX * -1.0;
							anchorX = anchorX + 1.0;
							anchorX = anchorX - (48.0 / imageWidth);

							anchorPoints = new Core.Point(anchorX, anchorPoints._y);
							cb(anchorPoints);
						}
					});
					return;
				}

				anchorX = anchorX * -1.0;
				anchorX = anchorX + 1.0;

				if (temp["tileWidth"] != temp["tileHeight"])
					anchorX = anchorX - (48.0 / imageWidth);

				anchorPoints = new Core.Point(anchorX, anchorPoints._y);
			}
			//			console.log("anchorX 3 = " +  anchorX);			
		}

		cb(anchorPoints);
	},

	// returns a set of anchor points from a tile on the map
	frameFromKey : function(key) {
		var dict = this._tilePropertiesDictionary[key];
		if (dict["frameName"]) {
			CCSpriteFrameCache.sharedSpriteFrameCache().addSpriteFramesWithFile(dict["frameList"]);
			var frame = CCSpriteFrameCache.sharedSpriteFrameCache().spriteFrameByName(dict["frameName"]);
			// TODO ?			
			//			CCSpriteFrame *copy = [CCSpriteFrame frameWithTexture:frame.texture rect:frame.rect offset:frame.offset originalSize:frame.originalSize];
			//			
			//			[[CCSpriteFrameCache sharedSpriteFrameCache] removeUnusedSpriteFrames];
			//			
			//			return copy;
			return frame;
		}

		return null;
	},

	spriteNodeFromKey : function(key, marketSize, color) {
		if (!color) {
			color = ccc3(255, 255, 255);
		}

		// key is nil or it doesn't exist
		if (!key) {
			return null;
		}

		if (!this._tilePropertiesDictionary[key]) {
			return null;
		}

		var dictionary = this._tilePropertiesDictionary[key];
		var spriteNode = new CCNode();
		var baseSprite = null;

		if (dictionary.frameName) {
			//			CCSpriteFrameCache.addSpriteFramesWithFile(dictionary.frameList);
			var plist = eval(DataPreloader + "._" + (dictionary.frameList + "").replace(".plist", ""));
			CCSpriteFrameCache.addSpriteFramesWithDictionary(plist, "./Content/" + dictionary.spriteSheet);
			var frame = CCSpriteFrameCache.spriteFrameByName(dictionary.frameName);

			//			dictionary.frameName = shell_scallop.png
			//			dictionary.frameList  = tex1086.plist
			//			dictionary.spriteSheet = tex1086.png
			if (frame) {
				baseSprite = new CCSprite();
				baseSprite.initWithSpriteFrame(frame);
				//CCSpriteFrameCache.removeUnusedSpriteFrames();
			}
		} else {
			baseSprite = CCSprite.spriteWithFile(dictionary.spriteSheet);
			var origin = ccp((dictionary.x) ? dictionary.x : 0, (dictionary.y) ? dictionary.y : 0);
			var width = (dictionary.width) ? dictionary.width : baseSprite.getSize()._width;
			var height = (dictionary.height) ? dictionary.height : baseSprite.getSize()._height;
			//int width  = ([dictionary objectForKey:@"width"])?[[dictionary objectForKey:@"width"] intValue]:baseSprite.texture.pixelsWide;
			//int height = ([dictionary objectForKey:@"height"])?[[dictionary objectForKey:@"height"] intValue]:baseSprite.texture.pixelsHigh;

			var size = new Core.Size(width, height);
			var spriteRect = new Core.Rect(origin._x, origin._y, size._width, size._height);

			baseSprite.destroy();
			baseSprite = CCSprite.spriteWithFile(dictionary.spriteSheet, spriteRect);
		}

		if (!baseSprite) //image hasn't been found, best we can do here is put the missing icon
		{
			baseSprite = CCSprite.spriteWithFile("missingItem.png");
		}

		baseSprite.setAnchorPoint(ccp(0.5, 0.5));
		spriteNode.addChild(baseSprite, 0);

		//		NSArray *animationDictionaries = [dictionary objectForKey:@"animationDictionaries"];
		//		if(animationDictionaries)
		{
			//			for(NSDictionary *dict in animationDictionaries)
			{
				//				// sprite parts with anchorpoints are usually going to wind up in the wrong spot
				//				// - fix this at some point in the future 
				//				if([dict objectForKey:@"anchorPoint"])
				//					continue;
				//				
				//				[[CCTextureCache sharedTextureCache] addImage:[dict objectForKey:@"animationSheet"]];
				//				[[CCSpriteFrameCache sharedSpriteFrameCache] addSpriteFramesWithFile:[dict objectForKey:@"animationFrameList"]];
				//				
				//				CCSprite *animatedSprite = nil;
				//				NSArray *animationFrames = [dict objectForKey:@"animationFrames"];
				//				
				//				CCSpriteFrame *frame = nil;
				//				
				//				if(animationFrames)
				{
					//					frame = [[CCSpriteFrameCache sharedSpriteFrameCache] spriteFrameByName:[animationFrames objectAtIndex:0]];
					//					animatedSprite = [CCSprite spriteWithSpriteFrame:frame];
				}
				//				else 
				{
					//					frame = [[CCSpriteFrameCache sharedSpriteFrameCache] spriteFrameByName:[dict objectForKey:@"animationFrameName"]];
					//					animatedSprite = [CCSprite spriteWithSpriteFrame:frame];
				}
				//				
				//				[animatedSprite.texture setAliasTexParameters];
				//				
				//				
				//				if([[dict objectForKey:@"frameBehind"]boolValue])
				{
					//					[spriteNode addChild:animatedSprite z:-1];
				}
				//				else 
				{
					//					[spriteNode addChild:animatedSprite z:0];
				}
			}
		}

		if (marketSize) {
			if (ZFMarketMenu.marketItemFromTilePropertiesKey(key)) {
				var scale = ZFMarketMenu.marketItemFromTilePropertiesKey(key).scale;
				scale = (scale) ? scale : 1;
				spriteNode.setScale(ccp(scale, scale));
			}
		}

		for ( var key in spriteNode._children) {
			spriteNode._children[key].setColor(color);
		}

		return spriteNode;
	},

	createZombieCombinerAtTile : function(tileCoordinates) {
		if (this.getZombieCombinerAtTile(tileCoordinates)) {
			return null;
		}

		if (!this._zombieCombinerList) {
			this._zombieCombinerList = [];
		}

		var combiner = new ZFZombieCombiner();
		combiner.initWithRootTile(tileCoordinates);
		this._zombieCombinerList.push(combiner)

		var gs = GameState;
		gs._zfGameData._zombiePotBought = true;

		return combiner;
	},

	deleteZombieCombinerAtTile : function(tileCoordinates) {
		if (!this._zombieCombinerList) {
			this._zombieCombinerList = [];
		}

		var combiner = this.getZombieCombinerAtTile(tileCoordinates);
		if (combiner) {
			combiner.evictAllInabitants();
			this._zombieCombinerList.splice(this._zombieCombinerList.indexOf(combiner));
		}

		if (this._zombieCombinerList.length == 0) {
			var gs = GameState;
			gs._zfGameData._zombiePotBought = false;
		}
	},

	getZombieCombinerAtTile : function(tileCoordinates) {
		if (!this._zombieCombinerList) {
			this._zombieCombinerList = [];
		}

		for ( var key in this._zombieCombinerList) {
			var combiner = this._zombieCombinerList[key];
			if (CGPointEqualToPoint(tileCoordinates, combiner._rootTile)) {
				return combiner;
			}
		}

		return null;
	},

	isKeyZombieCombiner : function(key) {
		if (key && (key == ZFGameDefines.kZombieCombinerKey1 || key == ZFGameDefines.kZombieCombinerKey2 || key == ZFGameDefines.kZombieCombinerKey3)) {
			return true;
		}

		return false;
	},

	refundItem : function(itemName, messageOnly) {
		var market = ZFMarketMenu.theMarket();
		var gui = ZFGuiLayer.gui();
		gui.displayAlertSimple(NSLocalizedString(itemName), NSLocalizedString("There's nothing on the farm that this item can be used on.\n\nSince the item wasn't used, it's back in your storage."), CCSprite.spriteWithFile(market.spriteFilenameFromName(itemName)));

		if (!messageOnly) {
			var c = new ZFConsumable();
			c.initWithName(itemName, 1);
			ZFStorageMenu.storageMenu().addItemToStorage(c, false);
		}
	},

	alertWindow_dismissedPositive : function(alertWindow, dummy) {
		if (alertWindow._idTag == ZFGameDefines.TAG_DELETE_TILE) {
			if (dummy) {
				this.deleteConfirmedDisplaySale(true, false);
			} else {
				var tSprite = this.tSpriteFromTile(this._tileCoordinateToDelete);
				var dictionary = this._tilePropertiesDictionary[tSprite._tile._key];
				//TODO ?				
				//				NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
				//														[dictionary objectForKey:@"name"], @"itemType",
				//														nil];
				//				[[EventTracker eventTracker] sendEvent:@"zf_sell_item_dismiss" withParameters:eventDictionary andDelegate:nil];
				this._tileCoordinateToDelete = ccp(-1, -1);
			}
		}
	},

	unwitherEntireMap : function(dt) {
		var spritesToUnwither = [];
		var name = "Regrowth";
		ZFToolManager.toolManager().clearAllGameActions();

		var tSprites = TSprite.allMySprites();
		for ( var key in tSprites) {
			var tSprite = tSprites[key];
			if (tSprite._tile && tSprite._tile._key) {
				if (tSprite._tile._key == "soil_withered_plant" || tSprite._tile._key == "soil_withered_zombie") {
					if (tSprite._tile._endCropTile) {
						spritesToUnwither.push(tSprite);
					}
				}
			}
		}

		if (spritesToUnwither.length <= 0) {
			this.refundItem(name);
		}
		
		for ( var i = 0; i < spritesToUnwither.length; i++) {
			var tSprite = spritesToUnwither[i];
			this.replaceTile_withGIDkey_considerNeighbouringTiles(tSprite._tile._rootTile, tSprite._tile._endCropTile, false);
			SimpleAudioEngine.playEffect(kHarvestPlantSFX);
			tSprite._tile._plantDate = Core.Time.getRealTime() / 1000;
			tSprite._tile._date = Core.Time.getRealTime() / 1000;
			tSprite._tile._endCropTile = tSprite._tile._key;
			NSNotificationCenter.defaultCenter().postNotificationName(ZFGameDefines.kSoilPlowedNotification, this, NSLocalizedString("Plow"));
		}
		spritesToUnwither.length = 0;
		spritesToUnwither = null;
	},

	plowEntireMap : function(dt) {
		var gs = GameState;
		var spritesToPlow = [];
		var name = "Insta-Plow";
		ZFToolManager.toolManager().clearAllGameActions();

		var tSprites = TSprite.allMySprites();
		for ( var key in tSprites) {
			var tSprite = tSprites[key];
			if (tSprite._tile && tSprite._tile._key) {
				var dictionary = ZFTileManager._tilePropertiesDictionary[tSprite._tile._key];
				if (dictionary && dictionary["plowable"]) {
					spritesToPlow.push(tSprite);
				}
			}
		}

		if (spritesToPlow.length <= 0) {
			this.refundItem(name);
		}

		// SHIKAKA : INSTA PLOW
		for ( var key in spritesToPlow) {
			var tSprite = spritesToPlow[key];
			var gidKey = "soil_plowed";
			this.replaceTile_withGIDkey_considerNeighbouringTiles(tSprite._tile._rootTile, gidKey, false);

			var message = sprintf("+%i xp", ZFGameDefines.PLOW_XP);
			gs.addResource(GameData.gameResources.kGameResourceXP, ZFGameDefines.PLOW_XP);
			ZFGuiLayer.gui().displayMessage(message, tSprite._tile._rootTile, ZFColorDefines.colorTextHighlight, 0);
			NSNotificationCenter.defaultCenter().postNotificationName(ZFGameDefines.kSoilPlowedNotification, this, "Plow");
		}
		
		ZFGuiLayer._playerProgressBar.setVisible(false);
		spritesToPlow.length = 0;
	},

	harvestEntireMap : function(dt) {
		var gs = GameState;
		var gui = ZFGuiLayer.gui();
		var market = ZFMarketMenu.theMarket();
		var spritesToHarvest = [];
		var name = "Insta-Harvest";
		ZFToolManager.toolManager().clearAllGameActions();

		var tSprites = TSprite.allMySprites();
		for ( var key in tSprites) {
			var tSprite = tSprites[key];

			if (tSprite._tile && tSprite._tile._key) {
				var dictionary = ZFTileManager._tilePropertiesDictionary[tSprite._tile._key];
				if (dictionary && dictionary["canHarvest"]) {
					spritesToHarvest.push(tSprite);
				}
			}
		}
		;

		var combinerNeedingHarvest = false;
		for ( var key in this._zombieCombinerList) {
			var combiner = this._zombieCombinerList[key];
			if (combiner.isDone() && gs.curArmySize() < gs.maxArmySize()) {
				combinerNeedingHarvest = true;
				break;
			}
		}

		if (spritesToHarvest.length <= 0 && !combinerNeedingHarvest) {
			this.refundItem(name);
		}

		for ( var key in spritesToHarvest) {
			var tSprite = spritesToHarvest[key];
			var marketItemDictionary = market.marketItemFromTilePropertiesKey(tSprite._tile._key);
			NSAssert(marketItemDictionary, "marketItemDictionary missing");
			var name = marketItemDictionary["name"];
			NSAssert(name, "name dictionary");
			var subCategory = marketItemDictionary["subCategory"];

			if (subCategory == "plant") {
				var amount = gs.amountToSellHarvestedItem(marketItemDictionary);

				if (tSprite._tile._fertilized) {
					gui.displayMessage(sprintf(NSLocalizedString("+%ig (Fertilizer)"), amount * 2), tSprite._tile._rootTile, ZFColorDefines.colorTextHighlight, 0);
					gs.addResource(GameData.gameResources.kGameResourceGold, amount * 2);
				} else {
					gs.addResource(GameData.gameResources.kGameResourceGold, amount);
					gui.displayMessage(sprintf(NSLocalizedString("+%ig"), amount), tSprite._tile._rootTile, ZFColorDefines.colorTextHighlight, 0);
				}

				var gidKey = "soil_barren"; //original code comment: replace me
				this.replaceTile_withGIDkey_considerNeighbouringTiles(tSprite._tile._rootTile, gidKey, false);
				SimpleAudioEngine.playEffect(kHarvestPlantSFX);

				NSNotificationCenter.defaultCenter().postNotificationName(ZFGameDefines.kCropHarvestedNotification, this, name);

				//check the carrot harvest achievement
				if (name == NSLocalizedString("Carrots")) {
					gs._zfGameData._carrotsHarvested++;
					ZFAchievementChecker.check1000Carrots();
					//					if(gs._zfGameData._carrotsHarvested == 1000)
					//					{
					//						/* Unlock Achievement through Facebook */
					//						var gui = ZFGuiLayer.gui();
					//						//[gui.publishAchievement("com.zombiefarm.farm.1000_carrots" withDescription:@"com.zombiefarm.farm.1000_carrots.description" withImageURl:@"com.zombiefarm.farm.1000_carrots.image" ];
					//						
					//						//TODO:publishAchievement:
					//						gui.publishAchievement("com.zombiefarm.farm.1000_carrots", "com.zombiefarm.farm.1000_carrots.description", "com.zombiefarm.farm.1000_carrots.image");
					//						/////////////////////////////////////////
					//					}
				}
			} else if (subCategory == "zombie") {
				var maxArmySize = gs.maxArmySize();
				var curArmySize = gs.curArmySize();
				var unitKey = marketItemDictionary["unitKey"]; //from Market

				if (curArmySize < maxArmySize) // we got space for this unit in our army
				{

					if (tSprite._tile._fertilized) {
						var amount = ZFMarketMenu.theMarket().costFromName(name);
						gs.addResource(GameData.gameResources.kGameResourceGold, amount);
					}

					ZFToolManager.toolManager().harvestZombieWithUnitKey(unitKey, tSprite._tile._rootTile);
					NSNotificationCenter.defaultCenter().postNotificationName(ZFGameDefines.kCropHarvestedZombieNotification, this, name);
				} else // our army is full! reward cash instead
				{
					var amount = gs.amountToSellHarvestedItem(marketItemDictionary);
					gs.addResource(GameData.gameResources.kGameResourceGold, amount);
					gui.displayMessage(NSLocalizedString("Max Army size"), tSprite._tile._rootTile, ccc3(0xFF, 0x40, 0x40), 0);
					gui.displayMessage(sprintf(NSLocalizedString("Sold! +%ig"), amount), tSprite._tile._rootTile, ZFColorDefines.colorTextHighlight, 10);
				}

				var gidKey = "soil_blighted";
				this.replaceTile_withGIDkey_considerNeighbouringTiles(tSprite._tile._rootTile, gidKey, false);
			}
		}

		for ( var key in this._zombieCombinerList) {
			var combiner = this._zombieCombinerList[key];
			if (combiner.isDone() && gs.curArmySize() < gs.maxArmySize()) {
				combiner.spawnResult();
			}
		}
		spritesToHarvest.length = 0;
	},

	createZombiePatchAtTile : function(tileCoordinates) {
		if (this.getZombiePatchAtTile(tileCoordinates)) {
			return;
		}

		if (!this._zombiePatchList) {
			this._zombiePatchList = [];
		}

		if (this._zombiePatchList.length > 1) {
			NSLog("crap 2 zombiePatches");
		}

		var patch = new ZFZombiePatch();
		patch._rootTile = tileCoordinates;
		this._zombiePatchList.push(patch);
	},

	deleteZombiePatchAtTile : function(tileCoordinates) {
		if (!this._zombiePatchList) {
			this._zombiePatchList = [];
		}
		var patch = this.getZombiePatchAtTile(tileCoordinates);
		patch.evictAllInabitants();
		this._zombiePatchList.splice(this._zombiePatchList.indexOf(patch));
	},

	getZombiePatchAtTile : function(tileCoordinates) {
		if (!this._zombiePatchList) {
			this._zombiePatchList = [];
		}

		for ( var patchKey in this._zombiePatchList) {
			var patch = this._zombiePatchList[patchKey];
			if (CGPointEqualToPoint(tileCoordinates, patch._rootTile)) {
				return patch;
			}
		}

		return null;
	},

	nearestZombiePatchFromTile : function(tileCoordinates) {
		var shortestDistance = 999999;
		var retpatch = null;

		for ( var patchKey in this._zombiePatchList) {
			var patch = this._zombiePatchList[patchKey];
			var distance = ccpDistance(tileCoordinates, patch._rootTile);

			if (!(patch.isFull()) && distance < shortestDistance) {
				shortestDistance = distance;
				retpatch = patch;
			}
		}

		return retpatch;
	},

	// zombie actors call this when they arrive at their destination (in farmUpdate)
	reachedTile : function(tileCoordinate, actor) {
		// if tile forces actor to perform an animation then we put that here and set a new state
		var tileDictionary = this.tilePropertiesFromPoint(tileCoordinate);
		if (tileDictionary && tileDictionary["allowZombieToggle"])
			this.toggleTile(tileCoordinate);
		else {
			if (actor instanceof ZombieActor) {
				var z = actor;
				z.setThought(ZombieActor.zombieThoughts.kZombieThoughtHmm);
				z.setState(kActorStateIdle);
				if(!z._willSleep){
					z._brainState = kActorBrainStateLookingForHome;
				}
			}
		}
	}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GameState/GameState'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GameState/GameState'] || {}; $MODULE_REGISTRY['Code/Game/GameState/GameState'] = exports; var SaveTile = require('Code/Game/Tiles/SaveTile').SaveTile;
var GameData = require('Code/Game/GameState/GameData').GameData;
var ZFGameDefines = require('Code/Game/ZFGameDefines').ZFGameDefines;
var ZFGameFlags = require('Code/Game/ZFGameFlags').ZFGameFlags;
var Actor = require('Code/Game/Actor/Actor').Actor;

var COUNTS_FOR_SAVE = 7;

exports.GameState = Core.Class.singleton({
	classname : 'GameState',

	initialize : function() {
		//		ZFMarketMenu = require('../GUI/ZFMenus/Market/ZFMarketMenu').ZFMarketMenu;
		//		Actor = require('./../Actor/Actor').Actor;
		this._initialized = false;
		this._saveCount = 0;
	},

	exists : function() {
		return this._initialized;
	},

	gameState : function() {
		return this;
	},

	init : function(cb) {
		//		console.log("initialize GameState " + ZFTileManager + " " + SaveTile);
		if (!this._playerLevelsList) {
			Storage.FileSystem.readFile("./Content/PlayerLevels.plist.json", false, function(err, file) {
				if (err) {
					console.log("GameState error read file = " + err);
				} else if (file) {
					this._playerLevelsList = eval('(' + file + ')');
					this._initialized = true;
					cb();
				}
			}.bind(this));
		}
	},

	saveGame : function() {
		if (!CCDirector.shouldSave()) {
			return;
		}
		//delay the saving to next half second
		setTimeout(this.saveGameReal.bind(this), 500);
	},

	saveGameReal : function() {
		// Loop breaker
		CCDirector._lastSave = Core.Time.getRealTime();

		// If we already in the process of saving then don't do it again
		if (this._isSaving) {
			return;
		}

		//	    NSArray *syms = [NSThread callStackSymbols];
		//	    if ([syms count] > 1)
		//	        [[PlayerProfileManager playerProfileManager] log:[NSString stringWithFormat:@"GameState::saveGame() called from: %@", [syms objectAtIndex:1U]]];

		// Don't save if we are in the process of switching user or if the user is cheating
		if (!this._isSavingDisabled) {
			// Starting to save
			this._isSaving = true;

			//TODO
			// Make sure we fill in the actor and zombie storage list
			var acm = ZFActorManager;
			if (this._zfGameData) {
				this._zfGameData.fillActorList(acm._actorList, acm._farmActors, acm._zombieStorage);

				// Save the current game's data (this will also update the active player's data if they match)
				var ppm = PlayerProfileManager.playerProfileManager();
				ppm.saveGameData(this._zfGameData);
			} else {
				console.log("GameState.saveGame: Could not save (no game data)");
			}

			// Clean up the ActorManager variables we created
			//	        [acm release];
			//	        [acm.actorList release];
		}

		//DO NOT CONVERT THAT IS DONE IN THE GameData.writeToFile method 
		// Done saving
		//this._isSaving = false;
	},

	seasonalItemsAvailable : function() {
//		return false;
		var date = new Date();
		var currentYear = date.getFullYear();
		var currentMonth = date.getMonth() + 1;//iOS is based on 1, javascript is based on 0
		var currentDay = date.getDate();

		// if > seasonal deadline
		if (currentYear > ZFGameDefines.SEASONAL_DEADLINE_YEAR) {
			return false;
		}

		if (currentYear == ZFGameDefines.SEASONAL_DEADLINE_YEAR && currentMonth > ZFGameDefines.SEASONAL_DEADLINE_MONTH) {
			return false;
		}

		if (currentYear == ZFGameDefines.SEASONAL_DEADLINE_YEAR && currentMonth == ZFGameDefines.SEASONAL_DEADLINE_MONTH && currentDay > ZFGameDefines.SEASONAL_DEADLINE_DAY) {
			return false;
		}

		return true;
	},

	loadGameData : function() {
		// Attempt to get the game data from the active player profile
		var activePlayer = PlayerProfileManager.getActivePlayer();

		if (activePlayer._playerGameData && !(activePlayer._playerGameData == null)) {
			//FIXME should be a copy by value using the copyWithZone function 
			this._zfGameData = activePlayer._playerGameData;
			//	        this._zfGameData = new GameData();
			//	        this._zfGameData.initWithData(activePlayer._playerGameData);
			//	        console.log("storage@@@@ GameState.loadGameData : " + JSON.stringify(this._zfGameData));
			//	        console.log("@@@@@@@@@@@@@@@@@@@@@ zf game flags tuto in load = " + (this._zfGameData._gflags & ZFGameFlags.GFLAG_TUTORIAL_START));
		} else {
			this._zfGameData = new GameData();
			this._zfGameData._playerProfileID = activePlayer._playerProfileID;

			if (activePlayer._playerProfileAlias && !(activePlayer._playerProfileAlias == null))
				this._zfGameData.farmOwner = activePlayer._playerProfileAlias;

			activePlayer.setGameData(this._zfGameData);

			var ppm = PlayerProfileManager.playerProfileManager();
			ppm.saveActivePlayerLocalGame();
			console.log("@@@@@@@@@@@@@@@@@@@@@@@ zf game flags from new in load = " + (this._zfGameData._gflags & ZFGameFlags.GFLAG_TUTORIAL_START));
		}
	},

	mausoleumSlotsAllowed : function() {
		var slots = 3;
		if (this._zfGameData._mausoleumFlags & ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM01)
			slots = 9; // putting this here as it's subject to change: <changed from 3 to 6>
		if (this._zfGameData._mausoleumFlags & ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM02)
			slots = 12;

		return slots;
	},

	upgradeMausoleumSlots : function() {
		var acm = ZFActorManager;
		for ( var i = acm._zombieStorage.length; i < this._zfGameData._mausoleumSlots; i++) {
			acm._zombieStorage.push(null);
		}
	},

	addResource : function(type, amount) {
		var gui = ZFGuiLayer.gui();
		var market = ZFMarketMenu.theMarket();
		var total = this._zfGameData._resources[type];
		
		var brainPurchase = false;
		
		total += Math.floor(amount);
		this._zfGameData._resources[type] = total;

		if (type == GameData.gameResources.kGameResourceXP) {
			if (this._zfGameData._level >= ZFGameDefines.MAXLEVEL) {
				return; // DO NOTHING !
			}
			gui.updateXP();
			while (total >= this.xpNeededForLevel(this._zfGameData._level + 1)) {
				this.levelUp();

				if (this._zfGameData._level >= ZFGameDefines.MAXLEVEL) {
					break;
				}
			}
		} else if (type == GameData.gameResources.kGameResourceGold) {
			gui.updateGold();
			market.updateGold();
		} else if (type == GameData.gameResources.kGameResourceBrains) {
			gui.updateBrains();
			market.updateBrains();
			this.saveGameReal();
			brainPurchase = true;
		}
		this._saveCount++;
		if(this._saveCount >= COUNTS_FOR_SAVE){
			if(!brainPurchase){
				this.saveGameReal();
			}
			this._saveCount = 0;
		}
	},

	hasResource : function(type, amount) {
		var total = this._zfGameData._resources[type];
		if (type == GameData.gameResources.kGameResourceGold && (this._zfGameData._cheatFlags & ZFGameFlags.CFLAG_INFINITEGOLD)) {
			return true;
		}

		if (total - amount < 0) {
			return false;
		}

		return true;
	},

	subResource : function(type, amount) {
		var gui = ZFGuiLayer.gui();
		var market = ZFMarketMenu;

		var brainPurchase = false;
		
		amount = Math.floor(amount);

		var total = this._zfGameData._resources[type];

		if (type == GameData.gameResources.kGameResourceGold && (this._zfGameData._cheatFlags & ZFGameFlags.CFLAG_INFINITEGOLD)) {
			return true;
		}

		if (total - amount < 0) {
			return false;
		}

		total -= amount;

		if (type == GameData.gameResources.kGameResourceXP) {
			var lastLvlXP = this.xpNeededForLevel(this._zfGameData._level);
			if (total <= lastLvlXP) {
				total = lastLvlXP;
			}
		}

		this._zfGameData._resources[type] = total;

		if (type == GameData.gameResources.kGameResourceGold) {
			gui.updateGold();
			market.updateGold();
			SimpleAudioEngine.playEffect(kBuySFX);
		} else if (type == GameData.gameResources.kGameResourceBrains) {
			gui.updateBrains();
			market.updateBrains();
			SimpleAudioEngine.playEffect(kBuySFX);
			this.saveGameReal();
			brainPurchase = true;
		} else if (type == GameData.gameResources.kGameResourceXP) {
			gui.updateXP();
		}
		
		this._saveCount++;
		if(this._saveCount >= COUNTS_FOR_SAVE){
			if(!brainPurchase){
				this.saveGameReal();
			}
			this._saveCount = 0;
		}
		
		return true;
	},

	levelUp : function() {
		var gui = ZFGuiLayer.gui();
		//FIXME: Screenshot manager
		//ZFScreenshotManager *sm = [ZFScreenshotManager screenshotManager];

		if (this._zfGameData._level >= ZFGameDefines.MAXLEVEL) {
			return;
		}

		this._zfGameData._level++;

		//TODO		
		//		//take screenshot now
		//		if (![gui shouldStartSalesPitch] && sm.autoScreenShot && zfGameData.level > 5)
		//		{
		//			//[sm takeScreenshotInstant];
		//			[sm takeScreenCap:NO];
		//		}
		//
		//		
		//		//flurry
		//		NSString *flurryEvent = nil;
		//		
		//		if (zfGameData.level < 10)
		//		{
		//			flurryEvent = kFlurryEvent_levelUp_level01to10;
		//		}
		//		
		//		else if (zfGameData.level < 15)
		//		{
		//			flurryEvent = kFlurryEvent_levelUp_level11to15;
		//		}
		//		else if (zfGameData.level < 20)
		//		{
		//			flurryEvent = kFlurryEvent_levelUp_level16to20;
		//		}
		//		else if (zfGameData.level < 25)
		//		{
		//			flurryEvent = kFlurryEvent_levelUp_level21to25;
		//		}
		//		else if (zfGameData.level < 30)
		//		{
		//			flurryEvent = kFlurryEvent_levelUp_level26to30;
		//		}
		//		else if (zfGameData.level < 35)
		//		{
		//			flurryEvent = kFlurryEvent_levelUp_level31to35;
		//		}
		//		else if (zfGameData.level <= 40)
		//		{
		//			flurryEvent = kFlurryEvent_levelUp_level36to40;
		//		}

		var goldVal = this._zfGameData._resources[GameData.gameResources.kGameResourceGold];

		if (goldVal <= 500) {
			goldVal = 500;
		} else if (goldVal <= 1000) {
			goldVal = 1000;
		} else if (goldVal <= 5000) {
			goldVal = 5000;
		} else if (goldVal <= 10000) {
			goldVal = 10000;
		} else if (goldVal <= 25000) {
			goldVal = 25000;
		} else if (goldVal <= 50000) {
			goldVal = 50000;
		} else if (goldVal <= 75000) {
			goldVal = 75000;
		} else if (goldVal <= 100000) {
			goldVal = 100000;
		} else if (goldVal <= 150000) {
			goldVal = 150000;
		} else if (goldVal <= 200000) {
			goldVal = 200000;
		} else if (goldVal <= 300000) {
			goldVal = 300000;
		} else if (goldVal <= 400000) {
			goldVal = 400000;
		} else if (goldVal <= 500000) {
			goldVal = 500000;
		} else {
			goldVal = 1000000;
		}

		//mutation collection
		var muMenu = ZFMutationMenu.mutationMenu();
		var collectedMutations = 0;

		for ( var flag in muMenu._mutationCollectionArray) {
			var mutationArray = muMenu._mutationCollectionArray[flag];
			if (this._zfGameData._mutationCollectionFlags.hasFlag(flag)) {
				collectedMutations++;
			}
		}

		//brain count
		var brainVal = this._zfGameData._resources[GameData.gameResources.kGameResourceBrains];

		//life force count
		var luck = this.getLuck();
		var maxLuck = this.maxLuckForLevel(this._zfGameData._level);
		var percent = luck / maxLuck;

		//TODO	    
		//	    ZFStorageMenu *stm = [ZFStorageMenu storageMenu];
		//	    
		//		NSDictionary* eventDictionary = [NSDictionary dictionaryWithObjectsAndKeys:
		//										 [NSNumber numberWithInt:goldVal], @"gold",
		//										 [self separateIntIntoBucket:brainVal], @"brains",
		//	                                     [self separateFloatIntoBucket:percent], @"life force percent",
		//	                                     [NSNumber numberWithInt:collectedMutations], @"Collected Mutations",
		//	                                     [NSNumber numberWithInt:zfGameData.mapSize], @"Farm Size",
		//	                                     [self separateIntIntoBucket:[stm numberOfItemInStorageWithKey:@"Insta-Harvest"]], @"Insta-Harvest",
		//	                                     [self separateIntIntoBucket:[stm numberOfItemInStorageWithKey:@"Insta-Plow"]], @"Insta-Plow",
		//	                                     [self separateIntIntoBucket:[stm numberOfItemInStorageWithKey:@"Insta-Hunger"]], @"Insta-Hunger",
		//	                                     [self separateIntIntoBucket:[stm numberOfItemInStorageWithKey:@"Insta-Grow"]], @"Insta-Grow",
		//	                                     [self separateIntIntoBucket:[stm numberOfItemInStorageWithKey:@"Regrowth"]], @"Regrowth",
		//	                                     [self separateIntIntoBucket:[stm numberOfItemInStorageWithKey:@"Invasion Voucher"]], @"Invasion Voucher",
		//	                                     [self separateIntIntoBucket:[stm numberOfItemInStorageWithKey:@"Golden Dice"]], @"Golden Dice",
		//										 nil];
		//	    
		//		[FlurryAPI logEvent:flurryEvent withParameters:eventDictionary];
		//	    
		//	    //apsalar
		//	    [Apsalar eventWithArgs:@"zf_user_lvlup",
		//	        @"userLevel", [NSNumber numberWithInt:zfGameData.level],
		//	        @"brains", [NSNumber numberWithInt:brainVal],
		//	        @"gold", [NSNumber numberWithInt:goldVal],
		//	        nil];

		var stuffWeCanBuy = new Array();

		for ( var key in DataPreloader._marketData) {
			var item = DataPreloader._marketData[key];
			if (item["level"] == this._zfGameData._level && !item["dontShowInMarket"] && !item["notForSale"] && !(item["flagNeeded"] && item["modular"])) {
				stuffWeCanBuy.push(item["name"]);
			}
		}

		var message2 = NSLocalizedString("Yee-Haw!");

		if (stuffWeCanBuy.length > 0) {
			message2 = NSLocalizedString("You can now buy:\n");
			while (stuffWeCanBuy.length > 0) {
				var thing = stuffWeCanBuy.shift();
				message2 = message2 + Core.Localization.getString(thing);

				if (stuffWeCanBuy.length > 0) {
					message2 = message2 + ", ";
				}
			}
		}

		var message3 = "";

		//subsidize lowbies
		if (this._zfGameData._level <= ZFGameDefines.LEVEL_SUBSIDY) {
			message3 = sprintf(NSLocalizedString("+%i gold", null), this._zfGameData._level * 100);
			this.addResource(GameData.gameResources.kGameResourceGold, this._zfGameData._level * 100);
		}

		var aw = gui.displayAlertSimple(NSLocalizedString("Congratulations!"), sprintf(NSLocalizedString("You are now Level %i!\n%@\n%@"), this._zfGameData._level, message3, message2), CCSprite.spriteWithFile("levelUp.png"));

		aw._idTag = ZFGuiLayer.guiTags.kGuiTagAlertWindowLevelUp;
		aw._delegate = gui;
		gui.updateLevel();
		this.saveGameReal();
		
		
//		RateGame.askReachedLvl8();
	},

	amountToSellHarvestedItem : function(item) {
		var priceNumber = item["price"];
		var amount = 0.0;

		if (priceNumber) {
			amount = item["price"];
		} else {
			//sell formula
			amount = item["cost"];
			//float baseBonus = 1.25f;
			//float levelBonus = 0.05f * [[item objectForKey:@"level"] floatValue];
			//float speedBonus = 0.02 * [[item objectForKey:@"growTime"] floatValue];
			//amount *= (baseBonus + levelBonus);// + speedBonus);
			amount += ZFGameDefines.PLOW_COST + 1;
		}

		return Math.floor(amount);
	},

	xpNeededForLevel : function(alevel) {
		//		NSAssert(alevel - 1 >= 0, @"oob");

		//DONE IN INIT
		//		if(!playerLevelsList)
		//		{
		//			NSString *path = [[NSBundle mainBundle] bundlePath];
		//			NSString *finalPath = [path stringByAppendingPathComponent:@"PlayerLevels.plist"]; 
		//			playerLevelsList = [NSArray arrayWithContentsOfFile:finalPath];
		//			[playerLevelsList retain];
		//		}

		if (alevel > ZFGameDefines.MAXLEVEL) {
			alevel = ZFGameDefines.MAXLEVEL;
		}

		return this._playerLevelsList[alevel - 1];
	},

	maxArmySize : function() {
		return ZFGameDefines.ARMYINCREASEBY;
	},

	curArmySize : function() {
		var size = 0;

		for ( var key in ZFActorManager._actorList) {
			var actor = ZFActorManager._actorList[key];
			if (actor._type != kActorTypePlayer) {
				size++;
			}
		}

		return size;
	},

	effectiveDefectiveRate : function() {
		if (this._zfGameData._level <= ZFGameDefines.LEVEL_DEFECTS_PROTECTION_CAP || this._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_NO_LIFELESS)) {
			return 0.0;
		}

		// the idea is if you max out luck your just get the MINDEFECTIVERATE penalty 
		// otherwise you get the MAXDEFECTIVERATE

		var defectLevel = this._zfGameData._level - ZFGameDefines.LEVEL_DEFECTS_PROTECTION_CAP; //1-17
		var minMaxDifference = ZFGameDefines.MAXDEFECTIVERATE - ZFGameDefines.MINDEFECTIVERATE;
		var skewPercentFromLevel = (defectLevel) / (ZFGameDefines.LEVEL_DEFECTS_IN_FULL_EFFECT - ZFGameDefines.LEVEL_DEFECTS_PROTECTION_CAP);
		skewPercentFromLevel = (skewPercentFromLevel > 1.0) ? 1.0 : skewPercentFromLevel;
		var luckPercent = (this.getLuck() * 1.0) / (this.maxLuckForLevel(this._zfGameData._level) * 1.0); //0.0 - 1.0

		minMaxDifference *= skewPercentFromLevel;
		var effectiveDefectiveRate = ZFGameDefines.MINDEFECTIVERATE + (minMaxDifference * (1.0 - luckPercent));

		//cap it
		effectiveDefectiveRate = (effectiveDefectiveRate < ZFGameDefines.MINDEFECTIVERATE) ? ZFGameDefines.MINDEFECTIVERATE : effectiveDefectiveRate;
		effectiveDefectiveRate = (effectiveDefectiveRate > ZFGameDefines.MAXDEFECTIVERATE) ? ZFGameDefines.MAXDEFECTIVERATE : effectiveDefectiveRate;

		return effectiveDefectiveRate;
	},

	effectiveMutantRate : function() {
		if (this._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_ALL_MUTATION)) {
			return 1.0;
		}

		if (this._zfGameData._level < ZFGameDefines.LEVEL_MUTANT_IN_EFFECT) {
			return -1.0;
		}

		//the idea is with max luck you get MAXMUTANTRATE
		//otherwise you get MINMUTANTRATE
		var luckPercent = (this.getLuck() * 1.0) / (this.maxLuckForLevel(this._zfGameData._level) * 1.0); //0.0 - 1.0
		var minMaxDifference = ZFGameDefines.MAXMUTANTRATE - ZFGameDefines.MINMUTANTRATE;
		var effectiveMutantRate = ZFGameDefines.MINMUTANTRATE + (minMaxDifference * luckPercent);

		//cap it
		effectiveMutantRate = (effectiveMutantRate < ZFGameDefines.MINMUTANTRATE) ? ZFGameDefines.MINMUTANTRATE : effectiveMutantRate;
		effectiveMutantRate = (effectiveMutantRate > ZFGameDefines.MAXMUTANTRATE) ? ZFGameDefines.MAXMUTANTRATE : effectiveMutantRate;

		return effectiveMutantRate;
	},

	getLuck : function() {
		var tim = ZFTileManager;

		//get luck count
		var luck = 0;

		for ( var key in TSprite.allMySprites()) {
			var obj = TSprite.allMySprites()[key];
			if (!obj._tile) {
				continue;
			}

			var tileItemDictionary = tim._tilePropertiesDictionary[obj._tile._key];

			if (obj._tile && tileItemDictionary) {
				var luckData = tileItemDictionary["luck"];
				if (luckData) {
					luck += luckData;
				} else {
					var tileWidth = tileItemDictionary["tileWidth"];
					var tileHeight = tileItemDictionary["tileHeight"];

					if (tileWidth && tileHeight) {
						luck += tileWidth * tileHeight;
					}
				}
			}
		}
//				if(this._0lifeforce)
//					return 0; 
//				if(this._150lifeforce)
//					return 150;
				return luck;
	},

	maxLuckForLevel : function(playerLevel) {
		var maxLuck = playerLevel * ZFGameDefines.LUCK_NEEDED_PER_LEVEL;
		return maxLuck;
	},

	$rollAgainstFrequencyInArray : function(array) {
		//		var frequencySorter = [[NSSortDescriptor alloc] initWithKey:@"frequency" ascending:YES];
		//		[array sortUsingDescriptors:[NSMutableArray arrayWithObject:frequencySorter]];
		//		[frequencySorter release];

		//TODO : Check
		function sortfunction(a, b) {
			return a.frequency - b.frequency;
		}
		;

		array.sort(sortfunction);

		var frequencyTotal = 0;
		for ( var key in array) {
			var action = array[key];
			frequencyTotal += action.frequency;
		}

		var frequencyRoll = Math.random() * frequencyTotal;
		var frequency = 0;
		for ( var key in array) {
			var item = array[key];
			frequency += item.frequency;
			if (frequencyRoll <= frequency) {
				return item;
			}
		}

		return null;
	},

	canInvade : function() {
		var cur = this.curArmySize();
		var max = this.maxArmySize() / 2.0;

		if (cur >= max) {
			var interval = ZFGameDefines.INVASION_INTERVAL;
			if (!this._zfGameData._lastInvasionDate || (Math.abs(Core.Time.getRealTime() / 1000 - this._zfGameData._lastInvasionDate) > interval)) {
				return true;
			}
		}

		return false;
	},

	chancetoEarnBrain : function(enemyDictionary) {
		var thisStageLevel = enemyDictionary["reccomendedLevel"];
		var levelDifference = Math.floor(thisStageLevel) - this._zfGameData._level;
		levelDifference = Math.abs(levelDifference);
		levelDifference = (levelDifference > ZFGameDefines.BRAIN_DROPRATE_LEVEL_DEVIATION) ? ZFGameDefines.BRAIN_DROPRATE_LEVEL_DEVIATION : levelDifference;
		levelDifference = (levelDifference < 0) ? 0 : levelDifference;
		var x = levelDifference / ZFGameDefines.BRAIN_DROPRATE_LEVEL_DEVIATION;
		var chanceToEarnBrain = ZFGameDefines.BRAIN_DROPRATE_MAX - ((ZFGameDefines.BRAIN_DROPRATE_MAX - ZFGameDefines.BRAIN_DROPRATE_MIN) * x);

		return chanceToEarnBrain;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Tools/ZFToolManager'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Tools/ZFToolManager'] || {}; $MODULE_REGISTRY['Code/Game/Tools/ZFToolManager'] = exports; var ZFGameTool = require('Code/Game/Tools/ZFGameTool').ZFGameTool;
var ZFGameData = require('Code/Game/GameState/GameData').GameData;
var ZFGameAction = require('Code/Game/Tools/ZFGameAction').ZFGameAction;
var ZFMenu = require('Code/Game/GUI/ZFMenus/ZFMenu').ZFMenu;

exports.ZFToolManager = Core.Class.singleton(
{
	classname:'ZFToolManager',
	
	TAG_DELETE_ACTOR: 1,
	TAG_PATCH_COLLECT: 2,
	TAG_PATCH_EVICT: 3,
	TAG_SCREENSHOT: 4,

	$kGameTool:
	{
		kGameToolNone: -1,
		kGameToolMulti: 0,
		kGameToolMove: 1,
		kGameToolPlow: 2,
		kGameToolDelete: 3,
		kGameToolPlace: 4,
		kGameToolPlant: 5,
		kGameToolInstaGrow: 6,
		kGameToolZombieCombiner: 7,
		kGameToolRotate: 8,
		kGameToolTotal: 9
	},
	
	initialize: function()
	{
		this._tools = [];
		for (var i=0; i < this.kGameTool.kGameToolTotal; i++)
		{
			var tool = new ZFGameTool();
			this._tools.push(tool);
		}
				
		this._gameActionQueue = [];
		this._currentGameTool = this.kGameTool.kGameToolNone;
	},
		
	$toolManager: function()
	{
		this.instantiate();
		return this;
	},

	placeToolOnNearestTileToPointOnMap : function(pointOnMap, toolID)
    {
        var tool = this._tools[toolID];
        var wasOnValidTile = tool._onValidTile;
        tool.placeToolOnNearestTileToPointOnMap(pointOnMap);
        
        switch (toolID)
        {
            case this.kGameTool.kGameToolPlow:
                if (wasOnValidTile != tool._onValidTile)
                {
                    tool._label.setString((tool._onValidTile) ? Core.Localization.getString("Plow") : Core.Localization.getString("Drag"));
                    tool._labelShadow.setString((tool._onValidTile) ? Core.Localization.getString("Plow") : Core.Localization.getString("Drag"));
                }
                break;
        }
    },

	
	toolSelected: function(toolID)
	{
		var tool = this._tools[toolID];
		var gui = ZFGuiLayer.gui();
		this.toolCleanup(this._currentGameTool);
		this._currentGameTool = toolID;
		
		var showLabel = true;
		if (toolID == this.kGameTool.kGameToolMulti &&
		    ZFMarketMenu.theMarket()._menuState == ZFMenu.menuStates.menuStateClosed)
		{
			showLabel = false;
		}
		
		if (showLabel)
		{
			tool._label = CCLabel.labelWithString("", "Arial-BoldMT", 14);
			tool._labelShadow = CCLabel.labelWithString("", "Arial-BoldMT", 14);
			tool._labelShadow.setColor(ccc3(0x0, 0x0, 0x0));
		}
		
		tool._state = ZFGameTool.kGameToolState.kGameToolStateNothingSelected;
		
		switch (toolID) 
		{
			case this.kGameTool.kGameToolPlant:
				var name = tool._dictionary["name"];
				gui._toolsLayer.setToolLabel(sprintf(Core.Localization.getString("Planting: %@        "), Core.Localization.getString(name)));
				gui._toolsLayer.replaceActiveToolButton("plantButton.png");
				break;
				
			case this.kGameTool.kGameToolPlow:
				tool._tileSize = new Core.Size(4,4);
				
				this.placeToolOnNearestTileToPointOnMap(ccpSub(new Core.Point(480/2, 320/2), ZFTileManager._map.getPosition()),toolID);
				tool._originalTile = tool._toolTile;
				
				if (this.isTilePlowable(tool._toolTile))
				{
					tool._onValidTile = true;
				}
				else
				{
					tool._onValidTile = false;
				}
				
				tool._label.setString((tool._onValidTile) ? Core.Localization.getString("Plow") : Core.Localization.getString("Drag"));
				tool._labelShadow.setString((tool._onValidTile) ? Core.Localization.getString("Plow") : Core.Localization.getString("Drag"));
				break;
				
			case this.kGameTool.kGameToolInstaGrow:
				var name = Core.Localization.getString(tool._dictionary["name"]);
				gui._toolsLayer.setToolLabel(sprintf("%@ (%i)        ", name, tool._amount));
				gui._toolsLayer.replaceActiveToolButton("plantButton.png");
				break;
			
			case this.kGameTool.kGameToolZombieCombiner:
				gui.disableMenus();
			    break;
		}
	},
	
	toolCleanup: function(toolID)
	{
		var tim = ZFTileManager;
		var tool = this._tools[toolID];
		gui = ZFGuiLayer.gui();
		
		switch (toolID) 
		{
			case this.kGameTool.kGameToolPlace:
			    break;
				
			case this.kGameTool.kGameToolZombieCombiner:
			    gui.enableMenus();
			    break;
			
			case this.kGameTool.kGameToolInstaGrow:
				var amount = tool._dictionary["amount"];
				var amountVal = amount;
				
				if (tool._amount == amountVal)
				{
					gui.displayToolTip(Core.Localization.getString("Insta-Grow was returned to your storage"));
					var c = new ZFConsumable(); 
					c.initWithName(tool._dictionary["name"] ,1);					
					ZFStorageMenu.storageMenu().addItemToStorage(c, false);
				}
				break;
				
			case this.kGameTool.kGameToolRotate:
			    break;
			    
			case this.kGameTool.kGameToolMove:			
				if (!CGPointEqualToPoint(tool._originalTile, ccp(-1,-1)))
				{
					var refSprite = tim.atlasSpriteFromTile(tool._originalTile);
					color = refSprite.getColor();
					refSprite.setOpacity(0xFF);
					refSprite.setColor(color);
					 
					// make sure orientation is considered
					// - if shouldRotate is YES then the tool tileSize is the reverse of the originalTile (including orientation)
					if(tool._shouldRotate == true)
					{
						tool._tileSize = new Core.Size(tool._tileSize._height,tool._tileSize._width);
					}
					
					var key = tim.tileKeyFromPoint(tool._toolTile);
					tim.replaceTile(tool._toolTile, key, true, tool._spriteOrientation, color);	//used to restart animation					
				}
				
				break;
		}
		
		if (tool._sprite)
		{
			var mgr = tool._sprite.getParent();
			if (mgr)
			{
    			mgr.removeChild(tool._sprite, false);
    			//[tool.sprite release];
			}
			tool._sprite.destroy();
			tool._sprite = null;
		}
		
		if (tool._spriteNode)
		{
			tool._spriteNode.getParent().removeChild(tool._spriteNode, true);
			tool._spriteNode.destroy();
			tool._spriteNode = null;
		}
		
		if (tool._label)
		{
			tool._label.setString("");
			//TODO
			//tool._label.destroy(); 
			tool.label = null;
		}
		
		if(tool._labelShadow)
		{
			tool._labelShadow.setString("");
			//TODO			
			//tool._labelShadow.destroy(); 
			tool._labelShadow = null;
		}
		
		tool.reset();
		tim._selectedSprite = null;
	},

	isTileHarvestable: function(tileCoordinates)
	{
		var tSprite = TSprite.findByCoordinates(tileCoordinates);
		if (!tSprite || !tSprite._tile)
		{
			return false;
		}
			
		var dictionary = ZFTileManager._tilePropertiesDictionary[tSprite._tile._key];
		if(dictionary && dictionary["canHarvest"])
		{
			return true;
		}
		
		return false;
	},
	
	isTilePlantable: function(tileCoordinates)
	{
		var tileKey = ZFTileManager.tileKeyFromPoint(tileCoordinates);
		
		if(tileKey == "soil_plowed")
		{
			return true;
		}
		
		return false;
	},
	
	isTilePlowable: function(tileCoordinates)
	{
		var tim = ZFTileManager;
		var tSprite = tim.tSpriteFromTile(tileCoordinates);
		if(!tSprite)
		{
			if(tim.canPlaceTileOfSize(new Core.Size(4, 4), tileCoordinates))
			{
				return true;
			}
		}
		else
		{
			var dictionary = tim._tilePropertiesDictionary[tSprite._tile._key];
			if(dictionary && dictionary["plowable"])
			{
				return true;
			}
		}
		return false;
	},
	
	onActorClickUp: function(actor, toolID)
	{
	    var w = CCDirector.winSize();
		var widthOffset = (w._width- ZFGameDefines.ORIGINAL_WINDOW_WIDTH)/2;
		var gui = ZFGuiLayer.gui();
		var market = ZFMarketMenu.theMarket();
		//ZFActorManager *am = [ZFActorManager actorManager];
		var tim = ZFTileManager;
		
		switch (toolID) 
		{
			case this.kGameTool.kGameToolMulti:
			{
				if(ZFActorManager._player == actor)
				{
					//[[CreateFarmer createFarmer] openMenu];
				}
				else if(actor instanceof StageActor)
				{			
				    /*
					var stageActor = actor;
					var toolTipButtonText = "";
					var buttonSelector = this.showInformativeSlideInForActor;
					var target = ZFStorageMenu.storageMenu();
					
					var toolTip = stageActor._actorDictionary["name"];
					gui.displayToolTip(toolTip);
				
				
					if (toolTipButtonText)
					{
						var sm = ZFStorageMenu.storageMenu();
						sm._currentActor = stageActor;
						sm._currentItemCoordinates = actor._farmData._currentTile;
						gui.addToolTipButton(toolTipButtonText, target, buttonSelector);
					}*/
				}
				else 
				{
					//NSString *toolTipButtonText;
					actor.talk();
					
					actor._destinationPoint = actor.getPosition();
					actor._farmData._destinationTile = actor._farmData._currentTile.clone();
					actor.setState(kActorStateIdle);
					
					var zName = actor._name;
					var tName = NSLocalizedString(market.nameFromUnitKey(actor.classname));
					var hunger = "";
					
					if (actor._hunger < 0.25)
					{
						hunger = sprintf(NSLocalizedString("This is %@ the %@"), zName, tName);
					}
					else if(actor._hunger < 0.5)
					{
						hunger = sprintf(NSLocalizedString("%@ is a bit hungry"), zName);
					}
					else if(actor._hunger < 0.75)
					{
						hunger = sprintf(NSLocalizedString("%@ is hungry"), zName);
					}
					else
					{
						hunger = sprintf(NSLocalizedString("%@ is starving! (invade the enemy to feed)"), zName);
					}
					
					// if nothing goes wrong this is where tooltip is displayed
					if(tName)
					{
						// old code for just displaying name and hunger
						gui.displayToolTip(tName, hunger);
						var zmenu = ZFZombieMenu.zombieMenu();
						
						// set the current zombie to this one (everytime you click a zombie that's the first zombie you see in the zombie menu)					
						zmenu._currentZombie = actor;
						
						gui.addToolTipButton(null, 
									   zmenu,
									 "openMenu");//(storeItemFromCurrentItemCoordinates)];
					}
				}
			}
			break;
				
			case this.kGameTool.kGameToolDelete:
			{
				if(ZFActorManager._player == actor)
				{
					break;
				}
				else if(actor instanceof StageActor)
				{
					var sActor = actor;
					var cost = ZFGameDefines.PLOW_COST;
					var aw = null;

					var marketDictionary = market.marketItemFromTileKey_withColor(sActor._key, sActor._savedColor);
					var tileName = marketDictionary["name"];
					
					aw = ZFGuiLayer.displayAlertSimpleChoice(
							NSLocalizedString("Sell Item", null),
							sprintf(NSLocalizedString("Are you sure you want to sell %@ for %ig?", null), NSLocalizedString(tileName,null), cost),
							CCSprite.spriteWithFile("sellSprite.png"));
				
					
					aw._delegate = this;
					aw._idTag = this.TAG_DELETE_ACTOR;
					aw._data = actor;
				}
				else 
				{	
					var baseSaleValue = ZFGameDefines.PLOW_COST;
					var trueSaleValue = baseSaleValue + market.costFromName(market.nameFromUnitKey(actor.classname));
					
					var name = market.nameFromUnitKey(actor.classname);
					var aw = ZFGuiLayer.gui().displayAlertSimpleChoice(NSLocalizedString("Sell Zombie"),
																	   sprintf(NSLocalizedString("Are you sure you want to sell %@ the %@ for %ig?"), actor._name, name, trueSaleValue), 
																		CCSprite.spriteWithFile("male.png"));
					aw._delegate = this;
					aw._idTag = this.TAG_DELETE_ACTOR;
					aw._data = actor;
					
					var acm = ZFActorManager;
					if(aw._image)
					{
						aw._image.getParent().removeChild(aw._image, true);
						destroy(aw._image);
					}
					var zombieGuiActor = acm.spawnGUIActor_withClass_atPoint_withTarget(actor.classname, 
																		   ccp(84+widthOffset, Math.floor(w._height*55/100)), 
																			aw);	
					zombieGuiActor.addMutation(actor._flags);
					zombieGuiActor._savedColor = actor._savedColor;
					zombieGuiActor._spriteMan.setScale(new Core.Vector(zombieGuiActor._spriteMan.getScale()._x * 1.25, zombieGuiActor._spriteMan.getScale()._y * 1.25));
					zombieGuiActor.resetColor();
					zombieGuiActor._tag = aw.kAlertWindowTags.kAlertWindowTagZombie;
				}
			}
			break;
				
			case this.kGameTool.kGameToolZombieCombiner:
			{
				if(ZFActorManager._player == actor)
				{
					break;
				}
				
				var zcmb = null;
				for (var key in tim._zombieCombinerList)
				{
					var z = tim._zombieCombinerList[key];
					if (z.isAwaitingZombie())
					{
						zcmb = z;
						break;
					}
				}
				
				if (zcmb && actor instanceof ZombieActor)
				{
					zcmb.zombieTapped(actor);
					break;
				}	
			}
				break;
		}
	},

	
	onTileClickUp: function(tileCoordinates, toolID)
	{
		var tim = ZFTileManager;
		var market = ZFMarketMenu.theMarket();
		var tool = this._tools[toolID];
		var gs = GameState;
		
		var gui = ZFGuiLayer.gui();
		var acm = ZFActorManager;
		
//		console.log("@@@@@@@@@@@@@@@@ tool state = " + tool._state + " tool id = " + toolID);
		switch (toolID) 
		{
				
		    // MULTI TOOL
			case this.kGameTool.kGameToolMulti:
			{	
				switch (tool._state)
				{
					case ZFGameTool.kGameToolState.kGameToolStateMapScrolling:
					{			
						tool._state = ZFGameTool.kGameToolState.kGameToolStateNothingSelected;
					}
					break;
						
					case ZFGameTool.kGameToolState.kGameToolStateNothingSelected:
					{
						// checking tile properties for an alternate tile (we always change tiles on click for now)
						var alternateTileCheck = tim.tilePropertiesFromPoint(tileCoordinates);
						if(!(alternateTileCheck === null) && (alternateTileCheck["alternateTile"]))
						{
							ZFTileManager.toggleTile(tileCoordinates);
						}
						
						var movePlayer = true;
						var showToolTip = true;
						
						if (this.isTileHarvestable(tileCoordinates))
						{
							var tileSize = new Core.Size(4,4);
							var rect;
							rect = tim.selectorRectFromTile(tileCoordinates);
							rect.getOrigin().setX(rect.getOrigin()._x - ((tileSize._width-1) * rect.getSize()._width)/2);
							rect.getSize().setAll( rect.getSize()._width * tileSize._width,  rect.getSize()._height * tileSize._height);
							this.pushGameAction(ZFGameAction.gameCommands.kGameCommandHarvest, tileCoordinates, rect, null);
						}
						else if (this.isTilePlowable(tileCoordinates) && tim.tSpriteFromTile(tileCoordinates))
						{
							var tileSize = new Core.Size(4,4);
							var rect;
							rect = tim.selectorRectFromTile(tileCoordinates);
							rect.getOrigin().setX(rect.getOrigin()._x - ((tileSize._width-1) * rect.getSize()._width)/2);
							rect.getSize().setAll( rect.getSize()._width * tileSize._width,  rect.getSize()._height * tileSize._height);
							this.pushGameAction(ZFGameAction.gameCommands.kGameCommandPlow, tileCoordinates, rect, null);
						}
		
						else if (this.isTilePlantable(tileCoordinates))
						{
							//open market
							ZFMarketMenu.theMarket()._category = "crop";
							ZFMarketMenu.theMarket().openMenu();
							gui._toolsLayer.toggleTool(this.kGameTool.kGameToolMulti, "multiButton.png", Core.Localization.getString("Multi Tool"));
							gui._toolsLayer.disableMenus();
						}				
						else
						{						
							var tileProperties = tim.tilePropertiesFromPoint(tileCoordinates);
							var tSprite = TSprite.findByCoordinates(tileCoordinates);
							
							if (tSprite && gs.curArmySize() > 0 && tSprite._tile._key == ZFGameDefines.kZombiePatchKey)
							{
								movePlayer = false;
								var patch = tim.getZombiePatchAtTile(tileCoordinates);
								if(patch._population > 0)
								{
									//evict?
									var aw = gui.displayAlertSimpleChoice(
											NSLocalizedString("Zombie Patch", "Zombie Patch Title"), 
											NSLocalizedString("Would you like to wake up the zombies?", "Zombie Wake Patch Message"),
											CCSprite.spriteWithFile("SoilZombiePatch.png"));
									aw._idTag = this.TAG_PATCH_EVICT;
									aw._delegate = this;
									aw._data = patch;
								}
								else
								{
									//collect?
									var aw = gui.displayAlertSimpleChoice(
											NSLocalizedString("Zombie Patch", "Zombie Patch Title"),
											NSLocalizedString("Would you like your zombies to gather and nap on the zombie patch?", "Zombie Nap Patch Message"),
											CCSprite.spriteWithFile("SoilZombiePatch.png"));
									aw._idTag = this.TAG_PATCH_COLLECT;
									aw._delegate = this;
									aw._data = patch;
								}
							}
							else if (tSprite && tSprite._tile._key == ZFGameDefines.kCameraKey)
							{
//TODO	
//								// SHIKAKA : SEARCHING FOR SCREENSHOT BUG
//								ZFScreenshotManager *sm = [ZFScreenshotManager screenshotManager];
//								if (sm.shotPending)
//								{
//									[sm cameraBusyMessage];
//								}
//								else
//								{
//									GameState *gs = [GameState gameState];
//									NSString *extraInfo = NSLocalizedString(@"Say cheese!", @"Expression used when someone is taking your picture");
//									NSTimeInterval day = 60 * 60 * 24;
//									
//									if (!gs.zfGameData.lastPhotoDate || fabs([gs.zfGameData.lastPhotoDate timeIntervalSinceNow]) > day) 
//									{
//										extraInfo = [NSString stringWithFormat:NSLocalizedString(@"You will earn %i gold for taking a photo today.", @"Earn Gold for Picture message"), DAILY_PHOTO_GOLD_BONUS];
//									}
//									
//									ZFAlertWindow *aw = [gui displayAlertSimpleChoice:NSLocalizedString(@"Zombie Camera", @"Zombie Camera Title")
//																		  withMessage:[NSString stringWithFormat:NSLocalizedString(@"The Zombie Camera wants to take a photo of your farm.\nTap on the green button to take a photo!\n\n%@", @"Zombie Camera Message"), extraInfo] 
//																		   withSprite:[CCSprite spriteWithFile:@"camera.png"]];
//									aw.idTag = TAG_SCREENSHOT;
//									aw.delegate = self;
//								}
							}
							else if (tSprite && tim.isKeyZombieCombiner(tSprite._tile._key))
							{
								var combiner = tim.getZombieCombinerAtTile(tileCoordinates);
								combiner && combiner.combinerTapped()
								showToolTip = false;
								movePlayer = false;
							}	
							
							//TODO:
//							var animdict = tileProperties["animationDictionaries"];
//							
//							if ( animdict )
//							{
//								if ( animdict[0]["onClick"] )
//								{
//									ZFTileManager.tileManager().replaceTile(tileCoordinates, tSprite._tile._key, false, tSprite._tile._orientation);
//								}
//							}
							
							
							//tooltip
							if (tileProperties && showToolTip)
							{
								movePlayer = false;
								var toolTip= null;
								var toolTipInfo = null;
								var toolTipButtonText = null;

								var buttonSelector = "showInformativeSlideIn";
								var target = ZFStorageMenu.storageMenu();
								var sprite = null;
								
								var name = tileProperties["name"];
//								NSAssert(name, @"no tileProperties name");
//								
								var noTooltip = tileProperties["noTooltip"] ? true : false;
//								
								if (tileProperties["movable"])
								{
									//this thing is an object
									toolTip = name;

									var luck = tim.luckFromKey(tileProperties["tile"]);
									var monolith = tileProperties["monolith"] ? true : false;
									
									if (monolith)
									{
										toolTipInfo = tileProperties["toolTip"];
									}
									else if(luck)
									{
										var needed = null
										var curLF = gs.getLuck()
										var maxLF = gs.maxLuckForLevel(gs._zfGameData._level);
										
										if (curLF >= maxLF)
										{
											needed = NSLocalizedString("(Life Force at 100%!)", "Life Force 100% message");
										}
										else
										{
											needed = sprintf(NSLocalizedString("(%i more needed)", "More Life Force Needed Message"), maxLF - curLF);
										}
										
										toolTipInfo = sprintf(NSLocalizedString("+%d Life Force     %@", "Life Force Tool Tip showing %"), luck, needed);
									}
									else if (tileProperties["toolTip"])
									{
										if (tileProperties["mausoleum"] && (gs._zfGameData._mausoleumFlags & ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM_UNLOCKED))
										{
											toolTipInfo = tileProperties["toolTipAlt"];
										}
										else 
										{
											toolTipInfo = tileProperties["toolTip"];
										}
									}
									
									toolTipButtonText = "";
									var check;
									var item = market.marketItemFromTileKey_withColor(tSprite._tile._key, tSprite._tile._color);
									if(item != null){
										check = item["pflag"];
									}
									var pFlag = -1;
									if(check)	// if number value is zero it will still pass because this is checks if address is nil
										pFlag = check;

									if (pFlag == ZFGameFlags.PFLAG_STORAGE01 ||
										pFlag == ZFGameFlags.PFLAG_STORAGE02 ||
										pFlag == ZFGameFlags.PFLAG_STORAGE03 ||
										pFlag == ZFGameFlags.PFLAG_STORAGE04 ||
										pFlag == ZFGameFlags.PFLAG_STORAGE05 ||
										pFlag == ZFGameFlags.PFLAG_STORAGE06 ||
										pFlag == ZFGameFlags.PFLAG_STORAGE07 ||
										pFlag == ZFGameFlags.PFLAG_STORAGE08)
									{
										buttonSelector = "openMenu";
									}
									else if (tileProperties["mausoleum"] && (gs._zfGameData._mausoleumFlags & ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM_UNLOCKED))
									{
										buttonSelector = "openMenu";
										target = ZFMausoleumMenu.mausoleumMenu();
									}
								}
								else
								{
									var growTime = market.growTimeFromName(name);	
									growTime /= GameState._zfGameData._growSpeed;
									var curDate = Core.Time.getRealTime() / 1000;
									totalAge = curDate - tSprite._tile._plantDate;
									if (totalAge < 0)
									{
										totalAge = 0;
									}
									
									if (totalAge > growTime)
									{
										totalAge = growTime;
									}
									
									if (gs._zfGameData._headID == 13 && tSprite._tile._isZombie) //monolith head bonus
									{
										growTime = growTime * 0.75;
									}
									
									var totalGrowthTimeLeft = growTime - totalAge;
									var percentGrown = Math.floor(100.0 * (totalAge / growTime) + 0.5);
									percentGrown = (percentGrown > 100) ? 100 : percentGrown;
									toolTip = sprintf("%@%@", (tSprite._tile._fertilized) ? Core.Localization.getString("Fertilized ") : "", name);
									toolTipInfo = sprintf(Core.Localization.getString("%d%% grown     "), percentGrown);
									
									var daysLeft = Math.floor(totalGrowthTimeLeft / 60 / 60 / 24);
									totalGrowthTimeLeft -= (daysLeft * 60 * 60 * 24);
									var hoursLeft = Math.floor(totalGrowthTimeLeft / 60 / 60 );
									totalGrowthTimeLeft -= (hoursLeft * 60 * 60);
									var minutesLeft = Math.floor(totalGrowthTimeLeft / 60);
									totalGrowthTimeLeft -= (minutesLeft * 60);
									var secondsLeft = totalGrowthTimeLeft;
									
									if (daysLeft > 0)
									{
										toolTipInfo = toolTipInfo + sprintf(Core.Localization.getString("%d day%@ "), daysLeft, daysLeft==1 ? "" : "s");
										toolTipInfo = toolTipInfo + sprintf(Core.Localization.getString("%d hr%@ left"), hoursLeft, hoursLeft==1 ? "" : "s");
									}
									else if (hoursLeft > 0)
									{
										toolTipInfo = toolTipInfo + sprintf(Core.Localization.getString("%d hr%@ "), hoursLeft, hoursLeft==1 ? "" : "s");
										toolTipInfo = toolTipInfo + sprintf(Core.Localization.getString("%d min%@ left"), minutesLeft, minutesLeft==1 ? "" : "s");
									}
									else if (minutesLeft > 0)
									{
										
										toolTipInfo = toolTipInfo + sprintf(Core.Localization.getString("%d min%@ "),minutesLeft, minutesLeft==1 ? "" : "s");
										toolTipInfo = toolTipInfo + sprintf(Core.Localization.getString("%d sec%@ left"),secondsLeft, secondsLeft==1 ? "" : "s");
									}
									else if (secondsLeft > 0)
									{
										toolTipInfo = toolTipInfo + sprintf(Core.Localization.getString("%d sec%@ left"),secondsLeft, secondsLeft==1 ? "" : "s");
									}
									
									toolTipButtonText = "";

									target = this;
									buttonSelector = "useInstaGrow";
									sprite = CCSprite.spriteWithFile("stex0028.png");	//display Insta-Grow as a shortcut option in tooltip
								}
								
								if (noTooltip)
								{
									movePlayer = true;
								}
								else
								{
									if (toolTipInfo)
									{
										gui.displayToolTip(toolTip, toolTipInfo);
									}
									else
									{
										gui.displayToolTip(toolTip);
									}
									
									if (!(toolTipButtonText === null) && !sprite)
									{
										
										sm = ZFStorageMenu.storageMenu();
										sm._currentItemCoordinates = tileCoordinates;
										gui.addToolTipButton(toolTipButtonText, target,
													 buttonSelector,
													  CCSprite.spriteWithFile("infoButton.png"), 
													  CCSprite.spriteWithFile("infoButtonSel.png"));
									}
									else if (toolTipButtonText && sprite)
									{
										
										var sm = ZFStorageMenu.storageMenu();
										sm._currentItemCoordinates = tileCoordinates;
										gui.addToolTipButton(toolTipButtonText, target,
												 buttonSelector,
												  sprite,sprite, true);
									}
								}
							}
						}
						
						if (movePlayer)
						{
							//move the player here
							acm._player.moveToTile(tileCoordinates);
						}
						
					}
					break;
				}
			}
			break;

			// PLOW TOOL	
			case this.kGameTool.kGameToolPlow:
				tool._state = ZFGameTool.kGameToolState.kGameToolStateNothingSelected;
				tim._selectedSprite = null;
				var touched = false;
				if(CGPointEqualToPoint(tool._originalTile, tool._toolTile) && !tool._moved)
				{
					for (var i = 0; i < tool._tileSize._width; i++)
					{
						for (var j = 0; j < tool._tileSize._height; j++)
						{
							if (((tool._toolTile._x - i) == tileCoordinates._x) && ((tool._toolTile._y - j) == tileCoordinates._y))
								
							{
								touched = true;
								i = tool._tileSize._width;
								j = tool._tileSize._height;
								break;
							}
						}
					}
					if (touched)
					{
						var plowable = (this.isTilePlowable(tool._toolTile)) ? true : false;
						if(this.isTilePlowable(tool._toolTile))
						{
							this.pushGameAction(ZFGameAction.gameCommands.kGameCommandPlow, tool._toolTile, tool._toolSelectorRectMap, null);
						}
					}
				}			
				
				tool._originalTile = tool._toolTile.clone();
				break;
				
			// DELETE TOOL
			case this.kGameTool.kGameToolDelete:
			{
				switch (tool._state) 
				{
					case ZFGameTool.kGameToolState.kGameToolStateMapScrolling:
						tool._state = ZFGameTool.kGameToolState.kGameToolStateNothingSelected;
						break;
						
					default:
						//HACK set to false to test without alert messages
						tim.sellTile(tileCoordinates, true);
					    break;
				}
			}
			break;
				
	// ROTATE TOOL !
	// GOES TO MOVE TOOL IF CAN'T PLACE
			case this.kGameTool.kGameToolRotate:
			{
				if(tool._state != ZFGameTool.kGameToolState.kGameToolStateSpriteDragging)
				{
					var tileProperties = tim.tilePropertiesFromPoint(tileCoordinates);
					if(tileProperties && tileProperties["rotations"]) // if rotation tile property exists //
					{
						//the following is code that fixes Rob's duping trick, hope it doesnt break other stuff	
						tim._selectedSprite = TSprite.findByCoordinates(tileCoordinates);				
						//end fix
						
						var rotations = parseInt(tileProperties["rotations"]);
						
						// default is the actual tile key
						var tempKey = tim._selectedSprite._tile._key;
						var tileWidth = tileProperties["tileWidth"];
						var tileHeight = tileProperties["tileHeight"];
						
						var orientation = (parseInt(tim._selectedSprite._tile._orientation) + 1) % (rotations + 1);
//						var orientation = 1;

						var usesSeparateRotateSprite = tileProperties["usesSeparateRotateSprite"];
						
						// if already flipped make sure the dimensions are flipped as well
						if(tim._selectedSprite._tile._orientation == 1 && !usesSeparateRotateSprite)
						{
							var temp = tileWidth;
							tileWidth = tileHeight;
							tileHeight = temp;
//							orientation = 0;
						}
							
						// change tiles to grass

						for (var x = 0; x < tileWidth; x++)
						{
							for(var y = 0; y < tileHeight; y++)
							{
								tim.setTileToGrass(ccp(tileCoordinates._x - x, tileCoordinates._y - y));
							}
						}
						
						// fancy rotation code that now works for any size tiles

						
						// actual flipping is done in replaceTile (BUT ONLY IF ORIENTATION == 1!!)
						if (tim.canPlaceTileOfSize(CGSizeMake(tileHeight, tileWidth), tim._selectedSprite._tile._rootTile))
						{
//							orientation = 1;
							tim._selectedSprite._tile._orientation = orientation;
							var key = tempKey;
							var point = ccp(tim._selectedSprite._tile._rootTile._x, tim._selectedSprite._tile._rootTile._y);

							var tileColor = new Core.Color(tim._selectedSprite._tile._color);
							var spriteColor = new Core.Color(tim._selectedSprite._sprite.getColor());

//							[key retain];
//							
							// deleting causes the sound effect //
							tim._tileCoordinateToDelete = tim._selectedSprite._tile._rootTile;
							tim.deleteConfirmedDisplaySale(true, false);
							
							tim.replaceTile(point, key, true, orientation, tileColor);
							
							//sets the color for the newly placed tile
							var tSprite = tim.tSpriteFromTile(point);
							
							tSprite._sprite.setColor(spriteColor);
							tSprite._tile._color = tileColor;
							
							// clean up tool here
							tool._originalTile = ccp (-1,-1);
							tool.reset();
							
							
						}
						else // resets tile to original position and orientation but should be calling the move tool
						{
							
							var tileColor = new Core.Color(tim._selectedSprite._tile._color);
							var spriteColor = new Core.Color(tim._selectedSprite._sprite.getColor());	
							var point = tim._selectedSprite._tile._rootTile.clone();
							tim.replaceTile(tim._selectedSprite._tile._rootTile, tim._selectedSprite._tile._key,
											true, tim._selectedSprite._tile._orientation, tileColor);
							var tSprite = tim.tSpriteFromTile(point);
							tSprite._sprite.setColor(spriteColor);
							tSprite._tile._color = tileColor;						
							// when you replace tim.selectedSprite gets set to nil !
											
							
							
							/// test code
							
							tool.reset();
							
							tool   = this._tools[this.kGameTool.kGameToolMove];
							
							// checked : originalTile is = -1,-1 before this assignment
							tool._originalTile = tileCoordinates.clone();
							tool._spriteOrientation = orientation;
							tool._shouldRotate = true;
							tool._state = ZFGameTool.kGameToolState.kGameToolStateNothingSelected; //(tells it to assign the clicked up tile to the move tool)
							tool._onValidTile = false;
							
							this.toolSelected(this.kGameTool.kGameToolMove);	// REMEMBER! this sets selectedSprite to NIL
							
							tim._selectedSprite = TSprite.findByCoordinates(tileCoordinates);

							this.onTileClickUp(tileCoordinates, this.kGameTool.kGameToolMove);
							
						}
						
					}
				}

			}
				break;
	// MOVE TOOL
			case this.kGameTool.kGameToolMove:
			{
				var movable = true;
				
				
				var tileProperties = tim.tilePropertiesFromPoint(tileCoordinates);
				if(tileProperties)
				{
					var movableKey = tileProperties["movable"];
					if(!movableKey)
					{
						movable = false;
					}
	//				else if(![movableKey boolValue]){	//only missingItem has movable set to false
	//					movable = NO;
	//				}
				}

				
				// TOOL STATES 
				// kGameToolNothingSelected == the first time you click on something 
				// kGameToolStateSpriteSelected == when you click on a touch sprite AFTER selecting something
				// kGameToolStateSpriteDragging == drag and drop the sprite
				switch (tool._state) 
				{
				
					case ZFGameTool.kGameToolState.kGameToolStateSpriteDragging:
					{
//						console.log("@@@@@@@@@@@@@@@@@ DRAGGINg");
						// save key value and orientation
						
						//the following is code that fixes Rob's duping trick, hope it doesnt break other stuff
						tim._selectedSprite = TSprite.findByCoordinates(tool._originalTile);
						//end fix
							
						var key = tim._selectedSprite._tile._key;
						
						if(!key)
						{
							//bad!
							break;
						}

//						[key retain];
						
						// RESETS THE TILE IF IT CAN'T BE PLACED ON TOOLTILE POSITION
						if(!tool._onValidTile)
						{
							//reset
							tool._toolTile = tool._originalTile;
							
							//reset orientation
							////////// NEWEST PROBLEM: tim.selectedSprite.tile == nil ! 
							if(tool._shouldRotate)
							{
								tool._spriteOrientation = tim._selectedSprite._tile._orientation;
								tool._tileSize = new Core.Size(tool._tileSize._height, tool._tileSize._width);
							}
						}
						
						// SAVE ZOMBIE COMBINER DATA BEFORE MOVING //
						var rdToSave = null;
						if (tim.isKeyZombieCombiner(key))
						{
							for (var ZCkey in gs._zfGameData._zombieCombiners)
							{
								var rd = gs._zfGameData._zombieCombiners[ZCkey];
								if (rd._rootTile._x == tool._originalTile._x && rd._rootTile._y == tool._originalTile._y)
								{
									rdToSave = rd;
									break;
								}
							}
						}
						
						//place the tile
						tim._tileCoordinateToDelete = tool._originalTile;
						tim.deleteConfirmedDisplaySale(true, false);
						tim.replaceTile(tool._toolTile, key, true, tool._spriteOrientation);
						
						var tSprite = tim.tSpriteFromTile(tool._toolTile);
						
						if (tool._sprite)
						{
							tSprite._sprite.setColor(tool._sprite.getColor());
							tSprite._tile._color = tool._sprite.getColor();
						}
						else if (tool._spriteNode)
						{
							var temp = tool._spriteNode._children[0];
							var color = temp.getColor();
							tSprite._sprite.setColor(color);
							tSprite._tile._color = color;
						}
						
						
						//game objects
						if (key == ZFGameDefines.kZombiePatchKey)
						{
							tim.createZombiePatchAtTile(tool._toolTile);
						}
						
						if (tim.isKeyZombieCombiner(key))
						{
							var zcmb = tim.createZombieCombinerAtTile(tool._toolTile);
							
							if (rdToSave)
							{
								zcmb._resultData = rdToSave;
								zcmb._resultData._rootTile = tool._toolTile;
								gs._zfGameData._zombieCombiners.push(zcmb._resultData);
							}
							
						}
						
						// release key
						
//						[key release];
						
						var refSprite = tim.atlasSpriteFromTile(tool._toolTile);
						
						var color = refSprite.getColor();
						refSprite.setOpacity(0xFF);
						refSprite.setColor(color);
						
						// clear tool sprite
						
						if(tool._sprite)
						{
							var mgr = tool._sprite.getParent();
							mgr.removeChild(tool._sprite, false);
//							[tool.sprite release];
							tool._sprite.destroy();
							tool._sprite = null;
						}
						if(tool._spriteNode)
						{
							tool._spriteNode.getParent().removeChild(tool._spriteNode, true);
							tool.spriteNode = null;
						}
						
						//reset tool data
						tool._label.setString("");
						tool._labelShadow.setString("");
						tool._originalTile = ccp(-1,-1);
						tool._toolSelectorRectMap = new Core.Rect(0,0,0,0);
						
						tool._state = ZFGameTool.kGameToolState.kGameToolStateNothingSelected;
						//////////////
						if(tool._shouldRotate)
						{
							tool.reset();
							this.toolSelected(this.kGameTool.kGameToolRotate); // resets selectedSprite AND sets current game tool AND calls toolCleanup
						}
					}
					break;
						
					case ZFGameTool.kGameToolState.kGameToolStateNothingSelected:
					{
//												console.log("@@@@@@@@@@@@@@@@@@@@@ tool move nothing selected");
						// to make sure we don't get wierd bugs (WHICH WE DID)
						tim._selectedSprite = TSprite.findByCoordinates(tileCoordinates);
						
						if(!movable || !tim._selectedSprite || tim._selectedSprite._tile._key === null)
						{
							tim._selectedSprite = null;
							return;
						}
						
						/// ROTATION STUFF /////
						var orientation = 0; // NOT equal to the original rotation
						var flipY = false;
						var usesSeparateRotateSprite = false;
						var rotations = 0;
						var key = tim._selectedSprite._tile._key;
						////////////////////////

						
						//attach sprite to cursor (and sets old tiles to grassTiles)
						if(!tool._sprite && !tool._spriteNode)
						{
							var tSprite = tim.tSpriteFromTile(tileCoordinates);
							var refSprite = tim.atlasSpriteFromTile(tileCoordinates); // this is the sprite that you drag around

							if(refSprite)
							{
								var color = refSprite.getColor();
								refSprite.setOpacity(0x80);
								refSprite.setColor(color);
								
								if(tSprite._animatedSprites)
								{
									for(var s in tSprite._animatedSprites)
									{
										c = tSprite._animatedSprites[s];
										c.setOpacity(0x80);
										c.setColor(color);
									}
								}
								
								var tileItemDictionary = tim._tilePropertiesDictionary[tSprite._tile._key];
//								NSAssert(tileItemDictionary, @"tileItemDictionary missing");
								
								////// setting ROTATION stuff //////
								usesSeparateRotateSprite = tileItemDictionary["usesSeparateRotateSprite"];
								flipY = Boolean(tileItemDictionary["flipY"]);
								rotations = tileItemDictionary["rotations"];
								
								var mgr = refSprite.getParent();
								
								orientation = tSprite._tile._orientation;	// this is the original rotation
								
								if(tool._shouldRotate)			// this is the original rotation + 1
								{
									orientation = (parseInt(tSprite._tile._orientation) + 1) % (rotations + 1);
								}
								
								
								if(tool._shouldRotate && (usesSeparateRotateSprite || rotations == 3))
								{
									key = tim.getCorrectKey(key ,orientation);
//									console.log("---@---- " + key);
									tileItemDictionary = tim._tilePropertiesDictionary[key];
									
									// change the sprite (this may apply to road bends in the future if they change into non-square tileSizes)
									// p.s. : does not actually work with road bends (square tiles will never have tool.shouldRotate == YES)
									if(usesSeparateRotateSprite)
									{
										// change the tool.sprite
										// a separate rotate sprite will NOT have a flipX or flipY value
										// if they where flipped sprites there would be no point in having a separate file for it
										
										flipY = false; // resets this to NO just in case
//										var x = tileItemDictionary["x"];
//										var y = tileItemDictionary["y"];
//										var imageWidth = tileItemDictionary["width"];
//										var imageHeight = tileItemDictionary["height"];
//										
//										var fileName = tileItemDictionary["spriteSheet"];
//										
//										var imageRect = CGRectMake(x,y,imageWidth,imageHeight);
//										tool._sprite = CCSprite.spriteWithFile(fileName, imageRect);
										
										
										var origin;
										var x = 0;
										var y = 0;
										if (tileItemDictionary.x !== undefined) {
											x = tileItemDictionary.x;
										}
										if (tileItemDictionary.y !== undefined) {
											y = tileItemDictionary.y;
										}
										origin = new Core.Point(x, y);
										var width = (tileItemDictionary.width) ? tileItemDictionary.width : mgr.texture()._imageSize._width;
										var height = (tileItemDictionary.height) ? tileItemDictionary.height : mgr.texture()._imageSize._height;

										var size = new Core.Size(width, height);
										var spriteRect = new Core.Rect(origin, size);

										tool._sprite = new CCSprite();
										tool._sprite.initWithSpriteSheet(mgr, spriteRect);
										
										
										
										
									}
								}
								else 
								{
									// this is where the tool sprite is set ! // CHANGE IT IF usesSeparateRotateSprite is YES
									tool._sprite = new CCSprite();
									tool._sprite.initWithSpriteSheet(mgr, refSprite._textureRect);
								}
								
								if(tim._tilePropertiesDictionary[tSprite._tile._key]["frameName"])
								{
									tool._sprite = new CCSprite();
									tool._sprite.initWithSpriteFrame(tim.frameFromKey(tSprite._tile._key));
//										[CCSprite spriteWithSpriteFrame:[tim frameFromKey:tSprite.tile.key]];
								}
								
								if(orientation == 1 && !usesSeparateRotateSprite)
									tool._sprite.setFlipX(true);
								if(flipY)
									tool._sprite.setFlipY(true);
								
								color = tool._sprite.getColor();
								
								tool._sprite.setOpacity(0x0);
								tool._sprite.setColor(color);
								
								
								// change the sprite attached

								//var anchors = [tim anchorsFromKey:key orientation:orientation];
								tim.anchorsFromKey_orientation(key, orientation, function(anchors)
								{


								// set new sprite values (need to place this in spriteDragging as well
								
								tool._spriteOrientation = orientation; // WARNING SPRITE ORIENTATION NOW == CHANGE ORIENTATION !!!
//								tSprite._tile._orientation = orientation;
								tool._sprite.setAnchorPoint(ccp(anchors._x, anchors._y));
								tool._sprite.setColor(refSprite.getColor());
								mgr.addChild(tool._sprite, 5, 100);
//								[tool.sprite retain];
										});
							}
						}
						
						tool._key = key;
//						[tool.key retain];
						
						//HACK labels are going undefined recreate them if necessary
						if(!(tool._label === undefined))
						{
							tool._label.setString(Core.Localization.getString("Drag"));
						}
						if(!(tool._labelShadow === undefined))
						{
							tool._labelShadow.setString(Core.Localization.getString("Drag"));
						}
						tool._originalTile = tileCoordinates;
						var pointOnMap = ccpAdd(tim.mapPointFromTile(tileCoordinates), ccp(28, 12));
						
						/////// MORE ROTATION STUFF //////////

						
						// TESTING //
						tool._tileSize = tim.tileDimensionsFromPoint(tool._originalTile);
						
						
						// MAKES SURE THAT YOU SET THE OLD TILES TO GRASS IDS /////
						var tempWidth = tool._tileSize._width;
						var tempHeight = tool._tileSize._height;
						
						////////////////////////////////////////////
						
						// AFTER THIS POINT MAKE SURE THAT SELECTED SPRITE FROM POINT IS NOT USED !!! //
						tim.setTileToGrass(tool._originalTile);
						
						for (var x = 0; x < tempWidth; x++)
						{
							for(var y = 0; y < tempHeight; y++)
							{
								tim.setTileToGrass(ccp(tileCoordinates._x - x, tileCoordinates._y - y));
							}
						}
						
						tool._tileSize = tim.tileDimensionsFromKey(tool._key, tool._spriteOrientation);
						
						this.placeToolOnNearestTileToPointOnMap(pointOnMap, toolID);
						
						tool._state = ZFGameTool.kGameToolState.kGameToolStateSpriteSelected;
					}
					break;
					
						
					// still part of MOVE tool --- sets selectedSprite
					case ZFGameTool.kGameToolState.kGameToolStateSpriteSelected:
					{
//						console.log("@@@@@@@@@@@@ ZFGameTool.kGameToolState.kGameToolStateSpriteSelected:");
						if(!movable)
						{						
							// this is the original sprite that was clicked on with orientation and all ...
							var oldSprite = tim.tSpriteFromTile(tool._originalTile); 
							tim._selectedSprite = oldSprite;
							break;
						}
						
						var newTappedSprite = tim.tSpriteFromTile(tileCoordinates);
						//tim.selectedSprite = newTappedSprite;
						
						if(newTappedSprite && !CGPointEqualToPoint(newTappedSprite._tile._rootTile, tool._originalTile))//we clicked on a new movable sprite
						{
							var refSprite = tim.atlasSpriteFromTile(tool._originalTile);
							var oldSprite = tim.tSpriteFromTile(tool._originalTile);
							
							var color = refSprite.getColor();
							refSprite.setOpacity(0xFF);
							refSprite.setColor(color);
							
							if(oldSprite._animatedSprites)
							{
								for(var key in oldSprite._animatedSprites)
								{
									c = oldSprite._animatedSprites[key];
									c.setOpacity(0xFF);
									c.setColor(color);
								}
							}

							
							color = tool._sprite.getColor();
							tool._sprite.setOpacity(0x0);
							tool._sprite.setColor(color);
							
							// again reverse toolSize (SHOULD REALLY CLEAN THIS ALL UP SOMETIME)
							
							if(tool._shouldRotate)
							{
								tool._tileSize = new Core.Size(tool._tileSize._height,tool._tileSize._width);
							}
							
							for (var x = 0; x < tool._tileSize._width; x++)
							{
								for(var y = 0; y < tool._tileSize._height; y++)
								{
									tim.setTileToOccupied(ccp(tool._originalTile._x - x, tool._originalTile._y - y), oldSprite._tile);
								}
							}
							
							// gets rid of old sprite attached to tool

							if(tool._spriteNode)
							{
								tool._spriteNode.getParent().removeChild(tool._spriteNode, true);
								tool._spriteNode = null;
							}
							if(tool._sprite)
							{
								tool._sprite.getParent().removeChild(tool._sprite, true);
								tool._sprite = null;
							}						

							// if move tool came from the rotate tool it should return to the rotate tool
							if(tool._shouldRotate)
							{						
								tool.reset();
								/* Looks like a bug in the original game. At this point tool._label and tool._labelShadow are null.
								tool._label.setString("");
								tool._labelShadow.setString("");*/
								
								tool = this._tools[this.kGameTool.kGameToolRotate];
								this.toolSelected(this.kGameTool.kGameToolRotate);	// REMEMBER! this sets selectedSprite to NIL
								this.onTileClickUp(tileCoordinates, this.kGameTool.kGameToolRotate);
							}
							else 
							{
								//reset tool data
								tool._label.setString("");
								tool._labelShadow.setString("");
								tool._originalTile = ccp(-1,-1);
								tool._toolSelectorRectMap = new Core.Rect(0,0,0,0);
								
								tool._state = ZFGameTool.kGameToolState.kGameToolStateNothingSelected;
								
								this.onTileClickUp(tileCoordinates, this.kGameTool.kGameToolMove);
							}
						}
					}
					break;
				}
				
			}
			break;
				
	// PLACE TOOL			
			case this.kGameTool.kGameToolPlace:
			{
				switch (tool._state)
				{
					case ZFGameTool.kGameToolState.kGameToolStateNothingSelected:
					{
					}
					break;
						
					case ZFGameTool.kGameToolState.kGameToolStateSpriteDragging:
					{
						if (!tool._onValidTile)//place the tile
						{
							tool._state = ZFGameTool.kGameToolState.kGameToolStateNothingSelected;
							return;
						}
						
						//check to see if this tile will fit an there are no conflicts
						if (!tim.canPlaceTileOfSize(tool._tileSize, tool._toolTile))
						{
							tool._state = ZFGameTool.kGameToolState.kGameToolStateNothingSelected;
							return;
						}
						
						if (market._paymentPending)
						{
							market.payForItemFromTool(tool);
						}
						else
						{
							// from storage
							var storage = ZFStorageMenu.storageMenu();
							storage.restoreItemFromTool(tool);
							
							var tSprite = tim.tSpriteFromTile(tool._originalTile);
							//FIXME: This validation is not int he riginal code
							if(tSprite)
							{
								TSprite.untrack(tSprite);
							}
							tim.replaceTile_withGIDkey_considerNeighbouringTiles(tool._toolTile, tool._key, true);
							tSprite = tim.tSpriteFromTile(tool._toolTile);
							
							var color;
							if(tool._spriteNode)
								color = tool._spriteNode._children[0].getColor();
							else
								color = tool._sprite.getColor();

							
							tSprite._tile._color = color;
							tSprite._sprite.setColor(color);
						}
						
						//game objects
						if (tool._key == ZFGameDefines.kZombiePatchKey)
						{
							tim.createZombiePatchAtTile(tool._toolTile);
						}
						
						if (tim.isKeyZombieCombiner(tool._key))
						{
							tim.createZombieCombinerAtTile(tool._toolTile);
						}
						
						if (tool._sprite)
						{
							var mgr = tool._sprite._parent;
							mgr.removeChild(tool._sprite, false);
							tool._sprite.destroy();
							tool._sprite = null;
						}
						if(tool._spriteNode)
						{
							tool._spriteNode.getParent().removeChild(tool._spriteNode, true);
							tool._spriteNode = null;
						}
						
						
						//reset tool data
						tool._label.setString("");
						tool._labelShadow.setString("");
						tool._originalTile = ccp(-1,-1);
						tool._toolSelectorRectMap = new Core.Rect(0,0,0,0);
						
						tool._state = ZFGameTool.kGameToolState.kGameToolStateNothingSelected;
						gui.enableMenus();
						this.toolSelected(this.kGameTool.kGameToolMulti);
						
//						RateGame.askPurchased();
						
					}
					break;
				}
			}
			break;
				
	// PLANT TOOL			
			case this.kGameTool.kGameToolPlant:
			{
				if(tool._state == ZFGameTool.kGameToolState.kGameToolStateMapScrolling)
				{
					tool._state = ZFGameTool.kGameToolState.kGameToolStateNothingSelected;
					break;
				}
				
				tool._state = ZFGameTool.kGameToolState.kGameToolStateNothingSelected;
				tim._selectedSprite = null;
				
				if (this.isTilePlantable(tileCoordinates))
				{
//					var tileSize = new Core.Size(4,4);
//					var rect;
//					rect = tim.selectorRectFromTile(tileCoordinates);
//					rect.origin.x -= ((tileSize.width-1) * rect.size.width)/2;
//					rect.size.width *= tileSize.width;
//					rect.size.height *= tileSize.height;
//					[self pushGameAction:kGameCommandPlant onTile:tileCoordinates withRect:rect withItem:tool.dictionary];

					var tileSize = new Core.Size(4,4);
					var rect;
					rect = tim.selectorRectFromTile(tileCoordinates);
					rect.getOrigin().setX(rect.getOrigin()._x - ((tileSize._width-1) * rect.getSize()._width)/2);
					rect.getSize().setAll( rect.getSize()._width * tileSize._width,  rect.getSize()._height * tileSize._height);
//					console.log("@@@@@@@@@@@@@@@@ push game action plant");
					this.pushGameAction(ZFGameAction.gameCommands.kGameCommandPlant, tileCoordinates, rect, tool._dictionary);
					
				}
				else
				{
					//default back to multi tool if place tapped is not a plantable area
					gui._toolsLayer.toggleTool(this.kGameTool.kGameToolMulti, "multiButton.png", "Multi Tool");
					this.onTileClickUp(tileCoordinates, this.kGameTool.kGameToolMulti);
				}
			}
			break;
				
			case this.kGameTool.kGameToolInstaGrow:
			{
				if(tool._state == ZFGameTool.kGameToolState.kGameToolStateMapScrolling)
				{
					tool._state = ZFGameTool.kGameToolState.kGameToolStateNothingSelected;
					break;
				}
				
				tool._state = ZFGameTool.kGameToolState.kGameToolStateNothingSelected;
				var tileProperties = tim.tilePropertiesFromPoint(tileCoordinates);
				var key = tim[tileCoordinates];
				var tSprite = TSprite.findByCoordinates(tileCoordinates);
				var name = null;
				if(tileProperties)
				 name = tileProperties["name"];	
				
				if (key == ZFGameDefines.kZombieCombinerKey2)
				{
					//allow thru
					var combiner = tim.getZombieCombinerAtTile(tileCoordinates);
							
					var t1 = combiner.timeSpentCombining();
					var t2 = combiner.getCombineTime();
					var totalGrowthTimeLeft = t2 - t1;
					
					if(totalGrowthTimeLeft > 0)
					{
						combiner._resultData._startTime = combiner._resultData._startTime - totalGrowthTimeLeft; 
						tool._amount--;
						var name = tool._dictionary["name"];
						gui._toolsLayer.setToolLabel(sprintf("%@ (%i)            "), name, tool._amount);
					}
				}
				else
				{
					if (!tileProperties								|| 
						!name										||
						this.isTileHarvestable(tileCoordinates)	|| 
						this.isTilePlowable(tileCoordinates)		|| 
						this.isTilePlantable(tileCoordinates)		||
						tileProperties["movable"])
					{
						break;
					}

					var growTime = market.growTimeFromName(name);	
					growTime = Math.floor(growTime/ GameState._zfGameData._growSpeed);
					var curDate = Core.Time.getRealTime()/1000;
					var totalAge = (curDate - tSprite._tile._plantDate);
					var totalGrowthTimeLeft = growTime - totalAge;

					if(totalGrowthTimeLeft > 0)
					{
						tSprite._tile._date = tSprite._tile._date - (totalGrowthTimeLeft);
						tool._amount--;
						var name = tool._dictionary["name"];
						gui._toolsLayer.setToolLabel(sprintf("%@ (%i)            ", name, tool._amount));
					}
				}
				
				
				if(tool._amount <= 0)
				{
					//reset tool data
					gui._toolsLayer.setToolLabel("");
					tool._label.setString("");
					tool._labelShadow.setString("");
					tool._state = ZFGameTool.kGameToolState.kGameToolStateNothingSelected;
					gui.enableMenus();
					gui._toolsLayer.replaceActiveToolButton("multiButton.png");
					this.toolSelected(this.kGameTool.kGameToolMulti);
					break;
				}
			}
			break;
				
			case this.kGameTool.kGameToolZombieCombiner:
			{
				
			}
			break;
		}
		
		tool._moved = false;
	},	
	
	clearAllGameActions: function()
	{
		var player = ZFActorManager._player;
		player._currentPlayerAction = null;
		player.moveToTile(player._farmData._currentTile);
		this._gameActionQueue.length = 0;
	},

	pushGameAction: function(actionID, tileCoordinates, rect, item)
	{
		var gs = GameState;
		var market = ZFMarketMenu.theMarket();
		
		// Check for dupes
		if (this._gameActionQueue.length > 0)
		{
			for (var key in this._gameActionQueue)
			{
				var action = this._gameActionQueue[key];
				if(CGPointEqualToPoint(action._tile, tileCoordinates))
				{
					var player = ZFActorManager._player;
					if (player._currentPlayerAction != action)
					{
						//remove this action
						this._gameActionQueue.splice(this._gameActionQueue.indexOf(action),1);
					}
					
					return;
				}
			}
		}
		
		var action = new ZFGameAction();
		action._tile = tileCoordinates;
		action._command = actionID;
		action._rect = rect;
		action._item = item;
		switch (actionID)
		{
			case ZFGameAction.gameCommands.kGameCommandPlow:
				var hasPlowMonolith = gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_NO_PLOWCOST);
				action._resourceTypeNeeded = GameData.gameResources.kGameResourceGold;
				action._cost = (hasPlowMonolith) ? 0 : ZFGameDefines.PLOW_COST;
				break;
				
			case ZFGameAction.gameCommands.kGameCommandPlant:
				var tool = this._tools[this.kGameTool.kGameToolPlant];
				action._resourceTypeNeeded = (tool._dictionary["brainsNeeded"]) ? GameData.gameResources.kGameResourceBrains : GameData.gameResources.kGameResourceGold;
				action._cost = tool._dictionary["cost"];
				break;
				
			case ZFGameAction.gameCommands.kGameCommandHarvest:
				var tSprite = TSprite.findByCoordinates(tileCoordinates); 				
				var marketItemDictionary = market.marketItemFromTilePropertiesKey(tSprite._tile._key);
				action._item = marketItemDictionary;
				break;
		}
		
		this._gameActionQueue.splice(0, 0, action);
	},
	
	popGameActionAndExecute: function(execute, dt)
	{
		var w = CCDirector.winSize();
		var tim = ZFTileManager;
		var market = ZFMarketMenu.theMarket();
		var gui = ZFGuiLayer.gui();
		var gs = GameState;
		
		if (this._gameActionQueue.length <= 0)
		{
			//nothing in queue
			return;
		}
		
		var action = this._gameActionQueue.pop();		
		if (execute)
		{
			switch (action._command)
			{
				case ZFGameAction.gameCommands.kGameCommandPlow:
					var tool = this._tools[this.kGameTool.kGameToolPlow];
					var considerNeighbouringTiles = this.isTilePlowable(action._tile) ? false : true;
					
					var gidKey = "soil_plowed";
					if(tim.canPlaceTileOfSize(tool._tileSize, action._tile) || !considerNeighbouringTiles)
					{
						if(tim.replaceTile_withGIDkey_considerNeighbouringTiles(action._tile, gidKey, considerNeighbouringTiles))
						{
							this.deductResourceForAction(action);
						}							
						
						if(tool._label)
						{
							tool._label.setString(Core.Localization.getString("Drag"));
						}
						
						if(tool._labelShadow)
						{
							tool._labelShadow.setString(Core.Localization.getString("Drag"));
						}
						
						if (!(gs._zfGameData._gflags & ZFGameFlags.GFLAG_TUTORIAL_PLANT))
						{
							var message = Core.Localization.getString("Tap on the freshly plowed soil to open the Market.\nThe Market is where you'll be able to select stuff to plant.\nYou can plant crops for money, or zombies to build yer army.");
							gui.displayAlertSimple(Core.Localization.getString("Planting"), message, 
							        CCSprite.spriteWithFile("plantTutorial1.png"),
									new Core.Rect((w._width - 480) / 2, w._height - (w._height - 240) / 2, 480, 240));
							gs._zfGameData._gflags |= ZFGameFlags.GFLAG_TUTORIAL_PLANT;
						}
					}

					NSNotificationCenter.defaultCenter().postNotificationName(ZFGameDefines.kSoilPlowedNotification, this, "Plow");
					//[[EventTracker eventTracker] sendEvent:@"zf_farm_plow_soil" withParameters:nil andDelegate:nil];
					break;
					
				case ZFGameAction.gameCommands.kGameCommandHarvest:
					var subCategory = action._item["subCategory"];
					
					//check if tile is harvestable
					var tSprite = tim.tSpriteFromTile(action._tile);
					var key = tSprite._tile._key;
					var tileItemDictionary = tim._tilePropertiesDictionary[key];
					var canHarvest = tileItemDictionary["canHarvest"];
					if (!tileItemDictionary || !canHarvest)
					{
						break;
					}
					
					if (subCategory && subCategory == "plant")
					{
						var tSprite = tim.tSpriteFromTile(action._tile);
						var flyingCropCount = (tSprite._tile._fertilized) ? 6 : 3;
						var key = tSprite._tile._key;
						var marketItemDictionary = market.marketItemFromTilePropertiesKey(key);
//						console.log("-------------@ " +key);
						var filename = marketItemDictionary["spriteSheet"];
						var scale = tim._map.getParent().getScale();
						
//						for (var i = 0; i < flyingCropCount; i++)
//						{
//							var image = new CCSprite();
//							image.initWithFile(filename);
//							image.setScale(1.0 * scale._x, 1.0 * scale._y);
//							image.setPosition(ccpAdd(tSprite._sprite.getPosition(), ccp(24 + (i % 2 * 10 ), 60 + (i * 10))));
//							image.setPosition(ccpAdd(image.getPosition(), tim._map.getPosition()));
//							var midpt = ccp(w._width/2, w._height/2);
//							var tmp = ccpSub(image.getPosition(), midpt);
//							tmp = new Core.Point(tmp._x * scale._x, tmp._y * scale._y);
//							image.setPosition(ccpAdd(tmp, midpt));
//							[gui addChild:image z:3];
//							[gui.flyingCrops addObject:image];
//							
//							[image runAction:[CCSequence actions:	
//											  [CCSpawn actions:
//											   [CCScaleTo actionWithDuration:.5f scale:1.25 * scale],nil],
//											  [CCSpawn actions:
//											   [CCMoveTo actionWithDuration:.5f position:ccp(105, 310)],
//											   [CCScaleTo actionWithDuration:.5f scale:0.25f], nil],
//											  [CCFadeTo actionWithDuration:.25f opacity:0x0], nil]];
//						}
						
						// this is how much you get for harvesting !!
						var amount = gs.amountToSellHarvestedItem(action._item);
						if(gs._zfGameData._headID == 14 || gs._zfGameData._headID == 12)
						{
							// ugly hack is ugly
							var bonus = amount * ZFGameDefines.HEAD_GOLD_BONUS; 
							amount += Math.floor(bonus);
						}
						
						if (tSprite._tile._fertilized)
						{							
							gui.displayMessage(sprintf(Core.Localization.getString("+%ig (Fertilizer)"), amount), action._tile, ZFColorDefines.colorTextHighlight, 15);
							gs.addResource(GameData.gameResources.kGameResourceGold, amount * 2.0);
						}
						else
						{
							gs.addResource(GameData.gameResources.kGameResourceGold, amount);
						}

						gui.displayMessage(sprintf("+%ig", amount), action._tile, ZFColorDefines.colorTextHighlight, 10);
						
						var gidKey = "soil_barren"; //replace me
						tim.replaceTile_withGIDkey_considerNeighbouringTiles(action._tile, gidKey, false);

						SimpleAudioEngine.playEffect(kHarvestPlantSFX);
						
						var name = action._item["name"]; //from Market
						if (name == Core.Localization.getString("Carrots"));
						{
							gs._zfGameData._carrotsHarvested++;
							ZFAchievementChecker.check1000Carrots();
//TODO							
//							[[ZFAchievementChecker achievementChecker] check1000Carrots];
//							
//							if(gs.zfGameData.carrotsHarvested == 1000)
//							{
//									/* Unlock Achievement through Facebook */
//								ZFGuiLayer *gui = [ZFGuiLayer gui];
//								[gui publishAchievement:@"com.zombiefarm.farm.1000_carrots" withDescription:@"com.zombiefarm.farm.1000_carrots.description" withImageURl:@"com.zombiefarm.farm.1000_carrots.image" ];
//								/////////////////////////////////////////
//							}
						}
					}
					else // harvesting a zombie //
					{					
						var maxArmySize = gs.maxArmySize();
						var curArmySize = gs.curArmySize();
						var defectiveRoll = Math.random();
						var defectiveRate = gs.effectiveDefectiveRate();
						var defective = (defectiveRoll < defectiveRate);
						var unitKey = action._item["unitKey"]; //from Market
						var name = action._item["name"]; //from Market
						
						if (curArmySize < maxArmySize) // we got space for this unit in our army
						{
							var tSprite = tim.tSpriteFromTile(action._tile);
							
							if (tSprite._tile._fertilized)
							{
								defective = false; //fertilized tiles are always successful harvests
								var amount = ZFMarketMenu.theMarket().costFromName(name);
								gs.addResource(GameData.gameResources.kGameResourceGold, amount);
				
								gui.displayMessage(sprintf(Core.Localization.getString("+%ig (Fertilizer Bonus)"), amount), action._tile, ZFColorDefines.colorTextHighlight, 25);
								
							}
							
							if (defective) // no zombie :(
							{
//TODO								
								gui.displayMessage(sprintf(NSLocalizedString("Lifeless %@", "Defective Zombie Message"), name), action._tile, ccc3(0xFF, 0x40, 0x40), 10);
								gui.displayMessage(NSLocalizedString("(Life Force roll failed)", "Life Force Failed roll Message"),action._tile, ccc3(0xFF, 0x40, 0x40), 25);
								
								//refund
								var refund = ZFMarketMenu.theMarket().costFromName(name);
								var hasPlowMonolith = gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_NO_PLOWCOST);
								refund += (hasPlowMonolith) ? 0 : ZFGameDefines.PLOW_COST;
								gs.addResource(GameData.gameResources.kGameResourceGold, refund);
								
								//tutorial
								if (!(gs._zfGameData._gflags & ZFGameFlags.GFLAG_LIFELESS))
								{
									var message = sprintf(NSLocalizedString("Oh no! This %@ didn't come to life! It happens from time to time.\nTo prevent this, make sure you have enough \"Life Force\" by decorating yer farm a bit.\nTrees give the most Life Force.", "Life Force Tutorial Message"), name);
									gui.displayAlertSimple(NSLocalizedString("Lifeless Zombie", "LifeLess Zombie Title"), message, CCSprite.spriteWithFile("lifelessZombieTutorial1.png"));
									gs._zfGameData._gflags |= ZFGameFlags.GFLAG_LIFELESS;
								}
//								var usrLevel = gs._zfGameData.level();
//								NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
//																		[NSNumber numberWithInt:usrLevel], @"usrLevel",
//																		[NSNumber numberWithInt:[gs getLuck]], @"lifeForce",
//																		 [NSNumber numberWithInt:[gs maxLuckForLevel:usrLevel]], @"lifeForceMax",
//																		nil];
//								[[EventTracker eventTracker] sendEvent:@"zf_farm_hvst_crop_lifeless" withParameters:eventDictionary andDelegate:nil];
							}
							else //harvest, spawn actor at tile
							{
								this.harvestZombieWithUnitKey(unitKey, action._tile);
							}
						}
						else  // our army is full! reward cash instead
						{										
							var amount = gs.amountToSellHarvestedItem(action._item);
							
							gs.addResource(GameData.gameResources.kGameResourceGold, amount);
							gui.displayMessage(NSLocalizedString("Max Army size"), action._tile, ccc3(0xFF, 0x40, 0x40), 0);
							gui.displayMessage(sprintf(NSLocalizedString("Sold! +%ig"), amount), action._tile, ZFColorDefines.colorTextHighlight, 10);
							
							if (tSprite._tile._fertilized)
							{
								gs.addResource(GameData.gameResources.kGameResourceGold, amount);
								gui.displayMessage(sprintf(NSLocalizedString("+%ig (Fertilizer Bonus)"), amount), action._tile, ZFColorDefines.colorTextHighlight, 20);
							}
						}
						
						var dictionaryProperties = tim.tilePropertiesFromPoint(action._tile);
						var gidKey = (defective) ? dictionaryProperties["transformsTo"] : "soil_blighted";
						tim.replaceTile_withGIDkey_considerNeighbouringTiles(action._tile, gidKey, false);
						
						NSNotificationCenter.defaultCenter().postNotificationName(ZFGameDefines.kCropHarvestedZombieNotification, this, name);
					}
					
					var name = action._item["name"];
					NSNotificationCenter.defaultCenter().postNotificationName(ZFGameDefines.kCropHarvestedNotification, this, name);
				
					/* FIXME: EventTracker
					NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
															name, @"Crop type",
															nil];
					
					[[EventTracker eventTracker] sendEvent:@"zf_farm_hvst_crop" withParameters:eventDictionary andDelegate:nil];*/
					break;
					
				case ZFGameAction.gameCommands.kGameCommandPlant:
				{
					//update the tile
					var name = action._item["name"];
					var isZombie = (action._item["subCategory"] == "zombie");
//					NSAssert(name, @"missing name in action.item");
					formattedName = name.replace(/ /g, "_").toLowerCase(); 
//					[[name stringByReplacingOccurrencesOfString:@" " withString:@"_"] lowercaseString];
					var gidKey = "soil_seeded_" + formattedName;
						
					this.deductResourceForAction(action);
					tim.replaceTile_withGIDkey_considerNeighbouringTiles(action._tile, gidKey, false);
					
					var tSprite = TSprite.findByCoordinates(action._tile);
					
					if (tSprite && tSprite._tile) 
					{
						tSprite._tile._date = Core.Time.getRealTime()/1000;
						tSprite._tile._plantDate = Core.Time.getRealTime()/1000;
						var dict = tim._tilePropertiesDictionary[gidKey];
						var lastKey = gidKey;
						var newKey = null;
						
						// find out what tis tile eventualy turns into when harvestable
						while (newKey != lastKey && dict["transformsTo"])
						{
							newKey = dict["transformsTo"];
							dict = tim._tilePropertiesDictionary[newKey];
							
							if(dict["canHarvest"])
							{
								tSprite._tile._endCropTile = newKey;
								break;
							}
							else if(dict["plowable"] || dict["movable"])
							{
								break;
							}
						}
						//fertilize check
						for (var key in ZFActorManager._actorList)
						{
							var actor = ZFActorManager._actorList[key];
							if(actor == "ZombieActorGarden")
							{
								var zombie = actor;
								var fertilizeChance = zombie._unitDictionary["fertilizeChance"];
								
								if (Math.random() <= fertilizeChance)
								{
									if(actor._brainState == kActorBrainStateAtHome)
									{
										var patch = ZFTileManager.getZombiePatchAtTile(actor._farmData._myHomeTile);
										patch.evictInabitant(actor);
									}
									
									//teleport
									zombie.setPosition(tim.mapPointFromTile(action._tile));
									zombie._destinationPoint = zombie.getPosition().clone();
									zombie._farmData._destinationTile = action._tile.clone();
									zombie._farmData._currentTile = zombie._farmData._destinationTile.clone();
									zombie.movementUpdate(dt); // Need to get dt here somehow...
									var newZ = zombie._farmData._currentTile._y + zombie._farmData._currentTile.x + 1;
									zombie._spriteMan.getParent().reorderChild(zombie._spriteMan, newZ);
									
//TODO particles									
//									for (var p in zombie._particles)
//									{
//										if ([p.particle isKindOfClass:[CCParticleSmoke class]])
//										{
//											p.attachmentID = kActorPartTagFootB;
//										}
//									}
//									
//									CCParticleSystem *smoke = [CCParticleSmoke node];
//									smoke.duration = 0.25f;
//									ccColor3B actorColor = [zombie colorFromSubType:zombie.subType];
//									smoke.startColor = (ccColor4F) {actorColor.r/255, actorColor.g/255, actorColor.b/255, 1.f};
//									smoke.endColor = (ccColor4F) {0, 0, 0, .0f};
//									smoke.positionType = kCCPositionTypeGrouped;
//									
//									
//									ActorParticle *p = [[ActorParticle alloc] init];
//									p.attachmentID = kActorPartTagFootB;
//									p.particle = smoke;
//									p.size = smoke.startSize;
//									p.sizevar = smoke.startSizeVar;
//									[zombie.particles addObject:p];
//									[p release];
									
									var name = market.nameFromUnitKey(zombie.classname);
									gui.displayMessage(sprintf(NSLocalizedString("Fertilized by %@!"), name), action._tile, ZFColorDefines.colorTextHighlight, 25);
									tSprite._tile._fertilized = true;
									tim._fertilizeTile(action._tile);
									
									SimpleAudioEngine.playEffect(kPoofSFX);
									
									//achievement
									gs._zfGameData._timesFertilized++;
//TODO achievements									
//									[[ZFAchievementChecker achievementChecker] check100Fertilize];
//									
//									if(gs.zfGameData.timesFertilized == 100)
//									{
//										/* Unlock Achievement through Facebook */
//										ZFGuiLayer *gui = [ZFGuiLayer gui];
//										[gui publishAchievement:@"com.zombiefarm.farm.100_fertilize" withDescription:@"com.zombiefarm.farm.100_fertilize.description" withImageURl:@"com.zombiefarm.farm.100_fertilize.image" ];
//										/////////////////////////////////////////
//									}
									
									break;
								}
							}
						}
						
						if (!(gs._zfGameData._gflags & ZFGameFlags.GFLAG_TUTORIAL_PLANT_DONE))
						{
							var message = sprintf(Core.Localization.getString("You just planted yer first crop, %@%@ will soon germinate!\n\nBe watchful, ya gotta harvest yer crops when they're ready or they'll wither away (Zombies too!)."), (isZombie) ? Core.Localization.getString("a ") : "", name);
							gui.displayAlertSimple(Core.Localization.getString("Crop Growth"), 
										message, 
										 null,
										 new Core.Rect((w._width - 360) / 2, w._height - (w._height - 240) / 2, 360, 240));
							
							gs._zfGameData._gflags |= ZFGameFlags.GFLAG_TUTORIAL_PLANT_DONE;
							
							gs.saveGame();
						}
						
						if (!(gs._zfGameData._gflags & ZFGameFlags.GFLAG_TUTORIAL_DONE) && 
							(gs._zfGameData._gflags & ZFGameFlags.GFLAG_TUTORIAL_PLANT_DONE) &&
							(gs._zfGameData._gflags & ZFGameFlags.GFLAG_HARVEST_ZOMBIE) &&
							(gs._zfGameData._gflags & ZFGameFlags.GFLAG_TUTORIAL_START))
						{
							var message = Core.Localization.getString("That's it!\n\nHave a rotten good time, and happy farming!");
							gui.displayAlertSimple(Core.Localization.getString("Congratulations"), message, 
										 CCSprite.spriteWithFile("levelUp.png"),
										 new Core.Rect((w._width - 480) / 2, w._height - (w._height - 210) / 2, 480, 210));
							gs._zfGameData._gflags |= ZFGameFlags.GFLAG_TUTORIAL_DONE;
				
							ZFQuestMan.addQuestWithID(1); //1 is the preparin the farm quest
							gs.saveGame();
							//TODO achievement							
//							[[ZFAchievementChecker achievementChecker] checkFarmTutorialDone];
							
							/* Unlock Achievement through Facebook */
//							ZFGuiLayer *gui = [ZFGuiLayer gui];
//							[gui publishAchievement:@"com.zombiefarm.farm.tutorial_done" withDescription:@"com.zombiefarm.farm.tutorial_done.description" withImageURl:@"com.zombiefarm.farm.tutorial_done.image" ];
							/////////////////////////////////////////
						}
					}
					
					NSNotificationCenter.defaultCenter().postNotificationName(ZFGameDefines.kCropPlantedNotification, this, name);

					/* FIXME: Event tracker
					NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
															name, @"Crop type",
															nil];
					[[EventTracker eventTracker] sendEvent:@"zf_farm_plant_crop" withParameters:eventDictionary andDelegate:nil];*/
				}
				break;
					
				default:
				{
					console.log("popGameAction:unknown command = "+ action._command);
				}
			}
		}
			
//		[action release];
	},

	hasResourceForAction: function(action)
	{
		if(!action)
			return false;
		
		var gs = GameState;
		
		switch (action._command) 
		{
			case ZFGameAction.gameCommands.kGameCommandPlow:
			{
				if(gs.hasResource(action._resourceTypeNeeded, action._cost))
				{
					return true;
				}
				else 
				{
					ZFGuiLayer.gui().displayMessage(Core.Localization.getString("Not enough gold!"), action._tile, ccc3(0xFF, 0x40, 0x40), 0);	
				}
				break;
			}
			case ZFGameAction.gameCommands.kGameCommandPlant:
			{
				if(gs.hasResource(action._resourceTypeNeeded, action._cost))
				{
					return true;
				}
				else
				{					
					ZFGuiLayer.gui().displayMessage(Core.Localization.getString("Not enough gold!"), action._tile, ccc3(0xFF, 0x40, 0x40), 0);
				}
				break;
			}
			default:
			{
				return true;
			}
		}
		return false;
	},


	deductResourceForAction: function(action)
	{			
		if(!action)
			return;
		
		if(!this.hasResourceForAction(action))
			return;
		
		var gs = GameState;
		var message = "";
		var message2 = "";
//		console.log("deduct resource " + action._cost);
		switch (action._command) 
		{
			case ZFGameAction.gameCommands.kGameCommandPlow:
			{
				var hasPlowMonolith = gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_NO_PLOWCOST);
//				console.log("hasPlowMonolith  " + hasPlowMonolith);
				// 0.82 build change (fixed sfx for plowing with plow monolith)
				
				var plowCost = (hasPlowMonolith)? 0:action._cost;
//				console.log("plowCost  " + plowCost);
				gs.subResource(action._resourceTypeNeeded, plowCost);
				
				if (!hasPlowMonolith)
				{
					
					message = sprintf("-%ig", ZFGameDefines.PLOW_COST);
					message2 = sprintf("+%ixp", ZFGameDefines.PLOW_XP);
					gs.addResource(GameData.gameResources.kGameResourceXP ,ZFGameDefines.PLOW_XP);
				
					ZFGuiLayer.gui().displayMessage(message, action._tile, ccc3(0xFF, 0x40, 0x40), 0);
					ZFGuiLayer.gui().displayMessage(message2, action._tile, ZFColorDefines.colorTextHighlight, 10);
				}
				break;
			}
			
			case ZFGameAction.gameCommands.kGameCommandPlant:
			{
				var xp = ZFMarketMenu.theMarket().xpFromName(action._item["name"]);
				var hasPlowMonolith = gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_NO_PLOWCOST);
				if (hasPlowMonolith)
				{
					xp++;
				}
					
				var cost = action._cost;
				gs.subResource(action._resourceTypeNeeded, action._cost);
				gs.addResource(GameData.gameResources.kGameResourceXP, xp);
				
				message =  sprintf("-%i%@", cost, (action._resourceTypeNeeded == GameData.gameResources.kGameResourceGold) ? Core.Localization.getString("g") : Core.Localization.getString(" brain"));
				message2 = sprintf("+%ixp", xp);
				ZFGuiLayer.gui().displayMessage(message, action._tile, ccc3(0xFF, 0x40, 0x40), 0);
				ZFGuiLayer.gui().displayMessage(message2, action._tile, ZFColorDefines.colorTextHighlight, 10);
				break;
			}
			default:
			{
			}
		}
	},

	harvestZombieWithUnitKey: function(unitKey, tileCoordinates)
	{
		
		var w = new Core.Size(UI.Window._width, UI.Window._height);
		var gs = GameState;
		var gui = ZFGuiLayer.gui();
		var tim = ZFTileManager;
//		NSAssert(unitKey, @"unitKey is nil");
//		
		var mutantRoll = Math.random();
		var mutantRate = gs.effectiveMutantRate();
		var mutant = (mutantRoll <= mutantRate);
		
		//HACK to init zombieActor base class instead of unitKey
		var zActor = ZFActorManager.spawnFarmActor_onTile(unitKey, tileCoordinates);

		SimpleAudioEngine.playEffect(kHarvestZombieSFX);
//		
		
		zActor._eatDate = Core.Time.getRealTime()/1000;
//		zActor._eatDate -= ZFGameDefines.ZOMBIE_HUNGER_DURATION;
//			[NSDate dateWithTimeIntervalSinceNow:-ZOMBIE_HUNGER_DURATION];

		if (mutant)
		{
			//check neighbouring tiles for crops to determine mutation type
			var neighbouringCrops = tim.neighbouringTilesWithCategory("crop", "plant", tileCoordinates, CGSizeMake(4,4));
			
			if(neighbouringCrops)
			{
				mutant = false;
	            var mutationID = 0;
				
				for (var i in neighbouringCrops)
				{
					var crop = neighbouringCrops[i];

					if (crop == "Dragon Fruit" && gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_DRAGONMUTATION))
					{
						mutationID |= kMutationDragonArms;
					}
					else if (crop == "Venus Flytrap" && gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_FLYTRAPMUTATION))
					{
						mutationID |= kMutationFlyTrapCollar;
					}
					else if (crop == "Tomatoes" && gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_TOMATOMUTATION))
					{
						mutationID |= kMutationTomatoHead;
					}
					else if (crop == "Onions" && gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_ONIONMUTATION))
					{
						mutationID |= kMutationOnionHead;
					}
					else if (crop == "Carrots" && gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_CARROTMUTATION))
					{
						mutationID |= kMutationCarrotHat;
					}
					else if (crop == "Turnips" && gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_TURNIPMUTATION))
					{
						mutationID |= kMutationTurnipArms;
					}
					else if (crop == "Potatoes" && gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_POTATOMUTATION))
					{
						mutationID |= kMutationPotatoHead;
					}
					else if (crop == "Coffee" && gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_COFFEEMUTATION))
					{
						mutationID |= kMutationCoffeeHead;
					}
					//else if (crop == "Pumpking" && [zActor isKindOfClass:[ZombieActorHeadless class]]) //removed after haloween season
					//{
					//	mutationID |= kMutationPumpkinHead;
					//}
					else if (crop == "Celery" && gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_CELERYMUTATION))
					{
						mutationID |= kMutationCeleryArms;
					}
					else if (crop == "Broccoli" && gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_BROCCOLIMUTATION))
					{
						mutationID |= kMutationBroccoliHat;
					}
					else if (crop == "Garlic" && gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_GARLICMUTATION))
					{
						mutationID |= kMutationGarlicHead;
					}
					else if (crop == "Cauliflower" && gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_CAULIFLOWERMUTATION))
					{
						mutationID |= kMutationCauliflowerHat;
					}
					else if (crop == "Lima Beans" && gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_LIMABEANMUTATION))
					{
						mutationID |= kMutationLimaBeanBody;
					}
				}

	            zActor.addMutation(mutationID);  

	            if (mutationID != 0)
	            {
	                mutant = true;
	            }
			}
			else
			{
				gui.displayToolTip(Core.Localization.getString("Mutation failed"), Core.Localization.getString("(Harvest zombies next to food crops for a possible mutation)"));
				mutant = false;
			}
		}

		gui.updateArmySize();
		var name = ZFMarketMenu.theMarket().nameFromUnitKey(unitKey);
		var message = name;
		gui.displayMessage(message, tileCoordinates, ZFColorDefines.colorTextHighlight, 0);
		message = null;
		
		//tutorial
		if (!(gs._zfGameData._gflags & ZFGameFlags.GFLAG_HARVEST_ZOMBIE ) && unitKey == "ZombieActorRegularTier1")
		{
			message = Core.Localization.getString("This is yer basic home grown zombie.\nAlthough he's happy to be alive, he seems lonely. Plant more zombies to give him buddies! In the meantime, he's gonna wander around yer farm.");
			gs._zfGameData._gflags |= ZFGameFlags.GFLAG_HARVEST_ZOMBIE;
			gui.displayAlertSimple(Core.Localization.getString("Hello Zombie!"), message, 
						 CCSprite.spriteWithFile("regularZombie.png"),
						 new Core.Rect((w._width - 480) / 2, w._height - (w._height - 280) / 2, 480, 280));
			
			message = Core.Localization.getString("\nWhen you have at least 8 zombies, you can start an invasion!\nInvasions are a great way to get some gold, and sometimes even brains. So keep planting those zombies.");
			ZFGuiLayer.gui().displayAlertSimple(Core.Localization.getString("What do I do with my zombie?"), message, CCSprite.spriteWithFile("regularZombie.png"));
			
			message = Core.Localization.getString("Now that yer zombie is out and about, use the Plow Tool to cover up that unsightly hole he came from.\nYou can also plow it with the Multi Tool just by tapping it.\nPlowing will prepare the patch of soil for re-planting.");
			ZFGuiLayer.gui().displayAlertSimple(Core.Localization.getString("Plowing Soil"), message,  
									  CCSprite.spriteWithFile("plowTutorial1.png"),
									  new Core.Rect((w._width - 480) / 2, w._height - (w._height - 280) / 2, 480, 280));
			
			gs.saveGame();
			message = null;
		}
		else if (!(gs._zfGameData._gflags & ZFGameFlags.GFLAG_HARVEST_MUTANT) && mutant)
		{
			message = Core.Localization.getString("WOAH! That's one bizarre zombie!\nThanks to all that Life Force, your zombie got some traits from the plants next to him. Some mutations increase speed, others increase power or defense. Visit the market to unlock more mutations.");
			gui.displayAlertSimple(Core.Localization.getString("Zombie Mutation!"), message, null);
			gs._zfGameData._gflags |= ZFGameFlags.GFLAG_HARVEST_MUTANT;
			message = null;
		}
		else if (!(gs._zfGameData._gflags & ZFGameFlags.GFLAG_HARVEST_GARDEN_ZOMBIE) && unitKey == "ZombieActorGardenTier1")
		{
			message = Core.Localization.getString("Yer very own Garden Zombie! If your lucky, he'll fertilize your crops after you plant them. Garden zombies are peaceful creatures, they're the last to join a fight and they don't do well in combat.");
			gui.displayAlertSimple(Core.Localization.getString("Garden Zombie"), message, CCSprite.spriteWithFile("gardenZombie.png"));
			gs._zfGameData._gflags |= ZFGameFlags.GFLAG_HARVEST_GARDEN_ZOMBIE;
			message = null;
		}
		
		if (message)
		{
			gui.displayAlertSimple(unitKey, message, CCSprite.spriteWithFile("regularZombie.png"));
		}
		
		if (gs.canInvade())
		{
			gui.showInvasionMenu(null);
			
			if(!(gs._zfGameData._gflags & ZFGameFlags.GFLAG_INVADE))
			{
				var message = NSLocalizedString("Looks like ya finally have enough zombies to start an invasion.\nThough you can start an invasion now, it's usually best to fight with a full army of 16 zombies. If you win, you just might get a brain from the enemy.", "Invade Message");
				gui.displayAlertSimple(NSLocalizedString("Zombie Invasion", "Zombie Invade Title"),  message, null);
				gs._zfGameData._gflags |= ZFGameFlags.GFLAG_INVADE;
				message = NSLocalizedString("That darned farmer Old McDonnell has been givin ya the stink eye lately... Why don't ya show him who's boss!\n\nTap on \"Invade\" when yer ready to raid his barn.", "Old McDonnell Message");
				gui.displayAlertSimple(NSLocalizedString("Old McDonnell", "Old McDonnell Title"), message, CCSprite.spriteWithFile("oldMcDonnellSprite.png"));
			}
		}
		
		if (gs.curArmySize() >= gs.maxArmySize())
		{		
			if(!(gs._zfGameData._gflags & ZFGameFlags.GFLAG_MAX_ARMY_SIZE))
			{
				var message = Core.Localization.getString("Yer army of zombies is full! You're now fully prepared to invade and terrorize!\nKeep in mind, that harvesting zombies when you have a full army will give you gold instead of a zombie.");
				gui.displayAlertSimple(Core.Localization.getString("Max zombies"), message, CCSprite.spriteWithFile("oldMcDonnellSprite.png"));
				gs._zfGameData._gflags |= ZFGameFlags.GFLAG_MAX_ARMY_SIZE;
	
	
				ZFQuestMan.addQuestWithID(7);//7 is overrun the farm
			}
		}
		
//		RateGame.ask10Zombies();
	},
	
	placeTileWithSprite: function(sprite, key)
	{
		var winSize = new Core.Rect(0,0, 480, 320);
		var widthScale = UI.Window._width / ZFGameDefines.ORIGINAL_WINDOW_WIDTH;
		var heightScale = UI.Window._height / ZFGameDefines.ORIGINAL_WINDOW_HEIGHT;
		
		var tim = ZFTileManager;
		var tool = this._tools[this.kGameTool.kGameToolPlace];
		this.toolCleanup(this._currentGameTool);
		this._currentGameTool = this.kGameTool.kGameToolPlace;
		tool._tileSize = tim.tileDimensionsFromKey(key, 0);
		tool._label = CCLabel.labelWithString(Core.Localization.getString("Drag"), "Arial-BoldMT", 14);
//		[tool.label retain];
		tool._labelShadow = CCLabel.labelWithString(Core.Localization.getString("Drag") ,"Arial-BoldMT" ,14);
		tool._labelShadow.setColor(ccc3(0x0, 0x0, 0x0));
//		[tool.labelShadow retain];
		tool._state = ZFGameTool.kGameToolState.kGameToolStateNothingSelected;//kGameToolStateSpriteDragging;
		this.placeToolOnNearestTileToPointOnMap(ccpAdd(ccp(-tim._map.getPosition()._x, -tim._map.getPosition()._y), ccp((480*widthScale)/2, (320*heightScale)/2)), this.kGameTool.kGameToolPlace);
		tool._key = key;

                
        if (!(sprite instanceof CCSprite))
        {
            tool._spriteNode = sprite;
            ZFTileManager.anchorsFromKey(key, function(anchor)
            {
                for (var key in tool._spriteNode._children)
                {
                    c = tool._spriteNode._children[key];
                    c.setOpacity(0xFF);
                    c.setAnchorPoint(anchor);
                }
            });
        }
		else 
		{		
			tool._sprite = sprite;
			tool._sprite.setOpacity(0xFF);		
		}

		var anchorX = ZFGameDefines.LARGE_TILE_POSITION_ADJUST_X;
		var anchorY = ZFGameDefines.LARGE_TILE_POSITION_ADJUST_Y;
		
		var dictionary = tim._tilePropertiesDictionary[key];
		
		if(dictionary["pivotx"])
		{
			anchorX =dictionary["pivotx"];
		}
		
		if(dictionary["pivoty"])
		{
			anchorY =dictionary["pivoty"];
		}
	
		if(tool._sprite)
			tool._sprite.setAnchorPoint(ccp(anchorX, anchorY));
		tool._tileSize = tim.tileDimensionsFromKey(key, 0);
//		[tool.sprite retain];
	},
	
	useInstaGrow: function()
	{
		var sm = ZFStorageMenu.storageMenu();
		var key = "Insta-Grow";
		if (sm.numberOfItemInStorageWithKey(key) > 0)
		{
			//auto use the item
			sm.useItemWithName(key);
		}
		else 
		{
			ZFMarketMenu.theMarket().shortcutBuy(key);
		}
	},
	
	startInstaGrow: function(item)
	{

		var gui = ZFGuiLayer.gui();
		var tool = this._tools[this.kGameTool.kGameToolInstaGrow];
		tool._dictionary = item;
		var amount = item["amount"];
		NSAssert(amount, "amount missing in this item");
		tool._amount = amount;
		
		var filename = item["spriteSheet"];
		var spriteRect = CGRectMake(0, 0, 32, 32);
		
		var mgr = CCSpriteSheet.spriteSheetWithFile(filename);
		var image = CCSprite.spriteWithSpriteSheet(mgr, spriteRect);
		
		image.setScale(ccp(1.25, 1.25));
		mgr.addChild(image);
		gui.addChild(mgr, 3);
		tool._sprite = image;
		tool._sprite._tag = ZFGameTool.kGameToolState.kTagSelectedSprite;
		this.toolSelected(this.kGameTool.kGameToolInstaGrow);
		
		gui.displayAlertSimple(NSLocalizedString("Insta-Grow"), 
					sprintf(NSLocalizedString("Choose %i crops or zombies to instantly grow so that they can be harvested.\n\nWarning: Don't change tools unless you're done using the Insta-Grow."), tool._amount),
					 null);
	},

	
	alertWindow_dismissedPositive: function(alertWindow, dummy)
	{
		var market = ZFMarketMenu.theMarket();
		if (alertWindow._idTag == this.TAG_DELETE_ACTOR)
		{
			if(dummy)
			{
				var actor = alertWindow._data;
				var guiActor = alertWindow.getChildByTag(alertWindow.kAlertWindowTags.kAlertWindowTagZombie);

				var baseSaleValue = ZFGameDefines.PLOW_COST;
				var trueSaleValue = baseSaleValue + market.costFromName(market.nameFromUnitKey(actor.classname));

				ZFGuiLayer.gui().displayMessage(sprintf(NSLocalizedString("Sold! +%ig"), trueSaleValue), 
										actor._farmData._currentTile,
									 ZFColorDefines.colorTextHighlight, 
									 0);
				GameState.addResource(GameData.gameResources.kGameResourceGold, trueSaleValue);
				SimpleAudioEngine.playEffect(kEarnSFX);
				
				if(guiActor)
				{
					ZFActorManager.despawnActor(guiActor);
				}
				
				if(actor instanceof StageActor)
				{
					ZFActorManager._farmActors.splice(ZFActorManager._farmActors.indexOf(actor), 1);
					actor.despawn();
				}
				else 
				{
					ZFActorManager.despawnFarmActor(actor);				
				}

				SimpleAudioEngine.playEffect(kDeleteSFX);
			}
		}
		else if(alertWindow._idTag == this.TAG_PATCH_COLLECT)
		{
			if(dummy)
			{
                var patch = alertWindow._data;
                patch.on();
			}
		}
		else if (alertWindow._idTag == this.TAG_PATCH_EVICT)
		{
			if (dummy)
			{
                 var patch = alertWindow._data;
                 patch.off();
			}
		}
		else if (dummy && alertWindow._idTag == this.TAG_SCREENSHOT)
		{
		    /* FIXME: Screenshot manager
			ZFScreenshotManager *ssm = [ZFScreenshotManager screenshotManager];
			
			GameState *gs = [GameState gameState]; 
			NSTimeInterval day = 60 * 60 * 24;
			
			if (!gs.zfGameData.lastPhotoDate || fabs([gs.zfGameData.lastPhotoDate timeIntervalSinceNow]) > day)
			{
				[[NSNotificationCenter defaultCenter] addObserver:self 
														 selector:@selector(saveDone) 
															 name:kSaveDoneNotification 
														   object:nil];
				
				gs.zfGameData.lastPhotoDate = [NSDate date];
				[gs addResource:kGameResourceGold amount:DAILY_PHOTO_GOLD_BONUS];
				[gs saveGame]; //save after getting photo gold
			}
			else
			{
				[ssm takeScreenCap:YES];
			}*/
		}
		
		alertWindow.data = null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/GuiLayer/Quests/ZFQuestMan'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/GuiLayer/Quests/ZFQuestMan'] || {}; $MODULE_REGISTRY['Code/Game/GUI/GuiLayer/Quests/ZFQuestMan'] = exports; exports.ZFQuestMan = CCNode.singleton({
	classname : 'ZFQuestMan',

	initialize : function() {
	    this._widthScale = UI.Window._width / 480.0; 
        this._questQueue = [];
        this._disabled = false;
        this._scaleLastQuest = true;
        this._questArray = DataPreloader._questData;
	},

	$questMan : function() {
		return this;
	},

	destroy : function() {
		if (this._questArray) {
			this._questArray.length = 0;
			this._questArray = null;
		}
		if (this._questQueue) {
			this._questQueue.length = 0;
			this._questQueue = null;
		}
	},

	//- (void)questPressed:(ZFQuestNotification*)quest
	questPressed : function(quest) {
		var gui = ZFGuiLayer.gui();

		if (quest._ID == -1) {
			//this is just a notification
			this._questQueue.splice(this._questQueue.indexOf(quest), 1);
			this.cleanupQuest(quest);
		} else {
			//this is an actual quest
			if (gui._inGameMenu.isMenuEnabled()) {
				return; //don't allow for overlapping of inGameMenu when it's open
			}

			var qm = ZFQuestMenu;
			qm.openMenuWithQuest(quest);

			//FIXME
			//NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObject:@"game" forKey:@"Quest Type"];
			//[[EventTracker eventTracker] sendEvent:@"zf_farm_sel_quest" withParameters:eventDictionary andDelegate:nil];
		}

		if (quest._alertWindowActive) {
			//FIXME
			//if (quest._alertWindowActive instanceof ZFAlertWindowFlurryOffer) {
			//    NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObject:@"salesman" forKey:@"Quest Type"];
			//    [[EventTracker eventTracker] sendEvent:@"zf_farm_sel_quest" withParameters:eventDictionary andDelegate:nil];
			//}
			gui._alertWindows.unshift(quest._alertWindowActive);
		}
	},

	cleanupQuest : function(/*ZFQuestNotification* */quest) {
		quest.removeAllChildrenWithCleanup(true);
		quest._parent.removeChild(quest, true);

		this._scaleLastQuest = false;
		this.reorderQuests();
		quest.stopListening();
		destroy(quest);
	},

	completeQuest : function(/*ZFQuestNotification*/quest) {
		var gui = ZFGuiLayer.gui();
		var storage = ZFStorageMenu;
		quest._alertWindowComplete = ZFAlertWindowQuestComplete.alertWindowWithQuest(quest);
		gui._alertWindows.unshift(quest._alertWindowComplete);
		quest._alertWindowComplete._delegate = this;
		quest._alertWindowComplete._userData = quest; //retain

		//the quest will be removed from queue but will stick around until dealloced
		this._questQueue.splice(this._questQueue.indexOf(quest), 1);

		//also remove quest form the save structure
		var gs = GameState;

		for ( var i = gs._zfGameData._currentQuests.length - 1; i >= 0; i--) {
			var it = gs._zfGameData._currentQuests[i];
			if (it.ID == quest._ID) {
				gs._zfGameData._currentQuests.splice(i, 1);
				break;
			}
		}

		switch (quest._rewardType) {
			case ZFQuestNotification.questRewardTypes.questRewardTypeResourceXP:
				gs.addResource(GameData.gameResources.kGameResourceXP, quest._rewardObject);
				break;
	
			case ZFQuestNotification.questRewardTypes.questRewardTypeResourceGold:
				gs.addResource(GameData.gameResource.kGameResourceGold, quest._rewardObject);
				break;
	
			case ZFQuestNotification.questRewardTypes.questRewardTypeResourceBrains:
				gs.addResource(GameData.gameResources.kGameResourceBrains, quest._rewardObject);
				break;
	
			case ZFQuestNotification.questRewardTypes.questRewardTypeItem:
				storage.addMarketItemToStorage(quest._rewardObject);
				break;
		}

		if (!this.hasQuestBeenCompleted(quest._ID)) {
			gs._zfGameData._completedQuests.push(quest._ID);
		}

		this.cleanupQuest(quest);
	},

	addQuestWithAlert : function(/*ZFAlertWindow* */alert, /*CCSprite* */ sprite) {
		//FIXME: Temporarty
		return;
		
		var quest = new ZFQuestNotification();
		quest._sprite = sprite;
//		console.log("sprite: (" + sprite.getSize()._width + "," + sprite.getSize()._height + ")");
		quest._sprite.setAnchorPoint(ccp(0, 0));
		quest.setPosition(ccp(5, -100));
		quest._alertWindowActive = alert;
		this._questQueue.unshift(quest);//alert quests move to the top of the que since they get dismissed easily
		quest._ID = ZFQuestNotification.questType.kQuestTypeNotification;

		//add the sprite in the right place
		var gui = ZFGuiLayer;
		quest.addChild(quest._sprite, 0);
		gui.addChild(quest, 3);

		this._scaleLastQuest = true;
		this.reorderQuests();
	},

	addQuestWithID : function(questID) {
		// not a valid quest?
		if (questID < 0 || questID > this._questArray.length) {
			return;
		}
		
		var quest = new ZFQuestNotification();
		if( !quest.initWithID(questID, true) ){
			return;
		} //autorelease
		

		var gs = GameState;

		//lets see if this quest has been completed
		if (this.hasQuestBeenCompleted(questID)) {
			return;
		}

		// if the quest has been flagged to be removed (in plist).
		if (quest._removeQuest) {
			return;
		}

		// if seasonal quest and is not the season
		if (quest._seasonal && !gs.seasonalItemsAvailable()) {
			return;
		}

		if (gs._zfGameData._level < quest._levelRequired) {
			return;
		}

		if (!this.hasQuestBeenCompleted(quest._prerequisiteQuest)) {
			return;
		}

		//lets see if this quest already exists
		for (var qi in this._questQueue) {
			var q = this._questQueue[qi];
			if (q._ID == questID) {
				return; //dupe!
			}
		}

		//add it to the save structure
		var item = {};
		item.ID = questID;
		item.progress = [ 0, 0, 0 ];

		gs._zfGameData._currentQuests.push(item);

		quest._sprite.setAnchorPoint(ccp(0, 0));
		quest.setPosition(ccp(5, -100));

		// seasonal quest are always prioritized
		if (quest._seasonal) {
			this._questQueue.unshift(quest);
		} else {
			this._questQueue.push(quest);
		}

		//add the sprite in the right place
		var gui = ZFGuiLayer.gui();
		quest.addChild(quest._sprite, 0);
		gui.addChild(quest, 3);

		quest.startListening();
		this._scaleLastQuest = true;
		this.reorderQuests();
	},

	hasQuestBeenCompleted : function(questID) {
		if (questID == -1)
			return true;

		var gs = GameState;
		for ( var i in gs._zfGameData._completedQuests) {
			if (gs._zfGameData._completedQuests[i] == questID) {
				return true;
			}
		}

		return false;
	},

	reorderQuests : function() {
		if (this._disabled) {
			return;
		}

		var w = CCDirector.winSize();

		var visibleLimit = 6;

		for ( var index in this._questQueue) {
			var quest = this._questQueue[index];

			var iconsize = 48;

			if (index < visibleLimit) {
				//slide up if needed
				var destination = ccp(5, w._height - iconsize -80 - ((iconsize*1.2) * (index)));

				var actionTo = CCMoveTo.actionWithDuration(0.5, destination);
				quest.runAction(actionTo);
//				quest._sprite.setPosition(ccp(0, 0));
				quest._isTouchEnabled = true;
				quest._sprite.setVisible(true);
//				if (this._widthScale <= 1)
				{
					quest.setScale(0.75);
				} 
				
//				if (quest.getPosition()._y == -100) {
//					//give a nice opening effect (attention getter)
//					quest.setScale(0);
//					
//					var actionTo2 = CCSequence.actions(CCScaleTo.actionWithDuration(0.3, 1.75), CCScaleTo.actionWithDuration(0.2, 1));
//					quest.runAction(actionTo2);
//				}
			} else {
				//off screen
				quest.setPosition(ccp(5, -100));
				quest._sprite.setPosition(0, 0);
				quest._sprite.setVisible(false);
			}
		}

	},

	disableMenus : function() {
		this._disabled = true;

		for ( var qi in this._questQueue) {
			var quest = this._questQueue[qi];
			quest._sprite.setVisible(false);
			quest._isTouchEnabled = false;
		}
	},

	enableMenus : function() {
		this._disabled = false;
		this._scaleLastQuest = false;
		this.reorderQuests();
	},

	alertWindow_dismissedPositive : function(/*ZFAlertWindow* */ alertWindow, /*BOOL*/ dummy) {
		var quest = alertWindow._userData;
		this.questTriggerQuestCompleted(quest._ID);
		alertWindow._userData = null;
		destroy(quest);
	},

	// Triggers
	questTriggerCheckLevelUp : function() {
		var gs = GameState;
		//check quests that trigger from leveling up

		for ( var di in this._questArray) {
			var d = this._questArray[di];
			var levelReq = d.levelRequired;
			if (levelReq <= gs._zfGameData._level) {
				//trigger!
				this.addQuestWithID(di);
			}
		}
	},

	questTriggerQuestCompleted : function(questID) {
		//check quests that trigger from leveling up

		for ( var di in this._questArray) {
			var d = this._questArray[di];
			var preReq = d.prerequisiteQuest;

			if (preReq == questID) {
				//trigger!
				this.addQuestWithID(di);
			}
		}
	},

	checkSeason : function() {
		if (GameState.seasonalItemsAvailable()) {
			this.addSeasonalQuests();
		} else {
			this.removeSeasonalQuests();
		}
	},

	addSeasonalQuests : function() {
		for ( var di in this._questArray) {
			var d = this._questArray[di];
			if (d.seasonal) {
				this.addQuestWithID(di);
			}
		}
	},

	removeSeasonalQuests : function() {
		var toRemove = [];
		var gs = GameState;

		for ( var qi in this._questQueue) {
			var q = this._questQueue[qi];
			if (q.seasonal) {
				// make an array of quests to remove from quest queue (NOT equal to saved quest array)
				toRemove.push(q);
				this.cleanupQuest(q);
				// remove quest from saved quest array
				var idx = -1;
				for ( var di in gs._zfGameData._currentQuests) {
					// SHIKAKA
					var d = gs._zfGameData._currentQuests[di];
					if (d.ID == q._ID) {
						idx = di;
						break;
					}
				}

				if (idx != -1) {
					gs._zfGameData._currentQuests.splice(idx,1);
				}
			}
		}

		for ( var qi in toRemove) {
			this._questQueue.splice(this._questQueue.indexOf(toRemove[qi]),1);
		}

		toRemove.length = 0;
		toRemove = null;
	},

	restoreQuestsFromSave : function() {
		var gs = GameState;

		if (!gs._zfGameData._currentQuests || gs._zfGameData._currentQuests.length == 0)
			return;

		for ( var di in gs._zfGameData._currentQuests) {
			var d = gs._zfGameData._currentQuests[di];
			var questID = d.ID;

			var quest = new ZFQuestNotification();
			quest.initWithID(questID, true);

			//lets see if this quest has been completed
			if (this.hasQuestBeenCompleted(questID))
				continue;

			// Check the remove flag(s).
			if (quest._removeQuest)
				continue;

			//lets see if this quest already exists
			var dupe = false;
			for ( var qi in this._questQueue) {
				var q = this._questQueue[qi];
				if (q._ID == questID) {
					dupe = true;
					break; //dupe!
				}
			}

			if (dupe)
			{
				continue;
			}

			//restore progress
			var tempA = d.progress;

			if (tempA && tempA.length > 0) {
				var a = d.progress;

				for ( var index in quest._requirements) {
					var req = quest._requirements[index];

					// If the requirement progress exists then write it out
					// otherwise write out a 0
					if (index < a.length) {
						var amount = a[index];
						// Just in case
						if (!amount)
						{
							req._countCurrent = 0;
						}
						else
						{
							req._countCurrent = amount;
						}
					}
					else
					{
						req._countCurrent = 0;
					}

					// Make sure to clamp to the total
					if (req._countCurrent > req._countTotal)
						req._countCurrent = req._countTotal;
				}
			} else {
				// Progress array wasn't initialized
				d.progress = [ 0, 0, 0 ];
			}

			//set it up in the gui
			quest._sprite.setAnchorPoint(ccp(0, 0));
			quest.setPosition(ccp(5, -100));

			if (quest._seasonal)
			{
				this._questQueue.splice(0, 0, quest);
			}
			else
			{
				this._questQueue.push(quest);
			}

			//add the sprite in the right place
			var gui = ZFGuiLayer.gui();
			quest.addChild(quest._sprite, 0);
			gui.addChild(quest, 3);

			quest.startListening();
		}

		this._scaleLastQuest = false;
		this.checkSeason();
		this.reorderQuests();
	}

//- (void)alertWindow:(ZFAlertWindow*)alertWindow dismissedPositive:(BOOL)dummy withButtonTag:(NSInteger)buttonTag
//{
//	
//}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Tools/ZFGameTool'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Tools/ZFGameTool'] || {}; $MODULE_REGISTRY['Code/Game/Tools/ZFGameTool'] = exports; var Core = require('NGCore/Client/Core').Core;
//var ZFTileManager = require('../Tiles/ZFTileManager').ZFTileManager;

exports.ZFGameTool = Core.Class.subclass(
{
	classname:'ZFGameTool',
	
	$kGameToolState:
	{
		kGameToolStateInactive: 0,
		kGameToolStateNothingSelected: 1,
		kGameToolStateSpriteSelected: 2,
		kGameToolStateSpriteDragging: 3,
		kGameToolStateMapScrolling: 4
	},

	
	initialize: function()
	{
//		ZFTileManager = require('../Tiles/ZFTileManager').ZFTileManager;
		this.reset();
	},

	reset: function()
	{
		this._toolSelectorRectMap = new Core.Rect(0, 0, 0, 0);
		this._toolColor = new Core.Color(0,1,0);
		this._toolTile = new Core.Point(-1,-1);
		this._originalTile = new Core.Point(-1,-1);
		this._tileSize = new Core.Size(1,1);
		this._toolSelectorRectMap = new Core.Rect(0, 0, 0, 0);
		
		if(this._sprite && this._sprite.getParent())
		{
			this._sprite.getParent().removeChild(this._sprite, true);
		}
		this._sprite = null;
		
		if(this._label && this._label.getParent())
		{	
			this._label.getParent().removeChild(this._label, true);
		}
		
		if (this._spriteNode && this._spriteNode.getParent()) 
		{
			this._spriteNode.getParent().removeChild(this._spriteNode, true);
		}
		this._spriteNode = null;
		
		this._label = null;
		this._key = "";
//HACK to test		
//		this._state = this.kGameToolState.kGameToolStateInactive;
		this._state = this.kGameToolState.kGameToolStateNothingSelected;		
		this._moved = false;
		this._amount = 0;
		this._spriteOrientation = 0;
		this._shouldRotate = false;
	},
	
	placeToolOnNearestTileToPointOnMap: function(pointOnMap)
	{
		var tim = ZFTileManager;
		
		var tileCoordinatesForTool = tim.tileFromMapPoint(pointOnMap, true);		
		
		tileCoordinatesForTool.setX((tileCoordinatesForTool._x < this._tileSize._width-1) ? this._tileSize._width-1 : tileCoordinatesForTool._x);
		tileCoordinatesForTool.setY((tileCoordinatesForTool._y < this._tileSize._height-1) ? this._tileSize._height-1 : tileCoordinatesForTool._y);

		this._toolSelectorRectMap = tim.selectorRectFromTile(tileCoordinatesForTool);
		this._toolSelectorRectMap.getOrigin().setX(this._toolSelectorRectMap.getOrigin()._x - ((this._tileSize._width-1) * this._toolSelectorRectMap.getSize()._width)/2);
		this._toolSelectorRectMap.getSize().setAll(this._toolSelectorRectMap.getSize()._width * this._tileSize._width, this._toolSelectorRectMap.getSize()._height * this._tileSize._height); 
		
		if(!CGPointEqualToPoint(this._toolTile,tileCoordinatesForTool))
		{
			this._moved = true;
			
			// quick fix
			var zOrder = tileCoordinatesForTool._x + tileCoordinatesForTool._y;
			if(this._sprite)
			{
				this._sprite.getParent().setDepth(zOrder);
			}
			if(this._spriteNode)
			{
				this._spriteNode.setDepth(zOrder);			
			}
			
		}
		
		this._toolTile = tileCoordinatesForTool;
		
		//check to see if we should color the selector red
		if(!(tim.canPlaceTileOfSize(this._tileSize , this._toolTile)))
		{
			this._onValidTile = false;
			this._toolColor = ccc3(0xFF,0x00,0x00);
		}
		else
		{
			this._onValidTile = true;
			this._toolColor = ccc3(0x00,0xFF,0x00);
		}
	}
	

});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GameObjects/ZFConsumable'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GameObjects/ZFConsumable'] || {}; $MODULE_REGISTRY['Code/Game/GameObjects/ZFConsumable'] = exports; exports.ZFConsumable = Core.Class.subclass(
{
	classname:'ZFConsumable',
	
	initialize: function()
	{
		this._name = null; //NSString*
		this._count = 0; //int 
	},
	
	$initWithName: function(aName, ct)
	{
		this._name = aName;
		this._count = ct;
		
		return this;
	}

});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GameObjects/ZFZombieCombiner'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GameObjects/ZFZombieCombiner'] || {}; $MODULE_REGISTRY['Code/Game/GameObjects/ZFZombieCombiner'] = exports; exports.ZFZombieCombiner = Core.Class.subclass
({
	classname:'ZFZombieCombiner',

	initialize: function()
	{
		this._zombie1 = null; //Actor
		this._zombie2 = null; //Actor
		this._rootTile = new Core.Point(0,0); //CGPoint 
		this._awaitingZombieArrival = false; //BOOL 
		this._state = this.zombieCombinerStates.kZombieCombinerStateEmpty; //int
		this._resultData = null; //ZFZombieCombinerResultData
	},
	
	zombieCombinerStates : 
	{
		kZombieCombinerStateEmpty : 0,
		kZombieCombinerStateCooking : 1,
		kZombieCombinerStateDone : 2,
		kZombieCombinerStateMAX : 3
	},
	
	initWithRootTile : function(tile)
	{
		this._rootTile = tile;
		var gs = GameState;
		for (var key in gs._zfGameData._zombieCombiners)
		{
			var rd = gs._zfGameData._zombieCombiners[key];
			if (rd._rootTile._x == tile._x && rd._rootTile._y == tile._y)
			{
				this._resultData = rd;
				this._state = this.isDone() ? this.zombieCombinerStates.kZombieCombinerStateDone : this.zombieCombinerStates.kZombieCombinerStateCooking;
				break;
			}
		}
		
		return this;
	},
	
	addInhabitant : function(actor)
	{
		if (this.isFull())
		{
			return;
		}
			
		if (!this._zombie1)
		{
			this._zombie1 = actor;
		}
		else if (!this._zombie2)
		{
			this._zombie2 = actor;
		}
	},
	
	evictAllInabitants : function()
	{
		this.stopCombineProcess();
		
		if (this._zombie1)
		{
			this._zombie1._brainState = kActorBrainStateLookingForHome;
			this._zombie1.startAnim(kActorAnimIdle, true);
			this._zombie1 = null;
		}
		
		if (this._zombie2)
		{
			this._zombie2._brainState = kActorBrainStateLookingForHome;
			this._zombie2.startAnim(kActorAnimIdle, true);
			this._zombie2 = null;
		}
	},
	
	isFull : function()
	{
		return (this._zombie1 && this._zombie2);
	},

	isDone : function()
	{
		var t1 = this.timeSpentCombining();
		var t2 = this.getCombineTime();
		return (t1 >= t2);
	},
	
	isAwaitingZombie : function()
	{
		return this._awaitingZombieArrival;
	},

	isCombining : function()
	{
		var t1 = this.timeSpentCombining();
		var t2 = this.getCombineTime();
		return (this._resultData && this._resultData._startTime && t1 > 0 && t1 < t2);
	},
	
	getCombineTime : function()
	{
		var gs = GameState;
		var hasCombineMonolith = gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_FASTER_COMBINE);
		return (hasCombineMonolith) ? ZFGameDefines.ZOMBIE_COMBINER_COOK_TIME * 0.25: ZFGameDefines.ZOMBIE_COMBINER_COOK_TIME;
	},
	
	timeSpentCombining : function()
	{
		return (this._resultData && this._resultData._startTime) ? (Core.Time.getRealTime()/1000 - this._resultData._startTime) : 0;
	},

	getActorName : function(actor)
	{
		return actor ? ZFMarketMenu.nameFromUnitKey(actor.classname) : null;
	},
	
	startCombineProcess : function()
	{
		var gui = ZFGuiLayer.gui();
		var am = ZFActorManager;
		if (!this.isFull())
		{
			gui.displayToolTip(NSLocalizedString("hmmm...", null), NSLocalizedString("The combiner is not full", "combiner is the name of the combining object tool"));
			return;
		}
		
		this.createResult();
		
		this.displayCombiningZombiesAsToolTip();
		am.despawnFarmActor(this._zombie1);
		am.despawnFarmActor(this._zombie2);
		
		this._state = this.zombieCombinerStates.kZombieCombinerStateCooking;
	},
	
	stopCombineProcess : function()
	{
		this.freeResultData();
		this._state = this.zombieCombinerStates.kZombieCombinerStateEmpty;
	},
	
	createResult : function()
	{
		var rand = Math.random();
		var actorClass = (rand > 0.5) ? this._zombie1.classname : this._zombie2.classname;
		
		var unitKey = actorClass;
		var unitKey1 = unitKey;
		var unitKey2 = unitKey1.substring(0, unitKey1.length-1);
		var unitKey3 = unitKey2 + '4';
		
		this.createResultDataIfNeeded();	
		
		this._resultData._rootTile = this._rootTile;
		this._resultData._color = this.blendZombieColor(this._zombie1._savedColor, this._zombie2._savedColor);
		this._resultData._flags = this.combineZombieMutationFlag(this._zombie1._flags, this._zombie2._flags);
		this._resultData._key = unitKey3;
		this._resultData._startTime = Core.Time.getRealTime()/1000;
	},
	
	createResultDataIfNeeded : function()
	{
		var gs = GameState;
		if (!this._resultData)
		{
			this._resultData = new ZFZombieCombinerResultData();
			gs._zfGameData._zombieCombiners.push(this._resultData);
		}
	},
	
	freeResultData : function()
	{
		var gs = GameState;
		if (this._resultData)
		{
			gs._zfGameData._zombieCombiners.splice(gs._zfGameData._zombieCombiners.indexOf(this._resultData), 1);
			this._resultData = null;
		}
	},
	
	spawnResult : function()
	{
		var gui = ZFGuiLayer.gui();
		var am = ZFActorManager;
		if (!this._resultData)
		{
			console.log("crap!");
		}

		var zActor = am.spawnFarmActor_onTile(this._resultData._key, this._rootTile);
		zActor._savedColor = ccc3(this._resultData._color._red * 255, this._resultData._color._green * 255, this._resultData._color._blue * 255);
		zActor.addMutation(this._resultData._flags);
		zActor.resetColor();
		zActor._eatDate = Core.Time.getRealTime()/ 1000 - ZFGameDefines.ZOMBIE_HUNGER_DURATION;
		
		var zmenu = ZFZombieMenu;
		zmenu._currentZombie = zActor;
		
		var text = ZFMarketMenu.nameFromUnitKey(zActor.classname);
		NSNotificationCenter.postNotificationName(ZFGameDefines.kCombinerHarvestedNotification, null, text);
		
		this.freeResultData();
		SimpleAudioEngine.playEffect(kHarvestZombieSFX);
		gui.updateArmySize();
		this._state = this.zombieCombinerStates.kZombieCombinerStateEmpty;
	},
	
	combineZombieMutationFlag : function(f1,f2)
	{
		var resultFlag = 0;
		
		resultFlag |= this.randMutation(resultFlag, f1, f2, kMutationHead);
		resultFlag |= this.randMutation(resultFlag, f1, f2, kMutationArms);
		resultFlag |= this.randMutation(resultFlag, f1, f2, kMutationHat);
		resultFlag |= this.randMutation(resultFlag, f1, f2, kMutationBody);
		resultFlag |= this.randMutation(resultFlag, f1, f2, kMutationCollar);
		
		return resultFlag;
	},
	
	randMutation : function(resultFlag, f1, f2, tf)
	{
		var gs = GameState;
		
		var hasMutantMonolith = gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_ALL_MUTATION);
		var rand = Math.random()	
		if (rand <= 0.33 && !hasMutantMonolith)
		{
			resultFlag |= 0;
		}
		else 
		{
			var flag1 = (f1 & tf);
			var flag2 = (f2 & tf);
			
			if(!flag1) flag1 = flag2;
			if(!flag2) flag2 = flag1; 
			
			if(hasMutantMonolith)
				resultFlag |= (rand <= 0.49) ? flag1 : flag2;
			else
				resultFlag |= (rand <= 0.66) ? flag1 : flag2;
			
		}
		return resultFlag;
	},
	
	blendZombieColor : function(c1, c2)
	{
		var rc = ccc3(255*(c1.getRed() + c2.getRed())/2, 255*(c1.getGreen() + c2.getGreen())/2, 255*(c1.getBlue() + c2.getBlue())/2);
		if (rc.getRed() >= rc.getGreen() && rc.getRed() >= rc.getBlue())
		{
			if (rc.getGreen() >= rc.getBlue())
			{
				rc = ccc3(0xFF, rc.getGreen() * 255, 0);
			}
			else
			{
				rc = ccc3(0xFF, 0, rc.getBlue() * 255);
			}
		}
		else if (rc.getGreen() >= rc.getRed() && rc.getGreen() >= rc.getBlue())
		{
			if (rc.getRed() >= rc.getBlue())
			{
				rc = ccc3(rc.getRed() * 255, 0xFF, 0);
			}
			else
			{
				rc = ccc3(0, 0xFF, rc.getBlue() * 255);
			}
		}
		else if (rc.getBlue() >= rc.getGreen() && rc.getBlue() >= rc.getRed())
		{
			if (rc.getRed() >= rc.getGreen())
			{
				rc = ccc3(rc.getRed() * 255, 0, 0xFF);
			}
			else
			{
				rc = ccc3(0, rc.getGreen() * 255, 0xFF);
			}
		}
		return rc;
	},
	
	displayCombiningZombiesAsToolTip : function()
	{
		var gui = ZFGuiLayer.gui();
		var message = "";
		var totalAge = Core.Time.getRealTime()/1000 - this._resultData._startTime;
		totalAge = (totalAge < 0) ? 0: totalAge;
		var combTime = this.getCombineTime();
		totalAge = (totalAge > combTime) ? combTime : totalAge;
		var totalGrowthTimeLeft = combTime - totalAge;
		var daysLeft = Math.floor((totalGrowthTimeLeft / 60 / 60 / 24));
		totalGrowthTimeLeft -= (daysLeft * 60 * 60 * 24);
		var hoursLeft = Math.floor((totalGrowthTimeLeft / 60 / 60 ));
		totalGrowthTimeLeft -= (hoursLeft * 60 * 60);
		var minutesLeft = Math.floor((totalGrowthTimeLeft / 60));
		totalGrowthTimeLeft -= (minutesLeft * 60);
		var secondsLeft = Math.floor(totalGrowthTimeLeft);
		
		if (daysLeft > 0)
		{
			message += sprintf(NSLocalizedString("%d day%@ ", null), daysLeft, daysLeft==1 ? "" : NSLocalizedString("s", "Plural s added at the end to make there be more than one of the object"));
			message += sprintf(NSLocalizedString("%d hr%@ left", null), hoursLeft, hoursLeft==1 ? "" : NSLocalizedString("s", "Plural s added at the end to make there be more than one of the object"));
		}
		else if (hoursLeft > 0)
		{
			message += sprintf(NSLocalizedString("%d hr%@ ", null), hoursLeft, hoursLeft==1 ? "" : NSLocalizedString("s", "Plural s added at the end to make there be more than one of the object"));
			message += sprintf(NSLocalizedString("%d min%@ left", null), minutesLeft, minutesLeft==1 ? "" : NSLocalizedString("s", "Plural s added at the end to make there be more than one of the object"));
		}
		else if (minutesLeft > 0)
		{
			message += sprintf(NSLocalizedString("%d min%@ ", null), minutesLeft, minutesLeft==1 ? "" : NSLocalizedString("s", "Plural s added at the end to make there be more than one of the object")); 
			message += sprintf(NSLocalizedString("%d sec%@ left", null), secondsLeft, secondsLeft==1 ? "" : NSLocalizedString("s", "Plural s added at the end to make there be more than one of the object"));
		}
		else if (secondsLeft > 0)
		{
			message += sprintf(NSLocalizedString("%d sec%@ left", null), secondsLeft, secondsLeft==1 ? "" : NSLocalizedString("s", "Plural s added at the end to make there be more than one of the object")); 
		}
		
		gui.displayToolTip(NSLocalizedString("Combining Zombies...", null), message);
	},
	
	zombieSelected : function(actor)
	{
		var gui = ZFGuiLayer.gui();
		var zactor = actor;
		
		if(zactor._brainState == kActorBrainStateAtHome)
		{
			var patch = ZFTileManager.getZombiePatchAtTile(zactor._farmData._myHomeTile);
			patch.evictInabitant(actor);
		}
		
		zactor.talk();
		gui.displayMessage(NSLocalizedString("Zombie Selected", null), zactor._farmData._currentTile, ZFColorDefines.colorTextHighlight, 0);
		zactor.startAnim(kActorAnimVictory, true);
		zactor._brainState = kActorBrainStateNone; //we gotta resstore this to a proper one
		zactor.setThought(ZombieActor.zombieThoughts.kZombieThoughtSmile);
		zactor.unscheduleUpdate();
	},
	
	startSelectionProcess : function()
	{	
		var gui = ZFGuiLayer.gui();
		var tom = ZFToolManager;
		var am = ZFActorManager;
		gui.displayToolTip(NSLocalizedString("Combine Zombies", null), NSLocalizedString("Tap on a zombie to select it...", null));
		gui.unschedule(gui.removeToolTipIn);
		gui.addToolTipButton(null, this, this.revertSelectionProcess.bind(this), CCSprite.spriteWithFile("smallX.png"), CCSprite.spriteWithFile("smallX.png"));
		this._awaitingZombieArrival = true;
		
		tom.toolSelected(ZFToolManager.kGameTool.kGameToolZombieCombiner);	
		
		for (var key in am._actorList)
		{ 
			var actor = am._actorList[key];
			actor._destinationPoint = actor._ccPosition;
			actor._farmData._destinationTile = actor._farmData._currentTile;
			actor.setState(kActorStateIdle);
		}
	},
	
	revertSelectionProcess : function()
	{
		var gui = ZFGuiLayer.gui();
		var tom = ZFToolManager;
		tom.toolSelected(ZFToolManager.kGameTool.kGameToolMulti);
		this._awaitingZombieArrival = false;
		gui.removeToolTip();
		this.evictAllInabitants();
	},
	
	combinePromptFinal : function()
	{
		var gui = ZFGuiLayer.gui();
		var combineTime = this.getCombineTime();
		combineTime = Math.floor((combineTime / 60));
		
		var addedString = null;
		
		if (combineTime < 60)
		{
			addedString = sprintf(NSLocalizedString("(Combining takes %i minutes)", null), combineTime);
		}
		else
		{
			addedString = sprintf(NSLocalizedString("(Combining takes %i hour)", null), Math.floor(combineTime / 60));
		}
											  
		var aw = gui.displayAlertSimpleChoice(
				NSLocalizedString("Combine Zombies", null), 
				sprintf(NSLocalizedString("Do you want to combine:\n\n%@\n with\n%@?\n\n%@", null), this.getActorName(this._zombie1), this.getActorName(this._zombie2), addedString),
				CCSprite.spriteWithFile("combineZombiesIcon.png"));
		aw._delegate = this;
		aw._idTag = 2;
	},
	
	combinerTapped : function() 
	{
		var gui = ZFGuiLayer.gui();
		var gs = GameState;
		if (this.isDone())
		{
			if (gs.curArmySize() >= gs.maxArmySize())
			{
				gui.displayAlertSimple(
						NSLocalizedString("Max Army Size", null),
						sprintf(NSLocalizedString("You have no space for this zombie in yer army.\n\nHarvest this zombie when ya got less than %i zombies", null), gs.maxArmySize()),
						CCSprite.spriteWithFile("combineZombiesIcon.png"));
			}
			else
			{
				this.spawnResult();
			}
			return;
		}
		
		if (this.isCombining())
		{
			this.displayCombiningZombiesAsToolTip();
			return;
		}
		
		if (!this.isFull())
		{
			var aw = gui.displayAlertSimpleChoice(
					NSLocalizedString("Combine Zombies", null),
					NSLocalizedString("Would ya like to combine two o' yer Zombies?\n\nYou will be prompted to select two zombies after tapping on the accept button.", null),
					CCSprite.spriteWithFile("combineZombiesIcon.png"));
			aw._delegate = this;
			aw._idTag = 0;
		}
	},
	
	zombieTapped : function(actor)
	{
		var gui = ZFGuiLayer.gui();
		
		if (!this._awaitingZombieArrival || actor == this._zombie1 || actor == this._zombie2 || this.isFull())
		{
			return;
		}
		
		if(actor instanceof ZombieActorGardenCupid)
		{
			var message = NSLocalizedString("You can't combine a Cupid Zombie!","you can't combine a cupid zombie message");
			gui.displayAlertSimple(
					NSLocalizedString("Can't Combine!","you can't combine a cupid zombie window title"),
					message,
					CCSprite.spriteWithFile("stex0051.png"));
			
			return;
		}
		
		if(actor instanceof ZombieActorRegularCrazy)
		{
			var message = NSLocalizedString("You can't combine a Crazy Zombie!","you can't combine a cupid zombie message");
			gui.displayAlertSimple(
					NSLocalizedString("Can't Combine!","you can't combine a crazy zombie window title"),
					message,
					CCSprite.spriteWithFile("stex1002.png"));
			
			return;
		}
		
		this.addInhabitant(actor)
		this.zombieSelected(actor);
		
		if (!this.isFull())
		{
			gui.displayToolTip(NSLocalizedString("Combine Zombies", null), NSLocalizedString("Tap on another zombie to select it...", null));
			gui.unschedule(gui.removeToolTipIn);
			gui.addToolTipButton(
					null,
					this,
					this.revertSelectionProcess.bind(this),
					CCSprite.spriteWithFile("smallX.png"),
					CCSprite.spriteWithFile("smallX.png"));
			this._awaitingZombieArrival = true;
		}
		else
		{
			setTimeout(this.combinePromptFinal.bind(this), 1);				
		}
	},
	
	update : function()
	{
		var tim = ZFTileManager;
		var tSprite = TSprite.findByCoordinates(this._rootTile);
		var saveTile = tSprite._tile;
		
		if (this._state == this.zombieCombinerStates.kZombieCombinerStateEmpty)
		{
			if (this.isCombining())
			{
				this.state = this.zombieCombinerStates.kZombieCombinerStateCooking;
			}
			else if (this.isDone())
			{
				this._state = this.zombieCombinerStates.kZombieCombinerStateDone;
			}
			else if (!(saveTile._key == ZFGameDefines.kZombieCombinerKey1))
			{
				tim.replaceTile_withGIDkey_considerNeighbouringTiles(this._rootTile, ZFGameDefines.kZombieCombinerKey1, false);
			}
		}
		else if (this._state == this.zombieCombinerStates.kZombieCombinerStateCooking)
		{
			if (this.isDone())
			{
				this._state = this.zombieCombinerStates.kZombieCombinerStateDone;
			}
			else
			{
				if (!(saveTile._key == ZFGameDefines.kZombieCombinerKey2))
				{
					tim.replaceTile_withGIDkey_considerNeighbouringTiles(this._rootTile, ZFGameDefines.kZombieCombinerKey2, false);
				}
			}
		}
		else if (this._state == this.zombieCombinerStates.kZombieCombinerStateDone)
		{
			if (!(saveTile._key == ZFGameDefines.kZombieCombinerKey3))
			{
				tim.replaceTile(this._rootTile, ZFGameDefines.kZombieCombinerKey3, false);
			}
		}
	},
	
	//NOTE: buttonTag is never used
	alertWindow_dismissedPositive : function(aw, selectedYes, buttonTag)
	{
		if (selectedYes)
		{
			var gui = ZFGuiLayer.gui();
			var tom = ZFToolManager;
			var gs = GameState;
			
			if (aw._idTag == 0)
			{
				if (gs.curArmySize() < 2)
				{
					gui.displayAlertSimple(
							NSLocalizedString("Army Size", null),
							NSLocalizedString("You need at least two zombies in your army to be able to combine zombies.", null),
							CCSprite.spriteWithFile("combineZombiesIcon.png"));
					this.revertSelectionProcess();
				}
				else
				{
					this.startSelectionProcess();
				}
			}
			else if (aw._idTag == 1)
			{
			}
			else if (aw._idTag == 2)
			{
				tom.toolSelected(ZFToolManager.kGameTool.kGameToolMulti);
				this._awaitingZombieArrival = false;
				gui.removeToolTip();		
				this.startCombineProcess();
				
				/*
				var eventDictionary = {};
				eventDictionary["Zombie1"] = this.getActorName(this._zombie1);
				eventDictionary["Zombie2"] = this.getActorName(this._zombie2);
				
				//TODO: FlurryAPI
                [FlurryAPI logEvent:kFlurryEvent_zombieCombiner withParameters:eventDictionary];
				*/
				
				this._zombie1 = null;
				this._zombie2 = null;
			}
		}
		else
		{
			if (aw._idTag == 2)
			{
				this.revertSelectionProcess();
			}
		}
		
		if (aw._userData)
		{
			var actor = aw._userData;
			actor = null;
		}
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GameObjects/ZFZombieCombinerResultData'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GameObjects/ZFZombieCombinerResultData'] || {}; $MODULE_REGISTRY['Code/Game/GameObjects/ZFZombieCombinerResultData'] = exports; exports.ZFZombieCombinerResultData = Core.Class.subclass
({
	classname : 'ZFZombieCombinerResultData',
	
	initialize : function() 
	{
		this._startTime = 0; //NSDate
		this._color = ccc3(0,0,0); //ccColor3B
		this._key = null; //NSString
		this._flags = 0; //int
		this._rootTile = new Core.Point(0,0);
	},
	
	encodeWithCoder : function(coder)
	{
		//TODO
//		[coder encodeInt:rootTile.x forKey:@"tileX"];
//		[coder encodeInt:rootTile.y forKey:@"tileY"];
//		[coder encodeObject:startTime forKey:@"startTime"];
//		[coder encodeInt:flags forKey:@"flags"];
//		[coder encodeObject:key forKey:@"key"];
//		[coder encodeInt:(int)color.r forKey:@"colorR"];
//		[coder encodeInt:(int)color.g forKey:@"colorG"];
//		[coder encodeInt:(int)color.b forKey:@"colorB"];
	},

	initWithCoder : function(coder) 
	{
		this._rootTile._x = coder._tileX;
		this._rootTile._y = coder._tileY;
		this._startTime = coder._startTime;
		this._flags = coder._flags;
		this._key = coder._key;
		this._color = ccc3(coder._colorR, coder._colorG, coder._colorB);
		
		return this;
	}
}); return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GameObjects/ZFZombiePatch'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GameObjects/ZFZombiePatch'] || {}; $MODULE_REGISTRY['Code/Game/GameObjects/ZFZombiePatch'] = exports; exports.ZFZombiePatch = Core.Class.subclass(
{
	classname:'ZFZombiePatch',
	
	initialize: function()
	{
		this._maxCapacity = 16; //int
		this._population = 0; //int 
		this._rootTile = new Core.Point(0,0); // CGPoint
		this._actorList = []; //NSMutableArray *
		this._on = GameState._zfGameData._zombiePatchOn; //BOOL
		
		return this;
	},
	
	isOn : function()
	{
		return this._on;
	},
	
	on : function()
	{
		GameState._zfGameData._zombiePatchOn = true;
		this._on = true;
		
		var am = ZFActorManager;
		am.animAllZombies(true);
	},
	
	off : function()
	{
		GameState._zfGameData._zombiePatchOn = false;
		this._on = false;
		this.evictAllInabitants();
	},
	
	evictAllInabitants : function()
	{
		var tempActorList = [].concat(this._actorList);
		
		for(var actorKey in tempActorList)
		{
			var actor = tempActorList[actorKey];
			actor._willSleep = false;
			//Set true when the zombie arrives to his place to sleep (in farmupdate of zombieactor)
			this.evictInabitant(actor);
		}
		am = ZFActorManager;
		am.animAllZombies(true);
	},
	
	evictInabitant : function(actor)
	{
		actor._farmData._myHomeTile = ccp(-1,-1);
		actor._brainState = kActorBrainStateLookingForHome;
		actor.setState(kActorStateIdle);
		this._population--;
	    
		//TODO: PlayerProfileManager
//	    PlayerProfileManager.log("Removing a zombie from the Zombie Patch's actorList");
		this._actorList.splice(this._actorList.indexOf(actor)); 
		
		actor.schedule(actor.farmWander, Math.random() * 3, "farmWander");
	    
		var pop = 0;
		for(var key in this._actorList)
		{
			var actor = this._actorList[key];
			actor._farmData._destinationTile = ccp(this._rootTile._x - Math.floor(pop/4), this._rootTile._y - pop%4);
			actor.moveToTile(actor._farmData._destinationTile);
			pop++;
		}
	},
	
	isActorAnInabitant : function(actor)
	{
		for(var key in this._actorList)
		{
			var zActor = this._actorList[key];
			if (zActor == actor)
			{
				return true;
			}
		}
		return false;
	},
	
	loadInhabitant : function(actor)
	{
		if(this.isFull())
		{
			return false;
		}
		this._actorList.push(actor);
		this._population++;
		
		return true;
	},
	
	addInhabitant : function(actor)
	{
		if(this.isFull())
		{
			return false;
		}		
		actor._brainState = kActorBrainStateAtHome;
		actor._farmData._myHomeTile = this._rootTile;
		actor._farmData._destinationTile = ccp(this._rootTile._x - Math.floor(this._population/4), this._rootTile._y - this._population%4);
		actor._willSleep = true;
		actor.moveToTile(actor._farmData._destinationTile);
		this._actorList.push(actor);
		this._population++;
		console.log("ZFZombiePatch.addInhabitant, population: "+ this._population);
		
		return true;
	},
	
	isFull : function()
	{
		return (this._population >= this._maxCapacity);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Player/PlayerActor'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Player/PlayerActor'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Player/PlayerActor'] = exports; exports.PlayerActor = Actor.subclass(
{
	classname: 'PlayerActor',
	
	initialize: function()
	{
//		this.initActorSpecificData();
	},
	
	destroy: function()
    {
        this._playerLight = null;
    },
	
	initActorSpecificData: function( $super )
	{
		$super();
		
		this._spriteFileName = "playerSpriteSheet.png";
		this._brainState = kActorBrainStateNone;
		this._walkingSpeed = 4.0;
		this._animSpeed = 1.0 / this._walkingSpeed;
		this._type = kActorTypePlayer;
	},

	moveToTile: function( $super ,  tileCoordinates ) // CGPoint
	{
		if( this._currentPlayerAction )
		{
			return false; // dont go places if we have an action to perform
		}
		
		return $super( tileCoordinates );
	},
	
	update: function( dt ) // ccTime
	{
		this.movementUpdate( dt );

		if( 		ZFToolManager.toolManager()._gameActionQueue.length  > 0 
				&& 	!this._currentPlayerAction )
		{
			var i = ZFToolManager.toolManager()._gameActionQueue.length - 1;
			var action = ZFToolManager.toolManager()._gameActionQueue[ i ];
			this.moveToTile( action._tile );
			this._currentPlayerAction = action;
			return;
		}
		else if( 		this._currentPlayerAction 
					&& 	ccpEqual( this.getPosition() , this._destinationPoint )
					&&  this._state == kActorStateIdle )
		{
			//we've arrived
			
			//do we have the resources to perform this action?
			if( ZFToolManager.toolManager().hasResourceForAction( this._currentPlayerAction ) )
			{
				//execute, and paid for
				this.setState( kActorStateWorking );
				this.schedule( this.tickProgress , 0.05, "tickProgress");
				this._currentPlayerAction._soundID = SimpleAudioEngine.playEffect(kPlowingSFX);
			}
			else
			{
				//deny
				this.playerPopActionAndExecute( false ,  dt );
			}
		}
		
		if (this._currentPlayerAction
			&& !this.isScheduled( this.tickProgress )
			&& ccpEqual( this.getPosition() , this._destinationPoint ) 
			&& this._state == kActorStateWorking )
		{
			this.startAnimForState( kActorStateWorking );
			this.schedule( this.tickProgress , 0.05, "tickProgress");
			SimpleAudioEngine.stopEffect(this._currentPlayerAction._soundID);
			this._currentPlayerAction._soundID = SimpleAudioEngine.playEffect(kPlowingSFX);
		}
	},

	tickProgress: function( dt ) // ccTime
	{	
		var fpsComp = (dt / 0.05);
		var hasPlowMonolith = GameState._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_NO_PLOWCOST);
		var newScale = this._playerProgressBar._bar.getScale();
		newScale._x += 0.01 * fpsComp * GameState._zfGameData._playerActionSpeed;
		this._playerProgressBar._bar.setScale(newScale);
		
		if (newScale._x >= 1.0) {
			if(this._currentPlayerAction){
				SimpleAudioEngine.stopEffect(this._currentPlayerAction._soundID);
			}
			
			this.playerPopActionAndExecute(true,dt);
			this._playerProgressBar._bar.setScale( hasPlowMonolith ? 0 : 1,newScale._y);
			this.setState(kActorStateIdle);
			this._currentPlayerAction = null;
			this._playerProgressBar._actionString = "";
			this.unschedule(this.tickProgress);
		}
	},

	playerPopActionAndExecute: function( execute , dt ) // ccTime
	{
		this._playerProgressBar._bar.setScale((execute) ? 1.0 : 0.0, this._playerProgressBar._bar.getScale()._y);
		this.setState( kActorStateIdle );
		this._currentPlayerAction = null;
		ZFToolManager.toolManager().popGameActionAndExecute( execute , dt );
	},

	startAnimForState: function( value ) // int.
	{	
		var attachmentArm1 		= this._attachments[ kActorPartTagArmF ];
		var attachmentArm2 		= this._attachments[ kActorPartTagArmB ];
		var attachmentFoot1 	= this._attachments[ kActorPartTagFootF ];
		var attachmentFoot2 	= this._attachments[ kActorPartTagFootB ];
		var attachmentBody 		= this._attachments[ kActorPartTagBody ];
		var attachmentHead 		= this._attachments[ kActorPartTagHead ];
		var attachmentTool 		= this._attachments[ kActorPartTagArmBm ];
		
		attachmentArm2._sprite.stopAllActions();
		attachmentArm1._sprite.stopAllActions();
		attachmentFoot2._sprite.stopAllActions();
		attachmentFoot1._sprite.stopAllActions();
		attachmentBody._sprite.stopAllActions();
		attachmentHead._sprite.stopAllActions();
		attachmentTool._sprite.stopAllActions();
		
		attachmentArm1.stopAllActions();
		attachmentArm2.stopAllActions();
		attachmentFoot1.stopAllActions();
		attachmentFoot2.stopAllActions();
		attachmentBody.stopAllActions();
		attachmentHead.stopAllActions();
		attachmentTool.stopAllActions();
		
		var modifier = this._attachments[0]._sprite.getFlipX() ? -1 : 1; // float
		var f = modifier;
		var s = this._animSpeed;
		
		attachmentTool._sprite.setVisible( false );
			
		switch(value)
		{
			case kActorStateDormant:
			{
			
			}
			break;
				
			//case kActorStateWorking:
			case kActorStateIdle:
			{	
//				if( this._lightsOn )
//				{
//					var acm = ZFActorManager;
//					attachmentTool = this.replaceAttachmentFromPlist_withSpriteDetails( 
//							kActorPartTagArmBm , acm.farmerSprites( "lantern" ) );
//					
//					attachmentTool._sprite.setVisible( true );
//				}
//				else 
//				{
					attachmentTool._sprite.setVisible( false );
//				}
				
				attachmentArm2._sprite.runAction( CCRotateTo.actionWithDuration( s * 1 , modifier * 0 ) );
				attachmentFoot1._sprite.runAction( CCRotateTo.actionWithDuration( s * 1 , modifier * 0 ) );
				attachmentFoot2._sprite.runAction( CCRotateTo.actionWithDuration( s * 1 , modifier * 0 ) );
				
				//arms
				attachmentArm1._sprite.runAction( CCRotateTo.actionWithDuration( s * 1 , modifier * 0 ) );
				attachmentArm2._sprite.runAction( CCRotateTo.actionWithDuration( s * 1 , modifier * 0 ) );
				
				attachmentArm1.runAction( CCMoveByWithoutChangingPosition.actionWithDuration( s * 1 , ccp( 0 , 0 ) ) );
				attachmentArm2.runAction( CCMoveByWithoutChangingPosition.actionWithDuration( s * 1 , ccp( 0 , 0 ) ) );
				
				//feet
				attachmentFoot1.runAction( CCMoveByWithoutChangingPosition.actionWithDuration( s * 1 , ccp( 0 , 0 ) ) );
				attachmentFoot2.runAction( CCMoveByWithoutChangingPosition.actionWithDuration( s * 1 , ccp( 0 , 0 ) ) );
				
				//body
				attachmentBody.runAction( CCMoveByWithoutChangingPosition.actionWithDuration( s * 1 , ccp( 0 , 0 ) ) );
				
				//head
				var actionHeadRotate = CCRepeatForever.actionWithAction( CCSequence.actions( new Array (
											CCRotateTo.actionWithDuration( s * 3 , modifier * 1.0 ),
											CCRotateTo.actionWithDuration( s * 3 , modifier * 2.0 ) ) ) );
				
				attachmentHead._sprite.runAction( actionHeadRotate );
				attachmentHead.runAction( CCMoveByWithoutChangingPosition.actionWithDuration( s * 1 , ccp( 0 , 0 ) ) );
			}
			break;
				
			case kActorStateWalking:
			{	
//				if( this._lightsOn )
//				{
//					var acm = ZFActorManager;
//					
//					attachmentTool = this.replaceAttachmentFromPlist_withSpriteDetails( 
//							kActorPartTagArmBm , acm.farmerSprites( "lantern" ) );
//					attachmentTool._sprite.setVisible( true );
//				}
//				else 
//				{
					attachmentTool._sprite.setVisible( false );
//				}
				
				attachmentArm1.loopS( ZFAnims.armWalkFrontRotatePlayer( s , f ) );
				attachmentArm2.loop( ZFAnims.armWalkBackRotatePlayer( s , f ) );
				attachmentFoot1.loop( ZFAnims.footWalkFrontMovePlayer( s ) );
				attachmentFoot2.loop( ZFAnims.footWalkBackMovePlayer( s ) );
				attachmentFoot1.loopS( ZFAnims.footWalkFrontRotatePlayer( s , f ) );
				attachmentBody.loop( ZFAnims.bodyWalkMove( s ) );
				attachmentHead.loopS( ZFAnims.headWalkRotate( s , f ) );
			}
			break;
				
			case kActorStateWorking:
			//case kActorStateIdle:
			{
//				var acm = ZFActorManager;
//				attachmentTool = this.replaceAttachmentFromPlist_withSpriteDetails(
//						kActorPartTagArmBm , acm.farmerSprites( "hoe" ) );
				
				attachmentTool._sprite.setVisible( true );
				attachmentFoot1._sprite.runAction( CCRotateTo.actionWithDuration( s * 1 , modifier * 0 ) );
				attachmentFoot2._sprite.runAction( CCRotateTo.actionWithDuration( s * 1 , modifier * 0 ) );
				attachmentArm1.loopS( ZFAnims.armWorkFrontRotatePlayer( s , 1 ) );
				attachmentArm2.loopS( ZFAnims.armWorkBackRotatePlayer( s , 1 ) );
				attachmentArm1.loop( ZFAnims.armWorkFrontMovePlayer( s ) );
				attachmentArm2.loop( ZFAnims.bodyWorkMovePlayer( s ) );
				attachmentBody.loop( ZFAnims.bodyWorkMovePlayer( s ) );
				attachmentHead.loop( ZFAnims.bodyWorkMovePlayer( s ) );
				attachmentHead.onceS( ZFAnims.headWorkPlayer( s , 1 ) );
				
			}
			break;
		}
	},

	
	initSpriteDictionary: function( $super )
	{
		$super();
	},

	initSprite: function( $super )
	{
		var gs = GameState;
		var acm = ZFActorManager;
		
		$super();
		
		if( this._lightsOn )
		{
			this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagArmBm , acm.farmerSprites( "lantern" ) );
		}
		else 
		{
			this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagArmBm , acm.farmerSprites( "hoe" ) );
			var attachmentTool = this._attachments[ kActorPartTagArmBm ];
			
			if(attachmentTool._sprite.getVisible())
			{
				attachmentTool._sprite.setVisible(false);
			}
		}

		this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagFootF , acm.farmerSprites( "bootFront" ) );
		this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagFootB , acm.farmerSprites( "bootBack" ) );
		
		switch( gs._zfGameData._bodyID )
		{
			case 0:	
				this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagArmF , acm.farmerSprites( "whiteArmFrontMale" ) ); 
				this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagArmB , acm.farmerSprites( "whiteArmBackMale" ) ); 
				this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagBody , acm.farmerSprites( "whiteBodyMale" ) ); 
				break;
					
			case 1: 
				this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagArmF , acm.farmerSprites( "whiteArmFrontFemale" ) );
				this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagArmB , acm.farmerSprites( "whiteArmBackFemale" ) );
				this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagBody , acm.farmerSprites( "whiteBodyFemale" ) ); 
				break;
					
			case 2:	
				this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagArmF , acm.farmerSprites( "blackArmFrontMale" ) ); 
				this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagArmB , acm.farmerSprites( "blackArmBackMale" ) ); ;
				this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagBody , acm.farmerSprites( "blackBodyMale" ) ); 
				break;
					
			case 3: 
				this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagArmF , acm.farmerSprites( "blackArmFrontFemale" ) );
				this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagArmB , acm.farmerSprites( "blackArmBackFemale" ) ); 
				this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagBody , acm.farmerSprites( "blackBodyFemale" ) ); 
				break;
		}
		
		switch( gs._zfGameData._headID )
		{
			case 0: this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagHead , acm.farmerSprites( "asianHeadMale" ) ); break;
			case 1: this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagHead , acm.farmerSprites( "whiteHeadMale" ) ); break;
			case 2: this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagHead , acm.farmerSprites( "skeletonHeadMale" ) ); break;
			case 3: this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagHead , acm.farmerSprites( "vampireHeadMale" ) ); break;
			case 4: this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagHead , acm.farmerSprites( "asianHeadFemale" ) ); break;
			case 5: this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagHead , acm.farmerSprites( "whiteHeadFemale" ) ); break;
			case 6: this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagHead , acm.farmerSprites( "skeletonHeadFemale" ) ); break;
			case 7: this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagHead , acm.farmerSprites( "vampireHeadFemale" ) ); break;
			case 8: this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagHead , acm.farmerSprites( "zombieHeadMale" ) ); break;
			case 9: this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagHead , acm.farmerSprites( "zombieHeadFemale" ) ); break;
			case 10: this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagHead , acm.farmerSprites( "blackHeadMale" ) ); break;
			case 11: this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagHead , acm.farmerSprites( "blackHeadFemale" ) ); break;
			case 12: this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagHead , acm.farmerSprites( "paperBagHeadMale" ) ); break;
			case 13: this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagHead , acm.farmerSprites( "monolithHeadMale" ) ); break;
			case 14: this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagHead , acm.farmerSprites( "pumpkinHeadMale" ) ); break;
		}
		
		var foot1 = this._attachments[ kActorPartTagFootF ];
		var foot2 = this._attachments[ kActorPartTagFootB ];
		var arm2 = this._attachments[ kActorPartTagArmB ];
		
		foot1._sprite.setScale(1.15, 1.15);
		foot2._sprite.setScale(1.07, 1.07);
		arm2._sprite.setScale(1.10, 1.10);
		
		foot1.setScale( foot1._sprite.getScale() );
		foot2.setScale( foot2._sprite.getScale() );
		arm2.setScale( arm2._sprite.getScale() );
		
		// TODO : Notification center.
//		[[NSNotificationCenter defaultCenter] addObserver:self 
//												 selector:@selector(dayCycleStateChange:) 
//													 name:kDayCycleStateChangeNotification 
//												   object:nil];
	},

    reloadPlayerSprite : function()
    {
        var toRemove = [];
        
        //untrack the tSprite before it disappears
        var sprites = TSprite.allMySprites();
        for (var key in sprites)
        {
            var tSprite = sprites[key];
            if (tSprite._actor && tSprite._actor == this)
            {
                toRemove.push(tSprite);
            }
        }
        
        for (var key in toRemove)
        {
            TSprite.untrack(toRemove[key]);
        }
        
        for (var i = 0; i < kActorPartTagMax; i++)
        {
            var a = this._attachments[i];
            if (!a)
            {
                continue;
            }
            
            this._attachments[i] = null;
            this._spriteMan.removeChild(a._sprite, true);
            this.removeChild(a, true);
            a = null;
        }
        
        this.initSprite();
        
        // This actor must be able to be touched, set this up now.
        var a = this._attachments[kActorPartTagHead];
        
        var tSprite = new TSprite();
        tSprite.initWithAtlasSprite( a._sprite );
        TSprite.track(tSprite);
        tSprite._actor = this;
    },
	
	movementUpdate: function( dt )
	{
//		console.log( "PlayerActor Pos:" + this.getPosition()._x + "," + this.getPosition()._y );
//		console.log( "PlayerActor SpriteMan Pos:" + this._spriteMan.getPosition()._x + "," + this._spriteMan.getPosition()._y );
//		console.log( "PlayerActor Tile Pos:" + this._farmData._currentTile._x + "," + this._farmData._currentTile._y );
		
		// TODO Restore this when menu is done.
//		var menuOpen = false;
//		
//		if (		this._farmData != null
//				&&  this.classname == "ZombieActor"
//				&&	menuOpen
//				// TODO : to be done where the market menu.
//				// &&	ZFMarketMenu.theMarket]._menuState != menuStateClosed
//				)
//		{
//			return; //no updates when market is open for zombies on farm
//		}
		
		var fpsComp = dt * 60;
		this._lastFramePosition = this.getPosition().clone();
		
		if ( 		this.getPosition()._x	!= this._destinationPoint._x 
				|| 	this.getPosition()._y	!= this._destinationPoint._y )
		{
			var lastTile = this._farmData ? this._farmData._currentTile.clone() : new Core.Point( 0 , 0 );
			var distanceLeftDelta = ccpSub( this._destinationPoint, this.getPosition() );
			var newPositionDelta = ccpMult( ccpNormalize( distanceLeftDelta ) , this._walkingSpeed * fpsComp );
			
			if ( ccpLength( newPositionDelta ) >= ccpLength( distanceLeftDelta ) )
			{
				this.setPosition( this._destinationPoint.clone() );
				
				if ( this._farmData )
				{
					this._farmData._currentTile = this._farmData._destinationTile.clone();
					this.setState( kActorStateIdle );
				}
			}
			else
			{
				this.setPosition( ccpAdd( this.getPosition() , newPositionDelta ) );
				
				if ( this._farmData )
				{
					// TODO : Restore the considerOffMap
					//this._farmData._currentTile = ZFTileManager.tileFromMapPoint_considerOffMap( this._position , false );
					this._farmData._currentTile = ZFTileManager.tileFromMapPoint( this.getPosition() );
					this.setState( kActorStateWalking );
				}
			}
			
			//console.log( "PlayerActor Position:" + this.getPosition()._x + "," + this.getPosition()._y 
			//				+ "  atTile:" + this._farmData._currentTile._x + "," + this._farmData._currentTile._y );
			
			// if actor is in a NEW tile //
			// TODO : Restore code.
			if( this._farmData 
					&& ( 		this._farmData._currentTile._x != lastTile._x 
							|| 	this._farmData._currentTile._y != lastTile._y ) )
			{
//				var gs = GameState;
//				var currentTile  = gs._zfGameData.saveTileAt_forMapWithSize( this._farmData._currentTile , sizeMake( gs._zfGameData._mapSize, gs._zfGameData._mapSize) );
//				var previousTile = gs._zfGameData.saveTileAt_forMapWithSize( this._lastTile , sizeMake( gs._zfGameData._mapSize, gs._zfGameData._mapSize ) );
//				
//				if( this._currentTile != this._previousTile ) // if it's 2 different tile locations
//				{
//					// have an isEntering function for tile later on
//					var ctile = (!ccpEquals( this._currentTile._ownerTile, 	ccp( -1 , -1 ) ) ) ?
//							gs._zfGameData.saveTileAt_forMapWithSize( currentTile._ownerTile , sizeMake( gs._zfGameData._mapSize, gs._zfGameData._mapSize) ) : this._currentTile;
//							
//					var ptile = (!ccpEquals( this._previousTile._ownerTile, ccp( -1 , -1 ) ) )	? 
//							gs._zfGameData.saveTileAt_forMapWithSize( previousTile._ownerTile , sizeMake( gs._zfGameData._mapSize, gs._zfGameData._mapSize) ) : this._previousTile;
// 
//					// TODO : Tile test might fail.
//					if( ctile != ptile ) 
//					{
//						if( ctile._isGate ) // if it's not the same tSprite object coordinates
//						{
//							// open gate 
//							var tsprite = TSprite.findByCoordinates( ctile._rootTile );
//							var spriteColor = tsprite._sprite._color;
//							var tileColor	   = tsprite._tile._color;
//							
//							if ( ctile._key == "fenceGate_01_closed" ) 
//							{
//								ZFTileManager.replaceTile_withGIDkey_considerNeighbouringTiles_withOrientation(
//										ctile._rootTile, "fenceGate_01_open" , false , ctile._orientation );
//							
//							}
//							else if ( ctile._key == "ironGate_01_closed" ) 
//							{
//								ZFTileManager.replaceTile_withGIDkey_considerNeighbouringTiles_withOrientation(
//										ctile._rootTile, "ironGate_01_open" , false , ctile._orientation );
//							}
//							
//							tsprite = TSprite.findByCoordinates( ctile._rootTile );
//							tsprite._sprite._color 		= spriteColor;
//							tsprite._tile._color	 	= tileColor;
//						}
//						
//						if( ptile.isGate )
//						{					
//							var tsprite = TSprite.findByCoordinates( ptile._rootTile );
//							var spriteColor 	= tsprite._sprite._color;
//							var tileColor	   	= tsprite._tile._color;
//							
//							if ( ptile._key == "fenceGate_01_open" ) 
//							{
//								ZFTileManager.replaceTile_withGIDkey_considerNeighbouringTiles_withOrientation(
//										ptile._rootTile , "fenceGate_01_closed" , false , ptile._orientation );
//							}
//							else if ( ptile._key == "ironGate_01_open" ) 
//							{
//								ZFTileManager.replaceTile_withGIDkey_considerNeighbouringTiles_withOrientation(
//										ptile._rootTile , "ironGate_01_closed" , false , ptile._orientation );
//							}
//							
//							tsprite = TSprite.findByCoordinates( ptile._rootTile );
//							tsprite._sprite._color 		= spriteColor;
//							tsprite._tile._color	 	= tileColor;
//						}
//					}
//				}
//				
				var x = this._farmData._currentTile._x;
				var y = this._farmData._currentTile._y;
				
				var newZ = y + x + 1;
				//this._spriteMan._parent.reorderChild_withZ( this._spriteMan , newZ );
				this._spriteMan.setDepth( newZ );
			}
		}
		
		//set the new position for the attachments
		for ( var key in this._attachments )
		{
			var a = this._attachments[ key ];
			
			if( a == null )
			{
				continue;
			}
			
			a._updated = false;
			
			if ( key == kActorPartTagHead )
			{
				this.updateAttachment( this._attachments[ kActorPartTagHead] );
			}
		}
		
		
		for ( var key in this._attachments )
		{
			this.updateAttachment( this._attachments[ key ] );
		}
	},

	updateAttachment: function( $super , a ) // ActorAttachment*
	{
		if( a == null )
		{
			return;
		}
		
		$super( a );
		
		
		if( a._parentAttachment == null )
		{
			if ( a._tag == kActorPartTagArmBm )
			{
				// oh lord...
				// why is getting a the position of an object so non trivial?
				// this is here to set the lights position of the latern
				
				var light = this._playerLight;
				if (light) {
					var flayer = CCDirector._runningScene.getChildByTag( ZFFarmGameScene.kTag.kTagFarm );
					light.setPosition( ccpAdd( a._sprite.getPosition() , flayer._map.getPosition() ) );
				}
			}
		}
	},

	dayCycleStateChange: function ( notification ) // NSNotification*
	{
		// TODO : handle cycle test.
		//DayCycle *cycle = (DayCycle*)notification.object;
		//this. lightsOn = ( cycle.currentState == kDayStateDusk || cycle.currentState == kDayStateNight)?YES:NO;
		
		this.setState( kActorStateDormant );
		this.setState( kActorStateIdle );
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActor'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActor'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActor'] = exports; var ZOMBIEBASESPEED = 0.75;
var ZOMBIE_TALK_CHANCE = 0.03;
var ZOMBIE_THINK_CHANCE = 0.10;
var ZOMBIE_THINK_INTERVALS = 10.0;
var ZOMBIE_THINK_DISPLAYTIME = 10.0;

var fm = null;

exports.ZombieActor = Actor.subclass({
	classname : 'ZombieActor',

	$zombieThoughts : {
		kZombieThoughtNothing : -1,
		kZombieThoughtBrains : 0,
		kZombieThoughtHmm : 1,
		kZombieThoughtHeart : 2,
		kZombieThoughtRainbow : 3,
		kZombieThoughtCupCake : 4,
		kZombieThoughtButterfly : 5,
		kZombieThoughtSunshine : 6,
		kZombieThoughtLollipop : 7,
		kZombieThoughtSmile : 8,
		kZombieThoughtFlower : 9,
		kZombieThoughtMusic : 10,

		kZombieThoughtMax : 11
	},

	initialize : function() {
		this._zombieW = 50;
		this._zombieH = 60;
		fm = ZFFightMan;
		
		this._fightUpdateObject = {};
		this._animForStateObject = {};
		this.initAnimForStateObject();
	},

	initWithCoder : function($super, coder) {
		//		console.log("zombie init with coder");
		//		console.log(coder);
		$super(coder);
		this._thought = 0;
		this._thoughtBubble = null;
		this._tier = 0;
		this._name = coder._name;

		if (!this._name) {
			this._name = this.generateName();
		}
	},

	initWithData : function($super, data) {
		$super(data);
		this._name = data._name;
	},

	initActorSpecificData : function($super) {
		$super();

		//spriteFileName = @"BasicZombie128.png";
		//spriteFileName = @"zombie_sheet_512.png";
		this._spriteFileName = "ZombieSheet.png";
		this._brainState = kActorBrainStateLookingForHome;
		this._walkingSpeed = ZOMBIEBASESPEED;
		this._animSpeed = ZOMBIEBASESPEED;
		this._type = kActorTypeZombie;

		// TODO : Thoughts.
		this._thoughtBubble = null;
		this.setThought(this.zombieThoughts.kZombieThoughtNothing);

		this._lastX = 0;

		this._originalWalkingSpeed = 0.0;

	},

	initActorSpecificDataAfterLoad : function($super) {
		$super();

		var dict = ZFActorManager._unitStats;
		var unitKey = this.classname;
		this._unitDictionary = dict[unitKey];
		var dex = this._unitDictionary["dex"];
		this._walkingSpeed = ZOMBIEBASESPEED * 0.5 * dex;
		this._animSpeed = 1.0 / (this._walkingSpeed);

		if (!ZFActorManager.spawningSpawnQueue && !this._name) {
			this._name = this.generateName();
		}

		this._originalWalkingSpeed = this._walkingSpeed;
		
		this.initFightUpdateObject();
	},

	colorFromSubType : function(actorSubType) {
		var gs = GameState;
		if (!gs.exists()) {
			return ccc3(0, 0, 0);
		}

		if (!this._savedColor) {
			this._savedColor = ccc3(0x0, 0x0, 0x0);
		}

		if (this._savedColor._red == 0 && this._savedColor._green == 0 && this._savedColor._blue == 0) {
			if (this._color._red == 0 && this._color._green == 0 && this._color._blue == 0) {
				var marketArray = DataPreloader._marketData;
				var unitKey = this.classname;
				var zombieItem = null;

				for ( var key in marketArray) {
					var item = marketArray[key];

					// unitKey is a field only available in zombies that are in the market
					if (unitKey == item["unitKey"]) {
						zombieItem = item;
						break;
					}
				}

				var colorConv = ccc3(255, 255, 255);

				// if the zombie was found in the market
				if (zombieItem) {
					// for tier 4 zombies this color is white (255,255,255)
					var colorArray = zombieItem["color"];

					// ALL zombies have a color array
					if (colorArray) {
						colorConv = ccc3(colorArray[0], colorArray[1], colorArray[2]);
					} else {
						colorConv = ccc3(255, 255, 255);
					}
				}

				// initializes both color and savedColor
				this.setColor(colorConv);
				this._savedColor = colorConv;
			}
		} else {
			// if the color has already been initialized then the color to use is the savedColor
			this.setColor(this._savedColor);
		}

		// if not initialized we return the default color that is defined in the market
		// else color is always equal to savedcolor
		return this._color;
	},

	update : function($super, dt) {
		$super(dt);
		this.positionThoughtBubble();
	},

	animForState : function(value) {
		var ret = this._animForStateObject[value];
		if(typeof(ret) != undefined) return ret;
		return -1;
	},

	startAnimForState : function(value) {
		
		if (value==kActorFightStateWait)
			return;
		
		var animID = this.animForState(value);

		if (animID != -1) {
			this.startAnim(animID, true);
		}
	},

	startAnimForWaitState : function() {
		
		var animID = this.animForState(kActorFightStateWait);

		if (animID != -1) {
			this.startAnim(this.animForState(kActorFightStateWait), true);
		}
		this._waitAnimated = true;
	},
	
	cleanupAnimForState : function(value) {
		this.cleanupAnim(this.animForState(value));
	},

	cleanupAnim : function(animID) {
		
		if (!this._attachments || animID < 0) {
			return;
		}

		var arm1 = this._attachments[kActorPartTagArmF];
		var arm2 = this._attachments[kActorPartTagArmB];
		var head = this._attachments[kActorPartTagHead];
		var jaw = this._attachments[kActorPartTagJaw];
		var eye1 = this._attachments[kActorPartTagEyeL];
		var eye2 = this._attachments[kActorPartTagEyeR];

		switch (animID) {
		case kActorAnimIdle: {
			if (eye1._ccPosition._y != 0) {
				eye1.setPosition(ccp(0, 0));
				eye1._sprite.setOpacity(255);
				var spriteScale = eye1._sprite._totoScale.clone();
				spriteScale.setY(1.0 * eye1._totoScale._y);
				eye1._sprite.setScale(spriteScale.clone());
			}

			if (eye2._ccPosition._y != 0) {
				eye2.setPosition(ccp(0, 0));
				eye2._sprite.setOpacity(0);
				var spriteScale = eye2._sprite._totoScale.clone();
				spriteScale.setY(1.0 * eye2._totoScale._y);
				eye2._sprite.setScale(spriteScale);
			}

		}
			break;

		case kActorAnimWalk: {
		}
			break;
		case kActorAnimVictory: {
		}
			break;
		case kActorAnimAttack: {
			var tmp;

			tmp = eye1._sprite._totoScale.clone().setY(eye1._totoScale._y * 1.0);
			eye1._sprite.setScale(tmp);

			tmp = eye2._sprite._totoScale.clone().setY(eye2._totoScale._y * 1.0);
			eye2._sprite.setScale(tmp);

			jaw.setPosition(ccp(0, 0));
			head.setPosition(ccp(0, 0));
			head._sprite.setRotation(0.0);
		}
			break;
		}
	},

	stopZombieAnimation : function (){
		this.unschedule( this.farmUpdate );
		this.unschedule( this.farmWander);
		this.updateHunger();
//		actor.schedule(actor.updateHunger,0.5);
		this.stopAttachmentActions();
	},
	
	resetActionData : function(){
        this._stopAction = false;
        this._stoppedAction = false;
        this._doingAbility = false;
//        if(this._spriteMan && this._spriteMan.getParent())
//        	this._spriteMan.getParent().reorderChild(this._spriteMan,this._order);
	},
	
	justAttack : function(animID){		
		
		if(animID == kActorAnimAttack){
			this._fightData._attacking = true;
			var asc = this.getFightAttackSpeed();
			this.schedule(this.doneAttacking, asc, "doneAttacking");
	
			var attackAnimID = this._fightData._currentAttackVariation["animID"];
			if(attackAnimID == ZFAttackAnims.kAttackTypes.kAttackTypeBashV2 || attackAnimID == ZFAttackAnims.kAttackTypes.kAttackTypeBash ||
			   attackAnimID == ZFAttackAnims.kAttackTypes.kAttackTypeExplode || attackAnimID == ZFAttackAnims.kAttackTypes.kAttackTypeExplodeV2 ){
				this._doingAbility = true;
				ZFAttackAnims.performAttackWithID(attackAnimID, this);
			}
			else{
				if(this._doingAbility){
					this._doingAbility = false;
					this._stoppedAction = false;
				}
			}
		}
	},
	
	startAnim : function(animID, interrupt, fromActorManager) {

		if(this._fightData)	{
			if(animID == kActorAnimDying){
				this._dying = true;
				this.resetActionData();
			}
			
			//Zombie has to stop but his actions are already stopped
			if(this._stopAction && this._stoppedAction && !this._dying){
				this.justAttack(animID);
				return;
			}
			
			//Zombie has to stop
			if(this._stopAction && !this._dying){
				this.justAttack(animID);
				
				if(!this._doingAbility){
					this.stopAttachmentActions();
					this.resetColor();
					this._stoppedAction = true;
					return;
				}
			}
			
			//Zombie actions are not stopped
			this._stoppedAction = false;
		}
		
		if (interrupt) {
			this.stopAttachmentActions();
		}
		
		this.resetColor();

		var arm1 = this._attachments[kActorPartTagArmF];
		var arm2 = this._attachments[kActorPartTagArmB];
		var foot1 = this._attachments[kActorPartTagFootF];
		var foot2 = this._attachments[kActorPartTagFootB];
		var body = this._attachments[kActorPartTagBody];
		var head = this._attachments[kActorPartTagHead];
		var jaw = this._attachments[kActorPartTagJaw];
		var eye1 = this._attachments[kActorPartTagEyeL];
		var eye2 = this._attachments[kActorPartTagEyeR];

		// Sanity check before we start to use the attachment objects
		if (body == null)
			return;

		var asc = this.getFightAttackSpeed();
		var s = this._animSpeed;
		var f = 1; // flip already handled with scale. ([head.sprite flipX]) ? -1 : 1;
		
		
		if(typeof(fromActorManager) == "undefined")
		{
			this.resetAttachmentScaleInterpolate(false);
			this.resetAttachmentPositionInterpolate(false);
			this.resetAttachmentRotationInterpolate(false);
		}

		if (!(this._flags & kMutationArms)) {
			arm1 = this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagArmF, this._spriteDictionary["defaultArmF"]);
			arm2 = this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagArmB, this._spriteDictionary["defaultArmB"]);
		}

		switch (animID) {
		
		case kActorAnimIdleFarm: {
			jaw.loop(ZFAnims.jawOpenCloseMove(s));
			
			var random = Math.floor(Math.random()*4 + 5);
			if(Math.random() > 0.2){
				eye1.loopS(ZFAnims.eyeBlink(random, eye1._totoScale._x));
				eye2.loopS(ZFAnims.eyeBlink(random, eye2._totoScale._x));
			}
			break;
		}
			
		
		case kActorAnimIdle: {
			//break;
			arm1.onceS(ZFAnims.armIdleRotate(s, f));
			arm2.onceS(ZFAnims.armIdleRotate(s, f));
//			head.loopS(ZFAnims.headDaydream(s, f));
			jaw.loop(ZFAnims.jawOpenCloseMove(s));
			
			var random = Math.floor(Math.random()*4 + 5);
			if(Math.random() > 0.2){
				eye1.loopS(ZFAnims.eyeBlink(random, eye1._totoScale._x));
				eye2.loopS(ZFAnims.eyeBlink(random, eye2._totoScale._x));
			}
		}
			break;

		case kActorAnimKnockBack: {
			arm1.loopS(ZFAnims.armVictory(0.25, arm1._totoScale._x, f));
			arm2.loopS(ZFAnims.armVictory(0.25, arm2._totoScale._x, f));
			arm1.once(ZFAnims.armVictoryMove(0.25));
			arm2.once(ZFAnims.armVictoryMove(0.25));
		}
			break;

		case kActorAnimSleeping: {
			eye1.onceS(ZFAnims.eyeSquint(eye1._totoScale._x));
			eye2.onceS(ZFAnims.eyeSquint(eye2._totoScale._x));
			arm1.onceS(ZFAnims.armIdleRotate(s, f));
			arm2.onceS(ZFAnims.armIdleRotate(s, f));
//			head.loopS(ZFAnims.headSleep(s, f));
//			jaw.loop(ZFAnims.jawCloseMove(s));
		}
			break;

		case kActorAnimChase: {
			var headAdjust = ccp(2.0, 5.0);
//			jaw.once(ZFAnims.jawOpenMove(s));
			eye1.onceS(ZFAnims.eyeBulge(s, eye1._totoScale._x));
			eye2.onceS(ZFAnims.eyeBulge(s, eye2._totoScale._x));
			arm1.loopS((this.subType == zombieSubTypeLummox) ? ZFAnims.armWalkLummoxRotate(s, f) : ZFAnims.armWalkWiggleFrontRotate(s, arm1._totoScale
					._x, f));

			arm2.loopS((this.subType == zombieSubTypeLummox) ? ZFAnims.armWalkLummoxRotate(s, f) : ZFAnims.armWalkWiggleBackRotate(s, arm2._totoScale
					._x, f));

//			foot1.loop(ZFAnims.footWalkFrontMove(s));
//			foot2.loop(ZFAnims.footWalkBackMove(s));
//			foot1.loopS(ZFAnims.footWalkFrontRotate(s, f));
//			body.loop(ZFAnims.bodyWalkMove(s));
//			head.loop(ZFAnims.headWalkMove(s, headAdjust));
//			head.loopS(ZFAnims.headWalkRotate(s, f));
		}
			break;

		case kActorAnimChaseNoWalk: {
			jaw.once(ZFAnims.jawOpenMove(s));
			eye1.onceS(ZFAnims.eyeBulge(s, eye1._totoScale._x));
			eye2.onceS(ZFAnims.eyeBulge(s, eye2._totoScale._x));
			arm1.loopS((this.subType == zombieSubTypeLummox) ? ZFAnims.armWalkLummoxRotate(s, f) : ZFAnims.armWalkWiggleFrontRotate(s, arm1._totoScale
					._x, f));

			arm2.loopS((this.subType == zombieSubTypeLummox) ? ZFAnims.armWalkLummoxRotate(s, f) : ZFAnims.armWalkWiggleBackRotate(s, arm2._totoScale
					._x, f));
		}
			break;

		case kActorAnimWalk: {
			arm1.onceS((this.subType == zombieSubTypeLummox) ? ZFAnims.armWalkLummoxRotate(s, f) : ZFAnims.armWalkFrontRotate(s, f));

			arm2.onceS((this.subType == zombieSubTypeLummox) ? ZFAnims.armWalkLummoxRotate(s, f) : ZFAnims.armWalkFrontRotate(s, f));

//			foot1.loop(ZFAnims.footWalkFrontMove(s));
//			foot2.loop(ZFAnims.footWalkBackMove(s));
//			foot1.loopS(ZFAnims.footWalkFrontRotate(s, f));
//			body.loop(ZFAnims.bodyWalkMove(s));
//			head.loop(ZFAnims.headWalkMove(s, ccp(0, 0)));
//			head.loopS(ZFAnims.headWalkRotate(s, f));
		}
			break;

		case kActorAnimWalkSimple: {
			arm1.onceS((this.subType == zombieSubTypeLummox) ? ZFAnims.armWalkLummoxRotate(s, f) : ZFAnims.armWalkFrontRotate(s, f));
			arm2.onceS((this.subType == zombieSubTypeLummox) ? ZFAnims.armWalkLummoxRotate(s, f) : ZFAnims.armWalkFrontRotate(s, f));
		}
			break;

		case kActorAnimAttack: {
			this._fightData._attacking = true;

			if (!this.isScheduled(this.doneAttacking)) {
				this.schedule(this.doneAttacking, asc, "doneAttacking");
			}

			var attackAnimID = this._fightData._currentAttackVariation["animID"];
			ZFAttackAnims.performAttackWithID(attackAnimID, this);
			
			if(attackAnimID == ZFAttackAnims.kAttackTypes.kAttackTypeBashV2 || attackAnimID == ZFAttackAnims.kAttackTypes.kAttackTypeBash ||
			   attackAnimID == ZFAttackAnims.kAttackTypes.kAttackTypeExplode || attackAnimID == ZFAttackAnims.kAttackTypes.kAttackTypeExplodeV2 ){
					this._doingAbility = true;
			}
			else{
				if(this._doingAbility){
					this._doingAbility = false;
					this._stoppedAction = false;
				}
			}
		}
			break;

		case kActorAnimVictory: {
			arm1.loopS(ZFAnims.armVictory(s, arm1._totoScale._x, f));
			arm2.loopS(ZFAnims.armVictory(s, arm2._totoScale._x, f));
			arm1.once(ZFAnims.armVictoryMove(s));
			arm2.once(ZFAnims.armVictoryMove(s));
//			eye1.onceS(ZFAnims.eyeBulge(s, eye1._totoScale._x));
//			eye2.onceS(ZFAnims.eyeBulge(s, eye2._totoScale._x));
//			head.loop(ZFAnims.headWalkMove(s, ccp(0, 0)));
		}
			break;

		case kActorAnimDying: {
			head.once(ZFAnims.headFlyOff(s, f));
			head.onceS(ZFAnims.headFlyRotate(s, f));
			arm1.onceS(ZFAnims.armWalkFrontRotate(0.05, f));
			arm2.onceS(ZFAnims.armWalkFrontRotate(0.05, f));
			arm1.once(ZFAnims.armFallMove(1.0));
			arm2.once(ZFAnims.armFallMove(1.0));
			body.once(ZFAnims.bodyDieMove(s));
			body.onceS(ZFAnims.bodyDie(s, f));
		}
			break;

		case kActorAnimThinking: {
			arm1.onceS(ZFAnims.armIdleRotate(s, f));
			arm2.onceS(ZFAnims.armIdleRotate(s, f));
			eye1.onceS(ZFAnims.eyeSquint(eye1._totoScale._x));
			eye2.onceS(ZFAnims.eyeSquint(eye2._totoScale._x));
//			head.loop(ZFAnims.headMove(s, ccp(0, -3)));
//			jaw.once(ZFAnims.jawCloseMove(s));
		}
			break;

		case kActorAnimIdea: {
			arm1.onceS(ZFAnims.armIdleRotate(s, f));
			arm2.onceS(ZFAnims.armIdleRotate(s, f));
//			head.loopS(ZFAnims.headDistracted(s, f));
			eye1.once(ZFAnims.eyeDistractedMove(s));
			eye2.once(ZFAnims.eyeDistractedMove(s));
//			jaw.once(ZFAnims.jawOpenMove(s));
		}
			break;

		case kActorAnimHeal: {
			// fixed speed ... animation not determined by animSpeed
			s = 1.0;
			arm1.once(ZFAnims.armVictoryMove(s));
			arm2.once(ZFAnims.armVictoryMove(s));
			eye1.onceS(ZFAnims.eyeBulge(s, eye1._totoScale._x));
			eye2.onceS(ZFAnims.eyeBulge(s, eye2._totoScale._x));

			arm1._sprite.runAction(CCSequence.actions(new Array(ZFAnims.armVictory(s * 0.8, arm1._totoScale._x, f), ZFAnims.armIdleRotate(s * 0.2,
					f))));

			arm2._sprite.runAction(CCSequence.actions(new Array(ZFAnims.armVictory(s * 0.8, arm2._totoScale._x, f), ZFAnims.armIdleRotate(s * 0.2,
					f))));

//			head._sprite.runAction(CCSequence.actions(new Array(ZFAnims.headDistracted(s * 0.8, f), ZFAnims.headDaydream(s * 0.2, f))));
//
//			jaw.runAction(CCSequence.actions(new Array(ZFAnims.jawOpenMove(s * 0.8), ZFAnims.jawOpenCloseMove(s * 0.2))));
		}
		}
		this.resetColor();
		
//		var delta = Core.Time.getRealTime()-ini;
//		if(delta > 15)
//			console.log("startAnim with state: (" + animID + "," + interrupt + "): " + delta); 		
	},

	setThought : function(newThought) {
		this._thought = newThought;
		var tm = ZFTileManager;

		if (this._thoughtBubble && this._thoughtBubble._parent) {
			this._thoughtBubble._parent.removeChild(this._thoughtBubble);
			destroyWithChildren(this._thoughtBubble);
		}
		switch (newThought) {
		case this.zombieThoughts.kZombieThoughtNothing:
			this._thoughtBubble = null;
			break;
		case this.zombieThoughts.kZombieThoughtBrains:
			this._thoughtBubble = CCSprite.spriteWithFile("thoughtBubbleBrains.png");
			break;
		case this.zombieThoughts.kZombieThoughtHeart:
			this._thoughtBubble = CCSprite.spriteWithFile("thoughtBubbleHeart.png");
			break;
		case this.zombieThoughts.kZombieThoughtRainbow:
			this._thoughtBubble = CCSprite.spriteWithFile("thoughtBubbleRainbow.png");
			break;
		case this.zombieThoughts.kZombieThoughtHmm:
			this._thoughtBubble = CCSprite.spriteWithFile("thoughtBubbleHmm.png");
			break;
		case this.zombieThoughts.kZombieThoughtCupCake:
			this._thoughtBubble = CCSprite.spriteWithFile("thoughtBubbleCupCake.png");
			break;
		case this.zombieThoughts.kZombieThoughtLollipop:
			this._thoughtBubble = CCSprite.spriteWithFile("thoughtBubbleLollipop.png");
			break;
		case this.zombieThoughts.kZombieThoughtSunshine:
			this._thoughtBubble = CCSprite.spriteWithFile("thoughtBubbleSunshine.png");
			break;
		case this.zombieThoughts.kZombieThoughtFlower:
			this._thoughtBubble = CCSprite.spriteWithFile("thoughtBubbleFlower.png");
			break;
		case this.zombieThoughts.kZombieThoughtButterfly:
			this._thoughtBubble = CCSprite.spriteWithFile("thoughtBubbleButterfly.png");
			break;
		case this.zombieThoughts.kZombieThoughtSmile:
			this._thoughtBubble = CCSprite.spriteWithFile("thoughtBubbleSmile.png");
			break;
		case this.zombieThoughts.kZombieThoughtMusic:
			this._thoughtBubble = CCSprite.spriteWithFile("thoughtBubbleMusic.png");
			break;
		default:
			this._thoughtBubble = null;
			break;
		}
		if (this._thoughtBubble) {
			this._thoughtBubble.setAnchorPoint(1, 0);

			this.positionThoughtBubble();

			if (this._farmData)
				tm._map.addChild(this._thoughtBubble, 3001);

			if (this._fightData)
				(this.getParent()).addChild(this._thoughtBubble, 100);
		}
	},

	positionThoughtBubble : function() {		
		if (this._thoughtBubble && this._state != kActorFightStatePrepCycle && this._attachments) {
			var pos = this.getHeadPosition();	
			var scale = this._thoughtBubble._totoScale.clone();
			var a = this._attachments[kActorPartTagHead];
			this._thoughtBubble.setScale(a._sprite._flipX ? -1 * Math.abs(scale._x) : 1 * Math.abs(scale._x), scale._y);
//			pos._x += 100;
//			pos._y += 100;
			this._thoughtBubble.setPosition(pos);
		}
	
	},

	getHeadPosition : function(){
		if (!this._attachments || this._attachments.length == 0) {
			return {_x:0,_y:0};
		}
			
		var a = this._attachments[kActorPartTagHead];

		if (a /*&& this._thoughtBubble && this._state != kActorFightStatePrepCycle*/) {
			var pos = {_x: 30 * (a._sprite._flipX ? 1 : -1), _y: 25};
			
			if(!a._lastFramePosition){				
				a._updated = false;
				//this should be here, don't remove
				this.updateAttachment(a);
			}
			
			pos._x += a._lastFramePosition._x;
			pos._y += a._lastFramePosition._y;
	
			pos._x *= this._spriteMan._totoScale._x;
			pos._y *= this._spriteMan._totoScale._y;
			
			if(this instanceof ZombieActorHeadless && !(ZFFightMan._farmData))
				pos._y -= 60; 
			
			return pos;
		}
		return {_x:0,_y:0};
	},
	
	initSpriteDictionary : function($super) {
		$super();
		this._spriteDictionary = ZFActorManager.zombieSprites();
	},

	initSprite : function($super) {
		$super();

		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmF, this._spriteDictionary["defaultArmF"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmB, this._spriteDictionary["defaultArmB"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagHead, this._spriteDictionary["defaultHead"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagBody, this._spriteDictionary["defaultBody"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFootF, this._spriteDictionary["defaultFootF"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFootB, this._spriteDictionary["defaultFootB"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagEyeL, this._spriteDictionary["defaultEyeL"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagEyeR, this._spriteDictionary["defaultEyeR"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagJaw, this._spriteDictionary["defaultJaw"]);

		this._attachments[kActorPartTagEyeL]._inheritColor = false;
		this._attachments[kActorPartTagEyeR]._inheritColor = false;

		this.addMutation(this._flags);
	},

	addMutation : function(mutationFlags) {
		if (!mutationFlags) {
			return;
		}

		this._flags |= mutationFlags;

		if (mutationFlags & kMutationTomatoHead) {
			var a = this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagHead, this._spriteDictionary["tomatoHead"]);

			a._inheritColor = false;
			this._flags &= ~kMutationHead;
			this._flags |= kMutationTomatoHead;
		}

		if (mutationFlags & kMutationOnionHead) {
			var a = this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagHead, this._spriteDictionary["onionHead"]);
			a._inheritColor = false;
			this._flags &= ~kMutationHead;
			this._flags |= kMutationOnionHead;
		}

		if (mutationFlags & kMutationCarrotHat) {
			var a = this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagHat, this._spriteDictionary["carrotHat"]);
			a._inheritColor = false;
			this._flags &= ~kMutationHat;
			this._flags |= kMutationCarrotHat;
		}

		if (mutationFlags & kMutationTurnipArms) {
			var a = this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagArmF, this._spriteDictionary["mutationArm"]);
			var b = this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagArmB, this._spriteDictionary["mutationArm"]);
			var c = this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmFm, this._spriteDictionary["turnipArm"]);

			a._inheritColor = true;
			b._inheritColor = true;
			c._inheritColor = false;
			a.setScale(ccp(1.5, 1.5));
			b.setScale(ccp(1.5, 1.5));
			this._flags &= ~kMutationArms;
			this._flags |= kMutationTurnipArms;
		}

		if (mutationFlags & kMutationPotatoHead) {
			var a = this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagHead, this._spriteDictionary["potatoHead"]);
			a._inheritColor = false;
			this._flags &= ~kMutationHead;
			this._flags |= kMutationPotatoHead;
		}

		if (mutationFlags & kMutationCoffeeHead) {
			var a = this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagHead, this._spriteDictionary["coffeeHead"]);
			a._inheritColor = false;
			this._flags &= ~kMutationHead;
			this._flags |= kMutationCoffeeHead;
		}

		if (mutationFlags & kMutationPumpkinHead) {
			var a = this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagHead, this._spriteDictionary["pumpkinHead"]);
			a._inheritColor = false;
			this._flags &= ~kMutationHead;
			this._flags |= kMutationPumpkinHead;
		}

		if (mutationFlags & kMutationCeleryArms) {
			var a = this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagArmF, this._spriteDictionary["mutationArm"]);
			var b = this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagArmB, this._spriteDictionary["mutationArm"]);
			var c = this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmFm, this._spriteDictionary["celeryArm"]);

			a._inheritColor = true;
			b._inheritColor = true;
			c._inheritColor = false;

			a.setScale(ccp(1.5, 1.5));
			b.setScale(ccp(1.5, 1.5));
			this._flags &= ~kMutationArms;
			this._flags |= kMutationCeleryArms;
		}

		if (mutationFlags & kMutationBroccoliHat) {
			var a = this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagHat, this._spriteDictionary["broccoliHat"]);
			a._inheritColor = false;
			this._flags &= ~kMutationHat;
			this._flags |= kMutationBroccoliHat;
		}

		if (mutationFlags & kMutationGarlicHead) {
			var a = this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagHead, this._spriteDictionary["garlicHead"]);
			a._inheritColor = false;
			this._flags &= ~kMutationHead;
			this._flags |= kMutationGarlicHead;
		}

		if (mutationFlags & kMutationCauliflowerHat) {
			var a = this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagHat, this._spriteDictionary["cauliflowerHat"]);
			a._inheritColor = false;
			this._flags &= ~kMutationHat;
			this._flags |= kMutationCauliflowerHat;
		}

		if (mutationFlags & kMutationLimaBeanBody) {
			var a = this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagBody, this._spriteDictionary["limaBeanBody"]);
			a._inheritColor = false;
			this._flags &= ~kMutationBody;
			this._flags |= kMutationLimaBeanBody;
		}

		if (mutationFlags & kMutationFlyTrapCollar) {
			var a = this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagCollar, this._spriteDictionary["flytrapCollar"]);
			a._inheritColor = false;
			this._flags &= ~kMutationCollar;
			this._flags |= kMutationFlyTrapCollar;
		}

		if (mutationFlags & kMutationDragonArms) {
			var a = this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagArmF, this._spriteDictionary["mutationArm"]);
			var b = this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagArmB, this._spriteDictionary["mutationArm"]);
			var c = this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmFm, this._spriteDictionary["dragonArm"]);
			a._inheritColor = true;
			b._inheritColor = true;
			c._inheritColor = true;
			a.setScale(ccp(1.5, 1.5));
			b.setScale(ccp(1.5, 1.5));
			this._flags &= ~kMutationArms;
			this._flags |= kMutationDragonArms;
		}

		this.resetColor();

		//let us check if the zombie created is a real actor
		if (this.isScheduled(this.farmUpdate)) {
			// TODO : MutationMenu first
			//	        // check if the mutation here matches any in the mutation collection list
				        var gs = GameState;
				        
				        var mm = ZFMutationMenu.mutationMenu();
				        var collectionFlags = 0;
				        
				        for ( var key in mm._mutationCollectionArray.collection) 
				        {
				        	var mutationArray = mm._mutationCollectionArray.collection[key];
				            collectionFlags = 0;
				            
				            for ( var i in mutationArray) 
				            {
				            	var mutationNum = mutationArray[i];
				                collectionFlags |= (1<< parseInt(mutationNum));
				            }
				            
				            if (mutationFlags == collectionFlags)
				            {
				                //unlock the mutation collection
				                //int mutationIndex = [mm.mutationCollectionArray indexOfObject:mutationArray];
				            	var mutationIndex = key;

								if( !(gs._zfGameData._mutationCollectionFlags.hasFlag(mutationIndex)) )
								{
									gs._zfGameData._mutationCollectionFlags.setFlag(mutationIndex);
									ZFGuiLayer.gui().displayToolTip(NSLocalizedString("Mutation Discovered","Mutation Discovered"),
																	(sprintf(NSLocalizedString("Collectable #%i Unlocked", null), mutationIndex + 1)));
//									//record this event
//									var eventDictionary = {};
//									eventDictionary["level"] = gs._zfGameData._level;
//									eventDictionary["mutation number"] = mutationIndex + 1;
//
//									//TODO:
//									FlurryAPI.logEvent(kFlurryEvent_mutationCollection, eventDictionary);
								}
				            }
				        }
		}
	},

	despawn : function($super) {
		this.setThought(this.zombieThoughts.kZombieThoughtNothing);
		$super();
	},

	quietTime : function(dt) {
		this.unschedule(this.quietTime);
	},

	farmUpdate : function(dt, think) {		
		switch (this._brainState) {
			case kActorBrainStateNone: {
				this.unschedule(this.farmWander);
			}
				break;
			case kActorBrainStatePerformingTileAction: {
				// right now performing a tile action means we reached the tile that summoned zombies
				if (ccpEqual(this._farmData._destinationTile, this._farmData._currentTile)) {
					ZFTileManager.reachedTile(this._farmData._currentTile.clone(), this);
				}
			}
				break;
	
			case kActorBrainStateLookingForHome: {
				
				var patch = this._farmData ? ZFTileManager.nearestZombiePatchFromTile( this._farmData._currentTile ) : null;
				var newDestination = patch ? patch._rootTile : ccp(-1, -1);
	
				if (!patch || !patch.isOn()) {
					if (!this.isScheduled(this.farmThink) && !this.isScheduled(this.farmStopThink)) {
						this.schedule(this.farmThink, ZOMBIE_THINK_INTERVALS + Math.random() * ZOMBIE_THINK_INTERVALS, "farmThink");
					}
	
					//wander aimlessly on whole map
					if (!this.isScheduled(this.farmWander)) {
						this.schedule(this.farmWander, ( (5  + Math.random() * 60) / this._walkingSpeed), "farmWander");
					}
				} else if (patch.isOn()) {
					if (newDestination._x == this._farmData._currentTile._x && newDestination._y == this._farmData._currentTile._y) {
						if (patch.addInhabitant(this)) {
							this._brainState = kActorBrainStateAtHome;
							this._farmData._myHomeTile = newDestination.clone();
							this.unschedule(this.farmWander);
						} else {
							//wander aimlessly on whole map
							this.schedule(this.farmWander, 0, "farmWander");
						}
					} else {
						this.moveToTile(newDestination);
						this.unschedule(this.farmWander);
					}
				}
	
				if (!this.isScheduled(this.quietTime)) {
					if (Math.random() <= ZOMBIE_TALK_CHANCE) {
						this.talk();
					}
	
					this.schedule(this.quietTime, 10.0, "quietTime");
				}
			}
				break;
	
			case kActorBrainStateAtHome: {
				if (this._ccPosition._x == this._destinationPoint._x && this._ccPosition._y == this._destinationPoint._y) {
					this.setState(kActorStateDormant);
					//this.unschedule: @selector(update); // NB was commented in objC.
					if (this.isScheduled(this.farmThink)) {
						this.unschedule(this.farmThink);
					}
	
					this.setThought(this.zombieThoughts.kZombieThoughtNothing);
				}
			}
				break;
		}

		this.update(dt);
	},

	farmWander : function(dt) {
		tim = ZFTileManager;
		var mapSize = tim._map._mapSize;
		var newDestination=  ccp(0,0);
		var counter = 0;

		
		while (counter < 5) {
			counter++;
			newDestination._x = Math.floor(Math.random() * mapSize._width);
			newDestination._y = Math.floor(Math.random() * mapSize._height);
		 
			if (tim.isTileOccupied(newDestination ) == false) {
				break;
			}
		}

		this.moveToTile(newDestination);
		this.schedule(this.farmWander, 5 / this._walkingSpeed + Math.random() * 60 / this._walkingSpeed);
	},

	farmThink : function(dt) {
		this.unschedule(this.farmStopThink);
		this.unschedule(this.farmThink);

		//random zombie thought
		var roll = Math.random();

		if (this._hunger >= 1.0) {
			this.setThought(this.zombieThoughts.kZombieThoughtBrains);
		} else if (roll >= 1.0 - ZOMBIE_THINK_CHANCE) {
			var rand = Math.random();
			var thoughtRoll = 1 + rand * (this.zombieThoughts.kZombieThoughtMax - 1);

			if (this._hunger > 0.5) {
				if (rand < ((this._hunger - 0.5) * 2)) {
					this._thoughtRoll = this.zombieThoughts.kZombieThoughtBrains;
				}
			}

			//think
			this.setThought(thoughtRoll);
			this.schedule(this.farmStopThink, ZOMBIE_THINK_DISPLAYTIME, "farmStopThink");
		} else {
			this.setThought(this.zombieThoughts.kZombieThoughtNothing);
		}
	},

	farmStopThink : function(dt) {
		this.unschedule(this.farmStopThink);

		this.setThought(this.zombieThoughts.kZombieThoughtNothing);
	},

	initFightDataAfterLoad : function($super) {
		$super();

		var statDict = [];
		statDict["dr"] = 0;
		statDict["str"] = this._unitDictionary["str"];
		statDict["con"] = this._unitDictionary["con"];
		statDict["dex"] = this._unitDictionary["dex"];

		// self buffs and mutations are applied at this point
		statDict = this.modifyStats(statDict);

		var str = statDict["str"];
		var con = statDict["con"];
		var dex = statDict["dex"];
		var dr = statDict["dr"];

		this._fightData._hitPointsTotal = this._fightData._hitPoints = ZFGameDefines.HITPOINTS_MULTIPLIER * con;
		this._fightData._power = ZFGameDefines.POWER_MULTIPLIER * str;
		this._fightData._attackSpeed = 2.0 / dex; //dex is # of attacks in 2 seconds
		this._walkingSpeed = ZOMBIEBASESPEED * dex;
		animSpeed = 1.0 / (ZOMBIEBASESPEED * 0.5 * dex);

		this._fightData._finalHitPointsTotal = this.calculateFinalHitPointsTotal();
		this._fightData._finalAttackSpeed = this.calculateFinalAttackSpeed();
		this._fightData._finalPower = this.calculateFinalPower();
		this._fightData._finalDamageReduction = dr;

		this._state = kActorFightStateWait; 
		this.schedule(this.fightUpdate, 0.05, "fightUpdate");
		
	},

	setHunger : function() {
		// check for valid eat dates
		if (!this._eatDate)
			this._eatDate = Core.Time.getRealTime() / 1000 - ZFGameDefines.ZOMBIE_HUNGER_DURATION;

		var timeSinceNow = this._eatDate;
		var zombieHungerDuration = ZFGameDefines.ZOMBIE_HUNGER_DURATION;
		var gs = GameState;

		if (gs._zfGameData._headID == 8 || gs._zfGameData._headID == 9) {
			zombieHungerDuration *= 0.75; //down from 8 hours to 6 hour hunger
		}

		this._hunger = Math.abs(timeSinceNow / zombieHungerDuration);
		this._hunger = (!(gs._zfGameData._gflags & ZFGameFlags.GFLAG_FIGHT_TUTORIAL)) ? 0.0 : this._hunger;
		this._hunger = (this._hunger > 1.0) ? 1.0 : this._hunger;
	},

	modifyStats : function(statDict) {
		var gs = GameState;
		
		var str = statDict["str"];
		var con = statDict["con"];
		var dex = statDict["dex"];
		var dr = statDict["dr"];

		//mutation effects
		if (this._flags & kMutationTomatoHead) {
			str += 1;
		}

		if (this._flags & kMutationOnionHead) {
			con += 1;
		}

		if (this._flags & kMutationCarrotHat) {
			dex += 1;
		}

		if (this._flags & kMutationTurnipArms) {
			str += 2;
		}

		if (this._flags & kMutationPotatoHead) {
			con += 2;
		}

		if (this._flags & kMutationCoffeeHead) {
			dex += 2;
		}

		if (this._flags & kMutationPumpkinHead) {
			str += 3;
		}

		if (this._flags & kMutationCeleryArms) {
			str += 3;
		}

		if (this._flags & kMutationBroccoliHat || this._flags & kMutationCauliflowerHat) {
			con += 3;
		}

		if (this._flags & kMutationGarlicHead) {
			str += 3;
		}

		if (this._flags & kMutationLimaBeanBody) {
			con += 3;
		}

		if (this._flags & kMutationFlyTrapCollar) {
			con += 4;
		}

		if (this._flags & kMutationDragonArms) {
			str += 4;
		}

		//rank effects
		var rank = this.getRank();
		var statMultiplier = 1.0 + rank * ZFGameDefines.ZOMBIE_RANK_STAT_INCREASE;
		str *= statMultiplier;
		con *= statMultiplier;
		dex *= statMultiplier;

		//head effects
		if (gs._zfGameData._headID == 3 || gs._zfGameData._headID == 7) // vampire head selected
		{
			str *= 1.1;
		}

		if (gs._zfGameData._headID == 2 || gs._zfGameData._headID == 6) // skeleton head selected
		{
			con *= 1.1;
		}

		// ability effects ? (they affect atk power and atk speed ... both not seen on stat list
		//					-> must translate to raw stats
		// handles more than 1 passive
		// no need to calculate caps for passive self buffs ... should be balanced developer side
		// passive bonuses also do not count towards stat caps

		var powerBonus = 0;
		var attackSpeedBonus = 0;
		var hitPointsBonus = 0;
		var damageReduction = 0;

		for ( var key in this._abilityList) {
			var buff = this._abilityList[key];

			if (buff instanceof ZFActorFightEffect) {
				if (buff._unlocked && !buff._appliesToGroup && buff._timerActivateIn == -1) {
					// this is a passive self buff -- buff numbers range from 0.0 to 1.0
					powerBonus += buff._powerChange;
					attackSpeedBonus += buff._attackSpeedChange;
					hitPointsBonus += buff._hitPointsTotalChange;
					damageReduction += buff._damageReduction;
					buff._active = true; // very important, makes sure buff doesn't get applied twice //
				}
			}
		}

		str = str * (1 + powerBonus); // 0.1 increase in power = 10% increase in str
		con = con * (1 + hitPointsBonus); // 0.1 increase in hp	 = 10% increase in con
		dex = dex * (1 + (attackSpeedBonus * 2.0)); // 0.1 increase in speed = 20% increase in dex
		dr = dr + damageReduction; // used in fight not really displayed 

		statDict["str"] = str;
		statDict["con"] = con;
		statDict["dex"] = dex;
		statDict["dr"] = dr;
		
		return statDict;
	},

	knockBackBy : function($super, distance, force) {
		$super(distance, force);
		this._destinationPoint = this.calculateDestinationPoint();
	},

	calculateDestinationPoint : function() {
//		var ini = Core.Time.getRealTime();
		var offset = 0;

		if (this instanceof ZombieActorLarge)
			offset = 15;
		else if (this instanceof ZombieActorRegular)
			offset = 8;
		else if (this instanceof ZombieActorGarden)
			offset = 15;
		else if (this instanceof ZombieActorGirl)
			offset = 4;
		else if (this instanceof ZombieActorHeadless)
			offset = -5;
		else if (this instanceof ZombieActorSmall)
			offset = -15;

		// figure out what column to place zombie
		var index = fm._zombies.indexOf(this); // defeated zombies are taken out of zombies array already

		// later on base this on size instead of index
		var column = Math.floor(index / 5); // 5 zombies per column ... xVal == value * column number + starting position

		// get zombies for your column and find specific place

		var zombiesTemp = [];
		

		var gardenZombieIndex = 0;
		var largeZombieIndex = 0;
		var regularZombieIndex = 0;
		var girlZombieIndex = 0;
		var headlessZombieIndex = 0;
		var smallZombieIndex = 0;
		
		for ( var zKey in fm._zombies ) {
			//check if the same column ... and count number of zombies of diff types		

			var z = fm._zombies[zKey];
			var tempColumn = Math.floor(zKey / 5);
			if (column == tempColumn
					&& (z.isInMeleeRange() || z._state == kActorFightStateMoveForwardAfterAttack || z._state == kActorFightStateGo
							|| z._state == kActorFightStateGoing || z._state == kActorFightStateStunned
							|| z._state == kActorFightStateUsingAbilityAtRange || z._state == kActorFightStateExitMelee)) {
				// zombies are in the same column			
				if (z instanceof ZombieActorGarden && !(z instanceof ZombieActorGardenCupid)) {
					if(!zombiesTemp[3])
						zombiesTemp[3] = [];
					zombiesTemp[3][gardenZombieIndex] = z;
					gardenZombieIndex++;
				} else if (z instanceof ZombieActorLarge) {
					if(!zombiesTemp[5])
						zombiesTemp[5] = [];
					zombiesTemp[5][largeZombieIndex] = z;
					largeZombieIndex++;
				} else if (z instanceof ZombieActorRegular) {
					if(!zombiesTemp[4])
						zombiesTemp[4] = [];
					zombiesTemp[4][regularZombieIndex] = z;
					regularZombieIndex++;
				} else if (z instanceof ZombieActorGirl) {
					if(!zombiesTemp[2])
						zombiesTemp[2] = [];
					zombiesTemp[2][girlZombieIndex] = z;
					girlZombieIndex++;
				} else if (z instanceof ZombieActorHeadless) {
					if(!zombiesTemp[1])
						zombiesTemp[1] = [];
					zombiesTemp[1][headlessZombieIndex] = z;
					headlessZombieIndex++;
				} else if (z instanceof ZombieActorSmall || z instanceof ZombieActorGardenCupid) {
					if(!zombiesTemp[0])
						zombiesTemp[0] = [];
					zombiesTemp[0][smallZombieIndex] = z;
					smallZombieIndex++;
				}
			}
		}

		var i = 0;
		var zombiesTemp2 = [];
		for (var num in zombiesTemp)
        {
        	var zombieClass = zombiesTemp[num];
        	var tier = 0;
        	for(var key in zombieClass){
        		var zombie = zombieClass[key];
        		
        		zombiesTemp2[i] = zombie;
        		tier++;
        		i++;
        	}
        	zombieClass.length = 0;
        	zombieClass = null;
        }
		// contains all zombies for column

		var totalRows = zombiesTemp2.length;
		var rowIndex = zombiesTemp2.indexOf(this);

		zombiesTemp2.length = 0;
		zombiesTemp2 = null;
//		zombiesTemp.length = 0;
//		zombiesTemp = null;
		// 5  == pixels from bottom 
		// 20 == center point to insert zombies 

		var zombieSpacing = 4;
		var center = zombieSpacing * 2;
		var totalColumns = Math.floor(fm._zombies.length / 5);

		// column and row index are in here .... super bad to do this but we're gonna set the z order here too
		var z = Math.floor(5 + (totalColumns - column - 1) + (4 - rowIndex) * totalColumns);
		
		
//		if (this._spriteMan._zOrder != z) {
			this._spriteMan._parent.reorderChild(this._spriteMan, z);
//			this._spriteMan._zOrder = z;
//			this.updateParticles();
//			_spriteMan
//		}
//		var ini2 = Core.Time.getRealTime();
		// zombies face wrong way sometimes
		this.flipActor(true, true);
//		var ini3 = Core.Time.getRealTime();
		var yVal = 0 + center + (rowIndex * zombieSpacing) - ((zombiesTemp.length - 1) * (zombieSpacing / 2));
		
		var offsetX = 20;
		var xVal = (fm._zombieAttackPosition._x - 55) - (column * 80) - offset
				+ (totalRows - 1 - rowIndex) * 5 - offsetX;
//		var finaltime = Core.Time.getRealTime();
//		console.log("calculateDestinationPoint with state: statego2 " + (ini3 - ini2));
//		console.log("calculateDestinationPoint with state: statego " + (finaltime-ini));
		return {_x:xVal, _y: yVal};
	},

	fightUpdate : function(dt) {
		var state = this._state;
		var fgd = this._fightData;
		if (state != kActorFightStateDead && state != kActorFightStateDying && fgd._hitPoints <= 0 && fgd._canInterrupt) {
			this.setState(kActorFightStateDying);
		}
		
		var func = this._fightUpdateObject[state];
		if(func) {
//			var ini = Core.Time.getRealTime();
			func();
//			var delta = Core.Time.getRealTime() - ini;
//			if(delta > 30)
//				console.log(this.classname + " with state: " + state + "-> FightUpdate: " + delta);
			if(state != kActorFightStateDead && state != kActorFightStateRanAway) {
//				var ini = Core.Time.getRealTime();
				this.update(dt);
//				var delta = Core.Time.getRealTime() - ini;
//				if(delta > 30)
//					console.log(this.classname + " with state: " + state + "-> Update: " + delta);
			}
		}
	},

	fightDieIn : function(dt) {
		this.unschedule(this.fightDieIn);
		this._state = kActorFightStateDead;
	},

	fightWanderIn : function(dt) {
		this.unschedule(this.fightWanderIn);
		this.moveToPoint(ccpF(-10.0 + (Math.random() * 50.0), this._ccPosition._y));
	},

	fightGoIn : function(dt) {
		this.unschedule(this.fightWanderIn);
		this.unschedule(this.fightGoIn);
		this._state = kActorFightStateGo;
	},

	generateNameWithKey : function(key) {
		var zName = this.getNameFromFriendList(key);

		if (!zName) {
			var nameList = ZFActorManager._nameList[key];
			zName = this.pickRandomNameFromList(nameList);
		}

		if (!zName) {
			zName = this.generateName();
		}

		return zName;
	},

	getNameFromFriendList : function(key) {
		return null;
		// TODO: FBMan first.
		//		var arrayWithAppUsers = FBMan.fbman()._appUserFriends;
		//		NSMutableArray* maleNames = [[[NSMutableArray alloc] init] autorelease];
		//		NSMutableArray* femaleNames = [[[NSMutableArray alloc] init] autorelease];
		//		
		//		if (!arrayWithAppUsers || [arrayWithAppUsers count] <= 0)
		//		{
		//			return null;
		//		}
		//		
		//		for(NSDictionary *dict in arrayWithAppUsers)
		//		{
		//			NSString* gender = @"male";
		//			if(dict objectForKey:@"sex"])
		//			{
		//				if([dict objectForKey:@"sex"] instanceof NSNull == NO)
		//				{
		//					gender = (NSString*)[dict objectForKey:@"sex"];
		//				}
		//			}
		//			
		//			NSString *zName = [dict objectForKey:@"name"];
		//			zName = (NSString*)[[zName componentsSeparatedByString: @" "] objectAtIndex:0];
		//			
		//			if (!(zName && [zName length] > 0 && [zName length] <= 10))
		//			{
		//				continue;
		//			}
		//				
		//			if (gender isEqualToString:@"male"])
		//			{
		//				[maleNames addObject:zName];
		//			}
		//			else
		//			{
		//				[femaleNames addObject:zName];
		//			}
		//		}
		//		
		//		NSMutableArray* names = (key isEqualToString:@"female"]) ? femaleNames : maleNames;
		//		
		//		return this.pickRandomNameFromList:names];
	},

	pickRandomNameFromList : function(names) {
		if (!names || names.length <= 0) {
			return null;
		}

		var rUnused = [];

		for ( var i = 0; i < names.length; i++) {
			rUnused.push(i);
		}

		while (rUnused.length) {
			var randIndex = (Math.ceil(Math.random() * rUnused.length) - 1);
			var val = rUnused[randIndex];
			var zName = names[val];
			rUnused.splice(randIndex, 1);

			if (!this.nameHasDupe(zName)) {
				return zName;
			}
		}

		return null;
	},

	nameHasDupe : function(aName) {
		var acm = ZFActorManager;

		for ( var key in acm._actorList) {
			var z = acm._actorList[key];

			if (!z instanceof ZombieActor) // TODO : Test the beginning of the string, as the objC method was isKindOfClass
			{
				continue;
			}

			if (z._name == aName) {
				return true;
			}
		}

		return false;
	},

	getRank : function() {
		var rank = (this._fights > ZFGameDefines.ZOMBIE_RANK_CAP) ? ZFGameDefines.ZOMBIE_RANK_CAP : this._fights;
		return rank;
	},

	isInMeleeRange : function() {
		// doesn't count if they're stunned (should fix this sometime)
		// can't fight if not in melee
		if (this.actorIsFighting())
			return true;
		if ( this._ccPosition._x == this._destinationPoint._x && this._ccPosition._y == this._destinationPoint._y && this._fightData._knockBackPoint._x == 0 && this._fightData._knockBackPoint._y == 0 ){
			// if zombie is at its destination point and no knockback point exists
			// gotta figure out a way to stop them while knocked back
			// check if not in certain conditions such as prepstart // prepcycle // wait
			var state = this._state;
			if (!(state == kActorFightStateWait || state == kActorFightStatePrepStart || state == kActorFightStatePrepCycle
					|| state == kActorFightStateFightWall || state == kActorFightStateGo
					|| state == kActorFightStateUsingAbilityAtRange || state == kActorFightStateExitMelee
					|| state == kActorFightStateFightBossWall || state == kActorFightStateFightingBossWall
					|| state == kActorFightStateRunAway || state == kActorFightStateRunningAway || state == kActorFightStateRanAway
					|| state == kActorFightStateGrabbed || state == kActorFightStateFall || state == kActorFightStateFalling
					|| state == kActorFightStateFell || state == kActorFightStateGrab)) {
				return true;
			}
		}
		return false;
	},

	unlockActorSpecificAbilities : function() {
		var gs = GameState;
		var lifeForce = gs.getLuck();

		// a.unlocked = NO at this point (from init)

		for (key in this._abilityList) {
			var a = this._abilityList[key];

			if (lifeForce >= a._requiredLifeForce && gs._zfGameData._abilityFlags.hasFlag(a._flagBit)) {
				a._unlocked = true;
			}
		}

	},

	wallCollision : function() {
		zombieOffset = 0;
		var zombieX = (this._ccPosition._x + (this._zombieW + zombieOffset));

		var wallX = fm._wall._sprite._ccPosition._x - (fm._wall._contentSize._width / 2);
		var wallX2 = wallX + fm._wall._contentSize._width;

		if (zombieX >= wallX && zombieX <= wallX2) {
			this.setPosition(wallX - (this._zombieW + zombieOffset), this._ccPosition._y);
			this.setState(kActorFightStateFightWall);
			return;
		}
//
//		if (zombieX < wallX) {
//			this._lastX = zombieX;
//			return;
//		}
//
//		if (zombieX > wallX2 && this._lastX < wallX) {
//			this.setPosition(wallX - (this._zombieW + 20) * this._widthScale, this._ccPosition._y);
//			this.setState(kActorFightStateFightWall);
//		}

	},
	
	bossWallCollision : function(right) {
		zombieOffset = 0;
		var zombieX = (this._ccPosition._x + (this._zombieW + zombieOffset));

		var wallX = fm._bossWall._ccPosition._x - (100);
		var wallX2 = wallX + 200;
		
		if (zombieX >= wallX && zombieX <= wallX2) {
			var px = 0;
			if(!right){
				px = wallX - (this._zombieW + zombieOffset);
				this.setPosition(px, this._ccPosition._y);
			}		
			this.setState(kActorFightStateFightingBossWall);
			return true;
		}
		return false;
//
//		if (zombieX < wallX) {
//			this._lastX = zombieX;
//			return;
//		}
//
//		if (zombieX > wallX2 && this._lastX < wallX) {
//			this.setPosition(wallX - (this._zombieW + 20) * this._widthScale, this._ccPosition._y);
//			this.setState(kActorFightStateFightWall);
//		}

	},
	
	generateName : function() {
		return "Sam"; //default name
	},
	
	initFightUpdateObject : function()
	{
		this._fightUpdateObject[kActorFightStateWait] = function(){
			if (this._ccPosition._x == this._destinationPoint._x && this._ccPosition._x >= 0.0 && !this.isScheduled(this.fightWanderIn)) {
				var duration = Math.random() * 60.0;
				this.schedule(this.fightWanderIn, duration, "fightWanderIn");
			}
//			break;
		}.bind(this);
		
		
		this._fightUpdateObject[kActorFightStateMoveForwardAfterAttack] = function(){
			this.unschedule(this.fightAttack);
			if (!this._fightData._attacking)
				this.setState(kActorFightStateGo);
//			break;
		}.bind(this);
		
		this._fightUpdateObject[kActorFightStateEnterScene] = function(){
//			var p1 = this._ccPosition;
//			var p2 = this._destinationPoint;
			
//			if ( (!p1 && !p2) || (p1 && p2 && (p1._x == p2._x && p1._y == p2._y)) ) {
			if ( this._ccPosition._x == this._destinationPoint._x && this._ccPosition._y == this._destinationPoint._y ) {
				this.setState(kActorFightStateWait);
				this.unschedule(this.fightUpdate);
			}
//			break;
		}.bind(this);
		
		this._fightUpdateObject[kActorFightStateRunAway] = function(){
			this._fightData._invincible = true;

			this._walkingSpeed = this._walkingSpeed + 2;

			this._fightData._knockBackPoint = CGPointMake(0, 0);
			var actionTo = CCFadeOut.actionWithDuration(0.5);
			this._fightData._lifeBG.runAction(actionTo);
			actionTo = CCFadeOut.actionWithDuration(0.5);
			this._fightData._lifeBar.runAction(actionTo);

			this.moveToPoint(ccp(-150, this._ccPosition._y));
			//this._destinationPoint = ccp(-150,this.getPosition()._y);
			this.setState(kActorFightStateRunningAway);
//			break;
		}.bind(this);
		
		this._fightUpdateObject[kActorFightStateRunningAway] = function(){
			if (CGPointEqualToPoint(this._destinationPoint, this._ccPosition)) {
				this.setState(kActorFightStateRanAway);
			}
//			break;
		}.bind(this);
		
		this._fightUpdateObject[kActorFightStateRanAway] = function(){
			// cleans up any anims and calls
			this.stopAllActions();

			// update gui and set dying animation
			fm._zombieCount--;
			fm._zombiesFighting--;
			fm.deploy(1.0);
//			fm.schedule(fm.deploy, 1.0, "ZFFightMan.deploy");
			ZFFightGUI.updateZombieCount();


			fm._zombies.splice(fm._zombies.indexOf(this), 1);

			// have zombies move forward			
			fm.reorderZombies();

			// remove any group buffs
			fm.checkForEffects(this, true);
			this.unscheduleAllSelectors(); // because timers are gone we can't really have another state after this
			this.despawn();
//			return false;
		}.bind(this);
		
		this._fightUpdateObject[kActorFightStateGrab] = function(){
			var fightdata = this._fightData;
			fightdata._lifeBG.stopAllActions();
			fightdata._lifeBar.stopAllActions();
			fightdata._lifeBarTemp.stopAllActions();

			fightdata._lifeBG.setOpacity(0x00);
			fightdata._lifeBar.setOpacity(0x00);
			fightdata._lifeBarTemp.setOpacity(0x00);

			this.setZombieToLastIndex();
			fm.reorderZombies();

			this.setState(kActorFightStateGrabbed);
			//break;
		}.bind(this);
		
		this._fightUpdateObject[kActorFightStateFall] = function(){
			this._originalWalkingSpeed = this._walkingSpeed;

			this._walkingSpeed = -2;

			var floor = ccp(this._ccPosition._x, 0);

			this._destinationPoint = floor;
			this.moveToPoint(this._destinationPoint);

			this._state = kActorFightStateFalling;
//			break;
		}.bind(this);
		
		this._fightUpdateObject[kActorFightStateFalling] = function(){
			// change walkingspeed by certain amount

			// accelerate walkingspeed by time
			var constantAcceleration = 6.0;

			var deltaVelocity = dt * constantAcceleration;

			var newWalkingSpeed = deltaVelocity + this._walkingSpeed;

			this._walkingSpeed = newWalkingSpeed;

			if (CGPointEqualToPoint(this._ccPosition, this._destinationPoint))
				this._state = kActorFightStateFell;
//			break;
		}.bind(this);
		
		this._fightUpdateObject[kActorFightStateFell] = function(){
			this._walkingSpeed = this._originalWalkingSpeed;

			this.setState(kActorFightStateGo);
//			break;
		}.bind(this);
		
		this._fightUpdateObject[kActorFightStateDead] = function(){
			this.unscheduleAllSelectors(/*deactivateTimers*/); // because timers are gone we can't really have another state after this
			this.despawn();
//			return;
		}.bind(this);
		
		this._fightUpdateObject[kActorFightStateDying] = function(){
			if (!this.isScheduled(this.fightDieIn)) {
				// cleans up any anims and calls
				this.stopAllActions();

				var actionTo = CCFadeOut.actionWithDuration(2.0);
				this._fightData._lifeBG.runAction(actionTo);
				actionTo = CCFadeOut.actionWithDuration(2.0);
				this._fightData._lifeBar.runAction(actionTo);

				// update gui and set dying animation
				this._fightData._knockBackPoint = CGPointMake(0, 0);
				this._destinationPoint = this._ccPosition.clone();
				this.schedule(this.fightDieIn, 3.0, "fightDieIn");
				fm._zombieCount--;
				fm._zombiesFighting--;
				fm.deploy(1.0);
//				fm.schedule(fm.deploy, 1.0, "ZFFightMan.deploy");

				ZFFightGUI.updateZombieCount();


				fm._defeatedZombies.push(this);
				fm._zombies.splice(fm._zombies.indexOf(this), 1);
				// have zombies move forward
				fm.reorderZombies();
				// remove any group buffs
				fm.checkForEffects(this, true);
			}
//			break;
		}.bind(this);
		
		this._fightUpdateObject[kActorFightStatePrepStart] = function(){
			//FIXME: Harcoded values for improvement
//			var ini = Core.Time.getRealTime();
			if (this._ccPosition._x == 200 /*ZFGameDefines.FIGHT_PREPSPOT_X*/) {
				this.unschedule(this.fightWanderIn);
				this.setState(kActorFightStatePrepCycle);
				ZFFightGUI.displayThoughtButtonForZombie(this);
//				var ini2 = Core.Time.getRealTime();
			} else if (this._destinationPoint._x != 200 /*ZFGameDefines.FIGHT_PREPSPOT_X*/) {
				this.moveToPoint(200/*ZFGameDefines.FIGHT_PREPSPOT_X*/, this._ccPosition._y);
//				var ini3 = Core.Time.getRealTime();
			}
//			var delta1 = ini2 - ini;
//			var delta2 = ini3 - ini;
//			console.log("PrepStart: delta1 " + delta1);
//			console.log("PrepStart: delta2 " + delta2);
//			break;
		}.bind(this);
		
		this._fightUpdateObject[kActorFightStatePrepCycle] = function(){
//			break;
		}.bind(this);
		
		this._fightUpdateObject[kActorFightStateGo] = function(){
//			var ini1 = Core.Time.getRealTime();
			this.setState(kActorFightStateGoing);
//			var ini2 = Core.Time.getRealTime();
			if (fm.isGameWon()) {
				this.moveToPoint(ccp(1200 * this._widthScale, this._ccPosition._y));
				this.startAnim(kActorAnimVictory, false);
			} else {
				this.moveToPoint(this.calculateDestinationPoint(), true, true);
//				var ini3 =  Core.Time.getRealTime();
			}
			
//			var delta1 = ini2 - ini1;
//			var delta2 = ini3 - ini2;
//			console.log("kActorFightStateGo with state: delta1 " +delta1);
//			console.log("kActorFightStateGo with state: delta2 " +delta2);
			
//			break;
		}.bind(this);
		
		this._fightUpdateObject[kActorFightStateUsingAbility] = function(){
//			break;
		}.bind(this);
		
		this._fightUpdateObject[kActorFightStateStunned] = function(){
			// this.startAnimForState:kActorFightStateStunned);
//			if (!CGPointEqualToPoint(this._ccPosition, this._destinationPoint)) {
				// this zombie has been stunned while walking

//			}
//			break;
		}.bind(this);
		
		this._fightUpdateObject[kActorFightStateExitMelee] = function(){
			if (CGPointEqualToPoint(this._ccPosition, this._destinationPoint)
					&& CGPointEqualToPoint(this._fightData._knockBackPoint, CGPointMake(0, 0))) {
				this.setState(kActorFightStateUsingAbilityAtRange);
				this.flipActor(true, true); // face right
				fm.reorderZombies();
			}
//			break;
		}.bind(this);

		this._fightUpdateObject[kActorFightStateGoing] = function(){
			var p1 = this._ccPosition;
			var p2 = this._destinationPoint;
			var p3 = this._fightData._knockBackPoint;
			var p4 = {_x:0, _y:0};
			
			if ( (p1._x == p2._x && p1._y == p2._y)	&& ((!p3 && !p4) || (p3 && p4 && (p3._x == p4._x && p3._y == p4._y)))) {
				this.setState(kActorFightStateEnterFight);
			} else {
				if (fm._wall && fm._wall._hitPoints > 0) {
					this.wallCollision();
				}
				if (fm._bossWall && fm._bossWall._fightData  && fm._bossWall._fightData._hitPoints > 0){
					this.bossWallCollision();
//					this.setState(kActorFightStateFightingBossWall);
				}
			}
//			break;
		}.bind(this);

		this._fightUpdateObject[kActorFightStateFightWall] = function(){
			if (fm._wall && fm._wall._hitPoints > 0) {
				this.moveToPoint(this._ccPosition);
				this.setAttackVariation();
				if (!this.isScheduled(this.fightAttackWall) && !this._fightData._attacking) {
					this.schedule(this.fightAttackWall, 0, "fightWallAttack");
				}
			} else {
				this.unschedule(this.fightAttackWall);
				this.setState(kActorFightStateGo);
			}
//			break;
		}.bind(this);

		this._fightUpdateObject[kActorFightStateGoFightBossWall] = function(){
			if (this.isScheduled(this.fightAttack))
				this.unschedule(this.fightAttack);
			if (!this._fightData._attacking)
				this.setState(kActorFightStateFightBossWall);
			
			//TODO: should i call this._fightUpdateObject[kActorFightStateFightBossWall] instead?
//			if (fm._bossWall && fm._bossWall_fightData._hitPoints > 0) {
//				if (fm._bossWall._ccPosition._x == this._ccPosition._x)
//					this.moveToPoint(ccp(this._ccPosition._x, fm._bossWall._ccPosition._y));
//				else
//					this.moveToPoint(ccp(fm._bossWall._ccPosition._x, this._ccPosition._y));
//			} else {
//				this.setState(kActorFightStateGo);
//			}
//			break;
		}.bind(this);

		this._fightUpdateObject[kActorFightStateFightBossWall] = function(){
			if (fm._bossWall && fm._bossWall._fightData._hitPoints > 0) {
				if (!this.bossWallCollision(true))//{
					this.moveToPoint(ccp(fm._bossWall._ccPosition._x + 50, this._ccPosition._y));
//				}
//				else
//					this.moveToPoint(ccp(fm._bossWall._ccPosition._x+100, this._ccPosition._y));		
			} else {
				this.setState(kActorFightStateGo);
			}
//			break;
		}.bind(this);

		this._fightUpdateObject[kActorFightStateFightingBossWall] = function(){
			if (this._thought != this.zombieThoughts.kZombieThoughtNothing) {
				this.setThought(this.zombieThoughts.kZombieThoughtNothing);

			}

			this.moveToPoint(this._ccPosition);

			if (fm._bossWall && fm._bossWall._fightData._hitPoints > 0) {
				
				if (fm._bossWall._ccPosition._x < this._ccPosition._x)
					this.flipActor(false); // face left
				else
					this.flipActor(true); // face right
				
				this._fightData._opponent = fm._bossWall;
				var opponentData = fm._bossWall._fightData;

				// if opponent is still alive and im not attacking, then hit him
				if (!this._fightData._attacking) {
					if (opponentData && opponentData._hitPoints > 0) {
						//choose attack variation
						this.setAttackVariation();

						this.schedule(this.fightAttack, 0, "fightAttack");
					} else {
						this._fightData._opponent = null;
						this.unschedule(this.fightAttack);
					}
				}
			} else {
				this._fightData._opponent = null;
				this.setState(kActorFightStateGo);
			}
//			break;
		}.bind(this);

		this._fightUpdateObject[kActorFightStateEnterFight] = function(){
			if (this._thought != this.zombieThoughts.kZombieThoughtNothing) {
				this.setThought(this.zombieThoughts.kZombieThoughtNothing);
			}
//			break;
		}.bind(this);

		this._fightUpdateObject[kActorFightStateFight] = function(){
			if (this._thought != this.zombieThoughts.kZombieThoughtNothing) {
				this.setThought(this.zombieThoughts.kZombieThoughtNothing);
			}
			if (this._fightData._opponent) {
				// check for not attacking because zombies can be healers also (which sets attacking to YES)
				if (this._fightData._opponent._fightData && this._fightData._opponent._fightData._hitPoints > 0 && !this._fightData._attacking) {
					this.setState(kActorFightStateFighting);

					this.setAttackVariation();

					if (this._fightData._opponent._ccPosition._x > this._ccPosition._x)
						this.flipActor(true, true);
					else
						this.flipActor(false, true);
					this.schedule(this.fightAttack, Math.floor(Math.random() * 0.25), "fightAttack"); //1st attack has a random delay

				} else {
					//clear opponent
					this._fightData._opponent = null;
				}
			}
//			break;
		}.bind(this);
		
		this._fightUpdateObject[kActorFightStateFighting] = function(){
			if (this._thought != this.zombieThoughts.kZombieThoughtNothing) {
				this.setThought(this.zombieThoughts.kZombieThoughtNothing);
			}

			if (!this._fightData._opponent) {
				this.setState(kActorFightStateFight);
			} else {
				var opponentData = this._fightData._opponent._fightData;

				if (!opponentData) {
					this._fightData._opponent = null;
				}
				//fightData if opponent is still alive and im not attacking, then hit him
				if (!this._fightData._attacking) {
					if (opponentData && opponentData._hitPoints > 0) {
						//choose attack variation
						this.setAttackVariation();

						this.schedule(this.fightAttack, 0, "fightAttack");
					} else {
						this._fightData._opponent = null;
						this.unschedule(this.fightAttack);
						this.setState(kActorFightStateFight);
					}
				}
			}
//			break;
		}.bind(this);
		
		this._fightUpdateObject[kActorFightStateUsingAbilityAtRange] = function(){
			// handled by the actor
			if (this._thought != this.zombieThoughts.kZombieThoughtNothing) {
				this.setThought(this.zombieThoughts.kZombieThoughtNothing);
			}
//			break;
		}.bind(this);
		
	},
	
	initAnimForStateObject : function()
	{
		this._animForStateObject[kActorFightStateStunned] = kActorAnimIdea;
		this._animForStateObject[kActorStateDormant] = kActorAnimSleeping;
		this._animForStateObject[kActorFightStateDying] = kActorAnimDying;
		
		//TODO: Special animation for Zombies that are wating in the farm
		this._animForStateObject[kActorStateIdle] = kActorAnimIdle;
		
		this._animForStateObject[kActorFightStateWait] = kActorAnimIdle;
		this._animForStateObject[kActorFightStateEnterFight] = kActorAnimIdle;
		this._animForStateObject[kActorFightStateUsingAbility] = kActorAnimIdle;
		this._animForStateObject[kActorFightStateUsingAbilityAtRange] = kActorAnimIdle;
		this._animForStateObject[kActorFightStatePrepCycle] = kActorAnimIdle;
		this._animForStateObject[kActorFightStateFight] = kActorAnimIdle;
		
		this._animForStateObject[kActorFightStatePrepStart] = kActorAnimWalkSimple;
		this._animForStateObject[kActorFightStateEnterScene] = kActorAnimWalkSimple;
		
		this._animForStateObject[kActorStateWalking] = kActorAnimWalk;
		this._animForStateObject[kActorFightStateRunAway] = kActorAnimChase;
		this._animForStateObject[kActorFightStateRunningAway] = kActorAnimChase;
		this._animForStateObject[kActorFightStateExitMelee] = kActorAnimChase;
		this._animForStateObject[kActorFightStateGoing] = kActorAnimChase;
		
		this._animForStateObject[kActorFightStateFall] = kActorAnimVictory;
		this._animForStateObject[kActorFightStateFalling] = kActorAnimVictory;
		this._animForStateObject[kActorFightStateFell] = kActorAnimVictory;
		this._animForStateObject[kActorFightStateGrab] = kActorAnimVictory;
		this._animForStateObject[kActorFightStateGrabbed] = kActorAnimVictory;
	},
	
	copyWithZone: function (/*NSZone **/ zone)
	{
		var copy = new this.constructor();
	    
	    // Actor specific
	    this.copyActorData(copy,zone);
	    
	    // ZombieActor specific
	    copy._name = this._name;
		return copy;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGardenCupid'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGardenCupid'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGardenCupid'] = exports; var ZombieActorGarden = require('Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGarden').ZombieActorGarden;

exports.ZombieActorGardenCupid = ZombieActorGarden.subclass(
{
	classname: 'ZombieActorGardenCupid',

	initialize: function($super)
	{
		$super();
		this._tier = 0;
	},

	initSprite: function( $super )
	{
		$super();
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFeatures, this._spriteDictionary["cupidFeature"]);
		this._attachments[kActorPartTagFeatures]._inheritColor = false;
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagButt, this._spriteDictionary["cupidWings"]);
		this._attachments[kActorPartTagButt]._inheritColor = false;
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagBody, this._spriteDictionary["cupidBody"]);
		this._attachments[kActorPartTagBody]._inheritColor = false;
	},

	heal: function()
	{
		var healSpeed = 1; // heal speed separate from attack speed
		var healThisZombie = this.getZombieToHeal();
		
		if( healThisZombie )
		{
			this._fightData._attacking = true;
			
			// have heal animation somewhere
			// using a CCCallFuncND so that stuns can interrupt this action as well as the animation
			this.runAction(
					CCSequence.actions(
							new Array ( CCDelayTime.actionWithDuration(healSpeed*0.8),
										CCCallFuncND.actionWithTarget(this, this.data, healThisZombie) )
					)
			);

			this.startAnim( kActorAnimHeal, true );

			this.schedule( this.doneAttacking, healSpeed, "doneAttacking");
			this.shootArrowAt(healThisZombie.getPosition(), healSpeed*0.8);

			return true;
		}
		else 
		{
			this._fightData._attacking = false;
			return false;
		}
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGarden'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGarden'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGarden'] = exports; var ZombieActor = require('Code/Game/Actor/Types/Zombies/ZombieActor').ZombieActor;

exports.ZombieActorGarden = ZombieActor.subclass({
    classname : 'ZombieActorGarden',
    
    kTag : {
        kZombieActorGardenTagArrow : 1337
    },
    
    initialize : function($super)
    {
        $super();
        this._tier = 0;
    },
    
    initSprite : function($super)
    {
        $super();
        this._spriteMan.setScale(0.7, 0.7);
        this._priority = 0;
    },
    
    talk : function()
    {
        SimpleAudioEngine.playEffect(kZombieGardenBrain);
    },
    
    fightAttackAnim : function(dt)
    {
        this.unschedule(this.fightAttackAnim);
        if (this._state != kActorFightStateDying && this._state != kActorFightStateDead)
        {
            this.startAnim(kActorAnimAttackBite, true);
        }
    },
    
    generateName : function()
    {
        return this.generateNameWithKey("male");
    },
    
    initActorSpecificAbilities : function()
    {
        // clear the list
        if (this._abilityList)
        {
            
            this._abilityList = null;
            this._abilityList = [];
        }
        
        var abilityLevel = 0;
        switch (this.classname)
        {
            case "ZombieActorGardenTier1":
                abilityLevel = 1;
                break;
            case "ZombieActorGardenTier2":
                abilityLevel = 2;
                break;
            case "ZombieActorGardenTier3":
                abilityLevel = 3;
                break;
            case "ZombieActorGardenTier4":
            case "ZombieActorGardenCupid":
                abilityLevel = 4;
                break;
        }
        
        switch (abilityLevel)
        {
            case 4: {
                var ability = new ZFActorActivatedAbility();
                ability.initWithTag(kActorActivatedAbilityTagHealAOE);
                this._abilityList.splice(0, 0, ability);
            }
                
            case 3: {
                var ability = new ZFActorActivatedAbility();
                ability.initWithTag(kActorActivatedAbilityTagRessurect);
                this._abilityList.splice(0, 0, ability);
            }
                
            case 2: {
                var ability = new ZFActorFightEffect();
                ability.initWithTag(kFightEffectTankHitPointsBuff);
                this._abilityList.splice(0, 0, ability);
            }
                
            case 1: {
                var ability = new ZFActorFightEffect();
                ability.initWithTag(kActorActivatedAbilityTagHeal);
                this._abilityList.splice(0, 0, ability);
            }
        }
        
        this.unlockActorSpecificAbilities();
    },
    
    // overwriting ... if not attacking and heal ability is unlocked ... setup a heal
    fightUpdate : function($super, dt)
    {
        if (this._state != kActorFightStateDead && this._state != kActorFightStateDying)
        {
            
            if ((this.isInMeleeRange() || this._state == kActorFightStateGoing) &&
                 this._state != kActorFightStateStunned && !this._fightData._attacking)
            {
                if (this.canHeal() || this.canRez())
                {
                    this.setState(kActorFightStateExitMelee);
                    
                    this._destinationPoint = ccpAdd(this._destinationPoint, ccp(-120, 0));
                    if (this._destinationPoint._x < this.getPosition()._x)
                        this.flipActor(false); // should face left
                    else
                        this.flipActor(true);
                }
            }
            
            if (this._state == kActorFightStateUsingAbilityAtRange && !this._fightData._attacking)
            {
                // check abilities again and make sure you can use it
                if (this.canRez())
                {
                    this.ressurectZombie(this);
                }
                else if (this.canHeal())
                {
                    this.heal();
                }
                else
                {
                    this.setState(kActorFightStateGo);
                }
            }
            
        }
        
        $super(dt);
    },
    
    getZombieToHeal : function()
    {
        var fm = ZFFightMan;
        var damagedZombie = null;
        
        // if enemy exists and enemy has a target with 50% hp or less ... then damagedZombie equals target
        if (fm._zombies && fm._zombies.length > 0)
        {
        	var length = fm._zombies.length;
        	for ( var i = 0; i < length; ++i)
            {
                var z = fm._zombies[i];
	            // can't heal yourself
	            if (z == this)
	            {
	                continue;
	            }
	            
	            // you can only heal zombies that are hurt
	            // choose zombie to heal based on damage
	            if ((z.isInMeleeRange() || (z._state == kActorFightStateMoveForwardAfterAttack && z._fightData._attacking) ||
	                 z._state == kActorFightStateGo || z._state == kActorFightStateGoing) && z._fightData._hitPoints > 0 &&
	                 z._fightData._hitPoints < z._fightData._finalHitPointsTotal)
	            {
	                // if damagedZombie is null
	                if (!damagedZombie)
	                {
	                    damagedZombie = z;
	                }
	                // if z's hp is less than or equal to tempZombie then replace tempZombie with z 
	                else if (z._fightData._hitPoints <= damagedZombie._fightData._hitPoints)
	                {
	                    damagedZombie = z;
	                }
	            }
	        }
        }
        
        if (fm._enemy && fm._enemy._fightData._opponent && fm._enemy._fightData._opponent._fightData._hitPoints > 0 &&
            fm._enemy._fightData._opponent != this && (fm._enemy._fightData._opponent._fightData._hitPoints / fm._enemy._fightData._opponent._fightData._finalHitPointsTotal) <= 0.5)
        {
            damagedZombie = fm._enemy._fightData._opponent;
        }
        
        return damagedZombie;
    },
    
    healAOE : function(sender)
    {
        // the fact that this ability was called is proof enough that healAOE is active
        var healAOE = this.getAbilityByTag(kActorActivatedAbilityTagHealAOE);
        
        // refresh timers on healAOE -> gets shut off in fightMan
        healAOE.refreshTimers();
          
        var fm = ZFFightMan;
        
        // emitter effect where self is
        /*
        var emitter = CCQuadParticleSystem.particleWithFile( "healAOE.plist" );
        emitter._autoRemoveOnFinish = true;
        emitter.setPosition(this.getPosition().clone());
        fm.getParent().addChild( emitter , 199 );*/

        // emitter will remove itself after duration is finished
        for ( var i in fm._zombies)
        {
        	var z = fm._zombies[i];
            // heals ALL hurt zombies ... not just zombies in melee range
            
            // heal happens every 20 seconds 
            // every 1 second 1 heal = 1/2 attack = dps = hps
            // hps is = to dps because heals happen twice as fast
            
            // 20s of healing ... normal heal is healing for 10 attacks (have aoe heal do the same amount)
            var healingPower = this._fightData._finalPower * 0.5;
            if (z._fightData._hitPoints < z._fightData._finalHitPointsTotal)
            {
                z.heal(healingPower);
            }
        }
    },
    
    canHeal : function()
    {
        var heal = this.getAbilityByTag(kActorActivatedAbilityTagHeal);
        var zombieToHeal = null;
        
        if (heal && heal._active && heal._unlocked)
        {
            zombieToHeal = this.getZombieToHeal();
        }
        
        if (zombieToHeal)
        {
            return true;
        }
        
        return false;
    },
    
    canRez : function()
    {
        var rez = this.getAbilityByTag(kActorActivatedAbilityTagRessurect);
        var deadZombie = null;
        
        if (rez && rez._active && rez._unlocked)
        {
            var fm = ZFFightMan;
            
            for ( var key in fm._defeatedZombies)
            {
            	var z = fm._defeatedZombies[key];
                // don't rez if in the middle of dying
                if (z._state != kActorFightStateDying)
                {
                    deadZombie = z;
                }
            }
        }
        
        if (deadZombie)
        {
            return true;
        }
        
        return false;
    },
    
    heal : function()
    {
        var healSpeed = 1; // heal speed separate from attack speed
        var healThisZombie = this.getZombieToHeal();
        
        if (healThisZombie)
        {
            this._fightData._attacking = true;
            
            // have heal animation somewhere
            // using a CCCallFuncND so that stuns can interrupt this action as well as the animation
            this.runAction(CCSequence.actions([ CCDelayTime.actionWithDuration(healSpeed * 0.8), CCCallFuncND.actionWithTarget(this, this.healZombie, healThisZombie) ]));
            this.startAnim(kActorAnimHeal, true);
            this.schedule(this.doneAttacking, healSpeed, "doneAttacking");
            return true;
            
        }
        else
        {
            this._fightData._attacking = false;
            return false;
        }
    },
    
    healZombie: function(sender,zombie)
    {
        // if zombie is not "dead" and zombie is hurt
        var healingPower = this._fightData._finalPower * 0.5;
        /* var emitter = CCQuadParticleSystem.particleWithFile("healSingle.plist");
        emitter._autoRemoveOnFinish = true;
        emitter.setPosition( zombie.getPosition().clone() );*/

//        var fm = ZFFightMan;
//        fm.getParent().addChild(emitter, 199);
        
        zombie.heal(healingPower);
    },
    
    shootArrowAt : function(target, actionSpeed)
    {
        var arrow = CCSprite.spriteWithFile("cupidArrow.png");
        arrow.setPosition(ccpAdd(this.getPosition(), ccp(0, 30)));
        arrow.setScale(0.7, 0.7);
        var flip = (this.getPosition()._x < target._x) ? 1 : -1;
        
        this._spriteMan.getParent().addChild(arrow, this._spriteMan._zOrder);
        
        arrow.runAction(CCSpawn.actions([
                CCSequence.actions([ CCJumpTo.actionWithDuration(1, ccpAdd(target, ccp(0, 20)), 100, 1),
                                     CCCallFuncND.actionWithTarget(this, this.removeArrow.bind(this), arrow) ]),
                CCRotateBy.actionWithDuration(actionSpeed, 170 * flip) ]));
    },
    
    removeArrow : function(sender, arrow)
    {
        /* TODO: particle system
        var emitter = CCQuadParticleSystem.particleWithFile("cupidArrowEffect.plist");
        emitter._autoRemoveOnFinish = true;
        emitter.setPosition(arrow.getPosition().clone());
        this._spriteMan.getParent().addChild( emitter, 199 );

        arrow.getParent().removeChild(arrow, true);*/
    },
    
    ressurectZombie : function(sender)
    {
        var fm = ZFFightMan;
        var acm = ZFActorManager;
        var deadZombie = null;
        
        //TODO: Obtain the last zombie directly
        for ( var key in fm._defeatedZombies)
        {
        	var z = fm._defeatedZombies[key];
            deadZombie = z;
        }
        
        
        if (deadZombie)
        {   
        	this._fightData._attacking = true;
            //////////// initial spawn stuff ///////////////
            
            // doing some crazy ugly stuff
            
            // copy all the zombies
            var index = 0;
            var zombiesTemp = [].concat(fm._zombies);
            
            // now loop through
            for ( var key in zombiesTemp)
            {
            	var z = zombiesTemp[key];
                // check if the zombie is still waiting for a destination point (i.e. it's waiting to be deployed) 
                if (z._state == kActorFightStateWait || z._state == kActorFightStatePrepCycle || z._state == kActorFightStatePrepStart)
                {
                    break;
                }
                
                index++;
            }
            
            if (index >= zombiesTemp.length)
            {
                zombiesTemp.push(deadZombie);
            }
            else
            {
                zombiesTemp.splice(index, 0, deadZombie);
            }
            
            // now use the zombiesTemp array to set the array
            fm.setZombieYOrder(zombiesTemp);
            
            // we are setting its default position 
            //TODO convert:
//            var zombiePosition = fm._yOrder[zombiesTemp.indexOf(deadZombie)];
            zombiesTemp.length = 0;
            zombiesTemp = null;
            
//            var i = zombiePosition._y;
            var posx = this.getPosition()._x - Math.random() * 100;
//            var posy = ((i % fm._zombies.length) * 2) - 5; // used to be modulo 10
            var posy = this.getPosition()._y;
            var order = 3;
            order += fm._zombies.length + 10;
            
            //spawn in middle and have some animation effect
            var zombie = acm.spawnFightActor(deadZombie.classname, ccp(posx, posy), fm.getParent(), order);
//            zombie.movementUpdate(0.03);
            zombie.resetActionData();
            zombie._dying = false;
            
            zombie.setHunger(deadZombie._doppleganger._hunger);
            zombie._eatDate = deadZombie._doppleganger._eatDate;
            zombie._fights = deadZombie._doppleganger._fights;
            zombie._doppleganger = deadZombie._doppleganger;
            
            zombie.addMutation(deadZombie._doppleganger._flags);
            zombie.flipActor(true);
            zombie._savedColor = deadZombie._doppleganger._savedColor;
//            zombie._spriteMan.setScale(zombie._spriteMan.getScale()._x * this._widthScale);
            zombie._spriteMan.setScale(zombie._spriteMan.getScale()._x * fm._widthScale, zombie._spriteMan.getScale()._y * fm._widthScale);
            
            if (index >= fm._zombies.length)
            {
                fm._zombies.push(zombie);
            }
            else
            {
                fm._zombies.splice(index, 0, zombie);
            }
            
            // for fight buffs --- consume all consumable abilities such as rez
            for ( var key in zombie._abilityList)
            {
            	var ability = zombie._abilityList[key];
                if (ability._consumable)
                    ability._consumed = true;
            }
            zombie.resetColor();
            
            // consume own rez
            var rez = this.getAbilityByTag(kActorActivatedAbilityTagRessurect);
            rez._consumed = true;
            rez._active = false;
            
            // just in case
            zombie.stopAllActions();
            if (zombie.isScheduled(zombie.fightWanderIn))
                zombie.unschedule(zombie.fightWanderIn);
            
            // zombie should not be targeted if he's using an ability 
            // ... enemy will wail on you though if you're already a target 
            zombie.setState(kActorFightStateUsingAbility);
            
            // zombie can't be interrupted when he's rezzed
            zombie.setInterrupt(false);
            
            // have zombie set his own state (so zombie doesn't get stuck when rezzer dies)
            zombie.runAction(CCSequence.actions([ CCCallFuncND.actionWithTarget(zombie, zombie.callStartAnim.bind(zombie), kActorAnimVictory), CCDelayTime.actionWithDuration(2),
                    CCCallFuncND.actionWithTarget(zombie, zombie.callSetState.bind(zombie), kActorFightStateGo), CCCallFuncND.actionWithTarget(zombie, zombie.setInterrupt, true)]));
            
            if (zombie.isScheduled(zombie.fightWanderIn))
                zombie.unschedule(zombie.fightWanderIn);
            
            fm._zombieCount++;
            ZFFightGUI.updateZombieCount();
            
            fm._defeatedZombies.splice(fm._defeatedZombies.indexOf(deadZombie), 1);
            
            this._fightData._attacking = false;
            var rezEffect = CCColorLayer.layerWithColor(ccc3(0xff, 0xff, 0xff), 100 * this._widthScale, 1500);
//                            CCColorLayer.layerWithColor(ccc3(0xff,0x0,0x0), this._laser._distance, 6);
            rezEffect.setScale(0, rezEffect.getScale()._x);
            rezEffect.setPosition(ccp(zombie.getPosition()._x - 50 * this._widthScale, rezEffect.getPosition()._y));
            
            fm.getParent().addChild(rezEffect, order - 1);
            
            rezEffect.runAction(CCSpawn.actions([ CCSequence.actions([ CCScaleTo.actionWithDuration(0.2, 1, 1), CCScaleTo.actionWithDuration(1.3, 0, 1) ]),
                    CCSequence.actions([ CCDelayTime.actionWithDuration(0.2), CCFadeTo.actionWithDuration(1.3, 0), CCCallFuncND.actionWithTarget(this, this.cleanupNode2, rezEffect) ]), ]));
            //SFX
            SimpleAudioEngine.playEffect(kRezSFX);
            
            fm._zombiesFighting++;
        }
    },
    
    cleanupNode2 : function(data) {
		if (data && data._parent) {
			data._parent.removeChild(data, true);
		}
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGardenTier1'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGardenTier1'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGardenTier1'] = exports; var ZombieActorGarden = require('Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGarden').ZombieActorGarden;

exports.ZombieActorGardenTier1 = ZombieActorGarden.subclass(
{
	classname: 'ZombieActorGardenTier1',

	initialize: function($super)
	{
		$super();
		this._tier = 1;
	},

	initSprite: function( $super )
	{
		$super();
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFeatures, this._spriteDictionary["gnomeFeature"]);
		this._attachments[kActorPartTagFeatures]._inheritColor = false;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGardenTier2'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGardenTier2'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGardenTier2'] = exports; var ZombieActorGarden = require('Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGarden').ZombieActorGarden;

exports.ZombieActorGardenTier2 = ZombieActorGarden.subclass(
{
	classname: 'ZombieActorGardenTier2',

	initialize: function($super)
	{
		$super();
		this._tier = 2;
	},

	initSprite: function( $super )
	{
		$super();
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFeatures, this._spriteDictionary["nerdFeature"]);
		this._attachments[kActorPartTagFeatures]._inheritColor = false;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGardenTier3'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGardenTier3'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGardenTier3'] = exports; var ZombieActorGarden = require('Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGarden').ZombieActorGarden;

exports.ZombieActorGardenTier3 = ZombieActorGarden.subclass(
{
	classname: 'ZombieActorGardenTier3',

	initialize: function($super)
	{
		$super();
		this._tier = 3;
	},

	initSprite: function( $super )
	{
		$super();
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFeatures, this._spriteDictionary["sunflowerFeature"]);
		this._attachments[kActorPartTagFeatures]._inheritColor = false;

		for ( var key in this._attachments )
		{
			var a = this._attachments[ key ];

			if(a == null)
				continue;
			
			if (a._tag == kActorPartTagArmF)
			{
				a._sprite.setOpacity(0);
			}
			
			if (a._tag == kActorPartTagFeatures)
			{
				a.setScale(1.5, 1.5);
				a._sprite.setScale(1.5, 1.5);
			}
			
			if (a._tag == kActorPartTagJaw)
			{
				a._sprite.setVisible(true);
			}
		}
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGardenTier4'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGardenTier4'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGardenTier4'] = exports; var ZombieActorGarden = require('Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGarden').ZombieActorGarden;

exports.ZombieActorGardenTier4 = ZombieActorGarden.subclass(
{
	classname: 'ZombieActorGardenTier4',

	initialize: function($super)
	{
		$super();
		this._tier = 4;
	},

	initSprite: function( $super )
	{
		$super();
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFeatures, this._spriteDictionary["beeFeature"]);
		this._attachments[kActorPartTagFeatures]._inheritColor = false;
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagButt, this._spriteDictionary["beeButt"]);
		this._attachments[kActorPartTagButt]._inheritColor = false;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirl'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirl'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirl'] = exports; var ZombieActor = require('Code/Game/Actor/Types/Zombies/ZombieActor').ZombieActor;

exports.ZombieActorGirl = ZombieActor.subclass(
{
	classname: 'ZombieActorGirl',

	initialize: function()
	{
		this._tier = 0;
	},

	initSprite: function( $super )
	{
		$super();
		this._spriteMan.setScale(0.8, 0.8);

		this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagBody, this._spriteDictionary["girlBody"]);

		// set priority
		this._priority = 1;
	},

	talk: function()
	{
		SimpleAudioEngine.playEffect( kZombieGirlBrain );
	},

	fightAttackAnim: function( dt )
	{
		this.unschedule( this.fightAttackAnim.bind( this ) );
		
		if (this._state != kActorFightStateDying &&
			this._state != kActorFightStateDead )
		{
			// TODO : Relies on ZFAttackAnims.
			//this.startAnim( kActorAnimAttackBite , true );
		}
	},

	generateName: function()
	{
		return this.generateNameWithKey( "female" );
	},

	damageIn: function($super, dt)
	{
//		return;
		var fm = ZFFightMan;

		var doubleStrikeAbility = this.getAbilityByTag(kActorActivatedAbilityTagDoubleStrike); 
		var doubleStrikeRand = Math.random();
//		doubleStrikeRand = 1;
		var doubleStriking = (this._fightData._currentAttackVariation == fm._allAttacks["ZombieDoubleStrike"]);

		if(doubleStrikeAbility && doubleStrikeAbility._active && doubleStrikeRand > 0.7) 
		{
			this._fightData._specialAttack = fm._allAttacks["ZombieDoubleStrike"];
		}	

		// the first hit
		$super(dt);

		if(this._state == kActorFightStateFighting &&
			this._fightData._opponent)
		{
			//var emitter = CCQuadParticleSystem.particleWithFile("strike.plist");

			var stunAbility = this.getAbilityByTag(kActorActivatedAbilityTagStun);
			var stunRand = Math.random();
//			stunRand = 1;
			
			// DO NOT STUN IF DOUBLE STRIKE !!! 
			// also do not stun if in 2nd column or further ... just gets ridiculous
			var column = Math.floor(fm._zombies.indexOf(this)/5);
			
			if( (!doubleStriking) && 
				(!(column >= 2)) &&
				stunAbility &&
				stunAbility._active &&
				stunRand > 0.95 &&
				this._fightData._opponent._state != kActorFightStateStunned)
			{
				// stun needs to check for hp because damage function was called (i.e. opponent could be dead)
				// some checks are done inside stun function (i.e. opponent must be alive and interruptable)
				this._fightData._opponent.stunSelfFor(1);		
			}
		}
	},

	initActorSpecificAbilities: function()
	{
		// clear the list
		if( this._abilityList)
		{
		    this._abilityList.length = 0;
			this._abilityList = null;
			this._abilityList = [];
		}
		
		var abilityLevel = 0;
		switch( this.classname )
		{
			case "ZombieActorGirlTier1": abilityLevel = 1; break;
			case "ZombieActorGirlTier2": abilityLevel = 2; break;
			case "ZombieActorGirlTier3": abilityLevel = 3; break;
			case "ZombieActorGirlTier4": abilityLevel = 4; break;
		}
		
		switch ( abilityLevel )
		{
			case 4: 
			{	
				var ability = new ZFActorActivatedAbility();
				ability.initWithTag( kActorActivatedAbilityTagDoubleStrike );
				this._abilityList.splice( 0, 0, ability );
			}
			
			case 3: 
			{
				var ability = new ZFActorActivatedAbility();
				ability.initWithTag( kActorActivatedAbilityTagStun );
				this._abilityList.splice( 0, 0, ability );
			}
			
			case 2: 
			{
				var ability = new ZFActorFightEffect();
				ability.initWithTag( kFightEffectGrace );
				this._abilityList.splice( 0, 0, ability );
			}
			
			case 1: 
			{
				var ability = new ZFActorFightEffect();
				ability.initWithTag( kFightEffectSelfBuffSpeed );
				this._abilityList.splice( 0, 0, ability );
			}			
		}

		this.unlockActorSpecificAbilities();
	},

	cleanupSprite: function(sender)
	{
		sender.getParent().removeChild(sender, true);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirlTier1'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirlTier1'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirlTier1'] = exports; var ZombieActorGirl = require('Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirl').ZombieActorGirl;

exports.ZombieActorGirlTier1 = ZombieActorGirl.subclass(
{
	classname: 'ZombieActorGirlTier1',

	initialize: function()
	{
		this._tier = 1;
	},

	initSprite: function( $super )
	{
		$super();
		this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagFeatures, this._spriteDictionary[ "femaleFeature" ] );
		this._attachments[kActorPartTagFeatures]._inheritColor = false;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirlTier2'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirlTier2'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirlTier2'] = exports; var ZombieActorGirl = require('Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirl').ZombieActorGirl;

exports.ZombieActorGirlTier2 = ZombieActorGirl.subclass(
{
	classname: 'ZombieActorGirlTier2',

	initialize: function()
	{
		this._tier = 2;
	},

	initSprite: function( $super )
	{
		$super();
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFeatures, this._spriteDictionary["beautyFeature"]);
		this._attachments[kActorPartTagFeatures]._inheritColor = false;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirlTier3'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirlTier3'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirlTier3'] = exports; var ZombieActorGirl = require('Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirl').ZombieActorGirl;

exports.ZombieActorGirlTier3 = ZombieActorGirl.subclass(
{
	classname: 'ZombieActorGirlTier3',

	initialize: function()
	{
		this._tier = 3;
	},

	initSprite: function( $super )
	{
		$super();
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFeatures, this._spriteDictionary["amazonFeature"]);
		this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagBody, this._spriteDictionary["amazonBody"]);
		this._attachments[kActorPartTagBody]._sprite.setScale(1.1, 1.1);
		this._attachments[kActorPartTagBody].setScale(1.1, 1.1);
		this._attachments[kActorPartTagFeatures]._inheritColor = false;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirlTier4'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirlTier4'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirlTier4'] = exports; var ZombieActorGirl = require('Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirl').ZombieActorGirl;

exports.ZombieActorGirlTier4 = ZombieActorGirl.subclass(
{
	classname: 'ZombieActorGirlTier4',

	initialize: function()
	{
		this._tier = 4;
	},

	initSprite: function( $super )
	{
		$super();
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFeatures, this._spriteDictionary["locksFeature"]);
		this._attachments[kActorPartTagFeatures]._inheritColor = false;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadless'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadless'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadless'] = exports; var ZombieActor = require('Code/Game/Actor/Types/Zombies/ZombieActor').ZombieActor;

exports.ZombieActorHeadless = ZombieActor.subclass(
{
	classname: 'ZombieActorHeadless',

	initialize: function($super)
	{
		$super();
		this._tier = 0;
	},

	initSprite: function( $super )
	{
		$super();
		this._spriteMan.setScale( 1.1 , 1.1 );

		for ( var key in this._attachments )
		{
			var a = this._attachments[ key ];

			if (a == null)
				continue;

			if (a._tag == kActorPartTagHead ||
				(			a._tag > kActorPartTagHeadParts 
						&& 	a._tag < kActorPartTagHeadPartsMAX) )
			{
				a._sprite.setVisible(false);
			}
		}

		// set priority
		this._priority = 5;
	},

	addMutation: function( $super , mutationFlags)
	{	
		if (		 this.classname.indexOf("ZombieActorHeadless", 0) != -1 
				&& !(mutationFlags & kMutationPumpkinHead))
		{
			mutationFlags &= ~kMutationHead;
			mutationFlags &= ~kMutationHat;
		}

		$super(mutationFlags);
	},

	fightAttackAnim: function( dt )
	{
		this.unschedule( this.fightAttackAnim.bind( this ) );
		
		if (this._state != kActorFightStateDying &&
			this._state != kActorFightStateDead )
		{
			this.startAnim( kActorAnimAttackFlail , true );
		}
	},

	generateName: function()
	{
		return this.generateNameWithKey( "large" );
	},

	damage: function($super, amount)
	{
		var block = this.getAbilityByTag(kActorActivatedAbilityTagBlock);
		var blockRand = Math.random();
		
		// 10% chance to block
		if(block && block._active && blockRand > 0.9)
		{
			//block effect
			SimpleAudioEngine.playEffect(kBlockSFX);
			
			//first stop all actions
			this._fightData._lifeBG.stopAllActions();
			this._fightData._lifeBar.stopAllActions();
			this._fightData._lifeBarTemp.stopAllActions();
			
//			this._fightData._lifeBarTemp._scaleX = this._fightData._hitPoints / this._fightData._finalHitPointsTotal;
			this._fightData._lifeBarTemp.setScale(this._fightData._hitPoints / this._fightData._finalHitPointsTotal, 1);
			this._fightData._lifeBarTemp.setColor(ccc3(0xff,0xff,0xff));
			
//			this._fightData._lifeBar._scaleX = this._fightData._hitPoints / this._fightData._finalHitPointsTotal;
			this._fightData._lifeBar.setScale(this._fightData._hitPoints / this._fightData._finalHitPointsTotal, 1);
			this._fightData._lifeBar.setColor(ccc3(0xff,0xff,0xff));
		
			// instantly makes life bar opacity 100% 
			this._fightData._lifeBG.setOpacity(255);
			this._fightData._lifeBar.setOpacity(255);
			this._fightData._lifeBarTemp.setOpacity(255);

			var showLifeBarDelay = 0.5;
			
			// if you are the target then show the bar longer
			if (this._fightData._opponent && this._fightData._opponent._fightData && this._fightData._opponent._fightData._opponent == this)
			{
				showLifeBarDelay = 5;
			}

			// actionTo    = fade out after a delay (0.5 seconds if not the opponents target ... 5 seconds otherwise)
			// actionToTwo = scales the 2nd life bar to the 1st bar's size (lifeBar = currentHP, lifeBarTemp = previousHP)

			// make both bars fade out BUT have the current hp also blink to and fade out from white
			
			var actionTo = CCSequence.actions(
									CCDelayTime.actionWithDuration(showLifeBarDelay),
									CCFadeOut.actionWithDuration(0.25) );
			var actionToTwo = CCSequence.actions(
									CCTintTo.actionWithDuration(0.1, 0xff, 0xff, 0xff),
									CCTintTo.actionWithDuration(0.3, 0xff, 0x00, 0x00));
			this._fightData._lifeBar.runAction(CCSpawn.actions(actionTo,actionToTwo));
//			this._fightData._lifeBar.runAction(actionTo);

			actionTo = CCSequence.actions(
									CCDelayTime.actionWithDuration(showLifeBarDelay),
									CCFadeOut.actionWithDuration(0.25));
			this._fightData._lifeBG.runAction(actionTo);
			
			
			actionTo = CCSequence.actions(
									CCDelayTime.actionWithDuration(showLifeBarDelay),
									CCFadeOut.actionWithDuration(0.25));
			// the bar behind the current hp amount (not seen just make sure it fades out like the other bars)
			this._fightData._lifeBarTemp.runAction(actionTo);

			// make the zombie blink yellow (not noticeable)
			this.blinkWithColor(ccc3(0xff,0xff,0x00));
		}
		else 
		{
			$super(amount);
		}
	},

	initFightDataAfterLoad: function($super)
	{
		$super();

		var turboSpeed = this.getAbilityByTag(kActorActivatedAbilityTagTurboSpeed);
		if(turboSpeed && turboSpeed._unlocked)
		{
			this._walkingSpeed *= 2;
		}
	},

	initActorSpecificAbilities: function()
	{
		// clear the list
		if( this._abilityList)
		{
			//[abilityList removeAllObjects];
			//[abilityList release];
			this._abilityList = null;
			this._abilityList = new Array();
		}
		
		var abilityLevel = 0;
		
		switch( this.classname )
		{
			case "ZombieActorHeadlessTier1": abilityLevel = 1; break;
			case "ZombieActorHeadlessTier2": abilityLevel = 2; break;
			case "ZombieActorHeadlessTier3": abilityLevel = 3; break;
			case "ZombieActorHeadlessTier4": abilityLevel = 4; break;
		}
		
		switch ( abilityLevel )
		{
			case 4: 
			{	
				var ability = new ZFActorActivatedAbility();
				ability.initWithTag( kActorActivatedAbilityTagBlock );
				this._abilityList.splice( 0, 0, ability );
			}
			
			case 3: 
			{
				var ability = new ZFActorActivatedAbility();
				ability.initWithTag( kActorActivatedAbilityTagTurboSpeed );
				this._abilityList.splice( 0, 0, ability );
			}
			
			case 2: 
			{
				var ability = new ZFActorFightEffect();
				ability.initWithTag( kFightEffectProtect );
				this._abilityList.splice( 0, 0, ability );
			}
			
			case 1: 
			{
				var ability = new ZFActorFightEffect();
				ability.initWithTag( kFightEffectSelfBuffHitPoints );
				this._abilityList.splice( 0, 0, ability );
			}			
		}

		// TODO implement unlockActorSpecificAbilities in ZombieActor
		this.unlockActorSpecificAbilities();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadlessTier1'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadlessTier1'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadlessTier1'] = exports; var ZombieActorHeadless = require('Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadless').ZombieActorHeadless;

exports.ZombieActorHeadlessTier1 = ZombieActorHeadless.subclass(
{
	classname: 'ZombieActorHeadlessTier1',

	initialize: function($super)
	{
		$super();
		this._tier = 1;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadlessTier2'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadlessTier2'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadlessTier2'] = exports; var ZombieActorHeadless = require('Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadless').ZombieActorHeadless;

exports.ZombieActorHeadlessTier2 = ZombieActorHeadless.subclass(
{
	classname: 'ZombieActorHeadlessTier2',

	initialize: function($super)
	{
		$super();
		this._tier = 2;
	},

	initSprite: function( $super )
	{
		$super();

		//TODO ActorParticle
//		var p = new ActorParticle();
//		p._particle = new CCParticleSun().initWithTotalParticles(10);
//		p._particle._startSize *= 1.5;
//		p._particle._startSizeVar *= 1.5;
//		p._particle._emissionRate = 5;//*= 0.125;
//		p._particle._life = 2;
//		p._particle._speed *= 0.5;//1;
//		p._particle._speedVar *= 0.5;
//		p._particle._angleVar = 45;
//		p._particle._startColor = (ccColor4F) {0.12, 0.25,  1, 1};
//		p._particle._endColor = (ccColor4F) {0, 0, 0, 1};
//		p._attachmentID = kActorPartTagHead;
//		p._size = p._particle._startSize;
//		p._sizevar = p._particle._startSizeVar;
//
//		this._particles.push(p);
//		p._particle._positionType = kCCPositionTypeGrouped;
//		
//		p = new ActorParticle();
//		p._particle = new CCParticleSun().initWithTotalParticles(5);
//		p._particle._startSize *= 0.75;
//		p._particle._startSizeVar *= 0.5;
//		p._particle._emissionRate = 5;
//		p._particle._life = 0.5;
//		p._particle._speed *= 0.5;
//		p._particle._speedVar *= 0.5;
//		p._particle._angleVar = 45;
//		p._particle._startColor = (ccColor4F) {1, 0.2,  0.2, 1};
//		p._particle._endColor = (ccColor4F) {1, 0.2, 0.2, 0};
//		p._particle._blendAdditive = false;
//		p._attachmentID = kActorPartTagHead;
//		p._size = p._particle._startSize;
//		p._sizevar = p._particle._startSizeVar;
//
//		this._particles.push(p);
//		p._particle._positionType = kCCPositionTypeGrouped;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadlessTier3'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadlessTier3'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadlessTier3'] = exports; var ZombieActorHeadless = require('Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadless').ZombieActorHeadless;

exports.ZombieActorHeadlessTier3 = ZombieActorHeadless.subclass(
{
	classname: 'ZombieActorHeadlessTier3',

	initialize: function($super)
	{
		$super();
		this._tier = 3;
	},

	initSprite: function( $super )
	{
		$super();

		//TODO ActorParticle
//		var p = new ActorParticle();
//		p._particle = new CCParticleSun().initWithTotalParticles(10);
//		p._particle._startSize *= 1.75;
//		p._particle._startSizeVar *= 1.75;
//		p._particle._emissionRate = 5;//*= 0.25;
//		p._particle._life = 2;
//		p._particle._speed *= 1.5;
//		p._particle._angleVar = 45;
//		p._particle._startColor = (ccColor4F) {1, 0.25,  0.12, 1};
//		p._attachmentID = kActorPartTagHead;
//		p._size = p._particle._startSize;
//		p._sizevar = p._particle._startSizeVar;
//
//		this._particles.push(p);
//		p._particle._positionType = kCCPositionTypeGrouped;
//		
//		p = new ActorParticle();
//		p._particle = new CCParticleSun().initWithTotalParticles(5);
//		p._particle._startSize *= 1.1;
//		p._particle._startSizeVar *= 0.5;
//		p._particle._emissionRate = 5;
//		p._particle._life = 0.5;
//		p._particle._speed *= 0.5;
//		p._particle._speedVar *= 0.5;
//		p._particle._angleVar = 45;
//		p._particle._startColor = (ccColor4F) {0.2, 0.2,  1, 1};
//		p._particle._endColor = (ccColor4F) {0.2, 0.2, 1, 0.5};
//		p._particle._blendAdditive = false;
//		p._attachmentID = kActorPartTagHead;
//		p._size = p._particle._startSize;
//		p._sizevar = p._particle._startSizeVar;
//
//		this._particles.push(p);
//		p._particle._positionType = kCCPositionTypeGrouped;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadlessTier4'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadlessTier4'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadlessTier4'] = exports; var ZombieActorHeadless = require('Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadless').ZombieActorHeadless;

exports.ZombieActorHeadlessTier4 = ZombieActorHeadless.subclass(
{
	classname: 'ZombieActorHeadlessTier4',

	initialize: function($super)
	{
		$super();
		this._tier = 4;
	},

	initSprite: function( $super )
	{
		$super();

		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagCollar, this._spriteDictionary["partyCollar"]);
		this._attachments[kActorPartTagCollar]._inheritColor = false;

		//TODO ActorParticle
//		var p = new ActorParticle();
//		p._particle = new CCParticleSun().initWithTotalParticles(20);
//		p._particle._startSize = 6;
//		p._particle._startSizeVar = 0;
//		p._particle._angleVar = 35;
//		p._particle._startColor = (ccColor4F) {0.5, 0.5, 0.5, 1};
//		p._particle._startColorVar = (ccColor4F) { 0.5, 0.5, 0.5, 0.5};
//		p._particle._endColor = (ccColor4F) { 0.5, 0.5, 0.5, 1};
//		p._particle._endColorVar = (ccColor4F) { 0.5, 0.5, 0.5, 0.5};
//		p._particle._emissionRate = 50;//*= 0.25;
//		p._particle._speed = 80;
//		p._particle._speedVar = 0;
//		p._particle._life = 0.20f;
//		p._particle._lifeVar = 0.1;
//		p._attachmentID = kActorPartTagHead;
//		p._size = p._particle._startSize;
//		p._sizevar = p._particle._startSizeVar;
//		//p._particle._blendAdditive = true;
//		p._particle._texture = CCTextureCache.sharedTextureCache().addImage:("confetti.png");
//
//		this._particles.push(p);
//		p._particle._positionType = kCCPositionTypeGrouped;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLarge'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLarge'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLarge'] = exports; var ZOMBIEBASESPEED = 0.75;
var ZombieActor = require('Code/Game/Actor/Types/Zombies/ZombieActor').ZombieActor;

exports.ZombieActorLarge = ZombieActor.subclass({
    classname : 'ZombieActorLarge',
    
    initialize : function($super)
    {
        $super();
        this._tier = 0;
    },
    
    initSprite : function($super)
    {
        $super();
        this._spriteMan.setScale(1.2, 1.2);
        this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFeatures, this._spriteDictionary["browFeature"]);
        
        for ( var key in this._attachments)
        {
            var a = this._attachments[key];
            
            if (a == null)
                continue;
            
            if (a._tag > kActorPartTagHeadParts && a._tag < kActorPartTagHeadPartsMAX)
            {
                a.setScale(0.9, 0.9);
                a._sprite.setScale(0.9, 0.9);
                
                if (a._tag == kActorPartTagEyeL)
                {
                    a.setScale(0.33, 0.33);
                    a._sprite.setScale(0.33, 0.33);
                    a._offsetFromRefPoint = ccpAdd(a._offsetFromRefPoint, ccp(-3, 0));
                }
                else if (a._tag == kActorPartTagEyeR)
                {
                    a.setScale(0.33, 0.33);
                    a._sprite.setScale(0.33, 0.33);
                    a._offsetFromRefPoint = ccpAdd(a._offsetFromRefPoint, ccp(3, 0));
                }
            }
            
            if (a._tag == kActorPartTagHead)
            {
                a.setScale(0.9, 0.9);
                a._sprite.setScale(0.9, 0.9);
                a._offsetFromRefPoint = ccpAdd(a._offsetFromRefPoint, ccp(-7, -5));
            }
            
            if (a._tag == kActorPartTagArmB || a._tag == kActorPartTagArmF)
            {
                a.setScale(1.15, 1.15);
                a._sprite.setScale(1.15, 1.15);
            }
        }
        
        //TODO ActorParticle
        /*
        var p = new ActorParticle();
        p._particle = new CCParticleRain().initWithTotalParticles(5);
        p._particle._startSize = 16;
        p._particle._emissionRate = 0.25;
        p._particle._speed = 30;
        p._particle._speedVar = 0;
        p._particle._life = 0.8;
        p._particle._posVar = ccp( 20, 0 );
        p._attachmentID = kActorPartTagJaw;
        p._size = p._particle._startSize;
        p._sizevar = p._particle._startSizeVar;
        p._particle._texture = CCTextureCache.sharedTextureCache().addImage("rainDrop.png");
        this._particles.push(p);
        
        //TODO kCCPositionTypeGrouped
        p._particle._positionType = kCCPositionTypeGrouped;*/
        
        // set priority
        this._priority = 4;
        this._miniZombieAttached = null;
    },
    
    initActorSpecificAbilities : function()
    {
        // clear the list
        if (this._abilityList)
        {
            this._abilityList = null;
            this._abilityList = new Array();
        }
        
        var abilityLevel = 0;
        switch (this.classname)
        {
            case "ZombieActorLargeTier1":
                abilityLevel = 1;
                break;
            case "ZombieActorLargeTier2":
                abilityLevel = 2;
                break;
            case "ZombieActorLargeTier3":
                abilityLevel = 3;
                break;
            case "ZombieActorLargeTier4":
                abilityLevel = 4;
                break;
        }
        
        switch (abilityLevel)
        {
            case 4: {
                var ability = new ZFActorActivatedAbility();
                ability.initWithTag(kActorActivatedAbilityTagBashV2);
                this._abilityList.splice(0, 0, ability);
            }
                
            case 3: {
                var ability = new ZFActorActivatedAbility();
                ability.initWithTag(kActorActivatedAbilityTagBash);
                this._abilityList.splice(0, 0, ability);
            }
                
            case 2: {
                var ability = new ZFActorActivatedAbility();
                ability.initWithTag(kActorActivatedAbilityTagAttachMini);
                this._abilityList.splice(0, 0, ability);
            }
                
            case 1: {
                var ability = new ZFActorFightEffect();
                ability.initWithTag(kFightEffectSelfBuffPower);
                this._abilityList.splice(0, 0, ability);
            }
        }
        
        this.unlockActorSpecificAbilities();
        // turn off first bash if bash2 is unlocked
        var bash = this.getAbilityByTag(kActorActivatedAbilityTagBash);
        var bashV2 = this.getAbilityByTag(kActorActivatedAbilityTagBashV2);
        if (bashV2 && bash && bashV2._unlocked)
            bash._unlocked = false;
    },
    
    talk : function()
    {
        SimpleAudioEngine.playEffect(kZombieLargeBrain);
    },
    
    fightAttackAnim : function(dt)
    {
        this.unschedule(this.fightAttackAnim.bind(this));
        if (this._state != kActorFightStateDying && this._state != kActorFightStateDead)
        {
            this.startAnim(kActorAnimAttackFlail, true);
        }
    },
    
    generateName : function()
    {
        return this.generateNameWithKey("large");
    },
    
    /////////////// bash ability ///////////////////
    bash : function(sender)
    {
        var bash = this.getAbilityByTag(kActorActivatedAbilityTagBash);
        if (bash)
        {
            var fm = ZFFightMan;
            if (this._fightData._specialAttack)
            {
                this._fightData._specialAttack = null;
            }
            
            this._fightData._specialAttack = fm._allAttacks["ZombieBash"];
            
            if (!this._fightData._attacking && this._state == kActorFightStateFight && !this.isScheduled(this.fightAttack))
            {
                this.schedule(this.fightAttack, 0, "fightAttack");
            }
            
            // add cooldown
            bash.refreshTimers();
        }
    },
    
    bashV2 : function(sender)
    {
        var bashV2 = this.getAbilityByTag(kActorActivatedAbilityTagBashV2);
        
        if (bashV2)
        {
            var fm = ZFFightMan;
            if (this._fightData._specialAttack)
            {
                this._fightData._specialAttack = null;
            }
            
            this._fightData._specialAttack = fm._allAttacks["ZombieBashV2"];
            
            if (!this._fightData._attacking && this._state == kActorFightStateFight && !this.isScheduled(this.fightAttack))
            {
                this.schedule(this.fightAttack, 0, "fightAttack");
            }
            
            // add cooldown
            bashV2.refreshTimers();
        }
    },
    
    /////////////// attach mini ability ////////////
    attachMini : function(sender)
    {
        var fm = ZFFightMan;
        var miniZombie = null;
        
        for ( var key in fm._zombies)
        {
        	var z = fm._zombies[key];
            if ( (z instanceof ZombieActorSmall) && (z._state == kActorFightStateWait))
            {
                miniZombie = z;
                break;
            }
        }
        
        // if miniZombie exists
        if (miniZombie)
        {
            miniZombie.setState(kActorFightStateUsingAbility);
            
            var s = 0.8;
            
            var positionDeltaX = this.getPosition()._x - miniZombie.getPosition()._x;
            var landingCGPoint = ccp(this.getPosition()._x - 20, this.getPosition()._y + 60);
            
            miniZombie.stopAllActions();
            
            if (miniZombie.isScheduled(miniZombie.fightWanderIn))
                miniZombie.unschedule(miniZombie.fightWanderIn);
			
            miniZombie.schedule(miniZombie.fightUpdate, 0.05, "fightUpdate");
            fm._zombiesFighting++;
            this._miniZombieAttached_y = miniZombie.getPosition()._y;
            
            var bezier = {};
            bezier._controlPoint_1 = miniZombie.getPosition();
            bezier._controlPoint_2 = ccp(miniZombie.getPosition()._x+positionDeltaX*0.5, this.getPosition()._y+300);
            bezier._endPosition = landingCGPoint;
            
            var bezierForward = CCBezierTo.actionWithDuration(s, bezier);
            miniZombie.runAction(CCSequence.actions(new Array(
            				bezierForward,
            				CCCallFuncND.actionWithTarget(this, this.callStartAnim.bind(this), kActorAnimChase)
            )));

            this.runAction(CCSequence.actions(new Array(CCCallFuncND.actionWithTarget(this, this.callStartAnim.bind(this), kActorAnimVictory), CCDelayTime.actionWithDuration(s)
            )));
            
            this._miniZombieAttached = miniZombie;
            this._walkingSpeed *= 4;
            
            this._miniZombieAttached._walkingSpeed = 0;
            this._miniZombieAttached.setState(kActorFightStateGo);
        }
    },
    
    unattachMini : function()
    {
        // jump off animation then recalculate miniZombie position
        var fm = ZFFightMan;
//        var zombiePosition = fm._yOrder[fm._zombies.indexOf(this._miniZombieAttached)];
//        var i = zombiePosition._y;
//        var posy = ((i % fm._zombies.length) * 2) - 5;
        var posy = this._miniZombieAttached_y;
        
        var s = 0.5;
        
        var landingCGPoint = ccp(this._miniZombieAttached.getPosition()._x - 125, posy);
        
        //TODO ccBezierConfig
        var bezier = {};
        bezier._controlPoint_1 = this._miniZombieAttached.getPosition();
        bezier._controlPoint_2 = ccp(this._miniZombieAttached.getPosition()._x - 80, this._miniZombieAttached.getPosition()._y + 150);
        bezier._endPosition = landingCGPoint;
        
        var bezierForward = CCBezierTo.actionWithDuration(s, bezier);
        var setState = CCCallFuncND.actionWithTarget(this._miniZombieAttached, this._miniZombieAttached.callSetState.bind(this._miniZombieAttached), kActorFightStateGo);
        
        this._miniZombieAttached.runAction(CCSequence.actions(new Array(bezierForward, setState)));
        
        var dex = this._miniZombieAttached._unitDictionary["dex"];
//        this._miniZombieAttached._walkingSpeed = 4 * 0.5 * dex; //TODO ZOMBIEBASESPEED * 0.5 * dex
        this._miniZombieAttached._walkingSpeed = ZOMBIEBASESPEED * dex;
        
        this._miniZombieAttached.setZombieToLastIndex();
        this._miniZombieAttached = null;
        this._walkingSpeed *= 0.25;
    },
    
    fightGoIn : function($super, dt)
    {
        $super(dt);
        if (this._miniZombieAttached)
        {
            SimpleAudioEngine.playEffect("./Content/charge.wav");
        }
    },
    
    fightUpdate : function($super, dt)
    {
        $super(dt);
        switch (this._state)
        {
            case kActorFightStateGoing:
                if (this._miniZombieAttached)
                {
                    this._miniZombieAttached.setPosition(this.getPosition()._x - 20, this.getPosition()._y + 60);
//                    this._miniZombieAttached._destinationPoint = this._destinationPoint - 20;
                }
                break;
            
            case kActorFightStateFight:
            case kActorFightStateFighting:
            case kActorFightStateFightWall:
                if (this._miniZombieAttached)
                {
                    this.unattachMini();
                    
                    // stun !
                    var fm = ZFFightMan;
                    if (this._state != kActorFightStateFightWall && fm._enemy && (fm._enemy._state == kActorFightStateFight || fm._enemy._state == kActorFightStateFighting))
                    {
                        fm._enemy.stunSelfFor(2);
                        this.stunSelfFor(1);
                    }
                }
                break;
            
            case kActorFightStateFightingBossWall:
                if (this._miniZombieAttached)
                {
                    this.unattachMini();
                    
                    // stun !
                    var fm = ZFFightMan;
                    if (fm._bossWall && fm._bossWall._fightData._hitPoints > 0)
                    {
                        fm._bossWall.stunSelfFor(2);
                        this.stunSelfFor(1);
                    }
                }
                break;
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLargeTier1'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLargeTier1'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLargeTier1'] = exports; var ZombieActorLarge = require('Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLarge').ZombieActorLarge;

exports.ZombieActorLargeTier1 = ZombieActorLarge.subclass(
{
	classname: 'ZombieActorLargeTier1',

	initialize: function($super)
	{
		$super();
		this._tier = 1;
	},

	initSprite: function( $super )
	{
		$super();
		this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagJaw,
				this._spriteDictionary["bruteJaw"]);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLargeTier2'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLargeTier2'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLargeTier2'] = exports; var ZombieActorLarge = require('Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLarge').ZombieActorLarge;

exports.ZombieActorLargeTier2 = ZombieActorLarge.subclass(
{
	classname: 'ZombieActorLargeTier2',

	initialize: function($super)
	{
		$super();
		this._tier = 2;
	},

	initSprite: function( $super )
	{
		$super();
		this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagJaw,
				this._spriteDictionary["bruteJaw"]);
		
		for (var p in this._particles)
		{
			//TODO ActorParticle
			//p._particle._emissionRate *= 8;
			var a = this._attachments[kActorPartTagEyeR];
			a.setScale(0.66, 0.66);
			a._sprite.setScale(0.66, 0.66);
		}
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLargeTier3'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLargeTier3'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLargeTier3'] = exports; var ZombieActorLarge = require('Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLarge').ZombieActorLarge;

exports.ZombieActorLargeTier3 = ZombieActorLarge.subclass(
{
	classname: 'ZombieActorLargeTier3',

	initialize: function($super)
	{
		$super();
		this._tier = 3;
	},

	initSprite: function( $super )
	{
		$super();
		this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagJaw, 
				this._spriteDictionary["barbarianJaw"]);
		
		for (var p in this._particles)
		{
			//TODO ActorParticle
			//p._particle._emissionRate *= 4;
			var a = this._attachments[kActorPartTagEyeL];
			a.setScale(0.66, 0.66);
			a._sprite.setScale(0.66, 0.66);
		}
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLargeTier4'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLargeTier4'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLargeTier4'] = exports; var ZombieActorLarge = require('Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLarge').ZombieActorLarge;

exports.ZombieActorLargeTier4 = ZombieActorLarge.subclass(
{
	classname: 'ZombieActorLargeTier4',

	initialize: function($super)
	{
		$super();
		this._tier = 4;
	},

	initSprite: function( $super )
	{
		$super();
		this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagJaw, 
				this._spriteDictionary["barbarianJaw"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFeatures2,
				this._spriteDictionary["barbarianHair"]);
		this._attachments[kActorPartTagFeatures2]._inheritColor = false;
		this._particles = new Array();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmall'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmall'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmall'] = exports; var ZombieActor = require('Code/Game/Actor/Types/Zombies/ZombieActor').ZombieActor;

exports.ZombieActorSmall = ZombieActor.subclass({
    classname : 'ZombieActorSmall',
    
    initialize : function($super)
    {
        $super();
        this._tier = 0;
    },
    
    initSprite : function($super)
    {
        $super();
        this._spriteMan.setScale(0.6, 0.6);
        this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFeatures, this._spriteDictionary["eyeBrowFeature"]);
        
        // set priority
        this._priority = 3;
    },
    
    talk : function()
    {
        SimpleAudioEngine.playEffect(kZombieSmallBrain);
    },
    
    fightAttackAnim : function(dt)
    {
        this.unschedule(this.fightAttackAnim);
        
        if (this._state != kActorFightStateDying && this._state != kActorFightStateDead)
        {
            this.startAnim(kActorAnimAttackBite, true);
        }
    },
    
    generateName : function()
    {
        return this.generateNameWithKey("small");
    },
    
    initActorSpecificAbilities : function()
    {
        // clear the list
        if (this._abilityList)
        {
            this._abilityList = null;
            this._abilityList = new Array();
        }
        
        var abilityLevel = 0;
        
        switch (this.classname)
        {
            case "ZombieActorSmallTier1":
                abilityLevel = 1;
                break;
            case "ZombieActorSmallTier2":
                abilityLevel = 2;
                break;
            case "ZombieActorSmallTier3":
                abilityLevel = 3;
                break;
            case "ZombieActorSmallTier4":
                abilityLevel = 4;
                break;
        }
        
        switch (abilityLevel)
        {
            case 4: {
                var ability = new ZFActorActivatedAbility();
                ability.initWithTag(kActorActivatedAbilityTagExplodeV2);
                this._abilityList.splice(0, 0, ability);
            }
                
            case 3: {
                var ability = new ZFActorActivatedAbility();
                ability.initWithTag(kActorActivatedAbilityTagExplode);
                this._abilityList.splice(0, 0, ability);
            }
                
            case 2:
            case 1:
                break;
        }
        
        this.unlockActorSpecificAbilities();
        
        // turn off first explode if explode2 is unlocked
        var explode = this.getAbilityByTag(kActorActivatedAbilityTagExplode);
        var explodeV2 = this.getAbilityByTag(kActorActivatedAbilityTagExplodeV2);
        if (explodeV2 && explode && explodeV2._unlocked)
            explode._unlocked = false;
    },
    
    explode : function(sender)
    {
    	console.log("Explode 1");
        this._fightData._specialAttack = this.getAttackVariationByTag(ZFAttackAnims.kAttackTypes.kAttackTypeExplode);
        if (!this._fightData._attacking && this._state == kActorFightStateFight && !this.isScheduled(this.fightAttack))
        {
            this.schedule(this.fightAttack, 0, "fightAttack");
        }
        // if not fighting and in a state which allows attacking ... explode immediately
    },
    
    explodeV2 : function(sender)
    {
        //TODO Relies on ZFAttackAnims.
        this._fightData._specialAttack = this.getAttackVariationByTag(ZFAttackAnims.kAttackTypes.kAttackTypeExplodeV2);
        if (!this._fightData._attacking && this._state == kActorFightStateFight && !this.isScheduled(this.fightAttack))
        {
            this.schedule(this.fightAttack, 0, "fightAttack");
        }
        // if not fighting and in a state which allows attacking ... explode immediately
    },
    
    suicide : function(sender)
    {
//        if (this.isScheduled(this.suicide))
        this.unschedule(this.suicide);
        this._fightData._hitPoints = 0;
        this.setState(kActorFightStateDying);
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmallTier1'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmallTier1'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmallTier1'] = exports; var ZombieActorSmall = require('Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmall').ZombieActorSmall;

exports.ZombieActorSmallTier1 = ZombieActorSmall.subclass(
{
	classname: 'ZombieActorSmallTier1',

	initialize: function($super)
	{
		$super();
		this._tier = 1;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmallTier2'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmallTier2'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmallTier2'] = exports; var ZombieActorSmall = require('Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmall').ZombieActorSmall;

exports.ZombieActorSmallTier2 = ZombieActorSmall.subclass(
{
	classname: 'ZombieActorSmallTier2',

	initialize: function($super)
	{
		$super();
		this._tier = 2;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmallTier3'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmallTier3'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmallTier3'] = exports; var ZombieActorSmall = require('Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmall').ZombieActorSmall;

exports.ZombieActorSmallTier3 = ZombieActorSmall.subclass(
{
	classname: 'ZombieActorSmallTier3',

	initialize: function($super)
	{
		$super();
		this._tier = 3;
	},

	initSprite: function( $super )
	{
		$super();
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFeatures2, this._spriteDictionary["goblinEarFeature"]);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmallTier4'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmallTier4'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmallTier4'] = exports; var ZombieActorSmall = require('Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmall').ZombieActorSmall;

exports.ZombieActorSmallTier4 = ZombieActorSmall.subclass(
{
	classname: 'ZombieActorSmallTier4',

	initialize: function($super)
	{
		$super();
		this._tier = 4;
	},

	initSprite: function( $super )
	{
		$super();
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFeatures2, this._spriteDictionary["goblinEarFeature"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFeatures3, this._spriteDictionary["impFeature"]);
		this._attachments[kActorPartTagFeatures3]._inheritColor = false;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegular'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegular'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegular'] = exports; var ZombieActor = require('Code/Game/Actor/Types/Zombies/ZombieActor').ZombieActor;
var LaserNode = require('Code/Game/Actor/Types/Zombies/ZombieActorRegular/LaserNode').LaserNode;

exports.ZombieActorRegular = ZombieActor.subclass({
    classname : 'ZombieActorRegular',
    
    initSprite : function($super)
    {
        $super();
        this._spriteMan.setScale(0.9, 0.9);
        this._priority = 2;
        
        this._laser = null;
        this.addLaserNode();
    },
    
    addLaserNode : function()
    {
        if (this._laser)
        {
        	destroyWithChildren( this._laserShine );
        	destroyWithChildren( this._laser );
            this._laser._laserShine = null;
            this._laser.getParent().removeChild(this._laser, true);
            this._laser = null;
        }
        
        if (!this._laser)
        {
            var laserV1 = this.getAbilityByTag(kActorActivatedAbilityTagLaser); // ZFActorAbility
            var laserV2 = this.getAbilityByTag(kActorActivatedAbilityTagLaserV2);
            
            this._laser = new LaserNode();
            this._laser._laserShine = CCSprite.spriteWithFile("laserShine.png");
//            this._laser.addChild(this._laser._laserShine);
            
            this._laser._laserShine.setScale(3);
            this._laser._laserShine.setOpacity(255);
            
            if (laserV1 && laserV1._unlocked)
            {
                this._laser._laserType = 1;
                this._laser._laserShine.setColor(ccc3(0xff, 0x00, 0x00));
            }
            else if (laserV2 && laserV2._unlocked)
            {
                this._laser._laserType = 2;
                this._laser._laserShine.setColor(ccc3(0xff, 0xff, 0xff));
            }
            
            this._laser._zombie = this;
            this._laser._laserShine.setPosition((ccp(this.getPosition()._x, this.getPosition()._y + 60 * this._heightScale)));

        }
    },
    
    destroy : function($super)
    {
        if (this._laser)
        {
            this._laser._zombie = null;
            if (this._laser.getParent())
            {
                this._laser.getParent().removeChild(this._laser, true);
            }
            
            this._laser.hide();
            
            destroyWithChildren(this._laser);
            this._laser._laserShine = null;
            this._laser._laserLayer = null;
            this._laser = null;
            this.unschedule(this.laser);
        }
        
        $super();
    },
    
    talk : function()
    {
        SimpleAudioEngine.playEffect(kZombieRegularBrain);
    },
    
    fightAttackAnim : function(dt)
    {
        this.unschedule(this.fightAttackAnim);
        
        if (this._state != kActorFightStateDying &&
            this._state != kActorFightStateDead)
        {
            if (Math.random() >= 0.5)
            {
                this.startAnim(kActorAnimAttackFlail, true);
            }
            else
            {
                this.startAnim(ActorAnimAttackBite, true);
            }
        }
    },
    
    generateName : function()
    {
        return this.generateNameWithKey("male");
    },
    
    initActorSpecificAbilities : function()
    {
        // clear the list
        if (this._abilityList)
        {
            this._abilityList.length = 0;
            this._abilityList = null;
            this._abilityList = [];
        }
        
        var abilityLevel = 0;
        switch (this.classname)
        {
            case "ZombieActorRegularTier1":
                abilityLevel = 1;
                break;
            case "ZombieActorRegularTier2":
                abilityLevel = 2;
                break;
            case "ZombieActorRegularTier3":
                abilityLevel = 3;
                break;
            case "ZombieActorRegularTier4":
                abilityLevel = 4;
                break;
        }
        
        if (this.classname == "ZombieActorRegularCrazy")
        {
            // custom abilities / ZFActorFightEffect
            var ability1 = new ZFActorFightEffect();
            ability1.initWithTag(kFightEffectSelfBuffToAllStats);
            this._abilityList.push(ability1);
            
            var ability2 = new ZFActorFightEffect();
            ability2.initWithTag(kFightEffectChivalry);
            this._abilityList.push(ability2);
            
            var ability3 = new ZFActorFightEffect();
            ability3.initWithTag(kFightEffectSelfBuffSpeed);
            this._abilityList.push(ability3);
            
            var ability4 = new ZFActorFightEffect();
            ability4.initWithTag(kFightEffectGrace);
            this._abilityList.push(ability4);
        }
        
        switch (abilityLevel)
        {
            case 4: {
                var ability = new ZFActorActivatedAbility();
                ability.initWithTag(kActorActivatedAbilityTagLaserV2);
                this._abilityList.splice(0, 0, ability);
            }
                
            case 3: {
                var ability = new ZFActorActivatedAbility();
                ability.initWithTag(kActorActivatedAbilityTagLaser);
                this._abilityList.splice(0, 0, ability);
            }
                
            case 2: {
                var ability = new ZFActorFightEffect();
                ability.initWithTag(kFightEffectChivalry);
                this._abilityList.splice(0, 0, ability);
            }
                
            case 1: {
                var ability = new ZFActorFightEffect();
                ability.initWithTag(kFightEffectSelfBuffToAllStats);
                this._abilityList.splice(0, 0, ability);
            }
        }
        
        this.unlockActorSpecificAbilities();
        // turn off first laser if laser2 is unlocked
        
        var laserV1 = this.getAbilityByTag(kActorActivatedAbilityTagLaser);
        var laserV2 = this.getAbilityByTag(kActorActivatedAbilityTagLaserV2);
        
        if (laserV2 && laserV1 && laserV2._unlocked)
        {
            laserV1._unlocked = false;
        }
    },
    
    fightUpdate : function($super, dt)
    {
        $super(dt);
        if (this._state != kActorFightStateDead &&
            this._state != kActorFightStateDying && this._state != kActorFightStateRanAway)
        {
//            this._laser.setPosition(
//                ccpAdd(this._laser._zombie.getPosition(),
//                ccp(-3.52 * this._laser._zombie._spriteMan.getScale()._x,
//                -3.52 * this._laser._zombie._spriteMan.getScale()._y)));   	
        }
        
        fm = ZFFightMan;
        var laserV1 = null;
        var laserV2 = null;
        laserV1 = this.getAbilityByTag(kActorActivatedAbilityTagLaser);
        laserV2 = this.getAbilityByTag(kActorActivatedAbilityTagLaserV2);
        
        // find some place to check if laserSparks particle system exists 
        
        // note: laser is a special case ... because zombie regular moves at a fairly fast pace
        //	     laser should activate the very moment it changes to kActorFightStateGoing
        //       i.e. we can't wait until our 1 second buff update to activate laser 
        
        if ((laserV1 && laserV1._unlocked) || (laserV2 && laserV2._unlocked))
        {
            var laserTime = 0.0;
            
            // default attackspeed of regular zombie is 1 second 
            if (laserV1 && laserV1._unlocked)
            {
                laserTime = this._fightData._finalAttackSpeed / 3; // 30% of regular damage
            }
            else if (laserV2 && laserV2._unlocked)
            {
                laserTime = this._fightData._finalAttackSpeed / 6; // 60% of regular damage
            }
            
            if (this._state == kActorFightStateGo || this._state == kActorFightStateGoing)
            {
                if (!this._laser._active && fm._enemy && fm._enemy.isInMeleeRange())
                {
                    var laserScale = 0.0;
                    
                    switch (this._laser._laserType)
                    {
                        case 1:
                            laserScale = 2.0;
                            break;
                        case 2:
                            laserScale = 2.5;
                            break;
                        default:
                            laserScale = 0.2;
                            break;
                    }
//                    this._laser._laserShine.setScale(laserScale);
                    this._laser._laserShine.setOpacity(255);
//                    this._laser._laserShine.runAction(
//                            CCSpawn.actions(
//                                    [CCFadeTo.actionWithDuration(laserTime, 255),
//                                     CCScaleTo.actionWithDuration(laserTime, laserScale)]));
                }
                
                if (!this.isScheduled(this.laser) && fm._enemy && fm._enemy.isInMeleeRange())
                {
                    this.schedule(this.laser, 0, "laser");
                }
            }
            else
            {
                if (this.isScheduled(this.laser))
                {
                    this.unschedule(this.laser);
                    this._laser._active = false;
                    this._withLaser = false;
                    
                    var laserTime = 0.5;
//                    this._laser._laserShine.runAction(
//                            CCSpawn.actions([CCFadeTo.actionWithDuration(laserTime, 0),
//                                             CCScaleTo.actionWithDuration(laserTime, 0.2)]));
                    
                    if (this._laser)
                    {
                    	this._laser.hide();
                    }
                    /* TODO: particle system
                    var laserSparks = null;
                    var fm = ZFFightMan;
                    laserSparks = fm.getParent().getChildByTag(kActorLaserParticle);
                    
                    if (laserSparks)
                    {
                        laserSparks.stopSystem(); // should remove itself from its own parent class
                    }*/
                }
            }
        }
    },
    
    laser : function(dt)
    {
        var fm = ZFFightMan;

        var target = null;
        // make the emitter effect
//        var laserSparks = null;
//        laserSparks = fm.getParent().getChildByTag(kActorLaserParticle);
        var laserV1 = this.getAbilityByTag(kActorActivatedAbilityTagLaser);
        var laserV2 = this.getAbilityByTag(kActorActivatedAbilityTagLaserV2);
        
        if (fm._bossWall && fm._bossWall._fightData._hitPoints > 0 && fm._bossWall.getPosition()._x > this.getPosition()._x)
        {
            target = fm._bossWall;
        }
        else if (fm._enemy && fm._enemy._fightData._hitPoints > 0 &&
                (fm._enemy._state == kActorFightStateFight ||
                 fm._enemy._state == kActorFightStateFighting ||
                 fm._enemy._state == kActorFightStateStunned) )
        {
            target = fm._enemy;
        }
        
        if (target)
        {
            if ((laserV1 && laserV1._unlocked) || (laserV2 && laserV2._unlocked))
            {
            	this._laser._active = true;
            }
            
            var damageMultiplier = 0.1; //0.1
            target.damage(this._fightData._finalPower * damageMultiplier);
            
            /* TODO: 
            if (!laserSparks)
            {
                var eyeLevel = 50 * this._spriteMan.getScale()._x; // tentative 
                
                // we can change the actual effect based on some condition here if we want 
                
                laserSparks = CCQuadParticleSystem.particleWithFile("laserBurn.plist");
                laserSparks.setPosition(ccp(target.getPosition()._x, eyeLevel));
                laserSparks._autoRemoveOnFinish = true;
                fm.getParent().addChild(laserSparks, z, kActorLaserParticle);
            }*/
            
            if (fm.getParent() && !this._withLaser)
            {
            	this._laser._distance = (target.getPosition()._x - this.getPosition()._x-30); 
            	this._laser._laserLayer = CCColorLayer.layerWithColor(ccc3(0xff,0x0,0x0), this._laser._distance, 6);
            	this._laser._laserLayer.setColor(this._laser._laserShine.getColor());
                fm.getParent().addChild(this._laser._laserShine, this._spriteMan.getDepth()+1);
                fm.getParent().addChild(this._laser._laserLayer, this._spriteMan.getDepth()+1);
                this._withLaser = true;
            }
            
            var distance = target.getPosition()._x - this.getPosition()._x-30;
            this._laser._laserLayer.setPosition((ccp(this.getPosition()._x, this.getHeadPosition()._y-10* fm._widthScale)));
            this._laser._laserLayer.setScale(ccp(distance/this._laser._distance,1));
            
            this._laser._laserShine.setPosition(this._laser._laserLayer.getPosition());
//            this._laser._laserShine.runAction(CCRotateBy.actionWithDuration(dt, 180));
            this._laser._laserShine.setRotation(dt*10000);
//            if (this._laser._laserShine.getDepth() != this._spriteMan.getDepth()+1)
//            {
//                this._laser._laserShine.setDepth(this._spriteMan.getDepth()+1);
//                this._laser._laserLayer.setDepth(this._spriteMan.getDepth()+1);
//            }
        }
        else
        {
        	this._laser._active = false;
        	this._withLaser = false;
            var laserTime = 0.5;
            
            if (this._laser)
            {
            	this._laser.hide();
            }
            
            this._laser._laserShine.runAction(
                    CCSpawn.actions(
                            [CCFadeTo.actionWithDuration(laserTime, 0),
                             CCScaleTo.actionWithDuration(laserTime, 0.2)]));
            
            /* TODO: particle system
            if (laserSparks)
            {
                laserSparks.stopSystem();
            }*/
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegularCrazy'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegularCrazy'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegularCrazy'] = exports; var ZombieActorRegular = require('Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegular').ZombieActorRegular;

exports.ZombieActorRegularCrazy = ZombieActorRegular.subclass({
    classname : 'ZombieActorRegularCrazy',
    
    initSprite : function($super)
    {
        $super();
        
        // TODO : cupidBody, although being in the original code, seems wrong.
        //			this.replaceAttachmentFromPlist_withSpriteDetails( kActorPartTagBody ,
        //					this._spriteDictionary[ "cupidBody" ] );
        
        this._attachments[kActorPartTagBody]._inheritColor = false;
        this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagEyeL, this._spriteDictionary["crazyEyeL"]);
        
        var crazyEyeL = this._attachments[kActorPartTagEyeL]; 
        crazyEyeL._inheritColor = false;
       
        this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagEyeR, this._spriteDictionary["crazyEyeR"]);
        
        var crazyEyeR = this._attachments[kActorPartTagEyeR];        
        crazyEyeR._inheritColor = false;
        
        this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFeatures, this._spriteDictionary["mustache"]);
        this._attachments[kActorPartTagFeatures]._inheritColor = false;
        this.replaceAttachmentFromPlist_withSpriteDetails(kActorPartTagJaw, this._spriteDictionary["beard"]);
        
        this._attachments[kActorPartTagJaw]._inheritColor = false;
        this.resetColor();
    },
    
    modifyStats : function($super, statDict)
    {
        var gs = GameState;
        
        // tier 4 zombie + all mutation stats
        var maxStr = statDict["str"];
        var maxCon = statDict["con"];
        var maxDex = statDict["dex"];
        //float maxDr  = [[statDict objectForKey:@"dr"]  floatValue];
        
        // green zombie + full mutation stats
        var baseStr = 9;
        var baseCon = 12;
        var baseDex = 2;
        //float baseDr = 0;
        
        // CRAZY ZOMBIE EFFECTS //
        var lvl = gs._zfGameData._level;
        var statRatio = (lvl > 8) ? (lvl - 8) / (25 - 8) : 0;
        statRatio = (statRatio > 1) ? 1 : statRatio;
        
        var str = baseStr + statRatio * (maxStr - baseStr);
        var con = baseCon + statRatio * (maxCon - baseCon);
        var dex = baseDex + statRatio * (maxDex - baseDex);
        var dr = 0; // damage reduction has not been implemented yet
        // END CRAZY ZOMBIE EFFECTS //
        
        statDict["str"] = str;
        statDict["con"] = con;
        statDict["dex"] = dex;
        statDict["dr"] = dr;
        
        return $super(statDict);
    },
    
    damage : function($super, amount)
    {
        $super(amount);
        
        var randomChance = Math.random();
        var randomChanceThreshold = 0.0;
        var hpRatio = this._fightData._hitPoints / this._fightData._finalHitPointsTotal;
        
        // if:     , then
        // hp > 50%, run chance = 5%
        // hp > 25%, run chance = 25%
        // hp > 10%, run chance = 50%
        // hp >  0%, run chance = 75%  
        
        if (hpRatio > 0.50)
            randomChanceThreshold = 0.05;
        else if (hpRatio > 0.25)
            randomChanceThreshold = 0.25;
        else if (hpRatio > 0.10)
            randomChanceThreshold = 0.50;
        else
            randomChanceThreshold = 0.75;
        
        if (randomChance < randomChanceThreshold)
        {
            this.setState(kActorFightStateRunAway);
        }
    },
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegularTier1'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegularTier1'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegularTier1'] = exports; var ZombieActorRegular = require('Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegular').ZombieActorRegular;

exports.ZombieActorRegularTier1 = ZombieActorRegular.subclass(
{
	classname: 'ZombieActorRegularTier1'
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegularTier2'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegularTier2'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegularTier2'] = exports; var ZombieActorRegular = require('Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegular').ZombieActorRegular;
// ActorParticle
// CCParticleSun
// SimpleAudioEngine.

exports.ZombieActorRegularTier2 = ZombieActorRegular.subclass(
{
	classname: 'ZombieActorRegularTier2',

	initSprite: function( $super )
	{
		$super();
		
		// TODO : ActorParticle.
//		var p = new ActorParticle();
//		p._particle = CCParticleSun.node();
//		p._particle._startSize = 8.0;
//		p._particle._startSizeVar = 2.0;
//		p._particle._emissionRate = 50.0;
//		p._particle._speed = 3;
//		p._particle._speedVar = 1;
//		p._particle._life = 0.15;
//		p._particle._lifeVar = 0.12;
//		p._particle._startColor = new Core.Color( 1.0 , 0.125 , 0.125 );
//		p._attachmentID = kActorPartTagEyeR;
//		p._size = p._particle._startSize;
//		p._sizevar = p._particle._startSizeVar;
//		this._particles.push( p );

		this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagFeatures , this._spriteDictionary[ "cyborgFeature" ] );
		this._attachments[ kActorPartTagFeatures ]._inheritColor = false;
	},

	talk: function()
	{
		SimpleAudioEngine.playEffect( kZombieRobotBrain );
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegularTier3'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegularTier3'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegularTier3'] = exports; var ZombieActorRegular = require('Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegular').ZombieActorRegular;
// ActorParticle
// CCParticleSun
// SimpleAudioEngine

exports.ZombieActorRegularTier3 = ZombieActorRegular.subclass(
{
	classname: 'ZombieActorRegularTier3',
	
	initSprite: function( $super )
	{
		$super();
		
//		var p = new ActorParticle();
//		p._particle = new CCParticleSun();
//		p._particle.initWithTotalParticles( 25 );
//		p._particle._startSize = 8.0;
//		p._particle._startSizeVar = 2.0;
//		p._particle._emissionRate = 50.0;
//		p._particle._speed = 3.0;
//		p._particle._speedVar = 1.0;
//		p._particle._life = 0.15;
//		p._particle._lifeVar = 0.12;
//		p._particle._startColor = new Core.Color( 1.125 , 1.125 , 1.0 );
//		p._attachmentID = kActorPartTagEyeL;
//		p._size = p._particle._startSize;
//		p._sizevar = p._particle._startSizeVar;
//		this._particles.push( p );
//		
//		p = new ActorParticle();
//		p._particle = new CCParticleSun();
//		p.initWithTotalParticles( 25 );
//		p.particle._startSize = 8.0;
//		p.particle._startSizeVar = 2.0;
//		p.particle._emissionRate = 50.0;
//		p.particle._speed = 3.0;
//		p.particle._speedVar = 1.0;
//		p.particle._life = 0.15;
//		p.particle._lifeVar = 0.12;
//		p.particle._startColor = new Core.Color( 1.125 , 1.125 , 1.0 );
//		p._attachmentID = kActorPartTagEyeR;
//		p._size = p._particle._startSize.clone();
//		p._sizevar = p._particle._startSizeVar.clone();
//
//		this._particles.push( p );
		
		this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagFeatures ,
				this._spriteDictionary[ "robotFeature"] );
	},

	talk: function()
	{
		SimpleAudioEngine.playEffect( kZombieRobotBrain );
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegularTier4'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegularTier4'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegularTier4'] = exports; var ZombieActorRegular = require('Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegular').ZombieActorRegular;

exports.ZombieActorRegularTier4 = ZombieActorRegular.subclass(
{
	classname: 'ZombieActorRegularTier4',
	
	initSprite: function( $super )
	{
		$super();
		this.addAttachmentFromPlist_withSpriteDetails( kActorPartTagFeatures ,
				this._spriteDictionary[ "robocopFeature" ] );
		
		this._attachments[ kActorPartTagFeatures ]._inheritColor = false;
		
		this.replaceAttachmentFromPlist_withSpriteDetails( kActorPartTagJaw ,
				this._spriteDictionary[ "robocopJaw" ] );
	},

	talk: function()
	{
		SimpleAudioEngine.playEffect( kZombieRobotBrain );
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/ActorFightData'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/ActorFightData'] || {}; $MODULE_REGISTRY['Code/Game/Actor/ActorFightData'] = exports; exports.ActorFightData = Core.Class.subclass
({
	classname: 'ActorFightData',
	
	initialize : function() 
	{
	    // Save these values for use elsewhere
        var mainFrame = new Core.Size(960,640);
        var resolutionWidth = mainFrame._height;
       
        this._widthScale = resolutionWidth / 480.0;
        this._heightScale = this._widthScale;
        mainFrame = null;
        
        this._knockBackPoint = CGPointMake(0,0);
        this._opponent = null;
        this._power = 1.0;
        this._attackSpeed = 1.0;
        this._hitPointsTotal = 100.0;
        this._damageTimer = 0.0;
        this._armor = 0;
        this._passivePowerChange = this._temporaryPowerChange = 0;
        this._passiveAttackSpeedChange = this._temporaryAttackSpeedChange = 0;      
        this._passiveDamageReduction = this._temporaryDamageReduction = 0;
        this._hitPointsTotalChange = 0;
        this._fightColor = ccc3(255,255,255);
        this._attacking = false;
        this._canInterrupt = true;
        this._isGettingBuffed = false;
        this._lifeBarOffset = ccp(0,0);
        this._stunTimer = 0;

        this._lifeBG = CCColorLayer.layerWithColor(ccc4(0x30,0x0,0x0,0xFF), 50 * this._widthScale, 10 * this._heightScale);
        this._lifeBar = CCColorLayer.layerWithColor(ccc4(0xFF,0x0,0x0,0xFF), 46 * this._widthScale, 6 * this._heightScale);
        this._lifeBarTemp = CCColorLayer.layerWithColor(ccc4(0xFF,0x0,0x0,0xFF), 46 * this._widthScale, 6 * this._heightScale);

        this._lifeBG.setAnchorPoint(ccp(0,.5));
        this._lifeBG.setOpacity(0x0);
        
        this._lifeBar.setAnchorPoint(ccp(0,.5));
        this._lifeBar.setScale(0.0, 1.0);
        this._lifeBar.setOpacity(0x0);
        
        this._lifeBarTemp.setAnchorPoint(ccp(0,.5));
        this._lifeBarTemp.setScale(0.0, 1.0);
        this._lifeBarTemp.setOpacity(0x0);
        
        //the bars are offscreen until their position is updated in tick
        this._lifeBG.setPosition(CGPointMake(0, -this._lifeBG.getSize()._height));
        this._lifeBar.setPosition(CGPointMake(0, -this._lifeBar.getSize()._height));
        this._lifeBarTemp.setPosition(CGPointMake(0, -this._lifeBarTemp.getSize()._height));
        
        this._throwTiming = 0;
        this._throwOffset = ccp(0,0);
        this._throwParticles = null;
        
        this._specialAttack = null;
        this._invincible = false;
	},
	
	destroy : function()
	{
        this._knockBackPoint = null;
        this._fightColor = null;
        this._lifeBarOffset = null;
        this._throwOffset = null;
		this._throwParticles.length = 0;
		this._throwParticles = null;
		this._opponent = null;
		this._currentAttackVariation = null;
		this._specialAttack = null;
		
		destroyWithChildren(this._lifeBG);
		this._lifeBG = null;
		
		destroyWithChildren(this._lifeBar);
		this._lifeBar = null;
		
		destroyWithChildren(this._lifeBarTemp);
		this._lifeBarTemp = null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/FightGameScene/GUI/ZFToolTipLayer'] = function(){var exports = $MODULE_REGISTRY['Code/Game/FightGameScene/GUI/ZFToolTipLayer'] || {}; $MODULE_REGISTRY['Code/Game/FightGameScene/GUI/ZFToolTipLayer'] = exports; exports.ZFToolTipLayer = CCColorLayer.subclass(
{
	classname: 'ZFToolTipLayer',
	
	initialize: function()
	{	
	    this._isTouchEnabled = true;		
	},
	
	ccTouchBegan: function(touch, event)
	{
		return true;
	},
	
	ccTouchEnded: function(touch, event)
	{
		ZFFightGUI.startButtonPressed(this);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/FightGameScene/GUI/ZFFightBubble'] = function(){var exports = $MODULE_REGISTRY['Code/Game/FightGameScene/GUI/ZFFightBubble'] || {}; $MODULE_REGISTRY['Code/Game/FightGameScene/GUI/ZFFightBubble'] = exports; exports.ZFFightBubble = CCColorLayer.subclass(
{
	classname: 'ZFFightBubble',
	//- (id) initWithColor:(ccColor4B)color width:(GLfloat)w  height:(GLfloat) h
	
	initialize : function()
	{
		this._zombie = null; //ZombieActor
		this._meter = 0; //float
		this._meterBG = null; // CCColorLayer
		this._meterBar = null; //CCColorLayer
		this._rollCount = 0; //int
		
		this._target = new GL2.TouchTarget();
		this._target.setAnchor(new Core.Point(0.5, 0.5));
		this._target.setPosition(new Core.Point(50,-110));
		
		this._listener = new Core.MessageListener();
		this._target.getTouchEmitter().addListener(this._listener, this.onBubbleTouch.bind(this));
		this.addChild(this._target);
		this._target.setDepth(100000);
	},
	
	initWithColor: function($super, color, w, h)
	{
		$super(color, w, h);
			
		var screenSize = new Core.Size(960,640);
	    var resolutionWidth = screenSize._height;
		
		var widthScale = resolutionWidth / 480;
	    var heightScale = widthScale; //resolutionHeight / 320;
		
		this._isTouchEnabled = true;
		this._rollCount = 0;
		this._meter = 0.0;
		this._target.setSize(w*3/5, h*3/5);
		
		this._meterBG = CCColorLayer.layerWithColor(ccc4(0,0,0, 0xff), 60*widthScale, 10*heightScale);
		this._meterBar = CCColorLayer.layerWithColor(ccc4(0x7F,0xF6,0xF8,0xff), 58*widthScale, 8*heightScale);
		
		this._meterBG.setAnchorPoint(ccp(0,0.5));
		this._meterBG.setOpacity(0);
		
		this._meterBar.setAnchorPoint(ccp(0,0.5));
		this._meterBar.setScale(0, this._meterBar.getScale()._y);
		this._meterBar.setOpacity(0);
		
		this.addChild(this._meterBG, 0);
		this.addChild(this._meterBar, 1);
	},

	setAllPositions : function(){

		
//		var a = this._zombie._attachments[kActorPartTagHead];
//    	var pos = {_x: 30 * (a._sprite._flipX ? 1 : -1), _y: 25};
//    	pos._x += a._lastFramePosition._x;
//		pos._y += a._lastFramePosition._y;
//		
//		pos._x *= this._zombie._spriteMan._totoScale._x;
//		pos._y *= this._zombie._spriteMan._totoScale._y;
		
		var pos = this._zombie.getHeadPosition();
		
		this._target.setPosition(this._target._position._x-20, -(pos._y+32) );
//		this._zombie._thoughtBubble.setPosition(pos);
		this._meterBG.setPosition(-10,pos._y+80);
		this._meterBar.setPosition(this._meterBG._ccPosition._x + 1, this._meterBG._ccPosition._y + 1);
	},
	//-(void)dealloc
	destroy: function()
	{
		destroy(this._meterBG);
		this._meterBG = null;
		
		destroy(this._meterBar);
		this._meterBar = null;
		
		destroy(this._target);
		this._target = null;
	},

	onBubbleTouch : function(touch)
	{
		switch(touch.getAction())
		{
			case touch.Action.Start:
					ZFFightGUI.thoughtButtonPressed(this);
					return true;
				break;
		}
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/FightGameScene/GUI/ZFFightGUI'] = function(){var exports = $MODULE_REGISTRY['Code/Game/FightGameScene/GUI/ZFFightGUI'] || {}; $MODULE_REGISTRY['Code/Game/FightGameScene/GUI/ZFFightGUI'] = exports; var ZFGameDefines = require('Code/Game/ZFGameDefines').ZFGameDefines;
var ZFFightAbilityGUI = require('Code/Game/FightGameScene/GUI/ZFFightAbilityGUI').ZFFightAbilityGUI;

exports.ZFFightGUI = CCLayer.singleton({
    classname: 'ZFFightGUI',
    	
    fightBubbleTags :
    {
        kFightBubbleTagQuestionMark : 100,
        kFightBubbleTagGo : 101
    },
    
    $fightGuiTags : // all of these must be textureNodes
    {
        kFightGuiTagGo : 100,
        kFightGuiTagHelperArrow : 101,
        kFightGuiTagAbilityHelperArrow : 102,
        kFightGuiTagFailedText : 103,
        kFightGuiTagFailedTextShadow : 104,
        kFightGuiTagEnemyCount : 105,
        kFightGuiTagEnemyCountShadow : 106,
        kFightGuiTagEnemyIcon : 107,
        kFightGuiTagZombieCount : 108,
        kFightGuiTagZombieCountShadow : 109,
        kFightGuiTagZombieIcon : 110,
        kFightGuiTagHUD : 111,
        kFightGuiTagZombieProgress : 112,
        kFightGuiTagEnemyProgress : 113,
        kFightGuiTagHUDMgr : 114,
        kFightGuiTagEnrageTimer : 115,
        kFightGuiTagEnrageTimerBG : 116,
        kFightGuiTagEnrageSprite : 117,
        kFightGuiTagDoOrDieLayer : 118,
        kFightGuiTagDoOrDieParticles : 119,
        kFightGuiTagDoOrDieSprite : 120,
        kFightGuiTagMAX : 121
    },
    
    $gui : function()
    {
        return this;
    },
    
    initialize : function()
    {
    	// FIXME: Just for now
        this._resolutionWidth = 960;
        this._resolutionHeight = 640;
        
        //FIXME: Check resolution
        this._widthScale = this._resolutionWidth / 480.0;
        this._heightScale = this._resolutionHeight / 320.0;
        
        this._toolTip = null; //CCLabel
    	this._toolTipBG = null; //ZFToolTipLayer
    	this._fightBubble = null; //ZFFightBubble
    	this._zombieCount = null; //CCLabel
    	this._enemyCount = null; //CCLabel
    	this._zombieCountShadow = null; //CCLabel
    	this._enemyCountShadow = null; //CCLabel
    	
    	this._currentEnemyMaxHp = 0; //float
    	
    	this._zombieProgress = null; //CCColorLayer
    	this._enemyProgress = null; //CCColorLayer
    	this._abilityButtons = null; //CCLayer
    	this._abilityButtonList = []; //NSMutableArray
    	this._buffIcons = null; //NSMutableArray
    },
    
    //- (void)initElements:(NSDictionary*)enemyDict
    initElements : function(enemyDict)
    {    
    	
    	this._exclamationMark = CCSprite.spriteWithFile("exclamationButton.png");
    	this._questionMark = CCSprite.spriteWithFile("questionMarkButton.png");
    	
        var mgrTemp = CCSpriteSheet.spriteSheetWithFile(ZFGameDefines.HUDELEMENTS1_FILE);
        var hud = CCSprite.spriteWithSpriteSheet(mgrTemp, CGRectMake(0, 343, 480, 32));
        mgrTemp.addChild(hud, 1, this.fightGuiTags.kFightGuiTagHUD);
        this.addChild(mgrTemp, 0, this.fightGuiTags.kFightGuiTagHUDMgr);
        hud.setAnchorPoint(0,1);
		hud.setPosition(ccp(0, this._resolutionHeight));
		hud.setScale(hud._totoScale._x * (this._widthScale), hud._totoScale._y*this._widthScale);
        
        //labels
        var icon = CCSprite.spriteWithFile("zombieIcon.png");
        icon.setPosition(new Core.Point(2 * this._widthScale, (320 - 16) * this._heightScale));
        icon.setAnchorPoint(ccp(0, 0.5));
        icon.setScale(0.75 * this._widthScale);
        this.addChild(icon, 1, this.fightGuiTags.kFightGuiTagZombieIcon);
        
        var sizeFont = (this._widthScale > 1) ? 32 : 18;
        
        this._zombieCountShadow = CCLabel.labelWithString("0", "AmericanTypewriter-Bold", sizeFont);
        this._zombieCount = CCLabel.labelWithString("0", "AmericanTypewriter-Bold", sizeFont);
        
        this._zombieCountShadow.setColor(ccc3(0, 0, 0));
        this._zombieCountShadow.setAnchorPoint(new Core.Point(0, 0.5));
        this._zombieCountShadow.setPosition(2 * this._widthScale + 40 +icon.getContentSize()._width +2, (320 - 16) * this._heightScale + 2);
        
        this._zombieCount.setAnchorPoint(new Core.Point(0, 0.5));
        this._zombieCount.setPosition(2 * this._widthScale + 40 +icon.getContentSize()._width, (320 - 16) * this._heightScale);        
    
        this.addChild(this._zombieCount, 2, this.fightGuiTags.kFightGuiTagZombieCount);
        this.addChild(this._zombieCountShadow, 1, this.fightGuiTags.kFightGuiTagZombieCountShadow);
        
        if (this._widthScale > 1)
        {
//        	var winSize = new Core.Size(960, 640);
//            
//          var clr = ZFColorDefines.colorMenuQuestDarkBrown;
//          var clrBG = CCColorLayer.layerWithColor(ccc4(clr.getRed(), clr.getGreen(), clr.getBlue(), 1), winSize._width, 85);
//          clrBG.setPosition(ccp(0, winSize._height - 85));
//          this.addChild(clrBG, -1);
//            
//          var clrBG2 = CCColorLayer.layerWithColor(ccc4(0, 0, 0, 0x80), winSize._width, 6);
//          clrBG2.setPosition(ccp(0, winSize._height - 91));
//          this.addChild(clrBG2, -1);
        }
        
        var iconName = null;
        
        if (enemyDict && enemyDict ["enemyIcon"])
        {
            iconName = enemyDict["enemyIcon"];
        }
        else
        {
            iconName = "enemyIcon.png";
        }
        
        icon = CCSprite.spriteWithFile(iconName);
        
        icon.setPosition(new Core.Point((480 - 0) * this._widthScale, (320 - 13) * this._heightScale));
        icon.setAnchorPoint(new Core.Point(1, 0.5));
        icon.setScale(0.75 * this._widthScale);
        this.addChild(icon, 1, this.fightGuiTags.kFightGuiTagEnemyIcon);
        
        this._enemyCount = CCLabel.labelWithString("0", "AmericanTypewriter-Bold", sizeFont);
        this._enemyCountShadow = CCLabel.labelWithString("0", "AmericanTypewriter-Bold", sizeFont);
        
        this._enemyCount.setAnchorPoint(new Core.Point(1, 0.5));
        this._enemyCount.setPosition(480 * this._widthScale - icon.getContentSize()._width - 30, (320 - 16) * this._heightScale);
        
        this._enemyCountShadow.setColor(ccc3(0, 0, 0));
        this._enemyCountShadow.setAnchorPoint(new Core.Point(1, 0.5));        
        this._enemyCountShadow.setPosition(480 * this._widthScale - icon.getContentSize()._width - 30 +2, (320 - 16) * this._heightScale + 2);
        
        this.addChild(this._enemyCount, 2, this.fightGuiTags.kFightGuiTagEnemyCount);
        this.addChild(this._enemyCountShadow, 1, this.fightGuiTags.kFightGuiTagEnemyCountShadow);
        
        
        this._zombieProgress = CCColorLayer.layerWithColor(ccc4(0xFF, 0xE6, 0x66, 0xFF), 98*this._widthScale, 16*this._heightScale);
//        this._zombieProgress.setAnchorPoint(new Core.Point(0, 0.5));
//        this._zombieProgress.setScale(1.0/**this._widthScale*/, this._zombieProgress.getScale()._y);
//        this._zombieProgress.setPosition(ccp(60 * this._widthScale, (320 - 16) * this._heightScale));
        this._zombieProgress.setPosition(67*this._widthScale,this._resolutionHeight-14*this._heightScale);
        this.addChild(this._zombieProgress, 1, this.fightGuiTags.kFightGuiTagZombieProgress);

        this._enemyProgress = CCColorLayer.layerWithColor(ccc4(0xFF, 0xE6, 0x66, 0xFF), 98 * this._widthScale, 16 * this._heightScale);
//        this._enemyProgress.setAnchorPoint(new Core.Point(1.0, 0.5));
//        this._enemyProgress.setScale(1.0/**this._widthScale*/, this._enemyProgress.getScale()._y);
//        this._enemyProgress.setPosition(ccp((480 - 66 - 98) * this._widthScale, (320 - 16) * this._heightScale));
        this._enemyProgress.setPosition(this._resolutionWidth-(67+98)*this._widthScale,this._resolutionHeight-14*this._heightScale);
        this.addChild(this._enemyProgress, 1, this.fightGuiTags.kFightGuiTagEnemyProgress);
        
        var aux = CCColorLayer.layerWithColor(ccc4(0xFF, 0xFF, 0xFF, 0x00), this._resolutionWidth, this._resolutionHeight);
        this._abilityButtons = aux;
        
        this._abilityButtonList = [];
        this._buffIcons = [];
        this.addChild(this._abilityButtons, 3);
    },
    
    //- (void)updateZombieCount
    updateZombieCount : function()
    {
        if (this._zombieCount && this._zombieCountShadow) {
            var count = ZFFightMan._zombieCount ? ZFFightMan._zombieCount : 0;
            this._zombieCount.setString(count+"");
            this._zombieCountShadow.setString(count+"");
        }
    },
    
    //- (void)updateEnemyCount
    updateEnemyCount : function()
    {
        if (this._enemyCount && this._enemyCountShadow) {
        	var count = ZFFightMan._enemyPopulation ? ZFFightMan._enemyPopulation : 0;
            count = count < 0 ? 0 : count;
            this._enemyCount.setString(count+"");
            this._enemyCountShadow.setString(count+"");
        }
    },
    
    //- (void)displayLongToolTip:(NSString*)text duration:(float)duration
    displayLongToolTip : function(text, duration)
    {
        this.removeToolTip();
        
        if (!this._toolTipBG)
        {
            this._toolTipBG = ZFToolTipLayer.layerWithColor(ccc4(0x0,0x0,0x0, 0xBF), 480 * this._widthScale, 100);
            this._toolTipBG.setPosition(new Core.Point(0.0, 70));
            this.addChild(this._toolTipBG, -1);
        }
        
        if (!this._toolTip)
        {
            this._toolTip = CCLabel.labelWithString(text, (new Core.Size(400 * this._widthScale, 100)), GL2.Text.HorizontalAlign.Center, "AmericanTypewriter", 22);
            this._toolTip.setAnchorPoint(new Core.Point(0.5, 0.5));
            this._toolTipBG.addChild(this._toolTip, 2);
            this._toolTip.setPosition(460,
            		this._toolTipBG.getContentSize()._height/2 - 45);
            var toolTipShadow = CCLabel.labelWithString(text, (new Core.Size(400 * this._widthScale, 100)), GL2.Text.HorizontalAlign.Center, "AmericanTypewriter", 22);
            toolTipShadow.setAnchorPoint(new Core.Point(0.5, 0.5));
            toolTipShadow.setColor(ccc3(0x0, 0x0, 0x0));
            this._toolTipBG.addChild(toolTipShadow, 1);
            toolTipShadow.setPosition(460 + 2,
            		this._toolTipBG.getContentSize()._height/2 - 45+ 2);
        }
        
        if (duration)
        {
            this.schedule(this.removeToolTipIn, duration, "removeToolTipIn");
        }
    },
    
    //- (void)displayToolTip:(NSString*)text duration:(float)duration
    displayToolTip : function(text, duration)
    {
        this.removeToolTip();
        
        if (!this._toolTipBG)
        {
//            if (this._widthScale > 1)
//            {
//                this._toolTipBG = ZFToolTipLayer.layerWithColor(ccc3(0x0, 0x0, 0x0), 480.0 * this._widthScale, 50.0);
//                this._toolTipBG.setAlpha(0xBF / 0xFF);
//            }
//            else
            {
                this._toolTipBG = ZFToolTipLayer.layerWithColor(ccc3(0x0, 0x0, 0x0), 480.0 * this._widthScale, 50.0 * this._heightScale);
                this._toolTipBG.setAlpha(0xBF / 0xFF);
            }
            
            this._toolTipBG.setPosition(new Core.Point(0, 100));
            this.addChild(this._toolTipBG, -1);
        }
        
        if (!this._toolTip)
        {
            this._toolTip = CCLabel.labelWithString(text, "AmericanTypewriter-Bold", 25);
            this._toolTip.setAnchorPoint(new Core.Point(0.5, 0.5));
            this._toolTipBG.addChild(this._toolTip, 2);
            this._toolTip.setPosition(460,
            		this._toolTipBG.getContentSize()._height/2 - 45);
            
            
            this._toolTip.runAction(
                    CCRepeatForever.actionWithAction(
                            CCSequence.actions([
                                    CCFadeTo.actionWithDuration(0.5, 0xBF),
                                    CCFadeTo.actionWithDuration(0.5, 0xff), null
                                    ])));
            
        	
            var toolTipShadow = CCLabel.labelWithString(text, "AmericanTypewriter-Bold", 25);
            toolTipShadow.setAnchorPoint(new Core.Point(0.5, 0.5));
            toolTipShadow.setColor(ccc3(0x0, 0x0, 0x0));
            this._toolTipBG.addChild(toolTipShadow, 1);
//            toolTipShadow.setPosition(ccp(this._toolTipBG.getContentSize()._width/2 + 2,
            toolTipShadow.setPosition(460 + 2,
            		this._toolTipBG.getContentSize()._height/2 +2 - 45);
        }
        
        if (duration)
        {
            this.schedule(this.removeToolTipIn, duration, "removeToolTipIn");
        }
    },
    
    //- (void)displayToolTip:(NSString*)text withInfo:(NSString*)info duration:(float)duration
    displayToolTip_withInfo : function(text, info, duration)
    {
        this.displayToolTip(text, duration);
        
        for ( var i = 0; i < this._toolTipBG._children.length; ++i)
        {
            var label = this._toolTipBG._children[i];
            label.setPosition(ccpAdd(label.getPosition(), ccp(0, 10)));
        }
        
        var toolTipInfoShadow = CCLabel.labelWithString(info, "AmericanTypewriter", 18);
        toolTipInfoShadow.setAnchorPoint(new Core.Point(0.5, 0.5));
        toolTipInfoShadow.setColor(ccc3(0x0, 0x0, 0x0));
        this._toolTipBG.addChild(toolTipInfoShadow, 1);
        toolTipInfoShadow.setPosition(460+2, -30+2);
        
        var toolTipInfo = CCLabel.labelWithString(info, "AmericanTypewriter", 18);
        toolTipInfo.setAnchorPoint(new Core.Point(0.5, 0.5));
        toolTipInfo.setColor(ccc3(0xFF, 0xFF, 0xFF));
        this._toolTipBG.addChild(toolTipInfo, 2);
        toolTipInfo.setPosition(460, -30);
        
        var scale = CCDirector.zoomValue();
		if(scale._x > 1.0)
		{
			this._toolTipBG.setScale(scale);
			this._toolTipBG.setPosition(ccpAdd(this._toolTipBG._ccPosition, ccp(-960*1/8, 0)));
		}
        
    },
    
    //- (void)removeToolTipIn:(ccTime)dt
    removeToolTipIn : function(dt)
    {
        this.removeToolTip();
    },
    
    //- (void)removeToolTip
    removeToolTip : function()
    {
        this.unschedule(this.removeToolTipIn);
        
        if (this._toolTipBG)
        {
//            this._toolTipBG.removeAllChildrenWithCleanup(true);
            this.removeChild(this._toolTipBG, true);
            destroyWithChildren(this._toolTipB);
            this._toolTipBG = null;
            destroyWithChildren(this._toolTip);
            this._toolTip = null;
        }
    },
    
    //- (void)displayThoughtButtonForZombie:(ZombieActor*)zombie
    displayThoughtButtonForZombie : function(zombie)
    {
        this.unschedule(this.removeThoughtButtonIn);
        this.removeThoughtButton();
        
        if (!this._fightBubble)
        {
            this._fightBubble = ZFFightBubble.layerWithColor(ccc4(0xff, 0x0, 0x0, 0x00), 60 * this._widthScale, 60 * this._heightScale);
            this._fightBubble._zombie = zombie;
            this._fightBubble.setAllPositions();
            this.setThought(ZombieActor.zombieThoughts.kZombieThoughtHmm, true, false, false);
            this._fightBubble._rollCount = 1;            
            this._fightBubble._meterBG.runAction(CCSequence.actions([CCDelayTime.actionWithDuration(0.25), CCFadeTo.actionWithDuration(0.25, 255), null]));
            this._fightBubble._meterBar.runAction(CCSequence.actions([CCDelayTime.actionWithDuration(0.25), CCFadeTo.actionWithDuration(0.25, 255), null]));
            this.addChild(this._fightBubble, -1);
        }
        
    },
    
    //- (void)removeThoughtButtonIn:(ccTime)dfaut
    removeThoughtButtonIn : function(dfaut)
    {
        this.unschedule(this.removeThoughtButtonIn);
        this.removeThoughtButton();
    },
    
    //- (void)removeThoughtButton
    removeThoughtButton : function()
    {
        if (this._fightBubble)
        {
            this._fightBubble._zombie = null;
            this._fightBubble.removeAllChildrenWithCleanup(true);
            this.removeChild(this._fightBubble, true);
            destroyWithChildren(this._fightBubble);
            this._fightBubble = null;
        }
    },
    
    //- (void)thoughtButtonPressed:(id)sender
    thoughtButtonPressed : function(sender)
    {
        this.removeToolTip();
        
        if (this.isScheduled(this.newRandomThoughtIn) || this.isScheduled(this.hmmThoughtIn) || this.isScheduled(this.removeThoughtButtonIn))
        {
            return;
        }
        
        if (this._fightBubble._zombie._thought == ZombieActor.zombieThoughts.kZombieThoughtHmm && this._fightBubble._meter < 1.0)
        {
            return;
        }
        
        this.unschedule(this.thoughtAvailableIn);
        this.removeChildByTag(this.fightGuiTags.kFightGuiTagHelperArrow, true);

        this.unschedule(this.showBubbleHelperArrow);
        
        if (this._fightBubble._zombie._thought == ZombieActor.zombieThoughts.kZombieThoughtBrains && this._fightBubble._meter >= 1.0)
        {
            //ready
            this._fightBubble._zombie.talk();
            this.removeChildByTag(this.fightGuiTags.kFightGuiTagGo, true);
            var goButton = CCSprite.spriteWithFile("goButton.png");
//            goButton.setScale(goButton.getScale()._x * this._widthScale, goButton.getScale()._y * this._widthScale);
//            goButton.setScale(30, 30);
            goButton.setPosition(ccpAdd(this._fightBubble._ccPosition, new Core.Point(25 * this._widthScale, 70 * this._heightScale)));
            this.addChild(goButton, 3, this.fightGuiTags.kFightGuiTagGo);
            goButton.setScale(0.5 * this._widthScale);
            goButton.runAction(
                    CCSequence.actions(
                            [CCScaleTo.actionWithDuration(0.25, 1.5 * this._widthScale), CCDelayTime.actionWithDuration(0.25), CCFadeTo.actionWithDuration(0.25, 0), null]));
            
            this._fightBubble._zombie.schedule( this._fightBubble._zombie.fightGoIn, 0, "fightGoIn");
            ZFFightMan._zombieThinking = false;
            ZFFightMan.deploy(1.0); //next zombie
            this._fightBubble.removeChildByTag(this.fightBubbleTags.kFightBubbleTagQuestionMark, false);
            this.removeThoughtButton();
        }
        else
        {
            //say no
            this._fightBubble.removeChildByTag(this.fightBubbleTags.kFightBubbleTagGo, true);
            var noButton = CCSprite.spriteWithFile("noButton.png");
//            noButton.setScale(noButton.getScale()._x * this._widthScale, noButton.getScale()._y * this._widthScale);
            noButton.setPosition(ccpAdd(this._fightBubble._ccPosition, new Core.Point(-100 * this._widthScale, 70 * this._heightScale)));
            this._fightBubble.addChild(noButton, 3, this.fightBubbleTags.kFightBubbleTagGo);
            noButton.setScale(1.25 * this._widthScale);
            noButton.runAction(CCSequence.actions(CCDelayTime.actionWithDuration(0.5), CCFadeTo.actionWithDuration(0.25, 0)));
            this._fightBubble._zombie.setThought(ZombieActor.zombieThoughts.kZombieThoughtNothing);
            this._fightBubble.removeChildByTag(this.fightBubbleTags.kFightBubbleTagQuestionMark, false);
            this.schedule(this.hmmThoughtIn, 1.0, "hmmThoughtIn");
        }
    },
    
    //- (void)newRandomThoughtIn:(ccTime)dt
    newRandomThoughtIn : function(dt)
    {
        this.unschedule(this.newRandomThoughtIn);
        var newthought = 2 + Math.floor((Math.random() * (ZombieActor.zombieThoughts.kZombieThoughtMax - 2)));
        this.setThought(newthought, true, true, false);
        this.schedule(this.showBubbleHelperArrow, 3.0, "showBubbleHelperArrow");
    },
    
    //- (void)showBubbleHelperArrow:(ccTime)dt
    showBubbleHelperArrow : function(dt)
    {
        this.unschedule(this.showBubbleHelperArrow);
        
        if (!this._fightBubble)
        {
            return;
        }
        

        var arrow = CCSprite.spriteWithFile("tap1.png");

        arrow.setScale(0.67 * this._widthScale);
        arrow.setPosition(ccpAdd(this._fightBubble._ccPosition, ccp(20 * this._widthScale, 120 * this._heightScale)));
        this.removeChildByTag(this.fightGuiTags.kFightGuiTagHelperArrow, true);
        this.addChild(arrow, 0, this.fightGuiTags.kFightGuiTagHelperArrow);
		
		arrow.runAction(CCRepeatForever.actionWithAction(
				CCSequence.actions(
				 [CCMoveTo.actionWithDuration(0.25, ccp(arrow._ccPosition._x, arrow._ccPosition._y + 10 * this._widthScale)),
				  CCMoveTo.actionWithDuration(0.25, ccp(arrow._ccPosition._x, arrow._ccPosition._y ))]
				 )));  

        
        //TODO: frameWithTexture, CCTextureCache and addSpriteFrame not implemented
				// var frame1 =
				// CCSpriteFrame.frameWithTexture(CCTextureCache.sharedTextureCache().addImage("tap1.png"),
				// new Core.Rect(0, 0, 64, 64), new Core.Point(0, 0));
//        var frame2 = CCSpriteFrame.frameWithTexture(CCTextureCache.sharedTextureCache().addImage("tap2.png"), new Core.Rect(0, 0, 64, 64), new Core.Point(0, 0));
//        CCSpriteFrameCache.sharedSpriteFrameCache().addSpriteFrame(frame1, "tap1.png");
//        CCSpriteFrameCache.sharedSpriteFrameCache().addSpriteFrame(frame1, "tap2.png");
//        
//        var a = [ frame1, frame2, null ];
//        var animMixed = CCAnimation.animationWithName("TapMe", 1.0, a);
//        
//        var action1 = CCMoveBy.actionWithDuration(0.25, new Core.Point(0.0, 10.0));
//        arrow.runAction(CCRepeatForever.actionWithAction(CCSpawn.actions(CCAnimate.actionWithDuration(0.5, animMixed, false), CCFadeTo.actionWithDuration(0.25, 0xff), CCSequence.actions(action1, action1.reverse(), null), null)));
    },
    
    //- (void)hmmThoughtIn:(ccTime)dt
    hmmThoughtIn : function(dt)
    {
        this.unschedule(this.hmmThoughtIn);
        this._fightBubble._meterBG.runAction(CCFadeTo.actionWithDuration(0.25, 0xff));
        this._fightBubble._meterBar.runAction(CCFadeTo.actionWithDuration(0.25, 0xff));
        this._fightBubble.removeChildByTag(this.fightBubbleTags.kFightBubbleTagQuestionMark, false);
        this.setThought(ZombieActor.zombieThoughts.kZombieThoughtHmm, true, false, false);
    },
    
    //- (void)setThought:(int)newThought  animate:(BOOL)animate addQuestionMark:(BOOL)addQM addExclamationPoint:(BOOL)addEP
    setThought : function(newThought, animate, addQM, addEP)
    {
        this._fightBubble._zombie.setThought(newThought);
        
        if (animate)
        {
        	if (this._fightBubble._zombie._thoughtBubble)
        	{
        		this._fightBubble._zombie._thoughtBubble.setScale(0);
        		this._fightBubble._zombie._thoughtBubble.runAction(CCScaleTo.actionWithDuration(0.25, -1.0 * this._widthScale, 1.0 * this._heightScale));
        	}
        }
        else
        {
        	if (this._fightBubble._zombie._thoughtBubble)
        	{
        		this._fightBubble._zombie._thoughtBubble.setScale(-1.0*this._widthScale, this._fightBubble._zombie._thoughtBubble._totoScale._y);
        	}
        }
        
        if (addQM)
        {
            this.schedule(this.displayPunctuationQuestion, 0.25, "displayPunctuationQuestion");
            this._fightBubble._zombie.startAnim(kActorAnimIdea, true);
        }
        else if (addEP)
        {
            this.schedule(this.displayPunctuationExclamation, 0.25, "displayPunctuationExclamation");
            this._fightBubble._zombie.startAnim(kActorAnimChaseNoWalk, true);
        }
        else
        {
            this._fightBubble._zombie.startAnim(kActorAnimThinking, true);
        }
    },
    
    //- (void)displayPunctuationQuestion:(ccTime)dt
    displayPunctuationQuestion : function(dt)
    {
        this.unschedule(this.displayPunctuationQuestion);
        if (!this._fightBubble)
        {
        	return;
        }
        
//        questionMark.setPosition(new Core.Point(52 * this._widthScale, 60 * this._heightScale));
        this._questionMark.setPosition(ccpAdd(this._fightBubble._ccPosition, CGPointMake(-80 * this._widthScale, 70 * this._heightScale)));
        
        this._fightBubble.addChild(this._questionMark, 3, this.fightBubbleTags.kFightBubbleTagQuestionMark);
        this._questionMark.setScale(0);
        this._questionMark.runAction(CCScaleTo.actionWithDuration(0.25, 1.0 * this._widthScale));
    },
    
    //- (void)displayPunctuationExclamation:(ccTime)dt
    displayPunctuationExclamation : function(dt)
    {
        this.unschedule(this.displayPunctuationExclamation);
        if (!this._fightBubble)
        {
        	return;
        }
    	
//        exclamationMark.setPosition(new Core.Point(52 * this._widthScale, 30 * this._heightScale));
        this._exclamationMark.setPosition(ccpAdd(this._fightBubble._ccPosition, CGPointMake(-80 * this._widthScale, 70 * this._heightScale)));
        
        this._fightBubble.addChild(this._exclamationMark, 3, this.fightBubbleTags.kFightBubbleTagQuestionMark);
        this._exclamationMark.setScale(0);
        this._exclamationMark.runAction(
                CCRepeatForever.actionWithAction(
                        CCSequence.actions(CCScaleTo.actionWithDuration(0.25, 1.25 * this._widthScale), CCScaleTo.actionWithDuration(0.25, 0.75 * this._widthScale))));
    },
    
    //- (void)enableStartButton
    enableStartButton : function()
    {
    	this._target = new GL2.TouchTarget();
		this._target.setAnchor(new Core.Point(0.5, 0.5));
		
		this._target.setPosition(new Core.Point(this._resolutionWidth/2,this._resolutionHeight/2));
		this._target.setSize(new Core.Size(10000,10000));
			
		this._listener = new Core.MessageListener();
		this._target.getTouchEmitter().addListener(this._listener, this.startButtonPressed.bind(this));
		this.addChild(this._target);
		this._target.setDepth(100000);
    },
    
    //- (void)startButtonPressed:(id)sender
    startButtonPressed : function(sender)
    {
    	this.removeChild(this._target);
    	destroy(this._target);
    	this._target = null;
        this.removeToolTip();
        ZFFightMan.startGame();
    },
    
    //- (void) tick: (ccTime) dt
    tick : function(dt)
    {	
        var fm = ZFFightMan;
        //Actor* enemy = fm.enemy;
        var gs = GameState;
        
        if (fm.isGameWon() || fm.isGameLost())
        {
                this.unschedule(this.displayPunctuationQuestion);
                this.unschedule(this.showBubbleHelperArrow);
            
            if (this.getChildByTag(this.fightGuiTags.kFightGuiTagHelperArrow))
            {
                this.removeChildByTag(this.fightGuiTags.kFightGuiTagHelperArrow, true);
            }
            
            if (this._fightBubble && this._fightBubble.getChildByTag(this.fightBubbleTags.kFightBubbleTagQuestionMark))
            {
                this._fightBubble.removeChildByTag(this.fightBubbleTags.kFightBubbleTagQuestionMark, false);
            }
            
            if (this._fightBubble && this._fightBubble._meterBar)
            {
                if (this._fightBubble._meterBar)
                {
                    this._fightBubble._meterBar.setOpacity(0);
                    this._fightBubble._meterBG.setOpacity(0);
                }
                
                if (this._fightBubble._zombie)
                {
                    this._fightBubble._zombie.setThought(ZombieActor.zombieThoughts.kZombieThoughtNothing);
                }
            }
            
            this._zombieProgress.setOpacity(0);
            this._enemyProgress.setOpacity(0);
            
            return;
        }
        
        if (this._zombieProgress._alpha != 1) {
        	this._zombieProgress.setAlpha(1);
        }

        if (this._enemyProgress._aplha != 1) {
        	this._enemyProgress.setAlpha(1);
        }
        
        var newScale = fm._zombieCount/gs.maxArmySize();
        if (newScale != this._zombieProgress.__lastScale) {
        	this._zombieProgress.setScale(fm._zombieCount/gs.maxArmySize(), 1);
            this._zombieProgress.__lastScale = newScale;
        }
        
        
//        this._enemyProgress.setScale(0.75 * ( fm._enemyPopulation / fm._enemyDictionary["population"]), 1);     
//        this._enemyProgress.setScale(0.25 * ((fm._boss != fm._enemy) ? 1.0 : (fm._boss._fightData._hitPoints / this._currentEnemyMaxHp)) * this._enemyProgress.getScale()._x,1);
        
        //FIXME: (fm._enemyPopulation/5) for (fm._enemyPopulation/fm._enemyDictionary["population"])
        var enemyProgressWidth = 0.75 * ( fm._enemyPopulation / fm._enemyDictionary.population) + 0.25 * ((fm._boss != fm._enemy) ? 1.0 : (fm._boss._fightData._hitPoints / this._currentEnemyMaxHp));
        enemyProgressWidth = Math.max(0,enemyProgressWidth);
        if (this._enemyProgress.__lastScale != enemyProgressWidth) {
        	this._enemyProgress.setScale(enemyProgressWidth,1);
            this._enemyProgress.setPosition(this._resolutionWidth-(67+98*enemyProgressWidth)*this._widthScale,this._resolutionHeight-14*this._heightScale);
        }
        
        var fb = this._fightBubble;
        if (fb && fb._zombie)
        {        	
            var a = fb._zombie._attachments[kActorPartTagHead];
//            if (a._lastFramePosition._x != fb._lastFramePosition_x) {
            	var scale = fb._zombie._spriteMan._totoScale._y;
                var pos = ccpF(30, 25);
                ccpAddF(pos,a._lastFramePosition);
                ccpMultF(pos,scale);
                
                if(fb._zombie instanceof ZombieActorHeadless)
    				pos._y -= 60;
    				
                fb._zombie._thoughtBubble && fb._zombie._thoughtBubble.setPosition(pos._x,pos._y);
                fb.setPosition(pos._x,fb._ccPosition._y);
//                fb.setPosition(ccpAdd(pos, new Core.Point(-15 * this._widthScale, -15 * this._heightScale)));
//                fb._lastFramePosition_x = fb._zombie._thoughtBubble ? a._lastFramePosition._x : null;
//            }
            
            
            
            if (fb._zombie._thought == ZombieActor.zombieThoughts.kZombieThoughtHmm && !this.isScheduled(this.randomThoughtIn))
            {
                if (fb._meter < 1.0 && fb._meterBar._opacity >= 0xff)
                {
                    // original formual : (60/fps)/60  == every update moves it by 1/60 per update not per frame    
                    var fpsComp = (dt / ZFGameDefines.GUI_UPDATE_INTERVAL) * (1 / 60);
                    var meterIncrement = 1.0 + (ZFGameDefines.PREP_CHARGE_TIME_MAX * (1.0 - fb._zombie._hunger));
                    
                    if (!(gs._zfGameData._gflags & ZFGameFlags.GFLAG_FIGHT_TUTORIAL))
                    {
                        meterIncrement = ZFGameDefines.PREP_CHARGE_TIME_MAX;
                    }
                    
                    fb._meter += fpsComp / meterIncrement;
                    
                    if (fb._meter >= 1.0)
                    {
                        fb._meter = 1.0;
                        this.setThought(ZombieActor.zombieThoughts.kZombieThoughtBrains, true, false, true);
                        this.schedule(this.showBubbleHelperArrow, 3.0, "showBubbleHelperArrow");
                        fb.removeChild(fb._meterBar, true);
                        fb.removeChild(fb._meterBG, true);
                        destroy(fb._meterBar);
                        fb._meterBar = null;
                        destroy(fb._meterBG);
                        fb._meterBG = null;
                        
                        if (!(gs._zfGameData._gflags & ZFGameFlags.GFLAG_FIGHT_TUTORIAL))
                        {
	                    	this.displayLongToolTip(NSLocalizedString("Now he's ready to boogie!\nTap on his thought again to send him off to battle.", null), 0);
	                        gs._zfGameData._gflags |= ZFGameFlags.GFLAG_FIGHT_TUTORIAL;
	                        fm.schedule(fm.updateTimer, 1.0, "updateTimer");
	                        ZFAchievementChecker.checkFightTutorialDone();
	                        
	                        //Unlock Achievement through Facebook
	                        var gui = ZFGuiLayer.gui();
	                        //TODO publishAchievement needs FB Man
//	                        gui.publishAchievement("com.zombiefarm.fight.tutorial_done", "com.zombiefarm.fight.tutorial_done.description", "com.zombiefarm.fight.tutorial_done.image");

                        }
                    }
                    else
                    {
                        fb._meterBar.setScale(fb._meter, fb._meterBar._totoScale._y );
                        
                        if (fb._meter >= 0.25 * fb._rollCount)
                        {
                            fb._rollCount++;
                            
                            // random value from 0 - 1
                            var randomValue = Math.random();
                            // distraction value from 0.23 to 1
                            var distractionValue = (randomValue + (0.23 * (1.0 - randomValue)));
                            
                            var isDistracted = (distractionValue > fb._zombie._hunger - 0.03);
                            
                            if (!(gs._zfGameData._gflags & ZFGameFlags.GFLAG_FIGHT_TUTORIAL))
                            {
                                if (fb._rollCount == 2)
                                {
                                    this.displayLongToolTip(NSLocalizedString("Zombies will sometimes get distracted.\nTap on his thought to keep him focused.", null), 0);
                                    isDistracted = true;
                                }
                                else if (fb._rollCount == 3)
                                {
                                    this.displayLongToolTip(NSLocalizedString("Zombies can't focus on brains if they're not hungry. Be sure to starve your zombies!", null), 0);
                                    
                                    // Some zombie types are smarter than others.\nSmart zombies don't get distracted as much." duration:0];
                                    isDistracted = true;
                                }
                                else if (fb._rollCount == 4)
                                {
                                    this.displayLongToolTip(sprintf(NSLocalizedString("Starved zombies are better at fighting.\nIt takes %i hours for a zombie to starve."), Math.floor(ZFGameDefines.ZOMBIE_HUNGER_DURATION / 60 / 60)), 0);
                                    isDistracted = true;
                                    
                                }
                                else
                                {
                                    isDistracted = false;
                                }
                            }
                            if (isDistracted)
                            {
                                this.newRandomThoughtIn(0);
                                fb._meterBG.runAction(CCFadeTo.actionWithDuration(0.25, 0x80 ));
                                fb._meterBar.runAction(CCFadeTo.actionWithDuration(0.25, 0x80 ));
                            }
                        }
                    }
                }
            }
        }
    },
    
    //- (void)initEnrageTimer
    initEnrageTimer : function()
    {
        var fm = ZFFightMan;
        
        var enrage = fm._boss.getAbilityByTag(kFightEffectEnemyBuffEnrage);
        
        // enrage timer
        if (fm._boss && enrage)
        {
        	
            var fntFile = "ABD26.fnt";
            
            var spriteRect = CGRectMake(414, 287, 66, 32);
            var enrageTimerBG = CCSprite.spriteWithFile(ZFGameDefines.HUDELEMENTS1_FILE, spriteRect);
            enrageTimerBG.setScale(this._widthScale, this._heightScale);
            var w = CCDirector.winSize();
//            enrageTimerBG.setScale(enrageTimerBG.getScale()._x * this._widthScale, enrageTimerBG.getScale()._y * this._widthScale);
            //FIXME: ZombieFarmAppDelegate doesn't exist
            if (true/*ZombieFarmAppDelegate.getCurrentLanguage() == "zh-Hant" ||
                ZombieFarmAppDelegate.getCurrentLanguage() == "zh-Hans" ||
                ZombieFarmAppDelegate.getCurrentLanguage() == "ja"*/)
            {
                var enrageTimer = CCLabel.labelWithString("-", "Arial", 26);
                
                this.addChild(enrageTimerBG, 5, this.fightGuiTags.kFightGuiTagEnrageTimerBG);
                this.addChild(enrageTimer, 5, this.fightGuiTags.kFightGuiTagEnrageTimer);
                
                enrageTimer.setScale(0.8*this._widthScale);
                enrageTimer.setPosition(ccp(this._resolutionWidth/2, this._resolutionHeight-15*this._heightScale));
                enrageTimerBG.setAnchorPoint(new Core.Point(0.5, 1));
                enrageTimerBG.setPosition(ccp(this._resolutionWidth/2, this._resolutionHeight));
            }
            else
            {
            	//TODO
                //var *enrageTimer = [CCBitmapFontAtlas bitmapFontAtlasWithString:@"-" fntFile:fntFile];
                
                this.addChild(enrageTimerBG, 5, this.fightGuiTags.kFightGuiTagEnrageTimerBG);
                this.addChild(enrageTimer, 5, this.fightGuiTags.kFightGuiTagEnrageTimer);
                
                
                enrageTimer.setScale(0.8 * this._heightScale);
                enrageTimer.setPosition(new Core.Point(w._width / 2, w._height - (15 * this._heightScale)));
                enrageTimerBG.setAnchorPoint(new Core.Point(0.5, 1));
                enrageTimerBG.setPosition(new Core.Point(w._width / 2, w._height));
            }
            
            fm._enrageTime = enrage._timerActivateIn;
            this.updateEnrageTimer();
        }
    },
    
    //- (void)updateEnrageTimer
    updateEnrageTimer : function()
    {
        var fm = ZFFightMan;
        var enrageTime = ZFFightMan._enrageTime;
        
        // if boss exists
        if (fm._boss && fm._boss._fightData._hitPoints > 0 && enrageTime >= 0 && !fm._doOrDie)
        {
            // if enrage timer exists
            //FIXME: ZombieFarmAppDelegate doesn't exist
            if (true/*ZombieFarmAppDelegate.getCurrentLanguage() == "zh-Hant" ||
                ZombieFarmAppDelegate.getCurrentLanguage == "zh-Hans" ||
                ZombieFarmAppDelegate.getCurrentLanguage() == "ja"*/)
            {
                enrageTimer = this.getChildByTag(this.fightGuiTags.kFightGuiTagEnrageTimer);
                if (enrageTimer)
                {
                    
                    var timerMinutes = enrageTime / 60;
                    var timerSeconds = Math.floor(enrageTime % 60);
                    
                    var timerString = sprintf("%d:",timerMinutes);
                    
                    if (timerSeconds < 10)
                    {
                        timerString = timerString + "0";
                    }
                    timerString = timerString + timerSeconds;
                    
                    enrageTimer.setString(timerString);
                    
                    if (enrageTime <= 0)
                        this.doOrDie();
                }
            }
            else
            {
                //TODO
                //CCBitmapFontAtlas *enrageTimer = (CCBitmapFontAtlas*)[self getChildByTag:kFightGuiTagEnrageTimer];
                if (enrageTimer)
                {
                    
                    var timerMinutes = enrageTime / 60;
                    var timerSeconds = enrageTime % 60;
                    
                    var timerString = sprintf("%d:",timerMinutes);
                    
                    if (timerSeconds < 10)
                    {
                        timerString = timerString + "0";
                    }
                    timerString = timerString + timerSeconds;
                    
                    enrageTimer.setString(timerString);
                    
                    if (enrageTime <= 0)
                        this.doOrDie();
                }
            }
            
        }
    },
    
    // add to abilityButtons Layer
    //- (void)doOrDie
    doOrDie: function()
    {
   		SimpleAudioEngine.playBackgroundMusic(kEnrageBGM);
    	
    	ZFFightMan._doOrDie = true;
    	if(true)/*ZombieFarmAppDelegate.getCurrentLanguage() == "zh-Hant" || ZombieFarmAppDelegate.getCurrentLanguage() == "zh-Hans" ||
    	   ZombieFarmAppDelegate.getCurrentLanguage() == "ja")*/
    	{
    		var enrageTimer = this.getChildByTag(this.fightGuiTags.kFightGuiTagEnrageTimer);
    		enrageTimer.runAction(CCRepeatForever.actionWithAction(
    							CCSequence.actions(
    							 [CCFadeTo.actionWithDuration(0.25, 0x00),
    							 CCFadeTo.actionWithDuration(0.25, 0xff)]
    							 )));
    	}
    	else 
    	{
    		/*CCBitmapFontAtlas *enrageTimer = (CCBitmapFontAtlas*)[self getChildByTag:kFightGuiTagEnrageTimer];
    		[enrageTimer runAction:[CCRepeatForever actionWithAction:
    								[CCSequence actions:
    								 [CCFadeTo actionWithDuration:0.25 opacity:0x00],
    								 [CCFadeTo actionWithDuration:0.25 opacity:0xff],
    								 nil]]];
    								 */
    	}

    	
    	var w = CCDirector.winSize();
    	
    	var doOrDieLayer = CCColorLayer.layerWithColor(ccc4(0x0,0x0,0x0,0xd0), 480*this._widthScale, 75*this._heightScale);
    	var doOrDieSprite = CCSprite.spriteWithFile("doOrDieSprite.png");
    	doOrDieLayer.setScale(doOrDieLayer._totoScale._x*this._widthScale, doOrDieLayer._totoScale._y*this._widthScale);
    	doOrDieSprite.setScale(doOrDieSprite._totoScale._x*this._widthScale, doOrDieSprite._totoScale._y*this._widthScale);
    	/*CCQuadParticleSystem *doOrDieEffect = [ZFParticleEffects particleSystemByTag:@"doOrDie.plist"];
    	
    	doOrDieEffect.position = ccp(w.width/2,w.height/2); 
    	doOrDieEffect.scale *= widthScale;
    	*/
    	
    	doOrDieLayer.setPosition(ccp(0,(this._resolutionHeight/2)));
    	doOrDieSprite.setPosition(ccp(this._resolutionWidth/2,this._resolutionHeight/2));
    	
    	this._abilityButtons.addChild(doOrDieLayer, 199, this.fightGuiTags.kFightGuiTagDoOrDieLayer);
    	//this._abilityButtons.addChild(doOrDieEffect, 200, this.fightGuiTags.kFightGuiTagDoOrDieParticles);
    	this._abilityButtons.addChild(doOrDieSprite, 201, this.fightGuiTags.kFightGuiTagDoOrDieSprite);
    	
    	doOrDieLayer.runAction(CCSequence.actions(
    									 [CCScaleTo.actionWithDuration(0.2, 1.2),
    									 CCScaleTo.actionWithDuration(0.2, 1.0)]));
    	doOrDieLayer.runAction(CCSequence.actions(
    									 [CCScaleTo.actionWithDuration(0.2, 1.2),
    									 CCScaleTo.actionWithDuration(0.2, 1.0)]));
    },
    
    //- (void)cleanupDoOrDie
    cleanupDoOrDie : function()
    {
        var doOrDieLayer = this._abilityButtons.getChildByTag(this.fightGuiTags.kFightGuiTagDoOrDieLayer);
        //TODO
        //CCQuadParticleSystem *doOrDieEffect = (CCQuadParticleSystem*)[abilityButtons getChildByTag:kFightGuiTagDoOrDieParticles];
        var doOrDieSprite = this._abilityButtons.getChildByTag(this.fightGuiTags.kFightGuiTagDoOrDieSprite);
        
        if (doOrDieLayer)
            this._abilityButtons.removeChild(doOrDieLayer, true);
        /*if (doOrDieEffect)
            this._abilityButtons.removeChild(doOrDieEffect, true);*/
        if (doOrDieSprite)
            this._abilityButtons.removeChild(doOrDieSprite, true);
    },
    
    //- (void)cleanupEnrageTimer
    cleanupEnrageTimer : function()
    {
        // if enrageTimer child exists then cleanup
        var enrageTimer = this.getChildByTag(this.fightGuiTags.kFightGuiTagEnrageTimer);
        if (enrageTimer)
        {
            this.removeChildByTag(this.fightGuiTags.kFightGuiTagEnrageTimerBG, true);
            this.removeChild(enrageTimer, true);
            destroy(enrageTimer);
            enrageTimer = null;
        }
    },
    
    //- (void)cleanupLocal
    cleanupLocal : function()
    {
        this.unschedule(this.removeToolTipIn);
        this.unschedule(this.removeThoughtButtonIn);
        this.unschedule(this.displayPunctuationQuestion);
        this.unschedule(this.hmmThoughtIn);
        this.unschedule(this.displayPunctuationExclamation);
        this.unschedule(this.tick);
        this.unschedule(this.newRandomThoughtIn);
        this.unschedule(this.showBubbleHelperArrow);
        
        this.getChildByTag(this.fightGuiTags.kFightGuiTagHUDMgr) && this.getChildByTag(this.fightGuiTags.kFightGuiTagHUDMgr).removeChildByTag(this.fightGuiTags.kFightGuiTagHUD, true);
        
        for ( var i = this.fightGuiTags.kFightGuiTagGo; i < this.fightGuiTags.kFightGuiTagMAX; i++)
        {
            this.removeChildByTag(i, true);
        }
        
        if (ZFFightMan._pendingActivatedAbilityList) {
        	for ( var i = 0; i < ZFFightMan._pendingActivatedAbilityList.length; ++i)
            {
                var ability = ZFFightMan._pendingActivatedAbilityList[i];
                var temp = null;
                temp = this._abilityButtons.getChildByTag(ability._tag);
                if (temp)
                {
                    //temp.removeAllChildrenWithCleanup(true);
                    destroyWithChildren(temp);
                }
            }
        }
        
        ZFFightAbilityGUI.cleanup();
        this.removeChild(this._abilityButtons, true);
        destroyWithChildren(this._abilityButtons);
        this._abilityButtons = null;
        
        destroyWithChildren(this._exclamationMark);
        this._exclamationMark = null;
        
        destroyWithChildren(this._questionMark);
        this._questionMark = null;
        
        
        this.removeToolTip();
        this.removeThoughtButton();
        
        destroyWithChildren(this._zombieCount);
        this._zombieCount = null;
        
        destroyWithChildren(this._zombieCountShadow);
        this._zombieCountShadow = null;
        
        destroyWithChildren(this._enemyCount);
        this._enemyCount = null;
        
        destroyWithChildren(this._enemyCountShadow );
        this._enemyCountShadow = null;
        
        if(this._fightBubble)
    	{
        	this.removeChild(this._fightBubble, true);
        	destroyWithChildren(this._fightBubble);
        	this._fightBubble = null;
    	}
        destroyChildren(this);
        
    }
    
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/FightGameScene/ZFActorAbility'] = function(){var exports = $MODULE_REGISTRY['Code/Game/FightGameScene/ZFActorAbility'] || {}; $MODULE_REGISTRY['Code/Game/FightGameScene/ZFActorAbility'] = exports; var ZFBitBank = require('Code/Game/GameState/ZFBitBank').ZFBitBank;

exports.ZFActorAbility = Core.Class.subclass(
{
	classname: 'ZFActorAbility',

	/*
	 * @synthesize unlocked, requiredLifeForce, active, consumable, changeColor,
	 * changeScale, consumed, abilityIcon, abilityName, requiresState;
	 * @synthesize timerActivateIn,timerActivateFor,tag, abilityDescription;
	 * @synthesize tier, flagBit; @synthesize particleEffectWhenActive;
	 */
	
	// returns nil if no abilities, else returns the list of abilities that need
	// to be unlocked
	// +(NSMutableArray*)abilitiesToUnlockForTier:(int)tier
	$abilitiesToUnlockForTier: function(tier)
	{
		var tempAbilities = new Array();
		var abilities = new Array();
		
		// index == 1st zombie effect buff
		var index = kFightEffectZombieEffectsStart + 1;
		while(index < kFightEffectZombieEffectsEnd)
		{
			var ability = new this();
			ability.initBasicDataForTag(index);
			if(ability.implementedAbility())
				if(ability._tier == tier)
					tempAbilities.push(ability);
			index++;
		}
		
		// index == 1st zombie activated ability
		index = kActorActivatedAbilityTagZombieAbilityStart + 1;
		
		while(index < kActorActivatedAbilityTagZombieAbilityEnd)
		{
			var ability = new this();
			ability.initBasicDataForTag(index);
			if(ability.implementedAbility())
				if(ability._tier == tier)
					tempAbilities.push(ability);
			index++;
		}
		
		var gs = GameState;
		for( var i = 0; i < tempAbilities.length; ++i)
		{
			var ability = tempAbilities[i];
			// check flag then add to abilities array
			if(!(gs._zfGameData._abilityFlags.hasFlag(ability._flagBit)))
				abilities.push(ability);
		}
		
		if(abilities.length == 0)
			abilities = null;
		return abilities;
	},
	
	// -(ZFActorAbility *) init
	initialize: function()
	{
		this._unlocked	= false; 
		this._active	= false;
		this._consumable  = false;
		this._consumed    = false;
		this._changeColor = false;
		this._changeScale = false;
		this._requiredLifeForce = -1;
		this._abilityName = null;
		this._abilityIcon = null;
		this._requiresState = kActorFightStateEnterFight;	
		this._timerActivateIn = -1;
		this._timerActivateFor = -1;
		this._tag = -1;
		this._tier = 0;
		this._flagBit = -1;
		this._particleEffectWhenActive = null;
	
        return this;
	},
	
	// -(BOOL)canActivateInState:(int)state
	canActivateInState: function(state)
	{
		var answer = false;
		
		// if required state is zombie must enter the fight
		// check the 3 states that shoes the zombie fighting
		if(this._requiresState == kActorFightStateEnterFight)
		{
			// once on it is always on
			if(this._active)
				answer = true;
			else if(!this._active && (state == kActorFightStateEnterFight ||
								state == kActorFightStateFight	    ||
								state == kActorFightStateFighting	||
								state == kActorFightStateUsingAbilityAtRange))
				answer = true;
			
			// only death can deactivate
		}
		else 
		{
			// this is for any non-fighting state
			// such as fightStatePrepCycle (attach mini)
			// or fightStateGoing (laser beams)
			if(state == this._requiresState || this._requiresState == kActorFightStateAny)
				answer = true;
		}
	
		if(state == kActorFightStateDying || state == kActorFightStateDead)
			answer = false;
		
		return answer;
		
	},
	
	// -(BOOL)isUseable
	isUseable: function()
	{
		// you can only use abilities that are unlocked and not consumed (i.e. 1
		// time use)
		// only active abilities are checked for this or abilities that are
		// going to be active
		return (!this._consumed && this._unlocked);
	},
	
	// -(void)refreshTimers
	refreshTimers: function()
	{
		// override me
	},
	
	// -(void)initBasicDataForTag:(int)abilityTag;
	initBasicDataForTag: function(abilityTag) // int
	{	
		this._tag = abilityTag;
		
		// farm info variables
		this._unlocked	= false; 
		this._active		= false;
	
		this._requiredLifeForce = -1;
		
		// cosmetic
		this._changeColor = false;
		this._changeScale = false;
		
		// if ability is consumable then it is a 1-time use (e.g. explosion,
		// ressurect)
		this._consumable  = false;
		this._consumed    = false;
	
		this._abilityName = null;
		this._abilityIcon = null;
		
		// sets what state to activate the ability in
		this._requiresState = kActorFightStateEnterFight;	
		
		// these are set in the ZFActorFightEffect / ZFActorActivatedAbility
		this._timerActivateIn = -1;
		this._timerActivateFor = -1;
		this._particleEffectWhenActive = null;
	    
		switch(this._tag)
		{
	// PLAYER BUFFS //
			case kFightEffectSelfBuffToAllStats:
			{
				this._abilityName = Core.Localization.getString("+5% All Stats");
				this._abilityDescription = Core.Localization.getString("Zombie is a little stronger");
				this._abilityIcon = "ability_buffAllStats.png";
				this._requiredLifeForce = 30;
				this._tier = 1;
				this._flagBit = kAbilityBitsSelfBuffToAllStats;
			}
				break;
			case kFightEffectSelfBuffSpeed:
			{
				this._abilityName = Core.Localization.getString("+10% Speed");
				this._abilityDescription = Core.Localization.getString("Zombie attacks faster");
				this._abilityIcon = "ability_attackSpeedBuff.png";
				this._requiredLifeForce = 30;
				this._tier = 1;
				this._flagBit = kAbilityBitsSelfBuffSpeed;
			}
				break;
			case kFightEffectSelfBuffPower:
			{
				this._abilityName = Core.Localization.getString("+10% Power");
				this._abilityDescription = Core.Localization.getString("Zombie hits harder");
	
				this._abilityIcon = "ability_powerBuff.png";
				this._requiredLifeForce = 30;
				this._tier = 1;
				this._flagBit = kAbilityBitsSelfBuffPower;
			}
				break;
			case kFightEffectSelfBuffHitPoints:
			{
				this._abilityName = Core.Localization.getString("+10% Life");
				this._abilityDescription = Core.Localization.getString("Zombie is tougher");
	
				this._abilityIcon = "ability_hitPointsBuff.png";
				this._requiredLifeForce = 30;
				this._tier = 1;
				this._flagBit = kAbilityBitsSelfBuffHitPoints;
			}
				break;
			case kActorActivatedAbilityTagHeal:
			{
				this._abilityName = Core.Localization.getString("Heal");
				this._abilityDescription = Core.Localization.getString("Heal other zombies");
	
				this._abilityIcon = "ability_heal.png";
				this._requiredLifeForce = 30;
				this._tier = 1;
				this._flagBit = kAbilityBitsHeal;
			}
				break;
			case kFightEffectChivalry:
			{
				this._abilityName = Core.Localization.getString("Chivalry");
				this._abilityDescription = Core.Localization.getString("Girl zombies are stronger around you");
				this._abilityIcon = "ability_chivalry.png";
				this._requiredLifeForce = 65;
				this._tier = 2;
				this._flagBit = kAbilityBitsChivalry;
			}
				break;
			case kFightEffectGrace:
			{
				this._abilityName = Core.Localization.getString("Grace");
				this._abilityDescription = Core.Localization.getString("Regular zombies are stronger around you");
				this._abilityIcon = "ability_grace.png";
				this._requiredLifeForce = 65;
				this._tier = 2;
				this._flagBit = kAbilityBitsGrace;
			}
				break;
			case kActorActivatedAbilityTagAttachMini:	
			{
				this._abilityName = Core.Localization.getString("Mini Buddy");
				this._abilityDescription = Core.Localization.getString("Carry a mini zombie and ram the enemy (use before sending zombie)");
				this._abilityIcon = "ability_attachMini.png";
				this._requiredLifeForce = 65;
				this._tier = 2;
				this._flagBit = kAbilityBitsAttachMini;
			}
				break;
			case kFightEffectProtect:
			{
				this._abilityName = Core.Localization.getString("Protect");
				this._abilityDescription = Core.Localization.getString("Other zombie types take less damage when you're near");
				this._abilityIcon = "ability_protect.png";
				this._requiredLifeForce = 65;
				this._tier = 2;
				this._flagBit = kAbilityBitsProtect;
			}
				break;
			case kFightEffectTankHitPointsBuff:
			{
				this._abilityName = Core.Localization.getString("Fortitude");
				this._abilityDescription = Core.Localization.getString("Headless zombies are a little tougher");
				this._abilityIcon = "ability_tankHitPointsBuff.png";
				this._requiredLifeForce = 65;
				this._tier = 2;
				this._flagBit = kAbilityBitsTankHitPointsBuff;
			}
				break;
			case kActorActivatedAbilityTagLaser:
			{
				this._abilityName = Core.Localization.getString("Laser Beam");
				this._abilityDescription = Core.Localization.getString("Shoot a laser beam while you're walking!");
				this._abilityIcon = "ability_laserBeam.png";
				this._requiredLifeForce = 105;
				this._tier = 3;
				this._flagBit = kAbilityBitsLaser;
			}
				break;
			case kActorActivatedAbilityTagStun:
			{
				this._abilityName = Core.Localization.getString("Random Stun");
				this._abilityDescription = Core.Localization.getString("Small chance to stun your target");
				this._abilityIcon = "ability_stun.png";
				this._requiredLifeForce = 105;
				this._tier = 3;
				this._flagBit = kAbilityBitsStun;
			}
				break;
			case kActorActivatedAbilityTagBash:	
			{
				this._abilityName = Core.Localization.getString("Bash");
				this._abilityDescription = Core.Localization.getString("Bashes the enemy when activated (use when fighting)");
				this._abilityIcon = "ability_bash.png";
				this._requiredLifeForce = 105;
				this._tier = 3;
				this._flagBit = kAbilityBitsBash;
			}
				break;
			case kActorActivatedAbilityTagTurboSpeed:
			{
				this._abilityName = Core.Localization.getString("Turbo Walking Speed");
				this._abilityDescription = Core.Localization.getString("Zombie walks twice as fast");
				this._abilityIcon = "ability_turboSpeed.png";
				this._requiredLifeForce = 105;
				this._tier = 3;
				this._flagBit = kAbilityBitsTurboSpeed;
			}
				break;
			case kActorActivatedAbilityTagRessurect: 
			{
				this._abilityName = Core.Localization.getString("Resurrect");
				this._abilityDescription = Core.Localization.getString("Resurrect any zombie once");
				this._abilityIcon = "ability_ressurect.png";
				this._requiredLifeForce = 105;
				this._tier = 3;
				this._flagBit = kAbilityBitsRessurect;
			}
				break;
			case kActorActivatedAbilityTagExplode:
			{
				this._abilityName = Core.Localization.getString("Explode");
				this._abilityDescription = Core.Localization.getString("Zombie will explode and stun the enemy (use when fighting)");
				this._abilityIcon = "ability_explode.png";
				this._requiredLifeForce = 105;
				this._tier = 3;
				this._flagBit = kAbilityBitsExplode;
			}
				break;
			case kActorActivatedAbilityTagLaserV2:
			{
				this._abilityName = Core.Localization.getString("Laser Beam Ver.2");
				this._abilityDescription = Core.Localization.getString("New and improved");
				this._abilityIcon = "ability_zomBeam.png";
				this._requiredLifeForce = 150;
				this._tier = 4;
				this._flagBit = kAbilityBitsLaserV2;
			}
				break;
			case kActorActivatedAbilityTagDoubleStrike:
			{
				this._abilityName = Core.Localization.getString("Double Strike");
				this._abilityDescription = Core.Localization.getString("Small chance to hit twice");
				this._abilityIcon = "ability_doubleStrike.png";
				this._requiredLifeForce = 150;
				this._tier = 4;
				this._flagBit = kAbilityBitsDoubleStrike;
			}
				break;
			case kActorActivatedAbilityTagBashV2:
			{
				this._abilityName = Core.Localization.getString("Smash");
				this._abilityDescription = Core.Localization.getString("Smashes the enemy when activated (use when fighting)");
				this._abilityIcon = "ability_bashV2.png";
				this._requiredLifeForce = 150;
				this._tier = 4;
				this._flagBit = kAbilityBitsBashV2;
			}
				break;
			case kActorActivatedAbilityTagBlock:
			{
				this._abilityName = Core.Localization.getString("Block");
				this._abilityDescription = Core.Localization.getString("Small chance to block any attack");
				this._abilityIcon = "ability_block.png";
				this._requiredLifeForce = 150;
				this._tier = 4;
				this._flagBit = kAbilityBitsBlock;
			}
				break;
			case kActorActivatedAbilityTagHealAOE:
			{
				this._abilityName = Core.Localization.getString("Heal All");
				this._abilityDescription = Core.Localization.getString("Heal all zombies every once in awhile");
				this._abilityIcon = "ability_healAOE.png";
				this._requiredLifeForce = 150;
				this._tier = 4;
				this._flagBit = kAbilityBitsHealAOE;
			}
				break;
			case kActorActivatedAbilityTagExplodeV2:
			{
				this._abilityName = Core.Localization.getString("Explode Ver.2");
				this._abilityDescription = Core.Localization.getString("Can hit and stun the boss (use when fighting)");
				this._abilityIcon = "ability_explodeV2.png";
				this._requiredLifeForce = 150;
				this._tier = 4;
				this._flagBit = kAbilityBitsExplodeV2;
			}
				break;
	
	// ENEMY BUFFS //
			case kFightEffectEnemyBuffEnrage:
			{
	            
			}
				break;
	            
	        case kFightEffectEnemyDebuffIce:
	        {
	            this._particleEffectWhenActive = true;
	        }
	            break;
		}
	},
	
	implementedAbility: function (){
	
		switch(this._tag){
//			case kActorActivatedAbilityTagAttachMini:	
//			{
//				return false;
//			}
//			case kActorActivatedAbilityTagLaser:
//			{
//				return false;
//			}
//			case kActorActivatedAbilityTagStun:
//			{
//				return false;
//			}
//			case kActorActivatedAbilityTagBash:	
//			{
//				return false;
//			}
//			case kActorActivatedAbilityTagTurboSpeed:
//			{
//				return false;
//			}
//			case kActorActivatedAbilityTagRessurect: 
//			{
//				return false;
//			}
//			case kActorActivatedAbilityTagExplode:
//			{
//				return false;
//			}
//			case kActorActivatedAbilityTagLaserV2:
//			{
//				return false;
//			}
//			case kActorActivatedAbilityTagDoubleStrike:
//			{
//				return false;
//			}
//			case kActorActivatedAbilityTagBashV2:
//			{
//				return false;
//			}
//			case kActorActivatedAbilityTagBlock:
//			{
//				return false;
//			}
//			case kActorActivatedAbilityTagHealAOE:
//			{
//				return false;
//			}
//			case kActorActivatedAbilityTagExplodeV2:
//			{
//				return false;
//			}
		}
		
		return true;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/FightGameScene/ZFActorActivatedAbility'] = function(){var exports = $MODULE_REGISTRY['Code/Game/FightGameScene/ZFActorActivatedAbility'] || {}; $MODULE_REGISTRY['Code/Game/FightGameScene/ZFActorActivatedAbility'] = exports; exports.ZFActorActivatedAbility= ZFActorAbility.subclass
({
	classname : 'ZFActorActivatedAbility',
	
	initWithTag : function($super, abilityTag)
	{
		
		this.initBasicDataForTag(abilityTag);
		this._useOnce = false;
		this._abilityMethod = null;
		this._trigger = kTriggerEventNothing;
		this._buttonPosition = ccp(0,0);
		this._needsButton = false;
		
		switch (abilityTag) 
		{
			case kActorActivatedAbilityTagRessurect:
			{				
				this._requiresState = kActorFightStateAny;
				this._abilityMethod = "ressurectZombie";
				this._trigger = kTriggerEventZombieDeath;
				this._useOnce = true;
				this._consumable = true;
			}
				break;
			case kActorActivatedAbilityTagAttachMini:
			{
				this._abilityMethod = "attachMini";
				this._trigger = kTriggerEventAttachMiniButtonPressed;
				this._useOnce = true; //during trigger search stop after the first active attach mini ability
				this._requiresState = kActorFightStatePrepCycle;
				this._buttonPosition = ccp(240,160);
				this._needsButton = true;
				this._consumable = true;			
			}
				break;
			case kActorActivatedAbilityTagBash:
			{				
				this._abilityMethod = "bash";
				this._trigger = kTriggerEventBashButtonPressed;
				this._buttonPosition = ccp(270,160);
				this._needsButton = true;
				this._timerActivateIn = 10;
			}
                break;
                
            case kActorActivatedAbilityTagBashV2:
            {				
            	this._abilityMethod = "bashV2";
            	this._trigger = kTriggerEventBashV2ButtonPressed;
            	this._buttonPosition = ccp(270,130);
            	this._needsButton = true;
            	this._timerActivateIn = 10;
			}
				break;
			case kActorActivatedAbilityTagLaser:
			{				
				// never gets activated except by the actor
				this._requiresState = kActorFightStateNothing;
			}
				break;
			case kActorActivatedAbilityTagLaserV2:
			{
				this._requiresState = kActorFightStateNothing;
			}
				break;
			case kActorActivatedAbilityTagExplode:
			{
				this._abilityMethod = "explode";
				this._trigger = kTriggerEventExplodeButtonPressed;
				this._useOnce = true; //during trigger search stop after the first explode ability
				this._buttonPosition = ccp(210,160);
				this._needsButton = true;
				this._consumable = true;
			}
				break;
			case kActorActivatedAbilityTagExplodeV2:
			{
				this._abilityMethod = "explodeV2";
				this._trigger = kTriggerEventExplodeV2ButtonPressed;
				this._useOnce = true; //during trigger search stop after the first explode ability
				this._buttonPosition = ccp(210,130);
				this._needsButton = true;
				this._consumable = true;
			}
				break;
			case kActorActivatedAbilityTagTurboSpeed:
			{
				// always on
				this._requiresState = kActorFightStateAny;
			}
				break;
			case kActorActivatedAbilityTagBlock:
			{
				// always on
				this._requiresState = kActorFightStateAny;
			}
				break;
			case kActorActivatedAbilityTagStun:
			case kActorActivatedAbilityTagDoubleStrike:
			case kActorActivatedAbilityTagHeal:
			{
				this._requiresState = kActorFightStateAny;
				// default :
				// - no timers, no ability methods, no buttons, and no triggers
			}
				break;
			case kActorActivatedAbilityTagHealAOE:
			{
				this._abilityMethod = "healAOE";
				this._trigger = kTriggerEventAuto;
				this._timerActivateIn = 20;
			}
		}
		
		
		return this;
	},
	
	initialize : function(tag){
    	if(tag)
    		this.initWithTag(tag);
    },

	refreshTimers: function()
	{
//		var zfaa = new ZFActorActivatedAbility();
//		var temp = zfaa.initWithTag(this._tag);
		var temp = new ZFActorActivatedAbility(this._tag);
		this._timerActivateIn = temp._timerActivateIn;
		this._timerActivateFor = temp._timerActivateFor;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/FightGameScene/ZFActorFightEffect'] = function(){var exports = $MODULE_REGISTRY['Code/Game/FightGameScene/ZFActorFightEffect'] || {}; $MODULE_REGISTRY['Code/Game/FightGameScene/ZFActorFightEffect'] = exports; exports.ZFActorFightEffect = ZFActorAbility.subclass({
    classname : 'ZFActorFightEffect',
    
    FightEffectFlag : {
        FIGHT_EFFECT_FLAG_ZOMBIE_REGULAR : (1 << 0), //atk1 1
        FIGHT_EFFECT_FLAG_ZOMBIE_GIRL : (1 << 1), //def1 2
        FIGHT_EFFECT_FLAG_ZOMBIE_LARGE : (1 << 2), //spd1 4
        FIGHT_EFFECT_FLAG_ZOMBIE_SMALL : (1 << 3), //atk2 8
        FIGHT_EFFECT_FLAG_ZOMBIE_HEADLESS : (1 << 4), //def2 16
        FIGHT_EFFECT_FLAG_ZOMBIE_GARDEN : (1 << 5), //spd2 32
        FIGHT_EFFECT_FLAG_ENEMY : (1 << 6), //atk3 64
        
        FIGHT_EFFECT_FLAG_ALL_ZOMBIES : (1 << 0) + (1 << 1) + (1 << 2) + (1 << 3) + (1 << 4) + (1 << 5)
    },
    
    initWithTag: function(effectID)
    {
        this.initBasicDataForTag(effectID);
        this._powerChange = 0;
        this._attackSpeedChange = 0;
        this._spriteScaleChange = 1;
        this._spriteColorChange = ccc3(255, 255, 255); //removes any color tinting
        this._damageReduction = 0;
        this._hitPointsTotalChange = 0;
        this._appliesToGroup = false;
        this._appliesToActorTypes = 0;
        this._activateInMeleeIfLessThanTime = 0;
        
        switch (effectID)
        {
            case kFightEffectGroupBuffFiveToAllStats: {
                this._powerChange = 0.05;
                this._attackSpeedChange = 0.025;
                this._hitPointsTotalChange = 0.05;
                
                this._appliesToActorTypes = this.FightEffectFlag.FIGHT_EFFECT_FLAG_ALL_ZOMBIES;
                
                this._appliesToGroup = true;
            }
                break;
            case kFightEffectSelfBuffFiveToAllStatsRegular: {
                this._requiresState = kActorFightStateAny;
                this._powerChange = 0.05;
                this._attackSpeedChange = 0.025;
                this._hitPointsTotalChange = 0.05;
                
                this._appliesToActorTypes = this.FightEffectFlag.FIGHT_EFFECT_FLAG_ZOMBIE_REGULAR;
            }
                break;
            case kFightEffectEnemyBuffEnrage: {
                this._powerChange = 2; // 200% power
                this._attackSpeedChange = 0.25; // 50% haste
                
                this._appliesToActorTypes = this.FightEffectFlag.FIGHT_EFFECT_FLAG_ENEMY;
                
                this._requiresState = kActorFightStateAny;
                
                this._timerActivateIn = ZFGameDefines.FIGHT_TIMER;
                this._timerActivateFor = -1; // 
                
                this._spriteScaleChange = 1.2;
                this._changeScale = true;
                this._spriteColorChange = ccc3(255, 0, 0); // pure red
                this._changeColor = true;
                this._appliesToGroup = true; // affects all enemies 
            }
                break;
            
            case kFightEffectEnemyDebuffIce: {
                this._powerChange = -0.5; // 200% power
                this._attackSpeedChange = -0.25; // -50% haste ?
                
                this._appliesToActorTypes = this.FightEffectFlag.FIGHT_EFFECT_FLAG_ALL_ZOMBIES;
                
                this._requiresState = kActorFightStateAny;
                this._timerActivateIn = 90;
                this._timerActivateFor = -1;
                
                this._spriteScaleChange = 0.5;
                this._changeScale = true;
                this._spriteColorChange = ccc3(127, 180, 255); // ice blue
                this._changeColor = true;
                this._appliesToGroup = true; // affects all enemies 
                this._activateInMeleeIfLessThanTime = this.FightEffectFlag.FIGHT_TIMER;
            }
                break;
            case kFightEffectBigZombie: {
                this._changeColor = true;
                this._spriteColorChange = ccc3(255, 0, 0);
                this._changeScale = true;
                this._spriteScaleChange = 1.2; // 20% bigger scale
                
                this._appliesToActorTypes = this.FightEffectFlag.FIGHT_EFFECT_FLAG_ALL_ZOMBIES;
                
                this._timerActivateIn = 5; // apply in 5 seconds (test) 
                this._timerActivateFor = 10;
                this._appliesToGroup = false;
            }
                break;
            case kFightEffectBigBoss: {
                this._changeColor = true;
                this._spriteColorChange = ccc3(255, 0, 0);
                this._changeScale = true;
                this._spriteScaleChange = 1.2; // 20% bigger scale
                
                this._appliesToActorTypes = this.FightEffectFlag.FIGHT_EFFECT_FLAG_ENEMY;
                
                this._timerActivateIn = 5; // apply in 5 seconds (test) 
                this._timerActivateFor = 10;
                this._appliesToGroup = false;
            }
                break;
            // PLAYER BUFFS //
            case kFightEffectSelfBuffToAllStats: {
                this._powerChange = 0.05;
                // 0.5 = 100% haste ... 5% = 0.025
                this._attackSpeedChange = 0.025;
                this._hitPointsTotalChange = 0.05;
                this._appliesToGroup = false;
            }
                break;
            case kFightEffectSelfBuffSpeed: {
                this._attackSpeedChange = 0.05; // 0.05 = 10% speed buff
                this._appliesToGroup = false;
            }
                break;
            case kFightEffectSelfBuffPower: {
                this._powerChange = 0.1;
                this._appliesToGroup = false;
            }
                break;
            case kFightEffectSelfBuffHitPoints: {
                this._hitPointsTotalChange = 0.1;
                this._appliesToGroup = false;
            }
                break;
            case kFightEffectChivalry: {
                this._powerChange = 0.1;
                // 0.5 = 100% haste ... 10% = 0.05 ==> 3% = 0.015
                this._attackSpeedChange = 0.05;
                this._hitPointsTotalChange = 0.1;
                this._appliesToActorTypes = this.FightEffectFlag.FIGHT_EFFECT_FLAG_ZOMBIE_GIRL;
                this._appliesToGroup = true;
            }
                break;
            case kFightEffectGrace: {
                this._powerChange = 0.1;
                // 0.5 = 100% haste ... 10% = 0.05 ==> 3% = 0.015
                this._attackSpeedChange = 0.05;
                this._hitPointsTotalChange = 0.1;
                this._appliesToActorTypes = this.FightEffectFlag.FIGHT_EFFECT_FLAG_ZOMBIE_REGULAR;
                this._appliesToGroup = true;
            }
                break;
            case kFightEffectProtect: {
                this._damageReduction = 0.20; // 10% damage reduction for anybody not a tank
                this._appliesToActorTypes = (this.FightEffectFlag.FIGHT_EFFECT_FLAG_ALL_ZOMBIES & ~this.FightEffectFlag.FIGHT_EFFECT_FLAG_ZOMBIE_HEADLESS);
                this._appliesToGroup = true;
            }
                break;
            case kFightEffectTankHitPointsBuff: {
                this._hitPointsTotalChange = 0.1;
                this._appliesToActorTypes = this.FightEffectFlag.FIGHT_EFFECT_FLAG_ZOMBIE_HEADLESS;
                this._appliesToGroup = true;
            }
                break;
        }
        
//        return this;
    },
    
    canApplyToActor : function(a)
    {
        var answer = false;
        var flag = 0;
        if (a instanceof CivilianActorFight)
            flag = this.FightEffectFlag.FIGHT_EFFECT_FLAG_ENEMY;
        else if (a instanceof ZombieActorRegular)
            flag = this.FightEffectFlag.FIGHT_EFFECT_FLAG_ZOMBIE_REGULAR;
        else if (a instanceof ZombieActorGirl)
            flag = this.FightEffectFlag.FIGHT_EFFECT_FLAG_ZOMBIE_GIRL;
        else if (a instanceof ZombieActorLarge)
            flag = this.FightEffectFlag.FIGHT_EFFECT_FLAG_ZOMBIE_LARGE;
        else if (a instanceof ZombieActorSmall)
            flag = this.FightEffectFlag.FIGHT_EFFECT_FLAG_ZOMBIE_SMALL;
        else if (a instanceof ZombieActorHeadless)
            flag = this.FightEffectFlag.FIGHT_EFFECT_FLAG_ZOMBIE_HEADLESS;
        else if (a instanceof ZombieActorGarden)
            flag = this.FightEffectFlag.FIGHT_EFFECT_FLAG_ZOMBIE_GARDEN;
        
        if (flag & this._appliesToActorTypes)
            answer = true;
        
        return answer;
    },
    
    removeEffectFromActor : function(a)
    {
        if (this.canApplyToActor(a))
        {
//        	console.log("QQQQQQQQQQQQ Remove Group STATS QQQQQQQQQQQQQ")
//    		console.log("QQQQQQQQ zombie: "+a.classname);
//    		console.log("QQQQQQ L hit: "+a._fightData._finalHitPointsTotal);
//    		console.log("QQQQQQ L con: "+a._fightData._finalPower);
//    		console.log("QQQQQQ L dex: "+a._fightData._finalAttackSpeed);
//    		console.log("QQQQQQ L dr: "+a._fightData._finalDamageReduction);
    		
            // hitPointsTotalChange contains both passive and temporary buffs
            a._fightData._hitPointsTotalChange -= this._hitPointsTotalChange;
            a._fightData._finalHitPointsTotal = a.calculateFinalHitPointsTotal();
            
            if (this._hitPointsTotalChange > 0) // removing a buff results in hp loss
                a._fightData._hitPoints = (a._fightData._hitPoints > a._fightData._finalHitPointsTotal) ? a._fightData._finalHitPointsTotal : a._fightData._hitPoints;
            if (this._timerActivateIn == -1)
            {
                // this is a passive buff
                a._fightData._passivePowerChange -= this._powerChange;
                a._fightData._passiveAttackSpeedChange -= this._attackSpeedChange;
                a._fightData._passiveDamageReduction -= this._damageReduction;
            }
            else
            {
                // this is a temporary buff
                a._fightData._temporaryPowerChange -= this._powerChange;
                a._fightData._temporaryAttackSpeedChange -= this._attackSpeedChange;
                a._fightData._temporaryDamageReduction -= this._damageReduction;
            }
            
            a._fightData._finalPower = a.calculateFinalPower();
            a._fightData._finalAttackSpeed = a.calculateFinalAttackSpeed();
            a._fightData._finalDamageReduction = a.calculateFinalDamageReduction();
            
            if (this._changeScale)
            {
                
                a._spriteMan.runAction(CCScaleTo.actionWithDuration(0.5, a._spriteMan.getScale()._x / this._spriteScaleChange));
                // a.spriteMan.scale /= spriteScaleChange;
            }
            if (this._changeColor)
            {
                a._fightData._fightColor = ccc3(255, 255, 255);
                a.resetColor();
            }
//            console.log("QQQQQQ N hit: "+a._fightData._finalHitPointsTotal);
//    		console.log("QQQQQQ N con: "+a._fightData._finalPower);
//    		console.log("QQQQQQ N dex: "+a._fightData._finalAttackSpeed);
//    		console.log("QQQQQQ N dr: "+a._fightData._finalDamageReduction);
        }
    },
    
    applyEffectToActor : function(a)
    {
        if (this.canApplyToActor(a))
        {
//        	console.log("QQQQQQQQQQQQ MODIFY Group STATS QQQQQQQQQQQQQ")
//    		console.log("QQQQQQQQ zombie: "+a.classname);
//    		console.log("QQQQQQ L hit: "+a._fightData._finalHitPointsTotal);
//    		console.log("QQQQQQ L con: "+a._fightData._finalPower);
//    		console.log("QQQQQQ L dex: "+a._fightData._finalAttackSpeed);
//    		console.log("QQQQQQ L dr: "+a._fightData._finalDamageReduction);
    		
            a._fightData._hitPointsTotalChange += this._hitPointsTotalChange;
            a._fightData._finalHitPointsTotal = a.calculateFinalHitPointsTotal();
            
            if (this._hitPointsTotalChange > 0)
                a._fightData._hitPoints += this._hitPointsTotalChange * a._fightData._hitPointsTotal; // change by amount increased
            else if (this._hitPointsTotalChange < 0)
                a._fightData._hitPoints = (a._fightData._hitPoints > a._fightData._finalHitPointsTotal) ? a._fightData._finalHitPointsTotal : a._fightData._hitPoints;
            
            if (this._timerActivateIn == -1)
            {
                // this is a passive buff
                a._fightData._passivePowerChange += this._powerChange;
                a._fightData._passiveAttackSpeedChange += this._attackSpeedChange;
                a._fightData._passiveDamageReduction += this._damageReduction;
            }
            else
            {
                // this is a temporary buff
                a._fightData._temporaryPowerChange += this._powerChange;
                a._fightData._temporaryAttackSpeedChange += this._attackSpeedChange;
                a._fightData._temporaryDamageReduction += this._damageReduction;
                
//                console.log("QQQQQQ C hit: "+this._hitPointsTotalChange);
//        		console.log("QQQQQQ C con: "+this._powerChange);
//        		console.log("QQQQQQ C dex: "+this._attackSpeedChange);
//        		console.log("QQQQQQ C dr: "+this._damageReduction);
            }
            
            a._fightData._finalPower = a.calculateFinalPower();
            a._fightData._finalAttackSpeed = a.calculateFinalAttackSpeed();
            a._fightData._finalDamageReduction = a.calculateFinalDamageReduction();
            
            if (this._changeScale)
            {
                a._spriteMan.stopAllActions();
                a._spriteMan.runAction(CCScaleTo.actionWithDuration(0.5, a._spriteMan.getScale()._x * this._spriteScaleChange));
                //a.spriteMan.scale *= spriteScaleChange;
            }
            if (this._changeColor)
            {
                a._fightData._fightColor = this._spriteColorChange;
                a.resetColor();
            }
//            console.log("QQQQQQ N hit: "+a._fightData._finalHitPointsTotal);
//    		console.log("QQQQQQ N con: "+a._fightData._finalPower);
//    		console.log("QQQQQQ N dex: "+a._fightData._finalAttackSpeed);
//    		console.log("QQQQQQ N dr: "+a._fightData._finalDamageReduction);
        }
    },
    
    isSameEffect : function(effect)
    {
        return this.isSameEffectID(effect._identifier);
    },
    
    isSameEffectID : function(effectID)
    {
        var answer = false;
        if (effectID == this._identifier)
            answer = true;
        return answer;
    },
    
    initialize : function(tag){
    	if(tag)
    		this.initWithTag(tag);
    },
    
    refreshTimers : function()
    {
        temp = new ZFActorFightEffect(this._tag);
        this._timerActivateIn = temp._timerActivateIn;
        this._timerActivateFor = temp._timerActivateFor;
        temp.release();
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/FightGameScene/ZFFightGameScene'] = function(){var exports = $MODULE_REGISTRY['Code/Game/FightGameScene/ZFFightGameScene'] || {}; $MODULE_REGISTRY['Code/Game/FightGameScene/ZFFightGameScene'] = exports; var CCScene = require('Code/Cocos2D/CCScene').CCScene;

exports.ZFFightGameScene = CCScene.subclass
({
	classname : 'ZFFightGameScene',
	
	initialize : function()
	{
		this._farmGameScene = null; //ZFFarmGameScene *
		this._resolutionWidth = 0; //float 
		this._resolutionHeight = 0; //float 
		this._widthScale = 0; //float 
		this._heightScale = 0; //float 
	},
	
	fightTags:
	{
		kFightWeatherParticle : 100
	},
	
	initWithEnemyDictionary : function(aDict)
	{
	    //NgLogD("ZFFightGameScene.initWithEnemyDictionary: dictionary " + JSON.stringify(aDict));
		var gs = GameState;
		
		if (this.isScheduled(this.farmThink))
		{
			this.unschedule(farmThink);
		}
		
        this._resolutionWidth = 960;
        this._resolutionHeight = 640;
        
		this._widthScale = this._resolutionWidth / 480.0;
        this._heightScale = this._widthScale;
        
        var winSize = CCDirector.winSize();
  		
        result = {
                offsetX : 0,
                offsetY : 0,
                scaleX : winSize._width / this._resolutionWidth,
                scaleY : winSize._height / this._resolutionHeight
            };
        
        result.scaleX = Math.min(result.scaleX, result.scaleY);
        result.scaleY = result.scaleX;
        result.width = result.scaleX * this._resolutionWidth;
        result.height = result.scaleY * this._resolutionHeight;
        result.offsetX = Math.floor((winSize._width - result.width) / 2);
        result.offsetY = Math.floor((winSize._height - result.height) / 2);
        
		var gui = ZFFightGUI;
		gui.initElements(aDict);
		
		this._rootNode = new CCNode();
        this.addChild(this._rootNode);
        
        this._rootNode.setScale( result.scaleX, result.scaleY, true );
        this._rootNode.setPosition( result.offsetX , result.offsetY );
        
        if (result.offsetX) {
            var border1 = CCColorLayer.layerWithColor(new CCColor(0,0,0,1),result.offsetX, winSize._height);
            border1.setPosition(0,winSize._height/2);
            this.addChild(border1,501);
            var border2 = CCColorLayer.layerWithColor(new CCColor(0,0,0,1),result.offsetX, winSize._height);
            border2.setPosition(result.width + result.offsetX,winSize._height/2);
            this.addChild(border2,501);

        	
//			var border1Name = aDict["border1"];
//			var border1 = CCSprite.spriteWithFile(border1Name);
//			
//			var size = border1.getSize();
//			var scaleX = result.offsetX/size.getWidth();
//			var scaleY = winSize.getHeight()/size.getHeight();
//			
//			border1.setAnchorPoint(ccp(0,0));
//			border1.setPosition(0,0);
//			border1.setScale(scaleX,scaleY);
//			this.addChild(border1,501);
//			
//			var border2Name = aDict["border2"];
//			var border2 = CCSprite.spriteWithFile(border2Name);
//			border2.setAnchorPoint(ccp(0,0));
//			border2.setPosition(result.width + result.offsetX,0);
//			border2.setScale(scaleX,scaleY);
//			this.addChild(border2,501);
        }
        		
		this._rootNode.addChild(gui, 500);
		/* TODO: ZFGameCenterDelegate
		var gcd = ZFGameCenterDelegate.gameCenterDelegate();
		gcd.getParent().removeChild(gcd, true);
		this._rootNode.addChild(gcd, 502, this.kTag.kTagGameCenter);
		this.cleanupAchievementBox();*/
		
		this._rootNode.addChild(ZFFightMan);
		var fm = ZFFightMan.initDataWithDictionary(aDict);
		
		if(aDict["levelAssets"])
		{
			var levelAssetsArray = aDict["levelAssets"];
			
			for(var key in levelAssetsArray)
			{
			    var dict = levelAssetsArray[key];
				var sprite = dict["sprite"];
				var iPadSprite = null;
				if (this._widthScale>1)
				{
//					iPadSprite = this.checkForAssetFile(sprite);
				}
				
				var z = dict["z"];
				var spritePosition = dict["position"] ? CGPointFromString(dict["position"]) : CGPointMake(0,0);
				var anchorPosition = dict["anchor"] ? CGPointFromString(dict["anchor"]) : CGPointMake(0,0);
				
				//TODO: Not really sure about this
				var windowSize = new Core.Size(960,480);
				var windowSizeOffset = ccp(this._widthScale, this._heightScale);
				spritePosition = ccp(spritePosition._x * windowSizeOffset._x, spritePosition._y * windowSizeOffset._y);
				var spriteWidthScale = 1;
				var spriteHeightScale = 1;
		
				if (iPadSprite)
				{
					sprite = iPadSprite;
				}
				else {
					spriteWidthScale = this._widthScale;
					spriteHeightScale = this._heightScale;
				}
				
				var asset = null;
				if(dict["isScrolling"])
				{
					var spriteImageWidthScale = 1;	//how much bigger is this sprite than the original?
					var spriteImageHeightScale = 1;
					if (iPadSprite)
					{
						//TODO: Check this for different resolutions
						spriteImageWidthScale = 1024.0/512;
						spriteImageHeightScale = windowSize._height/ZFGameDefines.ORIGINAL_WINDOW_HEIGHT;
					}
					
					asset  = CCSprite.spriteWithFile(sprite, CGRectMake(0, 0, 512 * 2*spriteImageWidthScale, 256*spriteImageHeightScale));
					spritePosition = dict["position"] ? CGPointFromString(dict["position"]) : CGPointMake(0,0);
					spritePosition = ccp(spritePosition._x *this._widthScale, spritePosition._y * spriteImageHeightScale);	//this needs to scale to next piece (the sky)
					
					asset.setPosition(spritePosition);
					asset.setAnchorPoint(anchorPosition);
					asset.setScale( asset.getScale()._x * spriteWidthScale, asset.getScale()._y * spriteHeightScale );
					//TODO: GL_* and setTextParameters
//					var params = {GL_LINEAR, GL_LINEAR, GL_REPEAT, GL_REPEAT};
//					[asset.texture  setTexParameters:&params];
					
					// FIXME: CCCallFuncND
//					asset.runAction(CCCallFuncND.actionWithTarget(this, this.repeatMovement, dict));
								
					this._rootNode.addChild(asset, z);
				}
				else 
				{
				    asset = CCSprite.spriteWithFile(sprite);
                    asset.setPosition(spritePosition);
                    asset.setAnchorPoint(anchorPosition);
                    asset.setScale(spriteWidthScale,spriteHeightScale);
                    this._rootNode.addChild(asset, z);
				}
			}
		}
		else
		{
			var bgName = aDict["levelBG"];
			var bg = CCSprite.spriteWithFile(bgName);
			
			bg.setAnchorPoint(ccp(0.0, 0.0));
			bg.setScale(bg.getScale()._x* this._widthScale, bg.getScale()._y * this._heightScale);
			this._rootNode.addChild(bg, 0);
			
			var building = null;
			var buildingDoor = null;
			
			if(aDict["levelBldng"])
			{
				building = CCSprite.spriteWithFile(aDict["levelBldng"]);
				building.setAnchorPoint(ccp(1.0, 0.0));
				building.setPosition(ccp(this._resolutionWidth, aDict["doorPositionY"]/*this._heightScale*/));
				building.setScale( building.getScale()._x * this._widthScale, building.getScale()._y * this._heightScale );
				
				this._rootNode.addChild(building, 3);
			}
			
			if(aDict["levelDoor"])
			{
				buildingDoor = CCSprite.spriteWithFile(aDict["levelDoor"]);
				buildingDoor.setAnchorPoint(ccp(1.0, 0.0));
				buildingDoor.setPosition(ccp(this._resolutionWidth, aDict["doorPositionY"]/*this._heightScale*/));
//				buildingDoor.setPosition(ccp(screenSize._width, aDict["doorPositionY"]*this._heightScale));
				buildingDoor.setScale(buildingDoor.getScale()._x*this._widthScale, buildingDoor.getScale()._y * this._heightScale);
				this._rootNode.addChild(buildingDoor, 100);
			}
			
			if(gs._zfGameData._currentEnemy == 4)
			{
				
				//TODO:
				var temp = DataPreloader._robotStageElementsData;
				var spriteDetails = temp["robotStageFloor.png"];
				
				var spriteRect = CGRectMake(spriteDetails.x, spriteDetails.y, spriteDetails.width, spriteDetails.height);

					var floor = CCSprite.spriteWithFile("RobotStageElements.png", spriteRect);
					floor.setAnchorPoint(0,0);
					floor.setPosition(0,-1*this._heightScale);
					this._rootNode.addChild(floor,3);
					floor.setScale(this._widthScale, this._heightScale);
//					floor._scaleX *= widthScale;
//					floor._scaleY *= heightScale;
					
					building.anchorPoint = buildingDoor.anchorPoint;
					building.position = buildingDoor.position;
			}
		}
			
		ZFFightMan.initialSpawn();
//		this._rootNode.addChild(ZFFightPhysics.fightPhysics());
		
		var name = NSLocalizedString(aDict["name"]);
		
		gui.schedule(gui.tick, ZFGameDefines.GUI_UPDATE_INTERVAL, "tick");
		gui.displayToolTip_withInfo(name, sprintf(NSLocalizedString("Population: %d", null), fm._enemyPopulation), 5); 
		this.schedule(this.showStartButton, 5, "showStartButton");
		this.schedule(this.zombiesEntrance, 2.5, "zombiesEntrance");
		
		var player = ZFActorManager._player;
		
		if (player && player._currentPlayerAction)
		{
			SimpleAudioEngine.stopEffect(player._currentPlayerAction._soundID);
		}
			
		if (gs._zfGameData._currentEnemy == 0) //ol mcdonnell
		{
			SimpleAudioEngine.playBackgroundMusic(kFarmsStageBGM);
		}
		else if (gs._zfGameData._currentEnemy == 2) //pirates
		{
			SimpleAudioEngine.playBackgroundMusic(kPirateStageBGM);
		}
		else if (gs._zfGameData._currentEnemy == 3) //ninjas
		{
			SimpleAudioEngine.playBackgroundMusic(kNinjaStageBGM);
		}
		else if (gs._zfGameData._currentEnemy == 4) //robots
		{
			SimpleAudioEngine.playBackgroundMusic(kRobotStageBGM);
		}
		else if (gs._zfGameData._currentEnemy == 5) //aliens
		{
			SimpleAudioEngine.playBackgroundMusic(kAlienStageBGM);
		}
		else
		{
			SimpleAudioEngine.playBackgroundMusic(kFightBGM);
		}
		
		if (gs._zfGameData._currentEnemy == 3)//rabbit ninja stage
		{
			//TODO: Wait implementation
//				var emitter = CCParticleSnow.initWithTotalParticles(100);
//				emitter._life = 0;
//				emitter._lifeVar = 2.17;
//				emitter._startSize = 6*this._widthScale;
//				emitter._startSizeVar = 8;
//				emitter._endSize = 6*this._widthScale;
//				emitter._endSizeVar = 0;
//				emitter._angle = 239;
//				emitter._angleVar = 27;
//				emitter._speed = 33;
//				emitter._speedVar = 606;
//				emitter._gravity = CGPointMake(355.2, 0);
//				emitter._radialAccel = 0;
//				emitter._radialAccelVar = 0;
//				emitter._tangentialAccel = 0;
//				emitter._tangentialAccelVar = 0;
			//TODO: Check
//				emitter._startColor = (ccColor4F) {1, 1, 1, 1};
//				emitter.startColorVar = (ccColor4F) {0, 0, 0, 0};
//				emitter.endColor = (ccColor4F) {.91, 1, .91, .19};
//				emitter.startColorVar = (ccColor4F) {0, 0, 0, .24};
//				
//				emitter.position = ccp(
//						   [[CCDirector sharedDirector] winSize].width / 2,
//						   [[CCDirector sharedDirector] winSize].height + 10);
//				emitter.posVar = ccp([[CCDirector sharedDirector] winSize].width / 2, 6);
//				emitter.duration = -1;
//				emitter.blendAdditive = NO;
//				emitter.emissionRate = 80;
//				emitter.texture = [[CCTextureCache sharedTextureCache] addImage:@"snow.png"];
//				[self addChild: emitter z:400 tag:kFightWeatherParticle];
		}
		//weather
		if (gs._zfGameData._currentEnemy == 4)//robot stage
		{
//				TODO: Wait for implementation
//				var emitter = ZFParticleEffects.particleSystemByTag("steam.plist");
//				emitter.setScale(emitter.getScale() * this._widthScale);
//				this._rootNode.addChild(emitter, 2, this.fightTags.kFightWeatherParticle);
		}
		
		NSNotificationCenter.defaultCenter().addObserver(this, this.endFightIn, ZFGameDefines.kFightSummaryDone, null);

		//var enemy = "Pirates";
		//var eventDictionary = {};
		//eventDictionary["Opponent"] = enemy;
		//TODO: Wait for implementation
		//FlurryAPI.logEvent(ZFGameDefines.kFlurryEvent_beginFight, eventDictionary);

		return this;
	},
	
	checkForAssetFile : function(assetName)
	{
	    console.log("ZFFightGameScene.checkForAssetFile: return NULL");
	    return null;
//		//TODO
//		NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
//		NSString *documentsDirectory = [paths objectAtIndex:0];
//		NSString *gameVersion = [[[NSBundle mainBundle] infoDictionary] objectForKey:@"CFBundleVersion"];
//		NSString *path = [documentsDirectory stringByAppendingPathComponent:gameVersion];	//documents folder path
//		NSFileManager *fm = [NSFileManager defaultManager];
//		BOOL isDir = NO;
		
//		NSString *filePath = [path stringByAppendingPathComponent:assetName];
		
//		if ([fm fileExistsAtPath:filePath isDirectory:(&isDir)])
//		{
//			return filePath;
//		}
//		else{	//try downloading the item
//			NSString *itemPath = [NSString stringWithFormat:@"%@", WEBSITESERVER_IPAD_URL];
//			NSData *data = nil;
//			if ([assetName length] > 0) 
//			{
//				data = [NSData dataWithContentsOfURL:[NSURL URLWithString:[NSString stringWithFormat:@"%@%@", itemPath, assetName]]];
//				if (!data)
//				{
//					NSLog(@"Error downloading ipad asset file %@ from webserver", assetName);
//					return nil;
//				}
//				[data writeToFile:filePath atomically:YES];
//				return filePath;
//			}
//		}
//		return nil;
	},
	
	zombiesEntrance : function(dt)
	{
		this.unschedule(this.zombiesEntrance);
		ZFFightMan.zombiesEnterScene();
	},
	
	showStartButton : function(dt)
	{	    
		this.unschedule(this.showStartButton);
		ZFFightGUI.displayToolTip_withInfo(NSLocalizedString("Ready?"), NSLocalizedString("(Tap to start)"), 0);
		ZFFightGUI.enableStartButton();
	},
	
	showPrizeIn : function(dt)
	{
		ZFFightGUI.cleanupLocal();
		this.unschedule(this.showPrizeIn);
		this.schedule(this.endFightIn, 10, "endFightIn");
		this.removeChildByTag(this.fightTags.kFightWeatherParticle, true);
		var sprite = CCSprite.spriteWithFile("brainLarge.png");
		sprite.setScale(0);
		sprite.setPosition(ccp(480/2, 320/2));
		this._rootNode.addChild(sprite, 201);
		
		sprite.runAction(CCSpawn.actions([CCRotateBy.actionWithDuration(2, 1440),
		                                  CCScaleTo.actionWithDuration(2, 1),
		                                  null]));
		var white = CCColorLayer.layerWithColor(ccc4(0xFF, 0xFF, 0xFF, 0x0));
		white.runAction(CCFadeTo.actionWithDuration(1.0, 1));
		this._rootNode.addChild(white, 200);
		this.schedule(this.showPrizeInfoIn, 2, "showPrizeInfoIn");
	},
	 
	showPrizeInfoIn : function(dt)
	{
		this.unschedule(this.showPrizeInfoIn);
		ZFFightGUI.displayToolTip_withInfo(NSLocalizedString("You got a Brain!"), NSLocalizedString("Use brains to buy cool stuff in the market."), 4.9);
		this.schedule(this.endFightIn, 5, "endFightIn");
	},
	
	endFightIn : function(dt)
	{
		NSNotificationCenter.defaultCenter().removeObserver(this);
		this.unschedule(this.endFightIn);
		this.unscheduleUpdate();
		
		NSNotificationCenter.defaultCenter().addObserver(this, this.loadScreenHideDone, LoadScreen.kLoadScreenHideDoneNotification, null); 
		this.endFight();
	},
	
	endFight : function()
	{
		//TODO: 
//		NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
//		EAGLContext *k_context = [[[EAGLContext alloc] initWithAPI :kEAGLRenderingAPIOpenGLES1
//														 sharegroup:[[[[CCDirector sharedDirector] openGLView] context] sharegroup]] autorelease];
//		[EAGLContext setCurrentContext:k_context];
//		// hold on to the scene because once we replace it, we lose it
//		[self retain];
		
		
		//TODO:
//		 CCScene *scene = [CCScene node];
//		if(scene && [[FBMan fbman] connectedToInternet])
//		{
//			[scene addChild:[LoadScreen getInstance]];
//			[[CCDirector sharedDirector] replaceScene:scene];
//			
//			[self performSelectorOnMainThread:@selector(showLoadScreen) withObject:nil waitUntilDone:YES];
//			// for faster devices, because they wont ever see the loading screen
//			[NSThread sleepForTimeInterval:2.0];
//		}
		
		LoadScreen.show();
		setTimeout(this.switchToGameScene.bind(this), 2000);
		
		var farmGui = ZFGuiLayer.gui();
		var actm = ZFActorManager;
		var tim = ZFTileManager;
		//FIXME: day/night
//		var cycle = this._farmGameScene.getChildByTag(ZFFarmGameScene.kTag.kTagDayAndNight);
		
		/* FIXME: ZFGameCenterDelegate
		var gcd = ZFGameCenterDelegate.gameCenterDelegate();
		gcd.getParent().removeChild(gcd, true);
		farmGameScene.addChild(gcd, 2, this.kTag.kTagGameCenter);
		gcd.cleanupAchievementBox();*/
		
		farmGui.startInitialSchedules();
		actm.restoreSchedules();
		//FIXME: day/night
//		tim.restartSchedule(cycle._currentState);
		
//		NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
		//TODO: Day / Night
		
//		var dayAndNightEnabled = ZFGameDefines.ZFDayAndNightEnabled;
//		
//		if(dayAndNightEnabled)
//		{
//			var dayCycle = farmGameScene.getChildByTag(ZFFarmGameScene.kTag.kTagDayAndNight);
//			dayCycle.resumeSchedule();
//		}
//		
//		var ftm = farmGameScene.getChildByTag(ZFFarmGameScene.kTag.kTagFarm);
//		ftm.resetTouchState();
//		
		
		for(var key in farmGui._scrollingText)
		{
//			console.log("farmGui._scrollingText: " + farmGui._scrollingText.length);
		    var text = farmGui._scrollingText[key];
		    
			if(text && text._label){
				if(text._label._parent){
//					console.log("farmGui._scrollingText: remove from parent");
					text._label._parent.removeChild(text._label, true);
				}
//				console.log("farmGui._scrollingText: destroying");
				destroyWithChildren(text._label);
				destroyWithChildren(text);
			}
		}
		
		farmGui._scrollingText.length = 0;
//		for(var crop in farmGui._flyingCrops)
//		{
//			if(crop && crop.getParent())
//				crop.getParent().removeChild(crop, true); 
//		}
//		farmGui._flyingCrops.length = 0;
//
		
        SimpleAudioEngine.playBackgroundMusic(kFarmBGM);
		
		//TODO: ?
//		[[CCTextureCache sharedTextureCache] removeUnusedTextures];
		
		// FIXME
		//if (FBMan.fbman().connectedToInternet) 
//			this.hideLoadScreen.bind(this);
		//else 
		//{
//			this.switchToGameScene.bind(this);
		//}
	},
	
	showLoadScreen : function()
	{
		//LoadScreen.getInstance().show();
	},
	
	hideLoadScreen : function()
	{
		//LoadScreen.getInstance().hide();
	},
	
	switchToGameScene : function()
	{
		LoadScreen.hide();
		if(this._farmGameScene) {
			//TODO: Check if CCDirector is supporting actions
//			CCDirector.replaceScene(CCFadeTransition.transitionWithDuration(0.5, this._farmGameScene, ccc3(0,0,0)));
			 CCDirector.replaceScene(this._farmGameScene);
		}

		ZFGuiLayer.gui().showFightResult();
		
		ZFFightMan.cleanupLocal();
//		ZFFightPhysics.fightPhysics().cleanupLocal();
		ZFFightGUI.cleanupLocal();
		
		//FIXME: is not being used for now
//		this.removeChildByTag(this.fightTags.kFightWeatherParticlekFightWeatherParticle, true);
		
	    var flayer = this._farmGameScene.getChildByTag(ZFFarmGameScene.kTag.kTagFarm);
	    flayer.schedule(flayer.tick, ZFGameDefines.FARM_UPDATE_INTERVAL, "tick");
		
//		this._farmGameScene = null;
	    
	    this.removeAllChildrenWithCleanup(true);
	    //destroyChildren(this);
		
	},
	
	loadScreenHideDone : function(notification)
	{
		NSNotificationCenter.defaultCenter().removeObserver(this, LoadScreen.kLoadScreenHideDoneNotification, null);
		this.switchToGameScene();
	},
	
	repeatMovement : function(sender, dict)
	{
		return;
		var sprite = sender;
		this._sprite.setPosition(ccp(0,this._sprite.getPosition()._y));
		
		var speed = dict["speed"];
		var duration = 512.0 / Math.abs(speed); 
		var scrollWidthScale = 1;
		
		if (this._widthScale>1)
		{
			scrollWidthScale = 2;
		}
		
		var destination = (speed > 0) ? ccp(
				-512*scrollWidthScale,
				this._sprite.getPosition()._y):ccp(512*scrollWidthScale,this._sprite.getPosition()._y);
		
//		this._sprite.runAction(CCSequence.actions([CCMoveTo.actionWithDuration(duration, destination),
//		                                           CCCallFuncND.actionWithTarget(this, this.repeatMovement,dict)]));
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/FightGameScene/ZFFightMan'] = function(){var exports = $MODULE_REGISTRY['Code/Game/FightGameScene/ZFFightMan'] || {}; $MODULE_REGISTRY['Code/Game/FightGameScene/ZFFightMan'] = exports; var ZFFightSummary = require('Code/Game/FightGameScene/Summary/ZFFightSummary').ZFFightSummary;
var ZFFightAbilityGUI = require('Code/Game/FightGameScene/GUI/ZFFightAbilityGUI').ZFFightAbilityGUI;
var fp = null;
exports.ZFFightMan = CCNode.singleton({
    classname : 'ZFFightMan',
    
    // bulletTypes enum
    bulletTypes : {
        kBulletTypeNil : 0,
        kBulletTypeAlien : 1,
        kBulletTypeMAX : 2
    },
    
    // fightManTags enum
    fightManTags : {
        kFightManTagTauntBubble : 100,
        kFightManTagTauntText : 0,
        kFightManTagShine1 : 1,
        kFightManTagShine2 : 2,
        kFightManTagMAX : 3
    },
    
    /* Methods*/
    initialize : function()
    {
        ZFFightGUI.instantiate();
        this._enemyDictionary = null; //NSMutableDictionary
    	this._allAttacks = null; //NSDictionary    	
    	this._currentBossAction = null; //NSDictionary
    	
    	this._bg = null; //CCSprite
    	this._building = null; //CCSprite
    	this._boss = null; //CivilianActorFight		// like a boss
    	this._enemy = null; //CivilianActorFight		// current enemy on 1st floor
    	this._special = null;//CivilianActorFight	// used for robotstage robot

    	this._zombies = null; //NSMutableArray			// undead zombies
    	this._yOrder = null; //NSMutableArray				// used to set yorder initially, legacy stuff but should take time to clean in case of bugs
    	this._defeatedZombies = null; //NSMutableArray	// dead zombies
    	this._farmDespawnList = null; //NSMutableArray			// farm actors for dead zombies
    	this._fightEffectList = null; //NSMutableArray			// list of effects to apply
    	this._pendingActivatedAbilities = null; //NSMutableArray	// used for zffightability gui
    	this._stageActors = null; //NSMutableArray			// list of special stage actors (new: going to replace special enemy soon)
    	this._enemyList = null; //NSMutableArray				// list of enemies to spawn if you need a specific order
    	this._enemySlots = null; //NSMutableArray				// slots for alien stage
    	this._bossSummonList = null; //NSMutableArray			// list of bosses to spawn if you need a specific order
    	
    	this._bossWall = null; //CivilianActorFight
    	
    	this._bonusRoll = 0; //float
    	this._state = 0; //int 
    	this._deployTimer = 0; //float 
    	this._fightTimer = 0; //float
    	this._bossActionCastTimer = 0; //float
    	this._bossActionCooldownTimer = 0; //float
    	this._zombieCount = 0; //int
    	this._zombiesInFight = null; //NSMutableArray
    	
    	this._zombieCasualty = 0;//int
    	this._enemyCasualty = 0;//int
    	this._reward = 0;//int
    	this._xpGained = 0; //int
    	this._refund = 0; //Int
    	this._enrageTime = 0; ////int
    	this._spawnTimer = 0; //float
    	this._enemyName = null; //NSString
    	
    	this._enemyPopulation = 0; //int
    	this._strengthPerEnemy = 0; //float
    	this._attackSpeedPerEnemy = 0; //float
    	
    	this._newZombieEntersFight = false; // BOOL
    	this._doOrDie = false; // BOOL
    	this._buttonPressedTimer = false; //BOOL
    	
    	this._bossPosition = null; //CGPoint 
    	this._enemyPosition = null; //CGPoint 
    	this._enemySpawnPosition = null; //CGPoint 
    	this._zombieAttackPosition = null; //CGPoint 
    	
    	this._startGame = false; //BOOL
    	
    	this._newAbilityBG = null; //CCLayer
    	this._newAbility = null; //CCMenu
    	this._newAbilityDescription = null; //CCBitmapFontAtlas
    	this._newAbilityTapIconToContinue = null; //CCBitmapFontAtlas
    	this._newAbilityColorLayer = null; //CCColorLayer
    	
    	this._telekinesis = null; //CCQuadParticleSystem
    	
    	this._wall = null; //ZFFightWall
    	
    	this._resolutionWidth = 0;//float
    	this._resolutionHeight = 0;//float
    	this._widthScale = 0;//float
    	this._heightScale = 0;//float
        
    	this._fightTime = 0;//float
    	
    	this._zombiesFighting = 0;
    	
    	fp = ZFFightPhysics.fightPhysics();
        
    },
    
    destroy : function()
    {
    },
    
    fightMan : function()
    {
        return this;
    },
    
    getRandomAbilityToUnlock : function()
    {
        var gs = GameState;
        
        // tier 1 == currentEnemy 0 + 1
        var unlockList = ZFActorAbility.abilitiesToUnlockForTier(gs._zfGameData._currentEnemy + 1);
        if (unlockList)
        {
            var tempCount = unlockList.length;
            var random = Math.floor(Math.random() * tempCount);
            
            // there is a incredibly small chance that random could be out of bounds, however using tempCount -1 with CCARCRANDOM_0_1 will also make it 
            // artificially harder to get the last object in the unlock array
            
            // creating objects
            
            var tempScale = 1.4 * this._widthScale;
            var time = 1.3;
            
            random = (random >= tempCount) ? tempCount - 1 : random;
            var tempAbility = unlockList[random];
            var sprite = CCSprite.spriteWithFile(tempAbility._abilityIcon);
            var newAbilityItem = CCMenuItemSprite.itemFromNormalSprite(sprite, null, this, this.newAbilityIconClicked.bind(this, tempAbility._flagBit));
            
            newAbilityItem._tag = tempAbility._flagBit; // so we know what flag to set 
            this._newAbility = CCMenu.menuWithItems([newAbilityItem]);
            var w = new Core.Size(960, 640);
            this._abiliyTouched = false;
            
            var fntFile = "./Content/ABD26.fnt";
            
            var zombieClass = "";
            switch (tempAbility._tag)
            {
                case kFightEffectSelfBuffToAllStats:
                    zombieClass = "Zombie";
                    break;
                case kFightEffectSelfBuffSpeed:
                    zombieClass = "Girl Zombie";
                    break;
                case kFightEffectSelfBuffPower:
                    zombieClass = "ZomBumpkin";
                    break;
                case kFightEffectSelfBuffHitPoints:
                    zombieClass = "Headless Zombie";
                    break;
                case kActorActivatedAbilityTagHeal:
                    zombieClass = "Garden Zombie";
                    break;
                case kFightEffectChivalry:
                    zombieClass = "Zyborg";
                    break;
                case kFightEffectGrace:
                    zombieClass = "ZomBeauty";
                    break;
                case kActorActivatedAbilityTagAttachMini:
                    zombieClass = "ZomBruiser";
                    break;
                case kFightEffectProtect:
                    zombieClass = "Kindlehead";
                    break;
                case kFightEffectTankHitPointsBuff:
                    zombieClass = "ZomBotanist";
                    break;
                case kActorActivatedAbilityTagLaser:
                    zombieClass = "Zombot";
                    break;
                case kActorActivatedAbilityTagStun:
                    zombieClass = "Amazombie";
                    break;
                case kActorActivatedAbilityTagBash:
                    zombieClass = "ZomBrute";
                    break;
                case kActorActivatedAbilityTagTurboSpeed:
                    zombieClass = "Flamehead";
                    break;
                case kActorActivatedAbilityTagRessurect:
                    zombieClass = "Flower Zombie";
                    break;
                case kActorActivatedAbilityTagExplode:
                    zombieClass = "ZomGoblin";
                    break;
                case kActorActivatedAbilityTagLaserV2:
                    zombieClass = "Robo Zombie";
                    break;
                case kActorActivatedAbilityTagDoubleStrike:
                    zombieClass = "Zombielocks";
                    break;
                case kActorActivatedAbilityTagBashV2:
                    zombieClass = "Zombarian";
                    break;
                case kActorActivatedAbilityTagBlock:
                    zombieClass = "Party Zombie";
                    break;
                case kActorActivatedAbilityTagHealAOE:
                    zombieClass = "Zombee";
                    break;
                case kActorActivatedAbilityTagExplodeV2:
                    zombieClass = "Imp Zombie";
                    break;
                default:
                    zombieClass = "zombie";
                    break; // lowercase "zombie" == no zombie class defined in list
            }
            
            if (true /*ZombieFarmAppDelegate.getCurrentLanguage() == "zh-Hant" || ZombieFarmAppDelegate.getCurrentLanguage() == "zh-Hans" || ZombieFarmAppDelegate.getCurrentLanguage() == "ja"*/)
            {
                this._newAbilityDescription	= CCLabel.labelWithString(sprintf(NSLocalizedString("Unlocked a new %@ ability!"), zombieClass), "Arial", 26);
                this._newAbilityTapIconToContinue = CCLabel.labelWithString(NSLocalizedString("tap icon to continue"), "Arial", 26);
            }
            
            this._newAbilityColorLayer = CCColorLayer.layerWithColor(ccc4(0, 0, 0, 0xd0), 480.0 * 2, 50.0 * 2);
            this._newAbilityColorLayer.setPosition(new Core.Point(0, 300));
            
            this._newAbilityDescription.setPosition(460, 350);
            this._newAbilityDescription.setScale(0.7 * this._widthScale, 0.7 * this._widthScale);
            this._newAbilityDescription.setAlpha(0);
            this._newAbilityTapIconToContinue.setPosition(460, 270);
            this._newAbilityTapIconToContinue.setScale(0.5 * this._widthScale, 0.5 * this._widthScale);
            this._newAbilityTapIconToContinue.setAlpha(0);
            
            // actions
            
            this._newAbilityBG = new CCLayer();
            this._newAbilityBG.setPosition(ccp(0, 0));
            
            var zombieHand = CCSprite.spriteWithFile("handHoldingSign.png");
            zombieHand.setScale(0.6 * this._widthScale, 0.6 * this._widthScale);            
            zombieHand.setPosition(460, -100);
            
            var abilityBorder = CCSprite.spriteWithFile("abilityBorder.png");
            abilityBorder.setScale(tempScale, tempScale);            
            abilityBorder.setPosition(460, 25);
            newAbilityItem.setScale(tempScale, tempScale);
            newAbilityItem._normalImage.setPosition(ccpAdd(newAbilityItem._normalImage.getPosition(), ccp(1,-70)));
            
            this._newAbility.setPosition(ccpAdd(zombieHand._position, ccp(-47, -48)));
            this._newAbilityBG.addChild(zombieHand, 1);
            this._newAbilityBG.addChild(abilityBorder, 0);
            this._newAbilityBG.addChild(this._newAbility, 2);
            
            var start = ccp(0, -20);
            var end = ccp(0, 100);

            this._newAbilityColorLayer.setScale(this._newAbilityColorLayer.getScale()._x, 0);
            
            this._newAbilityBG.setPosition(start);
            this._newAbilityBG.runAction(CCMoveTo.actionWithDuration(time, end));
            
            this._newAbilityColorLayer.runAction(CCSequence.actions([CCScaleTo.actionWithDuration(0.2, 1.2 * this._widthScale), CCScaleTo.actionWithDuration(0.2, 1.0 * this._widthScale), null]));
            this._newAbilityDescription.runAction(CCSequence.actions([CCDelayTime.actionWithDuration(0.1), CCFadeTo.actionWithDuration(0.3, 255), null]));
            
            newAbilityItem.isEnabled = false;
            
            this.schedule(this.enableButtonAfterAnim, time, "enableByttonAfterAnim");
            this.schedule(this.tapIconToDisappearVisible, 4, "tapIconToDisappearVisible");
            
            //z:200 is roughly the same zorder as the zombie hp bars
            
            var shine1 = CCSprite.spriteWithFile("shine.png");
            shine1.setScale(this._widthScale, this._widthScale);
            shine1.setPosition(ccpAdd(this._newAbility.getPosition(), ccp(0, -250 * this._widthScale)));
            shine1.setAnchorPoint(ccp(0.5, 0));
            this._parent.addChild(shine1, 199, this.fightManTags.kFightManTagShine1);
            
            var actionTo = CCSequence.actions([CCRotateTo.actionWithDuration(1, 0), CCRotateTo.actionWithDuration(1, 10), null]);
            var repeatAction = CCRepeatForever.actionWithAction(actionTo);
            shine1.setRotation(10);
            shine1.runAction(CCMoveTo.actionWithDuration(time, ccpAdd(shine1.getPosition(), ccp(40, 550))));
            shine1.runAction(repeatAction);
            
            var shine2 = CCSprite.spriteWithFile("shine.png");
            shine2.setScale(this._widthScale, this._widthScale);
            shine2.setPosition(ccpAdd(this._newAbility.getPosition(), ccp(0, -250 * this._widthScale)));
            shine2.setAnchorPoint(ccp(0.5, 0));
            this._parent.addChild(shine2, 199, this.fightManTags.kFightManTagShine2);
            
            actionTo = CCSequence.actions([CCRotateTo.actionWithDuration(1, 0), CCRotateTo.actionWithDuration(1, -10), null]);
            repeatAction = CCRepeatForever.actionWithAction(actionTo);
            shine2.setRotation(-10);
            shine2.runAction(CCMoveTo.actionWithDuration(time, ccpAdd(shine2.getPosition(), ccp(40, 550))));
            shine2.runAction(repeatAction);
            
            this._parent.addChild(this._newAbilityBG, 200);
            this._parent.addChild(this._newAbilityColorLayer, 198);
            this._parent.addChild(this._newAbilityDescription, 199);
            this._parent.addChild(this._newAbilityTapIconToContinue, 199);
        }
        else
        {
            this.schedule(this.showFightSummaryIn, 0);
        }
    },
    
    setZombieYOrder : function(zombiesTemp)
    {
        // 3 loops used to make an array that contains the zombies yOrders
        //
        // yOrder index is == zombie index, and value == zombie y position
        // tempYOrder index is == zombie y position, and value == zombie index
        //
        // reversing tempYOrder is useful if the array becomes larger 
        // (e.g. 100 zombie array == a lot of searching and sorting)
        
        var largeZombieIndex = 0;
        var regularZombieIndex = 0;
        var gardenZombieIndex = 0;
        var girlZombieIndex = 0;
        var headlessZombieIndex = 0;
        var smallZombieIndex = 0;
        
        
        
        var tempYOrder = [];
//        tempYOrder.length = zombiesTemp.length;
       
//        for (var i = 0; i < zombiesTemp.length; i++)
//        {
//            tempYOrder[i] = null;
//        }
        
        for (var key in zombiesTemp)
        {
            var zombie = zombiesTemp[key];
            if (zombie instanceof ZombieActorLarge)
            {
            	if(!tempYOrder[5])
            		tempYOrder[5] = [];
                tempYOrder[5][largeZombieIndex] = key;
                largeZombieIndex++;
            }
            else if (zombie instanceof ZombieActorRegular)
            {
            	if(!tempYOrder[4])
            		tempYOrder[4] = [];
                tempYOrder[4][regularZombieIndex] = key;
                regularZombieIndex++;
            }
            else if (zombie instanceof ZombieActorGarden)
            {
            	if(!tempYOrder[3])
            		tempYOrder[3] = [];
                tempYOrder[3][gardenZombieIndex] = key;
                gardenZombieIndex++;
            }
            else if (zombie instanceof ZombieActorGirl)
            {
            	if(!tempYOrder[2])
            		tempYOrder[2] = [];
                tempYOrder[2][girlZombieIndex] = key;
                girlZombieIndex++;
            }
            else if (zombie instanceof ZombieActorHeadless)
            {
            	if(!tempYOrder[1])
            		tempYOrder[1] = [];
                tempYOrder[1][headlessZombieIndex] = key;
                headlessZombieIndex++;
            }
            else if (zombie instanceof ZombieActorSmall)
            {
            	if(!tempYOrder[0])
            		tempYOrder[0] = [];
                tempYOrder[0][smallZombieIndex] = key;
                smallZombieIndex++;
            }
        }
        
        this._yOrder.length = 0;
        for (var i = 0; i < zombiesTemp.length; i++)
        {
            this._yOrder[i] = null;
        }
        
//        var i = 0;
//        var tier = 0;
//        var previousIndex = -1;
//        for (var num in tempYOrder)
//        {
//        	var zombieIndex = tempYOrder[num] || 0;        	
//            if (previousIndex > -1)
//            {
//                if (!(zombiesTemp[zombieIndex] instanceof zombiesTemp[previousIndex].constructor))
//                {
//                    tier = 0;
//                }
//            }
//            var zombiePosition = ccp(tier, i);
//            this._yOrder[zombieIndex] = zombiePosition;
//            i++;
//            tier++;
//            
//            previousIndex = zombieIndex;
//        }
        var i = 0;
        for (var num in tempYOrder)
        {
        	var zombieClass = tempYOrder[num];
        	var tier = 0;
        	for(var key in zombieClass){
        		var zombieIndex = zombieClass[key];
        		
        		var zombiePosition = ccp(tier, i);
        		this._yOrder[zombieIndex] = zombiePosition;
        		tier++;
        		i++;
        	}
        	zombieClass.length = 0;
        	zombieClass = null;
        }
        
        tempYOrder.length = 0;
        tempYOrder = null;
    },
    
    initDataWithDictionary : function(aDict)
    {
        // Save these values for use elsewhere        
        this._resolutionWidth = 960;
        this._resolutionHeight = 640;
        
        this._widthScale = this._resolutionWidth / 480;
        this._heightScale = this._widthScale; //resolutionHeight / 320;
        
        this._newAbility = null;
        this._newAbilityDescription = null;
        this._newAbilityTapIconToContinue = null;
        this._newAbilityColorLayer = null;
        
        var gs = GameState;
        
        this._enemyDictionary = aDict;
        this._enemyName = this._enemyDictionary["name"];
        this._enemyPopulation = this._enemyDictionary["population"];
        
        this._allAttacks = DataPreloader._attacksData;
        
        this._currentBossAction = null;
        this._newZombieEntersFight = false;
        
        if (!(gs._zfGameData._gflags & ZFGameFlags.GFLAG_FIGHT_TUTORIAL))
        {
            this._enemyPopulation = 5;
        }
        
        this._reward = this._enemyDictionary["reward"];
        if (gs._zfGameData._currentEnemy == 0) //farm
        {
            var mult = (gs._zfGameData._level < ZFGameDefines.TIER1LVL) ? 1.0 : ((gs._zfGameData._level < ZFGameDefines.TIER2LVL) ? 1.25 : 1.5);
            //reward += reward * mult *(gs.level / (MAXLEVEL*1.0));
            this._reward *= mult;
        }
        else if (gs._zfGameData._currentEnemy == 1) //city
        {
            var mult = (gs._zfGameData._level < ZFGameDefines.TIER4LVL) ? 1.0 : ((gs._zfGameData._level < ZFGameDefines.TIER5LVL) ? 1.25 : 1.5);
            this._reward *= mult;
        }
        
        this._xpGained = this._enemyDictionary["xp"];
        
        this._fightEffectList = [];
        this._zombies = [];
        this._farmDespawnList = [];
        this._defeatedZombies = [];
        this._stageActors = [];
        this._yOrder = [];
        this._pendingActivatedAbilities = [];
        this._zombieCount = GameState.curArmySize();
        this._zombieCasualty = 0;
        this._enemyCasualty = 0;
        this._refund = 0;
        this._bonusRoll = 0;
        this._deployTimer = 10;
        this._fightTimer = 0;
        this._bossActionCooldownTimer = 0;
        this._bossActionCastTimer = 0;
        this._special = null;
        this._enemyList = null;
        this._telekinesis = null;
        this._startGame = false;
        this._fightTime = 0;
        
        this._enemyPosition = (this._enemyDictionary["enemyPosition"]) ? CGPointFromString(this._enemyDictionary["enemyPosition"]) : ccp(ZFGameDefines.ENEMY_POSITION_X, ZFGameDefines.ENEMY_POSITION_Y);
        this._bossPosition = (this._enemyDictionary["bossPosition"]) ? CGPointFromString(this._enemyDictionary["bossPosition"]) : ccp(ZFGameDefines.BOSS_POSITION_X, ZFGameDefines.BOSS_POSITION_Y);
        this._enemySpawnPosition = (this._enemyDictionary["enemySpawnPosition"]) ? CGPointFromString(this._enemyDictionary["enemySpawnPosition"]) : ccp(ZFGameDefines.ENEMY_POSITION_X, ZFGameDefines.ENEMY_POSITION_Y);
        this._zombieAttackPosition = (this._enemyDictionary["zombieAttackPosition"]) ? CGPointFromString(this._enemyDictionary["zombieAttackPosition"]) : ccp(ZFGameDefines.ENEMY_POSITION_X, ZFGameDefines.ENEMY_POSITION_Y);
        
        this._enemyPosition.setX(this._enemyPosition._x * this._widthScale);
        this._enemyPosition.setY(this._enemyPosition._y * this._heightScale);
        this._bossPosition.setX(this._bossPosition._x * this._widthScale);
        this._bossPosition.setY(this._bossPosition._y * this._heightScale);
        this._enemySpawnPosition.setX(this._enemySpawnPosition._x * this._widthScale);
        this._enemySpawnPosition.setY(this._enemySpawnPosition._y * this._heightScale);
        this._zombieAttackPosition.setX(this._zombieAttackPosition._x * this._widthScale);
        this._zombieAttackPosition.setY(this._zombieAttackPosition._y * this._heightScale);

//      this._enemyPopulation = 1;
        return this;
    },
    
    jsonToGamePosition : function(point)
    {
    	return new Core.Point(point._x + 123123123, point._y + 123123213);
    },
    
    initialSpawn : function()
    {        
    	var gs = GameState;
        
        //Spawn the levelBoss
        var acm = ZFActorManager;
        var bossname = this._enemyDictionary["boss"];
        // if a boss for the stage exists 
        if (bossname)
        {
//        	this._boss = acm.spawnFightActor(bossname, new Core.Point(300,400), this._parent, 3);
        	this._boss = acm.spawnFightActor(bossname, this._bossPosition, this._parent, 3);
        	this._boss._spriteMan.setScale(this._boss._spriteMan.getScale()._x * this._widthScale, this._boss._spriteMan.getScale()._y * this._widthScale);
            
            this._boss._walkingSpeed *= this._widthScale;
            
            //hack for fuzzy dairy king
            var realBossName = this._enemyDictionary["bossName"];
            if (realBossName == "Dairy King" && this._widthScale > 1)
            {
                this._boss._spriteMan.setScale(1.75, 1.75);
            }
            //end hack
        }
        else
        {
        	// array of the list of enemies i.e. class name followed by frequency
            this._enemyList = [].concat(this._enemyDictionary["enemies"]);
            
            // grabs a random enemy from the list and then removes it (forcing unique spawns)
            var randomEnemy = Math.floor(Math.random() * this._enemyList.length);
            randomEnemy %= this._enemyList.length; // in case CCARCRANDOM returns a perfect 1 (extremely unlikely)
            // fyi: apparently ccarcrandom is 0 - 0.99 so it's impossible to get 1 ... still it's really really hard to test if true
            
            bossname = this._enemyList[randomEnemy]["enemy"];
            this._enemyList.splice(randomEnemy, 1);
            
            if (this._enemyList.length == 0)
            {
                this._enemyList = null;
            }
            this._boss = acm.spawnFightActor(bossname, this._bossPosition, this._parent, 3);
            this._boss._spriteMan.setScale(this._boss._spriteMan.getScale()._x * this._widthScale, this._boss._spriteMan.getScale()._y* this._heightScale);
            
            // activate enrage here
            
            var enrage = this._boss.getAbilityByTag(kFightEffectEnemyBuffEnrage);
            if (enrage)
            {
                enrage._unlocked = true;
            }
        }
        
        this._boss._subType = CivilianActorFight.civilianSubTypes.civilianSubTypeBoss;
        this._boss.setAnchorPoint(ccp(1, 0));
        this._boss.setState(kActorFightStateBossWait);
        this._boss.movementUpdate(0); // Need to get dt passed in somehow
        
        //Spawn the Zombies
        var zombiesTemp = [];
        
        //farm zombies are added to zombiesTemp array
        for (var key in acm._actorList)
        {

            var actor = acm._actorList[key];
        	if (actor._type == kActorTypeZombie)
            {
                zombiesTemp.push(actor);
            }
        }
        // all temp zombies are loaded at this point
        this.setZombieYOrder(zombiesTemp);
        this._zombieCount = zombiesTemp.length;
        for (var key in zombiesTemp )
        {
        	var actor = zombiesTemp[key];
            var zombiePosition = this._yOrder[key];
            
            if (!zombiePosition)
            {
                zombiePosition = ccp(0,0);
            }
            
            var i = zombiePosition._y;
            var order = 5;
            var posx = Math.random() * 10;
            var posy = (((i % zombiesTemp.length) * 2) - 5); // used to be modulo 10
            order += zombiesTemp.length - i;
            zombiePosition.setX(zombiePosition._x * this._widthScale);
            zombiePosition.setY(zombiePosition._y * this._heightScale); //do this after z order var is set
            //spawn offscreen
            var zombie = acm.spawnFightActor(actor, ccp(-50.0 - posx, posy), this._parent, order);
            zombie._order = order;
            zombie._spriteMan.setScale(zombie._spriteMan.getScale()._x * this._widthScale, zombie._spriteMan.getScale()._y * this._widthScale);
            /* FIXME: particles
            for (var p in zombie.particles)
            {
                p.particle.scale *= widthScale;
            }*/
            zombie._walkingSpeed *= this._widthScale;
            zombie._hunger = actor._hunger;
            zombie._eatDate = actor._eatDate;
            if (zombie._eatDate == 0)
            {
                zombie._eatDate = Core.Time.getRealTime()/1000;
            }
            zombie._fights = actor._fights;
            zombie._doppleganger = actor;
            
            zombie._state = kActorFightStateWait;
            zombie.addMutation(actor._flags);
            zombie.flipActor(true);
            this._zombies.push(zombie);
            zombie._savedColor = actor._savedColor;
            // for fight buffs 
            //[zombie initActorSpecificAbilities];
            zombie.resetColor();
        }
        //Robot Stage
        if (gs._zfGameData._currentEnemy == 4)
        {
            this._special = acm.spawnFightActor("RobotStageActorGiantBot", ccp(430, -300), this._parent, 1);
            this._special._spriteMan.setScale(this._special._spriteMan.getScale()._x * this._widthScale, this._special._spriteMan.getScale()._y * this._heightScale);
        }
        ZFFightGUI.updateEnemyCount();
        ZFFightGUI.updateZombieCount();
        this._doOrDie = false;
        this._bossSummonList = null;
        
        // alien stage specific mechanics
        if (gs._zfGameData._currentEnemy == 5)
        {
            // 10 second spawn timer
            this._spawnTimer = 10;
            
            this._bossSummonList = []; // iz empty
            this._bossSummonList.push("FarmStageActorLumberjack");
            
            // TEST
//            this._bossSummonList.push("FarmStageActorLumberjack");
//            this._bossSummonList.push("CityStageActorCrazedWorker");
//            this._bossSummonList.push("NinjaStageActorBoy");
        }
        else
        {
            // 1 hour spawn timer 
            this._spawnTimer = 60 * 60;
        }
        
        this._enemySlots = new Array(5);
        if (this._enemyDictionary["stageActors"])
        {
            var stageActorDictionaries = this._enemyDictionary["stageActors"];        
            for ( var key in stageActorDictionaries)
            {
                var stageActorDictionary = stageActorDictionaries[key];
            	this.spawnStageActorWithDictionary(stageActorDictionary);
            }
        }
        
        this._bonusRoll = gs._bonusDropRate;
        gs._bonusDropRate = 0;
        
        this._zombieThinking = false;
        this._zombiesFighting = 0;
    },
    
    spawnEnemy : function()
    {
        var gs = GameState;
        var uKey;
        
        if (this._enemyList)
        {
            // grabs a random enemy from the list and then removes it (forcing unique spawns)
            var randomEnemy = Math.floor(Math.random() * this._enemyList.length);
            randomEnemy %= this._enemyList.length; // in case CCARCRANDOM returns a perfect 1 (extremely unlikely)
            
            uKey = this._enemyList[randomEnemy]["enemy"];
            this._enemyList.splice(randomEnemy, 1);
            if (this._enemyList.length == 0)
            {
                this._enemyList = null;
            }
        }
        else
        {
            var enemies = [].concat(this._enemyDictionary["enemies"]);
            var aEnemy = GameState.rollAgainstFrequencyInArray(enemies);
            uKey = aEnemy["enemy"];
        }
        
        var dude = ZFActorManager.spawnFightActor(uKey, this._enemySpawnPosition, this.getParent(), 3);
        dude._spriteMan.setScale(dude._spriteMan.getScale()._x * this._widthScale, dude._spriteMan.getScale()._y * this._widthScale);
        dude._walkingSpeed *= this._widthScale;
        dude._subType = CivilianActorFight.civilianSubTypes.civilianSubTypeFodder;
        dude.setAnchorPoint(ccp(1, 0));
        dude._state = kActorFightStateGo;
        
        // check for applicable buffs
//        for ( var key in this._fightEffectList)
//        {
//            var effect = this._fightEffectList[key];
//        	effect.applyEffectToActor(dude);
//        }
        
        if (gs._zfGameData._currentEnemy == 5)
        {
            // if alien stage 
            var randomRed = Math.floor(Math.random() * 255);
            var randomGreen = Math.floor(Math.random() * 255);
            var randomBlue = Math.floor(Math.random() * 255);
            
            dude._savedColor = ccc3(randomRed, randomGreen, randomBlue);
            dude.resetColor();
        }
        
        return dude;
    },
    
//    setAttackAnimations : function(){
//    	console.log("--------------------------------------------------");
//    	var orders = {};
//    	for ( var key in this._zombies)
//        {
//        	var zombie = this._zombies[key];
//        	if(zombie.isInMeleeRange()){
//        		console.log("--------Created: "+zombie.classname +" at"+zombie._spriteMan._zOrder);
//        		orders[zombie._spriteMan._zOrder] = key;
//        	}
//        	else
//        		zombie._stopAction = false;
//        }
//    	
//    	var maxAnimated = 2;
//    	var animated = 0;
//    	for ( var order in orders)
//        {
//        	var key = orders[order];
//        	if(!key)
//        		continue;
//    	
//        	var zombie = this._zombies[key];
//        	
//        	if(animated < maxAnimated){
//        		console.log("-----------------: "+zombie.classname+" at"+zombie._spriteMan._zOrder);
//        		zombie._stopAction = false;
//        	}
//        	else{
//        		console.log("------+++++++++++: "+zombie.classname);
//        		zombie._stopAction = true;
//        	}
//        	
//        	animated ++;
//        		
//        }
//    },
    
    update : function(dt)
    {        
        var fpsComp = dt * 60;
        this._fightTimer += fpsComp / 60;
        
        // Check if the game is done       
        if (this.gameOverCheckForUpdate())
        {
            return;
        }
        
        // update for every zombie
        for ( var key in this._zombies)
        {
        	var zombie = this._zombies[key];
//        	zombie._spriteMan.setDepth(zombie._order);
        	if(zombie.isInMeleeRange()){

	        	if (key > 3){
	        		zombie._stopAction = true;
	        		zombie._spriteMan.setDepth(zombie._order);
	            }
	        	else{
	        		zombie._stopAction = false;
//	        		zombie._spriteMan.getParent().reorderChild(zombie._spriteMan,1000 + zombie._order);
	        	}
        	}
        	else{
        		zombie._stopAction = false;
//        		zombie._spriteMan.getParent().reorderChild(zombie._spriteMan,zombie._order);
        	}
        	
            if ((zombie._state == kActorFightStateEnterFight ||
                 zombie._state == kActorFightStateUsingAbilityAtRange ||
                 zombie._state == kActorFightStateFightingBossWall) &&
                 !zombie._fightData._isGettingBuffed)
            {
                //////////////// ZOMBIE ENTERED FIGHT SECTION OF CODE ///////////
                
                // check bufflist !
                for (var i in this._fightEffectList)
                {
                    var buff = this._fightEffectList[i];
                	buff.applyEffectToActor(zombie);
                }
                
                // check if zombie can give buffs - buffs and adds it to list already
                this.checkForEffects(zombie);
                
                zombie._fightData._isGettingBuffed = true; // now this zombie is getting buffed and unbuffed
                
                // first time a headless zombie comes in it always goes into the first slot
                if (zombie instanceof ZombieActorHeadless)
                {
                    var zombiesTemp = [];
                    for ( var i in this._zombies)
                    {
                        var z = this._zombies[i];
                    	if (Math.floor(i / 5) == 0 && z.isInMeleeRange())
                            zombiesTemp.push(z);
                    }
                    for ( var i in zombiesTemp)
                    {
                        var z = zombiesTemp[i];
                    	if (z instanceof ZombieActorHeadless)
                            z.setZombieToLastIndex();
                    }
                    
                    this._zombies.splice(this._zombies.indexOf(zombie), 1);
                    this._zombies.unshift(zombie);
                }
                
                this.reorderZombies();
            }
            
            if (zombie._state == kActorFightStateEnterFight && zombie._fightData._isGettingBuffed)
            {
                this._newZombieEntersFight = true;
                //zombie.fightData.opponent = nil; // just in case (i.e. lasers activated ability might screw this up)
                
                zombie.setState(kActorFightStateFight);
            }
            
            // if the zombie has no target but is in the fight state
            else if (zombie._state == kActorFightStateFight && !zombie._fightData._opponent)
            {
                // if an enemy exists and he is attacking
                // extra - make sure to wail on the enemy when in melee range
                if (this._enemy && this._enemy._fightData._hitPoints > 0 && this._enemy.isInMeleeRange())
                {
                    // set the zombies target and state
                    zombie._fightData._opponent = this._enemy;
                    
                    //[zombie setState:kActorFightStateFighting];
                }
            }
        }
        
        //sort the array by level
        // TODO: z sorting
        /*
        var zOrderSorter = [[[NSSortDescriptor alloc] initWithKey:"zOrder" ascending:YES] autorelease];
        [zombiesInFight sortUsingDescriptors:[NSArray arrayWithObject:zOrderSorter]];
        */
        
//        this.setAttackAnimations();
        
        //give the enemy a zombie
        if (this._enemy && ((!this._enemy._fightData._opponent && !this._enemy._fightData._attacking) || this._newZombieEntersFight))
        {
            var eligibleZombies = [];
            var noEnemy = false;
            
            if (!this._enemy._fightData._opponent)
            {
                noEnemy = true;
            }
            
            for ( var key in this._zombies)
            {
                var zombie = this._zombies[key];
            	if (this._enemy.isInMeleeRange() && zombie.isInMeleeRange())
                {
                    if (zombie._fightData._hitPoints > 0)
                    {
                        eligibleZombies.push(zombie);
                    }
                }
            }
            
            if (eligibleZombies.length > 0)
            {
                // sort array here
                
                // picks the first zombie with the highest priority, tankZombie = newest zombie with the highest priority
                
                //ZombieActor *previousTarget = (ZombieActor *)enemy.fightData.opponent;
                
                var target = null;
                for ( var key in this._zombies)
                {
                    var z = this._zombies[key];
                	if (Math.floor(key / 5) > 0)
                        break;
                    
                    if (z.isInMeleeRange())
                    {
                        if (!target)
                            target = z;
                        else
                        {
                            if (z._priority > target._priority)
                                target = z;
                        }
                    }
                }
                
                this._enemy._fightData._opponent = target;
                for (var key in this._enemySlots)
                {
                    var c = this._enemySlots[key];
                	if (!c)
                        continue;
                    c._fightData._opponent = target;
                }
                
                // all zombies should have used this chance to update themselves by now so unset the boolean
                
                if (this._newZombieEntersFight)
                {
                    this._newZombieEntersFight = false;
                }
            }
        }
        
        if (this._enemy)
        {
            // clear dead enemies
            if (this._enemy._state == kActorFightStateDead)
            {
                if (this._enemy == this._boss)
                {
                    this._boss = null;
                }
                
                this._enemy = null;
            }
            
            if (this._enemy == this._boss && (
            		this._state == kActorFightStateBossTelekinesis || 
            		this._state == kActorFightStateBossWait || 
            		this._state == kActorFightStateBossSummonWall || 
            		this._state == kActorFightStateBossThrow))
            {
                this._enemy.setState(kActorFightStateBossGoDown);
            }
        }
        else
        {
            // spawn more enemies section //
            
            // no more enemies? it's time to fight the boss
            if (this._enemyPopulation <= 0)
            {
                if (this._boss._state == kActorFightStateBossWait)
                {
                    this._boss._state = kActorFightStateBossGoDown;
                    this._enemy = this._boss;
                    ZFFightGUI._currentEnemyMaxHp = this._enemy._fightData._hitPoints;
                }
            }
            else
            {
                var gs = GameState;
                var nextEnemy = null;
                
                // check if there is an enemy waiting in line
                for ( var key in this._enemySlots)
                {
                    var e = this._enemySlots[key];
                	if (!e) //|| e.state == kActorFightStateStunned)
                        continue;
                    
                    nextEnemy = e;
                    break;
                }
                
                // there is an enemy waiting in line
                if (nextEnemy)
                {
                    this._enemy = nextEnemy; // should still have a retain from spawn function (double check that!)
                    
                    if (this._enemy._state == kActorFightStateFighting)
                        this._enemy.setState(kActorFightStateMoveForwardAfterAttack);
                    else
                    {
                        // this will unstun the mob
                        this._enemy.setState(kActorFightStateGo);
                    }
                    
                    this._enemySlots[this._enemySlots.indexOf(nextEnemy)] = null;
                }
                
                // if no enemies and not spawning + alien stage + enemyPopulation < 15 (i.e. after initial set of 5)
                if (!this.isScheduled(this.spawnEnemyIn))
                {
                    if (gs._zfGameData._currentEnemy == 5 && !nextEnemy && !this._enemy && this._enemyPopulation < 15)
                    {
                        // start spawning
                        var spawnThisManyEnemies = this._enemyPopulation;
                        
                        if (this._enemy)
                        {
                            spawnThisManyEnemies--;
                        }
                        
                        for ( var key in this._enemySlots)
                        {
                            var c = this._enemySlots[key];
                        	if (c instanceof CivilianActorFight && c._fightData._hitPoints > 0)
                            {
                                spawnThisManyEnemies--;
                            }
                        }
                        
                        spawnThisManyEnemies = (spawnThisManyEnemies > 5) ? 5 : spawnThisManyEnemies;
                        
                        // actual enemy population == fm.enemyPopulation - spawned enemies that are still alive
                        
                        while (spawnThisManyEnemies > 0)
                        {
                            if (!this._enemy)
                            {
                                this._enemy = this.spawnEnemy();
                                ZFFightGUI._currentEnemyMaxHp = this._enemy._fightData._hitPoints;
                                spawnThisManyEnemies--;
                            }
                            else
                            {
                                // find an emptySlot else quit
                                var availableSlot = -1;
                                for ( var i = 0; i < 5; i++)
                                {
                                    if (!this._enemySlots[i])
                                    {
                                        availableSlot = i;
                                        break;
                                    }
                                }
                                if (availableSlot >= 0)
                                {
                                    var newEnemy = this.spawnEnemy();
                                    this._enemySlots[availableSlot] = newEnemy;
                                    spawnThisManyEnemies--;
                                }
                                else
                                {
                                    spawnThisManyEnemies = 0;
                                }
                            }
                        }
                        
                    }
                    else
                    {
                        // check if over limit
                        var numberOfEnemies = 0;
                        
                        if (this._enemy && this._enemy._fightData._hitPoints > 0)
                        {
                            numberOfEnemies++;
                        }
                        for ( var key in this._enemySlots)
                        {
                            var c = this._enemySlots[key];
                        	if (!c)
                            {
                                continue;
                            }
                            if (c && c._fightData._hitPoints > 0)
                            {
                                numberOfEnemies++;
                            }
                        }
                        
                        if (this._enemyPopulation - numberOfEnemies > 0)
                        {
                            this.schedule(this.spawnEnemyIn, 1,"spawnEnemyIn");
                            if (this.spawnTimer < 10)
                            {
                                this.spawnTimer = 10;
                            }
                        }
                    }
                }
            }
        }
        
        if (this._bossWall)
        {
            if (this._bossWall._state == kActorFightStateDead || this._bossWall._state == kActorFightStateDying)
            {
                this._bossWall = null;
            }
        }
        
        if (this._bossActionCooldownTimer > 0)
        {
            this._bossActionCooldownTimer -= fpsComp;
        }
        
        if (this._bossActionCastTimer > 0)
        {
            this._bossActionCastTimer -= fpsComp;
        }
    },
    
    deploy : function(dt)
    {

    	//take a zombie from the wait pile and puts him in thought bubble minigame mode
        this.unschedule(this.deploy);

        if (this._zombiesFighting>= ZFGameDefines.MAX_ZOMBIE_FIGHTING || this._zombieThinking)
        	return;
        
        var zombieWaitArray = [];

        for ( var key in this._zombies)
        {
            var zombie = this._zombies[key];
        	
            if (zombie._state == kActorFightStateWait)
            {
                zombieWaitArray.push(zombie);
            }
        }
        
        if (zombieWaitArray.length <= 0 )
        {
            return;
        }
        
//        var randZombieIndex = 0;
        
        var length = zombieWaitArray.length;
        var maxZombieAnim = 0;
        for(var i = 0; (i < length && i< maxZombieAnim+1); i++)
        {
        	var zombie = zombieWaitArray[i];
        	
        	if(i==0){
                zombie.setState(kActorFightStatePrepStart);
                zombie.schedule(zombie.fightUpdate, 0.05, "fightUpdate");
                this._zombiesFighting++;
                this._zombieThinking = true;
                
                zombie.unschedule(zombie.fightWanderIn);
                zombie.moveToPoint(ccp(ZFGameDefines.FIGHT_PREPSPOT_X, zombie.getPosition()._y));
        	}
        		
        	else
        	{
        		if(!zombie._waitAnimated)
        			zombie.startAnimForWaitState();
        	}
        	
        }
    },
    
    isGameWon : function()
    {
        return (!this._boss && !this._enemy);
    },
    
    isGameLost : function()
    {
        return (this._boss._state != kActorFightStateDead && this._zombieCount <= 0);
    },
    
    zombiesEnterScene : function()
    {
        //scoot zombies forward
        for ( var key in this._zombies)
        {
            var zombie = this._zombies[key]; 
        	var newPosx = Math.floor(Math.random() * 50 * this._widthScale);
            zombie.setState(kActorFightStateEnterScene);
            zombie.moveToPoint(ccp(newPosx, zombie.getPosition()._y));
        }
    },
    
    startGame : function()
    {
        if (!this._startGame)
        {
            //activate the update loop
            this.scheduleUpdate();
            
            //activate the buff management loop
            this._buttonPressedTimer = 0;
            
            if (GameState._zfGameData._gflags & ZFGameFlags.GFLAG_FIGHT_TUTORIAL)
            {
                this.schedule(this.updateTimer, 1.0, "updateTimer");
            }
            
            //deploy the 1st Zombie
            this.schedule(this.deploy, 1.0, "deploy");
            ZFFightGUI.initEnrageTimer();
            this._startGame = true;
        }
    },
    
    gameOverCheckForUpdate : function()
    {
        var gs = GameState;
        
        if (this.isGameWon() || this.isGameLost()) {
            for ( var key in this._zombies ) {
            	var z = this._zombies[key];
            	z.resetActionData();
            	var rez = z.getAbilityByTag(kActorActivatedAbilityTagRessurect);
                if (rez && !rez._consumed && rez._active && this._defeatedZombies && this._defeatedZombies.length > 0)
                {
                    rez._consumed = true;
                    rez._active = false;
                    var zombieToRez = null;
                    for ( var y in this._defeatedZombies)
                    {
                        zombieToRez = this._defeatedZombies[y];
                        break;
                    }
                    
                    if (zombieToRez)
                        this._defeatedZombies.splice(this._defeatedZombies.indexOf(zombieToRez), 1);
                    else
                        break; // stop looking for zombies to rez if there are none
                }
            }
            
            // these zombies are dead 
            for ( var key in this._defeatedZombies )
            {
            	var z = this._defeatedZombies[key];
            	z.resetActionData();
                if (z._state == kActorFightStateDead || z._state == kActorFightStateDying)
                {
                    this._zombieCasualty++;
                    var hasPlowMonolith = gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_NO_PLOWCOST);
                    var plowCost = (hasPlowMonolith) ? 0 : ZFGameDefines.PLOW_COST;
                    this._refund = this._refund + ZFMarketMenu.costFromName(ZFMarketMenu.nameFromUnitKey(z.classname)) + plowCost;
                    this._farmDespawnList.push(z._doppleganger);
                }
            }
            
            // theres should be no zombies that are dead in the zombies list (clean this up later)
            for ( var key in this._zombies )
            {
            	var z = this._zombies[key];
                if (z._state == kActorFightStateDead || z._state == kActorFightStateDying)
                {
                    this._zombieCasualty++;
                    var hasPlowMonolith = gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_NO_PLOWCOST);
                    var plowCost = (hasPlowMonolith) ? 0 : ZFGameDefines.PLOW_COST;
                    this._refund = this._refund + ZFMarketMenu.costFromName(ZFMarketMenu.nameFromUnitKey(z.classname)) + plowCost;
                    this._farmDespawnList.push(z._doppleganger);
                }
            }
            
            // CLEANUP
            this.unschedule(this.updateTimer);
            
            /* FIXME: particles
            for (var temp in this._zombies)
            {
                var stun = null;
                for ( var ptemp in temp.particles)
                {
                    if (ptemp.tagID == kActorStunParticle)
                    {
                        stun = ptemp;
                        break;
                    }
                }
                
                if (stun)
                {
                    if (stun.particle && stun.particle.parent)
                    {
                        stun.particle.getParent().removeChild(stun.particle);
                    }
                    temp.particles.removeObject(stun);
                }
            }*/
            
            ZFFightGUI._abilityButtons.setVisible(false);
            ZFFightGUI.cleanupEnrageTimer();
            ZFFightGUI.cleanupDoOrDie();
            ZFFightGUI._zombieCount.setString("");
            ZFFightGUI._enemyCount.setString("");
            ZFFightGUI._zombieCountShadow.setString("");
            ZFFightGUI._enemyCountShadow.setString("");
            
            if(this._wall){
            	this._wall.cleanWall();
	            if(this._wall.getParent())
	            	this._wall.getParent().removeChild(this._wall);
    			destroyWithChildren(this._wall);
    			this._wall = null;
    		}
        }
        
        // dont forget to remove
        if (this.isGameWon()) //win
        {
            SimpleAudioEngine.playEffect(kWinnerSFX);
            
            if (this._special && (this._special instanceof RobotStageActorGiantBot))
            {
                this._special.setState(RobotStageActor.robotStageActorStates.kGiantBotStateStunned);
            }
            var guihud = ZFFightGUI.getChildByTag(ZFFightGUI.fightGuiTags.kFightGuiTagHUDMgr).getChildByTag(ZFFightGUI.fightGuiTags.kFightGuiTagHUD);
            guihud.setAlpha(0);
            //guihud.visible = false;
            for ( var i = ZFFightGUI.fightGuiTags.kFightGuiTagGo; i < ZFFightGUI.fightGuiTags.kFightGuiTagMAX; i++)
            {
                var node = ZFFightGUI.getChildByTag(i);
                if (node && node instanceof CCSprite)
                {
                    node.setAlpha(0);
                }
            }
            
            for ( var key in this._zombies )
            {
                var zombie = this._zombies[key];
                zombie.schedule(zombie.fightUpdate, 0.05, "fightUpdate");
            	var isScheduledToGo = zombie.isScheduled(zombie.fightGoIn);
                if (!isScheduledToGo && zombie._state != kActorFightStateDead && zombie._state != kActorFightStateGoing && zombie._state != kActorFightStateGo)
                {
                    zombie.schedule(zombie.fightGoIn, Math.floor(Math.random() * 2));
                }
            }
            
            this.playWinningEffects();
            
            // places the sprite and schedules the fightsummary for us
            this.getRandomAbilityToUnlock();
            
            this.unscheduleUpdate();
            
            return true;
        }
        else if (this.isGameLost()) //loss
        {
            if (this._special && (this._special instanceof RobotStageActorGiantBot))
            {
                this._special.setState(RobotStageActor.robotStageActorStates.kGiantBotStateFightWait);
            }
            
            SimpleAudioEngine.playBackgroundMusic(kLoseBGM);
            var guihud = ZFFightGUI.getChildByTag(ZFFightGUI.fightGuiTags.kFightGuiTagHUDMgr).getChildByTag(ZFFightGUI.fightGuiTags.kFightGuiTagHUD);
            guihud.setAlpha(0);
            if (this._boss != this._enemy)
            {
                var tauntBubble = CCSprite.spriteWithFile("taunt.png");
                tauntBubble.setPosition(ccp(this._bossPosition._x - (50 * this._widthScale), this._bossPosition._y + (70 * this._heightScale)));
                tauntBubble.setAnchorPoint(ccp(1, 0));
                this.getParent().addChild(tauntBubble, 100, this.fightManTags.kFightManTagTauntBubble);
                
                var rand = Math.random();
                var tauntString = null;
                var fontsize = 14;
                var yAdjust = 0;
                
                if (gs._zfGameData._currentEnemy == 0)
                {
                    if (rand < 1 / 10)
                    {
                        tauntString = "For the glory of love";
                        fontsize = 11;
                        yAdjust = -7;
                    }
                    else if (rand < 2 / 10)
                    {
                        tauntString = "Brush your teeth";
                        fontsize = 12;
                        yAdjust = -5;
                    }
                    else if (rand < 3 / 10)
                    {
                        tauntString = "I eat my spinach";
                        fontsize = 12;
                        yAdjust = -6;
                    }
                    else if (rand < 4 / 10)
                    {
                        tauntString = "Zombies be gone!";
                        fontsize = 13;
                        yAdjust = -3;
                    }
                    else if (rand < 5 / 10)
                    {
                        tauntString = "You lost?";
                        yAdjust = -15;
                    }
                    else
                    {
                        tauntString = "e-i-e-i owned";
                    }
                }
                else if (gs._zfGameData._currentEnemy == 1)
                {
                    if (rand < 1 / 10)
                    {
                        tauntString = "Hawaiian shirt Friday!";
                        fontsize = 11;
                        yAdjust = -7;
                    }
                    else if (rand < 2 / 10)
                    {
                        tauntString = "Dead-line is today";
                        fontsize = 12;
                        yAdjust = -5;
                    }
                    else if (rand < 3 / 10)
                    {
                        tauntString = "Didn't you get the memo?";
                        fontsize = 12;
                        yAdjust = -6;
                    }
                    else if (rand < 4 / 10)
                    {
                        tauntString = "Give a toot. Don't pollute!";
                        fontsize = 13;
                        yAdjust = -3;
                    }
                    else if (rand < 5 / 10)
                    {
                        tauntString = "Wheres my mocha latte?";
                        fontsize = 13;
                        yAdjust = -3;
                    }
                    else
                    {
                        tauntString = "You're fired!";
                    }
                }
                else if (gs._zfGameData._currentEnemy == 2)
                {
                    if (rand < 3 / 10)
                    {
                        tauntString = "Hoist the Jolly Roger!";
                        fontsize = 13;
                        yAdjust = -3;
                    }
                    else
                    {
                        tauntString = "ARRRRR!";
                        yAdjust = -17;
                    }
                }
                else if (gs._zfGameData._currentEnemy == 3)
                {
                    if (rand < 3 / 10)
                    {
                        tauntString = "Your kung-fu is no good!";
                        fontsize = 13;
                        yAdjust = -3;
                    }
                    else if (rand < 5 / 10)
                    {
                        tauntString = "Go ninja, go ninja, GO!";
                        fontsize = 13;
                        yAdjust = -3;
                    }
                    else
                    {
                        tauntString = "Roll Hax!";
                        yAdjust = -17;
                    }
                }
                else if (gs._zfGameData._currentEnemy == 4)
                {
                    if (rand < 3 / 10)
                    {
                        tauntString = "Domo Arigato";
                        fontsize = 13;
                        yAdjust = -3;
                    }
                    else if (rand < 5 / 10)
                    {
                        tauntString = "PC LOAD LETTER";
                        fontsize = 13;
                        yAdjust = -3;
                    }
                    else if (rand < 7 / 10)
                    {
                        tauntString = "1337";
                        yAdjust = -15;
                    }
                    else
                    {
                        tauntString = "Error 404: Zombies Not Found";
                        fontsize = 9;
                        yAdjust = -3;
                    }
                }
                else if (gs._zfGameData._currentEnemy == 5)
                {
                    if (rand < 3 / 10)
                    {
                        tauntString = "Now take me to your leader";
                        fontsize = 11;
                        yAdjust = -3;
                    }
                    else if (rand < 6 / 10)
                    {
                        tauntString = "Resistance is fertile";
                        fontsize = 13;
                        yAdjust = -3;
                    }
                    else
                    {
                        tauntString = "All your farm are belong to us";
                        fontsize = 10;
                        yAdjust = -8;
                    }
                }
                else if (gs._zfGameData._currentEnemy >= 6)
                {
                    {
                        tauntString = "Hahaha!";
                        yAdjust = -15;
                    }
                }
                
                var tauntLabel = CCLabel.labelWithString(NSLocalizedString(tauntString), CGSizeMake(100, 300), GL2.Text.HorizontalAlign.Center, "AmericanTypewriter-Bold", fontsize);
                
                tauntLabel.setPosition(ccp(-50,30));
                tauntLabel.setAnchorPoint(ccp(0.5, 0.5));
                tauntLabel.setColor(ccc3(0, 0, 0));
                tauntBubble.addChild(tauntLabel, 6, this.fightManTags.kFightManTagTauntText);
                tauntBubble.setScale(0.01 * this._widthScale, 0.01 * this._widthScale);
                tauntBubble.runAction(CCSequence.actions([CCDelayTime.actionWithDuration(0.25), CCScaleTo.actionWithDuration(0.25, 1.0 * this._widthScale), null]));
            }
            
            for ( var i = ZFFightGUI.fightGuiTags.kFightGuiTagGo; i < ZFFightGUI.fightGuiTags.kFightGuiTagMAX; i++)
            {
                var node = ZFFightGUI.getChildByTag(i);
                if (node && (node instanceof CCSprite))
                {
                    node.setOpacity(0);
                }
            }
            
            this.schedule(this.showFightSummaryIn, 2.0);
            this.unscheduleUpdate();
            
            return true;
        }
        
        return false;
    },
    
    cleanupLocal : function()
    {
        this.unscheduleAllSelectors();
        
        /*
        if([self isScheduled: @selector(updateTimer:)])         [self unschedule: @selector(updateTimer:)];
        if([self isScheduled: @selector(update:)])              [self unschedule: @selector(update:)];
        if([self isScheduled: @selector(spawnEnemyIn:)])        [self unschedule: @selector(spawnEnemyIn:)];
        if([self isScheduled: @selector(deploy:)])              [self unschedule: @selector(deploy:)];
        if([self isScheduled: @selector(showFightSummaryIn:)])  [self unschedule: @selector(showFightSummaryIn:)];
         */

        if (this._special)
        {
            this._special.stopAllActions();
            this._special.unscheduleAllSelectors()/*deactivateTimers*/;
            this._special.despawn();
            this._special = null;
        }
        
        if (this._telekinesis)
        {
            // FIXME: remove child
            this._telekinesis.getParent().removeChild(this._telekinesis, true);
            this._telekinesis.destroy();
            this._telekinesis = null;
        }
        if (  this.getParent().getChildByTag(this.fightManTags.kFightManTagTauntBubble) ) 
        	this.getParent().getChildByTag(this.fightManTags.kFightManTagTauntBubble).removeChildByTag(this.fightManTags.kFightManTagTauntText, true);
        this.getParent().removeChildByTag(this.fightManTags.kFightManTagTauntBubble, true);
        
        /*this._enemyDictionary = null;*/
        this._enemyList = null;
        
        this._enemyName = "";
        this._enemyPopulation = 0;
        this._reward = 0;
        this._xpGained = 0;
        this._zombieCount = 0;
        this._zombieCasualty = 0;
        this._enemyCasualty = 0;
        this._refund = 0;
        this._deployTimer = 0;
        this._fightTimer = 0;
        this._bossActionCooldownTimer = 0;
        
        if (this._enemy && this._boss != this._enemy)
        {
            this._enemy.stopAllActions();
            this._enemy.unscheduleAllSelectors()/*deactivateTimers*/;
            this._enemy.despawn();
            this._enemy = null;
        }
        else if (this._enemy == this._boss)
        {
            this._enemy = null;
        }
        
        if (this._boss)
        {
        	this._boss.stopAttachmentActions();
            this._boss.stopAllActions();
            this._boss.unscheduleAllSelectors()/*deactivateTimers*/;
            this._boss.despawn();
            this._boss = null;
        }
        
        if (this._bossWall)
        {
        	this._bossWall.stopAttachmentActions();
            this._bossWall.stopAllActions();
            this._bossWall.unscheduleAllSelectors();
            this._bossWall.despawn();
            this._bossWall = null;
        }
        
        if (this._stageActors)
        {
            for ( var aKey in this._stageActors)
            {
                this._stageActors[aKey].despawn();
            }
            
            this._stageActors.length = 0;
            this._stageActors = null;
        }
        
        if (this._enemySlots)
        {
            for ( var objectKey in this._enemySlots)
            {
                var object = this._enemySlots[objectKey];
                if (!object)
                {
                    continue;
                }
                else
                {
                    if (object)
                    {
                        object.stopAllActions();
                        object.unscheduleAllSelectors();
                        object.despawn();
                    }
                }
            }
            
            this._enemySlots = null;
        }
        
        if (this._bossSummonList)
        {
            this._bossSummonList.length = 0;
            this._bossSummonList = null;
        }
        
        if(this._yOrder)
    	{
        	this._yOrder.length = 0;
            this._yOrder = null;
    	}
        if(this._pendingActivatedAbilities.length){
        	this._pendingActivatedAbilities.length = 0;
        	this._pendingActivatedAbilities = null;
        }
        if(this._defeatedZombies)
        {
        	this._defeatedZombies.length = 0;
        	this._defeatedZombies = null;
        }
        if(this._fightEffectList){
        	this._fightEffectList.length = 0;
        	this._fightEffectList = null;
        }
        if(this._zombies){
        	this._zombies.length = 0;
        	this._zombies = null;
        }
        
        this._allAttacks = null;
        
        fp.cleanupLocal();
    },
    
    playWinningEffects : function()
    {
        /* FIXME: particle generator
        for(int i=0; i<3; i++)
        {
            var emitter = CCParticleFireworks.node();
            
            emitter.position = ccp((50 + (120 * i))*this._widthScale, 50*heightScale);
            emitter.startColor = (ccColor4F) {.5,.5,.5,1};
            emitter.startColorVar = (ccColor4F) {.5,.5,.5,.5};
            emitter.endColor = (ccColor4F) {.5,.5,.5,1};
            emitter.endColorVar = (ccColor4F) {.5,.5,.5,.5};
            emitter.life = 3;
            emitter.lifeVar = 0;
            emitter.startSize = 20*heightScale;
            emitter.startSizeVar = 5;
            emitter.endSize = 20*heightScale;
            emitter.blendAdditive = YES;
            emitter.emissionRate = 50;
            emitter.texture = [[CCTextureCache sharedTextureCache] addImage: "stars.png"];
            [self.parent addChild: emitter z:3];
        }*/
    },
    
    playDeathEffect : function()
    {
        /* FIXME: particle generator
        //poof im dead
        CCQuadParticleSystem *emitter = [ZFParticleEffects particleSystemByTag:"smoke.plist"];
        emitter.startSpin = 270;
        emitter.startSpinVar = 90;
        emitter.position = this._enemyPosition;
        emitter.scale *= widthScale;
        [self.parent addChild:emitter z:4];*/
    },
    
    updateTimer : function(dt)
    {
        this._spawnTimer -= dt;
        if (this._spawnTimer <= 0)
        {
            // summon enemy into que
            // ARGH CHECK HERE FOR ENEMY POPULATION
            
            // check if over limit
            var numberOfEnemies = 0;
            if (this._enemy && this._enemy._fightData._hitPoints > 0)
            {
                numberOfEnemies++;
            }
            
            for ( var key in this._enemySlots)
            {
                var c = this._enemySlots[key];
            	if (!c)
                {
                    continue;
                }
                if (c._fightData._hitPoints > 0)
                {
                    numberOfEnemies++;
                }
            }
            
            if (this._enemyPopulation - numberOfEnemies > 0)
            {
                this.schedule(this.spawnEnemyIn, 1,"spawnEnemyIn");
                this._spawnTimer = 10;
            }
        }
        
        this._fightTime += dt;
        if (this._boss)
        {
            this.updateActorEffects(this._boss, dt);
            var enrage = this._boss.getAbilityByTag(kFightEffectEnemyBuffEnrage);
            if (enrage)
            {
                this._enrageTime = enrage._timerActivateIn;
                ZFFightGUI.updateEnrageTimer();
            }
        }
        
        if (this._enemy && this._enemy != this._boss)
        {
            this.updateActorEffects(this._enemy, dt);
        }
        if (this._bossWall)
        {
            this.updateActorEffects(this._bossWall, dt);
        }
        if (this._enemySlots)
        {
            for ( var key in this._enemySlots)
            {
            	var c = this._enemySlots[key];
                if (!c)
                    continue;
                this.updateActorEffects(c, dt);
            }
        }
        
        for ( var key in this._zombies)
        {
        	var z = this._zombies[key];
            if (!(z._state == kActorFightStateDead ||
                  z._state == kActorFightStateDying ||
                  z._state == kActorFightStateWait))
            {
                this.updateActorEffects(z, dt);
            }
        }
        
        // for showing ability button
        var temp = ZFFightAbilityGUI.getAbilityToShowArrowWith();
        if (temp)
        {
            this._buttonPressedTimer++;
            
            if (this._buttonPressedTimer >= 5)
            {
                ZFFightAbilityGUI.showAbilityHelperArrow();
            }
            if (this._buttonPressedTimer == 13)
            {
                ZFFightAbilityGUI.cleanAbilityHelperArrow();
                this._buttonPressedTimer = 0;
            }
        }
        else
        {
            this._buttonPressedTimer = 0;
            ZFFightAbilityGUI.cleanAbilityHelperArrow();
        }
    },
    
    triggeredAbility : function(trigger)
    {
        var tempZombies = [].concat(this._zombies);
        var breakNow = false;
        for ( var i in tempZombies)
        {
            var z = tempZombies[i];
        	for ( var j in z._abilityList)
            {
                var a = z._abilityList[j];
        		// check if it's active ... any active ability has already been checked to be unlocked
                if (a._active && (a instanceof ZFActorActivatedAbility))
                {
                    if (a._trigger == trigger)
                    {
                        // this is the ability that was triggered so use it
                        // have the zombie perform its own ability method (if it exists!) 
                        if (a._abilityMethod)
                        {
                            // FIXME: implement tihs
                            //[z performSelector:((ZFActorActivatedAbility*)a).abilityMethod];
                        	eval("z."+a._abilityMethod+"()");
                        }
                        
                        if (a._consumable)
                        {
                            a._consumed = true; // makes sure it can't be turned on again
                        }
                        
                        if (a._useOnce) // don't check other zombies for the ability
                        {
                            breakNow = true;
                        }
                    }
                }
            }
            if (breakNow)
            {
                break;
            }
        }
        
        tempZombies.length = 0;
        tempZombies = null;
    },
    
    applyEffect : function(effect)
    {
        this._fightEffectList.push(effect);
        for ( var key in this._zombies)
        {
        	 var zombieToBeBuffed = this._zombies[key];
        	// for all zombies that are attacking ... (i.e. already buffed)
            if (zombieToBeBuffed._fightData._isGettingBuffed)
            {
                // if capable of applying buff effect then buff is applied
                effect.applyEffectToActor(zombieToBeBuffed);
            }
        }
        
        if (this._enemy)
            effect.applyEffectToActor(this._enemy);
        if (this._boss)
            effect.applyEffectToActor(this._boss);
        
        effect._active = true;
    },
    
    removeEffect : function(effect)
    {
        for (var key in this._zombies)
        {
            var zombieToBeUnBuffed = this._zombies[key];
        	// for all zombies that are attacking ... (i.e. already buffed)
            if (zombieToBeUnBuffed._fightData._isGettingBuffed)
            {
                // if capable of applying buff effect then buff is removed
                effect.removeEffectFromActor(zombieToBeUnBuffed);
            }
        }
        
        if (this._enemy)
            effect.removeEffectFromActor(this._enemy);
        if (this._boss)
            effect.removeEffectFromActor(this._boss);
        
        effect._active = true; // turns ability off so buff update doesn't have to
        this._fightEffectList.splice(this._fightEffectList.indexOf(effect), 1);
    },
    
    checkForEffects : function(a, removeEffect)
    {
        if (!removeEffect)
        {
            removeEffect = false;
        }
        
        // check all abilities
        for ( var key in a._abilityList)
        {
        	var ability = a._abilityList[key];
        	// is it a buff/debuff - is it unlocked ?
            if ((ability instanceof ZFActorFightEffect) && ability.isUseable())
            {
                // is it a group buff ? personal buffs are applied somewhere else 
                if (ability._appliesToGroup)
                {
                    // remove from the buff list if the ability is active
                    if (removeEffect && ability._active)
                    {
                        this.removeEffect(ability);
                        ZFFightAbilityGUI.removeBuffIcon(ability);
                    }
                    // add to the buff list if the ability is inactive AND able to be applied (no timer) and has no duration or duration > 0
                    else if (!(removeEffect || ability._active || ability._timerActivateIn > 0)) // nor operation
                    {
                        if (ability._timerActivateFor != 0)
                        {
                            this.applyEffect(ability); // apply to zombie group
                            ZFFightAbilityGUI.addBuffIcon(ability, a.getPosition());
                        }
                    }
                }
            }
            else if ((ability instanceof ZFActorActivatedAbility) && ability.isUseable())
            {
                var temp = ability;
                
                // get rid of all activated abilities
                if (temp._active && removeEffect)
                {
                    temp._active = false;
                    
                    // should make it so only abilities that need buttons get put into the list
                    this._pendingActivatedAbilities.splice(this._pendingActivatedAbilities.indexOf(temp), 1);
                    if (temp._needsButton){
                        ZFFightAbilityGUI.removeByActivatedAbilty(temp);
                    }
                    if (this.isActivatedAbilityOnPendingList(temp))
                        ZFFightAbilityGUI.addAbilityButton(temp);
                }
            }
        }
    },
    
    updateActorEffects : function(z, dt)
    {
        if (z._state == kActorFightStateStunned)
        {
            if (z._fightData._stunTimer > 0)
            {
                z._fightData._stunTimer -= dt;
                z._fightData._stunTimer = (z._fightData._stunTimer < 0) ? 0 : z._fightData._stunTimer;
            }
            else
            {
                var fm = this.fightMan();
                if (fm._boss == z && fm._enemy != fm._boss)
                    z.setState(kActorFightStateBossWait); // if the boss is stunned
                else if (z instanceof ZombieActor)
                {
                    z.setState(kActorFightStateGoing); // if it's a zombie 
                }
                else
                // if it's a civilian
                {
                    z.setState(kActorFightStateFight);
                }
                
                /* FIXME: particle engine
                // cleanup stun particles
                var p = null;
                for (var particle in z._particles)
                {
                    if (particle.tagID == kActorStunParticle)
                    {
                        p = particle;
                        break;
                    }
                }
                
                if (p)
                {
                    // remove from array
                    // remove from spriteManager parent (sprite layer)
                    z._spriteMan._parent.removeChild(p.particle, true);
                    z._particles.splice(z._particles.indexOf(p), 1);
                    p = null;
                }*/
            }
            
        }
        
        for ( var key in z._abilityList)
        {
        	var a = z._abilityList[key];
        	if ((a instanceof ZFActorFightEffect) && a._unlocked)
            {
                if (a._active)
                {
                    //why is ability active ? should it change ?
                    if (a._timerActivateFor > 0)
                    {
                        a._timerActivateFor -= dt;
                        a._timerActivateFor = (a._timerActivateFor < 0) ? 0 : a._timerActivateFor;
                    }
                    
                    if ((a._timerActivateFor == 0 || !a.canActivateInState(z._state)) || a._consumed) // -1 is reserved for abilities that have no expiration
                    {
                        if (a._appliesToGroup) // group buff that needs to be removed from the list
                        {
                            this.removeEffect(a);
                            if (z instanceof ZombieActor)
                            {
                                ZFFightAbilityGUI.removeBuffIcon(a);
                            }
                        }
                        else
                        {
                            // self buff that needs to be removed from a specific zombie
                            a.removeEffectFromActor(z);
                            a._active = false;
                        }
                        
                        // if a is not a consumed ability then restart the timer by making a brand new ability refreshing the timer
                        if (!a._consumable)
                        {
                            a.refreshTimers();
                        }
                        else
                        {
                            a._consumed = true;
                        }
                    }
                }
                else
                {
                    // make sure timer is ticking down regardless of requirements
                    if (a._timerActivateIn > 0)
                    {
                        a._timerActivateIn -= dt;
                        a._timerActivateIn = (a._timerActivateIn < 0) ? 0 : a._timerActivateIn;
                    }
                    
                    var passesRequirements = false;
                    if (!passesRequirements && (a._activateInMeleeIfLessThanTime > 0))
                    {
                        if (this._fightTime < (a._activateInMeleeIfLessThanTime && z.isInMeleeRange()))
                            passesRequirements = true;
                    }
                    
                    if (!passesRequirements && a._timerActivateIn <= 0 && !a._consumed && a._timerActivateFor != 0)
                    {
                        passesRequirements = true;
                    }
                    
                    if (passesRequirements)
                    {
                        //why is ability inactive ? should it change ?
                        
                        //                        if(a.timerActivateIn <= 0 && !a._consumed && a.timerActivateFor != 0)
                        //                        {
                        if (a.canActivateInState(z._state))
                        {
                            if (a._appliesToGroup)
                            { // group buff that needs to be added from the list
                                this.applyEffect(a); // gets set to active here so it'll continue to apply effect
                                if (z instanceof ZombieActor)
                                {
                                    ZFFightAbilityGUI.addBuffIcon(a, z.getPosition());
                                }
                            }
                            else
                            { // self buff that needs to be applied to zombie
                                a.applyEffectToActor(z);
                                a._active = true;
                            }
                        }
                        
                        if (a._particleEffectWhenActive)
                        {                        
//                           CCQuadParticleSystem *particle = [CCQuadParticleSystem particleWithFile:a.particleEffectWhenActive];
//                           particle.position = ccpMult(particle.position, widthScale);
//                           particle.scale *= widthScale;
                        	
                        	var sprite1 = CCSprite.spriteWithFile("icecream_1.png");
                        	var sprite2 = CCSprite.spriteWithFile("icecream_2.png");
//                        	var sprite3 = CCSprite.spriteWithFile("icecream_3.png");
                        	var initialPosition1 = ccp(990, 670);
                        	var initialPosition2 = ccp(950, 700);
                        	sprite1.setPosition(initialPosition1);
                        	sprite2.setPosition(initialPosition2);
                        	sprite2.setOpacity(0);
//                        	sprite3.setPosition(initialPosition);
                        	
                        	var actionTo1 = CCSequence.actions(
                    				CCMoveBy.actionWithDuration(2, ccp(-380, -850)),
                    				CCMoveTo.actionWithDuration(0, initialPosition1));
                    		var repeatAction1 = CCRepeatForever.actionWithAction(actionTo1);
                    		var actionTo2 = CCSequence.actions(
                    				CCDelayTime.actionWithDuration( 0.5 ),
                    				CCFadeIn.actionWithDuration(0),
                    				CCMoveBy.actionWithDuration(3, ccp(-400, -850)),
                    				CCMoveTo.actionWithDuration(0, initialPosition2),
                    				CCFadeOut.actionWithDuration(0)
                    				);
                    		var repeatAction2 = CCRepeatForever.actionWithAction(actionTo2);
//                    		var actionTo3 = CCSequence.actions(
//                    				CCMoveBy.actionWithDuration(6, ccp(-400, -850)),
//                    				CCMoveTo.actionWithDuration(0, initialPosition));
//                    		var repeatAction3 = CCRepeatForever.actionWithAction(actionTo3);
                    		sprite1.runAction(repeatAction1);
                    		sprite2.runAction(repeatAction2);
//                    		sprite3.runAction(repeatAction3);
                        	
                            this._parent.addChild(sprite1, 200, 65);
                            this._parent.addChild(sprite2, 200, 66);
//                            this._parent.addChild(sprite3, 200, 67);
                            SimpleAudioEngine.playBackgroundMusic(kStormSFX);
                        }
                    }
                }
            }
            else if ((a instanceof ZFActorActivatedAbility) && a._unlocked)
            {
                var temp = a;
                if (temp._requiresState)
                {
                    // include cooldowns ?
                    if (temp._active) // ability is ... <puts on glasses> ... active ... YYYEEEEAAAAAHHHH !!!
                    {
                    	// check if activated ability needs to be turned off
                        if (!temp.canActivateInState(z._state) || temp._timerActivateIn > 0 || temp._consumed)
                        {	
                        	temp._active = false;
                            if (temp._needsButton)
                            {
                            	this._pendingActivatedAbilities.splice(this._pendingActivatedAbilities.indexOf(temp), 1);
                                ZFFightAbilityGUI.removeByActivatedAbilty(temp);
                            }
                            if (this.isActivatedAbilityOnPendingList(temp))
                                ZFFightAbilityGUI.addAbilityButton(temp);
                        }
                        
                        // if the zombie is active ... and it has an autotrigger event
                        if (temp._trigger == kTriggerEventAuto && temp._active)
                        {
                            // use the ability ... it'll have its own refresh timers
                        	eval("z." + temp._abilityMethod + "()");
                        }
                    }
                    else
                    // ability is inactive 
                    {
                    	if (temp._timerActivateIn > 0)
                            temp._timerActivateIn--;
                        // check if activated ability needs to be turned on
                        if (temp.canActivateInState(z._state) && temp._timerActivateIn <= 0 && !temp._consumed && temp._timerActivateFor != 0)
                        {
                            var canSetActive = true;
                            if (temp._tag == kActorActivatedAbilityTagAttachMini)
                            {
                                // check zombie list for any miniZombie that's waiting
                                canSetActive = false;
                                for ( var key in this._zombies)
                                {
                                    var z = this._zombies[key];
                                	if ((z._state == kActorFightStateWait) && (z instanceof ZombieActorSmall))
                                    {
                                        canSetActive = true;
                                        break;
                                    }
                                }
                            }
                            
                            temp._active = canSetActive;
                            if (temp._active && temp._needsButton)
                            {
                                if (!this.isActivatedAbilityOnPendingList(temp))
                                    ZFFightAbilityGUI.addAbilityButton(temp);
                                this._pendingActivatedAbilities.push(temp);
                            }
                        }
                    }
                }
            }
        }
    },
    
    allowedToShootBullet : function()
    {
        if (this._bossActionCastTimer <= 0 && this._bossActionCooldownTimer <= 0 && this._startGame)
        {
            for (var key in this._zombies)
            {
                var z = this._zombies[key];
            	if (z.isInMeleeRange() ||
                    z._state == kActorFightStateGoing ||
                    z._state == kActorFightStateFightBossWall ||
                    z._state == kActorFightStateFightingBossWall ||
                    z._state == kActorFightStateFightBossWall)
                {
                    return true;
                }
            }
        }
        
        return false;
    },
    
    allowedToSummonMinion : function()
    {
        if (this._bossWall || this._bossActionCooldownTimer > 0 || this._bossActionCastTimer > 0)
        {
            return false;
        }
        
        return true;
    },
    
    allowedToThrowProjectile : function()
    {
        var throwingAllowed = false;
        for ( var zombieKey in this._zombies )
        {
            var zombie = this._zombies[zombieKey];
            if (this.isZombieAllowedToThrowAt(zombie))
            {
                throwingAllowed = true;
                break;
            }
        }
        
        if (this._bossActionCooldownTimer <= 0 && throwingAllowed)
        {
            return true;
        }
        
        return false;
    },
    
    allowedToSummonWall : function()
    {
        if (this._wall || this._bossActionCooldownTimer > 0 || this._bossActionCastTimer > 0)
        {
            return false;
        }
        
        var anyZombieLeft = false;
        for ( var key in this._zombies)
        {
        	var zombie = this._zombies[key];
        	if (zombie._state == kActorFightStateWait || zombie._state == kActorFightStatePrepStart || zombie._state == kActorFightStatePrepCycle || zombie._state == kActorFightStateGo
                    || zombie._state == kActorFightStateGoing)
            {
                anyZombieLeft = true;
                break;
            }
        }
        
        if (!this._wall && this._bossActionCooldownTimer <= 0 && this._bossActionCastTimer <= 0 && anyZombieLeft)
        {
            return true;
        }
        
        return false;
    },
    
    getLaserTarget : function(){
    	
    	fm = this;
    	var targetZombie = null;
        var targets = [];
        for ( var key in fm._zombies)
        {
        	var z = fm._zombies[key];
        	if (z.isInMeleeRange() || z._state == kActorFightStateGoing || z._state == kActorFightStateGoFightBossWall || z._state == kActorFightStateFightingBossWall
                    || z._state == kActorFightStateFightBossWall)
            {
                targets.push(z);
            }
        }
        
        if (targets.length > 0)
        {
            var randomZombieIndex = Math.floor(Math.random() * targets.length);
            targetZombie = fm._zombies[randomZombieIndex];         
            // schedules update
        }
    	
        return targetZombie;
    },
    
    shootBullet : function(bulletType, origin)
    {
    	fm = this;
    	if (!fm._currentBossAction){
            return;
        }
    	
        switch (bulletType)
        {
            case this.bulletTypes.kBulletTypeNil:
                return;
            case this.bulletTypes.kBulletTypeAlien:
                break;
        }
        // get a target 
        var targetZombie = this.getLaserTarget();
        
        if(!targetZombie)
        	return;
        
        var fileName = "alienLaser.png";
        var spriteSize = 50;
        var sprite = (spriteSize > 0) ? CCSprite.spriteWithFile(fileName, CGRectMake(0, 0, 33, 50)) : CCSprite.spriteWithFile(fileName);
        sprite.setScale(sprite._totoScale._x * fm._widthScale, sprite._totoScale._y * fm._widthScale);
        
//        origin = ccp (fm._boss._fightData._throwOffset._x * fm._widthScale + fm._boss._ccPosition._x,
//        		fm._boss._fightData._throwOffset._y * fm._widthScale + fm._boss._ccPosition._y);
            
        if(!fp._widthScale){
	    	fp._widthScale = this._widthScale;
	        fp._heightScale = this._heightScale;
    	}
        
        fp.throwAnObject(sprite, targetZombie, origin, fp.MovementType.laser,200/*fm._currentBossAction["damage"]*/, 15);
        fm._currentBossAction = null;
    },
    
    getThrowTarget : function()
    {
        var fm = this;
        var targetZombie = null;
        var targetPref = null;
        
        if (fm._zombies && fm._zombies.length > 0)
        {
            for ( var i in fm._zombies)
            {
                var zombie = fm._zombies[i];
                if (zombie._state == kActorFightStateGoing)
                {
                    targetZombie = zombie;
                    targetPref = zombie;
                    break;
                }
                // if there is no preferred target yet it will hit the first zombie in the zombie order that's at range
                // note: do not break after this as we are still looking for a zombie that is kActorFightStateGoing
                if (!targetPref && zombie._state == kActorFightStateUsingAbilityAtRange)
                {
                    targetZombie = zombie;
                    targetPref = zombie;
                }
                if (fm.isZombieAllowedToThrowAt(zombie))
                {
                    targetZombie = zombie;
                }
            }
            
            if (!targetZombie)
            {
                return null;
            }
            else
            {
                targetZombie = (targetPref) ? targetPref : targetZombie;
            }
        }
        
        return targetZombie;
    },
    
    throwProjectile : function(dt)
    {
    	fm = this;
    	if (!fm._currentBossAction){
            return;
        }
    	
    	var actionName = fm._currentBossAction["name"];
    	if (actionName != "throw")
        {
            return;
        }
    	var fileName = fm._currentBossAction["sprite"];
        var spriteSize = fm._currentBossAction["spriteSize"];
        var damage = fm._currentBossAction["damage"];

        var sprite = (spriteSize > 0) ? CCSprite.spriteWithFile(fileName, CGRectMake(0, 0, spriteSize, spriteSize)) : CCSprite.spriteWithFile(fileName);
//        sprite.setScale(new Core.Vector(sprite.getScale()._x * this._widthScale, sprite.getScale()._y * this._widthScale));
        
        sprite.setScale(sprite._totoScale._x * fm._widthScale, sprite._totoScale._y * this._widthScale);
        
        
        if(!fp._widthScale){
	    	fp._widthScale = this._widthScale;
	        fp._heightScale = this._heightScale;
    	}
        
//    	fp.schedule(fp.throwProjectile, dt, "throwProjectile");
        var targetZombie = fm.getThrowTarget();
        var origin = ccp (fm._boss._fightData._throwOffset._x * fm._widthScale + fm._boss._ccPosition._x,
  			  			  fm._boss._fightData._throwOffset._y * fm._widthScale + fm._boss._ccPosition._y);
        
        fp.throwAnObject(sprite, targetZombie, origin,  fp.MovementType.box, damage, null);
        fm._currentBossAction = null;
    },
    
    summonWall : function(dt)
    {
//        var fp = ZFFightPhysics.fightPhysics(this._widthScale, this._heightScale);
    	
    	if(!fp._widthScale){
	    	fp._widthScale = this._widthScale;
	        fp._heightScale = this._heightScale;
    	}
    	
//    	fp.summonWall();
        fp.schedule(fp.summonWall, dt, "summonWall");
    },
    
    isZombieAllowedToThrowAt : function(zombie)
    {
    	var state = zombie._state;
        if (state == kActorFightStateGoing || state == kActorFightStateFight || state == kActorFightStateFighting || state == kActorFightStateFightWall
                || state == kActorFightStateUsingAbilityAtRange || state == kActorFightStateExitMelee)
        {
            return true;
        }
        
        return false;
    },
    
    createTriggerEvent : function(tag, sender)
    {
        var gui = ZFFightGUI;
        var temp = sender;
        
        for ( var key in gui._abilityButtonList)
        {
        	var button = gui._abilityButtonList[key];
        	// index 0 of CCMenu button.button is CCMenuItemSprite                          
            var item = button._button._children[0];
            if (temp == item)
            {
                temp.isEnabled = false;
                temp.setVisible(false);
                button._buttonBorder.setVisible(false);
                
                buttonPressedTimer = 0;
                ZFFightAbilityGUI.cleanAbilityHelperArrow();
                break;
            }
        }
        
        this.triggeredAbility(tag);
    },
    
    isActivatedAbilityOnPendingList : function(ability)
    {
        for ( var key in this._pendingActivatedAbilities)
        {
        	var a = this._pendingActivatedAbilities[key];
        	if (a._tag == ability._tag)
                return true;
        }
        return false;
    },
    
    reorderZombies : function()
    {
//    	return;
        // search for a tank in the 1st column
        var hasTank = false;
        for ( var key in this._zombies)
        {
        	var z = this._zombies[key];
        	if (Math.floor(key / 5) > 0)
                break;
            if ((z instanceof ZombieActorHeadless) && z.isInMeleeRange())
                hasTank = true;
        }
        
        if (!hasTank)
        {
            // search for a tank if no tank in 1st column
            var tank = null;
            for ( var key in this._zombies)
            {
            	var z = this._zombies[key];
            	if ((z instanceof ZombieActorHeadless) && z.isInMeleeRange())
                {
                    tank = z;
                }
            }
            ;
            // if there is a tank
            if (tank)
            {
                this._zombies.splice((this._zombies).indexOf(tank), 1);
                this._zombies.unshift(tank);
            }
        }
        
        // garden zombies always move to the back
        var zombiesToMoveToLastIndex = [];
        for ( var key in this._zombies)
        {
        	var z = this._zombies[key];
        	if ((z instanceof ZombieActorGarden) && z._state != kActorFightStateWait && z._state != kActorFightStatePrepStart && z._state != kActorFightStatePrepCycle && z._state != kActorFightStateDying)
                zombiesToMoveToLastIndex.push(z);
        }
        
        // move all garden zombies to last index
        for (key in zombiesToMoveToLastIndex)
        {
            var z = zombiesToMoveToLastIndex[key];
            z.setZombieToLastIndex();
        }
        
        // adjust their positions
        for ( var key in zombiesToMoveToLastIndex)
        {
        	var z = zombiesToMoveToLastIndex[key];
        	if (z._state == kActorFightStateUsingAbilityAtRange)
            {
                z._destinationPoint = z.calculateDestinationPoint();
                z._destinationPoint = ccpAdd(z._destinationPoint, ccp(-120 * this._widthScale, 0));
                //z.state = kActorFightStateExitMelee;
            }
        }
        for ( var key in this._zombies)
        {
        	var z = this._zombies[key];
        	if (z.isInMeleeRange())
            {
                z.setState(kActorFightStateMoveForwardAfterAttack);
            }
        }
        
        this._newZombieEntersFight = true; // force enemy to recheck for a target //
    },
    
    telekinesis : function(dt)
    {
    	// knockback all zombies
        this.unschedule(this.telekinesis);
        var knockBackCount = 0;
        
        if (this._telekinesis)
        {
            this._telekinesis.getParent().removeChild(this._telekinesis, true);
            this._telekinesis = null;
        }
        
        if (!this._currentBossAction)
        {
            return;
        }
        
        var actionName = this._currentBossAction["name"];
        if (!actionName == "telekinesis")
        {
            return;
        }
        
        var temp = [].concat(this._zombies);
        
        // special splash effect
        // FIXME: particle system
//        var splash = ZFParticleEffects.particleSystemByTag("telekinesisSplash.plist");
//        splash.setPosition(ccpAdd(this._enemyPosition, ccp(-50 * this._heightScale, 0)));
//        splash.setScale(splash.getScale()._x * this._widthScale, splash.getScale()._y * this._widthScale);
//        this.getParent().addChild(splash, 200);
        for ( var key in temp)
        {
        	var z = temp[key];
        	if (z._state == kActorFightStateExitMelee || z._state == kActorFightStateGoing || z.isInMeleeRange())
            {
                if (z._fightData._canInterrupt)
                {
                	var chance = Math.random();
                    var force = 7;
                    
                    if (z instanceof ZombieActorLarge)
                    {
                        chance -= 0.1;
                    }
                    else if (z instanceof ZombieActorSmall)
                    {
                        chance += 0.1;
                    }
                    else if (z instanceof ZombieActorRegular)
                    {
                        chance = 0;
                    }
                    
                    if (chance > 0.7)
                    {
                        z.stunSelfFor(1);
                    }
                    
                    if (z.isInMeleeRange() && (!(z instanceof ZombieActorHeadless)))
                    {
                    	z.knockBackBy(-50 + (-20 * force), 5);
                        knockBackCount++;
                    }
                }
            }
        }
        
        temp.length = 0;
        temp = null;
        this._currentBossAction = null;
        
        if (this._boss && this._boss._state == kActorFightStateBossTelekinesis)
        {
            this._boss.setState(kActorFightStateBossWait);
        }
        
    },
    
    allowedToTelekinesis : function()
    {
        if (this._bossActionCooldownTimer > 0 || this._bossActionCastTimer > 0 || this._telekinesis)
        {
            return false;
        }
        
        for (var key in this._zombies)
        {
        	z = this._zombies[key];
        	if (z.isInMeleeRange() && this._bossActionCooldownTimer <= 0 && this._bossActionCastTimer <= 0 && !this._telekinesis)
            {
                return true;
            }
        }
        
        return false;
    },
    
    allowedToSummonBoss : function()
    {
        if (this._bossWall || !this._bossSummonList || this._bossSummonList.length == 0 || this._bossActionCooldownTimer > 0 || this._bossActionCastTimer > 0)
        {
            return false;
        }
        
        return true;
    },
    
    /*
    spawnCrabIn : function(dt)
    {
        this.unschedule(this.spawnCrabIn);
        this.spawnStageActor("BeachStageActorCrab");
    },*/
    
    spawnStageActorWithDictionary : function(stageActorDictionary)
    {
        if (!this.isGameWon() && !this.isGameLost())
        {
            var acm = ZFActorManager;
            var dude = acm.spawnStageActorWithDictionary_fromObject(stageActorDictionary, this.getParent());
            this._stageActors.push(dude);
            dude._spriteMan.setScale(this._widthScale, this._widthScale);
            
            dude.scheduleUpdate();
        }
    },
    
    spawnStageActor : function(className)
    {
        var dude = ZFActorManager.spawnFightActor(className, ccp(ZFGameDefines.ENEMY_POSITION_X, -250), this.getParent(), 3);
        dude._spriteMan.setScale(dude._spriteMan.getScale()._x * this._widthScale, dude._spriteMan.getScale()._y * this._widthScale);
        dude._walkingSpeed *= this._widthScale;
        this._stageActors.push(dude);
    },
    
    spawnEnemyIn : function(dt)
    {
        this.unschedule(this.spawnEnemyIn);
        
        if (!this._enemy)
        {
            this._enemy = this.spawnEnemy();
            ZFFightGUI._currentEnemyMaxHp = this._enemy._fightData._hitPoints;
        }
        else
        {
            // find an emptySlot else quit
            var availableSlot = -1;
            for ( var i = 0; i < 5; i++)
            {
                if (!this._enemySlots[i])
                {
                    availableSlot = i;
                    break;
                }
            }
            if (availableSlot >= 0)
            {
                var newEnemy = this.spawnEnemy();
                this._enemySlots[availableSlot] = newEnemy;
            }
        }
        //int rc = [enemy retainCount];
        //  rc=0;
    },
    
    enableButtonAfterAnim : function(dt)
    {
    	this.unschedule(this.enableButtonAfterAnim);
        
        var button = null;
        for ( var key in this._newAbility._children )
        {
            button = this._newAbility._children[key];
            if(button instanceof CCMenuItemSprite)
            	break;
        }
        button.isEnabled = true;
    },
    
    tapIconToDisappearVisible : function(dt)
    {
        this.unschedule(this.tapIconToDisappearVisible);
        this._newAbilityTapIconToContinue.runAction(CCRepeatForever.actionWithAction(CCSequence.actions(CCFadeTo.actionWithDuration(0.5, 255), CCFadeTo.actionWithDuration(0.5, 0x50))));
    },
    
    cleanupNewAbilityMenu : function(dt)
    {
        this.unschedule(this.cleanupNewAbilityMenu);
        this.unschedule(this.tapIconToDisappearVisible);
        
        //this.getParent().removeChild(this._newAbility, true);
        //this.getParent().removeChild(this._newAbilityBG, true);
//        this._newAbility.removeAllChildrenWithCleanup(true);
        destroyWithChildren(this._newAbility);
//        this._newAbilityBG.removeAllChildrenWithCleanup(true);
        destroyWithChildren(this._newAbilityBG);
        this._newAbility = null;
        this.newAbilityBG = null;
        
        this.getParent().removeChild(this._newAbilityColorLayer, true);
        destroyWithChildren(this._newAbilityColorLayer);
        this._newAbilityColorLayer = null;
        
        this.getParent().removeChild(this._newAbilityDescription, true);
        destroyWithChildren(this._newAbilityDescription);
        this._newAbilityDescription = null;
        
        this.getParent().removeChild(this._newAbilityTapIconToContinue, true);
        destroyWithChildren(this._newAbilityTapIconToContinue);
        this._newAbilityTapIconToContinue = null;
        
        var shine1 = this.getParent().getChildByTag(this.fightManTags.kFightManTagShine1);
        this.getParent().removeChildByTag(this.fightManTags.kFightManTagShine1, true);
        destroyWithChildren(shine1);
        
        var shine2 = this.getParent().getChildByTag(this.fightManTags.kFightManTagShine2);
        this.getParent().removeChildByTag(this.fightManTags.kFightManTagShine2, true);
        destroyWithChildren(shine2);
    },
    
    // show a little summary of the ability then schedule fight summary
    newAbilityIconClicked : function(tag, sender)
    {
    	if(this._abiliyTouched) return;
    	this._abiliyTouched = true;
        var gs = GameState;
        var itemSprite = sender;
        
        itemSprite.isEnabled = false;
        itemSprite.runAction(CCSequence.actions([CCScaleTo.actionWithDuration(0.05, itemSprite.getScale()._x * 1.2), CCScaleTo.actionWithDuration(0.1, itemSprite.getScale()._x), CCFadeTo.actionWithDuration(1.0, 0), null]));
        
        for ( var key in this._newAbilityBG._children )
        {
        	var object = this._newAbilityBG._children[key];
        	if (object instanceof CCSprite || object instanceof CCMenu)
            {
        		if(object instanceof CCMenu)
        			object = object._menuItems[0]._normalImage;
                object.runAction(CCSequence.actions([CCDelayTime.actionWithDuration(0.15), CCFadeTo.actionWithDuration(1.0, 0), null]));
            }
        }
        
        var shine1 = this._parent.getChildByTag(this.fightManTags.kFightManTagShine1);
        var shine2 = this._parent.getChildByTag(this.fightManTags.kFightManTagShine2);
        if (shine1)
        {
            shine1.runAction(CCSequence.actions([CCDelayTime.actionWithDuration(0.15), CCFadeTo.actionWithDuration(1, 0), null]));
        }
        
        if (shine2)
        {
            shine2.runAction(CCSequence.actions([CCDelayTime.actionWithDuration(0.15), CCFadeTo.actionWithDuration(1, 0), null]));
        }
        this.schedule(this.cleanupNewAbilityMenu, 1.2);
        var flagBit = tag; //itemSprite._tag;
        
        // make a tooltip or something 
        
        gs._zfGameData._abilityFlags.setFlag(flagBit);
        
        var tempTime = 1.0;
        this.schedule(this.showFightSummaryIn, tempTime);
        
        ZFAchievementChecker.checkAllZombieAbilities();
    },
    
    showFightSummaryIn : function(dt)
    {
        var gs = GameState;
        var gui = ZFGuiLayer.gui();
        this.unschedule(this.showFightSummaryIn);
        
        ZFActorManager.makeAllZombiesFull();
        //This was moved to ZFFightGameScene.endFight GameState.saveGame();
        
        /* FIXME: event tracker
        var eventDictionary = {
            enemy : this._enemyName,
            zombiesLost : this._zombieCasualty,
            time : this._fightTimer
        };
        
        if (this._doOrDie)
        {
            var eventDictionary1 = {
                enemy : enemyName
            };
            
            EventTracker.eventTracker().sendEvent("zf_invade_timeexpired", eventDictionary1, null);
        }
        */
        // no cleanup has been done at this point so safe to check for game Win
        if (this.isGameWon())
        {
            switch (gs._zfGameData._currentEnemy)
            {
                case 0:
                    gs._zfGameData._farmerFightsWon++;
                    break;
                case 1:
                    gs._zfGameData._lawyerFightsWon++;
                    break;
                case 2:
                    gs._zfGameData._pirateFightsWon++;
                    break;
                case 3:
                    gs._zfGameData._ninjaFightsWon++;
                    break;
                case 4:
                    gs._zfGameData._robotFightsWon++;
                    break;
                case 5:
                    gs._zfGameData._alienFightsWon++;
                    break;
                case 6:
                    gs._zfGameData._seasonalFightsWon++;
                    break;
            }
            
            var totalFightsWon = 
            	gs._zfGameData._ninjaFightsWon + 
            	gs._zfGameData._pirateFightsWon +
            	gs._zfGameData._lawyerFightsWon +
            	gs._zfGameData._farmerFightsWon +
            	gs._zfGameData._robotFightsWon +
            	gs._zfGameData._alienFightsWon +
            	gs._zfGameData._seasonalFightsWon;
            
            var prevUnlockCheck = false;
            var postUnlockCheck = false;
            
            //no achievements during tutorial
            if (totalFightsWon > 1)
            {
                prevUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievementWinEnraged);
                //FIXME:ZFAchievementChecker.checkWinEnraged();
                postUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievementWinEnraged);
                
                if (prevUnlockCheck != postUnlockCheck)
                {
                    /* Unlock Achievement through Facebook */
                    gui.publishAchievement("com.zombiefarm.fight.win_enraged", "com.zombiefarm.fight.win_enraged.description", "com.zombiefarm.fight.win_enraged.image");
                    /////////////////////////////////////////
                }
                
                prevUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievement2orLessDeaths);
                //FIXME:ZFAchievementChecker.checkWinOrLessDeaths();
                postUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievement2orLessDeaths);
                
                if (prevUnlockCheck != postUnlockCheck)
                {
                    /* Unlock Achievement through Facebook */
                    gui.publishAchievement("com.zombiefarm.fight.2_or_less_deaths", "com.zombiefarm.fight.2_or_less_deaths.description", "com.zombiefarm.fight.2_or_less_deaths.image");
                    /////////////////////////////////////////
                }
                
                prevUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievement1MinuteWin);
                //FIXME:ZFAchievementChecker.checkWin1Minute();
                postUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievement1MinuteWin);
                
                if (prevUnlockCheck != postUnlockCheck)
                {
                    /* Unlock Achievement through Facebook */
                    gui.publishAchievement("com.zombiefarm.fight.1_minute_win", "com.zombiefarm.fight.1_minute_win.description", "com.zombiefarm.fight.1_minute_win.image");
                    /////////////////////////////////////////
                }
                
                prevUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievement1ZombieLeft);
                //FIXME:ZFAchievementChecker.checkWin1Survivor();
                postUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievement1ZombieLeft);
                
                if (prevUnlockCheck != postUnlockCheck)
                {
                    /* Unlock Achievement through Facebook */
                    gui.publishAchievement("com.zombiefarm.fight.1_zombie_left", "com.zombiefarm.fight.1_zombie_left.description", "com.zombiefarm.fight.1_zombie_left.image");
                    /////////////////////////////////////////
                }
                
                prevUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievementNoDeaths);
                //FIXME:ZFAchievementChecker.checkWinNoZombiesLost();
                postUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievementNoDeaths);
                
                if (postUnlockCheck)
                {
                    //post quest notification
                    // FIXME: notifications
                    NSNotificationCenter.defaultCenter().postNotificationName(ZFGameDefines.kInvasionPerfectGameNotification, null, enemyName);
                    if (prevUnlockCheck != postUnlockCheck)
                    {
                        /* Unlock Achievement through Facebook */
                        gui.publishAchievement("com.zombiefarm.fight.no_deaths", "com.zombiefarm.fight.no_deaths.description", "com.zombiefarm.fight.no_deaths.image");
                        /////////////////////////////////////////
                    }
                }
                
                prevUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievementAllZombieTypes);
                //FIXME:ZFAchievementChecker.checkWinAllTypes();
                postUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievementAllZombieTypes);
                
                if (prevUnlockCheck != postUnlockCheck)
                {
                    /* Unlock Achievement through Facebook */
                    gui.publishAchievement("com.zombiefarm.fight.all_zombie_types", "com.zombiefarm.fight.all_zombie_types.description", "com.zombiefarm.fight.all_zombie_types.image");
                    /////////////////////////////////////////
                }
                
                prevUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievement10Wins);
                //FIXME:ZFAchievementChecker.checkFightsWon10();
                postUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievement10Wins);
                
                if (prevUnlockCheck != postUnlockCheck)
                {
                    /* Unlock Achievement through Facebook */
                    gui.publishAchievement("com.zombiefarm.fight.10_wins", "com.zombiefarm.fight.10_wins.description", "com.zombiefarm.fight.10_wins.image");
                    /////////////////////////////////////////
                }
                
                prevUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievement25Wins);
                //FIXME:ZFAchievementChecker.checkFightsWon25();
                postUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievement25Wins);
                
                if (prevUnlockCheck != postUnlockCheck)
                {
                    /* Unlock Achievement through Facebook */
                    gui.publishAchievement("com.zombiefarm.fight.25_wins", "com.zombiefarm.fight.25_wins.description", "com.zombiefarm.fight.25_wins.image");
                    /////////////////////////////////////////
                }
                
                prevUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievement50Wins);
                //FIXME:ZFAchievementChecker.checkFightsWon50();
                postUnlockCheck = gs._zfGameData._achievementFlags.hasFlag(kAchievement50Wins);
                
                if (prevUnlockCheck != postUnlockCheck)
                {
                    /* Unlock Achievement through Facebook */
                    gui.publishAchievement("com.zombiefarm.fight.50_wins", "com.zombiefarm.fight.50_wins.description", "com.zombiefarm.fight.50_wins.image");
                    /////////////////////////////////////////
                }
            }
            
            //EventTracker.eventTracker().sendEvent("zf_invade_win", eventDictionary, null);
        }
        else
        {
            gs._zfGameData._fightLossCount++;
            //lost
            ZFAchievementChecker.checkLosses10();
            
//            if (gs._zfGameData._fightLossCount == 10)
//            {
//                // Unlock Achievement through Facebook
//                gui.publishAchievement("com.zombiefarm.fight.10_losses", "com.zombiefarm.fight.10_losses.description", "com.zombiefarm.fight.10_losses.image");
//                /////////////////////////////////////////
//            }
//            
//            EventTracker.eventTracker().sendEvent("zf_invade_lose", eventDictionary, null);*/
        }
        
        var sprite1 = this._parent.getChildByTag(65);
        if (sprite1)   //stop blizzard effect if available
        {
            destroy(sprite1);
            sprite1 = null;
        }
        
        var sprite2 = this._parent.getChildByTag(66);
        if (sprite2)   //stop blizzard effect if available
        {
            destroy(sprite2);
            sprite2 = null;
        }

        //Code to skip summary (working with leaks)
//      NSNotificationCenter.defaultCenter().postNotificationName(ZFGameDefines.kFightSummaryDone, null);
//      return;  
        var zfs = new ZFFightSummary();
        this.getParent().addChild(zfs, 501, 150);
        zfs.openMenu();
    },
    
    summonBoss : function(dt)
    {
        this.unschedule(this.summonBoss);
        
        if (!this._currentBossAction)
        {
            return;
        }
        
        var actionName = this._currentBossAction["name"];
        if (!actionName == "summonBoss")
        {
            return;
        }
        
//        var fp = ZFFightPhysics.fightPhysics();
//        
//        var w = CCDirector.winSize();
        var p = ccp(450, this._enemyPosition._y);
        
        var summon = ZFActorManager.spawnFightActor(this._bossSummonList[0], p, this.getParent(), 3);
        summon._spriteMan.setScale(summon._spriteMan.getScale()._x * this._widthScale, summon._spriteMan.getScale()._y * this._widthScale);
        this._bossSummonList.splice(0, 1);
        
        // add random enemy once list is exhausted //
        
        var randomEnemy = Math.floor(Math.random() * 5);
        switch (randomEnemy)
        {
            case 0:
                this._bossSummonList.push("FarmStageActorFarmhand");
                break;
            case 1:
                this._bossSummonList.push("FarmStageActorLumberjack");
                break;
            case 2:
                this._bossSummonList.push("CityStageActorCrazedWorker");
                break;
            case 3:
                this._bossSummonList.push("PirateStageActorSwashbuckler");
                break;
            case 4:
                this._bossSummonList.push("NinjaStageActorGirl");
                break;
            default:
                break;// nothing
        }
        
        /////////////////////////////////////////////
        summon._subType = CivilianActorFight.civilianSubTypes.civilianSubTypeFodder;
        summon._anchorPoint = ccp(1.0, 0.0);
        
        this._bossWall = summon;
        
        // nerfing the summon's hp
        //self.bossWall.fightData.finalHitPointsTotal = self.bossWall.fightData.finalHitPointsTotal/2;
        //self.bossWall.fightData.hitPoints = 500;
        
        summon._state = kActorFightStateBeingSummoned;
        summon.runAction(CCSequence.actions([CCDelayTime.actionWithDuration(1), CCCallFuncND.actionWithTarget(summon, summon.callSetState.bind(summon),kActorFightStateWall), null]));
        
        ////////////////////// summon effect
        var rezEffect = CCColorLayer.layerWithColor(ccc4(255, 255, 255, 255), 100, 1500);
        
        rezEffect.setScale(0, rezEffect.getScale()._y);
        rezEffect.setPosition ( ccp(summon.getPosition()._x, rezEffect.getPosition()._y) );
        
        this.getParent().addChild(rezEffect, summon._spriteMan._zOrder - 1);
        
        rezEffect.runAction(
                CCSpawn.actions([
                        CCSequence.actions([
                                 CCScaleTo.actionWithDuration(0.2, 1.0, 1.0),
                                 CCScaleTo.actionWithDuration(1.3, 0.0, 1.0), null]),
                        CCSequence.actions([
                                CCDelayTime.actionWithDuration(0.2),
                                CCFadeTo.actionWithDuration(1.3, 0),
                                // FIXME: CCCallfuncND missing
//                                CCCallFuncND.actionWithTarget(rezEffect),
                                null]),
                        null]));
        
        SimpleAudioEngine.playEffect(kRezSFX);
        
        //////////////////////
        
        // check for applicable buffs
        for (var key in this._fightEffectList)
        {
        	this._fightEffectList[key].applyEffectToActor(summon);
        }
        
        ////////////////////// add mind control effect
        /* FIXME: particle engine
        var effect = new ActorParticle();
        effect.particle = CCQuadParticleSystem.particleWithFile("mindControl.plist");
        effect.attachmentID = kActorPartTagHead;
        effect.offset = ccp(-5, 35);
        
        summon._particles.push(effect);
        effect._particle._positionType = kCCPositionTypeGrouped;
        */
        ///////////////////////
        
        // have zombies run to this guy if possible
        var eligibleZombieAttackers = [];
        
        // starting from column 1
        for ( var key in this._zombies)
        {
        	var z = this._zombies[key];
        	if (z.getPosition()._x > summon.getPosition()._x)
                eligibleZombieAttackers.push(z);
        }
        
        // count how many columns
        var eligibleZombieCount = eligibleZombieAttackers.length;
        var columns = 0;
        if (eligibleZombieCount > 0)
            columns = Math.floor((eligibleZombieCount / 5))+1;
        
        // based on how many columns there are set a number of zombies to attack
        var zombiesToAttack = 0;
        if (columns == 1)
        {
            zombiesToAttack = eligibleZombieCount / 2;
        }
        else if (columns > 1)
        {
            zombiesToAttack = 5;
        }
        
        // send the zombies out
        var zChange = 0;
        for (var key in eligibleZombieAttackers)
        {
        	var z = eligibleZombieAttackers[key];
        	z.setState(kActorFightStateGoFightBossWall);
            zombiesToAttack--;
            if (z._spriteMan._zOrder > zChange)
                zChange = z._spriteMan._zOrder;
            
            if (zombiesToAttack == 0)
                break;
        }
        
        if (zChange)
        {
            summon._spriteMan.getParent().reorderChild(summon._spriteMan, zChange);
        }
    },
    
    cleanupNode : function(sender, data)
    {
        if (data && data.getParent())
        {
            data.getParent().removeChild(data, true);
        }
    },
    
    cleanSummary : function()
    {
    	var zfs = this._parent.getChildByTag(150);
    	if(zfs)
    	{
    		this._parent.removeChild(zfs, true);
    		zfs.cleanupLocal();
    		destroyWithChildren(zfs);
    		zfs = null;
    	}
    }
    
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/CivilianActorFight'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/CivilianActorFight'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/CivilianActorFight'] = exports; var ZFActorFightEffect = require('Code/Game/FightGameScene/ZFActorFightEffect').ZFActorFightEffect;
var fm = null;
var gs = null;
var halfAtackSpeed = 0.2;
exports.CivilianActorFight = Actor.subclass
({
	classname : 'CivilianActorFight',
	
	$civilianSubTypes : 
	{
		civilianSubTypeBoss : 1,
		civilianSubTypeFodder : 0
	},
	
	initialize : function()
	{
		fm = ZFFightMan;
		gs = GameState;
		this._bossUpdateObject = {};
		this._civilianUpdateObject = {};
	},
	
	initActorSpecificData : function()
	{
		this._spriteFileName = "BasicZombie128.png";
		this._type  = kActorTypeCivilian;
		this._state = kActorFightStateWait;
	},
	
	initActorSpecificDataAfterLoad : function($super)
	{
		$super();
		
		var dict = ZFActorManager._unitStats;
		var unitKey = this.classname;
		this._unitDictionary = dict[ unitKey ];
		this._walkingSpeed = 1.0;
		this._animSpeed = 1.0 / this._walkingSpeed;
	},
	
	initFightDataAfterLoad: function($super)
	{
		$super();
		var statDict = new Array();
		statDict["str"] = this._unitDictionary["str"];
		statDict["con"] = this._unitDictionary["con"];
		statDict["dex"] = this._unitDictionary["dex"];
		statDict["dr"] = 0;
		
		var dex = statDict[ "dex" ]; //float
		var str = statDict[ "str" ]; //float
		var con = statDict[ "con" ]; //float
		var dr = statDict[ "dr" ]; //float
		
		var powerBonus		= 0; //float
		var attackSpeedBonus  = 0; //float
		var hitPointsBonus	= 0; //float
		var damageReduction	= 0; //float
		
		
		for ( var i = 0 ; i < this._abilityList.length ; i++ )
		{
			var buff = this._abilityList[i];
			if ( buff instanceof ZFActorFightEffect )
			{
				if (buff._appliesToGroup && buff._timerActivateIn == -1)
				{
					powerBonus		 += buff._powerChange;
					attackSpeedBonus += buff._attackSpeedChange;
					hitPointsBonus	 += buff._hitPointsTotalChange;
					damageReduction  += buff._damageReduction;
					buff._active = true;
				}
			}
			
			str = str * (1 + powerBonus);			    // 0.1 increase in power = 10% increase in str
			con = con * (1 + hitPointsBonus);			// 0.1 increase in hp	 = 10% increase in con
			dex = dex * (1 + (attackSpeedBonus * 2.0)); // 0.1 increase in speed = 20% increase in dex
			dr  = dr + damageReduction;		
		}
		
		statDict["str"] = str;
		statDict["con"] = con;
		statDict["dex"] = dex;
		statDict["dr"] = dr;
		
		this._fightData._hitPointsTotal = this._fightData._hitPoints = ZFGameDefines.HITPOINTS_MULTIPLIER * con;
		this._fightData._power = ZFGameDefines.POWER_MULTIPLIER * str;
		this._fightData._attackSpeed = 2.0 / dex; //dex is # of attacks in 2 seconds
		
		this._fightData._finalHitPointsTotal = this.calculateFinalHitPointsTotal();
		this._fightData._finalAttackSpeed = this.calculateFinalAttackSpeed();
		this._fightData._finalPower = this.calculateFinalPower();
		this._fightData._finalDamageReduction = dr;	
		
		this._fightData._throwTiming = this._unitDictionary["throwTiming"];
		
		this._fightData._throwOffset = (this._unitDictionary["throwOffset"])?CGPointFromString(this._unitDictionary["throwOffset"]):ccp(-20,40);
		
		if(this._unitDictionary["throwParticles"])
		{
			this._fightData._throwParticles = this._unitDictionary["throwParticles"];
		}
		
		this._state = kActorFightStateWait;
		this.scheduleUpdate();
		
		this.initBossUpdateObject();
		this.initCivilianUpdateObject();
	},
	
	update: function($super, dt)
	{
		if (this._state != kActorFightStateDead && this._state != kActorFightStateDying	&& this._fightData._hitPoints <= 0.0 )
		{
			this._state = kActorFightStateDying;
		}
		var shouldContinue = true;
		
		//boss has sparate logic
		
		if (this._subType == this.civilianSubTypes.civilianSubTypeBoss)
		{
			shouldContinue = this.bossUpdate(dt);
		}
		else
		{
			shouldContinue = this.civilianUpdate();
		}
		
		if ( shouldContinue == false)
		{
			return;
		}
		
		$super(dt);
	},
	
	bossUpdate : function(dt)
	{
		var func = this._bossUpdateObject[this._state];
		if(func)
		{
			func();
		}else{
			return this.civilianUpdate();
		}
			
		return true;		
	},
	
	civilianUpdate :  function()
	{
		var state = this._state;
		var func = this._civilianUpdateObject[state];
		if(func)
		{
			func();
			if(state == kActorFightStateDead) {
				return false;
			}
		}
			
		return true;
	},
	
	animForState : function(value)
	{
		return 0;
	},
	
	startAnimForState : function(value)
	{
		switch(value)
		{
			case kActorStateDormant:
			case kActorFightStateBeingSummoned:
			case kActorFightStateWall:
			case kActorStateIdle:
			case kActorFightStateWait:
			case kActorFightStateBossWait:
			case kActorFightStateFight:
			case kActorFightStateStunned:
			{
				this.startAnim(kActorAnimIdle, true);
			}
				break;
				
			case kActorStateWalking:
			case kActorFightStateGoing:
			case kActorFightStateBossGoingDown:
			{			
				this.startAnim(kActorAnimWalk, true);
			}
				break;
				
			case kActorFightStateBossThrow:
			{
				this.startAnim(kActorAnimThrow ,false);
			}
				break;
			case kActorFightStateBossTelekinesis:
			case kActorFightStateBossSummonWall:
				this.startAnim(kActorAnimSummon, true);
				break;
		}
	},
	
	doneAttackingHalf : function(dt){
		this.unschedule(this.doneAttackingHalf);
		this._firstAtackDone = true;

		if (!this._stoppedActions){
			for (var key in this._attachments)
			{
			    var a = this._attachments[key];
				if (!a)
					continue;
				a._sprite.stopAllActions();
				a.stopAllActions();
			}
			this._stoppedActions = true;
		}
		dt = dt/halfAtackSpeed - dt;
		this.schedule(this.doneAttacking,dt, "doneAttacking");
	},
	
	justAttack : function(animID){
		var asc = this.getFightAttackSpeed();
		if(animID == kActorAnimAttack)
		{
			this._fightData._attacking = true;
			if ( !this.isScheduled(this.doneAttacking))
			{
				this.schedule(this.doneAttacking, asc, "doneAttacking");
			}
		}
		
		if (animID == kActorAnimThrow)
		{
			SimpleAudioEngine.playEffect(kThrowSFX);
		}
		
		if (!this._stoppedActions){
			for (var key in this._attachments)
			{
			    var a = this._attachments[key];
				if (!a)
					continue;
				a._sprite.stopAllActions();
				a.stopAllActions();
			}
			this._stoppedActions = true;
		}
	},
	
	startAnim : function(animID, interrupt) 
	{	
//		if(this instanceof RobotStageActor ){
//			return;
//		}
		if(animID != kActorAnimVictory){
			if(this._subType == this.civilianSubTypes.civilianSubTypeBoss && fm._enemyPopulation != 0){		
				if(fm._startGame){	
					this.justAttack(animID);		
					return;
				}
			}
			else{
				if(this._firstAtackDone){
					this.justAttack(animID);
					return;
				}
			}	
		}
		
		if(!this._attachments || this._attachments.length <= 0)
		{
			return;
		}
		
		var arm1 = this._attachments[kActorPartTagArmF];
		var arm2 = this._attachments[kActorPartTagArmB];
		var foot1 = this._attachments[kActorPartTagFootF];
		var foot2 = this._attachments[kActorPartTagFootB];
		var body = this._attachments[kActorPartTagBody];
		var head = this._attachments[kActorPartTagHead];
		
		var asc = this.getFightAttackSpeed();
		var s = this._animSpeed;
		var f = (head._sprite.flipX() ) ? -1 : 1;
		
		if (interrupt)
		{
			for (var key in this._attachments)
			{
			    var a = this._attachments[key];
				if (!a)
					continue;
				a._sprite.stopAllActions();
				a.stopAllActions();
			}
		}
		
		if (animID != kActorAnimVictory)
		{
			this.resetColor();
			this.resetAttachmentScaleInterpolate(true);
			this.resetAttachmentPositionsInterpolate(true);
			this.resetAttachmentRotationInterpolate(true);
		}
		
		switch(animID)
		{
			case kActorAnimIdle:
			{
				if (this instanceof CityStageActorCrazedWorker)
				{
					arm1.onceS(ZFAnims.armIdleRotateNoScale(s,f));
					arm2.onceS(CCRotateTo.actionWithDuration(s, 0));
					
					head.loopS(ZFAnims.headBreatheRotate(2,f));
					body.loopS(ZFAnims.bodyBreatheScale(2,body._totoScale._x));
				}
				else if (this instanceof PirateStageActorBoss || this instanceof PirateStageActorSwashbuckler )
				{
					arm1.loopS(ZFAnims.armPirateIdleFront(asc, arm1._totoScale, f));
					arm2.loopS(ZFAnims.armPirateIdleBack(asc, arm2._totoScale, f));
				}
				else if (this instanceof PirateStageActorScallywag )
				{
					
				}
				else if (this instanceof NinjaStageActor )
				{
					// hoppity hop
					
					// move arms up and down
					arm1.loop(ZFAnims.armHopMove(1/2.5));
					arm2.loop(ZFAnims.armHopMove(1/2.5));
					// rotate arms outwards
					
					arm1.loopS(ZFAnims.armHopMoveRotateF(1/2.5, f));
					arm2.loopS(ZFAnims.armHopMoveRotateB(1/2.5, f));
					// move body up and down
					body.loop(ZFAnims.bodyHopMove(1/2.5));
					// move head up and down
					head.loop(ZFAnims.headHopMove(1/2.5));
					// move feet a little right then up and down
					foot1.loop(ZFAnims.footHopMove(1/2.5));
					foot2.loop(ZFAnims.footHopMove(1/2.5));
					// rotate feet o look like tip toeing then normal
					foot1.loopS(ZFAnims.footHop(1/2.5, f));
					foot2.loopS(ZFAnims.footHop(1/2.5, f));
				}
				else if (this instanceof FarmStageActor || this instanceof CityStageActorLawyer
					|| this instanceof CityStageActorBoss )
				{
					// breathe in breathe out
					if ( !(this instanceof FarmStageActorLumberjack ))
					{
						arm1.once(ZFAnims.armIdleRotateNoScale(s/10,f));
					}
					arm2.onceS(ZFAnims.armIdleRotateNoScale(s/10,f));
					head.loopS(ZFAnims.headBreatheRotate(2,f));
					body.loopS(ZFAnims.bodyBreatheScale(2,body._totoScale._x));
				}
				else if(this instanceof RobotStageActor )
				{
					// nothing ! so i can actually place the sprites
					
					if ( this instanceof RobotStageActorJunkBot)
					{
						arm2.onceS(CCRotateTo.actionWithDuration(s, f*80));
					}
					if (this instanceof RobotStageActorBrainBot)
					{
						arm2.onceS(CCRotateTo.actionWithDuration(s, f*20));
					}
					
					if ( this instanceof RobotStageActorBroBot)
					{
						arm2.onceS(CCRotateTo.actionWithDuration(s,f*20));
					}
				}
				else
				{
					arm1.onceS(ZFAnims.armIdleRotateNoScale(s/10,f));
					arm2.onceS(ZFAnims.armIdleRotateNoScale(s/10,f));
				}
				
			}
			break;
				
			case kActorAnimWalk:
			{			
				if( this instanceof PirateStageActorScallywag || this instanceof NinjaStageActor)
				{
				}
				else
				{
					arm1.onceS(ZFAnims.armIdleRotateNoScale(s/10, f));
					arm2.onceS(ZFAnims.armIdleRotateNoScale(s/10, f));
				}
				if(this instanceof RobotStageActor )
				{
					// robot walk anim
					
					// lean themselves forward ?
				}
				else 
				{
					foot1.loop(ZFAnims.footWalkFrontMove(s));
					foot2.loop(ZFAnims.footWalkBackMove(s));
					foot1.loopS(ZFAnims.footWalkFrontRotate(s,f));
					body.loop(ZFAnims.bodyWalkMove(s));
					head.loop(ZFAnims.headWalkMove(s, ccp(0,0)));
				}
			}
			break;
				
			case kActorAnimAttack:
			{
				// all attacks pulled from attack anim class
				this._fightData._attacking = true;
				if ( !this.isScheduled(this.doneAttacking) && !this.isScheduled(this.doneAttackingHalf))
				{
					this.schedule(this.doneAttackingHalf, asc*halfAtackSpeed, "doneAttacking");
//					this.schedule(this.doneAttacking, asc, "doneAttacking");
				}
				var attackAnimID = this._fightData._currentAttackVariation["animID"];
				ZFAttackAnims.performAttackWithID(attackAnimID, this);
			}
			break;
				
			case kActorAnimThrow:
			{
				var throwSpeedFromSheet = fm._enemyDictionary["throwSpeed"];
				var throwSpeed = throwSpeedFromSheet ? throwSpeedFromSheet : 1.0;
				throwSpeed = throwSpeed * 2.0 / 3.0;
				throwSpeed = (throwSpeed > 1) ? 1 : throwSpeed;
				arm1._sprite._rotation = -90.0;
				
				if ( this instanceof NinjaStageActorBoss);
				else
				{
					arm2.onceS(ZFAnims.armIdleRotateNoScale(s/20,f));
				}
				arm1.onceS(ZFAnims.armThrow(throwSpeed,f));
				
				SimpleAudioEngine.playEffect(kThrowSFX);
			}
			break;
				
			case kActorAnimSummon:
			{
				arm1.loopS(ZFAnims.armHackFront(fm._bossActionCastTimer/60, arm1._totoScale, f));
				arm2.loopS(ZFAnims.armHackFront(fm._bossActionCastTimer/60, arm1._totoScale, f));
			}
			break;
		}
	},
	
	initSpriteDictionary : function($super)
	{
		$super();
		//arms
		this.addSpriteDictionaryEntry("defaultArmF", CGRectMake(90.0, 0.0, 31.0, 18.0) , ccp(.87, .72) , ccp(-1.0 + 10, 28.0), 5);
		this.addSpriteDictionaryEntry("defaultArmB", CGRectMake(90.0, 18.0, 31.0, 18.0) , ccp(0.8, 0.76) , ccp(-13.0 + 10, 25.0), 0);
		//head
		this.addSpriteDictionaryEntry("defaultHead", CGRectMake(0.0, 0.0, 49.0, 58.0) , ccp(0.73, 0.25) , ccp(-4.0 + 10, 39.0), 4);
		//body
		this.addSpriteDictionaryEntry("defaultBody", CGRectMake(49.0, 0.0, 41.0, 35.0) , ccp(0.63, .34) , ccp(0 + 10, 13.0), 3);
		//feet
		this.addSpriteDictionaryEntry("defaultFootF", CGRectMake(49.0, 36.0, 17.0, 10.0) , ccp(.75, 0.9) , ccp(6.0 + 10, 8.0), 2);
		this.addSpriteDictionaryEntry("defaultFootB", CGRectMake(49.0, 36.0, 17.0, 10.0) , ccp(.75, 0.9) , ccp(-11.0 + 10, 8.0), 1);
	},
	
	initSprite : function($super)
	{
		$super();
		
		this.addAttachment_withSpriteDetails(kActorPartTagArmF, this._spriteDictionary["defaultArmF"]);
		this.addAttachment_withSpriteDetails(kActorPartTagArmB, this._spriteDictionary["defaultArmB"]);
		this.addAttachment_withSpriteDetails(kActorPartTagHead, this._spriteDictionary["defaultHead"]);
		this.addAttachment_withSpriteDetails(kActorPartTagBody, this._spriteDictionary["defaultBody"]);
		this.addAttachment_withSpriteDetails(kActorPartTagFootF, this._spriteDictionary["defaultFootF"]);
		this.addAttachment_withSpriteDetails(kActorPartTagFootB, this._spriteDictionary["defaultFootB"]);
	},
	
	isInMeleeRange : function()
	{
		var answer = false;
		if(CGPointEqualToPoint(this._ccPosition, fm._enemyPosition))
		   answer = true;
		   
		return answer;
	},
	
	initBossUpdateObject : function()
	{
		this._bossUpdateObject[kActorFightStateBossWait] = function(){
			if (fm.isGameLost())
			{
				this.startAnim(kActorAnimVictory, true);
				this.unscheduleUpdate();
				return;
			}
			
//			if (!fm.isScheduled(this.update))
//			{
//				return;
//			}
			
			var bossActions = this._unitDictionary["bossActions"];
			var currentAction = gs.rollAgainstFrequencyInArray(bossActions);
			
//			if (!currentAction)
//			{
//				return;
//			}
			var actionName = currentAction["name"];
			if ( actionName == "alienLaser" && fm.allowedToShootBullet() )
			{
				fm._currentBossAction = currentAction;
				fm._bossActionCooldownTimer = 60 * currentAction["cooldownTime"];
				this.setState(kActorFightStateShootBullet);
			}
			
			else if (actionName == "throw" && fm.allowedToThrowProjectile() )
			{
				
				fm._currentBossAction = currentAction;
				var throwSpeed = fm._enemyDictionary["throwSpeed"];
				
				if (gs._zfGameData._currentEnemy == 0)
				{
					if (gs._zfGameData._level >= ZFGameDefines.TIER2LVL)
					{
						fm._enemyDictionary["throwSpeed"] = 0.5;
					}
					else if (gs._zfGameData._level >= ZFGameDefines.TIER1LVL) 
					{
						fm._enemyDictionary["throwSpeed"] = 0.75;
					}
					
					throwSpeed = fm._enemyDictionary["throwSpeed"];
				}
				if( this instanceof RobotStageActorBroBot )
				{
					fm._enemyDictionary["throwSpeed"] = 0.75;
					throwSpeed = fm._enemyDictionary["throwSpeed"];
				}
				
				for ( var i in this._abilityList )
				{
					var a = this._abilityList[i];
					if ( a._tag == kFightEffectEnemyBuffEnrage && a._active)
					{
						fm._enemyDictionary["throwSpeed"] = 0.0;
						throwSpeed = fm._enemyDictionary["throwSpeed"];
						break;
					}
				}
				
				var throwSpeedFloat = ( (typeof throwSpeed == "undefined") || (throwSpeed == null)) ?  1 : throwSpeed;
				fm._bossActionCooldownTimer = 60 * throwSpeedFloat;
				fm.throwProjectile( throwSpeedFloat * this._fightData._throwTiming );
				
				this.setState( kActorFightStateBossThrow);
			}
			
			else if (actionName == "wall" && fm.allowedToSummonWall())
			{
				if (fm._startGame)
				{
					fm._currentBossAction = currentAction;
					fm._bossActionCastTimer = 60 * currentAction["castTime"];
					fm.summonWall(fm._bossActionCastTimer/60);
					this.setState( kActorFightStateBossSummonWall );
				}
			}
			
			else if(actionName == "telekinesis" && fm.allowedToTelekinesis() )
			{
//				fm._telekinesis = ZFParticleEffects.particlesSystemByTag["telekinesis.plist"];
//				fm._telekinesis.setPosition( ccpAdd(fm._bossPosition, ccp(-50,75) )); 
//				fm._telekinesis.setScale(0);
//	
//				fm.getParent().addChild(fm._telekinesis, 200);
				
				fm._currentBossAction =  currentAction;
				fm._bossActionCastTimer = 60 * currentAction["castTime"];
				fm._bossActionCooldownTimer = fm._bossActionCastTimer * 1.25;  
				
//				var scaleAction = CCScaleTo.actionWithDuration ( fm._bossActionCastTimer/60 * 0.85, 1.0 );
//				var moveToAction = CCMoveTo.actionWithDuration( fm._bossActionCastTimer/60 * 0.15, ccpAdd (fm._enemyPosition, ccp(-50,0)));
				
//				var actionsArrayactionsArray = new Array();
//				aux = [scaleAction, moveToAction, null];
//				var sequenceAction = CCSequence.actions(aux);
				
//				fm._telekinesis.runAction(sequenceAction);
				
				fm.schedule(fm.telekinesis, fm._bossActionCastTimer/60, "telekinesis");
				this.setState( kActorFightStateBossTelekinesis );
			}
			else if(actionName == "summonBoss" && fm.allowedToSummonBoss())
			{
				if (fm._startGame)
				{
					fm._currentBossAction = currentAction;
					fm._bossActionCastTimer = 60 * currentAction["castTime"];
					fm._bossActionCooldownTimer = fm._bossActionCastTimer * 1.25;
					fm.schedule( fm.summonBoss, fm._bossActionCastTimer/60, "summonBoss");
					this.setState( kActorFightStateBossSummonBoss );
				}
			}
//			break;
		}.bind(this);
		
		this._bossUpdateObject[kActorFightStateBossThrow] = function(){
			if (fm._bossActionCooldownTimer <= 0)
			{
				this.setState( kActorFightStateBossWait ) ; 
			}
//			break;
		}.bind(this);
		
		this._bossUpdateObject[kActorFightStateShootBullet] = function(){
			this.createBullet();
			this.setState( kActorFightStateBossWait );
//			break;
		}.bind(this);
		
		this._bossUpdateObject[kActorFightStateBossSummonBoss] = function(){
			if(fm._bossActionCastTimer <= 0 && fm._bossWall)
			{
				this.setState( kActorFightStateBossWait );
			}
			if (fm._bossActionCastTimer <= 0 && fm._telekinesis)
			{
				this.setState( kActorFightStateBossWait );
			}
		}.bind(this);
		
		this._bossUpdateObject[kActorFightStateBossTelekinesis] = function(){
			if (fm._bossActionCastTimer <= 0 && fm._telekinesis)
			{
				this.setState( kActorFightStateBossWait );
			}
//			break;
		}.bind(this);
		
		
		this._bossUpdateObject[kActorFightStateBossSummonWall] = function(){
			if (fm._bossActionCastTimer <= 0 && fm._wall)
			{
				this.setState( kActorFightStateBossWait );
			}
//			break;
		}.bind(this);
		
		this._bossUpdateObject[kActorFightStateStunned] = function(){
			this.stopAllActions();
			if ( this.isScheduled(this.damageIn))
			{
				this.unschedule(this.damageIn);
			}
//			break;
		}.bind(this);
		
		this._bossUpdateObject[kActorFightStateBossGoDown] = function(){
			this.moveToPoint({_x: fm._bossPosition._x + 200, _y: fm._bossPosition._y});
			this.setState(kActorFightStateBossGoingDown);
//			break;
		}.bind(this);
		
		this._bossUpdateObject[kActorFightStateBossGoingDown] = function(){
			this.movementUpdate(dt);
			if ( ccpEqual(this._ccPosition, this._destinationPoint) )
			{
				//AlienStage
				if(this._bossShipFront)
				{
					if(this._bossShipFront._parent)
						this._bossShipFront._parent.removeChild(this._bossShipFront, true);
					destroyWithChildren(this._bossShipFront);
					this._bossShipFront = null;
				}
				if(this._bossShipBack)
				{
					if(this._bossShipBack._parent)
						this._bossShipBack._parent.removeChild(this._bossShipBack,true);
					destroyWithChildren(this._bossShipBack);
					this._bossShipBack = null;
				}
				this.setPosition({_x:fm._bossPosition._x+200, _y: fm._enemyPosition._y});
				this.setState( kActorFightStateGo );
				this._spriteMan._parent.reorderChild(this._spriteMan, 3);
			}
			//break;
		}.bind(this);
	},
	
	initCivilianUpdateObject : function()
	{
		this._civilianUpdateObject[kActorFightStateBeingSummoned] = function(){
			// invincibility !!!
			this._fightData._invincible = true;
			this._fightData._canInterrupt = false;
//			break;
		}.bind(this);
		
		this._civilianUpdateObject[kActorFightStateWall] = function(){
		
			this._fightData._invincible = false;
			this._fightData._canInterrupt = true;
			
			// do nothin for now
			// collide with other zombies if no zombies left to run into
			if(this._fightData._opponent && this._fightData._opponent._fightData._hitPoints > 0)
			{
				this.setState ( kActorFightStateFight );
			}
			else 
			{
				var targets = [];
				var fartherTargets = [];
				for (var key in fm._zombies)
				{
					var z = fm._zombies[key];
					if ( z._state == kActorFightStateFightBossWall ||
							z._state == kActorFightStateFightingBossWall )
					{
						targets.push(z);
					}
					else if ( z._state == kActorFightStateFight ||
							z._state == kActorFightStateFighting )
					{
						fartherTargets.push(z);
					}
				}
				
				if ( targets.length > 0)
				{
					this._fightData._opponent = targets[0];
				}
				else if (fartherTargets.length > 0)
				{
					var target = null;
					var closestDistance = 100000;
					
					for (var key in fartherTargets)
					{
						var z = fartherTargets[key];
						if ( !target )
						{
							target = z;
							closestDistance = Math.abs(z._ccPosition._x - this._ccPosition._x);
						}
						else
						{
							var distance = Math.abs(z._ccPosition._x - this._ccPosition._x);								
							if(distance <= closestDistance)
								target = z;
						}
					}
					if(target)
					{
						this.moveToPoint( ccpF(target._ccPosition._x, this._ccPosition._y) );
					}
				}
				else 
				{
//					var w = new Core.Size(UI.Window._height, UI.Window._width);
					var p = ccp(450 , fm._enemyPosition._y);
					this.moveToPoint(p);
				}
	
			}
//			break;
		}.bind(this);
			
		this._civilianUpdateObject[kActorFightStateMoveForwardAfterAttack] = function(){
			this.unschedule( this.fightAttack );
			
			if(this._fightData._attacking == false)
			{
				this.setState ( kActorFightStateGo );
			}
//			break;
		}.bind(this);
		
		this._civilianUpdateObject[kActorFightStateStunned] = function(){
			this.stopAllActions();
			if ( this.isScheduled(this.damageIn) )
			{
				this.unschedule(this.damageIn);
			}
//			break;
		}.bind(this);
		
		this._civilianUpdateObject[kActorFightStateDead] = function(){
			if ( fm._enemySlots.indexOf(this) > 0)
			{
				var enemyIndex = fm._enemySlots.indexOf(this);
				fm._enemySlots.splice(enemyIndex, 1);
			}
			
			this.stopAllActions();
			this.unscheduleAllSelectors();
			this.despawn();
			
			ZFFightGUI.updateEnemyCount();
//			return false;
		}.bind(this);
		
		this._civilianUpdateObject[kActorFightStateDying] = function(){
			if( this != fm._bossWall )
			{
				fm._enemyPopulation--;
				fm._enemyCasualty++;
			}
			this.setState( kActorFightStateDead );
			fm.playDeathEffect();
//			break;
		}.bind(this);
		
		
		this._civilianUpdateObject[kActorFightStateGo] = function(){
			if(this == fm._enemy)
			{
				this.moveToPoint(fm._enemyPosition);
				this._spriteMan._parent.reorderChild(this._spriteMan, 4);
			}
			else 
			{
				var index = - 1;
				index = fm._enemySlots.indexOf(this);
				if(index >= 0)
				{
					var moveTo = ccp( fm._enemyPosition._x + 10 + (10*index), fm._enemyPosition._y - ((index-2)*10) );
					this.moveToPoint(moveTo);
					
					this._spriteMan._parent.reorderChild(this._spriteMan, index + 2);
				}
				else 
				{
					
				}

			}

			this.flipActor(false);
			this.setState( kActorFightStateGoing );
//			break;
		}.bind(this);
		
		this._civilianUpdateObject[kActorFightStateGoing] = function(){
			if (ccpEqual(this._ccPosition, this._destinationPoint))
			{
				if(fm._enemy && this != fm._enemy)
				{
					this._fightData._opponent = fm._enemy._fightData._opponent;
				}
				this.setState( kActorFightStateFight );
			}
//			break;
		}.bind(this);
		
		this._civilianUpdateObject[kActorFightStateFight] = function(){
			if (fm.isGameLost())
			{
				this.startAnim(kActorAnimVictory, true);
				this.unscheduleUpdate();
			}
			
			if (this._fightData._opponent)
			{
				if(this._fightData._opponent._fightData._hitPoints > 0)
				{
					this.setState( kActorFightStateFighting );
				}
				else
				{
					this._fightData._opponent = null;
					if(this == fm._bossWall)
					{
						this.setState(kActorFightStateWall );
					}
				}
			}
//			break;
		}.bind(this);
		
		
		this._civilianUpdateObject[kActorFightStateFighting] = function(){
			if (!this._fightData._opponent)
			{
				this.setState(kActorFightStateFight);
				if ( this == fm._bossWall )
				{
					this.setState(kActorFightStateWall);
				}
			}
			else
			{
				var opponentData = this._fightData._opponent._fightData;
				if (!this._fightData._attacking)
				{
					if (opponentData._hitPoints > 0)
					{
						this.setAttackVariation();
						this.schedule(this.fightAttack, 0, "fightAttack");
					}
					else
					{
						this._fightData._opponent = null;
						this.unschedule(this.fightAttack);
						this.setState( kActorFightStateFight );
						if ( this == fm._bossWall)
						{
							this.setState( kActorFightStateWall );
						}
					}
				}
			}
			if (this instanceof CityStageActorCrazedWorker)
			{
				var maxHP = ZFGameDefines.HITPOINTS_MULTIPLIER * this._unitDictionary["con"];
				
				var hat = this._attachments[kActorPartTagHat];
				var feature = this._attachments[kActorPartTagFeatures];
				
				if (this._fightData._hitPoints/maxHP < 0.75 && hat._sprite._visible)
				{
					hat._sprite.setVisible(false);
				}
				
				if (this._fightData._hitPoints/maxHP < 0.5 && feature._sprite._visible)
				{
					feature._sprite.setVisible(false);
				}
			}
//			break;
		}.bind(this);
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/StageActor/StageActor'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/StageActor/StageActor'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/StageActor/StageActor'] = exports; var fm = null;
exports.StageActor = CivilianActorFight.subclass
({
	classname : 'StageActor',
	
	initialize : function()
	{
		fm = ZFFightMan;
		
		this._grabbedActor = null; //Actor *
		
		this._actorDictionary = null; //NSDictionary *
		
		this._key = null; //NSString *
		
		this._pointSet = null; //NSMutableArray *
		this._pointBox = new Core.Rect(0,0,0,0); //CGRect 
		
		this._isFarmActor = false; //BOOL 
		this._isFightActor = false; //BOOL 
		
		this._usingSpriteDictionary = false; //BOOL 
		this._isTouchable = false; //BOOL 
		this._isCollidable = false; //BOOL 
		this._noFlip = false; //BOOL 
		this._suppposedToBeFacingRight = false; //BOOL 
		
		this._currentAction = null; //NSString *
		
		this._constantParticleNode = null; //CCNode *
		this._particleNode = null; //CCNode *
		
		this._movementType = 0; //int 
		
		this._targetPoint = new Core.Point(0,0); //CGPoint 
		this._originalPosition = new Core.Point(0,0); //CGPoint 
		this._currentPosition = new Core.Point(0,0); //CGPoint 
		
		this._jumpHeight = 0; //float 
		this._jumpLength = 0; //float 
		
		this._sinWavelength = 0; //int 
		this._sinAmplitude = 0; //int 
			
		this._animationsToBuild = null; //NSMutableArray *
		
		this._stageActorObject = {};
	},

	$stageActorStates :
	{
		kStageActorStateAll  : 				-1,
		kStageActorStateIdle : 				0,
		kStageActorStateWait : 				1,
		kStageActorStateWaitForRedo : 		2,
		kStageActorStateMoving : 			3,
		kStageActorStateDestination : 		4,
		kStageActorStateSpawn : 			5,
		kStageActorStateRun : 				6,
		kStageActorStateRunning : 			7,
		kStageActorStateRanAway : 			8,
		kStageActorStateDying : 			9,
		kStageActorStateDead : 				10,
		kStageActorStateMove : 				11,
		kStageActorStateTargetAcquired : 	12,
		kStageActorStateFall : 				13,
		kStageActorStateFalling : 			14,	
		kStageActorStateFell : 				15,
		kStageActorStateTappedOut :			16,
		kStageActorStateTouched : 			17,
		kStageActorStateCollided : 			18
		
	},
	
	movementTypes : 
	{
		kMovementTypeLinear : 				0,
		kMovementTypeSine : 				1,
		kMovementTypeSwoop : 				2,
		kMovementTypeJump : 				3 
	},
	
	initWithCoder : function($super,coder) /*NSCoder * */
	{
		$super(coder);
		
		//TODO: Check coder 
		this._key = coder._key;
//		this.key = (NSString*)[coder decodeObjectForKey:@"key"];
	},
	
	encodeWithCoder : function($super, coder)
	{
		$super(coder);
		//TODO: Check. coder
//		[coder encodeObject:this.key forKey:@"key"];		
	},
	
	copyWithZone : function(zone)
	{

		var copy = new StageActor();
	    
	    // Actor specific
	    copy.copyActorData(copy, zone);
	    
	    // StageActor specific
	    copy._key = this._key.copyWithZone(zone);
	    
		return copy;
	},
	
	colorFromSubType : function(actorSubType)
	{
		this._color = this._savedColor;
		return this._savedColor;	
	},
	
	$spriteNodeForMarketDictionary : function(marketDict)
	{
		var acm = ZFActorManager;
		
		var actorDict = acm._stageActorDictionaries[marketDict["tile"]];
		var spriteNode = this.spriteNodeForDictionary(actorDict);
		
		var colorArray = marketDict["color"];
		var red   = colorArray[0];
		var green = colorArray[1];
		var blue  = colorArray[2];
		
		var c = ccc3(red, green, blue);
		
		for(var s in spriteNode._children)
		{
			s.setColor(c);
		}
		
		return spriteNode;
	},
	
	$spriteNodeForDictionary: function(aDict, c)
	{
		if(!aDict)
			return null;
		
		if(!c)
			c = ccc3(0xff, 0xff, 0xff);
		
		var spriteNode = new CCnode();
		if(aDict["spriteFrameFile"])
		{
			var attachements = aDict["attachements"];
			var skeletonDictionaryTemp = aDict["skeletonDictionary"];
			var frameFile = aDict["spriteFrameFile"];
			
			CCSpriteFrameCache.sharedSpriteFrameCache().addSpriteFramesWithFile(frameFile);
			
			for(var key in attachements)
			{
				var attachement = attachements[key];
				var spriteFrames = attachement["spriteFrames"];
				var spriteFrameName = spriteFrames[0];
				
				var frame = CCSpriteFrameCache.sharedSpriteFrameCache().spriteFrameByName(spriteFrameName);
				var sprite = CCSprite.spriteWithSpriteFrame(frame);
				
				sprite.setColor(c);
				var attachementID = attachement["attachementID"];
				
				var z = 0;
				
				switch(attachementID)
				{
					case kActorPartTagButt    :	z =  0; break;
					case kActorPartTagFistB   :	z =  1; break;
					case kActorPartTagArmB    :	z =  2; break;
					case kActorPartTagFootB   :	z =  3; break;
					case kActorPartTagFootF   :	z =  4; break;
					case kActorPartTagBody	  :	z =  5; break;
					case kActorPartTagHead	  :	z =  6; break;
					case kActorPartTagJaw	  :	z =  7; break;
					case kActorPartTagFeatures: z =  8; break;
					case kActorPartTagArmF    :	z =  9; break;
					case kActorPartTagFistF   :	z = 10; break;
				}
				
				if(skeletonDictionaryTemp)
				{
					// we only need z order and offset, no anchor point correction
					var skeletonEntry = skeletonDictionaryTemp[spriteFrameName];
					if(skeletonEntry["offset"])
					{
						sprite.setPosition(CGPointFromString(skeletonEntry["offset"]));
					}		
					if(skeletonEntry["z"])
					{
						z = skeletonEntry["z"];
					}				
				}
				spriteNode.addChild(sprite, z);
			}
			
			CCSpriteFrameCache.sharedSpriteFrameCache().removeUnusedSpriteFrames();
		}
		else 
		{
			var sprite = CCSprite.spriteWithFile(aDict["spriteFile"]);
			sprite._anchorPoint = aDict["spriteOffsetForUI"] ? CGPointFromString(aDict["spriteOffsetForUI"]) : ccp(0.5,0.5);
			sprite.setColor(c);
			spriteNode.addChild(sprite, 0);
		}
		
		return spriteNode;
	},
	
	$stageActorWithMarketDictionary : function(aDict)
	{
		var dude = StageActor.stageActorWithDictionaryKey(aDict["tile"]);
		
		var colorArray = aDict["color"];
		var red   = colorArray[0];
		var green = colorArray[1];
		var blue  = colorArray[2];
		
		dude._savedColor = ccc3(red, green, blue);
		dude.resetColor();

		return dude;
	},
	
	$stageActorWithDictionaryKey : function(keyValue)
	{
		var acm = ZFActorManager;
		dict = acm._stageActorDictionaries[keyValue];
		
		var dude = StageActor.stageActorWithDictionary(dict);
		dude._key = keyValue;
		
		return dude;
	},
	
	$stageActorWithDictionary : function(aDict)
	{
		//TODO: Check for different plataforms
		var winSize = new Core.Size(UI.Window._width, UI.Window._height);
		var resolutionWidth = winSize._width;
		var myWidthScale = resolutionWidth / 480;
		var myHeightScale = myWidthScale; //resolutionHeight / 320;
		
		var dude = new this();
		dude._actorDictionary = aDict;
		
		dude.initActorSpecificData();
		
		dude.initActorSpecificDataAfterLoad();

		var spawnPosition = dude._actorDictionary["spawnPoint"] ? CGPointFromString(dude._actorDictionary["spawnPoint"]) : CGPointMake(0,0);
		spawnPosition.setX( spawnPosition._x * myWidthScale);
		spawnPosition.setY( spawnPosition._y * myHeightScale);
		dude._originalPosition = dude._destinationPoint = spawnPosition;
		dude.setPosition(spawnPosition);
		
		dude.initSprite();
		dude._isFarmActor = dude._actorDictionary["isFarmActor"];
        if(dude._isFarmActor)
            dude.initFarmDataAfterLoad();
        
        dude._isFightActor = dude._actorDictionary["isFightActor"];
        if(dude._isFightActor)
            dude.initFightDataAfterLoad();
        
        dude.initValuesFromDictionary();
            
        dude._state = this.stageActorStates.kStageActorStateSpawn;
            
        return dude;
	},
	
	initActorSpecificData : function($super)
	{
		$super();
		
		this._hitBox = null;
		
		this._grabbedActor = null;
		this._pointSet = null;
		this._pointBox = CGRectMake(0, 0, 0, 0);
		this._key = null;
		
		this._usingSpriteDictionary = false;
		this._articleNode = null;
		this._constantParticleNode = null;
		
		this._movementType = this.movementTypes.kMovementTypeLinear;
		
		this._sinWavelength = 0;
		this._sinAmplitude  = 0;
		this._noFlip = false;
		this._suppposedToBeFacingRight = true;
		
		this._targetPoint = CGPointMake(0, 0);
		this._jumpHeight = 0;
		this._jumpLength = 0;
		this._savedColor = ccc3(0xff,0xff,0xff);
		this._currentAction = null;
	},
	
	initActorSpecificDataAfterLoad : function($super)
	{
		$super();
		this._type = kActorTypeCivilian;
		this._state = kActorFightStateWait;
		
		this._isTouchable = this._actorDictionary["isTouchable"];
		this._isCollidable = this._actorDictionary["isCollidable"];
		
		this._animationsToBuild = [];
		
		this._collisionBoxSize   = CGSizeFromString(this._actorDictionary["collisionBoxSize"]);
		this._collisionBoxSize.setWidth(this._collisionBoxSize._width * this._widthScale);
		this._collisionBoxSize.setHeight( this._collisionBoxSize._height * this._widthScale);
		this._collisionBoxOffset = CGPointFromString(this._actorDictionary["collisionBoxOffset"]);
		this._collisionBoxOffset = ccpMult(this._collisionBoxOffset, this._widthScale);
		
		this._noFlip = this._actorDictionary["noFlip"];
		
		this._particleNode = new CCNode();
		this._constantParticleNode = new CCNode();
		
		var dict = ZFActorManager._unitStats;
		this._unitDictionary = dict[this._actorDictionary["unitStatsEntry"]];
		
		this._walkingSpeed = this._actorDictionary["walkingSpeed"]?this._actorDictionary["walkingSpeed"]*this._widthScale : 1*this._widthScale;
		this._animSpeed = 1.0 / this._walkingSpeed;
		
		this.initStageActorObject();

	},
	
	initSpriteDictionary : function()
	{
		this._frameOffset = CGPointFromString(this._actorDictionary["frameOffset"]);
		this._spriteFileName = this._actorDictionary["spriteFile"];
		if(this._actorDictionary["spriteFrameFile"])
		{
			this._usingSpriteDictionary = true;

			this._spriteFrameFile = DataPreloader._stageActorData[this._actorDictionary["spriteFrameFile"]];
			
			this._skeletonDictionary = this._actorDictionary["skeletonDictionary"];
		}
		//FIXME
		this._spriteDictionary = DataPreloader._alienStageData;
		this._extraSpriteDictionary = DataPreloader._alienStageElementsData;
		this._spriteFileName = "AlienStage.png";
	},
	
	initSprite : function($super)
	{
		$super();
		
		if(this._usingSpriteDictionary)
		{
			var attachements = this._actorDictionary["attachements"];
			
			for(var key in attachements)
			{
				var attachement = attachements[key];
			
				var spriteFrames = attachement["spriteFrames"];
				
				var attachementID = attachement["attachementID"];
				
//				console.log("dataaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa1");
//				this.addAttachment(attachementID, spriteFrames[0]);
				
				if(spriteFrames.length > 1)
				{
					this._animationsToBuild.push(attachement); //attachement is NSDictionary
				}
			}
			
			if(this._skeletonDictionary && this._skeletonDictionary["joints"])
			{
				var joints = this._skeletonDictionary["joints"];
				for(var key in joints)
				{
					var j = joints[key];
					var attachmentID = j["attachmentID"];
					
					var a = attachments[attachmentID];
					
					for(var key2 in j["attachments"])
					{
						var n =  j["attachments"][key2];
						var jointAttachmentID = n;
						var b = attachments[jointAttachmentID];
						
						a.addBone(b);
					}				
				}
			}
			else 
			{
				var sprite = CCSprite.spriteWithFile(this._spriteFileName);
				sprite._anchorPoint = this._actorDictionary["spriteAnchor"] ? CGPointFromString(this._actorDictionary["spriteAnchor"]) : ccp(0.5,0.5);
//				console.log("dataaaaaaaaaaaaaaaaaaaaaaaaaaaaaAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA: ");
//				this.addAttachment_withSprite_withZOrder(kActorPartTagBody, sprite, 0);
			}
			
			this._spriteMan.setScale(1);
			
			if(this._actorDictionary["constantParticles"])
			{
				var particlesToAdd = this._actorDictionary["constantParticles"];
				for(var key in particlesToAdd)
				{
					var p = particlesToAdd[key];
					var file = p["file"];
					var offset = p["offset"] ? CGPointFromString(p["offset"]):CGPointMake(0,0);
					offset = ccpMult(offset, this._widthScale);
					//TODO Wait for CCQuadParticleSystem implementation
//					var particle = CCQuadParticleSystem.particleWithFile(file);
//					particle.setPosition(offset);
//					particle.setScale(particle.getScale() * this.widthScale);
//					
//					this._constantParticleNode.addChild(particle);
				}
			}
			var hitBoxSize = (this._actorDictionary["hitBoxSize"]) ? CGSizeFromString(this._actorDictionary["hitBoxSize"]):CGSizeMake(32, 32);
			hitBoxSize.setWidth(hitBoxSize._width * this._widthScale);		//actor scaled up by widthScale
			hitBoxSize.setHeight(hitBoxSize._height * this._widthScale);
			
			this._hitBox = new ActorHitBox();
			var body = this._attachments[kActorPartTagBody];
			
			if(this._actorDictionary["hitBoxOffset"])
			{
				this._hitBox._actorSpecificOffset = CGPointFromString(this._actorDictionary["hitBoxOffset"]);
			}
			else
				this._hitBox._actorSpecificOffset = CGPointMake(0,0);
			
			this._hitBox._attachedTo = body;
			this._hitBox._target = this;
			
			var placeHere = body._offsetFromRefPoint;
			
			if(!placeHere){
				placeHere = ccp(0,0);
			}
			
			placeHere.setX(placeHere._x*this._widthScale);
			placeHere.setY(placeHere._y*this._widthScale);
			
			placeHere = ccpAdd(placeHere, this._hitBox._offset);
			
			var facing = body._sprite.flipX()?-1:1;
			
			this._hitBox._tapDelay = this._actorDictionary["tapDelay"];
			
			this._hitBox.setPosition(ccpAdd(placeHere,ccp(
					facing * this._hitBox._actorSpecificOffset._x*this._widthScale,
					this._hitBox._actorSpecificOffset._y*this._widthScale)));		
			this._hitBox._active = this._isTouchable;
			
			this.addChild(this._hitBox, this._spriteMan._zOrder);
		}
	},
	
	initFarmDataAfterLoad : function()
	{
		this._farmData = new ActorFarmData();
	},
	
	initFightDataAfterLoad : function()
	{
		if(!this._fightData)
		{
			this._actorFightData = new ActorFightData();
			
			this._fightData = this._actorFightData;
		}
		
		this._fightData._finalHitPointsTotal = this._fightData._hitPoints = ZFGameDefines.HITPOINTS_MULTIPLIER * this._unitDictionary["con"];
		this._fightData._power = ZFGameDefines.POWER_MULTIPLIER * this._unitDictionary["str"];
		this._fightData._attackSpeed = ZFGameDefines.ATTACKSPEED_MULTIPLIER/this._unitDictionary["dex"];
		
		if(this._actorDictionary["lifeBarOffset"])
		{
			this._fightData._lifeBarOffset = CGPointFromString(this._actorDictionary["lifeBarOffset"]);		
		}
		else 
		{
			this._fightData._lifeBarOffset = CGPointMake(0,0);
		}
	},
	
	initValuesFromDictionary : function()
	{
		if(this._actorDictionary["pointSet"])
		{
			var pointValues = this._actorDictionary["pointSet"].split(":");
			var pointSetArray = [];
			for(var key in pointValues)
			{
				var point = pointValues[key];
				var p = CGPointFromString(point);
				p.setX(p._x * this._widthScale);
				p.setY(p._y * this._widthScale);
				pointSetArray.push(p);
			}
			if(pointSetArray.length > 0)
				this._pointSet = pointSetArray;
			else ; 
//				NSLog(@"pointSet does not contain any points");
		}
		
		if(this._actorDictionary["pointBox"])
		{
			this._pointBox = CGRectFromString(this._actorDictionary["pointBox"]);
		}
	},
	
	initAfterAttachingToScene : function()
	{
		
	},
	
	despawn : function($super)
	{
		this._pointSet.length = 0;
		this._pointSet = null;
		this._actorDictionary = null;
		this._currentAction = null;
		
		if(this._hitBox)
		{
			destroyWithChildren(this._hitBox);
			this._hitBox = null;
		}
		
		if(this._particleNode)
		{
//			this._particleNode.removeAllChildrenWithCleanup(true);
			this._particleNode.removeFromParentAndCleanup(true);
			destroyWithChildren(this._particleNode);
			this._particleNode = null;
		}
		
		if(this._constantParticleNode)
		{			
//			this._constantParticleNode.removeAllChildrenWithCleanup(true);
			this._constantParticleNode.removeFromParentAndCleanup(true);
			destroyWithChildren(this._constantParticleNode);
			this._constantParticleNode = null;
		}
		
		if(this._animationsToBuild)
		{
			this._animationsToBuild.length = 0;
			this._animationsToBuild = null;
		}
		
		$super();
	},
	
	moveToPoint : function(point, flip)
	{
		if (typeof flip == "undefined")
			flip = !this._noFlip;
		
		this._currentPosition = this.getPosition().clone();
		this._originalPosition = this.getPosition().clone();	
		
		this._destinationPoint = point.clone();
		

		if(CGPointEqualToPoint(this._destinationPoint, this.getPosition()))
			return;
		
		if (this._destinationPoint._x > this.getPosition()._x) //moving to the right
			this._suppposedToBeFacingRight = true;
		else if (this._destinationPoint._x < this.getPosition()._x)
			this._suppposedToBeFacingRight = true;
		
		if(!flip)
		{
			return;
		}
		
		var a = this._attachments[kActorPartTagBody];
		var spriteToTest = a._sprite;
		
		if (this._suppposedToBeFacingRight) //moving to the right
		{
			if(!spriteToTest.flipX())//are we currently NOT facing right
			{
				this.flipActor(true);
			}
		}
		else if (!this._suppposedToBeFacingRight) //moving to the left
		{
			if(spriteToTest.flipX())//are we currently facing right
			{
				this.flipActor(false);
			}
		}
	},
	
	cleanupAnimForState : function(value)
	{
		for(var key in this._attachments)
		{
			var a = this._attachments[key];
			if(a == null)
				continue;
			a._sprite.stopAllActions(0);
			a._sprite.setRotation(0);
			a.setRotation(0);
			a._lastFrameRotation = 0;
			
			a._sprite.setScale(1); 
			a.setScale(1);
			a._lastFrameScale = 1.0;
			a._sprite.setPosition(a._offsetFromRefPoint);
		}
	},
	
	setState : function(value)
	{
		if(this._state == value)
		{
			return;
		}
		
		if(this._state == kActorFightStateStunned)
		{
			this.cleanupStunEffect();
		}
		
		this.startAnimForState(value);
		this._state = value;
		
		if(this._state == this.stageActorStates.kStageActorStateMoving || this._state == this.stageActorStates.kStageActorStateRunning || 
				this._state == this.stageActorStates.kStageActorStateIdle)
		{
			return;
		}
		
		if(this._particleNode)
		{
			this._particleNode.removeAllChildrenWithCleanup(true);
		}
	},
	
	startAnimForState : function(value)
	{
		this.startAnim(0, true);
	},
	
	hitBoxTouched : function()
	{
		if(!this._isTouchable)
			return;
		
		if(this._hitBox && this._hitBox._attachedTo)			
		{	
			if(this._hitBox._attachedTo instanceof ActorAttachment)
			{
				var attachement = this._hitBox._attachedTo;
				sColor = ccc3(0xFF, 0xFF, 0xFF);
				attachement._sprite.setColor(ccc3(0xFF, 0x00, 0x00));
				//TODO: not sure about sColor.r etc
				var action1 = CCTintBy.actionWithDuration(0.05, sColor.getRed() * 255, sColor.getGreen() * 255, sColor.getBlue() * 255);
				attachement._sprite.runAction(action1);
			}
		}
		
		this._state = this.stageActorStates.kStageActorStateTouched;
	},
	
	collidedWith : function(object)
	{
		if(!this._isCollidable)
			return;
		
		if(!this.isActorCollidable(object))
			return;
		
		this._grabbedActor = object;
		this._state = this.stageActorStates.kStageActorStateCollided;
		// all objects usually collide only once (except walls)
	},
	
	isActorCollidable : function(a)
	{
		if(a.isInMeleeRange() ||  a._state == kActorFightStateUsingAbilityAtRange || 
				   a._state == kActorFightStateGoing)
					return true;
				return false;
	},
	
	update : function(dt)
	{
		var fm = ZFFightMan;
		
		if(this._isFightActor)
		{
			if(fm.isGameWon() || fm.isGameLost())
			{
				this.setState(this.stageActorStates.kStageActorStateRanAway);
			}
			
			if(this._fightData._hitPoints <= 0 && 
			   this._state != this.stageActorStates.kStageActorStateDying   &&
			   this._state != this.stageActorStates.kStageActorStateDead    &&
			   this._state != this.stageActorStates.kStageActorStateFalling &&
			   this._state != this.stageActorStates.kStageActorStateFell)
				this._state = this.stageActorStates.kStageActorStateDying;
		}
		
		var state = this._state;
		var func = this._stageActorObject[state];
		if(func)
		{
			func();
			if(state == this.stageActorStates.kStageActorStateDead || state == this.stageActorStates.kStageActorStateRanAway) {
				return;
			}
		}
		
		this.movementUpdate(dt);
	},
	
	redoActionsForString : function(dt)
	{
		this.unschedule(this.redoActionsForString);
		if(this._currentAction)
			this.doActionsForString(this._currentAction);
		else 
			this._state = this.stageActorStates.kStageActorStateSpawn;
	},
	
	doActionsForString : function(eventActions)
	{
		//TODO: Momentary fix. eventActions should never be undefined.
		if(!eventActions)
		{
			return;
		}
		var actions = eventActions.split(":");
		this._currentAction = eventActions;
		
		for(var key in actions)
		{
			var action = actions[key];
			var actionComponents = action.split("_");
			if(actionComponents[0] == "jumpToPlayer")
			{
				var acm = ZFActorManager;
				var tim = ZFTileManager;
				var moveHere = tim.mapPointFromTile(acm._player._farmData._currentTile); 
				this._destinationPoint = moveHere;
				
				this.moveToPoint(destinationPoint);
				this._jumpLength = actionComponents[1];
				this._jumpHeight = actionComponents[2];
				this._movementType = this.movementTypes.kMovementTypeJump;
			}
			else if(actionComponents[0] == "resetAttachment")
			{
				var attachmentID = actionComponents[1];
				var resetDuration = actionComponents[2] ? actionComponents[2] : 0.1;
				
				var a = this._attachments[attachmentID];
				a._sprite.runAction(CCScaleTo.actionWithDuration(resetDuration, 1));			
				a._sprite.runAction(CCRotateTo.actionWithDuration(resetDuration, 0));
			}
			else if(actionComponents[0] == "resetAttachmentWithBounce")
			{
				var attachmentID = actionComponents[1];
				var resetDuration = actionComponents[2] ? actionComponents[2] : 0.1;
				
				var a = this._attachments[attachmentID];
				var bounce = CCSequence.actions([CCScaleTo.actionWithDuration(0.2*resetDuration, 0.8, 1.25),
				                                 CCScaleTo.actionWithDuration(0.2*resetDuration, 1.18, 0.85),
				                                 CCScaleTo.actionWithDuration(0.2*resetDuration, 0.9, 1.11),
				                                 CCScaleTo.actionWithDuration(0.2*resetDuration, 1.05, 0.95),
				                                 CCScaleTo.actionWithDuration(0.2*resetDuration, 1.0, 1.0),
				                                 null]);
				
				a._sprite.runAction(bounce);			
				a._sprite.runAction(CCRotateTo.actionWithDuration(resetDuration, 0));
			}
			else if(actionComponents[0] == "setFrame")
			{
				var attachmentID = actionComponents[1];
				var spriteFrameName = actionComponents[2];
				
				CCSpriteFrameCache.sharedSpriteFrameCache().addSpriteFramesWithFile(this._spriteFrameFile);
				
				var spriteFrame = CCSpriteFrameCache.sharedSpriteFrameCache().spriteFrameByName(spriteFrameName);
				var a = this._attachments[attachmentID];
				
				if(a)
					a._sprite.setDisplayFrame(spriteFrame);

				CCSpriteFrameCache.sharedSpriteFrameCache().removeUnusedSpriteFrames();
			}
			
			else if(actionComponents[0] == "moveToNextPointInSet" ||
					actionComponents[0] == "sinMoveToNextPointInSet" ||		   
					actionComponents[0] == "sinMoveToNextPointInSetWithWavelength" ||
					actionComponents[0] == "swoopToNextPointInSet")
			{
				if(actionComponents[0] == "sinMoveToNextPointInSet")
				{
					this._sinAmplitude  = actionComponents[1];
					this._sinWavelength = 0;
					
					this._movementType  = this.movementTypes.kMovementTypeSine;
				}
				else if(actionComponents[0] == "sinMoveToNextPointInSetWithWavelength")
				{
					this._sinAmplitude  = actionComponents[1];
					this._sinWavelength = actionComponents[2];
					
					this._movementType  =  this.movementTypes.kMovementTypeSine;
				}
				else if(actionComponents[0] == "swoopToNextPointInSet")
				{								
					this.sinAmplitude  = 0;
					this.sinWavelength = 0;
					if(CGPointEqualToPoint(this._targetPoint, CGPointMake(0,0)))
					{
						this._movementType = this.movementTypes.kMovementTypeLinear;
					}
					else 
					{					
						this._movementType = this.movementTypes.kMovementTypeSwoop;
					}
				}
				
				else if(actionComponents[0] == "jumpToNextPointInSet")
				{
					this._jumpHeight = actionComponents[1];
					
					this._jumpLength = actionComponents[2];
		
					this._movementType = this.movementTypes.kMovementTypeJump;
				}
				else
				{
					this._sinAmplitude  = 0;
					this._sinWavelength = 0;
					
					this._movementType  = this.movementTypes.kMovementTypeLinear;
				}
				
				var defaultDestination = this._pointSet[0];
				this._destinationPoint = defaultDestination;
				
				for(var i in this._pointSet)
				{
					var np = this._pointSet[i];
					
					if(CGPointEqualToPoint(np, this.getPosition()))
					{
						var destinationIndex = i;
						destinationIndex = (destinationIndex + 1 >= this._pointSet.length) ? 0 : destinationIndex + 1;
						
						var nextDestination = this._pointSet[destinationIndex];
						
						//FIXME: This doesnt have to be here
						//if (typeof nextDestination == "undefined")
						//	nextDestination = this._pointSet[0];
						
//						if (typeof nextDestination == "undefined")
//							nextDestination = cpp (100,0);
						
						this._destinationPoint = nextDestination;
						
						
						
						break;
					}
				}
				this.moveToPoint(this._destinationPoint);
			}
			else if(actionComponents[0] == "checkDestinationEqualsPosition")
			{
				var recheckTimer = actionComponents[1];
				
				if(CGPointEqualToPoint(this.getPosition(),this._destinationPoint))
				{
					this._movementType = this.movementTypes.kMovementTypeLinear;
	
					this._state = this.stageActorStates.kStageActorStateWaitForRedo;
					this.schedule(this.redoActionsForString, recheckTimer, "redoActionsForString");
					return;
				}
			}
			else if(actionComponents[0] == "changeState")
			{				
				if(actionComponents[1] == "move")
				{
					this._state = this.stageActorStates.kStageActorStateMove;
				}
				else if(actionComponents[1] == "idle")
				{
					this._state = this.stageActorStates.kStageActorStateIdle;
				}
				else if(actionComponents[1] == "run")
				{
					this._state = this.stageActorStates.kStageActorStateRun;
				}
				else if(actionComponents[1] == "fall")
				{
					this._state = this.stageActorStates.kStageActorStateFall;
				}
				else if(actionComponents[1] == "dead")
				{
					this._state = this.stageActorStates.kStageActorStateDead;
				}
			}
			else if(actionComponents[0] == "changeStateWithDelay")
			{			
				var targetState = 0;
				
				var delay = actionComponents[2] ? actionComponents[2] : 0;
				
				if(actionComponents[1] == "move")
				{
					targetState = this.stageActorStates.kStageActorStateMove;
				}
				else if(actionComponents[1] == "idle")
				{
					targetState = this.stageActorStates.kStageActorStateIdle;
				}
				else if(actionComponents[1] == "run")
				{
					targetState = this.stageActorStates.kStageActorStateRun;
				}
				else if(actionComponents[1] == "fall")
				{
					targetState = this.stageActorStates.kStageActorStateFall;
				}
				else if(actionComponents[1] == "dead")
				{
					targetState = this.stageActorStates.kStageActorStateDead;
				}
				this._state = this.stageActorStates.kStageActorStateWait;
				this.runAction(CCSequence.actions([CCDelayTime.actionWithDuration(delay),
				                                   CCCallFuncND.actionWithTarget(this, this.callSetState.bind(this, targetState)),
				                                   null]));
			}
			else if(actionComponents[0] == "checkForTarget")
			{
				var fm = ZFFightMan;
				
				this._targetPoint = CGPointMake(0,0);
				
				for(var key in fm._zombies)
				{
					var z = fm._zombies[key];
					if(this.isActorCollidable(z))
					{
						this._targetPoint = z._position;
						break;
					}
				}
			}
			else if(actionComponents[0] == "disableCollision")
			{
				this._isCollidable = false;
			}
			else if(actionComponents[0] == "enableTouch")
			{
				this._isTouchable = false;
				this._hitBox._active = false;
			}
			else if(actionComponents[0] == "grabZombie")
			{
				this._grabbedActor._fightData._invincible = true;
				
				this._grabbedActor._destinationPoint = this.getPosition();
				this._grabbedActor.setPosition(this.getPosition());
				this._grabbedActor._fightData._knockBackPoint = CGPointMake(0,0);
				
				this._grabbedActor._spriteMan.getParent().reorderChild(this._grabbedActor._spriteMan, this._spriteMan._zOrder);
				this._grabbedActor.setState(kActorFightStateGrab);		
			}
			
			else if(actionComponents[0] == "spawnSameStageActor")
			{
				var fm = ZFFightMan;

				fm.spawnStageActorWithDictionary(this._actorDictionary);
			}
			else if(actionComponents[0] == "stopSelf")
			{
				this._destinationPoint = this._currentPosition = this._originalPosition = this.getPosition();
				this._targetPoint = CGPointMake(0,0);
				this._movementType = this.movementTypes.kMovementTypeLinear;
			}
			else if(actionComponents[0] == "damageSelf")
			{
				var damage = actionComponents[1];
				
				this.damage(damage);
			}
			else if(actionComponents[0] == "dropZombie")
			{
				if(this._grabbedActor)
				{				
					this._grabbedActor._fightData._invincible = false;
					this._grabbedActor.setState(kActorFightStateFall);
					this._grabbedActor = null;
				}			
			}
			else if(actionComponents[0] == "changeSpeed")
			{
				var speed = actionComponents[1];

				this._walkingSpeed = speed;
			}
		}
	},
	
	movementUpdate : function(dt)
	{
		var fpsComp = dt * 60.0;
		
		if (this._fightData && !CGPointEqualToPoint(CGPointMake(0,0), this._fightData._knockBackPoint))
		{
			var distanceLeftDelta = ccpSub(this._fightData._knockBackPoint, this.getPosition());
			var newPositionDelta = ccpMult(ccpNormalize(distanceLeftDelta), this._fightData._knockBackSpeed*fpsComp);
			if (ccpLength(newPositionDelta) >= ccpLength(distanceLeftDelta))
			{
				this.setPosition(this._fightData._knockBackPoint);
				this._fightData._knockBackPoint = CGPointMake(0,0);
			}
			else 
			{
				this.setPosition(ccpAdd(this._position, newPositionDelta));
			}
		}
		
		if (!CGPointEqualToPoint(this._position, this._destinationPoint) && this._state != kActorFightStateStunned)
		{		
			var movementVector = ccpSub(this._destinationPoint, this._originalPosition);
			var currentVector  = ccpSub(this._currentPosition, this._originalPosition);
			
			var previousPosition = this._currentPosition;
			
			var originalLength = ccpLength(movementVector);
			var currentLength  = ccpLength(currentVector);
							
			var lengthTraveled = (currentLength + fpsComp * this._walkingSpeed)/ originalLength;
					
			if (lengthTraveled >= 1.0)
			{
				this._currentPosition = this._destinationPoint;
				this.setPosition(this._destinationPoint);
				
				// always default to a linear movement type
				this._movementType = this.movementTypes.kMovementTypeLinear;
			}
			else
			{
				// position along a straight line;
				this._currentPosition = ccpAdd(ccpMult(movementVector, lengthTraveled),this._originalPosition);
					
				switch(this._movementType)
				{
					case this.movementTypes.kMovementTypeLinear:
					{					
						this.setPosition(this._currentPosition);
					}
						break;	
						
					case this.movementTypes.kMovementTypeSine:
					{
						var frequency = (this._sinWavelength != 0)?(originalLength / this._sinWavelength ) * 4:4;
						
						frequency = (frequency < 4)? 4:frequency;
						
						var sineOffset = Math.sin(Math.PI * lengthTraveled * frequency) * this._sinAmplitude;
						this.setPosition(ccp(this._currentPosition._x,this._currentPosition._y + sineOffset));
					}
						break;
						
					case this.movementTypes.kMovementTypeSwoop:
					{
						var targetIntersect = ccp(this._targetPoint._x - this._originalPosition._x,((this._targetPoint._x - this._originalPosition._x)/movementVector._x) * movementVector._y); 
						var targetVector = ccpSub(this._targetPoint, this._originalPosition);
						
						var	targetLength  = ccpLength(targetIntersect)/originalLength;
						
						var deltaY = targetIntersect._y - targetVector._y;
											
						// need an amplitude
						var sinOffset = (lengthTraveled < targetLength)? Math.sin(0.5 * Math.PI * (lengthTraveled / targetLength)) * (deltaY):
																					 Math.sin(0.5 * Math.PI * (1 - ((lengthTraveled - targetLength)/(1.0 - targetLength)))) * (deltaY);
						
						this.setPosition(ccp(this._currentPosition._x, this._currentPosition._y - sinOffset));
					}
						break;
					case kMovementTypeJump:
					{
						
						var jumps = (this._jumpLength <= originalLength)?originalLength/this._jumpLength:1;
						var jumpPortion = (lengthTraveled * jumps % 1.0);
						
						var minScale = 0.8;
						var maxScale = 1.25;
						
						var scaleY = (1-jumpPortion)*(maxScale - minScale);
						
						var scaleX = jumpPortion*maxScale*(maxScale - minScale);
						
						for(var key in this._spriteMan._children)
						{
							var sprite = this._spriteMan._children[key];
							sprite.setScale(scaleX + minScale, scaleY + minScale);
						}
						
						var yOffset = this._jumpHeight * 4 * jumpPortion * (1-jumpPortion);
						
						this.setPosition(ccp(this._currentPosition._x,this._currentPosition._y + yOffset));
						
					}
				}			
			}
			
			if(this._farmData)
			{
				var tim = ZFTileManager;
				var previousTile = tim.tileFromMapPoint(previousPosition, true);
				
				var newTile = tim.tileFromMapPoint(this._currentPosition, true);
				
				if(!CGPointEqualToPoint(previousTile, newTile))
				{
					// stageActors don't care about destination tiles
					this._farmData._currentTile = newTile;
					
					this.getParent().reorderChild(this, newTile._x + newTile._y +1);
					this._spriteMan.getParent().reorderChild(this._spriteMan, newTile._x + newTile._y +1);
					
				}
			}
		}
		
		for (var key in this._attachments)
		{
			var a = this._attachments[key];
			if(a == null)
			{
				continue;
			}
		
			a._updated = false;
		}
		
		for (var key in this._attachments)
		{
			var a = this._attachments[key];
			if(a == null)
				continue;
			this.updateAttachment(a);
		}
		
		if (this._fightData && this._fightData._lifeBar && this._fightData._lifeBar._opacity > 0)
		{
			var a = this._attachments[kActorPartTagHead];
			
			if (!a)
			{
				a = this._attachments[kActorPartTagBody];
			}
			
			var pos = ccpAdd(this._position,this._fightData._lifeBarOffset);
			
			pos = ccp(pos._x-25*this._widthScale,pos._y);
			
			this._fightData._lifeBar.setPosition(pos);
			this._fightData._lifeBG.setPosition(ccpAdd(this._fightData._lifeBar.getPosition(), ccp(-2*this._widthScale,-2*this._heightScale)));
			this._fightData._lifeBarTemp.setPosition(pos);
		}
		
		if(this._grabbedActor)
		{
			this._grabbedActor._destinationPoint = this.getPosition();
			this._grabbedActor.setPosition(this.getPosition());
		}
		
		if(this._particleNode)
		{
			this._particleNode.setPosition(this.getPosition());
		}
		
		if(this._constantParticleNode)
		{
			this._constantParticleNode.setPosition(this.getPosition());
		}
		
		if(this._hitBox)
		{
			// sets position
			var body = this._attachments[kActorPartTagBody];
			
			var placeHere = body._offsetFromRefPoint;
			
			if(!placeHere){
				placeHere = ccp(0,0);
			}
			placeHere = ccpAdd(placeHere, this._hitBox._offset);
			
			var facing = body._sprite.flipX()?-1:1;
			
			if (this._fightData)
			{
				this._hitBox.setPosition(ccpAdd(placeHere,ccp(facing * this._hitBox._actorSpecificOffset._x*this._widthScale,this._hitBox._actorSpecificOffset._y*this._widthScale)));
			}
			else {
				this._hitBox.setPosition(ccpAdd(placeHere,ccp(facing * this._hitBox._actorSpecificOffset._x,this._hitBox._actorSpecificOffset._y)));
			}
		}
	},
	
	startAnim : function(animID, interrupt)
	{
		switch(this._state)
		{
			case this.stageActorStates.kStageActorStateWaitForRedo:
			{
				var animationArray = this._actorDictionary["waitForRedoAnimation"];
				if(animationArray)
					this.performAnimation(animationArray, this._animSpeed);
			}
				break;
			case this.stageActorStates.kStageActorStateIdle:
			{
				var animationArray = this._actorDictionary["idleAnimation"];
				if(animationArray)
					this.performAnimation(animationArray, this._animSpeed);
			}
				break;
			case this.stageActorStates.kStageActorStateDestination:
			{
				var animationArray = this._actorDictionary["destinationAnimation"];
				if(animationArray)
					this.performAnimation(animationArray, this._animSpeed);
			}
				break;
		}
		
		
		this.buildAnimations();
	},
	
	buildAnimations : function()
	{
		return;
		for(var key in this._animationsToBuild)
		{
			var dict = this._animationsToBuild[key];
			var attachementID = dict["attachementID"];
			var a = this._attachments[attachementID];
			a.stopAllActions();
			
			var animatesForState = dict["animatesForState"];
			if(animatesForState != this._state && animatesForState != this.stageActorStates.kStageActorStateAll)
				continue;
			
			var animation = CAnimation.animationWithName["animatedSprite"];
			var speed = dict["animationSpeed"];
			var spriteFrames = dict["spriteFrames"];
			
			CCSpriteFrameCache.sharedSpriteFrameCache().addSpriteFramesWithFile(this._spriteFrameFile);
			
			for(var key in spriteFrames)
			{
				var frameName = spriteFrames[key];
				var frame = CCSpriteFrameCache.sharedSpriteFrameCache().spriteFrameByName(frameName);
				animation.addFrame(frame);
			}
			
			CCSpriteFrameCache.sharedSpriteFrameCache().removeUnusedSpriteFrames();
			
			a._sprite.runAction(CCRepeatForever.actionWithAction(CCAnimate.actionWithDuration(speed, animation, false)));	
		}
	},
	
	parseAnimationString : function(animation, totalDuration)
	{
		if(!animation)
			return null;
		
		var action = null;
		var animationSequence = animation.split("_");
		if(animationSequence[0] == "scale")
		{
			var s = animationSequence[1];
			var duration = animationSequence[2];
			
			duration = duration * totalDuration;
			
			action = CCScaleTo.actionWithDuration(duration, s);
		}
		
		if(animationSequence[0] == "scaleXY")
		{
			var sX = animationSequence[1];
			var sY = animationSequence[2];
			var duration = animationSequence[3];
			
			duration = duration * totalDuration;
			
			action = CCScaleTo.actionWithDuration(duration, sX, sY);
		}
		else if(animationSequence[0] == "delayBy")
		{
			var duration = animationSequence[1];
			
			duration = duration * totalDuration;
			
			action = CCDelayTime.actionWithDuration(duration);
		}
		else if(animationSequence[0] == "rotateTo")
		{
			var rotation = animationSequence[1];
			var duration = animationSequence[2];
			
			rotation = (this._suppposedToBeFacingRight)?rotation*-1:rotation;
			duration = duration * totalDuration;
			
			action = CCRotateTo.actionWithDuration(duration, rotation);
		}
			
		return action;
	},
	
	parseAnimationSequence : function(animation, totalDuration)
	{
		var animationSequence = animation.split(":");
		var sequenceAction = null;
		
		for(var key in animationSequence)
		{
			var animationString = animationSequence[key];
			var action = this.parseAnimationString(animationString, totalDuration);
			if(sequenceAction && action)
			{
				sequenceAction = CCSequence.actions([sequenceAction,action,null]);
			}
			else if(!sequenceAction && action)
			{
				sequenceAction = action;
			}		
		}
		return sequenceAction;
	},
	
	parseAnimationSet : function(animation, totalDuration)
	{
		var animationSequence = animation.split(",");
		
		var spawnAction = null;
		
		for(var key in animationSequence)
		{
			var animationString = animationSequence[key];
			var action = this.parseAnimationSequence(animationString, totalDuration);
			if(spawnAction && action)
			{
				spawnAction = CCSpawn.actions([spawnAction,action,null]);
			}
			else if(!spawnAction && action)
			{
				spawnAction = action;
			}		
		}
		return spawnAction;
	},		
	
	performAnimation : function(animationArray, duration, repeat)
	{
		return;
		if (!repeat)
			repeat = false;
		
		for(var key in animationArray)
		{
			var d = animationArray[key];
			var attachmentID = d["attachementID"];
			var a = this._attachments[attachmentID];
			
			var action = this.parseAnimationSet(d["animationString"], duration);
			
			if(action && !repeat)
				a.runAction(action);
			else if(action && repeat)
				a.runAction(CCRepeatForever.actionWithAction(action));
		}
	},
	
	destroy : function()
	{
		this._animationsToBuild.length = 0;
		this._animationsToBuild = null;
	},
	
	initStageActorObject : function()
	{
		
		this._stageActorObject[this.stageActorStates.kStageActorStateIdle] = function(){
			this.doActionsForString(this._actorDictionary["idleAction"]);
//			break;
		}.bind(this);
		
		this._stageActorObject[this.stageActorStates.kStageActorStateWait] = function(){
//			break;
		}.bind(this);
		
		this._stageActorObject[this.stageActorStates.kStageActorStateMove] = function(){
			//TODO: We dont have this now
//			if(this._actorDictionary["moveParticles"])
//			{
//				var movementParticles = this._actorDictionary["moveParticles"];
//				for(var key in movementParticles)
//				{
//					var particle = movementParticles[key];
//					var file = particle["file"];
//					var offset = particle["offset"]?CGPointFromString(particle["offset"]) : CGPointMake(0,0);
					
//					offset = (this._spriteMan._children[0].flipX())? ccp(-offset._x,offset._y) : offset;
//					
//					if(!this._spriteMan._children[0].flipX() && this._suppposedToBeFacingRight)
//					{
//						offset = particle["flippedOffset"] ? CGPointFromString(particle["flippedOffset"]):offset;						
//					}
//					offset = ccpMult(offset, this._widthScale);
					
					//TODO: Wait for CCQuadParticleSystem implementation
//					var particleSystem = CCQuadParticleSystem.particleWithFile(file);
//					
//					particleSystem._tag = this._state;
//					particleSystem.etPosition(offset);
//					particleSystem.setScale( particleSystem._scale * this._widthScale);
//					
//					particleNode.addChild(particleSystem]);
//				}
//			}
			this._state = this.stageActorStates.kStageActorStateMoving;
			
			if(CGPointEqualToPoint(this._position, this._destinationPoint))
			{
				this._state = this.stageActorStates.kStageActorStateDestination;
			}
//			break;
		}.bind(this);
		
		this._stageActorObject[this.stageActorStates.kStageActorStateMoving] = function(){
			if(CGPointEqualToPoint(this._position, this._destinationPoint))
			{
				this._state = this.stageActorStates.kStageActorStateDestination;
			}
//			break;
		}.bind(this);
		
		this._stageActorObject[this.stageActorStates.kStageActorStateTargetAcquired] = function(){
//			break;
		}.bind(this);
		
		this._stageActorObject[this.stageActorStates.kStageActorStateFall] = function(){
//			break;
		}.bind(this);
		
		this._stageActorObject[this.stageActorStates.kStageActorStateFalling] = function(){
			if(CGPointEqualToPoint(this._position, this._destinationPoint))
				this._state = this.stageActorStates.kStageActorStateFell;
//			break;
		}.bind(this);
		
		this._stageActorObject[this.stageActorStates.kStageActorStateFell] = function(){
			this.doActionsForString(this._actorDictionary["fellAction"]);
//			break;
		}.bind(this);
		
		this._stageActorObject[this.stageActorStates.kStageActorStateCollided] = function(){
			this.doActionsForString(this._actorDictionary["collidedAction"]);
//			break;
		}.bind(this);
		
		this._stageActorObject[this.stageActorStates.kStageActorStateTouched] = function(){
			this.doActionsForString(this._actorDictionary["touchedAction"]);
//			break;
		}.bind(this);
		
		this._stageActorObject[this.stageActorStates.kStageActorStateTappedOut] = function(){
//			break;
		}.bind(this);
		
		this._stageActorObject[this.stageActorStates.kStageActorStateDestination] = function(){
			this.doActionsForString(this._actorDictionary["destinationAction"]);
//			break;
		}.bind(this);
		
		this._stageActorObject[this.stageActorStates.kStageActorStateSpawn] = function(){
			this.doActionsForString(this._actorDictionary["spawnAction"]);
//			break;
		}.bind(this);
		
		this._stageActorObject[this.stageActorStates.kStageActorStateRun] = function(){
			var exit = CGPointFromString(this._actorDictionary["exitPoint"]);
			var w = new Core.Size(UI.Window._width, UI.Window._height);
			
			exit = ccp(w._width * exit._x, w._height * exit._y);
			
			if(exit._x < 0)
				exit.setX(-100);
			else if (exit._x > 0)
				exit.setX(exit._x + 100);
			
			if(exit._y < 0)
				exit.setY(-100);
			else if (exit._y > 0)
				exit.setY(exit._y + 100);
			
			var offset = ccp((exit._x == 0) ? this.getPosition()._x:0,(exit._y == 0)?this.getPosition()._y:0);
			
			this._destinationPoint = ccpAdd(exit, offset);
			
			this._movementType = this.movementTypes.kMovementTypeLinear;
			
			this.moveToPoint(this._destinationPoint);
			
			this._state(this.stageActorStates.kStageActorStateRunning);
//			break;
		}.bind(this);
		
		this._stageActorObject[this.stageActorStates.kStageActorStateRunning] = function(){
			if(CGPointEqualToPoint(this.getPosition(), this._destinationPoint))
			{
				this._state = this.stageActorStates.kStageActorStateRanAway;
			}
//			break;
		}.bind(this);
		
		this._stageActorObject[this.stageActorStates.kStageActorStateRanAway] = function(){
			this.doActionsForString(this._actorDictionary["ranAwayAction"]);
			
			if(this._grabbedActor)
			{			
				this._grabbedActor._fightData._invincible = false;
				this._grabbedActor.setState(kActorFightStateRanAway);
				this._grabbedActor = null;
			}
			
			if(this._actorDictionary["despawnParticles"])
			{			
				//TODO: Waiting for CCQuadParticleSystem implementation
//				var despawnParticles = CCQuadParticleSystem.particleWithFile(this._actorDictionary["despawnParticles"]);
//				despawnParticles._autoRemoveOnFinish = yes;
//				despawnParticles.setPosition(this._position);
//				despawnParticles.setScale(despawnParticles._scale * this._widthScale);
//				this._spriteMan.getParent().addChild(despawnParticles, this._spriteMan._zOrder);							
			}
			this.despawn();	
			fm._stageActors.splice(fm._stageActors.indexOf(this), 1);
//			return;
		}.bind(this);
		
		this._stageActorObject[this.stageActorStates.kStageActorStateDying] = function(){
			this.stopAllActions();
			
			this._isTouchable  = false;
			this._isCollidable = false;
			
			this.doActionsForString(this._actorDictionary["dyingAction"]);
//			break;
		}.bind(this);
		
		this._stageActorObject[this.stageActorStates.kStageActorStateDead] = function(){
			
			NSNotificationCenter.postNotificationName(
					ZFGameDefines.kStageActorDefeated,
					null,
					this._actorDictionary["name"]);
			
			this.doActionsForString(this._actorDictionary["deadAction"]);
			
			if(this._grabbedActor)
			{				
				this._grabbedActor._fightData._invincible = false;
				this._grabbedActor.setState(kActorFightStateGo);
				this._grabbedActor = null;
			}
			
			if(this._actorDictionary["despawnParticles"])
			{			
				//TODO: Waiting for CCQuadParticleSystem implementation
//				var despawnParticles = CCQuadParticleSystem.particleWithFile(this._actorDictionary["despawnParticles"]);
//				despawnParticles._autoRemoveOnFinish = true;
//				despawnParticles.setPosition(this._position);
//				despawnParticles.setScale(despawnParticles._scale * this._widthScale);
//				this._spriteMan.getParent().addChild(despawnParticles, this._spriteMan._zOrder + 1);							
			}
			
			this.despawn();		
			fm._stageActors.splice(fm._stageActors.indexOf(this), 1);
//			return;
		}.bind(this);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/FightGameScene/Physics/ZFFightPhysics'] = function(){var exports = $MODULE_REGISTRY['Code/Game/FightGameScene/Physics/ZFFightPhysics'] || {}; $MODULE_REGISTRY['Code/Game/FightGameScene/Physics/ZFFightPhysics'] = exports; var Physics2 = require('NGCore/Client/Physics2').Physics2;
var ZombieActorHeadless = require('Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadless').ZombieActorHeadless;
var ZFFightWall = require('Code/Game/FightGameScene/ZFFightWall').ZFFightWall;
//var ZFBodyWrapper = require('./ZFFightPhysics').ZFBodyWrapper;

var ZFBody = Core.Class.subclass({
	classname : 'ZFBody',
	
	initialize : function()
    { 
		this._target = null;
	    this._hasDamaged = false;
	    this._damageAmount = 0;
	    this._sprite = null;
	    this._deltaT = 0.5;
		this._Vxi = 0;
		this._Vyi = 0;
		this._Pi = null;
	//	this._angle = 0;
		this._t = 0;
		this._direction = 1;
		this._finished = false;
		this._targetW = 0;
		this._targetH = 0;
		this._scene = null;
    },
    
	setTarget : function(target, scale){
    	this._target = target;
    	this._scale = scale;

		var pos = this._target.getHeadPosition();
		
//		if(this._target instanceof ZombieActorHeadless)
//			this._targetH = pos._y-5;
//		else
			this._targetH = pos._y+65;
		
    	this._targetW = this._target._zombieW*this._scale;
//    	this._targetH = this._target._zombieH*this._scale;
    },
    
    setSprite : function (sprite, z){
    	this._sprite = sprite;
    	this._scene = this._target.getParent();
    	this._scene.addChild(this._sprite, z);
    	if(sprite instanceof CCSprite){
    		this._sprite.setAnchorPoint(ccp(0.5,0.5));
    	}
    },
    
    setInitialPosition : function(p){
    	this._Pi=p;
//    	if(this instanceof ZFFire){
//    		this._sprite.setPosition(p._x, 640 -p._y);
//    	} else
    	{
    		this._sprite.setPosition(p);
    	}
    	this.setVelocity();
    },
    
    setVelocity : function(){
    	
    },
    
	destroy : function()
	{
//		if(this._target && this._target.getParent())
//		{
		this._scene.removeChild(this._sprite, true);
//		}
		destroy(this._sprite);
		this._sprite = null;
		this._finished = true;
	},
	
	collision : function (x, y) {
		
		var targetPos = this._target.getPosition();
		
		var bx = targetPos._x - (this._targetW/2);
		var by = targetPos._y;
		//var difX = this._target.getPosition()._x-x;
		//var difY = this._target.getPosition()._y-y;
		//var targetDistance = Math.sqrt( (difX*difX)+(difY*difY) );
		if (x >= bx && x<= bx + this._targetW && y>= by && y <= by + this._targetH) {
			this.hitTarget();
			return true;
		}
		return false;
	},
	
	lastCollision : function (x)
	{
		var targetX1 = this._target.getPosition()._x-(this._targetW/2);
		var targetX2 = targetX1 + this._targetW;
		
		if(x>=targetX1 && x<=targetX2)
		{
			this.hitTarget();
		}
	},
	
	hitTarget : function ()
    {
    	this._hasDamaged = true;
        this._target.damage(this._damageAmount);
        SimpleAudioEngine.playEffect(kSplatSFX);
    }
	
});

var ZFBox = ZFBody.subclass({
    classname : 'ZFBox',
    
    initialize : function($super)
    {       
//    	this._projectile = null;
    	$super();
    	this._rotation = 0;
    	this._deltaRot = 3;
    },

	setVelocity : function()
	{	
		var R = this._direction * ( (this._target.getPosition()._x) - this._Pi._x );
		
		if (this._target._state == kActorFightStateGoing)
		{
			R = this._direction * ( (this._target.getPosition()._x) - this._Pi._x ) - 0.3*(R/this._targetW)*this._targetW;
		}
		
		if (R/this._targetW > 2){
			var rand = 2*Math.random()-1;
			R = R + (1.5*this._targetW)*(rand);
		}
		
		this._Vxi = this._direction * R * 2.21 * Math.sqrt(1/this._Pi._y);
	},
    
    update : function (dt)
    {
    	var t = this._t;
    	var x = this._Pi._x + this._Vxi*t;
    	var y = this._Pi._y + this._Vyi*t - 4.9*t*t;
    	
    	if (this.event(x,y)){
    		return;
    	}
    	this._rotation -= this._deltaRot;
    	this._sprite.setRotation(this._rotation);
//    	if(this instanceof ZFFire){
//    		this._sprite.setPosition(x, 640 - y);
//    	} else
    	{
    		this._sprite.setPosition(x,y);
    	}
    	
    	if(dt) {
    		this._t += (dt*11);
    	} else {
    		this._t += this._deltaT;
    	}
    },
	
	event : function(x, y)
	{
		if(!this._target)
		{
			this.destroy();
			return true;
		}
		
		if(!this._hasDamaged)
		{ 		
    		if(y<0)
    		{
    			this.lastCollision(x);
    			this.destroy();
        		return true;
        	}
    		
    		if(this.collision(x,y))
    		{
        		return true;
    		}
    	}
		
		if(this._hasDamaged){
			if (this._sprite._alpha<=0)
			{
				this.destroy();
	    		return true;
			}
			var alpha = this._sprite._alpha-0.1;
			this._sprite.setAlpha(alpha>=0? alpha:0);
    	}
		
		return false;
	},
	
	collision : function ($super, x, y) {
		if ($super(x,y)) {
			if(y<= (this._target.getPosition()._y + this._targetH - 40) ){
				this._Vxi = this._Vxi*(-0.9); 
				this._Pi._x = x;
				this._Pi._y = y;
				this._t = 0;
				this._deltaRot = -20;
			}
			else{
				this._Vyi = 6*this._t; 
				this._Pi._x = x;
				this._Pi._y = y;
				this._t = 0;
				this._deltaRot = 20;
			}
			
			//this._target.getParent().removeChild(this._sprite, true);
			//this._sprite = null;
			return true;
		}
		return false;
	}
    
});
exports.ZFBox = ZFBox;


var ZFLaser = ZFBody.subclass({
    classname : 'ZFLaser',
    
    initialize : function($super)
    {       
//    	this._projectile = null;
    	$super();
    	this._angle = 0;
    	this._collisionTime = 10;
    },

	setVelocity : function()
	{	
		var R = this._direction * ( (this._target._ccPosition._x) - this._Pi._x - 110);
		
		if (this._target._state == kActorFightStateGoing)
		{
			R = R - 0.06*(R/this._targetW)*this._targetW;
		}
		
		if (R/this._targetW <= 2){
//			var rand = 2*Math.random()-1;
			R = R - 110;
		}
		
		var H = this._Pi._y;
		this._angle = Math.atan(R/H);
		var distance = Math.sqrt(R*R + H*H);
		var V = distance/this._collisionTime;
		this._Vxi = this._direction*V*Math.sin(this._angle);
		this._Vyi = this._direction*V*Math.cos(this._angle);
		
		this._sprite.setRotation(180+this._angle*57.32);
	},
    
    update : function (dt)
    {
    	var t = this._t;
    	var x = this._Pi._x + this._Vxi*t;
    	var y = this._Pi._y + this._Vyi*t;
    	
    	if (this.event(x,y)){
    		return;
    	}
//    	this._rotation -= this._deltaRot;
//    	this._sprite.setRotation(this._rotation);
    	this._sprite.setPosition(x,y);
    	
    	if(dt) {
    		this._t += (dt*11);
    	} else {
    		this._t += this._deltaT;
    	}
    },
	
	event : function(x, y)
	{
		if(!this._target)
		{
			this.destroy();
			return true;
		}
		
		if(this.collision(x,y))
		{
			this.destroy();
			return true;
		}

		
		return false;
	},
    
});
exports.ZFLaser = ZFLaser;

var ZFFire = ZFLaser.subclass({
    classname : 'ZFFire',
    
    setTarget : function($super, target, scale)
    {
    	$super(target, scale);
    	this._startScaleX 	= this._target.getScale()._x;
		this._startScaleY 	= this._target.getScale()._y;
		this._deltaX		= this._startScaleX * 1.25 - this._startScaleX;
		this._deltaY		= this._startScaleY * 1.25 - this._startScaleY;
    },
    
    update : function ($super, dt)
    {
    	$super(dt);
    	if(this._sprite){
    		this._sprite.setScale( this._startScaleX + this._deltaX * this._t , this._startScaleY + this._deltaY * this._t );
    	}
    },
    
    setVelocity : function($super)
    {
    	$super();
    	this._sprite.setRotation(this._angle*57.32);
    }
});
exports.ZFFire = ZFFire;

//var ZFBulletWrapper = CCNode.subclass({
//    classname : 'ZFBulletWrapper',
//    
//    initialize : function()
//    {
//        this._active = true;
//        this._vector = new Core.Point(0, 0);
//        this._speed = 0;
//        this._b = null;
//    },
//    
//    shootBulletAt : function(target, origin)
//    {
//        // set vector: speed is done with specific bullet init
//        
//        // target - origin = normalized x,y space
//        var delta = new Core.Point(target._x - origin._x, target._y - origin._y);
//        
//        var distance = Math.sqrt(Math.pow(delta._x, 2) + Math.pow(delta._y, 2));
//        
//        this._vector = new Core.Point(delta._x / distance, delta._y / distance);
//        
//        this.schedule(this.bulletTime, 0, "bulletTime");
//    },
//    
//    bulletTime : function(dt)
//    {
//        // only update position if active
//        if (this._active)
//        {
//            // get frame compensation
//            // dt = time in seconds(s)
//            // conversion is 60 frames(f) / 1 second(s)
//            // therefore time(s) * 60(f)/1(s) = number of frames(f)
//            
//            var fpsComp = dt * 60.0;
//            
//            var distance = ccpMult(this._vector, (fpsComp * this._speed));
//            
//            this.setPosition(ccAdd(this._ccPosition, distance));
//        }
//    },
//    
//    // override this function
//    collidedWith : function(actor)
//    {
//    }
//});
//exports.ZFBulletWrapper = ZFBulletWrapper;
//
//exports.AlienStageBullet = ZFBulletWrapper.subclass({
//    classname : 'AlienStageBullet',
//    
//    bulletTime : function($super, dt)
//    {
//        $super(dt);
//        this._alienLaser.setPosition(this._ccPosition);
//    },
//    
//    initialize : function()
//    {
//        // FIXME: Check the screen size
//        // Save these values for use elsewhere
//        var mainFrame = CCDirector.winSize();
//        var resolutionWidth = mainFrame._height;
//        
//        this._widthScale = resolutionWidth / 480.0;
//        this._heightScale = this._widthScale;
//        
//        this._alienLaser = null;
//        
//        // TODO: alienLaser type is CCQuadParticleSystem
//        // self.alienLaser = [CCQuadParticleSystem
//        // particleWithFile:@"alienLaser.plist"];
//        // self.alienLaser.scale *= widthScale;
//        
//        // now retained by fightGameScene and nowhere else
//        ZFFightMan.getParent().addChild(this._alienLaser, 1000);
//        SimpleAudioEngine.playEffect(kAlienLaserSFX);
//        
//        // add this somewhere
//        this._speed = 3; // speed == every 1 frame move speed * vector amount
//    },
//    
//    destroy : function()
//    {
//    	// alienLaser is only retained by its parent
//        if(this._alienLaser)
//        { 
//        	if(this._alienLaser.getParent())
//        	{ 
//        		this._alienLaser.getParent().removeChild(this._alienLaser, true);
//        	}
//        	
//        	this._alienLaser = null;
//        } 
//    },
//    
//    collidedWith : function(actor)
//    {
//        // do something to zombie (hurt it?)
//        if (actor._fightData._hitPoints > 0)
//            actor.damage(200);
//        
//        //TODO
//        /*CCQuadParticleSystem *hit = [CCQuadParticleSystem particleWithFile:@"alienLaserHit.plist"];
//        hit.position = self.position;
//        hit.scale *= widthScale;
//        hit.autoRemoveOnFinish = YES;*/
//
//        SimpleAudioEngine.playEffect("./Content/stun.wav");
//        
//        // add to the fightGameScene
//        ZFFightMan.getParent().addChild(hit, 2000);
//        
//        // have tick: function clean up bodies
//        this._active = false;
//    }
//});

exports.ZFFightPhysics = CCNode.singleton({
    classname : 'ZFFightPhysics',
    
    TagSprite : {
        kTagSpriteProjectile : 1,
        kTagSpriteBonkEffects : 2,
        kTagSpriteWall : 3
    },
    
    MovementType:{
    	box : 1,
    	laser : 2,
    	fire : 3
    },
    
    fightPhysics : function()
    {
//    	if(widthScale)		
//    		this._widthScale=widthScale;
//    	else
//    		this._widthScale=1;
//    	if (heightScale)
//    		this._heightScale=heightScale;
//    	else
//    		this._heightScale=1;
    	
    	this._projectiles   = [];
//      this._rezzedZombies = [];
      
    	this._initTick=false;
	    return this;
    },
    
    initialize : function()
    {
        //FIXME: Check screen resolution
//        this._bullets	    = [];
        
    },
    
    
    destroy : function()
    {
        this.cleanupLocal();
        
        
        
        //FIXME: Check for delete in original code
//        this._world.destroy();
//        this._world = null;
//        this._listener = null;
    },
    
    cleanupLocal : function()
    {
//        for ( var i = 0; i < this._world.getBodyCount(); ++i )
//        {
//            var b = this._world.getBody(i);
//            this._world.removeBody(b);
//            b.destroy();
//        }

    	if(this._projectiles){
	    	var length = this._projectiles.length;
	    	for ( var i = length-1; i >= 0; i--)
	        {
	    		if(this._projectiles[i]){
		            this._projectiles[i].destroy();
		            this._projectiles.splice( i, 1 );
	    	    }
	        }
	    	this._projectiles.length = 0;
	    	this._projectiles = null;
    	}	
        
//        this._rezzedZombies.length = 0;
        this._initTick = false;
        this.unschedule(this.tick);
        this.unschedule(this.throwAnObject);
        this.unschedule(this.summonWall);
        
        var fm = ZFFightMan;
        if(fm._wall){
        	fm._wall.cleanWall();
            if(fm._wall.getParent())
            	fm._wall.getParent().removeChild(fm._wall);
			destroyWithChildren(fm._wall);
			fm._wall = null;
		}
        
        if (this._bullets)
        {
            this._bullets.length = 0;
            this._bullets = null;
        }
        
        if (this._rezzedZombies)
        {
            this._rezzedZombies.length = 0;
            this._rezzedZombies = null;
        }
    },
    
    initTick : function ()
    {
    	if(!this._projectiles)
    		this._projectiles   = [];
    	
    	if (this._initTick)
    		return;
    	
    	this.schedule(this.tick, 0, "tick");
    	this._initTick = true;
    },
    
    tick : function(dt) //ccTime
    {
        //FIXME: This may have to be moved to the world setup with a fixed time
//        this._world.setTimeStep(dt);
        
        var fm = ZFFightMan;
        var length = this._projectiles.length;
        
        for ( var i = length-1; i >= 0; i--)
        {
        	var bw = this._projectiles[i];
        	
        	bw.update(dt);
        	if(bw._finished)
        	{
        		this._projectiles.splice( i, 1 );
        		bw = null;
        	}
        }

        
        if(fm._wall){
        	if (fm._wall._hitPoints <= 0)
    		{		
        		if(fm._wall){
                	fm._wall.cleanWall();
    	            if(fm._wall.getParent())
    	            	fm._wall.getParent().removeChild(fm._wall);
        			destroyWithChildren(fm._wall);
        			fm._wall = null;
        		}
    		}
        }
    },

    summonWall : function(dt) /*ccTime*/
    {
    	var fm = ZFFightMan;
        this.unschedule(this.summonWall);
        
        if (!fm._currentBossAction)
        {
            return;
        }
        
        var actionName = fm._currentBossAction["name"];
        
        if (!(actionName == "wall"))
        {
            return;
        }
        
        var p = ccp(200 * this._widthScale + Math.random() * 100 * this._widthScale, 0* this._widthScale);
        
        //Set up sprite
        var fileName = fm._currentBossAction["sprite"];
        var spriteSize = fm._currentBossAction["spriteSize"];
        var collisionSize = fm._currentBossAction["collisionSize"];
        var sprite = (spriteSize > 0) ? CCSprite.spriteWithFile(fileName, CGRectMake(0, 0, spriteSize, spriteSize),ccp(0.5,1)) : CCSprite.spriteWithFile(fileName,ccp(0.5,1));
        
        spriteSize *= this._widthScale;
        collisionSize *= this._widthScale;
        
        fm.getParent().addChild(sprite, 103, this.TagSprite.kTagSpriteWall);
//        sprite.setAnchorPoint = ccp(0.5, 0.0);
        sprite.setScale(0, 0);
        
        var actionTo = CCScaleTo.actionWithDuration(1, 1.0 * this._widthScale);
        sprite.runAction(actionTo);
        
        sprite.setPosition(p);
        
        fm._wall = new ZFFightWall();
        fm._wall._widthScale = this._widthScale; //float
        fm._wall._heightScale = this._heightScale; 
        fm._wall.setContentSize(CGSizeMake(collisionSize, spriteSize));
        fm._wall.setTarget();
        fm.getParent().addChild(fm._wall, 100);
        fm._wall.setPosition(ccpAdd(p, ccp(-collisionSize / 2, 0)));
        fm._wall._sprite = sprite;
        fm._wall._hitPoints = fm._currentBossAction["hp"];
        fm._wall._maxHitPoints = fm._currentBossAction["hp"];
        this.initTick();
    },
    
    /*Sprite(Object image), Actor(Target), Origin, Kind of movement, damage, Collision time, */
    throwAnObject : function(sprite, target, origin, movement, damage, collisionTime) /*ccTime*/
    {
    	if(!this._projectiles)
    		this._projectiles   = [];
    	
        this.unschedule(this.throwAnObject);
        
        if (!target){
            return;
        }
    
//        if (!fm._currentBossAction){
//            return;
//        }
        
        var object = null; 
        var z = 0;
        switch(movement){
        	case this.MovementType.box:
        		object = new ZFBox();
        		z = 103;
        		SimpleAudioEngine.playEffect(kThrowSFX);
        		break;
        	case this.MovementType.laser:
        		object = new ZFLaser();
        		z = 2000;
        		SimpleAudioEngine.playEffect(kAlienLaserSFX);
        		break;
        	case this.MovementType.fire:
        		object = new ZFFire();
        		break;
        }
        
//        bw._projectile = projectile;
        
        object.setTarget(target, this._widthScale);
        object.setSprite(sprite, z);
        object._damageAmount = damage;
        object._direction=-1;
        if(collisionTime)
        	object._collisionTime = collisionTime;

        object.setInitialPosition(origin);
    	
        this._projectiles.push(object);
        
        this.initTick(); 
//        fm._currentBossAction = null;
    },

    turnOffCollision : function(bw)
    {
        for (var i = 0; i < bw._b.getShapeCount(); ++i)
        {
            var f = bw._b.getShape(i);
            f.setCategoryBits(0x0000);
        }
    },
    
    //- (void)destroyProjectile:(ZFBodyWrapper*)bw
    destroyProjectile : function(bw)
    {
        if (bw && bw._b)
        {
            var s = bw._b.getGL2Node();
            this.getParent().RemoveChild(s, true);
            this._world.removeBody(bw._b);
            bw._b.destroy();
            bw_.b = null;
            this._projectiles.splice(this._projectiles.indexOf(bw), 1);
            bw = null;
        }
    },
    
    //- (void)destroyWall:(ZFFightWall*)wall
    destroyWall : function(wall)
    {
        this._world.removeBody(wall.getGL2Node());
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/AlienStageActor/AlienStageActor'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/AlienStageActor/AlienStageActor'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/AlienStageActor/AlienStageActor'] = exports; exports.AlienStageActor = CivilianActorFight.subclass({
	classname : 'AlienStageActor',

	initialize : function() {
		this._extraSpriteDictionary = {}; // dictionary
		this._bossShipFront = null; // CCSprite
		this._bossShipBack = null; // CCSprite
	},

	createBullet : function() {
		var offset = ccp(0, 0);
		if (Math.random() >= 0.5) {
			offset = ccp(5, -5);
		} else {
			offset = ccp(-120, 5);
		}

		var origin = ccpAdd(this.getPosition(), offset);
		(ZFFightMan).shootBullet(ZFFightMan.bulletTypes.kBulletTypeAlien, origin);
	},

	initActorSpecificData : function($super) {
		$super();
		this._spriteFileName = "AlienStage.png";
		this._type = kActorTypeCivilian;
		this._state = kActorFightStateWait;
	},

	initSpriteDictionary : function() {
		this._spriteDictionary = DataPreloader._alienStageData;
		this._extraSpriteDictionary = DataPreloader._alienStageElementsData;
		this._spriteFileName = "AlienStage.png";
	},

	initSprite : function($super) {
		$super();
		this._spriteMan.setScale(1.0);
	},

	startAnim : function(animID, interrupt) {
		return;
		if (!this._attachments || this._attachments.length <= 0) {
			return;
		}

		var foot1 = this._attachments[kActorPartTagFootF];
		var foot2 = this._attachments[kActorPartTagFootB];
		var body = this._attachments[kActorPartTagBody];
		var head = this._attachments[kActorPartTagHead];

		var asc = this.getFightAttackSpeed();
		var s = this._animSpeed;
		var f = (head._sprite.flipX()) ? -1 : 1;

		if (interrupt) {
			for ( var key in this._attachments) {
				var a = this._attachments[key];

				if (a == null)
					continue;
				a._sprite.stopAllActions();
				a.stopAllActions();
			}
		}

		if (animID != kActorAnimVictory) {
			this.resetColor();
			this.resetAttachmentScaleInterpolate(true);
			this.resetAttachmentPositionsInterpolate(true);
			this.resetAttachmentRotationInterpolate(true);
		}

		switch (animID) {
		case kActorAnimIdle: {

			if (this instanceof AlienStageActorBoss) {

				if (this._bossShipFront) {
					var act1 = CCMoveTo.actionWithDuration(0.5, ccp(0, -10));
					var act2 = CCMoveTo.actionWithDuration(0.5, ccp(0, 10));

					var seq = CCSequence.actions([ act1, act2, null ]);
					body.loop(seq);

				} else {

				}
			}

			if (this instanceof AlienStageActorMinion) {

			}

		}
			break;

		case kActorAnimWalk: {
			if (this instanceof AlienStageActorBoss) {
				body.loop(ZFAnims.bodyWalkMove(s));
				foot1.loop(ZFAnims.footWalkFrontMove(s));
				foot2.loop(ZFAnims.footWalkBackMove(s));
				foot1.loop(ZFAnims.footWalkFrontRotate(s, f));

			}

			if (this instanceof AlienStageActorMinion) {
				body.loop(ZFAnims.bodyWalkMove(s));
				foot1.loop(ZFAnims.footWalkFrontMove(s));
				foot2.loop(ZFAnims.footWalkBackMove(s));
				foot1.loop(ZFAnims.footWalkFrontRotate(s, f));
			}
		}
			break;

		case kActorAnimAttack: {
			// all attacks pulled from attack anim class
			this._fightData._attacking = true;
			if (!this.isScheduled(this.doneAttacking)) {
				this.schedule(this.doneAttacking, asc);
			}

			var attackAnimID = this._fightData._currentAttackVariation["animID"];
			ZFAttackAnims.performAttackWithID(attackAnimID, this);
		}
			break;

		}
	},

	destroy : function() {
		if (this._extraSpriteDictionary) {
			this._extraSpriteDictionary = null;
		}
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/AlienStageActor/AlienStageActorBoss'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/AlienStageActor/AlienStageActorBoss'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/AlienStageActor/AlienStageActorBoss'] = exports; exports.AlienStageActorBoss = AlienStageActor.subclass
({
	classname : 'AlienStageActorBoss',
	
	initialize : function()
	{
		this._bossShipFront = null; //CCSprite
		this._bossShipBack = null; //CCSprite
	},
	
	initSprite : function($super)
	{
		$super();
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmF, this._spriteDictionary["bossArmF.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmB, this._spriteDictionary["bossArmB.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFootF, this._spriteDictionary["bossFootF.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFootB, this._spriteDictionary["bossFootB.png"]);
		
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagBody, this._spriteDictionary["bossBody.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagHead, this._spriteDictionary["bossFace.png"]);
		
//		var armF = this._attachments[kActorPartTagArmF];
//		var armB = this._attachments[kActorPartTagArmB];
//		var footF = this._attachments[kActorPartTagFootF];
//		var footB = this._attachments[kActorPartTagFootB];
//		var body = this._attachments[kActorPartTagBody];
//		var head = this._attachments[kActorPartTagHead];
//		
//		body.addBone(head);
//		body.addBone(armF);
//		body.addBone(armB);
//		body.addBone(footF);
//		body.addBone(footB);
		
		this._bossShipFront = this.spriteFromPlist_withFile(this._extraSpriteDictionary["bossShip.png"], "AlienStageElements.png");		
		this._bossShipBack = this.spriteFromPlist_withFile(this._extraSpriteDictionary["bossShipBack.png"], "AlienStageElements.png");
		
		this._bossShipFront.setScale( 2);
		this._bossShipBack.setScale( 2);
		
		this._spriteMan.setScale( 0.58 );
	},
//	
	bossUpdate : function($super, dt)
	{
		
		if(this._state == kActorFightStateBossWait)
		{
			if(this._bossShipFront && !this._bossShipFront._parent)
			{
				this._spriteMan.getParent().addChild(this._bossShipFront,this._spriteMan._zOrder+1);
				this._bossShipFront.setPosition(this.getPosition());
			}
			
			if(this._bossShipBack && !this._bossShipBack._parent)
			{
				this._spriteMan.getParent().addChild(this._bossShipBack, 0);
				this._bossShipBack.setPosition(this.getPosition());
			}
		}
		
		return $super(dt);

	},
	
	movementUpdate : function($super, dt){
		$super(dt);
		var body = this._attachments[kActorPartTagBody];
		var bodyPosition = ccp(body.getPosition()._x, body.getPosition()._y+60);
		
		if(this._bossShipFront)
		{
			this._bossShipFront.setPosition( ccpAdd(this.getPosition(),bodyPosition));
		}
		if(this._bossShipBack)
		{
			this._bossShipBack.setPosition( ccpAdd(this.getPosition(),bodyPosition));
		}
	},
	
	initActorSpecificAbilities : function(){
		//clear the list
		if(this._abilityList)
		{
			this._abilityList.length = 0;
			this._abilityList = null;
			
			this._abilityList = new Array();
			var ability;
			ability = new ZFActorFightEffect();
			ability.initWithTag(kFightEffectEnemyBuffEnrage);
			this._abilityList.push(ability);
			ability._unlocked = true;	
		}
	},
	
	destroy : function(){
		if(this._bossShipFront)
		{
			if(this._bossShipFront.getParent())
				this._bossShipFront.getParent().removeChild(this._bossShipFront, true);
			destroyWithChildern(this._bossShipFront);
			this._bossShipFront = null;
		}
		if(this._bossShipBack)
		{
			if(this._bossShipBack.getParent())
				this._bossShipBack.getParent().removeChild(this._bossShipBack, true);
			destroyWithChildern(this._bossShipBack);
			this._bossShipBack = null;
		}
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/AlienStageActor/AlienStageActorMinion'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/AlienStageActor/AlienStageActorMinion'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/AlienStageActor/AlienStageActorMinion'] = exports; exports.AlienStageActorMinion = AlienStageActor.subclass
({
	classname : 'AlienStageActorMinion',
	
	initialize : function()
	{
		
	},
	
	colorFromSubType : function(actorSubType)
	{
		return this._savedColor;
	},
	
	initSprite : function($super)
	{
		$super();
		
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmF, this._spriteDictionary["minionArmF.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmB, this._spriteDictionary["minionArmB.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFootF, this._spriteDictionary["minionFootF.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFootB, this._spriteDictionary["minionFootB.png"]);
		
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagBody, this._spriteDictionary["minionBody.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagCollar, this._spriteDictionary["minionBodyDetail.png"]);
		
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagHead, this._spriteDictionary["minionHead.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFeatures, this._spriteDictionary["minionFace.png"]);
		
		var armF = this._attachments[kActorPartTagArmF];
		var armB = this._attachments[kActorPartTagArmB];
		var footF = this._attachments[kActorPartTagFootF];
		var footB = this._attachments[kActorPartTagFootB];
		var body = this._attachments[kActorPartTagBody];
		var head = this._attachments[kActorPartTagHead];
		
		var feature = this._attachments[kActorPartTagFeatures];
		feature._inheritColor = false;
		var bodyDetail = this._attachments[kActorPartTagCollar];
		bodyDetail._inheritColor = false;
		
		body.addBone(head);
		body.addBone(armF);
		body.addBone(armB);
		body.addBone(footF);
		body.addBone(footB);
		
		head.addBone(feature);
		body.addBone(bodyDetail);
		
		this._spriteMan.setScale( 0.58 );
	},
	
	destroy : function()
	{
		
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/BeachStageActor/BeachStageActor'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/BeachStageActor/BeachStageActor'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/BeachStageActor/BeachStageActor'] = exports; exports.BeachStageActor = CivilianActorFight.subclass({
	classname : 'BeachStageActor',

	initialize : function() {

	},

	beachCrabStates : {
		kCrabStateWander : 0, //0
		kCrabStateGrabbedZombie : 1, //1
		kCrabStateRunAway : 2, //2
		kCrabStateRunningAway : 3, //3
		kCrabStateRanAway : 4, //4
		kCrabStateTapped : 5, //5
		kCrabStatePop : 6, //6	
		kCrabStateThink : 7, //7
		kCrabStateWandering : 8, //8
		kCrabStateThinking : 9, //9
		kCrabStateRanAwayWithZombie : 10
	//10
	},

	initActorSpecificData : function($super) {
		$super();
		this._spriteFileName = "BeachStage.png";
		this._type = kActorTypeCivilian;
		this._state = kActorFightStateWait;
	},

	initSpriteDictionary : function() {
		this._spriteFrameFile = "BeachStage.plist.json";
		this._skeletonDictionary = DataPreloader._beachStageData;
	},

	initSprite : function($super) {
		$super();
		this._spriteMan.setScale(1.0);
	},

	startAnim : function(animID, interrupt) {
		var fm = ZFFightMan;

		if (!this._attachments || this._attachments.length <= 0) {
			return;
		}

		var arm1 = this._attachments[kActorPartTagArmF];
		var fist1 = this._attachments[kActorPartTagFistF];
		var arm2 = this._attachments[kActorPartTagArmB];
		var fist2 = this._attachments[kActorPartTagFistB];
		var foot1 = this._attachments[kActorPartTagFootF];
		var foot2 = this._attachments[kActorPartTagFootB];
		var body = this._attachments[kActorPartTagBody];
		var head = this._attachments[kActorPartTagHead];

		var asc = this.getFightAttackSpeed();
		var s = this._animSpeed;
		var f = (head._sprite.flipX()) ? -1 : 1;

		if (interrupt) {
			for ( var key in this._attachments) {
				var a = this._attachments[key];

				if (a == null)
					continue;

				a._sprite.stopAllActions();
				a.stopAllActions();
			}
		}

		if (animID != kActorAnimVictory) {
			// stops animation when finished by reseting to defaults
			this.resetColor();
			this.resetAttachmentScaleInterpolate(true);
			this.resetAttachmentPositionsInterpolate(true);
			this.resetAttachmentRotationInterpolate(true);
		}

		switch (animID) {
		case kActorAnimIdle: {

			if (this instanceof BeachStageActorBoss) {
				var act1 = CCRotateTo.actionWithDuration(s * 0.2, f * -10);
				var act2 = CCRotateTo.actionWithDuration(s * 0.2, f * 0);

				var actionArray = new Array();
				actionArray = [ act1, act2, null ];

				var seq = CCSequence.actions(actionArray);
				body.loopS(seq);
			}
			if (this instanceof BeachStageActorMinion1) {
				var act1 = CCRotateTo.actionWithDuration(s * 0.25, f * 5);
				var act2 = CCRotateTo.actionWithDuration(s * 0.50, f * -5);
				var act3 = CCRotateTo.actionWithDuration(s * 0.25, f * 0);

				var seq = CCSequence.actions([ act1, act2, act3, null ]);
				body.loopS(seq);

				var bodyBreath = ZFAnims.bodyBreatheScale(2, body.getScale());
				body.loopS(bodyBreath);

				act1 = CCRotateTo.actionWithDuration(s * 0.25, f * 5);
				act2 = CCRotateTo.actionWithDuration(s * 0.5, f * -5);
				act3 = CCRotateTo.actionWithDuration(s * 0.25, f * 0);

				seq = CCSequence.actions([ act1, act2, act3, null ]);
				arm2.loopS(seq);

				act1 = CCRotateTo.actionWithDuration(s * 0.25, f * 25);
				act2 = CCRotateTo.actionWithDuration(s * 0.5, f * 5);
				act3 = CCRotateTo.actionWithDuration(s * 0.25, f * 20);

				seq = CCSequence.actions([ act1, act2, act3, null ]);
				fist2.loopS(seq);

				act1 = CCRotateTo.actionWithDuration(s * 0.25, f * -5);
				act2 = CCRotateTo.actionWithDuration(s * 0.5, f * 5);
				act3 = CCRotateTo.actionWithDuration(s * 0.25, f * 0);

				seq = CCSequence.actions([ act1, act2, act3, null ]);
				arm1.loopS(seq);

				act1 = CCRotateTo.actionWithDuration(s * 0.25, f * 5);
				act2 = CCRotateTo.actionWithDuration(s * 0.5, f * 15);
				act3 = CCRotateTo.actionWithDuration(s * 0.25, f * 10);

				seq = CCSequence.actions([ act1, act2, act3, null ]);
				fist1.loopS(seq);
			}
			if (this instanceof BeachStageActorMinion2) {

				var act1 = CCRotateTo.actionWithDuration(s * 0.25, f * 5);
				var act2 = CCRotateTo.actionWithDuration(s * 0.50, f * -5);
				var act3 = CCRotateTo.actionWithDuration(s * 0.25, f * 0);

				var seq = CCSequence.actions([ act1, act2, act3, null ]);
				body.loopS(seq);

				var bodyBreath = ZFAnims.bodyBreatheScale(2, body.getScale());
				body.loopS(bodyBreath);

				act1 = CCRotateTo.actionWithDuration(s * 0.25, f * -5);
				act2 = CCRotateTo.actionWithDuration(s * 0.5, f * 5);
				act3 = CCRotateTo.actionWithDuration(s * 0.25, f * 0);

				seq = CCSequence.actions([ act1, act2, act3, null ]);
				arm1.loopS(seq);

				act1 = CCRotateTo.actionWithDuration(s * 0.25, f * 5);
				act2 = CCRotateTo.actionWithDuration(s * 0.5, f * 15);
				act3 = CCRotateTo.actionWithDuration(s * 0.25, f * 10);

				seq = CCSequence.actions([ act1, act2, act3, null ]);
				fist1.loopS(seq);
			}

		}
			break;

		case kActorAnimWalk: {
			if (this instanceof BeachStageActorBoss) {
				// SquiDude doesn't walk
			}
			if (this instanceof BeachStageActorMinion1) {

				var act1 = CCRotateTo.actionWithDuration(s * 0.1, f * 60);
				var act2 = CCRotateTo.actionWithDuration(s * 0.1, f * 60);
				var act3 = null;

				fist1.loopS(act1);
				fist2.loopS(act2);

				act1 = CCRotateTo.actionWithDuration(s * 0.25, f * 6);
				act2 = CCRotateTo.actionWithDuration(s * 0.6, f * -5);
				act3 = CCRotateTo.actionWithDuration(s * 0.25, f * 0);

				var seq = CCSequence.actions([ act1, act2, act3, null ]);
				body.loopS(seq);

				act1 = CCRotateTo.actionWithDuration(s * 0.25, f * 0);
				act2 = CCRotateTo.actionWithDuration(s * 0.25, f * 0);
				act3 = CCRotateTo.actionWithDuration(s * 0.25, f * -45);
				var act4 = CCRotateTo.actionWithDuration(s * 0.25, f * 0);

				seq = CCSequence.actions([ act1, act2, act3, act4, null ]);
				foot1.loopS(seq);

				act1 = CCRotateTo.actionWithDuration(s * 0.25, f * 45);
				act2 = CCRotateTo.actionWithDuration(s * 0.25, f * 0);
				act3 = CCRotateTo.actionWithDuration(s * 0.25, f * 0);
				act4 = CCRotateTo.actionWithDuration(s * 0.25, f * 0);

				seq = CCSequence.actions([ act1, act2, act3, act4, null ]);
				foot2.loopS(seq);
			}
			if (this instanceof BeachStageActorMinion2) {
				var act1 = CCRotateTo.actionWithDuration(s * 0.25, f * -5);
				var act2 = CCRotateTo.actionWithDuration(s * 0.50, f * 5);
				var act3 = CCRotateTo.actionWithDuration(s * 0.25, f * 0);
				var act4 = null;

				var seq = CCSequence.actions([ act1, act2, act3, null ]);
				arm1.loopS(seq);

				act1 = CCRotateTo.actionWithDuration(s * 0.25, f * 5);
				act2 = CCRotateTo.actionWithDuration(s * 0.50, f * -5);
				act3 = CCRotateTo.actionWithDuration(s * 0.25, f * 0);

				seq = CCSequence.actions([ act1, act2, act3, null ]);
				body.loopS(seq);

				act1 = CCRotateTo.actionWithDuration(s * 0.25, f * -45);
				act2 = CCRotateTo.actionWithDuration(s * 0.25, f * 0);
				act3 = CCRotateTo.actionWithDuration(s * 0.25, f * 0);
				act4 = CCRotateTo.actionWithDuration(s * 0.25, f * 0);

				seq = CCSequence.actions([ act1, act2, act3, act4, null ]);
				foot1.loopS(seq);

				act1 = CCRotateTo.actionWithDuration(s * 0.25, f * 0);
				act2 = CCRotateTo.actionWithDuration(s * 0.25, f * 0);
				act3 = CCRotateTo.actionWithDuration(s * 0.25, f * -45);
				act4 = CCRotateTo.actionWithDuration(s * 0.25, f * 0);

				seq = CCSequence.actions([ act1, act2, act3, act4, null ]);
				foot2.loopS(seq);
			}
		}
			break;

		case kActorAnimAttack: {
			// all attacks pulled from attack anim class
			this._fightData._attacking = true;
			if (!this.isScheduled(this.doneAttacking)) {
				this.schedule(this.doneAttacking, asc);
			}
			var attackAnimID = this._fightData.currentAttackVariation["animID"];
			ZFAttackAnims.performAttackWithID(attackAnimID, this);
		}
			break;

		case kActorAnimThrow: {
			throwSpeedFromSheet = fm._enemyDictionary["throwSpeed"];
			var throwSpeed = throwSpeedFromSheet ? throwSpeedFromSheet : 1.0;
			throwSpeed = throwSpeed * 2.0 / 3.0;
			throwSpeed = (throwSpeed > 1) ? 1 : throwSpeed;

			var act1 = CCRotateTo.actionWithDuration(throwSpeed * 0.2, f * -270);
			var act2 = CCRotateBy.actionWithDuration(throwSpeed * 0.45, f * -90);

			var seq = CCSequence.actions([ act1, act2, null ]);
			arm1.onceS(seq);
			SimpleAudioEngine.playEffect(kThrowSFX);
		}
			break;
		}
	},

	destroy : function() {

	}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/BeachStageActor/BeachStageActorBoss'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/BeachStageActor/BeachStageActorBoss'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/BeachStageActor/BeachStageActorBoss'] = exports; exports.BeachStageActorBoss = BeachStageActor.subclass
({
	classname : 'BeachStageActorBoss',
	
	initialize : function()
	{
		this._wave = null; //CCSprite
		this._waveOffset = null; //CGPoint
	},
	
	initSprite : function($super)
	{
		$super();
		this._savedColor = this.ccc3(0xff,0xff,0xff);
		this._frameOffset = this.ccp(-15,40);
		
		var armF = this.addAttachment(kActorPartTagArmF, "beach_boss_arm_back.png");
		var footF = this.addAttachment(kActorPartTagFootF, "beach_boss_arm_front.png");
		
		var body  = this.addAttachment(kActorPartTagBody, "beach_boss_body.png"); 
		var footB = this.addAttachment(kActorPartTagFootB, "beach_boss_surfboard.png");  
		
		body.addBone(footF);
		body.addBone(footB);
		body.addBone(armF);
		
		
		this._waveOffset = this.ccpAdd(this._frameOffset, this.ccp(-65,-155));
		this._wave = CCSprite.spriteWithFile("beach_wave.png");
		this._wave._anchorPoint = this.ccp(0,0);
		
		this._spriteMan.setScale(1.0/1.25);
	},
	
	initFightDataAfterLoad : function($super)
	{
		$super();
		this._fightData._lifeBarOffset = this.ccp(0,70);
	},
	
	jumpActionDone : function()
	{
		this.setState(kActorFightStateGo);
	},
	
	bossUpdate : function($super, dt)
	{
		
		if (this._state == kActorFightStateBossGoDown)
		{
			var act1 = CCMoveTo.actionWithDuration(0.5, this.ccp(this.getPosition()._x + (this.getPosition()._x - ZFGameDefines.ENEMY_POSITION_X) /2, this.getPosition()._y + 25));
			var act2 = CCMoveTo.actionWithDuration(0.5, this.ccp(ZFGameDefines.ENEMY_POSITION_X,ZFGameDefines.ENEMY_POSITION_Y));
			var act3 = CCCallFunc.actionWithTarget(this, this.jumpActionDone.bind(this));
			
			var actionArray = new Array();
			actionArray = [act1,act2,act3,null];
			
			var seq = CCSequence.actions(actionArray);
			this.runAction(seq);
			
			if(this._wave)
			{
				this._wave.stopAllActions();
			}
			
			this.setState(kActorFightStateBossJumpingDown);
		}
		
		if(this._state == kActorFightStateBossJumpingDown)
		{
			this._wave.setPosition( this.ccpAdd(this.getPosition(), this.ccp(this._waveOffset._x, this._waveOffset._y - 10)) );
		}
		
		if(this._state == kActorFightStateGo)
		{
			var fm = ZFFightMan;
			
			for (var z in fm._zombies)
			{
				if ( z.isInMeleeRange() )
				{
					z.knockBackBy(-260,8);
				}
			}
			
//			TODO: Wait for CCQuadParticleSystem particleWithFileimplementation
//			var splashBase = CCQuadParticleSystem.particleWithFile("beachSplashBase.plist");
//			splashBase._autoRemoveOnFinish = true;
//			splashBase.setPosition(this.ccp(ZFGameDefines.ENEMY_POSITION_X, ZFGameDefines.ENEMY_POSITION_Y));
//			splashBase.setScale(this.getScale() * this._widthScale);
			
//			this._spriteMan.getParent().addChild(splashBase, this._spriteMan._zOrder + 2);
			
			if(this._wave)
			{
				this._wave.removeFromParentAndCleanup(true);
				this._wave = null;
			}
		}
		
		else if(this._state == kActorFightStateBossWait)
		{		
			if(this._wave && !this._wave._parent)
			{			
				this._spriteMan._parent.addChild(this._wave, this._spriteMan._zOrder-1);
				var wavePosition = ccpAdd(this.getPosition(), this._waveOffset);
				wave.setPosition(wavePosition);
				
				var act1 = CCScaleTo.actionWithDuration(this._animSpeed * 0.2, 1.015, 1.03);
				var act2 = CCScaleTo.actionWithDuration(this._animSpeed * 0.2, 1.0, 1);
				
				var actionArray = new Array();
				actionArray = [act1, act2, null];
				
				var seq = CCSequence.actions(actionArray);
				var rep = CCRepeatForever.actionWithAction(seq);
				
				this._wave.runAction(rep);
			}		
		}
		
		return $super(dt);
	},
	
	movementUpdate : function($super, dt)
	{
		$super(dt);
	},
	
	initActorSpecificAbilities : function() 
	{
		if(this._abilityList)
		{
			this._abilityList.length = 0;
			this._abilityList = null;

			this._abilityList = new Array();
		}
		
		var ability;
		ability = new ZFActorFightEffect();
		ability.initWithTag(kFightEffectEnemyBuffEnrage);
		this._abilityList.push(ability);
		ability._unlocked = true;	// like a boss	
	},
	
	destroy : function()
	{
		if(this._wave)
		{
			this._wave.removeFromParentAndCleanup(true);
			
			this._wave = null;
		}
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/BeachStageActor/BeachStageActorCrab'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/BeachStageActor/BeachStageActorCrab'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/BeachStageActor/BeachStageActorCrab'] = exports; exports.BeachStageActorCrab = BeachStageActor.subclass
({
	classname : 'BeachStageActorCrab',
	
	initialize : function()
	{
		this._hitBox = null; // ActorHitBox
		this._grabbedZombie = null; // Actor
		this._movementParticle = null; //CCQuadParticleSystem
	}, 
	
	colorFromSubType : function (actorSubType)
	{
		return this._savedColor;
	},
	
	initFightDataAfterLoad : function($super)
	{
		$super();
		
		if(this._spriteMan)
		{
			this._spriteMan._parent.reorderChild(this._spriteMan,100);
		}
		this._hitBox = null;
		this._collisionBoxSize = CGSizeMake(2.0,100.0);
		this.setState(beachCrabStates.kCrabStatePop);
	},
	
	initSprite : function($super)
	{
		$super();
		this._savedColor = this.ccc3(0xff,0xff,0xff);
		this._frameOffset = this.ccp(0,20);

		this._movementParticle = null;
		this.addAttachment(kActorPartTagBody, "beach_crab.png");
		this._spriteMan.setScale(1.0/1.25);
	},
	
	despawn : function($super)
	{
		if (this._hitBox)
		{
			this._hitBox.cleanupHitBox();
			this._hitBox = null;
		}
		
		$super();
	},

	hitBoxTouched : function() 
	{
		this.damage(100);
		if(this._fightData._hitPoints > 0)
		{
			this.setState(beachCrabStates.kCrabStateTapped);
		} else { 
			this.setState(beachCrabStates.kCrabStateRanAway);
		}
	},
	
	collidedWith : function(object)
	{
		if(!this._collisionEnabled)
			return;
		
		if(!this._grabbedZombie && object instanceof ZombieActor )
		{
			if(object._fightData._hitPoints <= 0)
				return;
			
			if(object._state == kActorFightStateWait ||
					   object._state == kActorFightStatePrepStart ||
					   object._state == kActorFightStatePrepCycle ||
					   object._state == kActorFightStateStunned ||
					   object._state == kActorFightStateEnterScene)
						return;
		}
		
		object._fightData._knockBackPoint = this.ccp(0,0);
		
		this.stopAllActions();
		this._destinationPoint = this.getPosition();
		this._grabbedZombie = object;
		this.setState(beachCrabStates.kCrabStateGrabbedZombie);
		this._grabbedZombie.setState(kActorFightStateGrabbed);
		
		this._gragrabbedZombie._spriteMan.getParent().reorderChild(this._grabbedZombie._spriteMan, this._spriteMan._zOrder-1 );
		this._collisionEnabled = false;
	},
	
	update : function(dt)
	{
		var fm = ZFFightMan;
		if(this._hitBox)
		{
			var body = this._attachments[kActorPartTagBody];
			var placeHere = ccpAdd(this.getPosition(), body._offsetFromRefPoint);			
			placeHere = ccpAdd(placeHere, this._hitBox._actorSpecificOffset);			
			var facing = (body._sprite.flipX())? -1 : 1;			
			this._hitBox.setPosition(ccpAdd(placeHere,this. ccp(facing * this._hitBox._offset._x, this._hitBox._offset._y)));
		}
		
		if(this._grabbedZombie)
		{
			this._grabbedZombie._destinationPoint = this._grabbedZombie._position = ccpAdd(this.getPosition(),this._frameOffset);
		}
		
		if(this._state == beachCrabStates.kCrabStateWander || this._state == beachCrabStates.kCrabStateRunningAway)
		{
			if(!this._movementParticle)
			{
				this._movementParticle = CCQuadParticleSystem.particleWithFile("beachCrabMoveParticles.plist");
				this._movementParticle.setPosition(this.getPosition());
				this._movementParticle.setScale( this._movementParticle.getScale() * this._widthScale );
				
				this._spriteMan._parent.addChild(this._movementParticle, this._spriteMan._zOrder + 1 );
			}
			else 
			{
				this._movementParticle.setPosition(this.getPosition());
			}
		}
		else 
		{
			if(this._movementParticle)
			{
				this._movementParticle.removeFromParentAndCleanup(true);
				this._movementParticle = null;
			}
		}
		
		if( fm.isGameWon() || fm.isGameLost() )
		{
			this.setState(beachCrabStates.kCrabStateRanAway);
		}
		
		switch(this._state)
		{
			case beachCrabStates.kCrabStateThink:
			{			
				this._destinationPoint = this.getPosition();
				var time = Math.random() * 3 + 1;
				
				this.stopAllActions();
				
				var act1 = CCDelayTime.actionWithDuration(time);
				var act2 = CCCallFuncND.actionWithTarget(this, this.callSetState.bind(this, beachCrabStates.kCrabStateWandering));
				
				var actionArray = new Array();
				actionArray = [act1, act2, null];
				
				var seq = CCSequence.actions(actionArray);
				this.runAction(seq);
				
				this.setState(beachCrabStates.kCrabStateThinking);
			}
			case beachCrabStates.kCrabStateThinking:
			{
				// do nothing, just wait for state change to be set
			}
				break;
				
			case beachCrabStates.kCrabStateWandering:
			{
				// define an area for the crab to move around
				var w = new Core.Size(UI.Window._height, UI.Window._width);
				var xBoundaryRight = ZFDefines.ENEMY_POSITION_X;
				var xBoundaryLeft  = w._width/2 - 100;
				
				var random = Math.random();
				
				var xPosition = random * (xBoundaryRight - xBoundaryLeft) + xBoundaryLeft;
				
				this._destinationPoint = this.ccp(xPosition,0);
				this.setState(beachCrabStates.kCrabStateWander);
			}
				break;
				
			case beachCrabStates.kCrabStateWander:
			{
				if(ccpEqual(this.getPosition(), this._destinationPoint))
				{
					this.setState(beachCrabStates.kCrabStateThink);
				}
			}
				break;
				
			case beachCrabStates.kCrabStateGrabbedZombie:
			{	
				if(this._grabbedZombie)
				{
					this._grabbedZombie._fightData._invincible = true;
					this._grabbedZombie.setState(kActorFightStateGrabbed);
				}
				
				var act1 = CCScaleTo.actionWithDuration(0.1, this._spriteMan.getScale() * 1.2);
				var act2 = CCScaleTo.actionWithDuration(0.25, this._spriteMan.getScale() * 1);
				
				var actionArray = new Array();
				actionArray = [act1, act2, null];
				
				var seq = CCSequence.actions(actionArray);
				this._spriteMan.runAction(seq);
				this.stopAllActions();
				
				act1 = CCDelayTime.actionWithDuration(2);
				act2 = CCCallFuncND.actionWithTarget(this, this.callSetState.bind(this, this.beachCrabStates.kCrabStateRunAway));
				
				actionArray = new Array();
				actionArray = actionArray = [act1, act2, null];
				
				seq = CCSequence.actions(actionArray);
				this.runAction(seq);
				
				this._hitBox = new ActorHitBox();
				
				var body = this._attachments[kActorPartTagBody];
				this._hitBox._attachedTo = body;
				this._hitBox._target = this;
				this.setState(beachCrabStates.kCrabStateThinking);
				
				var placeHere = ccpAdd(this.getPosition(), body._offsetFromRefPoint);
				placeHere = ccpAdd(placeHere, this._hitBox._actorSpecificOffset);
				
				var facing = (body._sprite.flipX())? -1 : 1;
				
				this._hitBox.setPosition( ccpAdd(placeHere,ccp(facing * this._hitBox._offset._x,this._hitBox._offset._y)));		

				fm.getParent().addChild(this._hitBox, this._spriteMan._zOrder);
			}
				break;
				
			case beachCrabStates.kCrabStateRunAway:
			{			
				this._destinationPoint = ccp(-100, getPosition()._y);
				this.setState(beachCrabStates.kCrabStateRunningAway);			
			}
				break;
				
			case beachCrabStates.kCrabStateRunningAway:
			{			
				if(ccpEqual(this.getPosition(), this._destinationPoint))
				{
					this.setState(beachCrabStates.kCrabStateRanAwayWithZombie);
				}
			}
				break;	
				
			case beachCrabStates.kCrabStateRanAwayWithZombie:
			{
				if(this._grabbedZombie)
				{
					this._grabbedZombie.setState(kActorFightStateRanAway);
					this._grabbedZombie = null;
				}
				
				this.setState(beachCrabStates.kCrabStateRanAway);
			}
				break;
				
			case beachCrabStates.kCrabStateRanAway:
			{
				if(this._grabbedZombie)
				{
					this._grabbedZombie._fightData._invincible = false;
					this._grabbedZombie.setState(kActorFightStateGo);
					this._grabbedZombie = null;
				}
				
				fm.stageActors.removeObject(this);
				//TODO: Wait for CCQuadParticleSystem implementation
//				var pop = CCQuadParticleSystem.particleWithFile("beachCrabPopParticles.plist");
//				pop._autoRemoveOnFinish = true;
//				pop.setPosition(this.getPosition());
//				pop.setScale (this.getScale() * this._widthScale );
//				
//				this._spriteMan._parent.addChild(pop,  this._spriteMan._zOrder + 1);
				fm.schedule(this.spawnCrabIn, 3);
				this.despawn();			
			}
				break;
				
			case beachCrabStates.kCrabStateTapped:
			{
				this._destinationPoint = this.getPosition();
				this.stopAllActions();
				
				this._spriteMan.setScale(1.0/1.25);
				
				var act1 = CCDelayTime.actionWithDuration(0.1);
				var act2 = CCCallFuncND.actionWithTarget(this, this.callSetState.bind(this, beachCrabStates.kCrabStateRunAway));
				
				var actionArray = new Array();
				actionArray = [act1, act2, null];
				
				var seq = CCSequence.actions(actionArray);
				this.runAction(seq);
				
				this.setState(this.beachCrabStates.kCrabStateThinking);
			}
				break;
				
			case this.beachCrabStates.kCrabStatePop:
			{
				// perform visual cue
				var w = new Core.Size(UI.Window._height, UI.Window._width);
				
				this._position = this._destinationPoint = ccp(w._width/2 ,0);
				
				// always in front
				this._spriteMan.getParent().reorderChild(this._spriteMan,100 );
				// pop up at a random spot
				var pop = CCQuadParticleSystem.particleWithFile("beachCrabPopParticles.plist");
				pop._autoRemoveOnFinish = true;
				pop.setPosition(this.getPosition());
				pop.setScale(this.getScale() * this._widthScale);
				
				this._spriteMan.getParent().addChild(pop,this._spriteMan._zOrder + 1);
				
				this.setState(this.beachCrabStates.kCrabStateThink);
			}
				break;
		}
		
		this.movementUpdate(dt);	
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/BeachStageActor/BeachStageActorMinion1'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/BeachStageActor/BeachStageActorMinion1'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/BeachStageActor/BeachStageActorMinion1'] = exports; exports.BeachStageActorMinion1 = BeachStageActor.subclass
({
	classname : 'BeachStageActorMinion1',
	
	initialize : function()
	{
		
	},
	
	colorFromSubType : function(actorSubType)
	{
		return this._savedColor;
	},
	
	initSprite : function($super)
	{
		$super();
		
		this._savedColor = this.ccc3(0xff,0xff,0xff);
		this._frameOffset = this.ccp(0,40);
		
		var armF = this.addAttachment(kActorPartTagArmF, "beach_minion01_arm_upper.png");
		var fistF = this.addAttachment(kActorPartTagFistF, "beach_minion01_arm_lower.png");
		var armB = this.addAttachment(kActorPartTagArmB, "beach_minion01_arm_upper_B.png");
		var fistB = this.addAttachment(kActorPartTagFistB, "beach_minion01_arm_lower_B.png");
		var head = this.addAttachment(kActorPartTagHead, "beach_minion01_head.png");
		var body = this.addAttachment(kActorPartTagBody, "beach_minion01_body.png");
		var footB = this.addAttachment(kActorPartTagFootB, "beach_minion01_leg_B.png");
		var footF = this.addAttachment(kActorPartTagFootF, "beach_minion01_leg_F.png");
		
		bodyaddBone(footF);
		body.addBone(footB);
		
		body.addBone(armF);
		body.addBone(armB);
			
		body.addBone(head);
		
		armF.addBone(fistF);
		armB.addBone(fistB);
		
		this._spriteMan.setScale(1.0 / 1.25);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/BeachStageActor/BeachStageActorMinion2'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/BeachStageActor/BeachStageActorMinion2'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/BeachStageActor/BeachStageActorMinion2'] = exports; exports.BeachStageActorMinion2 = BeachStageActor.subclass
({
	classname : 'BeachStageActorMinion2',
	
	initialize : function() 
	{
		
	},
	
	colorFromSubType : function(actorSubType)
	{
		return this._savedColor;
	},
	
	initSprite : function($super)
	{
		$super();
		
		this._savedColor = this.ccc3(0xff,0xff,0xff);
		this._frameOffset = this.ccp(0,40);
		
		var armF = this.addAttachment(kActorPartTagArmF, "beach_minion02_arm_upper.png");
		var fistF = this.addAttachment(kActorPartTagFistF, "beach_minion02_arm_lower.png");
		var head = this.addAttachment(kActorPartTagHead, "beach_minion02_head.png");
		var body = this.addAttachment(kActorPartTagBody, "beach_minion02_body.png");
		var footB = this.addAttachment(kActorPartTagFootB, "beach_minion02_leg_B.png");
		var footF = this.addAttachment(kActorPartTagFootF, "beach_minion02_leg_F.png");
		
		body.addBone(footF);
		body.addBone(footB);
		
		body.addBone(armF);
		
		body.addBone(head);
		
		armF.addBone(fistF);
			 
		this._spriteMan.setScale(1.0/1.25);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/CityStageActor/CityStageActor'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/CityStageActor/CityStageActor'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/CityStageActor/CityStageActor'] = exports; exports.CityStageActor = CivilianActorFight.subclass
({
	classname : 'CityStageActor',
	
	initialize : function()
	{

	},
	
	initActorSpecificData : function($super)
	{
		$super();
		this._spriteFileName = "CityStage.png";
		this._type = kActorTypeCivilian;
		this._state = kActorFightStateWait;
	},
	
	initSprite : function($super)
	{
		$super();
		this._spriteMan.setScale(0.7);
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/CityStageActor/CityStageActorBoss'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/CityStageActor/CityStageActorBoss'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/CityStageActor/CityStageActorBoss'] = exports; exports.CityStageActorBoss = CityStageActor.subclass
({
	classname : 'CityStageActorBoss',
	
	initialize : function()
	{
		
	},
	
	initSpriteDictionary : function($super)
	{
		$super();
		//arms
		this.addSpriteDictionaryEntry("defaultArmF", CGRectMake(0, 212, 68, 44), ccp(0.87, 0.72), ccp(26, 41), 5);
		this.addSpriteDictionaryEntry("defaultArmB", CGRectMake(68, 204, 55, 52), ccp(0.65, 0.10), ccp(-30, 33), 0);
		//head
		this.addSpriteDictionaryEntry("defaultHead", CGRectMake(133, 0, 75, 77), ccp(0.73, 0.25), ccp(-3, 70), 4);
		//body
		this.addSpriteDictionaryEntry("defaultBody", CGRectMake(112, 79, 64, 86), ccp(0.5, 0.5), ccp(-5, 25), 3);
		//feet
		this.addSpriteDictionaryEntry("defaultFootF", CGRectMake(0, 196, 33, 16), ccp(0.75, 0.9), ccp(15, -12), 2);
		this.addSpriteDictionaryEntry("defaultFootB", CGRectMake(0, 196, 33, 16), ccp(0.75, 0.9), ccp(-5, -10), 1);
	},
	
	initSprite: function($super)
	{
		$super();
			
		for ( var key in this._attachments )
		{
			var a = this._attachments[key];

			if(a == null)
				continue;
				
			if (a._tag == kActorPartTagArmB || a._tag == kActorPartTagArmF)
			{
				a.setScale(1.2);
				a._sprite.setScale(1.2);
			}
		}
		
	},
	
	initActorSpecificAbilities : function()
	{
		//clear the list
		if(this._abilityList)
		{
			this._abilityList.length = 0;
			this._abilityList = null;
			
			this._abilityList = new Array();
		}
		var ability;
		ability = new ZFActorFightEffect();
		ability.initWithTag(kFightEffectEnemyBuffEnrage);
		this._abilityList.push(ability);
		ability._unlocked = true;	
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/CityStageActor/CityStageActorCrazedWorker'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/CityStageActor/CityStageActorCrazedWorker'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/CityStageActor/CityStageActorCrazedWorker'] = exports; exports.CityStageActorCrazedWorker = CityStageActor.subclass
({
	classname : 'CityStageActorCrazedWorker',
	
	initialize : function()
	{
		
	},
	
	initSpriteDictionary : function($super)
	{
		$super();
		
		//arms
		this.addSpriteDictionaryEntry("defaultArmF", CGRectMake(55, 156, 53, 48), ccp(0.75, 0.9), ccp(11+10, 53), 5);
		this.addSpriteDictionaryEntry("defaultArmB", CGRectMake(55, 156, 53, 48), ccp(0.75, 0.9), ccp(-13+10, 58), 0);
		
		//head
		this.addSpriteDictionaryEntry("defaultHead", CGRectMake(58, 0, 75, 75), ccp(0.73, 0.25), ccp(6+10, 64), 4);

		//body
		this.addSpriteDictionaryEntry("defaultBody", CGRectMake(58, 75, 54, 81), ccp(0.5, 0.5), ccp(0+10, 35), 3);
		
		//feet
		this.addSpriteDictionaryEntry("defaultFootF", CGRectMake(0, 196, 33, 16), ccp(0.75, 0.9), ccp(17+10, -2), 2);
		this.addSpriteDictionaryEntry("defaultFootB", CGRectMake(0, 196, 33, 16), ccp(0.75, 0.9), ccp(3+10, 0), 1);
		
		//accessories
		this.addSpriteDictionaryEntry("workerGlasses", CGRectMake(138, 222, 49, 34), ccp(0.5, 0.5), ccp(-29, 13), 5);
		this.addSpriteDictionaryEntry("workerHeadset", CGRectMake(186, 207, 46, 49), ccp(0.5, 0.5), ccp(-11, 16), 5);
		
		//weapons
		this.addSpriteDictionaryEntry("workerPencil", CGRectMake(232, 204, 8, 52), ccp(3.75, 1.2), ccp(0+10, 0), -1);
		this.addSpriteDictionaryEntry("workerBat", CGRectMake(202, 140, 54, 50), ccp(1.4, 0.6), ccp(0+10, 0), 4);
	},
	
	initSprite: function($super)
	{
		$super();
		
		this.addAttachment_withSpriteDetails(kActorPartTagFeatures, this._spriteDictionary["workerGlasses"]);
		this.addAttachment_withSpriteDetails(kActorPartTagHat, this._spriteDictionary["workerHeadset"]);
		this.addAttachment_withSpriteDetails(kActorPartTagArmBm, this._spriteDictionary["workerPencil"]);
		this.addAttachment_withSpriteDetails(kActorPartTagArmFm, this._spriteDictionary["workerBat"]);
		
		this._attachments[kActorPartTagFeatures]._inheritColor = false;
		this._attachments[kActorPartTagHat]._inheritColor = false;
		this._attachments[kActorPartTagArmFm]._inheritColor = false;
		this._attachments[kActorPartTagArmBm]._inheritColor = false;
		
		for ( var key in this._attachments )
		{
			var a = this._attachments[key];

			if(a == null)
				continue;
				
			if (a._tag == kActorPartTagArmB || a._tag == kActorPartTagArmF)
			{
				a.setScale(1.2);
				a._sprite.setScale(1.2);
			}
		}
		
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/CityStageActor/CityStageActorLawyer'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/CityStageActor/CityStageActorLawyer'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/CityStageActor/CityStageActorLawyer'] = exports; exports.CityStageActorLawyer = CityStageActor.subclass
({
	classname : 'CityStageActorLawyer',
	
	initialize : function()
	{
		
	},
	
	initSpriteDictionary : function($super)
	{
		$super();
		
		//arms
		this.addSpriteDictionaryEntry("defaultArmF", CGRectMake(0, 163, 55, 33), ccp(0.87, 0.50), ccp(21+5, 44), 5);
		this.addSpriteDictionaryEntry("defaultArmB", CGRectMake(0, 147, 40, 16), ccp(0.87, 0.50), ccp(-18+5, 44), 0);
		
		//head
		this.addSpriteDictionaryEntry("defaultHead", CGRectMake(5, 5, 53, 77), ccp(0.73, 0.25), ccp(-4+5, 56), 4);

		//body
		this.addSpriteDictionaryEntry("defaultBody", CGRectMake(0, 81, 46, 66), ccp(.5, .5), ccp(0+5, 25), 3);
		
		//feet
		this.addSpriteDictionaryEntry("defaultFootF", CGRectMake(0, 196, 33, 16), ccp(0.75, 0.9), ccp(5+5, -2), 2);
		this.addSpriteDictionaryEntry("defaultFootB", CGRectMake(0, 196, 33, 16), ccp(0.75, 0.9), ccp(-5+5, 0), 1);
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/FarmStageActor/FarmStageActor'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/FarmStageActor/FarmStageActor'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/FarmStageActor/FarmStageActor'] = exports; exports.FarmStageActor = CivilianActorFight.subclass
({
	classname : 'FarmStageActor',
	
	initialize : function()
	{
		
	},
	
	$classUnitKey : function() 
	{
		return "";
	},
	
	initActorSpecificData : function($super)
	{
		$super();
		this._spriteFileName = "FarmStage.png";
		this._type = kActorTypeCivilian;
		this._state = kActorFightStateWait;
	},
	
	initSprite : function($super)
	{
		$super();
		this._spriteMan.setScale(0.7);
	},
	
	initSpriteDictionary : function()
	{
	    this._spriteDictionary = DataPreloader._farmStageData;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/FarmStageActor/FarmStageActorBoss'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/FarmStageActor/FarmStageActorBoss'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/FarmStageActor/FarmStageActorBoss'] = exports; exports.FarmStageActorBoss = FarmStageActor.subclass
({
	classname : 'FarmStageActorBoss',
	
	initialize : function()
	{
		
	},
	
	initSprite : function($super)
	{
		$super();
		
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmF, this._spriteDictionary["oldMcDonnellArmF.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmB, this._spriteDictionary["oldMcDonnellArmB.png"]);
		
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFootF, this._spriteDictionary["footF.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFootB, this._spriteDictionary["footB.png"]);
		
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagBody, this._spriteDictionary["oldMcDonnellBody.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagHead, this._spriteDictionary["oldMcDonnellHead.png"]);
	},
	
	initActorSpecificAbilities : function()
	{
		if(this._abilityList)
		{
			this._abilityList.length = 0;
			this._abilityList = null;
			this._abilityList = new Array();
		}
		var ability;
		
		ability = new ZFActorFightEffect();
		ability.initWithTag(kFightEffectEnemyBuffEnrage);
		this._abilityList.push(ability);
		ability._unlocked = true;	
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/FarmStageActor/FarmStageActorFarmhand'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/FarmStageActor/FarmStageActorFarmhand'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/FarmStageActor/FarmStageActorFarmhand'] = exports; exports.FarmStageActorFarmhand = FarmStageActor.subclass
({
	classname : 'FarmStageActorFarmhand',
	
	initialize : function()
	{
		
	},
	
	initSprite : function($super)
	{
		$super();
		
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmF, this._spriteDictionary["farmHandArmF.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmB, this._spriteDictionary["pitchfork.png"]);
		
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFootF, this._spriteDictionary["footF.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFootB, this._spriteDictionary["footB.png"]);
		
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagBody, this._spriteDictionary["farmHandBody.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagHead, this._spriteDictionary["farmHandHead.png"]);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/FarmStageActor/FarmStageActorLumberjack'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/FarmStageActor/FarmStageActorLumberjack'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/FarmStageActor/FarmStageActorLumberjack'] = exports; exports.FarmStageActorLumberjack = FarmStageActor.subclass
({
	classname : "FarmStageActorLumberjack",
	
	initialize : function()
	{
		
	},
	
	initSprite : function($super)
	{
		$super();
		
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmF, this._spriteDictionary["lumberjackArmF.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmB, this._spriteDictionary["lumberjackArmB.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFistF, this._spriteDictionary["lumberjackFistF.png"]);
		
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFootF, this._spriteDictionary["lumberjackFootF.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFootB, this._spriteDictionary["lumberjackFootB.png"]);
		
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagBody, this._spriteDictionary["lumberjackBody.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagHead, this._spriteDictionary["lumberjackHead.png"]);
		
		var fist = this._attachments[kActorPartTagFistF];
		var arm = this._attachments[kActorPartTagArmF];
		
		arm.addBone(fist);
	},
	
	startAnim : function(animID, interrupt)
	{
		return;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/NinjaStageActor/NinjaStageActor'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/NinjaStageActor/NinjaStageActor'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/NinjaStageActor/NinjaStageActor'] = exports; exports.NinjaStageActor = CivilianActorFight.subclass
({
	classname : 'NinjaStageActor',
	
	initialize : function()
	{

	},
	
	initActorSpecificData : function($super)
	{
		$super();
		this._spriteFileName = "NinjaStage.png";
		this._type = kActorTypeCivilian;
		this._state = kActorFightStateWait;
	},
	
	initSprite : function($super)
	{
		$super();
		this._spriteMan.setScale(0.7);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/NinjaStageActor/NinjaStageActorBoss'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/NinjaStageActor/NinjaStageActorBoss'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/NinjaStageActor/NinjaStageActorBoss'] = exports; exports.NinjaStageActorBoss = NinjaStageActor.subclass
({
	classname : 'NinjaStageActorBoss',
	
	initialize : function()
	{
		
	},
	
	initSpriteDictionary : function($super)
	{
		$super();
		
		//arms
		this.addSpriteDictionaryEntry("defaultArmF", CGRectMake(224,173,32,82), ccp(0.47, 0.65), ccp(36, 56), 5);
		this.addSpriteDictionaryEntry("defaultArmB", CGRectMake(142,170,32,85), ccp(0.78, 0.64), ccp(-26, 56), 0);
		
		//head
		this.addSpriteDictionaryEntry("defaultHead", CGRectMake(168,78,74,98), ccp(0.62, 0.21), ccp(8, 62), 4);

		//body
		this.addSpriteDictionaryEntry("defaultBody", CGRectMake(109,73,58,78), ccp(0.42, 0.33), ccp(0, 15), 1);
		
		//feet
		this.addSpriteDictionaryEntry("defaultFootF", CGRectMake(2,194,21,24), ccp(0.5, 1), ccp(16, 0), 3);
		this.addSpriteDictionaryEntry("defaultFootB", CGRectMake(2,194,21,24), ccp(0.5, 1), ccp(-7, 0), 2);
		
		//weapon
		this.addSpriteDictionaryEntry("hugeCarrot", CGRectMake(1,156,134,32), ccp(0.7, 2), ccp(0, 0), 4);
		this.addSpriteDictionaryEntry("cape", CGRectMake(188, 0, 68, 78), ccp(0, 1), ccp(-25, 65), -1);
	},
	
	initSprite: function($super)
	{
		$super();
			
		this.addAttachment_withSpriteDetails(kActorPartTagArmFm, this._spriteDictionary["hugeCarrot"]);
		this._attachments[kActorPartTagArmFm]._inheritColor = false;
		
		this.addAttachment_withSpriteDetails(kActorPartTagButt, this._spriteDictionary["cape"]);
		this._attachments[kActorPartTagButt]._inheritColor = false;
	},
	
	initActorSpecificAbilities : function()
	{
		//clear the list
		if(this._abilityList)
		{
			this._abilityList.length = 0;
			this._abilityList = null;
			
			this._abilityList = new Array();
		}
		var ability;
		ability = new ZFActorFightEffect();
		ability.initWithTag(kFightEffectEnemyBuffEnrage);
		this._abilityList.push(ability);
		ability._unlocked = true;	
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/NinjaStageActor/NinjaStageActorBoy'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/NinjaStageActor/NinjaStageActorBoy'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/NinjaStageActor/NinjaStageActorBoy'] = exports; exports.NinjaStageActorBoy = NinjaStageActor.subclass
({
	classname : 'NinjaStageActorBoy',
	
	initialize : function()
	{
		
	},
	
	initSpriteDictionary : function($super)
	{
		$super();
		
		//arms
		this.addSpriteDictionaryEntry("defaultArmF", CGRectMake(76,203,29,52), ccp(0.28, 0.88), ccp(17, 60), 5);
		this.addSpriteDictionaryEntry("defaultArmB", CGRectMake(54,205,21,50), ccp(0.81, 0.84), ccp(-21, 56), 0);
		
		//head
		this.addSpriteDictionaryEntry("defaultHead", CGRectMake(86,1,69,71), ccp(0.51, 0.24), ccp(-1, 71), 4);

		//body
		this.addSpriteDictionaryEntry("defaultBody", CGRectMake(61,82,46,71), ccp(0.48, 0.24), ccp(0, 15), 1);
		
		//feet
		this.addSpriteDictionaryEntry("defaultFootF", CGRectMake(26,189,27,20), ccp(0.75, 0.9), ccp(14, 0), 3);
		this.addSpriteDictionaryEntry("defaultFootB", CGRectMake(26,189,27,20), ccp(0.75, 0.9), ccp(-5, 0), 2);
		
		//weapon
		this.addSpriteDictionaryEntry("carrotSickle", CGRectMake(176,209,46,47), ccp(0.48, 1.2), ccp(0, 0), 4);
	},
	
	initSprite: function($super)
	{
		$super();
			
		this.addAttachment_withSpriteDetails(kActorPartTagArmFm, this._spriteDictionary["carrotSickle"]);
		this._attachments[kActorPartTagArmFm]._inheritColor = false;
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/NinjaStageActor/NinjaStageActorGirl'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/NinjaStageActor/NinjaStageActorGirl'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/NinjaStageActor/NinjaStageActorGirl'] = exports; exports.NinjaStageActorGirl = NinjaStageActor.subclass
({
	classname : 'NinjaStageActorGirl',
	
	initialize : function()
	{
		
	},
	
	initSpriteDictionary : function($super)
	{
		$super();
		
		//arms
		this.addSpriteDictionaryEntry("defaultArmF", CGRectMake(27,210,26,45), ccp(0.27,0.73), ccp(4, 55), 5);
		this.addSpriteDictionaryEntry("defaultArmB", CGRectMake(1,219,23,36), ccp(0.83, 0.83), ccp(-25, 51), 0);
		
		//head
		this.addSpriteDictionaryEntry("defaultHead", CGRectMake(0,0,84,84), ccp(0.58, 0.23), ccp(-9, 70), 4);

		//body
		this.addSpriteDictionaryEntry("defaultBody", CGRectMake(1,87,57,68), ccp(0.53, 0.24), ccp(0, 14), 1);
		
		//feet
		this.addSpriteDictionaryEntry("defaultFootF", CGRectMake(54,189,16,15), ccp(0.75, 0.9), ccp(-3, 0), 3);
		this.addSpriteDictionaryEntry("defaultFootB", CGRectMake(54,189,16,15), ccp(0.75, 0.9), ccp(-17, 0), 2);
		
		//weapon
		this.addSpriteDictionaryEntry("carrotDaggerF", CGRectMake(178,179,42,27), ccp(0.29, 1.67), ccp(0, 0), 4);
		this.addSpriteDictionaryEntry("carrotDaggerB", CGRectMake(106,222,35,33), ccp(1.06, 1.2), ccp(0, 0), -1);
	},
	
	initSprite: function($super)
	{
		$super();
			
		this.addAttachment_withSpriteDetails(kActorPartTagArmFm, this._spriteDictionary["carrotDaggerF"]);
		this._attachments[kActorPartTagArmFm]._inheritColor = false;
		
		this.addAttachment_withSpriteDetails(kActorPartTagArmBm, this._spriteDictionary["carrotDaggerB"]);
		this._attachments[kActorPartTagArmBm]._inheritColor = false;
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/PirateStageActor/PirateStageActor'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/PirateStageActor/PirateStageActor'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/PirateStageActor/PirateStageActor'] = exports; exports.PirateStageActor = CivilianActorFight.subclass
({
	classname : 'PirateStageActor',
	
	initialize : function()
	{
		
	},
	
	initActorSpecificData : function($super)
	{
		$super();
		
		this._spriteFileName = "PirateStage.png";
		this._type = kActorTypeCivilian;
		this._state = kActorFightStateWait;
	},
	
	initSprite : function($super)
	{
		$super();
		this._spriteMan.setScale(0.7);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/PirateStageActor/PirateStageActorBoss'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/PirateStageActor/PirateStageActorBoss'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/PirateStageActor/PirateStageActorBoss'] = exports; exports.PirateStageActorBoss = PirateStageActor.subclass
({
	classname : 'PirateStageActorBoss',
	
	initialize : function()
	{
		
	},
	
	initSpriteDictionary : function($super)
	{
		$super();
		
		//arms
		this.addSpriteDictionaryEntry("defaultArmF", CGRectMake(170, 67, 62, 70),
				ccp(.77, .28), ccp(38, 71), 5);
		this.addSpriteDictionaryEntry("defaultArmB", CGRectMake(170, 67, 62, 70),
				ccp(.77, .28), ccp(-27, 74), 0);
		
		//head
		this.addSpriteDictionaryEntry("defaultHead", CGRectMake(0, 0, 90, 99),
				ccp(0.71, 0.39), ccp(14, 86), 4);
		//body
		this.addSpriteDictionaryEntry("defaultBody", CGRectMake(90, 0, 79, 90),
				ccp(.42, .33), ccp(0, 30), 3);
		//feet
		this.addSpriteDictionaryEntry("defaultFootF", CGRectMake(0, 244, 13, 10),
				ccp(.5, 1), ccp(20, 0.0), 2);
		this.addSpriteDictionaryEntry("defaultFootB", CGRectMake(0, 244, 13, 10),
				ccp(.5, 1), ccp(-10, 0.0), 1);
	},
	
	initSprite : function($super)
	{
		$super();
		
		for ( var key in this._attachments )
		{
			var a = this._attachments[ key ];

			if(a == null)
				continue;
			
			if (a._tag == kActorPartTagArmB || a._tag == kActorPartTagArmF)
			{
				a.setScale(1.2);
				a._sprite.setScale(1.2);
			}
		}
	},
	
	initActorSpecificAbilities : function() 
	{
		if(this._abilityList)
		{
			this._abilityList.length = 0;
			this._abilityList = null;

			this._abilityList = new Array();
		}
		
		var ability;
		ability = new ZFActorFightEffect();
		ability.initWithTag(kFightEffectEnemyBuffEnrage);
		this._abilityList.push(ability);
		ability._unlocked = true;	
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/PirateStageActor/PirateStageActorScallywag'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/PirateStageActor/PirateStageActorScallywag'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/PirateStageActor/PirateStageActorScallywag'] = exports; exports.PirateStageActorScallywag = PirateStageActor.subclass
({
	classname : 'PirateStageActorScallywag',
	
	initialize : function() 
	{
		
	},
	
	initSpriteDictionary : function($super)
	{
		$super();
		
		//arms
		this.addSpriteDictionaryEntry("defaultArmF", CGRectMake(224, 0, 32, 76),
				ccp(.45, .85), ccp(31, 62), 5);
		this.addSpriteDictionaryEntry("defaultArmB", CGRectMake(233, 76, 23, 73),
				ccp(.55, .85), ccp(-32, 59), 0);
		
		//head
		this.addSpriteDictionaryEntry("defaultHead", CGRectMake(65, 91, 79, 72),
				ccp(0.68, 0.24), ccp(10, 71), 4);
		
		//body
		this.addSpriteDictionaryEntry("defaultBody", CGRectMake(0.0, 99, 65, 78),
				ccp(.48, .24), ccp(0, 15), 3);
		
		//feet
		this.addSpriteDictionaryEntry("defaultFootF", CGRectMake(0, 232, 23, 11),
				ccp(.75, 0.9), ccp(14, 0), 2);
		this.addSpriteDictionaryEntry("defaultFootB", CGRectMake(0, 232, 23, 11),
				ccp(.75, 0.9), ccp(-10, 0), 1);
		
		//weapon
		this.addSpriteDictionaryEntry("scallywagBat", CGRectMake(142, 232, 64, 24),
				ccp(1, 2.50), ccp(0, 0), 4);
	},
	
	initSprite : function($super)
	{
		$super();
		this.addAttachment_withSpriteDetails(kActorPartTagArmFm, this._spriteDictionary["scallywagBat"]);
		var a = this._attachments[kActorPartTagArmFm];
		a._inheritColor = false;
		a.setScale(1.33);
		a._sprite.setScale(1.33); 
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/PirateStageActor/PirateStageActorSwashbuckler'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/PirateStageActor/PirateStageActorSwashbuckler'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/PirateStageActor/PirateStageActorSwashbuckler'] = exports; exports.PirateStageActorSwashbuckler = PirateStageActor.subclass
({
	classname : 'PirateStageActorSwashbuckler',
	
	initialize : function()
	{
		
	},
	
	initSpriteDictionary : function($super)
	{
		$super();
		
		//arms
		this.addSpriteDictionaryEntry("defaultArmF", CGRectMake(147, 138, 61, 38),
				ccp(0.9, 0.84), ccp(10, 86.0), 5);
		
		this.addSpriteDictionaryEntry("defaultArmB", CGRectMake(140, 176, 68, 45),
				ccp(0.97, 0.2), ccp(-23, 82.0), 0);
		
		//head
		this.addSpriteDictionaryEntry("defaultHead", CGRectMake(67, 164, 73, 73),
				ccp(0.6, 0.37), ccp(-3, 90.0), 4);
		//body
		this.addSpriteDictionaryEntry("defaultBody", CGRectMake(209, 158, 47, 98),
				ccp(0.53, 0.31), ccp(0, 30), 3);
		
		//feet
		this.addSpriteDictionaryEntry("defaultFootF", CGRectMake(32, 220, 10, 10),
				ccp(.75, 0.9), ccp(13, 0), 2);
		this.addSpriteDictionaryEntry("defaultFootB", CGRectMake(0, 220, 23, 10),
				ccp(.75, 0.9), ccp(-6, 0), 1);
		//weapons		
		this.addSpriteDictionaryEntry("swashbucklerSword", CGRectMake(46, 191, 19, 65),
				ccp(2.65, .25), ccp(0, 0), 4);
	},
	
	initSprite : function($super)
	{
		$super();
//		var a = this.addAttachment(kActorPartTagArmFm, this._spriteDictionary["swashbucklerSword"]);
		this.addAttachment_withSpriteDetails(kActorPartTagArmFm, this._spriteDictionary["swashbucklerSword"]);
		var a = this._attachments[kActorPartTagArmFm];
		a._inheritColor = false;
		a._sprite.setScale(1.33);
		a.setScale(1.33);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActor'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActor'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActor'] = exports; exports.RobotStageActor = CivilianActorFight.subclass
({
	classname : 'RobotStageActor',
	
	$robotStageActorStates : 
	{
		kGiantBotStateFightWait : 0,
		kGiantBotStateFightFight : 1,
		kGiantBotStateFightFightFight : 2,
		kGiantBotStateFightLaser : 3,
		kGiantBotStateStunned : 4,
		kGiantBotStateDead : 5,
		kGiantBotStateSleep : 6,
		kGiantBotStateYouWontLikeItWhenImAngry : 7
	},
	
	initialize : function()
	{
		
	},
	
	initActorSpecificData : function($super)
	{
		$super();

		this._spriteFileName = "RobotStage.png";
		
		this._type = kActorTypeCivilian;
		this._state = kActorFightStateWait;
	},
	
	initSpriteDictionary : function()
	{
	    this._spriteDictionary = DataPreloader._robotStageData;
//	    this._extraSpriteDictionary = DataPreloader._robotStageElementsData;
	},
	
	initSprite : function($super)
	{
		$super();
		
		this._spriteMan.setScale(1.0);
	},
	
	initActorSpecificAbilities : function()
	{
		// clear the list
		if(this._abilityList)
		{
			this._abilityList.length = 0;
			this._abilityList = null;
			
			this._abilityList = new Array();
		}
		var ability;
		
		ability = new ZFActorFightEffect();
		ability.initWithTag(kFightEffectEnemyBuffEnrage);
		this._abilityList.push(ability);
		ability._unlocked = false;		
	},
	
	update : function($super, dt)
	{
		$super(dt);
		if ( this instanceof RobotStageActorBrainBot)
		{
			
		}
		
	},
	
	startAnim : function(animID, interrupt)
	{
		return;
		if(!this._attachments || this._attachments.lentgh <= 0)
		{
			return;
		}
		
		if(animID != kActorAnimVictory)
		{
			// stops animation when finished by reseting to defaults
			this.resetColor();
//			this.resetAttachmentScaleInterpolate(true);
//			this.resetAttachmentPositionsInterpolate(true);
//			this.resetAttachmentRotationInterpolate(true);
		}
		var fm = ZFFightMan;
		var arm1 = this._attachments[kActorPartTagArmF];
		var arm2 = this._attachments[kActorPartTagArmB];
		var foot1 = this._attachments[kActorPartTagFootF];
		var foot2 = this._attachments[kActorPartTagFootB];
		var body = this._attachments[kActorPartTagBody];
		var head = this._attachments[kActorPartTagHead];
		
		var asc = this.getFightAttackSpeed();
		var s = this._animSpeed;
		var f = head._sprite.flipX() ? -1 : 1;
		
		if(interrupt)
		{
			for ( var key in this._attachments )
			{
				var a = this._attachments[ key ];

				if (a == null)
					continue;
				
				a._sprite.stopAllActions();
				a.stopAllActions();
			}
		}
		
		if(animID != kActorAnimVictory)
		{
			// stops animation when finished by reseting to defaults
			this.resetColor();
			this.resetAttachmentScaleInterpolate(true);
			this.resetAttachmentPositionsInterpolate(true);
			this.resetAttachmentRotationInterpolate(true);
		}
		
		switch(animID)
		{
			case kActorAnimIdle:
			{

				if (this instanceof RobotStageActorJunkBot)
				{
					//twitch
					head.loop(CCSequence.actions([CCMoveByWithoutChangingPosition.actionWithDuration(s*0.1, ccp(0,2*this._heightScale)),
					                              CCMoveByWithoutChangingPosition.actionWithDuration(s*0.1, ccp(0,-2*this._heightScale)),
					                              null]));
					
					arm1.loopS(CCSequence.actions([CCRotateTo.actionWithDuration(s*0.4, f*-40 - 20),
					                                CCRotateTo.actionWithDuration(s*0.6, f*-40 + 20),
					                                null]));
					
					arm2.loopS(CCSequence.actions([CCRotateTo.actionWithDuration(s*.40, f*100 + 20),
					                                CCRotateTo.actionWithDuration(s*.60, f*100 - 20),
					                                null]));
				}
				
				if(this instanceof RobotStageActorBrainBot)
				{
					
					body.loop(CCSequence.actions([CCMoveByWithoutChangingPosition.actionWithDuration(s*0.5, ccp(2*this._widthScale,0) ),
					                              CCMoveByWithoutChangingPosition.actionWithDuration(s*0.5, ccp(-2*this._widthScale,0)),
					                              null]));  
					
					arm1.loop(CCSequence.actions([CCMoveByWithoutChangingPosition.actionWithDuration(s*0.5, ccp(2*this._widthScale,0) ),
					                              CCMoveByWithoutChangingPosition.actionWithDuration(s*0.5, ccp(-2*this._widthScale,0)),
					                              null]));  
					
					arm2.loop(CCSequence.actions([CCMoveByWithoutChangingPosition.actionWithDuration(s*0.5, ccp(2*this._widthScale,0) ),
					                              CCMoveByWithoutChangingPosition.actionWithDuration(s*0.5, ccp(-2*this._widthScale,0)),
					                              null]));
					
					foot1.loop(CCSequence.actions([CCMoveByWithoutChangingPosition.actionWithDuration(s*0.5, ccp(2*this._widthScale,0) ),
					                               CCMoveByWithoutChangingPosition.actionWithDuration(s*0.5, ccp(-2*this._widthScale,0)),
					                              null]));
					
					foot2.loop(CCSequence.actions([CCMoveByWithoutChangingPosition.actionWithDuration(s*0.5, ccp(5,0) ),
					                               CCMoveByWithoutChangingPosition.actionWithDuration(s*0.5, ccp(-5*this._widthScale,0)),
					                              null]));
				}
				
				if(this instanceof RobotStageActorBroBot)
				{
					head.loop(CCSequence.actions([CCMoveByWithoutChangingPosition.actionWithDuration(s*0.1, ccp(0,2*this._heightScale) ),
					                              CCMoveByWithoutChangingPosition.actionWithDuration(s*0.1, ccp(0,-2*this._heightScale)),
					                              null]));
					
					body.loop(CCSequence.actions([CCMoveByWithoutChangingPosition.actionWithDuration(s*0.09, ccp(0,1*this._heightScale) ),
					                              CCMoveByWithoutChangingPosition.actionWithDuration(s*0.09, ccp(0,-1*this._heightScale)),
					                              null]));
					
					foot1.loop(CCSequence.actions([CCMoveByWithoutChangingPosition.actionWithDuration(s*0.09, ccp(0,-1*this._heightScale) ),
					                               CCMoveByWithoutChangingPosition.actionWithDuration(s*0.09, ccp(0,1*this._heightScale)),
					                              null]));
					
					foot2.loop(CCSequence.actions([CCMoveByWithoutChangingPosition.actionWithDuration(s*0.09, ccp(0,-1*this._heightScale) ),
					                               CCMoveByWithoutChangingPosition.actionWithDuration(s*0.09, ccp(0,1*this._heightScale)),
					                              null]));
					
					arm1.loop(CCSequence.actions([CCMoveByWithoutChangingPosition.actionWithDuration(s*0.11, ccp(0,1.5*this._heightScale) ),
					                              CCMoveByWithoutChangingPosition.actionWithDuration(s*0.11, ccp(0,-1.5*this._heightScale)),
					                              null]));
					
					arm2.loop(CCSequence.actions([CCMoveByWithoutChangingPosition.actionWithDuration(s*0.11, ccp(0,1.7*this._heightScale) ),
					                              CCMoveByWithoutChangingPosition.actionWithDuration(s*0.11, ccp(0,-1.7*this._heightScale)),
					                              null]));
					
					arm1.loopS(CCSequence.actions([CCRotateTo.actionWithDuration(s*.4, f*-10 - 5),
					                               CCRotateTo.actionWithDuration(s*.6, f*10 + 5),
					                               null]));
					
					arm2.loopS(CCSequence.actions([CCRotateTo.actionWithDuration(s*.4, f*10 + 5),
					                               CCRotateTo.actionWithDuration(s*.6, f*-10 - 5),
					                               null]));
					
					body.loopS(ZFAnims.bodyBreatheScale(2, body.getScale()._y));
				}
			}
				break;
				
			case kActorAnimWalk:
			{			
				if(this instanceof RobotStageActorJunkBot )
				{
					body.loop(ZFAnims.bodyWalkMove(s));
					foot1.loop(ZFAnims.footWalkFrontMove(s));
					foot2.loop(ZFAnims.footWalkBackMove(s));
					foot1.loopS(ZFAnims.footWalkFrontRotate(s, f));
				}
				
				if(this instanceof RobotStageActorBrainBot)
				{
					
				}
				if(this instanceof RobotStageActorBroBot)
				{
					body.loop(ZFAnims.bodyWalkMove(s));
					foot1.loop(ZFAnims.footWalkFrontMove(s));
					foot2.loop(ZFAnims.footWalkBackMove(s));
					foot1.loopS(ZFAnims.footWalkFrontRotate(s, f));
				}
			}
				break;
				
			case kActorAnimAttack:
			{
				// all attacks pulled from attack anim class
				this._fightData._attacking = true;
				if (!this.isScheduled(this.doneAttacking))
				{
					this.schedule(this.doneAttacking, asc);
				}
				var attackAnimID = this._fightData._currentAttackVariation["animID"];
				ZFAttackAnims.performAttackWithID(attackAnimID, this);
			}
				break;
				
			case kActorAnimThrow:
			{
				// throw speed for robots should be determined by type 
				var throwSpeedFromSheet = fm._enemyDictionary["throwSpeed"];
				var throwSpeed = throwSpeedFromSheet ? throwSpeedFromSheet : 1.0;
				throwSpeed = throwSpeed * 2.0 / 3.0;
				throwSpeed = (throwSpeed > 1) ? 1 : throwSpeed;
				
				var sequence = CCSequence.actions([CCRotateTo.actionWithDuration(0.01, f*-90),
				                                   ZFAnims.armThrow(throwSpeed, f),
				                                   null]);

				arm1.onceS(sequence);
				SimpleAudioEngine.playEffect(kThrowSFX);
			}
				break;
				
			case  kActorAnimSummon:
			{
				// this works
				if(this instanceof RobotStageActorBrainBot)
				{
					foot2.runAction(CCSequence.actions([CCMoveByWithoutChangingPosition.actionWithDuration((fm._bossActionCastTimer/60) * 0.95, ccp(0,20*this._heightScale)),
					                                    CCMoveByWithoutChangingPosition.actionWithDuration((fm._bossActionCastTimer/60)* 0.95, ccp(0,0)),
					                                    null]));
				}
				arm1.loopS(ZFAnims.armHackFront(fm._bossActionCastTimer / 60, arm1.getScale(), f));
				arm2.loopS(ZFAnims.armHackFront(fm._bossActionCastTimer / 60, arm1.getScale(), f));
			}
				break;
		}
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActorBrainBot'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActorBrainBot'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActorBrainBot'] = exports; exports.RobotStageActorBrainBot = RobotStageActor.subclass
({
	classname : 'RobotStageActorBrainBot',
	
	initialize : function()
	{
		
	},
	
	initSprite: function($super)
	{
		$super();
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmF, this._spriteDictionary["brainBotArm.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmB, this._spriteDictionary["brainBotArm.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFootF, this._spriteDictionary["brainBotLeg.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFootB, this._spriteDictionary["brainBotWheel.png"]);
		
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagBody, this._spriteDictionary["brainBotBody.png"]);

		var brainBotArmF = this._attachments[kActorPartTagArmF];
		var brainBotArmB = this._attachments[kActorPartTagArmB];
		var brainBotFootF = this._attachments[kActorPartTagFootF];
		var brainBotFootB = this._attachments[kActorPartTagFootB];
		var brainBotBody = this._attachments[kActorPartTagBody];
//		
		brainBotFootB.addBone(brainBotBody);
		brainBotFootB.addBone(brainBotFootF);
//		
		brainBotBody.addBone(brainBotArmB);
		brainBotBody.addBone(brainBotArmF);
		
		this._spriteMan.setScale(0.75);
		
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActorBroBot'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActorBroBot'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActorBroBot'] = exports; exports.RobotStageActorBroBot = RobotStageActor.subclass
({
	classname : 'RobotStageActorBroBot',
	
	initialize : function()
	{
		
	},
	
	initSprite : function($super)
	{
		$super();
		
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmF, this._spriteDictionary["broBotArm.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmB, this._spriteDictionary["broBotArm.pngB"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFistF, this._spriteDictionary["broBotFist.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFistB, this._spriteDictionary["broBotKeg.png"]);
		
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFootF, this._spriteDictionary["broBotFoot.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFootB, this._spriteDictionary["broBotFoot.pngB"]);
		
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagBody, this._spriteDictionary["broBotBody.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagHead, this._spriteDictionary["broBotHead.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagCollar, this._spriteDictionary["broBotCollar.png"]);
		
		var broBotArmF = this._attachments[kActorPartTagArmF];
		var broBotArmB = this._attachments[kActorPartTagArmB];
		var broBotFootF = this._attachments[kActorPartTagFootF];
		var broBotFootB = this._attachments[kActorPartTagFootB];
		var broBotBody = this._attachments[kActorPartTagBody];
		var broBotFistF = this._attachments[kActorPartTagFistF];
		var broBotFistB = this._attachments[kActorPartTagFistB];
		var broBotCollar = this._attachments[kActorPartTagCollar];
		var broBotHead = this._attachments[kActorPartTagHead];
		
		broBotFistB._followRotation = false;
		broBotFistF._followRotation = false;
		
		broBotBody.addBone(broBotHead);
		broBotBody.addBone(broBotArmB);
		broBotBody.addBone(broBotArmF);
		broBotBody.addBone(broBotFootF);
		broBotBody.addBone(broBotFootB);
		broBotBody.addBone(broBotCollar);
		
		broBotArmF.addBone(broBotFistF);
		broBotArmB.addBone(broBotFistB);
		
		this._spriteMan.setScale(0.75);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActorGiantBot'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActorGiantBot'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActorGiantBot'] = exports; exports.RobotStageActorGiantBot = RobotStageActor.subclass({
    classname : 'RobotStageActorGiantBot',
    
    initialize : function()
    {
        this._headHitBox = null; //RobotStageActorHitBox
        this._changeStateValue = null; //int
        this._laser = null; //boolean
        this._beamRight = null; //CCQuadParticleSystem
        this._beamLeft = null; //CCQuadParticleSystem
        this._targetZombie = null; //CGPoint
    },
    
    colorFromSubType : function(actorSubType)
    {
        //meant to be overridden
        return ccc3(0x00, 0x0, 0x0);
    },
    
    initSpriteDictionary : function(callback)
    {
        this._spriteDictionary = DataPreloader._robotStageData;
        this._extraSpriteDictionary = DataPreloader._robotStageElementsData;
    },
    
    initSprite : function($super)
    {
        $super();
        this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagBody, this._extraSpriteDictionary["giantBotBody.png"]);
        this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagHead, this._extraSpriteDictionary["giantBotHead.png"]);
        this.resetColor();
    },
    
    initActorSpecificData : function($super)
    {
        $super();
        this._spriteFileName = "RobotStageElements.png";
        this._changeStateValue = -1;
        this._type = kActorTypeStageElement;
        this._state = kActorFightStateWait;
        this._beamLeft = null;
        this._beamRight = null;
        this._targetZombie = ccp(0, 0);
    },
    
    initActorSpecificDataAfterLoad : function($super)
    {
        $super();
//        var dict = ZFActorManager._unitStats;
//        var unitKey = this.classname;
//        this._unitDictionary = dict[unitKey];
        this._walkingSpeed = 1.5/*this._widthScale*/;
        this._animSpeed = 1.0 / this._walkingSpeed;
        this._unitDictionary = [];
        
        //FIXME
        this._unitDictionary["con"] = 1000; 
        this._unitDictionary["str"] = 1000;
        this._unitDictionary["dex"] = 1000;
    },
    
    initFightDataAfterLoad : function()
    {
        this._fightData._hitPointsTotal = 9000;
        this._fightData._power = 10;
        this._fightData._attackSpeed = 1;
        
        // over 9000 hitpoints
        this._fightData._finalHitPointsTotal = 10000;
        this._fightData._finalAttackSpeed = 1;
        this._fightData._finalPower = 10;
        this._fightData._finalDamageReduction = 0;
        
        this._state = this.robotStageActorStates.kGiantBotStateFightWait;
        this.scheduleUpdate();
    },
    
    update : function(dt)
    {
        var time = 3 * 60.0;
        var laserChargeTime = 8;
        
        var fm = ZFFightMan;
        
        if (fm._boss)
        {
            var enrage = fm._boss.getAbilityByTag(kFightEffectEnemyBuffEnrage);
            if (enrage)
                time = enrage._timerActivateIn;
        }
        
        if (this._headHitBox)
        {
            // sets position
            var head = this._attachments[kActorPartTagHead];
            
            var placeHere = ccpAdd(this.getPosition(), head._offsetFromRefPoint/*ccpMult(head._offsetFromRefPoint, this._widthScale)*/);
            
            var facing = (head._sprite.flipX()) ? -1 : 1;
            this._headHitBox.setPosition(ccpAdd(placeHere, ccp(facing * this._headHitBox._offset._x, this._headHitBox._offset._y)));
            
            if (this._state != this.robotStageActorStates.kGiantBotStateFightLaser)
            {
            	var headPositionX = this._headHitBox.getPosition()._x;
            	var headPositionY = this._headHitBox.getPosition()._y;
                if (this._beamLeft)
                {
                    this._beamLeft.setPosition(ccp(headPositionX + facing * 30 /* this._widthScale*/,headPositionY + 75 /* this._widthScale*/) );
                }
                if (this._beamRight)
                {
                    this._beamRight.setPosition(ccp(headPositionX + facing * 135 /* this._widthScale*/, headPositionY + 60 /* this._widthScale*/));
                }
            }
            
        }
        
        if (fm.isGameWon() || fm.isGameLost())
        {
            this.setState(this.robotStageActorStates.kGiantBotStateDead);
        }
        
        switch (this._state)
        {
            case this.robotStageActorStates.kGiantBotStateFightWait: {
                if (fm._doOrDie)
                {
                    this.setState(this.robotStageActorStates.kGiantBotStateYouWontLikeItWhenImAngry);
                }
                else if (time <= 1 * 60.0 + 30.0) // start fighting harder
                {
                    this.setState(this.robotStageActorStates.kGiantBotStateFightFightFight);
                }
                else if (time <= 2 * 60.0 + 40.0) // start fighing
                {
                    this.setState(this.robotStageActorStates.kGiantBotStateFightFight);
                }
                else if (time <= 2 * 60.0 + 45.0) // enter scene
                {
                	//Initial Position
                    this.moveToPoint(ccp(430/*w._width / 2*/, 300 /*w._height / 4*/), false);
                }
            }
                break;
            
            case this.robotStageActorStates.kGiantBotStateYouWontLikeItWhenImAngry: {
                laserChargeTime = 4;
            }
                
            case this.robotStageActorStates.kGiantBotStateFightFightFight: {
                // start moving in a simple pattern with move speed changing at milestones
                
                if (this._state == this.robotStageActorStates.kGiantBotStateFightFightFight)
                    this._walkingSpeed = 4 /* this._widthScale*/;
                else if (this._state == this.robotStageActorStates.kGiantBotStateYouWontLikeItWhenImAngry)
                    this._walkingSpeed = 7.7 /* this._widthScale*/;
                if (CGPointEqualToPoint(this.getPosition(), this._destinationPoint))
                {
                    // Random Position after a certain moment
                    var destinationX = ((Math.random() * 330) + 180) /* this._widthScale*/;
                    var destinationY = ((Math.random() * 50) + 250) /* this._heightScale*/;
                    
                    this.moveToPoint(ccp(destinationX, destinationY), false);
                    
                }
            }
            case this.robotStageActorStates.kGiantBotStateFightFight: {
                // create hit box
                if (!this._headHitBox)
                {
                	var hitBoxSize = CGSizeMake(220.0 /* this._widthScale*/, 155.0 /* this._widthScale*/);
                    this._headHitBox = new RobotStageActorHitBox().initWithHitBoxSize(hitBoxSize);
                    
                    var head = this._attachments[kActorPartTagHead];
                    this._headHitBox._attachedTo = head;
                    
                    var body = this._attachments[kActorPartTagBody];
                    
                    head._sprite.runAction(CCSequence.actions([ CCDelayTime.actionWithDuration(laserChargeTime * 0.08), CCTintTo.actionWithDuration(laserChargeTime * 0.3, 255, 255, 255), null ]));
                    
                    body._sprite.runAction(CCSequence.actions([ CCDelayTime.actionWithDuration(laserChargeTime * 0.1), CCTintTo.actionWithDuration(laserChargeTime * 0.4, 0x99, 0x99, 0x99), null ]));
                    var placeHere = ccpAdd(this.getPosition(), head._offsetFromRefPoint);
                    
                    this._headHitBox._offset = ccpAdd(this._headHitBox._offset, ccp(-130 /* this._widthScale*/, 40 /* this._widthScale*/));
                    this._headHitBox.setPosition(ccpSub(placeHere, this._headHitBox._offset));
                    fm.getParent().addChild(this._headHitBox, this._spriteMan._zOrder);
                }
                
                if (this._headHitBox._hitPoints <= 0)
                {
                	this._headHitBox.cleanupHitBox();
                	fm.getParent().removeChild(this._headHitBox);
                	destroyWithChildren(this._headHitBox);
                    this._headHitBox = null;
                    this.setState(this.robotStageActorStates.kGiantBotStateStunned);
                    break;
                }
                
                if (this._headHitBox._hitPoints > 0)
                {
                	if (!this.isScheduled(this.changeState))
                    {
                    	this._changeStateValue = this.robotStageActorStates.kGiantBotStateFightLaser;
                        this.schedule(this.changeState, laserChargeTime);
                        
                        if(!this._beamLeft || !this._beamRight){
                            var animation = new GL2.Animation();
                        	animation.pushFrame(new GL2.Animation.Frame('Content/robotFire.png', 100, new Core.Size(100, 100), new Core.Point(0.5, 0.5), new Core.Rect(0*100/512, 0, 0.19, 0.19)));
                        	animation.pushFrame(new GL2.Animation.Frame('Content/robotFire.png', 100, new Core.Size(100, 100), new Core.Point(0.5, 0.5), new Core.Rect(1*100/512, 0, 0.19, 0.19)));
                        	animation.pushFrame(new GL2.Animation.Frame('Content/robotFire.png', 100, new Core.Size(100, 100), new Core.Point(0.5, 0.5), new Core.Rect(2*100/512, 0, 0.19, 0.19)));
                        	animation.pushFrame(new GL2.Animation.Frame('Content/robotFire.png', 100, new Core.Size(100, 100), new Core.Point(0.5, 0.5), new Core.Rect(3*100/512, 0, 0.19, 0.19)));
                        	animation.pushFrame(new GL2.Animation.Frame('Content/robotFire.png', 100, new Core.Size(100, 100), new Core.Point(0.5, 0.5), new Core.Rect(4*100/512, 0, 0.19, 0.19)));
                        	//GL2.Animation.Frame(image, duration, size, anchor, uvs)
//                        	var beamLeft = new GL2.Sprite();
//                        	beamLeft.setAnimation(animation);
	                        if (!this._beamLeft)
	                        {
	                        	var fileName = "robotFire.png";
	                            this._beamLeft =  CCSprite.spriteWithFile(fileName, CGRectMake(0, 0, 100, 100));
	                        	this._beamLeft._sprite.setAnimation(animation);
	                            
	                            this._beamLeft.setScale(0);
	                            this._beamLeft.setPosition(this.getPosition());
	                            this.getParent().addChild(this._beamLeft, 199);
	                            this._beamLeft.runAction(CCScaleTo.actionWithDuration(laserChargeTime, 2));
	                        }
	                        if (!this._beamRight)
	                        {
	                        	var fileName = "robotFire.png";
	                            this._beamRight =  CCSprite.spriteWithFile(fileName, CGRectMake(0, 0, 100, 100));
	                        	this._beamRight._sprite.setAnimation(animation);
	                            
	                            this._beamRight.setScale(0);
	                            this._beamRight.setPosition(this.getPosition());
	                            this.getParent().addChild(this._beamRight, 199);
	                            this._beamRight.runAction(CCScaleTo.actionWithDuration(laserChargeTime, 2));
	                        }
                        }
                        // to do : schedule extra charge particles
                    }
                }
                
                if (!this.hasTarget())
                {
                	this.setState(this.robotStageActorStates.kGiantBotStateSleep);
                }
                
            }
                break;
            
            case this.robotStageActorStates.kGiantBotStateFightLaser: {
                if (this._changeStateValue != this.robotStageActorStates.kGiantBotStateFightWait)
                    this.unschedule(this.changeState);
                
                var attackTime = 1;
                if (this._headHitBox && this._headHitBox._active)
                {
                    var head = this._attachments[kActorPartTagHead];
                    var body = this._attachments[kActorPartTagBody];
                    
                    head._sprite.runAction(CCTintTo.actionWithDuration(1, 0, 0, 0));
                    body._sprite.runAction(CCTintTo.actionWithDuration(1, 0, 0, 0));
                    
                    var fm = ZFFightMan;
                    
                    var targets = new Array();
                    
                    for ( var key in fm._zombies)
                    {
                    	var z = fm._zombies[key];
                        if (z.canBeDamaged())
                            targets.push(z);
                    }
                    
                    var randomZombie = Math.floor(Math.random() * targets.length);
                    if (randomZombie == targets.length)
                        randomZombie--;
                    
                    if (randomZombie >= 0)
                    {
                    	var target = targets[randomZombie].getPosition();
                        if (this._beamLeft){
                        	var R = this._beamLeft.getPosition()._x - target._x;
                        	var H = this._beamLeft.getPosition()._y - target._y;
                        	var angle = Math.atan(R/H);
                        	this._beamLeft.setRotation(angle*57.32);
                            this._beamLeft.runAction(CCMoveTo.actionWithDuration(attackTime, target));
                        }
                        if (this._beamRight){
                        	var R = this._beamRight.getPosition()._x - target._x;
                        	var H = this._beamRight.getPosition()._y - target._y;
                        	var angle = Math.atan(R/H);
                        	this._beamRight.setRotation(angle*57.32);
                            this._beamRight.runAction(CCMoveTo.actionWithDuration(attackTime, target));
                        }
                        // schedule attack on all zombies
                        this._targetZombie = target;
                        
                        this.schedule(this.explodeAttack, attackTime);
                        
//                      var animation = new GL2.Animation();
//                      animation.pushFrame(new GL2.Animation.Frame('Content/robotFire.png', 100, new Core.Size(100, 100), new Core.Point(0.5, 0.5), new Core.Rect(0*100/512, 0, 0.19, 0.19)));
//                      animation.pushFrame(new GL2.Animation.Frame('Content/robotFire.png', 100, new Core.Size(100, 100), new Core.Point(0.5, 0.5), new Core.Rect(1*100/512, 0, 0.19, 0.19)));
//                      animation.pushFrame(new GL2.Animation.Frame('Content/robotFire.png', 100, new Core.Size(100, 100), new Core.Point(0.5, 0.5), new Core.Rect(2*100/512, 0, 0.19, 0.19)));
//                      animation.pushFrame(new GL2.Animation.Frame('Content/robotFire.png', 100, new Core.Size(100, 100), new Core.Point(0.5, 0.5), new Core.Rect(3*100/512, 0, 0.19, 0.19)));
//                      animation.pushFrame(new GL2.Animation.Frame('Content/robotFire.png', 100, new Core.Size(100, 100), new Core.Point(0.5, 0.5), new Core.Rect(4*100/512, 0, 0.19, 0.19)));
//                      //GL2.Animation.Frame(image, duration, size, anchor, uvs)
//                      this._animation = new GL2.Sprite();
//                      this._animation.setAnimation(animation);
                        
                        
//                        this._animation = CCSprite.spriteWithFile("robotFire.png", new Core.Rect(0,0,100,100));
//                        ZFFightPhysics.throwAnObject(this._animation, targets[randomZombie], this.getPosition(), ZFFightPhysics.MovementType.fire, 0, 13);
                    }
                    
                    targets.length = 0;
                    this._headHitBox.cleanupHitBox();
                    destroy(this._headHitBox);
                    this._headHitBox = null;
                }
                
                this._changeStateValue = this.robotStageActorStates.kGiantBotStateFightWait;
                
                if (!this.isScheduled(this.changeState))
                    this.schedule(this.changeState, attackTime + 1);
            }
                break;
            
            case this.robotStageActorStates.kGiantBotStateStunned: {
                var head = this._attachments[kActorPartTagHead];
                var body = this._attachments[kActorPartTagBody];
                
                head._sprite.runAction(CCTintTo.actionWithDuration(1, 0, 0, 0));
                body._sprite.runAction(CCTintTo.actionWithDuration(1, 0, 0, 0));
                if (this._changeStateValue != this.robotStageActorStates.kGiantBotStateFightWait)
                {
                    if (this.isScheduled(this.changeState))
                        this.unschedule(this.changeState);
                }
                this.destroyBeams();
//                if (this._beamLeft)
//                    this._beamLeft.stopSystem();
//                if (this._beamRight)
//                    this._beamRight.stopSystem();
//                this._beamLeft = this._beamRight = null;
                
                this._changeStateValue = this.robotStageActorStates.kGiantBotStateFightWait;
                if (!this.isScheduled(this.changeState))
                    this.schedule(this.changeState, 5);
            }
                break;
            
            case this.robotStageActorStates.kGiantBotStateSleep: {
                if (this.hasTarget())
                    this.setState(this.robotStageActorStates.kGiantBotStateFightWait);
            }
                
            case this.robotStageActorStates.kGiantBotStateDead: {
                var head = this._attachments[kActorPartTagHead];
                var body = this._attachments[kActorPartTagBody];
                
                head._sprite.runAction(CCTintTo.actionWithDuration(1, 0, 0, 0));
                body._sprite.runAction(CCTintTo.actionWithDuration(1, 0, 0, 0));
                
                // unschedule stuff and remove headHitBox
                if (this.isScheduled(this.changeState))
                    this.unschedule(this.changeState);
                if (this.isScheduled(this.explodeAttack))
                    this.unschedule(this.explodeAttack);
                
                this.destroyBeams();
//                if (this._beamLeft)
//                    this._beamLeft.stopSystem();
//                if (this._beamRight)
//                    this._beamRight.stopSystem();
//                this._beamLeft = this._beamRight = null;
                
                if (this._headHitBox)
                {
                    this._headHitBox.cleanupHitBox();
                    this._headHitBox = null;
                }
                if (this._state == this.robotStageActorStates.kGiantBotStateDead)
                {
                    this._walkingSpeed = 1;
                    this.moveToPoint(ccpAdd(this.getPosition(), ccp(0, -200 * this._heightScale)));
                }
            }
                break;
        }
        this.movementUpdate(dt);
    },
    
    hasTarget : function()
    {
        var fm = ZFFightMan;
        for ( var key in fm._zombies){
        	var z = fm._zombies[key];
            if (z.canBeDamaged())
                return true;
        }
        return false;
    },
    
    explodeAttack : function(dt)
    {
    	this.unschedule(this.explodeAttack);
    	this.destroyBeams();
//        if (this._beamLeft)
//            this._beamLeft.stopSystem();
//        if (this._beamRight)
//            this._beamRight.stopSystem();
        
//        this._beamLeft = this._beamRight = null;
        
        var fm = ZFFightMan;
        var targets = new Array();
        for ( var key in fm._zombies)
        {
        	var z = fm._zombies[key];
            if (z.canBeDamaged())
                targets.push(z);
        }
        var closestToBlast = null;
        var tempDistance = 1000000000;
        for (var key in targets)
        {
            // check xValue absolute diff then check yValue absolute diff
            
            // calculate damage based on distance rather than charge time
        	var z = targets[key];
            var distanceX = z.getPosition()._x - this._targetZombie._x;
            var distanceY = z.getPosition()._y - this._targetZombie._y;
            
            var distance = (Math.sqrt(distanceX * distanceX + distanceY * distanceY)) / 10 + 1;
            
            var damage = (distance > 5) ? 0 : 800 / distance;
            z.damage(damage);
            
            if (!closestToBlast)
            {
                closestToBlast = z;
                tempDistance = distance;
            }
            else if (distance < tempDistance)
            {
                closestToBlast = z;
            }
        }
        
        if (closestToBlast)
        {
            closestToBlast.damage(100000);
        }
        
        targets.length = 0;
        
        var explodePosition = this._targetZombie;
        
        SimpleAudioEngine.playEffect("./Content/explosion.wav");
//        var boomFire = ZFParticleEffects.particleSystemByTag("boomFire.plist");
//        boomFire.setPosition(explodePosition);
//        boomFire.setScale(boomFire.getScale() * this._widthScale);
//        fm.getParent().addChild(boomFire, 203);
//        
//        var boomFire = ZFParticleEffects.particleSystemByTag("boomSide.plist");
//        boomSide.setPosition(explodePosition);
//        boomSide.setScale(boomFire.getScale() * this._widthScale);
//        fm.getParent().addChild(boomFire, 202);
//        
//        var boomSpray = ZFParticleEffects.particleSystemByTag("boomSpray.plist");
//        boomSpray.setPosition(explodePosition);
//        boomSpray.setScale(boomFire.getScale() * this._widthScale);
//        fm.getParent().addChild(boomSpray, 202);
//        
//        var boomTop = ZFParticleEffects.particleSystemByTag("boomTop.plist");
//        boomTop.setPosition(explodePosition);
//        boomTop.setScale(boomFire.getScale() * this._widthScale);
//        fm.getParent().addChild(boomTop, 202);
//        
//        var boomBiggerFire = ZFParticleEffects.particleSystemByTag("boomBiggerFire.plist");
//        boomBiggerFire.setPosition(explodePosition);
//        boomBiggerFire.setScale(boomFire.getScale() * this._widthScale);
//        fm.getParent().addChild(boomBiggerFire, 202);
    },
    
    changeState : function(dt)
    {
        this.unschedule(this.changeState);
        if (this._changeStateValue != -1)
            this.setState(this._changeStateValue);
        changeStateValue = -1;
    },
    
    destroy : function()
    {
        if (this.isScheduled(this.changeState))
            this.unschedule(this.changeState);
        this.destroyBeams();
        if (this._headHitBox) {
        	this._headHitBox.cleanupHitBox();
        	fm.getParent().removeChild(this._headHitBox);
        	destroyWithChildren(this._headHitBox);
            this._headHitBox = null;
        }
    },
    
    destroyBeams : function(){
    	
		if(this._beamLeft){
            if(this._beamLeft.getParent())
            	this._beamLeft.getParent().removeChild(this._beamLeft);
			destroyWithChildren(this._beamLeft);
			this._beamLeft = null;
		}
		
		if(this._beamRight){
            if(this._beamRight.getParent())
            	this._beamRight.getParent().removeChild(this._beamRight);
			destroyWithChildren(this._beamRight);
			this._beamRight = null;
		}
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActorHitBox'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActorHitBox'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActorHitBox'] = exports; exports.RobotStageActorHitBox = CCColorLayer.subclass
({
	classname : 'RobotStageActorHitBox',
	
	initialize : function () 
	{
		this._hitPoints = 0; //float
		this._arrow = null; //CCSprite
//		this._active = null; // boolean
		this._offset = null; // CGPoint
		this._attachedTo = null; //ActorAttachment
		
		this.initWithColor(ccc4(0x0, 0xff, 0x0, 0x00), 25, 250 );
		
		this._isTouchEnabled = true;
		this._hitPoints = 2400;
		this._active = true;
//		this.schedule(this.showWallHelperArrow,2);
		
		return this;
	},
	
	setTarget: function(s)
	{
		this._target = new GL2.TouchTarget();
		this._target.setAnchor(new Core.Point(0.0, 1.0));
		this._target.setPosition(new Core.Point(0,0));
		this._target.setSize(s._width, s._height);
		
		this._listener = new Core.MessageListener();
		this._target.getTouchEmitter().addListener(this._listener, this.onBoxTouch.bind(this));
		this.addChild(this._target);
		this._target.setDepth(1);
	},
	
	setAttachedTo : function(a)
	{
		this._offset = ccp( -this.getContentSize()._width/2,
				  -this.getContentSize()._height/2 );
		this._attachedTo = a;
	},
	
	initWithHitBoxSize : function(s)
	{
		this.changeWidth(s._width, s._height);
		this._offset = ccp(0,0);
		this.setTarget(s);
		return this;
	},
	
	cleanupHitBox : function()
	{
		//FIXME: CCTouchDispatcher.sharedDispatcher().removeDelegate(this);
		this._attachedTo = null;
		if ( this.getParent() )
		{
			this.getParent().removeChild(this, true);
		}
//		if(this.isScheduled( this.showWallHelperArrow)) 
//			this.unscheduled(this.showWallHelperArrow);
		if(this._target){
			this.removeChild(this._target, true);
			destroyWithChildren(this._target);
			this._target = null;
		}
		if (this._arrow){
			this.removeChild(this._arrow, true );
			destroyWithChildren(this._arrow);
			this._arrow = null;
		}
		this._active = false;
	},
	
	damage : function(amount)
	{
		this._hitPoints -= amount;

		if (this._hitPoints <= 0 && this._active)
		{
			//TODO: Check for different plataforms
//			var mainFrame = CCDirector.winsize();
//			var resolutionWidth = mainFrame._height;
//			var widthScale = resolutionWidth / 480;
            
//            var emitter = ZFParticleEffects.particleSystemByTag("smoke.plist");
//    		emitter._posVar = CGPointMake(0,0);
//    		emitter._startSize *= .25*this._widthScale;
//    		emitter._endSize *= .25*this._widthScale;
//    		emitter._speed *= .5;
//    		emitter._duration = .25;
//    		emitter._position = ccp(this.getPosition()._x + this.getCntentSize()._width/2, this.getPosition()._y);
//    		this.getParent().addChild(emitter, 104); 
		}
	},
	
	showWallHelperArrow : function(dt)
	{
		this.unschedule(this.showWallHelperArrow);
		
		if (this._arrow || this._hitPoints <= 0 || !this._active)
		{
			return;
		}
		
		this._arrow = CCSprite.spriteWithFile( "tap1.png" );
		this._arrow.setScale(1.2);
		
		var spritePos = new ccp(140, 220);
		
		this._arrow.setPosition(spritePos);
		
		this.addChild(this._arrow, 10);
		
		this._arrow.runAction(CCRepeatForever.actionWithAction(
				CCSequence.actions(
				 [CCMoveTo.actionWithDuration(0.25, ccp(this._arrow.getPosition()._x,this._arrow.getPosition()._y+10)),
				  CCMoveTo.actionWithDuration(0.25, ccp(this._arrow.getPosition()._x,this._arrow.getPosition()._y ) ) ]
				 )));  
		///////////////////////
		
//		this._arrow = CCSprite.spriteWithFile("tap1.png");
//		this._arrow.setOpacity( 0x0 );
//		this._arrow.setScale(0.67);
//		
//		this._arrow.setPosition(ccp(this.getContentSize()._width/2,this.getContentSize()._height + 10));
//		this.addChild(this._arrow, z);
//		
//		var frame1 = CCSpriteFrame.frameWithTexture( CCTextureCache.sharedTextureCache().addImage("tap1.png"), CGRectMake(0, 0, 64, 64), CGPointMake(0,0) );
//		var frame2 = CCSpriteFrame.frameWithTexture( CCTextureCache.sharedTextureCache().addImage("tap2.png"), CGRectMake(0, 0, 64, 64), CGPointMake(0,0) );
//		CCSpriteFrameCache.sharedSpriteFrameCache().addSpriteFrame(frame1, "tap1.png");
//		CCSpriteFrameCache.sharedSpriteFrameCache().addSpriteFrame(frame2, "tap2.png");
//		
//		var a = new Array();
//		a = [frame1, frame2, null];
//		var animMixed = CCAnimation.animationWithName("TapMe", 1, a);
//		
//		var action1 = CCMoveByWithoutChangingPosition.actionWithDuration(0.25, ccp(0,10));
//		
//		var act1 = CCAnimate.actionWithDuration(0.5,animMixed,false);
//		var act2 = CCFadeTo.actionWithDuration(0.25, 0xff);
//		
//		var actionArraySeq = new Array();
//		actionArraySeq = [action1, action1.reverse(), null];
//		var seq = CCSequence.actions(actionArraySeq);
//
//		var actionArraySpawn = new Array();
//		actionArraySpawn = [act1, act2, seq, null];
//		
//		var ccspawn = CCSpawn.actions(actionArraySpawn);
//		var repeat = CCRepeatForever.actionWithAction(ccspawn);
//		
//		this._arrow.runAction(repeat);
		
	},
	
	registerWithTouchDispatcher: function()
	{
		//TODO: Waiting for CCTouchDispatcher implementation
//		CCTouchDispatcher.sharedDispatcher().addTargetedDelegate( this , 0 , false ); // Delegate, Priority, swallowsTouches
	},
	
	onBoxTouch : function(touch)
	{
		switch(touch.getAction())
		{
			case touch.Action.Start:
					this.touched();
					return true;
				break;
		}
	},
	
//	ccTouchBegan: function( touch , event ) // UITouch*, UIEvent*
//	{
//		//TODO: Not sure
//		var pos = touch.locationInView( touch._view );
//		pos = CCDirector.sharedDirector.convertToGL( pos );
//		var nodePos = this.convertToNodeSpace( pos );
//		var rect = rectMake( 0 , 0 , this._contentSize._width , this._contentSize._height );
//		
//		if ( rectContainsPoint( rect , nodePos ) )
//		{
//			return true;
//		}
//		
//		return true;
//	},
	
	touched: function() // 
	{
		if (this._arrow){
			this.removeChild( this._arrow, true );
			destroyWithChildren(this._arrow);
			this._arrow = null;
		}
	
		this.damage(200);
		
		if(this._attachedTo)			{
			// sColor is == savedColor
			
//			var sColor = ccc3(0xFF,0xFF,0xFF);
			this._attachedTo._sprite.setColor(ccc3(0xFF, 0x00, 0x00));
			var action1 = CCTintBy.actionWithDuration(0.05, 1, 1, 1);
			var action2 = CCCallFunc.actionWithTarget(this, this.resetColor.bind(this));
			this._attachedTo._sprite.runAction(CCSequence.actions(action1, action2));
		}
//		if(this.isScheduled( this.showWallHelperArrow)) 
//			this.unschedule( this.showWallHelperArrow );
//		this.schedule( this.showWallHelperArrow , 3 );
	},
	
	resetColor : function (){
		var a = this._attachedTo;
		if(a){
			var tempColor = ccc3(0xFF, 0xFF, 0xFF);
			a._sprite.setColor(tempColor);
		}
	},
	
	destroy : function()
	{
		
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActorJunkBot'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActorJunkBot'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActorJunkBot'] = exports; exports.RobotStageActorJunkBot = RobotStageActor.subclass
({
	classname : 'RobotStageActorJunkBot',
	
	initialize : function()
	{
		
	},
	
	initSprite : function($super)
	{
		$super();
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmF, this._spriteDictionary["junkBotArm.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmB, this._spriteDictionary["junkBotArm.pngB"]);
		
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFootF, this._spriteDictionary["junkBotFoot.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFootB, this._spriteDictionary["junkBotFoot.pngB"]);
		
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagBody, this._spriteDictionary["junkBotBody.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagHead, this._spriteDictionary["junkBotHeadTop.png"]);
		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagJaw, this._spriteDictionary["junkBotMouth.png"]);
		
		this._spriteMan.setScale(0.75);
		
		var junkBotArmF = this._attachments[kActorPartTagArmF];
		var junkBotArmB = this._attachments[kActorPartTagArmB];
		var junkBotFootF = this._attachments[kActorPartTagFootF];
		var junkBotFootB = this._attachments[kActorPartTagFootB];
		var junkBotBody = this._attachments[kActorPartTagBody];
		var junkBotHead = this._attachments[kActorPartTagHead];
		var junkBotJaw = this._attachments[kActorPartTagJaw];	
//		
		junkBotBody.addBone(junkBotJaw);
		junkBotBody.addBone(junkBotArmB);
		junkBotBody.addBone(junkBotArmF);
		junkBotBody.addBone(junkBotFootF);
		junkBotBody.addBone(junkBotFootB);
//		
		junkBotJaw.addBone(junkBotHead);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/SpecialStageActor/SpecialStageActor'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/SpecialStageActor/SpecialStageActor'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/SpecialStageActor/SpecialStageActor'] = exports; exports.SpecialStageActor = CivilianActorFight.subclass
({
	classname : 'SpecialStageActor',
	
	initialize : function()
	{

	},
	
	initActorSpecificData : function($super)
	{
		$super();
		this._spriteFileName = "IceCreamStage.png";
		this._type = kActorTypeCivilian;
		this._state = kActorFightStateWait;
	},
	
	initSpriteDictionary : function()
	{
		this._spriteFrameFile = DataPreloader._iceCreamStageDictionary; //"IceCreamStage.plist";
//		this._spriteDictionary = DataPreloader._iceCreamStageDictionary2;
		this._skeletonDictionary = DataPreloader._skeletonDictionary;
	},
	
	initSprite : function($super)
	{
		$super();
		this._spriteMan.setScale(1);
	},
	
	startAnim : function(animID, interrupt){
		return;
		if(animID != kActorAnimVictory)
		{
			// stops animation when finished by reseting to defaults
			this.resetColor();
//			this.resetAttachmentScaleInterpolate(true);
//			this.resetAttachmentPositionsInterpolate(true);
//			this.resetAttachmentRotationInterpolate(true);
		}
		
		if(animID == kActorAnimAttack)
		{
			var asc = this.getFightAttackSpeed();
			// all attacks pulled from attack anim class
			this._fightData._attacking = true;
			if (!this.isScheduled(this.doneAttacking))
			{
				this.schedule(this.doneAttacking, asc);
			}
			if(!this._stopped){
				for (var key in this._attachments)
				{
					var a = this._attachments[key];
					if (a == null)
						continue;
					a._sprite.stopAllActions();
					a.stopAllActions();
				}
				this._stopped = true;
			}
			return;
		}
	
		
		this._stopped = false;
		var fm = ZFFightMan;
		
		if(!this._attachments || this._attachments.length <= 0)
		{
			return;
		}
		
		var arm1 = this._attachments[kActorPartTagArmF];
		var fist1 = this._attachments[kActorPartTagFistF];
		var arm2 = this._attachments[kActorPartTagArmB];
//		var fist2 = this._attachments[kActorPartTagFistB];
		var foot1 = this._attachments[kActorPartTagFootF];
		var foot2 = this._attachments[kActorPartTagFootB];
		var body = this._attachments[kActorPartTagBody];
		var head = this._attachments[kActorPartTagHead];
		
		var asc = this.getFightAttackSpeed();
		var s = this._animSpeed;
		var f = (head._sprite.flipX() ) ? -1 : 1;
		
		if(interrupt)
		{
			for (var key in this._attachments)
			{
				var a = this._attachments[key];
				if (a == null)
					continue;
				a._sprite.stopAllActions();
				a.stopAllActions();
			}
		}
		
//		if(animID != kActorAnimVictory)
//		{
//			// stops animation when finished by reseting to defaults
//			this.resetColor();
//			this.resetAttachmentScaleInterpolate(true);
//			this.resetAttachmentPositionsInterpolate(true);
//			this.resetAttachmentRotationInterpolate(true);
//		}
		
		switch(animID)
		{
			case kActorAnimIdle:
			{				
				if ( this instanceof SpecialStageActorBoss )
				{
					var actions = new Array();
					actions[0] = CCRotateTo.actionWithDuration(s*0.4, f*2.5);
					actions[1] = CCRotateTo.actionWithDuration(s*0.4, f*0);
					actions[2] = null;
//					body.loopS(CCSequence.actions(actions));
//					body.loopS(ZFAnims.bodyBreatheScale(2, body._scale));
				}
				
				if(this instanceof SpecialStageActorMinion1)
				{
					var actions = new Array();
					actions[0] = CCRotateTo.actionWithDuration(s*0.25, f*5);
					actions[1] = CCRotateTo.actionWithDuration(s*0.5, f*-5);
					actions[2] = CCRotateTo.actionWithDuration(s*0.25, f*0);
					actions[3] = null;
					body.loopS(CCSequence.actions(actions));
					body.loopS(ZFAnims.bodyBreatheScale(2, body._scale));
					
					actions[0] = CCRotateTo.actionWithDuration(s*0.25, f*-5);
					actions[1] = CCRotateTo.actionWithDuration(s*0.5, f*5);
					actions[2] = CCRotateTo.actionWithDuration(s*0.25, f*0);
					arm1.loopS(CCSequence.actions(actions));
				}
				
				if(this instanceof SpecialStageActorMinion2)
				{
				}
				
			}
				break;
				
			case kActorAnimWalk:
			{				
				if ( this instanceof SpecialStageActorBoss )
				{
					
					foot1.loop(ZFAnims.footWalkFrontMove(s));
					foot2.loop(ZFAnims.footWalkBackMove(s));
					foot1.loopS(ZFAnims.footWalkFrontRotate(s,f));
					foot2.loopS(ZFAnims.footWalkFrontRotate(s,f));
//					foot2.loopS(ZFAnims.footWalkBackRotate(s));
					body.loop(ZFAnims.bodyWalkMove(s));
					head.loop(ZFAnims.headWalkMove(s, ccp(0,0)));
				}
				
				if(this instanceof SpecialStageActorMinion1)
				{
					var actions = new Array();
					actions[0] = CCRotateTo.actionWithDuration(s*0.25, f*10);
					actions[1] = CCRotateTo.actionWithDuration(s*0.5, f*-10);
					actions[2] = CCRotateTo.actionWithDuration(s*0.25, f*0);
					actions[3] = null;
					body.loopS(CCSequence.actions(actions));
					
					actions[0] = CCRotateTo.actionWithDuration(s*0.25, f*-25);
					actions[1] = CCRotateTo.actionWithDuration(s*0.5, f*25);
					actions[2] = CCRotateTo.actionWithDuration(s*0.25, f*0);
					arm1.loopS(CCSequence.actions(actions));
					
					actions[0] = CCRotateTo.actionWithDuration(s*0.25, f*35);
					actions[1] = CCRotateTo.actionWithDuration(s*0.5, f*-15);
					actions[2] = CCRotateTo.actionWithDuration(s*0.25, f*0);
					arm2.loopS(CCSequence.actions(actions));
				}
				
				if(this instanceof SpecialStageActorMinion2)
				{
				}
				
			}
				break;
				
			case kActorAnimAttack:
			{
				// all attacks pulled from attack anim class
				this._fightData._attacking = true;
				if (!this.isScheduled(this.doneAttacking))
				{
					this.schedule(this.doneAttacking, asc);
				}
				
				var attackAnimID = this._fightData._currentAttackVariation["animID"];
				ZFAttackAnims.performAttackWithID(attackAnimID, this);
			}
				break;
				
			case kActorAnimThrow:
			{
				var throwSpeedFromSheet = fm._enemyDictionary["throwSpeed"];
				var throwSpeed = throwSpeedFromSheet ? throwSpeedFromSheet : 1;
				//throwSpeed = throwSpeed * 2.f / 3.f;
				throwSpeed = (throwSpeed > 1) ? 1 : throwSpeed;
				
				var actions = new Array();
				actions[0] = CCRotateTo.actionWithDuration(throwSpeed*0.5, f*-45);
				actions[1] = CCRotateTo.actionWithDuration(throwSpeed*0.1, f*100);
				actions[2] = CCDelayTime.actionWithDuration(throwSpeed*0.2);
				actions[3] = CCRotateTo.actionWithDuration(throwSpeed*0.2, f*0);
				actions[4] = null;
				arm1.onceS(CCSequence.actions(actions));
				
				actions[0] = CCRotateTo.actionWithDuration(throwSpeed*0.5, f*10);
				actions[1] = CCRotateTo.actionWithDuration(throwSpeed*0.1, f*120);
				actions[2] = CCDelayTime.actionWithDuration(throwSpeed*0.2);
				actions[3] = CCRotateTo.actionWithDuration(throwSpeed*0.2, f*0);
				actions[4] = null;
				fist1.onceS(CCSequence.actions(actions));
				
			}
				break;
		}
	},
	
	destroy : function()
	{
		
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/SpecialStageActor/SpecialStageActorBoss'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/SpecialStageActor/SpecialStageActorBoss'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/SpecialStageActor/SpecialStageActorBoss'] = exports; exports.SpecialStageActorBoss = SpecialStageActor.subclass
({
	classname : 'SpecialStageActorBoss',
	
	initialize : function()
	{
		
	},
	
	initSprite : function($super)
	{
		$super();
		
		this._savedColor = ccc3(0,0,0);
		
		this._frameOffset = ccp(10,70);

		var armF = this.addAttachment(kActorPartTagArmF, "icecream_boss_arm_upper.png");
		var armB = this.addAttachment(kActorPartTagArmB, "icecream_boss_arm_upper.pngB");
//		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmF, this._spriteDictionary["frames"]["icecream_boss_arm_upper.png"]);

//		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmB, this._spriteDictionary["frames"]["icecream_boss_arm_upper.pngB"]);

		var body = this.addAttachment(kActorPartTagBody, "icecream_boss_body.png");
//		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagBody, this._spriteDictionary["frames"]["icecream_boss_body.png"]);

//		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFistF, this._spriteDictionary["frames"]["icecream_boss_arm_lower_front.png"]);
//		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFistB, this._spriteDictionary["frames"]["icecream_boss_arm_lower_back.png"]);

		var footF = this.addAttachment(kActorPartTagFootF, "icecream_boss_leg.png");
		var footB = this.addAttachment(kActorPartTagFootB, "icecream_boss_leg.pngB");
//		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFootF, this._spriteDictionary["frames"]["icecream_boss_leg.png"]);
//		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagFootB, this._spriteDictionary["frames"]["icecream_boss_leg.pngB"]);

		var head = this.addAttachment(kActorPartTagHead, "icecream_boss_head.png");
//		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagHead, this._spriteDictionary["icecream_boss_head.png"]);
//		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagHead, this._spriteDictionary["frames"]["icecream_boss_head.png"]);
		var cape = this.addAttachment(kActorPartTagButt, "icecream_boss_cape.png");
//		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagButt, this._spriteDictionary["frames"]["icecream_boss_cape.png"]);
		var fistF  = this.addAttachment(kActorPartTagFistF, "icecream_boss_arm_lower_front.png");
		var fistB  = this.addAttachment(kActorPartTagFistB, "icecream_boss_arm_lower_back.png");
		
//		armF.addBone(fistF);
//		armB.addBone(fistB);
//		body.addBone(armF);
//		body.addBone(armB);
//		body.addBone(head);
//		body.addBone(cape);
//		body.addBone(footF);
//		body.addBone(footB);
		
		this._spriteMan.setScale(1);
	},
	
	initFightDataAfterLoad : function($super)
	{
		$super();
		this._fightData._lifeBarOffset = ccp(0,50);
	},
	
	jumpActionDone : function()
	{
		this.setState(kActorFightStateGo);
	},
	
//	bossUpdate : function($super, dt)
//	{
//		var fm = ZFFightMan;
//		
//		if (this._state == kActorFightStateBossGoDown)
//		{
//			this.moveToPoint(ccp(fm._bossPosition._x + 200, fm._bossPosition._y ));
//			this.setState(kActorFightStateBossGoingDown) ;
//		}
//		else if (this._state == kActorFightStateBossGoingDown)
//		{
//			this.movementUpdate(dt);
//			
//			if (CGPointEqualToPoint(this.getPosition(), this._destinationPoint))
//			{
//				this.setPosition(ccp(fm._bossPosition._x + 200, fm._enemyPosition._y ));
//				this.setState(kActorFightStateGo);
//				this._spriteMan._parent.reorderChild(this._spriteMan, 3);
//			}
//		}
//
//		
//		return $super(dt);
//		
//		
//	},
	
	movementUpdate : function($super, dt)
	{
		$super(dt);
	},
	
	initActorSpecificAbilities : function()
	{
		//clear the list
		if(this._abilityList)
		{
			this._abilityList.length = 0;
			this._abilityList = null;
			
			this._abilityList = new Array();
		}
		var ability;
		ability = new ZFActorFightEffect();
		ability.initWithTag(kFightEffectEnemyBuffEnrage);
		this._abilityList.push(ability);
		
		var ability2;
		ability2 = new ZFActorFightEffect();
		ability2.initWithTag(kFightEffectEnemyDebuffIce);
		this._abilityList.push(ability2);
		
		ability._unlocked = true;
		ability2._unlocked = true;
	},
	
	destroy : function()
	{
		
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/SpecialStageActor/SpecialStageActorMinion1'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/SpecialStageActor/SpecialStageActorMinion1'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/SpecialStageActor/SpecialStageActorMinion1'] = exports; exports.SpecialStageActorMinion1 = SpecialStageActor.subclass
({
	classname : 'SpecialStageActorMinion1',
	
	initialize : function()
	{	
		
	},
	
	colorFromSubType : function(actorSubType)
	{
		return this._savedColor;
	},
	
	initSprite: function($super)
	{
		$super();
			
		this._savedColor = ccc3(255,255,255);
		this._frameOffset = ccp(0,80);
		
		var armF = this.addAttachment(kActorPartTagArmF,"icecream_minion_arm_front.png");
		var armB = this.addAttachment(kActorPartTagArmB, "icecream_minion_arm_back.png");
		var body = this.addAttachment(kActorPartTagBody, "icecream_minion_body.png");
//		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmF, this._spriteDictionary["frames"]["icecream_minion_arm_front.png"]);
//		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagArmB, this._spriteDictionary["frames"]["icecream_minion_arm_back.png"]);
//		this.addAttachmentFromPlist_withSpriteDetails(kActorPartTagBody, this._spriteDictionary["frames"]["icecream_minion_body.png"]);
		
		body.addBone(armF);
		body.addBone(armB);
		
		this._spriteMan.setScale(1.0 / 1.25);
	},
	
	initFightDataAfterLoad: function($super)
	{
		$super();
			
		this._fightData._lifeBarOffset = ccp(0,100);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Enemies/SpecialStageActor/SpecialStageActorMinion2'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/SpecialStageActor/SpecialStageActorMinion2'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Enemies/SpecialStageActor/SpecialStageActorMinion2'] = exports; exports.SpecialStageActorMinion2 = SpecialStageActor.subclass
({
	classname : 'SpecialStageActorMinion2',
	
	initialize : function()
	{	
		
	},
	
	colorFromSubType : function(actorSubType)
	{
		return this._savedColor;
	},
	
	initSprite: function($super)
	{
		$super();
	},
	
	destroy : function()
	{
		
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Animation'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Animation'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Animation'] = exports; var Core = require('NGCore/Client/Core').Core;
var liveInstances = 0;

exports.Animation = Core.Class.subclass(
/** @lends GL2.Animation.prototype */
{
	classname: 'Animation',
    
	/**
	 * @class The <code>Animation</code> class constructs objects that define application animations. Animations aggregate and control 
	 * the instantiation of <code>Frame</code> objects for manipulation of <code>{@link GL2.Sprite}</code> and
	 * <code>{@link GL2.Primitive}</code> objects. Each <code>Frame</code> object defines a duration and an image display area. 
	 * <code>Frame</code> objects also include a pre-transform 
	 * offset that define the rotation and scale of sprite images. 
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */
    initialize: function()
    {
		Core.ObjectRegistry.register(this);
		
        this._wrapMode = this.WrapMode.WrapNone;
        this._blendEnabled = true;
        this._blendMode = this.BlendMode.Alpha;
        this._filteringEnabled = true;
		this._loopingEnabled = true;
		this._totalDuration = 0;
		this._frames = [];
		
		this._createSendGen(this.__objectRegistryId);
		
		//FPS
		if (FPS.leakCheck)
	    {
	        try
	        {
	            throw new Error();
	        }
	        catch (e)
	        {
	            FPS.trackObj(this, 'Node', e);
	        }
	    }
	    liveInstances++;
    },

	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		//FPS
		if (FPS.leakCheck)
	    {
	        FPS.untrackObj(this);
	    }
	    liveInstances--;
	    
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
	
	$getLiveInstances: function(){
		return liveInstances;
	},
	/**
	 * Retrieve the specified texture wrap mode for this <code>Animation</code>.
	 * @returns {GL2.Animation#WrapMode} The current texture wrap mode.
	 * @see GL2.Animation#setWrapMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getWrapMode: function()
	{
		return this._wrapMode;
	},
	
	/**
	 * Retrieve the alpha blending state for this <code>Animation</code>.
	 * @returns {Boolean} Returns <code>true</code> if alpha blending is enabled. Returns <code>false</code> in all other cases.
	 * @see GL2.Animation#setBlendEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBlendEnabled: function()
	{
		return this._blendEnabled;
	},
	
	/**
	 * Retrieve the filtering state for this <code>Animation</code>. 
	 * @returns {Boolean} Returns <code>true</code> if filtering is enabled. Returns <code>false</code> in all other cases.
	 * @see GL2.Animation#setFilteringEnabled
	 */
	getFilteringEnabled: function()
	{
		return this._filteringEnabled;
	},
	
	/**
	 * Retrieve the looping state of this <code>Animation</code>.
	 * @returns {Boolean} Returns <code>true</code> if looping is enabled. Returns <code>false</code> in all other cases.
	 * @see GL2.Animation#setLoopingEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLoopingEnabled: function()
	{
		return this._loopingEnabled;
	},
	
	/**
	 * Retrieve the total duration of this <code>Animation</code> in milliseconds.
	 * @returns {Number} The current duration. 
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTotalDuration: function()
	{
		return this._totalDuration;
	},
	
	/**
	 * Retrieve the total number of frames in this <code>Animation</code>.
	 * @returns {Number} The current number of frames. 
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrameCount: function()
	{
		return this._frames.length;
	},
	
	/**
	 * Retrieve a frame at the specified index for this <code>Animation</code>.
	 * @param {Number} index The specified index.
	 * @returns {GL2.Animation.Frame} The current frame at the specified index.
	 * @see GL2.Animation#setFrame
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrame: function(index)
	{
		return this._frames[index];
	},
    
    /**
	 * Apply a wrap mode to frame textures for this <code>Animation</code>.
	 * @param {GL2.Animation#WrapMode} [wrapMode=0] The new texture wrap mode.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation#getWrapMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */						
    setWrapMode: function(wrapMode)
	{
		this._wrapMode = wrapMode;
		
		this._setWrapModeSendGen(wrapMode);
		
		return this;
	},
    
    /**
	 * Set the alpha blending state for this <code>Animation</code>. 
	 * <br><br>
	 * <b>Note:</b> You can improve performance for animations with completely opaque frames by disabling alpha blending.
	 * @param {Boolean} [blendEnabled=true] Set as <code>true</code> to enable alpha blending.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation#getBlendEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setBlendEnabled: function(blendEnabled)
	{
		this._blendEnabled = blendEnabled;
		
		this._setBlendEnabledSendGen(blendEnabled);
		
		return this;
	},
	
	/**
	 * Set the alpha blend mode.
	 * @see GL2.Animation#setBlendEnabled
	 * @status Android,AndroidTested
	 */
	setBlendMode: function(blendMode)
	{
		this._blendMode = blendMode;
		
		this._setBlendModeSendGen(blendMode);
		
		return this;
	},
	
	getBlendMode: function()
	{
		return this._blendMode;
	},
	
    /**
	 * Set the filtering state for this <code>Animation</code>.
	 * <br><br>
	 * @param {Boolean} [filteringEnabled=false] Set as <code>true</code> to enable filtering. 
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation#getFilteringEnabled
	 */
    setFilteringEnabled: function(filteringEnabled)
	{
		this._filteringEnabled = filteringEnabled;
		
		this._setFilteringEnabledSendGen(filteringEnabled);
		
		return this;
	},
    
    /**
	 * Set the looping state for this <code>Animation</code>.
	 * @param {Boolean} [loopingEnabled=false] Set as <code>true</code> to enable animation looping.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation#getLoopingEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setLoopingEnabled: function(loopingEnabled)
	{
		this._loopingEnabled = loopingEnabled;
		
		this._setLoopingEnabledSendGen(loopingEnabled);
		
		return this;
	},
    
    /**
	 * Add a frame to the end of this <code>Animation</code>.<br><br>
	 * <pre class="code"><font size="2">var animation = new GL2.Animation();
	 * animation.pushFrame(new GL2.Animation.Frame('Content/tank.png', 50, [64, 64], [0.5, 0.5], [0/5, 0, 1/5, 1]));</font></pre>
	 * Calling <code>pushFrame()</code> is equivalent to calling <code>spliceFrames()</code> in the following way: 
	 * <pre class="code"><font size="2">animation.spliceFrames(animation.getFrameCount(), 0, frame);</font></pre>
	 * @param {GL2.Animation.Frame} frame The frame to add.
	 * @see GL2.Animation#spliceFrames
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    pushFrame: function(frame)
	{
		return this.spliceFrames(this._frames.length, 0, frame);
	},
    
    /**
	 * Replace the frame at index <i>i</i>.<br><br>
	 * Calling <code>setFrame()</code> is equivalent to calling <code>spliceFrames()</code> in the following way: 
	 * @example animation.spliceFrames(i, 1, frame)
	 * @param {Number} i Index of the frame to replace.
	 * @param {GL2.Animation.Frame} frame The frame to insert.
	 * @see GL2.Animation#getFrame,
	 * @see GL2.Animation#spliceFrames
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setFrame: function(i, frame)
	{
		return this.spliceFrames(i, 1, frame);
	},
    
    /**
	 * Remove a specific number of frames from this <code>Animation</code> and replace them with specified frames.
	 * <br><br>
	 * <b>Note:</b> This method accepts multiple parameters. The third parameter and beyond define all
	 * <code>Frames</code> to use for replacement.<br><br>
	 * The following example passes in three frames to a <code>spliceFrames()</code> call.
	 * @example animation.spliceFrames(0, 0, frame1, frame2, frame3).
	 * @param {Number} start The index of the first frame to remove.
	 * @param {Number} len The total number of frames to remove.
	 * @param {GL2.Animation.Frame} frames The frames to insert. 
	 * <br><br>
	 * <b>Note:</b> This parameter accepts multiple values.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    spliceFrames: function(start, len, frames)
	{
		var i;
		var frameCount = arguments.length-2;
		var frame;

		// Determine if we should use the v2 version of the messsage, which supports renderTargets.
		// This is so that new javaScript that doesn't use renderTargets will still work with an old binary.
		var useV2 = false;
		for (i = 0; i < frameCount; ++i) {
			frame = arguments[i+2];
			if (frame.getImage().classname === 'RenderTarget')
				useV2 = true;
		}

		// Decrement from total duration.
		for (var i=start; i < start + len; ++i) {
			this._totalDuration -= this._frames[i].getDuration();
		}
		
		this._frames.splice.apply(this._frames, arguments);

		if (useV2) {
			this._spliceFrames2SendGen(start, len, frameCount);
		} else {
			this._spliceFramesSendGen(start, len, frameCount);
		}
		
		for (i = 0; i < frameCount; ++i)
		{
			frame = arguments[i+2];
			var duration = frame.getDuration();
			var size = frame.getSize();
			var anchor = frame.getAnchor();
			var uvs = frame.getUVs();
			var uvOrigin = uvs.getOrigin();
			var uvSize = uvs.getSize();
			var image = frame.getImage();

			// if image is a renderTarget
			var renderTargetID = 0;
			if (image.classname === 'RenderTarget') {
				renderTargetID = image.__objectRegistryId;
				image = '';
			}

			if (useV2) {
				this._frame2SendGen(image,
									renderTargetID,
									duration,
									size.getWidth(),
									size.getHeight(),
									anchor.getX(),
									anchor.getY(),
									uvOrigin.getX(),
									uvOrigin.getY(),
									uvSize.getWidth(),
									uvSize.getHeight());
			} else {
				this._frameSendGen(image,
								   duration,
								   size.getWidth(),
								   size.getHeight(),
								   anchor.getX(),
								   anchor.getY(),
								   uvOrigin.getX(),
								   uvOrigin.getY(),
								   uvSize.getWidth(),
								   uvSize.getHeight());
			}
			this._totalDuration += duration;
		}
		
		return this;
	},
	
	$Frame: Core.Class.subclass(
	/** @lends GL2.Animation.Frame.prototype */
	{
		classname: 'Frame',
		
		/**
		 * @class <code>Frame</code> objects define a path to an image and any properties that support the image as
		 * a single frame in an animation.
		 * @constructs The default constructor. 
		 * @param {String|GL2.RenderTarget} image The directory path to an image, or an instance of GL2.RenderTarget.
		 * @param {Number} duration The time duration of the frame in milliseconds.
		 * @param {Core.Size} size The size of the frame in pixels.
		 * @param {Core.Point} anchor The offset within the frame used for scaling and rotation.
		 * @param {Core.Rect} uvs The image region to use for the frame. The default value is <code>[0,0,1,1]</code> (the entire image) 
		 * with a start coordinate of <code>(0,0)</code> and a size of <code>(1,1)</code>.<br><br> 
		 * <b>Example:</b> To select the lower left region of an image with nine distinct frames (three horizontally, three vertically), 
		 * you would specify <code>[0, 0.66, 0.33, 0.33]</code>. The start coordinate is <code>(0, 0.66)</code>, 
		 * which is the left edge of the image and 2/3rds down. 
		 * The size is <code>(0.33, 0.33)</code> which is a third of the image in each <i>x</i> and <i>y</i> direction.
		 * @see GL2.Animation
		 * @default [0,0,1,1] (the entire image)
		 * @augments Core.Class
		 */
		initialize: function(image, duration, size, anchor, uvs)
		{
			this._image     = image;
			this._duration  = duration || 0;
			this._size   = new Core.Size(size);
			
			if(anchor)
				this._anchor = new Core.Point(anchor);
			else
				this._anchor = new Core.Point(0.5, 0.5);
			
			if(uvs)
				this._uvs = new Core.Rect(uvs);
			else
				this._uvs = new Core.Rect(0, 0, 1, 1);
		},

		/**
		 * Retrieve the image directory path or the renderTarget referenced by this <code>Frame</code>.
		 * @returns {String|GL2.RenderTarget} The current directory path to the image, or a GL2.RenderTarget instance.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getImage:    function()
		{
			return this._image;
		},
		
		/**
		 * Retrieve time duration in milliseconds for this <code>Frame</code>.
		 * @returns {Number} The current time duration for the frame.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getDuration:  function()
		{
			return this._duration;
		},

		/**
		 * Retrieve the pixel size of this <code>Frame</code>.
		 * @returns {Core.Size} The current frame size in pixels.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getSize:    function()
		{
			return this._size;
		},

		/**
		 * Retrieve the offset used for scaling and rotation from within this <code>Frame</code>.
		 * @returns {Core.Point} The current frame offset.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getAnchor:  function()
		{
			return this._anchor;
		},

		/**
		 * Retrieve the texture rectangle for this <code>Frame</code> in UV coordinates.
		 * @returns {Core.Rect} The current UV bounds of the frame within the texture.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getUVs:    function()
		{
			return this._uvs;
		},
	}),
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for UV wrapping modes.
	 * @namespace
	 */
	WrapMode:
	{ 
		/** Clamp in both U and V. */
		WrapNone: 0,
		/** Wrap in U, clamp in V. */
		WrapU: 1,
		/** Wrap in V, clamp in U. */
		WrapV: 2,
		/** Wrap in both U and V. */
		WrapUV: 3,
	},
	
	/** 
	 * Enumeration for Blend modes.
	 * @namespace
	 */
	BlendMode:
	{ 
		/** blend func: (src alpha, 1 - src alpha). */
		Alpha: 1,
		/** blend func: (src alpha, 1). */
		Add: 2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 306
	// Method create = -1
	// Method destroy = 2
	// Method setWrapMode = 3
	// Method setBlendEnabled = 4
	// Method setLoopingEnabled = 5
	// Method spliceFrames = 6
	// Method frame = 7
	// Method setFilteringEnabled = 8
	// Method spliceFrames2 = 9
	// Method frame2 = 10
	// Method setBlendMode = 11
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Animation._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Animation._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[306] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":306,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":306,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setWrapModeSendGen: function( wrapMode )
	{
		Core.Proc.appendToCommandString( ":306,3," + this.__objectRegistryId + "," + wrapMode  );
	},
	
	/** @private */
	_setBlendEnabledSendGen: function( blendEnabled )
	{
		Core.Proc.appendToCommandString( ":306,4," + this.__objectRegistryId + "," + ( blendEnabled ? 1 : 0 )  );
	},
	
	/** @private */
	_setLoopingEnabledSendGen: function( loopingEnabled )
	{
		Core.Proc.appendToCommandString( ":306,5," + this.__objectRegistryId + "," + ( loopingEnabled ? 1 : 0 )  );
	},
	
	/** @private */
	_spliceFramesSendGen: function( start, len, frameCount )
	{
		Core.Proc.appendToCommandString( ":306,6," + this.__objectRegistryId + "," + start + "," + len + "," + frameCount  );
	},
	
	/** @private */
	_frameSendGen: function( image, duration, width, height, anchorX, anchorY, startU, startV, sizeU, sizeV )
	{
		Core.Proc.appendToCommandString( "," + Core.Base64.encode( image ) + "," + duration + "," + width + "," + height + "," + anchorX + "," + anchorY + "," + startU + "," + startV + "," + sizeU + "," + sizeV  );
	},
	
	/** @private */
	_setFilteringEnabledSendGen: function( filteringEnabled )
	{
		Core.Proc.appendToCommandString( ":306,8," + this.__objectRegistryId + "," + ( filteringEnabled ? 1 : 0 )  );
	},
	
	/** @private */
	_spliceFrames2SendGen: function( start, len, frameCount )
	{
		Core.Proc.appendToCommandString( ":306,9," + this.__objectRegistryId + "," + start + "," + len + "," + frameCount  );
	},
	
	/** @private */
	_frame2SendGen: function( image, renderTargetID, duration, width, height, anchorX, anchorY, startU, startV, sizeU, sizeV )
	{
		Core.Proc.appendToCommandString( "," + Core.Base64.encode( image ) + "," + renderTargetID + "," + duration + "," + width + "," + height + "," + anchorX + "," + anchorY + "," + startU + "," + startV + "," + sizeU + "," + sizeV  );
	},
	
	/** @private */
	_setBlendModeSendGen: function( blendMode )
	{
		Core.Proc.appendToCommandString( ":306,11," + this.__objectRegistryId + "," + blendMode  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setWrapMode: function( wrapMode ) {}
	
	// setBlendEnabled: function( blendEnabled ) {}
	
	// setLoopingEnabled: function( loopingEnabled ) {}
	
	// spliceFrames: function( start, len, frameCount ) {}
	
	// frame: function( image, duration, width, height, anchorX, anchorY, startU, startV, sizeU, sizeV ) {}
	
	// setFilteringEnabled: function( filteringEnabled ) {}
	
	// spliceFrames2: function( start, len, frameCount ) {}
	
	// frame2: function( image, renderTargetID, duration, width, height, anchorX, anchorY, startU, startV, sizeU, sizeV ) {}
	
	// setBlendMode: function( blendMode ) {}
	

// {{/Wg Generated Code}}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Node'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Node'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Node'] = exports; var Core = require('NGCore/Client/Core').Core;
var liveInstances = 0;
exports.Node = Core.Class.subclass(
/** @lends GL2.Node.prototype */
{
	classname: 'Node',
	
	/**
	 * @class The <code>Node</code> class constructs base class objects that contain positionable elements in the GL2 module. 
	 * Applications can use <code>Node</code> objects for grouping and organizing the scene graph. 
	 * <p>
	 * Inside the <code>{@link UI.GLView}</code> class, positionable elements are organized into a node hierarchy. This data
	 * structure is analgous to a scene graph or a node tree. Child nodes inherit data for
	 * transform, visibility, and depth from the parent on a conditional basis. Most drawable attributes for nodes, such as size and color, are specified in 
	 * derived classes. 
	 *</p><p>
	 * All derived GL2 classes from <code>Node</code> are native-backed proxies including <code>Node</code>.
	 * When a <code>Node</code> is instantiated on the Javascript side, a C++ object
	 * is instantiated and managed for the user on the native backend. This condition means the application
	 * must explicity destroy any <code>Node</code> that is no longer used.
	 *</p><p>
	 * A <code>Node</code> can exist independent of the scene, but it will only receive draw or touch updates
	 * when it is attached to the root tree.
	 *</p>
	 *<div class="ul">
	 * <li>Add a node as a child to the root of the scene with <code>{@link GL2.Root#addChild}</code>.</li> 
	 * <li>Add a node as a child to another node with <code>{@link GL2.Node#addChild}</code>.</li>
	 * <li>Remove a node from the root of the scene with <code>{@link GL2.Root#removeChild}.</code></li>
	 * <li>Remove a child node from a parent node with <code>{@link GL2.Node#removeChild}</code>.</li> 
	 *</div><br>
	 * <p>
	 * Call <code><a href="GL2.Node.html#destroy">destroy()</a></code> to automatically remove a node from the parent node.
	 * As previously noted, nodes are supported by a native object on the backend. Maintaining a 
	 * node reference outside of the scene instead of calling <code>destroy()</code> and recreating a new node is a recommended best practice.
	 *</p><p>
	 * Absolute positioning of a single node is determined by the following properties in the defined order:
	 *</p>
	 *<div class="ol">
	 * <li>Scale (two-component [x,y] multiple)</li>
	 * <li>Rotation (degrees about z-axis)</li>
	 * <li>Position (two-component translation)</li>
	 *</div><br>
	 * <p>
	 * Each of these properties is applied to the node relative to the parent node. The final transform
	 * for any given node is the concatenation of each transform in the node graph ancestry. The
	 * root ancestor is fixed to the view and composes the scene so that <code>(0,0)</code> is in the upper
	 * left corner. The first anchored
	 * offset to rotate and scale around is not specified because nodes do not inherently contain a size <code>(see {@link GL2.Animation.Frame#getAnchor}</code>). 
	 *</p><p>
	 * The <code>Depth</code> property of a <code>Node</code> object determines that <code>Node</code> sort order when traversing the scene graph.
	 * Depth is roughly equivalent to z-order or index. Each node is sorted among siblings by
	 * <code>Depth</code>, starting with the lowest depth node and sorting in ascending order.
	 *</p><p>
	 * By default, <code>Nodes</code> are grouped 
	 * with their siblings (not interleaved with cousins) and sorted relative to their parent 
	 * as if the parent depth value was <code>0</code>. However, you can modify this behavior for specific use cases 
	 * with <code><a href="GL2.Node.html#setChildrenDepthGrouped">setChildrenDepthGrouped()</a></code>. 
	 *</p><p>
	 * The node depth (order) in the scene graph will dictate the drawing order and determines what the final frame will look like.
	 * When drawing, <code>GL2.Node</code> utilizes the painter's algorithm.
	 * This means lower depth nodes are obscured by higher depth nodes.
	 * Touch priority occurs in reverse order to drawing order. Touches travel through the scene from higher depth to lower depth nodes 
	 * (front of scene earlier to back of scene later).
	 *</p><p>
	 * As a base class, a <code>Node</code> is not drawable but does maintain <code>Color</code> and <code>Alpha</code>
	 * attributes (see <code><a href="GL2.Node.html#getColor">getColor()</a></code> and <code><a href="GL2.Node.html#getAlpha">getAlpha()</a></code>). 
	 * Child nodes that contain drawable derived classes from 
	 * <code>Node</code> inherit these attributes.
	 * As a result, setting the <code>Color</code> for a parent node affects the color of every child node through multiplication
	 * of color components.</p>
	 * <p>Classes derived from Node include:</p>
	 * <div class="ul">
	 * <li>{@link GL2.Primitive}</li>
	 * <li>{@link GL2.Sprite}</li>
	 * <li>{@link GL2.Text}</li>
	 * </div>
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
    initialize: function()
    {
		Core.ObjectRegistry.register(this);
        this._parent = null;
        this._position = new Core.Point();
        this._scale = new Core.Vector(1, 1);
        this._color = new Core.Color(1, 1, 1);
        this._alpha = 1;
        this._rotation = 0;
        this._depth = 0;
        this._visible = true;
        this._touchable = true;
		
        this._childrenDepthGrouped = true;
        this._children = [];
		
		this._createSendGen(this.__objectRegistryId);
		
		//FPS
		if (FPS.leakCheck)
	    {
	        try
	        {
	            throw new Error();
	        }
	        catch (e)
	        {
	            FPS.trackObj(this, 'Node', e);
	        }
	    }
	    liveInstances++;
    },

	/**
	 * The default destructor. Calling <code>destroy()</code> removes the node from the parent, which releases the
	 * native object on the backend. 
	 * <br><br>
	 * <b>Note:</b> Applications must call this explicitly for nodes that are no longer
	 * used.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		//FPS
		if (FPS.leakCheck)
	    {
	        FPS.untrackObj(this);
	    }
	    liveInstances--;
	    
	    
		children = this._children;
		while(children.length)
		{
			this.removeChild(children[0]);
		}
			
		if(this._parent)
		{
			this._parent.removeChild(this);
		}
		
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
		
	},

	$getLiveInstances: function(){
		return liveInstances;
	},
	/**
	 * Retrieve the position of this <code>Node</code>.
	 * @returns {Core.Vector} The current node position relative to the parent.
	 * @see GL2.Node#setPosition
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getPosition: function()
	{
		return this._position;
	},
	
	/**
	 * Retrieve the <i>width</i> and <i>height</i> scale multiple of this <code>Node</code>. 
	 * The default scale <code>[1,1]</code> will not modify the resulting transform.
	 * @returns {Core.Vector} The current scale multiple (<i>width</i> and <i>height</i>).
	 * @see GL2.Node#setScale
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getScale: function()
	{
		return this._scale;
	},

	/**
	 * Retrieve the <code>Color</code> component of this <code>Node</code>. Values for <code>Color</code> are based on the RGB color model. 
	 * When drawing, the values for <code>Color</code> are multiplied by the value of each drawable pixel. Child nodes will multiply
	 * the values for <code>Color</code> by the parent composite color before drawing. 
	 * @returns {Core.Color} The current value of all three color components (red, green, blue).
	 *<br><br>
	 * <b>Note:</b> The default RGB triplet <code>[1,1,1]</code> does not produce a color change.
	 * @see Core.Color, 
	 * @see GL2.Node#setColor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getColor: function()
	{
		return this._color;
	},

	/**
	 * Retrieve the <cod>alpha</code> components of this <code>Node</code>.
	 * @returns {Number} The new alpha blending state across the open interval ranging between <code>(0-1)</code>. 
	 * (0 = completely transparent, 1 = completely opaque). Expressed as a float.
	 * @see GL2.Node#setAlpha
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAlpha: function()
	{
		return this._alpha;
	},

	/**
	 * Retrieve the <code>rotation</code> component for this <code>Node</code>.
	 * The default value is 0 degrees about the z-axis.
	 * @returns {Number} The current degree of rotation. Expressed as a float.
	 * @see GL2.Node#setRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getRotation: function()
	{
		return this._rotation;
	},

	/**
	 * Retrieve the <code>depth</code> component for this <code>Node</code>.
	 * The default value is <code>0</code>.
	 * Applications will sort nodes with identical depth values by the last 
	 * time the node was attached to the root node graph.
	 * @returns {Number} The current node depth level (z-order). Expressed as a float.
	 * @see GL2.Root and 
	 * @see GL2.Node#setDepth
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getDepth: function()
	{
		return this._depth;
	},

	/**
	 * Retrieve the <code>visible</code> component for this <code>Node</code>.
	 * This component defines visibility of the node.
	 * The default value is <code>true</code>.<br><br>
	 * <b>Note:</b> A node can inherit the value of this component from parent nodes in the scene graph.
	 * @returns {Boolean} Returns <code>true</code> if the node is visible. Returns <code>false</code> in all other cases.
	 * @see GL2.Node#setVisible
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVisible: function()
	{
		return this._visible;
	},

	/**
	 * Retrieve the <code>touchable</code> component for this <code>Node</code>.
	 * This component defines touch-support for a node.
	 * The default value is <code>true</code>.<br><br>
	 * <b>Note:</b> A node can inherit "not touchable" from parent nodes in the scene graph.
	 * @returns {Boolean} Returns <code>true</code> if a node is touchable. Returns <code>false</code> in all other cases.
	 * @see GL2.Node#setTouchable
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTouchable: function()
	{
		return this._touchable;
	},
	

	/**
	 * Retrieve <code>childrenDepthGrouped</code> component of this <code>Node</code>.
	 * The default value is <code>true</code>.
	 * When <code>childrenDepthGrouped</code> is <code>false</code>, child nodes sort amongst (interleave 
	 * with) the children of the nearest depthgrouped ancestor.
	 * @returns {Boolean} Returns as <code>true</code> if sorting with ancestor siblings. Returns as <code>false</code> if sorting only with siblings in the graph.
	 * @see GL2.Node#setChildrenDepthGrouped
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getChildrenDepthGrouped: function()
	{
		return this._childrenDepthGrouped;
	},
	
	/**
	 * Retrieve the parent node for this <code>Node</code>.
	 * @returns {GL2.Node} The current parent node.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getParent: function()
	{
		return this._parent;
	},

	/**
	 * Retrieve a copy of the child array for this <code>Node</code>.
	 * @returns {Array GL2.Node} The current list of child nodes.
	 * @status 
	 */
	getChildren: function()
	{
		return this._children.slice();
	},
	
    /**
	 * Set the <code>translation</code> component of the transform for this <code>Node</code>.
	 * You can define the parameter value as a vector or two floats.<br><br>
	 * <b>Note:</b> An application can use this property to translate a group of nodes by
	 * translating the parent. Child nodes inherit this property from the parent node.<br/><br/>
	 * The following code examples illustrate different call styles for <code>setPosition()</code>.<br><br>
	 * 
	 * @example
	 * node.setPosition(new Core.Vector(50, 100));
	 *
	 * @example
	 * node.setPosition(50, 100);
	 * 
	 * @param {Core.Vector} position The new node position relative to the parent.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getPosition,
	 * @see Core.Vector
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setPosition: function(position)
	{
		var p = this._position;
		p.setAll.apply(p, arguments);
		this._setPositionSendGen(p.getX(),p.getY());
		return this;
	},
	
    /**
	 * Set the <i>x</i> and <i>y</i> scale of the transform for this <code>Node</code>.<br><br>
	 * <b>Note:</b> This property affects the coordinate system of child nodes and scales drawing for
	 * derived classes like <code>Sprite</code>, <code>Text</code>, and <code>Primitive</code>.
	 * <br><br>
	 * The following code examples illustrate different call styles for <code>setScale()</code>.<br><br>
	 * 
	 * @example
	 * node.setScale(new Core.Vector(2, 0.5));
	 *
	 * @example
	 * node.setScale(2, 0.5);
	 * 
	 * @param {Core.Vector} scale The new scale multiple (<i>width</i> and <i>height</i>). You can define the parameter value as a vector or two floats.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getScale, 
	 * @see GL2.Primitive, 
	 * @see GL2.Sprite, 
	 * @see GL2.Text
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setScale: function(scale)
	{
		var s = this._scale;
		s.setAll.apply(s, arguments);
		this._setScaleSendGen(s.getX(),s.getY());
		return this;
	},
	/**
	 * Set the color for the specified entity. Call this method either by reference to a single vector object  
	 * or by defining three float parameters.
	 * Every color pixel value for the entity is multiplied by the value of the parameter before drawing.
	 * <br><br>
	 * <b>Example:</b> If you specify an entity to draw an orange pixel <code>(1.0, 0.5, 0)</code>,
	 * but the entity color is purple <code>(0.5, 0, 1.0)</code>, the resulting pixel color is
	 * <code>(0.5, 0, 0)</code>, which is dark red. The application conducts this efficiently for each pixel in the
	 * entity.<br><br>
	 * The following code examples illustrate different call styles for <code>setColor()</code>.<br><br>
	 * 
	 * @example
	 * node.setColor(new Core.Color(1.0, 0.5, 0));
	 *
	 * @example
	 * node.setColor(1.0, 0.5, 0);
	 * 
	 * @param {Core.Color} color Pixel color value to muliply by the entity color value.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color, 
	 * @see GL2.Node#getColor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setColor: function(color)
	{
		var c = this._color;
		c.setAll.apply(c, arguments);
		this._setColorSendGen(c.getRed(),c.getGreen(),c.getBlue());
		return this;
	},
    /**
	 * Set the alpha blending state for the entity.
	 * Each pixel of the entity blends with the underlying surface. This occurs in proportion to the alpha blending state of the entity.
	 * The application must set the parameter value within the open interval <code>[0, 1]</code>.
	 * <br><br>
	 * <b>Example:</b> Drawing a red entity with an alpha of <code>0.5</code> over a white background results in a light pink entity. 
	 * Drawing an orange pixel <code>(1.0, 0.5, 0)</code> with an alpha of <code>0.66</code> over
	 * a light blue surface <code>(0.0, 1.0, 1.0)</code>, results in a light brown pixel:
	 * @example (1.0, 0.5, 0) * 0.66 + (0.0, 1.0, 1.0) * 0.34 = (0.6, 0.67, 0.34)
	 * @param {Number} alpha The new alpha blending state for the entity ranging between <code>(0-1)</code> 
	 * (0 = completely transparent, 1 = completely opaque). Expressed as a float.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getAlpha
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setAlpha: function(alpha)
	{
		this._alpha = alpha;
		this._setAlphaSendGen(alpha);
		return this;
	},
	
    /**
	 * Set the transform rotation (in degrees) for this <code>Node</code>.<br><br> 	 
	 * <b>Note:</b> This property affects the coordinate system of child nodes and rotates drawing for
	 * derived classes like <code>Sprite</code>, <code>Text</code>, and <code>Primitive</code>.
	 * <br><br>
	 * The following code examples illustrate different call styles for <code>setRotation()</code>.<br><br>
	 * 
	 * Rotate entity 90 degrees.
	 * <pre class="code">node.setRotation(90);</pre> 
	 * Restore entity to original orientation.
	 * <pre class="code">node.setRotation(0);</pre>
	 * Convert radians to degrees.
	 * <pre class="code">var radians = 0.785;
	 * var degrees = radians * Math.PI / 180;</pre>
	 * Convert degrees to radians.
	 * <pre class="code">var degrees = 90;
	 * var radians = degrees * 180 / Math.PI;</pre>
	 *
	 * @param {Number} rotation The new rotation of the entity relative to the parent (in degrees). Expressed as a float.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getRotation, 
	 * @see GL2.Primitive, 
	 * @see GL2.Sprite, 
	 * @see GL2.Text
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setRotation: function(rotation)
	{
		this._rotation = rotation;
		this._setRotationSendGen(rotation);
		return this;
	},
	
    /**
	 * Set the <code>depth</code> component for this <code>Node</code>.
	 * This property affects how a node is sorted when the scene is traversed. Different depth-levels affect
	 * both drawing order (back to front, low to high) and touch priority (front to back,
	 * high to low).<br><br>
	 * <b>Note:</b> Use <code>{@link GL2.Node#setChildrenDepthGrouped}</code> to set how a node will sort with siblings.
	 * @example node.setDepth(20);
	 * @param {Number} depth The new depth for the entity (z-order). Expressed as a float.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getChildrenDepthGrouped, 
	 * @see GL2.Node#setChildrenDepthGrouped
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setDepth: function(depth)
	{
		if(this._depth != depth)
		{
			this._depth = depth;
			this._setDepthSendGen(depth);
		}
		return this;
	},
	
    /**
	 * Set the <code>visible</code> component for this <code>Node</code>.
	 * This component defines visibility of the node.
	 * The default value is <code>true</code>.<br><br>
	 * <b>Note:</b> A node can inherit the value of this component from parent nodes in the scene graph.
	 * @example node.setVisible(true);
	 * @param {Boolean} [visible=true] Set as <code>true</code> if a node is visible.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getVisible
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setVisible: function(visible)
	{
		if(this._visible != visible)
		{
			this._visible = visible;
			this._setVisibleSendGen(visible);
		}
		return this;
	},
	
    /**
	 * Set this <code>Node</code> to support touches.
	 * The <code>touchable</code> property is Boolean and defines a node as supporting touch input.
	 * A node can inherit the value of <code>touchable</code> from parent nodes in the scene graph.<br><br> 
	 * <b>Caution!</b> Instantiating touchable <code>GL2.Node</code> objects will impact performance 
	 * much more than instantiating <code>GL2.Node</code> objects that do not support touch input. If
	 * a node does not need to support touch input, set <code>touchable</code> to <code>false</code>.
	 * @example node.setTouchable(false);
	 * @param {boolean} [touchable=true] Set as <code>true</code> if this node supports touch input.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getTouchahble
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setTouchable: function(touchable)
	{
		this._touchable = touchable;
		this._setTouchableSendGen(touchable);
		return this;
	},
    
	/**
	 * Set whether to sort child nodes adjacent to this <code>Node</code>.
	 * When <code>childrenDepthGrouped</code> is <code>false</code>, the child nodes interleave 
	 * with the children of the nearest similarly grouped ancestor. Applications can use this to sort a distant node
	 * on an independent branch of the graph in close proximity.<br/><br/>
	 * <b>Example:</b> You have multiple group nodes containing a character sprite and a 
	 * shadow sprite. By setting all the shadow sprites to a <code>depth</code> of <code>1</code>, all character sprites to
	 * a <code>depth</code> of <code>2</code>, and setting <code>childrenDepthGrouped</code> to <code>false</code> for each group node, all character sprites will 
	 * sort above shadows when drawn.<br><br>
     * Look at the following structure of nodes.
     * If <code>childrenDepthGrouped</code> is <code>true</code> for the group, the primitive will
     * draw above both the sprite and the text. However, if <code>false</code>,
     * the primitive will draw after the sprite but before the text.
     * <pre class="code">
     * Root
     * +-- Group (depth = 0)
     * |   +-- Sprite (depth = 10)
     * |   +-- Text (depth = -10)
     * |
     * +-- Primitive (depth = 5)
     * </pre>
	 * @param {Boolean} childrenDepthGrouped Set as <code>true</code> to sort with ancestor siblings. Set as <code>false</code> to sort only with siblings in the graph.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getChildrenDepthGrouped
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setChildrenDepthGrouped: function(childrenDepthGrouped)
	{
		if(this._childrenDepthGrouped != childrenDepthGrouped)
		{
			this._childrenDepthGrouped = childrenDepthGrouped;
			this._setChildrenDepthGroupedSendGen(childrenDepthGrouped);
		}
		return this;
	},
	
	/**
	 * Add a node as a child to this <code>Node</code>.
	 * @example node.addChild(this.mySprite);
	 * @param {GL2.Node} child The child node to add.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#removeChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	addChild: function(child)
	{
		// Add to children list.
		this._children.push(child);
		
		// Tell child.
		child._didAddToParent(this);
		
		this._addChildSendGen(Core.ObjectRegistry.objectToId(child));
		
		return this;
	},
	
	/**
	 * Remove a specified child node and its subtree from this <code>Node</code>.
	 * @example node.removeChild(this.mySprite);
	 * @param {String} child The child node to remove from the current entity.
	 * @throws {removeChild called for a node that is not a child} Specified node is not a child node.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#addChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	removeChild: function(child)
	{
		// Tell child.
		child._willRemoveFromParent();
		
		// Remove from children list.
		var index = this._children.indexOf(child);
		if(index == -1)
			throw new Error('removeChild called for a node that is not a child');
		this._children.splice(index, 1);
		
		this._removeChildSendGen(Core.ObjectRegistry.objectToId(child));
		
		return this;
	},
	
	/**
	 * Convert the relative location of a scene to the local coordinate space for this <code>Node</code>.
	 * @example var p = Game.getRoot().screenToLocal(touch.getPosition());
	 * @param {Core.Vector} location The relative location for a scene.
	 * @see GL2.Node#localToScreen
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	screenToLocal: function(location)
	{
		var parent = this._parent;
		if(!parent)
			return undefined;
			
		location = parent.screenToLocal(location);
		if(!location)
			return undefined;
		
		var x = location.getX();
		var y = location.getY();
		
		// Undo translation.
		var p = this._position;
		x -= p.getX();
		y -= p.getY();
		
		// Undo rotation.
		var r = this._rotation * Math.PI / 180;
		var cosr = Math.cos(r);
		var sinr = Math.sin(r);
		var tx = cosr*x + sinr*y;
		var ty = -sinr*x + cosr*y;
		x = tx;
		y = ty;
		
		// Undo scale.
		var s = this._scale;
		x /= s.getX();
		y /= s.getY();
		
		return new Core.Point(x, y);
	},
	
	/**
	 * Convert a location within the local coordinate space for this <code>Node</code> to a location within the screen coordinate
	 * space.
	 * @param {Core.Vector} location A location in the local transform for this <code>Node</code>.
	 * @see GL2.Node#screenToLocal
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	localToScreen: function(location)
	{
		var x = location.getX();
		var y = location.getY();
		
		// Undo scale.
		var s = this._scale;
		x *= s.getX();
		y *= s.getY();
		
		// Undo rotation.
		var r = -this._rotation * Math.PI / 180;
		var cosr = Math.cos(r);
		var sinr = Math.sin(r);
		var tx = cosr*x + sinr*y;
		var ty = -sinr*x + cosr*y;
		x = tx;
		y = ty;
		
		// Undo translation.
		var p = this._position;
		x += p.getX();
		y += p.getY();
		
		var parent = this._parent;
		if(!parent)
			return undefined;
		
		location = parent.localToScreen(new Core.Point(x, y));
		if(!location)
			return undefined;
		return location;
	},
	
	_didAddToParent: function(parent)
	{
		if(this._parent)
			this._parent.removeChild(this);
		
		this._parent = parent;
	},
	
	_willRemoveFromParent: function()
	{
		this._parent = null;
	},
	
	_synchronizeNodeRecv: function( cmd )
	{
		var msg = {};
		if(!this._synchronizeNodeRecvGen(cmd, msg))
			return;
		this._position.setAll(msg.x, msg.y);
		this._rotation = msg.rotation;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 307
	// Method create = -1
	// Method destroy = 2
	// Method setPosition = 3
	// Method setScale = 4
	// Method setColor = 5
	// Method setAlpha = 6
	// Method setRotation = 7
	// Method setDepth = 8
	// Method setVisible = 9
	// Method setTouchable = 10
	// Method setChildrenDepthGrouped = 11
	// Method addChild = 12
	// Method removeChild = 13
	// Method synchronizeNode = 14
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 14:
					instance._synchronizeNodeRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Node._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Node._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[307] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_synchronizeNodeRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		obj[ "rotation" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "rotation" ] === undefined )
		{
			NgLogE("Could not parse rotation in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":307,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":307,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setPositionSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":307,3," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setScaleSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":307,4," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setColorSendGen: function( red, green, blue )
	{
		Core.Proc.appendToCommandString( ":307,5," + this.__objectRegistryId + "," + red + "," + green + "," + blue  );
	},
	
	/** @private */
	_setAlphaSendGen: function( alpha )
	{
		Core.Proc.appendToCommandString( ":307,6," + this.__objectRegistryId + "," + alpha  );
	},
	
	/** @private */
	_setRotationSendGen: function( rotation )
	{
		Core.Proc.appendToCommandString( ":307,7," + this.__objectRegistryId + "," + rotation  );
	},
	
	/** @private */
	_setDepthSendGen: function( depth )
	{
		Core.Proc.appendToCommandString( ":307,8," + this.__objectRegistryId + "," + depth  );
	},
	
	/** @private */
	_setVisibleSendGen: function( visible )
	{
		Core.Proc.appendToCommandString( ":307,9," + this.__objectRegistryId + "," + ( visible ? 1 : 0 )  );
	},
	
	/** @private */
	_setTouchableSendGen: function( touchable )
	{
		Core.Proc.appendToCommandString( ":307,10," + this.__objectRegistryId + "," + ( touchable ? 1 : 0 )  );
	},
	
	/** @private */
	_setChildrenDepthGroupedSendGen: function( childrenDepthGrouped )
	{
		Core.Proc.appendToCommandString( ":307,11," + this.__objectRegistryId + "," + ( childrenDepthGrouped ? 1 : 0 )  );
	},
	
	/** @private */
	_addChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":307,12," + this.__objectRegistryId + "," + child  );
	},
	
	/** @private */
	_removeChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":307,13," + this.__objectRegistryId + "," + child  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setPosition: function( x, y ) {}
	
	// setScale: function( x, y ) {}
	
	// setColor: function( red, green, blue ) {}
	
	// setAlpha: function( alpha ) {}
	
	// setRotation: function( rotation ) {}
	
	// setDepth: function( depth ) {}
	
	// setVisible: function( visible ) {}
	
	// setTouchable: function( touchable ) {}
	
	// setChildrenDepthGrouped: function( childrenDepthGrouped ) {}
	
	// addChild: function( child ) {}
	
	// removeChild: function( child ) {}
	
	// _synchronizeNodeRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Primitive'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Primitive'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Primitive'] = exports; var Node = require('NGCore/Client/GL2/Node').Node;
var Animation = require('NGCore/Client/GL2/Animation').Animation;
var Core = require('NGCore/Client/Core').Core;

exports.Primitive = Node.subclass(
/** @lends GL2.Primitive.prototype */
{
	classname: 'Primitive',
    
	/**
	 * @class The <code>Primitive</code> class constructs objects that draw arbitrary vertex-based geometry.
	 * These objects provide a means of drawing raw 2D <a href="GL2.Primitive.Vertex.html">vertex</a> data as polygons to a <code>{@link UI.View}</code>. Data is
	 * provided by users as a vertex list. 
	 * @constructs The default constructor. 
	 * @augments GL2.Node
	 */
    initialize: function()
    {
        this._animation = null;
		this._ownsAnimation = false;
		
		this._animationCompleteEmitter = new Core.MessageEmitter();
        this._type = this.Type.Triangles;
        this._vertexes = [];
    },

	/**
	 * The default destructor.
	 * This call cleans up any attached <code>Animation</code> and <code>AnimationCompleteEmitter</code>.
	 * @see GL2.Animation
	 * @status iOS, Android, Flash
	 */
	destroy: function()
	{
		this._tryDestroyAnimation();
		this._animationCompleteEmitter.destroy();
	},
	
	/**
	 * Retrieve the number of listed vertices in the geometry of this <code>Primitive</code>.
	 * @returns {Number} The current number of vertices.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVertexCount: function()
	{
		return this._vertexes.length;
	},
	
	/**
	 * Retrieve a single vertex from the vertex list of this <code>Primitive</code>.
	 * @param {Number} index The vertex list offset to retrieve.
	 * @returns {GL2.Primitive.Vertex} The current vertex at the specified index in the vertex list.
	 * @see GL2.Primitive#setVertex
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVertex: function(index)
	{
		return this._vertexes[index];
	},
	
	/**
	 * Retrieve the GL draw mode for this <code>Primitive</code>.
	 * @returns {GL2.Primitive#Type} The current draw mode.
	 * @see GL2.Primitive#setType
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getType: function()
	{
		return this._type;
	},
	
	/**
	 * Retrieve the current <code>Texture Animation</code> object of this <code>Primitive</code>.
	 * @returns {GL2.Animation} The current animation.
	 * @see GL2.Primitive#setAnimation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnimation: function()
	{
		if(this._ownsAnimation) return null;
		
		return this._animation;
	},
	
	/**
	 * Retrieve the complete message emitter for the current animation.
	 * @returns {Core.MessageEmitter} The emitter for the current texture animation.
	 * @see GL2.Animation,  
	 * @see Core.MessageEmitter
	 * @status iOS, Android, Flash
	 */
	getAnimationCompleteEmitter: function()
	{
		return this._animationCompleteEmitter;
	},
    
	/**
	 * Begin playing the specified animation.
	 * Any animation that is not set to loop will trigger the animation complete callback when done.
	 * @example primitive.setAnimation(myAnimation, 30);
	 * @param {GL2.Animation} animation The current animation.
	 * @param {Number} [startTime=0] The starting point of the animation. Expressed as a float.<br><br>
	 * <b>Example:</b> If <code>setAnimation()</code> is called with a <code>startTime</code> equal to half the total duration of the animation, 
	 * playback begins half way through the animation.
	 * @see GL2.Primitive#getAnimation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setAnimation: function(animation, startTime)
	{
		this._tryDestroyAnimation();
		this._animation = animation;
		
		this._setAnimationSendGen( Core.ObjectRegistry.objectToId(animation), startTime || 0 );
	},
    
    /**
	 * Set a static image as the current animation for this <code>Primitive</code>.
	 * This method instantiates a single frame animation of infinite duration using the
	 * specified image. If the primitive is playing another animation at the time of this call, 
	 * the new animation will take priority over the primitive.
	 * The previous animation will stop and the complete emitter will not respond. 
	 * This is because the animation did not technically complete a full playback cycle. <br><br>
	 * You can define optional parameters for the size, anchor, and UV coordinates of the specified image. 
	 * @example primitive.setImage('./Content/blank.png', [480, 320], [0, 0]);
	 * @param {String} image The directory path to an image referenced by a frame.
	 * @param {Core.Size} [size] The size of the image to display in pixels.
	 * @param {Core.Point} [anchor] The anchor coordinates that indicate the image center in the animation.
	 * @param {Core.Rect} [uvs] The UV coordinates used to specify the subset of an image.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation, 
	 * @see GL2.Animation.Frame
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setImage: function(image, size, anchor, uvs)
	{
		this._tryDestroyAnimation();
		
		// Create a single frame animation.
		var args = Array.prototype.slice.call(arguments, 0);
		args.splice(1, 0, 0); // Insert a duration of zero into our arguments.
		var frame = new Animation.Frame();
		frame.constructor.apply(frame, args);
		var animation = new Animation();
		animation.pushFrame(frame);
		
		this._animation = animation;
		this._ownsAnimation = true;
		
		this._setAnimationSendGen(Core.ObjectRegistry.objectToId(animation),0);
		
		return this;
	},
    
    /**
	 * Set the type of geometry on display for this <code>Primitive</code>.
	 * @example primitive.setType(GL2.Primitive.Type.TriangleFan);
	 * @param {GL2.Primitive#Type} type The new GL draw mode.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setType: function(type)
	{
		this._type = type;
		
		this._setTypeSendGen(type);
		
		return this;
	},
    
    /**
     * Add a vertex to the end of the vertex list for this <code>Primitive</code>.<br>
     * <pre class="code"><font size="2">primitive.pushVertex(new Core.Point(w*2/10, h*5/6));</font></pre><br>
     * Calling <code>pushVertex()</code> is equivalent to calling <code>spliceVertexes()</code> in the following way:
     * <pre class="code"><font size="2">primitive.spliceVertexes(primitive.getVertexCount(), 0, vertex);</font></pre>
     * @param {GL2.Primitive.Vertex} vertex The vertex to add.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    pushVertex: function(vertex)
	{
		return this.spliceVertexes(this._vertexes.length, 0, vertex);
	},
    
    /**
	 * Set the vertex at index <i>i</i> for this <code>Primitive</code>.
	 * Calling <code>setVertex()</code> is equivalent to calling <code>spliceVertexes()</code> in the following way:
	 * @example primitive.spliceVertexes(i, 1, vertex)
	 * @param {Number} <i>i</i> The index in the vertex list to set.
	 * @param {GL2.Primitive.Vertex} vertex The new vertex.
	 * @see GL2.Primitive#getVertex
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setVertex: function(i, vertex)
	{
		return this.spliceVertexes(i, 1, vertex);
	},
    
    /**
	 * Replace <code>len</code> vertices, starting at position <code>start</code>, with specified vertices.<br><br>
	 * The following are examples of different call styles for <code>spliceVertexes</code>.<br><br>
	 * Splice a simple textureless quad into the vertex list.
	 * <pre class="code"><font size="2">var c = new Core.Color([1,1,1]);
	 * var w = 100;
	 * var h = 100;
	 * var v = new Array();
	 * v.push(new GL2.Primitive.Vertex([0,0],[0,0],c));
	 * v.push(new GL2.Primitive.Vertex([w,0],[0,0],c));
	 * v.push(new GL2.Primitive.Vertex([w,h],[0,0],c));
	 * v.push(new GL2.Primitive.Vertex([0,h],[0,0],c));</font></pre>
	 * Insert four vertices at position 0 in the vertex list.
	 * <pre class="code"><font size="2">myPrimitive.spliceVertexes.apply(myPrimitive, ([0,0]).concat(v));
	 * myPrimitive.setType(GL2.Primitive.Type.TriangleFan);</font></pre>
	 * @param {Number} start The index from which to remove vertices in the vertex list.
	 * @param {Number} len The number of vertices to replace.
	 * @param {GL2.Primitive.Vertex} vertexes A list of vertices to insert at the start location.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    spliceVertexes: function(start, len, vertexes)
	{
		this._vertexes.splice.apply(this._vertexes, arguments);
		
		var vertexCount = arguments.length-2;
		this._spliceVertexesSendGen(start,len,vertexCount);
		
		for(var i=0; i < vertexCount; ++i)
		{
			var vertex = arguments[i+2];
			var position = vertex.getPosition();
			var uv = vertex.getUV();
			var color = vertex.getColor();
			this._vertexSendGen(
				position.getX(),
				position.getY(),
				uv.getX(),
				uv.getY(),
				color.getRed(),
				color.getGreen(),
				color.getBlue()
			);
		}
		
		return this;
	},

	$Vertex: Core.Class.subclass(
	/** @lends GL2.Primitive.Vertex.prototype */
	{
		classname: 'Vertex',
		
		/**
		 * @class <code>Vertex</code> objects specify location, texture coordinates, and color data
		 * for GL primitive geometry.
		 * @constructs The default constructor. 
		 * @param {Core.Vector|float[2]} position A location.
		 * @param {Core.Vector|float[2]} uv A texture coordinate.
		 * @param {Core.Color|float[3]} color An RGB color triplet.
		 * @see GL2.Primitive
		 * @augments Core.Class
		 */
		initialize: function(position, uv, color)
		{
			this._position = new Core.Point(position);
			this._uv = new Core.Point(uv);
			this._color = new Core.Color(color);
		},
		
		/**
		 * Retrieve the location of this <code>Vertex</code>.
		 * @returns {Core.Vector} The current <i>x</i>,<i>y</i> coordinates for the vertex.
    	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getPosition: function()
		{
			return this._position;
		},
		
		/**
		 * Retrieve the texture coordinates of this <code>Vertex</code>.
		 * @returns {Core.Vector} The current <i>x</i>,<i>y</i> coordinates for the texture.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getUV: function()
		{
			return this._uv;
		},
		
		/**
		 * Retrieve the color of this <code>Vertex</code>.
		 * @returns {Core.Color} The current vertex color as a RGB triplet.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getColor: function()
		{
			return this._color;
		},
	}),
	
	_tryDestroyAnimation: function()
	{
		if(this._ownsAnimation)
		{
			// Set our animation to NULL to unlink ourselves from the animation on the backend
			// or else trying to destory the animation will fail because we are still using it.
			this._setAnimationSendGen(0,0);
		
			this._animation.destroy();
			this._animation = null;
			this._ownsAnimation = false;
		}
		this._animation = null;
		this._image = null;
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for primitive types.
	 * @namespace
	 */
	Type:
	{ 
		/** Every three vertices define a unique triangle. */
		Triangles: 0,
		/** Every vertex defines a triangle with the 2 preceding vertices. */
		TriangleStrip: 1,
		/** Every vertex defines a triangle with the first vertex and the previous vertex. */
		TriangleFan: 2,
		/** Every vertex pair defines a line segment. */
		LineList: 3,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 308
	// Method create = -1
	// Method spliceVertexes = 2
	// Method vertex = 3
	// Method setType = 4
	// Method setAnimation = 5
	// Method animationComplete = 6
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 6:
					instance._animationCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Primitive._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Primitive._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[308] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_animationCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in Primitive.animationComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":308,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_spliceVertexesSendGen: function( start, len, vertexCount )
	{
		Core.Proc.appendToCommandString( ":308,2," + this.__objectRegistryId + "," + start + "," + len + "," + vertexCount  );
	},
	
	/** @private */
	_vertexSendGen: function( x, y, u, v, red, green, blue )
	{
		Core.Proc.appendToCommandString( "," + x + "," + y + "," + u + "," + v + "," + red + "," + green + "," + blue  );
	},
	
	/** @private */
	_setTypeSendGen: function( type )
	{
		Core.Proc.appendToCommandString( ":308,4," + this.__objectRegistryId + "," + type  );
	},
	
	/** @private */
	_setAnimationSendGen: function( animation, startTime )
	{
		Core.Proc.appendToCommandString( ":308,5," + this.__objectRegistryId + "," + animation + "," + startTime  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// spliceVertexes: function( start, len, vertexCount ) {}
	
	// vertex: function( x, y, u, v, red, green, blue ) {}
	
	// setType: function( type ) {}
	
	// setAnimation: function( animation, startTime ) {}
	
	// _animationCompleteRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Touch'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Touch'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Touch'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Touch = Core.Class.subclass(
/** @lends GL2.Touch.prototype */
{
	classname: 'Touch',
	
	/**
	 * @class The <code>Touch</code> class constructs objects that identify and track the life cycle of unique touch events in the system.
	 * @constructs These objects are constructed by the system.
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this._id = 0;
		this._action = {};
		this._position = new Core.Point();
		this._targetIds = null;
	},
	
	/**
	 * Retrieve a list of every <code>TouchTarget</code> object in which this <code>Touch</code> object resides and is marked as touchable.
	 * @returns {GL2.TouchTarget} A prioritized list of every <code>TouchTarget</code> for this <code>Touch</code>.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTouchTargets: function()
	{
		var ids = this._targetIds;
		var result = [];
		for(var i in ids)
		{
			var t = Core.ObjectRegistry.idToObject(i);
			if(t) result.push(t);
		}
		return result;
	},
	
	/**
	 * Retrieve whether or not this <code>Touch</code> object resides in the specified <code>TouchTarget</code>.
	 * @param {GL2.TouchTarget} touchTarget The <code>TouchTarget</code> to test against.
	 * @returns {Boolean} Returns <code>true</code> when this <code>Touch</code> resides in the <code>TouchTarget</code>.
	 * @status iOS, Android, Flash
	 */
	getIsInside: function(touchTarget)
	{
		// Check if the object's id is in the touchtargets map
		return ( Core.ObjectRegistry.objectToId(touchTarget) in this._targetIds);
	},
	
	/**
	 * Retrieve the location of this <code>Touch</code> object in the global coordinate space.
	 * @returns {Core.Vector} The global coordinates of the <code>Touch</code> location.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getPosition: function()
	{
		return this._position;
	},
	
	/**
	 * Retrieve the ID of this <code>Touch</code> object.
	 * <b>Note:</b> When using this ID as a key, append it to a string so that you can use
	 * it to key an associative array. Otherwise, you will end up with a very large array.
	 * @returns {Number} The current <code>Touch</code> ID.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getId: function()
	{
		return this._id;
	},
	
	/**
	 * Retrieve the phase of this <code>touch</code> event.
	 * Use this method from your listener callback.
	 * The following is an example of a <code>touch</code> event handler for a button.
	 * @example
	 * onTouch: function(touch)
	 * {
	 * 	//getAction() informs us of the type of event being handled.
	 * 	//  In order to get Action.Move and Action.End, we need to return true from Action.Start.
	 * 	switch(touch.getAction())
	 * 	{
	 * 		case touch.Action.Start:
	 * 			//Change the color of our Rectangle
	 * 			this.button.setColor(Defaults.onColor);
	 * 			
	 * 			//Return true here if you want to capture this event for its lifetime.
	 * 			//  returning false will let other, lower priority handlers capture the
	 * 			//  event. In that case we would not want to react to the Action.Start since
	 * 			//  we would not get subsequent Action.End or Action.Move.
	 * 			return true;
	 * 			
	 * 		case touch.Action.End:
	 * 			//Reset the color of our Rectangle
	 * 			this.button.setColor(Defaults.offColor);
	 * 			
	 * 			//We do not need to return anything in Action.End or Action.Move.
	 * 			break;
	 * 		case touch.Action.Move:
	 * 			//The touch object allows us to retrieve metadata about the event.
	 * 			//  If the touch has left our bounds, getIsInside() will return false.
	 * 			if(!touch.getIsInside(this._target))
	 * 			{
	 * 				//If the active touch is outside, reset our Rectangle color.
	 * 				this.button.setColor(Defaults.offColor);
	 * 			}
	 * 			else
	 * 			{
	 * 				//If the active touch is inside, set our Rectangle color to on.
	 * 				this.button.setColor(Defaults.onColor);
	 * 			}
	 * 			break;
	 * 	}
	 * }
	 * @returns {GL2.Touch#Action} The current <code>touch</code> event phase.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAction: function()
	{
		return this._action;
	},
	
	_setId: function(id)
	{
		this._id = id;
	},
	
	_setAction: function(action)
	{
		this._action = action;
	},
	
	_setPosition: function(position)
	{
		this._position.setAll(arguments);
	},
	
	_setTargetIds: function(targetIds)
	{
		// We transfer the array of numeric target IDs into a
		// map so we can support getIsInside call which uses 'in'.
		this._targetIds = {};
		for(var i in targetIds)
			this._targetIds[targetIds[i]] = null;
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for touch action.
	 * @namespace
	 */
	Action:
	{ 
		/** Finger began touching screen. */
		Start: 0,
		/** Finger stopped touching screen. */
		End: 1,
		/** Finger moved where it is touching the screen. */
		Move: 2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 312
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Touch._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Touch._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[312] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	// This class is expected to implement the following methods outside of
	// the generated block:

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/TouchTarget'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/TouchTarget'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/TouchTarget'] = exports; var Node = require('NGCore/Client/GL2/Node').Node;
var Sprite = require('NGCore/Client/GL2/Sprite').Sprite;
var Core = require('NGCore/Client/Core').Core;

exports.TouchTarget = Node.subclass(
/** @lends GL2.TouchTarget.prototype */
{
	classname: 'TouchTarget',
    
	/**
	 * @class <code>TouchTarget</code> class constructs objects that provide applications access to touch events.
	 *<br><br>
	 * A <code>TouchTarget</code> is a node with added size and offset attributes that define a
	 * rectangular area as active. Any <a href"GL2.Touch.html">touch</a> that falls within the active area is broadcast
	 * to the <code>TouchTarget</code> where a <code>MessageListener</code> can respond 
	 * to the event. Attach a listener by calling <code><a href="GL2.TouchTarget.html#getTouchEmitter">getTouchEmitter()</a></code>
	 * to retrieve the emitter.
	 *<br><br>
	 * A <code>TouchTarget</code> is created with a <code>0</code> size and a center offset anchor point <code>(0.5,0.5)</code>.
	 * Set these two properties to define a usable area that supports touch events. Generally,
	 * you set these two values as identical to the values for <code><a href="GL2.Sprite.html">sprite</a></code>, <code><a href="GL2.Text.html">text</a></code>, 
	 * or <code><a href="GL2.Primitive.html">primitive</a></code> and add
	 * the <code>TouchTarget</code> as a child of that visible node with a position of <code>0</code>. The <code>TouchTarget</code> 
	 * inherits the transform for the visible node. 
	 * <br><br>
	 * <b>Note:</b> A <code>TouchTarget</code> is not part of the drawing scene traversal and activates regardless of node
	 * visibility or parent visibility. 
	 * Disable touch support for a node by calling <code><a href="GL2.Node.html#setTouchable">setTouchable()</a></code>.
	 * @constructs The default constructor.
	 * @augments GL2.Node
	 */
    initialize: function()
    {
		this._size = new Core.Size();
		this._anchor = new Core.Point(0, 0);
		this._touchEmitter = new Core.MessageEmitter();
    },
    
	/**
	 * Destroy this instance and release resources on the backend that are associated with this <code>TouchTarget</code> object.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Return the point size of the <code>TouchTarget</code> area.
	 * @returns {Core.Size} The current size of the <code>TouchTarget</code> area.
	 * @see GL2.TouchTarget#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSize: function()
	{
		return this._size;
	},
	
	/**
	 * Return the offset values used for scaling and rotating the <code>TouchTarget</code> area.
	 * @returns {Core.Point} The current offset of the target area.
	 * @see GL2.TouchTarget#setAnchor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnchor: function()
	{
		return this._anchor;
	},
	
	/**
	 * Return the touch emitter for this <code>TouchTarget</code>.
	 * The emitter fires when a captured <code>touch</code> event changes phases. For the initial touch down
	 * phase, this emitter fires when the <code>touch</code> event occurs within the defined touch area. After returning <code>true</code> from
	 * the initial <code>touch</code> event, the emitter fires regardless of where the <code>touch</code> event occurs.<br><br>	 
	 * The following example creates a new <code>TouchTarget</code> in the upper left corner of the scene. 
	 * The listener instance handles the <code>touch</code> events in the <code>onTouch()</code> function.
	 * @example
	 * var target = new GL2.TouchTarget();
	 * target.setAnchor([50,50]);
	 * target.setSize([100,100]);
	 * target.setPosition([50,50]);
	 * 
	 * target.getTouchEmitter().addListener(this, this.onTouch);
	 * 
	 * GL2.Root.addChild(target);
	 * @return {Core.MessageEmitter} The touch emitter for this touch area.
	 * @see GL2.Touch#getAction
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTouchEmitter: function()
	{
		return this._touchEmitter;
	},
	
    /**
	 * Set the size of this <code>TouchTarget</code> (<i>width</i> and <i>height</i>).
	 * @example this.t = new GL2.TouchTarget();
	 * this.t.setSize(Core.Capabilities.getScreenHeight(), Core.Capabilities.getScreenHeight());
	 * @param {Core.Size} size The new size of the <code>TouchTarget</code> area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setSize: function(size)
	{
		var s = this._size;
		s.setAll.apply(s, arguments);

		this._setSizeSendGen(s.getWidth(),s.getHeight());
		
		return this;
	},
	
    /**
	 * Set the anchor point used to rotate and scale the <code>TouchTarget</code> area.
	 * @example this.t = new GL2.TouchTarget();
	 * this.t.setAnchor(0, 0);
	 * @param {Core.Point} anchor The new anchor point for the <code>TouchTarget</code> area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAnchor: function(anchor)
	{
		var a = this._anchor;
		a.setAll.apply(a, arguments);
		
		this._setAnchorSendGen(a.getX(),a.getY());
		
		return this;
	},
	
	/**
	 * Translate a global scene location to the local coordinate space.
	 * Use this method when determining <code>touchMoved</code> offsets.
	 * @example var p = Game.getRoot().screenToLocal(touch.getPosition());
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.Vector} location The location to transform.
	 * @status iOS, Android, Flash
	 */
	screenToLocal: function($super, location)
	{
		location = $super(location);
		if(!location)
			return undefined;
		
		var a = this._anchor;
		var s = this._size;
			
		location.setX(location.getX() + a.getX() * s.getWidth());
		location.setY(location.getY() + a.getY() * s.getHeight());
		return location;
	},
	
	/**
	 * Translate a location in the local coordinate space to the global scene coordinate space.
	 * Use this method for translating between local coordinate spaces.
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.Vector} location The location to transform.
	 * @status iOS, Android, Flash
	 */
	localToScreen: function($super, location)
	{
		var a = this._anchor;
		var s = this._size;
			
		location.setX(location.getX() - a.getX() * s.getWidth());
		location.setY(location.getY() - a.getY() * s.getHeight());
		
		location = $super(location);
		if(!location)
			return undefined;
		return location;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 313
	// Method create = -1
	// Method setSize = 2
	// Method setAnchor = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in TouchTarget._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in TouchTarget._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[313] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":313,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_setSizeSendGen: function( width, height )
	{
		Core.Proc.appendToCommandString( ":313,2," + this.__objectRegistryId + "," + width + "," + height  );
	},
	
	/** @private */
	_setAnchorSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":313,3," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setSize: function( width, height ) {}
	
	// setAnchor: function( x, y ) {}
	

// {{/Wg Generated Code}}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Root'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Root'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Root'] = exports; var Core = require('NGCore/Client/Core').Core;
var Touch = require('NGCore/Client/GL2/Touch').Touch;

exports.Root = Core.Class.singleton(
/** @lends GL2.Root.prototype */
{
	classname: 'Root',
	
	/**
	 * @class The <code>Root</code> class constructs a singleton object that serves as the proxy object for the {@link UI.GLView} node hierarchy.
	 * <code>Root</code> is the root element of the node hierarchy (also known as a scene graph) for <code>GLView</code>.
	 * The <code>Root</code> transform is composed at the upper left corner of the view with a descending <i>y</i> axis.<br><br>
	 * Adding a node to the <code>Root</code> ensures applications include it when determining drawing and touch events.
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		
		this._children = [];
		
		this._createSendGen(this.__objectRegistryId);
		
		this._touchTracking = {};
	},
	
	/**
	 * Add a node and the node subtree to the root of the scene graph.
	 * @example var spr = new GL2.Sprite();
	 * ...
	 * GL2.Root.addChild(spr);
	 * @param {GL2.Node} child The node to add.
	 * @see GL2.Root#removeChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	addChild: function(child)
	{
		this._children.push(child);
		child._didAddToParent(this);
		
		this._addChildSendGen(Core.ObjectRegistry.objectToId(child));
	},
	
	/**
	 * Remove the child node and the node subtree from the root of the scene graph.<br><br>
	 * <b>Note:</b> This method will not destroy the node. You can keep or destroy a reference to a node 
	 * if you have no further use for it.
	 * @example GL2.Root.removeChild(spr);
	 * @throws {removeChild called for a node that is not a child} Specified node is not a child node.
	 * @param {GL2.Node} child The node to remove.
	 * @see GL2.Root#addChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	removeChild: function(child)
	{
		child._willRemoveFromParent();
		
		var index = this._children.indexOf(child);
		if(index == -1)
			throw new Error('removeChild called for a node that is not a child');
		this._children.splice(index, 1);
		
		this._removeChildSendGen(Core.ObjectRegistry.objectToId(child));
	},
	
	/** 
	 * Translate screen coordinates into node coordinates.
	 * @example var p = Game.getRoot().screenToLocal(touch.getPosition());
	 * @param {Core.Vector} location The screen coordinates to translate.
	 * @returns The location as node coordinates.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	screenToLocal: function(location)
	{
		return location;
	},
	
	/** 
	 * Translate node coordinates into screen coordinates.
	 * @param {Core.Vector} location The node coordinates to translate.
	 * @returns The location as screen coordinates.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	localToScreen: function(location)
	{
		return location;
	},
	
	_onTouchEventRecv: function( cmd )
	{
		var msg = {};
		if(!this._onTouchEventRecvGen(cmd, msg))
			return;
		
		// Build touch object.
		var touchId = msg.touchId;
		var touchAction = msg.touchAction;
		var touch = new Touch();
		touch._setId(touchId);
		touch._setAction(touchAction);
		touch._setPosition(msg.x, msg.y);
		
		// Extract all touch targets.
		var ids = [];
		for(var i=0; i < msg.touchTargetCount; ++i)
		{
			var t = {};
			if(!this._touchTargetRecvGen(cmd, t))
				return;
			// Add an array entry for every touch event that we have gotten from native.
			ids.push(t.nodeId);
		}
		
		touch._setTargetIds(ids);
		
		switch(touchAction)
		{
			case Touch.Action.Start:
				// Dispatch to all touch targets until one handles it.
				for(var key in ids)
				{
					var id=ids[key];
					var o = Core.ObjectRegistry.idToObject(id);
					if(o && o.getTouchEmitter().chain(touch))
					{
						this._touchTracking[touchId] = id;
						break;
					}
				}
				break;
			case Touch.Action.End:
				// Dispatch to tracking object.
				var track = this._touchTracking[touchId];
				if(track)
				{
					var o = Core.ObjectRegistry.idToObject(track);
                    if (o)
                        o.getTouchEmitter().chain(touch);
					delete this._touchTracking[touch.getId()];
				}
				break;
			case Touch.Action.Move:
				// Dispatch to tracking object.
				var track = this._touchTracking[touchId];
				if(track)
				{
					var o = Core.ObjectRegistry.idToObject(track);
                    if (o)
                        o.getTouchEmitter().chain(touch);
				}
				break;
		}
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 309
	// Method create = -1
	// Method addChild = 2
	// Method removeChild = 3
	// Method onTouchEvent = 4
	// Method touchTarget = 5
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 4:
					instance._onTouchEventRecv( cmd );
					break;
				case 5:
					instance._touchTargetRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Root._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Root._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[309] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onTouchEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 5 )
		{
			NgLogE("Could not parse due to wrong argument count in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "touchId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "touchId" ] === undefined )
		{
			NgLogE("Could not parse touchId in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "touchAction" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "touchAction" ] === undefined )
		{
			NgLogE("Could not parse touchAction in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 3 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "touchTargetCount" ] = Core.Proc.parseInt( cmd[ 4 ] );
		if( obj[ "touchTargetCount" ] === undefined )
		{
			NgLogE("Could not parse touchTargetCount in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 5);
		return true;
	},
	
	/** @private */
	_touchTargetRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Root.touchTarget from command: " + cmd );
			return false;
		}
		
		obj[ "nodeId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "nodeId" ] === undefined )
		{
			NgLogE("Could not parse nodeId in Root.touchTarget from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 1);
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":309,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_addChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":309,2," + this.__objectRegistryId + "," + child  );
	},
	
	/** @private */
	_removeChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":309,3," + this.__objectRegistryId + "," + child  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// addChild: function( child ) {}
	
	// removeChild: function( child ) {}
	
	// _onTouchEventRecv: function( cmd ) {}
	// _touchTargetRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Sprite'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Sprite'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Sprite'] = exports; var Node = require('NGCore/Client/GL2/Node').Node;
var Animation = require('NGCore/Client/GL2/Animation').Animation;
var Core = require('NGCore/Client/Core').Core;
var liveInstances = 0;

exports.Sprite = Node.subclass(
/** @lends GL2.Sprite.prototype */
{
	classname: 'Sprite',
	
	/**	 
	 * @class The <code>Sprite</code> class constructs objects that are used to display either a single image file 
	 * (see <code><a href="GL2.Sprite.html#setImage">setImage()</a></code>) or an animation.<br><br>
	 * Sprites apply their composite node transform and color to the final 
	 * rendered output of each <code><a href="GL2.Animation.Frame.html">frame</a></code> they display. Frames manage the
	 * pre-transform offset within the image. The pre-transform offset is used by frames for rotation and scale of the image. Combining these
	 * two features, an application can accurately place an image within the view.<br><br>
	 * Animations that reach the end of the last animation frame will trigger the
	 * <code>AnimationCompleteEmitter</code> (see <code><a href="GL2.Sprite.html#getAnimationCompleteEmitter">getAnimationCompleteEmitter()</a></code>). 
	 * All other cases, such as setting a new
	 * animation, does not trigger the emitter.<br><br>
	 * <b>Note:</b> The tick rate for any animation instantiated through <code>Sprite</code> is set through <code>{@link Core.UpdateEmitter#setTickRate}</code>.
	 * @constructs The default constructor.
	 * @augments GL2.Node
	 */
    initialize: function()
    {
		this._clubObject = null;
        this._animation = null;
		this._ownsAnimation = false;
		
		this._animationCompleteEmitter = new Core.MessageEmitter();
		
		//FPS
		if (FPS.leakCheck)
	    {
	        try
	        {
	            throw new Error();
	        }
	        catch (e)
	        {
	            FPS.trackObj(this, 'Node', e);
	        }
	    }
	    liveInstances++;
    },

	/**
	 * The default destructor.
	 * This call cleans up any attached <code>Animation</code> and <code>AnimationCompleteEmitter</code> objects.
	 * @see GL2.Animation,
	 * @see GL2.Sprite#getAnimationCompleteEmitter
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		//FPS
		if (FPS.leakCheck)
	    {
	        FPS.untrackObj(this);
	    }
	    liveInstances--;
	    
		this._tryDestroyAnimation();
		this._animationCompleteEmitter.destroy();
	},
	
	$getLiveInstances: function(){
		return liveInstances;
	},
	/**
	 * Retrieve the current <code>Sprite</code> animation.
	 * If the sprite is rendering a single image animation through <code>setImage()</code>,
	 * this method will return <code>undefined</code>.
	 * @returns {GL2.Animation} The current animation. Returns <code>null</code> if the application is not currently playing an animation.
	 * @see GL2.Sprite#setAnimation,
	 * @see GL2.Sprite#setImage
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnimation: function()
	{
		if(this._ownsAnimation) return null;
		
		return this._animation;
	},
    
    /**
	 * Retrieve the animation complete emitter for this <code>Sprite</code>.
	 *
	 * This emitter is triggered when one of the following conditions occurs:<br><br>
	 *<ul>
	 * <li>The sprite reaches the end of an animation for which the last frame has a duration of <code>0</code>.</li>
	 * <li>A <code>setAnimation()</code> or a <code>setImage()</code> call resets the animation complete emitter.</li>
	 *</ul>
	 * Any code that requires notification when an animation completes should register as a 
	 * listener to this emitter. The emitter callback will pass this sprite as the only parameter.<br><br>
	 * <b>Note:</b> Looping animations and starting new animations do not trigger this emitter.
	 * @returns {Core.MessageEmitter} The emitter that triggers the completion callback.
	 * @see GL2.Sprite#setAnimation,
	 * @see GL2.Sprite#setImage	 
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnimationCompleteEmitter: function()
	{
		return this._animationCompleteEmitter;
	},
    
    /**
	 * Begin playing the specified animation with this <code>Sprite</code>.
	 * If the sprite is playing another animation at the time of this call, the new animation will take priority over the sprite.
	 * The previous animation will stop and the complete emitter will not respond. This is because the animation did not technically complete a full playback cycle. 
	 * <br><br>
	 * <b>Note:</b> You can release the resources for any animation set with <code>setAnimation()</code> from the native backend if no other frame
	 * contains it.
	 * @example var animation = Animation.getNamed('background');
	 * ...
	 * var sprite = new GL2.Sprite();
	 * sprite.setAnimation(animation);
	 * @param {GL2.Animation} animation The animation to play.
	 * @param {Number} [startTime=0] The time offset where playback should start relative to the actual start of the animation. Expressed in milliseconds.<br><br>
	 * <b>Example:</b> If <code>setAnimation()</code> is called with a <code>startTime</code> equal to half the total duration of the animation, 
	 * playback begins half way through the animation.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setAnimation: function(animation, startTime)
	{
		this._tryDestroyAnimation();
		this._animation = animation;
		
		this._setAnimationSendGen(Core.ObjectRegistry.objectToId(animation), startTime || 0);
		
		return this;
	},
    
    /**
	 * Set a static image as the current animation for this <code>Sprite</code>.
	 * Internally, this method instantiates a single frame animation of infinite duration using the
	 * specified image. If the sprite is playing another animation at the time of this call, the new animation will take priority over the sprite.
	 * The previous animation will stop and the complete emitter will not respond. This is because the animation did not technically complete a full playback cycle. 
	 * <br><br>
	 * <b>Note:</b> You can release the resources for any image set with <code>setImage()</code> from the native backend if no other frame
	 * contains it.
	 * @example var myImage = new GL2.Sprite();
	 * myImage.setImage('./Content/animation.png', size);
	 * @param {String} image The directory path to an image resource.
	 * @param {Core.Size} [size] The size of the image to display (in pixels).
	 * @param {Core.Point} [anchor] The anchor coordinates that indicate the image center in the animation.
	 * @param {Core.Rect} [uvs] The UV coordinates used to specify the subset of an image.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setImage: function(image, size, anchor, uvs)
	{
		this._tryDestroyAnimation();
		
		// Create a single frame animation.
		var args = Array.prototype.slice.call(arguments, 0);
		args.splice(1, 0, 0); // Insert a duration of zero into our arguments.
		var frame = new Animation.Frame();
		frame.constructor.apply(frame, args);
		var animation = new Animation();
		animation.pushFrame(frame);
		
		this._animation = animation;
		this._ownsAnimation = true;
		
		this._setAnimationSendGen(Core.ObjectRegistry.objectToId(animation),0);
		
		return this;
	},
	
	_tryDestroyAnimation: function()
	{
		if(this._ownsAnimation)
		{
			// Set our animation to NULL to unlink ourselves from the animation on the backend
			// or else trying to destory the animation will fail because we are still using it.
			this._setAnimationSendGen(0,0);
		
			this._animation.destroy();
			this._animation = null;
			this._ownsAnimation = false;
		}
		this._animation = null;
	},
	
	_animationCompleteRecv: function(cmd)
	{
		var msg = {};
		if(!this._animationCompleteRecvGen(cmd, msg))
			return;
		
		this._animationCompleteEmitter.emit(this);
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 310
	// Method create = -1
	// Method setAnimation = 2
	// Method animationComplete = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 3:
					instance._animationCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Sprite._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Sprite._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[310] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_animationCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in Sprite.animationComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":310,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_setAnimationSendGen: function( animation, startTime )
	{
		Core.Proc.appendToCommandString( ":310,2," + this.__objectRegistryId + "," + animation + "," + startTime  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setAnimation: function( animation, startTime ) {}
	
	// _animationCompleteRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Text'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Text'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Text'] = exports; var Node = require('NGCore/Client/GL2/Node').Node;
var Core = require('NGCore/Client/Core').Core;
var liveInstances = 0;

exports.Text = Node.subclass(
/** @lends GL2.Text.prototype */
{
	classname: 'Text',
    
	/**
	 * @class The <code>Text</code> class constructs objects that provide font specifications to the GL2 module. 
	 * <code>Text</code> objects define positionable areas for rendering text strings as application labels.
	 * @constructs The default constructor. 
	 * @augments GL2.Node
	 * @param {String} [text] The text string to render in the constructor.
	 */
    initialize: function(text)
    {
		this._size = new Core.Size();
		this._anchor = new Core.Point(0.5, 0.5);
        this._horizontalAlign = this.HorizontalAlign.Center;
        this._verticalAlign = this.VerticalAlign.Middle;
        this._text = '';
		if (text)
			 this.setText(text);
							 
        this._fontFamily = '';
        this._fontSize = 18;
		this._overflowMode = this.OverflowMode.Multiline;
		this._fontLocation = this.FontLocation.Default;
		
		//FPS
		if (FPS.leakCheck)
	    {
	        try
	        {
	            throw new Error();
	        }
	        catch (e)
	        {
	            FPS.trackObj(this, 'Node', e);
	        }
	    }
	    liveInstances++;
    },
    
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		//FPS
		if (FPS.leakCheck)
	    {
	        FPS.untrackObj(this);
	    }
	    liveInstances--;
	},
	
	$getLiveInstances: function(){
		return liveInstances;
	},
	/**
	 * Retrieve the size of the text area from this <code>Text</code> node.
	 * The text area size is defined through two components: <i>width</i> and <i>height</i>.
	 * A value of <code>0</code> for either component means the text area will expand to the size of the string.
	 * @returns {Core.Vector} The current size of the text area (expressed as points).
	 * @see GL2.Text#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSize: function()
	{
		return this._size;
	},
	
	/**
	 * Retrieve the placement offset for translating before applying the transform of this <code>Text</code> node.
	 * This value is specified as a multiple of the text area size with <code>(0,0)</code> as the top-left corner.
	 * @returns {Core.Vector} The current placement offset.
	 * @see GL2.Text#setAnchor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnchor: function()
	{
		return this._anchor;
	},
	
	/**
	 * Retrieve the horizontal alignment of the text area from this <code>Text</code> node.
	 * @returns {GL2.Text#HorizontalAlign} The current horizontal alignment of the text area.
	 * @see GL2.Text#setHorizontalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getHorizontalAlign: function()
	{
		return this._horizontalAlign;
	},
	
	/**
	 * Retrieve the vertical alignment of the text area from this <code>Text</code> node.
	 * @returns {GL2.Text#VerticalAlign} The curren vertical alignment of the text area.
	 * @see GL2.Text#setVerticalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVerticalAlign: function()
	{
		return this._verticalAlign;
	},
	
	/**
	 * Retrieve the text string this <code>Text</code> node will render.
	 * @returns {String} The current text string to render in the text area.
	 * @see GL2.Text#setText
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getText: function()
	{
		return this._text;
	},
	
	/**
	 * Retrieve the font family for the text area from this <code>Text</code> node.
	 * The GL2 module uses Arial as the text area font family when this value is undefined.<br><br>
	 * <b>Note:</b> <code>Text</code> nodes default to Arial as the font family when an application cannot load the specified font.
	 * @returns The current font family defined for the text area.
	 * @see GL2.Text#setFontFamily
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getFontFamily: function()
	{
		return this._fontFamily;
	},
	
	/**
	 * Retrieve the font size for the text area from this <code>Text</code> node.
	 * @returns {Number} The current font size defined for the text area.
	 * @see GL2.Text#setFontSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFontSize: function()
	{
		return this._fontSize;
	},
	
	/**
	 * Retrieve the overflow style of the text area from this <code>Text</code> node. 
	 * @returns {GL2.Text#OverflowMode} The current overflow style defined for the text area.
	 * @see GL2.Text#setOverflowMode,
	 * @see GL2.Text#OverflowMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getOverflowMode: function()
	{
		return this._overflowMode;
	},
	
    /**
	 * Set the size in pixels of the text area for this <code>Text</code> node.
	 * The text area size is defined through two components: <i>width</i> and <i>height</i>. 
	 * @example var w = Core.Capabilities.getScreenWidth();
	 * var h = Core.Capabilities.getScreenHeight();
	 * ...
	 * var label = new GL2.Text();
	 * label.setSize(w, h);
	 * @param {Core.Vector} size A new vector specifying the text area size in pixels.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setSize: function(size)
	{
		var s = this._size;
		s.setAll.apply(s, arguments);

		this._setSizeSendGen(s.getWidth(),s.getHeight());
		
		return this;
	},
	
    /**
	 * Set the text area offset as a multiple of the area size (<i>width</i> and <i>height</i>).
	 * An <code>Anchor</code> defines a location the text area will rotate and scale around; <code>Anchors</code> are applied
	 * to the drawing prior to the composite transform for the node. When the text size of the text area is <code>0</code> in either
	 * dimension, the offset is measured from the rendered size of the string in that dimension.<br><br>
	 * <b>Example:</b> If you want to display a text area as centered, you can set the <code>horizontalAlign</code> to
	 * <code>centered</code> and set the <code>anchor</code> to <code>[0.5,h]</code> with <i>h</i> representing a vertical offset.
	 * @example text.setAnchor(0.5,h);
	 * @param {Core.Vector} location A new vector specifying the offset location.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node,
	 * @see GL2.Text#getAnchor,
	 * @see GL2.Text#setHorizontalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAnchor: function(location)
	{
		var a = this._anchor;
		a.setAll.apply(a, arguments);
		
		this._setAnchorSendGen(a.getX(),a.getY());
		
		return this;
	},
	
    /**
	 * Set the horizontal alignment of the text area for this <code>Text</code> node.
	 * @example var t = new GL2.Text(this._label);
	 * ...
	 * t.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
	 * @param {GL2.Text#HorizontalAlign} horizontalAlign The new horizontal alignment for the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setHorizontalAlign: function(horizontalAlign)
	{
		this._horizontalAlign = horizontalAlign;
		
		this._setHorizontalAlignSendGen(horizontalAlign);
		
		return this;
	},
    
    /**
	 * Set the vertical alignment of the text area for this <code>Text</code> node.
	 * @example var t = new GL2.Text(this._label);
	 * ...
	 * t.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
	 * @param {GL2.Text#VerticalAlign} verticalAlign The new vertical alignment for the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getVerticalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setVerticalAlign: function(verticalAlign)
	{
		this._verticalAlign = verticalAlign;
		
		this._setVerticalAlignSendGen(verticalAlign);
		
		return this;
	},
    
    /**
	 * Set the text string to render in the text area of this <code>Text</code> node.
	 * @example var label = new GL2.Text();
	 * ...
	 * label.setText('This is a label');
	 * @param {String} text The new text string to render in the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getText
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setText: function(text)
	{
		this._text = text;
		
		this._setTextSendGen(text);
		
		return this;
	},
    
    /**
	 * Set the font family to use for rendering text strings in the text area of this <code>Text</code> node.<br><br>
	 * Using this call to set application specific fonts (os-independent) requires you to add the font file name with extension (.ttf) to the manifest.json.
	 * The font family file must reside in the <code>Content</code> directory. The font family file name is passed in this call. The font face is applied to each object of type 
	 * <code>GL2.Text</code> that will override the system font.
	 * @example var font = new GL2.Text();
	 * ...
	 * font.setFontFamily("Content/Cacophony.ttf");
	 * @param {String} [fontFamily=Arial] The new font family to render in the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getFontFamily
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setFontFamily: function(fontFamily)
	{
		this._fontFamily = fontFamily;
		
		this._setFontFamilySendGen(fontFamily);
		
		return this;
	},
    
    /**
	 * Set the text area font size for this <code>Text</code> node.
	 * @example var fontSize = 24;
	 *
	 * var font = new GL2.Text();
	 * ...
	 * font.setFontSize(fontSize);
	 * @param {Number} [fontSize=18pt] The new font size for text strings (expressed in points).
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getFontSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setFontSize: function(fontSize)
	{
		this._fontSize = fontSize;
		
		this._setFontSizeSendGen(fontSize);
		
		return this;
	},
	
	/**
	 * Set the overflow style of the text area for this <code>Text</code> node. 
	 * This method defines how a <code>Text</code> node will fit a rendered string inside 
	 * the text area when the string is too long.
	 * @example var font = new GL2.Text();
	 * ...
	 * font.setOverflowMode(GL2.Text.OverflowMode.ReduceFontSize);
	 * @param {GL2.Text#OverflowMode} overflowMode The overflow rendering style for long text strings.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getOverflowMode,
	 * @see GL2.Text#OverflowMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setOverflowMode: function(overflowMode)
	{
		this._overflowMode = overflowMode;
		
		this._setOverflowModeSendGen(overflowMode);
		
		return this;
	},
	
	/**
	 * Set the directory path to the location of a font used by this <code>Text</code> node.
	 * @example var font = new GL2.Text();
	 * ...
	 * font.setFontLocation(GL2.Text.FontLocation.System);
	 * @param {String} fontLocation The new directory path to a font used in the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setFontLocation: function(fontLocation)
	{
		this._fontLocation = fontLocation;
		
		this._setFontLocationSendGen(fontLocation);
		
		return this;
	},
	
	/**
	 * Translate a global scene location to the local coordinate space of this <code>Text</code> node.
	 * Use this method when determining <code>touchMoved</code> offsets.
	 * @example var p = Game.getRoot().screenToLocal(touch.getPosition());
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.Vector} location The location to transform.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	screenToLocal: function($super, location)
	{
		location = $super(location);
		if(!location)
			return undefined;
		
		var a = this._anchor;
		var s = this._size;
			
		location.setX(location.getX() + a.getX() * s.getWidth());
		location.setY(location.getY() + a.getY() * s.getHeight());
		return location;
	},
	
	/**
	 * Translate a location in the local coordinate space to the global scene coordinate space of this <code>Text</code> node.
	 * Use this method for translating between local coordinate spaces.
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.Vector} location The location to transform.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	localToScreen: function($super, location)
	{
		var a = this._anchor;
		var s = this._size;
			
		location.setX(location.getX() - a.getX() * s.getWidth());
		location.setY(location.getY() - a.getY() * s.getHeight());
		
		location = $super(location);
		if(!location)
			return undefined;
		return location;
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for horizontal alignment modes.
	 * @namespace
	 */
	HorizontalAlign:
	{ 
		/** Align text to the left. */
		Left: 0,
		/** Align text in the center. */
		Center: 1,
		/** Align text to the right. */
		Right: 2,
	},
	
	/** 
	 * Enumeration for vertical alignment modes.
	 * @namespace
	 */
	VerticalAlign:
	{ 
		/** Align text to the top. */
		Top: 0,
		/** Align text in the middle. */
		Middle: 1,
		/** Align text to the bottom. */
		Bottom: 2,
	},
	
	/** 
	 * Enumeration for the behavior when there is too much text to fit on one line.
	 * @namespace
	 */
	OverflowMode:
	{ 
		/** Reduce the font size until the text fits. */
		ReduceFontSize: 0,
		/** Break the text across multiple lines. */
		Multiline: 1,
	},
	
	/** 
	 * Enumeration for location of fonts.
	 * @namespace
	 */
	FontLocation:
	{ 
		/** Use Default fonts. */
		Default: 0,
		/** Use System fonts. */
		System: 1,
		/** Use bundled fonts that ship with engine and available to all apps. */
		Bundled: 2,
		/** Use custom fonts that are loaded with app manifest. */
		Manifest: 3,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 311
	// Method create = -1
	// Method destroy = 2
	// Method setSize = 3
	// Method setAnchor = 4
	// Method setHorizontalAlign = 5
	// Method setVerticalAlign = 6
	// Method setText = 7
	// Method setFontFamily = 8
	// Method setFontSize = 9
	// Method setOverflowMode = 10
	// Method setFontLocation = 11
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Text._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Text._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[311] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":311,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":311,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setSizeSendGen: function( width, height )
	{
		Core.Proc.appendToCommandString( ":311,3," + this.__objectRegistryId + "," + width + "," + height  );
	},
	
	/** @private */
	_setAnchorSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":311,4," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setHorizontalAlignSendGen: function( align )
	{
		Core.Proc.appendToCommandString( ":311,5," + this.__objectRegistryId + "," + align  );
	},
	
	/** @private */
	_setVerticalAlignSendGen: function( align )
	{
		Core.Proc.appendToCommandString( ":311,6," + this.__objectRegistryId + "," + align  );
	},
	
	/** @private */
	_setTextSendGen: function( text )
	{
		Core.Proc.appendToCommandString( ":311,7," + this.__objectRegistryId + "," + Core.Base64.encode( text )  );
	},
	
	/** @private */
	_setFontFamilySendGen: function( fontFamily )
	{
		Core.Proc.appendToCommandString( ":311,8," + this.__objectRegistryId + "," + Core.Base64.encode( fontFamily )  );
	},
	
	/** @private */
	_setFontSizeSendGen: function( fontSize )
	{
		Core.Proc.appendToCommandString( ":311,9," + this.__objectRegistryId + "," + fontSize  );
	},
	
	/** @private */
	_setOverflowModeSendGen: function( overflowMode )
	{
		Core.Proc.appendToCommandString( ":311,10," + this.__objectRegistryId + "," + overflowMode  );
	},
	
	/** @private */
	_setFontLocationSendGen: function( fontLocation )
	{
		Core.Proc.appendToCommandString( ":311,11," + this.__objectRegistryId + "," + fontLocation  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setSize: function( width, height ) {}
	
	// setAnchor: function( x, y ) {}
	
	// setHorizontalAlign: function( align ) {}
	
	// setVerticalAlign: function( align ) {}
	
	// setText: function( text ) {}
	
	// setFontFamily: function( fontFamily ) {}
	
	// setFontSize: function( fontSize ) {}
	
	// setOverflowMode: function( overflowMode ) {}
	
	// setFontLocation: function( fontLocation ) {}
	

// {{/Wg Generated Code}}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/RenderTarget'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/RenderTarget'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/RenderTarget'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.RenderTarget = Core.Class.subclass(
	/** @lends GL2.RenderTarget.prototype */
{
	classname: 'RenderTarget',

	/**
	 * @class The GL2.RenderTarget object is used to render a set of GL2.Nodes into a texture target.
	 * this target can then be attached to GL2.Animation.Frames and rendered attached to a GL2.Sprite or GL2.Primitive node.
	 *
	 * @constructs Constructs a new GL2.RenderTarget object.
	 * @param {Number} width Width of texture, must be power of two.
	 * @param {Number} height Height of texture, must be power of two.
	 * @param {bool} [isOpaque] When false (the default) the texture will include an alpha channel, when true the texture will be opaque.
	 */
	initialize: function (width, height, isOpaque, sizePolicy) {
		Core.ObjectRegistry.register(this);
		this._children = [];
		this._width = width;
		this._height = height;
		this._isOpaque = isOpaque ? true : false;
		this._createSendGen(this.__objectRegistryId, width, height, this._isOpaque);
		this._callbackIndexCounter = 1;
		this._callbacks = [];
	},

	/**
	 * Destroys the texture target.
	 */
	destroy: function () {
		var children = this._children;
		while (children.length) {
			this.removeChild(children[0]);
		}
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},

	/**
	 * Adds a GL2.Node object to the RenderTarget.  Visual changes will take effect on the next update.
	 * @param {GL2.Node} child Node to be added.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	addChild: function (child) {
		this._children.push(child);
		child._didAddToParent(this);
		this._addChildSendGen(Core.ObjectRegistry.objectToId(child));
		return this;
	},

	/**
	 * Removes a GL2.Node object from the RenderTarget. Visual changes will take effect on the next update.
	 * @param {GL2.Node} child Node to be removed.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	removeChild: function (child) {
		child._willRemoveFromParent();
		var index = this._children.indexOf(child);
		if (index === -1)
			throw new Error('removeChild called for a node that is not a child');
		this._children.splice(index, 1);
		this._removeChildSendGen(Core.ObjectRegistry.objectToId(child));
		return this;
	},

	/**
	 * Render all the currently attached GL2.Nodes into the texture target.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	update: function () {
		this._updateSendGen();
		return this;
	},

	/**
	 * Automatically render all currently attached GL2.Nodes every frame.
	 * This has the same effect as calling the update method on every frame.
	 * @param {bool} [autoUpdateEnable] Defaults to true, which causes the texture to be updated frame.  Set to false to stop auto updates.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	setAutoUpdate: function (autoUpdateEnable) {
		var enable = (autoUpdateEnable || (autoUpdateEnable === undefined)) ? true : false;
		this._setAutoUpdateSendGen(enable);
		return this;
	},

	/**
	 * Clear texture background before rendering.  By default the background is not cleared.
	 * @param {bool} [clearEnabled] Defaults to true, causing the texture to be cleared before nodes are drawn.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	setClearEnable : function (clearEnable) {
		var enable = (clearEnable || (clearEnable === undefined)) ? true : false;
		this._setClearEnableSendGen(enable);
		return this;
	},

	/**
	 * Set background color of texture.  Can be called with a single Core.color argument or 3 Number arguments.
	 * The default clear color is white.  If the RenderTarget has an alpha component it can be set via the setClearColorAlpha() method.
	 * @param {Number|Core.color} colorOrRed Opaque background color, or the red component if 3 or 4 parameters are given.
	 * @param {Number} [green] Green component of clear color (0, 1).
	 * @param {Number} [blue] Blue component of clear color (0, 1).
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	setClearColor : function () {
		var r, g, b, color;
		if (arguments.length === 1)
		{
			color = arguments[0];
			r = color.getRed();
			g = color.getGreen();
			b = color.getBlue();
		}
		else
		{
			r = arguments[0];
			g = arguments[1];
			b = arguments[2];
		}
		this._setClearColorSendGen(r, g, b);
		return this;
	},

	/**
	 * Set alpha component of background color of texture.
	 * The default clear alpha is 1, opaque.
	 * @param {Number} alpha background color opacity.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	setClearColorAlpha : function (alpha) {
		this._setClearColorAlphaSendGen(alpha);
		return this;
	},

	/**
	 * Save image to the filesystem.
	 * @param {String} filename name of bitmap.
	 * @param {Core.Rect} [rect] Image clip rectangle.  If not specfied the entire RenderTexture will be saved.
	 * @param {Function} [callback] A closure to be executed after image has been saved.  The resulting filename is passed as an argument.
	 */
	save : function (filename, rect, callback) {
		var id = 0;
		if (callback) {
			id = this._callbackIndexCounter++;
			this._callbacks[id] = callback;
		}
		var x = rect ? rect.getOrigin().getX() : -1;
		var y = rect ? rect.getOrigin().getY() : -1;
		var w = rect ? rect.getSize().getWidth() : -1;
		var h = rect ? rect.getSize().getHeight() : -1;
		this._saveSendGen(id, filename, x, y, w, h);
	},

	/**
	 * @private
	 */
	_invokeCallbackRecv: function (cmd)	{
		var msg = {};
		if (!this._invokeCallbackRecvGen(cmd, msg)) {
			return;
		}

		var id = msg.callbackId;
		var err = msg.error;
		if (!id) {
			NgLogE("invokeCallbackRecv command : bad id = " + id);
			return;
		}
		var cb = this._callbacks[id];
		if (!cb) {
			NgLogE("invokeCallbackRecv command : No registered callback found, id = " + id);
			return;
		}
		delete this._callbacks[id];
		cb(err);
	},

	/**
	 * Enable or disable backing store for RenderTarget. Disabled by default
	 * The backing store is used to guarantee that texture will be restored after the application is suspended and restored.
	 * If backing store is not enabled, then the texture is not guaranteed to render correctly after the application is restored.
	 * @param {Bool} [backingStoreEnable] If omitted backing store will be enabled.
	 */
	setBackingStoreEnable: function (backingStoreEnable) {
		var enable = (backingStoreEnable || (backingStoreEnable === undefined)) ? true : false;
		this._setBackingStoreEnableSendGen(enable);
		return this;
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 353
	// Method create = -1
	// Method destroy = 2
	// Method addChild = 3
	// Method removeChild = 4
	// Method update = 5
	// Method setAutoUpdate = 6
	// Method setClearEnable = 7
	// Method setClearColor = 8
	// Method setClearColorAlpha = 9
	// Method save = 10
	// Method invokeCallback = 11
	// Method setBackingStoreEnable = 12
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 11:
					instance._invokeCallbackRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in RenderTarget._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in RenderTarget._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[353] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_invokeCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in RenderTarget.invokeCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in RenderTarget.invokeCallback from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in RenderTarget.invokeCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( objectRegistryId, width, height, isOpaque )
	{
		Core.Proc.appendToCommandString( ":353,-1," + objectRegistryId + "," + width + "," + height + "," + ( isOpaque ? 1 : 0 )  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":353,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_addChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":353,3," + this.__objectRegistryId + "," + child  );
	},
	
	/** @private */
	_removeChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":353,4," + this.__objectRegistryId + "," + child  );
	},
	
	/** @private */
	_updateSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":353,5," + this.__objectRegistryId );
	},
	
	/** @private */
	_setAutoUpdateSendGen: function( autoUpdateEnable )
	{
		Core.Proc.appendToCommandString( ":353,6," + this.__objectRegistryId + "," + ( autoUpdateEnable ? 1 : 0 )  );
	},
	
	/** @private */
	_setClearEnableSendGen: function( clearEnable )
	{
		Core.Proc.appendToCommandString( ":353,7," + this.__objectRegistryId + "," + ( clearEnable ? 1 : 0 )  );
	},
	
	/** @private */
	_setClearColorSendGen: function( r, g, b )
	{
		Core.Proc.appendToCommandString( ":353,8," + this.__objectRegistryId + "," + r + "," + g + "," + b  );
	},
	
	/** @private */
	_setClearColorAlphaSendGen: function( a )
	{
		Core.Proc.appendToCommandString( ":353,9," + this.__objectRegistryId + "," + a  );
	},
	
	/** @private */
	_saveSendGen: function( callbackId, filename, originX, originY, width, height )
	{
		Core.Proc.appendToCommandString( ":353,10," + this.__objectRegistryId + "," + callbackId + "," + Core.Base64.encode( filename ) + "," + originX + "," + originY + "," + width + "," + height  );
	},
	
	/** @private */
	_setBackingStoreEnableSendGen: function( backingStoreEnable )
	{
		Core.Proc.appendToCommandString( ":353,12," + this.__objectRegistryId + "," + ( backingStoreEnable ? 1 : 0 )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( objectRegistryId, width, height, isOpaque ) {}
	
	// destroy: function(  ) {}
	
	// addChild: function( child ) {}
	
	// removeChild: function( child ) {}
	
	// update: function(  ) {}
	
	// setAutoUpdate: function( autoUpdateEnable ) {}
	
	// setClearEnable: function( clearEnable ) {}
	
	// setClearColor: function( r, g, b ) {}
	
	// setClearColorAlpha: function( a ) {}
	
	// save: function( callbackId, filename, originX, originY, width, height ) {}
	
	// _invokeCallbackRecv: function( cmd ) {}
	// setBackingStoreEnable: function( backingStoreEnable ) {}
	

// {{/Wg Generated Code}}

});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/Body'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/Body'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/Body'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Body = Core.Class.subclass(
/** @lends Physics2.Body.prototype */
{
	classname: 'Body',
	
	/**
	 * @class The <code>Body</code> class constructs instances of application bodies.
	 * Most properties are identical to properties for the <code>b2Body</code> class
	 * of <code>Box2d</code>.
	 * @constructs The default constructor. 
	 * @see <a href="http://www.box2d.org/manual.html">Properties of b2Body</a>
	 * @augments Core.Class 
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._shapes = [];
		this._gl2Node = null;
		this._type = this.Type.Dynamic;
		this._contactFlags = 0;
		this._isSynchronized = false;
		this._isBullet = false;
		this._isAwake = true;
		this._isSleepingAllowed = true;
		this._isFixedRotation = false;
		this._linearDamping = 0;
		this._angularDamping = 0;
		this._position = new Core.Point();
		this._rotation = 0;
		this._linearVelocity = new Core.Vector();
		this._angularVelocity = 0;
		this._world = null;
		this._joints = [];
		
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash
	 */
	destroy: function()
	{
		shapes = this._shapes;
		while(shapes.length)
		{
			this.removeShape(shapes[0]);
		}
		
		if(this._world)
		{
			this._world.removeBody(this);
		}

		joints = this._joints;
		while(joints.length)
		{
			this._removeFromJoint(joints[0]);
		}
			
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
	
	/**
	 * Add a collision shape to this <code>Body</code>.
	 * @example var body = new Physics2.Body();
	 * ...
	 * var shape = new Physics2.BoxShape();
	 * ...
	 * body.addShape(shape);
	 * @param {Physics2.Shape} shape The collision shape to add.
	 * @see Physics2.Body#removeShape
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	addShape: function(shape)
	{
		this._shapes.push(shape);
		
		this._addShapeSendGen(Core.ObjectRegistry.objectToId(shape));
	},
	
	/**
	 * Remove a collision shape from this <code>Body</code>.
	 * @param {Physics2.Shape} shape The collision shape to remove.
	 * @see Physics2.Body#addShape
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	removeShape: function(shape)
	{
		var index = this._shapes.indexOf(shape);
		if(index != -1)
			this._shapes.splice(index, 1);
		
		this._removeShapeSendGen(Core.ObjectRegistry.objectToId(shape));
	},
	
	/**
	 * Retrieve the number of collision shapes in this <code>Body</code>.
	 * @returns {Number} The current number of collision shapes.
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getShapeCount: function()
	{
		return this._shapes.length;
	},
	
	/**
	 * Retrieve a collision shape at a specific index of this <code>Body</code>.
	 * @param {Number} index The index from which to retrieve a collision shape.
	 * @returns {Physics2.Shape} The current collision shape retrieved from the specified index.
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getShape: function(index)
	{
		return this._shapes[index];
	},
	
	/**
	 * Retrieve the node this <code>Body</code> is controlling.
	 * @returns {GL2.Node} The current node.
	 * @see Physics2.Body#setGL2Node
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getGL2Node: function()
	{
		return this._gl2Node;
	},
	
	/**
	 * Set the node this <code>Body</code> is controlling.
	 * When the physics simulation moves this <code>Body</code>,
	 * the position and rotation will automatically
	 * apply to the node specified through this call.
	 * @param {GL2.Node} [gl2Node=null] The new node to control.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setGL2Node: function(gl2Node)
	{
		this._gl2Node = gl2Node;
		this._setGL2NodeSendGen(Core.ObjectRegistry.objectToId(gl2Node));
		return this;
	},
	
	/**
	 * Retrieve the body type for this <code>Body</code>.
	 * @returns {Physics2.Body#Type} The current body type.
	 * @see Physics2.Body#setType
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getType: function()
	{
		return this._type;
	},
	
	/**
	 * Set the body type for this <code>Body</code>.
	 * @example var ground = new Physics2.Body();
	 * ground.setType(Physics2.Body.Type.Static);
	 * @param {Physics2.Body#Type} [type=Dynamic] The new body type.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Body#getType
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setType: function(type)
	{
		this._type = type;
		
		if(type == this.Type.Static)
		{
			this._linearVelocity.setAll(0,0);
			this._angularVelocity = 0.0;
		}
		
		this._isAwake = true;
		
		this._setTypeSendGen(type);
		return this;
	},
	
	/**
	 * Retrieve the contact flags for this <code>Body</code>.
	 * @returns {Number} The current number of contact flags.
	 * @see Physics2.Body#setContactFlags
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getContactFlags: function()
	{
		return this._contactFlags;
	},
	
	/**
	 * Set the contact flags for this <code>Body</code>.
	 * Contact flags control the collision dynamics that will generate
	 * contact events for this <code>Body</code>.
	 * @example var body = new Physics2.Body();
	 * body.setContactFlags(Physics2.Body.ContactFlags.Begin);
	 * @param {Physics2.Body#ContactFlags} [flags=none] The new number of contact flags.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setContactFlags: function(contactFlags)
	{
		this._contactFlags = contactFlags;
		this._setContactFlagsSendGen(contactFlags);
		return this;
	},
	
	/**
	 * Retrieve the synchronization state for this <code>Body</code>.
	 * @returns {Boolean} Returns <code>true</code> if this <code>Body</code> is synchronized.
	 * @see Physics2.Body#setIsSynchronized
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getIsSynchronized: function()
	{
		return this._isSynchronized;
	},
	
	/**
	 * Set the synchronization state for this <code>Body</code>.
	 * A <code>Body</code> specified through this call will synchronize the position, rotation, linear velocity, and angular
	 * velocity with the physics simulation on the backend.	 
	 * <br><br>
	 * <b>Note:</b> Synchronized bodies require significantly more processing time than non-synchronized bodies.
	 * Enable this only for bodies that require inspection from application code.
	 * @example var body = new Physics2.Body();
	 * body.setIsSynchronized(true);
	 * @param {Boolean} [isSynchronized=false] Set as <code>true</code> if this <code>Body</code> is synchronized.
	 * If <code>true</code>, <code>getPosition()</code>, <code>getRotation()</code>,
	 * <code>getLinearVelocity()</code>, <code>getAngularVelocity()</code> and 
	 * <code>getIsAwake()</code> return the state of the body on the native backend. If <code>false</code>,
	 * those functions will return the last value passed to the corresponding set function and will not
	 * reflect the current state of the physics simulation.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Body#getIsSynchronized,
	 * @see Physics2.Body#getPosition,
	 * @see Physics2.Body#getRotation,
	 * @see Physics2.Body#getLinearVelocity,
	 * @see Physics2.Body#getAngularVelocity, 
	 * @see Physics2.Body#getIsAwake
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setIsSynchronized: function(isSynchronized)
	{
		this._isSynchronized = isSynchronized;
		this._setIsSynchronizedSendGen(isSynchronized);
		return this;
	},
	
	/**
	 * Retrieve whether this <code>Body</code> is a bullet.
	 * @returns {Boolean} Returns <code>true</code> if this <code>Body</code> is a bullet.
	 * @see Physics2.Body#setIsBullet
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getIsBullet: function()
	{
		return this._isBullet;
	},
	
	/**
	 * Set this <code>Body</code> as a bullet.
	 * @param {Boolean} [isBullet=false] Set as <code>true</code> if this <code>Body</code> is a bullet.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Body#getIsBullet
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setIsBullet: function(isBullet)
	{
		this._isBullet = isBullet;
		this._setIsBulletSendGen(isBullet);
		return this;
	},
	
	/**
	 * Retrieve whether this <code>Body</code> is awake.
	 * @returns {Boolean} Returns <code>true</code> if this <code>Body</code>.
	 * @see Physics2.Body#setIsAwake
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getIsAwake: function()
	{
		return this._isAwake;
	},
	
	/**
	 * Set this <code>Body</code> as awake.
	 * @param {Boolean} [isAwake=true] Set as <code>true</code> if this <code>Body</code> is awake.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Pysics2.Body#getIsAwake
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setIsAwake: function(isAwake)
	{
		this._isAwake = isAwake;
		this._setIsAwakeSendGen(isAwake);
		return this;
	},
	
	/**
	 * Retrieve whether sleeping is allowed for this <code>Body</code>.
	 * @returns {Boolean} Returns <code>true</code> if sleeping is allowed.
	 * @see Physics2.Body#setIsSleepingAllowed
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getIsSleepingAllowed: function()
	{
		return this._isSleepingAllowed;
	},
	
	/**
	 * Set whether this <code>Body</code> is allowed to sleep.
	 * @param {Boolean} [isSleepingAllowed=true] Set as <code>true</code> if sleeping is allowed.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Body#getIsSleepingAllowed
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setIsSleepingAllowed: function(isSleepingAllowed)
	{
		this._isSleepingAllowed = isSleepingAllowed;
		this._setIsSleepingAllowedSendGen(isSleepingAllowed);
		return this;
	},
	
	/**
	 * Retrieve whether rotation is fixed for this <code>Body</code>.
	 * @returns {Boolean} Returns <code>true</code> if the rotation is fixed.
	 * @see Physics2.Body#setIsFixedRotation
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getIsFixedRotation: function()
	{
		return this._isFixedRotation;
	},
	
	/**
	 * Set whether rotation is fixed for this <code>Body</code>.
	 * @param {Boolean} [isFixedRotation=false] Returns <code>true</code> if rotation is fixed.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Body#getIsFixedRotation
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setIsFixedRotation: function(isFixedRotation)
	{
		this._isFixedRotation = isFixedRotation;
		this._setIsFixedRotationSendGen(isFixedRotation);
		return this;
	},
	
	/**
	 * Retrieve the linear damping amount for this <code>Body</code>.
	 * @returns {Number} The current linear damping amount.
	 * @see Physics2.Body#setLinearDamping
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getLinearDamping: function()
	{
		return this._linearDamping;
	},
	
	/**
	 * Set the linear damping amount for this <code>Body</code>.
	 * @param {Number} [linearDamping=0] The new linear damping amount.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Body#getLinearDamping
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setLinearDamping: function(linearDamping)
	{
		this._linearDamping = linearDamping;
		this._setLinearDampingSendGen(linearDamping);
		return this;
	},
	
	/**
	 * Retrieve the angular damping amount for this <code>Body</code>.
	 * @returns {Number} The current angular damping amount.
	 * @see Physics2.Body#setAngularDamping
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getAngularDamping: function()
	{
		return this._angularDamping;
	},
	
	/**
	 * Set the angular damping amount for this <code>Body</code>.
	 * @param {Number} [angularDamping=0] The new angular damping amount.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Body#getAngularDamping
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setAngularDamping: function(angularDamping)
	{
		this._angularDamping = angularDamping;
		this._setAngularDampingSendGen(angularDamping);
		return this;
	},
	
	/**
	 * Retrieve the position for this <code>Body</code>. If this <code>Body</code> is synchronized,
	 * this call will retrieve the current value from the physics simulation.
	 * @returns {Core.Point} The current position.
	 * @see Physics2.Body#setPosition
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getPosition: function()
	{
		return this._position;
	},
	
	/**
	 * Set the position for this <code>Body</code>.
	 * @example var w = Core.Capabilities.getScreenWidth();
	 * var h = Core.Capabilities.getScreenHeight();
	 * ...
	 * var body = new Physics2.Body();
	 * body.setPosition(w/4, h/5);
	 * @param {Core.Point} [position=(0,0)] The new position.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Body#getPosition
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setPosition: function(position)
	{
		var p = this._position;
		p.setAll.apply(p, arguments);
		this._setPositionSendGen(p.getX(),p.getY());
		return this;
	},
	
	/**
	 * Retrieve the rotation for this <code>Body</code>. If this <code>Body</code> is synchronized,
	 * this call will retrieve the current value from the physics simulation.
	 * @returns {Core.Point} The current rotation.
	 * @see Physics2.Body#setRotation
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getRotation: function()
	{
		return this._rotation;
	},
	
	/**
	 * Set the rotation for this <code>Body</code>.
	 * @example var body = new Physics2.Body();
	 * body.setRotation(5);
	 * @param {Number} [rotation=0] The new rotation.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Body#getRotation
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setRotation: function(rotation)
	{
		this._rotation = rotation;
		this._setRotationSendGen(rotation);
		return this;
	},

	/**
	 * Retrieve the linear velocity for this <code>Body</code>. If this <code>Body</code> is synchronized,
	 * this call will retrieve the current value from the physics simulation.
	 * @returns {Core.Vector} The current linear velocity.
	 * @see Physics2.Body#setLinearVelocity
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getLinearVelocity: function()
	{
		return this._linearVelocity;
	},
	
	/**
	 * Set the linear velocity for this <code>Body</code>.
	 * @example var body = new Physics2.Body();
	 * body.setLinearVelocity(40, 0);
	 * @param {Core.Vector} [linearVelocity=(0, 0)] The new linear velocity.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Body#getLinearVelocity
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setLinearVelocity: function(linearVelocity)
	{
		var v = this._linearVelocity;
		v.setAll.apply(v, arguments);
		this._setLinearVelocitySendGen(v.getX(),v.getY());
		return this;
	},
	
	/**
	 * Retrieve the angular velocity of this <code>Body</code>. If this <code>Body</code> is synchronized,
	 * this call will retrieve the current value from the physics simulation.
	 * @returns {Nmber} The current angular velocity.
	 * @see Physics2.Body#setAngularVelocity
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	getAngularVelocity: function()
	{
		return this._angularVelocity;
	},
	
	/**
	 * Set the angular velocity of this <code>Body</code>.
	 * @example var body = new Physics2.Body();
	 * ...
	 * var rvel = Math.random() * 12 - 6;
	 * ...
	 * body.setAngularVelocity(rvel);
	 * @param {Number} [angularVelocity=0] The new angular velocity.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Body#getAngularVelocity
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	setAngularVelocity: function(angularVelocity)
	{
		this._angularVelocity = angularVelocity;
		this._setAngularVelocitySendGen(angularVelocity);
		return this;
	},
	
	/**
	 * Set the force an application will apply to this <code>Body</code> at a specific location. The application will continue to apply the specified force
	 * every physics step until reaching a force of <code>0</code>.
	 * @param {Core.Vector} force The force to apply.
	 * @param {Core.Point} point The location point where force is applied.
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	applyForce: function(force, point)
	{
		this._applyForceSendGen(force.getX(),force.getY(),point.getX(),point.getY());
	},
	
	/**
	 * Set the torque an application will apply to this <code>Body</code>. The application will continue to apply the specified torque
	 * every physics step until reaching a toruqe of <code>0</code>.
	 * @param {Number} torque The torque to apply.
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	applyTorque: function(torque)
	{
		this._applyTorqueSendGen(torque);
	},
	
	/**
	 * Apply a one-time impulse to this <code>Body</code> at a specific location. 
	 * @param {Core.Vector} impulse The impulse to apply.
	 * @param {Core.Point} point The location point where the impulse is applied.
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	applyLinearImpulse: function(impulse, point)
	{
		this._applyLinearImpulseSendGen(impulse.getX(),impulse.getY(),point.getX(),point.getY());
	},
	
	/**
	 * Apply a one-time angular impulse. The impulse is designed to generate angular momentum on the <code>Body</code>.
	 * @param {Number} impulse The impulse to apply.
	 * @status iOS, Android, Flash,  Test, iOSTested, AndroidTested
	 */
	applyAngularImpulse: function(impulse)
	{
		this._applyAngularImpulseSendGen(impulse);
	},
	
	_setIsAwakeRecv: function( cmd ) 
	{
		var msg = {};
		if (!this._setIsAwakeRecvGen(cmd, msg))
			return;
		
		this._isAwake = msg.isAwake;
	},
	
	_synchronizeBodyRecv: function(cmd)
	{
		if (!this._isSynchronized) return;
		var msg = {};
		if(!this._synchronizeBodyRecvGen(cmd, msg))
			return;
		this._position.setAll(msg.px, msg.py);
		this._rotation = msg.rotation;
		this._linearVelocity.setAll(msg.vx, msg.vy);
		this._angularVelocity = msg.angularVelocity;
	},
	
	_didAddToWorld: function(world)
	{
		if(this._world)
			this._world.removeBody(this);
		
		this._world = world;
	},
	
	_willRemoveFromWorld: function(world)
	{
		this._world = null;
	},
	
	_didAddToJoint: function(joint)
	{
		this._joints.push(joint);
	},

	_willRemoveFromJoint: function(joint)
	{
		var index = this._joints.indexOf(joint);
		if(index == -1)
			return;

		this._joints.splice(index,1);
	},

	_removeFromJoint: function(joint)
	{
		this._willRemoveFromJoint(joint);

		if(joint.getBodyA() == this);
		   joint.setBodyA(null);
	   if(joint.getBodyB() == this);
		   joint.setBodyB(null);
	},

	// note: this does not support overriding MassData
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for body type.
	 * @namespace
	 */
	Type:
	{ 
		/** <code>Body</code> will never move under simulation. */
		Static: 0,
		/** <code>Body</code> assumes control of velocity and will push dynamic bodies aside. */
		Kinematic: 1,
		/** <code>Body</code> is under complete control of the simulation. */
		Dynamic: 2,
	},
	
	/** 
	 * Enumeration for contact flags.
	 * @namespace
	 */
	ContactFlags:
	{ 
		/** Generate a contact callback when this <code>Body</code> begins touching another <code>Body</code>. */
		Begin: 1,
		/** Generate a contact callback when this <code>Body</code> stops touching another <code>Body</code>. */
		End: 2,
		/** Generate a contact callback each simulation step that this <code>Body</code> is touching another <code>Body</code>. */
		Solved: 4,
		/** Generate a contact callback for all cases. */
		All: 7,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 315
	// Method create = -1
	// Method destroy = 2
	// Method addShape = 3
	// Method removeShape = 4
	// Method setGL2Node = 5
	// Method setType = 6
	// Method setContactFlags = 7
	// Method setIsSynchronized = 8
	// Method setIsBullet = 9
	// Method setIsAwake = 10
	// Method setIsSleepingAllowed = 11
	// Method setIsFixedRotation = 12
	// Method setLinearDamping = 13
	// Method setAngularDamping = 14
	// Method setPosition = 15
	// Method setRotation = 16
	// Method setLinearVelocity = 17
	// Method setAngularVelocity = 18
	// Method applyForce = 19
	// Method applyTorque = 20
	// Method applyLinearImpulse = 21
	// Method applyAngularImpulse = 22
	// Method synchronizeBody = 23
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 10:
					instance._setIsAwakeRecv( cmd );
					break;
				case 23:
					instance._synchronizeBodyRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Body._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Body._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[315] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_setIsAwakeRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Body.setIsAwake from command: " + cmd );
			return false;
		}
		
		obj[ "isAwake" ] = Core.Proc.parseBool( cmd[ 0 ] );
		if( obj[ "isAwake" ] === undefined )
		{
			NgLogE("Could not parse isAwake in Body.setIsAwake from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_synchronizeBodyRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 6 )
		{
			NgLogE("Could not parse due to wrong argument count in Body.synchronizeBody from command: " + cmd );
			return false;
		}
		
		obj[ "px" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "px" ] === undefined )
		{
			NgLogE("Could not parse px in Body.synchronizeBody from command: " + cmd );
			return false;
		}
		
		obj[ "py" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "py" ] === undefined )
		{
			NgLogE("Could not parse py in Body.synchronizeBody from command: " + cmd );
			return false;
		}
		
		obj[ "rotation" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "rotation" ] === undefined )
		{
			NgLogE("Could not parse rotation in Body.synchronizeBody from command: " + cmd );
			return false;
		}
		
		obj[ "vx" ] = Core.Proc.parseFloat( cmd[ 3 ] );
		if( obj[ "vx" ] === undefined )
		{
			NgLogE("Could not parse vx in Body.synchronizeBody from command: " + cmd );
			return false;
		}
		
		obj[ "vy" ] = Core.Proc.parseFloat( cmd[ 4 ] );
		if( obj[ "vy" ] === undefined )
		{
			NgLogE("Could not parse vy in Body.synchronizeBody from command: " + cmd );
			return false;
		}
		
		obj[ "angularVelocity" ] = Core.Proc.parseFloat( cmd[ 5 ] );
		if( obj[ "angularVelocity" ] === undefined )
		{
			NgLogE("Could not parse angularVelocity in Body.synchronizeBody from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":315,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":315,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_addShapeSendGen: function( shape )
	{
		Core.Proc.appendToCommandString( ":315,3," + this.__objectRegistryId + "," + shape  );
	},
	
	/** @private */
	_removeShapeSendGen: function( shape )
	{
		Core.Proc.appendToCommandString( ":315,4," + this.__objectRegistryId + "," + shape  );
	},
	
	/** @private */
	_setGL2NodeSendGen: function( gl2Node )
	{
		Core.Proc.appendToCommandString( ":315,5," + this.__objectRegistryId + "," + gl2Node  );
	},
	
	/** @private */
	_setTypeSendGen: function( type )
	{
		Core.Proc.appendToCommandString( ":315,6," + this.__objectRegistryId + "," + type  );
	},
	
	/** @private */
	_setContactFlagsSendGen: function( contactFlags )
	{
		Core.Proc.appendToCommandString( ":315,7," + this.__objectRegistryId + "," + contactFlags  );
	},
	
	/** @private */
	_setIsSynchronizedSendGen: function( isSynchronized )
	{
		Core.Proc.appendToCommandString( ":315,8," + this.__objectRegistryId + "," + ( isSynchronized ? 1 : 0 )  );
	},
	
	/** @private */
	_setIsBulletSendGen: function( isBullet )
	{
		Core.Proc.appendToCommandString( ":315,9," + this.__objectRegistryId + "," + ( isBullet ? 1 : 0 )  );
	},
	
	/** @private */
	_setIsAwakeSendGen: function( isAwake )
	{
		Core.Proc.appendToCommandString( ":315,10," + this.__objectRegistryId + "," + ( isAwake ? 1 : 0 )  );
	},
	
	/** @private */
	_setIsSleepingAllowedSendGen: function( isSleepingAllowed )
	{
		Core.Proc.appendToCommandString( ":315,11," + this.__objectRegistryId + "," + ( isSleepingAllowed ? 1 : 0 )  );
	},
	
	/** @private */
	_setIsFixedRotationSendGen: function( isFixedRotation )
	{
		Core.Proc.appendToCommandString( ":315,12," + this.__objectRegistryId + "," + ( isFixedRotation ? 1 : 0 )  );
	},
	
	/** @private */
	_setLinearDampingSendGen: function( linearDamping )
	{
		Core.Proc.appendToCommandString( ":315,13," + this.__objectRegistryId + "," + linearDamping  );
	},
	
	/** @private */
	_setAngularDampingSendGen: function( angularDamping )
	{
		Core.Proc.appendToCommandString( ":315,14," + this.__objectRegistryId + "," + angularDamping  );
	},
	
	/** @private */
	_setPositionSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":315,15," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setRotationSendGen: function( rotation )
	{
		Core.Proc.appendToCommandString( ":315,16," + this.__objectRegistryId + "," + rotation  );
	},
	
	/** @private */
	_setLinearVelocitySendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":315,17," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setAngularVelocitySendGen: function( angularVelocity )
	{
		Core.Proc.appendToCommandString( ":315,18," + this.__objectRegistryId + "," + angularVelocity  );
	},
	
	/** @private */
	_applyForceSendGen: function( fx, fy, px, py )
	{
		Core.Proc.appendToCommandString( ":315,19," + this.__objectRegistryId + "," + fx + "," + fy + "," + px + "," + py  );
	},
	
	/** @private */
	_applyTorqueSendGen: function( torque )
	{
		Core.Proc.appendToCommandString( ":315,20," + this.__objectRegistryId + "," + torque  );
	},
	
	/** @private */
	_applyLinearImpulseSendGen: function( ix, iy, px, py )
	{
		Core.Proc.appendToCommandString( ":315,21," + this.__objectRegistryId + "," + ix + "," + iy + "," + px + "," + py  );
	},
	
	/** @private */
	_applyAngularImpulseSendGen: function( angularImpulse )
	{
		Core.Proc.appendToCommandString( ":315,22," + this.__objectRegistryId + "," + angularImpulse  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// addShape: function( shape ) {}
	
	// removeShape: function( shape ) {}
	
	// setGL2Node: function( gl2Node ) {}
	
	// setType: function( type ) {}
	
	// setContactFlags: function( contactFlags ) {}
	
	// setIsSynchronized: function( isSynchronized ) {}
	
	// setIsBullet: function( isBullet ) {}
	
	// _setIsAwakeRecv: function( cmd ) {}
	// setIsAwake: function( isAwake ) {}
	
	// setIsSleepingAllowed: function( isSleepingAllowed ) {}
	
	// setIsFixedRotation: function( isFixedRotation ) {}
	
	// setLinearDamping: function( linearDamping ) {}
	
	// setAngularDamping: function( angularDamping ) {}
	
	// setPosition: function( x, y ) {}
	
	// setRotation: function( rotation ) {}
	
	// setLinearVelocity: function( x, y ) {}
	
	// setAngularVelocity: function( angularVelocity ) {}
	
	// applyForce: function( fx, fy, px, py ) {}
	
	// applyTorque: function( torque ) {}
	
	// applyLinearImpulse: function( ix, iy, px, py ) {}
	
	// applyAngularImpulse: function( angularImpulse ) {}
	
	// _synchronizeBodyRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/BoxShape'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/BoxShape'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/BoxShape'] = exports; var Shape = require('NGCore/Client/Physics2/Shape').Shape;
var Core = require('NGCore/Client/Core').Core;

exports.BoxShape = Shape.subclass(
/** @lends Physics2.BoxShape.prototype */
{
	classname: 'BoxShape',
	
	/**
	 * @class The <code>BoxShape</code> class constructs objects that define the collision box shape.
	 * @constructs The default constructor. 
	 * @augments Physics2.Shape
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._position = new Core.Point();
		this._anchor = new Core.Point(0.5, 0.5);
		this._size = new Core.Size();
		this._rotation = 0;
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Retrieve the position for this <code>BoxShape</code>.
	 * @returns {Core.Point} The current position.
	 * @see Physics2.BoxShape#setPosition
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getPosition: function()
	{
		return this._position;
	},
	
	/**
	 * Set the position for this <code>BoxShape</code>.
	 * @example var box = new Physics2.BoxShape();
	 * box.setPosition(0, Core.Capabilities.getScreenHeight());
	 * @param {Core.Point} [position=(0, 0)] The new position.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.BoxShape#getPosition
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setPosition: function(position)
	{
		var p = this._position;
		p.setAll.apply(p, arguments);
		this._setPositionSendGen(p.getX(),p.getY());
		return this;
	},
	
	/**
	 * Retrieve the anchor for this <code>BoxShape</code>.
	 * @returns {Core.Point} The current anchor.
	 * @see Physics2.BoxShape#setAnchor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnchor: function()
	{
		return this._anchor;
	},
	
	/**
	 * Set the anchor for this <code>BoxShape</code>.
	 * @example var box = new Physics2.BoxShape();
	 * box.setAnchor(0, 1);
	 * @param {Core.Point} [anchor=(0.5, 0.5)] The new anchor.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.BoxShape#getAnchor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAnchor: function(anchor)
	{
		var a = this._anchor;
		a.setAll.apply(a, arguments);
		this._setAnchorSendGen(a.getX(),a.getY());
		return this;
	},
	
	/**
	 * Retrieve the size for this <code>BoxShape</code>.
	 * @returns {Core.Size} The current size.
	 * @see Physics2.BoxShape#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSize: function()
	{
		return this._size;
	},
	
	/**
	 * Set the size for this <code>BoxShape</code>.
	 * @example var box = new Physics2.BoxShape();
	 * box.setSize(Core.Capabilities.getScreenWidth(), thick);
	 * @param {Core.Size} [size=(0, 0)] The new size.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.BoxShape#getSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setSize: function(size)
	{
		var s = this._size;
		s.setAll.apply(s, arguments);
		this._setSizeSendGen(s.getWidth(),s.getHeight());
		return this;
	},
	
	/**
	 * Retrieve the rotation for this <code>BoxShape</code>.
	 * @returns {Number} The current rotation.
	 * @see Physics2.BoxShape#setRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getRotation: function()
	{
		return this._rotation;
	},
	
	/**
	 * Set the rotation for this <code>BoxShape</code>.
	 * @example var box = BoxShape();
	 * box.setRotation(45);
	 * @param {Number} [rotation=0] The new rotation.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.BoxShape#getRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setRotation: function(rotation)
	{
		this._rotation = rotation;
		this._setRotationSendGen(rotation);
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 317
	// Method create = -1
	// Method destroy = 2
	// Method setPosition = 3
	// Method setAnchor = 4
	// Method setSize = 5
	// Method setRotation = 6
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in BoxShape._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in BoxShape._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[317] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":317,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":317,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setPositionSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":317,3," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setAnchorSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":317,4," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setSizeSendGen: function( width, height )
	{
		Core.Proc.appendToCommandString( ":317,5," + this.__objectRegistryId + "," + width + "," + height  );
	},
	
	/** @private */
	_setRotationSendGen: function( rotation )
	{
		Core.Proc.appendToCommandString( ":317,6," + this.__objectRegistryId + "," + rotation  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setPosition: function( x, y ) {}
	
	// setAnchor: function( x, y ) {}
	
	// setSize: function( width, height ) {}
	
	// setRotation: function( rotation ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/CircleShape'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/CircleShape'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/CircleShape'] = exports; var Shape = require('NGCore/Client/Physics2/Shape').Shape;

exports.CircleShape = Shape.subclass(
/** @lends Physics2.CircleShape.prototype */
{
	classname: 'CircleShape',
	
	/**
	 * @class The <code>CircleShape</code> class constructs objects that define the collision circle shape.
	 * @constructs The default constructor. 
	 * @augments Physics2.Shape
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._position = new Core.Point();
		this._radius = 0;
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Retrieve the position of this <code>CircleShape</code>.
	 * @returns {Core.Point} The current position.
	 * @see Physics2.CircleShape#setPosition
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getPosition: function()
	{
		return this._position;
	},
	
	/**
	 * Set the position for this <code>CircleShape</code>.
	 * @example var circle = new Physics2.CircleShape();
	 * circle.setPosition(0, Core.Capabilities.getScreenHeight());
	 * @param {Core.Point} [position=(0, 0)] The new position.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.CircleShape#getPosition
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setPosition: function(position)
	{
		var p = this._position;
		p.setAll.apply(p, arguments);
		this._setPositionSendGen(p.getX(),p.getY());
		return this;
	},
	
	/**
	 * Retrieve the radius for this <code>CircleShape</code>.
	 * @returns {Number} The current radius.
	 * @see Physics2.CircleShape#setRadius
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getRadius: function()
	{
		return this._radius;
	},
	
	/**
	 * Set the radius for this <code>CircleShape</code>.
	 * @example function makeCircle(position, radius)
	 * ...
	 * var circle = new Physics2.CircleShape();
	 * circle.setRadius(radius);
	 * @param {Number} [radius=0] The new radius.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.CircleShape#getRadius
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setRadius: function(radius)
	{
		this._radius = radius;
		this._setRadiusSendGen(radius);
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 318
	// Method create = -1
	// Method destroy = 2
	// Method setPosition = 3
	// Method setRadius = 4
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in CircleShape._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in CircleShape._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[318] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":318,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":318,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setPositionSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":318,3," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setRadiusSendGen: function( radius )
	{
		Core.Proc.appendToCommandString( ":318,4," + this.__objectRegistryId + "," + radius  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setPosition: function( x, y ) {}
	
	// setRadius: function( radius ) {}
	

// {{/Wg Generated Code}}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/PolygonShape'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/PolygonShape'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/PolygonShape'] = exports; var Shape = require('NGCore/Client/Physics2/Shape').Shape;

exports.PolygonShape = Shape.subclass(
/** @lends Physics2.PolygonShape.prototype */
{
	classname: 'PolygonShape',
	
	/**
	 * @class The <code>PolygonShape</code> class constructs objects that define a polygon collision shape.
	 * @constructs The default constructor. 
	 * @augments Physics2.Shape
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._vertexes = [];
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Retrieve the number of vertices from this <code>PolygonShape</code>.
	 * @returns {Number} The current number of vertices.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVertexCount: function()
	{
		return this._vertexes.length;
	},
	
	/**
	 * Retrieve a vertex at a specific index of this <code>PolygonShape</code>.
	 * @param {Number} index The index containing the vertex to retrieve.
	 * @returns {Core.Point} The current vertex at the specified index.
	 * @see Physics2.PolygonShape#setVertex
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVertex: function(index)
	{
		return this._vertexes[index];
	},
	
    /**
	 * Add a vertex polygon to this <code>PolygonShape</code>.
	 * <pre class="code"><font size="1">var poly = new Physics2.PolygonShape();
	 * ...
	 * poly.pushVertex(new Core.Point(w*2/10, h*5/6));</font></pre>
	 * Calling <code>pushVertex()</code> is equivalent to calling <code>spliceVertexes()</code> in the following way:
	 * <pre class="code"><font size="1">PolygonShape.spliceVertexes(polygon.getVertexCount(), 0, vertex)</font></pre>
	 * @param {Core.Point} vertex The vertex to add.
	 * @see Physics2.PolygonShape#spliceVertexes
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	pushVertex: function(vertex)
	{
		return this.spliceVertexes(this._vertexes.length, 0, vertex);
	},
	
    /**
	 * Set the vertex at index <i>i</i> for this <code>PolygonShape</code>.
	 * Calling <code>setVertex()</code> is equivalent to calling <code>spliceVertexes()</code> in the following way:
	 * <pre class="code"><font size="2">vertex.spliceVertexes(i, 1, vertex)</font></pre>
	 * @param {Number} <i>i</i> The specified index.
	 * @param {Core.Point} vertex The vertex to set.
	 * @see Physics2.PolygonShape#getVertex
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setVertex: function(i, vertex)
	{
		return this.spliceVertexes(i, 1, vertex);
	},
	
    /**
	 * Remove <code>len</code> vertices, beginning at <code>start</code> position, and insert vertices at <code>start</code> position.
	 * This method accepts <i>n</i> parameters, assuming that the second parameter and higher are references to vertices.<br><br>
	 * The following is an example of passing three vertices to insert.
	 * @param {Number} start The index of the first vertex to remove.
	 * @param {Number} len The number of vertices to remove.
	 * @param {Core.Point} vertexes The vertices to remove.
	 * @example
	 * PolygonShape.spliceVertexes(0, 0, vertex1, vertex2, vertex3).
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    spliceVertexes: function(start, len, vertexes)
	{
		var v = this._vertexes;
		v.splice.apply(v, arguments);
		
		var vertexCount = arguments.length-2;
		this._spliceVertexesSendGen(start,len,vertexCount);
		
		for(var i=0; i < vertexCount; ++i)
		{
			var vertex = arguments[i+2];
			this._vertexSendGen(vertex.getX(),vertex.getY());
		}
		
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 319
	// Method create = -1
	// Method destroy = 2
	// Method spliceVertexes = 3
	// Method vertex = 4
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in PolygonShape._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in PolygonShape._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[319] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":319,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":319,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_spliceVertexesSendGen: function( start, len, vertexCount )
	{
		Core.Proc.appendToCommandString( ":319,3," + this.__objectRegistryId + "," + start + "," + len + "," + vertexCount  );
	},
	
	/** @private */
	_vertexSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( "," + x + "," + y  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// spliceVertexes: function( start, len, vertexCount ) {}
	
	// vertex: function( x, y ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/Shape'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/Shape'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/Shape'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Shape = Core.Class.subclass(
/** @lends Physics2.Shape.prototype */
{
	classname: 'Shape',
	
	/**
	 * @class The <code>Shape</code> class is a base class for constructing collision shape objects.
	 * Most properties are identical to <a href="http://www.box2d.org/manual.html">properties of the b2Body</a> class
	 * of <code>Box2d</code>.<br><br>
	 * <b>Caution!:</b> Do not instantiate this class directly. Use classes derived from <code>Shape</code> for instantiation. This includes:
	 * <div class="ul">
	 * <li>{@link Physics2.BoxShape}</li>
	 * <li>{@link Physics2.CircleShape}</li>
	 * <li>{@link Physics2.PolygonShape}</li>
	 * </div>
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		
		this._isSensor = false;
		this._categoryBits = 0;
		this._maskBits = 0;
		this._groupIndex = 0;
		this._friction = 0;
		this._restitution = 0;
		this._density = 1;
		
		this._createSendGen(this.__objectRegistryId);
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		this._destroySendGen();
		
		Core.ObjectRegistry.unregister(this);
	},
	
	/**
	 * Retrieve whether this <code>Shape</code> is a sensor.
	 * @returns {Boolean} Returns <code>true</code> if this shape is a sensor.
	 * @see Physics2.Shape#setIsSensor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getIsSensor: function()
	{
		return this._isSensor;
	},
	
	/**
	 * Set whether this <code>Shape</code> is a sensor.
	 * @example var shape = new Physics2.PolygonShape();
	 * ...
	 * shape.setIsSensor(true);
	 * @param {Boolean} isSensor Set as <code>true</code> if this shape is a sensor.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Shape#getIsSensor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setIsSensor: function(isSensor)
	{
		this._isSensor = isSensor;
		this._setIsSensorSendGen(isSensor);
		return this;
	},
	
	/**
	 * Retrieve category collision bits for this <code>Shape</code>.
	 * @returns {Number} The current number of category collision bits.
	 * @see Physics2.Shape#setCategoryBits
	 * @status iOS, Android, Flash
	 */
	getCategoryBits: function()
	{
		return this._categoryBits;
	},
	
	/**
	 * Set category collision bits for this <code>Shape</code>.
	 * @example var shape = new Physics2.BoxShape();
	 * ...
	 * shape.setCategoryBits(1);
	 * @param {Number} categoryBits The new number of category collision bits.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Shape#getCategoryBits
	 * @status iOS, Android, Flash
	 */
	setCategoryBits: function(categoryBits)
	{
		this._categoryBits = categoryBits;
		this._setCategoryBitsSendGen(categoryBits);
		return this;
	},
	
	/**
	 * Retrieve mask collision bits for this <code>Shape</code>.
	 * @returns {Number} The current number of mask collision bits.
	 * @see Physics2.Shape#setMaskBits
	 * @status iOS, Android, Flash
	 */
	getMaskBits: function()
	{
		return this._maskBits;
	},
	
	/**
	 * Set mask collision bits for this <code>Shape</code>.
	 * @example var shape = new Physics2.CircleShape();
	 * ...
	 * shape.setMaskBits(1);
	 * @param {Number} maskBits The new number of mask collision bits.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Shape#getMaskBits
	 * @status iOS, Android, Flash
	 */
	setMaskBits: function(maskBits)
	{
		this._maskBits = maskBits;
		this._setMaskBitsSendGen(maskBits);
		return this;
	},
	
	/**
	 * Retrieve the group collision index for this <code>Shape</code>.
	 * @returns {Number} The current group collision index.
	 * @see Physics2.Shape#setGroupIndex
	 * @status iOS, Android, Flash
	 */
	getGroupIndex: function()
	{
		return this._groupIndex;
	},
	
	/**
	 * Set the group collision index for this <code>Shape</code>.
	 * @example var shape = new Physics2.BoxShape();
	 * ...
	 * shape.setGroupIndex(-1);
	 * @param {Number} groupIndex The new group collision index.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Shape#getGroupIndex
	 * @status iOS, Android, Flash
	 */
	setGroupIndex: function(groupIndex)
	{
		this._groupIndex = groupIndex;
		this._setGroupIndexSendGen(groupIndex);
		return this;
	},
	
	/**
	 * Retrieve the amount of friction applied to this <code>Shape</code>.
	 * @returns {Number} The current amount of friction.
	 * @see Physics2.Shape#setFriction
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFriction: function()
	{
		return this._friction;
	},
	
	/**
	 * Set the amount of friction applied to this <code>Shape</code>.
	 * @example var shape = new Physics2.PolygonShape();
	 * ...
	 * shape.setFriction(0.1);
	 * @param {Number} [friction=0] The new amount of friction.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Shape#getFriction
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setFriction: function(friction)
	{
		this._friction = friction;
		this._setFrictionSendGen(friction);
		return this;
	},
	
	/**
	 * Retrieve the restitution for this <code>Shape</code>.
	 * @returns {Number} The current restitution applied.
	 * @see Physics2.Shape#setRestitution
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getRestitution: function()
	{
		return this._restitution;
	},
	
	/**
	 * Set the restitution for this <code>Shape</code>.
	 * @example var shape = new Physics2.BoxShape();
	 * ...
	 * shape.setRestitution(0.8);
	 * @param {Number} [restitution=0] The new restitution applied.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Shape#getRestitution
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setRestitution: function(restitution)
	{
		this._restitution = restitution;
		this._setRestitutionSendGen(restitution);
		return this;
	},
	
	/**
	 * Retrieve the density of this <code>Shape</code>.
	 * @returns {Number} The current density.
	 * @see Physics2.Shape#setDensity
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getDensity: function()
	{
		return this._density;
	},
	
	/**
	 * Set the density of this <code>Shape</code>.
	 * @example var shape = new Physics2.CircleShape();
	 * ...
	 * shape.setDensity(100);
	 * @param {Number} [density=0] The new density.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Shape#getDensity
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setDensity: function(density)
	{
		this._density = density;
		this._setDensitySendGen(density);
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 316
	// Method destroy = 1
	// Method setIsSensor = 2
	// Method setCategoryBits = 3
	// Method setMaskBits = 4
	// Method setGroupIndex = 5
	// Method setFriction = 6
	// Method setRestitution = 7
	// Method setDensity = 8
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Shape._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Shape._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[316] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":316,1," + this.__objectRegistryId );
	},
	
	/** @private */
	_setIsSensorSendGen: function( isSensor )
	{
		Core.Proc.appendToCommandString( ":316,2," + this.__objectRegistryId + "," + ( isSensor ? 1 : 0 )  );
	},
	
	/** @private */
	_setCategoryBitsSendGen: function( categoryBits )
	{
		Core.Proc.appendToCommandString( ":316,3," + this.__objectRegistryId + "," + categoryBits  );
	},
	
	/** @private */
	_setMaskBitsSendGen: function( maskBits )
	{
		Core.Proc.appendToCommandString( ":316,4," + this.__objectRegistryId + "," + maskBits  );
	},
	
	/** @private */
	_setGroupIndexSendGen: function( groupIndex )
	{
		Core.Proc.appendToCommandString( ":316,5," + this.__objectRegistryId + "," + groupIndex  );
	},
	
	/** @private */
	_setFrictionSendGen: function( friction )
	{
		Core.Proc.appendToCommandString( ":316,6," + this.__objectRegistryId + "," + friction  );
	},
	
	/** @private */
	_setRestitutionSendGen: function( restitution )
	{
		Core.Proc.appendToCommandString( ":316,7," + this.__objectRegistryId + "," + restitution  );
	},
	
	/** @private */
	_setDensitySendGen: function( density )
	{
		Core.Proc.appendToCommandString( ":316,8," + this.__objectRegistryId + "," + density  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// destroy: function(  ) {}
	
	// setIsSensor: function( isSensor ) {}
	
	// setCategoryBits: function( categoryBits ) {}
	
	// setMaskBits: function( maskBits ) {}
	
	// setGroupIndex: function( groupIndex ) {}
	
	// setFriction: function( friction ) {}
	
	// setRestitution: function( restitution ) {}
	
	// setDensity: function( density ) {}
	

// {{/Wg Generated Code}}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/World'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/World'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/World'] = exports; var Core = require('NGCore/Client/Core').Core;
var Contact = require('NGCore/Client/Physics2/Contact').Contact;
var Body = require('NGCore/Client/Physics2/Body').Body;

exports.World = Core.Class.subclass(
/** @lends Physics2.World.prototype */
{
	classname: 'World',
	
	/**
	 * @class The <code>World</code> class constructs objects that contain application bodies and support simulation stepping.
	 * Most properties are identical to <a href="http://www.box2d.org/manual.html">properties of the b2Body</a> class
	 * of <code>Box2d</code>.
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._bodies = [];
		this._timeStep = 1/60;
		this._timeScale = 1;
		this._maxSteps = 5;
		this._velocityIterations = 10;
		this._positionIterations = 10;
		this._gravity = new Core.Vector(0, 9.8);
		this._debugDrawFlags = 0;
		this._debugDrawGL2Node = null;
		this._contactEmitter = new Core.MessageEmitter();
		
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash
	 */
	destroy: function()
	{
		this._contactEmitter.destroy();
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
	
	/**
	 * Retrieve the time step for this <code>World</code>. 
	 * @returns {Number} The current time step.
	 * @see Physics2.World#setTimeStep
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTimeStep: function()
	{
		return this._timeStep;
	},
	
	/**
	 * Set the time step for this <code>World</code>. This method controls how often the physics simulation will perform a time step.
	 * @example var body = new Physics2.Body();
	 * ...
	 * World.setTimeStep(1/30);
	 * @param {Number} [timeStep=1/60] The new time step.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.World#getTimeStep
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setTimeStep: function(timeStep)
	{
		this._timeStep = timeStep;
		this._setTimeStepSendGen(timeStep);
		return this;
	},
	
	/**
	 * Retrieve the time scale for this <code>World</code>.
	 * @returns {Number} The current time scale.
	 * @see Physics2.World#setTimeScale
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTimeScale: function()
	{
		return this._timeScale;
	},
	
	/**
	 * Set the time scale for this <code>World</code>.
	 * For each simulation step, the amount of time that is
	 * simulated by the physics engine is:
	 * <pre class=code>timeStep * timeScale</pre> 
	 * <b>Note:</b> You must set this value as greater than zero (<i>x</i> > 0). Setting this to a value less than one but greater than zero
	 * will cause the <code>World</code> physics to run slower. Setting this to a value greater than one causes the <code>World</code>
	 * physics to run faster.
	 * @example var world = this._world.getTimeScale();
	 * ...
	 * this._world.setTimeScale(world);
	 * @param {Number} [timeScale=1] The new time scale.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.World#getTimeScale
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setTimeScale: function(timeScale)
	{
		this._timeScale = timeScale;
		this._setTimeScaleSendGen(timeScale);
		return this;
	},
	
	/**
	 * Retrieve the maximum number of physics steps for this <code>World</code>.
	 * @returns {Number} The current maximum number of physics steps.
	 * @see Physics2.World#setMaxSteps
	 * @status iOS, Android, Flash
	 */
	getMaxSteps: function()
	{
		return this._maxSteps;
	},
	
	/**
	 * Set the maximum number of physics steps for this <code>World</code>. This method controls the maximum number of
	 * physics steps covered in a single step. This prevents the physics engine from getting too far behind and freezing because it fails to
	 * catch up.
	 * @example var world = new Physics2.World();
	 * ...
	 * world.setMaxStep(3);
	 * @param {Number} [maxSteps=5] The new maxmimum number of physics steps.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.World#getMaxSteps
	 * @status iOS, Android, Flash
	 */
	setMaxSteps: function(maxSteps)
	{
		this._maxSteps = maxSteps;
		this._setMaxStepsSendGen(maxSteps);
		return this;
	},
	
	/**
	 * Retrieve the number of velocity iterations for this <code>World</code>.
	 * @returns {Number} The current number of velocity iterations.
	 * @see Physics2.World#setVelocityIterations
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVelocityIterations: function()
	{
		return this._velocityIterations;
	},
	
	/**
	 * Set the number of velocity iterations for this <code>World</code>.
	 * @example var world = new Physics2.World();
	 * ...
	 * world.setVelocityIterations(5);
	 * @param {Number} [velocityIterations=10] The new number of velocity iterations.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.World#getVelocityIterations
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setVelocityIterations: function(velocityIterations)
	{
		this._velocityIterations = velocityIterations;
		this._setVelocityIterationsSendGen(velocityIterations);
		return this;
	},
	
	/**
	 * Retrieve the number of position iterations for this <code>World</code>.
	 * @returns {Number} The number of position iterations.
	 * @see Physics2.World#setPositionIterations
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getPositionIterations: function()
	{
		return this._positionIterations;
	},
	
	/**
	 * Set the number of position iterations for this <code>World</code>.
	 * @example var world = new Physics2.World();
	 * ...
	 * world.setPositionIterations(5);
	 * @param {Number} [positionIterations=10] The new number of position iterations.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.World#getPositionIterations
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setPositionIterations: function(positionIterations)
	{
		this._positionIterations = positionIterations;
		this._setPositionIterationsSendGen(positionIterations);
		return this;
	},
	
	/**
	 * Retrieve the number of bodies in this <code>World</code>.
	 * @returns {Number} The current number of bodies.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBodyCount: function()
	{
		return this._bodies.length;
	},
	
	/**
	 * Retrieve a body at a specific index.
	 * @param {Number} index The specified index.
	 * @returns {Physics2.Body} The body to retrieve.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBody: function(index)
	{
		return this._bodies[index];
	},
	
	/**
	 * Add a body to this <code>World</code>.
	 * @example var p = new Physics2.World(); 
	 * ...
	 * var b = new Physics2.Body();
	 * ...
	 * p.addBody(b);
	 * @param {Physics2.Body} body The body to add.
	 * @see Physics2.World#removeBody
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	addBody: function(body)
	{
		this._bodies.push(body);
		body._didAddToWorld(this);
		
		this._addBodySendGen(Core.ObjectRegistry.objectToId(body));
	},
	
	/**
	 * Remove a body from this <code>World</code>.
	 * @example var p = new Physics2.World(); 
	 * ...
	 * var b = new Physics2.Body();
	 * ...
	 * p.addBody(b);
	 *...
	 * p.removeBody(b);
	 * @param {Physics2.Body} body The body to remove.
	 * @see Physics2.World#addBody
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	removeBody: function(body)
	{
		var index = this._bodies.indexOf(body);
		if(index != -1)
		{
			this._bodies.splice(index, 1);
			body._willRemoveFromWorld(this);
		}
		
		this._removeBodySendGen(Core.ObjectRegistry.objectToId(body));
	},
	
	/**
	 * Retrieve the number of debug draw flags for this <code>World</code>.
	 * @returns {Number} The current number of debug draw flags.
	 * @see Physics2.World#setDebugDrawFlags
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getDebugDrawFlags: function()
	{
		return this._debugDrawFlags;
	},
	
	/**
	 * Set the number of debug draw flags for this <code>World</code>.<br><br>
	 * <b>Note:</b> This value is a bitwise combination of 
	 * <code>DebugDrawFlags</code>.
	 * @example var p = new Physics2.World(); 
	 * ...
	 * p.setDebugDrawFlags(Physics2.World.DebugDrawFlags.Shapes); 
	 * @param {Number} [debugDrawFlags=0] The new number of debug draw flags.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.World#DebugDrawFlags,
	 * @see Physics2.World#getDebugDrawFlags
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setDebugDrawFlags: function(debugDrawFlags)
	{
		if (arguments.length == 0)
			this._debugDrawFlags = 0;
		else
			this._debugDrawFlags = debugDrawFlags;
		
		this._setDebugDrawFlagsSendGen(this._debugDrawFlags);
		
		return this;
	},
	
	/**
	 * Retrieve the debug draw node for this <code>World</code>.
	 * @returns {GL2.Node} The current debug draw node.
	 * @see Physics2.World#setDebugDrawGL2Node
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getDebugDrawGL2Node: function()
	{
		return this._debugDrawGL2Node;
	},
	
	/**
	 * Set the debug draw node for this <code>World</code>. When performing debug drawing,
	 * all of the debug elements will translate as if the elements were children of this node.
	 * This allows debug drawing to accurately maintain camera position, rotation, and scale.
	 * @example var p = new Physics2.World(); 
	 * ...
	 * this._world.setDebugDrawGL2Node(this._root);
	 * @param {GL2.Node} [debugDrawGL2Node=null] The new debug draw node.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.World#getDebugDrawGL2Node
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setDebugDrawGL2Node: function(debugDrawGL2Node)
	{
		this._debugDrawGL2Node = debugDrawGL2Node;
		
		this._setDebugDrawGL2NodeSendGen(Core.ObjectRegistry.objectToId(debugDrawGL2Node));
		
		return this;
	},
	
	/**
	 * Retrieve the gravity applied to this <code>World</code>.
	 * @returns {Core.Vector} The current gravity applied.
	 * @see Physics2.World#setGravity
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getGravity: function()
	{
		return this._gravity;
	},
	
	/**
	 * Set the gravity applied to this <code>World</code>.
	 * @example var p = new Physics2.World(); 
	 * ...
	 * p.setGravity(0, 98);
	 * @param {Core.Vector} [gravity=(0, 9.8)] The new gravity applied.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.World#getGravity
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setGravity: function(gravity)
	{
		var g = this._gravity;
		g.setAll.apply(g, arguments);
		
		this._setGravitySendGen(g.getX(),g.getY());
		
		return this;
	},
	
	/**
	 * Retrieve the contact emitter for this <code>World</code>. This emitter will trigger when contact occurs between two bodies 
	 * and one of the bodies contains contact flags configured for that specific collision.<br><br>
	 * <b>Note:</b> The parameter to the emitter callback is always an instance of <code>Contact</code>.
	 * @returns {Core.MessageEmitter} The current contact emitter.
	 * @see Physics2.Contact
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getContactEmitter: function()
	{
		return this._contactEmitter;
	},
	
	_contactEventRecv: function(cmd)
	{
		var header = {};
		if( ! this._contactEventRecvGen(cmd, header) )
			return;
		
		var contact = new Contact();
		contact._type = header.type;
		contact._shapeA = Core.ObjectRegistry.idToObject(header.shapeA);
		contact._shapeB = Core.ObjectRegistry.idToObject(header.shapeB);
		contact._timestamp = header.timestamp;
		contact._normal = new Core.Vector(header.nx, header.ny);
		contact._locations = [];
		
		var impulses = (contact._type == Body.ContactFlags.Solved);
		
		for(var i=0; i < header.locationCount; ++i)
		{
			var msg = {};
			if( ! this._contactLocationRecvGen(cmd, msg) )
				return;
			
			var location = new Contact.Location();
			location._position = new Core.Point(msg.px, msg.py);
			
			if(impulses)
			{
				var msg = {};
				if( ! this._contactImpulsesRecvGen(cmd, msg) )
					return;

				location._normalImpulse = msg.normalImpulse;
				location._tangentImpulse = msg.tangentImpulse;
			}
			else
			{
				location._normalImpulse = NaN;
				location._tangentImpulse = NaN;
			}
			
			contact._locations.push(location);
		}
		
		this._contactEmitter.emit(contact);
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for debug draw flags.
	 * @namespace
	 */
	DebugDrawFlags:
	{ 
		/** Draw all shapes. */
		Shapes: 1,
		/** Draw all joints. */
		Joints: 2,
		/** Draw all bounding boxes. */
		AABBs: 4,
		/** Draw all pairs that overlap in the broad phase. */
		Pairs: 8,
		/** Draw the center of mass for all bodies. */
		CenterOfMass: 16,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 314
	// Method create = -1
	// Method destroy = 2
	// Method setTimeStep = 3
	// Method setTimeScale = 4
	// Method setMaxSteps = 5
	// Method setVelocityIterations = 6
	// Method setPositionIterations = 7
	// Method setDebugDrawFlags = 8
	// Method setDebugDrawGL2Node = 9
	// Method addBody = 10
	// Method removeBody = 11
	// Method setGravity = 12
	// Method contactEvent = 13
	// Method contactLocation = 14
	// Method contactImpulses = 15
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 13:
					instance._contactEventRecv( cmd );
					break;
				case 14:
					instance._contactLocationRecv( cmd );
					break;
				case 15:
					instance._contactImpulsesRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in World._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in World._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[314] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_contactEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 7 )
		{
			NgLogE("Could not parse due to wrong argument count in World.contactEvent from command: " + cmd );
			return false;
		}
		
		obj[ "type" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "type" ] === undefined )
		{
			NgLogE("Could not parse type in World.contactEvent from command: " + cmd );
			return false;
		}
		
		obj[ "shapeA" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "shapeA" ] === undefined )
		{
			NgLogE("Could not parse shapeA in World.contactEvent from command: " + cmd );
			return false;
		}
		
		obj[ "shapeB" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "shapeB" ] === undefined )
		{
			NgLogE("Could not parse shapeB in World.contactEvent from command: " + cmd );
			return false;
		}
		
		obj[ "timestamp" ] = Core.Proc.parseInt( cmd[ 3 ] );
		if( obj[ "timestamp" ] === undefined )
		{
			NgLogE("Could not parse timestamp in World.contactEvent from command: " + cmd );
			return false;
		}
		
		obj[ "nx" ] = Core.Proc.parseFloat( cmd[ 4 ] );
		if( obj[ "nx" ] === undefined )
		{
			NgLogE("Could not parse nx in World.contactEvent from command: " + cmd );
			return false;
		}
		
		obj[ "ny" ] = Core.Proc.parseFloat( cmd[ 5 ] );
		if( obj[ "ny" ] === undefined )
		{
			NgLogE("Could not parse ny in World.contactEvent from command: " + cmd );
			return false;
		}
		
		obj[ "locationCount" ] = Core.Proc.parseInt( cmd[ 6 ] );
		if( obj[ "locationCount" ] === undefined )
		{
			NgLogE("Could not parse locationCount in World.contactEvent from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 7);
		return true;
	},
	
	/** @private */
	_contactLocationRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 2 )
		{
			NgLogE("Could not parse due to wrong argument count in World.contactLocation from command: " + cmd );
			return false;
		}
		
		obj[ "px" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "px" ] === undefined )
		{
			NgLogE("Could not parse px in World.contactLocation from command: " + cmd );
			return false;
		}
		
		obj[ "py" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "py" ] === undefined )
		{
			NgLogE("Could not parse py in World.contactLocation from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 2);
		return true;
	},
	
	/** @private */
	_contactImpulsesRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 2 )
		{
			NgLogE("Could not parse due to wrong argument count in World.contactImpulses from command: " + cmd );
			return false;
		}
		
		obj[ "normalImpulse" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "normalImpulse" ] === undefined )
		{
			NgLogE("Could not parse normalImpulse in World.contactImpulses from command: " + cmd );
			return false;
		}
		
		obj[ "tangentImpulse" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "tangentImpulse" ] === undefined )
		{
			NgLogE("Could not parse tangentImpulse in World.contactImpulses from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 2);
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":314,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":314,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setTimeStepSendGen: function( timeStep )
	{
		Core.Proc.appendToCommandString( ":314,3," + this.__objectRegistryId + "," + timeStep  );
	},
	
	/** @private */
	_setTimeScaleSendGen: function( timeScale )
	{
		Core.Proc.appendToCommandString( ":314,4," + this.__objectRegistryId + "," + timeScale  );
	},
	
	/** @private */
	_setMaxStepsSendGen: function( maxSteps )
	{
		Core.Proc.appendToCommandString( ":314,5," + this.__objectRegistryId + "," + maxSteps  );
	},
	
	/** @private */
	_setVelocityIterationsSendGen: function( velocityIterations )
	{
		Core.Proc.appendToCommandString( ":314,6," + this.__objectRegistryId + "," + velocityIterations  );
	},
	
	/** @private */
	_setPositionIterationsSendGen: function( positionIterations )
	{
		Core.Proc.appendToCommandString( ":314,7," + this.__objectRegistryId + "," + positionIterations  );
	},
	
	/** @private */
	_setDebugDrawFlagsSendGen: function( debugDrawFlags )
	{
		Core.Proc.appendToCommandString( ":314,8," + this.__objectRegistryId + "," + debugDrawFlags  );
	},
	
	/** @private */
	_setDebugDrawGL2NodeSendGen: function( debugDrawGL2Node )
	{
		Core.Proc.appendToCommandString( ":314,9," + this.__objectRegistryId + "," + debugDrawGL2Node  );
	},
	
	/** @private */
	_addBodySendGen: function( body )
	{
		Core.Proc.appendToCommandString( ":314,10," + this.__objectRegistryId + "," + body  );
	},
	
	/** @private */
	_removeBodySendGen: function( body )
	{
		Core.Proc.appendToCommandString( ":314,11," + this.__objectRegistryId + "," + body  );
	},
	
	/** @private */
	_setGravitySendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":314,12," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setTimeStep: function( timeStep ) {}
	
	// setTimeScale: function( timeScale ) {}
	
	// setMaxSteps: function( maxSteps ) {}
	
	// setVelocityIterations: function( velocityIterations ) {}
	
	// setPositionIterations: function( positionIterations ) {}
	
	// setDebugDrawFlags: function( debugDrawFlags ) {}
	
	// setDebugDrawGL2Node: function( debugDrawGL2Node ) {}
	
	// addBody: function( body ) {}
	
	// removeBody: function( body ) {}
	
	// setGravity: function( x, y ) {}
	
	// _contactEventRecv: function( cmd ) {}
	// _contactLocationRecv: function( cmd ) {}
	// _contactImpulsesRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/Joint'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/Joint'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/Joint'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Joint = Core.Class.subclass(
/** @lends Physics2.Joint.prototype */
{
	classname: 'Joint',
	
	/**
	 * @class The <code>Joint</code> class is a base class for constructing objects that connect two application bodies (see <code>{@link Physics2.Body}</code>).
	 * Most properties are identical to <a href="http://www.box2d.org/manual.html">properties of the b2Joint</a> class
	 * of <code>Box2d</code>.<br><br>
	 * <b>Caution!:</b> Do not instantiate this class directly. Use classes derived from <code>Joint</code> for instantiation. This includes:
	 * <div class="ul">
	 * <li>{@link Physics2.DistanceJoint}</li>
	 * <li>{@link Physics2.MouseJoint}</li>
	 * <li>{@link Physics2.PrismaticJoint}</li>
	 * <li>{@link Physics2.RevoluteJoint}</li>
	 * <li>{@link Physics2.WeldJoint}</li>
	 * </div>
	 * @constructs The default constructor. 	
	 * @augments Core.Class
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._bodyA = null;
		this._bodyB = null;
		this._collideConnected = false;
		
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
	
	/**
	 * Retrieve the first connected body for this <code>Joint</code>.
	 * @returns {Physics2.Body} The current first connected body.
	 * @see Physics2.Joint#setBodyA
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBodyA: function()
	{
		return this._bodyA;
	},
	
	/**
	 * Set the first connected body for this <code>Joint</code>.
	 * @example var b1 = makeCircle([w*1/3+32*-1, h*1/8], 16);
	 * ...
	 * b1.setContactFlags(Physics2.Body.ContactFlags.All);
	 * ...
	 * var joint = new Physics2.DistanceJoint();
	 * joint.setBodyA(b1);
	 * @param {Physics2.Body} bodyA The new first connected body.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Joint#getBodyA
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setBodyA: function(bodyA)
	{
		//Let prev body know it was detached from this joint
		if(this._bodyA!=null)
			this._bodyA._willRemoveFromJoint(this);

		//Assign new body
		this._bodyA = bodyA;

		//Let new body know it was attached to this joint
		if(bodyA!=null)
			bodyA._didAddToJoint(this);

		this._setBodyASendGen( (bodyA == null) ? -1 : Core.ObjectRegistry.objectToId(bodyA) );
		return this;
	},
	
	/**
	 * Retrieve the second connected body for this <code>Joint</code>.
	 * @returns {Physics2.Body} The current second connected body.
	 * @see Physics2.Joint#setBodyB
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBodyB: function()
	{
		return this._bodyB;
	},
	
	/**
	 * Set the second connected body for this <code>Joint</code>.
	 * @example var b2 = makeCircle([w*1/3+32*0, h*1/8], 16);
	 * ...
	 * b2.setContactFlags(Physics2.Body.ContactFlags.All);
	 * ...
	 * var joint = new Physics2.DistanceJoint();
	 * joint.setBodyB(b2);
	 * @param {Physics2.Body} bodyB The new second connected body.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Joint#getBodyB
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setBodyB: function(bodyB)
	{
		//Let prev body know it was detached from this joint
		if(this._bodyB!=null)
			this._bodyB._willRemoveFromJoint(this);

		//Assign new body
		this._bodyB = bodyB;

		//Let new body know it was attached to this joint
		if(bodyB!=null)
			bodyB._didAddToJoint(this);

		this._setBodyBSendGen( (bodyB == null) ? -1 : Core.ObjectRegistry.objectToId(bodyB) );
		return this;
	},
	
	/**
	 * Retrieve whether two connected bodies collide with each other.
	 * @returns {Boolean} Returns <code>true</code> if connected bodies collide. Returns <code>false</code> in all other cases.
	 * @see Physics2.Joint#setCollideConnected
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getCollideConnected: function()
	{
		return this._collideConnected;
	},
	
	/**
	 * Set whether two connected bodies collide with each other.
	 * @param {Boolean} [collideConnected=false] Set as <code>true</code> if connected bodies collide.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.Joint#getCollideConnected
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setCollideConnected: function(collideConnected)
	{
		this._collideConnected = collideConnected;
		this._setCollideConnectedSendGen(collideConnected);
		return this;
	},
	
	_removeBody: function(body)
	{
		if(body==bodyA)
			this.setBodyA(null);
		if(body==bodyB)
			this.setBodyB(null);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 320
	// Method destroy = 1
	// Method setBodyA = 2
	// Method setBodyB = 3
	// Method setCollideConnected = 4
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Joint._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Joint._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[320] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":320,1," + this.__objectRegistryId );
	},
	
	/** @private */
	_setBodyASendGen: function( bodyA )
	{
		Core.Proc.appendToCommandString( ":320,2," + this.__objectRegistryId + "," + bodyA  );
	},
	
	/** @private */
	_setBodyBSendGen: function( bodyB )
	{
		Core.Proc.appendToCommandString( ":320,3," + this.__objectRegistryId + "," + bodyB  );
	},
	
	/** @private */
	_setCollideConnectedSendGen: function( collideConnected )
	{
		Core.Proc.appendToCommandString( ":320,4," + this.__objectRegistryId + "," + ( collideConnected ? 1 : 0 )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// destroy: function(  ) {}
	
	// setBodyA: function( bodyA ) {}
	
	// setBodyB: function( bodyB ) {}
	
	// setCollideConnected: function( collideConnected ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/DistanceJoint'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/DistanceJoint'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/DistanceJoint'] = exports; var Joint = require('NGCore/Client/Physics2/Joint').Joint;
var Core = require('NGCore/Client/Core').Core;

exports.DistanceJoint = Joint.subclass(
/** @lends Physics2.DistanceJoint.prototype */
{
	classname: 'DistanceJoint',
	
	/**
	 * @class The <code>DistanceJoint</code> class constructs objects that restrict the distance between two bodies
	 * but does not constrain their rotation (see <code>{@link Physics2.Body}</code>).
	 * @constructs The default constructor. 
	 * @augments Physics2.Joint
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._localAnchorA = new Core.Point();
		this._localAnchorB = new Core.Point();
		this._length = 0;
		this._frequency = 0;
		this._dampingRatio = 0;
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Retrieve the local anchor point for the first connected body.
	 * @returns {Core.Point} The current local anchor point for the first body.
	 * @see Physics2.DistanceJoint#setLocalAnchorA
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLocalAnchorA: function()
	{
		return this._localAnchorA;
	},
	
	/**
	 * Set the local anchor point for the first connected body.
	 * @example var joint = new Physics2.DistanceJoint();
	 * joint.setLocalAnchorA(0, 16);
	 * @param {Core.Point} [localAnchorA=(0, 0)] The new local anchor point for the first body.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.DistanceJoint#getLocalAnchorA
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLocalAnchorA: function(localAnchorA)
	{
		var l = this._localAnchorA;
		l.setAll.apply(l, arguments);
		this._setLocalAnchorASendGen(l.getX(),l.getY());
		return this;
	},
	
	/**
	 * Retrieve the local anchor point for the second connected body.
	 * @returns {Core.Point} The current local anchor point for the second body.
	 * @see Physics2.DistanceJoint#setLocalAnchorB
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLocalAnchorB: function()
	{
		return this._localAnchorB;
	},
	
	/**
	 * Set the local anchor point for the second connected body.
	 * @example var joint = new Physics2.DistanceJoint();
	 * joint.setLocalAnchorB(0, -16);
	 * @param {Core.Point} [localAnchorB=(0, 0)] The new local anchor point for the second body.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.DistanceJoint#getLocalAnchorB
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLocalAnchorB: function(localAnchorB)
	{
		var l = this._localAnchorB;
		l.setAll.apply(l, arguments);
		this._setLocalAnchorBSendGen(l.getX(),l.getY());
		return this;
	},
	
	/**
	 * Retrieve the joint length for this <code>DistanceJoint</code>.
	 * @returns {Number} The current joint length.
	 * @see Physics2.DistanceJoint#setLength
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLength: function()
	{
		return this._length;
	},
	
	/**
	 * Set the joint length for this <code>DistanceJoint</code>.
	 * @example var joint = new Physics2.DistanceJoint();
	 * joint.setLength(48);
	 * @param {Number} [length=0] The new joint length.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.DistanceJoint#getLength
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLength: function(length)
	{
		this._length = length;
		this._setLengthSendGen(length);
		return this;
	},
	
	/**
	 * Retrieve the damping frequency of this <code>DistanceJoint</code>.
	 * @returns {Number} The current damping frequency.
	 * @see Physics2.DistanceJoint#setFrequency
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrequency: function()
	{
		return this._frequency;
	},
	
	/**
	 * Set the damping frequency for this <code>DistanceJoint</code>.
	 * @example var joint = new Physics2.DistanceJoint();
	 * joint.setFrequency(1);
	 * @param {Number} [frequency=0] The new damping frequency.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.DistanceJoint#getFrequency
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setFrequency: function(frequency)
	{
		this._frequency = frequency;
		this._setFrequencySendGen(frequency);
		return this;
	},
	
	/**
	 * Retrieve the damping ratio of this <code>DistanceJoint</code>.
	 * @returns {Number} The current damping ratio.
	 * @see Physics2.DistanceJoint#setDampingRatio
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getDampingRatio: function()
	{
		return this._dampingRatio;
	},
	
	/**
	 * Set the damping ratio for this <code>DistanceJoint</code>.
	 * @example var joint = new Physics2.DistanceJoint();
	 * joint.setDampingRatio(10);
	 * @param {Number} [dampingRatio=0] The new damping ratio.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.DistanceJoint#setDampingRatio
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setDampingRatio: function(dampingRatio)
	{
		this._dampingRatio = dampingRatio;
		this._setDampingRatioSendGen(dampingRatio);
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 321
	// Method create = -1
	// Method destroy = 2
	// Method setLocalAnchorA = 3
	// Method setLocalAnchorB = 4
	// Method setLength = 5
	// Method setFrequency = 6
	// Method setDampingRatio = 7
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in DistanceJoint._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in DistanceJoint._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[321] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":321,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":321,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setLocalAnchorASendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":321,3," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setLocalAnchorBSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":321,4," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setLengthSendGen: function( length )
	{
		Core.Proc.appendToCommandString( ":321,5," + this.__objectRegistryId + "," + length  );
	},
	
	/** @private */
	_setFrequencySendGen: function( frequency )
	{
		Core.Proc.appendToCommandString( ":321,6," + this.__objectRegistryId + "," + frequency  );
	},
	
	/** @private */
	_setDampingRatioSendGen: function( dampingRatio )
	{
		Core.Proc.appendToCommandString( ":321,7," + this.__objectRegistryId + "," + dampingRatio  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setLocalAnchorA: function( x, y ) {}
	
	// setLocalAnchorB: function( x, y ) {}
	
	// setLength: function( length ) {}
	
	// setFrequency: function( frequency ) {}
	
	// setDampingRatio: function( dampingRatio ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/MouseJoint'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/MouseJoint'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/MouseJoint'] = exports; var Joint = require('NGCore/Client/Physics2/Joint').Joint;
var Core = require('NGCore/Client/Core').Core;

exports.MouseJoint = Joint.subclass(
/** @lends Physics2.MouseJoint.prototype */
{
	classname: 'MouseJoint',
	
	/**
	 * @class The <code>MouseJoint</code> class constructs objects that apply a force for moving an application body to a specific point (see <code>{@link Physics2.Body}</code>).
	 * @constructs The default constructor. 
	 * @augments Physics2.Joint
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._target = new Core.Point();
		this._maxForce = 0;
		this._frequency = 0;
		this._dampingRatio = 0;
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Retrieve the target location that applies to this <code>MouseJoint</code>.
	 * @returns {Core.Point} The current target location.
	 * @see Physics2.MouseJoint#setTarget
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTarget: function()
	{
		return this._;
	},
	
	/**
	 * Set the target location that applies to this <code>MouseJoint</code>.
	 * @example var circle = makeCircle([w/2, h*6/8], 16);
	 * ...
	 * joint.setTarget(c.getPosition());
	 * @param {Core.Point} [target=(0, 0)] The new target location.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.MouseJoint#getTarget
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setTarget: function(target)
	{
		var t = this._target;
		t.setAll(arguments);
		this._setTargetSendGen(t.getX(),t.getY());
		return this;
	},
	
	/**
	 * Retrieve the maximum force applied by this <code>MouseJoint</code>.
	 * @returns {Number} The current maximum force applied.
	 * @see Physics2.MouseJoint#setMaxForce
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMaxForce: function()
	{
		return this._maxForce;
	},
	
	/**
	 * Set the maximum force applied by this <code>MouseJoint</code>.
	 * @example var joint = new Physics2.MouseJoint();
	 * joint.setMaxForce(20);
	 * @param {Number} [maxForce=0] The new maximum force applied.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.MouseJoint#getMaxForce
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setMaxForce: function(maxForce)
	{
		this._maxForce = maxForce;
		this._setMaxForceSendGen(maxForce);
		return this;
	},
	
	/**
	 * Retrieve the damping frequency that applies to this <code>MouseJoint</code>.
	 * @returns {Number} The current damping frequency.
	 * @see Physics2.MouseJoint#setFrequency
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrequency: function()
	{
		return this._frequency;
	},
	
	/**
	 * Set the damping frequency that applies to this <code>MouseJoint</code>.
	 * @param {Number} [frequency=0] The new damping frequency.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.MouseJoint#getFrequency
	 */
	setFrequency: function(frequency)
	{
		this._frequency = frequency;
		this._setFrequencySendGen(frequency);
		return this;
	},
	
	/**
	 * Retrieve the damping ratio that applies to this <code>MouseJoint</code>.
	 * @returns {Number} The current damping ratio.
	 * @see Physics2.MouseJoint#setDampingRatio
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getDampingRatio: function()
	{
		return this._dampingRatio;
	},
	
	/**
	 * Set the damping ratio that applies to this <code>MouseJoint</code>.
	 * @param {Number} [dampingRatio=0] The new damping ratio.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.MouseJoint#getDampingRatio
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setDampingRatio: function(dampingRatio)
	{
		this._dampingRatio = dampingRatio;
		this._setDampingRatioSendGen(dampingRatio);
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 322
	// Method create = -1
	// Method destroy = 2
	// Method setTarget = 3
	// Method setMaxForce = 4
	// Method setFrequency = 5
	// Method setDampingRatio = 6
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in MouseJoint._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in MouseJoint._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[322] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":322,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":322,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setTargetSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":322,3," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setMaxForceSendGen: function( maxForce )
	{
		Core.Proc.appendToCommandString( ":322,4," + this.__objectRegistryId + "," + maxForce  );
	},
	
	/** @private */
	_setFrequencySendGen: function( frequency )
	{
		Core.Proc.appendToCommandString( ":322,5," + this.__objectRegistryId + "," + frequency  );
	},
	
	/** @private */
	_setDampingRatioSendGen: function( dampingRatio )
	{
		Core.Proc.appendToCommandString( ":322,6," + this.__objectRegistryId + "," + dampingRatio  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setTarget: function( x, y ) {}
	
	// setMaxForce: function( maxForce ) {}
	
	// setFrequency: function( frequency ) {}
	
	// setDampingRatio: function( dampingRatio ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/PrismaticJoint'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/PrismaticJoint'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/PrismaticJoint'] = exports; var Joint = require('NGCore/Client/Physics2/Joint').Joint;
var Core = require('NGCore/Client/Core').Core;

exports.PrismaticJoint = Joint.subclass(
/** @lends Physics2.PrismaticJoint.prototype */
{
	classname: 'PrismaticJoint',
	
	/**
	 * @class The <code>PrismaticJoint</code> class constructs objects that confine movement of two application bodies 
	 * along a specific axis (see <code>{@link Physics2.Body}</code>). This concept is similar to how a piston functions. 
	 * Movement is confined to bodies moving either towards or away from each other.
	 * @constructs The default constructor. 
	 * @augments Physics2.Joint
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._localAnchorA = new Core.Point();
		this._localAnchorB = new Core.Point();
		this._localAxis = new Core.Vector();
		this._referenceRotation = 0;
		this._enableLimit = false;
		this._lowerTranslation = 0;
		this._upperTranslation = 0;
		this._enableMotor = false;
		this._motorSpeed = 0;
		this._maxMotorForce = 0;
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Retrieve the local anchor point for the first connected body.
	 * @returns {Core.Point} The current local anchor point for the first connected body.
	 * @see Physics2.PrismaticJoint#setLocalAnchorA
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLocalAnchorA: function()
	{
		return this._localAnchorA;
	},
	
	/**
	 * Set the local anchor point for the first connected body.
	 * @example var joint = new Physics2.PrismaticJoint();
	 * ...
	 * joint.setLocalAnchorA(25, 0);
	 * @param {Core.Point} [localAnchorA=(0,0)] The new local anchor point for the first connected body.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.PrismaticJoint#getLocalAnchorA
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLocalAnchorA: function(localAnchorA)
	{
		var l = this._localAnchorA;
		l.setAll.apply(l, arguments);
		this._setLocalAnchorASendGen(l.getX(),l.getY());
		return this;
	},
	
	/**
	 * Retrieve the local anchor point for the second connected body.
	 * @returns {Core.Point} The current local anchor point for the second connected body.
	 * @see Physics2.PrismaticJoint#setLocalAnchorB
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLocalAnchorB: function()
	{
		return this._localAnchorB;
	},
	
	/**
	 * Set the local anchor point for the second connected body.
	 * @example var joint = new Physics2.PrismaticJoint();
	 * ...
	 * joint.setLocalAnchorB(-25, 0);
	 * @param {Core.Point} [localAnchorB=(0,0)] The new local anchor point for the second connected body.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.PrismaticJoint#getLocalAnchorB
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLocalAnchorB: function(localAnchorB)
	{
		var l = this._localAnchorB;
		l.setAll.apply(l, arguments);
		this._setLocalAnchorBSendGen(l.getX(),l.getY());
		return this;
	},
	
	/**
	 * Retrieve the local axis of movement for this <code>PrismaticJoint</code>.
	 * @returns {Core.Vector} The current local axis of movement.
	 * @see Physics2.PrismaticJoint#setLocalAxis
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLocalAxis: function()
	{
		return this._localAxis;
	},
	
	/**
	 * Set the local axis of movement for this <code>PrismaticJoint</code>.
	 * @example var joint = new Physics2.PrismaticJoint();
	 * ...
	 * joint.setLocalAxis(0, -1);
	 * @param {Core.Vector} [localAxis=(0,0)] The new local axis of movement.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.PrismaticJoint#getLocalAxis
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLocalAxis: function(localAxis)
	{
		var a = this._localAxis;
		a.setAll(arguments);
		this._setLocalAxisSendGen(a.getX(),a.getY());
		return this;
	},
	
	/**
	 * Retrieve the reference rotation for this <code>PrismaticJoint</code>.
	 * @returns {Number} The current reference rotation.
	 * @see Physics2.PrismaticJoint#setReferenceRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getReferenceRotation: function()
	{
		return this._referenceRotation;
	},
	
	/**
	 * Set the reference rotation for this <code>PrismaticJoint</code>.
	 * @example var joint = new Physics2.PrismaticJoint();
	 * ...
	 * joint.setReferenceRotation(-90);
	 * @param {Number} [refereceRotation=0] The new reference rotation.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.PrismaticJoint#getReferenceRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setReferenceRotation: function(referenceRotation)
	{
		this._referenceRotation = referenceRotation;
		this._setReferenceRotationSendGen(referenceRotation);
		return this;
	},
	
	/**
	 * Retrieve whether the range limiter is enabled for this <code>PrismaticJoint</code>.
	 * @returns {Boolean} Returns <code>true</code> if range limiter is enabled.
	 * @see Physics2.PrismaticJoint#setEnableLimit
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getEnableLimit: function()
	{
		return this._enableLimit;
	},
	
	/**
	 * Set whether the range limiter is enabled for this <code>PrismaticJoint</code>.
	 * @example var joint = new Physics2.PrismaticJoint();
	 * ...
	 * joint.setEnableLimit(true);
	 * @param {Boolean} [enableLimit=false] Set as <code>true</code> to enable the range limiter.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.PrismaticJoint#getEnableLimit
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setEnableLimit: function(enableLimit)
	{
		this._enableLimit = enableLimit;
		this._setEnableLimitSendGen(enableLimit);
		return this;
	},
	
	/**
	 * Retrieve the lower range limit for this <code>PrismaticJoint</code>.
	 * @returns {Number} The current lower range limit.
	 * @see Physics2.PrismaticJoint#setLowerTranslation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLowerTranslation: function()
	{
		return this._lowerTranslation;
	},
	
	/**
	 * Set the lower range limit for this <code>PrismaticJoint</code>.
	 * @example var joint = new Physics2.PrismaticJoint();
	 * ...
	 * joint.setLowerTranslation(0);
	 * @param {Number} [lowerTranslation=0] The new lower range limit.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.PrismaticJoint#getLowerTranslation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLowerTranslation: function(lowerTranslation)
	{
		this._lowerTranslation = lowerTranslation;
		this._setLowerTranslationSendGen(lowerTranslation);
		return this;
	},
	
	/**
	 * Retrieve the upper range limit for this <code>PrismaticJoint</code>.
	 * @returns {Number} The current upper range limit.
	 * @see Physics2.PrismaticJoint#setUpperTranslation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getUpperTranslation: function()
	{
		return this._upperTranslation;
	},
	
	/**
	 * Set the upper range limit for this <code>PrismaticJoint</code>.
	 * @example var joint = new Physics2.PrismaticJoint();
	 * ...
	 * joint.setUpperTranslation(32);
	 * @param {Number} [upperTranslation=0] The new upper range limit.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.PrismaticJoint#getUpperTranslation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setUpperTranslation: function(upperTranslation)
	{
		this._upperTranslation = upperTranslation;
		this._setUpperTranslationSendGen(upperTranslation);
		return this;
	},
	
	/**
	 * Retrieve whether the motor is enabled for this <code>PrismaticJoint</code>.
	 * @returns {Boolean} Returns <code>true</code> if the motor is eanbled.
	 * @see Physics2.PrismaticJoint#setEnableMotor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getEnableMotor: function()
	{
		return this._enableMotor;
	},
	
	/**
	 * Set whether the motor is enabled for this <code>PrismaticJoint</code>.
	 * @example var joint = new Physics2.PrismaticJoint();
	 * ...
	 * joint.setEnableMotor(true);
	 * @param {Boolean} [enableMotor=false] Set as <code>true</code> if the motor is eanbled.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.PrismaticJoint#getEnableMotor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setEnableMotor: function(enableMotor)
	{
		this._enableMotor = enableMotor;
		this._setEnableMotorSendGen(enableMotor);
		return this;
	},
	
	/**
	 * Retrieve the motor speed for this <code>PrismaticJoint</code>.
	 * @returns {Number} The current motor speed.
	 * @see Physics2.PrismaticJoint#setMotorSpeed
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested 
	 */
	getMotorSpeed: function()
	{
		return this._motorSpeed;
	},
	
	/**
	 * Set the motor speed for this <code>PrismaticJoint</code>.
	 * @example var joint = new Physics2.PrismaticJoint();
	 * ...
	 * joint.setMotorSpeed(1);
	 * @param {Number} [motorSpeed=0] The new motor speed.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.PrismaticJoint#getMotorSpeed
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setMotorSpeed: function(motorSpeed)
	{
		this._motorSpeed = motorSpeed;
		this._setMotorSpeedSendGen(motorSpeed);
		return this;
	},
	
	/**
	 * Retrieve the max motor force applied by this <code>PrismaticJoint</code>.
	 * @returns {Number} The current max motor force.
	 * @see Physics2.PrismaticJoint#setMaxMotorForce
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMaxMotorForce: function()
	{
		return this._maxMotorForce;
	},
	
	/**
	 * Set the max motor force applied by this <code>PrismaticJoint</code>.
	 * @example var joint = new Physics2.PrismaticJoint();
	 * ...
	 * joint.setMaxMotorForce(1);
	 * @param {Number} [maxMotorForce=0] The new max motor force.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.PrismaticJoint#getMaxMotorForce
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setMaxMotorForce: function(maxMotorForce)
	{
		this._maxMotorForce = maxMotorForce;
		this._setMaxMotorForceSendGen(maxMotorForce);
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 323
	// Method create = -1
	// Method destroy = 2
	// Method setLocalAnchorA = 3
	// Method setLocalAnchorB = 4
	// Method setLocalAxis = 5
	// Method setReferenceRotation = 6
	// Method setEnableLimit = 7
	// Method setLowerTranslation = 8
	// Method setUpperTranslation = 9
	// Method setEnableMotor = 10
	// Method setMotorSpeed = 11
	// Method setMaxMotorForce = 12
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in PrismaticJoint._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in PrismaticJoint._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[323] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":323,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":323,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setLocalAnchorASendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":323,3," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setLocalAnchorBSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":323,4," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setLocalAxisSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":323,5," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setReferenceRotationSendGen: function( referenceRotation )
	{
		Core.Proc.appendToCommandString( ":323,6," + this.__objectRegistryId + "," + referenceRotation  );
	},
	
	/** @private */
	_setEnableLimitSendGen: function( enableLimit )
	{
		Core.Proc.appendToCommandString( ":323,7," + this.__objectRegistryId + "," + ( enableLimit ? 1 : 0 )  );
	},
	
	/** @private */
	_setLowerTranslationSendGen: function( lowerTranslation )
	{
		Core.Proc.appendToCommandString( ":323,8," + this.__objectRegistryId + "," + lowerTranslation  );
	},
	
	/** @private */
	_setUpperTranslationSendGen: function( upperTranslation )
	{
		Core.Proc.appendToCommandString( ":323,9," + this.__objectRegistryId + "," + upperTranslation  );
	},
	
	/** @private */
	_setEnableMotorSendGen: function( enableMotor )
	{
		Core.Proc.appendToCommandString( ":323,10," + this.__objectRegistryId + "," + ( enableMotor ? 1 : 0 )  );
	},
	
	/** @private */
	_setMotorSpeedSendGen: function( motorSpeed )
	{
		Core.Proc.appendToCommandString( ":323,11," + this.__objectRegistryId + "," + motorSpeed  );
	},
	
	/** @private */
	_setMaxMotorForceSendGen: function( maxMotorForce )
	{
		Core.Proc.appendToCommandString( ":323,12," + this.__objectRegistryId + "," + maxMotorForce  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setLocalAnchorA: function( x, y ) {}
	
	// setLocalAnchorB: function( x, y ) {}
	
	// setLocalAxis: function( x, y ) {}
	
	// setReferenceRotation: function( referenceRotation ) {}
	
	// setEnableLimit: function( enableLimit ) {}
	
	// setLowerTranslation: function( lowerTranslation ) {}
	
	// setUpperTranslation: function( upperTranslation ) {}
	
	// setEnableMotor: function( enableMotor ) {}
	
	// setMotorSpeed: function( motorSpeed ) {}
	
	// setMaxMotorForce: function( maxMotorForce ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/RevoluteJoint'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/RevoluteJoint'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/RevoluteJoint'] = exports; var Joint = require('NGCore/Client/Physics2/Joint').Joint;
var Core = require('NGCore/Client/Core').Core;

exports.RevoluteJoint = Joint.subclass(
/** @lends Physics2.RevoluteJoint.prototype */
{
	classname: 'RevoluteJoint',
	
	/**
	 * @class The <code>RevoluteJoint</code> class constructs objects that confine movement of two application bodies, 
	 * rotating the bodies around a specified point (see {@link Physics2.Body}. This concept is similar to how a hinge functions.
	 * @constructs The default constructor. 
	 * @see Physics2.Body
	 * @augments Physics2.Joint
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._localAnchorA = new Core.Point();
		this._localAnchorB = new Core.Point();
		this._referenceRotation = 0;
		this._enableLimit = false;
		this._lowerRotation = 0;
		this._upperRotation = 0;
		this._enableMotor = false;
		this._motorSpeed = 0;
		this._maxMotorTorque = 0;
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Retrieve the local anchor point for the first connected body.
	 * @returns {Core.Point} The current local anchor point for the first connected body.
	 * @see Physics2.RevoluteJoint#setLocalAnchorA
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLocalAnchorA: function()
	{
		return this._localAnchorA;
	},
	
	/**
	 * Set the local anchor point for the first connected body.
	 * @example var joint = new Physics2.RevoluteJoint();
	 * ...
	 * joint.setLocalAnchorA(25, 0);
	 * @param {Core.Point} [localAnchorA=(0,0)] The new local anchor point.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.RevoluteJoint#getLocalAnchorA
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLocalAnchorA: function(localAnchorA)
	{
		var l = this._localAnchorA;
		l.setAll.apply(l, arguments);
		this._setLocalAnchorASendGen(l.getX(),l.getY());
		return this;
	},
	
	/**
	 * Retrieve the local anchor point for the second connected body.
	 * @returns {Core.Point} The current local anchor point for the second connected body.
	 * @see Physics2.RevoluteJoint#setLocalAnchorB
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLocalAnchorB: function()
	{
		return this._localAnchorB;
	},
	
	/**
	 * Set the local anchor point for the second connected body.
	 * @example var joint = new Physics2.RevoluteJoint();
	 * ...
	 * joint.setLocalAnchorB(-25, 0);
	 * @param {Core.Point} [localAnchorB=(0,0)] The new local anchor point.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.RevoluteJoint#getLocalAnchorB
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLocalAnchorB: function(localAnchorB)
	{
		var l = this._localAnchorB;
		l.setAll.apply(l, arguments);
		this._setLocalAnchorBSendGen(l.getX(),l.getY());
		return this;
	},
	
	/**
	 * Retrieve the reference rotation for this <code>RevoluteJoint</code>.
	 * @returns {Number} The current reference rotation.
	 * @see Physics2.RevoluteJoint#setReferenceRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getReferenceRotation: function()
	{
		return this._referenceRotation;
	},
	
	/**
	 * Set the reference rotation for this <code>RevoluteJoint</code>.
	 * @example var joint = new Physics2.RevoluteJoint();
	 * ...
	 * joint.setReferenceRotation(-90);
	 * @param {Number} [refereceRotation=0] The new reference rotation.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.RevoluteJoint#getReferenceRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setReferenceRotation: function(referenceRotation)
	{
		this._referenceRotation = referenceRotation;
		this._setReferenceRotationSendGen(referenceRotation);
		return this;
	},
	
	/**
	 * Retrieve whether the range limiter is enabled  for this <code>RevoluteJoint</code>.
	 * @returns {Boolean} Returns <cod>true</code> if the range limiter is enabled.
	 * @see Physics2.RevoluteJoint#setEnableLimit
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getEnableLimit: function()
	{
		return this._enableLimit;
	},
	
	/**
	 * Set whether the range limiter is enabled for this <code>RevoluteJoint</code>.
	 * @example var joint = new Physics2.RevoluteJoint();
	 * ...
	 * joint.setEnableLimit(true);
	 * @param {Boolean} [enableLimit=false] Set as <code>true</code> if the range limiter is enabled.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.RevoluteJoint#getEnableLimit
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setEnableLimit: function(enableLimit)
	{
		this._enableLimit = enableLimit;
		this._setEnableLimitSendGen(enableLimit);
		return this;
	},
	
	/**
	 * Retrieve the lower range limit for this <code>RevoluteJoint</code>.
	 * @returns {Number} The current lower range limit.
	 * @see Physics2.RevoluteJoint#setLowerRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLowerRotation: function()
	{
		return this._lowerRotation;
	},
	
	/**
	 * Set the lower range limit for this <code>RevoluteJoint</code>.
	 * @example var joint = new Physics2.RevoluteJoint();
	 * ...
	 * joint.setLowerRotation(-30);
	 * @param {Number} [lowerRotation=0] The new lower range limit.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.RevoluteJoint#getLowerRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLowerRotation: function(lowerRotation)
	{
		this._lowerRotation = lowerRotation;
		this._setLowerRotationSendGen(lowerRotation);
		return this;
	},
	
	/**
	 * Retrieve the upper range limit for this <code>RevoluteJoint</code>.
	 * @returns {Number} The current upper range limit.
	 * @see Physics2.RevoluteJoint#setUpperRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getUpperRotation: function()
	{
		return this._upperRotation;
	},
	
	/**
	 * Set the upper range limit for this <code>RevoluteJoint</code>.
	 * @example var joint = new Physics2.RevoluteJoint();
	 * ...
	 * joint.setUpperRotation(30);
	 * @param {Number} [upperRotation=0] The new upper range limit.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.RevoluteJoint#getUpperRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setUpperRotation: function(upperRotation)
	{
		this._upperRotation = upperRotation;
		this._setUpperRotationSendGen(upperRotation);
		return this;
	},
	
	/**
	 * Retrieve whether the motor is enabled for this <code>RevoluteJoint</code>.
	 * @returns {Boolean} Returns <code>true</code> if the motor is enabled.
	 * @see Physics2.RevoluteJoint#setEnableMotor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getEnableMotor: function()
	{
		return this._enableMotor;
	},
	
	/**
	 * Set whether the motor is enabled for this <code>RevoluteJoint</code>.
	 * @example var joint = new Physics2.RevoluteJoint();
	 * ...
	 * joint.setEnableMotor(true);
	 * @param {Boolean} [enableMotor=false] Set as <code>true</code> if the motor is enabled.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.RevoluteJoint#getEnableMotor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setEnableMotor: function(enableMotor)
	{
		this._enableMotor = enableMotor;
		this._setEnableMotorSendGen(enableMotor);
		return this;
	},
	
	/**
	 * Retrieve the motor speed applied by this <code>RevoluteJoint</code>.
	 * @returns {Number} The current motor speed.
	 * @see Physics2.RevoluteJoint#setMotorSpeed
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMotorSpeed: function()
	{
		return this._motorSpeed;
	},
	
	/**
	 * Set the motor speed applied by this <code>RevoluteJoint</code>.
	 * @example var joint = new Physics2.PrismaticJoint();
	 * ...
	 * joint.setMotorSpeed(1);
	 * @param {Number} [motorSpeed=0] The new motor speed.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.RevoluteJoint#getMotorSpeed
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setMotorSpeed: function(motorSpeed)
	{
		this._motorSpeed = motorSpeed;
		this._setMotorSpeedSendGen(motorSpeed);
		return this;
	},
	
	/**
	 * Retrieve the max motor torque applied by this <code>RevoluteJoint</code>.
	 * @returns {Number} The current max motor torque.
	 * @see Physics2.RevoluteJoint#setMaxMotorTorque
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMaxMotorTorque: function()
	{
		return this._maxMotorTorque;
	},
	
	/**
	 * Set the max motor torque applied by this <code>RevoluteJoint</code>.
	 * @example var joint = new Physics2.RevoluteJoint();
	 * ...
	 * joint.setMaxMotorTorque(1);
	 * @param {Number} [maxMotorTorque=0] The new max motor torque.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.RevoluteJoint#getMaxMotorTorque
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setMaxMotorTorque: function(maxMotorTorque)
	{
		this._maxMotorTorque = maxMotorTorque;
		this._setMaxMotorTorqueSendGen(maxMotorTorque);
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 324
	// Method create = -1
	// Method destroy = 2
	// Method setLocalAnchorA = 3
	// Method setLocalAnchorB = 4
	// Method setReferenceRotation = 5
	// Method setEnableLimit = 6
	// Method setLowerRotation = 7
	// Method setUpperRotation = 8
	// Method setEnableMotor = 9
	// Method setMotorSpeed = 10
	// Method setMaxMotorTorque = 11
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in RevoluteJoint._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in RevoluteJoint._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[324] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":324,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":324,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setLocalAnchorASendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":324,3," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setLocalAnchorBSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":324,4," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setReferenceRotationSendGen: function( referenceRotation )
	{
		Core.Proc.appendToCommandString( ":324,5," + this.__objectRegistryId + "," + referenceRotation  );
	},
	
	/** @private */
	_setEnableLimitSendGen: function( enableLimit )
	{
		Core.Proc.appendToCommandString( ":324,6," + this.__objectRegistryId + "," + ( enableLimit ? 1 : 0 )  );
	},
	
	/** @private */
	_setLowerRotationSendGen: function( lowerRotation )
	{
		Core.Proc.appendToCommandString( ":324,7," + this.__objectRegistryId + "," + lowerRotation  );
	},
	
	/** @private */
	_setUpperRotationSendGen: function( upperRotation )
	{
		Core.Proc.appendToCommandString( ":324,8," + this.__objectRegistryId + "," + upperRotation  );
	},
	
	/** @private */
	_setEnableMotorSendGen: function( enableMotor )
	{
		Core.Proc.appendToCommandString( ":324,9," + this.__objectRegistryId + "," + ( enableMotor ? 1 : 0 )  );
	},
	
	/** @private */
	_setMotorSpeedSendGen: function( motorSpeed )
	{
		Core.Proc.appendToCommandString( ":324,10," + this.__objectRegistryId + "," + motorSpeed  );
	},
	
	/** @private */
	_setMaxMotorTorqueSendGen: function( maxMotorTorque )
	{
		Core.Proc.appendToCommandString( ":324,11," + this.__objectRegistryId + "," + maxMotorTorque  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setLocalAnchorA: function( x, y ) {}
	
	// setLocalAnchorB: function( x, y ) {}
	
	// setReferenceRotation: function( referenceRotation ) {}
	
	// setEnableLimit: function( enableLimit ) {}
	
	// setLowerRotation: function( lowerRotation ) {}
	
	// setUpperRotation: function( upperRotation ) {}
	
	// setEnableMotor: function( enableMotor ) {}
	
	// setMotorSpeed: function( motorSpeed ) {}
	
	// setMaxMotorTorque: function( maxMotorTorque ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/WeldJoint'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/WeldJoint'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/WeldJoint'] = exports; var Joint = require('NGCore/Client/Physics2/Joint').Joint;
var Core = require('NGCore/Client/Core').Core;

exports.WeldJoint = Joint.subclass(
/** @lends Physics2.WeldJoint.prototype */
{
	classname: 'WeldJoint',
	
	/**
	 * @class The <code>WeldJoint</code> class constructs objects that hold two application bodies completely stationary relative to each other 
	 * (see <code>{@link Physics2.Body}</code>).
	 * @constructs The default constructor. 
	 * @augments Physics2.Joint
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._localAnchorA = new Core.Point();
		this._localAnchorB = new Core.Point();
		this._referenceRotation = 0;
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Retrieve the local anchor point for the first connected body.
	 * @returns {Core.Point} The current local anchor point for the first connected body.
	 * @see Physics2.WeldJoint#setLocalAnchorA
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLocalAnchorA: function()
	{
		return this._localAnchorA;
	},
	
	/**
	 * Set the local anchor point for the first connected body.
	 * @example var joint = new Physics2.WeldJoint();
	 * ...
	 * joint.setLocalAnchorA(25, 0);
	 * @param {Core.Point} [localAnchorA=(0,0)] The new local anchor point for the first connected body.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.WeldJoint#getLocalAnchorA
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLocalAnchorA: function(localAnchorA)
	{
		var l = this._localAnchorA;
		l.setAll.apply(l, arguments);
		this._setLocalAnchorASendGen(l.getX(),l.getY());
		return this;
	},
	
	/**
	 * Retrieve the local anchor point for the second connected body.
	 * @returns {Core.Point} The current local anchor point for the second connected body.
	 * @see Physics2.WeldJoint#setLocalAnchorB
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLocalAnchorB: function()
	{
		return this._localAnchorB;
	},
	
	/**
	 * Set the local anchor point for the second connected body.
	 * @example var joint = new Physics2.WeldJoint();
	 * ...
	 * joint.setLocalAnchorB(-25, 0);
	 * @param {Core.Point} [localAnchorB=(0,0)] The new local anchor point for the second connected body.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.WeldJoint#setLocalAnchorB
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setLocalAnchorB: function(localAnchorB)
	{
		var l = this._localAnchorB;
		l.setAll.apply(l, arguments);
		this._setLocalAnchorBSendGen(l.getX(),l.getY());
		return this;
	},
	
	/**
	 * Retrieve the reference rotation for this <code>WeldJoint</code>.
	 * @returns {Number} The current reference rotation.
	 * @see Physics2.WeldJoint#setReferenceRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getReferenceRotation: function()
	{
		return this._referenceRotation;
	},
	
	/**
	 * Set the reference rotation for this <code>WeldJoint</code>.
	 * @example var joint = new Physics2.WeldJoint();
	 * ...
	 * joint.setReferenceRotation(-90);
	 * @param {Number} [refereceRotation=0] The new reference rotation.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Physics2.WeldJoint#getReferenceRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setReferenceRotation: function(referenceRotation)
	{
		this._referenceRotation = referenceRotation;
		this._setReferenceRotationSendGen(referenceRotation);
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 325
	// Method create = -1
	// Method destroy = 2
	// Method setLocalAnchorA = 3
	// Method setLocalAnchorB = 4
	// Method setReferenceRotation = 5
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in WeldJoint._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in WeldJoint._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[325] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":325,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":325,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setLocalAnchorASendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":325,3," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setLocalAnchorBSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":325,4," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setReferenceRotationSendGen: function( referenceRotation )
	{
		Core.Proc.appendToCommandString( ":325,5," + this.__objectRegistryId + "," + referenceRotation  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setLocalAnchorA: function( x, y ) {}
	
	// setLocalAnchorB: function( x, y ) {}
	
	// setReferenceRotation: function( referenceRotation ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Physics2/Contact'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Physics2/Contact'] || {}; $MODULE_REGISTRY['NGCore/Client/Physics2/Contact'] = exports; var Core = require('NGCore/Client/Core').Core;

/**
 * @class The <code>Contact</code> class constructs objects that store information about collisions that occur between two bodies (see <code>{@link Physics2.Body}</code>).
 * @name Physics2.Contact
 * @augments Core.Class
 * @status iOS, Android, Flash
 */
exports.Contact = Core.Class.subclass(
/** @lends Physics2.Contact.prototype */
{
	classname: 'Contact',
	
	/**
	 * Retrieve the contact type for this <code>Contact</code>.
	 * @returns {Physics2.Body#ContactFlags} The current contact type.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getType: function()
	{
		return this._type;
	},
	
	/**
	 * Retrieve the first collision shape for this <code>Contact</code>.
	 * @returns {Physics2.Body} The first collision shape.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getShapeA: function()
	{
		return this._shapeA;
	},
	
	/**
	 * Retrieve the second collision shape for this <code>Contact</code>.
	 * @returns {Physics2.Body} The second collision shape.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getShapeB: function()
	{
		return this._shapeB;
	},
	
	/**
	 * Retrieve the timestamp of a collision for this <code>Contact</code> (expressed in milliseconds).
	 * @returns {Number} The current timestamp.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTimestamp: function()
	{
		return this._timestamp;
	},
		
	/**
	 * Retrieve the normal force for this <code>Contact</code>.
	 * @returns {Core.Vector} The normal force applied to a collision between two bodies.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getNormal: function()
	{
		return this._normal;
	},
	
	/**
	 * Retrieve the number of collision locations for this <code>Contact</code>.
	 * @returns {Number} The current number of collision locations.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLocationCount: function()
	{
		return this._locations.length;
	},
	
	/**
	 * Retrieve a collision location at a specific index.
	 * @param {Number} index The specified index.
	 * @returns {Physics2.Contact.Location} The current collision location.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLocation: function(index)
	{
		return this._locations[index];
	},
	
	/**
	 * @class <code>Location</code> objects store the location of a single point of contact.
	 * @name Physics2.Contact.Location
	 * @augments Core.Class
	 */
	$Location: Core.Class.subclass(
	/** @lends Physics2.Contact.Location.prototype */
	{
		/**
		 * Retrieve the position of this <code>Contact</code>.
		 * @returns {Core.Point} The position.
		 * @see Physics2.Contact
	 	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getPosition: function()
		{
			return this._position;
		},
		
		/**
		 * Retrieve the impulse that is in the direction of the contact normal.
		 * @returns {Number} The normal impulse.
		 * @see Physics2.Contact
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 	 */
		getNormalImpulse: function()
		{
			return this._normalImpulse;
		},
		
		/**
		 * Retrieve the impulse that is a tangent to the contact normal.
		 * @returns {Number} The tangent impulse.
		 * @see Physics2.Contact
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 	 */
		getTangentImpulse: function()
		{
			return this._tangentImpulse;
		},
	}),
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGcore/Client/Core/ObjectRegistry'] = function(){var exports = $MODULE_REGISTRY['NGcore/Client/Core/ObjectRegistry'] || {}; $MODULE_REGISTRY['NGcore/Client/Core/ObjectRegistry'] = exports; var Class = require('NGcore/Client/Core/Class').Class;

exports.ObjectRegistry = Class.singleton(
{
	classname: 'ObjectRegistry',
		
	/** @private @class @status */
	initialize: function()
	{
		this._currentId = 0;
		this._guardId = 0;
		this._objects = {};
	},
	
	/** @status */
	register: function(obj)
	{
		if(obj.__objectRegistryId)
			throw new Error('ObjectRegistry.register: object already registered');
			
		var id = "" + ++this._currentId;
		obj.__objectRegistryId = id;
		this._objects[id] = obj;
	},
	
	/** @status */
	unregister: function(obj)
	{
		if(!obj.__objectRegistryId)
			throw new Error('ObjectRegistry.unregister: object not registered');
			
		var id = obj.__objectRegistryId;
		obj.__objectRegistryId = 0;
		delete this._objects[id];
	},
	
	/** @status */
	isObjectRegistered: function(obj)
	{
		if(obj.__objectRegistryId)
			return true;
		else
			return false;
	},
	
	/** @status */
	isIdRegistered: function(id)
	{
		if(this._objects[id])
			return true;
		else
			return false;
	},
	
	/** @status */
	objectToId: function(obj)
	{
		var id = obj.__objectRegistryId;
		
		if(!id)
			throw new Error('ObjectRegistry.objectToId: object not registered');
		
		return id;
	},
	
	/** @status */
	idToObject: function(id)
	{
		return this._objects[id];
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGcore/Client/Core/Class'] = function(){var exports = $MODULE_REGISTRY['NGcore/Client/Core/Class'] || {}; $MODULE_REGISTRY['NGcore/Client/Core/Class'] = exports; exports.Class = require('NGcore/Shared/Class').Class;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGcore/Shared/Class'] = function(){var exports = $MODULE_REGISTRY['NGcore/Shared/Class'] || {}; $MODULE_REGISTRY['NGcore/Shared/Class'] = exports; /**
 * The default constructor.
 * @constructor 
 * @class The <code>Class</code> object provides an environment for Object Oriented Programming (OOP) development in Javascript, such as Java or C++.
 * @name Core.Class
 */
var Class = function() {}
exports.Class = Class;

/**
 * Create a new class by extending another class.
 * @example
 * var MyClass = Class.subclass(
 * {
 *    initialize: function()
 *    {
 *        console.log('constructor');
 *    },
 *    foo: function(v)
 *    {
 *        console.log('MyClass.foo(' + v + ')');
 *    },
 * });
 * var myClass = new MyClass();
 * myClass.foo('param');
 * @param {Object} extensions Object literal containing new functions for the derived class.
 * @function
 * @name Core.Class.subclass
 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
 */
Class.subclass = (function()
{
/**#@+ @ignore */
	// Parse a function body and extract the parameter names.
	function argumentNames(body)
	{
		var names = body.toString().match(/^[\s\(]*function[^(]*\(([^)]*)\)/)[1]
			.replace(/\/\/.*?[\r\n]|\/\*(?:.|[\r\n])*?\*\//g, '')
			.replace(/\s+/g, '').split(',');
		return names.length == 1 && !names[0] ? [] : names;
	}
	
	// Create a function that calls overrideBody with a closure to ancestorBody.
	function overrideMethod(overrideBody, ancestorBody)
	{
		if(ancestorBody !== undefined)
		{
			// Create a function that calls overrideBody with a closure to ancestorBody as the first param.
			var override = function()
			{
				var localThis = this;
				var $super = function() { return ancestorBody.apply(localThis, arguments) };
				Array.prototype.unshift.call(arguments, $super);
				return overrideBody.apply(this, arguments);
			}
		}
		else
		{
			// Create a function that calls overrideBody with undefined as the first param, because ancestorBody is undefined.
			var override = function()
			{
				Array.prototype.unshift.call(arguments, undefined);
				return overrideBody.apply(this, arguments);
			}
		}

		// Hide our dirty tricks from the rest of the world.
		override.valueOf = function() { return overrideBody.valueOf() };
		override.toString = function() { return overrideBody.toString() };
		return override;
	}
	
	// Define some empty functions used later. This is a speed optimization.
	function TempClass() {}
	function emptyFunction() {}
	
	return function()
	{
		// Constructor for new class to be created.
		var properties = arguments[0];
		var classname = properties.classname || "AnonymousClass";
		var NewClass = eval('(function ' + classname + '(){this.initialize.apply(this, arguments)})');
		
		// Copy statics from this.
		for(var property in this)
		{
			if(!this.hasOwnProperty(property)) continue;
			NewClass[property] = this[property];
		}
		
		// Copy prototype from this.
		var ancestorPrototype = this.prototype;
		TempClass.prototype = ancestorPrototype;
		NewClass.prototype = new TempClass();
		NewClass.prototype.superclass = ancestorPrototype;
		NewClass.prototype.constructor = NewClass;
		
		// Copy properties into NewClass prototype.
		for(var property in properties)
		{
			if(!properties.hasOwnProperty(property)) continue;

			// getters / setters behave differently than normal properties.
			var getter = properties.__lookupGetter__(property)
			var setter = properties.__lookupSetter__(property)
			if(getter || setter)
			{
				if(getter)
				{
					// Copy getter into klass.
					var value = getter;
					if(argumentNames(value)[0] == "$super")
						value = overrideMethod(value, ancestorPrototype.__lookupGetter__(property));
					NewClass.prototype.__defineGetter__(property, value);
				}

				if(setter)
				{
					// Copy setter into klass.
					var value = setter;
					if(argumentNames(value)[0] == "$super")
						value = overrideMethod(value, ancestorPrototype.__lookupSetter__(property));
					NewClass.prototype.__defineSetter__(property, value);
				}
			}
			else
			{
				var value = properties[property];
				if(typeof value === "function" && property[0] != '$')
				{
					if(argumentNames(value)[0] == "$super")
					{
						// Create override method if first param is $super.
						value = overrideMethod(value, ancestorPrototype[property]);
					}
					else if(property == 'initialize')
					{
						var ancestorInitialize = ancestorPrototype.initialize
						if(ancestorInitialize)
						{
							// Automatically call inherited constructor.
							var derivedInitialize = value;
							value = function()
							{
								ancestorInitialize.apply(this, arguments);
								derivedInitialize.apply(this, arguments);
							};
						}
					}
					else if(property == 'destroy')
					{
						var ancestorDestroy = ancestorPrototype.destroy
						if(ancestorDestroy)
						{
							// Automatically call inherited destructor.
							var derivedDestroy = value;
							value = function()
							{
								derivedDestroy.apply(this, arguments);
								ancestorDestroy.apply(this, arguments);
							};
						}
					}

					// Copy function into new class prototype.
					NewClass.prototype[property] = value;
				}
				else
				{
					if(property[0] == '$')
						property = property.slice(1);

					// Copy enum into new class and the prototype.
					NewClass[property] = value;
					NewClass.prototype[property] = value;
				}
			}
		}
		
		// Make sure the is an initialize function.
		if(!NewClass.prototype.initialize)
			NewClass.prototype.initialize = emptyFunction;

		return NewClass;
	}
/**#@-*/
})();

/**
 * Create a singleton by extending a class.
 * @example
 * var MySingleton = Class.singleton(
 * {
 *    initialize: function()
 *    {
 *        console.log('constructor');
 *    },
 *    foo: function(v)
 *    {
 *        console.log('MyClass.foo(' + v + ')');
 *    },
 * });
 * MySingleton.foo('param');
 * @param {Object} extensions Object literal containing new functions for the singleton.
 * @function
 * @name Core.Class.singleton
 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
 */
Class.singleton = function()
{
	// Create sublcass as normal.
	var tempClass = this.subclass.apply(this, arguments);
	
	// Hide the initialize.
	var initialize = tempClass.prototype.initialize;
	tempClass.prototype.initialize = function() {};
	
	// Now instantiate.
	var instance = new tempClass();
	
	// Hide every prototype function with an instance function that calls initialize.
	var functions = [];
	/** 
	 * Ensure that the singleton has been created and fully initialized.
	 * @status iOS, Android, Flash
	*/
	var instantiate = function(real)
	{
		// Delete all of the instance functions we added.
		for(var i in functions)
		{
			var func = functions[i];
			delete instance[func];
		}
		
		// Restore the initialize function and call it.
		instance.initialize = initialize;
		instance.initialize();
		
		// Replace instantiate method with an empty function.
		instance.instantiate = function() {};
		
		// Call the function that caused this instantiation.
		var args = Array.prototype.slice.call(arguments, 1);
		return real.apply(instance, args);
	}
	
	// Iterate over all prototype functions.
	for(var i in instance)
	{
		// Don't do anything for setters or getters.
		if(instance.__lookupGetter__(i)
			|| instance.__lookupSetter__(i))
		{
			//TODO Should put proxies here too.
			continue;
		}
			
		var value = instance[i];
		if(typeof(value) == 'function')
		{
			// Remember the function names that we added so that instantiate() can remove them.
			functions.push(i);
			
			// Add an instance function to hide the prototype function, which will call instantiate.
			instance[i] = instantiate.bind(this, value);
		}
	}
	
	// Add instantiate method.
	instance.instantiate = instantiate.bind(this, function() {});
	
	// Return the isntance.
	return instance;
}

/**
 * @ignore
 */
Class.prototype.bind = function(func)
{
	var context = this;
	if(arguments.length < 2)
	{
		// Fast path if only the 'this' pointer is being bound.
		return function()
		{
			return func.apply(context, arguments);
		}
	}
	else
	{
		// Slower path if additional parameters are being bound.
		var args = Array.prototype.slice.call(arguments, 1);
		return function()
		{
			var finalArgs = args.concat(Array.prototype.slice.call(arguments, 0));
			return func.apply(context, finalArgs);
		}
	}
}

/**
 * @ignore
 */
Class.prototype.toString = function()
{
	return this.constructor.name;
}

// Debug implementation that will replace every method in destroyed objects with a grenade.
/*Class.prototype.destroy = function()
{
	function suicide()
	{
		throw new Error('Function called on destroyed object');
	}
	
	for(var i in this)
	{
		var value = this[i];
		if(typeof(value) == 'function')
		{
			this[i] = suicide;
		}
	}
}*/
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/NSObjects/SyncKeyValue'] = function(){var exports = $MODULE_REGISTRY['Code/NSObjects/SyncKeyValue'] || {}; $MODULE_REGISTRY['Code/NSObjects/SyncKeyValue'] = exports; var SyncKeyValue = Core.Class.subclass({
    classname : "SyncKeyValue",
    
    initialize : function(/*String*/storeKey,/*Array*/knownKeys)
    {
        this._store = Storage.KeyValueCache.global("ZombieFarm." + storeKey);
        this._knownKeys = knownKeys;
        this._cachedData = [];
    },
    
    preloadKnownKeys : function(cb)
    {
        this.__readyArr = [];
        
        var myCb = function(j, error, data, key)
        {
            this.__readyArr[j] = true;
            if (data)
            {
                this._cachedData[this._knownKeys[j]] = JSON.parse(data);
            }
            else
            {
                if (error.indexOf('Could not find key') == 0 || error.indexOf('No Results') != -1)
                {
                    NgLogD('Key not found. Key: ' + key);
                }
                else
                {
                    NgLogE("Key: " + key + ",Can't read from disk. Error: " + error);
                }
            }
        };
        
        for (var i in this._knownKeys)
        {
            this.__readyArr[i] = false;
            this._store.getItem(this._knownKeys[i], myCb.bind(this, Number(i)));
        }
        
        function checkReady()
        {
            var ready = true;
            for ( var i in this._knownKeys)
            {
                ready = ready && this.__readyArr[i];
            }
            
            if (ready)
            {
                cb.call();
            }
            else
            {
                setTimeout(checkReady.bind(this), 100);
            }
        }
        
        setTimeout(checkReady.bind(this), 100);
    },
    
    objectForKey : function(/*String*/key)
    {
        if (this._checkKey(key))
        {
            return this._cachedData[key];
        }
    },
    
    setObject : function(/*String*/value, /*String*/key)
    {
        if (this._checkKey(key))
        {
            this._cachedData[key] = value;
            this._store.setItem(key, JSON.stringify(value), function(_error, _key)
            {
                //NgLogD('Data Persisted for key: '+key);
            }.bind(this));
        }
    },
    
    doubleForKey : function(key)
    {
        return parseFloat(this.objectForKey(key));
    },
    
    removeObjectForKey : function(/*String*/key)
    {
        if (this._checkKey(key))
        {
            this._cachedData[key] = null;
            this._store.removeItem(key, function(_error, _key)
            {
                //NgLogD('Data Removed for key: '+key);
            }.bind(this));
        }
    },
    
    _checkKey : function(/*String*/key)
    {
        if (this._knownKeys.indexOf(key) != -1)
        {
            return true;
        }
        else
        {
            throw new Error("This key is not known, declare it first in the _knownKeys array. Key: " + key);
        }
    }
});

exports.SyncKeyValue = SyncKeyValue;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio'] = exports; /**
 * <p>Classes and objects contained by the Audio module.</p>
 * @name Audio
 * @namespace 
 * @description <p>The Audio module is a collection of classes that support manipulation of audio effects in an application. 
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 *<ul>
 *<li><code>{@link Audio.ActiveEffect}</code>: Construct objects for controlling the reproduction of <code>Effect</code> objects.</li>
 *<li><code>{@link Audio.Device}</code>: A singleton object that controls device sound effects volume.</li>
 *<li><code>{@link Audio.Effect}</code>: Construct objects that load sound resources into memory.</li>
 *<li><code>{@link Audio.Music}</code>: A singleton object that controls the reproduction of application background music.</li>
 *</ul>
 */
exports.Audio = {};

exports.Audio.__defineGetter__("ActiveEffect", function() {
	delete this.ActiveEffect;
	return this.ActiveEffect = require('NGCore/Client/Audio/ActiveEffect').ActiveEffect;
});
exports.Audio.__defineGetter__("Effect", function() {
	delete this.Effect;
	return this.Effect = require('NGCore/Client/Audio/Effect').Effect;
});
exports.Audio.__defineGetter__("Device", function() {
	delete this.Device;
	return this.Device = require('NGCore/Client/Audio/Device').Device;
});
exports.Audio.__defineGetter__("Music", function() {
	delete this.Music;
	return this.Music = require('NGCore/Client/Audio/Music').Music;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/ActiveEffect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/ActiveEffect'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/ActiveEffect'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.ActiveEffect = Core.Class.subclass(
/** @lends Audio.ActiveEffect.prototype */
{
	/**
	 * @class The <code>ActiveEffect</code> class constructs objects that control 
	 * the reproduction of an audio effect. Audio effects in Mobage applications are captured as <code>{@link Audio.Effect}</code> objects. 
	 * <code>{@link Audio.Effect}</code> objects handle and load data for an audio effect into memory. 
	 * This seperation allows applications to manage effect data independently of effect reproduction.
	 * <br><br>
	 * <b>Note:</b> You can only specify <code>{@link Audio.Effect}</code> objects to reproduce at instantiation.
	 * 
	 * @example
	 *
	 *   var effect = new Audio.Effect('some_effect.wav');
	 *   var activeEffect = new Audio.ActiveEffect(effect);
	 *   activeEffect.play();
	 * @constructs The default constructor. 	 
	 * @augments Core.Class
	 * @param {Audio.Effect} effect The <code>{@link Audio.Effect}</code> that this <code>ActiveEffect</code> object plays.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function(effect)
	{
		this._volume  = 1.0;
		this._loops   = false;
		this._playing = false;
		this._paused  = false;

		this._playCompleteEmitter = new Core.MessageEmitter();

		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._setEffect(effect);
	},
	
	/**
	 * Destroy this instance and releases resources on the backend.
	 * <b>Note:</b> This call does not automatically destroy the associated <code>{@link Audio.Effect}</code>.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		this.stop();
		this._effect = null;
		this._playCompleteEmitter.destroy();
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
	
	/**
	 * Return the volume level for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Number} The current volume level.
	 * @see Audio.ActiveEffect#setVolume
	 * @status iOS, Android, Test
	 */
	getVolume: function()
	{
		return this._volume;
	},
	
	/**
	 * Set the volume level for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * Calling this changes the volume even if an application is in the middle of reproducing an <code>{@link Audio.Effect}</code> object.
	 * The new volume level applies to any subsequent reproductions of the <code>{@link Audio.Effect}</code> object.
	 * @example Audio.ActiveEffect.setVolume(0.5);
	 * @param {Number} [volume=1] The new volume level. Supported values range between <code>(0-1)</code>. 
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Audio.ActiveEffect#getVolume
	 * @status iOS, Android
	 */
	setVolume: function(volume)
	{
		if (volume < 0.0) volume = 0.0;
		if (volume > 1.0) volume = 1.0;

		this._volume = volume;
		this._setVolumeSendGen(volume);
		return this;
	},
	
	/**
	 * Return the loop status for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Boolean} Returns <code>true</code> if looping is enabled.
	 * @see Audio.ActiveEffect#setLoops
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getLoops: function()
	{
		return this._loops;
	},
	
	/**
	 * Set the loop state for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * A looped effect wraps seamlessly from begining to end.
	 * @example Audio.ActiveEffect.setLoops(true);
	 * @param {Boolean} loops Set as <code>true</code> to enable looping.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Audio.ActiveEffect#getLoops
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setLoops: function(loops)
	{
		this._loops = loops;
		this._setLoopsSendGen(loops);
		return this;
	},
	
	/**
	 * Return the <code>Play Complete</code> emitter for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * The <code>Play Complete</code> emitter notifies applications when reproduction of an <code>{@link Audio.Effect}</code> is complete.<br><br>
	 * <b>Notes:</b>
	 * <ul>
	 *   <li>Any <code>{@link Audio.Effect}</code> object that does not loop uses the <code>Play Complete</code> emitter. </li>
	 * </ul>
	 * @returns {Core.MessageEmitter} The current state of the <code>Play Complete</code> emitter.
	 * @status iOS
	 */
	getPlayCompleteEmitter: function()
	{
		return this._playCompleteEmitter;
	},
	
	/**
	 * Return the play status of the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Boolean} Returns <code>true</code> if this <code>ActiveEffect</code> is reproducing an <code>{@link Audio.Effect}</code>.
	 * @see Audio.ActiveEffect#play
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getIsPlaying: function()
	{
		return this._playing;
	},
	
	/**
	 * Return the pause status of the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Boolean} Returns <code>true</code> if this <code>(@link Audio.Effect}</code> is in a paused state.
	 * @see Audio.ActiveEffect#pause
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getIsPaused: function()
	{
		return this._paused;
	},
	
	/**
	 * Begin reproducing an <code>{@link Audio.Effect}</code>.
	 * <ul>
	 * <li>If this <code>{@link Audio.Effect}</code> is new or in a stopped state,
	 * reproduction starts at the beginning.</li>
	 * <li>If this <code>{@link Audio.Effect}</code> is in a paused state, reproduction resumes from the previous position.</li>
	 * <li>If this <code>{@link Audio.Effect}</code> is playing, this call does nothing.</li>
	 * </ul>
	 * @see Audio.ActiveEffect#getIsPlaying
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	play: function()
	{
		this._playing = true;
		this._paused  = false;
		this._playSendGen( );
	},
	
	/**
	 * Pause reproduction of an <code>{@link Audio.Effect}</code>.
	 * <ul>
	 * <li>If this <code>ActiveEffect</code> is in the process of reproducing an <code>{@link Audio.Effect}</code>, this call pauses reproduction.</li>
	 * <li>If the <code>{@link Audio.Effect}</code> is in a stopped or paused state, this call does nothing.</li>
	 * </ul>
	 * <b>Note:</b> Calling this does not trigger the <code>Play Complete</code> emitter.
	 * @see Audio.ActiveEffect#getIsPaused
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	pause: function()
	{
		this._playing = false;
		this._paused  = true;
		this._pauseSendGen( );
	},
	
	/**
	 * Stop reprodution of an <code>{@link Audio.Effect}</code> object.
	 * <ul>
	 * <li>If this <code>ActiveEffect</code> is currently reproducing an <code>{@link Audio.Effect}</code> or the <code>{@link Audio.Effect}</code> is in a paused state, this call stops reproduction.</li>
	 * <li>If the <code>{@link Audio.Effect}</code> is in a stopped state, this call does nothing.</li>
	 * </ul>
	 * <b>Note:</b> Calling <code>stop()</code> does not trigger the <code>Play Complete</code> emitter.
	 * @status iOS, Android, Test, iOSTested, AndroidTested	 
	 */
	stop: function()
	{
		this._playing = false;
		this._paused  = false;
		this._stopSendGen( );
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 328
	// Method create = -1
	// Method destroy = 2
	// Method setVolume = 3
	// Method setLoops = 4
	// Method play = 5
	// Method pause = 6
	// Method stop = 7
	// Method setEffect = 8
	// Method playComplete = 9
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 9:
					instance._playCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in ActiveEffect._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in ActiveEffect._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[328] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_playCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in ActiveEffect.playComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":328,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":328,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setVolumeSendGen: function( volume )
	{
		Core.Proc.appendToCommandString( ":328,3," + this.__objectRegistryId + "," + volume  );
	},
	
	/** @private */
	_setLoopsSendGen: function( loops )
	{
		Core.Proc.appendToCommandString( ":328,4," + this.__objectRegistryId + "," + ( loops ? 1 : 0 )  );
	},
	
	/** @private */
	_playSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":328,5," + this.__objectRegistryId );
	},
	
	/** @private */
	_pauseSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":328,6," + this.__objectRegistryId );
	},
	
	/** @private */
	_stopSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":328,7," + this.__objectRegistryId );
	},
	
	/** @private */
	_setEffectSendGen: function( effectId )
	{
		Core.Proc.appendToCommandString( ":328,8," + this.__objectRegistryId + "," + effectId  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setVolume: function( volume ) {}
	
	// setLoops: function( loops ) {}
	
	// play: function(  ) {}
	
	// pause: function(  ) {}
	
	// stop: function(  ) {}
	
	// setEffect: function( effectId ) {}
	
	// _playCompleteRecv: function( cmd ) {}

// {{/Wg Generated Code}}

	_setEffect: function(effect)
	{
		this._effect  = effect;
		this._setEffectSendGen(this._effect.__objectRegistryId);
		return this;
	},

	_playCompleteRecv: function( cmd )
	{
		var msg = {};
		if(!this._playCompleteRecvGen(cmd, msg))
			return;

		this._playing = false;
		this._paused  = false;

		this._playCompleteEmitter.emit(this);
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/Effect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/Effect'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/Effect'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Effect = Core.Class.subclass(
/** @lends Audio.Effect.prototype */
{
	/**
	 * @class The <code>Effect</code> class constructs objects for handling audio resources that comprise an audio effect.
	 * Instantiating these objects allocates resources on the backend.
	 * After creating an <code>Effect</code> object, applications can control reproduction through an <code>{@link Audio.ActiveEffect}</code> object.<br><br>
	 * @example
	 * var effect = new Audio.Effect('Content/explosion.wav');
	 * @constructs The default constructor.<br><br>
	 * The following code is an example of constructing a new <code>Effect</code> object.
	 * @augments Core.Class
	 * @param {String} path A directory path that points to the audio file to load.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function(path)
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._setPath(path);
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
	
	/**
	 * Set a directory path to the audio file resource for this <code>Effect</code> object.
	 * @param {String} path The new directory path.
	 * @returns Calls to <code>setPath()</code> return <code>this</code> to support method invocation chaining.
	 */
	_setPath: function(path)
	{
		this._path = path;
		this._setPathSendGen(path);
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 326
	// Method create = -1
	// Method destroy = 2
	// Method setPath = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Effect._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Effect._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[326] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":326,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":326,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setPathSendGen: function( path )
	{
		Core.Proc.appendToCommandString( ":326,3," + this.__objectRegistryId + "," + Core.Base64.encode( path )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setPath: function( path ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/Device'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/Device'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/Device'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Device = Core.Class.singleton(
/** @lends Audio.Device.prototype */
{
	classname: 'Device',

	/**
	 * @class The <code>Device</code> class constructs a singleton object that contains audio device properties.
	 * Applications can use <codeDevice</code> objects to control global audio effects volume 
	 * and reproduce detached audio effects.
	 * <br><br>
	 * <b>Note:</b> An application should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	 
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._volume = undefined; // default value

		var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
		var initialValues = KeyValueCache.global("Audio.Device.InitialValues");

		var self = this;
		initialValues.getItem("effectsVolume", function(error, value) {
			self._volume = parseFloat(value);
		});
	},
	
	/**
	 * Return the global sound effects volume for this <code>Device</code> object.
	 * @returns {Number} The current global sound effects volume.
	 * @see Audio.Device#setEffectsVolume	 
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getEffectsVolume: function()
	{
		return this._volume;
	},
	
	/**
	 * Set the global sound effects volume for this <code>Device</code> object.
	 * Volume for each active effect multiplies
	 * by this value to produce a new volume level. 
	 * For example, if the global sound effects volume is set to 0.5, each active effect will play at half the volume set on the effect.
	 * @param {Number} [effectsVolume=1] The new volume for global sound effects. 
	 * Supported values range between <code>(0-1)</code>. 
	 * @example Audio.Device.setEffectsVolume(0.5);
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Audio.Device#getEffectsVolume
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setEffectsVolume: function(effectsVolume)
	{
		if (effectsVolume < 0.0) effectsVolume = 0.0;
		if (effectsVolume > 1.0) effectsVolume = 1.0;

		this._volume = effectsVolume;
		this._setEffectsVolumeSendGen(effectsVolume);
		return this;
	},
	
	/**
	 * Play an audio effect in a way that is completely detached from upstream or downstream processing.
	 * Using this call is a simple, high-level way to reproduce an audio effect.<br><br>
	 * The specified audio effect is only reproduced once.
	 * There is no control over the effect volume or effect playback.
	 * Resource allocation automatically occurs on the backend when playback begins. Resources are automatically released when playback ends.	 
	 * The following code is an example of a <code>playDetached()</code> call.
	 * @example
	 * Audio.Device.playDetached('Content/explosion.wav');
	 * @param {String} path A relative directory path to the audio file.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	playDetached: function(path)
	{
		this._playDetachedSendGen( path );
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 327
	// Method create = -1
	// Method setEffectsVolume = 2
	// Method playDetached = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Device._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Device._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[327] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":327,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_setEffectsVolumeSendGen: function( effectsVolume )
	{
		Core.Proc.appendToCommandString( ":327,2," + this.__objectRegistryId + "," + effectsVolume  );
	},
	
	/** @private */
	_playDetachedSendGen: function( path )
	{
		Core.Proc.appendToCommandString( ":327,3," + this.__objectRegistryId + "," + Core.Base64.encode( path )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setEffectsVolume: function( effectsVolume ) {}
	
	// playDetached: function( path ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/Music'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/Music'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/Music'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Music = Core.Class.singleton(
/** @lends Audio.Music.prototype */
{
	classname: 'Music',

	/**
	 * @class The <code>Music</code> class constructs a singleton object that provides control over reproduction
	 * of application background music.
	 * This object is constructed independently of <code>Device</code> objects because many devices
	 * already provide hardware-accelerated streaming and decode
	 * for a single background music track. Some
	 * devices gracefully mute a background music track
	 * if the user is playing a music track from their own library.
	 * <br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @example 
	 * var background = new Audio.Music('Content/music.mp3');
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._path    = null;
		this._playing = false;
		this._paused  = false;
		this._volume  = 1.0;
	},
	
	/**
	 * Return the directory path to the background music file used as a resource for this <code>Music</code> object.
	 * @returns {String} The directory path to a music file.
	 * @see Audio.Music#setPath
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getPath: function()
	{
		return this._path;
	},
	
	/**
	 * Set the directory path for the background music file that this <code>Music</code> object loads.<br><br>
	 * <b>Note:</b> If the application is reproducing music when this is called, reproduction will stop.
	 * The application must call <code>play()</code> again to start reproduction of the new resource.<br><br>
	 * The code in the following example sets a directory path to a music resource and plays that resource.
	 * @example
	 * Audio.Music.setPath('Content/music.mp3');
	 * Audio.Music.play();
	 *
	 * @param {string} path The new directory path to a music file.
	 * @see Audio.Music#getPath,
	 * @see Audio.Music#play
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setPath: function(path)
	{
		this._path = path;
		this._setPathSendGen(path);
	},
	
	/**
	 * Return the volume level used for reproduction of this <code>Music</code> object.
	 * @returns {Number} The current volume level.
	 * @see Audio.Music#setVolume
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getVolume: function()
	{
		return this._volume;
	},
	
	/**
	 * Set the volume level used for reproduction of this <code>Music</code> object.
	 * This call instantly modifies the background music volume level.
	 * Any subsequent reproductions of background music will play at the specified volume.
	 * @example Audio.Music.setVolume(0.5);
	 * @param {Number} [volume=1] The new volume. Supported values range between <code>(0-1)</code>.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Audio.Music#getVolume
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setVolume: function(volume)
	{
		if (volume < 0.0) volume = 0.0;
		if (volume > 1.0) volume = 1.0;

		this._volume = volume;
		this._setVolumeSendGen(volume);
		return this;
	},
	
	/**
	 * Return the playback state of this <code>Music</code> object. 
	 * @returns {Boolean} Returns <code>true</code> if an application is reproducing background music.
	 * @see Audio.Music#play
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getIsPlaying: function()
	{
		return this._playing;
	},
	
	/**
	 * Return the pause state of this <code>Music</code> object.
	 * @returns {Boolean} Returns <code>true</code> if an application is reproducing background music.
	 * @see Audio.Music#pause
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getIsPaused: function()
	{
		return this._paused;
	},
	
	/**
	 * Begin reproduction of this <code>Music</code> object.
	 * <ul>	
	 * <li>If this <code>Music</code> object is a new background music track, or the application has stopped the current background music track, 
	 * this call begins reproduction from the beginning.</li>
	 * <li>If the background music track is in a paused state, this call resumes reproduction from the previous position.</li>
	 * <li>If the background music track is currently playing, this call does nothing.</li>
	 * </ul>
	 * @see Audio.Music#getIsPlaying,
	 * @see Audio.Music#pause,
	 * @see Audio.Music#stop
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	play: function()
	{
		this._playing = true;
		this._paused  = false;
		this._playSendGen( );
	},
	
	/**
	 * Pause reproduction of this <code>Music</code> object.
	 * <ul>
	 * <li>If an application is currently reproducing a background music track, this call pauses reproduction.</li>
	 * <li>If the background music track is in a paused or stopped state, this call does nothing.</li>
	 * </ul>
	 * @see Audio.Music#getIsPaused
	 * @see Audio.Music#play,
	 * @see Audio.Music#stop
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	pause: function()
	{
		this._playing = false;
		this._paused  = true;
		this._pauseSendGen( );
	},
	
	/**
	 * Stop reproduction of this <code>Music</code> object.
	 * <ul>
	 * <li>If the background music track is playing or in a paused state, this call stops playback.</li>
	 * <li>If the background music track is in a stopped state, this call does nothing.</li>
	 * </ul>
	 * @see Audio.Music#play,
	 * @see Audio.Music#pause
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	stop: function()
	{
		this._playing = false;
		this._paused  = false;
		this._stopSendGen( );
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 329
	// Method create = -1
	// Method destroy = 2
	// Method setPath = 3
	// Method setVolume = 4
	// Method play = 5
	// Method pause = 6
	// Method stop = 7
	// Method playComplete = 8
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 8:
					instance._playCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Music._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Music._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[329] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_playCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in Music.playComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":329,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":329,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setPathSendGen: function( path )
	{
		Core.Proc.appendToCommandString( ":329,3," + this.__objectRegistryId + "," + Core.Base64.encode( path )  );
	},
	
	/** @private */
	_setVolumeSendGen: function( volume )
	{
		Core.Proc.appendToCommandString( ":329,4," + this.__objectRegistryId + "," + volume  );
	},
	
	/** @private */
	_playSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":329,5," + this.__objectRegistryId );
	},
	
	/** @private */
	_pauseSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":329,6," + this.__objectRegistryId );
	},
	
	/** @private */
	_stopSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":329,7," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setPath: function( path ) {}
	
	// setVolume: function( volume ) {}
	
	// play: function(  ) {}
	
	// pause: function(  ) {}
	
	// stop: function(  ) {}
	
	// _playCompleteRecv: function( cmd ) {}

// {{/Wg Generated Code}}

	_playCompleteRecv: function( cmd )
	{
		var msg = {};
		if(!this._playCompleteRecvGen(cmd, msg))
			return;

		this._playing = false;
		this._paused  = false;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Tools/HashTable'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Tools/HashTable'] || {}; $MODULE_REGISTRY['Code/Game/Tools/HashTable'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.HashTable = Core.Class.subclass({
	classname : "HashTable",

	initialize : function() {
		this._keyArray = new Array();
		this._valArray = new Array();
	},

	put : function(key, val) {
		var index = this.findIt(key);

		if (index == -1) {
			this._keyArray.push(key);

			var subIndex = this._keyArray.length - 1;
			this._valArray[subIndex] = [val];
		} else {
			this._valArray[index].push(val);
		}
	},

	get : function(key) {
		var index = this.findIt(key);
		if (index != -1) {
			return this._valArray[index];
		}
		return null;
	},

	remove : function(key) {
		var index = this.findIt(key);

		if (index != -1) {
			this._keyArray.splice(index,1);
			this._valArray.splice(index,1);
		}
	},

	size : function() {
		return this._keyArray.length;
	},

	clear : function() {
		this._keyArray.length = 0;
		this._valArray.length = 0;
	},

	findIt : function(key) {
		
		for ( var i in this._keyArray) {
			if (this._keyArray[i] == key) {
				return i;
			}
		}
		return -1;
	},
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCTexture2D'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCTexture2D'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCTexture2D'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var UI = require('NGCore/Client/UI').UI;

exports.CCTexture2D = Core.Class.subclass(
{
	classname: 'CCTexture2D',
	
	initialize: function()
	{
	},
	
	initialize: function(textureName, imageSize)
	{	
		this._textureName = textureName;
		this._imageSize = imageSize;
	},
	
	initWithFileName: function(fileName)
	{
		
		this._textureName = fileName;
//		var sprite = new GL2.Sprite();
//		sprite.setImage('./Content/' + fileName)._animation.setFilteringEnabled(false);
//		console.log("texture image size = " + sprite._animation._frames[0].getImage());
		
//TODO : HACK temp hacking to have image size :x		
//		this._imageSize = new Core.Size(256, 256);
		this._imageSize = new Core.Size(imagesSize[fileName]);
		//console.log("texture image size = (" + this._imageSize._width + ", " + this._imageSize._height + ")");
		

//		this._img = new Image();
//		this._img.src = './Content/' + fileName;
//		this._img.onload = this.printSize.bind(this);
	},
	
//	printSize: function()
//	{
//		console.log("texture image size = (" + this._img.width + ", " + this._img.height + ")");
//	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCTextureAtlas'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCTextureAtlas'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCTextureAtlas'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;

exports.CCTextureAtlas = Core.Class.subclass(
{
	classname: 'CCTextureAtlas',
	
	initialize: function(texture, n)
	{	
		this._capacity = n;
		this._totalQuads = 0;
		this._texture = texture;
		
//		capacity_ = n;
//		totalQuads_ = 0;
//		
//		// retained in property
//		self.texture = tex;
//
//		quads_ = calloc( sizeof(quads_[0]) * capacity_, 1 );
//		indices_ = calloc( sizeof(indices_[0]) * capacity_ * 6, 1 );
//		
//		if( ! ( quads_ && indices_) ) {
//			CCLOG(@"cocos2d: CCTextureAtlas: not enough memory");
//			if( quads_ )
//				free(quads_);
//			if( indices_ )
//				free(indices_);
//			return nil;
//		}
//		
//#if CC_TEXTURE_ATLAS_USES_VBO
//		// initial binding
//		glGenBuffers(2, &buffersVBO_[0]);		
//#endif // CC_TEXTURE_ATLAS_USES_VBO
//
//		[self initIndices];

	},
	
});

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCIntervalAction'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCIntervalAction'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCIntervalAction'] = exports; var CCFiniteTimeAction = require('Code/Cocos2D/CCFiniteTimeAction').CCFiniteTimeAction;

exports.CCIntervalAction = CCFiniteTimeAction.subclass({
	$actionWithDuration : function(d) {
		var action = new this();
		action.initWithDuration(d);
		return action;
	},

	initialize : function() {
		this._duration = 0;
	},

	reverse : function() {
	},

	initWithDuration : function(d) {
		this._duration = d;
		this._elapsed = 0;
		this._firstTick = true;

		if (this._duration == 0) {
			this._duration = 0.001; // To prevent division by zero.
		}
	},

	isDone : function() {
		return this._elapsed >= this._duration;
	},

	step : function(dt) {
		if (this._firstTick) {
			this._firstTick = false;
			this._elapsed = 0;
		} else {
			this._elapsed += dt;
		}

		this._target && this.update(Math.min(1.0, this._elapsed / this._duration));
	},

	startWithTarget : function($super, aTarget) {
		$super(aTarget);
		this._elapsed = 0;
		this._firstTick = true;
	}

});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCFiniteTimeAction'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCFiniteTimeAction'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCFiniteTimeAction'] = exports; var CCAction = require('Code/Cocos2D/CCAction').CCAction;

exports.CCFiniteTimeAction = CCAction.subclass(
{
	initialize: function()
	{
		//console.log( "CCFiniteTimeAction initialize()");
	},
	
	reverse: function()
	{
		//console.log("cocos2d: FiniteTimeAction#reverse: Implement me");
	}

	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCSpriteFrame'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCSpriteFrame'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCSpriteFrame'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;

exports.CCSpriteFrame = Core.Class.subclass(
{
	classname: 'CCSpriteFrame',
	
	initialize: function(textureName, rect, offset, originalSize, imageSize)
	{	
		this._textureName = textureName;
		this._offset = offset;
		this._rect = rect;
		this._originalSize = originalSize;
		this._imageSize = imageSize;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/MainMenu/Classes/MenuButton'] = function(){var exports = $MODULE_REGISTRY['Code/MainMenu/Classes/MenuButton'] || {}; $MODULE_REGISTRY['Code/MainMenu/Classes/MenuButton'] = exports; exports.MenuButton = Core.MessageListener.subclass({
    classname : 'MenuButton',
    
    initialize : function(position, size, image, callback)
    {
        this._callback = callback;
        this._size = size;
        
        this._node = new GL2.Node();
        this._node.setDepth(2);
        this._node.setPosition(position);
        
        this._bg = new GL2.Sprite();
        this._bg.setImage(image, size)._animation.setFilteringEnabled(true);
        this._bg.setPosition(size._width / 2.0, size._height / 2.0);
        this._node.addChild(this._bg);
        
        this._text = new GL2.Text("");
        this._bg.addChild(this._text);
        
        this._target = new GL2.TouchTarget();
        this._target.setSize(size);
        this._target.getTouchEmitter().addListener(this, this.onTouch);
        this._node.addChild(this._target);
    },
    
    setDepth : function(depth)
    {
        this._node.setDepth(depth);
    },
    
    setText : function(text)
    {
        this._text.setText(text);
    },
    
    setFontFamily : function(fontFamily)
    {
        this._text.setFontFamily(fontFamily);
    },
    
    setFontSize : function(fontSize)
    {
        this._text.setFontSize(fontSize);
    },
    
    setFontColor : function(fontColor)
    {
        this._text.setColor(fontColor);
    },
    
    getNode : function()
    {
        return this._node;
    },
    
    setBackgroundImage : function(path)
    {
        this._bg.setImage(path, this._size)._animation.setFilteringEnabled(false);
    },
    
    onTouch : function(touch)
    {
        switch (touch.getAction())
        {
            case touch.Action.Start:
                this._bg.setColor(new Core.Color(192.0 / 255.0, 192.0 / 255.0, 192.0 / 255.0));
                return true;
            case touch.Action.End:
                if (touch.getIsInside(this._target))
                {
                    this._callback();
                    this._bg.setColor(new Core.Color(1, 1, 1));
                }
                
                break;
            case touch.Action.Move:
                if (touch.getIsInside(this._target))
                {
                    this._bg.setColor(new Core.Color(192.0 / 255.0, 192.0 / 255.0, 192.0 / 255.0));
                }
                else
                {
                    this._bg.setColor(new Core.Color(1, 1, 1));
                }
                
                break;
        }
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/MainMenu/Classes/UISlider'] = function(){var exports = $MODULE_REGISTRY['Code/MainMenu/Classes/UISlider'] || {}; $MODULE_REGISTRY['Code/MainMenu/Classes/UISlider'] = exports; exports.UISlider = GL2.Node.subclass({
    classname : "UISlider",
    
    destroy : function()
    {
        this._target.getTouchEmitter().removeListener(this._listener);
        this._listener.destroy();
        this._listener = null;
        this._size = null;
        this._selectors = null;
        this._targets = null;
    },
    
    setEnabled : function(enabled)
    {
        this._enabled = enabled;
        if (enabled)
        {
            this._button.setColor(ccc3(255, 255, 255));
        }
        else
        {
            this._button.setColor(ccc3(128, 128, 128));
        }
    },
    
    initialize : function(position, size)
    {
        this._enabled = true;
        this.setPosition(position);
        
        this._colorLayer = CCColorLayer.layerWithColor(ccc3(0, 0, 0), size._width, 4);
        this._colorLayer.setPosition(ccp(0, -(size._height - 4) / 2));
        this._colorLayer.setDepth(0);
        
        this._button = new GL2.Sprite();
        this._button.setDepth(1);
        this._button.setImage("./Content/sliderKnob.png", new Core.Size(26, 26));
        this._button.setPosition(0, 13);
        
        var sizeIncrement = 70;
        
        this._listener = new Core.MessageListener();
        this._target = new GL2.TouchTarget();
        this._target.setSize(size._width * (1 + sizeIncrement/100), size._height * (1 + sizeIncrement/100));
        this._target.getTouchEmitter().addListener(this._listener, this._onTouch.bind(this));
        this._target.setDepth(10);
        this._target.setPosition(ccpAdd(this._target.getPosition(), ccp(-size._width * (sizeIncrement/2)/100, -size._height*(sizeIncrement/2)/100)));
        
        this.addChild(this._button);
        this.addChild(this._colorLayer);
        this.addChild(this._target);
        
        this._value = 0;
        this._size = size;
        
        this._selectors = {};
        this._targets = {};
    },
  
    setValue : function(value)
    {
        this._value = value;
        this._button.setPosition(value * this._size._width, 13);
        
//        if (this._selectors && this._selectors["UIControlEventValueChanged"])
//        {
//            this._selectors["UIControlEventValueChanged"](value);
//        }
    },
    
    getValue : function()
    {
        return this._value;
    },
    
    addTarget : function(target, selector, event)
    {
        this._selectors[event] = selector;
        this._targets[event] = target;
    },
    
    _onTouch : function(touch)
    {
        if (!this._enabled)
        {
            return true;
        }
        
        var width = this._size._width;
        var x = this.screenToLocal(touch.getPosition())._x;
        
        var value = x / width;
        if (value <= 0)
        {
            value = 0;
        }
        
        if (value >= 1)
        {
            value = 1;
        }
        
        this.setValue(value);
        
        switch (touch.getAction())
        {
            case touch.Action.End:
                if (this._selectors && this._selectors["UIControlEventTouchUpInside"])
                {
                    this._selectors["UIControlEventTouchUpInside"](value);
                }
                break;
        }
        return true;
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/MainMenu/ProfileView'] = function(){var exports = $MODULE_REGISTRY['Code/MainMenu/ProfileView'] || {}; $MODULE_REGISTRY['Code/MainMenu/ProfileView'] = exports; exports.ProfileView = Core.Class.subclass({
    classname : 'ProfileView',
    
    setDepth : function(depth)
    {
        this._rootNode.setDepth(depth);
    },
    
    getNode : function()
    {
        return this._rootNode;
    },
    
    setPosition : function(position)
    {
        this._rootNode.setPosition(position);
    },
    
    initialize : function()
    {
        this._rootNode = new GL2.Node();
        
        this._profileBGImageView = CCSprite.spriteWithFile("playerProfile_frame.png");
        this._size = new Core.Size(298, 60);
        this._rootNode.addChild(this._profileBGImageView);
        
        //separate method to show the head image
        this.switchPlayerProfileHeadImage();
        
        var activePlayer = PlayerProfileManager.getActivePlayer();
        
        // Set the active player's name
        this._profileNameLabel = CCLabel.labelWithString(activePlayer.playerProfileAlias(), "Arial-BoldMT", 16);
        this._profileNameLabel.setPosition(-80, 10);
        this._profileNameLabel.setAnchorPoint(ccp(0, 0));
        this._profileBGImageView.addChild(this._profileNameLabel);
        
        // The profile level label
        this._profileLevelLabel = CCLabel.labelWithString(NSLocalizedString("Level: ") + activePlayer.playerLevel(), "Arial", 10);
        this._profileLevelLabel.setPosition(-80, 21);
        this._profileLevelLabel.setAnchorPoint(ccp(0, 0));
        //this._profileLevelLabel.setColor(ccc3(224, 186, 109));
        this._profileBGImageView.addChild(this._profileLevelLabel);
        
        // the brain icon
        this._profileBrainIcon = CCSprite.spriteWithFile("brain.png", CGRectMake(0, 0, 20, 15));
        this._profileBrainIcon.setScale(0.8);
        this._profileBrainIcon.setAlpha(0.80);
        this._profileBrainIcon.setPosition(-20, 17);
        this._profileBrainIcon.setAnchorPoint(ccp(0.5, 0.5));
        this._profileBGImageView.addChild(this._profileBrainIcon);
        
        // The profile brains label
        this._profileBrainLabel = CCLabel.labelWithString("" + activePlayer.playerBrains(), "Arial", 10);
        this._profileBrainLabel.setPosition(-8, 21);
        this._profileBrainLabel.setAnchorPoint(ccp(0, 0));
        //this._profileBrainLabel.setColor(ccc3(224, 186, 109));
        this._profileBGImageView.addChild(this._profileBrainLabel);
        
        // the gold icon
        this._profileGoldIcon = CCSprite.spriteWithFile("gold.png", CGRectMake(0, 0, 20, 20));
        this._profileGoldIcon.setScale(0.4);
        this._profileGoldIcon.setAlpha(0.8);
        this._profileGoldIcon.setPosition(ccp(30, 16));
        this._profileGoldIcon.setAnchorPoint(ccp(0.5, 0.5));
        this._profileBGImageView.addChild(this._profileGoldIcon);
        
        // The profile gold label
        this._profileGoldLabel = CCLabel.labelWithString("" + activePlayer.playerGold(), "Arial", 10);
        this._profileGoldLabel.setPosition(40, 21);
        //this._profileGoldLabel.setColor(ccc3(224, 186, 109));
        this._profileGoldLabel.setAnchorPoint(ccp(0, 0));
        this._profileBGImageView.addChild(this._profileGoldLabel);
        
        /* FIXME: Profile switching
        // Add the switch profile button
        switchProfileButton = UIButton.initWithFrame(CGRectMake(236, 19.0, 51.0, 26.0));
        switchProfileButton.titleLabel.font = UIFont.boldSystemFontOfSize(12);
        switchProfileButton.setTitleColor(UIColor.colorWithRed(54 / 255, 25 / 255, 13 / 255, 1), UIControlStateNormal);
        switchProfileButton.setTitle(NSLocalizedString("Switch", "Switch player profiles"), UIControlStateNormal);
        switchProfileButton.addTarget(this, this.switchTapped.bind(this), UIControlEventTouchUpInside);
        switchProfileButton.titleLabel.textAlignment = UITextAlignmentCenter;
        
        // Set the image background for the button
        var switchProfileButtonImageNormal = CCSprite.spriteWithFile("playerProfile_button.png");
        switchProfileButton.setBackgroundImage(switchProfileButtonImageNormal, UIControlStateNormal);
        
        var switchProfileButtonImageDown = CCSprite.spriteWithFile("playerProfile_button.png");
        switchProfileButton.setBackgroundImage(switchProfileButtonImageDown, UIControlStateHighlighted);
        
        // Add the switch profile button to the profile view
        this._profileBGImageView.addChild(switchProfileButton);*/

        //separate method to show online status indicator
        //this.updateOnlineStatus();
    },
    
    destroy : function()
    {
        this._profileBrainIcon.destroy();
        this._profileBrainLabel.destroy();
        this._profileGoldIcon.destroy();
        this._profileGoldLabel.destroy();
        this._profileImage.destroy();
        this._profileLevelLabel.destroy();
        this._profileNameLabel.destroy();
        this._profileBGImageView.destroy();
        this._rootNode.destroy();
    },
    
    switchPlayerProfileHeadImage : function()
    {
        //this._profileImage.removeFromSuperview();
        this._profileImage = null;
        var key = null;
        var activePlayer = PlayerProfileManager.getActivePlayer();
        switch (activePlayer.playerHeadID())
        {
            case 0:
                key = "asianHeadMale";
                break;
            case 1:
                key = "whiteHeadMale";
                break;
            case 2:
                key = "skeletonHeadMale";
                break;
            case 3:
                key = "vampireHeadMale";
                break;
            case 4:
                key = "asianHeadFemale";
                break;
            case 5:
                key = "whiteHeadFemale";
                break;
            case 6:
                key = "skeletonHeadFemale";
                break;
            case 7:
                key = "vampireHeadFemale";
                break;
            case 8:
                key = "zombieHeadMale";
                break;
            case 9:
                key = "zombieHeadFemale";
                break;
            case 10:
                key = "blackHeadMale";
                break;
            case 11:
                key = "blackHeadFemale";
                break;
            case 12:
                key = "paperBagHeadMale";
                break;
            case 13:
                key = "monolithHeadMale";
                break;
            case 14:
                key = "pumpkinHeadMale";
                break;
            default:
                break;
        }
        
        var farmerSprites = DataPreloader._farmerSprites;
        var spriteDetails = farmerSprites[key];
        var playerHeadRect = CGRectMake(Number(spriteDetails.x), Number(spriteDetails.y), Number(spriteDetails.width), Number(spriteDetails.height));
        
        // Add an image for the button
        this._profileImage = CCSprite.spriteWithFile("playerSpriteSheet.png", playerHeadRect);
        this._profileImage.setPosition(-0.5 * (this._size._width - Number(spriteDetails.width)) + 5, 9);
        if (this._resolutionWidth != 1024 || this._resolutionHeight != 768)
        {
            this._profileImage.setScale(0.7);
        }
        
        this._profileBGImageView.addChild(this._profileImage);
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/MainMenu/ShakeListener'] = function(){var exports = $MODULE_REGISTRY['Code/MainMenu/ShakeListener'] || {}; $MODULE_REGISTRY['Code/MainMenu/ShakeListener'] = exports; exports.ShakeListener = Core.MessageListener.subclass({
    classname : 'ShakeListener',

    initialize : function(node)
    {
        this._node = node;
        this._step = 1;
        this._waitTime = 200;
        
        var widthScale = UI.Window._width / 480.0;
        this._originalPosX = this._node.getPosition()._x;
        this._movedPosX = this._originalPosX - 4.0 * widthScale;
        
        Core.UpdateEmitter.addListener(this, this.onUpdate);
    },
    
    onUpdate : function(delta)
    {
        if (delta > 200)
        {
            return;
        }
        
        switch (this._step)
        {
            case 1:
                //move frame a bit left
                this._node.setPosition(this._movedPosX, this._node.getPosition()._y);
                this._step++;
                break;
            case 2:
                //wait a bit
                this._waitTime -= delta;
                if (this._waitTime <= 0)
                {
                    this._step++;
                }
                break;
            case 3:
                //move frame to original position
                this._node.setPosition(this._originalPosX, this._node.getPosition()._y);
                this._step++;
                break;
            case 4:
                this.destroy();
                break;
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/MainMenu/SlideInListener'] = function(){var exports = $MODULE_REGISTRY['Code/MainMenu/SlideInListener'] || {}; $MODULE_REGISTRY['Code/MainMenu/SlideInListener'] = exports; exports.SlideInListener = Core.MessageListener.subclass({
    classname : 'SlideInListener',
    
    initialize : function(node, destination, slideInSpeed)
    {
        this._node = node;
        this._dstX = destination._x;
        this._dstY = destination._y;
        var widthScale = UI.Window._width / 480.0;
        this._slideInSpeed = slideInSpeed * widthScale;
        
        Core.UpdateEmitter.addListener(this, this.onUpdate);
    },
    
    onUpdate : function(delta)
    {
        var dt = delta / 1000;
        if (delta > 200)
        {
            return;
        }
        
        xFinished = false;
        yFinished = false;
        
        //have we finished sliding?
        if (this._node.getPosition()._x <= this._dstX)
        {
            this._node.setPosition(this._dstX, this._node.getPosition()._y);
            xFinished = true;
        }
        
        if (this._node.getPosition()._y <= this._dstY)
        {
            this._node.setPosition(this._node.getPosition()._x, this._dstY);
            yFinished = true;
        }
        
        //have we?
        if (xFinished && yFinished)
        {
            this.destroy();
            return;
        }
        
        var x = this._slideInSpeed * dt;
        var y = this._slideInSpeed * dt;
        
        //check if we don't go too far with x
        var length = this._node.getPosition()._x - this._dstX;
        if (x > length)
        {
            x = length;
        }
        
        var lengthY = this._node.getPosition()._y - this._dstY;
        if (y > lengthY)
        {
            y = lengthY;
        }
        
        this._node.setPosition(this._node.getPosition()._x - x, this._node.getPosition()._y - y);
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/ZFMenus/ZombieSelection/ZFZombieCell'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/ZombieSelection/ZFZombieCell'] || {}; $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/ZombieSelection/ZFZombieCell'] = exports; var cellSize = new Core.Size(58, 120);
exports.ZFZombieCell = CCTableViewCell.subclass({
	classname: "ZFZombieCell",
	
	$cellSize : function() {
		return cellSize;
	},

	initialize : function() {
		var fntFile = "ABD26.fnt";
		var color = ccc4(0xff, 0x0, 0x0, 0x0);
		this._cellLayer = CCColorLayer.layerWithColor(color, 58, 100);

		//TODO
		if (true/*[[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hant"] || [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"zh-Hans"] ||
				   [[ZombieFarmAppDelegate getCurrentLanguage] isEqualToString:@"ja"]*/) {
			this._name = CCLabel.labelWithString("-", "Arial", 26);
			this._number = CCLabel.labelWithString("-", "Arial", 26);
		} else {
			this._name = CCLabel.labelWithString("-", "AmericanTypewriter-Bold", 26);
			//TODO
			//number = [CCBitmapFontAtlas bitmapFontAtlasWithString:@"-" fntFile:fntFile];
		}

		this._number.setColor(ZFColorDefines.colorTextHighlight);
		this._number.setAnchorPoint(ccp(0.5, 0));
		this._number.setScale(0.75);
		this._number.setPosition(ccp(this._cellLayer.getSize()._width / 2, 50));

		this._name.setScale(0.5);
		this._name.setAnchorPoint(ccp(0.5, 0));
		this._name.setPosition(ccp(this._cellLayer.getSize()._width / 2, -35));

		this._cellLayer.addChild(this._name, 14);
		this._cellLayer.addChild(this._number, 15);

		return this;
	},

	setZombie : function(aZombie) {
		var acm = ZFActorManager;
		var zs = ZFZombieSelectionMenu.zombieSelectionMenu();

		if (this._zombie) {
			this._cellLayer.removeChild(this._zombie, true);
			this._zombie.despawn();
//			destroy(this._zombie);
			this._zombie = null;
		}

		this._zombieRef = aZombie;
		this._zombie = acm.spawnGUIActor_withClass_atPoint_withTarget(aZombie.classname, ccp(0, 25), this._cellLayer);
		this._zombie.addMutation(aZombie._flags);
		this._zombie._savedColor = aZombie._savedColor;
		scale = this._zombie._spriteMan.getScale();
		this._zombie._spriteMan.setScale(scale._x * 0.80, scale._y * 0.80);
		this._zombie.resetColor();

		this._zombie._spriteMan.setPosition(this._cellLayer.getSize()._width / 2, -45);
		this._zombie._spriteMan.setAnchorPoint(ccp(0.5, 1));

		this._name.setString(aZombie._name);

		var ind;
		if (!zs._zombieOrder) {
			ind = -1;
		} else {
			ind = zs._zombieOrder.indexOf(aZombie);
		}

		if (ind >= 0 && ind < zs._zombieOrder.length) {
			this._number.setString(sprintf("%i", ind + 1));
			this._number.setColor(ZFColorDefines.colorGreenButton);
		} else {
			this._number.setString("");
			this._number.setColor(ZFColorDefines.colorTextHighlight);
		}
	},

	destroy : function() {
		if (this._zombie) {
			this._cellLayer.removeChild(this._zombie, true);
			this._zombie.despawn();
			destroy(this._zombie);
			this._zombie = null;
		}
		
//		this._cellLayer.removeAllChildrenWithCleanup(true);
		destroyWithChildren(this._cellLayer);
		this._cellLayer = null;
	},

	//- (void)pressed:(id)sender
	pressed : function(sender) {
		var zs = ZFZombieSelectionMenu.zombieSelectionMenu();

		//check if its already in there
		if (zs._zombieOrder.indexOf(this._zombieRef) >= 0) {
			zs._zombieOrder.splice(zs._zombieOrder.indexOf(this._zombieRef), 1, null);
			this.updateNumberDisplay();
			return;
		}

		var ind = -1;

		//get the first available slot
		for ( var i = 0; i < zs._zombieOrder.length; ++i) {
			var item = zs._zombieOrder[i];
			if (!item) {
				ind = i;
				break;
			}
		}

		if (ind == -1) {
			zs._zombieOrder.splice(ind, 1, null);
		} else {
			zs._zombieOrder.splice(ind, 1, this._zombieRef);
		}

		this.updateNumberDisplay();
	},

	//-(void)updateNumberDisplay
	updateNumberDisplay : function() {
		var zs = ZFZombieSelectionMenu.zombieSelectionMenu();
		var ind = -1;
		for ( var i = 0; i < zs._zombieOrder.length; ++i) {
			var item = zs._zombieOrder[i];
			if (item == this._zombieRef) {
				ind = zs._zombieOrder.indexOf(item);
				break;
			}
		}

		if (ind == -1) {
			this._number.setString("");
			this._number.setColor(ZFColorDefines.colorTextHighlight);
		} else {
			this._number.setString(sprintf("%i", ind + 1));
			this._number.setColor(ccc3(0, 0, 0));//ZFColorDefines.colorGreenButton);
		}
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/FarmGameScene/ZFFarmTileMap'] = function(){var exports = $MODULE_REGISTRY['Code/Game/FarmGameScene/ZFFarmTileMap'] || {}; $MODULE_REGISTRY['Code/Game/FarmGameScene/ZFFarmTileMap'] = exports; var CCTMXTiledMap = require('Code/Cocos2D/CCTMXTiledMap').CCTMXTiledMap;
var ZFGameTool = require('Code/Game/Tools/ZFGameTool').ZFGameTool;

exports.ZFFarmTileMap = CCLayer.subclass(
{
	classname: 'ZFFarmTileMap',
	TouchState:
	{
		kTouchStateGrabbed: {},
		kTouchStateUngrabbed: {},
		kTouchStateGrabbedMulti: {}
	},
	
	TagMap: 
	{
		kTagTileMap : 1,
		kTagColorLayer : 2
	},

	initialize: function(cb)
	{	
		this._cb = cb;
		
		var gs = GameState;
		this._initialDistance = 0.0;
		this._firstTickWitherCheck = true;
	
		this._colorLayer = CCColorLayer.layerWithColor(ccc3(108, 165, 100));
		this._colorLayer.setScale(this.getContentSize()._width, this.getContentSize()._height);
		this._colorLayer.setPosition(new Core.Point(-this.getContentSize()._width * 5, 0));
		this.addChild(this._colorLayer, -1, this.TagMap.kTagColorLayer);
		
		// Make sure we have the right farm size based on the purchase flags
		var mapSize = gs._zfGameData._mapSize;
		
		if( mapSize < 40 && gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_FARM40))
			gs._zfGameData._mapSize = mapSize = 40;
		
		if( mapSize < 50 && gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_FARM50))
			gs._zfGameData._mapSize = mapSize = 50;
		
		if( mapSize < 60 && gs._zfGameData._purchaseFlags.hasFlag(ZFGameFlags.PFLAG_FARM60))
			gs._zfGameData._mapSize = mapSize = 60;
        
		// Likewise make sure we have the right purchase flags based on the farm size
        if (mapSize >= 40)
            gs._zfGameData._purchaseFlags.setFlag(ZFGameFlags.PFLAG_FARM40);
        if (mapSize >= 50)
            gs._zfGameData._purchaseFlags.setFlag(ZFGameFlags.PFLAG_FARM50);
        if (mapSize >= 60)
            gs._zfGameData._purchaseFlags.setFlag(ZFGameFlags.PFLAG_FARM60);
		
		switch (mapSize)
		{
			case 30: this._map = new CCTMXTiledMap('./Content/farm30.tmx', this.finishInit.bind(this)); break;
			case 40: this._map = new CCTMXTiledMap('./Content/farm40.tmx', this.finishInit.bind(this)); break;
			case 50: this._map = new CCTMXTiledMap('./Content/farm50.tmx', this.finishInit.bind(this)); break;
			case 60: this._map = new CCTMXTiledMap('./Content/farm60.tmx', this.finishInit.bind(this)); break;
		}
		
		this._zoomInMax = ZFGameDefines.ZOOM_MAX_VALUE;
		this._zoomOutMax = ZFGameDefines.ZOOM_MIN_VALUE;
		var screenSize = CCDirector.winSize();
		
		if (screenSize._width > 480)
		{
			this._zoomInMax = 2.0;
			this._zoomOutMax = 0.9 - (/*this._map._mapSize._width*/mapSize * 0.01);	//just enough to keep whole map within screen for iPad
		}
		this._zoomFactor = this._zoomInMax;
		this._initialTouchTime = null;
	},
	
	finishInit: function()
	{
		this.addChild(this._map, 0, this.TagMap.kTagTileMap);
		
		//var s1 = this._map._contentSize;
		var winSize = CCDirector.winSize();
		this._map.setAnchorPoint(new Core.Point(0,0));
		var s1 = this._map.getContentSize();
		var newPosition = ccpAdd(ccp(winSize._width/2, winSize._height/2), CGPointMake(-s1._width/2, -s1._height/2));
		newPosition = ccpAdd(newPosition, ccp(0,-40));
		this._map.setPosition(newPosition);
		ZFTileManager.setMap(this._map);
		
		this._touchState = this.TouchState.kTouchStateUngrabbed;
		
		//create internal listener
		this._listener = new Core.MessageListener();		
		this.schedule(this.tick, ZFGameDefines.FARM_UPDATE_INTERVAL, "tick");		

		//init touch node currently hacked size and removed anchor point compared to original code
		this._target = new GL2.TouchTarget();
		this._target.setSize(this.getContentSize()._width * 5, this.getContentSize()._height * 5);
		this._target.setAnchor(new Core.Point(0.5,0.5));
		this._target.setPosition(ccp(this.getContentSize()._width / 2 , -this.getContentSize()._height / 2));
		this._target.getTouchEmitter().addListener(this._listener, this.onTouch.bind(this));
		this._target.setDepth(100000);
		this.addChild(this._target);
		
		this._touches = [];
		this._cb();
		this.setZoomOutAmount(1.2);
	},
	
	destroy: function()
	{
		destroy(this._node);
		this._node = null;
	},
	
	tick: function(dt)
	{
		var tim = ZFTileManager;
		var gs = GameState;
		
		var spritesToGraduate = [];
		var ttiles = TSprite.allMySprites();
		for (var key in ttiles) 
		{
			var tSprite = ttiles[key];
			if (!tSprite._tile || !tSprite._tile._date || !tSprite._tile._isTransformable)
			{
				continue;
			}

			var growthStages = 1;
			if (tSprite._tile._isPlant)
			{
				growthStages = ZFGameDefines.PLANT_GROWTH_STAGES;
			}
			else if (tSprite._tile._isZombie)
			{
				growthStages = ZFGameDefines.ZOMBIE_GROWTH_STAGES;
			}
			
			//lets get how long this crop has been at this stage
			var curDate = Core.Time.getRealTime()/1000;
			var growthStageAge = (curDate - tSprite._tile._date);
			var growthStageMaturity;

			// now lets get the time it takes from the last stage to the next
			if (tSprite._tile._isHarvestable)
			{
				var witherMultiplier = (tSprite._tile._ignoreWitherRule) ? 1 : ZFGameDefines.WITHER_MULTIPLIER;
				growthStageMaturity = (tSprite._tile._growTime * witherMultiplier); // only for withering
			}
			else 
			{
				growthStageMaturity = tSprite._tile._growTime / growthStages; //for growing crops
				growthStageMaturity = growthStageMaturity / gs._zfGameData._growSpeed;  //Used for cheats
				
				if(gs._zfGameData._headID == 13 && tSprite._tile._isZombie)
				{
					//get how long its been growing from the time it was planted
					var growthStageAgeFromPlanting = (curDate - tSprite._tile._plantDate) / 1000;
					
					// if its been growing longer than it's total grow tim have it graduate
					if (growthStageAgeFromPlanting >= tSprite._tile._growTime * 0.75)
					{
						growthStageAge = growthStageMaturity;
					}
					else 
					{
						growthStageMaturity *= .75;
					}
				}
			}
			
			if ( growthStageAge >= growthStageMaturity )
			{
				//XFORM!
				if(!(tSprite._tile._isHarvestable && (GameState._zfGameData._cheatFlags & ZFGameDefines.CFLAG_NEVERWITHER)))
				{					
					spritesToGraduate.push(tSprite);
					if (this._firstTickWitherCheck && tSprite._tile._isHarvestable)
					{
						
						var gui = ZFGuiLayer.gui();
						var aw = gui.displayAlertSimpleChoice(Core.Localization.getString("Withered Crops"),
															   Core.Localization.getString("Looks like some of yer crops or zombies have withered.\n\nWould you like to use\nRegrowth\nto revive all your withered crops?"),
																CCSprite.spriteWithFile("stex0031.png"));
						aw._delegate = gui;
						aw._idTag = ZFGuiLayer.guiTags.kGuiTagInvasionUseRegrowth;
						this._firstTickWitherCheck = false;
//TODO						
//						NSDictionary *eventDictionary = [NSDictionary dictionaryWithObjectsAndKeys:
//														 tSprite.tile.key, @"CropType",
//														 nil];
//						[FlurryAPI logEvent:kFlurryEvent_cropsExpired withParameters:eventDictionary];
					}
				}
			}
		}
		
		for (var key in spritesToGraduate)
		{
//			console.log("sprite to graduate = " + key);
			var tSprite = spritesToGraduate[key];
			tim.graduateSoilTileWithTSprite(tSprite);
		}
		
        //TODO
        //[spritesToGraduate release];

		//ambient Sounds
		if (!this.isScheduled(this.quietTime) && SimpleAudioEngine.isBackgroundMusicPlaying())
		{
			this.schedule(this.quietTime, 30 + Math.floor(Math.random() * 30), "quietTime");
			
			var filePath = null;
			var rand = Math.random();
			if (rand < 1 / 6)
			{
				filePath = kMooSFX;
			}
			else if (rand < 2 / 6)
			{
				filePath = kSheepSFX;
			}
			else if (rand <  3 / 6)
			{
				filePath = kBirdsSFX;
			}
			else if (rand <= 4 / 6)
			{
				filePath = kRoosterSFX;
			}
			else if (rand <= 5 / 6)
			{
				filePath = kOinkSFX;
			}
			else if (rand <= 6 / 6)
			{
				filePath = kCrowSFX;
			}
			
			SimpleAudioEngine.playEffect(filePath);
		}

		for (var key in tim._zombieCombinerList)
		{
			var zcmb = tim._zombieCombinerList[key];
			zcmb.update();
		}
		
		firstTickWitherCheck = false;
	},
	
	quietTime: function(dt)
	{
	    this.unschedule(this.quietTime);
	},

	onTouch: function(touch)
	{
		if (this.isMenuBlockingFarm()) //no functionality if menu is blocking the touch
		{
			this._touchState = this.TouchState.kTouchStateUngrabbed;
			this._touch1 = null; 
			this._touch2 = null;
			this._touches.length = 0;
			
			return;
		}
		switch(touch.getAction())
		{
			case touch.Action.Start:
				return this.ccTouchBegan(touch);
			case touch.Action.End:
				this.ccTouchEnded(touch);
				break;
			case touch.Action.Move:
				this.ccTouchMoved(touch);
				break;
		}
	},
	    
    ccTouchBegan : function(touch)
    {
        this._touches.push(touch.getId());
        //if (this.isMenuBlockingFarm())
        //{
        //      return false;
        //}
        
        var toolID = ZFToolManager.toolManager()._currentGameTool;
        if (this._touchState == this.TouchState.kTouchStateGrabbed)
        {
            if (this._touches.length >= 2 /*&& this._initialTouchTime != null && this._initialTouchTime - Core.Time.getRealTime() < 500*/)
            {
                //NSArray *tchs = [touches allObjects];
                var i = this._touches.indexOf(this._touch1.getId());
                if (i < 2)
                {
                    // two finger touch handling 
                    this._touch2 = touch;                    
                    var touchLocationScreen = this._touch1.getPosition().clone();
                    touchLocationScreen.setAll(touchLocationScreen._x, toScreenCY(touchLocationScreen._y));
                    var prevLocationOnScreen = this._touch2.getPosition().clone();
                    prevLocationOnScreen.setAll(prevLocationOnScreen._x, toScreenCY(prevLocationOnScreen._y));
                    this._initialDistance = ccpDistance(touchLocationScreen, prevLocationOnScreen);
                    this._originalScale = this.getScale();
                    this._touchState = this.TouchState.kTouchStateGrabbedMulti;
                    return true;
                }
            }
            else
            {
                this._touch1 = null;
                this._touchState = this.TouchState.kTouchStateUngrabbed;
            }
        }
        
        this._initialTouch = touch;
        this._initialTouchTime = Core.Time.getRealTime();
        
        this._touch1 = touch;
        
        if (ZFMarketMenu.theMarket()._menuState != ZFMenu.menuStates.menuStateClosed)
        {
            return false;
        }
        
        if (ZFFarmerSelectionMenu.farmerSelectionMenu()._menuState != ZFMenu.menuStates.menuStateClosed)
        {
            return false;
        }
        
        if (this._touchState != this.TouchState.kTouchStateGrabbedMulti &&
            this._touchState != this.TouchState.kTouchStateUngrabbed)
        {
            return false;
        }
        
		if (ZFGuiLayer.gui().isAlertWindowOpen())
		{
		    return false;
		}
        
        this._touchState = this.TouchState.kTouchStateGrabbed;
        //CGPoint touchLocationScreen = [touch locationInView: [touch view]];
        var touchLocationScreen = touch.getPosition().clone();
        touchLocationScreen.setAll(touchLocationScreen._x, toScreenCY(touchLocationScreen._y));
        
        this._previousLocationOnScreen = touchLocationScreen.clone();
        //touchLocationScreen = [[CCDirector sharedDirector] convertToGL: touchLocationScreen];
        touchLocationScreen = ZFTileManager.scaleCompensation(touchLocationScreen.clone());
        var tool = ZFToolManager.toolManager()._tools[toolID];
        var toolSelectorRectScreen = tool._toolSelectorRectMap.clone();
        toolSelectorRectScreen.setOrigin(ccpAdd(toolSelectorRectScreen.getOrigin(), this._map.getPosition()));
        
        if (tool._state == ZFGameTool.kGameToolState.kGameToolStateSpriteDragging)
        {
            return true;
        }
        
        var p = [];
        var size = tool._tileSize;
        var w = size._width;
        var h = size._height;
        var tile = new Core.Rect(toolSelectorRectScreen.getOrigin()._x, toolSelectorRectScreen.getOrigin()._y, 48, 24);
        p[0] = new Core.Point(tile.getOrigin()._x + tile.getSize()._width / 2 * w, tile.getOrigin()._y);
        p[1] = new Core.Point(tile.getOrigin()._x, tile.getOrigin()._y + tile.getSize()._height / 2 * w);
        p[3] = new Core.Point(p[0]._x + tile.getSize()._width / 2 * h, tile.getOrigin()._y + tile.getSize()._height / 2 * h);
        p[2] = new Core.Point(tile.getOrigin()._x + tile.getSize()._width / 2 * h, p[1]._y + tile.getSize()._height / 2 * h);
        
        if (ZFTileManager.pointInPolygon(p, 4, touchLocationScreen))
        {
            tool._state = ZFGameTool.kGameToolState.kGameToolStateSpriteDragging;
        }
        
        switch (toolID)
        {
            case ZFToolManager.kGameTool.kGameToolPlace:
            case ZFToolManager.kGameTool.kGameToolMove:
                if (CGPointEqualToPoint(tool._originalTile, ccp(-1, -1))) //no tile selected to be moved
                {
                    break;
                }
                
                var tSprite = ZFTileManager.tSpriteFromTile(tool._toolTile);
//                console.log(tSprite);
                if (tSprite && this.isTouchingSprite(tSprite, touchLocationScreen))
                {
                    tool._state = ZFGameTool.kGameToolState.kGameToolStateSpriteDragging;
                }
                break;
            default:
                break;
        }
        
        return true;
    },
	
	ccTouchMoved: function(touch)
	{
		if (this._touchState == this.TouchState.kTouchStateGrabbedMulti)
		{
			if (touch.getId() == this._touch1.getId())
			{
				this._touch1 = touch;
			}
			else if (touch.getId() == this._touch2.getId())
			{
				this._touch2 = touch;
			}

			if(this._touch1 && this._touch2)//either one could be garbage at this point
			{
				var touchLocationScreen = this._touch1.getPosition().clone();
				touchLocationScreen.setAll(touchLocationScreen._x, toScreenCY(touchLocationScreen._y));
				
				var prevLocationOnScreen = this._touch2.getPosition().clone();
				prevLocationOnScreen.setAll(prevLocationOnScreen._x, toScreenCY(prevLocationOnScreen._y));
				
				var zoomAmount = ccpDistance(touchLocationScreen, prevLocationOnScreen);
				if (this._initialDistance)
				{
					zoomAmount = zoomAmount / this._initialDistance;
					zoomAmount *= this._originalScale._x;
					this.setZoomOutAmount(zoomAmount);
				}
			}
			
			return;
		}
		
//		if (this.isMenuBlockingFarm()) //no functionality if menu is blocking the touch
//		{
//			return;
//		}
		
//		// drag methods
//		CGPoint touchLocationOnScreen = [touch locationInView: [touch view]];
//		CGPoint prevLocationOnScreen = [touch previousLocationInView: [touch view]];
//		touchLocationOnScreen = [[CCDirector sharedDirector] convertToGL: touchLocationOnScreen];
//		prevLocationOnScreen = [[CCDirector sharedDirector] convertToGL: prevLocationOnScreen];
//		touchLocationOnScreen = [[ZFTileManager tileManager] scaleCompensation:touchLocationOnScreen];
//		prevLocationOnScreen = [[ZFTileManager tileManager] scaleCompensation:prevLocationOnScreen];
//		[self dragFrom:prevLocationOnScreen to:touchLocationOnScreen];
		
		var touchLocationScreen = touch.getPosition().clone();
		touchLocationScreen.setAll(touchLocationScreen._x, toScreenCY(touchLocationScreen._y));
		var tmpTouchLocationScreen = touchLocationScreen.clone();
		touchLocationScreen = ZFTileManager.scaleCompensation(touchLocationScreen.clone());
		this._previousLocationOnScreen = ZFTileManager.scaleCompensation(this._previousLocationOnScreen.clone());
		
		this.dragFrom(this._previousLocationOnScreen, touchLocationScreen);
		this._previousLocationOnScreen = tmpTouchLocationScreen;
	},
	
	ccTouchEnded: function(touch)
	{
		this._touches.splice(this._touches.indexOf(touch.getId()), 1);
		if (this._touchState == this.TouchState.kTouchStateGrabbedMulti || (this._touch1 && this._touch2))
		{
			if (this._touchState != this.TouchState.kTouchStateGrabbedMulti)
			{
				this._touch1 = null; 
				this._touch2 = null;
				this._touchState = this.TouchState.kTouchStateUngrabbed;
				return;
			}
			/*
			else if (this._touchState == this.TouchState.kTouchStateGrabbedMulti)
			{
				if (this._zoomFactor > 1.0)
				{
					this.runAction(CCScaleTo.actionWithDuration(0.2, 1.0));
				
					// FIXME: particles
					//for (Actor* actor in [ZFActorManager actorManager].actorList)
					//{
					//	for (ActorParticle *p in actor.particles)
					//	{
					//		p.particle.startSize = p.size;
					//		p.particle.startSizeVar = p.sizevar;
					//	}
					//}
				}
			}*/

			this._touches.length = 0;
			this._touchState = this.TouchState.kTouchStateGrabbed;
			return;
		}
		
		var tlm = ZFToolManager.toolManager();
		var tim = ZFTileManager;

		if (ZFMarketMenu.theMarket()._menuState != ZFMenu.menuStates.menuStateClosed)
		{
		    return;
		}
	
		touchState = this.TouchState.kTouchStateUngrabbed;
		var gui = ZFGuiLayer.gui();
		gui.hideEnemyMenu(null);
		
		// Ingore input if market is active Ingore input if alert is active
		if (this.isMenuBlockingFarm())
		{
			return;
		}
		
		if(this._slide)
		{
			this._slide = false;
			touch = this._initialTouch;
		}
		var touchLocationOnScreen = touch.getPosition().clone();
		touchLocationOnScreen.setAll(touchLocationOnScreen._x, toScreenCY(touchLocationOnScreen._y));
		touchLocationOnScreen = ZFTileManager.scaleCompensation(touchLocationOnScreen.clone());
//		touchLocationOnScreen = [[CCDirector sharedDirector] convertToGL: touchLocationOnScreen];
//		touchLocationOnScreen = [[ZFTileManager tileManager] scaleCompensation:touchLocationOnScreen];
		
		var mySprites = TSprite.allMySprites();
		ZFTileManager._pointLastClicked = touchLocationOnScreen.clone();
		var tool = tlm._tools[tlm._currentGameTool];
		if (tlm._currentGameTool != ZFToolManager.kGameTool.kGameToolPlow &&
			!(tlm._currentGameTool == ZFToolManager.kGameTool.kGameToolRotate && tool._state == ZFGameTool.kGameToolState.kGameToolStateSpriteDragging) &&
			!(tlm._currentGameTool == ZFToolManager.kGameTool.kGameToolMove && tool._state == ZFGameTool.kGameToolState.kGameToolStateSpriteDragging) &&
			!(tlm._currentGameTool == ZFToolManager.kGameTool.kGameToolPlace && tool._state == ZFGameTool.kGameToolState.kGameToolStateSpriteDragging))
		{
			//check touchable sprites like trees, etc.
			var player = ZFActorManager._player;
			var touchedSprites = [];

			// SHIKAKA : UNSELECTABLE SPRITES BUG
			for (var key in mySprites) 
			{
				var tSprite = mySprites[key];
				if (this.isTouchingSprite(tSprite ,touchLocationOnScreen))				
				{
					tim._selectedSprite = tSprite;
					if (tSprite._tile && tlm._currentGameTool != ZFGameTool.kGameToolState.kGameToolZombieCombiner) //is this a tile?
					{
						touchedSprites.push(tSprite);
					}					
					else if(tSprite._actor && tSprite._actor != player)
					{
						this.actorTapped(tSprite._actor);
						return;
					}
				}
			}
			
			var highestZSprite = null;
			for (var key in touchedSprites) 
			{
				var tSprite = touchedSprites[key];
				if (!highestZSprite || tSprite._sprite.getParent().getDepth() > highestZSprite._sprite.getParent().getDepth() )
				{
					highestZSprite = tSprite;
				}
			}

			// only reach this point if it's a tile
			if (highestZSprite)
			{
				var indexToRemove = touchedSprites.indexOf(highestZSprite);
				touchedSprites.splice(indexToRemove, 1);
				for (var key in touchedSprites) 
				{
					var tSprite = touchedSprites[key];
					// compare with other tiles only
					if(tSprite._tile && tSprite._sprite.getParent().getDepth() == highestZSprite._sprite.getParent().getDepth() && tSprite != highestZSprite)
					{
						// clicked an overlap area
						// check parent's (map) index of child object (the sprite manager) to see which one is being drawn on top 
					
						// this is the array of children of the map
						var childArray = tSprite._sprite.getParent().getParent()._children;
						
						var tSpriteIndex = childArray.indexOf(tSprite._sprite.getParent());
						var highestZSpriteIndex = childArray.indexOf(highestZSprite._sprite.getParent());
						
						if(tSpriteIndex > highestZSpriteIndex)
						{
							highestZSprite = tSprite;
						}
					}
				}
				//check if touch was actually on the sprite, if not, don't consider it tapped
				if(this.isOnSprite(highestZSprite, touchLocationOnScreen))
				{
					this.tileTapped(highestZSprite._tile._rootTile);
					return;
				}
				return;	//the touch was not on the sprite
			}
		}
		
		//check floor tiles
		var tileTouched = tim.tileFromScreenPoint(touchLocationOnScreen, false);
		if(!CGPointEqualToPoint(tileTouched, ccp(-1,-1)))
		{
			this.tileTapped(tileTouched);
			return;
		}
	},
	
	dragFrom: function(prevLocationOnScreen, touchLocationOnScreen)
	{
		var touchLocationScreen = this._initialTouch.getPosition().clone();
		touchLocationScreen.setAll(touchLocationScreen._x, toScreenCY(touchLocationScreen._y));
		var initialTouchLocation = ZFTileManager.scaleCompensation(touchLocationScreen.clone());
		
		if (this._initialTouchTime != null && ccpDistance (initialTouchLocation, touchLocationOnScreen) < 10 && (Core.Time.getRealTime() - this._initialTouchTime< 100) )
		{
			this._slide =true;
			return;
		}
		var tom = ZFToolManager.toolManager();
		var diff = new Core.Point(touchLocationOnScreen._x - prevLocationOnScreen._x, touchLocationOnScreen._y - prevLocationOnScreen._y);
		
		var touchLocationOnMap = ccpSub(touchLocationOnScreen, this._map.getPosition());
		var toolID = tom._currentGameTool;
		var tool = tom._tools[toolID];
		
		if (tool._state == ZFGameTool.kGameToolState.kGameToolStateSpriteDragging)
		{
			touchLocationOnMap = ccp(touchLocationOnMap._x, touchLocationOnMap._y + 35);
			tom.placeToolOnNearestTileToPointOnMap(touchLocationOnMap, tom._currentGameTool);
			return;
		}
		
		if(toolID == ZFToolManager.kGameTool.kGameToolMulti || toolID == ZFToolManager.kGameTool.kGameToolPlant || toolID == ZFToolManager.kGameTool.kGameToolDelete)
		{
			//if we are scrolling the map consider it as dragging
			tool._state = ZFGameTool.kGameToolState.kGameToolStateMapScrolling;
		}
		
		//scroll map
		var newPosition = new Core.Point(this._map.getPosition()._x + diff._x, this._map.getPosition()._y + diff._y);
		this._map.setPosition(newPosition);
		this.keepMapInBounds();	
	},

	keepMapInBounds: function()
	{		
		var screenSize = CCDirector.winSize();
		var widthOffset = (screenSize._width)/2;
		var heightOffset = (screenSize._height)/2;
		var newPosition = this._map.getPosition().clone();
		var horizontalLimit = ((this._map._tileSize._width * this._map._mapSize._width));
		var verticalLimit = ((this._map._tileSize._height * this._map._mapSize._height));
				
		var lowerX = widthOffset - horizontalLimit;
		if (newPosition._x < lowerX)
		{ 
			newPosition.setX(lowerX);
		}
		
		var upperX = widthOffset;
		if (newPosition._x > upperX)
		{ 
			newPosition.setX(upperX);
		}
		
		var lowerY = heightOffset/2 - verticalLimit;
		if (newPosition._y < lowerY)
		{ 
			newPosition.setY(lowerY);
		}
		
		var upperY = heightOffset;
		if (newPosition._y > upperY)
		{ 
			newPosition.setY(upperY);
		}
		
		this._map.setPosition(newPosition);
	},

	setZoomOutAmount: function(zoomAmount)
	{	
//		var zoomInMax = ZFGameDefines.ZOOM_MAX_VALUE;
//		var zoomOutMax = ZFGameDefines.ZOOM_MIN_VALUE;
//		var screenSize = CCDirector.winSize();
//		if (screenSize._width > 480)
//		{
//			zoomInMax = 2.0;
//			zoomOutMax = 0.9 - (this._map._mapSize._width * 0.01);	//just enough to keep whole map within screen for iPad
//		}
		
//		zoomOutMax = 0.9;
		// this scales it out so the whole height of the tilemap is in the screen
		zoomAmount = Math.abs(zoomAmount);
		zoomAmount = zoomAmount < this._zoomOutMax ? this._zoomOutMax : zoomAmount;
		zoomAmount = zoomAmount > this._zoomInMax ? this._zoomInMax : zoomAmount;
		this._zoomFactor = zoomAmount;
//		console.log("Set scale with " + zoomAmount);
		this.setScale(new Core.Vector(zoomAmount, zoomAmount));
//		this.setScale(zoomAmount, zoomAmount, true);
		this.setPosition(new Core.Point((this.getContentSize()._width - this.getContentSize()._width * this.getScale()._x) / 2,
				(this.getContentSize()._height - this.getContentSize()._height * this.getScale()._x) / 2));

		//TODO proper zooming
//		if ([self numberOfRunningActions] == 0)
//		{
//			//NSLog(@"scale: %f, %f", zoomAmount, map.mapSize.width);
//			zoomFactor = zoomAmount;
//			[self runAction:[CCScaleTo actionWithDuration:ZOOM_OUT_RATE scale:zoomAmount]];
//			
//			for (Actor* actor in [ZFActorManager actorManager].actorList)
//			{
//				//TODO
//				for (ActorParticle *p in actor.particles)
//				{
//					p.particle.startSize = p.size * zoomAmount;
//					p.particle.startSizeVar = p.sizevar * zoomAmount;
//				}
//			}
//		}
	},

	isTouchingSprite: function(tSprite, touchLocationScreen)
	{
		if (tSprite._actor)
		{				
			var spriteRectScreen = tSprite.rect();
			spriteRectScreen.setOrigin(ccpAdd(spriteRectScreen.getOrigin(), this._map.getPosition()));
			
			if (CGRectContainsPoint(spriteRectScreen, touchLocationScreen))
			{
				return true;
			}
				
			return false;
		}
		
		var spriteRectScreen = tSprite.rect();
		spriteRectScreen.setOrigin(ccpAdd(spriteRectScreen.getOrigin(), this._map.getPosition()));
		if (CGRectContainsPoint(spriteRectScreen, touchLocationScreen))
		{
			var touchLocationInSprite = ccpSub(touchLocationScreen, spriteRectScreen.getOrigin());
			if (tSprite.isPixelOpaqueAt(touchLocationInSprite))
			{
				return true;
			}
		}
		else 
		{
			//touch was off the map
			var tim = ZFTileManager;
			var tileCoordinates = tim.tileFromScreenPoint(touchLocationScreen, true);
			
			if(CGPointEqualToPoint(tSprite._tile._rootTile, tileCoordinates))
			{
				return true;
			}
		}
		
		return false;
	},
	
	isOnSprite: function(tSprite, touchLocationScreen)
	{
		var spriteRectScreen = tSprite.rect();
		spriteRectScreen.setOrigin(ccpAdd(spriteRectScreen.getOrigin(), this._map.getPosition()));
		
		if (CGRectContainsPoint(spriteRectScreen, touchLocationScreen))
		{
			//check to see if the pixel touched was transparent		
			var touchLocationInSprite = ccpSub(touchLocationScreen, spriteRectScreen.getOrigin());

			if (tSprite.isPixelOpaqueAt(touchLocationInSprite))
			{	
				return true;
			}
		}		
		return false;
	},

	tileTapped: function(tileCoordinates)
	{
		var gui = ZFGuiLayer.gui();
		
		if (gui.isScheduled(gui.removeToolTipIn))
		{
			gui.removeToolTip();
		}
		
		ZFToolManager.toolManager().onTileClickUp(tileCoordinates, ZFToolManager.toolManager()._currentGameTool);
		// if tsprite not selected and tsprite exists at tile
	},
	
	actorTapped: function(actor)
	{
		var gui = ZFGuiLayer.gui();
		
		if (gui.isScheduled(gui.removeToolTipIn))
		{
			gui.removeToolTip();
		}
		
//		[[ZFToolManager toolManager] onActorClickUp:actor forTool:[[ZFToolManager toolManager] currentGameTool]];
		ZFToolManager.toolManager().onActorClickUp(actor, ZFToolManager.toolManager()._currentGameTool);
	},

	isMenuBlockingFarm: function()
	{
	    //var menuIsBlockingFarm = false;
		if (ZFMarketMenu.theMarket()._menuState != ZFMenu.menuStates.menuStateClosed) return true;
		if (ZFStorageMenu._menuState != ZFMenu.menuStates.menuStateClosed) return true;
		if (ZFZombieMenu._menuState != ZFMenu.menuStates.menuStateClosed) return true;
		if (ZFZombieSelectionMenu._menuState != ZFMenu.menuStates.menuStateClosed) return true;
		if (ZFFarmerSelectionMenu._menuState != ZFMenu.menuStates.menuStateClosed) return true;
		if (ZFMausoleumMenu._menuState != ZFMenu.menuStates.menuStateClosed) return true;
		if (ZFGuiLayer.gui()._inGameMenu._menuState != ZFMenu.menuStates.menuStateClosed) return true;
		if (ZFGuiLayer.gui().isAlertWindowOpen()) return true;
		if (ZFQuestMenu._menuState != ZFMenu.menuStates.menuStateClosed) return true;
		if (ZFMutationMenu._menuState != ZFMenu.menuStates.menuStateClosed) return true;
		
		return false;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/GuiLayer/ZFSelectorLayer'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/GuiLayer/ZFSelectorLayer'] || {}; $MODULE_REGISTRY['Code/Game/GUI/GuiLayer/ZFSelectorLayer'] = exports; //var ZFToolManager = require('../../Tools/ZFToolManager').ZFToolManager;
//var ZFTileManager = require('../../Tiles/ZFTileManager').ZFTileManager;
var ZFGameTool = require('Code/Game/Tools/ZFGameTool').ZFGameTool;

exports.ZFSelectorLayer = CCLayer.subclass({
	classname : 'ZFSelectorLayer',

	kTag : {
		kTagLabel : 1,
		//kTagSpriteManager,
		kTagSelectedSprite : 2,
	},

	initialize : function() {
		this.scheduleDraw();
		this._primitives = [];
	},

	onEnter: function($super) {
		$super();
//		prims.length = 0;
//		this._primitives = null;
//		this._primitives = [];
		this.scheduleDraw();
	},
	
//	cleanup : function($super)
//	{	
//		for ( var i = prims.length - 1; i > -1; i--) {
//			prims[i].destroy();
//			prims.splice(i, 1);
//		}
//		this._primitives.length = 0;
//		this._primitives = null;
//		$super();
//	},
	
	draw : function() {
		var toolID = ZFToolManager._currentGameTool;

		var prims = this._primitives;
		for ( var i = prims.length - 1; i > -1; i--) {
			// if the primitive wasn't visible in the last frame, then remove it.
			if (!prims[i].getVisible()) {
				prims[i].destroy();
				prims.splice(i, 1);
			} else {
				prims[i].setVisible(false);
			}
		}

		//ACTION
		if (ZFToolManager._gameActionQueue.length > 0) {
			for ( var index in ZFToolManager._gameActionQueue) {
				var action = ZFToolManager._gameActionQueue[index];
				//			glColor4ub(0x00, 0xFF/5 ,0x00, 0x80);
				//			this.drawDiamond(action._rect, ccc3(0x00, 0xFF/5 ,0x00), 0x80); 
				//			glColor4ub(0x00, 0xFF/10 ,0x00, 0x80);
				this.drawDiamondFilled(action._rect, ccc3(0x00, 0xFF / 7, 0x00), 0x80);
			}
		}

		//TOOLS
		if (toolID != ZFToolManager.kGameTool.kGameToolNone) {
			var toolID = ZFToolManager._currentGameTool;
			var tool = ZFToolManager._tools[toolID];

			var toolSelectorRect = tool._toolSelectorRectMap;

			var color = tool._toolColor;
			//			glLineWidth(3);
			//			glColor4ub(color.r, color.g ,color.b, 0x80);

			switch (toolID) {
			case ZFToolManager.kGameTool.kGameToolPlow:
			case ZFToolManager.kGameTool.kGameToolMove:
			case ZFToolManager.kGameTool.kGameToolRotate:
			case ZFToolManager.kGameTool.kGameToolPlace: {
				//					console.log("draw selector layer tool " + toolID + " tool rect = " + stringFromRect(tool._toolSelectorRectMap));					
				if (!CGRectEqualToRect(new Core.Rect(0, 0, 0, 0), tool._toolSelectorRectMap)) {
					//						console.log("draw selector layer tool " + toolID);	

					//RECT
					if (tool._tileSize._width != tool._tileSize._height) {
						if (tool._originalTile._x != -1) {
							var tim = ZFTileManager;
							var tileProperties = tim.tilePropertiesFromPoint(tool._originalTile);
							var tileWidth = tileProperties["tileWidth"];
							var tileHeight = tileProperties["tileHeight"];
							var usesSeparateRotateSprite = tileProperties["usesSeparateRotateSprite"];
							if (tool._spriteOrientation == 1 && !usesSeparateRotateSprite) {
								tool._tileSize = new Core.Size(tileHeight, tileWidth);
							}

						}
						//FIXME: This has to draw the frame on the farm
						//this.drawDiamondTile(new Core.Rect(toolSelectorRect.getOrigin()._x, toolSelectorRect.getOrigin()._y, 48, 24), tool._tileSize._height, tool._tileSize._width);

					} else {
//						this.drawDiamond(toolSelectorRect, ccc3(color.getRed()*255/3,color.getGreen()*255/3,color.getBlue()*255/3), 0x80);
						this.drawDiamondFilled(toolSelectorRect, ccc3(color.getRed()*255/3,color.getGreen()*255/3,color.getBlue()*255/3), 0xff/2);

					}

					// SPRITE
					if (tool._spriteNode) {
						tool._spriteNode.setPosition(ZFTileManager.mapPointFromTile(tool._toolTile));
						for ( var key in tool._spriteNode._children) {
							var c = tool._spriteNode._children[key];
							c.setOpacity(0xFF);
						}
					} else if (tool._sprite) {
						var color = tool._sprite.getColor();
						tool._sprite.setPosition(ZFTileManager.mapPointFromTile(tool._toolTile));
						tool._sprite.setOpacity(0xFF);
						tool._sprite.setColor(color);
					}
				}
			}
				break;

			case ZFToolManager.kGameTool.kGameToolPlant: {
			}
				break;
			default:
				break;
			}
		}

		//		//uncomment to see touch area for actors
		//		/*for(TSprite *s in [TSprite allMySprites])
		//		{
		//			if(s.actor)
		//			{
		//				[self drawRect:s.rect R:0xFF G:0 B:0 A:0XFF];
		//			}
		//		}*/
		//		
		//		//selected tile shape
		//		/*rect = selectedTileRect;
		//		 CGSize size = [[ZFTileManager tileManager] selectedTileDimensions];
		//		 rect.origin.x += [map position].x - ((size.width - 1) * rect.size.width)/2;
		//		 rect.origin.y += [map position].y;
		//		 rect.size.width *= size.width;
		//		 rect.size.height *= size.height;
		//		 [self drawDebugDiamond:rect R:0 G:255 B:0 A:255];*/
		//		
		//		//shows all selectable sprites and displays collision maps
		//		//NSArray * mySprites = [TSprite allMySprites];
		////		NSUInteger i, count = [mySprites count];
		////		 
		////		for (i = 0; i < count; i++) 
		////		{
		////			TSprite *tSprite = (TSprite *)[mySprites objectAtIndex:i];
		////			{
		////				[self drawOutline:tSprite];
		////			}
		////			
		////			CGRect rect = [tSprite rect];
		////			[self drawRect:rect R:0 G:255 B:0 A:128];
		////		}
		//		
		//		//point last clicked... do a particle effect here
		//		/*glColor4ub(0,255,225,255);
		//		 glPointSize(3);
		//		 CGPoint lastClicked  = pointLastClicked;
		//		 lastClicked.x += [map position].x;
		//		 lastClicked.y += [map position].y;
		//		 drawPoint(lastClicked);*/
		//		
		//		//selected sprite boundary
		//		/*rect = selectedSpriteRect;
		//		 rect.origin.x += [map position].x;
		//		 rect.origin.y += [map position].y;
		//		 [self drawRect:rect R:255 G:0 B:0 A:128];*/
		//		
		//		glDisable(GL_POINT_SMOOTH);
		//		glDisable(GL_LINE_SMOOTH);
	},

	drawRect : function(rect, r, g, b, a) {
//		console.log("@@@@@@@@@@@ draw rect");
		//		CGPoint p[4];
		//		glColor4ub(r,g,b,a);
		//		p[0] = rect.origin;
		//		p[1] = CGPointMake(rect.origin.x + rect.size.width, rect.origin.y);
		//		p[2] = CGPointMake(rect.origin.x + rect.size.width, rect.origin.y + rect.size.height);
		//		p[3] = CGPointMake(rect.origin.x, rect.origin.y +  rect.size.height);
		//		ccDrawPoly( p, 4, YES);
	},

	drawDiamondTile : function(tile, w, h) {
//		console.log("@@@@@@@@@@@ draw diamond tile");
		// tile = width:48 height:24
		// p0 = bottom side
		// p1 = left side
		// p3 = right side
		// p2 = top side

		//		CGPoint p[4];
		//		p[0] = CGPointMake(tile.origin.x + tile.size.width/2 * w, tile.origin.y);
		//		p[1] = CGPointMake(tile.origin.x						, tile.origin.y + tile.size.height/2 * w);
		//		p[3] = CGPointMake(p[0].x + tile.size.width/2 * h		, tile.origin.y + tile.size.height/2 * h);
		//		p[2] = CGPointMake(tile.origin.x + tile.size.width/2 * h, p[1].y + tile.size.height/2 * h);
		//		ccDrawPoly( p, 4, YES);	
		
		var prim = this._getFreePrimitive();

		//		if(!CGRectEqualToRect(rect, this._zeroRect))
		//		{
		//			this._zeroRect = rect;
		var tmpRect = new Core.Rect(tile.getOrigin(), tile.getSize());
		tmpRect.getOrigin().setY(toMY(tmpRect.getOrigin()._y) - tmpRect.getSize()._height);

		//	        var c = ccc3(color.getRed()*255/10, color.getGreen()*255/10, color.getBlue()*255/10)
		var p = [];
		
		p[0] = new Core.Point(tmpRect.getOrigin()._x + tmpRect.getSize()._width / 2 * w, tmpRect.getOrigin()._y);
		p[1] = new Core.Point(tmpRect.getOrigin()._x, tmpRect.getOrigin()._y + tmpRect.getSize()._height / 2 * w);
		p[3] = new Core.Point(p[0]._x + tmpRect.getSize()._width/2 * h, tmpRect.getOrigin()._y + tmpRect.getSize()._height / 2 * h);
		p[2] = new Core.Point(tmpRect.getOrigin()._x + tmpRect.getSize()._width / 2 * h, p[1]._y + tmpRect.getSize()._height / 2 * h);
//		p[0] = new Core.Point(tmpRect.getOrigin()._x, tmpRect.getOrigin()._y + tmpRect.getSize()._height / 2);
//		p[1] = new Core.Point(tmpRect.getOrigin()._x + tmpRect.getSize()._width / 2, tmpRect.getOrigin()._y);
//		p[2] = new Core.Point(tmpRect.getOrigin()._x + tmpRect.getSize()._width, tmpRect.getOrigin()._y + tmpRect.getSize()._height / 2);
//		p[3] = new Core.Point(tmpRect.getOrigin()._x + tmpRect.getSize()._width / 2, tmpRect.getOrigin()._y + tmpRect.getSize()._height);
		var t1 = [];
		t1[0] = (new GL2.Primitive.Vertex(p[0]));
		t1[1] = (new GL2.Primitive.Vertex(p[1]));
		t1[2] = (new GL2.Primitive.Vertex(p[2]));
		var t2 = [];
		t2[0] = (new GL2.Primitive.Vertex(p[0]));
		t2[1] = (new GL2.Primitive.Vertex(p[2]));
		t2[2] = (new GL2.Primitive.Vertex(p[3]));

		prim.spliceVertexes.apply(prim, ([ 0, prim.getVertexCount() ]).concat(t1).concat(t2));
		//			console.log("primitive vertex count = " +  this._primitive.getVertexCount());
		prim.setType(GL2.Primitive.Type.Triangles);

		if (this._children.indexOf(prim) < 0) {
			this.addChild(prim);
		}

		//	        console.log("children len = " + this._children.length);
		//		}
		prim.setVisible(true);
		prim.setColor(1,1,1);//ccc3(color.getRed() * 255 / 10, color.getGreen() * 255 / 10, color.getBlue() * 255 / 10)
		prim.setAlpha(1);
	},

	drawDiamond : function(rect, color, opacity) {
		var prim = this._getFreePrimitive();
		prim.setType(GL2.Primitive.Type.LineList);
		rect.getOrigin().setY(toMY(rect.getOrigin()._y) - rect.getSize()._height);
		var p = [];
		
		//1st line
		p[0] = (new GL2.Primitive.Vertex(CGPointMake(rect.getOrigin()._x, rect.getOrigin()._y + rect.getSize()._height / 2), [ 0, 0 ], color));
		p[1] = (new GL2.Primitive.Vertex(CGPointMake(rect.getOrigin()._x + rect.getSize()._width / 2, rect.getOrigin()._y), [ 0, 0 ], color));
		//2nd line
		p[2] = (new GL2.Primitive.Vertex(CGPointMake(rect.getOrigin()._x + rect.getSize()._width / 2, rect.getOrigin()._y), [ 0, 0 ], color));
		p[3] = (new GL2.Primitive.Vertex(CGPointMake(rect.getOrigin()._x + rect.getSize()._width, rect.getOrigin()._y + rect.getSize()._height / 2), [ 0, 0 ], color));
		//3rd line
		p[4] = (new GL2.Primitive.Vertex(CGPointMake(rect.getOrigin()._x + rect.getSize()._width, rect.getOrigin()._y + rect.getSize()._height / 2), [ 0, 0 ], color));
		p[5] = (new GL2.Primitive.Vertex(CGPointMake(rect.getOrigin()._x + rect.getSize()._width / 2, rect.getOrigin()._y + rect.getSize()._height), [ 0, 0 ], color));
		//4th line
		p[6] = (new GL2.Primitive.Vertex(CGPointMake(rect.getOrigin()._x + rect.getSize()._width / 2, rect.getOrigin()._y + rect.getSize()._height), [ 0, 0 ], color));
		p[7] = (new GL2.Primitive.Vertex(CGPointMake(rect.getOrigin()._x, rect.getOrigin()._y + rect.getSize()._height / 2), [ 0, 0 ], color));

		prim.spliceVertexes.apply(prim, ([ 0, prim.getVertexCount() ]).concat(p));

		if (this._children.indexOf(prim) < 0) {
			this.addChild(prim);
		}

		prim.setVisible(true);
		prim.setColor(color);
		prim.setAlpha(1);
	},

	drawDiamondFilled : function(rect, color, opacity) {
		//		console.log("@@@@@@@@@@@ draw diamond filled for rect = " + stringFromRect(rect));

		//		var rect = new Core.Rect(624, -384 - 96, 192, 96);

		var prim = this._getFreePrimitive();

		//		if(!CGRectEqualToRect(rect, this._zeroRect))
		//		{
		//			this._zeroRect = rect;
		var tmpRect = new Core.Rect(rect.getOrigin(), rect.getSize());
		tmpRect.getOrigin().setY(toMY(tmpRect.getOrigin()._y) - tmpRect.getSize()._height);

		//	        var c = ccc3(color.getRed()*255/10, color.getGreen()*255/10, color.getBlue()*255/10)
		var p = [];
		p[0] = new Core.Point(tmpRect.getOrigin()._x, tmpRect.getOrigin()._y + tmpRect.getSize()._height / 2);
		p[1] = new Core.Point(tmpRect.getOrigin()._x + tmpRect.getSize()._width / 2, tmpRect.getOrigin()._y);
		p[2] = new Core.Point(tmpRect.getOrigin()._x + tmpRect.getSize()._width, tmpRect.getOrigin()._y + tmpRect.getSize()._height / 2);
		p[3] = new Core.Point(tmpRect.getOrigin()._x + tmpRect.getSize()._width / 2, tmpRect.getOrigin()._y + tmpRect.getSize()._height);
		var t1 = [];
		t1[0] = (new GL2.Primitive.Vertex(p[0]));
		t1[1] = (new GL2.Primitive.Vertex(p[1]));
		t1[2] = (new GL2.Primitive.Vertex(p[2]));
		var t2 = [];
		t2[0] = (new GL2.Primitive.Vertex(p[0]));
		t2[1] = (new GL2.Primitive.Vertex(p[2]));
		t2[2] = (new GL2.Primitive.Vertex(p[3]));

		prim.spliceVertexes.apply(prim, ([ 0, prim.getVertexCount() ]).concat(t1).concat(t2));
		//			console.log("primitive vertex count = " +  this._primitive.getVertexCount());
		prim.setType(GL2.Primitive.Type.Triangles);

		if (this._children.indexOf(prim) < 0) {
			this.addChild(prim);
		}

		//	        console.log("children len = " + this._children.length);
		//		}
		prim.setVisible(true);
		prim.setColor(color);//ccc3(color.getRed() * 255 / 10, color.getGreen() * 255 / 10, color.getBlue() * 255 / 10)
		prim.setAlpha(opacity / 255);
	},

	drawOutline : function(spriteToOutline) {
//		console.log("@@@@@@@@@@@ draw outline");
//		//		return;
//		//		
////				glColor4ub(0xFF,0xB0,0x3A,0xFF);
//				var pointSize = 1;
//				//CGRect selectedSpriteRect = [spriteToOutline rect];
//				var spriteDim = spriteToOutline.sprite.textureRect;
//				CGPoint mapPosition = selectedSpriteRect.origin;
//				glPointSize(pointSize);
//				if(!spriteToOutline.collisionMap)
//					return;
//				
//				for(int i=0; i < spriteDim.size.height; i++)
//				{
//					for(int j=0; j < spriteDim.size.width; j++)
//					{
//						if(spriteToOutline.collisionMap[ i*(int)(spriteDim.size.width) + j])
//						{
//							ccDrawPoint(ccp(mapPosition.x + j, mapPosition.y + spriteDim.size.height - i));
//						}
//					}
//				}
	},

	_getFreePrimitive : function() {
		var prims = this._primitives;
		for ( var i in prims) {
			if (!prims[i].getVisible()) {
				return prims[i];
			}
		}
		var prim = new GL2.Primitive();
		prims.push(prim);
		return prim;
	}

});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCTMXTiledMap'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCTMXTiledMap'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCTMXTiledMap'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var CCNode = require('Code/Cocos2D/CCNode').CCNode;
var CCTMXMapInfo = require('Code/Cocos2D/CCTMXMapInfo').CCTMXMapInfo;
var CCTMXLayer = require('Code/Cocos2D/CCTMXLayer').CCTMXLayer;

exports.CCTMXTiledMap = CCNode.subclass(
{
	classname: 'CCTMXTiledMap',
		
	initialize: function(filename, cb)
	{	
	//	console.log("CCTMXTiledMap initialize + CCTMXMapInfo = " + CCTMXMapInfo.CCTMXOrientation.CCTMXOrientationOrtho);
		
//		CCTMXMapInfo *mapInfo = [CCTMXMapInfo formatWithTMXFile:tmxFile];
		this._cb = cb;
		this._mapInfo = new CCTMXMapInfo(filename,this.initWithTMXFile.bind(this));
		
		

		//		mapSize_ = mapInfo.mapSize;
		//this._mapSize = mapInfo._mapSize;


//		tileSize_ = mapInfo.tileSize;
//		mapOrientation_ = mapInfo.orientation;
//		objectGroups_ = [mapInfo.objectGroups retain];
//		properties_ = [mapInfo.properties retain];
//		tileProperties_ = [mapInfo.tileProperties retain];
//				
//		int idx=0;
//
//		for( CCTMXLayerInfo *layerInfo in mapInfo.layers ) {
//			
//			if( layerInfo.visible ) {
//				id child = [self parseLayer:layerInfo map:mapInfo];
//				[self addChild:child z:idx tag:idx];
//				
//				// update content size with the max size
//				CGSize childSize = [child contentSize];
//				CGSize currentSize = [self contentSize];
//				currentSize.width = MAX( currentSize.width, childSize.width );
//				currentSize.height = MAX( currentSize.height, childSize.height );
//				[self setContentSize:currentSize];
//	
//				idx++;
//			}			
//		}		
	},
	
	initWithTMXFile:function()
	{
		this._mapSize = this._mapInfo._mapSize;
//		console.log("map size = " + this._mapSize._width + ", " + this._mapSize._height);
		this._tileSize = this._mapInfo._tileSize;
		this._mapOrientation = this._mapInfo._orientation;
		this._objectGroups = this._mapInfo._objectGroups;
		this._properties = this._mapInfo._properties;
		this._tileProperties = this._mapInfo._tileProperties;
		
		var idx = 0;
		
		for (var key in this._mapInfo._layers)
		{
			var layerInfo = this._mapInfo._layers[key];
			if(layerInfo._visible)
			{
				var child = this.parseLayer(layerInfo, this._mapInfo);
//				console.log("add child to tiled map children len" + child._children.length);
				
				var tmpPos = child.getPosition();
//				console.log("child position = " + tmpPos._x + ", " + tmpPos._y);
				
				this.addChild(child, idx, idx);
				

				// update content size with the max size
				var childSize = child._contentSize;
				var currentSize = this._contentSize;
				currentSize.setWidth(Math.max(currentSize._width, childSize._width));
				currentSize.setHeight(Math.max(currentSize._height, childSize._height));
				this.setContentSize(currentSize);
				idx++;
			}
		}
	

		this._cb();
	},
	
	parseLayer:function(layerInfo, mapInfo)
	{
		var tileset = this.tilesetForLayer(layerInfo, mapInfo);
		var layer = new CCTMXLayer(tileset, layerInfo, mapInfo);
//	

		layer.setupTiles();
		
//		console.log("setup tiles children len = " + layer._children.length);
		return layer;
	},
	
	tilesetForLayer:function(layerInfo, mapInfo)
	{
		var tileset = null;
		var size = layerInfo._layerSize;
		for(var i = mapInfo._tilesets.length - 1; i >= 0; i--)
		{

			var tmpTileset = mapInfo._tilesets[i];
			for(var y  = 0; y < size._height; y++)
			{
				for(var x = 0; x < size._width; x++)
				{
					var pos = x + size._width * y;
					var gid = layerInfo._tiles[pos];
					if(gid != 0)
					{
						if( gid >= tmpTileset._firstGid )
							return tmpTileset;	
					}
				}
			}
		}
		return tileset;
	},
	
		layerNamed: function(layerName)
	{
//	for( CCTMXLayer *layer in children_ ) {
//		if([layer isKindOfClass:[CCTMXLayer class]]){
//			if( [layer.layerName isEqual:layerName] )
//				return layer;
//		}
//	}
//		console.log("children name len = " + this._children.length + " | " + layerName);
		for(var key in this._children)
		{
			var layer = this._children[key];		
//			console.log("layer classsname = " + layer.classname);
			if(layer.classname == "CCTMXLayer")
			{
				if(layer._layerName == layerName)
				{
//					console.log("return layer = " + layer._layerName);
					return layer;
				}
			}
		}
		
		// layer not found
		return null;	
	},
	
//	-(CCTMXLayer*) layerNamed:(NSString *)layerName 
//{
//	for( CCTMXLayer *layer in children_ ) {
//		if([layer isKindOfClass:[CCTMXLayer class]]){
//			if( [layer.layerName isEqual:layerName] )
//				return layer;
//		}
//	}
//	
//	// layer not found
//	return nil;
//}

	

	
	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCTMXMapInfo'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCTMXMapInfo'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCTMXMapInfo'] = exports; var Core = require('NGCore/Client/Core').Core;
var Storage = require('NGCore/Client/Storage').Storage;
var CCTMXTiledMap = require('Code/Cocos2D/CCTMXTiledMap').CCTMXTiledMap;
var CCTMXTilesetInfo = require('Code/Cocos2D/CCTMXTilesetInfo').CCTMXTilesetInfo;
var CCTMXLayerInfo = require('Code/Cocos2D/CCTMXLayerInfo').CCTMXLayerInfo;
//var CCTMXMapInfoEnums = Core.Class.subclass(
//{
//	TMXLayerAttrib :
//	{
//		TMXLayerAttribNone : (1 << 0),
//		TMXLayerAttribBase64 : (1 << 1),
//		TMXLayerAttribGzip : (1 << 2),
//	},
//
//	TMXProperty :
//	{
//		TMXPropertyNone: {},
//		TMXPropertyMap: {},
//		TMXPropertyLayer: {},
//		TMXPropertyObjectGroup: {},
//		TMXPropertyObject: {},
//		TMXPropertyTile: {},
//	},
//});

exports.CCTMXMapInfo = Core.Class.subclass(
{
	classname: 'CCTMXMapInfo',
	
	TMXLayerAttrib :
	{
		TMXLayerAttribNone : (1 << 0),
		TMXLayerAttribBase64 : (1 << 1),
		TMXLayerAttribGzip : (1 << 2),
	},

	TMXProperty :
	{
		TMXPropertyNone: {},
		TMXPropertyMap: {},
		TMXPropertyLayer: {},
		TMXPropertyObjectGroup: {},
		TMXPropertyObject: {},
		TMXPropertyTile: {},
	},
	
	CCTMXOrientation:
	{
		CCTMXOrientationOrtho:{},
		CCTMXOrientationHex:{},
		CCTMXOrientationIso:{},
	},	


	
	initialize: function(filename, cb)
	{
//		console.log("CCTMXMapInfo initialize");
//		self.tilesets = [NSMutableArray arrayWithCapacity:4];
		this._tilesets = new Array();
//		self.layers = [NSMutableArray arrayWithCapacity:4];
		this._layers = new Array();
//		self.filename = [CCFileUtils fullPathFromRelativePath:tmxFile];
		this._filename = filename;
//		self.objectGroups = [NSMutableArray arrayWithCapacity:4];
		this._objectGroups = new Array();
//		self.properties = [NSMutableDictionary dictionaryWithCapacity:5];
//		this._properties = new Object;
//		self.tileProperties = [NSMutableDictionary dictionaryWithCapacity:5];
//		this._tileProperties = new Object;
		
//		// tmp vars
//		currentString = [[NSMutableString alloc] initWithCapacity:1024];
		this._currentString = "";
//		storingCharacters = NO;
		this._storingCharacters = false;
//		layerAttribs = TMXLayerAttribNone;
		this._layerAttribs = this.TMXLayerAttrib.TMXLayerAttribNone;
		
//		parentElement = TMXPropertyNone;
		this._parentElement = this.TMXProperty.TMXPropertyNone;
//		
//		[self parseXMLFile:filename_];		
//		console.log("parse this file = " + this._filename);
		
		this.parseXMLFile(this._filename, cb);		
	},
	
	parseXMLFile: function(filename, cb)
	{
		var self = this;
		var tileSetInfo = new CCTMXTilesetInfo();
	    Storage.FileSystem.readFile(filename, false, 
	    function(err, file)
   		{
//        	console.log("Callback self = " + self);
        	
        	var utf8 = {}

			utf8.toByteArray = function(str) {
			    var byteArray = [];
			    for (var i = 0; i < str.length; i++)
			        if (str.charCodeAt(i) <= 0x7F)
			            byteArray.push(str.charCodeAt(i));
			        else {
			            var h = encodeURIComponent(str.charAt(i)).substr(1).split('%');
			            for (var j = 0; j < h.length; j++)
			                byteArray.push(parseInt(h[j], 16));
			        }
			    return byteArray;
			};
			
			utf8.parse = function(byteArray) {
			    var str = '';
			    for (var i = 0; i < byteArray.length; i++)
			        str +=  byteArray[i] <= 0x7F?
			                byteArray[i] === 0x25 ? "%25" : // %
			                String.fromCharCode(byteArray[i]) :
			                "%" + byteArray[i].toString(16).toUpperCase();
			    return decodeURIComponent(str);
			};
			
			utf8.getUIntAt = function( arr, offs ) {
			 return (arr[offs+3] << 24) +
			         (arr[offs+2] << 16) +
			         (arr[offs+1] << 8) +
			          arr[offs+0] >>> 0;}


        	
	        if(err)
	        {
	            console.log("Error == " + err);
	        }
	        else
	        {
//	            console.log("File = " + file);
	            var jsonfile = eval('(' + file + ')');
	            
	            //parse the json file
	            if(jsonfile.map)
	            {
//	            	this.parseJSONFile(jsonfile);
					if( jsonfile.map.orientation == "orthogonal")
					{
						self._orientation = self.CCTMXOrientation.CCTMXOrientationOrtho;
					}
					else if( jsonfile.map.orientation == "isometric")
					{
//						console.log("orientation = isometric");
						self._orientation = self.CCTMXOrientation.CCTMXOrientationIso;
					}
					else if( jsonfile.map.orientation == "hexagonal")
					{
						self._orientation = self.CCTMXOrientation.CCTMXOrientationHex;
					}
					self._mapSize = new Core.Size(jsonfile.map.width, jsonfile.map.height);
					self._tileSize = new Core.Size(jsonfile.map.tileset.tilewidth, jsonfile.map.tileset.tileheight);
					self._imageTileSize = new Core.Size(jsonfile.map.tileset.image.tilewidth, jsonfile.map.tileset.image.tileheight);
//					console.log("width = " + self._tileSize._width);
					self._parentElement = self.TMXProperty.TMXPropertyMap;
					
					if(jsonfile.map.tileset)
					{
						var tileset = new CCTMXTilesetInfo();
						tileset._name = jsonfile.map.tileset.name;
						tileset._firstGid = jsonfile.map.tileset.firstgid;
						if(jsonfile.map.tileset.spacing)
							tileset._spacing = jsonfile.map.tileset.spacing;
						if(jsonfile.map.tileset.margin)
							tileset._margin = jsonfile.map.tileset.margin;
						tileset._tileSize.setWidth(jsonfile.map.tileset.tilewidth);
						tileset._tileSize.setHeight(jsonfile.map.tileset.tileheight);
						tileset._sourceImage1 = jsonfile.map.tileset.image.source1;
						tileset._sourceImage2 = jsonfile.map.tileset.image.source2;
						tileset._sourceImage3 = jsonfile.map.tileset.image.source3;
						tileset._imageSize.setAll(jsonfile.map.tileset.image.width, jsonfile.map.tileset.image.height);

						self._tilesets.push(tileset);
						destroy(tileset);	
					}
					if(jsonfile.map.layer)
					{											
						var layer = new CCTMXLayerInfo();
						layer._name = jsonfile.map.layer.name;
						layer._layerSize.setWidth(jsonfile.map.layer.width);
						layer._layerSize.setHeight(jsonfile.map.layer.height);
						layer._visible = !(jsonfile.map.layer.visible == "0");
						if(jsonfile.map.layer.opacity)
						{
							layer._opacity = 255 * jsonfile.map.layer.opacity;
						}
						else
						{
							layer._opacity = 255;
						}
						layer._offset.setX(0);
						layer._offset.setY(0);
						if(jsonfile.map.layer.x)
							layer._offset.setX(jsonfile.map.layer.x);
						if(jsonfile.map.layer.y)
							layer._offset.setY(jsonfile.map.layer.y);
						
						if(jsonfile.map.layer.data)
						{
							if(jsonfile.map.layer.data.encoding == "base64")
							{
								self._layerAttribs |= self.TMXLayerAttrib.TMXLayerAttribBase64;
								self._storingCharacers = true;
							}
							if(jsonfile.map.layer.data.compression == "gzip")
							{
								self._layerAttribs |= self.TMXLayerAttrib.TMXLayerAttribGzip;
							}
							if(self._layerAttribs&self.TMXLayerAttrib.TMXLayerAttribBase64)
							{
//								console.log("data = " + jsonfile.map.layer.data.data);
								var buffer = utf8.toByteArray(Core.Base64.decode(jsonfile.map.layer.data.data));
								for(var i = 0; i < buffer.length; i+= 4)
								{
//									console.log("data = " + utf8.getUIntAt(buffer, i));	
									layer._tiles.push(utf8.getUIntAt(buffer, i));
								}
							}							
						}
						self._layers.push(layer);
						destroy(layer);
					}
					self.checkResult();
					cb();
	            }
	        }
//	        console.log("End Callback");
    	}
    );
	
	},
	
	checkResult:function()
	{
		console.log("this orientation = " + (this._orientation == this.CCTMXOrientation.CCTMXOrientationIso));
		console.log("map size = " + (this._mapSize._width) + " tileset size = " + this._tileSize._width);
	},

});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCTMXLayer'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCTMXLayer'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCTMXLayer'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var CCSpriteSheet = require('Code/Cocos2D/CCSpriteSheet').CCSpriteSheet;
var CCTMXMapInfo = require('Code/Cocos2D/CCTMXMapInfo').CCTMXMapInfo;
var CCTextureAtlas = require('Code/Cocos2D/CCTextureAtlas').CCTextureAtlas;
var CCTexture2D = require('Code/Cocos2D/CCTexture2D').CCTexture2D;
var CCSprite = require('Code/Cocos2D/CCSprite').CCSprite;

exports.CCTMXLayer = CCSpriteSheet.subclass(
{
	classname: 'CCTMXLayer',
	
	initialize: function(tilesetInfo, layerInfo, mapInfo)
	{	
//		console.log("CCTMXLayer initialize");		
		var size = layerInfo._layerSize;
		var totalNumberOfTiles = size._width * size._height;
		var capacity = totalNumberOfTiles * 0.35 + 1;
		
		this._texture = new CCTexture2D('./Content/' + tilesetInfo._sourceImage, tilesetInfo._imageSize);
		this._sourceImage1 = tilesetInfo._sourceImage1;
		this._sourceImage2 = tilesetInfo._sourceImage2;
		this._sourceImage3 = tilesetInfo._sourceImage3;
//		console.log("source image name = " + this._sourceImage);
		this._imageSize = tilesetInfo._imageSize;
		this._imageTileSize = mapInfo._imageTileSize;
		this.initWithTexture(this._texture, capacity);
		this._layerName = layerInfo._name;
//		console.log("layer name = " + this._layerName);
		this._layerSize = layerInfo._layerSize;
		this._tiles = layerInfo._tiles;
		this._minGID = layerInfo._minGID;
		this._maxGID = layerInfo._maxGID;
		this._opacity = layerInfo._opacity;
		this._properties = layerInfo._properties;
		this._tileset = tilesetInfo;
//		console.log("tileset class = " + tilesetInfo);
		this._mapTileSize = mapInfo._tileSize;
		this._layerOrientation = mapInfo._orientation;
//		var offset = this.calculateLayerOffset(layerInfo._offset);
//		console.log("offset = " + offset._x + ", " + offset._y);
//		this.setPosition(new Core.Point(1100,50));
		this._atlasIndexArray = new Array();
		this.setContentSize(new Core.Size(this._layerSize._width * this._mapTileSize._width, this._layerSize._height * this._mapTileSize._height));
		this._useAutomaticVertexZ = false;
		this._vertexZvalue = 0;
		this._alphaFuncValue = 0;
		this._atlasIndexArray = new Array();
		this._grassGID = null;
		
		this._testSize=10;
	},

	calculateLayerOffset: function(pos)
	{
		var ret = new Core.Point();
		switch(this._layerOrientation)
		{
			case CCTMXMapInfo.CCTMXOrientation.CCTMXOrientationOrtho:
				ret.setX(pos._x * this._mapTileSize._width);
				ret.setY(-pos._y * this._mapTileSize._height);
				break;
			case CCTMXMapInfo.CCTMXOrientation.CCTMXOrientationIso:
				ret.setX((pos._x - pos._y) *(this._mapTileSize._width / 2));
				ret.setY((-pos._x - pos._y) * (this._mapTileSize._height / 2));
				break;
		}
		return ret;
	},		
	
	setUpPrimitive: function(){
		
		if(this._grassGID == GameState._zfGameData._baseGID)
			return;
		
		this._grassGID = GameState._zfGameData._baseGID;
		var initialY = 0;
		
		switch (this._grassGID){
			case 1:
				initialY = 0;
				this._sourceImage = this._sourceImage1;
				break;
			case 3:
				initialY = (this._imageTileSize._height/this._imageSize._height);
				this._sourceImage = this._sourceImage1;
				break;
			case 5:
				initialY = 0;
				this._sourceImage = this._sourceImage2;
				break;
			case 7:
				initialY = (this._imageTileSize._height/this._imageSize._height);
				this._sourceImage = this._sourceImage2;
				break;
			case 9:
				initialY = 0;
				this._sourceImage = this._sourceImage3;
				break;
		}

		//FIXME: spriteSize
//		var spriteSize = new Core.Size(48,24);
		
		if(this._primitive)
		{
//			if(this._primitive.getAnimation())
//				destroy(this._primitive.getAnimation());
			destroy(this._primitive);
		}
			
		this._primitive = new GL2.Primitive();
		this._primitive.setType(GL2.Primitive.Type.Triangles);        
		this._primitive.setColor(1, 1, 1);
		this._primitive.setAlpha(255/255);

        this.addChild(this._primitive);
   
        
		var spriteSize = new Core.Size(this._imageTileSize._width,this._imageTileSize._height);
		
		var anim = SpriteFactoryCache.getAnimation('./Content/' + this._sourceImage, /*Core.Size*/ spriteSize, /*Core.Point*/ [0.5,0.5],
				///*Core.Rect*/ [0,0,48/96,24/120],
				[0,initialY, this._imageTileSize._width/this._imageSize._width,this._imageTileSize._height/this._imageSize._height],
				/*Boolean*/ false);

		this._primitive.setAnimation(anim);
		
		//First Position
		var gid = this._tiles[0];
		var pos = this.positionAt(ccp(0,0));

		var rect = this._tileset.rectForGID(gid);

		var tmpRect = new Core.Rect(pos, rect.getSize());
		tmpRect.getOrigin().setY(toMY(tmpRect.getOrigin()._y) - tmpRect.getSize()._height);
		
		this._primitive.setPosition(tmpRect.getOrigin()._x+35-this._imageTileSize._width*0.5,tmpRect.getOrigin()._y);
	},
	
	setupTiles : function()
	{	
		
		this.setUpPrimitive();
		
//		return;
		//FIXME: This is a task of tm (zfTileManager)

		var imageLayerSizeWidth = this._layerSize._width/this._testSize;
		var imageLayerSizeHeight = this._layerSize._height/this._testSize;
		
		for (var i = 0; i < imageLayerSizeHeight; i++) {
			for (var j = 0; j < imageLayerSizeWidth; j++) {
				this._insertGid(j,i);
			}
		}
	},

	_insertGid: function (j,i)
	{
		var spriteSize = new Core.Size(this._mapTileSize._width,this._mapTileSize._height);
		var w = spriteSize._width * this._testSize;
		var h = spriteSize._height * this._testSize;
		//isometric projection
		var x = i*0.5*w - j*0.5*w; 
		var y = i*0.5*h + j*0.5*h;
		
		this._primitive.pushVertex(new GL2.Primitive.Vertex([0+x,h+y],[0,1],[1,1,1]));
		this._primitive.pushVertex(new GL2.Primitive.Vertex([0+x,0+y],[0,0],[1,1,1]));
		this._primitive.pushVertex(new GL2.Primitive.Vertex([w+x,h+y],[1,1],[1,1,1]));
		
		this._primitive.pushVertex(new GL2.Primitive.Vertex([w+x,h+y],[1,1],[1,1,1]));
		this._primitive.pushVertex(new GL2.Primitive.Vertex([0+x,0+y],[0,0],[1,1,1]));
		this._primitive.pushVertex(new GL2.Primitive.Vertex([w+x,0+y],[1,0],[1,1,1]));
	},
	
	appendTileForGID: function(gid, pos)
	{
		// console.log("tileset class = " + this._tileset.classname);
		var rect = this._tileset.rectForGID(gid);
		var z = pos._x + pos._y * this._layerSize._width;
		
		// if(!this._reusedTile)
		// {
		
			//this._reusedTile = new GL2.Sprite();
		// }
		
		//var uv = new Core.Rect(rect.getMinX() / this._imageSize._width, rect.getMinY() / this._imageSize._height, rect.getSize()._width / this._imageSize._width, rect.getSize()._height / this._imageSize._height);
		this._reusedTile = CCSprite.spriteWithFile(this._sourceImage,rect, new Core.Point(0, 1));
		//this._reusedTile.setImage(this._sourceImage, rect.getSize(), new Core.Point(0, 0), uv)._animation.setFilteringEnabled(false);
		this._reusedTile.setPosition(this.positionAt(pos));
		//var newPos = this._reusedTile.getPosition();
		//newPos.setY(toMY(newPos._y + rect.getSize()._height));
		//this._reusedTile.setPosition(newPos);

		 var pos = this._reusedTile.getPosition();
		// console.log("tile position Mobage / Cocos = (" + pos._x + ", " + pos._y + ")" + " / (" +  pos._x + ", "+ toCY(pos._y) + ")");
		// console.log("depth = " + this.vertexZForPos(pos) + " | alpha = " +
		// this._opacity);
		// this._reusedTile.setDepth(this.vertexZForPos(pos));
		this._reusedTile.setAlpha(this._opacity / 255);				
		
		// optimization:
		// The difference between appendTileForGID and insertTileforGID is that
		// append is faster, since
		// it appends the tile at the end of the texture atlas
        
		// unsigned int indexForZ = atlasIndexArray_->num;
		if(this._atlasIndexArray[z] === undefined)
		{
			var indexForZ = this._atlasIndexArray.length;
			this._atlasIndexArray[z] = indexForZ;
		}
		else
			indexForZ = this._atlasIndexArray[z];
		// don't add it using the "standard" way.
		
		//this.addChild(this._reusedTile, this.vertexZForPos(pos), z);
		this.addQuadFromSprite(this._reusedTile, indexForZ);
		
		
		// append should be after addQuadFromSprite since it modifies the
		// quantity values
        // ccCArrayInsertValueAtIndex(atlasIndexArray_, (void*)z, indexForZ);
		
        //FIXME: check if return is required, by now the CCNode is being destroyed		return this._reusedTile;
		destroy(this._reusedTile);
		this._reusedTile = null;
	},
	
	positionAt: function(pos)
	{
		var ret = new Core.Point();

		switch(this._layerOrientation) {
// case CCTMXOrientationOrtho:
// ret = [self positionForOrthoAt:pos];
// break;
			case CCTMXMapInfo.CCTMXOrientation.CCTMXOrientationIso:
				ret = this.positionForIsoAt(pos);
				break;
// case CCTMXOrientationHex:
// ret = [self positionForHexAt:pos];
// break;
		}
		return ret;
	},
	
	positionForIsoAt: function(pos)
	{
		var x = Math.floor(this._mapTileSize._width /2 * ( this._layerSize._width + pos._x - pos._y - 1) + 0.49);
		var y = Math.floor(this._mapTileSize._height /2 * ((this._layerSize._height * 2 - pos._x - pos._y) - 2) + 0.49);	
		var ret = new Core.Point(x, y);
		return ret;
	},
	
	vertexZForPos: function(pos)
	{
		var ret = 0;
		var maxVal = 0;
// if( useAutomaticVertexZ_ ) {
// switch( layerOrientation_ ) {
// case CCTMXOrientationIso:
// maxVal = layerSize_.width + layerSize_.height;
// ret = -(maxVal - (pos.x + pos.y));
// break;
// case CCTMXOrientationOrtho:
// ret = -(layerSize_.height-pos.y);
// break;
// case CCTMXOrientationHex:
// NSAssert(NO,@"TMX Hexa zOrder not supported");
// break;
// default:
// NSAssert(NO,@"TMX invalid value");
// break;
// }
// } else
		ret = this._vertexZvalue;
		
		return ret;
	},
	
	tileAt: function(pos)
	{
// NSAssert( pos.x < layerSize_.width && pos.y < layerSize_.height && pos.x >=0
// && pos.y >=0, @"TMXLayer: invalid position");
// NSAssert( tiles_ && atlasIndexArray_, @"TMXLayer: the tiles map has been
// released");
		
		var tile = null;
		var gid = this.tileGIDAt(pos);
		
		// if GID == 0, then no tile is present
		if( gid ) {
			var z = pos._x + pos._y * this._layerSize._width;
			tile = this.getChildByTag(z);
			
			// tile not created yet. create it
			if( ! tile ) {
				var rect = this._tileset.rectForGID(gid);			
				tile = new CCSprite();
				tile.initWithSpriteSheet(this, rect);
				tile.setPosition(this.positionAt(pos));
				

// tile.setDepth(this.vertexZForPos(pos));
// tile.setAnchorPoint([0,0]);
				tile.setAlpha(this._opacity / 255);				
				
// indexForZ = this.atlasIndexForExistantZ(z);
				
// [self addSpriteWithoutQuad:tile z:indexForZ tag:z];
// this.addChild(tile, this.vertexZForPos(pos), z);
// [tile release];
			}
		}
//		console.log("tile position = " + tile.getPosition()._x + ", " + tile.getPosition()._y);		
		return tile;
	},

	
	tileGIDAt: function(pos)
	{
		if(!(pos._x < this._layerSize._width && pos._y < this._layerSize._height && pos._x >=0 && pos._y >=0))
			console.log("TMXLayer: invalid position");
		if(!(this._tiles /*&& this._atlasIndexArray*/))
			console.log("TMXLayer: the tiles map has been released");
		
		var idx = pos._x + pos._y * this._layerSize._width;
		//This was added to solve a bug only present on android. The map can't be used until the next load of the game
		if (idx >= this._tiles.length) {
			this._tiles[idx] = this._grassGID;
		} else {
			var gid = this._tiles[idx];
			if (!gid) {
				this._tiles[idx] = this._grassGID;
			}
		}
		//end fixme
		return this._tiles[idx];
	},
	
	setTileGID: function(gid, pos)
	{
// NSAssert( pos.x < layerSize_.width && pos.y < layerSize_.height && pos.x >=0
// && pos.y >=0, @"TMXLayer: invalid position");
// NSAssert( tiles_ && atlasIndexArray_, @"TMXLayer: the tiles map has been
// released");	
// unsigned int currentGID = [self tileGIDAt:pos];
		var currentGID = this.tileGIDAt(pos);
		
		if( currentGID != gid ) {
			
			// setting gid=0 is equal to remove the tile
			if( gid == 0 )
			{
				this.removeTileAt(pos);
			}
	
			// empty tile. create a new one
			else if( currentGID == 0 )
			{
				this.insertTileForGID(gid, pos);
			}
			// modifying an existing tile with a non-empty tile
			else {
				var z = pos._x + pos._y * this._layerSize._width;
				var ccsprite = this.getChildByTag(z);
				if( ccsprite ) {
					destroy(ccsprite._sprite);
					var rect = this._tileset.rectForGID(gid);
					ccsprite.initWithFile_rect(this._sourceImage,rect,new Core.Point(0, 1));
					this._tiles[z] = gid;
				} 
				else {
					this.updateTileForGID(gid, pos);
				}
			}
		}
	},
	
	updateTileForGID: function(gid, pos)
	{

//		this._insertGid(pos._x,pos._y); 
		var z = pos._x + pos._y * this._layerSize._width;
		this._tiles[z] = gid;
		return;
		
		var rect = this._tileset.rectForGID(gid);
		var z = pos._x + pos._y * this._layerSize._width;
		
		this._reusedTile = CCSprite.spriteWithFile(this._sourceImage,rect, new Core.Point(0, 1));
		//this._reusedTile.setImage(this._sourceImage, rect.getSize(), new Core.Point(0, 0), uv)._animation.setFilteringEnabled(false);
		this._reusedTile.setPosition(this.positionAt(pos));
//		var newPos = this._reusedTile.getPosition();
//		newPos.setY(toMY(newPos._y + rect.getSize()._height));
//		this._reusedTile.setPosition(newPos);

		 var pos = this._reusedTile.getPosition();
		// console.log("tile position Mobage / Cocos = (" + pos._x + ", " + pos._y + ")" + " / (" +  pos._x + ", "+ toCY(pos._y) + ")");
		// console.log("depth = " + this.vertexZForPos(pos) + " | alpha = " +
		// this._opacity);
		// this._reusedTile.setDepth(this.vertexZForPos(pos));
		this._reusedTile.setAlpha(this._opacity / 255);				
		
		// optimization:
		// The difference between appendTileForGID and insertTileforGID is that
		// append is faster, since
		// it appends the tile at the end of the texture atlas
// unsigned int indexForZ = atlasIndexArray_->num;
		var indexForZ = this._atlasIndexArray[z];
		// don't add it using the "standard" way.
// [self addQuadFromSprite:reusedTile_ quadIndex:indexForZ];
		
		//this.addChild(this._reusedTile, this.vertexZForPos(pos), z);
		this.addQuadFromSprite(this._reusedTile, indexForZ);
		
		
		// append should be after addQuadFromSprite since it modifies the
		// quantity values
		// ccCArrayInsertValueAtIndex(atlasIndexArray_, (void*)z, indexForZ);
		
		// get atlas index
//		unsigned int indexForZ = [self atlasIndexForExistantZ:z];

//		[reusedTile_ setAtlasIndex:indexForZ];
//		[reusedTile_ updateTransform];
		this._tiles[z] = gid;
		
		//FIXME: check if return is required, by now the CCNode is being destroyed	return this._reusedTile;
		destroy(this._reusedTile);
		this._reusedTile = null;
	},

	
	
	
	insertTileForGID: function(gid, pos)
	{
//		this._insertGid(pos._x,pos._y); 
		var z = pos._x + pos._y * this._layerSize._width;
		this._tiles[z] = gid;
		return;
		
		var rect = this._tileset.rectForGID(gid);
		
		var z = pos._x + pos._y * this._layerSize._width;
		
		//this._reusedTile = new GL2.Sprite();
		//var uv = new Core.Rect(rect.getMinX() / this._imageSize._width, rect.getMinY() / this._imageSize._height, rect.getSize()._width / this._imageSize._width, rect.getSize()._height / this._imageSize._height);
		this._reusedTile = CCSprite.spriteWithFile(this._sourceImage,rect,new Core.Point(0, 0));
		//this._reusedTile.setImage(this._sourceImage, rect.getSize(), new Core.Point(0, 0), uv)._animation.setFilteringEnabled(false);
		this._reusedTile.setPosition(this.positionAt(pos));
//		var newPos = this._reusedTile.getPosition();
//		newPos.setY(toMY(newPos._y));
//		this._reusedTile.setPosition(newPos);
		// this._reusedTile.setDepth(this.vertexZForPos(pos));
		this._reusedTile.setAlpha(this._opacity / 255);				
		
		// optimization:
		// The difference between appendTileForGID and insertTileforGID is that
		// append is faster, since
		// it appends the tile at the end of the texture atlas
		if(this._atlasIndexArray[z] === undefined)
		{
			var indexForZ = this._atlasIndexArray.length;
			this._atlasIndexArray[z] = indexForZ;
		}
		else
			indexForZ = this._atlasIndexArray[z];
	
		// don't add it using the "standard" way.
// [self addQuadFromSprite:reusedTile_ quadIndex:indexForZ];
//		this.addChild(this._reusedTile, this.vertexZForPos(pos), z);		
		this.addQuadFromSprite(this._reusedTile, indexForZ);
		
// get atlas index
// unsigned int indexForZ = [self atlasIndexForNewZ:z];
//		
// Optimization: add the quad without adding a child
// [self addQuadFromSprite:reusedTile_ quadIndex:indexForZ];
//		
// insert it into the local atlasindex array
// ccCArrayInsertValueAtIndex(atlasIndexArray_, (void*)z, indexForZ);
//		
// update possible children
// for( CCSprite *sprite in children_) {
// unsigned int ai = [sprite atlasIndex];
// if( ai >= indexForZ)
// [sprite setAtlasIndex: ai+1];
// }
		
		this._tiles[z] = gid;
		
		//FIXME: check if return is required, by now the CCNode is being destroyed		return this._reusedTile;
		destroy(this._reusedTile);
		this._reusedTile = null;
	},

	
	removeTileAt: function($super, pos)
	{
// NSAssert( pos.x < layerSize_.width && pos.y < layerSize_.height && pos.x >=0
// && pos.y >=0, @"TMXLayer: invalid position");
// NSAssert( tiles_ && atlasIndexArray_, @"TMXLayer: the tiles map has been
// released");
	
		var gid = this.tileGIDAt(pos);
		
		if( gid ) {
			
			var z = pos._x + pos._y * this._layerSize._width;
// unsigned atlasIndex = [self atlasIndexForExistantZ:z];
			
			// remove tile from GID map
			this._tiles[z] = 0;
	
			// remove tile from atlas position array
// ccCArrayRemoveValueAtIndex(atlasIndexArray_, atlasIndex);
			
			// remove it from sprites and/or texture atlas
			var sprite = this.getChildByTag(z);
			if( sprite )
			{
// HACK see implementation in CCSpriteSheet
// [super removeChild:sprite cleanup:YES];
				$super(sprite, true);
			}
// else {
// [textureAtlas_ removeQuadAtIndex:atlasIndex];
//	
// // update possible children
// for( CCSprite *sprite in children_) {
// unsigned int ai = [sprite atlasIndex];
// if( ai >= atlasIndex) {
// [sprite setAtlasIndex: ai-1];
// }
// }
// }
		}
	},


	addQuadFromSprite: function(sprite, index)
	{
//		var tmpRect = new Core.Rect(sprite.getPosition(), sprite.getContentSize());
//		tmpRect.getOrigin().setY(toMY(tmpRect.getOrigin()._y) - tmpRect.getSize()._height);
//		
//		var imgWidth = this._texture._imageSize._width;
//		var imgHeight = this._texture._imageSize._height;
//		var textureX = sprite._textureRect.getOrigin()._x;
//		var textureY = sprite._textureRect.getOrigin()._y;
//		var textureW = sprite._textureRect.getSize()._width;
//		var textureH = sprite._textureRect.getSize()._height;
//
//		var p = new Array();
//		p[0] = new Core.Point(tmpRect.getOrigin()._x , tmpRect.getOrigin()._y);
//		p[1] = new Core.Point(tmpRect.getOrigin()._x, tmpRect.getOrigin()._y +  tmpRect.getSize()._height);
//		p[2] = new Core.Point(tmpRect.getOrigin()._x +  tmpRect.getSize()._width, tmpRect.getOrigin()._y +  tmpRect.getSize()._height);
//		p[3] = new Core.Point(tmpRect.getOrigin()._x +  tmpRect.getSize()._width, tmpRect.getOrigin()._y);
//		
//		if(!this._asd)
//		console.log ("POSITIONNNNNnnnnnnnnnnnn: ("+tmpRect.getOrigin()._x +","+tmpRect.getOrigin()._y +")");
//		this._asd = true;
//		
//		if(this._primitive.getVertexCount() <= index * 6)
//		{
//			this._primitive.pushVertex(new GL2.Primitive.Vertex(p[0], new Core.Vector(textureX/imgWidth, textureY/imgHeight)));
//			this._primitive.pushVertex(new GL2.Primitive.Vertex(p[1], new Core.Vector(textureX/imgWidth, (textureY + textureH)/imgHeight)));
//			this._primitive.pushVertex(new GL2.Primitive.Vertex(p[2], new Core.Vector((textureX + textureW)/imgWidth, (textureY + textureH)/imgHeight)));
//			this._primitive.pushVertex(new GL2.Primitive.Vertex(p[0], new Core.Vector(textureX/imgWidth, textureY/imgHeight)));
//			this._primitive.pushVertex(new GL2.Primitive.Vertex(p[2], new Core.Vector((textureX + textureW)/imgWidth, (textureY + textureH)/imgHeight)));
//			this._primitive.pushVertex(new GL2.Primitive.Vertex(p[3], new Core.Vector((textureX + textureW)/imgWidth, textureY/imgHeight)));
//		}
//		else
//		{
//			this._primitive.setVertex(index*6, new GL2.Primitive.Vertex(p[0], new Core.Vector(textureX/imgWidth, textureY/imgHeight)));
//			this._primitive.setVertex(index*6 + 1,new GL2.Primitive.Vertex(p[1], new Core.Vector(textureX/imgWidth, (textureY + textureH)/imgHeight)));
//			this._primitive.setVertex(index*6 + 2, new GL2.Primitive.Vertex(p[2], new Core.Vector((textureX + textureW)/imgWidth, (textureY + textureH)/imgHeight)));
//			this._primitive.setVertex(index*6 + 3,new GL2.Primitive.Vertex(p[0], new Core.Vector(textureX/imgWidth, textureY/imgHeight)));
//			this._primitive.setVertex(index*6 + 4,new GL2.Primitive.Vertex(p[2], new Core.Vector((textureX + textureW)/imgWidth, (textureY + textureH)/imgHeight)));
//			this._primitive.setVertex(index*6 + 5,new GL2.Primitive.Vertex(p[3], new Core.Vector((textureX + textureW)/imgWidth, textureY/imgHeight)));		
//		}
	}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCTMXTilesetInfo'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCTMXTilesetInfo'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCTMXTilesetInfo'] = exports; var Core = require('NGCore/Client/Core').Core;


exports.CCTMXTilesetInfo = Core.Class.subclass(
{
	classname: 'CCTMXTilesetInfo',
	initialize: function()
	{	
//		console.log("CCTMXTilesetInfo initialize");
		this._name = "";
		this._firstGid = 0;
		this._tileSize = new Core.Size();
		this._spacing = 0;
		this._margin = 0;
		this._sourceImage = "";
		this._imageSize = new Core.Size();
	},
	
	destroy: function()
    {
    },
    

//    -(CGRect) rectForGID:(unsigned int)gid
//    {
//    	CGRect rect;
//    	rect.size = tileSize_;
//    	
//    	gid = gid - firstGid_;
//    	
//    	int max_x = (imageSize_.width - margin_*2 + spacing_) / (tileSize_.width + spacing_);
//    	//	int max_y = (imageSize.height - margin*2 + spacing) / (tileSize.height + spacing);
//    	
//    	rect.origin.x = (gid % max_x) * (tileSize_.width + spacing_) + margin_;
//    	rect.origin.y = (gid / max_x) * (tileSize_.height + spacing_) + margin_;
//    	
//    	return rect;
//    }
    
	rectForGID: function(gid)
	{
		var rect = new Core.Rect();
	
		rect.setSize(this._tileSize);

		gid = gid - this._firstGid;
//		console.log("max x = " + this._imageSize._width + ", " + this._margin + ", " + this._spacing);		
		var max_x = Math.floor((this._imageSize._width - this._margin*2 + this._spacing) / (this._tileSize._width + this._spacing));
		//	int max_y = (imageSize.height - margin*2 + spacing) / (tileSize.height + spacing);
		var origin = new Core.Point((gid % max_x) * (this._tileSize._width + this._spacing) + this._margin, Math.floor(gid / max_x) * (this._tileSize._height + this._spacing) + this._margin);
		rect.setOrigin(origin);
		
		return rect;
	}

	
});



; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Cocos2D/CCTMXLayerInfo'] = function(){var exports = $MODULE_REGISTRY['Code/Cocos2D/CCTMXLayerInfo'] || {}; $MODULE_REGISTRY['Code/Cocos2D/CCTMXLayerInfo'] = exports; var Core = require('NGCore/Client/Core').Core;


exports.CCTMXLayerInfo = Core.Class.subclass(
{
	classname: 'CCTMXLayerInfo',
	initialize: function()
	{	
//			NSString			*name_;
//	CGSize				layerSize_;
//	unsigned int		*tiles_;
//	BOOL				visible_;
//	unsigned char		opacity_;
//	BOOL				ownTiles_;
//	unsigned int		minGID_;
//	unsigned int		maxGID_;
//	NSMutableDictionary	*properties_;
//	CGPoint				offset_;

//		console.log("CCTMXLayerInfo initialize");
		this._name = "";
		this._layerSize = new Core.Size();
		this._tiles = new Array();
		this._visible = false;
		this._opacity = 0;
		this._ownTiles = false;
		this._minGID = 0;
		this._maxGID = 0;
		this._properties = new Object();
		this._offset = new Core.Point();
	},
	
	destroy: function()
    {
    },
	
});

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GameState/ZFBitBank'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GameState/ZFBitBank'] || {}; $MODULE_REGISTRY['Code/Game/GameState/ZFBitBank'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.ZFBitBank = Core.Class.subclass(
{
	classname:'ZFBitBank',
	
	initialize: function()
	{
		this._bank = [];
	},
	
	setFlag: function(bitCount)
	{
		if(bitCount < 0)
		{
			return;
		}
		
		//find out which container to use based ont he size of the flag
		var bankIndexToUse = this.bankIndexForFlag(bitCount);
		var flag = (1 << bitCount % 32);
		var num = (bankIndexToUse >= this._bank.length) ? null : this._bank[bankIndexToUse];
		
		if (!num)
		{
			//if this container doesnt exist make one to be stored
			
			// bankIndexToUse == how many banks we need + 1;
			currentBanks = this._bank.length;
			
			// if the difference is too much we need to pad it with some extra banks
			while(currentBanks < bankIndexToUse)
			{
				this._bank.push(0);
				currentBanks ++;
			}
			
			num = flag;
		}
		else 
		{
			//this container exist, update it and replace the old one
		    var flags = num;
			flags = num;
			flags |= flag;
			num = flags;
		}
		
		if (bankIndexToUse < this._bank.length)
		{
			this._bank[bankIndexToUse] = num;
		}
		else 
		{
			this._bank.push(num);
		}
	},
	
	remFlag: function(bitCount)
	{
		if(bitCount < 0)
		{
			return;
		}
	    
		//find out which container to use based ont he size of the flag
		var bankIndexToUse = this.bankIndexForFlag(bitCount);
		var flag = (1 << bitCount % 32);
		var num = (bankIndexToUse >= this._bank.length) ? null : this._bank[bankIndexToUse];
		
		if (!num)
		{
			//if this container doesnt exist make one to be stored
			num = flag;
		}
		else 
		{
			//this container exist, update it and replace the old one
			var flags = num;
			flags &= ~flag;
			num = flags;
		}
		
		this._bank.splice(bankIndexToUse, 1, num);
	},

	
	hasFlag: function(bitCount)
	{
		if(bitCount == null)
		{
			console.log("Null/Undefined flag given, should be a number");
		}
		
		if(bitCount < 0)
		{
			return false;
		}
	    
		var bankIndexToUse = this.bankIndexForFlag(bitCount);
		var flag = (1 << bitCount % 32);
		if (bankIndexToUse >= this._bank.length)
		{
			return false;
		}
			
		var flags = (bankIndexToUse >= this._bank.length) ? null : this._bank[bankIndexToUse];
		
		return (flags & flag) ? true : false;
	},

	
	bankIndexForFlag: function(bitCount)
	{
		//find out which container to use based ont he size of the flag
		var bankIndexToUse = Math.floor(bitCount / 32);
		return bankIndexToUse;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Tiles/SaveTile'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Tiles/SaveTile'] || {}; $MODULE_REGISTRY['Code/Game/Tiles/SaveTile'] = exports; exports.SaveTile = Core.Class.subclass({
    classname : 'SaveTile',
    
    initialize : function()
    {
    },
    
    setKey : function(aKey, ZFTileManager)
    {
        if (this._key != aKey)
        {
            if (this._key)
            {
                this._key = null;
                this._key = aKey;
            }
            else
            {
                this._key = aKey;
            }
            
            this._isZombie = false;
            this._isPlant = false;
            this._isHarvestable = false;
            this._isTransformable = false;
            this._isGate = false;
            this._fertilized = false;
            this._growTime = 0;
            this._orientation = 0;
            
            if (!ZFTileManager.exists())
            {
                return;
            }
            
            var tim = ZFTileManager;
            var market = ZFMarketMenu.theMarket();
            var tileProperties = tim._tilePropertiesDictionary[this._key];
            if (!tileProperties || !tileProperties["transformsTo"])
            {
                return;
            }
            isGate = tileProperties["isGate"];
            
            this._isTransformable = true;
            var name = tileProperties["name"];
            var subCategory = market.subCategoryFromName(name);
            if (subCategory)
            {
                if (subCategory == "plant")
                {
                    this._isPlant = true;
                }
                else if (subCategory = "zombie")
                {
                    this._isZombie = true;
                }
            }
            
            this._isHarvestable = tileProperties["canHarvest"];
            this._ignoreWitherRule = tileProperties["ignoreWitherRule"];
            this._growTime = market.growTimeFromName(name);
        }
    },
    
    resetData : function()
    {
        this._date = null;
        this._plantDate = null;
        this._key = null;
        this._endCropTile = null;
        if (this._color)
        {
            this._color.setAll(1, 1, 1);
        }
        else
        {
            this._color = new Core.Color(1, 1, 1);
        }
    },
    
    toJSON : function()
    {
        // Ignores default values
        var o = {};
        for ( var key in this)
        {
            var val = this[key];
            if (val)
            {
                o[key] = val;
            }
        }
        
        return o;
    },
    
    initWithData : function(data)
    {
        /*this._isZombie = false;
        this._isPlant = false;
        this._isHarvestable = false;
        this._ignoreWitherRule = false;
        this._isTransformable = false;
        this._isGate = false;
        
        this._rootTile.x = this._coder.decodeIntForKey["tileX"];
        this._rootTile.y = this._coder.decodeIntForKey["tileY"];
        this._ownerTile.x = this._coder.decodeIntForKey["ownerTileX"];
        this._ownerTile.y = this._coder.decodeIntForKey["ownerTileY"];
        this._plantDate = this._coder.decodeObjectForKey["plantDate"];
        this._date = this._coder.decodeObjectForKey["date"];
        this._key = this._coder.decodeObjectForKey["keyString"];
        
        this._endCropTile = this._coder.decodeObjectForKey["endCropTile"];
        this._fertilized = this._coder.decodeBoolForKey["fertilized"];
        this._color = ccc3(this._coder.decodeIntForKey["colorR"], 
        			 this._coder.decodeIntForKey["colorG"], 
        			 this._coder.decodeIntForKey["colorB"]);
        this._orientation = this._coder.decodeIntForKey["orientation"];
        */
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Player/PlayerProfile'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Player/PlayerProfile'] || {}; $MODULE_REGISTRY['Code/Game/Player/PlayerProfile'] = exports; var GameData = require('Code/Game/GameState/GameData').GameData;
var Social = require('NGCore/Client/Social').Social;

exports.PlayerProfile = Core.Class.subclass(
{
	classname:'PlayerProfile',
	
	kDefaultSaveFileName : "saveGame",
	
	PlayerProfileType:
	{
		kGameCenterProfileType: 0,
		kFacebookProfileType: 1,
		kLocalProfileType: 2,
	    kPlayforgeProfileType: 3,
		kMobageProfileType: 4
	},
	
	initialize: function(callback)
	{
		GameData = require('Code/Game/GameState/GameData').GameData;
//		console.log("GameData = "+ Core + " " + GameData);
		 this.initValues(callback);
	},
	
	initValues: function(callback)
	{
//	    [[PlayerProfileManager playerProfileManager] log:@"Setting default values for a player profile"];
	    
//		var currSession = null;
//		if(Social.US)
//		{
//			currSession = Social.US.Session.getCurrentSession();
//		}
//		else
//		{
//			console.log('///PlayerProfile.initValues: Session not available in current API.');
//		}
		
		Social.Common.People.getCurrentUser(null, function(error, user){
			if(error){
				console.log('///PlayerProfile.initValues: Social.Common.People.getCurrentUser failed: ' + error.description);
			} else {
				this.setPlayerProfileID(user);
				if(callback){
					callback();
				}
			}
		}.bind(this));
		
//		var currUser;
//		if (currSession)
//		{
//			currUser    = currSession.user();
//		}
//		if (currUser)
//		{
//				this._playerProfileID = 'M' + currUser.recordID;
//				this._playerProfileType = this.PlayerProfileType.kMobageProfileType;
//		}
//		else
//		{
//				this._playerProfileID = "UnknownPlayer";
//				this._playerProfileType = this.PlayerProfileType.kLocalProfileType;
//		}
	    
	    this._playerGameData = null;
	    
	    this._latestStatus = null;
	    
	    this._playerProfileAlias = Core.Localization.getString("Zombie Farmer");
	    this._playerLevel = 1;
	    this._playerXP = -1;
	    this._playerBrains = 0;
	    this._playerGold = 200;
	    this._playerActiveSaveID = 0;
	    this._playerHeadID = 0;
	},
	
	setPlayerProfileID: function(user){
		if (user)
		{
			//console.log('///user.id: ' + user.id);
			this._playerProfileID = 'M' + user.id;
			this._playerProfileType = this.PlayerProfileType.kMobageProfileType;
		}
		else
		{
			this._playerProfileID = "UnknownPlayer";
			this._playerProfileType = this.PlayerProfileType.kLocalProfileType;
		}
	},
	
	$determineProfileType: function(profileID)
	{
	    var playerProfileType = this.PlayerProfileType.kLocalProfileType;
	    
	    if (profileID && profileID.length > 0)
	    {
	        // Attempt to determine the type
	        var firstLetter = profileID.charAt(0);
	        
	        if (firstLetter == 'G')
	            playerProfileType = this.PlayerProfileType.kGameCenterProfileType;
	        else if (firstLetter == 'F')
	            playerProfileType = this.PlayerProfileType.kFacebookProfileType;
	        else if (firstLetter == 'L')
	            playerProfileType = this.PlayerProfileType.kLocalProfileType;
	        else if (firstLetter == 'P')
	            playerProfileType = this.PlayerProfileType.kPlayforgeProfileType;
	        else if (firstLetter == 'M')
	            playerProfileType = this.PlayerProfileType.kMobageProfileType;
	    }
	    
//	    [[PlayerProfileManager playerProfileManager] log:[NSString stringWithFormat:@"Determined that the player profile of %@ has a type of %d", profileID, playerProfileType]];
	    
	    return playerProfileType;
	},

	
	$determineSaveFileName: function(profileID)
	{
		console.log("return save file name for profile id " + profileID);
	    var saveFileName = this.kDefaultSaveFileName + ".bin";
	    
	    //if (profileID || ![profileID isKindOfClass:[NSNull class]])
	    if (profileID)
	    {
	        // Make sure our profile type is up-to-date
	        var playerProfileType = this.determineProfileType(profileID);
	        
	        //TODO
	        // We have to do a bit of extra massaging for the Game Center saves
//	        if (playerProfileType == this.PlayerProfileType.kGameCenterProfileType)
//	        {
//	            if (profileID.length > 1)
//	                saveFileName = [NSString stringWithFormat:@"%@_G:%@.bin", kDefaultSaveFileName, [profileID substringFromIndex:1]];
//	        }
//	        else
	        if (playerProfileType == this.PlayerProfileType.kLocalProfileType)
	            saveFileName = this.kDefaultSaveFileName + ".bin";
	        else
	            saveFileName = this.kDefaultSaveFileName + "_" + profileID + ".bin";
	    }
	    
//	    [[PlayerProfileManager playerProfileManager] log:[NSString stringWithFormat:@"Determined a save file name as  %@ for %@", saveFileName, profileID]];
	    console.log("return save file name = " + saveFileName);
	    return saveFileName;
	},
	
	playerProfileAlias: function()
	{
		if (this._playerGameData)
	        return this._playerGameData._farmOwner;
	    
	    return this._playerProfileAlias;
	},

	playerLevel: function()
	{
		if (this._playerGameData)
	        return this._playerGameData._level;
	    
	    return this._playerLevel;
	},

	playerXP: function()
	{
		if (this._playerGameData)
	    {
	        var playerXPResource = this._playerGameData._resources[GameData.gameResources.kGameResourceXP];
	        return playerXPResource;
	    }
	    
	    return this._playerXP;
	},

	playerBrains: function()
	{
		if (this._playerGameData)
	    {
	        var playerBrainsResource =  this._playerGameData._resources[GameData.gameResources.kGameResourceBrains];
	        return playerBrainsResource;
	    }
	    
	    return this._playerBrains;
	},

	playerGold: function()
	{
		if (this._playerGameData)
	    {
	        var playerGoldResource = this._playerGameData._resources[GameData.gameResources.kGameResourceGold];
	        return playerGoldResource;
	    }
	    
	    return this._playerGold;
	},

	playerActiveSaveID: function()
	{
		if (this._playerGameData)
	        return this._playerGameData._saveID;
	    
	    return this._playerActiveSaveID;
	},

	playerHeadID: function()
	{
		if (this._playerGameData)
	        return this._playerGameData._headID;
	    
	    return this._playerHeadID;
	},
	
	
	loadFromSaveFile: function(cb)
	{
	    var saveFileName = this.determineSaveFileName(this._playerProfileID);
	    
	    this.loadFromSaveFile_saveFileName(saveFileName, cb);
	},
	
	loadFromSaveFile_saveFileName: function(saveFileName, cb)
	{
		console.log("load " + saveFileName);
	    // If we got here without a save file name then we can't load
	    if (!saveFileName)
	    {
//	        [[PlayerProfileManager playerProfileManager] log:@"Unable to load save file because the saveFileName is not valid"];
	        console.log("Unable to load save file because the saveFileName is not valid" + saveFileName);
	        cb();
	        return;
	    }
	    
	    // Attempt to load the save file
	    // Find the docs path
//	    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
//	    NSString *docsPath = nil;
//	    
//	    docsPath = [paths objectAtIndex:0];
//	    
//	    NSAssert(docsPath != nil, @"PlayerProfile::loadFromSaveFile(): docsPath is nil");
//	    
//	    // Build the full path to the save file in the documents directory
//	    NSString* fullPath = [docsPath stringByAppendingPathComponent:saveFileName];
	    
	    Storage.FileSystem.readFile(saveFileName, false, function(err, data)
		{
	    	if(err)
	    	{
	    		console.log("filesave " + saveFileName + "can't be read error = " + err);
	            // TODO: Automatically send and error report
//TODO	    		
//	            [[PlayerProfileManager playerProfileManager] log:[NSString stringWithFormat:@"exception = %@", exception]];
//	            
//	            NSString *message = [NSString stringWithString: @"Your save data is corrupt. Please send an email to \"support@theplayforge.com\"."];
//	            UIAlertView *av = [[UIAlertView alloc] initWithTitle:@"Corrupt Save File"
//	                                                         message:message
//	                                                        delegate:self
//	                                               cancelButtonTitle:NSLocalizedString(@"Ok", @"Ok")
//	                                               otherButtonTitles:nil];
//	            
//	            [av show];
//	            [av release];
	    		cb();
	    	}
	    	else
	    	{
//		        [[PlayerProfileManager playerProfileManager] log:[NSString stringWithFormat:@"Found a save file named %@ and now loading it", saveFileName]];
	    		console.log("Found a save file named " + saveFileName + " and now loading it");
		        var ppm = PlayerProfileManager.playerProfileManager();
//		        console.log("loaded data = " + data);
		        var tempData = JSON.parse(data);
		        
		        if (tempData)
		        {
//		            [[PlayerProfileManager playerProfileManager] log:[NSString stringWithFormat:@"Successfully loaded %@", saveFileName]];
//		        	console.log("save successfully loaded : " + data);
		        	this._playerGameData = new GameData();
		        	this._playerGameData.initWithData(tempData);
//		        	this._playerGameData = tempData;
//		        	console.log("save successfully loaded : " + this._playerGameData);
		            // Make sure these are up-to-date
		            this._playerLevel = this.playerLevel();
		            this._playerXP = this.playerXP();
		            this._playerGold = this.playerGold();
		            this._playerBrains = this.playerBrains();
//		            console.log("PlayerProfile.loadFromSaveFile_saveFileName: gold successfully loaded : " + this._playerGold);
//		            console.log("PlayerProfile.loadFromSaveFile_saveFileName: xp successfully loaded : " + this._playerXP);
//		            console.log("PlayerProfile.loadFromSaveFile_saveFileName: level successfully loaded : " + this._playerLevel);
//		            console.log("PlayerProfile.loadFromSaveFile_saveFileName: brains successfully loaded : " + this._playerBrains);
		            this._playerActiveSaveID = this.playerActiveSaveID();
		            this._playerHeadID = this.playerHeadID();
		            
//		            if ([_playerProfileAlias isEqualToString:NSLocalizedString(@"Zombie Farmer", "The default name for the player")])
//		                _playerProfileAlias = playerGameData.farmOwner;
		            if(this._playerProfileAlias == Core.Localization.getString("Zombie Farmer"))
		            { 
		            	this._playerProfileAlias = this._playerGameData._farmOwner;
		            }
		            
		            this._playerGameData._UDID = Core.Capabilities.getUniqueId();
		            this._playerGameData._playerProfileID = this._playerProfileID;
		        }
		        cb();
	    	}
		}.bind(this));	    
	},

	setGameData: function(gameData)
	{
//	    [[PlayerProfileManager playerProfileManager] log:[NSString stringWithFormat:@"Setting a new GameData for %@", playerProfileID]];
	    
	    if (gameData && !(gameData ===null))
	    {
	        // TODO: do more validation checks here
	        if ((gameData._playerProfileID) && !(gameData._playerProfileID === null) &&
	            !(gameData._playerProfileID == this._playerProfileID))
	        {
//	            NSString* message = [NSString stringWithFormat:@"Attempting to set a GameData with a player profile id of %@ into %@'s player profile", [gameData playerProfileID], playerProfileID];
//	            
//	#ifndef ZF_SUBMISSION
//	            UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Farm Stomping Occurring!"
//	                                                                message:message
//	                                                               delegate:self
//	                                                      cancelButtonTitle:nil
//	                                                      otherButtonTitles:NSLocalizedString(@"Ok", @"OK Button"), nil];
//	            
//	            [alertView show];
//	            [alertView release];
//	#endif
//	            
//	            [[PlayerProfileManager playerProfileManager] log:message];
	        }
	        
	        // Update our game data
	        this._playerGameData = gameData;
	        
	        this._playerGameData._playerProfileID = this._playerProfileID;
	        
	        
	        // Save out to file
	        this.save();
	    }
	    else
	    {
//	        [[PlayerProfileManager playerProfileManager] log:@"Unable to save because gameData was null"];
	    }
	},

	save: function()
	{
	    // Make sure we are saving data with a matching profile id
	    if (!this._playerGameData._playerProfileID || this._playerGameData.playerProfileID === null || this._playerGameData._playerProfileID == "UnknownPlayer")
	    {
	    	this._playerGameData._playerProfileID = this._playerProfileID;
	    }
	    else if (!(this._playerGameData._playerProfileID == this._playerProfileID))
	    {
//	        NSString* message = [NSString stringWithFormat:@"Failed to save %@'s data into %@'s file", playerProfileID, [playerGameData playerProfileID]];
//	        
//	#ifndef ZF_SUBMISSION
//	        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Farm Stomping Occurring!"
//	                                                            message:message
//	                                                           delegate:self
//	                                                  cancelButtonTitle:nil
//	                                                  otherButtonTitles:NSLocalizedString(@"Ok", @"OK Button"), nil];
//
//	        [alertView show];
//	        [alertView release];
//	#endif
//	        
//	        [[PlayerProfileManager playerProfileManager] log:message];
	        
	        return;
	    }
	    
	    // Let the GameData write itself to a file based on its playerProfileID
//	    [[PlayerProfileManager playerProfileManager] log:@"PlayerProfile is letting its GameData save itself"];
	    
	    this._playerGameData.save();
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/ZFMenus/FarmerSelection/ZFFarmerCell'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/FarmerSelection/ZFFarmerCell'] || {}; $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/FarmerSelection/ZFFarmerCell'] = exports; var cellSize = new Core.Size(70,70); 
exports.ZFFarmerCell = CCTableViewCell.subclass({
	classname : 'ZFFarmerCell',

	$cellSize : function() {
		return cellSize;
	},

	initialize : function() {
		this._cellLayer = CCColorLayer.layerWithColor(ccc3(0xbc, 0x96, 0x84), 70, 70);
		this._headID = 0;
		this._sprite = null;
		this._description = null;
		this._ability = null;
		this._isSelected = false;
		this.removeCheckMark();
	},

	destroy : function() {
//		this.removeCheckMark();
//		destroyWithChildren(this._checkMark);
//		this._checkMark = null;
//		
//		destroyWithChildren(this._sprite);
//		this._sprite = null;
//		
//		destroyWithChildren(this._description);
//		this._description = null;
//		
//		destroyWithChildren(this._ability);
//		this._ability = null;
//		
//		this._cellLayer.removeAllChildrenWithCleanup(true);
		destroyWithChildren(this._cellLayer);
		this._sprite = null;
		this._description = null;
		this._ability = null;
		this._selector = null;
		this._cellLayer = null;
	},

	isIndexEqualToHeadID : function(tableIndex) {
		// array index  : actual head id value
		// 0			: 0		(asian male)
		// 1			: 4		(asian female)
		// 2			: 1		(white male)
		// 3			: 5		(white female)
		// 4			: 10	(black male)
		// 5			: 11	(black female)
		// 6			: 12	(paper bag head)
		// 7			: 13	(monolith head)
		// 8			: 14	(pumpkin head)
		// 9			: 2		(skelly male)
		// 10			: 6		(skelly female)
		// 11			: 3		(vampire male)
		// 12			: 7		(vampire female)
		// 13			: 8		(zombie male)
		// 14			: 9		(zombie female)

		var hID = GameState._zfGameData._headID;
		var convertedIndex = ZFFarmerSelectionMenu.headIDFromTableIndex(tableIndex);

		return (convertedIndex == hID);
	},

	setHeadID : function(hID) {
		var gs = GameState;
		var point = ccp(0, -11);
		
		destroyChildren(this._cellLayer); 
		
//		this.removeCheckMark();
//		if (this._sprite) {
//			this._cellLayer.removeChild(this._sprite, true);
//			destroyWithChildren(this._sprite);
//		}
//
//		if (this._lockIcon) {
//			this._cellLayer.removeChild(this._lockIcon, true);
//			destroyWithChildren(this._lockIcon);
//		}

		this._available = true;
		this._sprite = null;
		this._description = null;
		this._ability = null;
		this._selector = null;
		
		switch (hID) {
		case 0:
			this._key = "asianHeadMale";
			this._selector = ZFFarmerSelectionMenu.asianHeadMaleSelected.bind(ZFFarmerSelectionMenu);
			this._description = NSLocalizedString("Male Head 1", "Male Head 1 Description");
			break;
		case 1:
			this._key = "asianHeadFemale";
			this._selector = ZFFarmerSelectionMenu.asianHeadFemaleSelected.bind(ZFFarmerSelectionMenu);
			this._description = NSLocalizedString("Female Head 1", "Female Head 1 Description");
			break;
		case 2:
			this._key = "whiteHeadMale";
			this._selector = ZFFarmerSelectionMenu.whiteHeadMaleSelected.bind(ZFFarmerSelectionMenu);
			this._description = NSLocalizedString("Male Head 2", "Male Head 2 Description");
			break;
		case 3:
			this._key = "whiteHeadFemale";
			this._selector = ZFFarmerSelectionMenu.whiteHeadFemaleSelected.bind(ZFFarmerSelectionMenu);
			this._description = NSLocalizedString("Female Head 2", "Female Head 2 Description");
			break;
		case 4:
			this._key = "blackHeadMale";
			this._selector = ZFFarmerSelectionMenu.blackHeadMaleSelected.bind(ZFFarmerSelectionMenu);
			this._description = NSLocalizedString("Male Head 3", "Male Head 3 Description");
			break;
		case 5:
			this._key = "blackHeadFemale";
			this._selector = ZFFarmerSelectionMenu.blackHeadFemaleSelected.bind(ZFFarmerSelectionMenu);
			this._description = NSLocalizedString("Female Head 3", "Female Head 3 Description");
			break;
		case 6:
			this._key = "paperBagHeadMale";
			this._selector = ZFFarmerSelectionMenu.paperBagHeadMaleSelected.bind(ZFFarmerSelectionMenu);
			this._description = NSLocalizedString("Paper Bag Head", "Paper Bag Head Description");
			this._ability = NSLocalizedString("+" + Math.floor(ZFGameDefines.HEAD_GOLD_BONUS * 100) + "% more gold for harvesting",
					"Paper Bag Ability Description");
			this._available = (gs._zfGameData._fflags & ZFGameFlags.FFLAG_HEAD07);
			break;
		case 7:
			this._key = "monolithHeadMale";
			this._selector = ZFFarmerSelectionMenu.monolithHeadMaleSelected.bind(ZFFarmerSelectionMenu.farmerSelectionMenu());
			this._description = NSLocalizedString("Monolith Head", "Monolith Head Description");
			this._ability = NSLocalizedString("-25% grow time for zombies (does not affect combine time)", "Monolith Ability Description");
			this._available = (gs._zfGameData._fflags & ZFGameFlags.FFLAG_HEAD08);
			break;
		case 8:
			this._key = "pumpkinHeadMale";
			this._selector = ZFFarmerSelectionMenu.pumpkinHeadMaleSelected.bind(ZFFarmerSelectionMenu.farmerSelectionMenu());
			this._description = NSLocalizedString("Pumpkin Head", "Pumpkin Head Description");
			this._ability = NSLocalizedString("+" + Math.floor(ZFGameDefines.HEAD_GOLD_BONUS * 100) + "% more gold for harvesting",
					"Pumpkin Head Ability Description");
			this._available = (gs._zfGameData._fflags & ZFGameFlags.FFLAG_HEAD09);
			break;
		case 9:
			this._key = "skeletonHeadMale";
			this._selector = ZFFarmerSelectionMenu.skeletonHeadMaleSelected.bind(ZFFarmerSelectionMenu.farmerSelectionMenu());
			this._description = NSLocalizedString("Skeleton Male", "Skeleton Male Description");
			this._ability = NSLocalizedString("+10% zombie life", "Skeleton Male Ability Description");
			this._available = (gs._zfGameData._fflags & ZFGameFlags.FFLAG_HEAD01);
			break;
		case 10:
			this._key = "skeletonHeadFemale";
			this._selector = ZFFarmerSelectionMenu.skeletonHeadFemaleSelected.bind(ZFFarmerSelectionMenu.farmerSelectionMenu());
			this._description = NSLocalizedString("Skeleton Female", "Skeleton Female Description");
			this._ability = NSLocalizedString("+10% zombie life", "Skeleton Female Ability Description");
			this._available = (gs._zfGameData._fflags & ZFGameFlags.FFLAG_HEAD03);
			break;
		case 11:
			this._key = "vampireHeadMale";
			this._selector = ZFFarmerSelectionMenu.vampireHeadMaleSelected.bind(ZFFarmerSelectionMenu.farmerSelectionMenu());
			this._description = NSLocalizedString("Vampire Male", "Vampire Male Description");
			this._ability = NSLocalizedString("+10% zombie strength", "Vampire Male Ability Description");
			this._available = (gs._zfGameData._fflags & ZFGameFlags.FFLAG_HEAD02);
			break;
		case 12:
			this._key = "vampireHeadFemale";
			this._selector = ZFFarmerSelectionMenu.vampireHeadFemaleSelected.bind(ZFFarmerSelectionMenu.farmerSelectionMenu());
			this._description = NSLocalizedString("Vampire Female", "Vampire Female Description");
			this._ability = NSLocalizedString("+10% zombie strength", "Vampire Female Ability Description");
			this._available = (gs._zfGameData._fflags & ZFGameFlags.FFLAG_HEAD04);
			break;
		case 13:
			this._key = "zombieHeadMale";
			this._selector = ZFFarmerSelectionMenu.zombieHeadMaleSelected.bind(ZFFarmerSelectionMenu.farmerSelectionMenu());
			this._description = NSLocalizedString("Zombie King", "Zombie King Description");
			this._ability = NSLocalizedString("-25% hunger time for zombies", "Zombie King Ability Description");
			this._available = (gs._zfGameData._fflags & ZFGameFlags.FFLAG_HEAD05);
			break;
		case 14:
			this._key = "zombieHeadFemale";
			this._selector = ZFFarmerSelectionMenu.zombieHeadFemaleSelected.bind(ZFFarmerSelectionMenu.farmerSelectionMenu());
			this._description = NSLocalizedString("Zombie Queen", "Zombie Queen Description");
			this._ability = NSLocalizedString("-25% hunger time for zombies", "Zombie Queen Ability Description");
			this._available = (gs._zfGameData._fflags & ZFGameFlags.FFLAG_HEAD06);
			break;
		}

		this._headID = hID;
		this._sprite = ZFFarmerSelectionMenu.addHeadWithSpriteKey_atPoint(this._key, point);
		this._sprite.setPosition(35, 10);
		this._sprite.setAnchorPoint(ccp(0.5, 0.5));

		if (!this._available) {
			this._lockIcon = CCSprite.spriteWithFile("lockIcon.png");
			this._lockIcon.setPosition(this._sprite.getPosition());
			this._cellLayer.addChild(this._lockIcon, 13);

			this._sprite.setColor(ccc3(0x80, 0x80, 0x80));
			this._sprite.setAlpha(0.8);
		}

		this._cellLayer.addChild(this._sprite, 12);
		if (ZFFarmerSelectionMenu._curHeadID == hID) {
			this.addCheckMark();
		} else {
			this.removeCheckMark();
		}
	},

	removeCheckMark : function() {
		this._cellLayer.removeChild(this._checkMark);
		destroy(this._checkMark);
		this._checkMark = null;
	},

	addCheckMark : function(point) {
		if (!point) {
			point = ccp(33, 7);
		}

		this._checkMark = CCSprite.spriteWithFile("farmerSelectHighlight.png");
		this._checkMark.setPosition(point);
		this._cellLayer.addChild(this._checkMark, 11);
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/ZFMenus/Market/ZFBuyable'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Market/ZFBuyable'] || {}; $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Market/ZFBuyable'] = exports; var Core = require('NGCore/Client/Core').Core;

var CCSprite = require('Code/Cocos2D/CCSprite').CCSprite;
var CCNode = require('Code/Cocos2D/CCNode').CCNode;
var CCMenu = require('Code/Cocos2D/CCMenu').CCMenu;
var CCLabel = require('Code/Cocos2D/CCLabel').CCLabel;
var CCSpriteSheet = require('Code/Cocos2D/CCSpriteSheet').CCSpriteSheet;
var CCLayer = require('Code/Cocos2D/CCLayer').CCLayer;


exports.ZFBuyable = CCLayer.subclass(
{
	classname: 'ZFBuyable',
	
	destroy: function()
	{
		destroyWithChildren(this.nameLabel);
		destroyWithChildren(this.costLabel);
		destroyWithChildren(this.infoLabel);
		destroyWithChildren(this.infoLabel2);
		destroyWithChildren( this.mgr);
		destroyWithChildren(this.spriteNode);
		destroyWithChildren(this.backgroundSprite);
		destroyWithChildren(this.newBadge);
		destroyWithChildren(this.buyButton);
		destroyWithChildren(this.lockIcon);
		destroyWithChildren(this.resourceIcon);
		destroyWithChildren(this.lifeforceIcon);		
		destroyWithChildren(this.zombieActor);
		this.removeAllChildrenWithCleanup(true);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/ZFMenus/MutationCollection/ZFMutationCell'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/MutationCollection/ZFMutationCell'] || {}; $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/MutationCollection/ZFMutationCell'] = exports; var cellSize = new Core.Size(67, 87);
exports.ZFMutationCell = CCTableViewCell.subclass({
	classname : 'ZFMutationCell',

	kMutationCellClearSelectorNotification : "kMutationCellClearSelectorNotification",

	$cellSize : function() {
		return cellSize;
	},

	initialize : function(callback) {
		this._callback = callback;
		//FIXME UIScreen
		//		var mainFrame = UIScreen.mainScreen().bounds();
		//      var resolutionWidth = mainFrame.getSize()._height;
		//      var resolutionHeight = mainFrame.getSize().getWidth);

		var cellSize = this.cellSize();
		var size = CGSizeMake(60, 80);
		var windowSize = CGRectMake(0, 0, size._width, size._height);
		var f = ZFGameDefines.HUDELEMENTS1_FILE;
		this._bg = CCColorLayer.layerWithColor(ccc3(0, 0, 0), cellSize._width, cellSize._height);
		this._bg._node.setAlpha(0);

		var bgOverlay = ZFMenu.makeWindow(windowSize, CGRectMake(37, 40, 11, 11), CGRectMake(49, 40, 11, 11), f, ZFColorDefines.colorMenuMutationGreen,
				CGRectMake(0, 0, 0, 0), CGRectMake(0, 0, 0, 0), CGRectMake(49, 40, 11, 9));

		var yOffset = 320;
		this._bg.addChild(bgOverlay, 1);
		bgOverlay.setPosition(ccpAdd(bgOverlay.getPosition(), ccp(0, 44 - yOffset/* - (resolutionHeight - 320)/2*/)));

		bgOverlay.__varName = "bgOverlay";

		for ( var i in bgOverlay._children) {
			var l = bgOverlay._children[i];

			//[l isKindOfClass:[CCSpriteSheet class]]
			if (l.classname == 'CCSpriteSheet' || l.classname == 'CCTMXLayer' || l.classname == 'CCBitmapFontAtlas') {
				for ( var j in l._children) {
					var s = l._children[j];
					s.setColor(ZFColorDefines.colorMenuMutationGreen);
				}
			}
		}
		
		var target = new GL2.TouchTarget();
		target.setAnchor(new Core.Point(0, 1));

		var screenSize = CCDirector.winSize();
		var initialY = screenSize._height-360;		
		target.setPosition(-2,-initialY);//-size._height*2
		
		target.setSize(cellSize._width, cellSize._height);
		target.getTouchEmitter().addListener(new Core.MessageListener(), this.onTouch.bind(this));
		this._bg.addChild(target, 100, null, true);
		target.setDepth(100000);
		
		this._selector = ZFMenu.makeWindow(windowSize, CGRectMake(37, 52, 11, 11), CGRectMake(49, 52, 11, 3), f, ccc4(0, 0, 0, 0), CGRectMake(0, 0, 0, 0),
				CGRectMake(0, 0, 0, 0), CGRectMake(49, 52, 3, 3));

		for ( var i in this._selector._children) {
			var l = this._selector._children[i];

			//[l isKindOfClass:[CCSpriteSheet class]]
			if (l.classname == 'CCSpriteSheet' || l.classname == 'CCTMXLayer' || l.classname == 'CCBitmapFontAtlas') {
				for ( var j in l._children) {
					var s = l._children[j];
					s.setColor(ZFColorDefines.colorTextHighlight);
				}
			}
		}
		this._selector.setPosition(ccpAdd(this._selector.getPosition(), ccp(0, 44 - 320)));
		this._bg.addChild(this._selector, 1);

		this._number = CCLabel.labelWithString("0", CGSizeMake(40, 40), GL2.Text.HorizontalAlign.Center, "Arial-BoldMT", 16);
		this._number.setColor(ZFColorDefines.colorTextWhite /*  ZFColorDefines.colorTextBlack*/);
		this._bg.addChild(this._number, 6, 4);
		this._number.setPosition(ccp(48, 36 + screenSize._height - 320));

		this._cellActor = null;
		this._cellID = -1;
		NSNotificationCenter.defaultCenter().addObserver(this, this.clearSelector, this.kMutationCellClearSelectorNotification, null);
	},

	onTouch : function(touch) {
		
		this._callback(this);
		return true;
//		switch (touch.getAction()) {
//		case touch.Action.Start:
//			return this.ccTouchBegan(touch);
//		case touch.Action.End:
//			this.ccTouchEnded(touch);
//			break;
//		case touch.Action.Move:
//			this.ccTouchMoved(touch);
//			break;
//		}
	},
	
	setCellID : function(cID) {
		this._cellID = cID;
		var numberToDisplay = this._cellID + 1;
		this._number.setString("" + numberToDisplay);

		this._selector.setVisible(false);
	},

	pressed : function(sender) {
		this._selector.setVisible(true);
	},

	clearSelector : function() {
		this._selector.setVisible(false);
	},

	destroy : function() {
		NSNotificationCenter.defaultCenter().removeObserver(this, this.kMutationCellClearSelectorNotification, null);

		if (this._cellActor) {
			this._cellActor.despawn();
			destroyWithChildren(this._cellActor);
			this._cellActor = null;
		}
		destroyWithChildren(this._selector);
		this._selector = null;
		
		destroyWithChildren(this._number);
		this._number = null;
		
		destroyWithChildren(this._bg);
		this._bg = null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/ZFMenus/Zombie/ZFAbilityCell'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Zombie/ZFAbilityCell'] || {}; $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Zombie/ZFAbilityCell'] = exports; exports.ZFAbilityCell = CCTableViewCell.subclass({
	classname: "ZFAbilityCell",

	$cellSize : function() {
		return new Core.Size(240, 49);
	},

	initialize : function($super) {
		$super();
		var size = this.cellSize();
		this._cellLayer = CCColorLayer.layerWithColor(ccc4(0xff, 0x0, 0x0, 0x00), size._width, size._height);

		this._ability = null;
		this._abilityIcon = null;
		this._abilityName = null;
		this._abilityDescription = null;

		this._lifeForce = null;
		this._lifeForceNeeded = null;
		this._lifeForceString = null;
	},

	destroy : function() {
		
//		destroyWithChildren(this._cellLayer);
		this.destroyAbility();
		this.destroyLifeForce();
		
//		this._cellLayer.removeAllChildrenWithCleanup(true);
		destroyWithChildren(this._cellLayer);
		this._cellLayer = null;
		
//		destroyWithChildren(this);
	},

	setAbility : function(a) {
		// called from cell for index function in menu class
		var gs = GameState;

		// initialize the variables	
		var fontName = "Arial";
		var fontsize = 8;
		
		this.destroyAbility();

		
		this._abilityName = CCLabel.labelWithString(a._abilityName, fontName, fontsize + 2);
		this._abilityName.setColor(ccc3(0x00, 0x00, 0x00));

		this._abilityDescription = CCLabel.labelWithString("???", CGSizeMake(190, 30), GL2.Text.HorizontalAlign.Left, fontName, fontsize - 1);
		this._abilityDescription.setColor(ccc3(0x00, 0x00, 0x00));

		this._abilityIcon = CCSprite.spriteWithFile(a._abilityIcon);

		if (a._unlocked) {
			this._abilityDescription.setString(a._abilityDescription);
		} else {
			// if they have the required lifeForce AND the required flag
			if (gs.getLuck() >= a._requiredLifeForce && gs._zfGameData._abilityFlags.hasFlag(a._flagBit)) {
				this._abilityIcon.setColor(ccc3(0x50, 0x50, 0x50)); // this was turned off because of a higher ranking ability
				this._abilityDescription.setString(a._abilityDescription);
			} else {
				this._abilityIcon.setColor(ccc3(0x50, 0x50, 0x50)); // this was turned off because of a higher ranking ability
				destroyWithChildren(this._abilityName);
				// tell them what boss to kill to unlock
				if (!gs._zfGameData._abilityFlags.hasFlag(a._flagBit)) {
					destroyWithChildren(this._abilityIcon);
					this._abilityIcon = CCSprite.spriteWithFile("emptyIcon.png");
					this._abilityIcon.setColor(ccc3(0x80, 0x80, 0x80));

					var msg = null;
					switch (a._tier) {
					case 1:
						msg = NSLocalizedString("Defeat Old McDonnell to unlock!");
						break;
					case 2:
						msg = NSLocalizedString("Defeat CorporateVille to unlock!");
						break;
					case 3:
						msg = NSLocalizedString("Defeat Arrrnold to unlock!");
						break;
					case 4:
						msg = NSLocalizedString("Defeat Mr.Whiskers to unlock!");
						break;
					}
					
					this._abilityName = CCLabel.labelWithString(msg, fontName, fontsize);
					this._abilityName.setColor(ccc3(0x00, 0x00, 0x00));
				} 
				else // lets em know that they need life force if flag is present
				{
					var msg = NSLocalizedString("Collect more life force");
					this._abilityName = CCLabel.labelWithString(msg, fontName, fontsize);
					this._abilityName.setColor(ccc3(0x00, 0x00, 0x00));

				}

			}
		}
		
		this.destroyLifeForce();
		
		destroyChildren(this._cellLayer);
		this._lifeForceIcon = CCSprite.spriteWithFile("lifeForce.png");

		// cell size = 240 ... bar size = 240 -64 - 5
		var size = new Core.Size(171, 24);

		// color layer anchor points are at bottom left ... sprites and strings are default in the middle

		this._lifeForce = CCColorLayer.layerWithColor(ccc4(0x30, 0xb0, 0x20, 0xff), size._width - 4, size._height - 4);
		this._lifeForceNeeded = CCColorLayer.layerWithColor(ccc4(0x00, 0x00, 0x00, 0xFF), size._width, size._height);

		var currentLifeForce = gs.getLuck();

		this._lifeForce.setScale(currentLifeForce / a._requiredLifeForce, this._lifeForce.getScale()._y);
		this._lifeForce.setScale((this._lifeForce.getScale()._x > 1) ? 1 : this._lifeForce.getScale()._x, this._lifeForce.getScale()._y);

		//TODO: ZombieFarmAppDelegate
		if (true/*ZombieFarmAppDelegate.getCurrentLanguage().isEqualToString("zh-Hant") || ZombieFarmAppDelegate.getCurrentLanguage().isEqualToString("zh-Hans") ||
						ZombieFarmAppDelegate.getCurrentLanguage().isEqualToString("ja") */) {
			currentLifeForce = (currentLifeForce > a._requiredLifeForce) ? a._requiredLifeForce : currentLifeForce;
			//			this._lifeForceString = [CCLabel.labelWithString([NSString stringWithFormat:@"%d/%d",currentLifeForce,a.requiredLifeForce], "Arial", 26];
			this._lifeForceString = CCLabel.labelWithString(currentLifeForce + "/" + a._requiredLifeForce, "Arial", 26);
		} else {
			var fntFile = "ABD26.fnt";
			currentLifeForce = (currentLifeForce > a._requiredLifeForce) ? a._requiredLifeForce : currentLifeForce;
			//			this._lifeForceString = [CCBitmapFontAtlas bitmapFontAtlasWithString:[NSString stringWithFormat:@"%d/%d",currentLifeForce,a.requiredLifeForce] fntFile:fntFile];
			this._lifeForceString = CCBitmapFontAtlas.bitmapFontAtlasWithString(currentLifeForce + "/" + a._requiredLifeForce, fntFile);
		}

		// set the positions and anchor points (where applicable)

		var offsety = -5;
		
		this._abilityIcon.setAnchorPoint(ccpF(0, 0));
		this._abilityIcon.setPosition(0, 7);

		this._abilityName.setAnchorPoint(ccpF(0, 0));
		this._abilityName.setPosition(50, 42);

		this._abilityDescription.setAnchorPoint(ccpF(0, 0));
		this._abilityDescription.setPosition(50, 30);

		this._lifeForce.setAnchorPoint(ccpF(0, 0));
		this._lifeForce.setPosition(50 + 2, 6 + 1 - offsety);

		this._lifeForceNeeded.setAnchorPoint(ccpF(0, 0));
		this._lifeForceNeeded.setPosition(50, 6 - offsety);
		this._lifeForceString.setAnchorPoint(ccpF(0, 0.5));
		this._lifeForceString.setPosition(this._lifeForceNeeded._ccPosition._x + this._lifeForceNeeded._contentSize._width / 2,
				this._lifeForceNeeded._ccPosition._y /*+ this._lifeForceNeeded._contentSize._height / 2*/);
		this._lifeForceIcon.setAnchorPoint(ccpF(0, 0.5));
		this._lifeForceIcon.setPosition(this._lifeForceString._ccPosition._x - 24, this._lifeForceString._ccPosition._y);
		this._lifeForceString.setScale(0.5);

		// add to layer
		this._cellLayer.addChild(this._abilityIcon);
		this._cellLayer.addChild(this._abilityName);
		
		if (!(gs._zfGameData._abilityFlags.hasFlag(a._flagBit))
				|| ( (currentLifeForce >= a._requiredLifeForce) && gs._zfGameData._abilityFlags.hasFlag(a._flagBit)) ) {
			this._cellLayer.addChild(this._abilityDescription);

			this.destroyLifeForce();
			
		} else {
			this._cellLayer.addChild(this._lifeForceNeeded);
			this._cellLayer.addChild(this._lifeForce);
			this._cellLayer.addChild(this._lifeForceString);
			this._cellLayer.addChild(this._lifeForceIcon);
			
			this.destroyAbility(true);
		}
	},

	destroyLifeForce : function(){
		destroyWithChildren(this._lifeForceIcon);
		destroyWithChildren(this._lifeForce);
		destroyWithChildren(this._lifeForceNeeded);
		destroyWithChildren(this._lifeForceString);
	},
	
	destroyAbility : function(noIconName){
		
		destroyWithChildren(this._abilityDescription);
		if(!noIconName){
			destroyWithChildren(this._abilityIcon);
			destroyWithChildren(this._abilityName);
		}
	},
	
	pressed : function(sender) {

	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/ZFMenus/Quest/ZFQuestCell'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Quest/ZFQuestCell'] || {}; $MODULE_REGISTRY['Code/Game/GUI/ZFMenus/Quest/ZFQuestCell'] = exports; var cellSize = new Core.Size(154, 36);
exports.ZFQuestCell = CCTableViewCell.subclass({
	classname : 'ZFQuestCell',

	kQuestCellClearSelectorNotification : "kQuestCellClearSelectorNotification",

	$cellSize : function() {
		return cellSize;
	},

	initialize : function() {
		this._bg = CCColorLayer.layerWithColor(ccc4(0x47, 0x92, 0x21, 0x00), 154, 20);

		this._cellID = -1;
		this._questID = -1;
		this.clearSelector();
		NSNotificationCenter.defaultCenter().addObserver(this, this.clearSelector, this.kQuestCellClearSelectorNotification, null);
	},

	destroy : function() {
		this.clearSelector();
		NSNotificationCenter.removeObserver(this, this.kQuestCellClearSelectorNotification, null);

		if (this._bgLight) {
			this._bg.removeChild(this._bgLight);
			destroyWithChildren(this._bgLight);
			this._bgLight = null;
		}

		if (this._name) {
			destroyWithChildren(this._name);
			this._name = null;
		}

		if (this._icon) {
			destroyWithChildren(this._icon);
			this._icon = null;
		}

		this._bg.removeAllChildrenWithCleanup(true);
		destroyWithChildren(this._bg);
		this._bg = null;

		this._quest = null;
	},

	setQuestID : function(paramID) {
		this._bg.removeAllChildrenWithCleanup(false);
		this._questID = paramID;

		var qm = ZFQuestMan;

		if (this._questID >= qm._questArray.length) {
			return;
		}

		this._quest = qm._questArray[this._questID];
		if(this._icon)
		{
			destroyWithChildren(this._icon);
		}
		if(this._name)
		{
			destroyWithChildren(this._name);
		}
		this._icon = CCSprite.spriteWithFile(this._quest.sprite);

		var name = NSLocalizedString(this._quest.title);
		var fontSize = 10;
		if(name.length > 17 ){
			fontSize = 7;
		}
		this._name = CCLabel.labelWithString(name, new Core.Size(100, 20), GL2.Text.HorizontalAlign.Left, "AmericanTypewriter-Bold", fontSize);

		this._bg.addChild(this._icon, 1);
		this._bg.addChild(this._name, 1);

		this._icon.setPosition(ccp(25, 12));
		this._icon.setScale(0.6);
		this._name.setPosition(ccp(96, 10));
	},

	pressed : function(sender) {
		this._bgLight = CCColorLayer.layerWithColor(ccc4(0x47, 0x92, 0x21, 0xFF), 154, 35);
		this._bgLight.setPosition(ccp(0, 12));
		this._bg.addChild(this._bgLight, 0);
	},

	clearSelector : function() {
		this._bg.removeChild(this._bgLight, true);
		destroyWithChildren(this._bgLight);
		this._bgLight = null;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/GuiLayer/ZFProgressBar'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/GuiLayer/ZFProgressBar'] || {}; $MODULE_REGISTRY['Code/Game/GUI/GuiLayer/ZFProgressBar'] = exports; exports.ZFProgressBar = CCLayer.subclass(
{
	classname: 'ZFProgressBar',
	
	initialize: function()
	{
		this._bar 		= new CCSprite();
		this._frame 	= new CCSprite();
		this._text 		= null;
		this._actionString = "";
	}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/GuiLayer/ZFToolsLayer'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/GuiLayer/ZFToolsLayer'] || {}; $MODULE_REGISTRY['Code/Game/GUI/GuiLayer/ZFToolsLayer'] = exports; //var ZFToolManager = require('./../../Tools/ZFToolManager').ZFToolManager;

//var ZFMarketMenu = require('./../ZFMenus/Market/ZFMarketMenu').ZFMarketMenu;
var ZFColorDefines = require('Code/Game/ZFColorDefines').ZFColorDefines;
var ZFActorManager = require('Code/Game/Actor/ZFActorManager').ZFActorManager;

var TOOLMENU_PADDING  	= 12;
var TOOLMENU_BUTTONSIZE = 60;

exports.ZFToolsLayer = CCLayer.subclass(
{
	classname: "ZFToolsLayer",
		
	initialize: function()
	{
		var winSize = CCDirector.winSize();
		var widthScale = UI.Window._width / 480.0; 
		var heightScale = UI.Window._height / 320.0;
		
		var menuFontSize = 12;
		var menuFontName = "AmericanTypewriter-Bold"; //TODO 

		this._toolName = CCLabel.labelWithString(Core.Localization.getString("Multi Tool"), menuFontName, menuFontSize + 8);
		this._toolName.setPosition(ccp(winSize._width - (58 + 12), 25 + 5));	
		this._toolName.setColor(new Core.Color(1,1,1));
		this._toolName.setAnchorPoint(ccp(1, 0.5));
		this.addChild(this._toolName, 1);
		this._toolName.setOpacity(0);
		
		this._toolNameShadow = CCLabel.labelWithString(Core.Localization.getString("Multi Tool"), menuFontName, menuFontSize + 8);
		this._toolNameShadow.setPosition(ccp(winSize._width - (58 + 10), 23 + 5));
		this._toolNameShadow.setAnchorPoint(ccp(1, 0.5));
		this._toolNameShadow.setColor(new Core.Color(0,0,0));
		this._toolNameShadow.setOpacity(0);
		this.addChild(this._toolNameShadow, 0);
		
		//game tools
		var sprite1 = CCSprite.spriteWithFile("multiButton.png");
		var sprite2 = CCSprite.spriteWithFile("multiButton.png");		
		sprite2.setColor(ccc3(128, 128, 128));
		this._activeTool = new CCMenuItemImage();
		this._activeTool.initFromNormalSprite(sprite1, sprite2, this, this.toggleActiveTool.bind(this));
		
		var sprite1 = CCSprite.spriteWithFile("multiButton.png");
		var sprite2 = CCSprite.spriteWithFile("multiButton.png");		
		sprite2.setColor(ccc3(128, 128, 128));
		this._multiTool = new CCMenuItemImage();
		this._multiTool.initFromNormalSprite(sprite1, sprite2, this, this.toggleMultiTool.bind(this));
		
		var sprite1 = CCSprite.spriteWithFile("moveButton.png");
		var sprite2 = CCSprite.spriteWithFile("moveButton.png");		
		sprite2.setColor(ccc3(128, 128, 128));
		this._moveTool = new CCMenuItemImage();
		this._moveTool.initFromNormalSprite(sprite1, sprite2, this, this.toggleMoveTool.bind(this));
		
		var sprite1 = CCSprite.spriteWithFile("plowButton.png");
		var sprite2 = CCSprite.spriteWithFile("plowButton.png");		
		sprite2.setColor(ccc3(128, 128, 128));
		this._plowTool = new CCMenuItemImage();
		this._plowTool.initFromNormalSprite(sprite1, sprite2, this, this.togglePlowTool.bind(this));

		var sprite1 = CCSprite.spriteWithFile("deleteButton.png");
		var sprite2 = CCSprite.spriteWithFile("deleteButton.png");		
		sprite2.setColor(ccc3(128, 128, 128));
		this._deleteTool = new CCMenuItemImage();
		this._deleteTool.initFromNormalSprite(sprite1, sprite2, this, this.toggleDeleteTool.bind(this));
		
		var sprite1 = CCSprite.spriteWithFile("rotateButton.png");
		var sprite2 = CCSprite.spriteWithFile("rotateButton.png");		
		sprite2.setColor(ccc3(128, 128, 128));
		this._rotateTool = new CCMenuItemImage();
		this._rotateTool.initFromNormalSprite(sprite1, sprite2, this, this.toggleRotateTool.bind(this));
		
		//game menus
		var sprite1 = CCSprite.spriteWithFile("marketButton.png");
		var sprite2 = CCSprite.spriteWithFile("marketButton.png");		
		sprite2.setColor(ccc3(128, 128, 128));
		this._marketMenuItem = new CCMenuItemImage();
		this._marketMenuItem.initFromNormalSprite(sprite1, sprite2, this, this.openMarketMenu.bind(this));

		var sprite1 = CCSprite.spriteWithFile("storageButton.png");
		var sprite2 = CCSprite.spriteWithFile("storageButton.png");		
		sprite2.setColor(ccc3(128, 128, 128));
		this._storageMenuItem = new CCMenuItemImage();
		this._storageMenuItem.initFromNormalSprite(sprite1, sprite2, this, this.openStorageMenu.bind(this));

		var sprite1 = CCSprite.spriteWithFile("zombieButton.png");
		var sprite2 = CCSprite.spriteWithFile("zombieButton.png");		
		sprite2.setColor(ccc3(128, 128, 128));
		this._zombieMenuItem = new CCMenuItemImage();
		this._zombieMenuItem.initFromNormalSprite(sprite1, sprite2, this, this.openZombieMenu.bind(this));
		
		// TODO: Remove after test.
		//this.initPiano();
		
		ZFToolManager.toolManager()._currentGameTool = ZFToolManager.kGameTool.kGameToolMulti;
		var tool = ZFToolManager.toolManager()._tools[ZFToolManager.kGameTool.kGameToolMulti];
		tool._state = ZFGameTool.kGameToolState.kGameToolStateNothingSelected;
		
		this._toolMenu = CCMenu.menuWithItems([this._activeTool, this._multiTool, this._moveTool, this._rotateTool, this._plowTool, this._deleteTool]);
		this._toolMenu.setPosition(this._toolMenuHiddenPos());
		
		this._toolMenu.alignItemsHorizontallyWithPadding(TOOLMENU_PADDING);
		this.addChild(this._toolMenu);
		
		this._menuMenu = null;
		if(false && widthScale > 1)
		{
			this._menuMenu = CCMenu.menuWithItems([this._zombieMenuItem, this._storageMenuItem, this._marketMenuItem]);
			this._menuMenu.setPosition(this._menuMenuHiddenPos());
			this._menuMenu.alignItemsHorizontallyWithPadding(TOOLMENU_PADDING - 4); 
		}
		else 
		{
			this._menuMenu = CCMenu.menuWithItems([this._zombieMenuItem, this._storageMenuItem, this._marketMenuItem]);
			this._menuMenu.setPosition(this._menuMenuHiddenPos());
			this._menuMenu.alignItemsVerticallyWithPadding(TOOLMENU_PADDING - 4);
		}
		this.addChild(this._menuMenu);
		
	},
	
	initPiano: function()
	{
		var items = new Array();
		
		for ( var i = 0 ; i < 10 ; i++ )
		{
			var sprite1 = CCSprite.spriteWithFile("zombieButton.png");
			var sprite2 = CCSprite.spriteWithFile("zombieButton.png");	
			
			sprite1.setScale( ccp( 0.5 , 0.5 ) );
			sprite2.setScale( ccp( 0.5 , 0.5 ) );
			
			sprite2.setColor(ccc3(128, 128, 128));
			var item = new CCMenuItemImage();
			item.initFromNormalSprite( sprite1, sprite2, this, ZFActorManager.pianoTouched.bind( ZFActorManager , i ) );
			items.push( item );
		}
		
		var piano = CCMenu.menuWithItems( items );
		piano.setPosition( ccp( 130 , 250 ) );
		piano.alignItemsHorizontallyWithPadding(TOOLMENU_PADDING - 32 );
		
		this.addChild( piano );
	},
	
	_toolMenuHiddenPos: function()
	{
//		var winSize = new Core.Size(UI.Window._width, UI.Window._height);
//		var widthOffset = 0;
//		if(winSize._width > 480)
//		{
//			widthOffset = 7; //hidden position is slightly more left in iPad
//		}
//		
//		return ccp(winSize._width + ((TOOLMENU_BUTTONSIZE * this._toolMenu.childrenCount()) + ((TOOLMENU_PADDING-2) * this._toolMenu.childrenCount() - 1)) / 2 - TOOLMENU_BUTTONSIZE*1.5 - widthOffset, 0);
		
		var w = CCDirector.winSize();
		var widthOffset = 0;
		if (w._width > ZFGameDefines.ORIGINAL_WINDOW_WIDTH)
		{
			widthOffset = 7;	//hidden position is slightly more left in iPad
		}
		return ccp(w._width + ((TOOLMENU_BUTTONSIZE * this._toolMenu.childrenCount()) + ((TOOLMENU_PADDING-2) * this._toolMenu.childrenCount() - 1)) / 2 - TOOLMENU_BUTTONSIZE*(/*anchor adjust*/1.5) - widthOffset , 0); //TOOLMENU_BUTTONSIZE/2 removed because of change on default anchor point
	},
	
	_toolMenuExpandedPos: function()
	{
		var w = CCDirector.winSize();
		return ccp(2+w._width - TOOLMENU_BUTTONSIZE*5, 0);//-TOOLMENU_BUTTONSIZE/2 to adjust to 800x480 screen. TOOLMENU_BUTTONSIZE/2 removed because of change on default anchor point
	},
	
	_menuMenuHiddenPos: function()
	{
		var w = CCDirector.winSize();
		if (false && w._width > ZFGameDefines.ORIGINAL_WINDOW_WIDTH)
		{
			return ccp(2+w._width + ((TOOLMENU_BUTTONSIZE * this._toolMenu.childrenCount()) + ((TOOLMENU_PADDING-2) * this._toolMenu.childrenCount() - 1)) / 2 - TOOLMENU_BUTTONSIZE * 1.5, 0); // TOOLMENU_BUTTONSIZE/2
		}
		return ccp(1 + w._width - TOOLMENU_BUTTONSIZE, ((TOOLMENU_BUTTONSIZE * this._menuMenu.childrenCount() + 1) + ((TOOLMENU_PADDING-2) * this._menuMenu.childrenCount() - 1)) / -2);
	},
	
	_menuMenuExpandedPos: function()
	{
		var w = CCDirector.winSize();
		if (false && w._width > ZFGameDefines.ORIGINAL_WINDOW_WIDTH)
		{
			return ccp(2+w._width/2 + 7*TOOLMENU_BUTTONSIZE - TOOLMENU_BUTTONSIZE - 10, 0); //- TOOLMENU_BUTTONSIZE - 10 to adjust to 800x480 screen //in iPad, keep all tool buttons on the bottom
		}
		return ccp(1 + w._width - TOOLMENU_BUTTONSIZE, /*w._height/2 +*/ TOOLMENU_BUTTONSIZE*6);
	},
	
	
	
	toggleActiveTool: function()
	{
		var gui = this._parent;
		//ZFGuiLayer.instantiate(); 
		
		//gui.hideEnemyMenu(null);
		//gui.removeToolTip();
		var toolID = ZFToolManager._currentGameTool;
		if (toolID == ZFToolManager.kGameTool.kGameToolPlant || toolID == ZFToolManager.kGameTool.kGameToolInstaGrow) {
			var tool = ZFToolManager._tools[toolID];
			tool._sprite.setOpacity(0x00);
			destroy(tool._spriteNode);
		}

		this._toolName.setOpacity(0);
		this._toolNameShadow.setOpacity(0);
		
//		var moveTo1 = new CCMoveTo();
//		var moveTo2 = new CCMoveTo();
//		var fadeTo = new CCFadeTo();
		
		var expandedPos1 = this._toolMenuExpandedPos();
		var hiddenPos1 = this._toolMenuExpandedPos();
		var expandedPos2 = this._menuMenuExpandedPos();
		var hiddenPos2 = this._menuMenuExpandedPos();
		
		
		if(ccpEqual(this._toolName.getPosition(), expandedPos1))
		{
			this._toolMenu.runAction( CCMoveTo.actionWithDuration( 0.25 , hiddenPos1 ) );
			this._menuMenu.runAction( CCMoveTo.actionWithDuration( 0.25 , hiddenPos2 ) );
			this._activeTool.runAction( CCFadeTo.actionWithDuration( 0.25 , 255 ) );
//			moveTo1.actionWithDuration(0.25, hiddenPos1);
//			moveTo2.actionWithDuration(0.25, hiddenPos2);
//			fadeTo.actionWithDuration(0.25, 255);
		}
		else
		{
			this._toolMenu.runAction( CCMoveTo.actionWithDuration( 0.25 , expandedPos1 ) );
			this._menuMenu.runAction( CCMoveTo.actionWithDuration( 0.25 , expandedPos2 ) );
			this._activeTool.runAction( CCFadeTo.actionWithDuration( 0.25 , 0 ) );
//			moveTo1.actionWithDuration(0.25, expandedPos1);
//			moveTo2.actionWithDuration(0.25, expandedPos2);
//			fadeTo.actionWithDuration(0.25, 0);			
		}
		
//		this._toolMenu.runAction(moveTo1);
//		this._menuMenu.runAction(moveTo2);
//		this._activeTool.runAction(fadeTo);
	},
	
		//- (void)replaceActiveToolButton:(NSString*)imageName
		//{
//			/*CCMenuItemImage *item1 = [activeTool.subItems objectAtIndex:0];
//			CCMenuItemImage *item2 = [activeTool.subItems objectAtIndex:1];
//			[activeTool removeChild:item1 cleanup:YES];
//			[activeTool removeChild:item2 cleanup:YES];
//			item1 = [CCMenuItemImage itemFromNormalImage:imageName selectedImage:imageName];
//			item2 = [CCMenuItemImage itemFromNormalImage:imageName selectedImage:imageName];
//			[activeTool.subItems replaceObjectAtIndex:0 withObject:item1];
//			[activeTool.subItems replaceObjectAtIndex:1 withObject:item2];
//			[activeTool setSelectedIndex:1];
//			[activeTool setSelectedIndex:0];*/
		//	
//			CCSprite *sprite1 = [CCSprite spriteWithFile:imageName];
//			CCSprite *sprite2 = [CCSprite spriteWithFile:imageName];
//			sprite2.color = ccc3(0x80, 0x80, 0x80);
//			activeTool.normalImage = sprite1;
//			activeTool.selectedImage = sprite2;
		//}
		//

	
	toggleMultiTool: function()
	{
		//- (void)toggleMultiTool: (id)sender
		//{	
//			[self toggleTool:kGameToolMulti withButtonImageName:@"multiButton.png" withToolName:@"Multi Tool"];
		//	
//			NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
//													@"multi", @"Tool type",
//													nil];
//			[[EventTracker eventTracker] sendEvent:@"zf_farm_sel_tool" withParameters:eventDictionary andDelegate:nil];
		//}
		
		//TODO update with args
		this.toggleTool(ZFToolManager.kGameTool.kGameToolMulti, "multiButton.png", "Multi Tool");
	},
	

	
	toggleMoveTool: function()
	{
		this.toggleTool(ZFToolManager.kGameTool.kGameToolMove, "moveButton.png", "Move Tool");
//		
//		NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
//												@"move", @"Tool type",
//												nil];
//		[[EventTracker eventTracker] sendEvent:@"zf_farm_sel_tool" withParameters:eventDictionary andDelegate:nil];
	},
	
	togglePlowTool: function()
	{
		this.toggleTool(ZFToolManager.kGameTool.kGameToolPlow, "plowButton.png", "Plow Tool");


//		NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
//												@"plow", @"Tool type",
//												nil];
//		[[EventTracker eventTracker] sendEvent:@"zf_farm_sel_tool" withParameters:eventDictionary andDelegate:nil];	
	},
	 
	
	toggleDeleteTool: function()
	{
		this.toggleTool(ZFToolManager.kGameTool.kGameToolDelete, "deleteButton.png", "Sell Tool");
		
//		NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
//												@"sell", @"Tool type",
//												nil];
//		[[EventTracker eventTracker] sendEvent:@"zf_farm_sel_tool" withParameters:eventDictionary andDelegate:nil];
	},
	
		
	toggleRotateTool: function()
	{
		this.toggleTool(ZFToolManager.kGameTool.kGameToolRotate, "rotateButton.png", "Rotate Tool");
		
		//HACK CHEAT		
//		//shorten all timers
//		console.log('tiles crops shorten timer');
//		//crops
//		for(var key in TSprite.allMySprites())
//		{
//			var tSprite = TSprite.allMySprites()[key];
//			if(tSprite && tSprite._tile && tSprite._tile._date)
//			{
//				tSprite._tile._date.setTime(tSprite._tile._date.getTime() - 60*60*1000);
//			}
//		}
		//CHEAT level and gold	
//		gs = GameState;
//		gs.addResource(GameData.gameResources.kGameResourceGold, 10000);
//		gs.addResource(GameData.gameResources.kGameResourceBrains, 10000);
//		gs._zfGameData._level = ZFGameDefines.MAXLEVEL - 1;
//		gs.levelUp();		

//END HACK CHEAT		

//		NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
//												@"rotate", @"Tool type",
//												nil];
//		[[EventTracker eventTracker] sendEvent:@"zf_farm_sel_tool" withParameters:eventDictionary andDelegate:nil];	
	},
	
	openMarketMenu: function()
	{
		ZFMarketMenu.openMenu();
		this.toggleTool(ZFToolManager.kGameTool.kGameToolMulti, "multiButton.png", "Multi Tool", true);
		this.disableMenus();
		
//		NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
//										@"market", @"Tool type",
//										 nil];
//		[[EventTracker eventTracker] sendEvent:@"zf_farm_sel_tool" withParameters:eventDictionary andDelegate:nil];	
	}, 
	
	openStorageMenu: function()
	{
		
		
		this.toggleTool(ZFToolManager.kGameTool.kGameToolMulti, "multiButton.png", "Multi Tool", true);
		ZFStorageMenu.openMenu();

		
//		NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
//												@"storage", @"Tool type",
//												nil];
//		[[EventTracker eventTracker] sendEvent:@"zf_farm_sel_tool" withParameters:eventDictionary andDelegate:nil];
//			
		
		
//		//TEST
//		var ZFAlertWindow = require("./../AlertWindows/ZFAlertWindowQuestComplete").ZFAlertWindowQuestComplete;
//		var quest = new Core.Class();
//		quest.title = "Quest Title";
//		quest.requirments = [];
//		quest.messageComplete = "Quest Message Complete";
//		quest.spriteFilename = "quest_icon_brainfreeze.png";
//		quest.requirments.text = "Quest Text";
//		quest.rewardType = 1;
//		quest.rewardObject = 1;
//		var alert = ZFAlertWindow.alertWindowWithQuest(quest);		
//		alert.display();
//		this._parent.addChild(alert);
	},
	
	openZombieMenu: function()
	{
		this.toggleTool(ZFToolManager.kGameTool.kGameToolMulti, "multiButton.png", "Multi Tool", true);
		
		if(GameState.curArmySize() > 0)
		{
			ZFZombieMenu.openMenu();
		}
		else if(ZFMausoleumMenu.containsZombie())
		{
			ZFMausoleumMenu.openMenu();
		}
		else 
		{
			ZFZombieMenu.noZombieMessage();
		}

		this.disableMenus();
		
//		NSMutableDictionary *eventDictionary = [NSMutableDictionary dictionaryWithObjectsAndKeys:
//												@"army", @"Tool type",
//												nil];
//		[[EventTracker eventTracker] sendEvent:@"zf_farm_sel_tool" withParameters:eventDictionary andDelegate:nil];
	
	}, 
	
	replaceActiveToolButton: function(imageName)
	{
		this._activeTool.replaceSprites(imageName, imageName);
		this._activeTool._disabledSprite.setColor(ccc3(128,128,128));
	},
	
	toggleTool: function(toolType, imageName, toolLabelName, forceNotToolName)
	{
		var gui = ZFGuiLayer;
		gui.hideEnemyMenu(null);
		
		var interval = 0.25; 
		ZFToolManager.toolSelected(toolType);
		
		this.replaceActiveToolButton(imageName);
		this.closeToolMenu();
		this._toolName.setString(Core.Localization.getString(toolLabelName));
		this._toolNameShadow.setString(Core.Localization.getString(toolLabelName));
		this.unschedule(this.showToolName);
		this.unschedule(this.holdToolName);
		this.unschedule(this.hideToolName);
		if(!forceNotToolName){
			this.schedule(this.showToolName, interval);
		}
		
//		console.log(this._toolName);
	},

		
	hideActiveToolButton: function()
	{
		this._activeTool.setVisible(false);
	},
	
	unhideActiveToolButton: function()
	{
		this._activeTool.setVisible(true);
	},

	closeToolMenu: function()
	{
		var interval = 0.25;
		
//		var moveTo1 = new CCMoveTo();
//		moveTo1.actionWithDuration(interval, this._toolMenuHiddenPos());
		this._toolMenu.runAction( CCMoveTo.actionWithDuration( interval , this._toolMenuHiddenPos() ) );
		
//		var moveTo2 = new CCMoveTo();
//		moveTo2.actionWithDuration(interval, this._menuMenuHiddenPos());
		this._menuMenu.runAction( CCMoveTo.actionWithDuration( interval , this._menuMenuHiddenPos() ) );
		
//		var fadeTo = new CCFadeTo();
//		fadeTo.actionWithDuration(interval, 255);
		this._activeTool.runAction( CCFadeTo.actionWithDuration( interval , 255 ) );
		
		this._toolName.setOpacity( 0 );
		this._toolNameShadow.setOpacity( 0 );
	},

	disableMenus: function()
	{
		for (var itemKey in this._toolMenu._children)
		{
			var item = this._toolMenu._children[itemKey];
			item.isEnabled = false;
		}
		
		for (var itemKey in this._menuMenu._children)
		{
			var item = this._menuMenu._children[itemKey];
			item.isEnabled = false;
		}
		
		this._toolMenu.setVisible(false);
		this._menuMenu.setVisible(false);
	},

	showToolName: function(dt)
	{
		this.unschedule(this.showToolName);
		this.schedule(this.holdToolName, 0.5);
		this.fadeToolNameWithDuration(0.5, 255);
	},
	
	holdToolName: function(dt)
	{
		this.unschedule(this.holdToolName);
		this.schedule( this.hideToolName, 2 );
	},
	
	hideToolName: function(dt)
	{
		this.unschedule(this.hideToolName);
		this.fadeToolNameWithDuration(0.5, 0);
	},
	
	setToolLabel: function(name)
	{
		this._toolName.setString(name);
		this._toolNameShadow.setString(name);
		
		this.fadeToolNameWithDuration(0.5,0xFF);
		this.unschedule(this.showToolName);
		this.unschedule(this.holdToolName);
		this.unschedule(this.hideToolName);
	},
	
	fadeToolNameWithDuration: function(interval, opacity)
	{
		var fadeTo1 = CCFadeTo.actionWithDuration(interval, opacity);
		var fadeTo2 = CCFadeTo.actionWithDuration(interval, opacity);
		
		this._toolName.runAction(fadeTo1);
		this._toolNameShadow.runAction(fadeTo2);
	},

	enableMenus: function ()
	{
		for(var itemKey in this._toolMenu._children)
		{
			var item = this._toolMenu._children[itemKey];
			item.isEnabled = true;
		}
		
		for(var itemKey in this._menuMenu._children)
		{
			var item = this._menuMenu._children[itemKey];
			item.isEnabled = true;
		}
		
		this._toolMenu.setVisible(true);
		this._menuMenu.setVisible(true);
	},
});
		
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Tools/ZFGameAction'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Tools/ZFGameAction'] || {}; $MODULE_REGISTRY['Code/Game/Tools/ZFGameAction'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.ZFGameAction = Core.Class.subclass(
{
	classname:'ZFGameAction',

	$gameCommands: 
	{
		kGameCommandNothing: 0,
		kGameCommandPlow: 1,
		kGameCommandHarvest: 2,
		kGameCommandPlant: 3,
		kGameCommandMAX: 4,
	},

	
	initialize: function()
	{
		this._command = 0;
		this._tile = new Core.Point();
		this._rect = new Core.Rect();
		this._cost = 0;
		this._resourceTypeNeeded = 0;
		this._item =  [];
		this._soundID = 0;
	},
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/GuiLayer/ZFScrollingText'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/GuiLayer/ZFScrollingText'] || {}; $MODULE_REGISTRY['Code/Game/GUI/GuiLayer/ZFScrollingText'] = exports; var Core = require('NGCore/Client/Core').Core;
var CCLabel = require('Code/Cocos2D/CCLabel').CCLabel;
var CCLayer = require('Code/Cocos2D/CCLayer').CCLayer;


exports.ZFScrollingText = CCLayer.subclass(
{
	classname: 'ZFScrollingText',
	
	destroy: function($super)
	{
		$super();
	},
	
	initialize: function()
	{
		this._label = null;
		this._string = "";
		this._distanceScrolled = 0;
		this._originalPosition = null;
		this._delay = 0;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GUI/AlertWindows/ZFAlertWindowGoldenDice'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GUI/AlertWindows/ZFAlertWindowGoldenDice'] || {}; $MODULE_REGISTRY['Code/Game/GUI/AlertWindows/ZFAlertWindowGoldenDice'] = exports; var ZFAlertWindow = require('Code/Game/GUI/AlertWindows/ZFAlertWindow').ZFAlertWindow;
var ZFMenu = require('Code/Game/GUI/ZFMenus/ZFMenu').ZFMenu;
var ZFColorDefines = require('Code/Game/ZFColorDefines').ZFColorDefines;

exports.ZFAlertWindowGoldenDice = ZFAlertWindow.subclass(
{
	classname: "ZFAlertWindowGoldenDice",
	
	//-(void)incrementCounter:(id)sender
	incrementCounter: function(sender)
	{
		// check max number of die
		var gs = GameState;
		sm = ZFStorageMenu.storageMenu();
		dict = gs._zfGameData._inventory[sm.indexForItemNameInStorage("Golden Dice")];
		
		var max = dict["count"];
		
		if(this._numberOfDice < max)
		{
			this._numberOfDice++;
			this._counter.setString(sprintf("%d", this._numberOfDice));
		}
	},
	
	//-(void)decrementCounter:(id)sender
	decrementCounter: function(sender)
	{
		// check max number of die
		if (this._numberOfDice > 0)
		{
			this._numberOfDice--;
			this._counter.setString(sprintf("%d", this._numberOfDice));
		}
	},
	
	confirmButton: function(sender) 
	{
		var gs = GameState;
		var sm = ZFStorageMenu.storageMenu();
		
		var index = sm.indexForItemNameInStorage("Golden Dice");
		var dict = gs._zfGameData._inventory[index];
		
		var max = dict["count"];
		
		if (max > this._numberOfDice)
		{
			itemDictionary = {	"name" : "Golden Dice",
								"count" : (max-this._numberOfDice) };
			gs._zfGameData._inventory[index] = itemDictionary;
		}
		else if (max == this._numberOfDice)
		{
			gs._zfGameData._inventory.splice(index, 1);
		}
		else 
		{
			console.log("Too many Golden Dice used!");
		}
		
		gs._zfGameData._bonusDropRate += this._numberOfDice;
		
		var enemyDictionary = ZFGuiLayer.gui()._enemyArray[gs._zfGameData._currentEnemy];
		var enemyName = enemyDictionary["name"];
		eventDictionary = {	"enemy" : enemyName,
							"numUsed" : this._numberOfDice };
		//TODO
		//[[EventTracker eventTracker] sendEvent:@"zf_invade_goldenDice" withParameters:eventDictionary andDelegate:nil];
		
		this.dismissAlertNegative(sender);
	},
	
	initialize: function()
	{
		var w = CGSizeMake(480, 320);
		var winSize =  new Core.Size(UI.Window._width, UI.Window._height);
		var widthOffset =  (winSize._width  - 480) / 2 + 20;
		var heightOffset = -(winSize._height - 320) / 2 - 20;
		var c = CGRectMake(1,1,34,42);	
		var b = CGRectMake(36,1,30,38);
		var s = CGRectMake(1,44,34,24);
		var f = "hudElements.png";
		var offerWindowSize = CGSizeMake(210, 106);
		var offerWindowYPos = 178;
		var offerWindow1XPos = 25;
		var spaceBetweenWindows = 245;

		var color = ccc3(237, 226, 177);

		var bgOverlay = ZFMenu.makeWindow( CGRectMake(0, 0, w._width-40, w._height-40), c,b,f,color, CGRectMake(0,0,0,0), CGRectMake(0,0,0,0), s) ;

		this.addChild(bgOverlay, 0, this.kAlertWindowTags.kAlertWindowTagBG1 );
		bgOverlay.setPosition(widthOffset, heightOffset);
		
		var menuBanner = CCSprite.spriteWithFile(f, CGRectMake(144, 376, 200, 47));
		this.addChild(menuBanner, 2);
		//menuBanner.setPosition(ccp(widthOffset + 220, -heightOffset + 277 - menuBanner.getSize()._height/2));
		menuBanner.setPosition(ccp(w._width/2 + widthOffset, w._height - 32 - heightOffset));
		menuBanner.setScale(1.25, 1);
		menuBanner.setAnchorPoint(0.5, 1);
		
		var menuTitle = CCLabel.labelWithString(Core.Localization.getString("Golden Dice"), new Core.Size(300, 120), GL2.Text.HorizontalAlign.Center, "AmericanTypewriter-Bold", 24);
		menuTitle.setColor(ZFColorDefines.colorTextDarkBrown);
		menuBanner.addChild(menuTitle, 3);
		var p = menuTitle.getPosition();
		var pn = ccpAdd(p, ccp(0, -menuBanner.getSize()._height/2));
		menuTitle.setPosition(pn);
		
		
		dismissItem = CCMenuItemImage.itemFromNormalImage("bigX.png", "bigXSel.png", this, this.dismissAlertNegative.bind(this));
		this._dismiss = CCMenu.menuWithItems([dismissItem]);
		dismissItem.setScale(0.75);
		
		this._dismiss.setPosition(ccp( widthOffset + w._width - dismissItem.getSize()._width * 0.75 - 40, -heightOffset - dismissItem.getSize()._height * 0.75 + w._height - 40 ));


		this._body1 = CCLabel.labelWithString(Core.Localization.getString("Use your Golden Dice and get a better chance of winning rare items!\n\nHow many dice will you use?"), 
											   CGSizeMake(250, 180), GL2.Text.HorizontalAlign.Center, "Arial", 14);
		
		this._body1.setPosition(w._width*0.5 + 25 + widthOffset, w._height - 155 - heightOffset + 35);
		
		this._body1.setColor(ccc3(0,0,0));
		this.addChild(this._body1, 1);

		
		
		this._diceSprite = CCSprite.spriteWithFile("stex0049.png");
		this._diceSprite.setPosition(ccp(w._width/2 - 115 - 15 - 10 + widthOffset, w._height/2 + 10 + 10 - heightOffset));
		this._diceSprite.setAnchorPoint(ccp(0.5, 0.5));
		
		
		this._chestSprite = CCSprite.spriteWithFile("tex1056.png");
		this._chestSprite.setPosition(w._width/2 - 130 - 10 + widthOffset, w._height/2 - 35 /*- 20*/ - heightOffset);
		this._chestSprite.setScale(ccp(0.6, 0.6));
		this._chestSprite.setAnchorPoint(ccp(0.5, 0.5));
		
		
//		//show the accept buttons
		var sp1 = CCSprite.spriteWithFile("hudElements.png", CGRectMake(1, 253, 180, 50));
		var sp2 = CCSprite.spriteWithFile("hudElements.png", CGRectMake(1, 253, 180, 50));
		
		sp1.setColor(ZFColorDefines.colorGreenButton);
		sp2.setColor(ZFColorDefines.colorGreenButton);

		var confirm = CCMenuItemImage.itemFromNormalSprite(sp1, sp2, this, this.confirmButton.bind(this));
		
		
		var bl1 = CCLabel.labelWithString(Core.Localization.getString("Continue"), CGSizeMake(180, 50), GL2.Text.HorizontalAlign.Center, "Arial-BoldMT", 18 );
		confirm.addChild(bl1, 1);
		bl1.setPosition(ccp(0, -confirm.getSize()._height/2));
	
		this._confirmMenu = CCMenu.menuWithItems([confirm]);
		this._confirmMenu.setPosition(ccp(w._width/2 + /*90 + 5 - 124 + 40 +*/ widthOffset, 50 + 84 - 27 - 40 - heightOffset));
		confirm.setAnchorPoint(ccp(0.5, 1));
		
		
//		//////////////// GOLDEN DICE SPECIFIC STUFF ///////////
		this._numberOfDice = 1;
		
		var upArrow = CCSprite.spriteWithFile("diceArrow_up_small.png");
		var bigUpArrow = CCSprite.spriteWithFile("diceArrow_up.png");
		var downArrow = CCSprite.spriteWithFile("diceArrow_up_small.png");
		var bigDownArrow = CCSprite.spriteWithFile("diceArrow_up.png");
		
		downArrow.setFlipY(true);
		bigDownArrow.setFlipY(true);
		
		var upArrowItem = CCMenuItemImage.itemFromNormalSprite(upArrow, bigUpArrow, this, this.incrementCounter.bind(this));
		upArrowItem.setPosition(ccp(0, 22));
		upArrowItem.setAnchorPoint(ccp(0.5, 1));

		var downArrowItem = CCMenuItemImage.itemFromNormalSprite(downArrow, bigDownArrow, this, this.decrementCounter.bind(this));
		downArrowItem.setPosition(ccp(0, -73));
		downArrowItem.setAnchorPoint(ccp(0.5, 1));
		

		this._diceMenu = CCMenu.menuWithItems([upArrowItem, downArrowItem]);
		downArrowItem._touchTarget.setAnchor(0,1);
		
//		console.log(this._diceMenu);
		
		this._counterLayer = CCColorLayer.layerWithColor(ccc3(0xDF, 0xCF, 0x8F), 80, 50);
		
		this._diceMenu.setPosition(ccp(w._width/2 + 25 - 70 + 15 + 10 + widthOffset, w._height/2 - 25 - 27 + 30 + 5 - heightOffset));
		
		this._counter = CCLabel.labelWithString(this._numberOfDice, new Core.Size(80, 50), GL2.Text.HorizontalAlign.Center, "Arial-BoldMT", 30);
		this._counterLayer.addChild(this._counter, 1);
		
		this._counter.setColor(ZFColorDefines.colorTextDarkBrown);
		this._counter.setPosition(ccp(40, 0));
		
		this._counterLayer.setPosition(ccp(w._width/2 + 90 - 70 + 15 - 10 + widthOffset - 40, 110 - 27 + 30 + 5 - heightOffset));
		
		this.addChild(this._dismiss, 2);
		this.addChild(this._chestSprite, 3);
		this.addChild(this._diceMenu, 4);
		this.addChild(this._confirmMenu, 3);
		this.addChild(this._counterLayer, 3);
		this.addChild(this._diceSprite, 4);
	},
	
	//- (void)dismissAlertNegative:(id)sender
	dismissAlertNegative: function($super, sender)
	{
		$super(sender);
	}
});

//@implementation ZFAlertWindowGoldenDice
//
//@synthesize diceMenu,counter,numberOfDice,diceSprite,chestSprite,confirmMenu,counterLayer;
//
//-(id)init
//{
//	self = [super init];
//	
//	if (self != nil)
//	{

//		// Show the body text
//		

//		
//		
//		[CCMenuItemFont setFontSize:18];
//		[CCMenuItemFont setFontName:@"AmericanTypewriter-Bold"];
//		


//		
//		delayOkButton = 0.f;
//		endScale = 1.f;
//		

//		
//		//get the offers
//		
//		self.visible = NO;
//		menuState = menuStateClosed;
//		
//		offerWindowSize = CGSizeMake(210, 106);
//		offerWindowYPos = 187;
//		offerWindow1XPos = 200.f;
//		spaceBetweenWindows = 0;
//		
//		

//	}
//	
//	return self;	
//	
//}


//
//-(void)dealloc
//{
//	if(chestSprite && chestSprite.parent)
//	{
//		[chestSprite.parent removeChild:chestSprite cleanup:YES];
//	}
//	self.chestSprite = nil;
//		
//	if(diceSprite && diceSprite.parent)
//	{
//		[diceSprite.parent removeChild:diceSprite cleanup:YES];
//	}
//	self.diceSprite = nil;
//	
//	if(diceMenu && diceMenu.parent)
//	{
//		[diceMenu.parent removeChild:diceMenu cleanup:YES];
//	}
//	self.diceMenu = nil;
//	
//	if(counter && counter.parent)
//	{
//		[counter.parent removeChild:counter cleanup:YES];
//	}
//	self.counter = nil;
//	
//	if(confirmMenu && confirmMenu.parent)
//	{
//		[confirmMenu.parent removeChild:confirmMenu cleanup:YES];
//	}
//	self.confirmMenu = nil;
//	
//	[super dealloc];
//}
//

//
//@end
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/FightGameScene/Summary/ZFFightSummary'] = function(){var exports = $MODULE_REGISTRY['Code/Game/FightGameScene/Summary/ZFFightSummary'] || {}; $MODULE_REGISTRY['Code/Game/FightGameScene/Summary/ZFFightSummary'] = exports; var ZFEnemyDrop = require('Code/Game/GameObjects/ZFEnemyDrop').ZFEnemyDrop;

exports.ZFFightSummary = CCLayer.subclass({
	
	classname : 'ZFFightSummary',
	
	menuStatesExt : 
	{
		menuStateOpeningPhase1 : 			10 /* menuStateMAX */,
		menuStateOpeningPhase2 : 			11,
		menuStateOpeningPhase3 : 			12,
		menuStateOpeningPhase4 : 			13,
		menuStateOpeningPhase5 : 			14,
		menuStateOpeningPhase6 : 			15,
		menuStateOpeningPhase7 : 			16,
		menuStateOpeningPhase8 : 			17,
		menuStateOpeningPhase9 : 			18,
		menuStateOpeningPhase10 : 			19,
		menuStateOpeningPhase11 : 			20,
		menuStateOpeningGoldenDicePhase : 	21
	},
	
	statIDs :
	{
		statIDEnemiesBeaten : 				0,
		statIDZombiesLost :					1,
		statIDGoldPlundered :				2,
		statIDBonusGold : 					3,
		statIDLoot : 						4,
		statIDDropIcon1 : 					5,
		statIDDropName1 :					6,
		statIDDropIcon2 : 					7,
		statIDDropName2 : 					8,
		statIDMAX: 							9
	},
	
	lootTypes : 
	{
		lootTypeGold : 						0,
		lootTypeFreemium : 					1,
		lootTypeBoost : 					2,
		lootTypeBrainBanner :				3,
		lootTypeStageRare : 				4,
		lootTypeStageUnique : 				5
	},
	
	fightSummaryTags:
	{
		kFightSummaryTagBG : 				0
	},
	
	kSkipButton:
	{
		kSkipButton : "menuButtonUp.png",
		kSkipButtonSel : "menuButtonDn.png"
	},
	
	initialize : function()
	{
		this._menuState = 0; // int
		
		this._rightPanel = null; // CCLayer *
//		this._backgroundSpriteSheet = null; // CCSpriteSheet*
//		this._rightPanelBG = null; // CCSprite *
		this._banner = null; // CCSprite *
//		this._strip2 = null; // CCColorLayer *
//		this._strip3 = null; // CCColorLayer *
		this._dimLayer2 = null; // CCColorLayer *
		
		this._treasureChest = null; // CCSprite *
		
		this._drop1 = null; // ZFEnemyDrop *
		this._drop2 = null; // ZFEnemyDrop *
		this._curDrop = null; // ZFEnemyDrop *
		
		this._winLoseContainer = null; // CCColorLayer *
		
		this._currentStat = null; // CCLabel *
		this._currentStatS = null; // CCLabel *
		this._rollingNumbers = null; // CCLabel *
		
		this._panelTitle = null; // CCLabel *
		this._zombiesLost = null; // CCLabel *
		this._zombiesLostVal = null; // CCLabel *
		this._enemiesLost = null; // CCLabel *
		this._enemiesLostVal = null; // CCLabel *
		this._gold = null; // CCLabel *
		this._goldVal = null; // CCLabel *
		this._bonusGold = null; // CCLabel *
		this._bonusGoldVal = null; // CCLabel *
		this._loot = null; // CCLabel *
//		this._brains = null; // CCLabel *
//		this._brainslVal = null; // CCLabel *
		this._dropName1 = null; // CCLabel *
		this._dropName2 = null; // CCLabel *
		this._curDropName = null; // CCLabel *
		
		this._dimLayer = null; // DimLayer *
		this._dismissMenu = null; // CCMenu *
		this._buttonLabel = null; // CCLabel *
		
		this._drops = null; // NSDictionary
		this._targetVal = 0; // float
		this._rollval = 0; // float
		this._rollTimeLimit = 0; // float
		this._dm = 0; // float
		this._currentStatID = 0; // int
		this._goldEarned = 0; // int
		
		this._widthScale = 0; // float
		this._heightScale = 0; // float
		
		var w = new Core.Size(960, 640);
		this._widthScale = w._width/480.0; 
		this._heightScale = w._height/320.0;
		
		this._dimLayer = CCColorLayer.layerWithColor(ccc4(0x0,0x0,0x0,0xA0), w._width, w._height);
		this._rightPanel = CCColorLayer.layerWithColor(ccc4(0xFF,0x0,0x0,0x00), Math.floor(w._width*2/5), ZFGameDefines.ORIGINAL_WINDOW_HEIGHT*2);
		
		this._menuState = ZFMenu.menuStates.menuStateClosed;
		this._drops = DataPreloader._drops;
	},
	
	initElements : function()
	{
		//var w = new Core.Size(UI.Window._width, UI.Window._height);
		var w = new Core.Size(960, 640);
		
		var widthOffset = 0;
		var windowWidthScale = 1;
		
		var bannerOffset = (this._widthScale>1)? (w._width*3/5)/4-40 : 0;
		var heightOffset = (this._widthScale>1)? w._height/4: 0;
		var fm = ZFFightMan;
		
		var windowSize = CGRectMake(-5, w._height, Math.floor((w._width*windowWidthScale)) , ZFGameDefines.ORIGINAL_WINDOW_HEIGHT*2);
		var c1 = CGRectMake(1,1,34,42);	// left corner 
		var b = CGRectMake(36,1,30,38); // right side
		var s = CGRectMake(1,44,34,24); // bottom
		var f = ZFGameDefines.HUDELEMENTS1_FILE;
		
		var color = ccc4(237,226,177,255);
		var bgOverlay = CCColorLayer.layerWithColor(color, Math.floor((w._width*windowWidthScale)), ZFGameDefines.ORIGINAL_WINDOW_HEIGHT*2);//ZFMenu.makeWindow(windowSize, c1, b ,f, color, CGRectMake(0,0,0,0), CGRectMake(0,0,0,0), s);
		
//		this._backgroundSpriteSheet = bgOverlay.getChildByTag(1); // ??
		this._rightPanel.addChild(bgOverlay, 0, this.fightSummaryTags.kFightSummaryTagBG);
		//bgOverlay.setPosition(ccpSub(bgOverlay.getPosition(), CGPointMake(0, -320*3/5)));
		bgOverlay.setPosition(ccp(0, 200));
		
		this._dimLayer.setPosition(this._dimLayer.getPosition()._x, 640/2);
		this.addChild(this._dimLayer,0);
	    this._dimLayer.setOpacity(0);
		this.addChild(this._rightPanel, 1);
		
		//rightPanel is the right side frame
		//this._rightPanel.setPosition(200, 70);
		this._rightPanel.setPosition(w._width*3/5, 70);
		
		//banner is the summary title bar
		this._banner = CCSprite.spriteWithFile(f, CGRectMake(144,376,200,47));
		this._rightPanel.addChild(this._banner, 1);
		
		//banner.position = ccp(banner.contentSize.width/2 - 5 + bannerOffset, w.height - banner.contentSize.height/2-heightOffset);
		
		//this._banner.setPosition(w._width - 100, w._height - 100);
		this._banner.setScale(2, 2);
		this._banner.setPosition(bgOverlay.getPosition()._x + this._banner.getSize()._width, 550 - this._banner.getSize()._height/2);
		this._dimLayer2 = DimLayer.layerWithColor(ccc4(0xff,0xff,0xff,0x0),w._width, w._height);
		
		var fontName = "AmericanTypewriter-Bold";
		var fontsize = 26;
		
		this._zombiesLost = CCLabel.labelWithString(this.statNameforStatID(this.statIDs.statIDZombiesLost), CGSizeMake(240,50), GL2.Text.HorizontalAlign.Left, fontName, fontsize);
		this._enemiesLost = CCLabel.labelWithString(this.statNameforStatID(this.statIDs.statIDEnemiesBeaten), CGSizeMake(240,50), GL2.Text.HorizontalAlign.Left, fontName, fontsize);
		this._gold = CCLabel.labelWithString(this.statNameforStatID(this.statIDs.statIDGoldPlundered), CGSizeMake(240,50), GL2.Text.HorizontalAlign.Left, fontName, fontsize);
		this._bonusGold = CCLabel.labelWithString(this.statNameforStatID(this.statIDs.statIDBonusGold), CGSizeMake(240,50), GL2.Text.HorizontalAlign.Left, fontName, fontsize);
		this._loot = CCLabel.labelWithString(this.statNameforStatID(this.statIDs.statIDLoot), CGSizeMake(240,50), GL2.Text.HorizontalAlign.Left, fontName, fontsize);
		
		var c = ZFColorDefines.colorTextAsh;
		this._zombiesLost.setColor(c);
		this._enemiesLost.setColor(c);
		this._gold.setColor(c);
		this._bonusGold.setColor(c);
		this._loot.setColor(c);
		
		this._zombiesLost.setOpacity(0x40);
		this._enemiesLost.setOpacity(0x40);
		this._gold.setOpacity(0x40);
		this._bonusGold.setOpacity(0x40);
		this._loot.setOpacity(0x40);
		

        this._zombiesLost.setPosition(ccp(150, 325));//this.positionForStatVal(this.statIDs.statIDZombiesLost)._y));
        this._enemiesLost.setPosition(ccp(150, 400));//this.positionForStatVal(this.statIDs.statIDEnemiesBeaten)._y));
        this._gold.setPosition(ccp(150, 250));//this.positionForStatVal(this.statIDs.statIDGoldPlundered)._y));
        this._bonusGold.setPosition(ccp(150, 100));//this.positionForStatVal(this.statIDs.statIDBonusGold)._y));
        this._loot.setPosition(ccp(150, 175));//this.positionForStatVal(this.statIDs.statIDLoot)._y));
		 
		this._rightPanel.addChild(this._zombiesLost,12);
		this._rightPanel.addChild(this._enemiesLost,12);
		this._rightPanel.addChild(this._gold, 12);
		 
		if (fm.isGameWon())
		{
			this._rightPanel.addChild(this._loot,12);
		}
		else
		{
			this._loot = null;
		}
		
		this._dropName1 = CCLabel.labelWithString("", CGSizeMake(240,50), GL2.Text.HorizontalAlign.Right, "AmericanTypewriter-Bold", fontsize);
		this._dropName1.setColor(c);
		this._dropName1.setAnchorPoint(ccp(1, 0.5));
		this._dropName1.setPosition(ccp(960*2/5 - 20, 100));
		this._rightPanel.addChild(this._dropName1, 2);
		
		this._dropName2 = CCLabel.labelWithString("", CGSizeMake(240,50), GL2.Text.HorizontalAlign.Right, "AmericanTypewriter-Bold", fontsize);
		
		this._dropName2.setColor(c);
		this._dropName2.setAnchorPoint(ccp(1, 0.5));
		this._dropName2.setPosition(ccp(960*2/5 - 20, 25));
		
		this._rightPanel.addChild(this._dropName2, 2);
		
		var skipButton = CCMenuItemImage.itemFromNormalImage(this.kSkipButton.kSkipButton, this.kSkipButton.kSkipButtonSel);
		skipButton.setColor(ZFColorDefines.colorBrownButton);
		skipButton.getSize().setWidth(0.75 * skipButton.getSize()._width);
		
		var dismissButton = CCMenuItemToggle.itemWithTarget(this, this.dismissMenu.bind(this), [skipButton]);
		dismissButton.setAnchorPoint(0, 0);
		this._dismissMenu = CCMenu.menuWithItems([dismissButton]);
		this._dismissMenu.setPosition(ccp(this._rightPanel.getSize()._width/4, -50));
		
		dismissButton.setScale(0.75);
		this._rightPanel.addChild(this._dismissMenu, 2);
	    this._dismissMenu.setOpacity(0);
		
	    this._buttonLabel = CCLabel.labelWithString(NSLocalizedString("Skip"),"AmericanTypewriter-Bold", 32);
		this._buttonLabel.setColor(ZFColorDefines.colorTextAsh);
		this._buttonLabel.setPosition(ccpAdd(this._dismissMenu.getPosition(), dismissButton.getPosition()));
		this._buttonLabel.setPosition(ccpAdd(this._buttonLabel.getPosition(), ccp(dismissButton.getSize()._width/2, dismissButton.getSize()._height/2)));
		this._buttonLabel.setPosition(20 + this._buttonLabel.getPosition()._x, this._buttonLabel.getPosition()._y);
		this._rightPanel.addChild(this._buttonLabel, 2);
		this._buttonLabel.setOpacity(0);
		
		this._dm = 1.0;
	},
	
	openMenu : function()
	{
		this.initElements();
		this.setVisible(true);
		this.schedule(this.openTimerCallback);
		this._menuState = ZFMenu.menuStates.menuStateOpening;
	},
	
	animationDone : function(sender) 
	{
		var node = sender;
		if(node && node.getParent())
		{
//			if(node._children && node._children.length > 0)
//			{
//				node.removeAllChildrenWithCleanup(true);
//			}
//			node.removeFromParentAndCleanup(true);
			node.getParent().removeChild(node);
			destroyWithChildren(node);
		}
	},
	
	openTimerCallback : function()
	{
		var w = new Core.Size(960, 640);
		this.unschedule(this.openTimerCallback);
		
		switch (this._menuState)
		{
		// Zombies win/lose text grows
		case ZFMenu.menuStates.menuStateOpening:
			var duration = 0.2 / this._dm;
			var fontsize = 22;
			var message = (this._loot) ? NSLocalizedString("Zombies Win") : NSLocalizedString("Zombies Lose");
			
			// Only play the lose/win music for a fight if your not muted
			if (this._loot)// win
			{			
				SimpleAudioEngine.playBackgroundMusic(kWinBGM);
			}
			else // lose
			{
				SimpleAudioEngine.playBackgroundMusic(kLoseBGM);
			}
			
			this._panelTitle = CCLabel.labelWithString(message, CGSizeMake(this._rightPanel.getSize()._width, 50),
			        GL2.Text.HorizontalAlign.Center, "AmericanTypewriter-Bold", fontsize);
			
			this._panelTitle.setColor(ZFColorDefines.colorTextAsh);
			this._panelTitle.setOpacity(0);
			this._panelTitle.setPosition(0, 0);
			
			this._banner.addChild(this._panelTitle, 2);
			this._winLoseContainer = new CCLayer();
			this._winLoseContainer.setPosition(0, w._height/2 - 50);
			this.addChild(this._winLoseContainer, 2);
			
			
			//winLose: fondo del mensaje inicial
			//winloseLabel. lo que dice ( y winloslebalS es shadow)
			var winLose = CCColorLayer.layerWithColor(ccc4(0,0,0,0xD0), w._width, 130);
			var winLoseLabel = CCLabel.labelWithString(message, /*winLose.getSize()*/new Core.Size(1000,1000), GL2.Text.HorizontalAlign.Center,"AmericanTypewriter-Bold", 45);
			var winLoseLabelS = CCLabel.labelWithString(message, /*winLose.getSize()*/ new Core.Size(1000,1000), GL2.Text.HorizontalAlign.Center,"AmericanTypewriter-Bold", 45);		
			
			winLose.setPosition(ccp(0,0));
//			winLoseLabel.setPosition(w._width/2 - 100, -25 );
			winLoseLabel.setPosition(450, 10 );
			winLoseLabelS.setPosition(450 + 2, 10 + 2);
			winLoseLabel.setColor(ccc3(0x5c, 0xcb, 0x56));
			winLoseLabelS.setColor(ccc3(0x3e, 0x52, 0x1b));
			
			winLoseLabel.setScale(2.5);
			winLoseLabelS.setScale(2.5);
			
			winLoseLabel.setRotation(-90);
			winLoseLabelS.setRotation(-90);
			
			this._winLoseContainer.addChild(winLoseLabel, 2);
			this._winLoseContainer.addChild(winLoseLabelS, 1);
			this._winLoseContainer.addChild(winLose, 0);
			
			var actionTo = CCSpawn.actions([CCDelayTime.actionWithDuration(duration),
			                                CCFadeTo.actionWithDuration(duration,0xD0)
			                                ]);
			
			winLose.runAction(actionTo);
			
//			actionTo = CCSequence.actions(
//			                               CCSpawn.actions(
//			                                                CCScaleTo.actionWithDuration(duration, 1.15),
//			                                                CCRotateBy.actionWithDuration(duration, 90)
//			                                                ),
//			                                                CCScaleTo.actionWithDuration(duration*2/5, 1.3),
//			                                                CCScaleTo.actionWithDuration(duration*5/5, 1)
//			                                                );
			
			actionTo = CCRotateBy.actionWithDuration(duration, 90);
			winLoseLabel.runAction(actionTo);
			
//			actionTo = CCSequence.actions([
//			                               CCSpawn.actions([
//			                                                CCScaleTo.actionWithDuration(duration, 1),
//			                                                CCRotateBy.actionWithDuration(duration, 90)
//			                                                ]),
//			                                                CCScaleTo.actionWithDuration(duration*2/5, 1.3),
//			                                                CCScaleTo.actionWithDuration(duration*5/5, 1)
//			                                                ]);
			
			actionTo = CCRotateBy.actionWithDuration(duration, 90);
			winLoseLabelS.runAction(actionTo);
			
			this._menuState = this.menuStatesExt.menuStateOpeningPhase1;
			this.schedule(this.openTimerCallback, duration + (2/this._dm));
			this._currentStatID = this.statIDs.statIDEnemiesBeaten;
			break;
			
		// Phase 1: panel slides in. sin label disappears
		case this.menuStatesExt.menuStateOpeningPhase1:
			
			var duration = 0.35 / this._dm;
			var actionTo = CCFadeTo.actionWithDuration(duration, 0xA0);
			this._dimLayer.runAction(actionTo);
			
			actionTo = CCSequence.actions(
								CCDelayTime.actionWithDuration(duration),
								CCMoveTo.actionWithDuration(duration, ccp(w._width*3/5, this._rightPanel.getPosition()._y))
								);
			this._rightPanel.runAction(actionTo);
			actionTo = CCSequence.actions(
							CCDelayTime.actionWithDuration(duration*2),
							CCFadeTo.actionWithDuration(duration*2, 0xff)
							);
			this._dismissMenu.runAction(actionTo);
			actionTo = CCSequence.actions(
							CCDelayTime.actionWithDuration(duration*2),
							CCFadeTo.actionWithDuration(duration*2, 0xff)
							);
			this._buttonLabel.runAction(actionTo);
			
			actionTo = CCSequence.actions(
					CCScaleTo.actionWithDuration(duration*1/2, 1, 1.2),
					CCScaleTo.actionWithDuration(duration*1/2, 1.5, 0)
					);
			this._winLoseContainer.runAction(actionTo);
			this._menuState = this.menuStatesExt.menuStateOpeningPhase2;
			this.schedule(this.openTimerCallback, duration + 0.5/this._dm);
			
		// Phase 2: stat with the number 0 flies in from the left
		case  this.menuStatesExt.menuStateOpeningPhase2:
			var duration = 0.5 / this._dm;
			// ccColor3B c = colorTextDarkBrown;

			var actionTo = CCFadeTo.actionWithDuration(duration, 0xff);
			this._panelTitle.runAction(actionTo);
			this.introStat(this._currentStatID);
			this.schedule(this.openTimerCallback, duration + (0.1 / this._dm));
			
			if (this._currentStatID == this.statIDs.statIDBonusGold)
			{
				this._goldVal && this._goldVal.setOpacity(0x40);
			}
			this._menuState = this.menuStatesExt.menuStateOpeningPhase3;
			break;
			
		// Phase 3: Value rolls up
		case this.menuStatesExt.menuStateOpeningPhase3:
			var duration = this.displayDurationForStat(this._currentStatID) / this._dm;
			if (this._winLoseContainer)
			{
				this._winLoseContainer.removeAllChildrenWithCleanup(true);
				this.removeChild(this._winLoseContainer, true);
				this._winLoseContainer = null;
			}
			
			this._rollval = 0;
			this._targetVal = this.targetValForStat(this._currentStatID);
			this._rollTimeLimit = duration;
			
			this.unschedule(this.rollNumber);
			this.schedule(this.rollNumber);
			
			this.schedule(this.openTimerCallback, duration + (0.75 / this._dm));
			this._menuState = this.menuStatesExt.menuStateOpeningPhase4;
			break;
			
		// Phase 4: value flies to the right. sat fades away
		case this.menuStatesExt.menuStateOpeningPhase4:
			var duration = 0.25 / this._dm;
			this._currentStat.setOpacity(0);
			this._currentStatS.setOpacity(0);
			
			var moveActionTo = CCMoveTo.actionWithDuration(duration , this.positionForStatVal(this._currentStatID));
			var scaleActionTo = CCScaleTo.actionWithDuration(duration, 0.5);
			
			var actionArray = [moveActionTo]; //, scaleActionTo, null];
			
			var actionTo = CCSpawn.actions(actionArray);
			this._rollingNumbers.runAction(actionTo);
			this.schedule(this.displayVal, duration);
			this.schedule(this.openTimerCallback, duration);
			
			if (this._currentStatID == this.statIDs.statIDBonusGold)
			{
				this._currentStatID++;
				this._menuState = this.menuStatesExt.menuStateOpeningPhase10;
				break;
			}
			
			this._currentStatID++;
			if (this._currentStatID > this.statIDs.statIDGoldPlundered)
			{
				if (this._loot) // loot exists if game is won
				{
					this._menuState =  this.menuStatesExt.menuStateOpeningPhase5;
					actionTo = CCFadeTo.actionWithDuration(duration, 0xFF);
					this._loot.runAction(actionTo);
				}
				else
				{
					this._menuState = this.menuStatesExt.menuStateOpeningPhase11;
				}				
			}
			else
			{
				this._menuState = this.menuStatesExt.menuStateOpeningPhase2;
			}
			break;
			
		// Phase 5: treasure chest moves up
		case this.menuStatesExt.menuStateOpeningPhase5:
			var duration = 1.0 / this._dm;
			
			if (this._treasureChest)
			{
				this.removeChild(this._treasureChest, true);
				this._treasureChest = null;
			}
			
			this._treasureChest = CCSprite.spriteWithFile("tex1055.png");
			this.addChild(this._treasureChest, 1);
	
			this._treasureChest.setPosition(ccp(w._width*3/10, - 100));
			
			var moveActionTo = CCMoveTo.actionWithDuration(duration, ccp(this._treasureChest.getPosition()._x, w._height*20/100));
			this._treasureChest.runAction(moveActionTo);
			
			var actionTo = CCFadeTo.actionWithDuration(duration/2, 0x00);
			this._dimLayer.runAction(actionTo);
			
			this._menuState = this.menuStatesExt.menuStateOpeningPhase6;
			this.schedule(this.openTimerCallback, duration);
			break;
			
		// Phase 6: treasure chest jiggles
		case this.menuStatesExt.menuStateOpeningPhase6:
			var duration = .025 / this._dm;

			var act1 = CCRotateBy.actionWithDuration(duration/4, 5);
			var act2 = CCRotateBy.actionWithDuration(duration/4, -10);
			var act3 = CCRotateBy.actionWithDuration(duration/4, 10);
			var act4 = CCRotateBy.actionWithDuration(duration/4, -5);

			var actionArray = [act1, act2, act3, act4, null];
			
			var moveActionTo = CCSequence.actions(actionArray);
			this._treasureChest.runAction(moveActionTo);
			this._menuState = this.menuStatesExt.menuStateOpeningGoldenDicePhase;
			this.schedule(this.openTimerCallback, duration);
			break;
			
		// Phase 7: treasure chest scales briefly before opening
		case this.menuStatesExt.menuStateOpeningPhase7:
			var duration = 0.05 / this._dm;
			var actionTo = CCScaleTo.actionWithDuration(duration,  1.2 * this._widthScale);
			this._treasureChest.runAction(actionTo);
			this._menuState = this.menuStatesExt.menuStateOpeningPhase8;
			this.schedule(this.openTimerCallback, duration);
			break;
			
		case this.menuStatesExt.menuStateOpeningGoldenDicePhase:
			var fm = ZFFightMan;
			
			if(fm._bonusRoll > 0)
			{
				var w = new Core.Size(960, 640);
				var animationTime = 1.0;
				animationTime = animationTime / this._dm;
				
				var message = "x ".concat(fm._bonusRoll);
				
				var diceContainer = CCColorLayer.layerWithColor(ccc4(0x0,0x0,0x0,0xd0), w._width, 75);
				var diceText = CCLabel.labelWithString(NSLocalizedString("Golden Dice"), "AmericanTypewriter-Bold", 26);
				diceText.setColor(ccc3(0xe5, 0xb7, 0x00));
				var numberOfDice = CCLabel.labelWithString(message, "Arial-BoldMT", 26);
				var goldenDice = CCSprite.spriteWithFile("stex0049.png");
				
				diceContainer.setPosition(ccp(0,(w._height/2) - diceContainer.getSize()._height/2));
				diceText.setPosition(ccp(w._width/2,0));
				numberOfDice.setPosition(ccp(w._width/2 + 30,0));
				goldenDice.setPosition(ccp(w._width/2 - 20,0));
				
				this.addChild(diceContainer, 5);
				diceContainer.addChild(diceText, 6);
				diceContainer.addChild(numberOfDice, 6);
				diceContainer.addChild(goldenDice, 6);
				
				numberOfDice.setOpacity(0);
				goldenDice.setOpacity(0);
				
				goldenDice.setScale(1.2 * this._widthScale);
				diceContainer._scale.setY(0);
				
				var seq = CCSequence.actions([ CCScaleTo.actionWithDuration(0.2 * animationTime, 1.2),
				                               CCScaleTo.actionWithDuration(0.2 * animationTime, 1.0),
				                               CCDelayTime.actionWithDuration(1.8 * animationTime),
				                               CCDelayTime.actionWithDuration(0.4 * animationTime),
				                               CCScaleTo.actionWithDuration(0.2 * animationTime, 1.0, 0.0),
				                               CCCallFuncN.actionWithTarget(this, this.animationDone),
				                               null
				                              ]);
				diceContainer.runAction(seq);
				
				seq = CCSequence.actions([ CCDelayTime.actionWithDuration(0.4 * animationTime),
				                           CCDelayTime.actionWithDuration(0.2 * animationTime),
				                           CCFadeTo.actionWithDuration(0.2 * animationTime, 0),
				                           CCCallFuncN.actionWithTarget(this, this.animationDone),
				                           null
				                          ]);
				diceText.runAction(seq);
				
				seq = CCSequence.actions([ CCDelayTime.actionWithDuration(0.4 * animationTime),
				                           CCDelayTime.actionWithDuration(0.4 * animationTime),
				                           CCFadeTo.actionWithDuration(0.2 * animationTime, 255),
				                           CCScaleTo.actionWithDuration(0.2 * animationTime, 1.4),
				                           CCScaleTo.actionWithDuration(0.2 * animationTime, 1.3),
				                           CCDelayTime.actionWithDuration(1.6 * animationTime),
				                           CCCallFuncN.actionWithTarget(this, this.animationDone),
				                           null
				                          ]); 
				goldenDice.runAction(seq);
				
				seq = CCSequence.actions([ CCDelayTime.actionWithDuration(0.8 * animationTime),
				                           CCDelayTime.actionWithDuration(0.4 * animationTime),
				                           CCFadeTo.actionWithDuration(0.2 * animationTime, 255),
				                           CCScaleTo.actionWithDuration(0.2 * animationTime, 1.4),
				                           CCScaleTo.actionWithDuration(0.2 * animationTime, 1.2),
				                           CCDelayTime.actionWithDuration(1.2 * animationTime),
				                           CCCallFuncN.actionWithTarget(this, this.animationDone),
				                           null
				                           ]);
				numberOfDice.runAction(seq);
				
				this._menuState = this.menuStatesExt.menuStateOpeningPhase7;
				this.schedule(this.openTimerCallback, animationTime*3);
			}
			else 
			{
				this._menuState = this.menuStatesExt.menuStateOpeningPhase7;
				this.schedule(this.openTimerCallback, 0);
			}
			break;
				
		// Phase 8: treasure chest opens. loot image is spawned
		case this.menuStatesExt.menuStateOpeningPhase8:
			var duration = 0.05 / this._dm;
			var s = CCSprite.spriteWithFile("tex1056.png");
			s.setPosition( this._treasureChest.getPosition() );
			s.setScale( this._treasureChest.getScale() );
			this.removeChild(this._treasureChest, true);
			this._treasureChest = s;
			this.addChild(this._treasureChest, 1);
			var actionTo = CCScaleTo.actionWithDuration(duration, 1.* this._widthScale);
			this._treasureChest.runAction(actionTo);
			
			var d = null; // ZFEnemyDrop
			var l = null; // CCLabel
			if (!this._drop1)
			{
				this._drop1 = new ZFEnemyDrop();
				d = this._drop1;
				l = this._dropName1;
				this.rollForDrop(d);
			}
			else if (!this._drop2)
			{
				this._drop2 = new ZFEnemyDrop();
				this._drop2._name = NSLocalizedString("Brain");
				this._drop2._sprite = CCSprite.spriteWithFile("stex0001.png");
				d = this._drop2;
				l = this._dropName2;
			}
			
			this._curDrop = d;
			this._curDropName = l;
			d._sprite.setPosition(ccp(this._treasureChest.getPosition()._x, this._treasureChest.getPosition()._y+100));
//			d._sprite.setPosition(ccp(303,300));
			d._sprite.setScale( d._sprite.getScale()._x * 1.5 );
			this.addChild(d._sprite, 3);
			
			l.setString(NSLocalizedString(d._name));
			l.setOpacity(0);
			
			this._menuState = this.menuStatesExt.menuStateOpeningPhase9;
			this.schedule(this.openTimerCallback, duration);
			break;
			
		// Phase 9: loot moves up. bg fades white
		case this.menuStatesExt.menuStateOpeningPhase9:
			var duration = 2.0 / this._dm;
//			var actionTo = CCSpawn.actions([ CCMoveTo.actionWithDuration(duration, ccp(this._curDrop._sprite.getPosition()._x, this._curDrop._sprite.getPosition()._y + 100)),
//			                                 CCScaleTo.actionWithDuration(duration, this._curDrop._sprite.getScale() * 1.5 * this._widthScale),
//			                                 null
//			                                 ]);
			var actionTo = CCSpawn.actions([ CCMoveTo.actionWithDuration(duration, ccp(this._curDrop._sprite.getPosition()._x, this._curDrop._sprite.getPosition()._y + 100)),
			                                 CCScaleTo.actionWithDuration(2, this._curDrop._sprite.getScale()._x * 1.25)]);
			this._curDrop._sprite.runAction(actionTo);
			
			actionTo =  CCFadeTo.actionWithDuration(duration, 0xCC);
			this._dimLayer2.runAction(actionTo);
			actionTo = CCFadeTo.actionWithDuration(duration, 0);
			this._treasureChest.runAction(actionTo);
			this._menuState = this.menuStatesExt.menuStateOpeningPhase10;
			this.schedule(this.openTimerCallback, duration);
			break;
			
		// Phase 10: loot flies to the right. loot name becomes visible
		case this.menuStatesExt.menuStateOpeningPhase10:
			var duration = 0.25 / this._dm;
			var parameter = (this._curDrop == this._drop1) ? this.statIDs.statIDDropIcon1 : this.statIDs.statIDDropIcon2;
			var moveActionTo = CCMoveTo.actionWithDuration(duration, this.positionForStatVal(parameter));
			var scaleActionTo = CCScaleTo.actionWithDuration(duration, this._curDrop._sprite.getScale()._x * 0.75);
			var actionTo = CCSpawn.actions([moveActionTo, scaleActionTo, null]);
			this._curDrop._sprite.runAction(actionTo);
			this._menuState = this.menuStatesExt.menuStateOpeningPhase11;
			
			if (this._drop1 && !this._drop2)
			{
				if (this._drop1._name == NSLocalizedString("Bonus Gold") && this._dropName1.getOpacity() <= 0)
				{
					actionTo = CCFadeTo.actionWithDuration(duration, 0x40);
					this._curDropName.runAction(actionTo);
					
					actionTo = CCFadeTo.actionWithDuration(duration, 0);
					this._dimLayer2.runAction(actionTo);
					this._currentStatID = this.statIDs.statIDBonusGold;
					this._menuState = this.menuStatesExt.menuStateOpeningPhase2;
					this.schedule(this.openTimerCallback, duration);
					break;
				}
				else if(this.rollForBrain())
				{
					
					actionTo = CCSequence.actions([ CCDelayTime.actionWithDuration(duration),
					                                CCFadeTo.actionWithDuration(duration, 255),
					                                null
				                                ]);
					this._curDropName.runAction(actionTo);
					this._menuState = this.menuStatesExt.menuStateOpeningPhase5;
				}
			}
			
			actionTo = CCSequence.actions([ CCDelayTime.actionWithDuration(duration),
			                                CCFadeTo.actionWithDuration(duration, 255),
			                                null
		                                ]);
			this._curDropName.runAction(actionTo);
			this.schedule(this.openTimerCallback, duration);
			break;
				
		case this.menuStatesExt.menuStateOpeningPhase11:
			var duration = 0.5;
			this._buttonLabel.setVisible(true);
			this._dismissMenu.setVisible(true);
			this._buttonLabel.setOpacity(0);
            this._dismissMenu.setOpacity(0);
			this._buttonLabel.setString(NSLocalizedString("Done"));
			var actionTo = CCFadeTo.actionWithDuration(duration, 0);
			this._dimLayer2.runAction(actionTo);
			
			actionTo = CCSequence.actions([ CCFadeTo.actionWithDuration(duration, 255),
			                                CCFadeTo.actionWithDuration(duration, 0x80),
			                                null
			                               ]);
			
			actionTo = CCRepeatForever.actionWithAction(actionTo);
			this._buttonLabel.runAction(actionTo);
			
			actionTo = CCSequence.actions([ CCFadeTo.actionWithDuration(duration, 255),
			                                CCFadeTo.actionWithDuration(duration, 0x80),
			                                null
			                               ]);
			
			actionTo = CCRepeatForever.actionWithAction(actionTo);
			this._dismissMenu.runAction(actionTo);
	
			this._menuState = ZFMenu.menuStates.menuStateOpen;
			break;
	
			default:
				break;
		}
	},
	
	// ?
	dismissMenu : function()
	{
		var gs = GameState;
		if (this._menuState == ZFMenu.menuStates.menuStateOpen && !this._endSummary)
		{
			this._endSummary = true;
			// hide and disable the done button when pressed
			this._dismissMenu.setVisible(false);
			this._buttonLabel.setVisible(false);
			this._dismissMenu._isTouchEnabled = false;
			
			// just in case
			this.unschedule(this.rollNumber);
			this.unschedule(this.displayVal);
			
//			ZFGuiLayer.enableMenus(false);
			gs.addResource(GameData.gameResources.kGameResourceGold, this._goldEarned);
			NSNotificationCenter.defaultCenter().postNotificationName(ZFGameDefines.kFightSummaryDone, null);
		}
		else // this is the skip part of the dismiss menu
		{
			this._dm = 10;
			this._dismissMenu.setVisible(false);
			this._buttonLabel.setVisible(false);
		}
	},
	
	/**
	 * Never called, according to the original code
	 */
	dismissTimerCallback : function()
	{
	},
	
	spriteFromDropName : function(name)
	{
		return null;
	},
	
	rectForTileKey : function (key)
	{
		var tim = ZFTileManager;
		var dictionary = tim._tilePropertiesDictionary[key];
		return(CGRectMake(dictionary["x"],dictionary["y"], dictionary["width"], dictionary["height"]));
	},
	
	introStat : function(statID)
	{
		var w = new Core.Size(960, 640);
		var fontName = "AmericanTypewriter-Bold";
		this.removeChild(this._currentStat);
		if (this._currentStat)
		{
			this.removeChild(this._currentStat);
			destroy(this._currentStat);
		}
		
		if (this._currentStatS)
		{
			this.removeChild(this._currentStatS);
			destroy(this._currentStatS);
		}
	    // Current stat
		this._currentStat = CCLabel.labelWithString(this.statNameforStatID(statID), fontName, 60);
		this.addChild(this._currentStat, 3);
		
		// Current stat shadow
		this._currentStatS = CCLabel.labelWithString(this.statNameforStatID(statID), fontName, 60);
		this._currentStatS.setColor(ccc3(0,0,0));
		this.addChild(this._currentStatS, 2);
		
		this._currentStat.setPosition( ccp(-w._width/2, w._height/2 + 50));
		this._currentStatS.setPosition(ccpAdd(this._currentStat.getPosition(), ccp(3, -3)));
		
		var actionTo = CCMoveTo.actionWithDuration(0.25/this._dm, ccp(w._width * 3/10, this._currentStat.getPosition()._y));
		this._currentStat.runAction(actionTo);
		
		actionTo = CCMoveTo.actionWithDuration(0.25/this._dm, ccpAdd(ccp(w._width * 3/10, this._currentStat.getPosition()._y), ccp(3, -3)));
		this._currentStatS.runAction(actionTo);
		
		if (this._rollingNumbers)
		{
			this._rollingNumbers.setString("0");
		    this.removeChild(this._rollingNumbers);
		    destroy(this._rollingNumbers);
		}
		
		this._rollingNumbers = CCLabel.labelWithString("0", fontName, 35);
        this.addChild(this._rollingNumbers, 2);
		
		this._rollingNumbers.setPosition(ccp(-w._width/2, w._height/2 - 20));
		actionTo = CCMoveTo.actionWithDuration(0.35/this._dm, ccp(w._width * 3/10, this._rollingNumbers.getPosition()._y ));
		this._rollingNumbers.runAction(actionTo);
	},
	
	rollNumber : function(dt) 
	{
		var fpsComp = dt;
		this._rollval += (this._targetVal * fpsComp) / (this._rollTimeLimit) < 1 ? 1 : (this._targetVal * fpsComp) / (this._rollTimeLimit);
		
		if (this._rollval >= this._targetVal)
		{
			this._rollval = this._targetVal;
			this.unschedule(this.rollNumber);
		}
		
		this._rollval = Math.round(this._rollval);
		this._rollingNumbers.setString('' + this._rollval);
	},
	
	displayVal : function(dt)
	{
		var fm = ZFFightMan;
		this.unschedule(this.displayVal);
		var fontName = "AmericanTypewriter-Bold";
		var l = null; // CCLabel *
		var l2 = null; // CCLabel *
		var str = null; // String
		var statID = this._currentStatID - 1;
		
		switch (statID)
		{
			case this.statIDs.statIDEnemiesBeaten:
				l2 = this._enemiesLost;
				str = fm._enemyCasualty + "";
				break;
				
			case this.statIDs.statIDZombiesLost:
				l2 = this._zombiesLost;
				str = fm._zombieCasualty + "";
				break;
				
			case this.statIDs.statIDGoldPlundered:	
				l2 = this._gold;
				this._goldEarned = this._loot ? (fm._reward + fm._refund) : (fm._refund);
				str = this._goldEarned + "";
				break;
				
			case this.statIDs.statIDBonusGold:		
				l2 = this._dropName1;
				this._goldEarned += this.getBonusGold();
				str = this._goldEarned + "";	
				break;
		}
		
		var action = CCFadeTo.actionWithDuration(0.5/this._dm, 255);
		l2.runAction(action);
		
	    var fontsize = 24;
	    if (this._widthScale > 1)
		{
	        fontsize = 26;
	    }
	    
	    l = CCLabel.labelWithString(str, CGSizeMake(100,50), GL2.Text.HorizontalAlign.Right, fontName, fontsize);
	    
	    switch (statID)
		{
			case this.statIDs.statIDEnemiesBeaten:	this._enemiesLostVal = l;									break;
			case this.statstatIDZombiesLost:		this._zombiesLostVal = l;									break;
			case this.statstatIDGoldPlundered:		this._goldVal = l;											break;
			case this.statstatIDBonusGold:			this.removeChild(this._goldVal, true);	this._goldVal = l;	break;
		}
	    
	   	this._rightPanel.addChild(l,2);
		l.setColor(ZFColorDefines.colorTextAsh);
		action = CCTintTo.actionWithDuration(1.0/this._dm, 0, 0, 0);
		l.runAction(action);
		l.setPosition(ccpAdd(this.positionForStatVal(statID),ccp(-460,0)));
		
		this._rollingNumbers.setString("");
	},
	
	lootTableFromCategory : function(category)
	{
		var fm = ZFFightMan;
		var gs = GameState;
		var sm = ZFStorageMenu.storageMenu();
		
		var lootItem = fm._enemyDictionary["loot"];
		var lootCategory = lootItem[category];
		
		var lootTable = new Array();
		
		for(var dropKey in lootCategory)
		{
			var drop = lootCategory[dropKey];
			var dropDictionary = this._drops[drop];
			
			if (dropDictionary["unique"] == true)
			{
				if (sm.doesOwnItem(dropDictionary["tile"]))
				{
					continue;
				}
			}
			
			if (dropDictionary["limit"])
			{
				
				var ct = sm.numberOfItemInStorageWithKey(drop);
				
				if (ct >= dropDictionary["limit"] )
				{
					continue;
				}
				
				var transformsInto = dropDictionary["transformsInto"];
				if (transformsInto && sm.numberOfItemInStorageWithKey(transformsInto) > 0)
				{
					continue;
				}
				
				if (drop == "Rusty Fragment" && gs._zfGameData._mausoleumFlags & ZFGameFlags.MAUSOLEUMFLAG_MAUSOLEUM_UNLOCKED)
				{
					continue;
				}
			}
			
			lootTable.push(drop);		
		}
		
		if(lootTable.length > 0)
			return lootTable;
		return null;
	},
	
	rollForDrop : function(d) /* ZFEnemyDrop* */
	{
		var sm = ZFStorageMenu.storageMenu();
	 	var fm = ZFFightMan;
		var gs = GameState;
		
		var rand = Math.random();
		var dropType = this.lootTypes.lootTypeGold;
		
		var bonus = fm._bonusRoll;
		
		if(bonus == 0)
		{
			var goldRate		= 0.09;				  // 10%
			var freemiumRate  = 0.15 + goldRate;	  // 15%
			var boostRate	    = 0.60 + freemiumRate;// 60%
			var brainRate     = 0.08 + boostRate;	  // 8%
			// stageRareRate = 7%
			
			if (rand < goldRate)
			{
				dropType = this.lootTypes.lootTypeGold;
			}
			else if (rand < freemiumRate)
			{
				dropType = this.lootTypes.lootTypeFreemium;
			}
			else if (rand < boostRate)
			{
				dropType = this.lootTypes.lootTypeBoost;
			}
			else if (rand < brainRate)
			{
				dropType = this.lootTypes.lootTypeBrainBanner;
			}
			else 
			{
				dropType = this.lootTypes.lootTypeStageRare;
			}
		}
		else if(bonus == 1)
		{
			var freemiumRate  = 0.14;				  // 15%
			var boostRate	    = 0.60 + freemiumRate;// 60%
			var brainRate     = 0.10 + boostRate;	  // 10%
			var stageRareRate = 0.08 + brainRate;	  // 8%
			// stageUniqueRate = 7%
			
			if (rand < freemiumRate)
			{
				dropType = this.lootTypes.lootTypeFreemium;
			}
			else if (rand < boostRate)
			{
				dropType = this.lootTypes.lootTypeBoost;
			}
			else if (rand < brainRate)
			{
				dropType = this.lootTypes.lootTypeBrainBanner;
			}
			else if (rand < stageRareRate)
			{
				dropType = this.lootTypes.lootTypeStageRare;
			}
			else 
			{
				dropType = this.lootTypes.lootTypeStageUnique;
			}	
		}
		else if(bonus == 2)
		{
			var boostRate	    = 0.59;				  // 60%
			var brainRate     = 0.20 + boostRate;	  // 20%
			var stageRareRate = 0.10 + brainRate;	  // 10%
			// stageUniqueRate = 10%
			
			if (rand < boostRate)
			{
				dropType = this.lootTypes.lootTypeBoost;
			}
			else if (rand < brainRate)
			{
				dropType = this.lootTypes.lootTypeBrainBanner;
			}
			else if (rand < stageRareRate)
			{
				dropType = this.lootTypes.lootTypeStageRare;
			}
			else 
			{
				dropType = this.lootTypes.lootTypeStageUnique;
			}
		}
		else if(bonus >= 3)
		{
			var brainRate     = 0.39;				  // 40%
			var stageRareRate = 0.40 + brainRate;	  // 40%
			// stageUniqueRate = 20%
			
			// special: +10% chance of getting the unique drop for every dice
			// past 3
			rand = rand + (bonus - 3) * 0.10;
			
			for(var c = 0; c < bonus - 3; c++)
			{
				brainRate = brainRate * 0.9;
				stageRareRate = stageRareRate * 0.9;
			}
			
			if (rand < brainRate)
			{
				dropType = this.lootTypes.lootTypeBrainBanner;
			}
			else if (rand < stageRareRate)
			{
				dropType = this.lootTypes.lootTypeStageRare;
			}
			else 
			{
				dropType = this.lootTypes.lootTypeStageUnique;
			}
		}
		
		fm._bonusRoll = 0;
		
		// hands out a brain or gold after 10 rolls
		
		var lootTable = null;
		
		while(!lootTable && dropType >= 0)
		{
			lootTable = this.lootTableFromCategory(dropType);
			if(!lootTable)
				dropType = dropType - 1;
		}
		
		var dropWon; // Array
		
		if(dropType < 0)
		{
			d._name = NSLocalizedString("Bonus Gold");
			dropWon = this._drops["Bonus Gold"];
		}
		else 
		{
			var randInt = Math.floor(Math.random() * lootTable.length);
			
			d._name = lootTable[randInt];
			dropWon = this._drops[d._name];
		}
		
		var addToStorage = null;
		
		if (dropWon["tile"])
		{
			d._sprite = ZFTileManager.spriteNodeFromKey(dropWon["tile"], true);
			var itemDictionary = {};
			itemDictionary.name = d._name;
			itemDictionary.tile = dropWon["tile"];
			addToStorage = itemDictionary;
		}
		else
		{
			d._sprite = CCSprite.spriteWithFile(dropWon["sprite"]);
			addToStorage = new ZFConsumable();
			addToStorage.initWithName(d._name, 1);
		}
		
		var numScale = dropWon["scale"];
		var scale = numScale ? numScale : d._sprite.getScale();
		d._sprite.setScale(scale);
		
		if (d._name == "Brain")
		{
			gs.addResource(GameData.gameResources.kGameResourceBrains, 1);
			gs._zfGameData._lastEarnedBrainDate = Core.Time.getRealTime()/1000;
		}
		
		if (!dropWon["dontAddToStorage"])
		{
			sm.addItemToStorage(addToStorage, false);
		}
		
		//TODO: publishAchievement
		if (d._name =="Double Rainbow")
		{
//			[[ZFGameCenterDelegate gameCenterDelegate].gameCenterManager submitAchievement:@"com.zombiefarm.fight.double_rainbow" percentComplete:100.f];
			
			/* Unlock Achievement through Facebook */
			if(!gs._zfGameData._achievementFlags.hasFlag(kAchievementDoubleRainbow))
			{
				gs._zfGameData._achievementFlags.setFlag(kAchievementDoubleRainbow);
//				ZFGuiLayer *gui = [ZFGuiLayer gui];
//				[gui publishAchievement:@"com.zombiefarm.fight.double_rainbow" withDescription:@"com.zombiefarm.fight.double_rainbow.description" withImageURl:@"com.zombiefarm.fight.double_rainbow.image" ];
			}
		}
		
		if (d._name == "Farmer Banner")
		{
			ZFAchievementChecker.checkFarmerBanner();
			
//			ZFGuiLayer *gui = [ZFGuiLayer gui];
//			[gui publishAchievement:@"com.zombiefarm.farm.farm_banner" withDescription:@"com.zombiefarm.farm.farm_banner.description" withImageURl:@"com.zombiefarm.farm.farm_banner.image" ];
			
//			if ([[ZFAchievementChecker achievementChecker] checkAllBanners])
//			{
//				ZFGuiLayer *gui = [ZFGuiLayer gui];
//				[gui publishAchievement:@"com.zombiefarm.farm.all_banners" withDescription:@"com.zombiefarm.farm.all_banners.description" withImageURl:@"com.zombiefarm.farm.all_banners.image" ];
//			}
		}
		
		if (d._name == "Corporate Banner")
		{
			ZFAchievementChecker.checkCorporateBanner();
			
//			ZFGuiLayer *gui = [ZFGuiLayer gui];
//			[gui publishAchievement:@"com.zombiefarm.farm.city_banner" withDescription:@"com.zombiefarm.farm.city_banner.description" withImageURl:@"com.zombiefarm.farm.city_banner.image" ];
			
//			if ([[ZFAchievementChecker achievementChecker] checkAllBanners])
//			{
//				ZFGuiLayer *gui = [ZFGuiLayer gui];
//				[gui publishAchievement:@"com.zombiefarm.farm.all_banners" withDescription:@"com.zombiefarm.farm.all_banners.description" withImageURl:@"com.zombiefarm.farm.all_banners.image" ];
//			}
		}
		
		if (d._name == "Pirate Banner")
		{
			ZFAchievementChecker.checkPirateBanner();
			
//			ZFGuiLayer *gui = [ZFGuiLayer gui];
//			[gui publishAchievement:@"com.zombiefarm.farm.pirate_banner" withDescription:@"com.zombiefarm.farm.pirate_banner.description" withImageURl:@"com.zombiefarm.farm.pirate_banner.image" ];
			
//			if ([[ZFAchievementChecker achievementChecker] checkAllBanners])
//			{
//				ZFGuiLayer *gui = [ZFGuiLayer gui];
//				[gui publishAchievement:@"com.zombiefarm.farm.all_banners" withDescription:@"com.zombiefarm.farm.all_banners.description" withImageURl:@"com.zombiefarm.farm.all_banners.image" ];
//			}
		}
		
		if (d._name == "Ninja Banner")
		{
			ZFAchievementChecker.checkNinjaBanner();
			
//			ZFGuiLayer *gui = [ZFGuiLayer gui];
//			[gui publishAchievement:@"com.zombiefarm.farm.ninja_banner" withDescription:@"com.zombiefarm.farm.ninja_banner.description" withImageURl:@"com.zombiefarm.farm.ninja_banner.image" ];
			
//			if ([[ZFAchievementChecker achievementChecker] checkAllBanners])
//			{
//				ZFGuiLayer *gui = [ZFGuiLayer gui];
//				[gui publishAchievement:@"com.zombiefarm.farm.all_banners" withDescription:@"com.zombiefarm.farm.all_banners.description" withImageURl:@"com.zombiefarm.farm.all_banners.image" ];
//			}
		}
		
		if (d._name == "Robot Banner")
		{
			ZFAchievementChecker.checkRobotBanner();
			
//			ZFGuiLayer *gui = [ZFGuiLayer gui];
//			[gui publishAchievement:@"com.zombiefarm.farm.robot_banner" withDescription:@"com.zombiefarm.farm.robot_banner.description" withImageURl:@"com.zombiefarm.farm.robot_banner.image" ];
			
//			if ([[ZFAchievementChecker achievementChecker] checkAllBanners])
//			{
//				ZFGuiLayer *gui = [ZFGuiLayer gui];
//				[gui publishAchievement:@"com.zombiefarm.farm.all_banners" withDescription:@"com.zombiefarm.farm.all_banners.description" withImageURl:@"com.zombiefarm.farm.all_banners.image" ];
//			}
		}
		
		if (d._name.length > 0)	//loot won notification
		{
			NSNotificationCenter.defaultCenter().postNotificationName(ZFGameDefines.kLootItemWonNotification, null, d._name);
		}
	},
	
	rollForBrain : function()
	{
		var fm = ZFFightMan;
		var gs = GameState;
		
		//FIXME:
		if(!fm._enemyDictionary){
			console.log("@@@@ fm._enemyDictionary es NULL");
			return 0;
		}
			
		var brainEarned = ZFGuiLayer.gui().isFirstTimeBeatingEnemy(false);
		var chanceToEarnBrain = gs.chancetoEarnBrain(fm._enemyDictionary);
		
		if (Math.random() <= chanceToEarnBrain)
		{
			brainEarned = true;
		}
		
		if (brainEarned)
		{
			gs.addResource(GameData.gameResources.kGameResourceBrains, 1);
			gs._zfGameData._lastEarnedBrainDate = Core.Time.getRealTime()/1000;
			/* FIXME: Flurry
			//var eventDictionary = new Array();
			//eventDictionary["Source"] = "Invasion";
			// [FlurryAPI logEvent:kFlurryEvent_brainAttained withParameters:eventDictionary];*/
		}
		
		return brainEarned;
	},
	
	getBonusGold : function()
	{
		var fm = ZFFightMan;
		var n = fm._enemyDictionary["reward"];
		return n / 2;
	},
	
	statNameforStatID : function(statID)
	{
        switch (statID)
        {
            case this.statIDs.statIDEnemiesBeaten:
                return NSLocalizedString("Enemies Beaten");
            case this.statIDs.statIDZombiesLost:
                return NSLocalizedString("Zombies Lost");
            case this.statIDs.statIDGoldPlundered:
                return NSLocalizedString("Gold Plundered");
            case this.statIDs.statIDBonusGold:
                return NSLocalizedString("Bonus Gold");
            case this.statIDs.statIDLoot:
                return NSLocalizedString("Loot");
            default:
                return "";
        }
    },
    
	targetValForStat : function(statID)
    {
        var fm = ZFFightMan;
        
        switch (statID)
        {
            case this.statIDs.statIDEnemiesBeaten:
                return fm._enemyCasualty;
            case this.statIDs.statIDZombiesLost:
                return fm._zombieCasualty;
            case this.statIDs.statIDGoldPlundered:
                return this._loot ? (fm._reward + fm._refund) : (fm._refund);
            case this.statIDs.statIDBonusGold:
                return this.getBonusGold();
        }
        
        return 0;
    },
	
	positionForStatVal : function(statID)
	{
		var w = new Core.Size(960, 640);
	        switch (statID)
	        {
//		        case this.statIDs.statIDEnemiesBeaten:	return ccp(w._width* 88/100, ZFGameDefines.ORIGINAL_WINDOW_HEIGHT*2* 88/100+this._heightOffset);
//	            case this.statIDs.statIDZombiesLost:	return ccp(w._width* 88/100, ZFGameDefines.ORIGINAL_WINDOW_HEIGHT*2* (88-11*1)/100+this._heightOffset);
//	            case this.statIDs.statIDBonusGold:
//	            case this.statIDs.statIDGoldPlundered:	return ccp(w._width* 88/100, ZFGameDefines.ORIGINAL_WINDOW_HEIGHT*2* (88-11*2)/100+this._heightOffset);
//	            case this.statIDs.statIDLoot:			return ccp(w._width* 68/100, ZFGameDefines.ORIGINAL_WINDOW_HEIGHT*2* (88-11*3)/100+this._heightOffset);
//	            case this.statIDs.statIDDropIcon1:		return ccp(w._width* 68/100, ZFGameDefines.ORIGINAL_WINDOW_HEIGHT*2* (88-11*4)/100+this._heightOffset);
//	            case this.statIDs.statIDDropName1:		return ccp(w._width* 68/100, ZFGameDefines.ORIGINAL_WINDOW_HEIGHT*2* (88-11*4)/100+this._heightOffset);
//	            case this.statIDs.statIDDropIcon2:		return ccp(w._width* 68/100, ZFGameDefines.ORIGINAL_WINDOW_HEIGHT*2* (88-11*5.5)/100+this._heightOffset);
//	            case this.statIDs.statIDDropName2:		return ccp(w._width* 68/100, ZFGameDefines.ORIGINAL_WINDOW_HEIGHT*2* (88-11*5.5)/100+this._heightOffset);
	            
	            
	            case this.statIDs.statIDEnemiesBeaten:	return ccp(760, 400);
	            case this.statIDs.statIDZombiesLost:	return ccp(760, 325);
	            case this.statIDs.statIDBonusGold:
	            case this.statIDs.statIDGoldPlundered:	return ccp(760, 250);
	            case this.statIDs.statIDLoot:			return ccp(100, 175);
	            case this.statIDs.statIDDropIcon1:		return ccp(710, 175);
	            case this.statIDs.statIDDropName1:		return ccp(100, 100);
	            case this.statIDs.statIDDropIcon2:		return ccp(740, 100);
	            case this.statIDs.statIDDropName2:		return ccp(100, 25);
	        }
		return ccp(0,0);
	},
	
	displayDurationForStat : function(statID)
	{
		switch (statID)
		{
			case this.statIDs.statIDEnemiesBeaten:	return (this.targetValForStat(statID) <= 0) ? 0.5 : 1.0;
			case this.statIDs.statIDZombiesLost:	return (this.targetValForStat(statID) <= 0) ? 0.5 : 1.0;
			case this.statIDs.statIDGoldPlundered:	return (this.targetValForStat(statID) <= 0) ? 0.5 : 3.0;
			case this.statIDs.statIDBonusGold:		return (this.targetValForStat(statID) <= 0) ? 0.5 : 3;
		}
		
		return 1.0;
	},
	
	cleanupLocal : function()
	{
//		console.log("FPS destruyendo SUMMARY");
		var window = this.getChildByTag(this.fightSummaryTags.kFightSummaryTagBG);
		var spriteSheet = window.getChildByTag(1);
		spriteSheet.removeAllChildrenWithCleanup(YES);
		
		if(window){
			window.removeChildByTag(1, true);
			window.removeChildByTag(0, true);
		}
		this.removeChildByTag(this.fightSummaryTags.kFightSummaryTagBG, true);
		
		if (this._drops) destroyWithChildren(this._drops); this._drops = null;

		if(this._banner) 
		{
			if(this._panelTitle)
			{
				this._banner.removeChild(this._panelTitle, true);
				destroyWithChildren(this._panelTitle);
				this._panelTitle = null;
			}
			this._rightPanel.removeChild(this._banner, true);
			destroyWithChildren(this._banner);
			this._banner = null;
		}
//		this._rightPanel.removeAllChildrenWithCleanup(true);
		this.removeChild(this._rightPanel, true);
		destroyWithChildren(this._rightPanel);
		this._rightPanel = null;
		
		if(this._dimLayer)
		{
			this.removeChild(this._dimLayer, true);
//			this._dimLayer.removeAllChildrenWithCleanup(true);
			destroyWithChildren(this._dimLayer);
			this._dimLayer = null;
		}
		
		if(this._dimLayer2)
		{
			this.removeChild(this._dimLayer2, true);
//			this._dimLayer2.removeAllChildrenWithCleanup(true);
			destroyWithChildren(this._dimLayer2);
			this._dimLayer2 = null;
		}
			
		if(this._treasureChest)
		{
			this.removeChild(this._treasureChest, true);
			destroy(this._treasureChest);
			this._treasureChest = null;
		}
		
		if(this._drop1)
		{
			destroy(this._drop1);
			this._drop1 = null;
		}
		
		if(this._drop2)
		{
			destroy(this._drop2);
			this._drop2 = null;
		}
		
		if(this._curDrop)
		{
			destroy(this._curDrop);
			this._curDrop = null;
		}
		
		if(this._winLoseContainer)
		{
			var winLoseLabel = this._winLoseContainer.getChildByTag(2);
			if(winLoseLabel)
			{
				this._winLoseContainer.removeChild(winLoseLabel, true);
				destroyWithChildren(winLoseLabel);
				this._winLoseContainer = null;
			}
			var winLoseLabel = this._winLoseContainer.getChildByTag(1);
			if(winLoseLabelS)
			{
				this._winLoseContainer.removeChild(winLoseLabelS, true);
				destroyWithChildren(winLoseLabelS);
				winLoseLabelS = null;
			}
			var winLose = this._winLoseContainer.getChildByTag(0);
			if(winLose)
			{
				this._winLoseContainer.removeChild(winLose, true);
				destroyWithChildren(winLose);
				winLose = null;
			}
			this.removeChild(this._winLoseContainer, true);
			destroyWithChildren(this._winLoseContainer);
			this._winLoseContainer = null;
		}
		
		if(this._currentStat)
		{
			this.removeChild(this._currentStat, true);
			destroy(this._currentStat);
			this._currentStat = null;
		}
		
		if(this._currentStatS)
		{
			this.removeChild(this._currentStatS, true);
			destroy(this._currentStatS);
			this._currentStatS = null;
		}
		
		if(this._rollingNumbers)
		{
			this.removeChild(this._rollingNumbers);
			destroy(this._rollingNumbers);
			this._rollingNumbers = null;
		}	
		
		//right panel
//		this._zombiesLost = null; // CCLabel *
//		this._zombiesLostVal = null; // CCLabel *
//		this._enemiesLost = null; // CCLabel *
//		this._enemiesLostVal = null; // CCLabel *
//		this._gold = null; // CCLabel *
//		this._goldVal = null; // CCLabel *
//		this._bonusGold = null; // CCLabel *
//		this._bonusGoldVal = null; // CCLabel *
//		this._loot = null; // CCLabel *
//		this._dropName1 = null; // CCLabel *
//		this._dropName2 = null; // CCLabel *
//		this._dismissMenu = null; // CCMenu *
//		this._buttonLabel = null; // CCLabel *
		
		
//		this._curDropName = null; // CCLabel *
		
//		if(this._dimLayer)
//		{
//			this.removeChild(this._dimLayer, true);
//			destroyWithChildren(this._dimLayer);
//			this._dimLayer = null;
//		}
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/FightGameScene/GUI/ZFFightAbilityGUI'] = function(){var exports = $MODULE_REGISTRY['Code/Game/FightGameScene/GUI/ZFFightAbilityGUI'] || {}; $MODULE_REGISTRY['Code/Game/FightGameScene/GUI/ZFFightAbilityGUI'] = exports; var ZFFightAbilityButton = Core.Class.subclass(
{
	classname: 'ZFFightAbilityButton',
	
	initialize: function()
	{
		this._buttonLayer = null; //CCLayer
		this._button = null; //CCMenu
		this._buttonBorder = null; //CCSprite
		this._name = null; //CCBitmapFontAtlas
		this._tag = 0; //int
	}
});
exports.ZFFightAbilityButton = ZFFightAbilityButton;

var ZFFightBuffIcon = Core.Class.subclass(
{
	classname: 'ZFFightBuffIcon',
	
	initialize: function()
	{
		this._buffLayer = null; //CCLayer
		this._buff = null; //CCSprite
		this._buffCount = null; //CCBitmapFontAtlas
		this._buffCountBorder = null; //CCSprite
		this._buffName = null; //CCBitmapFontAtlas
		this._buffEffect = null; //CCBitmapFontAtlas
		this._tag = 0; // int
	}
});
exports.ZFFightBuffIcon = ZFFightBuffIcon;

exports.ZFFightAbilityGUI = Core.Class.subclass(
{
	classname: 'ZFFightAbilityGUI',
	
	//+ (void)addBuffIcon:(ZFActorFightEffect*)buff atPoint:(CGPoint)startPosition
	$addBuffIcon: function(buff, startPosition)
	{		
		var gui = ZFFightGUI;
		var w = new Core.Size(960, 640);
		//FIXME: Check the resolution numbers
		var widthScale = 1; //w._width / 480;
		var heightScale = 1; //w._height / 320;
	
		// check if ability already exists in buffIcons array
		var temp = null;
		var length = gui._buffIcons.length;
		for(var i=0; i < length; ++i)
		{
			var tempBuff = gui._buffIcons[i];
			if(buff._tag == tempBuff._tag)
			{
				temp = tempBuff;
				break;
			}
		}
		
		// add to array and ccmove the sprite to a certain point and have it clean itself up somehow 
		if(temp == null)
		{
			var gui = ZFFightGUI;
			
			var newBuff = new ZFFightBuffIcon();
			newBuff._buffLayer = new CCLayer();
			newBuff._buff = CCSprite.spriteWithFile(buff._abilityIcon);
			newBuff._tag = buff._tag;
			var fntFile = "ABD26.fnt";
			//FIXME: ZombieFarmAppDelegate doesn't exist
//			if(ZombieFarmAppDelegate.getCurrentLanguage() == "zh-Hant" || ZombieFarmAppDelegate.getCurrentLanguage == "zh-Hans" ||
//			   ZombieFarmAppDelegate.getCurrentLanguage == "ja")
//			{
				newBuff._buffCount = CCLabel.labelWithString("1", "Arial", 26);
//			}
//			else 
//			{
//				//TODO
//				//newBuff._buffCount = CCBitmapFontAtlas.bitmapFontAtlasWithString("1", fntFile);
//			}
			
			newBuff._buffCount.setScale(0.9*widthScale);
			newBuff._buffCount.setAlpha(0);
			newBuff._buffCountBorder = CCSprite.spriteWithFile("buffCountBorder.png");
			newBuff._buffCountBorder.setAlpha(0);
			newBuff._buffCountBorder.setScale(1.5*widthScale);
			
//			if(ZombieFarmAppDelegate.getCurrentLanguage() == "zh-Hant" || ZombieFarmAppDelegate.getCurrentLanguage() == "zh-Hans" ||
//			   ZombieFarmAppDelegate.getCurrentLanguage() == "ja")
//			{
				newBuff._buffName = CCLabel.labelWithString(buff._abilityName, "Arial", 26);
//			}
//			else 
//			{
//				//TODO
//				//newBuff._buffName = [CCBitmapFontAtlas bitmapFontAtlasWithString:buff.abilityName fntFile:fntFile];
//			}
	
			newBuff._buffName.setOpacity(0);
			newBuff._buffName.setScale(2*widthScale);
			newBuff._buffName.setPosition(0, 80*heightScale);
			
			newBuff._buffLayer.addChild(newBuff._buffName, 3);
	
			var effect = null;
			switch(buff._tag)
			{
				case kFightEffectChivalry:			effect = NSLocalizedString("+ stats (girl zombie)"); break;
				case kFightEffectGrace:				effect = NSLocalizedString("+ stats (regular zombie)"); break;
				case kFightEffectProtect:				effect = NSLocalizedString("+ defense (other zombies)"); break;
				case kFightEffectTankHitPointsBuff:	effect = NSLocalizedString("+ life (headless zombies)"); break;
				default: effect = ""; break;
			}
			
//			if(ZombieFarmAppDelegate.getCurrentLanguage() == "zh-Hant" || ZombieFarmAppDelegate.getCurrentLanguage() == "zh-Hans" ||
//			   ZombieFarmAppDelegate.getCurrentLanguage() == "ja")
//			{
				newBuff._buffEffect = CCLabel.labelWithString(effect, "Arial", 26);
				
//			}
//			else 
//			{
//				//TODO
//				//newBuff.buffEffect = [CCBitmapFontAtlas bitmapFontAtlasWithString:effect fntFile:fntFile];
//			}

			newBuff._buffEffect.setScale(1.5*widthScale);
			newBuff._buffEffect.setColor(ccc3(0x00,0xff,0x00));
			newBuff._buffEffect.setPosition(0, -60*heightScale);
			newBuff._buffEffect.setOpacity(0);
			newBuff._buffLayer.addChild(newBuff._buffEffect, 3);
			
			newBuff._buffLayer.addChild(newBuff._buff, 0);
			newBuff._buffLayer.addChild(newBuff._buffCount, 2);
			newBuff._buffLayer.addChild(newBuff._buffCountBorder, 1);
			
			newBuff._buffLayer.setPosition(ccpAdd(startPosition, (new Core.Point(0, 50*heightScale))));
			newBuff._buff.setScale(0.2*widthScale);
			
			gui._abilityButtons.addChild(newBuff._buffLayer, 3);
			gui._buffIcons.push(newBuff);
			
			
			var destinationPoint = ccp((160*widthScale + 66 *gui._buffIcons.indexOf(newBuff))*widthScale, w._height - 76*heightScale);
			
			newBuff._buffCountBorder.setPosition(24*widthScale,-24*heightScale);
			newBuff._buffCount.setPosition(24*widthScale,-24*heightScale);
			
			var bezier = {};
			bezier._controlPoint_1 = newBuff._buffLayer.getPosition();
			bezier._controlPoint_2 = new Core.Point((newBuff._buffLayer.getPosition()._x + destinationPoint._x)*0.5, 
										destinationPoint._y + 150*heightScale);
			bezier._endPosition = new Core.Point(w._width/2, w._height/2);
			
			//FIXME: There is no override in CCBezierTo for this function, the orignial is at CCBezierBy
			var bezierWithSpin = CCBezierTo.actionWithDuration(1.0, bezier);
			
			
			newBuff._buffName.runAction(CCSequence.actions(							
										CCDelayTime.actionWithDuration(1),
										CCFadeTo.actionWithDuration(0.1, 255),
										CCDelayTime.actionWithDuration(0.9),
										CCFadeTo.actionWithDuration(0.5, 0),
										null));		
			newBuff._buffEffect.runAction(CCSequence.actions(							
										CCDelayTime.actionWithDuration(1),
										CCFadeTo.actionWithDuration(0.1, 255),
										CCDelayTime.actionWithDuration(0.9),
										CCFadeTo.actionWithDuration(0.5, 0),
										null));
			newBuff._buffLayer.runAction(CCSequence.actions(
										bezierWithSpin,
										CCDelayTime.actionWithDuration(1.5),
										CCMoveTo.actionWithDuration(0.5, destinationPoint),
										null));
			newBuff._buff.runAction(CCSequence.actions(							
										CCSpawn.actions(
												CCRotateBy.actionWithDuration(1, -720),
												CCScaleTo.actionWithDuration(1, 2.5*widthScale),
												null),
										CCDelayTime.actionWithDuration(1.5),
										CCScaleTo.actionWithDuration(0.5, 1.5*widthScale),
										null));
			newBuff._buffCount.runAction(CCSequence.actions(							
										CCDelayTime.actionWithDuration(3.0),
										CCFadeTo.actionWithDuration(0.1, 255),
//										CCScaleTo.actionWithDuration(0.1, 1.2*widthScale),
//										CCScaleTo.actionWithDuration(0.1, 0.9*widthScale),
										null));
			newBuff._buffCountBorder.runAction(CCSequence.actions(
										CCDelayTime.actionWithDuration(3.0),
										CCFadeTo.actionWithDuration(0.1, 255), 
										null));
			// animation for buff Icon		
		}
		else 
		{
			this.updateBuffCount(temp);
		}
	},

	// note: when we call removeBuffIcon it's important that we know if the effect is removed
	//		 before or after this function is called
	//+ (void)removeBuffIcon:(ZFActorFightEffect*)buff
	$removeBuffIcon: function(buff)
	{
		//FIXME: Check the resolution
		var widthScale = 1; //resolutionWidth / 480.0;
		var heightScale = 1; //resolutionHeight / 320.0;
		
		var gui = ZFFightGUI;
		// check if there are similiar buffs
		var count = this.countBuffs(buff._tag);
		
		// if there are no more stacks of the buff, remove it
		var buffToRemove = null;
		var length = gui._buffIcons.length;
		for(var i=0; i < length; ++i)
		{
			var tempBuff = gui._buffIcons[i];
			if(tempBuff._tag == buff._tag)
			{
				buffToRemove = tempBuff;
				break;
			}
		}	
		if(count == 0)
		{	
			// if there exists a buff to remove
			if(buffToRemove != null)
			{
				// cleans up buff, buffCount, buffCountBorder
				buffToRemove._buffLayer.removeAllChildrenWithCleanup(true);
				destroy(buffToRemove._buffName);
				buffToRemove._buffName = null;
				
				destroy(buffToRemove._buffEffect);
				buffToRemove._buffEffect = null;
				
				destroy(buffToRemove._buff);
				buffToRemove._buff = null;
				
				destroy(buffToRemove._buffCount);
				buffToRemove._buffCount = null;
				
				destroy(buffToRemove._buffCountBorder);
				buffToRemove._buffCountBorder = null;
				
				gui._abilityButtons.removeChild(buffToRemove._buffLayer, true);
				destroy(buffToRemove._buffLayer);
				buffToRemove._buffLayer = null;
				gui._buffIcons.splice(gui._buffIcons.indexOf(buffToRemove), 1);
			}
			
			var w = new Core.Size(960, 640);
			var length = gui._buffIcons.length;
			for(var i=0; i < length; ++i)
			{
				var buffIcon = gui._buffIcons[i];

				var destinationPoint = ccp((160*widthScale + 66 *gui._buffIcons.indexOf(buffIcon))*widthScale, w._height - 76*heightScale);
				buffIcon._buffLayer.runAction(CCMoveTo.actionWithDuration(0.3, destinationPoint)); 
			}
		}
		else 
		{
			if(buffToRemove != null)
				this.updateBuffCount(buffToRemove);
		}
	},

	//+ (void)updateBuffCount:(ZFFightBuffIcon*)buff
	$updateBuffCount: function(buff)
	{
		if(buff != null)
		{
			//var w = new Core.Size(UI.Window._width, UI.Window._height);
			//FIXME: Check screen resolution
			var widthScale = 1; //w._width / 480.0;
				
			var currentBuffCount = this.countBuffs(buff._tag);

			buff._buffCount.setString(currentBuffCount);
			buff._buff.runAction(CCSequence.actions(								  
								   CCScaleTo.actionWithDuration(0.1, 1.8*widthScale),
								   CCScaleTo.actionWithDuration(0.1, 1.5*widthScale),
								   null));
//			buff._buffCount.runAction(CCSequence.actions(								  
//										 CCScaleTo.actionWithDuration(0.1, 1.2*widthScale),
//										 CCScaleTo.actionWithDuration(0.1, 0.9*widthScale),
//										 null));
		}
	},

	//+ (int)countBuffs:(int)buffTag
	$countBuffs: function(buffTag)
	{
		var fm = ZFFightMan;
		var count = 0;
		for(var i=0; i < fm._fightEffectList.length; ++i)
		{
			var effect = fm._fightEffectList[i];
			if(effect._tag == buffTag)
				count++;
		}
		return count;
	},

	//+ (void)addAbilityButton:(ZFActorActivatedAbility*)ability
	$addAbilityButton: function(ability)
	{
		var gui = ZFFightGUI;
		var w = new Core.Size(960, 640);
		
		//FIXME: Check screen resolution
		var widthScale = 1; //w._width / 480.0;
		var heightScale = 1; // w._height / 320.0;
		
		var sprite = CCSprite.spriteWithFile(ability._abilityIcon);
		var button = CCMenuItemSprite.itemFromNormalSprite(sprite, null,  ZFFightMan, ZFFightMan.createTriggerEvent.bind(ZFFightMan,ability._trigger));
		
		button.setScale(0.8, 0.8);
		button._tag = ability._trigger; // for resolving what event to trigger when pressed
		var abilityButton = CCMenu.menuWithItems([button]);
		
		var newAbility = new ZFFightAbilityButton();
		
		newAbility._buttonLayer = new CCLayer();
		newAbility._button = abilityButton;
		newAbility._button.setScale(2.7*widthScale, 2.7*widthScale);
		newAbility._button.setPosition(-40, -40);
		
//		newAbility._sprite = CCSprite.spriteWithFile(ability._abilityIcon);
//		newAbility._sprite.setScale(1.8*widthScale);
		
		newAbility._buttonBorder = CCSprite.spriteWithFile("abilityBorder.png");
		newAbility._buttonBorder.setScale(1.8*widthScale);
		
		newAbility._buttonLayer.addChild(newAbility._buttonBorder);
//		newAbility._buttonLayer.addChild(newAbility._sprite);
		newAbility._buttonLayer.addChild(newAbility._button);
	
		
		newAbility._name = CCLabel.labelWithString(ability._abilityName, "Arial", 26);
		newAbility._name.setAnchorPoint(new Core.Point(0, 0.5));
		newAbility._name.setPosition(new Core.Point(50*widthScale, 0));
		newAbility._name.setAlpha(0);
		newAbility._buttonLayer.addChild(newAbility._name);
	
		newAbility._name.setScale(1.6*widthScale);
		newAbility._tag = ability._tag;
						
		// add the whole data structure to array
		gui._abilityButtonList.push(newAbility);
		
		newAbility._buttonLayer.setPosition(45*widthScale, -100*heightScale);
		var destinationPoint = new Core.Point(newAbility._buttonLayer.getPosition()._x,
									   w._height - 130*heightScale - (95 * gui._abilityButtonList.indexOf(newAbility)*heightScale));
		
		newAbility._buttonLayer.runAction(CCMoveTo.actionWithDuration(0.7, destinationPoint));
		newAbility._name.runAction(CCSequence.actions(
									CCDelayTime.actionWithDuration(0.7),
									CCFadeTo.actionWithDuration(0.1, 255),
									CCDelayTime.actionWithDuration(2),
									CCFadeTo.actionWithDuration(1.5, 0),
									null));
		gui._abilityButtons.addChild(newAbility._buttonLayer, 3, ability._tag);
	},
	
	//+ (void)removeByActivatedAbilty:(ZFActorActivatedAbility*)ability
	$removeByActivatedAbilty: function(ability)
	{
		var gui = ZFFightGUI;
		var temp = null;
		for(var i=0; i < gui._abilityButtonList.length; ++i)
		{
			var button = gui._abilityButtonList[i];
			// all ZFFightAbilityButton's have the same tag as the abilities they represent
			if(button._tag == ability._tag)
			{
				temp = button;
				break;
			}
		}
		
		if(temp != null)
			this.removeAbilityButton(temp);
	},

	//+ (void)removeAbilityButton:(ZFFightAbilityButton*)button
	$removeAbilityButton: function(button)
	{
		//FIXME: Make sure the origin is correct. CGRect mainFrame = [[UIScreen mainScreen] bounds];
//		var screenSize = new Core.Size(UI.Window._height, UI.Window._width);
//		var mainFram = new Core.Rect(new Core.Point(0, 0), screenSize);
		
		//FIXME: Check screen resolution
		var heightScale = 1; //screenSize.getWidth/ 320.0;
		
		var gui = ZFFightGUI;
		// remove menu from array
		
		// redundant since we can see it's checked for null a few lines above ... still ... safety first!
		if(button != null)
		{
			// gets rid of button, buttonBorder, name
			button._buttonLayer.removeAllChildrenWithCleanup(true);
			button._buttonBorder = null;
			button._name = null;
			
			// gets rid of ccmenuitemsprite
			button._button.removeAllChildrenWithCleanup(true);
			button._button = null;
			
			gui._abilityButtons.removeChild(button._buttonLayer, true);
			button._buttonLayer = null;
			
			gui._abilityButtonList.splice(gui._abilityButtonList.indexOf(button), 1);
			
			// move all remaining menu items
			var w = new Core.Size(960, 640);
			var length = gui._abilityButtonList.length;
			for(var i=0; i < length; ++i)
			{
				var button = gui._abilityButtonList[i];
				destinationPoint = new Core.Point(button._buttonLayer.getPosition()._x, 
												w._height - 130*heightScale - (95 * i)*heightScale);
				button._buttonLayer.runAction(CCMoveTo.actionWithDuration(0.75, destinationPoint));
			}
			
			// remove menu from layer
		}
	},
	
	//+ (void)fadeOutAllButtons
	$fadeOutAllButtons: function()
	{
		var time = 1.0;
		var gui = ZFFightGUI;
		
		// make menuitem and border fade out
		for(var i=0; i < gui._abilityButtonList.length; ++i)
		{
			var button = gui._abilityButtonList[i];
			button._buttonBorder.runAction(CCFadeTo.actionWithDuration(time, 0));
			
			// gets rid of ccmenuitemsprite
			var item = button._button._children[0];
			item.runAction(CCFadeTo.actionWithDuration(time, 0));
		}
		// make buff, buffcount, and buffcountborder fade out
		for(var i=0; i < gui._buffIcons.length; ++i)
		{
			var buff = gui._buffIcons[i];
			buff._buff.runAction(CCFadeTo.actionWithDuration(time, 0));
			buff._buffCount.runAction(CCFadeTo.actionWithDuration(time, 0));
			buff._buffCountBorder.runAction(CCFadeTo.actionWithDuration(time, 0));
		}
	},

	//+ (void)cleanup
	$cleanup: function()
	{
		gui = ZFFightGUI;
		if (gui._abilitybuttonList)
		{
    		for(var i=0; i < gui._abilityButtonList.length; ++i)
    		{
    			var button = gui._abilityButtonList[i];
    			
    			button._buttonLayer.removeAllChildrenWithCleanup(true);
    			destroy(button._buttonLayer);
    			button._buttonLayer = null;
    			
    			destroy(button._buttonBorder);
    			button._buttonBorder = null;
    			
    			destroy(button._name);
    			button._name = null;
    			
    			// gets rid of ccmenuitemsprite
    			button._button.removeAllChildrenWithCleanup(true);
    			destroy(button._button);
    			button._button = null;
    			
    			gui._abilityButtons.removeChild(button._buttonLayer, true);
    			
    		}
    		gui._abilityButtonList.length = 0;
    		gui._abilityButtonList = null;
		}
		
		if (gui._buffIcons) {
    		for (var i = 0; i < gui._buffIcons.length; ++i)
    		{
    			
    			this._buffLayer = null; //CCLayer
    			this._buff = null; //CCSprite
    			this._buffCount = null; //CCBitmapFontAtlas
    			this._buffCountBorder = null; //CCSprite
    			this._buffName = null; //CCBitmapFontAtlas
    			this._buffEffect = null; //CCBitmapFontAtlas
    			this._tag = 0; // int
    			
    			
    			var buff = gui._buffIcons[i];
    			// cleans up buff, buffCount, buffCountBorder
    			buff._buffLayer.removeAllChildrenWithCleanup(true);
    			destroyWithChildren(buff._buffLayer);
    			buff._buffLayer = null;
    			
    			destroyWithChildren(buff._buff);
    			buff._buff = null;
    			
    			destroyWithChildren(buff._buffCount);
    			buff._buffCount = null;
    			
    			destroyWithChildren(buff._buffCountBorder);
    			buff._buffCountBorder = null;
    			
    			gui._abilityButtons.removeChild(buff._buffLayer, true);
    			
    		}
    		gui._buffIcons.length = 0;
    		gui._buffIcons = null;
		}
		
		this.cleanAbilityHelperArrow();
	},

	//+ (ZFFightAbilityButton*)getAbilityToShowArrowWith
	$getAbilityToShowArrowWith: function()
	{
		var gui = ZFFightGUI;
		
		var tapThisAbility = null;
		for (var i=0; i < gui._abilityButtonList.length; ++i)
		{
			button = gui._abilityButtonList[i];
			if(button._buttonLayer.numberOfRunningActions() == 0)
			{
				if (tapThisAbility == null)
				{
					tapThisAbility = button;
				}
				else 
				{
					if(button._tag == kActorActivatedAbilityTagAttachMini)
					{
						tapThisAbility = button;
						break;
					}
				}
			}
		}
		return tapThisAbility;
	},
	
	//+ (void)showAbilityHelperArrow
	$showAbilityHelperArrow: function()
	{
		var gui = ZFFightGUI;
		
		var tapThisAbility = this.getAbilityToShowArrowWith();
		var temp = gui._abilityButtons.getChildByTag(gui.fightGuiTags.kFightGuiTagAbilityHelperArrow);
	
		if(temp && tapThisAbility && temp._userData == tapThisAbility)
			return;
		// exit without making changes
		
		gui._abilityButtons.removeChildByTag(gui.fightGuiTags.kFightGuiTagAbilityHelperArrow, true);
		
		if (!tapThisAbility)
		{
			return;
			// returns after cleanup
		}
		
		var arrow = CCSprite.spriteWithFile("tapAbility1.png");
//		arrow.setAlpha(0);
		arrow.setScale(1);
		arrow._userData = tapThisAbility;
		
		// find ability at top row ... or ability that needs to be tapped first
		arrow.setPosition(ccpAdd(tapThisAbility._buttonLayer.getPosition(), new Core.Point(65, 0)));
		gui._abilityButtons.addChild(arrow, 5, gui.fightGuiTags.kFightGuiTagAbilityHelperArrow);
		
		arrow.runAction(CCRepeatForever.actionWithAction(
				CCSequence.actions(
				 [CCMoveTo.actionWithDuration(0.25, ccp(arrow.getPosition()._x + 10, arrow.getPosition()._y )),
				  CCMoveTo.actionWithDuration(0.25, ccp(arrow.getPosition()._x, arrow.getPosition()._y ) ) ]
				 ))); 
		
		
//		var action1 = CCMoveBy.actionWithDuration(25.0, new Core.Point(10.0, 0.0));
//		arrow.runAction(CCRepeatForever.actionWithAction(
//						CCSpawn.actions(
//						CCAnimate.actionWithDuration(0.5, animMixed, false),
//						CCFadeTo.actionWithDuration(0.25, 255),
//						CCSequence.actions(action1, action1.reverse(), null), null)));
	},
	
	//+ (void)cleanAbilityHelperArrow
	$cleanAbilityHelperArrow: function()
	{
		var gui = ZFFightGUI;
	    if (gui._abilityButtons) {
    		var temp = ZFFightGUI._abilityButtons.getChildByTag(gui.fightGuiTags.kFightGuiTagAbilityHelperArrow);
    		if(temp != null)
    		{
    			temp._userData = null;
    			gui._abilityButtons.removeChildByTag(gui.fightGuiTags.kFightGuiTagAbilityHelperArrow, true);
    		}
	    }
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GameObjects/ZFEnemyDrop'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GameObjects/ZFEnemyDrop'] || {}; $MODULE_REGISTRY['Code/Game/GameObjects/ZFEnemyDrop'] = exports; exports.ZFEnemyDrop = Core.Class.subclass
({
	classname : 'ZFEnemyDrop',
	
	initialize : function()
	{
		this._name = null; //String
		this._sprite = null; // CCNode
		this._spriteNode = null; // CCNode
	},
	
	destroy : function($super)
	{
		if(this._spriteNode)
		{
			this._spriteNode.removeAllChildrenWithCleanup(true);
			destroyWithChildren(this._spriteNode);
			this._spriteNode = null;
		}
		
		if(this._sprite)
		{
			this._sprite.removeAllChildrenWithCleanup(true);
			destroyWithChildren(this._sprite);
			this._sprite = null;
		}
			
		this._name = null;
		
		$super();
	}
}); return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorRegular/LaserNode'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorRegular/LaserNode'] || {}; $MODULE_REGISTRY['Code/Game/Actor/Types/Zombies/ZombieActorRegular/LaserNode'] = exports; var CCNode = require('Code/Cocos2D/CCNode').CCNode;

exports.LaserNode = CCNode.subclass( 
{
	initialize: function()
	{
		this._active 		= false;
		this._laserType 	= 0;
		this._zombie 		= null;
		this._laserShine	 = null;	
		this._laserLayer =  null;

		return this;
	},

	hide: function(){
		this._withLaser = false;
		
		if (this._laserShine && this._laserShine.getParent())
        {
            this._laserShine.getParent().removeChild(this._laserShine, true);
        }
    	
        if (this._laserLayer && this._laserLayer.getParent())
        {
            this._laserLayer.getParent().removeChild(this._laserLayer, true);
            this._laserLayer = null;
        }
	},
	draw: function()
	{
		if( this._active && this._laserType > 0)
		{				
			fm = ZFFightMan;
			
			target = null; // CivilianActorFight
			
			if(			fm._bossWall 
					&& 	fm._bossWall._fightData._hitPoints > 0 
					&& 	fm._bossWall.getPosition()._x > this.getPosition()._x )
			{
				target = fm._bossWall;
			}
			else if(	fm._enemy 
					&&  fm._enemy._fightData._hitPoints > 0 
					&&		(fm._enemy._state == kActorFightStateFight    ||
							 fm._enemy._state == kActorFightStateFighting ||
							 fm._enemy._state == kActorFightStateStunned ) )
			{
				target = fm._enemy;
			}
			
			// TODO Convert drawing of laser. look at ZFSelectorLayer
//			if( target )
//			{
//				glEnable(GL_LINE_SMOOTH);
//				glEnable(GL_POINT_SMOOTH);
//				
//				float width = 0;
//				
//				CGPoint start = ccp(0,0);
//				CGPoint end	  = ccp(target.position.x - zombie.position.x,0);
//				
//				// border laser
//				if(laserType == 2)
//				{
//					glColor4ub(0x00, 0x00, 0xFF, 0xFF);
//					
//					float width = 4 * CCARCRANDOM_0_1() + 2;
//					glLineWidth(width);
//					
//					if(start.x < end.x)
//						ccDrawLine(start, end);
//				}
//				
//				// inside laser
//				if(laserType == 1)
//				{
//					glColor4ub(0xFF, 0x00 ,0x00, 0xFF);
//					width = 4 * CCARCRANDOM_0_1() + 1;
//				}
//				else if(laserType == 2)
//				{
//					glColor4ub(0xFF, 0xFF, 0xFF, 0xFF);
//					width = 1 * CCARCRANDOM_0_1() + 1;
//				}
//				
//				glLineWidth(width);
//				
//				if(start.x < end.x)
//					ccDrawLine(start, end);
//				
//				glDisable(GL_POINT_SMOOTH);
//				glDisable(GL_LINE_SMOOTH);	
//			}
		}
	},

	destroy: function( $super )
	{
		if( this._zombie )
			this._zombie = null;
		
		if( this._laserShine ){
			destroy(this._laserShine);
			this._laserShine = null;
		}
		
		$super();
	},
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/FightGameScene/ZFFightWall'] = function(){var exports = $MODULE_REGISTRY['Code/Game/FightGameScene/ZFFightWall'] || {}; $MODULE_REGISTRY['Code/Game/FightGameScene/ZFFightWall'] = exports; 

exports.ZFFightWall = CCColorLayer.subclass(
{
	classname: "ZFFightWall",
	
	initialize: function() {
	
	this.initWithColor( ccc4( 0x00 , 0xff , 0x00 , 0x00 ) , 32 , 32 );
	
	this._hitPoints = 0;    //float
	this._maxHitPoints = 10;  //float
	this._widthScale = 0 ; //float
	this._heightScale = 0 ; //float
	this._isTouchEnabled = true;
	this._sprite = null ;// CCSprite
	this._arrow = null ;// CCSprite
	
	if ( !this.isScheduled(this.showWallHelperArrow) )
	{
		this.schedule(this.showWallHelperArrow, 3, "showWallHelperArrow");
	}
	
	return this;
				
	},
	
	//setScale(SUPER)
	setTarget: function()
	{
		this._target = new GL2.TouchTarget();
		this._target.setAnchor(new Core.Point(0.0, 1.0));
		this._target.setPosition(new Core.Point(0,0));
		this._target.setSize(this._contentSize._width, this._contentSize._height);
		
		this._listener = new Core.MessageListener();
		this._target.getTouchEmitter().addListener(this._listener, this.onWallTouch.bind(this));
		this.addChild(this._target);
		this._target.setDepth(100000);
	},
	
	damage: function(damage)
	{
		
		this._hitPoints -= damage;
		var ratio = this._hitPoints / this._maxHitPoints;
		this._sprite.setScale( 0.5*this._widthScale + 0.5*ratio*this._widthScale );
//		this._sprite.setScale(1,ratio);
	},
	
	cleanWall : function (){
		var fm = ZFFightMan;
		if(this._sprite){
			if(this._sprite.getParent())
				this._sprite.getParent().removeChild(this._sprite, true);
			destroyWithChildren(this._sprite);
			this._sprite= null;
		}
		
		if(this._arrow){
			if(this._arrow.getParent())
				this._arrow.getParent().removeChild(this._arrow, true);
			destroyWithChildren(this._arrow);
			this._arrow= null;
		}
		
//		if(this.getParent())
//			this.getParent().removeChild(this, true);
		
		if (this.isScheduled(this.showWallHelperArrow))
		{
			this.unschedule(this.showWallHelperArrow);
		}
		
		
		for(var key in fm._zombies)
		{
			var z = fm._zombies[key];
			if (z.isScheduled(this.damageWallIn))
			{
				z.unschedule(this.damageWallIn);
			}
		}
//		fm._wall = null;
//		destroyWithChildren(this);
	},
	
	showWallHelperArrow: function(dt)
	{
		this.unschedule(this.showWallHelperArrow);
		
		if (this._arrow || this._hitPoints <= 0)
		{
			return;
		}
		
		this._arrow = CCSprite.spriteWithFile( "tap1.png" );
//		this._arrow.setOpacity( 255 );
		this._arrow.setScale( 0.67*this._widthScale );
		
		//TODO: check if is getX or getY.
//		var f1 = this._sprite.getScale()._x; // float
//		var f2 = this._widthScale; //float
//		var f3 = f1/f2;	//floating point division is weird
		
//		var spritePos = new Core.Point(this._contentSize._width/2, this._contentSize._height/2 * f3 + 25 * this._widthScale);
		var spritePos = new ccp(this._contentSize._width/2, this._contentSize._height+ 40 * this._widthScale);
		
		this._arrow.setPosition(spritePos);
		
		this.addChild(this._arrow, 0);
		
		this._arrow.runAction(CCRepeatForever.actionWithAction(
				CCSequence.actions(
				 [CCMoveTo.actionWithDuration(0.25, ccp(this._arrow.getPosition()._x,this._arrow.getPosition()._y+10*this._widthScale)),
				  CCMoveTo.actionWithDuration(0.25, ccp(this._arrow.getPosition()._x,this._arrow.getPosition()._y ) ) ]
				 )));  
		
		
		
		
//		var frame1 = CCSpriteFrame.frameWithTexture(CCTextureCache.sharedTextureCache.addImage("tap1.png"), new Core.Rect(0,0,64,64), new Core.Point(0,0));
//		var frame2 = CCSpriteFrame.frameWithTexture(CCTextureCache.sharedTextureCache.addImage("tap2.png"), new Core.Rect(0,0,64,64), new Core.Point(0,0));
//		
//		CCSrpiteFrame.sharedSpriteFrameCache().addSpriteFrame( frame1, "tap1.png" );
//		CCSrpiteFrame.sharedSpriteFrameCache().addSpriteFrame( frame2, "tap2.png" );
//		
//		var a = [ frame1, frame2, null ];		
//		var animMixed = CCAnimation.animationWithName( "tapMe", 1.0, a );		
//		
//		var act1 = CCAnimation.actionWithDuration( 0.5 , animMixed , false ); // duration, animation, restoreOriginalFrame
//		var act2 = CCFadeTo.actionWithDuration(  0.25 , 1 ); // duration, opacity
//		var act3 = CCSequence.actions(  act1, act2.reverse(), null );
//		var spawn = CCSpawn.actions( act1 , act2 , act3, null );
//		
//		this._arrow.runAction( CCRepeatForever.actionWithAction( spawn ) );		
	},
	
	onWallTouch : function(touch)
	{
		switch(touch.getAction())
		{
			case touch.Action.Start:
					this.damage(this._maxHitPoints/20);
					return true;
				break;
		}
	}
	
//	ccTouchBegan: function( touch , event ) // UITouch*, UIEvent*
//	{
//		
//		console.log("TOUCHBEGAN !!!!!!!!!!!!!!!!!!!")
//		//TODO: Code from "ActorHitBox.js" need revision
//		var pos = touch.locationInView( touch._view );
//		pos = CCDirector.sharedDirector.convertToGL( pos );
//		var nodePos = this.convertToNodeSpace( pos );
//		var rect = rectMake( 0 , 0 , this._contentSize._width , this._contentSize._height );
//		
//		if ( rectContainsPoint( rect , nodePos ) )
//		{
//			return true;
//		}
//		
//		return true;
//	},
//	
//	ccTouchEnded: function( touch , event ) // UITouch*, UIEvent*
//	{
//		console.log("TOUCHENDED !!!!!!!!!!!!!!!!!!!")
//		
//		//TODO: Code from "ActorHitBox.js" need revision!
//		var pos = touch.locationInView( touch._view );
//		pos = CCDirector.convertToGL( pos );
//		var rect = rectMake( 0 , 0 , this._contentSize._width , this._contentSize._height );
//		var nodePos = this.convertToNodeSpace( pos );
//
//		if ( rectContainsPoint( rect , nodePos ) && this._active )
//		{
//			if ( this._arrow)
//			{
//				this.removeChild( this._arrow, true );
//				this._arrow = null;
//			}
//
//			if ( this.isScheduled( this.showWallHelperArrow ) )
//			{
//				this.unschedule( this.showWallHelperArrow );
//			}
//			
//			this.schedule( this.showWallHelperArrow , this._tapDelay );
//			
//			if ( this._target )
//			{
//				this._target.performSelector( this.hitBoxTouched );
//			}
//		}
//	}
});

; return exports;};
(function()
{
	if(!Function.prototype.hasOwnProperty('bind'))
	{
		var slice = Array.prototype.slice;
		Function.prototype.bind = function(context)
		{
			var func = this;
			if(arguments.length > 1)
			{
				var args = slice.call(arguments, 1);
				return function()
				{
					if(arguments.length)
					{
						var finalArgs = args.concat(slice.call(arguments));
						return func.apply(context, finalArgs);
					}
					else
					{
						return func.apply(context, args);
					}
				}
			}
			else
			{
				return function()
				{
					if(arguments.length)
						return func.apply(context, arguments);
					else
						return func.call(context);
				}
			}
		}
	}
})();

(function()
{
	if(!Array.prototype.hasOwnProperty('indexOf'))
	{
		Array.prototype.indexOf = function(obj)
		{
			var len = this.length;
			for(var i=0; i < this.length; ++i)
			{
				if(obj === this[i])
					return i;
			}
			return -1;
		}
	}
})();

(function()
{
	if (typeof(console) == 'undefined') { 
		console = { log: function(str) {} };
	}
})();

function userGameInit()
{
	console.log("ngCore calling main()");
	main();
}
//////////////////////////////////////////////////////////////////////////////
/** 
 *  @date:      2010-11-0?
 *  @file:      NgWebEngine.js
 *  Website:    http://www.ngmoco.com/
 *  Copyright:  2010, by ngmoco:)
 *              Unauthorized redistribution of source code is 
 *              strictly prohibited. Violators will be prosecuted.
 * 
 *  @brief:
 */
//////////////////////////////////////////////////////////////////////////////
var NGSetTimeoutRunTimers = require('NGCore/Client/UI/NGJSEnvironmentSupport').NGSetTimeoutRunTimers;
var SystemBinding = require('NGCore/Client/UI/SystemBinding').SystemBinding;
var UI = require('NGCore/Client/UI').UI;
var AlertDialog = UI.AlertDialog;
var ProgressDialog = UI.ProgressDialog;
var Downloader = require('NGCore/Client/Network/DownloadManifest').Downloader;
var LocalGameList = require('NGCore/Client/Core/LocalGameList').LocalGameList;
var Device = require('NGCore/Client/Device').Device;
var Core = require('NGCore/Client/Core').Core;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Localization = require('NGCore/Client/Core/Localization').Localization;

// Global until oauth does not depend on storage.
Storage = require('NGCore/Client/Storage').Storage;

//////////////////////////////////////////////////////////////////////////////////////////////////
// App switching.

var NgProcID =
{
    PersistProc: -1,
    GameProc: -2
};

//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */

var gNgShutdownPending = false;


/////////////////////////////////////////////////////////////////////////////////////////////////
// Global data.
//////////////////////////////////////////////////////////////////////////////////////////////////

var gNgEngineEntities;
var gNgAddedEngineEntities;
var gNgRemovedEngineEntities;

var gNgUpdateEngineEntities;
var gNgTouchEngineEntities;
var gNgKeyPressEngineEntities;

//////////////////////////////////////////////////////////////////////////////////////////////////
// This function is called once by the html container to initialize the game.
//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */

function NgEngineInitPrivate()
{
	NgLogInit();

	NgApplication.getInstance().restart();

	gNgEngineEntities = new Array();
	gNgAddedEngineEntities = new Array();
	gNgRemovedEngineEntities = new Array();

	gNgUpdateEngineEntities = new Array();
	gNgTouchEngineEntities = new Array();
    gNgKeyPressEngineEntities = new Array();

	Core.Analytics.instantiate();
}

//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */

function NgEngineProcessEntityAddRemove()
{
	for(var i in gNgAddedEngineEntities)
	{
		var e = gNgAddedEngineEntities[i];
		if(e.mIsTouchable) NgInsertSortedTouch(e);
		if(e.mIsKeyable)	NgInsertSortedKeyPress(e);
		if(e.mIsUpdatable) gNgUpdateEngineEntities[e.mId] = e;
	}
	gNgAddedEngineEntities = [];

	for(var i in gNgRemovedEngineEntities)
	{
		var e = gNgRemovedEngineEntities[i];

		if(e.mIsTouchable)	gNgTouchEngineEntities.splice(NgFindIndex(gNgTouchEngineEntities,e),1);
		if(e.mIsKeyable) gNgKeyPressEngineEntities.splice(NgFindIndex(gNgKeyPressEngineEntities,e),1);
		if(e.mIsUpdatable) delete gNgUpdateEngineEntities[e.mId];
	}
	gNgRemovedEngineEntities = [];
}

/**
  * @private
  */

function NgHandleException(ex)
{
	if (Core.Proc.isPrivileged()) {
		NgLogException( ex );
	}
	else {
		var exStr = JSON.stringify(ex);
		NgLogException( ex );
		Core.LocalGameList._forwardException(exStr);
	}
}

function NgEngineInit(inputs)
{
	NgLogD("NgEngineInit beg");
	try
	{
		NgEngineInitPrivate();

		time.setCtr('frame',1000,NgLogD);

		//NgLogD("Initializing Storage");
		//Storage.init();
		//NgLogD("Storage initialized");
		NgLogD("KeyValue Storage initializing...");
		Storage.KeyValueCache.init();
		NgLogD("KeyValue Storage initialized...");
	
		Core.Time.instantiate();
	
		NgLogD("Instantiate the Localization context (singleton), depends on Capabilities");
		Localization.instantiate();

	}
	catch( ex )
	{
		NgHandleException(ex);
	}
	NgLogD("NgEngineInit end");	
	
	return NgEngineUpdate(inputs);
}

function NgPreInit(inputs)
{
	NgLogD("Localization NgPreInit beg");
	return update(inputs);
}

/**
  * @private
  */

function NgGameInit(inputs)
{
	NgLogD("NgGameInit beg");
	try
	{
		NGWindow = UI.Window;

		userGameInit();
	}
	catch( ex )
	{
		NgHandleException(ex);
	}
	NgLogD("NgGameInit end");

	return update(inputs);
}

/**
  * @private
  */

// TEMPORARY: Until native code is updated to call NgEngineUpdate.
function update ( inputs )
{
	return NgEngineUpdate ( inputs );
}

//Frame loop calls this every time, get the object out of require once ahead of time.
var NGSetTimeoutRunTimers = require('NGCore/Client/UI/NGJSEnvironmentSupport').NGSetTimeoutRunTimers;

var setTimeoutOrig = setTimeout;
setTimeout  = function(fn, time)
{
	return setTimeoutOrig(function() 
	{
		try
		{
			fn();
		}
		catch( ex )
		{
			NgHandleException(ex);
		}
	}, time);
	
}


var setIntervalOrig = setInterval;
setInterval  = function(fn, time)
{
	return setIntervalOrig(function() 
	{
		try
		{
			fn();
		}
		catch( ex )
		{
			NgHandleException(ex);
		}
	}, time);
	
}



/**
  *	Main entry point for native to invoke JS.
  * @private
  */
var NgEngineUpdate = (function()
{
	var Core = require('NGCore/Client/Core').Core;
	
return function ( inputs )
{
	// time causes a racehorse-sized leak in v8. Only use this for single profiling runs. DO NOT CHECK IN.
//	time.stop('frame');
//	time.start('frame');
	
	try {
		NGSetTimeoutRunTimers();

		if(inputs.length)
		{
			NgEngineProcessEntityAddRemove();
			var commands = inputs.split(':');
			for(var i=0; i<commands.length; ++i)
			{
				command = commands[i];

				// Make sure this isn't an empty input.
				if(0 == command.length) {
					continue;
				}

				switch(parseInt(command))
				{
					case NgEntityTypes.App:
						NgApplication.getInstance().handleCommand(command);
						break;
					case NgEntityTypes.NgFileSys:
						NgApplication.getInstance().getFileSys().handleCommand(command);
                        break;
					case NgEntityTypes.Storage:
						NgLogD("Command for storage is " + command);
						Storage.getInstanceForCommand(command).handleCommand(command);
						break;
					case NgEntityTypes.NgUI:
						NGWindow.handleCommand(command);
						break;
					case NgEntityTypes.NgSystemBinding:
						SystemBinding.handleCommand(command);
						break;
					case 3117:
						console.log('got leet response');
						if(typeof(_WifiDiagCallback) != 'undefined')
							_WifiDiagCallback(command);
						break;
					default:
						Core.Proc._classRecvGen( command.split( ',' ) );
						break;
				}
			}
		}

		if( gNgShutdownPending )
		{
			gNgShutdownPending = false;
		}
		else	// Don't do updates if we're resetting.
		{
			NgEngineProcessEntityAddRemove();
			for(var i in gNgUpdateEngineEntities)
			{
				var entity = gNgUpdateEngineEntities[i];
				if(!entity.mRegistered) continue;
				entity.onUpdate();
			}
		}
	}
	catch(ex)
	{
		NgHandleException(ex);
	}
		
	var tmp = Core.Proc.getCommandString() + gNgCommandString;
	gNgCommandString = tmp;
	Core.Proc.clearCommandString();

	return NgFlushCommandsToString();
}
})();


//////////////////////////////////////////////////////////////////////////////////////////////////
////	NgApplication class
//////////////////////////////////////////////////////////////////////////////////////////////////

var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Logger = require('NGCore/Client/Core/Logger').Logger;

/** @private */

var NgApplicationCommands = {
	Caps : 0,
	Debug : 1,
	FrameTime : 2,
	FrameRate : 3,
	Start : 4,
	DeviceOrientation: 10,
	SetOrientation: 11,
	BackPress: 12,
	OnBackPressed: 13,
	LaunchExternalNativeApp: 15,
	ExitSystemProcess: 16
};

/**
  * Enumeration values for orientation change events received by
  * {@link NgApplicationObserver}.
  */

var NgApplicationOrientation = {
	Portrait : 0,
	PortraitUpsideDown : 1,
	LandscapeLeft : 2,
	LandscapeRight : 3,
	FaceUp : 4,
	FaceDown : 5
};

/**
  * The NgApplication constructor is invoked during application bootstrap and
  * should not be created by the ngGame application.  Access to the application
  * object should be through the singleton accessor {@link NgApplication#getInstance}.
  * @constructor
  *
  * @class
  * The NgApplication class represents global state and services that are available to
  * ngGame applications.  This includes file system operations,
  * download services, etc.  The application class also manages a time source
  * that is synchronized between the native engine and the ngGame application. <br>
  * The application object is a singleton and should only be accessed through the
  * {@link NgApplication#getInstance} method.
  */

function NgApplication()
{
	/** @private */
	this.mFileSys = Storage.FileSystem;
	/** @private */
	this.mFrameTime = 0.0;
	/** @private */
	this.mObservers = [];
}

// Singleton instance.
/** @private */
NgApplication.sInstance = null;

/**
  * Acquire the singleton instance of the application class.
  * @type NgApplication
  * @return The global application object.
  */

NgApplication.getInstance = function()
{
	if( NgApplication.sInstance == null )
		NgApplication.sInstance = new NgApplication();

	return NgApplication.sInstance;
};

// APITODO: Switch these methods to be defined out-of-line, not by an object literal.

NgApplication.prototype =
{
	mFileSys : null,
	mObservers : [],
	mFrameTime : 0.0,
	
	/** @private */
	restart : function()
	{
	},
	
	/** @private */
	handleCommand : function(command)
	{
		//		NgLogD( "NgApplication command = " + command );

		var commandId = NgPeekCommandId( command );

		switch( commandId )
		{
			case NgApplicationCommands.FrameTime:
				this.parseFrameTime( command );
				break;
			case NgApplicationCommands.Start:
				this.onApplicationStart();
				break;
			case NgApplicationCommands.OnBackPressed:
				this.onApplicationBackPressed();
				break;
			default:
				NgLogE( "NgApplication command unknown: " + command);
				break;
		}
	},
	
	/**
	  * Acquire the file system object.
	  * @type NgFileSys
	  * @return The file system instance.
	  */
	getFileSys : function()
	{
		return this.mFileSys;
	},

	/** @private */
	ngLog : function( level, dbgStr )
	{
		NgPushCommand4( NgEntityTypes.App, NgApplicationCommands.Debug, Core.Base64.encode( dbgStr ), level );
	},
	
	/** @private */
	parseFrameTime : function( command )
	{
		var fields = NgParseCommand2(command,parseInt,parseFloat);
		var frameTime = fields[1];

		if(this.mFrameDelta == undefined)
			this.mFrameDelta = 0;
		else
			this.mFrameDelta = frameTime - this.mFrameTime;

		this.mFrameTime = frameTime;
	},
	
	/**
	  * Get the application time for the current frame.
	  * @type number
	  * @return The time in milliseconds.
	  */
	getFrameTime : function()
	{
		return this.mFrameTime;
	},
	
	/**
	  * Get the application time delta between the current frame and the last frame.
	  * @type number
	  * @return The time delta in milliseconds.
	  */
	getFrameDelta : function()
	{
		return this.mFrameDelta;
	},

	/**
	  * Set the desired application frame rate. <br>
	  * Note: The frame rate specification is not currently fully functional on all 
	  * platforms.
	  * @param {number} frameRate The desired frame rate in hz.
	  * @type void
	  */
	setFrameRate : function(frameRate)
	{
		NgPushCommand3( NgEntityTypes.App, NgApplicationCommands.FrameRate, frameRate);
	},

	/**
	  * Set the current device orientation for the application. <br>
	  * Note: Setting the orientation is not currently fully functional on all
	  * platforms.
	  * @param {NgApplicationOrientation} orientation The desired orientation.
	  * @type void
	  */
	setOrientation : function(orientation)
	{
		NgPushCommand3( NgEntityTypes.App, NgApplicationCommands.SetOrientation, orientation);
	},

	/**
	  * Register an application observer to receive application callbacks.
	  * @param {NgApplicationObserver} obs The observer to register.
	  * @type void
	  */
	registerObserver : function(obs)
	{
		obs.index = this.mObservers.push(obs);
	},

	unregisterObserver : function(obs)
	{
		if (obs.index)
			delete this.mObservers[obs.index - 1];
	},

	/** @private */
	onApplicationStart : function()
	{
		NgUI.onLoad();
		for (i in this.mObservers)
		{
			// TODO is this even possible?
			this.mObservers[i].onApplicationStart();
		}
	},
	
	/** @private */
	onApplicationReceivedCustomMessage : function( message )
	{
		for (i in this.mObservers)
		{
			this.mObservers[i].onApplicationReceivedCustomMessage( message );
		}
	},
	
	/** @private */
	onApplicationBackPressed : function()
	{
			var observerResult = false;
			for (i in this.mObservers)
			{
				 if (this.mObservers[i].onApplicationBackPressed())
				 {
					observerResult = true;
					break;
				 }
			}
			if (!observerResult)
			{
				// back button was not fully handled. Ask the native application to handle it.
				NgPushCommand2(NgEntityTypes.App, NgApplicationCommands.BackPress);
			}
	},
	
	/** @private */
	exitSystemProcess : function ()
	{
		NgLogD ( "pushing exit command" );
		//This makes java exit the app through android lifecycle
		NgPushCommand2(NgEntityTypes.App, NgApplicationCommands.BackPress);
		NgLogD ( "pushed exit command" );
	}
};

// Observer base class for application events.

/**
  * Initialize a new application observer.
  * @constructor
  *
  * @class
  * The NgApplicationObserver class is used as the base class for any user-defined
  * class that receives application-level callbacks.  This currently includes
  * notifications on all application lifecycle events and device orientation
  * changes. <br>
  * Register the application observer by calling {@link NgApplication#registerObserver}.
  */

function NgApplicationObserver() {}

NgApplicationObserver.prototype =
{
	index: 0,
	/**
	  * Callback for application lifecycle start event.
	  * @type void
	  */
	onApplicationStart:function() {},

	/** @private */
	onApplicationReceivedCustomMessage:function( message ) {},

	/**
	  * Callback for device orientation change events.
	  * @param {NgApplicationOrientation} orientation Orientation enumeration value.
	  * @type void
	  */
	onApplicationDeviceOrientation:function( orientation ) {},

	/*
	 * Listener for when the user pushes the HW back button. Currently Android only.
	 *
	 * @return boolean true if back was handled entirely (eat the event), 
	 * false if it was not
	 *
	 */
	onApplicationBackPressed:function()
	{
		return false;
	}
};

//////////////////////////////////////////////////////////////////////////////////////////////////
// class Entity
// Base class for other entity types.
//////////////////////////////////////////////////////////////////////////////////////////////////

// ObjectTypes
// Defined in
//		JS:  NgEntityTypes in NgWebEngine.js and
//		C++: EntityCommandIds in GameView.h
// 1 = App
// 2 = NgTouchEvent
// 3 = NgKeyPressEvent
// 4 = Accel
// 5 = NgTextInputBox2D
// 6 = Animation (completion events)
// 7 = Sound (completion events)
// 8 = EngineEntity
// 9 = DrawableEntity2D
// 10 = NgCanvas2D
// 11 = NgCamera2D
// 12 = NgSprite2D
// 13 = NgText2D
// 14 = NgWebView2D
// 15 = NgAudioManager
// 16 = NgGroup2D
// 100 = LoadApp

// App Commands
// in:
// capabilities = 0, command dictionary format
// frameTime = 2, double
// out:
// NgLogD = 1, string

// NgTouchEvent Commands
// non-native
//	action: 1 = add, 2 = remove, 3 = modify
//	id: touch instance ID
//	x: x position
//	y: y position
// native
//	action: 4 = add, 5 = remove, 6 = modify
//	id: touch instance ID
//	x: x pos
//	y: y pos
//  eid: entity instance ID
//	lx: local x pos
//  ly: local y pos

// NgKeyPressEvent Commands
// action: 1 = down, 2 = up
// id: instance ID
// value: key value

// InputText Box Commands

// Animation
// in:
// only one kind of event, so first value is id of sprite to callback.

// Sound
// in:
//

// Accel Commands
// out:
// SetEventRate = 0, rate (hz)
// in:
// x, y, z position (floats)

// EngineEntity commands

// DrawableEntity2D commands:
// SetNativeTouchType=1,id,value (None=1, Enable = 2, EnableBounds = 3)

// NgCanvas2D Commands
// NewNgCanvas2D=1, id
// DeleteNgCanvas2D=2, id
// Update=3, id, args... not used currently
// SetRoot=4, id, grp id
// ClearRoot=5, id
// EnableNativePicking=6, id, bool

// NgCamera2D Commands
// NewNgCamera2D=1,		id, canvasId, porperties
// DeleteNgCamera2D=2,	id
// UpdateNgCamera2D=3,	id, properties
//	Properties: vx, vy, vz, vh, vw, cx, cy, ch, cw

// NgSprite2D Commands
// NewNgSprite2D=1,		id, canvasId, texture, properties
// DeleteNgSprite2D=2,	id
// UpdateNgSprite2D=3,	id, properties
//   Properties: x, y, z, w, h, r, a

// NgText2D Operations
// NewNgText2D=1		id, canvasId, properties
// DeleteNgText2D=2	id
// UpdateNgText2D=3	id, properties
//  Properties: x, y, z, w, h, justify, text

// NgGroup2D Operations
// New = 1			id, canvasId, [properties/todo]
// Delete = 2		id
// Update = 3		id, [properties/todo]
// Child = 4		id, subcmd, [child id]
//						subcmd 0 = add, 1 = rem, 2 = remAll (no child id)
// Rot = 5			id, anglef
// Pos = 6			id, xf, yf, zf
// Alpha = 7		id, alphaf
// Scale = 8		id, xf, yf

// APITODO: Clean up these identifiers.
// APITODO: Sound is probably not used any more.
// APITODO: Animation is probably not used any more.

var NgEntityTypes = {
	App : 1,
	NgTouchEvent : 2,
	NgKeyPressEvent : 3,
	Accel : 4,
	NgTextInputBox2D : 5,
	Animation : 6,
	Sound : 7,
	NgEngineEntity : 8,
	NgDrawableEntity2D : 9,
	NgCanvas2D : 10,
	NgCamera2D : 11,
	NgSprite2D : 12,
	NgText2D : 13,
	NgWebView2D : 14,
	NgGroup2D : 16,
	NgPhysics2D: 17,
	NgPrimitive2D: 18,
	NgFileSys: 19,
	Gyro : 22,
	NgUI : 23,
	Storage: 24,
	NgSystemBinding: 25,
	NgCustomMessage : 50,
	LoadApp : 100
};

var NgEngineEntityCommandIDs = {
	SetNativeTouchType : 1
};

/**
 * Initializes instance to default values. <br>
 * mId member defaults to 0 but can be set by application before calling {@link NgEngineEntity#register}.
 * @constructor
 *
 * @class
 * NgEngineEntity is the base class for all game entities, such as NgSprite2D and NgText2D. <br>
 * This class introduces key callback functions for touch, key press and per-frame update
 * notification. <br>
 * Additionally, the class introduces a register/unregister mechanism
 * for controlling the existence of the entity in the native game engine.
 *
 */

function NgEngineEntity()
{
	/** The entity id.  Used by the native engine for identification.  @type number */
	this.mId = 0;
	/** The touch priority.  Touches are routed first to the highest priority entities.  @type number */
	this.mTouchPriority = 0;
	/** The key press priority.  Key presses are routed first to the highest priority entities.  @type number */
	this.mKeyPressPriority = 0;
	/** @private */
	this.mIsTouchable = false;
	/** @private */
	this.mIsKeyable = false;
	/** @private */
	this.mIsUpdatable = false;
	/** @private */
	this.mNativeTouchType = NgEngineEntity.NativeTouchType.Enable;
	/** @private */
	this.mRegistered = false;
}

// Static methods and data.

/**
  * NgEngineEntity touch policy enumeration. <br>
  * Used with {@link NgEngineEntity#setNativeTouchType} and {@link NgCanvas2D#enableNativePicking}. <br>
  * Values: <br>
  * None : Disables native touches for this entity (and its children). <br>
  * Enable : Enables this entity to receive touches (or visits child entities) <br>
  * EnableBounds : Enables this entity to receive touches on its axis-aligned bounding box.  If
  * a touch is received on a group, it will report the touch and _not_ visit the group's children.
  */

NgEngineEntity.NativeTouchType = {
	None : 0,
	Enable : 1,
	EnableBounds : 2
};

/**
  * @private
  */

NgEngineEntity.engineCurrentId = 1;

/**
  * Allocate a unique ID for an entity.
  * @return ID value.
  * @type number
  * @private
  */

NgEngineEntity.newEngineId = function ()
{
	return NgEngineEntity.engineCurrentId++;
}

/**
  * Reclaim an entity ID.
  * @private
  */

NgEngineEntity.deleteEngineId = function ()
{
	// Nothing.
}

// Instance methods.

// Basic entity callbacks.

/** @private */

NgEngineEntity.prototype.newEntity = function() {}

/** @private */

NgEngineEntity.prototype.deleteEntity = function() {}

/**
  *	Callback for standard touch events. <br>
  * Standard touch events correspond to all touches
  * within the game view.  For each touch on the game view, all registered touchable
  * entities will receive the event.  Application logic must perform filtering to determine
  * if a particular entity corresponds to the touch event. <br>
  * Refer to {@link NgEngineEntity#toggleTouchable} for control of an entity's touchable state.
  * @param {NgTouchEvent} touch The touch event.
  * @return The application can return true to indicate that it has consumed this event or false
  * to allow other entities to continue processing this event.
  * @type bool
  */

NgEngineEntity.prototype.onTouch = function(touch)
{
	return false;
}

/**
  * Callback for native touch events. <br>
  * Native touch events are pre-filtered by the game engine
  * to correspond to a specific touchable entity.  For each touch on the game view, the game
  * engine will determine which game entities are selected by the touch event.  Only the 
  * selected entities will receive the onNativeTouch event callback. <br>
  * Native touch capability is not affected by touchable state of the entity determined by
  * {@link NgEngineEntity#toggleTouchable}.  Refer to {@link NgEngineEntity#setNativeTouchType} 
  * for management of an entity's native touch policy.
  * @param {NgNativeTouchEvent} touch The touch event.
  * @return The application can return true to indicate that it has consumed this event or false
  * to allow other entities to continue processing this event.
  * @type bool
  */

NgEngineEntity.prototype.onNativeTouch = function(touch)
{

}

/**
  * Callback for keyboard events. <br>These events correspond to physical or software keyboard events. <br>
  * Enable/disable key press events for an entity with {@link NgEngineEntity#toggleKeyable}.
  * @param {NgKeyPressEvent} keyPress The key press event.
  * @return The application can return true to indicate that it has consumed this event or false
  * to allow other entities to continue processing this event.
  * @type bool
  */

NgEngineEntity.prototype.onKeyPress = function(keyPress)
{
	return false;
}

/**
  *	Callback for update events. <br>Per-frame entity logic should be implemented in this callback. <br>
  * Enable/disable update events for an entity with {@link NgEngineEntity#toggleUpdatable}.
  * The return value of this method is ignored.
  * @type void
  */

NgEngineEntity.prototype.onUpdate = function()
{
}

/**
  *	Register this entity instance with the native game engine. <br>
  * The initialization sequence of engine entities has specific constraints: <br>
  * After construction and before calling
  * the register method, class methods that affect the native engine state cannot be called.  
  * During this period, changes to entity state by changing instance variables will be
  * sent to the native engine on the call to register. <br>
  * After register is called, 
  * changes to instance variables will be ignored.  During this phase, the only
  * way to affect native engine state is through methods that push commands to
  * the native side.
  * @type void
  */

NgEngineEntity.prototype.register = function()
{
	this.mParents = new Array();

	if( this.mId >= 0 )
	{
		this.mId = NgEngineEntity.newEngineId();
	}

	this.mRegistered = true;
	gNgEngineEntities[this.mId] = this;
	gNgAddedEngineEntities[this.mId] = this;
	this.newEntity();
}

/**
  * Unregister this entity from the native game engine.
  * @type void
  */

NgEngineEntity.prototype.unregister = function()
{
	var parents = this.mParents.concat(new Array());

	for (var i in parents)
	{
		NgLogD ( "Removing child " + this.mId + " from parent Group " + parents[i].mId + " because the Entity was unregistered");
		parents[i].removeChild( this );
	}

	this.mRegistered = false;
	delete gNgEngineEntities[this.mId];
	// CAUTION : DO NOT SPLICE gNgEngineEntities EVER.
	//gNgEngineEntities.splice(this.mId,1);

	gNgRemovedEngineEntities[this.mId] = this;
	this.deleteEntity();

	if(this.mId >= 0)
		NgEngineEntity.deleteEngineId(this.mId);
}

/**
  * Enable/disable key press callbacks for this entity. <br>This method flips the enable state
  * for key press events. <br>
  * In order to receive key press callbacks, an entity
  * must override the onKeyPress event and enable keyable state by calling this 
  * method. <br>
  * The default state is false.
  * @type void
  */

NgEngineEntity.prototype.toggleKeyable = function()
{
	if(this.mIsKeyable)
		gNgKeyPressEngineEntities.splice(NgFindIndex(gNgKeyPressEngineEntities,this),1);
	else
		NgInsertSortedKeyPress(this);

	this.mIsKeyable = !this.mIsKeyable;
}

/**
  * Enable/disable update callbacks for this entity. <br>
  * This method flips the enable state
  * for update events. <br>
  * In order to receive update callbacks, an entity
  * must override the onUpdate event and enable updatable state by calling this 
  * method. <br>
  * The default state is false.
  * @type void
  */

NgEngineEntity.prototype.toggleUpdatable = function()
{
	if(this.mIsUpdatable)
	{
		delete gNgUpdateEngineEntities[this.mId];
	}
	else
	{
		gNgUpdateEngineEntities[this.mId] = this;
	}
	this.mIsUpdatable = !this.mIsUpdatable;
}

/**
  * Enable/disable touch callbacks for this entity. <br>
  * This method flips the enable state for touch events. <br>
  * In order to receive touch callbacks, an entity
  * must override the onTouch event and enable touchable state by calling this 
  * method. <br>
  * The default state is false.
  * @type void
  */

NgEngineEntity.prototype.toggleTouchable = function()
{
	if(this.mIsTouchable)
		gNgTouchEngineEntities.splice(NgFindIndex(gNgTouchEngineEntities,this),1);
	else
		NgInsertSortedTouch(this);

	this.mIsTouchable = !this.mIsTouchable;
}

/**
  * Set native touch traversal policy. <br>
  * This method controls how the native game engine
  * traverses the game scene graph. <br>
  * The policies are described in further detail with {@link NgEngineEntity#NativeTouchType}. <br>
  * The default state is "Enable".
  * @param {NativeTouchType} type The policy enum for native touch processing.
  * @type void
  */

NgEngineEntity.prototype.setNativeTouchType = function( type )
{
	this.mNativeTouchType = type;
	NgPushCommand4(NgEntityTypes.NgDrawableEntity2D, NgEngineEntityCommandIDs.SetNativeTouchType, this.mId, this.mNativeTouchType );
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
var Core = require('NGCore/Client/Core').Core;

// These methods handle all composition for commands being sent back to the
// native engine.

/**
  * @private
  */

var gNgCommandStrings = [];

/**
  * @private
  */

var gNgCommandString = '';

// 0 deferred string composition via user loop
// 1 deferred string composition via internal loop
// 2 on-the-fly string composition.

// TODO: Benchmark all variation on all platforms.  Choose appropriate one(s)
// and prune code for others.

// UPDATE: ALL variations on contructing a string performed IDENTICALLY in
// the iPhone's UIWebView.  Unbelievable.

/**
  * @private
  */

var gNgCommandMode = 2;

/**
  * @private
  */

function NgQueueCommandText(command)
{
	switch(gNgCommandMode)
	{
		case 0:
		case 1:
			gNgCommandStrings.push( command );
			break;
		case 2:
			gNgCommandString += command;
			break;
	}
}

/**
  * @private
  */

function NgFlushCommandsToString()
{
	var outputString = '';
	
	switch(gNgCommandMode)
	{	
		case 0:
			for( var num = 0, end = gNgCommandStrings.length; num < end; ++num )
			{
				outputString += gNgCommandStrings[ num ];
			}
			break;
			
		case 1:
			outputString = String.prototype.concat.apply(gNgCommandStrings);
			break;
	}
	
	switch(gNgCommandMode)
	{
		case 0:
		case 1:
			gNgCommandStrings = [];
			break;
		case 2:
			outputString = gNgCommandString;
			gNgCommandString = '';
			break;
	}
	
	return outputString;	
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

function NgParseString(txt)
{
	return txt;
}

/**
  * @private
  */

function NgParseBase64(txt)
{
	if( txt )
		return Core.Base64.decode(txt);
	else
		return "";
}

/**
  * @private
  */

function NgParseBool(txt)
{
	return parseInt(txt) ? true : false;
}

function NgParseInt(txt)
{
	return parseInt(txt, 10);
}

function NgKVArrayToCmd(kvArray)
{
	var out = "";
	var count = 0
	for (var s in kvArray)
	{
		var value = kvArray[s];
		
		out += "," + s + "," + Core.Base64.encode(value);
		++count;
	}
	return count + out;
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

/**
 * Submit a command with 1 argument to the native engine.
 * @private
 */
function NgPushCommand1(arg1)
{
	gNgCommandString += ":" + arg1;
}

/**
 * Submit a command with 2 arguments to the native engine.
 * @private
 */
function NgPushCommand2(arg1, arg2)
{
	gNgCommandString += ":" + arg1 + "," + arg2;
}

/**
 * Submit a command with 3 arguments to the native engine.
 * @private
 */
function NgPushCommand3(arg1, arg2, arg3)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3;
}

/**
 * Submit a command with 4 arguments to the native engine.
 * @private
 */
function NgPushCommand4(arg1, arg2, arg3, arg4)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4;
}

/**
 * Submit a command with 5 arguments to the native engine.
 * @private
 */
function NgPushCommand5(arg1, arg2, arg3, arg4, arg5)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5;
}

/**
 * Submit a command with 6 arguments to the native engine.
 * @private
 */
function NgPushCommand6(arg1, arg2, arg3, arg4, arg5, arg6)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6;
}

/**
 * Submit a command with 7 arguments to the native engine.
 * @private
 */
function NgPushCommand7(arg1, arg2, arg3, arg4, arg5, arg6, arg7)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6 + "," + arg7;
}

/**
 * Submit a command with 8 arguments to the native engine.
 * @private
 */
function NgPushCommand8(arg1, arg2, arg3, arg4, arg5, arg6, arg7,arg8)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6 + "," + arg7 + "," + arg8;
}

/**
 * Submit a command with 8 arguments to the native engine.
 * @private
 */
function NgPushCommand9(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6 + "," + arg7 + "," + arg8 + "," + arg9;
}

/**
 * Submit a command with n arguments to the native engine.
 * @private
 */
function NgPushCommandN()
{
	var argv = arguments;
	var argc = argv.length;
	
	var tmp = ":";
	
	if( argc > 0 )
	{
		tmp += argv[ 0 ];
		
		for( var num = 1; num < argc; ++num )
		{
			tmp += "," + argv[ num ];
		}
	}
	
	gNgCommandString += tmp;
}

/**
 * Peek at the command ID in a command string.  This helps avoid 
 * splitting the string twice in a number of cases.
 * @return Command id or null if parsing failed.
 * @private
 */

function NgPeekCommandId(str)
{
	var vals = str.split ( ",", 2 );
	if( vals.length == 2 )
		return parseInt ( vals[ 1 ] );
	else
		return null;
}

/**
 * Peek at the class and command ID in a command string.  This helps avoid 
 * splitting the string twice in a number of cases.
 * @return Two-element array of ids or null if parsing failed.
 * @private
 */

function NgPeekClassAndCommandId(str)
{
	var vals = str.split ( ",", 2 );
	if( vals.length == 2 )
	{
		vals[ 0 ] = parseInt ( vals[ 0 ] );
		vals[ 1 ] = parseInt ( vals[ 1 ] );
		return vals;
	}
	else
		return null;
}


/**
 * Parse an incoming command string to individual strings.
 * @return an array of fields in serialization order.
 * @private
 */
function NgParseCommandToStrings(src)
{
	return src.split(",");
}

/**
  * @private
  */

function NgParseCommand1(src, func1)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand2(src, func1, func2)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand3(src, func1, func2, func3)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	ret[ 2 ] = func3( fields[ 3 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand4(src, func1, func2, func3, func4)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	ret[ 2 ] = func3( fields[ 3 ] );
	ret[ 3 ] = func4( fields[ 4 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand5(src, func1, func2, func3, func4, func5)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	ret[ 2 ] = func3( fields[ 3 ] );
	ret[ 3 ] = func4( fields[ 4 ] );
	ret[ 4 ] = func5( fields[ 5 ] );
	
	return ret;
}


/**
 * Parse an incoming command string to typed values based on passed-in functions.
 * ex: NgParseCommandN("1:1,1.0,ACFHENA==",parseInt, parseFloat, NgParseString);
 * NOTE: The first item is assumed to be the command type, and will be
 * discarded in the output.  I.e., the output starts with the second src element.
 * @return an array of parsed fields in serialization order.
 * @private
 */

function NgParseCommandN(src)
{
	var ret = [];
	
	var argv = arguments;
	var argc = argv.length;
	
	var fields = src.split(",");
	for( var num = 1; num < argc; ++num )
	{
		ret[ num - 1 ] = argv[ num ]( fields[ num ] );
	}
	
	return ret;
}

/**
 * Parse an incoming typed dictionary.  The format of the dictionary is:
 * type,field name,value,type,field name,value[...]
 * Parsed values will be asigned to the field name in the dst array/object.
 * NOTE: Strings passed in this format must not have embedded commas (use
 * base64 encoding if arbitrary strings are being used.
 * @arg src The source command string.
 * @arg srcStart The field index to start parsing dictionary entries from.
 * @arg dst The destination object/array for parsed values.
 * @arg initialFields Optionally store the fields before srcStart in the passed-in array.
 * @return true if all fields were successfully parsed.
 * @private
 */

function NgParseCommandDictionary(src,srcStart,dst,initialFields)
{
	var ret = true;
	var fields = src.split(",");
	var end = fields.length;
	
	if(initialFields)
	{
		for( var num = 0; num < srcStart; ++num )
		{
			initialFields[ num ] = fields[ num ];
		}
	}
	
	for( var num = srcStart; num < end; )
	{
		var type = fields[ num++ ];
		var name = fields[ num++ ];
		var val = fields[ num++ ];
		var good = true;
		
		switch(type)
		{
			case 'i':	// int
				val = parseInt( val );
				break;
			case 'f':	// float
				val = parseFloat( val );
				break;
			case 's':	// string
				break;
			case 'S':	// base64 string
				val = Core.Base64.decode(val);
				break;
			case 'b':	// bool
				val = parseInt(val) ? true : false;
				break;
			default:
				//				NgLogD("NgParseCommandDictionary unknown type for " + type + " " + name + " " + val);
				ret = false;
				good = false;
				break;
		}
		
		if( good )
		{
			dst[ name ] = val;
			
			// TEMP PRW
			NgLogD( "dict: " + name + " : " + dst[ name ] );
		}
		else
		{
			NgLogD("dict: could not process " + type );
		}
	}
	
	return ret;
}
/**
  * @private
  */

var gNgTrace=null;

//////////////////////////////////////////////////////////////////////////////////////////////////
// Logging functions.
//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */
var NgDebugModes = {
	BrowserTrace : {},
	NgCommand : {},
	NgCommandDocLoc : {}
};

/**
  * @private
  */
var NgLogLevel = {
	Verbose : 5,
	Debug : 4,
	Info : 3,
	Warning : 2,
	Error : 1
};

/**
  * @private
  */
var NgLogStr = [ '', 'e', 'w', 'i', 'd', 'v'];


/**
  * @private
  */

// TEMP... this is not how we want to do this long-term.
function NgSetDebugDefaultDestination()
{
	if (typeof navigator == 'undefined')
	{
		return NgDebugModes.NgCommand;
	}

	var agent=navigator.userAgent.toLowerCase();
	if( ! ( (agent.indexOf('iphone') >=0) || (agent.indexOf('ipad') >= 0) ) )
	{
		return NgDebugModes.BrowserTrace;
	}
	else
	{
		return NgDebugModes.NgCommand;
	}
}

/**
  * @private
  */

var gNgDebugMode = NgSetDebugDefaultDestination();

/**
  * @private
  */

function NgLogInit()
{
	if( gNgDebugMode == NgDebugModes.BrowserTrace )
	{
		gNgTrace = document.getElementById("trace");
	}

	// Other modes don't need initialization.
}

function NgLogSetLevel(level)
{
	switch( level )
	{
		case NgLogLevel.Debug:
		{
			NgLogV = NgNoLog;
			NgLogD = NgDoDebugLog;
			NgLogI = NgDoInfoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
		}
			break;

		case NgLogLevel.Info:
		{
			NgLogV = NgNoLog;
			NgLogD = NgNoLog;
			NgLogI = NgDoInfoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
		}
			break;

		case NgLogLevel.Warning:
		{
			NgLogV = NgNoLog;
			NgLogD = NgNoLog;
			NgLogI = NgNoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
		}
			break;

		case NgLogLevel.Error:
		{
			NgLogV = NgNoLog;
			NgLogD = NgNoLog;
			NgLogI = NgNoLog;
			NgLogW = NgNoLog;
			NgLogE = NgDoErrorLog;
		}
			break;

		default:
		case NgLogLevel.Verbose:
		{
			NgLogV = NgDoVerboseLog;
			NgLogD = NgDoDebugLog;
			NgLogI = NgDoInfoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
		}
			break;
	}
}

NgDoVerboseLog = function ( msg ) {
	NgLog(NgLogLevel.Verbose, msg);
}

NgDoDebugLog = function ( msg ) {
	NgLog(NgLogLevel.Debug, msg);
}

NgDoInfoLog = function ( msg ) {
	NgLog(NgLogLevel.Info, msg);
}

NgDoWarningLog = function ( msg ) {
	NgLog(NgLogLevel.Warning, msg);
}

NgDoErrorLog = function ( msg ) {
	NgLog(NgLogLevel.Error, msg);
}

NgNoLog = function() {};
NgLogSetLevel(NgLogLevel.Verbose);

var useConsole = ((typeof console != 'undefined') && (typeof console.log == 'function'));

function NgLog( level, msg )
{
	console.log(NgLogStr[level] + ": " + msg);
}

function NgLogException( ex )
{
    var str = "\nEXCEPTION:\n";

    for( var prop in ex )
    {
		str += "property: "+ prop+ " value: ["+ ex[prop]+ "]\n";
    }

    str += "toString(): " + " value: [" + ex.toString() + "]\n\n";

	NgLogD( str );
}
/*
 @author: Remy Sharp / http://remysharp.com
 @date: 2007-04-20
 @name: time
 @methods:
 start - start named timer
 stop - stop named timer
 event - hook predefined event
 func - hook existing function, or hook anonymous function (note refrence is passed back)
 report - output timings
 */
if ((typeof window == 'undefined') || (typeof window.time == 'undefined'))
{
	(function() {
		time = {
			// start + stop taken from firebuglite.js -
			// http://getfirebug.com/firebuglite
			start : function(name) {
				if (!name) {
					error('start: If starting a timer manually a name must be set');
				} else {
					timeMap[name] = (new Date()).getTime();
					if (name in NgRecordMap) {
					} else {
						NgRecordMap[name] = new NgRecord(name);
					}
				}
			},

			stop : function(name) {
				if (name in timeMap) {
					var stop = (new Date()).getTime();
					// var l = new Report(name, timeMap[name], stop);
					var l = NgRecordMap[name].addRecord(stop - timeMap[name]);
					log.push(l);
					if (NgRecordMap[name].records % NgRecordMap[name].ctr == 0) {
						NgRecordMap[name].lineReportMethod.call(this, l);
						NgRecordMap[name].records = 0;
						NgRecordMap[name].avg = 0;
						NgRecordMap[name].min = 55555;
						NgRecordMap[name].max = 0;
					}
					delete timeMap[name];
				} else {
					error('stop:' + name + ' not found');
				}
			},

			event : function(name, elm, type) {
				if (typeof name != 'string') {
					// name has not been passed in
					type = elm;
					elm = name;
					name = '';
				}

				if (!elm.length) {
					elm = [ elm ];
				}

				if (type.indexOf('on') == -1) {
					type = 'on' + type;
				}

				var i = elm.length;
				var timerN = null;
				var c = null;
				while (i--) {
					timerN = name;
					if (!timerN) {
						timerN = elm[i].id || elm[i].getAttribute('class')
								|| elm[i].getAttribute('className')
								|| elm[i].tagName;
					}

					mapEvent(elm[i], type, timerN);
				}
			},

			func : function(name, fn) {
				if (typeof name == 'function') {
					fn = name;
				}

				// get function name as this browser may not support fn.name (IE
				// + Safari + Opera)
				if (!fn.name && typeof fn == 'function') {
					var m = fn.toString().match(/function\s*(.*)\s*\(/);
					if (m[1]) {
						fn.name = m[1];
					}
				}

				if (typeof fn == 'function' && !fn.name) {
					// function is anonymous -
					// time function using var func = time.fn(function() { ...do
					// stuff });
					if (typeof name != 'string') {
						anonFuncId++;
						name = 'anonymous' + anonFuncId;
					}

					return function() {
						time.start(name);
						var ret = fn.apply(window, arguments);
						time.stop(name);
						return ret;
					};
				} else {
					var fnName = fn.name || fn;
					if (typeof name != 'string') {
						name = fnName;
					}

					eval('var fnCopy = ' + fnName);
					if (typeof fnCopy == 'function') {
						var wrap = function() {
							time.start(name);
							var ret = fnCopy.apply(this, arguments);
							time.stop(name);
							return ret;
						};
						wrap.hooked = true;
						eval(fnName + ' = wrap;');
						return eval(fnName);
					} else {
						// error hooking
						error('func: Could not hook function (name: ' + name + ')');
					}
				}
			},

			report : function(name) {
				if (typeof name == 'undefined') {
					reportMethod.call(this, log);
				} else {
					var i = log.length;
					var l = [];
					while (i--) {
						if (name == log[i].name) {
							l.push(log[i]);
						}
					}
					reportMethod.call(this, l);
				}
			},

			setReportMethod : function(fn) {
				if (fn.hooked) {
					error('setReportMethod: Cannot use hooked method ' + fn.name);
				} else {
					reportMethod = fn;
				}
			},

			setCtr : function(name, ctr, fn) {
				if (name in NgRecordMap) {
				} else
					NgRecordMap[name] = new NgRecord(name, ctr, fn);
			},

			setLineReportMethod : function(fn) {
				if (fn.hooked) {
					error('setLineReportMethod: Cannot use hooked method ' + fn.name);
				} else {
					lineReportMethod = fn;
					lineReport = true;
				}
			},

			errors : false
		};

		var timeMap = {};
		var NgRecordMap = {};
		var log = [];
		var reportMethod = defaultReport;
		var lineReport = false;
		var lineReportMethod = defaultLineReport;
		var anonFuncId = 0;

		var Report = function(n, s, e) {
			this.name = n;
			this.start = s;
			this.stop = e;
			this.delta = e - s;
			// useful if I could grab the call - but can't see how due to anon
			// functions (though I can see them in the start method)
		};

		Report.prototype.toString = function() {
			return this.name + ": " + this.delta + "ms";
		};

		function defaultReport(l) {
			alert(l.join("\n"));
		}

		function defaultLineReport(l) {
			alert(l);
		}

		function error(e) {
			if (time.errors)
				alert(e);
		}

		var NgRecord = function(name, ctr, fn) {
			this.name = name;
			this.records = 0;
			this.avg = 0;
			this.min = 555555;
			this.max = 0;
			this.ctr = ctr;
			if (fn.hooked) {
				error('setLineReportMethod: Cannot use hooked method. Will use default method' + fn.name);
				this.lineReportMethod = defaultLineReport;
			} else {
				this.lineReportMethod = fn;
			}

		}

		NgRecord.prototype.addRecord = function(delta) {
			this.avg = (this.avg * this.records + delta) / (this.records + 1);
			if (this.min > delta)
				this.min = delta;
			if (this.max < delta)
				this.max = delta;
			this.records++;
			frq = 1000 / this.avg;
			return this.name + '->  max:' + this.max + '  min:' + this.min
					+ '  avg:' + this.avg.toFixed(2) + '  freq:'
					+ frq.toFixed(2) + '\n';
		}

		// required to create a brand new instance of our copied function
		function mapEvent(e, t, n) {
			var c = e[t];
			if (typeof c == 'function') {
				e[t] = function() {
					time.start(n + ':' + t);
					var ret = c.apply(this, arguments);
					time.stop(n + ':' + t);
					return ret;
				};
			} else {
				error('event: Function must be set on element.' + t
						+ ' before hooking (name: ' + n + ')');
			}
		}
	})();
}

/*
 *  SoundIDs.h
 *  ZombieFarm
 *
 *  Created by Vicente McDonnell on 1/17/10.
 *  Copyright 2010 The Playforge LLC. All rights reserved.
 *
 */

var kFarmBGM				= "./Content/dayFarmBGM.m4a";
var kFightBGM				= "./Content/fightBGM.m4a";
var kLoseBGM				= "./Content/loseBGM.m4a";
var kWinBGM					= "./Content/winBGM.m4a";
var kEnrageBGM				= "./Content/enrageBGM.m4a";
var kFarmsStageBGM			= "./Content/farmStageBGM.m4a";
var kNinjaStageBGM			= "./Content/ninjaStageBGM.m4a";
var kPirateStageBGM			= "./Content/pirateStageBGM.m4a";
var kRobotStageBGM			= "./Content/robotStageBGM.m4a";
var kAlienStageBGM			= "./Content/alienStageBGM.m4a";

var kMooSFX					= "./Content/moo.wav";
var kSheepSFX				= "./Content/sheep.wav";
var kBirdsSFX				= "./Content/birds.wav";
var kRoosterSFX				= "./Content/rooster.wav";
var kOinkSFX				= "./Content/oink.wav";
var kCrowSFX				= "./Content/crow.wav";
var kRainSFX				= "./Content/rain.wav";
var kStormSFX               = "./Content/storm.wav";

var kZombieRegularBrain		= "./Content/brainRegular.wav";
var kZombieRobotBrain		= "./Content/brainRobot.wav";
var kZombieGirlBrain		= "./Content/brainGirl.wav";
var kZombieSmallBrain		= "./Content/brainSmall.wav";
var kZombieLargeBrain		= "./Content/brainLarge.wav";
var kZombieGardenBrain		= "./Content/brainGarden.wav";

var kSplatSFX				= "./Content/splat.wav";
var kHarvestZombieSFX		= "./Content/harvest.wav";
var kHarvestPlantSFX		= "./Content/harvestPlant.wav";

var kWinnerSFX				= "./Content/winner.wav";
var kDeleteSFX				= "./Content/delete.wav";
var kBuySFX					= "./Content/buy.wav";
var kEarnSFX				= "./Content/earn.wav";
var kPlowingSFX				= "./Content/plowing.wav";

var kBiteSFX				= "./Content/bite.wav";
var kFlailSFX				= "./Content/flail.wav";
var kPokeSFX				= "./Content/poke.wav";
var kPunchSFX				= "./Content/punch.wav";
var kPoofSFX				= "./Content/poof.wav";
var kRezSFX					= "./Content/resurrect.wav";
var kBlockSFX				= "./Content/block.wav";
var kThrowSFX				= "./Content/swipe.wav";

var kMenuOpenSFX			= "./Content/menuOpen.wav";
var kMenuCloseSFX			= "./Content/menuClose.wav";
var kMenuClick              = "./Content/menuClick.wav";

var kCameraSFX				= "./Content/cameraClick.wav";
var kAlienLaserSFX			= "./Content/alienLaser.wav";

var kParrotSFX				= "./Content/parrot.wav";
var kTaikoSFX				= "./Content/taiko.wav";


var kAchievementFarmTutorialDone = 0;
var kAchievementFightTutorialDone = 1;
var kAchievementAllBanners = 2;
var kAchievementFarmBanner = 3;
var kAchievementCityBanner = 4;
var kAchievementPirateBanner = 5;
var kAchievementNinjaBanner = 6;
var kAchievementRobotBanner = 7;
var kAchievementAllMonoliths = 8;
var kAchievementAllGraves = 9;
var kAchievementAllMutations = 10;
var kAchievementAllStorage = 11;
var kAchievementAllGrounds = 12;
var kAchievement1000Carrots = 13;
var kAchievement100Fertilize = 14;
var kAchievementUnlockMausoleum = 15;
var kAchievementAllVeterans = 16;
var kAchievementAllMasters = 17;
var kAchievement10Wins = 18;
var kAchievement25Wins = 19;
var kAchievement50Wins = 20;
var kAchievementWinEnraged = 21;
var kAchievementAllAbilities = 22;
var kAchievement1MinuteWin = 23;
var kAchievement1ZombieLeft = 24;
var kAchievementNoDeaths = 25;
var kAchievement2orLessDeaths = 26;
var kAchievementDoubleRainbow = 27;
var kAchievement10Losses = 28;
var kAchievementAllZombieTypes = 29;
var kAchievement10FightZombie = 30;

var kActorTypePlayer = 0;
var kActorTypeZombie = 1;
var kActorTypeCivilian = 2;
var kActorTypeStageElement = 3;
var kActorTypeMAX  = 4;
 
var kActorStateInvalid =  0;
var kActorStateIdle =  1;
var kActorStateWalking = 2;
var kActorStateWorking = 3;
var kActorStateDormant = 4;
var kActorStateMAX = 5;
 
var kActorBrainStateNone = 0;
var kActorBrainStateLookingForHome = 1;
var kActorBrainStateAtHome = 2;
var kActorBrainStatePerformingTileAction = 3;
var kActorBrainStateMAX = 4;

var zombieSubTypeNone = 0;
var zombieSubTypeRegular = 1;
var zombieSubTypeMini = 2;
var zombieSubTypeLummox = 3;
var zombieSubTypeHeadless = 4;
var zombieSubTypeGirl = 5;
var zombieSubTypeGarden = 6;
var zombieSubTypeMAX = 7;
 
var kActorFightStateWait    = 6;
var kActorFightStatePrepStart  = 7;
var kActorFightStatePrepCycle  = 8;
var kActorFightStateGo   = 9;
var kActorFightStateGoing   = 10;
var kActorFightStateEnterFight  = 11;
var kActorFightStateFight   = 12;
var kActorFightStateFighting  = 13;
var kActorFightStateReallyDead  = 14;
var kActorFightStateStunned   = 15;
var kActorFightStateUsingAbility  = 16;
var kActorFightStateEnterScene  = 17;
var kActorFightStateWall   = 18;
var kActorFightStateBossWait  = 19;
var kActorFightStateBossThrow  = 20;
var kActorFightStateBossSummonWall  = 21;
var kActorFightStateBossTelekinesis  = 22;
var kActorFightStateBossSummonBoss  = 23;
var kActorFightStateBossGoDown  = 24;
var kActorFightStateBossGoingDown  = 25;
var kActorFightStateBossJumpingDown  = 26;
var kActorFightStateShootBullet  = 27;
var kActorFightStateFightWall  = 28;
var kActorFightStateBeingSummoned  = 29;
var kActorFightStateGoFightBossWall  = 30;
var kActorFightStateFightBossWall  = 31;
var kActorFightStateFightingBossWall = 32;
var kActorFightStateExitMelee  = 33;
var kActorFightStateMoveForwardAfterAttack = 34;
var kActorFightStateUsingAbilityAtRange = 35;
var kActorFightStateRunAway   = 36;
var kActorFightStateRunningAway  = 37;
var kActorFightStateRanAway   = 38;
var kActorFightStateGrab   = 39;
var kActorFightStateGrabbed   = 40;
var kActorFightStateFall   = 41;
var kActorFightStateFalling   = 42;
var kActorFightStateFell   = 43;
var kActorFightStateDying    = 100; // making sure that custom classes with their own states
var kActorFightStateDead     = 101; // do not accidentally get set to "dead"
var kActorFightStateAny    = 102; // used purely for activating buffs ... kActorFightStateAny == activate in any state
var kActorFightStateMAX    = 103; // not used as there are no more enum sets for states after this 
 
var kMutationTomatoHead = (1<<0); //atk1 1
var kMutationOnionHead = (1<<1); //def1 2
var kMutationCarrotHat = (1<<2); //spd1 4
var kMutationTurnipArms = (1<<3); //atk2 8
var kMutationPotatoHead = (1<<4); //def2 16
var kMutationCoffeeHead = (1<<5); //spd2 32
var kMutationCeleryArms = (1<<6); //atk3 64
var kMutationBroccoliHat = (1<<7); //def3 128
var kMutationGarlicHead = (1<<8); //atk3 256
var kMutationCauliflowerHat = (1<<9); //def3 512
var kMutationLimaBeanBody = (1<<10);//def3 1024
var kMutationFlyTrapCollar = (1<<11); //def4 2048
var kMutationDragonArms = (1<<12); //atk4 4096
var kMutationPumpkinHead = (1<<13); //atk3 8192
 
var kMutationHead = (kMutationPumpkinHead | kMutationTomatoHead	| kMutationOnionHead	| kMutationPotatoHead | kMutationCoffeeHead | kMutationGarlicHead);
var kMutationArms = (kMutationTurnipArms	| kMutationCeleryArms	| kMutationDragonArms);
var kMutationHat = (kMutationCarrotHat	| kMutationBroccoliHat	| kMutationCauliflowerHat);
var kMutationBody = (kMutationLimaBeanBody);
var kMutationCollar = (kMutationFlyTrapCollar);
 
var /*-1*/ kActorPartTagAll  = -1;
var /*0*/  kActorPartTagHead  = 0; 
var /*1*/  kActorPartTagBody = 1;
var /*2*/  kActorPartTagArmF = 2;
var /*3*/  kActorPartTagArmB = 3;
var /*4*/  kActorPartTagFootF = 4;
var /*5*/  kActorPartTagArmFm = 5;
var /*6*/  kActorPartTagArmBm = 6;
var /*7*/  kActorPartTagFootB = 7;
var /*8*/  kActorPartTagFistF = 8;
var /*9*/  kActorPartTagFistB = 9;
 
var /*10*/ kActorPartTagButt = 10;
var /*11*/ kActorPartTagCollar = 11;
 
 
var /*12*/ kActorPartTagHeadParts = 12;
var /*13*/ kActorPartTagEyeL  = 13;
var /*14*/ kActorPartTagEyeR  = 14;
var /*15*/ kActorPartTagJaw  = 15;
var /*16*/ kActorPartTagHat  = 16;
var /*17*/ kActorPartTagFeatures = 17;
var /*18*/ kActorPartTagFeatures2 = 18;
var /*19*/ kActorPartTagFeatures3 = 19;
var /*20*/ kActorPartTagHeadPartsMAX = 20;
 
var kActorPartTagMax = 21;


var kActorAnimIdle  = 0;
var kActorAnimKnockBack  = 1;
var kActorAnimWalk  = 2;
var kActorAnimAttack = 3;
var kActorAnimAttackBite = 4;
var kActorAnimAttackFlail = 5;
var kActorAnimVictory = 6;
var kActorAnimDying  = 7;
var kActorAnimSleeping = 8;
var kActorAnimThrow  = 9;
var kActorAnimChase  = 10;
var kActorAnimChaseNoWalk = 11;
var kActorAnimThinking = 12;
var kActorAnimIdea  = 13;
var kActorAnimWalkSimple = 14;
var kActorAnimSummon = 15;
var kActorAnimHeal  = 16;
var kActorAnimIdleFarm = 17;
var kActorAnimMAX  = 18;

 
var kActorStunParticle = 1000;  // added to self (it's in the particles array)
var kActorLaserParticle = 1001; // not really added to self (added to fightmanager parent)
 
var kActorFightStateNothing = -1;
 
var kTriggerEventNothing = 0;
var kTriggerEventZombieDeath = 1;  
var kTriggerEventAttachMiniButtonPressed = 2; 
var kTriggerEventBashButtonPressed = 3; 
var kTriggerEventBashV2ButtonPressed = 4;
var kTriggerEventAuto = 5;   
var kTriggerEventExplodeButtonPressed = 6;
var kTriggerEventExplodeV2ButtonPressed = 7;
var kTriggerEventMax = 8;
 
 // these are test buffs //
var kFightEffectBuff = -7; 
var kFightEffectGroupBuffFiveToAllStats = -6; 
var kFightEffectSelfBuffFiveToAllStatsRegular = -5; 
var kFightEffectEnemyBuffEnrage =  -4;  // ... etc
var kFightEffectBigZombie = -3;   
var kFightEffectBigBoss = -2;
var kFightEffectEnemyDebuffIce = -1;
 
 // these are the real buffs //
 
 // start of zombie fight effects
var kFightEffectZombieEffectsStart = 0;
var kFightEffectSelfBuffToAllStats = 1;
var kFightEffectSelfBuffSpeed = 2;
var kFightEffectSelfBuffPower = 3;
var kFightEffectSelfBuffHitPoints = 4;
var kFightEffectChivalry = 5;
var kFightEffectGrace = 6;
var kFightEffectProtect = 7;
var kFightEffectTankHitPointsBuff = 8;
var kFightEffectZombieEffectsEnd = 9;
 // end of zombie fight effects
 
var kFightEffectDebuff = 10;   
var kFightEffectMax = 11;

 // start of zombie abilities
var kActorActivatedAbilityTagZombieAbilityStart =  11;
var kActorActivatedAbilityTagRessurect = 12; 
var kActorActivatedAbilityTagAttachMini = 13;   
var kActorActivatedAbilityTagBash = 14; 
var kActorActivatedAbilityTagBashV2 = 15;
var kActorActivatedAbilityTagLaser = 16;
var kActorActivatedAbilityTagLaserV2 = 17;
var kActorActivatedAbilityTagExplode = 18;
var kActorActivatedAbilityTagExplodeV2 = 19;
var kActorActivatedAbilityTagTurboSpeed = 20;
var kActorActivatedAbilityTagBlock = 21;
var kActorActivatedAbilityTagStun = 22;
var kActorActivatedAbilityTagDoubleStrike = 23;
var kActorActivatedAbilityTagHeal = 24;
var kActorActivatedAbilityTagHealAOE = 25;
var kActorActivatedAbilityTagZombieAbilityEnd = 26;
 // end of zombie abilities
 
var kAbilityBitsSelfBuffToAllStats = 0;
var kAbilityBitsSelfBuffSpeed = 1; 
var kAbilityBitsSelfBuffPower = 2;
var kAbilityBitsSelfBuffHitPoints = 3;
var kAbilityBitsHeal = 4;
var kAbilityBitsChivalry = 5;
var kAbilityBitsGrace = 6;
var kAbilityBitsAttachMini = 7;
var kAbilityBitsProtect = 8;
var kAbilityBitsTankHitPointsBuff = 9;
var kAbilityBitsLaser = 10;
var kAbilityBitsStun = 11;
var kAbilityBitsBash = 12;
var kAbilityBitsTurboSpeed = 13;
var kAbilityBitsRessurect = 14;
var kAbilityBitsExplode = 15;
var kAbilityBitsLaserV2 = 16;
var kAbilityBitsDoubleStrike = 17;
var kAbilityBitsBashV2 = 18;
var kAbilityBitsBlock = 19;
var kAbilityBitsHealAOE = 20;
var kAbilityBitsExplodeV2 = 21;
var kAbilityBitsMAX = 22;

//Mobage
	var Core = require('NGCore/Client/Core').Core;
	var GL2 = require('NGCore/Client/GL2').GL2;
	var UI = require('NGCore/Client/UI').UI;
	var Bank = require('NGCore/Client/Bank').Bank;
	var Physics2 = require('NGCore/Client/Physics2').Physics2;
	var Storage = require('NGCore/Client/Storage').Storage;	
	var DownloadFile = require('NGCore/Client/Network/DownloadFile').DownloadFile;
	var FileSystem = require('NGcore/Client/Storage/FileSystem').FileSystem;
	var Device = require('NGCore/Client/Device').Device;
	var Social = require('NGCore/Client/Social').Social;	
	
	var NSUserDefaults = require('Code/NSObjects/NSUserDefaults').NSUserDefaults;

//External
    var SimpleAudioEngine = require('Code/External/SimpleAudioEngine').SimpleAudioEngine;
    var SpriteFactoryCache = require('Code/External/SpriteFactoryCache').SpriteFactoryCache;
    var FPS = require('Code/External/FPS').FPS;
    var TouchTargetVisualizer = require('Code/External/TouchTargetVisualizer').TouchTargetVisualizer;
    var RefCounter = require('Code/External/RefCounter').RefCounter;
    var MobagePaymentController = require('Code/External/MobagePaymentController').MobagePaymentController;
    var BackButtonHandler = require('Code/External/BackButtonHandler').BackButtonHandler;
    var TouchBlocker = require('Code/External/TouchBlocker').TouchBlocker;
    var RateGame = require('Code/External/RateGame').RateGame;
	
//Cocos
	var CCScheduler = require('Code/Cocos2D/CCScheduler').CCScheduler;
	var CCColor = require('Code/Cocos2D/CCColor').CCColor;
	var CCNode = require('Code/Cocos2D/CCNode').CCNode;
	var CCLayer = require('Code/Cocos2D/CCLayer').CCLayer;
	var CCColorLayer = require('Code/Cocos2D/CCColorLayer').CCColorLayer;
	var CCMenuItem = require('Code/Cocos2D/CCMenuItem').CCMenuItem;
	var CCMenuItemLayer = require('Code/Cocos2D/CCMenuItemLayer').CCMenuItemLayer;
	var CCMenuItemSprite = require('Code/Cocos2D/CCMenuItemSprite').CCMenuItemSprite;
	var CCMenuItemImage = require('Code/Cocos2D/CCMenuItemImage').CCMenuItemImage;
	var CCLabel = require('Code/Cocos2D/CCLabel').CCLabel;
	var CCMenu = require('Code/Cocos2D/CCMenu').CCMenu;
	var CCSprite = require('Code/Cocos2D/CCSprite').CCSprite;
	var CCDirector = require('Code/Cocos2D/CCDirector').CCDirector;
	var CCSpriteSheet = require('Code/Cocos2D/CCSpriteSheet').CCSpriteSheet;
	var CCMenuItemToggle = require('Code/Cocos2D/CCMenuItemToggle').CCMenuItemToggle;
	var CCSpawn = require('Code/Cocos2D/CCSpawn').CCSpawn;
	var CCSpriteFrameCache = require('Code/Cocos2D/CCSpriteFrameCache').CCSpriteFrameCache;
	var CCScene = require('Code/Cocos2D/CCScene').CCScene;

//CCTableViewSuite
	var CCScrollView = require('Code/CCTableViewSuite/CCScrollView').CCScrollView;
	var CCTableView = require('Code/CCTableViewSuite/CCTableView').CCTableView;
	var CCMultiColumnTableView = require('Code/CCTableViewSuite/CCMultiColumnTableView').CCMultiColumnTableView;
	var CCTableViewCell = require('Code/CCTableViewSuite/CCTableViewCell').CCTableViewCell;
	
//Hand Game
	var ZombieMiniGame = require('Code/MainMenu/ZombieMiniGame').ZombieMiniGame;
	var Timer = require('Code/MainMenu/Classes/Timer').Timer;
	var HandButton = require('Code/MainMenu/HandButton').HandButton;
	
//Actions
	var CCAction = require('Code/Cocos2D/CCAction').CCAction;
	var CCActionManager = require('Code/Cocos2D/CCActionManager').CCActionManager;
	var CCMoveTo = require('Code/Cocos2D/CCMoveTo').CCMoveTo;
	var CCMoveBy = require('Code/Cocos2D/CCMoveBy').CCMoveBy;
	var CCRepeatForever = require('Code/Cocos2D/CCRepeatForever').CCRepeatForever;
	var CCSequence = require('Code/Cocos2D/CCSequence').CCSequence;
	var CCScaleTo = require('Code/Cocos2D/CCScaleTo').CCScaleTo;
	var CCMoveTo = require('Code/Cocos2D/CCMoveTo').CCMoveTo;
	var CCMoveByWithoutChangingPosition = require('Code/Cocos2D/CCMoveByWithoutChangingPosition').CCMoveByWithoutChangingPosition;
	var CCFadeIn = require('Code/Cocos2D/CCFadeIn').CCFadeIn;
	var CCFadeOut= require('Code/Cocos2D/CCFadeOut').CCFadeOut;
	var CCFadeTo = require('Code/Cocos2D/CCFadeTo').CCFadeTo;
	var CCDelayTime = require('Code/Cocos2D/CCDelayTime').CCDelayTime;
	
	var CCJumpTo = require('Code/Cocos2D/CCJumpTo').CCJumpTo;
	var CCRotateTo = require('Code/Cocos2D/CCRotateTo').CCRotateTo;
	var CCMoveBy = require('Code/Cocos2D/CCMoveBy').CCMoveBy;
	var CCRepeat = require('Code/Cocos2D/CCRepeat').CCRepeat;
	var CCRotateBy = require('Code/Cocos2D/CCRotateBy').CCRotateBy;
	var CCScaleBy = require('Code/Cocos2D/CCScaleBy').CCScaleBy;
	var CCTintBy = require('Code/Cocos2D/CCTintBy').CCTintBy;
	var CCTintTo = require('Code/Cocos2D/CCTintTo').CCTintTo;
	var CCJumpBy = require('Code/Cocos2D/CCJumpBy').CCJumpBy;
	var CCBlink = require('Code/Cocos2D/CCBlink').CCBlink;
	var CCBezierBy = require('Code/Cocos2D/CCBezierBy').CCBezierBy;
	var CCBezierTo = require('Code/Cocos2D/CCBezierTo').CCBezierTo;
	var CCCallFunc = require('Code/Cocos2D/CCInstantAction').CCCallFunc;
	var CCCallFuncN = require('Code/Cocos2D/CCInstantAction').CCCallFuncN;
	var CCCallFuncND = require('Code/Cocos2D/CCInstantAction').CCCallFuncND;
	var CCFadeTransition = require('Code/Cocos2D/CCTransition').CCFadeTransition;
	
	var TSprite = require('Code/Game/TouchSprite/TSprite').TSprite;
	
// Loading screen
	var LoadScreen = require('Code/LoadingScreen/LoadScreen').LoadScreen;
	var ZombieFarmAppDelegate = require('Code/Application/ZombieFarmAppDelegate').ZombieFarmAppDelegate;
	var DataPreloader = require('Code/Game/DataPreloader').DataPreloader;
	
// Actor
	var Actor = require('Code/Game/Actor/Actor').Actor;
	var ZFAnims = require('Code/Game/Actor/ZFAnims').ZFAnims;
	var ZFAttackAnims = require('Code/Game/Actor/ZFAttackAnims').ZFAttackAnims;
	var ActorAttachment = require('Code/Game/Actor/ActorAttachment').ActorAttachment;
	var ActorFarmData = require('Code/Game/Actor/ActorFarmData').ActorFarmData;
	var ActorHitBox = require('Code/Game/Actor/ActorHitBox').ActorHitBox;
	
	
//Menu
	var OptionsMenu = require('Code/MainMenu/OptionsMenu').OptionsMenu;
	var MainMenu = require('Code/MainMenu/MainMenu').MainMenu;
	var ZFZombieSelectionMenu = require('Code/Game/GUI/ZFMenus/Zombie/ZFZombieSelectionMenu').ZFZombieSelectionMenu;
		
//Game
	var ZFFarmGameScene = require('Code/Game/FarmGameScene/ZFFarmGameScene').ZFFarmGameScene;
	var GameData = require('Code/Game/GameState/GameData').GameData;
	var ZFAchievementChecker = require('Code/Application/ZFAchievementChecker').ZFAchievementChecker;
	

	//GUI
	var DimLayer = require('Code/Game/GUI/ZFMenus/ZFMenu').DimLayer;
	var ZFMenu = require('Code/Game/GUI/ZFMenus/ZFMenu').ZFMenu;
	var ZFFarmerSelectionMenu = require('Code/Game/GUI/ZFMenus/FarmerSelection/ZFFarmerSelectionMenu').ZFFarmerSelectionMenu;
	
	//AlertWindows
	var ZFAlertWindow = require('Code/Game/GUI/AlertWindows/ZFAlertWindow').ZFAlertWindow;
	var ZFAlertWindowQuest = require('Code/Game/GUI/AlertWindows/ZFAlertWindowQuest').ZFAlertWindowQuest;
	var ZFAlertWindowQuestComplete = require('Code/Game/GUI/AlertWindows/ZFAlertWindowQuestComplete').ZFAlertWindowQuestComplete;
	
	
	///Menus
	var MKStoreObserver = require('Code/Game/GUI/ZFMenus/Market/MKStoreObserver').MKStoreObserver;
	var ZFMarketMenu = require('Code/Game/GUI/ZFMenus/Market/ZFMarketMenu').ZFMarketMenu;
	var ZFMutationMenu = require('Code/Game/GUI/ZFMenus/MutationCollection/ZFMutationMenu').ZFMutationMenu;
	var ZFZombieMenu = require('Code/Game/GUI/ZFMenus/Zombie/ZFZombieMenu').ZFZombieMenu;
	var ZFStorageMenu = require('Code/Game/GUI/ZFMenus/Storage/ZFStorageMenu').ZFStorageMenu;
	var ZFQuestMenu = require('Code/Game/GUI/ZFMenus/Quest/ZFQuestMenu').ZFQuestMenu;
	var ZFZombieSelectionMenu = require('Code/Game/GUI/ZFMenus/Zombie/ZFZombieSelectionMenu').ZFZombieSelectionMenu;
	var ZFInGameMenu = require('Code/Game/GUI/ZFMenus/InGame/ZFInGameMenu').ZFInGameMenu;
	var ZFHelpMenu = require('Code/Game/GUI/ZFMenus/Help/ZFHelpMenu').ZFHelpMenu;
	
	
	var ZFMausoleumMenu = require('Code/Game/GUI/ZFMenus/Mausoleum/ZFMausoleumMenu').ZFMausoleumMenu;
	var MausoleumCell = require('Code/Game/GUI/ZFMenus/Mausoleum/MausoleumCell').MausoleumCell;
	var ZFMenuWithHigherPriority = require('Code/Game/GUI/ZFMenus/Mausoleum/ZFMenuWithHigherPriority').ZFMenuWithHigherPriority;
	
	var ZFQuestRequirement = require('Code/Game/GUI/GuiLayer/Quests/ZFQuestRequirement').ZFQuestRequirement;
	var ZFQuestNotification = require('Code/Game/GUI/GuiLayer/Quests/ZFQuestNotification').ZFQuestNotification;
	
//singletons defined for whole application
	var ZFColorDefines = require('Code/Game/ZFColorDefines').ZFColorDefines;
	var ZFGameDefines = require('Code/Game/ZFGameDefines').ZFGameDefines;
	var ZFGameFlags = require('Code/Game/ZFGameFlags').ZFGameFlags;

	var NSNotificationCenter = require('Code/NSObjects/NSNotificationCenter').NSNotificationCenter;
	var PlayerProfileManager = require('Code/Game/Player/PlayerProfileManager').PlayerProfileManager;
	var ZFActorManager = require('Code/Game/Actor/ZFActorManager').ZFActorManager;
	var ZFGuiLayer = require('Code/Game/GUI/ZFGuiLayer').ZFGuiLayer;	
	var ZFTileManager = require('Code/Game/Tiles/ZFTileManager').ZFTileManager;
	var GameState = require('Code/Game/GameState/GameState').GameState;
	var ZFToolManager = require('Code/Game/Tools/ZFToolManager').ZFToolManager;
	var ZFQuestMan = require('Code/Game/GUI/GuiLayer/Quests/ZFQuestMan').ZFQuestMan;
	
	
	var ZFGameTool = require('Code/Game/Tools/ZFGameTool').ZFGameTool;
	var ZFConsumable = require('Code/Game/GameObjects/ZFConsumable').ZFConsumable;
	var ZFZombieCombiner = require('Code/Game/GameObjects/ZFZombieCombiner').ZFZombieCombiner;
	var ZFZombieCombinerResultData = require('Code/Game/GameObjects/ZFZombieCombinerResultData').ZFZombieCombinerResultData;
	var ZFZombiePatch = require('Code/Game/GameObjects/ZFZombiePatch').ZFZombiePatch;
	
	var PlayerActor = require('Code/Game/Actor/Types/Player/PlayerActor').PlayerActor;

	//Zombies
	var ZombieActor = require('Code/Game/Actor/Types/Zombies/ZombieActor').ZombieActor;
	var ZombieActorGardenCupid = require('Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGardenCupid').ZombieActorGardenCupid;
	var ZombieActorGarden = require('Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGarden').ZombieActorGarden;
	var ZombieActorGardenTier1 = require('Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGardenTier1').ZombieActorGardenTier1;
	var ZombieActorGardenTier2 = require('Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGardenTier2').ZombieActorGardenTier2;
	var ZombieActorGardenTier3 = require('Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGardenTier3').ZombieActorGardenTier3;
	var ZombieActorGardenTier4 = require('Code/Game/Actor/Types/Zombies/ZombieActorGarden/ZombieActorGardenTier4').ZombieActorGardenTier4;

	var ZombieActorGirl = require('Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirl').ZombieActorGirl;
	var ZombieActorGirlTier1 = require('Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirlTier1').ZombieActorGirlTier1;
	var ZombieActorGirlTier2 = require('Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirlTier2').ZombieActorGirlTier2;
	var ZombieActorGirlTier3 = require('Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirlTier3').ZombieActorGirlTier3;
	var ZombieActorGirlTier4 = require('Code/Game/Actor/Types/Zombies/ZombieActorGirl/ZombieActorGirlTier4').ZombieActorGirlTier4;

	var ZombieActorHeadless = require('Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadless').ZombieActorHeadless;
	var ZombieActorHeadlessTier1 = require('Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadlessTier1').ZombieActorHeadlessTier1;
	var ZombieActorHeadlessTier2 = require('Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadlessTier2').ZombieActorHeadlessTier2;
	var ZombieActorHeadlessTier3 = require('Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadlessTier3').ZombieActorHeadlessTier3;
	var ZombieActorHeadlessTier4 = require('Code/Game/Actor/Types/Zombies/ZombieActorHeadless/ZombieActorHeadlessTier4').ZombieActorHeadlessTier4;

	var ZombieActorLarge = require('Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLarge').ZombieActorLarge;
	var ZombieActorLargeTier1 = require('Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLargeTier1').ZombieActorLargeTier1;
	var ZombieActorLargeTier2 = require('Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLargeTier2').ZombieActorLargeTier2;
	var ZombieActorLargeTier3 = require('Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLargeTier3').ZombieActorLargeTier3;
	var ZombieActorLargeTier4 = require('Code/Game/Actor/Types/Zombies/ZombieActorLarge/ZombieActorLargeTier4').ZombieActorLargeTier4;

	var ZombieActorSmall = require('Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmall').ZombieActorSmall;
	var ZombieActorSmallTier1 = require('Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmallTier1').ZombieActorSmallTier1;
	var ZombieActorSmallTier2 = require('Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmallTier2').ZombieActorSmallTier2;
	var ZombieActorSmallTier3 = require('Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmallTier3').ZombieActorSmallTier3;
	var ZombieActorSmallTier4 = require('Code/Game/Actor/Types/Zombies/ZombieActorSmall/ZombieActorSmallTier4').ZombieActorSmallTier4;

	var ZombieActorRegular = require('Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegular').ZombieActorRegular;
	var ZombieActorRegularCrazy = require('Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegularCrazy').ZombieActorRegularCrazy;
	var ZombieActorRegularTier1 = require('Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegularTier1').ZombieActorRegularTier1;
	var ZombieActorRegularTier2 = require('Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegularTier2').ZombieActorRegularTier2;
	var ZombieActorRegularTier3 = require('Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegularTier3').ZombieActorRegularTier3;
	var ZombieActorRegularTier4 = require('Code/Game/Actor/Types/Zombies/ZombieActorRegular/ZombieActorRegularTier4').ZombieActorRegularTier4;
	
// Fight
	var ActorFightData = require('Code/Game/Actor/ActorFightData').ActorFightData;
	var ZFToolTipLayer = require('Code/Game/FightGameScene/GUI/ZFToolTipLayer').ZFToolTipLayer;
	var ZFFightBubble = require('Code/Game/FightGameScene/GUI/ZFFightBubble').ZFFightBubble;
	var ZFFightGUI = require('Code/Game/FightGameScene/GUI/ZFFightGUI').ZFFightGUI;
	var ZFActorAbility = require('Code/Game/FightGameScene/ZFActorAbility').ZFActorAbility;
	var ZFActorActivatedAbility = require('Code/Game/FightGameScene/ZFActorActivatedAbility').ZFActorActivatedAbility;
    var ZFActorFightEffect = require('Code/Game/FightGameScene/ZFActorFightEffect').ZFActorFightEffect;
    var ZFFightGameScene = require('Code/Game/FightGameScene/ZFFightGameScene').ZFFightGameScene;
    var ZFFightMan = require('Code/Game/FightGameScene/ZFFightMan').ZFFightMan;
    var CivilianActorFight = require('Code/Game/Actor/Types/Enemies/CivilianActorFight').CivilianActorFight;
    var StageActor = require('Code/Game/Actor/Types/Enemies/StageActor/StageActor').StageActor;
    var ZFFightPhysics = require('Code/Game/FightGameScene/Physics/ZFFightPhysics').ZFFightPhysics;
    
    // Alien stage
    var AlienStageActor = require('Code/Game/Actor/Types/Enemies/AlienStageActor/AlienStageActor').AlienStageActor;
    var AlienStageActorBoss = require('Code/Game/Actor/Types/Enemies/AlienStageActor/AlienStageActorBoss').AlienStageActorBoss;
    var AlienStageActorMinion = require('Code/Game/Actor/Types/Enemies/AlienStageActor/AlienStageActorMinion').AlienStageActorMinion;
    
    // Beach stage
    /*
    var BeachStageActor = require('Code/Game/Actor/Types/Enemies/BeachStageActor/BeachStageActor').BeachStageActor;
    var BeachStageActorBoss = require('Code/Game/Actor/Types/Enemies/BeachStageActor/BeachStageActorBoss').BeachStageActorBoss;
    var BeachStageActorCrab = require('Code/Game/Actor/Types/Enemies/BeachStageActor/BeachStageActorCrab').BeachStageActorCrab;
    var BeachStageActorMinion1 = require('Code/Game/Actor/Types/Enemies/BeachStageActor/BeachStageActorMinion1').BeachStageActorMinion1;
    var BeachStageActorMinion2 = require('Code/Game/Actor/Types/Enemies/BeachStageActor/BeachStageActorMinion2').BeachStageActorMinion2;
    */

    // City stage
    var CityStageActor = require('Code/Game/Actor/Types/Enemies/CityStageActor/CityStageActor').CityStageActor;
    var CityStageActorBoss = require('Code/Game/Actor/Types/Enemies/CityStageActor/CityStageActorBoss').CityStageActorBoss;
    var CityStageActorCrazedWorker = require('Code/Game/Actor/Types/Enemies/CityStageActor/CityStageActorCrazedWorker').CityStageActorCrazedWorker;
    var CityStageActorLawyer = require('Code/Game/Actor/Types/Enemies/CityStageActor/CityStageActorLawyer').CityStageActorLawyer;

    // Farm stage
    var FarmStageActor = require('Code/Game/Actor/Types/Enemies/FarmStageActor/FarmStageActor').FarmStageActor;
    var FarmStageActorBoss = require('Code/Game/Actor/Types/Enemies/FarmStageActor/FarmStageActorBoss').FarmStageActorBoss;
    var FarmStageActorFarmhand = require('Code/Game/Actor/Types/Enemies/FarmStageActor/FarmStageActorFarmhand').FarmStageActorFarmhand;
    var FarmStageActorLumberjack = require('Code/Game/Actor/Types/Enemies/FarmStageActor/FarmStageActorLumberjack').FarmStageActorLumberjack;

    // Ninja stage
    var NinjaStageActor = require('Code/Game/Actor/Types/Enemies/NinjaStageActor/NinjaStageActor').NinjaStageActor;
    var NinjaStageActorBoss = require('Code/Game/Actor/Types/Enemies/NinjaStageActor/NinjaStageActorBoss').NinjaStageActorBoss;
    var NinjaStageActorBoy = require('Code/Game/Actor/Types/Enemies/NinjaStageActor/NinjaStageActorBoy').NinjaStageActorBoy;
    var NinjaStageActorGirl = require('Code/Game/Actor/Types/Enemies/NinjaStageActor/NinjaStageActorGirl').NinjaStageActorGirl;

    // Pirate stage
    var PirateStageActor = require('Code/Game/Actor/Types/Enemies/PirateStageActor/PirateStageActor').PirateStageActor;
    var PirateStageActorBoss = require('Code/Game/Actor/Types/Enemies/PirateStageActor/PirateStageActorBoss').PirateStageActorBoss;
    var PirateStageActorScallywag = require('Code/Game/Actor/Types/Enemies/PirateStageActor/PirateStageActorScallywag').PirateStageActorScallywag;
    var PirateStageActorSwashbuckler = require('Code/Game/Actor/Types/Enemies/PirateStageActor/PirateStageActorSwashbuckler').PirateStageActorSwashbuckler;

    // Robot stage
    var RobotStageActor = require('Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActor').RobotStageActor;
    var RobotStageActorBrainBot = require('Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActorBrainBot').RobotStageActorBrainBot;
    var RobotStageActorBroBot = require('Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActorBroBot').RobotStageActorBroBot;
    var RobotStageActorGiantBot = require('Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActorGiantBot').RobotStageActorGiantBot;
    var RobotStageActorHitBox = require('Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActorHitBox').RobotStageActorHitBox;
    var RobotStageActorJunkBot = require('Code/Game/Actor/Types/Enemies/RobotStageActor/RobotStageActorJunkBot').RobotStageActorJunkBot;

    // Special stage
    var SpecialStageActor = require('Code/Game/Actor/Types/Enemies/SpecialStageActor/SpecialStageActor').SpecialStageActor;
    var SpecialStageActorBoss = require('Code/Game/Actor/Types/Enemies/SpecialStageActor/SpecialStageActorBoss').SpecialStageActorBoss;
    var SpecialStageActorMinion1 = require('Code/Game/Actor/Types/Enemies/SpecialStageActor/SpecialStageActorMinion1').SpecialStageActorMinion1;
    var SpecialStageActorMinion2 = require('Code/Game/Actor/Types/Enemies/SpecialStageActor/SpecialStageActorMinion2').SpecialStageActorMinion2;   
	
var allMySprites = [];

var imagesSize;

var Base64Ext = {
		 
		// private property
		_keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",
	 
		// public method for encoding
		encode : function (input) {
			if(!input){return "";}

			var output = "";
			var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
			var i = 0;
			
			input = Base64Ext._utf8_encode(input);
	 
			while (i < input.length) {
	 
				chr1 = input.charCodeAt(i++);
				chr2 = input.charCodeAt(i++);
				chr3 = input.charCodeAt(i++);
	 
				enc1 = chr1 >> 2;
				enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
				enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
				enc4 = chr3 & 63;
	 
				if (isNaN(chr2)) {
					enc3 = enc4 = 64;
				} else if (isNaN(chr3)) {
					enc4 = 64;
				}
	 
				output = output +
				this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
				this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);
	 
			}
	 
			return output;
		},
	 
		// public method for decoding
		decode : function (input) {
			if(!input){return input;}

			var output = "";
			var chr1, chr2, chr3;
			var enc1, enc2, enc3, enc4;
			var i = 0;
	 
			input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
	 
			while (i < input.length) {
	 
				enc1 = this._keyStr.indexOf(input.charAt(i++));
				enc2 = this._keyStr.indexOf(input.charAt(i++));
				enc3 = this._keyStr.indexOf(input.charAt(i++));
				enc4 = this._keyStr.indexOf(input.charAt(i++));
	 
				chr1 = (enc1 << 2) | (enc2 >> 4);
				chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
				chr3 = ((enc3 & 3) << 6) | enc4;
	 
				output = output + String.fromCharCode(chr1);
	 
				if (enc3 != 64) {
					output = output + String.fromCharCode(chr2);
				}
				if (enc4 != 64) {
					output = output + String.fromCharCode(chr3);
				}
	 
			}
	 
			output = Base64Ext._utf8_decode(output);
	 
			return output;
	 
		},
	 
		// private method for UTF-8 encoding
		_utf8_encode : function (string) {
			if(string == undefined) return undefined;
			if(typeof string != "string") string = string.toString();

			var utftext = "";
	 
			for (var n = 0; n < string.length; n++) {
	 
				var c = string.charCodeAt(n);
	 
				if (c < 128) {
					utftext += String.fromCharCode(c);
				}
				else if((c > 127) && (c < 2048)) {
					utftext += String.fromCharCode((c >> 6) | 192);
					utftext += String.fromCharCode((c & 63) | 128);
				}
				else {
					utftext += String.fromCharCode((c >> 12) | 224);
					utftext += String.fromCharCode(((c >> 6) & 63) | 128);
					utftext += String.fromCharCode((c & 63) | 128);
				}
	 
			}
	 
			return utftext;
		},
	 
		// private method for UTF-8 decoding
		_utf8_decode : function (utftext) {
			var string = "";
			var i = 0;
			var c = c1 = c2 = 0;
	 
			while ( i < utftext.length ) {
	 
				c = utftext.charCodeAt(i);
	 
				if (c < 128) {
					string += String.fromCharCode(c);
					i++;
				}
				else if((c > 191) && (c < 224)) {
					c2 = utftext.charCodeAt(i+1);
					string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
					i += 2;
				}
				else {
					c2 = utftext.charCodeAt(i+1);
					c3 = utftext.charCodeAt(i+2);
					string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
					i += 3;
				}
	 
			}
	 
			return string;
		}
	 
	};

//function gratz()
//{
//	var w = new Core.Size(UI.Window._width, UI.Window._height);
//	var gui = ZFGuiLayer;
//	var message = Core.Localization.getString("That's it!\n\nHave a rotten good time, and happy farming!");
//	gui.displayAlertSimple(Core.Localization.getString("Congratulations"), message, 
//				 CCSprite.spriteWithFile("levelUp.png"),
//				 new Core.Rect((w._width - 480) / 2, w._height - (w._height - 210) / 2, 480, 210));	
//}


function NSAssert(condition,message) {
	if (!condition) {
		DumpStack(message);
	}
}

function DumpStack(message) {
    try { throw new Error(); } catch (e) { console.log(message + " " + e.stack); }
}

// check if destroyable element's isn't null/undefined and destroy if not
function destroy(destroyable)
{
	if (destroyable && destroyable.__objectRegistryId) {
		if (destroyable instanceof GL2.Sprite) {
			var anim = destroyable.getAnimation();
			if (anim && anim._refCounter != null)
				anim._refCounter--;
		}
		try{destroyable.destroy();} catch (e) {console.log ("Error while destroying node." + e.message + ". Stack: " + e.stack);}
	}
}

function destroyWithChildren(destroyable)
{	
	//console.log("�� destroyWithChildren");
	//console.log(destroyable);
	if(destroyable) 
	{
		if(destroyable._children){
			var length = destroyable._children.length;
			for(var i = length - 1;i>=0; i--)
			{
				destroyWithChildren(destroyable._children[i]);
			}
		}
		destroy(destroyable);
	}
}

function destroyChildren(destroyable)
{	
	//console.log("�� destroyWithChildren");
	//console.log(destroyable);
	
	if(destroyable) 
	{
		if(destroyable._children){
			var length = destroyable._children.length;
			for(var i = length - 1;i>=0; i--)
			{
				destroyWithChildren(destroyable._children[i]);
			}
		}
	}
}

// TODO : Simplify this bezier maybe.
function bezierAt( a , b , c , d , t )
{
	mt = ( 1 - t );
	mt2 = mt * mt;
	t2 = t * t;
	return (	a	* mt * mt2 + 
				b 	* 3 * t * mt2 + 
				c	* 3 * t2 * mt +
				d	* t * t2 );
}

function ccpNormalize( vector )
{
	var length = ccpLength( vector );
	
	return new Core.Vector( vector._x / length , vector._y / length );
}

function ccpNormalizeF( p )
{
	var lengthInv = 1/ccpLength( p );
	
	p._x *= lengthInv;
	p._y *= lengthInv;
}

function ccpLength( p )
{
	return Math.sqrt( ( p._x * p._x ) + ( p._y * p._y ) );
}

function ccpDistance( p1, p2 )
{
	difX = p1._x - p2._x;
	difY = p1._y - p2._y;
	return Math.sqrt( ( difX*difX ) + ( difY*difY ) );
}

function toMY(y)
{
	return (-y); 
}

function toMX(x)
{
	return x;
}

function toCY(y)
{
	return (-y); 
}

function toCX(x)
{
	return x;
}

function toScreenCY(y)
{
	return (-y + UI.Window._height);
}

function ccp(x,y)
{
	return new Core.Vector(x,y);
}

function ccpF(x,y)
{
	return {_x:x,_y:y};
}

function ccc3(r,g,b)
{
	return ccc4(r,g,b,255); //  new Core.Color(r/255, g/255, b/255);
}

function ccc4(r,g,b,a)
{
    return new CCColor(r/255, g/255, b/255, a/255);
}
var _PIOver180 = Math.PI / 180;
var _180OverPI = 180 / Math.PI;
function degreesToRadian( degreesAngle )
{
	return degreesAngle * _PIOver180;
}

function radianToDegrees( radianAngle )
{
	return radianAngle * _180OverPI;
}

function CGPointFromString ( point )
{
    if (point) {
        return eval("new Core.Point(" + point.toString().replace("{", "").replace("}", "") + ")");
    }
    return  CGPointMake(0, 0);
}

function CGRectFromString( rect )
{   
//    console.log ("CGRectFromString: " + rect);
    if (rect) {
        return eval("new Core.Rect(" + rect.toString().replace(/{/g, "").replace(/}/g,"") + ")");
    }
    return CGRectMake(0, 0, 0, 0);
    
}

function CGSizeFromString( size )
{
    if(size){ 
        return eval("new Core.Size(" + size.toString().replace("{", "").replace("}","") + ")");
    }
    return CGSizeMake(0, 0);
}

function trim(stringToTrim)
{
	return stringToTrim.replace(/^\s+|\s+$/g,"");
}

//add two vectors
function ccpAdd(a,b)
{
	var x = a._x + b._x;
	var y = a._y + b._y;
	return new Core.Vector(x,y);
}

function ccpAddF(a,b)
{
	a._x += b._x;
	a._y += b._y;
}

function ccpSub(a,b)
{
	var x = a._x - b._x;
	var y = a._y - b._y;
	return new Core.Vector(x,y);
}

function ccpSubF(a,b)
{
	a._x -= b._x;
	a._y -= b._y;
}


function ccpMult(a, b)
{
	return new Core.Point(a._x*b, a._y*b);
}

function ccpMultF(a, b) {
	a._x *= b;
	a._y *= b;
}

function CGRectContainsPoint(rect, point)
{
	return (point._x > rect._origin._x && point._x < rect._origin._x + rect._size._width &&
			point._y > rect._origin._y && point._y < rect._origin._y + rect._size._height);
}

function CGRectContainsPointF(rect, x, y)
{
	return (x > rect._origin._x && x < rect._origin._x + rect._size._width &&
			y > rect._origin._y && y < rect._origin._y + rect._size._height);
}

function ccpEqual(p1, p2)
{
	return (!p1 && !p2) || (p1 && p2 && (p1._x == p2._x && p1._y == p2._y));
}

function CGPointEqualToPoint(p1, p2)
{
	return (!p1 && !p2) || (p1 && p2 && (p1._x == p2._x && p1._y == p2._y));
}

function CGSizeEqualToSize(s1, s2)
{
	return (!s1 && !s2) || (s1 && s2 && (s1._width == s2._width && s1._height == s2._height));
}

function CGRectEqualToRect(r1, r2)
{
	return (CGPointEqualToPoint(r1._origin, r2._origin) && CGSizeEqualToSize(r1._size, r2._size));
}

function CGPointMake(x, y)
{
	var ret = {_x:x, _y:y};
	ret.getX = function () {return this._x;};
	ret.getY = function () {return this._y;};
	return ret;
}

var ZERO_POINT = CGPointMake(0,0);

function CGRectMake(x,y,width,height)
{
	return new Core.Rect(x,y,width,height);
}

function CGSizeMake(width, height)
{
	return new Core.Size(width, height); 
}

function stringFromRect(rect)
{
	return ("(" + rect.getOrigin()._x + ", " + rect.getOrigin()._y + ", " + rect.getSize()._width + ", " + rect.getSize()._height + ")");
}

function stringFromSize(size)
{
	return ("(" + size._width + ", " + size._height + ")");
}

function stringFromPoint(point)
{
	return ("(" + point._x + ", " + point._y + ")");
}

function stringFromColor(color)
{
	return ("(" + color.getRed() + ", " + color.getGreen() + ", " +  color.getBlue() + ")");
}

function NSLocalizedString(text) {
	if(!text) return "";
	return Core.Localization.getString(text);
	}

function str_repeat(i, m) {
	for (var o = []; m > 0; o[--m] = i);
	return o.join('');
}

function log10(val) {
	  return Math.log(val) / Math.log(10);
	}

var gameInitialized;

function main() {
	//Required to be call here to avoid wrong initialization order in Android
	UI.Window.instantiate();
	
    FPS.instantiate();
    gameInitialized = false;    
    MobagePaymentController.cancelPendingTransactions();
//    TouchTargetVisualizer.show();
    
    NSUserDefaults.preloadKnownKeys(function(){
    	ZombieFarmAppDelegate.instantiate();
    });
}

function mainContinueLoad() {
	
    Storage.FileSystem.readFile("./Content/imagessize.json", false, 
    function(err, file)
	{
		if(err)
        {
            console.log("Error == " + err);
        }
        else
        {
            imagesSize = eval('(' + file + ')');                	    
    	    NSNotificationCenter.addObserver(this,function(){
    	    	if(!gameInitialized)
    	    	{
					gameInit();
    	    	}
    	    }.bind(this),ZFGameDefines.kActivePlayerProfileUpdateNotification);
    	    
    	    var ppm = PlayerProfileManager.playerProfileManager();
    	    ppm.init();
        }
	});
	
};

function gameInit()
{
   // Caps frames per second to 30, uncomment this when we know we are getting a good fps.
    //Core.UpdateEmitter.setTickRate(1/30);
    SimpleAudioEngine.preloadSfXs();
	MainMenu.Init();
	OptionsMenu.instantiate();
	CCActionManager.instantiate();
	gameInitialized = true;	
}

var sprintf = (function() {
	   function get_type(variable) {
	       return Object.prototype.toString.call(variable).slice(8, -1).toLowerCase();
	   }
	   function str_repeat(input, multiplier) {
	       for (var output = []; multiplier > 0; output[--multiplier] = input) {/* do nothing */}
	       return output.join('');
	   }

	   var str_format = function() {
	       if (!str_format.cache.hasOwnProperty(arguments[0])) {
	           str_format.cache[arguments[0]] = str_format.parse(arguments[0]);
	       }
	       return str_format.format.call(null, str_format.cache[arguments[0]], arguments);
	   };

	   str_format.format = function(parse_tree, argv) {
	       var cursor = 1, tree_length = parse_tree.length, node_type = '', arg, output = [], i, k, match, pad, pad_character, pad_length;
	       for (i = 0; i < tree_length; i++) {
	           node_type = get_type(parse_tree[i]);
	           if (node_type === 'string') {
	               output.push(parse_tree[i]);
	           }
	           else if (node_type === 'array') {
	               match = parse_tree[i]; // convenience purposes only
	               if (match[2]) { // keyword argument
	                   arg = argv[cursor];
	                   for (k = 0; k < match[2].length; k++) {
	                       if (!arg.hasOwnProperty(match[2][k])) {
	                           console.log(sprintf('[sprintf] property "%s" does not exist', match[2][k]));
	                       }
	                       arg = arg[match[2][k]];
	                   }
	               }
	               else if (match[1]) { // positional argument (explicit)
	                   arg = argv[match[1]];
	               }
	               else { // positional argument (implicit)
	                   arg = argv[cursor++];
	               }

	               if (/[^s]/.test(match[8]) && (get_type(arg) != 'number')) {
	                   console.log(sprintf('[sprintf] expecting number but found %s', get_type(arg)));
	               }
	               switch (match[8]) {
	                   case 'b': arg = arg.toString(2); break;
	                   case 'c': arg = String.fromCharCode(arg); break;
	                   case 'd': arg = parseInt(arg, 10); break;
	                   case 'e': arg = match[7] ? arg.toExponential(match[7]) : arg.toExponential(); break;
	                   case 'f': arg = match[7] ? parseFloat(arg).toFixed(match[7]) : parseFloat(arg); break;
	                   case 'o': arg = arg.toString(8); break;
	                   case 's': arg = ((arg = String(arg)) && match[7] ? arg.substring(0, match[7]) : arg); break;
	                   case 'u': arg = Math.abs(arg); break;
	                   case 'x': arg = arg.toString(16); break;
	                   case 'X': arg = arg.toString(16).toUpperCase(); break;
	               }
	               arg = (/[def]/.test(match[8]) && match[3] && arg >= 0 ? '+'+ arg : arg);
	               pad_character = match[4] ? match[4] == '0' ? '0' : match[4].charAt(1) : ' ';
	               pad_length = match[6] - String(arg).length;
	               pad = match[6] ? str_repeat(pad_character, pad_length) : '';
	               output.push(match[5] ? arg + pad : pad + arg);
	           }
	       }
	       return output.join('');
	   };

	   str_format.cache = {};

	   str_format.parse = function(fmt) {
	       var _fmt = fmt;
	       var _fmt = _fmt.replace(/%(\d?\$?)@/g, "%$1s");	       
	       var _fmt = _fmt.replace(/%(\d?\$?)i/g, "%$1d");	 
	       
	       var match = [], parse_tree = [], arg_names = 0;
	       while (_fmt) {
	           if ((match = /^[^\x25]+/.exec(_fmt)) !== null) {
	               parse_tree.push(match[0]);
	           }
	           else if ((match = /^\x25{2}/.exec(_fmt)) !== null) {
	               parse_tree.push('%');
	           }
	           else if ((match = /^\x25(?:([1-9]\d*)\$|\(([^\)]+)\))?(\+)?(0|'[^$])?(-)?(\d+)?(?:\.(\d+))?([b-fosuxX])/.exec(_fmt)) !== null) {
	               if (match[2]) {
	                   arg_names |= 1;
	                   var field_list = [], replacement_field = match[2], field_match = [];
	                   if ((field_match = /^([a-z_][a-z_\d]*)/i.exec(replacement_field)) !== null) {
	                       field_list.push(field_match[1]);
	                       while ((replacement_field = replacement_field.substring(field_match[0].length)) !== '') {
	                           if ((field_match = /^\.([a-z_][a-z_\d]*)/i.exec(replacement_field)) !== null) {
	                               field_list.push(field_match[1]);
	                           }
	                           else if ((field_match = /^\[(\d+)\]/.exec(replacement_field)) !== null) {
	                               field_list.push(field_match[1]);
	                           }
	                           else {
	                               console.log('[sprintf] huh?');
	                           }
	                       }
	                   }
	                   else {
	                       console.log('[sprintf] huh?');
	                   }
	                   match[2] = field_list;
	               }
	               else {
	                   arg_names |= 2;
	               }
	               if (arg_names === 3) {
	                   console.log('[sprintf] mixing positional and named placeholders is not (yet) supported');
	               }
	               parse_tree.push(match);
	           }
	           else {
	               console.log('[sprintf] huh?');
	           }
	           _fmt = _fmt.substring(match[0].length);
	       }
	       return parse_tree;
	   };

	   return str_format;
	})();
